/* ramachandran.cpp: ramachandran plot class */
//C Copyright (C) 2000-2006 Kevin Cowtan and University of York
//L
//L  This library is free software and is distributed under the terms
//L  and conditions of version 2.1 of the GNU Lesser General Public
//L  Licence (LGPL) with the following additional clause:
//L
//L     `You may also combine or link a "work that uses the Library" to
//L     produce a work containing portions of the Library, and distribute
//L     that work under terms of your choice, provided that you give
//L     prominent notice with each copy of the work that the specified
//L     version of the Library is used in it, and that you include or
//L     provide public access to the complete corresponding
//L     machine-readable source code for the Library including whatever
//L     changes were used in the work. (i.e. If you make changes to the
//L     Library you must distribute those, but you do not need to
//L     distribute source or object code to those portions of the work
//L     not covered by this licence.)'
//L
//L  Note that this clause grants an additional right and does not impose
//L  any additional restriction, and so does not affect compatibility
//L  with the GNU General Public Licence (GPL). If you wish to negotiate
//L  other terms, please contact the maintainer.
//L
//L  You can redistribute it and/or modify the library under the terms of
//L  the GNU Lesser General Public License as published by the Free Software
//L  Foundation; either version 2.1 of the License, or (at your option) any
//L  later version.
//L
//L  This library is distributed in the hope that it will be useful, but
//L  WITHOUT ANY WARRANTY; without even the implied warranty of
//L  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//L  Lesser General Public License for more details.
//L
//L  You should have received a copy of the CCP4 licence and/or GNU
//L  Lesser General Public License along with this library; if not, write
//L  to the CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
//L  The GNU Lesser General Public can also be obtained by writing to the
//L  Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
//L  MA 02111-1307 USA


#include "ramachandran.h"


namespace clipper {

namespace data {

  int rama_data_size = 36;
  ftype32 rama_gly[] = {
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     1,    9,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,// 0
     0,    0,    0,    0,    0,    0,    0,    7,    1,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    1,    7,
     0,    2,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,// 1
     0,    0,    0,    0,    0,    0,    0,    3,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    5,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,// 2
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    3,
     3,    0,    0,    0,    0,    0,    0,    0,    3,    3,    0,    0,// 3
     0,    0,    0,   11,   37,   21,   10,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    4,   15,   18,   74,
    36,    3,    5,    2,    0,    0,    0,    0,    3,    3,    0,    0,// 4
     1,    3,   30,  146,  193,  137,   30,    6,    0,    0,    0,    0,
     0,    0,    0,    0,    1,    0,    0,    1,   16,   60,  237,  329,
   131,   25,    7,    2,    0,    3,    2,    0,    0,    0,    0,    1,// 5
    42,  154,  432,  857,  603,  201,   52,    3,    0,    0,    0,    0,
     3,    8,    0,    3,    8,    8,   49,   97,  204,  334,  409,  593,
   320,   63,   11,    0,    0,    4,    3,    0,    0,    2,    5,   15,// 6
   616, 1527, 1975, 1407,  577,  144,   51,    0,    0,    0,    0,    0,
     1,    0,    0,    5,   34,   93,  178,  366,  452,  310,  236,  305,
   210,   53,   22,   16,    3,    2,    0,    0,    7,    9,   26,  111,// 7
  2655, 2916, 2032,  816,  205,   61,   14,   10,    5,    2,    7,   11,
    13,    5,   19,   73,  171,  337,  524,  493,  460,  222,  127,   97,
    57,   28,   21,   12,    4,   19,   31,   29,   24,   41,  196, 1032,// 8
  2461, 1984,  840,  240,   74,   29,   16,    5,   10,   15,   15,   22,
    23,   40,   75,  253,  356,  406,  464,  420,  289,  144,   53,   24,
    20,   19,   15,   15,    0,   19,   26,   30,   41,  145,  798, 1998,// 9
  1122,  937,  278,   55,   30,    6,   16,    6,   19,   12,   29,   39,
    51,   83,  119,  216,  327,  228,  292,  250,  168,  101,   47,   32,
     9,   19,    6,    9,   12,    0,    9,   30,   40,  218,  929, 1231,//10
   467,  301,  148,   54,    6,    3,    3,    0,    6,    2,   26,   28,
    41,   50,   66,  173,  205,  172,  190,  206,  112,   45,   17,   22,
     2,   12,   11,    7,    3,    0,    5,   12,   58,  195,  402,  443,//11
   190,  104,   33,   19,   24,   10,    5,    0,    1,   10,   17,   15,
    29,   36,   71,   87,  127,  173,  156,  135,   68,   48,   32,   13,
     7,   16,    5,    4,    7,    1,   16,   13,   16,   86,  102,  111,//12
    64,   32,   12,   11,   32,    9,    0,    0,    0,    7,    8,   11,
    10,   38,   43,   61,   86,  106,  112,  140,  132,   67,   40,   15,
     9,   12,    1,    0,   13,   10,    2,   11,   11,   24,   68,  101,//13
    15,   11,    9,    2,    3,    1,    0,    0,    0,    2,    3,    0,
    14,    9,   28,   45,  101,  102,  169,  169,  162,  112,   60,   18,
     2,    1,    0,    0,    5,    2,    0,   10,   16,   15,   26,   36,//14
     7,   12,    5,    0,    0,    0,    0,    0,    0,    2,    5,    4,
    10,    4,   31,   40,   76,  139,  259,  193,  137,  116,   51,   18,
     4,    0,    0,    1,    0,    4,    6,    1,   21,    8,   11,   18,//15
     4,    8,    0,    0,    0,    0,    0,    1,   12,    0,    1,    6,
     0,    7,    6,   27,   93,  150,  202,  253,  211,  105,   30,   23,
     6,    5,    3,    8,    1,   17,   16,    0,    0,    1,    3,   10,//16
     0,    0,    0,    0,    0,    6,    1,   10,    0,    0,    1,    6,
     9,    6,    9,   30,  104,  187,  324,  399,  208,  126,   48,   19,
    12,    6,    3,    0,    0,    3,    1,    0,    0,    0,    0,    0,//17
     0,    2,    1,    0,    0,    6,    0,    0,    0,    0,    0,   10,
    10,   16,   38,   35,  153,  303,  421,  352,  184,   72,   54,   19,
    21,    8,    7,    0,    0,    0,    0,    5,    4,    1,    0,    1,//18
     4,    6,    3,    0,    1,    3,    1,    9,    0,    0,    0,    3,
     3,   18,   38,   72,  191,  401,  430,  252,  172,   74,   40,    9,
     9,    0,   11,    6,    7,    0,    0,    3,   12,   10,    2,    8,//19
    18,    1,    0,    3,   12,    8,   11,    3,    0,    2,    0,    0,
     1,   23,   71,  164,  338,  358,  286,  185,  125,   46,   17,    5,
     1,    7,    4,   10,    2,    0,    0,    0,    0,    1,    0,    1,//20
     4,   14,   12,    6,    5,    4,    0,    0,    2,    8,    0,    1,
    14,   39,   97,  183,  245,  212,  178,  143,  107,   51,   36,   13,
    11,    1,    4,    7,    0,    0,    0,    0,    0,    0,    0,    0,//21
     7,   21,   18,   46,   23,    4,   10,    1,    0,    0,    0,    6,
    25,   62,  150,  258,  187,  143,  150,  125,   62,   16,   35,   17,
    14,    7,    4,    1,    3,    6,    0,    0,    0,    1,    6,    2,//22
    24,   31,   34,   55,   25,   13,    9,    4,    0,    0,    1,   20,
    40,   82,  144,  259,  208,  150,  148,  151,   88,   50,   33,   26,
    25,   11,    7,   14,    8,    4,   14,    0,    0,   10,   19,   21,//23
    24,   61,   51,   26,   24,    5,    6,    2,    0,    0,    0,   15,
    42,  107,  142,  154,  151,  140,  113,  141,   96,   76,   31,   22,
     9,   16,   19,   13,    7,    8,   12,    1,    0,    4,   23,   28,//24
    86,  126,  147,   42,   16,   27,   25,    3,    0,    1,    3,   35,
    54,   94,  145,  114,  153,  147,  180,  151,  129,  114,   86,   33,
    24,   31,   22,   22,   25,   11,   24,    6,    9,   20,   24,   40,//25
   244,  273,  176,   62,    6,   16,   20,    6,    1,    4,   31,   58,
    80,   90,  107,  157,  181,  206,  254,  225,  269,  151,  100,   87,
    41,   43,   30,   20,   18,   24,   10,    1,   10,   34,   73,  137,//26
   499,  309,  145,   71,   18,   30,   21,   36,   30,   25,   22,   43,
    45,  132,  180,  216,  225,  325,  436,  455,  378,  138,   72,   51,
    21,   37,   28,    3,   17,   26,    5,   21,   32,   79,  158,  357,//27
   463,  119,   15,   44,   15,   33,   40,   30,   24,   27,   19,   35,
    53,  113,  225,  313,  425,  594,  531,  432,  223,   92,   34,    8,
     0,    5,    4,    7,    8,   13,   28,  104,  249,  318,  354,  531,//28
   174,   21,    1,    0,    1,   17,   10,    3,    4,   13,   20,   23,
    72,  120,  275,  490,  579,  477,  271,  124,   48,   17,    2,    0,
     0,    0,    8,    7,    0,   13,   91,  851, 2514, 1280,  752,  630,//29
    36,    3,    7,    1,    0,    1,    0,    0,    0,    0,    1,    5,
    48,  158,  339,  299,  137,  111,   57,   29,    2,    1,    0,    0,
     0,    0,    0,    0,    0,   11,  179, 2348, 4535, 1658,  748,  240,//30
     4,    0,   16,    1,    0,    0,    0,    0,    0,    0,    5,   12,
    14,   74,  122,   40,    1,   10,    7,    2,    0,    0,    0,    0,
     0,    0,    0,    0,   10,   12,  140,  626,  736,  309,   95,   15,//31
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    2,    1,
    13,    6,    4,    0,    0,    0,   11,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    4,   10,   60,   85,   28,    8,    0,    0,//32
     0,    0,    0,    0,    0,    3,    9,    0,    0,    0,    0,    0,
     3,    9,    3,    6,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,   11,   10,    5,    6,    5,    0,    0,    0,    0,//33
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    5,    7,    3,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,   10,    4,    0,    0,    0,    0,    0,    0,    0,//34
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,//35
  };
  ftype32 rama_pro[] = {
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,// 0
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,// 1
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,// 2
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,// 3
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,// 4
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,// 5
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,// 6
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,// 7
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,// 8
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,// 9
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,//10
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,//11
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,//12
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,//13
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,//14
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,//15
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,//16
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,//17
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,//18
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,//19
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,//20
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,//21
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,//22
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,//23
     0,    0,    0,    0,    0,    2,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,//24
     3,    7,    8,    8,   18,   16,    7,    0,    0,    0,    0,    0,
     0,    0,    3,    7,   11,   11,    6,    4,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,//25
    89,   84,   65,   44,    8,    7,   10,    0,    0,    0,    0,    4,
    23,   29,   25,   34,   70,   44,   34,    9,    0,    0,    0,    1,
     3,    0,    0,    0,    0,    0,    0,    0,    0,    0,    9,   47,//26
   245,  142,  121,   55,   11,   26,   52,   86,   22,   15,   15,   16,
    45,   95,  111,  269,  327,  234,  109,   37,    3,    2,    2,    2,
     6,    0,    0,    0,    0,    0,    0,    0,    0,    9,  122,  217,//27
   399,  100,   43,   21,   45,  111,  203,  246,  126,   59,   69,   61,
   149,  349,  658, 1240, 1354,  828,  239,   58,   16,   12,    7,    6,
     1,    4,    2,    0,    0,    0,    0,    0,   28,  138,  434,  704,//28
   309,   35,   10,    3,   10,   67,  101,   68,   42,   34,   26,   75,
   280,  912, 2196, 3282, 2681, 1103,  162,   21,    3,    1,    1,    2,
    11,    4,    2,    4,    2,    1,    7,   45,  400, 1155, 1852, 1359,//29
    62,    9,    2,    5,    4,    3,    8,    0,    0,    9,   36,   37,
   404, 1893, 3871, 3571, 1491,  290,   38,   11,    0,    0,    0,    0,
     0,    0,    0,    4,    2,   14,   48,  615, 2889, 4269, 2608,  601,//30
     0,    4,    3,    0,    0,    0,    0,    0,    0,    4,   14,   19,
   366, 1302, 1543,  683,  130,    8,    1,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    3,   93,  961, 2346, 1684,  400,   18,//31
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    3,   20,
    82,  119,   85,   14,    1,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,   19,   81,  230,  242,   85,   11,    0,//32
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,   10,   11,
     8,    2,    5,    3,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    4,    0,    0,    5,   33,   31,    4,    1,    0,    0,//33
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    3,    6,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    8,    0,    0,    0,    2,    3,    0,    0,    0,    0,//34
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,//35
  };
  ftype32 rama_ngp[] = {
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    4,    0,    0,    2,    3,    0,    0,    0,    0,// 0
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    1,    1,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    1,    7,    5,    2,    0,    0,    0,    0,    0,    0,// 1
     0,    0,    0,    0,    0,    3,    4,    0,    0,    0,    0,    0,
     0,    5,    4,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    3,    1,    3,    8,    0,    0,    0,    0,// 2
     0,    0,    0,    0,    1,   26,   46,   23,    2,    1,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     1,   10,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,// 3
     0,    0,    1,   14,  170,  518,  444,  135,   18,    3,    4,    5,
     0,    0,    0,    0,    0,    0,    0,    0,    1,    7,   10,   29,
    22,    6,    5,    0,    0,    0,    0,    0,    0,    0,    0,    0,// 4
     0,    7,  164,  821, 2467, 2335,  972,  229,   38,    7,   10,    8,
     0,    0,    0,    0,    0,    0,    0,    1,    4,   29,   51,  157,
    87,   29,   22,    0,    0,    0,    0,    0,    0,    5,    2,    0,// 5
    46,  354, 1203, 2297, 2859, 1352,  417,  140,   36,    3,   19,   19,
     3,    0,    0,    1,    2,    7,   29,    9,   36,   49,   58,   85,
    90,   45,   22,    1,    3,   14,   22,   11,   18,   16,   15,   10,// 6
   276,  752,  962,  848,  373,   77,   42,   30,   15,    5,   10,   10,
     9,    3,    6,    8,   14,   16,   42,   15,    9,   13,   11,   10,
    16,   14,    8,    0,    2,   26,   99,   65,   35,   12,   32,   65,// 7
   166,  207,  109,   52,    7,   10,    9,   15,   17,    5,    5,    7,
     3,    6,   18,   22,   16,    7,    3,    1,    0,    0,    1,    0,
     0,    0,    0,    0,    0,    7,   33,   39,   17,    6,   21,  111,// 8
    18,   15,    0,    0,    0,    3,    6,    1,   12,    0,   10,    1,
     9,   11,    5,    8,    1,    0,    0,    0,    2,   10,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    1,    0,    0,    2,   14,// 9
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    1,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,//10
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    4,    1,//11
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    5,    2,//12
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    1,    4,    0,    0,    0,//13
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     1,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    5,   14,    3,    1,    0,//14
     0,    0,    0,    0,    0,    5,    3,    0,    0,    0,    0,    3,
     8,    9,    0,    0,    0,    0,    0,    1,    1,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    7,    2,    0,//15
     0,    0,    0,    0,    0,    3,    2,    0,    0,    0,    0,    0,
     0,    3,    0,    0,    0,    0,    0,    4,    6,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    3,    1,    0,    0,//16
     0,    0,    0,    0,    0,    0,    0,    0,    3,    3,    0,    0,
     0,    0,    6,   16,   12,   16,    3,    0,    1,    2,    0,    0,
     0,    0,    0,    0,    0,    5,    2,    0,    5,    2,    0,    0,//17
     0,    0,    0,    0,    0,    0,    0,    4,    5,    7,    8,    5,
     4,   11,   36,   74,  164,  192,   69,   20,    4,    7,    0,    0,
     0,    0,    0,    0,    0,    7,    3,    0,    0,    0,    0,    0,//18
     2,    2,    3,    1,    3,    7,    9,   23,   37,   57,   40,   35,
    62,  161,  397,  884, 1539, 1299,  524,  153,   31,    8,    0,    0,
     0,    1,    6,    0,    0,    5,    3,    0,    0,    0,    0,    0,//19
    16,   22,   24,   18,   31,   41,   55,  135,  119,  122,  187,  269,
   365,  760, 1462, 2646, 4068, 2973, 1140,  323,   91,   27,    2,    0,
     1,    2,   16,    2,   20,   13,   11,    2,    8,    9,    5,    2,//20
    65,  105,  141,   97,  107,  112,  206,  297,  260,  302,  376,  583,
   976, 1843, 3301, 4919, 5142, 3134, 1234,  421,  112,   36,   12,    2,
     5,   15,    9,    9,   13,   42,   22,   11,   15,   40,   34,   36,//21
   215,  326,  337,  260,  286,  224,  427,  636,  531,  416,  627, 1304,
  2420, 4039, 5543, 6810, 6445, 3344, 1056,  322,  109,   11,   10,   11,
    15,   17,    3,   19,   33,   92,   76,   61,   39,   78,  103,  174,//22
   807,  852,  845,  653,  539,  340,  574, 1144, 1005,  652,  999, 2377,
  5342, 8103, 7864, 7454, 6508, 3025,  893,  281,  109,   29,   13,   17,
    29,   18,   15,   42,   72,   91,  122,  192,  213,  318,  367,  670,//23
  1774, 1897, 1793, 1122,  556,  188,  227,  471,  600,  823, 1461, 3182,
  7185,10522, 7989, 5999, 4607, 1941,  688,  286,  147,   58,   60,   21,
    49,   29,   27,   68,   76,  128,  222,  341,  383,  670, 1032, 1362,//24
  2961, 3726, 2711, 1208,  435,  157,  106,   90,  221,  646, 1795, 4095,
  8039, 9609, 6837, 4629, 3183, 1428,  604,  199,   87,   32,   29,    7,
    19,   30,   48,   55,   93,  136,  278,  545,  710, 1067, 1726, 2191,//25
  5516, 5175, 2490,  769,  268,  141,  209,  303,  458,  875, 2273, 4174,
  6766, 7542, 5419, 3686, 2828, 1522,  709,  257,   65,   18,   29,    8,
    15,   30,   19,   34,   83,  147,  324, 1002, 1361, 1833, 2523, 3674,//26
  7319, 4002, 1093,  251,  193,  284,  568,  878, 1058, 1420, 2200, 3704,
  5133, 6007, 4894, 3567, 3106, 1918,  926,  405,   72,    4,    4,    6,
     4,   31,    3,    7,   51,  130,  424, 1324, 2216, 3224, 4255, 6717,//27
  4905, 1403,  224,   68,   80,  205,  495,  811,  922,  945, 1401, 2495,
  4199, 6009, 5594, 5039, 4551, 2869,  990,  337,   49,    5,    0,    0,
     0,    2,    0,    2,   39,  113,  547, 2674, 6560, 7703, 7839, 8289,//28
  1646,  228,   24,   16,   11,   52,   44,   93,  153,  115,  312, 1043,
  2929, 6120, 7732, 6801, 4734, 1953,  396,   36,    4,    1,    0,    0,
     0,    0,    5,    3,   12,   65, 1086,21027,57767,28567,15321, 8073,//29
   188,   23,    3,    0,    5,    3,    0,    2,   15,   23,   40,  295,
  1803, 5781, 7356, 4257, 1641,  351,   28,    4,    0,    0,    0,    0,
     6,    5,    2,    3,   14,   74, 2655,49493,86255,29323,10531, 2193,//30
     5,    4,    3,    0,    0,    0,    0,    0,    0,    6,    6,   85,
   795, 2705, 2139,  709,   97,    7,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    2,   14,   85, 1433,10936,11859, 4044,  687,   60,//31
     0,    0,    0,    0,    0,    0,    0,    0,    0,    5,    4,   39,
   187,  346,  118,   18,    3,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    1,   17,   48,  323,  729,  469,  110,    5,    2,//32
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,   17,
    36,   15,    1,    4,    7,    0,    0,    0,    0,    0,    0,    0,
     4,    3,    0,    2,   12,   25,   26,   41,    8,    4,   15,    1,//33
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    6,    6,
    18,    4,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     3,    2,    0,    0,    0,    7,    3,   13,    0,    0,    2,    0,//34
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,   12,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    4,    2,    6,    0,    0,    0,    0,//35
  };

  int rama5_data_size = 72;
  ftype32 rama5_gly[] = {
  // 0
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 1
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 2
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 3
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 4
  0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 5
  0,0,0,0,0,0,0,1,3,4,5,4,4,3,2,1,1,1,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,1,2,3,4,5,5,3,2,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 6
  0,0,0,0,1,4,7,12,16,18,17,14,10,7,4,3,2,1,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,1,1,2,4,7,10,13,15,14,10,5,2,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 7
  0,0,2,5,12,21,35,51,61,62,53,40,25,15,8,4,2,1,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
  1,1,1,2,4,8,14,21,28,33,34,30,22,12,5,2,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 8
  1,5,12,25,44,75,117,157,178,175,145,111,84,30,14,6,3,1,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,
  2,3,5,9,15,24,35,48,58,63,62,55,40,23,11,4,1,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 9
  10,22,43,74,121,192,279,346,381,402,336,227,143,56,23,9,3,1,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,5,
  7,11,17,26,38,53,71,90,105,121,128,100,67,41,20,8,3,1,
  0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,4,
  // 10
  35,65,108,169,259,374,560,622,689,668,551,400,230,102,35,12,3,1,
  0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,13,
  20,30,43,59,78,98,137,164,193,228,188,137,103,65,34,14,5,1,
  0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,3,6,16,
  // 11
  96,147,220,318,465,682,931,1045,1207,1190,812,494,305,135,80,14,3,1,
  0,0,0,0,0,0,0,0,0,0,0,1,2,4,8,13,21,33,
  48,80,91,114,138,160,205,248,291,319,234,224,167,89,44,20,8,3,
  1,0,0,0,0,0,0,0,1,1,1,1,2,3,4,10,24,58,
  // 12
  202,282,397,606,852,1104,1390,1687,1973,2022,1179,573,352,158,52,15,4,1,
  0,0,0,0,0,0,0,0,0,1,2,3,7,13,21,34,60,74,
  102,181,167,193,221,306,391,445,331,346,251,204,183,95,49,24,11,5,
  2,1,1,1,2,2,2,2,2,2,3,3,4,7,14,32,69,133,
  // 13
  375,506,662,940,1119,1290,1398,1690,2039,1881,1042,595,312,140,48,14,4,1,
  1,1,1,1,1,0,0,0,1,3,6,11,19,31,48,73,116,136,
  169,304,324,369,379,402,405,379,321,295,251,213,183,127,50,25,14,9,
  4,3,3,4,5,5,6,6,6,6,7,8,11,20,42,85,152,246,
  // 14
  609,800,1069,1226,1286,1271,1376,1477,1329,1078,715,462,246,114,37,12,5,3,
  2,3,3,3,3,2,2,3,5,9,16,26,41,61,95,156,164,218,
  283,435,431,536,475,407,399,321,294,260,216,183,146,105,58,25,22,19,
  6,5,6,7,9,9,10,10,10,11,12,15,25,49,97,173,280,435,
  // 15
  966,1261,1585,1748,1363,1171,1121,1041,860,687,480,340,178,87,24,10,5,5,
  5,5,6,6,6,6,6,7,12,20,32,49,73,103,148,258,253,372,
  408,525,541,559,550,499,389,326,301,266,226,153,104,61,40,35,21,14,
  7,8,9,11,12,13,14,14,15,16,19,28,50,97,177,298,483,753,
  // 16
  1481,1628,1517,1393,1176,1029,881,687,567,447,294,182,93,45,17,9,7,7,
  7,8,10,11,11,11,12,15,22,41,52,80,158,212,215,322,372,439,
  558,560,591,509,472,439,323,264,247,183,160,140,94,57,39,67,24,10,
  9,9,12,15,16,16,52,17,18,21,28,45,85,159,273,447,670,1042,
  // 17
  1415,1475,1546,1259,1001,793,550,414,318,254,153,82,45,40,21,9,8,9,
  10,12,14,16,18,18,20,24,37,78,83,118,173,226,295,418,502,540,
  485,432,562,535,414,347,268,278,200,174,133,103,61,54,37,46,38,16,
  9,10,14,17,17,19,35,22,47,26,38,66,123,230,407,608,858,1192,
  // 18
  1393,1359,1277,988,726,527,395,285,166,106,63,60,28,20,13,9,11,12,
  14,16,18,22,24,25,28,41,68,88,116,153,184,261,331,379,421,477,
  576,441,419,361,308,344,244,227,163,132,106,61,48,43,34,24,21,12,
  9,9,12,14,49,16,22,19,66,30,47,84,180,294,510,721,1014,1286,
  // 19
  1058,958,910,751,502,342,246,148,86,52,28,21,20,13,9,11,14,16,
  37,20,25,34,45,34,34,56,112,99,117,176,242,315,329,341,328,354,
  478,430,407,312,247,207,168,178,141,98,72,55,48,40,31,22,14,10,
  8,7,8,9,10,11,14,32,25,33,53,97,209,355,668,852,1018,1065,
  // 20
  805,696,619,469,329,225,150,102,52,32,17,16,19,13,9,13,16,19,
  29,21,27,35,43,35,49,91,106,102,142,192,193,337,342,281,272,322,
  360,332,268,234,207,186,149,114,98,80,68,81,49,39,26,18,19,15,
  7,5,5,5,7,9,14,29,23,33,54,93,169,374,575,832,819,831,
  // 21
  572,548,395,308,278,176,92,45,27,17,12,10,10,9,9,16,27,18,
  19,35,35,28,30,44,48,60,61,86,116,232,179,253,292,269,268,317,
  294,248,247,200,183,168,135,153,113,96,60,53,48,38,23,16,22,17,
  5,3,3,3,4,7,15,21,21,30,50,84,151,298,484,530,546,633,
  // 22
  379,320,280,235,193,101,55,27,17,12,9,8,8,8,9,16,28,15,
  16,17,28,50,29,48,45,53,69,94,106,111,143,213,188,214,189,207,
  256,243,202,182,177,135,136,133,119,87,82,58,50,46,55,29,19,6,
  3,2,1,2,3,5,10,14,17,26,42,97,129,223,343,355,427,404,
  // 23
  261,210,160,122,98,57,32,19,18,22,10,8,7,7,8,9,10,11,
  13,16,19,21,24,29,34,38,52,60,81,93,133,193,166,194,165,196,
  192,167,203,171,153,129,130,131,115,81,58,63,53,34,20,17,10,4,
  2,1,1,2,3,4,6,9,13,21,35,77,103,184,216,206,234,243,
  // 24
  130,112,111,75,51,34,22,15,16,19,9,7,7,6,6,7,7,9,
  11,13,16,19,21,24,29,32,50,63,97,83,99,164,146,210,163,176,
  179,191,204,185,164,131,135,132,105,104,62,60,53,34,20,9,5,3,
  2,1,1,2,2,4,5,7,18,45,27,46,98,82,108,137,163,193,
  // 25
  88,76,55,43,32,22,16,12,9,8,7,6,6,5,5,5,9,15,
  10,11,13,15,17,19,29,34,33,40,55,70,85,105,109,132,185,212,
  162,154,198,189,165,171,132,157,107,81,59,45,33,22,13,8,5,3,
  1,1,1,2,2,3,4,6,9,14,35,45,42,64,102,101,102,111,
  // 26
  70,52,35,30,26,17,11,9,8,6,6,5,4,4,3,4,9,17,
  10,9,11,12,14,15,24,32,58,42,44,57,105,101,123,153,151,207,
  167,172,201,224,212,198,206,160,117,88,61,44,32,24,12,7,4,2,
  1,1,1,2,2,2,3,5,9,13,17,23,32,75,73,76,61,81,
  // 27
  34,29,24,24,22,14,8,6,6,5,4,3,3,2,2,2,3,5,
  6,7,8,9,10,12,14,20,25,27,33,44,58,73,94,124,119,195,
  198,216,204,227,253,203,180,153,119,93,59,38,32,33,12,6,3,2,
  1,1,1,2,2,2,21,8,9,12,16,47,26,83,43,45,45,41,
  // 28
  23,20,17,16,13,8,6,4,4,3,3,2,2,1,1,2,2,3,
  5,6,7,7,8,9,12,15,19,23,29,39,52,67,85,125,135,166,
  262,215,202,197,185,183,167,137,167,86,52,37,23,17,8,5,3,1,
  1,1,2,2,2,2,15,7,9,13,17,29,22,25,29,33,34,30,
  // 29
  15,13,13,11,7,5,4,2,2,2,1,1,1,1,1,1,2,3,
  4,5,6,6,6,7,10,13,17,21,28,50,65,103,124,116,142,183,
  216,202,255,203,213,187,191,130,124,74,43,46,26,11,6,3,2,1,
  1,1,2,3,3,3,4,6,9,12,16,18,19,19,20,23,26,21,
  // 30
  9,7,21,18,3,2,2,1,1,1,0,0,0,0,1,1,2,3,
  4,5,5,5,5,5,8,11,15,19,28,49,82,81,97,135,197,270,
  252,273,276,240,244,209,163,166,111,62,38,24,14,8,4,2,1,1,
  1,2,2,3,3,4,4,6,7,10,12,14,14,13,12,15,16,14,
  // 31
  4,3,3,2,1,1,0,0,0,0,0,0,0,0,0,1,2,3,
  3,4,4,5,4,5,7,9,13,18,26,41,62,98,109,153,194,320,
  305,309,288,271,260,217,174,130,80,76,50,19,11,6,3,1,1,1,
  1,2,3,3,4,4,5,5,6,6,8,9,9,8,8,8,12,6,
  // 32
  3,2,1,1,1,0,0,0,0,0,0,0,0,0,0,1,2,2,
  3,3,3,27,11,5,6,9,12,18,27,51,71,101,133,168,239,292,
  314,351,341,386,303,213,211,144,68,47,28,16,10,5,3,1,1,1,
  1,2,3,4,4,4,39,5,4,4,4,5,5,4,4,4,32,5,
  // 33
  2,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,2,2,
  3,3,3,4,4,5,7,9,13,19,30,51,71,98,141,212,276,334,
  338,362,362,396,338,226,198,126,65,39,24,15,10,6,4,2,1,1,
  1,2,3,3,4,4,5,4,3,3,2,2,2,2,2,2,2,2,
  // 34
  1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,2,
  2,3,3,5,6,8,8,10,14,20,32,50,79,147,170,236,292,307,
  424,431,387,349,233,176,164,93,61,37,23,15,11,8,5,3,1,1,
  1,1,2,3,3,3,3,3,2,2,1,1,1,1,1,1,1,1,
  // 35
  1,1,1,1,1,1,1,0,0,0,35,0,0,0,1,1,1,2,
  2,2,3,6,10,11,11,12,17,31,64,81,82,173,229,324,379,467,
  529,415,378,362,272,199,112,72,51,39,22,15,12,11,8,5,2,1,
  1,1,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,
  // 36
  1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,
  1,2,3,6,11,13,13,14,23,43,56,59,88,138,206,372,381,418,
  611,418,381,372,206,138,88,59,56,43,23,14,13,13,11,6,3,2,
  1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,
  // 37
  1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,1,
  1,1,2,5,8,11,12,15,22,39,51,72,112,199,272,362,378,415,
  529,467,379,324,229,173,82,81,64,31,17,12,11,11,10,6,3,2,
  2,2,1,1,1,0,0,0,35,0,0,0,1,1,1,1,1,1,
  // 38
  1,1,1,1,1,1,1,1,1,2,2,3,3,3,3,3,2,1,
  1,1,1,3,5,8,11,15,23,37,61,93,164,176,233,350,387,431,
  424,307,292,236,170,147,79,50,32,20,14,10,8,8,6,5,3,3,
  2,2,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,
  // 39
  2,2,2,2,2,2,2,2,2,3,3,4,5,4,4,3,3,2,
  1,1,1,2,4,6,10,15,24,39,65,126,198,226,338,396,362,362,
  338,334,276,212,141,98,71,51,30,19,13,9,7,5,4,4,3,3,
  3,2,2,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,
  // 40
  3,5,32,4,4,4,5,5,4,4,4,5,39,4,4,4,3,2,
  1,1,1,1,3,5,10,16,28,47,68,144,211,213,303,386,341,351,
  314,292,239,168,133,101,71,51,27,18,12,9,6,5,11,27,3,3,
  3,2,2,1,0,0,0,0,0,0,0,0,0,0,1,1,1,2,
  // 41
  4,6,12,8,8,8,9,9,8,6,6,5,5,4,4,3,3,2,
  1,1,1,1,3,6,11,19,50,76,80,130,174,217,260,271,288,309,
  305,320,194,153,109,98,62,41,26,18,13,9,7,5,4,5,4,4,
  3,3,2,1,0,0,0,0,0,0,0,0,0,1,1,2,3,3,
  // 42
  9,14,16,15,12,13,14,14,12,10,7,6,4,4,3,3,2,2,
  1,1,1,2,4,8,14,24,38,62,111,166,163,209,244,240,276,273,
  252,270,197,135,97,81,82,49,28,19,15,11,8,5,5,5,5,5,
  4,3,2,1,1,0,0,0,0,1,1,1,2,2,3,18,21,7,
  // 43
  15,21,26,23,20,19,19,18,16,12,9,6,4,3,3,3,2,1,
  1,1,2,3,6,11,26,46,43,74,124,130,191,187,213,203,255,202,
  216,183,142,116,124,103,65,50,28,21,17,13,10,7,6,6,6,5,
  4,3,2,1,1,1,1,1,1,2,2,2,4,5,7,11,13,13,
  // 44
  23,30,34,33,29,25,22,29,17,13,9,7,15,2,2,2,2,1,
  1,1,3,5,8,17,23,37,52,86,167,137,167,183,185,197,202,215,
  262,166,135,125,85,67,52,39,29,23,19,15,12,9,8,7,7,6,
  5,3,2,2,1,1,2,2,3,3,4,4,6,8,13,16,17,20,
  // 45
  34,41,45,45,43,83,26,47,16,12,9,8,21,2,2,2,1,1,
  1,2,3,6,12,33,32,38,59,93,119,153,180,203,253,227,204,216,
  198,195,119,124,94,73,58,44,33,27,25,20,14,12,10,9,8,7,
  6,5,3,2,2,2,3,3,4,5,6,6,8,14,22,24,24,29,
  // 46
  70,81,61,76,73,75,32,23,17,13,9,5,3,2,2,2,1,1,
  1,2,4,7,12,24,32,44,61,88,117,160,206,198,212,224,201,172,
  167,207,151,153,123,101,105,57,44,42,58,32,24,15,14,12,11,9,
  10,17,9,4,3,4,4,5,6,6,8,9,11,17,26,30,35,52,
  // 47
  88,111,102,101,102,64,42,45,35,14,9,6,4,3,2,2,1,1,
  1,3,5,8,13,22,33,45,59,81,107,157,132,171,165,189,198,154,
  162,212,185,132,109,105,85,70,55,40,33,34,29,19,17,15,13,11,
  10,15,9,5,5,5,6,6,7,8,9,12,16,22,32,43,55,76,
  // 48
  130,193,163,137,108,82,98,46,27,45,18,7,5,4,2,2,1,1,
  2,3,5,9,20,34,53,60,62,104,105,132,135,131,164,185,204,191,
  179,176,163,210,146,164,99,83,97,63,50,32,29,24,21,19,16,13,
  11,9,7,7,6,6,7,7,9,19,16,15,22,34,51,75,111,112,
  // 49
  261,243,234,206,216,184,103,77,35,21,13,9,6,4,3,2,1,1,
  2,4,10,17,20,34,53,63,58,81,115,131,130,129,153,171,203,167,
  192,196,165,194,166,193,133,93,81,60,52,38,34,29,24,21,19,16,
  13,11,10,9,8,7,7,8,10,22,18,19,32,57,98,122,160,210,
  // 50
  379,404,427,355,343,223,129,97,42,26,17,14,10,5,3,2,1,2,
  3,6,19,29,55,46,50,58,82,87,119,133,136,135,177,182,202,243,
  256,207,189,214,188,213,143,111,106,94,69,53,45,48,29,50,28,17,
  16,15,28,16,9,8,8,8,9,12,17,27,55,101,193,235,280,320,
  // 51
  572,633,546,530,484,298,151,84,50,30,21,21,15,7,4,3,3,3,
  5,17,22,16,23,38,48,53,60,96,113,153,135,168,183,200,247,248,
  294,317,268,269,292,253,179,232,116,86,61,60,48,44,30,28,35,35,
  19,18,27,16,9,9,10,10,12,17,27,45,92,176,278,308,395,548,
  // 52
  805,831,819,832,575,374,169,93,54,33,23,29,14,9,7,5,5,5,
  7,15,19,18,26,39,49,81,68,80,98,114,149,186,207,234,268,332,
  360,322,272,281,342,337,193,192,142,102,106,91,49,35,43,35,27,21,
  29,19,16,13,9,13,19,16,17,32,52,102,150,225,329,469,619,696,
  // 53
  1058,1065,1018,852,668,355,209,97,53,33,25,32,14,11,10,9,8,7,
  8,10,14,22,31,40,48,55,72,98,141,178,168,207,247,312,407,430,
  478,354,328,341,329,315,242,176,117,99,112,56,34,34,45,34,25,20,
  37,16,14,11,9,13,20,21,28,52,86,148,246,342,502,751,910,958,
  // 54
  1393,1286,1014,721,510,294,180,84,47,30,66,19,22,16,49,14,12,9,
  9,12,21,24,34,43,48,61,106,132,163,227,244,344,308,361,419,441,
  576,477,421,379,331,261,184,153,116,88,68,41,28,25,24,22,18,16,
  14,12,11,9,13,20,28,60,63,106,166,285,395,527,726,988,1277,1359,
  // 55
  1415,1192,858,608,407,230,123,66,38,26,47,22,35,19,17,17,14,10,
  9,16,38,46,37,54,61,103,133,174,200,278,268,347,414,535,562,432,
  485,540,502,418,295,226,173,118,83,78,37,24,20,18,18,16,14,12,
  10,9,8,9,21,40,45,82,153,254,318,414,550,793,1001,1259,1546,1475,
  // 56
  1481,1042,670,447,273,159,85,45,28,21,18,17,52,16,16,15,12,9,
  9,10,24,67,39,57,94,140,160,183,247,264,323,439,472,509,591,560,
  558,439,372,322,215,212,158,80,52,41,22,15,12,11,11,11,10,8,
  7,7,7,9,17,45,93,182,294,447,566,687,880,1029,1175,1393,1517,1628,
  // 57
  966,753,483,298,177,97,50,28,19,16,15,14,14,13,12,11,9,8,
  7,14,21,35,40,61,104,153,226,266,301,326,389,499,550,559,541,525,
  408,372,253,258,148,103,73,49,32,20,12,7,6,6,6,6,6,5,
  5,5,5,10,24,87,178,340,480,687,860,1040,1120,1170,1362,1748,1585,1261,
  // 58
  609,435,280,173,97,49,25,15,12,11,10,10,10,9,9,7,6,5,
  6,19,22,25,58,105,146,183,216,260,294,321,399,407,475,536,431,435,
  283,218,164,156,95,61,41,26,16,9,5,3,2,2,3,3,3,3,
  2,3,5,12,37,114,246,462,714,1078,1329,1476,1375,1271,1285,1226,1069,800,
  // 59
  375,246,152,85,42,20,11,8,7,6,6,6,6,5,5,4,3,3,
  4,9,14,25,50,127,183,213,251,295,321,379,405,402,379,369,324,304,
  169,136,116,73,48,31,19,11,6,3,1,0,0,0,1,1,1,1,
  1,1,4,14,48,140,312,595,1041,1881,2038,1689,1397,1289,1118,940,662,506,
  // 60
  202,133,69,32,14,7,4,3,3,2,2,2,2,2,2,1,1,1,
  2,5,11,24,49,95,183,204,251,346,331,445,391,306,221,193,167,181,
  102,74,60,34,21,13,7,3,2,1,0,0,0,0,0,0,0,0,
  0,1,4,15,52,158,352,573,1178,2021,1972,1686,1389,1103,852,606,397,282,
  // 61
  96,58,24,10,4,3,2,1,1,1,1,0,0,0,0,0,0,0,
  1,3,8,20,44,89,167,224,234,319,291,248,205,160,138,114,91,80,
  48,33,21,13,8,4,2,1,0,0,0,0,0,0,0,0,0,0,
  0,1,3,14,80,135,305,494,812,1190,1206,1044,930,681,464,318,220,147,
  // 62
  35,16,6,3,2,1,1,1,0,0,0,0,0,0,0,0,0,0,
  0,1,5,14,34,65,103,137,188,228,193,164,137,98,78,59,43,30,
  20,13,8,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,3,12,35,102,230,400,551,668,688,622,560,374,259,169,108,65,
  // 63
  10,4,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,3,8,20,41,67,100,128,121,105,90,71,53,38,26,17,11,
  7,5,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,3,9,23,56,143,227,336,402,381,346,279,191,121,74,43,22,
  // 64
  1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,1,4,11,23,40,55,62,63,58,48,35,24,15,9,5,3,
  2,2,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,3,6,14,30,84,111,145,175,178,157,117,75,44,25,12,5,
  // 65
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,2,5,12,22,30,34,33,28,21,14,8,4,2,1,1,
  1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,2,4,8,15,25,40,53,62,61,51,35,21,12,5,2,0,
  // 66
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,2,5,10,14,15,13,10,7,4,2,1,1,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,2,3,4,7,10,14,17,18,16,12,7,4,1,0,0,0,
  // 67
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,2,3,5,5,4,3,2,1,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,1,1,2,3,4,4,5,4,3,1,0,0,0,0,0,0,
  // 68
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,
  // 69
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 70
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 71
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
  };
  ftype32 rama5_pro[] = {
  // 0
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 1
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 2
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 3
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 4
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 5
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 6
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 7
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 8
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 9
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 10
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 11
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 12
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 13
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 14
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 15
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 16
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 17
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 18
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 19
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 20
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 21
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 22
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 23
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 24
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 25
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 26
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 27
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 28
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 29
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 30
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 31
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 32
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 33
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 34
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 35
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 36
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 37
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 38
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 39
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 40
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 41
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 42
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 43
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 44
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 45
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 46
  0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 47
  1,1,2,2,3,3,4,4,4,4,3,2,1,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,1,2,2,3,3,3,3,3,
  2,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 48
  7,8,9,10,10,10,10,10,8,7,6,4,3,1,0,0,0,0,
  0,0,0,0,0,0,1,2,3,4,5,6,8,10,11,11,10,9,
  7,5,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,5,
  // 49
  24,26,26,26,26,24,22,18,15,11,9,7,5,3,2,0,0,0,
  0,0,0,0,1,3,5,7,8,10,13,16,20,24,26,26,24,21,
  16,12,8,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,1,2,5,8,14,19,
  // 50
  56,59,59,56,51,45,38,30,23,17,13,49,51,8,6,4,2,0,
  0,0,1,3,6,9,13,17,20,24,31,40,49,56,60,58,53,44,
  34,24,16,9,4,1,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,1,4,9,17,27,40,50,
  // 51
  112,111,105,95,83,71,57,45,34,27,23,46,49,24,22,17,11,7,
  4,4,5,9,15,22,30,37,45,56,73,94,114,129,135,128,114,94,
  70,47,29,16,8,4,1,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,1,5,14,27,45,68,90,105,
  // 52
  200,197,178,139,116,96,76,61,48,42,42,47,53,56,52,44,33,24,
  17,14,16,23,33,45,60,76,97,127,167,212,253,281,288,271,235,186,
  134,87,52,29,15,7,4,2,1,1,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,1,6,17,36,66,106,147,177,194,
  // 53
  549,301,257,189,146,114,90,73,63,61,69,82,95,101,98,84,67,51,
  38,32,34,43,60,82,111,149,202,344,415,452,529,573,572,523,439,336,
  233,148,85,47,25,13,7,4,3,2,1,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,2,7,19,46,91,156,230,291,326,332,
  // 54
  440,356,283,253,180,120,95,80,74,81,99,121,142,157,156,136,106,81,
  63,54,56,70,96,135,192,273,388,538,712,887,1019,1156,1059,910,834,539,
  485,223,128,67,35,18,10,6,4,3,1,1,1,1,1,1,1,1,
  0,0,0,0,0,0,0,3,10,27,64,129,224,341,453,604,589,517,
  // 55
  596,432,308,236,161,113,89,129,110,174,122,151,180,302,301,181,142,106,
  85,74,78,98,138,206,312,471,695,1058,1289,1616,1869,1981,1657,1392,1115,844,
  507,316,196,94,43,22,12,8,5,3,2,1,1,2,2,2,2,1,
  0,0,0,0,0,0,4,15,46,110,216,363,533,697,818,906,881,776,
  // 56
  721,493,320,204,133,93,74,88,85,134,131,190,206,269,337,202,159,119,
  96,87,94,122,185,297,481,766,1192,1752,2124,2509,2701,2849,2510,2098,1523,1066,
  624,413,247,110,46,23,12,8,6,3,2,1,2,2,3,3,2,2,
  1,0,0,0,0,5,20,69,179,356,610,867,1104,1276,1381,1386,1267,1001,
  // 57
  817,526,303,171,100,66,54,55,67,91,123,226,262,227,290,184,148,113,
  93,88,100,148,249,414,730,1187,1810,2681,3165,3521,3561,3703,3479,2832,1876,1126,
  690,492,243,105,43,20,11,7,5,3,2,1,2,2,3,3,3,2,
  1,0,0,0,4,20,77,218,468,815,1263,1639,1911,2046,2116,1977,1623,1168,
  // 58
  872,555,348,126,64,39,34,38,51,72,99,125,144,153,153,139,115,91,
  78,77,96,172,315,547,1052,1676,2350,3241,4104,4390,4452,4223,4187,3139,1965,1186,
  673,362,184,78,33,15,8,5,3,2,1,1,1,2,3,3,2,2,
  1,0,0,2,13,59,192,465,892,1424,1979,2471,2875,3010,2804,2445,2093,1463,
  // 59
  781,440,195,79,33,19,18,23,34,49,67,85,98,102,99,88,74,61,
  55,59,85,168,342,643,1264,2006,2729,4348,5144,5262,5401,4751,3633,2907,1712,1047,
  571,284,129,53,21,10,6,3,2,1,0,0,1,2,2,2,2,1,
  0,0,0,5,31,121,344,753,1341,2021,2903,3684,4287,4109,3624,2862,1957,1231,
  // 60
  603,306,120,41,14,8,8,13,19,27,37,47,53,55,53,47,39,34,
  33,40,70,154,339,679,1266,2017,2892,4099,4624,5144,4698,3924,3003,2018,1331,791,
  408,188,78,29,11,5,3,1,0,0,0,0,0,1,1,1,1,0,
  0,0,1,10,53,186,479,979,1680,2519,3559,4542,4411,3925,3198,2384,1673,1038,
  // 61
  390,167,58,16,5,3,4,6,9,13,17,20,22,22,21,18,16,15,
  16,24,54,136,315,639,1172,1809,2626,3504,3932,4174,3645,3010,2225,1429,889,491,
  236,99,37,13,5,2,1,0,0,0,0,0,0,0,0,0,0,0,
  0,0,2,16,72,226,545,1091,1862,2726,3711,4199,4050,3519,2733,1944,1282,757,
  // 62
  204,73,21,5,1,1,2,3,4,5,5,6,7,6,5,5,4,5,
  7,14,39,107,257,525,1089,1532,2111,2774,2967,2742,2357,1871,1349,870,497,248,
  106,39,13,5,2,1,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,4,20,77,226,532,1047,1936,2975,3469,3210,3129,2600,2046,1379,851,456,
  // 63
  77,22,4,0,0,0,1,1,1,1,1,1,1,1,0,0,1,2,
  3,9,26,73,180,372,803,1081,1407,1849,1755,1661,1415,1076,722,422,214,92,
  34,11,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,5,21,69,188,412,863,1440,1763,1987,2118,2015,1697,1254,811,452,210,
  // 64
  17,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  1,5,16,44,106,220,392,594,801,934,965,881,704,491,294,149,64,23,
  7,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,6,19,53,133,281,501,773,1044,1236,1288,1172,926,629,362,172,63,
  // 65
  1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,2,8,23,52,107,191,290,379,431,425,361,262,160,81,34,11,3,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,5,15,36,81,162,279,418,547,624,618,524,375,221,106,38,9,
  // 66
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,3,10,22,42,73,109,139,150,137,104,66,34,13,4,1,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,4,11,23,44,79,128,182,226,240,218,164,100,48,17,4,0,
  // 67
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,1,4,8,14,21,30,35,36,30,20,11,4,1,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,3,7,13,22,35,50,63,70,66,52,32,15,6,2,0,0,
  // 68
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,1,2,4,5,6,6,6,5,3,2,1,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,1,3,6,10,14,17,18,16,12,7,3,1,0,0,0,0,
  // 69
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,1,3,4,5,5,4,3,1,0,0,0,0,0,0,0,
  // 70
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,
  // 71
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
  };
  ftype32 rama5_ngp[] = {
  // 0
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 1
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 2
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 3
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 4
  0,0,0,0,0,0,0,0,1,2,2,3,3,2,1,1,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 5
  0,0,0,0,0,0,1,3,5,7,9,10,9,7,4,2,1,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 6
  0,0,0,0,1,3,7,13,19,23,24,24,21,15,9,5,3,1,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,1,1,1,1,1,7,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 7
  0,0,0,2,6,13,24,35,45,51,57,46,37,26,17,9,5,2,
  1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,1,1,2,2,2,2,2,1,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 8
  0,1,4,10,19,34,53,71,89,90,96,86,65,42,27,14,7,3,
  1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,1,5,3,3,4,4,4,3,2,1,1,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 9
  2,6,12,24,41,65,91,114,140,147,142,121,97,58,39,18,9,4,
  2,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,1,1,2,7,4,6,9,6,5,4,3,2,1,1,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 10
  7,14,26,43,68,101,130,158,208,235,211,149,129,73,46,22,10,5,
  2,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,1,1,2,3,5,6,13,16,8,7,6,4,3,2,1,
  0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,3,
  // 11
  14,25,41,64,102,148,206,247,317,288,202,153,108,68,41,19,9,4,
  2,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
  1,1,1,1,2,2,4,5,6,13,19,9,9,8,4,3,2,1,
  0,0,0,0,1,1,2,2,1,1,1,1,1,1,1,1,3,7,
  // 12
  21,36,56,95,144,181,210,250,245,212,173,128,80,53,38,20,8,4,
  2,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,3,
  5,1,1,2,5,4,3,5,6,7,9,9,8,6,4,3,2,1,
  0,0,0,1,1,2,3,3,3,2,2,7,1,1,2,6,7,12,
  // 13
  28,48,76,105,132,167,174,181,170,142,112,83,55,33,19,12,7,3,
  2,1,1,1,1,1,0,0,0,0,0,0,0,2,1,0,1,1,
  5,1,1,1,2,2,3,3,4,5,7,8,6,4,3,2,1,1,
  0,0,1,1,2,5,6,5,4,3,3,3,2,2,3,7,12,16,
  // 14
  32,51,73,92,98,125,122,123,109,91,69,48,31,18,10,6,3,2,
  1,1,1,1,1,1,1,1,0,0,0,0,0,4,1,1,3,1,
  5,1,1,1,1,2,2,2,3,3,4,4,3,3,2,1,1,0,
  0,0,1,1,2,5,7,6,5,4,3,2,2,3,4,6,16,19,
  // 15
  38,41,55,57,70,87,73,70,58,47,34,23,13,8,9,3,2,1,
  1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,3,2,
  1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1,0,0,
  0,0,1,1,2,3,4,5,4,4,3,2,2,3,4,6,11,24,
  // 16
  22,26,31,36,39,39,37,32,26,19,13,7,4,3,4,1,1,1,
  1,1,0,0,0,0,1,1,1,1,3,1,1,6,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,1,2,2,3,3,3,3,2,2,2,2,3,6,14,22,
  // 17
  13,16,18,20,20,18,16,12,9,5,3,2,1,1,1,1,1,0,
  0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,1,2,2,2,2,2,1,1,1,2,3,4,8,10,
  // 18
  7,8,9,9,8,7,5,3,2,1,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,1,1,1,1,1,1,0,0,1,2,3,4,6,
  // 19
  3,4,3,3,2,2,1,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,3,
  // 20
  1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,
  // 21
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 22
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 23
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 24
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 25
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 26
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 27
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 28
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 29
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 30
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 31
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 32
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 33
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,1,1,2,3,3,3,3,2,
  2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 34
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,1,1,2,3,5,7,10,11,12,11,8,
  6,4,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,
  // 35
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
  1,1,1,1,1,1,2,3,4,7,11,16,21,27,30,30,27,22,
  16,10,5,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,
  // 36
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,
  2,2,2,3,3,4,5,8,12,18,26,37,49,60,67,68,59,47,
  34,22,12,6,3,1,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 37
  0,0,0,0,0,0,0,0,0,0,1,1,1,2,2,3,3,4,
  4,5,6,6,7,10,13,19,29,40,57,75,96,122,126,128,107,86,
  63,42,23,12,6,3,1,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 38
  1,1,1,1,1,1,1,1,1,1,2,2,4,5,6,6,7,11,
  13,9,11,12,15,19,26,38,59,75,107,137,167,208,208,205,196,141,
  101,69,39,20,11,5,3,1,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 39
  2,2,3,3,3,3,3,3,3,3,4,12,8,10,10,13,16,14,
  15,16,22,25,27,36,49,65,91,127,171,229,296,332,361,353,264,218,
  137,93,56,31,15,8,4,2,1,0,0,0,0,0,0,0,0,0,
  0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,
  // 40
  4,5,6,6,7,7,7,6,5,6,7,9,12,22,32,18,19,29,
  24,24,29,37,54,78,84,108,146,215,278,328,381,429,457,434,342,261,
  180,105,76,45,25,12,11,3,1,0,0,0,0,0,0,0,0,1,
  1,1,1,1,2,2,1,1,1,1,1,1,1,1,2,2,3,3,
  // 41
  8,10,11,12,12,12,12,14,13,14,12,15,19,27,31,29,28,32,
  37,39,45,56,79,100,132,182,230,298,365,453,489,546,529,508,381,289,
  204,121,73,40,23,12,6,3,1,0,0,0,0,0,1,1,1,1,
  1,2,2,3,6,3,3,2,2,2,2,6,2,3,4,4,5,7,
  // 42
  16,18,20,21,21,20,18,23,23,22,20,25,30,40,43,50,44,43,
  45,56,66,86,117,154,195,264,328,404,484,568,599,663,613,595,435,312,
  218,126,74,44,24,14,6,3,1,1,1,1,1,1,1,1,1,1,
  2,2,3,4,9,4,4,4,4,4,4,8,5,7,7,9,11,13,
  // 43
  29,32,34,35,38,32,29,34,27,33,36,39,50,62,56,60,62,58,
  62,74,93,127,163,227,298,385,457,563,632,705,761,773,712,615,498,334,
  232,130,76,46,26,16,7,3,2,1,1,1,1,1,1,1,1,2,
  2,3,4,5,6,6,7,7,7,7,8,8,17,15,15,17,20,24,
  // 44
  49,53,55,58,71,52,49,52,46,44,41,53,61,71,77,77,90,74,
  76,102,129,173,234,329,455,547,647,719,818,893,900,863,816,673,497,332,
  213,140,75,43,25,13,7,4,2,1,1,2,2,2,2,2,2,2,
  3,4,5,7,8,9,10,10,11,12,13,15,18,23,26,30,44,44,
  // 45
  87,90,92,97,87,87,86,62,69,48,50,59,77,85,109,90,104,106,
  102,116,170,247,320,441,602,704,800,899,957,953,908,906,852,654,474,318,
  200,131,72,46,23,13,7,4,3,2,2,2,2,2,2,2,2,3,
  4,5,7,8,10,16,15,15,21,22,31,25,30,39,45,51,71,87,
  // 46
  125,134,146,142,122,117,99,72,62,59,54,62,68,86,89,87,103,118,
  119,136,190,275,387,531,719,826,938,1035,1020,961,922,873,758,604,440,298,
  186,114,65,39,22,13,8,5,3,2,2,2,2,2,2,2,3,5,
  7,6,11,10,12,16,18,23,30,33,36,41,50,60,74,102,110,118,
  // 47
  183,205,205,198,184,150,115,89,71,65,51,57,61,77,86,87,102,120,
  134,159,229,323,453,633,845,992,1098,1123,1092,975,916,833,712,568,405,264,
  164,100,58,34,21,13,8,6,4,3,3,2,4,4,3,3,4,5,
  8,8,15,14,17,22,23,31,39,47,53,60,74,83,104,138,157,163,
  // 48
  268,274,276,264,252,214,165,110,84,64,45,42,52,56,73,91,93,112,
  160,190,258,389,519,713,950,1152,1199,1156,1103,945,873,781,637,497,351,236,
  171,95,53,32,23,16,8,13,5,4,3,3,10,5,3,4,5,6,
  7,9,11,19,20,28,32,43,52,60,70,84,117,128,167,182,208,258,
  // 49
  337,366,358,347,335,227,179,124,81,63,41,35,36,41,49,62,84,99,
  149,192,294,443,598,802,1022,1212,1201,1141,1084,974,821,647,617,454,310,223,
  145,79,49,30,19,12,8,12,4,4,3,2,3,3,3,4,7,7,
  7,9,11,14,20,29,37,58,71,80,92,121,154,168,197,258,286,314,
  // 50
  461,473,471,407,331,254,204,125,76,48,41,39,34,35,42,56,77,95,
  136,205,304,453,615,808,1065,1099,1132,1117,1006,878,735,617,497,364,264,185,
  124,80,47,29,18,11,7,5,3,3,2,2,2,3,4,5,5,5,
  11,10,11,20,21,36,49,70,85,102,115,145,183,214,276,324,396,404,
  // 51
  541,533,521,421,342,247,176,111,71,47,33,33,39,38,45,61,81,105,
  153,229,327,470,604,778,927,1001,1028,998,880,762,635,554,443,355,255,181,
  117,79,47,31,18,11,6,7,3,2,2,2,2,3,4,5,4,5,
  6,9,12,18,24,40,58,81,106,134,157,192,232,277,345,406,454,498,
  // 52
  638,615,559,438,339,244,153,99,69,45,33,34,47,49,56,74,94,123,
  170,248,344,465,575,732,850,960,988,928,828,707,592,514,432,368,263,190,
  127,84,50,32,20,12,5,6,4,1,1,1,2,2,3,3,3,4,
  5,9,13,18,28,46,69,95,134,178,219,260,314,360,451,516,585,601,
  // 53
  814,726,639,464,305,192,126,76,57,39,35,46,50,59,76,91,110,146,
  178,258,339,464,571,709,859,894,952,898,795,719,610,502,436,336,262,208,
  157,96,62,32,18,9,4,4,4,1,1,1,1,1,6,5,2,3,
  4,7,10,20,31,47,82,132,210,280,340,397,468,530,554,615,720,748,
  // 54
  852,709,512,344,227,147,90,57,36,32,35,51,71,78,96,123,130,159,
  227,251,312,382,536,628,744,808,846,858,774,675,614,541,489,438,286,224,
  154,104,79,36,19,9,4,1,0,0,0,1,1,1,1,1,1,2,
  3,6,9,16,34,61,125,205,336,500,598,665,709,732,762,806,855,846,
  // 55
  774,587,424,286,174,102,58,36,28,27,41,50,70,93,110,119,120,150,
  193,219,273,360,481,558,670,741,804,827,776,728,651,584,532,446,304,229,
  159,100,63,38,18,8,3,1,0,0,0,0,0,1,1,1,1,1,
  2,6,10,18,39,89,210,437,726,978,1131,1221,1151,1058,1013,981,960,853,
  // 56
  653,464,312,199,117,65,35,24,21,21,31,36,52,70,84,96,96,112,
  133,174,216,287,383,465,590,707,785,833,789,764,703,633,547,452,333,239,
  158,98,52,31,16,7,2,0,0,0,0,0,0,0,0,0,0,1,
  1,4,9,19,56,171,440,872,1360,1764,2020,2034,1906,1590,1327,1128,1023,807,
  // 57
  540,383,230,131,71,36,19,14,14,15,20,27,36,46,55,77,71,82,
  92,131,160,215,310,406,530,694,782,850,847,806,752,669,560,471,344,230,
  152,86,43,22,13,6,1,0,0,0,0,0,0,0,0,0,0,0,
  1,3,8,25,96,330,783,1436,2174,2765,3134,3095,2745,2166,1700,1356,1078,746,
  // 58
  419,265,154,78,37,17,8,6,6,9,15,18,22,28,33,38,42,47,
  56,77,110,147,225,341,495,613,759,893,913,893,788,694,570,422,272,182,
  129,59,30,14,6,2,0,0,0,0,0,0,0,0,0,0,0,0,
  1,2,8,35,159,506,1132,1975,3103,4118,4744,4533,3614,2736,2105,1578,1098,695,
  // 59
  306,178,90,40,17,7,3,2,3,4,8,10,12,15,18,20,22,25,
  31,42,63,105,197,283,407,577,692,871,986,872,719,592,439,311,204,126,
  74,39,18,8,3,1,0,0,0,0,0,0,0,0,0,0,0,0,
  0,2,9,47,209,626,1346,2431,4229,6649,7923,6169,4175,3105,2229,1507,828,503,
  // 60
  202,102,45,17,6,2,1,1,1,1,2,3,4,6,7,8,9,11,
  14,21,37,68,122,215,323,471,611,774,747,628,522,411,334,216,138,83,
  45,22,9,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,2,9,52,223,647,1372,2484,4373,5829,5886,4645,3662,2606,1686,1025,599,365,
  // 61
  113,50,19,6,2,1,0,0,0,0,0,1,1,1,2,3,3,4,
  5,10,20,43,86,155,245,360,468,572,531,458,375,280,205,136,82,46,
  22,9,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,3,11,47,191,548,1175,2068,3274,4073,4070,3486,2735,1907,1190,691,395,224,
  // 62
  50,18,5,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,
  2,4,11,27,57,111,183,257,327,370,347,310,237,177,115,71,39,19,
  8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,3,10,34,133,386,852,1473,2138,2530,2611,2330,1790,1198,711,397,218,112,
  // 63
  15,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  1,2,6,15,35,66,112,165,195,222,212,171,126,86,53,29,14,6,
  2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,6,21,75,215,503,860,1219,1444,1493,1293,957,611,343,183,93,42,
  // 64
  2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,3,8,19,37,66,89,110,109,104,81,57,35,19,9,3,1,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,4,12,36,97,225,399,560,666,668,560,391,231,123,61,27,9,
  // 65
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,2,4,9,19,30,40,47,48,42,32,20,11,5,2,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,3,4,6,17,40,78,138,198,231,220,172,111,63,35,14,4,1,
  // 66
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,1,2,4,8,13,16,18,17,14,9,5,2,1,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,2,3,6,13,24,40,55,61,54,40,25,13,9,2,0,0,
  // 67
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,1,2,3,5,5,5,5,3,2,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,1,2,5,7,11,13,13,11,7,4,2,1,0,0,0,
  // 68
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,1,1,2,2,1,1,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,1,2,2,3,3,3,2,1,0,0,0,0,0,0,
  // 69
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,
  // 70
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 71
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
  };
  ftype32 rama5_ngl[] = {
  // 0
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 1
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 2
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 3
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 4
  0,0,0,0,0,0,0,0,1,1,2,3,3,2,1,1,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 5
  0,0,0,0,0,0,1,2,5,7,8,9,8,6,4,2,1,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 6
  0,0,0,0,1,3,7,12,18,22,23,22,19,14,9,5,2,1,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,1,1,1,1,1,6,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 7
  0,0,0,2,6,13,22,33,43,48,54,44,35,25,16,9,4,2,
  1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,1,1,2,2,2,2,1,1,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 8
  0,1,4,9,18,32,50,67,84,85,90,81,61,39,25,13,7,3,
  1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,1,5,2,3,4,4,3,3,2,1,1,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 9
  2,5,12,22,39,62,86,107,131,138,133,114,91,55,37,17,8,4,
  2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,1,1,2,7,4,6,8,6,5,4,3,2,1,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 10
  6,13,24,40,64,95,123,148,198,221,201,144,121,68,43,21,9,4,
  2,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,1,1,2,3,4,5,12,15,8,6,5,4,3,2,1,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,
  // 11
  13,23,39,60,96,139,193,234,299,271,189,145,101,63,38,17,9,4,
  2,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
  1,1,1,1,2,2,4,5,6,12,19,8,9,8,4,3,2,1,
  0,0,0,0,1,1,1,2,1,1,1,1,1,1,1,1,3,6,
  // 12
  20,34,53,89,139,169,198,238,232,200,163,120,78,50,36,19,8,3,
  2,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,3,
  5,1,1,1,5,4,3,4,5,6,8,8,7,6,4,3,2,1,
  0,0,0,1,1,2,3,3,3,2,2,7,1,1,2,6,7,11,
  // 13
  26,45,72,100,126,157,164,172,160,133,106,79,52,31,18,11,6,3,
  1,1,1,1,1,1,0,0,0,0,0,0,0,2,0,0,1,1,
  5,1,1,1,2,2,2,3,4,5,7,7,6,4,3,2,1,1,
  0,0,1,1,2,5,6,5,4,3,2,3,2,2,3,6,12,15,
  // 14
  30,48,68,86,93,118,114,115,104,85,65,46,29,17,9,6,3,2,
  1,1,1,1,1,1,1,1,0,0,0,0,0,3,1,0,2,1,
  5,1,1,1,1,1,2,2,2,3,4,4,3,2,2,1,1,0,
  0,0,1,1,2,5,6,5,5,4,3,2,2,2,3,6,15,18,
  // 15
  36,39,52,54,66,82,69,67,55,44,33,21,13,8,8,3,2,1,
  1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,3,2,
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,
  0,0,0,1,2,3,4,4,4,3,3,2,2,2,4,6,11,24,
  // 16
  21,24,29,34,36,37,35,30,25,18,12,7,4,3,3,1,1,1,
  1,0,0,0,0,0,1,1,1,1,2,1,1,5,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,1,2,2,3,3,3,3,2,2,2,2,3,6,15,21,
  // 17
  13,15,17,19,19,17,15,11,8,5,3,2,1,1,1,1,0,0,
  0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,1,1,2,2,2,2,1,1,1,1,2,4,7,9,
  // 18
  7,8,9,9,8,6,5,3,2,1,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,1,1,1,1,1,0,0,0,1,1,2,4,5,
  // 19
  3,3,3,3,2,1,1,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,2,
  // 20
  1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
  // 21
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 22
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 23
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 24
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 25
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 26
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 27
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 28
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 29
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 30
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 31
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 32
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 33
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,1,1,2,3,3,3,3,2,
  2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 34
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,1,2,3,5,7,9,11,11,10,8,
  6,3,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,
  // 35
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
  1,1,1,1,1,1,2,3,4,7,10,15,20,25,29,29,26,21,
  15,9,5,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,
  // 36
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,
  2,2,2,2,3,4,5,8,12,17,25,35,46,56,63,64,55,44,
  32,20,12,6,3,1,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 37
  0,0,0,0,0,0,0,0,0,0,0,1,1,2,2,3,3,4,
  4,5,5,6,7,9,12,18,27,38,53,71,91,115,119,121,101,81,
  59,39,22,12,6,3,1,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 38
  0,1,1,1,1,1,1,1,1,1,2,2,3,5,5,5,7,10,
  12,9,10,12,14,18,25,36,55,70,101,129,158,196,195,192,185,134,
  96,65,37,19,10,5,2,1,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 39
  2,2,3,3,3,3,2,2,3,3,4,11,7,9,10,13,15,13,
  14,15,21,24,26,34,46,62,85,120,162,216,280,313,342,337,250,206,
  130,88,53,30,14,7,3,2,0,0,0,0,0,0,0,0,0,0,
  0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,
  // 40
  4,5,5,6,6,7,7,5,5,6,7,9,11,20,30,17,19,27,
  23,23,27,34,51,73,79,102,138,202,262,310,358,404,431,410,322,246,
  171,99,71,42,24,11,10,3,1,0,0,0,0,0,0,0,0,1,
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,3,
  // 41
  8,9,10,11,12,12,11,13,12,13,12,14,18,25,29,27,26,30,
  34,36,42,53,75,95,123,171,217,280,346,426,460,516,498,479,359,272,
  193,114,69,38,21,11,6,2,1,0,0,0,0,0,0,1,1,1,
  1,1,2,2,5,3,2,2,2,2,2,5,2,3,3,4,5,6,
  // 42
  15,17,18,19,20,18,17,22,22,20,18,24,28,38,40,47,41,41,
  43,52,62,82,112,146,183,249,308,381,460,536,565,629,578,561,409,294,
  206,118,70,41,23,13,6,3,1,1,0,1,1,1,1,1,1,1,
  2,2,3,4,8,4,4,4,3,3,4,8,5,6,7,8,10,12,
  // 43
  27,30,32,33,36,30,28,32,26,31,36,37,47,58,53,57,59,55,
  58,70,88,120,154,215,282,364,431,533,596,667,718,729,671,581,469,314,
  218,123,71,43,24,15,6,3,2,1,1,1,1,1,1,1,1,2,
  2,3,4,5,6,6,6,6,6,7,7,8,16,14,14,16,19,23,
  // 44
  46,50,52,54,67,49,46,49,44,41,38,50,57,70,72,73,85,70,
  72,96,123,164,220,309,429,516,613,679,772,844,848,813,770,634,467,314,
  201,132,70,41,23,12,6,3,2,1,1,1,2,2,2,2,2,2,
  3,4,5,6,7,8,9,10,10,11,13,14,17,22,25,29,41,42,
  // 45
  82,85,87,91,82,82,81,58,65,45,47,56,72,80,101,86,99,100,
  96,109,161,233,302,416,568,665,755,851,900,903,857,854,804,617,449,301,
  189,123,68,43,22,12,7,4,2,2,2,2,2,2,2,2,2,3,
  4,5,6,8,9,15,14,14,19,21,29,24,29,37,43,49,67,82,
  // 46
  118,127,139,133,115,110,94,68,58,56,51,58,64,81,84,82,97,111,
  111,128,180,260,365,501,679,777,884,977,958,907,870,824,717,571,415,281,
  176,108,62,37,20,12,7,4,3,2,2,2,2,2,2,2,3,4,
  7,6,10,9,12,15,17,21,28,31,34,39,47,57,70,96,104,112,
  // 47
  173,193,196,186,174,143,109,84,67,62,49,54,58,73,81,81,96,114,
  126,150,216,305,430,598,799,936,1036,1064,1031,919,864,786,672,537,381,250,
  155,94,55,32,20,12,8,5,4,3,2,2,3,4,3,3,3,5,
  7,7,14,13,16,21,22,29,36,45,51,57,70,78,98,130,148,154,
  // 48
  253,259,261,250,237,202,157,104,80,61,44,40,50,52,69,86,88,106,
  151,179,243,367,489,673,896,1088,1134,1093,1042,892,823,740,603,469,330,223,
  161,89,50,31,22,15,8,12,4,4,3,2,10,5,3,3,5,5,
  6,8,10,18,19,27,30,41,49,57,66,80,111,121,157,175,196,244,
  // 49
  319,347,340,331,319,216,170,117,76,60,39,33,34,39,46,58,79,93,
  139,181,278,418,563,758,968,1145,1133,1078,1024,923,776,614,583,429,293,211,
  137,75,47,29,18,11,7,11,4,3,3,2,2,3,3,4,6,7,
  6,8,10,13,19,27,36,54,66,76,86,114,146,158,186,246,271,297,
  // 50
  437,449,449,388,314,241,194,120,73,47,39,37,32,34,40,53,73,90,
  129,193,287,427,580,763,1003,1038,1068,1053,950,829,694,586,475,346,251,176,
  120,76,45,28,17,10,6,5,3,2,2,2,2,3,4,4,5,5,
  10,9,10,19,20,34,46,65,80,96,109,137,172,203,261,309,376,385,
  // 51
  516,509,498,403,327,238,169,107,69,46,33,33,39,38,45,58,77,100,
  145,216,308,445,571,735,876,943,971,946,834,723,604,528,426,342,246,175,
  116,77,46,30,17,10,6,6,3,2,2,2,2,2,4,4,4,4,
  6,8,11,17,23,38,55,76,100,126,149,181,218,262,328,388,433,475,
  // 52
  614,593,537,420,325,235,148,97,68,44,34,37,49,50,56,72,90,118,
  161,235,325,441,543,696,803,908,940,886,790,678,570,498,423,363,258,189,
  127,84,50,32,20,12,5,6,3,1,1,1,1,2,3,3,3,3,
  5,9,12,17,26,44,65,90,127,168,209,246,299,343,430,495,562,577,
  // 53
  790,703,618,447,297,188,124,76,57,40,36,49,53,61,77,90,107,140,
  171,245,321,440,543,679,816,851,907,869,773,702,603,503,446,342,269,213,
  160,99,64,33,18,9,4,4,4,1,1,1,1,1,6,4,2,3,
  4,7,10,19,29,44,78,125,198,264,321,377,446,510,534,596,696,723,
  // 54
  832,691,500,343,223,147,95,59,38,34,38,55,75,87,99,123,130,154,
  218,242,298,363,512,599,712,776,823,836,770,684,637,574,517,461,319,240,
  177,110,81,38,20,9,4,2,1,0,0,0,1,1,1,1,1,2,
  3,5,9,15,32,59,118,194,317,473,569,633,682,708,743,792,836,829,
  // 55
  761,577,417,282,173,102,60,41,32,35,45,55,75,104,120,121,119,147,
  187,210,259,345,463,537,647,723,794,839,799,774,722,655,595,494,347,264,
  178,112,68,40,20,9,4,1,0,0,0,0,0,1,1,1,1,1,
  2,6,10,17,36,84,198,413,687,929,1081,1172,1113,1036,1000,976,953,847,
  // 56
  655,464,312,199,118,66,38,28,24,27,36,45,66,80,101,102,98,112,
  131,169,207,278,372,455,582,707,810,884,854,859,819,759,655,545,404,283,
  184,120,60,34,18,8,3,1,0,0,0,0,0,0,0,0,0,1,
  1,4,9,18,52,162,416,827,1293,1683,1937,1964,1851,1566,1326,1145,1046,812,
  // 57
  557,392,234,133,72,38,21,16,16,19,26,39,54,56,72,84,75,83,
  92,129,156,210,305,405,540,719,839,946,970,954,909,848,721,602,441,279,
  180,109,52,25,15,7,2,1,0,0,0,0,0,0,0,0,0,0,
  1,3,7,23,91,313,744,1368,2073,2648,3019,3011,2691,2153,1721,1398,1117,768,
  // 58
  442,280,160,80,39,18,10,7,9,12,21,26,29,35,41,44,45,49,
  57,76,109,147,228,350,527,666,843,1036,1098,1109,998,922,799,580,372,238,
  157,74,37,17,8,3,1,0,0,0,0,0,0,0,0,0,0,0,
  1,2,7,33,151,482,1078,1887,2976,3952,4590,4416,3572,2748,2146,1646,1160,748,
  // 59
  328,188,95,42,18,7,4,3,4,7,11,13,16,19,22,24,25,27,
  32,43,64,107,203,301,450,649,811,1076,1235,1155,991,833,649,458,287,176,
  99,51,24,10,4,1,0,0,0,0,0,0,0,0,0,0,0,0,
  0,2,8,44,200,598,1287,2335,4067,6371,7643,6046,4198,3171,2316,1590,899,552,
  // 60
  221,110,48,18,7,3,1,1,2,3,4,5,7,8,9,10,11,12,
  15,22,40,76,132,240,374,555,733,974,1001,923,764,607,496,312,200,119,
  63,30,12,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,2,9,49,214,621,1319,2397,4211,5632,5760,4704,3736,2721,1783,1107,650,398,
  // 61
  127,56,20,6,2,1,0,0,0,1,1,1,2,2,3,3,4,4,
  6,10,22,48,97,180,299,439,591,747,727,668,553,424,315,202,123,68,
  33,14,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,3,10,45,185,530,1138,2010,3190,4002,4060,3558,2821,2007,1271,754,439,251,
  // 62
  58,21,6,2,0,0,0,0,0,0,0,0,0,0,0,1,1,1,
  2,5,12,30,68,135,237,329,441,519,494,435,348,265,181,111,62,31,
  13,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,3,9,33,130,377,833,1446,2124,2554,2655,2400,1864,1274,777,446,249,129,
  // 63
  18,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  1,2,7,18,42,82,147,213,268,314,295,249,193,137,87,49,24,10,
  3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,5,21,74,213,497,862,1225,1462,1518,1336,1006,663,388,214,111,50,
  // 64
  3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,4,10,23,46,82,115,145,152,149,122,90,58,33,16,6,2,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,4,12,36,99,228,408,570,684,695,595,429,265,149,76,34,12,
  // 65
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,2,5,11,23,38,52,63,67,62,48,32,18,9,3,1,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,3,4,6,18,42,82,150,209,248,240,194,132,79,45,18,6,1,
  // 66
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,1,2,5,10,16,21,24,24,20,14,8,4,1,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,2,3,7,15,27,46,61,70,63,49,32,18,11,3,0,0,
  // 67
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,1,2,4,5,7,7,6,4,2,1,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,1,1,3,5,9,13,16,16,14,10,6,3,1,0,0,0,
  // 68
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,1,1,2,2,2,1,1,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,1,1,2,3,3,4,3,2,1,0,0,0,0,0,0,
  // 69
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,
  // 70
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 71
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
  };
  ftype32 rama5_all[] = {
  // 0
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 1
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 2
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 3
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 4
  0,0,0,0,0,0,0,0,1,1,2,2,2,2,1,1,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 5
  0,0,0,0,0,0,1,2,5,7,8,9,8,6,4,2,1,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 6
  0,0,0,0,1,3,7,12,18,21,23,22,18,13,8,5,2,1,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,1,1,2,2,2,1,1,6,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 7
  0,0,0,2,6,13,24,35,45,50,54,44,34,24,15,8,4,2,
  1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,1,2,3,4,5,5,5,4,2,1,1,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 8
  0,1,4,10,21,37,56,75,93,93,95,83,63,38,24,12,6,3,
  1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,1,1,3,4,9,8,9,9,9,7,5,3,1,1,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 9
  3,7,14,27,46,74,104,130,155,159,151,129,99,55,36,16,8,3,
  1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  1,1,2,3,4,6,9,15,14,16,18,14,10,7,5,3,1,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
  // 10
  9,18,32,53,82,125,165,195,246,267,235,169,132,73,43,19,9,4,
  2,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,
  2,3,5,7,9,12,15,18,21,27,31,20,15,11,7,4,2,1,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,4,
  // 11
  21,36,57,89,133,190,265,312,377,347,250,185,119,73,43,17,8,4,
  2,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,2,4,
  6,8,10,12,15,18,24,29,32,37,41,28,27,16,9,5,2,1,
  0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,2,5,11,
  // 12
  38,61,90,143,209,249,303,364,405,366,251,166,101,60,38,19,7,3,
  2,1,1,1,1,0,0,0,0,0,0,0,0,1,2,4,6,11,
  15,14,18,21,25,35,42,40,33,33,34,26,22,15,9,5,3,1,
  1,0,0,1,1,2,3,3,3,2,2,7,2,2,3,9,13,23,
  // 13
  60,93,131,177,215,255,278,297,312,259,182,124,76,42,21,13,6,2,
  1,1,1,1,1,1,0,0,0,0,1,1,2,5,5,8,13,15,
  23,28,28,31,35,38,39,34,33,31,28,26,20,13,8,5,2,1,
  1,1,1,1,2,5,6,5,4,4,3,4,3,4,7,14,26,39,
  // 14
  85,115,153,186,201,222,221,229,219,173,124,84,50,26,12,6,3,2,
  1,1,1,1,1,1,1,1,1,1,2,3,4,9,10,14,20,22,
  31,41,39,42,42,40,39,32,32,28,23,20,16,11,7,4,2,1,
  1,1,1,2,3,6,7,6,5,4,4,4,4,7,13,23,42,58,
  // 15
  120,147,180,182,186,184,170,162,130,110,75,49,29,15,12,3,2,1,
  1,1,1,1,1,1,1,2,2,3,4,6,8,11,16,24,26,31,
  33,45,48,47,48,39,37,30,27,28,21,15,11,8,5,4,2,1,
  1,1,1,2,3,4,5,5,5,5,4,5,7,12,22,36,54,84,
  // 16
  154,167,150,161,142,128,115,94,74,56,39,24,13,6,5,2,1,1,
  1,1,1,1,1,2,2,2,3,5,7,9,15,25,21,28,36,37,
  54,49,57,48,45,37,32,28,23,18,14,10,7,6,4,5,3,1,
  1,1,1,2,3,4,7,5,5,4,5,6,10,18,31,48,88,113,
  // 17
  135,135,150,133,107,85,65,51,38,27,18,10,6,3,2,1,1,1,
  1,2,2,2,2,2,2,3,4,6,9,12,15,23,25,35,51,45,
  48,45,48,40,37,32,25,29,20,16,11,10,6,4,3,2,3,1,
  1,1,1,2,2,3,6,4,6,4,5,8,14,24,41,62,86,114,
  // 18
  117,113,116,97,73,55,40,27,18,12,7,4,3,2,3,1,1,1,
  2,2,2,2,2,3,3,4,7,7,9,13,17,22,29,35,36,39,
  45,41,39,32,31,25,21,20,16,10,8,7,5,4,3,2,2,1,
  1,0,1,2,2,2,2,3,4,4,5,9,17,29,45,70,87,111,
  // 19
  99,90,87,68,51,34,24,14,9,5,3,2,2,1,2,1,1,1,
  2,2,2,2,3,3,3,5,7,8,12,16,19,23,27,33,31,33,
  36,36,36,29,25,20,17,17,13,8,6,5,4,3,2,2,1,1,
  0,0,0,0,1,1,1,2,2,3,6,10,20,31,46,74,85,101,
  // 20
  77,67,63,46,33,22,14,10,4,3,2,1,1,1,1,1,1,1,
  2,2,2,2,3,3,4,10,11,10,17,18,19,29,26,30,26,30,
  30,31,26,24,20,16,13,11,9,7,6,7,4,3,2,2,1,1,
  0,0,0,0,0,1,1,1,2,3,6,9,17,32,46,69,72,84,
  // 21
  54,49,40,29,25,18,8,5,2,1,1,1,1,1,1,1,1,1,
  2,2,2,2,4,5,3,4,6,9,10,21,16,18,29,24,28,28,
  27,23,23,18,17,15,14,12,8,9,5,5,4,3,5,1,1,1,
  0,0,0,0,0,0,1,3,2,3,4,8,17,33,45,53,50,58,
  // 22
  36,29,25,21,19,9,5,3,1,1,1,1,0,0,1,1,1,1,
  1,2,2,2,3,4,3,4,5,7,8,12,14,17,16,19,18,18,
  18,22,19,15,16,14,10,9,10,7,8,7,4,2,2,1,1,0,
  0,0,0,0,0,0,0,1,1,2,4,7,14,21,26,33,38,37,
  // 23
  22,18,16,12,9,5,3,2,1,2,0,0,0,0,0,0,1,1,
  1,1,1,2,2,2,4,3,5,6,7,9,11,13,16,19,17,18,
  16,17,18,16,15,12,11,11,10,8,5,5,4,2,1,1,0,0,
  0,0,0,0,0,0,0,0,1,2,3,5,12,14,17,21,22,22,
  // 24
  14,11,11,7,4,3,2,1,1,2,0,0,0,0,0,0,0,1,
  1,1,1,1,2,2,3,3,4,5,6,7,9,13,14,20,15,17,
  16,16,18,18,15,12,12,11,9,10,6,5,4,4,1,1,0,0,
  0,0,0,0,0,0,0,0,1,1,2,4,9,8,11,14,14,16,
  // 25
  8,7,5,4,3,2,1,1,0,0,0,0,0,0,0,0,0,0,
  1,1,1,1,2,2,2,2,3,3,7,5,8,11,10,11,14,17,
  14,16,16,18,17,13,12,13,10,7,5,4,2,2,1,0,0,0,
  0,0,0,0,0,0,0,0,1,1,3,4,4,6,7,8,9,10,
  // 26
  5,4,3,2,1,1,1,0,0,0,0,0,0,0,0,0,0,0,
  0,0,1,1,1,1,1,2,5,3,3,4,8,7,13,15,12,17,
  16,17,15,18,20,14,18,12,10,8,6,4,2,1,1,0,0,0,
  0,0,0,2,0,0,0,0,1,1,2,2,3,4,5,6,8,6,
  // 27
  3,3,2,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,1,1,1,1,2,2,3,4,5,6,9,11,13,14,
  20,17,17,18,20,16,18,14,12,9,6,4,2,1,1,0,0,0,
  0,0,0,0,0,0,0,0,1,1,2,7,3,3,4,4,5,4,
  // 28
  2,1,1,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,1,1,1,2,2,3,3,5,7,8,10,13,15,
  16,16,18,17,19,18,16,13,12,8,5,3,2,1,0,0,0,0,
  0,0,0,0,0,0,0,0,1,1,1,3,2,3,3,3,3,2,
  // 29
  1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,1,1,1,1,2,2,3,5,8,10,10,13,18,
  17,19,20,19,18,18,14,12,9,6,5,4,2,1,0,0,0,0,
  0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,1,1,
  // 30
  0,0,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,1,1,1,2,2,5,7,8,12,12,20,24,
  25,26,25,23,22,22,16,14,12,5,4,2,1,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,
  // 31
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,1,1,1,2,4,6,11,12,13,17,28,
  30,26,29,26,25,23,16,10,7,9,4,1,1,0,0,0,0,0,
  0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,0,0,0,
  // 32
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,1,1,2,2,5,8,10,15,16,19,25,
  33,31,35,32,30,18,21,12,6,4,2,1,0,0,0,0,0,0,
  0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,
  // 33
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,1,1,1,2,3,6,9,12,18,21,25,29,
  33,33,33,32,23,18,15,11,5,3,2,1,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 34
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,1,1,1,2,2,4,6,9,13,21,27,31,36,37,
  40,40,35,33,23,18,13,10,5,3,2,1,0,0,0,0,0,0,
  0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,
  // 35
  0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,1,1,
  1,1,1,1,1,2,2,4,6,9,14,21,26,40,49,51,64,61,
  60,44,36,34,26,20,12,7,4,3,2,1,0,3,0,0,0,0,
  0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,
  // 36
  0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,2,
  2,2,2,3,3,4,6,8,12,19,27,38,51,66,80,86,82,76,
  72,64,43,34,23,16,10,6,5,2,1,1,0,1,1,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 37
  0,0,0,0,0,0,0,0,0,0,1,1,1,2,2,3,3,3,
  4,4,5,6,7,9,12,17,26,38,53,72,93,121,131,137,124,109,
  92,80,50,38,26,18,10,6,6,2,1,1,0,1,1,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 38
  1,1,1,1,1,1,1,1,1,1,2,2,3,5,5,5,6,9,
  11,8,9,11,13,17,23,34,52,68,98,126,158,195,204,205,206,158,
  121,93,61,37,26,17,9,6,3,2,1,3,1,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 39
  2,2,3,3,3,2,2,2,2,3,4,11,7,9,9,12,14,12,
  13,13,19,21,23,31,43,57,79,112,153,206,272,305,338,340,260,223,
  151,107,71,49,30,16,9,6,3,2,1,1,0,0,0,0,1,1,
  1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,
  // 40
  4,5,6,6,6,7,7,5,5,5,7,8,11,18,27,16,17,24,
  21,20,24,31,47,67,72,94,128,187,243,293,341,386,416,407,324,259,
  181,120,90,57,34,19,15,6,3,2,1,1,0,0,1,3,1,1,
  1,1,1,1,1,1,1,1,1,0,1,1,1,1,2,2,2,3,
  // 41
  8,9,11,11,11,12,12,13,11,12,11,13,16,24,27,25,24,28,
  31,32,38,49,68,86,112,157,202,261,321,399,434,487,474,467,354,278,
  200,130,81,50,29,19,11,6,3,2,1,1,1,1,1,1,1,1,
  1,2,2,2,5,2,2,2,2,1,1,5,2,3,3,4,5,6,
  // 42
  14,16,18,19,20,18,17,22,23,19,17,22,26,35,37,45,37,37,
  38,49,56,74,101,135,167,230,286,352,430,503,532,592,549,535,397,291,
  207,130,81,51,30,21,12,6,4,2,2,1,1,1,1,1,1,1,
  2,2,3,3,8,4,4,3,3,3,3,7,5,6,7,8,10,12,
  // 43
  26,29,33,32,34,30,28,31,25,29,32,34,44,53,49,53,55,51,
  54,64,80,109,140,196,256,336,397,492,555,622,675,681,636,551,454,303,
  214,126,81,53,35,22,12,7,4,3,2,2,2,2,2,1,1,2,
  2,3,4,4,5,6,6,6,6,6,7,7,14,14,13,15,18,22,
  // 44
  44,48,50,52,63,47,44,47,41,39,35,46,53,64,66,67,77,63,
  67,88,111,149,201,281,390,470,561,623,717,780,788,754,717,598,444,303,
  206,133,76,49,32,17,11,7,5,3,3,3,3,3,2,2,2,2,
  3,4,5,6,7,8,8,9,10,11,12,13,16,21,23,27,38,40,
  // 45
  77,80,84,87,77,80,76,56,60,41,43,51,65,73,93,78,90,91,
  87,100,145,211,274,381,519,608,692,781,832,840,801,793,749,580,431,293,
  188,129,74,51,29,18,12,8,5,4,4,4,3,3,3,3,3,3,
  4,5,6,7,9,14,13,13,18,20,26,22,26,36,42,46,62,78,
  // 46
  112,120,132,125,108,105,89,65,57,51,47,54,58,74,77,75,89,101,
  100,118,162,236,331,459,618,712,815,900,888,846,808,764,666,533,399,272,
  175,114,69,46,28,20,13,10,7,5,6,4,4,4,3,3,3,5,
  7,6,9,9,11,14,16,20,26,29,32,36,43,54,66,90,98,108,
  // 47
  164,183,186,178,168,135,105,81,64,57,45,49,53,67,74,76,87,103,
  115,134,195,278,391,547,732,856,950,971,948,855,805,734,629,499,361,240,
  156,102,65,43,29,22,15,12,8,6,7,5,6,6,4,4,4,6,
  8,7,13,13,16,20,20,26,34,41,49,54,64,72,93,123,139,147,
  // 48
  243,253,253,236,225,192,153,101,76,60,41,37,46,48,62,79,80,96,
  137,161,220,335,447,616,822,997,1037,1000,957,822,756,683,564,445,314,219,
  161,98,61,43,33,25,17,18,12,9,6,6,11,7,4,5,6,7,
  7,8,10,17,18,25,27,38,45,52,61,74,103,114,148,166,188,233,
  // 49
  318,342,336,318,309,215,164,116,73,57,37,31,32,36,42,52,71,85,
  126,166,253,379,512,692,884,1044,1033,986,936,849,719,572,546,405,282,207,
  141,88,59,42,32,26,20,19,11,12,7,6,5,5,6,7,7,8,
  7,8,13,13,18,25,32,50,60,69,79,105,136,150,176,234,263,289,
  // 50
  433,451,448,386,314,239,188,116,70,44,37,35,30,31,37,49,66,81,
  116,178,263,391,528,698,917,951,974,965,879,768,648,550,447,327,243,180,
  130,94,62,45,34,28,20,15,12,11,9,7,6,7,7,8,6,6,
  10,9,11,19,19,31,42,59,73,87,100,126,161,197,249,300,364,379,
  // 51
  524,523,509,413,335,238,168,106,67,47,31,31,37,34,41,53,70,91,
  132,195,279,407,524,676,806,873,893,871,772,668,560,499,409,331,241,183,
  132,97,66,51,41,32,22,19,14,11,8,7,6,6,7,8,5,5,
  7,11,12,17,21,35,51,76,91,116,137,168,207,252,317,381,429,482,
  // 52
  633,617,561,447,339,242,152,98,67,46,33,36,46,45,51,65,82,107,
  147,213,297,403,499,638,742,837,865,817,734,625,531,471,407,353,263,199,
  151,104,73,56,47,37,23,22,16,10,7,7,6,5,6,5,5,5,
  7,10,12,15,27,42,60,83,118,155,194,231,284,332,423,494,571,597,
  // 53
  822,738,655,478,327,200,132,79,57,39,36,46,50,57,71,83,97,128,
  156,221,289,404,499,616,750,782,831,800,713,650,560,476,431,339,277,229,
  193,123,89,60,46,40,25,19,14,10,9,5,5,4,10,6,4,4,
  6,7,10,18,27,40,72,115,182,245,302,357,427,495,531,612,719,759,
  // 54
  890,745,551,381,249,161,101,61,39,34,40,52,70,81,95,114,118,140,
  198,220,272,334,468,544,652,713,758,768,710,640,600,548,501,454,331,258,
  209,146,110,64,47,34,21,16,11,8,10,4,4,3,3,3,3,3,
  5,6,9,15,29,55,109,181,292,440,534,604,654,690,740,814,876,893,
  // 55
  824,629,462,310,194,118,68,43,32,34,44,53,70,97,110,112,109,135,
  171,191,238,320,423,490,595,667,734,773,740,729,690,629,582,492,359,280,
  205,143,102,73,44,30,20,13,8,5,4,3,2,2,2,2,2,2,
  3,6,10,16,34,79,183,381,634,863,1007,1099,1058,1009,996,995,1002,904,
  // 56
  705,509,346,221,133,75,42,30,25,27,35,42,62,74,93,95,92,104,
  121,159,188,254,341,417,533,658,753,819,795,799,774,732,643,544,415,302,
  212,152,87,61,38,28,15,9,5,3,2,2,1,1,1,1,1,2,
  3,4,8,17,49,150,383,763,1195,1559,1804,1847,1758,1507,1313,1165,1087,868,
  // 57
  589,424,258,148,82,43,23,18,17,18,24,36,50,52,67,78,69,76,
  85,118,143,192,281,376,501,670,781,882,908,905,864,818,706,597,450,297,
  200,133,73,46,28,16,9,5,3,2,1,1,1,1,1,1,1,1,
  2,3,7,22,85,288,685,1266,1926,2462,2823,2832,2543,2059,1679,1401,1145,797,
  // 58
  459,297,172,89,44,21,11,8,9,12,22,24,27,33,38,40,42,45,
  53,72,102,135,212,327,493,624,791,963,1034,1043,944,884,781,578,372,247,
  168,87,50,30,16,9,5,3,1,1,0,0,0,0,0,0,0,0,
  1,2,7,31,139,444,994,1752,2774,3735,4334,4174,3385,2628,2069,1607,1153,756,
  // 59
  331,194,101,46,20,9,5,4,5,6,11,12,15,18,20,22,23,25,
  29,40,59,99,189,283,428,612,765,1003,1158,1087,943,805,629,450,289,179,
  108,59,34,16,8,4,2,1,0,0,0,0,0,0,0,0,0,0,
  0,2,7,41,184,553,1192,2171,3797,6007,7154,5665,3961,3008,2204,1534,885,552,
  // 60
  218,112,50,20,7,3,2,2,2,3,4,5,6,8,9,9,10,11,
  14,20,37,71,124,226,354,526,692,913,946,872,724,577,473,300,196,124,
  67,35,17,7,3,1,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,8,46,198,577,1224,2225,3944,5350,5434,4448,3531,2581,1697,1057,627,388,
  // 61
  123,55,21,7,2,1,0,0,0,1,1,1,2,2,3,3,3,4,
  5,10,20,45,92,171,283,416,561,711,688,628,521,399,297,193,120,70,
  35,16,7,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,3,9,42,172,495,1058,1870,2989,3761,3808,3338,2658,1888,1193,710,417,241,
  // 62
  55,20,6,2,0,0,0,0,0,0,0,0,0,0,0,0,1,1,
  2,4,11,29,64,130,225,310,415,495,468,410,328,249,171,106,60,31,
  14,5,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,3,8,31,121,351,773,1345,1975,2385,2478,2236,1740,1188,725,416,234,122,
  // 63
  17,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  1,2,6,17,40,77,139,202,253,295,279,235,182,128,82,46,23,10,
  4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,5,19,69,198,461,800,1138,1359,1407,1240,935,614,359,199,103,47,
  // 64
  3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,3,9,22,44,78,110,137,143,140,115,85,54,31,15,6,2,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,3,11,35,93,211,377,527,633,643,550,396,245,137,71,32,11,
  // 65
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,2,5,11,22,36,50,60,63,58,45,30,17,8,3,1,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,2,4,6,17,39,76,139,193,229,222,179,122,72,41,17,5,1,
  // 66
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,1,2,5,9,15,20,23,22,19,13,7,3,1,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,1,2,3,7,14,25,43,57,64,58,45,29,16,10,2,0,0,
  // 67
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,1,2,4,5,6,7,6,4,2,1,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,1,1,3,5,8,12,15,15,13,9,5,3,1,0,0,0,
  // 68
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,1,1,2,2,2,1,1,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,1,1,2,3,3,3,3,2,1,0,0,0,0,0,0,
  // 69
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,
  // 70
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  // 71
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
  };
  
  /***** Rama2 data set *****/
  
    // export : rjcmod.py (Version 0.5.0 for Python 2.7.8)
  int rama2_data_size = 180;
  
  // type   : gly
  // tiling : [180, 180]
  // range  : [[-180.0, 178.0], [-180.0, 178.0]]
  ftype32 rama2_gly_data[] = {
 0.0111508615425   , 0.0138022174606   , 0.0135024115292   , 0.0104467251891   ,
 0.00639356414861  , 0.00309442550871  , 0.00118352649237  , 0.000357327109971 ,
 8.50480297768e-05 , 1.59345783917e-05 , 2.34747784735e-06 , 2.74858607938e-07 ,
 3.59750160245e-08 , 2.97984553398e-08 , 5.42069008978e-08 , 8.19032769088e-08 ,
 9.74157471847e-08 , 9.11956814491e-08 , 6.72914294084e-08 , 3.91904339234e-08 ,
 1.80358521587e-08 , 6.57037683362e-09 , 2.02490478585e-09 , 2.70692452113e-09 ,
 3.09979728985e-08 , 3.35744369535e-07 , 2.89915740939e-06 , 1.98519350214e-05 ,
 0.00010764376181  , 0.000461994855352 , 0.0015694445937   , 0.0042203119478   ,
 0.00898224465421  , 0.0151245265302   , 0.0201323638494   , 0.0211613422423   ,
 0.0175405652224   , 0.0114487356494   , 0.00587551358032  , 0.00236780596886  ,
 0.000748825746501 , 0.000186200077759 , 3.68624963191e-05 , 6.13553326117e-06 ,
 1.02037337689e-06 , 2.15974432345e-07 , 5.47773953975e-08 , 1.29300998854e-08 ,
 2.49663295236e-09 , 3.80081036488e-10 , 4.52174208937e-11 , 4.19478198224e-12 ,
 3.03267946609e-13 , 1.70834264391e-14 , 7.49712709925e-16 , 2.56440116732e-17 ,
 7.99034139393e-19 , 7.8210625135e-19  , 3.95423376656e-18 , 1.98857034609e-17 ,
 2.75553969058e-16 , 8.94672859542e-15 , 2.71723505284e-13 , 6.5777543642e-12  ,
 1.25655707716e-10 , 1.89535593489e-09 , 2.25959116959e-08 , 2.13048878629e-07 ,
 1.58899393404e-06 , 9.37205024382e-06 , 4.3681682513e-05  , 0.000160709928919 ,
 0.000466104251842 , 0.00106410165     , 0.00190939947081  , 0.00268909712985  ,
 0.00296860938917  , 0.00256621927194  , 0.00173727060103  , 0.000928383153519 ,
 0.000419073369986 , 0.000232371176817 , 0.000267019186082 , 0.000406152709712 ,
 0.0005369683065   , 0.000568157427489 , 0.000475957572136 , 0.000315264051348 ,
 0.000165195310368 , 6.86071029778e-05 , 2.26746898657e-05 , 6.00682124975e-06 ,
 1.2902296792e-06  , 2.28348816287e-07 , 3.39268089737e-08 , 4.29797239872e-09 ,
 4.66759128677e-10 , 4.31216376991e-11 , 3.3443009833e-12  , 2.52435548022e-13 ,
 1.20046964176e-13 , 2.30469250803e-13 , 3.83285450068e-13 , 5.0499689953e-13  ,
 5.25764098798e-13 , 4.32045523129e-13 , 2.79844286572e-13 , 1.42663828945e-13 ,
 5.72176546067e-14 , 2.07224998904e-14 , 1.07164344055e-13 , 3.00228422057e-12 ,
 6.83188253829e-11 , 1.21117634672e-09 , 1.67233531538e-08 , 1.79842468399e-07 ,
 1.50633455859e-06 , 9.82698976457e-06 , 4.99346199374e-05 , 0.000197642773825 ,
 0.00060936607001  , 0.00146359046096  , 0.00273865846796  , 0.00399277980752  ,
 0.0045361331271   , 0.0040164057056   , 0.0027721550387   , 0.00149188517455  ,
 0.000626223682315 , 0.000205103452563 , 5.24422463219e-05 , 1.04741811241e-05 ,
 1.63535961254e-06 , 1.99779204265e-07 , 1.91160635445e-08 , 1.44419672157e-09 ,
 3.09370744936e-10 , 4.02478772129e-09 , 5.61329922001e-08 , 6.12132969648e-07 ,
 5.21830132908e-06 , 3.48060678342e-05 , 0.000181836052326 , 0.000744954888284 ,
 0.00239658190843  , 0.00606315791557  , 0.0120808533297   , 0.0189850427416   ,
 0.02356077931     , 0.0231128979747   , 0.0179331544759   , 0.0110064307486   ,
 0.00534154601655  , 0.00204820287995  , 0.000619826098811 , 0.000147830346312 ,
 2.7746773021e-05  , 4.09234840403e-06 , 4.73622552955e-07 , 4.29571114473e-08 ,
 3.04993404848e-09 , 1.69347222653e-10 , 7.34853852839e-12 , 2.68282816504e-13 ,
 3.15329334689e-13 , 3.89591114444e-12 , 3.88194621785e-11 , 3.05178781269e-10 ,
 1.89295645663e-09 , 9.31557307351e-09 , 3.74697015656e-08 , 1.38467960335e-07 ,
 6.10458680658e-07 , 3.55273072081e-06 , 2.13089014412e-05 , 0.000108538067474 ,
 0.000441721456181 , 0.0014171564859   , 0.00357768430319  , 0.007112849528    ,
 0.0197476213167   , 0.0244430922774   , 0.0239121600584   , 0.0185006793753   ,
 0.0113227140829   , 0.00548008819327  , 0.00209597210912  , 0.000632810211755 ,
 0.000150616184774 , 2.82191225584e-05 , 4.15574450727e-06 , 4.80600544141e-07 ,
 4.43417201153e-08 , 5.11146347679e-09 , 4.08581944951e-09 , 5.95780558261e-09 ,
 7.12658111615e-09 , 6.74383091759e-09 , 5.06099053375e-09 , 3.02557665371e-09 ,
 1.44905391766e-09 , 5.62475214172e-10 , 2.36629724096e-10 , 1.12539521967e-09 ,
 1.52205527732e-08 , 1.69016978507e-07 , 1.48043310624e-06 , 1.02251464197e-05 ,
 5.57314520075e-05 , 0.000239927133101 , 0.000816526799334 , 0.00219798838875  ,
 0.00468091009567  , 0.00788460532247  , 0.0104973964154   , 0.0110353184424   ,
 0.0091481688245   , 0.00597245688492  , 0.00306789589009  , 0.0012412775362   ,
 0.000399457166411 , 0.000106917368735 , 2.76842698051e-05 , 8.91120130094e-06 ,
 3.54692570889e-06 , 1.35575076496e-06 , 4.28718191367e-07 , 1.07244111486e-07 ,
 2.09888464358e-08 , 3.20501142282e-09 , 3.81551367226e-10 , 3.54014876072e-11 ,
 2.5595090615e-12  , 1.44179874752e-13 , 6.32743518764e-15 , 2.16978907838e-16 ,
 1.13888777711e-17 , 3.72225243478e-17 , 1.91041058181e-16 , 7.79419671948e-16 ,
 3.02007250865e-15 , 2.94226785317e-14 , 7.33198176913e-13 , 1.75014911864e-11 ,
 3.34036858544e-10 , 5.03824019358e-09 , 6.00643051184e-08 , 5.66325018183e-07 ,
 4.22385234893e-06 , 2.49127171187e-05 , 0.000116114336719 , 0.000427197983672 ,
 0.00123899496299  , 0.00282858708711  , 0.0050755490966   , 0.00714811332528  ,
 0.00789093824834  , 0.00682020437152  , 0.00461104001035  , 0.00243803593753  ,
 0.00101267057276  , 0.000344466904219 , 0.000125990257224 , 9.17827566964e-05 ,
 0.000104272412571 , 0.000108335066916 , 9.05322395004e-05 , 5.98196517389e-05 ,
 3.11877467408e-05 , 1.28352192718e-05 , 4.17787956969e-06 , 1.08004146429e-06 ,
 2.23389926139e-07 , 3.740730328e-08   , 5.1567197346e-09  , 5.96792303956e-10 ,
 5.89529336783e-11 , 5.00023235442e-12 , 3.61556351713e-13 , 2.29324423959e-14 ,
 3.98296809316e-15 , 6.14880137551e-15 , 1.01741408727e-14 , 1.34036371971e-14 ,
 1.39549019864e-14 , 1.14682506615e-14 , 7.43469956981e-15 , 3.83013279502e-15 ,
 1.86933688931e-15 , 8.02921131377e-15 , 2.55207058499e-13 , 7.38809920919e-12 ,
 1.68045718334e-10 , 2.97898419603e-09 , 4.11321982532e-08 , 4.42334560745e-07 ,
 3.70493378351e-06 , 2.41701905024e-05 , 0.00012281801188  , 0.000486118597113 ,
 0.00149879023695  , 0.00359984547519  , 0.00673603625413  , 0.0098207554403   ,
 0.0111573059311   , 0.00987908110108  , 0.00681873635339  , 0.00366971223512  ,
 0.00154042441404  , 0.000504549874084 , 0.000129015351611 , 2.57704598817e-05 ,
 4.02417458258e-06 , 4.91704859127e-07 , 4.70634810117e-08 , 3.54709667994e-09 ,
 5.2932050096e-10  , 5.74976553038e-09 , 8.01343238187e-08 , 8.73867083529e-07 ,
 7.44952821148e-06 , 4.96883505469e-05 , 0.000259585011736 , 0.00106348065241  ,
 0.00342130581644  , 0.0086556263202   , 0.0172463514084   , 0.0271026151628   ,
 0.0336348326032   , 0.0329954473971   , 0.0256009634024   , 0.0157125301723   ,
 0.00762546958854  , 0.00292396784073  , 0.000884849639416 , 0.000211039239684 ,
 3.96106620061e-05 , 5.84214349252e-06 , 6.76132783059e-07 , 6.13245951523e-08 ,
 4.35401646889e-09 , 2.41756192685e-10 , 1.04893251762e-11 , 3.57134211892e-13 ,
 3.73465731162e-14 , 3.53037418053e-13 , 3.52301279043e-12 , 2.79606438598e-11 ,
 1.81179751678e-10 , 1.06826986066e-09 , 7.41357143983e-09 , 6.86512853668e-08 ,
 6.66849386599e-07 , 5.53137734342e-06 , 3.66461733752e-05 , 0.000190993405283 ,
 0.000781199163716 , 0.00250899014354  , 0.00633552900851  , 0.0125963747604   ,
 0.0275032906576   , 0.0340428618246   , 0.0333034122475   , 0.025766628917    ,
 0.0157695923726   , 0.00763233588309  , 0.00291914337407  , 0.000881339846104 ,
 0.00020976912363  , 3.93018729801e-05 , 5.78778441536e-06 , 6.69010270076e-07 ,
 6.0698207634e-08  , 4.57102764597e-09 , 9.51927426583e-10 , 1.55319005737e-09 ,
 2.71769482194e-09 , 3.86002406557e-09 , 4.38867479299e-09 , 3.97311690571e-09 ,
 2.85608197708e-09 , 1.63126763608e-09 , 7.68612901276e-10 , 7.1634730374e-10  ,
 6.24106509912e-09 , 6.85292665379e-08 , 6.01664174533e-07 , 4.16342921612e-06 ,
 2.27190016569e-05 , 9.78747930067e-05 , 0.0003332268089   , 0.000897220000549 ,
 0.00191101978043  , 0.00321924624716  , 0.0042864181651   , 0.00450699607204  ,
 0.00373917074595  , 0.00244927154904  , 0.00127637708893  , 0.000548871789088 ,
 0.000221919032567 , 0.000108327014206 , 6.70616273994e-05 , 4.12718012236e-05 ,
 2.13091348965e-05 , 8.74198648552e-06 , 2.81064821054e-06 , 7.0570897529e-07  ,
 1.38228026226e-07 , 2.11111704476e-08 , 2.51333281149e-09 , 2.33195499565e-10 ,
 1.68599014027e-11 , 9.49734437476e-13 , 4.16816135785e-14 , 1.44990874931e-15 ,
 2.49313157838e-16 , 1.3941423885e-15  , 7.17425600079e-15 , 2.88956580258e-14 ,
 9.21689048207e-14 , 2.73461222529e-13 , 1.95047055816e-12 , 3.74137228143e-11 ,
 7.02975354893e-10 , 1.05924176029e-08 , 1.26271665112e-07 , 1.19056615777e-06 ,
 8.87966150976e-06 , 5.23731593252e-05 , 0.000244103227362 , 0.000898083815135 ,
 0.00260469703735  , 0.00594644255694  , 0.0106701541917   , 0.0150272326444   ,
 0.0165888240692   , 0.0143376971185   , 0.00969261606854  , 0.00512100942308  ,
 0.00211388029217  , 0.000683460446039 , 0.000177569272461 , 4.47812819469e-05 ,
 2.03054691849e-05 , 1.67474238076e-05 , 1.35817098504e-05 , 8.93652743474e-06 ,
 4.6457863794e-06  , 1.90231518204e-06 , 6.13779771458e-07 , 1.56368742372e-07 ,
 3.1589749826e-08  , 5.09883587414e-09 , 6.65510657015e-10 , 7.14551737123e-11 ,
 6.4402779003e-12  , 4.95796089772e-13 , 3.28274965579e-14 , 1.91297960816e-15 ,
 2.42660662278e-16 , 3.09615051205e-16 , 4.76158324608e-16 , 5.8449497798e-16  ,
 5.7221799153e-16  , 4.83084475986e-16 , 5.89567737767e-16 , 1.96975858686e-15 ,
 8.93119421959e-15 , 4.55439593435e-14 , 5.85355440953e-13 , 1.44672173306e-11 ,
 3.24346643306e-10 , 5.74259965612e-09 , 7.92818567691e-08 , 8.52587792583e-07 ,
 7.14117908262e-06 , 4.65877715519e-05 , 0.000236732139329 , 0.000937004733305 ,
 0.00288899112725  , 0.00693899991059  , 0.012984570932    , 0.0189313514779   ,
 0.0215087023967   , 0.0190456568419   , 0.0131467016174   , 0.00707605461169  ,
 0.00297073695691  , 0.000973238668438 , 0.000248935941658 , 4.97459896964e-05 ,
 7.77302756524e-06 , 9.50663784262e-07 , 9.11193599106e-08 , 6.87024189525e-09 ,
 7.63718514413e-10 , 6.4260030016e-09  , 8.9446362826e-08  , 9.75411863089e-07 ,
 8.31517545992e-06 , 5.5462217393e-05  , 0.000289749210728 , 0.00118705882748  ,
 0.00381886709623  , 0.00966142412428  , 0.0192504053882   , 0.0302519829621   ,
 0.037543254654    , 0.0368295718509   , 0.0285758368339   , 0.0175383516391   ,
 0.00851156151114  , 0.00326373764186  , 0.000987670601338 , 0.000235562341306 ,
 4.42134851168e-05 , 6.52101003304e-06 , 7.54700508065e-07 , 6.84506124801e-08 ,
 4.85996023777e-09 , 2.69848650466e-10 , 1.17081110795e-11 , 3.96803578776e-13 ,
 1.24704600562e-14 , 2.54773503369e-14 , 2.62099581966e-13 , 2.44773216324e-12 ,
 2.65225773686e-11 , 3.89132091585e-10 , 6.12788994031e-09 , 8.30401321997e-08 ,
 8.99249753043e-07 , 7.64962501367e-06 , 5.0960893559e-05  , 0.000265917019254 ,
 0.00108793084981  , 0.00349431795584  , 0.00882371450715  , 0.0175434585575   ,
 0.0300804356107   , 0.0372327853957   , 0.0364240471008   , 0.0281810433879   ,
 0.0172472529609   , 0.00834750984993  , 0.0031926763237   , 0.000963924171996 ,
 0.000229425152793 , 4.29845836277e-05 , 6.33012959245e-06 , 7.31784007955e-07 ,
 6.6854177759e-08  , 6.9500420237e-09  , 7.29025741763e-09 , 1.72124525221e-08 ,
 3.29592503809e-08 , 4.95019504096e-08 , 5.83521992133e-08 , 5.40661663698e-08 ,
 3.94537621394e-08 , 2.27671674157e-08 , 1.0552065412e-08  , 4.35063908995e-09 ,
 3.89886028188e-09 , 2.34098931501e-08 , 1.93747701602e-07 , 1.33089097856e-06 ,
 7.25532872412e-06 , 3.12543769685e-05 , 0.000106414739832 , 0.000286540514009 ,
 0.000610364405383 , 0.00102843026281  , 0.00137042522232  , 0.0014453845613   ,
 0.00121439623293  , 0.000837968824402 , 0.000531218343671 , 0.000393299462318 ,
 0.000374850865143 , 0.000368168285578 , 0.000308677178157 , 0.000206932947234 ,
 0.000109017539268 , 4.49231338375e-05 , 1.4456541582e-05  , 3.63037788839e-06 ,
 7.11091022215e-07 , 1.08601210043e-07 , 1.29290443443e-08 , 1.19958937052e-09 ,
 8.67291328021e-11 , 4.8855221139e-12  , 2.14469210419e-13 , 8.06186962041e-15 ,
 6.37835832752e-15 , 4.07639307592e-14 , 2.09868623361e-13 , 8.44672810549e-13 ,
 2.66145900712e-12 , 6.63921150554e-12 , 1.51997683543e-11 , 8.03650142799e-11 ,
 1.19067735165e-09 , 1.76351265255e-08 , 2.09999915453e-07 , 1.97987373233e-06 ,
 1.47665335294e-05 , 8.70945150248e-05 , 0.000405934110818 , 0.0014934782244   ,
 0.00433150919826  , 0.0098887011645   , 0.0177440486474   , 0.0249896992092   ,
 0.0275865618702   , 0.0238430075503   , 0.016118323514    , 0.00851552791508  ,
 0.00351354711967  , 0.00113180147173  , 0.000285034866202 , 5.70138880209e-05 ,
 1.0283577353e-05  , 2.90208319142e-06 , 1.67844385175e-06 , 1.05320201498e-06 ,
 5.43994777619e-07 , 2.22032624638e-07 , 7.12823371247e-08 , 1.80074634904e-08 ,
 3.58741211478e-09 , 5.66069374128e-10 , 7.12905112995e-11 , 7.25358734961e-12 ,
 6.06719137151e-13 , 4.274015615e-14   , 3.17621488223e-15 , 2.06387820583e-15 ,
 4.68467167297e-15 , 8.84708736375e-15 , 1.30732073034e-14 , 1.51365791039e-14 ,
 1.39395039977e-14 , 1.15472773672e-14 , 1.65938145857e-14 , 6.21816193517e-14 ,
 2.7211211955e-13  , 1.02540437352e-12 , 3.74595190539e-12 , 2.87609998214e-11 ,
 5.03992665685e-10 , 8.70738119193e-09 , 1.19944384609e-07 , 1.28959383439e-06 ,
 1.08014008078e-05 , 7.04678737666e-05 , 0.000358088791926 , 0.00141740764504  ,
 0.00437044032292  , 0.010498092499    , 0.0196465813086   , 0.0286485194199   ,
 0.0325549367266   , 0.0288343131988   , 0.0199104943086   , 0.0107217490432   ,
 0.00450433672203  , 0.0014770629017   , 0.000378318742599 , 7.57499061814e-05 ,
 1.18702396707e-05 , 1.4578875249e-06  , 1.40603886187e-07 , 1.06876113069e-08 ,
 9.52243129912e-10 , 5.6177900816e-09  , 7.80033233403e-08 , 8.5061970609e-07  ,
 7.25134912923e-06 , 4.83664961386e-05 , 0.000252679296657 , 0.00103518897899  ,
 0.0033302891472   , 0.00842536152657  , 0.0167875483824   , 0.0263816069011   ,
 0.0327400483899   , 0.0321176726869   , 0.0249199034379   , 0.015294531245    ,
 0.00742260995527  , 0.00284618180579  , 0.000861310069654 , 0.00020542498311  ,
 3.85569033785e-05 , 5.68672551168e-06 , 6.5814568773e-07  , 5.96931828519e-08 ,
 4.23818698788e-09 , 2.35324772671e-10 , 1.02101945689e-11 , 3.45935996131e-13 ,
 9.25708139651e-15 , 1.86228386333e-15 , 2.8054180625e-14  , 6.45121075027e-13 ,
 1.64346700297e-11 , 3.64420671499e-10 , 6.46839049363e-09 , 9.01211853514e-08 ,
 9.81869875413e-07 , 8.36340436288e-06 , 5.57317647928e-05 , 0.000290829435924 ,
 0.00118986916399  , 0.00382174368458  , 0.00965052287085  , 0.0191873353677   ,
 0.0258002679886   , 0.0319349045962   , 0.0312412422782   , 0.0241711417105   ,
 0.0147931284764   , 0.00715973644892  , 0.00273838802894  , 0.00082676668293  ,
 0.000196780078592 , 3.68682953384e-05 , 5.42958072605e-06 , 6.28775555868e-07 ,
 6.30757980015e-08 , 2.8935338376e-08  , 7.81779067928e-08 , 1.90866142875e-07 ,
 3.65814104881e-07 , 5.49536997076e-07 , 6.47879050197e-07 , 6.00398185342e-07 ,
 4.38363404995e-07 , 2.53567058014e-07 , 1.18829853598e-07 , 5.0150854801e-08  ,
 2.75604841538e-08 , 3.08277771462e-08 , 7.78824056912e-08 , 3.65551325552e-07 ,
 1.84639590761e-06 , 7.84256234207e-06 , 2.66265522621e-05 , 7.16665943065e-05 ,
 0.000152807175979 , 0.00025852193878  , 0.000349497670218 , 0.00038835299825  ,
 0.000391241360843 , 0.000444019990838 , 0.000642899787382 , 0.000988033020178 ,
 0.00132622200806  , 0.00143954244845  , 0.00123513755971  , 0.000831819563216 ,
 0.000438494583531 , 0.000180672870118 , 5.813201457e-05   , 1.45965460664e-05 ,
 2.8588404812e-06  , 4.36595150865e-07 , 5.19754567423e-08 , 4.82233158029e-09 ,
 3.48646253029e-10 , 1.96394945311e-11 , 8.63415309519e-13 , 4.61501240844e-14 ,
 1.41690400301e-13 , 9.28877021591e-13 , 4.78261185494e-12 , 1.92481172529e-11 ,
 6.0605932681e-11  , 1.49537632765e-10 , 2.92205776437e-10 , 5.18866125215e-10 ,
 2.05894944551e-09 , 2.36554600447e-08 , 2.76516175913e-07 , 2.60395121171e-06 ,
 1.94196982718e-05 , 0.000114538839506 , 0.000533847728762 , 0.00196408708467  ,
 0.00569640797253  , 0.0130047227349   , 0.0233353631573   , 0.0328641854706   ,
 0.0362793434255   , 0.0313561587116   , 0.0211973462452   , 0.0111988032512   ,
 0.00462053788123  , 0.00148800478984  , 0.000373907403638 , 7.3367952166e-05  ,
 1.13516680028e-05 , 1.50532372863e-06 , 2.68876499732e-07 , 1.04896850259e-07 ,
 5.03363175699e-08 , 2.03476556997e-08 , 6.50915573795e-09 , 1.6363841266e-09  ,
 3.23378997159e-10 , 5.0350634127e-11  , 6.20454606103e-12 , 6.09938757733e-13 ,
 4.95343276545e-14 , 9.04761971841e-15 , 2.36208293153e-14 , 7.27699316129e-14 ,
 1.76198048817e-13 , 3.33157260677e-13 , 4.9231133994e-13  , 5.69930559166e-13 ,
 5.23596776514e-13 , 4.20761616273e-13 , 5.12644153478e-13 , 1.64256107967e-12 ,
 6.80101022964e-12 , 2.45937930704e-11 , 7.3351535414e-11  , 1.98264107813e-10 ,
 9.16920158419e-10 , 1.08640146668e-08 , 1.43322019678e-07 , 1.53425316021e-06 ,
 1.28450392885e-05 , 8.38032286748e-05 , 0.000425910019598 , 0.00168619084428  ,
 0.00520059052998  , 0.0124966203649   , 0.0233978323961   , 0.0341402520443   ,
 0.0388286101197   , 0.034430670251    , 0.023812284767    , 0.0128506703275   ,
 0.00541503633481  , 0.00178325573857  , 0.000459508362423 , 9.28052481085e-05 ,
 1.47250278611e-05 , 1.84123298377e-06 , 1.82196745008e-07 , 1.4352747098e-08  ,
 1.11681534401e-09 , 3.85030995655e-09 , 5.31123651015e-08 , 5.79173814746e-07 ,
 4.9373312404e-06  , 3.29319976271e-05 , 0.000172045417019 , 0.000704844132231 ,
 0.00226754226684  , 0.00573669808549  , 0.0114303815168   , 0.0179628272715   ,
 0.0222921915368   , 0.0218684255663   , 0.0169675760372   , 0.010413809287    ,
 0.00505394008144  , 0.00193792108087  , 0.000586452677671 , 0.000139870687282 ,
 2.62527979478e-05 , 3.87200326689e-06 , 4.48121198702e-07 , 4.06441630669e-08 ,
 2.88571583578e-09 , 1.60228990593e-10 , 6.95196302487e-12 , 2.35538070295e-13 ,
 6.23295566246e-15 , 4.35677272485e-16 , 1.28138793726e-14 , 4.64942358707e-13 ,
 1.35492783101e-11 , 3.09906103821e-10 , 5.53783312807e-09 , 7.726732401e-08   ,
 8.42087438987e-07 , 7.17323819197e-06 , 4.78014622838e-05 , 0.000249446887774 ,
 0.00102056160893  , 0.00327794480003  , 0.00827734270843  , 0.016457155083    ,
 0.0173331442086   , 0.0214545177168   , 0.0209885012788   , 0.0162386640769   ,
 0.00993832425674  , 0.004810056408    , 0.00183970471268  , 0.000555438655869 ,
 0.000132200870996 , 2.47690458647e-05 , 3.64918559728e-06 , 4.32171127964e-07 ,
 9.23757698513e-08 , 2.19738849561e-07 , 6.79553093603e-07 , 1.66340377534e-06 ,
 3.18823535994e-06 , 4.78950566753e-06 , 5.64680449321e-06 , 5.23381134267e-06 ,
 3.82423885449e-06 , 2.22029533198e-06 , 1.0592792975e-06  , 4.81826897237e-07 ,
 3.09116108769e-07 , 3.25123455603e-07 , 3.97384317717e-07 , 4.97388454064e-07 ,
 8.02679934697e-07 , 2.02628521128e-06 , 5.91861440192e-06 , 1.53462892545e-05 ,
 3.30429387704e-05 , 6.01895420278e-05 , 0.000101237428549 , 0.000184132977528 ,
 0.000394427946243 , 0.000888353948529 , 0.00180831261991  , 0.00306818332135  ,
 0.00419545451764  , 0.00455619628154  , 0.00390104616896  , 0.00262261629007  ,
 0.00138094897138  , 0.000568601951631 , 0.000182874773139 , 4.59075140295e-05 ,
 8.99003683521e-06 , 1.37281964778e-06 , 1.63422111055e-07 , 1.51619949409e-08 ,
 1.09616612205e-09 , 6.17487655717e-11 , 2.73710816054e-12 , 3.88873763557e-13 ,
 2.50412071947e-12 , 1.64911304573e-11 , 8.49109292319e-11 , 3.41732026639e-10 ,
 1.07595723e-09    , 2.65310246526e-09 , 5.1323900647e-09  , 7.86838682443e-09 ,
 1.08862936026e-08 , 3.28036503275e-08 , 2.93468370267e-07 , 2.7098011428e-06  ,
 2.01841773734e-05 , 0.000119038678441 , 0.000554818144073 , 0.0020412390486   ,
 0.00592017037736  , 0.01351556535     , 0.024252006915    , 0.0341551338998   ,
 0.0377044437336   , 0.0325878697303   , 0.0220300051231   , 0.0116387036383   ,
 0.00480202716728  , 0.00154642408965  , 0.000388526899947 , 7.61335623274e-05 ,
 1.16404266902e-05 , 1.39703273267e-06 , 1.38893024798e-07 , 1.61684918591e-08 ,
 4.09540888267e-09 , 1.47907905613e-09 , 4.66387368791e-10 , 1.16775372916e-10 ,
 2.29683076891e-11 , 3.54885259934e-12 , 4.32382981458e-13 , 4.67366637281e-14 ,
 3.71083206105e-14 , 1.73242483857e-13 , 6.88391375689e-13 , 2.13608711181e-12 ,
 5.17268156514e-12 , 9.78061460129e-12 , 1.44530377496e-11 , 1.67306495283e-11 ,
 1.53484103096e-11 , 1.20941223656e-11 , 1.29665007718e-11 , 3.5266171338e-11  ,
 1.36366503269e-10 , 4.7722265031e-10  , 1.38218558498e-09 , 3.27387212439e-09 ,
 6.78180426081e-09 , 1.96428567442e-08 , 1.47486666506e-07 , 1.45573707334e-06 ,
 1.20732486854e-05 , 7.86952885365e-05 , 0.00040010117143  , 0.00158528485888  ,
 0.00489502312927  , 0.0117808858643   , 0.022104411775    , 0.0323444067227   ,
 0.0369260298658   , 0.0329114047874   , 0.0229197979783   , 0.0124865133347   ,
 0.00533036322813  , 0.00178713628034  , 0.000472082962172 , 9.86697420242e-05 ,
 1.64071317413e-05 , 2.18491768876e-06 , 2.34705657767e-07 , 2.04793595173e-08 ,
 1.57032685334e-09 , 2.10616353952e-09 , 2.8223745414e-08  , 3.07738447281e-07 ,
 2.62340253963e-06 , 1.74980939858e-05 , 9.14146451393e-05 , 0.000374512017482 ,
 0.00120483634643  , 0.00304813826979  , 0.00607342112488  , 0.00954437211507  ,
 0.0118447373608   , 0.0116195734681   , 0.00901555513184  , 0.00553327543978  ,
 0.00268536149992  , 0.00102969536175  , 0.000311605879129 , 7.43189180206e-05 ,
 1.39491667369e-05 , 2.05735096438e-06 , 2.3810480435e-07  , 2.15958774615e-08 ,
 1.53329681006e-09 , 8.51361028374e-11 , 3.69385737026e-12 , 1.25150695392e-13 ,
 3.30945071914e-15 , 2.36703371564e-16 , 8.22668303963e-15 , 3.09356642962e-13 ,
 9.08411077038e-12 , 2.08110866585e-10 , 3.72008364382e-09 , 5.19087241269e-08 ,
 5.65729024141e-07 , 4.81912270084e-06 , 3.21139871379e-05 , 0.000167583479963 ,
 0.000685634016972 , 0.00220218990913  , 0.00556088699684  , 0.0110562511375   ,
 0.00911139249308  , 0.0112778460339   , 0.0110328784375   , 0.00853606478938  ,
 0.00522420929158  , 0.00252846865636  , 0.000967064689175 , 0.0002919735553   ,
 6.9493217405e-05  , 1.3021376995e-05  , 1.92840378592e-06 , 2.93967093643e-07 ,
 3.91183427209e-07 , 1.48805501917e-06 , 4.65393043245e-06 , 1.13941399419e-05 ,
 2.18392071111e-05 , 3.28081856068e-05 , 3.86827589294e-05 , 3.58625540181e-05 ,
 2.62351237289e-05 , 1.53187866903e-05 , 7.50665166228e-06 , 3.77602133312e-06 ,
 2.88359219423e-06 , 3.290104788e-06   , 3.96384438079e-06 , 4.36567327591e-06 ,
 4.46509388985e-06 , 4.95993226935e-06 , 7.2488722953e-06  , 1.31284171337e-05 ,
 2.60374896133e-05 , 5.81823928318e-05 , 0.000149457646305 , 0.00040412882642  ,
 0.00104217827279  , 0.00240873231042  , 0.00478349936242  , 0.00790271289136  ,
 0.0106085421433   , 0.0113915632543   , 0.00968947486707  , 0.00648936596882  ,
 0.00340951031688  , 0.00140207099519  , 0.000450601754187 , 0.000113066348817 ,
 2.21359979229e-05 , 3.37975044914e-06 , 4.02292851033e-07 , 3.73219321571e-08 ,
 2.69817497711e-09 , 1.52011809914e-10 , 7.04832948513e-12 , 4.32592188721e-12 ,
 3.46119383035e-11 , 2.28124449753e-10 , 1.17458947838e-09 , 4.72724525347e-09 ,
 1.4883889377e-08  , 3.66994266054e-08 , 7.09524837393e-08 , 1.07757819515e-07 ,
 1.29823887864e-07 , 1.40514412929e-07 , 3.24946750452e-07 , 2.27243044666e-06 ,
 1.65823075225e-05 , 9.76702129289e-05 , 0.000455187105826 , 0.00167467681328  ,
 0.00485703475435  , 0.0110884594838   , 0.0198968662273   , 0.0280216038412   ,
 0.030933533694    , 0.0267357867202   , 0.0180738882925   , 0.009548641711    ,
 0.00393968535559  , 0.0012687176953   , 0.000318751961767 , 6.24550417456e-05 ,
 9.54117857374e-06 , 1.13668720767e-06 , 1.05995573054e-07 , 8.00696701199e-09 ,
 6.2935264142e-10  , 1.00345204432e-10 , 2.66864565578e-11 , 6.538125044e-12   ,
 1.27996428436e-12 , 1.98150186616e-13 , 3.79072920127e-14 , 1.2092433719e-13  ,
 7.76697374226e-13 , 3.96143563913e-12 , 1.5758676072e-11  , 4.88999901713e-11 ,
 1.18414718007e-10 , 2.23901888639e-10 , 3.30869321589e-10 , 3.83010094964e-10 ,
 3.51103995662e-10 , 2.73308060994e-10 , 2.66864386254e-10 , 6.19483660001e-10 ,
 2.20631305237e-09 , 7.40956015999e-09 , 2.09307879281e-08 , 4.84642550914e-08 ,
 9.22349680474e-08 , 1.52385516487e-07 , 2.98755850522e-07 , 1.3266261728e-06  ,
 9.35059237013e-06 , 5.9563968734e-05  , 0.000302298533392 , 0.00120088599341  ,
 0.00372533313672  , 0.00902506903111  , 0.0170856874892   , 0.0253006333      ,
 0.0293445392484   , 0.0267056627606   , 0.0191163192473   , 0.0107969323013   ,
 0.00483104897556  , 0.00172095146155  , 0.000490836221023 , 0.000112744453838 ,
 2.09659991311e-05 , 3.16761640315e-06 , 3.89197296946e-07 , 3.88194297734e-08 ,
 3.17643385251e-09 , 1.04064304097e-09 , 1.17066271822e-08 , 1.2754752823e-07  ,
 1.08731147954e-06 , 7.25236709293e-06 , 3.78882731302e-05 , 0.000155222542157 ,
 0.000499363843739 , 0.00126335003684  , 0.00251722727866  , 0.00395581886251  ,
 0.00490924231666  , 0.00481591951207  , 0.00373664214016  , 0.00229335519322  ,
 0.00111299135721  , 0.000426773839657 , 0.000129150079174 , 3.08026734711e-05 ,
 5.78145699149e-06 , 8.52702268266e-07 , 9.86863740169e-08 , 8.95075950356e-09 ,
 6.35499577125e-10 , 3.52860300734e-11 , 1.53097872575e-12 , 5.18707190074e-14 ,
 1.37159263448e-15 , 1.15983571402e-16 , 4.31434454884e-15 , 1.62537835556e-13 ,
 4.77468892917e-12 , 1.09393787835e-10 , 1.95550116499e-09 , 2.72864679869e-08 ,
 2.97382748784e-07 , 2.53323435303e-06 , 1.6881134483e-05  , 8.80924337583e-05 ,
 0.000360412430497 , 0.00115760974253  , 0.00292315251215  , 0.00581186208361  ,
 0.00374418070918  , 0.00463445006824  , 0.00453378456078  , 0.0035077590106   ,
 0.00214680507564  , 0.00103903366857  , 0.000397399736515 , 0.00011998189633  ,
 2.85577262599e-05 , 5.35743348767e-06 , 8.47269099741e-07 , 4.81124400124e-07 ,
 2.00913843585e-06 , 8.01607199302e-06 , 2.50922535966e-05 , 6.14339251777e-05 ,
 0.000117751198637 , 0.000176896150538 , 0.000208587973192 , 0.000193454907597 ,
 0.000141778708846 , 8.350436697e-05   , 4.25440694052e-05 , 2.42740494591e-05 ,
 2.18269602275e-05 , 2.64403904428e-05 , 3.18789338142e-05 , 3.45836954401e-05 ,
 3.42158979029e-05 , 3.51108206466e-05 , 4.51963739966e-05 , 7.1726679214e-05  ,
 0.000123315251139 , 0.000234729223055 , 0.000519489971541 , 0.00123192224687  ,
 0.00280978388342  , 0.00582681139314  , 0.0106420547086   , 0.0166070948636   ,
 0.0215143651458   , 0.0226202950369   , 0.019006972096    , 0.0126406193858   ,
 0.00661463139303  , 0.00271375351952  , 0.000870970676348 , 0.000218372758107 ,
 4.27327117365e-05 , 6.52266698997e-06 , 7.76266719671e-07 , 7.20094986887e-08 ,
 5.20560408226e-09 , 2.9350747703e-10  , 1.69484764129e-11 , 4.4613598259e-11  ,
 3.7304825379e-10  , 2.45908355174e-09 , 1.26615756276e-08 , 5.09576953451e-08 ,
 1.60441981211e-07 , 3.95603297778e-07 , 7.64808969427e-07 , 1.16088902295e-06 ,
 1.3861786009e-06  , 1.3145577651e-06  , 1.11691749883e-06 , 2.0003040797e-06  ,
 1.09706009379e-05 , 6.3261829121e-05  , 0.000294436355539 , 0.00108316989145  ,
 0.00314148181788  , 0.0071719031172   , 0.0128690909922   , 0.0181240887388   ,
 0.0200074953885   , 0.0172924352837   , 0.0116900073617   , 0.00617596446095  ,
 0.00254814844264  , 0.00082059364076  , 0.000206165362701 , 4.03949977442e-05 ,
 6.17074627999e-06 , 7.34780157759e-07 , 6.8205742241e-08  , 4.94663747767e-09 ,
 2.86455834436e-10 , 1.57488779229e-11 , 1.55402832046e-12 , 2.95761526631e-13 ,
 5.76813869838e-14 , 3.19837037446e-14 , 2.53425405972e-13 , 2.1191646552e-12  ,
 1.38667989429e-11 , 7.07402719138e-11 , 2.81405499511e-10 , 8.73213498902e-10 ,
 2.11454751862e-09 , 3.9982717336e-09  , 5.90856280771e-09 , 6.84012573408e-09 ,
 6.26898421634e-09 , 4.84627711948e-09 , 4.43674110829e-09 , 8.94046564099e-09 ,
 2.90161261454e-08 , 9.2577366946e-08  , 2.53458503771e-07 , 5.74610004521e-07 ,
 1.07263867074e-06 , 1.67735787871e-06 , 2.32300469252e-06 , 3.46755605698e-06 ,
 9.10609729879e-06 , 4.23584921196e-05 , 0.000203034203952 , 0.000804969632443 ,
 0.00253080604665  , 0.00626884840462  , 0.0122361873254   , 0.0188553553325   ,
 0.0229969404417   , 0.0222679886775   , 0.0171766337993   , 0.0105914656846   ,
 0.00523790198261  , 0.00208308177651  , 0.000667337690573 , 0.000172297041096 ,
 3.58202428598e-05 , 5.98417943123e-06 , 8.00988387243e-07 , 8.56043224935e-08 ,
 7.29357848682e-09 , 7.6140479571e-10  , 3.80621791854e-09 , 4.12231555046e-08 ,
 3.51409184835e-07 , 2.34389889864e-06 , 1.22451443084e-05 , 5.01665098879e-05 ,
 0.000161389839752 , 0.000408303209277 , 0.000813544897605 , 0.00127848457655  ,
 0.00158662234105  , 0.00155646126178  , 0.00120764865893  , 0.00074119148146  ,
 0.000359708655396 , 0.000137929412504 , 4.17401276507e-05 , 9.95514312412e-06 ,
 1.86851416875e-06 , 2.75585595867e-07 , 3.18945359941e-08 , 2.89280383442e-09 ,
 2.0538766713e-10  , 1.14041230867e-11 , 4.94798360572e-13 , 1.67641432054e-14 ,
 4.43284938499e-16 , 4.52115804343e-17 , 1.77270143995e-15 , 6.679067381e-14   ,
 1.96207171141e-12 , 4.49535742539e-11 , 8.03581672165e-10 , 1.12129361097e-08 ,
 1.22204672883e-07 , 1.04099205269e-06 , 6.93703164433e-06 , 3.62001737185e-05 ,
 0.00014810571168  , 0.000475701169716 , 0.00120122267308  , 0.00238829157172  ,
 0.00120190093915  , 0.00148768190483  , 0.00145536776795  , 0.0011260083785   ,
 0.000689135284074 , 0.000333535061685 , 0.000127567335226 , 3.85149806285e-05 ,
 9.1697383823e-06  , 1.7474483006e-06  , 5.05180943617e-07 , 1.68708739716e-06 ,
 8.50690663095e-06 , 3.40676326605e-05 , 0.000106646644716 , 0.000261105592455 ,
 0.000500467153025 , 0.000751865802297 , 0.000886677163137 , 0.000822828548307 ,
 0.00060469325296  , 0.000360775001318 , 0.000194142593676 , 0.000128287161257 ,
 0.00013288270802  , 0.000167633519232 , 0.000201766701856 , 0.000216293215271 ,
 0.000209566096454 , 0.000206474507811 , 0.000251165349907 , 0.000377096132209 ,
 0.000596287796948 , 0.000972852577558 , 0.00176887284966  , 0.00352143057149  ,
 0.00692673366146  , 0.0125670927707   , 0.0204529625104   , 0.0292241095648   ,
 0.035658760153    , 0.0361149007379   , 0.0296776922495   , 0.0194831805516   ,
 0.0101192522931   , 0.00413366493914  , 0.00132335902472  , 0.000331310506431 ,
 6.47772350362e-05 , 9.88247059166e-06 , 1.17576246782e-06 , 1.09048539095e-07 ,
 7.8824351068e-09  , 4.46425432433e-10 , 5.37702261165e-11 , 3.71786389752e-10 ,
 3.13404089489e-09 , 2.06597031348e-08 , 1.06374756826e-07 , 4.28115157822e-07 ,
 1.34793465572e-06 , 3.32361468257e-06 , 6.42543927405e-06 , 9.75272441065e-06 ,
 1.16391345882e-05 , 1.0943285633e-05  , 8.18171869756e-06 , 5.47271027663e-06 ,
 7.64559627312e-06 , 3.29636922777e-05 , 0.00015013292208  , 0.000551555745296 ,
 0.00159952328457  , 0.00365164151282  , 0.00655241581117  , 0.00922804596136  ,
 0.0101869997128   , 0.00880460196705  , 0.00595207442569  , 0.00314454892814  ,
 0.00129741314081  , 0.000417812772988 , 0.000104970978834 , 2.05674735456e-05 ,
 3.14187861409e-06 , 3.74105703444e-07 , 3.47155046124e-08 , 2.51063752925e-09 ,
 1.41701270829e-10 , 6.32716180581e-12 , 2.50970746766e-13 , 1.66718560076e-14 ,
 2.5635765295e-14  , 3.26843692492e-13 , 3.51782802616e-12 , 2.95327810664e-11 ,
 1.9324943498e-10  , 9.85821477128e-10 , 3.92154903008e-09 , 1.21686380673e-08 ,
 2.9467157623e-08  , 5.57182140327e-08 , 8.23425955171e-08 , 9.53383946285e-08 ,
 8.74005764678e-08 , 6.7365803189e-08  , 5.92011788303e-08 , 1.06146359464e-07 ,
 3.12345459289e-07 , 9.37447626506e-07 , 2.46842608694e-06 , 5.45159922815e-06 ,
 9.97925535681e-06 , 1.53165060509e-05 , 2.0406683128e-05  , 2.51000835924e-05 ,
 3.25632725465e-05 , 6.10519787809e-05 , 0.000190351709629 , 0.000679086972026 ,
 0.00212579350677  , 0.00542859589882  , 0.0111326809618   , 0.0182730721773   ,
 0.0239899495118   , 0.0251880574794   , 0.0211477654599   , 0.0141956385461   ,
 0.00761600580482  , 0.00326422127085  , 0.00111694782776  , 0.000304867501582 ,
 6.63013284499e-05 , 1.14722550423e-05 , 1.57672255355e-06 , 1.71796008839e-07 ,
 1.48131679577e-08 , 1.07614517417e-09 , 1.00644042616e-09 , 1.03881397505e-08 ,
 8.85372902725e-08 , 5.90543193403e-07 , 3.08515295038e-06 , 1.2639406453e-05  ,
 4.06620230621e-05 , 0.000102871621519 , 0.000204971895625 , 0.000322113024068 ,
 0.000399748053049 , 0.000392148996609 , 0.000304265979172 , 0.000186742518358 ,
 9.06282679496e-05 , 3.47511897948e-05 , 1.05163871267e-05 , 2.50818923869e-06 ,
 4.7077044217e-07  , 6.94335397568e-08 , 8.03579928044e-09 , 7.2883929007e-10  ,
 5.17472355779e-11 , 2.8732584199e-12  , 1.24663996071e-13 , 4.22371060325e-15 ,
 1.11685214707e-16 , 1.38949595382e-17 , 5.69042663606e-16 , 2.1440116802e-14  ,
 6.29834771772e-13 , 1.4430323813e-11  , 2.57953776744e-10 , 3.59940917723e-09 ,
 3.92283178706e-08 , 3.34163712386e-07 , 2.22682223312e-06 , 1.16204388006e-05 ,
 4.75426823084e-05 , 0.000152702480742 , 0.000385598551736 , 0.000766653670315 ,
 0.0003011990103   , 0.000372816346822 , 0.000364718353277 , 0.000282180168223 ,
 0.000172698813057 , 8.35846193198e-05 , 3.19686897807e-05 , 9.65256613301e-06 ,
 2.30659564383e-06 , 5.31006527879e-07 , 9.1010681638e-07  , 5.57039812695e-06 ,
 2.85338488958e-05 , 0.000114296001897 , 0.000357790951559 , 0.000875982632867 ,
 0.00167902618093  , 0.00252254994582  , 0.00297541233057  , 0.00276358230341  ,
 0.00203931065564  , 0.00123987814717  , 0.000718204083428 , 0.000556106256648 ,
 0.000645774190515 , 0.000836388770537 , 0.00100342510676  , 0.0010644411518   ,
 0.0010129778705   , 0.000963181804213 , 0.00111387464595  , 0.00160037564429  ,
 0.0023968939931   , 0.00351307189354  , 0.00541487901844  , 0.00911633893722  ,
 0.015542586792    , 0.0246673850898   , 0.0352094826491   , 0.0447243392944   ,
 0.0497899822797   , 0.0473453982973   , 0.037390516063    , 0.0239687675796   ,
 0.0122766693875   , 0.00497455288206  , 0.00158510138082  , 0.000395754501835 ,
 7.72531811775e-05 , 1.17746730379e-05 , 1.40010182082e-06 , 1.29812102967e-07 ,
 9.38217565573e-09 , 5.4450016435e-10  , 2.47746470172e-10 , 2.43133757832e-09 ,
 2.0525393422e-08  , 1.35304709283e-07 , 6.96670502135e-07 , 2.80381559371e-06 ,
 8.8279056142e-06  , 2.17670466151e-05 , 4.20815382605e-05 , 6.38724906845e-05 ,
 7.62244727075e-05 , 7.16298707868e-05 , 5.31069863231e-05 , 3.13463271728e-05 ,
 1.65428184192e-05 , 1.81238998452e-05 , 6.1512641152e-05  , 0.000221069256514 ,
 0.000640217940114 , 0.00146146318007  , 0.00262239945724  , 0.00369323547547  ,
 0.0040770264998   , 0.00352376524037  , 0.0023821307364   , 0.00125850688651  ,
 0.00051924883651  , 0.000167216431951 , 4.20113352601e-05 , 8.23148465937e-06 ,
 1.25743781804e-06 , 1.497236669e-07   , 1.38934663877e-08 , 1.00458975894e-09 ,
 5.66002641232e-11 , 2.4869432753e-12  , 8.65935178263e-14 , 1.70552788582e-14 ,
 2.57446476896e-13 , 3.55570224799e-12 , 3.82927969023e-11 , 3.21422337383e-10 ,
 2.10302085407e-09 , 1.07274090485e-08 , 4.26713701206e-08 , 1.32406973012e-07 ,
 3.20629523681e-07 , 6.06272658187e-07 , 8.96032926431e-07 , 1.0377011541e-06  ,
 9.5202806799e-07  , 7.34056306082e-07 , 6.31084197441e-07 , 1.03543742718e-06 ,
 2.76739470874e-06 , 7.74963080409e-06 , 1.94687897478e-05 , 4.1636170595e-05  ,
 7.44166436788e-05 , 0.000111927264321 , 0.000146090986087 , 0.000173761231761 ,
 0.000200034972632 , 0.000250388875569 , 0.000433409024506 , 0.00109690686177  ,
 0.00303709846134  , 0.00747082076387  , 0.015244907171    , 0.0252863436953   ,
 0.0338224345041   , 0.0363206852392   , 0.0312187766961   , 0.0214311477337   ,
 0.0117320648372   , 0.00511604125354  , 0.00177571294659  , 0.000490201172864 ,
 0.000107543875692 , 1.8731218744e-05  , 2.58680653342e-06 , 2.82827790024e-07 ,
 2.44408824235e-08 , 1.67961255285e-09 , 2.76479907685e-10 , 2.04324383142e-09 ,
 1.73861466733e-08 , 1.15964760904e-07 , 6.05830393843e-07 , 2.4819957752e-06  ,
 7.98478708843e-06 , 2.02008639368e-05 , 4.02502586547e-05 , 6.32532206198e-05 ,
 7.84983838049e-05 , 7.70061597792e-05 , 5.97486027251e-05 , 3.66705622877e-05 ,
 1.77966409262e-05 , 6.82407885012e-06 , 2.06509922091e-06 , 4.92532233771e-07 ,
 9.24450252392e-08 , 1.36346396466e-08 , 1.57798706281e-09 , 1.43121913634e-10 ,
 1.01615863498e-11 , 5.64220739778e-13 , 2.44802248205e-14 , 8.29408557428e-16 ,
 2.19315861141e-17 , 3.35985789359e-18 , 1.42603339022e-16 , 5.37294027414e-15 ,
 1.57837974604e-13 , 3.61627078339e-12 , 6.46437819688e-11 , 9.02019830864e-10 ,
 9.83070245932e-09 , 8.37421589171e-08 , 5.58046533523e-07 , 2.91210743913e-06 ,
 1.19143004152e-05 , 3.82675764463e-05 , 9.66318424199e-05 , 0.00019212509053  ,
 5.88972091188e-05 , 7.29014425382e-05 , 7.13179405958e-05 , 5.51782171224e-05 ,
 3.37699589436e-05 , 1.63443516906e-05 , 6.25134451409e-06 , 1.88923009919e-06 ,
 4.74384793576e-07 , 3.5269330696e-07  , 2.26342634617e-06 , 1.47668351306e-05 ,
 7.56820994005e-05 , 0.000303078122172 , 0.000948646608712 , 0.00232248078448  ,
 0.00445156616276  , 0.00668837682331  , 0.00789138565304  , 0.00733925844085  ,
 0.00544890294441  , 0.00340368887958  , 0.00216685229949  , 0.00196625834     ,
 0.00249105668356  , 0.00327923293518  , 0.00391801781387  , 0.00411806052956  ,
 0.00385956414472  , 0.00355948846153  , 0.00393445701177  , 0.00544557528327  ,
 0.00785938539102  , 0.0107139283888   , 0.0145030087531   , 0.020945875434    ,
 0.0312396742602   , 0.0439723685229   , 0.0554009740473   , 0.0617804753751   ,
 0.0609634965166   , 0.052664709525    , 0.0388954390995   , 0.0238907705347   ,
 0.0119248618389   , 0.00475913199259  , 0.00150308909116  , 0.000373348319108 ,
 7.266019378e-05   , 1.10550589419e-05 , 1.31316291486e-06 , 1.21676297684e-07 ,
 8.79469807114e-09 , 5.77551338958e-10 , 1.16849474885e-09 , 1.24127723978e-08 ,
 1.04816645762e-07 , 6.90958626677e-07 , 3.5576773139e-06  , 1.43182050915e-05 ,
 4.50813396642e-05 , 0.000111157466451 , 0.000214897189971 , 0.00032617669707  ,
 0.000389253613505 , 0.000365778803791 , 0.000271052054039 , 0.000158673693793 ,
 7.40202094373e-05 , 3.08649845429e-05 , 2.66060392943e-05 , 7.11125173594e-05 ,
 0.00020141804245  , 0.000459144015307 , 0.000823799928363 , 0.0011601856958   ,
 0.00128074860361  , 0.00110694824052  , 0.000748317564768 , 0.00039534471978  ,
 0.00016311574292  , 5.25290200143e-05 , 1.31973529424e-05 , 2.58582136016e-06 ,
 3.95008877356e-07 , 4.70338714025e-08 , 4.36445772912e-09 , 3.15575322456e-10 ,
 1.7778168547e-11  , 7.80962329486e-13 , 3.31096574716e-14 , 1.26181949766e-13 ,
 2.19618785223e-12 , 3.02877041619e-11 , 3.25924233251e-10 , 2.73447699929e-09 ,
 1.78861779714e-08 , 9.12203280881e-08 , 3.62815466339e-07 , 1.12572450674e-06 ,
 2.72591475301e-06 , 5.15445552431e-06 , 7.618770075e-06   , 8.82684486251e-06 ,
 8.10940360536e-06 , 6.27523211689e-06 , 5.36231339141e-06 , 8.27823716736e-06 ,
 2.02544335775e-05 , 5.26537932381e-05 , 0.000125268106437 , 0.000257792384255 ,
 0.000447694593365 , 0.000657227977307 , 0.000838299380841 , 0.00097318644991  ,
 0.00107888538148  , 0.00120560088442  , 0.00154457781914  , 0.0026877432399   ,
 0.00587797156768  , 0.0127944762657   , 0.0242807213314   , 0.0383102919718   ,
 0.0493820002526   , 0.0515654279679   , 0.0433917219414   , 0.029315781707    ,
 0.0158584317069   , 0.00685499477868  , 0.00236411479226  , 0.000649643405764 ,
 0.000142061245373 , 2.46874308115e-05 , 3.40412882965e-06 , 3.71807706154e-07 ,
 3.21078020746e-08 , 2.19007112507e-09 , 1.46063653081e-10 , 3.17046837448e-10 ,
 2.66066542321e-09 , 1.77455463556e-08 , 9.27073792151e-08 , 3.79808153741e-07 ,
 1.22187445779e-06 , 3.0912433101e-06  , 6.15930799721e-06 , 9.67934320509e-06 ,
 1.20122389097e-05 , 1.17838908771e-05 , 9.14304799241e-06 , 5.61152387859e-06 ,
 2.72333635718e-06 , 1.04425672877e-06 , 3.16012432504e-07 , 7.5369893952e-08  ,
 1.41464279309e-08 , 2.08644485331e-09 , 2.41471947269e-10 , 2.19012740958e-11 ,
 1.55497982276e-12 , 8.63400492532e-14 , 3.74609380287e-15 , 1.26920495208e-16 ,
 3.35608759444e-18 , 6.38174758678e-19 , 2.78850142005e-17 , 1.05063820294e-15 ,
 3.08640330121e-14 , 7.07134649436e-13 , 1.26406070891e-11 , 1.76383217709e-10 ,
 1.92232018941e-09 , 1.6375151568e-08  , 1.09121817333e-07 , 5.6944078484e-07  ,
 2.32975215408e-06 , 7.4829377765e-06  , 1.88956325748e-05 , 3.75686215655e-05 ,
 8.98292628784e-06 , 1.11188339118e-05 , 1.08773203702e-05 , 8.41571116329e-06 ,
 5.15055437338e-06 , 2.49285054825e-06 , 9.53805164083e-07 , 2.92670419128e-07 ,
 1.25998534517e-07 , 5.95991243224e-07 , 4.79019268661e-06 , 3.11452450265e-05 ,
 0.000159090362866 , 0.000636197803977 , 0.00199016342988  , 0.00487119079876  ,
 0.00933612716377  , 0.0140284110933   , 0.0165591993713   , 0.0154319807409   ,
 0.0115616978214   , 0.00750296216866  , 0.00535829886676  , 0.00563581981736  ,
 0.00760324420077  , 0.0100994271849   , 0.012009237648    , 0.012518457043    ,
 0.0115834162786   , 0.0104174298899   , 0.0110791545853   , 0.0148563962099   ,
 0.0208853850548   , 0.0271137708074   , 0.0332728682534   , 0.0419546323081   ,
 0.0551120830132   , 0.0697830558011   , 0.0791781150829   , 0.0784100084498   ,
 0.0679513768126   , 0.0518558700318   , 0.0346164192969   , 0.0197874824882   ,
 0.00942853295965  , 0.00365782743173  , 0.00113606921781  , 0.000279435284356 ,
 5.40733524453e-05 , 8.19969676201e-06 , 9.72084148762e-07 , 8.99687943745e-08 ,
 6.51345177745e-09 , 6.9470137041e-10  , 4.58387886814e-09 , 4.9439984851e-08  ,
 4.17504232046e-07 , 2.75221738764e-06 , 1.4170893872e-05  , 5.70320877773e-05 ,
 0.000179567404358 , 0.00044276097242  , 0.000855975696115 , 0.00129922281634  ,
 0.00155046995133  , 0.00145696302176  , 0.00107961626723  , 0.000631686612782 ,
 0.000292278930207 , 0.000107835749479 , 3.55544800235e-05 , 2.41492973317e-05 ,
 5.08003425157e-05 , 0.00011323563404  , 0.00020287921725  , 0.000285696032652 ,
 0.000315382854171 , 0.000272584611118 , 0.00018427225329  , 9.73531366707e-05 ,
 4.01670451497e-05 , 1.29352046634e-05 , 3.2498314508e-06  , 6.36755235537e-07 ,
 9.72704357565e-08 , 1.15820312582e-08 , 1.0747426905e-09  , 7.77124384916e-11 ,
 4.38571832507e-12 , 2.13047025617e-13 , 8.18864705587e-14 , 8.9415674752e-13  ,
 1.47802842189e-11 , 2.02438748959e-10 , 2.17358066774e-09 , 1.82135299127e-08 ,
 1.19043695518e-07 , 6.06840586956e-07 , 2.41291048056e-06 , 7.48533332824e-06 ,
 1.8123954822e-05  , 3.42708692742e-05 , 5.06642813041e-05 , 5.87362827476e-05 ,
 5.40875243564e-05 , 4.21629133891e-05 , 3.633153893e-05   , 5.4132625573e-05  ,
 0.00012268137337  , 0.000295683933384 , 0.00066229442199  , 0.00130378190406  ,
 0.00218935464902  , 0.00312388130209  , 0.00387803184517  , 0.00438255012167  ,
 0.00472268542733  , 0.00502065175932  , 0.00559687690944  , 0.00742420988611  ,
 0.0123406029258   , 0.0223478211804   , 0.0376602617867   , 0.0545372986675   ,
 0.0657079629531   , 0.0649347757013   , 0.0522311282121   , 0.0340220759946   ,
 0.0178773976963   , 0.00755471997276  , 0.0025607934673   , 0.000694661731472 ,
 0.000150478228237 , 2.59740826976e-05 , 3.5646440819e-06  , 3.88079792833e-07 ,
 3.34401955275e-08 , 2.27584553138e-09 , 1.25450327835e-10 , 4.23593575111e-11 ,
 3.17388988486e-10 , 2.11585130353e-09 , 1.10537406266e-08 , 4.52855082958e-08 ,
 1.4568725118e-07  , 3.68576933338e-07 , 7.34390219521e-07 , 1.15409311962e-06 ,
 1.43225030699e-06 , 1.40502378059e-06 , 1.09014925464e-06 , 6.69076502575e-07 ,
 3.24710435992e-07 , 1.24509430058e-07 , 3.76789794866e-08 , 8.98654735076e-09 ,
 1.68671518267e-09 , 2.48772215083e-10 , 2.87913246819e-11 , 2.61134554374e-12 ,
 1.85404265204e-13 , 1.02945473344e-14 , 4.46656450934e-16 , 1.51330588404e-17 ,
 4.00155002207e-19 , 9.50788958677e-20 , 4.25298635898e-18 , 1.60241982062e-16 ,
 4.70734246143e-15 , 1.07851263635e-13 , 1.92792907089e-12 , 2.69017406079e-11 ,
 2.93189793068e-10 , 2.49751697252e-09 , 1.66431186747e-08 , 8.6850373206e-08  ,
 3.55330790218e-07 , 1.14128800724e-06 , 2.88193748114e-06 , 5.72991765081e-06 ,
 1.06827639854e-06 , 1.32228548779e-06 , 1.29356692353e-06 , 1.00083675032e-06 ,
 6.1257923333e-07  , 2.96742243066e-07 , 1.15338079576e-07 , 5.01420903932e-08 ,
 1.44648453029e-07 , 1.14282191317e-06 , 8.53256346929e-06 , 5.32652120025e-05 ,
 0.000267424761887 , 0.00106176877596  , 0.00331154591067  , 0.00809560881071  ,
 0.0155094471179   , 0.0233057080944   , 0.0275325268029   , 0.0257460377446   ,
 0.0195633801071   , 0.0133977563735   , 0.0109286097238   , 0.0130587106532   ,
 0.0183685880131   , 0.0244685515909   , 0.0289239199269   , 0.0299150418093   ,
 0.0273882708821   , 0.0241577873113   , 0.0249240733457   , 0.0325760789917   ,
 0.044922232569    , 0.0564055262066   , 0.0643862937702   , 0.0722984869101   ,
 0.0840733065023   , 0.0964753871324   , 0.100474289593    , 0.0905545813474   ,
 0.0700157231654   , 0.0469305019673   , 0.0275682239059   , 0.0141574208375   ,
 0.00624033998619  , 0.0023004144623   , 0.000692384289597 , 0.000167154345838 ,
 3.19944260307e-05 , 4.82083058671e-06 , 5.6939284734e-07  , 5.25858844888e-08 ,
 3.84869429649e-09 , 1.23628036793e-09 , 1.42067993606e-08 , 1.53664452212e-07 ,
 1.29765684997e-06 , 8.55424585691e-06 , 4.40449620003e-05 , 0.000177263069292 ,
 0.000558118606919 , 0.00137615811452  , 0.00266048280488  , 0.00403815258676  ,
 0.00481906344114  , 0.00452843801445  , 0.00335560292552  , 0.00196334082938  ,
 0.000908011025245 , 0.00033233498181  , 9.70400963301e-05 , 2.53246690956e-05 ,
 1.35501322181e-05 , 2.23763381541e-05 , 3.91802250755e-05 , 5.50904957914e-05 ,
 6.08086191183e-05 , 5.25563032465e-05 , 3.55290068639e-05 , 1.87703782922e-05 ,
 7.74449233291e-06 , 2.49399956377e-06 , 6.26590643751e-07 , 1.22770943409e-07 ,
 1.87544331939e-08 , 2.23310191519e-09 , 2.07237747176e-10 , 1.50630334004e-11 ,
 1.0970989544e-12  , 6.70788889929e-13 , 1.42399503961e-12 , 6.36642530971e-12 ,
 8.04819333928e-11 , 1.06962791365e-09 , 1.1407773165e-08  , 9.52739875277e-08 ,
 6.21457145839e-07 , 3.16398426899e-06 , 1.25707613526e-05 , 3.89785260132e-05 ,
 9.43531787222e-05 , 0.00017840545955  , 0.000263818731428 , 0.000306189263153 ,
 0.000283032480491 , 0.000223388313643 , 0.000196959754903 , 0.000289524867361 ,
 0.000615597316191 , 0.00137842825165  , 0.00289662801366  , 0.00542837640875  ,
 0.00877634485036  , 0.0121253752797   , 0.0145925672954   , 0.0159850429733   ,
 0.0167244587327   , 0.0172079187221   , 0.0179239656366   , 0.0202904308174   ,
 0.0267196970089   , 0.0390826729354   , 0.0561932958972   , 0.0723124766986   ,
 0.0793447874239   , 0.0725476904092   , 0.0546398105743   , 0.0336720985089   ,
 0.0168999997293   , 0.00688176661868  , 0.00226566038668  , 0.000601051875311 ,
 0.000128060042115 , 2.18411585571e-05 , 2.97232932839e-06 , 3.21753051648e-07 ,
 2.7623431089e-08  , 1.8759059746e-09  , 1.00855153302e-10 , 7.70392667643e-12 ,
 2.96094940802e-11 , 1.96550897534e-10 , 1.02681252218e-09 , 4.20669541513e-09 ,
 1.3533289392e-08  , 3.4238124896e-08  , 6.82195270167e-08 , 1.07206883579e-07 ,
 1.33045669653e-07 , 1.30516522767e-07 , 1.01266962171e-07 , 6.21523562936e-08 ,
 3.01632453625e-08 , 1.15660233645e-08 , 3.50010402387e-09 , 8.34785097039e-10 ,
 1.56683611919e-10 , 2.31091352046e-11 , 2.6745053286e-12  , 2.42575069023e-13 ,
 1.72227120763e-14 , 9.56288813037e-16 , 4.14911460832e-17 , 1.40575145335e-18 ,
 3.71714986285e-20 , 1.10968335328e-20 , 5.05777773606e-19 , 1.90564525923e-17 ,
 5.5981115122e-16  , 1.2825992702e-14  , 2.29275053066e-13 , 3.19923491926e-12 ,
 3.48670012706e-11 , 2.970121386e-10   , 1.97924912024e-09 , 1.03285044187e-08 ,
 4.22569932886e-08 , 1.35725360794e-07 , 3.4272856928e-07  , 6.81418845994e-07 ,
 9.90355524824e-08 , 1.225944852e-07   , 1.19985690021e-07 , 9.30515288334e-08 ,
 5.77164763908e-08 , 3.07161172507e-08 , 2.48624213531e-08 , 8.33630620051e-08 ,
 4.69205447112e-07 , 2.69129964595e-06 , 1.51902277673e-05 , 8.06628390637e-05 ,
 0.00037449121983  , 0.00143617354783  , 0.00441347293133  , 0.0107234955327   ,
 0.0204970156229   , 0.0307925240266   , 0.0364434311632   , 0.0343173397323   ,
 0.026731348756    , 0.0198049351086   , 0.0186952000247   , 0.0246475725963   ,
 0.035379793521    , 0.0468934800886   , 0.0549461812428   , 0.0563480699289   ,
 0.0511363486133   , 0.0445199047634   , 0.0450083861996   , 0.0577231821875   ,
 0.0784246835818   , 0.0961490251683   , 0.104099432959    , 0.106287179731    ,
 0.110185447407    , 0.114791390479    , 0.110939883123    , 0.0930552741651   ,
 0.065977852735    , 0.0396042013538   , 0.0204273153265   , 0.00918698118239  ,
 0.00361047497521  , 0.00122185318853  , 0.000347382636767 , 8.09523884804e-05 ,
 1.51719181481e-05 , 2.25807270195e-06 , 2.64799236393e-07 , 2.43584946477e-08 ,
 1.89098976731e-09 , 2.58087725419e-09 , 3.44549435453e-08 , 3.72871772823e-07 ,
 3.14881168301e-06 , 2.07571897399e-05 , 0.000106876707822 , 0.000430135309899 ,
 0.00135429520436  , 0.00333929818842  , 0.00645576052625  , 0.00979873401967  ,
 0.0116936695167   , 0.0109885292056   , 0.00814274939012  , 0.00476458278942  ,
 0.00220393090781  , 0.000806753604248 , 0.000234107922068 , 5.44195700226e-05 ,
 1.13970216225e-05 , 4.79428205315e-06 , 6.09588562913e-06 , 8.33174908619e-06 ,
 9.17366729612e-06 , 7.92651084862e-06 , 5.3582559258e-06  , 2.83080996509e-06 ,
 1.16796596674e-06 , 3.76126149592e-07 , 9.44976585234e-08 , 1.85153861046e-08 ,
 2.82841632159e-09 , 3.36876073543e-10 , 3.17514782338e-11 , 4.27848766712e-12 ,
 6.50839706861e-12 , 1.58524630029e-11 , 3.17174456939e-11 , 6.71202285627e-11 ,
 3.94152327475e-10 , 4.56390396138e-09 , 4.76009978996e-08 , 3.94004727322e-07 ,
 2.55652890612e-06 , 1.29732031143e-05 , 5.14377019092e-05 , 0.000159293007269 ,
 0.000385318359652 , 0.000728406124453 , 0.00107760990744  , 0.00125308995015  ,
 0.00116575618064  , 0.000938680430592 , 0.000860731943659 , 0.00127091812091  ,
 0.00256382186086  , 0.0053553755785   , 0.0105471379596   , 0.0187574563844   ,
 0.0291077489354   , 0.0388364309437   , 0.0451787627898   , 0.047779455416    ,
 0.0483355979114   , 0.0482644052422   , 0.0483339877145   , 0.0502894557248   ,
 0.0567960679943   , 0.0688216413138   , 0.0831362588764   , 0.0925975660972   ,
 0.0902128300923   , 0.0745920052362   , 0.0514891997096   , 0.0294046643603   ,
 0.0138184820328   , 0.00532296578381  , 0.00167464607391  , 0.00042863575368  ,
 8.88831405128e-05 , 1.48662622791e-05 , 1.99692194145e-06 , 2.14592730309e-07 ,
 1.83932843407e-08 , 1.25568313524e-09 , 6.8507181367e-11  , 3.33159860771e-12 ,
 2.28214224449e-12 , 1.42410404486e-11 , 7.43111134156e-11 , 3.04426960345e-10 ,
 9.79364750153e-10 , 2.47771330752e-09 , 4.93684866901e-09 , 7.75825084474e-09 ,
 9.6281296028e-09  , 9.44510344391e-09 , 7.32839799374e-09 , 4.49778719661e-09 ,
 2.18282747639e-09 , 8.3699997849e-10  , 2.53292521082e-10 , 6.04110148386e-11 ,
 1.13387464557e-11 , 1.67234233852e-12 , 1.93546346171e-13 , 1.75544686311e-14 ,
 1.24635878108e-15 , 6.92039082484e-17 , 3.00259657911e-18 , 1.01730247637e-19 ,
 2.68999601227e-21 , 1.01346166544e-21 , 4.6887542021e-20  , 1.76660634023e-18 ,
 5.18966436253e-17 , 1.18901878049e-15 , 2.12546779264e-14 , 2.96581363362e-13 ,
 3.23230492278e-12 , 2.75341659625e-11 , 1.8348399614e-10  , 9.57492051471e-10 ,
 3.91738590491e-09 , 1.25822659511e-08 , 3.177229072e-08   , 6.31704495844e-08 ,
 7.19033711357e-09 , 9.06035123752e-09 , 9.64741018757e-09 , 1.05688159273e-08 ,
 1.66391854046e-08 , 3.84180616981e-08 , 1.16974056993e-07 , 4.75069623096e-07 ,
 2.17135517696e-06 , 9.40013762478e-06 , 3.73351508152e-05 , 0.000140960815077 ,
 0.000512371080817 , 0.00171248782072  , 0.00492556178483  , 0.011625252826    ,
 0.021970838243    , 0.0329362372697   , 0.0391906334257   , 0.0376029186935   ,
 0.0308909531649   , 0.0258681985378   , 0.0282357842138   , 0.0391864960099   ,
 0.0556443453241   , 0.0722671466208   , 0.083288112399    , 0.0844166333205   ,
 0.0760259139923   , 0.0658303182356   , 0.0660083237128   , 0.0835988169088   ,
 0.112027160478    , 0.134670723383    , 0.140190249141    , 0.132888811907    ,
 0.124417975659    , 0.11794852685     , 0.10628275473     , 0.0841524896814   ,
 0.0560330328113   , 0.0310005681136   , 0.0143523006652   , 0.00565712675454  ,
 0.00193320514594  , 0.000577107052419 , 0.000149022893863 , 3.25330973549e-05 ,
 5.85361138052e-06 , 8.50285631451e-07 , 9.83093437811e-08 , 8.97890517877e-09 ,
 9.06312087632e-10 , 4.74178789902e-09 , 6.5305914305e-08  , 7.06812461798e-07 ,
 5.96886170697e-06 , 3.93471594728e-05 , 0.000202594616865 , 0.000815361012418 ,
 0.00256719125539  , 0.00632994898223  , 0.0122375032616   , 0.018574480394    ,
 0.0221667332088   , 0.0208306969251   , 0.0154375236741   , 0.00903574754031  ,
 0.00418356651516  , 0.00153576555448  , 0.000449267864012 , 0.00010619566822  ,
 2.11345449098e-05 , 4.11265132684e-06 , 1.35039406634e-06 , 1.09641085423e-06 ,
 1.10064912567e-06 , 9.37060879339e-07 , 6.31877483119e-07 , 3.33683176585e-07 ,
 1.37664306199e-07 , 4.43321727589e-08 , 1.11379604814e-08 , 2.18234871613e-09 ,
 3.33665923547e-10 , 4.16399608181e-11 , 1.36906297766e-11 , 4.06098009596e-11 ,
 1.27504112875e-10 , 3.16191208488e-10 , 6.19401196905e-10 , 1.02107897998e-09 ,
 2.37364227013e-09 , 1.68459703856e-08 , 1.61904121048e-07 , 1.30787219008e-06 ,
 8.37285118331e-06 , 4.21322902357e-05 , 0.000166165279262 , 0.000512884089983 ,
 0.00123825317367  , 0.00233900595266  , 0.00346260025281  , 0.00404042437123  ,
 0.00380077019738  , 0.00316024276113  , 0.00307212828146  , 0.00461707275395  ,
 0.00890472638509  , 0.0174275941659   , 0.0321978173896   , 0.0542796142267   ,
 0.080742972836    , 0.103959938091    , 0.116816016192    , 0.119016050137    ,
 0.115918612492    , 0.111966534932    , 0.108664687564    , 0.107693430755    ,
 0.111198334838    , 0.118176478987    , 0.122979435553    , 0.118472160791    ,
 0.101204149548    , 0.0744719046983   , 0.046340879247    , 0.0241156236761   ,
 0.0104302753259   , 0.00373616588112  , 0.00110558462297  , 0.000269574166587 ,
 5.40068748662e-05 , 8.8675461211e-06  , 1.19221869402e-06 , 1.31607483109e-07 ,
 1.20351257564e-08 , 9.3231818295e-10  , 6.6872212845e-11  , 6.73145449708e-12 ,
 1.62879847543e-12 , 1.245382604e-12   , 4.33542922515e-12 , 1.7341311127e-11  ,
 5.57255057062e-11 , 1.40978009032e-10 , 2.80909013659e-10 , 4.41466950989e-10 ,
 5.47893898147e-10 , 5.375050085e-10   , 4.17067737949e-10 , 2.55987070082e-10 ,
 1.24239384323e-10 , 4.76414206954e-11 , 1.44178075617e-11 , 3.43881314614e-12 ,
 6.45462466458e-13 , 9.52012397998e-14 , 1.10182337431e-14 , 9.99361449213e-16 ,
 7.09552312103e-17 , 3.93982707708e-18 , 1.70941570247e-19 , 5.79167418546e-21 ,
 1.5314692683e-22  , 7.2394363185e-23  , 3.3877878241e-21  , 1.27643439324e-19 ,
 3.74971235698e-18 , 8.59107219226e-17 , 1.53572392753e-15 , 2.14290275461e-14 ,
 2.33545215058e-13 , 1.98943982461e-12 , 1.32573845108e-11 , 6.91826564244e-11 ,
 2.83051706344e-10 , 9.09185301233e-10 , 2.29630622406e-09 , 4.56934674592e-09 ,
 8.54769827412e-10 , 2.96496950397e-09 , 1.1974780242e-08  , 4.45317777877e-08 ,
 1.39236492892e-07 , 3.71124481108e-07 , 9.49343597963e-07 , 2.84689908831e-06 ,
 1.03500774408e-05 , 3.81278053005e-05 , 0.000125353305543 , 0.000360311427494 ,
 0.000939081441941 , 0.00232019677842  , 0.00543766044272  , 0.0115013024792   ,
 0.02073181494     , 0.0307541841584   , 0.0372605712764   , 0.037846766907    ,
 0.0351430218435   , 0.0351288418975   , 0.0423906194398   , 0.0572171503846   ,
 0.0761131176872   , 0.0936888907769   , 0.104184141144    , 0.103396043064    ,
 0.0923674133476   , 0.0802998256241   , 0.0809123934346   , 0.101433917936    ,
 0.133348382141    , 0.156809272922    , 0.158145211786    , 0.141986855334    ,
 0.122792603783    , 0.107283905324    , 0.0907720257095   , 0.0684909793965   ,
 0.0435157972244   , 0.0227230613383   , 0.00971970095264  , 0.00343812893669  ,
 0.00102425870678  , 0.000262570810901 , 5.87550727811e-05 , 1.14437691079e-05 ,
 1.90227425178e-06 , 2.62864366936e-07 , 2.95026082688e-08 , 2.66231191684e-09 ,
 5.79311749871e-10 , 6.98422428549e-09 , 9.67777544913e-08 , 1.04745557398e-06 ,
 8.84551165712e-06 , 5.83102405738e-05 , 0.000300233649934 , 0.00120831859548  ,
 0.003804432778    , 0.00938063971926  , 0.0181353887677   , 0.0275268523634   ,
 0.0328518896134   , 0.0308761073348   , 0.0228921602788   , 0.013417429389    ,
 0.00623862508438  , 0.0023195302952   , 0.000704005875124 , 0.000183439487362 ,
 4.50219122744e-05 , 1.13478273783e-05 , 2.91050319324e-06 , 7.37227582373e-07 ,
 2.21835529595e-07 , 1.04470093877e-07 , 6.03275157413e-08 , 3.09164512544e-08 ,
 1.26866188604e-08 , 4.08163186607e-09 , 1.02535022864e-09 , 2.01465848005e-10 ,
 3.54491267823e-11 , 3.46375724802e-11 , 1.59155014241e-10 , 6.39348510586e-10 ,
 2.01954857017e-09 , 5.00876405949e-09 , 9.77775311496e-09 , 1.52712603925e-08 ,
 2.22818538466e-08 , 6.58357443505e-08 , 4.77290557533e-07 , 3.6056800433e-06  ,
 2.23391729487e-05 , 0.000110114956247 , 0.000428543854716 , 0.00131164193389  ,
 0.00315082796329  , 0.00593828277868  , 0.00879835882071  , 0.0103325778576   ,
 0.00991466828911  , 0.0086808569013   , 0.0091458310782   , 0.0140883105442   ,
 0.0260547638039   , 0.0479284008567   , 0.0832334839623   , 0.133114538609    ,
 0.18999408866     , 0.236534776876    , 0.257432078129    , 0.253117900262    ,
 0.236932553793    , 0.220253922514    , 0.206633489636    , 0.197231063306    ,
 0.192605045801    , 0.188692593294    , 0.177271019881    , 0.15258163629     ,
 0.116444956882    , 0.0771149377813   , 0.0436850236752   , 0.0209752153086   ,
 0.00849260638055  , 0.00289427449459  , 0.00083105375117  , 0.00020189647433  ,
 4.18602393666e-05 , 7.51094136085e-06 , 1.18568416619e-06 , 1.66598077204e-07 ,
 2.0923770931e-08  , 2.4450647523e-09  , 3.4677057668e-10  , 9.0386269566e-11  ,
 3.1795877388e-11  , 1.01606194991e-11 , 3.58972798635e-12 , 5.01624873318e-12 ,
 1.46851781651e-11 , 3.70855915572e-11 , 7.41317051636e-11 , 1.16943992754e-10 ,
 1.45732173737e-10 , 1.43585389617e-10 , 1.11902031816e-10 , 6.89809726919e-11 ,
 3.36179326871e-11 , 1.2941088464e-11  , 3.93007184006e-12 , 9.40258698034e-13 ,
 1.76955834498e-13 , 2.61586515993e-14 , 3.03319960847e-15 , 2.75539074368e-16 ,
 1.95880637052e-17 , 1.08874191484e-18 , 4.72768222975e-20 , 1.60282281876e-21 ,
 4.24045818525e-23 , 4.84133343144e-24 , 1.94679664794e-22 , 7.33382254446e-21 ,
 2.1541560495e-19  , 4.93499689638e-18 , 8.82101950184e-17 , 1.23078437385e-15 ,
 1.34135526768e-14 , 1.14275723412e-13 , 7.61898858437e-13 , 3.98227245565e-12 ,
 1.63719396915e-11 , 5.33778150876e-11 , 1.41531520245e-10 , 3.31922637371e-10 ,
 4.88784430913e-09 , 2.44980850097e-08 , 1.08550677309e-07 , 4.0565636293e-07  ,
 1.25054943465e-06 , 3.20731784007e-06 , 7.2945976543e-06  , 1.71095699741e-05 ,
 4.76599630847e-05 , 0.000147488850589 , 0.000431440637419 , 0.00109512087766  ,
 0.00238059256017  , 0.00456483570091  , 0.008118454435    , 0.0138207377051   ,
 0.0221136890443   , 0.0318367472939   , 0.0403771048679   , 0.0463358134178   ,
 0.0516884557473   , 0.0600025258674   , 0.0726902693043   , 0.0879343770419   ,
 0.102578060387    , 0.113509748666    , 0.117448117417    , 0.111861198538    ,
 0.0986338442272   , 0.0867662473345   , 0.0883852930453   , 0.108475830849    ,
 0.137373285101    , 0.15604588357     , 0.152433888211    , 0.131918819592    ,
 0.108911939654    , 0.0906194032709   , 0.0735975269591   , 0.0536972501055   ,
 0.0330040336947   , 0.0165632456062   , 0.00671730507981  , 0.00220403878355  ,
 0.000590618523155 , 0.000131500916044 , 2.48923474651e-05 , 4.09147244527e-06 ,
 5.88193486165e-07 , 7.30424382651e-08 , 7.64069737527e-09 , 6.75685425949e-10 ,
 4.99635328835e-10 , 8.08934843479e-09 , 1.12224000853e-07 , 1.21463962177e-06 ,
 1.02573412318e-05 , 6.76171250227e-05 , 0.000348153935955 , 0.00140117907567  ,
 0.00441166852714  , 0.0108779716466   , 0.0210305414658   , 0.0319231981916   ,
 0.0381061220402   , 0.0358366428681   , 0.0266223896344   , 0.0156998177857   ,
 0.00743709637408  , 0.00291753595548  , 0.00101606309003  , 0.000349248017612 ,
 0.000124976767981 , 4.33657290582e-05 , 1.31003796679e-05 , 3.22861902639e-06 ,
 6.35000023311e-07 , 1.02043936629e-07 , 1.5603087799e-08  , 3.2683668061e-09  ,
 9.87341246347e-10 , 2.97618260809e-10 , 7.46643028905e-11 , 2.21589883071e-11 ,
 6.36255385419e-11 , 3.94157791101e-10 , 2.00522783539e-09 , 8.04763260164e-09 ,
 2.53965460067e-08 , 6.29998011335e-08 , 1.23014333679e-07 , 1.90222260079e-07 ,
 2.4368295986e-07  , 3.64249491071e-07 , 1.39791955723e-06 , 8.84277016819e-06 ,
 5.09381821596e-05 , 0.000239751035766 , 0.000904531859525 , 0.00271266026603  ,
 0.00643508892021  , 0.0120537847632   , 0.0178740713936   , 0.0212472671069   ,
 0.0211389361853   , 0.0200842481693   , 0.0234252714781   , 0.0369450468006   ,
 0.0654161982664   , 0.113260195639    , 0.185314136538    , 0.281843364298    ,
 0.387285652694    , 0.468679171822    , 0.497679039372    , 0.475878649375    ,
 0.429823407649    , 0.383419306164    , 0.345132417243    , 0.316014978217    ,
 0.294561205241    , 0.273304887096    , 0.241513869739    , 0.194894587083    ,
 0.13988789476     , 0.0881863641934   , 0.0485819516723   , 0.0233381155528   ,
 0.00976028600112  , 0.00355064565745  , 0.00112666520363  , 0.000314692403272 ,
 7.84247663763e-05 , 1.758336305e-05   , 3.52118162857e-06 , 6.17846890957e-07 ,
 9.51988649566e-08 , 1.49303386083e-08 , 3.67724466297e-09 , 1.44104678211e-09 ,
 5.62506642469e-10 , 1.82380716894e-10 , 6.19737695207e-11 , 7.89895483895e-11 ,
 2.27905872731e-10 , 5.75437312619e-10 , 1.15100280652e-09 , 1.81709078559e-09 ,
 2.26624076884e-09 , 2.23474818227e-09 , 1.74312677285e-09 , 1.07544057511e-09 ,
 5.24538006776e-10 , 2.02068981342e-10 , 6.14073337693e-11 , 1.47001886186e-11 ,
 2.76796498295e-12 , 4.09352152193e-13 , 4.74829239777e-14 , 4.31466134471e-15 ,
 3.06802038612e-16 , 1.70559061715e-17 , 7.40738601557e-19 , 2.51282025861e-20 ,
 8.41930082231e-22 , 2.09259115952e-21 , 1.93202418206e-20 , 1.44425689784e-19 ,
 9.24692128128e-19 , 6.24570234758e-18 , 5.82646796705e-17 , 6.60533231714e-16 ,
 6.84528907748e-15 , 5.77662229982e-14 , 3.88436368617e-13 , 2.10847397597e-12 ,
 9.66747378352e-12 , 4.11780912305e-11 , 1.85043129125e-10 , 9.28540621932e-10 ,
 4.46699658661e-08 , 2.02442080926e-07 , 8.4044532509e-07  , 3.02383380119e-06 ,
 9.12166706832e-06 , 2.29012446226e-05 , 4.93296373156e-05 , 9.99615526459e-05 ,
 0.000219016331985 , 0.000544043010013 , 0.00137856874184  , 0.00317746508934  ,
 0.00633436028272  , 0.0109190441923   , 0.0168597936571   , 0.0246287946745   ,
 0.0353089201311   , 0.049330701511    , 0.0657116211377   , 0.0835443043797   ,
 0.103187355325    , 0.124065891087    , 0.142258405222    , 0.152924343031    ,
 0.154842624811    , 0.150221037911    , 0.140550593479    , 0.125701872665    ,
 0.108058740751    , 0.0952282077893   , 0.0958133781866   , 0.111048692305    ,
 0.130790426994    , 0.139851967323    , 0.130829370589    , 0.110218252845    ,
 0.0899302430108   , 0.074610220528    , 0.0603785724015   , 0.043675240926    ,
 0.0264910175793   , 0.013070890536    , 0.00519228208356  , 0.00166034019754  ,
 0.000430077578902 , 9.13036267475e-05 , 1.61440813992e-05 , 2.41846597538e-06 ,
 3.10543560297e-07 , 3.41863812624e-08 , 3.18996094791e-09 , 2.65770004173e-10 ,
 4.28450311757e-10 , 7.34654595493e-09 , 1.01939091897e-07 , 1.10332317675e-06 ,
 9.31730121691e-06 , 6.14203293382e-05 , 0.000316247490672 , 0.00127277169153  ,
 0.00400740497327  , 0.00988142506879  , 0.0191055132125   , 0.0290090144536   ,
 0.034657891706    , 0.0326850842167   , 0.0244954905249   , 0.0148377101695   ,
 0.00758566362289  , 0.00358292028429  , 0.00174066757035  , 0.000876341283844 ,
 0.000411573823971 , 0.000163241825978 , 5.20054233242e-05 , 1.304896111e-05   ,
 2.56083485594e-06 , 3.92277407177e-07 , 4.69939525055e-08 , 4.47101659548e-09 ,
 3.66428426396e-10 , 3.55859101234e-11 , 1.49565756571e-11 , 8.64100402869e-11 ,
 6.4529829088e-10  , 4.02668800181e-09 , 2.02270677246e-08 , 8.06815593657e-08 ,
 2.5402863892e-07  , 6.30132226231e-07 , 1.23211955186e-06 , 1.90558702114e-06 ,
 2.37142881271e-06 , 2.68799287384e-06 , 4.99143169562e-06 , 2.14987542125e-05 ,
 0.000107614242812 , 0.000464214833149 , 0.00164439710754  , 0.00471791151622  ,
 0.0108749159513   , 0.0200678567103   , 0.0297655794264   , 0.036215240654    ,
 0.0384351947003   , 0.0411831999257   , 0.0537408452405   , 0.0859494769851   ,
 0.145154321567    , 0.236723291562    , 0.365968432364    , 0.531396324649    ,
 0.706923637655    , 0.838580103632    , 0.879064698193    , 0.828912176278    ,
 0.731033220479    , 0.6281062032      , 0.5391144801      , 0.4681381595      ,
 0.413170958779    , 0.364635431601    , 0.309815662216    , 0.244200829385    ,
 0.174977478057    , 0.11337317511     , 0.0663685037384   , 0.0349128827222   ,
 0.0163293037522   , 0.00673225888455  , 0.00244831944102  , 0.000792817786823 ,
 0.000230266705316 , 5.95499117117e-05 , 1.34274631858e-05 , 2.60476290451e-06 ,
 4.64079053278e-07 , 1.05510291959e-07 , 4.16365140945e-08 , 1.95453548541e-08 ,
 7.89740161616e-09 , 2.5764326909e-09  , 8.84058805763e-10 , 1.15042925201e-09 ,
 3.33095198232e-09 , 8.41186325768e-09 , 1.68257729484e-08 , 2.65629414088e-08 ,
 3.31288506477e-08 , 3.26685397747e-08 , 2.54818480835e-08 , 1.57213258977e-08 ,
 7.66797131592e-09 , 2.95395502141e-09 , 8.97687357222e-10 , 2.14896029103e-10 ,
 4.04638593003e-11 , 5.98431087144e-12 , 6.94365816215e-13 , 6.33574150059e-14 ,
 4.75929511095e-15 , 4.59517008832e-16 , 1.38234107066e-16 , 6.14551650601e-17 ,
 2.31759081243e-17 , 7.03735162093e-18 , 2.58842734578e-18 , 7.31196465866e-18 ,
 4.21449375612e-17 , 2.27028513701e-16 , 1.42389171554e-15 , 1.23757112419e-14 ,
 1.17663726375e-13 , 9.7025523709e-13  , 6.45161805922e-12 , 3.44167531048e-11 ,
 1.51565559851e-10 , 5.91442183062e-10 , 2.29747341919e-09 , 9.7615599542e-09  ,
 3.53658743067e-07 , 1.41884747657e-06 , 5.42219371818e-06 , 1.8542057326e-05  ,
 5.44064648206e-05 , 0.000134411878881 , 0.000282721196948 , 0.000534288587635 ,
 0.00100099786324  , 0.00201633877148  , 0.0042644722843   , 0.00866709958527  ,
 0.0158836795243   , 0.0258257223938   , 0.0381300422552   , 0.0536463178043   ,
 0.0749016332733   , 0.104013593467    , 0.140539626943    , 0.182146279206    ,
 0.225342122541    , 0.263112944708    , 0.284704891146    , 0.283079419217    ,
 0.262187895752    , 0.232796095186    , 0.202044901279    , 0.171112851492    ,
 0.141887720154    , 0.120708939493    , 0.113372234473    , 0.117962885431    ,
 0.124248632754    , 0.121207879291    , 0.106209793291    , 0.0865121967786   ,
 0.0707550746978   , 0.0601915755906   , 0.0499189411608   , 0.0367288037378   ,
 0.0226314250446   , 0.0114313159186   , 0.00472773629753  , 0.00161542415611  ,
 0.000461994153203 , 0.000111807566689 , 2.2973609354e-05  , 3.98218857882e-06 ,
 5.74700228613e-07 , 6.80515486118e-08 , 6.53111564538e-09 , 5.16347553635e-10 ,
 3.25027161506e-10 , 5.23470287685e-09 , 7.26225319254e-08 , 7.8601928951e-07  ,
 6.63774787598e-06 , 4.3756566925e-05  , 0.000225299236205 , 0.000906750985815 ,
 0.00285506850278  , 0.00704083027517  , 0.0136184626864   , 0.0207031112374   ,
 0.0248322204518   , 0.0237119076793   , 0.0184569756705   , 0.0124247927705   ,
 0.0080731940443   , 0.00555153854859  , 0.00386921715922  , 0.00242194159886  ,
 0.00125151097635  , 0.00051451091271  , 0.000166012901053 , 4.18415548557e-05 ,
 8.22374963993e-06 , 1.25977348227e-06 , 1.50414459817e-07 , 1.40152771363e-08 ,
 1.03225475515e-09 , 8.24499083926e-11 , 1.18791020187e-10 , 8.21409438383e-10 ,
 5.64310083262e-09 , 3.3533320342e-08  , 1.64270709948e-07 , 6.47377977354e-07 ,
 2.0281520667e-06  , 5.02662349024e-06 , 9.84799688071e-06 , 1.52885398967e-05 ,
 1.89895885604e-05 , 1.98784584199e-05 , 2.35517967042e-05 , 5.83460476822e-05 ,
 0.000230993350747 , 0.000874757410343 , 0.00280181186404  , 0.00743232583798  ,
 0.0162089700915   , 0.0290121374734   , 0.0430185212888   , 0.0546323030226   ,
 0.0643286568844   , 0.079988826844    , 0.115266204482    , 0.184225209696    ,
 0.296331209131    , 0.456804576591    , 0.670795576411    , 0.935329738109    ,
 1.21291946984     , 1.42368096332     , 1.49248613589     , 1.41039829981     ,
 1.23483816093     , 1.0340280106      , 0.848226243109    , 0.693116169844    ,
 0.571096780135    , 0.473416327624    , 0.386340788471    , 0.302470634393    ,
 0.223785526895    , 0.155220822732    , 0.0996010824637   , 0.057874793917    ,
 0.0298737836879   , 0.0136158148247   , 0.00552255934388  , 0.0020129289632   ,
 0.000656694239163 , 0.000187775008905 , 4.6024715489e-05  , 9.83918671603e-06 ,
 2.21756967585e-06 , 8.01150286253e-07 , 4.23567531546e-07 , 2.13313683008e-07 ,
 8.72356992399e-08 , 2.8536698686e-08  , 9.90097062436e-09 , 1.32017298334e-08 ,
 3.83780761176e-08 , 9.69391401356e-08 , 1.9390379917e-07  , 3.06117149186e-07 ,
 3.81784133238e-07 , 3.76479411517e-07 , 2.93658402559e-07 , 1.81176006142e-07 ,
 8.83673827503e-08 , 3.40420255457e-08 , 1.03451463586e-08 , 2.47651015137e-09 ,
 4.66317335339e-10 , 6.89703186106e-11 , 8.01104734071e-12 , 7.41204544722e-13 ,
 6.55536048868e-14 , 1.34890305823e-14 , 6.55261640417e-15 , 3.08308210942e-15 ,
 1.16742477079e-15 , 3.57449370442e-16 , 1.34289166412e-16 , 3.21447212622e-16 ,
 1.64068154963e-15 , 7.75119499925e-15 , 3.65303131823e-14 , 2.24684182237e-13 ,
 1.80362020729e-12 , 1.41611557712e-11 , 9.26751006138e-11 , 4.8710588304e-10  ,
 2.07827769597e-09 , 7.54285843566e-09 , 2.55856271772e-08 , 9.09838443609e-08 ,
 2.4450923584e-06  , 8.56093858811e-06 , 2.96712903388e-05 , 9.51723150071e-05 ,
 0.00026924111173  , 0.000653490326666 , 0.00135862054336  , 0.00249594591255  ,
 0.00432056692519  , 0.00754225965631  , 0.0134933387774   , 0.023736076742    ,
 0.0392234768737   , 0.0600317421524   , 0.0867352170872   , 0.122444281402    ,
 0.172178909286    , 0.238470512123    , 0.317788310702    , 0.401640125693    ,
 0.478378805603    , 0.532280023522    , 0.546953459412    , 0.517651575172    ,
 0.458681559252    , 0.392010971499    , 0.329543610215    , 0.271303190898    ,
 0.217409048765    , 0.174036336388    , 0.146812378551    , 0.132988056089    ,
 0.12261136097     , 0.107028296197    , 0.0858938795498   , 0.0659148707936   ,
 0.052871781501    , 0.0457866547606   , 0.0393585858207   , 0.0303752860577   ,
 0.0200442664017   , 0.0112061305659   , 0.00533910434313  , 0.00217690953821  ,
 0.000755289920653 , 0.000219740425858 , 5.26670997696e-05 , 1.02405057339e-05 ,
 1.59773712627e-06 , 1.98682386623e-07 , 1.96194989417e-08 , 1.54291901171e-09 ,
 2.59726694427e-10 , 2.93262579998e-09 , 4.06322430119e-08 , 4.39775727592e-07 ,
 3.71380841865e-06 , 2.44818463588e-05 , 0.000126057174029 , 0.000507362090137 ,
 0.00159778286376  , 0.00394235181292  , 0.00763842901583  , 0.0116763144498   ,
 0.01425145794     , 0.0143455058123   , 0.0128702365361   , 0.0116394077077   ,
 0.0112647121703   , 0.0106879961675   , 0.00881165473711  , 0.00589974203099  ,
 0.00312298441768  , 0.00129466804661  , 0.00041896801839  , 0.000105718478202 ,
 2.07942342809e-05 , 3.18914667211e-06 , 3.81919193583e-07 , 3.60127364988e-08 ,
 2.92530865118e-09 , 5.71085134422e-10 , 1.32482319094e-09 , 7.15111771345e-09 ,
 4.24916549033e-08 , 2.32512504832e-07 , 1.08897616965e-06 , 4.19488283038e-06 ,
 1.30089132647e-05 , 3.21515323989e-05 , 6.31257641623e-05 , 9.86095148653e-05 ,
 0.000123508567703 , 0.000127831679223 , 0.000126616193018 , 0.000192032009713 ,
 0.000540861790332 , 0.00173176236837  , 0.00490990020544  , 0.0117629798892   ,
 0.0237198969944   , 0.0406002253457   , 0.0603930295746   , 0.0819934763377   ,
 0.109766536966    , 0.156054892106    , 0.239148330428    , 0.37701904785     ,
 0.580443672502    , 0.853786734165    , 1.20252954272     , 1.62318299144     ,
 2.06491490188     , 2.41342706753     , 2.55016899077     , 2.43991318671     ,
 2.14773529318     , 1.77711612169     , 1.40956789005     , 1.09015918185     ,
 0.835387360901    , 0.640968400958    , 0.492397543408    , 0.376405596614    ,
 0.283989643886    , 0.207767037138    , 0.142808257749    , 0.0892393025102   ,
 0.0498283532137   , 0.0249220409939   , 0.0112793203397   , 0.0046119405917   ,
 0.00166823130452  , 0.000519133798318 , 0.000137868143127 , 3.40353180892e-05 ,
 1.09814878576e-05 , 5.8737692149e-06  , 3.56327532739e-06 , 1.84259807022e-06 ,
 7.56958904472e-07 , 2.48030214935e-07 , 8.71712366871e-08 , 1.19499193756e-07 ,
 3.48933902526e-07 , 8.81576989524e-07 , 1.76340530202e-06 , 2.78390045601e-06 ,
 3.47203366275e-06 , 3.42379129365e-06 , 2.6705977838e-06  , 1.64765672051e-06 ,
 8.03633523405e-07 , 3.09586097935e-07 , 9.40811798568e-08 , 2.25220030889e-08 ,
 4.24090865241e-09 , 6.27449848318e-10 , 7.31926137187e-11 , 7.15528044886e-12 ,
 9.97477234337e-13 , 4.29794341088e-13 , 2.45552387782e-13 , 1.17220499593e-13 ,
 4.46413336912e-14 , 1.39425955166e-14 , 5.31974870005e-15 , 1.07453926112e-14 ,
 4.99984134151e-14 , 2.20979007891e-13 , 8.86545768564e-13 , 3.91510852808e-12 ,
 2.37060018962e-11 , 1.67113451809e-10 , 1.06032188037e-09 , 5.49376764716e-09 ,
 2.29582538079e-08 , 7.9492486281e-08  , 2.44294126126e-07 , 7.43774019316e-07 ,
 1.49063897075e-05 , 4.51716449997e-05 , 0.000140366900618 , 0.000417406231088 ,
 0.00112718764054  , 0.00267305704304  , 0.00550580427592  , 0.0100114700876   ,
 0.0167558870486   , 0.0270970277231   , 0.0433235216283   , 0.0676480477114   ,
 0.101192759131    , 0.145199607691    , 0.204322902033    , 0.287607997426    ,
 0.402911659705    , 0.547958678341    , 0.707097451674    , 0.856530125394    ,
 0.970558088528    , 1.02488940349     , 1.00419200574     , 0.915350078118    ,
 0.789485399527    , 0.661368586434    , 0.546322591365    , 0.441329315583    ,
 0.3436808257      , 0.259949170587    , 0.197759770044    , 0.155876092274    ,
 0.125080055604    , 0.0969235752162   , 0.0701687042081   , 0.0491430564987   ,
 0.0371086856987   , 0.0322317203319   , 0.0296350447928   , 0.0257455883732   ,
 0.019972919331    , 0.0135177138446   , 0.00782604894504  , 0.00378912408882  ,
 0.00150201364867  , 0.000479705709028 , 0.000122163793218 , 2.46616921788e-05 ,
 3.93522505599e-06 , 4.95838308821e-07 , 4.93341896626e-08 , 3.88130081731e-09 ,
 3.13410803384e-10 , 1.30028706297e-09 , 1.78805276406e-08 , 1.93522997687e-07 ,
 1.63427052884e-06 , 1.07735417545e-05 , 5.54770297962e-05 , 0.000223338573953 ,
 0.000703858792262 , 0.00174085281775  , 0.00339898095209  , 0.00532325503936  ,
 0.00698384453771  , 0.00846032203784  , 0.0107273675255   , 0.0144543654334   ,
 0.0183906131859   , 0.0197975582637   , 0.0171104820188   , 0.0116443010572   ,
 0.0061982244397   , 0.00257474142875  , 0.000834058618162 , 0.00021069789517  ,
 4.15405237173e-05 , 6.40861807837e-06 , 7.81072975918e-07 , 7.9850299215e-08  ,
 1.10993913242e-08 , 6.98113475304e-09 , 1.48867380094e-08 , 5.89534596309e-08 ,
 2.86811399975e-07 , 1.38570273551e-06 , 6.02676508692e-06 , 2.22962551044e-05 ,
 6.78084948716e-05 , 0.000166455766248 , 0.000327346481859 , 0.000515676439524 ,
 0.000655600333958 , 0.000689428955569 , 0.000656786683882 , 0.000759643929503 ,
 0.00147594828835  , 0.00379711554247  , 0.00941874067992  , 0.0204153390396   ,
 0.038235743519    , 0.0630405047383   , 0.0951244135822   , 0.138565131477    ,
 0.204663366853    , 0.31285328026     , 0.48810682279     , 0.753374377624    ,
 1.1206976931      , 1.59384064027     , 2.17980735583     , 2.87313917163     ,
 3.60021820648     , 4.19287770007     , 4.46252625189     , 4.32290939186     ,
 3.83844271336     , 3.16490280616     , 2.45911198205     , 1.82751569221     ,
 1.31841047811     , 0.936312603564    , 0.663410409157    , 0.475797140984    ,
 0.348314030029    , 0.256241871921    , 0.182042507797    , 0.120316387788    ,
 0.0729182287152   , 0.0406166820195   , 0.0207201869688   , 0.0094624176401   ,
 0.00374430307851  , 0.00125634886349  , 0.000367125871624 , 0.00011376125524  ,
 5.49617576687e-05 , 3.73328063638e-05 , 2.40016832172e-05 , 1.25420772951e-05 ,
 5.1623785041e-06  , 1.69399296213e-06 , 6.04310818151e-07 , 8.54308659698e-07 ,
 2.50642005739e-06 , 6.33400103728e-06 , 1.26699532887e-05 , 2.00021555409e-05 ,
 2.4946351374e-05  , 2.45997329009e-05 , 1.91880831909e-05 , 1.18383136624e-05 ,
 5.7740581706e-06  , 2.22435744793e-06 , 6.75967983632e-07 , 1.61820533237e-07 ,
 3.04739461479e-08 , 4.51464571336e-09 , 5.35912475888e-10 , 6.36959202973e-11 ,
 1.90547217097e-11 , 1.21825580859e-11 , 7.26984039888e-12 , 3.48351296002e-12 ,
 1.33126261858e-12 , 4.22016079625e-13 , 1.64422115657e-13 , 2.90819332266e-13 ,
 1.22149157348e-12 , 5.11319150117e-12 , 1.88681407864e-11 , 6.64812552345e-11 ,
 2.86862925613e-10 , 1.64894231003e-09 , 9.78170012932e-09 , 4.95864689688e-08 ,
 2.03935617713e-07 , 6.85330153743e-07 , 1.97073569044e-06 , 5.31046937582e-06 ,
 8.0748998056e-05  , 0.000212106056234 , 0.000586501946296 , 0.00160221316001  ,
 0.00409015638263  , 0.00940058462415  , 0.0191121942086   , 0.0345562020077   ,
 0.0570441598302   , 0.0889238413865   , 0.133624600571    , 0.193660939213    ,
 0.269986583468    , 0.366841176054    , 0.498039202781    , 0.683124242093    ,
 0.93009027156     , 1.21961743032     , 1.50750485052     , 1.74170214362     ,
 1.87796447377     , 1.88925471288     , 1.77477695049     , 1.56637486798     ,
 1.31884408765     , 1.08140946207     , 0.873621138373    , 0.690014488357    ,
 0.523926428676    , 0.380293364232    , 0.267959282597    , 0.187831745067    ,
 0.131654771847    , 0.0897873891788   , 0.0578046052815   , 0.036055607324    ,
 0.0250274835172   , 0.0224653469751   , 0.0241304629117   , 0.025775301347    ,
 0.0244840497741   , 0.0195935817531   , 0.0128156299543   , 0.00672722627176  ,
 0.00280415135133  , 0.000922937090076 , 0.000239219383912 , 4.87871397657e-05 ,
 7.83049746878e-06 , 9.89915269605e-07 , 9.86749834732e-08 , 7.76566031105e-09 ,
 5.07897002146e-10 , 4.7033546853e-10  , 6.19848279845e-09 , 6.70793585629e-08 ,
 5.6649279599e-07  , 3.73485441675e-06 , 1.92384512242e-05 , 7.75306507558e-05 ,
 0.000245159220531 , 0.0006128748029   , 0.00123734106969  , 0.00213575141639  ,
 0.00353932261831  , 0.00630408416149  , 0.0116681786754   , 0.0196615686301   ,
 0.0274648275559   , 0.0305606655878   , 0.0267085813586   , 0.0182458463438   ,
 0.00972763863649  , 0.00404598832028  , 0.00131351836197  , 0.000333480812381 ,
 6.65568340503e-05 , 1.05968528865e-05 , 1.4223710423e-06  , 2.17641608304e-07 ,
 8.81707414444e-08 , 8.99159129694e-08 , 1.6034905475e-07  , 4.69153493569e-07 ,
 1.7967391385e-06  , 7.36218388887e-06 , 2.87316644222e-05 , 9.95861680129e-05 ,
 0.000292628821116 , 0.000708325289711 , 0.00139243927301  , 0.00221613165104  ,
 0.00287588784698  , 0.00311776813955  , 0.00303527663608  , 0.00321978065062  ,
 0.00482198492694  , 0.00972202755422  , 0.0206179142409   , 0.0404922767437   ,
 0.0716517599864   , 0.116035254069    , 0.178263113893    , 0.269955736163    ,
 0.41236498631     , 0.636628994766    , 0.980242000074    , 1.47548806087     ,
 2.13694270139     , 2.96812587933     , 3.97748227982     , 5.15016348418     ,
 6.36700482706     , 7.36883947294     , 7.85577636882     , 7.65993409871     ,
 6.8406042854      , 5.6348441794      , 4.32649044356     , 3.13381453667     ,
 2.16704903615     , 1.4466343971      , 0.94474106185     , 0.616869413137    ,
 0.414131796995    , 0.289033891445    , 0.205091881846    , 0.142991387574    ,
 0.0957440656992   , 0.0603352377718   , 0.0346267349067   , 0.0173888466706   ,
 0.0074113601127   , 0.0026747061      , 0.000891710544208 , 0.000376561084308 ,
 0.000253559038896 , 0.000194366914681 , 0.000128103569592 , 6.72480628438e-05 ,
 2.77087136426e-05 , 9.10701778827e-06 , 3.30454169247e-06 , 4.82858653292e-06 ,
 1.42356353524e-05 , 3.59840017958e-05 , 7.19799075977e-05 , 0.000113635306616 ,
 0.000141724042709 , 0.000139754850188 , 0.000109010439375 , 6.72552730903e-05 ,
 3.28033092538e-05 , 1.2636917681e-05  , 3.84028715856e-06 , 9.19357571133e-07 ,
 1.73203169502e-07 , 2.57982111376e-08 , 3.27718797843e-09 , 6.46688723704e-10 ,
 3.83727367807e-10 , 2.79869811449e-10 , 1.68811769673e-10 , 8.10255436427e-11 ,
 3.11246078836e-11 , 1.00928195854e-11 , 4.1350932305e-12  , 6.55238887639e-12 ,
 2.41955177092e-11 , 9.49715604767e-11 , 3.3280642906e-10  , 1.03750760118e-09 ,
 3.37075542665e-09 , 1.44157905474e-08 , 7.46492094496e-08 , 3.62291022366e-07 ,
 1.46318870011e-06 , 4.81994304514e-06 , 1.32943418466e-05 , 3.28726593447e-05 ,
 0.000390363010134 , 0.000903225914268 , 0.00222028340883  , 0.00553686222702  ,
 0.0132448202595   , 0.0292131212378   , 0.0581383673419   , 0.104129273737    ,
 0.170347291612    , 0.260393734437    , 0.378345549372    , 0.525838353949    ,
 0.70277051998     , 0.917899690203    , 1.1982036421      , 1.57475582024     ,
 2.04629426449     , 2.55652495633     , 3.01199962359     , 3.32175734614     ,
 3.42622831204     , 3.30983929106     , 3.00427390447     , 2.57963393171     ,
 2.12033019114     , 1.69349913036     , 1.32791696115     , 1.0193322871      ,
 0.755367297871    , 0.533606264339    , 0.359014124743    , 0.232304151591    ,
 0.145569455947    , 0.087463566558    , 0.0494754663534   , 0.0271165753999   ,
 0.0175631097417   , 0.0177434893866   , 0.0236893945043   , 0.0303140863605   ,
 0.0325113523792   , 0.0280486249728   , 0.0191799262293   , 0.0103291557709   ,
 0.00436865101825  , 0.00144969666939  , 0.000377475635902 , 7.71770724995e-05 ,
 1.24035746011e-05 , 1.56902680565e-06 , 1.5643641863e-07  , 1.23098469757e-08 ,
 7.72160087539e-10 , 1.59731223543e-10 , 1.69599238407e-09 , 1.83416508851e-08 ,
 1.54920071355e-07 , 1.02185594384e-06 , 5.27141899276e-06 , 2.13438313782e-05 ,
 6.85046916985e-05 , 0.000179301640568 , 0.000411684556567 , 0.000944191555498 ,
 0.00235430451518  , 0.00590303737844  , 0.0130450740305   , 0.0235386661466   ,
 0.0336565886838   , 0.0377424339122   , 0.0330791167495   , 0.0226352932218   ,
 0.0120946795334   , 0.00505404379554  , 0.00165871249136  , 0.000432106408922 ,
 9.16484620749e-05 , 1.68567782903e-05 , 3.27034703822e-06 , 1.14116309444e-06 ,
 8.77446096036e-07 , 9.85721853687e-07 , 1.5595331921e-06  , 3.56412046516e-06 ,
 1.06220989523e-05 , 3.58932393931e-05 , 0.00012202458618  , 0.000385672410205 ,
 0.00107354871616  , 0.00253344880259  , 0.00495608902903  , 0.00797302831735  ,
 0.0106066750687   , 0.0119571354266   , 0.0121879707016   , 0.0129639076856   ,
 0.0171992455395   , 0.0286940546749   , 0.0519152842258   , 0.0916694549086   ,
 0.153034932756    , 0.242858034226    , 0.373190631609    , 0.565110340327    ,
 0.852127508286    , 1.28307092204     , 1.91736541921     , 2.80407375609     ,
 3.96190585344     , 5.39236341304     , 7.10150275419     , 9.05044372054     ,
 11.0378221304     , 12.6577235242     , 13.4437922443     , 13.1150246373     ,
 11.7315320655     , 9.65513880141     , 7.36366979693     , 5.25323760914     ,
 3.53855135201     , 2.26763997335     , 1.39245478148     , 0.831077549211    ,
 0.49765962122     , 0.313238918264    , 0.214092961067    , 0.157083240577    ,
 0.117359059933    , 0.0832399832941   , 0.0526200625614   , 0.0284060383775   ,
 0.0128647013659   , 0.00502716473634  , 0.00201765885298  , 0.00119273350626  ,
 0.000997767853496 , 0.000810588522641 , 0.000540383354861 , 0.000284354031053 ,
 0.000117274415291 , 3.86267275286e-05 , 1.4284362215e-05  , 2.15917043358e-05 ,
 6.39574852758e-05 , 0.000161705547161 , 0.00032346782706  , 0.000510661674809 ,
 0.000636888657898 , 0.000628039373469 , 0.00048987815438  , 0.000302236092116 ,
 0.00014741363865  , 5.67886399599e-05 , 1.72579039732e-05 , 4.13202072169e-06 ,
 7.79734380665e-07 , 1.18657494502e-07 , 1.89535745021e-08 , 8.07870778015e-09 ,
 6.72442619516e-09 , 5.079505827e-09   , 3.07193521162e-09 , 1.47711086707e-09 ,
 5.72113392705e-10 , 1.92051009523e-10 , 8.52893069926e-11 , 1.24280500585e-10 ,
 3.93966250132e-10 , 1.41879325901e-09 , 4.7420094715e-09  , 1.3866119315e-08  ,
 3.78015008872e-08 , 1.19240824857e-07 , 4.93459675031e-07 , 2.19245645287e-06 ,
 8.58605555844e-06 , 2.78000935672e-05 , 7.47868088563e-05 , 0.000175287421423 ,
 0.00168632841216  , 0.00354228727775  , 0.00781904585758  , 0.0177625926701   ,
 0.0395257993455   , 0.0827737619417   , 0.159364978927    , 0.280010060976    ,
 0.451981443966    , 0.679979822075    , 0.96646350751     , 1.30911642637     ,
 1.70413215282     , 2.16229098651     , 2.71883651613     , 3.40509024572     ,
 4.19120387695     , 4.96202811663     , 5.56199266113     , 5.86577639607     ,
 5.81815693448     , 5.43880423201     , 4.80836293621     , 4.04066753242     ,
 3.25027959268     , 2.52638287572     , 1.91583372034     , 1.42238939459     ,
 1.02685938106     , 0.711598092262    , 0.468414692473    , 0.291466967937    ,
 0.170770505064    , 0.0932971497835   , 0.0470059193439   , 0.0227378039935   ,
 0.0140177922561   , 0.016261230965    , 0.0251981218449   , 0.035031436908    ,
 0.0392312669244   , 0.034633951623    , 0.0239773942416   , 0.0129982896761   ,
 0.00551651676455  , 0.00183368880592  , 0.000477781059029 , 9.76915104033e-05 ,
 1.56955749281e-05 , 1.98431116608e-06 , 1.97690516283e-07 , 1.55419344468e-08 ,
 9.66922389416e-10 , 7.39125365261e-11 , 3.67903792745e-10 , 3.9620771305e-09  ,
 3.34865285157e-08 , 2.2134399766e-07  , 1.14945657622e-06 , 4.75197092603e-06 ,
 1.62379494526e-05 , 5.02140064184e-05 , 0.000160789853249 , 0.000556832360406 ,
 0.00186690307188  , 0.00536962222319  , 0.0124734790449   , 0.022884152221    ,
 0.0329065416436   , 0.0369958340809   , 0.0325060224609   , 0.0223466296267   ,
 0.0120642938721   , 0.00516182814223  , 0.00178701549231  , 0.000522179614329 ,
 0.000138367575701 , 3.71299431574e-05 , 1.28346199539e-05 , 7.96110202009e-06 ,
 7.57744782712e-06 , 8.8061296037e-06  , 1.30675186255e-05 , 2.50416429154e-05 ,
 5.91742806151e-05 , 0.000162704541443 , 0.000473164694947 , 0.00133570014736  ,
 0.00345274454665  , 0.00783070575281  , 0.0151281617277   , 0.0245449995134   ,
 0.0335176044647   , 0.0394162717435   , 0.0423324519182   , 0.0464703769202   ,
 0.0590088796746   , 0.0878326793253   , 0.140282756727    , 0.224026818308    ,
 0.349845187657    , 0.534660521834    , 0.802580757369    , 1.18542993978     ,
 1.72900641686     , 2.50399289559     , 3.60094279793     , 5.09358589754     ,
 7.00530782951     , 9.32984402525     , 12.0609562706     , 15.1142927485     ,
 18.1618413        , 20.5879836769     , 21.7049836402     , 21.0991087822     ,
 18.853012844      , 15.5047038599     , 11.7921847586     , 8.35428529086     ,
 5.55550534736     , 3.48646323365     , 2.06902977007     , 1.16465629134     ,
 0.633809948964    , 0.354028652361    , 0.224335804837    , 0.168634054461    ,
 0.137263019447    , 0.106057108972    , 0.0715462626828   , 0.0406182096363   ,
 0.019379211202    , 0.00835299814584  , 0.0042689960675   , 0.00339137766051  ,
 0.0032149619862   , 0.00268761915481  , 0.00180242152488  , 0.000950202036991 ,
 0.000392486684118 , 0.000129710850222 , 4.89660916243e-05 , 7.64224825606e-05 ,
 0.000227289097518 , 0.000574763840506 , 0.00114973628453  , 0.00181509957621  ,
 0.00226376166179  , 0.0022323076982   , 0.00174122646464  , 0.00107427017934  ,
 0.000523968233338 , 0.000201850575535 , 6.13441059063e-05 , 1.46947798132e-05 ,
 2.79123879343e-06 , 4.60620959213e-07 , 1.27627828086e-07 , 1.024137326e-07   ,
 9.50932741315e-08 , 7.24439702522e-08 , 4.38488914506e-08 , 2.11449771964e-08 ,
 8.29895557329e-09 , 2.93219811039e-09 , 1.44977110748e-09 , 1.99059775362e-09 ,
 5.35196005921e-09 , 1.72168468286e-08 , 5.42673238209e-08 , 1.52157755137e-07 ,
 3.78760625401e-07 , 9.55276058601e-07 , 3.00702467549e-06 , 1.14433492279e-05 ,
 4.22281056541e-05 , 0.000133535153159 , 0.000353336138929 , 0.000804617492911 ,
 0.00652090781818  , 0.0128761306209   , 0.0260664822339   , 0.0541996426474   ,
 0.111725157733    , 0.220075523323    , 0.404743092377    , 0.688622097426    ,
 1.08607645606     , 1.60174469597     , 2.23138521911     , 2.96214340178     ,
 3.77896600633     , 4.68109402791     , 5.68698233921     , 6.79529803631     ,
 7.91995159988     , 8.87774732439     , 9.46586650654     , 9.55962919549     ,
 9.15013020732     , 8.3228101979      , 7.21430037043     , 5.97089110837     ,
 4.72531513313     , 3.5886866917      , 2.63580399588     , 1.88845442711     ,
 1.32323515144     , 0.900954834968    , 0.588789546689    , 0.363908624565    ,
 0.209149650676    , 0.109694307609    , 0.0517712019517   , 0.0228689453207   ,
 0.0130231651059   , 0.0154980691228   , 0.0251542662045   , 0.0357903852222   ,
 0.0405033968771   , 0.0359245588508   , 0.0249165176455   , 0.0135119415131   ,
 0.00573155090068  , 0.0019031422739   , 0.000495149105996 , 0.000101058418488 ,
 1.62015517577e-05 , 2.04320446912e-06 , 2.02993168053e-07 , 1.59137459845e-08 ,
 9.89880552932e-10 , 5.69721896779e-11 , 6.78129939963e-11 , 6.80877142319e-10 ,
 5.74775609422e-09 , 3.83270150536e-08 , 2.04882462511e-07 , 9.22041492873e-07 ,
 3.8917002032e-06  , 1.74789834971e-05 , 8.31502683505e-05 , 0.000368533344766 ,
 0.00137144482944  , 0.00409063008682  , 0.00961794328229  , 0.0177268406692   ,
 0.0255723353273   , 0.0288919755825   , 0.0256488967815   , 0.0180404540432   ,
 0.0102414277802   , 0.00486770823377  , 0.00205206553361  , 0.000813160244494 ,
 0.000311384282428 , 0.000121551951242 , 6.1848975331e-05  , 5.05500856987e-05 ,
 5.31477979939e-05 , 6.36274307388e-05 , 9.1735731512e-05  , 0.000156848464728 ,
 0.0003066320689   , 0.000687659299755 , 0.00169452397108  , 0.00422694800092  ,
 0.0100079819655   , 0.021514342405    , 0.0406288230881   , 0.0660835191454   ,
 0.0923290878368   , 0.112948547589    , 0.127348930385    , 0.144772033694    ,
 0.181313716563    , 0.252675746807    , 0.370183051515    , 0.544968040236    ,
 0.797320219961    , 1.16149895111     , 1.67933856523     , 2.39228517929     ,
 3.35209341639     , 4.64710555691     , 6.40127712226     , 8.71797319117     ,
 11.6255036114     , 15.1016166456     , 19.1115060748     , 23.4997458218     ,
 27.7745019599     , 31.0698866441     , 32.4533977598     , 31.3856009091     ,
 27.9999891639     , 23.0437504834     , 17.5493340553     , 12.4366610538     ,
 8.25457990867     , 5.15368997718     , 3.02419976102     , 1.66015919213     ,
 0.856503319276    , 0.435914791159    , 0.249679039261    , 0.181043354023    ,
 0.151391460857    , 0.12177259491     , 0.0850775173536   , 0.0499440605241   ,
 0.0250591556896   , 0.0123075590274   , 0.00829543416672  , 0.00820964311673  ,
 0.00833633086902  , 0.00707514573801  , 0.00476442437349  , 0.00251836355123  ,
 0.00104383126979  , 0.000347183484286 , 0.00013392193493  , 0.000214226687103 ,
 0.000638613087846 , 0.00161498132789  , 0.0032305364631   , 0.00510007523839  ,
 0.00636072758411  , 0.00627234806841  , 0.00489250592763  , 0.00301848948335  ,
 0.00147224986613  , 0.000567167837149 , 0.000172393094767 , 4.13783155465e-05 ,
 8.06459672807e-06 , 1.73024031874e-06 , 1.03398409815e-06 , 1.11304661208e-06 ,
 1.06377458841e-06 , 8.11834470797e-07 , 4.91765814853e-07 , 2.38294207379e-07 ,
 9.55043802266e-08 , 3.62980612996e-08 , 2.03651447793e-08 , 2.68135528384e-08 ,
 6.13656613532e-08 , 1.72216270729e-07 , 5.01551226287e-07 , 1.3499504921e-06  ,
 3.2058070283e-06  , 7.12382356828e-06 , 1.76744347899e-05 , 5.452691474e-05   ,
 0.000181298271754 , 0.000549704282237 , 0.00142913088394  , 0.00320800723471  ,
 0.0227233395834   , 0.0433201568392   , 0.0823553852567   , 0.158452427214    ,
 0.302746569469    , 0.557877810155    , 0.970536972272    , 1.57961858642     ,
 2.40674544353     , 3.45314184833     , 4.70047728477     , 6.11387928094     ,
 7.64860089419     , 9.25839490276     , 10.8924150732     , 12.4632639205     ,
 13.8050463098     , 14.6894272641     , 14.9255764883     , 14.460639705      ,
 13.3906122762     , 11.8935892577     , 10.1526744722     , 8.31696181765     ,
 6.51230640009     , 4.86397336463     , 3.48051832203     , 2.41175895016     ,
 1.63656628693     , 1.09245450356     , 0.712328566199    , 0.444842678754    ,
 0.258642123478    , 0.13601555075     , 0.0634186410229   , 0.0269340573345   ,
 0.0137983599852   , 0.0147987131398   , 0.0234452095658   , 0.0332236942786   ,
 0.0374989930151   , 0.0331592379244   , 0.0229218448694   , 0.0123856762277   ,
 0.0052334337543   , 0.00173032351376  , 0.000448029688299 , 9.09440151406e-05 ,
 1.44895541422e-05 , 1.81444914992e-06 , 1.78901684495e-07 , 1.39943211757e-08 ,
 9.65280441636e-10 , 1.43903845029e-10 , 9.2307957907e-11  , 1.75243806152e-10 ,
 9.21786964879e-10 , 5.72886452485e-09 , 3.33086816177e-08 , 1.9284363028e-07  ,
 1.21212592873e-06 , 7.81926723703e-06 , 4.5369218465e-05  , 0.000217426075388 ,
 0.000830958186307 , 0.00250168923618  , 0.005910168456    , 0.0109541913918   ,
 0.0159737159122   , 0.0184701042657   , 0.0172302759292   , 0.0134097232208   ,
 0.00916798259938  , 0.00579142456849  , 0.00342065919074  , 0.0018327674609   ,
 0.000877988525014 , 0.000421012815325 , 0.000275755623895 , 0.000267567026874 ,
 0.000301339779639 , 0.000372760428983 , 0.000533017265602 , 0.000850005578285 ,
 0.00144818766284  , 0.00271023512508  , 0.0056465926095   , 0.0123824374067   ,
 0.0266739748044   , 0.0538058403481   , 0.0982431536231   , 0.158680336088    ,
 0.225029252928    , 0.284129813987    , 0.333418678527    , 0.390555837229    ,
 0.487308808296    , 0.652046944344    , 0.900200695857    , 1.24567831179     ,
 1.72253681758     , 2.3908492794      , 3.3146349165      , 4.53756801716     ,
 6.09903869841     , 8.08528043254     , 10.6421908784     , 13.9019340623     ,
 17.9008637631     , 22.5971949748     , 27.9126414876     , 33.6029729892     ,
 39.0092893161     , 43.0373909481     , 44.5481299512     , 42.9051629136     ,
 38.2912073261     , 31.6345780158     , 24.234607086      , 17.2887964749     ,
 11.549342233      , 7.25031617066     , 4.26647686773     , 2.33272528111     ,
 1.17949982528     , 0.568597967093    , 0.294455793628    , 0.19314365268     ,
 0.154592575532    , 0.1237392814      , 0.0872797204835   , 0.052308974039    ,
 0.0277736677634   , 0.0162232643368   , 0.0143499207494   , 0.0164072973107   ,
 0.0173021136224   , 0.0148251797456   , 0.0100323867226   , 0.00533320680236  ,
 0.00222946805274  , 0.000751739548542 , 0.000296199070191 , 0.000476361850032 ,
 0.00141757348517  , 0.00358388196828  , 0.00716883391426  , 0.0113174680604   ,
 0.0141149505186   , 0.0139188293805   , 0.0108568536282   , 0.00669826872257  ,
 0.00326705457274  , 0.00125865735223  , 0.000382807120199 , 9.26116671507e-05 ,
 1.98597323812e-05 , 7.69337454533e-06 , 8.25690838007e-06 , 9.74794896984e-06 ,
 9.37915816179e-06 , 7.1590645277e-06  , 4.34274934699e-06 , 2.12153135237e-06 ,
 8.78383694478e-07 , 3.68603764857e-07 , 2.36468105159e-07 , 3.01314353856e-07 ,
 5.96654924723e-07 , 1.44329574266e-06 , 3.79250450397e-06 , 9.69354420878e-06 ,
 2.23232987143e-05 , 4.66779437855e-05 , 9.94196255837e-05 , 0.000249486387149 ,
 0.000717060227532 , 0.00202473473777  , 0.00511092861772  , 0.0113367613792   ,
 0.0723433367952   , 0.134669264928    , 0.244308185752    , 0.440008053167    ,
 0.782428031966    , 1.34732263566     , 2.20681528123     , 3.40979094184     ,
 4.97473556597     , 6.89188390644     , 9.12209048659     , 11.5918908241     ,
 14.1897706381     , 16.7634917076     , 19.121649635      , 21.0403985866     ,
 22.278103434      , 22.6260552343     , 22.0030546325     , 20.5193724376     ,
 18.4316580239     , 16.0199744982     , 13.4884690594     , 10.9549208122     ,
 8.51392578742     , 6.29165171652     , 4.4240775457      , 2.98881620713     ,
 1.97125092301     , 1.28851938177     , 0.836454914603    , 0.528462490778    ,
 0.313182862277    , 0.167727028356    , 0.0792494429993   , 0.0336747472516   ,
 0.0162145941196   , 0.0152965047679   , 0.0228461856208   , 0.031746189094    ,
 0.0354470720398   , 0.0310795470031   , 0.0213189083937   , 0.0114327461177   ,
 0.00479310843125  , 0.00157135801702  , 0.000403022502569 , 8.0923476092e-05  ,
 1.27321555701e-05 , 1.57199027905e-06 , 1.53630419048e-07 , 1.35136635192e-08 ,
 2.83136829117e-09 , 1.95528765634e-09 , 1.55111459552e-09 , 1.5639726814e-09  ,
 2.50730939099e-09 , 4.95318392872e-09 , 1.24504908091e-08 , 6.12928453102e-08 ,
 4.69772808676e-07 , 3.48768850711e-06 , 2.14107337626e-05 , 0.000104659597706 ,
 0.000403310437011 , 0.00122270879533  , 0.00292275602827  , 0.00555038086729  ,
 0.00851581568901  , 0.0108971637919   , 0.0121954415864   , 0.0124853132541   ,
 0.011801639425    , 0.00996603873201  , 0.00720034125315  , 0.00436194849     ,
 0.00231132047967  , 0.00130672191438  , 0.00106356389386  , 0.00116756211657  ,
 0.00139186348832  , 0.00178585634994  , 0.00256138833006  , 0.00391677132711  ,
 0.00609399654819  , 0.00991770504795  , 0.0176949406558   , 0.0340580775733   ,
 0.0665083738281   , 0.125039461226    , 0.218507994872    , 0.346487037684    ,
 0.493201301331    , 0.635829045673    , 0.768394377848    , 0.920551778268    ,
 1.14676977141     , 1.492047143       , 1.97370019324     , 2.60533911204     ,
 3.43727902053     , 4.56108043261     , 6.06172970344     , 7.96886654407     ,
 10.2790914374     , 13.0414346827     , 16.3965383221     , 20.4953708723     ,
 25.3892294461     , 31.0283179256     , 37.2967248605     , 43.8764625616     ,
 49.9993096163     , 54.447577869      , 55.9730798838     , 53.8630206808     ,
 48.2771711882     , 40.2094765787     , 31.1307196818     , 22.4732287668     ,
 15.1982984235     , 9.65539154445     , 5.74112123524     , 3.16120641072     ,
 1.59765566347     , 0.753740896956    , 0.362556832739    , 0.208994833074    ,
 0.150110388995    , 0.113876893977    , 0.0787824021805   , 0.047544521032    ,
 0.027036980539    , 0.0194310280568   , 0.0214854989108   , 0.0267577777272   ,
 0.0288400866346   , 0.0249376169441   , 0.0170357612514   , 0.00918090589504  ,
 0.00391794871766  , 0.00136120816009  , 0.000546085116594 , 0.000844379263079 ,
 0.0024842143741   , 0.00627374921764  , 0.012548190514    , 0.0198096897401   ,
 0.0247062675876   , 0.0243629861613   , 0.0190034441453   , 0.0117244608991   ,
 0.00571869877888  , 0.0022036421094   , 0.000671887592517 , 0.000167680842448 ,
 4.8516203682e-05  , 4.03761495199e-05 , 5.60121788403e-05 , 6.77241328208e-05 ,
 6.52251010275e-05 , 4.97865920605e-05 , 3.028468836e-05   , 1.49945150211e-05 ,
 6.52142847819e-06 , 3.10487040132e-06 , 2.26572516514e-06 , 2.80250896663e-06 ,
 4.90794134006e-06 , 1.02746793665e-05 , 2.38977291456e-05 , 5.70128158303e-05 ,
 0.00012748916633  , 0.000259541221509 , 0.000512375782111 , 0.00110842468356  ,
 0.00273694660736  , 0.00700928745178  , 0.016842406661    , 0.0365660109865   ,
 0.214192315793    , 0.388202093463    , 0.675362435619    , 1.14690055853     ,
 1.90639924025     , 3.07091244461     , 4.73094550387     , 6.92075995499     ,
 9.62814163663     , 12.8197726096     , 16.4327370681     , 20.3323851439     ,
 24.2796035115     , 27.9357910343     , 30.911105363      , 32.8415108312     ,
 33.4632361718     , 32.6774734134     , 30.6095831308     , 27.6080903875     ,
 24.123016814      , 20.5267250244     , 17.0190003785     , 13.671830851      ,
 10.5418339231     , 7.73859532819     , 5.39683396361     , 3.59947784075     ,
 2.33280188926     , 1.4995620104      , 0.965723288412    , 0.612406372277    ,
 0.367274535346    , 0.199934133214    , 0.0965539135359   , 0.0423565408145   ,
 0.0207399204359   , 0.0182112052705   , 0.0253242928951   , 0.0340852158775   ,
 0.0374580652257   , 0.032498516499    , 0.0221004271929   , 0.0117562480143   ,
 0.00488810180014  , 0.001588161639    , 0.000403207110772 , 8.00080039136e-05 ,
 1.24170834601e-05 , 1.51745969409e-06 , 1.63059184872e-07 , 3.9000103389e-08  ,
 3.23851177549e-08 , 2.86646032998e-08 , 2.30952395306e-08 , 2.30199179195e-08 ,
 3.53384095637e-08 , 6.12019493534e-08 , 9.36259803287e-08 , 1.30562592484e-07 ,
 2.79462078587e-07 , 1.40089328482e-06 , 8.24364833554e-06 , 4.04361458639e-05 ,
 0.000157806503239 , 0.000491050422563 , 0.00123841657767  , 0.00261146961526  ,
 0.00481489964462  , 0.00807522029977  , 0.0123812658517   , 0.016794379536    ,
 0.0193110743894   , 0.0182699154161   , 0.0140740424594   , 0.0089925234092   ,
 0.0052378778992   , 0.00357948482729  , 0.00352204290983  , 0.00423273351975  ,
 0.00531807910691  , 0.00709676441106  , 0.0102599860923   , 0.0152785501898   ,
 0.0224586839237   , 0.0332865980809   , 0.0525074784783   , 0.0894955418608   ,
 0.15822991665     , 0.275823074263    , 0.457213914691    , 0.70363996425     ,
 0.993143405176    , 1.29175449636     , 1.5895843934      , 1.93060598996     ,
 2.3952941254      , 3.04493919001     , 3.89342054576     , 4.9477023113      ,
 6.26995719279     , 7.97787180878     , 10.1658796118     , 12.8295270465     ,
 15.8943951784     , 19.3375979223     , 23.2590246917     , 27.8055979279     ,
 33.0476458067     , 38.9576741929     , 45.4272929483     , 52.132872765      ,
 58.3155068093     , 62.7926658508     , 64.3248255328     , 62.1150445435     ,
 56.1689111353     , 47.3708218115     , 37.2201745139     , 27.3042497572     ,
 18.7754847877     , 12.1269231427     , 7.3264763748      , 4.09683015097     ,
 2.1014865125      , 0.999620420443    , 0.468809881992    , 0.245202706779    ,
 0.153803706609    , 0.105262251584    , 0.0687123034989   , 0.0409139670781   ,
 0.0250435040549   , 0.0217742557184   , 0.0276531005254   , 0.0359061482568   ,
 0.0392693810561   , 0.0344456663355   , 0.0240316799089   , 0.0133643533314   ,
 0.00596744948091  , 0.00219972756393  , 0.000891142167118 , 0.00120986893825  ,
 0.00343726609227  , 0.00865271460651  , 0.0173011385898   , 0.0273119683452   ,
 0.0340626714279   , 0.0335894259819   , 0.0262004745915   , 0.0161653728109   ,
 0.00788599888675  , 0.00304194162967  , 0.000937315182701 , 0.000262736866544 ,
 0.000143435714389 , 0.000204571578577 , 0.000306568538726 , 0.000372469205194 ,
 0.000358554391833 , 0.000273819677246 , 0.000167423757655 , 8.4719639723e-05  ,
 3.95893973924e-05 , 2.18756068367e-05 , 1.78709131038e-05 , 2.14664078047e-05 ,
 3.39629054184e-05 , 6.26223535052e-05 , 0.00012815911113  , 0.000280480313206 ,
 0.000605007104189 , 0.00121693286077  , 0.0023361291085   , 0.00465881588199  ,
 0.0102141810984   , 0.0235968446544   , 0.0530485513672   , 0.110901994462    ,
 0.598220053354    , 1.04499312016     , 1.73849134945     , 2.79005184053     ,
 4.34698695757     , 6.55744661586     , 9.50322133897     , 13.1622260924     ,
 17.4549008023     , 22.3126132317     , 27.646924045      , 33.2260255179     ,
 38.6003208547     , 43.1695094185     , 46.3459659932     , 47.7072721181     ,
 47.0728270074     , 44.5307720927     , 40.4567813627     , 35.462419676      ,
 30.1978375934     , 25.1193959943     , 20.4212688591     , 16.1458505508     ,
 12.3190142824     , 9.00418309008     , 6.28020444563     , 4.19106430775     ,
 2.7090761256      , 1.73071516673     , 1.10780287282     , 0.701493312031    ,
 0.423455671778    , 0.23500521825     , 0.118532363619    , 0.0565639283724   ,
 0.0302835520562   , 0.0249217363837   , 0.0304561755302   , 0.0383843104998   ,
 0.0410674958103   , 0.0352043324263   , 0.0237822818666   , 0.0125926275921   ,
 0.00521539986759  , 0.00168805307879  , 0.000426833795145 , 8.4325469907e-05  ,
 1.3066100688e-05  , 1.69886565784e-06 , 3.82947408879e-07 , 3.450597162e-07   ,
 3.75213458484e-07 , 3.38436693448e-07 , 2.73839003668e-07 , 2.718602596e-07   ,
 4.1101264229e-07  , 7.02549267622e-07 , 1.05493260306e-06 , 1.30296931753e-06 ,
 1.34588343444e-06 , 1.44917073097e-06 , 3.22293392018e-06 , 1.32234538447e-05 ,
 5.33157459004e-05 , 0.000184786998949 , 0.000563186384118 , 0.00155888271765  ,
 0.00391543817055  , 0.00862033348849  , 0.0159621412556   , 0.0241466894034   ,
 0.0294162337607   , 0.0287961370931   , 0.0229396082414   , 0.015600789489    ,
 0.0104440902071   , 0.00883937135537  , 0.0101096325098   , 0.0130125449277   ,
 0.0172076738124   , 0.0238631275879   , 0.0347646831288   , 0.0507860461154   ,
 0.0720386365175   , 0.100963162982    , 0.146588767802    , 0.226437198619    ,
 0.364685063028    , 0.588065954353    , 0.918417103344    , 1.35855631367     ,
 1.88033140499     , 2.43899176954     , 3.02078337747     , 3.68186787446     ,
 4.52298244159     , 5.61384408754     , 6.95750698517     , 8.5455343018      ,
 10.4359953659     , 12.7488091767     , 15.5656153374     , 18.8380888819     ,
 22.4209972555     , 26.2129228218     , 30.2468766596     , 34.6319359688     ,
 39.447591422      , 44.7237259915     , 50.4346199367     , 56.3570237014     ,
 61.8775571653     , 65.9939463532     , 67.5701968377     , 65.7170597005     ,
 60.1792774541     , 51.575143393      , 41.2730637107     , 30.886037999      ,
 21.6870081976     , 14.3101814947     , 8.83812415947     , 5.06384231181     ,
 2.67497030439     , 1.31683053183     , 0.632665576343    , 0.322685906457    ,
 0.185111809251    , 0.114136293139    , 0.069113510752    , 0.0401937584672   ,
 0.0259045881205   , 0.0244423040599   , 0.0317926799737   , 0.0413638559458   ,
 0.0457814604083   , 0.0412532478133   , 0.0300501201494   , 0.0177645032226   ,
 0.00859125554971  , 0.00346785289569  , 0.00140415773262  , 0.00145604557712  ,
 0.00377032259481  , 0.00939846660807  , 0.0187697494329   , 0.0296230135118   ,
 0.0369426101055   , 0.0364298832251   , 0.0284190119358   , 0.0175398521465   ,
 0.00856631450179  , 0.00332372946973  , 0.00107296075707  , 0.000430505387686 ,
 0.000496560223705 , 0.000877699331349 , 0.00133799592063  , 0.00162480454487  ,
 0.00156298393525  , 0.00119556128993  , 0.000737840700781 , 0.000386544533519 ,
 0.000199546283045 , 0.00012948629362  , 0.000115866287263 , 0.000135274867005 ,
 0.000196874709044 , 0.000327467213902 , 0.000596473751291 , 0.00118745004826  ,
 0.00244881747444  , 0.0048855801944   , 0.0093439859959   , 0.0179995385878   ,
 0.036597329142    , 0.0774968691294   , 0.162163608316    , 0.321972273658    ,
 1.58187607138     , 2.63815092254     , 4.17640692147     , 6.33259841282     ,
 9.26213782979     , 13.0961776615     , 17.8601877401     , 23.4406467351     ,
 29.6766104169     , 36.4665387659     , 43.6839583012     , 50.9367584904     ,
 57.4711495163     , 62.3883374528     , 64.9904119777     , 64.9670221433     ,
 62.3587592046     , 57.4782483986     , 50.9208704565     , 43.5281288758     ,
 36.1415046839     , 29.3130211029     , 23.257634368      , 18.0131572645     ,
 13.5688185822     , 9.89414060355     , 6.94810976664     , 4.69052102583     ,
 3.06604940963     , 1.97386527855     , 1.26920644561     , 0.808965194291    ,
 0.49732897999     , 0.288738848343    , 0.159804248383    , 0.08852622782     ,
 0.0536463012841   , 0.0401531580611   , 0.0389036683028   , 0.0421347134862   ,
 0.0422328978019   , 0.0353310337674   , 0.0236821695851   , 0.0125301074677   ,
 0.00520422987768  , 0.00169335478394  , 0.000431433800301 , 8.62382325158e-05 ,
 1.3986690662e-05  , 2.87463437462e-06 , 2.36680647268e-06 , 3.14547828957e-06 ,
 3.51411928987e-06 , 3.18496336821e-06 , 2.5959305976e-06  , 2.57796213395e-06 ,
 3.83113808809e-06 , 6.44039162335e-06 , 9.58293056878e-06 , 1.17645431705e-05 ,
 1.1773811547e-05  , 9.67494658753e-06 , 7.03337855727e-06 , 7.31814768952e-06 ,
 2.10648516386e-05 , 9.01366078923e-05 , 0.000371008332375 , 0.00133523306275  ,
 0.0040138188134   , 0.00979746472988  , 0.0191420309725   , 0.0297915127659   ,
 0.0370263591946   , 0.0371901367776   , 0.0311775494914   , 0.0236854289999   ,
 0.0193484342009   , 0.0201716001737   , 0.0257551012112   , 0.035055229452    ,
 0.0486129604113   , 0.06956334007     , 0.10161341549     , 0.145951425131    ,
 0.202093182958    , 0.274311231772    , 0.378928082585    , 0.545823128362    ,
 0.812678536725    , 1.2166367719      , 1.78519421426     , 2.52188277102     ,
 3.39350438273     , 4.34607825956     , 5.35908078835     , 6.48874183978     ,
 7.83677791721     , 9.46560115748     , 11.3619193903     , 13.4957914038     ,
 15.8970312402     , 18.6479925568     , 21.7903280437     , 25.2441371209     ,
 28.8393082347     , 32.4378643266     , 36.0102409167     , 39.5979127472     ,
 43.2627574142     , 47.1042339413     , 51.2380423902     , 55.6280032998     ,
 59.8949939148     , 63.2912201602     , 64.8431268474     , 63.6139836559     ,
 59.0979254918     , 51.5861860835     , 42.1738451971     , 32.321350681      ,
 23.2829144437     , 15.7793734046     , 10.0257946623     , 5.93365227808     ,
 3.26386310209     , 1.69050642799     , 0.857018834293    , 0.450900199682    ,
 0.255025878898    , 0.150872401882    , 0.0887254062126   , 0.0520475417364   ,
 0.0342822083948   , 0.0305947695299   , 0.0362302909083   , 0.0451878194085   ,
 0.0504582484021   , 0.0474574802763   , 0.0369838594335   , 0.0238314001429   ,
 0.0127107569044   , 0.00565088093267  , 0.00229783674633  , 0.0016337845657   ,
 0.00336445087905  , 0.00809238537253  , 0.0160565849255   , 0.0252952844733   ,
 0.031529839575    , 0.031097486203    , 0.0242830997724   , 0.0150319242539   ,
 0.00741196380699  , 0.00298770192168  , 0.00117849488733  , 0.000932123499339 ,
 0.00165601725743  , 0.00306382687223  , 0.00466083042755  , 0.00564473094125  ,
 0.00542744842095  , 0.00416757025146  , 0.0026144139252   , 0.00144546051033  ,
 0.000848944517456 , 0.000644793710068 , 0.000618100690102 , 0.000703554409202 ,
 0.000956358271144 , 0.00146971131594  , 0.00244420424349  , 0.00446296482265  ,
 0.00875935207809  , 0.0172912591675   , 0.0332016149688   , 0.0632027475473   ,
 0.122916755327    , 0.243679008278    , 0.47706462811     , 0.894314363354    ,
 3.93254798754     , 6.22998871911     , 9.35693741252     , 13.4048310116     ,
 18.4394381479     , 24.4825076439     , 31.4585919994     , 39.1801393244     ,
 47.4527434436     , 56.1652397758     , 65.1127843658     , 73.6497215686     ,
 80.6411019349     , 84.9166677728     , 85.8273982824     , 83.3910491062     ,
 78.0180762692     , 70.2639043672     , 60.8733990405     , 50.8423588383     ,
 41.1706620763     , 32.5137147348     , 25.1248411326     , 19.0327542359     ,
 14.1551349051     , 10.3202124693     , 7.32971318213     , 5.04070918711     ,
 3.36690222459     , 2.21594040319     , 1.45731880901     , 0.955431699592    ,
 0.615326632131    , 0.387990015553    , 0.244598870135    , 0.158444560288    ,
 0.10642314801     , 0.0747984720199   , 0.0573213918809   , 0.0487887135717   ,
 0.0424800535008   , 0.0335215571593   , 0.0221310073799   , 0.0117787907255   ,
 0.00497943586499  , 0.00166319464891  , 0.000438684174505 , 9.26478801671e-05 ,
 1.91388714486e-05 , 1.12549469872e-05 , 1.68116770981e-05 , 2.34956876973e-05 ,
 2.63240472711e-05 , 2.39854989035e-05 , 1.97960834749e-05 , 1.97905653932e-05 ,
 2.88650926051e-05 , 4.74120522886e-05 , 6.95322547105e-05 , 8.4801232025e-05  ,
 8.47180881763e-05 , 6.91871202128e-05 , 4.63640822336e-05 , 2.67872949946e-05 ,
 2.2065189136e-05  , 6.72068272958e-05 , 0.000308096044104 , 0.00121126100069  ,
 0.00381651313109  , 0.00954094307865  , 0.0189054804987   , 0.0298261882949   ,
 0.0379278391923   , 0.0399791941375   , 0.0371018273673   , 0.033915822792    ,
 0.0351356104146   , 0.0435893753099   , 0.0603207544533   , 0.0860025828506   ,
 0.123694535173    , 0.180101065231    , 0.261613918974    , 0.369247103131    ,
 0.501705302718    , 0.667308467998    , 0.894095700617    , 1.22795440359     ,
 1.71977183184     , 2.41216125339     , 3.33206559792     , 4.48199353202     ,
 5.82822507409     , 7.31138227555     , 8.89585996409     , 10.6125781749     ,
 12.5321135005     , 14.6908192543     , 17.061376336      , 19.5966972138     ,
 22.2788458089     , 25.1123668821     , 28.0757987237     , 31.087723004      ,
 34.0309471531     , 36.8120762952     , 39.3815702836     , 41.7096791439     ,
 43.8118826556     , 45.831633196      , 48.0214580142     , 50.5417228179     ,
 53.2469205217     , 55.6339932011     , 56.9225508036     , 56.2384126975     ,
 52.9641272859     , 47.1212992784     , 39.4491161204     , 31.07893183       ,
 23.0732259002     , 16.1390103111     , 10.6021493275     , 6.51642891584     ,
 3.75481923385     , 2.06099155824     , 1.11587179197     , 0.622497543952    ,
 0.365223284099    , 0.22068772374     , 0.133317303678    , 0.0813882512291   ,
 0.0541253320547   , 0.0440410772343   , 0.0456159113469   , 0.0531680939267   ,
 0.0595598976665   , 0.0586537111831   , 0.0489709779416   , 0.0341633549831   ,
 0.0197822426528   , 0.00954349644932  , 0.00406549890965  , 0.0021852895091   ,
 0.00285317189054  , 0.00588044779717  , 0.0111737758173   , 0.0173531942224   ,
 0.0215431843649   , 0.0212873002597   , 0.0167801147267   , 0.0106743106311   ,
 0.00569265466828  , 0.00288176086763  , 0.00195826912077  , 0.0025666094194   ,
 0.00482162758539  , 0.00869574794196  , 0.013052055742    , 0.0157278368916   ,
 0.0151251041388   , 0.0117063262734   , 0.00755288208031  , 0.00452474256415  ,
 0.00309637150643  , 0.00270360588369  , 0.00272519153074  , 0.00304195626245  ,
 0.00391773287046  , 0.00568104938283  , 0.00889942887739  , 0.0152754345657   ,
 0.0286843687519   , 0.0557392548092   , 0.107010220289    , 0.202214019862    ,
 0.381430931585    , 0.718233089848    , 1.32523285975     , 2.34544083606     ,
 9.08277883748     , 13.6510513988     , 19.4460239447     , 26.3619045059     ,
 34.2113474578     , 42.8037472283     , 51.979082746      , 61.593237669      ,
 71.537098348      , 81.7110548655     , 91.7497232827     , 100.659056894     ,
 106.915020157     , 109.183566874     , 107.046423723     , 101.039419268     ,
 92.0800898016     , 81.0107764906     , 68.6742555246     , 56.1150000432     ,
 44.3930915316     , 34.2083827505     , 25.8138267825     , 19.1844103786     ,
 14.1272754287     , 10.3210792233     , 7.42838188714     , 5.22225196938     ,
 3.59089430593     , 2.44829728495     , 1.67827903184     , 1.15761038697     ,
 0.798698634095    , 0.554136921535    , 0.392593209292    , 0.284067794367    ,
 0.204552331194    , 0.143015700896    , 0.0982088609495   , 0.0693659832424   ,
 0.0512192173072   , 0.0370922981338   , 0.0240133499496   , 0.0130351221626   ,
 0.00574777404634  , 0.0020319667538   , 0.000575598184133 , 0.000138468830946 ,
 4.92782222386e-05 , 6.05448705103e-05 , 0.000101117543852 , 0.000141446495972 ,
 0.000158394762702 , 0.000145374261585 , 0.000122292743226 , 0.000124062914423 ,
 0.000177488599179 , 0.000282758966555 , 0.000405689554251 , 0.00048885932554  ,
 0.000486177359008 , 0.000397246322542 , 0.000266445774859 , 0.000147894119465 ,
 7.5978126939e-05  , 7.89208046056e-05 , 0.000260595579052 , 0.000977089582283 ,
 0.00304128849263  , 0.00758717335386  , 0.0151342344332   , 0.0243779067294   ,
 0.0325611326999   , 0.0380662189653   , 0.0425096510612   , 0.0498882472846   ,
 0.0646888517587   , 0.0913770761106   , 0.134235401683    , 0.197735504639    ,
 0.289501491107    , 0.42157723501     , 0.603671005532    , 0.835889700399    ,
 1.11611630161     , 1.45976217191     , 1.91122377417     , 2.53354374552     ,
 3.38405724675     , 4.49628641612     , 5.88096476503     , 7.53371183532     ,
 9.42831657931     , 11.509943591      , 13.7205857729     , 16.0365360464     ,
 18.4644390162     , 21.0028566251     , 23.6236933037     , 26.2786258147     ,
 28.8964378666     , 31.3800796359     , 33.6341906679     , 35.606765578      ,
 37.3033192509     , 38.7542827695     , 39.9512435173     , 40.823266665      ,
 41.3322055777     , 41.6223260596     , 42.0189776513     , 42.8072436772     ,
 43.9947556831     , 45.2525898618     , 45.9948897781     , 45.5281255554     ,
 43.306797899      , 39.2164934231     , 33.6530462622     , 27.3279968479     ,
 20.9828514021     , 15.2016810151     , 10.359078507      , 6.63245591021     ,
 4.01569960151     , 2.34502590915     , 1.36622642691     , 0.822196090086    ,
 0.515993887206    , 0.329893245178    , 0.209095035648    , 0.131794508701    ,
 0.0868088705847   , 0.065826574868    , 0.0623690585435   , 0.0696362863583   ,
 0.0786358948834   , 0.0803810066758   , 0.0706341073093   , 0.0522334775947   ,
 0.0323383947282   , 0.0170399551099   , 0.00822675217452  , 0.00453161586348  ,
 0.00394595929296  , 0.00531920183293  , 0.00813644685731  , 0.0115315408447   ,
 0.013929122021    , 0.0139912284502   , 0.0118490869106   , 0.00898695152063  ,
 0.00683904769158  , 0.00583034425996  , 0.0058920254187   , 0.00759804573845  ,
 0.0122926817483   , 0.0204857199056   , 0.0298464372828   , 0.0356175798022   ,
 0.0342911476519   , 0.0269407552212   , 0.0182101489683   , 0.012195631692    ,
 0.00980917073539  , 0.00957657858633  , 0.0100153949567   , 0.0110560306528   ,
 0.0136969747693   , 0.0190936171134   , 0.0290008837676   , 0.0482458702081   ,
 0.0878550754533   , 0.167320757776    , 0.31790035059     , 0.59274934885     ,
 1.08667078699     , 1.95580982614     , 3.41760182105     , 5.71909411189     ,
 19.2838951946     , 27.5021918374     , 37.2003417946     , 47.8482497004     ,
 58.8287122665     , 69.7094910663     , 80.3942507104     , 91.0115227291     ,
 101.680135641     , 112.277883511     , 122.150514518     , 129.910468391     ,
 133.768272582     , 132.434883236     , 125.888090402     , 115.276539275     ,
 102.100754741     , 87.5533518506     , 72.5596752537     , 58.0827962181     ,
 45.0578502772     , 34.0743146592     , 25.2865361601     , 18.5632865635     ,
 13.5989554069     , 9.97219153055     , 7.273597263       , 5.23439584914     ,
 3.72437348384     , 2.65475367746     , 1.9173603374      , 1.40296600714     ,
 1.03716254296     , 0.779702010661    , 0.600027330283    , 0.466004292308    ,
 0.353021634513    , 0.253564603402    , 0.173036818489    , 0.116593204921    ,
 0.0806442300428   , 0.0559938332464   , 0.036103347542    , 0.0200834795799   ,
 0.00922901692432  , 0.00343747128743  , 0.00104506501724  , 0.000302167779232 ,
 0.000186013841289 , 0.000296928501703 , 0.000498459063392 , 0.00069015065776  ,
 0.000770879008353 , 0.000714148857447 , 0.00061669516742  , 0.000640115931343 ,
 0.000898767911407 , 0.00137902064441  , 0.00191894160314  , 0.00226802706411  ,
 0.00223368393582  , 0.00182067746515  , 0.00122512403744  , 0.000684057066871 ,
 0.000335113221026 , 0.000207196498511 , 0.000326724979514 , 0.000872484832411 ,
 0.00231486367815  , 0.00536685383951  , 0.0105335091138   , 0.0176091744804   ,
 0.0261737121008   , 0.0371820722151   , 0.0537691878562   , 0.0804342441105   ,
 0.122836049962    , 0.188777109052    , 0.287531691537    , 0.428930837058    ,
 0.626660111292    , 0.899631706026    , 1.26166161859     , 1.71119394674     ,
 2.24413508201     , 2.88360746197     , 3.69194774508     , 4.74690537097     ,
 6.10036260925     , 7.75435802951     , 9.67758232143     , 11.8437116888     ,
 14.2392919649     , 16.8305526982     , 19.5439995976     , 22.2912800254     ,
 25.0042506631     , 27.6497434633     , 30.2184459474     , 32.676024905      ,
 34.8998641466     , 36.688457524      , 37.8787010129     , 38.4671724902     ,
 38.6095405857     , 38.4940748222     , 38.1968574835     , 37.6516754645     ,
 36.7906150163     , 35.7356627831     , 34.814013359      , 34.3353835452     ,
 34.3504774343     , 34.6097270448     , 34.6850055284     , 34.1156370807     ,
 32.5498384922     , 29.8720511746     , 26.2344067718     , 21.9695153791     ,
 17.4751239107     , 13.1423623738     , 9.31309879028     , 6.22866921655     ,
 3.97721013759     , 2.48565624151     , 1.57442844465     , 1.03847698689     ,
 0.710120560403    , 0.4861330411      , 0.321596090926    , 0.204207832613    ,
 0.129904114259    , 0.0927522180729   , 0.0846480775351   , 0.0952398859611   ,
 0.111109491419    , 0.118420578538    , 0.109159209084    , 0.0855165884285   ,
 0.0572647653767   , 0.0339961873257   , 0.019612199675    , 0.0128415815891   ,
 0.0107498658188   , 0.0111601630504   , 0.0129789364026   , 0.0154301730762   ,
 0.0175228680977   , 0.0184669259748   , 0.0184507510129   , 0.0184936786535   ,
 0.0192091484107   , 0.0200779687197   , 0.0206287438634   , 0.0224190515727   ,
 0.0289043748985   , 0.0418971079021   , 0.0575668148766   , 0.0673671067279   ,
 0.0649792504211   , 0.0523960075002   , 0.038041596818    , 0.029237581072    ,
 0.027264634994    , 0.0288629124451   , 0.0310619194494   , 0.0342617813308   ,
 0.0415282998648   , 0.0566465746186   , 0.085304378702    , 0.140892100419    ,
 0.252114609177    , 0.469571699129    , 0.874055127493    , 1.59384469728     ,
 2.83105727125     , 4.87765382685     , 8.09090339609     , 12.816851865      ,
 37.3731338555     , 50.5945431709     , 65.0661786289     , 79.6326262944     ,
 93.1833443838     , 105.185906072     , 115.903018739     , 126.009278877     ,
 135.929049062     , 145.38758882      , 153.289504247     , 157.900873648     ,
 157.445547207     , 150.993078736     , 139.057197533     , 123.361340293     ,
 105.92426757      , 88.2799792241     , 71.4095130341     , 56.0598605452     ,
 42.8295292395     , 32.0118721079     , 23.5612998836     , 17.220157211      ,
 12.6123385751     , 9.29687247063     , 6.87096193087     , 5.06679818586     ,
 3.74162641517     , 2.79551597035     , 2.12472395985     , 1.63853012852     ,
 1.28212586162     , 1.02542792056     , 0.838129639085    , 0.684796223649    ,
 0.540369978597    , 0.402098123314    , 0.283270994572    , 0.19552841883     ,
 0.136891457439    , 0.0955777126015   , 0.0621569735793   , 0.0351303416108   ,
 0.0165383913228   , 0.00639082304971  , 0.00209802182125  , 0.000784652782997 ,
 0.000727629657277 , 0.00124086396701  , 0.00202919829277  , 0.00275724408602  ,
 0.00306237502149  , 0.0028682332039   , 0.00255869235886  , 0.00273480923943  ,
 0.00377362858139  , 0.00554768031171  , 0.00742317645705  , 0.00853185520309  ,
 0.00826428556239  , 0.00669100310295  , 0.00451325457079  , 0.00255703697368  ,
 0.00129887592732  , 0.00080382509145  , 0.000965748925316 , 0.00172894704922  ,
 0.00317981692637  , 0.00560077412278  , 0.00953982958779  , 0.0160310375254   ,
 0.0273424077453   , 0.0480090166232   , 0.0848368631266   , 0.145918488065    ,
 0.241071796555    , 0.383366875915    , 0.587883374557    , 0.870065851502    ,
 1.24996084449     , 1.7540282949      , 2.40057929435     , 3.18457950308     ,
 4.09500769566     , 5.15675557599     , 6.44564508866     , 8.04925288956     ,
 10.0031009095     , 12.2572853528     , 14.7118133967     , 17.2964171311     ,
 20.0052430432     , 22.8399051864     , 25.735649865      , 28.5645353074     ,
 31.209874908      , 33.6336197294     , 35.8623854601     , 37.8770531686     ,
 39.5014524673     , 40.44131727       , 40.4861776869     , 39.6854496974     ,
 38.3239047309     , 36.7253860998     , 35.057133637      , 33.2949790352     ,
 31.3809871628     , 29.4234250792     , 27.7142768036     , 26.5160048096     ,
 25.8377342438     , 25.4296751306     , 24.9584126543     , 24.1624164689     ,
 22.8979106311     , 21.1253405931     , 18.8826978804     , 16.2590570412     ,
 13.388866599      , 10.4661184797     , 7.73565644113     , 5.42979794445     ,
 3.6824384446      , 2.48867393014     , 1.73536884021     , 1.26737938136     ,
 0.947103051777    , 0.689993197631    , 0.469882961433    , 0.295648763141    ,
 0.179626588962    , 0.12176884226     , 0.111340541536    , 0.131979946154    ,
 0.163291092264    , 0.183851366745    , 0.179456315327    , 0.150731088741    ,
 0.110935760654    , 0.0749530181415   , 0.050452646561    , 0.0375626169113   ,
 0.0331237556041   , 0.0340009218453   , 0.0380238509743   , 0.0434913382567   ,
 0.0486782748358   , 0.0524202344899   , 0.0552008711328   , 0.0587074150965   ,
 0.063277247443    , 0.0663735914942   , 0.0654744128161   , 0.0629467656519   ,
 0.0660647528466   , 0.0798501975426   , 0.0995548723746   , 0.112302685892    ,
 0.108416409016    , 0.0909000352719   , 0.0725208037688   , 0.0641750577973   ,
 0.0670082475879   , 0.0748204417421   , 0.0825251390204   , 0.0919778023773   ,
 0.11109788291     , 0.150922840204    , 0.228697383007    , 0.379483539027    ,
 0.671564231877    , 1.22163255992     , 2.21264177676     , 3.91744988729     ,
 6.71610123503     , 11.0751256301     , 17.4627323154     , 26.2118253968     ,
 65.8593506412     , 84.674978706      , 103.654265454     , 121.032857451     ,
 135.408828419     , 146.486813171     , 155.217541842     , 162.978337504     ,
 170.423935788     , 176.930236423     , 180.86215466      , 180.302567395     ,
 173.865404277     , 161.327152767     , 143.83266153      , 123.514926869     ,
 102.665564359     , 82.9890423815     , 65.4237421        , 50.3972844534     ,
 38.0442664121     , 28.2600222328     , 20.7636656917     , 15.1972289918     ,
 11.1730332129     , 8.29596355537     , 6.22217382185     , 4.71247590578     ,
 3.61767692914     , 2.82604013769     , 2.2427077586      , 1.80440195426     ,
 1.48109130926     , 1.24997229051     , 1.07449691646     , 0.913008490559    ,
 0.74247504725     , 0.568719108489    , 0.414137380918    , 0.295777997056    ,
 0.212450988765    , 0.150402139554    , 0.0987277759549   , 0.0565832124675   ,
 0.0273699395989   , 0.0111923832673   , 0.00423159204639  , 0.00222948265156  ,
 0.00264554036488  , 0.0044292094206   , 0.00692085741283  , 0.00913925469324  ,
 0.0100465353039   , 0.00951702369107  , 0.00880373768607  , 0.00971116785227  ,
 0.0131841516299   , 0.0185296979747   , 0.023683521926    , 0.0262451355981   ,
 0.0248090552423   , 0.0198525645729   , 0.0134251524036   , 0.00779811139209  ,
 0.00426667580578  , 0.00301689528714  , 0.00372196353404  , 0.00598011306362  ,
 0.00937806802117  , 0.01373375421     , 0.0198515726164   , 0.0304857915077   ,
 0.051374236605    , 0.0922523656634   , 0.1666492554      , 0.290066832408    ,
 0.479235840219    , 0.753209488637    , 1.1323966709      , 1.63730231385     ,
 2.29362130747     , 3.13383681725     , 4.17775015379     , 5.41075900816     ,
 6.80441123517     , 8.37322465412     , 10.1983218964     , 12.3738608471     ,
 14.9154972626     , 17.713589159      , 20.5877663492     , 23.4097049985     ,
 26.1687729437     , 28.9018987936     , 31.5756193994     , 34.0663779595     ,
 36.2600111842     , 38.151766501      , 39.8158366522     , 41.2400454491     ,
 42.1928689217     , 42.3090373479     , 41.3551636788     , 39.4217555972     ,
 36.8699246713     , 34.1053561325     , 31.3698929809     , 28.701071007      ,
 26.0795157556     , 23.612560923      , 21.545075611      , 20.0638865302     ,
 19.1062943009     , 18.3899477468     , 17.6233123931     , 16.666520259      ,
 15.5202593068     , 14.2279233598     , 12.809896411      , 11.2570627161     ,
 9.5635343799      , 7.77651232333     , 6.02335546469     , 4.47492077308     ,
 3.26197772386     , 2.41466758499     , 1.86679673821     , 1.5027596094      ,
 1.21045344238     , 0.924096022624    , 0.641315951922    , 0.400230338698    ,
 0.236110485933    , 0.157093886973    , 0.149228148177    , 0.189071785628    ,
 0.247971400112    , 0.294399698663    , 0.304500400692    , 0.274736396311    ,
 0.22143612264     , 0.166447716685    , 0.124213886461    , 0.0995547967698   ,
 0.091404151433    , 0.0961707286842   , 0.109407410908    , 0.12628917176     ,
 0.141984222422    , 0.153394754574    , 0.161458767323    , 0.170036865757    ,
 0.179879807561    , 0.184619009332    , 0.176959231436    , 0.159874497669    ,
 0.147514522096    , 0.151631314497    , 0.168114141072    , 0.179661265698    ,
 0.172837849952    , 0.151509835868    , 0.132809476657    , 0.131063889461    ,
 0.146536926151    , 0.168962522319    , 0.190827593977    , 0.217315230182    ,
 0.266411021749    , 0.366518427247    , 0.563653075199    , 0.941260656782    ,
 1.64647482901     , 2.91885482351     , 5.12124106636     , 8.75857003584     ,
 14.4458858513     , 22.7893314077     , 34.1980959534     , 48.7053233199     ,
 105.32219566      , 128.781901743     , 150.317517585     , 167.943029219     ,
 180.468857228     , 188.246868952     , 193.059101063     , 196.849716183     ,
 200.249440154     , 202.129155133     , 200.391472414     , 193.227217743     ,
 179.996369196     , 161.414361475     , 139.239675719     , 115.756819824     ,
 93.1676010303     , 73.0431788836     , 56.1159667238     , 42.4506832798     ,
 31.7341918502     , 23.5024896395     , 17.2929588843     , 12.7085664475     ,
 9.40097561619     , 7.05069879387     , 5.38717667487     , 4.20809559067     ,
 3.36404286742     , 2.73812526803     , 2.25312975558     , 1.88072489932     ,
 1.61569944178     , 1.43456895123     , 1.28614173373     , 1.12147842729     ,
 0.925639178844    , 0.719150169138    , 0.534262553699    , 0.39039643035     ,
 0.285238631605    , 0.203900385413    , 0.1354063269      , 0.0796934202656   ,
 0.0408474781709   , 0.0188089548199   , 0.00902141398133  , 0.00658946424084  ,
 0.00861198867256  , 0.0136275707692   , 0.0200818242159   , 0.0255203270441   ,
 0.0276042209688   , 0.0264098237318   , 0.0253208721965   , 0.0287271282594   ,
 0.0383618188642   , 0.0515775671437   , 0.0627732260789   , 0.0666297681945   ,
 0.0610238674419   , 0.0480642447183   , 0.032706323562    , 0.0198715135478   ,
 0.0122558862113   , 0.0102775799273   , 0.0133158721519   , 0.0204547356164   ,
 0.030504002835    , 0.0427380530912   , 0.0588846765691   , 0.0848799256229   ,
 0.131699127897    , 0.216343839892    , 0.361780158055    , 0.593415227064    ,
 0.935456456804    , 1.41155140444     , 2.04598064537     , 2.86363953776     ,
 3.8941079687      , 5.17026129036     , 6.70302283914     , 8.45442762362     ,
 10.3639746945     , 12.4249415753     , 14.7212792853     , 17.358343169      ,
 20.3375588508     , 23.4956809139     , 26.5828704877     , 29.4229337475     ,
 31.9964501622     , 34.3595562545     , 36.5052784774     , 38.3381260487     ,
 39.7875395103     , 40.9142294995     , 41.8502654958     , 42.5916447023     ,
 42.867185188      , 42.2734690121     , 40.5733960104     , 37.8727428534     ,
 34.5482021376     , 31.0346302411     , 27.6308718435     , 24.4409153665     ,
 21.4841021803     , 18.8530481386     , 16.7290087549     , 15.2214503416     ,
 14.2158543656     , 13.4195835037     , 12.5686287471     , 11.577642887      ,
 10.5092710509     , 9.4533849162      , 8.45135910106     , 7.48877456626     ,
 6.52072253451     , 5.51710626979     , 4.50919327781     , 3.58907642041     ,
 2.85023598397     , 2.32585778194     , 1.97617887224     , 1.71610065478     ,
 1.45621767978     , 1.14794761193     , 0.810822203493    , 0.5107293701      ,
 0.305409573234    , 0.211560729408    , 0.213085379188    , 0.28113537338     ,
 0.38020160458     , 0.468129342352    , 0.508100338477    , 0.487654382911    ,
 0.42287759127     , 0.343065867476    , 0.273787846533    , 0.230481080879    ,
 0.218538581015    , 0.23487651662     , 0.270687651679    , 0.314480867284    ,
 0.354670332385    , 0.383402225123    , 0.401126969466    , 0.415089408784    ,
 0.427837944505    , 0.428313829638    , 0.40240338061     , 0.354252476928    ,
 0.309030164819    , 0.289434616091    , 0.293183144882    , 0.297398848212    ,
 0.283721118381    , 0.256860739085    , 0.239204764239    , 0.249370998838    ,
 0.286819951589    , 0.336869523339    , 0.390203746849    , 0.458893661237    ,
 0.580468928702    , 0.8200808521      , 1.28473186472     , 2.15157788293     ,
 3.70466290667     , 6.37845704268     , 10.7972966609     , 17.7598374066     ,
 28.0926437557     , 42.3610762723     , 60.5629218688     , 81.991651722      ,
 152.801890945     , 178.183003035     , 198.922296418     , 213.486295451     ,
 221.487940195     , 224.158547942     , 223.899691523     , 222.770602777     ,
 221.04117157      , 217.09282179      , 208.692752767     , 194.528413684     ,
 174.921992104     , 151.50675025      , 126.456187207     , 101.900239838     ,
 79.6013777364     , 60.7008984678     , 45.580261113      , 33.9684753197     ,
 25.231866359      , 18.6844041062     , 13.7878043336     , 10.1774963648     ,
 7.58081480275     , 5.75793360588     , 4.50165207        , 3.64246380524     ,
 3.03639681672     , 2.56925129586     , 2.18510047997     , 1.88842381449     ,
 1.69260656965     , 1.56714586923     , 1.44413728307     , 1.27101568813     ,
 1.04728770761     , 0.812016845283    , 0.605954784101    , 0.446902254054    ,
 0.329332249972    , 0.23797259944     , 0.162398741643    , 0.101821666298    ,
 0.0588880794013   , 0.0330385617708   , 0.0207101302551   , 0.0185764303311   ,
 0.0245178363943   , 0.036314428702    , 0.0502184322129   , 0.060983820324    ,
 0.0645375346298   , 0.062151259943    , 0.0614165044192   , 0.0710039530764   ,
 0.0929957052374   , 0.11986645128     , 0.139028496517    , 0.140993139364    ,
 0.12462203768     , 0.0965931812158   , 0.0669341527342   , 0.0440678352801   ,
 0.0322010027666   , 0.031951175281    , 0.0423786145507   , 0.061886794206    ,
 0.0882481479008   , 0.120546763499    , 0.163262334729    , 0.228425591017    ,
 0.334619050431    , 0.507159560797    , 0.778772843488    , 1.18424579264     ,
 1.75304920335     , 2.5103347137      , 3.48209319597     , 4.69607263299     ,
 6.18161547015     , 7.96134813197     , 10.0194079911     , 12.2744567416     ,
 14.6205343539     , 17.0293015386     , 19.5995806894     , 22.4639102254     ,
 25.6211538346     , 28.8666361898     , 31.9067533218     , 34.5521233802     ,
 36.7905195775     , 38.6781801802     , 40.2001452028     , 41.2698600534     ,
 41.8623708585     , 42.1123846917     , 42.2192332932     , 42.2087651373     ,
 41.811256735      , 40.6279986261     , 38.4310169439     , 35.3121405681     ,
 31.6140838285     , 27.7630364123     , 24.0999509096     , 20.7870528177     ,
 17.8592838154     , 15.3569072849     , 13.3698919414     , 11.9380591337     ,
 10.9403600034     , 10.1274595763     , 9.28178455451     , 8.33846263857     ,
 7.36129818383     , 6.44283038851     , 5.6408821716      , 4.96636545139     ,
 4.38773692606     , 3.85473903039     , 3.34356344962     , 2.87865396811     ,
 2.50212408926     , 2.22860731975     , 2.0304211437      , 1.8491951544      ,
 1.61940755384     , 1.307753419       , 0.946762200939    , 0.618017126959    ,
 0.393705928197    , 0.298153768362    , 0.316815383965    , 0.420421933465    ,
 0.570981389454    , 0.717375506869    , 0.806638977505    , 0.810533837351    ,
 0.739562918021    , 0.631092245286    , 0.527795388898    , 0.462721865933    ,
 0.451896543686    , 0.493047806208    , 0.570727848046    , 0.663590122719    ,
 0.749485472332    , 0.810993606587    , 0.843745409582    , 0.857449261671    ,
 0.8594088317      , 0.837698477363    , 0.77389348805     , 0.675666092845    ,
 0.582365676608    , 0.529562283587    , 0.51541722363     , 0.507911365741    ,
 0.481114203261    , 0.440964239763    , 0.418193184713    , 0.43950262208     ,
 0.50642233084     , 0.601958770714    , 0.718081716896    , 0.881108775434    ,
 1.16517619574     , 1.70502071003     , 2.71926368519     , 4.54181801574     ,
 7.65869406321     , 12.7545977596     , 20.7413988331     , 32.6651994413     ,
 49.3830496        , 71.071067094      , 96.8594590364     , 124.89503008      ,
 201.511654118     , 225.016278486     , 241.429657931     , 250.270829283     ,
 252.236081099     , 249.264844821     , 243.851941855     , 237.625234346     ,
 230.28908758      , 219.992540547     , 204.868294124     , 184.464091495     ,
 160.062064974     , 133.921542066     , 108.272850098     , 84.7964143961     ,
 64.5870606296     , 48.197636269      , 35.6191462011     , 26.3416182533     ,
 19.5799769331     , 14.5800772364     , 10.8268323628     , 8.03888027961     ,
 6.03588275094     , 4.65056139631     , 3.72550012998     , 3.12096603741     ,
 2.70595300993     , 2.37342827881     , 2.08132137266     , 1.852767957       ,
 1.71073545149     , 1.61981213608     , 1.50436868724     , 1.31561905645     ,
 1.06866943407     , 0.817342154356    , 0.606050176984    , 0.447900595498    ,
 0.333609235735    , 0.248218741789    , 0.18136295988     , 0.128938789945    ,
 0.0895538799992   , 0.062228342512    , 0.0473314215882   , 0.0465801519404   ,
 0.060143087351    , 0.0838402122208   , 0.10918957539     , 0.126510571025    ,
 0.130531962443    , 0.125967547414    , 0.127023427681    , 0.147582866176    ,
 0.188422915923    , 0.233217229445    , 0.258803304926    , 0.251548868423    ,
 0.215248836633    , 0.165698579427    , 0.120036145091    , 0.0897976814902   ,
 0.0797342557107   , 0.0900789214842   , 0.119172581941    , 0.164410150149    ,
 0.222902513331    , 0.295686528213    , 0.394216196742    , 0.541166509493    ,
 0.76469549731     , 1.09676513353     , 1.57583000782     , 2.24058505529     ,
 3.11937465298     , 4.23372681112     , 5.60904603486     , 7.2739075703      ,
 9.25071009408     , 11.5375454213     , 14.0723999464     , 16.714639369      ,
 19.3098723141     , 21.8207336363     , 24.3824566524     , 27.1748244693     ,
 30.2076542422     , 33.2490926522     , 35.9895656455     , 38.2650775504     ,
 40.0955295285     , 41.5284775476     , 42.5055449987     , 42.9080214171     ,
 42.721467403      , 42.1302728135     , 41.3991505185     , 40.6157183691     ,
 39.5665191589     , 37.9019109225     , 35.4120960905     , 32.1540532681     ,
 28.4060182091     , 24.5581814643     , 20.9725070314     , 17.8509851346     ,
 15.2196937108     , 13.0358524298     , 11.2789351416     , 9.93128932436     ,
 8.90770917351     , 8.04969982294     , 7.2097357342      , 6.33367503044     ,
 5.45779681845     , 4.64896237947     , 3.96156239118     , 3.42355730841     ,
 3.02747999153     , 2.73489270373     , 2.50601258622     , 2.32344938389     ,
 2.18302976888     , 2.07356654471     , 1.97163013421     , 1.84287500302     ,
 1.64640879673     , 1.3615098189      , 1.02212013667     , 0.708886443851    ,
 0.496971626247    , 0.417190984206    , 0.462270153758    , 0.609481548749    ,
 0.82330440841     , 1.04440240851     , 1.1991932447      , 1.23731792553     ,
 1.1617640177      , 1.0225910197      , 0.886135727251    , 0.806203078498    ,
 0.808680444215    , 0.890414354545    , 1.02911073813     , 1.19433404271     ,
 1.35156452903     , 1.46643912596     , 1.51966266634     , 1.51852264139     ,
 1.48032956575     , 1.40396017901     , 1.27673323315     , 1.11391026375     ,
 0.968101567398    , 0.884335306207    , 0.856648458657    , 0.839048789134    ,
 0.79466632843     , 0.730794752688    , 0.690674129398    , 0.715869821796    ,
 0.817498094082    , 0.983743340275    , 1.21681867245     , 1.5724541917      ,
 2.19001378745     , 3.32171265491     , 5.36307103942     , 8.87224746718     ,
 14.5780570185     , 23.3941038686     , 36.4029541912     , 54.6607602606     ,
 78.6965900163     , 107.87939996      , 140.139148076     , 172.401095722     ,
 242.795041465     , 260.898710238     , 270.728626635     , 272.994440482     ,
 269.182294275     , 261.358224993     , 251.514015584     , 240.531875531     ,
 227.671534473     , 211.301772023     , 190.386893333     , 165.491645229     ,
 138.613335053     , 112.181999157     , 88.0932213911     , 67.3748458462     ,
 50.3950662503     , 37.1362449615     , 27.2829890601     , 20.2310043196     ,
 15.2023443207     , 11.4903794816     , 8.65630103232     , 6.51062246558     ,
 4.95479533529     , 3.87994568372     , 3.17119396044     , 2.7239907368      ,
 2.43158452204     , 2.19584424282     , 1.97400100421     , 1.7880678268      ,
 1.66294873749     , 1.5681851234      , 1.43694468399     , 1.23242136994     ,
 0.980026234206    , 0.736763903154    , 0.542839322097    , 0.405352019257    ,
 0.312734554267    , 0.250865011787    , 0.208195959968    , 0.175218559079    ,
 0.145107710632    , 0.117254432668    , 0.0990781366217   , 0.100923124631    ,
 0.12657615979     , 0.167795341702    , 0.207750387372    , 0.230727511873    ,
 0.232175468539    , 0.223570515972    , 0.227273200844    , 0.261191028361    ,
 0.32221758062     , 0.382915884541    , 0.408920358881    , 0.384676218001    ,
 0.323327890956    , 0.253429960971    , 0.199883373591    , 0.175914178555    ,
 0.185173058548    , 0.225762323024    , 0.293122240493    , 0.382462292944    ,
 0.492369471914    , 0.631926455375    , 0.827475873883    , 1.11825522737     ,
 1.54297836727     , 2.13584216172     , 2.93166289595     , 3.95861616189     ,
 5.22734433987     , 6.74511557668     , 8.53716638029     , 10.6376887749     ,
 13.0590724718     , 15.7614345263     , 18.6242553176     , 21.4493372549     ,
 24.0498413355     , 26.3975875169     , 28.6751947884     , 31.1170026721     ,
 33.7574304714     , 36.3599358871     , 38.6219753327     , 40.4189886393     ,
 41.8074788266     , 42.8272604162     , 43.3742076042     , 43.2812265598     ,
 42.5065841029     , 41.2381104573     , 39.7817478056     , 38.3043455916     ,
 36.6918811427     , 34.675891446      , 32.0691970138     , 28.8838087085     ,
 25.3201620145     , 21.7114685989     , 18.4126250046     , 15.6431447671     ,
 13.4109943758     , 11.5908375483     , 10.060885563      , 8.76511097521     ,
 7.67669040591     , 6.74322808384     , 5.89139797203     , 5.0754883683      ,
 4.29999964671     , 3.5978987939      , 3.00384843555     , 2.54248776814     ,
 2.21960865        , 2.01809669566     , 1.90840796418     , 1.85991377458     ,
 1.84073042082     , 1.81914307762     , 1.77203179484     , 1.68253286138     ,
 1.5298033046      , 1.30158837495     , 1.02477509841     , 0.766741650179    ,
 0.596416949631    , 0.549966342085    , 0.632266402465    , 0.832547618028    ,
 1.11949670095     , 1.42267349957     , 1.64356341561     , 1.70972594382     ,
 1.62355805853     , 1.45641161793     , 1.30035502837     , 1.2237998235      ,
 1.25465456449     , 1.38663521175     , 1.59551472693     , 1.84898376186     ,
 2.10148339264     , 2.29229314975     , 2.37211773862     , 2.33765222981     ,
 2.22308462234     , 2.05536056861     , 1.8424695554      , 1.61097171156     ,
 1.42072808973     , 1.31819325751     , 1.28846129187     , 1.26945909773     ,
 1.21167388574     , 1.12251204289     , 1.05924657151     , 1.0848822774      ,
 1.23217815408     , 1.51065511388     , 1.95285885719     , 2.67180988866     ,
 3.91336660402     , 6.1032537286      , 9.87591883634     , 16.0554945706     ,
 25.5854233642     , 39.4500268214     , 58.5841749492     , 83.6170930782     ,
 114.314579509     , 148.972906169     , 184.385890942     , 216.718434151     ,
 269.488035417     , 280.177889883     , 283.171130232     , 279.946035646     ,
 272.031706919     , 260.893781687     , 247.636638473     , 232.48785265      ,
 214.701762395     , 193.347985908     , 168.444473391     , 141.414113419     ,
 114.538463134     , 89.9598059358     , 68.9633855184     , 51.8842544088     ,
 38.4723490976     , 28.2922783638     , 20.874610608      , 15.6628948222     ,
 12.0004399015     , 9.29069836699     , 7.17775174329     , 5.53625756288     ,
 4.31692360204     , 3.44951144362     , 2.85787692182     , 2.48054638569     ,
 2.24536487875     , 2.06457898237     , 1.88343108549     , 1.70800258567     ,
 1.56068508629     , 1.42609017894     , 1.2613142063      , 1.04782169247     ,
 0.81379286375     , 0.606041669078    , 0.452565421331    , 0.354212229629    ,
 0.298904806898    , 0.273055539118    , 0.262868576855    , 0.25368217842     ,
 0.234384980284    , 0.205788586438    , 0.183704696143    , 0.189012111245    ,
 0.2300358548      , 0.292692735799    , 0.348480970966    , 0.374356100059    ,
 0.368850610774    , 0.353312621475    , 0.358015001802    , 0.401447060881    ,
 0.474447784413    , 0.54080154567     , 0.560120430047    , 0.519032617507    ,
 0.441089497442    , 0.366328574327    , 0.325749214526    , 0.333641626458    ,
 0.391923286518    , 0.493241503595    , 0.624497543806    , 0.776020792923    ,
 0.952957008308    , 1.18391182979     , 1.52152356307     , 2.02760366625     ,
 2.75140463683     , 3.72379739345     , 4.96131456912     , 6.4540676586      ,
 8.1618253772      , 10.0584900484     , 12.1772586433     , 14.581353483      ,
 17.2863620048     , 20.21071771       , 23.1752289378     , 25.9451011198     ,
 28.3308254995     , 30.3239059589     , 32.1389768518     , 34.0502355682     ,
 36.1304710482     , 38.1713893095     , 39.8905409211     , 41.1783075631     ,
 42.0970655492     , 42.6837611149     , 42.828519805      , 42.3510155479     ,
 41.1787014376     , 39.4632240659     , 37.5075767439     , 35.5386797986     ,
 33.5479746174     , 31.3570123927     , 28.8016560086     , 25.8494061235     ,
 22.6247518633     , 19.3930769778     , 16.4750152429     , 14.083706093      ,
 12.2102195252     , 10.6754367915     , 9.29658809329     , 8.00848821755     ,
 6.84590752657     , 5.84454305258     , 4.98646561604     , 4.23012014159     ,
 3.55509396606     , 2.96451506955     , 2.46626843447     , 2.0666141253      ,
 1.77083140924     , 1.5795062994      , 1.48403337427     , 1.4621141588      ,
 1.47626930813     , 1.48643287149     , 1.4687038729      , 1.41443630081     ,
 1.31361750382     , 1.15741759429     , 0.962851732982    , 0.780363597152    ,
 0.668450225244    , 0.666338867152    , 0.791353760279    , 1.04504096358     ,
 1.39813334664     , 1.76651039949     , 2.02981612792     , 2.10468859616     ,
 2.00543665176     , 1.82790600767     , 1.68014538197     , 1.62976306016     ,
 1.69686791775     , 1.87365388744     , 2.14447366921     , 2.48657168792     ,
 2.84697420579     , 3.13079462112     , 3.24522169298     , 3.16867932        ,
 2.9573230266      , 2.67983772261     , 2.37599000933     , 2.08415965689     ,
 1.8633956884      , 1.75417782953     , 1.73230874747     , 1.72408174794     ,
 1.67002888893     , 1.57528747746     , 1.50699368741     , 1.55131792098     ,
 1.77645122271     , 2.23948352165     , 3.03888604577     , 4.3878984593      ,
 6.6866930049      , 10.5791189855     , 16.9632783133     , 26.9025617207     ,
 41.4204600379     , 61.2658580607     , 86.7483711478     , 117.557114539     ,
 152.388916776     , 188.58291449      , 222.384508231     , 250.107473977     ,
 278.477844313     , 281.756235935     , 279.375194226     , 272.843860291     ,
 262.949527826     , 250.04998252      , 234.337156982     , 215.786364448     ,
 194.175767756     , 169.577410399     , 142.962611815     , 116.205075573     ,
 91.4011711272     , 70.0860493352     , 52.8544916001     , 39.4760568048     ,
 29.3077771199     , 21.7067905992     , 16.1924471404     , 12.3403373871     ,
 9.66314357292     , 7.69146029143     , 6.13652443195     , 4.90087805551     ,
 3.95036327566     , 3.23457727827     , 2.7099386825      , 2.35719630019     ,
 2.13970316492     , 1.9808474529      , 1.812575123       , 1.62243868865     ,
 1.43011526835     , 1.23963787093     , 1.03789059753     , 0.825867977969    ,
 0.628816796212    , 0.475469707362    , 0.377788823787    , 0.330737399425    ,
 0.32174661788     , 0.335940917414    , 0.356941403845    , 0.368074629521    ,
 0.357572469278    , 0.328196538891    , 0.302330385438    , 0.31043247837     ,
 0.366117472549    , 0.449913629158    , 0.520575801299    , 0.546653596079    ,
 0.53049285662     , 0.504598588895    , 0.505930658732    , 0.550132892233    ,
 0.6215794352      , 0.68176768584     , 0.693708642252    , 0.650134384344    ,
 0.580416176731    , 0.528489400703    , 0.528077229636    , 0.596663944406    ,
 0.736493273797    , 0.930767049406    , 1.14955089561     , 1.37481832084     ,
 1.62580827298     , 1.9648927308      , 2.48218912687     , 3.26555588382     ,
 4.37300916939     , 5.82543814194     , 7.60208078292     , 9.61862624477     ,
 11.7425916448     , 13.8944190586     , 16.1326180512     , 18.5905020506     ,
 21.3209510082     , 24.2157111541     , 27.0492701837     , 29.5740432739     ,
 31.6188683281     , 33.1877431628     , 34.4928192301     , 35.8210692823     ,
 37.2937595154     , 38.7604106676     , 39.9581948792     , 40.7478131966     ,
 41.1561130511     , 41.2289634094     , 40.9104475546     , 40.0714103998     ,
 38.6410172174     , 36.7210282974     , 34.5608453994     , 32.3892996107     ,
 30.265187434      , 28.088009227      , 25.723116012      , 23.1112637807     ,
 20.3190477456     , 17.5445633452     , 15.0497693998     , 13.0114381551     ,
 11.4014650541     , 10.0258702392     , 8.69794157288     , 7.37863184026     ,
 6.1574687468      , 5.12462838092     , 4.28902282815     , 3.60625191728     ,
 3.03763171782     , 2.56226514833     , 2.1616489128      , 1.82089514951     ,
 1.53947961806     , 1.3290117705      , 1.19994730405     , 1.14679546093     ,
 1.14180186019     , 1.14846233879     , 1.14366233006     , 1.11984955254     ,
 1.06904171022     , 0.981476216031    , 0.865397338788    , 0.756821428628    ,
 0.703113166944    , 0.742103775822    , 0.89792633861     , 1.17960375731     ,
 1.55814496446     , 1.9420728653      , 2.20610157652     , 2.27505988007     ,
 2.18137301997     , 2.03246452719     , 1.92990319774     , 1.92358354202     ,
 2.02205199282     , 2.22301410095     , 2.53042415382     , 2.94035869373     ,
 3.39747237035     , 3.77348993694     , 3.92982015855     , 3.82354874109     ,
 3.53117224331     , 3.16313916894     , 2.79028045424     , 2.4588405         ,
 2.22131244275     , 2.11037101682     , 2.09867228467     , 2.11214565937     ,
 2.08961739094     , 2.03254748079     , 2.00876799607     , 2.12230593966     ,
 2.48866527175     , 3.24628050159     , 4.60916665987     , 6.94423874796     ,
 10.8470733203     , 17.1867789378     , 27.0746289529     , 41.6807462142     ,
 61.861666893      , 87.7441387642     , 118.539267596     , 152.634302793     ,
 187.683381549     , 220.631241596     , 248.135278756     , 267.650482649     ,
 271.051790548     , 268.589649422     , 263.116563367     , 255.48736885      ,
 245.307240915     , 231.755323537     , 214.400024194     , 193.42853567      ,
 169.487526718     , 143.651273468     , 117.505270323     , 92.9154189294     ,
 71.4573940921     , 53.9519152295     , 40.3976044298     , 30.217133042      ,
 22.625250602      , 16.9622116721     , 12.8210374364     , 9.91571116023     ,
 7.91208928035     , 6.45575825395     , 5.31162912424     , 4.39063559693     ,
 3.65600823741     , 3.06634696781     , 2.60129606301     , 2.27127922784     ,
 2.06411801461     , 1.91188473901     , 1.73938144384     , 1.52402885326     ,
 1.2872539161      , 1.05114681791     , 0.827030455668    , 0.629515281482    ,
 0.477697039667    , 0.383032555371    , 0.344495461913    , 0.352798317358    ,
 0.392995886971    , 0.445541787659    , 0.491028864924    , 0.514781047432    ,
 0.508899029492    , 0.478308581975    , 0.448112842746    , 0.455076382764    ,
 0.51877433863     , 0.617765668628    , 0.700417337204    , 0.726076887278    ,
 0.69853324873     , 0.660044982923    , 0.654007130517    , 0.693234729118    ,
 0.757432603625    , 0.811638022287    , 0.829203006653    , 0.809515945109    ,
 0.779374626527    , 0.776530995027    , 0.834676665486    , 0.979554650093    ,
 1.21883942199     , 1.52485781809     , 1.84511012283     , 2.15126684528     ,
 2.48230414696     , 2.94270719794     , 3.66415322476     , 4.75887148782     ,
 6.28811352879     , 8.25152587164     , 10.5699562694     , 13.0578167915     ,
 15.4713556243     , 17.6775042667     , 19.7797121142     , 22.0134100996     ,
 24.5033163067     , 27.1442126315     , 29.6857484874     , 31.8779450546     ,
 33.563434606      , 34.7374495451     , 35.578056814      , 36.3603956481     ,
 37.2520051038     , 38.1714798364     , 38.8729030896     , 39.1649248315     ,
 39.0256839401     , 38.5285340892     , 37.7121816996     , 36.5429461961     ,
 34.9864272658     , 33.099002567      , 31.033970975      , 28.9490112248     ,
 26.9096923408     , 24.8760153618     , 22.7655293443     , 20.5311662133     ,
 18.2119306039     , 15.9428073078     , 13.9018771567     , 12.1963751219     ,
 10.7737977838     , 9.46206530557     , 8.12192521031     , 6.7655549807      ,
 5.5230931463      , 4.50731270744     , 3.7314786225      , 3.14284087253     ,
 2.6867092259      , 2.32051646752     , 2.00352441044     , 1.70762713118     ,
 1.43262521093     , 1.1991770711      , 1.02946387686     , 0.930900910353    ,
 0.888942397143    , 0.876950044143    , 0.875228191608    , 0.874556336909    ,
 0.863969667752    , 0.830127969956    , 0.774528158462    , 0.722719836161    ,
 0.711430045237    , 0.771844305406    , 0.926426637387    , 1.18519880995     ,
 1.52200404163     , 1.85484519642     , 2.07906717968     , 2.14400464218     ,
 2.09272153601     , 2.01848970689     , 1.99237209155     , 2.03776047659     ,
 2.15566720657     , 2.35612728223     , 2.66599843096     , 3.1017698387      ,
 3.6124276232      , 4.05084663615     , 4.24725343613     , 4.14078970156     ,
 3.81820944329     , 3.4160254068      , 3.02320881656     , 2.68642348802     ,
 2.44916552934     , 2.33931531679     , 2.33595853908     , 2.37908917358     ,
 2.41815246886     , 2.45253774694     , 2.54079513189     , 2.79537482117     ,
 3.38754776062     , 4.57156925671     , 6.72968602519     , 10.4330205817     ,
 16.4918649395     , 25.9537564894     , 40.0006279513     , 59.6644018057     ,
 85.3120946113     , 116.107355191     , 149.912865811     , 183.822851136     ,
 214.8727052       , 240.439421226     , 258.541874542     , 268.429439185     ,
 251.509521907     , 245.764712563     , 239.37539297      , 232.165457184     ,
 222.586928086     , 208.972336131     , 190.696356648     , 168.463486907     ,
 143.814738642     , 118.560359947     , 94.492107607      , 73.139483468      ,
 55.4445624978     , 41.5989022859     , 31.190277572      , 23.5027237244     ,
 17.7961937159     , 13.5151114022     , 10.3508522097     , 8.1117551203      ,
 6.56591935593     , 5.45056430696     , 4.58136242714     , 3.87861924904     ,
 3.30267309976     , 2.81863063253     , 2.42027341717     , 2.13111970551     ,
 1.94764907797     , 1.8053969602      , 1.62868729325     , 1.39576900116     ,
 1.13547006777     , 0.88329317421     , 0.66296354583     , 0.492386106371    ,
 0.38365110362     , 0.338684241051    , 0.352124844151    , 0.413806136715    ,
 0.504176239958    , 0.594667396155    , 0.660326716639    , 0.689767241152    ,
 0.682354403461    , 0.646622802584    , 0.60789979178     , 0.60555971682     ,
 0.665131209434    , 0.768309731777    , 0.858746663771    , 0.886968467986    ,
 0.853182118109    , 0.804887389905    , 0.792737933945    , 0.831402662802    ,
 0.899817265599    , 0.967693339864    , 1.01740526881     , 1.0503328128      ,
 1.08270153874     , 1.13944012687     , 1.25429465719     , 1.46734628359     ,
 1.79854021296     , 2.21399380823     , 2.64167783906     , 3.04417817002     ,
 3.47744746707     , 4.08099894359     , 5.02011258962     , 6.42465441012     ,
 8.34881711067     , 10.751825901      , 13.4769865558     , 16.2405903671     ,
 18.7210300978     , 20.7700330675     , 22.5481694925     , 24.3833326166     ,
 26.4721916178     , 28.7354279441     , 30.9214707245     , 32.7784400565     ,
 34.1443135838     , 34.9864303707     , 35.4332883662     , 35.7296450441     ,
 36.0715614176     , 36.4438712435     , 36.6343726665     , 36.4257306463     ,
 35.7681912738     , 34.7685813016     , 33.5534103196     , 32.1801352451     ,
 30.6595088328     , 29.0098017524     , 27.268115898      , 25.4713427806     ,
 23.6435252225     , 21.7926096104     , 19.9160331836     , 18.0216595593     ,
 16.1505618657     , 14.3782031777     , 12.7813200066     , 11.3804357275     ,
 10.1049404279     , 8.83380625814     , 7.49973426259     , 6.1626486359      ,
 4.96825343793     , 4.02878831339     , 3.35290611162     , 2.87906773927     ,
 2.53599062554     , 2.25882748725     , 1.99012685916     , 1.70222447595     ,
 1.40982098506     , 1.14796937381     , 0.944305885484    , 0.808755619697    ,
 0.734130721855    , 0.70382922721     , 0.703300000356    , 0.721139266929    ,
 0.740756862471    , 0.743382277664    , 0.725269547939    , 0.705358406977    ,
 0.711948631382    , 0.767152722274    , 0.885411830701    , 1.07267719162     ,
 1.30993538626     , 1.54150281319     , 1.70275193282     , 1.77259274501     ,
 1.79003314143     , 1.81295106644     , 1.87108976572     , 1.96408598352     ,
 2.09149722055     , 2.27490433089     , 2.55569859942     , 2.9640056753      ,
 3.46057662677     , 3.90428536726     , 4.1218163184      , 4.0440075455      ,
 3.75414182731     , 3.39106564001     , 3.04329393548     , 2.7490206273      ,
 2.54079265828     , 2.44419389988     , 2.45209416404     , 2.53088378996     ,
 2.65312993302     , 2.82087625596     , 3.07822104525     , 3.53996807838     ,
 4.43978806274     , 6.17315213196     , 9.32690303406     , 14.7031120734     ,
 23.3121576785     , 36.2836070627     , 54.6587173277     , 79.0173418664     ,
 108.916706547     , 142.393481826     , 176.094008921     , 206.27688991      ,
 230.050117137     , 245.96267682      , 253.924502717     , 255.054245968     ,
 225.218297091     , 218.526781424     , 212.708024662     , 206.544536751     ,
 197.71903726      , 184.253797703     , 165.718345286     , 143.397128904     ,
 119.482266041     , 96.1346816864     , 75.0239207261     , 57.2068373585     ,
 43.0634830044     , 32.3455861972     , 24.4231384337     , 18.5818274981     ,
 14.2163747747     , 10.9185541721     , 8.46759578479     , 6.71733387866     ,
 5.49012691172     , 4.5929608462      , 3.89233733863     , 3.32506455569     ,
 2.85404860071     , 2.45163746614     , 2.11990240385     , 1.88416479057     ,
 1.73915334767     , 1.62079791112     , 1.45705364263     , 1.23225117074     ,
 0.982772538584    , 0.749978180667    , 0.557929601504    , 0.419707148649    ,
 0.342866775431    , 0.330394359187    , 0.382788862667    , 0.493373827505    ,
 0.636877972152    , 0.771300174395    , 0.860598465429    , 0.893128581961    ,
 0.876407657439    , 0.826180952674    , 0.769526072335    , 0.74629047794     ,
 0.786867718121    , 0.880916296774    , 0.975246970528    , 1.01414387896     ,
 0.98816698103     , 0.941992772673    , 0.932627567008    , 0.983346511133    ,
 1.07801761262     , 1.18871640667     , 1.29868069987     , 1.4036459736      ,
 1.50552623875     , 1.61663875219     , 1.77355787091     , 2.03414371744     ,
 2.43538664402     , 2.94656742438     , 3.48804474499     , 4.01705102228     ,
 4.594132537       , 5.37194403748     , 6.53235023312     , 8.21402728323     ,
 10.4510913064     , 13.1388023653     , 16.0310614692     , 18.7804836262     ,
 21.0666331179     , 22.7944057505     , 24.1847577627     , 25.6068551038     ,
 27.2840103942     , 29.1581644024     , 30.9917434251     , 32.5350793819     ,
 33.6150576466     , 34.1695491548     , 34.277904599      , 34.1411209223     ,
 33.9599573141     , 33.7812127407     , 33.4627114463     , 32.8152194672     ,
 31.7850789489     , 30.4867167194     , 29.0837819506     , 27.6857660771     ,
 26.3376844127     , 25.0316036946     , 23.7044173271     , 22.2731196011     ,
 20.7038081633     , 19.0358373179     , 17.3454150882     , 15.7081000368     ,
 14.1833665088     , 12.8011582574     , 11.5505970927     , 10.3843999319     ,
 9.23619852655     , 8.04771519608     , 6.81093745512     , 5.60134316357     ,
 4.54991335343     , 3.75566316875     , 3.22348149501     , 2.88441507622     ,
 2.64795024534     , 2.42631979186     , 2.15346097698     , 1.8187438221      ,
 1.46894900559     , 1.16153664354     , 0.925271645611    , 0.761998002064    ,
 0.663724966898    , 0.621345866853    , 0.62551599103     , 0.661442556998    ,
 0.703917337417    , 0.726675018398    , 0.722384550864    , 0.708601681526    ,
 0.710893923515    , 0.744717812227    , 0.813943934428    , 0.915834220186    ,

 1.03793508472     , 1.15607515962     , 1.2496635492      , 1.32273045937     ,
 1.40072989051     , 1.50237606858     , 1.62264309585     , 1.74737027274     ,
 1.87746712112     , 2.03740343706     , 2.26778256071     , 2.60138588933     ,
 3.01568136992     , 3.39933927806     , 3.60487958595     , 3.56861858579     ,
 3.36054582441     , 3.10063402647     , 2.86019395653     , 2.66086955858     ,
 2.52079029119     , 2.46182204338     , 2.49245155809     , 2.61147625523     ,
 2.82244800669     , 3.13652890134     , 3.58816042372     , 4.29987519839     ,
 5.57465679532     , 7.95517136057     , 12.2319657223     , 19.4192319081     ,
 30.6704445083     , 47.0708148682     , 69.2975178139     , 97.186650782      ,
 129.273925977     , 162.564109696     , 193.001450331     , 216.782533452     ,
 231.782968605     , 238.070248982     , 237.361523668     , 232.18628337      ,
 196.879198632     , 190.926560435     , 186.360978541     , 181.186618199     ,
 172.841585978     , 159.557892953     , 141.339457596     , 119.920436964     ,
 97.7868850697     , 77.1003404543     , 59.2231557266     , 44.7494817325     ,
 33.6457759069     , 25.418506331      , 19.373756195      , 14.874067696      ,
 11.4644914824     , 8.87407482407     , 6.94947470467     , 5.56350192331     ,
 4.56726740866     , 3.82015170711     , 3.23194841425     , 2.75504990621     ,
 2.35576330137     , 2.01320817196     , 1.73553968745     , 1.54722924801     ,
 1.44100221769     , 1.35680722777     , 1.22984797302     , 1.04839695906     ,
 0.847831091931    , 0.664582553721    , 0.514845858739    , 0.405087660707    ,
 0.344038726422    , 0.345267477027    , 0.42294810173     , 0.577641870637    ,
 0.778643436171    , 0.967505839332    , 1.09069976534     , 1.12936734981     ,
 1.09683631792     , 1.01994551063     , 0.932540740532    , 0.875720845843    ,
 0.883543520219    , 0.956882738475    , 1.05344592945     , 1.11543720143     ,
 1.11838271945     , 1.09387540425     , 1.10080192355     , 1.1759188214      ,
 1.31394673817     , 1.48696698138     , 1.67030390973     , 1.84882483296     ,
 2.01364637996     , 2.17199287613     , 2.36651513665     , 2.66915290052     ,
 3.13030796635     , 3.72836886034     , 4.38927270418     , 5.06993476341     ,
 5.82241407556     , 6.7899533311      , 8.15440608712     , 10.0546570302     ,
 12.493125261      , 15.2850906534     , 18.0969640297     , 20.5625502401     ,
 22.440544422      , 23.7501888503     , 24.7723476965     , 25.8629067231     ,
 27.2121753897     , 28.7538095823     , 30.261371755      , 31.4954557775     ,
 32.2867779784     , 32.5651245993     , 32.3780685624     , 31.8815950044     ,
 31.2623963027     , 30.6186923439     , 29.899834371      , 28.9803765414     ,
 27.8056134993     , 26.452172943      , 25.0605523641     , 23.7531024826     ,
 22.6023681045     , 21.6007462954     , 20.6365878954     , 19.5545126285     ,
 18.2721608379     , 16.825810821      , 15.3183268974     , 13.8577034835     ,
 12.5234099842     , 11.3372045476     , 10.2570088596     , 9.21914824672     ,
 8.18452867969     , 7.14244219083     , 6.10399049819     , 5.12185379083     ,
 4.2936430151      , 3.70330989766     , 3.35277239744     , 3.16119805578     ,
 3.01400319554     , 2.80429718847     , 2.47163573792     , 2.03982168605     ,
 1.59901931248     , 1.23052389736     , 0.958885612534    , 0.771282883418    ,
 0.654356250895    , 0.604065774638    , 0.614557897404    , 0.665429016875    ,
 0.720554004208    , 0.745902072331    , 0.734030432696    , 0.70787393938     ,
 0.697776373287    , 0.717021742992    , 0.757402855239    , 0.800851621811    ,
 0.833779043936    , 0.856906470988    , 0.886863970921    , 0.946842728364    ,
 1.04939007589     , 1.18454591082     , 1.32752603642     , 1.46035968701     ,
 1.58473457901     , 1.7183381153      , 1.88816671904     , 2.12045626862     ,
 2.40958851545     , 2.68645013527     , 2.8487325496      , 2.8508490806      ,
 2.74650831012     , 2.62450784685     , 2.5290739194      , 2.46076932513     ,
 2.42031962513     , 2.42280872975     , 2.49000464481     , 2.65144744439     ,
 2.9419039469      , 3.38861440603     , 4.03280622034     , 5.02316500367     ,
 6.73667241253     , 9.84194348331     , 15.2841443037     , 24.2154106513     ,
 37.8315625108     , 57.0378756875     , 81.974405301      , 111.571599641     ,
 143.343388295     , 173.614101782     , 198.347094948     , 214.475991008     ,
 221.092708595     , 219.659579712     , 213.124555045     , 204.688181789     ,
 169.506954226     , 165.233024107     , 162.01841792      , 157.478788761     ,
 149.279007581     , 136.21125547      , 118.781463225     , 98.959725676      ,
 79.204641114      , 61.4512219658     , 46.7026201281     , 35.1703366845     ,
 26.5450926509     , 20.228305174      , 15.5623969979     , 12.0234594073     ,
 9.29223294544     , 7.20568624589     , 5.66112348277     , 4.54583994943     ,
 3.73241227948     , 3.11620844936     , 2.63276635742     , 2.23958374638     ,
 1.90209084715     , 1.60427806116     , 1.36038196398     , 1.19717094154     ,
 1.11239095974     , 1.0590453932      , 0.984186567519    , 0.874415263001    ,
 0.751141961589    , 0.634629238625    , 0.529587901256    , 0.439243810146    ,
 0.379887043272    , 0.381191914853    , 0.473947857758    , 0.667212971563    ,
 0.925991157292    , 1.17590138507     , 1.34323449115     , 1.39547398593     ,
 1.34621521287     , 1.23408861349     , 1.10508249797     , 1.00507589209     ,
 0.971620773519    , 1.01762516714     , 1.11623081806     , 1.21146949053     ,
 1.26139111658     , 1.27683284607     , 1.31299130047     , 1.42099010185     ,
 1.60924712843     , 1.84757441141     , 2.09749299081     , 2.33333762774     ,
 2.54673841271     , 2.75335789145     , 3.00404542168     , 3.37231055267     ,
 3.90627565466     , 4.58844245644     , 5.35675579936     , 6.17392277891     ,
 7.08088106493     , 8.2029176265      , 9.71299264584     , 11.7420882158     ,
 14.2554669052     , 16.9933785149     , 19.5565500316     , 21.5935066023     ,
 22.9726824991     , 23.8422398453     , 24.5368100437     , 25.3760825221     ,
 26.486298476      , 27.7627012673     , 28.9707145617     , 29.8825928726     ,
 30.3572187286     , 30.3546066025     , 29.9271833721     , 29.2031251435     ,
 28.3414620798     , 27.4579110974     , 26.5669719653     , 25.598595278      ,
 24.4864134384     , 23.241441714      , 21.949895403      , 20.7313331833     ,
 19.6920179746     , 18.8585294373     , 18.1326106981     , 17.3488429689     ,
 16.3938384064     , 15.2541381314     , 13.97807441       , 12.6446261706     ,
 11.3488964179     , 10.1561564095     , 9.06792224669     , 8.05857714143     ,
 7.12275333958     , 6.26265526941     , 5.46658275931     , 4.7442187489      ,
 4.16187743504     , 3.79366678188     , 3.63364438651     , 3.57856798572     ,
 3.48701762043     , 3.24500314679     , 2.81715478656     , 2.2734004371      ,
 1.74397969384     , 1.32315186431     , 1.02417946212     , 0.818723048042    ,
 0.688097079127    , 0.630822831607    , 0.641348545161    , 0.692864401862    ,
 0.740954028696    , 0.748922493051    , 0.714956198096    , 0.672421629355    ,
 0.660278156816    , 0.690995845454    , 0.741275522362    , 0.770418361564    ,
 0.754381254617    , 0.709256379078    , 0.680780500047    , 0.708523483958    ,
 0.798457400003    , 0.925129753175    , 1.05619538816     , 1.17503936073     ,
 1.28252624783     , 1.38530311316     , 1.49301096272     , 1.62211479957     ,
 1.78046959571     , 1.93977457474     , 2.04614028302     , 2.07688243023     ,
 2.07034121007     , 2.08194957712     , 2.12826824015     , 2.19034121993     ,
 2.25267520205     , 2.32328037006     , 2.43400886388     , 2.63774265758     ,
 2.99452670472     , 3.55486319784     , 4.38973283602     , 5.69533941316     ,
 7.91554640561     , 11.7946536081     , 18.3434382892     , 28.736050363      ,
 44.079569513      , 64.9738024919     , 90.9451740219     , 120.064610154     ,
 149.083564592     , 174.160565213     , 191.939391487     , 200.616420461     ,
 200.588233848     , 194.275900901     , 185.104902567     , 176.212599019     ,
 144.415395267     , 142.122047206     , 140.050661037     , 135.818776745     ,
 127.620894391     , 114.93240677      , 98.6855968837     , 80.8754630683     ,
 63.7201786709     , 48.8336539211     , 36.9002907313     , 27.8539383343     ,
 21.2119434034     , 16.3473755996     , 12.6860778119     , 9.82959963024     ,
 7.57505473056     , 5.84065481233     , 4.56477001162     , 3.65451077506     ,
 3.00249899442     , 2.52275810366     , 2.15576480181     , 1.85276438875     ,
 1.57541355823     , 1.3117863239      , 1.08233208679     , 0.919458575506    ,
 0.833012617617    , 0.796920978853    , 0.773346543868    , 0.742479397773    ,
 0.702434154018    , 0.651157426973    , 0.582932200476    , 0.502887733027    ,
 0.438480588298    , 0.434986431906    , 0.536678737237    , 0.758926133923    ,
 1.0644092012      , 1.36861746586     , 1.58193145642     , 1.65560893169     ,
 1.59642619332     , 1.45096667729     , 1.27963527876     , 1.13655275703     ,
 1.06268011806     , 1.08073356535     , 1.1792380252      , 1.30727377561     ,
 1.40871054869     , 1.47364701105     , 1.5505370693      , 1.70152830669     ,
 1.94609392624     , 2.24804185882     , 2.5514083606      , 2.82325861759     ,
 3.06932882331     , 3.32824868956     , 3.65998994108     , 4.12378110073     ,
 4.74449342592     , 5.49610436116     , 6.32755825849     , 7.21299022295     ,
 8.1895095717      , 9.36965185874     , 10.9161305933     , 12.9463101942     ,
 15.3939211353     , 17.9546864249     , 20.2049574547     , 21.8243196783     ,
 22.7652152048     , 23.261435743      , 23.6787283516     , 24.3074095961     ,
 25.2213670435     , 26.2718061721     , 27.1998567254     , 27.784924166      ,
 27.9318300337     , 27.6659392801     , 27.0848311266     , 26.3145551002     ,
 25.4745780719     , 24.6450194456     , 23.8403378597     , 23.0057851897     ,
 22.0580634746     , 20.955165884      , 19.7425884585     , 18.5459683751     ,
 17.512406531      , 16.7201198679     , 16.121627595      , 15.5837342848     ,
 14.9749105737     , 14.1988129447     , 13.191680773      , 11.9608561678     ,
 10.6145189839     , 9.29705842074     , 8.10198325653     , 7.06889460174     ,
 6.21562180373     , 5.52569530147     , 4.94347092023     , 4.43844542721     ,
 4.05915015468     , 3.87534770942     , 3.86777365761     , 3.90569936299     ,
 3.8271042736      , 3.52807746137     , 3.01313603811     , 2.39575727471     ,
 1.82709096173     , 1.39571905765     , 1.09834339996     , 0.894750386983    ,
 0.762286968218    , 0.698267114976    , 0.69442249817     , 0.72084385327     ,
 0.734266576889    , 0.70577521418     , 0.644924918206    , 0.595001480342    ,
 0.599802180985    , 0.667313931002    , 0.756655407014    , 0.802577283222    ,
 0.767509255877    , 0.677023463453    , 0.599088516655    , 0.587406361439    ,
 0.646802678666    , 0.745205392345    , 0.848076759132    , 0.940172867957    ,
 1.02045911776     , 1.08690496972     , 1.13706111954     , 1.1803664628      ,
 1.23339814349     , 1.29753736937     , 1.35647435223     , 1.40555478114     ,
 1.46944182429     , 1.57612038407     , 1.72221537847     , 1.8769727873      ,
 2.01528132468     , 2.14172564854     , 2.29530995047     , 2.54264375361     ,
 2.96217822505     , 3.63521565069     , 4.68124609369     , 6.35094064991     ,
 9.12520952527     , 13.7515522657     , 21.2022880989     , 32.5489688364     ,
 48.6794709501     , 69.8001468293     , 94.8710752945     , 121.369851588     ,
 145.753513906     , 164.536381022     , 175.420250408     , 177.959053661     ,
 173.621188639     , 165.273991411     , 156.1825609       , 148.884024752     ,
 121.917373534     , 121.405231922     , 120.143259448     , 116.057236005     ,
 107.978410615     , 95.9896217752     , 81.2805727981     , 65.6974504415     ,
 51.1115040623     , 38.817803373      , 29.2740042595     , 22.2517392188     ,
 17.1768966558     , 13.4289965271     , 10.5208522433     , 8.16707033041     ,
 6.25945415336     , 4.77749789279     , 3.69534962614     , 2.9450897044      ,
 2.43738459223     , 2.09050234863     , 1.83566864323     , 1.61431777823     ,
 1.38765768787     , 1.14959030462     , 0.925301474522    , 0.751792381597    ,
 0.651826360907    , 0.620895097683    , 0.635302946208    , 0.667115583289    ,
 0.69071210712     , 0.684463283006    , 0.637739212216    , 0.561784419635    ,
 0.493774223295    , 0.487522601339    , 0.592431686888    , 0.82596991424     ,
 1.15226999837     , 1.48734443981     , 1.73577673167     , 1.8346741316      ,
 1.77845987941     , 1.61522859357     , 1.41702055177     , 1.24583679132     ,
 1.14419460125     , 1.14001978105     , 1.23401561305     , 1.38397917549     ,
 1.52937496123     , 1.64741994406     , 1.77894340845     , 1.98959275353     ,
 2.30310515777     , 2.67434630387     , 3.02897410378     , 3.32816847706     ,
 3.5972069792      , 3.90350628366     , 4.31523719767     , 4.86855829154     ,
 5.55455381625     , 6.33187103654     , 7.15797428592     , 8.0192809219      ,
 8.95337514027     , 10.0657301727     , 11.5108005796     , 13.3935155304     ,
 15.6339753205     , 17.928730558      , 19.8780278264     , 21.1972860047     ,
 21.8677136582     , 22.1322530179     , 22.3462907721     , 22.7818965135     ,
 23.4958189572     , 24.3216323604     , 24.987088101      , 25.2825216933     ,
 25.1603647882     , 24.7149469779     , 24.0999016049     , 23.4521820068     ,
 22.8472890767     , 22.2925004447     , 21.744298312      , 21.1221665547     ,
 20.3300874867     , 19.3130389925     , 18.1173473702     , 16.8925329061     ,
 15.820197913      , 15.0176874209     , 14.4869540207     , 14.1364034916     ,
 13.8236813569     , 13.3706820055     , 12.60321927       , 11.4600089539     ,
 10.0607886432     , 8.62415471253     , 7.33148199032     , 6.27997795481     ,
 5.49640701085     , 4.93482855126     , 4.49950726168     , 4.13358836649     ,
 3.8778102841      , 3.79976446733     , 3.86995080717     , 3.94127308723     ,
 3.84715204081     , 3.50554098095     , 2.95890716319     , 2.34555878659     ,
 1.81258177037     , 1.42852564993     , 1.17432896291     , 1.00285890736     ,
 0.886595345597    , 0.816809816638    , 0.781660590812    , 0.755444747358    ,
 0.70877715471     , 0.6312808079      , 0.546099430902    , 0.499734623434    ,
 0.531074278098    , 0.638133326809    , 0.765177126576    , 0.831075976848    ,
 0.791141583261    , 0.677407587836    , 0.570127703572    , 0.530181408905    ,
 0.562573584952    , 0.633531538488    , 0.707932115154    , 0.769964864009    ,
 0.816861270519    , 0.844093092183    , 0.846427946491    , 0.831224247388    ,
 0.818528435297    , 0.824530540402    , 0.853581193246    , 0.909912076186    ,
 1.00719000625     , 1.15601080244     , 1.34429339228     , 1.54014245483     ,
 1.7185566624      , 1.88548714424     , 2.08290617108     , 2.38200507237     ,
 2.87630212892     , 3.68471220708     , 4.98001576056     , 7.0485487221      ,
 10.3547326768     , 15.5699988587     , 23.5375976605     , 35.1285338945     ,
 50.9206733198     , 70.7115723148     , 93.0687980794     , 115.292315927     ,
 134.073705318     , 146.653866007     , 151.811255563     , 150.165486376     ,
 143.833043444     , 135.697002983     , 128.474429936     , 123.835676655     ,
 102.056629752     , 102.807236172     , 102.009402259     , 98.0665482257     ,
 90.3946330567     , 79.4933469608     , 66.6101802891     , 53.3181855804     ,
 41.1150227592     , 31.0327001577     , 23.4065925294     , 17.9551997147     ,
 14.0851313416     , 11.2006237614     , 8.88207698657     , 6.92739138635     ,
 5.29722166334     , 4.01482561945     , 3.08311222292     , 2.45802192331     ,
 2.06466284697     , 1.81941427631     , 1.64301829279     , 1.47330158815     ,
 1.27861649898     , 1.06098038054     , 0.846814132729    , 0.67194289264     ,
 0.56551082104     , 0.537256601126    , 0.572628601681    , 0.63716540344     ,
 0.689506546865    , 0.698632424704    , 0.656816903906    , 0.583013443515    ,
 0.517826104082    , 0.512394137346    , 0.611340434147    , 0.831137054082    ,
 1.14315586199     , 1.47575559201     , 1.73896689823     , 1.86099865683     ,
 1.82225465093     , 1.66600117809     , 1.46879382592     , 1.29605925199     ,
 1.18900877339     , 1.17591709027     , 1.2651384608      , 1.42674753698     ,
 1.60834604688     , 1.78480681517     , 1.98734746917     , 2.2741190978      ,
 2.66626418935     , 3.11304515109     , 3.52787834755     , 3.86498834045     ,
 4.15969243599     , 4.49706105982     , 4.94844164859     , 5.53136998601     ,
 6.21384836551     , 6.94842760072     , 7.70242301979     , 8.46788160104     ,
 9.2745854812      , 10.2176106013     , 11.4456820335     , 13.0599684142     ,
 14.9887305004     , 16.9675307292     , 18.6563693505     , 19.8070179735     ,
 20.3825047815     , 20.5684205765     , 20.6662884756     , 20.9280622794     ,
 21.4229315024     , 22.0102506105     , 22.4451482566     , 22.5476955229     ,
 22.3023716617     , 21.8326102664     , 21.3115389325     , 20.8757229856     ,
 20.5682915584     , 20.3337592981     , 20.0603970292     , 19.625151349      ,
 18.92678474       , 17.9332450617     , 16.7260280921     , 15.4837913221     ,
 14.4002096789     , 13.6008135742     , 13.1129147826     , 12.8753524631     ,
 12.7421833183     , 12.4863862438     , 11.8740938164     , 10.8120679093     ,
 9.4256658948      , 7.966425053       , 6.6582119704      , 5.62782430136     ,
 4.90422268654     , 4.42300680665     , 4.06768131706     , 3.76835117892     ,
 3.55889742627     , 3.50389416004     , 3.57577475285     , 3.63498903703     ,
 3.52882396244     , 3.19569325592     , 2.69549320454     , 2.16450321204     ,
 1.72810181315     , 1.43350340389     , 1.25373191183     , 1.13915490582     ,
 1.05450365772     , 0.980908478161    , 0.904177207406    , 0.810235003919    ,
 0.692992588002    , 0.565879794686    , 0.46281088405     , 0.423972764295    ,
 0.473272742792    , 0.595933553179    , 0.730518623051    , 0.797117164976    ,
 0.756041415561    , 0.64252987195     , 0.534645906946    , 0.488575119298    ,
 0.507611006021    , 0.55980456336     , 0.611268291249    , 0.645072116105    ,
 0.658236547352    , 0.649813802252    , 0.619233723319    , 0.574600284224    ,
 0.533730546671    , 0.514311919523    , 0.527008123905    , 0.578541209688    ,
 0.676163720309    , 0.822878468185    , 1.00730452666     , 1.20585254495     ,
 1.40257999778     , 1.60731880703     , 1.8586182512      , 2.22473184125     ,
 2.81419826337     , 3.78622015505     , 5.35497521363     , 7.80280345164     ,
 11.5155063541     , 17.0227092045     , 24.981446264      , 36.0137475259     ,
 50.3667336598     , 67.5060366708     , 85.8653164981     , 102.993309873     ,
 116.224879881     , 123.66080004      , 124.907482663     , 121.168110461     ,
 114.744253009     , 108.229556039     , 103.643690792     , 101.784493466     ,
 84.9297912278     , 86.3488679123     , 85.7571643774     , 82.0528842732     ,
 75.0909803235     , 65.5762768745     , 54.6479808244     , 43.5476154245     ,
 33.4345518343     , 25.1535987163     , 18.9982278828     , 14.7071467001     ,
 11.7197764807     , 9.47999710723     , 7.61847531028     , 5.98832116713     ,
 4.59515760108     , 3.48863399728     , 2.68724212856     , 2.16037492503     ,
 1.84189195592     , 1.64918854079     , 1.50330904719     , 1.35004114477     ,
 1.1707224643      , 0.974876148268    , 0.785802739102    , 0.631556082456    ,
 0.538201362253    , 0.518788635498    , 0.56165424839     , 0.629618463302    ,
 0.677257738477    , 0.676232696056    , 0.62816735841     , 0.558313433197    ,
 0.502591605463    , 0.499103471134    , 0.580801797649    , 0.762986171416    ,
 1.0298392691      , 1.33001082539     , 1.58673354799     , 1.7255462108      ,
 1.71485400121     , 1.58843558882     , 1.41943221213     , 1.27223709893     ,
 1.18572769307     , 1.18488302714     , 1.27977384332     , 1.4529606139      ,
 1.66921820088     , 1.90890882651     , 2.18988761355     , 2.5515783216      ,
 3.00898771588     , 3.51758683959     , 3.99451166611     , 4.38772110039     ,
 4.72202137908     , 5.07369883544     , 5.50684152816     , 6.03390359644     ,
 6.62626729428     , 7.25152712116     , 7.89138666609     , 8.53272455798     ,
 9.18219096619     , 9.91619884761     , 10.8802175115     , 12.1806627245     ,
 13.7651482753     , 15.420812298      , 16.8789176887     , 17.9300219209     ,
 18.5059544244     , 18.711036683      , 18.7690940613     , 18.8972444803     ,
 19.1817459218     , 19.5398548284     , 19.8003672919     , 19.838288105      ,
 19.6485467949     , 19.3231992981     , 18.9906424397     , 18.7582235325     ,
 18.658585359      , 18.6230277664     , 18.510755115      , 18.1729207903     ,
 17.5138951462     , 16.5374628936     , 15.3606994908     , 14.1701177333     ,
 13.1407545106     , 12.380171074      , 11.9206159656     , 11.7190584776     ,
 11.636473322      , 11.4410872266     , 10.9006612661     , 9.92855658263     ,
 8.64385416185     , 7.28002675411     , 6.04918162359     , 5.07809775954     ,
 4.39922236963     , 3.95153841859     , 3.62191609796     , 3.3382071494      ,
 3.12379760907     , 3.03709701969     , 3.06428513886     , 3.09559206768     ,
 3.00446849915     , 2.73844302811     , 2.34740036924     , 1.94238117398     ,
 1.62175100404     , 1.42091936887     , 1.31649221462     , 1.26124324312     ,
 1.21173095929     , 1.1382586442      , 1.0255685659      , 0.87328871158     ,
 0.69911460902     , 0.537470078549    , 0.42709164469     , 0.394806007003    ,
 0.444669834164    , 0.550607951073    , 0.656096875979    , 0.698334300764    ,
 0.652866358467    , 0.554717428222    , 0.467150081798    , 0.431425313765    ,
 0.44698512301     , 0.486418223736    , 0.519701048663    , 0.530217752943    ,
 0.516625559931    , 0.484441555052    , 0.43995819075     , 0.391236341839    ,
 0.34898240429     , 0.324255994445    , 0.326568826699    , 0.363620591706    ,
 0.441325910012    , 0.561717865399    , 0.719341533283    , 0.904547050368    ,
 1.11557762428     , 1.36564425395     , 1.68352648626     , 2.1293159489      ,
 2.82547525985     , 3.96557125105     , 5.78194772013     , 8.51165207352     ,
 12.4160909686     , 17.8477542552     , 25.2586657217     , 35.0265635432     ,
 47.1236929249     , 60.835097358      , 74.7195807892     , 86.865076121      ,
 95.4172453784     , 99.2506033895     , 98.4617291425     , 94.3903368085     ,
 89.148179022      , 84.8486672476     , 82.8272389627     , 83.1963114138     ,
 70.6425970801     , 72.2523914033     , 71.7286804265     , 68.3725342973     ,
 62.3074585928     , 54.27393093       , 45.2099511819     , 36.0402900162     ,
 27.6644352103     , 20.8101414355     , 15.7644539346     , 12.3067911442     ,
 9.93003077095     , 8.13180801174     , 6.59296361223     , 5.21053605365     ,
 4.0193625387      , 3.07825000471     , 2.40271076107     , 1.9590226188      ,
 1.68322843458     , 1.50150610983     , 1.35020764212     , 1.19290203684     ,
 1.02398895636     , 0.85626686493     , 0.706861478246    , 0.593021739219    ,
 0.531020838256    , 0.528096949437    , 0.57070466345     , 0.623200749502    ,
 0.646208815075    , 0.622594844837    , 0.565723449857    , 0.503825340018    ,
 0.462092757341    , 0.460253302036    , 0.517633852399    , 0.649927853902    ,
 0.85656294104     , 1.10802515114     , 1.34344743912     , 1.4911025899      ,
 1.51139180891     , 1.42658364478     , 1.3015877911      , 1.19861287357     ,
 1.15555943014     , 1.19128941466     , 1.30998193445     , 1.50144777165     ,
 1.74918655995     , 2.04261149126     , 2.38441432576     , 2.78913494379     ,
 3.26598539141     , 3.79166043738     , 4.30795480866     , 4.7622661384      ,
 5.14958406559     , 5.50872645154     , 5.88376861165     , 6.2945425698      ,
 6.74089215997     , 7.22392966472     , 7.74241121769     , 8.2696348365      ,
 8.77999135317     , 9.32762957683     , 10.056193166      , 11.0785984828     ,
 12.356399673      , 13.7159241355     , 14.950953772      , 15.8975183088     ,
 16.4770165358     , 16.7325673351     , 16.8129023944     , 16.8812968291     ,
 17.0183927894     , 17.1983939747     , 17.3463424327     , 17.41218718       ,
 17.3932881738     , 17.3113549688     , 17.2001739512     , 17.1086321906     ,
 17.0713526484     , 17.0531106845     , 16.938295218      , 16.5932773533     ,
 15.9482412055     , 15.0375951737     , 13.9826583836     , 12.9362706538     ,
 12.0273236042     , 11.3367472029     , 10.8968553139     , 10.6776475515     ,
 10.5577793342     , 10.3358636563     , 9.8231269171      , 8.96023801312     ,
 7.84718705739     , 6.6631726075      , 5.57063489722     , 4.67549297622     ,
 4.01658438899     , 3.55597099416     , 3.20557268049     , 2.90202038454     ,
 2.65686991899     , 2.51822380023     , 2.48902808032     , 2.4979084628      ,
 2.44685582112     , 2.28074921742     , 2.02034368628     , 1.73992667743     ,
 1.5137083654      , 1.37595890354     , 1.31640937233     , 1.29694097549     ,
 1.27195356971     , 1.20544729523     , 1.0808915749      , 0.905421981363    ,
 0.710584871134    , 0.54239831225     , 0.439159902942    , 0.413878220755    ,
 0.453403420152    , 0.524696683324    , 0.581804552182    , 0.584688457842    ,
 0.526898173191    , 0.441810754766    , 0.374604915196    , 0.349580327378    ,
 0.362144829591    , 0.390281284798    , 0.409352372051    , 0.404765206041    ,
 0.377561424054    , 0.338685335507    , 0.298872739231    , 0.263538252941    ,
 0.234097074407    , 0.21292444941     , 0.207003711407    , 0.225985488681    ,
 0.27752216353     , 0.365215155326    , 0.490533864847    , 0.65856845741     ,
 0.882226201506    , 1.17694119932     , 1.55981935697     , 2.08088593063     ,
 2.87042136596     , 4.14005230669     , 6.11540107684     , 8.96596791038     ,
 12.8183559153     , 17.847608121      , 24.310726062      , 32.3837153729     ,
 41.8728099743     , 52.0576911817     , 61.7998626946     , 69.808082742      ,
 74.9635219116     , 76.7015506247     , 75.3302710746     , 72.0516550826     ,
 68.5758694812     , 66.4526985996     , 66.4330100695     , 68.2093963506     ,
 59.1641558422     , 60.6505157375     , 60.1104375099     , 57.1311175409     ,
 51.9678174175     , 45.2954700194     , 37.8328010224     , 30.2520862101     ,
 23.276210758      , 17.5559898046     , 13.3661919694     , 10.5113398977     ,
 8.53760392375     , 7.01036941455     , 5.67413478125     , 4.47113391064     ,
 3.45420322812     , 2.67426637378     , 2.12657573596     , 1.76166361358     ,
 1.51514963151     , 1.32938871479     , 1.16495798254     , 1.00479937907     ,
 0.851058394574    , 0.715272740751    , 0.609010262712    , 0.540888851929    ,
 0.51587727774     , 0.53080432077     , 0.56809041873     , 0.597177020365    ,
 0.590831327896    , 0.546028764718    , 0.485785011796    , 0.437419589759    ,
 0.413277806363    , 0.415013469729    , 0.449811304657    , 0.534674728803    ,
 0.682806822092    , 0.8833195245      , 1.09050535258     , 1.23936647394     ,
 1.28699211622     , 1.24501519398     , 1.16888145561     , 1.11908533295     ,
 1.13376628959     , 1.22364582614     , 1.38040258937     , 1.59272833496     ,
 1.85744549834     , 2.17336960836     , 2.53182060821     , 2.92508318912     ,
 3.35891940885     , 3.83960888152     , 4.34783921383     , 4.83909914147     ,
 5.2727996375      , 5.6366442235      , 5.94724364041     , 6.23617317529     ,
 6.5409027751      , 6.8996797004      , 7.32482238057     , 7.77352046699     ,
 8.19098680918     , 8.61205245409     , 9.17564872522     , 9.99378909203     ,
 11.0304781196     , 12.1342243083     , 13.1474377065     , 13.9576535082     ,
 14.5063813718     , 14.8133198855     , 14.9715112827     , 15.0780611542     ,
 15.1734100136     , 15.2559020969     , 15.3339313156     , 15.439605042      ,
 15.5872173175     , 15.7359688067     , 15.8203156925     , 15.817840284      ,
 15.7552834552     , 15.6370883835     , 15.4019933008     , 14.9730914935     ,
 14.3336776174     , 13.54124032       , 12.6851137969     , 11.8482369183     ,
 11.1000322947     , 10.4993238024     , 10.0811746553     , 9.82574968495     ,
 9.63464852002     , 9.35491293814     , 8.85905483321     , 8.12025807638     ,
 7.21165399396     , 6.24298733125     , 5.31065290961     , 4.48906552834     ,
 3.82348594097     , 3.30905752195     , 2.89697969063     , 2.5440905153      ,
 2.25457246783     , 2.0641572042      , 1.98697210459     , 1.98353915197     ,
 1.97798656777     , 1.90659753176     , 1.75747699422     , 1.5695746689      ,
 1.39788631925     , 1.27985861519     , 1.22198517297     , 1.20234331579     ,
 1.1840047133      , 1.13266610015     , 1.02882201125     , 0.875273306862    ,
 0.701705208126    , 0.554626850613    , 0.470243677672    , 0.453798102599    ,
 0.482939886312    , 0.52247413856     , 0.536334571022    , 0.502244354438    ,
 0.426978839604    , 0.342583181263    , 0.281745865823    , 0.257682756896    ,
 0.26360509191     , 0.281605775584    , 0.291552522507    , 0.28127780933     ,
 0.253688189243    , 0.222292122378    , 0.198621252258    , 0.183671780326    ,
 0.17046609133     , 0.154769089774    , 0.142680441       , 0.146737013835    ,
 0.176583857955    , 0.236348968531    , 0.331624868173    , 0.47826165773     ,
 0.700647612245    , 1.0171075943      , 1.43804804191     , 2.00586102966     ,
 2.84854704513     , 4.17334620266     , 6.18052236467     , 8.97520135896     ,
 12.5730136053     , 16.9979794044     , 22.3383362239     , 28.6262984679     ,
 35.6200796872     , 42.7342650426     , 49.1945816354     , 54.2386150108     ,
 57.2674463436     , 58.0458076005     , 56.9302149467     , 54.8944311115     ,
 53.2026351352     , 52.8602384015     , 54.1628021655     , 56.6087373045     ,
 50.2275203735     , 51.3962599256     , 50.7316314237     , 48.0277557543     ,
 43.600897508      , 38.0308761513     , 31.8521208425     , 25.5558748838     ,
 19.7345076572     , 14.9573496153     , 11.4598168897     , 9.05547291885     ,
 7.347161069       , 5.98203700914     , 4.77869927353     , 3.72129363104     ,
 2.86639425535     , 2.24273603765     , 1.81817039719     , 1.5281534121      ,
 1.31300776436     , 1.1347468734      , 0.974952596117    , 0.827174019758    ,
 0.693659969664    , 0.583784378435    , 0.508786311865    , 0.474608846216    ,
 0.477300533164    , 0.502662496846    , 0.529071371816    , 0.533466907466    ,
 0.503034630004    , 0.447159208144    , 0.393308529305    , 0.364204937013    ,
 0.360572829308    , 0.370097987742    , 0.390563934171    , 0.439431305589    ,
 0.539580285683    , 0.693986484353    , 0.87062717906     , 1.01458450916     ,
 1.08455652815     , 1.0837956069      , 1.05725187345     , 1.06172330281     ,
 1.13498875253     , 1.28055590899     , 1.47666738723     , 1.70432480921     ,
 1.96442397829     , 2.26260216604     , 2.58690005027     , 2.91785813643     ,
 3.26045293666     , 3.64621564846     , 4.0926127146      , 4.56898368872     ,
 5.01057709575     , 5.36474660761     , 5.62516103628     , 5.83183034564     ,
 6.05035412657     , 6.34347485387     , 6.72833361167     , 7.14927854563     ,
 7.53338737552     , 7.89890281959     , 8.36900067139     , 9.04321499101     ,
 9.88568381164     , 10.7666283439     , 11.5713217303     , 12.2365660357     ,
 12.7372511611     , 13.0954517267     , 13.371415409      , 13.6005912669     ,
 13.7611635028     , 13.8331002108     , 13.868434426      , 13.969757872      ,
 14.191104888      , 14.4722051008     , 14.6876089685     , 14.7560649651     ,
 14.6750742567     , 14.456432947      , 14.0831968923     , 13.5522436086     ,
 12.9170780375     , 12.2545073331     , 11.6064014214     , 10.9793570164     ,
 10.3905842636     , 9.8848811728      , 9.49826374865     , 9.21356660732     ,
 8.95260121023     , 8.61450901609     , 8.1363081893      , 7.52296816093     ,
 6.81885487869     , 6.06334133616     , 5.28584564818     , 4.52732267199     ,
 3.83728966406     , 3.243798855       , 2.74142768313     , 2.31564502253     ,
 1.97199120226     , 1.73597330039     , 1.62429460822     , 1.61447104814     ,
 1.64210148601     , 1.63507617986     , 1.55760500373     , 1.42308445872     ,
 1.27147919325     , 1.14131275482     , 1.05363505083     , 1.00671933845     ,
 0.981259882219    , 0.95098534873     , 0.891079870278    , 0.789477948806    ,
 0.661490697326    , 0.547132688815    , 0.482472003461    , 0.473060125963    ,
 0.495626591254    , 0.516521057356    , 0.506451210841    , 0.452222189985    ,
 0.365615875242    , 0.27664464118     , 0.212669076721    , 0.183752582817    ,
 0.183453252941    , 0.195782260937    , 0.202499968667    , 0.192879697204    ,
 0.170972110743    , 0.15103878619     , 0.143631326       , 0.145677597671    ,
 0.1445613321      , 0.132764766725    , 0.117463925621    , 0.114130409999    ,
 0.13295890051     , 0.175662947745    , 0.246760542582    , 0.365755472129    ,
 0.563248557796    , 0.862472080464    , 1.27638706178     , 1.84604290772     ,
 2.68883530693     , 3.98796665309     , 5.90786089796     , 8.50580805748     ,
 11.7252226493     , 15.4799431052     , 19.727380206      , 24.4126622434     ,
 29.3314703923     , 34.099193556      , 38.2696801123     , 41.4438362922     ,
 43.3191006057     , 43.8167138856     , 43.2743490041     , 42.4558845389     ,
 42.2420954255     , 43.1877548485     , 45.2589260974     , 47.8890252573     ,
 43.2994726463     , 44.0456893001     , 43.1361599164     , 40.5326737029     ,
 36.5997202809     , 31.8467171877     , 26.6826305227     , 21.4677894944     ,
 16.6635614593     , 12.7209836408     , 9.81025848105     , 7.75800521988     ,
 6.24069205248     , 4.99704335811     , 3.91490098863     , 3.00403061273     ,
 2.30786674683     , 1.82622330104     , 1.50534462234     , 1.27811420527     ,
 1.09922937113     , 0.949219360144    , 0.818751761524    , 0.698194111865    ,
 0.583572279326    , 0.484916753443    , 0.420220885482    , 0.399025904733    ,
 0.41223078807     , 0.436590303145    , 0.447690455163    , 0.430669730397    ,
 0.385956391918    , 0.330905936001    , 0.291549130824    , 0.283504463683    ,
 0.299266061973    , 0.318620899671    , 0.333187242316    , 0.358863632892    ,
 0.422846734812    , 0.537240163945    , 0.682840944778    , 0.81817142172     ,
 0.908087791089    , 0.949001767229    , 0.972102142054    , 1.02516607194     ,
 1.14396736893     , 1.32969367015     , 1.55342069711     , 1.78727423407     ,
 2.02706335729     , 2.27933007303     , 2.53571395871     , 2.77844352631     ,
 3.01523827716     , 3.28978720019     , 3.63917782928     , 4.04496150606     ,
 4.43840865013     , 4.7545470716      , 4.9793606597      , 5.1553355781      ,
 5.35613044494     , 5.64832815561     , 6.04561129299     , 6.48832010786     ,
 6.89875783225     , 7.27635667468     , 7.70985361053     , 8.27353244938     ,
 8.94021289822     , 9.61917500601     , 10.2429770421     , 10.786865648      ,
 11.2487708475     , 11.6562844106     , 12.0547212722     , 12.4400536863     ,
 12.7332629914     , 12.8682945671     , 12.8942477953     , 12.9532413321     ,
 13.1467653434     , 13.4385095783     , 13.6982579245     , 13.8192134285     ,
 13.7621845589     , 13.5129161688     , 13.0690120049     , 12.4847728637     ,
 11.8717744639     , 11.3178690313     , 10.8251784001     , 10.3486524063     ,
 9.87755260163     , 9.45112186955     , 9.10059867565     , 8.80184722979     ,
 8.48910078081     , 8.10699631828     , 7.65015674822     , 7.15025939615     ,
 6.62428990536     , 6.05051790327     , 5.40315783001     , 4.69584547923     ,
 3.97937849989     , 3.30634461193     , 2.70849631658     , 2.20175839171     ,
 1.80139184039     , 1.52787796471     , 1.39395019741     , 1.3796161545      ,
 1.42264883325     , 1.44634320773     , 1.40357380116     , 1.29350858395     ,
 1.14452702348     , 0.992515562317    , 0.868257943237    , 0.788982932962    ,
 0.754363037588    , 0.746529298497    , 0.73333376966     , 0.684580106125    ,
 0.598605427114    , 0.508743220072    , 0.453904975723    , 0.44491456187     ,
 0.462074266773    , 0.475298197681    , 0.460341323935    , 0.407354275641    ,
 0.32628709102     , 0.242343349677    , 0.180453511996    , 0.152046367799    ,
 0.152613202765    , 0.166290033178    , 0.1741681479      , 0.165729468319    ,
 0.146110266533    , 0.130470776329    , 0.129052715731    , 0.136971707026    ,
 0.139475051847    , 0.128603509316    , 0.113342212759    , 0.111083561684    ,
 0.130959942401    , 0.1699051354      , 0.226632402136    , 0.317060662586    ,
 0.472094876126    , 0.720590998609    , 1.08565770501     , 1.61388549583     ,
 2.4098056412      , 3.62283959428     , 5.37734657656     , 7.69729876987     ,
 10.4890995263     , 13.602346337      , 16.909704868      , 20.3127392119     ,
 23.6775836754     , 26.8115743667     , 29.5125518629     , 31.5980490263     ,
 32.9147001051     , 33.449617553      , 33.5016645328     , 33.6647030041     ,
 34.5257098859     , 36.310845952      , 38.7701055179     , 41.3279632796     ,
 37.6794633847     , 37.9903735998     , 36.7827722951     , 34.1557653779     ,
 30.5286808613     , 26.3815918271     , 22.0517175265     , 17.7955484522     ,
 13.9260128589     , 10.7427045857     , 8.34116183892     , 6.5781966004      ,
 5.2212523104      , 4.09943842323     , 3.15252003175     , 2.39574209408     ,
 1.84862116223     , 1.48471227553     , 1.24026509819     , 1.05801484113     ,
 0.913042835182    , 0.800705662663    , 0.710604561656    , 0.621065546676    ,
 0.51942444424     , 0.418819544565    , 0.347325265748    , 0.320993105805    ,
 0.329195568566    , 0.343787717294    , 0.339857223228    , 0.309348504936    ,
 0.261396118576    , 0.215687894198    , 0.192642259346    , 0.200627541309    ,
 0.228540600766    , 0.254858167737    , 0.268666649294    , 0.28224510654     ,
 0.321366472781    , 0.402459565011    , 0.518239043354    , 0.643170669422    ,
 0.751489724083    , 0.833674720437    , 0.904135820254    , 0.996528604383    ,
 1.14257596892     , 1.34590769525     , 1.57901889263     , 1.80932968967     ,
 2.02301317864     , 2.22069635549     , 2.39930514805     , 2.55309855928     ,
 2.69744673979     , 2.87610268372     , 3.12500862365     , 3.43011077139     ,
 3.73445985643     , 3.98785703367     , 4.18543002135     , 4.36783476864     ,
 4.59735271817     , 4.92572974923     , 5.359830008       , 5.84924191898     ,
 6.3256073848      , 6.76681748634     , 7.20931132896     , 7.6895071971      ,
 8.19568356049     , 8.6929804413      , 9.16786114597     , 9.62348553946     ,
 10.0633419225     , 10.5103999256     , 11.002778859      , 11.5230234718     ,
 11.960355749      , 12.2010088457     , 12.2585133733     , 12.2761258677     ,
 12.3875303177     , 12.5983555856     , 12.8125916538     , 12.9343047914     ,
 12.9052804809     , 12.6829890496     , 12.2603166535     , 11.7137555467     ,
 11.1730136121     , 10.7166123695     , 10.3204565075     , 9.9214530504      ,
 9.50825451551     , 9.1248924348      , 8.798875185       , 8.49786913316     ,
 8.16200809222     , 7.76543641593     , 7.33913794455     , 6.92717877748     ,
 6.52343387157     , 6.06782527246     , 5.50595597082     , 4.83765084773     ,
 4.11036952071     , 3.38577086479     , 2.7176316165      , 2.14611581446     ,
 1.70006358678     , 1.40052294029     , 1.25425478083     , 1.23559750249     ,
 1.28013598266     , 1.31124014164     , 1.27992333095     , 1.17893509854     ,
 1.02834631636     , 0.860426970493    , 0.71198967733     , 0.613966066448    ,
 0.578713319554    , 0.591340724672    , 0.611324465777    , 0.59481654786     ,
 0.529757670291    , 0.447130344573    , 0.389945541662    , 0.374464540427    ,
 0.38495580557     , 0.395364897543    , 0.386448946994    , 0.350439610461    ,
 0.292909601319    , 0.231686611047    , 0.187810817483    , 0.173383741573    ,
 0.185017505297    , 0.205877218066    , 0.21562294193     , 0.204044763863    ,
 0.1779772852      , 0.154125058424    , 0.143785016972    , 0.143275378404    ,
 0.139437667353    , 0.125918212162    , 0.11281724863     , 0.117666515081    ,
 0.147888830324    , 0.195748380856    , 0.252244039753    , 0.324614921491    ,
 0.438611117712    , 0.626624801374    , 0.923666884045    , 1.38492759771     ,
 2.10400638953     , 3.19684563443     , 4.74900243995     , 6.76093876866     ,
 9.12930408745     , 11.6821854269     , 14.2484015028     , 16.7058826452     ,
 18.9797800772     , 21.0213722312     , 22.7920247234     , 24.2375988762     ,
 25.2889736924     , 25.9657742948     , 26.5170975759     , 27.3858832416     ,
 28.9366518083     , 31.1816821109     , 33.7568514686     , 36.1100563103     ,
 32.7483225661     , 32.6955823941     , 31.2457125234     , 28.5957611019     ,
 25.2130987808     , 21.5714987134     , 17.9671768463     , 14.5686978419     ,
 11.5400646665     , 9.02896003131     , 7.06683343972     , 5.55385081621     ,
 4.34879190873     , 3.35594174117     , 2.54759698945     , 1.93363969352     ,
 1.51147029045     , 1.23782104191     , 1.04761143544     , 0.89600929688     ,
 0.775605390113    , 0.692700154932    , 0.634718483746    , 0.569665469684    ,
 0.477571768512    , 0.372998835089    , 0.290419933356    , 0.250797312533    ,
 0.245128288228    , 0.246190865957    , 0.231760162213    , 0.197909450461    ,
 0.15610279345     , 0.123125512376    , 0.112410234025    , 0.127298780605    ,
 0.157767701145    , 0.186476801822    , 0.203243445425    , 0.215122221282    ,
 0.241141836932    , 0.297194888117    , 0.386075712994    , 0.498652207775    ,
 0.62006169281     , 0.737037675881    , 0.848762649352    , 0.973767535148    ,
 1.1367574274      , 1.34258723411     , 1.56862492948     , 1.78363258647     ,
 1.96703814245     , 2.11125187481     , 2.21655124434     , 2.2926591783      ,
 2.36621202515     , 2.47567185041     , 2.64322707443     , 2.85172776102     ,
 3.06121573434     , 3.24903844492     , 3.42873299296     , 3.63711301025     ,
 3.91276129184     , 4.28046690182     , 4.73996969224     , 5.26216917632     ,
 5.80170350667     , 6.32014317944     , 6.7976900128      , 7.22582432892     ,
 7.60363640892     , 7.95072090579     , 8.30659892592     , 8.69938859983     ,
 9.13120055597     , 9.61010960225     , 10.1621726047     , 10.7693873148     ,
 11.3170982038     , 11.663743593      , 11.7798090822     , 11.7816972318     ,
 11.8110163535     , 11.9096048765     , 12.0249730473     , 12.0895919214     ,
 12.0510322426     , 11.8633462693     , 11.5195792894     , 11.0914204337     ,
 10.6848894947     , 10.343937625      , 10.0222461389     , 9.65776990059     ,
 9.2545621122      , 8.87188700641     , 8.54559425109     , 8.24769761884     ,
 7.92413510156     , 7.55610449283     , 7.17520370208     , 6.81399897283     ,
 6.45134355053     , 6.02416000462     , 5.48673678936     , 4.84236645688     ,
 4.12929549963     , 3.39935512028     , 2.70827139176     , 2.10800730196     ,
 1.63928073832     , 1.32774466945     , 1.1762337998      , 1.15227908736     ,
 1.18969840946     , 1.21576970541     , 1.18389044584     , 1.08341642276     ,
 0.929220392835    , 0.752702661179    , 0.595926562379    , 0.497343023157    ,
 0.472489941747    , 0.502168530447    , 0.537855434266    , 0.530165040399    ,
 0.466096515735    , 0.37846331774     , 0.312926084608    , 0.288391098946    ,
 0.291689929625    , 0.30036745712     , 0.300263907807    , 0.286822688832    ,
 0.262899571212    , 0.239049547179    , 0.229605370099    , 0.242808890251    ,
 0.272989982854    , 0.302006373937    , 0.310316509328    , 0.290487332455    ,
 0.251672638005    , 0.211095278874    , 0.180795979938    , 0.160377949973    ,
 0.14149678091     , 0.121014287951    , 0.109282039613    , 0.122742108953    ,
 0.167975884918    , 0.234975353807    , 0.307691115154    , 0.381931763477    ,
 0.474048190231    , 0.616282518001    , 0.852221490556    , 1.24334866462     ,
 1.87377411094     , 2.83140986794     , 4.16988387163     , 5.87654510272     ,
 7.85924415924     , 9.95446695228     , 11.9698032534     , 13.7585825424     ,
 15.277796967      , 16.5772233869     , 17.7302586304     , 18.7678711737     ,
 19.6782707031     , 20.4967301713     , 21.4095995565     , 22.7168121311     ,
 24.616007696      , 27.0014609772     , 29.4806098174     , 31.5530075734     ,
 28.1925056925     , 27.8833668777     , 26.3066331505     , 23.7181132715     ,
 20.6096425214     , 17.4457506119     , 14.4891766813     , 11.8336676659     ,
 9.51835346179     , 7.57086132818     , 5.98194471325     , 4.69667346894     ,
 3.64642145247     , 2.7855018247      , 2.10260185749     , 1.60194309555     ,
 1.27004310793     , 1.05939755687     , 0.908636297487    , 0.780396321729    ,
 0.675619100369    , 0.607605637721    , 0.566671337254    , 0.518883469977    ,
 0.43988414761     , 0.340440910213    , 0.253412923715    , 0.200955639189    ,
 0.178514131573    , 0.165531582036    , 0.14541363676     , 0.115783484391    ,
 0.0850382185367   , 0.0638597473942   , 0.0596430310666   , 0.0739015951838   ,
 0.101109569236    , 0.13123153099     , 0.156598549567    , 0.177624698926    ,
 0.202297226814    , 0.241760609697    , 0.306571836986    , 0.402909827281    ,
 0.52724162027     , 0.666349041273    , 0.810181803801    , 0.965191562984    ,
 1.14577981484     , 1.35122453974     , 1.56018802788     , 1.74658962227     ,
 1.89113311125     , 1.98276815932     , 2.02367774534     , 2.03560264736     ,
 2.05514776928     , 2.11556960155     , 2.22473969665     , 2.36092287216     ,
 2.49892907249     , 2.64151739258     , 2.81971902751     , 3.06510791435     ,
 3.38804522636     , 3.78087223098     , 4.23444006467     , 4.74425876928     ,
 5.29658408509     , 5.85193044205     , 6.35151757119     , 6.74848903647     ,
 7.04134719353     , 7.28372845957     , 7.55521594113     , 7.90913608631     ,
 8.34992040082     , 8.86563652813     , 9.45827142263     , 10.1069544273     ,
 10.7117992329     , 11.1310703072     , 11.3051419939     , 11.3159035419     ,
 11.2992925637     , 11.3222908288     , 11.3624021498     , 11.3683331944     ,
 11.2987285062     , 11.1281341399     , 10.86942825       , 10.5863847198     ,
 10.3429747066     , 10.1340441486     , 9.8878244713      , 9.54591271699     ,
 9.1303963652      , 8.72013624611     , 8.3708239714      , 8.07520479478     ,
 7.79119593023     , 7.48861615771     , 7.16421414918     , 6.8156382572      ,
 6.41665532758     , 5.93519288933     , 5.36572108403     , 4.72795938047     ,
 4.04683719068     , 3.350845277       , 2.6813667252      , 2.08928594556     ,
 1.62199646325     , 1.31098557884     , 1.15811576045     , 1.12646252531     ,
 1.15059780614     , 1.16410932957     , 1.12347235848     , 1.01482189276     ,
 0.850591403829    , 0.665779682769    , 0.508761070308    , 0.420411439445    ,
 0.411414982324    , 0.453386896249    , 0.491908868613    , 0.47944667037     ,
 0.408632161693    , 0.315109984488    , 0.243761159936    , 0.212804851571    ,
 0.210421475875    , 0.217243064911    , 0.223700480339    , 0.22968969722     ,
 0.238834855671    , 0.257004727004    , 0.290029823427    , 0.336921502096    ,
 0.385631862796    , 0.417845054757    , 0.420001037078    , 0.391556364684    ,
 0.343418402664    , 0.289440664066    , 0.239259967713    , 0.195592934485    ,
 0.156696824719    , 0.12430050843     , 0.109740186253    , 0.129085140619    ,
 0.189928556571    , 0.282534413048    , 0.385027797232    , 0.480697571465    ,
 0.574275566183    , 0.695073205398    , 0.890776551205    , 1.22414710763     ,
 1.76894877496     , 2.59088261936     , 3.72141355718     , 5.14541981071     ,
 6.79351594404     , 8.52268323215     , 10.1278168724     , 11.4364979312     ,
 12.4227175615     , 13.2081266976     , 13.9464450303     , 14.7224133136     ,
 15.5531479427     , 16.4677045954     , 17.5826278578     , 19.0758452282     ,
 21.0353849821     , 23.3151907792     , 25.5533735697     , 27.3138246877     ,
 24.0017590562     , 23.5076990839     , 21.8901783624     , 19.4417430265     ,
 16.6511853731     , 13.9540504349     , 11.5721700066     , 9.53564010445     ,
 7.79396540652     , 6.29881073672     , 5.02499657239     , 3.95613507638     ,
 3.07065090009     , 2.34722846276     , 1.77751018206     , 1.3614662419      ,
 1.08586866864     , 0.911245410489    , 0.785827553875    , 0.676392474762    ,
 0.583906544008    , 0.523934819812    , 0.493019909139    , 0.462135781493    ,
 0.40471515879     , 0.322770794977    , 0.240662633824    , 0.179109457622    ,
 0.140441595184    , 0.114475041511    , 0.0915019254356   , 0.0688209982736   ,
 0.0490586640959   , 0.0361910507713   , 0.033672192544    , 0.0439561430498   ,
 0.0676538700795   , 0.102676371558    , 0.143918226228    , 0.183920506729    ,
 0.216925246298    , 0.246552239339    , 0.28921823627     , 0.364963758164    ,
 0.481348736798    , 0.628245041383    , 0.791876946139    , 0.970267020874    ,
 1.16640115566     , 1.36934708245     , 1.5548244151      , 1.7025322691      ,
 1.8011450723      , 1.8433167466      , 1.83301760548     , 1.79671233653     ,
 1.77519639473     , 1.79892841281     , 1.86914649792     , 1.96362813084     ,
 2.06691626213     , 2.19628459884     , 2.39160359332     , 2.67713930906     ,
 3.03768959297     , 3.43580652593     , 3.85118482683     , 4.29676012496     ,
 4.78910392832     , 5.30518727298     , 5.77872873485     , 6.14576666705     ,
 6.39722206937     , 6.59402505679     , 6.83242309323     , 7.18318848219     ,
 7.6551860551      , 8.21693907574     , 8.84089115912     , 9.49883514316     ,
 10.1130604268     , 10.5611111284     , 10.7723250083     , 10.8047153683     ,
 10.7926867739     , 10.8230876272     , 10.8812620957     , 10.9011647828     ,
 10.8348456105     , 10.6824298807     , 10.4919512831     , 10.3301145443     ,
 10.2231941128     , 10.1198125306     , 9.92733621197     , 9.59588800357     ,
 9.16547694224     , 8.72705894424     , 8.34875360426     , 8.04613482116     ,
 7.79651468196     , 7.55661529925     , 7.27541421222     , 6.90820054551     ,
 6.43301726611     , 5.86429221325     , 5.24314328395     , 4.60366393133     ,
 3.95563354869     , 3.30411568885     , 2.67351901397     , 2.10772322365     ,
 1.65530996568     , 1.35146131969     , 1.19796504794     , 1.15550347372     ,
 1.16113873732     , 1.15552684787     , 1.09819560947     , 0.97258623117     ,
 0.791066527585    , 0.595104345451    , 0.439380314383    , 0.363436381303    ,
 0.368915562505    , 0.417450711362    , 0.451939792276    , 0.431281531435    ,
 0.356090147958    , 0.263317222986    , 0.193419409136    , 0.161236730686    ,
 0.15552152034     , 0.159647479906    , 0.167878626608    , 0.184935013427    ,
 0.217957016656    , 0.271194272033    , 0.341974341879    , 0.417038400903    ,
 0.476158281418    , 0.503875106818    , 0.498486195391    , 0.469341931482    ,
 0.426452017455    , 0.374647728478    , 0.316471641214    , 0.255527967613    ,
 0.196636425567    , 0.148117895464    , 0.125007279865    , 0.145385673401    ,
 0.219190444155    , 0.337661457652    , 0.473773879411    , 0.59905900649     ,
 0.707244923281    , 0.824282263176    , 0.999259256761    , 1.29201329829     ,
 1.76402373843     , 2.46250587978     , 3.40458601836     , 4.57824347853     ,
 5.93638416531     , 7.35630972848     , 8.63026825641     , 9.57602358833     ,
 10.1877131192     , 10.6399051488     , 11.1345913069     , 11.7750643915     ,
 12.5735768973     , 13.531513694      , 14.7011622436     , 16.1751413914     ,
 17.989468359      , 20.0137505062     , 21.9433352604     , 23.3943428485     ,
 20.2817432939     , 19.5983553594     , 17.9522921969     , 15.6717599969     ,
 13.219130986      , 10.972757327      , 9.09735322534     , 7.56719926232     ,
 6.27570893855     , 5.13783504181     , 4.13056006111     , 3.2673971251      ,
 2.55375551929     , 1.97539088592     , 1.51679689718     , 1.17128152054     ,
 0.930293289893    , 0.770309399657    , 0.655920755567    , 0.560038236499    ,
 0.480573372586    , 0.430910237256    , 0.412341039921    , 0.402486588754    ,
 0.373825013507    , 0.317840875093    , 0.247471239774    , 0.181169005797    ,
 0.129444234837    , 0.093381273922    , 0.0694654679819   , 0.0534519508456   ,
 0.0418596838915   , 0.0330908260787   , 0.028797246112    , 0.0340888344887   ,
 0.055801961       , 0.0986886721177   , 0.159404006268    , 0.222725075745    ,
 0.269338590634    , 0.294591651108    , 0.318834520899    , 0.373507101454    ,
 0.475681892703    , 0.618654747129    , 0.786400047113    , 0.970070915255    ,
 1.16371115712     , 1.34983751705     , 1.50344784641     , 1.60974985927     ,
 1.66597630018     , 1.6708487689      , 1.62892800081     , 1.56433203613     ,
 1.51647603031     , 1.51666490424     , 1.56920252985     , 1.65641888636     ,
 1.76635689692     , 1.91633893478     , 2.14161546152     , 2.45560129073     ,
 2.82650192041     , 3.20073988844     , 3.55100314918     , 3.8971447514      ,
 4.27525337581     , 4.68759666787     , 5.08892928953     , 5.42376125019     ,
 5.67742543036     , 5.89770820163     , 6.17058630838     , 6.56465221803     ,
 7.08703322666     , 7.69312829384     , 8.33574863765     , 8.98207737845     ,
 9.57353342183     , 10.0105161337     , 10.2278262375     , 10.2811920079     ,
 10.316495493      , 10.4359947573     , 10.6125294867     , 10.7401058118     ,
 10.7456184979     , 10.646321587      , 10.5240366813     , 10.4510789813     ,
 10.4226376953     , 10.3544240887     , 10.1550342425     , 9.80651742555     ,
 9.37362230167     , 8.93940842165     , 8.55113085947     , 8.22621059242     ,
 7.96405904111     , 7.72534883285     , 7.43058806623     , 7.01050376854     ,
 6.45841434101     , 5.82890347495     , 5.18649300733     , 4.55780175276     ,
 3.93385268976     , 3.3085359795      , 2.70256946517     , 2.15707079143     ,
 1.71823227733     , 1.42042240079     , 1.26419371563     , 1.20854356634     ,
 1.19255178269     , 1.16297598129     , 1.08371003504     , 0.938651776276    ,
 0.741699409782    , 0.539144833145    , 0.388627756051    , 0.325926382572    ,
 0.343633609287    , 0.395295929638    , 0.423259285714    , 0.394144725088    ,
 0.31685421899     , 0.229002073663    , 0.165203541945    , 0.135365905324    ,
 0.127715381917    , 0.127552587509    , 0.132020073275    , 0.150103005132    ,
 0.193312461039    , 0.266240770355    , 0.359364372829    , 0.448280983986    ,
 0.506652825337    , 0.525393394682    , 0.517310030527    , 0.50080067311     ,
 0.481222898676    , 0.450429833681    , 0.400774548592    , 0.33399885499     ,
 0.259794798101    , 0.194016942233    , 0.158385558823    , 0.175138619017    ,
 0.256193049828    , 0.392606479028    , 0.553109404947    , 0.700843181741    ,
 0.821987808328    , 0.940403521356    , 1.10539541306     , 1.37138096214     ,
 1.7858282274      , 2.37901941701     , 3.15776638209     , 4.11315263286     ,
 5.21338470157     , 6.35417241821     , 7.34279495947     , 8.01374914011     ,
 8.38680470377     , 8.66429837485     , 9.06081188229     , 9.66934777786     ,
 10.4767149425     , 11.4481099956     , 12.5842549366     , 13.9251931261     ,
 15.4941554734     , 17.204179614      , 18.8082746361     , 19.9500225988     ,
 17.0946827939     , 16.1680568735     , 14.4564115953     , 12.3327304277     ,
 10.216547576      , 8.40059606277     , 6.97344356179     , 5.85874367575     ,
 4.92115287298     , 4.06738491574     , 3.28544186357     , 2.60929460131     ,
 2.0595475588      , 1.62296919491     , 1.27372593447     , 0.995765726628    ,
 0.783951049239    , 0.631427545395    , 0.521398968383    , 0.43556323821     ,
 0.369676369622    , 0.33293518235     , 0.328429070131    , 0.339574830565    ,
 0.339549132058    , 0.311225303494    , 0.256707787756    , 0.191712965143    ,
 0.133733087104    , 0.0931565136736   , 0.0708468870615   , 0.0606936891595   ,
 0.0543102734197   , 0.0462335779498   , 0.037696639319    , 0.0368293677247   ,
 0.055431679813    , 0.10292937761     , 0.177159501846    , 0.257984185341    ,
 0.317010924963    , 0.343048192295    , 0.357282239562    , 0.397191618704    ,
 0.485587892397    , 0.617835855779    , 0.775081155212    , 0.941884531397    ,
 1.10739993169     , 1.25599219575     , 1.36911326563     , 1.43789481101     ,
 1.46393099759     , 1.44857433577     , 1.39448307709     , 1.3199580715      ,
 1.26144594869     , 1.25516914191     , 1.31542485737     , 1.4316100379      ,
 1.58897441237     , 1.79101555922     , 2.05330281023     , 2.37252790376     ,
 2.71107992756     , 3.02071839051     , 3.28145476611     , 3.51598722315     ,
 3.76649961809     , 4.05660036111     , 4.37421372769     , 4.68923413825     ,
 4.98798118848     , 5.29567490422     , 5.66701555317     , 6.14648716555     ,
 6.73016315799     , 7.3701655618      , 8.01724250045     , 8.63890165124     ,
 9.18502711258     , 9.57329641237     , 9.75926728627     , 9.81961170074     ,
 9.9184576673      , 10.1610350465     , 10.4952151706     , 10.7742282208     ,
 10.9013694317     , 10.9025514966     , 10.8764299486     , 10.885867158      ,
 10.8906402675     , 10.7868192202     , 10.5165376962     , 10.1299070056     ,
 9.72884477524     , 9.36366506265     , 9.01489328977     , 8.6656284834      ,
 8.33050012324     , 7.99642550578     , 7.59446847957     , 7.06848398485     ,
 6.44359293313     , 5.79921787607     , 5.1866552689      , 4.59320231642     ,
 3.98343974285     , 3.35450648128     , 2.74316103479     , 2.19821309439     ,
 1.76257756742     , 1.46526618364     , 1.30390387311     , 1.23560512159     ,
 1.19917403173     , 1.14557423695     , 1.04623636241     , 0.890877815092    ,
 0.694762154239    , 0.502280223587    , 0.367760692808    , 0.322775073083    ,
 0.354430061614    , 0.41066461292     , 0.432430657777    , 0.392136662219    ,
 0.307188465824    , 0.218501238089    , 0.157292569933    , 0.128708829443    ,
 0.118842490685    , 0.113090237981    , 0.109948496454    , 0.121256788003    ,
 0.161998085138    , 0.23771119447     , 0.334884814096    , 0.422763338953    ,
 0.473451437853    , 0.485456972384    , 0.483007998209    , 0.489044488526    ,
 0.502356509023    , 0.502934796964    , 0.473699136401    , 0.41256429592     ,
 0.3311537641      , 0.251922105788    , 0.204326929858    , 0.215047029229    ,
 0.296092608005    , 0.436632738555    , 0.6031468549      , 0.756085335959    ,
 0.879387889427    , 0.996298748403    , 1.15464392429     , 1.40115584773     ,
 1.76827188489     , 2.27075688712     , 2.90792327778     , 3.67322076285     ,
 4.5447832496      , 5.43783977412     , 6.19157205888     , 6.67523962913     ,
 6.92823259791     , 7.151308613       , 7.54510628578     , 8.18384505345     ,
 9.03106451385     , 10.0205082336     , 11.1098845441     , 12.2991108371     ,
 13.6095462874     , 15.0006569441     , 16.2740521797     , 17.0843880038     ,
 14.4264940747     , 13.2234174359     , 11.4179840081     , 9.43182703702     ,
 7.63426561826     , 6.21621876619     , 5.17920781449     , 4.40313381178     ,
 3.74485566613     , 3.11990999046     , 2.52737959297     , 2.01075758436     ,
 1.59880856965     , 1.28129848427     , 1.02723574807     , 0.813477727131    ,
 0.635897051895    , 0.498664399312    , 0.398435164189    , 0.324229574994    ,
 0.271038838368    , 0.244593766323    , 0.248613703619    , 0.271823046394    ,
 0.290810079701    , 0.284616119628    , 0.247666680449    , 0.192021115492    ,
 0.13792204532     , 0.100466137582    , 0.0827386308859   , 0.0777278567895   ,
 0.0745819763757   , 0.0657655789855   , 0.0523519390565   , 0.0442877270991   ,
 0.0558741306797   , 0.0985594061139   , 0.171384887496    , 0.254403456713    ,
 0.317980308514    , 0.348262448806    , 0.363359585823    , 0.398881170553    ,
 0.478066288524    , 0.597777883139    , 0.738054546414    , 0.878614265004    ,
 1.00590114352     , 1.10975618988     , 1.18153528619     , 1.21838598478     ,
 1.22308304522     , 1.19679740288     , 1.13987397099     , 1.06561029754     ,
 1.00859200807     , 1.01168315218     , 1.1008232087      , 1.27218754844     ,
 1.50450889031     , 1.77949211307     , 2.08238331222     , 2.38670536818     ,
 2.65521364688     , 2.86325941492     , 3.01599652916     , 3.14364753353     ,
 3.28577844938     , 3.47588643094     , 3.73043029471     , 4.04753209583     ,
 4.41892641849     , 4.84708439752     , 5.34851461893     , 5.93402962388     ,
 6.58487637334     , 7.25609284257     , 7.90459064871     , 8.49618256638     ,
 8.97902035691     , 9.28702859746     , 9.41152117741     , 9.46211921658     ,
 9.61097358285     , 9.94653778588     , 10.3925334566     , 10.7873618019     ,
 11.0339148076     , 11.1636175003     , 11.268159761      , 11.3772752056     ,
 11.4058323154     , 11.2392617542     , 10.8776682747     , 10.4655381473     ,
 10.1514146469     , 9.93698429813     , 9.70252897114     , 9.36194935811     ,
 8.92623829692     , 8.41836983621     , 7.81610579823     , 7.11720101518     ,
 6.39799442385     , 5.75271557417     , 5.19359863723     , 4.64654964892     ,
 4.04202850406     , 3.38634180978     , 2.74427654756     , 2.18161031889     ,
 1.74013282347     , 1.44117478548     , 1.27743487661     , 1.20281025333     ,
 1.15336381383     , 1.08312955481     , 0.97462441401     , 0.827631483077    ,
 0.656190944413    , 0.494014030413    , 0.386017333563    , 0.361495617036    ,
 0.408145846406    , 0.471451119376    , 0.488689061348    , 0.433839707543    ,
 0.331785613061    , 0.230301492295    , 0.162020906575    , 0.129562727521    ,
 0.116085464497    , 0.105136519423    , 0.0945717788634   , 0.0968884096864   ,
 0.128518569867    , 0.195822630925    , 0.284748542291    , 0.364122037051    ,
 0.408177167047    , 0.420183145708    , 0.428364323001    , 0.455416673822    ,
 0.495948966076    , 0.524515651723    , 0.518636590428    , 0.471455610615    ,
 0.392970089104    , 0.309222996485    , 0.255706397894    , 0.261883787729    ,
 0.337455860035    , 0.468239132972    , 0.620930108354    , 0.759836699459    ,
 0.872855333254    , 0.983942027181    , 1.13644963649     , 1.36634583884     ,
 1.69091268499     , 2.1123128217      , 2.62603996455     , 3.22899212746     ,
 3.90778698908     , 4.59903342584     , 5.18089960702     , 5.55880111334     ,
 5.77692452088     , 6.01236163549     , 6.44244907576     , 7.13171056978     ,
 8.03518538811     , 9.06330387446     , 10.1317823448     , 11.1981574684     ,
 12.276596538      , 13.3647844014     , 14.3064853983     , 14.7673223434     ,
 12.1993453269     , 10.7652402469     , 8.8976925291      , 7.05190529304     ,
 5.54457363241     , 4.46883483404     , 3.74773119375     , 3.23221150902     ,
 2.78705903645     , 2.343091096       , 1.90441464395     , 1.51336297118     ,
 1.20206371061     , 0.967747102762    , 0.783324541347    , 0.624767241492    ,
 0.487518393694    , 0.378737949158    , 0.299709979721    , 0.242445288732    ,
 0.20158270174     , 0.180840104539    , 0.184404817656    , 0.205981731799    ,
 0.228363255501    , 0.232848794861    , 0.211181696009    , 0.171209622042    ,
 0.130388184804    , 0.102802971036    , 0.0917901284705   , 0.0912782655207   ,
 0.0909705796924   , 0.0828177522341   , 0.0669206021017   , 0.0526131763399   ,
 0.0538412225639   , 0.0819551243711   , 0.137669107091    , 0.205978660619    ,
 0.263318886       , 0.297409879352    , 0.320537601216    , 0.359532940856    ,
 0.433441723829    , 0.541702543759    , 0.668223971795    , 0.791931927265    ,
 0.895569740182    , 0.968993516581    , 1.00845298874     , 1.01607494567     ,
 0.997890261706    , 0.958106066703    , 0.898253811641    , 0.828968596408    ,
 0.782233143604    , 0.803962547842    , 0.927848492277    , 1.15509122168     ,
 1.45887848498     , 1.80113532404     , 2.13728268824     , 2.41659831222     ,
 2.60308566328     , 2.70150524351     , 2.7507051713      , 2.79325866913     ,
 2.86231808156     , 2.99023512817     , 3.21001419864     , 3.54080994389     ,
 3.97939307787     , 4.51107971249     , 5.12347153125     , 5.80296667631     ,
 6.52081404614     , 7.2327086591      , 7.89343827204     , 8.45839331691     ,
 8.8729528703      , 9.09650357834     , 9.16447587905     , 9.20974441398     ,
 9.3848458223      , 9.74250054983     , 10.1980053409     , 10.6169836612     ,
 10.934342696      , 11.1866323619     , 11.4365059289     , 11.6626307603     ,
 11.7327957221     , 11.5278459704     , 11.1085973198     , 10.7112827411     ,
 10.5299417049     , 10.5211987943     , 10.4636676701     , 10.1845932792     ,
 9.66661814522     , 8.96124516231     , 8.11154654462     , 7.19437779133     ,
 6.34734276276     , 5.67596586219     , 5.15064799331     , 4.6376350501      ,
 4.03251389493     , 3.34541870072     , 2.66580066776     , 2.07919122633     ,
 1.63090363014     , 1.3356038696      , 1.17885395435     , 1.10932143481     ,
 1.05984850394     , 0.988113566037    , 0.888516972579    , 0.770023464069    ,
 0.641141695018    , 0.519010295873    , 0.436439115291    , 0.423626820103    ,
 0.475806805175    , 0.541884726975    , 0.55627293017     , 0.490119069791    ,
 0.370540366523    , 0.250935469663    , 0.168397175525    , 0.126786730147    ,
 0.108201040272    , 0.0942203099009   , 0.0805181891241   , 0.0777080991495   ,
 0.101313012108    , 0.158374539386    , 0.237438498924    , 0.311051441896    ,
 0.35577094216     , 0.373607339361    , 0.389195905298    , 0.423360995117    ,
 0.472778002983    , 0.515269399541    , 0.528032972207    , 0.499459589662    ,
 0.434727799632    , 0.359122328834    , 0.310195727398    , 0.317319671202    ,
 0.385747650475    , 0.496791813025    , 0.619336341048    , 0.727590756237    ,
 0.819857919232    , 0.92261908865     , 1.07188633564     , 1.29009564543     ,
 1.58000763748     , 1.93390093216     , 2.34551686535     , 2.8160771405      ,
 3.34161915223     , 3.88111339233     , 4.34944114369     , 4.67898713604     ,
 4.90490248827     , 5.17102878912     , 5.63361213936     , 6.35970251045     ,
 7.30838807576     , 8.37287642049     , 9.42924490001     , 10.3945467369     ,
 11.2720771834     , 12.0864772398     , 12.7179417948     , 12.8531794086     ,
 10.2704302007     , 8.73595809379     , 6.91482771103     , 5.25568299267     ,
 4.01607644093     , 3.21191057787     , 2.71695302375     , 2.37738182316     ,
 2.07780074437     , 1.7637711104      , 1.43765383347     , 1.1342849561      ,
 0.886590698672    , 0.701605175718    , 0.562077557273    , 0.447742053892    ,
 0.352338629484    , 0.279613195858    , 0.229028743468    , 0.192806646854    ,
 0.165534097533    , 0.149298497002    , 0.147436424345    , 0.157050981878    ,
 0.168506531061    , 0.170502599744    , 0.157278672819    , 0.133151219928    ,
 0.10904434639     , 0.0940424692797   , 0.0906619563149   , 0.095305619851    ,
 0.100185685534    , 0.0971413217666   , 0.0836088174586   , 0.065746374487    ,
 0.0554320328032   , 0.0636492212227   , 0.0937004524708   , 0.137657271768    ,
 0.181130868378    , 0.215782126413    , 0.247728311775    , 0.292330395016    ,
 0.362345655219    , 0.461172297176    , 0.58133678898     , 0.704833276954    ,
 0.808214596359    , 0.872393521937    , 0.890281398639    , 0.868171116642    ,
 0.820947495293    , 0.762635065777    , 0.700599242385    , 0.643515636949    ,
 0.616052500796    , 0.658561584258    , 0.804918375138    , 1.0594311099      ,
 1.39494723273     , 1.76436302265     , 2.10574284552     , 2.35311891036     ,
 2.47316739042     , 2.49439716851     , 2.48166522463     , 2.48430880205     ,
 2.52460879299     , 2.62707473365     , 2.83157197637     , 3.16909544946     ,
 3.63863350927     , 4.21660116128     , 4.88006223813     , 5.61051484324     ,
 6.377795841       , 7.1314274495      , 7.81064632265     , 8.35535768501     ,
 8.71722888382     , 8.89249494935     , 8.95532753415     , 9.03415157462     ,
 9.22923957471     , 9.546811598       , 9.91595577345     , 10.2679590962     ,
 10.5952922669     , 10.9392237464     , 11.3206647332     , 11.6642621844     ,
 11.8011459578     , 11.6115885609     , 11.1965423796     , 10.8495765404     ,
 10.7949768734     , 10.9649940461     , 11.0707148637     , 10.8654286563     ,
 10.2908358479     , 9.41421245665     , 8.34301398534     , 7.2296465763      ,
 6.2589118657      , 5.54009288176     , 5.01598883213     , 4.51735718327     ,
 3.91513764436     , 3.21331794658     , 2.51097793685     , 1.90833488429     ,
 1.45840269512     , 1.17306038019     , 1.03070947118     , 0.975121842912    ,
 0.938889609275    , 0.88459518071     , 0.814119334118    , 0.738475816221    ,
 0.656461276117    , 0.568601127866    , 0.497063451555    , 0.475272532952    ,
 0.511529694295    , 0.566908218583    , 0.579207529575    , 0.514376949952    ,
 0.392339955117    , 0.263854657149    , 0.168999712234    , 0.116660740883    ,
 0.0923936343102   , 0.0782380842861   , 0.0674331555844   , 0.0666686970649   ,
 0.0886619599274   , 0.141212484847    , 0.217378566418    , 0.294382392991    ,
 0.348053922705    , 0.372889402681    , 0.385609866593    , 0.407063462567    ,
 0.442908606194    , 0.481474241549    , 0.504118927308    , 0.495840913391    ,
 0.455225038848    , 0.4020584255      , 0.370350571965    , 0.385696673711    ,
 0.447559859356    , 0.53271782666     , 0.61417162023     , 0.680807804687    ,
 0.746467186603    , 0.841951664366    , 0.994836155818    , 1.21366889401     ,
 1.48772542443     , 1.79858865247     , 2.13491997977     , 2.50108250522     ,
 2.90614295475     , 3.3340327576      , 3.73029590921     , 4.04148636122     ,
 4.283913858       , 4.56677770999     , 5.02961064091     , 5.74790110196     ,
 6.69059811892     , 7.74150001042     , 8.75083559301     , 9.61028185356     ,
 10.3128790981     , 10.8931807646     , 11.2580276716     , 11.1320886839     ,
 8.48009878163     , 7.01525547049     , 5.3904094219      , 3.99373471331     ,
 3.01305154074     , 2.41473303146     , 2.06107239673     , 1.8189831521      ,
 1.60069569229     , 1.36428422751     , 1.10773046895     , 0.857856903643    ,
 0.647434027408    , 0.491735491577    , 0.383137383833    , 0.305388345023    ,
 0.248787981635    , 0.210570059381    , 0.186791910266    , 0.17067448269     ,
 0.157922105352    , 0.148408665337    , 0.142115915131    , 0.136872494569    ,
 0.130077541871    , 0.120146220323    , 0.10700840773     , 0.0929585728527   ,
 0.0820618312393   , 0.0780067441537   , 0.0828949869216   , 0.0960722613687   ,
 0.111833310637    , 0.120231293268    , 0.113667746785    , 0.0936147490443   ,
 0.0705355902192   , 0.0572060836286   , 0.061014577214    , 0.080681841297    ,
 0.109679289584    , 0.143332817212    , 0.182707483297    , 0.232787306844    ,
 0.300240588058    , 0.392582512039    , 0.511914408316    , 0.644008092926    ,
 0.757673823913    , 0.821141159041    , 0.821223786425    , 0.769263640634    ,
 0.69241108006     , 0.617832384514    , 0.560701021279    , 0.526903643053    ,
 0.528060587228    , 0.589286706197    , 0.736339656161    , 0.975139224781    ,
 1.28503277504     , 1.6233941205      , 1.92830522452     , 2.1343459564      ,
 2.21629621789     , 2.21664935904     , 2.20762395207     , 2.22974248352     ,
 2.2875592461      , 2.3955892747      , 2.59669499918     , 2.92783982554     ,
 3.38863578265     , 3.95444870477     , 4.60637241154     , 5.33338198001     ,
 6.1075255457      , 6.8694798648      , 7.54322296012     , 8.06246718012     ,
 8.39729403105     , 8.58084567151     , 8.70674352578     , 8.87144591783     ,
 9.10654585772     , 9.37465889895     , 9.63237595888     , 9.88742174681     ,
 10.1918764038     , 10.5901150583     , 11.0660667795     , 11.5073248794     ,
 11.7291060352     , 11.6123170663     , 11.263145477      , 10.9786765757     ,
 10.9846424366     , 11.2119550758     , 11.3594346392     , 11.1521081677     ,
 10.5079733543     , 9.50790283029     , 8.30799141963     , 7.10226892784     ,
 6.0812533417      , 5.33834677888     , 4.80561879226     , 4.31224104973     ,
 3.72446484249     , 3.03526220904     , 2.33673433889     , 1.73287077756     ,
 1.28432110124     , 1.00512417434     , 0.871384833806    , 0.827399348247    ,
 0.811093983188    , 0.789903403194    , 0.764473665746    , 0.7376164597      ,
 0.695939265401    , 0.628109406981    , 0.549761318371    , 0.498017234225    ,
 0.496204860281    , 0.524982287834    , 0.53377009123     , 0.484044909525    ,
 0.380256430836    , 0.260370829818    , 0.162766554759    , 0.103042379968    ,
 0.0745311623449   , 0.0630425428794   , 0.0602669042896   , 0.0680298731596   ,
 0.09514610691     , 0.150122770015    , 0.230916796045    , 0.318403223116    ,
 0.384585368958    , 0.413205731085    , 0.412447192639    , 0.405697389574    ,
 0.41133743417     , 0.431633353032    , 0.455412825566    , 0.467207081237    ,
 0.459244631319    , 0.441615069059    , 0.438370210974    , 0.467281298294    ,
 0.52227801821     , 0.57835813374     , 0.615735997355    , 0.640463586744    ,
 0.682980889657    , 0.778113727141    , 0.945480249288    , 1.18227951409     ,
 1.46565829881     , 1.76220098051     , 2.04786473628     , 2.32813839815     ,
 2.63190757864     , 2.9738754134      , 3.32444676365     , 3.63095452426     ,
 3.88270981865     , 4.15487958475     , 4.57244994635     , 5.21916446511     ,
 6.07652754676     , 7.03209686139     , 7.93397870979     , 8.66833341696     ,
 9.21465059129     , 9.59492733559     , 9.73415031447     , 9.41945256245     ,
 6.76083757947     , 5.50632142376     , 4.19396753588     , 3.11179986803     ,
 2.3764884509      , 1.9326385733      , 1.66076479147     , 1.46317718769     ,
 1.28132825431     , 1.0846105457      , 0.86821244691     , 0.652945945076    ,
 0.470003663963    , 0.338790679501    , 0.257790829535    , 0.212811583608    ,
 0.189459037783    , 0.178195855322    , 0.173286577979    , 0.171575074323    ,
 0.171418354018    , 0.169969180676    , 0.162036545117    , 0.144144934506    ,
 0.11917746129     , 0.0945659512913   , 0.0761767143327   , 0.0654064185525   ,
 0.0613909544416   , 0.0647115857087   , 0.0785978708785   , 0.105065323719    ,
 0.138293761267    , 0.163427188922    , 0.165494131792    , 0.141333838114    ,
 0.102636722468    , 0.0673952813399   , 0.0486871154998   , 0.0504323628944   ,
 0.0708672422696   , 0.107107720732    , 0.155860881262    , 0.213616744608    ,
 0.281925193214    , 0.371529247767    , 0.491584034544    , 0.629108478162    ,
 0.74539306861     , 0.800068689331    , 0.779071279787    , 0.700924188495    ,
 0.602812651978    , 0.521369412264    , 0.477951322669    , 0.475686891941    ,
 0.511055744879    , 0.587956161593    , 0.717707601229    , 0.906524511252    ,
 1.14556339658     , 1.40680408748     , 1.64173961882     , 1.79899780348     ,
 1.86698972615     , 1.89363114218     , 1.94130270848     , 2.02834407127     ,
 2.13789407274     , 2.27542178349     , 2.48540083263     , 2.80761516067     ,
 3.24325228691     , 3.77234239898     , 4.38300861511     , 5.066779773       ,
 5.79174515805     , 6.49522959067     , 7.10697684489     , 7.57849604065     ,
 7.90549317685     , 8.14069222512     , 8.37056468559     , 8.64936054608     ,
 8.95451671347     , 9.22404403272     , 9.43794618601     , 9.65018201372     ,
 9.94230228258     , 10.358784364      , 10.8727518556     , 11.3714862854     ,
 11.6802723525     , 11.6792701339     , 11.4446986862     , 11.2240643229     ,
 11.2095199952     , 11.3412851055     , 11.3569654115     , 11.0146786442     ,
 10.2520068317     , 9.17517549717     , 7.96634484793     , 6.8118151314      ,
 5.85521804686     , 5.14757425543     , 4.62033106435     , 4.13083182919     ,
 3.56411433406     , 2.90631370523     , 2.23193967222     , 1.63613134747     ,
 1.18238265694     , 0.891253191306    , 0.745523054354    , 0.698900341722    ,
 0.699709570949    , 0.717933327262    , 0.743878075699    , 0.763663564181    ,
 0.751240661128    , 0.689618356487    , 0.592935499926    , 0.501695202239    ,
 0.451986613639    , 0.44490707181     , 0.445667872383    , 0.414553112599    ,
 0.339510242861    , 0.241116265632    , 0.151460627885    , 0.0910417347744   ,
 0.061908747515    , 0.0555261905586   , 0.0632625425833   , 0.0821987309899   ,
 0.116721007367    , 0.175403717165    , 0.2604471623      , 0.355924626914    ,
 0.430477525258    , 0.458647359634    , 0.441460737104    , 0.404534343647    ,
 0.377151876231    , 0.374386542359    , 0.394205875595    , 0.424420317419    ,
 0.453043385559    , 0.478059371071    , 0.508263577805    , 0.550606647657    ,
 0.596014436185    , 0.623519529381    , 0.624390490331    , 0.62060465328     ,
 0.654503428278    , 0.761313171428    , 0.953369177997    , 1.22034399223     ,
 1.52953149067     , 1.82975533105     , 2.07892059871     , 2.28247852507     ,
 2.49440812908     , 2.76462129451     , 3.08412248565     , 3.39136409489     ,
 3.64326515567     , 3.88143830106     , 4.21602190368     , 4.73614254399     ,
 5.43793399659     , 6.22668005258     , 6.96962229559     , 7.56024624527     ,
 7.95793434776     , 8.15708458729     , 8.10177588252     , 7.66364391855     ,
 5.17707873006     , 4.19575943659     , 3.22070737849     , 2.43717200308     ,
 1.90806295736     , 1.5789060573      , 1.36019897255     , 1.18794647584     ,
 1.02741547592     , 0.858415134483    , 0.6758601957      , 0.495227762772    ,
 0.343225227581    , 0.239384049633    , 0.185735223331    , 0.169426745729    ,
 0.171973956991    , 0.178714807591    , 0.184230605071    , 0.190415823259    ,
 0.198519323284    , 0.202847339083    , 0.193358194167    , 0.165438782471    ,
 0.1262726477      , 0.0898613573351   , 0.0659596315911   , 0.0550258407695   ,
 0.0532264310691   , 0.060519600379    , 0.0826633039605   , 0.12393088695     ,
 0.176540173265    , 0.218730733461    , 0.227537221633    , 0.196526703372    ,
 0.141066428579    , 0.0863198970924   , 0.051426747862    , 0.0441400144382   ,
 0.0651416337849   , 0.111452754897    , 0.174903482781    , 0.24414786236     ,
 0.31648023592     , 0.405489925687    , 0.524786096218    , 0.659678411659    ,
 0.765127146825    , 0.799202741652    , 0.754765480858    , 0.658917205821    ,
 0.55271253252     , 0.47428607866     , 0.447659237068    , 0.475233903707    ,
 0.541891163697    , 0.630920817638    , 0.736828979924    , 0.86432923434     ,
 1.0174495406      , 1.18631628485     , 1.34112460699     , 1.44971168464     ,
 1.51463742728     , 1.58325129817     , 1.7014059005      , 1.86480760361     ,
 2.03930029906     , 2.22230526714     , 2.4553197695      , 2.77701914277     ,
 3.19267141774     , 3.69152487667     , 4.2644906035      , 4.8905593122      ,
 5.52226921958     , 6.10281912572     , 6.59683749182     , 6.99979911569     ,
 7.3322397875      , 7.63949530606     , 7.97677511314     , 8.36437651786     ,
 8.76262529678     , 9.11225868216     , 9.39840314253     , 9.66445238345     ,
 9.973011757       , 10.3674161039     , 10.8494317423     , 11.3501995316     ,
 11.7277084688     , 11.8580432162     , 11.7639018306     , 11.6105736078     ,
 11.5321195865     , 11.4768911467     , 11.2473184735     , 10.6778601866     ,
 9.76464523144     , 8.65200263367     , 7.52855293911     , 6.53438294657     ,
 5.72995760902     , 5.10537556543     , 4.59464713218     , 4.10077869602     ,
 3.54616283539     , 2.91878790966     , 2.27155267714     , 1.68039654629     ,
 1.20533724502     , 0.876565557153    , 0.69254545792     , 0.623854934719    ,
 0.630815878009    , 0.682376704748    , 0.753220885573    , 0.809643683015    ,
 0.814210337414    , 0.749040488199    , 0.631181188545    , 0.504528524971    ,
 0.412866991666    , 0.371319063479    , 0.358599767191    , 0.337873872025    ,
 0.287202740061    , 0.212761352966    , 0.137852382877    , 0.0833611310403   ,
 0.0573154523682   , 0.0566251570845   , 0.0734105317452   , 0.100964528023    ,
 0.139172536529    , 0.195458662438    , 0.275083836407    , 0.366432694188    ,
 0.439372472391    , 0.464904846667    , 0.438961080756    , 0.385652597335    ,
 0.338238342401    , 0.319261049772    , 0.335043658216    , 0.379689512059    ,
 0.440348593219    , 0.503606043406    , 0.561513878014    , 0.610174119501    ,
 0.641771693027    , 0.645675828852    , 0.626273256302    , 0.615924552144    ,
 0.65982254391     , 0.788060949339    , 1.00608666633     , 1.29970463343     ,
 1.63073163986     , 1.93465456882     , 2.15429227137     , 2.29427568158     ,
 2.42930304334     , 2.63899448039     , 2.93070864519     , 3.23308861857     ,
 3.47350871195     , 3.66320794443     , 3.89698206291     , 4.26654007753     ,
 4.78299606753     , 5.37517931058     , 5.93678292345     , 6.37251614513     ,
 6.62341116846     , 6.66115401715     , 6.45605173793     , 5.96408601464     ,
 3.83342757891     , 3.10984152279     , 2.4136662201      , 1.85718521175     ,
 1.47740009844     , 1.23354804447     , 1.06199733325     , 0.920055629974    ,
 0.787626253877    , 0.653241159144    , 0.512824941836    , 0.375578147734    ,
 0.260649049408    , 0.185349340133    , 0.154954282154    , 0.159395680001    ,
 0.178735752643    , 0.195900848318    , 0.206831443381    , 0.217213432932    ,
 0.229341452023    , 0.234700792958    , 0.220664676148    , 0.183695485316    ,
 0.134941488363    , 0.0921001634268   , 0.065868532114    , 0.0549318714886   ,
 0.0535009745595   , 0.0619333923109   , 0.0884558735215   , 0.138983689805    ,
 0.203893283674    , 0.256223227358    , 0.267787796655    , 0.230926271753    ,
 0.164522574117    , 0.0989754076224   , 0.0574500303858   , 0.0503136694345   ,
 0.079900694875    , 0.142247433386    , 0.223579120785    , 0.304828462978    ,
 0.3800322417      , 0.466449983908    , 0.581889711566    , 0.70961848337     ,
 0.800099398976    , 0.814072683241    , 0.754475603072    , 0.655084887138    ,
 0.554015543824    , 0.483543699454    , 0.467300636474    , 0.510497659492    ,
 0.594626765547    , 0.689878139744    , 0.776243232284    , 0.85405002856     ,
 0.935506023443    , 1.02548351861     , 1.11126651422     , 1.17802103907     ,
 1.23870558729     , 1.33725426637     , 1.50666181372     , 1.73045980445     ,
 1.96573440374     , 2.20032817744     , 2.46432943284     , 2.7901263875      ,
 3.1893404575      , 3.66446317705     , 4.20710024982     , 4.77502063091     ,
 5.29902432289     , 5.73426396215     , 6.09656926189     , 6.43689025335     ,
 6.79390665234     , 7.1854121873      , 7.62371676659     , 8.10975947125     ,
 8.61883860741     , 9.11202907398     , 9.5586373735      , 9.94427794956     ,
 10.2787891608     , 10.6099016494     , 11.0002032969     , 11.4524339502     ,
 11.8653957717     , 12.1061101687     , 12.1375900881     , 12.0421110891     ,
 11.8991916979     , 11.6669349564     , 11.2103446433     , 10.4396433687     ,
 9.41119269936     , 8.30354360157     , 7.30131745555     , 6.49072467379     ,
 5.84850020924     , 5.30524676246     , 4.79823570859     , 4.27948094281     ,
 3.71589369898     , 3.10336702346     , 2.47281208248     , 1.87511945438     ,
 1.36211587287     , 0.974905014679    , 0.732496848341    , 0.624522685305    ,
 0.620813196501    , 0.686405510517    , 0.781384309318    , 0.856227144983    ,
 0.865598008454    , 0.792646255842    , 0.65849132002     , 0.509574583035    ,
 0.391916449872    , 0.325855538968    , 0.297972575001    , 0.277194540376    ,
 0.240396951932    , 0.185725241864    , 0.127323792929    , 0.0820011855483   ,
 0.0598631047768   , 0.0619898236869   , 0.08221514798     , 0.111784101065    ,
 0.146770036192    , 0.192163243346    , 0.254543225685    , 0.327717995289    ,
 0.388356376311    , 0.410928846179    , 0.389035076974    , 0.341024515632    ,
 0.295538310057    , 0.274821247759    , 0.289987794929    , 0.342225206682    ,
 0.421163805926    , 0.505953827044    , 0.57546461733     , 0.61840901215     ,
 0.632369816462    , 0.620403144021    , 0.59839653325     , 0.600947522408    ,
 0.666482305531    , 0.815286935996    , 1.04676013266     , 1.34632970504     ,
 1.67712904776     , 1.97321987274     , 2.17340412632     , 2.28022270538     ,
 2.37292239393     , 2.54152820013     , 2.80150419378     , 3.07820853816     ,
 3.2831830158      , 3.40797173569     , 3.53571409503     , 3.76001188794     ,
 4.10405438148     , 4.51404658846     , 4.90256649872     , 5.18567252166     ,
 5.30115573556     , 5.21840712517     , 4.93572484439     , 4.46521651889     ,
 2.77031979533     , 2.24872400265     , 1.74726902778     , 1.34126130227     ,
 1.06254319027     , 0.885713370363    , 0.76300317193     , 0.660960934834    ,
 0.566497327548    , 0.474701825044    , 0.38262816327     , 0.292597311051    ,
 0.214811134099    , 0.163581164694    , 0.148023640691    , 0.16297838615     ,
 0.190151915322    , 0.212259228611    , 0.226049611294    , 0.238307171199    ,
 0.250411801479    , 0.251898332449    , 0.230441468928    , 0.185717966651    ,
 0.132193181076    , 0.0884054756933   , 0.0634865821596   , 0.0539135030943   ,
 0.052634132769    , 0.0601023025834   , 0.0852597334335   , 0.134404825237    ,
 0.197799778937    , 0.248441368407    , 0.258667162699    , 0.221692331285    ,
 0.156865397638    , 0.0943459296037   , 0.0572427621797   , 0.0570758881277   ,
 0.0977684191569   , 0.174641549883    , 0.269190667286    , 0.356339488527    ,
 0.428372963274    , 0.50669484838     , 0.61411850631     , 0.734814928404    ,
 0.818590365235    , 0.829871031437    , 0.777876294446    , 0.696162680064    ,
 0.613108780044    , 0.550531732721    , 0.530736082571    , 0.566554235331    ,
 0.646957931988    , 0.741052211787    , 0.819781448542    , 0.87479423643     ,
 0.916770981814    , 0.956902451054    , 0.994599640713    , 1.0287034674      ,
 1.07951052152     , 1.18818736305     , 1.38187119601     , 1.64222929583     ,
 1.92362085202     , 2.20216144737     , 2.49082591574     , 2.81256558568     ,
 3.18469943662     , 3.62286616387     , 4.12208538841     , 4.62648486841     ,
 5.05338420607     , 5.37175852471     , 5.64151660047     , 5.95704428231     ,
 6.36541378032     , 6.85470818491     , 7.40043650224     , 7.99443667915     ,
 8.63337453103     , 9.29397838049     , 9.91625550008     , 10.4185745886     ,
 10.7620575979     , 11.0102938499     , 11.2915360695     , 11.6734157283     ,
 12.0850889473     , 12.3814367079     , 12.4777394539     , 12.4010947761     ,
 12.2079673409     , 11.8785711121     , 11.320936884      , 10.4806682792     ,
 9.4345253971      , 8.37044074783     , 7.4670820181      , 6.7790561802      ,
 6.23238231292     , 5.72010984443     , 5.18464997785     , 4.61836352281     ,
 4.02629840314     , 3.4117655128      , 2.78522408263     , 2.17228425417     ,
 1.61485022447     , 1.16372388308     , 0.857187583361    , 0.700106363484    ,
 0.666514215695    , 0.716591052814    , 0.802965500919    , 0.871208378538    ,
 0.874609820131    , 0.7965625208      , 0.657973119182    , 0.503784355291    ,
 0.37797348067     , 0.30058331385     , 0.26191800872     , 0.237506522933    ,
 0.208181396641    , 0.168823102215    , 0.125445423562    , 0.0887319640036   ,
 0.068281205504    , 0.0681449603062   , 0.0847443127378   , 0.109471513665    ,
 0.136064394894    , 0.166230888594    , 0.205596816426    , 0.252702575905    ,
 0.293976766141    , 0.31255221327     , 0.303058242697    , 0.27656442426     ,
 0.251362896386    , 0.242686961645    , 0.26152144084     , 0.314256218011    ,
 0.394774832638    , 0.480055870585    , 0.542422460222    , 0.568213754311    ,
 0.562536347877    , 0.541425673764    , 0.528113702905    , 0.552237085509    ,
 0.638992974899    , 0.796876840561    , 1.02098074399     , 1.29962236388     ,
 1.60408477579     , 1.88008332326     , 2.07546384781     , 2.19020152432     ,
 2.28888750698     , 2.44615205697     , 2.671998241       , 2.89530201165     ,
 3.03098507151     , 3.06851691476     , 3.08825799233     , 3.18683594639     ,
 3.39406462494     , 3.66113050764     , 3.9063114511      , 4.05695201002     ,
 4.06610247233     , 3.91978207826     , 3.63593523121     , 3.24453056474     ,
 1.95727280278     , 1.58190432445     , 1.21349820096     , 0.910999141977    ,
 0.706438918578    , 0.584838404267    , 0.507473172207    , 0.445157382922    ,
 0.388530453163    , 0.337306726186    , 0.289350364533    , 0.240955499571    ,
 0.194153404529    , 0.160335977151    , 0.152571934841    , 0.17159264705     ,
 0.201852015372    , 0.225355293028    , 0.237586286722    , 0.245191003713    ,
 0.250104070714    , 0.24305472875     , 0.214208533787    , 0.166075526119    ,
 0.113873818161    , 0.0740726084529   , 0.0529616352126   , 0.0456097987276   ,
 0.0449116233148   , 0.0509470161411   , 0.0710856662378   , 0.11018573601     ,
 0.159836065507    , 0.198198880169    , 0.203902593       , 0.172814901499    ,
 0.12124155574     , 0.0734303867618   , 0.0482558446286   , 0.0565260012847   ,
 0.103259198285    , 0.183984380471    , 0.278691949278    , 0.360635939759    ,
 0.422153890318    , 0.486795205176    , 0.581016287279    , 0.693919197131    ,
 0.781420110362    , 0.81326665192     , 0.798254205556    , 0.759538590326    ,
 0.708323716289    , 0.653118789797    , 0.61609845076     , 0.623536470067    ,
 0.682569432831    , 0.772827740809    , 0.861424184971    , 0.926217633866    ,
 0.965032017241    , 0.985515440284    , 0.994312633061    , 1.00262910769     ,
 1.03891049878     , 1.14422650999     , 1.34324836655     , 1.61837600217     ,
 1.92312107314     , 2.22436065255     , 2.5211013632      , 2.82718816592     ,
 3.1594127766      , 3.53835385033     , 3.96518622838     , 4.38968528723     ,
 4.73753839125     , 4.99398940866     , 5.24039950936     , 5.58515042829     ,
 6.07140381043     , 6.66835947021     , 7.33259770229     , 8.05115099025     ,
 8.82718388088     , 9.63366862139     , 10.3807910573     , 10.9470913233     ,
 11.279292567      , 11.4648321468     , 11.6712884715     , 11.9950055685     ,
 12.3763281469     , 12.663502285      , 12.7498891796     , 12.6460116383     ,
 12.4217160724     , 12.0919205546     , 11.5837055181     , 10.8268177468     ,
 9.86521244214     , 8.86514569877     , 8.00238955963     , 7.33381993944     ,
 6.78045375404     , 6.22965587759     , 5.63343447216     , 5.00912321342     ,
 4.38243243343     , 3.75658294432     , 3.12454547392     , 2.49297295769     ,
 1.89654594101     , 1.39282426606     , 1.0324993735      , 0.827324908487    ,
 0.749121504672    , 0.753717002676    , 0.796146439158    , 0.831224645422    ,
 0.819657398378    , 0.743568976244    , 0.61580115266     , 0.472765364579    ,
 0.35323737475     , 0.276087636355    , 0.234673628961    , 0.21053230221     ,
 0.188833022307    , 0.162778561647    , 0.132073284941    , 0.102003673101    ,
 0.0810183003268   , 0.0753020100377   , 0.0842461562512   , 0.101091042829    ,
 0.118796052909    , 0.135605172175    , 0.154195553747    , 0.175608550879    ,
 0.195415795789    , 0.20702095694     , 0.208723251025    , 0.205982281504    ,
 0.206372210752    , 0.21587477123     , 0.241760616462    , 0.292016686408    ,
 0.363913346788    , 0.435932231009    , 0.47987643847     , 0.483591079479    ,
 0.459347447872    , 0.432969647268    , 0.431022661205    , 0.474610509322    ,
 0.574024617758    , 0.727036533953    , 0.926823098001    , 1.1665692751      ,
 1.42857284144     , 1.6766068057      , 1.87566880572     , 2.02522515282     ,
 2.16504989726     , 2.33644176801     , 2.53166426892     , 2.68612877092     ,
 2.73280666179     , 2.67363742101     , 2.59296499232     , 2.58996923773     ,
 2.69638204521     , 2.86077392464     , 2.99971467602     , 3.05137730372     ,
 2.99232432263     , 2.8304912212      , 2.59138650525     , 2.29768936861     ,
 1.34644758096     , 1.07736602857     , 0.810322264701    , 0.591281982096    ,
 0.447684730891    , 0.36951235866     , 0.325582976985    , 0.291866382862    ,
 0.26258699464     , 0.24069373616     , 0.224750531519    , 0.207145553471    ,
 0.184027884815    , 0.164388727823    , 0.164474670624    , 0.18977815158     ,
 0.225275224547    , 0.248516512352    , 0.25108692161     , 0.24139136926     ,
 0.227761662263    , 0.207329281218    , 0.17361386249     , 0.128788065461    ,
 0.0845835195491   , 0.052808255475    , 0.036872404596    , 0.0320898763766   ,
 0.0329264295776   , 0.039312599807    , 0.0557158505979   , 0.0838095137033   ,
 0.116084052136    , 0.137682574205    , 0.136388809683    , 0.112138076935    ,
 0.0770452914945   , 0.0469517157383   , 0.0341708616616   , 0.046911650924    ,
 0.0900076517928   , 0.159999521335    , 0.239547814298    , 0.305619890006    ,
 0.352104244189    , 0.400499888097    , 0.476482807866    , 0.576187604234    ,
 0.668914125897    , 0.733743636163    , 0.775108501508    , 0.797822460287    ,
 0.789952913282    , 0.744799523081    , 0.686112082875    , 0.658207665592    ,
 0.6927925899      , 0.786130144215    , 0.904040085089    , 1.00701975146     ,
 1.07172915994     , 1.09413013547     , 1.08426871648     , 1.06686933399     ,
 1.08244053145     , 1.17477990629     , 1.36493488902     , 1.63304560694     ,
 1.93327584302     , 2.2317939989      , 2.5230681291      , 2.81290181688     ,
 3.10761104451     , 3.42022086648     , 3.75725785504     , 4.09111160942     ,
 4.37794591263     , 4.62417850758     , 4.91234522128     , 5.3362681976      ,
 5.92227726937     , 6.62936674724     , 7.40924379647     , 8.24376771761     ,
 9.12577626104     , 10.0113919295     , 10.7962864637     , 11.3628851432     ,
 11.6809266392     , 11.8564040616     , 12.0527009509     , 12.3521974383     ,
 12.6937036994     , 12.9345697142     , 12.9743581137     , 12.8332400619     ,
 12.6095157073     , 12.3523708119     , 11.9911567873     , 11.4095708325     ,
 10.5856879417     , 9.64366683748     , 8.75887468244     , 8.01513182892     ,
 7.3642517237      , 6.71683099394     , 6.04151529861     , 5.36554575643     ,
 4.71261173895     , 4.07261499891     , 3.42434493889     , 2.76845679419     ,
 2.14152608049     , 1.60554418455     , 1.21315661083     , 0.972277604471    ,
 0.846558197396    , 0.788214387758    , 0.762298591665    , 0.743992465611    ,
 0.70943500894     , 0.639833837281    , 0.534222360789    , 0.41417806507     ,
 0.310606066555    , 0.241996768252    , 0.205755858145    , 0.188247429743    ,
 0.176800306418    , 0.162691914838    , 0.14163896747     , 0.116107287239    ,
 0.0941723604881   , 0.0834577066833   , 0.0856812483944   , 0.096186248547    ,
 0.108036385395    , 0.116609119692    , 0.121010751399    , 0.122659501187    ,
 0.123499830958    , 0.12546041643     , 0.131075834346    , 0.143053506431    ,
 0.162136668431    , 0.187768757435    , 0.222844191831    , 0.273198199608    ,
 0.336362404527    , 0.393144831615    , 0.418382783436    , 0.403483383249    ,
 0.366178342915    , 0.338234727817    , 0.346591228443    , 0.403403607954    ,
 0.506148778527    , 0.645330395244    , 0.814960230573    , 1.01319489209     ,
 1.23078478728     , 1.44679328887     , 1.64358867683     , 1.82352833607     ,
 2.00414857947     , 2.19238661342     , 2.36123331622     , 2.45473985777     ,
 2.42794701386     , 2.29591315659     , 2.14261584981     , 2.06459245992     ,
 2.09479128552     , 2.18324208792     , 2.24824730182     , 2.23711648972     ,
 2.14390661429     , 1.99056290556     , 1.80184778597     , 1.58851639094     ,
 0.903060656725    , 0.711540935405    , 0.527584969217    , 0.38076853857     ,
 0.288026265864    , 0.240805511317    , 0.215865796821    , 0.196148925105    ,
 0.179894782652    , 0.172548981951    , 0.173923110627    , 0.175322561645    ,
 0.170042839418    , 0.165438464241    , 0.179266337229    , 0.218755519326    ,
 0.26543703189     , 0.288379784527    , 0.273914887346    , 0.235563421504    ,
 0.194128679082    , 0.157320767303    , 0.121663748966    , 0.0854807433823   ,
 0.0535898357795   , 0.0318631168944   , 0.021533570331    , 0.0195703005622   ,
 0.023246814957    , 0.0331482148354   , 0.0509184335937   , 0.073942794957    ,
 0.0935043244989   , 0.0998280403955   , 0.08941213414     , 0.0673559210051   ,
 0.0432672418897   , 0.0257684651315   , 0.0206104837538   , 0.0322035830793   ,
 0.0638194649953   , 0.113228341612    , 0.168503401676    , 0.213867573766    ,
 0.245499210709    , 0.279230493768    , 0.335163770843    , 0.415330338613    ,
 0.505528454022    , 0.597458261757    , 0.691888608561    , 0.774842321726    ,
 0.811423840587    , 0.780267582359    , 0.707029175444    , 0.653676095193    ,
 0.67504796736     , 0.782969115334    , 0.942916070591    , 1.09943240555     ,
 1.20632736461     , 1.24261551873     , 1.21695466274     , 1.16738576216     ,
 1.15028281232     , 1.21530179045     , 1.37913439909     , 1.61796014025     ,
 1.88984621091     , 2.16884448982     , 2.45180264378     , 2.73599826677     ,
 3.01125688752     , 3.27697532315     , 3.54270675978     , 3.80633421562     ,
 4.06007219187     , 4.33286785848     , 4.70153968711     , 5.23488453103     ,
 5.93578600805     , 6.75154783604     , 7.62731578049     , 8.53326594654     ,
 9.44509491797     , 10.3090472222     , 11.0368375321     , 11.5561000295     ,
 11.8796022177     , 12.1116012643     , 12.3685274684     , 12.6891192713     ,
 13.0107790775     , 13.2188943784     , 13.2356117561     , 13.0904930046     ,
 12.8964833709     , 12.7267116269     , 12.5167158702     , 12.1133496171     ,
 11.4283402344     , 10.5323294767     , 9.59025642844     , 8.71655594723     ,
 7.91248902914     , 7.13396804532     , 6.37589835113     , 5.66549376472     ,
 5.00275009447     , 4.34784015004     , 3.66713534933     , 2.97219415763     ,
 2.31659515458     , 1.76685398356     , 1.36615614184     , 1.10803507292     ,
 0.944309880593    , 0.824430039172    , 0.725760130476    , 0.646986923565    ,
 0.583294591638    , 0.517700568174    , 0.435895060575    , 0.342968149086    ,
 0.260178080672    , 0.205318579747    , 0.179862723614    , 0.173348463757    ,
 0.172710090728    , 0.166818840832    , 0.150008546623    , 0.125338175974    ,
 0.102112377121    , 0.0887218936041   , 0.0875210968382   , 0.0947569836913   ,
 0.103794434902    , 0.108517733264    , 0.105536273784    , 0.0957120149673   ,
 0.0841965736023   , 0.077852425655    , 0.0819465408767   , 0.0984335648904   ,
 0.126059879136    , 0.162612473355    , 0.208135107601    , 0.263639416231    ,
 0.323213947973    , 0.369097941291    , 0.381205805783    , 0.356101573841    ,
 0.315346995622    , 0.292649790195    , 0.312341788006    , 0.378112576292    ,
 0.478197668762    , 0.600217668234    , 0.741668992894    , 0.904827413122    ,
 1.08403557956     , 1.26633524378     , 1.446131799       , 1.63017917359     ,
 1.82261189625     , 2.00791786603     , 2.14975156529     , 2.20482023633     ,
 2.14592996491     , 1.98960812125     , 1.8055538546      , 1.67901373124     ,
 1.64684679136     , 1.67285442882     , 1.68758390349     , 1.64511482645     ,
 1.54312131334     , 1.40400629277     , 1.24839491515     , 1.08262956773     ,
 0.597834297307    , 0.46038581254     , 0.341936580248    , 0.254543617312    ,
 0.202394492265    , 0.176325663357    , 0.160088295852    , 0.143420496759    ,
 0.12829770113     , 0.122375387308    , 0.127603155596    , 0.136859138163    ,
 0.143474815554    , 0.153764906284    , 0.184612267163    , 0.241616935329    ,
 0.301032474868    , 0.323819791452    , 0.292440034248    , 0.226555393516    ,
 0.159664346952    , 0.109581190608    , 0.0748274440155   , 0.0488416355522   ,
 0.0292634831883   , 0.0167449699977   , 0.0113059978971   , 0.0120682993672   ,
 0.0193633309055   , 0.0350699209464   , 0.0588575057692   , 0.0837027608369   ,
 0.0976980664108   , 0.0930182429941   , 0.0726529137912   , 0.047177602198    ,
 0.026222378067    , 0.0140350212338   , 0.011285684024    , 0.0185345816044   ,
 0.036885773464    , 0.0650893798704   , 0.0968651149614   , 0.124024212062    ,
 0.145063936423    , 0.169387977458    , 0.209404928633    , 0.269646777492    ,
 0.348974934518    , 0.450312724579    , 0.573536424274    , 0.693153126196    ,
 0.759897737219    , 0.742677491668    , 0.667486578089    , 0.606586088636    ,
 0.628497033097    , 0.754810083398    , 0.952752219769    , 1.15877150539     ,
 1.30985313591     , 1.36672335305     , 1.32992351711     , 1.24512629537     ,
 1.18385421446     , 1.20476953035     , 1.32424812242     , 1.51817104672     ,
 1.7517792312      , 2.00868091359     , 2.28720475274     , 2.57567009505     ,
 2.85165380435     , 3.10713454726     , 3.35390247869     , 3.60363119369     ,
 3.86900522783     , 4.19302132025     , 4.65033498414     , 5.29511713854     ,
 6.11267307222     , 7.03238976453     , 7.97782364132     , 8.89493128396     ,
 9.74424279497     , 10.4851944074     , 11.0831791856     , 11.5408301501     ,
 11.91378572       , 12.2760190301     , 12.6646176646     , 13.0610123956     ,
 13.4086329864     , 13.6343423603     , 13.6825453294     , 13.5694952217     ,
 13.3932465347     , 13.245397947      , 13.0997819024     , 12.8123357379     ,
 12.249231413      , 11.4096370219     , 10.4149639261     , 9.39450119139     ,
 8.40946599644     , 7.48185775275     , 6.64454764541     , 5.91988642561     ,
 5.26749339225     , 4.60186722945     , 3.87512747684     , 3.12372756252     ,
 2.43381981419     , 1.87900306618     , 1.48458588296     , 1.22315942497     ,
 1.03542375243     , 0.870067123216    , 0.71399225471     , 0.583547714373    ,
 0.490069607949    , 0.421311179375    , 0.355389550697    , 0.284731037044    ,
 0.2214012911      , 0.181366689716    , 0.168628106219    , 0.173710338835    ,
 0.181053766139    , 0.177028116657    , 0.157022829668    , 0.127831413913    ,
 0.101557164093    , 0.0866209821445   , 0.0839760172936   , 0.0891683160966   ,
 0.095976197893    , 0.0986237881521   , 0.0932738602542   , 0.0804086538607   ,
 0.0658963980674   , 0.0578240998053   , 0.0617309001753   , 0.0791647567815   ,
 0.109834079686    , 0.153694773482    , 0.210161083288    , 0.274621821156    ,
 0.335209474849    , 0.374393096885    , 0.378556388738    , 0.351147554595    ,
 0.316422799649    , 0.306041701286    , 0.338475636973    , 0.409545412782    ,
 0.502053087079    , 0.604581914284    , 0.719711877165    , 0.853014474869    ,
 0.999378849213    , 1.14830482698     , 1.30008284462     , 1.46434309865     ,
 1.63906055997     , 1.79971002583     , 1.91212863083     , 1.94864147245     ,
 1.89395856067     , 1.75541309179     , 1.57710561512     , 1.42548706513     ,
 1.34263363395     , 1.31605921707     , 1.29794205165     , 1.24760452143     ,
 1.15431513609     , 1.0296458865      , 0.889181103777    , 0.743158635603    ,
 0.395588975201    , 0.294979718958    , 0.224219164541    , 0.181315371595    ,
 0.159590358293    , 0.148272890106    , 0.135909349172    , 0.117379200791    ,
 0.0974852419028   , 0.0855762750963   , 0.0859041508561   , 0.0942576208621   ,
 0.105700550565    , 0.125478734032    , 0.167228385047    , 0.233207629421    ,
 0.297208039021    , 0.318459970246    , 0.279255880033    , 0.20213056915     ,
 0.12590497055     , 0.0729965770489   , 0.0428595768738   , 0.025993951701    ,
 0.0156117212478   , 0.00933850133341  , 0.00694102922069  , 0.00941945395534  ,
 0.019450058055    , 0.0400986149413   , 0.0699534749062   , 0.0987761508207   ,
 0.111567685679    , 0.100639612956    , 0.0727611833403   , 0.0426156536526   ,
 0.0209298089609   , 0.00995354658955  , 0.00719836483184  , 0.010305817301    ,
 0.0185504998384   , 0.031382269334    , 0.046815903596    , 0.062467614804    ,
 0.0789058204755   , 0.100977418124    , 0.134413841271    , 0.182579198244    ,
 0.249555933305    , 0.34325252728     , 0.464146770695    , 0.585496843772    ,
 0.657363721642    , 0.647523119141    , 0.580008072211    , 0.525701948622    ,
 0.553463003696    , 0.687857693603    , 0.901349869545    , 1.13345528758     ,
 1.31591408759     , 1.39578986386     , 1.36054383817     , 1.25289164182     ,
 1.1511187252      , 1.12244840329     , 1.18964619744     , 1.33585118794     ,
 1.53539690848     , 1.77663762851     , 2.05403951562     , 2.34962314838     ,
 2.6408246693      , 2.92416097476     , 3.21267013104     , 3.51416429631     ,
 3.83741777913     , 4.22510070742     , 4.75536008003     , 5.48701922119     ,
 6.40261043038     , 7.41113363398     , 8.39948037702     , 9.27842288134     ,
 9.99993112056     , 10.5612383642     , 11.0101765512     , 11.4368622138     ,
 11.9269035916     , 12.4981234702     , 13.0891500475     , 13.6196342124     ,
 14.0442956852     , 14.3356357781     , 14.4508118892     , 14.3664027204     ,
 14.1410653161     , 13.8921505289     , 13.6794066605     , 13.4252239951     ,
 12.9716538523     , 12.2174071967     , 11.1938249069     , 10.0237828498     ,
 8.84028153011     , 7.75213195931     , 6.83946147974     , 6.11689468882     ,
 5.49526487389     , 4.83394918639     , 4.06533500425     , 3.2533180414      ,
 2.52373394498     , 1.9611390153      , 1.57240123841     , 1.31030660408     ,
 1.10969203002     , 0.921395381543    , 0.735861841755    , 0.575202472988    ,
 0.4587488516      , 0.380153255818    , 0.317354508106    , 0.257116362027    ,
 0.205346517909    , 0.175813467347    , 0.173127682763    , 0.186715888803    ,
 0.197386897987    , 0.189507258992    , 0.161166693475    , 0.124333133749    ,
 0.0941243978148   , 0.0779535536424   , 0.073908515146    , 0.0760404952788   ,
 0.0790721905579   , 0.0792784629639   , 0.0742804452302   , 0.0648319431691   ,
 0.0561843165243   , 0.055167526952    , 0.0654865944167   , 0.0873245294609   ,
 0.121557781432    , 0.171711547519    , 0.238818030371    , 0.314229202249    ,
 0.379661954917    , 0.416188446307    , 0.415990556461    , 0.389720890868    ,
 0.363465466372    , 0.364186133286    , 0.402810968187    , 0.469267815564    ,
 0.545275138921    , 0.6232486305      , 0.710717666376    , 0.815373999887    ,
 0.931826079812    , 1.0500059365      , 1.17206607538     , 1.30819732725     ,
 1.45392201899     , 1.58316723587     , 1.66786243803     , 1.6938596314      ,
 1.65506814224     , 1.55018272588     , 1.39804671862     , 1.24281109795     ,
 1.12734725803     , 1.06230146676     , 1.02409584494     , 0.978099078229    ,
 0.901807430659    , 0.792069685457    , 0.659539155301    , 0.521393315035    ,
 0.260054685824    , 0.187218066051    , 0.149227281283    , 0.135990456496    ,
 0.134354626739    , 0.132395959765    , 0.121834639848    , 0.101207569036    ,
 0.0770237369574   , 0.0590431400046   , 0.0526286310317   , 0.0560379007074   ,
 0.0661881643213   , 0.0867731296933   , 0.126895376869    , 0.186061217393    ,
 0.241208546514    , 0.258318081617    , 0.223282535272    , 0.156122366208    ,
 0.0909332384841   , 0.0478591848311   , 0.0265117085796   , 0.0173827581483   ,
 0.0126787365838   , 0.00929670096166  , 0.0075339446534   , 0.0097318185428   ,
 0.0197185790398   , 0.0409587755344   , 0.0716580078089   , 0.100760207561    ,
 0.11269513021     , 0.100081110231    , 0.0707623084968   , 0.0403920989379   ,
 0.0198017007486   , 0.010400971101    , 0.00821947472531  , 0.00921344941765  ,
 0.0115952564628   , 0.0155079301444   , 0.0218858802979   , 0.0321678241154   ,
 0.0488284041895   , 0.0748906477083   , 0.111940568546    , 0.159716243072    ,
 0.219683325016    , 0.297255827377    , 0.392936574263    , 0.486657114948    ,
 0.539837725862    , 0.527419520935    , 0.469996159995    , 0.42711376632     ,
 0.457075223433    , 0.582241536635    , 0.782586441455    , 1.00908233646     ,
 1.20000657846     , 1.29870283811     , 1.28079066959     , 1.17642025223     ,
 1.05729611233     , 0.992533711391    , 1.01439705764     , 1.11957423041     ,
 1.29275647142     , 1.52286310865     , 1.79870408133     , 2.1028395644      ,
 2.42390463931     , 2.76818815676     , 3.14325646386     , 3.53764034094     ,
 3.94040891615     , 4.38617630572     , 4.96091606325     , 5.74060781027     ,
 6.71635023322     , 7.78036064705     , 8.78136472129     , 9.59701553823     ,
 10.1807591465     , 10.5801969448     , 10.9298029893     , 11.3967712008     ,
 12.0779025121     , 12.9212563796     , 13.7642515765     , 14.4666509874     ,
 14.994240827      , 15.361551385      , 15.5310014618     , 15.4289620366     ,
 15.0694486098     , 14.6079672754     , 14.2222126614     , 13.9350032548     ,
 13.5743661804     , 12.9176555688     , 11.8766311077     , 10.5566693861     ,
 9.17090235242     , 7.92309102814     , 6.93847312097     , 6.22072621511     ,
 5.63652174172     , 4.99616392615     , 4.20861814177     , 3.35339310166     ,
 2.58826713746     , 2.01152946314     , 1.62022192039     , 1.35561891258     ,
 1.15247783576     , 0.964585594868    , 0.778888364617    , 0.611490318367    ,
 0.481566459887    , 0.388876107955    , 0.317211761559    , 0.254272248687    ,
 0.203568179597    , 0.177051119552    , 0.178529594768    , 0.195351823508    ,
 0.205249495261    , 0.191894711627    , 0.156490053991    , 0.115041461994    ,
 0.0838849961575   , 0.0681575703753   , 0.0627654528289   , 0.0606957662285   ,
 0.0584513034894   , 0.0553612080369   , 0.0514563539021   , 0.0482726974767   ,
 0.0502587777826   , 0.0623881161182   , 0.0858329594673   , 0.118283392802    ,
 0.16008445937     , 0.217448447433    , 0.294736330808    , 0.382673531334    ,
 0.458088702898    , 0.498310111493    , 0.497213883045    , 0.46997317882     ,
 0.443866800227    , 0.441636715856    , 0.468565103583    , 0.512833374523    ,
 0.559807264269    , 0.607648911572    , 0.667255506761    , 0.746143607849    ,
 0.837483979625    , 0.930467720408    , 1.02712750766     , 1.13759754645     ,
 1.25730462235     , 1.3605065909      , 1.42196805193     , 1.43546478777     ,
 1.4048561704      , 1.32948260351     , 1.21196468449     , 1.07392177092     ,
 0.950044116124    , 0.864116403638    , 0.812838783388    , 0.770767817551    ,
 0.709467641077    , 0.615041443067    , 0.493873693174    , 0.367345073961    ,
 0.165662387022    , 0.116768742752    , 0.100317213965    , 0.103771376193    ,
 0.112193405178    , 0.114046788083    , 0.103833784864    , 0.0829753665752   ,
 0.0586021175319   , 0.0392101618549   , 0.0294243234088   , 0.0285722175474   ,
 0.0346940872328   , 0.0497123951431   , 0.0785011707623   , 0.119518759357    ,
 0.156879725752    , 0.168162651559    , 0.144544397165    , 0.0999889971236   ,
 0.0578857316087   , 0.032127331095    , 0.0220605178729   , 0.019835887178    ,
 0.0185664402767   , 0.0157130448146   , 0.0125340811758   , 0.0122490498544   ,
 0.0187731121249   , 0.0351220323808   , 0.0596811134527   , 0.0831380227847   ,
 0.0925496173549   , 0.0819128937923   , 0.0579586961254   , 0.0339390946319   ,
 0.0190025041779   , 0.0139959741604   , 0.014468572579    , 0.015471683877    ,
 0.0147246458386   , 0.013309990603    , 0.0144795066153   , 0.022337615301    ,
 0.041184181985    , 0.0741908089207   , 0.12093339591     , 0.176560897868    ,
 0.235486005412    , 0.296273387836    , 0.35872759306     , 0.412686806827    ,
 0.43589906092     , 0.414026815748    , 0.36397703026     , 0.330476773561    ,
 0.357444360941    , 0.462619289958    , 0.632530929119    , 0.831197916048    ,
 1.00973061474     , 1.11749848659     , 1.12476105509     , 1.04637805152     ,
 0.937628445799    , 0.860327159945    , 0.852560635533    , 0.924806089352    ,
 1.07281224223     , 1.28775008        , 1.55877842871     , 1.87809761853     ,
 2.24961201436     , 2.68216596221     , 3.1638092056      , 3.65410879852     ,
 4.12325237714     , 4.60467287876     , 5.19583204748     , 5.98729760041     ,
 6.97709886701     , 8.04854738568     , 9.02972679967     , 9.78454069851     ,
 10.2792881901     , 10.6069551395     , 10.9646338633     , 11.5633438539     ,
 12.4883689191     , 13.6181394918     , 14.7041069311     , 15.5585614963     ,
 16.1590990882     , 16.5577610337     , 16.7244153179     , 16.5476440088     ,
 16.0090697462     , 15.301628825      , 14.7090848837     , 14.3466693575     ,
 14.0344005118     , 13.4439450077     , 12.3808003752     , 10.9346803765     ,
 9.38692413804     , 8.01468688213     , 6.96811295608     , 6.23663634458     ,
 5.66307801444     , 5.03638147555     , 4.24996332913     , 3.38102522763     ,
 2.59848047769     , 2.01165051148     , 1.61879604807     , 1.35857359544     ,
 1.1666391225      , 0.99644170976     , 0.826835282928    , 0.663472150429    ,
 0.523248944107    , 0.413102752857    , 0.325622139237    , 0.252533899455    ,
 0.196744829731    , 0.168180061435    , 0.168850384683    , 0.184416211158    ,
 0.191678428927    , 0.17540483678     , 0.139197016714    , 0.100224555297    ,
 0.0733858714555   , 0.0608425427569   , 0.0552275668218   , 0.0495825902777   ,
 0.0426454015216   , 0.0366510683895   , 0.0337739761578   , 0.0363351463727   ,
 0.048446128779    , 0.0742129951027   , 0.113370422146    , 0.161126648669    ,
 0.215356810097    , 0.282425852739    , 0.369928712408    , 0.471198011751    ,
 0.561217798341    , 0.612081267801    , 0.613594474004    , 0.580216886597    ,
 0.539750049741    , 0.514426498379    , 0.509355886397    , 0.516024822165    ,
 0.526523015885    , 0.544814469412    , 0.582880159229    , 0.645327189675    ,
 0.721577302865    , 0.798064388396    , 0.875601066925    , 0.965130689722    ,
 1.06390994369     , 1.14630519176     , 1.18594625992     , 1.18046447958     ,
 1.14541043236     , 1.08921272906     , 1.00720658007     , 0.900419106272    ,
 0.788126004607    , 0.695811242553    , 0.633551796089    , 0.587983758818    ,
 0.534105483389    , 0.45492250522     , 0.353240252982    , 0.248950365946    ,
 0.100924371854    , 0.072323400067    , 0.0685592031656   , 0.0785682443273   ,
 0.0890751727137   , 0.0904304338886   , 0.0798148872998   , 0.0607816117834   ,
 0.0401211584418   , 0.0239545019007   , 0.0149881567668   , 0.0125210555289   ,
 0.0150919544423   , 0.0232561112362   , 0.0390244539966   , 0.0610889545588   ,
 0.0809159748733   , 0.0869081506808   , 0.0748362338917   , 0.0525857110808   ,
 0.0331274069958   , 0.0241899289928   , 0.0247495508737   , 0.0286000523203   ,
 0.029928234197    , 0.0269188474806   , 0.0216656339613   , 0.017772832446    ,
 0.0186370563565   , 0.0265670156946   , 0.0406722399952   , 0.0548605111722   ,
 0.0605156204247   , 0.0536081985778   , 0.038701705217    , 0.0249626915353   ,
 0.0188937740255   , 0.0207384588625   , 0.0257685997262   , 0.028205145157    ,
 0.0254079687879   , 0.0196350915652   , 0.016427607026    , 0.0221682592378   ,
 0.0428252953748   , 0.0822283761128   , 0.138514172016    , 0.202136879965    ,
 0.260332932803    , 0.305797058053    , 0.338895891831    , 0.35872867344     ,
 0.356533679715    , 0.326144505651    , 0.281031059736    , 0.254093372113    ,
 0.277905216831    , 0.365548331266    , 0.506433339985    , 0.673377895184    ,
 0.829732434691    , 0.935426680624    , 0.962300298147    , 0.91474178054     ,
 0.831355519624    , 0.761409539019    , 0.741171386867    , 0.788632493989    ,
 0.909211619396    , 1.10163910114     , 1.3651858211      , 1.70871111163     ,
 2.14815734229     , 2.68156577643     , 3.26390886457     , 3.82397906014     ,
 4.3255609038      , 4.81605359879     , 5.40602335589     , 6.18681493617     ,
 7.15245207326     , 8.188058363       , 9.13039154502     , 9.85672160303     ,
 10.3536410896     , 10.741882883      , 11.2421016481     , 12.0640016179     ,
 13.2548877918     , 14.6296113017     , 15.8805370694     , 16.7964911099     ,
 17.3762050343     , 17.7126910241     , 17.7984554301     , 17.512938082      ,
 16.8205180728     , 15.9239430848     , 15.1537976627     , 14.6775125886     ,
 14.3252089751     , 13.7262571403     , 12.6358555939     , 11.1339517794     ,
 9.52842185926     , 8.11531610653     , 7.03381430074     , 6.25626271051     ,
 5.63187952978     , 4.97237264639     , 4.18057381312     , 3.32177379712     ,
 2.55137560409     , 1.97711593575     , 1.6005339574      , 1.35993752387     ,
 1.18821054934     , 1.03514507672     , 0.873766665028    , 0.704975452414    ,
 0.547830487214    , 0.41754001301     , 0.31438107137     , 0.232787825427    ,
 0.174004549541    , 0.144677345033    , 0.144241075951    , 0.157631144081    ,
 0.162943008015    , 0.147277829083    , 0.115473739268    , 0.0834187648108   ,
 0.0631987218073   , 0.0547460964761   , 0.0501754363838   , 0.0435283039115   ,
 0.0352061026912   , 0.0289112804872   , 0.0276651682135   , 0.0340469089952   ,
 0.0523082060783   , 0.0871909615881   , 0.139129993806    , 0.202355261738    ,
 0.271501729279    , 0.35007946897     , 0.44655477206     , 0.558208716991    ,
 0.662121105932    , 0.726674126481    , 0.733760794971    , 0.691325496579    ,
 0.62618083251     , 0.564793064885    , 0.518988275364    , 0.487356955084    ,
 0.467937208042    , 0.467433565322    , 0.496373324389    , 0.555139459845    ,
 0.628348018645    , 0.698494267035    , 0.764525538967    , 0.838251885685    ,
 0.918759942209    , 0.980080033241    , 0.994283488103    , 0.962718209003    ,
 0.912897907551    , 0.86428110344     , 0.809458526005    , 0.733336680794    ,
 0.639286204064    , 0.548084974766    , 0.476469769985    , 0.422669844478    ,
 0.370983124171    , 0.307320495544    , 0.231449026776    , 0.156997281467    ,
 0.0622536004655   , 0.0480967309016   , 0.0493950895752   , 0.0587133215096   ,
 0.0664012450838   , 0.0654497205975   , 0.0549806967749   , 0.0393319094619   ,
 0.0241237264441   , 0.0130253426991   , 0.00689602794813  , 0.00474886646376  ,
 0.0054224653919   , 0.00879982104396  , 0.0154696790976   , 0.0247249151354   ,
 0.0330085216328   , 0.0356734463452   , 0.0313030793944   , 0.0237422027297   ,
 0.0191950556197   , 0.0214293586619   , 0.0292490381552   , 0.0376102175382   ,
 0.0414681455983   , 0.0393541110382   , 0.0334048593302   , 0.0267387456423   ,
 0.021952182285    , 0.0211004272188   , 0.0246168426079   , 0.0297323359282   ,
 0.031767492379    , 0.0283313076305   , 0.0219434362878   , 0.0181106288449   ,
 0.0209742732544   , 0.030110113195    , 0.0402761804368   , 0.0447079816061   ,
 0.0403518674601   , 0.0305545396712   , 0.0230015010206   , 0.0262166137111   ,
 0.0476247981133   , 0.0911708079564   , 0.152777798702    , 0.2183705602      ,
 0.270659981025    , 0.301034557911    , 0.313250242689    , 0.313288260483    ,
 0.299238566323    , 0.267484545716    , 0.228214821342    , 0.207961957078    ,
 0.23343146386     , 0.313654886955    , 0.436537961411    , 0.577985970969    ,
 0.710010864236    , 0.803314788632    , 0.835990601236    , 0.809865213738    ,
 0.753540710476    , 0.704225211937    , 0.690070188852    , 0.728168585392    ,
 0.829205976409    , 1.00154944365     , 1.25940107503     , 1.62908626586     ,
 2.13280586601     , 2.750395556       , 3.40239453986     , 3.99457800091     ,
 4.49703249095     , 4.97967119252     , 5.56272483699     , 6.3254319867      ,
 7.2505357523      , 8.23660174993     , 9.15394670038     , 9.91156427819     ,
 10.5154693453     , 11.0947426606     , 11.8601667164     , 12.9816824499     ,
 14.4442608865     , 16.0040302745     , 17.3206628815     , 18.1849849945     ,
 18.6298813238     , 18.7998220556     , 18.7337837463     , 18.3348679422     ,
 17.5590564082     , 16.5740100975     , 15.6774094517     , 15.0387639774     ,
 14.5262723298     , 13.8141045386     , 12.6827066489     , 11.2097871622     ,
 9.67501886457     , 8.32582480917     , 7.24981981605     , 6.39808123193     ,
 5.65306156044     , 4.89299411863     , 4.0650166483      , 3.22755244023     ,
 2.50274197791     , 1.97452330849     , 1.63602471361     , 1.42101378661     ,
 1.25846306275     , 1.09838346083     , 0.917882209461    , 0.723496055105    ,
 0.540844211549    , 0.391345711828    , 0.278577962637    , 0.196236927837    ,
 0.141846657853    , 0.117526113027    , 0.119738804941    , 0.133327496708    ,
 0.138583239638    , 0.12496584817     , 0.097661483886    , 0.0706843603865   ,
 0.0540997370554   , 0.0476155523462   , 0.0446879399048   , 0.0406453281261   ,
 0.036028460723    , 0.0337310329679   , 0.035851319078    , 0.0445151929018   ,
 0.0643484548347   , 0.10167158888     , 0.159189574737    , 0.231917638956    ,
 0.311848774421    , 0.397893423278    , 0.496647373933    , 0.609176357898    ,
 0.718511912124    , 0.793606441004    , 0.808338099       , 0.760036483856    ,
 0.672035136814    , 0.577829681628    , 0.500902602968    , 0.448043925639    ,
 0.418940133453    , 0.417411774249    , 0.4499589246      , 0.513748717372    ,
 0.591040395761    , 0.662267510927    , 0.724587608622    , 0.788580271707    ,
 0.852496640734    , 0.889816123811    , 0.87391217556     , 0.811913972113    ,
 0.741055409798    , 0.688336191416    , 0.645151032051    , 0.587021611812    ,
 0.50667555688     , 0.419207961374    , 0.342896424637    , 0.28359426714     ,
 0.234787269475    , 0.187246780996    , 0.138333509371    , 0.0938395837524   ,
 0.047099405814    , 0.0402260564063   , 0.0401010659591   , 0.0438651080711   ,
 0.0463333637633   , 0.0431430762765   , 0.0341015721696   , 0.022717257555    ,
 0.0128362864299   , 0.00627304124283  , 0.0028535131324   , 0.00157799695878  ,
 0.00160806867093  , 0.00267954600215  , 0.00488566730811  , 0.00797394108306  ,
 0.0108529213507   , 0.0121812026449   , 0.0117821905323   , 0.0113772181342   ,
 0.0137002351246   , 0.0205486011658   , 0.030989321174    , 0.0412914719006   ,
 0.047449977993    , 0.0480410493105   , 0.0440894884221   , 0.0370481196866   ,
 0.0284880446128   , 0.0208794117134   , 0.0164490391187   , 0.0150815529761   ,
 0.0145948566367   , 0.013449283962    , 0.0128227735051   , 0.0159980370072   ,
 0.0255993333614   , 0.040496200745    , 0.0547927836663   , 0.06098419129     ,
 0.0557306189524   , 0.0429511451457   , 0.0317117278237   , 0.0323105281888   ,
 0.0535194333268   , 0.0989915455383   , 0.161956718019    , 0.224488276931    ,
 0.267402244736    , 0.284107812729    , 0.283048505533    , 0.27474094791     ,
 0.259424765703    , 0.23244558312     , 0.201045466474    , 0.188995117764    ,
 0.220307313652    , 0.299787657405    , 0.410947587349    , 0.529699073429    ,
 0.634798840581    , 0.70747541578     , 0.734694764845    , 0.721390374754    ,
 0.692191320631    , 0.6751855304      , 0.68886238729     , 0.74439983907     ,
 0.851640617591    , 1.02311662039     , 1.28260090926     , 1.66799439606     ,
 2.20462281584     , 2.85957650118     , 3.53356647545     , 4.12430049542     ,
 4.61310674221     , 5.08661372929     , 5.66658887276     , 6.41696605085     ,
 7.31244478712     , 8.27336503538     , 9.21270853028     , 10.0737214881     ,
 10.8743075362     , 11.7374490272     , 12.8460486134     , 14.3117860832     ,
 16.0474338802     , 17.7581738792     , 19.0900327052     , 19.8482999862     ,
 20.1000786208     , 20.0435075635     , 19.7829796079     , 19.2736663691     ,
 18.4735086974     , 17.4844325453     , 16.5100530214     , 15.6757991069     ,
 14.8987271958     , 13.9608328033     , 12.732688949      , 11.3076679424     ,
 9.9050605624      , 8.67703029244     , 7.63003530856     , 6.68755158086     ,
 5.77704953685     , 4.86802723617     , 3.97821671245     , 3.16958987081     ,
 2.51846086133     , 2.06140420533     , 1.76641489629     , 1.56004561606     ,
 1.37505638219     , 1.17392065939     , 0.949400603018    , 0.719164644075    ,
 0.512843217132    , 0.351616997462    , 0.237464559439    , 0.16144166462     ,
 0.116953017325    , 0.101563240374    , 0.108986091057    , 0.124322303105    ,
 0.130046138081    , 0.117402014363    , 0.0914571854892   , 0.0648893915699   ,
 0.0473705799809   , 0.040322792625    , 0.0397516885791   , 0.0419891359406   ,
 0.0459986258916   , 0.0517085226102   , 0.0588741316703   , 0.0688985417339   ,
 0.0870917785699   , 0.121398863016    , 0.176506874547    , 0.248400266235    ,
 0.327391299344    , 0.408436658062    , 0.495782699567    , 0.594142298081    ,
 0.694875465631    , 0.771835278358    , 0.793887039823    , 0.747371866966    ,
 0.650054119283    , 0.541443710562    , 0.45663018022     , 0.408763098637    ,
 0.3943379109      , 0.408963290957    , 0.452887564962    , 0.522165154212    ,
 0.601492869719    , 0.673607188181    , 0.734898678304    , 0.792039291345    ,
 0.83954665555     , 0.851353156215    , 0.806206157905    , 0.718203882101    ,
 0.629212151889    , 0.567413334826    , 0.523095911474    , 0.46930893376     ,
 0.395182864821    , 0.312174458676    , 0.237346606323    , 0.179521166312    ,
 0.137741160924    , 0.106458573951    , 0.0812336740894   , 0.061091980896    ,
 0.050840317311    , 0.0446688003098   , 0.0384678438052   , 0.0340763652145   ,
 0.0306046712587   , 0.0257568030328   , 0.0189208915947   , 0.0117363943153   ,
 0.0061140294666   , 0.0027081658433   , 0.00107088635501  , 0.000469925314893 ,
 0.000397863545392 , 0.000666712078002 , 0.00128641423075  , 0.00227428951132  ,
 0.00355433141084  , 0.00506574847364  , 0.00695816459415  , 0.00967665261246  ,
 0.0139442084623   , 0.0204672196988   , 0.0290622202583   , 0.038050996532    ,
 0.0452209077808   , 0.049206704573    , 0.0491690447602   , 0.0441682571636   ,
 0.0346162834224   , 0.0236105884363   , 0.0150389047333   , 0.0105203481227   ,
 0.00903992036752  , 0.00924529799505  , 0.0116240289621   , 0.0185442218474   ,
 0.0319080335959   , 0.0499594367986   , 0.066337202486    , 0.0734651027065   ,
 0.0680623954814   , 0.0539111259606   , 0.0402234368549   , 0.0383019258274   ,
 0.0582337394598   , 0.103995242003    , 0.167517506601    , 0.228794992046    ,
 0.267355603483    , 0.276935588353    , 0.267824241875    , 0.253451201386    ,
 0.236653280483    , 0.213137422536    , 0.188222478009    , 0.183064436082    ,
 0.218438199886    , 0.294383141144    , 0.39020993877     , 0.482611699478    ,
 0.557631684725    , 0.607268365781    , 0.627920793055    , 0.628466093901    ,
 0.63068918012     , 0.65599485024     , 0.716561783885    , 0.818489329827    ,
 0.965826885539    , 1.16476200782     , 1.43600356122     , 1.81978382257     ,
 2.34533033451     , 2.98139885852     , 3.63124237456     , 4.20018156949     ,
 4.67873329973     , 5.1563489962      , 5.74764725071     , 6.50508134652     ,
 7.40260308292     , 8.38375710742     , 9.4012198707      , 10.4288878009     ,
 11.4900687806     , 12.6898447082     , 14.1710683018     , 15.984005784      ,
 17.980421778      , 19.8356352252     , 21.198415671      , 21.8850432088     ,
 21.9749350861     , 21.7004503703     , 21.2332645614     , 20.6019090024     ,
 19.7892143931     , 18.8365379514     , 17.8317220218     , 16.8190402442     ,
 15.7399069335     , 14.4915338135     , 13.065269364      , 11.598763304      ,
 10.2623729221     , 9.11170153592     , 8.06811791595     , 7.02348647575     ,
 5.94459447996     , 4.88760903791     , 3.94134899475     , 3.17295963688     ,
 2.60744007747     , 2.22219816845     , 1.95293247322     , 1.72395603404     ,
 1.485066304       , 1.22362260972     , 0.953245271995    , 0.699200140642    ,
 0.486186266846    , 0.327028936428    , 0.218904782857    , 0.151153451013    ,
 0.115179885817    , 0.105609068743    , 0.114434328203    , 0.127820049273    ,
 0.130961053099    , 0.116882591536    , 0.0902122815068   , 0.0622711999437   ,
 0.0428101964186   , 0.0355430196943   , 0.0392098480527   , 0.050615496732    ,
 0.0659715925548   , 0.0810773466295   , 0.0930452740884   , 0.103287818645    ,
 0.118589623945    , 0.147974096933    , 0.195997488557    , 0.257681327434    ,
 0.322057182219    , 0.382715939311    , 0.443802679689    , 0.513903390081    ,
 0.592377610847    , 0.659882251767    , 0.684764706308    , 0.646322909211    ,
 0.556606118814    , 0.456801417109    , 0.388314303613    , 0.367056755478    ,
 0.3841317909      , 0.424929776439    , 0.482139866881    , 0.551639609896    ,
 0.623899407083    , 0.687721789933    , 0.740643390136    , 0.785438543795    ,
 0.813516261248    , 0.802352167705    , 0.739248797955    , 0.643608658976    ,
 0.554220904435    , 0.492192075861    , 0.444700428825    , 0.387318282097    ,
 0.31252049303     , 0.232271827939    , 0.16241589269     , 0.111598139493    ,
 0.0804394943089   , 0.0646930223574   , 0.0582200722469   , 0.05502133198     ,
 0.0659128189752   , 0.055755579157    , 0.0414094160168   , 0.0287820021554   ,
 0.0200986442911   , 0.014131225016    , 0.0093114628206   , 0.00535528619395  ,
 0.00259693781707  , 0.00105726450702  , 0.000371205720644 , 0.0001313821423   ,
 9.00478414448e-05 , 0.000170906507097 , 0.000444122781639 , 0.00115523696876  ,
 0.00276730530189  , 0.00580028356277  , 0.0102977841404   , 0.0153834357874   ,
 0.0198151847378   , 0.023284110234    , 0.0267422951006   , 0.0312562160888   ,
 0.0369696514393   , 0.0428031085106   , 0.0462644004906   , 0.0444189518353   ,
 0.0366924761834   , 0.0263247294899   , 0.0178934065611   , 0.0137080306954   ,
 0.013026633589    , 0.0142121525818   , 0.0173347185195   , 0.0247016620814   ,
 0.0383097214759   , 0.0562792257093   , 0.0722736423926   , 0.0792512454156   ,
 0.0742226222692   , 0.0602521305927   , 0.0455721980317   , 0.0414946900336   ,
 0.0592324754275   , 0.104427607459    , 0.170681757759    , 0.238460258118    ,
 0.284704317078    , 0.297704697753    , 0.283701403526    , 0.258096551256    ,
 0.230541351329    , 0.202047746956    , 0.177560978104    , 0.173611913435    ,
 0.205415090038    , 0.268768144832    , 0.342018059012    , 0.405618462545    ,
 0.453468870086    , 0.486940950229    , 0.509397728357    , 0.530379156205    ,
 0.566607409981    , 0.634842223365    , 0.747014585106    , 0.909051327001    ,
 1.11777936328     , 1.36463711374     , 1.65561416657     , 2.02468442892     ,
 2.50617947533     , 3.08384723483     , 3.68220839842     , 4.22544590543     ,
 4.70960468639     , 5.21524810523     , 5.84402392332     , 6.64058398671     ,
 7.5809962295      , 8.62702858313     , 9.76584781032     , 11.0044133861     ,
 12.3727871434     , 13.9452065775     , 15.8040592484     , 17.9339361914     ,
 20.1487937435     , 22.1299824411     , 23.552144764      , 24.2366282064     ,
 24.2428869971     , 23.8004184107     , 23.1315126747     , 22.3505637526     ,
 21.4964016663     , 20.5801671943     , 19.5839316508     , 18.4506595613     ,
 17.1056667832     , 15.524810263      , 13.8088239448     , 12.159553637      ,
 10.7385683367     , 9.54517547535     , 8.44043159835     , 7.28779045947     ,
 6.07534518366     , 4.91534148927     , 3.94165545259     , 3.21760943246     ,
 2.72182180613     , 2.38130581193     , 2.10804136467     , 1.83318690614     ,
 1.53135273918     , 1.21749470893     , 0.922606738927    , 0.672028649226    ,
 0.477333234816    , 0.337107581204    , 0.241731265886    , 0.180364155781    ,
 0.145658330808    , 0.132287811286    , 0.13250185685     , 0.135029349046    ,
 0.12922236812     , 0.110741625761    , 0.0835331110199   , 0.0565259324555   ,
 0.0383609114337   , 0.0340590860308   , 0.0443658320206   , 0.0659976007475   ,
 0.0920322993639   , 0.114265162696    , 0.128170190419    , 0.136768832717    ,
 0.149334797192    , 0.175132077537    , 0.215938986523    , 0.263345636241    ,
 0.305325164512    , 0.337231538769    , 0.366044590098    , 0.403636143412    ,
 0.454066396563    , 0.503601493502    , 0.524161077785    , 0.4942978573      ,
 0.422265603497    , 0.345971959502    , 0.305948232712    , 0.317581304956    ,
 0.368025076826    , 0.434768740499    , 0.503187738618    , 0.567689829021    ,
 0.623625833736    , 0.66648743767     , 0.697352138464    , 0.71909484867     ,
 0.724744657964    , 0.698980079797    , 0.638059679121    , 0.562499514033    ,
 0.500083283263    , 0.456632029347    , 0.412256519915    , 0.347536104427    ,
 0.264828652827    , 0.182346563821    , 0.116558147782    , 0.0742344947604   ,
 0.0546207143203   , 0.0526335454582   , 0.0600181640018   , 0.0669473793737   ,
 0.0822727247115   , 0.0661320117553   , 0.0444662964964   , 0.0259036631092   ,
 0.014016529024    , 0.00761282640562  , 0.0041942617975   , 0.00219139463311  ,
 0.00101272930862  , 0.000401106122747 , 0.00013678374081  , 4.51214290306e-05 ,
 3.61833995078e-05 , 0.00012371789881  , 0.000501405930923 , 0.00172012774367  ,
 0.00478864088926  , 0.010693931776    , 0.0190950278683   , 0.0273478109893   ,
 0.0318359938929   , 0.0311927305426   , 0.0278294728596   , 0.0258213714926   ,
 0.0276570759357   , 0.0327057294036   , 0.0376861301308   , 0.0388802262801   ,
 0.035202364541    , 0.0292670357907   , 0.0250200247365   , 0.0244391119275   ,
 0.0263805318846   , 0.0283626548284   , 0.0298550695946   , 0.0336674613868   ,
 0.0430215247977   , 0.0570694650397   , 0.0702475128373   , 0.0762291067151   ,
 0.0720703697455   , 0.0596801277957   , 0.0456740926414   , 0.0405161720292   ,
 0.0560475379798   , 0.100493008825    , 0.171630646163    , 0.25247731466     ,
 0.316091712863    , 0.340419064506    , 0.3229073908      , 0.280343229446    ,
 0.232810593639    , 0.190833248844    , 0.160223741068    , 0.151070471816    ,
 0.171579813038    , 0.215317957244    , 0.264017788862    , 0.30451598484     ,
 0.337217708411    , 0.36855639237     , 0.403386554595    , 0.447076380832    ,
 0.50970153682     , 0.606577075641    , 0.755357665013    , 0.966726754044    ,
 1.23215214089     , 1.52705668134     , 1.83843844223     , 2.18831691209     ,
 2.61401335245     , 3.12008049886     , 3.66298635533     , 4.19241042503     ,
 4.70751212759     , 5.27307962494     , 5.9749090459      , 6.85240207725     ,
 7.883458513       , 9.0395868267      , 10.334919018      , 11.8138420952     ,
 13.5201783105     , 15.4872152038     , 17.7126976483     , 20.105469658      ,
 22.4627270534     , 24.5101757221     , 25.9787538079     , 26.7008556729     ,
 26.6923625729     , 26.138293584      , 25.2797683443     , 24.3157787171     ,
 23.3660714436     , 22.4448991393     , 21.4549258499     , 20.2447171115     ,
 18.7019934312     , 16.8363856404     , 14.8155416247     , 12.8976167698     ,
 11.2704565317     , 9.92990832656     , 8.71473823227     , 7.46762992695     ,
 6.17564900399     , 4.9669626259      , 3.98612171977     , 3.28463674505     ,
 2.81240502693     , 2.47151253508     , 2.16783469242     , 1.84449164546     ,
 1.49617502137     , 1.15625515943     , 0.864960320691    , 0.643368362288    ,
 0.488168989747    , 0.381906517401    , 0.306063223647    , 0.249317176303    ,
 0.207993326319    , 0.180272099387    , 0.161214729492    , 0.143644619548    ,
 0.122278972995    , 0.0962801501252   , 0.0689103695212   , 0.0456917539057   ,
 0.0325157414814   , 0.0340440658133   , 0.0518470324948   , 0.0821215553534   ,
 0.115167181612    , 0.139857012282    , 0.151595648154    , 0.156424807295    ,
 0.166506242393    , 0.190402793282    , 0.225563055935    , 0.259408577647    ,
 0.279951241517    , 0.286714511781    , 0.290832013493    , 0.305197108079    ,
 0.33348486546     , 0.364240429982    , 0.37504700163     , 0.349187063938    ,
 0.294006632647    , 0.241310384136    , 0.225531219435    , 0.259731321427    ,
 0.33064953689     , 0.413206051251    , 0.487794855523    , 0.545213274924    ,
 0.581561468492    , 0.596716181462    , 0.597139537148    , 0.590989270786    ,
 0.577790520544    , 0.550471183414    , 0.511307993573    , 0.477642936372    ,
 0.462373319514    , 0.452330962428    , 0.417713819167    , 0.344526692669    ,
 0.249009194805    , 0.159822911904    , 0.0954466668031   , 0.0598005073667   ,
 0.0493878932937   , 0.0574674462493   , 0.0735475067056   , 0.0848260833907   ,
 0.0899450064651   , 0.0690647657647   , 0.0435356884841   , 0.022869736723    ,
 0.0104297804605   , 0.00451337121799  , 0.00209647988954  , 0.00110066126503  ,
 0.000606112033449 , 0.000315103038646 , 0.000144241565214 , 6.06397918565e-05 ,
 5.59020468811e-05 , 0.000212073851979 , 0.000892270388044 , 0.00305345905072  ,
 0.00833298083575  , 0.0181034219144   , 0.0313056700601   , 0.0431432762603   ,
 0.0475986804602   , 0.042657789838    , 0.032531764531    , 0.0240723202687   ,
 0.0215256667133   , 0.0245229215904   , 0.0296365631055   , 0.0334085219997   ,
 0.0347967656833   , 0.0354478148759   , 0.0378811664422   , 0.0430648739537   ,
 0.0488542145645   , 0.0512130157596   , 0.0485778180764   , 0.044700455614    ,
 0.0453283335566   , 0.0521254871535   , 0.0610923377673   , 0.0663167118185   ,
 0.0640451546209   , 0.0545014131025   , 0.042545005211    , 0.0374346632562   ,
 0.0509428203017   , 0.0934381077875   , 0.167176890936    , 0.258602773396    ,
 0.337828089194    , 0.373022809642    , 0.352707735953    , 0.294164819885    ,
 0.226976928502    , 0.170985376516    , 0.133085619861    , 0.116981400486    ,
 0.124633578158    , 0.14990586386     , 0.180925948541    , 0.211573184278    ,
 0.245711572086    , 0.288930323679    , 0.341085963004    , 0.399769726013    ,
 0.470099185026    , 0.570976348055    , 0.729748837499    , 0.963621441082    ,
 1.26115534048     , 1.58627394199     , 1.90995691286     , 2.23982112914     ,
 2.6110668978      , 3.04831080097     , 3.54519812851     , 4.08195363149     ,
 4.66011838394     , 5.32391360498     , 6.14122562387     , 7.14997090271     ,
 8.33203744917     , 9.65898740063     , 11.1545125085     , 12.8912606553     ,
 14.9294806526     , 17.2627609118     , 19.7990458758     , 22.3724685439     ,
 24.779288159      , 26.8135285599     , 28.2856856404     , 29.0538830442     ,
 29.0820510271     , 28.4737104781     , 27.4457374094     , 26.2627171295     ,
 25.1364801532     , 24.114168557      , 23.0575532739     , 21.7550881527     ,
 20.0650406457     , 18.0008514401     , 15.7477673719     , 13.5896641425     ,
 11.7489428145     , 10.2497022308     , 8.93491574543     , 7.63193781079     ,
 6.31033156461     , 5.08562789452     , 4.0915078376      , 3.3693699519      ,
 2.8633103728      , 2.47756610911     , 2.12751451563     , 1.7674903052      ,
 1.39992335639     , 1.06216274519     , 0.795365284314    , 0.616229199764    ,
 0.51029339702     , 0.445961862538    , 0.394509070284    , 0.342566574381    ,
 0.290830078908    , 0.2432757242      , 0.199686215528    , 0.157715002765    ,
 0.117481066749    , 0.0816673271233   , 0.053051162419    , 0.0337395195842   ,
 0.0261878072963   , 0.0334408609991   , 0.0568105044009   , 0.0918431527161   ,
 0.127019553291    , 0.149712407509    , 0.156261467182    , 0.15580199478     ,
 0.162686805491    , 0.18414749621     , 0.213750320954    , 0.23645065386     ,
 0.24220910284     , 0.235521375917    , 0.230635254395    , 0.238355570696    ,
 0.257564008033    , 0.275712311439    , 0.275933820227    , 0.248921149487    ,
 0.203603575567    , 0.165553216591    , 0.161013845742    , 0.199885976624    ,
 0.271501913226    , 0.353947284195    , 0.426795769278    , 0.47675063234     ,
 0.496896288208    , 0.48839604109     , 0.463100038146    , 0.436521775224    ,
 0.415488118507    , 0.398421141504    , 0.388995741001    , 0.399291753386    ,
 0.429811913183    , 0.452694771424    , 0.430343952882    , 0.353363046089    ,
 0.249870483945    , 0.157073172836    , 0.0941224152533   , 0.0618822508517   ,
 0.0550852486707   , 0.066671642474    , 0.0851280830951   , 0.0959811687257   ,
 0.0834858611998   , 0.0618330228371   , 0.0373299760197   , 0.0185634505305   ,
 0.00796043814209  , 0.00346711941651  , 0.00205885261078  , 0.0016475444377   ,
 0.00130691418377  , 0.000868176766498 , 0.000460854996066 , 0.000202416170105 ,
 0.000133181390076 , 0.000375977127541 , 0.00147300690878  , 0.00480542713172  ,
 0.0125515842479   , 0.02616727927     , 0.0435164117129   , 0.0577407461935   ,
 0.0612488241304   , 0.0523726821168   , 0.0373270885308   , 0.0249715105296   ,
 0.0202865015332   , 0.022547228313    , 0.0280592483053   , 0.0338687334598   ,
 0.0394680706379   , 0.0460411885024   , 0.0549241531082   , 0.0659536991535   ,
 0.0755705104932   , 0.077685314293    , 0.0694631367737   , 0.0559018914892   ,
 0.0461025713269   , 0.0452020637301   , 0.0511479881513   , 0.0577443242016   ,
 0.0591557074224   , 0.0532506593846   , 0.0434208680361   , 0.0380354383702   ,
 0.0481127582153   , 0.0844151329577   , 0.151912846054    , 0.240681440163    ,
 0.321766522263    , 0.35993331266     , 0.33895550745     , 0.27475692908     ,
 0.200261366063    , 0.13963993921     , 0.100154106127    , 0.0814113229667   ,
 0.0819519827848   , 0.0979052824517   , 0.124151016318    , 0.159932435615    ,
 0.208959537903    , 0.271017632683    , 0.336613441477    , 0.395226363317    ,
 0.451655513261    , 0.533620506372    , 0.679218943672    , 0.910477005736    ,
 1.21406382544     , 1.54798545727     , 1.87280871295     , 2.18176410185     ,
 2.50286106405     , 2.8770740834      , 3.33734827037     , 3.89985469858     ,
 4.57129438652     , 5.37302060703     , 6.35186021073     , 7.54615647899     ,
 8.94519455794     , 10.5120139682     , 12.2543359494     , 14.2460184936     ,
 16.5552907214     , 19.1510722962     , 21.8806645344     , 24.5323351877     ,
 26.9160459548     , 28.8920927447     , 30.3465590558     , 31.1694417848     ,
 31.275875508      , 30.6667144083     , 29.4940788837     , 28.0560042223     ,
 26.6523889437     , 25.3897080624     , 24.1368275067     , 22.6703795889     ,
 20.8417577004     , 18.6557494803     , 16.2821824059     , 13.9990061604     ,
 12.0446274181     , 10.4655724965     , 9.1109337644      , 7.7964635009      ,
 6.47398177816     , 5.24149780488     , 4.21924648902     , 3.44518928225     ,
 2.87189646577     , 2.41974553338     , 2.0207891214      , 1.6386947756      ,
 1.27456402685     , 0.958894208975    , 0.727267099119    , 0.592317753155    ,
 0.533057382382    , 0.508166056983    , 0.480485139925    , 0.434311014865    ,
 0.37394569438     , 0.308794007276    , 0.243304953229    , 0.179587118151    ,
 0.122150173384    , 0.0762840809582   , 0.0444692783026   , 0.0264825923329   ,
 0.0220677881615   , 0.0322899175611   , 0.0574166427841   , 0.0924225585978   ,
 0.125298014639    , 0.143359851357    , 0.14396770106     , 0.137928879024    ,
 0.140254316926    , 0.156862750043    , 0.179521253955    , 0.193588830735    ,
 0.192370814976    , 0.184174786446    , 0.183846831983    , 0.198004318962    ,
 0.219343175136    , 0.23282863954     , 0.225792423708    , 0.195993510062    ,
 0.154993951067    , 0.123462850108    , 0.1196139313      , 0.149514655403    ,
 0.205878734651    , 0.27352883822     , 0.335639011048    , 0.376982896912    ,
 0.386832505599    , 0.365503712321    , 0.328047949188    , 0.294961671634    ,
 0.277124759829    , 0.274218044169    , 0.287657262755    , 0.32450918022     ,
 0.379457914722    , 0.420490859517    , 0.40972347214     , 0.341254627716    ,
 0.246815647326    , 0.163326895554    , 0.106409006246    , 0.0746775340976   ,
 0.0642674831088   , 0.0710157361841   , 0.0850190291751   , 0.0921251745476   ,
 0.0656698591776   , 0.0476574167739   , 0.028242830411    , 0.0140174047541   ,
 0.00665715158869  , 0.00432630536998  , 0.00429897643454  , 0.0044683103978   ,
 0.00387978021109  , 0.0026634096883   , 0.00143259554303  , 0.000621188048241 ,
 0.000323117051155 , 0.000639999520423 , 0.00223232713504  , 0.00677632198862  ,
 0.0166447705124   , 0.0328538947888   , 0.0519975262161   , 0.0659370881072   ,
 0.0670884306816   , 0.0552786681223   , 0.0384656638291   , 0.0262733546313   ,
 0.0232518327465   , 0.0275486681153   , 0.0345212227      , 0.041272396875    ,
 0.0482052507808   , 0.0572251823818   , 0.0696035904353   , 0.0844278737454   ,
 0.096647451768    , 0.0981856473574   , 0.0851594448745   , 0.0638182092847   ,
 0.046398149273    , 0.0413457628505   , 0.0482959560453   , 0.0599508870352   ,
 0.067245194366    , 0.0652407702439   , 0.056525336731    , 0.049281073686    ,
 0.0530966706809   , 0.0769422915957   , 0.126336324253    , 0.195482048736    ,
 0.261521388157    , 0.293911034648    , 0.276750670333    , 0.221916475311    ,
 0.157441882011    , 0.105137793621    , 0.0719213529967   , 0.0570114843734   ,
 0.0593373913464   , 0.0782550372595   , 0.113169479824    , 0.164800456774    ,
 0.233125662451    , 0.310232619502    , 0.378074420481    , 0.421899505058    ,
 0.451045364103    , 0.503764600937    , 0.626215766721    , 0.842038940274    ,
 1.13661714161     , 1.46642272319     , 1.78630528905     , 2.07662551381     ,
 2.35538262027     , 2.67509826314     , 3.10597426821     , 3.703976881       ,
 4.4879774725      , 5.45943308928     , 6.63997019412     , 8.06311303205     ,
 9.72466467138     , 11.5752441664     , 13.5871584646     , 15.8049853332     ,
 18.2891136257     , 21.005227607      , 23.7922964902     , 26.441299011      ,
 28.7865883402     , 30.7253587343     , 32.1817190736     , 33.0651666101     ,
 33.2558491039     , 32.6630308674     , 31.358868433      , 29.6410088431     ,
 27.8749371357     , 26.2393391021     , 24.6542249063     , 22.9305225907     ,
 20.9362880996     , 18.6688976626     , 16.2722236783     , 13.9964686464     ,
 12.0619090767     , 10.504787051      , 9.16767970669     , 7.8642734564      ,
 6.5462507993      , 5.30735751882     , 4.26112345213     , 3.44454356776     ,
 2.81801071873     , 2.31553203971     , 1.88386667645     , 1.49541803299     ,
 1.14888602466     , 0.864926406601    , 0.670169009129    , 0.572393637129    ,
 0.547205242452    , 0.549229532526    , 0.53805774843     , 0.497608638514    ,
 0.434206262101    , 0.35984065661     , 0.281673745061    , 0.204977662674    ,
 0.136895970019    , 0.0836597333147   , 0.0474894333508   , 0.0276654889389   ,
 0.0230785922633   , 0.0331863432487   , 0.0564816220813   , 0.0872296767377   ,
 0.114285188528    , 0.126521506011    , 0.122165006087    , 0.111607163494    ,
 0.108625826572    , 0.118217511692    , 0.132877143344    , 0.14079501292     ,
 0.138649510715    , 0.136090353299    , 0.14605123442     , 0.170859972661    ,
 0.198838279045    , 0.213315490559    , 0.204157346786    , 0.173752843613    ,
 0.135783118335    , 0.107691308736    , 0.101232253932    , 0.118257215509    ,
 0.153485402334    , 0.198660053811    , 0.243260260058    , 0.273688528625    ,
 0.277428509489    , 0.253200402588    , 0.215927113188    , 0.186508563319    ,
 0.175850075159    , 0.182383399935    , 0.204235891582    , 0.244762833836    ,
 0.298730241338    , 0.340193012733    , 0.339299547481    , 0.292829504304    ,
 0.226646371102    , 0.167270831076    , 0.122575462859    , 0.0903054964288   ,
 0.0712480428124   , 0.0670856685034   , 0.0720925213648   , 0.0743634365551   ,
 0.0462002972216   , 0.034069025663    , 0.0209016993152   , 0.0114716749582   ,
 0.0074905110046   , 0.00782481747849  , 0.00984650821495  , 0.0108596154445   ,
 0.00955372374895  , 0.00658060846767  , 0.0035429241546   , 0.0015283069346   ,
 0.000722481864738 , 0.00111246074998  , 0.00337543699873  , 0.00926056203208  ,
 0.0207993049757   , 0.0379015655593   , 0.0558699272205   , 0.0665118804508   ,
 0.0640398629795   , 0.0505788133889   , 0.0350548453329   , 0.0264806021198   ,
 0.0280937060849   , 0.0364857898541   , 0.0454785481297   , 0.0515657494142   ,
 0.0561491848993   , 0.0630102283752   , 0.0747121231835   , 0.0902703304325   ,
 0.103444943114    , 0.104764866531    , 0.0898058513308   , 0.0656327526186   ,
 0.0463782209639   , 0.0426730740996   , 0.0552075790118   , 0.0751362543349   ,
 0.0898621213285   , 0.0919406800969   , 0.0840175431247   , 0.0744715053412   ,
 0.0705294840611   , 0.0776853838412   , 0.101038949888    , 0.140043245214    ,
 0.181723605136    , 0.205221456938    , 0.197482707874    , 0.163694989262    ,
 0.121012036994    , 0.0845184824974   , 0.0612067751002   , 0.0537759510808   ,
 0.0649137243386   , 0.0970114607051   , 0.149973149834    , 0.220521227872    ,
 0.301698034107    , 0.37988134127     , 0.435366282611    , 0.456561723919    ,
 0.459498503605    , 0.488296507572    , 0.590402057407    , 0.788290913271    ,
 1.06846379099     , 1.39015304761     , 1.7061339811      , 1.98644727812     ,
 2.2391046739      , 2.5235945626      , 2.9405336089      , 3.58372055583     ,
 4.49015291567     , 5.64765969233     , 7.04953186015     , 8.71443263304     ,
 10.6402905591     , 12.7696903118     , 15.0383448269     , 17.4446605888     ,
 20.02550072       , 22.7574016256     , 25.5161221506     , 28.1366116274     ,
 30.4791840938     , 32.4381586894     , 33.9258818287     , 34.8494858163     ,
 35.0755079549     , 34.4622967705     , 33.0176454258     , 31.0126108303     ,
 28.8411981674     , 26.7470580513     , 24.7287811389     , 22.666984185      ,
 20.4691787387     , 18.1356040887     , 15.7833938059     , 13.6155325936     ,
 11.7973068751     , 10.3224001371     , 9.02112383043     , 7.72368856026     ,
 6.40502840596     , 5.16890885247     , 4.12627446919     , 3.31013379835     ,
 2.6803246619      , 2.17372042675     , 1.74371431267     , 1.36945016088     ,
 1.04984872535     , 0.798602834623    , 0.634095609716    , 0.559300914293    ,
 0.548874235068    , 0.559173448652    , 0.552816535339    , 0.515951895724    ,
 0.454978460832    , 0.381094253568    , 0.30202450998     , 0.224580546297    ,
 0.156021919024    , 0.101074426733    , 0.0614228192364   , 0.0379596940018   ,
 0.0311819382386   , 0.0397481247867   , 0.059562130778    , 0.0835720870013   ,
 0.102504645448    , 0.108489205152    , 0.100784696745    , 0.0875219972764   ,
 0.0794926477143   , 0.0811313948129   , 0.087654873673    , 0.0914426061407   ,
 0.0917001757892   , 0.0970518056785   , 0.116972168988    , 0.150532474974    ,
 0.184433450152    , 0.201966547646    , 0.194269472194    , 0.165741495768    ,
 0.13114286789     , 0.106268154382    , 0.0986894649218   , 0.106279348567    ,
 0.123423976397    , 0.14628652765     , 0.170854132564    , 0.188235953479    ,
 0.187293648471    , 0.165462574456    , 0.134586751666    , 0.111978830762    ,
 0.106230759123    , 0.114694791124    , 0.133605526582    , 0.164048555372    ,
 0.203184731814    , 0.235192324545    , 0.241743243861    , 0.221599084665    ,
 0.190239323951    , 0.159858439257    , 0.129955693504    , 0.098541329714    ,
 0.0716672933175   , 0.056973297174    , 0.0535274283012   , 0.052505696889    ,
 0.0348368077213   , 0.0279323031833   , 0.0191373597392   , 0.0126144085518   ,
 0.0110542376599   , 0.0141845509389   , 0.018890295436    , 0.0210514289012   ,
 0.0185530532117   , 0.0127838141464   , 0.00688454868652  , 0.00297334528981  ,
 0.00139231769409  , 0.00196540943633  , 0.00537112943953  , 0.0133002497489   ,
 0.0269154388291   , 0.0442394449244   , 0.0590744360795   , 0.0641458324799   ,
 0.0568872219392   , 0.0421970146194   , 0.0291949739757   , 0.0252661714007   ,
 0.0319781913056   , 0.0445609167957   , 0.0553297163203   , 0.0596944732961   ,
 0.0596322950632   , 0.0611178736717   , 0.0688375438915   , 0.082440135458    ,
 0.0951705628436   , 0.0970893091778   , 0.0837098766417   , 0.0620517657373   ,
 0.0463456250548   , 0.0479074142923   , 0.0679405283417   , 0.0963741903077   ,
 0.11802705082     , 0.124162877845    , 0.118237208091    , 0.108470865709    ,
 0.0986108158798   , 0.0899993289965   , 0.0877938984581   , 0.0978286809874   ,
 0.11789665746     , 0.136906803109    , 0.143686262346    , 0.134925229568    ,
 0.115224956619    , 0.0927555992248   , 0.0764961518437   , 0.0756166412096   ,
 0.0983133569266   , 0.148605977417    , 0.222436261969    , 0.307447983033    ,
 0.387985917509    , 0.449457833034    , 0.480374165007    , 0.48009291419     ,
 0.469937375972    , 0.490527376097    , 0.581922516697    , 0.763906058716    ,
 1.02835198537     , 1.34226335268     , 1.65983130845     , 1.94376287054     ,
 2.19422595368     , 2.47526089246     , 2.90920525497     , 3.61833653898     ,
 4.65528493309     , 5.99733368621     , 7.60928322098     , 9.48940125947     ,
 11.6375237369     , 14.0018425463     , 16.4983538064     , 19.0803701972     ,
 21.7473026778     , 24.4789506557     , 27.197117193      , 29.792682317      ,
 32.1502080551     , 34.1453282598     , 35.6579896762     , 36.5814567725     ,
 36.7819810216     , 36.100631004      , 34.5013197271     , 32.2127077019     ,
 29.6254201931     , 27.0347268616     , 24.5299865505     , 22.0836627363     ,
 19.6623050319     , 17.2795258212     , 15.0198299869     , 13.0152321287     ,
 11.3484194865     , 9.95973586083     , 8.6794504009      , 7.37537370998     ,
 6.0586505238      , 4.84472308159     , 3.83911919681     , 3.06759007538     ,
 2.48426177121     , 2.02074523322     , 1.62854168541     , 1.28888708812     ,
 1.00198843979     , 0.778744203779    , 0.632566039045    , 0.563218570392    ,
 0.546864443799    , 0.546446869207    , 0.532498923938    , 0.494805804179    ,
 0.437852891484    , 0.369915530023    , 0.298525232433    , 0.230983653394    ,
 0.172079665194    , 0.122291148137    , 0.0819679449803   , 0.0551057578841   ,
 0.0460042632922   , 0.0535851131366   , 0.0707121066753   , 0.0883151880579   ,
 0.0993185359684   , 0.10004417592     , 0.0908074114413   , 0.0762848098518   ,
 0.0633666945736   , 0.0564607505961   , 0.0547663564729   , 0.055311708782    ,
 0.0590126394287   , 0.072213794503    , 0.100320571184    , 0.139639479341    ,
 0.17647539138     , 0.195089681026    , 0.187899380112    , 0.160529213621    ,
 0.128417339546    , 0.106672007993    , 0.100444191876    , 0.104219096344    ,
 0.110160993646    , 0.115720077522    , 0.121891981077    , 0.125965439931    ,
 0.120767571096    , 0.103263309075    , 0.0806205327646   , 0.0644708578659   ,
 0.0605595941196   , 0.0665751729803   , 0.0790490844551   , 0.0980860772356   ,
 0.12260790728     , 0.144649301371    , 0.154925066434    , 0.153292123161    ,
 0.146733847067    , 0.137166846788    , 0.119288327876    , 0.0918423360214   ,
 0.0635883379367   , 0.0450451493129   , 0.0384011232016   , 0.0374469129895   ,
 0.0345456795211   , 0.0306440123527   , 0.0232163061597   , 0.0170501546426   ,
 0.0163656310393   , 0.0216511637929   , 0.0289005226852   , 0.0321729496688   ,
 0.0283368889212   , 0.0195209863798   , 0.01051635158     , 0.0045650248536   ,
 0.00222142555705  , 0.00324435640864  , 0.00849411036415  , 0.0197129993217   ,
 0.036923774193    , 0.0555520584157   , 0.0672923868668   , 0.0659059149191   ,
 0.0526995283687   , 0.0357453260202   , 0.024182230204    , 0.0234303610146   ,
 0.0334435589121   , 0.0486941616836   , 0.0606420548392   , 0.0635591492925   ,
 0.0592139709208   , 0.0550393375616   , 0.0576905507082   , 0.0678502203698   ,
 0.0791712870059   , 0.0823937885685   , 0.0733314003872   , 0.0578286959433   ,
 0.0482767326514   , 0.0552682083298   , 0.0803848269523   , 0.113481153051    ,
 0.138692271263    , 0.147550173886    , 0.144614241135    , 0.137282890917    ,
 0.125434788145    , 0.106815344799    , 0.0874913903679   , 0.079516472677    ,
 0.0894542936324   , 0.112673551783    , 0.137105435442    , 0.15051427089     ,
 0.147006319747    , 0.130882521075    , 0.115635324245    , 0.118148204421    ,
 0.151555501489    , 0.219104964965    , 0.309816676742    , 0.400670440066    ,
 0.468552494327    , 0.502567261975    , 0.506030632599    , 0.492978214648    ,
 0.486695011774    , 0.516215589087    , 0.608250091689    , 0.779680532239    ,
 1.03143311929     , 1.34252205621     , 1.67165115757     , 1.97650426979     ,
 2.25161743921     , 2.56538861126     , 3.05491180627     , 3.85787797468     ,
 5.03146061946     , 6.53996215704     , 8.32350089445     , 10.3643875801     ,
 12.6716991936     , 15.217081102      , 17.9217910649     , 20.7073188437     ,
 23.5228299348     , 26.318655277      , 29.0272311414     , 31.5731782609     ,
 33.8695525728     , 35.8051747487     , 37.2644979445     , 38.141856128      ,
 38.2972423907     , 37.5475628634     , 35.809632471      , 33.2612575308     ,
 30.2782738942     , 27.2026971774     , 24.2170874486     , 21.3923150005     ,
 18.7625178075     , 16.3577234424     , 14.2191684046     , 12.3889950036     ,
 10.8581759429     , 9.52565627641     , 8.24481029594     , 6.93480291474     ,
 5.63890317314     , 4.47208106863     , 3.52691118934     , 2.82145956037     ,
 2.30587208551     , 1.9059324027      , 1.56765881502     , 1.27055050369     ,
 1.01546855225     , 0.813045443113    , 0.674290468549    , 0.596892527748    ,
 0.559925074625    , 0.535775574815    , 0.505391125477    , 0.462177000917    ,
 0.406958955013    , 0.344080685325    , 0.281278022897    , 0.226711310301    ,
 0.181936958064    , 0.14165130016     , 0.103615523156    , 0.0747586717763   ,
 0.0640609565052   , 0.0718201623301   , 0.0884363716535   , 0.102734305071    ,
 0.109353091089    , 0.108082738225    , 0.0994484473232   , 0.0841892024754   ,
 0.0656873679826   , 0.0493116259902   , 0.0388906542965   , 0.0359541591915   ,
 0.042700334406    , 0.0630367679395   , 0.098124822604    , 0.14086197698     ,
 0.176572793382    , 0.191001409243    , 0.179399871151    , 0.149896064857    ,
 0.118762787056    , 0.100156351507    , 0.0971213559926   , 0.101331240303    ,
 0.102300785309    , 0.0969783013278   , 0.08954276111     , 0.0830832444635   ,
 0.0752248494945   , 0.0630711726049   , 0.0489536551261   , 0.0386535748501   ,
 0.0355322550087   , 0.0386414314527   , 0.046131330035    , 0.0579810968968   ,
 0.0736025635257   , 0.0886977932085   , 0.0983442040878   , 0.102606563542    ,
 0.104529602522    , 0.102790735742    , 0.0920207356763   , 0.0716393977559   ,
 0.0495595335152   , 0.0352087370048   , 0.0313954135994   , 0.0335039883713   ,
 0.0406892023446   , 0.0376279737712   , 0.0296703421175   , 0.0223773587946   ,
 0.0211066781028   , 0.0268745149523   , 0.0351357297646   , 0.0388144536904   ,
 0.0340959533285   , 0.0234678464059   , 0.0126466100005   , 0.00553427977721  ,
 0.00288253136611  , 0.00461879659322  , 0.0120693674713   , 0.0272930785874   ,
 0.0493377226068   , 0.0709363705306   , 0.081232191382    , 0.0744045983821   ,
 0.0552231274953   , 0.0349753096528   , 0.0231386647746   , 0.0233980337015   ,
 0.034266362352    , 0.0500183427654   , 0.0622134000586   , 0.0645525746286   ,
 0.0581381611381   , 0.0506928633089   , 0.0497912634107   , 0.0568718131907   ,
 0.0666805329091   , 0.0716961742438   , 0.0682867614914   , 0.0600160218559   ,
 0.0557564171157   , 0.0643956712818   , 0.0883230443222   , 0.11909086686     ,
 0.142301273537    , 0.150776040582    , 0.14970432886     , 0.14531893223     ,
 0.134837951294    , 0.114131725236    , 0.0902322901526   , 0.0789924985832   ,
 0.091646514535    , 0.125871414216    , 0.166715693713    , 0.194777426803    ,
 0.198178907945    , 0.181503026079    , 0.164193366098    , 0.169407853098    ,
 0.212025291069    , 0.291587946054    , 0.390252668126    , 0.478282593863    ,
 0.529995276115    , 0.540278712213    , 0.5260167778      , 0.513151845551    ,
 0.524185445579    , 0.574995597956    , 0.678860047496    , 0.850160062344    ,
 1.09942132762     , 1.41931559545     , 1.77551945353     , 2.12249788297     ,
 2.45001168139     , 2.8299646783      , 3.40824027208     , 4.32580348876     ,
 5.63296230348     , 7.27953553563     , 9.18954991249     , 11.3392540159     ,
 13.7534368292     , 16.4372081485     , 19.3372205769     , 22.3626159945     ,
 25.4081061698     , 28.3550262811     , 31.086034572      , 33.5136716431     ,
 35.5838777398     , 37.2585951852     , 38.5035991625     , 39.2562611921     ,
 39.3622298319     , 38.5843056434     , 36.7711820969     , 34.0425718802     ,
 30.7559846065     , 27.2928274936     , 23.9170382784     , 20.7866169826     ,
 17.9970552822     , 15.5919389596     , 13.5670906019     , 11.8768546321     ,
 10.4333354544     , 9.1167072845      , 7.82244374609     , 6.52209721618     ,
 5.27537060087     , 4.1791514424      , 3.30475936087     , 2.66352403676     ,
 2.20677328645     , 1.85959144961     , 1.5651582132      , 1.30154815973     ,
 1.07028865884     , 0.882292343263    , 0.746269324656    , 0.657181457891    ,
 0.59660052901     , 0.546614384415    , 0.498759161852    , 0.449425826494    ,
 0.39440799869     , 0.332857218389    , 0.272786355695    , 0.225075792992    ,
 0.190434234254    , 0.158654478456    , 0.123674178525    , 0.0934547642035   ,
 0.0809056898839   , 0.0885925152058   , 0.106029362327    , 0.120657973822    ,
 0.12781143806     , 0.128696473891    , 0.122714264564    , 0.107009955161    ,
 0.0827237808384   , 0.0569468309368   , 0.0378499024334   , 0.0307783026691   ,
 0.0390420925694   , 0.0645470390769   , 0.104411135741    , 0.147540031216    ,
 0.177716993895    , 0.182887481572    , 0.162958722766    , 0.129819772778    ,
 0.100160575643    , 0.0858274487355   , 0.0870659692726   , 0.0934137390664   ,
 0.092912454071    , 0.0822125010734   , 0.0674558493793   , 0.0558456117956   ,
 0.0487517517967   , 0.0432722454741   , 0.0374935802133   , 0.0324037787282   ,
 0.0299115743306   , 0.0307341616597   , 0.0346665607104   , 0.0417750659423   ,
 0.0515015504444   , 0.0609431815046   , 0.0666549660891   , 0.068426394451    ,
 0.0684190672226   , 0.0664376615341   , 0.0596671970628   , 0.0479536935031   ,
 0.0362208556489   , 0.0303444113025   , 0.0319925331123   , 0.0374896032455   ,
 0.0463764779282   , 0.0428465716438   , 0.034537618897    , 0.0264992800346   ,
 0.0238169562497   , 0.027771538003    , 0.0344234213992   , 0.0372138514975   ,
 0.0324323938092   , 0.0222608003772   , 0.01199444896     , 0.00530817036538  ,
 0.00303223780683  , 0.00546295692676  , 0.0145203608544   , 0.0327460913924   ,
 0.0588094738076   , 0.0837617795958   , 0.0947827163716   , 0.0857983721012   ,
 0.0635651146127   , 0.0416538551109   , 0.0299442889556   , 0.0306506009751   ,
 0.0408053970887   , 0.0547193469946   , 0.065129278127    , 0.0665585232831   ,
 0.0600304759913   , 0.0528604255635   , 0.0521098446901   , 0.05880139768     ,
 0.0684880214216   , 0.0757217168687   , 0.0775248600612   , 0.0746101429891   ,
 0.0715526212232   , 0.0753347043994   , 0.0900376792075   , 0.110792906861    ,
 0.126433518667    , 0.131198776982    , 0.129690245275    , 0.126884437808    ,
 0.119557208121    , 0.103832506331    , 0.0867327985725   , 0.0838216360629   ,
 0.106173484501    , 0.150725207397    , 0.200230969249    , 0.232566938787    ,
 0.235626356807    , 0.217543136158    , 0.202645994515    , 0.215924603597    ,
 0.268590974435    , 0.353480470619    , 0.448805295412    , 0.526619522901    ,
 0.566237576067    , 0.567889522834    , 0.554072007737    , 0.554799164117    ,
 0.590635264852    , 0.669190790424    , 0.795091667493    , 0.980318295126    ,
 1.24215363857     , 1.58596869061     , 1.98691437955     , 2.39961640464     ,
 2.80998753958     , 3.2894827639      , 3.9832516522      , 5.02449878431     ,
 6.45286131835     , 8.21214107175     , 10.2241440087     , 12.4644940979     ,
 14.9652972304     , 17.7547048298     , 20.8104862532     , 24.0528523555     ,
 27.3397585004     , 30.4689371083     , 33.2267824521     , 35.466997605      ,
 37.1574411881     , 38.3681009057     , 39.2045000871     , 39.6945748323     ,
 39.6882931673     , 38.8929178095     , 37.0841609556     , 34.3171790268     ,
 30.9141039918     , 27.2661768819     , 23.6846703049     , 20.3853134158     ,
 17.5064768619     , 15.1026001794     , 13.1395299877     , 11.5132981522     ,
 10.0895926187     , 8.7520922335      , 7.44206264842     , 6.17059225345     ,
 4.99587993878     , 3.98429498747     , 3.18103785939     , 2.5910175904      ,
 2.17090588328     , 1.85150187762     , 1.57884562915     , 1.33281792721     ,
 1.11659122162     , 0.940726853414    , 0.810190959162    , 0.7158247786      ,
 0.640265235822    , 0.573385797029    , 0.515681170647    , 0.465943685148    ,
 0.414266298358    , 0.352892229765    , 0.289204531075    , 0.238977231318    ,
 0.206137851545    , 0.178060126749    , 0.144201986544    , 0.111320468051    ,
 0.0948284123854   , 0.100007592916    , 0.117076938823    , 0.132998119597    ,
 0.14283811414     , 0.147463370345    , 0.14477334216     , 0.129648891313    ,
 0.102060865888    , 0.0701322056141   , 0.0445914725161   , 0.0332753223333   ,
 0.0404526883812   , 0.0667623204677   , 0.106350519945    , 0.145253481706    ,
 0.166834900026    , 0.162126097454    , 0.135812842713    , 0.10263991718     ,
 0.0781712491525   , 0.0705194998262   , 0.0765908964915   , 0.0846615151525   ,
 0.083235090711    , 0.0701667015404   , 0.0532797679398   , 0.0420556941525   ,
 0.0396568561269   , 0.042310505589    , 0.0443381330373   , 0.0432067694536   ,
 0.0404361143989   , 0.0385222044416   , 0.0383838720684   , 0.0399657045982   ,
 0.0429921371228   , 0.0459530080952   , 0.0465087822217   , 0.0441679991985   ,
 0.040773609947    , 0.0377095372278   , 0.0346613991668   , 0.0316481557993   ,
 0.0303029066726   , 0.0323666981063   , 0.0377196832041   , 0.0437526676083   ,
 0.0484452506829   , 0.0441727044142   , 0.0371666880401   , 0.029995033247    ,
 0.0257586121651   , 0.025869528542    , 0.0283590899202   , 0.0288837912125   ,
 0.0245817674973   , 0.0167245058624   , 0.00899329931266  , 0.00404205855664  ,
 0.00260724979294  , 0.00535823693437  , 0.0146451176011   , 0.0334448480813   ,
 0.0608653823884   , 0.0881551430548   , 0.102208986043    , 0.0964850802886   ,
 0.0777273040526   , 0.0598669419108   , 0.0524174550634   , 0.055826577338    ,
 0.0651620433086   , 0.0747024039456   , 0.0795291187032   , 0.0770532282208   ,
 0.0699165843487   , 0.0653548095498   , 0.0688091505506   , 0.0790419395181   ,
 0.0907739587704   , 0.0998407436199   , 0.10401455897     , 0.101755840437    ,
 0.0940411835972   , 0.0865624058285   , 0.0858013457883   , 0.0915082610531   ,
 0.0965839532008   , 0.0962886289139   , 0.0933577942139   , 0.0913328316175   ,
 0.0881923614521   , 0.0816077840151   , 0.0771269684973   , 0.0861750880204   ,
 0.116022800302    , 0.162020488844    , 0.207775160907    , 0.234343337145    ,
 0.234479088966    , 0.220868602938    , 0.219221245418    , 0.250314395089    ,
 0.315844185641    , 0.399581477982    , 0.479875771283    , 0.540075040483    ,
 0.572598048305    , 0.582299083344    , 0.587790044579    , 0.613485634475    ,
 0.676753552176    , 0.783688822003    , 0.937088223758    , 1.14758221192     ,
 1.43602088857     , 1.81821384304     , 2.28077703669     , 2.78382834585     ,
 3.31252170644     , 3.93180339723     , 4.77110348755     , 5.94367438823     ,
 7.48265633505     , 9.34559859925     , 11.4691400403     , 13.8230328398     ,
 16.4175525227     , 19.2710693975     , 22.3836697261     , 25.7132671805     ,
 29.1243987185     , 32.3588273311     , 35.1045477668     , 37.13482695       ,
 38.4116534925     , 39.0870482883     , 39.3956234108     , 39.4750153853     ,
 39.2240958706     , 38.3430678556     , 36.5676219366     , 33.8953645362     ,
 30.5908896279     , 27.0107304822     , 23.460904162      , 20.1678128523     ,
 17.2825500087     , 14.8676829424     , 12.8877287386     , 11.2298254573     ,
 9.75873919963     , 8.37876765375     , 7.06211577421     , 5.83367042183     ,
 4.73647525966     , 3.80720931011     , 3.06819936177     , 2.51770284523     ,
 2.11805832144     , 1.8092979219      , 1.54450615221     , 1.30788331711     ,
 1.10492004818     , 0.945107838459    , 0.828521585303    , 0.741010647544    ,
 0.664694498405    , 0.594208526831    , 0.536520031427    , 0.492915973903    ,
 0.449044204396    , 0.39012017263     , 0.321866021608    , 0.265303211545    ,
 0.229633138782    , 0.201684136653    , 0.166721989735    , 0.129346268124    ,
 0.106488280826    , 0.10601622904     , 0.119514960361    , 0.133959099483    ,
 0.14383407752     , 0.149482973704    , 0.148589900698    , 0.135752355086    ,
 0.110061708241    , 0.0784774713754   , 0.051303129512    , 0.0369683326101   ,
 0.0403387676499   , 0.0616980510456   , 0.0943151192296   , 0.12429528157     ,
 0.137055196911    , 0.127070119949    , 0.101782621399    , 0.0760002527977   ,
 0.0623397723855   , 0.0645453924849   , 0.0761067340341   , 0.0845672722461   ,
 0.0803998603785   , 0.0644688016253   , 0.0469513461898   , 0.0386342804566   ,
 0.0428158777246   , 0.0538563463716   , 0.0624977199952   , 0.0635797698158   ,
 0.0590019240777   , 0.0531989727818   , 0.0479467224572   , 0.0429136791341   ,
 0.0383265287907   , 0.0345046134836   , 0.0306540774326   , 0.0262138906628   ,
 0.0222826743842   , 0.0206581575429   , 0.0223720247974   , 0.0273610852434   ,
 0.0344293817358   , 0.0414802074545   , 0.0466705301016   , 0.0491548354838   ,
 0.0482384312256   , 0.0439083528903   , 0.0399260743588   , 0.0350198606975   ,
 0.0293646194274   , 0.0246193564173   , 0.0216288017661   , 0.0190603741368   ,
 0.0151599377221   , 0.0100391801189   , 0.00535351308798  , 0.0024600291264   ,
 0.0018741934312   , 0.00446771525142  , 0.0127116125158   , 0.0298922499676   ,
 0.0563193386917   , 0.0853646616411   , 0.105633641274    , 0.110404764084    ,
 0.104586361153    , 0.0999745815818   , 0.103937937167    , 0.114169104075    ,
 0.123214703069    , 0.125415886057    , 0.119321891163    , 0.107174803592    ,
 0.0952843497189   , 0.0921067719721   , 0.101238112158    , 0.11727478981     ,
 0.13155611336     , 0.139746541467    , 0.140980389707    , 0.133497420517    ,
 0.116568640005    , 0.0952746136518   , 0.0780999910762   , 0.0687990408278   ,
 0.0639800784622   , 0.0595995859526   , 0.056151628022    , 0.0557041159191   ,
 0.0577447220151   , 0.0613087833225   , 0.0690753675322   , 0.0862480990001   ,
 0.115158091041    , 0.150927637085    , 0.181976487646    , 0.197133668108    ,
 0.196297975422    , 0.195207465222    , 0.216699220228    , 0.272520235634    ,
 0.351447007244    , 0.427802972976    , 0.483577355581    , 0.519798452929    ,
 0.547750693558    , 0.577428667511    , 0.617129224174    , 0.676813411027    ,
 0.766821848442    , 0.89555395266     , 1.07129351349     , 1.30864197809     ,
 1.63286249872     , 2.06781262618     , 2.61041759526     , 3.22984794381     ,
 3.91461652416     , 4.71843189371     , 5.74026886356     , 7.06194410303     ,
 8.71608330162     , 10.6944784243     , 12.9625162968     , 15.4708434581     ,
 18.1682062114     , 21.021489626      , 24.0395370244     , 27.2452659905     ,
 30.5639797821     , 33.7366258106     , 36.3922998148     , 38.2376595931     ,
 39.2012963522     , 39.4457501105     , 39.2574557191     , 38.8560686296     ,
 38.2266523726     , 37.1304859518     , 35.3227471728     , 32.7770817718     ,
 29.7030143094     , 26.3923567722     , 23.0916523258     , 19.9786611782     ,
 17.175305121      , 14.7445677957     , 12.6796635696     , 10.912322031      ,
 9.35249457886     , 7.93404249104     , 6.63201607802     , 5.45328942745     ,
 4.4199539065      , 3.5545559073      , 2.86958130945     , 2.35683869558     ,
 1.97941796088     , 1.68417509187     , 1.43110473225     , 1.20895333499     ,
 1.02590036275     , 0.890713569649    , 0.798569419805    , 0.729738793469    ,
 0.663948816796    , 0.59745851613     , 0.541625702148    , 0.501749784596    ,
 0.463411279946    , 0.408288161641    , 0.340219261963    , 0.282500605112    ,
 0.247214990938    , 0.220676235205    , 0.1852326763      , 0.143861198263    ,
 0.114442025183    , 0.106758945192    , 0.113712962401    , 0.122653662072    ,
 0.127922154032    , 0.13023862038     , 0.12883798367     , 0.119727145412    ,
 0.101101012638    , 0.0767293006839   , 0.0537462743429   , 0.0390909915035   ,
 0.0374741292726   , 0.0496674130261   , 0.0704670382189   , 0.0891877057025   ,
 0.0953833249663   , 0.0864742890954   , 0.0700519783718   , 0.0584761168675   ,
 0.060502616711    , 0.0755761535606   , 0.0935906319803   , 0.101047122308    ,
 0.0909519955028   , 0.0686607343      , 0.0478716729483   , 0.0405674646318   ,
 0.0492903792921   , 0.0661475513292   , 0.0788878199165   , 0.0804739178096   ,
 0.0733028161754   , 0.0634951197071   , 0.053672736516    , 0.0433630371457   ,
 0.0331008610943   , 0.0245824938027   , 0.0183754740329   , 0.0140437882299   ,
 0.011945610642    , 0.0136556998078   , 0.020693020341    , 0.0326213981945   ,
 0.045812075775    , 0.0549092696981   , 0.0568783046841   , 0.053340037429    ,
 0.0477474835431   , 0.0444624149986   , 0.0439917684344   , 0.0414345385144   ,
 0.0344844732465   , 0.0252843104674   , 0.0173228855779   , 0.0118690841134   ,
 0.00803397727349  , 0.00492928427284  , 0.00255673422192  , 0.00121553296526  ,
 0.00117824353128  , 0.00332494929263  , 0.0100191622656   , 0.0248192971638   ,
 0.0498021628669   , 0.0819063946175   , 0.113219555857    , 0.137490651255    ,
 0.156170650271    , 0.175573610145    , 0.197911748932    , 0.217142624857    ,
 0.224181816566    , 0.2148003725      , 0.191944782307    , 0.163435535294    ,
 0.140454287976    , 0.134121494736    , 0.146620224016    , 0.166972008171    ,
 0.1808957393      , 0.183003038197    , 0.175360683259    , 0.158770887884    ,
 0.132519807991    , 0.100646519325    , 0.0717650388434   , 0.0517047514826   ,
 0.0397752048736   , 0.0328089946262   , 0.0299150723089   , 0.0321833998518   ,
 0.040106908312    , 0.0529568821865   , 0.0696038340464   , 0.0888635797843   ,
 0.109133247838    , 0.127510923572    , 0.139738623265    , 0.143674960552    ,
 0.1453599373      , 0.160780020101    , 0.206910175551    , 0.285047074919    ,
 0.372126643745    , 0.435787546548    , 0.463897624652    , 0.475844748138    ,
 0.502210520603    , 0.558808675193    , 0.642074014261    , 0.742151807674    ,
 0.856428682706    , 0.994673468222    , 1.1770099226      , 1.43193122374     ,
 1.79515193903     , 2.29666121065     , 2.93817689289     , 3.6960833691      ,
 4.56441359179     , 5.58581108188     , 6.82445673406     , 8.32602947821     ,
 10.1225508525     , 12.2451642123     , 14.6911066223     , 17.3801613397     ,
 20.1698073155     , 22.9452000946     , 25.7163102212     , 28.5930143264     ,
 31.6034864535     , 34.5387383004     , 37.0196194411     , 38.7189523553     ,
 39.5187967194     , 39.5220614373     , 38.973354919      , 38.1157284197     ,
 37.0263406508     , 35.5783485593     , 33.607108983      , 31.1127584621     ,
 28.2784977484     , 25.327422236      , 22.4100781139     , 19.6044655685     ,
 16.9627192284     , 14.5362638714     , 12.3670244803     , 10.4691895462     ,
 8.82650176622     , 7.40002979031     , 6.13999970414     , 5.01204816518     ,
 4.02054277273     , 3.19569742445     , 2.55721273795     , 2.09162149946     ,
 1.75459384117     , 1.49197524868     , 1.26654191523     , 1.0706625879      ,
 0.916406218312    , 0.813558984767    , 0.753094585105    , 0.708842759211    ,
 0.656185944267    , 0.590861777666    , 0.527784157107    , 0.478722362499    ,
 0.435227206457    , 0.381339624151    , 0.319574755228    , 0.270345525667    ,
 0.243229692178    , 0.222897058637    , 0.190548964517    , 0.148529883298    ,
 0.114980477217    , 0.100808629756    , 0.100363002742    , 0.102056941412    ,
 0.100706648205    , 0.0978714794092   , 0.094896576183    , 0.0899024362524   ,
 0.080690182785    , 0.0676112468093   , 0.0533729167636   , 0.0416359872309   ,
 0.0358965728679   , 0.0379848222752   , 0.0460403109513   , 0.0543305632535   ,
 0.0570026925123   , 0.0533578489006   , 0.0495278783202   , 0.0545810544083   ,
 0.0736240678981   , 0.102188372173    , 0.126390272527    , 0.131259252614    ,
 0.112397956335    , 0.0802602066477   , 0.052503883967    , 0.0420634197306   ,
 0.0503559154607   , 0.0678693619508   , 0.0810090683732   , 0.0819727232274   ,
 0.0731662268651   , 0.0613017823252   , 0.0495681148586   , 0.0376078945711   ,
 0.0258807943021   , 0.0163605311541   , 0.0101789403822   , 0.00714312961263  ,
 0.00742618504708  , 0.0125539841266   , 0.0241830500625   , 0.0412348168895   ,
 0.0580483351234   , 0.0670302197081   , 0.0649128413067   , 0.0559357591714   ,
 0.0474321866546   , 0.0458177447558   , 0.0475581296317   , 0.0459224237841   ,
 0.0377482166903   , 0.0257691627062   , 0.0149505576481   , 0.00788966388381  ,
 0.00409774286184  , 0.00211067597267  , 0.00101463451597  , 0.000514836698129 ,
 0.000705758498211 , 0.00236393780373  , 0.00766444248544  , 0.0204805499478   ,
 0.044994659421    , 0.0826878938882   , 0.130706661877    , 0.184128300011    ,
 0.239004156697    , 0.291354246505    , 0.334081978441    , 0.357695728979    ,
 0.355526897031    , 0.328357069241    , 0.284142489037    , 0.235212271777    ,
 0.197049166133    , 0.183689747633    , 0.19594261182     , 0.216615011349    ,
 0.225297199207    , 0.216310407852    , 0.196768560034    , 0.172048053044    ,
 0.141597672719    , 0.106485643613    , 0.0728627320425   , 0.0467878436003   ,
 0.029743144109    , 0.020247923337    , 0.0174981983498   , 0.0223721019763   ,
 0.0357557262682   , 0.0561394138848   , 0.0785478226714   , 0.096609392621    ,
 0.106466879771    , 0.108346473558    , 0.105096777797    , 0.101802713421    ,
 0.107957721484    , 0.137449375836    , 0.200628093149    , 0.290320942       ,
 0.376556386598    , 0.425582895195    , 0.432122357417    , 0.428990510221    ,
 0.459967863402    , 0.545378413105    , 0.672890289171    , 0.814264366032    ,
 0.950278986225    , 1.08774500425     , 1.26077400207     , 1.52053368293     ,
 1.92041538724     , 2.49555897641     , 3.24571705062     , 4.14884774044     ,
 5.20418815211     , 6.44956072724     , 7.92450568745     , 9.64261702988     ,
 11.6246998694     , 13.9238608868     , 16.5603250742     , 19.4221052595     ,
 22.271243082      , 24.9043256833     , 27.3319382985     , 29.7588364351     ,
 32.3323654487     , 34.9217646802     , 37.1751246108     , 38.7565412212     ,
 39.4981639111     , 39.4051593678     , 38.6190921632     , 37.3528396617     ,
 35.7618261867     , 33.8608301551     , 31.6122168587     , 29.0790323094     ,
 26.4350566553     , 23.8356761405     , 21.32663269       , 18.8724624792     ,
 16.4416365813     , 14.0662979502     , 11.8392452978     , 9.86296123163     ,
 8.19283593571     , 6.80470402505     , 5.61159152675     , 4.53596631484     ,
 3.57379989733     , 2.77712445598     , 2.1837868886      , 1.77742181085     ,
 1.50066896245     , 1.29023990853     , 1.10641060112     , 0.944321907826    ,
 0.821835207516    , 0.751936838152    , 0.722359351085    , 0.700266954292    ,
 0.65624969642     , 0.585254684618    , 0.505430233618    , 0.435682917997    ,
 0.376944775871    , 0.320298858043    , 0.268210299709    , 0.234436703109    ,
 0.221394624171    , 0.210842101756    , 0.184216017402    , 0.144156068826    ,
 0.108734848181    , 0.0896892966206   , 0.0832000160147   , 0.0792626394144   ,
 0.0731965180719   , 0.0667915630015   , 0.0626892984186   , 0.0610260373068   ,
 0.060314956545    , 0.0588763913272   , 0.0551682423329   , 0.0484721986096   ,
 0.0402024896747   , 0.0336217162801   , 0.0310771179152   , 0.0318161536728   ,
 0.0335165260999   , 0.0360908158769   , 0.043635425606    , 0.0622013225476   ,
 0.0939989799893   , 0.13158585222     , 0.158348301008    , 0.158706998012    ,
 0.130927458449    , 0.0895724862043   , 0.0547253038321   , 0.0390424130257   ,
 0.0426757855959   , 0.0559128164901   , 0.0661521993118   , 0.0662391545522   ,
 0.0579731479679   , 0.047141636339    , 0.0367936728648   , 0.0268014448046   ,
 0.0173530272584   , 0.00987306916082  , 0.00536003753853  , 0.00390966749236  ,
 0.00603022950115  , 0.0134888726732   , 0.0278928815355   , 0.0474072797927   ,
 0.0650602006982   , 0.0725375777322   , 0.0674404688349   , 0.0560014568776   ,
 0.0481125757083   , 0.0480175195959   , 0.0495222214602   , 0.0464743893395   ,
 0.03686202765     , 0.0239980189818   , 0.0128064505928   , 0.00576334275253  ,
 0.00234207264496  , 0.000944549863951 , 0.00041410666633  , 0.00026928933816  ,
 0.000509878225544 , 0.00177024234004  , 0.0060165439413   , 0.0174046888357   ,
 0.0422107323511   , 0.086870681023    , 0.154751500713    , 0.243064991037    ,
 0.340525988779    , 0.427962913176    , 0.485405999249    , 0.502133435705    ,
 0.480228232924    , 0.429891289162    , 0.363770345203    , 0.296119207259    ,
 0.244607161472    , 0.224771437141    , 0.235190607676    , 0.25291026503     ,
 0.253247994066    , 0.232317078917    , 0.20348092568     , 0.176608596391    ,
 0.149848373991    , 0.11897506347     , 0.0857679586961   , 0.0558825034014   ,
 0.0334563184236   , 0.0197989935318   , 0.0153248691957   , 0.0210579410608   ,
 0.0377297480222   , 0.0627650547365   , 0.0884964715      , 0.105482114073    ,
 0.108934322602    , 0.101485429029    , 0.0905246150574   , 0.0851386705766   ,
 0.0956853245876   , 0.132934626769    , 0.201836290268    , 0.290770354807    ,
 0.369217132958    , 0.407574689529    , 0.407044758232    , 0.405561530335    ,
 0.449162610362    , 0.558330390094    , 0.717948761832    , 0.891087373236    ,
 1.04539824603     , 1.18043436942     , 1.33970401812     , 1.59771361729     ,
 2.02883832079     , 2.67436713391     , 3.52961689262     , 4.56994918051     ,
 5.7979982187      , 7.2535042216      , 8.96570049441     , 10.9222898633     ,
 13.1170064887     , 15.598485112      , 18.3988392259     , 21.3864076098     ,
 24.2488013026     , 26.7083859014     , 28.7759968065     , 30.737535124      ,
 32.8486856044     , 35.0653274101     , 37.0819090219     , 38.5620124436     ,
 39.2818353398     , 39.1377916312     , 38.1515050493     , 36.4840419356     ,
 34.3631048603     , 31.9670485353     , 29.4115455686     , 26.8221898972     ,
 24.3402839763     , 22.0395095914     , 19.8757742828     , 17.7330107707     ,
 15.5211116578     , 13.2561431171     , 11.0660668043     , 9.11469466928     ,
 7.50008059647     , 6.19713282687     , 5.08865136806     , 4.07196913593     ,
 3.14471649866     , 2.38037788649     , 1.83452827815     , 1.49086158992     ,
 1.28000068598     , 1.12655261574     , 0.985156134926    , 0.853151465781    ,
 0.75526108006     , 0.709061762611    , 0.700753131193    , 0.693111020104    ,
 0.65428439393     , 0.579277028209    , 0.487298197912    , 0.400397200778    ,
 0.32681429506     , 0.266272035029    , 0.223794425298    , 0.20674688059     ,
 0.208468707871    , 0.206408540533    , 0.182825423477    , 0.142290976319    ,
 0.10403647641     , 0.0809535678372   , 0.0707123386151   , 0.0642472482582   ,
 0.0566406531962   , 0.048981244883    , 0.0441782195776   , 0.044055655182    ,
 0.0488389552487   , 0.0564162298505   , 0.0618676011587   , 0.0600507601814   ,
 0.0502265607114   , 0.0373538917945   , 0.0278484734193   , 0.0247276925749   ,
 0.0274024238095   , 0.0351310434179   , 0.0496997219386   , 0.0744941565158   ,
 0.109707020871    , 0.146870117037    , 0.16961841007     , 0.16415334143     ,
 0.131232364684    , 0.086743522473    , 0.0498640293307   , 0.0311224619836   ,
 0.029526408127    , 0.0366447726955   , 0.042712389659    , 0.0422988637974   ,
 0.036348902588    , 0.0287520098961   , 0.0217507244736   , 0.0153753129447   ,
 0.00960937223501  , 0.00517911648034  , 0.00272251222172  , 0.00259506603181  ,
 0.00577401087264  , 0.0142703331176   , 0.0294559591948   , 0.0488353650722   ,
 0.0650536426944   , 0.0705724903435   , 0.064639611324    , 0.0543909822928   ,
 0.0522624308457   , 0.0535993795324   , 0.0530182418775   , 0.0465037984081   ,
 0.0346321146874   , 0.0214692197362   , 0.0110341482217   , 0.00478659184866  ,
 0.00186859266176  , 0.000781951132732 , 0.000489475119361 , 0.000526159187112 ,
 0.000819490998998 , 0.00182169969649  , 0.00522583949605  , 0.0152314729297   ,
 0.0396363410693   , 0.0891783484033   , 0.173314486276    , 0.291745416798    ,
 0.425660712839    , 0.53978356565     , 0.601641622534    , 0.602533010401    ,
 0.557302896924    , 0.48655565228     , 0.405170040291    , 0.326276969105    ,
 0.267646366883    , 0.244729336072    , 0.253452896352    , 0.267197807471    ,
 0.260364223619    , 0.232373648539    , 0.201598659898    , 0.180204627496    ,
 0.16340707765     , 0.140774685779    , 0.109537762264    , 0.0755511883167   ,
 0.0465048442833   , 0.0271087684904   , 0.0191285879095   , 0.0234041067978   ,
 0.0400653996272   , 0.065845937799    , 0.0922457111665   , 0.109167760085    ,
 0.111800314678    , 0.103533502006    , 0.0930414268827   , 0.0902123071907   ,
 0.104227146943    , 0.142531036211    , 0.206899612895    , 0.286019973896    ,
 0.354829386748    , 0.392038198902    , 0.403751276866    , 0.424030642471    ,
 0.48865398692     , 0.611208961107    , 0.779273960323    , 0.961928176701    ,
 1.12538292765     , 1.26182432313     , 1.41515507441     , 1.67457131354     ,
 2.1332034009      , 2.84231440592     , 3.79775443994     , 4.97284664093     ,
 6.36890384124     , 8.02303934641     , 9.95434302965     , 12.1256939211     ,
 14.4988287201     , 17.1086039427     , 19.9968647999     , 23.0282643448     ,
 25.8481944172     , 28.1331147488     , 29.8924889586     , 31.4587819673     ,
 33.1596185585     , 35.0294953099     , 36.8208370693     , 38.2001712578     ,
 38.881174219      , 38.6543873277     , 37.4370981701     , 35.3531471657     ,
 32.7120847644     , 29.8626400213     , 27.0663991666     , 24.4788465837     ,
 22.1674105751     , 20.1084687395     , 18.1955806569     , 16.2857797755     ,
 14.2749979663     , 12.1739719692     , 10.1222663157     , 8.30336863624     ,
 6.82067351201     , 5.63609242874     , 4.61932274625     , 3.6675472159      ,
 2.78817951337     , 2.067107304       , 1.56912445841     , 1.27918269538     ,
 1.12126670837     , 1.01115476739     , 0.898806803508    , 0.783580116563    ,
 0.696039791611    , 0.658092972137    , 0.657053284682    , 0.656471672241    ,
 0.626501803543    , 0.562373541743    , 0.479105091924    , 0.393905549779    ,
 0.316619141739    , 0.255361559691    , 0.221443325281    , 0.219046780396    ,
 0.232350719681    , 0.232879731821    , 0.204144837563    , 0.155661934323    ,
 0.110597285551    , 0.0832759464279   , 0.0711496079428   , 0.0642729138679   ,
 0.0566117122205   , 0.0482443483271   , 0.0419384427824   , 0.0408399766084   ,
 0.0471228585471   , 0.0591380084602   , 0.0698008703307   , 0.0707783078912   ,
 0.0600264459297   , 0.0441186657065   , 0.0323005492802   , 0.0293651193277   ,
 0.0345972338002   , 0.045673325582    , 0.0620605212193   , 0.0848503277104   ,
 0.113154396212    , 0.139896891577    , 0.152584053354    , 0.141686730482    ,
 0.109650044739    , 0.0702237226489   , 0.038323670389    , 0.0210502153843   ,
 0.0167273543958   , 0.0190923935291   , 0.021763323572    , 0.021306526484    ,
 0.0180052661709   , 0.0138835873357   , 0.0102051186517   , 0.00704073318794  ,
 0.00431999431812  , 0.00232458336535  , 0.00142535586713  , 0.0021566261963   ,
 0.0058277738116   , 0.0145408886019   , 0.0293327918639   , 0.0472413327214   ,
 0.0611913502109   , 0.065246250153    , 0.0605495897994   , 0.0542980928442   ,
 0.0619601044053   , 0.0659544260562   , 0.063816616435    , 0.0533663644375   ,
 0.0380004660404   , 0.0231217406799   , 0.0122818018423   , 0.00599548766266  ,
 0.00298658769019  , 0.00184845886519  , 0.00171122343924  , 0.00209644143611  ,
 0.00273187115318  , 0.00374289440796  , 0.00639296049724  , 0.0145325536421   ,
 0.0364405050041   , 0.0852962071025   , 0.174656578418    , 0.306268415986    ,
 0.456607955207    , 0.580258718939    , 0.638408838329    , 0.626819977203    ,
 0.570488137838    , 0.494984871765    , 0.412562336563    , 0.332715529809    ,
 0.272586972928    , 0.247781430499    , 0.253493545495    , 0.26324682426     ,
 0.253507025961    , 0.22616683434     , 0.200891784006    , 0.189245773909    ,
 0.183303527693    , 0.167872759674    , 0.137249762338    , 0.0986108666611   ,
 0.0634533055533   , 0.0391948435795   , 0.0278912681213   , 0.0295124934043   ,
 0.0435693226232   , 0.0668018881538   , 0.0913097899842   , 0.107983671406    ,
 0.112675021678    , 0.108567796604    , 0.103512663805    , 0.105938860011    ,
 0.122213834415    , 0.156206630399    , 0.208431523031    , 0.272001727625    ,
 0.332161193872    , 0.378746639057    , 0.420940153317    , 0.481695380488    ,
 0.576137944073    , 0.703155180686    , 0.854581438797    , 1.01789681075     ,
 1.1732181103      , 1.31198877953     , 1.47197028048     , 1.74463297711     ,
 2.23537083772     , 3.00986760206     , 4.07409798895     , 5.40324407579     ,
 6.98773388211     , 8.8401231972      , 10.9482368363     , 13.2480826292     ,
 15.6892816859     , 18.3139505318     , 21.1791473886     , 24.1508412881     ,
 26.8601740563     , 28.9759147231     , 30.5128366439     , 31.8081635515     ,
 33.2030835716     , 34.7779389884     , 36.3427441381     , 37.5777192074     ,
 38.1462747063     , 37.7583886021     , 36.2693211248     , 33.8030260788     ,
 30.7543387127     , 27.6053145715     , 24.7074857928     , 22.2022278946     ,
 20.0690473874     , 18.2016004689     , 16.4636464654     , 14.7241952451     ,
 12.8962964171     , 10.9939090793     , 9.14977203306     , 7.533606554       ,
 6.22670305882     , 5.17217372764     , 4.24165369707     , 3.35152400651     ,
 2.52544699242     , 1.85360876277     , 1.39949767925     , 1.14661217182     ,
 1.01738201261     , 0.926278516734    , 0.823758194719    , 0.711458518739    ,
 0.622232304173    , 0.579687463587    , 0.57442865007     , 0.576503854897    ,
 0.562409238728    , 0.526842534762    , 0.475067814132    , 0.412410876667    ,
 0.345425820093    , 0.289704153241    , 0.265140512381    , 0.275383140361    ,
 0.296029723762    , 0.292113438835    , 0.249566658702    , 0.186031887648    ,
 0.130879443785    , 0.0992370060903   , 0.0860075874248   , 0.0786741588338   ,
 0.0699298647081   , 0.059406398805    , 0.0498835417189   , 0.0452953952221   ,
 0.049148348757    , 0.0604630332254   , 0.0715056894338   , 0.0729196267857   ,
 0.0625881397042   , 0.0479851967899   , 0.0390487155765   , 0.0400650073678   ,
 0.0487696726383   , 0.0611254444322   , 0.0750982964698   , 0.0903871445569   ,
 0.105797487966    , 0.117018876624    , 0.117417234191    , 0.102811337581    ,
 0.07629326953     , 0.0471972893537   , 0.0245976686962   , 0.0120793801803   ,
 0.0078613353356   , 0.0079376806961   , 0.0087455866373   , 0.00845383278388  ,
 0.00703655647447  , 0.00530365578024  , 0.00380505136232  , 0.00259903519512  ,
 0.00165237293088  , 0.00107031260569  , 0.0010891158809   , 0.00231189748986  ,
 0.00619672584568  , 0.014855188141    , 0.0290711174433   , 0.0456181968875   ,
 0.0578654969287   , 0.0614430632016   , 0.0592136589261   , 0.0583226455689   ,
 0.0771023367327   , 0.0867989111798   , 0.086477269484    , 0.0737407798715   ,
 0.0538975455984   , 0.0346097646232   , 0.0204977673638   , 0.0119882570626   ,
 0.00753499655863  , 0.00580483551608  , 0.00605276940122  , 0.00756283606586  ,
 0.00946085575114  , 0.0111478136616   , 0.013178309624    , 0.0187396191549   ,
 0.0357199241782   , 0.0776802711417   , 0.159368540179    , 0.283406234123    ,
 0.425878667072    , 0.54119310459     , 0.593251715314    , 0.58285429153     ,
 0.537526358308    , 0.479094321863    , 0.412296942099    , 0.341361682861    ,
 0.282748890912    , 0.253948715807    , 0.253304891525    , 0.258642886402    ,
 0.249679413998    , 0.227945710691    , 0.210323786592    , 0.206089337048    ,
 0.205774249746    , 0.192527088662    , 0.16023616318     , 0.118270486995    ,
 0.0809480692459   , 0.056179744528    , 0.0443049011427   , 0.0438667654335   ,
 0.0545069085375   , 0.0738643091936   , 0.0950145639224   , 0.110047438153    ,
 0.115880517355    , 0.115753383062    , 0.116340027621    , 0.123753358206    ,
 0.140786744713    , 0.167573135088    , 0.204071907533    , 0.249590858028    ,
 0.302045043805    , 0.363709294783    , 0.445655992861    , 0.556439442618    ,
 0.686410369134    , 0.81550909494     , 0.937242277148    , 1.06071907435     ,
 1.19058102907     , 1.32872509249     , 1.50844415373     , 1.81470185779     ,
 2.3561184148      , 3.21256978893     , 4.40682189668     , 5.91895463986     ,
 7.71654129921     , 9.75851466848     , 11.9737545752     , 14.2751346837     ,
 16.6390446129     , 19.1508833862     , 21.8845787344     , 24.6965315313     ,
 27.2209214825     , 29.1594896245     , 30.55080439       , 31.7053838598     ,
 32.9145778199     , 34.2487514992     , 35.5535987727     , 36.5377525539     ,
 36.8572265255     , 36.2042903579     , 34.44009889       , 31.7272990083     ,
 28.5172810371     , 25.3326492838     , 22.5175089754     , 20.1615355957     ,
 18.1868239742     , 16.458534735      , 14.8463532811     , 13.2432103091     ,
 11.5828055165     , 9.88331077617     , 8.26367129663     , 6.86604678417     ,
 5.73964147037     , 4.80890822583     , 3.95430180888     , 3.11883477603     ,
 2.34537454441     , 1.7240060516      , 1.30812819099     , 1.07474796197     ,
 0.948637229964    , 0.852660697316    , 0.745200397385    , 0.630003452716    ,
 0.536556694196    , 0.485677525053    , 0.471691574213    , 0.474293818486    ,
 0.47811838849     , 0.476640347898    , 0.463928726109    , 0.432506169365    ,
 0.384470123016    , 0.340693569545    , 0.327679702169    , 0.348550492989    ,
 0.37218425238     , 0.359432646603    , 0.30044106899     , 0.221690146414    ,
 0.157993638431    , 0.123532901339    , 0.109223610582    , 0.0997689791914   ,
 0.0874576008472   , 0.0725683868062   , 0.0583274692081   , 0.0488455930531   ,
 0.0478739034803   , 0.0548764772298   , 0.0628994972958   , 0.0636897043954   ,
 0.0559423315757   , 0.0468656293385   , 0.0448758149188   , 0.0519584988202   ,
 0.0637250339819   , 0.075210676572    , 0.0845257870485   , 0.0913514254815   ,
 0.0944595129116   , 0.0917625215692   , 0.0818342330914   , 0.0652547781819   ,
 0.0452459374271   , 0.026637724328    , 0.0132293704761   , 0.00590472187272  ,
 0.00312721580645  , 0.002657857818    , 0.00277372926971  , 0.00263941627313  ,
 0.00216861695138  , 0.00161188865293  , 0.00117104327454  , 0.000913950293896 ,
 0.0008862549449   , 0.00115636509946  , 0.00184162843851  , 0.00342548338334  ,
 0.00731125463402  , 0.015635927726    , 0.0292233412198   , 0.0449261465669   ,
 0.0565230152817   , 0.0606496521505   , 0.0614016058089   , 0.0662975070938   ,
 0.0960050205822   , 0.115169573006    , 0.121354412555    , 0.109351414998    ,
 0.085036955901    , 0.0591997770053   , 0.0391517413943   , 0.0261590767356   ,
 0.0187645810256   , 0.0160703118406   , 0.0176597926637   , 0.0222192734049   ,
 0.0274551245973   , 0.0312262194417   , 0.0329054896303   , 0.0349779356301   ,
 0.0450187575296   , 0.0763379034656   , 0.14307067938     , 0.247375848734    ,
 0.367459765423    , 0.464524048212    , 0.511211606019    , 0.512499919445    ,
 0.492292864139    , 0.463814948925    , 0.422992511948    , 0.368209207797    ,
 0.314262450757    , 0.281118638435    , 0.272850686413    , 0.27358191291     ,
 0.265641989055    , 0.247897931268    , 0.232923476954    , 0.228262215193    ,
 0.225237069184    , 0.208341440572    , 0.173249698916    , 0.131662919672    ,
 0.0986943961098   , 0.0797615302475   , 0.0713282194057   , 0.0703153489668   ,
 0.0777408738863   , 0.0931688334025   , 0.110541212042    , 0.122609347462    ,
 0.127409498359    , 0.12874897537     , 0.132401934341    , 0.142384741783    ,
 0.158739157365    , 0.17883866155     , 0.201994792961    , 0.232419470073    ,
 0.279099322641    , 0.355175376729    , 0.472486939907    , 0.626526642558    ,
 0.787643755302    , 0.920752898509    , 1.01825144365     , 1.10390416238     ,
 1.20599744082     , 1.34566345668     , 1.56052251278     , 1.9278595877      ,
 2.55049686818     , 3.51468240138     , 4.85725319292     , 6.56103368384     ,
 8.56193345972     , 10.7493998738     , 12.9840693871     , 15.1704761484     ,
 17.3452419019     , 19.6577584293     , 22.1901665407     , 24.77545918       ,
 27.0607188586     , 28.8064949343     , 30.088091376      , 31.1746526201     ,
 32.2694613535     , 33.3854241822     , 34.3714505717     , 34.9728594001     ,
 34.8943382756     , 33.8943417772     , 31.9134728307     , 29.1728452614     ,
 26.1203962063     , 23.2034717608     , 20.6590496368     , 18.5025479707     ,
 16.6491501438     , 15.0028164621     , 13.4737159583     , 11.9765511324     ,
 10.4537806368     , 8.92441181954     , 7.49581704821     , 6.28532123244     ,
 5.31500212593     , 4.49586104868     , 3.7165340034      , 2.94102070711     ,
 2.2263484281      , 1.65848834965     , 1.27603558527     , 1.04756048292     ,
 0.905236497926    , 0.789513097283    , 0.672195758722    , 0.556985759385    ,
 0.4640506738      , 0.407898275869    , 0.386605714433    , 0.389403098824    ,
 0.406977304681    , 0.430478414037    , 0.445898928257    , 0.438537593766    ,
 0.408488626268    , 0.378459863031    , 0.376043215816    , 0.402348267916    ,
 0.42347978323     , 0.401129642163    , 0.330898284563    , 0.245018350547    ,
 0.179604486575    , 0.145785105746    , 0.130810508921    , 0.117941757673    ,
 0.100289858397    , 0.079717180307    , 0.0604345925515   , 0.0464460060774   ,
 0.0408127769159   , 0.0429663257974   , 0.047429980139    , 0.0481672449402   ,
 0.0448996306636   , 0.0435811056206   , 0.0497679082045   , 0.062438367148    ,
 0.0754173897134   , 0.0840665310376   , 0.0882917567033   , 0.0889293640119   ,
 0.0845262485175   , 0.0735104930243   , 0.0573571448819   , 0.0398851320958   ,
 0.0245616704429   , 0.0132042461276   , 0.00610566699354  , 0.00248658915869  ,
 0.00108004874702  , 0.000730379410852 , 0.000697127417735 , 0.000649519830546 ,
 0.000533599371215 , 0.000424362553773 , 0.000435756976413 , 0.00072346754612  ,
 0.00148018093459  , 0.00279185806507  , 0.00451302136626  , 0.00663493124136  ,
 0.0101733294233   , 0.0173377324561   , 0.0295117595159   , 0.0442858394766   ,
 0.0559943494715   , 0.0615992301843   , 0.0656735076168   , 0.0765140917131   ,
 0.115371989163    , 0.145644175778    , 0.161380505076    , 0.153161274323    ,
 0.126386491018    , 0.0949307639223   , 0.0690788460111   , 0.0511228838394   ,
 0.040261691118    , 0.0370890296057   , 0.0421875102883   , 0.0531963844091   ,
 0.0651495012922   , 0.0731140361156   , 0.074598454576    , 0.0716392379509   ,
 0.0727901744086   , 0.0926999879206   , 0.14542318903     , 0.231684848525    ,
 0.330592998785    , 0.409801305355    , 0.450372054304    , 0.460274985952    ,
 0.459499316524    , 0.455229112948    , 0.438167653102    , 0.401938988416    ,
 0.357947604138    , 0.326408292387    , 0.315311552404    , 0.313133448776    ,
 0.303399370327    , 0.282867347804    , 0.26198853203     , 0.248658897913    ,
 0.236468391496    , 0.212729154982    , 0.175889249234    , 0.139258445785    ,
 0.116519079323    , 0.108448000802    , 0.10669747677     , 0.106787474918    ,
 0.111804005583    , 0.123780759186    , 0.137747171819    , 0.147148379122    ,
 0.150990095936    , 0.153102554284    , 0.157688011587    , 0.167116688183    ,
 0.181071850127    , 0.197003252278    , 0.214090237755    , 0.238532733898    ,
 0.285206378619    , 0.372746911287    , 0.511106387597    , 0.686667253657    ,
 0.861425003286    , 0.997646296548    , 1.08840539664     , 1.16113065311     ,
 1.25597818295     , 1.41282217628     , 1.68190676734     , 2.1378530741      ,
 2.87281989469     , 3.96787637308     , 5.46139659273     , 7.3291503032      ,
 9.47299465558     , 11.7235512815     , 13.8956902339     , 15.9071918929     ,
 17.8601804352     , 19.9551851071     , 22.2684239207     , 24.6103015652     ,
 26.649204049      , 28.200764496      , 29.3625744262     , 30.3578109531     ,
 31.3093654229     , 32.1717103368     , 32.78252501       , 32.922698051      ,
 32.3803953204     , 31.0375256502     , 28.9551677583     , 26.4045185356     ,
 23.7691605966     , 21.3410050441     , 19.1965140287     , 17.2731238595     ,
 15.5132923026     , 13.9013908802     , 12.4105999289     , 10.9763609306     ,
 9.541540215       , 8.12454859896     , 6.82659736955     , 5.74931466672     ,
 4.89982825422     , 4.18414463914     , 3.49442835641     , 2.80024125587     ,
 2.15892561545     , 1.64732986804     , 1.29134415124     , 1.05684064984     ,
 0.890190106706    , 0.753785230975    , 0.631933482706    , 0.523379281515    ,
 0.435054967938    , 0.375578245938    , 0.349044779895    , 0.3532660327      ,
 0.380326561058    , 0.41607808715     , 0.441681603638    , 0.442252586265    ,
 0.419789532586    , 0.39641277525     , 0.396247985955    , 0.417968924269    ,
 0.42962899787     , 0.398543194413    , 0.325382164379    , 0.242957930263    ,
 0.183678463289    , 0.154387025332    , 0.140371318113    , 0.12521228734     ,
 0.103353966398    , 0.0782582644774   , 0.0554112197376   , 0.0389476013754   ,
 0.0310069937996   , 0.0305743492289   , 0.0334048638259   , 0.0354948580704   ,
 0.037313985046    , 0.0432815776564   , 0.056001445867    , 0.0717739029729   ,
 0.0835044470783   , 0.0879927698165   , 0.0878330236874   , 0.0854116116228   ,
 0.0786132346119   , 0.0647747734316   , 0.0460061159273   , 0.0279074971961   ,
 0.0145979482841   , 0.00667397832907  , 0.00268321915877  , 0.000960461900521 ,
 0.000343145764191 , 0.000175860809553 , 0.000145068571643 , 0.000132904024862 ,
 0.000126147033689 , 0.000185566905998 , 0.000486016906531 , 0.00139158984709  ,
 0.00337736022331  , 0.00658856028262  , 0.0103494086392   , 0.0135855791718   ,
 0.0164327198841   , 0.021224088616    , 0.0305845516199   , 0.0437117455298   ,
 0.0558106056051   , 0.0635391201892   , 0.071001095466    , 0.0872241823484   ,
 0.130086295879    , 0.168271797106    , 0.192526453752    , 0.190373666178    ,
 0.166171387502    , 0.134911590069    , 0.107785175174    , 0.0873102340848   ,
 0.0742554255468   , 0.0724300246459   , 0.0843707246134   , 0.106076835079    ,
 0.12840261547     , 0.142275841328    , 0.142771167984    , 0.132111325227    ,
 0.121985333543    , 0.131457432488    , 0.176681315162    , 0.256292560543    ,
 0.346203272792    , 0.414386094367    , 0.445254532455    , 0.449011228211    ,
 0.446207024372    , 0.445255563852    , 0.437875386132    , 0.415763279378    ,
 0.386094407983    , 0.365527182359    , 0.360457142544    , 0.359011266539    ,
 0.344931964069    , 0.315885862814    , 0.283982784753    , 0.259048561097    ,
 0.236800885082    , 0.207264767285    , 0.171351664624    , 0.142550234893    ,
 0.131659349847    , 0.135137202318    , 0.141454158302    , 0.145468542814    ,
 0.151388284365    , 0.162655165779    , 0.175668443864    , 0.185414619753    ,
 0.191524610365    , 0.196053380113    , 0.200011030458    , 0.20469663288     ,
 0.212683717558    , 0.225468778933    , 0.243789195693    , 0.273404700494    ,
 0.328763069987    , 0.426261021811    , 0.569446967275    , 0.739194941735    ,
 0.901835074907    , 1.03242688646     , 1.13207061315     , 1.22519323012     ,
 1.34891199002     , 1.55105718889     , 1.89447821627     , 2.45717975051     ,
 3.32297394791     , 4.5604091219      , 6.19368708504     , 8.17704866503     ,
 10.3821160651     , 12.6129747515     , 14.6815539006     , 16.5338913574     ,
 18.3094378546     , 20.2201871463     , 22.3278257324     , 24.4427132655     ,
 26.26614266       , 27.6408025336     , 28.6447401132     , 29.4506729869     ,
 30.1449405754     , 30.67422971       , 30.8848895387     , 30.5885211934     ,
 29.6505404677     , 28.0725858532     , 26.0221559772     , 23.790840216      ,
 21.6678045931     , 19.7813951819     , 18.0621108304     , 16.3840687566     ,
 14.7178620878     , 13.1239576217     , 11.6390685876     , 10.2233139002     ,
 8.82404667105     , 7.46325331641     , 6.24070324114     , 5.24960763947     ,
 4.49295149959     , 3.8791143881      , 3.29783599987     , 2.706395748       ,
 2.14658901598     , 1.6837647867      , 1.34100182998     , 1.09370043387     ,
 0.90782324836     , 0.763955888567    , 0.650544704948    , 0.55500467168     ,
 0.470414554308    , 0.40373896554     , 0.369760293229    , 0.375560483527    ,
 0.410917953659    , 0.452275775995    , 0.475505007148    , 0.468491616741    ,
 0.437969103787    , 0.406189720396    , 0.393957152061    , 0.399283774906    ,
 0.395232680163    , 0.356283527739    , 0.286066587556    , 0.213590569696    ,
 0.164568066979    , 0.141867215823    , 0.130905600297    , 0.116830537679    ,
 0.0949534706617   , 0.0692879646751   , 0.0462001145635   , 0.0303109121919   ,
 0.0233086408625   , 0.0236963360014   , 0.0276993659831   , 0.0323101198113   ,
 0.0382850344589   , 0.048947715236    , 0.0648585388847   , 0.0806552541019   ,
 0.0893791385952   , 0.0900050042425   , 0.0877783668405   , 0.0859422243226   ,
 0.0807280573234   , 0.0671717047487   , 0.0468572478866   , 0.026792107226    ,
 0.0125412071734   , 0.00486501321483  , 0.00160290426504  , 0.000474661929358 ,
 0.000152271094811 , 7.59614688959e-05 , 5.8501389488e-05  , 5.68681613698e-05 ,
 9.19088682624e-05 , 0.000267881471527 , 0.000897416119343 , 0.00266364711785  ,
 0.00647467471335  , 0.0126041224155   , 0.0196268157185   , 0.0248741088068   ,
 0.0270959831718   , 0.0286979215491   , 0.0340500003226   , 0.044664672708    ,
 0.0569610182657   , 0.0668960809222   , 0.07714069019     , 0.0966552693317   ,
 0.138060737328    , 0.17691295346     , 0.205058576436    , 0.210529949298    ,
 0.196256517127    , 0.174410580441    , 0.15324553076     , 0.134531094823    ,
 0.12213352582     , 0.124924806081    , 0.14781106366     , 0.183956188965    ,
 0.218376768836    , 0.237010398447    , 0.232939196035    , 0.210200243754    ,
 0.1861693191      , 0.187180362281    , 0.233353853213    , 0.320418149206    ,
 0.416433533584    , 0.482261125225    , 0.499605589246    , 0.480644098096    ,
 0.452062835503    , 0.430647578911    , 0.414389007106    , 0.395953091224    ,
 0.378730152855    , 0.373165195554    , 0.379392042463    , 0.381799375023    ,
 0.364523550503    , 0.328507821735    , 0.288844025352    , 0.256584910775    ,
 0.228583342724    , 0.197210823514    , 0.164919374402    , 0.14362452578     ,
 0.140962074882    , 0.152022793337    , 0.166170460097    , 0.178801349445    ,
 0.192751657581    , 0.209990483857    , 0.227708513012    , 0.242891135619    ,
 0.254914831159    , 0.262243417364    , 0.262173867987    , 0.256642725661    ,
 0.254034927137    , 0.262468200032    , 0.285331700472    , 0.326572457689    ,
 0.395664395536    , 0.50044002827     , 0.634121390425    , 0.774401042413    ,
 0.900527492762    , 1.01164498937     , 1.12579451245     , 1.26537628645     ,
 1.45465118777     , 1.73392945074     , 2.16872228145     , 2.84203803525     ,
 3.8366961372      , 5.21073248709     , 6.96647061801     , 9.02858208985     ,
 11.2484349047     , 13.4377986657     , 15.4381807465     , 17.2150933624     ,
 18.8937092507     , 20.6535774079     , 22.5499421843     , 24.4354159576     ,
 26.06389982       , 27.2746587189     , 28.0776010147     , 28.5844754927     ,
 28.8925022056     , 29.0106319283     , 28.8373082827     , 28.2123550017     ,
 27.0402268241     , 25.387119746      , 23.4734454877     , 21.5789186385     ,
 19.9057781254     , 18.4681757614     , 17.110904761      , 15.6704458443     ,
 14.1235021748     , 12.5679972638     , 11.0841443386     , 9.66066908156     ,
 8.26179659933     , 6.92176218268     , 5.74288374193     , 4.81330004758     ,
 4.13619744625     , 3.62412697891     , 3.15877748487     , 2.67348779927     ,
 2.18611231878     , 1.75369710787     , 1.40924929419     , 1.14899473892     ,
 0.958837740896    , 0.827534101978    , 0.736382697713    , 0.656971332052    ,
 0.571180179159    , 0.489421996024    , 0.441008033528    , 0.44400093079     ,
 0.485540533796    , 0.530460594501    , 0.546325423683    , 0.521863948508    ,
 0.469171019522    , 0.413694594009    , 0.376724422491    , 0.358177564543    ,
 0.33647289018     , 0.291514753887    , 0.227054845721    , 0.166035770571    ,
 0.127114371534    , 0.11054466155     , 0.103569415851    , 0.0936268509021   ,
 0.076305070486    , 0.0548696772147   , 0.0355370637012   , 0.0232997915289   ,
 0.0199710469094   , 0.0238718915433   , 0.0310298772564   , 0.0382847294957   ,
 0.046217899773    , 0.0577824052843   , 0.0729209328839   , 0.0861257174839   ,
 0.0918010593295   , 0.0915073001065   , 0.0922903120151   , 0.0964123348786   ,
 0.0965042852759   , 0.0841195996815   , 0.0603906836076   , 0.0348984742468   ,
 0.0161274312622   , 0.00598255785608  , 0.00183761279936  , 0.00055475856584  ,
 0.000267149667031 , 0.000218026108816 , 0.00019172354142  , 0.000178916160714 ,
 0.000253103140217 , 0.000583016399169 , 0.00160905094325  , 0.00430929074195  ,
 0.0100463826417   , 0.0193303858686   , 0.0301251888584   , 0.0381762092846   ,
 0.040598251664    , 0.0394677850215   , 0.0406776077089   , 0.0482537740033   ,
 0.0603124996987   , 0.0723283961288   , 0.084820721024    , 0.105043999644    ,
 0.146990775382    , 0.180182774126    , 0.207752725394    , 0.222111855124    ,
 0.224225972263    , 0.219341962621    , 0.209656286674    , 0.19662260207     ,
 0.189411392857    , 0.20281481984     , 0.242473454996    , 0.295795309471    ,
 0.339870525777    , 0.355969467863    , 0.33797854944     , 0.295437068313    ,
 0.254024946466    , 0.248168938336    , 0.301555530154    , 0.405772359051    ,
 0.518320143225    , 0.588581762959    , 0.591796733929    , 0.542029679881    ,
 0.475409895444    , 0.420425660915    , 0.382874288253    , 0.357138042926    ,
 0.343528885813    , 0.346569773528    , 0.360420092951    , 0.366875270567    ,
 0.351586787614    , 0.317753194488    , 0.280132495003    , 0.248112248697    ,
 0.219307446475    , 0.18922338052     , 0.16137108154     , 0.144724034708    ,
 0.144264503613    , 0.157306028695    , 0.178224225975    , 0.203917856271    ,
 0.233319779258    , 0.264017182423    , 0.292702514201    , 0.317478233813    ,
 0.336039856374    , 0.343044919042    , 0.334521695476    , 0.316263113533    ,
 0.303412272341    , 0.308979343291    , 0.336757471266    , 0.387554792231    ,
 0.464843535812    , 0.566892064836    , 0.67715076697     , 0.772858525269    ,
 0.849251145505    , 0.932290462534    , 1.06133021948     , 1.26145385215     ,
 1.54203414575     , 1.92379382706     , 2.46087412966     , 3.2362667098      ,
 4.33723331131     , 5.8202793401      , 7.67395608323     , 9.80383933991     ,
 12.0583203172     , 14.2745786144     , 16.3209045531     , 18.1422614993     ,
 19.7906743458     , 21.384793234      , 23.0019275577     , 24.5917122165     ,
 25.9898655103     , 27.01785039       , 27.5841017564     , 27.7249949051     ,
 27.5725721419     , 27.2476496908     , 26.741748513      , 25.9241583212     ,
 24.6932943076     , 23.111002844      , 21.3935805602     , 19.7907101645     ,
 18.445748359      , 17.3188240295     , 16.2290721201     , 15.0010684225     ,
 13.5989483523     , 12.1185025803     , 10.6564286962     , 9.22725193209     ,
 7.82099152797     , 6.49129007285     , 5.34640108324     , 4.47084802276     ,
 3.86698771949     , 3.44844107337     , 3.08644960991     , 2.69060030722     ,
 2.25780362305     , 1.8422496214      , 1.4927569794      , 1.22844219173     ,
 1.0501617435      , 0.945101340381    , 0.880324899204    , 0.812316150199    ,
 0.717274430657    , 0.612536717518    , 0.541576244754    , 0.533038851136    ,
 0.573259295941    , 0.617044219415    , 0.622286931266    , 0.5757324552      ,
 0.494245882691    , 0.409054710227    , 0.344919980781    , 0.304292844986    ,
 0.26913637923     , 0.222119381191    , 0.165214288924    , 0.115055491082    ,
 0.0843641676457   , 0.0721337139825   , 0.0683042343144   , 0.0630477350957   ,
 0.0522670947776   , 0.0378717052254   , 0.0248928603166   , 0.0180429139785   ,
 0.0193813089569   , 0.0273701992752   , 0.0376661074401   , 0.0463696977922   ,
 0.0535660042623   , 0.0623178904419   , 0.073255720121    , 0.0823779026919   ,
 0.086621823244    , 0.09006780685     , 0.100138375093    , 0.115953237159    ,
 0.124622633232    , 0.113438881577    , 0.0837876714184   , 0.0494337620283   ,
 0.0232081197647   , 0.00875209657606  , 0.00286025685987  , 0.00116045775248  ,
 0.000895898232434 , 0.000883028924019 , 0.000795283073063 , 0.000706128263126 ,
 0.000840123842585 , 0.00145455454155  , 0.00297184112792  , 0.00636674226644  ,
 0.013208469655    , 0.0243874239302   , 0.037969691332    , 0.0490018870192   ,
 0.0531823560016   , 0.0514385297282   , 0.050037737414    , 0.0551212439464   ,
 0.0671518249488   , 0.0820071675399   , 0.097825910279    , 0.118284071935    ,
 0.171070112089    , 0.198300166305    , 0.225211776091    , 0.249930805055    ,
 0.270743530603    , 0.284455655152    , 0.287711527571    , 0.284475105397    ,
 0.291311024946    , 0.327266075775    , 0.393513183304    , 0.466123638417    ,
 0.511806133242    , 0.509555348682    , 0.460182501563    , 0.384751348819    ,
 0.319250989864    , 0.303786068988    , 0.362106170736    , 0.480449446799    ,
 0.607107403811    , 0.681795932819    , 0.674069061487    , 0.599583080349    ,
 0.502469861408    , 0.420184061808    , 0.363355707382    , 0.326592073441    ,
 0.307919170497    , 0.308901046477    , 0.322260561693    , 0.331431584538    ,
 0.324472157135    , 0.303086868155    , 0.276110811829    , 0.24831221175     ,
 0.21892221067     , 0.188471129667    , 0.162128637977    , 0.145901118872    ,
 0.142991528609    , 0.154616794611    , 0.181225387234    , 0.22079589165     ,
 0.267247001134    , 0.313137777237    , 0.354106929562    , 0.388071298888    ,
 0.410206837125    , 0.413310831119    , 0.396500261209    , 0.372277885697    ,
 0.360479006718    , 0.372986245505    , 0.408230658057    , 0.461590697247    ,
 0.532138145854    , 0.613356657897    , 0.685738744957    , 0.731540885976    ,
 0.761693779285    , 0.823360211232    , 0.972950060539    , 1.23979843848     ,
 1.62135293961     , 2.11599190905     , 2.75796606589     , 3.62226249974     ,
 4.79864745164     , 6.34911167788     , 8.26645471746     , 10.4635074178     ,
 12.8072523511     , 15.1590178932     , 17.381201709      , 19.344493784      ,
 20.9819445031     , 22.3446999213     , 23.56824528       , 24.7465646819     ,
 25.8245013337     , 26.6112743567     , 26.9113588823     , 26.6817222525     ,
 26.0864338414     , 25.3639175685     , 24.6119089478     , 23.7294202898     ,
 22.5784476965     , 21.1673697895     , 19.6731100404     , 18.315123588      ,
 17.2063623258     , 16.2886636076     , 15.3843258519     , 14.3243737753     ,
 13.063704573      , 11.6822209189     , 10.2735889254     , 8.86662910832     ,
 7.47393377262     , 6.16748265251     , 5.06156294913     , 4.23793219851     ,
 3.69654775005     , 3.34986914446     , 3.06265865616     , 2.73188139077     ,
 2.3437508432      , 1.95136408988     , 1.61288110591     , 1.36114060604     ,
 1.20444363396     , 1.12405970319     , 1.07330885569     , 0.999991902458    ,
 0.882669558305    , 0.74791335887     , 0.64884585482     , 0.620042192661    ,
 0.647627262809    , 0.680401240885    , 0.669264344655    , 0.599059898178    ,
 0.491047098763    , 0.382380431746    , 0.300559879809    , 0.248142186376    ,
 0.207754391693    , 0.163133300592    , 0.114569304919    , 0.0738438607498   ,
 0.0493849877248   , 0.0396778279693   , 0.0372856783537   , 0.0351218506332   ,
 0.0298239963404   , 0.0221460353488   , 0.015467043483    , 0.0135132578076   ,
 0.0182618043613   , 0.0284794556526   , 0.0398549386519   , 0.0480478189456   ,
 0.0526242392537   , 0.0567003052801   , 0.0620822737092   , 0.0672044798097   ,
 0.0719157746029   , 0.0819796515774   , 0.103760617678    , 0.132441640364    ,
 0.149963156576    , 0.14021284525     , 0.105274167952    , 0.0629127936324   ,
 0.0299569577413   , 0.0116836538148   , 0.00443691074569  , 0.00271756779741  ,
 0.00281212784777  , 0.00295102535138  , 0.0026599840216   , 0.00228713588042  ,
 0.00248898666596  , 0.00370317077858  , 0.00603805672014  , 0.00984772676517  ,
 0.0163844927918   , 0.0270840716774   , 0.0412340154514   , 0.0546627442237   ,
 0.0622838835105   , 0.0630653074318   , 0.0621968653544   , 0.0671263449622   ,
 0.0809353254365   , 0.100686418448    , 0.122455781822    , 0.145592908506    ,
 0.216976292184    , 0.244654817841    , 0.276646753332    , 0.314331704299    ,
 0.352714927061    , 0.382573403453    , 0.399535737749    , 0.413966144794    ,
 0.44995242976     , 0.525827505901    , 0.630234417358    , 0.72136118678     ,
 0.754539307745    , 0.711678930155    , 0.608729431374    , 0.484244663645    ,
 0.384339944059    , 0.349403579418    , 0.39798453747     , 0.510934997805    ,
 0.633186810112    , 0.702756143549    , 0.688609948822    , 0.607112002081    ,
 0.503949915521    , 0.417337959135    , 0.357059288411    , 0.316387559654    ,
 0.292806422381    , 0.288688938308    , 0.29957269573     , 0.313092530096    ,
 0.318992054961    , 0.314172548672    , 0.298469130995    , 0.271470607033    ,
 0.235443233624    , 0.19744928652     , 0.165587505532    , 0.144587680845    ,
 0.137124706553    , 0.147425984536    , 0.17924165182     , 0.229458281261    ,
 0.287248089234    , 0.341876440714    , 0.388901662594    , 0.426160837169    ,
 0.447568714531    , 0.447143947018    , 0.429884210365    , 0.414855691463    ,
 0.422788457156    , 0.458598877072    , 0.50992257653     , 0.563523805971    ,
 0.614696326992    , 0.658099096006    , 0.681553805779    , 0.680984390437    ,
 0.682691579529    , 0.744852461572    , 0.928669363715    , 1.26256083482     ,
 1.73623259282     , 2.33391598985     , 3.07473048608     , 4.02291632629     ,
 5.26267842861     , 6.85672856587     , 8.81048470177     , 11.0645428845     ,
 13.5196150972     , 16.0526974889     , 18.4909812545     , 20.602353171      ,
 22.1917781324     , 23.2543786627     , 24.001276458      , 24.6790811935     ,
 25.3448238096     , 25.8133148569     , 25.8209758041     , 25.2699162943     ,
 24.3419286614     , 23.3533281388     , 22.4785908558     , 21.6374425908     ,
 20.6490318803     , 19.4548605381     , 18.1845328283     , 17.0371430483     ,
 16.1143948394     , 15.3499170665     , 14.5705801984     , 13.6237370833     ,
 12.4744188563     , 11.1964173247     , 9.87251416463     , 8.5312096341      ,
 7.19484120897     , 5.94328618899     , 4.89084063473     , 4.11612441937     ,
 3.61861145911     , 3.31334630761     , 3.0685126078      , 2.78336436187     ,
 2.44336029491     , 2.0971453433      , 1.79809235438     , 1.57819437632     ,
 1.44597800756     , 1.3770744134      , 1.31625783906     , 1.21167450123     ,
 1.0537183062      , 0.881414724568    , 0.752222374775    , 0.698941067656    ,
 0.704975874785    , 0.716854590415    , 0.683685514645    , 0.590876595679    ,
 0.46353430076     , 0.342697617025    , 0.2558641215      , 0.202664885643    ,
 0.164023990543    , 0.124084906637    , 0.0826846679799   , 0.0489203608568   ,
 0.0285713096869   , 0.0198927236275   , 0.0174094574634   , 0.0162711799466   ,
 0.0140431215863   , 0.0107964685284   , 0.00838690249941  , 0.00923291620239  ,
 0.0148332235861   , 0.0242927101476   , 0.0340172875128   , 0.0401084981746   ,
 0.0418941050599   , 0.0420996570301   , 0.0431929792377   , 0.0456715630126   ,
 0.0514381917095   , 0.0664519811623   , 0.0952026958563   , 0.130426399202    ,
 0.152446992302    , 0.14467602493     , 0.109634977319    , 0.0661194006283   ,
 0.0320590367511   , 0.0134190969359   , 0.00670598540168  , 0.00613835812707  ,
 0.00735195297842  , 0.00787155216381  , 0.00705690413566  , 0.00590751180573  ,
 0.00605615809222  , 0.00834938387367  , 0.012206338129    , 0.0165598716661   ,
 0.0217213936943   , 0.0298295211751   , 0.0424021095152   , 0.0573068330645   ,
 0.0693736766568   , 0.0754322473704   , 0.0788357446828   , 0.087400025473    ,
 0.10596049366     , 0.132428321592    , 0.16155628509     , 0.189931231286    ,
 0.27556076749     , 0.313048899578    , 0.35969285138     , 0.41555320277     ,
 0.472284678318    , 0.519052946178    , 0.555218350551    , 0.598709464136    ,
 0.677854238583    , 0.804229765469    , 0.948247086092    , 1.04829315009     ,
 1.05172584356     , 0.949954066424    , 0.779430963961    , 0.596991182425    ,
 0.454829864063    , 0.387610792236    , 0.405191754549    , 0.485438885667    ,
 0.577996246291    , 0.628865324576    , 0.612183689084    , 0.543239676594    ,
 0.461058516554    , 0.395469064398    , 0.350510011391    , 0.318217220478    ,
 0.298281597734    , 0.296761679438    , 0.312958441286    , 0.336983206914    ,
 0.357590843142    , 0.365951979779    , 0.354520731653    , 0.320139683603    ,
 0.269240884905    , 0.215320540081    , 0.170132681822    , 0.139389259291    ,
 0.126631466778    , 0.137162063222    , 0.173968969283    , 0.230378121152    ,
 0.291598186391    , 0.345655415097    , 0.389380479561    , 0.422157023395    ,
 0.439654038857    , 0.439424664348    , 0.431366912847    , 0.437859404976    ,
 0.478229156797    , 0.550225394929    , 0.630377365216    , 0.694021622097    ,
 0.729124184103    , 0.732583238406    , 0.707379765964    , 0.67196609427     ,
 0.668912769578    , 0.757236559427    , 0.987919951772    , 1.37943942599     ,
 1.91830245739     , 2.5914033815      , 3.42156973989     , 4.47038328354     ,
 5.80745839925     , 7.47570911085     , 9.47495664587     , 11.7658007692     ,
 14.2800060379     , 16.9070098133     , 19.4448820122     , 21.5874748765     ,
 23.0530824711     , 23.8019562671     , 24.0992039592     , 24.2939636316     ,
 24.520562838      , 24.6176529103     , 24.3183269792     , 23.5248355939     ,
 22.4275882145     , 21.354154203      , 20.4899449708     , 19.754456004      ,
 18.9409015803     , 17.9468177324     , 16.8667055469     , 15.8860180475     ,
 15.1023348613     , 14.4442585175     , 13.7422191179     , 12.8652134332     ,
 11.8026802544     , 10.632766649      , 9.42533955657     , 8.19834706775     ,
 6.9701794153      , 5.81332494032     , 4.83102785117     , 4.09744336556     ,
 3.61826655762     , 3.32151160649     , 3.09087248402     , 2.83897229241     ,
 2.55513798097     , 2.27812722257     , 2.04379147288     , 1.87096027479     ,
 1.76294764497     , 1.6915654224      , 1.59869112092     , 1.44012230704     ,
 1.22548634967     , 1.00996706037     , 0.852414753297    , 0.777110248939    ,
 0.760806672263    , 0.749613068196    , 0.694867566006    , 0.583739984049    ,
 0.443056347511    , 0.315376892018    , 0.227538450391    , 0.176464532688    ,
 0.141162790687    , 0.105709473138    , 0.0696958006832   , 0.0405299469978   ,
 0.0222796562309   , 0.0131579784993   , 0.00919998657584  , 0.00729645802173  ,
 0.00585530849529  , 0.00457807817643  , 0.00415066635113  , 0.00574242710872  ,
 0.0101605217727   , 0.01678208721     , 0.0231870609447   , 0.0266787964549   ,
 0.0267278941513   , 0.0253113407309   , 0.024681265806    , 0.0262018593633   ,
 0.0322714274122   , 0.047544536855    , 0.0745495570087   , 0.106241493766    ,
 0.126071573195    , 0.120538852248    , 0.0920176964678   , 0.0563323626878   ,
 0.0286367769651   , 0.0142250283906   , 0.0104856708596   , 0.0124769341021   ,
 0.0156567583538   , 0.0167336370118   , 0.0148636979116   , 0.012133983832    ,
 0.011804786448    , 0.0154498797506   , 0.0215312001211   , 0.0269632162693   ,
 0.0307267699274   , 0.035777083976    , 0.0462468587882   , 0.062356206721    ,
 0.0791782085267   , 0.0919343634566   , 0.102422145976    , 0.117996266676    ,
 0.14331244466     , 0.175670543218    , 0.209538450832    , 0.24240617861     ,
 0.33111324591     , 0.385892320292    , 0.456033861647    , 0.537381155086    ,
 0.619178218006    , 0.691439645198    , 0.756657249272    , 0.835493619997    ,
 0.954880789506    , 1.11772333782     , 1.2800697285      , 1.36869886068     ,
 1.33128798926     , 1.17218537702     , 0.944580729524    , 0.715147171923    ,
 0.534442379481    , 0.428160313407    , 0.399079450262    , 0.427207318655    ,
 0.473657829885    , 0.498249693739    , 0.482556102695    , 0.438340914886    ,
 0.39237404482     , 0.360973820644    , 0.340534607611    , 0.323099459065    ,
 0.313159342668    , 0.322267230151    , 0.352527482664    , 0.392811849814    ,
 0.427616945719    , 0.442940684124    , 0.427805740902    , 0.379894224735    ,
 0.310292933531    , 0.237372586635    , 0.175797433953    , 0.133170552065    ,
 0.114556760274    , 0.12510587638     , 0.165057936172    , 0.223767231802    ,
 0.283735641651    , 0.332606989827    , 0.368431773368    , 0.393049568527    ,
 0.405927332961    , 0.408261450359    , 0.411464017168    , 0.437788045602    ,
 0.50652717147     , 0.614759947581    , 0.733966605384    , 0.827486609251    ,
 0.869187445429    , 0.852445773935    , 0.796077085308    , 0.745306836791    ,
 0.759359669579    , 0.890944066124    , 1.16987071288     , 1.5984821774      ,
 2.16641554576     , 2.88304885052     , 3.79967843671     , 4.99023305021     ,
 6.50263675519     , 8.32995870024     , 10.4256430931     , 12.7341894671     ,
 15.1975994191     , 17.7233098322     , 20.1257205733     , 22.1063831041     ,
 23.374895626      , 23.8755155564     , 23.8694672341     , 23.7164309735     ,
 23.5685162507     , 23.2991833939     , 22.7038971553     , 21.746961506      ,
 20.6288107902     , 19.6254444416     , 18.8607626995     , 18.2307979993     ,
 17.535314155      , 16.6730319588     , 15.7214836105     , 14.8452327698     ,
 14.1322005586     , 13.5156912319     , 12.8442909943     , 12.0150672775     ,
 11.0398814425     , 9.99724623311     , 8.94109982609     , 7.87426017685     ,
 6.80104596105     , 5.77233000019     , 4.86994978049     , 4.16360180791     ,
 3.67447230478     , 3.35586464169     , 3.11653596786     , 2.88677669933     ,
 2.65924706036     , 2.4588687818      , 2.29787884575     , 2.17574453218     ,
 2.0879414691      , 2.00543953134     , 1.87249597633     , 1.65535050738     ,
 1.383077488       , 1.12718862874     , 0.947876588293    , 0.859269420777    ,
 0.829578193468    , 0.804209692958    , 0.736674324461    , 0.613709360956    ,
 0.460696027119    , 0.321200920741    , 0.224655429683    , 0.169501561145    ,
 0.134753575645    , 0.103517970535    , 0.07319999934     , 0.0482244643853   ,
 0.0306721515263   , 0.0190397740193   , 0.0113182954139   , 0.00641671304836  ,
 0.00368755114085  , 0.00257764630918  , 0.00279544706378  , 0.00434880507794  ,
 0.00719709521045  , 0.0107450859572   , 0.013702316167    , 0.0148264232523   ,
 0.0140864874333   , 0.0128270319619   , 0.0126679338056   , 0.0148224996464   ,
 0.0208465593292   , 0.0330782307005   , 0.0522466126695   , 0.0733958575337   ,
 0.0860844620077   , 0.0821213395665   , 0.0635576116503   , 0.0409900689607   ,
 0.0243324340171   , 0.0170006870751   , 0.0174075813031   , 0.0221908222557   ,
 0.0272050550743   , 0.0284885005411   , 0.0249698877454   , 0.0199299600114   ,
 0.0184598527199   , 0.022994136802    , 0.0311204605266   , 0.0379049523447   ,
 0.0412349437561   , 0.0449070585035   , 0.0551874960884   , 0.0738534400435   ,
 0.0958899453869   , 0.115492739095    , 0.133608644945    , 0.156692305207    ,
 0.187624857202    , 0.221998386263    , 0.255270534793    , 0.289493367718    ,
 0.379190777451    , 0.453381907747    , 0.548723662106    , 0.658732784412    ,
 0.77284924952     , 0.880657598553    , 0.9805823235      , 1.08658346269     ,
 1.21946590102     , 1.37863878779     , 1.52024665143     , 1.576067159       ,
 1.50341522937     , 1.31621047189     , 1.07056743099     , 0.827256636528    ,
 0.626396194995    , 0.485603359836    , 0.407137416472    , 0.379707384715    ,
 0.379385085481    , 0.379954778674    , 0.368522988443    , 0.35119879748     ,
 0.341370889847    , 0.341780958332    , 0.341685646875    , 0.334048270231    ,
 0.329527962543    , 0.346438109998    , 0.389660338058    , 0.445147547092    ,
 0.491405727839    , 0.509698547789    , 0.488282496891    , 0.427939222053    ,
 0.344048402175    , 0.257592659816    , 0.184036307218    , 0.131679845097    ,
 0.106467606649    , 0.113350682486    , 0.151089806078    , 0.207709662017    ,
 0.265345325157    , 0.311326353609    , 0.343042093492    , 0.362957492299    ,
 0.373097546879    , 0.376428301253    , 0.383247382712    , 0.414688895755    ,
 0.493712631005    , 0.625430939027    , 0.785470077097    , 0.928294641854    ,
 1.00854965126     , 1.00721312851     , 0.952126243251    , 0.911933329541    ,
 0.960224507251    , 1.14039514147     , 1.45850039775     , 1.90187889086     ,
 2.47127398629     , 3.21348190289     , 4.22537313703     , 5.60352091167     ,
 7.36860156937     , 9.43949064658     , 11.6859700406     , 13.9977281985     ,
 16.3021453561     , 18.5332174755     , 20.5776665549     , 22.2347242106     ,
 23.2800445182     , 23.6480316024     , 23.5281736579     , 23.2018270778     ,
 22.7893411824     , 22.2065419754     , 21.3521175803     , 20.2892020654     ,
 19.2316420795     , 18.3689672816     , 17.7192144747     , 17.1434781402     ,
 16.480720081      , 15.6724568392     , 14.789680675      , 13.9569056124     ,
 13.2391460221     , 12.5887384369     , 11.8981168251     , 11.1018244929     ,
 10.2235809606     , 9.3290301849      , 8.45069219171     , 7.57305847542     ,
 6.67946407572     , 5.79197143566     , 4.96906024803     , 4.27943441935     ,
 3.76562692596     , 3.41115403266     , 3.15111436917     , 2.93130848142     ,
 2.74560342966     , 2.60581682958     , 2.50284164155     , 2.41753123565     ,
 2.33812962288     , 2.23922889956     , 2.0728647         , 1.81403521243     ,
 1.50270116952     , 1.22051472374     , 1.03015084386     , 0.939809116639    ,
 0.910943740696    , 0.886467018548    , 0.818283686262    , 0.688930717106    ,
 0.520697187439    , 0.360089835317    , 0.243945553834    , 0.177098237791    ,
 0.140709565084    , 0.115689281661    , 0.0942712729016   , 0.075241579929    ,
 0.0574880909223   , 0.0401386742932   , 0.0244865925353   , 0.0128587494037   ,
 0.00630101194597  , 0.00412549801579  , 0.00491671250249  , 0.0072263274022   ,
 0.00966611233044  , 0.0110836383455   , 0.0109438998324   , 0.00953238834668  ,
 0.00784524070742  , 0.0072585238985   , 0.00904378968056  , 0.0138844549528   ,
 0.0216798720361   , 0.0317465310374   , 0.0428153131092   , 0.0522559964206   ,
 0.0560920354145   , 0.0518830295876   , 0.0419957611918   , 0.0322717737977   ,
 0.0270297600303   , 0.0266908250834   , 0.0298328127661   , 0.0349265491301   ,
 0.0393254736651   , 0.0393665869124   , 0.0338930073      , 0.0267195922623   ,
 0.0238566808321   , 0.0281551782564   , 0.0368325985289   , 0.0443334446579   ,
 0.0484455999938   , 0.0536899089032   , 0.067270127915    , 0.0910873280017   ,
 0.119229726961    , 0.144871729181    , 0.168430846058    , 0.195708668625    ,
 0.228257670559    , 0.260958126146    , 0.291503336395    , 0.327219034518    ,
 0.434605669554    , 0.523459304002    , 0.633193952327    , 0.761341409427    ,
 0.902208410435    , 1.04289345337     , 1.16988063363     , 1.28254350337     ,
 1.39389483269     , 1.50779475544     , 1.59613319316     , 1.61102132951     ,
 1.52501711909     , 1.35406270338     , 1.14130597588     , 0.926454499387    ,
 0.73224487323     , 0.570936618838    , 0.451818698058    , 0.378052518445    ,
 0.341147391449    , 0.325218927533    , 0.319077478254    , 0.322518537191    ,
 0.338145891851    , 0.35821569013     , 0.366278111216    , 0.356294314725    ,
 0.34498191524     , 0.357741212878    , 0.403212415775    , 0.465655029665    ,
 0.518281254799    , 0.538030509002    , 0.513224658007    , 0.448190106238    ,
 0.361281586237    , 0.273345512842    , 0.197724056273    , 0.140927107063    ,
 0.108365904333    , 0.105582740475    , 0.133160197856    , 0.182184171406    ,
 0.237488232857    , 0.286146312457    , 0.32215873999     , 0.344627100334    ,
 0.354556211862    , 0.354796078914    , 0.354527296815    , 0.374827339677    ,
 0.444577390108    , 0.581922457791    , 0.774383891491    , 0.974483152617    ,
 1.11898231337     , 1.17035185611     , 1.15460250596     , 1.15343872066     ,
 1.24935119837     , 1.4774062816      , 1.82600475325     , 2.27554184724     ,
 2.84429679136     , 3.6186992127      , 4.73892795097     , 6.31972159361     ,
 8.35082420579     , 10.6745865773     , 13.0728521155     , 15.3711487437     ,
 17.4718230418     , 19.3362564066     , 20.9468182734     , 22.2420013344     ,
 23.0972679066     , 23.4325396051     , 23.3221390763     , 22.9244852499     ,
 22.3168922747     , 21.4732483033     , 20.4082114503     , 19.2805315803     ,
 18.3078079864     , 17.5858594698     , 17.0231588494     , 16.4501645022     ,
 15.7612264883     , 14.9580421914     , 14.1068085814     , 13.2782834977     ,
 12.5046965042     , 11.7657587326     , 11.0154615331     , 10.233225305      ,
 9.44703154882     , 8.69913625972     , 7.99531635002     , 7.29880860126     ,
 6.5706859805      , 5.8092213667      , 5.05935902546     , 4.39446681        ,
 3.87498958377     , 3.50501627972     , 3.23512117404     , 3.01871975773     ,
 2.84980127026     , 2.73424899314     , 2.65268449962     , 2.5748703755      ,
 2.48449620765     , 2.36305567411     , 2.174194353       , 1.89828400496     ,
 1.57447237183     , 1.28473336355     , 1.09403900067     , 1.01050770359     ,
 0.992686305837    , 0.979782163612    , 0.918672069936    , 0.785858049444    ,
 0.601254940462    , 0.41627863586     , 0.27723695163     , 0.197107815971    ,
 0.160091034689    , 0.144393636108    , 0.13546919438     , 0.124576501121    ,
 0.105998920159    , 0.0793074045555   , 0.0504443283977   , 0.0272098492673   ,
 0.0138179563178   , 0.00986303580404  , 0.0124594158723   , 0.0178491622776   ,
 0.0220944085433   , 0.0223993763611   , 0.0186059653356   , 0.013036988256    ,
 0.00878447202952  , 0.00834828267522  , 0.0132974006029   , 0.0237459499872   ,
 0.0372976728129   , 0.0493836394974   , 0.0559722965821   , 0.0559619480258   ,
 0.0508963675245   , 0.0438002021329   , 0.0386544470836   , 0.0385782589799   ,
 0.0429206576258   , 0.0476813880468   , 0.0499455627664   , 0.0501656607634   ,
 0.0491504673398   , 0.0455569920833   , 0.0385687285133   , 0.0311106031907   ,
 0.0280047324149   , 0.0313523380045   , 0.0386503061141   , 0.0455520852244   ,
 0.0510597215461   , 0.0601194165024   , 0.0795336557895   , 0.110192245401    ,
 0.144724343081    , 0.174862418722    , 0.2002532896      , 0.226938304553    ,
 0.257776871813    , 0.289973343892    , 0.324022562974    , 0.368953839787    ,
 0.522232025673    , 0.615487595047    , 0.717436554796    , 0.83674992269     ,
 0.978706678815    , 1.12975917024     , 1.26343378439     , 1.36334651533     ,
 1.43492845485     , 1.48916704718     , 1.51901317016     , 1.50205243865     ,
 1.42680932203     , 1.30635947645     , 1.16311135965     , 1.00877932716     ,
 0.845398909842    , 0.68127223347     , 0.537065850801    , 0.433270177984    ,
 0.374788224167    , 0.350397798817    , 0.346527703427    , 0.358098296846    ,
 0.382527584554    , 0.406629327555    , 0.410080618273    , 0.387327878134    ,
 0.359709862231    , 0.358260562919    , 0.395172999911    , 0.454466230785    ,
 0.505989770732    , 0.524029319887    , 0.498480566152    , 0.437651375522    ,
 0.361071089031    , 0.286047624013    , 0.220288218052    , 0.165696732271    ,
 0.12586756141     , 0.10823586234     , 0.118809383844    , 0.155668518255    ,
 0.208601266725    , 0.264205443045    , 0.310631929937    , 0.339987088422    ,
 0.349579367909    , 0.342331976276    , 0.328438801325    , 0.329690483721    ,
 0.379037318911    , 0.506342962627    , 0.714671233239    , 0.963702767125    ,
 1.18121787739     , 1.31181421975     , 1.36939791259     , 1.43412794773     ,
 1.5889659599      , 1.86414800778     , 2.24299164636     , 2.7113673373      ,
 3.30697304023     , 4.14191558397     , 5.37502543478     , 7.11935417599     ,
 9.33521876188     , 11.8151091991     , 14.2914646782     , 16.556470074      ,
 18.4967635118     , 20.0845981701     , 21.363621608      , 22.3795310621     ,
 23.0940210682     , 23.4135257835     , 23.3016381175     , 22.8055420088     ,
 21.9863382583     , 20.9025784167     , 19.6822786894     , 18.5458576783     ,
 17.6835586346     , 17.0979948744     , 16.6093409912     , 16.0299394792     ,
 15.3048879083     , 14.4895982557     , 13.6490326618     , 12.8079690352     ,
 11.96755984       , 11.1313029029     , 10.3123568589     , 9.53355783607     ,
 8.82270890172     , 8.19286270322     , 7.62062715906     , 7.05154083993     ,
 6.43540599994     , 5.76377887636     , 5.08262818534     , 4.47149235687     ,
 3.99551715225     , 3.65939148216     , 3.41146442896     , 3.20247380257     ,
 3.02646330279     , 2.89408634083     , 2.79162761283     , 2.68901039729     ,
 2.56782969237     , 2.41555816942     , 2.20779547445     , 1.92880317639     ,
 1.61037693247     , 1.32700496945     , 1.14263146237     , 1.06704844942     ,
 1.05919676771     , 1.05694880159     , 1.00391687013     , 0.872237261876    ,
 0.679721149358    , 0.480337755816    , 0.326244605184    , 0.236436077226    ,
 0.198625425421    , 0.190360695851    , 0.192341711322    , 0.189060780629    ,
 0.169319743374    , 0.131750253673    , 0.0867133341926   , 0.0486852670096   ,
 0.0265806889869   , 0.0211600983019   , 0.0280008867591   , 0.0399787319728   ,
 0.0488578715819   , 0.0486933209344   , 0.0394410045368   , 0.0265584478458   ,
 0.0168851789542   , 0.0153333480887   , 0.0242694850248   , 0.0430010067459   ,
 0.0661459479331   , 0.0844573120287   , 0.0904044651581   , 0.0835086794239   ,
 0.0697398071031   , 0.0572317520899   , 0.0528712238587   , 0.0590960453737   ,
 0.0709715187707   , 0.0787744477185   , 0.0765332997282   , 0.0668497864512   ,
 0.0560083866271   , 0.0471964469626   , 0.0405119301442   , 0.0364419897067   ,
 0.0361570713917   , 0.0395182864826   , 0.0447449631364   , 0.050225689953    ,
 0.0570093843854   , 0.0699266008106   , 0.0945494357174   , 0.130770708353    ,
 0.170216468836    , 0.203064318705    , 0.227827379286    , 0.25177994158     ,
 0.282095558036    , 0.32130067064     , 0.372055656631    , 0.439044242417    ,
 0.658341266739    , 0.745164173814    , 0.815409185703    , 0.893106174311    ,
 1.00047404821     , 1.13001936975     , 1.24895111603     , 1.32940610282     ,
 1.36875391676     , 1.38017482727     , 1.3712380091      , 1.33991101922     ,
 1.2881878503      , 1.22660830294     , 1.15942401588     , 1.07340648048     ,
 0.951670208221    , 0.799238694487    , 0.648581058852    , 0.536311664629    ,
 0.475498895103    , 0.451772973549    , 0.444777508501    , 0.447902774416    ,
 0.461842313769    , 0.474924758678    , 0.464969236763    , 0.425412530276    ,
 0.379524035888    , 0.361208693759    , 0.38431097203     , 0.432358741698    ,
 0.47341183355     , 0.482277453164    , 0.453976521033    , 0.402394587542    ,
 0.346672296459    , 0.297086338505    , 0.252183176834    , 0.206725419005    ,
 0.161633598801    , 0.12753720411     , 0.118492073877    , 0.141591628209    ,
 0.191948661639    , 0.25490253178     , 0.311545058635    , 0.345907334387    ,
 0.351793623435    , 0.334350170302    , 0.307038654924    , 0.291395473337    ,
 0.319330604933    , 0.426648993154    , 0.631379703816    , 0.908492820208    ,
 1.18991479897     , 1.41006972658     , 1.56498950145     , 1.71794337376     ,
 1.94095944057     , 2.26241544471     , 2.67583629003     , 3.18706451662     ,
 3.85157645199     , 4.78260834217     , 6.12007021569     , 7.94941456237     ,
 10.2106427988     , 12.692776677      , 15.1410209991     , 17.3634669583     ,
 19.2448665537     , 20.7339615253     , 21.8610200947     , 22.702190593      ,
 23.2718056257     , 23.4843143935     , 23.2432220487     , 22.5351203512     ,
 21.4444536898     , 20.1353486324     , 18.8366589455     , 17.7850690983     ,
 17.0997325473     , 16.6847264384     , 16.2968140936     , 15.7440046687     ,
 15.0080227922     , 14.1822931737     , 13.3399383977     , 12.4842706281     ,
 11.5966796301     , 10.6946853814     , 9.83473980056     , 9.07224214952     ,
 8.42684038633     , 7.87585920364     , 7.36828598825     , 6.84724639664     ,
 6.2757323054      , 5.65933434217     , 5.05106435523     , 4.52682682261     ,
 4.13866404634     , 3.87551046499     , 3.67314056448     , 3.47489435748     ,
 3.27575216966     , 3.09885492244     , 2.94785741669     , 2.80112716287     ,
 2.63851599483     , 2.44918656352     , 2.21841018317     , 1.93596996712     ,
 1.6275277955      , 1.35689307128     , 1.18101917226     , 1.10776026296     ,
 1.09854834043     , 1.09700914457     , 1.05159947401     , 0.934038281696    ,
 0.756560571839    , 0.566382219118    , 0.412069957475    , 0.314332003333    ,
 0.266448614807    , 0.251353643231    , 0.25155788316     , 0.248955490581    ,
 0.227262860486    , 0.181641937535    , 0.123793894852    , 0.0732427624784   ,
 0.0438025794892   , 0.0385016549129   , 0.0521505940837   , 0.0739356607196   ,
 0.0900355212515   , 0.090029775401    , 0.0736432446713   , 0.050396435391    ,
 0.0324199540237   , 0.0281214302625   , 0.0406528016733   , 0.0677631221217   ,
 0.100620701176    , 0.125681900699    , 0.132449863933    , 0.120611150356    ,
 0.0991229065184   , 0.0801415099086   , 0.0737665035228   , 0.0830443123331   ,
 0.0998755859226   , 0.109133254019    , 0.101507750899    , 0.0814996005641   ,
 0.0612075701824   , 0.0491671763792   , 0.0467640533648   , 0.0511779569505   ,
 0.0582701615144   , 0.0646209522864   , 0.0694522957806   , 0.0745656434405   ,
 0.0828400172069   , 0.0980942402319   , 0.124528407816    , 0.162221218231    ,
 0.203261907901    , 0.236907830531    , 0.260597538071    , 0.283434261476    ,
 0.318388819649    , 0.374413956755    , 0.454900647876    , 0.555129573274    ,
 0.83458293768     , 0.909932347381    , 0.93580138126     , 0.951676504917    ,
 1.00048597726     , 1.08814468878     , 1.1832714875      , 1.25059086232     ,
 1.27793865571     , 1.27430526067     , 1.25275021091     , 1.22298327728     ,
 1.19567671611     , 1.17977675538     , 1.1677617815      , 1.13082421966     ,
 1.04142569136     , 0.905182724798    , 0.765330931663    , 0.669414081703    ,
 0.62981584657     , 0.619172137809    , 0.605450466747    , 0.584624387511    ,
 0.570600915257    , 0.561321951688    , 0.534464436087    , 0.479353042336    ,
 0.417219335417    , 0.382137433526    , 0.388152568529    , 0.41793310493     ,
 0.4391305981      , 0.430311111692    , 0.394851586767    , 0.35323254407     ,
 0.322926232995    , 0.305122649101    , 0.287485936501    , 0.256519357387    ,
 0.210062809341    , 0.162259648958    , 0.135615199904    , 0.145745433565    ,
 0.191906704674    , 0.257821847895    , 0.318813806543    , 0.353016988959    ,
 0.352824135372    , 0.327161263098    , 0.293054912571    , 0.269649282646    ,
 0.282770787993    , 0.367814619293    , 0.554225440741    , 0.836211675104    ,
 1.16164312248     , 1.46669155033     , 1.73070804037     , 1.98852094517     ,
 2.28810172974     , 2.65456059026     , 3.10333900861     , 3.67304769354     ,
 4.43575337028     , 5.48471725892     , 6.90971107842     , 8.7494775575      ,
 10.9361370279     , 13.2983489786     , 15.6454849301     , 17.8347624147     ,
 19.7482823156     , 21.2726844058     , 22.3589356309     , 23.0512716835     ,
 23.396612626      , 23.3541596037     , 22.8353249609     , 21.8232357929     ,
 20.4490892581     , 18.9755461127     , 17.7043273239     , 16.8479673438     ,
 16.4210040151     , 16.2250798579     , 15.9750318006     , 15.4896072683     ,
 14.7783832796     , 13.9593733239     , 13.1200967703     , 12.2628670296     ,
 11.3604388072     , 10.4370730366     , 9.57710661468     , 8.85514803906     ,
 8.27279192077     , 7.76650069625     , 7.2636406007      , 6.72514068747     ,
 6.15196374829     , 5.57603256266     , 5.04952634197     , 4.62568123419     ,
 4.32861934204     , 4.12891151386     , 3.95595659115     , 3.75234648236     ,
 3.51701691721     , 3.28666606939     , 3.08335010508     , 2.89421210892     ,
 2.69521952191     , 2.47274279376     , 2.21900229106     , 1.93188012659     ,
 1.63525550406     , 1.38164615621     , 1.21503778936     , 1.1365594485      ,
 1.11245482265     , 1.10149843538     , 1.06763008407     , 0.986129289709    ,
 0.856866335909    , 0.706322332036    , 0.566813022876    , 0.456103016364    ,
 0.377306543261    , 0.328199057498    , 0.302788549139    , 0.286810389306    ,
 0.260651229177    , 0.213210389462    , 0.15205590221     , 0.0968448182042   ,
 0.0643178054817   , 0.0605227131381   , 0.0811977527178   , 0.113157857006    ,
 0.137547131739    , 0.139183789225    , 0.116692861951    , 0.0830477853262   ,
 0.0559440462108   , 0.047806349489    , 0.0621542508285   , 0.0940423259228   ,
 0.131217028951    , 0.158034551775    , 0.163587248281    , 0.148036423758    ,
 0.121234564701    , 0.0968689071241   , 0.086958138945    , 0.0955550760797   ,
 0.11350425297     , 0.123140381776    , 0.113317815223    , 0.0893591967499   ,
 0.0668719001978   , 0.0583741333043   , 0.0664619418213   , 0.0850537375588   ,
 0.104395015854    , 0.117798720845    , 0.125987893413    , 0.134142541091    ,
 0.145864696837    , 0.162895192946    , 0.188289179256    , 0.223502371923    ,
 0.262186200665    , 0.293472197049    , 0.314519795162    , 0.33690595343     ,
 0.37950430265     , 0.457159419713    , 0.572826912597    , 0.710560127727    ,
 1.01530125142     , 1.08307064789     , 1.07134416803     , 1.03146203891     ,
 1.02621645946     , 1.07723683672     , 1.15676558386     , 1.22255201543     ,
 1.2527473228      , 1.2515947452      , 1.23455667291     , 1.21665923401     ,
 1.21019570768     , 1.21907489986     , 1.22754365845     , 1.2021290208      ,
 1.11810733961     , 0.99000196272     , 0.871062382482    , 0.812148734352    ,
 0.814856034548    , 0.830032392945    , 0.810020990851    , 0.756245633836    ,
 0.703436715444    , 0.666071697375    , 0.62333724607     , 0.556860620212    ,
 0.481015304564    , 0.427592458384    , 0.411235730642    , 0.41580008059     ,
 0.41113605502     , 0.381334733682    , 0.337634018764    , 0.304949115019    ,
 0.297639802338    , 0.308399493996    , 0.315894345603    , 0.300133167367    ,
 0.256389405712    , 0.201062803256    , 0.162404213987    , 0.16142672907     ,
 0.199654967666    , 0.260375923633    , 0.317433869448    , 0.347793250902    ,
 0.344477538114    , 0.319057937589    , 0.289816867245    , 0.271514646561    ,
 0.281459976976    , 0.350465466314    , 0.51453881596     , 0.785740843112    ,
 1.13403155493     , 1.50922618975     , 1.88261806004     , 2.25814937274     ,
 2.64915014673     , 3.06919665986     , 3.55539503173     , 4.18286281661     ,
 5.04108085639     , 6.19874612313     , 7.688181347       , 9.49774170713     ,
 11.5587850171     , 13.7579119901     , 15.9863266827     , 18.1521086819     ,
 20.1180770399     , 21.6858656779     , 22.709523096      , 23.1928667553     ,
 23.2214139783     , 22.8279516987     , 21.9765112858     , 20.6783960257     ,
 19.1055608853     , 17.5822423512     , 16.443119107      , 15.8534886583     ,
 15.7191534219     , 15.7501584245     , 15.6389365988     , 15.2304536658     ,
 14.5637176614     , 13.7747991735     , 12.9635555095     , 12.1354950793     ,
 11.2566275371     , 10.3515224332     , 9.52034074939     , 8.84730123772     ,
 8.31521043073     , 7.82740743495     , 7.30070027003     , 6.7236810216      ,
 6.14040925535     , 5.60558687414     , 5.15824886136     , 4.81561485406     ,
 4.5696939775      , 4.381044411       , 4.18770208578     , 3.94405145521     ,
 3.65766661482     , 3.37568467515     , 3.13164196789     , 2.91588809398     ,
 2.69775530087     , 2.45845553411     , 2.19507582762     , 1.91419816303     ,
 1.63966682596     , 1.411482141       , 1.25697666668     , 1.16909559023     ,
 1.12245263164     , 1.09841634634     , 1.0839588612      , 1.06037794464     ,
 1.00912303487     , 0.923679812661    , 0.808812320919    , 0.675458159893    ,
 0.541408621413    , 0.428965045574    , 0.352779883543    , 0.308072627587    ,
 0.273572515951    , 0.229623750148    , 0.174294898711    , 0.121834302771    ,
 0.089044414775    , 0.0851381965147   , 0.108691764996    , 0.146933300467    ,
 0.178731349771    , 0.185149946692    , 0.161962020467    , 0.122623892045    ,
 0.0887576636909   , 0.0768590623691   , 0.0907595804431   , 0.121988653165    ,
 0.155153285481    , 0.175353419294    , 0.174809726043    , 0.155277342354    ,
 0.125641015886    , 0.098115550938    , 0.0842984348889   , 0.0888752423172   ,
 0.10411659        , 0.113991115118    , 0.107917179114    , 0.0904547433356   ,
 0.0769225013416   , 0.0811416373438   , 0.106393204335    , 0.14382405293     ,
 0.17880775831     , 0.202437612315    , 0.217739621725    , 0.232968658229    ,
 0.251540559035    , 0.272924544645    , 0.299361279118    , 0.333045040155    ,
 0.367632952168    , 0.391651102083    , 0.40345799809     , 0.418958178236    ,
 0.46343017202     , 0.556912193606    , 0.701584429971    , 0.871718743357    ,
 1.15785588642     , 1.22750232713     , 1.20188635673     , 1.13775352043     ,
 1.11075919761     , 1.15304481235     , 1.23647527445     , 1.31011664737     ,
 1.34529138176     , 1.3474589967      , 1.33806347232     , 1.33469883335     ,
 1.34380447084     , 1.35774866009     , 1.3529564728      , 1.30056890621     ,
 1.19169737497     , 1.05739370444     , 0.958717148959    , 0.9421416911      ,
 0.992547346199    , 1.03743116046     , 1.01369251029     , 0.927752315904    ,
 0.835325877699    , 0.769889132387    , 0.714790027153    , 0.643181687203    ,
 0.558628270037    , 0.48745982511     , 0.445524693644    , 0.421815565074    ,
 0.392330681322    , 0.346725268237    , 0.299564757834    , 0.27499557028     ,
 0.282797320698    , 0.310112175183    , 0.331701881378    , 0.325727726793    ,
 0.286826335032    , 0.231554973099    , 0.188853226666    , 0.180106000145    ,
 0.206962108267    , 0.254426956073    , 0.300438105261    , 0.326187827426    ,
 0.326650327841    , 0.313125620999    , 0.30170112464     , 0.301619113393    ,
 0.321766421039    , 0.386782617334    , 0.534826143763    , 0.790908146049    ,
 1.14676251355     , 1.57383942236     , 2.04864725324     , 2.55351181615     ,
 3.06488774176     , 3.57180142656     , 4.11622794984     , 4.79749218754     ,
 5.72186813469     , 6.94686563375     , 8.46688675943     , 10.2318249892     ,
 12.1706844924     , 14.2184945379     , 16.3352242016     , 18.4609858174     ,
 20.4207769667     , 21.933089922      , 22.7867177225     , 22.9858044064     ,
 22.6768785081     , 21.9685924857     , 20.8737152795     , 19.4213132897     ,
 17.7947579263     , 16.3354519819     , 15.378491033      , 15.0429720421     ,
 15.152237926      , 15.3517361457     , 15.3274820583     , 14.9591815804     ,
 14.3201589569     , 13.5658481325     , 12.8065874267     , 12.0469650794     ,
 11.2387370691     , 10.3934177162     , 9.61073148972     , 8.97769692929     ,
 8.4712362147      , 7.98616904524     , 7.44324074321     , 6.85088567714     ,
 6.27543967745     , 5.77822027031     , 5.38202209354     , 5.07505911459     ,
 4.82774263        , 4.59992025078     , 4.34524102241     , 4.03539997564     ,
 3.68922791831     , 3.36076546027     , 3.08718899645     , 2.8571233936      ,
 2.63403392501     , 2.39572996858     , 2.143156541       , 1.88891652673     ,
 1.65378606837     , 1.46231211971     , 1.32439331801     , 1.22749731955     ,
 1.15848303639     , 1.12364946015     , 1.13410619311     , 1.17781189603     ,
 1.21648725858     , 1.20617307678     , 1.11871626007     , 0.956017705851    ,
 0.753270363203    , 0.562694325843    , 0.423905828104    , 0.343287820341    ,
 0.297656813535    , 0.257322418325    , 0.208575801581    , 0.158181348667    ,
 0.121955429008    , 0.112217211961    , 0.131407808771    , 0.169783774584    ,
 0.207345389455    , 0.222912245342    , 0.20714299591     , 0.169597211857    ,
 0.132906232083    , 0.117590963864    , 0.128881733663    , 0.155204668001    ,
 0.178287303461    , 0.185355360203    , 0.173861441948    , 0.148371225799    ,
 0.116370947461    , 0.0869887157772   , 0.0695701497752   , 0.0687203468742   ,
 0.0796338356284   , 0.0908708010413   , 0.0941978486339   , 0.0922414941661   ,
 0.0970061260576   , 0.121108018142    , 0.167578139968    , 0.225169518516    ,
 0.275711505408    , 0.309618026578    , 0.332723395696    , 0.355946836681    ,
 0.383130709361    , 0.413555282203    , 0.449316056712    , 0.490170741792    ,
 0.524787766976    , 0.538557673574    , 0.532347463786    , 0.529126611247    ,
 0.562007174009    , 0.655976320986    , 0.812684768206    , 1.00032493074     ,
 1.25145544596     , 1.33000485475     , 1.31778203032     , 1.26964630546     ,
 1.2625120238      , 1.32879406976     , 1.43417684221     , 1.51883927107     ,
 1.55212229542     , 1.54750957366     , 1.53685584695     , 1.53994811526     ,
 1.55355392434     , 1.55537032697     , 1.51530093736     , 1.41481922961     ,
 1.2663917331      , 1.11731091274     , 1.02984292144     , 1.04010989665     ,
 1.1190035121      , 1.18100597315     , 1.15459980474     , 1.04698623543     ,
 0.924773940658    , 0.83591014566     , 0.771721616294    , 0.70164987033     ,
 0.618001251629    , 0.537839509791    , 0.476536823149    , 0.430774697035    ,
 0.386032764243    , 0.336612467803    , 0.294793216629    , 0.2785369671      ,
 0.292264384928    , 0.321346006499    , 0.342405079885    , 0.337242747287    ,
 0.302840376254    , 0.254428778228    , 0.216451074749    , 0.205434322687    ,
 0.221067585151    , 0.251716515191    , 0.283360711523    , 0.305048390024    ,
 0.314432995307    , 0.320383306192    , 0.334604203903    , 0.36082614845     ,
 0.400891763049    , 0.473583498234    , 0.616734330183    , 0.863247378264    ,
 1.22208084211     , 1.68777853393     , 2.25307138123     , 2.8947608561      ,
 3.56105356716     , 4.20656455442     , 4.85183219841     , 5.5943794255      ,
 6.55152377445     , 7.79049704337     , 9.30020452994     , 11.010990135      ,
 12.8428366165     , 14.7560571497     , 16.7544448463     , 18.7900814514     ,
 20.6426215201     , 21.968623836      , 22.5451964538     , 22.4334539815     ,
 21.8614515927     , 20.9896653225     , 19.8347875489     , 18.4011756688     ,
 16.848227245      , 15.5060457211     , 14.6997571467     , 14.5226503979     ,
 14.7575780704     , 15.0207201599     , 15.0033554675     , 14.616173029      ,
 13.9638201855     , 13.2244073217     , 12.5236931173     , 11.8659926525     ,
 11.1809458172     , 10.448826763      , 9.74735388832     , 9.15807860423     ,
 8.66755173246     , 8.18909278953     , 7.65909902094     , 7.0892356333      ,
 6.53866679862     , 6.05967360375     , 5.66815514139     , 5.34716066368     ,
 5.06486858254     , 4.78425201736     , 4.46746820152     , 4.09725831677     ,
 3.70131789443     , 3.33618440393     , 3.03620387169     , 2.78772759833     ,
 2.55594509246     , 2.32305280347     , 2.09460776672     , 1.88358097804     ,
 1.70060121356     , 1.55104767179     , 1.42953545663     , 1.32372408059     ,
 1.23547272162     , 1.19247269002     , 1.22453756855     , 1.32555175671     ,
 1.44215772042     , 1.4983708608      , 1.43582467713     , 1.24748331279     ,
 0.984628875825    , 0.727054198587    , 0.536123562168    , 0.426107786446    ,
 0.369812925911    , 0.327525445828    , 0.275899836902    , 0.217289867544    ,
 0.168696890433    , 0.145923804796    , 0.154825712689    , 0.189055884334    ,
 0.231199570017    , 0.258760365693    , 0.256024797969    , 0.2256040206      ,
 0.188563064102    , 0.16917146722     , 0.175726754507    , 0.195325078105    ,
 0.207309232791    , 0.200361034362    , 0.176458379933    , 0.143118632029    ,
 0.107213718863    , 0.0753345995922   , 0.0544511437921   , 0.0486663731625   ,
 0.0559735709067   , 0.0698929025521   , 0.0850650501153   , 0.102207686447    ,
 0.129038559706    , 0.175240367252    , 0.242232228065    , 0.316670673432    ,
 0.378776328391    , 0.419799066636    , 0.44767998198     , 0.474837386079    ,
 0.507383689712    , 0.548670763713    , 0.602505439195    , 0.66319112952     ,
 0.709320090045    , 0.719684116227    , 0.696542480182    , 0.669943627678    ,
 0.680910403423    , 0.759271287939    , 0.907134906848    , 1.09143097646     ,
 1.34199440195     , 1.4286855315      , 1.44545097756     , 1.44038678139     ,
 1.48007007808     , 1.58692896884     , 1.71779819698     , 1.80801737278     ,
 1.82997493053     , 1.80682947624     , 1.779734304       , 1.77040324917     ,
 1.76879198527     , 1.7431126269      , 1.66138897374     , 1.51628034634     ,
 1.3369254928      , 1.17747209294     , 1.09121945102     , 1.10043430613     ,
 1.17180535018     , 1.22579928196     , 1.19490551835     , 1.08146418004     ,
 0.946282379919    , 0.841251082683    , 0.768772863477    , 0.703536149311    ,
 0.630890857561    , 0.556268591513    , 0.490648164451    , 0.437301387521    ,
 0.392010729561    , 0.352778858893    , 0.325952150753    , 0.320044512855    ,
 0.334165655397    , 0.354911623279    , 0.364821009384    , 0.353418807052    ,
 0.32294542867     , 0.286913075667    , 0.261444040918    , 0.254265529444    ,
 0.261942443333    , 0.277193937165    , 0.29514417275     , 0.313077395007    ,
 0.331084684486    , 0.355114608675    , 0.392596939099    , 0.443243204639    ,
 0.504424469773    , 0.591211370216    , 0.741084313207    , 0.9916470961      ,
 1.36315664115     , 1.86777401608     , 2.51566540765     , 3.28971271229     ,
 4.12451747401     , 4.94204301623     , 5.72313167017     , 6.5389655622      ,
 7.50970698814     , 8.72811416932     , 10.2024631682     , 11.8555044997     ,
 13.5882257501     , 15.3630182581     , 17.2063445666     , 19.0740158385     ,
 20.711562498      , 21.7478028709     , 21.9966560353     , 21.6128990795     ,
 20.9052196797     , 20.0466117578     , 19.004093579      , 17.7149574645     ,
 16.292162079      , 15.0475130838     , 14.3026098182     , 14.1494228036     ,
 14.3702641564     , 14.5883313782     , 14.5125994259     , 14.0739917499     ,
 13.3927714543     , 12.6629383098     , 12.0281929856     , 11.4982387921     ,
 10.9816940465     , 10.4184035246     , 9.84849353995     , 9.3386287395      ,
 8.88889530754     , 8.4408925503      , 7.94844184688     , 7.41603495389     ,
 6.88359496072     , 6.39385374008     , 5.96961397645     , 5.60802561695     ,
 5.28675221414     , 4.96951027281     , 4.61682887062     , 4.21500841679     ,
 3.79603032629     , 3.41137473422     , 3.08484626832     , 2.80212264043     ,
 2.54193958702     , 2.30273868104     , 2.09729407291     , 1.93235344217     ,
 1.79985701928     , 1.6832560039      , 1.56717049739     , 1.44717325799     ,
 1.34119756645     , 1.28980603412     , 1.33103337939     , 1.46279551155     ,
 1.62575795165     , 1.7252994476      , 1.68259340804     , 1.48392498657     ,
 1.19137172458     , 0.902298944238    , 0.689677514527    , 0.568941769546    ,
 0.506734856105    , 0.455467349092    , 0.387448545364    , 0.306726356864    ,
 0.23579794003     , 0.195170454459    , 0.192611960245    , 0.222398259037    ,
 0.267599003141    , 0.304376873647    , 0.31223535603     , 0.287984107224    ,
 0.250517334595    , 0.22657146167     , 0.227522197033    , 0.240583760325    ,
 0.243672711111    , 0.225943281094    , 0.191871101509    , 0.150853390898    ,
 0.109774815701    , 0.074194692051    , 0.0499098260793   , 0.0405252401708   ,
 0.0454320601185   , 0.0614423698135   , 0.0859055209701   , 0.119082769114    ,
 0.16538340772     , 0.230577693856    , 0.3130340649      , 0.398010315399    ,
 0.466749984522    , 0.512510398791    , 0.543003008044    , 0.569144541279    ,
 0.599908987357    , 0.646728937119    , 0.719033285874    , 0.807828848898    ,
 0.882080378357    , 0.911430299118    , 0.893249843069    , 0.857607354254    ,
 0.849748836579    , 0.905014502251    , 1.02917521327     , 1.19263427284     ,
 1.51197266043     , 1.601540378       , 1.64638333137     , 1.68780908589     ,
 1.77505233148     , 1.91383098456     , 2.05405428066     , 2.13479426894     ,
 2.13658108442     , 2.08785444596     , 2.03046829234     , 1.98580559942     ,
 1.94496045234     , 1.87840342268     , 1.75841718173     , 1.58531502175     ,
 1.39468558764     , 1.23620578993     , 1.14602797761     , 1.1315185495      ,
 1.16469239354     , 1.18856891514     , 1.15103795232     , 1.04620482269     ,
 0.915066314815    , 0.802065881215    , 0.720265981155    , 0.657225096842    ,
 0.598484760212    , 0.53923669411     , 0.482837227237    , 0.435505593169    ,
 0.401666795911    , 0.382557788831    , 0.377820699963    , 0.385673727495    ,
 0.40021714125     , 0.410768124638    , 0.407576554374    , 0.389776265802    ,
 0.366395081365    , 0.348660577082    , 0.341514176237    , 0.341797753576    ,
 0.343771790968    , 0.346083081562    , 0.352460702041    , 0.366319220548    ,
 0.388751110796    , 0.422689744709    , 0.472325407845    , 0.536181399921    ,
 0.6118745621      , 0.715036881493    , 0.883888999546    , 1.15819288088     ,
 1.56375909177     , 2.12136075343     , 2.84955155227     , 3.73625480938     ,
 4.71322683933     , 5.68336898622     , 6.59161992589     , 7.47715516027     ,
 8.45953126812     , 9.66126297735     , 11.1145913494     , 12.7303161935     ,
 14.3755269123     , 15.9952258144     , 17.6254528016     , 19.2320363921     ,
 20.5580891652     , 21.2498264731     , 21.1895774277     , 20.6228107194     ,
 19.9041582479     , 19.1751806083     , 18.3223586548     , 17.2053350094     ,
 15.8931070746     , 14.6848662953     , 13.9052318643     , 13.6587232786     ,
 13.7541016479     , 13.8533491006     , 13.7000964183     , 13.2380569083     ,
 12.580350435      , 11.9132539118     , 11.3841725069     , 11.0086581907     ,
 10.6853191988     , 10.3229348682     , 9.92479959738     , 9.5375740484      ,
 9.16690079037     , 8.77199439451     , 8.31498905617     , 7.79451345495     ,
 7.24597386735     , 6.72141190609     , 6.26065717499     , 5.87211353957     ,
 5.53271102461     , 5.19854844851     , 4.82819063125     , 4.416262057       ,
 3.99915031723     , 3.61483417789     , 3.26728179462     , 2.94047502746     ,
 2.63404773408     , 2.37135196935     , 2.17563155417     , 2.04395418282     ,
 1.94454479586     , 1.83947564793     , 1.710946914       , 1.56997457232     ,
 1.44904213665     , 1.38978318566     , 1.42541560421     , 1.55504038515     ,
 1.72406744115     , 1.83656758788     , 1.80685985487     , 1.61797359115     ,
 1.33548486276     , 1.06079303667     , 0.865545084744    , 0.758947068121    ,
 0.700337967622    , 0.637458040864    , 0.543623055921    , 0.430274135303    ,
 0.329975976615    , 0.270035830921    , 0.258601259056    , 0.285771418151    ,
 0.330269379651    , 0.366358300172    , 0.373411949546    , 0.348190500508    ,
 0.309242869737    , 0.283104240314    , 0.280844840426    , 0.288858770517    ,
 0.284633388837    , 0.258472348921    , 0.216838257262    , 0.170182224676    ,
 0.125284624689    , 0.0874505024553   , 0.0621714210394   , 0.0520720408649   ,
 0.0555263042278   , 0.07005924832     , 0.0957402084574   , 0.13520057048     ,
 0.19221541614     , 0.268890605767    , 0.359837724271    , 0.450004335798    ,
 0.524095460076    , 0.577784225478    , 0.615333831957    , 0.641701054481    ,
 0.666311697606    , 0.709723168455    , 0.792028771069    , 0.909534102238    ,
 1.02908471758     , 1.11032275348     , 1.13488470988     , 1.11953563734     ,
 1.10738025125     , 1.14226493164     , 1.24028454356     , 1.37883631761     ,
 1.83175255197     , 1.9230487225      , 1.98676809544     , 2.06183918421     ,
 2.17939948228     , 2.32584156375     , 2.44809621741     , 2.49886128362     ,
 2.4722523549      , 2.39586208559     , 2.30042639834     , 2.20228135355     ,
 2.10085110286     , 1.98001739598     , 1.82095174972     , 1.62738763792     ,
 1.43378047571     , 1.28019702752     , 1.18428003047     , 1.13969380147     ,
 1.12683394971     , 1.11559375003     , 1.07305233868     , 0.985892615946    ,
 0.8716515983      , 0.760489809742    , 0.670802388292    , 0.603860718737    ,
 0.551620798845    , 0.504691711549    , 0.459429174722    , 0.421803288626    ,
 0.402027211431    , 0.404240383534    , 0.422485154198    , 0.445515315625    ,
 0.462839233242    , 0.467027220212    , 0.456534163949    , 0.440075556158    ,
 0.432428335609    , 0.440179359299    , 0.45471567808     , 0.462210087866    ,
 0.457584876955    , 0.44768147224     , 0.443969401472    , 0.453648086555    ,
 0.477295785005    , 0.513946844013    , 0.564352723076    , 0.628826754563    ,
 0.711899937375    , 0.835282739495    , 1.03752402374     , 1.35565378197     ,
 1.81570120625     , 2.44061552214     , 3.2468984434      , 4.21723011833     ,
 5.2812853218      , 6.33934432543     , 7.3233954523      , 8.25643298298     ,
 9.26038581109     , 10.4801920509     , 11.9591195569     , 13.5814376512     ,
 15.165953782      , 16.6260946183     , 17.9985353104     , 19.2700753622     ,
 20.2210979816     , 20.562995578      , 20.2609825391     , 19.6142654718     ,
 18.9636893175     , 18.382755841      , 17.6829585417     , 16.6761876886     ,
 15.4121009451     , 14.1828280442     , 13.3097229989     , 12.9077708112     ,
 12.8248100664     , 12.7844639827     , 12.5823772981     , 12.1749355159     ,
 11.6488613366     , 11.1500787587     , 10.7985381285     , 10.6049108766     ,
 10.4713188483     , 10.2972470998     , 10.0635907931     , 9.80087496134     ,
 9.51419337048     , 9.16575248648     , 8.71359941073     , 8.15614322503     ,
 7.54948191988     , 6.98061610623     , 6.51094498323     , 6.14021243838     ,
 5.81731397735     , 5.47796824281     , 5.08725295897     , 4.66426314379     ,
 4.25725317509     , 3.88754745347     , 3.53299196703     , 3.17052531423     ,
 2.81683655769     , 2.51929070828     , 2.31370179419     , 2.19034773782     ,
 2.09724187057     , 1.98106425277     , 1.82862513941     , 1.6688993463      ,
 1.54308649702     , 1.48193216542     , 1.50273471415     , 1.60311512327     ,
 1.74222718919     , 1.83892504708     , 1.81410073999     , 1.65089602722     ,
 1.411378293       , 1.18891835615     , 1.04338767625     , 0.972836588526    ,
 0.929325165829    , 0.858089682825    , 0.736153052929    , 0.585582942582    ,
 0.452456988769    , 0.373021043345    , 0.354882219137    , 0.379861889677    ,
 0.417906649246    , 0.440972888635    , 0.433416898477    , 0.398711886021    ,
 0.357693088661    , 0.333562581518    , 0.331967612768    , 0.335866964183    ,
 0.323132825223    , 0.287434505921    , 0.238863418423    , 0.189475880933    ,
 0.145835012934    , 0.112663692511    , 0.0943544108638   , 0.0903858981484   ,
 0.0945424080234   , 0.102256931125    , 0.116991059423    , 0.147801665233    ,
 0.202136061439    , 0.28042697792     , 0.373780925106    , 0.467253908699    ,
 0.549688281482    , 0.618709871381    , 0.673133921074    , 0.708993620115    ,
 0.732610747269    , 0.771200507628    , 0.857899368092    , 1.00283474849     ,
 1.17984152677     , 1.33989437825     , 1.44029123896     , 1.47272887467     ,
 1.47266032999     , 1.49669829847     , 1.57916044621     , 1.70593455156     ,
 2.32630809882     , 2.42761656743     , 2.50513561221     , 2.60043514344     ,
 2.73041788101     , 2.86347163203     , 2.94655215112     , 2.95153303241     ,
 2.88924072312     , 2.78290075389     , 2.64444975042     , 2.48022310339     ,
 2.29949093926     , 2.1047424587      , 1.88968341968     , 1.66151256996     ,
 1.45235046273     , 1.29377477222     , 1.18895869783     , 1.12081093092     ,
 1.07502369773     , 1.04040660869     , 0.998579706779    , 0.932796869836    ,
 0.843861739287    , 0.746894548074    , 0.656862912175    , 0.582033801353    ,
 0.523350628658    , 0.474895770717    , 0.431202531945    , 0.397248669955    ,
 0.385851912696    , 0.402722760676    , 0.437570155552    , 0.471592618335    ,
 0.490866182843    , 0.491887089487    , 0.48155375342     , 0.476713399395    ,
 0.494250430615    , 0.532466048569    , 0.56866246183     , 0.581392936482    ,
 0.569802344087    , 0.549770932607    , 0.538999917765    , 0.547399303934    ,
 0.574950658991    , 0.615531428019    , 0.664386250503    , 0.725088075747    ,
 0.815284687701    , 0.967467978921    , 1.21760210596     , 1.59212699686     ,
 2.11220242576     , 2.80237450081     , 3.67453788617     , 4.69783497387     ,
 5.79448960271     , 6.87301418586     , 7.87859169756     , 8.84057799303     ,
 9.88511334479     , 11.1633162123     , 12.7117367005     , 14.3805358256     ,
 15.9397758192     , 17.267075844      , 18.3898182664     , 19.3160473794     ,
 19.8888851675     , 19.9183427318     , 19.4521718421     , 18.7952337476     ,
 18.2182840948     , 17.7133043117     , 17.0548393155     , 16.0607236706     ,
 14.7907223763     , 13.5245192975     , 12.5583419892     , 12.0035353147     ,
 11.7499960171     , 11.5951450388     , 11.3965961102     , 11.1258484327     ,
 10.8339254828     , 10.6017248124     , 10.4910030581     , 10.4914880273     ,
 10.5163953484     , 10.4749876258     , 10.3420725977     , 10.1430462172     ,
 9.88869024305     , 9.54341854809     , 9.05665152612     , 8.42789334393     ,
 7.74419475133     , 7.13781402788     , 6.69045256608     , 6.37742696447     ,
 6.09948712445     , 5.76299941426     , 5.34601768645     , 4.90357014467     ,
 4.50314602161     , 4.15357086174     , 3.80803286943     , 3.43091184669     ,
 3.04441724662     , 2.71080386145     , 2.4776024514      , 2.33514293973     ,
 2.22263665967     , 2.08224666754     , 1.90916807914     , 1.74490361868     ,
 1.62980923926     , 1.57600861625     , 1.58032363027     , 1.63755496854     ,
 1.72493330464     , 1.78653342816     , 1.76012739692     , 1.63141568308     ,
 1.45264330595     , 1.30015202068     , 1.21684938764     , 1.18990116253     ,
 1.16660678717     , 1.0909470536      , 0.943508587858    , 0.757056812202    ,
 0.591600289771    , 0.492284114419    , 0.465781448093    , 0.485339839798    ,
 0.511959832546    , 0.515711317925    , 0.487640527776    , 0.44007396715     ,
 0.396537416877    , 0.374901205459    , 0.373021980494    , 0.369993038523    ,
 0.345563899992    , 0.298567603371    , 0.243949009822    , 0.196227526679    ,
 0.162188688674    , 0.14535034937     , 0.146868736806    , 0.159564697261    ,
 0.16871623899     , 0.165376255098    , 0.157592166989    , 0.165122670133    ,
 0.203848568211    , 0.275294847348    , 0.36726758836     , 0.463649264031    ,
 0.556069574384    , 0.643917176855    , 0.722072893425    , 0.77922656656     ,
 0.817205641113    , 0.86525566818     , 0.965461641711    , 1.14177768614     ,
 1.37893119218     , 1.6238735571      , 1.81143114553     , 1.90611355303     ,
 1.93267168902     , 1.96119486693     , 2.04800822316     , 2.18721548171     ,
 2.97297850881     , 3.10131294422     , 3.19965964493     , 3.31214275525     ,
 3.44685055601     , 3.5607258329      , 3.60296538854     , 3.56120499789     ,
 3.45841579218     , 3.312581984       , 3.11847989505     , 2.87178509792     ,
 2.58870539249     , 2.29066173417     , 1.98933210088     , 1.70079834133     ,
 1.45609443216     , 1.27842668155     , 1.15999437852     , 1.07667482709     ,
 1.01534267325     , 0.971870731189    , 0.934518433457    , 0.887934445649    ,
 0.827126680737    , 0.755428880579    , 0.676273796697    , 0.595102627627    ,
 0.520483158327    , 0.456840123728    , 0.403944588182    , 0.367068555935    ,
 0.358313781266    , 0.382006268555    , 0.423865356218    , 0.460034135623    ,
 0.475302550834    , 0.471126361808    , 0.46276493139     , 0.472871656003    ,
 0.516356308642    , 0.581554714346    , 0.635156604869    , 0.653353629444    ,
 0.641122457379    , 0.620589177893    , 0.612460043198    , 0.628940614806    ,
 0.670738780326    , 0.726255112873    , 0.782714722871    , 0.845878907517    ,
 0.949161070232    , 1.13854214653     , 1.44490612224     , 1.87714299762     ,
 2.44682299269     , 3.18221728077     , 4.09585434662     , 5.14416516219     ,
 6.23904331275     , 7.30162927865     , 8.30670099155     , 9.30416244713     ,
 10.4186405051     , 11.7859352485     , 13.4218966362     , 15.1503012366     ,
 16.7112087402     , 17.9546253207     , 18.8885615571     , 19.5288364827     ,
 19.7820844453     , 19.5635043757     , 18.9883482727     , 18.3278598311     ,
 17.7561779731     , 17.2034262032     , 16.4623677268     , 15.40672482       ,
 14.1214974485     , 12.8556911912     , 11.8516247449     , 11.1992980521     ,
 10.8275164394     , 10.6081574131     , 10.4587565747     , 10.3645456745     ,
 10.3412835295     , 10.4011729003     , 10.5377567302     , 10.7108808716     ,
 10.8447671376     , 10.865892732      , 10.7519314373     , 10.5320092487     ,
 10.2335470335     , 9.83577415886     , 9.28863940985     , 8.59171622516     ,
 7.84999272468     , 7.22406887198     , 6.80685721673     , 6.55152017943     ,
 6.31866901003     , 5.99143244558     , 5.55963109063     , 5.10663818259     ,
 4.71455295102     , 4.38517337232     , 4.0562439416      , 3.68091248552     ,
 3.27882188178     , 2.91717648458     , 2.6501320181      , 2.4714897153      ,
 2.32339128892     , 2.15530515674     , 1.97204798484     , 1.81852204711     ,
 1.72566870397     , 1.68567468332     , 1.67643890181     , 1.68886305299     ,
 1.71733623743     , 1.73568771005     , 1.70567508046     , 1.61662362179     ,
 1.50379992037     , 1.41872572819     , 1.38678040488     , 1.39058176309     ,
 1.37957580273     , 1.29930176328     , 1.13268214057     , 0.919512618502    ,
 0.728579058936    , 0.609518410595    , 0.568164737775    , 0.574594451655    ,
 0.58708073978     , 0.575584461647    , 0.53437279325     , 0.479169141972    ,
 0.432462361468    , 0.406685162022    , 0.395180745865    , 0.377775746703    ,
 0.339039186742    , 0.282686954366    , 0.226585593142    , 0.186806348813    ,
 0.170731771901    , 0.180436467642    , 0.212088111766    , 0.249624979372    ,
 0.268295374013    , 0.254258651637    , 0.220694123326    , 0.199717902439    ,
 0.217881860206    , 0.27925463803     , 0.367788227663    , 0.464089943836    ,
 0.561189818753    , 0.661969798117    , 0.76249861464     , 0.849529225209    ,
 0.921548113182    , 1.00474203576     , 1.14076701762     , 1.3584677211      ,
 1.65098984975     , 1.96842995303     , 2.23523162019     , 2.39602145924     ,
 2.4630676857      , 2.51429074866     , 2.62530542243     , 2.79864969636     ,
 3.72002227411     , 3.89735692957     , 4.03517663236     , 4.17254491551     ,
 4.31428522965     , 4.41839803253     , 4.43876979492     , 4.36544523938     ,
 4.21842204913     , 4.00995692987     , 3.72964733488     , 3.37112836252     ,
 2.95672558517     , 2.52604225594     , 2.11447347627     , 1.75219199591     ,
 1.46636533841     , 1.26556377382     , 1.13013837623     , 1.03271577407     ,
 0.961087878631    , 0.911415220742    , 0.873391741742    , 0.836333259196    ,
 0.797669052356    , 0.753443939715    , 0.692574418579    , 0.611014306575    ,
 0.521206525598    , 0.439933868938    , 0.376518146669    , 0.337723980518    ,
 0.332037388834    , 0.359267861798    , 0.401287034469    , 0.431927020481    ,
 0.436871658365    , 0.422526328937    , 0.410740004949    , 0.427213273822    ,
 0.483441207649    , 0.561379112194    , 0.625078524528    , 0.653969118326    ,
 0.657108036245    , 0.656332125359    , 0.66970421147     , 0.709785558021    ,
 0.77925829122     , 0.862942347706    , 0.939574681702    , 1.01410088937     ,
 1.13365698822     , 1.35898892233     , 1.7179439503      , 2.20060910771     ,
 2.80505245518     , 3.56248312015     , 4.49193874016     , 5.54501745199     ,
 6.62654676923     , 7.67106750431     , 8.68766975277     , 9.75091982462     ,
 10.9745401608     , 12.4577054506     , 14.1838536022     , 15.9632726985     ,
 17.5321186708     , 18.7290131062     , 19.5398168952     , 19.9750431        ,
 19.99057801       , 19.5877795588     , 18.9213062818     , 18.2072389039     ,
 17.5338299941     , 16.8139485876     , 15.9074186169     , 14.7677542722     ,
 13.5003618082     , 12.304230395      , 11.3481686028     , 10.6866699355     ,
 10.2759200939     , 10.0487326203     , 9.96894215869     , 10.0298188627     ,
 10.2200544318     , 10.5020608354     , 10.8186890073     , 11.1060118313     ,
 11.2971804205     , 11.3351222543     , 11.2010407335     , 10.9239250842     ,
 10.5435918949     , 10.0614887511     , 9.44581254564     , 8.70365676836     ,
 7.93991950539     , 7.3126972442      , 6.91044418184     , 6.67715293924     ,
 6.46281258534     , 6.14826362584     , 5.73074959447     , 5.2988811686      ,
 4.93029720259     , 4.61921771647     , 4.29983944542     , 3.92467888203     ,
 3.5136254305      , 3.13438389531     , 2.83966972979     , 2.62223501584     ,
 2.43145705927     , 2.23214296416     , 2.04076889484     , 1.90140856093     ,
 1.83328644946     , 1.81112498193     , 1.79514470788     , 1.76839827979     ,
 1.73834918143     , 1.7108111506      , 1.67719624426     , 1.63035617925     ,
 1.58064873698     , 1.54794150654     , 1.54259832201     , 1.55261203097     ,
 1.53932886374     , 1.45454404704     , 1.28198392193     , 1.06098926141     ,
 0.858323194214    , 0.720282924328    , 0.653274762071    , 0.634523399455    ,
 0.630624256878    , 0.614374272863    , 0.576386517287    , 0.525023301374    ,
 0.475044247677    , 0.434771228353    , 0.400424319183    , 0.360512681836    ,
 0.307778479659    , 0.248266059626    , 0.197723899523    , 0.170678158578    ,
 0.174776533213    , 0.211002017095    , 0.270935163829    , 0.331627303562    ,
 0.361850029411    , 0.344866785186    , 0.297041408869    , 0.258612776633    ,
 0.263738983856    , 0.318190546904    , 0.401953238857    , 0.492130790622    ,
 0.584038706161    , 0.68750973656     , 0.805263663777    , 0.926876430758    ,
 1.04869530271     , 1.19022526223     , 1.38463083555     , 1.65596848005     ,
 2.00079657624     , 2.37733167791     , 2.71155712034     , 2.93703896291     ,
 3.05264181879     , 3.13672792182     , 3.27945209604     , 3.49508709103     ,
 4.52299761524     , 4.77095139966     , 4.9681830196      , 5.13990173571     ,
 5.2951360707      , 5.40718857361     , 5.43415406857     , 5.34802813026     ,
 5.1449542026      , 4.83196489001     , 4.4138957861      , 3.90221962783     ,
 3.33197572016     , 2.75985295151     , 2.24406970149     , 1.82581019981     ,
 1.518877544       , 1.30610161104     , 1.15209892533     , 1.03066613756     ,
 0.936343675776    , 0.867712527733    , 0.815353437741    , 0.772998963408    ,
 0.742179616319    , 0.715379313533    , 0.67060834534     , 0.594384290246    ,
 0.499263389807    , 0.410572984228    , 0.345691524836    , 0.31209044466     ,
 0.313133588056    , 0.34350520483     , 0.383243960323    , 0.407041062604    ,
 0.402421836244    , 0.377948325982    , 0.357287788112    , 0.366021710936    ,
 0.414341895828    , 0.486338175419    , 0.553785959475    , 0.603956397169    ,
 0.646073259334    , 0.693218595263    , 0.752569048779    , 0.831795114906    ,
 0.935600728387    , 1.05007905696     , 1.14928356864     , 1.23511463091     ,
 1.363703          , 1.61100650508     , 2.00817488007     , 2.53085512411     ,
 3.16023751908     , 3.92482971891     , 4.85278875397     , 5.90204620069     ,
 6.97850199943     , 8.02838740456     , 9.09024821857     , 10.2609704373     ,
 11.6368318232     , 13.2654578697     , 15.0867626577     , 16.9031787194     ,
 18.4642082246     , 19.6124373129     , 20.3205180036     , 20.5956783688     ,
 20.4300452543     , 19.8786733466     , 19.1027781944     , 18.2617701259     ,
 17.39492771       , 16.4430460473     , 15.352717038      , 14.149223929      ,
 12.94485961       , 11.8848833857     , 11.065169444      , 10.4957632996     ,
 10.1373933796     , 9.95605478617     , 9.9416461681      , 10.0905562693     ,
 10.3789851075     , 10.7515462683     , 11.1345833755     , 11.4586754296     ,
 11.6683651056     , 11.7226219426     , 11.6023138906     , 11.3164839002     ,
 10.8872343433     , 10.3248018595     , 9.63136584284     , 8.8447139373      ,
 8.07252033464     , 7.45305358709     , 7.05537755603     , 6.81886467521     ,
 6.6037552345      , 6.30726254089     , 5.93334866959     , 5.55661275224     ,
 5.22963857402     , 4.93208383947     , 4.6020581771      , 4.20494866849     ,
 3.77160361292     , 3.37269771737     , 3.05370798523     , 2.79822429278     ,
 2.55906535018     , 2.31780944681     , 2.10618860076     , 1.9718931521      ,
 1.92739356463     , 1.93214151279     , 1.92443056213     , 1.87093503632     ,
 1.78667989194     , 1.71107267855     , 1.66966739723     , 1.65919186421     ,
 1.66110058509     , 1.66195598894     , 1.6617622379      , 1.66168286978     ,
 1.64134170164     , 1.56163676968     , 1.40451043703     , 1.19975065549     ,
 1.0003439553      , 0.842661863803    , 0.737336182876    , 0.680087468092    ,
 0.656593829841    , 0.645114405916    , 0.62579854185     , 0.589108828034    ,
 0.535956402567    , 0.472778350526    , 0.4063368091      , 0.340652098444    ,
 0.278041354417    , 0.222710238798    , 0.182366361486    , 0.16640773364     ,
 0.182339131887    , 0.231393628603    , 0.303667849995    , 0.375592184615    ,
 0.417233918954    , 0.412337000859    , 0.375449033597    , 0.34491467916     ,
 0.35459249339     , 0.409765336969    , 0.488512847162    , 0.567924749407    ,
 0.649031640366    , 0.751370458146    , 0.885741505245    , 1.04457768262     ,
 1.22176059145     , 1.4301481152      , 1.69360181383     , 2.02811938671     ,
 2.42927037989     , 2.86166274648     , 3.25550575708     , 3.53791339318     ,
 3.69670463365     , 3.80924672494     , 3.97896882987     , 4.23637871023     ,
 5.38360441114     , 5.71792508543     , 5.98265822493     , 6.19038852398     ,
 6.36475442085     , 6.50093085707     , 6.55222028353     , 6.45241913246     ,
 6.15954332301     , 5.68100312472     , 5.06055254627     , 4.35324491306     ,
 3.61934790887     , 2.92944036469     , 2.35288467614     , 1.92801400015     ,
 1.64132007081     , 1.4387210534      , 1.26574934945     , 1.1034632246      ,
 0.963964977808    , 0.856826045042    , 0.775541092066    , 0.71450129844     ,
 0.675483180962    , 0.649298106748    , 0.610012195826    , 0.539828062189    ,
 0.449710735559    , 0.367155241267    , 0.311715530126    , 0.288598425176    ,
 0.295926517898    , 0.325950927662    , 0.361625793007    , 0.382428442882    ,
 0.37750995724     , 0.352543009052    , 0.326194908848    , 0.320352786205    ,
 0.347001639361    , 0.401006493027    , 0.470624240187    , 0.554407999016    ,
 0.658717647498    , 0.78060113783     , 0.90724261389     , 1.0337844687      ,
 1.16573877824     , 1.29708802299     , 1.40523317123     , 1.49070354206     ,
 1.61487375323     , 1.86793542309     , 2.28963088921     , 2.84546546609     ,
 3.49498898998     , 4.25551783802     , 5.16687043958     , 6.20979619658     ,
 7.30519094906     , 8.4073146314      , 9.56845319044     , 10.8948020187     ,
 12.4584182706     , 14.2500691641     , 16.1629020697     , 17.9936283741     ,
 19.5105075502     , 20.5677991544     , 21.1399310237     , 21.2480670992     ,
 20.9176428444     , 20.226208969      , 19.3139548416     , 18.2957404253     ,
 17.2020960249     , 16.0248764112     , 14.784023779      , 13.5511464678     ,
 12.4389054343     , 11.5543042091     , 10.9361269361     , 10.5447280927     ,
 10.3180360082     , 10.2238570291     , 10.2601597579     , 10.4263092332     ,
 10.7018207371     , 11.0419341818     , 11.3873329906     , 11.6832993795     ,
 11.8940453507     , 11.9981295091     , 11.970358347      , 11.7718460678     ,
 11.3637769955     , 10.7376789854     , 9.93865428487     , 9.06775084275     ,
 8.26336414113     , 7.65249536076     , 7.27738808212     , 7.05979823022     ,
 6.86138065921     , 6.59521092129     , 6.27563651934     , 5.96358350807     ,
 5.68110517984     , 5.38672162217     , 5.02131046689     , 4.56903851892     ,
 4.0803988406      , 3.63542136486     , 3.27439381397     , 2.96942491665     ,
 2.67131142091     , 2.37383930422     , 2.12537841267     , 1.98489077725     ,
 1.96598293873     , 2.01407461785     , 2.03875677414     , 1.98040051498     ,
 1.85448646169     , 1.73164104476     , 1.67230374536     , 1.68003659843     ,
 1.71327968486     , 1.73288511996     , 1.73343561446     , 1.7289989221      ,
 1.71478333813     , 1.65879423296     , 1.53820518654     , 1.36708928633     ,
 1.17854435031     , 0.998266737046    , 0.846188576611    , 0.743152434553    ,
 0.698140439027    , 0.695068195926    , 0.699921274701    , 0.680279396037    ,
 0.621361275938    , 0.53086954312     , 0.431141076575    , 0.344026000575    ,
 0.279304122441    , 0.234460838602    , 0.204519911702    , 0.191576132683    ,
 0.203633561027    , 0.244917342895    , 0.308873946061    , 0.378589238428    ,
 0.432928622382    , 0.458517483936    , 0.462032886235    , 0.468728973952    ,
 0.503112827172    , 0.567813939089    , 0.643145009421    , 0.712642601064    ,
 0.787582681919    , 0.897183227234    , 1.05578655338     , 1.25312550189     ,
 1.47915242732     , 1.74459378837     , 2.07077027781     , 2.46859091737     ,
 2.92896490739     , 3.41557969234     , 3.85857005191     , 4.18184552814     ,
 4.37046006375     , 4.50677703691     , 4.70789402194     , 5.01873084142     ,
 6.35123022489     , 6.77935324521     , 7.10652260443     , 7.34639144032     ,
 7.54387687708     , 7.70621836536     , 7.765278933       , 7.60943307854     ,
 7.16469752157     , 6.45253223579     , 5.57310868564     , 4.64301198488     ,
 3.75723662011     , 2.99415065772     , 2.41702635397     , 2.04382117084     ,
 1.82160145711     , 1.65288284455     , 1.46383084148     , 1.24917114937     ,
 1.04852744336     , 0.890242128508    , 0.772196131729    , 0.685400448822    ,
 0.627624743491    , 0.588471230033    , 0.543122103129    , 0.474515966285    ,
 0.392675184984    , 0.323150454421    , 0.28205312051     , 0.268705887187    ,
 0.275980415519    , 0.297194012268    , 0.323559027172    , 0.343450935035    ,
 0.347872881673    , 0.335789285626    , 0.315537674635    , 0.301951349425    ,
 0.309192417216    , 0.345859246809    , 0.419793290099    , 0.542680160264    ,
 0.71821212006     , 0.925235061834    , 1.12604726492     , 1.29778843641     ,
 1.44503896253     , 1.57423194164     , 1.67421414731     , 1.74935479722     ,
 1.86537861339     , 2.12372656868     , 2.57253269102     , 3.1664164556      ,
 3.8356107547      , 4.57741945354     , 5.44945097478     , 6.47925657176     ,
 7.62384465439     , 8.84179096731     , 10.172300503      , 11.7013474402     ,
 13.4615779851     , 15.3893618178     , 17.3443924006     , 19.1310273275     ,
 20.5420250342     , 21.4454185352     , 21.828396177      , 21.7451242286     ,
 21.2590162587     , 20.4495901833     , 19.4165817414     , 18.2383165424     ,
 16.9554898256     , 15.6078965352     , 14.2643617415     , 13.0252665032     ,
 12.0087029816     , 11.302206977      , 10.9025685193     , 10.7202194855     ,
 10.6556793983     , 10.6620536035     , 10.7385799118     , 10.8908702216     ,
 11.1092568336     , 11.3690115863     , 11.6367388831     , 11.8837874192     ,
 12.1022708971     , 12.2940408496     , 12.4222985329     , 12.3799646386     ,
 12.0386884806     , 11.3525663315     , 10.4138029774     , 9.41029418029     ,
 8.53965785358     , 7.93635022964     , 7.61602767685     , 7.46493251354     ,
 7.32085052872     , 7.09602720048     , 6.81661880032     , 6.54447336727     ,
 6.28458153164     , 5.97691491242     , 5.55899306253     , 5.02690668107     ,
 4.44841884356     , 3.91661493306     , 3.47535877141     , 3.09343839454     ,
 2.72044808722     , 2.3569829259      , 2.06431354774     , 1.91446833364     ,
 1.92606786856     , 2.03220823007     , 2.11229818521     , 2.07592643219     ,
 1.93125382903     , 1.77054606088     , 1.68363459696     , 1.68633460647     ,
 1.72952570305     , 1.76276539656     , 1.77747954837     , 1.79127247837     ,
 1.8040989221      , 1.78599325513     , 1.70869990661     , 1.57130423361     ,
 1.39005190663     , 1.18553254484     , 0.99021985946     , 0.847001339755    ,
 0.782126580617    , 0.782354349341    , 0.801371990828    , 0.78794276896     ,
 0.715972325584    , 0.597897235597    , 0.472174074461    , 0.375188439396    ,
 0.319069300311    , 0.290533215328    , 0.269978330601    , 0.252015802239    ,
 0.24667615194     , 0.264600762353    , 0.307400753503    , 0.369760476137    ,
 0.442759037504    , 0.515908499494    , 0.583468646187    , 0.649879623501    ,
 0.723613292159    , 0.803473582241    , 0.87721151059     , 0.94238928211     ,
 1.02466415351     , 1.15998668092     , 1.35694829726     , 1.59284243363     ,
 1.85134275057     , 2.14850580145     , 2.51432576456     , 2.96060807571     ,
 3.47035069605     , 3.9983535097      , 4.47165700463     , 4.8185796937      ,
 5.03444674365     , 5.21345274888     , 5.48092265396     , 5.88245384274     ,
 7.48403486774     , 8.00723844217     , 8.39157818227     , 8.66588935106     ,
 8.88850572002     , 9.05340090802     , 9.05709971021     , 8.75862270979     ,
 8.0830440905      , 7.08555702106     , 5.92532195572     , 4.77709713528     ,
 3.7661869284      , 2.96928042661     , 2.43021764925     , 2.13735379572     ,
 1.99732334001     , 1.87321585022     , 1.67597806955     , 1.41612674007     ,
 1.16103102686     , 0.957032845252    , 0.805418724079    , 0.693297281272    ,
 0.6147457985      , 0.558924985538    , 0.502953358347    , 0.431702933985    ,
 0.355555869844    , 0.29803737591     , 0.269853770644    , 0.262224912079    ,
 0.262116224086    , 0.265272402518    , 0.273844784255    , 0.287888074847    ,
 0.302103248872    , 0.309228279483    , 0.306383442433    , 0.299238145534    ,
 0.300847524861    , 0.329284508142    , 0.408128463946    , 0.561098269929    ,
 0.79181632894     , 1.06569034375     , 1.32467462403     , 1.53036092486     ,
 1.68616057106     , 1.81017300489     , 1.90457876403     , 1.98092665418     ,
 2.10903411349     , 2.39704853528     , 2.89701553611     , 3.54851601174     ,
 4.24500174971     , 4.95748347367     , 5.76865435381     , 6.77551544916     ,
 7.99150361788     , 9.37688174076     , 10.9294938659     , 12.6786343163     ,
 14.5961181241     , 16.5694178998     , 18.4509784489     , 20.0828891765     ,
 21.3016819991     , 21.994426912      , 22.1616350265     , 21.8948874452     ,
 21.2983013306     , 20.445847065      , 19.3840342535     , 18.1437441021     ,
 16.7623159168     , 15.3104044513     , 13.8971736184     , 12.6570670734     ,
 11.7218343619     , 11.1627133666     , 10.9379719225     , 10.9172936073     ,
 10.9752326936     , 11.0592905901     , 11.1761848453     , 11.339498358      ,
 11.5440967703     , 11.7732447069     , 12.0096431016     , 12.2463946606     ,
 12.5012570091     , 12.7972922557     , 13.0862508764     , 13.1966074153     ,
 12.9162995267     , 12.1660910431     , 11.0847689577     , 9.94434007755     ,
 9.0017035232      , 8.40237689796     , 8.139175641       , 8.06291801185     ,
 7.98057511098     , 7.79026213472     , 7.5204472994      , 7.24053178775     ,
 6.95896481714     , 6.61395317777     , 6.13924637439     , 5.52873093007     ,
 4.85220412407     , 4.20961671906     , 3.65462661458     , 3.16602657855     ,
 2.70215269496     , 2.27119433065     , 1.94138245085     , 1.79034649898     ,
 1.8372312759      , 2.00455183947     , 2.14850355851     , 2.15291756565     ,
 2.01382828157     , 1.83151011573     , 1.71483646054     , 1.69642147198     ,
 1.73620774662     , 1.78582530706     , 1.83239653423     , 1.88478205929     ,
 1.93567583551     , 1.95260190027     , 1.90471715751     , 1.78404963043     ,
 1.60071826065     , 1.3780721035      , 1.15832418768     , 0.992544279377    ,
 0.910099332064    , 0.897505222655    , 0.905116955745    , 0.876127854387    ,
 0.782426771294    , 0.642712668528    , 0.506134798278    , 0.415398535178    ,
 0.379155956125    , 0.372302672161    , 0.362278346452    , 0.337558355506    ,
 0.311188484461    , 0.302573036702    , 0.324808930601    , 0.385979506647    ,
 0.488556221765    , 0.622733435439    , 0.767602988464    , 0.903210704319    ,
 1.01909036293     , 1.11158115971     , 1.18239443384     , 1.25031114885     ,
 1.35734473052     , 1.54052632889     , 1.79145955414     , 2.06420090348     ,
 2.33334981569     , 2.62822144702     , 3.00024456067     , 3.46999418194     ,
 4.01095865592     , 4.56339053915     , 5.05200106211     , 5.42026578241     ,
 5.68555053031     , 5.95434606913     , 6.34627385194     , 6.8870733568      ,
 8.82702524463     , 9.44587166106     , 9.88948632712     , 10.204261809      ,
 10.4422157313     , 10.5585402034     , 10.4134293102     , 9.86982762046     ,
 8.89429152171     , 7.5945043654      , 6.17688666417     , 4.84964210426     ,
 3.74705888607     , 2.93055098549     , 2.41930360507     , 2.17788343756     ,
 2.08883891135     , 1.99408914086     , 1.7977294988      , 1.52014808895     ,
 1.24282091772     , 1.01889473339     , 0.849514730621    , 0.720680337757    ,
 0.627329533246    , 0.56033862946     , 0.497690067753    , 0.424558008383    ,
 0.351996737111    , 0.30314762652     , 0.284415292571    , 0.27904864268     ,
 0.267666037456    , 0.247531396526    , 0.230830287773    , 0.229631101868    ,
 0.244778374047    , 0.266537418171    , 0.283625507832    , 0.292367989597    ,
 0.3007543704      , 0.329222976945    , 0.409263886267    , 0.571894519947    ,
 0.822082014119    , 1.12013709458     , 1.4008248188      , 1.62222454195     ,
 1.79049751909     , 1.93059101284     , 2.05129439857     , 2.16731897753     ,
 2.34867687044     , 2.7042327414      , 3.28502544488     , 4.01460649773     ,
 4.75109143461     , 5.44097939989     , 6.19430280916     , 7.18056973882     ,
 8.47172224029     , 10.0263584121     , 11.7880393242     , 13.7106927566     ,
 15.6938656979     , 17.5822872442     , 19.2443319304     , 20.5925928276     ,
 21.5374074256     , 21.9968095637     , 21.9742581832     , 21.5815630798     ,
 20.9575192632     , 20.1744736512     , 19.2220221645     , 18.0600255975     ,
 16.6889827444     , 15.1928452208     , 13.7312973296     , 12.4914227196     ,
 11.6202889602     , 11.1599491615     , 11.0268882463     , 11.0698640656     ,
 11.1694885984     , 11.293066432      , 11.4650165496     , 11.7028276638     ,
 11.9908562581     , 12.3000810931     , 12.6094745645     , 12.9145287328     ,
 13.2396840824     , 13.6199594494     , 14.0083660196     , 14.2032424578     ,
 13.9475369129     , 13.1488183475     , 11.9820636508     , 10.7706262817     ,
 9.79520544961     , 9.19115127427     , 8.93190885417     , 8.86069497989     ,
 8.78500671821     , 8.5946381178      , 8.29877695537     , 7.95734689069     ,
 7.5944420189      , 7.17439096505     , 6.64119280685     , 5.97693446779     ,
 5.23225866293     , 4.49657805578     , 3.82860154392     , 3.22525632019     ,
 2.66672932482     , 2.1766084583      , 1.82691800906     , 1.68945408419     ,
 1.77402416833     , 1.99341327829     , 2.19176084692     , 2.23834549478     ,
 2.11757186256     , 1.92723151223     , 1.78505111615     , 1.74083926522     ,
 1.77209549434     , 1.83864336171     , 1.92166660687     , 2.01476355368     ,
 2.09692755387     , 2.13049944201     , 2.08618040698     , 1.96044712013     ,
 1.77058527202     , 1.54727283423     , 1.33185909347     , 1.16389684309     ,
 1.06163173058     , 1.01234220835     , 0.97719851335     , 0.910835643171    ,
 0.79242630615     , 0.64435648255     , 0.516091929664    , 0.44659828229     ,
 0.437341676796    , 0.454273405608    , 0.456605218408    , 0.42883251334     ,
 0.386880459401    , 0.359362548971    , 0.372081351522    , 0.445804488424    ,
 0.590857385994    , 0.794216275053    , 1.01766811078     , 1.21651243991     ,
 1.36324730291     , 1.45715594145     , 1.52114620101     , 1.59905790466     ,
 1.74618948988     , 1.99259096851     , 2.30442554202     , 2.60709011878     ,
 2.86579830637     , 3.12892140368     , 3.47917639613     , 3.95411320297     ,
 4.5194906451      , 5.09857996497     , 5.61426842714     , 6.03048839111     ,
 6.38954187405     , 6.80370546879     , 7.37261896413     , 8.08819395428     ,
 10.4388820935     , 11.1586831793     , 11.6565792256     , 11.9914988982     ,
 12.2005952851     , 12.1969053479     , 11.8165730198     , 10.9543273085     ,
 9.64627387228     , 8.06133673099     , 6.43641347538     , 4.9823704996      ,
 3.81483951655     , 2.96548778374     , 2.42976344991     , 2.16465905912     ,
 2.05650628574     , 1.95281825874     , 1.76032326659     , 1.49762628778     ,
 1.23983229666     , 1.03207497896     , 0.870653483864    , 0.742086860933    ,
 0.645420561374    , 0.575668732535    , 0.512608882703    , 0.441551408705    ,
 0.373938846535    , 0.332903890673    , 0.321739926954    , 0.317255466064    ,
 0.294466230428    , 0.251055875862    , 0.206741175082    , 0.183849079415    ,
 0.190267866405    , 0.216982270662    , 0.247673012425    , 0.271044551809    ,
 0.289093816395    , 0.320347785048    , 0.397199705874    , 0.551236647546    ,
 0.7866135894      , 1.06451756427     , 1.32671093449     , 1.54378788197     ,
 1.73253722698     , 1.92038029693     , 2.11167234118     , 2.31367018708     ,
 2.58760731484     , 3.03469775574     , 3.70088486339     , 4.50113400354     ,
 5.2773861488      , 5.96754770493     , 6.70242549967     , 7.69495878149     ,
 9.04734161121     , 10.7097281633     , 12.5835346313     , 14.5646858638     ,
 16.4958082553     , 18.189525826      , 19.5366109989     , 20.5308506364     ,
 21.1748390211     , 21.4282039489     , 21.2836321676     , 20.8454731355     ,
 20.2735196916     , 19.6474109048     , 18.9093099094     , 17.9365581822     ,
 16.6684865138     , 15.1899129703     , 13.7168036872     , 12.4950468486     ,
 11.6806078149     , 11.2770982895     , 11.1648477699     , 11.1958786254     ,
 11.2858251063     , 11.439202712      , 11.6994829706     , 12.0793091216     ,
 12.5407404472     , 13.0305169118     , 13.5081442283     , 13.9463109508     ,
 14.3472531897     , 14.7466287035     , 15.1236477917     , 15.3018817201     ,
 15.0343736509     , 14.2371690064     , 13.0983475541     , 11.939973064      ,
 11.0106507279     , 10.3994624737     , 10.0618897423     , 9.87586725023     ,
 9.70468776858     , 9.45317545451     , 9.089449708       , 8.63263250023     ,
 8.1212646912      , 7.57312455073     , 6.96715287963     , 6.27526266467     ,
 5.51182137581     , 4.73483517497     , 3.99494392347     , 3.30533302864     ,
 2.67391507346     , 2.14582551732     , 1.79629003745     , 1.68355346517     ,
 1.80121732185     , 2.05448828367     , 2.28595464984     , 2.36099899539     ,
 2.25587069481     , 2.06180505041     , 1.89925861951     , 1.83150478428     ,
 1.85178663165     , 1.92699133156     , 2.03307617613     , 2.15063787593     ,
 2.24559114116     , 2.27401516531     , 2.21091633835     , 2.06691625727     ,
 1.87622048694     , 1.67557545478     , 1.491429789       , 1.33574787957     ,
 1.20924619126     , 1.10561503611     , 1.00919693907     , 0.897490792003    ,
 0.760746225097    , 0.619429319494    , 0.513486002562    , 0.47154862826     ,
 0.488019667652    , 0.524736916927    , 0.537647194932    , 0.50937030914     ,
 0.458621244923    , 0.423007593259    , 0.440480470667    , 0.541452860071    ,
 0.738420259628    , 1.0099740423      , 1.29953699142     , 1.54194808381     ,
 1.70070965947     , 1.78590227104     , 1.84445259463     , 1.94040526561     ,
 2.13253143553     , 2.43672196315     , 2.79511956583     , 3.11197496002     ,
 3.34867030253     , 3.57292351392     , 3.8982988318      , 4.38267004598     ,
 4.98957949668     , 5.6283905017      , 6.21835089954     , 6.73735702101     ,
 7.24374039318     , 7.84848026273     , 8.62883737132     , 9.54347655243     ,
 12.4175059883     , 13.2478778207     , 13.7651420607     , 14.0424178251     ,
 14.1240508494     , 13.9104279133     , 13.234726441      , 12.0304555943     ,
 10.400679834      , 8.56687443747     , 6.78048917566     , 5.23434436185     ,
 4.00872158303     , 3.0992676123      , 2.48186133309     , 2.11993033284     ,
 1.92592734074     , 1.77396029864     , 1.57985880954     , 1.35073688531     ,
 1.14103951817     , 0.979060410358    , 0.852551405911    , 0.745569046532    ,
 0.658619082781    , 0.591363503992    , 0.52936012399     , 0.461903970209    ,
 0.401558295994    , 0.370142856888    , 0.367322368916    , 0.364577466992    ,
 0.332677106065    , 0.269686706443    , 0.201024325253    , 0.156842200309    ,
 0.150763631989    , 0.17503060129     , 0.210343517474    , 0.240766973817    ,
 0.264887846256    , 0.299247001514    , 0.373350259458    , 0.513753956315    ,
 0.720059162377    , 0.955787044182    , 1.17750336647     , 1.37918678717     ,
 1.59518629623     , 1.85345640636     , 2.14473601181     , 2.45760818339     ,
 2.83383188589     , 3.35700851872     , 4.06485580904     , 4.88046660593     ,
 5.66663919781     , 6.38106615648     , 7.15980302661     , 8.2032433897      ,
 9.59243772895     , 11.2602967984     , 13.0976995731     , 14.9904893335     ,
 16.7675119398     , 18.2299961965     , 19.2805638571     , 19.9673337315     ,
 20.3683541961     , 20.4840016537     , 20.2933663142     , 19.8767435474     ,
 19.3975970677     , 18.9441685115     , 18.4306420534     , 17.6726849617     ,
 16.5581232575     , 15.1674320449     , 13.7532260035     , 12.5957010107     ,
 11.8491122345     , 11.4914407718     , 11.3915449303     , 11.4220016784     ,
 11.5345486059     , 11.760458867      , 12.1507269865     , 12.7084186759     ,
 13.3761489806     , 14.0800724027     , 14.7543745401     , 15.3294604961     ,
 15.7620722108     , 16.0813817551     , 16.3181028345     , 16.3747904575     ,
 16.0675158481     , 15.3383909677     , 14.3602503004     , 13.39824015       ,
 12.6138534857     , 12.0163475229     , 11.5433640577     , 11.1405895647     ,
 10.7715003955     , 10.3813640678     , 9.89231253856     , 9.26423398285     ,
 8.54310622756     , 7.81280955917     , 7.1064717563      , 6.39410468628     ,
 5.64694732828     , 4.87872894092     , 4.12167727829     , 3.39813664577     ,
 2.73810123862     , 2.2041460385      , 1.87186349173     , 1.78383532063     ,
 1.91822224141     , 2.1788668574      , 2.41638496211     , 2.49982352472     ,
 2.40003304953     , 2.20087624921     , 2.02259226581     , 1.93659470213     ,
 1.94521476875     , 2.01864458956     , 2.1298991596      , 2.2523185064      ,
 2.3425689228      , 2.35111537588     , 2.25851056683     , 2.09359951481     ,
 1.91033575127     , 1.74789302968     , 1.60993259998     , 1.47623233009     ,
 1.3315007348      , 1.179629954       , 1.03038762455     , 0.884014369047    ,
 0.739328037301    , 0.610881307422    , 0.526432111997    , 0.505123385374    ,
 0.537722243888    , 0.585422164323    , 0.602971000634    , 0.572068824562    ,
 0.51492808677     , 0.478484721997    , 0.51122348645     , 0.648283018436    ,
 0.897382028123    , 1.22404759211     , 1.55573466409     , 1.81730072584     ,
 1.97591121325     , 2.0575015471      , 2.12538573541     , 2.24803467996     ,
 2.47451231549     , 2.80616810338     , 3.17615815984     , 3.48811654959     ,
 3.70941449986     , 3.91991325884     , 4.25004747495     , 4.77234130183     ,
 5.45502255504     , 6.20298240927     , 6.93037144542     , 7.61496704438     ,
 8.31758408931     , 9.14850004652     , 10.1748231726     , 11.3291210239     ,
 14.8768477837     , 15.8196649028     , 16.2870324813     , 16.3776070961     ,
 16.1839109417     , 15.6439137023     , 14.6181239147     , 13.0749328526     ,
 11.1579218923     , 9.1132376957      , 7.18878506423     , 5.55295224201     ,
 4.25497085296     , 3.26348086378     , 2.54026796485     , 2.05651987303     ,
 1.75368529777     , 1.53754496916     , 1.33516756417     , 1.14018663784     ,
 0.984725571697    , 0.880772198782    , 0.806535776013    , 0.738207751402    ,
 0.671115696907    , 0.607622395318    , 0.5432213843      , 0.476628343066    ,
 0.423403068664    , 0.402804028106    , 0.409741389592    , 0.410707580871    ,
 0.37316655737     , 0.295921769051    , 0.209128416347    , 0.148611058292    ,
 0.131525051208    , 0.150503363996    , 0.184594070035    , 0.216529605114    ,
 0.244954205746    , 0.28555418613     , 0.363184577277    , 0.49690467856     ,
 0.680772405707    , 0.880939743475    , 1.06916893371     , 1.26312223264     ,
 1.5147133697      , 1.85053142472     , 2.24278165566     , 2.65471227493     ,
 3.10144072308     , 3.64203493602     , 4.30692021724     , 5.04988151714     ,
 5.79596849302     , 6.54890415099     , 7.42709731293     , 8.55771828572     ,
 9.95158978124     , 11.5211946979     , 13.183506462      , 14.8680247416     ,
 16.4413418082     , 17.7203304026     , 18.6014706766     , 19.1318251194     ,
 19.4128046965     , 19.4719416873     , 19.2905949008     , 18.9320260183     ,
 18.5465912466     , 18.2169225315     , 17.8474920365     , 17.2399695043     ,
 16.2752434747     , 15.0360128569     , 13.7730518417     , 12.7515309599     ,
 12.1102480261     , 11.8317155369     , 11.8092245499     , 11.9383752943     ,
 12.1756399536     , 12.5431825567     , 13.0842420956     , 13.8014636351     ,
 14.6391682132     , 15.5186047014     , 16.3495369261     , 17.0118025879     ,
 17.4089529346     , 17.5608040313     , 17.5581951007     , 17.4108116825     ,
 17.0346430672     , 16.4148038255     , 15.6902331407     , 15.0284626767     ,
 14.4669968477     , 13.9183657398     , 13.3043879901     , 12.6473059151     ,
 12.0186448427     , 11.4159251949     , 10.7337328091     , 9.88520815759     ,
 8.91981477732     , 7.97726623492     , 7.14356659974     , 6.39367137116     ,
 5.66129733401     , 4.91757849188     , 4.17525785826     , 3.46018019903     ,
 2.81346350746     , 2.30346398557     , 1.99928165431     , 1.9272492687      ,
 2.05454593338     , 2.29189253198     , 2.50748328787     , 2.58062911601     ,
 2.47831904408     , 2.27533155784     , 2.08843090271     , 1.99240592291     ,
 1.99412009239     , 2.0656273903      , 2.17844745862     , 2.30044730158     ,
 2.38050419505     , 2.36520661836     , 2.24158534503     , 2.05541302551     ,
 1.87808556349     , 1.75148341985     , 1.66169594348     , 1.56341013529     ,
 1.42730940384     , 1.2611194727      , 1.08936058931     , 0.926360584064    ,
 0.776243305841    , 0.649965619606    , 0.569273522198    , 0.550659349806    ,
 0.58556273483     , 0.635458473198    , 0.65303131568     , 0.618258860689    ,
 0.556594324484    , 0.523590803108    , 0.575542056104    , 0.747256988851    ,
 1.03666242329     , 1.39570233067     , 1.7433653076      , 2.00821455105     ,
 2.17185428454     , 2.27361550686     , 2.3766828046      , 2.53459195105     ,
 2.77822680371     , 3.10304590111     , 3.45469311753     , 3.7574372908      ,
 3.99147460858     , 4.23740084604     , 4.62326172464     , 5.2249378583      ,
 6.01922046376     , 6.91666435605     , 7.82749664153     , 8.72022659364     ,
 9.65416622823     , 10.7500724656     , 12.0788179788     , 13.5420464356     ,
 17.9180124209     , 18.94357484       , 19.2690657619     , 19.0304880102     ,
 18.3968936194     , 17.3894138121     , 15.935679261      , 14.0438482646     ,
 11.8670559732     , 9.63625742303     , 7.57315642845     , 5.8247343858      ,
 4.42991656148     , 3.35072386491     , 2.5394035305      , 1.96358651608     ,
 1.5787402573      , 1.31380670429     , 1.10646415453     , 0.941037440392    ,
 0.833311917124    , 0.784150753631    , 0.764147902543    , 0.739573346951    ,
 0.696605539357    , 0.637834855572    , 0.569259147433    , 0.500858385522    ,
 0.451958778796    , 0.439146019995    , 0.45318494436     , 0.457128982546    ,
 0.416377365836    , 0.330287106649    , 0.232028306119    , 0.160695200855    ,
 0.135188809506    , 0.148431499766    , 0.179689339696    , 0.213228342041    ,
 0.24959890641     , 0.303091839195    , 0.39219772185     , 0.52883377707     ,
 0.705187190902    , 0.893195162391    , 1.07703786337     , 1.28926622747     ,
 1.59012222206     , 1.99957375675     , 2.469776707       , 2.93885688774     ,
 3.39583796661     , 3.87676408377     , 4.41274271858     , 5.00848991104     ,
 5.67573766072     , 6.47015181835     , 7.4678445706      , 8.68575916443     ,
 10.0453917808     , 11.4481490448     , 12.8639282644     , 14.2987660974     ,
 15.690047865      , 16.8902365383     , 17.7745123815     , 18.3335399907     ,
 18.6307717309     , 18.7006413135     , 18.5511881441     , 18.2527815918     ,
 17.9344592531     , 17.6530275099     , 17.3109905011     , 16.7420084891     ,
 15.8750049463     , 14.8157416421     , 13.7831017821     , 12.9779116715     ,
 12.5044096288     , 12.3720392511     , 12.5246618909     , 12.8719596493     ,
 13.3349558731     , 13.8904798537     , 14.5673889076     , 15.3887055548     ,
 16.3287162688     , 17.3196570367     , 18.2485662307     , 18.9473309892     ,
 19.2737848633     , 19.2348364012     , 18.9641222938     , 18.5706795445     ,
 18.0853988006     , 17.5556292836     , 17.0873937573     , 16.7357646498     ,
 16.4035196455     , 15.9108674672     , 15.1707806065     , 14.2707053008     ,
 13.3655250996     , 12.5008754911     , 11.5752973959     , 10.4890505641     ,
 9.29253447419     , 8.14995971502     , 7.17777519794     , 6.36013067951     ,
 5.61128329369     , 4.8735944909      , 4.14391323787     , 3.44789727441     ,
 2.83041041369     , 2.35691196941     , 2.08343384541     , 2.01829195198     ,
 2.1201027102      , 2.31160642988     , 2.4855801299      , 2.5375900758      ,
 2.43225395328     , 2.23241591272     , 2.04698589261     , 1.95094011096     ,
 1.95574521658     , 2.03771760032     , 2.16713772881     , 2.30278387551     ,
 2.38262606482     , 2.34994920252     , 2.19879973805     , 1.98847858193     ,
 1.80488891496     , 1.69863922962     , 1.65333093887     , 1.61061116359     ,
 1.5240058233      , 1.38816428088     , 1.22417531847     , 1.05163310245     ,
 0.882477941689    , 0.733475589717    , 0.630498691704    , 0.593962449303    ,
 0.618359528052    , 0.665687926763    , 0.686135264677    , 0.656192248933    ,
 0.600762871008    , 0.579036733705    , 0.650253584778    , 0.845507657064    ,
 1.15343049951     , 1.51918097107     , 1.86524117905     , 2.13460538242     ,
 2.32480786983     , 2.47807400381     , 2.64136359169     , 2.84316039097     ,
 3.0991638004      , 3.41209359509     , 3.75399064823     , 4.07633175299     ,
 4.36927285263     , 4.70481827476     , 5.19747507368     , 5.91853828861     ,
 6.85223707033     , 7.9183489306      , 9.02652634463     , 10.1413488182     ,
 11.3339257289     , 12.7498607504     , 14.4597969719     , 16.3051311608     ,
 21.6486319304     , 22.6682760212     , 22.7361237973     , 22.0357573941     ,
 20.8138259838     , 19.1960950405     , 17.2145468549     , 14.9339791751     ,
 12.4967154256     , 10.0824336058     , 7.86550642074     , 5.97675224025     ,
 4.46631843751     , 3.308238292       , 2.44731884637     , 1.83348951503     ,
 1.41698637417     , 1.1373555711      , 0.941110570609    , 0.808094481948    ,
 0.743106592011    , 0.73959623366     , 0.764033819127    , 0.776830174921    ,
 0.757629047941    , 0.708157406658    , 0.640882414693    , 0.572901235494    ,
 0.525038691263    , 0.511528591056    , 0.52208769701     , 0.521096352568    ,
 0.475358421135    , 0.384377845204    , 0.280661540189    , 0.202719753449    ,
 0.169685016284    , 0.176018907498    , 0.203920654054    , 0.241210242138    ,
 0.290124251177    , 0.361523853945    , 0.466004520028    , 0.610266040898    ,
 0.790915969426    , 0.991908783187    , 1.20802622897     , 1.47390792809     ,
 1.84148062445     , 2.3141943809      , 2.8252774621      , 3.2964026788      ,
 3.70142265059     , 4.06459550278     , 4.42893389795     , 4.85626256645     ,
 5.43797788123     , 6.2630026665      , 7.35126536735     , 8.61555162984     ,
 9.90896440144     , 11.1386230878     , 12.3304557919     , 13.5640073755     ,
 14.8494644895     , 16.0819797522     , 17.1122802689     , 17.845754839      ,
 18.2649227649     , 18.3887078686     , 18.26453439       , 17.9938920931     ,
 17.6926513035     , 17.3854388346     , 16.9723015258     , 16.3388833182     ,
 15.4968522281     , 14.6000570014     , 13.8311514488     , 13.3012265269     ,
 13.0591519328     , 13.1370548661     , 13.5307469195     , 14.1567453931     ,
 14.886076364      , 15.6411123114     , 16.4405057105     , 17.3412298654     ,
 18.3585438654     , 19.435433231      , 20.4339293653     , 21.1511392565     ,
 21.4199571663     , 21.2312050915     , 20.7266352963     , 20.0808750651     ,
 19.4355266884     , 18.9177072153     , 18.6161408642     , 18.4806445136     ,
 18.2897040959     , 17.790442149      , 16.899297127      , 15.755058727      ,
 14.5663631505     , 13.4184261972     , 12.2406712529     , 10.9491248876     ,
 9.58594643707     , 8.29948034515     , 7.20658875049     , 6.30498098241     ,
 5.51351952286     , 4.76245479682     , 4.033629234       , 3.34809063186     ,
 2.75296978743     , 2.31033865312     , 2.06188679872     , 1.99800774948     ,
 2.06992990397     , 2.21272897276     , 2.34415784414     , 2.37740888867     ,
 2.27522765407     , 2.08688655125     , 1.91100319692     , 1.8219369267      ,
 1.83797754241     , 1.94305583013     , 2.10662122666     , 2.27479365701     ,
 2.370724866       , 2.33311219071     , 2.16243239449     , 1.92874727477     ,
 1.7304536763      , 1.63253564203     , 1.62951830772     , 1.65992860614     ,
 1.65527760017     , 1.57979705396     , 1.43503567498     , 1.24227174627     ,
 1.03008597501     , 0.833302463897    , 0.688954500751    , 0.621903205394    ,
 0.628706576105    , 0.673695206932    , 0.707518710533    , 0.702029619971    ,
 0.674406636624    , 0.677977189794    , 0.768118076986    , 0.971078486945    ,
 1.27230761617     , 1.62298033411     , 1.96261812165     , 2.25320835045     ,
 2.4994615549      , 2.73143323084     , 2.97089886924     , 3.22540916991     ,
 3.50902404553     , 3.84353233188     , 4.22775123885     , 4.62966748582     ,
 5.03728653541     , 5.50884211101     , 6.14613243926     , 7.0166390117      ,
 8.11008697716     , 9.35412489495     , 10.6638575707     , 12.0176839544     ,
 13.5196314409     , 15.3418396076     , 17.5214819226     , 19.7897782821     ,
 26.1850912351     , 27.0379123677     , 26.6912915843     , 25.3934964944     ,
 23.4557010052     , 21.1029403455     , 18.4887867909     , 15.7527244189     ,
 13.0239897534     , 10.4140353341     , 8.03648799171     , 6.00443279779     ,
 4.38502791667     , 3.16990502877     , 2.29694911507     , 1.69171653976     ,
 1.28762526674     , 1.0255237965      , 0.859037421986    , 0.766788608227    ,
 0.745061712898    , 0.780752486551    , 0.839361547437    , 0.882323022498    ,
 0.888653686063    , 0.85857081775     , 0.804366251982    , 0.743073403748    ,
 0.693178742016    , 0.666681591118    , 0.656323942387    , 0.634858956967    ,
 0.576450491868    , 0.481249381835    , 0.376452069474    , 0.294613035106    ,
 0.252810408273    , 0.248447406541    , 0.269504986292    , 0.308617372242    ,
 0.368593172762    , 0.455424003235    , 0.572050926616    , 0.722566535888    ,
 0.913388767723    , 1.14656240355     , 1.42708047362     , 1.77904872996     ,
 2.22671321656     , 2.74509082402     , 3.25298685789     , 3.67293213462     ,
 3.98427117257     , 4.2162904384      , 4.42929611414     , 4.72599167538     ,
 5.24123293562     , 6.06779848422     , 7.17897822718     , 8.43105758322     ,
 9.65524570073     , 10.7724562575     , 11.835497931      , 12.9607009579     ,
 14.2123679151     , 15.5339024392     , 16.7685223851     , 17.7421042576     ,
 18.3404837973     , 18.5433569742     , 18.4265692876     , 18.1320179708     ,
 17.7836480845     , 17.3915469427     , 16.8573374145     , 16.113654259      ,
 15.2528049605     , 14.4827465391     , 13.960495516      , 13.7140891033     ,
 13.7295920052     , 14.0399054629     , 14.6742998767     , 15.5606809292     ,
 16.5448972845     , 17.5175909625     , 18.4912647563     , 19.5435383688     ,
 20.7076850183     , 21.9132132142     , 22.9888900416     , 23.718630741      ,
 23.9442887566     , 23.6491846485     , 22.954995375      , 22.0637464589     ,
 21.208896436      , 20.6014304029     , 20.326986359      , 20.2472912949     ,
 20.0388261932     , 19.4006907305     , 18.2676465498     , 16.8254529003     ,
 15.3231778647     , 13.88298915       , 12.4769852645     , 11.0446791912     ,
 9.60524854133     , 8.25963074157     , 7.1019357254      , 6.1447634496      ,
 5.32757900327     , 4.57851087847     , 3.86192741494     , 3.18919742852     ,
 2.60992660981     , 2.18652978861     , 1.95141803103     , 1.88365694514     ,
 1.93167123828     , 2.04083438217     , 2.14707677035     , 2.17553087182     ,
 2.08524064394     , 1.91272990566     , 1.74781508958     , 1.66533376966     ,
 1.69091296222     , 1.81653372541     , 2.01214534044     , 2.21344141537     ,
 2.33031209533     , 2.2969886826      , 2.11975862871     , 1.87738624587     ,
 1.67635064806     , 1.5925099991      , 1.63324145487     , 1.7393626124      ,
 1.82179827371     , 1.80868437536     , 1.67544815993     , 1.44609132148     ,
 1.1748446067      , 0.922824133538    , 0.738066661255    , 0.64364051725     ,
 0.634568373506    , 0.680892668611    , 0.73939281049     , 0.777651452274    ,
 0.798267558685    , 0.839471548638    , 0.947134191553    , 1.1434708016      ,
 1.41815653065     , 1.74043407089     , 2.07763162562     , 2.41170291765     ,
 2.74328244052     , 3.07591782455     , 3.40158779675     , 3.71614694699     ,
 4.0475144671      , 4.44577811874     , 4.93210092076     , 5.47678484457     ,
 6.05265837425     , 6.6998033353      , 7.51071246676     , 8.55455554264     ,
 9.83015318657     , 11.2774865689     , 12.8294152246     , 14.4968521255     ,
 16.4233699334     , 18.7802772825     , 21.5130076915     , 24.191386586      ,
 31.5259772347     , 31.9969405098     , 31.0408851539     , 28.9924155897     ,
 26.2171233703     , 23.0200501923     , 19.6721592525     , 16.4015459298     ,
 13.3403016338     , 10.5354097703     , 8.03032870101     , 5.90432333267     ,
 4.2261365655      , 2.99690220037     , 2.14843666787     , 1.58490320186     ,
 1.22110614105     , 0.995087060026    , 0.867550630663    , 0.819813771949    ,
 0.842523937665    , 0.916667650055    , 1.00869855225     , 1.08557296657     ,
 1.12850539735     , 1.13311288044     , 1.10452181076     , 1.05442159094     ,
 0.997614864414    , 0.944991868303    , 0.895430690556    , 0.835644725539    ,
 0.752955926282    , 0.650076414038    , 0.545762543794    , 0.461317597687    ,
 0.408178539412    , 0.386702369713    , 0.392852671258    , 0.425427000091    ,
 0.487595789494    , 0.580825800979    , 0.702162183501    , 0.854899647899    ,
 1.05708045668     , 1.33109317235     , 1.69091323636     , 2.14040174235     ,
 2.66187408838     , 3.19565075638     , 3.6557713337      , 3.98693122838     ,
 4.19677130586     , 4.33393997038     , 4.46968239008     , 4.71184168311     ,
 5.18894161908     , 5.97494036843     , 7.02941853544     , 8.21949211039     ,
 9.40107152336     , 10.4993036273     , 11.5423962632     , 12.631581412      ,
 13.862995396      , 15.2408436694     , 16.6352348433     , 17.8251092364     ,
 18.6080120165     , 18.9041922949     , 18.7885853471     , 18.4336367396     ,
 17.9921512294     , 17.4934895129     , 16.8585707495     , 16.0529094378     ,
 15.211957805      , 14.5659413876     , 14.2485055621     , 14.2363570719     ,
 14.475204887      , 14.9877386908     , 15.8175740538     , 16.916573115      ,
 18.1476363254     , 19.400520642      , 20.6730935798     , 22.0259818931     ,
 23.4673281781     , 24.8798359162     , 26.0482245793     , 26.7629330128     ,
 26.9119378313     , 26.4976732934     , 25.620576826      , 24.4854386456     ,
 23.386470144      , 22.5981215545     , 22.2030308011     , 21.9961991686     ,
 21.5862269277     , 20.6543982585     , 19.1660726589     , 17.3508975056     ,
 15.4940234476     , 13.7548116578     , 12.1473764215     , 10.6298920094     ,
 9.19101638395     , 7.87379291154     , 6.73711479156     , 5.79981035378     ,
 5.02054323314     , 4.32681300013     , 3.66397129111     , 3.02920587546     ,
 2.47185643506     , 2.05777036607     , 1.8199068064      , 1.73885861966     ,
 1.76820207272     , 1.8610659399      , 1.9618530266      , 1.99953333711     ,
 1.92772019194     , 1.77257043792     , 1.61712927223     , 1.53599548909     ,
 1.5588314066      , 1.6828861371      , 1.88128464689     , 2.08834673453     ,
 2.21042778167     , 2.18245479165     , 2.01720915933     , 1.7983972783      ,
 1.63012837687     , 1.58459475278     , 1.6726858227      , 1.83983770129     ,
 1.98676102649     , 2.01521035807     , 1.87962228151     , 1.60966124645     ,
 1.28759144042     , 0.999678260844    , 0.797829974784    , 0.694093396572    ,
 0.677848758978    , 0.728043637961    , 0.813198648111    , 0.899009678552    ,
 0.971657766613    , 1.05113450174     , 1.172492711       , 1.35522899731     ,
 1.59608357369     , 1.88614686819     , 2.22507433089     , 2.61727872729     ,
 3.05576725043     , 3.50876444058     , 3.93129034603     , 4.30855664328     ,
 4.69091446644     , 5.16543949783     , 5.7784307358      , 6.50003135599     ,
 7.28307406144     , 8.14364092145     , 9.16097246245     , 10.4085903064     ,
 11.9054834522     , 13.621992966      , 15.5282187339     , 17.6729524559     ,
 20.2105236221     , 23.2483259361     , 26.5758319637     , 29.5786300615     ,
 37.3451260214     , 37.2050636001     , 35.4467536702     , 32.4994773654     ,
 28.7791258367     , 24.6546775086     , 20.5022820531     , 16.6470615065     ,
 13.2454037571     , 10.2908847038     , 7.7454544842      , 5.6282204637      ,
 3.98370698217     , 2.80944536561     , 2.03261818658     , 1.54308210671     ,
 1.24041242259     , 1.05966712609     , 0.97064524577     , 0.962976340669    ,
 1.02718643375     , 1.14147275404     , 1.27501015779     , 1.40092348063     ,
 1.49988232888     , 1.55616484795     , 1.56124722798     , 1.52032952464     ,
 1.44836286718     , 1.35901450774     , 1.25851342223     , 1.14808920872     ,
 1.03042124271     , 0.913439055122    , 0.807700961211    , 0.720260527854    ,
 0.65293209609     , 0.607183751255    , 0.588150352659    , 0.603265769027    ,
 0.658058762397    , 0.750640821325    , 0.872170063208    , 1.02331717814     ,
 1.23075525526     , 1.53449849697     , 1.95479280942     , 2.47208683878     ,
 3.02646061158     , 3.53093751104     , 3.90935370956     , 4.14441622566     ,
 4.28428561789     , 4.40050878677     , 4.55931725082     , 4.83285768658     ,
 5.29893586407     , 6.00373941339     , 6.93350814677     , 8.02426010703     ,
 9.18683342358     , 10.3356170952     , 11.4315162054     , 12.518733824      ,
 13.7025419642     , 15.051715748      , 16.4937429119     , 17.8052612872     ,
 18.7266826431     , 19.1147259919     , 19.0138578679     , 18.6059787475     ,
 18.0827244668     , 17.5246241948     , 16.8949031541     , 16.1759355026     ,
 15.4878984668     , 15.0213787916     , 14.873351702      , 15.011712773      ,
 15.3929343567     , 16.0475980248     , 17.0294545467     , 18.3219593747     ,
 19.8279135414     , 21.4453340999     , 23.1356508181     , 24.9054819253     ,
 26.7097405363     , 28.3718179037     , 29.6298878516     , 30.286478283      ,
 30.2931906024     , 29.6998280239     , 28.6080378529     , 27.2195743123     ,
 25.8532272764     , 24.8067363229     , 24.1479294543     , 23.6334808583     ,
 22.8550115345     , 21.5145216006     , 19.6118453263     , 17.4007772017     ,
 15.1853734176     , 13.1557136097     , 11.3643764324     , 9.78787977804     ,
 8.3922714793      , 7.16996619418     , 6.13753306493     , 5.30220361628     ,
 4.62985107142     , 4.04743489008     , 3.48356422585     , 2.91673164946     ,
 2.38955758165     , 1.97330412277     , 1.71321012913     , 1.60441035535     ,
 1.61137849734     , 1.69168901019     , 1.79136827058     , 1.84038741581     ,
 1.78957872583     , 1.65713224536     , 1.51663841514     , 1.43581398499     ,
 1.44156273437     , 1.53331640779     , 1.69203781078     , 1.86367646045     ,
 1.96612221873     , 1.94402625906     , 1.81656703012     , 1.66411149227     ,
 1.5736827566      , 1.59672919491     , 1.73574293068     , 1.94099201026     ,
 2.11605588834     , 2.15530933505     , 2.00703221307     , 1.71074274698     ,
 1.37063836112     , 1.08673113244     , 0.903400635772    , 0.81382327412     ,
 0.79903478398     , 0.848617852428    , 0.946999629519    , 1.06323752637     ,
 1.17245998755     , 1.28054887505     , 1.41367272698     , 1.58766274429     ,
 1.80175033834     , 2.06264036297     , 2.40038631883     , 2.84773319025     ,
 3.39792165051     , 3.98363129295     , 4.51303692833     , 4.95088232186     ,
 5.36922776702     , 5.89951277087     , 6.62311636305     , 7.5192061271      ,
 8.5250403152      , 9.62856405363     , 10.8880361868     , 12.3821833029     ,
 14.1662794187     , 16.2663691206     , 18.7052767499     , 21.5485827429     ,
 24.8923340069     , 28.6944298525     , 32.5467714263     , 35.6831769339     ,
 42.916181335      , 41.9423964809     , 39.2297610836     , 35.2917688179     ,
 30.5921681113     , 25.5535902265     , 20.6370778498     , 16.253044455      ,
 12.5867928849     , 9.58491865938     , 7.12100808099     , 5.13552487145     ,
 3.63058783868     , 2.59120492784     , 1.94124096589     , 1.56266703474     ,
 1.34502064844     , 1.22191600234     , 1.17278263239     , 1.19879061286     ,
 1.2966896971      , 1.44859558812     , 1.63025311875     , 1.8199878311      ,
 1.99217010935     , 2.11187585856     , 2.15193409315     , 2.11301903257     ,
 2.01764395719     , 1.88800070211     , 1.73648192862     , 1.57351607286     ,
 1.41460799716     , 1.27554616451     , 1.16269619974     , 1.06986655191     ,
 0.98675563378     , 0.912798288195    , 0.8617702446      , 0.852620253823    ,
 0.896787857978    , 0.989400051788    , 1.11168324221     , 1.25504731048     ,
 1.4478034994      , 1.74202470495     , 2.16311689968     , 2.67543257468     ,
 3.19335998022     , 3.62252143703     , 3.90989523095     , 4.07773664433     ,
 4.20849282584     , 4.38722734743     , 4.65803658766     , 5.02893888181     ,
 5.50221207521     , 6.0977973161      , 6.85624277771     , 7.81139946193     ,
 8.94164886015     , 10.1514439664     , 11.3303097274     , 12.4507328824     ,
 13.5974273485     , 14.8747393097     , 16.2676724694     , 17.5890724692     ,
 18.5709333377     , 19.0276845834     , 18.9624008837     , 18.5501063428     ,
 18.0210230294     , 17.5202473684     , 17.0609381343     , 16.6210476845     ,
 16.2508330252     , 16.0449095855     , 16.0492199305     , 16.2589677757     ,
 16.6948452077     , 17.431328758      , 18.5437990599     , 20.044762971      ,
 21.8664088167     , 23.8951620752     , 26.0302758187     , 28.207153296      ,
 30.3332998451     , 32.1975720647     , 33.5102325961     , 34.0795352858     ,
 33.904204257      , 33.084401216      , 31.743609251      , 30.0847859066     ,
 28.4219668436     , 27.0379503483     , 25.9778046907     , 24.9977375483     ,
 23.7334938391     , 21.9478768609     , 19.6675226486     , 17.130756217      ,
 14.6246283709     , 12.3537454715     , 10.4071334493     , 8.78763415089     ,
 7.45468556773     , 6.36163577926     , 5.47718156846     , 4.78111112219     ,
 4.23904310678     , 3.78351431649     , 3.33305881534     , 2.8442313867      ,
 2.34601346401     , 1.91564202238     , 1.61816102138     , 1.46895650918     ,
 1.44319552189     , 1.49975038939     , 1.58529499904     , 1.63515330143     ,
 1.60423465546     , 1.50445263043     , 1.39299735655     , 1.32017400336     ,
 1.30280735222     , 1.34116769241     , 1.42937809935     , 1.53682487035     ,
 1.60673379445     , 1.60074279135     , 1.54026191345     , 1.49077762464     ,
 1.51107386928     , 1.62388064879     , 1.81659485273     , 2.04062326685     ,
 2.2089629178      , 2.22757495458     , 2.0588939601      , 1.75849966313     ,
 1.44124362056     , 1.20337432107     , 1.07025897211     , 1.01285969766     ,
 1.0035704783      , 1.04229788947     , 1.13151578104     , 1.25120883174     ,
 1.37602456136     , 1.50524843046     , 1.6572163554      , 1.83937062605     ,
 2.04455167176     , 2.28448266767     , 2.61329811945     , 3.09651304933     ,
 3.74062860523     , 4.45240931309     , 5.09065005902     , 5.58945190077     ,
 6.03505140982     , 6.60271742965     , 7.41419241905     , 8.46635148118     ,
 9.68853278513     , 11.0434082611     , 12.5698979845     , 14.3603234274     ,
 16.5226369129     , 19.1522386961     , 22.3150666679     , 26.0407634441     ,
 30.2778780792     , 34.7610876734     , 38.8902217131     , 41.8365473259     ,
 47.3012157566     , 45.2620604679     , 41.4884127385     , 36.5679659211     ,
 31.0074025757     , 25.2597507826     , 19.8200859628     , 15.1313754398     ,
 11.383504321      , 8.48085320649     , 6.22094767535     , 4.47041360766     ,
 3.18715623125     , 2.34190747636     , 1.85812109448     , 1.61801562539     ,
 1.50932608842     , 1.46523207666     , 1.46848514017     , 1.52707880256     ,
 1.64798615184     , 1.82684447465     , 2.05251260615     , 2.3078675369      ,
 2.55629451069     , 2.73971542274     , 2.81126466526     , 2.76983815858     ,
 2.65122606699     , 2.48961416795     , 2.29949581461     , 2.0915665324      ,
 1.88901234057     , 1.7184861536      , 1.58950550605     , 1.48797519225     ,
 1.39157308922     , 1.29365170822     , 1.21272459495     , 1.17916424533     ,
 1.21272685495     , 1.3057650051      , 1.42547981864     , 1.54712721489     ,
 1.69263981634     , 1.91978426806     , 2.26128680998     , 2.68196585631     ,
 3.09688159158     , 3.42565658208     , 3.64191631149     , 3.79316093769     ,
 3.97600782023     , 4.27416494275     , 4.7006887772      , 5.19326142383     ,
 5.67740967557     , 6.15272703814     , 6.71928163724     , 7.50563967509     ,
 8.55694603753     , 9.78794148614     , 11.0519094789     , 12.2646822494     ,
 13.460444076      , 14.7226322028     , 16.0584758472     , 17.3317465844     ,
 18.3121150001     , 18.8092539847     , 18.7976976567     , 18.4447074706     ,
 18.0140805053     , 17.7053002169     , 17.5642360638     , 17.5412489532     ,
 17.5925892387     , 17.7016224912     , 17.8631650668     , 18.1122597995     ,
 18.5541948145     , 19.3310611386     , 20.5564238631     , 22.269090402      ,
 24.4087485811     , 26.8224584917     , 29.3271392193     , 31.7836119357     ,
 34.0744852978     , 36.0004032238     , 37.2838521058     , 37.7383199714     ,
 37.3767826889     , 36.3258956149     , 34.7303902996     , 32.7915631788     ,
 30.7975589361     , 28.9966115851     , 27.4208928123     , 25.8691238724     ,
 24.0723726142     , 21.8798785868     , 19.3304327536     , 16.6074584224     ,
 13.9434226113     , 11.5354320504     , 9.50207344778     , 7.87710016619     ,
 6.6240419664      , 5.66507097133     , 4.92080286109     , 4.34054743391     ,
 3.89312843978     , 3.52787956408     , 3.16412029862     , 2.73978826783     ,
 2.26725375835     , 1.82544161162     , 1.49481999756     , 1.30589711569     ,
 1.24084050805     , 1.26010728176     , 1.31495402894     , 1.35202068371     ,
 1.33575665167     , 1.27293652107     , 1.20003890307     , 1.1441446396      ,
 1.10889279401     , 1.0952252677      , 1.1121281353      , 1.15656401973     ,
 1.20241996968     , 1.22906052569     , 1.25311515592     , 1.3172861438      ,
 1.45242961707     , 1.65831380709     , 1.90670127259     , 2.14112282195     ,

 2.28006416466     , 2.25321912516     , 2.05625892413     , 1.76738012497     ,
 1.50055334912     , 1.33235061211     , 1.26332435967     , 1.24578004321     ,
 1.24571260545     , 1.26994200531     , 1.33686445369     , 1.44347428599     ,
 1.57489163525     , 1.73049800228     , 1.91917357916     , 2.13370942798     ,
 2.35425555507     , 2.59092404594     , 2.9136262758      , 3.41572274865     ,
 4.12345821631     , 4.93454706042     , 5.67329284848     , 6.2444058009      ,
 6.73627415579     , 7.35367445379     , 8.25260768718     , 9.45125668971     ,
 10.879321749      , 12.4843480192     , 14.2996631865     , 16.4471750551     ,
 19.0951616246     , 22.393169997      , 26.4035928897     , 31.0466809524     ,
 36.0502087207     , 40.9008119587     , 44.8644685144     , 47.1667086923     ,
 49.6929685865     , 46.3573605859     , 41.4725743972     , 35.7014925974     ,
 29.5778843226     , 23.5315675478     , 18.0009147556     , 13.3726851956     ,
 9.80004988968     , 7.15790608176     , 5.2025446717      , 3.7521296202      ,
 2.72944960133     , 2.09393739921     , 1.77626710804     , 1.67336526121     ,
 1.68381498455     , 1.73986974603     , 1.81448024306     , 1.9105054719      ,
 2.04523115272     , 2.23614941619     , 2.49088083662     , 2.79650298436     ,
 3.10533810327     , 3.34047553164     , 3.44005577006     , 3.4023552488      ,
 3.27560612985     , 3.10382709133     , 2.89744217658     , 2.65841248115     ,
 2.41272925787     , 2.20171863627     , 2.04741389651     , 1.93592183363     ,
 1.83491538319     , 1.72676389859     , 1.62629657964     , 1.56900707476     ,
 1.58219199085     , 1.65924112857     , 1.75812112307     , 1.83893670133     ,
 1.91117171454     , 2.02928498768     , 2.23327196434     , 2.50469154824     ,
 2.78328942921     , 3.0161358738      , 3.1960953816      , 3.37408625987     ,
 3.63976636273     , 4.06559687091     , 4.6368559626      , 5.23436256845     ,
 5.72318946222     , 6.08911816285     , 6.47917703973     , 7.09159367574     ,
 8.02415136984     , 9.22017807272     , 10.5415061592     , 11.8832413118     ,
 13.2234264313     , 14.5805298543     , 15.9374201846     , 17.1934904051     ,
 18.1747820963     , 18.7169910868     , 18.7892422432     , 18.5593025371     ,
 18.315540119      , 18.2873737971     , 18.5263720942     , 18.9457566983     ,
 19.4258820832     , 19.8701497039     , 20.2360022024     , 20.580213295      ,
 21.0625861643     , 21.8790389867     , 23.1865899582     , 25.0574396421     ,
 27.4380560001     , 30.1313366199     , 32.8665997635     , 35.4262320061     ,
 37.6764412112     , 39.4618338688     , 40.5585281079     , 40.8039212237     ,
 40.2146739808     , 38.9268651393     , 37.0930367638     , 34.8920150236     ,
 32.560183617      , 30.3035825342     , 28.163899741      , 26.0176917762     ,
 23.7144804998     , 21.1932065196     , 18.4966348051     , 15.7401673789     ,
 13.0820680626     , 10.6867464079     , 8.68063009301     , 7.11830807841     ,
 5.96863487314     , 5.13059100737     , 4.48776820314     , 3.96948531917     ,
 3.55563245131     , 3.22077284883     , 2.8977949125      , 2.51887254732     ,
 2.08273945461     , 1.65916441882     , 1.32640603173     , 1.11699419974     ,
 1.01770562414     , 0.996026568562    , 1.01348562365     , 1.02976757349     ,
 1.01848763467     , 0.982307331548    , 0.940526257835    , 0.90174460633     ,
 0.859880818263    , 0.816161027077    , 0.78963303934     , 0.79820718638     ,
 0.840585334298    , 0.908279859587    , 1.00817792942     , 1.16160394941     ,
 1.38335001407     , 1.66471359943     , 1.96517123702     , 2.21059139782     ,
 2.31559006239     , 2.23606485957     , 2.00956980483     , 1.7380509045      ,
 1.52585968619     , 1.42296573046     , 1.40967404271     , 1.43061107801     ,
 1.44966848756     , 1.47410633535     , 1.53028583091     , 1.63229053833     ,
 1.78224567217     , 1.98396021969     , 2.23466411546     , 2.50854306968     ,
 2.77381488292     , 3.04128213064     , 3.38997687497     , 3.92513056721     ,
 4.68434399069     , 5.5704343648      , 6.4003106152      , 7.06247736329     ,
 7.63469179174     , 8.32944781913     , 9.32890855434     , 10.6807746906     ,
 12.3276166774     , 14.2121440177     , 16.3720946454     , 18.9653634857     ,
 22.2084738513     , 26.2607589816     , 31.1092388272     , 36.4935745326     ,
 41.8903630966     , 46.5768816024     , 49.7842000813     , 50.9055337827     ,
 49.6720699194     , 44.9156153997     , 38.9958988009     , 32.6371818672     ,
 26.3639974025     , 20.5135625095     , 15.3725603924     , 11.1872079513     ,
 8.03946515483     , 5.79461767007     , 4.21018295536     , 3.08686966231     ,
 2.32342150747     , 1.87228123061     , 1.68230502497     , 1.68277364641     ,
 1.79652692486     , 1.95482631118     , 2.1100399461      , 2.24936967794     ,
 2.39653924884     , 2.59063975343     , 2.85662530397     , 3.18513529196     ,
 3.52378860711     , 3.78956974313     , 3.91486923168     , 3.89646385235     ,
 3.7881868174      , 3.63726371757     , 3.44373256066     , 3.19377881343     ,
 2.9121280174      , 2.65784190756     , 2.47399487212     , 2.3550456838      ,
 2.26154332635     , 2.16019115129     , 2.05101867283     , 1.96326494103     ,
 1.92894444006     , 1.95259731206     , 2.00052260265     , 2.02966844535     ,
 2.03380974881     , 2.04998950801     , 2.11593408739     , 2.23476476578     ,
 2.383246071       , 2.54052291438     , 2.70906258063     , 2.9268268958      ,
 3.26481723716     , 3.78301563654     , 4.45028317983     , 5.11410516029     ,
 5.60387272254     , 5.89818010431     , 6.17110618561     , 6.65627701656     ,
 7.47609458081     , 8.59700519418     , 9.91271986951     , 11.3391637168     ,
 12.8319554669     , 14.347763309      , 15.8183126667     , 17.1455321252     ,
 18.1978775015     , 18.8465704143     , 19.0701398615     , 19.0371941154     ,
 19.0427009008     , 19.3211016949     , 19.9161997987     , 20.71984179       ,
 21.5843762522     , 22.3871434062     , 23.0662123472     , 23.6636470436     ,
 24.3271468222     , 25.2510039247     , 26.6139604988     , 28.5316535188     ,
 30.9870607885     , 33.7730304817     , 36.5521881197     , 39.0256123634     ,
 41.0262343675     , 42.4368346507     , 43.1061651282     , 42.9292770621     ,
 41.9585630201     , 40.3588106431     , 38.2865113811     , 35.8687668113     ,
 33.2550385212     , 30.5954074006     , 27.9515477013     , 25.2875019265     ,
 22.5634918861     , 19.7988208247     , 17.0505376773     , 14.3863097282     ,
 11.8912961122     , 9.67006716357     , 7.82139333552     , 6.39914400773     ,
 5.37614963331     , 4.64254441184     , 4.06603110606     , 3.57127463776     ,
 3.15199763923     , 2.80728592715     , 2.49312358008     , 2.15301178863     ,
 1.7790944042      , 1.41954420577     , 1.12895995446     , 0.928411916599    ,
 0.809741761088    , 0.75483170421     , 0.739697718738    , 0.734584436031    ,
 0.718002004537    , 0.689731200032    , 0.660503684034    , 0.631460352471    ,
 0.593592475701    , 0.547420288648    , 0.51357281961     , 0.518207591547    ,
 0.572686958501    , 0.673119772184    , 0.816306064014    , 1.01034969579     ,
 1.26846397718     , 1.58737415784     , 1.92087964251     , 2.17612416794     ,
 2.25932410492     , 2.14665686148     , 1.90906822382     , 1.66218111751     ,
 1.4947860217      , 1.4343470143      , 1.45461235498     , 1.50727925713     ,
 1.55982483533     , 1.61431080042     , 1.69498088993     , 1.82661594612     ,
 2.02791937136     , 2.30882056975     , 2.6545671439      , 3.02056538806     ,
 3.36893009129     , 3.72033984624     , 4.16180898693     , 4.79186481853     ,
 5.63821532443     , 6.60765416406     , 7.52946764013     , 8.29200391598     ,
 8.95776304988     , 9.73488617817     , 10.8344715444     , 12.3522883794     ,
 14.260745739      , 16.5010517945     , 19.1060993776     , 22.2499245576     ,
 26.1611749713     , 30.9512199345     , 36.463203027      , 42.2110023744     ,
 47.4380359618     , 51.301950172      , 53.1209802842     , 52.5561092436     ,
 47.2542865211     , 41.2103209781     , 34.5406609559     , 27.9698552442     ,
 21.9605733706     , 16.712281682      , 12.3156274398     , 8.8390603751      ,
 6.27925566853     , 4.50739798474     , 3.31387181808     , 2.50770206998     ,
 1.97413952214     , 1.66233316083     , 1.5464538079      , 1.59841383365     ,
 1.77306552685     , 2.00450819971     , 2.22649085918     , 2.40971952466     ,
 2.57729412788     , 2.77754481839     , 3.0422390533      , 3.36445930156     ,
 3.69719849201     , 3.96671706634     , 4.11048315097     , 4.12433934794     ,
 4.0609296767      , 3.96306409945     , 3.81455853215     , 3.58061656928     ,
 3.28066817824     , 2.9913714721      , 2.78103328155     , 2.65832575416     ,
 2.58069061377     , 2.4976372618      , 2.3856699805      , 2.2567905671      ,
 2.14493979073     , 2.07785755655     , 2.05171634465     , 2.03663665265     ,
 2.01036533168     , 1.97788573433     , 1.95830747341     , 1.96775465874     ,
 2.01809110793     , 2.11882921997     , 2.27811686821     , 2.51765271754     ,
 2.88917998763     , 3.44316267141     , 4.14405980528     , 4.8316612426      ,
 5.32720036818     , 5.60882213806     , 5.85657421573     , 6.30503531497     ,
 7.06793356188     , 8.10984627349     , 9.35198551048     , 10.7602525139     ,
 12.3209151772     , 13.9714376375     , 15.5962794792     , 17.0726390724     ,
 18.286894992      , 19.1423055737     , 19.6270040024     , 19.8921130281     ,
 20.2080306922     , 20.793940113      , 21.6922333496     , 22.8076185073     ,
 24.0168549677     , 25.2201836852     , 26.3535572534     , 27.4130159008     ,
 28.4639798575     , 29.6226721768     , 31.0415871977     , 32.8773232271     ,
 35.187304047      , 37.8119174067     , 40.3950038698     , 42.5684063188     ,
 44.1056301088     , 44.8931268954     , 44.8470265935     , 43.9551346805     ,
 42.3598432272     , 40.2968247708     , 37.9392415235     , 35.349164353      ,
 32.5642601127     , 29.6545098157     , 26.6795321918     , 23.6641354914     ,
 20.6514366161     , 17.7335767206     , 15.0066255956     , 12.5254573158     ,
 10.3125586406     , 8.3905916608      , 6.79842294821     , 5.57091967323     ,
 4.68810530757     , 4.05024212248     , 3.53114904974     , 3.06142874493     ,
 2.64331787685     , 2.29105844795     , 1.98517222241     , 1.69198180741     ,
 1.40415334747     , 1.142458807       , 0.926078808098    , 0.758164237637    ,
 0.636871424376    , 0.561970899978    , 0.524551629645    , 0.502487524534    ,
 0.476189079871    , 0.4439346722      , 0.414593463238    , 0.389950080027    ,
 0.362677866867    , 0.331605248622    , 0.312542045783    , 0.329573115172    ,
 0.39638028413     , 0.508748923106    , 0.656369703133    , 0.841828319464    ,
 1.08411635504     , 1.39171813154     , 1.72192402343     , 1.97550388653     ,
 2.05685519541     , 1.95292099795     , 1.74511789692     , 1.54248556208     ,
 1.41393264177     , 1.37496015672     , 1.40809736589     , 1.4842259366      ,
 1.58085987545     , 1.69550506469     , 1.8451350066      , 2.05673719702     ,
 2.35930932637     , 2.76817473094     , 3.25931927307     , 3.77279040057     ,
 4.26938182647     , 4.78527347411     , 5.41513472372     , 6.23705644059     ,
 7.24562261788     , 8.33511808028     , 9.34948250947     , 10.1919772635     ,
 10.9233652004     , 11.7553899894     , 12.9375909003     , 14.6284939491     ,
 16.8426332002     , 19.5172575627     , 22.6558201431     , 26.4037277036     ,
 30.9467419597     , 36.295674297      , 42.114122069      , 47.6937123128     ,
 52.1088108675     , 54.5134856385     , 54.4349067156     , 51.8818233881     ,
 42.8071508569     , 35.9049549378     , 28.962835905      , 22.6053112777     ,
 17.1831117247     , 12.7601765228     , 9.256702096       , 6.58297878461     ,
 4.6563811103      , 3.35838798295     , 2.5257940822      , 1.99384804947     ,
 1.64586848822     , 1.43045645242     , 1.34482880886     , 1.39958878521     ,
 1.5807424796      , 1.83321720084     , 2.08647243473     , 2.30265499254     ,
 2.49664191869     , 2.7088002864      , 2.96491399139     , 3.25910390023     ,
 3.55632731919     , 3.80154369698     , 3.94693052636     , 3.99334834609     ,
 3.99044425437     , 3.96942047736     , 3.89202169814     , 3.69999250772     ,
 3.40512140262     , 3.09790168204     , 2.86936092681     , 2.74435083765     ,
 2.68307345877     , 2.62256530846     , 2.51464803679     , 2.34831057185     ,
 2.1556618517      , 1.99140606041     , 1.89200034519     , 1.85123555798     ,
 1.83473075852     , 1.81095530588     , 1.77021453693     , 1.72890576416     ,
 1.72168083546     , 1.78073196579     , 1.92038912633     , 2.15263247331     ,
 2.51501063566     , 3.04998594729     , 3.72608265219     , 4.39934295925     ,
 4.90928963273     , 5.23858962692     , 5.55235950887     , 6.05783247775     ,
 6.83797886109     , 7.83673609736     , 8.98759521173     , 10.3095526181     ,
 11.8501596448     , 13.5687454473     , 15.3253498525     , 16.9712950055     ,
 18.406521869      , 19.5692119219     , 20.4484521664     , 21.1424717158     ,
 21.8534772105     , 22.7656088453     , 23.9343186676     , 25.3118874292     ,
 26.8369348669     , 28.4636299408     , 30.1423479989     , 31.8117189087     ,
 33.4098880467     , 34.9140290753     , 36.4025629523     , 38.0542632114     ,
 40.012616912      , 42.2054625396     , 44.3124856563     , 45.9334868118     ,
 46.7785284195     , 46.708835881      , 45.6948746748     , 43.8377415964     ,
 41.4040387425     , 38.7246230353     , 36.0052600168     , 33.2602605698     ,
 30.4240373092     , 27.4672823265     , 24.4013292272     , 21.259651641      ,
 18.1330973077     , 15.1804285851     , 12.555008271      , 10.3228192211     ,
 8.45504776183     , 6.88829080387     , 5.59165634194     , 4.57634445352     ,
 3.83562279015     , 3.29484776603     , 2.84824667743     , 2.43548703586     ,
 2.05825430386     , 1.73348930909     , 1.45928623802     , 1.22512549643     ,
 1.02831994848     , 0.866907692438    , 0.728892189908    , 0.602334076581    ,
 0.491356917032    , 0.410306128756    , 0.361938254543    , 0.33040692392     ,
 0.298373027629    , 0.26374088943     , 0.235051827832    , 0.216041714974    ,
 0.201540392347    , 0.188333144908    , 0.185739472925    , 0.211887820503    ,
 0.278337223406    , 0.379885338178    , 0.50338065518     , 0.649629059604    ,
 0.841673854979    , 1.09752685001     , 1.386063854       , 1.62078430579     ,
 1.71820778543     , 1.66810119465     , 1.5367012174      , 1.40507360916     ,
 1.31984396044     , 1.2951176727      , 1.33209182134     , 1.42635798309     ,
 1.57167289816     , 1.76857094364     , 2.02923975275     , 2.37717150008     ,
 2.84444824136     , 3.45244534633     , 4.17795696        , 4.9561246659      ,
 5.74508873097     , 6.58011890709     , 7.54063584717     , 8.66389059127     ,
 9.89453204118     , 11.1031529887     , 12.1535654536     , 12.9921963593     ,
 13.7158492245     , 14.5624909685     , 15.817781167      , 17.6897951661     ,
 20.2281052219     , 23.3604668228     , 27.0348059968     , 31.3120576202     ,
 36.2719753885     , 41.7909364092     , 47.3708085431     , 52.1521487444     ,
 55.1498646817     , 55.6314599814     , 53.4207441024     , 48.9090365798     ,
 36.9554062888     , 29.7776642873     , 23.0920838966     , 17.3296563981     ,
 12.6974566347     , 9.15686317032     , 6.52319039597     , 4.60356000946     ,
 3.25771729401     , 2.37577083214     , 1.83965110202     , 1.52022758995     ,
 1.31083606825     , 1.16230562755     , 1.08534025473     , 1.11438841436     ,
 1.25897691773     , 1.48201324503     , 1.72409483681     , 1.94782234039     ,
 2.15609339783     , 2.37212078734     , 2.61045551989     , 2.86514267792     ,
 3.11128385265     , 3.31155028062     , 3.43840892904     , 3.50643513466     ,
 3.56362393327     , 3.62340524226     , 3.62264540666     , 3.48386294995     ,
 3.21351250952     , 2.90949023429     , 2.67579236496     , 2.55035080967     ,
 2.5025647232      , 2.46756188482     , 2.38001637827     , 2.206389694       ,
 1.97034133987     , 1.74336462014     , 1.59453276148     , 1.54144700143     ,
 1.54606467598     , 1.55162534447     , 1.52503410718     , 1.47660149078     ,
 1.44856163279     , 1.4828677073      , 1.59862874096     , 1.80522616221     ,
 2.13054569862     , 2.60842740987     , 3.21706648904     , 3.84781356491     ,
 4.37803791877     , 4.79534808668     , 5.23113420929     , 5.84816616501     ,
 6.69847552047     , 7.71211816814     , 8.82748227444     , 10.0936099857     ,
 11.603212482      , 13.3458439652     , 15.1830632544     , 16.9690103856     ,
 18.6432757843     , 20.1951331529     , 21.6034341977     , 22.8699891813     ,
 24.0784824618     , 25.3551348499     , 26.7807853498     , 28.381084592      ,
 30.1748063181     , 32.1811810866     , 34.375566189      , 36.6434130303     ,
 38.7872282761     , 40.6313936987     , 42.1656998947     , 43.5659174475     ,
 45.0275162602     , 46.553673927      , 47.8949771908     , 48.6815917169     ,
 48.6045599754     , 47.5075133394     , 45.4046777078     , 42.4996358604     ,
 39.1688744315     , 35.8219299694     , 32.7008762966     , 29.8073997636     ,
 27.0112028716     , 24.1873527749     , 21.2636729619     , 18.2355270797     ,
 15.2065243444     , 12.3824052141     , 9.96504408365     , 8.0335357993      ,
 6.52217991532     , 5.30289779788     , 4.29168597608     , 3.48187955888     ,
 2.8810031642      , 2.44353893559     , 2.08923256961     , 1.76668423799     ,
 1.47084762322     , 1.21197461018     , 0.995061612046    , 0.824505261222    ,
 0.702897777386    , 0.617105461655    , 0.539184628972    , 0.450392762807    ,
 0.358273264846    , 0.283708113872    , 0.235394533758    , 0.203115891745    ,
 0.173478568985    , 0.144633193464    , 0.123429287558    , 0.113325104265    ,
 0.109919289715    , 0.108427733636    , 0.113136211288    , 0.136713664096    ,
 0.188348738687    , 0.263663043748    , 0.35079854787     , 0.450055442199    ,
 0.583070140859    , 0.770877285578    , 0.997091383407    , 1.2019629304      ,
 1.32575875908     , 1.35688400737     , 1.3297875427      , 1.28511823479     ,
 1.24843456332     , 1.24022888471     , 1.28408941962     , 1.40066196956     ,
 1.60436808908     , 1.90764583088     , 2.3237610064      , 2.87199697168     ,
 3.58744233128     , 4.51058965162     , 5.64842976792     , 6.95689730507     ,
 8.37844403623     , 9.881445965       , 11.4413703474     , 12.9919313262     ,
 14.4143103754     , 15.5830023724     , 16.4372190899     , 17.0398416123     ,
 17.5921044524     , 18.3875975864     , 19.7236400378     , 21.8047681008     ,
 24.6745406038     , 28.2318014956     , 32.3424773299     , 36.9289966949     ,
 41.9093203791     , 47.0194510281     , 51.6726124667     , 54.9934234577     ,
 56.0821076256     , 54.4186666421     , 50.1509554564     , 44.0164689801     ,
 30.465095831      , 23.5430965942     , 17.5324895997     , 12.6251824946     ,
 8.87461827733     , 6.1717502858      , 4.29009059954     , 2.99556702416     ,
 2.12222276221     , 1.56910935245     , 1.25396068085     , 1.08379891234     ,
 0.971318923895    , 0.873278061577    , 0.803762642944    , 0.804049277849    ,
 0.896386136566    , 1.062514825       , 1.26083984299     , 1.45924954535     ,
 1.65113632824     , 1.84618405939     , 2.05193926514     , 2.26206394602     ,
 2.45485965292     , 2.60325905267     , 2.69919635496     , 2.77389989326     ,
 2.87291241711     , 2.99008771571     , 3.04409228769     , 2.9515300856      ,
 2.71922882987     , 2.44324762578     , 2.22546509532     , 2.10909917832     ,
 2.07631652517     , 2.07141873385     , 2.02426580956     , 1.88496469412     ,
 1.66249645084     , 1.42729423537     , 1.26159892251     , 1.19886729586     ,
 1.20692962259     , 1.22423835564     , 1.21107371103     , 1.17369611875     ,
 1.15037450318     , 1.1791172542      , 1.27814608824     , 1.45607154723     ,
 1.73329550597     , 2.13594551408     , 2.65687939128     , 3.23286748221     ,
 3.78596549859     , 4.3039838701      , 4.87185684282     , 5.60337983015     ,
 6.53676407968     , 7.61602244051     , 8.79025747907     , 10.1052221292     ,
 11.651591422      , 13.4291929924     , 15.3206449389     , 17.2218934054     ,
 19.1468071574     , 21.1527054281     , 23.1995329517     , 25.1576302535     ,
 26.9482480785     , 28.6159344215     , 30.2742218063     , 32.0405189792     ,
 34.019430459      , 36.2876594118     , 38.8384339411     , 41.508556142      ,
 43.9897656904     , 45.9966940928     , 47.461429992      , 48.5364937737     ,
 49.4009286108     , 50.0737412983     , 50.383663984      , 50.0662421877     ,
 48.8821230472     , 46.7036496986     , 43.5786169419     , 39.7664334124     ,
 35.6949833851     , 31.8044941611     , 28.3579718038     , 25.3677418147     ,
 22.6797415959     , 20.1031021377     , 17.4883136533     , 14.7791280434     ,
 12.0635279218     , 9.55483337905     , 7.46625278998     , 5.87623776956     ,
 4.70227303729     , 3.79119869939     , 3.03698025008     , 2.42244941571     ,
 1.96177233186     , 1.63190537264     , 1.37717164536     , 1.15614089546     ,
 0.957257256657    , 0.781253054289    , 0.631804693366    , 0.518315079106    ,
 0.446974097791    , 0.40458478409     , 0.362914729051    , 0.304210917982    ,
 0.235960047526    , 0.177510825368    , 0.138149038977    , 0.112173799835    ,
 0.0908258531004   , 0.072723250105    , 0.062087037132    , 0.0606132683969   ,
 0.064022321879    , 0.0670769834711   , 0.0711313641301   , 0.0847969934369   ,
 0.115447220101    , 0.160949686422    , 0.213330692924    , 0.273144488637    ,
 0.357039374535    , 0.483693924864    , 0.649587570581    , 0.824544941299    ,
 0.975457292437    , 1.08811583271     , 1.16194633215     , 1.19771532147     ,
 1.20561224247     , 1.21819211979     , 1.28254032292     , 1.44319038346     ,
 1.73675946502     , 2.19244348647     , 2.83044810925     , 3.67427757369     ,
 4.78224304425     , 6.25843057702     , 8.20552760488     , 10.6445017655     ,
 13.4572300026     , 16.3834903968     , 19.0797588354     , 21.2239921138     ,
 22.6193996247     , 23.2544963466     , 23.3115050704     , 23.1292674283     ,
 23.1223349116     , 23.6743177672     , 25.0524632796     , 27.3710600588     ,
 30.5846893811     , 34.5088035        , 38.8865328375     , 43.4571881988     ,
 47.9464889077     , 51.9757614528     , 54.9753830533     , 56.2168470661     ,
 55.0399994926     , 51.2137238574     , 45.1807770603     , 37.9178496866     ,
 24.0581440901     , 17.7640864844     , 12.6640199048     , 8.72265127757     ,
 5.85113543787     , 3.88963206667     , 2.61039273893     , 1.78744919434     ,
 1.26141282027     , 0.944463871332    , 0.779418995729    , 0.703796782441    ,
 0.653972172474    , 0.596155559315    , 0.541717960379    , 0.526504835972    ,
 0.57524975421     , 0.683107962566    , 0.824094733147    , 0.972559464556    ,
 1.11853954672     , 1.26732613719     , 1.42598404557     , 1.58815509429     ,
 1.73094283277     , 1.83161500303     , 1.8951425147      , 1.9622556907      ,
 2.07176362639     , 2.20369113149     , 2.27546368505     , 2.21488759976     ,
 2.03268202873     , 1.81169958901     , 1.63652191419     , 1.54629916112     ,
 1.534318627       , 1.55960420558     , 1.55875933488     , 1.47667789425     ,
 1.30839060424     , 1.10973206779     , 0.956316291303    , 0.885763526435    ,
 0.876860995916    , 0.880439595106    , 0.866039835296    , 0.840790215094    ,
 0.833562738127    , 0.869624831777    , 0.960040433545    , 1.11057905797     ,
 1.33592819726     , 1.65926419778     , 2.09257266806     , 2.61762055607     ,
 3.19554507669     , 3.80768784137     , 4.48868272714     , 5.30759910132     ,
 6.30781619901     , 7.47528242439     , 8.78246047238     , 10.2512374784     ,
 11.9318109822     , 13.8115304491     , 15.7998741743     , 17.8518864204     ,
 20.0651877332     , 22.5668973833     , 25.2992234131     , 27.996386454      ,
 30.4000100384     , 32.4544792456     , 34.301874436      , 36.1567605167     ,
 38.2058269182     , 40.5618825217     , 43.2096398779     , 45.9357504365     ,
 48.3697380393     , 50.1999035682     , 51.3613309222     , 51.9740935264     ,
 52.1336776951     , 51.8096148967     , 50.9012650077     , 49.3104526356     ,
 46.9557599482     , 43.792813993      , 39.8913021046     , 35.5049383824     ,
 31.0399647928     , 26.9093604916     , 23.3635826749     , 20.4192564402     ,
 17.9199340934     , 15.6507928365     , 13.4286608513     , 11.1676968322     ,
 8.9267705424      , 6.88431014874     , 5.22006364918     , 3.99449705104     ,
 3.12792157659     , 2.48067153322     , 1.95355420607     , 1.52395749678     ,
 1.20205886153     , 0.976323259567    , 0.811578081017    , 0.678389843573    ,
 0.56355589172     , 0.461356711921    , 0.371471310343    , 0.301892182943    ,
 0.259815433385    , 0.23741633099     , 0.214767794097    , 0.179046854388    ,
 0.135298497813    , 0.096885257078    , 0.0706441162649   , 0.0538585260004   ,
 0.0416769604605   , 0.0332078507      , 0.0304663056338   , 0.0336834809055   ,
 0.0391739930273   , 0.042479051603    , 0.0436256179613   , 0.0480944165982   ,
 0.0613990503227   , 0.0834231052979   , 0.110330731348    , 0.143344314547    ,
 0.193821557639    , 0.276241424608    , 0.395871606569    , 0.546060389269    ,
 0.715164894954    , 0.886766597855    , 1.03313225016     , 1.12663242682     ,
 1.17099177092     , 1.21423068102     , 1.32643981958     , 1.57462426542     ,
 2.01734617455     , 2.70427162484     , 3.67621020478     , 4.99392773534     ,
 6.80314931739     , 9.37344047098     , 13.0183286696     , 17.8702433979     ,
 23.6191974257     , 29.4355575709     , 34.2322706033     , 37.1467386278     ,
 37.9115378061     , 36.8972959124     , 34.8913569992     , 32.8027779664     ,
 31.4165486825     , 31.2349225971     , 32.4312882214     , 34.9148138958     ,
 38.428221098      , 42.6046842599     , 47.0003047408     , 51.1413898956     ,
 54.5700011278     , 56.849306294      , 57.5356681021     , 56.1926664957     ,
 52.5331722002     , 46.6693654358     , 39.2741913061     , 31.4094115996     ,
 18.2333495197     , 12.7980230014     , 8.68863484681     , 5.69656744244     ,
 3.6247285853      , 2.2802743146      , 1.45595925825     , 0.962536813381    ,
 0.668924166601    , 0.505081892543    , 0.431258154508    , 0.40803324903     ,
 0.394226652735    , 0.36648308469     , 0.331511649891    , 0.314691939039    ,
 0.33688651012     , 0.399782288799    , 0.487695887022    , 0.581199460237    ,
 0.67190701047     , 0.766113895711    , 0.872517983557    , 0.985201776125    ,
 1.08149126292     , 1.1423783165      , 1.17805746991     , 1.22690102352     ,
 1.31689677615     , 1.42476546198     , 1.48443834139     , 1.44601738159     ,
 1.32243435323     , 1.17427980511     , 1.06017127138     , 1.00869982977     ,
 1.0189927338      , 1.06370793568     , 1.09344696181     , 1.06065321454     ,
 0.954838170163    , 0.813903783531    , 0.694336448316    , 0.626622877652    ,
 0.598705371599    , 0.58015423258     , 0.55665129684     , 0.539001439045    ,
 0.546478641022    , 0.590161806667    , 0.67151382458     , 0.791806440086    ,
 0.962610560849    , 1.21004340753     , 1.56667777264     , 2.05137138744     ,
 2.6537084213      , 3.34543421228     , 4.11596747641     , 4.99678280835     ,
 6.04366150965     , 7.29399755604     , 8.75388676082     , 10.4268949752     ,
 12.320792849      , 14.4031153944     , 16.5984467481     , 18.9006608575     ,
 21.4631966817     , 24.4650057399     , 27.8422136708     , 31.2263699835     ,
 34.2033625142     , 36.6132010386     , 38.6040622095     , 40.4647128103     ,
 42.4438769376     , 44.6654143353     , 47.0809739237     , 49.4336701266     ,
 51.3508088067     , 52.5806136439     , 53.1178457106     , 53.0531307149     ,
 52.3713691075     , 50.9694557909     , 48.8137118137     , 45.9896110806     ,
 42.6042503731     , 38.7179796291     , 34.4107080594     , 29.8856430798     ,
 25.4709825193     , 21.5016225113     , 18.1747895894     , 15.4871102164     ,
 13.2843899644     , 11.3639317296     , 9.55767681769     , 7.78439263382     ,
 6.07778874234     , 4.55982623        , 3.35021697367     , 2.48069572601     ,
 1.88497510421     , 1.45776281833     , 1.12278048639     , 0.856085740112    ,
 0.658624680484    , 0.522269825506    , 0.42693341332     , 0.35534260395     ,
 0.297433545895    , 0.246112332263    , 0.198547659909    , 0.159324257665    ,
 0.134391830745    , 0.12104120032     , 0.108554737337    , 0.0893820902277   ,
 0.065826366345    , 0.0450095258321   , 0.030771996837    , 0.0220148826144   ,
 0.0164591161624   , 0.0136202733913   , 0.0142632438716   , 0.0180710453617   ,
 0.0225290698605   , 0.0246581467876   , 0.0241171749858   , 0.0239648703477   ,
 0.0277043941531   , 0.0360944404764   , 0.0480608426884   , 0.065284433781    ,
 0.095200173072    , 0.148692303902    , 0.235766989114    , 0.363931612348    ,
 0.534612962802    , 0.731141995893    , 0.913176895404    , 1.04241891929     ,
 1.12529844455     , 1.22398779901     , 1.4267083077      , 1.82042708953     ,
 2.48824701806     , 3.5147379851      , 5.00218994038     , 7.13401036073     ,
 10.2862757385     , 15.0847182261     , 22.2241901009     , 31.9528837668     ,
 43.4501514163     , 54.6658779014     , 63.0317644078     , 66.7086311285     ,
 65.4667816148     , 60.6151968228     , 54.2157020645     , 48.231222005      ,
 44.018368822      , 42.181229505      , 42.6695416278     , 45.0203694873     ,
 48.6026866421     , 52.7379824184     , 56.7218021366     , 59.8635262577     ,
 61.5790190747     , 61.465271872      , 59.3072916849     , 55.0625117682     ,
 48.8967370575     , 41.2768529882     , 33.0109175151     , 25.073042976      ,
 13.2259816594     , 8.78909342346     , 5.65372357925     , 3.51057941327     ,
 2.10636942211     , 1.24103575518     , 0.740654586034    , 0.462500706419    ,
 0.311121865695    , 0.236044460554    , 0.210809150538    , 0.212304682441    ,
 0.216356506818    , 0.207772263157    , 0.189012114621    , 0.175899906103    ,
 0.184042046988    , 0.217322650754    , 0.266177634786    , 0.316640168053    ,
 0.363306308859    , 0.413216240969    , 0.47457566706     , 0.542043512292    ,
 0.597081376236    , 0.626540290015    , 0.640681261785    , 0.667590369675    ,
 0.723913202422    , 0.79137804463     , 0.828188323397    , 0.806959220985    ,
 0.738797074845    , 0.660250775843    , 0.604782965628    , 0.589183281227    ,
 0.613578341679    , 0.660314292541    , 0.696175052386    , 0.689450661951    ,
 0.633137500222    , 0.550918186608    , 0.476852857208    , 0.427435176958    ,
 0.394045304459    , 0.361871642589    , 0.331108338151    , 0.316287522991    ,
 0.329865976813    , 0.372635865865    , 0.438497687944    , 0.524905359432    ,
 0.642596466622    , 0.823022956793    , 1.11562749171     , 1.56568105149     ,
 2.18316732134     , 2.93427843437     , 3.7759824754      , 4.70994826453     ,
 5.79827089955     , 7.11762188751     , 8.70857892319     , 10.5786625048     ,
 12.7209493268     , 15.091851343      , 17.6119393625     , 20.2744112158     ,
 23.2414483385     , 26.7100269156     , 30.6159586832     , 34.5379388884     ,
 37.9647073709     , 40.6523139702     , 42.7246321174     , 44.4923525871     ,
 46.2261847072     , 48.0444208956     , 49.8726141816     , 51.4449486686     ,
 52.4403141715     , 52.7101818961     , 52.3250792301     , 51.3570917334     ,
 49.7136990702     , 47.2610481144     , 44.0413936663     , 40.2860783531     ,
 36.2383228292     , 32.030839362      , 27.7407767131     , 23.5067523705     ,
 19.5539450504     , 16.1079425877     , 13.2843302842     , 11.0439922784     ,
 9.23921086698     , 7.70083654878     , 6.30232341456     , 4.98774577457     ,
 3.77756835125     , 2.74214233619     , 1.94244276706     , 1.38224418503     ,
 1.00956967457     , 0.754520797976    , 0.566177321423    , 0.42334291591     ,
 0.320079842256    , 0.249103948555    , 0.200097843066    , 0.16514417006     ,
 0.138862677254    , 0.116097915681    , 0.0938592509441   , 0.0739927209239   ,
 0.0602042247489   , 0.0523364065607   , 0.0458786028483   , 0.0371299553479   ,
 0.0266937868882   , 0.0175059752956   , 0.0112539486969   , 0.00756323376066  ,
 0.00553161490953  , 0.00494325215765  , 0.00603638039226  , 0.00851436096809  ,
 0.0110467691229   , 0.0120729665199   , 0.0113095604181   , 0.0101840159697   ,
 0.0105012597299   , 0.0129983930372   , 0.0177842551484   , 0.0264766027197   ,
 0.043945123672    , 0.0784537740729   , 0.141331544735    , 0.24576136697     ,
 0.399059436258    , 0.587834564279    , 0.775184339598    , 0.929970488071    ,
 1.06770623231     , 1.25810716604     , 1.59798870137     , 2.19209489979     ,
 3.16018964004     , 4.65986864908     , 6.94153811146     , 10.4745069939     ,
 16.1195887008     , 25.1656842388     , 38.9074036633     , 57.5981764218     ,
 79.2648265295     , 99.5328640357     , 113.237002671     , 117.035859337     ,
 111.101083399     , 98.682277455      , 84.1840655234     , 71.3091909395     ,
 62.1881580728     , 57.3934809338     , 56.382456119      , 58.0531930978     ,
 61.1951627708     , 64.6900825546     , 67.5315232825     , 68.860891424      ,
 68.0850964057     , 64.9697729488     , 59.6308217965     , 52.465900147      ,
 44.0802506396     , 35.217951546      , 26.6843609664     , 19.2061310379     ,
 9.10868934836     , 5.72344966535     , 3.48054128509     , 2.04134142279     ,
 1.15064569912     , 0.62952334527     , 0.344815445573    , 0.198150560289    ,
 0.126678545715    , 0.0978196396465   , 0.0956506324763   , 0.107518781929    ,
 0.119300667545    , 0.120279754419    , 0.110100823885    , 0.0987555420205   ,
 0.0982918125319   , 0.113254598519    , 0.137830996508    , 0.16239260517     ,
 0.183661550517    , 0.207192336343    , 0.238201211741    , 0.271746115145    ,
 0.29542404873     , 0.302793946789    , 0.302463397026    , 0.311407319681    ,
 0.337683333449    , 0.37031587823     , 0.388149224736    , 0.379258641343    ,
 0.350654247637    , 0.320222982461    , 0.303556319392    , 0.30849380212     ,
 0.334274022357    , 0.36976385151     , 0.395993201457    , 0.3974026067      ,
 0.373561417912    , 0.338886377597    , 0.308836471486    , 0.285784247971    ,
 0.260195777503    , 0.226388303355    , 0.193555320918    , 0.178365213771    ,
 0.189595165433    , 0.223077220618    , 0.269262481242    , 0.323923189766    ,
 0.397782856437    , 0.525320942405    , 0.764751948475    , 1.17689955137     ,
 1.78808793507     , 2.568826881       , 3.46241996086     , 4.45221846681     ,
 5.59781328567     , 6.99268788408     , 8.69950685594     , 10.7424243525     ,
 13.1254989015     , 15.8089082654     , 18.7034163563     , 21.7781398103     ,
 25.1652625563     , 29.0353311772     , 33.3043810819     , 37.5319480972     ,
 41.1789586873     , 43.9642665029     , 45.972982559      , 47.4823292671     ,
 48.7408469579     , 49.8638295951     , 50.7993949354     , 51.3347060528     ,
 51.228368653      , 50.4089343515     , 48.9805462212     , 47.0054175115     ,
 44.3922411332     , 41.064369381      , 37.1553738673     , 32.9671245473     ,
 28.7718319939     , 24.7041725254     , 20.8212784157     , 17.2050130285     ,
 13.9829006893     , 11.2690776699     , 9.09593732836     , 7.39397696275     ,
 6.03245127503     , 4.88408434401     , 3.8657634428      , 2.94721267851     ,
 2.14319909607     , 1.48939758544     , 1.00679347072     , 0.681362634389    ,
 0.47304269677     , 0.338331759978    , 0.246393114161    , 0.181564573595    ,
 0.136396081817    , 0.105118536302    , 0.0829953887472   , 0.0673908349066   ,
 0.056357668503    , 0.0472555567618   , 0.0381227107635   , 0.0294028386913   ,
 0.0228468295971   , 0.0188729547884   , 0.0159819404864   , 0.0126643073269   ,
 0.00890615677233  , 0.00563087169517  , 0.00341926224215  , 0.00216437551563  ,
 0.00156887182859  , 0.00155514206787  , 0.00218604156671  , 0.00331354484823  ,
 0.00439166911961  , 0.00478083506578  , 0.00433902373749  , 0.00361090137963  ,
 0.0033438127587   , 0.0039758732732   , 0.00585808159249  , 0.0101850000654   ,
 0.0200642798538   , 0.0415583076738   , 0.0847830642306   , 0.1630288217      ,
 0.285493242065    , 0.445665224436    , 0.621651626476    , 0.800960650021    ,
 1.01044739611     , 1.32001958743     , 1.82708531298     , 2.65700126313     ,
 3.99139069059     , 6.12558556302     , 9.59230715268     , 15.3900525962     ,
 25.2330606311     , 41.4883850909     , 66.2720533418     , 99.5247831856     ,
 137.05482648      , 170.584125169     , 190.977701513     , 193.002670345     ,
 178.049694068     , 152.816264477     , 125.432722765     , 102.082808522     ,
 85.7456482844     , 76.6359864245     , 73.2811602292     , 73.575180084      ,
 75.5062779574     , 77.4407507134     , 78.1169021159     , 76.6425733873     ,
 72.5898078825     , 66.0474281425     , 57.5406592014     , 47.8753058263     ,
 37.9603274608     , 28.6286297354     , 20.5102273727     , 13.9757754012     ,
 5.89650548675     , 3.50555158543     , 2.01670151792     , 1.11844407491     ,
 0.592739111954    , 0.30019409892     , 0.14893032629     , 0.077082257054    ,
 0.0471685185148   , 0.0407445970173   , 0.049525156422    , 0.0663257931046   ,
 0.0811281725727   , 0.0847959065127   , 0.0759791499268   , 0.0626279087713   ,
 0.0553317265449   , 0.0588634240703   , 0.0697276829333   , 0.0814047229261   ,
 0.0916289194355   , 0.103386059767    , 0.118380278774    , 0.131980452345    ,
 0.137107666231    , 0.132433560762    , 0.124884222804    , 0.123627688571    ,
 0.131777471983    , 0.143775189608    , 0.150750269006    , 0.148495566314    ,
 0.140339839307    , 0.133327729223    , 0.133365785212    , 0.143310819981    ,
 0.161901348245    , 0.182718595753    , 0.196852010706    , 0.199566965321    ,
 0.194611346319    , 0.190518076732    , 0.191096387568    , 0.18972204684     ,
 0.175607071032    , 0.147172228583    , 0.116883322144    , 0.100996660692    ,
 0.106282621346    , 0.127597404205    , 0.155671221698    , 0.186741346312    ,
 0.231258014895    , 0.322434241185    , 0.518213671974    , 0.884818186239    ,
 1.46173554644     , 2.23437201539     , 3.15380159842     , 4.20300935948     ,
 5.43898904227     , 6.9534297792      , 8.80739110091     , 11.026314698      ,
 13.6228678803     , 16.5706517277     , 19.7875797514     , 23.2286089376     ,
 26.978749467      , 31.1365246615     , 35.5582860903     , 39.7923783535     ,
 43.328223666      , 45.9042372118     , 47.579328779      , 48.5706672937     ,
 49.0837079668     , 49.2553444931     , 49.1245650822     , 48.5935153297     ,
 47.496057441      , 45.7609632565     , 43.4457499363     , 40.5989189071     ,
 37.2072902664     , 33.3316620349     , 29.2024528279     , 25.1163548559     ,
 21.2735715681     , 17.7419559514     , 14.5394485647     , 11.7054320322     ,
 9.29612535142     , 7.34110265711     , 5.812898113       , 4.62922214914     ,
 3.68555160787     , 2.89524715693     , 2.20894502004     , 1.61222461382     ,
 1.11475013137     , 0.732062479954    , 0.465298466949    , 0.295065974463    ,
 0.192004725623    , 0.12989152415     , 0.0913077118406   , 0.0665688141032   ,
 0.0502130047401   , 0.0386815733018   , 0.0300501799127   , 0.0237886533039   ,
 0.019511426258    , 0.0162198285546   , 0.0129771770884   , 0.00977119518972  ,
 0.00722407327269  , 0.00561437623192  , 0.00454664773659  , 0.00351347072032  ,
 0.00242072011071  , 0.0014830048446   , 0.000855373000478 , 0.000512003257557 ,
 0.000372357141094 , 0.000414087362522 , 0.000651550698947 , 0.00103344091496  ,
 0.00138549930312  , 0.00150330551243  , 0.00133817636523  , 0.00106568169701  ,
 0.000956816570854 , 0.00125049450758  , 0.00224893073194  , 0.00466301020742  ,
 0.0102429426588   , 0.0229446068314   , 0.0504267950568   , 0.103836806412    ,
 0.193054026907    , 0.319997291942    , 0.481074755473    , 0.684492567303    ,
 0.967553383689    , 1.39795728354     , 2.07405226227     , 3.15241796159     ,
 4.91025064408     , 7.85882215492     , 12.9713391465     , 22.059268356      ,
 38.1080667626     , 64.9871685357     , 105.742378497     , 159.408935083     ,
 218.176071181     , 268.122475186     , 294.976412443     , 291.743289813     ,
 262.383699476     , 218.794335969     , 174.095691443     , 137.366200346     ,
 112.181147591     , 97.8700413227     , 91.5333911557     , 89.7352973664     ,
 89.5354258569     , 88.8321419387     , 86.2779589677     , 81.1619484654     ,
 73.4036691181     , 63.513127547      , 52.4103910353     , 41.1697316967     ,
 30.7671073089     , 21.8796723465     , 14.8111498048     , 9.5543324492      ,
 3.56078828097     , 2.00314996831     , 1.09081732292     , 0.573519004597    ,
 0.287203687618    , 0.135366279456    , 0.0609607212707   , 0.0289130938048   ,
 0.0195100364616   , 0.0242051053002   , 0.0394184440045   , 0.0597504793168   ,
 0.075528022077    , 0.0777896831566   , 0.0658324941488   , 0.0481505139839   ,
 0.0351378339632   , 0.0314097863078   , 0.0346297904451   , 0.0402071695373   ,
 0.046245644813    , 0.0535756574459   , 0.061570259516    , 0.0662150771267   ,
 0.0638454948604   , 0.0556079900791   , 0.0467946348963   , 0.042222050532    ,
 0.0428021291733   , 0.0458722923657   , 0.0480828033378   , 0.0481084703551   ,
 0.0471358339238   , 0.0473900291188   , 0.0506952502747   , 0.0578410129637   ,
 0.0678351912408   , 0.077572087094    , 0.0838235351904   , 0.0866951336819   ,
 0.0905750415897   , 0.100117376738    , 0.113900012789    , 0.122658038977    ,
 0.116560614382    , 0.0956291201521   , 0.0713239811645   , 0.0568832820647   ,
 0.0573012004405   , 0.0684482917999   , 0.0835018814675   , 0.100430253122    ,
 0.128931245546    , 0.197758378746    , 0.358196781348    , 0.673984158396    ,
 1.19380966857     , 1.92478142041     , 2.84394332228     , 3.95342101452     ,
 5.31524632622     , 7.00961966639     , 9.07144304413     , 11.494826985      ,
 14.2745404267     , 17.3955280835     , 20.8077754132     , 24.4790635038     ,
 28.4459198379     , 32.7038890633     , 37.0194545537     , 40.9305283744     ,
 43.9885737785     , 45.9942836954     , 47.0087066358     , 47.2008774354     ,
 46.746399372      , 45.8356037228     , 44.6441616451     , 43.2172910965     ,
 41.4407207569     , 39.1732934274     , 36.3596834923     , 33.0195895473     ,
 29.2447533875     , 25.2516462282     , 21.3471783155     , 17.7770740976     ,
 14.6242417751     , 11.8586422789     , 9.44741584568     , 7.39902394404     ,
 5.7309529718      , 4.42927281061     , 3.43986996236     , 2.6841860308      ,
 2.08506913294     , 1.58833013701     , 1.16701862636     , 0.813789991885    ,
 0.53237067978     , 0.327115774747    , 0.192560464893    , 0.112374495234    ,
 0.067321345268    , 0.0424229211006   , 0.0285286402575   , 0.0205888684116   ,
 0.0157026925876   , 0.0121738444136   , 0.00931894972146  , 0.00713901661791  ,
 0.00566286841016  , 0.00460844862069  , 0.0036329448522   , 0.00266909106312  ,
 0.00187966552552  , 0.00136778899315  , 0.0010500837104   , 0.00078754317125  ,
 0.000531863782256 , 0.000317116867832 , 0.000174767581513 , 9.93983985257e-05 ,
 7.32641577002e-05 , 9.1230528487e-05  , 0.000156140223336 , 0.000254778682747 ,
 0.000343952442975 , 0.000373820103249 , 0.000338302717076 , 0.000308878756743 ,
 0.000440622268044 , 0.000978962032195 , 0.00224331199217  , 0.00456935253201  ,
 0.00852611948438  , 0.0160383440801   , 0.0322882841066   , 0.0664897976468   ,
 0.129557570715    , 0.231048854413    , 0.382352318891    , 0.607649475805    ,
 0.952266764463    , 1.48421957044     , 2.31027450945     , 3.63240835737     ,
 5.85353797024     , 9.76675328437     , 16.9186986644     , 30.1649915247     ,
 54.0683399603     , 94.2180292642     , 154.414891205     , 231.984972248     ,
 314.216994743     , 380.427465145     , 411.008660614     , 398.163798687     ,
 349.986717883     , 284.828310209     , 221.192268932     , 170.674397738     ,
 136.762053087     , 117.327634121     , 107.756179861     , 103.245774019     ,
 100.053923638     , 95.8326934482     , 89.4062597945     , 80.4576041275     ,
 69.3478848423     , 56.9625255677     , 44.4561513424     , 32.9362633663     ,
 23.1925876459     , 15.5595335448     , 9.96201040111     , 6.08970893939     ,
 1.99912551995     , 1.06200814528     , 0.545621571479    , 0.271691534539    ,
 0.129180593735    , 0.0574506327177   , 0.0244163806592   , 0.0124933406801   ,
 0.0131425516538   , 0.0238665253031   , 0.0434497703164   , 0.0663904080365   ,
 0.0819748516583   , 0.0811642902984   , 0.0647280636778   , 0.0426844375307   ,
 0.0255974722705   , 0.0175681202474   , 0.0165343945056   , 0.0188442018236   ,
 0.0226725320628   , 0.0276562905452   , 0.0323973851033   , 0.0339502697466   ,
 0.0305224823362   , 0.0236779590303   , 0.0169714502189   , 0.0129207191704   ,
 0.0116938153934   , 0.0119946722569   , 0.0125347529262   , 0.0128507315373   ,
 0.0132413672632   , 0.01426789447     , 0.0163943550064   , 0.0197787379532   ,
 0.0239207594558   , 0.0276456795002   , 0.030207086515    , 0.0328320675182   ,
 0.0386606426363   , 0.0499010283792   , 0.0639946904872   , 0.0733128837378   ,
 0.0708749839644   , 0.0572507510044   , 0.040671526425    , 0.0299835211133   ,
 0.0283260668199   , 0.0331053979118   , 0.0404177733072   , 0.050074632047    ,
 0.0706278600378   , 0.125319734291    , 0.256574040135    , 0.521973552113    ,
 0.976361505132    , 1.65085397644     , 2.55763113756     , 3.72732899444     ,
 5.22839436197     , 7.12285812171     , 9.40844734923     , 12.031522301      ,
 14.9489922156     , 18.1464820276     , 21.6121655329     , 25.3365884472     ,
 29.307436426      , 33.4137139302     , 37.3389383133     , 40.626298327      ,
 42.9058746437     , 44.0596426112     , 44.1780216822     , 43.4157600297     ,
 41.9480048177     , 40.0300013885     , 37.9634729163     , 35.9138798166     ,
 33.7981414334     , 31.3939480493     , 28.5289965453     , 25.1838408292     ,
 21.5200008183     , 17.8504012801     , 14.5072644258     , 11.6724765914     ,
 9.32923674635     , 7.36733070355     , 5.70901030282     , 4.33997990454     ,
 3.26303289841     , 2.45485313432     , 1.8619765695      , 1.41988645537     ,
 1.07431722218     , 0.792678587883    , 0.560853005866    , 0.374152953864    ,
 0.231860408246    , 0.132991427231    , 0.0718300514814   , 0.037929971603    ,
 0.0204850976844   , 0.0117806229177   , 0.00746807257635  , 0.00530917713817  ,
 0.00410174728758  , 0.0032103901291   , 0.00242530801879  , 0.00179067234324  ,
 0.00135833113511  , 0.00106927734963  , 0.00082526338252  , 0.000591735789095 ,
 0.000398507803767 , 0.000271397561377 , 0.00019612143833  , 0.000141933078959 ,
 9.38809225843e-05 , 5.46618804025e-05 , 2.89504305037e-05 , 1.57265032134e-05 ,
 1.18320883244e-05 , 1.63281771595e-05 , 2.96967224648e-05 , 4.93786307455e-05 ,
 6.74073898093e-05 , 7.71081907106e-05 , 9.39631862522e-05 , 0.000200711794377 ,
 0.000632612690289 , 0.00185163899159  , 0.0043922102396   , 0.0083362036312   ,
 0.0130338551596   , 0.0183495227691   , 0.0274700582455   , 0.0488715074203   ,
 0.0954116946973   , 0.182901975162    , 0.333048168136    , 0.580092300291    ,
 0.974182083334    , 1.58548265733     , 2.53516347403     , 4.07910806652     ,
 6.75862271134     , 11.6722184272     , 20.9813114948     , 38.6304940006     ,
 70.734241372      , 124.362062581     , 203.510909597     , 303.072358498     ,
 405.043854274     , 482.472889406     , 511.84283048      , 486.23040583      ,
 418.81722783      , 334.152553138     , 254.961713929     , 194.021238777     ,
 153.817805709     , 130.480887112     , 117.889591654     , 110.314851457     ,
 103.661915564     , 95.6946033324     , 85.640804328      , 73.6594025849     ,
 60.4751469508     , 47.1432545731     , 34.7885413109     , 24.305529477      ,
 16.1351471582     , 10.2292152729     , 6.21073757993     , 3.60646101924     ,
 1.04230071882     , 0.521036626009    , 0.250467430847    , 0.117137289881    ,
 0.0529146073954   , 0.0229088189686   , 0.0107575330476   , 0.008893099297    ,
 0.0146521459746   , 0.0282740466431   , 0.0493333006567   , 0.0721916722582   ,
 0.0859695981454   , 0.0822198510556   , 0.0629481892549   , 0.038928307375    ,
 0.0203573248842   , 0.0106136951638   , 0.00756650971304  , 0.00798371237986  ,
 0.0100584291683   , 0.0130215734939   , 0.0156861004806   , 0.0163052355861   ,
 0.0140629701788   , 0.0100374085008   , 0.00620248773047  , 0.00378696734782  ,
 0.00278674883176  , 0.00258957197097  , 0.00266888375074  , 0.00282654065749  ,
 0.00310022003529  , 0.00360085333342  , 0.00442729468508  , 0.00560082464374  ,
 0.00694735725863  , 0.00814601292334  , 0.00920881019824  , 0.0110772224647   ,
 0.0154389866616   , 0.0231711701839   , 0.0323429526247   , 0.0383153060123   ,
 0.0371913616518   , 0.0295687832001   , 0.0201943372903   , 0.0138692575964   ,
 0.0121967906067   , 0.0138666840086   , 0.0172103550137   , 0.0231813998396   ,
 0.0388633929655   , 0.0824029899906   , 0.188317581083    , 0.408523144015    ,
 0.803638411221    , 1.42849761582     , 2.32908324555     , 3.55671207925     ,
 5.17063128752     , 7.20382890007     , 9.62572149092     , 12.358074378      ,
 15.3339855538     , 18.5299794953     , 21.9440614519     , 25.5591677221     ,
 29.3038143284     , 32.9857665947     , 36.2538437519     , 38.6943219138     ,
 40.028119571      , 40.2220118069     , 39.4123523374     , 37.7691945474     ,
 35.484764332      , 32.8543770244     , 30.238837537      , 27.8600263677     ,
 25.6573945884     , 23.3790718847     , 20.7976565025     , 17.8638401245     ,
 14.7429540194     , 11.7430378479     , 9.15438990799     , 7.09824889776     ,
 5.50810152886     , 4.24221099948     , 3.20167734996     , 2.35803412214     ,
 1.70989800675     , 1.2405373974      , 0.910752156696    , 0.674354942287    ,
 0.495028785903    , 0.353031914777    , 0.240495143248    , 0.153890468445    ,
 0.090812765214    , 0.0488827996756   , 0.0242327631665   , 0.0114675152952   ,
 0.00547178554076  , 0.00279866984268  , 0.00163449888994  , 0.00113062028611  ,
 0.00088166087941  , 0.00069658488279  , 0.00052011207465  , 0.000369867168204 ,
 0.000266360065897 , 0.000200727290323 , 0.000150724223598 , 0.000105490615693 ,
 6.82826297769e-05 , 4.3648983184e-05  , 2.95375422772e-05 , 2.04937370753e-05 ,
 1.32478681335e-05 , 7.54939943975e-06 , 3.86270817644e-06 , 2.01469163598e-06 ,
 1.55341645034e-06 , 2.34278232959e-06 , 4.45681707128e-06 , 7.58942280402e-06 ,
 1.13215471692e-05 , 2.03470060056e-05 , 6.84293091666e-05 , 0.000297092625701 ,
 0.0011245741221   , 0.0033880778518   , 0.00801640823862  , 0.0149118694069   ,
 0.0220738186368   , 0.0271784841149   , 0.0317768383638   , 0.0445434054851   ,
 0.0809502307006   , 0.162250213057    , 0.317817245409    , 0.588388742439    ,
 1.02569594513     , 1.69972674758     , 2.7441368019      , 4.46430764384     ,
 7.52514977145     , 13.2882581594     , 24.4219690794     , 45.709365648      ,
 84.3157697324     , 148.004953754     , 240.14760293      , 352.992213784     ,
 464.39314632      , 543.729771139     , 566.58029199      , 528.624961321     ,
 447.585615874     , 351.852751675     , 265.632840428     , 200.986509267     ,
 158.741596346     , 133.593923924     , 118.700721638     , 108.242143974     ,
 98.4082697898     , 87.4253103613     , 75.0081488298     , 61.6741134855     ,
 48.2749592528     , 35.7598690712     , 24.9811897698     , 16.4748573327     ,
 10.3213033733     , 6.19559416044     , 3.57900889746     , 1.9810804158      ,
 0.503020779934    , 0.236027383429    , 0.105101548571    , 0.0455296787638   ,
 0.0196573376031   , 0.00939569422688  , 0.00744697530449  , 0.0111523614605   ,
 0.0197965855887   , 0.0335914282707   , 0.0518720104221   , 0.0700378448318   ,
 0.0794336499257   , 0.0735758814076   , 0.0548455216746   , 0.032793388959    ,
 0.0159719362239   , 0.00687528842336  , 0.00347647599258  , 0.00300212071016  ,
 0.00382994511384  , 0.00522211599857  , 0.00646781102309  , 0.00674040699776  ,
 0.00571136206865  , 0.00390392685104  , 0.00219725569838  , 0.00110792870549  ,
 0.000618151087512 , 0.000473246708938 , 0.000466082108081 , 0.00051176751992  ,
 0.000601953068829 , 0.000752541900292 , 0.000981454266937 , 0.0012906710418   ,
 0.00163863454573  , 0.00197399240312  , 0.00240715017471  , 0.00341051094542  ,
 0.00570821040237  , 0.00958533219689  , 0.0140202087141   , 0.0168142636865   ,
 0.0162406620387   , 0.0126947807843   , 0.00837942754101  , 0.00539966284426  ,
 0.00441347184837  , 0.00489863761199  , 0.00640584285442  , 0.0101909401783   ,
 0.0216970980253   , 0.0548563898537   , 0.138205141471    , 0.320111162725    ,
 0.667837143707    , 1.25770520728     , 2.16096020784     , 3.43135719661     ,
 5.0950630597      , 7.14439157933     , 9.54105858129     , 12.2310662287     ,
 15.1649897597     , 18.3054291458     , 21.6063106464     , 24.9812463388     ,
 28.2836168437     , 31.2869733904     , 33.6797270277     , 35.1432470264     ,
 35.5039399698     , 34.8105030777     , 33.2467122006     , 31.0056303018     ,
 28.2892178921     , 25.3830077864     , 22.6184937035     , 20.1990651966     ,
 18.0829480843     , 16.0588336205     , 13.9273288306     , 11.6341050474     ,
 9.29609565869     , 7.13292702637     , 5.34107258348     , 3.98744662816     ,
 3.00082389606     , 2.25559533282     , 1.66072219757     , 1.1843796935      ,
 0.823632399567    , 0.569929088668    , 0.399750606544    , 0.284273830661    ,
 0.201064788272    , 0.138161371753    , 0.0906347458007   , 0.0558303882505   ,
 0.0316008327741   , 0.016120019887    , 0.00739885639079  , 0.00314031706463  ,
 0.0013055356816   , 0.000577053590285 , 0.00030025604636  , 0.000197573653128 ,
 0.000154085096388 , 0.000122574322443 , 9.05718175915e-05 , 6.21550513228e-05 ,
 4.23553742463e-05 , 3.02990095532e-05 , 2.19957598938e-05 , 1.50200714248e-05 ,
 9.39129529515e-06 , 5.66383783601e-06 , 3.57919643061e-06 , 2.36465185866e-06 ,
 1.48879920599e-06 , 8.31249280365e-07 , 4.1275494454e-07  , 2.07753620931e-07 ,
 1.64402178295e-07 , 2.67635728201e-07 , 5.35855154659e-07 , 1.05485698138e-06 ,
 2.92556802018e-06 , 1.5038464391e-05  , 8.72544371265e-05 , 0.000424536060569 ,
 0.00163439985896  , 0.004933645137    , 0.0116593702101   , 0.0215912910407   ,
 0.0315239264558   , 0.0372025794601   , 0.0388400221055   , 0.0454070254526   ,
 0.0745171142442   , 0.151636962517    , 0.312197780143    , 0.602066877568    ,
 1.07323036461     , 1.79253182531     , 2.89865364983     , 4.72871967352     ,
 8.02656769199     , 14.3036490608     , 26.4713568842     , 49.6162373009     ,
 91.061150733      , 158.153617784     , 252.904031656     , 365.527582938     ,
 472.35830753      , 543.180050976     , 556.221795116     , 510.686672477     ,
 426.593609787     , 332.264931102     , 249.985032831     , 189.442678727     ,
 149.806211396     , 125.231689249     , 109.23951109      , 96.8047104222     ,
 84.9411125758     , 72.5183030164     , 59.6379458098     , 46.9255127586     ,
 35.0894546555     , 24.7648348499     , 16.422274707      , 10.2447280635     ,
 6.06453362478     , 3.45036652959     , 1.8999731378      , 1.00536580538     ,
 0.222515834442    , 0.098069516221    , 0.0402365477826   , 0.0160334380238   ,
 0.00711556039513  , 0.00552596631493  , 0.00890036236987  , 0.0165308752623   ,
 0.0272224692864   , 0.0392834110481   , 0.0511826052116   , 0.0605569898138   ,
 0.0631953556864   , 0.0558494411916   , 0.0405180854568   , 0.0237288609116   ,
 0.0111906403449   , 0.00437717047591  , 0.00167504902141  , 0.00102964155604  ,
 0.00122261567543  , 0.00172119355542  , 0.00218078883581  , 0.0022866477668   ,
 0.00192666975851  , 0.00129271582358  , 0.000695198278523 , 0.000312080228677 ,
 0.00013515017709  , 7.70115389344e-05 , 6.75575301827e-05 , 7.62643344606e-05 ,
 9.62652746053e-05 , 0.000128637795013 , 0.00017615393727  , 0.000239211657182 ,
 0.000311819229084 , 0.000395834413975 , 0.000552851006713 , 0.000962658162996 ,
 0.00187767963338  , 0.00337259631687  , 0.00503592377366  , 0.00604306696297  ,
 0.00578354569924  , 0.00444477524616  , 0.00284621864447  , 0.00173087757951  ,
 0.00131691994536  , 0.00145109762101  , 0.00214783848884  , 0.00447031328248  ,
 0.0123387887981   , 0.0363577170996   , 0.100515746048    , 0.250584648497    ,
 0.558909389239    , 1.11688062414     , 2.00921414716     , 3.27828519331     ,
 4.90750438466     , 6.84957986897     , 9.07650784462     , 11.5928209197     ,
 14.3971793858     , 17.4325086796     , 20.5591378845     , 23.5691991387     ,
 26.2393495952     , 28.3654435801     , 29.7481097046     , 30.2099503018     ,
 29.6934595486     , 28.3192538305     , 26.3037762485     , 23.8479526798     ,
 21.1383284759     , 18.4022570898     , 15.8754218396     , 13.6892991442     ,
 11.8132467356     , 10.1157984502     , 8.47631291056     , 6.85746835216     ,
 5.31349269958     , 3.95016739022     , 2.85941211707     , 2.06344222881     ,
 1.50795809523     , 1.10710141132     , 0.796232754219    , 0.549980567043    ,
 0.36532377568     , 0.238631338101    , 0.157568116196    , 0.106199492473    ,
 0.0719517668177   , 0.047845343765    , 0.0306370096718   , 0.018512056707    ,
 0.0102473260912   , 0.00503905072984  , 0.00216827638397  , 0.000827669376992 ,
 0.00029494944474  , 0.000108097320228 , 4.73887589204e-05 , 2.84626726608e-05 ,
 2.18234765706e-05 , 1.73806974113e-05 , 1.2705519773e-05  , 8.43299737132e-06 ,
 5.43322995941e-06 , 3.66414818024e-06 , 2.55462964675e-06 , 1.69963485981e-06 ,
 1.03086101877e-06 , 5.90239170362e-07 , 3.48219593229e-07 , 2.17635454279e-07 ,
 1.32853505559e-07 , 7.26742689793e-08 , 3.51512088826e-08 , 1.71557905283e-08 ,
 1.39593525636e-08 , 2.49141679537e-08 , 6.31018742649e-08 , 2.7525727742e-07  ,
 2.07189990103e-06 , 1.57574109933e-05 , 9.81199999642e-05 , 0.000482238912656 ,
 0.00185923330072  , 0.00561397321413  , 0.0132691553912   , 0.024570960728    ,
 0.035823286475    , 0.0419395776277   , 0.0423982484289   , 0.0457901051188   ,
 0.0698003401774   , 0.141063004703    , 0.298101493936    , 0.590950559714    ,
 1.0739353435      , 1.81277408915     , 2.94517912622     , 4.81446942636     ,
 8.17634208115     , 14.531573577      , 26.6840427005     , 49.3699534797     ,
 89.1006186299     , 151.819458739     , 237.900316448     , 336.844303952     ,
 426.639943683     , 481.4303296       , 484.717074216     , 438.869183524     ,
 363.115411097     , 281.836259064     , 212.732105461     , 162.375241943     ,
 128.89777066      , 106.984574174     , 91.4230364676     , 78.5303135628     ,
 66.3562450695     , 54.3666627878     , 42.8475377121     , 32.3015225223     ,
 23.1337773662     , 15.6115065217     , 9.86582882572     , 5.84049954848     ,
 3.27095242917     , 1.76214548559     , 0.92341783509     , 0.466959814079    ,
 0.0886859717058   , 0.0368324865854   , 0.0139910344543   , 0.00529820299954  ,
 0.00320560285567  , 0.00527002138876  , 0.0116313912496   , 0.0221329400468   ,
 0.0342519567465   , 0.0439332466429   , 0.0486707323296   , 0.0485770935746   ,
 0.0442830963048   , 0.0359394968354   , 0.0248957563372   , 0.0142264525086   ,
 0.00658400837429  , 0.0024723310776   , 0.000809171427509 , 0.000340880868582 ,
 0.000327556217281 , 0.000459258508641 , 0.000590794483431 , 0.000623254149699 ,
 0.00052470887384  , 0.000349555098704 , 0.000184367527007 , 7.82630302452e-05 ,
 2.87969561099e-05 , 1.19140917413e-05 , 8.32952072361e-06 , 9.35393363822e-06 ,
 1.25772350029e-05 , 1.77865774235e-05 , 2.5339998311e-05  , 3.54204629404e-05 ,
 4.79301500333e-05 , 6.69331467483e-05 , 0.000114003567087 , 0.000242894475425 ,
 0.000525048037553 , 0.000976021241065 , 0.00146691946917  , 0.00175231531839  ,
 0.00165983790816  , 0.00125558339091  , 0.000782736850666 , 0.000451881318591 ,
 0.00032317853065  , 0.00037568347346  , 0.000734372773282 , 0.00218922249493  ,
 0.00756365009247  , 0.0250480336426   , 0.0748450525757   , 0.198929996567    ,
 0.468693513751    , 0.978448823959    , 1.81366477418     , 3.00427341117     ,
 4.50715488728     , 6.25601606135     , 8.24005062116     , 10.5154543435     ,
 13.1198654493     , 15.9665079648     , 18.8100013644     , 21.3222999775     ,
 23.2335081197     , 24.4089614555     , 24.7986019151     , 24.3794125702     ,
 23.2013717731     , 21.4349826498     , 19.3036079539     , 16.9912780656     ,
 14.6434240611     , 12.4031785803     , 10.3894632631     , 8.64774955527     ,
 7.14870319802     , 5.83480246858     , 4.6636455055      , 3.6213272725      ,
 2.71641343201     , 1.96877296114     , 1.39393155936     , 0.984773982934    ,
 0.705682226416    , 0.508774535754    , 0.358029504262    , 0.239135436798    ,
 0.15087289613     , 0.0920576431226   , 0.0566026378799   , 0.0363277681443   ,
 0.0246424703401   , 0.0174759593189   , 0.0124843443385   , 0.0084402840278   ,
 0.0050563642873   , 0.00255948845443  , 0.00106891266144  , 0.000367795779659 ,
 0.000107190608597 , 2.90851897959e-05 , 9.51499383132e-06 , 5.07203819281e-06 ,
 3.74008418059e-06 , 2.77837266493e-06 , 1.84005972381e-06 , 1.08527373744e-06 ,
 6.12952302456e-07 , 3.67378873096e-07 , 2.38100229825e-07 , 1.52693906317e-07 ,
 8.99337092484e-08 , 4.91856832092e-08 , 2.71436078368e-08 , 1.59577346362e-08 ,
 9.39355253958e-09 , 5.0288345998e-09  , 2.37611812303e-09 , 1.13049692525e-09 ,
 9.76694675864e-10 , 2.51506639437e-09 , 1.68027468514e-08 , 1.77542151004e-07 ,
 1.7474438633e-06  , 1.38821045725e-05 , 8.69728366479e-05 , 0.000427870824109 ,
 0.00165037504623  , 0.00498720964616  , 0.0118078519053   , 0.0219484927942   ,
 0.0322725305178   , 0.0384723456183   , 0.0401607323693   , 0.0445723222512   ,
 0.0665539499929   , 0.129576956594    , 0.270740906986    , 0.542444055451    ,
 1.00506885096     , 1.72978508452     , 2.85180423597     , 4.69495538398     ,
 7.95512988722     , 13.9632630426     , 25.0987610494     , 45.2135810753     ,
 79.3274279554     , 131.494634153     , 200.745638582     , 277.387304847     ,
 343.554901897     , 380.065142285     , 376.429834545     , 336.826197474     ,
 277.110776225     , 215.45213605      , 163.999408186     , 126.482076934     ,
 100.820384826     , 82.9591237051     , 69.3229898616     , 57.6221047609     ,
 46.8117956014     , 36.7550340645     , 27.7396315826     , 20.0450907653     ,
 13.7773278237     , 8.92106032985     , 5.39608703278     , 3.04317088256     ,
 1.61456693609     , 0.821212727253    , 0.407020349148    , 0.195637465131    ,
 0.031208870432    , 0.0122452524059   , 0.00438273426727  , 0.00180494459319  ,
 0.00213097404006  , 0.00542808596169  , 0.0128609797328   , 0.024338653087    ,
 0.036476533254    , 0.0438671872799   , 0.0435130787419   , 0.0371600479847   ,
 0.0286059850948   , 0.0202344435683   , 0.0128501321866   , 0.00701183226746  ,
 0.00316881043281  , 0.00116440732597  , 0.000354883187391 , 0.000112048590546 ,
 7.53750941772e-05 , 9.87993502314e-05 , 0.000127690882677 , 0.000135323306801 ,
 0.000114008400836 , 7.57642879765e-05 , 3.9651020042e-05  , 1.64345496857e-05 ,
 5.57239374977e-06 , 1.80585832541e-06 , 9.09862934038e-07 , 9.45557424512e-07 ,
 1.3314382476e-06  , 1.97132749639e-06 , 2.9019073777e-06  , 4.18236762624e-06 ,
 6.01415717918e-06 , 9.81494919595e-06 , 2.11015781877e-05 , 5.2588585739e-05  ,
 0.000120573000215 , 0.000227594642463 , 0.000342070298649 , 0.000406119973517 ,
 0.000380923497893 , 0.000284137146608 , 0.000173097097241 , 9.58779796458e-05 ,
 6.88978211624e-05 , 0.000111599064537 , 0.000374133087229 , 0.0015257472864   ,
 0.00586723141448  , 0.0201004471547   , 0.0610370998279   , 0.164404915369    ,
 0.392248792302    , 0.827600918631    , 1.54573732058     , 2.57165033423     ,
 3.86472164922     , 5.36707772685     , 7.08058957658     , 9.07589992721     ,
 11.3927750436     , 13.9115710623     , 16.3195983075     , 18.2311591238     ,
 19.3836421846     , 19.7291258442     , 19.3476800456     , 18.3360958754     ,
 16.8160492075     , 14.9745647167     , 13.0156298779     , 11.0887637437     ,
 9.28772204544     , 7.67432105867     , 6.2712986941      , 5.05858118491     ,
 4.00336159355     , 3.0913252044      , 2.32646816074     , 1.71120792844     ,
 1.23452388934     , 0.87673857766     , 0.618224667212    , 0.439605833274    ,
 0.317898130094    , 0.229567633761    , 0.159091450898    , 0.102224092643    ,
 0.0604765935564   , 0.0340650946073   , 0.0199846984296   , 0.0140976349122   ,
 0.0128655420824   , 0.0133449844766   , 0.0130793781006   , 0.0108842980425   ,
 0.00735264329198  , 0.00396359987092  , 0.00169596159313  , 0.00057745103536  ,
 0.000160500774026 , 4.26011239117e-05 , 1.80410338264e-05 , 1.37528532285e-05 ,
 1.09063804933e-05 , 7.14451700189e-06 , 3.71723420263e-06 , 1.53203392081e-06 ,
 5.06555361249e-07 , 1.41544979531e-07 , 3.93723861294e-08 , 1.41390542437e-08 ,
 6.60030275486e-09 , 3.29981714558e-09 , 1.69403701694e-09 , 9.31554112532e-10 ,
 5.25524657686e-10 , 2.74742029433e-10 , 1.270866796e-10   , 6.00446918908e-11 ,
 7.74547330357e-11 , 6.61030896197e-10 , 9.43118920664e-09 , 1.19097972269e-07 ,
 1.20405565593e-06 , 9.60135544205e-06 , 6.01974050761e-05 , 0.000296321209922 ,
 0.00114429912137  , 0.00346684555292  , 0.00825575826319  , 0.015547184971    ,
 0.0235397113154   , 0.0298840801793   , 0.0349543679189   , 0.0438669768058   ,
 0.066392072228    , 0.119416843362    , 0.234574257289    , 0.463728899726    ,
 0.87417452346     , 1.54667623409     , 2.61350895783     , 4.35973340382     ,
 7.36754036263     , 12.6919679176     , 22.1094214197     , 38.3434715049     ,
 64.7219519975     , 103.50548897      , 153.023940344     , 205.513455711     ,
 248.290230773     , 269.019547652     , 262.245302892     , 232.383629918     ,
 190.753813727     , 149.145714868     , 114.808822626     , 89.4962171665     ,
 71.5080698178     , 58.2139993087     , 47.5123129252     , 38.1944412239     ,
 29.8114403059     , 22.4028362361     , 16.1647864432     , 11.1835823674     ,
 7.37841530225     , 4.59339169604     , 2.66853338823     , 1.43909372145     ,
 0.724553599167    , 0.346755818389    , 0.161055645562    , 0.0727971063005   ,
 0.00953989846196  , 0.00353109888284  , 0.00123377120034  , 0.000721767060749 ,
 0.00160799458778  , 0.0047099089807   , 0.0113024574278   , 0.0212827066802   ,
 0.0314384826365   , 0.0366766023969   , 0.0342807086597   , 0.0263812799788   ,
 0.017461521937    , 0.010440383145    , 0.00577113322082  , 0.002884431813    ,
 0.00124474009174  , 0.000446206519494 , 0.000131310769913 , 3.50502302097e-05 ,
 1.55317116069e-05 , 1.71996551492e-05 , 2.19621405234e-05 , 2.33259659048e-05 ,
 1.96702321906e-05 , 1.30627782734e-05 , 6.8158863783e-06  , 2.79786792011e-06 ,
 9.15260491814e-07 , 2.57693617567e-07 , 9.221159983e-08   , 7.92224585507e-08 ,
 1.13382992623e-07 , 1.73939741133e-07 , 2.63586056897e-07 , 3.95255437193e-07 ,
 6.2942463529e-07  , 1.27764464263e-06 , 3.4146614484e-06  , 9.41742506396e-06 ,
 2.2257747267e-05  , 4.22546007618e-05 , 6.33482428028e-05 , 7.47522214759e-05 ,
 6.95111169833e-05 , 5.12377982136e-05 , 3.06838752994e-05 , 1.7209092441e-05  ,
 1.91954562483e-05 , 7.41414871174e-05 , 0.00037014282071  , 0.00162876485699  ,
 0.00608708573763  , 0.0196322724249   , 0.0558469516103   , 0.142145636668    ,
 0.325121474989    , 0.667407251597    , 1.22855770618     , 2.03536594506     ,
 3.06809678329     , 4.29041327018     , 5.70450125907     , 7.3595584358      ,
 9.27000827845     , 11.3014744536     , 13.1444333217     , 14.4414699684     ,
 14.9834891661     , 14.7896004835     , 14.0073187851     , 12.7874810144     ,
 11.2730625492     , 9.6331358777      , 8.0341411297      , 6.58753529485     ,
 5.34362349683     , 4.30765598718     , 3.4470748241      , 2.71086799555     ,
 2.06497327387     , 1.50936681178     , 1.06156469493     , 0.729598388893    ,
 0.50087824945     , 0.350393772469    , 0.253609471001    , 0.191236796639    ,
 0.147596432671    , 0.111033294018    , 0.0769554268819   , 0.0473809207904   ,
 0.0259213025294   , 0.0136511012564   , 0.00916583498984  , 0.0104660126057   ,
 0.0154008811648   , 0.0208489839739   , 0.0231685129783   , 0.0205396440781   ,
 0.0144239470739   , 0.00801516352574  , 0.00353160622846  , 0.00124693339119  ,
 0.000376284447639 , 0.00013413654778  , 9.17462727258e-05 , 8.48501861369e-05 ,
 6.94416122252e-05 , 4.54757405366e-05 , 2.34498437123e-05 , 9.48943882822e-06 ,
 3.00940482958e-06 , 7.47514905439e-07 , 1.45668406797e-07 , 2.25261702047e-08 ,
 2.93191757418e-09 , 4.1128587422e-10  , 1.01307335883e-10 , 4.42199669355e-11 ,
 2.32857048739e-11 , 1.18314632923e-11 , 5.37716604658e-12 , 3.0084532943e-12  ,
 1.69510345822e-11 , 3.10225306889e-10 , 4.99558524908e-09 , 6.41374202019e-08 ,
 6.49956904581e-07 , 5.1862406334e-06  , 3.25426666792e-05 , 0.000160466841051 ,
 0.000622016629389 , 0.00190020610961  , 0.0046079318661   , 0.00902296873046  ,
 0.0147958271947   , 0.021682035084    , 0.0308294441801   , 0.0449619434784   ,
 0.068237283449    , 0.110124762485    , 0.19502633314     , 0.370718258541    ,
 0.70657634929     , 1.2888675648      , 2.24317731336     , 3.8062421022      ,
 6.42513118873     , 10.8516348088     , 18.2504711645     , 30.2783809808     ,
 48.7944150856     , 74.7360751989     , 106.368126073     , 138.255719874     ,
 162.503614738     , 172.258238658     , 165.348780691     , 145.366011791     ,
 119.359351016     , 94.040702916      , 73.2116502909     , 57.5507081721     ,
 45.9409073681     , 36.912637033      , 29.4010869136     , 22.8647896988     ,
 17.1519899465     , 12.3278105647     , 8.48504162181     , 5.6025758758      ,
 3.53882226973     , 2.11637724677     , 1.18242712849     , 0.611467562633    ,
 0.292848715463    , 0.131657416766    , 0.0567972888304   , 0.0238047307695   ,
 0.00251663111712  , 0.000872795334386 , 0.00031909413446  , 0.000337011996581 ,
 0.00106512243916  , 0.0032383750127   , 0.00778719136033  , 0.0146259740347   ,
 0.0214704871493   , 0.0247129034787   , 0.0224574632532   , 0.01634297823     ,
 0.00978930744068  , 0.00504809326728  , 0.00236040078348  , 0.00102661698704  ,
 0.000405876732679 , 0.000138939440806 , 3.96736126918e-05 , 9.69699039555e-06 ,
 2.98331097564e-06 , 2.45447538342e-06 , 3.00508937375e-06 , 3.1871305139e-06  ,
 2.68926477769e-06 , 1.78574567979e-06 , 9.30729124471e-07 , 3.80599448196e-07 ,
 1.22675972188e-07 , 3.22685186754e-08 , 8.84081570854e-09 , 5.57818542113e-09 ,
 7.72760493355e-09 , 1.21613459988e-08 , 1.89797122154e-08 , 3.02311918898e-08 ,
 5.66138596143e-08 , 1.47759017186e-07 , 4.65669198186e-07 , 1.36056373312e-06 ,
 3.26267607108e-06 , 6.20194982534e-06 , 9.26837088768e-06 , 1.08778682933e-05 ,
 1.00423545401e-05 , 7.33732817077e-06 , 4.43766319527e-06 , 3.65396389568e-06 ,
 1.3752338358e-05  , 8.53416971316e-05 , 0.00045192789358  , 0.00194194304569  ,
 0.00686309627713  , 0.02046992265     , 0.05314594763     , 0.123580915431    ,
 0.26217156549     , 0.510935171477    , 0.914713141395    , 1.50321864934     ,
 2.27592779979     , 3.21063619278     , 4.29593844902     , 5.54510170308     ,
 6.94858439035     , 8.39222565873     , 9.63467378738     , 10.4071499541     ,
 10.5684319086     , 10.163637628      , 9.34001934265     , 8.24209462409     ,
 6.9941585806      , 5.72548737709     , 4.55749889535     , 3.56817721248     ,
 2.78122829315     , 2.17629594831     , 1.70435998858     , 1.31242102788     ,
 0.970156872901    , 0.677006606212    , 0.446223560834    , 0.284506238694    ,
 0.18413834576     , 0.128497298355    , 0.100615040412    , 0.0866274065334   ,
 0.0756494522167   , 0.0611615183722   , 0.0429975791897   , 0.0255642228489   ,
 0.0131233172468   , 0.00713940595926  , 0.00727510642903  , 0.0129553713073   ,
 0.0227695156587   , 0.0328519715695   , 0.0377394161005   , 0.0343598628295   ,
 0.0247945935807   , 0.0142045717428   , 0.00649142989622  , 0.00242386889318  ,
 0.000852309466472 , 0.000453172996213 , 0.000426880636771 , 0.000425753968648 ,
 0.000352277093875 , 0.000231027496899 , 0.000119142423107 , 4.8205343817e-05  ,
 1.52810007769e-05 , 3.79102541903e-06 , 7.35384415026e-07 , 1.11463566238e-07 ,
 1.31999674383e-08 , 1.22462369694e-09 , 9.10107773836e-11 , 6.52190616297e-12 ,
 1.02812441912e-12 , 4.08452452788e-13 , 1.85453531362e-13 , 3.19591157648e-13 ,
 6.32787392491e-12 , 1.29161742027e-10 , 2.10224999644e-09 , 2.7033222152e-08  ,
 2.74142947246e-07 , 2.19008844994e-06 , 1.37777626842e-05 , 6.83206885137e-05 ,
 0.000268080241843 , 0.000840548182085 , 0.00215048912028  , 0.0046648845504   ,
 0.00905849193552  , 0.0165054535027   , 0.0284753446158   , 0.0455800892286   ,
 0.06754183182     , 0.0980794282962   , 0.154951029833    , 0.278633485413    ,
 0.532174426054    , 0.996708013735    , 1.78390479022     , 3.08134583        ,
 5.20994234669     , 8.65644871061     , 14.088216868      , 22.3501900794     ,
 34.2713889881     , 50.0225462153     , 68.1929067457     , 85.4271370924     ,
 97.4059383232     , 100.872917911     , 95.3466996758     , 83.2556986258     ,
 68.4622497764     , 54.3441813414     , 42.6788787873     , 33.6853663364     ,
 26.7483450589     , 21.1492046269     , 16.420708589      , 12.3585330801     ,
 8.91966184835     , 6.13362667388     , 4.01914338226     , 2.52111267131     ,
 1.51596782325     , 0.867074178771    , 0.465042269866    , 0.23084802397     ,
 0.105479534859    , 0.0446316052228   , 0.0178057798295   , 0.00682864635617  ,
 0.000576411632342 , 0.000185442668128 , 8.00738343416e-05 , 0.000155715397564 ,
 0.000567410062065 , 0.00174302527525  , 0.00419237837955  , 0.00786499601898  ,
 0.0115146135463   , 0.0131762962503   , 0.0118236874438   , 0.00837776671422  ,
 0.00475526607523  , 0.00222393746688  , 0.000897966329201 , 0.00033050192605  ,
 0.000113805538004 , 3.57370501825e-05 , 9.73285344904e-06 , 2.25101070072e-06 ,
 5.36776209672e-07 , 2.94725063238e-07 , 3.27719126364e-07 , 3.44871558054e-07 ,
 2.90975873521e-07 , 1.93225512868e-07 , 1.00669815233e-07 , 4.11052399082e-08 ,
 1.31703176102e-08 , 3.36114155017e-09 , 7.79748090581e-10 , 3.38223660553e-10 ,
 4.20684538647e-10 , 6.72024161422e-10 , 1.08715308262e-09 , 1.91093084166e-09 ,
 4.49131603176e-09 , 1.48127831033e-08 , 5.18847025507e-08 , 1.56265696939e-07 ,
 3.77150612266e-07 , 7.16523730861e-07 , 1.06750293306e-06 , 1.24722364036e-06 ,
 1.1451140331e-06  , 8.3922708134e-07  , 6.30092527757e-07 , 1.86418991972e-06 ,
 1.39322899428e-05 , 9.21263830529e-05 , 0.000484786605636 , 0.00203696091242  ,
 0.0069366182796   , 0.0195932273064   , 0.0473826615668   , 0.101786819558    ,
 0.200875831063    , 0.371922576405    , 0.649307383145    , 1.06260954971     ,
 1.61852640166     , 2.29452349324     , 3.05792711132     , 3.8900794034      ,
 4.77436401483     , 5.64530792301     , 6.36036614042     , 6.75428028495     ,
 6.74055098062     , 6.35487300915     , 5.70394331719     , 4.89529234484     ,
 4.01881545772     , 3.16019699939     , 2.39732514564     , 1.77975451982     ,
 1.31799153312     , 0.989108284992    , 0.751792791589    , 0.566000292423    ,
 0.408597457279    , 0.27560355875     , 0.172444868884    , 0.102575147852    ,
 0.0627281314551   , 0.0450663339623   , 0.0409208184331   , 0.0422019614813   ,
 0.0418818552754   , 0.0360535155023   , 0.0257032427786   , 0.0149985838578   ,
 0.00757071736407  , 0.00489224129986  , 0.0074623751895   , 0.0158552392157   ,
 0.029344656586    , 0.0435840843718   , 0.0514676588617   , 0.0483032790821   ,
 0.0360643706661   , 0.0214659760371   , 0.0102720897444   , 0.00415915262468  ,
 0.00184833010416  , 0.00145212715377  , 0.00162876130777  , 0.00167688192492  ,
 0.00139378385545  , 0.000914635914974 , 0.000471725195011 , 0.000190863299954 ,
 6.05031511525e-05 , 1.50099103248e-05 , 2.91151068899e-06 , 4.41226296049e-07 ,
 5.22072531285e-08 , 4.82071813309e-09 , 3.47295986736e-10 , 1.95460712e-11    ,
 8.76156107037e-13 , 3.98616582026e-14 , 7.80390196405e-15 , 8.10613130674e-14 ,
 2.06194443794e-12 , 4.24820815051e-11 , 6.92274627176e-10 , 8.91002343133e-09 ,
 9.05154445444e-08 , 7.25912121468e-07 , 4.60534948672e-06 , 2.32542904466e-05 ,
 9.47610123438e-05 , 0.000320106936235 , 0.000934751939095 , 0.00246764271804  ,
 0.00600460078219  , 0.0132132338009   , 0.0253994169471   , 0.0418272922679   ,
 0.0599474268128   , 0.08052676918     , 0.116430913325    , 0.199127234507    ,
 0.378498112746    , 0.720505981164    , 1.31604250336     , 2.30767415314     ,
 3.914849393       , 6.42717182925     , 10.1724819949     , 15.4852503898     ,
 22.6071475674     , 31.3818773247     , 40.8389534548     , 49.1309265716     ,
 54.1769015328     , 54.6953794496     , 50.8568028201     , 44.0911229934     ,
 36.2784505965     , 28.9320763103     , 22.8065771758     , 17.9672912414     ,
 14.1199575246     , 10.9471179111     , 8.26803117074     , 6.01895715731     ,
 4.1837930412      , 2.75649362164     , 1.71881561831     , 1.01987345862     ,
 0.579353499443    , 0.314366965456    , 0.160967811922    , 0.0765914204152   ,
 0.0334818288625   , 0.0134075302852   , 0.00496211601369  , 0.00172981532671  ,
 0.000116534874168 , 3.45698674821e-05 , 2.03744136379e-05 , 6.19497874337e-05 ,
 0.000237790822945 , 0.00073273518812  , 0.00176234691288  , 0.00330450120603  ,
 0.00483230122051  , 0.00551565802488  , 0.00492204498548  , 0.00344554144561  ,
 0.00190553642399  , 0.000845096273593 , 0.000309531759242 , 9.83304933072e-05 ,
 2.86586018021e-05 , 7.85346302601e-06 , 1.96518467194e-06 , 4.29178915007e-07 ,
 8.7291667493e-08  , 3.09996290672e-08 , 2.86389757864e-08 , 2.9535785951e-08  ,
 2.48873767454e-08 , 1.6526523453e-08  , 8.60917194339e-09 , 3.51326258453e-09 ,
 1.1229794007e-09  , 2.82883815056e-10 , 6.00075403382e-11 , 1.81860590165e-11 ,
 1.83488627107e-11 , 2.9348713516e-11  , 5.00082439405e-11 , 1.0285939255e-10  ,
 3.15571077901e-10 , 1.24373831096e-09 , 4.6276485866e-09  , 1.41511647651e-08 ,
 3.42407996316e-08 , 6.49746848679e-08 , 9.65428388898e-08 , 1.12399762043e-07 ,
 1.03165840613e-07 , 8.33192660466e-08 , 1.74202246586e-07 , 1.44756523668e-06 ,
 1.20868700421e-05 , 8.01555345668e-05 , 0.00041917341029  , 0.00174131648338  ,
 0.00582120023317  , 0.0159864709141   , 0.0371895261306   , 0.0763224686346   ,
 0.144373285835    , 0.260132662719    , 0.450665089994    , 0.741725392974    ,
 1.13839597376     , 1.61155043517     , 2.11011166435     , 2.59404437792     ,
 3.05056677562     , 3.46696065745     , 3.79229416132     , 3.94727509051     ,
 3.88032129035     , 3.60407900714     , 3.17759774913     , 2.66815421538     ,
 2.13357106686     , 1.62398841404     , 1.18149074351     , 0.832073174706    ,
 0.579879453143    , 0.40976571793     , 0.29642988364     , 0.215615475997    ,
 0.151969757786    , 0.10013800841     , 0.0605432187801   , 0.0342289479471   ,
 0.0202112369263   , 0.0157187730608   , 0.0172308641871   , 0.0207755816782   ,
 0.0224209648288   , 0.0199901345927   , 0.0143580550731   , 0.00833119908438  ,
 0.00433235303697  , 0.00359994339836  , 0.00718207075471  , 0.0164944556092   ,
 0.0316066165197   , 0.048477812123    , 0.059281159625    , 0.0577862535212   ,
 0.044919075251    , 0.0279083842922   , 0.0140838229273   , 0.00638273803348  ,
 0.00381621718762  , 0.00403850936156  , 0.00494164613944  , 0.00516015853428  ,
 0.00429775513697  , 0.0028211109065   , 0.00145505160857  , 0.000588726896855 ,
 0.000186624875294 , 4.62987750731e-05 , 8.98068731684e-06 , 1.36098046635e-06 ,
 1.61034229676e-07 , 1.48690132874e-08 , 1.07093181127e-09 , 6.01473187865e-11 ,
 2.63382707457e-12 , 9.00888363037e-14 , 3.09468249386e-15 , 2.041380789e-14   ,
 5.30243534083e-13 , 1.09380824784e-11 , 1.78461928408e-10 , 2.3029270127e-09  ,
 2.35307028382e-08 , 1.91107183631e-07 , 1.24542310588e-06 , 6.64161656374e-06 ,
 2.99788084802e-05 , 0.000119581688317 , 0.000434427350112 , 0.00142829647164  ,
 0.00410163494663  , 0.00991835151589  , 0.0197845653101   , 0.032558654467    ,
 0.045528393648    , 0.0589131059076   , 0.0823840087266   , 0.138684647104    ,
 0.26269794603     , 0.501288602416    , 0.921736426286    , 1.6274240717      ,
 2.7625097158      , 4.48596412627     , 6.92698573533     , 10.1556673113     ,
 14.149803478      , 18.6820631236     , 23.1646785917     , 26.6831879732     ,
 28.3619745582     , 27.8291991877     , 25.38993392       , 21.8001949361     ,
 17.8806428336     , 14.2396109031     , 11.1776057599     , 8.7211496087      ,
 6.74225482393     , 5.10411320418     , 3.73844011589     , 2.62728321222     ,
 1.75874096557     , 1.11228731484     , 0.661158791009    , 0.370435665921    ,
 0.197379674465    , 0.100551142331    , 0.0486982692789   , 0.0221050116075   ,
 0.00925676599232  , 0.00353383141561  , 0.00122597025602  , 0.000390407901694 ,
 2.11603033398e-05 , 5.8390126214e-06  , 5.0917726797e-06  , 1.99362070056e-05 ,
 7.79824650232e-05 , 0.000240539006519 , 0.000578511197577 , 0.00108449618527  ,
 0.00158510290749  , 0.00180725950975  , 0.00160882437434  , 0.00112013958937  ,
 0.000612128834046 , 0.000264523014439 , 9.18294951267e-05 , 2.64208049409e-05 ,
 6.63363584579e-06 , 1.5391075145e-06  , 3.37108059314e-07 , 6.7580888127e-08  ,
 1.23285667442e-08 , 2.99108220536e-09 , 2.03468518953e-09 , 2.00289427526e-09 ,
 1.6808017415e-09  , 1.11580283086e-09 , 5.81219469857e-10 , 2.37141649747e-10 ,
 7.57526684093e-11 , 1.90395835353e-11 , 3.98732564357e-12 , 1.09651894852e-12 ,
 9.11173665232e-13 , 1.27091300105e-12 , 2.07576259597e-12 , 4.97069699863e-12 ,
 1.92683467913e-11 , 8.4987213791e-11  , 3.26504204418e-10 , 1.00579727248e-09 ,
 2.43545804653e-09 , 4.6155103689e-09  , 6.84317475731e-09 , 7.95745903284e-09 ,
 7.59295418416e-09 , 1.17068688292e-08 , 9.35416679744e-08 , 9.8165545197e-07  ,
 8.29490090025e-06 , 5.50383273838e-05 , 0.000287760288823 , 0.00119470066537  ,
 0.00398926225029  , 0.0109342219739   , 0.0253701354993   , 0.0519558563744   ,
 0.0983644176672   , 0.178321904209    , 0.312312320224    , 0.520076240159    ,
 0.803494847439    , 1.13102296647     , 1.44418325985     , 1.69246332668     ,
 1.86668596883     , 1.98961593298     , 2.07227068437     , 2.09271962122     ,
 2.02095649791     , 1.85148126032     , 1.60789437184     , 1.32645074381     ,
 1.04079803038     , 0.776484032491    , 0.550911050781    , 0.37351890299     ,
 0.245488669309    , 0.160410362828    , 0.106930845316    , 0.0729833966875   ,
 0.0495483057606   , 0.0319944603061   , 0.0189857917116   , 0.0104545845007   ,
 0.0061766364235   , 0.00541820494131  , 0.00700918738995  , 0.00930241949504  ,
 0.0104689204293   , 0.00948204329213  , 0.00683300230922  , 0.00397790945339  ,
 0.00222240691598  , 0.00247235399025  , 0.00594719063485  , 0.0144531997297   ,
 0.028791704363    , 0.0459304722203   , 0.0585034883147   , 0.0594285931517   ,
 0.0481191313172   , 0.0311737730629   , 0.0166780050236   , 0.00879062158433  ,
 0.00718002958134  , 0.00922390293517  , 0.0117840007381   , 0.0123875190035   ,
 0.0103270440849   , 0.00677966598949  , 0.00349680237101  , 0.0014148343568   ,
 0.000448497795917 , 0.000111265305423 , 2.15823921649e-05 , 3.27070794547e-06 ,
 3.86997347404e-07 , 3.57331884069e-08 , 2.57365642801e-09 , 1.44543435995e-10 ,
 6.32847606205e-12 , 2.15957090777e-13 , 5.86683989551e-15 , 4.20952788417e-15 ,
 1.06845615824e-13 , 2.20792843326e-12 , 3.61626276782e-11 , 4.7067514433e-10  ,
 4.9000982696e-09  , 4.13927774753e-08 , 2.91444969771e-07 , 1.78001305145e-06 ,
 9.79811369959e-06 , 4.90695772168e-05 , 0.000217479746082 , 0.000818164032661 ,
 0.00252913050073  , 0.00631595190554  , 0.0127012681158   , 0.0208182209105   ,
 0.0289952950195   , 0.038094430489    , 0.0557171895896   , 0.0976544708065   ,
 0.186362663726    , 0.351760182392    , 0.639157648547    , 1.11887924763     ,
 1.88120733689     , 3.00639554503     , 4.52558593661     , 6.40249126077     ,
 8.53299761963     , 10.7219359082     , 12.6459052837     , 13.9020034185     ,
 14.1879027872     , 13.4768289257     , 12.0166072547     , 10.1696104127     ,
 8.257009815       , 6.50094658245     , 5.02126453976     , 3.83712559118     ,
 2.89462194635     , 2.12869110998     , 1.50634779292     , 1.01877262317     ,
 0.655726287068    , 0.398563636107    , 0.226608130804    , 0.120138040901    ,
 0.0598315751479   , 0.0283295046722   , 0.0128182720011   , 0.00550121583161  ,
 0.00220232074384  , 0.000806494125155 , 0.000265929650852 , 7.86216818597e-05 ,
 3.4632994993e-06  , 9.13793439708e-07 , 1.14730353712e-06 , 5.07511473284e-06 ,
 1.99923297394e-05 , 6.16882973597e-05 , 0.000148360390366 , 0.000278093530162 ,
 0.000406372530376 , 0.000463101438444 , 0.000411809169682 , 0.000286032015804 ,
 0.000155468823463 , 6.63785435817e-05 , 2.24421354703e-05 , 6.11263433947e-06 ,
 1.38888723285e-06 , 2.79708361065e-07 , 5.39548727413e-08 , 1.06064598535e-08 ,
 2.21260997505e-09 , 5.37061030678e-10 , 1.97901546767e-10 , 1.25332884129e-10 ,
 9.27011241296e-11 , 5.98452824425e-11 , 3.10439539132e-11 , 1.28845322643e-11 ,
 4.8656599438e-12  , 3.10618537498e-12 , 4.33877860497e-12 , 6.4639481698e-12  ,
 7.88795827854e-12 , 7.63834737464e-12 , 5.87745790539e-12 , 3.72067682797e-12 ,
 2.66281969008e-12 , 5.26983952629e-12 , 1.82930875975e-11 , 5.60039767068e-11 ,
 1.35503481901e-10 , 2.56483753471e-10 , 3.79842556327e-10 , 4.48101310748e-10 ,
 5.9578281372e-10  , 3.78973724146e-09 , 4.88011599683e-08 , 5.27408353734e-07 ,
 4.47696225521e-06 , 2.98708173495e-05 , 0.000157559143254 , 0.000663278093779 ,
 0.00226189035673  , 0.0063890738277   , 0.0154151078181   , 0.0329822847095   ,
 0.0649796176444   , 0.121116258072    , 0.215271837782    , 0.360838385995    ,
 0.558341243003    , 0.780922792812    , 0.975191746863    , 1.09083041973     ,
 1.11895913132     , 1.09484069724     , 1.05762298519     , 1.01576100805     ,
 0.953560129748    , 0.858202299154    , 0.733773140967    , 0.596489159632    ,
 0.46333362664     , 0.344829634048    , 0.24492794694     , 0.164587360612    ,
 0.104128744397    , 0.0627254330774   , 0.0372194612487   , 0.0226639889069   ,
 0.0142744007796   , 0.00891730379804  , 0.00522837438068  , 0.00286234176379  ,
 0.00174731711742  , 0.00173995363758  , 0.00251715034294  , 0.00350851314726  ,
 0.00402313284157  , 0.00366791534174  , 0.00264848947045  , 0.00156073441486  ,
 0.000987698750127 , 0.00151592971724  , 0.00421288560222  , 0.010802398719    ,
 0.0224731913922   , 0.0373937749028   , 0.0495996573022   , 0.0523329671949   ,
 0.043899526216    , 0.0295207721664   , 0.0168908987587   , 0.010802745841    ,
 0.0116836809309   , 0.0168484334641   , 0.0219930398178   , 0.0231904787511   ,
 0.0193395463961   , 0.0126962032131   , 0.00654822056451  , 0.002649413496    ,
 0.000839847346238 , 0.00020835206517  , 4.04144496312e-05 , 6.12460944888e-06 ,
 7.24676880147e-07 , 6.69126274131e-08 , 4.81933182837e-09 , 2.70666546918e-10 ,
 1.18504592426e-11 , 4.04386982235e-13 , 1.07729838675e-14 , 8.66323985728e-16 ,
 1.69105196368e-14 , 3.51420354694e-13 , 5.82852086193e-12 , 7.79644129089e-11 ,
 8.5879924979e-10  , 8.06729031809e-09 , 6.74250973033e-08 , 5.14187210388e-07 ,
 3.5289493607e-06  , 2.0919179151e-05  , 0.000102875572489 , 0.000408937807099 ,
 0.00129754544271  , 0.0032764757024   , 0.0066236740577   , 0.0109612731721   ,
 0.0158040069717   , 0.0227403357023   , 0.0379393378135   , 0.0725104061991   ,
 0.14070775944     , 0.260295147309    , 0.45866069431     , 0.779134072438    ,
 1.27438114971     , 1.98195528107     , 2.8962249308      , 3.95704559008     ,
 5.05724844988     , 6.05280272965     , 6.77564581019     , 7.07662596207     ,
 6.89773647411     , 6.3105141706      , 5.47106211013     , 4.53442059479     ,
 3.61015621861     , 2.77281152566     , 2.07348195805     , 1.52736547103     ,
 1.11086014232     , 0.788014372401    , 0.53659344373     , 0.348036203854    ,
 0.214712747013    , 0.125326089555    , 0.0683533911252   , 0.0344549760538   ,
 0.0160662240741   , 0.00702723333901  , 0.00293191679397  , 0.00117385934184  ,
 0.000446035241046 , 0.000157006349169 , 4.98054867954e-05 , 1.39590709908e-05 ,
 5.02478988967e-07 , 1.31210404442e-07 , 2.16975986476e-07 , 1.01459276062e-06 ,
 4.00775934249e-06 , 1.23678965647e-05 , 2.97444047909e-05 , 5.57518114592e-05 ,
 8.14610544982e-05 , 9.28129443018e-05 , 8.24940465697e-05 , 5.72384804454e-05 ,
 3.10413002381e-05 , 1.31939795633e-05 , 4.43143445424e-06 , 1.21321318994e-06 ,
 3.06455564156e-07 , 9.81941529081e-08 , 4.65966284087e-08 , 2.40634618913e-08 ,
 1.07373322411e-08 , 3.87420166905e-09 , 1.11495796268e-09 , 2.57023009932e-10 ,
 4.92177579211e-11 , 9.22952678311e-12 , 3.51939861995e-12 , 6.70076778203e-12 ,
 1.96695550297e-11 , 4.89089562819e-11 , 9.63335064854e-11 , 1.49551718266e-10 ,
 1.83137070525e-10 , 1.7711267899e-10  , 1.35402743247e-10 , 8.18802853769e-11 ,
 3.92007515775e-11 , 1.50098416688e-11 , 5.21137784517e-12 , 3.47677650156e-12 ,
 6.08366597246e-12 , 1.11687459058e-11 , 1.6584317504e-11  , 2.26322204104e-11 ,
 9.968076528e-11   , 1.48179588538e-09 , 2.04717396396e-08 , 2.2321079617e-07  ,
 1.91359983281e-06 , 1.29694290925e-05 , 7.01084540763e-05 , 0.000306261769293 ,
 0.00110083867088  , 0.0033297604172   , 0.00868714464787  , 0.0200252453275   ,
 0.0416919423736   , 0.0799095274869   , 0.142858833252    , 0.238540937626    ,
 0.367289687498    , 0.510388752415    , 0.627534226705    , 0.677664210195    ,
 0.652036270163    , 0.582260559309    , 0.50991859867     , 0.453429044981    ,
 0.406113824527    , 0.355705730458    , 0.29861638004     , 0.240037270263    ,
 0.186784248811    , 0.141705876377    , 0.103686066294    , 0.07120261119     ,
 0.0446418882837   , 0.0253037904778   , 0.0132701515056   , 0.00686033874214  ,
 0.00375264527584  , 0.00217601579368  , 0.00124726618686  , 0.000684933631567 ,
 0.000438759488307 , 0.000485694363726 , 0.000750621972237 , 0.00107119657846  ,
 0.00123841795051  , 0.00113226770542  , 0.000819616014011 , 0.000495727307765 ,
 0.000384675938277 , 0.00082463408285  , 0.00256928542395  , 0.00693271127024  ,
 0.0150457066819   , 0.0260137948345   , 0.0357075680722   , 0.0388308357035   ,
 0.0334953030752   , 0.0233315818463   , 0.0145790488097   , 0.0117678429903   ,
 0.015871352923    , 0.0243773064237   , 0.0321113100465   , 0.0338746993069   ,
 0.0282383777396   , 0.0185329424617   , 0.00955715786024  , 0.00386654567914  ,
 0.00122562695338  , 0.000304052355053 , 5.8977140608e-05  , 8.93765881152e-06 ,
 1.05752096049e-06 , 9.76455115878e-08 , 7.03284188513e-09 , 3.94983106765e-10 ,
 1.72933479431e-11 , 5.9012031874e-13  , 1.56948540639e-14 , 4.02906997874e-16 ,
 2.11859181786e-15 , 4.48399939523e-14 , 7.73538773428e-13 , 1.12007395346e-11 ,
 1.42049449647e-10 , 1.64002534264e-09 , 1.73245370178e-08 , 1.61836098476e-07 ,
 1.27698265599e-06 , 8.22354413971e-06 , 4.24081433008e-05 , 0.000173729631898 ,
 0.000564778159997 , 0.00146413765546  , 0.00307116118447  , 0.00541282649722  ,
 0.00875778669143  , 0.0149817031183   , 0.0291827437892   , 0.0597745329784   ,
 0.116528964147    , 0.209548836763    , 0.352644885223    , 0.567970642371    ,
 0.882645451093    , 1.31368330207     , 1.84950516291     , 2.43975172214     ,
 2.99937764292     , 3.42741843251     , 3.63768226943     , 3.59282552557     ,
 3.32266730538     , 2.90753422656     , 2.43403554733     , 1.9598600195      ,
 1.51428065375     , 1.1192652194      , 0.796723873403    , 0.555672880107    ,
 0.384427922994    , 0.261703561454    , 0.171632797182    , 0.106814458666    ,
 0.0628868445483   , 0.0349751121746   , 0.0181886138423   , 0.00870875069157  ,
 0.00380936273801  , 0.00153609929309  , 0.000584479015522 , 0.000214661007295 ,
 7.63610017694e-05 , 2.57227482805e-05 , 7.90154810291e-06 , 2.13719981213e-06 ,
 6.65522514086e-08 , 1.75957148297e-08 , 3.33261282709e-08 , 1.59004497458e-07 ,
 6.28681805906e-07 , 1.94018754416e-06 , 4.66606107639e-06 , 8.74573618848e-06 ,
 1.2778306655e-05  , 1.45585425356e-05 , 1.29419635197e-05 , 8.99477090471e-06 ,
 4.93339975813e-06 , 2.24112566177e-06 , 1.03634756349e-06 , 7.13073016401e-07 ,
 6.72856405974e-07 , 6.01395583348e-07 , 4.40009729907e-07 , 2.55834943165e-07 ,
 1.17682021333e-07 , 4.28166307826e-08 , 1.23234571533e-08 , 2.80553645658e-09 ,
 5.05693799101e-10 , 7.70703205017e-11 , 3.54374205131e-11 , 1.12065658755e-10 ,
 3.5541152651e-10  , 8.90681299086e-10 , 1.7556911662e-09  , 2.72580825657e-09 ,
 3.33797549508e-09 , 3.22816777196e-09 , 2.46791525561e-09 , 1.4922732361e-09  ,
 7.13759916737e-10 , 2.69950881101e-10 , 8.06876552509e-11 , 1.91030280718e-11 ,
 3.73453613874e-12 , 8.95577139208e-13 , 6.5695483143e-13  , 1.82713729437e-12 ,
 2.75809119113e-11 , 4.84162232912e-10 , 6.7968259365e-09  , 7.51958197522e-08 ,
 6.59394374518e-07 , 4.62699430423e-06 , 2.63230506008e-05 , 0.00012337379902  ,
 0.000484479290534 , 0.00161749210521  , 0.00464169859004  , 0.0115589712848   ,
 0.0252995742007   , 0.0495759382576   , 0.0887433048475   , 0.1468524821      ,
 0.223625690879    , 0.307331065881    , 0.372243387505    , 0.39121463473     ,
 0.357960098762    , 0.294409369974    , 0.231561440868    , 0.185767608637    ,
 0.154844196489    , 0.130125743239    , 0.1068110875      , 0.085319770154    ,
 0.0674831954369   , 0.0532939209823   , 0.0409784741423   , 0.029223610579    ,
 0.0184928405618   , 0.0101433009826   , 0.00485053283651  , 0.00212753660392  ,
 0.000951724199517 , 0.000475724539007 , 0.000256587266729 , 0.000140209846751 ,
 9.3989412925e-05  , 0.000112297148123 , 0.000180110140277 , 0.00025995643683  ,
 0.000301631505095 , 0.000276177503223 , 0.000200847355992 , 0.000128108961311 ,
 0.000135948453443 , 0.00039629058285  , 0.00134603988475  , 0.00379448742324  ,
 0.0085317635451   , 0.0152031585672   , 0.0214121945664   , 0.0238244763144   ,
 0.0210777190579   , 0.0154067378126   , 0.0110640881911   , 0.0115408043908   ,
 0.0179160956725   , 0.0280775082348   , 0.0368455662432   , 0.0387092118403   ,
 0.0321930342709   , 0.0211034535698   , 0.0108764708901   , 0.00439908310107  ,
 0.00139424729728  , 0.000345861683578 , 6.70848941146e-05 , 1.01661987229e-05 ,
 1.20287600938e-06 , 1.1106641875e-07  , 7.99946008608e-09 , 4.4927063215e-10  ,
 1.96701847727e-11 , 6.71227525083e-13 , 1.78494691804e-14 , 3.75376102676e-16 ,
 2.14792786893e-16 , 4.82650753417e-15 , 9.32840121405e-14 , 1.63265633703e-12 ,
 2.65952351308e-11 , 3.9526632563e-10  , 5.1054786955e-09  , 5.48788214342e-08 ,
 4.78497144694e-07 , 3.34619979576e-06 , 1.87144516484e-05 , 8.38603654769e-05 ,
 0.000302605281589 , 0.000886987847611 , 0.00214577095265  , 0.00442367739164  ,
 0.00826744171708  , 0.0152961802401   , 0.0296169962796   , 0.0582102985084   ,
 0.108788219748    , 0.186906955973    , 0.296535091219    , 0.444186699644    ,
 0.640391562626    , 0.893340052795    , 1.19651059661     , 1.51732673979     ,
 1.79675482073     , 1.96744092976     , 1.98493251852     , 1.85187078374     ,
 1.61567435482     , 1.33974223064     , 1.07095545232     , 0.828261906858    ,
 0.614673187307    , 0.433590070714    , 0.292153532798    , 0.193140834323    ,
 0.129348333768    , 0.0878729810808   , 0.0583010373019   , 0.0361192801337   ,
 0.02038833464     , 0.0104564897356   , 0.00490484581686  , 0.00211197291012  ,
 0.000833735216703 , 0.000302825505896 , 0.000103146162211 , 3.40266337913e-05 ,
 1.11290161076e-05 , 3.56801233494e-06 , 1.07243784119e-06 , 2.87150097005e-07 ,
 4.94768898655e-08 , 1.2610887757e-08  , 6.14622873256e-09 , 1.98496163259e-08 ,
 7.72850311411e-08 , 2.3840141601e-07  , 5.73347801674e-07 , 1.0747792119e-06  ,
 1.57155456228e-06 , 1.79856557272e-06 , 1.6405956275e-06  , 1.30836543425e-06 ,
 1.24560160216e-06 , 1.84969324815e-06 , 3.16430382196e-06 , 4.68454067638e-06 ,
 5.55057574387e-06 , 5.19255875038e-06 , 3.83083453349e-06 , 2.23083419431e-06 ,
 1.02649546356e-06 , 3.73501588755e-07 , 1.07502561711e-07 , 2.44735412047e-08 ,
 4.41481084063e-09 , 7.0093922579e-10  , 4.61111250876e-10 , 1.59745158619e-09 ,
 5.07920953468e-09 , 1.27296356325e-08 , 2.50924385023e-08 , 3.89574137738e-08 ,
 4.77065450522e-08 , 4.6137166568e-08  , 3.52715918986e-08 , 2.13276553198e-08 ,
 1.02010804974e-08 , 3.85805836494e-09 , 1.15281272253e-09 , 2.7184345083e-10  ,
 5.05228506612e-11 , 7.39774387775e-12 , 8.7381854589e-13  , 3.95120911666e-13 ,
 6.98435217556e-12 , 1.26352376586e-10 , 1.81081723278e-09 , 2.0664322828e-08  ,
 1.8980079255e-07  , 1.42222181751e-06 , 8.81957385103e-06 , 4.58069236048e-05 ,
 0.000200643575925 , 0.000742890620014 , 0.00232875614318  , 0.00621725191054  ,
 0.0143235207302   , 0.0290207414301   , 0.0527055289969   , 0.0868152724233   ,
 0.129634161811    , 0.17332484945     , 0.203639941885    , 0.206768083086    ,
 0.18058983676     , 0.138255584928    , 0.0979048343482   , 0.0695527234502   ,
 0.0524453243719   , 0.0414685537547   , 0.0330733821215   , 0.0263980978579   ,
 0.0215289178096   , 0.0179505576795   , 0.014581269028    , 0.0107883085643   ,
 0.00691029937175  , 0.00373207326048  , 0.0016930371831   , 0.000663945748314 ,
 0.000247091694183 , 0.00010224482848  , 5.01911954171e-05 , 2.70528497106e-05 ,
 1.82229165359e-05 , 2.16749445286e-05 , 3.4672857723e-05  , 5.00325659477e-05 ,
 5.80460585695e-05 , 5.31627767959e-05 , 3.90187829436e-05 , 2.77233980993e-05 ,
 4.48284858199e-05 , 0.000165587459476 , 0.000597261206124 , 0.00174081108528  ,
 0.00401869355659  , 0.00732169747604  , 0.0105272950577   , 0.0120166793363   ,
 0.0111649348231   , 0.00922771085005  , 0.00856743227756  , 0.0111989989904   ,
 0.0177598476589   , 0.026664254127    , 0.0338642542834   , 0.034940842884    ,
 0.0287951172857   , 0.0187918076216   , 0.0096641557749   , 0.00390469442673  ,
 0.00123694095666  , 0.000306767055382 , 5.94952141446e-05 , 9.01555808918e-06 ,
 1.0667037927e-06  , 9.84918982373e-08 , 7.09375089799e-09 , 3.98402554139e-10 ,
 1.74430314122e-11 , 5.95227218944e-13 , 1.58282578758e-14 , 3.26607850254e-16 ,
 1.86964057642e-17 , 5.47120535811e-16 , 1.46554473681e-14 , 3.73949366288e-13 ,
 8.57085172029e-12 , 1.6632153404e-10  , 2.63912109323e-09 , 3.36902216625e-08 ,
 3.43698519029e-07 , 2.79541436491e-06 , 1.81195168341e-05 , 9.36799599193e-05 ,
 0.000387121556096 , 0.00128377606455  , 0.00344347964271  , 0.00759385823712  ,
 0.01424038362     , 0.0241423684148   , 0.04002686128     , 0.067764957171    ,
 0.114132507233    , 0.182039476421    , 0.26884819797     , 0.370842026162    ,
 0.488967215438    , 0.628252685309    , 0.788583799961    , 0.952808437814    ,
 1.08428355318     , 1.14150397884     , 1.10178631255     , 0.975910957011    ,
 0.802099840732    , 0.623659868198    , 0.467843163449    , 0.341350877101    ,
 0.240566191558    , 0.162442659207    , 0.106957675479    , 0.0730941965337   ,
 0.0552477724399   , 0.0446553824652   , 0.0345119160122   , 0.0232922955226   ,
 0.0131570715923   , 0.00615734382277  , 0.00241061242111  , 0.000809651563167 ,
 0.00024239240261  , 6.78929327492e-05 , 1.90041962533e-05 , 5.91387228585e-06 ,
 2.26062256378e-06 , 1.0012557177e-06  , 4.3324506953e-07  , 1.61937048724e-07 ,
 3.66313578719e-07 , 9.23987452538e-08 , 1.85118590612e-08 , 4.65646157536e-09 ,
 7.77482045939e-09 , 2.30105310674e-08 , 5.53613886165e-08 , 1.04778573174e-07 ,
 1.61682857111e-07 , 2.40829094067e-07 , 5.05405938897e-07 , 1.52211613693e-06 ,
 4.50851985877e-06 , 1.09778361707e-05 , 2.11340191118e-05 , 3.197712965e-05   ,
 3.80326114254e-05 , 3.56026963505e-05 , 2.62690249601e-05 , 1.52977144986e-05 ,
 7.03911273727e-06 , 2.56126009646e-06 , 7.37191679087e-07 , 1.67831374219e-07 ,
 3.03236932241e-08 , 5.13506570166e-09 , 4.86851579283e-09 , 1.78993870594e-08 ,
 5.69963594985e-08 , 1.42850228395e-07 , 2.81584107474e-07 , 4.37175078192e-07 ,
 5.35356703076e-07 , 5.1774534109e-07  , 3.95813263139e-07 , 2.39336203717e-07 ,
 1.14475213757e-07 , 4.32946339806e-08 , 1.29367090146e-08 , 3.0505681159e-09  ,
 5.66901734334e-10 , 8.29017032004e-11 , 9.52813298059e-12 , 9.20287018287e-13 ,
 1.49680715528e-12 , 2.67804947978e-11 , 4.00120182268e-10 , 4.84927121628e-09 ,
 4.83106156975e-08 , 4.00292851456e-07 , 2.77754566741e-06 , 1.61566713526e-05 ,
 7.86169328395e-05 , 0.000319766163276 , 0.00109199554855  , 0.00316348207099  ,
 0.00787852428463  , 0.017057389094    , 0.0322830095471   , 0.0534538783273   ,
 0.0773805508317   , 0.0978320304017   , 0.107677564821    , 0.102527665378    ,
 0.0840453867492   , 0.0597631637147   , 0.0382419853348   , 0.0238044744513   ,
 0.0157630426618   , 0.0114149552986   , 0.00874994308125  , 0.00700510994637  ,
 0.00595353430562  , 0.0052646047538   , 0.00449056007401  , 0.00341535879304  ,
 0.00220601986058  , 0.00118525923203  , 0.000533438112302 , 0.000215443200941 ,
 9.56846216915e-05 , 5.68946443904e-05 , 3.90515172299e-05 , 2.47296641317e-05 ,
 1.40653783613e-05 , 9.06654157183e-06 , 8.85533647376e-06 , 1.05540913955e-05 ,
 1.13202665418e-05 , 9.90106746509e-06 , 7.1267264578e-06  , 5.80913545401e-06 ,
 1.38372086869e-05 , 5.87145262443e-05 , 0.000219997388948 , 0.000656644396093 ,
 0.00154688151274  , 0.00288114964036  , 0.00429231869068  , 0.00530066201399  ,
 0.0059240276789   , 0.00691029060112  , 0.00915928626921  , 0.0130142962174   ,
 0.0181068532915   , 0.023315626826    , 0.0265954903311   , 0.0257857180668   ,
 0.0205635827702   , 0.0131999451598   , 0.00673361701235  , 0.00271000080241  ,
 0.000856868878464 , 0.00021231652618  , 4.11596037103e-05 , 6.23581725233e-06 ,
 7.37738832807e-07 , 6.81144755494e-08 , 4.90575005156e-09 , 2.75516196396e-10 ,
 1.20627091236e-11 , 4.1162694466e-13  , 1.09459555943e-14 , 2.25491925315e-16 ,
 1.57351028804e-18 , 1.89390948239e-16 , 8.39834297596e-15 , 3.00159799165e-13 ,
 8.56201088288e-12 , 1.92937667041e-10 , 3.42171618684e-09 , 4.77090144142e-08 ,
 5.23082301444e-07 , 4.51401359854e-06 , 3.07084937685e-05 , 0.000165050785435 ,
 0.000702996071133 , 0.00238294607409  , 0.00647065404519  , 0.0142366377625   ,
 0.0259411797506   , 0.0408252306308   , 0.0594231572712   , 0.0860079406771   ,
 0.126605518516    , 0.182789377878    , 0.248515417309    , 0.315097952459    ,
 0.379450694327    , 0.446166280727    , 0.519804044075    , 0.593759627932    ,
 0.647598535663    , 0.657764429544    , 0.612747122085    , 0.520656043418    ,
 0.405244277813    , 0.2934320316      , 0.202439097065    , 0.135895198371    ,
 0.0896890835801   , 0.0593660275588   , 0.0426750696202   , 0.0374819063496   ,
 0.0388974688935   , 0.0397570963758   , 0.0349903030485   , 0.0250846730744   ,
 0.0143859848668   , 0.00657174304716  , 0.00239508701076  , 0.000701351952234 ,
 0.000169161619543 , 3.82158654496e-05 , 1.33476470277e-05 , 9.52093098971e-06 ,
 7.67055073964e-06 , 5.15442265111e-06 , 2.73302518346e-06 , 1.13282592132e-06 ,
 2.43568463249e-06 , 6.1427075492e-07  , 1.20743387133e-07 , 1.86258436236e-08 ,
 2.77056487024e-09 , 1.98742663744e-09 , 4.8100156568e-09  , 1.44877216287e-08 ,
 6.75830689661e-08 , 3.82784511711e-07 , 1.91338495891e-06 , 7.65209561346e-06 ,
 2.40334391122e-05 , 5.91345925355e-05 , 0.000114049363717 , 0.000172617651852 ,
 0.000205317032766 , 0.000192201013794 , 0.000141813447093 , 8.25848014157e-05 ,
 3.80006932158e-05 , 1.38269787701e-05 , 3.97973855128e-06 , 9.06089998076e-07 ,
 1.64138283951e-07 , 3.0614455564e-08  , 4.13128239246e-08 , 1.57798830617e-07 ,
 5.02925719928e-07 , 1.26050968929e-06 , 2.48469779744e-06 , 3.85763236842e-06 ,
 4.72398693679e-06 , 4.56858434361e-06 , 3.49265587613e-06 , 2.11190250788e-06 ,
 1.01012926437e-06 , 3.82031875519e-07 , 1.14153544885e-07 , 2.69182253202e-08 ,
 5.00234444429e-09 , 7.31523569668e-10 , 8.40561016601e-11 , 7.58847946929e-12 ,
 7.79616539348e-13 , 4.84220436569e-12 , 7.76138560647e-11 , 1.03652327029e-09 ,
 1.15536416988e-08 , 1.07683105341e-07 , 8.3699032099e-07  , 5.40932486766e-06 ,
 2.90901411112e-05 , 0.000130987338042 , 0.0004987623249   , 0.0016200821887   ,
 0.00450044553083  , 0.0106391206897   , 0.0212189127706   , 0.0354614749676   ,
 0.0496108945816   , 0.0584295375165   , 0.058510851508    , 0.0503067393514   ,
 0.0373748367693   , 0.02415327738     , 0.0138713895718   , 0.0075125791168   ,
 0.00424758945061  , 0.0027152276653   , 0.00196061247357  , 0.00157282173341  ,
 0.00139964343826  , 0.00130830883622  , 0.00116016929181  , 0.000900968770415 ,
 0.000593828802749 , 0.000345379964938 , 0.000215031429202 , 0.000187998810793 ,
 0.000205015601276 , 0.000207961852095 , 0.000173446490527 , 0.000116507826965 ,
 6.57155409595e-05 , 3.66905052262e-05 , 2.65095756697e-05 , 2.41861631304e-05 ,
 2.13494841968e-05 , 1.58148119232e-05 , 9.50587195885e-06 , 5.05971965082e-06 ,
 5.20397734494e-06 , 1.76330497981e-05 , 6.6228165953e-05  , 0.000201662900819 ,
 0.000489581072308 , 0.000970054374323 , 0.00166909372249  , 0.00277752522458  ,
 0.0048491962602   , 0.00852304061307  , 0.0136527887307   , 0.0188104467481   ,
 0.0221477713954   , 0.0227790491065   , 0.0209608565416   , 0.0172832991065   ,
 0.0124450233798   , 0.0075460965738   , 0.00373742414926  , 0.00148222100883  ,
 0.000465321316331 , 0.000114902373436 , 2.22383583851e-05 , 3.36655049554e-06 ,
 3.98137408265e-07 , 3.67530337154e-08 , 2.64681088574e-09 , 1.48644022701e-10 ,
 6.50784171368e-12 , 2.22069383004e-13 , 5.90525333476e-15 , 1.21633625578e-16 ,
 1.42935784455e-19 , 2.27899346229e-16 , 1.12364936768e-14 , 4.23585289285e-13 ,
 1.24797369477e-11 , 2.87483104634e-10 , 5.18103620535e-09 , 7.31168263408e-08 ,
 8.09005011026e-07 , 7.0292290282e-06  , 4.80567935964e-05 , 0.000259165986763 ,
 0.00110597883213  , 0.00375017173743  , 0.010162836203    , 0.0222142712699   ,
 0.0398110503888   , 0.0603163909925   , 0.081482770939    , 0.105317769109    ,
 0.136804370467    , 0.177175272983    , 0.22005901061     , 0.256388143965    ,
 0.282904836282    , 0.304661977591    , 0.328469003411    , 0.353637827245    ,
 0.369784924683    , 0.364119846854    , 0.330423833943    , 0.272658633156    ,
 0.203256969153    , 0.137525996852    , 0.0862538301035   , 0.0519940413246   ,
 0.0317535857309   , 0.0219603171993   , 0.0206878009954   , 0.0261812970115   ,
 0.03429699802     , 0.0388081864713   , 0.0355622755926   , 0.0259068697592   ,
 0.0149348056634   , 0.00681003282724  , 0.00245991843528  , 0.000710779565725 ,
 0.000178735445705 , 6.42605269692e-05 , 5.50546352903e-05 , 5.75196883336e-05 ,
 4.99404953237e-05 , 3.40611032132e-05 , 1.81324099356e-05 , 7.52703061816e-06 ,
 1.2699137761e-05  , 3.20266900781e-06 , 6.29390713908e-07 , 9.6379110808e-08  ,
 1.15399663317e-08 , 1.36037264632e-09 , 2.9431913796e-09  , 2.87817898917e-08 ,
 2.39605448746e-07 , 1.57447573771e-06 , 8.09509769497e-06 , 3.2535029087e-05  ,
 0.000102272528527 , 0.000251680072873 , 0.000485412679159 , 0.000734692057248 ,
 0.000873867208191 , 0.000818043113183 , 0.000603584309844 , 0.000351496219668 ,
 0.000161737992952 , 5.88501864912e-05 , 1.69385375393e-05 , 3.85684269587e-06 ,
 7.01624665876e-07 , 1.50365850709e-07 , 2.80087986078e-07 , 1.09590509215e-06 ,
 3.49471720762e-06 , 8.75910203356e-06 , 1.72658152153e-05 , 2.68061448006e-05 ,
 3.28263216556e-05 , 3.17464522103e-05 , 2.42699778975e-05 , 1.46753174567e-05 ,
 7.01924963234e-06 , 2.65468808094e-06 , 7.93238131141e-07 , 1.87051450658e-07 ,
 3.47607431703e-08 , 5.08329284482e-09 , 5.84099260149e-10 , 5.2664272232e-11  ,
 3.75711481087e-12 , 9.89936155554e-13 , 1.41431281352e-11 , 2.12843489204e-10 ,
 2.67222402362e-09 , 2.78702929917e-08 , 2.41229757195e-07 , 1.73956718602e-06 ,
 1.05345078593e-05 , 5.39975197249e-05 , 0.000234908093401 , 0.000862972259077 ,
 0.00264809722569  , 0.0067043702273   , 0.0138665424742   , 0.0233012002701   ,
 0.0318013189573   , 0.0354348769531   , 0.0325875332313   , 0.0251235895636   ,
 0.0165267140208   , 0.00943455536643  , 0.00476821336917  , 0.00222429550592  ,
 0.00104898012354  , 0.000565422946548 , 0.000371261973095 , 0.000295477198483 ,
 0.00027492811446  , 0.000270093470251 , 0.000249350640099 , 0.000208792901126 ,
 0.000182770969354 , 0.000226867423168 , 0.000378799026478 , 0.000611601223134 ,
 0.000817837335685 , 0.000871844681299 , 0.000737164584451 , 0.000501567402839 ,
 0.000293741326816 , 0.000180784934107 , 0.000146995812588 , 0.000140831645546 ,
 0.000124411738611 , 9.09296031002e-05 , 5.34007830944e-05 , 2.51139220392e-05 ,
 1.01129834034e-05 , 6.83745031577e-06 , 1.6898000072e-05  , 5.23604615691e-05 ,
 0.000142800928255 , 0.000364428143124 , 0.000951298665099 , 0.00250757098345  ,
 0.00605626337739  , 0.0123628912126   , 0.0205441510642   , 0.0274909105014   ,
 0.0297267166257   , 0.026362801495    , 0.0196903883604   , 0.0128162540074   ,
 0.00745927395603  , 0.00387510663557  , 0.00174562436049  , 0.000657275460062 ,
 0.00020093311576  , 4.89708834485e-05 , 9.41800974189e-06 , 1.42142273591e-06 ,
 1.6785840851e-07  , 1.54847792713e-08 , 1.1147906081e-09  , 6.25966147762e-11 ,
 2.74036515546e-12 , 9.35043725289e-14 , 2.48646164495e-15 , 5.12143221172e-17 ,
 1.34370865018e-20 , 2.81979938315e-16 , 1.3994610534e-14  , 5.29640025062e-13 ,
 1.56452475789e-11 , 3.61052410262e-10 , 6.51476788909e-09 , 9.20065754324e-08 ,
 1.0183466493e-06  , 8.84779105502e-06 , 6.04661142047e-05 , 0.000325846140269 ,
 0.00138897360381  , 0.0047022372462   , 0.0127127216475   , 0.0276762706848   ,
 0.0492000857096   , 0.0732161904155   , 0.0951799208059   , 0.114782282911    ,
 0.135515412799    , 0.158604864572    , 0.179423229615    , 0.191582652257    ,
 0.193695073381    , 0.190963544916    , 0.190045569456    , 0.192467218413    ,
 0.193193301926    , 0.185261987525    , 0.164948715102    , 0.133510376838    ,
 0.0965763496745   , 0.0619177918732   , 0.0355594992704   , 0.0191129836203   ,
 0.0108671556524   , 0.0087640692703   , 0.0118519013704   , 0.0191178344727   ,
 0.0274721622686   , 0.0320516360177   , 0.0296789522114   , 0.0217032438314   ,
 0.0125286741876   , 0.00571620609106  , 0.00207364120616  , 0.000630219998231 ,
 0.000233271509097 , 0.000208571244261 , 0.000268637804636 , 0.000297691581905 ,
 0.000260147689495 , 0.000177562758532 , 9.4535526621e-05  , 3.92439989093e-05 ,
 5.19014342996e-05 , 1.30893226901e-05 , 2.5723162354e-06  , 3.93867391723e-07 ,
 4.70207904732e-08 , 5.00480201675e-09 , 9.12124460557e-09 , 9.51659247012e-08 ,
 8.02823120431e-07 , 5.28770404542e-06 , 2.71974317255e-05 , 0.000109316868596 ,
 0.000343637210234 , 0.000845650518132 , 0.00163099773717  , 0.00246858231615  ,
 0.00293621407495  , 0.00274864382665  , 0.00202805727581  , 0.00118103544798  ,
 0.000543443407134 , 0.000197738003977 , 5.69140578683e-05 , 1.29610272072e-05 ,
 2.37400742054e-06 , 6.15011964684e-07 , 1.51148721794e-06 , 6.00359443261e-06 ,
 1.91512302618e-05 , 4.8000682798e-05  , 9.46182698383e-05 , 0.000146900170687 ,
 0.000179891319432 , 0.000173973565296 , 0.000133001819969 , 8.04221994204e-05 ,
 3.84662226524e-05 , 1.45479921975e-05 , 4.34704711404e-06 , 1.02507086281e-06 ,
 1.90495758501e-07 , 2.78578234031e-08 , 3.20109359133e-09 , 2.88624296434e-10 ,
 2.03989935398e-11 , 1.251266598e-12   , 2.56111134153e-12 , 4.25786786461e-11 ,
 5.98615073925e-10 , 6.99862692554e-09 , 6.84688457562e-08 , 5.64311621705e-07 ,
 3.92813379158e-06 , 2.29908382396e-05 , 0.000111983996972 , 0.000448337680428 ,
 0.001459035494    , 0.00382773134865  , 0.00805292602727  , 0.0135518676766   ,
 0.0182420655652   , 0.0196973478315   , 0.0171725787878   , 0.0122267571886   ,
 0.00723194300364  , 0.00363352739593  , 0.00159255847996  , 0.000632114016963 ,
 0.000244604554855 , 0.000106024883961 , 5.98544478845e-05 , 4.6118207098e-05  ,
 4.47608786684e-05 , 4.76000926508e-05 , 5.50899374368e-05 , 9.02225582488e-05 ,
 0.000219664063158 , 0.000555449791684 , 0.00118572984581  , 0.00202680735372  ,
 0.00274338913321  , 0.00293538631907  , 0.00249448911135  , 0.00172567831828  ,
 0.00106775990349  , 0.000742862292388 , 0.000679996413752 , 0.000680530822351 ,
 0.000604231779452 , 0.000439822381705 , 0.000256951328184 , 0.000119767535136 ,
 4.45449874368e-05 , 1.38790634228e-05 , 6.64332608165e-06 , 1.49759827198e-05 ,
 5.78584034821e-05 , 0.000234359145321 , 0.000883869672829 , 0.00284386804387  ,
 0.00745555066709  , 0.0156357781008   , 0.0260682699445   , 0.0345008739126   ,
 0.0362880870509   , 0.0304572006698   , 0.0205877211054   , 0.011409050068    ,
 0.00533529380537  , 0.00218051444878  , 0.00079732642195  , 0.000259206924068 ,
 7.25699864131e-05 , 1.6868619835e-05  , 3.16730446012e-06 , 4.72447972107e-07 ,
 5.54775879247e-08 , 5.10395319101e-09 , 3.66975843317e-10 , 2.05935232743e-11 ,
 9.01284956027e-13 , 3.07449744275e-14 , 8.1756817963e-16  , 1.68396538679e-17 ,
 1.14269796949e-21 , 2.81930759287e-16 , 1.39898325038e-14 , 5.29528251459e-13 ,
 1.56419979412e-11 , 3.60932328176e-10 , 6.51094759424e-09 , 9.19165587762e-08 ,
 1.01679537755e-06 , 8.82797715893e-06 , 6.02759597835e-05 , 0.000324460527295 ,
 0.00138124723397  , 0.00466903551585  , 0.0126016131329   , 0.0273794436352   ,
 0.0485261933916   , 0.0717525294791   , 0.0918136678493   , 0.10689945238     ,
 0.118709861343    , 0.128027261237    , 0.132380000903    , 0.129029680638    ,
 0.11891023057     , 0.10672176779     , 0.097358636004    , 0.0922118254155   ,
 0.0886815466195   , 0.0829292360075   , 0.0726731437011   , 0.0580099200521   ,
 0.0411265951022   , 0.025408935851    , 0.0136568654477   , 0.00667134928974  ,
 0.00367328721084  , 0.00378593425167  , 0.00674384526734  , 0.0120961402519   ,
 0.0179275419969   , 0.0211084718546   , 0.0196032709696   , 0.0143500686051   ,
 0.00828921867106  , 0.00379392647978  , 0.00142062827629  , 0.000563811552996 ,
 0.000499289094666 , 0.000771313063993 , 0.00108645181178  , 0.00121538055348  ,
 0.00106310976496  , 0.000725691422925 , 0.00038636660079  , 0.000160390373573 ,
 0.0001664939236   , 4.19890649298e-05 , 8.2516989241e-06  , 1.26347987278e-06 ,
 1.50812706011e-07 , 1.56892201252e-08 , 2.43644655781e-08 , 2.5265439199e-07  ,
 2.13171787849e-06 , 1.40407721893e-05 , 7.22194513605e-05 , 0.000290277847104 ,
 0.00091248759261  , 0.00224552407227  , 0.00433091994889  , 0.00655502589852  ,
 0.00779676625801  , 0.00729869583634  , 0.00538526419879  , 0.0031360987639   ,
 0.00144304915138  , 0.000525069739842 , 0.000151129265794 , 3.44248732595e-05 ,
 6.3753412105e-06  , 2.10752465878e-06 , 6.47861197208e-06 , 2.59739315396e-05 ,
 8.28729148079e-05 , 0.000207713792848 , 0.000409442602493 , 0.000635682767543 ,
 0.000778446084132 , 0.000752838692496 , 0.00057554175735  , 0.000348013601956 ,
 0.000166456810738 , 6.29546916449e-05 , 1.8811547736e-05  , 4.43601278871e-06 ,
 8.24401783662e-07 , 1.20566181432e-07 , 1.38553674667e-08 , 1.24945691918e-09 ,
 8.83096614292e-11 , 4.90582690889e-12 , 6.49171535805e-13 , 8.35329922803e-12 ,
 1.32956411061e-10 , 1.77900994977e-09 , 2.003045172e-08   , 1.88920694467e-07 ,
 1.47783965944e-06 , 9.47394907233e-06 , 4.92351265091e-05 , 0.000205725546901 ,
 0.000687345566592 , 0.00183003190794  , 0.00387517130984  , 0.00652015610809  ,
 0.00871619382142  , 0.00926738323168  , 0.00785965206987  , 0.00534857533267  ,
 0.00295181950956  , 0.00134420376436  , 0.000518149397113 , 0.000175393657232 ,
 5.5477617982e-05  , 1.86725655893e-05 , 8.4055100064e-06  , 6.04880748931e-06 ,
 6.73695301829e-06 , 1.23819746228e-05 , 4.0460181502e-05  , 0.000156643528587 ,
 0.000530386880979 , 0.00144854446889  , 0.00314025741618  , 0.00538523297658  ,
 0.00729922149333  , 0.00782993838516  , 0.00670710857516  , 0.00476482568624  ,
 0.00318522849202  , 0.00253848836249  , 0.00256189135181  , 0.00263210875919  ,
 0.00233378696729  , 0.00168766128761  , 0.000979818105682 , 0.000454327284764 ,
 0.000167786824895 , 4.9379169979e-05  , 1.24980568932e-05 , 8.79620349521e-06 ,
 4.00964133247e-05 , 0.000203554676719 , 0.000850934468139 , 0.00284695431041  ,
 0.00756475225813  , 0.0159259521976   , 0.0265452170112   , 0.0350175166961   ,
 0.0365529924593   , 0.0302013551596   , 0.0197830117914   , 0.0103200089399   ,
 0.00433103900427  , 0.00149099812598  , 0.00043422693952  , 0.000110850025734 ,
 2.53228111361e-05 , 5.12149567985e-06 , 8.86302698494e-07 , 1.26601407382e-07 ,
 1.4546621689e-08  , 1.32419275405e-09 , 9.4726999309e-11  , 5.30291731632e-12 ,
 2.31815926287e-13 , 7.89969035636e-15 , 2.10068005719e-16 , 4.32682220193e-18 ,
 8.02151664612e-23 , 2.23357248364e-16 , 1.10762743353e-14 , 4.19173230857e-13 ,
 1.23794026596e-11 , 2.85564936223e-10 , 5.1494052774e-09  , 7.26598736443e-08 ,
 8.03281490616e-07 , 6.96891436651e-06 , 4.75387380229e-05 , 0.00025562033072  ,
 0.00108688167474  , 0.00366954252443  , 0.00989432727604  , 0.0214901766347   ,
 0.0381180883028   , 0.0564620181561   , 0.0722561233226   , 0.083360314721    ,
 0.0898735015899   , 0.0916546925786   , 0.0876401278553   , 0.077892989485    ,
 0.064922210464    , 0.0524774863677   , 0.0433353350703   , 0.0379410075432   ,
 0.034711618143    , 0.0315588694007   , 0.0271948420885   , 0.0214307336923   ,
 0.0149694402289   , 0.00902776329116  , 0.00464836703589  , 0.00213561321954  ,
 0.00120977316178  , 0.00160225398555  , 0.0033147174226   , 0.00618945848128  ,
 0.0092682108091   , 0.0109445621901   , 0.0101735011114   , 0.00745073778373  ,
 0.00431199862327  , 0.0020109917868   , 0.000895082942767 , 0.000764551650534 ,
 0.00136617995847  , 0.00243228243419  , 0.00347929327644  , 0.00389814405861  ,
 0.00341027783867  , 0.00232793189127  , 0.00123942008208  , 0.000514514146045 ,
 0.000419808452099 , 0.000105873920063 , 2.08063625873e-05 , 3.18581736718e-06 ,
 3.80228806094e-07 , 3.88498609847e-08 , 5.15911552056e-08 , 5.30589919684e-07 ,
 4.47654942038e-06 , 2.94852451336e-05 , 0.000151658923156 , 0.000609575751024 ,
 0.00191619965633  , 0.00471554078339  , 0.00909481661862  , 0.013765379915    ,
 0.0163730016192   , 0.0153270669906   , 0.0113089114806   , 0.0065857239327   ,
 0.00303036481963  , 0.00110263266796  , 0.000317370079391 , 7.23200647253e-05 ,
 1.36322281812e-05 , 6.04718245397e-06 , 2.20294900845e-05 , 8.88305470359e-05 ,
 0.000283460321934 , 0.000710470986206 , 0.00140047169327  , 0.00217431376055  ,
 0.00266263191645  , 0.0025750517231   , 0.00196862661956  , 0.00119038391974  ,
 0.000569376914782 , 0.000215347172429 , 6.43513131545e-05 , 1.51761869572e-05 ,
 2.82079299502e-06 , 4.12631727567e-07 , 4.74384492284e-08 , 4.2808099464e-09  ,
 3.0289717421e-10  , 1.67954169106e-11 , 8.0527698736e-13  , 1.68732461108e-12 ,
 3.04891391078e-11 , 4.66972780815e-10 , 5.91393807298e-09 , 6.11950120536e-08 ,
 5.11846090535e-07 , 3.43269948031e-06 , 1.83611565245e-05 , 7.80868625694e-05 ,
 0.000263599659135 , 0.00070571538024  , 0.00149769111451  , 0.00251867231928  ,
 0.00335562566624  , 0.00354203786122  , 0.00296455762925  , 0.00197200832524  ,
 0.00104793492784  , 0.000449292903746 , 0.00015813376807  , 4.70226712842e-05 ,
 1.24138103166e-05 , 3.23340337096e-06 , 1.08925554329e-06 , 8.49043778835e-07 ,
 2.49228719848e-06 , 1.38077484665e-05 , 7.35482349204e-05 , 0.000320224449951 ,
 0.00110912204801  , 0.00304221565856  , 0.00660190487882  , 0.0113302499905   ,
 0.0153831427055   , 0.0165805497511   , 0.0144088504954   , 0.0106871278587   ,
 0.00792938673941  , 0.00724678068805  , 0.00784827876458  , 0.00814595847973  ,
 0.00716713013912  , 0.00513331218192  , 0.00295618077031  , 0.00136203863152  ,
 0.000500493607851 , 0.000146323814321 , 3.44510234492e-05 , 1.06711786456e-05 ,
 3.07608081948e-05 , 0.000160284371448 , 0.000681458535957 , 0.00229373267499  ,
 0.00610686163677  , 0.0128628687753   , 0.0214347598897   , 0.0282509891285   ,
 0.0294320494181   , 0.0242187051673   , 0.0157313378986   , 0.00806692362343  ,
 0.00327142935242  , 0.00105456628422  , 0.00027330004164  , 5.81670555851e-05 ,
 1.05041566083e-05 , 1.66771230913e-06 , 2.36899139119e-07 , 2.96660147993e-08 ,
 3.16004059571e-09 , 2.76453760645e-10 , 1.93883988198e-11 , 1.07499794939e-12 ,
 4.67758558196e-14 , 1.58743532034e-15 , 4.22129674592e-17 , 8.69470829e-19    ,
 4.46522314871e-24 , 1.39912022339e-16 , 6.9337635471e-15  , 2.62352018473e-13 ,
 7.74621732985e-12 , 1.78634767462e-10 , 3.2199923437e-09  , 4.54137107221e-08 ,
 5.0176976748e-07  , 4.34999631726e-06 , 2.96482007921e-05 , 0.000159265587327 ,
 0.000676502746383 , 0.0022821128149   , 0.00615214821133  , 0.0133799714328   ,
 0.0238334895838   , 0.0356087949205   , 0.0461440947969   , 0.0537916259641   ,
 0.0577576525538   , 0.0571479173269   , 0.0514682965627   , 0.0419851195716   ,
 0.0315017022457   , 0.0226469871907   , 0.0166354869489   , 0.013225325468    ,
 0.0113663337843   , 0.00997759961109  , 0.00842158630949  , 0.00653984453405  ,
 0.0045072989431   , 0.00267294592001  , 0.00134095774196  , 0.000598521972331 ,
 0.000367457798007 , 0.000594513051955 , 0.00132156392902  , 0.00250554296229  ,
 0.00376526296235  , 0.00445068803857  , 0.00413877017251  , 0.00303452996971  ,
 0.00177562565912  , 0.000922161520002 , 0.00076154501297  , 0.00150146608171  ,
 0.00334862954114  , 0.00611576687738  , 0.00877049692496  , 0.00982876156995  ,
 0.00859886959619  , 0.00586979507822  , 0.00312515316089  , 0.00129732894751  ,
 0.000833267189549 , 0.000210146469    , 4.12980234313e-05 , 6.3234456817e-06  ,
 7.54642294349e-07 , 7.59677862267e-08 , 8.65280974003e-08 , 8.8143513173e-07  ,
 7.43621414373e-06 , 4.89793627968e-05 , 0.000251927951842 , 0.00101259568036  ,
 0.0031830916691   , 0.00783321222996  , 0.0151078385362   , 0.0228663364933   ,
 0.027197982674    , 0.025460530216    , 0.0187857782992   , 0.0109398636611   ,
 0.00503388518781  , 0.00183163681906  , 0.000527205896151 , 0.000120212096419 ,
 2.33055587674e-05 , 1.44305676101e-05 , 5.93791846395e-05 , 0.000240289961419 ,
 0.000766831002322 , 0.00192200768992  , 0.00378864804075  , 0.00588212330637  ,
 0.0072032171273   , 0.00696638339495  , 0.00532592799395  , 0.00322060333195  ,
 0.00154057033864  , 0.00058274006578  , 0.000174174774809 , 4.10910017275e-05 ,
 7.64220501563e-06 , 1.11905646332e-06 , 1.28871767742e-07 , 1.16621814186e-08 ,
 8.29044009497e-10 , 4.63166657243e-11 , 2.05023649301e-12 , 4.1289881931e-13  ,
 7.06130985126e-12 , 1.18682624821e-10 , 1.60849971392e-09 , 1.7430296881e-08  ,
 1.50214134594e-07 , 1.02640523341e-06 , 5.55282563046e-06 , 2.37745398823e-05 ,
 8.0564165969e-05  , 0.00021611559926  , 0.000458962814829 , 0.000771523095149 ,
 0.00102621270866  , 0.00107955297724  , 0.000897959369861 , 0.000590821624096 ,
 0.000308071185855 , 0.000127886566147 , 4.26621924389e-05 , 1.1640623146e-05  ,
 2.6853860015e-06  , 5.64844745494e-07 , 1.63323509245e-07 , 4.07434011319e-07 ,
 3.16335201904e-06 , 2.19110275357e-05 , 0.000121296475821 , 0.000531683320141 ,
 0.00184389849896  , 0.00505985659179  , 0.0109868290359   , 0.0188819115692   ,
 0.0257284791042   , 0.0280017664652   , 0.0249953921496   , 0.0198715626107   ,
 0.0168071236709   , 0.0173483762264   , 0.0195678338815   , 0.0202114950479   ,
 0.0175274817296   , 0.0123869444324   , 0.00705812090241  , 0.00322563231804  ,
 0.00117796931492  , 0.00034267574033  , 7.94678726011e-05 , 1.72301639784e-05 ,
 2.0932600012e-05  , 0.000102055503506 , 0.000434298078835 , 0.00146305524601  ,
 0.00389634425694  , 0.00820724994697  , 0.0136754908961   , 0.018020157038    ,
 0.0187642593403   , 0.0154246803491   , 0.00999784946471  , 0.00510427156738  ,
 0.00205120433065  , 0.000649020324936 , 0.000162049594978 , 3.21190296153e-05 ,
 5.1180668014e-06  , 6.70986455828e-07 , 7.48938482436e-08 , 7.37092410141e-09 ,
 6.48718966061e-10 , 5.01181057212e-11 , 3.27597917309e-12 , 1.75129853833e-13 ,
 7.53360489895e-15 , 3.74480521198e-16 , 2.40088467107e-16 , 3.40487432788e-16 ,
 3.86665906168e-16 , 4.11583952428e-16 , 3.66472746869e-15 , 1.29824537368e-13 ,
 3.82867553196e-12 , 8.82671817922e-11 , 1.5905116175e-09  , 2.24222719113e-08 ,
 2.47606977689e-07 , 2.14517950163e-06 , 1.46097338602e-05 , 7.84164714382e-05 ,
 0.000332833064995 , 0.00112236872883  , 0.00302787290358  , 0.00660589142122  ,
 0.0118588373295   , 0.017985725884    , 0.0238426059065   , 0.028486141677    ,
 0.0310100479749   , 0.0303857801793   , 0.0263009797948   , 0.0199869236717   ,
 0.0135639078905   , 0.00860603670263  , 0.00551631593372  , 0.00388758353539  ,
 0.00308090404746  , 0.00258422829017  , 0.00212416001803  , 0.00161992528299  ,
 0.00110063180305  , 0.000643843129025 , 0.000317845732424 , 0.000141078447113 ,
 9.67982952515e-05 , 0.000181289925529 , 0.00041749211141  , 0.000796386362968 ,
 0.00119835700639  , 0.0014170717012   , 0.00131868790925  , 0.000973114356067 ,
 0.000607880330721 , 0.000500336794181 , 0.00103214057144  , 0.00284353929721  ,
 0.00661578585962  , 0.0121335341812   , 0.0174075631553   , 0.0195087743513   ,
 0.0170676714456   , 0.0116508074204   , 0.00620303751912  , 0.00257503544781  ,
 0.00130386919413  , 0.000328830311987 , 6.46217975619e-05 , 9.89472005265e-06 ,
 1.18075858241e-06 , 1.17398675609e-07 , 1.14947871016e-07 , 1.1580310449e-06  ,
 9.76910773075e-06 , 6.43451772144e-05 , 0.00033096283318  , 0.0013302673752   ,
 0.00418169174705  , 0.0102906489477   , 0.0198474722974   , 0.0300399675973   ,
 0.0357305385792   , 0.0334480122308   , 0.0246792559695   , 0.0143719196146   ,
 0.00661311659534  , 0.00240625934284  , 0.000692616328922 , 0.000158091491835 ,
 3.20307042702e-05 , 2.83452785294e-05 , 0.000126783149688 , 0.000514179423787 ,
 0.00164097147982  , 0.00411300935856  , 0.00810762476738  , 0.0125878587398   ,
 0.015415543289    , 0.014909571713    , 0.0113998050582   , 0.00689471404826  ,
 0.00329908260458  , 0.00124857312063  , 0.000373518317927 , 8.82529962319e-05 ,
 1.64552659764e-05 , 2.41981277343e-06 , 2.80636705321e-07 , 2.56914814335e-08 ,
 1.86096608247e-09 , 1.07125464448e-10 , 4.9370967897e-12  , 2.51850044345e-13 ,
 1.51197893039e-12 , 2.65344749185e-11 , 3.70725862646e-10 , 4.09514648749e-09 ,
 3.57114593085e-08 , 2.45765312047e-07 , 1.33525568716e-06 , 5.73113791811e-06 ,
 1.9447967214e-05  , 5.2205692274e-05  , 0.000110889599105 , 0.000186358152724 ,
 0.000247679414488 , 0.000260138241948 , 0.000215751433609 , 0.000141222308396 ,
 7.29652837167e-05 , 2.98036208056e-05 , 9.66474901269e-06 , 2.51095426524e-06 ,
 5.32595354316e-07 , 9.88538012418e-08 , 5.73770382728e-08 , 4.63722469191e-07 ,
 4.09323517769e-06 , 2.87400272201e-05 , 0.000159433488728 , 0.000699155869248 ,
 0.00242536433375  , 0.00665899488307  , 0.0144776601742   , 0.024960123996    ,
 0.0342822332526   , 0.0380730326635   , 0.0357318787977   , 0.03160603355     ,
 0.0309519908686   , 0.0349652830008   , 0.0398607254285   , 0.0403717644566   ,
 0.0342384371119   , 0.0237574523162   , 0.0133485733214   , 0.00603631713203  ,
 0.00218694795322  , 0.000632354437754 , 0.000145567410611 , 2.78863115992e-05 ,
 1.32844317602e-05 , 5.16359109748e-05 , 0.00021850969215  , 0.000736112289249 ,
 0.00196045078893  , 0.00412949306385  , 0.00688068527808  , 0.00906613693313  ,
 0.00943934941867  , 0.00775740517057  , 0.00502548183746  , 0.00256287908558  ,
 0.00102756772419  , 0.000323589088654 , 8.00023293069e-05 , 1.55398048693e-05 ,
 2.37823852213e-06 , 2.88743234259e-07 , 2.82035805214e-08 , 2.27206704487e-09 ,
 1.56415365609e-10 , 9.52106441385e-12 , 5.18021072884e-13 , 2.54333089936e-14 ,
 3.50299390695e-15 , 6.07958992678e-15 , 1.13192703994e-14 , 1.65015255886e-14 ,
 1.87470502041e-14 , 1.66260637763e-14 , 1.27940611614e-14 , 5.67481765598e-14 ,
 1.49547810705e-12 , 3.44102432554e-11 , 6.1983970819e-10  , 8.7348030725e-09  ,
 9.64116085652e-08 , 8.34802369409e-07 , 5.68178908999e-06 , 3.04771296731e-05 ,
 0.00012930130106  , 0.000436116836971 , 0.00117866627581  , 0.00258497945471  ,
 0.00469464531552  , 0.0072727270967   , 0.00994564699969  , 0.0122946515126   ,
 0.0137136608982   , 0.0134876151155   , 0.0114153751673   , 0.00823641179483  ,
 0.00513432671218  , 0.00288744462365  , 0.00159327400577  , 0.00096746897456  ,
 0.000688760512712 , 0.00054410145814  , 0.000432411951369 , 0.000322486954336 ,
 0.000215541679063 , 0.000124448448032 , 6.07615475596e-05 , 2.7231015418e-05  ,
 2.11742490192e-05 , 4.41341691661e-05 , 0.000103595460119 , 0.000198154293376 ,
 0.000298333187004 , 0.000352951539188 , 0.000329700630337 , 0.000253052059888 ,
 0.0002179336062   , 0.000448516604687 , 0.0014945225976   , 0.00441511271082  ,
 0.0103444151537   , 0.0189847746259   , 0.0272385896103   , 0.0305266691146   ,
 0.0267069310469   , 0.018230801507    , 0.00970630982129  , 0.00402933108287  ,
 0.00161056926416  , 0.000406178854236 , 7.98224247739e-05 , 1.22222559711e-05 ,
 1.45846012388e-06 , 1.43516022695e-07 , 1.20916875339e-07 , 1.20241521969e-06 ,
 1.01427700366e-05 , 6.68063110241e-05 , 0.000343621804271 , 0.00138114866618  ,
 0.00434163694193  , 0.0106842551604   , 0.020606616686    , 0.0311889639276   ,
 0.0370971931062   , 0.034727362589    , 0.0256232108674   , 0.0149216300288   ,
 0.00686606127004  , 0.00249829802627  , 0.000719134080546 , 0.000164420217287 ,
 3.56503156954e-05 , 4.53295988652e-05 , 0.000214246850396 , 0.00087007529897  ,
 0.00277691514621  , 0.00696038327519  , 0.0137210479066   , 0.0213049580998   ,
 0.0260945063702   , 0.0252442569784   , 0.0193099594513   , 0.0116875476009   ,
 0.00559960211761  , 0.0021238839408   , 0.000637743852913 , 0.00015163007215  ,
 2.85687308137e-05 , 4.27373087763e-06 , 5.09524001503e-07 , 4.8713903476e-08  ,
 3.76810402164e-09 , 2.38365191677e-10 , 1.24587240003e-11 , 5.5325614816e-13  ,
 2.91885992906e-13 , 4.89210331583e-12 , 6.91716283647e-11 , 7.69739293229e-10 ,
 6.74237010362e-09 , 4.6524191811e-08  , 2.53164771833e-07 , 1.08761004484e-06 ,
 3.69252304244e-06 , 9.91445029796e-06 , 2.10599762769e-05 , 3.53875216576e-05 ,
 4.7013556897e-05  , 4.93412636466e-05 , 4.08662896572e-05 , 2.66840116004e-05 ,
 1.37265834091e-05 , 5.56293180758e-06 , 1.77862491796e-06 , 4.5046530653e-07  ,
 9.13591749133e-08 , 1.79996203992e-08 , 4.43090000345e-08 , 4.77272389467e-07 ,
 4.24986218307e-06 , 2.986221927e-05   , 0.00016569008525  , 0.00072675413469  ,
 0.00252237713785  , 0.00693386803239  , 0.0151205013177   , 0.0262592167381   ,
 0.0367097262068   , 0.0425078106134   , 0.0436342318922   , 0.0446996129609   ,
 0.0502385068583   , 0.0596026900078   , 0.0668125335996   , 0.0653740816671   ,
 0.053704597421    , 0.0363430476589   , 0.0200393168445   , 0.00893603414743  ,
 0.00320401957377  , 0.000919269271135 , 0.000210227812785 , 3.86920380943e-05 ,
 9.22757633873e-06 , 2.09032321353e-05 , 8.66013701955e-05 , 0.000291614591502 ,
 0.000776638815255 , 0.00163590942681  , 0.00272578410078  , 0.00359149951454  ,
 0.00373923325189  , 0.00307276881226  , 0.00199037471687  , 0.00101477107749  ,
 0.000406636072698 , 0.00012790227262  , 3.15441152999e-05 , 6.09578905454e-06 ,
 9.23008318079e-07 , 1.09637847722e-07 , 1.0251751407e-08  , 7.60480170392e-10 ,
 4.54458534181e-11 , 2.24804177503e-12 , 1.03034914025e-13 , 3.42874218658e-14 ,
 9.47897244697e-14 , 2.27383023143e-13 , 4.25471125204e-13 , 6.20306945842e-13 ,
 7.04718921078e-13 , 6.23981843266e-13 , 4.31080329042e-13 , 2.47311967831e-13 ,
 5.55884618569e-13 , 1.05997540586e-11 , 1.90322951768e-10 , 2.68102459903e-09 ,
 2.95801582851e-08 , 2.56006583222e-07 , 1.74155735571e-06 , 9.33788629124e-06 ,
 3.96143840723e-05 , 0.000133734793927 , 0.000362563888746 , 0.000801268266998 ,
 0.00147833399405  , 0.0023534167681   , 0.00334207839857  , 0.00429771763221  ,
 0.00493513301598  , 0.00490677416155  , 0.0041103957764   , 0.00286629919188  ,
 0.00167643179373  , 0.00085073665827  , 0.000404660182734 , 0.000206368330316 ,
 0.000127431539508 , 9.28416234239e-05 , 7.069519397e-05   , 5.13208308837e-05 ,
 3.36507620769e-05 , 1.91609099271e-05 , 9.27284158477e-06 , 4.23868290084e-06 ,
 3.75142424166e-06 , 8.47355994651e-06 , 2.01199471702e-05 , 3.85386463611e-05 ,
 5.80470513584e-05 , 6.88316667098e-05 , 6.58341008069e-05 , 6.25451711835e-05 ,
 0.00012479595071  , 0.000488165600662 , 0.0018223311856   , 0.00544688125281  ,
 0.0127761330971   , 0.0234501576296   , 0.0336456933424   , 0.037707238776    ,
 0.0329890144501   , 0.0225191048583   , 0.0119894569177   , 0.00497712237789  ,
 0.00157213667654  , 0.000396487781302 , 7.79193700607e-05 , 1.19319781482e-05 ,
 1.42443804065e-06 , 1.39250704143e-07 , 1.0080633019e-07  , 9.85725831394e-07 ,
 8.31380337185e-06 , 5.47595515613e-05 , 0.00028165864662  , 0.00113209481713  ,
 0.00355873686883  , 0.00875763065033  , 0.0168907551513   , 0.0255648542967   ,
 0.0304076896808   , 0.0284651957904   , 0.0210027384676   , 0.0122309063755   ,
 0.0056279477806   , 0.00204779815409  , 0.000589491867984 , 0.000135148798522 ,
 3.24278427722e-05 , 5.84460115439e-05 , 0.000286239729611 , 0.00116345277566  ,
 0.00371356123463  , 0.00930915358893  , 0.0183547856841   , 0.0285095839829   ,
 0.0349395895938   , 0.0338362244285   , 0.0259288613317   , 0.0157426478883   ,
 0.00758279495471  , 0.00290224164695  , 0.000884753489825 , 0.000215649025931 ,
 4.22758417183e-05 , 6.72289072472e-06 , 8.76455257755e-07 , 9.46581613303e-08 ,
 8.52640726632e-09 , 6.40412273017e-10 , 3.98064988319e-11 , 2.02462849898e-12 ,
 1.22800940768e-13 , 7.23515451277e-13 , 1.02395082095e-11 , 1.14257077095e-10 ,
 1.00245597465e-09 , 6.92397317316e-09 , 3.76989076182e-08 , 1.62009914e-07    ,
 5.50134307945e-07 , 1.47722843774e-06 , 3.13788019502e-06 , 5.27221805642e-06 ,
 7.00300831153e-06 , 7.34711188482e-06 , 6.08122074341e-06 , 3.96618853571e-06 ,
 2.03601172231e-06 , 8.22025111875e-07 , 2.6102373136e-07  , 6.52815144301e-08 ,
 1.30384145992e-08 , 4.43895157442e-09 , 3.48294618115e-08 , 3.91232768408e-07 ,
 3.48621269847e-06 , 2.44991928961e-05 , 0.000135960656194 , 0.000596643611422 ,
 0.00207326648198  , 0.00571587364858  , 0.012552242308    , 0.0221663110131   ,
 0.0322039493519   , 0.0404580511774   , 0.047849170044    , 0.0578811808472   ,
 0.0720279733547   , 0.0862829877088   , 0.093034693854    , 0.0866895009443   ,
 0.0681995872308   , 0.0446049540616   , 0.0239724023912   , 0.0104895273372   ,
 0.00370910118619  , 0.00105334180863  , 0.000239020791614 , 4.33063291063e-05 ,
 7.33705113969e-06 , 7.01360917739e-06 , 2.70155410677e-05 , 9.08225414238e-05 ,
 0.000241873921794 , 0.000509481803211 , 0.000848907099902 , 0.0011185180408   ,
 0.00116451891972  , 0.000956945624094 , 0.000619838392482 , 0.00031599708243  ,
 0.000126607989075 , 3.98114855025e-05 , 9.81265001825e-06 , 1.89386012892e-06 ,
 2.86002627054e-07 , 3.37839945562e-08 , 3.12269503227e-09 , 2.26222230722e-10 ,
 1.29036920269e-11 , 6.28337242165e-13 , 2.48543260789e-13 , 9.00018282161e-13 ,
 2.77293044004e-12 , 6.66004518839e-12 , 1.24622031165e-11 , 1.81690180859e-11 ,
 2.06414758725e-11 , 1.82764159661e-11 , 1.26145638311e-11 , 6.79241180514e-12 ,
 2.96035216611e-12 , 3.48649171314e-12 , 4.62082926043e-11 , 6.4745473581e-10  ,
 7.14059262947e-09 , 6.17770336328e-08 , 4.2011525597e-07  , 2.25223330924e-06 ,
 9.55847008866e-06 , 3.23244231813e-05 , 8.8043800361e-05  , 0.000196628149504 ,
 0.000370223014558 , 0.00060912921868  , 0.000902526666262 , 0.00120965508373  ,
 0.00143096538564  , 0.00144219874453  , 0.00120462023002  , 0.000822949738016 ,
 0.000460941814092 , 0.000216511243147 , 9.05456364973e-05 , 3.84038196807e-05 ,
 1.97504800471e-05 , 1.28587642241e-05 , 9.26287246566e-06 , 6.51131673934e-06 ,
 4.1758503421e-06  , 2.34127283842e-06 , 1.12379366373e-06 , 5.27767961022e-07 ,
 5.31089771007e-07 , 1.27621625131e-06 , 3.05342254317e-06 , 5.85402525506e-06 ,
 8.83020976286e-06 , 1.06217612098e-05 , 1.16581186553e-05 , 2.25284608393e-05 ,
 9.95688952521e-05 , 0.000466369767796 , 0.00177518627269  , 0.00531585603088  ,
 0.0124710126747   , 0.022890509148    , 0.0328427781087   , 0.0368074054736   ,
 0.0322017758845   , 0.0219817168209   , 0.0117033450921   , 0.00485835097883  ,
 0.00121362664803  , 0.000306094403454 , 6.01761966848e-05 , 9.23145961411e-06 ,
 1.11216186203e-06 , 1.12776406572e-07 , 6.87077427119e-08 , 6.37820932634e-07 ,
 5.37310443455e-06 , 3.53892921766e-05 , 0.000182026535006 , 0.000731634885678 ,
 0.00229989220066  , 0.0056597627672   , 0.0109159281697   , 0.0165217073287   ,
 0.019651469303    , 0.0183961006953   , 0.0135733649815   , 0.00790442430534  ,
 0.00363715391396  , 0.00132342585368  , 0.000381005505653 , 8.77411702182e-05 ,
 2.43468090546e-05 , 6.02844115975e-05 , 0.00030198896678  , 0.00122828869986  ,
 0.0039216273923   , 0.0098354080369   , 0.019408408873    , 0.0301894656269   ,
 0.0370909859415   , 0.0360759187479   , 0.0278528452072   , 0.0171281051274   ,
 0.00842877937786  , 0.00334116079633  , 0.00107654564037  , 0.000285130026837 ,
 6.27940533312e-05 , 1.15919446829e-05 , 1.79524574117e-06 , 2.31540816729e-07 ,
 2.45517575813e-08 , 2.11029856441e-09 , 1.45228854374e-10 , 7.92791565161e-12 ,
 3.4565777961e-13  , 9.53020436428e-14 , 1.19266042666e-12 , 1.33184267511e-11 ,
 1.16922157642e-10 , 8.07871169162e-10 , 4.3995307897e-09  , 1.89091025198e-08 ,
 6.42133417206e-08 , 1.72430741256e-07 , 3.66268951768e-07 , 6.1537348624e-07  ,
 8.17317131142e-07 , 8.57331736079e-07 , 7.09398165788e-07 , 4.62417435095e-07 ,
 2.37143666065e-07 , 9.55730908713e-08 , 3.0248087548e-08  , 7.52165783374e-09 ,
 1.554267395e-09   , 1.78033410972e-09 , 2.23851012469e-08 , 2.5301895292e-07  ,
 2.25486512197e-06 , 1.58487495754e-05 , 8.79946263922e-05 , 0.000386595785098 ,
 0.00134717803253  , 0.0037396373214   , 0.00834723921382  , 0.0152999946393   ,
 0.0240399633781   , 0.0346885630124   , 0.0490688585208   , 0.0685690162986   ,
 0.0902133919895   , 0.106207647315    , 0.108691285943    , 0.0953283804081   ,
 0.0709401288462   , 0.0443274707001   , 0.0230007702425   , 0.00980518600668  ,
 0.00340171427504  , 0.00095276960767  , 0.000214016463915 , 3.83824638354e-05 ,
 5.73914388651e-06 , 2.15792930195e-06 , 6.64413917068e-06 , 2.22073788781e-05 ,
 5.91344067452e-05 , 0.000124560036344 , 0.000207543920617 , 0.00027345915577  ,
 0.000284705099231 , 0.000233956083961 , 0.000151538226898 , 7.72537937726e-05 ,
 3.0951611631e-05  , 9.73195318911e-06 , 2.39835750183e-06 , 4.62744274457e-07 ,
 6.98361789121e-08 , 8.2380957186e-09  , 7.59270933234e-10 , 5.46928060164e-11 ,
 3.23458951488e-12 , 1.15648452252e-12 , 5.19136419731e-12 , 2.05290428131e-11 ,
 6.32940563459e-11 , 1.52021049303e-10 , 2.84460120639e-10 , 4.1472290499e-10  ,
 4.71158804328e-10 , 4.1717430521e-10  , 2.87935632041e-10 , 1.5495741229e-10  ,
 6.50640066915e-11 , 2.17874156112e-11 , 1.4169185704e-11  , 1.23901143723e-10 ,
 1.35439691817e-09 , 1.17132322884e-08 , 7.96430713492e-08 , 4.27025938197e-07 ,
 1.81396259563e-06 , 6.1510602525e-06  , 1.68635948653e-05 , 3.81826314661e-05 ,
 7.37244587918e-05 , 0.000126012823907 , 0.000195338157089 , 0.000272683585393 ,
 0.000331708178339 , 0.000338955423987 , 0.000283468571376 , 0.000191547644902 ,
 0.000104518031249 , 4.66938657185e-05 , 1.77954026984e-05 , 6.41764605016e-06 ,
 2.66789244281e-06 , 1.47526311555e-06 , 9.78533528661e-07 , 6.59220763873e-07 ,
 4.11612680279e-07 , 2.26705462383e-07 , 1.07896492835e-07 , 5.23510444507e-08 ,
 5.96256749713e-08 , 1.50393794212e-07 , 3.61781448326e-07 , 6.94535205784e-07 ,
 1.05693647658e-06 , 1.38788544809e-06 , 2.66499179744e-06 , 1.27518449012e-05 ,
 7.41826865298e-05 , 0.000358790494839 , 0.00136990755444  , 0.00410342831121  ,
 0.00962692019986  , 0.0176702322334   , 0.0253528509525   , 0.028413330045    ,
 0.0248580333755   , 0.0169687014588   , 0.00903435764566  , 0.00375039870724  ,
 0.000741338965317 , 0.000187229922762 , 3.70569571529e-05 , 5.87790720772e-06 ,
 8.26512280777e-07 , 1.3977937846e-07  , 6.32498940298e-08 , 3.32880433056e-07 ,
 2.73581857063e-06 , 1.80064574203e-05 , 9.26152313701e-05 , 0.000372256140637 ,
 0.00117018610944  , 0.00287968965148  , 0.00555402879573  , 0.00840625156484  ,
 0.00999867575994  , 0.00935994368986  , 0.00690613375174  , 0.0040217743816   ,
 0.00185058554814  , 0.000673361820957 , 0.000193886348069 , 4.4975425805e-05  ,
 1.52146145435e-05 , 4.94570395234e-05 , 0.00025136158024  , 0.00102338127162  ,
 0.00327122750746  , 0.00822068767915  , 0.0162784864173   , 0.0254735661519   ,
 0.0316227945832   , 0.0313054750507   , 0.0248952322531   , 0.0160627266232   ,
 0.00851599874513  , 0.00376144924521  , 0.00139954756994  , 0.000440259463443 ,
 0.000116384871123 , 2.55119998982e-05 , 4.56448397874e-06 , 6.57159424945e-07 ,
 7.5309267071e-08  , 6.81738938128e-09 , 4.85054351419e-10 , 2.70368303617e-11 ,
 1.17861217318e-12 , 4.77249271485e-14 , 1.09874941779e-13 , 1.21589664143e-12 ,
 1.06765007185e-11 , 7.37787026584e-11 , 4.01817081145e-10 , 1.72707668746e-09 ,
 5.86510061201e-09 , 1.57495408506e-08 , 3.3454199161e-08  , 5.62056563231e-08 ,
 7.46470848014e-08 , 7.8295375122e-08  , 6.47760184801e-08 , 4.22129153239e-08 ,
 2.16380802512e-08 , 8.71307601153e-09 , 2.75335201966e-09 , 6.84435390501e-10 ,
 1.77904522757e-10 , 8.23621646769e-10 , 1.14430843104e-08 , 1.29039485341e-07 ,
 1.14890431525e-06 , 8.07588948451e-06 , 4.48826447816e-05 , 0.000197720404508 ,
 0.000693622178755 , 0.00195651140099  , 0.00453048027187  , 0.00897137797513  ,
 0.016175515431    , 0.0280725566382   , 0.0469544857977   , 0.0721111050808   ,
 0.0968064232836   , 0.110742142822    , 0.107242169808    , 0.0880300088012   ,
 0.0613199924008   , 0.0361377312324   , 0.017880972985    , 0.00735101604713  ,
 0.0024832000534   , 0.000682266331227 , 0.000151151564577 , 2.68186611195e-05 ,
 3.84072598089e-06 , 7.1970420498e-07  , 1.3004938979e-06  , 4.25837550897e-06 ,
 1.13344208765e-05 , 2.38744815726e-05 , 3.97800310718e-05 , 5.24140208113e-05 ,
 5.45695111749e-05 , 4.48423915733e-05 , 2.90452959029e-05 , 1.48071580817e-05 ,
 5.93241603747e-06 , 1.86526647413e-06 , 4.59662577157e-07 , 8.86815779025e-08 ,
 1.33814655002e-08 , 1.57799280168e-09 , 1.45364659495e-10 , 1.07820942219e-11 ,
 3.37010710239e-12 , 1.81854734106e-11 , 9.22774614397e-11 , 3.65233357192e-10 ,
 1.12607512965e-09 , 2.70463200476e-09 , 5.06087775313e-09 , 7.37840481422e-09 ,
 8.38246537216e-09 , 7.42201808028e-09 , 5.12271082716e-09 , 2.75686075289e-09 ,
 1.15719357274e-09 , 3.79075063113e-10 , 9.82024963716e-11 , 3.76309164851e-11 ,
 2.0452087979e-10  , 1.74297733068e-09 , 1.1849122346e-08  , 6.35619306899e-08 ,
 2.70419810563e-07 , 9.20557899095e-07 , 2.5458820497e-06  , 5.86593634747e-06 ,
 1.16733328993e-05 , 2.0818377128e-05  , 3.37998085578e-05 , 4.90574990367e-05 ,
 6.1308331214e-05  , 6.37621187039e-05 , 5.41093774616e-05 , 3.73374749489e-05 ,
 2.12595953917e-05 , 1.03653907275e-05 , 4.58184096935e-06 , 1.93661062537e-06 ,
 7.99972189618e-07 , 3.2706160734e-07  , 1.39640664834e-07 , 6.66335918181e-08 ,
 3.4728498952e-08  , 1.7758351019e-08  , 8.24252280214e-09 , 4.13225564414e-09 ,
 5.28451173183e-09 , 1.384798451e-08   , 3.3460242808e-08  , 6.46121617319e-08 ,
 1.03981523533e-07 , 2.07168393431e-07 , 1.03186128155e-06 , 7.35062782292e-06 ,
 4.50466280667e-05 , 0.000218974871017 , 0.000836470923436 , 0.00250568162499  ,
 0.00587852350612  , 0.0107900467014   , 0.0154813168065   , 0.0173501519012   ,
 0.0151791740595   , 0.0103617011262   , 0.00551676971567  , 0.00229028549248  ,
 0.000360388822557 , 9.33565300397e-05 , 2.07695145715e-05 , 5.06187349183e-06 ,
 1.75980279113e-06 , 7.25873594762e-07 , 2.79936852766e-07 , 2.0993261682e-07  ,
 1.11253933272e-06 , 7.20560884032e-06 , 3.70445524611e-05 , 0.000148894298035 ,
 0.000468048620542 , 0.00115181230005  , 0.00222148892901  , 0.00336231508197  ,
 0.0039992496118   , 0.00374377088196  , 0.00276230106766  , 0.001608620987    ,
 0.000740193453584 , 0.000269331307039 , 7.75703449209e-05 , 1.82077925791e-05 ,
 7.94555433039e-06 , 3.21679374284e-05 , 0.000165204335045 , 0.000674660873941 ,
 0.0021671392745   , 0.00549194815274  , 0.0110318716888   , 0.0176859510794   ,
 0.0228518606595   , 0.024115376046    , 0.0211187150737   , 0.0155833916623   ,
 0.0097759985436   , 0.00520447507312  , 0.00232337722629  , 0.000855153982021 ,
 0.000255279962159 , 6.10036542372e-05 , 1.15617156401e-05 , 1.72708947784e-06 ,
 2.02524612993e-07 , 1.85942580054e-08 , 1.33439414746e-09 , 7.47674426283e-11 ,
 3.26850405469e-12 , 1.11965410849e-13 , 1.07272027061e-14 , 8.68655546756e-14 ,
 7.62286244945e-13 , 5.26794144429e-12 , 2.86913106949e-11 , 1.23321935044e-10 ,
 4.18800727769e-10 , 1.12460643858e-09 , 2.38881014425e-09 , 4.01334408287e-09 ,
 5.33003560453e-09 , 5.59032056853e-09 , 4.62471494725e-09 , 3.01343950963e-09 ,
 1.54432865032e-09 , 6.21643198417e-10 , 1.96737906072e-10 , 5.34413924245e-11 ,
 5.74868174656e-11 , 4.99576293067e-10 , 5.40224851875e-09 , 5.46815311505e-08 ,
 4.68863811112e-07 , 3.25743357293e-06 , 1.80754918008e-05 , 8.00391474741e-05 ,
 0.000285115356017 , 0.000833913980276 , 0.00208551711039  , 0.0047403630783   ,
 0.0103117340845   , 0.0213913146444   , 0.0401681406697   , 0.0647796597964   ,
 0.0871484869956   , 0.0969276263879   , 0.0893601228994   , 0.0688305435717   ,
 0.0446737614312   , 0.0245587716765   , 0.0114269994686   , 0.00446979362226  ,
 0.00145411846788  , 0.00038875315704  , 8.44673748112e-05 , 1.47786554908e-05 ,
 2.07451407881e-06 , 2.74027015803e-07 , 2.09754118096e-07 , 6.40143588237e-07 ,
 1.70122766426e-06 , 3.58330126273e-06 , 5.97054810136e-06 , 7.86677143578e-06 ,
 8.19028608846e-06 , 6.73035044836e-06 , 4.35937787693e-06 , 2.22238862065e-06 ,
 8.90387423868e-07 , 2.79953866782e-07 , 6.89891658046e-08 , 1.3309664003e-08  ,
 2.00826377374e-09 , 2.36833029449e-10 , 2.22344400121e-11 , 6.176880967e-12   ,
 3.86970564139e-11 , 2.51881287731e-10 , 1.27988323418e-09 , 5.06581372446e-09 ,
 1.56187464729e-08 , 3.75134487003e-08 , 7.01947539143e-08 , 1.0233902805e-07  ,
 1.16265423315e-07 , 1.02943947394e-07 , 7.10523833572e-08 , 3.82378639876e-08 ,
 1.60503186066e-08 , 5.25680749911e-09 , 1.34422005557e-09 , 2.70571804359e-10 ,
 6.54035729382e-11 , 2.08289384048e-10 , 1.38230014156e-09 , 7.41882954956e-09 ,
 3.16345701964e-08 , 1.08264849956e-07 , 3.02853126367e-07 , 7.13372708046e-07 ,
 1.47309600975e-06 , 2.76681090222e-06 , 4.78472763759e-06 , 7.5190276104e-06  ,
 1.06155101772e-05 , 1.36526303724e-05 , 1.64907127007e-05 , 1.88553465857e-05 ,
 1.96789173433e-05 , 1.77500815379e-05 , 1.32602769789e-05 , 8.00742312431e-06 ,
 3.86197359409e-06 , 1.47978144212e-06 , 4.50101771904e-07 , 1.09402662e-07    ,
 2.18919153908e-08 , 3.98994885631e-09 , 8.32707190731e-10 , 2.89308529858e-10 ,
 3.7071539189e-10  , 9.95828203247e-10 , 2.42145447897e-09 , 4.8483699399e-09  ,
 1.05225463853e-08 , 5.31036483397e-08 , 4.54661535827e-07 , 3.51787660495e-06 ,
 2.17359584952e-05 , 0.000105741380086 , 0.000403954884658 , 0.00121007101352  ,
 0.00283892238198  , 0.00521085098927  , 0.00747641552825  , 0.00837895288288  ,
 0.00733059084312  , 0.00500429041883  , 0.00266498164778  , 0.00110756407634  ,
 0.000154875910469 , 5.70729211e-05    , 2.89019958019e-05 , 1.81599611095e-05 ,
 1.06034387091e-05 , 5.08387221539e-06 , 1.94452494793e-06 , 6.2642715334e-07  ,
 4.82721402282e-07 , 2.28740794195e-06 , 1.16349094616e-05 , 4.67501769043e-05 ,
 0.000146957692166 , 0.000361645407925 , 0.00069750189679  , 0.00105569787729  ,
 0.00125568223768  , 0.00117546716378  , 0.000867305800518 , 0.000505073952335 ,
 0.000232405583293 , 8.45652435783e-05 , 2.43658971394e-05 , 5.83045848055e-06 ,
 3.46639760367e-06 , 1.66292662898e-05 , 8.64775608389e-05 , 0.000357432150481 ,
 0.00117133342368  , 0.0030683888432   , 0.00650260414122  , 0.0113255412802   ,
 0.0164990003036   , 0.0203952603111   , 0.0215011376993   , 0.0191984899519   ,
 0.0142982837403   , 0.00872749876281  , 0.00430005092178  , 0.00169083988665  ,
 0.000526474904991 , 0.000129133103738 , 2.48649362099e-05 , 3.74997999521e-06 ,
 4.42266165953e-07 , 4.07455680493e-08 , 2.93012459986e-09 , 1.64387005467e-10 ,
 7.19260307701e-12 , 2.45491693666e-13 , 6.97655267302e-15 , 4.97808819837e-15 ,
 4.25190870757e-14 , 2.93841332252e-13 , 1.60039372083e-12 , 6.87890414285e-12 ,
 2.3360787824e-11  , 6.27307847692e-11 , 1.33248050021e-10 , 2.23863533993e-10 ,
 2.97305339192e-10 , 3.11818152689e-10 , 2.57950015612e-10 , 1.68070373928e-10 ,
 8.61498939736e-11 , 3.50674742945e-11 , 1.58203051584e-11 , 4.88815916265e-11 ,
 3.48613543982e-10 , 2.12057107965e-09 , 1.08511573814e-08 , 5.08647009818e-08 ,
 2.4518635754e-07  , 1.25040299192e-06 , 6.13731378811e-06 , 2.63628013264e-05 ,
 9.58955070484e-05 , 0.000301490108676 , 0.000865054523603 , 0.0023774649044   ,
 0.00621419963831  , 0.0146116727453   , 0.0292381989204   , 0.048202129072    ,
 0.064622363801    , 0.0703282861755   , 0.0624178821545   , 0.045569571432    ,
 0.0276696455047   , 0.0141264488365   , 0.00610896986261  , 0.00223947779662  ,
 0.000691447431782 , 0.000177754131597 , 3.75535184394e-05 , 6.44206515345e-06 ,
 8.8939132031e-07  , 1.02975280606e-07 , 3.07908671085e-08 , 7.55827910708e-08 ,
 1.99762442062e-07 , 4.20712815333e-07 , 7.00996140367e-07 , 9.23629790257e-07 ,
 9.61613296609e-07 , 7.90203669973e-07 , 5.11830108884e-07 , 2.6092831835e-07  ,
 1.04539402046e-07 , 3.28690394219e-08 , 8.09991548999e-09 , 1.56266152347e-09 ,
 2.35802639275e-10 , 2.8137384287e-11  , 7.19624394199e-12 , 5.00421391619e-11 ,
 4.1761491289e-10  , 2.72435841888e-09 , 1.38434775956e-08 , 5.4792877982e-08  ,
 1.68935558463e-07 , 4.0575313903e-07  , 7.59240825594e-07 , 1.10691987476e-06 ,
 1.25755061789e-06 , 1.11346280913e-06 , 7.68517125423e-07 , 4.13588566629e-07 ,
 1.73603529405e-07 , 5.68586166519e-08 , 1.45377358547e-08 , 2.90370375428e-09 ,
 4.55457722988e-10 , 7.39177955175e-11 , 1.31476677617e-10 , 6.78757329683e-10 ,
 2.90253085479e-09 , 1.00171702533e-08 , 2.86186180309e-08 , 7.12433497521e-08 ,
 1.69839117437e-07 , 4.39706916077e-07 , 1.30415580169e-06 , 4.04416434439e-06 ,
 1.1497999583e-05  , 2.75832940019e-05 , 5.37221700276e-05 , 8.36034295185e-05 ,
 0.000103319711995 , 0.000101174526954 , 7.84411615484e-05 , 4.81277879425e-05 ,
 2.33539978915e-05 , 8.9547050979e-06  , 2.70994981379e-06 , 6.46429254017e-07 ,
 1.21396061471e-07 , 1.79408876367e-08 , 2.0939654777e-09  , 2.00632935659e-10 ,
 3.35162003495e-11 , 5.67170994599e-11 , 1.39714512887e-10 , 3.45035792519e-10 ,
 1.74876221295e-09 , 1.75870083747e-08 , 1.71042581824e-07 , 1.34088669517e-06 ,
 8.29518718425e-06 , 4.03591874838e-05 , 0.000154182470469 , 0.000461863321125 ,
 0.00108356845905  , 0.00198889712207  , 0.00285365146618  , 0.00319826985043  ,
 0.00279864577728  , 0.00191225242115  , 0.00102273492615  , 0.000433787125159 ,
 0.000146691199062 , 0.00014100047332  , 0.000129822093344 , 9.91764294233e-05 ,
 6.05436592868e-05 , 2.92880599595e-05 , 1.12016455245e-05 , 3.3916428898e-06  ,
 8.89370251691e-07 , 7.07404958579e-07 , 2.88514726681e-06 , 1.15098282487e-05 ,
 3.61732763863e-05 , 8.90176002525e-05 , 0.000171687329532 , 0.000259855850257 ,
 0.000309081208267 , 0.000289336585607 , 0.000213483886884 , 0.000124321953194 ,
 5.72057306031e-05 , 2.0815704712e-05  , 6.00186298163e-06 , 1.48266647574e-06 ,
 1.26882015076e-06 , 6.98701523112e-06 , 3.75099082499e-05 , 0.000162295088793 ,
 0.000571079396033 , 0.0016617832481   , 0.0040654514582   , 0.0084501959479   ,
 0.014920550106    , 0.0221476769654   , 0.0272056723147   , 0.0272256467534   ,
 0.0219163953636   , 0.0140609456129   , 0.0071436990083   , 0.00286136208391  ,
 0.000900785916397 , 0.000222387376771 , 4.29868351155e-05 , 6.49788076949e-06 ,
 7.67397611606e-07 , 7.07589600206e-08 , 5.09154814904e-09 , 2.85883393871e-10 ,
 1.25405490915e-11 , 4.32568733242e-13 , 1.20931305464e-14 , 5.12772904495e-16 ,
 1.8565060815e-15  , 1.27960336877e-14 , 6.96919060345e-14 , 2.99554624783e-13 ,
 1.01729026186e-12 , 2.73173281531e-12 , 5.80253732234e-12 , 9.74853510276e-12 ,
 1.29466270064e-11 , 1.35785073167e-11 , 1.12330710269e-11 , 7.33082192571e-12 ,
 3.98649857107e-12 , 5.07683811248e-12 , 4.30127486609e-11 , 4.01218787177e-10 ,
 2.99248547678e-09 , 1.76664636779e-08 , 8.2579148474e-08  , 3.06517751277e-07 ,
 9.13158253647e-07 , 2.25697627848e-06 , 5.03979616709e-06 , 1.18071549164e-05 ,
 3.24997519886e-05 , 0.000102616352494 , 0.000343986054614 , 0.00113112518964  ,
 0.00336092559343  , 0.00847145283229  , 0.0174887434509   , 0.0291191248423   ,
 0.0389112978873   , 0.0417471504827   , 0.0360960214204   , 0.0253209469883   ,
 0.0145514409788   , 0.0069350800763   , 0.00277607837276  , 0.000942101971542 ,
 0.000271599916772 , 6.60867255283e-05 , 1.34041680611e-05 , 2.2340804511e-06  ,
 3.02114981511e-07 , 3.32566631659e-08 , 4.87606930813e-09 , 7.07594278398e-09 ,
 1.8338895521e-08  , 3.86073395509e-08 , 6.43274343351e-08 , 8.47575634475e-08 ,
 8.82431468282e-08 , 7.2513616187e-08  , 4.69684619532e-08 , 2.39442753583e-08 ,
 9.59313244826e-09 , 3.01624996044e-09 , 7.43294134525e-10 , 1.43405408643e-10 ,
 2.17965749611e-11 , 5.38439704574e-12 , 3.93542321006e-11 , 4.2070484469e-10  ,
 3.52362160519e-09 , 2.29873045198e-08 , 1.16807056285e-07 , 4.62325651423e-07 ,
 1.42542690069e-06 , 3.42362168095e-06 , 6.4062433751e-06  , 9.33985357712e-06 ,
 1.06108300728e-05 , 9.39506097927e-06 , 6.48451413375e-06 , 3.48973477769e-06 ,
 1.46481390829e-06 , 4.79755761594e-07 , 1.22664896159e-07 , 2.44989468775e-08 ,
 3.82507791736e-09 , 4.68557563658e-10 , 5.37237009211e-11 , 5.2106067947e-11  ,
 2.13452208599e-10 , 8.09628240637e-10 , 3.27330901227e-09 , 1.80731107259e-08 ,
 1.21256149981e-07 , 7.54764394584e-07 , 3.86200849458e-06 , 1.57113210841e-05 ,
 5.04115306716e-05 , 0.000127401999642 , 0.0002537365145   , 0.000398671737037 ,
 0.00049471919031  , 0.000485298229118 , 0.00037653446275  , 0.000231095732912 ,
 0.000112153111389 , 4.30048010228e-05 , 1.30140909124e-05 , 3.10390248966e-06 ,
 5.8258435571e-07  , 8.59262495234e-08 , 9.94522249865e-09 , 9.02447443478e-10 ,
 6.49049298825e-11 , 6.04616052881e-12 , 7.35813483885e-12 , 3.70169943463e-11 ,
 4.26127823278e-10 , 5.18053549856e-09 , 5.14325089037e-08 , 4.03993063122e-07 ,
 2.49969599726e-06 , 1.21621635622e-05 , 4.64626819822e-05 , 0.000139182152388 ,
 0.000326535078299 , 0.00059937912781  , 0.0008601291227   , 0.000964761098953 ,
 0.000847324323201 , 0.00058896211388  , 0.00034028838258  , 0.000194520372591 ,
 0.000491680847713 , 0.000598949896428 , 0.000584011640435 , 0.000451545096798 ,
 0.00027631630807  , 0.000133731070368 , 5.11481086301e-05 , 1.54443596858e-05 ,
 3.69176482207e-06 , 7.95910423237e-07 , 6.53217940461e-07 , 2.22964767052e-06 ,
 6.97310608433e-06 , 1.71574513865e-05 , 3.30912647542e-05 , 5.00849873524e-05 ,
 5.95727528915e-05 , 5.57671461553e-05 , 4.11471888319e-05 , 2.39619908025e-05 ,
 1.10259196561e-05 , 4.01215043268e-06 , 1.15828825531e-06 , 3.03012149552e-07 ,
 4.07356821323e-07 , 2.61188878539e-06 , 1.54339280292e-05 , 7.60411594945e-05 ,
 0.000315458193054 , 0.00110646280293  , 0.00326345002062  , 0.00799738540818  ,
 0.0160603654644   , 0.0261097934082   , 0.0340415577887   , 0.0353517207023   ,
 0.0290987914511   , 0.0189161328832   , 0.00968465627577  , 0.00389659715461  ,
 0.00122991422216  , 0.00030411114505  , 5.88373709442e-05 , 8.89880489552e-06 ,
 1.05138403269e-06 , 9.70055754247e-08 , 6.994756283e-09   , 3.96241259282e-10 ,
 1.80613797892e-11 , 7.26493240873e-13 , 3.24623098235e-14 , 1.89750716604e-15 ,
 1.76485164298e-16 , 4.41191421802e-16 , 2.36837899156e-15 , 1.01787342254e-14 ,
 3.45670272994e-14 , 9.28228758709e-14 , 1.97166959894e-13 , 3.31248989888e-13 ,
 4.39919038952e-13 , 4.6149681559e-13  , 3.85172314281e-13 , 3.33627568338e-13 ,
 1.75057389022e-12 , 2.45347153994e-11 , 2.91901448058e-10 , 2.75209480028e-09 ,
 2.05262432593e-08 , 1.21069100915e-07 , 5.64330494487e-07 , 2.07675968554e-06 ,
 6.02790809331e-06 , 1.37957859298e-05 , 2.49605383824e-05 , 3.62263429277e-05 ,
 4.5190659547e-05  , 6.33858094654e-05 , 0.000149820625867 , 0.000493537329993 ,
 0.00154478299616  , 0.004020643296    , 0.00842754583826  , 0.0141079167534   ,
 0.0188253467304   , 0.0200350883083   , 0.017044916196    , 0.0116408445337   ,
 0.00642592170466  , 0.00289639113118  , 0.00108026444422  , 0.000338233494283 ,
 8.99016042269e-05 , 2.03481372206e-05 , 3.8956704027e-06  , 6.22361734563e-07 ,
 8.1694246642e-08  , 8.72232945093e-09 , 8.87117211342e-10 , 5.43473066673e-10 ,
 1.31632946475e-09 , 2.76714877914e-09 , 4.61048119254e-09 , 6.07474758175e-09 ,
 6.32456637326e-09 , 5.19719879772e-09 , 3.36632545439e-09 , 1.71613501646e-09 ,
 6.87559330563e-10 , 2.16180799636e-10 , 5.32749557036e-11 , 1.03238805557e-11 ,
 2.60312227736e-12 , 1.88397260546e-11 , 2.57622241136e-10 , 2.77028196003e-09 ,
 2.3203465312e-08  , 1.51374161396e-07 , 7.69188500615e-07 , 3.04446998238e-06 ,
 9.38660753375e-06 , 2.25449606387e-05 , 4.21858838417e-05 , 6.15040612131e-05 ,
 6.98735961479e-05 , 6.18676118639e-05 , 4.27013109332e-05 , 2.29803274748e-05 ,
 9.64597831267e-06 , 3.15925058226e-06 , 8.07763522916e-07 , 1.61328545726e-07 ,
 2.51876272103e-08 , 3.07686964416e-09 , 2.94905149562e-10 , 2.55824469948e-11 ,
 3.08785155048e-11 , 3.6034036792e-10  , 4.57504482896e-09 , 4.88765552861e-08 ,
 4.14716628706e-07 , 2.76281914046e-06 , 1.44284375103e-05 , 5.91036605572e-05 ,
 0.000190132170708 , 0.000481009462563 , 0.000958404272461 , 0.00150612552971  ,
 0.00186912602668  , 0.00183359347928  , 0.00142267344345  , 0.000873162330114 ,
 0.000423755589284 , 0.000162488051209 , 4.91720500184e-05 , 1.17276785418e-05 ,
 2.2012073548e-06  , 3.24654277163e-07 , 3.75734548657e-08 , 3.4078896952e-09  ,
 2.41986848501e-10 , 1.35296873603e-11 , 1.087108898e-12   , 6.49623034506e-12 ,
 9.77622904695e-11 , 1.22682843346e-09 , 1.22171427254e-08 , 9.59908044324e-08 ,
 5.93956434125e-07 , 2.88988101277e-06 , 1.10401895632e-05 , 3.30727205797e-05 ,
 7.7603570116e-05  , 0.000142546696963 , 0.000205223402606 , 0.0002336555965   ,
 0.000219404734775 , 0.000197984494429 , 0.000227417072405 , 0.000337614409278 ,
 0.00174140969464  , 0.00215366841512  , 0.00210652752685  , 0.00162975007958  ,
 0.000997426485662 , 0.000482744486467 , 0.000184635506871 , 5.57449313387e-05 ,
 1.32703276926e-05 , 2.50201360315e-06 , 4.49272805343e-07 , 3.76712006391e-07 ,
 1.05501480197e-06 , 2.587104234e-06   , 4.98921277229e-06 , 7.55135704282e-06 ,
 8.98183497074e-06 , 8.40806036758e-06 , 6.20379689083e-06 , 3.61276993574e-06 ,
 1.66238891552e-06 , 6.04946193529e-07 , 1.75133036725e-07 , 5.23210611007e-08 ,
 1.35444383261e-07 , 1.0842065204e-06  , 7.6749451519e-06  , 4.5508793379e-05  ,
 0.000223740540301 , 0.0009014529902   , 0.00294459681641  , 0.00773319416475  ,
 0.0162304760898   , 0.0271075007717   , 0.0359134189268   , 0.0376468160251   ,
 0.0311567259412   , 0.0203175787909   , 0.0104210448884   , 0.00419729159372  ,
 0.0013256401271   , 0.000327903667254 , 6.34590918734e-05 , 9.60250475546e-06 ,
 1.13645808521e-06 , 1.05622171468e-07 , 7.8617090537e-09  , 5.06883635112e-10 ,
 3.50457344067e-11 , 3.16055311178e-12 , 3.17993263076e-13 , 2.82950991653e-14 ,
 2.0224677418e-15  , 1.25357596605e-16 , 6.77582574726e-17 , 2.69941403636e-16 ,
 9.16147641253e-16 , 2.46012015338e-15 , 5.22559108979e-15 , 8.77949405955e-15 ,
 1.16749993277e-14 , 1.28439967599e-14 , 2.90630036193e-14 , 4.65642743905e-13 ,
 8.77316690021e-12 , 1.3228287499e-10  , 1.57702460661e-09 , 1.48692059617e-08 ,
 1.10899825974e-07 , 6.54099104559e-07 , 3.04866214185e-06 , 1.12164580416e-05 ,
 3.25316334173e-05 , 7.42742701066e-05 , 0.000133312593014 , 0.000187974183536 ,
 0.000208840811844 , 0.000187960680254 , 0.000163850593665 , 0.000237899229225 ,
 0.000602553867355 , 0.00153859024181  , 0.00323861543004  , 0.00544040243827  ,
 0.0072615246578   , 0.00769933332779  , 0.00649115320796  , 0.00436090087552  ,
 0.002344121011    , 0.00101514410265  , 0.00035795244621  , 0.000104257539084 ,
 2.54881433837e-05 , 5.29784251732e-06 , 9.39987487002e-07 , 1.41369316115e-07 ,
 1.77587396441e-08 , 1.83429145203e-09 , 1.61247178989e-10 , 3.78304634776e-11 ,
 7.40357551961e-11 , 1.54825997778e-10 , 2.57936254771e-10 , 3.39854854248e-10 ,
 3.53831079646e-10 , 2.9075992734e-10  , 1.88330787657e-10 , 9.60100450281e-11 ,
 3.84658601422e-11 , 1.20945587839e-11 , 2.98853965545e-12 , 8.12717659156e-13 ,
 5.49815804698e-12 , 9.59456070455e-11 , 1.32463169367e-09 , 1.42450393435e-08 ,
 1.19314360993e-07 , 7.783799278e-07   , 3.95523843369e-06 , 1.56549467069e-05 ,
 4.82668071437e-05 , 0.000115928285053 , 0.000216923751716 , 0.000316259646421 ,
 0.000359296615573 , 0.000318129133281 , 0.000219574235238 , 0.000118167077656 ,
 4.96005758909e-05 , 1.62451876484e-05 , 4.15360516599e-06 , 8.29569254403e-07 ,
 1.29517726207e-07 , 1.58212870044e-08 , 1.51382168892e-09 , 1.15999888307e-10 ,
 6.01512897308e-11 , 9.48909815234e-10 , 1.32226319153e-08 , 1.44147692473e-07 ,
 1.22873672604e-06 , 8.1955095967e-06  , 4.28152275291e-05 , 0.000175407133442 ,
 0.000564298851931 , 0.00142762981766  , 0.00284455460221  , 0.00447021295916  ,
 0.00554761447921  , 0.00544215639981  , 0.00422253544348  , 0.00259157104263  ,
 0.00125771889937  , 0.000482269264924 , 0.00014594407612  , 3.48080911034e-05 ,
 6.53324724918e-06 , 9.63583187119e-07 , 1.11519031592e-07 , 1.01146695737e-08 ,
 7.18137431316e-10 , 3.98788625068e-11 , 1.7918751466e-12  , 1.20783975392e-12 ,
 1.81971735496e-11 , 2.2940856177e-10  , 2.28552671326e-09 , 1.79582769929e-08 ,
 1.11120440163e-07 , 5.40669669917e-07 , 2.06579447736e-06 , 6.1923094758e-06  ,
 1.45722046845e-05 , 2.71267643198e-05 , 4.14499425422e-05 , 5.96604390171e-05 ,
 0.000106292087977 , 0.0002466003574   , 0.000571720752165 , 0.00111527642899  ,
 0.00495944886459  , 0.00613841231065  , 0.0060050259766   , 0.00464604044724  ,
 0.00284345066283  , 0.00137620355138  , 0.000526357265963 , 0.000158916390343 ,
 3.78242285247e-05 , 7.08851436809e-06 , 1.05341123293e-06 , 1.60031831703e-07 ,
 1.34799105701e-07 , 3.05604431389e-07 , 5.87963939864e-07 , 8.89844455663e-07 ,
 1.05840856625e-06 , 9.90795711967e-07 , 7.31048080618e-07 , 4.25724662183e-07 ,
 1.95894539723e-07 , 7.12969625102e-08 , 2.08441040076e-08 , 9.45755423689e-09 ,
 5.89129066089e-08 , 5.81724650493e-07 , 4.75729699662e-06 , 3.14632889861e-05 ,
 0.000166969592086 , 0.000707329044505 , 0.00238428334914  , 0.00638225074248  ,
 0.0135475252074   , 0.022776645542    , 0.0302913795248   , 0.0318234466437   ,
 0.0263706159699   , 0.0172090316802   , 0.00883037344707  , 0.00355753080552  ,
 0.00112381664357  , 0.00027808770193  , 5.38926869812e-05 , 8.20371677834e-06 ,
 9.96556133391e-07 , 1.03173155578e-07 , 1.10508480563e-08 , 1.5312185909e-09  ,
 2.45480312335e-10 , 3.56345137e-11    , 4.19303975195e-12 , 3.88022947898e-13 ,
 2.80329282958e-14 , 1.57936025245e-15 , 7.05778293894e-17 , 7.85968907258e-18 ,
 1.8708971751e-17  , 5.00711106081e-17 , 1.06354290813e-16 , 1.79860579068e-16 ,
 3.0432641266e-16  , 2.87218901903e-15 , 8.09238542972e-14 , 1.95572819061e-12 ,
 3.73599699932e-11 , 5.63528262958e-10 , 6.71822985596e-09 , 6.33438196909e-08 ,
 4.72440627791e-07 , 2.78650364533e-06 , 1.29874650655e-05 , 4.77823856128e-05 ,
 0.000138582523727 , 0.00031638037604  , 0.000567711357436 , 0.000799577200888 ,
 0.000882988672577 , 0.000765184881574 , 0.000527852059505 , 0.0003236499663   ,
 0.000285012233203 , 0.00049900031896  , 0.0009937883114   , 0.0016628265166   ,
 0.00222079195068  , 0.00235200561393  , 0.00197406905825  , 0.00131393801368  ,
 0.000694914739989 , 0.000293201067538 , 9.93868900868e-05 , 2.73671609499e-05 ,
 6.21604102088e-06 , 1.18513129046e-06 , 1.9240242473e-07  , 2.67241817212e-08 ,
 3.15235527788e-09 , 3.10923249128e-10 , 2.55289076248e-11 , 2.85318930849e-12 ,
 3.29422304595e-12 , 6.76060609061e-12 , 1.12587648072e-11 , 1.48343538811e-11 ,
 1.54444011296e-11 , 1.26914033188e-11 , 8.22046561015e-12 , 4.19075013279e-12 ,
 1.67901727808e-12 , 5.28777764592e-13 , 1.62773393196e-13 , 9.80285527181e-13 ,
 2.17465874771e-11 , 3.85465128994e-10 , 5.32231596235e-09 , 5.72360275637e-08 ,
 4.79400601395e-07 , 3.12750139107e-06 , 1.58920012218e-05 , 6.29010018599e-05 ,
 0.00019393428981  , 0.000465795756957 , 0.000871592198956 , 0.00127072084954  ,
 0.00144364263016  , 0.00127823375013  , 0.000882243729764 , 0.000474792881337 ,
 0.000199294413009 , 6.52730835792e-05 , 1.66892196425e-05 , 3.33323188738e-06 ,
 5.20409369503e-07 , 6.35714396854e-08 , 6.08255363091e-09 , 4.61738284223e-10 ,
 1.50169046965e-10 , 2.20559510641e-09 , 3.07728884386e-08 , 3.35578563289e-07 ,
 2.86073143346e-06 , 1.90810712764e-05 , 9.96845238629e-05 , 0.000408392446971 ,
 0.00131383248788  , 0.00332388964769  , 0.00662285623476  , 0.0104078085466   ,
 0.0129162774862   , 0.0126707440258   , 0.00983115186015  , 0.00603384598451  ,
 0.00292829407813  , 0.00112284727035  , 0.000339795461647 , 8.10422163039e-05 ,
 1.52110851188e-05 , 2.24347025374e-06 , 2.59645075192e-07 , 2.35495593795e-08 ,
 1.67200730199e-09 , 9.28383538918e-11 , 4.03643446295e-12 , 3.04192943046e-13 ,
 2.67786674564e-12 , 3.37394036119e-11 , 3.36157414908e-10 , 2.64140208946e-09 ,
 1.63461595708e-08 , 7.95786575317e-08 , 3.04848371454e-07 , 9.2485586518e-07  ,
 2.29680279365e-06 , 5.29749037531e-06 , 1.48105739386e-05 , 5.4248418852e-05  ,
 0.000201679222393 , 0.000633830887161 , 0.0015930269316   , 0.00316413179687  
};
  // type   : nogpivprep
  // tiling : [180, 180]
  // range  : [[-180.0, 178.0], [-180.0, 178.0]]
  ftype32 rama2_nogpivprep_data[] = {
 2.10946168407e-07 , 6.05719409038e-07 , 4.07073370192e-06 , 2.23269705886e-05 ,
 9.67648768984e-05 , 0.00033151999003  , 0.000898349121162 , 0.00192559880895  ,
 0.00326367539721  , 0.00437035570017  , 0.00461844500775  , 0.00384633471102  ,
 0.00252074027418  , 0.00129806257684  , 0.000524493228084 , 0.000166075888348 ,
 4.11631171069e-05 , 7.97863049856e-06 , 1.20849784319e-06 , 1.43178461153e-07 ,
 1.3779960766e-08  , 1.99451587146e-09 , 1.55355732557e-09 , 1.83737336052e-09 ,
 2.25625542231e-09 , 3.75250796147e-09 , 8.51625702922e-09 , 1.96343938969e-08 ,
 3.99426327937e-08 , 8.23046407032e-08 , 2.81498915309e-07 , 1.60115422537e-06 ,
 9.28418669844e-06 , 4.61555869813e-05 , 0.000192218369104 , 0.000669228979314 ,
 0.00194044382226  , 0.00465511931489  , 0.00918511021795  , 0.0148955727784   ,
 0.0200908225019   , 0.0234362666654   , 0.0258982274947   , 0.0312555889342   ,
 0.0446318282352   , 0.0692530827265   , 0.101537390966    , 0.12860334942     ,
 0.135097366548    , 0.116188903235    , 0.0820587091963   , 0.048267909301    ,
 0.0241657187787   , 0.0105685762954   , 0.00421959272021  , 0.00186059463897  ,
 0.00160101450382  , 0.00290342403835  , 0.00635346364573  , 0.013048629457    ,
 0.02291263667     , 0.0328303516107   , 0.0375363288876   , 0.0339295214607   ,
 0.0242301685327   , 0.0139919322401   , 0.00779741571662  , 0.00764850059169  ,
 0.0139440786987   , 0.0256469905124   , 0.039254488216    , 0.0495748955911   ,
 0.0529093695651   , 0.0489706623396   , 0.0397432528574   , 0.02795293892     ,
 0.0165935394032   , 0.00809077065254  , 0.00317537602837  , 0.000990646255448 ,
 0.000244102411602 , 4.74618815809e-05 , 7.33788476068e-06 , 9.32096904624e-07 ,
 1.1934315602e-07  , 5.9407891043e-08  , 1.27196406874e-07 , 2.72068391371e-07 ,
 4.6868157514e-07  , 6.38493379691e-07 , 6.85427226378e-07 , 5.78751661721e-07 ,
 3.83784651398e-07 , 1.995956344e-07   , 8.13113106992e-08 , 2.59194130884e-08 ,
 6.45923086579e-09 , 1.25744839802e-09 , 1.91110202143e-10 , 2.26643384666e-11 ,
 2.09648381851e-12 , 1.51212768904e-13 , 8.50201762107e-15 , 3.72566373323e-16 ,
 1.27230936952e-17 , 3.4813821388e-19  , 9.22559948106e-20 , 5.94017193822e-19 ,
 3.26945714417e-18 , 1.42911915127e-17 , 3.02861191385e-16 , 1.24206362351e-14 ,
 4.61647093923e-13 , 1.35122049988e-11 , 3.08565583046e-10 , 5.49504375655e-09 ,
 7.63262806905e-08 , 8.27170615323e-07 , 6.99716077334e-06 , 4.62268339372e-05 ,
 0.000238676529753 , 0.000963896554181 , 0.00304780472165  , 0.00755406993957  ,
 0.0146953177616   , 0.0224699542256   , 0.0270468403607   , 0.0256756502926   ,
 0.019307388996    , 0.011796295765    , 0.00691843278268  , 0.00671830739537  ,
 0.011665006747    , 0.0204216904086   , 0.0290845150957   , 0.0326035313054   ,
 0.0287906991471   , 0.0205270024912   , 0.0130602354497   , 0.00952052499623  ,
 0.00930189186656  , 0.00978935147799  , 0.00894662385831  , 0.00659975099057  ,
 0.00386449872391  , 0.00179094904487  , 0.000657588478981 , 0.000197876030395 ,
 8.97973825956e-05 , 0.000243962085578 , 0.000986700513528 , 0.00332995117358  ,
 0.00905550651641  , 0.0197561655247   , 0.0345024376565   , 0.0481637536009   ,
 0.0536872103043   , 0.047750420804    , 0.0338676502155   , 0.019145495937    ,
 0.00862154672757  , 0.00309096840874  , 0.000882018928863 , 0.000200659850865 ,
 3.68180261121e-05 , 5.94133637088e-06 , 2.14870460267e-06 , 5.34839092076e-06 ,
 1.64843083989e-05 , 4.09552163491e-05 , 8.00921227321e-05 , 0.000123243519141 ,
 0.000149419416822 , 0.000142929012293 , 0.00010800004882  , 6.45206523947e-05 ,
 3.04890950143e-05 , 1.13961193505e-05 , 3.36804054369e-06 , 7.91959790966e-07 ,
 8.1261503408e-07  , 1.56250616667e-06 , 1.02146999619e-05 , 5.59061042757e-05 ,
 0.000241854290474 , 0.000827011857583 , 0.00223662517173  , 0.00478482617368  ,
 0.00809452424305  , 0.0108202838142   , 0.0114162799529   , 0.00949427300518  ,
 0.00621456137143  , 0.00319687484355  , 0.00129060017549  , 0.00040836324343  ,
 0.000101156663006 , 1.95982194833e-05 , 2.96851261469e-06 , 3.54836573139e-07 ,
 4.13609740508e-08 , 1.83201160156e-08 , 2.31924200849e-08 , 2.82337212764e-08 ,
 3.36646046225e-08 , 5.10614620006e-08 , 1.06059899725e-07 , 2.33447516819e-07 ,
 4.52545273473e-07 , 7.70259643338e-07 , 1.54128138356e-06 , 5.74462909633e-06 ,
 2.95381600796e-05 , 0.000141149230808 , 0.000571420632336 , 0.00193747384795  ,
 0.00548105243775  , 0.0128578107195   , 0.0248388171287   , 0.0393567507802   ,
 0.0513711644961   , 0.0565373859966   , 0.0559462113667   , 0.0566443633569   ,
 0.0672817283515   , 0.0923452124017   , 0.126787489286    , 0.154444644461    ,
 0.157004465716    , 0.129736753652    , 0.0863877556825   , 0.046444281677    ,
 0.0203837827942   , 0.00746027773442  , 0.00237599256529  , 0.000795153649236 ,
 0.000648745748446 , 0.00153577388773  , 0.00411581656659  , 0.00942911167405  ,
 0.0174549499177   , 0.025623980565    , 0.0296200847366   , 0.0269100935217   ,
 0.0192774573184   , 0.0112216660752   , 0.00654927928588  , 0.00714464397271  ,
 0.0137145217761   , 0.0256856755409   , 0.0400880816079   , 0.0521271868498   ,
 0.0579008378345   , 0.0561008333026   , 0.0475032247912   , 0.0344988769923   ,
 0.0209061376742   , 0.0103181173988   , 0.00408005406835  , 0.00128141524648  ,
 0.00031922725896  , 6.36544189582e-05 , 1.04591668194e-05 , 1.52975419142e-06 ,
 3.17928676888e-07 , 4.16991546982e-07 , 1.0792747442e-06  , 2.35370902838e-06 ,
 4.06649873286e-06 , 5.54269208862e-06 , 5.95066863331e-06 , 5.02462827486e-06 ,
 3.33196632356e-06 , 1.73286318587e-06 , 7.05934230523e-07 , 2.2502897927e-07  ,
 5.60782039344e-08 , 1.0917003774e-08  , 1.65919396893e-09 , 1.96768844744e-10 ,
 1.82014003895e-11 , 1.31280963226e-12 , 7.38134135621e-14 , 3.23457535412e-15 ,
 1.10495456036e-16 , 3.41836379861e-18 , 4.30365196043e-18 , 2.95928924728e-17 ,
 1.63099537524e-16 , 7.12769098518e-16 , 2.64559494587e-15 , 1.47771919773e-14 ,
 3.04013922116e-13 , 8.35260428143e-12 , 1.88514642483e-10 , 3.33944043943e-09 ,
 4.62409126674e-08 , 5.00156808012e-07 , 4.22567316637e-06 , 2.78945235831e-05 ,
 0.000143947289349 , 0.000581124040756 , 0.00183704317384  , 0.00455239069407  ,
 0.00885494549293  , 0.0135386388626   , 0.016296246318    , 0.0154766973925   ,
 0.0116824438543   , 0.00735231848378  , 0.00509990271569  , 0.00682004040709  ,
 0.0134936848164   , 0.0241104658118   , 0.0343840424448   , 0.0384463319006   ,
 0.0336639855463   , 0.0232422009327   , 0.0130839350424   , 0.00681525764761  ,
 0.00429926333482  , 0.00357056247243  , 0.00302483469741  , 0.0021739635833   ,
 0.00125366097331  , 0.000573416249656 , 0.00020964406546  , 7.27334457758e-05 ,
 7.70303928239e-05 , 0.000256913713345 , 0.000863312837709 , 0.0024758465751   ,
 0.00597348769127  , 0.0120102100853   , 0.019918973075    , 0.0269942316634   ,
 0.0296604476739   , 0.0262672298906   , 0.0186690465863   , 0.0106169970486   ,
 0.00482218379822  , 0.00174942295813  , 0.000510503054206 , 0.000124077880082 ,
 2.86299379354e-05 , 8.99752700057e-06 , 8.51891526867e-06 , 2.41354970769e-05 ,
 7.37093019097e-05 , 0.000182841888824 , 0.000357505284104 , 0.000550109777418 ,
 0.00066694740276  , 0.00063797677949  , 0.000482068136539 , 0.00028799385969  ,
 0.000136090877134 , 5.08675842321e-05 , 1.5032759365e-05  , 3.52352163112e-06 ,
 2.61932992981e-06 , 3.30477308417e-06 , 2.06355792176e-05 , 0.000112473367263 ,
 0.000484772939313 , 0.00165119177222  , 0.0044476364648   , 0.00947665155949  ,
 0.0159693860141   , 0.0212689330966   , 0.0223655286849   , 0.018544836118    ,
 0.0121072748282   , 0.00621443575568  , 0.00250416527544  , 0.000791139041067 ,
 0.000195730871887 , 3.78867332106e-05 , 5.74792997137e-06 , 7.25752374158e-07 ,
 1.70975640686e-07 , 1.98142533842e-07 , 2.81053998753e-07 , 3.45202240614e-07 ,
 4.04176289533e-07 , 5.67464641066e-07 , 1.07321874178e-06 , 2.23784625794e-06 ,
 4.20009103421e-06 , 6.65399677458e-06 , 9.80491864633e-06 , 2.07014248964e-05 ,
 7.96611111451e-05 , 0.000351173099367 , 0.00136890581815  , 0.00450243458542  ,
 0.0123965903928   , 0.0283956361846   , 0.0537107105505   , 0.0833948405674   ,
 0.106264029631    , 0.112576266514    , 0.103453577389    , 0.0910703689606   ,
 0.089209011617    , 0.104012374366    , 0.129918630773    , 0.150741043727    ,
 0.149026403914    , 0.1204986234      , 0.0782628407386   , 0.0405635688516   ,
 0.0167886022564   , 0.00559202865323  , 0.00153413712027  , 0.000404992622094 ,
 0.000300120243569 , 0.000832023661776 , 0.00242652856735  , 0.00576699716382  ,
 0.010848519725    , 0.0160386898977   , 0.0185992306116   , 0.0169252687531   ,
 0.012147770157    , 0.00713785026266  , 0.004399240356    , 0.00534682573796  ,
 0.0107597863631   , 0.0205510920968   , 0.032830661156    , 0.0441475311394   ,
 0.051179354699    , 0.0518671991419   , 0.0456327991987   , 0.0340553309323   ,
 0.0210015919226   , 0.010493187582    , 0.0042058252976   , 0.00135569289338  ,
 0.000359320509338 , 8.27211480138e-05 , 1.80147532288e-05 , 4.05880950924e-06 ,
 1.55841857868e-06 , 2.79406025567e-06 , 7.35519699989e-06 , 1.60488951056e-05 ,
 2.77285008209e-05 , 3.77944584976e-05 , 4.05763902531e-05 , 3.42619145117e-05 ,
 2.27199986397e-05 , 1.18160406021e-05 , 4.81362152736e-06 , 1.53442671028e-06 ,
 3.82385834315e-07 , 7.44408219857e-08 , 1.13137052471e-08 , 1.34172661722e-09 ,
 1.24111636703e-10 , 8.95178110789e-12 , 5.03318616374e-13 , 2.20560021005e-14 ,
 7.54770278437e-16 , 3.82007438717e-17 , 1.6112357745e-16  , 1.12125072938e-15 ,
 6.18207164465e-15 , 2.70165069306e-14 , 9.41701278704e-14 , 2.70019742259e-13 ,
 8.24796626659e-13 , 6.66869638038e-12 , 1.13114881297e-10 , 1.83010652389e-09 ,
 2.41317536415e-08 , 2.53218053405e-07 , 2.09805601625e-06 , 1.36739078314e-05 ,
 6.99653822075e-05 , 0.000280834216592 , 0.000884268632146 , 0.00218528158458  ,
 0.00424235813527  , 0.00647731016844  , 0.0077896011573   , 0.00739921451473  ,
 0.00562419837124  , 0.0037392398703   , 0.00330948740299  , 0.00586267732699  ,
 0.0125257657202   , 0.0226278254627   , 0.032307086174    , 0.0361069570444   ,
 0.0315454071509   , 0.0215780084316   , 0.0116715469182   , 0.00522012149486  ,
 0.00225846091513  , 0.00124196309332  , 0.000867470043368 , 0.000587750075462 ,
 0.000332018909954 , 0.000151122301955 , 6.21008157179e-05 , 5.85592919761e-05 ,
 0.000183151426021 , 0.000608080089244 , 0.00167956234751  , 0.00381737933454  ,
 0.00718865065304  , 0.0113290087166   , 0.0150930276854   , 0.0171018915695   ,
 0.0164600975299   , 0.0133404308146   , 0.00899100645094  , 0.00498163565177  ,
 0.00226021382484  , 0.000856758192637 , 0.000298209265796 , 0.000119071493905 ,
 6.2331131265e-05  , 3.81117342473e-05 , 3.67340354047e-05 , 8.81566645563e-05 ,
 0.000261189020292 , 0.000645808165458 , 0.00126232360789  , 0.00194233387527  ,
 0.00235485824846  , 0.00225256812395  , 0.0017020859675   , 0.00101684865502  ,
 0.000480509687873 , 0.000179603225195 , 5.30761483046e-05 , 1.24186637197e-05 ,
 6.93989032644e-06 , 5.91822441065e-06 , 3.45046281445e-05 , 0.00018665834906  ,
 0.000798926646161 , 0.00270099892113  , 0.00721902310509  , 0.0152612714908   ,
 0.025519961314    , 0.033741117299    , 0.0352418474183   , 0.0290445565096   ,
 0.0188613731299   , 0.00963695088712  , 0.00386832374737  , 0.00121820082243  ,
 0.000300603353181 , 5.80996793734e-05 , 8.93215712492e-06 , 1.49841653161e-06 ,
 1.13201923937e-06 , 1.8632899306e-06  , 2.70917125093e-06 , 3.3537635294e-06  ,
 3.89406253159e-06 , 5.14842642105e-06 , 8.8754869727e-06  , 1.73723592201e-05 ,
 3.15390408182e-05 , 4.83291839314e-05 , 6.30059858949e-05 , 8.65575378882e-05 ,
 0.000203125653743 , 0.000740852088502 , 0.00269908146074  , 0.00850625268058  ,
 0.0226218926894   , 0.0503401725415   , 0.0929461326788   , 0.141280223153    ,
 0.176118109458    , 0.181066415017    , 0.157636503263    , 0.124683550121    ,
 0.102442827202    , 0.0991290476183   , 0.10926621075     , 0.118750293062    ,
 0.113580553276    , 0.0901298423494   , 0.0577171546972   , 0.0294518046701   ,
 0.0119157641984   , 0.00382523828998  , 0.000991164730776 , 0.000249049855369 ,
 0.000183246612993 , 0.000459005690679 , 0.00125448899079  , 0.00290538211203  ,
 0.00541679753762  , 0.00798757190689  , 0.00926206519691  , 0.00844167162977  ,
 0.00608668645209  , 0.00363730162703  , 0.00239930490302  , 0.00322545863501  ,
 0.00673990457893  , 0.0131344185171   , 0.0215570429144   , 0.030094511267    ,
 0.0364671774347   , 0.038575047018    , 0.0351232836037   , 0.0268692917767   ,
 0.0169106910956   , 0.00868145628822  , 0.00368053682767  , 0.00134861644897  ,
 0.000462595420498 , 0.000157915393593 , 5.22450819469e-05 , 1.61438921265e-05 ,
 7.74298811575e-06 , 1.49223236416e-05 , 3.94422063029e-05 , 8.60755973069e-05 ,
 0.000148718278514 , 0.000202705832197 , 0.000217626378458 , 0.000183759480319 ,
 0.000121855862496 , 6.3373851457e-05  , 2.58172551973e-05 , 8.22970516807e-06 ,
 2.05087845237e-06 , 3.99254010184e-07 , 6.06796387985e-08 , 7.19618239303e-09 ,
 6.65657193759e-10 , 4.80117549854e-11 , 2.6994864076e-12  , 1.18297329719e-13 ,
 4.08718890669e-15 , 6.44353956902e-16 , 4.75427210909e-15 , 3.31677545198e-14 ,
 1.82967335521e-13 , 8.00016846401e-13 , 2.78486909006e-12 , 7.7991905022e-12  ,
 1.83927335023e-11 , 4.69765824079e-11 , 2.4654485412e-10  , 2.34246573638e-09 ,
 2.26825668883e-08 , 1.89438005576e-07 , 1.31787291528e-06 , 7.52425674488e-06 ,
 3.48803821767e-05 , 0.000130175102756 , 0.000388577156855 , 0.000923463405968 ,
 0.00174202298827  , 0.00260409382737  , 0.00308351457805  , 0.00289981541202  ,
 0.00221529077199  , 0.00160811913729  , 0.00190768599466  , 0.00414836228179  ,
 0.00923895368208  , 0.0167839496569   , 0.02397933187     , 0.0267978434449   ,
 0.0233981004977   , 0.0159619798384   , 0.00853038703367  , 0.00362094796952  ,
 0.00129586038157  , 0.000473595248619 , 0.000228907360124 , 0.000134331765029 ,
 7.43104167156e-05 , 3.84999042622e-05 , 4.05590377108e-05 , 0.000138849274175 ,
 0.000533122286803 , 0.00170091710635  , 0.00439499324124  , 0.00916847675172  ,
 0.0154250157963   , 0.0209412638595   , 0.0230264030985   , 0.0206792031167   ,
 0.0153850420375   , 0.00966922623818  , 0.00525144735393  , 0.00254149718178  ,
 0.00118171324093  , 0.000633126687299 , 0.000452341246403 , 0.000369269756156 ,
 0.000277708404247 , 0.000182111789888 , 0.000141479784308 , 0.000261580126583 ,
 0.000734038784353 , 0.00180424459109  , 0.00352457857537  , 0.00542294643526  ,
 0.00657466727684  , 0.00628907479895  , 0.00475215275463  , 0.00283900001064  ,
 0.00134156444048  , 0.000501445773243 , 0.000148184769032 , 3.4639555142e-05  ,
 1.48878922469e-05 , 9.29723580848e-06 , 4.97841550488e-05 , 0.000266149647039 ,
 0.00112612681067  , 0.0037596679816   , 0.0099151870922   , 0.0206739105761   ,
 0.0340969088258   , 0.0444809000643   , 0.0458764220685   , 0.0373744136182   ,
 0.0240216284897   , 0.0121636071956   , 0.00484515969915  , 0.00151601947116  ,
 0.000372163788734 , 7.18991509483e-05 , 1.20124146342e-05 , 4.76721806785e-06 ,
 7.95275074592e-06 , 1.40954393296e-05 , 2.06998369832e-05 , 2.586943734e-05   ,
 3.00251088033e-05 , 3.80310788343e-05 , 6.02269374701e-05 , 0.00010990510221  ,
 0.000191889118906 , 0.000286689973391 , 0.000356067674911 , 0.000398277383051 ,
 0.00057155969679  , 0.00145503280403  , 0.0046129808326   , 0.0135064247034   ,
 0.0340317702296   , 0.0726004629384   , 0.129708385355    , 0.1920515062      ,
 0.233887026308    , 0.234170240078    , 0.195561745343    , 0.142737493647    ,
 0.101191516131    , 0.0807458429599   , 0.076161528108    , 0.0757738706259   ,
 0.0693526181779   , 0.053821109044    , 0.0340329258064   , 0.0172064958788   ,
 0.00689722386605  , 0.00219928218146  , 0.000605021019153 , 0.000255561403054 ,
 0.000311190176635 , 0.000516467050799 , 0.000867184657421 , 0.0014686032322   ,
 0.00235800313168  , 0.00328641478328  , 0.00376628610639  , 0.00348382150999  ,
 0.00262348322376  , 0.00171226830089  , 0.00126840335167  , 0.00171394050482  ,
 0.00345637294385  , 0.00675002208738  , 0.0113729841547   , 0.0165182293001   ,
 0.0209248220812   , 0.0230580325701   , 0.0217287023092   , 0.0172060076441   ,
 0.0114358998233   , 0.00658658505534  , 0.00353122741478  , 0.0018859065037   ,
 0.000988031945971 , 0.000466528713303 , 0.000184664729399 , 6.21004506524e-05 ,
 3.16866921277e-05 , 6.28805593923e-05 , 0.00016661598033  , 0.000363657490969 ,
 0.000628318507555 , 0.000856410348954 , 0.000919448070737 , 0.000776364065004 ,
 0.000514827929382 , 0.000267747714836 , 0.000109075129939 , 3.47696203066e-05 ,
 8.66474115752e-06 , 1.68680530547e-06 , 2.56364955764e-07 , 3.04030976023e-08 ,
 2.81233013956e-09 , 2.02844509089e-10 , 1.14050496258e-11 , 4.99875701774e-13 ,
 1.82173015911e-14 , 1.29540150875e-14 , 1.09971540956e-13 , 7.66926945731e-13 ,
 4.23243834107e-12 , 1.85204630711e-11 , 6.45102457705e-11 , 1.80206986584e-10 ,
 4.12457139104e-10 , 8.47326747438e-10 , 2.23302977257e-09 , 1.15303400273e-08 ,
 8.16966867635e-08 , 5.42365424097e-07 , 3.03632824286e-06 , 1.3955025895e-05  ,
 5.21549793171e-05 , 0.00015787620398  , 0.000386457841563 , 0.000764549910934 ,
 0.00122214912748  , 0.00157818399713  , 0.00164619996477  , 0.00139112909748  ,
 0.00098149287392  , 0.000717973006928 , 0.00100125844833  , 0.0023864630038   ,
 0.00540388835839  , 0.00983861447832  , 0.0140600455635   , 0.0157124084114   ,
 0.0137166101972   , 0.00934994478507  , 0.00497893062913  , 0.00207978209338  ,
 0.000695825579482 , 0.000204729673387 , 7.13514705772e-05 , 4.05223889985e-05 ,
 3.25061399497e-05 , 3.6875130613e-05  , 9.13564962066e-05 , 0.000359782999117 ,
 0.00133709815762  , 0.00410731099701  , 0.0102220888998   , 0.0205258835435   ,
 0.0331580812432   , 0.0429610400399   , 0.0445225383648   , 0.0368561423236   ,
 0.0244158127555   , 0.0130816449786   , 0.00590576438262  , 0.00261182670723  ,
 0.00159459425651  , 0.00149855093544  , 0.0015620891002   , 0.00145072865097  ,
 0.00112045544382  , 0.000719312989867 , 0.000469783765671 , 0.000639074190478 ,
 0.00163853885937  , 0.00398484171983  , 0.00777607213941  , 0.0119630813303   ,
 0.0145036487334   , 0.0138736321302   , 0.0104832128968   , 0.00626282909575  ,
 0.00295950295437  , 0.00110620304318  , 0.000326901978914 , 7.63815143271e-05 ,
 2.55904270962e-05 , 1.30835415917e-05 , 6.47300333951e-05 , 0.000340954481328 ,
 0.00142074852383  , 0.00466251030057  , 0.012066660538    , 0.0246590101597   ,
 0.0398309605143   , 0.0508849719649   , 0.0514220917709   , 0.0410924331662   ,
 0.0259475073579   , 0.0129320527079   , 0.00508031561422  , 0.00157089229175  ,
 0.000382173067412 , 7.48918687122e-05 , 1.83086284567e-05 , 2.21588387145e-05 ,
 4.69679509103e-05 , 8.45911352658e-05 , 0.000125257370127 , 0.00015832759381  ,
 0.000184860673053 , 0.000227883812131 , 0.000335845054686 , 0.000570112118304 ,
 0.000951311725037 , 0.00138389535566  , 0.00167287496421  , 0.00172078578883  ,
 0.00183068337658  , 0.00303076456182  , 0.00753417433877  , 0.019370158269    ,
 0.0444539148766   , 0.0882173331926   , 0.149241639996    , 0.212226194027    ,
 0.25052602497     , 0.243823147181    , 0.196535667566    , 0.134934015476    ,
 0.0850987055866   , 0.0566125404209   , 0.0445577784529   , 0.0394595063295   ,
 0.0340183123441   , 0.0256352994817   , 0.0159694070675   , 0.00800881662301  ,
 0.00320800876121  , 0.00108220271662  , 0.000488527612111 , 0.000610633194752 ,
 0.00104036239983  , 0.00150449462478  , 0.00177112208507  , 0.00177724360051  ,
 0.00167707725265  , 0.00165692870866  , 0.00174588786358  , 0.00184404558945  ,
 0.00185146208848  , 0.00172697719412  , 0.0015234948008   , 0.00144863540954  ,
 0.00183724984251  , 0.00297210955705  , 0.00489094835254  , 0.00732206632412  ,
 0.00969052250405  , 0.0111907539384   , 0.0111949779482   , 0.00986874708723  ,
 0.00812538611957  , 0.00669791713891  , 0.00551443131166  , 0.00417479255089  ,
 0.00267461955386  , 0.00138390064939  , 0.00056840024326  , 0.000194584750104 ,
 0.000102749040476 , 0.000209027051565 , 0.00055521629248  , 0.00121198849964  ,
 0.00209405987856  , 0.00285424550929  , 0.00306433777521  , 0.00258746721007  ,
 0.00171581922223  , 0.000892349947635 , 0.000363525741197 , 0.000115880237779 ,
 2.88778610974e-05 , 5.62178701293e-06 , 8.54413472742e-07 , 1.01327484983e-07 ,
 9.37293772794e-09 , 6.76040552242e-10 , 3.80111906784e-11 , 1.66823433917e-12 ,
 7.96789298548e-14 , 2.31265599438e-13 , 1.99349677304e-12 , 1.38750821381e-11 ,
 7.65958587105e-11 , 3.35497735716e-10 , 1.17002009481e-09 , 3.26964251698e-09 ,
 7.42737938908e-09 , 1.43449868838e-08 , 2.78708437216e-08 , 8.17105793293e-08 ,
 4.04219182105e-07 , 2.27977685853e-06 , 1.16287747931e-05 , 4.99194176493e-05 ,
 0.000175490456678 , 0.000498459609527 , 0.00113566436611  , 0.00206750120725  ,
 0.00300211253993  , 0.00347524644875  , 0.00320948850179  , 0.00237190085093  ,
 0.00142372893194  , 0.000770196306934 , 0.000629051464924 , 0.001162613219    ,
 0.00252438325075  , 0.00456749068868  , 0.00651958174027  , 0.00728370984702  ,
 0.00635777544557  , 0.004332835838    , 0.00230553986592  , 0.000961304141985 ,
 0.000323874111622 , 0.000110341282027 , 7.58779697103e-05 , 9.72877148125e-05 ,

 0.000125190275998 , 0.000153613004997 , 0.000266408266022 , 0.000814490240263 ,
 0.00278943576328  , 0.00821250139792  , 0.0197112340486   , 0.0382452338442   ,
 0.0598201233696   , 0.0752023140118   , 0.0757238536214   , 0.0608852440317   ,
 0.0390816609455   , 0.0202962231375   , 0.00920654019887  , 0.00483684075543  ,
 0.00415277052734  , 0.00469497918031  , 0.00507562394318  , 0.00469691075925  ,
 0.00359375009223  , 0.00226202241887  , 0.00131580709971  , 0.00130790902786  ,
 0.00291326661264  , 0.00695247836286  , 0.0135411714167   , 0.0208284890339   ,
 0.0252513867451   , 0.024154588911    , 0.018251895895    , 0.0109041468781   ,
 0.00515292124481  , 0.00192616650368  , 0.000569269670212 , 0.000133004640439 ,
 3.51022040328e-05 , 1.63915437803e-05 , 7.71756138044e-05 , 0.000400872714111 ,
 0.00164503744131  , 0.00530339769874  , 0.0134501582863   , 0.0268745108898   ,
 0.0423647137504   , 0.0527524647508   , 0.0519328917937   , 0.0404398765102   ,
 0.0249084428442   , 0.0121297079785   , 0.00466598329029  , 0.00141649783698  ,
 0.000340871644554 , 7.36494962633e-05 , 4.44653481105e-05 , 9.96133965512e-05 ,
 0.000221547012008 , 0.000401677247816 , 0.000600059413312 , 0.000768691008966 ,
 0.000907761804312 , 0.00110405247812  , 0.00153844376055  , 0.00243717316347  ,
 0.00386938383584  , 0.00546086586098  , 0.00645183094383  , 0.00637279044589  ,
 0.00587068484533  , 0.0070055040622   , 0.013013481253    , 0.0278724477104   ,
 0.0554597335362   , 0.0974752157956   , 0.149537990307    , 0.197602128803    ,
 0.221177479992    , 0.206712318076    , 0.160418955466    , 0.104645528155    ,
 0.060231066862    , 0.0341906018402   , 0.0221644007771   , 0.0169373576297   ,
 0.0134689164564   , 0.0097555033794   , 0.00596156247553  , 0.0029710784774   ,
 0.00123715937215  , 0.000617928742087 , 0.000836805319545 , 0.00175506320578  ,
 0.00317253271185  , 0.0045324073261   , 0.00508960562776  , 0.00453963486158  ,
 0.00336989058355  , 0.00245589197159  , 0.00237976165502  , 0.00311195902859  ,
 0.00410663593316  , 0.00464274569699  , 0.00430721207387  , 0.00330611947232  ,
 0.00227331657462  , 0.00176643660384  , 0.00196123421663  , 0.00271050804353  ,
 0.00372931180774  , 0.00476212422557  , 0.00580713977321  , 0.00720930657081  ,
 0.00917520980351  , 0.0110272283629   , 0.0114039540006   , 0.0096030865538   ,
 0.00642285113355  , 0.00337790825301  , 0.00139605796489  , 0.000481016301856 ,
 0.000262724760544 , 0.000548714381896 , 0.00146127475521  , 0.00319031056447  ,
 0.00551222701193  , 0.00751327898565  , 0.00806630861691  , 0.00681103409906  ,
 0.00451658022397  , 0.00234894799764  , 0.00095691501315  , 0.000305033527729 ,
 7.60156866492e-05 , 1.47983259059e-05 , 2.2490871673e-06  , 2.66726068291e-07 ,
 2.46725447547e-08 , 1.77955695535e-09 , 1.00073018809e-10 , 4.45176886291e-12 ,
 5.47042608841e-13 , 3.40155210797e-12 , 2.84510467488e-11 , 1.96803661784e-10 ,
 1.0860085489e-09  , 4.76176891962e-09 , 1.66330040413e-08 , 4.65549701388e-08 ,
 1.05625414529e-07 , 1.99895404873e-07 , 3.44518242924e-07 , 6.91365399852e-07 ,
 2.16534837463e-06 , 9.30754495982e-06 , 4.11577292173e-05 , 0.000163182312599 ,
 0.000548413852285 , 0.00151783275422  , 0.00340325454254  , 0.00612496496253  ,
 0.0088043932371   , 0.0100856679077   , 0.00920616112539  , 0.00671516240291  ,
 0.00395277925098  , 0.00194405898399  , 0.000929982702988 , 0.000704085818733 ,
 0.00103644942462  , 0.0017178582274   , 0.00240538562057  , 0.00267481391243  ,
 0.00233205785781  , 0.00158952047744  , 0.000849520694073 , 0.000369368856196 ,
 0.000172177839704 , 0.000175005460569 , 0.000299432749886 , 0.000476271581104 ,
 0.0006236193951   , 0.000693387135272 , 0.000826351279197 , 0.00166385228848  ,
 0.00487870108887  , 0.0135881070988   , 0.031381512914    , 0.0587480872089   ,
 0.0888154718772   , 0.108201757288    , 0.105941014393    , 0.0831741578794   ,
 0.0525226611535   , 0.0275239566556   , 0.0138986093278   , 0.00973891295052  ,
 0.0104842392378   , 0.0123917005906   , 0.0132245129189   , 0.0120248523177   ,
 0.00907866153099  , 0.00562699881545  , 0.00304269318835  , 0.00227835367251  ,
 0.00414723334915  , 0.00957666097674  , 0.0185882457531   , 0.0285822894635   ,
 0.0346511967926   , 0.0331471509347   , 0.0250484985053   , 0.0149663177747   ,
 0.00707401939005  , 0.00264525288396  , 0.000782308950506 , 0.000182980834221 ,
 3.91180318618e-05 , 1.79892097036e-05 , 8.25345808455e-05 , 0.000424281770834 ,
 0.00172112100638  , 0.00547273063022  , 0.0136561064962   , 0.0267788743633   ,
 0.041328061296    , 0.0502719269816   , 0.0482641005067   , 0.0366125197291   ,
 0.0219623631711   , 0.0104213411503   , 0.00391147544851  , 0.00116213962307  ,
 0.000280763546722 , 8.79372792604e-05 , 0.0001384706373   , 0.0003684059802   ,
 0.000827453331077 , 0.001508563198    , 0.00227662092703  , 0.00296316519814  ,
 0.00355768006582  , 0.00431988212559  , 0.00578650433094  , 0.00862297198882  ,
 0.0130067804143   , 0.0177486880846   , 0.0204848795806   , 0.0196946210212   ,
 0.0168649300892   , 0.016491609033    , 0.0239250808749   , 0.0427164688391   ,
 0.0726655835146   , 0.109249486349    , 0.144417949931    , 0.167954636492    ,
 0.170221712207    , 0.147847422328    , 0.108419556846    , 0.0669449238897   ,
 0.0356667834361   , 0.0177239693661   , 0.0094807206089   , 0.00606677445864  ,
 0.00433224047355  , 0.00297451202394  , 0.00177562499722  , 0.000900766241546 ,
 0.000502236110778 , 0.000715160325102 , 0.00183187413371  , 0.0042065852036   ,
 0.00766151423477  , 0.0109377607466   , 0.0122376874263   , 0.0108132466229   ,
 0.00786773967236  , 0.00562118830667  , 0.00563238963306  , 0.00789724132229  ,
 0.0109495204276   , 0.0127215962716   , 0.0119204027164   , 0.0089524703179   ,
 0.00542317420742  , 0.00275893750684  , 0.00140633296022  , 0.0010855935718   ,
 0.00143351096687  , 0.00245336508459  , 0.00466689801169  , 0.00875735744666  ,
 0.0144775488843   , 0.0197117848206   , 0.0214397945337   , 0.0183949096214   ,
 0.0123833575999   , 0.00652605849635  , 0.00269926546685  , 0.000934727866411 ,
 0.000530053249644 , 0.00113859321692  , 0.00304039048168  , 0.00663893000938  ,
 0.0114708584627   , 0.0156350235826   , 0.0167858705582   , 0.014173662617    ,
 0.00939893756958  , 0.00488812652256  , 0.0019913261853   , 0.000634770322145 ,
 0.000158187535192 , 3.07951003695e-05 , 4.68031759173e-06 , 5.55053062134e-07 ,
 5.13432317661e-08 , 3.70335596315e-09 , 2.0872664584e-10  , 1.08450029764e-11 ,
 7.06618927784e-12 , 4.23108465458e-11 , 3.23347116385e-10 , 2.19659453619e-09 ,
 1.20887882513e-08 , 5.30444170091e-08 , 1.85633160612e-07 , 5.20790329038e-07 ,
 1.18320728692e-06 , 2.22465908266e-06 , 3.65729857507e-06 , 6.06963925445e-06 ,
 1.3021131985e-05  , 3.92340049252e-05 , 0.000137175567875 , 0.000469373303598 ,
 0.00144349038873  , 0.00379969588656  , 0.00829565532457  , 0.014733408614    ,
 0.0210557177507   , 0.0240873446134   , 0.0220421750505   , 0.0162165128051   ,
 0.00974998480854  , 0.00498915059706  , 0.00236253965933  , 0.00118718607356  ,
 0.00076007834181  , 0.000696150009372 , 0.0007702294401   , 0.000797497884788 ,
 0.000682142290575 , 0.000465914285538 , 0.000265451050287 , 0.000179661826171 ,
 0.000273455440408 , 0.000605750248775 , 0.00119693149163  , 0.00192553251579  ,
 0.00249939539023  , 0.00265788426121  , 0.00257084981605  , 0.00330272880173  ,
 0.00732386159935  , 0.0186773737627   , 0.0413157643875   , 0.07455367345     ,
 0.108759772837    , 0.128061501767    , 0.121551218024    , 0.0930107469756   ,
 0.0580458188884   , 0.0316421269632   , 0.0193324615922   , 0.0181255003782   ,
 0.0220756493941   , 0.0261642204379   , 0.0272965153335   , 0.0243036667803   ,
 0.0180738821698   , 0.0110535035106   , 0.00571056012097  , 0.00340487659797  ,
 0.00477035634547  , 0.0104132765931   , 0.0200885623945   , 0.0308724533657   ,
 0.0374299936709   , 0.0358132015901   , 0.0270743326956   , 0.0161889228949   ,
 0.0076623553491   , 0.00287233217739  , 0.000853253069706 , 0.000201183048115 ,
 4.0576820335e-05  , 1.81872377895e-05 , 7.6195148755e-05  , 0.000387528379727 ,
 0.00156089500912  , 0.00492145407548  , 0.0121558932015   , 0.023549667817    ,
 0.0358329031116   , 0.0428859312595   , 0.0404325234772   , 0.0300709921623   ,
 0.0176647923077   , 0.00820460731912  , 0.0030165448116   , 0.000884406174652 ,
 0.000232240958337 , 0.000153587253383 , 0.000397734373282 , 0.00108864294399  ,
 0.00244751402751  , 0.00448765889134  , 0.00685596828819  , 0.00910009324589  ,
 0.0111739772839   , 0.0136912289088   , 0.0179088004178   , 0.0253805423134   ,
 0.036435532115    , 0.0479776844348   , 0.0540389474675   , 0.0508316480324   ,
 0.0416967242445   , 0.036122414949    , 0.0435131915359   , 0.0668864980408   ,
 0.100265296657    , 0.131370613666    , 0.148505987329    , 0.146465731576    ,
 0.127194475696    , 0.0970649027534   , 0.0643248879245   , 0.0365864792143   ,
 0.0179318371812   , 0.00791566064684  , 0.00352980349631  , 0.00184358032912  ,
 0.00114252007829  , 0.000730201074965 , 0.000429410208094 , 0.000265309550891 ,
 0.000383240550919 , 0.00117400024182  , 0.00341511633712  , 0.0079330729495   ,
 0.0144620748954   , 0.0206469408404   , 0.0231011295265   , 0.0204296044003   ,
 0.0149613569951   , 0.0110123160328   , 0.0116851749185   , 0.0170165852335   ,
 0.0239772795163   , 0.0281192902688   , 0.0265385242882   , 0.0200169970158   ,
 0.0120452897571   , 0.00579759699239  , 0.00229571947971  , 0.000934981710779 ,
 0.000921684050826 , 0.00221389924163  , 0.00568071152473  , 0.0123393038586   ,
 0.0216001702706   , 0.0299820095647   , 0.0327774712708   , 0.0281295800481   ,
 0.0189141130235   , 0.00995349893571  , 0.00411287944857  , 0.00143093850158  ,
 0.000845155832175 , 0.001868713391    , 0.0050036009414   , 0.0109274633914   ,
 0.0188808228802   , 0.0257349742922   , 0.0276292488878   , 0.0233296004069   ,
 0.0154704866123   , 0.00804577063808  , 0.00327768802191  , 0.00104482083192  ,
 0.00026037391219  , 5.06881958182e-05 , 7.7037207938e-06  , 9.13607733452e-07 ,
 8.45107355203e-08 , 6.09882470536e-09 , 3.55443384278e-10 , 5.45290907542e-11 ,
 1.17821649004e-10 , 4.82678770058e-10 , 3.00713614745e-09 , 1.94439361642e-08 ,
 1.06015531641e-07 , 4.64919218823e-07 , 1.63002673409e-06 , 4.58599849056e-06 ,
 1.04481853321e-05 , 1.96275494303e-05 , 3.16373466782e-05 , 4.8000696311e-05  ,
 8.14822209186e-05 , 0.000177980734241 , 0.000468297926437 , 0.00128661657833  ,
 0.00337971981646  , 0.00803492415895  , 0.0165334904787   , 0.0284539797146   ,
 0.0400596764106   , 0.0456097189617   , 0.0418989944826   , 0.0313447661344   ,
 0.0196708479579   , 0.0110279559015   , 0.00601395271519  , 0.00332025500323  ,
 0.0017808843922   , 0.000895726107852 , 0.000454122712566 , 0.000266992365375 ,
 0.000178682868664 , 0.000123641755232 , 0.000123190541086 , 0.000276635007986 ,
 0.000784590580233 , 0.0019220445294   , 0.00382171830408  , 0.00612044039028  ,
 0.00788578408993  , 0.00821695778199  , 0.00722341379008  , 0.0066405087196   ,
 0.00987876694528  , 0.021499875308    , 0.0449998794729   , 0.0782202867306   ,
 0.110105131864    , 0.125149574206    , 0.11490363437     , 0.085596994051    ,
 0.0532382692039   , 0.031588019517    , 0.0248906349214   , 0.0292124322922   ,
 0.0375700940211   , 0.0439065340908   , 0.0446220342205   , 0.0388246162176   ,
 0.0283947199245   , 0.0171442565466   , 0.00860138840665  , 0.00434616798264  ,
 0.00449753111615  , 0.00894845467979  , 0.0170771257113   , 0.026226971959    ,
 0.0318200440864   , 0.0304905778936   , 0.0231134911467   , 0.0138896455123   ,
 0.00663385039246  , 0.00252766037128  , 0.000773039392835 , 0.000191852903736 ,
 6.27364840913e-05 , 2.33709364145e-05 , 6.02013697784e-05 , 0.000294259034911 ,
 0.00117928531378  , 0.00370153066699  , 0.00909299426659  , 0.0175001274897   ,
 0.0264194325133   , 0.0313295193598   , 0.0292263921806   , 0.021481058167    ,
 0.0124595315515   , 0.00571599427325  , 0.00208810538118  , 0.000635311792267 ,
 0.000239408120932 , 0.000339818389553 , 0.000966968719601 , 0.00258592785218  ,
 0.00577277224694  , 0.0106409970713   , 0.0165100719086   , 0.0224748115118   ,
 0.0284337989348   , 0.0355142186894   , 0.0459987905913   , 0.0627276948404   ,
 0.086051429194    , 0.109314458898    , 0.120172944054    , 0.111092529259    ,
 0.0888667204815   , 0.0713702314172   , 0.07434968299     , 0.100176847783    ,
 0.13591915994     , 0.161426992342    , 0.162556175108    , 0.139439334035    ,
 0.103322695957    , 0.0669868743075   , 0.0381995162071   , 0.01909867541     ,
 0.0083437743149   , 0.00323975258972  , 0.00120280468229  , 0.000495853499443 ,
 0.000252622379247 , 0.000146692399424 , 9.45728841835e-05 , 0.000130924513211 ,
 0.00046354169968  , 0.00169977554173  , 0.00502850019855  , 0.0116970416195   ,
 0.0213261266177   , 0.0304483511762   , 0.0340801147588   , 0.0302009655197   ,
 0.0223510250558   , 0.0171112986442   , 0.0193293481849   , 0.0291280248656   ,
 0.041568190543    , 0.0491119831021   , 0.0466519187828   , 0.0354022617934   ,
 0.0214087393799   , 0.0103027220865   , 0.0039715623592   , 0.00137923133339  ,
 0.00104890875346  , 0.00263735951261  , 0.00711042586172  , 0.0156100248664   ,
 0.0272050518989   , 0.0374417456262   , 0.0405780271386   , 0.034557593091    ,
 0.0230879827426   , 0.0120872273044   , 0.00497563331781  , 0.00173598946763  ,
 0.00106748056523  , 0.00242642982159  , 0.00651355301663  , 0.014227192509    ,
 0.0245824031516   , 0.033506367791    , 0.0359726723109   , 0.0303746249147   ,
 0.0201422321827   , 0.0104754158252   , 0.00426747747597  , 0.00136033366717  ,
 0.000339001088032 , 6.5994912476e-05  , 1.0030074832e-05  , 1.18949955303e-06 ,
 1.10045117136e-07 , 8.0050556781e-09  , 7.00710509137e-10 , 7.80061145675e-10 ,
 1.95944200202e-09 , 5.53984913287e-09 , 2.42898491714e-08 , 1.38984439151e-07 ,
 7.37378912004e-07 , 3.21862238427e-06 , 1.12960750778e-05 , 3.18763185888e-05 ,
 7.2887535858e-05  , 0.000137188024578 , 0.000219370889351 , 0.000318349480981 ,
 0.000473349032987 , 0.000821454030181 , 0.00167413381883  , 0.00362278357767  ,
 0.00769662614659  , 0.0154424172436   , 0.0282698200478   , 0.045357263966    ,
 0.0615418248284   , 0.0690412043971   , 0.0636636705014   , 0.0490345986823   ,
 0.0331355079715   , 0.0213098294612   , 0.0138194551176   , 0.00874369272702  ,
 0.00495522785786  , 0.00235909176777  , 0.000922487197235 , 0.000304516168875 ,
 9.93482118646e-05 , 6.7491980601e-05  , 0.000182456423823 , 0.000651479973196 ,
 0.00197654690022  , 0.00485343538588  , 0.00959930729972  , 0.0152760236535   ,
 0.0195430993889   , 0.0201245262872   , 0.0169533956947   , 0.0129156385159   ,
 0.0127227206391   , 0.0211268250004   , 0.0405588930735   , 0.0677152400898   ,
 0.0920922908799   , 0.10112257859     , 0.0897969744501   , 0.0652383044749   ,
 0.0411342825066   , 0.0281567208254   , 0.028917778826    , 0.0390268993664   ,
 0.0510436011201   , 0.0584412267736   , 0.0577961644483   , 0.0490826957177   ,
 0.0352550145313   , 0.0210115444189   , 0.0103321475094   , 0.0046726624058   ,
 0.00354406157996  , 0.00610288029292  , 0.0114369594608   , 0.0175805612618   ,
 0.0214395670998   , 0.0207453067149   , 0.0160081777169   , 0.00993105323865  ,
 0.00501431403131  , 0.00209734897126  , 0.000743286443176 , 0.000228419143498 ,
 0.000174912075759 , 5.50613209319e-05 , 4.68841762528e-05 , 0.000182653660832 ,
 0.000723253075717 , 0.00226430596689  , 0.00554750950987  , 0.0106419849125   ,
 0.016003269847    , 0.0188902486703   , 0.0175299730527   , 0.0128146475462   ,
 0.00740662613366  , 0.00342418049909  , 0.00133281058158  , 0.000554192146443 ,
 0.000455266330452 , 0.000837638532068 , 0.00207211727677  , 0.00511108265396  ,
 0.0111159722455   , 0.0205292441406   , 0.032488172853    , 0.0457249162419   ,
 0.0601315948392   , 0.0772405021632   , 0.100112800137    , 0.132656538408    ,
 0.174681959007    , 0.214285012272    , 0.230395150878    , 0.210784024587    ,
 0.167306310144    , 0.128936475835    , 0.119378896897    , 0.140497922306    ,
 0.172634392458    , 0.189466125563    , 0.176521069169    , 0.138915842956    ,
 0.0932983155246   , 0.0542732569237   , 0.0276976508823   , 0.01246527283     ,
 0.00492958347659  , 0.00170643843391  , 0.000526946876774 , 0.000158318732508 ,
 5.55089277618e-05 , 2.69674996142e-05 , 2.98911091095e-05 , 0.000113582020798 ,
 0.000520500610814 , 0.00195697632575  , 0.00580051947398  , 0.0134932471359   ,
 0.0245987693059   , 0.0351207506553   , 0.0393263340092   , 0.034939684468    ,
 0.0261955948938   , 0.0209921095295   , 0.0253067518525   , 0.0393790529807   ,
 0.0568401164944   , 0.0676004153348   , 0.0645912210728   , 0.049299775273    ,
 0.0299852277327   , 0.0145113923939   , 0.00561854356519  , 0.00193414479232  ,
 0.00136748038207  , 0.00323118796817  , 0.00837640302242  , 0.0177387452893   ,
 0.0299173480659   , 0.0400059561826   , 0.04230234786     , 0.0352892642523   ,
 0.0231774754033   , 0.0119660919746   , 0.00487181086091  , 0.00169299229233  ,
 0.00107261062599  , 0.00249229346167  , 0.00670437620232  , 0.0146458445522   ,
 0.0253059510791   , 0.034492593581    , 0.0370314920602   , 0.0312686717554   ,
 0.0207350987329   , 0.0107837492606   , 0.00439308642695  , 0.00140037373469  ,
 0.000348979248127 , 6.7937408326e-05  , 1.03253066738e-05 , 1.22455308428e-06 ,
 1.13516691384e-07 , 9.29145199473e-09 , 4.53206292461e-09 , 1.19185074055e-08 ,
 2.87242881961e-08 , 6.45635944779e-08 , 1.87523561535e-07 , 8.35701266865e-07 ,
 4.12587292218e-06 , 1.77222124783e-05 , 6.20755801051e-05 , 0.000175581135938 ,
 0.000403058870437 , 0.000761220174174 , 0.00121439795784  , 0.00172172725889  ,
 0.00237184985624  , 0.00353643216094  , 0.0059308821562   , 0.0104940351913   ,
 0.0181476598579   , 0.029651963737    , 0.0453187224804   , 0.0636605033718   ,
 0.0796000681728   , 0.0859117595828   , 0.0791993595746   , 0.0639532926195   ,
 0.0483768077116   , 0.0367631169612   , 0.0278580371657   , 0.0194042028243   ,
 0.0114955422013   , 0.00554771966291  , 0.00214044481287  , 0.000657857880644 ,
 0.000173156284028 , 0.00010562818977  , 0.000350905698522 , 0.00130471995264  ,
 0.00395719876462  , 0.0096601414456   , 0.0189735855442   , 0.0299725205329   ,
 0.0380523013308   , 0.0388199311402   , 0.0320100203713   , 0.0222671896149   ,
 0.0161088774058   , 0.01841415815     , 0.0303815092357   , 0.0481979790434   ,
 0.0634053989976   , 0.0674232477929   , 0.0580367721705   , 0.0413625074447   ,
 0.0271765716085   , 0.0225979635379   , 0.028953887279    , 0.0420982556396   ,
 0.0550204987893   , 0.061626948752    , 0.0593355317041   , 0.0491665561648   ,
 0.0346555940989   , 0.0203846073778   , 0.00987905366958  , 0.00416744142245  ,
 0.00238940730599  , 0.00335337082721  , 0.00613229267912  , 0.00957066750224  ,
 0.0120675698717   , 0.0123860788318   , 0.0105489974628   , 0.00763196970832  ,
 0.00478706535037  , 0.00262500779544  , 0.00124988236564  , 0.000508783243028 ,
 0.000534631776676 , 0.000165034434016 , 5.75961489716e-05 , 9.66648866778e-05 ,
 0.000355693705695 , 0.0011089597933   , 0.00271320964361  , 0.00519701794028  ,
 0.00780154818796  , 0.00919246114113  , 0.00852362591091  , 0.00626018146013  ,
 0.00372622115488  , 0.00196055125086  , 0.00117443861456  , 0.00107678424524  ,
 0.00141305042557  , 0.00228637878576  , 0.00438647643308  , 0.00920525265429  ,
 0.0187294169383   , 0.0342432837009   , 0.0554143129212   , 0.081227988436    ,
 0.11164663007     , 0.147868523937    , 0.192384071532    , 0.248731440274    ,
 0.315019360776    , 0.373384095186    , 0.393958008442    , 0.360213992742    ,
 0.289176711935    , 0.220498379521    , 0.185919413658    , 0.188551938492    ,
 0.20543362722     , 0.207806820026    , 0.182641886781    , 0.138026310614    ,
 0.0910144219857   , 0.0535226067055   , 0.0284484060546   , 0.0135808928614   ,
 0.00568589895174  , 0.00202891462779  , 0.000604178079642 , 0.000149700570981 ,
 3.2335760364e-05  , 9.03889754818e-06 , 1.81410633709e-05 , 9.92204687022e-05 ,
 0.000472139797165 , 0.00177864460927  , 0.00526776099309  , 0.0122434552159   ,
 0.0223046766653   , 0.0318302080799   , 0.0356462428432   , 0.0317583702545   ,
 0.0241728072761   , 0.0203780710657   , 0.0262080330379   , 0.0419895130428   ,
 0.0612289087126   , 0.0732713825774   , 0.0704223203998   , 0.0540993041558   ,
 0.0331601743175   , 0.016219322383    , 0.00640911015945  , 0.00235987748857  ,
 0.00186603559001  , 0.00418154165001  , 0.0100349430511   , 0.0198993924869   ,
 0.0316476848831   , 0.0401157261499   , 0.0404134713187   , 0.0322908562154   ,
 0.0204243914087   , 0.0102098334282   , 0.0040450295696   , 0.00137480807668  ,
 0.000866176756658 , 0.00202481361433  , 0.00545194214859  , 0.0119107216696   ,
 0.0205801395164   , 0.0280512114181   , 0.0301159791537   , 0.0254293471636   ,
 0.0168628852659   , 0.00876991852962  , 0.0035726915746   , 0.00113885842408  ,
 0.000283808504601 , 5.52503429959e-05 , 8.39719238984e-06 , 9.96453155689e-07 ,
 9.54205884104e-08 , 2.12650561358e-08 , 5.25377645849e-08 , 1.49742770382e-07 ,
 3.49936167375e-07 , 7.03792554826e-07 , 1.48532658496e-06 , 4.56998038626e-06 ,
 1.91618992352e-05 , 7.86849094419e-05 , 0.000272740848623 , 0.000771166095374 ,
 0.00177593476422  , 0.00336705988152  , 0.00537434496979  , 0.00752406953044  ,
 0.00989802309562  , 0.0133514154404   , 0.0194138598948   , 0.0294507945761   ,
 0.0434556487411   , 0.0595865701801   , 0.0751671769527   , 0.0878061090416   ,
 0.0950022253094   , 0.0941261145647   , 0.0852641628887   , 0.0732308164175   ,
 0.0635349516253   , 0.0564316650924   , 0.0477185600313   , 0.035143396574    ,
 0.02132982432     , 0.0103968248069   , 0.00402500638918  , 0.00123389129349  ,
 0.00031704478715  , 0.000174200614962 , 0.000560366647417 , 0.00207496629427  ,
 0.00625642163867  , 0.0151649974187   , 0.0295520201591   , 0.0462946564493   ,
 0.0582711806347   , 0.0589036522297   , 0.0479066133137   , 0.0319028386502   ,
 0.0192699848886   , 0.0149834861977   , 0.0192023781547   , 0.0281325358707   ,
 0.0357373020172   , 0.036916225247    , 0.0309350231009   , 0.02185467783     ,
 0.0155057294107   , 0.0160238701159   , 0.023999064817    , 0.0361647617742   ,
 0.0469064807225   , 0.051459869528    , 0.048332569765    , 0.0391308780507   ,
 0.0271013474884   , 0.0157704632442   , 0.00758499097725  , 0.00308610300353  ,
 0.00143249472581  , 0.00158626168728  , 0.00291145287315  , 0.00500400604923  ,
 0.00738703310646  , 0.00945355806801  , 0.0105512201683   , 0.0101700341626   ,
 0.00830494151108  , 0.00564109448856  , 0.00314849071783  , 0.00143579761195  ,
 0.00140151741893  , 0.000443564407633 , 0.000120489624778 , 5.81846613738e-05 ,
 0.00014180527682  , 0.000431509839011 , 0.00105409439379  , 0.00201803381596  ,
 0.00302973496022  , 0.00358091939651  , 0.00337473227936  , 0.00265853202703  ,
 0.00203564767867  , 0.00196028236875  , 0.00247013457001  , 0.00337280230027  ,
 0.00462170340403  , 0.00657337402696  , 0.0102423321883   , 0.0177530609709   ,
 0.0323493899951   , 0.057129537608    , 0.0935501961575   , 0.141604378444    ,
 0.200785592518    , 0.270069244894    , 0.348737350432    , 0.43729919592     ,
 0.530632101043    , 0.606044909783    , 0.62828578013     , 0.578493364282    ,
 0.476198398653    , 0.366835159409    , 0.288933839371    , 0.251665536456    ,
 0.236311810966    , 0.216867558402    , 0.181805479873    , 0.137797461902    ,
 0.0965838471659   , 0.0637162507736   , 0.0389489784855   , 0.0211451344085   ,
 0.00975893539309  , 0.00371189786628  , 0.00114246342363  , 0.000281873749805 ,
 5.57658982691e-05 , 1.04655042891e-05 , 1.35213105952e-05 , 7.4404011826e-05  ,
 0.000352736921698 , 0.00132006726682  , 0.00388636228749  , 0.00898742136768  ,
 0.0163050997131   , 0.0231917680711   , 0.0259164590881   , 0.0231145656525   ,
 0.0178449417885   , 0.0157932781516   , 0.0215038358815   , 0.0353102336465   ,
 0.0519853257373   , 0.0626728857029   , 0.0607787118676   , 0.047282774612    ,
 0.0295462947816   , 0.0149398358818   , 0.00635526221889  , 0.00289269718663  ,
 0.00290346231259  , 0.005976100275    , 0.0128415860829   , 0.0234692557411   ,
 0.0348462710205   , 0.0414138316943   , 0.0391799220018   , 0.029445118423    ,
 0.0175641246395   , 0.00831256432154  , 0.00313145121688  , 0.00100724554881  ,
 0.00057811348468  , 0.00130237119066  , 0.00349890342166  , 0.00764331252202  ,
 0.013206584321    , 0.0180008811997   , 0.0193258733956   , 0.0163183916954   ,
 0.0108211652501   , 0.00562778774528  , 0.00229264970839  , 0.000730822734691 ,
 0.000182124531101 , 3.54555296405e-05 , 5.39005145003e-06 , 6.46126000229e-07 ,
 9.47101770752e-08 , 1.57388105955e-07 , 5.36069188363e-07 , 1.51238379081e-06 ,
 3.46220716465e-06 , 6.61304929924e-06 , 1.16838629415e-05 , 2.49577309625e-05 ,
 7.86581226076e-05 , 0.000289954095845 , 0.000973393356741 , 0.00273002929094  ,
 0.0062880297613   , 0.0119566288341   , 0.0191141620863   , 0.0265728275657   ,
 0.0339456085284   , 0.0427818407532   , 0.0559993740304   , 0.075424073985    ,
 0.0989808577352   , 0.120239573209    , 0.131923997466    , 0.130897615466    ,
 0.119666834884    , 0.103661739383    , 0.0886189932312   , 0.0793257202105   ,
 0.07672342194     , 0.0754083504251   , 0.0676108154766   , 0.0511428748666   ,
 0.0313978247329   , 0.0153842745663   , 0.00597254770203  , 0.001834212457    ,
 0.000468686610116 , 0.000234920670175 , 0.00071150668055  , 0.00261017252518  ,
 0.00781615779412  , 0.0187998599985   , 0.0363202724647   , 0.0563708646913   ,
 0.0702728188296   , 0.0703363005937   , 0.0565480592866   , 0.0367735242329   ,
 0.0202516689172   , 0.0116947991903   , 0.0105834047603   , 0.0134959844768   ,
 0.0163976953561   , 0.0164917805294   , 0.01352919441     , 0.0096147969706   ,
 0.00764370949057  , 0.00970849240355  , 0.0160583586445   , 0.0245883922323   ,
 0.0316153893175   , 0.0341159350834   , 0.0314652986187   , 0.0251229710536   ,
 0.0173298247951   , 0.0101796016218   , 0.0050115183198   , 0.00208505694133  ,
 0.000891426947803 , 0.000852970885209 , 0.00180203875809  , 0.00401623445203  ,
 0.00783496355459  , 0.0129052444677   , 0.0175908842841   , 0.0195735092242   ,
 0.0176454034655   , 0.0128533057674   , 0.00756976845451  , 0.00361301201476  ,
 0.00300690958145  , 0.000980164782209 , 0.000261143390599 , 6.60260865093e-05 ,
 5.19331413539e-05 , 0.000133813577099 , 0.000324350691142 , 0.000622204800715 ,
 0.000943261641283 , 0.00116027388528  , 0.00127272225251  , 0.00155605967615  ,
 0.00247375465681  , 0.00433050862962  , 0.00698757657499  , 0.0100738990619   ,
 0.0136147631996   , 0.0184660648905   , 0.0265364786891   , 0.0414436796367   ,
 0.0689784768244   , 0.115610133575    , 0.185484253539    , 0.278600815412    ,
 0.390784933993    , 0.514594729544    , 0.642323350659    , 0.768581257866    ,
 0.884097905677    , 0.964587642655    , 0.976009984057    , 0.900966823485    ,
 0.757861222563    , 0.591204382563    , 0.445127318183    , 0.341434316071    ,
 0.274311588783    , 0.224758306277    , 0.180831549591    , 0.142440031692    ,
 0.111101810698    , 0.0837521204865   , 0.0574056124459   , 0.0337111773111   ,
 0.0163213226591   , 0.00638147377286  , 0.00199398151014  , 0.000495308036705 ,
 9.76979557249e-05 , 1.65563410979e-05 , 1.16638054516e-05 , 5.6988486492e-05  ,
 0.000260961553263 , 0.000947316441799 , 0.00271465693783  , 0.00613252458704  ,
 0.0109063833016   , 0.0152566364956   , 0.0168175242882   , 0.0148418993466   ,
 0.0114053853811   , 0.0101946691358   , 0.014148571464    , 0.023541996764    ,
 0.0350683505198   , 0.0429687150654   , 0.0427498044629   , 0.0346627182284   ,
 0.0231705806505   , 0.0131324667714   , 0.00694153177658  , 0.00462611551699  ,
 0.00548227866977  , 0.00942997030189  , 0.0170983957981   , 0.0281168183088   ,
 0.038967816453    , 0.0438768019653   , 0.039482997468    , 0.0282145019325   ,
 0.0159840099871   , 0.0071825442524   , 0.00256980947503  , 0.000768576261235 ,
 0.000346899813442 , 0.000667857625579 , 0.00177054305908  , 0.00386503792283  ,
 0.00667800372361  , 0.00910225559459  , 0.00977224491336  , 0.00825149378964  ,
 0.0054717885938   , 0.00284572694644  , 0.00115929574834  , 0.000369550139522 ,
 9.20991973814e-05 , 1.79376067565e-05 , 2.74377953739e-06 , 3.91907338357e-07 ,
 3.42776060457e-07 , 1.296615092e-06   , 4.42793877671e-06 , 1.22794155344e-05 ,
 2.76362006066e-05 , 5.13549635862e-05 , 8.34464322521e-05 , 0.000139720046261 ,
 0.00031286430601  , 0.00093897208274  , 0.00291328896667  , 0.00795165093087  ,
 0.0181658326199   , 0.0345138762089   , 0.0552072140742   , 0.0764080366574   ,
 0.0956866482141   , 0.114943567636    , 0.139014906212    , 0.170274297312    ,
 0.203722390933    , 0.227464176672    , 0.229724026743    , 0.207614993197    ,
 0.169843381144    , 0.130734660431    , 0.101916933797    , 0.088119995648    ,
 0.0862125744437   , 0.0863787589657   , 0.0783027745006   , 0.0595188576998   ,
 0.036627040122    , 0.0179774124563   , 0.00699446387959  , 0.00215960937842  ,
 0.000560079718219 , 0.000265002220691 , 0.000725373296255 , 0.0026034284415   ,
 0.00772458335734  , 0.0184235222427   , 0.0352653261312   , 0.0541838011268   ,
 0.0668313804085   , 0.0661666325919   , 0.0525886411175   , 0.033646692389    ,
 0.0176769543869   , 0.00850538601361  , 0.00532810130083  , 0.00539020342098  ,
 0.00610418703096  , 0.00597137154204  , 0.00482459177273  , 0.00351231005532  ,
 0.00322501754139  , 0.00487428244646  , 0.00857038133765  , 0.0132412697134   ,
 0.0169954662104   , 0.0183617547455   , 0.0171903089484   , 0.0142949898662   ,
 0.0106298755867   , 0.0069811888481   , 0.00396951899018  , 0.00194000346362  ,
 0.000913204592396 , 0.000831751787154 , 0.00198619799854  , 0.00526311062919  ,
 0.011691113234    , 0.021020942753    , 0.0304088941495   , 0.0353490228929   ,
 0.0330508518819   , 0.0249104429513   , 0.0151778265915   , 0.00749640162375  ,
 0.00522783128729  , 0.00175061030827  , 0.000474962514705 , 0.000106757667318 ,
 2.91863162928e-05 , 3.60161485974e-05 , 8.29208508461e-05 , 0.000164417086177 ,
 0.000277140100219 , 0.000462477126379 , 0.000946251678132 , 0.00230139023627  ,
 0.00537293954429  , 0.0107321168325   , 0.0180698581437   , 0.026578717199    ,
 0.0364891611274   , 0.0503382448489   , 0.0732724573356   , 0.11350485613     ,
 0.182479038828    , 0.291705203851    , 0.446092431182    , 0.638808061431    ,
 0.851928870168    , 1.06250502089     , 1.25091239551     , 1.40500895389     ,
 1.51375681567     , 1.55763177795     , 1.513304864       , 1.372410385       ,
 1.15373249577     , 0.898761796397    , 0.656768331046    , 0.464471475006    ,
 0.331052649696    , 0.24399837665     , 0.188183166073    , 0.153820451509    ,
 0.130718268352    , 0.107124864953    , 0.0777175855011   , 0.0471497592298   ,
 0.0232271993039   , 0.00916220421308  , 0.00287454788291  , 0.000714913021047 ,
 0.000140893831648 , 2.36292956178e-05 , 1.47517961127e-05 , 6.64750654533e-05 ,
 0.000287201257352 , 0.000984664797522 , 0.00267037287033  , 0.00572854794483  ,
 0.00971764602589  , 0.0130294378473   , 0.0138209272334   , 0.0117161017477   ,
 0.0084211277757   , 0.00654120917552  , 0.00793881290135  , 0.0128297465852   ,
 0.0195937511831   , 0.0253658682125   , 0.0275884972329   , 0.0255270650036   ,
 0.0204523560584   , 0.0147019501547   , 0.0105936239463   , 0.00953015434448  ,
 0.0116156894769   , 0.0163417277126   , 0.0235884045569   , 0.0329384173526   ,
 0.0415685201981   , 0.0445311403119   , 0.0389688392348   , 0.0273668853949   ,
 0.0153338979293   , 0.00685720406524  , 0.00245847203812  , 0.000724225716228 ,
 0.000237665254561 , 0.000285191567879 , 0.000707544929604 , 0.00153813157923  ,
 0.00265691509252  , 0.00362137413184  , 0.00388792995155  , 0.00328289635164  ,
 0.00217698787925  , 0.00113221418362  , 0.00046128238493  , 0.000147102314833 ,
 3.67399082852e-05 , 7.26411784097e-06 , 1.29901513415e-06 , 7.12332915472e-07 ,
 2.2923001997e-06  , 8.8994073193e-06  , 2.95693614057e-05 , 8.04021648455e-05 ,
 0.000178020844102 , 0.000324777131193 , 0.000507271650592 , 0.000750237625521 ,
 0.00128141881338  , 0.0029167437958   , 0.00776458478393  , 0.0198259769588   ,
 0.0440663067325   , 0.0828565310565   , 0.132039256186    , 0.181885610807    ,
 0.224404544579    , 0.260067401295    , 0.295745442973    , 0.335046192286    ,
 0.370834293416    , 0.387538303181    , 0.371660209014    , 0.322363173907    ,
 0.253742776644    , 0.186379398653    , 0.135622416426    , 0.106206013374    ,
 0.0934184487091   , 0.0865774492584   , 0.0751518896459   , 0.0559426107075   ,
 0.0341156283675   , 0.0167040471408   , 0.0065332679656   , 0.00208076446696  ,
 0.000614440828509 , 0.000322763702056 , 0.000653359912545 , 0.00209650287087  ,
 0.00605961382933  , 0.0142880532072   , 0.0270761244339   , 0.0411577112003   ,
 0.0501860471998   , 0.049098902052    , 0.0385499033529   , 0.0243213451689   ,
 0.0124361396921   , 0.00542304286424  , 0.00252538382871  , 0.00184614110689  ,
 0.00184698704876  , 0.00174293369159  , 0.00139440568687  , 0.00106162765618  ,
 0.00114756006763  , 0.00199149286601  , 0.00365989779248  , 0.00578354998675  ,
 0.00773796710271  , 0.00915098709909  , 0.0100745290627   , 0.0105066899249   ,
 0.0100497698665   , 0.00837435861779  , 0.00584112143668  , 0.0033505807993   ,
 0.00167680159865  , 0.00123629438404  , 0.00258932707972  , 0.00701979718456  ,
 0.0161173473633   , 0.0298059889319   , 0.0442558050578   , 0.0528317789866   ,
 0.0508181548183   , 0.0394789660974   , 0.0248232382582   , 0.0126508548612   ,
 0.00733974124746  , 0.00252297769308  , 0.00070525964173  , 0.000163693162758 ,
 3.64695689508e-05 , 1.97297706565e-05 , 4.01252021679e-05 , 9.88312376076e-05 ,
 0.000241351781804 , 0.000636543423684 , 0.00181538625175  , 0.00500264159119  ,
 0.0120852489671   , 0.0246684229067   , 0.0428557077045   , 0.0659101323306   ,
 0.0956501612264   , 0.139882035167    , 0.213079739277    , 0.334954872478    ,
 0.527153603364    , 0.804827398719    , 1.16326859549     , 1.56928984586     ,
 1.96798937065     , 2.30331793357     , 2.53832464457     , 2.66019746574     ,
 2.66860369837     , 2.5634826746      , 2.34747473664     , 2.03608570551     ,
 1.66084725527     , 1.26656362694     , 0.904963494541    , 0.617386094038    ,
 0.416177311346    , 0.28774959134     , 0.212022871109    , 0.171696327919    ,
 0.148338946585    , 0.123961403783    , 0.0910608530996   , 0.0555705525895   ,
 0.0274242264759   , 0.0108117653336   , 0.00338551727076  , 0.000839595515486 ,
 0.000164985754118 , 2.85140083834e-05 , 2.35495720257e-05 , 0.000109656495237 ,
 0.000461095850786 , 0.00153319722688  , 0.00402598840297  , 0.0083564844261   ,
 0.0137188413065   , 0.0178181001261   , 0.01831428022     , 0.0149416714305   ,
 0.00987744894658  , 0.00593140622196  , 0.00473725291266  , 0.00649562329969  ,
 0.0106142901064   , 0.0161116739473   , 0.0215336008174   , 0.024932168291    ,
 0.0247931663687   , 0.021736662456    , 0.0188699278371   , 0.0193778510948   ,
 0.0236155477899   , 0.0292905634603   , 0.0344744733212   , 0.0390823683547   ,
 0.0427049693549   , 0.0427950025389   , 0.0370157885707   , 0.0265823936647   ,
 0.0155877282162   , 0.0074343989343   , 0.00288852391977  , 0.000920480421883 ,
 0.000259556158971 , 0.000129278471257 , 0.000228173354373 , 0.000481760995799 ,
 0.000830591118626 , 0.00113195996713  , 0.00121528497539  , 0.00102621144665  ,
 0.000680635145701 , 0.00035424736075  , 0.000144779537249 , 4.68395013125e-05 ,
 1.2594101654e-05  , 3.68610524511e-06 , 2.4651333704e-06  , 4.49938251136e-06 ,
 1.41452539193e-05 , 5.03762088113e-05 , 0.00016074330956  , 0.000426782487123 ,
 0.00092882617855  , 0.00166956597785  , 0.00255460636453  , 0.00357488161258  ,
 0.00524193273441  , 0.00933123638298  , 0.0200933350931   , 0.0452915715161   ,
 0.0944872088457   , 0.172338724328    , 0.270759649686    , 0.369664594222    ,
 0.449842852261    , 0.506345348687    , 0.547439219761    , 0.580307722321    ,
 0.599898211763    , 0.592191199383    , 0.546662595409    , 0.466162742407    ,
 0.367422595951    , 0.271999993478    , 0.194966164891    , 0.140794039527    ,
 0.106158958994    , 0.0833962663716   , 0.0642353922067   , 0.0446521144526   ,
 0.026334402952    , 0.0127940389539   , 0.00518472377486  , 0.00197618051714  ,
 0.000968761130959 , 0.000728584088978 , 0.000812319446625 , 0.00155337344401  ,
 0.0038670361341   , 0.00880695883866  , 0.0164568257923   , 0.0247265510127   ,
 0.0297879303061   , 0.0287738100264   , 0.0222971267113   , 0.0138737836623   ,
 0.00695914918941  , 0.00287944161471  , 0.00110757163718  , 0.000566740525433 ,
 0.000459622552035 , 0.000409009444128 , 0.000325083152459 , 0.000264850699558 ,
 0.000341083123719 , 0.00066871847888  , 0.00132334587126  , 0.00235424046013  ,
 0.00393114711306  , 0.00643428127566  , 0.0100248617389   , 0.0138331481202   ,
 0.0159560212671   , 0.0149220173523   , 0.0111665422751   , 0.00667056706656  ,
 0.00329438968464  , 0.00189383356093  , 0.0029847702676   , 0.00781701665807  ,
 0.0182136902242   , 0.0343968222822   , 0.0523140721507   , 0.0641486542069   ,
 0.0635217744548   , 0.050863375922    , 0.0329604454303   , 0.0172892740322   ,
 0.00835898210639  , 0.00299173167822  , 0.000901947179309 , 0.000247780647686 ,
 7.94399352944e-05 , 6.07587989783e-05 , 0.000126709423315 , 0.000325848298075 ,
 0.000806545316117 , 0.00196612789643  , 0.00490736799146  , 0.0121609969591   ,
 0.0279444076081   , 0.0569422780566   , 0.102435768553    , 0.167456115162    ,
 0.261189766347    , 0.406141834323    , 0.638395983369    , 0.998840833502    ,
 1.51861442474     , 2.20044619966     , 2.99875019293     , 3.81257858968     ,
 4.50924627791     , 4.97412432539     , 5.15325109886     , 5.05752932257     ,
 4.73336665128     , 4.23443613367     , 3.61653885466     , 2.94196311901     ,
 2.27443766344     , 1.66992521732     , 1.17067358015     , 0.796166772555    ,
 0.536852540668    , 0.365880841664    , 0.258595328984    , 0.196602010984    ,
 0.159964093922    , 0.12834299427     , 0.092021045121    , 0.0553061230239   ,
 0.0269945851438   , 0.010546745111    , 0.00327610210172  , 0.000806384936253 ,
 0.000157524104528 , 2.89318254382e-05 , 3.53553616506e-05 , 0.000172919328052 ,
 0.000723404764762 , 0.00238871099102  , 0.00622469159582  , 0.0128154515555   ,
 0.0208625982623   , 0.0268658748635   , 0.0273690438088   , 0.0220647527827   ,
 0.0141443763887   , 0.00747624167702  , 0.00406546502842  , 0.00412397488281  ,
 0.00748733090222  , 0.0140798026892   , 0.0227968397654   , 0.0304948751277   ,
 0.0336212007186   , 0.032026731622    , 0.030265489399    , 0.0333657558581   ,
 0.0412278114287   , 0.0485652989391   , 0.0508247021428   , 0.0486610728512   ,
 0.045448933722    , 0.0421047847502   , 0.0366293902554   , 0.0279418712405   ,
 0.0179030673001   , 0.00944142159865  , 0.0040597749966   , 0.00141607266388  ,
 0.000403154660715 , 0.00010908635597  , 6.99904632984e-05 , 0.000120167988042 ,
 0.000203942751451 , 0.000277694507762 , 0.000298268392467 , 0.000252318170938 ,
 0.000168497300872 , 9.00863989315e-05 , 4.09325624664e-05 , 1.92608322991e-05 ,
 1.30781734182e-05 , 1.35105487704e-05 , 1.79146999349e-05 , 3.09087485433e-05 ,
 7.71882016956e-05 , 0.00023985743913  , 0.000720005484068 , 0.00185207283343  ,
 0.00395184644025  , 0.00700813778953  , 0.0106011504115   , 0.0145140566495   ,
 0.0198896056345   , 0.0304364572047   , 0.0538380863277   , 0.102920933969    ,
 0.192898423435    , 0.330872752263    , 0.502952027156    , 0.673941465174    ,
 0.806460152131    , 0.883951017878    , 0.914645070509    , 0.914312231145    ,
 0.888818178313    , 0.833675454992    , 0.745495674039    , 0.630725705885    ,
 0.505075251676    , 0.385581819323    , 0.282725748092    , 0.199788258797    ,
 0.136664868659    , 0.0911846683945   , 0.059033749459    , 0.0359144030146   ,
 0.0196814713551   , 0.00963354732924  , 0.0047058170142   , 0.00303078058571  ,
 0.00269437283655  , 0.00246969845184  , 0.00203506497766  , 0.00177207022486  ,
 0.00238229006745  , 0.00446019018208  , 0.00796287593747  , 0.0117633718958   ,
 0.0139859439059   , 0.0133301672999   , 0.0101867436119   , 0.00624758986401  ,
 0.00308219876031  , 0.00123610257252  , 0.000426896296876 , 0.000161501686762 ,
 9.6666204772e-05  , 7.7351349131e-05  , 6.101309685e-05   , 5.48768389384e-05 ,
 8.74909264333e-05 , 0.000208472481294 , 0.000530324276027 , 0.00136095644244  ,
 0.00339414585281  , 0.00758707860806  , 0.0142059930295   , 0.0215060005329   ,
 0.0259433606408   , 0.0248124642629   , 0.0187899827425   , 0.011281565708    ,
 0.00547351380245  , 0.00262530844979  , 0.00290582570182  , 0.0070375749523   ,
 0.0165898981581   , 0.0320621797558   , 0.0500801868775   , 0.063204625803    ,
 0.0644810282766   , 0.0531825405528   , 0.0354593069664   , 0.0191196081163   ,
 0.00801673166456  , 0.00321944435451  , 0.00122654904199  , 0.00050424316318  ,
 0.000271494674662 , 0.000278452335642 , 0.000556287019275 , 0.00134747292183  ,
 0.00315920347129  , 0.00705901328663  , 0.015577520672    , 0.0342714006377   ,
 0.0728794494643   , 0.144519089489    , 0.263980659765    , 0.450439371091    ,
 0.738006924296    , 1.18585716187     , 1.87101859251     , 2.85750256608     ,
 4.15668811741     , 5.69877837508     , 7.32248863881     , 8.78960567793     ,
 9.84096719341     , 10.2883158509     , 10.0878527149     , 9.33776986845     ,
 8.2083278299      , 6.87185581544     , 5.47867305252     , 4.1600862318      ,
 3.02061635072     , 2.11895017054     , 1.45991174624     , 1.00458509289     ,
 0.693870205533    , 0.476905604438    , 0.326050233561    , 0.227795450229    ,
 0.166237562343    , 0.121725471189    , 0.0821150013995   , 0.0474671909176   ,
 0.0225580093718   , 0.00863704169352  , 0.00263879923337  , 0.000640295474298 ,
 0.000123759572327 , 2.49117099143e-05 , 4.42819997278e-05 , 0.000223836353564 ,
 0.000936034008486 , 0.00308711322832  , 0.00803388440873  , 0.0165164682799   ,
 0.0268472252958   , 0.0345195803641   , 0.0351096965499   , 0.0282442421037   ,
 0.0179991116052   , 0.00924498393847  , 0.0044171000513   , 0.00370913900997  ,
 0.00701751767073  , 0.0145556936406   , 0.0252618241218   , 0.0353147845389   ,
 0.0402029288515   , 0.0397345462308   , 0.0397459521976   , 0.0464293791636   ,
 0.0587178841908   , 0.0682556793182   , 0.068082401496    , 0.0598452815318   ,
 0.050738871323    , 0.0448374813257   , 0.0400082556265   , 0.0326426317826   ,
 0.0225975720655   , 0.0128043504303   , 0.00584875066398  , 0.00213854186367  ,
 0.00062407969146  , 0.000147919478631 , 3.68085824574e-05 , 2.65812634029e-05 ,
 3.98739917662e-05 , 5.41971177663e-05 , 5.94211435338e-05 , 5.37768302178e-05 ,
 4.44591880119e-05 , 4.11046571469e-05 , 4.73761231654e-05 , 5.97281964886e-05 ,
 7.41254260306e-05 , 9.26011926253e-05 , 0.000123887259288 , 0.000190835084587 ,
 0.000382168272876 , 0.00099082938097  , 0.00271071299874  , 0.00666158935541  ,
 0.0138618378813   , 0.0242461794017   , 0.0364576828959   , 0.0496902773702   ,
 0.0665921079931   , 0.0948217309601   , 0.147300635386    , 0.242374443515    ,
 0.399989186876    , 0.627846336799    , 0.903415579522    , 1.17166317869     ,
 1.36979990936     , 1.46228326246     , 1.45561263478     , 1.38189373521     ,
 1.2709331403      , 1.13735762704     , 0.987117281635    , 0.828051753456    ,
 0.671848342437    , 0.528031115373    , 0.399784372834    , 0.287548876426    ,
 0.193826946696    , 0.121838215782    , 0.0716095777161   , 0.0395331202957   ,
 0.0207884607355   , 0.011249514424    , 0.00774774534694  , 0.00753749798661  ,
 0.00809714446991  , 0.00768771253345  , 0.00599216734857  , 0.00388987178455  ,
 0.00248165605102  , 0.00231121561573  , 0.0032072406134   , 0.00446481770762  ,
 0.00520182862258  , 0.00488559991302  , 0.00367939151364  , 0.00222272199977  ,
 0.0010789735068   , 0.000423137231665 , 0.000137703551761 , 4.246816258e-05   ,
 1.79338110413e-05 , 1.19253168176e-05 , 9.28620639754e-06 , 1.00939912612e-05 ,
 2.43423235351e-05 , 9.07724195412e-05 , 0.000358212903219 , 0.00128987747952  ,
 0.00390868317902  , 0.00957224216031  , 0.0186348258005   , 0.0286776537625   ,
 0.0348448473365   , 0.0334392903844   , 0.0253654490378   , 0.0152301833602   ,
 0.00731120649692  , 0.00313889712996  , 0.00242568579268  , 0.00512927965348  ,
 0.012190693835    , 0.024181978242    , 0.0388885885152   , 0.0505741285778   ,
 0.0531488269131   , 0.0451214056959   , 0.0309844156196   , 0.0173130946214   ,
 0.00756120908501  , 0.00413833622489  , 0.00238365114031  , 0.00146322340708  ,
 0.00106895395838  , 0.00122537107162  , 0.00229552110207  , 0.00520049927648  ,
 0.0116890598762   , 0.0250013755937   , 0.0517779189348   , 0.105410845901    ,
 0.209198640942    , 0.397394110423    , 0.716262223346    , 1.23173005546     ,
 2.04420200976     , 3.29140654061     , 5.10885299117     , 7.54545814938     ,
 10.4845426126     , 13.6302086892     , 16.5624053824     , 18.8209117154     ,
 20.0061192135     , 19.9026843175     , 18.5725423958     , 16.3283699699     ,
 13.5901108329     , 10.739242831      , 8.06213365552     , 5.75922847967     ,
 3.9490910186      , 2.65211329997     , 1.79245509731     , 1.2395083032      ,
 0.867398508002    , 0.59635216106     , 0.395424969409    , 0.256069471255    ,
 0.166622625371    , 0.108469210208    , 0.0667496209284   , 0.0361853283648   ,
 0.0164304817766   , 0.00607695286082  , 0.00180528989847  , 0.000427798042042 ,
 8.1271055601e-05  , 1.84219743888e-05 , 4.47432605714e-05 , 0.00023056325823  ,
 0.000964341856967 , 0.00317984072615  , 0.00827333771754  , 0.0170046906633   ,
 0.0276341566301   , 0.0355237944979   , 0.0361280083853   , 0.0290760758359   ,
 0.0185742496319   , 0.00962729843439  , 0.00468803427922  , 0.0038460838525   ,
 0.0068735932427   , 0.0139593695406   , 0.0241698527149   , 0.0339355799426   ,
 0.0390564500823   , 0.0396610240227   , 0.0418198791377   , 0.051569067103    ,
 0.0668887354838   , 0.077866260168    , 0.0765904726624   , 0.0655435388075   ,
 0.0540891221081   , 0.0478363543085   , 0.0441557983832   , 0.0376772576577   ,
 0.0271569318844   , 0.015887749434    , 0.00743352466963  , 0.00276565023123  ,
 0.000816062577652 , 0.000191195716239 , 3.71376518835e-05 , 9.61153521348e-06 ,
 9.15166246299e-06 , 1.45919470973e-05 , 2.41320345507e-05 , 4.30875628653e-05 ,
 8.17825090964e-05 , 0.000148567717409 , 0.00023840922577  , 0.000332935411722 ,
 0.000422935419281 , 0.000531047760488 , 0.000704806279001 , 0.00102051329444  ,
 0.00173107209338  , 0.00367774889025  , 0.00883166155959  , 0.0202867599076   ,
 0.040773062398    , 0.0701670549439   , 0.105212252144    , 0.144209132119    ,
 0.193286029819    , 0.267442450293    , 0.386670255082    , 0.573287423922    ,
 0.847959027969    , 1.21427500717     , 1.6361480011      , 2.03271688594     ,
 2.30816103184     , 2.40096432507     , 2.31514467484     , 2.10839427757     ,
 1.84938837976     , 1.58304394103     , 1.32769474235     , 1.09122362251     ,
 0.880400771309    , 0.6974626131      , 0.53778805638     , 0.396484959449    ,
 0.274673615092    , 0.177291175953    , 0.107011586876    , 0.0614528409182   ,
 0.0349279421399   , 0.0217490793519   , 0.0176289514979   , 0.0186250976871   ,
 0.0203235605485   , 0.0192492022936   , 0.0148397401311   , 0.00917300533022  ,
 0.0046410980609   , 0.00219428396629  , 0.0014162515851   , 0.00143498102042  ,
 0.00154807167798  , 0.00141914292335  , 0.00105155800509  , 0.000625338482834 ,
 0.000298654889625 , 0.00011494171466  , 3.61177495196e-05 , 9.89945035839e-06 ,
 3.06945908568e-06 , 1.54915827108e-06 , 1.22630750265e-06 , 2.33172261561e-06 ,
 1.15979190941e-05 , 6.5969404661e-05  , 0.000323702639038 , 0.0012866818701   ,
 0.00406013824317  , 0.0101026259023   , 0.0197906133249   , 0.030533286944    ,
 0.0371394779299   , 0.0356589316568   , 0.0270549042683   , 0.0162392648909   ,
 0.0077523926603   , 0.00312792690343  , 0.0017711520268   , 0.00305393905312  ,
 0.00725652821131  , 0.0148028445944   , 0.0245444929165   , 0.0329047987566   ,
 0.0356456642606   , 0.0312946194917   , 0.0225259063744   , 0.0137207010529   ,
 0.00952362937559  , 0.00767895312334  , 0.00593852683796  , 0.00451449255089  ,
 0.00396426218585  , 0.00496892307258  , 0.0089265671364   , 0.0189248778516   ,
 0.0405897722004   , 0.0836244678934   , 0.165924375133    , 0.320578239551    ,
 0.602796560167    , 1.09495682646     , 1.91529609847     , 3.23654089644     ,
 5.29967569147     , 8.37671621543     , 12.6417078141     , 17.9860857164     ,
 23.9096383861     , 29.6039115682     , 34.1882223446     , 36.9362520367     ,
 37.4090917538     , 35.5464725682     , 31.722783051      , 26.6602153891     ,
 21.1789230821     , 15.9504895107     , 11.4059028285     , 7.76796397208     ,
 5.0945264422      , 3.29569504379     , 2.16825911473     , 1.47194947518     ,
 1.01217688831     , 0.679478858541    , 0.433895311784    , 0.263826300073    ,
 0.156030374414    , 0.0906898186183   , 0.0502931428451   , 0.0251260969591   ,
 0.0107273342325   , 0.00378266106372  , 0.00108155077517  , 0.000248564976954 ,
 4.63216804477e-05 , 1.19481376497e-05 , 3.61118772894e-05 , 0.000187894812558 ,
 0.000785898492647 , 0.00259113365247  , 0.0067409607966   , 0.0138540182001   ,
 0.022513271229    , 0.028944443922    , 0.0294597086597   , 0.0237954834008   ,
 0.015443473138    , 0.00853280497321  , 0.0050025521532   , 0.00468450535678  ,
 0.00707067778801  , 0.0121722097444   , 0.0194492878409   , 0.0264971174651   ,
 0.030416228172    , 0.0316336825567   , 0.0351453565973   , 0.0455797841883   ,
 0.0605306586067   , 0.0708853437787   , 0.0696938009688   , 0.0596765484919   ,
 0.0498270140039   , 0.0453238688709   , 0.0432079015      , 0.037804508147    ,
 0.0277231119681   , 0.0164115849089   , 0.00774170794911  , 0.00289709545961  ,
 0.00085910874995  , 0.000203366521793 , 4.1930359841e-05  , 1.49163571102e-05 ,
 2.08613647294e-05 , 4.40842073416e-05 , 9.43756973437e-05 , 0.0001978067305   ,
 0.000394749304767 , 0.00071411306697  , 0.00112843065606  , 0.00155739302979  ,
 0.0019680672803   , 0.00247271350387  , 0.00327950533281  , 0.00461458988567  ,
 0.00704863283933  , 0.0125454912114   , 0.0257570332708   , 0.0538479637722   ,
 0.10302140878     , 0.173431296115    , 0.259379990757    , 0.359198383438    ,
 0.486095152786    , 0.666015166065    , 0.925330362369    , 1.28464108003     ,
 1.75803619852     , 2.33843156985     , 2.96893588665     , 3.53340083754     ,
 3.89345928867     , 3.95647647074     , 3.72624716915     , 3.29570348111     ,
 2.7864318885      , 2.28730254437     , 1.83860593038     , 1.45318071551     ,
 1.1349470342      , 0.879746936348    , 0.674388667376    , 0.504554239623    ,
 0.362880620146    , 0.248857366226    , 0.163356020326    , 0.104159740025    ,
 0.0662047290795   , 0.0449001051384   , 0.0370646722281   , 0.0381115856072   ,
 0.0406500931284   , 0.0380703028997   , 0.0291584862502   , 0.0178553572928   ,
 0.00870660397515  , 0.00343818966841  , 0.00121868785566  , 0.000547719115142 ,
 0.000399118243311 , 0.000331521681241 , 0.000239017021798 , 0.00014018652204  ,
 6.64550752119e-05 , 2.56655475179e-05 , 8.24509948649e-06 , 2.32896851308e-06 ,
 6.79255989664e-07 , 2.88554436924e-07 , 2.93624867685e-07 , 1.17093281341e-06 ,
 8.1321684878e-06  , 5.16402023616e-05 , 0.000264534649532 , 0.0010693488623   ,
 0.0033961753779   , 0.00847134359468  , 0.0166107950519   , 0.025637132137    ,
 0.0311889555941   , 0.0299477493568   , 0.0227222032251   , 0.0136360099127   ,
 0.00649210779887  , 0.00253570926349  , 0.00114028447331  , 0.00151065643626  ,
 0.00352413940347  , 0.00738590061911  , 0.0126326980636   , 0.0175045677662   ,
 0.0197585251782   , 0.0185491611001   , 0.0152325791537   , 0.0119141771337   ,
 0.016324317343    , 0.0161510943007   , 0.0144109034541   , 0.0127893324387   ,
 0.0133732903817   , 0.0185107943467   , 0.0327432099497   , 0.0654908755796   ,
 0.133159733819    , 0.26233669858     , 0.498058635324    , 0.917618328575    ,
 1.6440049464      , 2.8572447275      , 4.81573470273     , 7.88940820878     ,
 12.5513301534     , 19.2323700688     , 28.0135597885     , 38.3080773898     ,
 48.801934459      , 57.7988091225     , 63.791748949      , 65.8866110385     ,
 63.8972858843     , 58.2721548923     , 50.0064347821     , 40.4469247807     ,
 30.9260626959     , 22.4232901831     , 15.458516519      , 10.1768962622     ,
 6.46782288808     , 4.05259493043     , 2.56832282043     , 1.66557065758     ,
 1.0877162027      , 0.692592907288    , 0.419254581685    , 0.239994463591    ,
 0.13147648021     , 0.069671779196    , 0.0351887854514   , 0.0162384534487   ,
 0.00653120123595  , 0.00221428507718  , 0.000622779809692 , 0.000145078515127 ,
 2.86021832885e-05 , 8.04651128303e-06 , 2.35450280019e-05 , 0.000121487252233 ,
 0.000507250301031 , 0.00167061579935  , 0.0043427344276   , 0.00892018302713  ,
 0.0144918576935   , 0.0186410567225   , 0.019038205383    , 0.015622477993    ,
 0.010827666104    , 0.0074712875101   , 0.0066733366787   , 0.00773132223113  ,
 0.00954818243622  , 0.0118433440253   , 0.0147808449931   , 0.0177140190208   ,
 0.01943470779     , 0.0204097299259   , 0.0237466864909   , 0.0321367686808   ,
 0.0434853264474   , 0.0512268831833   , 0.05058238407     , 0.0438197982356   ,
 0.0376074379815   , 0.0354986031909   , 0.034803800661    , 0.0309200512947   ,
 0.0228543497471   , 0.0135900732739   , 0.00643007858107  , 0.002415150762    ,
 0.000726877127969 , 0.000189999736936 , 6.83011351188e-05 , 6.78561796262e-05 ,
 0.000119482338593 , 0.000237077564734 , 0.000470173991604 , 0.000909354838053 ,
 0.00168742095997  , 0.00289349759783  , 0.00442157972501  , 0.00599399441326  ,
 0.00752311367323  , 0.00945333615989  , 0.0125507075966   , 0.0174344238986   ,
 0.0250889351552   , 0.0391864755156   , 0.0689168397282   , 0.128466184847    ,
 0.230105114654    , 0.375515428585    , 0.557889707768    , 0.779291885383    ,
 1.0649363837      , 1.45246145188     , 1.96739057545     , 2.61703256568     ,
 3.40028982219     , 4.29452286399     , 5.21372023968     , 5.99120224081     ,
 6.43178268223     , 6.40873798437     , 5.93404986278     , 5.14816334402     ,
 4.23855184146     , 3.35413435007     , 2.57522801575     , 1.93285141911     ,
 1.43212152766     , 1.05992188569     , 0.789564900254    , 0.591114064252    ,
 0.440974954705    , 0.3249799364      , 0.235589400042    , 0.167390138701    ,
 0.116302911561    , 0.0818152447484   , 0.0651801781891   , 0.0629134071243   ,
 0.0645393048758   , 0.0594391448926   , 0.0451806582918   , 0.0275267673809   ,
 0.0133214722634   , 0.00511559177993  , 0.0015787704178   , 0.000423998824212 ,
 0.000135122043185 , 7.24444895174e-05 , 4.99709128109e-05 , 3.35630518819e-05 ,
 2.13365523087e-05 , 1.30814991555e-05 , 7.5798692851e-06  , 4.02709214234e-06 ,
 2.04428538185e-06 , 1.23860955672e-06 , 1.22817350501e-06 , 2.1105416242e-06  ,
 7.00322029517e-06 , 3.56721459119e-05 , 0.000175649941936 , 0.000706067855486 ,
 0.00224135087007  , 0.00559137042084  , 0.0109646972505   , 0.0169237200909   ,
 0.0205890678455   , 0.0197699705209   , 0.0150004335679   , 0.00900287887031  ,
 0.00428602206714  , 0.00165959484607  , 0.000665944444964 , 0.000677552388747 ,
 0.00146360544464  , 0.00307700822024  , 0.005402890639    , 0.00786592398015  ,
 0.00979089984744  , 0.0111790764036   , 0.0127462010438   , 0.0147801466764   ,
 0.0283893663792   , 0.0310712706987   , 0.0314054304072   , 0.033247624636    ,
 0.041618256088    , 0.0633724495409   , 0.111922604138    , 0.213212331135    ,
 0.409983880861    , 0.767212591601    , 1.38646403609     , 2.43036787565     ,
 4.14596580512     , 6.88313373587     , 11.1271186205     , 17.5342518597     ,
 26.8524513352     , 39.5717642097     , 55.3578018687     , 72.6427238929     ,
 88.802396179      , 100.976509509     , 107.078734196     , 106.372570563     ,
 99.3888190328     , 87.5259220869     , 72.7039149916     , 57.0298450581     ,
 42.3511440821     , 29.8777061947     , 20.1006846254     , 12.9609410902     ,
 8.07763533819     , 4.93178484633     , 2.99600786709     , 1.82469071422     ,
 1.10383111013     , 0.6494673018      , 0.36528533203     , 0.195776794319    ,
 0.100950595177    , 0.0505331608159   , 0.0243456359252   , 0.0109835608587   ,
 0.0045127935689   , 0.00166731949539  , 0.000553772387247 , 0.000164826101604 ,
 4.35732805139e-05 , 1.19239940688e-05 , 1.47269564303e-05 , 6.59713551385e-05 ,
 0.000269426255424 , 0.000876191196883 , 0.00225650717051  , 0.00460331586031  ,
 0.0074456476099   , 0.00957540385139  , 0.00990802688688  , 0.00866428788023  ,
 0.00750664014587  , 0.00823111351453  , 0.0111344820295   , 0.0145714885506   ,
 0.0163402475812   , 0.0157318616383   , 0.0139406596846   , 0.0124005756447   ,
 0.0115259669136   , 0.0115378476721   , 0.0135521168651   , 0.018529873236    ,
 0.0250699011308   , 0.0294913619807   , 0.0292259258872   , 0.0257156061512   ,
 0.0228065360959   , 0.0223463724765   , 0.0224284288359   , 0.0201323245833   ,
 0.0149437581953   , 0.00890665017038  , 0.00423158944169  , 0.00162495429605  ,
 0.000561761464107 , 0.000271456121639 , 0.000267442093178 , 0.000373784238761 ,
 0.000608439224092 , 0.00108893590228  , 0.00198624307633  , 0.0035499751095   ,
 0.00612099035908  , 0.00990414478688  , 0.0145648974068   , 0.0193362902135   ,
 0.0240660833014   , 0.0301673344353   , 0.0399558456215   , 0.0549902587514   ,
 0.0764349470499   , 0.109552570043    , 0.16956943528     , 0.281027524694    ,
 0.465729030066    , 0.729459211492    , 1.06786110168     , 1.492685823       ,
 2.0455099734      , 2.77142346015     , 3.68116205896     , 4.75400423096     ,
 5.96797731827     , 7.2851701221      , 8.58228978389     , 9.61970233288     ,
 10.1232542347     , 9.92912206388     , 9.07381849904     , 7.76579593749     ,
 6.27492672662     , 4.82752631771     , 3.56414057771     , 2.54866065617     ,
 1.78916812608     , 1.25549378888     , 0.897973821665    , 0.664757226562    ,
 0.511478249696    , 0.404583915104    , 0.321313142909    , 0.248240894413    ,
 0.181673963733    , 0.127778051943    , 0.0953751535731   , 0.0841704519716   ,
 0.081643096692    , 0.0734227425848   , 0.0552538645422   , 0.0334810420715   ,
 0.0161329055241   , 0.00615656760291  , 0.00186104085332  , 0.00045295967656  ,
 0.000103063300676 , 4.56300729463e-05 , 5.20870638149e-05 , 6.66774913632e-05 ,
 7.2333355698e-05  , 6.38316427338e-05 , 4.59282484735e-05 , 2.78933461375e-05 ,
 1.59244517e-05    , 1.09106288868e-05 , 1.10501292047e-05 , 1.43631086589e-05 ,
 2.02140279744e-05 , 3.64289399246e-05 , 0.000107050252091 , 0.000377540861593 ,
 0.00116838759208  , 0.00290083262144  , 0.00568324202174  , 0.00877019833954  ,
 0.0106692133388   , 0.0102451251508   , 0.0077758830714   , 0.00467629533964  ,
 0.00225498097877  , 0.000940543601171 , 0.000487264621288 , 0.000519056068982 ,
 0.000827339184038 , 0.00138522709927  , 0.00224664258157  , 0.00352322715541  ,
 0.00559574406693  , 0.00927600148497  , 0.0151773049883   , 0.0224056197282   ,
 0.0436393273013   , 0.0532927938588   , 0.0636591497118   , 0.0824641749911   ,
 0.121317504435    , 0.199051713014    , 0.351225289169    , 0.640983646955    ,
 1.16600406585     , 2.06568417547     , 3.54161023937     , 5.89427490716     ,
 9.55750972452     , 15.1202646969     , 23.3549353875     , 35.2159337788     ,
 51.6152002013     , 72.791235059      , 97.4948127234     , 122.660003976     ,
 144.070370775     , 157.793511313     , 161.55679283      , 155.28928227      ,
 140.702318422     , 120.466690081     , 97.5602234396     , 74.8118151982     ,
 54.4513163319     , 37.7672211189     , 25.0851288005     , 16.0362109269     ,
 9.91404321879     , 5.95699851955     , 3.49771918995     , 2.01264656595     ,
 1.12982563649     , 0.612649405683    , 0.319797698226    , 0.162967528301    ,
 0.0833075748753   , 0.0434830154665   , 0.022990273073    , 0.0120481284442   ,
 0.00612276667425  , 0.00292752632849  , 0.00125933884103  , 0.000466111653208 ,
 0.000145437469254 , 4.10122462678e-05 , 2.04630963172e-05 , 4.88567170706e-05 ,
 0.000168500836497 , 0.000494536052385 , 0.00117383311674  , 0.00224281487482  ,
 0.00345305598414  , 0.00432595937041  , 0.00461731713553  , 0.00490812349742  ,
 0.00666041595846  , 0.0112534428907   , 0.018314241921    , 0.0248902852588   ,
 0.0272035104597   , 0.02402369235     , 0.0178462375924   , 0.0123062513812   ,
 0.00915274316682  , 0.00810129022156  , 0.00853812259741  , 0.0102295659083   ,
 0.0125413639626   , 0.0140608123174   , 0.0137681352269   , 0.0122921052792   ,
 0.0112639415739   , 0.0113646975498   , 0.0115550133498   , 0.0104042837135   ,
 0.00772955866872  , 0.00463182632105  , 0.00228364945728  , 0.0010866655378   ,
 0.000795074463601 , 0.000987801865055 , 0.00135611331027  , 0.00182922142671  ,
 0.0026328559923   , 0.00421241948052  , 0.00707726092987  , 0.0118017638677   ,
 0.0190711193534   , 0.0291997159203   , 0.0412769185352   , 0.0535498210308   ,
 0.0659031839399   , 0.0819696513065   , 0.107473585335    , 0.145918729082    ,
 0.197773440227    , 0.268009632518    , 0.377592611324    , 0.564273198139    ,
 0.863772957215    , 1.28958020034     , 1.84302527272     , 2.54914876533     ,
 3.46660426121     , 4.64138491041     , 6.05729515054     , 7.65655941796     ,
 9.39707977078     , 11.2301021006     , 12.9876482676     , 14.3318669862     ,
 14.8817876802     , 14.4286078477     , 13.051110185      , 11.0548634276     ,
 8.81769148174     , 6.66173546064     , 4.79979340163     , 3.33191662063     ,
 2.26254142464     , 1.53301703057     , 1.06244348396     , 0.775430145845    ,
 0.608007893218    , 0.505536417568    , 0.425197796744    , 0.342039717677    ,
 0.25293905196     , 0.172492354561    , 0.117959107692    , 0.0925938801478   ,
 0.0829238417192   , 0.072018633701    , 0.0534482161389   , 0.0321699446038   ,
 0.0154346002218   , 0.00587130461306  , 0.00177328777763  , 0.0004444001802   ,
 0.00014395223034  , 0.000153619638028 , 0.000251685517052 , 0.000353136868434 ,
 0.000397140638582 , 0.000358592690845 , 0.000264994522259 , 0.000168715822911 ,
 0.000105133076835 , 8.0130617794e-05  , 8.42922641789e-05 , 0.000105504043583 ,
 0.000129833687386 , 0.0001448567263   , 0.000159804990758 , 0.000239447769357 ,
 0.000528487442047 , 0.00120918483454  , 0.00232768319639  , 0.00357734157297  ,
 0.00434744081115  , 0.00417552063927  , 0.00317957626429  , 0.00195224594272  ,
 0.00106388568381  , 0.000739804222947 , 0.000893564643276 , 0.00127847118931  ,
 0.00161893952002  , 0.00177168899887  , 0.00189410831116  , 0.00256315325842  ,
 0.00487809089524  , 0.0103103153761   , 0.0197107680277   , 0.0318481809139   ,
 0.0611859292525   , 0.0879980655457   , 0.129122705455    , 0.201443423686    ,
 0.332938970412    , 0.571494907561    , 1.00016498536     , 1.75202064066     ,
 3.01818833361     , 5.05520485453     , 8.20912418084     , 12.9596420454     ,
 19.9582780936     , 30.0414300641     , 44.2253078379     , 63.608414713      ,
 88.9385941803     , 119.715132455     , 153.294015248     , 184.906546066     ,
 208.986000815     , 221.126546004     , 219.534207443     , 205.279724316     ,
 181.468735447     , 152.042439107     , 120.880948861     , 91.2963848407     ,
 65.6673185588     , 45.1913750623     , 29.9298395181     , 19.1655855771     ,
 11.881713454      , 7.122340248       , 4.12619080083     , 2.31311466991     ,
 1.25452079195     , 0.658223189405    , 0.338851976984    , 0.178424219312    ,
 0.100880373013    , 0.0615756341426   , 0.0389697537144   , 0.0244551199075   ,
 0.0146077609242   , 0.00791225120635  , 0.0037021433007   , 0.00145215546674  ,
 0.000482957101527 , 0.000153144921438 , 7.38254380805e-05 , 0.00011119661521  ,
 0.000292585253219 , 0.000712913987689 , 0.00141406654995  , 0.00224998103654  ,
 0.00289248341558  , 0.00310180719631  , 0.00314096299997  , 0.00407010128736  ,
 0.00762651090478  , 0.0152192738697   , 0.025970701759    , 0.0355878571889   ,
 0.0387106127709   , 0.0336892688724   , 0.0243673539666   , 0.0163369964835   ,
 0.0121754856832   , 0.0107526594355   , 0.00995297306809  , 0.0089055190983   ,
 0.00787080829962  , 0.00709254877254  , 0.00643422355154  , 0.00583394876299  ,
 0.00547875716288  , 0.00539969348796  , 0.00521919652298  , 0.0045106666218   ,
 0.00330342239914  , 0.00209492687558  , 0.00144580936459  , 0.00166760194227  ,
 0.00275052402746  , 0.0043624700113   , 0.00600784953226  , 0.00754340085579  ,
 0.00968478858896  , 0.013835884231    , 0.0214196543447   , 0.0336443217122   ,
 0.051619997548    , 0.0754933026465   , 0.102965805812    , 0.130443946174    ,
 0.158058430427    , 0.193503997475    , 0.248559591661    , 0.330151629869    ,
 0.436491797526    , 0.567965182691    , 0.747771943783    , 1.02794428411     ,
 1.46303087682     , 2.0781459792      , 2.87994534993     , 3.9028345581      ,
 5.21747383303     , 6.86712370383     , 8.80893774887     , 10.9528287652     ,
 13.2429996332     , 15.6234478684     , 17.8782377113     , 19.5589241815     ,
 20.1589137421     , 19.4097683876     , 17.4352134321     , 14.6607447249     ,
 11.6016708377     , 8.69346495489     , 6.21868405951     , 4.29772483837     ,
 2.91465752301     , 1.97346133382     , 1.36296833932     , 0.991205325499    ,
 0.780727158361    , 0.657149397667    , 0.556637581463    , 0.443846566161    ,
 0.3190562763      , 0.205803169458    , 0.1268826797      , 0.0861111130435   ,
 0.0687492075665   , 0.0565524754771   , 0.0411058940291   , 0.0245416618461   ,
 0.0117454519416   , 0.00448698616144  , 0.00140133040118  , 0.000451200423573 ,
 0.000365322734514 , 0.000649018871612 , 0.00111762221845  , 0.001572817386    ,
 0.00177858045611  , 0.00162783580392  , 0.00123783192625  , 0.000835193353725 ,
 0.000574979527753 , 0.000484288016477 , 0.000522904250008 , 0.000636952605891 ,
 0.000756824158656 , 0.000799864313504 , 0.000724432025398 , 0.000581782394492 ,
 0.000496213302505 , 0.000586586503737 , 0.000879349213661 , 0.00125461478224  ,
 0.00149101313217  , 0.00143026648849  , 0.0011264502535   , 0.000827319595441 ,
 0.00083638497496  , 0.00138548515059  , 0.00249626540139  , 0.00381935755673  ,
 0.00470348475829  , 0.00468116183584  , 0.00401564851474  , 0.00381810712802  ,
 0.00580849212889  , 0.0119271562337   , 0.0235009596177   , 0.0402696924521   ,
 0.0913524673787   , 0.158846938969    , 0.278049481256    , 0.48900781615     ,
 0.858119709299    , 1.49441561173     , 2.56671101854     , 4.31346797089     ,
 7.045108861       , 11.1522172199     , 17.1349872935     , 25.6452654724     ,
 37.507263824      , 53.6971993089     , 75.2720284999     , 103.134315279     ,
 137.398903495     , 176.380623181     , 215.904091984     , 249.887166558     ,
 272.253173599     , 279.055773762     , 269.620467744     , 246.346967502     ,
 213.553678758     , 176.076740845     , 138.267944336     , 103.532299847     ,
 74.1183831607     , 50.9942138997     , 33.9367750244     , 21.9376284433     ,
 13.7611366037     , 8.34353873263     , 4.88501706009     , 2.77419454444     ,
 1.5380552249      , 0.840431133502    , 0.464295527506    , 0.271457730777    ,
 0.173108937428    , 0.11777700216     , 0.0814851725483   , 0.0550062482936   ,
 0.0347389429809   , 0.0195452014838   , 0.00940139378378  , 0.00382163044444  ,
 0.00138509882443  , 0.000535637083392 , 0.00030727330012  , 0.00038332708739  ,
 0.000844727950692 , 0.00189362255814  , 0.00351794440611  , 0.00520132366779  ,
 0.00609686926777  , 0.00577537264352  , 0.00491069119551  , 0.00529774270369  ,
 0.00926084574107  , 0.0183783166189   , 0.0313666751317   , 0.0429385086826   ,
 0.0467052444094   , 0.0409198718624   , 0.0305336442444   , 0.0224251704959   ,
 0.019277015306    , 0.0186837320571   , 0.0171176992407   , 0.0135691925814   ,
 0.00957278614383  , 0.00688818564097  , 0.00587448953371  , 0.0057086125651   ,
 0.00544356887142  , 0.00469460564697  , 0.00361741883953  , 0.00254811371485  ,
 0.00178701382662  , 0.00166071054559  , 0.00267867534374  , 0.00548838148076  ,
 0.0103556920728   , 0.0164289311139   , 0.0219297849932   , 0.025957469836    ,
 0.0303041285868   , 0.0389047180855   , 0.0555507421155   , 0.0828228789408   ,
 0.122310157539    , 0.173122827991    , 0.229618351649    , 0.284405784986    ,
 0.33766862705     , 0.403303679528    , 0.502392709576    , 0.647264375983    ,
 0.832015982228    , 1.04614993548     , 1.30797599113     , 1.68154974219     ,
 2.24413659846     , 3.03658060301     , 4.06806987572     , 5.37232633117     ,
 7.02190487842     , 9.05618793768     , 11.4168310604     , 13.9973155101     ,
 16.7365274103     , 19.5723882461     , 22.2497545179     , 24.2303609811     ,
 24.8951580263     , 23.9044873112     , 21.4043939176     , 17.9333227418     ,
 14.1537732365     , 10.6167136105     , 7.65505050317     , 5.38091067252     ,
 3.74054507331     , 2.60203218962     , 1.83757284443     , 1.35265303455     ,
 1.0638760257      , 0.880187054749    , 0.721456397842    , 0.549600996385    ,
 0.373669264976    , 0.22463384423     , 0.124390707172    , 0.0716786381436   ,
 0.0487131459189   , 0.0366561503143   , 0.0258226071145   , 0.0154019321287   ,
 0.00755029100812  , 0.00310751471947  , 0.00124671040912  , 0.000832467482419 ,
 0.0012605517619   , 0.00239051792906  , 0.00404934034848  , 0.00565900280516  ,
 0.00642640430976  , 0.00598182842232  , 0.00472237072419  , 0.00342625714382  ,
 0.00262853854731  , 0.00241779444073  , 0.00264759655567  , 0.00312628177042  ,
 0.00359507503257  , 0.00372644157827  , 0.00333233042203  , 0.00255537973863  ,
 0.00175774921339  , 0.00123046517507  , 0.00103080343631  , 0.0010259090684   ,
 0.00103302526338  , 0.000955893490638 , 0.000856901267083 , 0.000960724439826 ,
 0.00164152385402  , 0.00333371376943  , 0.00615707113056  , 0.00937955584017  ,
 0.0114893830546   , 0.0113371261039   , 0.00937170033693  , 0.00761642751316  ,
 0.0086337488868   , 0.0147951601105   , 0.0283104338608   , 0.0519668027903   ,
 0.175546787286    , 0.339211084141    , 0.63969282574     , 1.16782790106     ,
 2.06636473182     , 3.55178514143     , 5.91947908925     , 9.52483447357     ,
 14.7655623059     , 22.1025435812     , 32.1170975639     , 45.5497294007     ,
 63.2704854849     , 86.18441108       , 115.066957203     , 150.206216548     ,
 190.692216259     , 233.550215245     , 273.510502558     , 304.149563523     ,
 320.02904259      , 318.513011621     , 300.340195439     , 269.023253079     ,
 229.575350783     , 187.11138146      , 145.88055915      , 108.933899221     ,
 78.1173272359     , 54.0812609368     , 36.3840140568     , 23.8762804442     ,
 15.2579939552     , 9.46328044628     , 5.70843077451     , 3.38094579254     ,
 1.9892437586      , 1.1775957063      , 0.71647001991     , 0.459987346163    ,
 0.313580925548    , 0.221659351941    , 0.157300363677    , 0.108543453752    ,
 0.0698306964022   , 0.0399179937238   , 0.0196442340078   , 0.00846176236003  ,
 0.00356976325799  , 0.00179309555099  , 0.00120950604901  , 0.00128525163442  ,
 0.00230231676901  , 0.00472000349097  , 0.00842996626626  , 0.0121609785478   ,
 0.013945827801    , 0.012784983847    , 0.00991340735176  , 0.00832305812064  ,
 0.0112143029282   , 0.0203005077934   , 0.0338827870646   , 0.0460769632838   ,
 0.0501244770181   , 0.0444930985693   , 0.0348662535699   , 0.0286638024357   ,
 0.0280781809042   , 0.0292093088538   , 0.0272596383372   , 0.0214618040777   ,
 0.0149791426699   , 0.0111440530425   , 0.0105548211162   , 0.0112893400185   ,
 0.0110803758138   , 0.00916188860891  , 0.0064016725975   , 0.00413755818162  ,
 0.00325789524847  , 0.00440538944786  , 0.00876041183969  , 0.0180898240688   ,
 0.0330686685818   , 0.0509049356057   , 0.0658593782987   , 0.0744875000107   ,
 0.0807406566441   , 0.0943665389197   , 0.124635206843    , 0.177224133487    ,
 0.254543863266    , 0.352987171142    , 0.459397483743    , 0.557932971994    ,
 0.647025875179    , 0.749045963161    , 0.898805821229    , 1.11706458993     ,
 1.39216064555     , 1.69550084423     , 2.03079419033     , 2.46774972318     ,
 3.107001352       , 4.0096131554      , 5.18773620865     , 6.66640013984     ,
 8.50790653799     , 10.7420204489     , 13.3033374171     , 16.0852658991     ,
 19.0303796329     , 22.0746473041     , 24.9492360796     , 27.0829566136     ,
 27.798362789      , 26.6944225159     , 23.9061824252     , 20.0404708057     ,
 15.8682657462     , 12.0178904617     , 8.83465627267     , 6.39803356735     ,
 4.61553626585     , 3.33690472533     , 2.43937068971     , 1.83938792742     ,
 1.45179127625     , 1.17289678062     , 0.917322960526    , 0.657853275874    ,
 0.418738838381    , 0.2347950231      , 0.119133134275    , 0.0597368827139   ,
 0.0339820130786   , 0.0227658848589   , 0.0159122974451   , 0.0103896486952   ,
 0.00621988361895  , 0.00368443528195  , 0.00261426281126  , 0.00277891679988  ,
 0.00430511946292  , 0.00752482085869  , 0.0121742372354   , 0.0167257882045   ,
 0.0190309350376   , 0.0180876260871   , 0.0149852570791   , 0.0118570974833   ,
 0.010147901552    , 0.0100308422925   , 0.0110278828744   , 0.0125836160452   ,
 0.013964659068    , 0.0141964062999   , 0.0127024087216   , 0.00994397120832  ,
 0.00709109341002  , 0.00508291200015  , 0.00409845128949  , 0.00372899841039  ,
 0.00346202986708  , 0.00307243923272  , 0.00272680919417  , 0.00287109316512  ,
 0.00414762112695  , 0.0072874491885   , 0.0124975682676   , 0.0184640483713   ,
 0.0224271071076   , 0.0222794239873   , 0.0188496474664   , 0.0156937447272   ,
 0.0168809788843   , 0.0258517311618   , 0.0471113427208   , 0.0902902051675   ,
 0.426244872366    , 0.813902014713    , 1.50755694612     , 2.68719712592     ,
 4.61679771697     , 7.66341569143     , 12.264778788      , 18.8430273372     ,
 27.7502549299     , 39.3363327531     , 54.0915028943     , 72.7013478841     ,
 95.9305160749     , 124.400162775     , 158.311121243     , 197.039559717     ,
 238.562489175     , 279.002664584     , 312.935724786     , 334.803427249     ,
 340.778439719     , 329.926861296     , 304.21682367      , 267.738223428     ,
 225.532070564     , 182.341423628     , 141.774718374     , 106.152218988     ,
 76.7139787076     , 53.7627884029     , 36.7575545015     , 24.602435615      ,
 16.1063956975     , 10.304789325      , 6.48127810492     , 4.05929248519     ,
 2.56492036518     , 1.65159375313     , 1.09469922272     , 0.751405123355    ,
 0.530057953599    , 0.377549808464    , 0.266954385646    , 0.183316521476    ,
 0.117755690882    , 0.0678702720921   , 0.0346357828889   , 0.0166335294389   ,
 0.00879661438898  , 0.00569819259636  , 0.00429878993897  , 0.00406552961725  ,
 0.00578317665263  , 0.0102728783419   , 0.0170999147549   , 0.0237305130777   ,
 0.0265742137029   , 0.0239291432353   , 0.0179206477529   , 0.0131896210422   ,
 0.0139873665016   , 0.0220505586655   , 0.0352049803873   , 0.0471998143987   ,
 0.0512394616343   , 0.0460195998468   , 0.0375307039122   , 0.0332670793013   ,
 0.0349008650821   , 0.0374772440394   , 0.0354298909119   , 0.028407278382    ,
 0.0210325802267   , 0.0179195585666   , 0.0195903178835   , 0.0226408400844   ,
 0.0231354508806   , 0.0198968188357   , 0.0149170001229   , 0.0111850751391   ,
 0.0108158455136   , 0.0154378674006   , 0.0278576865954   , 0.052041506605    ,
 0.0890297201793   , 0.131349561277    , 0.164514196034    , 0.179457439979    ,
 0.184062999847    , 0.199161472765    , 0.244479250915    , 0.331817609168    ,
 0.465543375903    , 0.637215056893    , 0.819531389961    , 0.97988357347     ,
 1.11055621609     , 1.24467161479     , 1.43696828105     , 1.72106290413     ,
 2.07829093263     , 2.45526620893     , 2.83158740996     , 3.27370466611     ,
 3.90169910942     , 4.8002947943      , 5.99073411369     , 7.48884607534     ,
 9.33578815403     , 11.5391811015     , 14.0259437706     , 16.7011222019     ,
 19.5222025671     , 22.4344945447     , 25.189601828      , 27.2509693741     ,
 27.9560689009     , 26.8803966495     , 24.1320478753     , 20.3235279666     ,
 16.2455080715     , 12.5192873503     , 9.45272222167     , 7.0873215424      ,
 5.31610793647     , 4.00028871699     , 3.04104513766     , 2.3700982175      ,
 1.8980818766      , 1.5123688915      , 1.13688870933     , 0.771717491633    ,
 0.463224363887    , 0.246696821913    , 0.120342119332    , 0.0580499203836   ,
 0.03171021876     , 0.0220123487073   , 0.0183346971277   , 0.0157680866987   ,
 0.0129603808255   , 0.010452025051    , 0.00919240779537  , 0.00993340922843  ,
 0.0135438493555   , 0.0209055485268   , 0.0314519611387   , 0.0418471906331   ,
 0.0474591124884   , 0.0462173476317   , 0.0406226096818   , 0.0353773736367   ,
 0.0334746714079   , 0.0348945030651   , 0.0382012277926   , 0.042068102112    ,
 0.0449691497644   , 0.0447757345192   , 0.0401944474733   , 0.0324367971161   ,
 0.0245253821942   , 0.0189265187998   , 0.0160828796203   , 0.0147859209967   ,
 0.0135478080205   , 0.0117954238541   , 0.0100819997792   , 0.00942905265827  ,
 0.0107661747866   , 0.0148765331198   , 0.0219223632423   , 0.0301786213462   ,
 0.0359688392144   , 0.036538131654    , 0.0334475260672   , 0.0324735622031   ,
 0.0405959955416   , 0.0649312819387   , 0.116922162731    , 0.221188354258    ,
 1.09457667363     , 1.96976720921     , 3.44247223311     , 5.81180736062     ,
 9.48564055247     , 14.9839826004     , 22.8398783686     , 33.4085166686     ,
 46.7723478893     , 62.9145803989     , 82.0261320682     , 104.605067614     ,
 131.219882303     , 162.111781947     , 196.804975665     , 233.759566367     ,
 270.140434196     , 301.92428396      , 324.605332287     , 334.444659757     ,
 329.649121389     , 310.809356822     , 280.577636483     , 242.966785829     ,
 202.423003534     , 162.805007305     , 126.734342289     , 95.6195858504     ,
 70.0347771551     , 49.9695214766     , 34.9012030113     , 23.944447373      ,
 16.1475515011     , 10.7240730666     , 7.07282070659     , 4.69801676473     ,
 3.18346545932     , 2.21510207907     , 1.58111623762     , 1.14579289253     ,
 0.828310188735    , 0.588542476516    , 0.408092027041    , 0.27336445662     ,
 0.172697277969    , 0.100517352428    , 0.0549839105422   , 0.0314116121345   ,
 0.0212264413998   , 0.0164650078526   , 0.0133196371214   , 0.0119249043999   ,
 0.0140596388715   , 0.0207905230407   , 0.0307364952991   , 0.0396177436633   ,
 0.0423902682044   , 0.0372817877893   , 0.0277489299918   , 0.0199448317936   ,
 0.018662412865    , 0.0252960323888   , 0.0373135127002   , 0.0485432726035   ,
 0.0523928419494   , 0.0474359778002   , 0.0392597615665   , 0.035080524395    ,
 0.036607562372    , 0.0390738010136   , 0.0371363061861   , 0.0308318821723   ,
 0.025400259632    , 0.0259330299215   , 0.0325892803739   , 0.0404553903448   ,
 0.043789468918    , 0.0408817307934   , 0.0351727714342   , 0.0321702561553   ,
 0.0362351686814   , 0.0507903108459   , 0.0809141158726   , 0.133172074202    ,
 0.207989129687    , 0.289450293214    , 0.348910597227    , 0.368808963135    ,
 0.363423946306    , 0.370342944358    , 0.424803782425    , 0.548200627184    ,
 0.749061238341    , 1.01306228294     , 1.29234888212     , 1.5283323913      ,
 1.70123924004     , 1.8557418628      , 2.0713015682      , 2.39755448178     ,
 2.80793999657     , 3.22142287196     , 3.58960863856     , 3.96862334385     ,
 4.48975698155     , 5.25960190678     , 6.31453708911     , 7.66496856529     ,
 9.32460641079     , 11.2697646806     , 13.4203183056     , 15.7034209468     ,
 18.1025657008     , 20.5847587164     , 22.9478545891     , 24.7359333961     ,
 25.3596608194     , 24.4205539922     , 22.0089318819     , 18.6880687168     ,
 15.1656527922     , 11.9612679352     , 9.30556890279     , 7.2173631888      ,
 5.61180267108     , 4.38834264137     , 3.47881260508     , 2.82356190285     ,
 2.32177099757     , 1.85367734635     , 1.36397278551     , 0.893038632944    ,
 0.516021082364    , 0.26892912159     , 0.133898294178    , 0.0709075056765   ,
 0.046884272911    , 0.0417032663785   , 0.0427928566134   , 0.0423756868076   ,
 0.0382881505196   , 0.0330237207317   , 0.0300760255723   , 0.0315626738142   ,
 0.0388699737995   , 0.0531594142004   , 0.0730957482585   , 0.092639215107    ,
 0.103865383072    , 0.103769229815    , 0.097417179167    , 0.0932217801355   ,
 0.0956461027573   , 0.103093904172    , 0.111673079729    , 0.118770853107    ,
 0.122341978204    , 0.119320319565    , 0.107772476355    , 0.0902009345299   ,
 0.0725912336309   , 0.0599055273393   , 0.0529188186695   , 0.0487674097596   ,
 0.0440418795913   , 0.0377387183894   , 0.0316053964447   , 0.0279401067386   ,
 0.0276981285712   , 0.030800639066    , 0.0369544320366   , 0.0448915827607   ,
 0.0517555951843   , 0.0556077413999   , 0.0594113144685   , 0.0720521853536   ,
 0.106612983387    , 0.181205184028    , 0.326275228936    , 0.5980177637      ,
 2.63728576214     , 4.45578176206     , 7.29333190051     , 11.5543841036     ,
 17.7501555526     , 26.4762651921     , 38.232948805      , 53.1223250396     ,
 70.7386601322     , 90.5075371245     , 112.205469994     , 136.102878685     ,
 162.581629531     , 191.560103585     , 222.033323413     , 251.87128626      ,
 278.017705761     , 297.112621913     , 306.322010547     , 304.061893897     ,
 290.351049464     , 266.718236131     , 235.850889484     , 201.132660318     ,
 165.989793989     , 133.129862545     , 104.110687431     , 79.4960501522     ,
 59.3038512626     , 43.3023228097     , 31.0604165027     , 21.9650360289     ,
 15.3483643797     , 10.6335626295     , 7.36966841712     , 5.1839767767      ,
 3.7519679498      , 2.80547021653     , 2.14362662435     , 1.63486722453     ,
 1.2135781685      , 0.863471650157    , 0.587048423392    , 0.381567281953    ,
 0.236499054268    , 0.141230875599    , 0.0863466085822   , 0.0599929245618   ,
 0.0485471733519   , 0.0415855343168   , 0.0352736050018   , 0.0313503592139   ,
 0.0331183091755   , 0.0414018215887   , 0.0527467709714   , 0.0607902368919   ,
 0.060324777717    , 0.0513601953739   , 0.0392493582664   , 0.0304200872517   ,
 0.028357156172    , 0.0331897120246   , 0.0426081633578   , 0.0518609535212   ,
 0.0552836270914   , 0.0507173214305   , 0.042054585841    , 0.0356263469462   ,
 0.0339928965138   , 0.0342666499883   , 0.0325829932321   , 0.02928195657     ,
 0.0291328897281   , 0.0368009824182   , 0.0521334765621   , 0.0693141196787   ,
 0.0809907511356   , 0.0845213617346   , 0.0847404883775   , 0.0906902299098   ,
 0.110377415939    , 0.149396139459    , 0.213842024444    , 0.310451251223    ,
 0.436031368341    , 0.563202496643    , 0.647400008785    , 0.663409264421    ,
 0.634676386329    , 0.61797787746     , 0.665411907037    , 0.80971290263     ,
 1.06637646194     , 1.41726175597     , 1.79335924195     , 2.10715112741     ,
 2.32301085494     , 2.49300393658     , 2.71649148787     , 3.05484876722     ,
 3.47354960117     , 3.87041744621     , 4.17699992775     , 4.43824435355     ,
 4.78530531143     , 5.33592216832     , 6.13976876087     , 7.20417449856     ,
 8.51713499047     , 10.0295588061     , 11.6662551729     , 13.3860347622     ,
 15.2010072591     , 17.1020589758     , 18.9406781267     , 20.3569579391     ,
 20.8643064398     , 20.128089737      , 18.2343753917     , 15.6583412902     ,
 12.9529065606     , 10.482523965      , 8.39313683482     , 6.70419337247     ,
 5.37758029654     , 4.36011389696     , 3.60885659933     , 3.0634931355      ,
 2.60739202816     , 2.11460505617     , 1.55267933205     , 1.00370520054     ,
 0.573576943186    , 0.302802651178    , 0.1624623331      , 0.102889983805    ,
 0.0876910455648   , 0.0944725090172   , 0.10550572292     , 0.107871393012    ,
 0.0993965291132   , 0.0877510150164   , 0.0817807593887   , 0.0855841618237   ,
 0.100146673258    , 0.125696314457    , 0.158993424641    , 0.190569003195    ,
 0.209729271565    , 0.214463276474    , 0.214396942658    , 0.221838168147    ,
 0.240339957011    , 0.262971693605    , 0.280595614281    , 0.289118292472    ,
 0.288040387885    , 0.275913475623    , 0.251637650525    , 0.219156681092    ,
 0.18703702011     , 0.162475737041    , 0.146302960705    , 0.133409529048    ,
 0.118064850412    , 0.0995343319433   , 0.0823957460777   , 0.0712926155577   ,
 0.0665297413562   , 0.0654311053261   , 0.0665223659262   , 0.0707060589829   ,
 0.0793750450725   , 0.0943942817547   , 0.121630924577    , 0.175111319509    ,
 0.281026154447    , 0.484271731715    , 0.858510884042    , 1.51890647543     ,
 5.69345142059     , 9.08286163084     , 13.9751837068     , 20.7886231838     ,
 30.0106034125     , 42.1542603343     , 57.5166073304     , 75.8044198833     ,
 96.0581633134     , 117.172169905     , 138.586134955     , 160.417258377     ,
 182.93482802      , 205.884069949     , 228.051894127     , 247.249231944     ,
 260.852035761     , 266.705641714     , 263.798970253     , 252.346012243     ,
 233.482627512     , 208.969327644     , 181.026387451     , 152.119983615     ,
 124.523072209     , 99.8070620379     , 78.6328697675     , 60.9708903893     ,
 46.5040606518     , 34.896801182      , 25.8299107047     , 18.9337981715     ,
 13.7895833232     , 10.0120744349     , 7.30501409896     , 5.43658632077     ,
 4.1904503893      , 3.35099297536     , 2.72662987365     , 2.186159054       ,
 1.67813671497     , 1.21383512431     , 0.825142125698    , 0.530833642935    ,
 0.329350699914    , 0.206515553062    , 0.142025006367    , 0.113295324878    ,
 0.100297105176    , 0.0902543068222   , 0.0796368514442   , 0.0720667666433   ,
 0.0723989885178   , 0.080490722793    , 0.0897035901624   , 0.0917227380274   ,
 0.0834443033827   , 0.0693982019548   , 0.0573267338537   , 0.0515113546525   ,
 0.0508572026668   , 0.052789118851    , 0.0565291187818   , 0.0612935654485   ,
 0.0637080597687   , 0.0600442615636   , 0.0506813949185   , 0.0402135167854   ,
 0.0328748494559   , 0.0292975404374   , 0.0282679676185   , 0.0304812359335   ,
 0.0394862725448   , 0.0590081679535   , 0.0891650902641   , 0.124492605386    ,
 0.156487254142    , 0.180742657925    , 0.202852388371    , 0.23631165453     ,
 0.294079040766    , 0.382880000239    , 0.505107483837    , 0.660833817356    ,
 0.838039560449    , 0.998065406057    , 1.08651888819     , 1.07784116955     ,
 1.0070187318      , 0.946503617501    , 0.960520603517    , 1.09131341791     ,
 1.36305260635     , 1.7590346121      , 2.19810812259     , 2.57321186276     ,
 2.83479530557     , 3.03120556864     , 3.26204475223     , 3.58589585027     ,
 3.9626603706      , 4.28702795821     , 4.48948927049     , 4.60815132229     ,
 4.76153333202     , 5.0614470291      , 5.56131180558     , 6.26606226978     ,
 7.14866895389     , 8.15384373989     , 9.22802046017     , 10.3630962435     ,
 11.5893881019     , 12.9113975215     , 14.2269172071     , 15.2695103823     ,
 15.6658040871     , 15.1618887988     , 13.8377128079     , 12.0540270949     ,
 10.1871929101     , 8.45302075221     , 6.93585775094     , 5.67095268878     ,
 4.66639000835     , 3.90731124516     , 3.3674617315      , 2.98455639263     ,
 2.6325557011      , 2.18380095804     , 1.62167502537     , 1.05547414567     ,
 0.612589713907    , 0.340127202441    , 0.206850648189    , 0.161157767088    ,
 0.166159848815    , 0.195549275006    , 0.222971586085    , 0.228550041476    ,
 0.212171996331    , 0.191357860061    , 0.183916324998    , 0.196369101023    ,
 0.227440264827    , 0.273810595494    , 0.327860208171    , 0.37575714771     ,
 0.406326030096    , 0.4233204038      , 0.444341494771    , 0.484064380024    ,
 0.538935123925    , 0.589756726533    , 0.618521737079    , 0.6208194131      ,
 0.602679207435    , 0.570331350224    , 0.526942742229    , 0.476630471867    ,
 0.426302655999    , 0.381967114992    , 0.343992997078    , 0.306713582111    ,
 0.26447326528     , 0.219211156173    , 0.180286734549    , 0.155276150815    ,
 0.142533088516    , 0.13464629995     , 0.128337946456    , 0.129250415178    ,
 0.147970692793    , 0.194922608516    , 0.282187919507    , 0.433470588652    ,
 0.70024274751     , 1.17973403685     , 2.02524877405     , 3.44408779046     ,
 10.8588849721     , 16.4464264534     , 23.9234089169     , 33.5527731164     ,
 45.6112404118     , 60.353128684      , 77.7580584933     , 97.1546700602     ,
 117.211288357     , 136.571455708     , 154.582712604     , 171.338612042     ,
 187.066109686     , 201.489516477     , 213.531677517     , 221.452011275     ,
 223.516361824     , 218.875878981     , 207.91735284      , 191.846986826     ,
 172.093241582     , 150.098427418     , 127.39545009      , 105.54253846      ,
 85.8046566392     , 68.8577912688     , 54.7685184231     , 43.2170763476     ,
 33.7795609728     , 26.1199103755     , 20.0188112971     , 15.2799852477     ,
 11.6615963391     , 8.91895918828     , 6.87638361667     , 5.42101047759     ,
 4.43704373563     , 3.76718623993     , 3.23895942071     , 2.72467239497     ,
 2.1803010056      , 1.63424253064     , 1.14321739839     , 0.752934681732    ,
 0.481383493386    , 0.31870223939     , 0.236017870347    , 0.19951925942     ,
 0.182342170109    , 0.168997136516    , 0.155036044898    , 0.144210855564    ,
 0.141651629887    , 0.14582711409     , 0.147345238581    , 0.137545903062    ,
 0.11811082512     , 0.100194355686    , 0.0932691649164   , 0.0958493984605   ,
 0.0982865277774   , 0.0941864691346   , 0.0867564255674   , 0.0827456270693   ,
 0.0827171720909   , 0.0803815809872   , 0.0706820936835   , 0.0555704717955   ,
 0.0415095109976   , 0.0338637865963   , 0.0350762299949   , 0.0465680218475   ,
 0.0704420751461   , 0.109419466888    , 0.165034218827    , 0.2342345632      ,
 0.30832645327     , 0.379783364099    , 0.452801625029    , 0.544404009889    ,
 0.672080945265    , 0.840872526362    , 1.04265539634     , 1.26220670928     ,
 1.47399343721     , 1.63285042989     , 1.6874123983      , 1.62284707184     ,
 1.48628440118     , 1.35815462164     , 1.30687384598     , 1.37937636997     ,
 1.6066550458      , 1.9781509213      , 2.41571221224     , 2.8120114611      ,
 3.11134895352     , 3.34483304102     , 3.58624512609     , 3.87454687786     ,
 4.17045887992     , 4.38742054194     , 4.47263232693     , 4.45955698257     ,
 4.44349958273     , 4.51616392652     , 4.7255283561      , 5.07633267561     ,
 5.54176863769     , 6.07975798359     , 6.66556368037     , 7.31347440025     ,
 8.0551860125      , 8.89538380556     , 9.7657521755      , 10.4840200767     ,
 10.7901922331     , 10.5111628142     , 9.70775695987     , 8.61545429155     ,
 7.4525746669      , 6.32837348078     , 5.29619616058     , 4.40690163058     ,
 3.69653532637     , 3.17272851537     , 2.82150544389     , 2.58684100584     ,
 2.34996445867     , 1.99252285733     , 1.5048658637      , 0.999003011459    ,
 0.603302330573    , 0.367354186435    , 0.265065079524    , 0.250555427496    ,
 0.28883242403     , 0.34859198513     , 0.394206996216    , 0.400806504301    ,
 0.37451632727     , 0.346970947012    , 0.347244046475    , 0.384096351548    ,
 0.451876927414    , 0.540150417887    , 0.632797464249    , 0.709617817629    ,
 0.761920840544    , 0.805987501327    , 0.871855071252    , 0.973284297214    ,
 1.08998791184     , 1.18157366375     , 1.21848177461     , 1.19986366332     ,
 1.14618476284     , 1.07972157703     , 1.01178120431     , 0.942582480276    ,
 0.868053149986    , 0.786028968508    , 0.697196290234    , 0.602497036797    ,
 0.50422804791     , 0.411251036156    , 0.337916775131    , 0.292847290172    ,
 0.270284507605    , 0.256740788655    , 0.247756477356    , 0.257284742408    ,
 0.311161600239    , 0.435054072323    , 0.653361647213    , 1.00688242341     ,
 1.58717365211     , 2.57203732134     , 4.23111388706     , 6.88624026269     ,
 18.2582917823     , 26.3470486113     , 36.4163493518     , 48.3881419128     ,
 62.1643589934     , 77.6457629866     , 94.5317778948     , 111.99243986      ,
 128.70139774      , 143.454057328     , 155.775883987     , 165.832992092     ,
 173.835452052     , 179.580276409     , 182.348430872     , 181.118470299     ,
 175.143564176     , 164.575432713     , 150.484963873     , 134.236319972     ,
 116.946971261     , 99.5057310994     , 82.8061881207     , 67.7061649058     ,
 54.7602924344     , 44.0815368276     , 35.4472915812     , 28.4866107        ,
 22.8264895815     , 18.1962533459     , 14.4570301881     , 11.5205017985     ,
 9.25490992794     , 7.49984542735     , 6.14451558617     , 5.14267054518     ,
 4.45014319302     , 3.97184543525     , 3.57478863248     , 3.14612772025     ,
 2.6398435976      , 2.07915665522     , 1.52714671493     , 1.05278979716     ,
 0.702920201412    , 0.484678800415    , 0.369460773927    , 0.316223954108    ,
 0.29226289569     , 0.27829233589     , 0.265809051761    , 0.254511404465    ,
 0.246939037337    , 0.240530495129    , 0.226479229139    , 0.200004000218    ,
 0.170290207871    , 0.154810092349    , 0.161269941211    , 0.17737175923     ,
 0.181532037382    , 0.164313247366    , 0.136998096127    , 0.11785489076     ,
 0.112838605758    , 0.11233457901     , 0.10439442206     , 0.0871578050683   ,
 0.0687817594032   , 0.0596287219656   , 0.0666788021865   , 0.0928614516822   ,
 0.13900012963     , 0.207132397773    , 0.302221488908    , 0.427156322359    ,
 0.575118617055    , 0.733163545777    , 0.89804222898     , 1.08387066534     ,
 1.30821455459     , 1.57151902388     , 1.85224469775     , 2.11737364547     ,
 2.32937532863     , 2.44526496141     , 2.4287975511      , 2.28190832153     ,
 2.05993006132     , 1.84373287369     , 1.70085684814     , 1.67826115451     ,
 1.80785037121     , 2.08496626973     , 2.44657675733     , 2.80354518016     ,
 3.10395105763     , 3.35539844118     , 3.59161885948     , 3.82584138726     ,
 4.02804479997     , 4.14272910528     , 4.13687418314     , 4.03409529721     ,
 3.90123597902     , 3.80613627036     , 3.78844046227     , 3.85613107548     ,
 3.99468885389     , 4.18478434671     , 4.42495553687     , 4.73579357464     ,
 5.13795320221     , 5.6289861396      , 6.16337699746     , 6.62850088165     ,
 6.86592152943     , 6.77230218271     , 6.38095663522     , 5.81329634032     ,
 5.16815540717     , 4.49177556041     , 3.82562993468     , 3.22685754769     ,
 2.74019966979     , 2.38319176327     , 2.15252235535     , 2.00725370424     ,
 1.85261033842     , 1.59315863786     , 1.22244339139     , 0.834299180587    ,
 0.536950400743    , 0.374717230653    , 0.329344968705    , 0.363347682357    ,
 0.442506681926    , 0.530225290993    , 0.586538748163    , 0.589684133294    ,
 0.557540424207    , 0.536354038797    , 0.564739783352    , 0.652858694901    ,
 0.790120354125    , 0.956366501007    , 1.12241889776     , 1.25838007494     ,
 1.359091667       , 1.45797772607     , 1.60033432108     , 1.79515198744     ,
 1.99641104629     , 2.13534409665     , 2.17081838555     , 2.11218812652     ,
 2.00348890041     , 1.89005280881     , 1.791996507       , 1.69803930958     ,
 1.58125541828     , 1.4243965084      , 1.23335694539     , 1.02971927826     ,
 0.836839560164    , 0.674725494955    , 0.558662250421    , 0.492396253169    ,
 0.463350884487    , 0.453024784995    , 0.459009759304    , 0.508166762724    ,
 0.647783222038    , 0.926696250244    , 1.39044349498     , 2.10557854164     ,
 3.21338190623     , 4.98522622702     , 7.81793182752     , 12.1350672273     ,
 27.1585556275     , 37.3956099773     , 49.2804294452     , 62.2986676329     ,
 75.938541861      , 89.8035439533     , 103.503991774     , 116.377562962     ,
 127.487807302     , 136.093268301     , 142.046287617     , 145.602184901     ,
 146.938140953     , 145.936993439     , 142.265012037     , 135.579141153     ,
 125.884978698     , 113.836495114     , 100.546960722     , 87.020799513      ,
 73.8545929112     , 61.4443639035     , 50.237723067      , 40.6462287404     ,
 32.8116926085     , 26.5737717788     , 21.6353221266     , 17.7003539312     ,
 14.5148515424     , 11.9004613461     , 9.78322231538     , 8.13924978928     ,
 6.90252495579     , 5.95848189021     , 5.21535223697     , 4.64025306247     ,
 4.22266660249     , 3.92370795479     , 3.66527741349     , 3.36147979808     ,
 2.95885283297     , 2.45603412968     , 1.90186431297     , 1.37757152331     ,
 0.960056367255    , 0.682454511293    , 0.526763112637    , 0.451969867226    ,
 0.422406474418    , 0.414233338977    , 0.411558581566    , 0.405364737855    ,
 0.392060675956    , 0.368423593394    , 0.330927423407    , 0.284603404271    ,
 0.24896941802     , 0.245373729197    , 0.273522380335    , 0.304436200279    ,
 0.303219434442    , 0.26114855766     , 0.202937239744    , 0.161563291943    ,
 0.149112974816    , 0.152634137003    , 0.152763165959    , 0.141892621853    ,
 0.127173363267    , 0.122512187049    , 0.139872968545    , 0.184727330866    ,
 0.257264199432    , 0.360072396718    , 0.505003550356    , 0.706022141559    ,
 0.961113739813    , 1.24802728481     , 1.54466281314     , 1.84844438213     ,
 2.16829953768     , 2.50036271636     , 2.81719934018     , 3.07867195397     ,
 3.24665407411     , 3.29036954181     , 3.19243482899     , 2.96545282276     ,
 2.66200299912     , 2.35686242504     , 2.11601742307     , 1.98470858367     ,
 1.98999817068     , 2.12932514834     , 2.35830332662     , 2.61415715936     ,
 2.85613949384     , 3.07422485489     , 3.26881795615     , 3.43503830422     ,
 3.55664502525     , 3.60564124995     , 3.55847501334     , 3.42156168883     ,
 3.23501521729     , 3.04749284357     , 2.89127996281     , 2.77841714154     ,
 2.71035797861     , 2.68995984516     , 2.72915529552     , 2.84375996245     ,
 3.04016809262     , 3.30887718321     , 3.61969534268     , 3.91128466528     ,
 4.10260908415     , 4.1409624746      , 4.03337545156     , 3.81613525181     ,
 3.51076644566     , 3.13073477251     , 2.71295949609     , 2.31339033082     ,
 1.97543189842     , 1.71936994626     , 1.54872663702     , 1.43812741024     ,
 1.32276037956     , 1.13775576826     , 0.881206645603    , 0.621297187667    ,
 0.436699020894    , 0.361963723633    , 0.385282608387    , 0.473953206285    ,
 0.589677715765    , 0.691495091485    , 0.744981404883    , 0.743423207613    ,
 0.720329646546    , 0.730984752204    , 0.816803353022    , 0.988242979331    ,
 1.23248403526     , 1.52084994071     , 1.80916376334     , 2.05437231542     ,
 2.25113300455     , 2.44647050515     , 2.69811367105     , 3.00843331073     ,
 3.30436071552     , 3.48809391194     , 3.50891465339     , 3.39236613548     ,
 3.21291836882     , 3.04110832972     , 2.90105631496     , 2.76110076508     ,
 2.56412621327     , 2.27776510769     , 1.92303715768     , 1.55791283436     ,
 1.23866304115     , 0.997203270848    , 0.841720068799    , 0.763182192557    ,
 0.740860162417    , 0.755785919908    , 0.813423238548    , 0.957695292186    ,
 1.26096806262     , 1.8014421505      , 2.65496065941     , 3.92069233558     ,
 5.78541328094     , 8.59205989029     , 12.8221925133     , 18.9351477208     ,
 35.9883660995     , 47.2701165416     , 59.46975754       , 71.7187631982     ,
 83.2351956764     , 93.5182914803     , 102.32234509      , 109.395333906     ,
 114.378206185     , 117.069399443     , 117.628818966     , 116.357418694     ,
 113.371019035     , 108.587815943     , 101.925685697     , 93.4667071362     ,
 83.5923958541     , 73.022276279      , 62.5657000087     , 52.7513318751     ,
 43.7636599914     , 35.7095469796     , 28.7902143298     , 23.1689557935     ,
 18.7880983049     , 15.3995704989     , 12.7355711477     , 10.6031722796     ,
 8.86696977087     , 7.43789080688     , 6.29390132061     , 5.44917111628     ,
 4.87807584453     , 4.49560960232     , 4.21139881469     , 3.97783674422     ,
 3.78742335953     , 3.63833235218     , 3.50307102266     , 3.32621405877     ,
 3.05047264841     , 2.64899234075     , 2.14863572928     , 1.62981381564     ,
 1.18722507696     , 0.875136300032    , 0.689952942895    , 0.598359419319    ,
 0.5676785775      , 0.571985828489    , 0.58796292888     , 0.59618592033     ,
 0.58419213805     , 0.545925456839    , 0.483665109899    , 0.41561964789     ,
 0.374763403776    , 0.385540120375    , 0.43500909203     , 0.473600151015    ,
 0.454371104772    , 0.374636245427    , 0.276755298576    , 0.209103686523    ,
 0.189577554765    , 0.202890815115    , 0.222786788014    , 0.233172164455    ,
 0.235251853956    , 0.242950390072    , 0.272497186023    , 0.3327021117      ,
 0.424707063877    , 0.554676865576    , 0.745862163251    , 1.02780034078     ,
 1.40495419563     , 1.84107680419     , 2.28278143089     , 2.69541401217     ,
 3.07058746695     , 3.40491487204     , 3.68152205684     , 3.87348596217     ,
 3.95856099542     , 3.92544303388     , 3.77092430085     , 3.50427510377     ,
 3.16028620783     , 2.79861082471     , 2.48098695235     , 2.25118551221     ,
 2.13236497459     , 2.12460425791     , 2.20092087365     , 2.32241011274     ,
 2.46103616116     , 2.60030030424     , 2.72462131278     , 2.82213233078     ,
 2.88710435452     , 2.90672216545     , 2.85784752748     , 2.730706791       ,
 2.5460363443      , 2.33832047096     , 2.13141674747     , 1.93764926988     ,
 1.77049360113     , 1.64920222066     , 1.59245046259     , 1.60906278621     ,
 1.69478127375     , 1.83689516482     , 2.01693824343     , 2.20769167766     ,
 2.37659564266     , 2.49836634428     , 2.55822579722     , 2.54008936687     ,
 2.42523244375     , 2.21451007269     , 1.94400660956     , 1.66685525971     ,
 1.42314721271     , 1.23200467047     , 1.09709225851     , 1.00092113782     ,
 0.902434712174    , 0.76475821351     , 0.592361763667    , 0.432243334614    ,
 0.33765416626     , 0.334818659096    , 0.415882891737    , 0.547531783607    ,
 0.683555457608    , 0.781661262904    , 0.82287457225     , 0.824453641166    ,
 0.834748964577    , 0.908160662235    , 1.07948705098     , 1.35826802232     ,
 1.73509236837     , 2.1793080565      , 2.63529946613     , 3.04521588014     ,
 3.39445762713     , 3.729375759       , 4.11022155403     , 4.53547727173     ,
 4.91646249543     , 5.13474270368     , 5.1310240234      , 4.94610756244     ,
 4.68477676822     , 4.43951767098     , 4.23150166301     , 4.00504284592     ,
 3.6780273891      , 3.21410929121     , 2.65981098971     , 2.11520669947     ,
 1.669534736       , 1.36147416161     , 1.18516891809     , 1.11570363847     ,
 1.12794163164     , 1.21024983526     , 1.3816309431      , 1.70279611578     ,
 2.26730214865     , 3.1813012345      , 4.55464166433     , 6.5203040877      ,
 9.29089467243     , 13.2222921608     , 18.7836218765     , 26.3587492204     ,
 42.8544480155     , 53.6272797868     , 64.3764720967     , 74.1268042678     ,
 82.1070400357     , 87.9470476099     , 91.6785035014     , 93.4777576234     ,
 93.4783747467     , 91.8733252559     , 89.0017063972     , 85.1564834592     ,
 80.3820176945     , 74.56981078       , 67.7096759108     , 60.0233000029     ,
 51.9517126465     , 44.0458906717     , 36.7596539537     , 30.2821120043     ,
 24.604599917      , 19.7325732716     , 15.7544557252     , 12.7071736784     ,
 10.4589162443     , 8.7659124016      , 7.41585248484     , 6.29386696904     ,
 5.34847449212     , 4.55869925782     , 3.94011490213     , 3.52693081072     ,
 3.31726051829     , 3.25054775929     , 3.24240859452     , 3.23185387359     ,
 3.20218103023     , 3.16507645951     , 3.12175753247     , 3.04019002012     ,
 2.86985810019     , 2.5762417686      , 2.17253872744     , 1.72765584925     ,
 1.33077073182     , 1.0372210411      , 0.851618688832    , 0.754208515796    ,
 0.724894951756    , 0.743354392183    , 0.784127918332    , 0.82061276533     ,
 0.830545516143    , 0.798322897532    , 0.723095628309    , 0.631906998408    ,
 0.573962791961    , 0.582434178593    , 0.635491964918    , 0.665234926014    ,
 0.615670470261    , 0.492545533213    , 0.354941974278    , 0.263705707715    ,
 0.241679125835    , 0.273353828426    , 0.327037503285    , 0.375633270344    ,
 0.408963162521    , 0.436032484172    , 0.474679202791    , 0.536938791725    ,
 0.627724639227    , 0.761465936746    , 0.975938535854    , 1.31580947905     ,
 1.7898814697      , 2.34595088326     , 2.89630858237     , 3.36960695454     ,
 3.73806752998     , 4.00441841725     , 4.17574820825     , 4.25354293214     ,
 4.2410345658      , 4.1470237778      , 3.9765767032      , 3.72754779531     ,
 3.40738104362     , 3.04812313798     , 2.69586973199     , 2.39115776094     ,
 2.16246397264     , 2.02282614073     , 1.96395945478     , 1.96385212762     ,
 2.00204747923     , 2.06052078662     , 2.119088409       , 2.16391214942     ,
 2.19238712848     , 2.19725430635     , 2.15721458728     , 2.05765490164     ,
 1.90946517233     , 1.73425639672     , 1.54317640301     , 1.34270795763     ,
 1.15121468206     , 0.997561563143    , 0.904498242969    , 0.87700693457     ,
 0.90585850041     , 0.979128204907    , 1.08866594179     , 1.22864928146     ,
 1.39066673925     , 1.55683607147     , 1.69432775267     , 1.76096841061     ,
 1.72595393496     , 1.59216230435     , 1.39791852915     , 1.19356920037     ,
 1.01564855722     , 0.87956969671     , 0.783233899788    , 0.70811306304     ,
 0.626029258656    , 0.519640554736    , 0.399766408893    , 0.300686496337    ,
 0.259638769905    , 0.297966631029    , 0.409807441539    , 0.55935791403     ,
 0.694479112055    , 0.776515939568    , 0.806247739856    , 0.824986685028    ,
 0.890405824025    , 1.04704122735     , 1.31561677579     , 1.70344935152     ,
 2.21027135077     , 2.8129716672      , 3.45269912369     , 4.05804226995     ,
 4.5947605193      , 5.08960548355     , 5.59251211007     , 6.10475942954     ,
 6.54280021322     , 6.78251131435     , 6.75416777369     , 6.50235524049     ,
 6.15209461303     , 5.81182053761     , 5.49824596973     , 5.13977995176     ,
 4.648346862       , 4.00194185596     , 3.27560512334     , 2.59818453668     ,
 2.07428119639     , 1.73907005382     , 1.57312988623     , 1.5441869129      ,
 1.6344259568      , 1.84894243219     , 2.22189589394     , 2.82219810889     ,
 3.74918191701     , 5.12170771463     , 7.07293883474     , 9.75907004059     ,
 13.3908125358     , 18.2694876452     , 24.7423286741     , 33.0047976709     ,
 46.2184969368     , 55.0569280485     , 62.9932823995     , 69.2326533552     ,
 73.2882634388     , 75.0769350644     , 74.8813548252     , 73.1212331632     ,
 70.1642989214     , 66.3609330655     , 62.0875976477     , 57.5989148184     ,
 52.8880631154     , 47.7985745566     , 42.2765898274     , 36.4965361815     ,
 30.7909200168     , 25.4938576819     , 20.8057583066     , 16.759839852      ,
 13.3179136034     , 10.4859670559     , 8.30924805764     , 6.76943232587     ,
 5.72662607367     , 4.9757473016      , 4.35220136047     , 3.78343833486     ,
 3.26277898335     , 2.81063245257     , 2.46424025675     , 2.26336165728     ,
 2.21559525498     , 2.27976217756     , 2.3875375795      , 2.48101816833     ,
 2.53884297538     , 2.57032602145     , 2.58149698676     , 2.55252633951     ,
 2.44958826731     , 2.25153922131     , 1.97130343547     , 1.65956025517     ,
 1.37706779624     , 1.15702036609     , 1.00175665327     , 0.90846897775     ,
 0.879409611029    , 0.909123493182    , 0.977623249039    , 1.05768495481     ,
 1.11892347604     , 1.12760928903     , 1.06333612125     , 0.949072544847    ,
 0.850343486796    , 0.820767360199    , 0.844415157695    , 0.845690427875    ,
 0.762670610917    , 0.604870359307    , 0.439506148105    , 0.333843094469    ,
 0.315470097413    , 0.371986893242    , 0.468866969549    , 0.567680632463    ,
 0.643635416902    , 0.695604445259    , 0.737929935631    , 0.784361352746    ,
 0.847282187805    , 0.954128785524    , 1.1559779118      , 1.50468070012     ,
 2.00731377011     , 2.60028000056     , 3.17551073763     , 3.63906373378     ,
 3.95084166229     , 4.12009863854     , 4.17589613493     , 4.14549443075     ,
 4.05277713078     , 3.92076588791     , 3.76202809887     , 3.56933456391     ,
 3.32632518326     , 3.02774963135     , 2.68752838797     , 2.33710248961     ,
 2.0206830681      , 1.77851220843     , 1.62549814443     , 1.55028216986     ,
 1.53127981393     , 1.54510318587     , 1.56818354951     , 1.584917408       ,
 1.59132054336     , 1.58241219572     , 1.54461903606     , 1.47050510775     ,
 1.36921593974     , 1.25035251301     , 1.10970158222     , 0.943681080593    ,
 0.769366296104    , 0.619453291465    , 0.519439300484    , 0.473829156147    ,
 0.472603817449    , 0.506614107005    , 0.576068013616    , 0.687481557813    ,
 0.841500004009    , 1.01765988811     , 1.17104252727     , 1.2516059071      ,
 1.23324774781     , 1.1280301559      , 0.976380900459    , 0.824063247259    ,
 0.70282294963     , 0.622737372011    , 0.572731064605    , 0.52755458559     ,
 0.463907474593    , 0.377486170378    , 0.285962490862    , 0.218136161981    ,
 0.201876560676    , 0.254241670579    , 0.36917245196     , 0.510359872567    ,
 0.626678253334    , 0.688168602242    , 0.712639533254    , 0.756996124823    ,
 0.880580569059    , 1.11425544871     , 1.46301406048     , 1.93157240177     ,
 2.53171274163     , 3.25468125958     , 4.04593389561     , 4.82400325119     ,
 5.53070459037     , 6.16215880968     , 6.74970880428     , 7.30287533766     ,
 7.76094947787     , 8.00879127616     , 7.96418910461     , 7.65878160539     ,
 7.22087014799     , 6.7692144245      , 6.32358946565     , 5.81475171753     ,
 5.17191841597     , 4.40202895721     , 3.60079922873     , 2.89787676678     ,
 2.38422709715     , 2.07986605836     , 1.9606654843      , 2.00615791005     ,
 2.22305173827     , 2.641428211       , 3.30741896798     , 4.28333236577     ,
 5.65023597678     , 7.51022307865     , 9.98841358773     , 13.2347332227     ,
 17.4298386454     , 22.78194524       , 29.4588321339     , 37.4159681548     ,
 45.3745382148     , 51.4940015043     , 56.1522730394     , 58.9066037128     ,
 59.6699792562     , 58.6513060832     , 56.248683473      , 52.8867945084     ,
 48.9151470799     , 44.6541192841     , 40.4282916315     , 36.4483342105     ,
 32.6912028446     , 28.9791501322     , 25.1951755312     , 21.4045574815     ,
 17.7899955377     , 14.5138805577     , 11.643231262      , 9.17308884436     ,
 7.09911022724     , 5.45515642612     , 4.27542165366     , 3.52910815952     ,
 3.09953650332     , 2.82732734685     , 2.58300034622     , 2.31240250663     ,
 2.02604325872     , 1.76275242958     , 1.56651438882     , 1.47126085041     ,
 1.48239502063     , 1.5709290789      , 1.68956448554     , 1.79809790619     ,
 1.88070641607     , 1.93994842618     , 1.97368383338     , 1.96640161805     ,
 1.90398175821     , 1.78760581603     , 1.63587626122     , 1.47838178951     ,
 1.33748761808     , 1.21426638941     , 1.10418073414     , 1.02216198022     ,
 0.995718616685    , 1.03689463942     , 1.13458421837     , 1.26669784757     ,
 1.39948922848     , 1.4780081661      , 1.44939633978     , 1.31757525295     ,
 1.15896020868     , 1.05690693858     , 1.01990416763     , 0.980514009908    ,
 0.87405026377     , 0.703755865041    , 0.531208874386    , 0.422669481694    ,
 0.411097950329    , 0.49129497695     , 0.63015772123     , 0.781476576985    ,
 0.906392678087    , 0.988745359057    , 1.03209115391     , 1.04934397768     ,
 1.06434574674     , 1.12067624171     , 1.27687234549     , 1.57926528793     ,
 2.02639048786     , 2.5539043322      , 3.05943556345     , 3.45246458908     ,
 3.69110789664     , 3.78344145234     , 3.76359078412     , 3.66808440091     ,
 3.52884251381     , 3.37610951279     , 3.23285997699     , 3.09991797965     ,
 2.95022491877     , 2.74268809242     , 2.45047779321     , 2.08933397271     ,
 1.72080993057     , 1.41710506795     , 1.21721852024     , 1.116359962       ,
 1.08593299377     , 1.09292320733     , 1.10948693404     , 1.11957074225     ,
 1.11819299661     , 1.10148206221     , 1.06379337571     , 1.00794241003     ,
 0.945713210646    , 0.879127276283    , 0.792283554481    , 0.672332758951    ,
 0.531885858938    , 0.402885377936    , 0.311356410911    , 0.262223742499    ,
 0.246270113718    , 0.256860783733    , 0.299000349407    , 0.384545913889    ,
 0.51655711344     , 0.672825536524    , 0.806690625295    , 0.872306717668    ,
 0.853041442698    , 0.767313856334    , 0.653381574724    , 0.55083730624     ,
 0.486866326107    , 0.465593692972    , 0.464330020548    , 0.447101684059    ,
 0.392012811384    , 0.307503875626    , 0.222237300681    , 0.165329022814    ,
 0.157539771322    , 0.208723003222    , 0.309337363976    , 0.424824249823    ,
 0.511847791214    , 0.552267810905    , 0.57448032151     , 0.639160184663    ,
 0.799878876087    , 1.07478824963     , 1.45760220357     , 1.95244991642     ,
 2.58255436416     , 3.35340962639     , 4.21689107659     , 5.08608867223     ,
 5.88530167503     , 6.58518615356     , 7.19923811807     , 7.743814057       ,
 8.18416396859     , 8.42267642072     , 8.36847709265     , 8.03070709963     ,
 7.52551036219     , 6.97653386898     , 6.41647584645     , 5.79561653608     ,
 5.07422266834     , 4.29024701992     , 3.54572418551     , 2.94417526714     ,
 2.53788283156     , 2.32361728229     , 2.28362162675     , 2.42783449862     ,
 2.80080497619     , 3.46160508279     , 4.46452082884     , 5.8536182561      ,
 7.67011727154     , 9.96554398207     , 12.8116756675     , 16.3064237445     ,
 20.5743721923     , 25.7347899623     , 31.8027284526     , 38.5415728917     ,
 40.6509998216     , 44.0694320073     , 45.9088094487     , 46.0696109884     ,
 44.7808812624     , 42.4185072233     , 39.349471565      , 35.852781623      ,
 32.1356247823     , 28.4165460771     , 24.9455550991     , 21.8944608695     ,
 19.2469151156     , 16.842494625      , 14.537196798      , 12.3069528335     ,
 10.2123007483     , 8.30813397106     , 6.60688394166     , 5.1087844061      ,
 3.84142329323     , 2.85683656414     , 2.18930068621     , 1.81702760654     ,
 1.657173257       , 1.59384849536     , 1.52637073934     , 1.40979996981     ,
 1.25715526166     , 1.10962512018     , 1.00706972873     , 0.971576316105    ,
 1.00048693742     , 1.07100367001     , 1.15509298521     , 1.23430470106     ,
 1.30403594352     , 1.36288079506     , 1.40013328759     , 1.402303324       ,
 1.37066531358     , 1.32300113264     , 1.27940008072     , 1.24895378082     ,
 1.22201013888     , 1.17658776471     , 1.10676293113     , 1.04310618384     ,
 1.03075268885     , 1.0913574231      , 1.21854830764     , 1.39652032001     ,
 1.59415181121     , 1.7428172426      , 1.760015416       , 1.62437540506     ,
 1.41242823555     , 1.23315474863     , 1.12778890206     , 1.05030993092     ,
 0.938206212026    , 0.780864942477    , 0.622308812346    , 0.520961203692    ,
 0.514921032229    , 0.609470419869    , 0.778515175803    , 0.974994564593    ,
 1.14933871153     , 1.26608703235     , 1.31072962021     , 1.29353173723     ,
 1.25359489512     , 1.25158054225     , 1.34623707854     , 1.56773804145     ,
 1.90274451412     , 2.29761036798     , 2.67851694495     , 2.97848055842     ,
 3.15751649875     , 3.20936217516     , 3.15504538023     , 3.02806347005     ,
 2.86323245277     , 2.6958777531      , 2.55893090276     , 2.46562790965     ,
 2.38936824864     , 2.26728965812     , 2.04079542039     , 1.70835328275     ,
 1.33857377213     , 1.02354237455     , 0.818382066125    , 0.722542207819    ,
 0.702001485047    , 0.717247740801    , 0.739596533782    , 0.755834358625    ,
 0.761504732393    , 0.75120385143     , 0.720906970773    , 0.678389890342    ,
 0.638709458189    , 0.603299314015    , 0.553459482677    , 0.472398510577    ,
 0.367889351284    , 0.267266285015    , 0.193610712258    , 0.151133088375    ,
 0.131545080094    , 0.129642193768    , 0.151417430302    , 0.208916771427    ,
 0.305793068484    , 0.423867362423    , 0.525645329481    , 0.576322022144    ,
 0.565493549082    , 0.509206870698    , 0.438419729866    , 0.387855589789    ,
 0.38329770331     , 0.422924220357    , 0.46868767786     , 0.469594298722    ,
 0.404213094944    , 0.297643809596    , 0.196066602907    , 0.133799966185    ,
 0.124849276918    , 0.168479753176    , 0.248453138893    , 0.332303401988    ,
 0.387378725269    , 0.407619457977    , 0.425726222005    , 0.496121533396    ,
 0.660619292611    , 0.927215670531    , 1.28544509334     , 1.74240619767     ,
 2.32955281506     , 3.06089123969     , 3.89271254292     , 4.73830567117     ,
 5.51851769107     , 6.19538645241     , 6.77196603572     , 7.26368429677     ,
 7.65086082697     , 7.85551827519     , 7.79045785212     , 7.44759935219     ,
 6.92312988998     , 6.33694470018     , 5.73575465824     , 5.09494879056     ,
 4.40488646806     , 3.7246528588      , 3.14887677558     , 2.74214338828     ,
 2.50994637309     , 2.4257183026      , 2.48418243199     , 2.73060864208     ,
 3.24671974384     , 4.1178565858      , 5.40606841975     , 7.13647921016     ,
 9.30195487555     , 11.8808794452     , 14.8544790503     , 18.2283754257     ,
 22.0536018967     , 26.3911398198     , 31.1865729151     , 36.132435322      ,
 33.3152111068     , 34.6452497211     , 34.6469509381     , 33.4340497965     ,
 31.3637614717     , 28.8175774788     , 26.044504495      , 23.1538619442     ,
 20.2179274746     , 17.3728594728     , 14.8110935656     , 12.6693399348     ,
 10.9383175533     , 9.49326535454     , 8.2024137337      , 6.99934357848     ,
 5.87255610349     , 4.82158511955     , 3.84140370912     , 2.94108179401     ,
 2.15927891952     , 1.5488661686      , 1.14308769277     , 0.933349357242    ,
 0.86884600525     , 0.872448687881    , 0.870905738908    , 0.8275963736      ,
 0.751723955551    , 0.677374963908    , 0.635034010829    , 0.635513745712    ,
 0.669269473001    , 0.717003428876    , 0.763790637176    , 0.806962091104    ,
 0.851571894095    , 0.896698793614    , 0.92957082359     , 0.939918954311    ,
 0.936715327282    , 0.942052693446    , 0.969610406161    , 1.01161586017     ,
 1.04167777324     , 1.03319870535     , 0.988374276825    , 0.948570506856    ,
 0.963305310599    , 1.05164075555     , 1.20406761379     , 1.40691750949     ,
 1.63481512721     , 1.82044917226     , 1.8719813579      , 1.75139136539     ,
 1.52377808032     , 1.30368033556     , 1.15478304002     , 1.05614208615     ,
 0.95455335656     , 0.826996817801    , 0.69622280152     , 0.608483957378    ,
 0.604585327274    , 0.700930084276    , 0.883169113118    , 1.11033293278     ,
 1.32586388075     , 1.4730458017      , 1.5164216964      , 1.46464855691     ,
 1.37433786272     , 1.32143663404     , 1.35990858251     , 1.50084928621     ,
 1.72113799486     , 1.98396363111     , 2.25063964317     , 2.47913412554     ,
 2.6241329918      , 2.65360435346     , 2.56959296992     , 2.40688229443     ,
 2.21199193372     , 2.02818905377     , 1.89076147914     , 1.81521142933     ,
 1.77738487415     , 1.71173596207     , 1.55003370788     , 1.27892299772     ,
 0.958849567714    , 0.679714379927    , 0.498912775581    , 0.418957704789    ,
 0.40762491151     , 0.427823854932    , 0.45584106299     , 0.483167593871    ,
 0.505221649359    , 0.512016858785    , 0.495243538396    , 0.461641773958    ,
 0.42839169043     , 0.401689377931    , 0.368301341539    , 0.313389141075    ,
 0.240715616945    , 0.170105972183    , 0.118531342745    , 0.0882802236024   ,
 0.0721644470609   , 0.0658922424432   , 0.0741190946106   , 0.106242555281    ,
 0.166131272447    , 0.243447712282    , 0.315434266328    , 0.360174815432    ,
 0.369160471988    , 0.349879021785    , 0.323940349938    , 0.32360995267     ,
 0.375693610198    , 0.472128067223    , 0.557769294303    , 0.565703227958    ,
 0.475740257407    , 0.331690828238    , 0.199722130506    , 0.121262829213    ,
 0.104246417846    , 0.137010217479    , 0.196091090334    , 0.250788442364    ,
 0.278335956458    , 0.282271251531    , 0.294796450436    , 0.358271420103    ,
 0.49952237509     , 0.718605746711    , 1.00618530392     , 1.37405256768     ,
 1.85699428871     , 2.47120775458     , 3.17673797729     , 3.8941318674      ,
 4.5542552696      , 5.12623786688     , 5.61064988371     , 6.01493975458     ,
 6.32157251594     , 6.47131612975     , 6.39512232788     , 6.08142216811     ,
 5.60491811508     , 5.06920723774     , 4.52479145359     , 3.96645712226     ,
 3.40519292149     , 2.9070258507      , 2.55007381405     , 2.36276740084     ,
 2.31469734006     , 2.36533606431     , 2.52131750861     , 2.85111175335     ,
 3.45730252504     , 4.44162069182     , 5.87481377081     , 7.77006393674     ,
 10.0767822195     , 12.6984319047     , 15.518509482      , 18.443748736      ,
 21.4576232356     , 24.6003266223     , 27.8306674281     , 30.8886299191     ,
 25.0999438508     , 25.1695034517     , 24.32270849       , 22.7459996693     ,
 20.7665564124     , 18.6661232167     , 16.563571438      , 14.4538066441     ,
 12.3409545212     , 10.3240088119     , 8.55708770654     , 7.14056151203     ,
 6.06177109186     , 5.229542814       , 4.5438049624      , 3.93486334575     ,
 3.36366186559     , 2.80843035002     , 2.26033586106     , 1.73091285853     ,
 1.2547588666      , 0.874264429732    , 0.616529697259    , 0.481164171081    ,
 0.441297886119    , 0.451391954465    , 0.463700034263    , 0.450883711364    ,
 0.416873721785    , 0.385023129159    , 0.375992275214    , 0.39400565151     ,
 0.427815226829    , 0.461452829109    , 0.486034722425    , 0.504810076109    ,
 0.527084768816    , 0.555339566925    , 0.581293176792    , 0.599347893522    ,
 0.619477561223    , 0.658659155998    , 0.720216754957    , 0.785551316922    ,
 0.825162658467    , 0.820844649118    , 0.786907880026    , 0.769121050866    ,
 0.811501364418    , 0.923865925277    , 1.08884540961     , 1.28877435294     ,
 1.50247904971     , 1.67769486365     , 1.73940985763     , 1.6511074717      ,
 1.45947475762     , 1.25864137726     , 1.11149444095     , 1.01529271713     ,
 0.932386342558    , 0.836641629584    , 0.735032834651    , 0.661517237462    ,
 0.65601947393     , 0.743333081512    , 0.921669747497    , 1.15923956251     ,
 1.39557042646     , 1.55633889913     , 1.59037447915     , 1.50825326307     ,
 1.38168231824     , 1.29606496504     , 1.29900663831     , 1.38775572227     ,
 1.53490282201     , 1.71830277615     , 1.92375021193     , 2.12096268422     ,
 2.25032561454     , 2.25321219091     , 2.12050265674     , 1.90143811959     ,
 1.6657152911      , 1.46637730237     , 1.33059712462     , 1.26139744437     ,
 1.23313975689     , 1.19175240113     , 1.08041168507     , 0.882687711637    ,
 0.640945015553    , 0.42515807221     , 0.283235350684    , 0.219896608841    ,
 0.211235076881    , 0.229937962208    , 0.26051761135     , 0.298050843956    ,
 0.335727474414    , 0.358122574272    , 0.352037961648    , 0.321754728733    ,
 0.285535200228    , 0.255351358853    , 0.226303262845    , 0.188257241186    ,
 0.141821935997    , 0.0984164098502   , 0.067849904927    , 0.0503313030553   ,
 0.040169124482    , 0.034115351651    , 0.0351006211879   , 0.0493650405149   ,
 0.0806181335177   , 0.125688430022    , 0.175037185903    , 0.217640827658    ,
 0.24583314509     , 0.259527680512    , 0.272769766521    , 0.314988271711    ,
 0.411121101041    , 0.546026610278    , 0.652887249855    , 0.657348376729    ,
 0.543778445044    , 0.369712589288    , 0.213502095714    , 0.119844024106    ,
 0.0920850778318   , 0.111688768237    , 0.151564558469    , 0.183823280751    ,
 0.19328382026     , 0.188808389131    , 0.198430915648    , 0.250851279376    ,
 0.358441259574    , 0.515411465669    , 0.715185751809    , 0.972290118291    ,
 1.31941255647     , 1.7714528906      , 2.29513270509     , 2.82535408802     ,
 3.30997005393     , 3.73127672101     , 4.09180993817     , 4.39076426313     ,
 4.6083090402      , 4.70230914614     , 4.62815806032     , 4.37960762654     ,
 4.01002320383     , 3.59596363567     , 3.17923123799     , 2.76512805049     ,
 2.37544377172     , 2.07146430048     , 1.91106193476     , 1.89863441993     ,
 1.9896815487      , 2.14474351242     , 2.37810112705     , 2.76046690482     ,
 3.39179927132     , 4.37591570863     , 5.78931201327     , 7.63856290439     ,
 9.84030993366     , 12.2392641345     , 14.6461952332     , 16.9027355795     ,
 18.9608165998     , 20.8766642455     , 22.6682787568     , 24.1769181028     ,
 17.5276312366     , 17.0531572141     , 16.0364716027     , 14.652390465      ,
 13.1339880491     , 11.6433362253     , 10.2063148543     , 8.77258217013     ,
 7.33488485374     , 5.97958154981     , 4.82642109093     , 3.93775054523     ,
 3.29244342916     , 2.8258219012      , 2.47137913362     , 2.17468923985     ,
 1.89565781939     , 1.61035049881     , 1.3117436326      , 1.01035796149     ,
 0.731236187856    , 0.502350447873    , 0.341172938726    , 0.24962829715     ,
 0.215787712525    , 0.216599363029    , 0.224777693977    , 0.2220153888      ,
 0.208277103539    , 0.196969521284    , 0.200908219994    , 0.222206155004    ,
 0.25233833705     , 0.279179041649    , 0.295270559701    , 0.302712414522    ,
 0.310361079345    , 0.324282481871    , 0.342926442221    , 0.364996309014    ,
 0.397969989063    , 0.451185633667    , 0.520106061861    , 0.582474970246    ,
 0.612518167459    , 0.601695902027    , 0.571653591672    , 0.566259568089    ,
 0.621555298246    , 0.740209051062    , 0.898478371357    , 1.07146216546     ,
 1.2389441177      , 1.36982964284     , 1.42248015522     , 1.37684919082     ,
 1.26068524133     , 1.13050885248     , 1.02687143442     , 0.95282884911     ,
 0.887632430404    , 0.812547848454    , 0.729563211012    , 0.664507531863    ,
 0.653549984701    , 0.724401341631    , 0.883498233572    , 1.10669261959     ,
 1.33352153272     , 1.48312938912     , 1.50079214879     , 1.40127010921     ,
 1.26171056353     , 1.16685792182     , 1.15872852424     , 1.23007073417     ,
 1.35414807205     , 1.51467611054     , 1.70382171926     , 1.89032774988     ,
 2.00312269184     , 1.97090504478     , 1.78576173018     , 1.51531976968     ,
 1.25011067339     , 1.0482991863      , 0.923160168558    , 0.859416695357    ,
 0.82777148798     , 0.790248140399    , 0.710473428913    , 0.575641122383    ,
 0.41007412994     , 0.259084630178    , 0.156505368447    , 0.107933514821    ,
 0.0992150251409   , 0.114211856229    , 0.144827360194    , 0.187400517473    ,
 0.231968928769    , 0.259771348808    , 0.256278477635    , 0.225365052914    ,
 0.185512836102    , 0.151746813033    , 0.125131328548    , 0.0996360393172   ,
 0.0737117124367   , 0.0519611949028   , 0.0382586829843   , 0.0310974663064   ,
 0.0260732966194   , 0.0210841247191   , 0.0182824662936   , 0.0219370072157   ,
 0.0353263088359   , 0.0591675175226   , 0.0916999388001   , 0.129089476411    ,
 0.166126499963    , 0.200704599494    , 0.242577596414    , 0.314610506371    ,
 0.432682963342    , 0.57432860195     , 0.673538367284    , 0.665138621106    ,
 0.543062875052    , 0.367273716037    , 0.211953403635    , 0.1165387715      ,
 0.0814622601482   , 0.0878988746804   , 0.111216439187    , 0.128753028866    ,
 0.13073755935     , 0.12684328276     , 0.138310102328    , 0.181608504827    ,
 0.258376870309    , 0.359598868026    , 0.480859386849    , 0.635809866605    ,
 0.850910110062    , 1.13868528802     , 1.47577677502     , 1.81549991792     ,
 2.12306645518     , 2.39171828905     , 2.62676829634     , 2.82441200199     ,
 2.96624847557     , 3.02470767671     , 2.97471081654     , 2.81394164668     ,
 2.5751119532      , 2.30558409391     , 2.03324615476     , 1.76763001357     ,
 1.53369899104     , 1.38112174146     , 1.34892064329     , 1.4320036449      ,
 1.59291558671     , 1.80616219985     , 2.08849916529     , 2.49410811467     ,
 3.10034986363     , 3.99930544965     , 5.2664291134      , 6.90311961234     ,
 8.80517859215     , 10.7828337001     , 12.61315821       , 14.1236105073     ,
 15.2824261513     , 16.1907172178     , 16.9332990613     , 17.4407783833     ,
 11.464091518      , 10.8959084119     , 10.0324111945     , 9.00822468849     ,
 7.97078309819     , 6.99741887887     , 6.07093413144     , 5.14104149883     ,
 4.21024798965     , 3.35102997787     , 2.64495691893     , 2.12114373114     ,
 1.75478436036     , 1.50298289808     , 1.32515970963     , 1.18335223347     ,
 1.04622744606     , 0.897178950239    , 0.735166149845    , 0.570065175221    ,
 0.416962575093    , 0.28936357806     , 0.194545602345    , 0.133946602952    ,
 0.104412297892    , 0.0970756331641   , 0.0984888107133   , 0.0975094666831   ,
 0.0921338445392   , 0.0886755803897   , 0.0944284057482   , 0.111305245923    ,
 0.134724348677    , 0.156456819108    , 0.169456573876    , 0.172965012362    ,
 0.173373590132    , 0.178255282512    , 0.190611139792    , 0.211478244109    ,
 0.245306073535    , 0.296228378113    , 0.357588235582    , 0.409760722461    ,
 0.432256003555    , 0.42048190417     , 0.394549940615    , 0.39142176766     ,
 0.441059299986    , 0.545053548492    , 0.678685380168    , 0.811762290544    ,
 0.923920755955    , 1.00333923944     , 1.04188704962     , 1.03960369133     ,
 1.00966401068     , 0.970145934944    , 0.930486624707    , 0.888154547795    ,
 0.83472694868     , 0.764782935608    , 0.685689473335    , 0.621088964305    ,
 0.601785422696    , 0.652069314616    , 0.779566927359    , 0.964534319775    ,
 1.15250765394     , 1.27113438038     , 1.27478149192     , 1.18009910045     ,
 1.05499778108     , 0.97200385832     , 0.968973025435    , 1.04286437876     ,
 1.17045393708     , 1.3318526637      , 1.5114929007      , 1.67433028911     ,
 1.75360344565     , 1.68728567616     , 1.47655641754     , 1.19566771516     ,
 0.937686749475    , 0.756081153323    , 0.652081952033    , 0.598465978906    ,
 0.564843904057    , 0.526374018511    , 0.464054571589    , 0.371068542237    ,
 0.260604397207    , 0.159255779341    , 0.0883568367907   , 0.052604297737    ,
 0.0446852442631   , 0.0564879193117   , 0.0844116584275   , 0.12472375622     ,
 0.165755940556    , 0.189165896004    , 0.182958180197    , 0.152242624456    ,
 0.114168828882    , 0.0829188394618   , 0.0615651194986   , 0.0465699358505   ,
 0.035709534374    , 0.0298152100522   , 0.0289388804484   , 0.0297847881162   ,
 0.0280211974495   , 0.022408238518    , 0.0157908235334   , 0.0124453684068   ,
 0.0154343463063   , 0.0263126726125   , 0.0458793539181   , 0.0739417741746   ,
 0.10907122754     , 0.151769038647    , 0.209835860365    , 0.296162754138    ,
 0.412312582809    , 0.530166606748    , 0.596790595016    , 0.570548831356    ,
 0.458029163042    , 0.310523705593    , 0.183214211461    , 0.102674984016    ,
 0.0676378844497   , 0.0642998691096   , 0.0753628956173   , 0.0852838168296   ,
 0.0879140639717   , 0.0902759277942   , 0.105588969987    , 0.141202806729    ,
 0.193256168798    , 0.252673456387    , 0.316654622207    , 0.395702708521    ,
 0.508459469646    , 0.664603288767    , 0.850659959729    , 1.03755841023     ,
 1.20460471948     , 1.35117231368     , 1.48417182585     , 1.60179343406     ,
 1.69175430406     , 1.73748031844     , 1.72398311248     , 1.64750559994     ,
 1.52334151798     , 1.37632879123     , 1.22309043349     , 1.07386128013     ,
 0.950879321492    , 0.889805359463    , 0.91578226131     , 1.02559211927     ,
 1.20050168417     , 1.43373194965     , 1.73995574294     , 2.14679717753     ,
 2.69822779551     , 3.46491684485     , 4.51525773885     , 5.84835427693     ,
 7.35402317279     , 8.83360484569     , 10.0648401301     , 10.8993042423     ,
 11.3505701344     , 11.5707055321     , 11.6932216901     , 11.7002686903     ,
 7.10971965183     , 6.64409922381     , 6.01624195796     , 5.31817755963     ,
 4.64176701934     , 4.02433337643     , 3.44352665894     , 2.86598439514     ,
 2.30003050711     , 1.79496907275     , 1.39562398214     , 1.10973360428     ,
 0.917038377485    , 0.792283412127    , 0.710521039898    , 0.64433296232     ,
 0.571961341001    , 0.487268005721    , 0.397191570271    , 0.311833005859    ,
 0.237400948965    , 0.174721155045    , 0.122579362456    , 0.0820213781934   ,
 0.0557920533805   , 0.0435479670186   , 0.039877614749    , 0.0381841088973   ,
 0.0357684602414   , 0.0347093855074   , 0.0386375170768   , 0.0492389006419   ,
 0.0647494718503   , 0.0802561844271   , 0.0900867895958   , 0.092166369359    ,
 0.0904065685886   , 0.0913660552778   , 0.0990645872928   , 0.11494521984     ,
 0.14139308895     , 0.18062466651     , 0.228269663209    , 0.270907000929    ,
 0.293108280359    , 0.28917459105     , 0.271269967002    , 0.266482601893    ,
 0.300276415574    , 0.377197009804    , 0.476666388821    , 0.568473728193    ,
 0.633713918588    , 0.673493540852    , 0.701843086816    , 0.73312989111     ,
 0.772473447899    , 0.811686564914    , 0.833973895602    , 0.825053486644    ,
 0.780538336364    , 0.707118677666    , 0.62269785579     , 0.553374940976    ,
 0.524518902716    , 0.552823052981    , 0.641821725864    , 0.774418378885    ,
 0.908107240009    , 0.990287299788    , 0.990885487288    , 0.923018735982    ,
 0.832996127326    , 0.772807687745    , 0.776669564343    , 0.85077622525     ,
 0.977740502058    , 1.13073117284     , 1.28213385936     , 1.3969931464      ,
 1.42814310274     , 1.33895914191     , 1.14083448961     , 0.89794258199     ,
 0.685479035377    , 0.543661082522    , 0.467701625087    , 0.429447108408    ,
 0.401724600094    , 0.367133442539    , 0.316014275504    , 0.246852011777    ,
 0.169326487032    , 0.10009892653     , 0.0518213444253   , 0.0268810920358   ,
 0.0209505884566   , 0.0299381279813   , 0.0521696459581   , 0.0839538143103   ,
 0.114614975871    , 0.129560437123    , 0.121036054925    , 0.0948295679376   ,
 0.0647177075341   , 0.0413549903413   , 0.027362144024    , 0.0208408831004   ,
 0.0204423944498   , 0.0260008655758   , 0.0354071907163   , 0.0430133747203   ,
 0.0429996949728   , 0.0345119769193   , 0.0223653181761   , 0.0126603845269   ,
 0.00883499433513  , 0.0117430147354   , 0.0217296079142   , 0.0396762389236   ,
 0.0673265230343   , 0.108694293529    , 0.170481868876    , 0.25603343868     ,
 0.353992701517    , 0.434188638462    , 0.461464475388    , 0.420314188035    ,
 0.328144665192    , 0.222626455759    , 0.13553977501     , 0.0789831550154   ,
 0.0506758358382   , 0.0433499287091   , 0.0481908636355   , 0.0566205111129   ,
 0.0643749972309   , 0.0738073757897   , 0.0903219412124   , 0.115857200093    ,
 0.146265424489    , 0.175563898421    , 0.202764699245    , 0.234883194421    ,
 0.283261922857    , 0.354263237431    , 0.441272872862    , 0.528443964968    ,
 0.604838064827    , 0.672140954508    , 0.737108948562    , 0.801141470477    ,
 0.858898851855    , 0.901121881405    , 0.916663694276    , 0.898418262993    ,
 0.850349066528    , 0.784340814824    , 0.710707577099    , 0.638347060793    ,
 0.583367312757    , 0.568580238912    , 0.610519631186    , 0.712256006942    ,
 0.873714321805    , 1.10365279237     , 1.41288322949     , 1.80341622293     ,
 2.28519402646     , 2.90228013748     , 3.71149379544     , 4.7147813244      ,
 5.81384872066     , 6.82695042993     , 7.55763871347     , 7.89598406829     ,
 7.89571362401     , 7.7354579022      , 7.5658341506      , 7.39130896639     ,
 4.2443976267      , 3.92050999226     , 3.50367776098     , 3.04626812255     ,
 2.60557765984     , 2.20795079896     , 1.84497835223     , 1.50107444662     ,
 1.18157337652     , 0.909761723166    , 0.702751624545    , 0.559208024487    ,
 0.467697607612    , 0.41540975761     , 0.385419181007    , 0.356401422087    ,
 0.31434868186     , 0.261727048599    , 0.211276781144    , 0.172651123224    ,
 0.145163802714    , 0.12065046715     , 0.0926035752533   , 0.0626852726296   ,
 0.0379276513857   , 0.0228989949817   , 0.016228717386    , 0.0136191527424   ,
 0.0121667617347   , 0.011758662321    , 0.0137809417078   , 0.019310666226    ,
 0.027879697443    , 0.0369559769533   , 0.0429663529988   , 0.0441575669421   ,
 0.0426342089305   , 0.0426462182639   , 0.0471001318127   , 0.056992564609    ,
 0.0737264151568   , 0.0993482955824   , 0.132949291637    , 0.167731465197    ,
 0.192995067393    , 0.200848526784    , 0.194366598463    , 0.190216102895    ,
 0.208947105594    , 0.257891522583    , 0.322879850523    , 0.378840600757    ,
 0.410895333237    , 0.426493340074    , 0.448400244168    , 0.496917047295    ,
 0.575078343359    , 0.664471449409    , 0.734265645253    , 0.758129556013    ,
 0.727096125988    , 0.652648468533    , 0.561770704738    , 0.485381879396    ,
 0.445736850191    , 0.452163337739    , 0.502965463214    , 0.583684334001    ,
 0.665998978463    , 0.719068875541    , 0.727114290103    , 0.695848853368    ,
 0.646530444339    , 0.608609858261    , 0.611422459941    , 0.670488113728    ,
 0.776919930467    , 0.901581427501    , 1.00936401329     , 1.06897082767     ,
 1.05595803641     , 0.960717090022    , 0.801617085095    , 0.623922588155    ,
 0.475714337426    , 0.381031415107    , 0.333904355094    , 0.312591817146    ,
 0.295881552948    , 0.269714147949    , 0.227663452019    , 0.171954802895    ,
 0.113047604714    , 0.0635912189865   , 0.0307762810543   , 0.0143138817309   ,
 0.0104477553566   , 0.0164921257758   , 0.0313470020611   , 0.0520294356072   ,
 0.0708475778029   , 0.078348645087    , 0.0705501268922   , 0.052341076962    ,
 0.0329161244067   , 0.0188119823437   , 0.0116983140918   , 0.0111386750451   ,
 0.0174586054746   , 0.0309596863647   , 0.0483409455678   , 0.0614629615853   ,
 0.0623151960961   , 0.0500900299026   , 0.031930232659    , 0.0164279812241   ,
 0.0077817709859   , 0.00588496154841  , 0.00970150978543  , 0.0197307582206   ,
 0.0389994397883   , 0.0732332773332   , 0.128088245424    , 0.201279633227    ,
 0.275288742785    , 0.322129348868    , 0.321266422642    , 0.274870918121    ,
 0.205207381497    , 0.13760443317     , 0.0860406952405   , 0.0523270519146   ,
 0.033723699558    , 0.0278976217143   , 0.0325161061197   , 0.04406735217     ,
 0.0585482523623   , 0.072971279566    , 0.086162386797    , 0.0979897196762   ,
 0.107893722453    , 0.115109997962    , 0.120676550639    , 0.128569804516    ,
 0.144260027287    , 0.170794166987    , 0.205042890445    , 0.239282627211    ,
 0.268357478145    , 0.294056687534    , 0.321512116375    , 0.353696403181    ,
 0.389897372307    , 0.425459638145    , 0.451704041938    , 0.460393370025    ,
 0.450312621819    , 0.42723935967     , 0.398322226101    , 0.370450588106    ,
 0.353667073887    , 0.361204361396    , 0.403968632701    , 0.488970557142    ,
 0.627030893097    , 0.835951587663    , 1.12518223884     , 1.48175541097     ,
 1.88993714053     , 2.36566506011     , 2.94801360698     , 3.64294843705     ,
 4.37883579699     , 5.01447212989     , 5.39768639583     , 5.45429240613     ,
 5.24942366502     , 4.94736165677     , 4.68448348483     , 4.47594882361     ,
 2.48179774588     , 2.2756896848      , 2.01931130465     , 1.72984829052     ,
 1.4389612035      , 1.17232659617     , 0.939253272795    , 0.738230689828    ,
 0.568955078518    , 0.434522220945    , 0.335501565196    , 0.26847922548     ,
 0.229505660324    , 0.213128885942    , 0.207363058642    , 0.196167056739    ,
 0.171307823108    , 0.139162388894    , 0.113315608366    , 0.101422684567    ,
 0.0988967508501   , 0.0937517962305   , 0.0778579018036   , 0.0538110377866   ,
 0.0307534469778   , 0.0152880799859   , 0.00769353879045  , 0.00475831242331  ,
 0.00367816988432  , 0.00345280154202  , 0.00430900818228  , 0.00671515183587  ,
 0.0105928157396   , 0.0148406242944   , 0.0177144519832   , 0.0182727154528   ,
 0.0174961539898   , 0.0175057945223   , 0.0197872841075   , 0.0248821503714   ,
 0.0338063516222   , 0.0486960847652   , 0.0710891895461   , 0.0991794947191   ,
 0.126532222673    , 0.144702695972    , 0.150396827001    , 0.151331914986    ,
 0.161751163713    , 0.188921508323    , 0.224589487509    , 0.251930885553    ,
 0.262231553728    , 0.264928540509    , 0.281918388548    , 0.332766829634    ,
 0.421780470463    , 0.532378312829    , 0.631672068019    , 0.685004019814    ,
 0.673487607877    , 0.604843113071    , 0.509937291329    , 0.425016307706    ,
 0.373042562715    , 0.359403548051    , 0.378745140129    , 0.419244724372    ,
 0.464338697765    , 0.499330700419    , 0.517382103189    , 0.517194886926    ,
 0.500690769317    , 0.478751632116    , 0.473641181787    , 0.505941584451    ,
 0.57613894543     , 0.660481638932    , 0.724913901602    , 0.743347417174    ,
 0.706862091903    , 0.623235253461    , 0.513125494541    , 0.404001280129    ,
 0.319467842308    , 0.268841125378    , 0.246043833169    , 0.23737588809     ,
 0.228776683517    , 0.208975859334    , 0.172895265213    , 0.125134169928    ,
 0.0774695032814   , 0.0405782546503   , 0.0180928756167   , 0.00759065015571  ,
 0.00515701324228  , 0.00847515796359  , 0.0165974452202   , 0.0275931615627   ,
 0.0370632978147   , 0.040044227266    , 0.0349166376565   , 0.0247852202784   ,
 0.0146436221517   , 0.00782644611941  , 0.00540583349581  , 0.00810891841823  ,
 0.0176529088992   , 0.0350046524668   , 0.0564184116136   , 0.0723743961346   ,
 0.0735538152402   , 0.0591287551413   , 0.0375742083575   , 0.0189389987442   ,
 0.00787452954971  , 0.00365962587143  , 0.00421781266254  , 0.00923160140538  ,
 0.0213433013632   , 0.0458287067104   , 0.0871478390971   , 0.141677894323    ,
 0.192865818335    , 0.218264363797    , 0.206189728556    , 0.165246540177    ,
 0.116067818312    , 0.0751444180597   , 0.047215511769    , 0.0296705402513   ,
 0.0199707078901   , 0.0183667185537   , 0.0261042584694   , 0.0424687688297   ,
 0.0628049899833   , 0.0795617655639   , 0.0869515736108   , 0.0848945998212   ,
 0.0777245180142   , 0.0699665827701   , 0.0642705537192   , 0.0621314558329   ,
 0.0648282491371   , 0.0728602044978   , 0.0845754642145   , 0.0965788185404   ,
 0.106589124035    , 0.115409359297    , 0.125749367625    , 0.140221003937    ,
 0.160239101549    , 0.184369976888    , 0.207118314642    , 0.221723519619    ,
 0.225303902183    , 0.220379512323    , 0.212082618264    , 0.205982581289    ,
 0.20852900933     , 0.226997201329    , 0.267438255941    , 0.335630214619    ,
 0.444112945395    , 0.613814807513    , 0.857541409203    , 1.16186147576     ,
 1.4990673682      , 1.85992568042     , 2.25941517926     , 2.70242005995     ,
 3.14885063402     , 3.51146383798     , 3.69147176503     , 3.64063707655     ,
 3.40668515015     , 3.10824371718     , 2.84969128346     , 2.65559559182     ,
 1.44420708416     , 1.31932728253     , 1.17428563371     , 1.00023462138     ,
 0.808655398077    , 0.62384476472     , 0.467106261891    , 0.346357888969    ,
 0.258352989101    , 0.195549655074    , 0.150969047063    , 0.121088622594    ,
 0.105586864467    , 0.102644946125    , 0.104606510095    , 0.101083095284    ,
 0.0878282285802   , 0.0708787832211   , 0.0605866254492   , 0.0617535981636   ,
 0.0690104508295   , 0.0712930832068   , 0.0616887163852   , 0.0431041984741   ,
 0.024141596754    , 0.0110194189915   , 0.00439908300818  , 0.00184995339271  ,
 0.00104454002477  , 0.000887631583099 , 0.00118273579346  , 0.0020445436319   ,
 0.00346195557564  , 0.00503880951157  , 0.00611219304262  , 0.00631804307474  ,
 0.00603844418127  , 0.00610074025045  , 0.00709186917717  , 0.00931082788647  ,
 0.0135677270364   , 0.0218292003533   , 0.0366462220935   , 0.0591003292361   ,
 0.0862379588842   , 0.111026145076    , 0.127433416649    , 0.136588595954    ,
 0.145563179521    , 0.158690306304    , 0.171985402577    , 0.177810961616    ,
 0.174717354701    , 0.17213245103     , 0.186136257032    , 0.231366786369    ,
 0.313611319476    , 0.42326834682     , 0.532753889312    , 0.604552792956    ,
 0.61046661778     , 0.550540075469    , 0.454789009414    , 0.363108551371    ,
 0.301047634073    , 0.272991423532    , 0.27161939016     , 0.286969084241    ,
 0.309747120193    , 0.333936970905    , 0.356696411581    , 0.373131986752    ,
 0.375605424996    , 0.363596017076    , 0.351118190739    , 0.357811438545    ,
 0.390750338891    , 0.435877519139    , 0.467258120457    , 0.465208195618    ,
 0.42793943941     , 0.369283536196    , 0.30822651495     , 0.259754233196    ,
 0.230058094096    , 0.216064001781    , 0.210048463313    , 0.205154205812    ,
 0.195530985773    , 0.17467707039     , 0.139528291833    , 0.0958738839294   ,
 0.055375463485    , 0.0266437131266   , 0.0107524623576   , 0.0039743577472   ,
 0.0023454850106   , 0.00373458377772  , 0.00731073601639  , 0.0120446950812   ,
 0.0159268974108   , 0.016854816884    , 0.0143162783804   , 0.00982460954539  ,
 0.00557123360746  , 0.00300538570333  , 0.00289516020579  , 0.00648096997808  ,
 0.0159398498199   , 0.0324680281375   , 0.0526573875313   , 0.0676433225323   ,
 0.0687533195135   , 0.0552529233395   , 0.0350793504669   , 0.0175957744671   ,
 0.00705375940724  , 0.00257950358606  , 0.00188450997988  , 0.00412225982378  ,
 0.0108937688488   , 0.0258906600757   , 0.0522638679108   , 0.0873774429519   ,
 0.119495404779    , 0.133204860011    , 0.121601041583    , 0.0924359655031   ,
 0.0607841024324   , 0.0370097668929   , 0.0225410918749   , 0.0143809071865   ,
 0.0107432978054   , 0.0128393592308   , 0.023223688392    , 0.0423176095833   ,
 0.0650201705313   , 0.0814689256136   , 0.0837991068853   , 0.0726341112188   ,
 0.0556676123958   , 0.0406097689311   , 0.0307687659954   , 0.0259382610094   ,
 0.0250225218883   , 0.0272212724872   , 0.0317035560804   , 0.037278562741    ,
 0.0427814546052   , 0.0475285863144   , 0.0516010502828   , 0.056370115274    ,
 0.0643012642667   , 0.0767843716463   , 0.0918201824972   , 0.104769748611    ,
 0.11186651342     , 0.113049056946    , 0.111999778265    , 0.114259821729    ,
 0.125337261695    , 0.14926193516     , 0.187308931082    , 0.239994827887    ,
 0.315160007042    , 0.432719731938    , 0.611731319467    , 0.848808798195    ,
 1.11717369978     , 1.39053911204     , 1.65988950004     , 1.92376917684     ,
 2.16818147213     , 2.35634960048     , 2.43777877269     , 2.379566272       ,
 2.19961258219     , 1.9642506534      , 1.74507098705     , 1.57551483797     ,
 0.848021439895    , 0.77198680866     , 0.694527604234    , 0.594401302587    ,
 0.470663551346    , 0.34295997435     , 0.23526989731     , 0.159276905511    ,
 0.111777298817    , 0.0826637412775   , 0.0633127685788   , 0.0503294275286   ,
 0.0440589364007   , 0.0440977927948   , 0.0464340981395   , 0.0456072779392   ,
 0.0397736250849   , 0.0327826791459   , 0.0306265453914   , 0.035638599329    ,
 0.0436796638983   , 0.0471124751221   , 0.0414385753458   , 0.0290374561908   ,
 0.0161288176341   , 0.00713679876743  , 0.00257999369388  , 0.000833959224358 ,
 0.000311030284302 , 0.000205538566946 , 0.000282760339922 , 0.000532323991924 ,
 0.000946750169823 , 0.00140981612788  , 0.00172425937008  , 0.00178401079678  ,
 0.00171009186504  , 0.00175903013828  , 0.00212999151521  , 0.00302524979431  ,
 0.00509846429148  , 0.00999118662172  , 0.0203337824459   , 0.0384525047358   ,
 0.0638461522747   , 0.0918362047698   , 0.116251070526    , 0.133976831041    ,
 0.145416011942    , 0.15076828687     , 0.148739535979    , 0.139946287497    ,
 0.129822257155    , 0.127102419023    , 0.140515407894    , 0.177723843496    ,
 0.244296688361    , 0.337394128824    , 0.437354348559    , 0.5094462434      ,
 0.522101295159    , 0.469864908652    , 0.379222080893    , 0.289372291187    ,
 0.226194414566    , 0.193544158553    , 0.183258330007    , 0.186552971268    ,
 0.197673452925    , 0.213878450171    , 0.2336014146      , 0.252073988499    ,
 0.260623255767    , 0.254415056991    , 0.240083579314    , 0.231837781141    ,
 0.238507408669    , 0.254803600324    , 0.265356009106    , 0.257744443646    ,
 0.232879265979    , 0.204005362391    , 0.186526368037    , 0.187557639943    ,
 0.201603804135    , 0.215000542776    , 0.216932759067    , 0.20629078627     ,
 0.186465648714    , 0.157676180347    , 0.11951187413     , 0.0776565376054   ,
 0.0419925161335   , 0.0186404063566   , 0.00680332077491  , 0.00216940176775  ,
 0.000985655780108 , 0.00136206030838  , 0.00261086896075  , 0.0042492394757   ,
 0.00553650919666  , 0.00575638751112  , 0.00478718099322  , 0.00320375844871  ,
 0.00178472520664  , 0.0010872838499   , 0.001644728816    , 0.00457630792941  ,
 0.0116799326114   , 0.0239344521422   , 0.0388537750344   , 0.0499059134861   ,
 0.0507067695809   , 0.0407328789684   , 0.025847109815    , 0.0129453752117   ,
 0.00513419252747  , 0.00171101413367  , 0.000867860695566 , 0.00173096266432  ,
 0.00501254200743  , 0.0127760767777   , 0.0269273909849   , 0.0461560985319   ,
 0.0638520735048   , 0.0711139685386   , 0.0639527967688   , 0.0470300106284   ,
 0.0292431618392   , 0.0165090434778   , 0.00939733942652  , 0.00600385302461  ,
 0.00542620440302  , 0.00899605587625  , 0.0192141904137   , 0.0367329988582   ,
 0.0569503458033   , 0.0705665021233   , 0.0701875158646   , 0.0568318962692   ,
 0.0385692539997   , 0.0232693190875   , 0.0139097410145   , 0.00955807705773  ,
 0.00843148051894  , 0.00960452764909  , 0.0130249062353   , 0.0187093522522   ,
 0.0257121051947   , 0.0316861270028   , 0.0342330369224   , 0.0335079984362   ,
 0.0330108638059   , 0.0368310965057   , 0.0458985421733   , 0.0569511026142   ,
 0.0651498235174   , 0.0683251492003   , 0.0693885835642   , 0.0747261304814   ,
 0.0902698380719   , 0.118258419837    , 0.15559738214     , 0.196188386818    ,
 0.240632359074    , 0.305494344938    , 0.415310536014    , 0.579072410471    ,
 0.777937292294    , 0.979281124026    , 1.15905389819     , 1.30991456905     ,
 1.43370080174     , 1.52716010327     , 1.57185504453     , 1.54231667671     ,
 1.43127444774     , 1.26552287103     , 1.09230798124     , 0.949685479408    ,
 0.50987593625     , 0.459747059926    , 0.415313189152    , 0.355856055191    ,
 0.276908331814    , 0.192200328582    , 0.120879477979    , 0.073031829751    ,
 0.0463292136638   , 0.0324245809556   , 0.024216006264    , 0.0187917325789   ,
 0.0161319830931   , 0.016190257247    , 0.0172985833576   , 0.0171768703965   ,
 0.0151771766162   , 0.0131405605316   , 0.0137761017012   , 0.0179463569763   ,
 0.0232581070455   , 0.0255887198862   , 0.0226243491898   , 0.0158376543928   ,
 0.00875060121081  , 0.00382229092368  , 0.00133147083832  , 0.000382545892201 ,
 0.000104124274818 , 4.54885826381e-05 , 5.81049459415e-05 , 0.000115514329103 ,
 0.000211779827308 , 0.000319220108835 , 0.000391717606666 , 0.000405627534305 ,
 0.000392626869257 , 0.000422616904508 , 0.000582276087533 , 0.00106957634176  ,
 0.00248190124209  , 0.00620613623854  , 0.0145344388738   , 0.0298797401041   ,
 0.0529358542985   , 0.0811914432727   , 0.109727997337    , 0.13346141912     ,
 0.148012576983    , 0.149901980317    , 0.139117960803    , 0.121985623824    ,
 0.10889240708     , 0.107725292603    , 0.120761831803    , 0.148830679395    ,
 0.195588491606    , 0.262496960096    , 0.337681385128    , 0.393695672286    ,
 0.402793584072    , 0.358528047329    , 0.282297873374    , 0.207138706483    ,
 0.154836451243    , 0.127887119723    , 0.118475598569    , 0.119157466699    ,
 0.125594500518    , 0.135384652277    , 0.147186055871    , 0.158716370619    ,
 0.165088317453    , 0.161812230585    , 0.150202265085    , 0.137689727467    ,
 0.131337207593    , 0.131269466285    , 0.130991935496    , 0.124637215533    ,
 0.114443802636    , 0.111277176061    , 0.126976433463    , 0.163578026385    ,
 0.207621064566    , 0.237173304215    , 0.238716775273    , 0.216376637283    ,
 0.18254679275     , 0.144277164034    , 0.103325336351    , 0.063879670026    ,
 0.0328290696377   , 0.0137329044942   , 0.00464497396699  , 0.00130528823783  ,
 0.000419617390459 , 0.000413327911779 , 0.000748525344879 , 0.00120097563651  ,
 0.00154411464752  , 0.00158138478274  , 0.00129262545278  , 0.000849802743084 ,
 0.000479234222371 , 0.000378454051807 , 0.000859699535475 , 0.00263394810811  ,
 0.00679951174339  , 0.0139498535534   , 0.0226409876485   , 0.029068650505    ,
 0.0295209254648   , 0.0237029636672   , 0.0150336016041   , 0.0075240594408   ,
 0.00297328231447  , 0.000956237540268 , 0.000383822820255 , 0.00065680945135  ,
 0.00200293140678  , 0.00535611086244  , 0.011666258015    , 0.0204499985078   ,
 0.0286963232222   , 0.0321656584457   , 0.0288412222073   , 0.0208594929612   ,
 0.0124739871871   , 0.00655739082369  , 0.00342060315872  , 0.00219991514349  ,
 0.0026145949451   , 0.00570985625113  , 0.0132938188988   , 0.0258738771717   ,
 0.0401535913339   , 0.0494085810278   , 0.0483375379676   , 0.0378585521597   ,
 0.0240759376478   , 0.0128405916183   , 0.00622911816969  , 0.00335933438662  ,
 0.0028527242579   , 0.00431672245972  , 0.00843459038875  , 0.0159260460366   ,
 0.0257358927389   , 0.034099996078    , 0.0366930411368   , 0.0328242846159   ,
 0.0269707040561   , 0.0253115980763   , 0.0306682922405   , 0.0404452130833   ,
 0.0490824708294   , 0.0533040654818   , 0.0557998597826   , 0.0636341804673   ,
 0.0830509908911   , 0.115050492131    , 0.153243868277    , 0.186122788485    ,
 0.207898665986    , 0.231101010226    , 0.282391381218    , 0.378997142295    ,
 0.510671352981    , 0.647417746998    , 0.762358798925    , 0.846889929173    ,
 0.909255111413    , 0.960276726144    , 0.996145452761    , 0.995284042822    ,
 0.937773771919    , 0.828871406364    , 0.70017890869     , 0.587821574871    ,
 0.316062642799    , 0.279792519225    , 0.248190962649    , 0.207979911115    ,
 0.157038545565    , 0.104161447116    , 0.0608618656735   , 0.0328615173791   ,
 0.0182600224691   , 0.0115728276642   , 0.00820493704274  , 0.00611976380548  ,
 0.00503835862052  , 0.00493392766418  , 0.00525640269502  , 0.0052542020715   ,
 0.00475099191208  , 0.0044352568061   , 0.00527957424521  , 0.00751927941282  ,
 0.0100772672253   , 0.0111865438279   , 0.00989622149546  , 0.0069093974838   ,
 0.00380002894753  , 0.00164749947795  , 0.000564955159868 , 0.000155078855633 ,
 3.60709409772e-05 , 1.03269919813e-05 , 1.01789657374e-05 , 2.04613673788e-05 ,
 3.81364067443e-05 , 5.78129719541e-05 , 7.10413401909e-05 , 7.41613196392e-05 ,
 7.68606217409e-05 , 0.000111696972375 , 0.000277472367866 , 0.000877342374441 ,
 0.00265962376486  , 0.00698788797754  , 0.0156214516424   , 0.0300016181719   ,
 0.0504338020358   , 0.0756915039201   , 0.102995060224    , 0.127765700479    ,
 0.14355562792     , 0.144433798893    , 0.130273810359    , 0.10971215539     ,
 0.0952552197257   , 0.0939945321989   , 0.104275928083    , 0.122253251994    ,
 0.149148185936    , 0.188155554733    , 0.233714469015    , 0.267664468178    ,
 0.270339630359    , 0.237093764227    , 0.183262761419    , 0.132230559568    ,
 0.0988263418394   , 0.0837679254099   , 0.0807182383608   , 0.0841243904484   ,
 0.090207763478    , 0.0957232409296   , 0.0993082524464   , 0.101880201171    ,
 0.103460850364    , 0.101373279288    , 0.0933772620719   , 0.0813050810716   ,
 0.0698464114815   , 0.0619891533664   , 0.0569210059366   , 0.0531119359033   ,
 0.0534008071555   , 0.0664379656362   , 0.101160003532    , 0.156273680301    ,
 0.21379584184     , 0.247585820804    , 0.243554545284    , 0.210011290966    ,
 0.165716255898    , 0.12250188218     , 0.0831166169984   , 0.0493162647188   ,
 0.0244703503728   , 0.00987176412465  , 0.00319399656318  , 0.000832566740396 ,
 0.000201506576998 , 0.0001110520153   , 0.000172260221911 , 0.000270669733879 ,
 0.000343787670586 , 0.000347526088567 , 0.000280045259086 , 0.000182205438735 ,
 0.000108949812925 , 0.00012584077467  , 0.000378956359569 , 0.00120914733289  ,
 0.00313279370386  , 0.00642700594217  , 0.010426401225    , 0.0133793474279   ,
 0.0135803044194   , 0.0108983403254   , 0.00690892863309  , 0.00345596847054  ,
 0.00136358790021  , 0.000431912389645 , 0.000150234316053 , 0.000216043596792 ,
 0.000674795471572 , 0.001867843091    , 0.00417555895858  , 0.00746183516812  ,
 0.0106158440011   , 0.0120010033051   , 0.0107865337985   , 0.00774853950314  ,
 0.00452402628652  , 0.00224978056581  , 0.00108039267786  , 0.000723889466619 ,
 0.00116953313767  , 0.0030508211259   , 0.00738987222506  , 0.0144736822772   ,
 0.0224410112575   , 0.0274987924858   , 0.0266826592568   , 0.0205740759058   ,
 0.012687834624    , 0.00635278668015  , 0.00271285144105  , 0.0012484119826   ,
 0.00129303108762  , 0.00303209986454  , 0.00759236054152  , 0.0160001725238   ,
 0.0271346873658   , 0.0366267925657   , 0.0393289691229   , 0.0341453004556   ,
 0.0258429368235   , 0.0212930327719   , 0.0240074559441   , 0.0319174636137   ,
 0.0397983445419   , 0.0444827864998   , 0.0485259667113   , 0.0586258010988   ,
 0.0804062848992   , 0.113904785107    , 0.151242991857    , 0.178589035428    ,
 0.186822698517    , 0.184803574261    , 0.197185504332    , 0.243143953927    ,
 0.318540763059    , 0.400953513527    , 0.469211075736    , 0.517030392769    ,
 0.552569946428    , 0.587190387804    , 0.620520116397    , 0.63492209529     ,
 0.609431605166    , 0.541563873343    , 0.452876021418    , 0.372418291309    ,
 0.19834275638     , 0.171332525555    , 0.145752236955    , 0.115843147183    ,
 0.0827627585122   , 0.0518969373788   , 0.0283650271781   , 0.0138889294585   ,
 0.00670440021854  , 0.00368958719337  , 0.00239665875875  , 0.00169068019726  ,
 0.00131315270422  , 0.00122611351713  , 0.00128263237298  , 0.00128723883231  ,
 0.00120541319452  , 0.0012430458155   , 0.00168065574813  , 0.00256233372959  ,
 0.00350572409196  , 0.00390639345976  , 0.00345108982889  , 0.00240162428778  ,
 0.0013149903832   , 0.000566793331897 , 0.000192631373238 , 5.18613726036e-05 ,
 1.13029636562e-05 , 2.42493620892e-06 , 1.53387718226e-06 , 2.91849847672e-06 ,
 5.47216551973e-06 , 8.32234682837e-06 , 1.03526501554e-05 , 1.21245588388e-05 ,
 2.26470904718e-05 , 8.77680882078e-05 , 0.000390179205943 , 0.00148114452056  ,
 0.00454562676591  , 0.0112359499737   , 0.0226386738022   , 0.0381212471056   ,
 0.0558120038437   , 0.0746020243286   , 0.0945513667301   , 0.114053738131    ,
 0.127414266872    , 0.127699224032    , 0.113654599895    , 0.0931915871601   ,
 0.0781363616804   , 0.0747128341553   , 0.0801259005234   , 0.0888991003639   ,
 0.100452770668    , 0.117876891993    , 0.13972500849     , 0.15619112746     ,
 0.155789426664    , 0.135888289466    , 0.105872792564    , 0.0797004989346   ,
 0.0655790099293   , 0.0628069200234   , 0.0668452687922   , 0.0741409880812   ,
 0.0814177312868   , 0.0847309624444   , 0.082900844212    , 0.0794799177728   ,
 0.0779724599936   , 0.0766260333018   , 0.0706198714169   , 0.0584256860888   ,
 0.0437571249199   , 0.0315468564146   , 0.0240179178519   , 0.0215378016331   ,
 0.0265713286836   , 0.0455958860353   , 0.0849447562668   , 0.14140589538     ,
 0.196439057341    , 0.224993650751    , 0.215066470975    , 0.176960046533    ,
 0.13110580882     , 0.0906551255454   , 0.0582214562663   , 0.0332469307754   ,
 0.0160607438363   , 0.0063370505973   , 0.00200318966987  , 0.000504072199741 ,
 0.000105512385359 , 3.07393399909e-05 , 3.2359305588e-05  , 4.85385887816e-05 ,
 6.08906813119e-05 , 6.08561992655e-05 , 4.84719111916e-05 , 3.15277397281e-05 ,
 2.15156289923e-05 , 3.82497889808e-05 , 0.000135636824893 , 0.000440258898615 ,
 0.00114190577868  , 0.00234177885164  , 0.0037969951255   , 0.0048696498802   ,
 0.00494005383096  , 0.00396234236646  , 0.0025106539707   , 0.0012552678916   ,
 0.00049484317301  , 0.000155545051263 , 4.9382724659e-05  , 5.97335226238e-05 ,
 0.000187684602687 , 0.000533090406817 , 0.00121651955677  , 0.00220841008587  ,
 0.00317871870561  , 0.00362215214169  , 0.00326833008427  , 0.0023430642784   ,
 0.00134944722794  , 0.000646124310097 , 0.00029235628969  , 0.000216152108462 ,
 0.000460068183414 , 0.00132264503182  , 0.00325917391998  , 0.00639471392873  ,
 0.00990111242449  , 0.0120986431551   , 0.0116859564115   , 0.00894080503104  ,
 0.00543532861865  , 0.0026447852572   , 0.00107062764245  , 0.00050760975783  ,
 0.000796172031913 , 0.00238933444526  , 0.00642300606384  , 0.0138668233643   ,
 0.0237448125916   , 0.0321620511515   , 0.0344934291023   , 0.0296568846575   ,
 0.0217086083324   , 0.016565764231    , 0.0173513965666   , 0.0226394589217   ,
 0.0285302385007   , 0.0327724256519   , 0.0375169073854   , 0.0479821683076   ,
 0.0683367133081   , 0.0980621708032   , 0.129899042442    , 0.151341468948    ,
 0.153495576873    , 0.142175966117    , 0.136489642957    , 0.152346621189    ,
 0.188990165617    , 0.232932310309    , 0.271636124281    , 0.301704632181    ,
 0.327669919114    , 0.35541260314     , 0.383615981902    , 0.399773029908    ,
 0.388503333008    , 0.346833652801    , 0.289344002359    , 0.236403773556    ,
 0.122118097795    , 0.101766817416    , 0.0817691188671   , 0.0603736383438   ,
 0.0398477651865   , 0.0231637572784   , 0.0117645020844   , 0.00527556876418  ,
 0.00223286512151  , 0.00103913357035  , 0.000593313922621 , 0.000387945872932 ,
 0.000281089615148 , 0.000245933610328 , 0.000249319600878 , 0.000251030532345 ,
 0.000247163181358 , 0.000287625402989 , 0.000437985947922 , 0.000702525168187 ,
 0.000973685347177 , 0.0010862911261   , 0.000957594923903 , 0.000664080588053 ,
 0.000362035768988 , 0.000155223473298 , 5.2396409626e-05  , 1.39554772015e-05 ,
 2.95806868267e-06 , 5.45261487235e-07 , 2.05698449052e-07 , 3.33148756538e-07 ,
 6.22818132317e-07 , 9.66482831192e-07 , 1.44151462394e-06 , 4.00788920795e-06 ,
 2.30463111881e-05 , 0.000135589734429 , 0.000652064937564 , 0.00248583930695  ,
 0.00748636760185  , 0.0178491208061   , 0.0339319006308   , 0.052276882194    ,
 0.0675060781341   , 0.0775739794184   , 0.0855582593773   , 0.0944058468594   ,
 0.101347979111    , 0.0999485519114   , 0.0876752965942   , 0.0699455926666   ,
 0.0558982073259   , 0.0504936982891   , 0.0515208756632   , 0.0542411793433   ,
 0.0573627703212   , 0.0630604704728   , 0.0718907624328   , 0.0797205865471   ,
 0.0807102100559   , 0.0730600790385   , 0.0613765127706   , 0.0530624111476   ,
 0.0522426704988   , 0.0576604287557   , 0.06614853781     , 0.075618554719    ,
 0.0834782769959   , 0.0858975992951   , 0.0822118147866   , 0.0773230231857   ,
 0.0758096178744   , 0.0753592005715   , 0.0693864866207   , 0.0552433254275   ,
 0.0372108526025   , 0.0218055481286   , 0.0125868791127   , 0.0102111413105   ,
 0.0160665757033   , 0.0342859016256   , 0.068515856227    , 0.114553600963    ,
 0.156519673115    , 0.174828871015    , 0.161605576661    , 0.126904565868    ,
 0.0882879829469   , 0.0568470597403   , 0.0342993792632   , 0.0187570454918   ,
 0.00882259849256  , 0.00342163515795  , 0.00106687010251  , 0.000264177087828 ,
 5.23368223331e-05 , 1.00720282063e-05 , 5.29565063101e-06 , 6.94047107957e-06 ,
 8.55711589721e-06 , 8.46566690751e-06 , 6.68366650648e-06 , 4.42040172019e-06 ,
 3.81514747144e-06 , 1.0059565636e-05  , 3.8824541581e-05  , 0.000126936097768 ,
 0.000329285942836 , 0.000674969331327 , 0.00109380454666  , 0.00140201356587  ,
 0.00142148974273  , 0.00113954581944  , 0.000721689188525 , 0.000360659670968 ,
 0.000142086158352 , 4.44625561806e-05 , 1.32672373243e-05 , 1.36035683452e-05 ,
 4.24443419876e-05 , 0.000122924289597 , 0.000285048880282 , 0.00052385396369  ,
 0.000760963244427 , 0.000872749579404 , 0.00079045247968  , 0.000566654261178 ,
 0.000323922032758 , 0.000151508484734 , 6.66819327629e-05 , 5.77799741314e-05 ,
 0.000151731175962 , 0.000458039663525 , 0.00113655266349  , 0.00222980276349  ,
 0.00344708688881  , 0.00420262119313  , 0.00404667208978  , 0.0030821031485   ,
 0.00186019172637  , 0.000894260774454 , 0.000360666579792 , 0.00021243302221  ,
 0.000492049988019 , 0.00161263512903  , 0.00440378254039  , 0.00955190953593  ,
 0.0163857035508   , 0.0222061926361   , 0.0237967749088   , 0.0203661997956   ,
 0.0146361876753   , 0.0105935974335   , 0.0103727362909   , 0.0131821229649   ,
 0.0167328600703   , 0.0198259218207   , 0.0239634044573   , 0.0324352343279   ,
 0.0477433186739   , 0.0692919677449   , 0.0919976775448   , 0.10728998579     ,
 0.109009888343    , 0.100482468256    , 0.0932421999519   , 0.0968064836176   ,
 0.111531905735    , 0.131957652792    , 0.153820500787    , 0.176132984597    ,
 0.199189134888    , 0.222690724588    , 0.243756634638    , 0.255122287851    ,
 0.24822640638     , 0.221361535098    , 0.183691586231    , 0.148446775724    ,
 0.0738616770834   , 0.0571555474335   , 0.0425023398407   , 0.0288471841101   ,
 0.0173730672881   , 0.00920409455884  , 0.00428019108963  , 0.00175434991629  ,
 0.000658822371467 , 0.000257533956313 , 0.000124011683324 , 7.30480018116e-05 ,
 4.88851594784e-05 , 3.95879965155e-05 , 3.84607335797e-05 , 3.89123674166e-05 ,
 4.10645539471e-05 , 5.47921870504e-05 , 9.25853230242e-05 , 0.000154080284495 ,
 0.000215273279434 , 0.000240136513508 , 0.000211162616628 , 0.000145933056597 ,
 7.92246922007e-05 , 3.37983268112e-05 , 1.13400358241e-05 , 2.99650519629e-06 ,
 6.25981154775e-07 , 1.07404547592e-07 , 2.57576587102e-08 , 3.05804127556e-08 ,
 5.774927031e-08   , 1.17396640344e-07 , 5.12159177467e-07 , 4.10874434767e-06 ,
 3.10449645902e-05 , 0.000188896906368 , 0.000908176221267 , 0.00343976055588  ,
 0.0102553308814   , 0.0240795299763   , 0.0446565319397   , 0.0659600815483   ,
 0.0792241414656   , 0.0810634041881   , 0.0768036739182   , 0.0736278782721   ,
 0.0723727214902   , 0.0682740076525   , 0.0581908925195   , 0.0447834132      ,
 0.033768653936    , 0.0284477141558   , 0.0275439159136   , 0.0279164359778   ,
 0.0283514084715   , 0.0301824804476   , 0.034739220542    , 0.0409521028924   ,
 0.0456919918705   , 0.0466165656003   , 0.0448899512432   , 0.0445440524739   ,
 0.04851774283     , 0.0561804549359   , 0.0653793793715   , 0.0747271821746   ,
 0.0821856527798   , 0.0845561640824   , 0.0816907907262   , 0.0784487946483   ,
 0.0786152917978   , 0.0788072790671   , 0.0719610559665   , 0.0559175087214   ,
 0.0359103893469   , 0.0191734861551   , 0.00954860442568  , 0.00761099942624  ,
 0.0140338650037   , 0.031016907091    , 0.0592935220803   , 0.0931051377655   ,
 0.119480621735    , 0.125745469885    , 0.109553323313    , 0.0805735621372   ,
 0.0518186583603   , 0.0305214332704   , 0.0169578079551   , 0.00873850810604  ,
 0.00396726837175  , 0.00150872484449  , 0.0004649592446   , 0.000114076550217 ,
 2.21636402048e-05 , 3.5996194612e-06  , 8.88841113709e-07 , 8.04133253896e-07 ,
 9.52809898832e-07 , 9.33155888573e-07 , 7.33007734344e-07 , 5.08347728185e-07 ,
 6.18759679715e-07 , 2.19540835535e-06 , 8.8299272642e-06  , 2.89560423147e-05 ,
 7.50999834131e-05 , 0.000153864114043 , 0.000249206427156 , 0.000319251174856 ,
 0.000323509798364 , 0.000259208158881 , 0.000164080025379 , 8.19612283202e-05 ,
 3.22725994196e-05 , 1.00692040265e-05 , 2.87357143635e-06 , 2.51799848001e-06 ,
 7.71617191783e-06 , 2.26709281172e-05 , 5.32184211128e-05 , 9.87157007037e-05 ,
 0.000144391152143 , 0.000166422943596 , 0.00015119455569  , 0.000108458580248 ,
 6.17550043756e-05 , 2.85163569412e-05 , 1.26263871023e-05 , 1.34158772114e-05 ,
 4.07413951959e-05 , 0.000125940362989 , 0.000313251408084 , 0.000614008530225 ,
 0.000947611150948 , 0.00115287549527  , 0.00110723967396  , 0.000840583081256 ,
 0.000505154238023 , 0.000241841055374 , 0.000101101874    , 8.42390801639e-05 ,
 0.000255833007975 , 0.000865631845874 , 0.00237272394878  , 0.00515121725384  ,
 0.00883949900923  , 0.0119796277395   , 0.0128301360803   , 0.0109480371359   ,
 0.00776800903486  , 0.00539655584687  , 0.00497524794782  , 0.00617107813962  ,
 0.00795959861119  , 0.00991288157414  , 0.0129104889493   , 0.0185878209135   ,
 0.0280567907931   , 0.040900558971    , 0.0547065215598   , 0.0657234222992   ,
 0.0715437081988   , 0.0735780575486   , 0.0753414302739   , 0.0783338719784   ,
 0.0817791154382   , 0.0863351325478   , 0.095214371087    , 0.110503757908    ,
 0.130142852608    , 0.149615836422    , 0.164964532117    , 0.172618553867    ,
 0.16839646767     , 0.150428456562    , 0.123240793631    , 0.0957308401891   ,
 0.0465427003911   , 0.0311869036686   , 0.0204048800079   , 0.0124540230008   ,
 0.00679408096426  , 0.0032544282034   , 0.00136790083346  , 0.000507391002349 ,
 0.000169859295727 , 5.61501441884e-05 , 2.20736642e-05    , 1.12613889039e-05 ,
 6.86387782809e-06 , 5.09852768739e-06 , 4.70300416463e-06 , 4.80359604319e-06 ,
 5.55910244981e-06 , 8.56616112095e-06 , 1.57676537743e-05 , 2.69310697822e-05 ,
 3.78084654087e-05 , 4.21388606575e-05 , 3.69610330884e-05 , 2.54590642751e-05 ,
 1.37663928025e-05 , 5.84522989167e-06 , 1.95019118025e-06 , 5.11795072417e-07 ,
 1.05867738759e-07 , 1.75470069219e-08 , 3.08224672492e-09 , 2.39045644706e-09 ,
 6.34941158998e-09 , 4.37189053068e-08 , 4.72349083318e-07 , 4.53383266823e-06 ,
 3.48173169757e-05 , 0.000211343720559 , 0.00101164577748  , 0.00381351541133  ,
 0.0113095687198   , 0.026378351066    , 0.0484448915094   , 0.0703888321456   ,
 0.0819850959377   , 0.0790665142319   , 0.067551215143    , 0.0564136732598   ,
 0.0488693509541   , 0.0422307098364   , 0.0338558422501   , 0.0246466669005   ,
 0.0175029411574   , 0.0141428272096   , 0.0138213907014   , 0.0145746346408   ,
 0.0153224221033   , 0.0168743662587   , 0.0210096048117   , 0.0282563389136   ,
 0.0363630978611   , 0.0416883941938   , 0.0429161036102   , 0.0426920601194   ,
 0.0446111526099   , 0.0496748838422   , 0.0568142513309   , 0.0648279122965   ,
 0.0717554597556   , 0.0748023408923   , 0.0738368681545   , 0.0727189111718   ,
 0.073982016621    , 0.0740636493981   , 0.0669152834727   , 0.0513656674694   ,
 0.0326463826416   , 0.0174075472258   , 0.00939868032775  , 0.0100284790814   ,
 0.0209715739166   , 0.0438256222905   , 0.0757463748438   , 0.10616178157     ,
 0.121017459918    , 0.112956503851    , 0.0871532601105   , 0.056452408568    ,
 0.0315608892411   , 0.0159258476189   , 0.00761288952501  , 0.0034933197976   ,
 0.00147739098515  , 0.000541305851047 , 0.000163743936281 , 3.97730958912e-05 ,
 7.65555605788e-06 , 1.17789971239e-06 , 1.80349378731e-07 , 8.03676519534e-08 ,
 8.42439525046e-08 , 8.13439166646e-08 , 6.39487814224e-08 , 4.90869490725e-08 ,
 9.04729491268e-08 , 3.87796216014e-07 , 1.59036343711e-06 , 5.22127711606e-06 ,
 1.35373971825e-05 , 2.77221035634e-05 , 4.48773027514e-05 , 5.74610747729e-05 ,
 5.81975537791e-05 , 4.66069869269e-05 , 2.94888405709e-05 , 1.47240377739e-05 ,
 5.79500608226e-06 , 1.80426919531e-06 , 4.97954508326e-07 , 3.7544537083e-07  ,
 1.11804982175e-06 , 3.31873898234e-06 , 7.86231104235e-06 , 1.46849053134e-05 ,
 2.15893196183e-05 , 2.49747485785e-05 , 2.27433227581e-05 , 1.63280211025e-05 ,
 9.27896262956e-06 , 4.2624251776e-06  , 1.96403236468e-06 , 2.62344807012e-06 ,
 8.77438679868e-06 , 2.74350765447e-05 , 6.82631589968e-05 , 0.000133630012768 ,
 0.000205868014249 , 0.000249937047119 , 0.000239463639221 , 0.000181287646894 ,
 0.000108612860675 , 5.20550463137e-05 , 2.36163677318e-05 , 2.96432235329e-05 ,
 0.00010620293528  , 0.000364153450844 , 0.000999246648807 , 0.00216979821872  ,
 0.00372357021994  , 0.00504600207286  , 0.00540186888713  , 0.00459971122576  ,
 0.00323370299832  , 0.0021800703092   , 0.00192994478804  , 0.00241701987893  ,
 0.0033820175212   , 0.00488142009021  , 0.00743028497863  , 0.01155551306     ,
 0.0172739121139   , 0.0242183466631   , 0.0323172797594   , 0.0423805834014   ,
 0.0559015271478   , 0.0730744689105   , 0.0898391723922   , 0.0986318807847   ,
 0.0951534249687   , 0.0842244522137   , 0.0765148186839   , 0.0791355504826   ,
 0.0906324199913   , 0.104763767624    , 0.116834504136    , 0.124632637878    ,
 0.12504584374     , 0.114289323784    , 0.093013658238    , 0.0679828794076   ,
 0.0320941964973   , 0.0178671513407   , 0.00956948218601  , 0.00495421572561  ,
 0.00238256075582  , 0.0010230273089   , 0.000386041424201 , 0.000128344439    ,
 3.8196913702e-05  , 1.07864325062e-05 , 3.40503841904e-06 , 1.43344702969e-06 ,
 7.76760912377e-07 , 5.24688716791e-07 , 4.56122753581e-07 , 4.74423665935e-07 ,
 6.16895719724e-07 , 1.09370659415e-06 , 2.15124178779e-06 , 3.74010537128e-06 ,
 5.26492807874e-06 , 5.86077395431e-06 , 5.12815722459e-06 , 3.52145894221e-06 ,
 1.89712703173e-06 , 8.01984748739e-07 , 2.66173035834e-07 , 6.94154253536e-08 ,
 1.42444059167e-08 , 2.31707539169e-09 , 3.44613497612e-10 , 2.55050103768e-10 ,
 2.43266824302e-09 , 3.46134231931e-08 , 4.20173287291e-07 , 4.0651842735e-06  ,
 3.11130673998e-05 , 0.000188065736971 , 0.000896691396877 , 0.00336834724208  ,
 0.00995888595396  , 0.0231687990826   , 0.042468252744    , 0.061632864139    ,
 0.0717310835723   , 0.0689360834699   , 0.0578826505839   , 0.0459147383694   ,
 0.0362248711468   , 0.0278888979857   , 0.0199258985627   , 0.0131464235619   ,
 0.00905076875489  , 0.00832857113773  , 0.0102634223722   , 0.0130607500146   ,
 0.0151183580896   , 0.0166824130532   , 0.0200343552527   , 0.0269885547801   ,
 0.0358583075736   , 0.0420226023463   , 0.0425157181328   , 0.039247824795    ,
 0.0366902999545   , 0.0375748575471   , 0.0420272180816   , 0.048950953334    ,
 0.0560741227654   , 0.0603654342184   , 0.0609937878883   , 0.0605665589195   ,
 0.0611812322476   , 0.0606384734215   , 0.0547943742201   , 0.0427890467473   ,
 0.0283112967565   , 0.016521183788    , 0.0116174407472   , 0.0177122085785   ,
 0.0400479238713   , 0.0813858839816   , 0.133823262425    , 0.176140542039    ,
 0.186031484906    , 0.158451387391    , 0.109595018824    , 0.0621771443469   ,
 0.02941190623     , 0.0119422683651   , 0.00436937171943  , 0.00152726471386  ,
 0.000523050222827 , 0.000168769259292 , 4.78381752551e-05 , 1.12641152455e-05 ,
 2.13431362413e-06 , 3.21570106861e-07 , 4.07500676044e-08 , 8.18072763742e-09 ,
 6.00704020307e-09 , 5.60331831947e-09 , 4.45216425502e-09 , 4.11566429144e-09 ,
 1.14776914579e-08 , 5.46981479975e-08 , 2.26347218853e-07 , 7.43366236804e-07 ,
 1.92666610248e-06 , 3.9437200877e-06  , 6.38121367809e-06 , 8.16662003353e-06 ,
 8.26736934951e-06 , 6.61783219178e-06 , 4.18540799704e-06 , 2.08899942586e-06 ,
 8.21847470771e-07 , 2.55477930892e-07 , 6.87031084601e-08 , 4.48269673326e-08 ,
 1.28309444922e-07 , 3.83457330336e-07 , 9.14640455672e-07 , 1.71703396163e-06 ,
 2.53375682112e-06 , 2.93893190241e-06 , 2.68110573309e-06 , 1.92630467063e-06 ,
 1.09385418181e-06 , 5.02875932008e-07 , 2.4975439339e-07  , 4.22250387007e-07 ,
 1.50507361522e-06 , 4.7317215149e-06  , 1.17666530075e-05 , 2.30001195805e-05 ,
 3.53687770592e-05 , 4.28492890864e-05 , 4.09559924206e-05 , 3.09247319795e-05 ,
 1.84832493627e-05 , 8.92079347341e-06 , 4.67460902997e-06 , 8.82206214889e-06 ,
 3.47131413167e-05 , 0.000119760647211 , 0.000328758245377 , 0.000713910011737 ,
 0.00122514029994  , 0.00166019349197  , 0.0017770115678   , 0.00151249639605  ,
 0.00106364069921  , 0.000728628964528 , 0.000708450139213 , 0.00109996077982  ,
 0.00208888667236  , 0.0041153559816   , 0.00764853383519  , 0.0125291509923   ,
 0.0177156951766   , 0.0224525478962   , 0.028346533734    , 0.0401541757643   ,
 0.0631678758838   , 0.0971727743763   , 0.131504557876    , 0.149107514627    ,
 0.14015172784     , 0.111879527014    , 0.0825956965889   , 0.0663463719216   ,
 0.0647180667836   , 0.0714440249635   , 0.080958119259    , 0.0904534622308   ,
 0.0959328809355   , 0.0915464356127   , 0.0753211989317   , 0.0527337933825   ,
 0.0229925883963   , 0.0111328421428   , 0.00482137848321  , 0.00197693697098  ,
 0.000782186156553 , 0.000289936972644 , 9.68614554966e-05 , 2.86531200476e-05 ,
 7.54464275343e-06 , 1.8335477296e-06  , 4.64988249601e-07 , 1.53781225517e-07 ,
 7.11475034219e-08 , 4.31562391141e-08 , 3.51546380416e-08 , 3.77443067863e-08 ,
 5.63353858689e-08 , 1.1329827145e-07  , 2.3398622057e-07  , 4.11608003689e-07 ,
 5.80188974174e-07 , 6.44972745716e-07 , 5.63083899513e-07 , 3.85587523017e-07 ,
 2.07034183342e-07 , 8.71701984168e-08 , 2.87922584318e-08 , 7.46559283741e-09 ,
 1.52121878382e-09 , 2.44567717633e-10 , 3.61184764895e-11 , 9.01040051562e-11 ,
 1.61108545393e-09 , 2.46868347158e-08 , 3.00670200796e-07 , 2.89799701419e-06 ,
 2.20860663044e-05 , 0.000132980441354 , 0.000631932662749 , 0.00236787356583  ,
 0.00699281425055  , 0.016289267541    , 0.030038673676    , 0.044272184637    ,
 0.053254432224    , 0.0543614732821   , 0.0497519791307   , 0.0426767427988   ,
 0.0342820859039   , 0.0248295570212   , 0.0157590485417   , 0.00923053225547  ,
 0.00671007908939  , 0.00850086813006  , 0.0135894911485   , 0.0194080935374   ,
 0.0229484939485   , 0.0234975476073   , 0.0238508489862   , 0.0273543084662   ,
 0.033541330748    , 0.0379513355956   , 0.036919829632    , 0.031551322108    ,
 0.0262389062555   , 0.0245569182162   , 0.0276181835637   , 0.0346405335086   ,
 0.0430114194535   , 0.048940219922    , 0.0504028309589   , 0.049092701148    ,
 0.0478959756746   , 0.0470601278338   , 0.0441939503543   , 0.0374772568667   ,
 0.0279100718157   , 0.019172949731    , 0.017084070592    , 0.030303917631    ,
 0.069715477198    , 0.14050055941     , 0.228146539789    , 0.295491128581    ,
 0.305629642211    , 0.253303075815    , 0.168998463535    , 0.0913245317416   ,
 0.0403066207261   , 0.0147024609948   , 0.0045134668143   , 0.00120101975887  ,
 0.00028949610304  , 6.61307791838e-05 , 1.44682656805e-05 , 2.91164803047e-06 ,
 5.0732829843e-07  , 7.30379748513e-08 , 8.58511151858e-09 , 1.02477310842e-09 ,
 3.67681187887e-10 , 3.0597081147e-10  , 2.49544491032e-10 , 3.0889839725e-10  ,
 1.21486543705e-09 , 6.11544030675e-09 , 2.54100039184e-08 , 8.34508949873e-08 ,
 2.16215157873e-07 , 4.42398812232e-07 , 7.15532289927e-07 , 9.15339453416e-07 ,
 9.26238079295e-07 , 7.4112866236e-07  , 4.68543587732e-07 , 2.33775656887e-07 ,
 9.19391655606e-08 , 2.85451861882e-08 , 7.52049799295e-09 , 4.26940410399e-09 ,
 1.16099170341e-08 , 3.4831352438e-08  , 8.34990074245e-08 , 1.57337795636e-07 ,
 2.3280970357e-07  , 2.70566342048e-07 , 2.47155699439e-07 , 1.77691984357e-07 ,
 1.0090219225e-07  , 4.66879122003e-08 , 2.59626769078e-08 , 5.51171748901e-08 ,
 2.04915865776e-07 , 6.45853631592e-07 , 1.60453804636e-06 , 3.13156745064e-06 ,
 4.80678264785e-06 , 5.81116738269e-06 , 5.54132533853e-06 , 4.1735138579e-06  ,
 2.49010823099e-06 , 1.22163399314e-06 , 7.9971916422e-07  , 2.14891380264e-06 ,
 8.89823882319e-06 , 3.07917974761e-05 , 8.45423453146e-05 , 0.000183591463922 ,
 0.000315085823857 , 0.00042718040246  , 0.000458627534026 , 0.000397713745121 ,
 0.000310509149626 , 0.000314817431454 , 0.000556061125284 , 0.00126523410364  ,
 0.0029204832925   , 0.00632363270642  , 0.0121294259243   , 0.0197744446795   ,
 0.0271457283363   , 0.0326608455226   , 0.0388066519527   , 0.0532945770331   ,
 0.0846470782167   , 0.132991469238    , 0.182963071732    , 0.209346458378    ,
 0.196196488352    , 0.151489207073    , 0.100174306586    , 0.0635608727518   ,
 0.0472236546817   , 0.0454811399553   , 0.0515665991445   , 0.0611640396557   ,
 0.0692642152983   , 0.0693169750818   , 0.0582812569646   , 0.0402986819907   ,
 0.0157760138963   , 0.00717886488217  , 0.00272062645475  , 0.000899061631247 ,
 0.000274677417153 , 8.05529439532e-05 , 2.24565581911e-05 , 5.75209832997e-06 ,
 1.32597376872e-06 , 2.78098942558e-07 , 5.73455366185e-08 , 1.43768350853e-08 ,
 5.3451407198e-09  , 2.84386902611e-09 , 2.1599697625e-09  , 2.43855216243e-09 ,
 4.23289701127e-09 , 9.45346461187e-09 , 2.02036175985e-08 , 3.58083894164e-08 ,
 5.04980966867e-08 , 5.60606132103e-08 , 4.88445884376e-08 , 3.3365209119e-08  ,
 1.78616755114e-08 , 7.49362261309e-09 , 2.46445160584e-09 , 6.35687980185e-10 ,
 1.287162609e-10   , 2.05609962528e-11 , 4.55577880067e-12 , 4.77322873489e-11 ,
 9.1857594284e-10  , 1.40865568714e-08 , 1.70912005147e-07 , 1.64049504307e-06 ,
 1.24535455786e-05 , 7.47280441477e-05 , 0.000354222160802 , 0.00132606970367  ,
 0.0039245503782   , 0.00921793170336  , 0.0173536778395   , 0.0267414290548   ,
 0.0350052749586   , 0.040859085434    , 0.0439923646283   , 0.0433249359704   ,
 0.0374561409253   , 0.027310071745    , 0.0166017058719   , 0.00923884722407  ,
 0.00730356092956  , 0.0111233341979   , 0.0193267603809   , 0.0282114791736   ,
 0.0330040428937   , 0.0317900995297   , 0.0277132966236   , 0.025680572058    ,
 0.0269978132254   , 0.0284338216643   , 0.026496107454    , 0.0213670119501   ,
 0.0163216888551   , 0.0146672825633   , 0.0180629434333   , 0.026237153921    ,
 0.0364705175488   , 0.0441626486003   , 0.046153051084    , 0.0437800305624   ,
 0.0413584581866   , 0.0414941542811   , 0.0426196981986   , 0.0409831899007   ,
 0.0347233216144   , 0.0267191639613   , 0.025263160218    , 0.0439362650094   ,
 0.0991104763521   , 0.198248409174    , 0.320589908252    , 0.413663918145    ,
 0.42601872809     , 0.351225916241    , 0.232819132055    , 0.124825853815    ,
 0.0545547008317   , 0.0196229563388   , 0.0058712616073   , 0.00147692326574  ,
 0.000315561660515 , 5.79136684434e-05 , 9.26423681734e-06 , 1.31418685394e-06 ,
 1.67191300081e-07 , 1.89585314226e-08 , 1.87472711249e-09 , 1.65784094921e-10 ,
 2.38274324979e-11 , 1.35074299974e-11 , 1.14710076437e-11 , 2.08743476294e-11 ,
 1.04345592644e-10 , 5.39629339315e-10 , 2.24622969163e-09 , 7.37600780103e-09 ,
 1.91048043715e-08 , 3.90769005182e-08 , 6.31795402991e-08 , 8.07916920091e-08 ,
 8.1723263531e-08  , 6.53674172634e-08 , 4.13116527148e-08 , 2.06057961974e-08 ,
 8.10140375612e-09 , 2.51290341294e-09 , 6.51270197284e-10 , 3.2360468079e-10  ,
 8.25665008712e-10 , 2.48041253988e-09 , 5.96800287177e-09 , 1.12765741142e-08 ,
 1.67190534073e-08 , 1.94583126963e-08 , 1.77920687146e-08 , 1.27986677481e-08 ,
 7.27202999754e-09 , 3.40880552538e-09 , 2.21207171019e-09 , 5.78058922865e-09 ,
 2.21008029806e-08 , 6.97298019429e-08 , 1.73043531728e-07 , 3.37218215665e-07 ,
 5.16686977673e-07 , 6.23370643808e-07 , 5.9306443782e-07  , 4.45599276541e-07 ,
 2.65673300078e-07 , 1.34617153603e-07 , 1.19330324719e-07 , 4.19983578615e-07 ,
 1.78708713679e-06 , 6.19358657373e-06 , 1.70072269346e-05 , 3.69414043537e-05 ,
 6.3491065133e-05  , 8.68421534488e-05 , 9.82392763426e-05 , 0.000110782445439 ,
 0.000187221287406 , 0.000466784919157 , 0.00117922583408  , 0.00266660275157  ,
 0.0055070128211   , 0.010659273889    , 0.0190130049685   , 0.0300083376503   ,
 0.0409518590325   , 0.0494397511257   , 0.0578261775461   , 0.0748101733964   ,
 0.11042821444     , 0.165562903658    , 0.223342415984    , 0.254396724606    ,
 0.238415613631    , 0.182606637628    , 0.115623938968    , 0.063874363395    ,
 0.0361446140222   , 0.0273163603989   , 0.0294969851188   , 0.037047018298    ,
 0.0447532818014   , 0.0468475077014   , 0.040414670822    , 0.0281518565674   ,
 0.01090164523     , 0.00494344564423  , 0.00180059183497  , 0.000534977813224 ,
 0.000133538299706 , 2.93642423453e-05 , 6.00663789813e-06 , 1.17956792389e-06 ,
 2.20903360988e-07 , 3.87717252577e-08 , 6.5274721154e-09  , 1.22414109287e-09 ,
 3.38909648947e-10 , 1.51127083918e-10 , 1.06257844511e-10 , 1.28916452731e-10 ,
 2.60475278093e-10 , 6.30872306026e-10 , 1.37983908372e-09 , 2.45695892476e-09 ,
 3.46476078144e-09 , 3.84153831217e-09 , 3.34118946798e-09 , 2.27744931972e-09 ,
 1.21606015995e-09 , 5.08585870415e-10 , 1.66624412964e-10 , 4.27812522483e-11 ,
 8.61461665009e-12 , 1.3902328744e-12  , 1.05262184119e-12 , 2.1618518225e-11  ,
 4.17612310602e-10 , 6.38144243792e-09 , 7.71249694576e-08 , 7.37479672371e-07 ,
 5.57946997622e-06 , 3.33944707974e-05 , 0.000158156510935 , 0.000593566150542 ,
 0.00177337382312  , 0.0042645037323   , 0.00844336770444  , 0.0143004920254   ,
 0.0216951812805   , 0.0302674671765   , 0.0382215897803   , 0.0418479553686   ,
 0.0381626083836   , 0.0283170854263   , 0.0171597576351   , 0.00953699606705  ,
 0.00797000180685  , 0.0129279920899   , 0.0228926290873   , 0.0334822518847   ,
 0.0388148153532   , 0.0361149204265   , 0.0285150017176   , 0.0217864082267   ,
 0.0186890582875   , 0.0175198628328   , 0.015471078927    , 0.0119925779131   ,
 0.00891366225512  , 0.00866830377141  , 0.0130177252981   , 0.0221789331543   ,
 0.0336663569266   , 0.0426528123115   , 0.0455575772457   , 0.0437748644185   ,
 0.0425410763073   , 0.0454890258925   , 0.0507507832733   , 0.0526223233453   ,
 0.0472609993622   , 0.0375299136742   , 0.0339027623502   , 0.0529323091491   ,
 0.11333785391     , 0.223127716982    , 0.358836548338    , 0.462038202295    ,
 0.475692343061    , 0.392801109914    , 0.261604550104    , 0.141717333142    ,
 0.0631898956371   , 0.0235322777142   , 0.00742632448417  , 0.00200477455474  ,
 0.000462991605377 , 9.06522564674e-05 , 1.48491380263e-05 , 2.01122350161e-06 ,
 2.23942301844e-07 , 2.05520211362e-08 , 1.57360292651e-09 , 1.02837822198e-10 ,
 6.23678350105e-12 , 7.22644192988e-13 , 4.55289434414e-13 , 1.2388288366e-12  ,
 7.15315597723e-12 , 3.74755724611e-11 , 1.56110374839e-10 , 5.12534431681e-10 ,
 1.32717415828e-09 , 2.71379322017e-09 , 4.38628746176e-09 , 5.60722528467e-09 ,
 5.67007302763e-09 , 4.53389086696e-09 , 2.86455898255e-09 , 1.42843656634e-09 ,
 5.61463222263e-10 , 1.74022784104e-10 , 4.45101651359e-11 , 1.94936346519e-11 ,
 4.60533403944e-11 , 1.38210669069e-10 , 3.33428804734e-10 , 6.31301786867e-10 ,
 9.37369040677e-10 , 1.09209723331e-09 , 9.99306409775e-10 , 7.19188809842e-10 ,
 4.09130760836e-10 , 1.95998176043e-10 , 1.54884658382e-10 , 4.84074123964e-10 ,
 1.88530042422e-09 , 5.9498945728e-09  , 1.47490145419e-08 , 2.87009442443e-08 ,
 4.39014612452e-08 , 5.28633902449e-08 , 5.01843667392e-08 , 3.76233290721e-08 ,
 2.24556648556e-08 , 1.20702357232e-08 , 1.53925547454e-08 , 6.51502560465e-08 ,
 2.81262676304e-07 , 9.7564480679e-07  , 2.68080953818e-06 , 5.8455094889e-06  ,
 1.02884253444e-05 , 1.60943327543e-05 , 3.12935052501e-05 , 9.83675940593e-05 ,
 0.000353667913006 , 0.00109696020241  , 0.00276546184254  , 0.00575276201681  ,
 0.010348988225    , 0.0171162916557   , 0.0270275178338   , 0.0402610986963   ,
 0.0548370905323   , 0.0681407199986   , 0.0810868428345   , 0.10027013017     ,
 0.134362246303    , 0.185029862411    , 0.237962537387    , 0.265708189665    ,
 0.247492075578    , 0.188803392107    , 0.117550195944    , 0.0608744432665   ,
 0.0286948386822   , 0.0164212637279   , 0.0158960715523   , 0.0211065148374   ,
 0.0273449071545   , 0.0300815393531   , 0.0268606585593   , 0.0191761438269   ,
 0.00982978993552  , 0.00460651438061  , 0.00171457036988  , 0.000508043898205 ,
 0.000120455531693 , 2.31024808735e-05 , 3.66276101634e-06 , 4.98725636873e-07 ,
 6.1578973243e-08  , 7.28316091137e-09 , 8.59216744047e-10 , 1.09556571953e-10 ,
 1.96849205297e-11 , 6.60721126483e-12 , 4.21035574681e-12 , 5.6038341235e-12  ,
 1.30246881981e-11 , 3.34653425503e-11 , 7.43124557625e-11 , 1.32685829738e-10 ,
 1.87054185043e-10 , 2.0716007055e-10  , 1.7990771537e-10  , 1.22406971546e-10 ,
 6.52161428825e-11 , 2.72018114627e-11 , 8.88269684682e-12 , 2.2715067167e-12  ,
 4.55383606306e-13 , 8.18437072661e-14 , 3.28981778659e-13 , 7.81798514092e-12 ,
 1.50646456603e-10 , 2.29401605654e-09 , 2.76282117776e-08 , 2.63330784584e-07 ,
 1.98729255824e-06 , 1.18847085857e-05 , 5.64420114697e-05 , 0.000214022039052 ,
 0.000656048161519 , 0.00166622031351  , 0.00364861133906  , 0.00719914459798  ,
 0.013051578671    , 0.0212600471087   , 0.0297661303651   , 0.0344741199411   ,
 0.0322771186701   , 0.0242008900709   , 0.014719774308    , 0.00827515345317  ,
 0.00722151708405  , 0.0120902213346   , 0.0215533701693   , 0.0315160664966   ,
 0.0363523515527   , 0.0332217891581   , 0.0247915538558   , 0.0164626463796   ,
 0.0114007558934   , 0.0090238573834   , 0.00735671015043  , 0.00555201749526  ,
 0.00434678717792  , 0.00527100666319  , 0.00984976471266  , 0.0185771928584   ,
 0.0295612346773   , 0.0387627847676   , 0.043275010268    , 0.0446587010606   ,
 0.047675232493    , 0.055018601192    , 0.0637003779989   , 0.0670307559208   ,
 0.060796445535    , 0.0484443268606   , 0.0413024857643   , 0.0554139779852   ,
 0.107064175986    , 0.202345674183    , 0.320418616555    , 0.410794436       ,
 0.424273924843    , 0.354450432852    , 0.241983174977    , 0.137243437862    ,
 0.0660672098349   , 0.0275498315684   , 0.0100443721695   , 0.00317651276783  ,
 0.000853590075956 , 0.000190515132903 , 3.47193589032e-05 , 5.12391258455e-06 ,
 6.13530792748e-07 , 6.04122876987e-08 , 5.01803437736e-09 , 3.62783396727e-10 ,
 2.33042718556e-11 , 1.3312571864e-12  , 7.90456319293e-14 , 6.46419133932e-14 ,
 3.87854116294e-13 , 2.04405342211e-12 , 8.51713895831e-12 , 2.79582477064e-11 ,
 7.23796122184e-11 , 1.47964282676e-10 , 2.39090799028e-10 , 3.05560043211e-10 ,
 3.08902019392e-10 , 2.46939721426e-10 , 1.55981363094e-10 , 7.77642755777e-11 ,
 3.05596312696e-11 , 9.46606859922e-12 , 2.39557633611e-12 , 9.32505693496e-13 ,
 2.01191514647e-12 , 6.01792664346e-12 , 1.45456344557e-11 , 2.75819959181e-11 ,
 4.09990612368e-11 , 4.7803944685e-11  , 4.37661477828e-11 , 3.15113801044e-11 ,
 1.79626337613e-11 , 8.90540899147e-12 , 8.91412894076e-12 , 3.22188837237e-11 ,
 1.27010010716e-10 , 4.00786832028e-10 , 9.92453979435e-10 , 1.9287304231e-09  ,
 2.94564367355e-09 , 3.54062557827e-09 , 3.35449120204e-09 , 2.5101871549e-09  ,
 1.50459678129e-09 , 8.94753292351e-10 , 1.67937588054e-09 , 7.98022010701e-09 ,
 3.47259546664e-08 , 1.20700257004e-07 , 3.35074871486e-07 , 7.77684682601e-07 ,
 1.87207893721e-06 , 7.03657792074e-06 , 3.68985239232e-05 , 0.000180747432333 ,
 0.000715906361456 , 0.00223575710755  , 0.00551890825543  , 0.0109351735601   ,
 0.0179907445466   , 0.0261219819295   , 0.0361538061443   , 0.0498991827354   ,
 0.067687174478    , 0.0874419240716   , 0.107177400994    , 0.12808454782     ,
 0.154570764429    , 0.189109012905    , 0.223836622999    , 0.239292487186    ,
 0.218667598021    , 0.165341380387    , 0.101904836666    , 0.0512778946553   ,
 0.0221311324931   , 0.0106555803723   , 0.00982340504343  , 0.0144129634691   ,
 0.0204045223221   , 0.0238701976011   , 0.0223576172977   , 0.0166431842923   ,
 0.0124416383076   , 0.00600089674826  , 0.00229857177426  , 0.000700977174604 ,
 0.000171059707405 , 3.37218363776e-05 , 5.4573905289e-06  , 7.42152085922e-07 ,
 8.70432605718e-08 , 8.96276366198e-09 , 8.1073559349e-10  , 6.39008278214e-11 ,
 4.56093105651e-12 , 4.24148209986e-13 , 1.42755078248e-13 , 2.00583041556e-13 ,
 5.24494805536e-13 , 1.40400127067e-12 , 3.1479764692e-12  , 5.62945615669e-12 ,
 7.93276074076e-12 , 8.77677874622e-12 , 7.6125656037e-12  , 5.17159895047e-12 ,
 2.75023705977e-12 , 1.14453605612e-12 , 3.72706324721e-13 , 9.49841877292e-14 ,
 1.90266486099e-14 , 5.94175837891e-15 , 9.24581599556e-14 , 2.24278214148e-12 ,
 4.30935038319e-11 , 6.54212425031e-10 , 7.85607580105e-09 , 7.47063086154e-08 ,
 5.63402904785e-07 , 3.3793807753e-06  , 1.62250208422e-05 , 6.32217706944e-05 ,
 0.000205332748967 , 0.000579349518937 , 0.00148173897281  , 0.00348200285199  ,
 0.00731095292789  , 0.0131046062693   , 0.019328276103    , 0.022959556466    ,
 0.02174388973     , 0.016384464684    , 0.010002615121    , 0.0057091224542   ,
 0.00520576267066  , 0.00895058864859  , 0.0160337893252   , 0.0234442293231   ,
 0.0269737589783   , 0.0244288710462   , 0.0176910407981   , 0.0107665191819   ,
 0.0062201765266   , 0.00399896104304  , 0.00288727162625  , 0.00214155120251  ,
 0.00194948541077  , 0.00316804876072  , 0.00689673338952  , 0.0136696783912   ,
 0.0224171050789   , 0.0307153361795   , 0.0371681700511   , 0.0433944700401   ,
 0.052361873307    , 0.0643334896831   , 0.0750017192585   , 0.078067532099    ,
 0.0705956537913   , 0.0569981346882   , 0.0479969983097   , 0.0560056880936   ,
 0.0910153190006   , 0.155370365895    , 0.234953252652    , 0.297541876354    ,
 0.31155360999     , 0.271672023507    , 0.201294905954    , 0.1300250038      ,
 0.0744938580752   , 0.0377034113233   , 0.0164652816182   , 0.00602531537748  ,
 0.00180510879978  , 0.00043684648095  , 8.51040910545e-05 , 1.34341580161e-05 ,
 1.74878777988e-06 , 1.92997391013e-07 , 1.85916617189e-08 , 1.5847880252e-09  ,
 1.18052843525e-10 , 7.45784829503e-12 , 3.87894211023e-13 , 1.87197091781e-14 ,
 1.70633106097e-14 , 8.74354157331e-14 , 3.6429780215e-13  , 1.19565504069e-12 ,
 3.09478368867e-12 , 6.32530287744e-12 , 1.02186270453e-11 , 1.30565698032e-11 ,
 1.31964374397e-11 , 1.05471183777e-11 , 6.6608318216e-12  , 3.32013993947e-12 ,
 1.30451216277e-12 , 4.0388724932e-13  , 1.01343625338e-13 , 3.54023513796e-14 ,
 6.87867479296e-14 , 2.04569758761e-13 , 4.95100040288e-13 , 9.39893362716e-13 ,
 1.39824005234e-12 , 1.63126644659e-12 , 1.49409909137e-12 , 1.07619176459e-12 ,
 6.15466966472e-13 , 3.21589719258e-13 , 4.20281661636e-13 , 1.69817022958e-12 ,
 6.74685665676e-12 , 2.12833900043e-11 , 5.26530522858e-11 , 1.02205280255e-10 ,
 1.55875794185e-10 , 1.87060512552e-10 , 1.7691127154e-10  , 1.32203709275e-10 ,
 8.00275983668e-11 , 5.58997847675e-11 , 1.51374950814e-10 , 7.70751645614e-10 ,
 3.38180807338e-09 , 1.20764174143e-08 , 3.91666813233e-08 , 1.67815450807e-07 ,
 1.17685423162e-06 , 9.03457137232e-06 , 5.82028783887e-05 , 0.000296088453117 ,
 0.0011779800058   , 0.00366566315899  , 0.00895746247719  , 0.017360224399    ,
 0.0273193501076   , 0.0367522024219   , 0.0462641833852   , 0.059890624007    ,
 0.0811721246037   , 0.108804383645    , 0.136735512869    , 0.158630092007    ,
 0.173007177823    , 0.183393096389    , 0.190880536314    , 0.187837576835    ,
 0.164384188091    , 0.121705533743    , 0.0740598367516   , 0.0367219577112   ,
 0.0155197510367   , 0.00778648222527  , 0.00878301418469  , 0.0148856631773   ,
 0.0225686651626   , 0.0275358485723   , 0.0266639559921   , 0.020458980155    ,
 0.0164252518591   , 0.00809195979981  , 0.00319734598498  , 0.00102305095332  ,
 0.000269113935316 , 5.94024004899e-05 , 1.124066887e-05   , 1.84739901981e-06 ,
 2.62889789304e-07 , 3.18305657678e-08 , 3.20580266805e-09 , 2.63293643263e-10 ,
 1.73907212786e-11 , 9.18768107601e-13 , 4.14082377783e-14 , 7.08948728592e-15 ,
 1.68883012434e-14 , 4.63989544817e-14 , 1.04672381105e-13 , 1.87339104175e-13 ,
 2.63870097231e-13 , 2.91701792367e-13 , 2.52744446934e-13 , 1.7148579344e-13  ,
 9.10559216694e-14 , 3.78225353078e-14 , 1.22879194231e-14 , 3.12283284601e-15 ,
 6.38136187129e-16 , 7.76897024226e-16 , 2.09916857959e-14 , 5.09721357578e-13 ,
 9.76920770728e-12 , 1.47940001171e-10 , 1.7730242291e-09  , 1.68523074402e-08 ,
 1.2749298637e-07  , 7.73365874375e-07 , 3.81914559554e-06 , 1.58003988936e-05 ,
 5.71781608221e-05 , 0.000188658746147 , 0.000572516309535 , 0.00154655305181  ,
 0.00354857110387  , 0.00667195570105  , 0.0100726112036   , 0.0120943253056   ,
 0.0115091661858   , 0.0086927800183   , 0.00532531318651  , 0.00309554576732  ,
 0.00296429085612  , 0.00523651455847  , 0.0094248985224   , 0.0137844934539   ,
 0.0158404737923   , 0.0142816337375   , 0.0101852471647   , 0.00590452713633  ,
 0.0030100642245   , 0.0015830992508   , 0.000985594526073 , 0.000753305328847 ,
 0.000902988636023 , 0.00187139385111  , 0.00431029528919  , 0.00863173143385  ,
 0.0145128152804   , 0.0212348190463   , 0.0289984993647   , 0.0393299635794   ,
 0.0530633832722   , 0.0679180186629   , 0.0787867858867   , 0.0808141562817   ,
 0.0732502148205   , 0.0615311124889   , 0.054864410678    , 0.0605875240486   ,
 0.0810667696865   , 0.114490284573    , 0.154599496562    , 0.189741703228    ,
 0.207765455655    , 0.203889871653    , 0.181076841097    , 0.14464521184     ,
 0.101155994058    , 0.0598395990437   , 0.0291148712954   , 0.0114523696221   ,
 0.00361557216698  , 0.000917512394342 , 0.000189145045537 , 3.23331992813e-05 ,
 4.7140877618e-06  , 6.01166503693e-07 , 6.75085536427e-08 , 6.56238808741e-09 ,
 5.36133983415e-10 , 3.58116587355e-11 , 1.91815181618e-12 , 8.14865164565e-14 ,
 3.2582016815e-15  , 2.99888636593e-15 , 1.22026552498e-14 , 4.00404583624e-14 ,
 1.0362305503e-13  , 2.11755211412e-13 , 3.42032831936e-13 , 4.36943022316e-13 ,
 4.41543324103e-13 , 3.52837041411e-13 , 2.22790887964e-13 , 1.11035071366e-13 ,
 4.36203964447e-14 , 1.34999946233e-14 , 3.36415401673e-15 , 1.06507274538e-15 ,
 1.83709409022e-15 , 5.41888959067e-15 , 1.31289367891e-14 , 2.49497418039e-14 ,
 3.71446605676e-14 , 4.33584189687e-14 , 3.97277976642e-14 , 2.86293651788e-14 ,
 1.6456316535e-14  , 9.29825539301e-15 , 1.61204008934e-14 , 7.06609338142e-14 ,
 2.82146436608e-13 , 8.89710706244e-13 , 2.19921664934e-12 , 4.26453400237e-12 ,
 6.49605236603e-12 , 7.78472431673e-12 , 7.35106478684e-12 , 5.49008147334e-12 ,
 3.3895209894e-12  , 2.9943296688e-12  , 1.10865479172e-11 , 5.93349834931e-11 ,
 2.79330802253e-10 , 1.4137744227e-09  , 1.17417115418e-08 , 1.33838461912e-07 ,
 1.39338102672e-06 , 1.16293426251e-05 , 7.59962047929e-05 , 0.000387482003092 ,
 0.0015415047726   , 0.00479090405955  , 0.0116685856743   , 0.0224425067376   ,
 0.0347500184617   , 0.0453955895133   , 0.0550346512138   , 0.0698526529986   ,
 0.0962768948427   , 0.133386984798    , 0.170672495844    , 0.193888018051    ,
 0.19542693579     , 0.179960746346    , 0.158014503551    , 0.134543831136    ,
 0.107330052312    , 0.0755968729873   , 0.0448261031536   , 0.0219598369615   ,
 0.00960284015643  , 0.00627311888179  , 0.00975242053706  , 0.0181375864994   ,
 0.0282075059753   , 0.0348982030098   , 0.0342051160157   , 0.0265878601342   ,
 0.0189706709724   , 0.00977960639041  , 0.00416150232175  , 0.0014912482641   ,
 0.000458615523702 , 0.000122188363133 , 2.80460520087e-05 , 5.45063807628e-06 ,
 8.78588302558e-07 , 1.15409200919e-07 , 1.21991368693e-08 , 1.02899027142e-09 ,
 6.88794136578e-11 , 3.64520460965e-12 , 1.5212577733e-13  , 5.1074346513e-15  ,
 5.42390172778e-16 , 1.19600679435e-15 , 2.72100469978e-15 , 4.87919609628e-15 ,
 6.87166652859e-15 , 7.59154614323e-15 , 6.57191649499e-15 , 4.45421960419e-15 ,
 2.36200638091e-15 , 9.7953557349e-16  , 3.17596175898e-16 , 8.05591926077e-17 ,
 1.90926136562e-17 , 1.25298243036e-16 , 3.78095888009e-15 , 9.16796995504e-14 ,
 1.75361764682e-12 , 2.65141232712e-11 , 3.17698704061e-10 , 3.02955138706e-09 ,
 2.3179722556e-08  , 1.44658141091e-07 , 7.59130008511e-07 , 3.50445737847e-06 ,
 1.48348301923e-05 , 5.78917950397e-05 , 0.000200770970125 , 0.000589488773487 ,
 0.00141390940969  , 0.00271629930412  , 0.00414189750103  , 0.00499566766792  ,
 0.00476363208976  , 0.00360248799354  , 0.00221520756451  , 0.00131672009648  ,
 0.00133320759159  , 0.0024228130706   , 0.00438147038732  , 0.00641074669379  ,
 0.00736271286268  , 0.0066243473493   , 0.00469251213006  , 0.00266612598227  ,
 0.00129756997131  , 0.000657155396412 , 0.000469305552398 , 0.000521896433291 ,
 0.000833593124566 , 0.0016318476991   , 0.00321126694298  , 0.00572913830098  ,
 0.00919969123861  , 0.0139904702909   , 0.0213583691512   , 0.0327089810239   ,
 0.0474744527367   , 0.0620228198304   , 0.0714251721597   , 0.0726224250184   ,
 0.0668735243897   , 0.0601862594937   , 0.0598646017172   , 0.0684211324867   ,
 0.081739856998    , 0.094812821821    , 0.107933409568    , 0.125816843906    ,
 0.151373584299    , 0.179480274704    , 0.19552712456     , 0.184154075733    ,
 0.144001195671    , 0.0913784790804   , 0.0465540105146   , 0.0189998796168   ,
 0.00624504646742  , 0.00167580050182  , 0.000375412483899 , 7.21302766623e-05 ,
 1.21262885104e-05 , 1.78402082073e-06 , 2.25105109853e-07 , 2.36856603448e-08 ,
 2.02815253204e-09 , 1.38971568629e-10 , 7.54188383959e-12 , 3.22195732923e-13 ,
 1.0789480532e-14  , 3.59678117783e-16 , 3.25237122792e-16 , 1.0489324419e-15  ,
 2.71425279803e-15 , 5.54585635902e-15 , 8.95652397394e-15 , 1.14401587687e-14 ,
 1.15588984628e-14 , 9.23539448232e-15 , 5.83070123238e-15 , 2.90556525732e-15 ,
 1.14132407931e-15 , 3.53107724267e-16 , 8.74651443132e-17 , 2.5220097125e-17  ,
 3.78784706942e-17 , 1.10794330904e-16 , 2.69311941942e-16 , 5.1314467401e-16  ,
 7.65395830898e-16 , 8.94630538585e-16 , 8.20517728004e-16 , 5.9195674614e-16  ,
 3.43241936082e-16 , 2.1747138761e-16  , 4.99277469012e-16 , 2.31565881829e-15 ,
 9.27455382639e-15 , 2.92341606262e-14 , 7.2209881632e-14  , 1.39900272496e-13 ,
 2.12884934417e-13 , 2.54810121269e-13 , 2.40312225023e-13 , 1.79586292232e-13 ,
 1.15039777968e-13 , 1.38949111699e-13 , 6.71445153455e-13 , 4.33852069101e-12 ,
 3.93960087036e-11 , 5.9836706618e-10  , 9.80560682717e-09 , 1.33828449339e-07 ,
 1.43906432856e-06 , 1.20819783198e-05 , 7.91003685663e-05 , 0.000403888653337 ,
 0.00160942077583  , 0.00501195846325  , 0.012236370654    , 0.0236046345071   ,
 0.0367057185596   , 0.0483531662166   , 0.0597671377639   , 0.0786087273551   ,
 0.112951475302    , 0.161599802428    , 0.209942297195    , 0.236662551363    ,
 0.228518054299    , 0.190960827887    , 0.142716159079    , 0.0997840121511   ,
 0.0668117881004   , 0.0417753490788   , 0.0231456900972   , 0.0110505119105   ,
 0.0053050075494   , 0.00513482950275  , 0.01010638041     , 0.0195780232873   ,
 0.03072034056     , 0.0382623871629   , 0.0378621771754   , 0.0298967986701   ,
 0.0196132050188   , 0.0113565223804   , 0.00566414591565  , 0.00244891868789  ,
 0.00090962343045  , 0.000284801845372 , 7.36583785518e-05 , 1.54848792683e-05 ,
 2.61727064918e-06 , 3.53208056516e-07 , 3.78902836006e-08 , 3.2211593045e-09  ,
 2.16499042702e-10 , 1.1480987859e-11  , 4.79492828197e-13 , 1.57441668068e-14 ,
 4.13785027598e-16 , 3.0397734152e-17  , 5.22671653593e-17 , 9.35074294452e-17 ,
 1.31360717741e-16 , 1.44710704596e-16 , 1.24861034532e-16 , 8.42924494073e-17 ,
 4.44835322524e-17 , 1.83373522631e-17 , 5.9011455862e-18  , 1.48970926761e-18 ,
 7.3820094305e-19  , 1.75580203428e-17 , 5.38203572081e-16 , 1.30345996585e-14 ,
 2.49034810195e-13 , 3.76559341278e-12 , 4.5270289998e-11  , 4.36489796645e-10 ,
 3.43420382623e-09 , 2.27645266487e-08 , 1.33292228604e-07 , 7.19542887502e-07 ,
 3.59450785692e-06 , 1.59673928095e-05 , 5.99638218608e-05 , 0.00018358987384  ,
 0.000449343303125 , 0.000871360807293 , 0.00133431574158  , 0.00161241398948  ,
 0.00153891140319  , 0.00116491417004  , 0.000719847679411 , 0.000440718853277 ,
 0.000476875517254 , 0.000892361302716 , 0.00161950324143  , 0.00236825147309  ,
 0.0027180197754   , 0.00244742068665  , 0.00175163969338  , 0.00106263886595  ,
 0.000698761682452 , 0.000717639931813 , 0.00101336607869  , 0.00149862639208  ,
 0.00225030755983  , 0.00347579915461  , 0.00522753439331  , 0.00718927949801  ,
 0.00906758568516  , 0.0114733839856   , 0.0161704541929   , 0.0247007098269   ,
 0.0362817729581   , 0.0474412409818   , 0.054256530438    , 0.0551653978081   ,
 0.0524688662996   , 0.0518488640756   , 0.058571800443    , 0.0716989356433   ,
 0.0833810319722   , 0.0872163440024   , 0.0875693222972   , 0.0984520015309   ,
 0.131132820108    , 0.179976984381    , 0.219723368294    , 0.222373853872    ,
 0.181779341038    , 0.119079085893    , 0.06257421501     , 0.0265923802149   ,
 0.00928557797907  , 0.00272609364591  , 0.000689470750639 , 0.000152319005947 ,
 2.92267156153e-05 , 4.76602058907e-06 , 6.43637001773e-07 , 7.04691619098e-08 ,
 6.16521642746e-09 , 4.27154900979e-10 , 2.3310368671e-11  , 9.98578264174e-13 ,
 3.34801948723e-14 , 8.80711769494e-16 , 2.35319325363e-17 , 2.04465893138e-17 ,
 5.28829252723e-17 , 1.07995856685e-16 , 1.74316321169e-16 , 2.22527790009e-16 ,
 2.24710519511e-16 , 1.79442651224e-16 , 1.13232006709e-16 , 5.63996683372e-17 ,
 2.21443988055e-17 , 6.8437332454e-18  , 1.66233367222e-18 , 3.16899698132e-19 ,
 4.73520734598e-20 , 5.5394962563e-21  , 5.06860534173e-22 , 3.63585447217e-23 ,
 5.41052393003e-24 , 7.74277985131e-23 , 1.37679417372e-21 , 1.91108473463e-20 ,
 2.06908123285e-19 , 1.7479788594e-18  , 1.15285224689e-17 , 5.93961253055e-17 ,
 2.39230132899e-16 , 7.53942492788e-16 , 1.8611680887e-15  , 3.60319061974e-15 ,
 5.47814885199e-15 , 6.55040337499e-15 , 6.17184482276e-15 , 4.62580794177e-15 ,
 3.2020985837e-15  , 6.72764106617e-15 , 6.36643856509e-14 , 1.05414585697e-12 ,
 2.2798804037e-11  , 4.73075464583e-10 , 8.15845317772e-09 , 1.11909218205e-07 ,
 1.20505841447e-06 , 1.01457861809e-05 , 6.67197588279e-05 , 0.000342766979482 ,
 0.00137706664842  , 0.00433557079143  , 0.0107459065705   , 0.0211874628045   ,
 0.0340746583915   , 0.0473347713802   , 0.06303204446     , 0.089261430959    ,
 0.134183313716    , 0.195568823091    , 0.25539198322     , 0.28695210536     ,
 0.272775577257    , 0.218846555379    , 0.149849810237    , 0.0898856537969   ,
 0.0489439437135   , 0.0248099100278   , 0.0116577072893   , 0.00509485656677  ,
 0.00277199652729  , 0.0038777972488   , 0.00864955036353  , 0.0170757461035   ,
 0.0270369686823   , 0.0341566317269   , 0.0346801264721   , 0.0286554520527   ,
 0.0210933849165   , 0.0147964138024   , 0.00891727866391  , 0.00451729753807  ,
 0.00188282162987  , 0.00063556074467  , 0.000172028605288 , 3.7123794236e-05  ,
 6.36663950688e-06 , 8.66001350001e-07 , 9.32908436886e-08 , 7.94836509845e-09 ,
 5.34827797641e-10 , 2.83783987345e-11 , 1.18554770316e-12 , 3.89329458776e-14 ,
 1.00369840336e-15 , 1.83591053174e-17 , 1.73349331766e-26 , 4.26690932459e-28 ,
 6.43318425015e-30 , 0, 0, 0, 0, 0, 0, 8.97271778986e-22 , 5.04342751089e-20 ,
 1.9692834843e-18  , 6.04309696703e-17 , 1.46323299553e-15 , 2.79653025969e-14 ,
 4.24248263044e-13 , 5.15433112588e-12 , 5.1043444366e-11  , 4.25826909859e-10 ,
 3.14439367706e-09 , 2.15093025848e-08 , 1.36883021826e-07 , 7.76910869597e-07 ,
 3.7293721847e-06  , 1.45819925808e-05 , 4.55177365351e-05 , 0.000112404751656 ,
 0.000218855590199 , 0.000335742382611 , 0.00040606531713  , 0.000387840517264 ,
 0.000294428683438 , 0.000185310157648 , 0.000124180801653 , 0.000154819971926 ,
 0.000297276230349 , 0.000528085332628 , 0.00075517856956  , 0.000855492943456 ,
 0.000785589187086 , 0.000661832659746 , 0.000725330720936 , 0.00122154505045  ,
 0.00225225956506  , 0.00368326412447  , 0.00529419517352  , 0.0071568326003   ,
 0.00967006879436  , 0.0128157722707   , 0.0154975270688   , 0.0163520889564   ,
 0.015570754968    , 0.0153804974237   , 0.018106061512    , 0.0237741099412   ,
 0.0299326791164   , 0.0338124769876   , 0.0346429866695   , 0.0346352243634   ,
 0.0382458406119   , 0.0488012110508   , 0.0637625514504   , 0.074751096125    ,
 0.075853803055    , 0.0728053490144   , 0.0817895835699   , 0.116118427129    ,
 0.170473126631    , 0.217688472703    , 0.227003063235    , 0.190387279091    ,
 0.128594439107    , 0.0706520903013   , 0.0321300883663   , 0.0123701886608   ,
 0.00411458326142  , 0.00119104833503  , 0.000296899776811 , 6.23414874695e-05 ,
 1.07734895601e-05 , 1.50467150835e-06 , 1.677614896e-07   , 1.48158649682e-08 ,
 1.03138875355e-09 , 5.64163770989e-11 , 2.41958423715e-12 , 8.12091300831e-14 ,
 2.13263098156e-15 , 4.19581817222e-17 , 1.45410121085e-28 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 1.17217932524e-30 , 5.68495862769e-29 ,
 2.13721721448e-27 , 6.26069486285e-26 , 1.42926172686e-24 , 2.54329149507e-23 ,
 3.52839079668e-22 , 3.81751515092e-21 , 3.22231661669e-20 , 2.12294231323e-19 ,
 1.09228745769e-18 , 4.39203372959e-18 , 1.38129960571e-17 , 3.40122225537e-17 ,
 6.56459811572e-17 , 9.9443082611e-17  , 1.18413348372e-16 , 1.11458453852e-16 ,
 9.8018183989e-17  , 4.88636993629e-16 , 1.00667202942e-14 , 1.84373320789e-13 ,
 2.83327374776e-12 , 3.9138856939e-11  , 5.27459035749e-10 , 7.02152661462e-09 ,
 8.58500444673e-08 , 8.8964049958e-07  , 7.46105029989e-06 , 4.96641836894e-05 ,
 0.000260718624987 , 0.00107883187066  , 0.00352876967385  , 0.00918465617478  ,
 0.0192855811837   , 0.0336116540628   , 0.0513668224143   , 0.0747604339676   ,
 0.110906142624    , 0.166611849242    , 0.237981370324    , 0.304599348025    ,
 0.337277707042    , 0.31745367971     , 0.252241414064    , 0.169347977923    ,
 0.0967760720424   , 0.0476593095442   , 0.0205315058509   , 0.00787565038603  ,
 0.00287388460595  , 0.00158467352474  , 0.00259837817398  , 0.00599765628855  ,
 0.0119700422893   , 0.019389816144    , 0.0256085623696   , 0.0280799051702   ,
 0.0261561901622   , 0.0262645864592   , 0.0215999445755   , 0.0145785169798   ,
 0.00794138429708  , 0.00345698838075  , 0.00119637484357  , 0.000328364187906 ,
 7.14044844533e-05 , 1.22964514432e-05 , 1.67628780471e-06 , 1.80790748039e-07 ,
 1.54127245482e-08 , 1.03741307197e-09 , 5.5054758653e-11  , 2.30017860218e-12 ,
 7.5542784334e-14  , 1.94750666263e-15 , 3.56227320802e-17 , 1.10463126515e-28 ,
 2.25896112421e-30 , 0, 0, 0, 0, 0, 0, 0, 7.98565953576e-23 ,
 4.46929376138e-21 , 1.74333875453e-19 , 5.34337884928e-18 , 1.2959905338e-16  ,
 2.48478539379e-15 , 3.80656807394e-14 , 4.74152633164e-13 , 4.96418935e-12    ,
 4.59865916635e-11 , 3.96079863294e-10 , 3.19454547521e-09 , 2.31023983835e-08 ,
 1.41634935405e-07 , 7.0746813951e-07  , 2.81904788967e-06 , 8.87628797142e-06 ,
 2.20057030424e-05 , 4.29219394377e-05 , 6.59085189568e-05 , 7.98362547171e-05 ,
 7.68870514562e-05 , 6.1537225109e-05  , 5.11838201468e-05 , 7.02990026817e-05 ,
 0.000141630814417 , 0.000268861227877 , 0.000415402260635 , 0.00051236321056  ,
 0.000518811996496 , 0.000503978237184 , 0.000709878238608 , 0.00157614577038  ,
 0.00363164909464  , 0.00710103620685  , 0.0114561299903   , 0.0156915461007   ,
 0.0194940886364   , 0.023731234146    , 0.0288222006111   , 0.0328362564819   ,
 0.0326798405083   , 0.0276690015401   , 0.0208314415266   , 0.0161107021258   ,
 0.0149832881598   , 0.0160707642215   , 0.0172640984686   , 0.0177966814557   ,
 0.0190053760918   , 0.0236842205349   , 0.0335960452093   , 0.046203341573    ,
 0.0549597855268   , 0.0556237354029   , 0.0531748256311   , 0.0608623502488   ,
 0.0897318478292   , 0.135915580497    , 0.1777211287      , 0.189918058694    ,
 0.164709877852    , 0.117063493671    , 0.0694211885949   , 0.0350747940226   ,
 0.0153276515572   , 0.00579759668651  , 0.00187118053236  , 0.000504369606575 ,
 0.000111259604524 , 1.97808956076e-05 , 2.80549554821e-06 , 3.15310624277e-07 ,
 2.79601308872e-08 , 1.95036326269e-09 , 1.06790430973e-10 , 4.58227753654e-12 ,
 1.53865611783e-13 , 4.04066107505e-15 , 7.94974814089e-17 , 5.48235444299e-27 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3.63922358711e-30 ,
 1.7697143374e-28  , 6.65811070879e-27 , 1.95227944071e-25 , 4.46234657322e-24 ,
 7.95289467024e-23 , 1.10552006631e-21 , 1.1991163397e-20  , 1.01537331589e-19 ,
 6.71627000153e-19 , 3.54256548555e-18 , 1.74105310342e-17 , 1.70587966344e-16 ,
 3.79568586404e-15 , 8.42903207288e-14 , 1.49704669594e-12 , 2.08815907385e-11 ,
 2.30745152856e-10 , 2.07504623887e-09 , 1.61332040769e-08 , 1.19365974581e-07 ,
 8.97283817492e-07 , 6.57782911171e-06 , 4.28362808196e-05 , 0.000232131847162 ,
 0.00101718236161  , 0.00357398779914  , 0.0100863419503   , 0.023083473686    ,
 0.043736844527    , 0.0712811835668   , 0.105837778662    , 0.151551553714    ,
 0.213052287885    , 0.28527026399     , 0.347577914082    , 0.372393401427    ,
 0.344251139179    , 0.27233274472     , 0.183954354374    , 0.106072748313    ,
 0.0521540856754   , 0.021841919807    , 0.00789916458768  , 0.0027492534092   ,
 0.00146710509411  , 0.00191729222651  , 0.0037505982921   , 0.00724193448829  ,
 0.0123357149015   , 0.0182515086699   , 0.0236449479232   , 0.0268392482218   ,
 0.0339026881034   , 0.0299509441205   , 0.021083132708    , 0.0117609942363   ,
 0.00518763705683  , 0.00180833423717  , 0.000498285005264 , 0.000108585938151 ,
 1.87208484821e-05 , 2.55363784719e-06 , 2.75503136269e-07 , 2.34910526699e-08 ,
 1.58129243207e-09 , 8.39217171239e-11 , 3.50631414036e-12 , 1.15157272749e-13 ,
 2.96877534897e-15 , 5.43032231336e-17 , 0, 0, 0, 0, 0, 0, 0, 0, 0,
 5.58157049002e-24 , 3.1126843587e-22  , 1.21314492385e-20 , 3.71463595782e-19 ,
 9.05933327317e-18 , 1.75244669546e-16 , 2.74632190299e-15 , 3.60226917419e-14 ,
 4.16812548922e-13 , 4.4923752387e-12  , 4.56717239195e-11 , 4.19537788592e-10 ,
 3.28139928153e-09 , 2.09409336581e-08 , 1.06597063213e-07 , 4.28426740172e-07 ,
 1.35421221762e-06 , 3.36340032813e-06 , 6.56956766739e-06 , 1.01368875997e-05 ,
 1.26619688446e-05 , 1.46737675558e-05 , 2.42035018389e-05 , 6.64180533107e-05 ,
 0.000191645249041 , 0.000456978711956 , 0.000857896392001 , 0.00125971759766  ,
 0.0014536841622   , 0.00136479440661  , 0.00125382246987  , 0.00180489451457  ,
 0.00413182827929  , 0.0094877675656   , 0.0182499570966   , 0.0287323935154   ,
 0.037793687201    , 0.0438148371763   , 0.0485069647031   , 0.0539720764028   ,
 0.0582959083989   , 0.0565512001873   , 0.0467245498745   , 0.0325886648478   ,
 0.0200694892343   , 0.012357348047    , 0.0089438249023   , 0.00782672918059  ,
 0.00769722851937  , 0.00874297484496  , 0.0122133241682   , 0.018831841442    ,
 0.0268654001263   , 0.0323604798602   , 0.0329095396848   , 0.0317697482954   ,
 0.03732013615     , 0.0567384000715   , 0.0881298903978   , 0.118405065676    ,
 0.131520683319    , 0.120984105813    , 0.0936775473575   , 0.0621426286502   ,
 0.0356344626775   , 0.0175670038423   , 0.00732033448074  , 0.00252687412045  ,
 0.000710096089319 , 0.000160428635427 , 2.88956821363e-05 , 4.12627991157e-06 ,
 4.65377395565e-07 , 4.1339941275e-08  , 2.88619525132e-09 , 1.58099016101e-10 ,
 6.78531338171e-12 , 2.27884245265e-13 , 5.98446266697e-15 , 1.17740564908e-16 ,
 1.6118901829e-25  , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.76120890735e-28 , 8.56456488561e-27 , 3.22220484831e-25 , 9.44809204029e-24 ,
 2.15956078112e-22 , 3.84881791327e-21 , 5.35018395196e-20 , 5.80314227266e-19 ,
 4.9139056067e-18  , 3.25031494521e-17 , 1.68543411331e-16 , 7.02942498859e-16 ,
 3.0172217949e-15  , 3.05716797592e-14 , 5.84861997808e-13 , 1.02105258207e-11 ,
 1.41069851505e-10 , 1.52389587001e-09 , 1.29131422387e-08 , 8.69151519531e-08 ,
 4.80742422037e-07 , 2.36261833228e-06 , 1.16004996284e-05 , 6.00925574868e-05 ,
 0.00030373028918  , 0.00134540461109  , 0.00491990612534  , 0.0145428242757   ,
 0.034698137854    , 0.0675867458772   , 0.110280852564    , 0.157465158271    ,
 0.207934111047    , 0.264346853435    , 0.323078810456    , 0.367243145229    ,
 0.375045148498    , 0.336925012815    , 0.263873623295    , 0.179520454175    ,
 0.105617219675    , 0.0533352306754   , 0.0231026595747   , 0.00907092433532  ,
 0.00413318161613  , 0.00302996102028  , 0.00308166046056  , 0.00361755869119  ,
 0.00514840541206  , 0.00864821105415  , 0.0148469950182   , 0.0231978336237   ,
 0.0309206320333   , 0.0386685660865   , 0.0349514342923   , 0.0249141233904   ,
 0.0139932525709   , 0.00619512899606  , 0.00216386121187  , 0.000596896684097 ,
 0.000130151375331 , 2.24458892495e-05 , 3.06226658262e-06 , 3.30406332085e-07 ,
 2.81737166874e-08 , 1.8965490034e-09  , 1.00654090455e-10 , 4.20543142475e-12 ,
 1.38119052996e-13 , 3.56073420261e-15 , 6.51310123518e-17 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 3.05962653344e-25 , 1.70129324469e-23 , 6.62607989716e-22 ,
 2.0272432644e-20  , 5.01064731448e-19 , 9.89141195005e-18 , 1.6246109582e-16  ,
 2.34055545459e-15 , 3.13900640174e-14 , 3.99997827444e-13 , 4.65077481927e-12 ,
 4.6341930935e-11  , 3.77794914566e-10 , 2.45809173906e-09 , 1.26222503226e-08 ,
 5.09300962217e-08 , 1.6131770843e-07  , 4.01942082629e-07 , 7.98815676183e-07 ,
 1.37700020913e-06 , 2.91975771143e-06 , 1.09471278215e-05 , 4.96316422937e-05 ,
 0.000193045802885 , 0.000594179499568 , 0.00142870731443  , 0.00267923708614  ,
 0.00392112686691  , 0.00449956322907  , 0.00416002615504  , 0.00358779544704  ,
 0.00446341391937  , 0.00921923256393  , 0.0202697365334   , 0.037935961792    ,
 0.0581585780248   , 0.0738192564484   , 0.0807934392458   , 0.0821545128008   ,
 0.0836440814741   , 0.0853684730999   , 0.081384610966    , 0.067778954961    ,
 0.0478937136767   , 0.0288462283675   , 0.0154215753696   , 0.00808144040607  ,
 0.00485626160386  , 0.00375429353171  , 0.00391679047019  , 0.00549276091214  ,
 0.0086556117638   , 0.0125105537505   , 0.0151626367771   , 0.015503837663    ,
 0.0151813481313   , 0.0183955952938   , 0.0289728502115   , 0.0466166514526   ,
 0.0656146087692   , 0.0780378882867   , 0.0789614197876   , 0.0687811611682   ,
 0.0516814579644   , 0.033129241464    , 0.0177845121806   , 0.00784781337424  ,
 0.00280543107068  , 0.000804310879617 , 0.000183712612954 , 3.32817505656e-05 ,
 4.76688303636e-06 , 5.38447965437e-07 , 4.78674990778e-08 , 3.34319324443e-09 ,
 1.83166472678e-10 , 7.86188258202e-12 , 2.64063001906e-13 , 6.93455360876e-15 ,
 1.36433055787e-16 , 3.6970259081e-24  , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 6.6171292518e-27  , 3.21783705482e-25 , 1.21063128105e-23 ,
 3.54979162055e-22 , 8.11379771937e-21 , 1.4460593228e-19  , 2.01014533718e-18 ,
 2.18032865462e-17 , 1.8462289372e-16  , 1.22119266466e-15 , 6.31710447643e-15 ,
 2.56711467307e-14 , 8.56030166297e-14 , 3.37016108564e-13 , 3.48611862193e-12 ,
 5.54850981629e-11 , 7.59334849675e-10 , 8.17366626223e-09 , 6.87087671641e-08 ,
 4.52157850373e-07 , 2.3511848952e-06  , 9.92333698237e-06 , 3.64028086472e-05 ,
 0.00013135781751  , 0.000510876668484 , 0.00201743310488  , 0.00715039988467  ,
 0.0211103341453   , 0.0505889626434   , 0.098360672646    , 0.157637445854    ,
 0.215127588738    , 0.262527159774    , 0.301352766325    , 0.333042840231    ,
 0.348988012034    , 0.336067651552    , 0.290627856287    , 0.223426137389    ,
 0.151959152587    , 0.0907579087175   , 0.0472626138581   , 0.022094304298    ,
 0.0111254022656   , 0.00839217338113  , 0.00865510286892  , 0.00873553530495  ,
 0.00781875853449  , 0.00704202966697  , 0.00855375170471  , 0.0142107243589   ,
 0.0238437814101   , 0.0338776995281   , 0.0360745317551   , 0.0327906445554   ,
 0.0234516005813   , 0.0131960669557   , 0.00584805186359  , 0.00204374186225  ,
 0.000563927562568 , 0.000122982030059 , 2.12112645907e-05 , 2.89395875834e-06 ,
 3.12254008832e-07 , 2.66261991341e-08 , 1.79238732704e-09 , 9.5126305402e-11  ,
 3.97448147963e-12 , 1.30534162572e-13 , 3.36519435369e-15 , 6.15543038443e-17 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.31375862726e-26 , 7.28783047663e-25 ,
 2.83681890246e-23 , 8.67345503398e-22 , 2.2079426405e-20  , 4.54538952699e-19 ,
 8.13900819465e-18 , 1.35180320927e-16 , 2.14676914673e-15 , 3.14674294979e-14 ,
 3.98739965511e-13 , 4.15095855929e-12 , 3.45331700007e-11 , 2.26732974171e-10 ,
 1.16912895834e-09 , 4.73180493595e-09 , 1.51382542565e-08 , 4.0180627029e-08  ,
 1.13438421136e-07 , 5.48832646918e-07 , 3.79051751513e-06 , 2.39495935079e-05 ,
 0.000121071506092 , 0.000478861083878 , 0.00147697969731  , 0.00355118168755  ,
 0.006657197303    , 0.00973911195127  , 0.0111654939251   , 0.0102623336668   ,
 0.00851893528076  , 0.00939209122577  , 0.0172809079396   , 0.0358402381717   ,
 0.0646444903551   , 0.0959818868713   , 0.117543653779    , 0.122290277938    ,
 0.115365892281    , 0.107842392603    , 0.103952462596    , 0.0980841094133   ,
 0.0839147459329   , 0.0623648579528   , 0.039976758839    , 0.0226813145189   ,
 0.0122992244328   , 0.00722161071151  , 0.00489469736693  , 0.0037110205946   ,
 0.00332145494618  , 0.00381786220627  , 0.00488056457631  , 0.00571513137265  ,
 0.00581508345434  , 0.00577766080334  , 0.00728219468521  , 0.0120762159581   ,
 0.020635376362    , 0.0314720187831   , 0.0415826444261   , 0.0475397638176   ,
 0.046732120503    , 0.0388739170183   , 0.0268387423308   , 0.0151226323849   ,
 0.0068708954094   , 0.00249747171174  , 0.000722606244926 , 0.000165860621859 ,
 3.01247850259e-05 , 4.32041521271e-06 , 4.88343822635e-07 , 4.34278943255e-08 ,
 3.03362809637e-09 , 1.6622001685e-10  , 7.13491096131e-12 , 2.39772499193e-13 ,
 6.4031336023e-15  , 2.01870445458e-16 , 4.36392975715e-17 , 1.91886427643e-17 ,
 6.64529526776e-18 , 1.81513720676e-18 , 3.9154075224e-19  , 6.67631572145e-20 ,
 9.00402789463e-21 , 9.6055754226e-22  , 8.10282191847e-23 , 5.40042045144e-24 ,
 2.84053728484e-25 , 1.17749699042e-26 , 3.84116910516e-28 , 9.84617902538e-30 ,
 1.75838924224e-31 , 0, 0, 0, 0, 0, 1.93690126243e-25 , 9.41893745246e-24 ,
 3.54364130935e-22 , 1.03906023436e-20 , 2.37499139698e-19 , 4.23276321392e-18 ,
 5.88390054521e-17 , 6.38204448324e-16 , 5.40410051415e-15 , 3.57455555701e-14 ,
 1.84843901592e-13 , 7.48323622157e-13 , 2.38942904219e-12 , 6.46561681704e-12 ,
 2.46258365941e-11 , 2.50629872367e-10 , 3.24121220604e-09 , 3.46904411571e-08 ,
 2.90983767706e-07 , 1.90520465253e-06 , 9.76016754208e-06 , 3.94486626459e-05 ,
 0.000128935559197 , 0.000363871308945 , 0.00100619284773  , 0.00303024859604  ,
 0.00942964615507  , 0.0266183071307   , 0.0629348460649   , 0.12146056989     ,
 0.191923346107    , 0.253755791491    , 0.291919539867    , 0.307130063107    ,
 0.307279631034    , 0.294127436702    , 0.263913117526    , 0.217176754162    ,
 0.162093546409    , 0.109104564512    , 0.0657936140685   , 0.0360069626851   ,
 0.0203376975142   , 0.0162998031292   , 0.0190195722665   , 0.0228204845066   ,
 0.0234216793325   , 0.0198664247261   , 0.0146597133541   , 0.011820237954    ,
 0.014331673224    , 0.0221499928718   , 0.0313733779432   , 0.0269010340921   ,
 0.0244219245385   , 0.0174722974255   , 0.00983529118581  , 0.00435973644095  ,
 0.00152382829186  , 0.000420500962759 , 9.17072430419e-05 , 1.58175198442e-05 ,
 2.15808928218e-06 , 2.32856226507e-07 , 1.98559397706e-08 , 1.3366382216e-09  ,
 7.09386659446e-11 , 2.96389666552e-12 , 9.73434979726e-14 , 2.50953300876e-15 ,
 4.59030121572e-17 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 4.41403381111e-28 ,
 2.44394359084e-26 , 9.50884088407e-25 , 2.90572804271e-23 , 7.86645440377e-22 ,
 1.75150641478e-20 , 3.58974789023e-19 , 7.06496107194e-18 , 1.29970923044e-16 ,
 2.08966925028e-15 , 2.77598948698e-14 , 2.9533334139e-13  , 2.48091366583e-12 ,
 1.63688325051e-11 , 8.4993403813e-11  , 3.56763820582e-10 , 1.4219265142e-09  ,
 8.63871473154e-09 , 8.67002739507e-08 , 8.78541455322e-07 , 7.26707184609e-06 ,
 4.71947489853e-05 , 0.000239214122267 , 0.000945433600401 , 0.0029131242657   ,
 0.00699821304444  , 0.0131105438341   , 0.0191718182502   , 0.0219752331367   ,
 0.0201671934062   , 0.016456013383    , 0.0168000187004   , 0.0278353683503   ,
 0.0538182462453   , 0.0923909275594   , 0.131570326134    , 0.154624620957    ,
 0.153094490374    , 0.135002962091    , 0.116758720066    , 0.107057638232    ,
 0.101398068827    , 0.0909743931556   , 0.0728912614741   , 0.0516100317285   ,
 0.0336517924237   , 0.0222783255656   , 0.016251352324    , 0.0124323488325   ,
 0.008892141934    , 0.00566460601464  , 0.00345142574116  , 0.0023970021763   ,
 0.0020208258999   , 0.00182619281208  , 0.00178028599484  , 0.00235211235963  ,
 0.00423470658479  , 0.00798832340988  , 0.0136923778929   , 0.0205090811327   ,
 0.0263276649718   , 0.0283700368933   , 0.0251613179463   , 0.0180927993769   ,
 0.0104443912468   , 0.00481122770174  , 0.00176218195654  , 0.000511963074866 ,
 0.000117768386997 , 2.14144281481e-05 , 3.0730314853e-06  , 3.47458830245e-07 ,
 3.09044440077e-08 , 2.15903632446e-09 , 1.18311312534e-10 , 5.08391535078e-12 ,
 1.76792072717e-13 , 1.01038710005e-14 , 4.09210943821e-15 , 2.23872421246e-15 ,
 9.84390880376e-16 , 3.4090832475e-16  , 9.31178163517e-17 , 2.0086316189e-17  ,
 3.42499695859e-18 , 4.61912968781e-19 , 4.92772780385e-20 , 4.1568046786e-21  ,
 2.77045370426e-22 , 1.4572156212e-23  , 6.04064244293e-25 , 1.9705467883e-26  ,
 5.05115914565e-28 , 9.02066058279e-30 , 0, 0, 0, 0, 0, 4.4174049486e-24  ,
 2.14813536034e-22 , 8.08182583164e-21 , 2.36973866981e-19 , 5.41653772106e-18 ,
 9.65347564698e-17 , 1.34191514507e-15 , 1.45552462737e-14 , 1.2324892764e-13  ,
 8.15233058747e-13 , 4.21544114013e-12 , 1.70564631587e-11 , 5.41109161459e-11 ,
 1.36238740859e-10 , 3.06110410741e-10 , 1.18308251817e-09 , 1.12770478718e-08 ,
 1.16639265936e-07 , 9.74936372729e-07 , 6.37302439363e-06 , 3.25128284812e-05 ,
 0.000129760521883 , 0.00040838598041  , 0.00103816364253  , 0.00227609166447  ,
 0.00490430895061  , 0.0116366048216   , 0.0288491309288   , 0.0652729474954   ,
 0.12434347072     , 0.194947985699    , 0.253649439377    , 0.281646352088    ,
 0.278279666055    , 0.255191622986    , 0.222080116728    , 0.182769926248    ,
 0.140415004271    , 0.0999380701217   , 0.0657333479558   , 0.0402970607167   ,
 0.0251785715698   , 0.0213130812539   , 0.0276383931377   , 0.0395921697808   ,
 0.0496860870415   , 0.0512402950667   , 0.042967029819    , 0.0298067174284   ,
 0.0189334334898   , 0.0149622981663   , 0.0178814934815   , 0.0236754923222   ,
 0.0160355623831   , 0.0144188846143   , 0.0102964682204   , 0.00579407462563  ,
 0.00256828904222  , 0.000897689971557 , 0.000247721694899 , 5.40262730645e-05 ,
 9.31841914615e-06 , 1.27137778661e-06 , 1.37180945115e-07 , 1.16975998521e-08 ,
 7.87445282287e-10 , 4.1791660402e-11  , 1.74610243712e-12 , 5.73473899093e-14 ,
 1.47842609873e-15 , 2.70425656672e-17 , 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.15940220726e-29 , 6.40911741785e-28 , 2.49269789289e-26 , 7.61380158661e-25 ,
 2.32648077559e-23 , 5.88039629776e-22 , 1.42687527922e-20 , 3.27831691531e-19 ,
 6.66950492975e-18 , 1.12948785505e-16 , 1.53657666823e-15 , 1.65206782619e-14 ,
 1.39915031788e-13 , 9.45842813998e-13 , 5.66605636235e-12 , 4.48542157706e-11 ,
 6.27400252232e-10 , 9.96748267112e-09 , 1.33422364638e-07 , 1.41213375708e-06 ,
 1.16963755135e-05 , 7.56666788065e-05 , 0.000382084244056 , 0.00150544062001  ,
 0.00462729144626  , 0.0110947230454   , 0.0207543760133   , 0.0303209524829   ,
 0.0347557558381   , 0.0319573656642   , 0.0260830647577   , 0.0257935297866   ,
 0.039532328532    , 0.0708810158554   , 0.114324683248    , 0.15415246785     ,
 0.172095591625    , 0.161413884905    , 0.133574891978    , 0.108252562169    ,
 0.0964731720127   , 0.0943591927531   , 0.091137512452    , 0.080446920445    ,
 0.0645791288284   , 0.0502394030299   , 0.0413755279568   , 0.036177464728    ,
 0.0304384168266   , 0.0224586491721   , 0.0139617357584   , 0.00735203501205  ,
 0.00344541758208  , 0.00158709271597  , 0.000815403353767 , 0.000553585928732 ,
 0.000667065261978 , 0.00131620928629  , 0.00283168044724  , 0.0055228788672   ,
 0.00923635259847  , 0.0128732969279   , 0.0146561972227   , 0.0134483047565   ,
 0.00986563335476  , 0.00576033420774  , 0.00267043821744  , 0.00098153848514  ,
 0.000285725618226 , 6.58012874758e-05 , 1.19736648448e-05 , 1.719187516e-06   ,
 1.94479763063e-07 , 1.73070612675e-08 , 1.20992989317e-09 , 6.64853927871e-11 ,
 3.05486535907e-12 , 3.323132881e-13   , 2.17181555693e-13 , 1.52890443312e-13 ,
 8.5457684315e-14  , 3.75766650679e-14 , 1.30133244765e-14 , 3.55454024073e-15 ,
 7.66744990154e-16 , 1.30740710969e-16 , 1.76323747654e-17 , 1.88103710551e-18 ,
 1.58675644273e-19 , 1.05755155809e-20 , 5.5625569498e-22  , 2.30586449345e-23 ,
 7.52207056576e-25 , 1.92815393971e-26 , 3.44341204463e-28 , 0, 0, 0, 0, 0,
 7.85060800407e-23 , 3.81766418292e-21 , 1.43630134207e-19 , 4.2114973803e-18  ,
 9.6262658466e-17  , 1.71561480243e-15 , 2.38485035926e-14 , 2.58675702651e-13 ,
 2.1903788063e-12  , 1.44883144078e-11 , 7.4916229147e-11  , 3.03100676001e-10 ,
 9.60659037036e-10 , 2.39200487781e-09 , 4.7745285764e-09  , 9.21698631023e-09 ,
 3.72287084987e-08 , 3.16036850442e-07 , 2.58823471457e-06 , 1.68830297615e-05 ,
 8.60252481467e-05 , 0.000342104066925 , 0.00106446170422  , 0.00261232639765  ,
 0.00518226984997  , 0.00889852591677  , 0.0151838866297   , 0.0289681385063   ,
 0.0581799573171   , 0.106953873089    , 0.166600909021    , 0.216267565435    ,
 0.237379847457    , 0.227149714746    , 0.196181117741    , 0.156759389407    ,
 0.116918117806    , 0.0815688625294   , 0.0536214741963   , 0.0338504148195   ,
 0.022089724283    , 0.0191657030006   , 0.0268855435506   , 0.045245095751    ,
 0.0689217779024   , 0.0871909794079   , 0.0898639324903   , 0.0751698716523   ,
 0.0512929000353   , 0.0296193727012   , 0.016984392928    , 0.0134498624068   ,
 0.0147815822075   , 0.00783019162722  , 0.00678979500865  , 0.0048081286457   ,
 0.00270043674804  , 0.00119646261113  , 0.000418154553193 , 0.0001153891025   ,
 2.51654125034e-05 , 4.34051469252e-06 , 5.92207345212e-07 , 6.38988596288e-08 ,
 5.4487410235e-09  , 3.66791986493e-10 , 1.9466555201e-11  , 8.13334531256e-13 ,
 2.67124155133e-14 , 6.88650910134e-16 , 1.25964276977e-17 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 2.28284049487e-31 , 1.25490915365e-29 , 4.87418383362e-28 ,
 1.4864256421e-26  , 5.74841935606e-25 , 1.73546989785e-23 , 4.99977084192e-22 ,
 1.29014158829e-20 , 2.78946394452e-19 , 4.85767233887e-18 , 6.68910400423e-17 ,
 7.30571131257e-16 , 7.03275001788e-15 , 8.07953704228e-14 , 1.60817119829e-12 ,
 3.91002350602e-11 , 8.26737565911e-10 , 1.39717997158e-08 , 1.85928044015e-07 ,
 1.94170525556e-06 , 1.58897154388e-05 , 0.000101782915699 , 0.000509897729067 ,
 0.00199637113931  , 0.00610555080743  , 0.0145812635486   , 0.0271935315048   ,
 0.0396469343088   , 0.045434398573    , 0.0419585243463   , 0.0347016958007   ,
 0.0344539060775   , 0.0504384402568   , 0.0842958286241   , 0.126822602619    ,
 0.160119161682    , 0.167851930351    , 0.14794003621     , 0.115168850736    ,
 0.0895466131526   , 0.0813003250855   , 0.0859486706232   , 0.0915702944166   ,
 0.0900289535042   , 0.0825781905478   , 0.0758697493974   , 0.0731921175982   ,
 0.0706801201838   , 0.0623956629126   , 0.0474142580608   , 0.0304384072173   ,
 0.0166793028915   , 0.00801674113752  , 0.00347638675399  , 0.00138100120672  ,
 0.000524857949199 , 0.000277798242043 , 0.000406640186177 , 0.000941594866786 ,
 0.00202670565715  , 0.00364373189862  , 0.00532257409564  , 0.00623591604118  ,
 0.00582029448486  , 0.00431341985971  , 0.00253458183972  , 0.00118018293285  ,
 0.000435325545464 , 0.000127154418701 , 2.93923401087e-05 , 5.37214820831e-06 ,
 7.75563983226e-07 , 8.83390730961e-08 , 7.93086232111e-09 , 5.62647251712e-10 ,
 3.52776002671e-11 , 7.45336507301e-12 , 7.10677699608e-12 , 6.41122032211e-12 ,
 4.56401285126e-12 , 2.55185786096e-12 , 1.12207950628e-12 , 3.8859182093e-13  ,
 1.06142382541e-13 , 2.28958274614e-14 , 3.90405780144e-15 , 5.2652161481e-16  ,
 5.61697846993e-17 , 4.73822485998e-18 , 3.15796233643e-19 , 1.66103914342e-20 ,
 6.88555859761e-22 , 2.24617091781e-23 , 5.75767438841e-25 , 1.02823975461e-26 ,
 0, 0, 0, 0, 0, 1.08738919326e-21 , 5.28785385013e-20 , 1.9894236941e-18  ,
 5.83335295358e-17 , 1.33333589547e-15 , 2.37630129411e-14 , 3.30326072434e-13 ,
 3.58292202944e-12 , 3.03389781007e-11 , 2.00677915742e-10 , 1.0376649646e-09  ,
 4.19819834436e-09 , 1.33040482042e-08 , 3.30715241579e-08 , 6.47614852141e-08 ,
 1.03349688224e-07 , 1.79633165453e-07 , 7.59771312399e-07 , 5.50361968402e-06 ,
 3.54763796717e-05 , 0.000180580125757 , 0.000717653823684 , 0.00222668327996  ,
 0.00540885450895  , 0.0103766304061   , 0.0161563034817   , 0.0220453310586   ,
 0.0306882416991   , 0.048857806025    , 0.0819721799569   , 0.125695285918    ,
 0.164733669089    , 0.18308779916     , 0.175560102826    , 0.148534839927    ,
 0.112617772366    , 0.0770385552245   , 0.0479778635983   , 0.0279902646262   ,
 0.0166194319163   , 0.0129493374153   , 0.0180708824667   , 0.0347282922969   ,
 0.063407327272    , 0.0974627985103   , 0.122942311457    , 0.126563435224    ,
 0.106172870927    , 0.0726911640403   , 0.0411279054135   , 0.0204271472384   ,
 0.0109563316745   , 0.00832479636792  , 0.00347817596584  , 0.0026319325958   ,
 0.00179458746123  , 0.000998229307272 , 0.000441200437427 , 0.000154100829187 ,
 4.25172137483e-05 , 9.27228748211e-06 , 1.59926272237e-06 , 2.1819829682e-07  ,
 2.354346865e-08   , 2.00758279078e-09 , 1.35144111935e-10 , 7.17243138476e-12 ,
 2.99672238061e-13 , 9.84216099574e-15 , 2.537326931e-16   , 4.64114034579e-18 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7.47042182593e-27 , 3.88628645197e-25 ,
 1.49781030555e-23 , 4.50887287493e-22 , 1.06608639309e-20 , 1.98453352491e-19 ,
 2.91702770504e-18 , 5.1349381394e-17  , 1.76390146085e-15 , 6.32472365477e-14 ,
 2.03915670969e-12 , 5.33274276286e-11 , 1.10750626317e-09 , 1.8180240869e-08  ,
 2.35439515055e-07 , 2.40171731514e-06 , 1.92702271367e-05 , 0.000121440377499 ,
 0.000600333961618 , 0.00232536299831  , 0.00705112282996  , 0.0167266469287   ,
 0.0310352928148   , 0.0450909142402   , 0.0516227458859   , 0.0479052678853   ,
 0.0403060690412   , 0.0407045957082   , 0.0580626543058   , 0.0916188165338   ,
 0.129136686258    , 0.152413687624    , 0.149207494986    , 0.122962037935    ,
 0.0906989953437   , 0.0705383088048   , 0.0699061822501   , 0.0829693072449   ,
 0.0974934425422   , 0.105240499883    , 0.107440555334    , 0.110292328427    ,
 0.115389305145    , 0.116263862539    , 0.105340602505    , 0.0826720959813   ,
 0.0559538558373   , 0.0332054025185   , 0.0176254587743   , 0.00839817863475  ,
 0.00352680601013  , 0.00128130091842  , 0.000431952401253 , 0.000230572215387 ,
 0.000347257432223 , 0.000711720078098 , 0.0012944745566   , 0.00192563496743  ,
 0.00229645660882  , 0.00218148474173  , 0.00164776912804  , 0.000989822670996 ,
 0.000473289743355 , 0.000180335921905 , 5.48101676884e-05 , 1.32984744791e-05 ,
 2.57700617413e-06 , 3.9891307855e-07  , 4.93261873376e-08 , 4.88864716755e-09 ,
 4.3393380916e-10  , 1.20163112906e-10 , 1.43613457352e-10 , 1.65130287722e-10 ,
 1.49886096419e-10 , 1.06720214989e-10 , 5.96703561114e-11 , 2.62377016981e-11 ,
 9.0864829298e-12  , 2.48193836086e-12 , 5.35375512775e-13 , 9.12889892654e-14 ,
 1.23117096332e-14 , 1.31342391257e-15 , 1.10794404279e-16 , 7.38429614759e-18 ,
 3.88402508993e-19 , 1.61005732208e-20 , 5.25224479845e-22 , 1.34632298539e-23 ,
 2.40434370327e-25 , 0, 0, 0, 0, 0, 1.1740869618e-20  , 5.70945554712e-19 ,
 2.14804086266e-17 , 6.29844740856e-16 , 1.43964304618e-14 , 2.56576429489e-13 ,
 3.566630395e-12   , 3.86858915464e-11 , 3.27579111906e-10 , 2.16678008071e-09 ,
 1.12039802486e-08 , 4.53291264687e-08 , 1.43644474254e-07 , 3.56985182582e-07 ,
 6.9701597863e-07  , 1.07627378532e-06 , 1.39190264247e-06 , 2.30656919317e-06 ,
 9.95150135321e-06 , 5.96100606379e-05 , 0.000301583918914 , 0.00119910507849  ,
 0.00372320637439  , 0.0090343324953   , 0.0171933082938   , 0.0259550473689   ,
 0.0322162912782   , 0.0363393502922   , 0.044443686872    , 0.0638386708049   ,
 0.0945774335856   , 0.126323671141    , 0.145098990464    , 0.143236287753    ,
 0.122835015604    , 0.0921052342372   , 0.0604445735489   , 0.0349581150255   ,
 0.018530045092    , 0.0105702957125   , 0.0101835420501   , 0.0188246026153   ,
 0.0396296714053   , 0.0729948595839   , 0.111476235254    , 0.139996931802    ,
 0.144469979139    , 0.122569641727    , 0.0856313985046   , 0.0495122949144   ,
 0.0241459510249   , 0.0106890300222   , 0.00526211186675  , 0.00189340880356  ,
 0.000970739925988 , 0.000560607655567 , 0.000296415288321 , 0.000129213530948 ,
 4.49671100428e-05 , 1.23948782903e-05 , 2.70245037585e-06 , 4.660831216e-07   ,
 6.35898831989e-08 , 6.86128411727e-09 , 5.85070227755e-10 , 3.93850619542e-11 ,
 2.09026239848e-12 , 8.73335105965e-14 , 2.86830197813e-15 , 7.39453445083e-17 ,
 1.35256800213e-18 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.99007571322e-28 ,
 5.96082047381e-25 , 3.0688849023e-23  , 1.17066813037e-21 , 3.49719149265e-20 ,
 8.18948541973e-19 , 1.50502828538e-17 , 2.48110377407e-16 , 4.5775171091e-15  ,
 1.07898042364e-13 , 2.9137336753e-12  , 7.09593124033e-11 , 1.41308529432e-09 ,
 2.24290269269e-08 , 2.81966266392e-07 , 2.80152548494e-06 , 2.19673650904e-05 ,
 0.000135750909351 , 0.000660210895642 , 0.00252360295075  , 0.00757266327747  ,
 0.0178226631689   , 0.0328874848364   , 0.0476335619076   , 0.0545170446602   ,
 0.0507764527158   , 0.0430346451724   , 0.0432936468326   , 0.0597890615812   ,
 0.0900584876657   , 0.120598272695    , 0.13457304593     , 0.123950042387    ,
 0.0960953026064   , 0.0683238098194   , 0.0558213481204   , 0.0630936809552   ,
 0.0834417409198   , 0.105318014288    , 0.121312153505    , 0.132546201112    ,
 0.143904217015    , 0.155246710018    , 0.159018375438    , 0.147500549453    ,
 0.121182711694    , 0.088377685785    , 0.0578718252837   , 0.0340712644701   ,
 0.0177170152606   , 0.00793095386381  , 0.0030461619655   , 0.00110638344934  ,
 0.000536368306612 , 0.000472012188225 , 0.000608491357598 , 0.000881348841807 ,
 0.0012241496809   , 0.00148454543937  , 0.00150162639342  , 0.00124218238822  ,
 0.000833261840971 , 0.000451367953568 , 0.000196883462107 , 6.89729621978e-05 ,
 1.93515156077e-05 , 4.33502318481e-06 , 7.72940996104e-07 , 1.09461007022e-07 ,
 1.26191102043e-08 , 2.01022992254e-09 , 1.83733163147e-09 , 2.61484565759e-09 ,
 3.02647736841e-09 , 2.74769397952e-09 , 1.95639693481e-09 , 1.09387834065e-09 ,
 4.80990154177e-10 , 1.66573615152e-10 , 4.54989514143e-11 , 9.81451627818e-12 ,
 1.67351186183e-12 , 2.25698545645e-13 , 2.40777175318e-14 , 2.03108558083e-15 ,
 1.35369087704e-16 , 7.12020377481e-18 , 2.95156080533e-19 , 9.62842730781e-21 ,
 2.46808240955e-22 , 4.40764843572e-24 , 0, 0, 0, 0, 0, 9.8846239907e-20  ,
 4.80678374864e-18 , 1.80843301516e-16 , 5.3026552874e-15  , 1.21203374667e-13 ,
 2.16011386966e-12 , 3.00274183389e-11 , 3.25696054995e-10 , 2.75788459777e-09 ,
 1.82420954028e-08 , 9.43261723845e-08 , 3.81625254497e-07 , 1.2093367696e-06  ,
 3.00532734728e-06 , 5.86528495952e-06 , 9.00995273174e-06 , 1.10107810877e-05 ,
 1.17964976829e-05 , 1.98006529026e-05 , 8.33149495831e-05 , 0.000404728444931 ,
 0.00160835382888  , 0.00501372485736  , 0.0122240969432   , 0.023355450357    ,
 0.0351898948127   , 0.0426683938709   , 0.0443945752612   , 0.046383306903    ,
 0.0580056820137   , 0.0826846868058   , 0.112718640377    , 0.134004511879    ,
 0.13620486668     , 0.118834210109    , 0.0896074249681   , 0.0588725648012   ,
 0.0344128731185   , 0.0189276438927   , 0.0113973324733   , 0.0108296360258   ,
 0.018740991667    , 0.0380397008222   , 0.0687837153838   , 0.104030584096    ,
 0.130574868075    , 0.136291218522    , 0.118667644114    , 0.0864036068679   ,
 0.0526881444674   , 0.0269634071847   , 0.0117254041701   , 0.00458788910903  ,
 0.00156836948146  , 0.000494393007051 , 0.000180350435608 , 7.59112094115e-05 ,
 3.0659865077e-05  , 1.04414986149e-05 , 2.86150785378e-06 , 6.22948809636e-07 ,
 1.07396075636e-07 , 1.4651090761e-08  , 1.58079856525e-09 , 1.34795828834e-10 ,
 9.07400769159e-12 , 4.81579973692e-13 , 2.01209521766e-14 , 6.60834158194e-16 ,
 1.70364242897e-17 , 3.11621002217e-19 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 4.12497797612e-30 , 1.06506827185e-23 , 5.50776411404e-22 , 2.10684092294e-20 ,
 6.30745372741e-19 , 1.47951369677e-17 , 2.7225187444e-16  , 3.97845502775e-15 ,
 4.74276172787e-14 , 5.07706982681e-13 , 6.19459979323e-12 , 9.93900395197e-11 ,
 1.71290595246e-09 , 2.5802245787e-08  , 3.15287745117e-07 , 3.06562591703e-06 ,
 2.36006958946e-05 , 0.000143582110231 , 0.000689403210108 , 0.00260929629276  ,
 0.00777655403355  , 0.0182355276969   , 0.033637016656    , 0.0488694358575   ,
 0.0562809134751   , 0.0527463886231   , 0.0443168793675   , 0.0423719685912   ,
 0.0545793764506   , 0.0782918747432   , 0.101005464054    , 0.108494771435    ,
 0.0957156541071   , 0.0710338866642   , 0.0497632292131   , 0.0437797911272   ,
 0.0556378349853   , 0.0791601427123   , 0.104763773513    , 0.126326549184    ,
 0.144076452801    , 0.160661045076    , 0.175106627408    , 0.181627427034    ,
 0.174477066341    , 0.153220848906    , 0.122638760271    , 0.0888375465908   ,
 0.0570825826513   , 0.0316704477017   , 0.014961384219    , 0.00629790534259  ,
 0.00291938264619  , 0.00201914848379  , 0.00194310866655  , 0.00213430153707  ,
 0.00255659976311  , 0.00318256253377  , 0.0037541897335   , 0.0038791726027   ,
 0.00335493060285  , 0.00237306467252  , 0.00135658790725  , 0.000622508219781 ,
 0.000228254778102 , 6.66372095312e-05 , 1.54413782748e-05 , 2.83246852473e-06 ,
 4.11834418482e-07 , 5.22840793089e-08 , 1.7575593446e-08  , 2.56558926211e-08 ,
 3.75878233761e-08 , 4.35525253784e-08 , 3.9542281918e-08  , 2.81547046125e-08 ,
 1.57421137762e-08 , 6.92197794092e-09 , 2.39717773787e-09 , 6.54780010317e-10 ,
 1.41241696161e-10 , 2.40836784276e-11 , 3.24805059359e-12 , 3.46504867884e-13 ,
 2.9229557996e-14  , 1.94811023135e-15 , 1.02467572627e-16 , 4.24762100636e-18 ,
 1.38563671205e-19 , 3.55184235819e-21 , 6.34309144699e-23 , 0, 0, 0, 0, 0,
 6.49089379104e-19 , 3.15645014097e-17 , 1.18753597918e-15 , 3.48207198508e-14 ,
 7.95901020434e-13 , 1.41847274289e-11 , 1.97179764695e-10 , 2.13873436475e-09 ,
 1.81100829218e-08 , 1.19789588253e-07 , 6.19407642461e-07 , 2.5060021308e-06  ,
 7.94129564355e-06 , 1.97348248238e-05 , 3.85123570566e-05 , 5.91127279855e-05 ,
 7.15770266412e-05 , 6.96247025964e-05 , 6.41441150188e-05 , 0.000115447047091 ,
 0.000452114756133 , 0.00176930670416  , 0.00556447120919  , 0.0137488436491   ,
 0.0266886301126   , 0.0409006855656   , 0.0502405341365   , 0.0519483444726   ,
 0.0517060005322   , 0.0603824728288   , 0.0838224871559   , 0.115490506383    ,
 0.139874655247    , 0.143979644942    , 0.126180188524    , 0.0954999547083   ,
 0.0641693643747   , 0.0402933018864   , 0.0253147202481   , 0.0169460119029   ,
 0.0139026378006   , 0.0178425951158   , 0.0314126900038   , 0.0544927626811   ,
 0.0816184922645   , 0.103176643018    , 0.110390951545    , 0.100447944508    ,
 0.0777734580825   , 0.0509650665505   , 0.027988278263    , 0.0127541050866   ,
 0.00482322094702  , 0.00149502509012  , 0.000384092003591 , 8.90943776893e-05 ,
 2.22610127403e-05 , 6.57197525167e-06 , 1.99126556239e-06 , 5.27255945191e-07 ,
 1.1372477399e-07  , 1.95588949908e-08 , 2.66660576684e-09 , 2.87672494733e-10 ,
 2.45291012858e-11 , 1.65119762856e-12 , 8.7633131659e-14  , 3.66141066436e-15 ,
 1.20252024518e-16 , 3.10011897233e-18 , 5.67056892174e-20 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 1.51567527435e-22 , 7.83801841405e-21 ,
 2.99822404058e-19 , 8.97609600033e-18 , 2.10549028691e-16 , 3.87441179334e-15 ,
 5.60545177687e-14 , 6.39764960809e-13 , 5.81852939653e-12 , 4.38103440332e-11 ,
 3.10429461656e-10 , 2.64882653099e-09 , 2.89072413636e-08 , 3.19217274934e-07 ,
 3.00616442858e-06 , 2.28302228626e-05 , 0.000137840353657 , 0.000659114532552 ,
 0.0024926778322   , 0.00745050756538  , 0.0175954455952   , 0.0328445310811   ,
 0.0485415329148   , 0.0571219885278   , 0.0545845274747   , 0.0453789184038   ,
 0.0395593298204   , 0.0446026269171   , 0.0592171077989   , 0.0737823106304   ,
 0.0774024160718   , 0.0666413986209   , 0.048306007117    , 0.0339296692341   ,
 0.0319581297878   , 0.0439256321415   , 0.0653689602789   , 0.0896653443174   ,
 0.112336312531    , 0.13242676258     , 0.150339903959    , 0.165510669227    ,
 0.176009085137    , 0.17909703455     , 0.171818207194    , 0.151960711354    ,
 0.120247528327    , 0.0825270130074   , 0.0481395492967   , 0.0242923958205   ,
 0.012109143973    , 0.00795770562434  , 0.00737445146999  , 0.00764980356976  ,
 0.00808096588894  , 0.00894225295969  , 0.0103468051352   , 0.0116668076867   ,
 0.0118122145011   , 0.0101603409528   , 0.00720251690459  , 0.00414089880298  ,
 0.00191354437736  , 0.000706713364    , 0.000207731209891 , 4.84338165594e-05 ,
 8.93584726075e-06 , 1.31922340471e-06 , 2.11186175653e-07 , 1.6479863094e-07  ,
 2.87871658358e-07 , 4.25123990872e-07 , 4.92731881043e-07 , 4.47366799225e-07 ,
 3.18532065041e-07 , 1.78100538472e-07 , 7.8312735899e-08  , 2.71207953569e-08 ,
 7.40794243087e-09 , 1.59795708255e-09 , 2.72473962028e-10 , 3.67472609171e-11 ,
 3.92022982262e-12 , 3.30692569404e-13 , 2.20402093859e-14 , 1.15928078479e-15 ,
 4.80560365704e-17 , 1.56765889543e-18 , 4.01842504796e-20 , 7.17634259667e-22 ,
 0, 0, 0, 0, 0, 3.32589322126e-18 , 1.61734523242e-16 , 6.08485979023e-15 ,
 1.78419182072e-13 , 4.07814685294e-12 , 7.2681652667e-11  , 1.01033673311e-09 ,
 1.09587405911e-08 , 9.27949277393e-08 , 6.13794328522e-07 , 3.17380586518e-06 ,
 1.28405974713e-05 , 4.06906966336e-05 , 0.0001011198971   , 0.000197332475141 ,
 0.000302846787442 , 0.000366158417857 , 0.000350291185213 , 0.000274196142685 ,
 0.000233198916278 , 0.00047637464677  , 0.0016836945654   , 0.00536033325279  ,
 0.0136167870753   , 0.0273251684354   , 0.0434542401043   , 0.0554074265354   ,
 0.0588376473282   , 0.0580491513079   , 0.064413058897    , 0.0859055709223   ,
 0.117599633316    , 0.143463211352    , 0.148680626165    , 0.130814305533    ,
 0.100032494237    , 0.0700356944475   , 0.048614604722    , 0.0352049982105   ,
 0.0258547783826   , 0.0192572580773   , 0.017876814498    , 0.0246796983983   ,
 0.0396095392314   , 0.0584678954516   , 0.074625262607    , 0.082199738808    ,
 0.078447523031    , 0.0645280597428   , 0.045071096168    , 0.0262247325399   ,
 0.0124892777723   , 0.00480951840509  , 0.00125698348456  , 0.000310385821783 ,
 6.18787672833e-05 , 1.05917289613e-05 , 1.81499195611e-06 , 3.66088402796e-07 ,
 8.14541336841e-08 , 1.66484057357e-08 , 2.82178892082e-09 , 3.83268870537e-10 ,
 4.13077054078e-11 , 3.52137371037e-12 , 2.37026584844e-13 , 1.2579585604e-14  ,
 5.25589215095e-16 , 1.72619716758e-17 , 4.45016756321e-19 , 8.14000433716e-21 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.72012339213e-31 , 1.69220704532e-21 ,
 8.75091794879e-20 , 3.34742930714e-18 , 1.00215482194e-16 , 2.35071822138e-15 ,
 4.32566725799e-14 , 6.25349302095e-13 , 7.11392422335e-12 , 6.38181749794e-11 ,
 4.53435718186e-10 , 2.58717960939e-09 , 1.24839561229e-08 , 5.98475492737e-08 ,
 3.62720449148e-07 , 2.69536887586e-06 , 1.92204354214e-05 , 0.000114765401189 ,
 0.000551122033797 , 0.00210798856188  , 0.00640917622585  , 0.0154902681454   ,
 0.0297870494999   , 0.0456586661527   , 0.0560226717535   , 0.055678840778    ,
 0.0466004922557   , 0.0369189861631   , 0.0341556203229   , 0.0392215346727   ,
 0.0461573306831   , 0.047437973432    , 0.0403860203037   , 0.0291539291144   ,
 0.0210042869512   , 0.0211735870821   , 0.0305327393469   , 0.0464222714586   ,
 0.065121523912    , 0.0839847704993   , 0.101676477524    , 0.117634610445    ,
 0.132645467362    , 0.148607610181    , 0.165057595213    , 0.175687388142    ,
 0.170660251865    , 0.144922707144    , 0.104714377688    , 0.0644180717263   ,
 0.036318829201    , 0.0235635001388   , 0.0214343031644   , 0.0231463379169   ,
 0.0245184407213   , 0.0250337407359   , 0.0260122249427   , 0.0281363551169   ,
 0.0301752022077   , 0.0296824204499   , 0.0251854652055   , 0.017767881258    ,
 0.0102137391629   , 0.00473007960792  , 0.00175246702547  , 0.000516910785987 ,
 0.000120937520508 , 2.24151597814e-05 , 3.44344789316e-06 , 9.313792873e-07   ,
 1.38277118169e-06 , 2.55827583498e-06 , 3.78649287147e-06 , 4.38901806953e-06 ,
 3.98493810697e-06 , 2.83733751095e-06 , 1.58643788185e-06 , 6.97573920963e-07 ,
 2.41579602545e-07 , 6.59865527974e-08 , 1.42338686902e-08 , 2.4270730773e-09  ,
 3.27327746723e-10 , 3.49196094646e-11 , 2.94565776697e-12 , 1.963240793e-13   ,
 1.03263417129e-14 , 4.28061141943e-16 , 1.39639867683e-17 , 3.57942882176e-19 ,
 6.39235707387e-21 , 0, 0, 0, 0, 0, 1.3304206589e-17  , 6.46968909297e-16 ,
 2.43405985491e-14 , 7.13710723673e-13 , 1.63133644483e-11 , 2.90740459198e-10 ,
 4.04153943903e-09 , 4.38370504151e-08 , 3.71197391935e-07 , 2.45529426615e-06 ,
 1.26958282023e-05 , 5.13648365491e-05 , 0.00016277053793  , 0.000404498788544 ,
 0.000789365904497 , 0.00121141619609  , 0.00146430386175  , 0.00139688565515  ,
 0.00105991916361  , 0.00068767239388  , 0.000631608145941 , 0.00154944276799  ,
 0.00488681061068  , 0.012948013347    , 0.0273060733109   , 0.045706169266    ,
 0.0611292329494   , 0.0669839162204   , 0.0650767478603   , 0.0664393046612   ,
 0.081321744911    , 0.107872062048    , 0.131848100977    , 0.138239175811    ,
 0.123426060947    , 0.0968215729602   , 0.0718107611405   , 0.0551774654152   ,
 0.0445401236809   , 0.0347873265851   , 0.0251360339797   , 0.0194341486497   ,
 0.0214862406248   , 0.0313006548305   , 0.0448415923653   , 0.0564883139544   ,
 0.061974348397    , 0.0595981232597   , 0.0499464198002   , 0.0357551844206   ,
 0.021324070315    , 0.0103674952575   , 0.00404670942173  , 0.000856398405488 ,
 0.000210120931833 , 4.06950316487e-05 , 6.2805163318e-06  , 8.04783292471e-07 ,
 9.66373933076e-08 , 1.3183333116e-08  , 2.10544261863e-09 , 3.28833341023e-10 ,
 4.36719737064e-11 , 4.6798528341e-12  , 3.98373614085e-13 , 2.6802626103e-14  ,
 1.42248148958e-15 , 5.94328743836e-17 , 1.95196155877e-18 , 5.03682557464e-20 ,
 1.57566536555e-21 , 7.2467731078e-21  , 6.28551993866e-20 , 4.28109510127e-19 ,
 2.29307307821e-18 , 9.67337614173e-18 , 3.21853429435e-17 , 8.45680222121e-17 ,
 1.75648145405e-16 , 2.88549104418e-16 , 3.74958674258e-16 , 3.85283588278e-16 ,
 3.12834631097e-16 , 2.0075640322e-16  , 1.03245270224e-16 , 4.9690035224e-17  ,
 4.78336971559e-17 , 1.3174205314e-16  , 1.10476187878e-15 , 2.10204929561e-14 ,
 3.79978487924e-13 , 5.4853962078e-12  , 6.237955044e-11   , 5.59012339703e-10 ,
 3.95377603437e-09 , 2.21186143878e-08 , 9.8380053142e-08  , 3.54542514346e-07 ,
 1.11294336035e-06 , 3.72907917769e-06 , 1.65038174063e-05 , 8.48217954458e-05 ,
 0.000399503614335 , 0.00155780259308  , 0.00489698074366  , 0.0123396179493   ,
 0.0249044109189   , 0.0402735116356   , 0.0522551809837   , 0.0546535747253   ,
 0.0468593549741   , 0.0348873313795   , 0.0262003428965   , 0.0237485762419   ,
 0.0247879458015   , 0.0245655072307   , 0.0208755576134   , 0.0155902105447   ,
 0.0125597177915   , 0.0144957757738   , 0.0214676222981   , 0.031601986639    ,
 0.0429496143227   , 0.0545999864277   , 0.0662207504606   , 0.0780483275022   ,
 0.092515478293    , 0.11381196942     , 0.142278802122    , 0.168765763435    ,
 0.17784540783     , 0.160103306167    , 0.121752318752    , 0.0808788058584   ,
 0.054123397415    , 0.0466039196676   , 0.0519308735084   , 0.0595920434335   ,
 0.06300136767     , 0.0623569782177   , 0.0613832611543   , 0.0622955935956   ,
 0.0633314785563   , 0.0601798817021   , 0.0501166436817   , 0.0350532711414   ,
 0.0200906371341   , 0.00930415539375  , 0.00345210765544  , 0.00102036260643  ,
 0.00023933640522  , 4.47072255198e-05 , 7.76906199888e-06 , 4.66519612316e-06 ,
 9.54511584474e-06 , 1.79566723811e-05 , 2.65935104198e-05 , 3.08257254492e-05 ,
 2.79877139849e-05 , 1.99276821204e-05 , 1.11421461689e-05 , 4.89932240229e-06 ,
 1.69670387571e-06 , 4.63448240432e-07 , 9.99697853408e-08 , 1.70462426261e-08 ,
 2.29894532261e-09 , 2.45253496591e-10 , 2.06884581981e-11 , 1.37885759331e-12 ,
 7.25257694316e-14 , 3.00643393232e-15 , 9.80743170806e-17 , 2.51396715499e-18 ,
 4.48959240115e-20 , 0, 0, 0, 0, 0, 4.1573275748e-17  , 2.02166259871e-15 ,
 7.60600347475e-14 , 2.23021888049e-12 , 5.09763580602e-11 , 9.08512146632e-10 ,
 1.26290908492e-08 , 1.36982974175e-07 , 1.15992573241e-06 , 7.67235726181e-06 ,
 3.96722019812e-05 , 0.000160505967065 , 0.000508628949551 , 0.00126398668645  ,
 0.00246662718658  , 0.00378544450741  , 0.00457546512335  , 0.00436253972715  ,
 0.00329062276537  , 0.00200353658552  , 0.00119969047915  , 0.00159786447111  ,
 0.00455514239041  , 0.0125202552864   , 0.0277118716023   , 0.0485524227542   ,
 0.0674479116863   , 0.0753572537437   , 0.0712515121417   , 0.0653314697916   ,
 0.06990023602     , 0.0869960274545   , 0.106065709522    , 0.113507005215    ,
 0.104250434786    , 0.0849717605316   , 0.066878087971    , 0.0555079674996   ,
 0.0478064521248   , 0.0386348879709   , 0.0279629239134   , 0.0206950446584   ,
 0.0212693985978   , 0.0295679759007   , 0.0408779252402   , 0.0491007621471   ,
 0.0506334224515   , 0.0456100828988   , 0.0362086091878   , 0.0250257547997   ,
 0.0146605967417   , 0.00707964168176  , 0.00275929946627  , 0.000464063901299 ,
 0.000113201203983 , 2.17724104134e-05 , 3.29420455315e-06 , 3.94178968513e-07 ,
 3.83193297129e-08 , 3.31041696011e-09 , 3.07215339434e-10 , 3.44956476015e-11 ,
 4.06333245125e-12 , 4.21001354408e-13 , 3.5530717054e-14  , 2.38392653333e-15 ,
 1.2652086245e-16  , 5.28618911814e-18 , 1.73739098077e-19 , 6.72296323456e-21 ,
 3.1813748016e-20  , 3.50964357001e-19 , 3.04410450124e-18 , 2.07335288014e-17 ,
 1.11054521299e-16 , 4.68485791828e-16 , 1.55875008407e-15 , 4.09566590499e-15 ,
 8.5067156789e-15  , 1.39745579891e-14 , 1.81594110886e-14 , 1.86594538582e-14 ,
 1.51507429624e-14 , 9.72290408294e-15 , 5.00123079132e-15 , 2.41032543877e-15 ,
 2.29999092631e-15 , 5.20254041938e-15 , 1.70886786497e-14 , 1.61900317181e-13 ,
 2.64584687935e-12 , 3.7880969581e-11  , 4.30499338629e-10 , 3.85741475416e-09 ,
 2.72730854201e-08 , 1.52341259213e-07 , 6.73088942639e-07 , 2.35701963453e-06 ,
 6.58667230391e-06 , 1.51292807559e-05 , 3.20185642313e-05 , 8.14821580198e-05 ,
 0.000282785588571 , 0.00104948846312  , 0.00340231669844  , 0.00902634609114  ,
 0.0192803857417   , 0.0330000757672   , 0.0451714022078   , 0.0494549920234   ,
 0.0435493203534   , 0.0315946350866   , 0.0204514728854   , 0.0140937434067   ,
 0.0118431452517   , 0.0108765784689   , 0.00950457768459  , 0.00840914080482  ,
 0.0095311157072   , 0.0139752632904   , 0.0206894540604   , 0.0271909126001   ,
 0.0318665024762   , 0.0352873191033   , 0.039229406274    , 0.0458845496842   ,
 0.0590139460881   , 0.0834574063706   , 0.119454502056    , 0.156551293097    ,
 0.176779003991    , 0.16817364339     , 0.136155159574    , 0.100666409885    ,
 0.0818208506739   , 0.0866309311564   , 0.106083014477    , 0.123859623153    ,
 0.129593313871    , 0.124807469154    , 0.117346973454    , 0.112322600506    ,
 0.108084237494    , 0.0986995312172   , 0.0802422012912   , 0.0554079419254   ,
 0.0315636556173   , 0.0145829981991   , 0.00540888542999  , 0.00160019050906  ,
 0.000376465593432 , 7.20086924383e-05 , 1.7528914629e-05  , 2.30006211741e-05 ,
 5.26947904854e-05 , 9.95612625816e-05 , 0.000147462788823 , 0.000170929556529 ,
 0.000155192406258 , 0.000110499342872 , 6.17833931326e-05 , 2.71668287042e-05 ,
 9.40825336995e-06 , 2.56982898029e-06 , 5.54334335596e-07 , 9.4521743777e-08  ,
 1.27476975722e-08 , 1.35993583524e-09 , 1.14718035699e-10 , 7.64583200307e-12 ,
 4.02167371292e-13 , 1.66733427283e-14 , 5.45867104656e-16 , 2.05095286075e-17 ,
 2.11770144776e-17 , 5.5288224052e-17  , 1.21458420214e-16 , 2.22996560878e-16 ,
 3.41376773225e-16 , 4.31677862487e-16 , 5.46614069617e-16 , 5.307910752e-15   ,
 1.86046806306e-13 , 5.44820336398e-12 , 1.24527322913e-10 , 2.21935311285e-09 ,
 3.08508940097e-08 , 3.34627985781e-07 , 2.8335172051e-06  , 1.87423694133e-05 ,
 9.69129898264e-05 , 0.000392091010817 , 0.00124250118123  , 0.0030877227145   ,
 0.00602558743551  , 0.00924725087275  , 0.0111770543122   , 0.0106557520297   ,
 0.00802702963068  , 0.00481357608407  , 0.00248259098032  , 0.00193959082196  ,
 0.00432139730426  , 0.0119225674335   , 0.0272018002858   , 0.0490096794174   ,
 0.0695512781192   , 0.07833926575     , 0.0722545765683   , 0.0602797236575   ,
 0.0555943479425   , 0.0633693902769   , 0.077033962965    , 0.0851529265013   ,
 0.0813805448727   , 0.0689651780438   , 0.0562896561859   , 0.0481398508354   ,
 0.042261250031    , 0.0345312939942   , 0.0253010227408   , 0.0193105206475   ,
 0.0207518196772   , 0.0292595363262   , 0.0396506591687   , 0.0453745431103   ,
 0.0432520342674   , 0.0350844157374   , 0.0248739312703   , 0.0155964734392   ,
 0.00853580320988  , 0.00395937101016  , 0.00151087311898  , 0.000200455557262 ,
 4.82088106261e-05 , 9.20195710274e-06 , 1.38341622864e-06 , 1.6331256928e-07  ,
 1.51780199215e-08 , 1.13010328453e-09 , 7.18880194374e-11 , 4.61597976902e-12 ,
 3.59095226788e-13 , 3.14103066006e-14 , 2.52324481421e-15 , 1.6653576117e-16  ,
 8.83846968125e-18 , 3.69483555633e-19 , 1.68074113824e-20 , 8.47587906015e-20 ,
 1.1924659889e-18  , 1.31889819055e-17 , 1.14395273079e-16 , 7.79152158307e-16 ,
 4.17336494945e-15 , 1.76055120254e-14 , 5.85777762282e-14 , 1.53917847218e-13 ,
 3.19699445271e-13 , 5.2522772919e-13  , 6.82602377788e-13 , 7.01575061136e-13 ,
 5.69940613428e-13 , 3.66171956965e-13 , 1.88921902672e-13 , 9.180740549e-14   ,
 8.79174410313e-14 , 1.91256352349e-13 , 4.50143849819e-13 , 1.51412433703e-12 ,
 1.52739619155e-11 , 2.06960673598e-10 , 2.34177815156e-09 , 2.09760180091e-08 ,
 1.48299091678e-07 , 8.28265851396e-07 , 3.65761937482e-06 , 1.27786788741e-05 ,
 3.53447552622e-05 , 7.76079250648e-05 , 0.000137219546037 , 0.000208762184319 ,
 0.000341748928092 , 0.000799521579772 , 0.00231719064575  , 0.00622253540726  ,
 0.0138021968656   , 0.024568320421    , 0.0348290077863   , 0.0392343166288   ,
 0.0351639236223   , 0.0253142730308   , 0.0151847981873   , 0.00850771569463  ,
 0.00552823719262  , 0.00468245580047  , 0.0049259446077   , 0.00671957502664  ,
 0.0113524738667   , 0.0190791712037   , 0.0275400044115   , 0.0327147047236   ,
 0.0324040439498   , 0.0284291089968   , 0.0250227432655   , 0.0264421635661   ,
 0.0370701538763   , 0.0613201381125   , 0.0992200285374   , 0.140858964756    ,
 0.168684622094    , 0.169919559836    , 0.148424456995    , 0.12395029323     ,
 0.118660404362    , 0.140902701831    , 0.178313413448    , 0.207644720356    ,
 0.214201296583    , 0.20140735575     , 0.182246141723    , 0.165568793989    ,
 0.150810525723    , 0.131689541923    , 0.10388170298     , 0.0704492175855   ,
 0.039732297448    , 0.0182622331356   , 0.0067593615695   , 0.00200211781134  ,
 0.000476353207877 , 9.98031353881e-05 , 4.64534679147e-05 , 9.78787920232e-05 ,
 0.000230884900773 , 0.000436381579646 , 0.000646263192437 , 0.000749089367068 ,
 0.000680119446828 , 0.000484255096283 , 0.000270761120564 , 0.000119056631674 ,
 4.12309912725e-05 , 1.12620936971e-05 , 2.42933189957e-06 , 4.14235185895e-07 ,
 5.58659647969e-08 , 5.95984241844e-09 , 5.02749407511e-10 , 3.35090620435e-11 ,
 1.76293737854e-12 , 7.31862997458e-14 , 2.4874562297e-15  , 3.98394640225e-16 ,
 1.07077345374e-15 , 2.80731166201e-15 , 6.11808473254e-15 , 1.11373574087e-14 ,
 1.69139259178e-14 , 2.12462231352e-14 , 2.19894676191e-14 , 2.74623093693e-14 ,
 3.67029464477e-13 , 1.04197723834e-11 , 2.38026820557e-10 , 4.24212322078e-09 ,
 5.89691072482e-08 , 6.39615629252e-07 , 5.4160501916e-06  , 3.58246002179e-05 ,
 0.000185241764798 , 0.000749452151579 , 0.00237494760751  , 0.00590195487897  ,
 0.0115174855532   , 0.0176755187071   , 0.0213642862428   , 0.0203674706333   ,
 0.0153376139383   , 0.00915658335395  , 0.00448493071684  , 0.00251015184368  ,
 0.00391825747727  , 0.0103633938292   , 0.0239539456568   , 0.0438088338754   ,
 0.0629055536554   , 0.071214969409    , 0.0648692908513   , 0.0511653295005   ,
 0.0423328878823   , 0.0448446696127   , 0.0550871444483   , 0.0636644031416   ,
 0.0634465829486   , 0.0549212350017   , 0.0442940361506   , 0.0364261291006   ,
 0.0308154524457   , 0.0247599891256   , 0.0183553692355   , 0.0149441968709   ,
 0.0175910248108   , 0.025753691443    , 0.0347300659988   , 0.0386055464115   ,
 0.0348245983012   , 0.0258613119487   , 0.0162581232068   , 0.00892104221788  ,
 0.00433967916217  , 0.00185040780225  , 0.000670969992525 , 7.01979467011e-05 ,
 1.63523862825e-05 , 3.07036490462e-06 , 4.57662693876e-07 , 5.37103293667e-08 ,
 4.94450578063e-09 , 3.57360277871e-10 , 2.05066999343e-11 , 9.77680474538e-13 ,
 4.43932389635e-14 , 2.37846612703e-15 , 1.51799432483e-16 , 9.12617938977e-18 ,
 4.84523685266e-19 , 2.61690473915e-20 , 1.37664890486e-19 , 2.47253797448e-18 ,
 3.49143575215e-17 , 3.86163557585e-16 , 3.34940779845e-15 , 2.28129948328e-14 ,
 1.22193130927e-13 , 5.154780612e-13   , 1.71512943831e-12 , 4.50669563786e-12 ,
 9.36098628384e-12 , 1.53796992585e-11 , 1.99897585354e-11 , 2.05490070736e-11 ,
 1.66994354138e-11 , 1.07375096497e-11 , 5.55160354892e-12 , 2.71356891031e-12 ,
 2.60901873328e-12 , 5.62448259088e-12 , 1.24300670335e-11 , 2.50954183402e-11 ,
 9.15343428318e-11 , 9.16550502307e-10 , 1.00723766463e-08 , 9.00175732468e-08 ,
 6.36308129951e-07 , 3.55376655166e-06 , 1.56927379811e-05 , 5.48154118299e-05 ,
 0.000151480861858 , 0.000331239026005 , 0.000574327203793 , 0.000799444455776 ,
 0.000947249524241 , 0.00117293295558  , 0.00204488274966  , 0.00455255903233  ,
 0.0096044203541   , 0.0168656961175   , 0.0238257240328   , 0.0268266828831   ,
 0.0240157567612   , 0.0171494399002   , 0.00997627454052  , 0.00519657402967  ,
 0.00328988899883  , 0.00354530932897  , 0.00551796697173  , 0.00974681023765  ,
 0.0173150252682   , 0.0280010284462   , 0.0383683987451   , 0.0429676138886   ,
 0.0389997981683   , 0.0293375523696   , 0.0201908010891   , 0.0171180571011   ,
 0.0242554255255   , 0.0449606613295   , 0.0792268817754   , 0.119247132209    ,
 0.150475704056    , 0.161265441619    , 0.153651204675    , 0.144828068391    ,
 0.156066910078    , 0.195253636699    , 0.247046005129    , 0.283386035208    ,
 0.287306816372    , 0.2645252559      , 0.232056095078    , 0.201492705195    ,
 0.173871078877    , 0.1443760366      , 0.109640690613    , 0.0725165524267   ,
 0.0402812806177   , 0.0183607204188   , 0.0067836474094   , 0.00203417012608  ,
 0.000516555598675 , 0.000148414629883 , 0.000140047350825 , 0.000340643040893 ,
 0.000801806037439 , 0.00151301514429  , 0.00224003851432  , 0.0025963200789   ,
 0.00235725479924  , 0.00167839927289  , 0.000938442542405 , 0.00041264390698  ,
 0.000142904589166 , 3.90339203779e-05 , 8.41997155321e-06 , 1.43572657786e-06 ,
 1.93630663631e-07 , 2.06570973286e-08 , 1.74270202324e-09 , 1.16205130113e-10 ,
 6.12802725485e-12 , 2.58281197315e-13 , 1.23810060782e-14 , 1.31642954578e-14 ,
 4.08255956909e-14 , 1.06880530428e-13 , 2.32415422458e-13 , 4.22112912575e-13 ,
 6.39651435225e-13 , 8.02020833412e-13 , 8.21899218163e-13 , 6.92858735204e-13 ,
 9.78901540863e-13 , 1.58242034656e-11 , 3.56463944408e-10 , 6.3513079458e-09  ,
 8.82881636306e-08 , 9.57628414274e-07 , 8.10887770509e-06 , 5.36364008112e-05 ,
 0.000277343219399 , 0.00112207845092  , 0.0035557774769   , 0.00883646813911  ,
 0.0172442699263   , 0.0264647291666   , 0.0319888754857   , 0.0304981425048   ,
 0.0229665619079   , 0.0136919860055   , 0.00657406991201  , 0.00306493219679  ,
 0.00326632353752  , 0.00788606477431  , 0.0182972027371   , 0.0338767342824   ,
 0.0492735702215   , 0.0564760456882   , 0.0518804084666   , 0.0406723780898   ,
 0.0326458301318   , 0.0339418504672   , 0.0427265151277   , 0.0513324071209   ,
 0.052546299099    , 0.0452894969358   , 0.0344933564387   , 0.0254162802184   ,
 0.0192585696763   , 0.0145293895169   , 0.0107434094974   , 0.00944176945747  ,
 0.0122696731248   , 0.0186717295797   , 0.025233443645    , 0.0276648771264   ,
 0.024227924305    , 0.0170543082987   , 0.00982478178633  , 0.00476727979757  ,
 0.00201327605152  , 0.000754640176689 , 0.000249016099626 , 2.06541914384e-05 ,
 4.51139856019e-06 , 8.17392625236e-07 , 1.19616979034e-07 , 1.39081663432e-08 ,
 1.27353494491e-09 , 9.14744051533e-11 , 5.15625872082e-12 , 2.30202833228e-13 ,
 8.43675627937e-15 , 2.83847724619e-16 , 1.07047258648e-17 , 4.22747478107e-19 ,
 2.66112238062e-20 , 1.38977485454e-19 , 3.15364450802e-18 , 5.66378406561e-17 ,
 7.98015399387e-16 , 8.8174701624e-15  , 7.64441216534e-14 , 5.20558779376e-13 ,
 2.78801480316e-12 , 1.17609526427e-11 , 3.91314055117e-11 , 1.02823370578e-10 ,
 2.135849469e-10   , 3.50936961881e-10 , 4.56196407136e-10 , 4.69091944833e-10 ,
 3.81431952406e-10 , 2.45567734988e-10 , 1.27392564325e-10 , 6.28360909333e-11 ,
 6.07905798612e-11 , 1.30033670793e-10 , 2.8332094476e-10  , 5.11203512681e-10 ,
 9.05197698021e-10 , 3.75972794995e-09 , 3.47038392028e-08 , 3.05503666953e-07 ,
 2.1570246728e-06  , 1.20458458093e-05 , 5.31914125512e-05 , 0.00018579577921  ,
 0.000513391676385 , 0.00112209883494  , 0.00194112665447  , 0.00267108882113  ,
 0.00299375601068  , 0.0029925976701   , 0.00335407008339  , 0.00503224862422  ,
 0.00850879126318  , 0.0130846203321   , 0.0168259316171   , 0.0176519648259   ,
 0.0149820712685   , 0.0103060765914   , 0.00599571733437  , 0.0037392995643   ,
 0.00409587307577  , 0.00695386676129  , 0.0120337790213   , 0.0193201825184   ,
 0.0291431337376   , 0.0408384893849   , 0.0507532122258   , 0.0532951435795   ,
 0.0459029279988   , 0.0322684849882   , 0.0194809203764   , 0.0131911459297   ,
 0.0165139738524   , 0.0314349442206   , 0.0580117498675   , 0.0913721767342   ,
 0.121707947843    , 0.140347366544    , 0.147924462413    , 0.15698683421     ,
 0.183981410103    , 0.233512749838    , 0.288785315048    , 0.322397004137    ,
 0.319828823689    , 0.289154460535    , 0.247937958416    , 0.207412039243    ,
 0.169741860143    , 0.133035644251    , 0.096149900174    , 0.0613682664273   ,
 0.0333335935755   , 0.0150515175253   , 0.00564100711757  , 0.00184524093764  ,
 0.000630662919369 , 0.000329688280721 , 0.00041421344725  , 0.000957389773173 ,
 0.00220808994332  , 0.00415137529308  , 0.00614249603738  , 0.00711879826894  ,
 0.00646322532065  , 0.00460191217681  , 0.00257307401648  , 0.00113141542914  ,
 0.000391827851431 , 0.000107027203422 , 2.30869308083e-05 , 3.93670869387e-06 ,
 5.30949514637e-07 , 5.66534085609e-08 , 4.78378728442e-09 , 3.20491491859e-10 ,
 1.73274654635e-11 , 8.48186435292e-13 , 1.48506546804e-13 , 3.88983505026e-13 ,
 1.21814201318e-12 , 3.18104412554e-12 , 6.89856257099e-12 , 1.24930452065e-11 ,
 1.88795162471e-11 , 2.36171842955e-11 , 2.4151761498e-11  , 1.99432194764e-11 ,
 1.37421302446e-11 , 2.51399819759e-11 , 4.21237360766e-10 , 7.45833826146e-09 ,
 1.03664879209e-07 , 1.12441225445e-06 , 9.5211626193e-06  , 6.29781868496e-05 ,
 0.00032564949234  , 0.00131752933465  , 0.00417522016209  , 0.0103761888593   ,
 0.0202502715859   , 0.0310816703098   , 0.037577917422    , 0.0358419321653   ,
 0.0270115755617   , 0.0161182633797   , 0.00769564037094  , 0.00328837157493  ,
 0.00255627536975  , 0.00544682730505  , 0.0127092499923   , 0.0240827736357   ,
 0.0360819495305   , 0.0429370357872   , 0.041367971168    , 0.0342433680307   ,
 0.0284891179555   , 0.0293329810623   , 0.0362650709558   , 0.0435223430083   ,
 0.0447192210138   , 0.0381526709479   , 0.0276364463705   , 0.0181475950733   ,
 0.0117329544668   , 0.00775313653786  , 0.00541607643572  , 0.00496856272265  ,
 0.0069465326803   , 0.0108762202357   , 0.0147501436823   , 0.016076703439    ,
 0.0138828040999   , 0.00950924613828  , 0.00521217781034  , 0.00232678682534  ,
 0.000870235592959 , 0.000282155716697 , 8.11986459369e-05 , 5.3937296641e-06  ,
 1.05499819471e-06 , 1.78386881268e-07 , 2.52066094253e-08 , 2.90524427465e-09 ,
 2.71144931224e-10 , 2.08009026384e-11 , 1.37323325073e-12 , 8.39773186401e-14 ,
 5.01970471633e-15 , 3.02367833089e-16 , 5.27414363977e-17 , 7.36440777612e-17 ,
 1.28029342053e-16 , 2.22810218613e-16 , 4.32479125385e-16 , 1.62026361138e-15 ,
 1.51228284745e-14 , 1.58165323636e-13 , 1.36142857683e-12 , 9.259785929e-12   ,
 4.95797740699e-11 , 2.09129539998e-10 , 6.95808636978e-10 , 1.82836927773e-09 ,
 3.79811474331e-09 , 6.24137238646e-09 , 8.11536161361e-09 , 8.34869836147e-09 ,
 6.79502579843e-09 , 4.38390369279e-09 , 2.28674983597e-09 , 1.14426489109e-09 ,
 1.11704462469e-09 , 2.3616289097e-09  , 5.0963066108e-09  , 9.00021571727e-09 ,
 1.30569352491e-08 , 2.17350560158e-08 , 1.03056500583e-07 , 8.25615202208e-07 ,
 5.78484694219e-06 , 3.22860361483e-05 , 0.000142558679105 , 0.000497944015814 ,
 0.00137588063162  , 0.00300686794565  , 0.00519897568211  , 0.00713716976624  ,
 0.00791108351284  , 0.00754056930604  , 0.00732008935534  , 0.0087855500236   ,
 0.012157201036    , 0.0158015780859   , 0.0173709123961   , 0.0156819368259   ,
 0.0115920290611   , 0.00718651270731  , 0.00441516710078  , 0.00458631846974  ,
 0.00861139734088  , 0.0168219298104   , 0.0282126217724   , 0.0406004377535   ,
 0.0521119154618   , 0.0615615929802   , 0.0666641501946   , 0.063870017027    ,
 0.0521164415902   , 0.0355718647945   , 0.0208857894527   , 0.0126621769267   ,
 0.0126232377444   , 0.0215037741999   , 0.0394818080009   , 0.0644918671715   ,
 0.0915957263133   , 0.115847100805    , 0.137261531573    , 0.163100057641    ,
 0.202370513309    , 0.254045260712    , 0.301346013269    , 0.322975754865    ,
 0.311603995023    , 0.27752377399     , 0.235031984377    , 0.191563786444    ,
 0.14930900421     , 0.109705626057    , 0.0743793349514   , 0.0451447650533   ,
 0.0238129708381   , 0.0108448527145   , 0.00454605231064  , 0.0021241743843   ,
 0.0012976260434   , 0.000984237203268 , 0.0011086884807   , 0.00218268538028  ,
 0.00482982110069  , 0.00901607025223  , 0.0133252746877   , 0.0154405068596   ,
 0.014018311343    , 0.00998133317831  , 0.00558097047813  , 0.00245408021539  ,
 0.000849910138395 , 0.000232158872727 , 5.0081394452e-05  , 8.54056773509e-06 ,
 1.15231663439e-06 , 1.23180887009e-07 , 1.04997618444e-08 , 7.37958318143e-10 ,
 4.97924654169e-11 , 5.21864842086e-12 , 3.09521007641e-12 , 9.14098245838e-12 ,
 2.84636794998e-11 , 7.40830229718e-11 , 1.60119994561e-10 , 2.8893152309e-10  ,
 4.35136244894e-10 , 5.42747013393e-10 , 5.53790053323e-10 , 4.56213000292e-10 ,
 3.00578392043e-10 , 1.73059464924e-10 , 4.49898314147e-10 , 6.89731405459e-09 ,
 9.55940667105e-08 , 1.03681408424e-06 , 8.77947535887e-06 , 5.80733448713e-05 ,
 0.000300297670321 , 0.00121503499937  , 0.00385085445268  , 0.0095720851426   ,
 0.0186882812214   , 0.0287053452545   , 0.0347534685981   , 0.0332364233994   ,
 0.0251756103829   , 0.0151661537218   , 0.00735196529566  , 0.00312360398303  ,
 0.00207473539877  , 0.00397614564914  , 0.00945132366432  , 0.0187431487583   ,
 0.0297724962036   , 0.0381166449798   , 0.0401488427661   , 0.0364343012898   ,
 0.0314332109245   , 0.029752477961    , 0.0324965684165   , 0.0365298623538   ,
 0.0372701350733   , 0.0327445749601   , 0.0248444398666   , 0.016816158151    ,
 0.0105234262342   , 0.00620136069471  , 0.0036108898032   , 0.00267833725007  ,
 0.00333341848477  , 0.00509188364929  , 0.00687533612345  , 0.00746776839235  ,
 0.00640703129133  , 0.00433303055511  , 0.00231729402126  , 0.000988303625825 ,
 0.000341737168948 , 9.84530348076e-05 , 2.44716069278e-05 , 1.33964562238e-06 ,
 2.37227581787e-07 , 4.07112827003e-08 , 7.1194937941e-09  , 1.29109159507e-09 ,
 2.31252192351e-10 , 3.75063872936e-11 , 5.13324834745e-12 , 5.70256533207e-13 ,
 5.10189238404e-14 , 4.65198716973e-15 , 2.34874244294e-15 , 3.92611289641e-15 ,
 6.7445085372e-15  , 1.15178817735e-14 , 2.02467183669e-14 , 4.55667580498e-14 ,
 2.44753003101e-13 , 2.24437562023e-12 , 1.89528127087e-11 , 1.28491153827e-10 ,
 6.87456821929e-10 , 2.89903611137e-09 , 9.64489642117e-09 , 2.53441382529e-08 ,
 5.26527264898e-08 , 8.65407925736e-08 , 1.12570237936e-07 , 1.15898163333e-07 ,
 9.44796663622e-08 , 6.11683274251e-08 , 3.21938994577e-08 , 1.64761999336e-08 ,
 1.62921308041e-08 , 3.38164700295e-08 , 7.20081078566e-08 , 1.26029316434e-07 ,
 1.76214495097e-07 , 2.08758239776e-07 , 3.58696084042e-07 , 1.84616753479e-06 ,
 1.23198808289e-05 , 6.84888471183e-05 , 0.000302296230375 , 0.0010558034043   ,
 0.00291716843066  , 0.00637470819416  , 0.0110190162783   , 0.0151094433464   ,
 0.0166678469338   , 0.0156002284535   , 0.0143686848785   , 0.0158368455726   ,
 0.0202431255797   , 0.0245374017467   , 0.0250096167369   , 0.020641623099    ,
 0.0137621246632   , 0.00781511559302  , 0.00532507679823  , 0.00805451368106  ,
 0.0178161445434   , 0.0353558722364   , 0.0577727371507   , 0.0784724395355   ,
 0.0914646216593   , 0.0951314394968   , 0.0907070000304   , 0.0791647214249   ,
 0.0619922005145   , 0.0432036357686   , 0.0277606175293   , 0.0185355884728   ,
 0.0161469072233   , 0.0208407737284   , 0.03318430237     , 0.053083564596    ,
 0.0789490980177   , 0.108544757785    , 0.141525692606    , 0.180841309298    ,
 0.228555620121    , 0.277864216858    , 0.312432078049    , 0.31871498082     ,
 0.298119628032    , 0.26303416563     , 0.223066869519    , 0.180520459584    ,
 0.13671538431     , 0.0956224917306   , 0.0612276775429   , 0.0354339882141   ,
 0.0184748163849   , 0.0092577943134   , 0.00542831296109  , 0.00420169609471  ,
 0.00355977863171  , 0.00285425114848  , 0.00262912859871  , 0.0040962244628   ,
 0.00842156280282  , 0.0155124336079   , 0.0228772802754   , 0.0265002728919   ,
 0.0240590422202   , 0.0171313956148   , 0.00957957915893  , 0.00421275778044  ,
 0.00145915368601  , 0.000398638706874 , 8.60179685271e-05 , 1.46813113477e-05 ,
 1.98828170319e-06 , 2.16547720591e-07 , 2.02128559344e-08 , 2.03518180199e-09 ,
 3.09478647604e-10 , 7.44532887822e-11 , 5.90119777494e-11 , 1.69232675461e-10 ,
 5.21514086052e-10 , 1.35150461096e-09 , 2.90897820974e-09 , 5.22592992518e-09 ,
 7.83679868314e-09 , 9.73928187721e-09 , 9.90960933553e-09 , 8.14707363079e-09 ,
 5.35093492391e-09 , 2.79538666162e-09 , 1.42138859172e-09 , 5.36208116233e-09 ,
 6.94445002787e-08 , 7.52035945385e-07 , 6.36785497677e-06 , 4.2125744185e-05  ,
 0.000217880109215 , 0.00088191776602  , 0.00279713305983  , 0.00696217929106  ,
 0.0136266662039   , 0.0210283532231   , 0.0256824036167   , 0.0249668398065   ,
 0.0194952499875   , 0.0124094816236   , 0.00661342551111  , 0.00321095146981  ,
 0.00216444689615  , 0.00366858572017  , 0.00868363102172  , 0.0179945118095   ,
 0.0303397835366   , 0.0417219272451   , 0.0476411802798   , 0.0465433358233   ,
 0.0408734464129   , 0.0349595543583   , 0.03201610841     , 0.0324375831267   ,
 0.0342369423259   , 0.0348923680283   , 0.0327670311941   , 0.0274884934335   ,
 0.0200247426101   , 0.0123753019303   , 0.00646651148477  , 0.00310320013304  ,
 0.00193367081923  , 0.0020696055277   , 0.00258060082542  , 0.00276260678106  ,
 0.00235858630965  , 0.00158555840277  , 0.000838433722404 , 0.000349820860064 ,
 0.000116066521394 , 3.1111186401e-05  , 6.93021169788e-06 , 6.14222090891e-07 ,
 2.29777172017e-07 , 9.25003455303e-08 , 3.27153785918e-08 , 9.42669968023e-09 ,
 2.16575233325e-09 , 3.94054147247e-10 , 5.66241359545e-11 , 6.4321577357e-12  ,
 6.01375514364e-13 , 8.71686006436e-14 , 8.72761860101e-14 , 1.52068059958e-13 ,
 2.59825634076e-13 , 4.41205796412e-13 , 7.54010795412e-13 , 1.35851847099e-12 ,
 3.95187013554e-12 , 2.61476927618e-11 , 2.07691423356e-10 , 1.39346199162e-09 ,
 7.43802366526e-09 , 3.13446945975e-08 , 1.04258146647e-07 , 2.73955755469e-07 ,
 5.69220907356e-07 , 9.35889215676e-07 , 1.21820052148e-06 , 1.25586927275e-06 ,
 1.02649818352e-06 , 6.68438063936e-07 , 3.56946700212e-07 , 1.89091001729e-07 ,
 1.90311108819e-07 , 3.84074211413e-07 , 8.01287915667e-07 , 1.38787122989e-06 ,
 1.92129578714e-06 , 2.12712205476e-06 , 2.13326808798e-06 , 4.14613386912e-06 ,
 2.12807207364e-05 , 0.000115342834091 , 0.00050780910818  , 0.00177259827929  ,
 0.0048963839727   , 0.0106979787136   , 0.0184877432459   , 0.0253299382267   ,
 0.0278478785161   , 0.0257382743085   , 0.0228968334345   , 0.0239482097294   ,
 0.0294533252662   , 0.034947988349    , 0.0350438265164   , 0.0284222116511   ,
 0.0186070706812   , 0.0105652609686   , 0.0079372107045   , 0.0136208565106   ,
 0.0309145634879   , 0.0610805809612   , 0.0984451218705   , 0.130263271647    ,
 0.145054423636    , 0.141107071601    , 0.125063193383    , 0.104182840299    ,
 0.082772083828    , 0.0636886326346   , 0.0491495117847   , 0.0401763369386   ,
 0.0373177771032   , 0.0418266998817   , 0.0553216354085   , 0.0786376107288   ,
 0.111111767347    , 0.150611237079    , 0.195042435806    , 0.244003092073    ,
 0.29579360961     , 0.341090416295    , 0.364688993841    , 0.35857190261     ,
 0.330076096913    , 0.292662044252    , 0.252250736675    , 0.20747354426     ,
 0.159008182116    , 0.112180226737    , 0.0723992742143   , 0.0425114170264   ,
 0.0233019482014   , 0.0136659048347   , 0.0105105840722   , 0.00989300072056  ,
 0.00893785583743  , 0.00701864343067  , 0.00547608065416  , 0.00648883142171  ,
 0.01181868328     , 0.0212383946009   , 0.0311947103108   , 0.0361146670011   ,
 0.0327899943239   , 0.0233538383616   , 0.0130633951693   , 0.00574724497588  ,
 0.00199173004018  , 0.0005445908737   , 0.000117746539646 , 2.02524602536e-05 ,
 2.84430962992e-06 , 3.65191897221e-07 , 5.80640842624e-08 , 1.36128060173e-08 ,
 3.68588995542e-09 , 1.13314068464e-09 , 9.20110984391e-10 , 2.47387307254e-09 ,
 7.50421380746e-09 , 1.93379940694e-08 , 4.14121906474e-08 , 7.39940407674e-08 ,
 1.10378516165e-07 , 1.36553501433e-07 , 1.38454398208e-07 , 1.13543823929e-07 ,
 7.44440065056e-08 , 3.86894861824e-08 , 1.60244381799e-08 , 8.09923167987e-09 ,
 4.14465788564e-08 , 4.3145127065e-07  , 3.6440296857e-06  , 2.41120991899e-05 ,
 0.000124875513077 , 0.000506764531483 , 0.00161485723557  , 0.00405404024919  ,
 0.00805980902865  , 0.0127961542407   , 0.0164417986013   , 0.0174430028693   ,
 0.0156805468362   , 0.0122537132061   , 0.00845895482716  , 0.00527179999131  ,
 0.00352026306067  , 0.00425005257948  , 0.00886955572255  , 0.0184832497557   ,
 0.0322710056211   , 0.0465046440283   , 0.0561166633248   , 0.0578936234569   ,
 0.0523803707466   , 0.0434817202652   , 0.0367080800404   , 0.0366991132685   ,
 0.0445881855483   , 0.0564682028495   , 0.0646757838884   , 0.0626006430358   ,
 0.0498264296116   , 0.0322529797513   , 0.0169209985763   , 0.00725775161755  ,
 0.00272221167447  , 0.0011931458446   , 0.000883099334844 , 0.000830046691554 ,
 0.000691874799936 , 0.000462279008799 , 0.000243195985801 , 0.000100649582925 ,
 3.30336701466e-05 , 8.87146571137e-06 , 2.1699508181e-06  , 2.89321596967e-06 ,
 1.6792526609e-06  , 7.80608770619e-07 , 2.87837372194e-07 , 8.39996527617e-08 ,
 1.93812296735e-08 , 3.53225523485e-09 , 5.08462175664e-10 , 5.84315528544e-11 ,
 6.2029662073e-12  , 1.88731309111e-12 , 2.64966995806e-12 , 4.61976882129e-12 ,
 7.84154799652e-12 , 1.32513713998e-11 , 2.24120045938e-11 , 3.73555978776e-11 ,
 7.21198392996e-11 , 2.75396572724e-10 , 1.83000228048e-09 , 1.18717651395e-08 ,
 6.29126704454e-08 , 2.64576685853e-07 , 8.79428436288e-07 , 2.31047930116e-06 ,
 4.80148570238e-06 , 7.89860798312e-06 , 1.02927400692e-05 , 1.06345013498e-05 ,
 8.73084695746e-06 , 5.73994508623e-06 , 3.13685159124e-06 , 1.74872869121e-06 ,
 1.80089635647e-06 , 3.48936427015e-06 , 7.05910292812e-06 , 1.20373128625e-05 ,
 1.65286632324e-05 , 1.80561868169e-05 , 1.59653329699e-05 , 1.45416997263e-05 ,
 3.36208977577e-05 , 0.000157239608924 , 0.000680826993524 , 0.00236768718244  ,
 0.00652878205662  , 0.0142511368589   , 0.0246169614877   , 0.0337142641003   ,
 0.0369987632528   , 0.0339140687867   , 0.0294147048139   , 0.029560000377    ,
 0.0354321275542   , 0.041854661976    , 0.0423149729924   , 0.0349841983453   ,
 0.0237732103414   , 0.0145134442062   , 0.0118908345245   , 0.0202298971493   ,
 0.044572585402    , 0.0868573922303   , 0.138892321229    , 0.18220062218     ,
 0.200212819749    , 0.191344355189    , 0.167676983394    , 0.142520691677    ,
 0.122380429858    , 0.108152232146    , 0.0988179260967   , 0.0939494406694   ,
 0.0955756247873   , 0.107832688968    , 0.133972414624    , 0.174396146587    ,
 0.226818248021    , 0.286034664003    , 0.344915427611    , 0.398735861753    ,
 0.446059990907    , 0.482181907549    , 0.497062069538    , 0.485443147874    ,
 0.454004552146    , 0.412654892878    , 0.363698796896    , 0.305264233218    ,
 0.240270595175    , 0.176083079263    , 0.119092703405    , 0.0736606961715   ,
 0.0429052441919   , 0.027010529214    , 0.0218104931117   , 0.0207129346573   ,
 0.018574105252    , 0.0142254445131   , 0.00993229038259  , 0.00901975179924  ,
 0.0137378394114   , 0.0236208238837   , 0.0344322341838   , 0.0398281354841   ,
 0.0361801628258   , 0.0257950437671   , 0.0144496170499   , 0.0063690972374   ,
 0.002213133318    , 0.000608246528469 , 0.000133648087308 , 2.46081070763e-05 ,
 4.54191287442e-06 , 1.15911347029e-06 , 3.97137416519e-07 , 1.35296806362e-07 ,
 4.21340216169e-08 , 1.46052167938e-08 , 1.17171528545e-08 , 2.86788421248e-08 ,
 8.49610448267e-08 , 2.17328500187e-07 , 4.62553720152e-07 , 8.21082447363e-07 ,
 1.21698005036e-06 , 1.49717292746e-06 , 1.51139199175e-06 , 1.23558009036e-06 ,
 8.08382828701e-07 , 4.19501739889e-07 , 1.72091222683e-07 , 5.86872268711e-08 ,
 3.95599673031e-08 , 2.17306564953e-07 , 1.69370101697e-06 , 1.10662772875e-05 ,
 5.76086775073e-05 , 0.000237464918006 , 0.000778939520668 , 0.00205680866193  ,
 0.00445152639182  , 0.00808715116615  , 0.012634466327    , 0.0172177209051   ,
 0.0203972202926   , 0.0206340977559   , 0.0174543139753   , 0.0122415283403   ,
 0.00755519367482  , 0.00579502765064  , 0.00865378812256  , 0.0170219056016   ,
 0.0302176055275   , 0.0451715828101   , 0.0572233943862   , 0.0623825954143   ,
 0.0594993979965   , 0.0516908855054   , 0.0464659982208   , 0.0529555924995   ,
 0.0757388112631   , 0.108449709728    , 0.134079160958    , 0.136010842135    ,
 0.111590949597    , 0.0737687156166   , 0.0392526891862   , 0.0168167526103   ,
 0.00583575896503  , 0.001710778895    , 0.000520400122593 , 0.000247522082333 ,
 0.000167817710513 , 0.00010804418494  , 5.72097092711e-05 , 2.52297414599e-05 ,
 1.07678208074e-05 , 5.89177685711e-06 , 4.17067914493e-06 , 2.00616041468e-05 ,
 1.18320560345e-05 , 5.51973055282e-06 , 2.03700483947e-06 , 5.94594953582e-07 ,
 1.3720999463e-07  , 2.50215200678e-08 , 3.61955580431e-09 , 4.35141400446e-10 ,
 6.63664380163e-11 , 4.18224169466e-11 , 6.43256195143e-11 , 1.10426712753e-10 ,
 1.85822817132e-10 , 3.12323870777e-10 , 5.25287396785e-10 , 8.5359930169e-10  ,
 1.37988300613e-09 , 3.07200717215e-09 , 1.3777739285e-08  , 8.06720403841e-08 ,
 4.17991922575e-07 , 1.74711692163e-06 , 5.79553984079e-06 , 1.52171839114e-05 ,
 3.16278755187e-05 , 5.20725031868e-05 , 6.79825433131e-05 , 7.05010050634e-05 ,
 5.83105526213e-05 , 3.89386244998e-05 , 2.2059421024e-05  , 1.32079629815e-05 ,
 1.397974876e-05   , 2.56353074591e-05 , 4.96109869329e-05 , 8.26350337152e-05 ,
 0.000112189417433 , 0.000121850130137 , 0.000105567986685 , 7.68394797422e-05 ,
 7.26468041382e-05 , 0.000194788903989 , 0.000763851804081 , 0.00259274616972  ,
 0.00706764675696  , 0.015328520333    , 0.0263977961549   , 0.0361461292919   ,
 0.0397537627041   , 0.036534584122    , 0.0316056700459   , 0.0314674382739   ,
 0.0377352676179   , 0.045516218964    , 0.0480098661999   , 0.0425778887994   ,
 0.0323402668459   , 0.0229944906623   , 0.0199683106832   , 0.0289277523848   ,
 0.0563435521213   , 0.1049587285      , 0.165892753257    , 0.218288891695    ,
 0.242940290684    , 0.237693110738    , 0.216970047368    , 0.197454065185    ,
 0.187251624992    , 0.186109552067    , 0.190680207378    , 0.199950508841    ,
 0.218795677314    , 0.255250379044    , 0.313031442659    , 0.389153006383    ,
 0.477424949135    , 0.568048962899    , 0.645952467396    , 0.699423737551    ,
 0.730281123201    , 0.747666498553    , 0.754501250603    , 0.74700228407     ,
 0.72169596125     , 0.675040510292    , 0.602530893571    , 0.506442453908    ,
 0.399749189337    , 0.297052740358    , 0.206570193252    , 0.133050577127    ,
 0.081240327316    , 0.0524929696694   , 0.0412045253948   , 0.03726472161     ,
 0.0323226275174   , 0.0241348943172   , 0.0157808289416   , 0.0116914379819   ,
 0.0144196065856   , 0.0231559160526   , 0.0333258241943   , 0.0385124144932   ,
 0.035062482437    , 0.0250962861946   , 0.0141361949536   , 0.00627952618335  ,
 0.00221045617807  , 0.000627329958901 , 0.000154356566151 , 4.15976217527e-05 ,
 1.60511902837e-05 , 7.49266829245e-06 , 3.21601012953e-06 , 1.17947693928e-06 ,
 3.98179149585e-07 , 1.56850344144e-07 , 1.22971821563e-07 , 2.65195914776e-07 ,
 7.58520178919e-07 , 1.92136402639e-06 , 4.05933228835e-06 , 7.14977911309e-06 ,
 1.05154000168e-05 , 1.28483650731e-05 , 1.29005773741e-05 , 1.05052498895e-05 ,
 6.85492039527e-06 , 3.55138441841e-06 , 1.45605474283e-06 , 4.91522865927e-07 ,
 2.09035991744e-07 , 3.14136442512e-07 , 1.06496406418e-06 , 4.95888024378e-06 ,
 2.43960275779e-05 , 0.000106993456003 , 0.000399965598614 , 0.00127882152874  ,
 0.00352624482835  , 0.00836241666037  , 0.0168143928275   , 0.0281385249629   ,
 0.0385563700308   , 0.0427588071075   , 0.0381139571476   , 0.0272775319517   ,
 0.0160162683004   , 0.00900072761085  , 0.00808379199196  , 0.013235885415    ,
 0.0233958791517   , 0.0363229282778   , 0.0486350403712   , 0.0567288497957   ,
 0.0585857394238   , 0.0565132312674   , 0.0593195901137   , 0.0801497603079   ,
 0.12712528428     , 0.190769402096    , 0.24182028547     , 0.249665784111    ,
 0.207895649473    , 0.139287855076    , 0.0750317456377   , 0.0324736646149   ,
 0.011284178046    , 0.00315536105359  , 0.00072669695246  , 0.000157196667521 ,
 4.73371607892e-05 , 2.46069617847e-05 , 1.83556646614e-05 , 1.96906643625e-05 ,
 2.49772419405e-05 , 2.87120804881e-05 , 2.69165150374e-05 , 0.000112142640559 ,
 6.61677902642e-05 , 3.08710069505e-05 , 1.13932556124e-05 , 3.32591437586e-06 ,
 7.67747626146e-07 , 1.40340093587e-07 , 2.07131968969e-08 , 2.92752825779e-09 ,
 8.66882586519e-10 , 8.18893491003e-10 , 1.24284741202e-09 , 2.08302876479e-09 ,
 3.46608263808e-09 , 5.78677956416e-09 , 9.68581851692e-09 , 1.55920327351e-08 ,
 2.37040193908e-08 , 3.85852815317e-08 , 1.01108231206e-07 , 4.56529625103e-07 ,
 2.21043036242e-06 , 9.07216453876e-06 , 2.9917446971e-05  , 7.8401140539e-05  ,
 0.000162928881328 , 0.000268584161972 , 0.000351726763301 , 0.000367030524006 ,
 0.000307312792185 , 0.000210430287    , 0.000125791053724 , 8.26006543326e-05 ,
 8.99982563571e-05 , 0.000154174185691 , 0.000281000803504 , 0.000452427256301 ,
 0.00060412465753  , 0.000652195272358 , 0.000564474140552 , 0.00039860998712  ,
 0.000269205797511 , 0.000331994133325 , 0.000907059397889 , 0.00272517130359  ,
 0.00697622451431  , 0.0145718101162   , 0.0245823548514   , 0.0334639453425   ,
 0.0371815828869   , 0.0352310347739   , 0.0321392301289   , 0.0339826111659   ,
 0.042931361106    , 0.055005739664    , 0.0632290573949   , 0.0632462817971   ,
 0.0561703630817   , 0.0470193888722   , 0.0420799806472   , 0.0482031005144   ,
 0.0725258435812   , 0.118700268277    , 0.180140642553    , 0.238780969989    ,
 0.275855813759    , 0.286164143657    , 0.280526566955    , 0.275244029237    ,
 0.281285884238    , 0.301265111223    , 0.332706423683    , 0.375383067102    ,
 0.437243836051    , 0.528522600418    , 0.648300166282    , 0.78406492767     ,
 0.92396446535     , 1.05686051952     , 1.16220040683     , 1.22009075032     ,
 1.23539904189     , 1.23552073641     , 1.24088628409     , 1.24681868551     ,
 1.22983760742     , 1.16266228271     , 1.03159992757     , 0.851202861941    ,
 0.657799024213    , 0.483091284864    , 0.338944650879    , 0.226230202351    ,
 0.145949913701    , 0.0975938164912   , 0.0737869223555   , 0.0617458815556   ,
 0.050452942708    , 0.0364130321542   , 0.0230330317843   , 0.0155072453832   ,
 0.0165677719024   , 0.0249379935772   , 0.0353668934221   , 0.0408621160355   ,
 0.0374075222244   , 0.0270378298186   , 0.0154549020542   , 0.00702755940908  ,
 0.00259579796055  , 0.000844514961619 , 0.000305530446411 , 0.000154212701045 ,
 9.09237168059e-05 , 4.86154800286e-05 , 2.17028723954e-05 , 8.30680734014e-06 ,
 3.10072296565e-06 , 1.40702353272e-06 , 1.07097795623e-06 , 1.97071120976e-06 ,
 5.3540205605e-06  , 1.33846861023e-05 , 2.80321787767e-05 , 4.89247099221e-05 ,
 7.12965587195e-05 , 8.64000363122e-05 , 8.61808875184e-05 , 6.98415368516e-05 ,
 4.5423479099e-05  , 2.34845008834e-05 , 9.62686102236e-06 , 3.29164765288e-06 ,
 1.50576934239e-06 , 2.05535116348e-06 , 4.04741811773e-06 , 7.88553506937e-06 ,
 2.0005501463e-05  , 7.85644535378e-05 , 0.000350021618968 , 0.00139856988315  ,
 0.00466597835522  , 0.0127071346865   , 0.0279507471582   , 0.0493544061046   ,
 0.0697063923927   , 0.0785833432086   , 0.070640111954    , 0.0506543768039   ,
 0.0291933190899   , 0.014300976731    , 0.00807624111563  , 0.00899875307811  ,
 0.0149609225431   , 0.0241697555249   , 0.0347400840479   , 0.0444235210775   ,
 0.0515562789216   , 0.0580418575738   , 0.0731038341369   , 0.112651590827    ,
 0.187913819737    , 0.286478246806    , 0.366356755671    , 0.381459299252    ,
 0.320488316248    , 0.216698124447    , 0.117788688186    , 0.0514131386253   ,
 0.0179926129246   , 0.00503967671904  , 0.00112980935742  , 0.000206292770587 ,
 3.80999446329e-05 , 2.39726843938e-05 , 4.63441061314e-05 , 8.72254709804e-05 ,
 0.00013234245669  , 0.000158728113026 , 0.000150170430763 , 0.000495982053967 ,
 0.000292665122803 , 0.000136555961626 , 5.040361847e-05   , 1.47180191652e-05 ,
 3.40204116385e-06 , 6.28003683484e-07 , 1.0020106847e-07  , 2.1891165855e-08  ,
 1.25351992456e-08 , 1.32486090668e-08 , 1.91459162117e-08 , 3.11190500667e-08 ,
 5.10328272102e-08 , 8.44800806915e-08 , 1.40641745659e-07 , 2.25258247522e-07 ,
 3.35365363989e-07 , 4.80933836437e-07 , 8.2656506489e-07  , 2.38344276065e-06 ,
 9.64379724263e-06 , 3.75431775568e-05 , 0.000121723175992 , 0.000317129320233 ,
 0.000658207278726 , 0.00108686561029  , 0.00143046173739  , 0.00150819394492  ,
 0.00128836838925  , 0.000917315501847 , 0.000591186443986 , 0.000432231158646 ,
 0.000483413435952 , 0.000767673759117 , 0.00129868967828  , 0.0019965193023   ,
 0.00260438605923  , 0.00279064663319  , 0.0024269892753   , 0.00173713323409  ,
 0.00113724085408  , 0.00102443110217  , 0.00182615242588  , 0.00422096246488  ,
 0.00908521065476  , 0.0167796886315   , 0.0260989330048   , 0.0341754940783   ,
 0.0383275510476   , 0.0387368607201   , 0.0393999683449   , 0.0459909981497   ,
 0.0616319730181   , 0.0834962235224   , 0.103658206337    , 0.114437187978    ,
 0.113726330932    , 0.10588070851     , 0.0986377359291   , 0.0998469088163   ,
 0.116283257549    , 0.152668912239    , 0.208079594834    , 0.272355520697    ,
 0.329075181842    , 0.365643934297    , 0.382296629754    , 0.392298906977    ,
 0.413749814905    , 0.459530928523    , 0.533617947345    , 0.638508011806    ,
 0.783788615199    , 0.97673898909     , 1.20280675571     , 1.43114905255     ,
 1.64324938104     , 1.83595489269     , 1.99500543794     , 2.09617800897     ,
 2.14096012164     , 2.16341799684     , 2.19029311476     , 2.20793194324     ,
 2.16914494202     , 2.02485865535     , 1.76054891427     , 1.41641148518     ,
 1.06644487934     , 0.769511289436    , 0.543027019116    , 0.377721332682    ,
 0.26114428874     , 0.184090656996    , 0.136369521559    , 0.105196225502    ,
 0.079406311       , 0.0547587945639   , 0.0342297696725   , 0.023167832503    ,
 0.0244174206855   , 0.0359511452952   , 0.0504701156794   , 0.0582624978043   ,
 0.0536363334843   , 0.0392319923427   , 0.0229071701374   , 0.0108679700678   ,
 0.00445741651127  , 0.00189280592578  , 0.00105563237851  , 0.000720282794039 ,
 0.000467998599938 , 0.000256393402817 , 0.000116856337928 , 4.73774940575e-05 ,
 2.01237799881e-05 , 1.05186321233e-05 , 7.75554036366e-06 , 1.18756720799e-05 ,
 2.99725534635e-05 , 7.35951221458e-05 , 0.000152555905356 , 0.000263475517852 ,
 0.000379860313005 , 0.000455849136434 , 0.000451087984479 , 0.000363417152353 ,
 0.000235403374689 , 0.000121398742102 , 4.97596903261e-05 , 1.731680664e-05   ,
 8.88261006131e-06 , 1.33776427978e-05 , 2.56558167713e-05 , 4.18654878361e-05 ,
 6.24992916428e-05 , 0.000128943694194 , 0.000467542100411 , 0.00190130661774  ,
 0.00659896322512  , 0.0184629237693   , 0.0412525292371   , 0.0734807567461   ,
 0.104299383968    , 0.11795920572     , 0.106312054564    , 0.0764097316163   ,
 0.0439612657621   , 0.0207172599707   , 0.00918482267665  , 0.00627386323044  ,
 0.00847365208509  , 0.013895336303    , 0.0218178073804   , 0.0316919681062   ,
 0.0430939722063   , 0.0580549794852   , 0.085585445503    , 0.142728482127    ,
 0.242350332613    , 0.369341705823    , 0.471617880666    , 0.491148125999    ,
 0.41331622284     , 0.280178225718    , 0.152762714092    , 0.0668981472017   ,
 0.0234873341199   , 0.00659645433296  , 0.00147955216294  , 0.000270298867579 ,
 6.30232528013e-05 , 8.42082477599e-05 , 0.000197766611428 , 0.000383088742068 ,
 0.000584439557855 , 0.000701769428725 , 0.000664110508435 , 0.00173617006779  ,
 0.00102466323971  , 0.000478234726756 , 0.000176598747106 , 5.1625170437e-05  ,
 1.1998692468e-05  , 2.30350701527e-06 , 4.74566637087e-07 , 2.04573803766e-07 ,
 1.6549386009e-07  , 1.73683334209e-07 , 2.36266159127e-07 , 3.69935261197e-07 ,
 5.95326701356e-07 , 9.74744015716e-07 , 1.61198629996e-06 , 2.57070834423e-06 ,
 3.79474154364e-06 , 5.19907380242e-06 , 7.23974656742e-06 , 1.3255198373e-05  ,
 3.77873382331e-05 , 0.000128151665237 , 0.000396340424569 , 0.00101542062208  ,
 0.00209718033581  , 0.00346874336458  , 0.00460155728949  , 0.00493399435084  ,
 0.0043510956888   , 0.00328152703583  , 0.00232811315784  , 0.00190012198893  ,
 0.00216577276223  , 0.00318835270136  , 0.00496119861926  , 0.00719857987014  ,
 0.00910812656822  , 0.00967887152704  , 0.00851077826252  , 0.00629015850982  ,
 0.00431845071766  , 0.00377966526532  , 0.00560448760078  , 0.0106866384212   ,
 0.0195719658627   , 0.0314460302302   , 0.043621847886    , 0.052889063967    ,
 0.0579528192677   , 0.0606372510136   , 0.0653831152392   , 0.0781030278061   ,
 0.103538131265    , 0.140598038113    , 0.180132579683    , 0.209872655322    ,
 0.223295187296    , 0.223794511259    , 0.220480242781    , 0.221135919879    ,
 0.230517975915    , 0.254408378547    , 0.300654722869    , 0.371179536777    ,
 0.452755980689    , 0.521340072076    , 0.56170887577     , 0.584039896723    ,
 0.619291254058    , 0.698245336875    , 0.836837824678    , 1.04184043234     ,
 1.32178984968     , 1.67504314879     , 2.06589049852     , 2.4386404949      ,
 2.76771683523     , 3.06860320482     , 3.35075675123     , 3.59400349625     ,
 3.78168515401     , 3.92006910283     , 4.00797630769     , 4.00822275054     ,
 3.86002480219     , 3.51816065644     , 2.99393358588     , 2.37036497081     ,
 1.76631008491     , 1.27110926952     , 0.909705125216    , 0.659622613012    ,
 0.485554543016    , 0.359872484729    , 0.266224807345    , 0.194666956054    ,
 0.137624361652    , 0.0911968246919   , 0.0570002401151   , 0.0395884339763   ,
 0.0415656587718   , 0.0595041213309   , 0.0821402678164   , 0.0943250780279   ,
 0.0870829754927   , 0.0644559505606   , 0.0387180709639   , 0.0196626622984   ,
 0.00949204400548  , 0.00539120405111  , 0.00388103682261  , 0.00292351392781  ,
 0.00194263931495  , 0.00107458224924  , 0.000503689422488 , 0.000221919036771 ,
 0.000109708704965 , 6.50549888699e-05 , 4.65621704473e-05 , 5.86280804461e-05 ,
 0.000133599024171 , 0.000319941231278 , 0.000655240378229 , 0.00111834031171  ,
 0.00159271190466  , 0.00188963767726  , 0.00185229322318  , 0.00148173446837  ,
 0.000955087804235 , 0.000491048389741 , 0.000201301419234 , 7.16835508267e-05 ,
 4.18224324835e-05 , 6.92737602191e-05 , 0.000134030202262 , 0.000214062475872 ,
 0.000280449796572 , 0.000356265819483 , 0.000710952365371 , 0.00235673333619  ,
 0.00793364508396  , 0.0221691715887   , 0.0496331354113   , 0.0886108683206   ,
 0.126120961122    , 0.143179648987    , 0.129766891296    , 0.0940842958053   ,
 0.0549128145328   , 0.0264391585908   , 0.0116041353458   , 0.00631659844091  ,
 0.00595969217225  , 0.00835371874757  , 0.0135177419421   , 0.0223580231847   ,
 0.0358914303603   , 0.0568044898412   , 0.0940175186746   , 0.164367415284    ,
 0.279727138572    , 0.421227675468    , 0.530665930421    , 0.54604493902     ,
 0.454866211242    , 0.305755636079    , 0.165570359439    , 0.0721147296733   ,
 0.0252143598116   , 0.00706136438983  , 0.00158438040776  , 0.000304375475924 ,
 0.00012892173814  , 0.000283723935884 , 0.000690687289846 , 0.00134029757668  ,
 0.0020451491596   , 0.00245593845677  , 0.00232437788423  , 0.00481620588544  ,
 0.00284433141559  , 0.00132881313064  , 0.000491512271196 , 0.000144322301146 ,
 3.42940323172e-05 , 7.59144570362e-06 , 2.72737401756e-06 , 2.01709656803e-06 ,
 1.81542738366e-06 , 1.84015375571e-06 , 2.35106494753e-06 , 3.52204261224e-06 ,
 5.53092316902e-06 , 8.92608754637e-06 , 1.46344378267e-05 , 2.32223217522e-05 ,
 3.41051118913e-05 , 4.58851462093e-05 , 5.86772114707e-05 , 8.11823382957e-05 ,
 0.000151805719998 , 0.000389950402786 , 0.00107168795007  , 0.00262388361819  ,
 0.00533577051929  , 0.0088222740828   , 0.0118407772783   , 0.0130359165395   ,
 0.012059749477    , 0.0098337730898   , 0.00777834431319  , 0.00699996622666  ,
 0.00805302619677  , 0.0110678757822   , 0.0158395430844   , 0.0215426293429   ,
 0.0263049378356   , 0.0277662974636   , 0.0249242235232   , 0.0193636206992   ,
 0.0143265769615   , 0.0129404752729   , 0.0175178634735   , 0.0295680824126   ,
 0.0489458474509   , 0.0722333370322   , 0.0930687544479   , 0.106308588492    ,
 0.112435652843    , 0.116789024753    , 0.125535135554    , 0.144668301285    ,
 0.180465571697    , 0.234973045241    , 0.299851883385    , 0.359148082298    ,
 0.401271341057    , 0.427158211664    , 0.445274204048    , 0.46070894384     ,
 0.473556585247    , 0.489463194594    , 0.526202444182    , 0.600250727509    ,
 0.703529209113    , 0.801946012403    , 0.867331413016    , 0.910747385935    ,
 0.979501833117    , 1.12370020137     , 1.37081875475     , 1.72990644997     ,
 2.20547233442     , 2.78631858289     , 3.41957387635     , 4.02862760366     ,
 4.57965647723     , 5.10646500498     , 5.65066564557     , 6.20190998692     ,
 6.70443547447     , 7.0865329429      , 7.27011873242     , 7.17995559691     ,
 6.76800830387     , 6.04077237744     , 5.07719623217     , 4.02036205979     ,
 3.02953047562     , 2.21760507677     , 1.62007569638     , 1.2074346408      ,
 0.919273702879    , 0.699935499778    , 0.519927640818    , 0.372192232797    ,
 0.255473931241    , 0.166902254341    , 0.105282507673    , 0.0726896063807   ,
 0.0703112815717   , 0.0922847625579   , 0.122217338306    , 0.1384725703      ,
 0.128251742499    , 0.0969805700855   , 0.0614788343828   , 0.035164931821    ,
 0.0210680709406   , 0.0151884887144   , 0.0123808525181   , 0.00962102362416  ,
 0.00642363298492  , 0.00359120058572  , 0.00175851957793  , 0.000867405143893 ,
 0.00050275398746  , 0.000329890436433 , 0.000230405827795 , 0.00023957183682  ,
 0.000476603246344 , 0.00110158160956  , 0.00222397036838  , 0.00374653562835  ,
 0.00526325265669  , 0.00616361507738  , 0.00597551411633  , 0.00474012552416  ,
 0.00303764910585  , 0.00155638416811  , 0.000638551521916 , 0.000234397668649 ,
 0.000157416163492 , 0.000283252420849 , 0.000553035701851 , 0.000880156404475 ,
 0.00111926977481  , 0.0011908442744   , 0.00135901438502  , 0.00270840617717  ,
 0.0079066545196   , 0.0215906012316   , 0.0482565890001   , 0.0864420468135   ,
 0.123847457656    , 0.142092735441    , 0.130921389582    , 0.0974890948939   ,
 0.0597133908204   , 0.0317656609283   , 0.0169196702245   , 0.0110030800101   ,
 0.00899280392483  , 0.00864958306721  , 0.0106185250095   , 0.0169089733934   ,
 0.0297675564467   , 0.0529922963057   , 0.0961249535105   , 0.175068599595    ,
 0.297830410683    , 0.439733467408    , 0.539861767328    , 0.540909153499    ,
 0.439249101966    , 0.288410526344    , 0.152943874592    , 0.0654261920698   ,
 0.022543292375    , 0.00625171454559  , 0.00140975962196  , 0.000317404406438 ,
 0.000286134225723 , 0.000779886153405 , 0.00191414121737  , 0.00371450914537  ,
 0.00566808413756  , 0.00680772358066  , 0.00644498560727  , 0.0106314952413   ,
 0.00629299870619  , 0.00295022601705  , 0.00109810721829  , 0.000328123931793 ,
 8.4783546101e-05  , 2.76622035019e-05 , 1.87654038347e-05 , 1.74937733318e-05 ,
 1.61079643209e-05 , 1.58038890575e-05 , 1.90247043321e-05 , 2.70946140316e-05 ,
 4.12267651606e-05 , 6.5258056849e-05  , 0.000105740238316 , 0.000166669017026 ,
 0.000243614068947 , 0.000324692307314 , 0.000400511247848 , 0.000486044030701 ,
 0.000667203333886 , 0.00119233286411  , 0.00260066461542  , 0.00571658852694  ,
 0.0111409216179   , 0.0182633992287   , 0.0248784688978   , 0.0284592769597   ,
 0.0281193262586   , 0.025186197607    , 0.0221658553122   , 0.0214960140228   ,
 0.0247180498032   , 0.0320561182723   , 0.0425788207389   , 0.0543700422706   ,
 0.0641086145827   , 0.067615857473    , 0.0627660371648   , 0.052124628937    ,
 0.0420368778514   , 0.0394596222455   , 0.0496693716697   , 0.0750361507124   ,
 0.113269735689    , 0.155798243812    , 0.190333222857    , 0.209452984129    ,
 0.217513931108    , 0.226089535277    , 0.243438841797    , 0.273175285191    ,
 0.321071654603    , 0.393840458874    , 0.488254829523    , 0.588221213575    ,
 0.677471825639    , 0.752189914135    , 0.817384496845    , 0.873464932985    ,
 0.913724208288    , 0.939734657524    , 0.974167429083    , 1.045567535       ,
 1.15535974294     , 1.27193027062     , 1.37007103068     , 1.47199368496     ,
 1.64043412513     , 1.9353869149      , 2.3843050814      , 2.98904292288     ,
 3.74691144306     , 4.6473473799      , 5.64430786241     , 6.66061080888     ,
 7.64930465953     , 8.6365264733      , 9.67512735905     , 10.7550436444     ,
 11.7583824203     , 12.4878238929     , 12.7459849341     , 12.4181667128     ,
 11.5106969711     , 10.1400821199     , 8.49780147381     , 6.80068026895     ,
 5.23579591432     , 3.92545287263     , 2.9195743066      , 2.1978194672      ,
 1.68377861        , 1.28846377556     , 0.958869940161    , 0.684854360794    ,
 0.46974325478     , 0.31021545145     , 0.199859875099    , 0.1357974189      ,
 0.115786315867    , 0.130413044479    , 0.15871793329     , 0.174606336392    ,
 0.16282951964     , 0.128812744926    , 0.0903863291941   , 0.061653122612    ,
 0.0457602182941   , 0.0381668723278   , 0.0326112186971   , 0.0254366236085   ,
 0.0169796457916   , 0.00966171780316  , 0.00505577606876  , 0.00286696905165  ,
 0.00192586477283  , 0.00136125333087  , 0.00093385782058  , 0.000817457234061 ,
 0.00137048102571  , 0.00300954884548  , 0.00597127655937  , 0.00991782838548  ,
 0.0137271699145   , 0.0158438402891   , 0.015168858941    , 0.0119175405206   ,
 0.00758761819298  , 0.00387469942365  , 0.00159434490018  , 0.000610012576257 ,
 0.000475924037421 , 0.000917466882076 , 0.00180407016783  , 0.00287055591711  ,
 0.00362701578342  , 0.00368485552796  , 0.00327032038693  , 0.00358810906371  ,
 0.00710501540341  , 0.017628811989    , 0.0387968128486   , 0.0698386968164   ,
 0.101703064801    , 0.120040863237    , 0.115649227263    , 0.0924114162969   ,
 0.0637477529407   , 0.0417048283657   , 0.0298170842922   , 0.024444832955    ,
 0.020609887873    , 0.0164313558226   , 0.0135960601634   , 0.0152657863908   ,
 0.0246261421161   , 0.0465361574861   , 0.0913635969225   , 0.173533391668    ,
 0.295671638679    , 0.427007233165    , 0.507337431264    , 0.48981776772     ,
 0.382780034817    , 0.241993616302    , 0.123821186743    , 0.0513152067115   ,
 0.0172657730673   , 0.00476949727377  , 0.00114934560594  , 0.000388590193334 ,
 0.000607375414535 , 0.00172496327011  , 0.00421815879418  , 0.00817583639547  ,
 0.012474834384    , 0.0149903018141   , 0.0142052833672   , 0.0189563172506   ,
 0.0113086690879   , 0.0053675214246   , 0.00204438208947  , 0.000651474042837 ,
 0.000216701498878 , 0.000128047940655 , 0.000124825920728 , 0.00012446942755  ,
 0.000115194633733 , 0.000110623035905 , 0.000126470521854 , 0.000170454125948 ,
 0.000249198307463 , 0.00038420561463  , 0.000612225959144 , 0.000955459640454 ,
 0.00138800077909  , 0.00183727196864  , 0.00222482586122  , 0.00254059499114  ,
 0.00295158741687  , 0.00392166587194  , 0.00632314937431  , 0.0114116878602   ,
 0.0201962951594   , 0.0320939428533   , 0.0442651455773   , 0.0531156791013   ,
 0.0567471286241   , 0.0559710876731   , 0.0538877070154   , 0.0548914846132   ,
 0.0625762490127   , 0.0774112023322   , 0.0968780381035   , 0.117455775253    ,
 0.134910176063    , 0.143684588851    , 0.139666055596    , 0.125084675189    ,
 0.109686955796    , 0.106670207871    , 0.1267022736      , 0.172827197868    ,
 0.23751863575     , 0.30371737363     , 0.352808953251    , 0.37829477193     ,
 0.392859737242    , 0.416646360481    , 0.45827140312     , 0.51433979964     ,
 0.586363013625    , 0.685823368237    , 0.818023491831    , 0.970269272562    ,
 1.12253755479     , 1.26515419652     , 1.40028069582     , 1.52751164358     ,
 1.63526002286     , 1.71384172004     , 1.77544244328     , 1.84873671484     ,
 1.94960356059     , 2.07304181786     , 2.226569043       , 2.46030440516     ,
 2.84917677449     , 3.44724871499     , 4.26291723191     , 5.2740327197      ,
 6.46538401418     , 7.8466171202      , 9.42158537766     , 11.1483218213     ,
 12.9568331412     , 14.8083058959     , 16.702175116      , 18.5861500303     ,
 20.2480635348     , 21.330163034      , 21.5006834867     , 20.6367775682     ,
 18.8659484739     , 16.4806606506     , 13.8235161875     , 11.1912403159     ,
 8.78315310922     , 6.71436560385     , 5.05042212786     , 3.79933082018     ,
 2.88749364138     , 2.19518446318     , 1.6340182171      , 1.17611796532     ,
 0.819397380954    , 0.554969769016    , 0.368610117375    , 0.250581865982    ,
 0.193357957866    , 0.182941586278    , 0.195122000407    , 0.202857356555    ,
 0.190913529948    , 0.162743334864    , 0.131575543747    , 0.107310365023    ,
 0.0919218606287   , 0.0815241572628   , 0.0700758015543   , 0.0542139406817   ,
 0.0362103646192   , 0.0212441686121   , 0.012211601751    , 0.0080673679401   ,
 0.00611636200827  , 0.00454966463063  , 0.00308591133695  , 0.00234276609386  ,
 0.00320881376596  , 0.00654003579855  , 0.0126929750981   , 0.0207641322422   ,
 0.028291107461    , 0.0321467157878   , 0.030358061385    , 0.0236052678662   ,
 0.0149356722228   , 0.00761855987037  , 0.00316462461818  , 0.00128565369835  ,
 0.00116750581941  , 0.00237010423678  , 0.00468147623534  , 0.00745277735789  ,
 0.0094119454917   , 0.00948173041727  , 0.00788459838042  , 0.00635778036323  ,
 0.00750413649931  , 0.0141802388511   , 0.028750376284    , 0.0511364536097   ,
 0.0764839628319   , 0.0958332589019   , 0.101453169505    , 0.0928932322142   ,
 0.0775508112028   , 0.0645014293472   , 0.0572985378758   , 0.0526178857418   ,
 0.0454494995947   , 0.0348280849713   , 0.0244784348402   , 0.0192750299558   ,
 0.0229552047412   , 0.0403942156066   , 0.0815469875787   , 0.158437289238    ,
 0.269029131233    , 0.380146670515    , 0.437432586309    , 0.406655756399    ,
 0.304928057944    , 0.18468611296     , 0.0906786645072   , 0.0363933932723   ,
 0.0122411636277   , 0.0037340435569   , 0.00126668153562  , 0.000735065582835 ,
 0.00119000157631  , 0.00312422085391  , 0.00749040283405  , 0.0144502216759   ,
 0.0220333807934   , 0.0265114769043   , 0.0252003299815   , 0.0287012753146   ,
 0.0175558988723   , 0.00867139988713  , 0.00355433427122  , 0.00135811584202  ,
 0.00070428894111  , 0.000642979445219 , 0.000705560219104 , 0.000715773225303 ,
 0.000666736806656 , 0.000635558812804 , 0.000698706956387 , 0.000890515328024 ,
 0.00124012653337  , 0.00184487004461  , 0.00286870075182  , 0.00440796826992  ,
 0.00634326098608  , 0.00833696758038  , 0.00997799672886  , 0.0110322359306   ,
 0.0117603354302   , 0.0130619175529   , 0.0163064817126   , 0.023106148887    ,
 0.034855976155    , 0.0515300668988   , 0.0707494863671   , 0.0887025122612   ,
 0.102000088323    , 0.10909213243     , 0.112034019334    , 0.11728700019     ,
 0.131822930239    , 0.157014578687    , 0.188298389179    , 0.22066369616     ,
 0.250659967779    , 0.272701807267    , 0.279201941396    , 0.268744470237    ,
 0.253183531414    , 0.254261734202    , 0.290893285652    , 0.366138339175    ,
 0.463054204341    , 0.553129874775    , 0.614137844136    , 0.64751950615     ,
 0.679689918168    , 0.739497157576    , 0.832397918721    , 0.944081890762    ,
 1.06871091864     , 1.21994057077     , 1.40987393862     , 1.62913447352     ,
 1.85502872886     , 2.07451041048     , 2.29390760082     , 2.52397317063     ,
 2.75639302698     , 2.96289288845     , 3.12270972125     , 3.24435716287     ,
 3.36015212193     , 3.51827121962     , 3.79079299679     , 4.27178656044     ,
 5.04642249295     , 6.15423239136     , 7.57392012764     , 9.24483018366     ,
 11.1314560648     , 13.283258919      , 15.8018209691     , 18.7212984343     ,
 21.9367896863     , 25.2677135004     , 28.5519775524     , 31.5981870641     ,
 34.0321452334     , 35.3051167507     , 34.9770380595     , 33.0063549463     ,
 29.7581484747     , 25.7879159591     , 21.6217577571     , 17.6302635976     ,
 14.0060974169     , 10.8390366044     , 8.20262892581     , 6.14417752226     ,
 4.61474779531     , 3.47512509046     , 2.59026268277     , 1.89027234014     ,
 1.34765702357     , 0.939827916837    , 0.64452165812     , 0.446180027694    ,
 0.331261161325    , 0.279354429218    , 0.262053679374    , 0.252376833666    ,
 0.236725959728    , 0.21612493697     , 0.195924544778    , 0.178122625515    ,
 0.162025465062    , 0.14516787441     , 0.123169086698    , 0.0941638605562   ,
 0.0633053505534   , 0.0390375887881   , 0.0252869057214   , 0.0193136691051   ,
 0.0159917404905   , 0.0123004553781   , 0.00829800912489  , 0.0056541666649   ,
 0.00620614576476  , 0.0113490336674   , 0.0213762968476   , 0.0344010393186   ,
 0.0461241492065   , 0.0515758327191   , 0.0480370534985   , 0.0370078076841   ,
 0.0233612759435   , 0.0120152681685   , 0.00514061027248  , 0.0022907694198   ,
 0.00237464797997  , 0.00494473219925  , 0.00977164193278  , 0.0155672976708   ,
 0.0196950434857   , 0.0199043630238   , 0.0165553804247   , 0.0127038591802   ,
 0.0119484928786   , 0.0165160509794   , 0.0271026116436   , 0.0434920098238   ,
 0.0642661384483   , 0.0856254302151   , 0.101783549442    , 0.108797617259    ,
 0.108500653988    , 0.106521204434    , 0.105258823006    , 0.100699561277    ,
 0.087752162966    , 0.0674027035749   , 0.0468326186054   , 0.0333076023923   ,
 0.0303869765103   , 0.0410669907127   , 0.0727049685163   , 0.133946585343    ,
 0.220425863057    , 0.302691048605    , 0.338102708156    , 0.304695739968    ,
 0.221430216695    , 0.130420498894    , 0.0631766740838   , 0.0262407062173   ,
 0.0104428775548   , 0.00479913521118  , 0.0027571228313   , 0.00195562398283  ,
 0.00234082586967  , 0.00497677960293  , 0.0112498972278   , 0.0213446417426   ,
 0.0324257351688   , 0.039142927396    , 0.0375515329942   , 0.0420604313856   ,
 0.0273718328966   , 0.0148489643775   , 0.00710471089388  , 0.0036062583371   ,
 0.00269617427127  , 0.00290478375166  , 0.00326715645198  , 0.00333542856776  ,
 0.00314733048562  , 0.00302197759785  , 0.00324568717043  , 0.00393134049661  ,
 0.0051817282753   , 0.0073552213263   , 0.0110343398255   , 0.0165414395959   ,
 0.023437810147    , 0.0305101740253   , 0.0361837848747   , 0.0392483321837   ,
 0.039870995711    , 0.0400007314786   , 0.0423697908634   , 0.0493080939684   ,
 0.0625627546655   , 0.0830242916886   , 0.109827027654    , 0.139955550614    ,
 0.168350075908    , 0.189396042528    , 0.202043981163    , 0.214065221188    ,
 0.23676671976     , 0.273941411826    , 0.319990851098    , 0.36936094978     ,
 0.420991337654    , 0.470307482344    , 0.504632674883    , 0.515331608219    ,
 0.514270195756    , 0.532679419111    , 0.59918520805     , 0.71567718615     ,
 0.852505131599    , 0.968844520578    , 1.04379578491     , 1.09411222082     ,
 1.16259924022     , 1.28345632501     , 1.45581832469     , 1.65538732196     ,
 1.86959350234     , 2.10929682014     , 2.38574380287     , 2.68992014739     ,
 3.00011108525     , 3.30678954255     , 3.62979422968     , 4.00404209582     ,
 4.43643797509     , 4.88071725216     , 5.26880015124     , 5.57149959877     ,
 5.83374606131     , 6.16851902501     , 6.72392568188     , 7.63823443378     ,
 9.00508679763     , 10.8597447501     , 13.1684932784     , 15.8405645904     ,
 18.821168702      , 22.2112952107     , 26.2378108279     , 31.0333050789     ,
 36.4423795542     , 42.065164722      , 47.4397538267     , 52.0736483588     ,
 55.3076227351     , 56.373515014      , 54.8067472411     , 50.8110380075     ,
 45.1613379734     , 38.7852861468     , 32.4195290062     , 26.4915703865     ,
 21.1665221108     , 16.4896919683     , 12.5228412465     , 9.346866516       ,
 6.95342413102     , 5.19930871068     , 3.8924619678      , 2.88941118644     ,
 2.10999046409     , 1.50976586375     , 1.06330882712     , 0.754552174963    ,
 0.56391616874     , 0.460218686533    , 0.405031032506    , 0.367108967402    ,
 0.333969047849    , 0.306990285767    , 0.286513371638    , 0.267115013027    ,
 0.244172187654    , 0.215781673851    , 0.179625036948    , 0.136088675963    ,
 0.0932070855969   , 0.0618011394727   , 0.045603402534    , 0.039138389843    ,
 0.034297038758    , 0.0269559037793   , 0.0181867073316   , 0.0115054259737   ,
 0.0101154346834   , 0.0158465531329   , 0.0285572246781   , 0.0451257074764   ,
 0.059564584167    , 0.0656275511744   , 0.0604669552906   , 0.0464890987993   ,
 0.0297429761138   , 0.0159125005356   , 0.00739970477757  , 0.00378740241568  ,
 0.00417874427567  , 0.00852137155819  , 0.016722001596    , 0.0266631504438   ,
 0.033877744462    , 0.034596976814    , 0.0295891676592   , 0.0241493130339   ,
 0.0238188229141   , 0.03032912197     , 0.0416302076887   , 0.0554842307513   ,
 0.0723355932825   , 0.0935630771693   , 0.117382039972    , 0.139100733722    ,
 0.155973015774    , 0.168457923593    , 0.175144779113    , 0.170121020505    ,
 0.149022043811    , 0.116556532387    , 0.0848115261371   , 0.0636807184295   ,
 0.0553120583441   , 0.0587440713381   , 0.0770489807298   , 0.115508904086    ,
 0.170089768086    , 0.219699891031    , 0.236576361523    , 0.20907151861     ,
 0.152079930892    , 0.0929586212821   , 0.0502977269698   , 0.0267770991162   ,
 0.0159878472299   , 0.0109373822758   , 0.00774765279445  , 0.00555013905039  ,
 0.00518687115297  , 0.00825469979852  , 0.0163865976113   , 0.0296315031664   ,
 0.0443750159862   , 0.053873394042    , 0.0528604268616   , 0.0713169676551   ,
 0.0507462900702   , 0.0311051998195   , 0.0176307923769   , 0.0111517446826   ,
 0.00982596928601  , 0.0110067824551   , 0.0123704502878   , 0.0127092590151   ,
 0.0122413628753   , 0.0119991079475   , 0.0128025275357   , 0.0148998366595   ,
 0.0185731251203   , 0.0248980067384   , 0.0355207173546   , 0.0512528105575   ,
 0.0708047080445   , 0.0908141441703   , 0.106728884445    , 0.114423595436    ,
 0.113061814802    , 0.106862838001    , 0.102635860008    , 0.105633843829    ,
 0.118522558242    , 0.142529078033    , 0.177515075843    , 0.220819788113    ,
 0.265725776087    , 0.302626642394    , 0.326917229789    , 0.346994586961    ,
 0.378898546319    , 0.430750359031    , 0.497690766       , 0.573691933398    ,
 0.659241170299    , 0.750750712253    , 0.83131244931     , 0.885494121374    ,
 0.924263117682    , 0.986142694838    , 1.10675020169     , 1.28472357061     ,
 1.47742331374     , 1.63428221626     , 1.74065858076     , 1.83166864078     ,
 1.96307546852     , 2.16742009052     , 2.43619163197     , 2.74201355636     ,
 3.07093871794     , 3.42642485771     , 3.8106912103      , 4.21591294064     ,
 4.63201659873     , 5.06241308597     , 5.54212072848     , 6.13117979712     ,
 6.86223160115     , 7.6892598841      , 8.51003586326     , 9.25772309316     ,
 9.97899118393     , 10.831903585      , 12.0113247997     , 13.6697584243     ,
 15.9003322298     , 18.7610114627     , 22.2585879608     , 26.3256069487     ,
 30.9229207075     , 36.2120808497     , 42.5289738309     , 50.0729135433     ,
 58.5963592458     , 67.4030167977     , 75.5800978877     , 82.1319681855     ,
 85.9698045742     , 86.1191473645     , 82.2552724128     , 75.0480410536     ,
 65.8611145914     , 56.0826946526     , 46.6712779455     , 38.0956170611     ,
 30.483620756      , 23.8240273508     , 18.1407726543     , 13.5269595809     ,
 10.0173178251     , 7.47481752275     , 5.63903562538     , 4.26009347227     ,
 3.17719140391     , 2.31826774415     , 1.66414792486     , 1.20682252212     ,
 0.920661756984    , 0.756750131712    , 0.656703408749    , 0.576231996672    ,
 0.501122055732    , 0.43819666475     , 0.391518590058    , 0.353638445643    ,
 0.315561580222    , 0.272981513671    , 0.223788507598    , 0.169823111967    ,
 0.120599896128    , 0.0873246684361   , 0.0722030021523   , 0.0668041514719   ,
 0.0603902402823   , 0.0481718219667   , 0.0327040179777   , 0.0198190288711   ,
 0.0142797624965   , 0.0181055754601   , 0.0303825009829   , 0.0469524107593   ,
 0.0611364801476   , 0.0667561661359   , 0.0616190787411   , 0.0485287780237   ,
 0.0330382673789   , 0.0198700378929   , 0.011007749777    , 0.00658551246541  ,
 0.00680456169876  , 0.0126062335664   , 0.0242211688922   , 0.0386730775604   ,
 0.0495825272585   , 0.0516825434817   , 0.0464875186867   , 0.042230397168    ,
 0.0469597511064   , 0.061427382113    , 0.0788397517735   , 0.0922601748228   ,
 0.102512463403    , 0.11744069439     , 0.143083261797    , 0.177742602881    ,
 0.214591470726    , 0.245874904728    , 0.262978612961    , 0.257335863793    ,
 0.226984107626    , 0.182366500116    , 0.141419995781    , 0.116279032864    ,
 0.106201728724    , 0.104554338699    , 0.109592578094    , 0.124607800795    ,
 0.148174146666    , 0.168724478844    , 0.172107746349    , 0.153925046721    ,
 0.122407626492    , 0.0899779829351   , 0.0643936623093   , 0.0470087887291   ,
 0.0355694202572   , 0.0271144083066   , 0.0199684598421   , 0.0145575728725   ,
 0.0127439013244   , 0.0167492349199   , 0.0283224546394   , 0.0470709812415   ,
 0.0682160011412   , 0.0831010976671   , 0.0843086119021   , 0.140293291054    ,
 0.107160680437    , 0.0720432910973   , 0.0458995899514   , 0.0328361434346   ,
 0.0308385362321   , 0.034616917738    , 0.0386757467142   , 0.0401152832261   ,
 0.0397156066059   , 0.040140153006    , 0.0431455005684   , 0.0489456076246   ,
 0.0580890289292   , 0.0731853240903   , 0.0979107827184   , 0.133726797013    ,
 0.177625472686    , 0.222550629743    , 0.258569403019    , 0.275252521139    ,
 0.268262648287    , 0.245426100689    , 0.222945137411    , 0.21468217144     ,
 0.226526818162    , 0.258151495353    , 0.305841163622    , 0.363374063912    ,
 0.421295527931    , 0.468224979305    , 0.499477875292    , 0.526635100278    ,
 0.572044748888    , 0.649054295831    , 0.752142954999    , 0.870056681173    ,
 0.999982148575    , 1.13977498097     , 1.27510039361     , 1.39121622104     ,
 1.49940255795     , 1.63949086287     , 1.84680550218     , 2.114258624       ,
 2.38923140862     , 2.61625364786     , 2.78943610047     , 2.95949762959     ,
 3.18711052806     , 3.49501739729     , 3.8665602076      , 4.27922569732     ,
 4.72485503311     , 5.19933675884     , 5.6956368519      , 6.21784577323     ,
 6.78575021407     , 7.42391389789     , 8.17045776831     , 9.09286343886     ,
 10.2548174978     , 11.6485918438     , 13.1856714334     , 14.7862270966     ,
 16.4831645988     , 18.427069428      , 20.7879321137     , 23.6706019567     ,
 27.1435828303     , 31.3141937492     , 36.3030596082     , 42.1669270691     ,
 48.9702966226     , 56.9581346581     , 66.512976236      , 77.7934568004     ,
 90.3611420986     , 103.125433359     , 114.572904006     , 123.021200364     ,
 126.864461823     , 125.034291005     , 117.598219843     , 105.924413544     ,
 92.0777231489     , 77.9159729819     , 64.5949191916     , 52.6168390118     ,
 42.0845499518     , 32.9354107015     , 25.1385228242     , 18.7748052924     ,
 13.9096248981     , 10.407236254      , 7.92455871728     , 6.07985169426     ,
 4.61052657398     , 3.41231961231     , 2.48068699033     , 1.82436154897     ,
 1.41261596872     , 1.17256035041     , 1.01604422092     , 0.87588545495     ,
 0.731108110304    , 0.59780370568     , 0.494014297662    , 0.418706070897    ,
 0.359539865257    , 0.305518740629    , 0.25018437309     , 0.193764511896    ,
 0.144864979692    , 0.113502913023    , 0.100500493059    , 0.0959677036621   ,
 0.0878920635615   , 0.0710687427705   , 0.0489990297806   , 0.0293243130375   ,
 0.0181748763817   , 0.0176674496027   , 0.0261710422984   , 0.0391407247079   ,
 0.0505718516647   , 0.0557747076745   , 0.0536990388818   , 0.0465479162854   ,
 0.0372807429708   , 0.0277344741431   , 0.0189497779381   , 0.0125124512532   ,
 0.0109782727666   , 0.016988031149    , 0.0312602361129   , 0.050069215423    ,
 0.0653931899741   , 0.0707143254836   , 0.0683976855874   , 0.0697323237947   ,
 0.0853253386188   , 0.114237825941    , 0.142938007998    , 0.157296270322    ,
 0.15735433598     , 0.158914643764    , 0.179452439923    , 0.223559921247    ,
 0.280801574989    , 0.332915262284    , 0.361733557216    , 0.355829809793    ,
 0.317017170921    , 0.262543468576    , 0.21623250601     , 0.191950715098    ,
 0.185304565979    , 0.183141444551    , 0.178940078528    , 0.175582479729    ,
 0.175755020321    , 0.176209942334    , 0.172533955782    , 0.164272020149    ,
 0.152794601026    , 0.137746747329    , 0.118532153067    , 0.0971300716007   ,
 0.0767732810214   , 0.0590315786903   , 0.0442543195189   , 0.0339364620165   ,
 0.0310304003911   , 0.0386291378396   , 0.0587332142488   , 0.0900872344086   ,
 0.12538708608     , 0.151916399118    , 0.157888689009    , 0.271549159454    ,
 0.21745384528     , 0.156139474726    , 0.108320672002    , 0.0841829659944   ,
 0.0817975096149   , 0.091271487497    , 0.101442674077    , 0.106624881059    ,
 0.108983400712    , 0.114053391369    , 0.124497750518    , 0.139493859734    ,
 0.159537244106    , 0.189609466274    , 0.236078770401    , 0.300579957621    ,
 0.377729553238    , 0.45691228544     , 0.522169147519    , 0.5531804244      ,
 0.537486096065    , 0.486278308817    , 0.431655740312    , 0.405052724706    ,
 0.420258282666    , 0.472665031698    , 0.546905042922    , 0.624674915884    ,
 0.68978026395     , 0.73211641259     , 0.755487542715    , 0.784183687258    ,
 0.85268866492     , 0.978622671689    , 1.14732264427     , 1.32983127454     ,
 1.51159396437     , 1.69455493877     , 1.87930076291     , 2.06367248599     ,
 2.26125656785     , 2.5062475607      , 2.82708609463     , 3.21115452974     ,
 3.60050971128     , 3.93732317635     , 4.22132968266     , 4.51235276439     ,
 4.87072790005     , 5.30692257656     , 5.79518303178     , 6.31832318374     ,
 6.87709392614     , 7.46684293186     , 8.08367965824     , 8.76128409535     ,
 9.56622381347     , 10.547545507      , 11.7274548977     , 13.1533950434     ,
 14.9187806638     , 17.0988933626     , 19.6869380217     , 22.6345794239     ,
 25.9504263482     , 29.7135152445     , 33.9795532044     , 38.7278214258     ,
 43.9596438743     , 49.8331068684     , 56.6397401711     , 64.67739219       ,
 74.2428846002     , 85.7133955745     , 99.4401981186     , 115.386262149     ,
 132.770155215     , 149.975111293     , 164.745813442     , 174.591932443     ,
 177.403107745     , 172.227889619     , 159.833538613     , 142.505288553     ,
 123.051242211     , 103.726747654     , 85.8089311327     , 69.8067537648     ,
 55.8078057841     , 43.7150005196     , 33.4487378231     , 25.0678599839     ,
 18.6466884094     , 14.0280485472     , 10.7711105872     , 8.35414006077     ,
 6.40643542377     , 4.78691979423     , 3.50623627975     , 2.59417554937     ,
 2.01729603343     , 1.6763750869      , 1.44750914672     , 1.23292271577     ,
 0.99868855263     , 0.770109900082    , 0.586122903025    , 0.460099541412    ,
 0.378638940204    , 0.320027871568    , 0.267484745841    , 0.215198408945    ,
 0.168823357014    , 0.137503082716    , 0.1229840193      , 0.116841803582    ,
 0.107458350634    , 0.0887203817089   , 0.0632057575574   , 0.0387393139588   ,
 0.0223396388347   , 0.0165956793172   , 0.0197935520578   , 0.0277520851934   ,
 0.0360421999768   , 0.0422247808758   , 0.0464835540177   , 0.0494947596946   ,
 0.0499109964574   , 0.0451639085696   , 0.03512618465     , 0.0239779552129   ,
 0.0180771346582   , 0.0225664287356   , 0.0388625684522   , 0.0626751196608   ,
 0.0846235394425   , 0.0968471530404   , 0.101800648406    , 0.112919800867    ,
 0.143097979833    , 0.190034122787    , 0.233524607943    , 0.251451717213    ,
 0.241770038733    , 0.227442389982    , 0.237954008348    , 0.285974654515    ,
 0.359248650969    , 0.429717759582    , 0.469429725787    , 0.463748427402    ,
 0.417993636981    , 0.355607400149    , 0.305621273688    , 0.283910126285    ,
 0.283710563343    , 0.286387376152    , 0.280850703098    , 0.269502569433    ,
 0.258383645259    , 0.24971601088     , 0.244685292296    , 0.244761524312    ,
 0.246097379482    , 0.238512051645    , 0.214946919486    , 0.179243623112    ,
 0.141625216745    , 0.109382201171    , 0.0850342464023   , 0.0705958294527   ,
 0.0696038390243   , 0.0859838921607   , 0.122287339434    , 0.176160647027    ,
 0.236122122786    , 0.282591724137    , 0.296693549945    , 0.462794047467    ,
 0.386235476999    , 0.295007807002    , 0.221891926632    , 0.185690315403    ,
 0.185487711424    , 0.205743986636    , 0.22799692068     , 0.243411105937    ,
 0.256758504794    , 0.277372483888    , 0.307637286911    , 0.343209966194    ,
 0.383002591011    , 0.434025702495    , 0.504427080506    , 0.594612165877    ,
 0.697902865353    , 0.804971766965    , 0.898413815433    , 0.947076400713    ,
 0.924709418421    , 0.842400934164    , 0.751952485617    , 0.710724858103    ,
 0.745612973456    , 0.844514114802    , 0.969945504353    , 1.07981647827     ,
 1.1450364019      , 1.16035171839     , 1.15068984637     , 1.16871365895     ,
 1.27108348248     , 1.47794436623     , 1.75233355378     , 2.03054647889     ,
 2.27606344739     , 2.49755185549     , 2.72172428911     , 2.96813704018     ,
 3.253831925       , 3.60491778137     , 4.04460108259     , 4.56128948409     ,
 5.09632603646     , 5.58546482839     , 6.02281046212     , 6.46958462555     ,
 6.99006284226     , 7.59151064029     , 8.23806607992     , 8.90694932202     ,
 9.60451740793     , 10.3403549864     , 11.1352069676     , 12.0637733187     ,
 13.2396337585     , 14.7331392523     , 16.5419718624     , 18.676061788      ,
 21.2502394343     , 24.4506764846     , 28.4128452094     , 33.1730651915     ,
 38.7231284043     , 45.0278932056     , 51.9606486461     , 59.3071385183     ,
 66.9407788481     , 75.0227018888     , 84.0157469118     , 94.5424578422     ,
 107.261091012     , 122.754640294     , 141.300314994     , 162.536424472     ,
 185.183756021     , 206.946942662     , 224.695580873     , 235.070571563     ,
 235.539446463     , 225.503701891     , 206.726445161     , 182.623813188     ,
 156.797819702     , 131.821809517     , 108.97464572      , 88.6770445219     ,
 70.9543749531     , 55.6769662069     , 42.7437100337     , 32.2020701792     ,
 24.1108765446     , 18.2583666899     , 14.0988618122     , 10.9890758259     ,
 8.46670141358     , 6.35321833517     , 4.66607834741     , 3.45230625421     ,
 2.67625340355     , 2.21204075477     , 1.89771034224     , 1.6014293117      ,
 1.27217673456     , 0.941696382938    , 0.670847417332    , 0.491023461234    ,
 0.389668751292    , 0.332207573219    , 0.287236595499    , 0.239804835267    ,
 0.192289568123    , 0.154929624282    , 0.13337350943     , 0.123273223272    ,
 0.11441111586     , 0.0986200509376   , 0.0750435352966   , 0.049590566889    ,
 0.0297549022057   , 0.019561438332    , 0.0182906181915   , 0.0225146465465   ,
 0.0292605885074   , 0.0382464487995   , 0.0509183663495   , 0.0661351483995   ,
 0.077355773956    , 0.076672841565    , 0.0627604700097   , 0.0434750609628   ,
 0.0303994844291   , 0.0321649446529   , 0.0513761311554   , 0.0834461540787   ,
 0.117547090387    , 0.143411538089    , 0.161301787277    , 0.184388839793    ,
 0.227374216647    , 0.289157481365    , 0.346998976441    , 0.373175232548    ,
 0.361801581556    , 0.338132007439    , 0.339551137475    , 0.386700367339    ,
 0.469009248942    , 0.5523810557      , 0.600324936773    , 0.593842323021    ,
 0.539877186754    , 0.466543043211    , 0.407577737411    , 0.382405688317    ,
 0.385645639351    , 0.397068481132    , 0.40218699378     , 0.400338617095    ,
 0.395506041493    , 0.388969090626    , 0.383128418408    , 0.382194907697    ,
 0.382621195887    , 0.370020919524    , 0.333152103705    , 0.277600217037    ,
 0.220437412915    , 0.174946814094    , 0.145558264036    , 0.133534533988    ,
 0.141195805514    , 0.17202487826     , 0.22909412696     , 0.309664141831    ,
 0.398469369831    , 0.468851742263    , 0.494221386644    , 0.675301298877    ,
 0.590585968781    , 0.48434713036     , 0.398301148448    , 0.359375843256    ,
 0.368936002661    , 0.407516761992    , 0.450860171529    , 0.488239325087    ,
 0.527899723867    , 0.582633969202    , 0.652317072952    , 0.725699280887    ,
 0.796914140424    , 0.871930362134    , 0.957316058042    , 1.05091460817     ,
 1.14925772406     , 1.25453882975     , 1.35804968907     , 1.42156497484     ,
 1.40175635318     , 1.30428940557     , 1.19863786792     , 1.16982536626     ,
 1.25863085349     , 1.4402293379      , 1.64426645049     , 1.79504979745     ,
 1.84845043474     , 1.81126379706     , 1.74252899706     , 1.73610400124     ,
 1.87807350064     , 2.19015376567     , 2.6046543499      , 3.01107818506     ,
 3.3414837501      , 3.6087641688      , 3.8681559602      , 4.16303234318     ,
 4.5153632013      , 4.94860434731     , 5.49172887555     , 6.14548166015     ,
 6.85386707132     , 7.5371586087      , 8.16831984014     , 8.80362019389     ,
 9.52253322686     , 10.3440894432     , 11.2200612862     , 12.106391349      ,
 13.0131164592     , 13.9863866559     , 15.0919500061     , 16.4363868644     ,
 18.1542702461     , 20.3298742717     , 22.9525032368     , 26.0028754525     ,
 29.6040070663     , 34.04819773       , 39.6444197328     , 46.5620664427     ,
 54.802861535      , 64.2127393513     , 74.4620649697     , 85.1073795021     ,
 95.8228212405     , 106.670951628     , 118.214128924     , 131.416676614     ,
 147.387583551     , 167.003117957     , 190.496614776     , 217.139599144     ,
 245.042795316     , 271.077349669     , 291.115545351     , 300.924312026     ,
 297.678440761     , 281.339906844     , 254.884696876     , 223.035700912     ,
 190.279860174     , 159.487184315     , 131.817454165     , 107.440337222     ,
 86.1935214026     , 67.8758485048     , 52.3861272303     , 39.7718197299     ,
 30.048867254      , 22.9232138405     , 17.7588506156     , 13.8390961181     ,
 10.6503217464     , 7.98537230798     , 5.85699740788     , 4.31816802043     ,
 3.32613450693     , 2.72637653027     , 2.31897261001     , 1.94041992903     ,
 1.52368725869     , 1.10350007169     , 0.756856378052    , 0.529740622523    ,
 0.410629169234    , 0.353450537357    , 0.312862045618    , 0.26534632858     ,
 0.211295327427    , 0.163578910029    , 0.132853289366    , 0.119510113225    ,
 0.114861127804    , 0.10772378185     , 0.0917503258923   , 0.069126622125    ,
 0.0477983730525   , 0.0347680474049   , 0.0315480732019   , 0.0350966500713   ,
 0.042608146573    , 0.0553303887675   , 0.0764691660916   , 0.103680825463    ,
 0.125052700368    , 0.126719674407    , 0.106049805905    , 0.0753536124647   ,
 0.0527667283528   , 0.0517754803479   , 0.0771721951066   , 0.124373345768    ,
 0.180334081767    , 0.230138254436    , 0.268167187281    , 0.303574841739    ,
 0.351959171628    , 0.417670785689    , 0.483370597287    , 0.521749917883    ,
 0.522020229726    , 0.504207510192    , 0.505823746461    , 0.553155979776    ,
 0.640488156436    , 0.731863293327    , 0.783707499445    , 0.771502929038    ,
 0.702197047182    , 0.607749626062    , 0.526838180717    , 0.484496521627    ,
 0.481503451715    , 0.502101526114    , 0.531431141153    , 0.561995404364    ,
 0.585704287246    , 0.591600110278    , 0.577403004075    , 0.553711773885    ,
 0.528153640519    , 0.492732322144    , 0.436313181339    , 0.364319117371    ,
 0.296783818038    , 0.250384187759    , 0.230050151214    , 0.234183567236    ,
 0.260326558778    , 0.308081638753    , 0.380128343758    , 0.475824124988    ,
 0.580945651887    , 0.667151222647    , 0.704039362588    , 0.859236327034    ,
 0.796908216035    , 0.71326556076     , 0.64860898832     , 0.631579482043    ,
 0.665848186578    , 0.732931536368    , 0.808424425601    , 0.882392638205    ,
 0.96561297225     , 1.07202670452     , 1.19739009345     , 1.32214560806     ,
 1.43251066496     , 1.52815079102     , 1.6096111208      , 1.67282912201     ,
 1.72446490955     , 1.78834799233     , 1.87410640257     , 1.9436422337      ,
 1.93972917941     , 1.8603815904      , 1.78614612468     , 1.82171072713     ,
 2.01331744656     , 2.31352322063     , 2.61022704424     , 2.79331533432     ,
 2.81395199785     , 2.7054490033      , 2.56880634875     , 2.5369488053      ,
 2.7198555927      , 3.14015859981     , 3.7039290119      , 4.25600466328     ,
 4.6915745189      , 5.01781909225     , 5.3105268201      , 5.63504983288     ,
 6.02407805658     , 6.50996328689     , 7.13931855275     , 7.93249775906     ,
 8.83662311947     , 9.74999508325     , 10.6160372573     , 11.4852021695     ,
 12.4603264859     , 13.577060015      , 14.7668862448     , 15.9556428317     ,
 17.1682777694     , 18.5149570016     , 20.1155709824     , 22.077015552      ,
 24.510878527      , 27.5095692655     , 31.0923948629     , 35.2438403827     ,
 40.0844631754     , 45.982496268      , 53.417429284      , 62.717940225      ,
 73.9184790793     , 86.7582897667     , 100.722605472     , 115.145233188     ,
 129.450391494     , 143.491812545     , 157.821967831     , 173.694846455     ,
 192.685284167     , 216.032669194     , 244.018899048     , 275.591904285     ,
 308.184790895     , 337.695250159     , 358.921272491     , 366.848451921     ,
 358.580314302     , 334.842907538     , 299.919603236     , 259.861657951     ,
 220.057330782     , 183.677029546     , 151.696524798     , 123.896748444     ,
 99.7894950198     , 79.028155356      , 61.4876701527     , 47.1897946326     ,
 36.0732347606     , 27.7576748942     , 21.562369303      , 16.7656206149     ,
 12.8537737114     , 9.60769687267     , 7.02759312709     , 5.15941892216     ,
 3.94535392465     , 3.20030207102     , 2.69093203859     , 2.23118399717     ,
 1.74336890012     , 1.25967618855     , 0.86038062679     , 0.596429732081    ,
 0.457044927991    , 0.390812782607    , 0.344884739074    , 0.290819551265    ,
 0.228004492127    , 0.171090925435    , 0.134123296363    , 0.121216930177    ,
 0.125239171616    , 0.131909322936    , 0.128151770807    , 0.111060751841    ,
 0.0895000840182   , 0.0755606017637   , 0.0741293405414   , 0.0810977947939   ,
 0.0914078403877   , 0.107217864688    , 0.135029202263    , 0.172818027034    ,
 0.203237760717    , 0.205489765801    , 0.175142624753    , 0.129520569164    ,
 0.0948048225217   , 0.0912603555043   , 0.127312489535    , 0.198484765873    ,
 0.288021283382    , 0.373548658651    , 0.439900038358    , 0.488538040232    ,
 0.534296430954    , 0.589930070925    , 0.651135957566    , 0.698755352956    ,
 0.719115491279    , 0.722276366226    , 0.738860587861    , 0.796270494024    ,
 0.892569257545    , 0.990587085224    , 1.04067271942     , 1.01397581561     ,
 0.9186155527      , 0.790948675391    , 0.67457326186     , 0.600861112263    ,
 0.579872240829    , 0.605626687815    , 0.666930974096    , 0.747579024859    ,
 0.8182322889      , 0.843578481308    , 0.809562086982    , 0.736744490387    ,
 0.656386273489    , 0.580013831501    , 0.502440003519    , 0.425902664539    ,
 0.366516405894    , 0.339404306119    , 0.347984791767    , 0.385578343894    ,
 0.440278263706    , 0.502444896098    , 0.572409610006    , 0.655534112611    ,
 0.747279164396    , 0.827741039776    , 0.870907797654    , 1.00750315183     ,
 1.00409028965     , 0.994019808469    , 1.00163249412     , 1.04498662288     ,
 1.1267305092      , 1.23492968966     , 1.35298762731     , 1.47457780059     ,
 1.60916371783     , 1.76733348005     , 1.94145007202     , 2.10779515997     ,
 2.2461073762      , 2.3472602844      , 2.40442140074     , 2.41457112466     ,
 2.39819112842     , 2.40148531204     , 2.45365247754     , 2.52374388104     ,
 2.55056732544     , 2.52824007054     , 2.54149653703     , 2.70056320858     ,
 3.04088554511     , 3.47837408419     , 3.85452951605     , 4.03663394815     ,
 3.99560504855     , 3.8111226259      , 3.62513874526     , 3.58920524676     ,
 3.81626336765     , 4.32720413773     , 5.0181755321      , 5.70706512061     ,
 6.25382113394     , 6.64560983888     , 6.96417843164     , 7.29575789018     ,
 7.69549039185     , 8.21708513765     , 8.92819625443     , 9.86522110632     ,
 10.976058821      , 12.1395543045     , 13.2756677302     , 14.4350507151     ,
 15.742957737      , 17.239936248      , 18.8240303081     , 20.3932069465     ,
 22.0092996852     , 23.8692517902     , 26.1428236636     , 28.9006373045     ,
 32.1937518986     , 36.1229317524     , 40.7773207783     , 46.1849702934     ,
 52.4656845277     , 60.0325491384     , 69.5065832544     , 81.3607849292     ,
 95.6446622742     , 111.974965247     , 129.667686384     , 147.878688748     ,
 165.811332362     , 183.093048285     , 200.201711283     , 218.576782831     ,
 240.15630475      , 266.521538652     , 298.080385219     , 333.531365913     ,
 369.607334529     , 401.168195478     , 421.985815759     , 426.505938311     ,
 412.097260456     , 380.468122991     , 337.173227376     , 289.375998853     ,
 243.165247613     , 201.934813276     , 166.476295768     , 136.171891335     ,
 110.161685151     , 87.8861111682     , 69.1162977294     , 53.7719910763     ,
 41.6790213379     , 32.3977834151     , 25.2693567299     , 19.6324595712     ,
 15.0161980222     , 11.2077394339     , 8.19430589032     , 6.00635147251     ,
 4.56546017762     , 3.65902545766     , 3.03206594018     , 2.49036150692     ,
 1.95123938949     , 1.43491019347     , 1.00761267628     , 0.714083301809    ,
 0.546028223124    , 0.456521471875    , 0.394168322333    , 0.32911724194     ,
 0.258804344143    , 0.19694373447     , 0.158416677057    , 0.149880045984    ,
 0.166096446305    , 0.190158083465    , 0.201532494841    , 0.191275445994    ,
 0.170101061845    , 0.15757392075     , 0.162669469821    , 0.177713296551    ,
 0.192295955925    , 0.209349098657    , 0.241313318553    , 0.28849480111     ,
 0.327545506213    , 0.328978221277    , 0.285672037411    , 0.220522197663    ,
 0.16938717537     , 0.161301346707    , 0.209660345942    , 0.310041891069    ,
 0.440652770924    , 0.569866332349    , 0.671395401343    , 0.737407985257    ,
 0.77978362753     , 0.817992379138    , 0.86196555179     , 0.905377297491    ,
 0.937612010694    , 0.96296218999     , 1.00530242863     , 1.08833617622     ,
 1.2061805643      , 1.31466748292     , 1.35813876294     , 1.30847899046     ,
 1.18019893713     , 1.01556906038     , 0.86138226283     , 0.753134871422    ,
 0.709121816542    , 0.733682676191    , 0.821523535447    , 0.950341291113    ,
 1.06941125376     , 1.11459136514     , 1.05456913328     , 0.919229815414    ,
 0.769749436862    , 0.645983910955    , 0.553105295949    , 0.487320919612    ,
 0.454391990263    , 0.463525745389    , 0.515784208446    , 0.598868976307    ,
 0.688184698095    , 0.759923815675    , 0.809586503939    , 0.851503571776    ,
 0.898412751789    , 0.948264158998    , 0.988624016113    , 1.18884955338     ,
 1.27320730056     , 1.38292200824     , 1.51500022369     , 1.6633644703      ,
 1.82209535515     , 1.98759509859     , 2.15736436229     , 2.33036770673     ,
 2.50861300219     , 2.69288847442     , 2.87430370088     , 3.03457224051     ,
 3.15655192351     , 3.22928856354     , 3.24470115467     , 3.2039536393      ,
 3.13622061431     , 3.09828361552     , 3.13106141226     , 3.21433169947     ,
 3.29251320771     , 3.36027298439     , 3.50158974142     , 3.82079178651     ,
 4.32834735543     , 4.89218385703     , 5.30861510917     , 5.44149342934     ,
 5.30929237295     , 5.05462752434     , 4.85224762326     , 4.84467974703     ,
 5.12125331376     , 5.69571965538     , 6.47337980774     , 7.27126977402     ,
 7.92387026906     , 8.38587271815     , 8.72777818848     , 9.05402472748     ,
 9.45275253004     , 10.0064368314     , 10.7996286113     , 11.8773901473     ,
 13.1892677469     , 14.6044968681     , 16.0305894239     , 17.5225877215     ,
 19.2219829322     , 21.1629406581     , 23.2057397026     , 25.2281438896     ,
 27.339400565      , 29.8245058601     , 32.8929904458     , 36.5659941484     ,
 40.8274373927     , 45.7903885855     , 51.6289984446     , 58.4381113126     ,
 66.3514361194     , 75.81223033       , 87.5382948395     , 102.085025538     ,
 119.444311277     , 139.042167125     , 160.004075008     , 181.376086342     ,
 202.294336876     , 222.326725119     , 241.936137246     , 262.620352274     ,
 286.432866502     , 315.101371046     , 349.110771978     , 386.948085582     ,
 424.701417567     , 456.309279276     , 474.773206224     , 474.371908971     ,
 453.088290719     , 413.765099837     , 363.088373792     , 308.969197257     ,
 257.813963183     , 213.026554135     , 175.205259219     , 143.428215504     ,
 116.536306962     , 93.7415876012     , 74.6280619654     , 58.9356581453     ,
 46.3622606737     , 36.4506920716     , 28.6163074402     , 22.293167296      ,
 17.0759583185     , 12.7767496888     , 9.3790657109      , 6.89675876334     ,
 5.22974537664     , 4.1456436699      , 3.38344950425     , 2.75598109134     ,
 2.18002205425     , 1.65422574171     , 1.2158657791      , 0.89546488864     ,
 0.69029808333     , 0.566508255464    , 0.480435950314    , 0.401976668342    ,
 0.325026163406    , 0.260797439613    , 0.223888098283    , 0.222480923498    ,
 0.252681427221    , 0.294965415531    , 0.321411848403    , 0.317328480385    ,
 0.296490033821    , 0.287439624054    , 0.303097886989    , 0.329855621583    ,
 0.34963891463     , 0.366483824458    , 0.401110044253    , 0.457490240727    ,
 0.505364458742    , 0.505015162755    , 0.446053282194    , 0.357223785362    ,
 0.284511976801    , 0.26608028191     , 0.320662811922    , 0.444492314264    ,
 0.611644456009    , 0.782485623618    , 0.921377632962    , 1.01260238265     ,
 1.06338687574     , 1.09339307824     , 1.1184220491      , 1.14150353924     ,
 1.16141088845     , 1.19009216833     , 1.25498162903     , 1.37456787311     ,
 1.52767515251     , 1.65267558922     , 1.68686334059     , 1.61013799825     ,
 1.45110316326     , 1.26010559396     , 1.08426217376     , 0.958213045826    ,
 0.902044554819    , 0.923441530423    , 1.02051992946     , 1.17154814061     ,
 1.31694723051     , 1.37262546735     , 1.28972438734     , 1.10161044135     ,
 0.894975948269    , 0.737379245414    , 0.644377888437    , 0.603811086328    ,
 0.607408863588    , 0.656710121771    , 0.75199381624     , 0.8784572817      ,
 1.00064690684     , 1.07997502182     , 1.10525542262     , 1.09854266611     ,
 1.09013028744     , 1.09840299819     , 1.13059373189     , 1.52071626969     ,
 1.70719222286     , 1.96335920358     , 2.25759366459     , 2.55213534152     ,
 2.82303787385     , 3.06996305546     , 3.30484650846     , 3.53154467216     ,
 3.73886742517     , 3.91126322338     , 4.03921312697     , 4.11918248439     ,
 4.15163943316     , 4.14043011035     , 4.08990689816     , 4.00816363002     ,
 3.92275876074     , 3.88594171861     , 3.94049932773     , 4.0739688612      ,
 4.23437652438     , 4.41228858608     , 4.68680920523     , 5.15570820588     ,
 5.80517011103     , 6.45665423069     , 6.86844703296     , 6.915341925       ,
 6.67709815717     , 6.36234049608     , 6.168252679       , 6.20974636858     ,
 6.53520623423     , 7.14577378471     , 7.9682931225      , 8.84236715721     ,
 9.59314744658     , 10.1396273237     , 10.5263557806     , 10.8652868749     ,
 11.2739609888     , 11.8609342371     , 12.7259787103     , 13.9280716108     ,
 15.4297738429     , 17.098120248      , 18.823715349      , 20.6543047594     ,
 22.7432961795     , 25.1323536714     , 27.6681710006     , 30.2172990394     ,
 32.9146367772     , 36.1002545967     , 40.0165913567     , 44.6648703113     ,
 49.9956238886     , 56.1358609843     , 63.3217824396     , 71.7058745043     ,
 81.4470807575     , 93.0107343644     , 107.155012714     , 124.429596551     ,
 144.674948195     , 167.035307183     , 190.390201004     , 213.743884198     ,
 236.415144447     , 258.246336179     , 279.875868319     , 302.752365538     ,
 328.705715988     , 359.243345606     , 394.690904697     , 433.271866483     ,
 470.575969189     , 499.966048832     , 514.144675099     , 507.647476328     ,
 479.284393591     , 433.00222615      , 376.41141878      , 317.851333436     ,
 263.684139615     , 217.040745713     , 178.224994989     , 146.071394805     ,
 119.222202887     , 96.7072584947     , 77.9208187971     , 62.4258617852     ,
 49.8200981992     , 39.6551301082     , 31.4225716415     , 24.6415274163     ,
 18.9759299817     , 14.2838617667     , 10.5646530616     , 7.82272441205     ,
 5.93922876916     , 4.66972622853     , 3.75903537597     , 3.03755405162     ,
 2.42602560924     , 1.89895198308     , 1.45882647791     , 1.11804582119     ,
 0.879059751383    , 0.72219634057     , 0.611933929699    , 0.517867030093    ,
 0.431628520788    , 0.364399938161    , 0.331470148248    , 0.34041116369     ,
 0.385409111061    , 0.443247911736    , 0.480566416466    , 0.479619028334    ,
 0.458112555286    , 0.452542381932    , 0.478738984278    , 0.517203348411    ,
 0.542681200978    , 0.560348949276    , 0.598658750826    , 0.664579024775    ,
 0.720885237744    , 0.718454526858    , 0.644347025503    , 0.53230241211     ,
 0.435732753146    , 0.398886151168    , 0.444744502694    , 0.572395063863    ,
 0.756468825269    , 0.954493214326    , 1.12607833204     , 1.25120268495     ,
 1.33245953484     , 1.38224052106     , 1.40789025608     , 1.4095575239      ,
 1.39617336313     , 1.40141472752     , 1.47090382864     , 1.62103396431     ,
 1.80815278625     , 1.94613432931     , 1.96549108724     , 1.86015052517     ,
 1.67868023364     , 1.4815024669      , 1.31409183681     , 1.20448685216     ,
 1.16411116114     , 1.19098843057     , 1.27947772194     , 1.41559482951     ,
 1.55051442113     , 1.59919741683     , 1.50142835161     , 1.28684264161     ,
 1.05581916271     , 0.894859833275    , 0.825320340769    , 0.823956103973    ,
 0.866556983678    , 0.94695189932     , 1.06803366275     , 1.21963587019     ,
 1.36430209672     , 1.45507441951     , 1.4740462284      , 1.44406870936     ,
 1.40341091381     , 1.38482301403     , 1.41623383538     , 2.10987569704     ,
 2.40441315539     , 2.81330456405     , 3.28624377002     , 3.75775930699     ,
 4.17972123902     , 4.54343598582     , 4.8660752087      , 5.15259444096     ,
 5.37765191334     , 5.50838965209     , 5.53411159397     , 5.46882019295     ,
 5.33989969844     , 5.18138503181     , 5.02432200304     , 4.88910820016     ,
 4.79913218586     , 4.79733175096     , 4.92147859765     , 5.15373905112     ,
 5.42703561666     , 5.71179631757     , 6.07866295656     , 6.63054467406     ,
 7.3501775098      , 8.03344307612     , 8.41428348415     , 8.37959196359     ,
 8.05854477275     , 7.70876461462     , 7.53839573392     , 7.6317682104      ,
 7.99602030669     , 8.61777414134     , 9.44694489206     , 10.3578395698     ,
 11.1851184544     , 11.8240065878     , 12.2893656509     , 12.6835828367     ,
 13.1321608199     , 13.7570433058     , 14.6802377323     , 15.9970634777     ,
 17.7006621453     , 19.6501478717     , 21.6906416709     , 23.8331258749     ,
 26.2434222826     , 29.0140542905     , 32.0352684667     , 35.177680115      ,
 38.5530155028     , 42.4926970336     , 47.2669682127     , 52.9212356902     ,
 59.4375191605     , 66.9576188669     , 75.7306823525     , 85.926972967      ,
 97.7154816872     , 111.552369835     , 128.165570138     , 148.022340001     ,
 170.759964193     , 195.190636901     , 219.893435513     , 243.871715658     ,
 266.867511376     , 289.35640271      , 312.389957115     , 337.323663336     ,
 365.472241428     , 397.717434664     , 433.85967629      , 471.702642918     ,
 506.51655317      , 531.576701175     , 539.879287445     , 526.62324099      ,
 491.488886169     , 439.298635616     , 378.323114564     , 317.13201992      ,
 261.845837019     , 215.098769556     , 176.731783133     , 145.280995694     ,
 119.220497769     , 97.4720837569     , 79.3458764975     , 64.3402812142     ,
 52.0207499945     , 41.9435293646     , 33.6267140936     , 26.6293426411     ,
 20.6740531258     , 15.6832774562     , 11.6956841624     , 8.72082193824     ,
 6.62935668147     , 5.17204526098     , 4.10500314192     , 3.27925851752     ,
 2.62319510769     , 2.09291348408     , 1.66050464017     , 1.31887459526     ,
 1.06849094689     , 0.895491174311    , 0.76797277981     , 0.656632653313    ,
 0.556649249599    , 0.485304863459    , 0.460547970597    , 0.48567426748     ,
 0.547254690316    , 0.616553779602    , 0.658659805667    , 0.657468778152    ,
 0.634372427494    , 0.629861311165    , 0.661420728663    , 0.707338144999    ,
 0.738845259904    , 0.761081343957    , 0.805764278578    , 0.880373259257    ,
 0.942742059158    , 0.938508076047    , 0.854261542964    , 0.726361490071    ,
 0.609721961228    , 0.548716560629    , 0.568526032195    , 0.674551314074    ,
 0.848998256759    , 1.05347584445     , 1.24770980803     , 1.41093427924     ,
 1.54326738366     , 1.64674332202     , 1.70895227223     , 1.71293765468     ,
 1.67094435192     , 1.64187987451     , 1.69615953681     , 1.85158865817     ,
 2.04443236273     , 2.16918368484     , 2.1559257344      , 2.01610827302     ,
 1.81844739376     , 1.63297215355     , 1.50266997167     , 1.44457577097     ,
 1.45161201007     , 1.50006905612     , 1.5734843792      , 1.66992928695     ,
 1.76663982714     , 1.79514030299     , 1.69239598406     , 1.47990117766     ,
 1.26039408013     , 1.12950199685     , 1.10889279877     , 1.16106952279     ,
 1.24342121774     , 1.34127185787     , 1.46337493038     , 1.61332804397     ,
 1.76536643164     , 1.87600325381     , 1.92240116033     , 1.91806186879     ,
 1.89446055087     , 1.88838951868     , 1.94518320892     , 3.03684429059     ,
 3.45251892031     , 4.01184597826     , 4.66262384745     , 5.32757671394     ,
 5.93590653689     , 6.45515924153     , 6.88765503249     , 7.23121218489     ,
 7.45420793965     , 7.51907486294     , 7.4191649258      , 7.18342994611     ,
 6.8624749568      , 6.51994384751     , 6.21691538451     , 5.99452386464     ,
 5.88487538463     , 5.93068979807     , 6.15848051117     , 6.52223612062     ,
 6.91286367424     , 7.26390251147     , 7.63756641473     , 8.15934174546     ,
 8.84052618684     , 9.48802402204     , 9.83375812583     , 9.76872910857     ,
 9.43744484321     , 9.11042699793     , 8.9908570258      , 9.13857375128     ,
 9.53144131049     , 10.1433698728     , 10.9401043119     , 11.8306013349     ,
 12.6763658845     , 13.3735207054     , 13.9190705055     , 14.3948104184     ,
 14.9104957241     , 15.5879668437     , 16.5815459766     , 18.0439192197     ,
 20.0048760908     , 22.2948564503     , 24.6764360618     , 27.0938560975     ,
 29.7294287727     , 32.777486184      , 36.2416597845     , 40.0245071074     ,
 44.1694090579     , 48.9282321187     , 54.5843923924     , 61.288701457      ,
 69.1246629289     , 78.2596152813     , 88.9139618456     , 101.22711735      ,
 115.33055651      , 131.600155674     , 150.649002491     , 172.820400602     ,
 197.572475645     , 223.413244919     , 248.60092783      , 272.135735642     ,
 294.302487421     , 316.424372571     , 340.136259777     , 366.73245976      ,
 396.890563385     , 430.595347381     , 466.78185926      , 502.637047341     ,
 533.254920285     , 552.294135951     , 553.609841485     , 533.416722169     ,
 492.22761014      , 435.411715434     , 371.558146219     , 309.2809162       ,
 254.376805819     , 208.901410102     , 172.132959123     , 142.225070608     ,
 117.453062786     , 96.6896362717     , 79.3048409695     , 64.8854002222     ,
 53.0378927437     , 43.3021907048     , 35.1615563466     , 28.1661235619     ,
 22.0766829283     , 16.8818942246     , 12.6739599756     , 9.48471603965     ,
 7.18967095074     , 5.54619911461     , 4.32540944466     , 3.39537170017     ,
 2.69061040068     , 2.15630611234     , 1.74436833483     , 1.42960952228     ,
 1.20061229831     , 1.03681515872     , 0.904424388002    , 0.778438799971    ,
 0.664523105063    , 0.591456951989    , 0.581191842626    , 0.629879226883    ,
 0.711947165158    , 0.79177071393     , 0.836669373487    , 0.836253319644    ,
 0.814041598915    , 0.809462092528    , 0.840807726952    , 0.889358549541    ,
 0.927222345654    , 0.957337504308    , 1.00896504718     , 1.08793221507     ,
 1.15089961448     , 1.14398077537     , 1.05587236206     , 0.923048484044    ,
 0.795879045828    , 0.712985609033    , 0.699694360724    , 0.77042220539     ,
 0.919987429241    , 1.11783342002     , 1.3247818538      , 1.51998012682     ,
 1.70463409659     , 1.87534481659     , 2.00090259147     , 2.04191524088     ,
 2.00439235323     , 1.96103992341     , 1.99679673865     , 2.12810487525     ,
 2.28072444763     , 2.34737289555     , 2.27153357085     , 2.08452644535     ,
 1.86988637721     , 1.70269299963     , 1.62183205043     , 1.63117076895     ,
 1.70123691297     , 1.78355128967     , 1.85036144212     , 1.91326529064     ,
 1.97843003957     , 1.99767891186     , 1.90700056708     , 1.71722514883     ,
 1.52897950056     , 1.44501500163     , 1.4875462255      , 1.60342809516     ,
 1.72752020626     , 1.83305200629     , 1.93578172971     , 2.06111612321     ,
 2.20812814859     , 2.34826803622     , 2.45604815726     , 2.52838248909     ,
 2.58015989778     , 2.6446889865      , 2.77749649499     , 4.41042084696     ,
 4.97810224979     , 5.68569906536     , 6.4982802563      , 7.35068985007     ,
 8.15945061792     , 8.85435732782     , 9.396756244       , 9.76513577265     ,
 9.93596724432     , 9.89385618161     , 9.65394203299     , 9.26065927869     ,
 8.77441904895     , 8.26819163004     , 7.81872646292     , 7.49206197203     ,
 7.34787211855     , 7.44160165388     , 7.78047088363     , 8.26823343915     ,
 8.73653883074     , 9.07873975129     , 9.35429078192     , 9.72231844009     ,
 10.2456919246     , 10.7786630213     , 11.080468559      , 11.0420134247     ,
 10.7855239394     , 10.5529198328     , 10.5241140388     , 10.7405427818     ,
 11.1628198674     , 11.7527260556     , 12.4810820449     , 13.2855630795     ,
 14.0663626901     , 14.7447224444     , 15.3193314584     , 15.8559843329     ,
 16.4437290745     , 17.2017967103     , 18.3189452944     , 20.0012411563     ,
 22.2977647356     , 24.9875237574     , 27.7334261296     , 30.4035129321     ,
 33.1991470045     , 36.4433374785     , 40.3008721091     , 44.7421053739     ,
 49.735095866      , 55.4137396457     , 62.0501035913     , 69.916552821      ,
 79.2341355947     , 90.2156025104     , 103.046086283     , 117.807268593     ,
 134.538894992     , 153.450076831     , 174.956997387     , 199.263675385     ,
 225.713026946     , 252.586505473     , 277.843296747     , 300.44844911      ,
 321.193102208     , 342.241507372     , 365.84664269      , 393.312651558     ,
 424.730834601     , 459.130594        , 494.420604354     , 527.066576144     ,
 552.104224755     , 563.919535357     , 557.633550262     , 530.729634102     ,
 484.50586687      , 424.551336649     , 359.355370364     , 297.283258672     ,
 243.724834378     , 200.216427694     , 165.555668556     , 137.546199551     ,
 114.262672248     , 94.5547600693     , 77.9298396182     , 64.1452432312     ,
 52.8815823683     , 43.6473838802     , 35.8656501558     , 29.0577992112     ,
 23.0000968926     , 17.7248692433     , 13.3710544968     , 10.0046200776     ,
 7.52591407245     , 5.71629064271     , 4.36746221714     , 3.35670255507     ,
 2.61573130867     , 2.08159381312     , 1.69717458444     , 1.42553082979     ,
 1.23945810718     , 1.10422683201     , 0.981247188238    , 0.851608920923    ,
 0.732914622916    , 0.664856782611    , 0.673338432035    , 0.748826268308    ,
 0.854767178591    , 0.949184211304    , 1.00278006466     , 1.01145930252     ,
 0.998516246776    , 0.998592425235    , 1.03000879167     , 1.07988951954     ,
 1.12360415117     , 1.16074503578     , 1.21542922215     , 1.29158423359     ,
 1.34776293985     , 1.33446271757     , 1.24487287509     , 1.1157384276      ,
 0.991044969086    , 0.900938986424    , 0.868943415514    , 0.91775611141     ,
 1.05375928714     , 1.25085663153     , 1.46536980606     , 1.67264891234     ,
 1.87893168639     , 2.08840007808     , 2.26747731554     , 2.36427415732     ,
 2.37305105632     , 2.35887546446     , 2.39656981952     , 2.49099784618     ,
 2.56811708697     , 2.54005369603     , 2.37850858976     , 2.13528576954     ,
 1.90092899516     , 1.74875348201     , 1.71081875954     , 1.77813712057     ,
 1.90273118228     , 2.0192516458      , 2.09644874773     , 2.16048364583     ,
 2.23859147724     , 2.29065332597     , 2.2410036272      , 2.08447755504     ,
 1.92209953496     , 1.8734835778      , 1.97179303451     , 2.15138309259     ,
 2.3194293857      , 2.43005274036     , 2.50413882345     , 2.59397132498     ,
 2.73176426672     , 2.91008420453     , 3.10323946193     , 3.2936361316      ,
 3.48269656132     , 3.6980257436      , 3.99089180152     , 6.41167647483     ,
 7.17446840463     , 8.0215326626      , 8.95459839219     , 9.9480344563      ,
 10.9245433074     , 11.7740124578     , 12.3978371502     , 12.7404991249     ,
 12.7938528027     , 12.5897436338     , 12.1891306834     , 11.6606049813     ,
 11.0639087066     , 10.4569635377     , 9.90882495282     , 9.50259026323     ,
 9.33069478063     , 9.4643771813      , 9.88631845245     , 10.4458565138     ,
 10.9219556543     , 11.1808353747     , 11.2845992647     , 11.4190271534     ,
 11.6948960963     , 12.0305711611     , 12.2397816828     , 12.2222162201     ,
 12.059400102      , 11.9402472816     , 12.0125136111     , 12.3042506295     ,
 12.7626799544     , 13.3317949067     , 13.9767475716     , 14.6574904112     ,
 15.3159759108     , 15.9094239263     , 16.4520458949     , 17.0083478477     ,
 17.6617239051     , 18.537166566      , 19.8471315082     , 21.8201083307     ,
 24.4945964381     , 27.5956438758     , 30.7104775829     , 33.6511654683     ,
 36.631623793      , 40.0812566145     , 44.3177092904     , 49.4031062361     ,
 55.2763272815     , 61.9875434853     , 69.7914377646     , 79.0448083894     ,
 90.076201193      , 103.144458509     , 118.417769357     , 135.927032983     ,
 155.598128147     , 177.426399285     , 201.585770499     , 228.128101932     ,
 256.309915946     , 284.242387171     , 309.633552052     , 331.390325933     ,
 350.678093688     , 370.325056162     , 393.110927597     , 420.402153559     ,
 451.830149717     , 485.57239117      , 518.578503188     , 546.679858979     ,
 565.000763368     , 568.847914056     , 554.794182715     , 521.695640435     ,
 471.574689425     , 409.961359716     , 344.816661155     , 283.892054001     ,
 232.063523517     , 190.497302542     , 157.752114952     , 131.465156714     ,
 109.590799006     , 90.9593887512     , 75.1814600586     , 62.1422090671     ,
 51.5664103135     , 42.9294207167     , 35.6177099148     , 29.1439743914     ,
 23.2873239761     , 18.0876820234     , 13.7050614327     , 10.2400154467     ,
 7.63442949153     , 5.7105563962      , 4.28570470595     , 3.2372477478      ,
 2.48258476188     , 1.94984322807     , 1.58278444554     , 1.34390506696     ,
 1.19658690518     , 1.09417369877     , 0.993295193821    , 0.877826500755    ,
 0.769789531228    , 0.712439113347    , 0.735172700088    , 0.829847939605    ,
 0.956879064736    , 1.07073235704     , 1.14327911217     , 1.17316231388     ,
 1.18094292588     , 1.19483436478     , 1.23156958713     , 1.28310063921     ,
 1.32894574621     , 1.36781364665     , 1.42084148929     , 1.49069561887     ,
 1.53716241646     , 1.51450375441     , 1.42180997587     , 1.30028415303     ,
 1.19227125983     , 1.1213397113      , 1.10677562904     , 1.17349705236     ,
 1.3310630771      , 1.54825798013     , 1.76780132419     , 1.95619435031     ,
 2.12879377906     , 2.31371510213     , 2.49989077041     , 2.64320455237     ,
 2.7262823606      , 2.78462949722     , 2.85675777028     , 2.92600855087     ,
 2.9277577772      , 2.80770960258     , 2.57072383573     , 2.28343734191     ,
 2.03524678905     , 1.8930065647      , 1.88104265303     , 1.98063570208     ,
 2.13414120369     , 2.27227085205     , 2.3707938531      , 2.47177414743     ,
 2.61398567778     , 2.74908174657     , 2.77349239804     , 2.65679264321     ,
 2.50319203281     , 2.46305375127     , 2.59662122772     , 2.83351557923     ,
 3.04962429414     , 3.17168984659     , 3.22155297052     , 3.28015432283     ,
 3.41556877309     , 3.64235304499     , 3.938896356       , 4.28639744655     ,
 4.68796559734     , 5.16460082951     , 5.73793391638     , 9.22882040885     ,
 10.2272027761     , 11.1897888968     , 12.1696603512     , 13.2067813632     ,
 14.2595334322     , 15.199671209      , 15.8715019801     , 16.1703867982     ,
 16.0873139126     , 15.6995221488     , 15.1241648109     , 14.4645787255     ,
 13.7840643615     , 13.1226247323     , 12.5311451374     , 12.0916720756     ,
 11.9077699574     , 12.0521062233     , 12.4880739134     , 13.0362259106     ,
 13.4536667356     , 13.5965054313     , 13.5224519        , 13.4165836013     ,
 13.4092301599     , 13.4756958934     , 13.4996670834     , 13.4079601374     ,
 13.249053902      , 13.1622662614     , 13.2715123281     , 13.6001604868     ,
 14.0819812908     , 14.6353873902     , 15.2109901489     , 15.7827031764     ,
 16.3266960205     , 16.8332206922     , 17.3362640837     , 17.9100477804     ,
 18.6466757495     , 19.6822260222     , 21.233539386      , 23.5134720462     ,
 26.5290242297     , 29.9802927554     , 33.4454085306     , 36.7304000409     ,
 40.0480568826     , 43.8594474833     , 48.553832139      , 54.2694732394     ,
 60.9945961758     , 68.8105808954     , 78.006547778      , 88.9756713078     ,
 102.066082602     , 117.529907318     , 135.512875523     , 156.009945944     ,
 178.857350477     , 203.870394498     , 231.00411961      , 260.141605261     ,
 290.406502233     , 319.72795754      , 345.614556896     , 366.933446383     ,
 385.089969983     , 403.336404738     , 424.812924096     , 450.9496076       ,
 481.035241612     , 512.570849088     , 541.775480759     , 564.087003842     ,
 574.881634829     , 570.435115961     , 548.752447554     , 510.02670196      ,
 456.931023666     , 394.740709961     , 330.557553599     , 271.21341723      ,
 220.990089798     , 180.85240099      , 149.393647827     , 124.319775042     ,
 103.592497002     , 86.0220163171     , 71.2210067898     , 59.0798535412     ,
 49.2976113562     , 41.3184191628     , 34.5349903683     , 28.4884398267     ,
 22.9638248985     , 17.984352311      , 13.7056377634     , 10.2526159169     ,
 7.61128154087     , 5.64951022456     , 4.20947684134     , 3.16291268405     ,
 2.40863745536     , 1.86799856077     , 1.49357208661     , 1.25819163171     ,
 1.12707959139     , 1.04967527234     , 0.978506277982    , 0.892380697702    ,
 0.805469166031    , 0.755770362164    , 0.777042756226    , 0.872129693515    ,
 1.00886197355     , 1.14174307163     , 1.23996523592     , 1.29953839291     ,
 1.33610761368     , 1.3706585203      , 1.41536551102     , 1.46404631276     ,
 1.50255763041     , 1.53551603535     , 1.58632607658     , 1.65602566047     ,
 1.70083177786     , 1.67357580354     , 1.57827031332     , 1.46627096351     ,
 1.38769132994     , 1.36552577945     , 1.41215198391     , 1.54408256871     ,
 1.76088815364     , 2.01620068531     , 2.2345027373      , 2.37323435506     ,
 2.46082479303     , 2.56039381651     , 2.70243852061     , 2.86840696207     ,
 3.03185191696     , 3.18523836603     , 3.31740045604     , 3.3902425494      ,
 3.3566714561      , 3.19691265255     , 2.93725158923     , 2.64401241814     ,
 2.3980246808      , 2.26091180771     , 2.25369979755     , 2.35389096551     ,
 2.50337172347     , 2.63933812864     , 2.75055394899     , 2.89410116082     ,
 3.11567156434     , 3.35379130233     , 3.47170185494     , 3.4073995337      ,
 3.26393702908     , 3.22468415908     , 3.38589704283     , 3.68175511718     ,
 3.9597783821      , 4.1160131818      , 4.16924019938     , 4.22650523146     ,
 4.387728543       , 4.68544123743     , 5.1077954266      , 5.65497121285     ,
 6.35270254747     , 7.21401927953     , 8.20040810164     , 12.9149863982     ,
 14.1763159583     , 15.2290966492     , 16.1769223048     , 17.1398366106     ,
 18.1467702427     , 19.0974648098     , 19.808758441      , 20.1171059147     ,
 19.9726094745     , 19.4583845449     , 18.7278672863     , 17.9202314748     ,
 17.1228168538     , 16.3892739579     , 15.7699609411     , 15.3266024738     ,
 15.1281949654     , 15.2187030895     , 15.5596394087     , 15.9946727994     ,
 16.3018897635     , 16.3329610702     , 16.1164164655     , 15.8023224088     ,
 15.5119433471     , 15.2630301746     , 15.0111571764     , 14.7232273105     ,
 14.4306062985     , 14.2383833079     , 14.2614481613     , 14.5308689325     ,
 14.974918056      , 15.4910427293     , 16.0145765991     , 16.5222218452     ,
 17.0077480682     , 17.485093251      , 18.007660299      , 18.659711453      ,
 19.5396339931     , 20.7872701886     , 22.6043660042     , 25.1608787144     ,
 28.4267073769     , 32.1231634815     , 35.9069441225     , 39.650509022      ,
 43.5610150942     , 48.0350407205     , 53.4020659743     , 59.8098968113     ,
 67.3584449613     , 76.3088386953     , 87.0987370138     , 100.155271056     ,
 115.752433892     , 134.028789674     , 155.035714338     , 178.711415826     ,
 204.849055551     , 233.187737559     , 263.55236408      , 295.650789031     ,
 328.388128493     , 359.462095979     , 386.235962668     , 407.594934992     ,
 425.092313158     , 442.171602161     , 462.129504085     , 486.410386449     ,
 514.061448268     , 542.121910026     , 566.37165188      , 582.114812567     ,
 585.069413543     , 572.380556585     , 543.318173742     , 499.307030678     ,
 443.64073933      , 381.285531213     , 318.333547127     , 260.529168697     ,
 211.519592014     , 172.185410369     , 141.339521993     , 116.924330183     ,
 97.012859851      , 80.401018995      , 66.6182560252     , 55.452034061      ,
 46.5145462818     , 39.2151603279     , 32.9741947705     , 27.3804132142     ,
 22.2363932877     , 17.5530204782     , 13.4764495079     , 10.1424864857     ,
 7.56463865483     , 5.64159541559     , 4.23213820277     , 3.20450271417     ,
 2.44865044951     , 1.88801919727     , 1.48776112623     , 1.23372060746     ,
 1.09908268896     , 1.03611762952     , 0.993906198974    , 0.939418772598    ,
 0.87049851463     , 0.815899783869    , 0.81594002116     , 0.890678886292    ,
 1.02167430648     , 1.16595206888     , 1.28794323674     , 1.37790364755     ,
 1.44525037708     , 1.5020098899      , 1.55141113275     , 1.58630015737     ,
 1.60290212836     , 1.62008449043     , 1.66875238595     , 1.74738760653     ,
 1.80390930516     , 1.78429697228     , 1.6942531537      , 1.59730684873     ,
 1.55842058614     , 1.60621849676     , 1.74444696585     , 1.97095638238     ,
 2.26394726752     , 2.55813938044     , 2.76501642716     , 2.83975023382     ,
 2.82509417836     , 2.81749573317     , 2.89195522028     , 3.06254260868     ,
 3.29724540811     , 3.54502038273     , 3.74928357624     , 3.86135874542     ,
 3.85695740359     , 3.73888025429     , 3.53036363786     , 3.2772084433      ,
 3.04699389773     , 2.90375725543     , 2.87541965084     , 2.94360921356     ,
 3.05629411545     , 3.16185058767     , 3.26123878114     , 3.42092144957     ,
 3.69168118707     , 4.00828492294     , 4.21597857515     , 4.22717725386     ,
 4.1326172033      , 4.13002776783     , 4.3431415342      , 4.71874058438     ,
 5.09082196594     , 5.33351580793     , 5.46071626358     , 5.59454951312     ,
 5.85015581276     , 6.26476927544     , 6.83869600176     , 7.61150959738     ,
 8.65449259559     , 9.97752289407     , 11.4636383677     , 17.3306853546     ,
 18.8605893813     , 20.0036886909     , 20.8895982977     , 21.7059680806     ,
 22.5738016766     , 23.4734394849     , 24.2432249919     , 24.6674215964     ,
 24.6133827676     , 24.1077835415     , 23.2912636003     , 22.3235015755     ,
 21.3409791421     , 20.4625202511     , 19.7765929076     , 19.3143659741     ,
 19.061277048      , 18.9983744774     , 19.1057458905     , 19.3065366962     ,
 19.4382067467     , 19.3413511116     , 18.9855720167     , 18.4662307736     ,
 17.8916259561     , 17.3190571844     , 16.7674084881     , 16.2368589079     ,
 15.7415254854     , 15.3543964673     , 15.1832210017     , 15.2745796883     ,
 15.5715515581     , 15.9780949862     , 16.4311899237     , 16.9045572647     ,
 17.3906561475     , 17.9132227002     , 18.5386893363     , 19.3530475525     ,
 20.4492703461     , 21.9605565247     , 24.062372736      , 26.868829793      ,
 30.3139064035     , 34.1779797589     , 38.2686597497     , 42.5919404961     ,
 47.3597590452     , 52.8368586194     , 59.1809534987     , 66.4668694659     ,
 74.9176407389     , 85.0775649749     , 97.6533086093     , 113.156290133     ,
 131.735911595     , 153.301383746     , 177.69017062      , 204.718448847     ,
 234.16430148      , 265.794486761     , 299.397780176     , 334.518754351     ,
 369.805880246     , 402.733528791     , 430.6020491       , 452.377907051     ,
 469.689006182     , 485.956806645     , 504.409897747     , 526.416671145     ,
 550.885584577     , 574.65028134      , 593.34771793      , 602.334230192     ,
 597.641833375     , 577.071493469     , 540.907630717     , 491.677283093     ,
 433.330790484     , 370.631088392     , 308.70840426      , 252.189312744     ,
 204.05658785      , 165.125801166     , 134.476286089     , 110.336802287     ,
 90.9362687805     , 75.0760232389     , 62.1837805006     , 51.9081642313     ,
 43.7516186659     , 37.0812118749     , 31.3370961657     , 26.1488527031     ,
 21.3458522312     , 16.9491722415     , 13.1086374884     , 9.96104765613     ,
 7.52093287158     , 5.69037912477     , 4.33237025543     , 3.32109018919     ,
 2.55817662857     , 1.9815007287      , 1.56529853998     , 1.29862909039     ,
 1.15875896895     , 1.10382372509     , 1.08236136987     , 1.04913405359     ,
 0.985350873102    , 0.912427326772    , 0.878872477782    , 0.921346818391    ,
 1.03406314403     , 1.17723766384     , 1.31263457124     , 1.42675879958     ,
 1.52316960707     , 1.60218183665     , 1.65309053637     , 1.66486521427     ,
 1.64614812533     , 1.63455108801     , 1.67157310411     , 1.75479295119     ,
 1.82574477977     , 1.82452739207     , 1.7558049455      , 1.68977687805     ,
 1.702485107       , 1.82793259829     , 2.06109501053     , 2.37852037786     ,
 2.73559304562     , 3.05400016374     , 3.24440439184     , 3.26747312026     ,
 3.17449009807     , 3.08048113157     , 3.09457580933     , 3.26386811499     ,
 3.55806729225     , 3.89284801611     , 4.17887433267     , 4.36719702463     ,
 4.45424118686     , 4.44773470155     , 4.34519008868     , 4.15835195282     ,
 3.94230155095     , 3.77379446277     , 3.69929669988     , 3.71179568038     ,
 3.76783018387     , 3.82659544854     , 3.89682884231     , 4.04540857399     ,
 4.32366223436     , 4.67560823921     , 4.95687853658     , 5.07430293217     ,
 5.0960942505      , 5.20176740304     , 5.51915967242     , 6.01421326335     ,
 6.53403676775     , 6.95207404905     , 7.27605306207     , 7.61920657783     ,
 8.07849912279     , 8.67174384493     , 9.40885676976     , 10.3852753125     ,
 11.7396938452     , 13.4943217885     , 15.4612434402     , 22.29065629       ,
 24.0546390788     , 25.311443226      , 26.1767001569     , 26.8611219176     ,
 27.5667053596     , 28.3881269134     , 29.2380693484     , 29.8792570707     ,
 30.0793624486     , 29.7525288706     , 28.9657065181     , 27.8671483725     ,
 26.6515585181     , 25.5401510611     , 24.6958066222     , 24.1283541045     ,
 23.7219869253     , 23.3781682072     , 23.1047587486     , 22.9329250081     ,
 22.7789597853     , 22.4678510997     , 21.8983862396     , 21.1171051657     ,
 20.2408350087     , 19.3760007022     , 18.5880449111     , 17.8827519295     ,
 17.2362442953     , 16.6738550768     , 16.2808023592     , 16.1154162895     ,
 16.157954994      , 16.3596260384     , 16.6922746583     , 17.1354400827     ,
 17.6678592321     , 18.3013186108     , 19.0940545537     , 20.1198107303     ,
 21.4627467875     , 23.2535599382     , 25.6454271286     , 28.6979065147     ,
 32.3157563974     , 36.3582329781     , 40.8093367553     , 45.8232723055     ,
 51.6159055859     , 58.3121478441     , 65.8847135333     , 74.3112124604     ,
 83.9126966883     , 95.51883705       , 110.14395446      , 128.424169341     ,
 150.379818696     , 175.63265184      , 203.727046552     , 234.296194388     ,
 267.080506291     , 301.880484992     , 338.457990952     , 376.214629883     ,
 413.621486919     , 448.072955181     , 476.935014844     , 499.285208756     ,
 516.73727599      , 532.509664579     , 549.553156287     , 569.039298332     ,
 589.814947427     , 608.762746984     , 621.648626607     , 624.011267288     ,
 612.13551432      , 584.265416443     , 541.430216274     , 487.071772993     ,
 425.801318865     , 362.353413906     , 301.100932989     , 245.657271205     ,
 198.326698103     , 159.782987282     , 129.287430378     , 105.301293823     ,
 86.2080410766     , 70.8535451513     , 58.6067857184     , 49.0013942978     ,
 41.4381640395     , 35.2420699423     , 29.8666052109     , 24.9753783734     ,
 20.4275194608     , 16.2646113197     , 12.6454906075     , 9.70113995163     ,
 7.42912712686     , 5.71357704152     , 4.41143107669     , 3.41265143697     ,
 2.65019923316     , 2.08533318632     , 1.69154302304     , 1.44375821429     ,
 1.31378156451     , 1.26729771928     , 1.25842042686     , 1.23493511626     ,
 1.16587366363     , 1.06896781682     , 1.00086879707     , 1.00998887245     ,
 1.09762273694     , 1.22623952806     , 1.3594497445      , 1.48582359388     ,
 1.60589910933     , 1.70751086193     , 1.76343957796     , 1.75527801712     ,
 1.69952703541     , 1.64850839378     , 1.65445415375     , 1.72072467848     ,
 1.79374846293     , 1.81707578975     , 1.79392481747     , 1.78887094835     ,
 1.87231760838     , 2.07341770604     , 2.37915008669     , 2.75345539094     ,
 3.14126834595     , 3.46506075913     , 3.64585756069     , 3.65033799717     ,
 3.52425075736     , 3.38100796878     , 3.35192586678     , 3.51997701701     ,
 3.86947199309     , 4.29661278308     , 4.68668509182     , 4.98722787447     ,
 5.20246467693     , 5.33078870133     , 5.33857661673     , 5.20856671888     ,
 4.99226082668     , 4.78695949814     , 4.66303091223     , 4.6257753573      ,
 4.63682934361     , 4.6620005024      , 4.71335110403     , 4.84992813077     ,
 5.11619986456     , 5.47392739805     , 5.81790169006     , 6.07637735883     ,
 6.29213435148     , 6.59504255425     , 7.08960592456     , 7.76425758302     ,
 8.50711937771     , 9.21454134291     , 9.88333134312     , 10.5844088809     ,
 11.3569185294     , 12.177275736      , 13.0647268358     , 14.1796080653     ,
 15.7378261297     , 17.7888227474     , 20.1013614692     , 27.8427840275     ,
 29.7454587384     , 31.1183086359     , 32.0323159495     , 32.6641380677     ,
 33.2520154763     , 33.9990951131     , 34.9245153687     , 35.8140333483     ,
 36.3574677882     , 36.3373950888     , 35.7025544735     , 34.5486073004     ,
 33.1036229327     , 31.6822880256     , 30.5324078639     , 29.67527458       ,
 28.9351752452     , 28.1577331175     , 27.3719677203     , 26.6958198275     ,
 26.1138561558     , 25.4426493729     , 24.5278149767     , 23.3926027118     ,
 22.1899704223     , 21.0839829086     , 20.1638880166     , 19.4059311224     ,
 18.7244638235     , 18.0824041035     , 17.5249392954     , 17.1102996807     ,
 16.8664389461     , 16.8211763101     , 17.0110316713     , 17.4387787593     ,
 18.0668399161     , 18.8698374263     , 19.8646223582     , 21.0962117409     ,
 22.6487329394     , 24.6717347989     , 27.3170239601     , 30.6100718399     ,
 34.4478451447     , 38.7755824462     , 43.7221689492     , 49.5259229117     ,
 56.3673463418     , 64.2761206655     , 73.1509425376     , 82.955996289      ,
 94.0929801774     , 107.578760735     , 124.636074536     , 145.980553269     ,
 171.516449692     , 200.62930199      , 232.624820732     , 266.956239428     ,
 303.238738773     , 341.153695373     , 380.311143211     , 419.984496791     ,
 458.658640636     , 493.905300223     , 523.305095531     , 546.032820591     ,
 563.597670526     , 578.910150118     , 594.50865613      , 611.242626878     ,
 627.901254191     , 641.583981372     , 648.399237523     , 644.208285226     ,
 625.589169665     , 591.149631086     , 542.43460107      , 483.500397115     ,
 419.444099328     , 355.059736946     , 294.239855543     , 239.82861878      ,
 193.5027727       , 155.672003531     , 125.609325567     , 101.89688976      ,
 83.055810975      , 68.026763395      , 56.1818412713     , 46.9789879567     ,
 39.7401402754     , 33.7722418648     , 28.5687221604     , 23.8439696904     ,
 19.4825728888     , 15.5232220561     , 12.1091959779     , 9.35614422169     ,
 7.2462094834      , 5.6451779711      , 4.40131815111     , 3.42353106908     ,
 2.68367256087     , 2.16772840539     , 1.83873822685     , 1.64413255294     ,
 1.54338472497     , 1.51161929468     , 1.51436846489     , 1.49774070596     ,
 1.42211371008     , 1.30315195552     , 1.20470584782     , 1.18327640293     ,
 1.24272544723     , 1.3458150374      , 1.460439648       , 1.58216968697     ,
 1.71320837554     , 1.83326702218     , 1.90209051102     , 1.89183853045     ,
 1.8164695023      , 1.73083143745     , 1.69470891215     , 1.72634986968     ,
 1.79204547539     , 1.85024534351     , 1.9032338559      , 1.99678867136     ,
 2.17456256514     , 2.44496692583     , 2.78711266339     , 3.16799982356     ,
 3.54341823224     , 3.85324183718     , 4.03487248205     , 4.05428088651     ,
 3.93543641882     , 3.77386485795     , 3.71615079485     , 3.88642879013     ,
 4.29721336901     , 4.83767367362     , 5.36733426956     , 5.81305494718     ,
 6.16423786739     , 6.40142696728     , 6.47465371809     , 6.36435929416     ,
 6.13739174266     , 5.91443625196     , 5.78175292302     , 5.74549256405     ,
 5.76232795059     , 5.7990800395      , 5.86791079968     , 6.01368301613     ,
 6.26767969214     , 6.61691806037     , 7.02195128193     , 7.46030110545     ,
 7.95352659111     , 8.55969605791     , 9.3342655628      , 10.2816016939     ,
 11.344005956      , 12.4533859491     , 13.587120008      , 14.7468777153     ,
 15.8938403064     , 16.9648907342     , 17.9969232837     , 19.2071446941     ,
 20.8679205738     , 23.0500189409     , 25.5087495523     , 34.4269819976     ,
 36.3176895473     , 37.7519642474     , 38.7571422388     , 39.4372064635     ,
 40.0029193579     , 40.7077883077     , 41.6593763657     , 42.7006256296     ,
 43.5041713055     , 43.7647177223     , 43.3154039579     , 42.1643530723     ,
 40.5141753915     , 38.7123993732     , 37.0677196987     , 35.6565353375     ,
 34.3337126475     , 32.9546073576     , 31.557228315      , 30.2827391545     ,
 29.1412079635     , 27.9523946407     , 26.549257874      , 24.9677309528     ,
 23.4154559556     , 22.1090665674     , 21.135031594      , 20.4135967932     ,
 19.7899254575     , 19.1674662662     , 18.5470103872     , 17.9763194827     ,
 17.5254905627     , 17.2993448999     , 17.4034611827     , 17.8723414744     ,
 18.6551364164     , 19.6747654092     , 20.8829365665     , 22.2850655316     ,
 23.97520215       , 26.1444316292     , 28.97424745       , 32.4961672211     ,
 36.6339438414     , 41.4118142567     , 47.0295024397     , 53.6990090385     ,
 61.507021741      , 70.4570121018     , 80.5473561226     , 91.8839073934     ,
 104.962376068     , 120.841300897     , 140.744611907     , 165.331254218     ,
 194.408782038     , 227.290845131     , 263.239828283     , 301.594687333     ,
 341.696241258     , 382.822512017     , 424.209927618     , 465.007225641     ,
 503.93570356      , 539.009131077     , 568.146158617     , 590.591896553     ,
 607.704965432     , 622.08796152      , 635.848318608     , 649.438230089     ,
 661.532333687     , 669.479362254     , 669.838210756     , 658.949333303     ,
 633.866773608     , 593.660955621     , 540.251370415     , 477.93088151      ,
 411.908868951     , 346.947217303     , 286.685820234     , 233.505733626     ,
 188.579102599     , 151.955982185     , 122.757673462     , 99.5891914069     ,
 81.0982113738     , 66.3513734671     , 54.755736986      , 45.7199200195     ,
 38.5254326786     , 32.518914028      , 27.2924513254     , 22.6415175384     ,
 18.4601499869     , 14.7330128316     , 11.5396523229     , 8.96692370549     ,
 6.99843905796     , 5.5018218995      , 4.32342053353     , 3.38668951187     ,
 2.69491247485     , 2.25277629806     , 2.00939610014     , 1.88352357233     ,
 1.82253412065     , 1.81169619985     , 1.82911660523     , 1.82117894874     ,
 1.74136351987     , 1.60331028261     , 1.47670585514     , 1.42483289159     ,
 1.45308903681     , 1.52332639615     , 1.60702813409     , 1.70763469363     ,
 1.83237115484     , 1.95988074665     , 2.04566589778     , 2.05541103121     ,
 1.992394819       , 1.90085647428     , 1.84162142946     , 1.85142659381     ,
 1.92368968471     , 2.03616966562     , 2.1899635652      , 2.40623160239     ,
 2.69031640283     , 3.01843213801     , 3.36053118966     , 3.69888363237     ,
 4.01779152682     , 4.28713391511     , 4.46441456375     , 4.511666182       ,
 4.42425429621     , 4.27190863785     , 4.20875705928     , 4.39592555649     ,
 4.87916652204     , 5.55240240377     , 6.25269618126     , 6.86998943693     ,
 7.35445795285     , 7.6613185571      , 7.7457426884      , 7.62211506642     ,
 7.3968976622      , 7.2117944321      , 7.14765921376     , 7.18998830219     ,
 7.28094072113     , 7.38861900114     , 7.52425011395     , 7.71015891521     ,
 7.95798034778     , 8.29061266948     , 8.76253531513     , 9.42776740817     ,
 10.2943060561     , 11.3342460561     , 12.5295689295     , 13.8799719177     ,
 15.3720960177     , 16.9688297342     , 18.6210592611     , 20.2606344333     ,
 21.7932371408     , 23.1515102189     , 24.3993424424     , 25.7711365981     ,
 27.5318902897     , 29.7377554269     , 32.1532510917     , 42.6944567801     ,
 44.4146425253     , 45.8243033193     , 46.9378726675     , 47.7785066548     ,
 48.461198808      , 49.1842471021     , 50.0671171878     , 51.0178852711     ,
 51.7794663075     , 52.0644572064     , 51.6483443602     , 50.4365514114     ,
 48.5375998487     , 46.2536560215     , 43.9159664154     , 41.6897830314     ,
 39.5478903368     , 37.4241021235     , 35.3534631744     , 33.4264262526     ,
 31.6222312261     , 29.7740045393     , 27.753782432      , 25.6510592967     ,
 23.7325481747     , 22.2427323992     , 21.2362492404     , 20.5684900067     ,
 20.0306809512     , 19.4878429602     , 18.9060639629     , 18.3179972384     ,
 17.818491181      , 17.5627729707     , 17.7020438894     , 18.2940471653     ,
 19.2780553079     , 20.5306521802     , 21.9430770998     , 23.4856856365     ,
 25.2654144366     , 27.5224192884     , 30.4946196701     , 34.2641125479     ,
 38.8090812057     , 44.2036207001     , 50.6359952435     , 58.2099232049     ,
 66.8957884137     , 76.7319645328     , 87.9394818494     , 100.884183251     ,
 116.17988741      , 134.809107136     , 157.796614878     , 185.607789226     ,
 217.999911112     , 254.428256643     , 294.336788647     , 337.003650489     ,
 381.312559102     , 425.833808011     , 469.209205459     , 510.450755061     ,
 548.669987115     , 582.497822148     , 610.279926156     , 631.342198259     ,
 646.906644898     , 659.335686949     , 670.394344871     , 680.183202782     ,
 687.238273064     , 689.087178046     , 682.694066248     , 664.953693399     ,
 633.607583486     , 588.390810101     , 531.57972387      , 467.406008582     ,
 400.794170848     , 336.249346138     , 277.215465985     , 225.802453399     ,
 182.790438293     , 147.85191414      , 119.9072031       , 97.573689766      ,
 79.6302504526     , 65.2542065097     , 53.8673444274     , 44.8427490932     ,
 37.4817131709     , 31.2495988977     , 25.894556547      , 21.3061890095     ,
 17.3586225768     , 13.9311213172     , 10.9968417315     , 8.60338123448     ,
 6.75582479287     , 5.35134690196     , 4.24744728623     , 3.37453652683     ,
 2.75005648063     , 2.3868502675      , 2.22316287375     , 2.15866104253     ,
 2.13386593507     , 2.14206378068     , 2.17019534933     , 2.16557197413     ,
 2.07864983498     , 1.92227527653     , 1.7687160937      , 1.68466269004     ,
 1.67723742123     , 1.70948428532     , 1.75701552998     , 1.82943277782     ,
 1.93757931705     , 2.06173714138     , 2.16116684968     , 2.20378116746     ,
 2.1848191053      , 2.1328603583      , 2.10118401807     , 2.13646439032     ,
 2.25093855515     , 2.43486891765     , 2.68713797982     , 3.01036974788     ,
 3.37932546296     , 3.74159173082     , 4.05791916699     , 4.3254290189      ,
 4.5566188967      , 4.75178931273     , 4.89372502675     , 4.95251124441     ,
 4.90722810793     , 4.80236799113     , 4.78275855421     , 5.02311981539     ,
 5.59281929904     , 6.40184986602     , 7.28089687739     , 8.0843557604      ,
 8.71109581        , 9.08352217191     , 9.17162859573     , 9.04479759319     ,
 8.86256729002     , 8.7794547417      , 8.84814352374     , 9.01863767011     ,
 9.22445743777     , 9.45031478207     , 9.70990357823     , 9.98894347168     ,
 10.2656109789     , 10.6046289447     , 11.1777113597     , 12.1371782328     ,
 13.4852166631     , 15.1014188235     , 16.87600915       , 18.7776890068     ,
 20.8103358813     , 22.9473340353     , 25.1103004874     , 27.193157403      ,
 29.1111261898     , 30.849552305      , 32.4963470176     , 34.2298213588     ,
 36.2097592598     , 38.422398242      , 40.6615390687     , 53.085331754      ,
 54.5349878183     , 55.8691286569     , 57.1228049725     , 58.2459385328     ,
 59.1984429552     , 60.0078193585     , 60.7064840585     , 61.2565264075     ,
 61.555042553      , 61.4510048823     , 60.7388323361     , 59.2244051502     ,
 56.8807030834     , 53.9269690186     , 50.707881428      , 47.4948264233     ,
 44.4073106424     , 41.4719280153     , 38.6966189282     , 36.0689441422     ,
 33.5045660845     , 30.8713349136     , 28.134670119      , 25.4705829394     ,
 23.1881871362     , 21.5161553573     , 20.4504007834     , 19.7916148512     ,
 19.3093371775     , 18.8600297804     , 18.3909776574     , 17.9171348065     ,
 17.533035281      , 17.4047407792     , 17.6951348265     , 18.4699738318     ,
 19.6625716985     , 21.1239617796     , 22.7154842713     , 24.3943022576     ,
 26.2788466215     , 28.6462122498     , 31.7965618389     , 35.8871770859     ,
 40.9537619601     , 47.0765857863     , 54.3830057641     , 62.8720284184     ,
 72.4438189024     , 83.1981933725     , 95.5677422787     , 110.165960178     ,
 127.719466884     , 149.099191714     , 175.066567803     , 205.876908907     ,
 241.327754945     , 281.165719713     , 325.109479316     , 372.336116073     ,
 421.114180459     , 469.118747049     , 514.2737408       , 555.421123497     ,
 592.084335954     , 623.56606018      , 648.722642319     , 667.037022771     ,
 679.634291761     , 688.694799436     , 695.792654747     , 700.881206733     ,
 702.467822385     , 698.181265107     , 685.203978884     , 660.86861068      ,
 623.655295547     , 574.110522278     , 514.956428202     , 450.297558972     ,
 384.575992801     , 321.820903763     , 265.141184866     , 216.33556785      ,
 175.811678588     , 142.921870172     , 116.477413147     , 95.1931029617     ,
 77.9967371508     , 64.127905202      , 52.9790885957     , 43.9065447514     ,
 36.300374246      , 29.80705751       , 24.3478245334     , 19.8847275443     ,
 16.2406378546     , 13.167040852      , 10.5195658999     , 8.30590876616     ,
 6.56425997314     , 5.2409684214      , 4.21742278021     , 3.42485013742     ,
 2.8767543324      , 2.58361506035     , 2.47912992046     , 2.45694891478     ,
 2.45602720071     , 2.47302050858     , 2.49861966039     , 2.48369863626     ,
 2.38328247445     , 2.2120815693      , 2.03849795311     , 1.92422153395     ,
 1.87683571427     , 1.86637397822     , 1.8778198086      , 1.9262419152      ,
 2.02084943107     , 2.13924440753     , 2.24650221182     , 2.32261484192     ,
 2.36707950501     , 2.39802359605     , 2.45344582698     , 2.57207348111     ,
 2.76494674989     , 3.02047538665     , 3.33310948264     , 3.70067918136     ,
 4.09276832585     , 4.45149776753     , 4.7347852588      , 4.94032766439     ,
 5.0839710633      , 5.17912408947     , 5.23904001277     , 5.26957533926     ,
 5.26476304464     , 5.2530209474      , 5.34788758377     , 5.70193627946     ,
 6.38607650047     , 7.33031014279     , 8.3793900966      , 9.37249619557     ,
 10.1683630291     , 10.6572468668     , 10.8157036337     , 10.7546855445     ,
 10.6719246263     , 10.7206623776     , 10.9182844329     , 11.1894337665     ,
 11.4874955838     , 11.844005409      , 12.2856975575     , 12.7485193423     ,
 13.1568039755     , 13.6061987251     , 14.384743918      , 15.7453882432     ,
 17.689858102      , 20.0136596771     , 22.5171252867     , 25.122197289      ,
 27.8169376148     , 30.5507646682     , 33.2094114943     , 35.6929000766     ,
 38.0039296298     , 40.237078677      , 42.4930197346     , 44.8169576582     ,
 47.169117687      , 49.4167258449     , 51.4061075929     , 65.5415205047     ,
 66.7296177527     , 68.0163623109     , 69.4636762362     , 70.9558521975     ,
 72.2712216492     , 73.2005892337     , 73.6260168572     , 73.5480684097     ,
 73.0552585879     , 72.1893755429     , 70.8012448876     , 68.6086768377     ,
 65.4630298576     , 61.540410202      , 57.2444545176     , 52.9614855926     ,
 48.9183094969     , 45.1760684086     , 41.6715260168     , 38.2728060877     ,
 34.8468901699     , 31.3391962323     , 27.8520245113     , 24.6516636168     ,
 22.0453726088     , 20.1939755577     , 19.0197019574     , 18.2940222949     ,
 17.8024551279     , 17.4217892587     , 17.0957003814     , 16.8169065041     ,
 16.6510883272     , 16.7368688541     , 17.2227613239     , 18.175842468      ,
 19.5336216048     , 21.1491304472     , 22.8928653659     , 24.7373746013     ,
 26.8097370344     , 29.3963191026     , 32.8362569616     , 37.3537913072     ,
 43.0246824116     , 49.9021683957     , 58.0566446652     , 67.4649365634     ,
 78.0523362161     , 89.9706337784     , 103.732827386     , 120.053373926     ,
 139.709797753     , 163.500759827     , 192.039241121     , 225.524781952     ,
 263.914325809     , 307.241349133     , 355.368993613     , 407.223493378     ,
 460.391346287     , 511.6726514       , 558.302443626     , 598.906354611     ,
 633.306474017     , 661.419881401     , 682.693125237     , 696.88492101      ,
 705.056762479     , 709.224830447     , 710.938754873     , 710.306768092     ,
 706.041561366     , 695.87904884      , 677.027350396     , 647.006512887     ,
 604.846784225     , 551.840022538     , 491.216420786     , 427.075129634     ,
 363.429614933     , 303.733554001     , 250.553324837     , 205.199246085     ,
 167.664910591     , 137.074197325     , 112.270412473     , 92.1625922128     ,
 75.8395807606     , 62.5675406366     , 51.6967631195     , 42.6040669077     ,
 34.8174966375     , 28.1739578221     , 22.7304734815     , 18.4762350976     ,
 15.1687213362     , 12.4513619001     , 10.0874465275     , 8.05265948802     ,
 6.41450918293     , 5.16945734788     , 4.2281785812      , 3.5202644625      ,
 3.04465277417     , 2.80445292575     , 2.73646815835     , 2.73924163017     ,
 2.75267278664     , 2.771633111       , 2.78707613263     , 2.75682613803     ,
 2.64647565009     , 2.47303991119     , 2.29357649146     , 2.15617282653     ,
 2.06752861921     , 2.01087073476     , 1.98709265618     , 2.01791590403     ,
 2.10709784722     , 2.22412008323     , 2.33703982972     , 2.44214361447     ,
 2.55413255526     , 2.68943453475     , 2.86737017494     , 3.10357038914     ,
 3.39017498125     , 3.70080638148     , 4.02118762134     , 4.35503761454     ,
 4.69577002119     , 5.0140578845      , 5.27830206309     , 5.46616868176     ,
 5.5568347822      , 5.54716074751     , 5.48255294172     , 5.43578502795     ,
 5.45345929028     , 5.56497011318     , 5.84021521185     , 6.38144288174     ,
 7.23600540873     , 8.34269757603     , 9.56677407494     , 10.7549470204     ,
 11.7546403565     , 12.43948299       , 12.7782818393     , 12.8831622372     ,
 12.9492080197     , 13.1128178131     , 13.3705132309     , 13.6528211596     ,
 13.9668938883     , 14.4203429935     , 15.0736337649     , 15.8213901606     ,
 16.5260980089     , 17.2864329122     , 18.4654042685     , 20.3848249262     ,
 23.0471572262     , 26.1953317877     , 29.5725620521     , 33.0582285419     ,
 36.5922829878     , 40.0526266008     , 43.2640238331     , 46.151384837      ,
 48.850971088      , 51.6033900963     , 54.5254472135     , 57.5005022519     ,
 60.2531665852     , 62.5218411679     , 64.2310428064     , 79.5793483485     ,
 80.6465477378     , 81.9944919253     , 83.683963196      , 85.5468801715     ,
 87.2106709616     , 88.2475911039     , 88.3846761588     , 87.6381382912     ,
 86.2517290493     , 84.4202196124     , 82.0300871402     , 78.7342667106     ,
 74.3356132243     , 69.0646545039     , 63.4560479561     , 58.0142680672     ,
 53.0094881143     , 48.4570216996     , 44.1803717861     , 39.9395686664     ,
 35.5967659654     , 31.2196070937     , 27.0611902696     , 23.4434765297     ,
 20.6086493943     , 18.6063675442     , 17.2892253628     , 16.4324028092     ,
 15.8676400175     , 15.5102626624     , 15.3097243015     , 15.2318760758     ,
 15.2915470026     , 15.5746865611     , 16.2045283491     , 17.2562560963     ,
 18.6916380826     , 20.3952682684     , 22.2781267229     , 24.3469068673     ,
 26.7297705732     , 29.6880444744     , 33.5572695684     , 38.5975394771     ,
 44.9058133176     , 52.5026548431     , 61.4383003917     , 71.7645659496     ,
 83.5280460014     , 96.9223268048     , 112.39615324      , 130.573565521     ,
 152.167955872     , 177.948181178     , 208.582814255     , 244.47313306      ,
 285.851315951     , 332.889332204     , 385.288530073     , 441.519258455     ,
 498.538184162     , 552.496619286     , 600.118599321     , 639.780268022     ,
 671.401565769     , 695.357358668     , 711.708862351     , 720.601832746     ,
 723.087470463     , 721.052014162     , 716.16301712      , 708.917777318     ,
 698.426375425     , 682.615419152     , 658.706162484     , 624.276305623     ,
 578.637985791     , 523.528232555     , 462.538263679     , 399.824830985     ,
 339.103778344     , 283.279773684     , 234.282299        , 192.84343969      ,
 158.557355499     , 130.410501255     , 107.354174527     , 88.5091095886     ,
 73.112231805      , 60.4609177204     , 49.9027172938     , 40.8818928025     ,
 33.0739910943     , 26.4615098022     , 21.1678240282     , 17.166397663      ,
 14.1624241193     , 11.7447173978     , 9.63246244838     , 7.77970806815     ,
 6.26378999912     , 5.11143786982     , 4.25642550381     , 3.62708349438     ,
 3.20800361725     , 2.99815016882     , 2.94583057427     , 2.96206640465     ,
 2.98873234267     , 3.01599320187     , 3.03343052381     , 3.0052371615      ,
 2.90496582593     , 2.74759438272     , 2.57578693969     , 2.42385938077     ,
 2.29932204059     , 2.20003283399     , 2.14285538602     , 2.15613916395     ,
 2.23968111395     , 2.35602302947     , 2.47403213765     , 2.60269989277     ,
 2.77210165582     , 3.00075693338     , 3.29104573626     , 3.63313909835     ,
 3.99738269606     , 4.34035540647     , 4.63571864599     , 4.89385717383     ,
 5.14651483861     , 5.4165944886      , 5.69391090962     , 5.91957405512     ,
 6.00336675433     , 5.90130835035     , 5.68959528605     , 5.52658367036     ,
 5.53699665088     , 5.77043985356     , 6.26003278591     , 7.05179878745     ,
 8.15175084578     , 9.48409465511     , 10.9206398615     , 12.3238927622     ,
 13.5565007664     , 14.4985119887     , 15.1058595361     , 15.4552610901     ,
 15.6999700163     , 15.9516456767     , 16.2090179013     , 16.4323508736     ,
 16.6906175479     , 17.176379106      , 18.0154983981     , 19.1085285852     ,
 20.2807701366     , 21.6017626788     , 23.4328064246     , 26.101192647      ,
 29.6074957427     , 33.6923993141     , 38.0983455091     , 42.6819984189     ,
 47.3072013218     , 51.726995382      , 55.6585759716     , 59.0230578805     ,
 62.0751132977     , 65.2042074143     , 68.5725964587     , 71.9541513092     ,
 74.9020025565     , 77.0840803585     , 78.5277940276     , 94.5909020035     ,
 95.7976347918     , 97.377907577      , 99.3546328554     , 101.540682289     ,
 103.491460209     , 104.632542648     , 104.554914113     , 103.24459132      ,
 101.008688086     , 98.1014706391     , 94.4092984713     , 89.5739074364     ,
 83.4592226971     , 76.4457850487     , 69.2395715757     , 62.4537014286     ,
 56.3678733418     , 50.920569031      , 45.8148529124     , 40.721530954      ,
 35.5245426689     , 30.4231790941     , 25.7963884707     , 21.9658761536     ,
 19.0522379185     , 16.9732402758     , 15.5316165902     , 14.5357827682     ,
 13.8763217239     , 13.506239722      , 13.3804534662     , 13.4391248509     ,
 13.6440090482     , 14.0255683144     , 14.6849140907     , 15.7180911926     ,
 17.1329791702     , 18.8692559584     , 20.8927206386     , 23.2453787818     ,
 26.0451421263     , 29.5011471425     , 33.9049182083     , 39.5198069122     ,
 46.4604029406     , 54.7355560319     , 64.4056851208     , 75.6387436306     ,
 88.6528941287     , 103.70700609      , 121.13710059      , 141.355624991     ,
 164.884051452     , 192.434694591     , 224.870466841     , 263.014431015     ,
 307.461753117     , 358.341288442     , 414.865509453     , 474.868238677     ,
 534.810554694     , 590.530623946     , 638.503689882     , 676.855413841     ,
 705.38517465      , 724.703265        , 735.424572826     , 738.170712664     ,
 734.116074773     , 725.132105895     , 713.079762816     , 698.850620999     ,
 681.913177909     , 660.435756019     , 631.863751376     , 594.028946657     ,
 546.451832798     , 490.959654785     , 431.117267771     , 370.938633757     ,
 313.834203329     , 262.232776032     , 217.516920741     , 179.953792126     ,
 148.865468959     , 123.180129537     , 101.943447694     , 84.422084828      ,
 69.9668495949     , 57.9385596473     , 47.7426422474     , 38.920854388      ,
 31.2690754012     , 24.8484102112     , 19.7843582077     , 16.01279928       ,
 13.2199842448     , 11.0053210257     , 9.09621475402     , 7.43365501348     ,
 6.0770040827      , 5.05046049087     , 4.29511094645     , 3.7388776476      ,
 3.35924237596     , 3.15842466992     , 3.10285462958     , 3.12126081909     ,
 3.16044314744     , 3.20720211105     , 3.24881527281     , 3.24936672985     ,
 3.17989385099     , 3.04818284084     , 2.88848229197     , 2.731694215       ,
 2.58933748709     , 2.46663619482     , 2.38571305949     , 2.37698197423     ,
 2.44158085457     , 2.54463713063     , 2.65965996525     , 2.80272553439     ,
 3.01014313146     , 3.29769091588     , 3.65270409759     , 4.04749852225     ,
 4.44281938504     , 4.79090163019     , 5.05887269972     , 5.25923374013     ,
 5.45387488076     , 5.71258944198     , 6.04245386398     , 6.34202018851     ,
 6.44676282619     , 6.27055824263     , 5.91884238739     , 5.63150120733     ,
 5.61171417573     , 5.94224663062     , 6.64133297719     , 7.71330605583     ,
 9.11635989451     , 10.7370648795     , 12.4329788792     , 14.0781179955     ,
 15.5611951899     , 16.7821310607     , 17.6869855827     , 18.3074278897     ,
 18.7463701392     , 19.0972464375     , 19.3729581682     , 19.5564922789     ,
 19.7515528354     , 20.2230567365     , 21.1974916997     , 22.6521647478     ,
 24.4233549465     , 26.5268401509     , 29.2413213012     , 32.8331227436     ,
 37.2981589063     , 42.4223551702     , 47.9998939121     , 53.8870428557     ,
 59.8549626385     , 65.4920538348     , 70.3602281274     , 74.3167582888     ,
 77.6657639571     , 80.9064892513     , 84.2821890048     , 87.5760530738     ,
 90.3326522904     , 92.2761592332     , 93.5511972166     , 110.156048275     ,
 111.811368926     , 113.826440699     , 116.178028701     , 118.701964126     ,
 120.949687978     , 122.25231614      , 122.062028951     , 120.272908161     ,
 117.165381658     , 112.986106581     , 107.629218307     , 100.815164086     ,
 92.5752231456     , 83.484256579      , 74.398155521      , 66.012508811      ,
 58.6278230691     , 52.1439628399     , 46.1786525358     , 40.3257433398     ,
 34.4731177632     , 28.9071622844     , 24.0765554391     , 20.2559159303     ,
 17.4233401315     , 15.3741319814     , 13.8865785632     , 12.8168343611     ,
 12.1039207937     , 11.7171832575     , 11.6080297739     , 11.7022766818     ,
 11.9316739824     , 12.292817357      , 12.8771184812     , 13.8074539774     ,
 15.1438885211     , 16.8855411161     , 19.0495837341     , 21.7058810175     ,
 24.95801478       , 28.9542813219     , 33.9174987896     , 40.0924900515     ,
 47.6277194962     , 56.5636072353     , 66.9832866962     , 79.1353546494     ,
 93.3849096086     , 110.091928521     , 129.540028446     , 151.936737097     ,
 177.540440481     , 206.920517386     , 241.118620636     , 281.440289882     ,
 328.876574096     , 383.416829145     , 443.603485734     , 506.545901664     ,
 568.345035633     , 624.816996126     , 672.425102541     , 709.073712002     ,
 734.284340249     , 748.70224314      , 753.405835373     , 749.585688089     ,
 738.747707737     , 722.901685546     , 704.063240746     , 683.286340814     ,
 660.12869286      , 632.941097596     , 599.668581613     , 558.819195273     ,
 510.330298969     , 455.935781486     , 398.741748783     , 342.220950361     ,
 289.299782987     , 241.985003241     , 201.305465529     , 167.287247837     ,
 139.148818374     , 115.818508796     , 96.387704073      , 80.18663651       ,
 66.6495233926     , 55.2370085139     , 45.458212546      , 36.9533761076     ,
 29.5932638868     , 23.4590318312     , 18.6399590162     , 15.0342282892     ,
 12.3463014679     , 10.2397444418     , 8.48879424087     , 7.02486355645     ,
 5.8639706879      , 4.99788172602     , 4.36021119441     , 3.88008390246     ,
 3.53447464902     , 3.33167706194     , 3.25682130521     , 3.26002277258     ,
 3.29984316375     , 3.3647714483      , 3.43817002766     , 3.47488807907     ,
 3.43383892434     , 3.31689438917     , 3.16382091714     , 3.0155331014      ,
 2.88673089765     , 2.77526517722     , 2.69141320216     , 2.65922843586     ,
 2.685420211       , 2.75034498723     , 2.84313980644     , 2.9877717356      ,
 3.21760808646     , 3.5343686432      , 3.90515422097     , 4.28970634103     ,
 4.65551461795     , 4.97363827914     , 5.22329213537     , 5.41895596877     ,
 5.62918779369     , 5.93702637373     , 6.34575188282     , 6.71725815408     ,
 6.83939785774     , 6.60724473623     , 6.1526739509      , 5.77009138332     ,
 5.71719206727     , 6.11320040248     , 6.98724250876     , 8.32416704153     ,
 10.0356626362     , 11.9579480517     , 13.9250583825     , 15.8229796617     ,
 17.567605515      , 19.0727172009     , 20.2697174452     , 21.1558796697     ,
 21.8071858122     , 22.3148312236     , 22.6986686989     , 22.9364946334     ,
 23.1350881839     , 23.6186847388     , 24.7357016928     , 26.5862704712     ,
 29.0496790923     , 32.0740945788     , 35.8115134794     , 40.4370337802     ,
 45.9440032038     , 52.1822974023     , 59.015710859      , 66.3109059342     ,
 73.7486433111     , 80.7477914885     , 86.6966619034     , 91.337211124      ,
 94.9364713438     , 98.0300913896     , 100.956631515     , 103.647232704     ,
 105.846531219     , 107.4808339       , 108.793443351     , 126.246675983     ,
 128.596589879     , 131.238725302     , 134.13289692      , 137.141500313     ,
 139.796620402     , 141.319541648     , 141.004665081     , 138.622736635     ,
 134.396612158     , 128.569632885     , 121.108124497     , 111.911489066     ,
 101.245498094     , 89.8665610489     , 78.7180923728     , 68.5400618894     ,
 59.6785836934     , 52.0597146695     , 45.2723597537     , 38.8438716909     ,
 32.6172272471     , 26.8796797292     , 22.0773001668     , 18.4189064877     ,
 15.7690223822     , 13.8413103759     , 12.412098455      , 11.3777229218     ,
 10.6945668604     , 10.3157715777     , 10.1789303113     , 10.2158339009     ,
 10.3677108196     , 10.6326740471     , 11.1053175582     , 11.9259679446     ,
 13.1885805619     , 14.9348320297     , 17.2217912295     , 20.1459231693     ,
 23.8070501782     , 28.3011739971     , 33.7720798956     , 40.4331878328     ,
 48.492668204      , 58.0806949652     , 69.3181970522     , 82.4620242715     ,
 97.9320372962     , 116.180506427     , 137.526893019     , 162.080891849     ,
 189.878974487     , 221.286520636     , 257.387121936     , 299.835129944     ,
 349.960973685     , 407.637940709     , 470.784979496     , 535.825664712     ,
 598.562622067     , 654.897556056     , 701.395803673     , 735.80434085      ,
 757.356799098     , 766.669627947     , 765.251717481     , 754.951297578     ,
 737.766909847     , 715.900451879     , 691.367019746     , 665.094652014     ,
 636.464305308     , 603.907845602     , 566.007056074     , 522.252984167     ,
 473.269477401     , 420.729833916     , 367.049215847     , 314.836739251     ,
 266.349360006     , 223.207774913     , 186.254637627     , 155.442844574     ,
 129.987616776     , 108.840398426     , 91.1031693172     , 76.122518797      ,
 63.4066027543     , 52.5484065751     , 43.1904308796     , 35.0611772955     ,
 28.0639643199     , 22.2578781581     , 17.6775526703     , 14.1925291501     ,
 11.5515401144     , 9.50915810757     , 7.90002321438     , 6.64145008931     ,
 5.69074553659     , 4.99467172058     , 4.47800214524     , 4.07670443227     ,
 3.7688789163      , 3.56249328843     , 3.45503610969     , 3.42071568127     ,
 3.43894761605     , 3.50509737452     , 3.59520507211     , 3.64786633939     ,
 3.60816899609     , 3.48073026154     , 3.32484486723     , 3.19866764441     ,
 3.11399324331     , 3.04721472868     , 2.98359459051     , 2.93306317493     ,
 2.9075185971      , 2.91072430656     , 2.9604845649      , 3.09751675416     ,
 3.35005540174     , 3.69428751472     , 4.06481838955     , 4.4046716135      ,
 4.6972349458      , 4.95400501642     , 5.18988151102     , 5.42737898091     ,
 5.71720902225     , 6.11418425642     , 6.59406452555     , 6.99867209559     ,
 7.11138320277     , 6.83945756766     , 6.33229803765     , 5.89963237634     ,
 5.82029719799     , 6.24731909957     , 7.24073250036     , 8.78441458738     ,
 10.7491416156     , 12.9214777143     , 15.1200152254     , 17.2570593143     ,
 19.2787997666     , 21.0937026202     , 22.5974034956     , 23.7600402371     ,
 24.6586779357     , 25.3936128161     , 25.9768276739     , 26.3679416042     ,
 26.6809309704     , 27.3033180532     , 28.6940678585     , 31.0566182055     ,
 34.2980871097     , 38.295734943      , 43.0883799784     , 48.7818631026     ,
 55.3746501576     , 62.7643073718     , 70.8609805897     , 79.5335817977     ,
 88.3872279312     , 96.7019961734     , 103.718878889     , 109.055515473     ,
 112.880588061     , 115.687031521     , 117.896034952     , 119.696258467     ,
 121.203105644     , 122.63250238      , 124.257804076     , 143.262755486     ,
 146.44702718      , 149.885874013     , 153.553936701     , 157.26467481      ,
 160.414513765     , 162.056040529     , 161.346071761     , 157.980988931     ,
 152.167981599     , 144.198213547     , 134.186898255     , 122.283909174     ,
 109.010247971     , 95.2675448012     , 82.0275591626     , 70.0329148547     ,
 59.673727661      , 50.9399526103     , 43.4434834735     , 36.6657479961     ,
 30.3572889764     , 24.7085834141     , 20.0889613321     , 16.6472130102     ,
 14.1995369882     , 12.4377045677     , 11.1505933025     , 10.2501737519     ,
 9.67352427014     , 9.33184404797     , 9.14584989569     , 9.07455453524     ,
 9.10457664309     , 9.2649918153      , 9.65761097238     , 10.419152607      ,
 11.6477999913     , 13.4055460588     , 15.7817913658     , 18.9071964123     ,
 22.8960868214     , 27.8089874225     , 33.711506275      , 40.7765300154     ,
 49.2850638996     , 59.5031135408     , 71.6167495648     , 85.84041988       ,
 102.544091369     , 122.207888214     , 145.228179204     , 171.747714996     ,
 201.718055057     , 235.323574015     , 273.527148104     , 318.069870848     ,
 370.471920343     , 430.581914122     , 495.922856042     , 562.374192623     ,
 625.400999066     , 680.875483202     , 725.441077531     , 756.820384487     ,
 774.159578299     , 778.173024298     , 770.823932887     , 754.610758345     ,
 731.99224811      , 705.238197102     , 676.174909527     , 645.482377698     ,
 612.353434094     , 575.301868901     , 533.481865849     , 487.299277935     ,
 438.089742233     , 387.558762302     , 337.474008455     , 289.543197816     ,
 245.325233964     , 206.099588693     , 172.598996539     , 144.747502756     ,
 121.762749116     , 102.610790258     , 86.3928642607     , 72.461276836      ,
 60.4010046801     , 49.9607901775     , 40.9431312376     , 33.1691222543     ,
 26.5523438633     , 21.1009132987     , 16.7803887018     , 13.4337330408     ,
 10.8595692231     , 8.90239814099     , 7.44982408011     , 6.3972147273      ,
 5.6407759819      , 5.0884068455      , 4.66799994197     , 4.33144447625     ,
 4.0564757967      , 3.84070519973     , 3.68627206936     , 3.59353047253     ,
 3.56939410019     , 3.61735060381     , 3.70153506822     , 3.74241118532     ,
 3.67675971424     , 3.52061557528     , 3.35753952503     , 3.26063660074     ,
 3.23252768568     , 3.22334020303     , 3.1911989789      , 3.12936025184     ,
 3.0516549486      , 2.98589366088     , 2.98541869871     , 3.11614141982     ,
 3.40413501856     , 3.79505335411     , 4.1815632735      , 4.48238016888     ,
 4.69658319691     , 4.88545239475     , 5.11334450625     , 5.41497877667     ,
 5.80672759615     , 6.28844327614     , 6.79903828018     , 7.18280806808     ,
 7.25552211387     , 6.95520342941     , 6.43378102417     , 5.98257892274     ,
 5.87587263023     , 6.29475468525     , 7.33714044187     , 8.99635138675     ,
 11.1149958508     , 13.4462495629     , 15.8119128841     , 18.1669788859     ,
 20.4904936877     , 22.6664249351     , 24.5288894604     , 26.0129574197     ,
 27.2033215162     , 28.2092751293     , 29.0353414366     , 29.6507521015     ,
 30.2210462619     , 31.2070876959     , 33.1276984175     , 36.2103726818     ,
 40.3389230199     , 45.3288203217     , 51.1592617471     , 57.914935193      ,
 65.6054201173     , 74.1464423793     , 83.4565816962     , 93.3810922891     ,
 103.451734455     , 112.850264865     , 120.736511085     , 126.657670483     ,
 130.685162164     , 133.22118881      , 134.739009583     , 135.725029273     ,
 136.72692832      , 138.234330725     , 140.451126735     , 161.939984904     ,
 166.102597311     , 170.53075189      , 175.200941127     , 179.739939065     ,
 183.258347377     , 184.612620421     , 182.930144535     , 177.971117907     ,
 170.007681662     , 159.409994463     , 146.465167599     , 131.592001423     ,
 115.568798226     , 99.4336740542     , 84.1694649753     , 70.4861932765     ,
 58.7745551434     , 49.0712736579     , 41.0353307965     , 34.1299731367     ,
 27.9899197198     , 22.6345218708     , 18.297829183      , 15.0820053204     ,
 12.8199487982     , 11.2329862348     , 10.1262359081     , 9.40268605788     ,
 8.96145530739     , 8.67057449447     , 8.44151690485     , 8.27058611448     ,
 8.20170072175     , 8.30236309651     , 8.6756251599      , 9.43673788954     ,
 10.6687308075     , 12.4410276712     , 14.871799477      , 18.1323724574     ,
 22.3683321097     , 27.6278719294     , 33.9133346259     , 41.3484986087     ,
 50.2663151642     , 61.0686725388     , 74.0321242127     , 89.3352127396     ,
 107.251626919     , 128.220495934     , 152.694499752     , 180.924457276     ,
 212.916812521     , 248.754791262     , 289.173851618     , 335.746133788     ,
 390.002505484     , 451.853116965     , 518.693404039     , 586.023706131     ,
 648.862600236     , 702.805187302     , 744.484863806     , 771.823265516     ,
 784.264895191     , 782.881284408     , 770.083475377     , 748.829702083     ,
 721.797067109     , 691.105357347     , 658.281262607     , 623.85248405      ,
 587.081060744     , 546.724446067     , 502.349213812     , 454.883083456     ,
 406.067963701     , 357.624388627     , 310.866761483     , 266.818847145     ,
 226.478719896     , 190.83888969      , 160.521351901     , 135.393236005     ,
 114.648015093     , 97.2619047661     , 82.3493704958     , 69.2779080518     ,
 57.7036752213     , 47.5273627686     , 38.7259963681     , 31.234360654      ,
 24.9815636914     , 19.9125867168     , 15.9081822279     , 12.7702179593     ,
 10.3294068901     , 8.50140432366     , 7.21637342516     , 6.34996798588     ,
 5.74829298929     , 5.29374694751     , 4.92785700081     , 4.6231708771      ,
 4.35614120394     , 4.11059302116     , 3.89140522174     , 3.72559722691     ,
 3.64704774748     , 3.66354050395     , 3.72481181138     , 3.73784759433     ,
 3.63945160946     , 3.45911745402     , 3.29734180906     , 3.23292343129     ,
 3.25639949332     , 3.29601293581     , 3.28942934423     , 3.21727478865     ,
 3.0954780784      , 2.97358118099     , 2.93720129383     , 3.07475098052     ,
 3.40990621927     , 3.8602789665      , 4.27922777373     , 4.56108137953     ,
 4.71787097322     , 4.85769575958     , 5.09217451258     , 5.46414315547     ,
 5.94810965865     , 6.48428316283     , 6.98224393587     , 7.30730316624     ,
 7.32343850665     , 7.00071999691     , 6.48211667794     , 6.02630118624     ,
 5.89119075224     , 6.2740480927      , 7.29959339641     , 8.97214207751     ,
 11.1293319547     , 13.5246049886     , 16.0047205878     , 18.5681298897     ,
 21.2153169911     , 23.7930450541     , 26.0625166469     , 27.910748435      ,
 29.4160261816     , 30.6942522796     , 31.7711616471     , 32.6842974969     ,
 33.6996112792     , 35.3406066669     , 38.1094302362     , 42.1650940621     ,
 47.3225079248     , 53.3579348291     , 60.2440871556     , 68.0747232678     ,
 76.8662140984     , 86.535513966      , 96.9839627399     , 107.990287152     ,
 118.979478033     , 129.060912946     , 137.412313177     , 143.638127202     ,
 147.798649943     , 150.212705334     , 151.361063129     , 151.97342752      ,
 152.961639859     , 154.992830229     , 158.11844457      , 183.231995674     ,
 188.700232754     , 194.396425644     , 200.224573792     , 205.490995234     ,
 208.931599131     , 209.263070512     , 205.771149852     , 198.473035981     ,
 187.790345078     , 174.145137074     , 157.93304922      , 139.807253404     ,
 120.819431309     , 102.195843886     , 84.970635892      , 69.8015168474     ,
 57.0024944075     , 46.5806155812     , 38.2174405723     , 31.3744356929     ,
 25.5783419918     , 20.6553904746     , 16.6806318223     , 13.7169770674     ,
 11.6451168496     , 10.2359737466     , 9.30538332709     , 8.73846933963     ,
 8.40886989665     , 8.16822907311     , 7.9333018302      , 7.72930828074     ,
 7.63852794077     , 7.75149837728     , 8.16449806075     , 8.96853198872     ,
 10.2291603808     , 12.0167937083     , 14.4701703736     , 17.8013628013     ,
 22.2050245621     , 27.7508744035     , 34.4057632223     , 42.2322912411     ,
 51.5594939223     , 62.877072954      , 76.5673098651     , 92.8357716084     ,
 111.896670688     , 134.114229542     , 159.926113408     , 189.659177401     ,
 223.424315549     , 261.282987057     , 303.742300405     , 352.089684342     ,
 407.751745757     , 470.732550724     , 538.464392431     , 606.175596906     ,
 668.339652826     , 720.060478637     , 757.896312269     , 780.211818271     ,
 787.164093013     , 780.444577315     , 762.832962867     , 737.434906052     ,
 706.851218703     , 672.907941819     , 636.832029087     , 599.148073461     ,
 559.473812895     , 517.034936633     , 471.701742492     , 424.483564855     ,
 377.079045907     , 331.072785952     , 287.498147515     , 246.985499671     ,
 210.169987101     , 177.801717513     , 150.35689559      , 127.618056332     ,
 108.762239696     , 92.8104794884     , 78.9348943451     , 66.5425741919     ,
 55.341693399      , 45.3411823183     , 36.6689905968     , 29.3852286026     ,
 23.4581707526     , 18.7815441609     , 15.1447127365     , 12.2842976708     ,
 10.0296947641     , 8.34372658489     , 7.19876769883     , 6.46925351891     ,
 5.97157439158     , 5.57202421672     , 5.22358906092     , 4.91468367681     ,
 4.62141532921     , 4.3200306632      , 4.02225101105     , 3.77812350998     ,
 3.6393842051      , 3.611897857       , 3.63444180534     , 3.61181711394     ,
 3.48945829285     , 3.30642467512     , 3.16608939924     , 3.14129294757     ,
 3.20954629822     , 3.28390444346     , 3.28968051006     , 3.20270641198     ,
 3.04762889308     , 2.89607578762     , 2.85598323832     , 3.02305116527     ,
 3.40990153987     , 3.91067547617     , 4.35219899954     , 4.61491540205     ,
 4.72562948286     , 4.83263293169     , 5.08402772687     , 5.52229928826     ,
 6.0802804701      , 6.64839496387     , 7.11913160916     , 7.38356379121     ,
 7.3490358318      , 7.01163093159     , 6.50667319814     , 6.06573373838     ,
 5.92724409675     , 6.28483507804     , 7.26387615329     , 8.8723989243      ,
 10.9699483693     , 13.3533356891     , 15.9156075458     , 18.682924954      ,
 21.6502478938     , 24.6207784915     , 27.2922098908     , 29.5010570089     ,
 31.3048657857     , 32.8326952985     , 34.1752262471     , 35.4911916948     ,
 37.164107094      , 39.7416677035     , 43.6369443621     , 48.8814786596     ,
 55.2108668277     , 62.3904605512     , 70.4101191544     , 79.3690341373     ,
 89.2804234285     , 100.060995355     , 111.573027544     , 123.464874845     ,
 134.99415168      , 145.217747449     , 153.457975774     , 159.560678318     ,
 163.73205775      , 166.269131692     , 167.606069675     , 168.576532554     ,
 170.294264668     , 173.486084844     , 178.015217909     , 208.160617688     ,
 215.504576473     , 222.843095072     , 229.893112684     , 235.565179308     ,
 238.227972814     , 236.570394625     , 230.232944676     , 219.690182341     ,
 205.615519931     , 188.452034361     , 168.605919494     , 146.900156071     ,
 124.677194746     , 103.425402883     , 84.2940490403     , 67.8815311595     ,
 54.3379984411     , 43.5268684402     , 35.0796706402     , 28.4490278362     ,
 23.0875998864     , 18.6653684097     , 15.1156907307     , 12.4603323236     ,
 10.6182507703     , 9.39943378702     , 8.62323634759     , 8.16541338406     ,
 7.90601757578     , 7.71834547994     , 7.53834276127     , 7.39982379242     ,
 7.38798424387     , 7.59180547757     , 8.09706432944     , 8.97818652442     ,
 10.2858618315     , 12.081997876      , 14.513460276      , 17.8339801299     ,
 22.3105012232     , 28.0734065572     , 35.0845476711     , 43.3332174377     ,
 53.0826626401     , 64.8493152953     , 79.1294099046     , 96.236246856      ,
 116.399452557     , 139.895520357     , 167.039783853     , 198.107234681     ,
 233.260720772     , 272.601039612     , 316.522745256     , 366.097374887     ,
 422.628711711     , 486.164722708     , 554.169547677     , 621.641883252     ,
 682.533092032     , 731.427250945     , 764.797056546     , 781.556189584     ,
 782.779119413     , 770.91414119      , 749.030538593     , 720.158853269     ,
 686.682417468     , 650.153190574     , 611.548190356     , 571.400273271     ,
 529.746085692     , 486.392959906     , 441.495858459     , 395.895067734     ,
 350.916222658     , 307.838319449     , 267.494610931     , 230.337536283     ,
 196.798179217     , 167.406979252     , 142.45808362      , 121.654062717     ,
 104.211833818     , 89.2653528406     , 76.1029105446     , 64.20624108       ,
 53.3213645006     , 43.5015429484     , 34.9574853705     , 27.8476980374     ,
 22.1959973838     , 17.8756145529     , 14.6009595612     , 12.03242579       ,
 9.96874077091     , 8.39756784718     , 7.33598743801     , 6.67832296599     ,
 6.23101648053     , 5.8491848409      , 5.48991164072     , 5.15079906273     ,
 4.81046950924     , 4.44558329117     , 4.07583848562     , 3.76322995943     ,
 3.5627527927      , 3.4742429572      , 3.43595287943     , 3.36613147462     ,
 3.22662275117     , 3.06001163359     , 2.9585514848      , 2.97959686938     ,
 3.08866657515     , 3.19015842237     , 3.20303848117     , 3.10441300894     ,
 2.9340055731      , 2.78589361519     , 2.77936855305     , 3.00009379168     ,
 3.43816327613     , 3.96648424089     , 4.39827144962     , 4.61378370395     ,
 4.66040282844     , 4.72212334844     , 4.97411617586     , 5.45496058397     ,
 6.06507805407     , 6.66052641074     , 7.12282445253     , 7.35901526845     ,
 7.30462211052     , 6.97712481175     , 6.51400999563     , 6.13154274633     ,
 6.0463608072      , 6.42784112751     , 7.37564219809     , 8.89095800266     ,
 10.8731192599     , 13.1951517884     , 15.8121514751     , 18.7622247419     ,
 22.011897131      , 25.3221333515     , 28.3468300419     , 30.8815805543     ,
 32.9618898717     , 34.7425019062     , 36.4067634829     , 38.2480704617     ,
 40.7470297956     , 44.4327711724     , 49.5930559938     , 56.1251775072     ,
 63.7052332881     , 72.1043095627     , 81.3215456172     , 91.4466424442     ,
 102.491126319     , 114.36943436      , 126.861508742     , 139.412093666     ,
 151.072006789     , 160.892755897     , 168.471753628     , 174.06681862      ,
 178.188223093     , 181.197065823     , 183.437276169     , 185.677876895     ,
 189.041931127     , 194.215808364     , 200.880531285     , 237.616859946     ,
 247.514457755     , 256.88467073      , 265.13409829      , 270.765260879     ,
 271.844585536     , 267.124420928     , 256.723374525     , 241.742897535     ,
 223.274791015     , 201.869247728     , 177.930261243     , 152.390538725     ,
 126.833436236     , 102.991746528     , 82.1321388823     , 64.7805812658     ,
 50.8647543408     , 40.0117369499     , 31.724406252      , 25.4252442255     ,
 20.5345101788     , 16.6334277312     , 13.5542869195     , 11.2708081468     ,
 9.71088842417     , 8.70445315785     , 8.07457696125     , 7.70266476828     ,
 7.50020185894     , 7.38657297754     , 7.32469463        , 7.34185636435     ,
 7.50000287506     , 7.86812158605     , 8.51772147219     , 9.50753943657     ,
 10.8676937142     , 12.6420259893     , 14.982849469      , 18.1941939795     ,
 22.632749649      , 28.5139940911     , 35.8208757497     , 44.4786955228     ,
 54.660458365      , 66.8675948745     , 81.6962239787     , 99.6011650603     ,
 120.871032291     , 145.683913358     , 174.138364465     , 206.317910694     ,
 242.347367319     , 282.414658754     , 326.977207223     , 377.059104749     ,
 433.856285356     , 497.322118677     , 564.827549474     , 631.198649072     ,
 690.092211543     , 735.78565012      , 764.696060461     , 776.143057194     ,
 771.955572394     , 755.269001563     , 729.446806568     , 697.484519327     ,
 661.648738051     , 623.350362226     , 583.341549724     , 542.016105311     ,
 499.638100167     , 456.504819788     , 413.047838005     , 369.911394158     ,
 327.969341396     , 288.130526255     , 251.051996285     , 217.105956281     ,
 186.596717097     , 159.838841267     , 136.930849959     , 117.537583222     ,
 100.998552574     , 86.6235363108     , 73.8498216494     , 62.2598178009     ,
 51.6437052831     , 42.0535497972     , 33.6999521932     , 26.7751487279     ,
 21.3466341711     , 17.2972171371     , 14.305796282      , 11.9770364527     ,
 10.0715697763     , 8.58105385112     , 7.5551007225      , 6.91215855311     ,
 6.46018300674     , 6.05089713422     , 5.64860895414     , 5.26383466839     ,
 4.88286860058     , 4.48278075537     , 4.07985797921     , 3.72882854252     ,
 3.473915876       , 3.3104770269      , 3.19050774692     , 3.06024157125     ,
 2.9024085738      , 2.75607079418     , 2.69129853299     , 2.74581230802     ,
 2.87989821372     , 3.00010573658     , 3.02552287796     , 2.93501616589     ,
 2.77936979568     , 2.66708772711     , 2.71900676308     , 3.00340428641     ,
 3.48530847263     , 4.01870698789     , 4.40970158617     , 4.54596102044     ,
 4.49800391931     , 4.48010851596     , 4.688282461       , 5.1626819116      ,
 5.79060472383     , 6.41173941407     , 6.89708978478     , 7.15444569898     ,
 7.13249844864     , 6.86616862951     , 6.49943040333     , 6.23577360273     ,
 6.26390075649     , 6.7166756591      , 7.65845819444     , 9.08254654828     ,
 10.9340195654     , 13.1690197814     , 15.8071413183     , 18.8973002674     ,
 22.3806765119     , 25.9881152732     , 29.3442739948     , 32.2130440959     ,
 34.6148059508     , 36.7357269519     , 38.8421347082     , 41.3268989155     ,
 44.7241315623     , 49.5232519218     , 55.9025630758     , 63.6640942385     ,
 72.453224275      , 82.0408630186     , 92.4109742027     , 103.639930089     ,
 115.75238967      , 128.645870305     , 141.962316318     , 154.906559428     ,
 166.359304249     , 175.455612717     , 182.153847851     , 187.190609822     ,
 191.451354163     , 195.427323517     , 199.362162788     , 203.832132749     ,
 209.802492144     , 217.840813166     , 227.473243904     , 272.252992774     ,
 285.257154151     , 296.882949485     , 306.120288459     , 311.09874048      ,
 309.673477979     , 300.712792331     , 284.851798282     , 263.938003717     ,
 239.71232222      , 213.085096703     , 184.59839332      , 155.255484279     ,
 126.707104946     , 100.734074874     , 78.5946819357     , 60.7039821041     ,
 46.7688822243     , 36.1721137595     , 28.2612557412     , 22.4126800416     ,
 18.0377696418     , 14.6801728157     , 12.106077082      , 10.2377269346     ,
 8.99306772881     , 8.21775814837     , 7.75007794216     , 7.4875061992      ,
 7.37466326943     , 7.37521669469     , 7.47955462963     , 7.71024494338     ,
 8.10425378534     , 8.70285570036     , 9.54987205558     , 10.6712249424     ,
 12.0641986655     , 13.7592700865     , 15.9332450669     , 18.9522767047     ,
 23.2546874269     , 29.1326955827     , 36.6130210118     , 45.6083650223     ,
 56.2365542157     , 68.962860057      , 84.419065228      , 103.145154848     ,
 125.472839051     , 151.49180788      , 181.076727194     , 214.068694712     ,
 250.493734661     , 290.640200869     , 335.145968747     , 385.103262589     ,
 441.566798022     , 504.220165125     , 570.225409928     , 634.383804866     ,
 690.449927494     , 732.767436435     , 757.758065527     , 764.833232198     ,
 756.124027447     , 735.189094294     , 705.740759087     , 670.985111756     ,
 633.312404513     , 594.122061722     , 553.928050838     , 512.821509081     ,
 471.031056577     , 429.116371389     , 387.719838631     , 347.377901164     ,
 308.630913672     , 272.0725411       , 238.186798907     , 207.263407935     ,
 179.48035257      , 154.935551415     , 133.558414066     , 115.052257754     ,
 98.9650022065     , 84.817708597      , 72.1859908382     , 60.7470628864     ,
 50.3443873092     , 41.0132099574     , 32.9062828507     , 26.1837971947     ,
 20.9250549083     , 17.0371031813     , 14.2091027972     , 12.034762534      ,
 10.2492342983     , 8.82476151203     , 7.81131121155     , 7.13823445736     ,
 6.62317237797     , 6.1304459478      , 5.64701124741     , 5.20951964252     ,
 4.81781367245     , 4.44020063769     , 4.06673320843     , 3.72251075911     ,
 3.43323295474     , 3.19719388537     , 2.9921250476      , 2.79914330195     ,
 2.62058792186     , 2.48470948614     , 2.43252296131     , 2.48371450694     ,
 2.60568981066     , 2.72299981581     , 2.76376892647     , 2.7050430984      ,
 2.59405094609     , 2.5363420867      , 2.64578837777     , 2.97824398452     ,
 3.48440216891     , 4.00623841279     , 4.34473969472     , 4.39422042495     ,
 4.24244351521     , 4.12219744591     , 4.2426303369      , 4.65474343169     ,
 5.25647961711     , 5.89053186984     , 6.41891671489     , 6.73988833726     ,
 6.80560431552     , 6.66194626396     , 6.45238418141     , 6.35870970229     ,
 6.53276596417     , 7.06778453689     , 8.00168327991     , 9.3345070348      ,
 11.0591845309     , 13.1988891976     , 15.8243759256     , 19.0072504552     ,
 22.6940959855     , 26.6095849225     , 30.3551605562     , 33.6629252984     ,
 36.5408596722     , 39.1979769496     , 41.9422690075     , 45.1970239436     ,
 49.4934945764     , 55.2808133163     , 62.6849369462     , 71.4814568766     ,
 81.3141378928     , 91.9361786167     , 103.291571602     , 115.442278025     ,
 128.429568497     , 142.113290623     , 155.981883709     , 169.051863753     ,
 180.14749592      , 188.575098824     , 194.649271246     , 199.522754261     ,
 204.423209463     , 210.000560342     , 216.423904812     , 224.021735633     ,
 233.486532001     , 245.197126915     , 258.544514462     , 312.535000094     ,
 328.841959419     , 342.486033509     , 351.992990902     , 355.226174793     ,
 349.993717021     , 335.3823012       , 312.57309157      , 284.222306416     ,
 252.919926948     , 220.230088504     , 187.033835353     , 154.36147305      ,
 123.668882621     , 96.4660064413     , 73.7832036419     , 55.8622761314     ,
 42.2437325285     , 32.1494488107     , 24.8159843181     , 19.5729159762     ,
 15.8142803329     , 13.0536287965     , 11.0057456806     , 9.55165677877     ,
 8.61049131172     , 8.06239182513     , 7.7785701822      , 7.67412799836     ,
 7.70975817124     , 7.87282307778     , 8.17568224287     , 8.6489890201      ,
 9.31948163831     , 10.1982166224     , 11.2790847859     , 12.5305712328     ,
 13.9138844707     , 15.4726705094     , 17.4421163404     , 20.2531803427     ,
 24.3864654742     , 30.1711786043     , 37.695260231      , 46.9383390833     ,
 58.03527198       , 71.4007586853     , 87.5968357385     , 107.128443089     ,
 130.320563529     , 157.223845198     , 187.59269014      , 221.097581299     ,
 257.657139415     , 297.610348398     , 341.742340658     , 391.175322449     ,
 446.726381439     , 507.696938815     , 571.048365867     , 631.782268257     ,
 684.140423545     , 722.890427847     , 744.556129033     , 748.3846401       ,
 736.355810149     , 712.117250149     , 679.709198827     , 642.735622475     ,
 603.867774199     , 564.5356822       , 525.017566062     , 485.079327279     ,
 444.784535594     , 404.748037648     , 365.719045803     , 328.216593533     ,
 292.61291825      , 259.271664673     , 228.482997104     , 200.39397183      ,
 175.019003573     , 152.25237186      , 131.916235522     , 113.838317656     ,
 97.8455681767     , 83.6936823246     , 71.0737138381     , 59.7201966442     ,
 49.5045400989     , 40.4300506124     , 32.5714914674     , 26.0290627577     ,
 20.8727521704     , 17.0386472611     , 14.2615141957     , 12.1667994487     ,
 10.4769872378     , 9.11637934486     , 8.09666486711     , 7.34652206865     ,
 6.71019083906     , 6.08593594748     , 5.49601486053     , 5.01075156167     ,
 4.64589118375     , 4.35030398485     , 4.06586752412     , 3.77157670334     ,
 3.47520905364     , 3.18750229139     , 2.91594907418     , 2.67243421351     ,
 2.47304250891     , 2.33205885492     , 2.26189186952     , 2.26908747022     ,
 2.33787295047     , 2.42240194651     , 2.46711582388     , 2.44427124036     ,
 2.38407128466     , 2.3737412344      , 2.51523359182     , 2.86139673592     ,
 3.36363694678     , 3.86202984607     , 4.15511770624     , 4.14019395623     ,
 3.91101341986     , 3.701906514       , 3.72313825345     , 4.04039835399     ,
 4.57962957837     , 5.20348621457     , 5.77185389928     , 6.17196796388     ,
 6.35398443106     , 6.36600104666     , 6.34112668712     , 6.43283704206     ,
 6.75345518758     , 7.35864198594     , 8.27142008355     , 9.51447105198     ,
 11.1279442303     , 13.1771323832     , 15.7620079226     , 18.9895984706     ,
 22.8531320207     , 27.106941094      , 31.3412993444     , 35.2536780032     ,
 38.8322039351     , 42.2892549121     , 45.9264525744     , 50.1210463963     ,
 55.3338963894     , 61.9686880107     , 70.1646898632     , 79.7500917624     ,
 90.4006174523     , 101.842062333     , 113.96069504      , 126.787241328     ,
 140.357238143     , 154.49273483      , 168.599594427     , 181.643428308     ,
 192.508498809     , 200.675035396     , 206.706083552     , 212.046625243     ,
 218.211967836     , 226.035197422     , 235.661310166     , 247.179328177     ,
 260.949651577     , 277.081918844     , 294.783338126     , 358.76634715      ,
 377.969006529     , 392.561999481     , 400.694517254     , 400.217088134     ,
 389.215909659     , 367.250249563     , 336.144339399     , 299.360914112     ,
 260.376538809     , 221.52185705      , 184.084478639     , 149.025924496     ,
 117.366339215     , 90.0726259308     , 67.7510923477     , 50.4068398959     ,
 37.4759177696     , 28.1343407375     , 21.5883933369     , 17.1343421521     ,
 14.1236288048     , 12.0183540839     , 10.4863841222     , 9.39618005918     ,
 8.70557615028     , 8.35892210017     , 8.27262248391     , 8.37241766801     ,
 8.61385684232     , 8.98473840561     , 9.50881862381     , 10.2315248665     ,
 11.1808565858     , 12.3374648577     , 13.6339259435     , 14.9778638023     ,
 16.3145351992     , 17.7358315888     , 19.5560276658     , 22.2513954437     ,
 26.2895690522     , 31.987411526      , 39.49919992       , 48.9342762995     ,
 60.5057431313     , 74.5691106146     , 91.5310765193     , 111.757783545     ,
 135.520226987     , 162.885206786     , 193.628890632     , 227.391852357     ,
 264.024111157     , 303.827123574     , 347.569872832     , 396.232108126     ,
 450.277910725     , 508.635394215     , 568.212307374     , 624.433273281     ,
 672.255878731     , 707.074066842     , 725.645957108     , 727.037232319     ,
 712.887259759     , 686.675397479     , 652.577019157     , 614.482615116     ,
 575.256559972     , 536.319137233     , 497.803814749     , 459.321398006     ,
 420.835997761     , 382.926977472     , 346.362143393     , 311.677665272     ,
 279.166490548     , 248.993928636     , 221.218127011     , 195.788074628     ,
 172.534563926     , 151.186438996     , 131.526952501     , 113.559527868     ,
 97.4187294125     , 83.119146442      , 70.472818637      , 59.2319760393     ,
 49.23093667       , 40.4004583264     , 32.737182221      , 26.2959798893     ,
 21.1467738241     , 17.2651798612     , 14.4526668832     , 12.3871948354     ,
 10.7765094503     , 9.46837738964     , 8.40947734944     , 7.53177480107     ,
 6.73238653361     , 5.96046741778     , 5.26960473976     , 4.75411752596     ,
 4.44186356        , 4.2588488158      , 4.0913321683      , 3.8690368913      ,
 3.58828808427     , 3.27825278962     , 2.97046847303     , 2.69469778699     ,
 2.47418940177     , 2.31438823961     , 2.20896987798     , 2.15641372681     ,
 2.15620082369     , 2.18935090587     , 2.21669801977     , 2.20664980917     ,
 2.17128645224     , 2.17761587049     , 2.31649354681     , 2.6426919131      ,
 3.11585713862     , 3.58197808485     , 3.8426077738      , 3.7972483622      ,
 3.53608899337     , 3.27971569785     , 3.22613345602     , 3.45046236896     ,
 3.91076310782     , 4.5003066532      , 5.08817622762     , 5.55522550358     ,
 5.8438601361      , 5.99362808038     , 6.12337836188     , 6.36762738357     ,
 6.81442179636     , 7.49105239422     , 8.4060163711      , 9.59827838296     ,
 11.1391783306     , 13.1110858067     , 15.6247778236     , 18.8295455591     ,
 22.7991302756     , 27.361865739      , 32.129801405      , 36.7740550223     ,
 41.2503508613     , 45.7535543138     , 50.5475008875     , 55.9065425175     ,
 62.1524251606     , 69.6140769438     , 78.479890677      , 88.6905358941     ,
 99.9857724828     , 112.065671187     , 124.747083307     , 138.002833817     ,
 151.840154321     , 166.089126945     , 180.217200738     , 193.299307011     ,
 204.322371867     , 212.825345435     , 219.447321982     , 225.824835181     ,
 233.765029635     , 244.345108284     , 257.758030961     , 273.90397303      ,
 292.792411656     , 314.144560468     , 336.792336965     , 410.924637768     ,
 431.730848883     , 445.099247487     , 449.089857346     , 441.993451954     ,
 422.677344607     , 391.562578857     , 351.260242315     , 305.953503937     ,
 259.821468986     , 215.775800482     , 175.333958164     , 139.221939311     ,
 107.889292073     , 81.6575280304     , 60.627135271      , 44.5263419814     ,
 32.7173870423     , 24.4103160128     , 18.8515965825     , 15.3306223931     ,
 13.148837475      , 11.7079249038     , 10.6439798982     , 9.8512684304      ,
 9.36429400346     , 9.20947468474     , 9.34633822777     , 9.69950927296     ,
 10.2043887234     , 10.8323014414     , 11.6014564925     , 12.55977602       ,
 13.7337608476     , 15.0833869542     , 16.5045871481     , 17.8826389508     ,
 19.1851030891     , 20.5659659078     , 22.3962672757     , 25.1522971276     ,
 29.2433064104     , 34.9434150325     , 42.4646458718     , 52.0575789423     ,
 64.0319488791     , 78.6943530351     , 96.2920278489     , 117.03151073      ,
 141.100219132     , 168.579446993     , 199.332918077     , 233.082929375     ,
 269.68083518      , 309.341604552     , 352.653049373     , 400.262210235     ,
 452.195268252     , 507.099384141     , 562.027177689     , 612.976064073     ,
 655.661183445     , 686.139742363     , 701.548221791     , 700.974166119     ,
 685.80611388      , 659.207340602     , 625.136325036     , 587.370074253     ,
 548.694275657     , 510.488361502     , 472.940869878     , 435.783626511     ,
 399.041502878     , 363.255368329     , 329.152197875     , 297.256860506     ,
 267.775337529     , 240.66217491      , 215.731825408     , 192.73430186      ,
 171.342077615     , 151.17811409      , 132.03579598      , 114.080695132     ,
 97.7124958951     , 83.2052933639     , 70.5246938453     , 59.4332552138     ,
 49.669846258      , 41.0450122094     , 33.4791598567     , 27.0125859321     ,
 21.7443931397     , 17.7090444082     , 14.7842474706     , 12.699341281      ,
 11.1362795125     , 9.85052435059     , 8.71604283081     , 7.67910199675     ,
 6.70917077887     , 5.81022509421     , 5.04859475442     , 4.51980526651     ,
 4.25588262567     , 4.16774951885     , 4.09956752839     , 3.9437958298      ,
 3.69226402507     , 3.39033909425     , 3.08074326406     , 2.79527266897     ,
 2.55887367701     , 2.37849678874     , 2.24434082083     , 2.15021182732     ,
 2.09872802157     , 2.08253775527     , 2.07324271325     , 2.04098376291     ,
 1.99058533039     , 1.97828071977     , 2.08714645073     , 2.37161552333     ,
 2.79825421791     , 3.22376804858     , 3.46019814556     , 3.41129519144     ,
 3.15766586832     , 2.89662164557     , 2.80463632909     , 2.95728750682     ,
 3.33893074219     , 3.87715713277     , 4.46202503105     , 4.97467480623     ,
 5.34194920314     , 5.58134504883     , 5.79716531047     , 6.12658685468     ,
 6.66577320521     , 7.43429273529     , 8.41861771614     , 9.64134053437     ,
 11.1677592226     , 13.0753593689     , 15.4810809921     , 18.5811655271     ,
 22.5469760309     , 27.3188975767     , 32.5763426076     , 37.9867504739     ,
 43.4651679601     , 49.1730582715     , 55.3277974067     , 62.0834585589     ,
 69.5832680068     , 78.0394102854     , 87.6712480366     , 98.5358148579     ,
 110.445286366     , 123.079423258     , 136.184164332     , 149.663651113     ,
 163.504911756     , 177.623244189     , 191.69015218      , 205.002264371     ,
 216.63046554      , 226.034115714     , 233.786814617     , 241.666443487     ,
 251.809128566     , 265.608902279     , 283.382026525     , 304.889324248     ,
 329.750933702     , 357.107966704     , 385.086621079     , 468.360642632     ,
 488.384719054     , 497.29437037      , 493.529262237     , 476.418481994     ,
 446.181859787     , 404.479807011     , 354.789789693     , 301.821330257     ,
 250.100250809     , 202.717571783     , 161.076420073     , 125.470244105     ,
 95.7446816449     , 71.622377953      , 52.7286288293     , 38.51333299       ,
 28.2684246665     , 21.2644140226     , 16.8260709001     , 14.2734211647     ,
 12.8920577651     , 12.0575750083     , 11.4101957832     , 10.8975050226     ,
 10.6377914862     , 10.7298760147     , 11.1647019073     , 11.8599602195     ,
 12.7270081839     , 13.7087063293     , 14.7902913832     , 15.9874162287     ,
 17.3095177027     , 18.7231617751     , 20.1527364988     , 21.5293598536     ,
 22.8720612318     , 24.3677648494     , 26.3802600865     , 29.3362163065     ,
 33.5760672527     , 39.3358779441     , 46.868530207      , 56.5269561071     ,
 68.695922433      , 83.6673147785     , 101.610708973     , 122.64129007      ,
 146.856637233     , 174.276580041     , 204.779062843     , 238.165517347     ,
 274.349136909     , 313.50408966      , 356.006333005     , 402.096804687     ,
 451.349251448     , 502.227007496     , 552.062793351     , 597.471113572     ,
 634.85808722      , 660.904611373     , 673.247863047     , 671.235332606     ,
 656.151141067     , 630.715325443     , 598.285577634     , 562.106089764     ,
 524.674103084     , 487.400546741     , 450.760687523     , 414.817690295     ,
 379.749741919     , 346.050298957     , 314.353064895     , 285.118354396     ,
 258.442892384     , 234.096049728     , 211.698317846     , 190.839948658     ,
 171.074700341     , 151.978194934     , 133.382560245     , 115.554841337     ,
 99.0527675469     , 84.3575501097     , 71.6110767432     , 60.617192715      ,
 51.0164495928     , 42.4853855509     , 34.8722241359     , 28.2232433911     ,
 22.6906558623     , 18.3832194373     , 15.2538190855     , 13.0728790526     ,
 11.4936128176     , 10.1856162513     , 8.95496372303     , 7.76185655942     ,
 6.64556782773     , 5.6564690785      , 4.85395523419     , 4.31137414171     ,
 4.05626897028     , 4.00108027602     , 3.97896379682     , 3.86788708637     ,
 3.65754763697     , 3.39790972737     , 3.12805423906     , 2.86889628616     ,
 2.6413171641      , 2.46004122877     , 2.32331033293     , 2.22176703216     ,
 2.14845925802     , 2.09327545622     , 2.03556140816     , 1.95615530468     ,
 1.86535680592     , 1.8163574576      , 1.8830028359      , 2.11272215365     ,
 2.47682248809     , 2.84964252621     , 3.06289462056     , 3.02634223869     ,
 2.80516420182     , 2.56744374932     , 2.4646163111      , 2.56697765868     ,
 2.87725113944     , 3.35582669358     , 3.92189360155     , 4.46399910948     ,
 4.88848283834     , 5.17889934274     , 5.42222658774     , 5.77430844868     ,
 6.36911359227     , 7.24305801826     , 8.35709281076     , 9.68209222895     ,
 11.2386968415     , 13.0892643336     , 15.36962748       , 18.3296649583     ,
 22.2353869774     , 27.1507414708     , 32.8535243628     , 39.0306460789     ,
 45.5523778751     , 52.5308953334     , 60.1387897423     , 68.4360176306     ,
 77.4096971408     , 87.1364687983     , 97.8032383505     , 109.51580875      ,
 122.129909439     , 135.317285784     , 148.77714034      , 162.364298528     ,
 176.074028672     , 189.95834099      , 203.949999941     , 217.597873059     ,
 230.056159581     , 240.700860576     , 250.047161765     , 260.011376986     ,
 273.038373439     , 290.829466515     , 313.825438384     , 341.598997359     ,
 373.222905716     , 406.986190404     , 439.976177907     , 529.361057275     ,
 545.141568046     , 545.70047431      , 530.403789584     , 500.201619215     ,
 457.125491579     , 404.274418328     , 345.89666753      , 286.906640783     ,
 231.741026688     , 183.234464643     , 142.34744924      , 108.789803722     ,
 81.8183160142     , 60.6536418775     , 44.5368293986     , 32.6877274522     ,
 24.3392232584     , 18.8176203186     , 15.5324486421     , 13.8731063809     ,
 13.1786444938     , 12.8732854861     , 12.6477598858     , 12.5010421503     ,
 12.5990847404     , 13.0810295245     , 13.9646124393     , 15.1738619088     ,
 16.6043849821     , 18.1570232175     , 19.74236419       , 21.2892833896     ,
 22.7637816527     , 24.1733695385     , 25.5479964438     , 26.9251577123     ,
 28.3729810428     , 30.0530793529     , 32.2608464076     , 35.3610585971     ,
 39.6619595663     , 45.3935003135     , 52.8272280556     , 62.3532507288     ,
 74.388790251      , 89.2487146278     , 107.135199053     , 128.18412101      ,
 152.434043513     , 179.751408818     , 209.854287629     , 242.484041719     ,
 277.610441667     , 315.479236659     , 356.391300481     , 400.287887249     ,
 446.373734874     , 492.993367204     , 537.776638276     , 577.900528333     ,
 610.373877642     , 632.466061127     , 642.373328656     , 639.787637835     ,
 625.879731463     , 602.766168433     , 572.965072618     , 539.029626088     ,
 503.194708895     , 467.057340362     , 431.509719967     , 396.965369509     ,
 363.70218426      , 332.105398688     , 302.665365879     , 275.758568514     ,
 251.429313125     , 229.382720874     , 209.140441859     , 190.150704184     ,
 171.840055091     , 153.758204934     , 135.793927163     , 118.265978102     ,
 101.784840641     , 86.9552611753     , 74.080603894      , 63.0411130283     ,
 53.4236325527     , 44.8017152012     , 36.9650908104     , 29.9704571103     ,
 24.0274558649     , 19.32062995       , 15.8703197432     , 13.4817924114     ,
 11.7919025751     , 10.4076240797     , 9.07455446776     , 7.75039694673     ,
 6.52230048856     , 5.47388123258     , 4.64668776983     , 4.07609501219     ,
 3.77720275611     , 3.68143004737     , 3.64636644976     , 3.55928829995     ,
 3.40450983494     , 3.22093891763     , 3.03376727907     , 2.84736188125     ,
 2.67175857122     , 2.52504861235     , 2.41428661012     , 2.32759343247     ,
 2.24566266785     , 2.15428474904     , 2.04523991048     , 1.91789413268     ,
 1.79224609233     , 1.71522152359     , 1.74291554245     , 1.90912833798     ,
 2.19217493498     , 2.49480206165     , 2.67882122959     , 2.66168536506     ,
 2.4874805048      , 2.29015489024     , 2.19484928435     , 2.26399819555     ,
 2.51224080924     , 2.92806804917     , 3.46256037982     , 4.01889067866     ,
 4.48704055697     , 4.81530706058     , 5.06967104628     , 5.42275091194     ,
 6.05100723688     , 7.01869840799     , 8.26610903211     , 9.7019641171      ,
 11.2918489292     , 13.0943239655     , 15.2881677537     , 18.1827961985     ,
 22.1195579443     , 27.2668511355     , 33.4999191001     , 40.5290239867     ,
 48.1659246311     , 56.4455988491     , 65.4915418115     , 75.3224381092     ,
 85.8509630291     , 97.0465427616     , 108.996051177     , 121.748133854     ,
 135.151107032     , 148.898010741     , 162.702273233     , 176.414838836     ,
 190.056338746     , 203.795567428     , 217.765938093     , 231.718731822     ,
 244.949627116     , 256.945551298     , 268.371562142     , 281.338076265     ,
 298.478612975     , 321.621503523     , 351.150435607     , 386.206879549     ,
 424.992405931     , 464.645958006     , 501.060711659     , 590.590667171     ,
 597.879219233     , 586.12600005      , 556.129789853     , 510.855284601     ,
 454.341510234     , 391.058604769     , 325.718356207     , 262.994925462     ,
 206.781834053     , 159.310147178     , 120.91334759      , 90.6735039686     ,
 67.3017976137     , 49.6117986176     , 36.5780868464     , 27.2884023951     ,
 20.9579556835     , 16.9587607893     , 14.7701555712     , 13.8776729993     ,
 13.748503297      , 13.9385929539     , 14.2268025888     , 14.6351504181     ,
 15.3184838553     , 16.4237057383     , 18.0086424847     , 20.0339844372     ,
 22.3898061551     , 24.9109206604     , 27.3801576245     , 29.5764491389     ,
 31.3839252246     , 32.8635234011     , 34.195052188      , 35.5467139011     ,
 37.0144694161     , 38.6974423205     , 40.8201349744     , 43.7356249336     ,
 47.79026773       , 53.2449460695     , 60.3656413325     , 69.5142422349     ,
 81.0869598644     , 95.4244275902     , 112.824852586     , 133.540030586     ,
 157.623390993     , 184.764009789     , 214.362235458     , 245.896730237     ,
 279.302011159     , 314.979796799     , 353.357548364     , 394.301930362     ,
 436.817083576     , 479.182149119     , 519.264733757     , 554.704757585     ,
 583.048689671     , 602.127493477     , 610.647244395     , 608.526482242     ,
 596.666588401     , 576.473846094     , 549.640240485     , 518.158823166     ,
 484.169003274     , 449.544245991     , 415.546111969     , 382.802089343     ,
 351.56995707      , 322.065907157     , 294.613991099     , 269.539657308     ,
 246.966288282     , 226.712844019     , 208.299668449     , 191.004793345     ,
 174.049868289     , 156.914316896     , 139.544110912     , 122.319690108     ,
 105.889192648     , 90.9359347845     , 77.8791651719     , 66.6656663451     ,
 56.8597505119     , 47.9732116169     , 39.757333787      , 32.2767159428     ,
 25.7902288794     , 20.55290045       , 16.6492864751     , 13.9235300373     ,
 12.0151060222     , 10.4929976204     , 9.04916986832     , 7.61940958211     ,
 6.31187571119     , 5.22957118286     , 4.39230678649     , 3.79047446381     ,
 3.42036667605     , 3.24160991767     , 3.15886184834     , 3.08311976522     ,
 2.98860937442     , 2.89325144478     , 2.80768891043     , 2.72294778409     ,
 2.63337605409     , 2.54836394782     , 2.47503242248     , 2.40039023964     ,
 2.30255791142     , 2.17474976519     , 2.02805311908     , 1.87938560727     ,
 1.75046835506     , 1.67131941105     , 1.67241478624     , 1.77215211893     ,
 1.96024022288     , 2.1759390478      , 2.31887079702     , 2.31791585205     ,
 2.19581250151     , 2.05074667472     , 1.97964866945     , 2.03361806899     ,
 2.23345327169     , 2.58940136662     , 3.08137313769     , 3.63129130552     ,
 4.12434089963     , 4.48630783347     , 4.76466945315     , 5.13439924367     ,
 5.79285687402     , 6.82237579374     , 8.15163984511     , 9.64725872786     ,
 11.2443911145     , 13.025174174      , 15.2321959694     , 18.2344178103     ,
 22.425980429      , 28.049850527      , 35.0554709236     , 43.1557989939     ,
 52.0715265676     , 61.7188852609     , 72.1576599964     , 83.4148592975     ,
 95.4232302809     , 108.105604984     , 121.418076989     , 135.265740618     ,
 149.440453473     , 163.693049467     , 177.837930283     , 191.793784952     ,
 205.616857696     , 219.517532678     , 233.688072577     , 247.979294783     ,
 261.913071476     , 275.387623707     , 289.545057093     , 306.790598643     ,
 329.750281465     , 360.016589206     , 397.510620332     , 440.516153051     ,
 485.964685358     , 529.634683401     , 566.343852129     , 646.855204324     ,
 641.155410743     , 613.662070956     , 566.992027555     , 506.236420786     ,
 437.310929166     , 365.720018734     , 296.163730448     , 232.562755174     ,
 177.836679928     , 133.370475185     , 98.8318519925     , 72.7513558515     ,
 53.3974022861     , 39.2920205533     , 29.2786833989     , 22.4337273826     ,
 18.0144629411     , 15.4367169917     , 14.2304155786     , 13.9856310438     ,
 14.3433835379     , 15.0449226916     , 15.978247164      , 17.1651396051     ,
 18.7116580769     , 20.7604126219     , 23.4300602973     , 26.7395696964     ,
 30.5629904575     , 34.6266245907     , 38.5321611201     , 41.8566728217     ,
 44.3559796309     , 46.1109441517     , 47.4320517442     , 48.6051334481     ,
 49.751625398      , 50.9399684647     , 52.4002416068     , 54.5694450416     ,
 57.9064896639     , 62.7345012101     , 69.3009780425     , 77.8896986652     ,
 88.8064455195     , 102.35622143      , 118.90786248      , 138.864260713     ,
 162.386283259     , 189.066332347     , 217.964681525     , 248.170822864     ,
 279.456346043     , 312.352040086     , 347.515222348     , 384.930694782     ,
 423.588903452     , 461.786468688     , 497.597216301     , 529.059274337     ,
 554.210970137     , 571.3659937       , 579.561615329     , 578.714426086     ,
 569.330093201     , 552.184465521     , 528.376124801     , 499.558576696     ,
 467.846788491     , 435.29370718      , 403.353396715     , 372.730808434     ,
 343.626033055     , 316.106040238     , 290.347248319     , 266.660345815     ,
 245.34761437      , 226.471054547     , 209.619827562     , 193.875896159     ,
 178.165947404     , 161.804023734     , 144.761740489     , 127.546714934     ,
 110.949914182     , 95.7778563244     , 82.521304843      , 71.1228414038     ,
 61.089987332      , 51.8753336736     , 43.199019373      , 35.1318290457     ,
 27.9801599573     , 22.0763562677     , 17.5818590571     , 14.3922654025     ,
 12.1624136993     , 10.4379316827     , 8.86550451694     , 7.34955784034     ,
 5.99692516754     , 4.91345115701     , 4.09415513137     , 3.48535344928     ,
 3.06159450479     , 2.80753779492     , 2.67564880277     , 2.6021434704      ,
 2.55038476326     , 2.51826177869     , 2.50911963061     , 2.51009586794     ,
 2.50154934812     , 2.47503244192     , 2.42821099289     , 2.3501876872      ,
 2.2315203644      , 2.08508271286     , 1.93926801368     , 1.8144896284      ,
 1.7189862478      , 1.65910292221     , 1.6429352593      , 1.68001066683     ,
 1.77383053106     , 1.89817795984     , 1.98966417097     , 1.99282473795     ,
 1.91635322308     , 1.82759779945     , 1.79488520615     , 1.8543908226      ,
 2.02841020095     , 2.34136680221     , 2.7916975771      , 3.31549704544     ,
 3.8035724024      , 4.18024720824     , 4.48687835739     , 4.88907278769     ,
 5.57683269407     , 6.63126307078     , 7.97833442459     , 9.47637265807     ,
 11.0681362697     , 12.8818852767     , 15.227171946      , 18.524363883      ,
 23.2071106953     , 29.5759279239     , 37.6353032129     , 47.0776778017     ,
 57.4994307122     , 68.659993867      , 80.535365471      , 93.1795499823     ,
 106.598510691     , 120.722282932     , 135.388301734     , 150.318824345     ,
 165.202583709     , 179.855831524     , 194.273889998     , 208.547241802     ,
 222.815127039     , 237.270161711     , 252.029933792     , 266.953102365     ,
 281.86173609      , 297.311618478     , 315.176923505     , 338.205229956     ,
 368.762445331     , 407.72876771      , 454.0175344       , 504.581331325     ,
 554.79198501      , 599.076912354     , 631.569602486     , 691.756886153     ,
 669.113592123     , 623.590538893     , 559.836743298     , 484.908173295     ,
 406.161221771     , 329.571709053     , 259.271282651     , 197.956274076     ,
 147.236601269     , 107.502150261     , 77.8014052811     , 56.2788316437     ,
 40.9455226249     , 30.1944436091     , 22.8743176865     , 18.1499281309     ,
 15.3718697275     , 14.0114310056     , 13.6431848868     , 13.9537851767     ,
 14.7546047831     , 15.9757711361     , 17.6256319245     , 19.7425080978     ,
 22.4013018473     , 25.7545340001     , 29.9873036585     , 35.1615489085     ,
 41.0903851767     , 47.3344308753     , 53.2746610231     , 58.2631815884     ,
 61.8874060603     , 64.1752844784     , 65.4905552552     , 66.2001450991     ,
 66.4836148459     , 66.4756108431     , 66.5341249079     , 67.2802797895     ,
 69.3469658892     , 73.1571759543     , 78.9556963621     , 86.9163666636     ,
 97.1631957666     , 109.843649493     , 125.296011165     , 144.044823497     ,
 166.431285134     , 192.103703833     , 219.930445852     , 248.661321235     ,
 277.826397066     , 307.944914228     , 339.815279182     , 373.574338263     ,
 408.329133723     , 442.531749886     , 474.54268047      , 502.809320189     ,
 525.789045177     , 542.084525034     , 550.780126096     , 551.576225375     ,
 544.613897451     , 530.317844564     , 509.520209636     , 483.679811674     ,
 454.781277561     , 424.818957057     , 395.251067899     , 366.825306388     ,
 339.771157239     , 314.106052129     , 289.898322935     , 267.43308215      ,
 247.17237151      , 229.418790332     , 213.852186868     , 199.387266014     ,
 184.642026223     , 168.694640578     , 151.498167357     , 133.761108799     ,
 116.572452474     , 100.967281477     , 87.4929098239     , 75.9973277863     ,
 65.8416832275     , 56.3632820587     , 47.2249427745     , 38.5000961232     ,
 30.5588540553     , 23.84098898       , 18.6156941897     , 14.8472396585     ,
 12.2089940851     , 10.2263894217     , 8.50846844045     , 6.92621304172     ,
 5.56657292494     , 4.51973642608     , 3.75408187131     , 3.1802495382      ,
 2.75153495711     , 2.46436950211     , 2.30319249598     , 2.22384044604     ,
 2.18381541596     , 2.16840515453     , 2.18053989838     , 2.2127929883      ,
 2.24085343896     , 2.24106376898     , 2.20015311346     , 2.11328338331     ,
 1.99195801171     , 1.86908179646     , 1.77612710014     , 1.71694872606     ,
 1.67477160363     , 1.63643570797     , 1.60250227044     , 1.58585555742     ,
 1.60310318899     , 1.65114102057     , 1.69333422189     , 1.69026739777     ,
 1.64608038062     , 1.60706208925     , 1.6177842906      , 1.70109504936     ,
 1.87955509187     , 2.18269597584     , 2.60973108701     , 3.09647681131     ,
 3.543322668       , 3.89457025739     , 4.20497283159     , 4.63077354953     ,
 5.33766383444     , 6.3911516618      , 7.721434127       , 9.20653530315     ,
 10.8230943035     , 12.7477884809     , 15.3399709421     , 19.0563742606     ,
 24.3654614316     , 31.6252098404     , 40.8996311292     , 51.8704401506     ,
 64.0136535605     , 76.9199420998     , 90.4566606807     , 104.677680169     ,
 119.65043567      , 135.330262328     , 151.464615324     , 167.584650788     ,
 183.217780241     , 198.197355677     , 212.735863043     , 227.210043584     ,
 241.945282239     , 257.143423842     , 272.831082541     , 288.891473909     ,
 305.521000629     , 324.010414483     , 346.96062658      , 377.308173481     ,
 416.824623419     , 465.184561996     , 519.774098846     , 575.880630281     ,
 627.311577382     , 667.480682838     , 690.465359104     , 719.150952495     ,
 677.072865538     , 612.970728584     , 533.517657215     , 447.348755937     ,
 362.596765501     , 285.000647907     , 217.586240442     , 161.514809963     ,
 116.940770269     , 83.2331771495     , 58.9205083398     , 41.9646644142     ,
 30.3508017524     , 22.5264072087     , 17.4551830179     , 14.4433340932     ,
 12.9621264542     , 12.5598498887     , 12.8664107721     , 13.6474768501     ,
 14.8400276293     , 16.5237924927     , 18.8326290872     , 21.8758571533     ,
 25.7617955652     , 30.6816208094     , 36.867381109      , 44.3732200444     ,
 52.8908327273     , 61.7680308635     , 70.1527587882     , 77.1844656603     ,
 82.269711301      , 85.3129949829     , 86.636082667      , 86.6371586739     ,
 85.5864871698     , 83.7776072809     , 81.7956631206     , 80.5156838823     ,
 80.7950870791     , 83.2135761316     , 88.0605374088     , 95.3876295253     ,
 105.045092848     , 116.886325439     , 131.094996211     , 148.252694589     ,
 168.913026227     , 192.933578602     , 219.230144288     , 246.407657182     ,
 273.765236429     , 301.631725202     , 330.718954409     , 361.19787441      ,
 392.349838142     , 422.963871757     , 451.863064178     , 477.946518194     ,
 499.940688064     , 516.435787965     , 526.253757677     , 528.74959094      ,
 523.85095078      , 511.97157944      , 493.980511307     , 471.22765088      ,
 445.4305401       , 418.312674721     , 391.213096        , 364.943983528     ,
 339.866435811     , 316.040152267     , 293.462462575     , 272.358566149     ,
 253.239334276     , 236.514133861     , 221.902888363     , 208.224198432     ,
 193.89133405      , 177.787927619     , 159.849111177     , 141.023607439     ,
 122.785501838     , 106.470878858     , 92.6947927764     , 81.1624977938     ,
 71.0057745155     , 61.3603296161     , 51.7751593509     , 42.3163093254     ,
 33.4449500494     , 25.7518070652     , 19.6531679442     , 15.2019977109     ,
 12.090626487      , 9.82003999593     , 7.96034459673     , 6.3409880588      ,
 5.00995781926     , 4.02769374487     , 3.34104887766     , 2.839228982       ,
 2.45575183161     , 2.18186595604     , 2.01490139009     , 1.92621258662     ,
 1.87610628426     , 1.84381534883     , 1.8317161076      , 1.84075698275     ,
 1.85329615274     , 1.84331473995     , 1.79429929079     , 1.70968913552     ,
 1.61774803369     , 1.55883815406     , 1.5508965456      , 1.57036831019     ,
 1.57673269847     , 1.54916257306     , 1.49570276434     , 1.44142930133     ,
 1.41252996881     , 1.41540750742     , 1.4265529262      , 1.41814751773     ,
 1.39508784212     , 1.39212251469     , 1.43977115258     , 1.55565282246     ,
 1.76472112734     , 2.09229104216     , 2.51939882381     , 2.9653628571      ,
 3.33990446909     , 3.62311300354     , 3.90127412756     , 4.32885700002     ,
 5.04368104774     , 6.09086532819     , 7.40991766362     , 8.91269831414     ,
 10.6160492769     , 12.7306396832     , 15.6415228952     , 19.8272285911     ,
 25.7872086748     , 33.9396051663     , 44.4309465028     , 56.9859775676     ,
 71.0204636256     , 85.9816897978     , 101.600171975     , 117.862744428     ,
 134.832267583     , 152.463193439     , 170.424213825     , 188.051890184     ,
 204.652504381     , 219.994923733     , 234.486925879     , 248.858333944     ,
 263.731688798     , 279.444069375     , 296.096097202     , 313.788085227     ,
 333.196782756     , 356.236042479     , 385.89807219      , 424.867238955     ,
 473.868135771     , 530.93136271      , 591.583781875     , 649.419093102     ,
 697.070662919     , 727.643868542     , 735.961673186     , 724.589496526     ,
 662.761002172     , 581.686189133     , 489.764487694     , 396.620901591     ,
 310.378430041     , 235.825345581     , 174.474783022     , 125.869972064     ,
 88.8009084953     , 61.7499587828     , 42.8815441494     , 30.1710569846     ,
 21.7826237471     , 16.3673903157     , 13.069958251      , 11.3502958991     ,
 10.8057746163     , 11.0801799314     , 11.8734111544     , 13.0120894752     ,
 14.5042228061     , 16.5230938475     , 19.317071109      , 23.1120521274     ,
 28.1106977854     , 34.5634477659     , 42.7162195026     , 52.5641535864     ,
 63.646483098      , 75.0984852239     , 85.8646533243     , 94.9211539161     ,
 101.528806879     , 105.450916719     , 106.904047703     , 106.257236702     ,
 103.845695032     , 100.123698432     , 95.9137116974     , 92.3588555629     ,
 90.5730022765     , 91.3493828925     , 95.0802688314     , 101.717714723     ,
 110.808637398     , 121.842047295     , 134.761649208     , 150.134762659     ,
 168.70766656      , 190.631623576     , 215.071877788     , 240.705173046     ,
 266.669762866     , 292.976126128     , 320.034595998     , 347.912219404     ,
 376.096593931     , 403.877806799     , 430.68926965      , 455.864406548     ,
 478.187127435     , 495.937683106     , 507.451776113     , 511.693145496     ,
 508.509433557     , 498.538434953     , 482.912807291     , 462.994791763     ,
 440.220867821     , 415.957049272     , 391.353975173     , 367.264153416     ,
 344.178972054     , 322.223382399     , 301.378749299     , 281.831965032     ,
 264.036977436     , 248.309562818     , 234.283790273     , 220.742769667     ,
 206.077037402     , 189.139794719     , 169.922416915     , 149.607659828     ,
 130.012010016     , 112.74383975      , 98.4956212476     , 86.8471577587     ,
 76.6764163658     , 66.8523223433     , 56.7550829839     , 46.4347829034     ,
 36.4717092777     , 27.6452257173     , 20.549021127      , 15.3399903743     ,
 11.7291089958     , 9.18367462312     , 7.22084834171     , 5.60893189484     ,
 4.33766701768     , 3.43254053818     , 2.83168318157     , 2.41885669805     ,
 2.10952061325     , 1.87691824472     , 1.71910352069     , 1.62331857957     ,
 1.56124046256     , 1.50964277472     , 1.46501078806     , 1.43196398183     ,
 1.40451768621     , 1.36658858265     , 1.30816424871     , 1.23994742023     ,
 1.19464505955     , 1.20501854668     , 1.26933495245     , 1.34367909239     ,
 1.37752739902     , 1.35333326418     , 1.29070930023     , 1.22517010497     ,
 1.18610732881     , 1.17939819962     , 1.18445554499     , 1.1793516047      ,
 1.17059337129     , 1.18811775911     , 1.25863018672     , 1.4031987209      ,
 1.65055490197     , 2.01526953539     , 2.45111468741     , 2.85520281722     ,
 3.14665750087     , 3.34578857318     , 3.57605718013     , 3.99478061812     ,
 4.71496146817     , 5.76418729279     , 7.09599781213     , 8.6594165924      ,
 10.5050299744     , 12.8616231052     , 16.1282056287     , 20.8041759215     ,
 27.4185988707     , 36.4444137698     , 48.1273982637     , 62.2997383466     ,
 78.4082736079     , 95.8166805091     , 114.105644363     , 133.118285098     ,
 152.815241941     , 173.073071591     , 193.442779761     , 213.050776635     ,
 230.957149302     , 246.816799741     , 261.17998478      , 275.110224794     ,
 289.580942691     , 305.238039994     , 322.56167602      , 342.20149742      ,
 365.448303383     , 394.587559473     , 432.408918413     , 480.657817358     ,
 538.460288202     , 601.877332885     , 664.544572003     , 718.737219991     ,
 756.711488464     , 772.260097234     , 761.80023871      , 706.004692027     ,
 626.477040216     , 532.191301916     , 432.634385591     , 337.623549966     ,
 254.479471705     , 186.492697431     , 133.496180058     , 93.5657090188     ,
 64.416170548      , 43.9159729144     , 30.0714200478     , 21.0323177431     ,
 15.2701913701     , 11.7184390042     , 9.72468601599     , 8.89323412424     ,
 8.93914181049     , 9.60636557147     , 10.6710026119     , 12.0095802249     ,
 13.6651886042     , 15.8552579457     , 18.9042355886     , 23.1443019758     ,
 28.8788786041     , 36.4103739479     , 45.9709442403     , 57.4835743832     ,
 70.3692159839     , 83.6223178355     , 96.0665898561     , 106.601976858     ,
 114.428119326     , 119.218283425     , 121.075007837     , 120.272999939     ,
 117.110913624     , 112.090257628     , 106.173642671     , 100.711791839     ,
 97.0522570648     , 96.2071971109     , 98.7048605999     , 104.468227891     ,
 112.837384443     , 123.009704673     , 134.689880459     , 148.360273418     ,
 164.87075894      , 184.641346948     , 207.174884585     , 231.365423796     ,
 256.272879135     , 281.557713755     , 307.247940559     , 333.271755089     ,
 359.363665027     , 385.374917527     , 411.340481425     , 436.913474603     ,
 460.764144593     , 480.723322985     , 494.578659104     , 500.891614138     ,
 499.436177552     , 491.129438405     , 477.507696925     , 460.110744418     ,
 440.184564284     , 418.734384074     , 396.664497515     , 374.773371493     ,
 353.58689162      , 333.289588564     , 313.967422255     , 295.891784452     ,
 279.420697008     , 264.585904249     , 250.777194093     , 236.760072717     ,
 221.071713694     , 202.72629124      , 181.866737838     , 159.86743686      ,
 138.761672085     , 120.332755145     , 105.34992014      , 93.326230159      ,
 82.9200720796     , 72.7168787701     , 61.9039480263     , 50.5233130698     ,
 39.3049312533     , 29.2402003751     , 21.1040620544     , 15.1474801643     ,
 11.0850984309     , 8.33409483298     , 6.34028999061     , 4.79217770694     ,
 3.60992766884     , 2.78669979393     , 2.26522848394     , 1.93674391342     ,
 1.7029151467      , 1.5157855086      , 1.37043028696     , 1.27099754832     ,
 1.20546003226     , 1.15118129365     , 1.0953685137      , 1.03895632682     ,
 0.983619724472    , 0.925929761371    , 0.866164595187    , 0.818695991566    ,
 0.80986994384     , 0.857780047498    , 0.947859460874    , 1.03414911583     ,
 1.07295051455     , 1.05471197012     , 1.00384608028     , 0.956218794683    ,
 0.936901004512    , 0.946250809354    , 0.962366474148    , 0.966034373394    ,
 0.965341995381    , 0.989904278788    , 1.06905241204     , 1.22968517879     ,
 1.50088223275     , 1.88453470232     , 2.31387782128     , 2.6745362358      ,
 2.89777614912     , 3.03485995091     , 3.23407176533     , 3.65110549829     ,
 4.37899853658     , 5.43573469665     , 6.79381429985     , 8.43744329882     ,
 10.4427052276     , 13.0519008359     , 16.6882744676     , 21.892912235      ,
 29.2369097866     , 39.2427690943     , 52.2524713244     , 68.2400659853     ,
 86.7640391298     , 107.188553427     , 128.970862557     , 151.753274671     ,
 175.27157286      , 199.174840274     , 222.772635146     , 244.934885477     ,
 264.506529044     , 281.066371731     , 295.281080928     , 308.477957055     ,
 321.978810292     , 336.908549653     , 354.46491357      , 376.194075515     ,
 404.092723729     , 440.457824319     , 487.135760035     , 544.135761638     ,
 608.458327907     , 674.088667126     , 733.113003096     , 777.26466732      ,
 799.511001957     , 795.418803301     , 763.71977984      , 663.683537032     ,
 570.579031131     , 468.548521006     , 367.222936995     , 275.657000068     ,
 199.679552175     , 140.827284499     , 97.3860304976     , 66.3176005383     ,
 44.6649602803     , 30.0165257047     , 20.4358535296     , 14.3584394817     ,
 10.6085458314     , 8.40903737011     , 7.29669687007     , 6.99965257429     ,
 7.33417119491     , 8.13560067539     , 9.25305454731     , 10.6098853169     ,
 12.2710862859     , 14.4620858456     , 17.5224734435     , 21.8224472551     ,
 27.7108396841     , 35.5057861151     , 45.4146119981     , 57.3239703827     ,
 70.6322952977     , 84.3242532796     , 97.2302863527     , 108.286385819     ,
 116.734146918     , 122.237990768     , 124.812957424     , 124.588371646     ,
 121.704301767     , 116.549963776     , 110.071552531     , 103.696258583     ,
 98.8972876741     , 96.8201976008     , 98.1033371766     , 102.733101047     ,
 110.052770235     , 119.192174677     , 129.72445541      , 141.991296607     ,
 156.794620376     , 174.697223702     , 195.518325507     , 218.432661682     ,
 242.49733535      , 267.080021459     , 291.890331013     , 316.793086705     ,
 341.796426403     , 367.224359917     , 393.532466535     , 420.535680263     ,
 446.75821405      , 469.667671307     , 486.601726658     , 495.716488047     ,
 496.600009526     , 490.346876921     , 478.912944084     , 464.111137511     ,
 447.068653881     , 428.444358747     , 408.860946868     , 388.975409657     ,
 369.265261733     , 350.0127296       , 331.585179481     , 314.507011401     ,
 299.053686467     , 284.851222769     , 270.92659759      , 256.011684122     ,
 238.869581015     , 218.771134995     , 196.039235562     , 172.176201023     ,
 149.32950293      , 129.397172857     , 113.245101236     , 100.389268479     ,
 89.3289560099     , 78.3895767867     , 66.5732280788     , 53.9350479532     ,
 41.3823979841     , 30.1215245139     , 21.0742134194     , 14.5339279547     ,
 10.1769757423     , 7.34798880346     , 5.41399079357     , 3.98496053269     ,
 2.91782848978     , 2.18113266778     , 1.72909657619     , 1.46765903074     ,
 1.29294481297     , 1.14175408393     , 1.00649780618     , 0.905157573383    ,
 0.841506540354    , 0.797211803296    , 0.752744678946    , 0.701809904079    ,
 0.646439882847    , 0.590172908433    , 0.54003987231     , 0.509710750686    ,
 0.515063139193    , 0.561629275434    , 0.63334503153     , 0.697582765056    ,
 0.727431265912    , 0.720396657434    , 0.696532278171    , 0.682317842648    ,
 0.693736360488    , 0.725491232926    , 0.755255567205    , 0.766468395414    ,
 0.769029467237    , 0.79405995334     , 0.8742677514      , 1.03766155493     ,
 1.30614788459     , 1.67026050796     , 2.05977944565     , 2.37059647026     ,
 2.55200579031     , 2.66934732623     , 2.87137608567     , 3.30035767724     ,
 4.03421362652     , 5.09156366013     , 6.46786306518     , 8.17822678533     ,
 10.3200447491     , 13.1572526791     , 17.1627980216     , 22.9556551756     ,
 31.1827169106     , 42.433941238      , 57.1493293228     , 75.4602235111     ,
 97.1029437678     , 121.544607631     , 148.181639329     , 176.405039184     ,
 205.545231872     , 234.757162124     , 262.855584998     , 288.334361533     ,
 309.879822194     , 327.128805462     , 340.936080832     , 352.887850563     ,
 364.695335613     , 378.152284171     , 395.474518941     , 419.336661284     ,
 452.362649349     , 496.332637061     , 551.31407296      , 614.827888108     ,
 681.447727547     , 743.355969657     , 791.850820977     , 819.209031058     ,
 820.282618705     , 793.345687024     , 739.871196672     , 600.188746666     ,
 499.130536507     , 395.749347879     , 298.732296505     , 215.427821686     ,
 149.693421367     , 101.370291154     , 67.5993988657     , 44.7246921733     ,
 29.5536554828     , 19.7075820237     , 13.4795694022     , 9.64338403859     ,
 7.356976674       , 6.09048882144     , 5.53220968378     , 5.50603138501     ,
 5.9073593263      , 6.64667415816     , 7.63827137981     , 8.85164464316     ,
 10.3691250109     , 12.396627422      , 15.2269165307     , 19.1833688724     ,
 24.581457249      , 31.7091987276     , 40.7526450351     , 51.623813247      ,
 63.814296531      , 76.4431509595     , 88.4830895474     , 99.0093985011     ,
 107.378512381     , 113.299202372     , 116.728466332     , 117.639621499     ,
 115.955035249     , 111.849045756     , 106.115375749     , 100.099097392     ,
 95.2289340886     , 92.6235137662     , 92.9379749545     , 96.27552993       ,
 102.202265179     , 110.065561444     , 119.496065441     , 130.693983317     ,
 144.264393601     , 160.741816982     , 180.168279418     , 202.000520882     ,
 225.360679501     , 249.438141391     , 273.768185886     , 298.264163459     ,
 323.18631882      , 349.137369467     , 376.736709165     , 405.830849623     ,
 434.888930408     , 461.245537236     , 481.987018969     , 494.908516868     ,
 499.292468968     , 496.211453953     , 487.865169307     , 476.242939338     ,
 462.342618505     , 446.529180754     , 429.199989534     , 410.885381962     ,
 392.029124764     , 373.093620934     , 354.852356223     , 338.161228693     ,
 323.219365614     , 309.226131042     , 294.829579861     , 278.714628261     ,
 259.852614018     , 237.73502004      , 212.799616365     , 186.613681887     ,
 161.430083919     , 139.31223711      , 121.292589499     , 106.953724387     ,
 94.6942561409     , 82.62825681       , 69.6014037378     , 55.6914589783     ,
 41.9719380052     , 29.8187330575     , 20.2216984442     , 13.4341602614     ,
 9.0412794376      , 6.30189415809     , 4.51959510791     , 3.25354190221     ,
 2.32173283992     , 1.67870090586     , 1.29023490409     , 1.07926066937     ,
 0.946488816786    , 0.823204424867    , 0.699068885818    , 0.598359585107    ,
 0.535840127283    , 0.500527579201    , 0.472408819296    , 0.44013603506     ,
 0.402349403401    , 0.36304835298     , 0.330087731718    , 0.313169117581    ,
 0.318801702428    , 0.345414780666    , 0.382202575895    , 0.414069458196    ,
 0.431010597028    , 0.434495872888    , 0.435805239978    , 0.448881507222    ,
 0.481029933204    , 0.524929309591    , 0.56153450273     , 0.578084932132    ,
 0.585131335699    , 0.613126738622    , 0.694353884311    , 0.851272029278    ,
 1.09233306024     , 1.39922391344     , 1.71422380656     , 1.96399187013     ,
 2.1230112245      , 2.25625391445     , 2.48905739354     , 2.93671457871     ,
 3.66536684588     , 4.70400088298     , 6.07410594759     , 7.81735591619     ,
 10.0518682016     , 13.0753699102     , 17.4348978544     , 23.8642829772     ,
 33.1402997564     , 45.9846872592     , 62.996193237      , 84.5331269973     ,
 110.62050407      , 140.966220926     , 174.979178132     , 211.699135111     ,
 249.733438815     , 287.263205692     , 322.118460548     , 352.110464291     ,
 375.758354894     , 392.985191703     , 405.130488984     , 414.30757939      ,
 422.885727426     , 433.625159825     , 450.001168306     , 475.820973716     ,
 513.940856877     , 564.845856046     , 625.947214367     , 691.736893796     ,
 754.46569432      , 805.256566632     , 835.755996859     , 840.01308219      ,
 815.801870309     , 764.693643571     , 690.93915956      , 520.500072219     ,
 417.814375557     , 319.413776527     , 232.044916886     , 160.651246579     ,
 106.942954661     , 69.3763217868     , 44.4953760967     , 28.5612476989     ,
 18.5437682745     , 12.3353932513     , 8.55637990858     , 6.31333676879     ,
 5.04045665437     , 4.39296806028     , 4.16614181599     , 4.24918566322     ,
 4.59143679121     , 5.15896850676     , 5.92059600115     , 6.88664975711     ,
 8.14783437636     , 9.86894548745     , 12.2565300073     , 15.5329003382     ,
 19.9258900353     , 25.6611967981     , 32.9098807918     , 41.6571085316     ,
 51.5700830402     , 62.0041965829     , 72.1680386517     , 81.3325269953     ,
 88.9863309151     , 94.8897748258     , 98.9654698704     , 101.07234279      ,
 100.954005736     , 98.5722946678     , 94.5062900606     , 89.8937407665     ,
 85.9558014747     , 83.6148525393     , 83.41535912       , 85.5561420178     ,
 89.9430680928     , 96.3490300746     , 104.652028214     , 114.984197251     ,
 127.690339771     , 143.136903665     , 161.461496673     , 182.357359176     ,
 205.074116507     , 228.768127422     , 252.960245403     , 277.696067645     ,
 303.421299107     , 330.811401038     , 360.429513032     , 392.073141979     ,
 424.267688976     , 454.439084897     , 479.637238844     , 497.412197517     ,
 506.693109634     , 508.290269975     , 504.300872108     , 496.632691614     ,
 486.119754484     , 472.97284571      , 457.532238638     , 440.32717484      ,
 421.868922414     , 402.862141915     , 384.449295617     , 367.71181954      ,
 352.730171057     , 338.35332069      , 322.949021174     , 305.174342937     ,
 284.149186345     , 259.492828975     , 231.67034571      , 202.287016747     ,
 173.776855069     , 148.501011043     , 127.7536306       , 111.221680847     ,
 97.2424612741     , 83.7871269681     , 69.5960153577     , 54.7517666437     ,
 40.4059224984     , 27.9793048911     , 18.409472988      , 11.8285117788     ,
 7.70368276432     , 5.22536602258     , 3.67385533591     , 2.60144402247     ,
 1.81916123532     , 1.2789084147      , 0.955549213361    , 0.788520528454    ,
 0.69114185682     , 0.597036820086    , 0.491538127603    , 0.396854775406    ,
 0.332989339616    , 0.297825057974    , 0.27668072418     , 0.25785047582     ,
 0.237270013449    , 0.21665450748     , 0.201229313612    , 0.195846389325    ,
 0.200638437787    , 0.210898855006    , 0.221126176849    , 0.228696195784    ,
 0.234547923266    , 0.241733454445    , 0.254185473916    , 0.276374045164    ,
 0.310689455379    , 0.352061572988    , 0.38805802264     , 0.410218206647    ,
 0.427028776589    , 0.463509244999    , 0.546569752827    , 0.689954378576    ,
 0.888603490548    , 1.11899742201     , 1.34332062495     , 1.52768823922     ,
 1.6750654919      , 1.84264985536     , 2.11830049414     , 2.58052113604     ,
 3.28438399892     , 4.27575312608     , 5.60538889774     , 7.34061661605     ,
 9.62253918813     , 12.7903313086     , 17.4767243799     , 24.5600296092     ,
 35.0212858568     , 49.8441573782     , 69.9646779758     , 96.1934915145     ,
 129.110614972     , 168.913742905     , 215.123612344     , 266.215031595     ,
 319.448752199     , 371.070139015     , 416.889449916     , 453.292214945     ,
 478.462965716     , 493.056000803     , 499.729705864     , 502.034550084     ,
 503.756997245     , 509.106217501     , 522.914803632     , 549.741354546     ,
 591.852970407     , 647.447043291     , 710.534479449     , 772.437786789     ,
 823.660080212     , 855.381803903     , 860.901323441     , 837.168058629     ,
 785.572040207     , 711.12551984      , 620.503753888     , 431.820757152     ,
 333.534269706     , 245.338639468     , 171.359426448     , 113.860710478     ,
 72.5694395718     , 45.0138439746     , 27.6743036642     , 17.1751415658     ,
 10.9404993739     , 7.27503729124     , 5.15034064778     , 3.95891418579     ,
 3.34099121248     , 3.0785147427      , 3.03678874523     , 3.1449077379      ,
 3.38293861812     , 3.75250682859     , 4.26223462129     , 4.9499154098      ,
 5.89968817914     , 7.22323959938     , 9.03539714324     , 11.4532167161     ,
 14.6087823284     , 18.657288896      , 23.7528310019     , 29.9596748635     ,
 37.1360783863     , 44.8984103003     , 52.7115959106     , 60.0403689142     ,
 66.485663868      , 71.8501793401     , 76.0513965896     , 78.9089843006     ,
 80.0883483239     , 79.4172068866     , 77.2725886871     , 74.5288479198     ,
 72.1032496164     , 70.6137164748     , 70.3966220233     , 71.6801765164     ,
 74.6898119689     , 79.66002448       , 86.8045567651     , 96.2882157837     ,
 108.241668008     , 122.81358055      , 140.129216551     , 160.057180573     ,
 182.037527308     , 205.347244534     , 229.627603972     , 255.087447991     ,
 282.275065656     , 311.794821591     , 344.031322308     , 378.700354384     ,
 414.453879909     , 448.940971133     , 479.312724746     , 502.965302957     ,
 518.439288453     , 526.051946361     , 527.455873594     , 524.258571275     ,
 517.172396895     , 506.451248254     , 492.561915084     , 476.166827741     ,
 457.946689824     , 438.844338365     , 420.195731489     , 403.085248641     ,
 387.422180392     , 371.853242627     , 354.629240736     , 334.411191701     ,
 310.402900316     , 282.292536521     , 250.564427047     , 216.910383615     ,
 184.047764545     , 154.745517863     , 130.606858538     , 111.410148001     ,
 95.4436827646     , 80.6159445932     , 65.6347175016     , 50.5506909766     ,
 36.4386198592     , 24.5744599984     , 15.706416178      , 9.79569710547     ,
 6.212445289       , 4.13158383192     , 2.86541552007     , 2.00361687352     ,
 1.37804319028     , 0.947916624139    , 0.695708477772    , 0.575717126819    ,
 0.517087592645    , 0.459159639861    , 0.381098614167    , 0.297679672918    ,
 0.230660882268    , 0.187594794707    , 0.162526581319    , 0.146574883688    ,
 0.134381832875    , 0.125216290707    , 0.121449596149    , 0.124580707499    ,
 0.131647356479    , 0.136766261358    , 0.136546571381    , 0.13303917079     ,
 0.131369922999    , 0.135302387918    , 0.145623569757    , 0.162381512486    ,
 0.186345360316    , 0.216309604975    , 0.247014175043    , 0.273824583436    ,
 0.301247567475    , 0.345461929082    , 0.425146890636    , 0.546756691557    ,
 0.697909777687    , 0.855340876332    , 1.00046142608     , 1.13345138662     ,
 1.28091487949     , 1.49000111496     , 1.80950750764     , 2.27881058512     ,
 2.93994738642     , 3.85552219665     , 5.10755217156     , 6.79416884939     ,
 9.08700624476     , 12.3701744619     , 17.3634313068     , 25.1193624492     ,
 36.9310312971     , 54.269708805      , 78.7758186708     , 112.225522249     ,
 156.365589194     , 212.446570237     , 280.33642399      , 357.483516924     ,
 438.394861531     , 515.198744581     , 579.398975733     , 624.427573652     ,
 647.964265148     , 652.610677115     , 644.415761464     , 630.507557553     ,
 617.642687975     , 612.12303236      , 619.851865397     , 645.123213134     ,
 688.290285097     , 744.18678139      , 803.027830952     , 853.353016944     ,
 884.90723164      , 890.208524387     , 865.407367735     , 811.127452869     ,
 732.546281367     , 637.753182049     , 535.152404246     , 342.371222762     ,
 253.333361448     , 178.70509113      , 119.777672251     , 76.3366584304     ,
 46.5813800425     , 27.6063827171     , 16.2270203269     , 9.69691503759     ,
 6.03817021921     , 4.01086466922     , 2.90922017537     , 2.34737144191     ,
 2.10742888869     , 2.05407680401     , 2.09833087168     , 2.19339340502     ,
 2.33407881507     , 2.53949207537     , 2.83893002547     , 3.27852434753     ,
 3.92225604307     , 4.83139653088     , 6.05194568667     , 7.62787591371     ,
 9.62151179755     , 12.1281865645     , 15.2749780421     , 19.1724745168     ,
 23.8224736824     , 29.0535905309     , 34.5433398023     , 39.9130423332     ,
 44.8530821112     , 49.2105630673     , 52.9309638627     , 55.8636655462     ,
 57.6941997259     , 58.2113144225     , 57.6441562209     , 56.6114597848     ,
 55.7137269826     , 55.2539671653     , 55.346034685      , 56.1939400692     ,
 58.2280934038     , 62.0123776652     , 68.0356141667     , 76.5485149852     ,
 87.5730543826     , 101.090394336     , 117.178450407     , 135.848903881     ,
 156.795269475     , 179.544511562     , 203.94253991      , 230.346413532     ,
 259.337730418     , 291.392405762     , 326.69941892      , 364.918035557     ,
 404.882655279     , 444.515953219     , 481.070254828     , 511.719197918     ,
 534.480347297     , 548.991849567     , 556.297680492     , 557.682748179     ,
 553.873442527     , 545.328093659     , 532.726816824     , 516.911642516     ,
 498.763907623     , 479.403503957     , 460.175214863     , 442.004081908     ,
 424.665646906     , 406.8116601       , 386.742356807     , 363.117861214     ,
 335.135822604     , 302.539441628     , 265.935872601     , 227.235854298     ,
 189.512667875     , 155.936101059     , 128.354932711     , 106.569777487     ,
 88.8143955476     , 73.0093723035     , 57.8988243596     , 43.4564422576     ,
 30.5159498394     , 20.0252690591     , 12.4398203898     , 7.5478974246      ,
 4.68138398801     , 3.06916491288     , 2.10807297025     , 1.45698504589     ,
 0.985164785282    , 0.665435720006    , 0.487801621869    , 0.419328880854    ,
 0.40383392622     , 0.386099749165    , 0.338471856437    , 0.267264450798    ,
 0.195586150706    , 0.141217957588    , 0.107740963238    , 0.0893118973771   ,
 0.078916008375    , 0.0733478974151   , 0.0733207712072   , 0.0795401079427   ,
 0.0889422952852   , 0.0957175435498   , 0.0960295651731   , 0.0910904285416   ,
 0.0857514674927   , 0.0843527046659   , 0.0879227738354   , 0.0954858690775   ,
 0.107111126624    , 0.124050251854    , 0.146278268527    , 0.172265001699    ,
 0.203095593581    , 0.246413510195    , 0.312812837855    , 0.404776694234    ,
 0.510299822077    , 0.612096393314    , 0.706359536373    , 0.814069904909    ,
 0.974715741418    , 1.22605048671     , 1.58662676566     , 2.06242658011     ,
 2.67836909565     , 3.50477946642     , 4.65232120023     , 6.25955139361     ,
 8.54320365943     , 11.940090526      , 17.2662843901     , 25.8045786957     ,
 39.3366347784     , 60.207193734      , 91.4484640431     , 136.84723604      ,
 200.647375392     , 286.429706177     , 394.919768139     , 521.345895478     ,
 654.038867134     , 776.007207319     , 869.711682224     , 923.184499501     ,
 934.402408728     , 911.407198215     , 868.260414521     , 819.743777425     ,
 778.007437731     , 751.91421263      , 747.316073908     , 766.284656633     ,
 805.355801319     , 854.895584102     , 901.314891703     , 931.244674035     ,
 934.985405331     , 907.731709868     , 849.473143914     , 764.813786936     ,
 662.265708242     , 552.059230295     , 443.290298589     , 259.37558791      ,
 182.888657661     , 123.170029797     , 78.9711743837     , 48.1993163867     ,
 28.1573323528     , 15.9542487557     , 8.96602838371     , 5.15038772026     ,
 3.12653419293     , 2.07141224206     , 1.54256281553     , 1.31266925503     ,
 1.25605016967     , 1.29053967164     , 1.3586391948      , 1.43037485283     ,
 1.50696852758     , 1.61032134213     , 1.77035451425     , 2.02372950786     ,
 2.40955508105     , 2.95490763823     , 3.67144671076     , 4.57029400467     ,
 5.67738801744     , 7.04558971289     , 8.76568471552     , 10.9498198954     ,
 13.6685381545     , 16.878938409      , 20.4021226715     , 23.9763913936     ,
 27.3716225143     , 30.4869641446     , 33.3116874548     , 35.7555516773     ,
 37.579625803      , 38.6031147912     , 38.9667510134     , 39.0783708929     ,
 39.2745949559     , 39.6206515781     , 40.0761564484     , 40.8057490706     ,
 42.303731146      , 45.2513365432     , 50.2520132808     , 57.6204399922     ,
 67.3642093298     , 79.4036672953     , 93.8129115772     , 110.755043728     ,
 130.219044919     , 152.052601693     , 176.337785486     , 203.553474618     ,
 234.287858532     , 268.910498224     , 307.48034109      , 349.683033561     ,
 394.603956987     , 440.439954884     , 484.428250999     , 523.305049582     ,
 554.342938741     , 576.366187011     , 589.80292764      , 595.715633403     ,
 594.973273188     , 588.305993495     , 576.607096683     , 560.888227114     ,
 542.212300754     , 521.798191123     , 500.893275781     , 480.257390525     ,
 459.703793286     , 438.147567341     , 414.09680791      , 386.1768549       ,
 353.458720895     , 315.724640038     , 273.847531261     , 230.113181016     ,
 187.955467994     , 150.795722375     , 120.548794759     , 96.9337354469     ,
 78.1250278385     , 62.106656895      , 47.6894845298     , 34.7219639908     ,
 23.6859365207     , 15.1041920499     , 9.11605023769     , 5.3832312806      ,
 3.27085465348     , 2.12015833232     , 1.44515458485     , 0.986536300946    ,
 0.654247795897    , 0.435519851971    , 0.327543138022    , 0.308026612861    ,
 0.332603239871    , 0.350320876251    , 0.328104907952    , 0.26607967126     ,
 0.189631786015    , 0.125891666068    , 0.0862596936294   , 0.0662366428535   ,
 0.0559553535555   , 0.0495895757312   , 0.0473597258216   , 0.0511665181625   ,
 0.0597651831459   , 0.0684010445681   , 0.0722749034158   , 0.0700635217281   ,
 0.0647474567497   , 0.0609143335428   , 0.0606895406561   , 0.0628571724579   ,
 0.0661918309367   , 0.0722231481378   , 0.0837686077115   , 0.10192395765     ,
 0.12648477838     , 0.159493217244    , 0.205492592263    , 0.265413300995    ,
 0.331950931022    , 0.396551559202    , 0.465055058025    , 0.566534384571    ,
 0.74353292778     , 1.02798279276     , 1.42283936583     , 1.91166926413     ,
 2.49774802014     , 3.24415230725     , 4.28208449363     , 5.7992110861      ,
 8.07634843959     , 11.6260301385     , 17.406641327      , 27.0577194677     ,
 43.1644153341     , 69.6233060504     , 112.128502755     , 178.516461024     ,
 278.21323489      , 419.656451625     , 605.093955397     , 824.313103323     ,
 1051.627048       , 1250.53622852     , 1385.9520869      , 1437.93630884     ,
 1409.05158789     , 1321.40181442     , 1206.07626605     , 1091.87232291     ,
 998.899470857     , 937.849530825     , 911.844002017     , 917.576373906     ,
 945.293706779     , 979.764285407     , 1003.86932801     , 1003.57997939     ,
 971.369541846     , 906.556896805     , 813.784405525     , 701.477534973     ,
 580.390055851     , 461.358044128     , 352.768792333     , 187.466329474     ,
 125.353865607     , 80.2307689014     , 49.0222236105     , 28.5835352814     ,
 15.9766411967     , 8.6696596609      , 4.67583746793     , 2.59340715015     ,
 1.53902756626     , 1.01661594245     , 0.775625969277    , 0.694228854608    ,
 0.704387598293    , 0.758145172548    , 0.820666874841    , 0.875012063715    ,
 0.924467811768    , 0.9838730827      , 1.06984048576     , 1.20047167825     ,
 1.39489370588     , 1.66618777358     , 2.01983511098     , 2.46137648927     ,
 3.00287929543     , 3.67006075017     , 4.51635498517     , 5.62476921239     ,
 7.07229966423     , 8.86962891074     , 10.9229879333     , 13.0613444017     ,
 15.1300505802     , 17.0766866973     , 18.9219429759     , 20.6261196821     ,
 22.0345875773     , 23.0272532644     , 23.6998222943     , 24.3056070536     ,
 25.0018405396     , 25.7303219257     , 26.3944341603     , 27.127620386      ,
 28.3761469188     , 30.7564439829     , 34.8274006901     , 40.9057378921     ,
 49.0328180226     , 59.1685841302     , 71.4543251148     , 86.2177746465     ,
 103.734298473     , 124.171409204     , 147.848284851     , 175.370561041     ,
 207.372894137     , 244.210057728     , 285.930829154     , 332.349165251     ,
 382.836468462     , 435.802575881     , 488.324230312     , 536.517334351     ,
 576.747271985     , 606.927937522     , 626.846420651     , 637.352817418     ,
 639.462411064     , 634.170390042     , 622.598002301     , 605.967593573     ,
 585.537469657     , 562.584615183     , 538.236187808     , 513.180487678     ,
 487.48703818      , 460.587233298     , 431.366665267     , 398.439287574     ,
 360.678567139     , 317.873601188     , 271.23320522      , 223.48434347      ,
 178.328320971     , 139.187285776     , 107.796743137     , 83.6838979538     ,
 64.9676764371     , 49.7174799338     , 36.7983513592     , 25.8985555543     ,
 17.1276474642     , 10.6041542563     , 6.21281847449     , 3.56454034516     ,
 2.11737589322     , 1.35552197272     , 0.916647746895    , 0.617582748125    ,
 0.401584628326    , 0.26613161816     , 0.213772163923    , 0.230771950777    ,
 0.282420687209    , 0.322448800419    , 0.316009194496    , 0.260524057351    ,
 0.183333450115    , 0.117161990687    , 0.0773920917546   , 0.0591565909808   ,
 0.0498207437434   , 0.0416725514685   , 0.0351946673078   , 0.0340189113772   ,
 0.039004426687    , 0.0468068468649   , 0.0524669311262   , 0.0531321023979   ,
 0.0502909405681   , 0.0481486703578   , 0.0489381280054   , 0.0506210692412   ,
 0.0502567227251   , 0.0485791303893   , 0.0496920492666   , 0.0568180315443   ,
 0.0702062449177   , 0.0894111158621   , 0.115355677566    , 0.148313852852    ,
 0.185611753408    , 0.225954731766    , 0.279925601123    , 0.376725295493    ,
 0.557045030361    , 0.85240843585     , 1.26484520659     , 1.76794199135     ,
 2.34231182941     , 3.03122126255     , 3.97586162718     , 5.41513534712     ,
 7.71199008916     , 11.4997821607     , 17.9875837792     , 29.4233064847     ,
 49.7621946302     , 85.6581682582     , 147.7642594       , 251.693385875     ,
 416.855680243     , 660.607246017     , 986.608064657     , 1371.46405178     ,
 1759.83222275     , 2077.34698392     , 2258.99367509     , 2276.92573364     ,
 2150.29611122     , 1932.51458796     , 1686.36019777     , 1462.32401937     ,
 1289.16049734     , 1175.70915653     , 1117.32417803     , 1100.99462031     ,
 1107.98921998     , 1116.6005568      , 1106.8553671      , 1065.72252001     ,
 989.755385898     , 883.854463136     , 757.78661831      , 623.056781379     ,
 490.957157012     , 370.932367156     , 269.044055678     , 128.564080286     ,
 81.2811843063     , 49.290356444      , 28.6228095381     , 15.9103414225     ,
 8.50337053019     , 4.43034281192     , 2.31166934868     , 1.25540887605     ,
 0.738549944893    , 0.487928832715    , 0.377052913054    , 0.348822116729    ,
 0.370074215465    , 0.414903098677    , 0.46430184534     , 0.510223434051    ,
 0.554975479989    , 0.60293927255     , 0.654672138692    , 0.711615221974    ,
 0.781941397554    , 0.878035805774    , 1.01147655617     , 1.19163579121     ,
 1.42595808292     , 1.72411672335     , 2.10999344603     , 2.62987809616     ,
 3.33671601282     , 4.25064953112     , 5.32616373435     , 6.46430636388     ,
 7.57628411354     , 8.64238300577     , 9.68972632266     , 10.7026335035     ,
 11.5922425697     , 12.2975111795     , 12.8920081092     , 13.5263387127     ,
 14.2581772766     , 14.9984296473     , 15.6630326998     , 16.3628393784     ,
 17.441047039      , 19.3597856231     , 22.5461812315     , 27.2684258414     ,
 33.6116541753     , 41.6305221525     , 51.5740734091     , 63.9129708681     ,
 79.1411863742     , 97.6882525011     , 120.101041852     , 147.159084944     ,
 179.646549363     , 218.052273522     , 262.564215142     , 313.193906321     ,
 369.53777689      , 430.083582729     , 491.658959011     , 549.759121137     ,
 599.848595209     , 638.852823379     , 665.750966527     , 680.990144868     ,
 685.600152631     , 680.826602533     , 668.113781866     , 649.025067146     ,
 625.10588169      , 597.739945448     , 567.990085794     , 536.568921729     ,
 503.929328274     , 470.165932855     , 434.703768847     , 396.290730722     ,
 353.679556853     , 306.659136297     , 256.712657556     , 206.894153255     ,
 160.961569602     , 122.04705185      , 91.4639175538     , 68.4560832042     ,
 51.1012760115     , 37.5640620485     , 26.742401289      , 18.168882087      ,
 11.6495895363     , 7.00996099726     , 3.98765571703     , 2.2157898909      ,
 1.27751944519     , 0.801436609346    , 0.535139678752    , 0.355507577875    ,
 0.227554361281    , 0.153036155568    , 0.136920203623    , 0.17180151039     ,
 0.231752407014    , 0.277698764658    , 0.277998313242    , 0.230158201286    ,
 0.160736084744    , 0.101922537928    , 0.0685467075983   , 0.0548562059504   ,
 0.0474275725417   , 0.0384828946486   , 0.0291964199271   , 0.02424359143     ,
 0.0255824101788   , 0.030849277449    , 0.0357283959468   , 0.0374869140317   ,
 0.0371806611609   , 0.0382223078059   , 0.0419238829649   , 0.045178972381    ,
 0.0438756366548   , 0.0380348314922   , 0.0320945063297   , 0.0304350263089   ,
 0.0341641757699   , 0.0422547000308   , 0.0539704135457   , 0.069131168215    ,
 0.0875390461629   , 0.11149065165     , 0.152139457297    , 0.234944137912    ,
 0.397137780857    , 0.673426145533    , 1.0743739403      , 1.57497365787     ,
 2.13997018215     , 2.79099298688     , 3.67084538315     , 5.0633062415      ,
 7.42611870971     , 11.5774701201     , 19.1533419479     , 33.4284282905     ,
 60.6808440505     , 112.360176001     , 207.93531557      , 376.867875696     ,
 655.810935388     , 1075.9215593      , 1639.11083553     , 2293.2078306      ,
 2927.1268783      , 3402.36496923     , 3611.14960002     , 3525.65833797     ,
 3205.63821643     , 2762.94523172     , 2310.54612934     , 1926.30606717     ,
 1643.51834203     , 1461.09231986     , 1359.19046745     , 1310.34313993     ,
 1284.84513554     , 1254.6600643      , 1198.53871982     , 1106.64710776     ,
 981.525628952     , 834.519354783     , 680.033501248     , 531.028434365     ,
 397.158065922     , 284.438215306     , 195.221743795     , 82.8564799818     ,
 49.4929932478     , 28.4242363999     , 15.6852640339     , 8.3138142123      ,
 4.25278263077     , 2.13622021401     , 1.09243791196     , 0.596202640413    ,
 0.358314230962    , 0.239793922833    , 0.184554403993    , 0.170885891296    ,
 0.185326502018    , 0.215719100739    , 0.253062464837    , 0.293727209986    ,
 0.33728522933     , 0.379996889634    , 0.412610037552    , 0.428359456612    ,
 0.431895366331    , 0.437988210631    , 0.46301005368     , 0.51832817626     ,
 0.608727288046    , 0.735678841141    , 0.905435249384    , 1.13636580058     ,
 1.45432165882     , 1.87274165117     , 2.37264707207     , 2.90688048794     ,
 3.43441539391     , 3.95147096882     , 4.47576131872     , 4.99696731369     ,
 5.46828461303     , 5.8701674823      , 6.26209871605     , 6.7311084305      ,
 7.28856542012     , 7.85751652495     , 8.38612202281     , 8.96383474175     ,
 9.82722884708     , 11.2806323114     , 13.609485631      , 17.0179683827     ,
 21.6282172398     , 27.5947615411     , 35.2643530516     , 45.1926605102     ,
 57.9950573797     , 74.2809569851     , 94.8074477106     , 120.584726091     ,
 152.667752663     , 191.847599011     , 238.601305429     , 293.16246204      ,
 355.221654522     , 423.189446533     , 493.634163451     , 561.566785117     ,
 621.657411799     , 669.760987524     , 703.790699396     , 723.507716855     ,
 729.808224        , 724.229626816     , 708.693527295     , 685.264401699     ,
 655.915912582     , 622.287082296     , 585.51024692      , 546.379054274     ,
 505.703831853     , 464.223475408     , 421.999526754     , 378.136412112     ,
 331.481034402     , 281.862392757     , 230.863480164     , 181.57025104      ,
 137.482127064     , 101.164874454     , 73.334781531      , 52.9144079007     ,
 37.9799755726     , 26.8183331446     , 18.3687576401     , 12.0604903374     ,
 7.51715207044     , 4.41364252277     , 2.44502059419     , 1.31248402508     ,
 0.725892560935    , 0.438814759596    , 0.285831214186    , 0.186583269439    ,
 0.118266377175    , 0.0825074237339   , 0.0839856521987   , 0.119323205654    ,
 0.170901544228    , 0.209653418948    , 0.211358389008    , 0.174824949562    ,
 0.122082196445    , 0.0790153254447   , 0.0565142442227   , 0.0484296321177   ,
 0.0430765321391   , 0.0346143968724   , 0.025247091704    , 0.0197524324696   ,
 0.0198458852217   , 0.0231917972078   , 0.0261306407444   , 0.0269344154082   ,
 0.0270828371726   , 0.0293578097316   , 0.0341274858033   , 0.0379013196346   ,
 0.036554982139    , 0.0298171787839   , 0.0215934112283   , 0.0160966255418   ,
 0.0147575915109   , 0.0167059817585   , 0.0208014608715   , 0.0266084142944   ,
 0.0345827731803   , 0.0475483813439   , 0.074564032571    , 0.135676456268    ,
 0.263340965377    , 0.4945166788      , 0.85027914151     , 1.3154805903      ,
 1.85288770387     , 2.47267824229     , 3.31650088052     , 4.70254559636     ,
 7.19099382098     , 11.8567448342     , 20.986886744      , 39.4666229831     ,
 77.3022535449     , 153.777759878     , 302.780936775     , 575.899910361     ,
 1035.66838937     , 1730.28891566     , 2650.45235691     , 3689.77444086     ,
 4646.75047074     , 5291.00144725     , 5467.12351588     , 5168.86753661     ,
 4532.4676926      , 3759.87322571     , 3029.40898161     , 2444.68222693     ,
 2032.72188981     , 1770.85766073     , 1616.18348137     , 1523.42625066     ,
 1451.95739889     , 1369.46342739     , 1256.26822403     , 1108.2208551      ,
 934.95406646      , 753.552505402     , 580.949485559     , 428.971587116     ,
 303.421058438     , 205.47968284      , 133.248916664     , 49.6117572471     ,
 28.0279015044     , 15.2752708361     , 8.03536665442     , 4.07751086676     ,
 2.00567177607     , 0.978911173826    , 0.500174482715    , 0.284787179163    ,
 0.182809099911    , 0.128173088387    , 0.09934970499     , 0.0904995179127   ,
 0.0975350938009   , 0.116158819466    , 0.143181523051    , 0.176492374429    ,
 0.212987174511    , 0.245272980446    , 0.262243263181    , 0.256907777972    ,
 0.23403861869     , 0.208211020014    , 0.194691146306    , 0.202637032098    ,
 0.234406286365    , 0.288502828384    , 0.363922776289    , 0.464272365733    ,
 0.597699003769    , 0.76974334562     , 0.97424479674     , 1.19396714735     ,
 1.41492389582     , 1.63871551788     , 1.87263831045     , 2.10747932447     ,
 2.32121397725     , 2.51642862651     , 2.73954683459     , 3.0394153917      ,
 3.40801961812     , 3.78666159649     , 4.14540447747     , 4.54991276771     ,
 5.1520047211      , 6.13643838162     , 7.67960142172     , 9.93236355473     ,
 13.0405046334     , 17.22806814       , 22.8954436547     , 30.6188275622     ,
 41.051945871      , 54.9114356366     , 73.1363308519     , 96.9937265301     ,
 127.889853386     , 167.045749021     , 215.345617015     , 273.262649815     ,
 340.488845688     , 415.263962879     , 493.899311165     , 570.987471026     ,
 640.423753577     , 696.903472593     , 737.115939228     , 760.015279415     ,
 766.365051142     , 758.108849439     , 737.787187808     , 708.085112639     ,
 671.547835082     , 630.269004616     , 585.618216433     , 538.483120897     ,
 489.88636567      , 441.048393108     , 392.655383345     , 344.350814059     ,
 295.302381277     , 245.42049288      , 196.152278961     , 150.225040769     ,
 110.528636498     , 78.8606541274     , 55.2929332223     , 38.4804055054     ,
 26.5768938754     , 18.0456764686     , 11.9108385984     , 7.57787545493     ,
 4.6116652806      , 2.65852345309     , 1.44307864521     , 0.74901268376     ,
 0.392641164817    , 0.223249393005    , 0.138778943286    , 0.0881510412164   ,
 0.0554909985658   , 0.0407359498269   , 0.0468818889373   , 0.0726330901476   ,
 0.107551789465    , 0.133334659628    , 0.134703895128    , 0.111752237438    ,
 0.0797989501094   , 0.0557870782362   , 0.045421708179    , 0.0426138811502   ,
 0.038732723248    , 0.0310467950396   , 0.0232352844524   , 0.0198443896779   ,
 0.0214833827398   , 0.0248382266783   , 0.0262374479755   , 0.0249070181582   ,
 0.0231216661166   , 0.0235034023263   , 0.0261169425022   , 0.0281040346531   ,
 0.0263684973192   , 0.0206499987099   , 0.013649879391    , 0.00835575108495  ,
 0.00586507898567  , 0.0055860634331   , 0.00658647407721  , 0.00842791382175  ,
 0.011466530649    , 0.0177198135304   , 0.0333108025806   , 0.0725645170967   ,
 0.161630838425    , 0.335598588356    , 0.622183228605    , 1.01949329395     ,
 1.50193756222     , 2.08311768471     , 2.90665649977     , 4.31841081585     ,
 6.98860705699     , 12.3177702299     , 23.4806615893     , 47.6516206413     ,
 100.279511822     , 212.167064736     , 438.060842508     , 860.163481892     ,
 1573.52325019     , 2641.03561405     , 4024.44018456     , 5531.41749626     ,
 6837.3639043      , 7605.13926516     , 7645.43414272     , 7009.2376366      ,
 5947.11967693     , 4772.97589646     , 3731.16819246     , 2937.93097941     ,
 2398.37974922     , 2057.47662025     , 1844.97516911     , 1698.37481899     ,
 1569.3210729      , 1425.29715785     , 1251.71758389     , 1051.83051838     ,
 841.605960241     , 641.024863435     , 465.943792817     , 324.146144514     ,
 216.116852171     , 138.063544413     , 84.4961553658     , 27.3244418107     ,
 14.6314992038     , 7.59765817032     , 3.83328703663     , 1.87743668112     ,
 0.896921353609    , 0.431934559167    , 0.227557045319    , 0.142068258608    ,
 0.102566127934    , 0.0796899906346   , 0.0664054489876   , 0.0616954772054   ,
 0.0644576738934   , 0.0743085252817   , 0.0915487161149   , 0.114941238794    ,
 0.140098681176    , 0.159283464608    , 0.163803430223    , 0.149875477746    ,
 0.122958890518    , 0.0947931444538   , 0.0760249946249   , 0.0719041455025   ,
 0.0830693017161   , 0.107922018698    , 0.144165274786    , 0.190082413221    ,
 0.245648710324    , 0.311619752862    , 0.386505240854    , 0.465764697717    ,
 0.546321350073    , 0.630519355739    , 0.720990871641    , 0.812297406171    ,
 0.897011744429    , 0.985649551954    , 1.11111640556     , 1.29929128768     ,
 1.53536336359     , 1.77418748442     , 1.99407261199     , 2.23621715101     ,
 2.59217606255     , 3.16922143564     , 4.07445544821     , 5.42165390864     ,
 7.36120610272     , 10.1407876635     , 14.1630601672     , 19.9778224893     ,
 28.2295653386     , 39.6954944955     , 55.462563364      , 77.0412096397     ,
 106.203785542     , 144.651857915     , 193.744562471     , 254.242836754     ,
 325.856144144     , 406.636279615     , 492.553059938     , 577.608656603     ,
 654.74090343      , 717.424699567     , 761.247894327     , 784.603320488     ,
 788.370001459     , 775.058826041     , 747.902180837     , 710.26370772      ,
 665.376795446     , 615.95875327      , 563.738715978     , 509.662820213     ,
 454.758711435     , 400.468875526     , 347.96158708      , 297.458864651     ,
 248.557016886     , 201.230570767     , 156.556294197     , 116.548610923     ,
 83.2147841925     , 57.519242479      , 38.9947650363     , 26.1774978208     ,
 17.4040506818     , 11.3730191093     , 7.24595960612     , 4.48026836843     ,
 2.67454902363     , 1.52364966738     , 0.816515368568    , 0.411877059854    ,
 0.203405073629    , 0.10611458612     , 0.061008417636    , 0.0369714744036   ,
 0.0229965074472   , 0.0177947452419   , 0.0226740426451   , 0.0371863718557   ,
 0.0561106193758   , 0.0699678112673   , 0.0710596254466   , 0.0603053019677   ,
 0.0468116659284   , 0.039549802893    , 0.0396640522564   , 0.0410452797046   ,
 0.0377695816519   , 0.0301863896216   , 0.0237819006999   , 0.0231559862891   ,
 0.0277171117311   , 0.0327024318849   , 0.0338235083648   , 0.030781130154    ,
 0.0264400570058   , 0.0233812326753   , 0.0218127148856   , 0.0201812810176   ,
 0.0170359836197   , 0.0123920247768   , 0.00760382143957  , 0.00406906866741  ,
 0.00221669797015  , 0.00162828113442  , 0.0017222688397   , 0.00220026285798  ,
 0.00323064742151  , 0.0059383688938   , 0.0139628828291   , 0.0367095789557   ,
 0.0934719356492   , 0.213637110766    , 0.425679693938    , 0.738675229925    ,
 1.14449855289     , 1.67015148843     , 2.46624554413     , 3.90544470399     ,
 6.77633230398     , 12.8597301547     , 26.4198484932     , 57.5346411176     ,
 128.651820579     , 285.247869941     , 607.733618513     , 1213.46628663     ,
 2229.53229352     , 3722.32970665     , 5601.68487545     , 7563.59452621     ,
 9148.61114092     , 9927.53196855     , 9713.95207339     , 8654.79552061     ,
 7134.6076143      , 5573.27925966     , 4259.20380613     , 3298.39036211     ,
 2660.28752355     , 2254.19948263     , 1985.97048783     , 1781.90445986     ,
 1592.06547855     , 1388.60409824     , 1164.54697878     , 930.082978886     ,
 704.42251885      , 506.102778051     , 346.13616043      , 226.330067495     ,
 141.893383422     , 85.3474618093     , 49.2559808955     , 13.7477541641     ,
 7.00017854399     , 3.48341818088     , 1.70033324721     , 0.813237285189    ,
 0.383912229758    , 0.188840284179    , 0.109668887655    , 0.0806247903609   ,
 0.0681283061934   , 0.0603751530271   , 0.0558775884823   , 0.0541128394372   ,
 0.0540609033205   , 0.0568235829322   , 0.0648287821791   , 0.078081559774    ,
 0.0925156423456   , 0.101507954631    , 0.0992034104546   , 0.0845271848575   ,
 0.0627203676308   , 0.0419747635362   , 0.0283961870073   , 0.0242355616128   ,
 0.0295178595386   , 0.0436129920871   , 0.0649945805358   , 0.0908035799835   ,
 0.118107342411    , 0.145554105107    , 0.1727742204      , 0.198720483335    ,
 0.222532028644    , 0.245662458451    , 0.270481994171    , 0.297106652435    ,
 0.32647907627     , 0.369064761946    , 0.444807350162    , 0.565728795767    ,
 0.717376278371    , 0.866374825366    , 0.994098027713    , 1.12088066202     ,
 1.29749498332     , 1.58506182897     , 2.05075769434     , 2.78070290412     ,
 3.90886628108     , 5.66411142265     , 8.41006969553     , 12.6421177875     ,
 18.9733083169     , 28.2141797191     , 41.5655761168     , 60.744241432      ,
 87.8551053377     , 125.062622325     , 174.218358899     , 236.437511166     ,
 311.533195202     , 397.372839394     , 489.394275855     , 580.652091629     ,
 662.827090143     , 728.194611945     , 771.643627402     , 791.582385822     ,
 789.458498645     , 768.542074952     , 732.78158987      , 686.232635051     ,
 632.867962811     , 576.079268064     , 517.963857586     , 459.4431821       ,
 401.327878021     , 344.964761067     , 291.725521908     , 242.261124211     ,
 196.536916298     , 154.517372425     , 116.757656379     , 84.3750525548     ,
 58.4058339304     , 39.0751486153     , 25.5902048264     , 16.5579112473     ,
 10.5922024143     , 6.66266075861     , 4.10279141096     , 2.47188565132     ,
 1.45283639138     , 0.821586765787    , 0.43707542608     , 0.215657578657    ,
 0.100575986035    , 0.0474051567876   , 0.0243377128102   , 0.0136316296156   ,
 0.00824297890976  , 0.00666160227496  , 0.009188676888    , 0.0156568177445   ,
 0.023917226475    , 0.0300492874847   , 0.0311716511792   , 0.0285896449109   ,
 0.0272620334351   , 0.0309975351453   , 0.0379966230326   , 0.0420326858104   ,
 0.03884477762     , 0.0308905368007   , 0.0250947911638   , 0.0263157331534   ,
 0.0332734205862   , 0.0402763977217   , 0.0425754486433   , 0.0398925911666   ,
 0.0348530014924   , 0.0293557684969   , 0.0236241413915   , 0.0176550544176   ,
 0.0119926678628   , 0.00728926450828  , 0.00389763939674  , 0.0018268730153   ,
 0.000805697794282 , 0.000433873655698 , 0.000377988556291 , 0.000478271383105 ,
 0.000802567776106 , 0.00191295222998  , 0.00584738347961  , 0.0184859316522   ,
 0.0531247762667   , 0.131958139389    , 0.279606895047    , 0.510495256932    ,
 0.831030114876    , 1.282260061       , 2.02247073815     , 3.44865204791     ,
 6.4662231097      , 13.2555537202     , 29.2669933379     , 67.7805796328     ,
 158.89026487      , 363.585753848     , 787.774910292     , 1579.92717879     ,
 2887.73753434     , 4762.12556506     , 7042.58304859     , 9311.36030003     ,
 11001.1176283     , 11641.5031079     , 11098.7201123     , 9635.77901453     ,
 7752.3641869      , 5931.6722518      , 4464.76754059     , 3424.23235684     ,
 2740.52719963     , 2295.96222833     , 1984.38081035     , 1731.1411918      ,
 1491.81036714     , 1246.77589408     , 996.609214467     , 755.328675123     ,
 540.82819083      , 366.171508408     , 235.423232086     , 144.531574005     ,
 85.0974487103     , 48.1445951912     , 26.1969889469     , 6.294596098       ,
 3.0608310848      , 1.47009609658     , 0.701384238285    , 0.33248651701     ,
 0.160076110778    , 0.0872419610514   , 0.0630763261942   , 0.0576048501781   ,
 0.0554392148143   , 0.0528667117293   , 0.0509943497325   , 0.0494548979875   ,
 0.046858896312    , 0.0443867253033   , 0.0452207588704   , 0.0504950377831   ,
 0.0573824284698   , 0.0608542867559   , 0.0569954598375   , 0.0457818801522   ,
 0.0312403636222   , 0.018509163542    , 0.0107500112709   , 0.00882841941466  ,
 0.0129606436834   , 0.0235042431182   , 0.0397837770979   , 0.0589025858865   ,
 0.0770805387743   , 0.0923694686889   , 0.104780629983    , 0.113811929052    ,
 0.117959985806    , 0.117317920035    , 0.114981766973    , 0.115462812599    ,
 0.123774549922    , 0.147149139098    , 0.194682719862    , 0.270137414665    ,
 0.363257144729    , 0.452875098253    , 0.524417106618    , 0.584479161245    ,
 0.658692485406    , 0.782788085491    , 1.00119435974     , 1.37582144406     ,
 2.00941357126     , 3.08553746769     , 4.90364788388     , 7.88762939071     ,
 12.6043535659     , 19.873965544      , 30.9721435532     , 47.768611923      ,
 72.6370883591     , 108.14199459      , 156.597959601     , 219.511159799     ,
 296.866580489     , 386.330338846     , 482.616503562     , 577.533297779     ,
 661.320613774     , 725.202910711     , 763.874455978     , 776.399785257     ,
 765.28423765      , 734.774397034     , 689.571318053     , 634.393488534     ,
 573.866173063     , 511.90801432      , 450.844430836     , 391.461866653     ,
 334.181597993     , 279.954540881     , 229.993690496     , 185.070350923     ,
 145.324944234     , 110.630583106     , 81.0193521245     , 56.7683572072     ,
 38.0744357722     , 24.6364927396     , 15.5659812206     , 9.69309899641     ,
 5.95972946161     , 3.60848085302     , 2.15114341822     , 1.26655169687     ,
 0.734851767367    , 0.412939070347    , 0.218161427194    , 0.105599256521    ,
 0.0468271034422   , 0.0199316989536   , 0.0088923480765   , 0.00441593656979  ,
 0.00251941795401  , 0.00208845026914  , 0.00305949043143  , 0.00535843019646  ,
 0.00828036205625  , 0.0106031931025   , 0.0117463330493   , 0.0130387053248   ,
 0.0172179250578   , 0.0255580219084   , 0.0351108377453   , 0.040016123426    ,
 0.0370013521931   , 0.0292662559351   , 0.0239181654968   , 0.0256903110003   ,
 0.0333272312553   , 0.0415187306877   , 0.0459537535046   , 0.046135831236    ,
 0.0433723789988   , 0.0378898281299   , 0.0295038052862   , 0.019709270131    ,
 0.0111377051961   , 0.00537368354318  , 0.00226209559544  , 0.000849516924547 ,
 0.000295874706943 , 0.000113353462957 , 7.23546778702e-05 , 9.00371970479e-05 ,
 0.000197090525873 , 0.000682136052893 , 0.00271616737319  , 0.00998477980056  ,
 0.0313560322634   , 0.0824204337845   , 0.181883735993    , 0.344133696057    ,
 0.582964270425    , 0.946953062865    , 1.59536637206     , 2.93697797572     ,
 5.96871017411     , 13.2243080478     , 31.2399872013     , 76.1963455489     ,
 184.834950642     , 430.683952068     , 937.805555896     , 1871.40552745     ,
 3378.72254714     , 5475.59454075     , 7929.95247096     , 10243.8667306     ,
 11809.3406415     , 12188.1047825     , 11338.1242342     , 9621.07191053     ,
 7590.68771134     , 5725.03489812     , 4273.40108919     , 3263.33027074     ,
 2597.42651833     , 2149.73353619     , 1818.3535915      , 1538.22767365     ,
 1275.55282762     , 1019.62412998     , 775.78921403      , 557.404944559     ,
 377.061099997     , 240.485219292     , 145.322024936     , 83.7543093683     ,
 46.3060744031     , 24.6438441987     , 12.652684532      , 2.62070747337     ,
 1.2228578398      , 0.57076563301     , 0.268682653984    , 0.128641065479    ,
 0.0671306972005   , 0.0463704357468   , 0.0450857230193   , 0.04858912235     ,
 0.0491342794792   , 0.0464866332975   , 0.0433564068343   , 0.0402442119592   ,
 0.0359284214443   , 0.0310242705111   , 0.0281553474898   , 0.0287766284776   ,
 0.0313404028128   , 0.0325163018425   , 0.0297330944006   , 0.023029750979    ,
 0.0148658399213   , 0.00811258312717  , 0.00435571657091  , 0.00408048588229  ,
 0.00786471246866  , 0.016598892062    , 0.0300470627256   , 0.0455597072539   ,
 0.0594488685585   , 0.0699732288078   , 0.0776258078925   , 0.0821884190275   ,
 0.0815340963994   , 0.0745847468632   , 0.0643824611447   , 0.0572252077069   ,
 0.0592085791005   , 0.0740851596911   , 0.103438683612    , 0.146444116989    ,
 0.197638933956    , 0.246656663321    , 0.284292698006    , 0.310830340036    ,
 0.339159256906    , 0.392683693003    , 0.502520686559    , 0.709721839754    ,
 1.08285487022     , 1.75305798778     , 2.94781013172     , 5.01243701475     ,
 8.45580091576     , 14.078782849      , 23.1758307966     , 37.6865927504     ,
 60.1517032622     , 93.4302031617     , 140.220678158     , 202.394639056     ,
 280.117476597     , 370.838048151     , 468.491810568     , 563.623189542     ,
 645.156689022     , 703.579133942     , 733.83636907      , 736.100149895     ,
 714.26759928      , 673.734240199     , 619.976140882     , 558.243460893     ,
 493.521393443     , 429.888556614     , 369.628716316     , 313.293413292     ,
 260.86212827      , 212.719630461     , 169.605181107     , 132.062608327     ,
 100.168310469     , 73.6558207582     , 52.1704906924     , 35.4023225143     ,
 22.9982728027     , 14.3887388029     , 8.76281246588     , 5.24342851611     ,
 3.0946783769      , 1.80419650549     , 1.04411529705     , 0.603347162677    ,
 0.346382671603    , 0.19294435726     , 0.100637236878    , 0.0475995057308   ,
 0.0201556735039   , 0.00782771488497  , 0.00300987965174  , 0.00127125716418  ,
 0.00065393496374  , 0.000540563524784 , 0.000827647021917 , 0.00148252001528  ,
 0.00233365279622  , 0.00315001116274  , 0.00410664291326  , 0.00627607253112  ,
 0.0112420925124   , 0.0193246163977   , 0.0278104339103   , 0.0320372661863   ,
 0.0296070222566   , 0.0233068146098   , 0.0189594649456   , 0.0204538166735   ,
 0.0270424439533   , 0.0349941548398   , 0.0413343416581   , 0.0453497138745   ,
 0.0465154422588   , 0.0430206497358   , 0.0340644320954   , 0.0222296200729   ,
 0.0117425419919   , 0.00501406017622  , 0.00175294230219  , 0.000515481451305 ,
 0.000133477684558 , 3.41945014671e-05 , 1.3503162245e-05  , 1.72995512855e-05 ,
 6.32088350571e-05 , 0.000321539938669 , 0.00152942822958  , 0.006100741071    ,
 0.0199523857147   , 0.0535829140072   , 0.119885477577    , 0.230149524736    ,
 0.399043491019    , 0.674269278589    , 1.20511609947     , 2.3902932629      ,
 5.26613880579     , 12.5894866674     , 31.6202058644     , 80.3840453258     ,
 199.388788436     , 467.848575216     , 1014.43026684     , 1999.95202227     ,
 3548.05098833     , 5629.46478938     , 7963.29296801     , 10035.0944123     ,
 11281.8400894     , 11362.4052992     , 10333.148276      , 8599.55097813     ,
 6687.1074903      , 5002.252324       , 3724.43295817     , 2841.7572282      ,
 2250.01153291     , 1835.80796947     , 1515.34771059     , 1239.75221836     ,
 987.133994722     , 753.517661021     , 545.140035371     , 371.106291741     ,
 237.116273254     , 142.468454955     , 80.9422049214     , 43.8164044412     ,
 22.7653483967     , 11.410784228      , 5.53911057673     , 0.996950600289    ,
 0.448720398925    , 0.204289052566    , 0.0953393313663   , 0.0472933483493   ,
 0.0294206891912   , 0.0281974226821   , 0.0344262017624   , 0.039987558269    ,
 0.0403764544068   , 0.036521025603    , 0.0317384096219   , 0.0274263499604   ,
 0.0229271701457   , 0.0182668764365   , 0.0148931825786   , 0.0138450385396   ,
 0.0144202985364   , 0.0147661943481   , 0.0133865099828   , 0.0102025524333   ,
 0.00640267312254  , 0.00336423169747  , 0.00185630331503  , 0.00227066588869  ,
 0.00529551829588  , 0.0118439052975   , 0.0218266878795   , 0.0331410103204   ,
 0.0428695777093   , 0.0498542311226   , 0.0549609124013   , 0.058326090121    ,
 0.0578979531516   , 0.0520308534548   , 0.0429420206156   , 0.0364453881182   ,
 0.0379148094692   , 0.0487204288455   , 0.0666460736997   , 0.0889659217933   ,
 0.113591105212    , 0.137191942901    , 0.155108471686    , 0.166165566815    ,
 0.178378950737    , 0.209700337589    , 0.283194669648    , 0.424722514697    ,
 0.675864224117    , 1.12349103862     , 1.93180424346     , 3.37490117343     ,
 5.90017767682     , 10.2573704472     , 17.6844124256     , 30.0714868272     ,
 49.9769163202     , 80.3989496052     , 124.286685698     , 183.788672998     ,
 259.216642479     , 347.834322896     , 442.942231921     , 534.130308093     ,
 609.464461029     , 659.180579793     , 678.854819952     , 669.977112956     ,
 637.912566033     , 589.190343086     , 529.926060158     , 465.580782431     ,
 401.012479459     , 339.962324776     , 284.361942363     , 234.473863827     ,
 189.914674411     , 150.519924353     , 116.418075234     , 87.7001807101     ,
 64.2100333134     , 45.5430540015     , 31.1506911815     , 20.4518800793     ,
 12.8671861173     , 7.78663277989     , 4.57080428843     , 2.62577018318     ,
 1.48564698092     , 0.833890608863    , 0.469835018145    , 0.267802760908    ,
 0.152523391483    , 0.0838825073996   , 0.0427778041725   , 0.0195754758286   ,
 0.00789783304654  , 0.00283027784887  , 0.000948519342755 , 0.000332197049774 ,
 0.000145410739856 , 0.00011471861615  , 0.00018077616627  , 0.000331641127972 ,
 0.000544544301675 , 0.000838137755211 , 0.0014675925441   , 0.00312274521203  ,
 0.00668510050485  , 0.0122044755024   , 0.0178561821235   , 0.0206427464057   ,
 0.0190619549693   , 0.0149476297179   , 0.0120814990507   , 0.0130628332444   ,
 0.0177055471021   , 0.0241525128659   , 0.0309686989353   , 0.0373931930568   ,
 0.0415736698285   , 0.0404182759447   , 0.0327356719809   , 0.0214252905773   ,
 0.0111609763852   , 0.00460206294787  , 0.00150391815499  , 0.000392758164965 ,
 8.35886806343e-05 , 1.52891322726e-05 , 3.39075034546e-06 , 5.27696390982e-06 ,
 3.28261222667e-05 , 0.00020158068642  , 0.00101830462974  , 0.00414188897874  ,
 0.0135843554423   , 0.0363012033827   , 0.0806344461836   , 0.154170739234    ,
 0.268963078057    , 0.466045372616    , 0.875650374002    , 1.86400825981     ,
 4.44013531172     , 11.3843980897     , 30.0897103771     , 78.7710286749     ,
 197.549628269     , 462.448881322     , 991.321067078     , 1920.47591843     ,
 3334.54005393     , 5164.96866629     , 7122.68686345     , 8747.00103654     ,
 9589.20727567     , 9434.38814276     , 8407.89178526     , 6889.82264748     ,
 5308.57830424     , 3961.1795629      , 2954.82028518     , 2255.99069644     ,
 1774.26646776     , 1422.94864407     , 1142.75211639     , 901.885701539     ,
 688.156144861     , 500.87837022      , 344.227832106     , 221.937239165     ,
 133.954193306     , 75.8566794907     , 40.550097717      , 20.6406577127     ,
 10.0956000941     , 4.77983434929     , 2.20350414019     , 0.353172522322    ,
 0.154481717128    , 0.068475807184    , 0.031546436272    , 0.0167406651939   ,
 0.0135427959504   , 0.0172837290347   , 0.0237449859568   , 0.0282484454893   ,
 0.028058289214    , 0.0241494804528   , 0.0193803679154   , 0.0153638743224   ,
 0.0119373449502   , 0.00884031535455  , 0.00654528143865  , 0.00551153529021  ,
 0.00545049806446  , 0.00551739055891  , 0.00499781971252  , 0.00379383151706  ,
 0.00235681001871  , 0.00123406195612  , 0.000766301095429 , 0.00123647973041  ,
 0.00317552197774  , 0.00722460752782  , 0.0133361144751   , 0.0201594256867   ,
 0.0258855571461   , 0.0299995842266   , 0.0334251613499   , 0.0364373090297   ,
 0.037363923509    , 0.0344557797503   , 0.0288870687672   , 0.0249561436069   ,
 0.0267171578281   , 0.034532628948    , 0.0453897640128   , 0.0564980376324   ,
 0.0673784622056   , 0.0777827307416   , 0.0856635841246   , 0.0903218507747   ,
 0.0982268393194   , 0.124128041411    , 0.185464650424    , 0.298538555931    ,
 0.488298202829    , 0.81267601092     , 1.39274475075     , 2.45176408917     ,
 4.38201044389     , 7.854160156       , 13.9725011085     , 24.4482282883     ,
 41.6848827656     , 68.6266683569     , 108.289530732     , 162.958232972     ,
 233.035722429     , 315.693896223     , 403.907034641     , 486.850480116     ,
 552.406211362     , 591.169185243     , 599.699137625     , 580.841601011     ,
 541.238362496     , 488.245496529     , 428.222675714     , 366.338387103     ,
 306.769102268     , 252.460215121     , 204.755409448     , 163.630389561     ,
 128.485636979     , 98.7652678552     , 74.0637622237     , 54.0120338239     ,
 38.2010814306     , 26.1420972003     , 17.2624187132     , 10.9625549735     ,
 6.68074558331     , 3.91317238407     , 2.21577668849     , 1.2219401174      ,
 0.661693655908    , 0.356703666131    , 0.195497293468    , 0.110110566142    ,
 0.0622992562352   , 0.0337330867532   , 0.0166874882578   , 0.00731198248933  ,
 0.00279222474158  , 0.000928726407164 , 0.000276678979704 , 8.05218497398e-05 ,
 2.83666784133e-05 , 1.99667932923e-05 , 3.18258859874e-05 , 6.0619974754e-05  ,
 0.000110245950693 , 0.000219601328639 , 0.000543672487813 , 0.00143380017343  ,
 0.00331509910902  , 0.00618571937156  , 0.00910140205356  , 0.0105331220843   ,
 0.00971930785329  , 0.0075991032554   , 0.00611547881056  , 0.00666952141153  ,
 0.00939395683878  , 0.0137537094784   , 0.0193798951221   , 0.0256531476937   ,
 0.0304624558654   , 0.0307376926607   , 0.0253378911307   , 0.0166899293053   ,
 0.00868836312476  , 0.00355658023658  , 0.00114290698146  , 0.000288589335295 ,
 5.75121714403e-05 , 9.18041182217e-06 , 1.50295475282e-06 , 2.94532118925e-06 ,
 2.21469328296e-05 , 0.000140997052088 , 0.000716075584731 , 0.0029008503736   ,
 0.00943397881877  , 0.0249399551444   , 0.0547852237608   , 0.103884528361    ,
 0.181318953261    , 0.319982046977    , 0.62774697061     , 1.42356694221     ,
 3.62657938798     , 9.82196911228     , 26.8698581363     , 71.390073788      ,
 178.99202299      , 414.592034208     , 873.407924784     , 1655.51320909     ,
 2804.51025683     , 4231.45654523     , 5681.04325345     , 6795.48606795     ,
 7268.37770971     , 6997.83782445     , 6130.71664352     , 4969.06197887     ,
 3813.99268083     , 2852.63813781     , 2137.32048462     , 1631.89664596     ,
 1271.20864292     , 998.627901239     , 777.891646251     , 590.841902735     ,
 431.245220643     , 298.888807457     , 194.952362228     , 118.999784925     ,
 67.8614355121     , 36.2457031197     , 18.2534781609     , 8.75531956215     ,
 4.04716382294     , 1.82277870669     , 0.806599753033    , 0.122652726282    ,
 0.0528338429342   , 0.0226441402616   , 0.0101812531217   , 0.00598496604784  ,
 0.00634621055732  , 0.00956288049206  , 0.013703339441    , 0.0163142517311   ,
 0.0159031503641   , 0.013103801806    , 0.00975219326794  , 0.00704761343682  ,
 0.00504410118379  , 0.0034776824427   , 0.00236118789562  , 0.0017981156572   ,
 0.00167012366895  , 0.00166413758129  , 0.00150889367056  , 0.00114693186807  ,
 0.00071217435681  , 0.000380921485251 , 0.000283789238057 , 0.000577199121366 ,
 0.00155673230496  , 0.00356067003941  , 0.00657033235239  , 0.00993600921551  ,
 0.0128798632124   , 0.015451249223    , 0.0184826344656   , 0.0221013925981   ,
 0.0246973688627   , 0.0242663586479   , 0.021006422678    , 0.0179166966153   ,
 0.0182323286903   , 0.0224419905396   , 0.0283170104574   , 0.0337677483161   ,
 0.0386916434188   , 0.0434687188988   , 0.0472301881686   , 0.0501527347397   ,
 0.0579524344848   , 0.082314042808    , 0.135590116397    , 0.227380836233    ,
 0.373142518174    , 0.615858286244    , 1.05519906105     , 1.88657319339     ,
 3.45686125224     , 6.34038606916     , 11.4560448961     , 20.2419545943     ,
 34.8009049313     , 57.8300324368     , 92.2017685179     , 140.159331862     ,
 202.123137452     , 275.294472364     , 352.709005557     , 423.768705076     ,
 476.927435174     , 503.770574808     , 502.124436268     , 476.054458366     ,
 433.036858582     , 380.686245881     , 325.033006681     , 270.427796777     ,
 219.942165419     , 175.464876159     , 137.663835991     , 106.272251697     ,
 80.6133199246     , 59.9451873925     , 43.5490329616     , 30.7704362683     ,
 21.0591277055     , 13.9289369868     , 8.89251452128     , 5.46787065344     ,
 3.22940422884     , 1.83137214262     , 1.00069256918     , 0.529868083864    ,
 0.274097712471    , 0.141073869304    , 0.0745646338293   , 0.0412125353938   ,
 0.0230906016719   , 0.0122965892216   , 0.00589054260036  , 0.00246127275148  ,
 0.000885378845099 , 0.000273739232523 , 7.37503364517e-05 , 1.82730166776e-05 ,
 5.03343514001e-06 , 2.87980757319e-06 , 4.54251740187e-06 , 9.3588267806e-06  ,
 2.10923478312e-05 , 5.94440203057e-05 , 0.000190074357781 , 0.000553952984949 ,
 0.00131836776245  , 0.00247880919669  , 0.00365418277862  , 0.00423019280349  ,
 0.00390099434533  , 0.00304423866239  , 0.002449720319    , 0.00272791478637  ,
 0.00407015508246  , 0.00650958925307  , 0.0101175902891   , 0.0145025152593   ,
 0.0180953739135   , 0.0187354753704   , 0.0156315721533   , 0.0103490646242   ,
 0.0053954888918   , 0.00220662104486  , 0.000706591827205 , 0.000177027035936 ,
 3.4714996823e-05  , 5.35739917789e-06 , 8.54326447899e-07 , 2.01882485493e-06 ,
 1.5235909987e-05  , 9.57279913912e-05 , 0.000482094418965 , 0.00194463894499  ,
 0.00631687064917  , 0.0167287530857   , 0.0369461664803   , 0.0708215422875   ,
 0.126014587869    , 0.229227039514    , 0.468238730712    , 1.11000368565     ,
 2.94056532065     , 8.17417762076     , 22.6008550041     , 59.8968131826     ,
 148.377828085     , 337.383187098     , 694.754223072     , 1283.66943038     ,
 2116.22925054     , 3105.15133087     , 4055.5028613      , 4725.93690283     ,
 4938.07598385     , 4664.48153865     , 4033.05193748     , 3249.26678208     ,
 2496.68883083     , 1877.8602256      , 1413.48725275     , 1076.38218372     ,
 827.147916491     , 634.023163916     , 477.598494122     , 348.384542225     ,
 242.897686707     , 160.150320334     , 99.073848567      , 57.2357207632     ,
 30.843512622      , 15.5511976828     , 7.39315971553     , 3.3569669738      ,
 1.48122014246     , 0.646449285409    , 0.281947489625    , 0.0460197098671   ,
 0.0199221149498   , 0.00838904070867  , 0.00397357157157  , 0.0029040311324   ,
 0.00350987450621  , 0.00505455774013  , 0.00679835452595  , 0.0077632324208   ,
 0.00732791499784  , 0.0057912544759   , 0.00402611524497  , 0.0026507879408   ,
 0.00173124668053  , 0.00110667623735  , 0.000693511235855 , 0.00047810691285  ,
 0.00041208489494  , 0.00040087739851  , 0.00036316139871  , 0.00027682350498  ,
 0.000172700309665 , 9.6461380473e-05  , 9.01498703725e-05 , 0.000219437407047 ,
 0.000608727512068 , 0.00139937161534  , 0.00260683980609  , 0.0040684348905   ,
 0.00575463497588  , 0.00822007712964  , 0.0123274108509   , 0.0179088650626   ,
 0.0227825756849   , 0.0240508392057   , 0.0210042245222   , 0.0162142806066   ,
 0.0131707892293   , 0.0132079275633   , 0.0151557281481   , 0.0174826059638   ,
 0.0198385290625   , 0.0223544512227   , 0.0247833742404   , 0.0281772737791   ,
 0.0377101637915   , 0.0621338608047   , 0.108800851361    , 0.181045466465    ,
 0.287360064234    , 0.463514217532    , 0.801367032388    , 1.48216936626     ,
 2.81334190376     , 5.27021992956     , 9.57702588337     , 16.8682420026     ,
 28.8620538753     , 47.8551639514     , 76.3798770922     , 116.458457752     ,
 168.447555951     , 229.689172832     , 293.656916764     , 350.604783981     ,
 390.273777476     , 405.768936916     , 396.280938914     , 366.723004938     ,
 324.750801697     , 277.554408682     , 230.295210524     , 186.171305537     ,
 147.014087        , 113.667710758     , 86.1954559999     , 64.1582303614     ,
 46.8975511976     , 33.6640452067     , 23.6730895961     , 16.2175061841     ,
 10.759320606      , 6.89454646358     , 4.26678548195     , 2.54595328897     ,
 1.45842826868     , 0.799839789632    , 0.420925609091    , 0.213697946925    ,
 0.105373157932    , 0.0513818684912   , 0.0257736631742   , 0.0137296644155   ,
 0.00753566182069  , 0.00393948043927  , 0.00183372240888  , 0.000733695243305 ,
 0.000249224915667 , 7.18318463798e-05 , 1.77150099347e-05 , 3.85135057583e-06 ,
 8.40786341101e-07 , 3.5354100697e-07  , 5.37499375872e-07 , 1.3095583658e-06  ,
 4.10708006852e-06 , 1.55893742101e-05 , 5.68273006227e-05 , 0.000172239399291 ,
 0.000414178981312 , 0.000780810906644 , 0.00115178647798  , 0.00133338097293  ,
 0.00122910032826  , 0.000958553293784 , 0.000776192577767 , 0.000898515734625 ,
 0.00145291571916  , 0.00256990708985  , 0.00437863959918  , 0.00668509030092  ,
 0.00863865580158  , 0.00909898559674  , 0.00765153842376  , 0.00508331061567  ,
 0.0026538046286   , 0.00108561896737  , 0.000347426760436 , 8.68978607426e-05 ,
 1.69817853277e-05 , 2.62389277373e-06 , 5.74937484867e-07 , 1.93092960997e-06 ,
 1.20356622456e-05 , 6.64515777955e-05 , 0.000312662610396 , 0.00122792763612  ,
 0.00398877433865  , 0.0107645345343   , 0.0246123951469   , 0.0495776183073   ,
 0.0937645626934   , 0.180994091136    , 0.38423864484     , 0.921796422053    ,
 2.42933237321     , 6.66003317016     , 18.067356637      , 46.817938209      ,
 113.125233213     , 250.439132365     , 501.423725012     , 899.975502423     ,
 1440.75443502     , 2053.58301544     , 2608.78266491     , 2964.39155379     ,
 3032.44127284     , 2820.04344619     , 2417.33607853     , 1945.22419861     ,
 1501.77327071     , 1136.87176522     , 857.59218508      , 648.324033384     ,
 489.013886903     , 364.20975801      , 264.51880561      , 184.982797754     ,
 123.103315157     , 77.1991617746     , 45.2970554795     , 24.7685404094     ,
 12.6160290446     , 6.01090670522     , 2.70745813188     , 1.17627425817     ,
 0.50814858473     , 0.224741163694    , 0.102010823655    , 0.0202769190531   ,
 0.00923838062168  , 0.00462806414493  , 0.00351807841614  , 0.00378120046265  ,
 0.00417866929034  , 0.00427244777952  , 0.00408099356655  , 0.00365801746087  ,
 0.0029864416527   , 0.00215309602062  , 0.00137797723794  , 0.000822751475443 ,
 0.000485173759556 , 0.000284790830373 , 0.000164939059458 , 0.000103184679573 ,
 8.15984902446e-05 , 7.66792773113e-05 , 6.91330581241e-05 , 5.28260912684e-05 ,
 3.32328203167e-05 , 1.98831260357e-05 , 2.39795233278e-05 , 6.67891536242e-05 ,
 0.00018951059989  , 0.00044497007935  , 0.000880537386334 , 0.00160914489476  ,
 0.00307455029324  , 0.00628747824832  , 0.0123162487365   , 0.0206999966906   ,
 0.0282666634241   , 0.0307529846365   , 0.0266356393159   , 0.0188111817309   ,
 0.0118315329166   , 0.00810560973863  , 0.00716588055752  , 0.00759409582821  ,
 0.00860529123078  , 0.0100207739861   , 0.0120475051089   , 0.0164477334393   ,
 0.0280328593079   , 0.0532554799033   , 0.0952229071219   , 0.15156765379     ,
 0.224678318831    , 0.345115134257    , 0.599242356164    , 1.1544073562      ,
 2.27878872293     , 4.35966348695     , 7.95518199536     , 13.9224666658     ,
 23.5747463591     , 38.7139328481     , 61.3862880574     , 93.2557615194     ,
 134.55838678      , 182.875854578     , 232.433744929     , 274.849059505     ,
 301.694908448     , 307.894019967     , 293.834054101     , 264.682879956     ,
 227.532567919     , 188.546255787     , 151.696947088     , 118.995608431     ,
 91.2049315143     , 68.3720426131     , 50.1464942595     , 36.0048521791     ,
 25.3619473215     , 17.5741103046     , 11.9683945517     , 7.95772149578     ,
 5.12521911259     , 3.18829413999     , 1.91817350846     , 1.11392296243     ,
 0.619348546366    , 0.327382617619    , 0.164818822267    , 0.079688609566    ,
 0.0372772921145   , 0.0170968950451   , 0.00799427603805  , 0.00399872134446  ,
 0.00210847174394  , 0.0010755173218   , 0.000488397171161 , 0.000188782417479 ,
 6.11275962717e-05 , 1.65616580592e-05 , 3.78018985201e-06 , 7.39815190712e-07 ,
 1.33767835628e-07 , 3.88199830065e-08 , 5.56258361119e-08 , 1.81272394876e-07 ,
 7.93940403355e-07 , 3.57762365636e-06 , 1.3768972054e-05  , 4.23372788971e-05 ,
 0.000102180448471 , 0.000192808981242 , 0.000284475725697 , 0.000329316505477 ,
 0.000303505538046 , 0.000236939960725 , 0.000194832530755 , 0.000240187312389 ,
 0.000430491512216 , 0.000844459049316 , 0.00155536519715  , 0.00248764321038  ,
 0.00329178181706  , 0.00350600392646  , 0.00296312212575  , 0.00197293180149  ,
 0.00103097202925  , 0.000421896187036 , 0.000135017849801 , 3.37609802088e-05 ,
 6.60502590145e-06 , 1.12562049019e-06 , 9.49867920748e-07 , 4.58715472556e-06 ,
 2.0813198502e-05  , 8.10968574545e-05 , 0.000282384230625 , 0.000903120357932 ,
 0.00265145836496  , 0.0070346247189   , 0.0167656526426   , 0.0365501087347   ,
 0.0759818035725   , 0.158711317874    , 0.348480653488    , 0.823163823813    ,
 2.07506124701     , 5.39738598683     , 13.9265727543     , 34.5157515507     ,
 80.1710635439     , 171.207768876     , 331.37025705      , 575.757014311     ,
 893.409553499     , 1236.3125098      , 1528.48910548     , 1696.50341988     ,
 1703.92597193     , 1566.16393959     , 1336.82932583     , 1078.38128465     ,
 837.585701766     , 636.846395179     , 479.019072741     , 357.254295954     ,
 262.96255342      , 189.43742366      , 132.253206224     , 88.5352892528     ,
 56.2338088776     , 33.5729672568     , 18.7098479026     , 9.69544205841     ,
 4.67247158635     , 2.1074228965      , 0.905481900555    , 0.385011578923    ,
 0.171626913424    , 0.0830260313246   , 0.0418382600041   , 0.0101976376438   ,
 0.00576272217031  , 0.00506322043319  , 0.0065621224797   , 0.0083336177049   ,
 0.00879765253329  , 0.00752369043569  , 0.00528503200741  , 0.00316481187712  ,
 0.00170897289755  , 0.00087842110532  , 0.000441890061444 , 0.000221180032    ,
 0.000113214054165 , 5.96436653144e-05 , 3.17006035181e-05 , 1.80182100554e-05 ,
 1.29463813342e-05 , 1.16104499858e-05 , 1.03638149699e-05 , 7.92929825455e-06 ,
 5.05106902728e-06 , 3.34470130413e-06 , 5.26888968382e-06 , 1.6308964057e-05  ,
 4.83709830637e-05 , 0.000125462821153 , 0.000314953844607 , 0.000855783930948 ,
 0.00243563432373  , 0.00636636212067  , 0.0139175214824   , 0.0244422599023   ,
 0.0339801370205   , 0.0371992252147   , 0.0320466213619   , 0.0218626753812   ,
 0.0121548149815   , 0.0060954076563   , 0.00352380678306  , 0.002920105913    ,
 0.00317061128013  , 0.00393606995367  , 0.0057002898319   , 0.0105467944364   ,
 0.0228439080228   , 0.0473981954133   , 0.0846381461184   , 0.128851434992    ,
 0.178505316803    , 0.258790764832    , 0.445868287349    , 0.885015221161    ,
 1.80214533854     , 3.51366729798     , 6.45683873036     , 11.2668700642     ,
 18.8782738873     , 30.5672722956     , 47.8187627723     , 71.866431446      ,
 102.815338047     , 138.589583895     , 174.406350737     , 203.572155981     ,
 219.746497304     , 219.642659815     , 204.438630339     , 178.902518667     ,
 148.945163713     , 119.350029958     , 92.8690372979     , 70.5448748485     ,
 52.426296112      , 38.1157373703     , 27.0821155258     , 18.8109947996     ,
 12.8200867524     , 8.61606600678     , 5.70962736549     , 3.69935681602     ,
 2.32058645228     , 1.40639929364     , 0.826306139426    , 0.468939479977    ,
 0.253133579933    , 0.128075758505    , 0.0607865239372   , 0.027487930538    ,
 0.0120238529204   , 0.00513781620756  , 0.00220723315131  , 0.00100888709427  ,
 0.000497510065122 , 0.00024450510909  , 0.000108375739666 , 4.0808496962e-05  ,
 1.2748401002e-05  , 3.28899625125e-06 , 7.04197741696e-07 , 1.26658071185e-07 ,
 1.99198599807e-08 , 4.05826003638e-09 , 5.47876517007e-09 , 2.53068387312e-08 ,
 1.38365788576e-07 , 6.72868137421e-07 , 2.64323468792e-06 , 8.16963296123e-06 ,
 1.97428841992e-05 , 3.72658268968e-05 , 5.49866911226e-05 , 6.36525286802e-05 ,
 5.86707398523e-05 , 4.59557413515e-05 , 3.8881663215e-05  , 5.25923693133e-05 ,
 0.000106205550356 , 0.000229219119636 , 0.000448527359752 , 0.000740972733445 ,
 0.000995882154167 , 0.001068250759    , 0.000905702272787 , 0.000603887632837 ,
 0.000315760256622 , 0.000129249164686 , 4.13667685061e-05 , 1.03476823114e-05 ,
 2.07132379252e-06 , 7.53320430779e-07 , 3.00775160346e-06 , 1.55586427345e-05 ,
 6.43256233802e-05 , 0.000212487719482 , 0.000573930253156 , 0.0013272503317   ,
 0.00283437054187  , 0.0060646830468   , 0.0134448683864   , 0.0302554576046   ,
 0.0675381298091   , 0.149660290946    , 0.334862867508    , 0.770341238101    ,
 1.82829583108     , 4.40825121915     , 10.5458330991     , 24.4502203021     ,
 53.7084138661     , 109.450023379     , 203.425342114     , 340.881896895     ,
 511.843895292     , 687.572457995     , 828.238690813     , 899.903391308     ,
 890.110689264     , 811.392194788     , 691.648828857     , 559.915377639     ,
 436.698102219     , 331.805262897     , 247.097729047     , 180.472157276     ,
 128.814237006     , 89.3292480568     , 59.7582199929     , 38.2403268526     ,
 23.1905136137     , 13.2080414913     , 7.01324997121     , 3.45615821039     ,
 1.5808251151      , 0.677505070888    , 0.280857146373    , 0.121242599467    ,
 0.059819537131    , 0.0336430740279   , 0.0191621272697   , 0.00562659630309  ,
 0.00530344702978  , 0.00803519557751  , 0.0126631313506   , 0.016671569529    ,
 0.0175080330089   , 0.0145546486249   , 0.00958016009085  , 0.00501774487637  ,
 0.00211973507295  , 0.000745260636176 , 0.000232698952517 , 7.21934440115e-05 ,
 2.5383380657e-05  , 1.06268893977e-05 , 4.96543339835e-06 , 2.54341148141e-06 ,
 1.64521774056e-06 , 1.38962823243e-06 , 1.22049830501e-06 , 9.33650483348e-07 ,
 6.06017561184e-07 , 4.6351826724e-07  , 9.5888912885e-07  , 3.35130225206e-06 ,
 1.1640629333e-05  , 4.16671405437e-05 , 0.000162979625932 , 0.000635329951007 ,
 0.00217593624591  , 0.0061113208118   , 0.0137017074019   , 0.0242812972371   ,
 0.0338723197262   , 0.0371189969886   , 0.0319293986369   , 0.0216027908222   ,
 0.0116386131656   , 0.00525910328627  , 0.00237144724877  , 0.00145440978916  ,
 0.00132567620024  , 0.00164434770863  , 0.00298254166005  , 0.00728138302571  ,
 0.0181338116057   , 0.0390918595109   , 0.069745478656    , 0.104540729164    ,
 0.141576883584    , 0.200920179486    , 0.343258933924    , 0.683579409549    ,
 1.40283632541     , 2.76089706365     , 5.11275168256     , 8.92951060108     ,
 14.8248873051     , 23.5843806747     , 36.1349646375     , 53.2724459613     ,
 74.9961810217     , 99.6668606178     , 123.63938023      , 142.010973624     ,
 150.446698256     , 147.118183791     , 133.487445148     , 113.428016813     ,
 91.3645710714     , 70.6635220917     , 53.0493935481     , 38.9268044339     ,
 27.9970854883     , 19.7278545049     , 13.5978665402     , 9.17689107772     ,
 6.09986373097     , 4.0214325413      , 2.62635264733     , 1.67911601942     ,
 1.03916565091     , 0.622697737941    , 0.362860263074    , 0.203448029131    ,
 0.106715178244    , 0.0510727213072   , 0.0222662895238   , 0.0090700772729   ,
 0.0035723954343   , 0.00138684594632  , 0.000539097634159 , 0.000220124190691 ,
 9.84483060684e-05 , 4.56789572583e-05 , 1.96601672106e-05 , 7.24567146e-06    ,
 2.20664253425e-06 , 5.49520492509e-07 , 1.12065087101e-07 , 1.88748806188e-08 ,
 2.68569933152e-09 , 4.18178613406e-10 , 5.42783049447e-10 , 3.29955228099e-09 ,
 2.00959658526e-08 , 1.00680227095e-07 , 3.98473873041e-07 , 1.23387597964e-06 ,
 2.98318440337e-06 , 5.63157204909e-06 , 8.30970270228e-06 , 9.61947248147e-06 ,
 8.87143602062e-06 , 6.99582338253e-06 , 6.20581159912e-06 , 9.51420731582e-06 ,
 2.17536688293e-05 , 5.08474233798e-05 , 0.000103950539573 , 0.000175481604015 ,
 0.00023822021358  , 0.000256677190647 , 0.000218051600854 , 0.000145515614422 ,
 7.61164654119e-05 , 3.11618210412e-05 , 9.97508342059e-06 , 2.50814351219e-06 ,
 6.42171842315e-07 , 1.39446853484e-06 , 8.78237340102e-06 , 4.56512055617e-05 ,
 0.000186370565744 , 0.000599259018464 , 0.00152997929852  , 0.00316254943103  ,
 0.0055486836358   , 0.00912696441706  , 0.0161080051029   , 0.0323166170341   ,
 0.0696346513698   , 0.152047090027    , 0.332768557914    , 0.735626261527    ,
 1.64057579185     , 3.6471109157      , 7.98299499251     , 17.0175396165     ,
 34.7935168762     , 66.8626334449     , 118.419116603     , 190.531259587     ,
 276.275804705     , 360.183000991     , 423.170302526     , 450.909565745     ,
 440.097751093     , 398.422149486     , 339.136707223     , 274.844202308     ,
 214.139591843     , 161.397942877     , 118.022958383     , 83.7603450684     ,
 57.5988732022     , 38.2633829165     , 24.4466443355     , 14.9287996761     ,
 8.6458360235      , 4.70899029829     , 2.39368095088     , 1.12911683475     ,
 0.493680351822    , 0.202601764785    , 0.0822459144741   , 0.0374131009301   ,
 0.0212734485368   , 0.0138283382493   , 0.00876718565252  , 0.00376685812906  ,
 0.00632597970235  , 0.0122083986629   , 0.020218752323    , 0.026827676501    ,
 0.0281707754368   , 0.0233418661541   , 0.0152402820782   , 0.00783512267938  ,
 0.00317300353043  , 0.00101544598465  , 0.00025951155556  , 5.46576612565e-05 ,
 1.04258562203e-05 , 2.2580561117e-06  , 6.97561993602e-07 , 2.9471564861e-07  ,
 1.67798500551e-07 , 1.31439882405e-07 , 1.12761907781e-07 , 8.61265463963e-08 ,
 5.75784757246e-08 , 5.42018662607e-08 , 1.54865191216e-07 , 7.08241335227e-07 ,
 3.67763407898e-06 , 2.04320092982e-05 , 0.000106714116101 , 0.000472575022044 ,
 0.00169359748417  , 0.00482808626679  , 0.0108777766507   , 0.0193097655898   ,
 0.0269561975782   , 0.0295568378354   , 0.0254617434523   , 0.0173333993434   ,
 0.00959314881296  , 0.00479969432295  , 0.00276190955517  , 0.00208083160067  ,
 0.00171705135897  , 0.00149919401746  , 0.00206635598535  , 0.00497414549051  ,
 0.012806155922    , 0.0281426217633   , 0.0512009338536   , 0.0794028558821   ,
 0.113392917162    , 0.168915211634    , 0.289108759276    , 0.555981359809    ,
 1.10604066592     , 2.14996307381     , 3.98085215564     , 6.95080841446     ,
 11.4302415446     , 17.8092747777     , 26.5366186318     , 38.0168499604     ,
 52.177491171      , 67.858162697      , 82.5612312197     , 93.0439015763     ,
 96.6308619136     , 92.4675602451     , 81.8788812965     , 67.6474237911     ,
 52.7577449928     , 39.3716534964     , 28.4787589903     , 20.1493297684     ,
 13.9997148574     , 9.54876851273     , 6.3860586374      , 4.20198421287     ,
 2.74884594914     , 1.8055751262      , 1.18646150155     , 0.767527740505    ,
 0.483742612778    , 0.297927999374    , 0.178776141372    , 0.10149199268     ,
 0.0521152931201   , 0.0234060900377   , 0.00914003354359  , 0.00319030365821  ,
 0.0010528948298   , 0.000347141725363 , 0.000117294082723 , 4.17250124226e-05 ,
 1.63976129198e-05 , 6.9849521597e-06  , 2.88357754883e-06 , 1.0399270922e-06  ,
 3.10831033588e-07 , 7.55551576992e-08 , 1.48877670911e-08 , 2.38940451541e-09 ,
 3.16665605242e-10 , 4.14232876452e-11 , 5.1941717789e-11  , 3.67285477597e-10 ,
 2.33801562305e-09 , 1.18437433308e-08 , 4.70025209865e-08 , 1.45640453738e-07 ,
 3.52178120987e-07 , 6.64858664617e-07 , 9.81047336038e-07 , 1.13577649811e-06 ,
 1.04868100478e-06 , 8.36888263801e-07 , 7.98871865879e-07 , 1.42898756728e-06 ,
 3.66877848585e-06 , 9.11497309254e-06 , 1.92022982099e-05 , 3.28738497931e-05 ,
 4.49098204485e-05 , 4.85248114748e-05 , 4.12733912039e-05 , 2.75585292238e-05 ,
 1.441881235e-05   , 5.90376127125e-06 , 1.89207198652e-06 , 5.05779395722e-07 ,
 4.54217874605e-07 , 3.08949482283e-06 , 2.04309464108e-05 , 0.000106218362173 ,
 0.000432931667186 , 0.00138686346589  , 0.00350992300245  , 0.00710492576929  ,
 0.0118703173071   , 0.0176454077714   , 0.0266548287816   , 0.0456554875956   ,
 0.0868609599866   , 0.171566811399    , 0.345195391403    , 0.710442342123    ,
 1.47785036018     , 3.03726609783     , 6.08633850133     , 11.8588747817     ,
 22.3415382713     , 40.0763550248     , 67.0923246068     , 103.073783696     ,
 143.844703652     , 181.692434369     , 208.090614867     , 217.437464518     ,
 209.321561554     , 187.880153818     , 159.119175002     , 128.354834779     ,
 99.1511741058     , 73.5033765786     , 52.334114002      , 35.8173385622     ,
 23.5841965796     , 14.9405668975     , 9.08817921819     , 5.28531287491     ,
 2.92081612723     , 1.52356984885     , 0.745239747111    , 0.33977018468     ,
 0.143968639367    , 0.0574642248745   , 0.0232072496061   , 0.0112487889162   ,
 0.00721253409972  , 0.00520872850946  , 0.00382785938005  , 0.00319850592393  ,
 0.00740364502863  , 0.0153605078978   , 0.0257471103185   , 0.0342255429177   ,
 0.0359435323643   , 0.0297717130749   , 0.0194205255206   , 0.00996273453881  ,
 0.00401437502652  , 0.00126945936543  , 0.000315089491768 , 6.1552083955e-05  ,
 9.57403531487e-06 , 1.24447252441e-06 , 1.63530184909e-07 , 3.38136010711e-08 ,
 1.40880488247e-08 , 9.84598050531e-09 , 8.16899930954e-09 , 6.22348534678e-09 ,
 4.38775045357e-09 , 5.92351308762e-09 , 2.89348709406e-08 , 2.14870622541e-07 ,
 1.65472443635e-06 , 1.13643646101e-05 , 6.451050669e-05   , 0.000293821217257 ,
 0.00106247143761  , 0.00303748204402  , 0.00684992076599  , 0.0121648735045   ,
 0.0169926746411   , 0.0186744833932   , 0.0162434277355   , 0.0115178194277   ,
 0.00742923556766  , 0.00554135345391  , 0.0053189943967   , 0.0052824947248   ,
 0.0045082871971   , 0.00321957685267  , 0.00241506309319  , 0.00342291510435  ,
 0.00790782508103  , 0.0177608100545   , 0.0344788202691   , 0.0593722343218   ,
 0.0964620931255   , 0.157881177438    , 0.270796587399    , 0.488042659401    ,
 0.906679059453    , 1.69100171703     , 3.07692984358     , 5.32652466197     ,
 8.64774612466     , 13.1649534619     , 18.9815611778     , 26.1985771815     ,
 34.6990474989     , 43.7639623922     , 51.898277027      , 57.2050375963     ,
 58.204949861      , 54.5698087913     , 47.2680757014     , 38.0756205706     ,
 28.8186208806     , 20.7776847883     , 14.4845602232     , 9.88246186627     ,
 6.63692922749     , 4.38479440987     , 2.84552680756     , 1.82597136187     ,
 1.18007510109     , 0.780980804321    , 0.52697101944     , 0.355878229915    ,
 0.238553298881    , 0.15847751951     , 0.101740875711    , 0.0598144441991   ,
 0.0305058997832   , 0.0130465396902   , 0.00463006495433  , 0.00138292914942  ,
 0.000364289878255 , 9.19776380423e-05 , 2.42932770181e-05 , 7.05300361037e-06 ,
 2.33163615264e-06 , 8.78300494785e-07 , 3.40547161904e-07 , 1.19474008734e-07 ,
 3.51384811386e-08 , 8.40010091367e-09 , 1.61749819685e-09 , 2.51072750646e-10 ,
 3.1672502635e-11  , 3.71729916896e-12 , 4.38894001479e-12 , 3.31128826209e-11 ,
 2.14352652147e-10 , 1.09025249014e-09 , 4.33096819282e-09 , 1.34230183282e-08 ,
 3.24605842266e-08 , 6.12815550257e-08 , 9.042687756e-08   , 1.04708649589e-07 ,
 9.68853813383e-08 , 7.88731610781e-08 , 8.37904079459e-08 , 1.77996202454e-07 ,
 5.03823686225e-07 , 1.30744909662e-06 , 2.80945490493e-06 , 4.85279477323e-06 ,
 6.65576160819e-06 , 7.20399620506e-06 , 6.13211415622e-06 , 4.09582763559e-06 ,
 2.14329294845e-06 , 8.77846515419e-07 , 2.85280069537e-07 , 1.3099685922e-07  ,
 6.74434663297e-07 , 5.61547382418e-06 , 3.72867428242e-05 , 0.000193846087121 ,
 0.000789918326031 , 0.00252908228591  , 0.00639184686399  , 0.0128906981956   ,
 0.021318460362    , 0.0308570542646   , 0.0440110997329   , 0.0689558361515   ,
 0.117917030435    , 0.207214644536    , 0.370636806357    , 0.688448346558    ,
 1.31702947587     , 2.50803002351     , 4.64402979159     , 8.33022624782     ,
 14.4764263747     , 24.1439984523     , 37.9701551929     , 55.3404920194     ,
 73.9012368199     , 90.009658108      , 100.110485642     , 102.25142492      ,
 96.7628949358     , 85.7386296939     , 71.8303687164     , 57.2542415721     ,
 43.490245635      , 31.4467322798     , 21.6317110049     , 14.1836094434     ,
 8.89936658653     , 5.36002994499     , 3.09829513614     , 1.71256901569     ,
 0.901005199938    , 0.44984662021     , 0.212999136598    , 0.0956704581653   ,
 0.0408082484965   , 0.0167484571433   , 0.00705080430937  , 0.00354023238405  ,
 0.00231608933724  , 0.00178900167881  , 0.00180106892392  , 0.00283577949791  ,
 0.00731066692818  , 0.0154549594174   , 0.0259816734016   , 0.0345526297785   ,
 0.0362888205604   , 0.0300566648729   , 0.0196043791034   , 0.010054608348    ,
 0.00404909299498  , 0.00127871153948  , 0.000316337964633 , 6.12648832073e-05 ,
 9.29180170569e-06 , 1.10796682417e-06 , 1.06146389605e-07 , 9.24603340436e-09 ,
 1.30716701934e-09 , 5.99906145031e-10 , 4.64574787599e-10 , 3.5315963931e-10  ,
 2.86879790287e-10 , 8.53881584153e-10 , 8.24010726404e-09 , 8.55316313216e-08 ,
 7.6190516559e-07  , 5.51407728597e-06 , 3.18414980031e-05 , 0.000145810755232 ,
 0.000528148967892 , 0.00151075598719  , 0.0034079842785   , 0.0060561657633   ,
 0.00848118859226  , 0.00942244631869  , 0.00857669809585  , 0.00719163571055  ,
 0.00707939924081  , 0.00889870114234  , 0.0113789739562   , 0.0123423707434   ,
 0.0106880078872   , 0.0073317023029   , 0.00423010819123  , 0.00297516149452  ,
 0.00461703325344  , 0.0105070252464   , 0.0231703685373   , 0.04691644794     ,
 0.0882198416261   , 0.156363273557    , 0.266900813238    , 0.451712329127    ,
 0.776885951933    , 1.36283682629     , 2.38658000568     , 4.03630477183     ,
 6.42409569294     , 9.53351942878     , 13.2693267774     , 17.538097628      ,
 22.2008456524     , 26.8789601618     , 30.8257735326     , 33.092803723      ,
 32.9585313774     , 30.3209957471     , 25.7693229183     , 20.3121153787     ,
 14.9690901896     , 10.449485208      , 7.03088035245     , 4.6379476006      ,
 3.02697755129     , 1.95040685628     , 1.23318903662     , 0.769747156615    ,
 0.487721254173    , 0.323843877891    , 0.226238213072    , 0.163388426745    ,
 0.120403516811    , 0.0884406899311   , 0.0612353022359   , 0.0373647872151   ,
 0.019112924375    , 0.00797532071862  , 0.00268588556456  , 0.000731447357102 ,
 0.000164004762317 , 3.17842309507e-05 , 5.88278305298e-06 , 1.19495575285e-06 ,
 2.97179024164e-07 , 9.24743324617e-08 , 3.24799766148e-08 , 1.09376790537e-08 ,
 3.15989026078e-09 , 7.45871262595e-10 , 1.41446893575e-10 , 2.1475895813e-11  ,
 2.62076179481e-12 , 2.86509201371e-13 , 3.06445322817e-13 , 2.3623428829e-12  ,
 1.53872749007e-11 , 7.83790151809e-11 , 3.11467101985e-10 , 9.65417478858e-10 ,
 2.33469780998e-09 , 4.40765227639e-09 , 6.50412310075e-09 , 7.53400137707e-09 ,
 6.99658025152e-09 , 5.88178422113e-09 , 7.23133698217e-09 , 1.82576447235e-08 ,
 5.57103944206e-08 , 1.48901644014e-07 , 3.24053590465e-07 , 5.62877474595e-07 ,
 7.73897430207e-07 , 8.3854060432e-07  , 7.14108925987e-07 , 4.77074186475e-07 ,
 2.4968323984e-07  , 1.02583811301e-07 , 3.89554882377e-08 , 9.49614782415e-08 ,
 9.4532530518e-07  , 8.01797069797e-06 , 5.32570597029e-05 , 0.00027687277114  ,
 0.00112823708004  , 0.00361215862591  , 0.00912814313831  , 0.0184015353021   ,
 0.0303836335302   , 0.0437216783401   , 0.0612823585445   , 0.0925231281466   ,
 0.149164409103    , 0.241520997041    , 0.39018454809     , 0.652702631802    ,
 1.14199049275     , 2.0206842916      , 3.49702858091     , 5.85733259947     ,
 9.49088240935     , 14.7796342676     , 21.7962653707     , 29.9685368905     ,
 38.009556453      , 44.2904780845     , 47.4911953121     , 47.1205913595     ,
 43.6032991117     , 37.9498827975     , 31.2756139027     , 24.4717594694     ,
 18.1474025361     , 12.7090168045     , 8.39610976387     , 5.25345667279     ,
 3.1373539519      , 1.79929443151     , 0.990594026103    , 0.520523334138    ,
 0.260210267582    , 0.12494344179     , 0.0594037474788   , 0.0292682157676   ,
 0.0153199955546   , 0.00825884089593  , 0.00432677426844  , 0.00216088997852  ,
 0.00110185822353  , 0.000738789714047 , 0.00108359002988  , 0.00219799740298  ,
 0.00580648126356  , 0.0123294344234   , 0.0207419295168   , 0.0275873403527   ,
 0.0289739510676   , 0.0239979700709   , 0.015652433065    , 0.00802753295715  ,
 0.00323256345979  , 0.00102069640406  , 0.000252416122627 , 4.88399326233e-05 ,
 7.3882165574e-06  , 8.73518203665e-07 , 8.08169692175e-08 , 5.91039702293e-09 ,
 3.72742046907e-10 , 4.15957028527e-11 , 2.11698119491e-11 , 1.60514590869e-11 ,
 2.2483975563e-11  , 2.06775247763e-10 , 2.79591762461e-09 , 3.20055286065e-08 ,
 2.94406997394e-07 , 2.15267137003e-06 , 1.24708519382e-05 , 5.71649326072e-05 ,
 0.000207131595754 , 0.000592641441687 , 0.00133780088805  , 0.00238402829559  ,
 0.0033788665278   , 0.0039448144326   , 0.00429748997347  , 0.00557190041015  ,
 0.00914427296185  , 0.0150486426594   , 0.020897551198    , 0.023125586651    ,
 0.0200955612599   , 0.0136817294508   , 0.00740052494087  , 0.00362207542836  ,
 0.00306200118989  , 0.00645872724845  , 0.0165297392975   , 0.0388470307677   ,
 0.0809291424187   , 0.150596932706    , 0.257733281685    , 0.422839033766    ,
 0.69026305524     , 1.14041334063     , 1.8904748217      , 3.06340006889     ,
 4.71839104657     , 6.79012653281     , 9.10886771953     , 11.4934089642     ,
 13.8049504946     , 15.8847258983     , 17.455848866      , 18.1436594986     ,
 17.6503040585     , 15.9497066475     , 13.3418386646     , 10.333755827      ,
 7.44504143265     , 5.0464252294      , 3.2840904208      , 2.10356228095     ,
 1.34726553122     , 0.858432503223    , 0.534508458869    , 0.323955332664    ,
 0.197576252085    , 0.128652271702    , 0.0926515758799   , 0.0731063344956   ,
 0.0608742800806   , 0.0499703247775   , 0.0371877071439   , 0.0234838653531   ,
 0.0121103670818   , 0.00500590101247  , 0.00164588486958  , 0.000429775551126 ,
 8.94762653402e-05 , 1.50581445157e-05 , 2.12904626899e-06 , 2.79255050052e-07 ,
 4.16022088372e-08 , 8.77619167907e-09 , 2.54685354171e-09 , 7.98765830395e-10 ,
 2.24986575161e-10 , 5.24710993908e-11 , 9.84511593438e-12 , 1.47351311113e-12 ,
 1.75965702298e-13 , 1.83040428966e-14 , 1.71127404232e-14 , 1.32132320337e-13 ,
 8.62621962536e-13 , 4.39640326296e-12 , 1.74730022141e-11 , 5.41607421912e-11 ,
 1.30979629843e-10 , 2.47276815319e-10 , 3.64913323306e-10 , 4.22950432112e-10 ,
 3.95174051825e-10 , 3.49370975976e-10 , 5.16772420747e-10 , 1.52575236933e-09 ,
 4.91307259931e-09 , 1.33872114762e-08 , 2.93688268352e-08 , 5.11906170416e-08 ,
 7.04881150171e-08 , 7.6426246139e-08  , 6.51040544744e-08 , 4.35000457971e-08 ,
 2.27829734061e-08 , 9.7121997866e-09  , 9.94080424056e-09 , 9.76496314676e-08 ,
 1.05398293547e-06 , 8.95322976333e-06 , 5.94711391038e-05 , 0.000309182440857 ,
 0.00125993817144  , 0.00403416457044  , 0.0101968773192   , 0.0205673127721   ,
 0.0339992128881   , 0.0490041252967   , 0.0686393583074   , 0.102622307906    ,
 0.16139922906     , 0.250252052446    , 0.379135226186    , 0.586365725775    ,
 0.950493787618    , 1.57536053436     , 2.57303140887     , 4.07307531343     ,
 6.22542578714     , 9.12399424328     , 12.6527358266     , 16.3770433021     ,
 19.6164171357     , 21.7012229708     , 22.252019921      , 21.2927264806     ,
 19.1577699931     , 16.3052673912     , 13.1626052877     , 10.0614484278     ,
 7.2458551488      , 4.89191143359     , 3.09591004206     , 1.85111870493     ,
 1.0595598867      , 0.585547296771    , 0.310928031798    , 0.156829134838    ,
 0.0758486853041   , 0.038083994289    , 0.0233219607005   , 0.018203009537    ,
 0.0150971551796   , 0.0112019110039   , 0.00689595467633  , 0.00344558791794  ,
 0.00142513772734  , 0.000624213359693 , 0.000779818246354 , 0.001397112821    ,
 0.00366185620664  , 0.00777782052594  , 0.0130863891005   , 0.0174056750569   ,
 0.0182805942898   , 0.0151410885089   , 0.00987560957643  , 0.00506480626404  ,
 0.00203950475331  , 0.000643972019035 , 0.000159246574351 , 3.08095075143e-05 ,
 4.65944116323e-06 , 5.50447094735e-07 , 5.07731051636e-08 , 3.65776324962e-09 ,
 2.06996564688e-10 , 9.99398396546e-12 , 1.03340892073e-12 , 6.78693812699e-13 ,
 3.49317118469e-12 , 5.74218819271e-11 , 8.39012551826e-10 , 9.79550133754e-09 ,
 9.06546501973e-08 , 6.64116566263e-07 , 3.84966340567e-06 , 1.76503310787e-05 ,
 6.39687064299e-05 , 0.000183161800952 , 0.000414743240642 , 0.000748874402492 ,
 0.00112023163069  , 0.00158404889709  , 0.00269840427018  , 0.00576225946974  ,
 0.0121781821985   , 0.0216271253153   , 0.0305966753047   , 0.034003033755    ,
 0.029569958469    , 0.0201016732156   , 0.0107188650742   , 0.00469004899568  ,
 0.00253773447055  , 0.00427856085486  , 0.0120029343572   , 0.0310016945367   ,
 0.0688790499462   , 0.133873545031    , 0.235982398389    , 0.392425254118    ,
 0.633216334426    , 1.00342165063     , 1.56304895094     , 2.37623911204     ,
 3.4718865487      , 4.78849983297     , 6.16509963625     , 7.41547844106     ,
 8.42134194436     , 9.14207690431     , 9.54046998283     , 9.53040429778     ,
 9.01939884799     , 8.00134692529     , 6.60315773853     , 5.04774478792     ,
 3.57425705335     , 2.36424717585     , 1.49459799685     , 0.934767494435    ,
 0.593068425876    , 0.37828077173     , 0.234304853394    , 0.137968392426    ,
 0.0797090672749   , 0.0499514607128   , 0.0379997382048   , 0.0352552604761   ,
 0.0353779317765   , 0.0333523533639   , 0.0268864360072   , 0.017661554871    ,
 0.00924971599189  , 0.0038260867659   , 0.00124525563646  , 0.000318524811165 ,
 6.40667728104e-05 , 1.01581444254e-05 , 1.27868704776e-06 , 1.30537302228e-07 ,
 1.16090708503e-08 , 1.13809931203e-09 , 1.85397103352e-10 , 4.74525109656e-11 ,
 1.26851995616e-11 , 2.9112108872e-12  , 5.41438488864e-13 , 8.02713314657e-14 ,
 9.45370748102e-15 , 9.48047508011e-16 , 7.53255631449e-16 , 5.77118192092e-15 ,
 3.77208214355e-14 , 1.92302683244e-13 , 7.64338962977e-13 , 2.36924828314e-12 ,
 5.72970052082e-12 , 1.08172300646e-11 , 1.59648753043e-11 , 1.85228125917e-11 ,
 1.74797611162e-11 , 1.66809763483e-11 , 3.0585082756e-11  , 1.02710335597e-10 ,
 3.43051675267e-10 , 9.46307389507e-10 , 2.08638655976e-09 , 3.64441413576e-09 ,
 5.02291875422e-09 , 5.44826361663e-09 , 4.64195968732e-09 , 3.10227750491e-09 ,
 1.63825879727e-09 , 1.00475235305e-09 , 6.28158057583e-09 , 8.45885610257e-08 ,
 9.19338925637e-07 , 7.81044829237e-06 , 5.18807378541e-05 , 0.00026972635521  ,
 0.00109921440105  , 0.00352010458064  , 0.00890144378637  , 0.0179760786297   ,
 0.0298092389826   , 0.0432710656314   , 0.061315855682    , 0.0926342503517   ,
 0.145964885287    , 0.224241688929    , 0.332187203194    , 0.494822357233    ,
 0.764094293018    , 1.20209380545     , 1.86260216113     , 2.79336464056     ,
 4.03657125466     , 5.58470974445     , 7.30647440531     , 8.92449855173     ,
 10.1016508692     , 10.5924890939     , 10.3486226094     , 9.5037052168      ,
 8.27121700086     , 6.84969962862     , 5.38973805948     , 4.00576928745     ,
 2.79103477647     , 1.81406107997     , 1.10283694031     , 0.63598419319     ,
 0.355133303859    , 0.193817088506    , 0.101956735122    , 0.0512372124255   ,
 0.0269788691759   , 0.0196710168689   , 0.0211960106718   , 0.0242931706731   ,
 0.0239349943231   , 0.0190478403876   , 0.0120511418066   , 0.00603488454435  ,
 0.00240320118477  , 0.000840014220994 , 0.000586310821308 , 0.000726324987283 ,
 0.00182788883531  , 0.00387392560124  , 0.00651736749731  , 0.00866847678013  ,
 0.00910421395954  , 0.00754065840291  , 0.00491831144491  , 0.00252240492951  ,
 0.00101572548617  , 0.000320713930274 , 7.93083680052e-05 , 1.53436605792e-05 ,
 2.32041665701e-06 , 2.74102768263e-07 , 2.52764379523e-08 , 1.81880933703e-09 ,
 1.02125386807e-10 , 4.49620803284e-12 , 1.73221130622e-13 , 4.93223612772e-14 ,
 7.40091883168e-13 , 1.36761116334e-11 , 2.02578681473e-10 , 2.37366781477e-09 ,
 2.19920446641e-08 , 1.61166163834e-07 , 9.34367872062e-07 , 4.28493289871e-06 ,
 1.55421467204e-05 , 4.46540465427e-05 , 0.000102581356183 , 0.000196409835061 ,
 0.000360243568946 , 0.000804769686018 , 0.0022298558242   , 0.00603998949871  ,
 0.0136982490505   , 0.0247487531619   , 0.0351520634628   , 0.0391005282769   ,
 0.0340082405942   , 0.0231110662275   , 0.0122817817864   , 0.00520439784409  ,
 0.00224984392048  , 0.00284083676847  , 0.00813926070958  , 0.0223979581686   ,
 0.0529663229904   , 0.109974700341    , 0.207346423558    , 0.36400813055     ,
 0.600403882756    , 0.931108488404    , 1.36522821868     , 1.91630132594     ,
 2.5948195927      , 3.36609806842     , 4.1192307262      , 4.71042479282     ,
 5.05434726762     , 5.16159775559     , 5.08445551549     , 4.84646825304     ,
 4.43540540629     , 3.84945582961     , 3.13300902955     , 2.37089306058     ,
 1.66033355869     , 1.08139353495     , 0.67085792726     , 0.413221353985    ,
 0.260730045236    , 0.166219313361    , 0.102043781329    , 0.0583035524794   ,
 0.0321368669781   , 0.0205202776804   , 0.0193796377814   , 0.0244038253418   ,
 0.0305478983746   , 0.032539502887    , 0.0279229498295   , 0.0189386037962   ,
 0.0100807480156   , 0.00419964912221  , 0.00136799340259  , 0.00034835767894  ,
 6.93669570761e-05 , 1.08079901328e-05 , 1.31920657241e-06 , 1.26446819631e-07 ,
 9.58149678705e-09 , 5.89613332677e-10 , 3.39811814017e-11 , 3.1140992852e-12  ,
 5.90293096767e-13 , 1.27623739641e-13 , 2.34253243075e-14 , 3.44850159495e-15 ,
 4.02533390903e-16 , 3.9335674071e-17  , 2.61554674225e-17 , 1.96827622558e-16 ,
 1.28632589378e-15 , 6.55775118715e-15 , 2.60648717011e-14 , 8.07942072666e-14 ,
 1.95389957978e-13 , 3.68887098932e-13 , 5.44522157341e-13 , 6.32833269084e-13 ,
 6.06938168974e-13 , 6.47238458116e-13 , 1.489789524e-12   , 5.51516025587e-12 ,
 1.886615143e-11   , 5.24444904639e-11 , 1.1598451162e-10  , 2.02863228706e-10 ,
 2.79755399558e-10 , 3.03520445547e-10 , 2.5863790529e-10  , 1.73171805637e-10 ,
 1.00598318573e-10 , 2.68864165385e-10 , 4.14750849202e-09 , 5.75934638077e-08 ,
 6.26212708945e-07 , 5.3198395525e-06  , 3.5336166199e-05  , 0.000183714502617 ,
 0.000748750742778 , 0.00239837558145  , 0.00606923618944  , 0.0122820995454   ,
 0.0204862651492   , 0.030174990712    , 0.0439750169027   , 0.0689065566327   ,
 0.112471182142    , 0.178475982516    , 0.27179373329     , 0.409590050846    ,
 0.622784198471    , 0.940901439964    , 1.377290625       , 1.93212100431     ,
 2.6008238041      , 3.35966058055     , 4.13194624975     , 4.78018073886     ,
 5.15500358126     , 5.17101442591     , 4.84731553389     , 4.28299621428     ,
 3.59599696817     , 2.87787621688     , 2.18825710868     , 1.56973654707     ,
 1.05514411608     , 0.662751442951    , 0.391238459968    , 0.221183161155    ,
 0.122865460236    , 0.0675989597152   , 0.0362307261322   , 0.0197680302409   ,
 0.0146766437931   , 0.0183186270471   , 0.0264890745807   , 0.0332649585625   ,
 0.0336572145786   , 0.0270251804416   , 0.0171558360307   , 0.00859536679364  ,
 0.0034008960897   , 0.0011001140948   , 0.000456485125843 , 0.00032062110624  ,
 0.000722887724433 , 0.0015214685286   , 0.00255870088012  , 0.00340315365861  ,
 0.00357421625534  , 0.00296038109701  , 0.00193087595832  , 0.000990268898475 ,
 0.000398762807533 , 0.000125908784457 , 3.11355836293e-05 , 6.02374351888e-06 ,
 9.10966030416e-07 , 1.07608398924e-07 , 9.92288489473e-09 , 7.13950091141e-10 ,
 4.00661475888e-11 , 1.75372746054e-12 , 6.04069315364e-14 , 7.67210671012e-15 ,
 1.38238802326e-13 , 2.59698592681e-12 , 3.85576793891e-11 , 4.52084378233e-10 ,
 4.18944747227e-09 , 3.07052861187e-08 , 1.78055742016e-07 , 8.17277483371e-07 ,
 2.97557933331e-06 , 8.68555870593e-06 , 2.12664171532e-05 , 5.05790149124e-05 ,
 0.000148002361026 , 0.0005309071554   , 0.00183968278835  , 0.00532042268834  ,
 0.012260428213    , 0.0222328640845   , 0.0316051126156   , 0.035161812212    ,
 0.0305835283726   , 0.0207820839274   , 0.0110337396642   , 0.00462533734643  ,
 0.00179464319526  , 0.00174713038615  , 0.00496567350767  , 0.0146675558578   ,
 0.0379240471524   , 0.0871362864709   , 0.181322740522    , 0.34318538466     ,
 0.586699430302    , 0.901056800879    , 1.25287958164     , 1.61563614353     ,
 1.99007071018     , 2.37463788791     , 2.71856593402     , 2.93477388197     ,
 2.97190129265     , 2.855371404       , 2.6497239138      , 2.39812449155     ,
 2.10753943664     , 1.77624525632     , 1.41765833573     , 1.06021613438     ,
 0.737404723074    , 0.478155256743    , 0.295710146777    , 0.181629797112    ,
 0.113831981876    , 0.0714189632826   , 0.0426780227765   , 0.0235847362839   ,
 0.0131178711119   , 0.0105843611507   , 0.0150748060956   , 0.0245525224799   ,
 0.0343886561532   , 0.0385136461353   , 0.0339134645607   , 0.0233722627838   ,
 0.0125902761955   , 0.0053002675682   , 0.00174432047072  , 0.000449040757414 ,
 9.04979320436e-05 , 1.42933597643e-05 , 1.77134917641e-06 , 1.72488648551e-07 ,
 1.32196245076e-08 , 7.99241369616e-10 , 3.83487314743e-11 , 1.51247495438e-12 ,
 6.24540492669e-14 , 5.35971651734e-15 , 8.05752163445e-16 , 1.16293752449e-16 ,
 1.34904463913e-17 , 1.29252972353e-18 , 7.12066556752e-19 , 5.2321557463e-18  ,
 3.41879220639e-17 , 1.74291493885e-16 , 6.92750513241e-16 , 2.14734388564e-15 ,
 5.1930773511e-15  , 9.80455785443e-15 , 1.44767458721e-14 , 1.68714012465e-14 ,
 1.66064502988e-14 , 2.0628155005e-14  , 5.91053301323e-14 , 2.34433482549e-13 ,
 8.14250757542e-13 , 2.2743013682e-12  , 5.0393103767e-12  , 8.82120395683e-12 ,
 1.21693297874e-11 , 1.32063871031e-11 , 1.12628788511e-11 , 7.73739807367e-12 ,
 9.69578407153e-12 , 1.28735874251e-10 , 2.23190858479e-09 , 3.08318158097e-08 ,
 3.33994680808e-07 , 2.83228786158e-06 , 1.87972311709e-05 , 9.76939246474e-05 ,
 0.00039815406     , 0.00127582495115  , 0.00323260251888  , 0.0065664674422   ,
 0.0110747589579   , 0.0167973787932   , 0.025985874989    , 0.0442864417499   ,
 0.0791889089913   , 0.137932072601    , 0.229017115912    , 0.365192108738    ,
 0.559603064978    , 0.813895254647    , 1.11049591692     , 1.42107731574     ,
 1.72520931673     , 2.01649773303     , 2.28423720916     , 2.49232081092     ,
 2.58653474329     , 2.5275891139      , 2.31763439808     , 1.9982642589      ,
 1.62677439477     , 1.25314728529     , 0.912432350623    , 0.627024819952    ,
 0.407218415028    , 0.250785964222    , 0.14711849906     , 0.0830523368062   ,
 0.0459063984633   , 0.0250935110405   , 0.0137958002067   , 0.00922104221243  ,
 0.0109386022302   , 0.0184386209417   , 0.0289208892809   , 0.0369609475106   ,
 0.0375519019704   , 0.0301890870201   , 0.0191726864518   , 0.00960630937705  ,
 0.00379459280445  , 0.00119518478379  , 0.000365159009351 , 0.000130037010983 ,
 0.000228022206037 , 0.000470706827505 , 0.000790739334671 , 0.00105164614333  ,
 0.00110450459741  , 0.000914817056856 , 0.000596679341752 , 0.000306012920906 ,
 0.000123225692046 , 3.89083346345e-05 , 9.62151805677e-06 , 1.86145698664e-06 ,
 2.81506598429e-07 , 3.32531054238e-08 , 3.06635877244e-09 , 2.20622257142e-10 ,
 1.23806026402e-11 , 5.41712434128e-13 , 1.85058531669e-14 , 1.35194966871e-15 ,
 2.05886312919e-14 , 3.87622213342e-13 , 5.7573892676e-12  , 6.75134151474e-11 ,
 6.25700119939e-10 , 4.58698654722e-09 , 2.66254840296e-08 , 1.22720450909e-07 ,
 4.5465897956e-07  , 1.42263349626e-06 , 4.38835776524e-06 , 1.68117355612e-05 ,
 7.79391783949e-05 , 0.00034491236944  , 0.00127007151346  , 0.00372787980018  ,
 0.0086200915806   , 0.0156437949237   , 0.0222424088816   , 0.0247465845128   ,
 0.0215250005719   , 0.0146274602883   , 0.00776609250091  , 0.00324577473391  ,
 0.001201915566    , 0.000993574684472 , 0.00286802115715  , 0.00936860347425  ,
 0.0273033039152   , 0.070760387206    , 0.163068976354    , 0.330944228466    ,
 0.584347571248    , 0.892504419656    , 1.18847337558     , 1.41654992733     ,
 1.57506613587     , 1.69466446301     , 1.77819443215     , 1.78884910279     ,
 1.70107917486     , 1.53741699325     , 1.34512597814     , 1.15412816        ,
 0.968062168363    , 0.783822224298    , 0.60572089827     , 0.443233853126    ,
 0.305339596654    , 0.198454691768    , 0.124063060495    , 0.0768812019497   ,
 0.0477954107089   , 0.0290803839318   , 0.0166597244004   , 0.0090615069101   ,
 0.00592426953177  , 0.00752498631106  , 0.0144178303709   , 0.0257452814855   ,
 0.0372330127591   , 0.0424574425586   , 0.0379613581823   , 0.0265842526845   ,
 0.0145855581233   , 0.0062748836122   , 0.00211921397499  , 0.000562619296    ,
 0.000117584781706 , 1.93735547965e-05 , 2.51978625964e-06 , 2.58991194365e-07 ,
 2.10518946526e-08 , 1.35367551137e-09 , 6.88505981391e-11 , 2.76956739793e-12 ,
 8.83809100174e-14 , 2.31530908754e-15 , 5.62420661019e-17 , 3.04832219511e-18 ,
 3.50340904922e-19 , 3.2844026005e-20  , 1.50470580677e-20 , 1.0758562436e-19  ,
 7.0285952887e-19  , 3.58320493986e-18 , 1.42420438952e-17 , 4.41465956612e-17 ,
 1.06763361781e-16 , 2.01578830359e-16 , 2.97774378026e-16 , 3.48631277673e-16 ,
 3.57718078369e-16 , 5.41875181469e-16 , 1.88651717993e-15 , 7.84504565113e-15 ,
 2.75264367391e-14 , 7.72164244608e-14 , 1.71952678653e-13 , 3.04522289294e-13 ,
 4.33780891098e-13 , 5.14282517543e-13 , 5.61775715642e-13 , 9.34070954881e-13 ,
 6.88188100891e-12 , 9.58521685909e-11 , 1.28989957933e-09 , 1.52283869684e-08 ,
 1.513785988e-07   , 1.22815503765e-06 , 7.9745791884e-06  , 4.101898322e-05   ,
 0.000166456516774 , 0.000533056689798 , 0.00135457460544  , 0.0027776187453   ,
 0.00480846717787  , 0.00779167250317  , 0.0136917383121   , 0.0275205878784   ,
 0.057926002611    , 0.116787568276    , 0.217565994138    , 0.370284283678    ,
 0.572189510073    , 0.799686408158    , 1.01089328917     , 1.16317271466     ,
 1.2386735427      , 1.25716322042     , 1.25768806587     , 1.26249806493     ,
 1.25985417576     , 1.21952131286     , 1.12006693706     , 0.96380235921     ,
 0.773275020794    , 0.578164714169    , 0.404119047954    , 0.266858317899    ,
 0.169577264395    , 0.105102407948    , 0.0630865047172   , 0.0359600674911   ,
 0.0193202196569   , 0.00998267404896  , 0.00552822408929  , 0.00489430491495  ,
 0.00825276531242  , 0.0156523715174   , 0.0251223038476   , 0.0322411048662   ,
 0.0327839315591   , 0.0263613293125   , 0.0167427909998   , 0.0083887655909   ,
 0.00331186293632  , 0.0010334394438   , 0.00027475600037  , 5.26128687507e-05 ,
 5.8532079528e-05  , 0.000114693810228 , 0.000192087338126 , 0.000255424550499 ,
 0.000268260441694 , 0.000222189306686 , 0.000144920522558 , 7.43239278243e-05 ,
 2.99288585745e-05 , 9.44999392977e-06 , 2.33685886498e-06 , 4.52107679431e-07 ,
 6.83718676141e-08 , 8.07645979933e-09 , 7.44752021652e-10 , 5.35843202942e-11 ,
 3.00696910462e-12 , 1.31567875542e-13 , 4.49067283937e-15 , 2.19808718631e-16 ,
 2.4080459628e-15  , 4.53220608387e-14 , 6.73227191768e-13 , 7.89518173989e-12 ,
 7.31899651382e-11 , 5.37136704628e-10 , 3.13223119247e-09 , 1.47172741226e-08 ,
 5.88321788134e-08 , 2.35565441112e-07 , 1.18172430959e-06 , 7.07138794552e-06 ,
 3.99053865203e-05 , 0.000186815017545 , 0.00069740337516  , 0.00205353657353  ,
 0.00475193254241  , 0.00862530738342  , 0.0122641531974   , 0.0136458816018   ,
 0.0118723631693   , 0.00807595771563  , 0.00430506552785  , 0.00182875143661  ,
 0.000717997129063 , 0.000644903223629 , 0.00194780306925  , 0.00691127523396  ,
 0.0221451219627   , 0.0625189232132   , 0.153879399464    , 0.32570863774     ,
 0.58532164664     , 0.887440499797    , 1.141166378       , 1.27239931512     ,
 1.28261736035     , 1.23004053467     , 1.15834725211     , 1.06658787508     ,
 0.94349673534     , 0.800656770858    , 0.662309161429    , 0.540492526554    ,
 0.432046907133    , 0.332624549984    , 0.244272695212    , 0.171234623156    ,
 0.115054008547    , 0.0745959830486   , 0.0473255928269   , 0.0297639077643   ,
 0.0184156226898   , 0.0109269391548   , 0.00621986557768  , 0.00388919841636  ,
 0.00391186873377  , 0.00687091531255  , 0.0137874574552   , 0.0245136538802   ,
 0.0356545017261   , 0.0413561413893   , 0.0379278359745   , 0.027434420413    ,
 0.0156496904362   , 0.00704559475869  , 0.00250581523782  , 0.000704623347789 ,
 0.000156730764816 , 2.7578112928e-05  , 3.83717300742e-06 , 4.21827374658e-07 ,
 3.65956501969e-08 , 2.50204386518e-09 , 1.34612885662e-10 , 5.69065909821e-12 ,
 1.88768670002e-13 , 4.90882145924e-15 , 9.32175054556e-17 , 6.25158992641e-20 ,
 7.17217608622e-21 , 6.48253311954e-22 , 4.59505490923e-23 , 2.54894251283e-24 ,
 1.10562926338e-25 , 5.1434601911e-27  , 5.39781287828e-26 , 1.62540498821e-24 ,
 3.84792576487e-23 , 7.16023514018e-22 , 1.04890937625e-20 , 1.21246359828e-19 ,
 1.11016200016e-18 , 8.1220422796e-18  , 4.85670024296e-17 , 2.51001755971e-16 ,
 1.24223232228e-15 , 6.42652896319e-15 , 3.35362431747e-14 , 1.57738321837e-13 ,
 6.16150960911e-13 , 1.93089173513e-12 , 4.88925208767e-12 , 1.17093823955e-11 ,
 4.91894284759e-11 , 4.09606679269e-10 , 3.53269827471e-09 , 2.57457627399e-08 ,
 1.5870303266e-07  , 8.54008867991e-07 , 4.09765344157e-06 , 1.74212334708e-05 ,
 6.38833986107e-05 , 0.00019659250076  , 0.000501121503114 , 0.00106983749445  ,
 0.00201753297479  , 0.0037863013429   , 0.00809776235532  , 0.0197381506072   ,
 0.0487424181954   , 0.11119137596     , 0.225049532127    , 0.39837394567     ,
 0.614740891235    , 0.829071555332    , 0.982508214476    , 1.03044249448     ,
 0.968909662473    , 0.841167715156    , 0.712207449763    , 0.626773466008    ,
 0.587146245045    , 0.565244401738    , 0.529837694391    , 0.465660386623    ,
 0.376942897222    , 0.279830757545    , 0.191881351781    , 0.124283202983    ,
 0.078734112516    , 0.0497691867498   , 0.0306468661946   , 0.0174907924324   ,
 0.00896553203122  , 0.00423183803261  , 0.00229958388067  , 0.00261394007267  ,
 0.00533218266099  , 0.0105724907011   , 0.0170985181309   , 0.0219714893546   ,
 0.0223463792969   , 0.0179693656459   , 0.0114129528484   , 0.00571827724349  ,
 0.00225713662834  , 0.000701998406161 , 0.00017669722839  , 2.11765609392e-05 ,
 1.28275472431e-05 , 2.20589612947e-05 , 3.66340383531e-05 , 4.86908518601e-05 ,
 5.1136443563e-05  , 4.23541978637e-05 , 2.76250560763e-05 , 1.41677840386e-05 ,
 5.7051022072e-06  , 1.80137779321e-06 , 4.45456970017e-07 , 8.61817201377e-08 ,
 1.30331896737e-08 , 1.53955179532e-09 , 1.4196619751e-10  , 1.02143553301e-11 ,
 5.73194666706e-13 , 2.50797229437e-14 , 8.55692480128e-16 , 3.19304839538e-17 ,
 2.20484878374e-16 , 4.14537462766e-15 , 6.15818123091e-14 , 7.22409040295e-13 ,
 6.70494797548e-12 , 4.94592578672e-11 , 2.94630333992e-10 , 1.50500345506e-09 ,
 7.83402326928e-09 , 5.15033098065e-08 , 3.97472205925e-07 , 2.85665454344e-06 ,
 1.69777732297e-05 , 8.04906422319e-05 , 0.000301368990082 , 0.000888001114629 ,
 0.00205520461432  , 0.0037307638651   , 0.00530579637602  , 0.00590809540402  ,
 0.00515571696836  , 0.00354946746237  , 0.00198504042082  , 0.00100908263246  ,
 0.000649799559081 , 0.000858682003747 , 0.0022479785844   , 0.0072776775363   ,
 0.0226194475168   , 0.063145132927    , 0.154814866921    , 0.326815343367    ,
 0.583211415162    , 0.869720030941    , 1.08328247197     , 1.14346744156     ,
 1.05855563467     , 0.90616452561     , 0.755237528449    , 0.625158672447    ,
 0.509026590484    , 0.4053526073      , 0.319267178024    , 0.250328254343    ,
 0.191936557304    , 0.139890734398    , 0.0956952398597   , 0.0621701782404   ,
 0.0393667005859   , 0.0248989535976   , 0.0159410454448   , 0.0102784024987   ,
 0.00655074707796  , 0.00420327105657  , 0.0031758243914   , 0.00350284205204  ,
 0.00518358028435  , 0.0085075562117   , 0.0143223911781   , 0.0230859107326   ,
 0.0328333641171   , 0.0388711360268   , 0.0371930914898   , 0.0284011615968   ,
 0.0172195948692   , 0.00827040040231  , 0.00314214153534  , 0.000943092438469 ,
 0.000223309336513 , 4.16520710781e-05 , 6.11058706459e-06 , 7.0405195956e-07  ,
 6.36218522602e-08 , 4.50354143076e-09 , 2.49450340485e-10 , 1.08019377401e-11 ,
 3.65407882937e-13 , 9.65031309458e-15 , 1.93896455709e-16 , 1.49218892884e-23 ,
 5.01591196914e-25 , 1.33430249775e-26 , 2.75670490523e-28 , 0,
 5.36533974888e-31 , 2.84329669129e-29 , 1.09445077408e-27 , 3.30169037565e-26 ,
 7.81631357011e-25 , 1.81579480995e-23 , 3.88639101248e-22 , 9.06694214264e-21 ,
 2.16139137459e-19 , 4.58826156841e-18 , 7.97831187691e-17 , 1.09980181859e-15 ,
 1.18903445823e-14 , 1.00507379449e-13 , 6.63857610453e-13 , 3.42744048751e-12 ,
 1.38428366191e-11 , 4.38061698743e-11 , 1.0938824656e-10  , 2.27360565331e-10 ,
 5.5148110048e-10  , 2.89538200099e-09 , 2.18838290505e-08 , 1.45234919322e-07 ,
 7.69921789973e-07 , 3.24560322872e-06 , 1.1027247293e-05  , 3.11075225979e-05 ,
 7.69419333028e-05 , 0.000179727157012 , 0.000416908232008 , 0.000946131659052 ,
 0.00201474112577  , 0.00404406941478  , 0.0082889645277   , 0.0188695320053   ,
 0.0460965029743   , 0.108234790915    , 0.225883525414    , 0.40561167351     ,
 0.621654035198    , 0.815368319477    , 0.92120005716     , 0.902526155561    ,
 0.772800326991    , 0.589176914615    , 0.420565345891    , 0.310227928513    ,
 0.260640800599    , 0.246825985632    , 0.23944980619     , 0.220160254304    ,
 0.18544601777     , 0.142253758677    , 0.100381873218    , 0.0666022586019   ,
 0.042694961142    , 0.0267741685146   , 0.016057033026    , 0.00878635830684  ,
 0.00422390411873  , 0.00181728765188  , 0.000946537707464 , 0.00124861762941  ,
 0.00277797059908  , 0.00560391089409  , 0.00908852564154  , 0.0116839516807   ,
 0.0118841803943   , 0.00955653222512  , 0.00606969180497  , 0.00304111240274  ,
 0.00120031744736  , 0.000372875793943 , 9.19715183723e-05 , 7.77459572937e-06 ,
 2.60734282339e-06 , 3.37690095454e-06 , 5.48107065795e-06 , 7.27564020903e-06 ,
 7.64054480729e-06 , 6.32832344176e-06 , 4.12757801664e-06 , 2.11686930836e-06 ,
 8.52423761124e-07 , 2.69151573072e-07 , 6.6557634195e-08  , 1.28767799997e-08 ,
 1.94734470123e-09 , 2.30031028698e-10 , 2.12117776557e-11 , 1.52617057152e-12 ,
 8.56434683956e-14 , 3.74726798366e-15 , 1.27829126906e-16 , 4.05446556488e-18 ,
 1.57978231214e-17 , 2.96332415561e-16 , 4.40365830395e-15 , 5.17314145564e-14 ,
 4.82878837104e-13 , 3.64757571162e-12 , 2.38293314576e-11 , 1.61629381112e-10 ,
 1.39445311682e-09 , 1.3872836839e-08  , 1.26859551188e-07 , 9.5598614494e-07  ,
 5.74767762772e-06 , 2.73234427395e-05 , 0.000102369022285 , 0.000301697681389 ,
 0.00069841786897  , 0.00126872552765  , 0.00180897371815  , 0.00203363657988  ,
 0.00183962652572  , 0.0014415358074   , 0.0011811023045   , 0.00122640669339  ,
 0.00152866399597  , 0.0021973871673   , 0.00426325331194  , 0.0108454298956   ,
 0.0290516916062   , 0.0730006773902   , 0.165885087829    , 0.332292565797    ,
 0.571294189514    , 0.825667611625    , 0.994013867685    , 1.00230651995     ,
 0.86697671311     , 0.673596042733    , 0.499570020599    , 0.370871133935    ,
 0.279023700497    , 0.2117866518      , 0.162239729409    , 0.124349816189    ,
 0.0921826292071   , 0.0633974735208   , 0.0396406167424   , 0.0229473142784   ,
 0.0130597809388   , 0.00793573862261  , 0.00541991162459  , 0.00410251247682  ,
 0.00337411304351  , 0.00327240348076  , 0.00423069662936  , 0.00657381551895  ,
 0.0100255366142   , 0.0140074445369   , 0.0187196136196   , 0.0252209802297   ,
 0.0332746506332   , 0.0394590282525   , 0.0392400575807   , 0.0315629759932   ,
 0.0202093058413   , 0.0102271764927   , 0.00407580382463  , 0.00127626960965  ,
 0.000313488513509 , 6.03213110444e-05 , 9.08256672329e-06 , 1.0691399438e-06  ,
 9.83145123424e-08 , 7.0580856134e-09  , 3.9538739267e-10  , 1.72762191484e-11 ,
 5.88604515291e-13 , 1.56327379933e-14 , 3.20572736235e-16 , 3.12100943758e-25 ,
 1.03398673232e-26 , 2.75132880421e-28 , 5.689375756e-30   , 0, 0, 0, 0, 0, 0,
 6.45289512202e-23 , 3.13550183132e-21 , 1.179393864e-19   , 3.45722159115e-18 ,
 7.89936592025e-17 , 1.40719838684e-15 , 1.95498928121e-14 , 2.11894555503e-13 ,
 1.79259217852e-12 , 1.18434084997e-11 , 6.11516988694e-11 , 2.46973517228e-10 ,
 7.81117766671e-10 , 1.94027478406e-09 , 3.85034804495e-09 , 6.94823510926e-09 ,
 1.99681894528e-08 , 1.18288087093e-07 , 7.54890697213e-07 , 3.95494122499e-06 ,
 1.63970946951e-05 , 5.38779111926e-05 , 0.000142269727075 , 0.000312842117818 ,
 0.000618698289514 , 0.00122673887929  , 0.00255102209666  , 0.00518200248849  ,
 0.0094728155698   , 0.0155657736492   , 0.0255192737132   , 0.0477778034832   ,
 0.100015000851    , 0.203073222143    , 0.362771287469    , 0.550716655176    ,
 0.706678950901    , 0.77024091723     , 0.717855312288    , 0.575341212123    ,
 0.400302008378    , 0.249761010876    , 0.153966926142    , 0.111362412497    ,
 0.102076708639    , 0.104447633396    , 0.104284741725    , 0.0966174444252   ,
 0.082668416067    , 0.0654683321965   , 0.0476416942844   , 0.0314541326562   ,
 0.0186931334882   , 0.00998007354329  , 0.00476433141708  , 0.00201149446164  ,
 0.000764547805729 , 0.000362697970714 , 0.000496919244774 , 0.00114296446648  ,
 0.0023212579584   , 0.00376881772638  , 0.00484593146951  , 0.00492911204579  ,
 0.00396370841049  , 0.00251749320688  , 0.00126134420715  , 0.000497836678316 ,
 0.000154586823942 , 3.78499801904e-05 , 2.39687461701e-06 , 5.27841825083e-07 ,
 4.2115328566e-07  , 6.43568912664e-07 , 8.51274279478e-07 , 8.93798874257e-07 ,
 7.40286334411e-07 , 4.82843203738e-07 , 2.47630917423e-07 , 9.97163487704e-08 ,
 3.1485293575e-08  , 7.78589807747e-09 , 1.50632317552e-09 , 2.27800077248e-10 ,
 2.69090258311e-11 , 2.481363617e-12   , 1.78534682729e-13 , 1.00192481882e-14 ,
 4.38459662799e-16 , 1.49645361987e-17 , 4.35252492919e-19 , 8.86338025005e-19 ,
 1.65440544512e-17 , 2.46249147603e-16 , 2.91221729383e-15 , 2.79161072787e-14 ,
 2.33625187923e-13 , 2.07145528839e-12 , 2.34947183317e-11 , 3.01283753064e-10 ,
 3.50333306532e-09 , 3.34430670436e-08 , 2.54676225356e-07 , 1.53502258737e-06 ,
 7.30216405675e-06 , 2.73700305482e-05 , 8.07418747323e-05 , 0.000187473390957 ,
 0.000343930625726 , 0.000507037012907 , 0.000636945299494 , 0.000792916877393 ,
 0.0011721404893   , 0.00197649805368  , 0.00317446777852  , 0.00449342189185  ,
 0.00602596247282  , 0.00938877497285  , 0.0188397930319   , 0.0420663160644   ,
 0.0912718121308   , 0.183881034111    , 0.336200026435    , 0.541781847513    ,
 0.747362676027    , 0.866099759095    , 0.840161786679    , 0.692336737793    ,
 0.503745048179    , 0.345411046763    , 0.240136906736    , 0.176227759681    ,
 0.135562601035    , 0.106036284234    , 0.0810451235806   , 0.0577875123427   ,
 0.0368985227496   , 0.0207295842474   , 0.01061945251     , 0.00579381253443  ,
 0.00432905899548  , 0.00443734487258  , 0.00497931879169  , 0.00550957164732  ,
 0.00635705160551  , 0.00851856068199  , 0.0127740738152   , 0.0184549022776   ,
 0.0236547836601   , 0.0274705473818   , 0.0314153133349   , 0.037049567757    ,
 0.0423329135814   , 0.0424223818891   , 0.034957505034    , 0.0229995411212   ,
 0.0119367725289   , 0.00486219037993  , 0.00155060265049  , 0.000386631556239 ,
 7.53060338239e-05 , 1.14501684499e-05 , 1.35838928463e-06 , 1.25688368443e-07 ,
 9.06752785579e-09 , 5.0991606819e-10  , 2.23480746708e-11 , 7.63214924184e-13 ,
 2.03079749784e-14 , 4.19212913361e-16 , 2.99942626117e-28 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 8.9831693235e-22  , 4.3649777863e-20  , 1.64185138284e-18 ,
 4.81284855169e-17 , 1.0996822398e-15  , 1.95898137839e-14 , 2.72156906422e-13 ,
 2.94981498199e-12 , 2.4954936913e-11  , 1.64873778151e-10 , 8.51299879792e-10 ,
 3.43808525456e-09 , 1.08720217437e-08 , 2.69641754231e-08 , 5.27645583558e-08 ,
 8.50101749653e-08 , 1.49696964455e-07 , 5.47616694216e-07 , 3.13023802319e-06 ,
 1.61678095799e-05 , 6.68304687875e-05 , 0.000218624556148 , 0.00057047180766  ,
 0.00121591908527  , 0.00224071606061  , 0.00395255753794  , 0.00728164163971  ,
 0.0135948357443   , 0.0232354513718   , 0.0342100195451   , 0.0444322959601   ,
 0.0581400189865   , 0.0903774565194   , 0.160916828679    , 0.276238417548    ,
 0.412321561981    , 0.518831414165    , 0.549237346825    , 0.491985230437    ,
 0.375061754935    , 0.244703848145    , 0.139151513542    , 0.0744275688948   ,
 0.0462720115819   , 0.0412128369596   , 0.0464568747577   , 0.0539848851215   ,
 0.0599747993446   , 0.0620888891883   , 0.0579574694183   , 0.0469098718932   ,
 0.0319624740553   , 0.0180916966645   , 0.008523770789    , 0.00338732393971  ,
 0.0011577270425   , 0.00035383438838  , 0.00013207032578  , 0.000160588745646 ,
 0.000368682528723 , 0.00075025711682  , 0.00121863623775  , 0.0015670275572   ,
 0.00159394324163  , 0.0012817596812   , 0.000814091690596 , 0.000407885661923 ,
 0.000160985952793 , 4.99813478057e-05 , 1.22052332672e-05 , 5.93490523433e-07 ,
 1.04353991211e-07 , 4.51056436787e-08 , 5.948593916e-08   , 7.79307750294e-08 ,
 8.17808579061e-08 , 6.77328698855e-08 , 4.41779219228e-08 , 2.26570923871e-08 ,
 9.12360096216e-09 , 2.88077740476e-09 , 7.12389595146e-10 , 1.37832127526e-10 ,
 2.08480886219e-11 , 2.46425049512e-12 , 2.27730171877e-13 , 1.65079206607e-14 ,
 9.50227235657e-16 , 4.51943553216e-17 , 1.96976349593e-18 , 9.35156937212e-20 ,
 4.30130982855e-20 , 7.21169607132e-19 , 1.08144005317e-17 , 1.31990017327e-16 ,
 1.41855400329e-15 , 1.65090421235e-14 , 2.4668106542e-13  , 4.07813024431e-12 ,
 6.02881240846e-11 , 7.28654499717e-10 , 7.02212917419e-09 , 5.36076998386e-08 ,
 3.23507785988e-07 , 1.54211066956e-06 , 5.81186781137e-06 , 1.74156478012e-05 ,
 4.23246671787e-05 , 8.83920890662e-05 , 0.000180041991957 , 0.000409735890446 ,
 0.001016220304    , 0.00238477934303  , 0.00480203346437  , 0.00802175749242  ,
 0.0112635855429   , 0.0144012827819   , 0.0198933240459   , 0.0335777694699   ,
 0.0633650751478   , 0.117723626315    , 0.205713623351    , 0.333940085859    ,
 0.492550112141    , 0.638912135006    , 0.709139064648    , 0.665561837211    ,
 0.533072498632    , 0.378403105979    , 0.256536788495    , 0.182394264476    ,
 0.142539220478    , 0.118228808717    , 0.0971564627157   , 0.074544175868    ,
 0.0511098316065   , 0.0304381132033   , 0.0158315534559   , 0.008166791138    ,
 0.00603847242754  , 0.00718857749135  , 0.00957412841374  , 0.0117161293613   ,
 0.0129137358891   , 0.0136870123299   , 0.015822165666    , 0.0209281327213   ,
 0.0281817515567   , 0.0342910241725   , 0.0369439087651   , 0.0376991974265   ,
 0.0396517676795   , 0.0423910595982   , 0.0415753769885   , 0.0342596083255   ,
 0.0226990568644   , 0.0118778205504   , 0.00487451554907  , 0.00156435667391  ,
 0.000392066207135 , 7.66787926565e-05 , 1.16969599127e-05 , 1.39124336234e-06 ,
 1.28989206054e-07 , 9.32046112383e-09 , 5.24792894086e-10 , 2.30224968373e-11 ,
 7.86846175427e-13 , 2.09492228054e-14 , 4.33361250056e-16 , 7.51758021646e-30 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 9.76165847863e-21 , 4.74325050349e-19 ,
 1.78413563128e-17 , 5.22993413338e-16 , 1.1949816455e-14  , 2.12874838413e-13 ,
 2.95742257261e-12 , 3.20544847729e-11 , 2.71175531405e-10 , 1.79161869278e-09 ,
 9.2507367544e-09  , 3.73601071863e-08 , 1.1813554424e-07  , 2.92860778533e-07 ,
 5.70711937487e-07 , 8.86520236888e-07 , 1.21882402281e-06 , 2.45612641701e-06 ,
 1.05574385493e-05 , 5.21299981132e-05 , 0.000214256658138 , 0.000699200775797 ,
 0.00181326638891  , 0.00379602763477  , 0.00667841138258  , 0.0107346033102   ,
 0.0175160715513   , 0.0297009764845   , 0.0479260398941   , 0.0671638903988   ,
 0.0792222754408   , 0.0825238505023   , 0.0891788525675   , 0.11858577931     ,
 0.179753765491    , 0.257260648501    , 0.316251965669    , 0.326171523625    ,
 0.282455406439    , 0.206550344956    , 0.128209241727    , 0.0683313486431   ,
 0.0331921202638   , 0.0186030820398   , 0.0172235416732   , 0.0234697996738   ,
 0.0343761675666   , 0.047438840226    , 0.0580284685619   , 0.0601647133456   ,
 0.0512843375533   , 0.0353312673189   , 0.0195321267981   , 0.0086630875635   ,
 0.00309994029389  , 0.000905544937371 , 0.000221911220263 , 5.58022336569e-05 ,
 4.33474605467e-05 , 9.31487551492e-05 , 0.000189098201966 , 0.000307161927833 ,
 0.000394984597225 , 0.000401770722287 , 0.000323081689075 , 0.000205200825311 ,
 0.000102812081293 , 4.05781597013e-05 , 1.25976239334e-05 , 3.07332781077e-06 ,
 1.15824610994e-07 , 1.84562855944e-08 , 4.51415198775e-09 , 4.37157145372e-09 ,
 5.58076308514e-09 , 5.84810587417e-09 , 4.84326799416e-09 , 3.159157998e-09   ,
 1.62056209745e-09 , 6.53050307116e-10 , 2.06709238444e-10 , 5.15424525678e-11 ,
 1.02519574316e-11 , 1.69508725866e-12 , 2.58847885469e-13 , 4.24690273476e-14 ,
 7.67397416501e-15 , 1.32711137938e-15 , 1.94002154518e-16 , 2.27085194652e-17 ,
 2.09005547802e-18 , 1.51678248197e-19 , 3.29525402327e-20 , 3.81952475111e-19 ,
 5.3342763492e-18  , 8.18865581091e-17 , 1.61549211034e-15 , 3.4444988923e-14  ,
 6.47574386528e-13 , 9.91055698298e-12 , 1.20877040519e-10 , 1.16957539916e-09 ,
 8.98035533231e-09 , 5.49598688392e-08 , 2.71697529918e-07 , 1.12324572605e-06 ,
 4.17986741705e-06 , 1.54890959334e-05 , 5.97138267281e-05 , 0.000225107896635 ,
 0.000760380699209 , 0.00218460608     , 0.00522044189947  , 0.0102879941781   ,
 0.0167373762786   , 0.0229670134065   , 0.0285987430344   , 0.0374160020001   ,
 0.0572366013989   , 0.0953401166347   , 0.154225901008    , 0.23287234037     ,
 0.329246522433    , 0.434028225684    , 0.51969202904     , 0.547441903482    ,
 0.498236385694    , 0.394839645396    , 0.284779422622    , 0.203481765706    ,
 0.157282321624    , 0.133590801419    , 0.117214806532    , 0.0986186201728   ,
 0.075311766188    , 0.0503357727417   , 0.0289844884439   , 0.0151377370666   ,
 0.00953157189566  , 0.0104513019078   , 0.0151506257509   , 0.0207584760547   ,
 0.0248530763584   , 0.0261466872897   , 0.0253200745708   , 0.0251426415369   ,
 0.0284535877992   , 0.0348783828468   , 0.0403544158378   , 0.0413362034231   ,
 0.0388745246445   , 0.036793907051    , 0.036210737326    , 0.0341010224323   ,
 0.0277124521214   , 0.0183094336279   , 0.0095891166463   , 0.0039423170584   ,
 0.00126748062052  , 0.000318159626859 , 6.23043041649e-05 , 9.5139627114e-06  ,
 1.13251524315e-06 , 1.05068260759e-07 , 7.59578901417e-09 , 4.27851907059e-10 ,
 1.87754692504e-11 , 6.41847678123e-13 , 1.70919271059e-14 , 3.53801166324e-16 ,
 1.22833329954e-31 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 8.2849764873e-20  ,
 4.02572154935e-18 , 1.51424287048e-16 , 4.43878275603e-15 , 1.01421237563e-13 ,
 1.80672478437e-12 , 2.51004237966e-11 , 2.72054849325e-10 , 2.30153811111e-09 ,
 1.5205939122e-08  , 7.85134232078e-08 , 3.17084515646e-07 , 1.0026313415e-06  ,
 2.4852163636e-06  , 4.83714563934e-06 , 7.43116909217e-06 , 9.32649069519e-06 ,
 1.21223950786e-05 , 3.10398779278e-05 , 0.000133970141263 , 0.000541012372412 ,
 0.00176033384927  , 0.00454758866074  , 0.00941224838558  , 0.0160469505955   ,
 0.0240216493536   , 0.0350294879754   , 0.0533360389682   , 0.0806033110189   ,
 0.109059684744    , 0.12401871135     , 0.117851427067    , 0.100436615979    ,
 0.092206757819    , 0.105934854827    , 0.135091991895    , 0.158952981571    ,
 0.15934786014     , 0.133808043753    , 0.0943145394488   , 0.0561035166585   ,
 0.0284627814118   , 0.0130751569968   , 0.00737551874785  , 0.00850726807033  ,
 0.0153248775171   , 0.0277179590543   , 0.0437937571975   , 0.0576460779995   ,
 0.0616915947375   , 0.052958929018    , 0.0362161038098   , 0.0196698857943   ,
 0.0084802673085   , 0.00290626346943  , 0.000794510727964 , 0.000174748332324 ,
 3.30692571135e-05 , 1.14602593118e-05 , 1.86037755575e-05 , 3.71693398449e-05 ,
 6.03391714354e-05 , 7.75899069806e-05 , 7.89230223573e-05 , 6.34655252415e-05 ,
 4.03092441561e-05 , 2.01962006899e-05 , 7.97108399552e-06 , 2.47460047933e-06 ,
 6.0349515024e-07  , 1.76866629315e-08 , 2.71137908241e-09 , 4.49136175151e-10 ,
 2.62272841021e-10 , 3.1336634516e-10  , 3.28144588075e-10 , 2.74555066919e-10 ,
 1.85215233069e-10 , 1.05443134829e-10 , 5.65172332592e-11 , 3.27613063523e-11 ,
 2.05713657974e-11 , 1.21803852365e-11 , 6.07762959778e-12 , 2.43376450153e-12 ,
 7.68903062376e-13 , 1.90515733561e-13 , 3.69336626467e-14 , 5.59525255826e-15 ,
 6.61890424265e-16 , 6.11047899336e-17 , 4.40047755791e-18 , 2.47764902499e-19 ,
 2.27676117519e-20 , 2.53283700937e-19 , 6.60191574906e-18 , 1.81607774524e-16 ,
 4.34870436865e-15 , 8.44905790481e-14 , 1.31073900111e-12 , 1.62739948551e-11 ,
 1.64027844409e-10 , 1.38864544645e-09 , 1.05288438572e-08 , 7.72425882081e-08 ,
 5.62630006476e-07 , 3.8564465428e-06  , 2.31172754815e-05 , 0.000115766658556 ,
 0.000475445062133 , 0.00159557304748  , 0.00438682967168  , 0.00992199297702  ,
 0.0185388945519   , 0.028836562291    , 0.0382957050549   , 0.0467464320501   ,
 0.0600506212682   , 0.0881515596558   , 0.136467541837    , 0.199615321216    ,
 0.266187238204    , 0.328282388844    , 0.381029067851    , 0.41308382772     ,
 0.407425062217    , 0.358814631042    , 0.285424438259    , 0.216041542792    ,
 0.167959007674    , 0.140403444605    , 0.123724147643    , 0.108787664793    ,
 0.0903372728993   , 0.0677091942118   , 0.0443632267508   , 0.0253914471237   ,
 0.0144254357106   , 0.012312934432    , 0.0175519571379   , 0.0269861485173   ,
 0.0365284908617   , 0.0424486459595   , 0.0428522067611   , 0.0387307948727   ,
 0.0338852560315   , 0.0324817833996   , 0.0351700014728   , 0.0381574103112   ,
 0.0373745729296   , 0.0329765248382   , 0.0283741448023   , 0.0254543457734   ,
 0.0226798308936   , 0.0180007900044   , 0.011795112211    , 0.00616261615414  ,
 0.00253261762652  , 0.00081443826192  , 0.000204513272891 , 4.0063506354e-05  ,
 6.11961286573e-06 , 7.28640685895e-07 , 6.7612328605e-08  , 4.88870903137e-09 ,
 2.75402101578e-10 , 1.2086640137e-11  , 4.13217626249e-13 , 1.10043126388e-14 ,
 2.27834506685e-16 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5.49595826264e-19 ,
 2.67052026595e-17 , 1.0044947778e-15  , 2.94453035581e-14 , 6.72792360298e-13 ,
 1.19851686027e-11 , 1.66507269842e-10 , 1.80471495523e-09 , 1.5267583943e-08  ,
 1.00870782684e-07 , 5.20830051955e-07 , 2.10342464676e-06 , 6.651067543e-06   ,
 1.64853141091e-05 , 3.2074883438e-05  , 4.9113363745e-05  , 5.98712356295e-05 ,
 6.32959629125e-05 , 9.0950220515e-05  , 0.000283107215123 , 0.00108133504591  ,
 0.00349371683509  , 0.00900003534085  , 0.0184936467229   , 0.0308794152512   ,
 0.0438972661035   , 0.0581653785712   , 0.0792014401573   , 0.11081244853     ,
 0.144768925626    , 0.162232973937    , 0.150677958244    , 0.117593608303    ,
 0.0840305141824   , 0.0660852008346   , 0.0641313987291   , 0.0670761308108   ,
 0.0639770499498   , 0.051939098853    , 0.0353710502219   , 0.0202652575835   ,
 0.00994545135102  , 0.00469508417044  , 0.00356072453186  , 0.00613592505686  ,
 0.0132016344521   , 0.0255999435841   , 0.0415228419175   , 0.054860356874    ,
 0.0582310672247   , 0.0492795948538   , 0.0331139924776   , 0.0176315171389   ,
 0.00743281915876  , 0.00248111145179  , 0.000656380685088 , 0.000137924131326 ,
 2.33696313503e-05 , 4.14327379808e-06 , 3.09454652067e-06 , 5.7095230047e-06  ,
 9.23720361384e-06 , 1.18765102108e-05 , 1.20805104223e-05 , 9.71447679275e-06 ,
 6.17001465293e-06 , 3.09137157538e-06 , 1.22010930661e-06 , 3.78776760892e-07 ,
 9.23627612365e-08 , 2.10744576393e-09 , 3.18473392015e-10 , 4.34711986545e-11 ,
 1.5895563129e-11  , 2.38527339471e-11 , 4.87700317014e-11 , 1.05508555265e-10 ,
 2.08926468003e-10 , 3.45587808563e-10 , 4.59790734592e-10 , 4.85395288209e-10 ,
 4.04454947297e-10 , 2.65291413362e-10 , 1.36728201718e-10 , 5.52871140061e-11 ,
 1.75169974698e-11 , 4.34391738908e-12 , 8.42322352489e-13 , 1.27616260375e-13 ,
 1.50966680174e-14 , 1.39371086726e-15 , 1.00367821391e-16 , 5.63635639084e-18 ,
 2.47191626417e-19 , 2.53583297387e-20 , 6.01830065022e-19 , 1.82992626212e-17 ,
 4.60876113798e-16 , 9.50529510271e-15 , 1.65514357405e-13 , 2.61681026544e-12 ,
 4.01796527759e-11 , 6.02237168524e-10 , 8.27909592841e-09 , 9.74583314582e-08 ,
 9.42262165135e-07 , 7.34158068065e-06 , 4.57787096069e-05 , 0.000228211464312 ,
 0.000911565295102 , 0.00293105924787  , 0.00763645756898  , 0.0162499301791   ,
 0.0285093962435   , 0.0418319454089   , 0.0530753757504   , 0.0632738090081   ,
 0.0810684240471   , 0.118015114959    , 0.176317890873    , 0.242140922444    ,
 0.295401043463    , 0.32589002003     , 0.335637538448    , 0.327506566849    ,
 0.300022588253    , 0.255884928605    , 0.207659187369    , 0.16885767306     ,
 0.142796430582    , 0.124027784594    , 0.106955123389    , 0.0892886664565   ,
 0.0703839359193   , 0.0506647504868   , 0.0323593031823   , 0.0187806073383   ,
 0.0125958196477   , 0.0148612808814   , 0.0246276390082   , 0.0384873890918   ,
 0.0511591320925   , 0.0577929862343   , 0.0563159362551   , 0.0483119367396   ,
 0.0383670524637   , 0.0314721282224   , 0.0292997864695   , 0.0291004105349   ,
 0.0271288918006   , 0.0226806406544   , 0.01793206968     , 0.0145847710886   ,
 0.012123573287    , 0.00930652605027  , 0.00601933267194  , 0.00313054460073  ,
 0.0012846187637   , 0.00041293327247  , 0.000103685000645 , 2.03124982947e-05 ,
 3.10290680215e-06 , 3.69476905808e-07 , 3.42866020545e-08 , 2.47920660523e-09 ,
 1.39669517659e-10 , 6.1298860541e-12  , 2.09573052953e-13 , 5.58119454577e-15 ,
 1.15560844845e-16 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.85203123336e-18 ,
 1.38581969582e-16 , 5.21264962927e-15 , 1.52801243041e-13 , 3.4913380587e-12  ,
 6.2194932273e-11  , 8.64060299363e-10 , 9.3652520155e-09  , 7.92284514956e-08 ,
 5.23451250009e-07 , 2.70275624435e-06 , 1.09153519583e-05 , 3.45145007316e-05 ,
 8.55465278121e-05 , 0.000166426882106 , 0.000254583491988 , 0.000307605210706 ,
 0.000302005454276 , 0.000294256027099 , 0.000532664372547 , 0.00173343346301  ,
 0.00548031732863  , 0.0140673827585   , 0.0287732851039   , 0.0473985413668   ,
 0.0650077273838   , 0.0798948891174   , 0.0979724200143   , 0.126110157356    ,
 0.159054816182    , 0.178105112519    , 0.167648871743    , 0.130977256606    ,
 0.0868439143916   , 0.0528581434346   , 0.0344158507107   , 0.0265124557633   ,
 0.0218582850936   , 0.0166299665796   , 0.0108862365772   , 0.00608922691235  ,
 0.0031747443623   , 0.00230719609118  , 0.00350032572089  , 0.00717939696808  ,
 0.0142496458226   , 0.0252113007079   , 0.0382556602132   , 0.0482769372774   ,
 0.0495753653497   , 0.040873816924    , 0.0268499957505   , 0.0139934768575   ,
 0.0057732448461   , 0.00188357598848  , 0.000485872668105 , 9.91388934054e-05 ,
 1.60499131432e-05 , 2.17703574756e-06 , 5.38101671106e-07 , 6.94354414521e-07 ,
 1.10245669185e-06 , 1.4164106068e-06  , 1.44069895269e-06 , 1.15852898682e-06 ,
 7.35823521195e-07 , 3.6867074252e-07  , 1.45507753955e-07 , 4.51720275143e-08 ,
 1.10144572529e-08 , 1.95863090826e-10 , 3.04920258197e-11 , 1.11376382037e-11 ,
 4.1852775131e-11  , 1.7929920198e-10  , 6.14166741481e-10 , 1.66626066953e-09 ,
 3.57719355776e-09 , 6.07270653549e-09 , 8.14435547784e-09 , 8.6187031277e-09  ,
 7.18671014842e-09 , 4.71493420376e-09 , 2.43017303549e-09 , 9.82675866958e-10 ,
 3.11349166267e-10 , 7.7209317246e-11  , 1.49715310292e-11 , 2.26826393525e-12 ,
 2.6832948539e-13  , 2.47719245433e-14 , 1.7839446344e-15  , 1.00180722251e-16 ,
 4.38590683052e-18 , 1.54013078185e-19 , 1.47169753991e-19 , 3.77256680234e-18 ,
 1.0127441488e-16  , 2.71013784937e-15 , 7.25889288629e-14 , 1.90246301559e-12 ,
 4.40400337437e-11 , 8.45169834034e-10 , 1.30786132558e-08 , 1.61468427809e-07 ,
 1.58424282297e-06 , 1.23358294762e-05 , 7.62138022752e-05 , 0.000373861424917 ,
 0.00145870378134  , 0.00454170429458  , 0.0113430461171   , 0.022899932889    ,
 0.0377956847182   , 0.052005984698    , 0.0623328627894   , 0.0719534964985   ,
 0.092290518713    , 0.135244384614    , 0.198968327594    , 0.262760793968    ,
 0.301622094893    , 0.306403016333    , 0.286252917613    , 0.254246875115    ,
 0.217877626006    , 0.182616183266    , 0.155100487463    , 0.137675391253    ,
 0.124609037587    , 0.108466667415    , 0.087871785894    , 0.0665015569277   ,
 0.0474997930647   , 0.0316868185889   , 0.0193952333532   , 0.0116799062512   ,
 0.0100191053837   , 0.0155650795778   , 0.0278976917161   , 0.0436247786193   ,
 0.0569240901324   , 0.0626481932792   , 0.0591615211389   , 0.048705752554    ,
 0.0360214602444   , 0.0259335077911   , 0.0204915916748   , 0.0180816622279   ,
 0.0158272540856   , 0.0125843243159   , 0.00924024422162  , 0.0068088386311   ,
 0.00520933685694  , 0.00382302071729  , 0.00242669544244  , 0.00125331019838  ,
 0.000513027332729 , 0.000164769909345 , 4.13612703463e-05 , 8.10227871566e-06 ,
 1.2376769289e-06  , 1.47376902252e-07 , 1.36764105585e-08 , 9.88930462623e-10 ,
 5.571334656e-11   , 2.44519718025e-12 , 8.35990539936e-14 , 2.22640335299e-15 ,
 4.61045730737e-17 , 5.76576910183e-22 , 4.15866749386e-23 , 2.33823271379e-24 ,
 1.02463530535e-25 , 3.49888077591e-27 , 9.30919929919e-29 , 1.92110029685e-30 ,
 0, 9.35302402207e-32 , 4.84119567731e-30 , 1.1589548878e-17  ,
 5.6314338051e-16  , 2.11821865606e-14 , 6.20924993426e-13 , 1.41874438846e-11 ,
 2.52736084759e-10 , 3.51120596286e-09 , 3.80567522252e-08 , 3.21953701061e-07 ,
 2.12710287779e-06 , 1.09829531598e-05 , 4.43557552255e-05 , 0.000140253486378 ,
 0.000347626547675 , 0.000676269815468 , 0.00103418534965  , 0.00124622718823  ,
 0.00119497804639  , 0.000979011819446 , 0.0010220385661   , 0.00231140689384  ,
 0.00683349904934  , 0.0173908292453   , 0.0354498953286   , 0.0578995545056   ,
 0.07754742597     , 0.0902735269157   , 0.101549336551    , 0.121113043221    ,
 0.148837925086    , 0.169708708129    , 0.16657831107     , 0.136579363707    ,
 0.0930679314897   , 0.0534312689176   , 0.0271340835819   , 0.0136162146987   ,
 0.00763452171251  , 0.00470620053334  , 0.00285189945721  , 0.00174926279379  ,
 0.00166919970718  , 0.00308049830521  , 0.00649473301928  , 0.0121442727915   ,
 0.0197170861127   , 0.0283165758731   , 0.036193576079    , 0.0404786086604   ,
 0.0384539748106   , 0.0301755294898   , 0.0191755865301   , 0.00974821987328  ,
 0.00393694029027  , 0.00125833899946  , 0.000317689041141 , 6.3304761833e-05  ,
 9.95927786491e-06 , 1.24815343558e-06 , 1.51978247799e-07 , 7.23715086486e-08 ,
 1.02910610237e-07 , 1.3162484101e-07  , 1.33858988363e-07 , 1.07640921188e-07 ,
 6.83664599677e-08 , 3.42536786464e-08 , 1.35192901937e-08 , 4.19697455569e-09 ,
 1.02335531247e-09 , 1.59785203668e-11 , 1.70465683529e-11 , 1.04090470318e-10 ,
 5.70720863439e-10 , 2.47741059865e-09 , 8.50215321647e-09 , 2.30791349232e-08 ,
 4.95549893778e-08 , 8.41289142554e-08 , 1.12829490579e-07 , 1.19400576615e-07 ,
 9.95616801194e-08 , 6.53183637784e-08 , 3.36662468284e-08 , 1.36133800956e-08 ,
 4.31322264857e-09 , 1.06960309505e-09 , 2.07404493027e-10 , 3.14227896297e-11 ,
 3.7172255614e-12  , 3.43170355476e-13 , 2.47133186843e-14 , 1.38785915586e-15 ,
 6.10148581602e-17 , 3.47971871881e-18 , 7.34884922033e-18 , 5.86718449991e-17 ,
 8.39288757247e-16 , 1.34739013018e-14 , 2.14971430096e-13 , 3.73335783495e-12 ,
 6.94099667665e-11 , 1.21690486625e-09 , 1.81863594229e-08 , 2.21235307425e-07 ,
 2.1528058788e-06  , 1.66478098278e-05 , 0.00010204281803  , 0.000495312779974 ,
 0.00190431302837  , 0.0058075233922   , 0.0140931988196   , 0.0273701195417   ,
 0.04298032732     , 0.055753962709    , 0.0629757406726   , 0.0699867024491   ,
 0.0898137864464   , 0.133147311288    , 0.194488244281    , 0.249859905026    ,
 0.274038811608    , 0.26105538679     , 0.225112083597    , 0.184490256712    ,
 0.15016204043     , 0.126988290485    , 0.116239543401    , 0.113173173559    ,
 0.107740819211    , 0.0928209013602   , 0.0703661111853   , 0.0476466635963   ,
 0.0298117925856   , 0.0176362097603   , 0.0100234761376   , 0.00639605738242  ,
 0.00726959770365  , 0.0136299848681   , 0.0253271286507   , 0.0393726639836   ,
 0.0504684326813   , 0.0542004371032   , 0.0497126298685   , 0.0395222436125   ,
 0.0277216897838   , 0.0180510899313   , 0.0121863630379   , 0.00928710605035  ,
 0.00746297542935  , 0.00562583391293  , 0.0038711853586   , 0.00259467084755  ,
 0.00180609839801  , 0.00124964578686  , 0.000772447692333 , 0.000394882736949 ,
 0.000161040672257 , 5.16533525702e-05 , 1.29602187032e-05 , 2.53837494942e-06 ,
 3.87733047269e-07 , 4.61687668583e-08 , 4.28440035359e-09 , 3.09802928744e-10 ,
 1.74536881009e-11 , 7.6609701749e-13  , 2.62063141214e-14 , 7.00070280668e-16 ,
 1.47517394298e-17 , 2.87066588353e-20 , 2.07052080733e-21 , 1.16416123516e-22 ,
 5.10146272283e-24 , 1.74202565114e-25 , 4.63487183743e-27 , 9.56479002819e-29 ,
 0, 5.8069113094e-30  , 3.02998191618e-28 , 3.69226040264e-17 ,
 1.79409226927e-15 , 6.74833416626e-14 , 1.97817601863e-12 , 4.51991167283e-11 ,
 8.05180121893e-10 , 1.11861875515e-08 , 1.21243234516e-07 , 1.02569730201e-06 ,
 6.77663799273e-06 , 3.49900789163e-05 , 0.000141310932872 , 0.000446826993148 ,
 0.00110748591529  , 0.00215447294885  , 0.00329443265017  , 0.00396667665021  ,
 0.00377596355089  , 0.00291018553612  , 0.00215481829338  , 0.00279995386033  ,
 0.00688065353882  , 0.0170594383807   , 0.0346230866611   , 0.0562451541864   ,
 0.0742313023853   , 0.0834583684832   , 0.0885772851909   , 0.100581987347    ,
 0.123670323408    , 0.147317636461    , 0.15396418533     , 0.1347447477      ,
 0.0969845870672   , 0.057042933746    , 0.0275062762803   , 0.0111509949167   ,
 0.0041022448929   , 0.00159250731638  , 0.000827110616235 , 0.000962491311384 ,
 0.00237393364665  , 0.0061295261734   , 0.0131742285549   , 0.0229710027056   ,
 0.0328262833062   , 0.0392919823038   , 0.0405024178566   , 0.0367962249311   ,
 0.0295930728362   , 0.0206935833749   , 0.0122216208986   , 0.00593529370055  ,
 0.00232567845625  , 0.000726767302408 , 0.00017992908296  , 3.51658933806e-05 ,
 5.41653648006e-06 , 6.57880251419e-07 , 6.50284166431e-08 , 9.35409529316e-09 ,
 7.7962546244e-09  , 9.6699046917e-09  , 9.81513139956e-09 , 7.88624516737e-09 ,
 5.00520901351e-09 , 2.50613364322e-09 , 9.88560116996e-10 , 3.06751277322e-10 ,
 7.4910686083e-11  , 2.13829905733e-11 , 1.61456159132e-10 , 1.12168352049e-09 ,
 6.16454787576e-09 , 2.67601547256e-08 , 9.1835865835e-08  , 2.49283896232e-07 ,
 5.35245692782e-07 , 9.08662198222e-07 , 1.21862972111e-06 , 1.28957997995e-06 ,
 1.07529505124e-06 , 7.05448275854e-07 , 3.6359665471e-07  , 1.4702365811e-07  ,
 4.65821901961e-08 , 1.15514912375e-08 , 2.23991452323e-09 , 3.39356625052e-10 ,
 4.01447947756e-11 , 3.70613280512e-12 , 2.66924804063e-13 , 1.50314137548e-14 ,
 7.14450956159e-16 , 1.32217141839e-16 , 3.43363539835e-16 , 1.52650009001e-15 ,
 1.29130099137e-14 , 1.62746983441e-13 , 1.96641926531e-12 , 2.10275453094e-11 ,
 2.13126405609e-10 , 2.25030380332e-09 , 2.49088299174e-08 , 2.6296637522e-07  ,
 2.40671002047e-06 , 1.81100336619e-05 , 0.000109437673441 , 0.000525849159178 ,
 0.00200097894965  , 0.00602300312866  , 0.0143546069686   , 0.0271832555166   ,
 0.0412439036434   , 0.0512046630313   , 0.0551632622007   , 0.0594803420491   ,
 0.0766434802066   , 0.114878919367    , 0.16663242771     , 0.208929748896    ,
 0.220277153451    , 0.198306320478    , 0.158892927778    , 0.120663568114    ,
 0.0941746764517   , 0.0822756771661   , 0.0826156932509   , 0.0874916784418   ,
 0.0866077883429   , 0.0745510040575   , 0.0547530491566   , 0.0348744338966   ,
 0.0199477602376   , 0.0106011200713   , 0.00548348090908  , 0.00357258388173  ,
 0.00487584198374  , 0.0099935501736   , 0.0187736801063   , 0.0289055799965   ,
 0.0363846320846   , 0.0381159492057   , 0.0339323467783   , 0.0260871038919   ,
 0.0175268193225   , 0.0105838668656   , 0.00623317464116  , 0.00402467729546  ,
 0.00287669647276  , 0.00203051904416  , 0.00131595139748  , 0.000808282974452 ,
 0.000508010861136 , 0.000326224483171 , 0.000194311835084 , 9.7859609019e-05  ,
 3.96884454018e-05 , 1.2704570838e-05  , 3.18539926486e-06 , 6.23730485379e-07 ,
 9.52655556591e-08 , 1.13434162063e-08 , 1.05272732246e-09 , 7.61564180108e-11 ,
 4.30149282316e-12 , 1.91547403513e-13 , 7.08633312125e-15 , 2.70450250442e-16 ,
 1.53000477409e-17 , 1.08707474083e-18 , 7.84072741773e-20 , 4.40849030972e-21 ,
 1.93184142366e-22 , 6.59676939104e-24 , 1.75515100185e-25 , 3.62203128572e-27 ,
 0, 2.31762071349e-28 , 1.21139178309e-26 , 9.23437718022e-17 ,
 4.487041236e-15   , 1.68776456841e-13 , 4.9474363744e-12  , 1.13043405639e-10 ,
 2.01376287184e-09 , 2.79767576873e-08 , 3.03230441767e-07 , 2.56527836155e-06 ,
 1.69484337837e-05 , 8.75105083053e-05 , 0.000353419937926 , 0.00111751836542  ,
 0.00276983143783  , 0.00538833873295  , 0.00823915551204  , 0.00991794405213  ,
 0.00942010508063  , 0.00711954698835  , 0.00455079055651  , 0.00352544588414  ,
 0.0058565414108   , 0.0134269034223   , 0.0269588863846   , 0.0436071386665   ,
 0.0570733866863   , 0.0630553926545   , 0.0653846707964   , 0.0741332910683   ,
 0.0950098488213   , 0.120673771027    , 0.134413351812    , 0.124165076908    ,
 0.0931348618893   , 0.056217882574    , 0.02719342018     , 0.0105510285714   ,
 0.00333433804304  , 0.000944786841361 , 0.000506922393943 , 0.00125618251186  ,
 0.00406539152715  , 0.0108990838201   , 0.0233159866499   , 0.0397836390436   ,
 0.0543901778756   , 0.0600803677973   , 0.0543806870976   , 0.0411972491058   ,
 0.0268058835831   , 0.0152939123737   , 0.00767351086841  , 0.00332667669921  ,
 0.0012122587078   , 0.000361996464541 , 8.69866185754e-05 , 1.66320105031e-05 ,
 2.5141571191e-06  , 2.99711224563e-07 , 2.8841317406e-08  , 3.63925084583e-09 ,
 2.5646491138e-09  , 3.00062405097e-09 , 2.89782372992e-09 , 2.21601433733e-09 ,
 1.34044052308e-09 , 6.41367840068e-10 , 2.42655930399e-10 , 7.26417376674e-11 ,
 1.87266872664e-11 , 1.88083135426e-10 , 1.36155036075e-09 , 9.45113979844e-09 ,
 5.19388821886e-08 , 2.25455920963e-07 , 7.7368855741e-07  , 2.10004470839e-06 ,
 4.50887516229e-06 , 7.65418618699e-06 , 1.02648156318e-05 , 1.08620583466e-05 ,
 9.05686264172e-06 , 5.94160077178e-06 , 3.06230282328e-06 , 1.23824651064e-06 ,
 3.92313189187e-07 , 9.72849044083e-08 , 1.88640236996e-08 , 2.85795656768e-09 ,
 3.38085186023e-10 , 3.12124053411e-11 , 2.24946128427e-12 , 1.2879236733e-13  ,
 8.8408193301e-15  , 5.50452522026e-15 , 1.36089002413e-14 , 4.43334552973e-14 ,
 2.07579077214e-13 , 1.85240068118e-12 , 2.01034997641e-11 , 1.93272087465e-10 ,
 1.57165833018e-09 , 1.10972164824e-08 , 7.19215270825e-08 , 4.57550502434e-07 ,
 2.9369858652e-06  , 1.81376596601e-05 , 9.95230683841e-05 , 0.000456878595548 ,
 0.00169849012465  , 0.00503710230207  , 0.0118486606267   , 0.0221097680111   ,
 0.0329579179272   , 0.0401479096073   , 0.0427278518315   , 0.0464341102238   ,
 0.0609286074574   , 0.0911806580357   , 0.129456566043    , 0.157231465784    ,
 0.159047877916    , 0.135423871196    , 0.100757507974    , 0.0704842035667   ,
 0.0525530460911   , 0.0478333046183   , 0.0526547697206   , 0.0598681013944   ,
 0.0616844308284   , 0.0547454930769   , 0.0418944036895   , 0.0283603752858   ,
 0.0174083607571   , 0.00972342283265  , 0.00498214343779  , 0.00289264414544  ,
 0.00345136391679  , 0.00683676489674  , 0.0126981182334   , 0.0192613640865   ,
 0.0237165756747   , 0.0241139328917   , 0.0207081769611   , 0.0153175595419   ,
 0.00986998880913  , 0.00560709736419  , 0.00293630876039  , 0.00157453117044  ,
 0.000944930978081 , 0.000600731920996 , 0.000363695869778 , 0.000206018474547 ,
 0.00011660940575  , 6.83986259147e-05 , 3.87203437729e-05 , 1.90794542109e-05 ,
 7.67403473402e-06 , 2.44911399402e-06 , 6.13404147778e-07 , 1.20071859809e-07 ,
 1.83438389522e-08 , 2.18891460563e-09 , 2.05636301531e-10 , 1.5894531124e-11  ,
 1.2225703635e-12  , 1.35238455123e-13 , 2.05149968085e-14 , 2.96270326831e-15 ,
 3.48127957988e-16 , 3.21391739393e-17 , 2.31809730116e-18 , 1.3033624235e-19  ,
 5.71145526668e-21 , 1.95032329363e-22 , 5.1890731354e-24  , 1.07084719323e-25 ,
 0, 7.29314814124e-27 , 3.81924901187e-25 , 1.81567167901e-16 ,
 8.82246122349e-15 , 3.3184979624e-13  , 9.72769405003e-12 , 2.2226696289e-10  ,
 3.95947868956e-09 , 5.50081527081e-08 , 5.96214422155e-07 , 5.04387338365e-06 ,
 3.33241628963e-05 , 0.000172063948176 , 0.000694897458326 , 0.00219727463086  ,
 0.00544606688913  , 0.0105945895484   , 0.0161997537805   , 0.0194991244775   ,
 0.0185078996295   , 0.0139041607557   , 0.00844875910995  , 0.00485792660582  ,
 0.00473212930109  , 0.00890191477382  , 0.0172963137607   , 0.0277344703356   ,
 0.0360484331654   , 0.0396276452756   , 0.0415720201282   , 0.0496061533819   ,
 0.0685074999704   , 0.0927294318089   , 0.108005676297    , 0.102768157457    ,
 0.0785158421387   , 0.0478545676712   , 0.0231903991536   , 0.00891935494451  ,
 0.00273311855743  , 0.000737838790461 , 0.000534240500306 , 0.00175079096749  ,
 0.00588725536174  , 0.0158825916995   , 0.0340312658826   , 0.0579632854641   ,
 0.0786079418485   , 0.0850974781823   , 0.0738564076272   , 0.051783698183    ,
 0.029706587246    , 0.0142080974445   , 0.00579449264709  , 0.00205176680094  ,
 0.000632809046683 , 0.000167567411013 , 3.71901553055e-05 , 6.75832524579e-06 ,
 9.89204470849e-07 , 1.18821364022e-07 , 2.03647087808e-08 , 1.99536962569e-08 ,
 2.95748086556e-08 , 3.58070424588e-08 , 3.42513281262e-08 , 2.58821103205e-08 ,
 1.5463040307e-08  , 7.30737716273e-09 , 2.73150310634e-09 , 8.0815250115e-10  ,
 2.02064969838e-10 , 1.40626386326e-09 , 8.97962803699e-09 , 6.21594939751e-08 ,
 3.41554939093e-07 , 1.4824850185e-06  , 5.08690807768e-06 , 1.38062122242e-05 ,
 2.96396467596e-05 , 5.03111662001e-05 , 6.74652023499e-05 , 7.13851056404e-05 ,
 5.95173999703e-05 , 3.90431031625e-05 , 2.01218334232e-05 , 8.135956988e-06   ,
 2.5776249473e-06  , 6.39175767501e-07 , 1.23936586038e-07 , 1.87764381282e-08 ,
 2.22116287414e-09 , 2.05090059127e-10 , 1.48372630263e-11 , 9.30518319378e-13 ,
 1.6388683657e-13  , 1.88592767645e-13 , 4.2877734676e-13  , 1.22623446234e-12 ,
 3.84002616597e-12 , 1.96864016279e-11 , 1.72601096235e-10 , 1.56618231397e-09 ,
 1.2143004356e-08  , 7.87718733517e-08 , 4.31643888369e-07 , 2.03088916248e-06 ,
 8.4244118031e-06  , 3.21096354613e-05 , 0.000117100044829 , 0.000409195945263 ,
 0.0013066293667   , 0.00359178866578  , 0.00815578046703  , 0.0150233240478   ,
 0.0225269859212   , 0.0283959558352   , 0.0326602315354   , 0.0391491249755   ,
 0.0529366401211   , 0.0750582882385   , 0.0987843719425   , 0.112112516689    ,
 0.106702604022    , 0.0851647392683   , 0.0585117389088   , 0.0372550168554   ,
 0.0260273068179   , 0.0243767764074   , 0.0290860178465   , 0.0354777545751   ,
 0.0392326789914   , 0.0386390885783   , 0.0345992015015   , 0.0284772932999   ,
 0.0210797561879   , 0.0134903552125   , 0.00733487558085  , 0.00385937389647  ,
 0.00346487368297  , 0.006040833447    , 0.0109044851202   , 0.0162604689344   ,
 0.0196064427031   , 0.0194107940842   , 0.0161762917196   , 0.0116293280311   ,
 0.00730559500281  , 0.00400265749944  , 0.00191196744987  , 0.000825285126077 ,
 0.000355566717732 , 0.000168773139049 , 8.60048530884e-05 , 4.35536394887e-05 ,
 2.20203077073e-05 , 1.16089691152e-05 , 6.13814883883e-06 , 2.93024809695e-06 ,
 1.16404914405e-06 , 3.69925118345e-07 , 9.26804439005e-08 , 1.83281794653e-08 ,
 2.96621621036e-09 , 4.64631679505e-10 , 1.01176242743e-10 , 3.09957041853e-11 ,
 9.3015630837e-12  , 2.29247633536e-12 , 4.45411717729e-13 , 6.76714310406e-14 ,
 8.02487415198e-15 , 7.42302859017e-16 , 5.35399651959e-17 , 3.01031275766e-18 ,
 1.3191470265e-19  , 4.50456679317e-21 , 1.19849496796e-22 , 2.47328733105e-24 ,
 1.79490255485e-28 , 1.8794600158e-25  , 9.70639485644e-24 , 2.81079686977e-16 ,
 1.36578297251e-14 , 5.13728154234e-13 , 1.5059190903e-11  , 3.4408568405e-10  ,
 6.12956519958e-09 , 8.5156676048e-08  , 9.22983858194e-07 , 7.80828752422e-06 ,
 5.1588258197e-05  , 0.000266367660772 , 0.00107575242481  , 0.00340154287508  ,
 0.00843091222253  , 0.0164012003501   , 0.0250783515289   , 0.0301854095226   ,
 0.0286457273997   , 0.0214845916785   , 0.0128648185513   , 0.00661943895007  ,
 0.0043488881354   , 0.00602812781603  , 0.010813819967    , 0.0168100619195   ,
 0.0213190961274   , 0.0230337215221   , 0.0244452673504   , 0.0309214106557   ,
 0.0456190525646   , 0.0643348135989   , 0.0764791104183   , 0.0733925363782   ,
 0.0561535925561   , 0.0341221761883   , 0.0164377803785   , 0.00627013666584  ,
 0.00190271867078  , 0.000536091077858 , 0.000552439394313 , 0.00203265287151  ,
 0.00691377697042  , 0.0187578345842   , 0.0404140188624   , 0.0692003214787   ,
 0.094248019395    , 0.102188198701    , 0.0883122468051   , 0.0609574458792   ,
 0.0337287431472   , 0.0150542260603   , 0.0054748030282   , 0.0016460001718   ,
 0.000416340610135 , 8.9974074441e-05  , 1.67114855682e-05 , 2.65075211601e-06 ,
 3.65667751803e-07 , 8.34664805074e-08 , 1.15778352733e-07 , 2.2009696589e-07  ,
 3.38333633184e-07 , 4.10178224569e-07 , 3.92360691439e-07 , 2.96475693652e-07 ,
 1.77118511299e-07 , 8.36969937675e-08 , 3.12842838645e-08 , 9.25089925694e-09 ,
 2.24760346939e-09 , 8.77921898167e-09 , 4.63814859834e-08 , 3.19483548855e-07 ,
 1.75505308449e-06 , 7.61616163539e-06 , 2.61283644579e-05 , 7.08995901696e-05 ,
 0.000152178792015 , 0.000258262363624 , 0.000346256614394 , 0.0003663150976   ,
 0.000305371455809 , 0.000200297089421 , 0.00010321716853  , 4.17306106858e-05 ,
 1.32200869396e-05 , 3.27800222768e-06 , 6.35576486889e-07 , 9.62865599215e-08 ,
 1.13903435351e-08 , 1.05269454944e-09 , 7.79193524962e-11 , 7.39915162536e-12 ,
 4.08711270721e-12 , 5.32589129632e-12 , 1.09198790468e-11 , 2.88580783526e-11 ,
 7.53379990296e-11 , 2.28980617666e-10 , 1.28490513101e-09 , 1.02759247549e-08 ,
 7.66983248658e-08 , 4.82157844797e-07 , 2.53364551273e-06 , 1.11659479261e-05 ,
 4.13250675135e-05 , 0.000128667144607 , 0.000340326664479 , 0.000784886998842 ,
 0.00164591746593  , 0.00325210396489  , 0.00605351820797  , 0.0103301189051   ,
 0.0159663529622   , 0.0230045676545   , 0.0324790497721   , 0.0456944861909   ,
 0.0619343903691   , 0.077318648457    , 0.0862790480074   , 0.0844161472235   ,
 0.0713021129032   , 0.0515049704365   , 0.0320750807182   , 0.0182641152365   ,
 0.0115571947313   , 0.0108065361569   , 0.0139519260635   , 0.0189667966635   ,
 0.0244841573626   , 0.0297836867497   , 0.0336008601979   , 0.03359397433     ,
 0.0283444749145   , 0.0195499022673   , 0.0110142136996   , 0.00575092436249  ,
 0.00480551701008  , 0.00801076059506  , 0.0143285562797   , 0.0213375634749   ,
 0.0257927733821   , 0.0257509953133   , 0.0218335291937   , 0.0161190724854   ,
 0.0104390497404   , 0.00584340713203  , 0.00275686395152  , 0.00107651988472  ,
 0.000349922182033 , 9.99622305162e-05 , 2.84904351313e-05 , 9.32789739665e-06 ,
 3.63373290984e-06 , 1.62707223792e-06 , 7.80644002022e-07 , 3.56282462195e-07 ,
 1.40290175001e-07 , 4.66995390245e-08 , 1.49815233695e-08 , 6.51236488146e-09 ,
 4.02536020482e-09 , 2.49242763306e-09 , 1.27970525543e-09 , 5.20123315834e-10 ,
 1.65730329479e-10 , 4.12977180194e-11 , 8.03951506358e-12 , 1.22186317272e-12 ,
 1.4490440207e-13  , 1.34038639267e-14 , 9.66778450883e-16 , 5.43576278743e-17 ,
 2.38200177026e-18 , 8.13395767119e-20 , 2.16413871005e-21 , 4.46608633634e-23 ,
 1.68091800312e-26 , 4.08044470018e-24 , 2.00419173715e-22 , 3.43102386949e-16 ,
 1.66714164143e-14 , 6.27078814537e-13 , 1.83818473246e-11 , 4.200039272e-10   ,
 7.48196956602e-09 , 1.03945254726e-07 , 1.12662628823e-06 , 9.5310653716e-06  ,
 6.29703976261e-05 , 0.00032513746436  , 0.00131310004382  , 0.00415203884197  ,
 0.0102910576492   , 0.0200198618376   , 0.030611489801    , 0.0368453429422   ,
 0.0349657701756   , 0.0262221594972   , 0.0156822712831   , 0.00796678097185  ,
 0.00485852146283  , 0.00599922330715  , 0.0100290162619   , 0.014721245491    ,
 0.0175043382234   , 0.0174021809569   , 0.0166105899207   , 0.0192550028367   ,
 0.027590661697    , 0.0388153313198   , 0.0460946021084   , 0.044028359799    ,
 0.0334227759315   , 0.0201082044509   , 0.00957986066437  , 0.00361275047734  ,
 0.00108787137026  , 0.000333319004376 , 0.000486040106027 , 0.00191388953643  ,
 0.00656627636265  , 0.0179393274436   , 0.0389457643706   , 0.0672369690634   ,
 0.0923661566902   , 0.1010104359      , 0.0879716398143   , 0.0610475806953   ,
 0.0337836696619   , 0.0149304475155   , 0.00528205463352  , 0.00150177891609  ,
 0.000345296472453 , 6.48004680213e-05 , 1.0053263421e-05  , 1.33624864676e-06 ,
 2.72041618852e-07 , 4.21592105782e-07 , 1.01731885555e-06 , 1.98782136773e-06 ,
 3.05874897451e-06 , 3.70840283892e-06 , 3.54731946164e-06 , 2.68042626957e-06 ,
 1.60132197789e-06 , 7.56701293179e-07 , 2.82838646964e-07 , 8.36125657682e-08 ,
 1.99705726332e-08 , 4.65375080629e-08 , 1.88356850345e-07 , 1.28600337914e-06 ,
 7.06086739878e-06 , 3.06284633564e-05 , 0.000105030258741 , 0.000284875720631 ,
 0.000611191834326 , 0.00103682158009  , 0.00138954614368  , 0.00146952696957  ,
 0.00122466350517  , 0.000803057845694 , 0.000413738236373 , 0.000167242367453 ,
 5.29734505945e-05 , 1.31334301671e-05 , 2.54620018245e-06 , 3.85708553635e-07 ,
 4.56359213173e-08 , 4.24189812298e-09 , 3.5723194346e-10  , 9.42904297336e-11 ,
 9.56134465884e-11 , 1.21954166663e-10 , 2.24721751407e-10 , 5.5232898833e-10  ,
 1.3352480398e-09  , 3.04478824145e-09 , 9.56858130983e-09 , 5.6090384563e-08  ,
 3.88004429263e-07 , 2.36609989055e-06 , 1.20975568184e-05 , 5.17341710976e-05 ,
 0.000184926439241 , 0.000550163911397 , 0.0013550963197   , 0.00276018958417  ,
 0.00469547312791  , 0.00687790802832  , 0.00922562402985  , 0.0123848869341   ,
 0.0179717063969   , 0.028436395832    , 0.0458776576193   , 0.0689806316562   ,
 0.090618013534    , 0.101010218162    , 0.0952191830143   , 0.0767185124923   ,
 0.0535528195635   , 0.0326693053732   , 0.0175385171164   , 0.00861960182515  ,
 0.00470949232839  , 0.00425358512653  , 0.00619561728466  , 0.0103245244863   ,
 0.0170620013326   , 0.0261547538946   , 0.0348657693216   , 0.0384822549744   ,
 0.0342071688184   , 0.0242223827782   , 0.0138612260626   , 0.00743318330045  ,
 0.00661059370718  , 0.0114286524216   , 0.0206752538372   , 0.0311414606904   ,
 0.0383656367475   , 0.0394850563398   , 0.0349218503924   , 0.0270600184895   ,
 0.0183231407816   , 0.0105993812329   , 0.00509002802237  , 0.0019826699042   ,
 0.000617824560989 , 0.000153536281587 , 3.08806531431e-05 , 5.33880672667e-06 ,
 9.44944778873e-07 , 2.31510885998e-07 , 8.73934123238e-08 , 4.5609301045e-08  ,
 3.74624572008e-08 , 4.63596712854e-08 , 5.86804770889e-08 , 6.21172053964e-08 ,
 5.23149213138e-08 , 3.46751605718e-08 , 1.80320674863e-08 , 7.34579742413e-09 ,
 2.3415961445e-09  , 5.83535704586e-10 , 1.13599589697e-10 , 1.72651539963e-11 ,
 2.04752696855e-12 , 1.89399181517e-13 , 1.36607659035e-14 , 7.68083761883e-16 ,
 3.3658144258e-17  , 1.14934390102e-18 , 3.05796975007e-20 , 6.31082029652e-22 ,
 7.87138648745e-25 , 7.86836156746e-23 , 3.48550904901e-21 , 3.30768147852e-16 ,
 1.60697906705e-14 , 6.04400565516e-13 , 1.77162213775e-11 , 4.04783349966e-10 ,
 7.21069943139e-09 , 1.00175428404e-07 , 1.08575865093e-06 , 9.18528966413e-06 ,
 6.06857234699e-05 , 0.0003133402937   , 0.00126545430057  , 0.00400137876339  ,
 0.00991763230144  , 0.0192934085136   , 0.0295007389026   , 0.0355088324215   ,
 0.0337008333537   , 0.0252939222815   , 0.0152230860298   , 0.00808404152355  ,
 0.00585727319442  , 0.00842966147713  , 0.0142950856472   , 0.0204169722049   ,
 0.0231786008189   , 0.021131166366    , 0.0166561158542   , 0.0140419207073   ,
 0.0157004164434   , 0.0201226919114   , 0.0232239512804   , 0.0218721866543   ,
 0.0163983146813   , 0.00973810894483  , 0.00457696587407  , 0.00170312605308  ,
 0.000509576810987 , 0.000177964080051 , 0.000358549300582 , 0.00146977017055  ,
 0.00507091735609  , 0.0139414979088   , 0.0305043570558   , 0.0531413209414   ,
 0.0737333578144   , 0.0814965834997   , 0.0717631515655   , 0.0503471001919   ,
 0.0281434159349   , 0.0125351677602   , 0.00444915002307  , 0.0012587359937   ,
 0.00028407762816  , 5.12573588674e-05 , 7.47984832512e-06 , 1.11057356964e-06 ,
 1.00934827449e-06 , 2.92342332906e-06 , 7.25664434046e-06 , 1.41917516175e-05 ,
 2.18380414911e-05 , 2.6476282387e-05  , 2.5326221274e-05  , 1.91370045224e-05 ,
 1.14326986875e-05 , 5.40249720454e-06 , 2.01933170213e-06 , 5.96854810865e-07 ,
 1.41145222226e-07 
};
  // type   : ileval
  // tiling : [180, 180]
  // range  : [[-180.0, 178.0], [-180.0, 178.0]]
  ftype32 rama2_ileval_data[] = {
 0, 0, 0, 0, 7.54543781343e-31 , 3.67784545318e-29 , 1.38460431017e-27 ,
 4.10072684259e-26 , 9.48409589306e-25 , 1.73001676839e-23 , 3.42583380046e-21 ,
 1.58525756957e-19 , 5.89407244883e-18 , 1.7267845726e-16  , 3.95666295638e-15 ,
 7.08041643027e-14 , 9.89591354801e-13 , 1.08081827367e-11 , 9.23171146012e-11 ,
 6.17243225626e-10 , 3.23415242937e-09 , 1.3296837876e-08  , 4.29565771278e-08 ,
 1.09206252137e-07 , 2.18798377987e-07 , 3.45951747726e-07 , 4.32175392473e-07 ,
 4.26901529814e-07 , 3.33565659426e-07 , 2.06147077088e-07 , 1.00709573946e-07 ,
 3.88550077592e-08 , 1.18241901252e-08 , 2.83441899331e-09 , 5.34599862941e-10 ,
 7.93195367557e-11 , 9.28722614306e-12 , 8.70658859981e-13 , 6.86782472573e-14 ,
 5.17283492503e-15 , 4.37604085191e-16 , 4.10973149665e-17 , 3.63002074134e-18 ,
 2.68660660073e-19 , 2.11520077263e-20 , 1.14342694799e-16 , 5.54567196239e-15 ,
 2.08486759371e-13 , 6.1084144809e-12  , 1.39487684899e-10 , 2.4830010485e-09  ,
 3.44634306939e-08 , 3.73093979864e-07 , 3.15158605456e-06 , 2.07829243752e-05 ,
 0.000107057243602 , 0.000431102475923 , 0.00135827542911  , 0.00335192982429  ,
 0.00648675556891  , 0.00985764387458  , 0.0117804994664   , 0.0110878437531   ,
 0.00823088169553  , 0.00482514370767  , 0.00223594537684  , 0.000819501639351 ,
 0.000237588783593 , 5.44668703393e-05 , 9.86561090315e-06 , 1.41028161267e-06 ,
 1.58885361362e-07 , 1.40869310401e-08 , 9.8143027153e-10  , 5.3653930212e-11  ,
 2.29871957515e-12 , 7.70943666342e-14 , 2.0220460444e-15  , 3.95950924929e-17 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4.67130509918e-30 ,
 2.25660107618e-28 , 8.47405757339e-27 , 2.47906954489e-25 , 5.64983925055e-24 ,
 1.00326287851e-22 , 1.38845965592e-21 , 1.49825840181e-20 , 1.26168044064e-19 ,
 8.30558374189e-19 , 4.28930878054e-18 , 1.75057178617e-17 , 5.73017520487e-17 ,
 1.54658308648e-16 , 3.59522312743e-16 , 7.55123587196e-16 , 1.46379004646e-15 ,
 2.55892345077e-15 , 3.8536709458e-15  , 4.80670797465e-15 , 4.84706809263e-15 ,
 3.90102068094e-15 , 2.48893581145e-15 , 1.25403657378e-15 , 4.97792315999e-16 ,
 1.57788903262e-16 , 8.26931716523e-17 , 6.25244247831e-16 , 6.66239355802e-15 ,
 5.59652695451e-14 , 3.6653598333e-13  , 1.87183969144e-12 , 7.45616861187e-12 ,
 2.31758358791e-11 , 5.62403821298e-11 , 1.06616802604e-10 , 1.58014721211e-10 ,
 1.83256426762e-10 , 1.66485047252e-10 , 1.18625677916e-10 , 6.6383938588e-11  ,
 2.92188787596e-11 , 1.0130423105e-11  , 2.77059177581e-12 , 5.98460890394e-13 ,
 1.02193385144e-13 , 1.38026713904e-14 , 1.47463209365e-15 , 1.24573019446e-16 ,
 8.58515419995e-18 , 1.07806184238e-17 , 3.07333432392e-16 , 7.14213646753e-15 ,
 1.29958401691e-13 , 1.85359579866e-12 , 2.07504459245e-11 , 1.8258313012e-10  ,
 1.26462282957e-09 , 6.90502913195e-09 , 2.97614987452e-08 , 1.0136805195e-07  ,
 2.73035658789e-07 , 5.81743398996e-07 , 9.80283315698e-07 , 1.30555954565e-06 ,
 1.3728363418e-06  , 1.13828872215e-06 , 7.43133712131e-07 , 3.81429853359e-07 ,
 1.53698486386e-07 , 4.85572452394e-08 , 1.20130672577e-08 , 2.32500801043e-09 ,
 3.51713871565e-10 , 4.15562596724e-11 , 3.83273840536e-12 , 2.75803706187e-13 ,
 1.54789833011e-14 , 6.77334338403e-16 , 2.31034291436e-17 , 6.1415640672e-19  ,
 1.26346731506e-20 , 0, 0, 0, 0, 0, 0, 0, 0, 3.96921850693e-29 ,
 1.93656693067e-27 , 7.29320235544e-26 , 2.15541959616e-24 , 4.97302628416e-23 ,
 9.02401510238e-22 , 4.39166507587e-20 , 1.66485157358e-18 , 5.85154764214e-17 ,
 1.68911859351e-15 , 3.85368693948e-14 , 6.88442022921e-13 , 9.61162792706e-12 ,
 1.04871651671e-10 , 8.94751005974e-10 , 5.97451014287e-09 , 3.12549524969e-08 ,
 1.28258689859e-07 , 4.13430690775e-07 , 1.04834383492e-06 , 2.09428441497e-06 ,
 3.30072752461e-06 , 4.10914628049e-06 , 4.04436509139e-06 , 3.14858428118e-06 ,
 1.93888553713e-06 , 9.43981807448e-07 , 3.630598427e-07   , 1.1018219123e-07  ,
 2.63564196385e-08 , 4.96748206288e-09 , 7.39507530292e-10 , 8.80535350175e-11 ,
 8.76484425911e-12 , 8.20212991172e-13 , 8.51978877973e-14 , 9.93034172566e-15 ,
 1.10513508515e-15 , 1.03647655571e-16 , 7.80305161409e-18 , 4.64847326707e-19 ,
 2.16212705159e-16 , 1.04914981605e-14 , 3.94488157749e-13 , 1.15585913324e-11 ,
 2.63947988558e-10 , 4.69852093984e-09 , 6.52143681498e-08 , 7.05997523828e-07 ,
 5.96367752701e-06 , 3.93270755633e-05 , 0.000202582094434 , 0.000815765844512 ,
 0.00257023507256  , 0.00634278395447  , 0.0122747465786   , 0.0186534052564   ,
 0.0222919831014   , 0.0209812857495   , 0.0155751185415   , 0.00913051456779  ,
 0.00423103084029  , 0.001550725141    , 0.000449584091411 , 0.000103066474954 ,
 1.86684810917e-05 , 2.66864524444e-06 , 3.00655316072e-07 , 2.66563934401e-08 ,
 1.8571391723e-09  , 1.01528166019e-10 , 4.34981709141e-12 , 1.45883994404e-13 ,
 3.82627378244e-15 , 7.492493296e-17   , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 2.26076980799e-28 , 1.09212639153e-26 , 4.10118652205e-25 ,
 1.19977151112e-23 , 2.73423693542e-22 , 4.85505730029e-21 , 6.71845130086e-20 ,
 7.24817991985e-19 , 6.10085269979e-18 , 4.01217119352e-17 , 2.06762500724e-16 ,
 8.40052434276e-16 , 2.72440419415e-15 , 7.22356621404e-15 , 1.62974495074e-14 ,
 3.28798072661e-14 , 6.12159898735e-14 , 1.03860224111e-13 , 1.53696270322e-13 ,
 1.90019891278e-13 , 1.90824858868e-13 , 1.53290878342e-13 , 9.77182800084e-14 ,
 4.92142775089e-14 , 1.95292047044e-14 , 6.13748791755e-15 , 2.3067375905e-15  ,
 1.15629856035e-14 , 1.21603062853e-13 , 1.02129645818e-12 , 6.68880768043e-12 ,
 3.41586523998e-11 , 1.36065429577e-10 , 4.22929017413e-10 , 1.02631420403e-09 ,
 1.94561869527e-09 , 2.88356420571e-09 , 3.3441926716e-09  , 3.03813669614e-09 ,
 2.16476513135e-09 , 1.21142098458e-09 , 5.33206730846e-10 , 1.8486711384e-10  ,
 5.05597150199e-11 , 1.09211368968e-11 , 1.86489705012e-12 , 2.51880893499e-13 ,
 2.69101276719e-14 , 2.2732434081e-15  , 1.53989342566e-16 , 9.48921973772e-17 ,
 2.58247750521e-15 , 6.00101683814e-14 , 1.09194564478e-12 , 1.55744132962e-11 ,
 1.74350859633e-10 , 1.53411284782e-09 , 1.06257030933e-08 , 5.80179225702e-08 ,
 2.50064162913e-07 , 8.5172179244e-07  , 2.29411946102e-06 , 4.88796539938e-06 ,
 8.23660558417e-06 , 1.09696644551e-05 , 1.15349422947e-05 , 9.56420974945e-06 ,
 6.24401046626e-06 , 3.20487680432e-06 , 1.29141625791e-06 , 4.07991109189e-07 ,
 1.00937040622e-07 , 1.9535346216e-08  , 2.95519508714e-09 , 3.49166934695e-10 ,
 3.22037048338e-11 , 2.31737734401e-12 , 1.30058604745e-13 , 5.69114632953e-15 ,
 1.94121261119e-16 , 5.16030825797e-18 , 1.06159941478e-19 , 0, 0, 0, 0,
 3.76918009318e-27 , 1.10668176201e-25 , 2.53389298127e-24 , 4.52579316486e-23 ,
 6.30858524398e-22 , 6.86650344343e-21 , 5.83986235545e-20 , 3.88439697317e-19 ,
 2.02349737538e-18 , 8.28065156706e-18 , 2.71232777113e-17 , 8.37034597934e-17 ,
 6.24864627079e-16 , 1.35665052492e-14 , 2.99670320228e-13 , 5.31910172681e-12 ,
 7.40840942777e-11 , 8.07128377908e-10 , 6.87725508616e-09 , 4.58566282592e-08 ,
 2.39503056131e-07 , 9.80947675279e-07 , 3.15488261475e-06 , 7.97902608359e-06 ,
 1.58924804701e-05 , 2.49650308451e-05 , 3.09686663053e-05 , 3.03661552235e-05 ,
 2.35500023504e-05 , 1.44472178032e-05 , 7.00852792344e-06 , 2.68663658765e-06 ,
 8.13113914807e-07 , 1.94210015238e-07 , 3.66784478791e-08 , 5.5357189915e-09  ,
 6.94009483646e-10 , 8.04794510702e-11 , 1.02144882468e-11 , 1.47086266745e-12 ,
 2.05944383715e-13 , 2.45047155943e-14 , 2.34496983069e-15 , 1.77547999885e-16 ,
 1.05957372096e-17 , 3.20180527915e-16 , 1.55139392096e-14 , 5.83336388615e-13 ,
 1.70918982254e-11 , 3.90304744461e-10 , 6.94778971012e-09 , 9.64336924994e-08 ,
 1.04397160293e-06 , 8.81860032946e-06 , 5.815367449e-05   , 0.000299561892411 ,
 0.00120628805245  , 0.00380065417168  , 0.00937919202568  , 0.0181508949468   ,
 0.0275831355899   , 0.032963567992    , 0.0310254155594   , 0.0230312160516   ,
 0.0135014608789   , 0.00625650361144  , 0.00229308596681  , 0.000664808316869 ,
 0.000152406304068 , 2.76054285065e-05 , 3.94617511423e-06 , 4.44584580404e-07 ,
 3.94173023364e-08 , 2.746186066e-09   , 1.50131578176e-10 , 6.43215503947e-12 ,
 2.15721362546e-13 , 5.65798185876e-15 , 1.10792885078e-16 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 8.49414364812e-27 , 4.1033272909e-25  ,
 1.54089404958e-23 , 4.50770472215e-22 , 1.02727226884e-20 , 1.82401378133e-19 ,
 2.52388421002e-18 , 2.72243427669e-17 , 2.29068155907e-16 , 1.50529592669e-15 ,
 7.74465052084e-15 , 3.13559042457e-14 , 1.00955272369e-13 , 2.63876332633e-13 ,
 5.80588553165e-13 , 1.12981267987e-12 , 2.02283457561e-12 , 3.32689411737e-12 ,
 4.83012331904e-12 , 5.91284385267e-12 , 5.91025339862e-12 , 4.73787004131e-12 ,
 3.01768081512e-12 , 1.5195080765e-12  , 6.03124115917e-13 , 1.8897669554e-13  ,
 5.78772124407e-14 , 1.70310106079e-13 , 1.74122156369e-12 , 1.46177534036e-11 ,
 9.57359167139e-11 , 4.88907704155e-10 , 1.94748422496e-09 , 6.05332002571e-09 ,
 1.46894823201e-08 , 2.78473505614e-08 , 4.12720249336e-08 , 4.78649315496e-08 ,
 4.34843979637e-08 , 3.09839608563e-08 , 1.7338888096e-08  , 7.63170851084e-09 ,
 2.64597546214e-09 , 7.23653669583e-10 , 1.56312605566e-10 , 2.66919936788e-11 ,
 3.60513370787e-12 , 3.85160648771e-13 , 3.25362431173e-14 , 2.18628283462e-15 ,
 6.83567769725e-16 , 1.69180320942e-14 , 3.93072054702e-13 , 7.15234164759e-12 ,
 1.02013800187e-10 , 1.1420137259e-09  , 1.00485763763e-08 , 6.95993057067e-08 ,
 3.80022582411e-07 , 1.63794263477e-06 , 5.57885392513e-06 , 1.50266876736e-05 ,
 3.20166105838e-05 , 5.39505033226e-05 , 7.18522833933e-05 , 7.55549038053e-05 ,
 6.26464293565e-05 , 4.08988270671e-05 , 2.09922297375e-05 , 8.45889200365e-06 ,
 2.6723782591e-06  , 6.61146644674e-07 , 1.27958265109e-07 , 1.93567921565e-08 ,
 2.28707465447e-09 , 2.10937147212e-10 , 1.51790288876e-11 , 8.5189549454e-13  ,
 3.7277517519e-14  , 1.27151162405e-15 , 3.3800480668e-17  , 6.95357112453e-19 ,
 0, 0, 2.05025274629e-30 , 1.00078379944e-28 , 2.8248506455e-25  ,
 7.70241812691e-24 , 1.65801829492e-22 , 2.81448280829e-21 , 3.76352534041e-20 ,
 3.96083431782e-19 , 3.27860775156e-18 , 2.13383840797e-17 , 1.09214468386e-16 ,
 4.40181579886e-16 , 1.40620461235e-15 , 3.70301673179e-15 , 1.10429862857e-14 ,
 1.01643527344e-13 , 1.90602662692e-12 , 3.28824905462e-11 , 4.54280192765e-10 ,
 4.93225219888e-09 , 4.19379428816e-08 , 2.79148639186e-07 , 1.45536990308e-06 ,
 5.94905948477e-06 , 1.90895781661e-05 , 4.81529266199e-05 , 9.56238751974e-05 ,
 0.000149712540466 , 0.000185042533696 , 0.000180746296419 , 0.000139622784817 ,
 8.53192775595e-05 , 4.1235140892e-05  , 1.57548520532e-05 , 4.75742002945e-06 ,
 1.13714099203e-06 , 2.17055788295e-07 , 3.42033205137e-08 , 4.90168420646e-09 ,
 7.55837761929e-10 , 1.336262139e-10   , 2.34786783067e-11 , 3.54435111526e-12 ,
 4.31544366473e-13 , 4.15660907019e-14 , 3.15279010976e-15 , 1.88270526837e-16 ,
 3.78572363562e-16 , 1.79420974077e-14 , 6.746255169e-13   , 1.97666918296e-11 ,
 4.51385417938e-10 , 8.03508286533e-09 , 1.11525066639e-07 , 1.20734775965e-06 ,
 1.01986656738e-05 , 6.72544237944e-05 , 0.00034644177933  , 0.0013950658941   ,
 0.00439543689372  , 0.0108469870714   , 0.0209914161351   , 0.0318997536581   ,
 0.0381221959052   , 0.0358807326404   , 0.0266354822532   , 0.015614369681    ,
 0.0072356140699   , 0.00265194206148  , 0.000768847380274 , 0.000176257102456 ,
 3.19255353009e-05 , 4.56373111119e-06 , 5.14159767981e-07 , 4.55859062977e-08 ,
 3.17594998289e-09 , 1.73626393726e-10 , 7.438754038e-12   , 2.49480640139e-13 ,
 6.5434267583e-15  , 1.28131398606e-16 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 2.48635678525e-25 , 1.20110234825e-23 , 4.51041640596e-22 ,
 1.31945439177e-20 , 3.00689770111e-19 , 5.33886583199e-18 , 7.38693407079e-17 ,
 7.96702619115e-16 , 6.70167406944e-15 , 4.40130609925e-14 , 2.26154048127e-13 ,
 9.13124271499e-13 , 2.92305043715e-12 , 7.55241081222e-12 , 1.62709711639e-11 ,
 3.06645914505e-11 , 5.28912278241e-11 , 8.42639974052e-11 , 1.19846724403e-10 ,
 1.45108195942e-10 , 1.44282950938e-10 , 1.15388094695e-10 , 7.34213625009e-11 ,
 3.69606064629e-11 , 1.46741673387e-11 , 4.59376051486e-12 , 1.25896630853e-12 ,
 2.03273663576e-12 , 1.95917151267e-11 , 1.64323929507e-10 , 1.07619065877e-09 ,
 5.49592893291e-09 , 2.18921378618e-08 , 6.80468241116e-08 , 1.65127998434e-07 ,
 3.13038755191e-07 , 4.6394874374e-07  , 5.38061190295e-07 , 4.88818560272e-07 ,
 3.48298144772e-07 , 1.94910605015e-07 , 8.57898681222e-08 , 2.97440455999e-08 ,
 8.13476468494e-09 , 1.75714753758e-09 , 3.00051111015e-10 , 4.05261737817e-11 ,
 4.32968334902e-12 , 3.65745905047e-13 , 2.44846979492e-14 , 4.19270563552e-15 ,
 8.64389431949e-14 , 2.00763948976e-12 , 3.65310038635e-11 , 5.21041458855e-10 ,
 5.83290198661e-09 , 5.13236923327e-08 , 3.55482529953e-07 , 1.94098759554e-06 ,
 8.36588793257e-06 , 2.8494323146e-05  , 7.67496873252e-05 , 0.000163526713597 ,
 0.00027555535531  , 0.000366989745432 , 0.000385901096029 , 0.000319970306802 ,
 0.000208893154469 , 0.000107219042786 , 4.32042863003e-05 , 1.36493284651e-05 ,
 3.37684520747e-06 , 6.53554332869e-07 , 9.88659495623e-08 , 1.16813677393e-08 ,
 1.07737383284e-09 , 7.75277789973e-11 , 4.35110612929e-12 , 1.90397103871e-13 ,
 6.49432008542e-15 , 1.72637934523e-16 , 3.55157717517e-18 , 0,
 1.69484619324e-30 , 1.86643648301e-28 , 8.18740873952e-27 , 1.17328530977e-23 ,
 3.15639489568e-22 , 6.71230402005e-21 , 1.12725299283e-19 , 1.49345984075e-18 ,
 1.55945222449e-17 , 1.28239060194e-16 , 8.30085846903e-16 , 4.22908385376e-15 ,
 1.69715901545e-14 , 5.38384737263e-14 , 1.3722600601e-13  , 3.09171870566e-13 ,
 1.05430994629e-12 , 1.10169759745e-11 , 1.67416559962e-10 , 2.2387011929e-09  ,
 2.40284523826e-08 , 2.03244247311e-07 , 1.34866481014e-06 , 7.01466122841e-06 ,
 2.86089360318e-05 , 9.15815883265e-05 , 0.000230395235686 , 0.000456153209587 ,
 0.000711782150911 , 0.000876538500901 , 0.000852859371769 , 0.000656173411276 ,
 0.000399369332    , 0.00019229759302  , 7.32563871927e-05 , 2.21101448467e-05 ,
 5.32557407461e-06 , 1.05268782599e-06 , 1.85977010628e-07 , 3.46298265909e-08 ,
 7.45636912498e-09 , 1.63741588394e-09 , 3.13406299127e-10 , 4.85867625662e-11 ,
 5.96064598688e-12 , 5.75314222224e-13 , 4.36608788018e-14 , 2.60763239635e-15 ,
 4.57461824728e-16 , 1.62485328247e-14 , 6.10787165158e-13 , 1.78962089271e-11 ,
 4.08671709682e-10 , 7.27473888504e-09 , 1.00971670428e-07 , 1.09309883197e-06 ,
 9.23358613674e-06 , 6.08902708495e-05 , 0.000313658679784 , 0.00126305357109  ,
 0.00397950540442  , 0.00982055816426  , 0.0190050399939   , 0.0288811431381   ,
 0.0345147679971   , 0.0324854099625   , 0.0241150193118   , 0.014136812798    ,
 0.0065509222386   , 0.00240099403563  , 0.000696092875167 , 0.000159578241879 ,
 2.8904485115e-05  , 4.13187427334e-06 , 4.65505847288e-07 , 4.1272202255e-08  ,
 2.8754161251e-09  , 1.57196471906e-10 , 6.73483947378e-12 , 2.2587278119e-13  ,
 5.9242352416e-15  , 1.16006578085e-16 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 5.67062681249e-24 , 2.73935080878e-22 , 1.02868943654e-20 ,
 3.00924939898e-19 , 6.85769098683e-18 , 1.21758354067e-16 , 1.68458782965e-15 ,
 1.81669525663e-14 , 1.52783127555e-13 , 1.00293245022e-12 , 5.14824326923e-12 ,
 2.07419537766e-11 , 6.60963784845e-11 , 1.69198065743e-10 , 3.58232577801e-10 ,
 6.56603270981e-10 , 1.09398970161e-09 , 1.68870342329e-09 , 2.3506613446e-09  ,
 2.81256920812e-09 , 2.7805147248e-09  , 2.21796207044e-09 , 1.40990252968e-09 ,
 7.0970677119e-10  , 2.81980665782e-10 , 8.83715090213e-11 , 2.29647540851e-11 ,
 2.02997879654e-11 , 1.73591814082e-10 , 1.45295769564e-09 , 9.51540937894e-09 ,
 4.85936070858e-08 , 1.93564718193e-07 , 6.0165272179e-07  , 1.46001978781e-06 ,
 2.76780910123e-06 , 4.10211685975e-06 , 4.75740027334e-06 , 4.3220094558e-06  ,
 3.07956366122e-06 , 1.72335002468e-06 , 7.58532206776e-07 , 2.62989290474e-07 ,
 7.19255215462e-08 , 1.55362518731e-08 , 2.65297565279e-09 , 3.58322127119e-10 ,
 3.8281959598e-11  , 3.23382497101e-12 , 2.16116009906e-13 , 2.29478198241e-14 ,
 3.44636172451e-13 , 7.99854457745e-12 , 1.45541346312e-10 , 2.07585522633e-09 ,
 2.32385731841e-08 , 2.04476156652e-07 , 1.41626017494e-06 , 7.73299163809e-06 ,
 3.33301158526e-05 , 0.000113522808249 , 0.000305774592108 , 0.000651498603987 ,
 0.00109782631447  , 0.00146210549682  , 0.00153744926324  , 0.00127477770215  ,
 0.000832240772933 , 0.000427166027859 , 0.000172128037015 , 5.43796071284e-05 ,
 1.34535201629e-05 , 2.60379314259e-06 , 3.93886886766e-07 , 4.65391531906e-08 ,
 4.29231122321e-09 , 3.08874548238e-10 , 1.73350243925e-11 , 7.58551582473e-13 ,
 2.58736959634e-14 , 6.87798163758e-16 , 1.41496610596e-17 , 0,
 8.26420079744e-29 , 7.990498376e-27   , 3.45023269434e-25 , 3.84319606725e-22 ,
 1.01977999993e-20 , 2.14113906937e-19 , 3.5545868415e-18  , 4.66173315174e-17 ,
 4.82518736371e-16 , 3.93846442207e-15 , 2.53347225998e-14 , 1.28398806154e-13 ,
 5.12878599009e-13 , 1.61807443156e-12 , 4.06881808616e-12 , 8.50813803855e-12 ,
 1.82815471864e-11 , 7.82653876873e-11 , 7.82103124975e-10 , 9.22510110707e-09 ,
 9.484967354e-08   , 7.88434949167e-07 , 5.18848767677e-06 , 2.68575786092e-05 ,
 0.000109165366968 , 0.000348424893638 , 0.000873971923076 , 0.00172493418726  ,
 0.00268240541917  , 0.00329108092435  , 0.0031895774997   , 0.00244404424519  ,
 0.00148161254819  , 0.000710945768871 , 0.000270416580497 , 8.20234895213e-05 ,
 2.03025870462e-05 , 4.4135245699e-06  , 9.86623829709e-07 , 2.56197092561e-07 ,
 6.99013854123e-08 , 1.69376221771e-08 , 3.34449049616e-09 , 5.23129078533e-10 ,
 6.43337885297e-11 , 6.21320541269e-12 , 4.71571615788e-13 , 2.81636800032e-14 ,
 1.5629890452e-15  , 1.1575727197e-14  , 4.33407612501e-13 , 1.2698906426e-11  ,
 2.89987885622e-10 , 5.16205574729e-09 , 7.16481237171e-08 , 7.75648060651e-07 ,
 6.55202710894e-06 , 4.32069078437e-05 , 0.000222567932162 , 0.000896245631464 ,
 0.00282380289779  , 0.0069685344745   , 0.0134857178351   , 0.0204936662717   ,
 0.0244912098319   , 0.0230512049779   , 0.017111689643    , 0.0100312900443   ,
 0.00464844530177  , 0.00170371270457  , 0.000493938034572 , 0.000113234549535 ,
 2.05102294211e-05 , 2.93192177435e-06 , 3.30316616495e-07 , 2.92861932532e-08 ,
 2.04035616522e-09 , 1.11544477964e-10 , 4.77895046985e-12 , 1.60276252759e-13 ,
 4.20375673415e-15 , 8.23166896556e-17 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 1.00780739945e-22 , 4.8684886794e-21  , 1.82822987774e-19 ,
 5.3481270747e-18  , 1.21875923107e-16 , 2.16387110104e-15 , 2.99371498882e-14 ,
 3.22823328883e-13 , 2.71447070406e-12 , 1.78124597077e-11 , 9.13631711061e-11 ,
 3.67476351352e-10 , 1.16680486974e-09 , 2.96482443951e-09 , 6.18856692472e-09 ,
 1.1077171409e-08  , 1.78875575062e-08 , 2.67841102424e-08 , 3.64776894282e-08 ,
 4.31062934806e-08 , 4.23558390399e-08 , 3.36967445968e-08 , 2.14023160854e-08 ,
 1.07774746203e-08 , 4.28941622278e-09 , 1.3489507338e-09  , 3.43690704353e-10 ,
 1.78288778499e-10 , 1.2150837977e-09  , 1.01204016917e-08 , 6.62730798223e-08 ,
 3.384450556e-07   , 1.34814070688e-06 , 4.19039447188e-06 , 1.01687545423e-05 ,
 1.92772533668e-05 , 2.85704480163e-05 , 3.31343698508e-05 , 3.01019572832e-05 ,
 2.14485633891e-05 , 1.20027985495e-05 , 5.28302964624e-06 , 1.83166938174e-06 ,
 5.00947302244e-07 , 1.0820697988e-07  , 1.84774606789e-08 , 2.49564409205e-09 ,
 2.66626420956e-10 , 2.25229402333e-11 , 1.50403136768e-12 , 1.1516498003e-13  ,
 1.07328518658e-12 , 2.48673699123e-11 , 4.52485053019e-10 , 6.45379119261e-09 ,
 7.22482459477e-08 , 6.35712164391e-07 , 4.40312374751e-06 , 2.40417119138e-05 ,
 0.000103622644493 , 0.000352940075367 , 0.000950646916235 , 0.00202549575667  ,
 0.00341311942638  , 0.00454565591006  , 0.00477989812984  , 0.00396325765028  ,
 0.00258741944155  , 0.00132805039263  , 0.00053514252593  , 0.000169065079823 ,
 4.18267174103e-05 , 8.0951393131e-06  , 1.22458622761e-06 , 1.4468926983e-07  ,
 1.33447072883e-08 , 9.60284616068e-10 , 5.3894234207e-11  , 2.35832126441e-12 ,
 8.04407884568e-14 , 2.13835034121e-15 , 4.39910051365e-17 , 0,
 3.11156057053e-27 , 2.69609000612e-25 , 1.14654982835e-23 , 9.96706153367e-21 ,
 2.60761966889e-19 , 5.40173521965e-18 , 8.85645608565e-17 , 1.14850104313e-15 ,
 1.17704390724e-14 , 9.52550013557e-14 , 6.08299171037e-13 , 3.06404678142e-12 ,
 1.21743314404e-11 , 3.82040161672e-11 , 9.52136099353e-11 , 1.93062207625e-10 ,
 3.54271796314e-10 , 8.54318044823e-10 , 4.33457520497e-09 , 3.61469273243e-08 ,
 3.21644838772e-07 , 2.51561424398e-06 , 1.61043300391e-05 , 8.22234205928e-05 ,
 0.000331621936333 , 0.00105302274051  , 0.00263065990813  , 0.00517279436311  ,
 0.00801414150999  , 0.00979453934026  , 0.00945411965101  , 0.00721473753043  ,
 0.00435716690127  , 0.00208577565971  , 0.000795469137319 , 0.000246255471792 ,
 6.58146624565e-05 , 1.75796952598e-05 , 5.44320767322e-06 , 1.82985120184e-06 ,
 5.59723756673e-07 , 1.40739120545e-07 , 2.8086890312e-08  , 4.40586584128e-09 ,
 5.42208116301e-10 , 5.23700633296e-11 , 3.97446953531e-12 , 2.37334841917e-13 ,
 1.13000445273e-14 , 6.83328375981e-15 , 2.41357816244e-13 , 7.07148675771e-12 ,
 1.61482047975e-10 , 2.8745315758e-09  , 3.98978244433e-08 , 4.31925758109e-07 ,
 3.6485481235e-06  , 2.40601084083e-05 , 0.000123938713583 , 0.000499081469369 ,
 0.0015724569805   , 0.00388048354467  , 0.0075096286513   , 0.0114120601725   ,
 0.0136381239254   , 0.0128362458317   , 0.00952877973467  , 0.00558600321075  ,
 0.00258852353645  , 0.000948725896257 , 0.000275053301703 , 6.30555546172e-05 ,
 1.14212834933e-05 , 1.63266383215e-06 , 1.83939420768e-07 , 1.63082483729e-08 ,
 1.13618847024e-09 , 6.21144248942e-11 , 2.66119637162e-12 , 8.92510991672e-14 ,
 2.34089519e-15    , 4.58386997767e-17 , 0, 0, 0, 0, 0, 0, 6.74203333994e-32 ,
 4.24550566808e-30 , 1.71659541742e-28 , 5.44882711596e-27 , 1.36913361108e-25 ,
 2.7286424264e-24  , 4.32063289829e-23 , 5.44366920165e-22 , 5.46414467496e-21 ,
 4.51380269116e-20 , 3.46971881378e-19 , 3.95978341848e-18 , 7.99092388935e-17 ,
 1.70721105404e-15 , 3.00220781779e-14 , 4.14757068189e-13 , 4.47124932475e-12 ,
 3.75904667728e-11 , 2.46598976572e-10 , 1.26407429484e-09 , 5.07758933512e-09 ,
 1.60768228919e-08 , 4.0611202977e-08  , 8.37978180935e-08 , 1.47040031186e-07 ,
 2.30975509454e-07 , 3.36144620141e-07 , 4.48065030217e-07 , 5.22846247001e-07 ,
 5.10557117165e-07 , 4.05141820661e-07 , 2.57211214379e-07 , 1.29686341134e-07 ,
 5.17946158421e-08 , 1.6405104727e-08  , 4.18608952818e-09 , 1.45809450569e-09 ,
 6.75925537736e-09 , 5.5615129362e-08  , 3.64112812164e-07 , 1.85945218679e-06 ,
 7.40682388873e-06 , 2.30224587358e-05 , 5.58681845819e-05 , 0.00010591121507  ,
 0.00015696898344  , 0.000182043639969 , 0.00016538325306  , 0.000117840615923 ,
 6.59446112179e-05 , 2.90255088959e-05 , 1.00633801993e-05 , 2.75225606352e-06 ,
 5.94500290064e-07 , 1.01517071685e-07 , 1.37113256304e-08 , 1.46487301256e-09 ,
 1.23743295453e-10 , 8.26039847633e-12 , 5.22291023806e-13 , 2.61533521157e-12 ,
 6.03626807796e-11 , 1.09834945548e-09 , 1.56657505934e-08 , 1.75373353125e-07 ,
 1.54310976591e-06 , 1.06880183137e-05 , 5.83581729615e-05 , 0.000251530682663 ,
 0.000856716777788 , 0.00230757349401  , 0.00491663123342  , 0.00828490976586  ,
 0.0110339968624   , 0.0116025898155   , 0.00962029976381  , 0.00628062892674  ,
 0.00322367204101  , 0.00129898986392  , 0.000410383803177 , 0.000101528993351 ,
 1.96499126965e-05 , 2.97252604696e-06 , 3.51214649968e-07 , 3.23925658389e-08 ,
 2.33096777458e-09 , 1.30821343037e-10 , 5.72452247745e-12 , 1.9525969959e-13  ,
 5.19057126681e-15 , 1.06782524294e-16 , 0, 9.13251259435e-26 ,
 7.19898357299e-24 , 3.01657698501e-22 , 2.04702304083e-19 , 5.28064985272e-18 ,
 1.07891312225e-16 , 1.74588975363e-15 , 2.23677659007e-14 , 2.26746766839e-13 ,
 1.81744365893e-12 , 1.15102248249e-11 , 5.7568614528e-11  , 2.27351416738e-10 ,
 7.09435054941e-10 , 1.75519432727e-09 , 3.49448793732e-09 , 5.96756805002e-09 ,
 1.10202641744e-08 , 3.32847390459e-08 , 1.70358618902e-07 , 1.09901594714e-06 ,
 7.20817739933e-06 , 4.22270434938e-05 , 0.000206191546157 , 0.000812423892037 ,
 0.00254612763226  , 0.00630865371966  , 0.0123316391862   , 0.0190112867448   ,
 0.0231295523383   , 0.0222283475707   , 0.0168941464626   , 0.0101721200823   ,
 0.00487364261523  , 0.00188617980508  , 0.000620097062692 , 0.000197404326144 ,
 7.2004702819e-05  , 2.94815686843e-05 , 1.13294612152e-05 , 3.62338646223e-06 ,
 9.22811335695e-07 , 1.84792399909e-07 , 2.90104721169e-08 , 3.57040153846e-09 ,
 3.44802737965e-10 , 2.61620587662e-11 , 1.56186532106e-12 , 7.35302621303e-14 ,
 5.53610151492e-15 , 1.05697878182e-13 , 3.09463234478e-12 , 7.06679240943e-11 ,
 1.25795518265e-09 , 1.74601230536e-08 , 1.89019752125e-07 , 1.59668102439e-06 ,
 1.0529207027e-05  , 5.42381751499e-05 , 0.000218408496967 , 0.000688140086808 ,
 0.0016981808192   , 0.00328637067729  , 0.00499415639041  , 0.00596832848106  ,
 0.00561740984365  , 0.004169993453    , 0.00244455192227  , 0.00113279207837  ,
 0.000415182309408 , 0.000120369081799 , 2.7594430478e-05  , 4.99819270861e-06 ,
 7.14487865247e-07 , 8.04957404523e-08 , 7.13683082602e-09 , 4.97219855448e-10 ,
 2.71825724131e-11 , 1.16459523211e-12 , 3.90581490562e-14 , 1.024424731e-15   ,
 2.00599744443e-17 , 0, 0, 0, 0, 0, 0, 3.58526374902e-30 , 2.30655623198e-28 ,
 9.36291109174e-27 , 2.98543125175e-25 , 7.53710565614e-24 , 1.5092561448e-22  ,
 2.40055146509e-21 , 3.0364543414e-20  , 3.05736383032e-19 , 2.4675315025e-18  ,
 1.64123486708e-17 , 1.07382178081e-16 , 1.12614272521e-15 , 1.92917268656e-14 ,
 3.26404561246e-13 , 4.48297499639e-12 , 4.8283410909e-11  , 4.05829033183e-10 ,
 2.66165315717e-09 , 1.36371620543e-08 , 5.47218045054e-08 , 1.72878173311e-07 ,
 4.34673660511e-07 , 8.88640899433e-07 , 1.53385382092e-06 , 2.35260343817e-06 ,
 3.33614254792e-06 , 4.35663346785e-06 , 5.02122669048e-06 , 4.8736151144e-06  ,
 3.85894463524e-06 , 2.45085439262e-06 , 1.23930896797e-06 , 4.98259757259e-07 ,
 1.59917027328e-07 , 4.16040509545e-08 , 1.14960270054e-08 , 3.03131490348e-08 ,
 2.41496525151e-07 , 1.58002298858e-06 , 8.06874265522e-06 , 3.21405053582e-05 ,
 9.99015855848e-05 , 0.000242429372369 , 0.000459581595287 , 0.000681137080451 ,
 0.000789943788416 , 0.000717649204801 , 0.00051134696377  , 0.000286154111289 ,
 0.000125950681176 , 4.36681263912e-05 , 1.19428922751e-05 , 2.57972105715e-06 ,
 4.40514044925e-07 , 5.94976925014e-08 , 6.35653812068e-09 , 5.36960408962e-10 ,
 3.58388131645e-11 , 2.0528412205e-12  , 5.00382704777e-12 , 1.14473704198e-10 ,
 2.08291862292e-09 , 2.9708653209e-08  , 3.3257941258e-07  , 2.92636555296e-06 ,
 2.02688423816e-05 , 0.000110670900322 , 0.000477004774074 , 0.00162468446675  ,
 0.00437610060736  , 0.00932393831987  , 0.0157115683433   , 0.020924958835    ,
 0.0220032430042   , 0.018244012487    , 0.0119106343231   , 0.00611339713045  ,
 0.00246341464191  , 0.000778255086997 , 0.000192540385223 , 3.72642497016e-05 ,
 5.6371218829e-06  , 6.66046237325e-07 , 6.14295178071e-08 , 4.42046570587e-09 ,
 2.48090628622e-10 , 1.08560296586e-11 , 3.70292037149e-13 , 9.84344036373e-15 ,
 2.02503222814e-16 , 0, 2.09000947441e-24 , 1.52024224339e-22 ,
 6.28230070269e-21 , 3.33572641062e-18 , 8.47734624791e-17 , 1.70767450017e-15 ,
 2.72617143641e-14 , 3.44844681058e-13 , 3.45502421927e-12 , 2.74029624699e-11 ,
 1.71948287244e-10 , 8.53139150033e-10 , 3.34608460471e-09 , 1.03771135453e-08 ,
 2.55009983679e-08 , 5.01228089324e-08 , 8.20373236453e-08 , 1.30656436724e-07 ,
 2.88495163584e-07 , 1.02575556317e-06 , 4.62683805627e-06 , 2.23945860225e-05 ,
 0.00010630021953  , 0.000457255959388 , 0.00167728885486  , 0.00505147182794  ,
 0.0122349906458   , 0.0235879246866   , 0.0360308965835   , 0.0435371775937   ,
 0.0416144731704   , 0.0315033637257   , 0.0189575782923   , 0.00917705984378  ,
 0.00371973938546  , 0.00141237285066  , 0.000599996825328 , 0.000294528475311 ,
 0.000141036465399 , 5.72106855322e-05 , 1.85829487876e-05 , 4.75175390788e-06 ,
 9.52328782363e-07 , 1.49502153938e-07 , 1.83948768011e-08 , 1.77583595854e-09 ,
 1.34690240246e-10 , 8.03751150299e-12 , 3.77937410929e-13 , 1.49879844694e-14 ,
 3.67885230059e-14 , 1.06588277294e-12 , 2.43399173216e-11 , 4.33273304803e-10 ,
 6.01373190379e-09 , 6.51034422901e-08 , 5.49939515565e-07 , 3.62653962994e-06 ,
 1.86810736198e-05 , 7.52257095607e-05 , 0.000237013793077 , 0.000584898750997 ,
 0.00113191368241  , 0.00172012061495  , 0.00205565145632  , 0.00193478572141  ,
 0.00143625692549  , 0.000841968858618 , 0.000390163794267 , 0.000142999856942 ,
 4.14583210494e-05 , 9.50425757872e-06 , 1.72151083054e-06 , 2.4608867045e-07  ,
 2.77248791874e-08 , 2.4581148185e-09  , 1.71255775081e-10 , 9.36240268019e-12 ,
 4.01117648349e-13 , 1.34526679024e-14 , 3.52839190545e-16 , 6.9091900372e-18  ,
 0, 0, 0, 0, 0, 0, 1.38125317692e-28 , 8.93658205304e-27 , 3.63132128577e-25 ,
 1.15922781036e-23 , 2.93019135425e-22 , 5.87465523733e-21 , 9.35467087115e-20 ,
 1.18446264655e-18 , 1.19356903793e-17 , 9.59190697514e-17 , 6.1887708434e-16  ,
 3.35671861306e-15 , 1.94729821067e-14 , 1.94968425566e-13 , 2.83303023829e-12 ,
 3.79214153928e-11 , 4.06800569688e-10 , 3.41684492958e-09 , 2.24035366017e-08 ,
 1.14741534987e-07 , 4.60050618379e-07 , 1.4508749781e-06  , 3.63459671724e-06 ,
 7.37566524784e-06 , 1.25605826626e-05 , 1.88786814843e-05 , 2.61610772113e-05 ,
 3.35207318622e-05 , 3.81854970417e-05 , 3.68591967999e-05 , 2.9145808291e-05  ,
 1.85462411063e-05 , 9.43276409145e-06 , 3.83858953783e-06 , 1.26080770085e-06 ,
 3.41027127826e-07 , 8.68307267097e-08 , 1.1397417674e-07  , 8.30302050068e-07 ,
 5.42045690653e-06 , 2.76792772567e-05 , 0.000110255674746 , 0.00034270513624  ,
 0.000831636359699 , 0.00157656129334  , 0.00233659129845  , 0.00270984480988  ,
 0.00246184348995  , 0.0017541386313   , 0.00098163090168  , 0.00043206466674  ,
 0.000149800336927 , 4.09692247994e-05 , 8.84954577799e-06 , 1.51115144624e-06 ,
 2.04102514114e-07 , 2.1805642487e-08  , 1.84200352722e-09 , 1.22933954193e-10 ,
 6.71925237447e-12 , 7.5718688126e-12  , 1.69739164807e-10 , 3.08841678364e-09 ,
 4.40500643616e-08 , 4.93127185054e-07 , 4.33902506586e-06 , 3.00533250403e-05 ,
 0.000164095633941 , 0.000707271745031 , 0.00240897676581  , 0.00648859818857  ,
 0.0138249310793   , 0.0232960946374   , 0.0310261719679   , 0.0326249818068   ,
 0.0270510385836   , 0.0176603161645   , 0.00906454880858  , 0.00365259147752  ,
 0.00115394617282  , 0.000285486396882 , 5.52530128549e-05 , 8.35835875817e-06 ,
 9.87570167319e-07 , 9.10837052736e-08 , 6.55437987955e-09 , 3.67852695336e-10 ,
 1.60966167596e-11 , 5.49045019086e-13 , 1.459521502e-14   , 3.00258646371e-16 ,
 1.01493888379e-25 , 3.96719581175e-23 , 2.57993729365e-21 , 1.04123953668e-19 ,
 4.31738514215e-17 , 1.07933122549e-15 , 2.14290382768e-14 , 3.37444538147e-13 ,
 4.21316134183e-12 , 4.16987467948e-11 , 3.27036576606e-10 , 2.03154254697e-09 ,
 9.9908633998e-09  , 3.88846024276e-08 , 1.1977691885e-07  , 2.92375883157e-07 ,
 5.68933380122e-07 , 9.05663850612e-07 , 1.31067466284e-06 , 2.3182520633e-06  ,
 6.4343897319e-06  , 2.30368758999e-05 , 8.58756613305e-05 , 0.000311076589468 ,
 0.00106139194413  , 0.00329026719455  , 0.0088872289144   , 0.0201510305952   ,
 0.0373563822358   , 0.0557316888867   , 0.0663634776456   , 0.0628661949859   ,
 0.0474199502055   , 0.0287236475352   , 0.0144076620404   , 0.00655688326517  ,
 0.0032164151361   , 0.0018531534877   , 0.00108985394805  , 0.000557183737631 ,
 0.000230258622137 , 7.51283170037e-05 , 1.92240593095e-05 , 3.85180743306e-06 ,
 6.04383418668e-07 , 7.43227829794e-08 , 7.17083833562e-09 , 5.43529597271e-10 ,
 3.24117073337e-11 , 1.52280009607e-12 , 5.67101806242e-14 , 1.152858283e-14   ,
 2.89400031766e-13 , 6.60776612021e-12 , 1.17624406097e-10 , 1.63259911611e-09 ,
 1.76741865759e-08 , 1.49296767033e-07 , 9.84527610747e-07 , 5.07151018658e-06 ,
 2.04221641014e-05 , 6.43441530168e-05 , 0.000158787445233 , 0.0003072902471   ,
 0.000466975792228 , 0.000558065207035 , 0.000525252756588 , 0.000389912898809 ,
 0.000228576456292 , 0.000105921087878 , 3.88213889548e-05 , 1.12550434754e-05 ,
 2.58020174338e-06 , 4.67353205594e-07 , 6.68077870637e-08 , 7.52670905868e-09 ,
 6.67325363138e-10 , 4.64922636791e-11 , 2.54169118601e-12 , 1.08894823924e-13 ,
 3.65211031868e-15 , 9.57882598434e-17 , 1.87569665821e-18 , 0, 0, 0, 0, 0, 0,
 4.17130052224e-27 , 2.71661890105e-25 , 1.10518867918e-23 , 3.53285327114e-22 ,
 8.94254193472e-21 , 1.79536060427e-19 , 2.86263310485e-18 , 3.62873140768e-17 ,
 3.65991860407e-16 , 2.93989485771e-15 , 1.88445334371e-14 , 9.74433732856e-14 ,
 4.34865045199e-13 , 2.27928518943e-12 , 2.12074484897e-11 , 2.54480459223e-10 ,
 2.68068932639e-09 , 2.24503495689e-08 , 1.4711563827e-07  , 7.53191256183e-07 ,
 3.01794929112e-06 , 9.50482593451e-06 , 2.3741705104e-05  , 4.78953605423e-05 ,
 8.06775715593e-05 , 0.000119219412191 , 0.000161929300723 , 0.000203972313888 ,
 0.000229920326698 , 0.000220941211693 , 0.00017473423389  , 0.000111702432549 ,
 5.74285776035e-05 , 2.38666902222e-05 , 8.14236470338e-06 , 2.3418547379e-06  ,
 6.08965783187e-07 , 3.96492122295e-07 , 2.27065857651e-06 , 1.47105671584e-05 ,
 7.51035343549e-05 , 0.000299160418022 , 0.000929873172812 , 0.00225650640276  ,
 0.00427773582496  , 0.00633995033727  , 0.00735271141629  , 0.0066798012445   ,
 0.00475956227931  , 0.00266349154421  , 0.00117233532934  , 0.000406458201388 ,
 0.00011116315067  , 2.40117648186e-05 , 4.10025712536e-06 , 5.53798092097e-07 ,
 5.91659698986e-08 , 4.99796880449e-09 , 3.335507181e-10   , 1.78498609795e-11 ,
 9.20336054459e-12 , 1.96974376702e-10 , 3.58371601347e-09 , 5.11145084143e-08 ,
 5.72211505522e-07 , 5.0348878356e-06  , 3.48730690346e-05 , 0.000190412154497 ,
 0.000820699085963 , 0.00279531176482  , 0.00752919459876  , 0.0160420777162   ,
 0.0270321608487   , 0.0360019344105   , 0.0378571502912   , 0.0313892966825   ,
 0.0204925552814   , 0.0105182583273   , 0.00423836878549  , 0.00133900806294  ,
 0.000331270726735 , 6.4114108142e-05  , 9.6988144107e-06  , 1.14594982669e-06 ,
 1.05691078697e-07 , 7.60552590146e-09 , 4.26846361321e-10 , 1.86780806027e-11 ,
 6.37097054254e-13 , 1.69358944571e-14 , 3.48412047383e-16 , 4.89338438727e-24 ,
 6.33653159858e-22 , 3.54967188284e-20 , 1.37786558287e-18 , 4.48764532741e-16 ,
 1.09404556596e-14 , 2.13507934574e-13 , 3.31393841812e-12 , 4.08295898926e-11 ,
 3.99078749375e-10 , 3.09366380689e-09 , 1.90143288914e-08 , 9.26232696601e-08 ,
 3.5747718054e-07  , 1.09303314757e-06 , 2.6497125946e-06  , 5.11213489623e-06 ,
 7.98281115303e-06 , 1.08341569153e-05 , 1.6147354454e-05  , 3.62518812923e-05 ,
 0.00011130174951  , 0.000357752466144 , 0.00107921082352  , 0.00296497267678  ,
 0.00735453575453  , 0.0163441925967   , 0.0319741397453   , 0.0536273429975   ,
 0.0751013301231   , 0.0861058400426   , 0.0799569040323   , 0.0601258861743   ,
 0.0373429541486   , 0.0205104102761   , 0.0115674079563   , 0.00760060972359  ,
 0.00534245806329  , 0.00339234448354  , 0.00177138952457  , 0.000735155476187 ,
 0.000239858827481 , 6.13196132696e-05 , 1.227382719e-05   , 1.92399784405e-06 ,
 2.36372390379e-07 , 2.27831744986e-08 , 1.72507253194e-09 , 1.02750866499e-10 ,
 4.82147176859e-12 , 1.78538920231e-13 , 7.33491966677e-15 , 6.21248696705e-14 ,
 1.41588680617e-12 , 2.5203850995e-11  , 3.49821537191e-10 , 3.78708387803e-09 ,
 3.19900548937e-08 , 2.10956024944e-07 , 1.08667832172e-06 , 4.3758785738e-06  ,
 1.37870854743e-05 , 3.40235376345e-05 , 6.58433682461e-05 , 0.000100059333063 ,
 0.00011957714151  , 0.000112546385343 , 8.35469899796e-05 , 4.89772839399e-05 ,
 2.26958071574e-05 , 8.31829404911e-06 , 2.41162831998e-06 , 5.52862155078e-07 ,
 1.00140192963e-07 , 1.43149648267e-08 , 1.61275475234e-09 , 1.42988411279e-10 ,
 9.96194008741e-12 , 5.44610597911e-13 , 2.33330096932e-14 , 7.82542771832e-16 ,
 2.05247826607e-17 , 4.01916558967e-19 , 4.7355701327e-25  , 1.89714379587e-26 ,
 6.00260349266e-28 , 1.49813732178e-29 , 2.36758585547e-31 , 0,
 9.8874494587e-26  , 6.49025233475e-24 , 2.64411338352e-22 , 8.46567380492e-21 ,
 2.14641917187e-19 , 4.31634629764e-18 , 6.89281673367e-17 , 8.74917498281e-16 ,
 8.83365591712e-15 , 7.09908320291e-14 , 4.54502368484e-13 , 2.32493592909e-12 ,
 9.65626428084e-12 , 3.58226693653e-11 , 1.71479481942e-10 , 1.4352124094e-09  ,
 1.3958556748e-08  , 1.15355293751e-07 , 7.54227693321e-07 , 3.85923633688e-06 ,
 1.54551146936e-05 , 4.86227898227e-05 , 0.000121176489102 , 0.000243312349095 ,
 0.000406246749373 , 0.000591953756856 , 0.000790392213675 , 0.000980920929138 ,
 0.00109586994745  , 0.00105014249627  , 0.000832825091119 , 0.000537325142108 ,
 0.00028152322235  , 0.000121109978316 , 4.37618832319e-05 , 1.36793893916e-05 ,
 3.83052795218e-06 , 1.49475292363e-06 , 5.01299504625e-06 , 3.15977327871e-05 ,
 0.000161195441369 , 0.000642076603148 , 0.00199574980235  , 0.00484304966196  ,
 0.00918113363594  , 0.0136071822884   , 0.0157808309484   , 0.0143365907111   ,
 0.0102152584878   , 0.00571654555759  , 0.00251613651018  , 0.000872365009205 ,
 0.000238585031933 , 5.15354921254e-05 , 8.80021815943e-06 , 1.18859473387e-06 ,
 1.26985558906e-07 , 1.07269407102e-08 , 7.15877307819e-10 , 3.79575850713e-11 ,
 9.26836552773e-12 , 1.79095456358e-10 , 3.25789525965e-09 , 4.64673192513e-08 ,
 5.20187624287e-07 , 4.57712981385e-06 , 3.17025064293e-05 , 0.000173100410123 ,
 0.000746083403884 , 0.00254116978084  , 0.00684466113199  , 0.0145835765539   ,
 0.0245744718439   , 0.0327287384996   , 0.0344152833038   , 0.028535468986    ,
 0.0186294290565   , 0.00956196748604  , 0.0038530280641   , 0.00121726916785  ,
 0.000301152512092 , 5.8285031454e-05  , 8.81702513496e-06 , 1.04176325038e-06 ,
 9.60819392919e-08 , 6.91405260459e-09 , 3.88038675364e-10 , 1.69799213773e-11 ,
 5.79173959094e-13 , 1.53961299589e-14 , 3.16735400736e-16 , 2.30287602067e-22 ,
 1.04549189551e-20 , 4.29906293863e-19 , 1.50182926657e-17 , 3.88597304733e-15 ,
 8.95105551689e-14 , 1.69750597195e-12 , 2.58723327295e-11 , 3.14199178096e-10 ,
 3.03183464475e-09 , 2.32250147483e-08 , 1.41187689698e-07 , 6.80928874651e-07 ,
 2.60468259204e-06 , 7.90143341833e-06 , 1.90171601878e-05 , 3.64054111396e-05 ,
 5.60577820395e-05 , 7.2874622789e-05  , 9.54620339007e-05 , 0.000175815578373 ,
 0.000469478683181 , 0.00136980279839  , 0.00373880166169  , 0.00908110525676  ,
 0.0192908200013   , 0.0357631262141   , 0.0581053233747   , 0.0827427532948   ,
 0.102253830156    , 0.10787209462     , 0.0958434760601   , 0.0718781846364   ,
 0.0473400109462   , 0.0304873485523   , 0.0219525924969   , 0.0175031434169   ,
 0.0133350884935   , 0.00863870707488  , 0.00451735047885  , 0.00187006193979  ,
 0.000608470799031 , 0.000155194893691 , 3.10040690944e-05 , 4.85179593804e-06 ,
 5.95103053159e-07 , 5.7266458727e-08  , 4.32858702188e-09 , 2.57348075255e-10 ,
 1.20518194518e-11 , 4.45223224928e-13 , 1.33530011321e-14 , 1.08539920618e-14 ,
 2.40503458646e-13 , 4.27561642028e-12 , 5.9298135047e-11  , 6.41645211056e-10 ,
 5.41852621132e-09 , 3.57258989794e-08 , 1.84012317454e-07 , 7.40941214303e-07 ,
 2.33439539058e-06 , 5.76064939995e-06 , 1.1148027045e-05  , 1.69410363015e-05 ,
 2.02454939311e-05 , 1.90550665736e-05 , 1.41451956527e-05 , 8.29225011872e-06 ,
 3.8425812587e-06  , 1.40835305651e-06 , 4.08307694083e-07 , 9.36039174694e-08 ,
 1.69545255383e-08 , 2.42363793402e-09 , 2.73052744101e-10 , 2.4209250766e-11  ,
 1.68667464645e-12 , 9.22134393693e-14 , 3.95131707449e-15 , 1.32578289233e-16 ,
 3.48210756501e-18 , 6.85025939723e-20 , 2.31367606529e-23 , 9.26894982003e-25 ,
 2.9327155213e-26  , 7.3195082467e-28  , 1.15674070341e-29 , 0,
 1.84217830951e-24 , 1.2205015567e-22  , 4.98046717229e-21 , 1.59755853784e-19 ,
 4.05827769053e-18 , 8.17645728678e-17 , 1.30801739159e-15 , 1.66284614889e-14 ,
 1.68093137907e-13 , 1.3518683209e-12  , 8.65500489375e-12 , 4.4163451311e-11  ,
 1.80370064139e-10 , 6.03430718965e-10 , 1.88087203166e-09 , 8.23064007466e-09 ,
 6.00284761373e-08 , 4.67327841341e-07 , 3.02487426199e-06 , 1.54496781671e-05 ,
 6.18320145573e-05 , 0.000194361085769 , 0.000483520733575 , 0.00096727708128  ,
 0.0016035946889   , 0.00230987957742  , 0.00304033963646  , 0.00372646352559  ,
 0.00413499038828  , 0.00396208118775  , 0.00316460988304  , 0.00207613294136  ,
 0.00112237405451  , 0.000508990621143 , 0.000198873912489 , 6.84896580151e-05 ,
 2.09309131432e-05 , 6.4650740371e-06  , 9.39443816081e-06 , 5.37850309067e-05 ,
 0.000273573636459 , 0.00108960475425  , 0.00338677592545  , 0.00821862344135  ,
 0.0155803218013   , 0.0230912958866   , 0.0267799627162   , 0.0243290968212   ,
 0.0173352240921   , 0.00970093888277  , 0.00426986652329  , 0.00148039747994  ,
 0.00040487717446  , 8.74553791876e-05 , 1.49339102883e-05 , 2.01703716922e-06 ,
 2.1549362871e-07  , 1.82035452035e-08 , 1.2148322065e-09  , 6.41586568973e-11 ,
 8.14841436154e-12 , 1.27762806129e-10 , 2.32319876668e-09 , 3.31357364916e-08 ,
 3.70944575788e-07 , 3.26394054321e-06 , 2.26069830356e-05 , 0.000123437496774 ,
 0.000532030326757 , 0.00181210221512  , 0.00488091181178  , 0.0103995142619   ,
 0.0175239982781   , 0.0233387867196   , 0.0245414578668   , 0.020348576057    ,
 0.0132846021994   , 0.00681861660446  , 0.00274758528239  , 0.000868031790748 ,
 0.000214751150579 , 4.15629193309e-05 , 6.28739996019e-06 , 7.42878932723e-07 ,
 6.85158060298e-08 , 4.93039489119e-09 , 2.76709557462e-10 , 1.21083752225e-11 ,
 4.13017477452e-13 , 1.09812748744e-14 , 2.26296728788e-16 , 7.14960173991e-20 ,
 2.11877427635e-19 , 5.40539620149e-18 , 1.4724122028e-16  , 3.10995426902e-14 ,
 6.1906570841e-13  , 1.09664956945e-11 , 1.61681967189e-10 , 1.92534908399e-09 ,
 1.83109118237e-08 , 1.38540818411e-07 , 8.32821437943e-07 , 3.97574259557e-06 ,
 1.50681949621e-05 , 4.53346547137e-05 , 0.000108305248174 , 0.000205816665881 ,
 0.000313552069279 , 0.00039609478527  , 0.00047324639428  , 0.000730645811128 ,
 0.00168859086999  , 0.00451561489757  , 0.0114743235413   , 0.0259171303869   ,
 0.0506895978568   , 0.0849194763668   , 0.121937174538    , 0.15128375836     ,
 0.163651298747    , 0.15518914495     , 0.129595679559    , 0.0971034801852   ,
 0.0692081910476   , 0.0518774136257   , 0.0430649111897   , 0.03655037904     ,
 0.0280608324977   , 0.0180193459563   , 0.00932914619716  , 0.00383177133856  ,
 0.0012395610351   , 0.000314790139263 , 6.26715459915e-05 , 9.77872715885e-06 ,
 1.19619259289e-06 , 1.14804574102e-07 , 8.6542183039e-09  , 5.13085141003e-10 ,
 2.39626782509e-11 , 8.83352294784e-13 , 2.58873303173e-14 , 3.03318852028e-15 ,
 4.63185778302e-14 , 7.24533429759e-13 , 9.21647370057e-12 , 9.42684120426e-11 ,
 7.68134078858e-10 , 4.95300380051e-09 , 2.51637913003e-08 , 1.00478471781e-07 ,
 3.14957069046e-07 , 7.74834814103e-07 , 1.49667541008e-06 , 2.2718701236e-06  ,
 2.71319129564e-06 , 2.55263251609e-06 , 1.89444961648e-06 , 1.11041426155e-06 ,
 5.14516851879e-07 , 1.88567799244e-07 , 5.46680562347e-08 , 1.25325881188e-08 ,
 2.27013812484e-09 , 3.24567011405e-10 , 3.65845926713e-11 , 3.24846473591e-12 ,
 2.27329932841e-13 , 1.25944138987e-14 , 5.61250714399e-16 , 2.10523586147e-17 ,
 7.33684045995e-19 , 2.63095074136e-20 , 8.71605824874e-22 , 3.49178987275e-23 ,
 1.10480977411e-24 , 2.75739811582e-26 , 4.3576624666e-28  , 0,
 2.70184362413e-23 , 1.80939594572e-21 , 7.39746814252e-20 , 2.37787333702e-18 ,
 6.05368140938e-17 , 1.22228848372e-15 , 1.95924645731e-14 , 2.49505540751e-13 ,
 2.52562200745e-12 , 2.03299183511e-11 , 1.3019501233e-10  , 6.6387459999e-10  ,
 2.69991761095e-09 , 8.81103361436e-09 , 2.38277557365e-08 , 6.30161797283e-08 ,
 2.50014705728e-07 , 1.54614236939e-06 , 9.55824823669e-06 , 4.84340849841e-05 ,
 0.000193539115152 , 0.000607879218726 , 0.00151017697148  , 0.00301234491395  ,
 0.004965685244    , 0.00708569736318  , 0.00921665736582  , 0.0111847666667   ,
 0.0123624439122   , 0.0118945097796   , 0.00963572689131  , 0.00650262197452  ,
 0.00368987839878  , 0.00180009930643  , 0.000771891003541 , 0.000292616743261 ,
 9.65470839019e-05 , 2.81406604845e-05 , 1.71132765251e-05 , 7.29682068678e-05 ,
 0.000366921562505 , 0.00146081590666  , 0.0045404728869   , 0.0110182257229   ,
 0.0208875991052   , 0.0309571010702   , 0.0359022705975   , 0.0326165428476   ,
 0.0232402822356   , 0.0130054596414   , 0.00572435074538  , 0.00198467899894  ,
 0.000542794240175 , 0.000117246115833 , 2.0020986608e-05  , 2.70411924091e-06 ,
 2.88899221383e-07 , 2.44043875033e-08 , 1.62864796857e-09 , 8.58693055286e-11 ,
 6.63622850283e-12 , 7.16321970539e-11 , 1.30130857267e-09 , 1.85605113097e-08 ,
 2.07779320667e-07 , 1.82824979334e-06 , 1.26629794357e-05 , 6.91417549986e-05 ,
 0.000298009206759 , 0.00101502323553  , 0.00273397320423  , 0.00582513973318  ,
 0.00981581793948  , 0.0130728888312   , 0.0137465479377   , 0.0113979649355   ,
 0.00744118063232  , 0.00381935093385  , 0.00153902074613  , 0.000486215639179 ,
 0.000120289797061 , 2.32808770587e-05 , 3.52179752076e-06 , 4.16113069117e-07 ,
 3.83781677161e-08 , 2.76169960002e-09 , 1.54999269917e-10 , 6.78397250899e-12 ,
 2.31833372285e-13 , 6.26552667341e-15 , 1.47980136359e-16 , 3.36170784392e-18 ,
 4.77400327737e-18 , 8.14181736567e-17 , 1.54323684107e-15 , 2.74025314322e-13 ,
 4.08296700193e-12 , 6.10019096444e-11 , 8.28327909466e-10 , 9.48429284123e-09 ,
 8.82687559107e-08 , 6.58036856017e-07 , 3.90870758826e-06 , 1.84651874658e-05 ,
 6.93304767613e-05 , 0.000206848443458 , 0.000490486816337 , 0.000925642553282 ,
 0.00139846674794  , 0.00173404569626  , 0.00194887095921  , 0.00260807721387  ,
 0.00521045885364  , 0.0127278288595   , 0.0302145565205   , 0.0641868728392   ,
 0.118507582424    , 0.187427563506    , 0.252817348628    , 0.292367603146    ,
 0.293617811295    , 0.260709257671    , 0.209528772739    , 0.158191964758    ,
 0.119249692236    , 0.0955807108994   , 0.0812918892101   , 0.0676710359786   ,
 0.050292019909    , 0.0313870918241   , 0.0159104309421   , 0.00643806430408  ,
 0.00206071519732  , 0.000519266980395 , 0.00010276027823  , 1.59543305517e-05 ,
 1.94309310588e-06 , 1.85734930657e-07 , 1.39495844561e-08 , 8.24785149852e-10 ,
 3.85335231846e-11 , 1.43466074682e-12 , 4.44701033883e-14 , 1.59305426806e-14 ,
 2.04862184701e-13 , 2.23114355728e-12 , 1.90705089395e-11 , 1.28441598124e-10 ,
 6.85977945457e-10 , 2.93138391933e-09 , 1.01397848055e-08 , 2.87609381246e-08 ,
 6.7660179183e-08  , 1.3281717592e-07  , 2.17252036483e-07 , 2.93839925487e-07 ,
 3.25160556601e-07 , 2.91427185218e-07 , 2.09880233448e-07 , 1.20797513701e-07 ,
 5.53716221152e-08 , 2.01727094568e-08 , 5.83567034847e-09 , 1.34161753414e-09 ,
 2.4641538758e-10  , 3.67951674299e-11 , 4.68112984373e-12 , 5.57261986958e-13 ,
 6.85176854163e-14 , 8.63591405469e-15 , 1.00626887251e-15 , 9.92242216859e-17 ,
 7.93427016341e-18 , 5.06174785259e-19 , 2.56034458806e-20 , 1.0257706564e-21  ,
 3.24579838958e-23 , 8.10168974702e-25 , 1.28066975545e-26 , 1.59421346428e-31 ,
 3.12396525503e-22 , 2.11780118963e-20 , 8.67668671285e-19 , 2.79567620928e-17 ,
 7.13461900555e-16 , 1.44396622603e-14 , 2.31969254596e-13 , 2.95972301757e-12 ,
 3.00047094915e-11 , 2.41759724852e-10 , 1.54885769059e-09 , 7.89520949034e-09 ,
 3.20588386209e-08 , 1.03950337945e-07 , 2.71424375158e-07 , 5.95799205831e-07 ,
 1.34724622682e-06 , 4.77590284012e-06 , 2.45142569929e-05 , 0.000119780529201 ,
 0.000475586875151 , 0.00149168495069  , 0.00370190069028  , 0.00736803239068  ,
 0.0120909239371   , 0.0171196096613   , 0.0220519788284   , 0.0265648446139   ,
 0.0293609652962   , 0.0285526539766   , 0.0237158157742   , 0.0167333493561   ,
 0.0101674280606   , 0.00542269053032  , 0.00255706144053  , 0.001051699714    ,
 0.000367260966906 , 0.000107260934294 , 3.64644734194e-05 , 8.09054451538e-05 ,
 0.000389062689597 , 0.0015458136963   , 0.00480355962142  , 0.011656083921    ,
 0.0220965444527   , 0.0327487571533   , 0.0379801015014   , 0.0345042066269   ,
 0.0245852990249   , 0.0137581422933   , 0.00605564385922  , 0.00209954101625  ,
 0.000574208106684 , 0.000124031659148 , 2.11796882915e-05 , 2.86061839767e-06 ,
 3.05619077661e-07 , 2.5816775797e-08  , 1.72290331218e-09 , 9.07750581896e-11 ,
 5.12106753741e-12 , 3.16362177516e-11 , 5.73405352742e-10 , 8.17837383465e-09 ,
 9.15542390648e-08 , 8.05585071774e-07 , 5.57971096363e-06 , 3.04660518919e-05 ,
 0.000131312313667 , 0.000447251446814 , 0.00120467534803  , 0.00256674140835  ,
 0.00432516085677  , 0.00576032964387  , 0.00605716522247  , 0.00502230502718  ,
 0.0032788203078   , 0.00168292721593  , 0.000678141376567 , 0.000214242039301 ,
 5.30035020283e-05 , 1.02582938433e-05 , 1.55181654457e-06 , 1.83353389787e-07 ,
 1.69112194145e-08 , 1.2172408515e-09  , 6.84630426922e-11 , 3.05141283991e-12 ,
 1.20629281891e-13 , 7.09625848415e-15 , 8.67761421952e-16 , 1.23897257167e-16 ,
 1.04682517038e-16 , 1.36174660919e-15 , 1.9268246386e-14  , 2.82862247679e-12 ,
 3.03609436143e-11 , 3.34831674489e-10 , 3.73844087426e-09 , 3.87605116961e-08 ,
 3.44137940343e-07 , 2.50338177863e-06 , 1.46425897068e-05 , 6.83762863715e-05 ,
 0.000254256491509 , 0.000752229312993 , 0.00177071036849  , 0.00332041181385  ,
 0.00498506368344  , 0.00611423628791  , 0.00662875836583  , 0.00801113669207  ,
 0.0139996196079   , 0.0310889438349   , 0.0686876289241   , 0.136861704486    ,
 0.238663863224    , 0.35946167675     , 0.465278704754    , 0.519571011602    ,
 0.507127191658    , 0.442119752516    , 0.354999499433    , 0.273848848746    ,
 0.213381567748    , 0.173177719231    , 0.143095099129    , 0.112744649989    ,
 0.0791502726825   , 0.0471250574264   , 0.0230582251988   , 0.00909462604397  ,
 0.00285782707177  , 0.000710445885057 , 0.00013915875958  , 2.14320930727e-05 ,
 2.59371745715e-06 , 2.46880020929e-07 , 1.85479355307e-08 , 1.11061695699e-09 ,
 5.4380527249e-11  , 2.33076350792e-12 , 1.15089851696e-13 , 1.7025635681e-13  ,
 2.23811482328e-12 , 2.41049624366e-11 , 2.02477573492e-10 , 1.325852153e-09   ,
 6.76990408801e-09 , 2.69656740775e-08 , 8.38330256515e-08 , 2.03570851045e-07 ,
 3.86511005747e-07 , 5.74635832004e-07 , 6.70397751286e-07 , 6.15659321708e-07 ,
 4.47131639931e-07 , 2.5859737442e-07  , 1.20330064722e-07 , 4.57559870435e-08 ,
 1.45969088809e-08 , 4.12886911208e-09 , 1.17082728047e-09 , 3.91171697249e-10 ,
 1.52690599578e-10 , 5.81119249497e-11 , 1.88388388113e-11 , 4.92928273455e-12 ,
 1.02364120715e-12 , 1.67980484891e-13 , 2.17723825293e-14 , 2.23014110656e-15 ,
 1.80640218837e-16 , 1.1574501815e-17  , 5.86623259892e-19 , 2.35047895387e-20 ,
 7.43854501289e-22 , 1.85704230627e-23 , 2.93688342264e-25 , 1.057395218e-29   ,
 2.85133662666e-21 , 1.9594976542e-19  , 8.04685512832e-18 , 2.59946404729e-16 ,
 6.65143553521e-15 , 1.3496514242e-13  , 2.17335595144e-12 , 2.77872937889e-11 ,
 2.82153803765e-10 , 2.27585488451e-09 , 1.45870163075e-08 , 7.43393103395e-08 ,
 3.0154932912e-07  , 9.75287130923e-07 , 2.52348739402e-06 , 5.28238285822e-06 ,
 9.45662830458e-06 , 1.83818080366e-05 , 5.72622634661e-05 , 0.000240324042589 ,
 0.000926573704273 , 0.00289147007198  , 0.00716734185963  , 0.0142440556122   ,
 0.023291455867    , 0.0327601442312   , 0.0418454436769   , 0.0501602766011   ,
 0.0557247312505   , 0.0553082604488   , 0.0478346672581   , 0.0359898423389   ,
 0.023823834825    , 0.013956579068    , 0.00715191142297  , 0.00312510035181  ,
 0.00113320209949  , 0.000335501158981 , 9.02508474509e-05 , 8.12603986564e-05 ,
 0.000329575995719 , 0.00129231558172  , 0.00400695490845  , 0.00971807942526  ,
 0.018420303263    , 0.027299409948    , 0.0316600055209   , 0.0287624574176   ,
 0.0204941163573   , 0.0114686800415   , 0.00504793726879  , 0.00175016092166  ,
 0.000478655372217 , 0.000103391817792 , 1.76552219717e-05 , 2.38458906185e-06 ,
 2.54761675782e-07 , 2.15206686677e-08 , 1.43620164754e-09 , 7.56490946141e-11 ,
 3.61428308089e-12 , 1.10733823287e-11 , 1.99219036575e-10 , 2.83972923447e-09 ,
 3.1784389865e-08  , 2.79656578338e-07 , 1.9369523741e-06  , 1.05760023297e-05 ,
 4.5583771975e-05  , 0.000155258861137 , 0.000418190937135 , 0.000891018448401 ,
 0.0015014360486   , 0.00199964043895  , 0.00210268391965  , 0.00174344262213  ,
 0.00113820945667  , 0.000584211239291 , 0.00023540995413  , 7.4371974136e-05  ,
 1.83996455805e-05 , 3.56108361201e-06 , 5.38721613775e-07 , 6.36722248151e-08 ,
 5.8878765297e-09  , 4.32915203155e-10 , 2.867804891e-11   , 2.90213533766e-12 ,
 5.8864328646e-13  , 1.30591972525e-13 , 2.39896638553e-14 , 3.60323478922e-15 ,
 2.06322768245e-15 , 2.1648608769e-14  , 2.5645623778e-13  , 2.99038658648e-11 ,
 2.57874748755e-10 , 2.10487239473e-09 , 1.72516705255e-08 , 1.43527686189e-07 ,
 1.13142415046e-06 , 7.77254792512e-06 , 4.4180996623e-05  , 0.0002029290187   ,
 0.00074607493418  , 0.00218801788154  , 0.00511420681881  , 0.0095372852301   ,
 0.0142618461132   , 0.0174238581684   , 0.018617935548    , 0.0212182427481   ,
 0.0332941678619   , 0.0671085016456   , 0.137218272115    , 0.254928275377    ,
 0.417146358958    , 0.595447958637    , 0.740047905532    , 0.80526884707     ,
 0.777964653101    , 0.68240137751     , 0.560350375909    , 0.447290356576    ,
 0.359226358055    , 0.292231639347    , 0.232923820705    , 0.172451142842    ,
 0.112974115891    , 0.0631546504131   , 0.0293488837982   , 0.0111250327486   ,
 0.00339350401007  , 0.000825284831491 , 0.000159091627119 , 2.42465103488e-05 ,
 2.92609455236e-06 , 2.82330881189e-07 , 2.2404769077e-08  , 1.5629875789e-09  ,
 1.07670995252e-10 , 8.45342994929e-12 , 1.02741868092e-12 , 1.60200990081e-12 ,
 1.9539803205e-11  , 2.10001416784e-10 , 1.76363790986e-09 , 1.15459328288e-08 ,
 5.89324357313e-08 , 2.34592695385e-07 , 7.28571665673e-07 , 1.76616439217e-06 ,
 3.34381915231e-06 , 4.94784360532e-06 , 5.72697220585e-06 , 5.19062410447e-06 ,
 3.68842493593e-06 , 2.0582153747e-06  , 9.04466803717e-07 , 3.15666425859e-07 ,
 9.07455573082e-08 , 2.49274115135e-08 , 9.0532456151e-09  , 4.57717762526e-09 ,
 2.32415800126e-09 , 9.83399723553e-10 , 3.30637838618e-10 , 8.75664415176e-11 ,
 1.82577009332e-11 , 3.00016082944e-12 , 3.89044682352e-13 , 3.98577819881e-14 ,
 3.22886558083e-15 , 2.06914959212e-16 , 1.04885745618e-17 , 4.20340026449e-19 ,
 1.33060353517e-20 , 3.32304353985e-22 , 5.26007838495e-24 , 4.27613903579e-28 ,
 2.05663124367e-20 , 1.43459885596e-18 , 5.90617504768e-17 , 1.91324505145e-15 ,
 4.90939104938e-14 , 9.98905671259e-13 , 1.61261588932e-11 , 2.06629398372e-10 ,
 2.1017143321e-09  , 1.6971775995e-08  , 1.08834284288e-07 , 5.54544834374e-07 ,
 2.24742498243e-06 , 7.25612120126e-06 , 1.87080399822e-05 , 3.86872555021e-05 ,
 6.51058386478e-05 , 9.56139552887e-05 , 0.000160645357973 , 0.000434225288769 ,
 0.00147838971634  , 0.00450701982174  , 0.0111324827765   , 0.0221032675202   ,
 0.0360430130743   , 0.0503691453762   , 0.0637781741769   , 0.0761635194173   ,
 0.0855651452697   , 0.0878196490361   , 0.0805874912594   , 0.0658263625388   ,
 0.0478002353183   , 0.0304667149538   , 0.0166290148408   , 0.00756470175656  ,
 0.00280784075099  , 0.000843544043859 , 0.000219148514375 , 0.000101861019471 ,
 0.000246128619499 , 0.000873222086074 , 0.00264745016766  , 0.00638568742556  ,
 0.0120872697638   , 0.0179074652371   , 0.0207660238049   , 0.0188650695327   ,
 0.0134418496167   , 0.00752216048141  , 0.00331087610571  , 0.00114790756055  ,
 0.000313943763014 , 6.78133332458e-05 , 1.15798282598e-05 , 1.56402109428e-06 ,
 1.67095241636e-07 , 1.41153856837e-08 , 9.4211861437e-10  , 4.96755247118e-11 ,
 2.3109108386e-12  , 3.78843368856e-12 , 5.83341773991e-11 , 7.93416594057e-10 ,
 8.75624083568e-09 , 7.67225357811e-08 , 5.30744865338e-07 , 2.89689029998e-06 ,
 1.24846001433e-05 , 4.25213586788e-05 , 0.000114530541637 , 0.00024402380663  ,
 0.000411198939682 , 0.000547642259591 , 0.000575862775202 , 0.000477477229072 ,
 0.000311721821521 , 0.000159998162479 , 6.44718857789e-05 , 2.0368455925e-05  ,
 5.03944044733e-06 , 9.75753022143e-07 , 1.48107274334e-07 , 1.79751895801e-08 ,
 2.01671687288e-09 , 3.59772820941e-10 , 1.21916524952e-10 , 4.34989563927e-11 ,
 1.28070639695e-11 , 2.99413543192e-12 , 5.52667287709e-13 , 8.23029869717e-14 ,
 3.53744941255e-14 , 3.04411211487e-13 , 3.16483373878e-12 , 2.86962982158e-10 ,
 2.1597992303e-09  , 1.46280241463e-08 , 9.16376660465e-08 , 5.62509306575e-07 ,
 3.48726071858e-06 , 2.08202085843e-05 , 0.00011036435804  , 0.000489872881959 ,
 0.00176835860172  , 0.00512861458157  , 0.0118998931407   , 0.0220942987364   ,
 0.0330093340455   , 0.0404824465683   , 0.0435048666445   , 0.04873720892     ,
 0.071112039468    , 0.130498074351    , 0.245401166928    , 0.422613579194    ,
 0.644680579208    , 0.865644950606    , 1.0266889151      , 1.08673658677     ,
 1.04390005883     , 0.930327768581    , 0.789796765444    , 0.656843829668    ,
 0.544687973273    , 0.445424959404    , 0.345213636635    , 0.242088622436    ,
 0.148175332151    , 0.0772356620959   , 0.0336736938578   , 0.0120995019165   ,
 0.00353894028843  , 0.000834904384207 , 0.000158257603548 , 2.42508527838e-05 ,
 3.08824893229e-06 , 3.49655444625e-07 , 3.90233605644e-08 , 4.5696611678e-09  ,
 5.54844233137e-10 , 7.60240726331e-11 , 1.60291974327e-11 , 1.43316271431e-11 ,
 1.34966357956e-10 , 1.43842222348e-09 , 1.20772873045e-08 , 7.90651215944e-08 ,
 4.03560926862e-07 , 1.60645100927e-06 , 4.98910337461e-06 , 1.20941922421e-05 ,
 2.28971450602e-05 , 3.38799803392e-05 , 3.92134361365e-05 , 3.5539050525e-05  ,
 2.52528838546e-05 , 1.40944672429e-05 , 6.20439017801e-06 , 2.18737439187e-06 ,
 6.61479172354e-07 , 2.17372107557e-07 , 1.04002002451e-07 , 6.08193690289e-08 ,
 3.20914134641e-08 , 1.36889607265e-08 , 4.61015016516e-09 , 1.22140515672e-09 ,
 2.5469344539e-10  , 4.18552630899e-11 , 5.42807257222e-12 , 5.56180076103e-13 ,
 4.50641172215e-14 , 2.88856231492e-15 , 1.46472233535e-16 , 5.87273718838e-18 ,
 1.86018598024e-19 , 4.64940158479e-21 , 7.37482479191e-23 , 1.36535700886e-26 ,
 1.17311637463e-19 , 8.31555754897e-18 , 3.43265673711e-16 , 1.1152356647e-14  ,
 2.87018038924e-13 , 5.85665299322e-12 , 9.47977296423e-11 , 1.21742434148e-09 ,
 1.24049815652e-08 , 1.00292982923e-07 , 6.43499346462e-07 , 3.27837675857e-06 ,
 1.32752421797e-05 , 4.27947931649e-05 , 0.000110071637069 , 0.000226587054695 ,
 0.000375389907939 , 0.000509966358744 , 0.000620336138718 , 0.000913897072665 ,
 0.00214401827102  , 0.00593006119446  , 0.0144055338415   , 0.0285489468945   ,
 0.0464404461109   , 0.0643760562945   , 0.0804704893601   , 0.0954442426176   ,
 0.108899578915    , 0.117148164532    , 0.115933217607    , 0.103597710103    ,
 0.0818567249744   , 0.055662594834    , 0.0316860069705   , 0.0147688809549   ,
 0.00556136562476  , 0.00170482802696  , 0.000482657761921 , 0.000226377164809 ,
 0.000280348019969 , 0.000591685641783 , 0.00147226140582  , 0.0033560987104   ,
 0.00626009064222  , 0.0092397325675   , 0.0107043843755   , 0.00972207675107  ,
 0.00692678377756  , 0.00387621499332  , 0.00170610701009  , 0.000591520433167 ,
 0.000161776180808 , 3.49444249681e-05 , 5.96713466688e-06 , 8.05959675132e-07 ,
 8.61167508253e-08 , 7.28140521531e-09 , 4.89371545376e-10 , 2.73466441701e-11 ,
 3.47497164189e-12 , 1.3605855379e-11  , 7.95956725916e-11 , 4.50306507258e-10 ,
 2.80741865365e-09 , 1.89568342578e-08 , 1.19628460319e-07 , 6.34438252761e-07 ,
 2.71065843103e-06 , 9.20851956195e-06 , 2.47840627484e-05 , 5.27940673032e-05 ,
 8.89561165626e-05 , 0.000118471038283 , 0.000124575250156 , 0.000103291583286 ,
 6.74342427054e-05 , 3.46126590624e-05 , 1.39486524255e-05 , 4.40967146767e-06 ,
 1.09625501737e-06 , 2.19975252821e-07 , 4.25209596287e-08 , 1.37609445211e-08 ,
 7.83370023225e-09 , 4.47736579613e-09 , 2.10062553664e-09 , 7.83920505415e-10 ,
 2.31572256159e-10 , 5.40586552964e-11 , 9.9598845544e-12  , 1.47344802845e-12 ,
 5.14941563985e-13 , 3.70896512064e-12 , 3.43327651933e-11 , 2.40913223775e-09 ,
 1.61302123869e-08 , 9.68186697896e-08 , 5.17944360833e-07 , 2.51816155268e-06 ,
 1.17199815289e-05 , 5.44276256856e-05 , 0.000245744480842 , 0.00100270830899  ,
 0.0034731698825   , 0.00986792768081  , 0.0226624095794   , 0.041921338204    ,
 0.0628293462275   , 0.0780945042603   , 0.0861493716358   , 0.0983229814947   ,
 0.137923060002    , 0.231905844367    , 0.398606899287    , 0.632946777168    ,
 0.896377828357    , 1.12618240811     , 1.26630598301     , 1.29666993012     ,
 1.2357813863      , 1.12028314706     , 0.9849557659      , 0.85260503521     ,
 0.727681458806    , 0.59816420467     , 0.453930043649    , 0.304994113646    ,
 0.176192759844    , 0.086005400074    , 0.0350960526251   , 0.0118782121938   ,
 0.00331677347727  , 0.00076596154061  , 0.000149725047758 , 2.64216121512e-05 ,
 4.65270088881e-06 , 8.57481851555e-07 , 1.55233656269e-07 , 2.57766893925e-08 ,
 4.1763869258e-09  , 8.59912019092e-10 , 2.67855561597e-10 , 1.49445965301e-10 ,
 7.53594980755e-10 , 7.76134365293e-09 , 6.50977168411e-08 , 4.26152759945e-07 ,
 2.17514954912e-06 , 8.65861203105e-06 , 2.68908709143e-05 , 6.51871824604e-05 ,
 0.000123416261777 , 0.000182618759636 , 0.000211378094777 , 0.000191594000919 ,
 0.000136183014514 , 7.60897037522e-05 , 3.36484796051e-05 , 1.21225503323e-05 ,
 4.0242276082e-06  , 1.68581433951e-06 , 1.01754877754e-06 , 6.47152914212e-07 ,
 3.47987171138e-07 , 1.48999505538e-07 , 5.02185064933e-08 , 1.33075468198e-08 ,
 2.77530363681e-09 , 4.56150251562e-10 , 5.91691056488e-11 , 6.06450007508e-12 ,
 4.91579392382e-13 , 3.15281580899e-14 , 1.59999742249e-15 , 6.42202852502e-17 ,
 2.03709015771e-18 , 5.1011690884e-20  , 8.13011068924e-22 , 3.44562228436e-25 ,
 5.29321991048e-19 , 3.81673624071e-17 , 1.57998356469e-15 , 5.14887359118e-14 ,
 1.32918581226e-12 , 2.72024386391e-11 , 4.41499222378e-10 , 5.68307405226e-09 ,
 5.80141046223e-08 , 4.69625898632e-07 , 3.01504374267e-06 , 1.53593171962e-05 ,
 6.21472702527e-05 , 0.000200052331412 , 0.000513471577687 , 0.00105389771638  ,
 0.0017363265594   , 0.0023125160493   , 0.00255466575787  , 0.00263348075669  ,
 0.00355122060998  , 0.00740140510425  , 0.0168315861891   , 0.0330287291678   ,
 0.0535156404263   , 0.0732690851661   , 0.089499243431    , 0.104133827693    ,
 0.12005093977     , 0.135904006097    , 0.145358891225    , 0.140666653515    ,
 0.118433023052    , 0.0839940542637   , 0.0489909730519   , 0.0231387474798   ,
 0.00881324672987  , 0.00282334704239  , 0.00100959438514  , 0.000712620139581 ,
 0.000774274374643 , 0.000865658253618 , 0.00107348128921  , 0.0016467454734   ,
 0.00267006802709  , 0.0037883762332   , 0.00434351735237  , 0.00393427440673  ,
 0.002801115429    , 0.00156720941217  , 0.000689770140793 , 0.00023914563319  ,
 6.54043657196e-05 , 1.41278665743e-05 , 2.4127745314e-06  , 3.26181996172e-07 ,
 3.50925999529e-08 , 3.12031005562e-09 , 2.86926322692e-10 , 4.92259252964e-11 ,
 3.79043351603e-11 , 1.80020046197e-10 , 9.4021892801e-10  , 3.93190008121e-09 ,
 1.31148521878e-08 , 3.58963495906e-08 , 8.70920739501e-08 , 2.15967396332e-07 ,
 6.00661551679e-07 , 1.71320365559e-06 , 4.34911015049e-06 , 9.09884544333e-06 ,
 1.52486477581e-05 , 2.02755698821e-05 , 2.13104783693e-05 , 1.76681780073e-05 ,
 1.15374585222e-05 , 5.93054673842e-06 , 2.41085599417e-06 , 8.06007970982e-07 ,
 2.77953631938e-07 , 1.68051458792e-07 , 1.59631632318e-07 , 1.44955274689e-07 ,
 1.07665409758e-07 , 6.37392981141e-08 , 2.99403496435e-08 , 1.11427273878e-08 ,
 3.28193102914e-09 , 7.6408174517e-10  , 1.40437105264e-10 , 2.06646925239e-11 ,
 6.21903943159e-12 , 3.86390746785e-11 , 3.23675919651e-10 , 1.76298767167e-08 ,
 1.05005447984e-07 , 5.63135093586e-07 , 2.70289710492e-06 , 1.15066534814e-05 ,
 4.40261912427e-05 , 0.000158220408371 , 0.000558161062835 , 0.00191565385997  ,
 0.00602180227975  , 0.0163023039558   , 0.0366322579375   , 0.0673454074445   ,
 0.101648350979    , 0.129416718565    , 0.149242189372    , 0.177603862227    ,
 0.244610766751    , 0.379425168733    , 0.593458665955    , 0.864967049845    ,
 1.13526832898     , 1.33278267839     , 1.41594167645     , 1.39502807685     ,
 1.31163134123     , 1.20342508039     , 1.08938500482     , 0.973315641682    ,
 0.846912371637    , 0.695685525855    , 0.517487558772    , 0.335669693521    ,
 0.18505072287     , 0.0855097959599   , 0.0329540363977   , 0.0106314293263   ,
 0.0029331933472   , 0.000735922359138 , 0.000187383995995 , 5.18449180483e-05 ,
 1.45010404552e-05 , 3.64587376687e-06 , 7.82556548873e-07 , 1.5137065897e-07  ,
 3.28212450148e-08 , 1.01706474788e-08 , 4.06731997513e-09 , 1.87287678747e-09 ,
 3.67065294408e-09 , 3.31348040052e-08 , 2.76625344006e-07 , 1.81055414226e-06 ,
 9.24127360863e-06 , 3.67868637806e-05 , 0.000114249254863 , 0.000276960857307 ,
 0.000524376550955 , 0.000775969918495 , 0.000898291229559 , 0.000814449561605 ,
 0.000579323323221 , 0.000324439908332 , 0.000144826070452 , 5.43909696514e-05 ,
 2.10120360179e-05 , 1.15199029283e-05 , 8.18659694486e-06 , 5.44702768562e-06 ,
 2.95650788482e-06 , 1.26826288452e-06 , 4.27642546152e-07 , 1.13347231208e-07 ,
 2.36444879001e-08 , 3.88755849922e-09 , 5.04521102778e-10 , 5.17471445864e-11 ,
 4.19871818261e-12 , 2.69661685161e-13 , 1.37105386446e-14 , 5.51698170774e-16 ,
 1.75585673122e-17 , 4.41616681248e-19 , 7.11574465021e-21 , 6.87698739925e-24 ,
 1.88887284049e-18 , 1.38683129974e-16 , 5.75783724245e-15 , 1.88229050249e-13 ,
 4.8744865568e-12  , 1.00060790108e-10 , 1.62848974451e-09 , 2.10121063123e-08 ,
 2.14900478956e-07 , 1.74190238744e-06 , 1.11907301727e-05 , 5.70084966301e-05 ,
 0.00023051423071  , 0.000741036498068 , 0.00189829809561  , 0.00388638042884  ,
 0.00638120790503  , 0.00844151777069  , 0.00908889648187  , 0.00830924083414  ,
 0.00771460320066  , 0.0104330906554   , 0.0200000775041   , 0.037865563152    ,
 0.0607544851842   , 0.0817818883233   , 0.0965809018319   , 0.108043775129    ,
 0.12292451018     , 0.143286497389    , 0.161570036594    , 0.164399142288    ,
 0.143396763976    , 0.103817509133    , 0.0611975201568   , 0.0291013113205   ,
 0.011299282225    , 0.0040591563638   , 0.00219574064332  , 0.00225825993342  ,
 0.00256527991169  , 0.00248171759415  , 0.00202069833572  , 0.00153820442968  ,
 0.00133327471252  , 0.00138514753955  , 0.00143152048179  , 0.00125950573649  ,
 0.000889828796597 , 0.00049683971464  , 0.000218554855148 , 7.57640512021e-05 ,
 2.07225084919e-05 , 4.48019907312e-06 , 7.70327007832e-07 , 1.09451268558e-07 ,
 1.60629209751e-08 , 4.14461844834e-09 , 1.68209002511e-09 , 6.77718322262e-10 ,
 4.84810128749e-10 , 1.96114388802e-09 , 1.01231913399e-08 , 4.21028950425e-08 ,
 1.38055314485e-07 , 3.57179915374e-07 , 7.30962468369e-07 , 1.1894991379e-06  ,
 1.56172897926e-06 , 1.72603604771e-06 , 1.78105248304e-06 , 1.98323517913e-06 ,
 2.43771146436e-06 , 2.89138803675e-06 , 2.93418427621e-06 , 2.42064529844e-06 ,
 1.61835017534e-06 , 9.42163041404e-07 , 6.4018364711e-07  , 7.33152083391e-07 ,
 1.1019447504e-06  , 1.53371301471e-06 , 1.76826339032e-06 , 1.64213760944e-06 ,
 1.21718297417e-06 , 7.17312260194e-07 , 3.35452225319e-07 , 1.24333588183e-07 ,
 3.6484023014e-08  , 8.4653871631e-09  , 1.55123252599e-09 , 2.27128507043e-10 ,
 6.11536303028e-11 , 3.38038880541e-10 , 2.625428047e-09   , 1.11647205155e-07 ,
 5.97628658008e-07 , 2.84766823549e-06 , 1.2250347103e-05  , 4.72528027343e-05 ,
 0.000161765293147 , 0.000496029677767 , 0.00141257039047  , 0.00388662697605  ,
 0.0103254265408   , 0.0252740341994   , 0.0540050792976   , 0.0975147998273   ,
 0.148049248902    , 0.194119617607    , 0.235519949659    , 0.292732537317    ,
 0.397405723512    , 0.572102551211    , 0.814241252779    , 1.08699502918     ,
 1.32306261741     , 1.45602239183     , 1.46535057911     , 1.38799163768     ,
 1.28113677142     , 1.17949277992     , 1.08611148526     , 0.986588823674    ,
 0.861928212228    , 0.699447983007    , 0.507353518799    , 0.31818346778     ,
 0.168645849523    , 0.0747696234992   , 0.0279110934186   , 0.00914423778951  ,
 0.00293499017219  , 0.0010635141939   , 0.000430933557919 , 0.00016709449254  ,
 5.52449462243e-05 , 1.50647934824e-05 , 3.53602488391e-06 , 8.45638696854e-07 ,
 2.67131352103e-07 , 1.12794163342e-07 , 5.17463822428e-08 , 2.31963243611e-08 ,
 1.90299048166e-08 , 1.13595503726e-07 , 9.28607308961e-07 , 6.07202619066e-06 ,
 3.09905052124e-05 , 0.000123365103748 , 0.000383144678323 , 0.000928853160752 ,
 0.00175876919461  , 0.00260304830709  , 0.00301437888592  , 0.00273494617826  ,
 0.00194866781618  , 0.00109683253448  , 0.0004989593705   , 0.000202095267349 ,
 9.66344128054e-05 , 6.75283157227e-05 , 5.29978417628e-05 , 3.60846162252e-05 ,
 1.96755723494e-05 , 8.44865959218e-06 , 2.84992017442e-06 , 7.5567917363e-07  ,
 1.57725059248e-07 , 2.59539009095e-08 , 3.37223044035e-09 , 3.4646037337e-10  ,
 2.81777457992e-11 , 1.81559265691e-12 , 9.27181549587e-14 , 3.75283825862e-15 ,
 1.20362326559e-16 , 3.05750354979e-18 , 5.04766405435e-20 , 1.08573166997e-22 ,
 5.32724111577e-18 , 3.9869188103e-16  , 1.66037958625e-14 , 5.44564438006e-13 ,
 1.41481802329e-11 , 2.91327850625e-10 , 4.75477568381e-09 , 6.14993800758e-08 ,
 6.30204179709e-07 , 5.11522219488e-06 , 3.28872221418e-05 , 0.000167553666628 ,
 0.000677127033047 , 0.0021741404072   , 0.00555933896736  , 0.0113548047634   ,
 0.0185904146315   , 0.024497049307    , 0.0261420496927   , 0.0230365060965   ,
 0.0183064861833   , 0.0174949815554   , 0.0259426765357   , 0.0454612246908   ,
 0.0715346706643   , 0.0948774123938   , 0.108994476412    , 0.116758059633    ,
 0.127241800561    , 0.145022343045    , 0.162996533422    , 0.166368965615    ,
 0.145416942966    , 0.10526471772     , 0.0620316770647   , 0.0297255163067   ,
 0.0122230149382   , 0.00576289321067  , 0.00504671197618  , 0.00628202325319  ,
 0.00722751551377  , 0.00683052430085  , 0.0051994516022   , 0.00321132115939  ,
 0.00168470626569  , 0.000857341912831 , 0.000509506564554 , 0.000349160297722 ,
 0.000227631672455 , 0.000124261034454 , 5.43316749789e-05 , 1.88191653341e-05 ,
 5.17908945394e-06 , 1.17561870139e-06 , 2.74556430813e-07 , 1.12559972273e-07 ,
 7.30195430078e-08 , 4.50897967924e-08 , 2.26267015417e-08 , 9.253409218e-09   ,
 5.22326371266e-09 , 1.68185315968e-08 , 8.52481395637e-08 , 3.54190620234e-07 ,
 1.16137552116e-06 , 3.00373737089e-06 , 6.1345776205e-06  , 9.90348696218e-06 ,
 1.26480329729e-05 , 1.27889349049e-05 , 1.02564887318e-05 , 6.5650645155e-06  ,
 3.42884389752e-06 , 1.5694710293e-06  , 7.65322096807e-07 , 5.68507484153e-07 ,
 7.86015050788e-07 , 1.54289655632e-06 , 3.18030779398e-06 , 6.05450199866e-06 ,
 1.00535614357e-05 , 1.40247568367e-05 , 1.60202126215e-05 , 1.47526259823e-05 ,
 1.08590678946e-05 , 6.36107520015e-06 , 2.95864022116e-06 , 1.09113015922e-06 ,
 3.18705709099e-07 , 7.36398008307e-08 , 1.34432886899e-08 , 1.95841462275e-09 ,
 4.83336073633e-10 , 2.43596301417e-09 , 1.79885516482e-08 , 6.00429942868e-07 ,
 2.95946706466e-06 , 1.26288914027e-05 , 4.81977805787e-05 , 0.000166989748135 ,
 0.000522165949987 , 0.001459628391    , 0.00367479712822  , 0.00857943217391  ,
 0.0191389359157   , 0.0407242746653   , 0.0797305426966   , 0.138053782015    ,
 0.207985872035    , 0.277943049347    , 0.349178863421    , 0.443772969665    ,
 0.588737716564    , 0.791917958732    , 1.03312571618     , 1.26810943171     ,
 1.43817907258     , 1.49656458777     , 1.44327344556     , 1.32722500512     ,
 1.20552759807     , 1.10459717157     , 1.01667430411     , 0.918351115846    ,
 0.788583986154    , 0.62181133321     , 0.435428872438    , 0.263328533856    ,
 0.135127302494    , 0.0589482988022   , 0.0229543920325   , 0.00919604312382  ,
 0.0044488931328   , 0.00243439926611  , 0.00124031336602  , 0.000527255557254 ,
 0.000181965784061 , 5.25578450544e-05 , 1.44158251889e-05 , 4.78312589167e-06 ,
 2.12450079337e-06 , 1.0738822478e-06  , 5.33962490036e-07 , 2.45870264258e-07 ,
 1.27851339833e-07 , 3.32469498023e-07 , 2.47478596709e-06 , 1.60974759605e-05 ,
 8.21268064536e-05 , 0.000326921730634 , 0.00101539930948  , 0.00246188889315  ,
 0.00466253192434  , 0.00690356045588  , 0.00800095291228  , 0.00727154436857  ,
 0.00520127861189  , 0.00295958723407  , 0.0013971859461   , 0.000641518695715 ,
 0.000393500435049 , 0.000329170221118 , 0.000272756492657 , 0.000187816722808 ,
 0.000102642134993 , 4.41069481416e-05 , 1.48880668896e-05 , 3.95130595121e-06 ,
 8.25822549887e-07 , 1.36156433318e-07 , 1.77408755732e-08 , 1.82996682911e-09 ,
 1.49660516041e-10 , 9.71657597931e-12 , 5.01266637117e-13 , 2.05610013473e-14 ,
 6.70801979353e-16 , 1.74097362007e-17 , 3.0206946539e-19  , 1.35555606156e-21 ,
 1.1862271074e-17  , 9.06145237573e-16 , 3.78597032735e-14 , 1.24593455977e-12 ,
 3.24795382565e-11 , 6.70940776856e-10 , 1.09824490757e-08 , 1.42407237661e-07 ,
 1.46224629595e-06 , 1.18860671454e-05 , 7.64842033508e-05 , 0.000389756687379 ,
 0.00157443183266  , 0.00504983314808  , 0.0128909031497   , 0.0262707687916   ,
 0.0428955389511   , 0.0563429116619   , 0.0598324876505   , 0.0519797075836   ,
 0.0388430226192   , 0.0304303944731   , 0.0351132738827   , 0.0551173299046   ,
 0.0843784568627   , 0.111407351534    , 0.127840410485    , 0.135149299164    ,
 0.141185054276    , 0.150139453098    , 0.156935341129    , 0.15119422217     ,
 0.127037893507    , 0.089795325373    , 0.0525243890179   , 0.0259789437706   ,
 0.0127510552936   , 0.00945701051543  , 0.0114223824021   , 0.0147940605277   ,
 0.0166428243196   , 0.0153935173469   , 0.0115042960266   , 0.00689902783694  ,
 0.00332200838172  , 0.00130546678094  , 0.000444676453704 , 0.000152108939555 ,
 6.09692507748e-05 , 2.69455857014e-05 , 1.10349047783e-05 , 3.91564696409e-06 ,
 1.44283326389e-06 , 9.33302256064e-07 , 9.64099343375e-07 , 9.53209622996e-07 ,
 7.67073879355e-07 , 4.89492641695e-07 , 2.46851007118e-07 , 1.00162625584e-07 ,
 4.72387808852e-08 , 1.14540799801e-07 , 5.61522847385e-07 , 2.32684012181e-06 ,
 7.62966479054e-06 , 1.97434262674e-05 , 4.03493709352e-05 , 6.51822698205e-05 ,
 8.32825080659e-05 , 8.41737133773e-05 , 6.72779526137e-05 , 4.25015434332e-05 ,
 2.12324700089e-05 , 8.51222038179e-06 , 3.21819432155e-06 , 2.57485412948e-06 ,
 5.26553316347e-06 , 1.19813184683e-05 , 2.48598350793e-05 , 4.61030958599e-05 ,
 7.46163863124e-05 , 0.000102129982292 , 0.000115097107808 , 0.000104929804656 ,
 7.66109621196e-05 , 4.45606500558e-05 , 2.05921396342e-05 , 7.54861139555e-06 ,
 2.19251652213e-06 , 5.03993233262e-07 , 9.15773704322e-08 , 1.32674764353e-08 ,
 3.04666197224e-09 , 1.42284494653e-08 , 1.01914477844e-07 , 2.67958230351e-06 ,
 1.25085835802e-05 , 4.8994116008e-05  , 0.000166902920642 , 0.000512140200998 ,
 0.00144115644657  , 0.00370736475012  , 0.00865260067282  , 0.0184400954886   ,
 0.0366552913064   , 0.0690950062305   , 0.122543182723    , 0.199200773054    ,
 0.291232613333    , 0.386747228376    , 0.48736692189     , 0.614600560102    ,
 0.78836626068     , 1.00062611731     , 1.21614808717     , 1.39159047635     ,
 1.48887586904     , 1.48833721492     , 1.40505372534     , 1.28292721206     ,
 1.16224179483     , 1.05583414089     , 0.952780640187    , 0.834364354639    ,
 0.688479570468    , 0.519523331566    , 0.349108975966    , 0.204841439605    ,
 0.104520683771    , 0.0482122708889   , 0.0229692668435   , 0.0134093122392   ,
 0.00910616797993  , 0.00585512143337  , 0.00315505919162  , 0.00137584086589  ,
 0.000493941137713 , 0.000160123197214 , 5.77856821779e-05 , 2.72110780216e-05 ,
 1.50361652067e-05 , 8.40070219616e-06 , 4.42394508881e-06 , 2.12478349605e-06 ,
 9.91039262544e-07 , 1.02660904559e-06 , 5.35640987696e-06 , 3.38313983181e-05 ,
 0.000172171305287 , 0.00068522020248  , 0.00212845990943  , 0.00516189527464  ,
 0.00978105650256  , 0.0144968182223   , 0.0168345254635   , 0.0153617816221   ,
 0.011086928193    , 0.00645539444556  , 0.00326430572083  , 0.00179554196394  ,
 0.00139297617898  , 0.0013035519055   , 0.00110984220733  , 0.000768255511004 ,
 0.000420433247083 , 0.00018085937633  , 6.11384543911e-05 , 1.62617980106e-05 ,
 3.40967493247e-06 , 5.64795499161e-07 , 7.40833337591e-08 , 7.7132996878e-09  ,
 6.3893501148e-10  , 4.21974096009e-11 , 2.22586291707e-12 , 9.39021334639e-14 ,
 3.17084941064e-15 , 8.57268679118e-17 , 1.62052497386e-18 , 1.3374181209e-20  ,
 2.08272440392e-17 , 1.62682888698e-15 , 6.82077384956e-14 , 2.25276270043e-12 ,
 5.89348867556e-11 , 1.22154433298e-09 , 2.00563495392e-08 , 2.60753913937e-07 ,
 2.68316509155e-06 , 2.18448495939e-05 , 0.000140703608724 , 0.0007172617188   ,
 0.00289655156482  , 0.00928177329017  , 0.0236573271479   , 0.0481101093019   ,
 0.0783509163473   , 0.102600607366    , 0.10853667532     , 0.0935675822333   ,
 0.0679603593789   , 0.0478603789758   , 0.0455068062741   , 0.0635283756625   ,
 0.0945109574689   , 0.125870251103    , 0.148367381073    , 0.160859986239    ,
 0.166281000314    , 0.16528428033     , 0.155499458843    , 0.134876350945    ,
 0.104704961551    , 0.0708396192603   , 0.0416585548177   , 0.0232583639661   ,
 0.0164516464751   , 0.0180802964655   , 0.0238367874553   , 0.0295585601684   ,
 0.031628953885    , 0.0282401993574   , 0.0206484081979   , 0.0122290480129   ,
 0.00584077735595  , 0.00225684143936  , 0.000716733790938 , 0.000194730305712 ,
 4.89324628231e-05 , 1.26610599868e-05 , 4.00676474863e-06 , 2.67236467122e-06 ,
 3.94067119654e-06 , 6.15175446431e-06 , 7.91005444543e-06 , 8.0856129808e-06  ,
 6.53895380176e-06 , 4.17899163926e-06 , 2.11140255861e-06 , 8.56068735639e-07 ,
 3.6005017377e-07  , 6.32588663996e-07 , 2.90883133741e-06 , 1.19622024612e-05 ,
 3.91889973599e-05 , 0.000101466478445 , 0.000207568090258 , 0.000335692060793 ,
 0.000429412397614 , 0.000434512479523 , 0.00034767605321  , 0.000219853863525 ,
 0.000109965849064 , 4.43921921476e-05 , 1.78545163465e-05 , 1.68153816625e-05 ,
 3.55368500114e-05 , 7.84899533755e-05 , 0.000156805180244 , 0.000280666397795 ,
 0.000441537313119 , 0.000591971805529 , 0.000657293587827 , 0.00059253573406  ,
 0.00042864756632  , 0.000247295641232 , 0.000113417521208 , 4.12802078525e-05 ,
 1.19094198335e-05 , 2.72049857969e-06 , 4.91495877586e-07 , 7.07601894706e-08 ,
 1.52536741312e-08 , 6.6612357476e-08  , 4.68976023911e-07 , 9.73571352885e-06 ,
 4.40432012804e-05 , 0.000163124179021 , 0.000508729443784 , 0.00138924179134  ,
 0.00345841265903  , 0.00803312318954  , 0.0174111963723   , 0.0349560015774   ,
 0.0651217203422   , 0.113603560575    , 0.186033597492    , 0.282990384434    ,
 0.395163591642    , 0.509559359506    , 0.62709223976     , 0.768159846875    ,
 0.948638050723    , 1.15219993077     , 1.33631965236     , 1.46147438227     ,
 1.50853866388     , 1.48120895234     , 1.40310292892     , 1.3029633128      ,
 1.19494596202     , 1.07668903078     , 0.942173085885    , 0.789509990563    ,
 0.622649726261    , 0.453523504137    , 0.300320997396    , 0.179553068415    ,
 0.098495357031    , 0.0533663849664   , 0.0328287784644   , 0.0240314175208   ,
 0.018077231748    , 0.0119852778602   , 0.00654762931779  , 0.00293487502718  ,
 0.0011491787848   , 0.000466501523522 , 0.00023665503836  , 0.000143312287209 ,
 8.91850553341e-05 , 5.31492137571e-05 , 2.93903500393e-05 , 1.48363923594e-05 ,
 7.17083112359e-06 , 4.57430944073e-06 , 1.05644860735e-05 , 5.7133336604e-05  ,
 0.000286163044643 , 0.0011369724723   , 0.00353179750315  , 0.00857000562218  ,
 0.0162586558697   , 0.0241556510178   , 0.028184354313    , 0.0259643548571   ,
 0.0191185440357   , 0.0116625687538   , 0.00661391334004  , 0.0045015236797   ,
 0.00416690699688  , 0.00413815702583  , 0.00356567392009  , 0.00247446796606  ,
 0.00135638730697  , 0.000584849188608 , 0.000198406703714 , 5.30503809319e-05 ,
 1.12084561946e-05 , 1.87698267553e-06 , 2.49989470574e-07 , 2.6576146143e-08  ,
 2.26298657767e-09 , 1.54808094839e-10 , 8.52612542647e-12 , 3.7841211722e-13  ,
 1.35288366091e-14 , 3.88965596599e-16 , 8.21662233296e-18 , 1.04159448142e-19 ,
 2.87913925713e-17 , 2.30534956813e-15 , 9.70246639358e-14 , 3.21700229201e-12 ,
 8.44818688402e-11 , 1.75736789607e-09 , 2.89481135645e-08 , 3.77417149467e-07 ,
 3.89255231628e-06 , 3.17455813438e-05 , 0.000204702413957 , 0.00104401416467  ,
 0.00421544547858  , 0.013497322132    , 0.0343527799863   , 0.0697190193672   ,
 0.113251727286    , 0.147855415612    , 0.155851124734    , 0.133622708184    ,
 0.0955682734676   , 0.0635578336966   , 0.0532241046509   , 0.0675781633332   ,
 0.0986619141173   , 0.134108400575    , 0.164572215872    , 0.185801748807    ,
 0.194665083237    , 0.187649239602    , 0.164999086827    , 0.132391679121    ,
 0.0970455038898   , 0.0648927952736   , 0.0409498005127   , 0.0286816093407   ,
 0.0279944121688   , 0.0350842523586   , 0.0444568042949   , 0.0508925555774   ,
 0.050673509432    , 0.0429328656665   , 0.0304162971172   , 0.0178285807981   ,
 0.00864582227089  , 0.00351991277802  , 0.00124233390637  , 0.000396749569448 ,
 0.000118312472738 , 3.38716601894e-05 , 1.26359213312e-05 , 1.37915651185e-05 ,
 2.52546619243e-05 , 4.0815380677e-05  , 5.27390726211e-05 , 5.39737181897e-05 ,
 4.36981734412e-05 , 2.79815429173e-05 , 1.41952629059e-05 , 5.80320591965e-06 ,
 2.32844873998e-06 , 2.9683342879e-06  , 1.20286147968e-05 , 4.83732059472e-05 ,
 0.000157817252691 , 0.000408648659987 , 0.000837006446563 , 0.00135583047834  ,
 0.00173733785801  , 0.00176101419809  , 0.0014114721178   , 0.000894114391054 ,
 0.000448507211856 , 0.000183584969889 , 8.08181306756e-05 , 8.96019711519e-05 ,
 0.000192154773091 , 0.000410841050162 , 0.000790478126526 , 0.00136560845355  ,
 0.0020867599831   , 0.00273765028078  , 0.00299182213823  , 0.00266431815174  ,
 0.00190784989537  , 0.00109062769174  , 0.00049588880386  , 0.00017899483666  ,
 5.12313758446e-05 , 1.16153764303e-05 , 2.08392899845e-06 , 2.9783747105e-07  ,
 6.05692004018e-08 , 2.48268630737e-07 , 1.73189229412e-06 , 2.84624742779e-05 ,
 0.000126737295751 , 0.000454939027303 , 0.00134074888299  , 0.00334637665868  ,
 0.00740272860508  , 0.0152446010697   , 0.0300921286498   , 0.0568694835175   ,
 0.10137173832     , 0.168712660104    , 0.261133130614    , 0.374588105229    ,
 0.49690310208     , 0.614950760505    , 0.730304153726    , 0.863568041186    ,
 1.03168139287     , 1.22047727893     , 1.38839261749     , 1.49664562442     ,
 1.5324794829      , 1.51096010693     , 1.45861982665     , 1.38843535048     ,
 1.29069706874     , 1.15288477524     , 0.981102684354    , 0.79611594694     ,
 0.617376666449    , 0.456624548288    , 0.320011657203    , 0.210980343504    ,
 0.131704568696    , 0.0817135310001   , 0.0550233468326   , 0.0410660249193   ,
 0.030547089335    , 0.0201271995948   , 0.0111590289802   , 0.0053405905511   ,
 0.00251029242496  , 0.0013984286655   , 0.000934655131108 , 0.000649249312517 ,
 0.000432612844259 , 0.000271026730685 , 0.00015698251251  , 8.40048188976e-05 ,
 4.43039606305e-05 , 2.6733671632e-05  , 2.73632155613e-05 , 8.38037503436e-05 ,
 0.000381632150973 , 0.00149846958566  , 0.00464820650171  , 0.0112882815835   ,
 0.0214723118369   , 0.0320806359523   , 0.0378477796612   , 0.0356281039715   ,
 0.0273753173153   , 0.0181910270129   , 0.0121045947743   , 0.0100105309027   ,
 0.0102842114282   , 0.0104737544626   , 0.00906276567423  , 0.0063028525405   ,
 0.00346711618519  , 0.00150338656209  , 0.000514324849965 , 0.000139212367211 ,
 2.99282425398e-05 , 5.13405549683e-06 , 7.06286844562e-07 , 7.82901212382e-08 ,
 7.01894588583e-09 , 5.09982145961e-10 , 3.00249484793e-11 , 1.42903853089e-12 ,
 5.47668790594e-14 , 1.68190311798e-15 , 3.92862497832e-17 , 6.39485589478e-19 ,
 3.12905260131e-17 , 2.57708099782e-15 , 1.08921659541e-13 , 3.62691404693e-12 ,
 9.56436512556e-11 , 1.99733925522e-09 , 3.30172270724e-08 , 4.31781792063e-07 ,
 4.46436679974e-06 , 3.64780889575e-05 , 0.000235518072271 , 0.00120193906314  ,
 0.0048530198081   , 0.0155282792391   , 0.039469282949    , 0.0799451111473   ,
 0.129530018869    , 0.168586332327    , 0.177067512955    , 0.151113789204    ,
 0.10708662998     , 0.0692243442613   , 0.0544045781742   , 0.0659917101733   ,
 0.0966365332833   , 0.134926675194    , 0.171305095816    , 0.19902314733     ,
 0.211667885378    , 0.204771066075    , 0.180845088518    , 0.148174589642    ,
 0.113941014381    , 0.0823862627506   , 0.0583744812889   , 0.047276035559    ,
 0.0501876914076   , 0.0616305765911   , 0.0727716641819   , 0.0764820459272   ,
 0.0701477918649   , 0.0557316709109   , 0.0381672245358   , 0.0226053826425   ,
 0.011804685128    , 0.00562088627732  , 0.00250633432172  , 0.00104015393022  ,
 0.000389202338361 , 0.000132309929366 , 5.83316904727e-05 , 7.09435289274e-05 ,
 0.000131850605789 , 0.000213357217156 , 0.000275888997621 , 0.000282696417894 ,
 0.000229375279661 , 0.00014747483581  , 7.54665482968e-05 , 3.15472794812e-05 ,
 1.29909544548e-05 , 1.29291582614e-05 , 4.13728214488e-05 , 0.000155963604243 ,
 0.000501221429551 , 0.00129492793001  , 0.00265543824378  , 0.00431072034151  ,
 0.00553721851998  , 0.00562677408083  , 0.00452120536522  , 0.00287172362206  ,
 0.00144741249538  , 0.000605776843957 , 0.000300512428775 , 0.000387879116659 ,
 0.000832411580594 , 0.0017197465251   , 0.00318768755902  , 0.00531676531148  ,
 0.00788988225304  , 0.0101230863419   , 0.0108815629911   , 0.00956623010435  ,
 0.00677559053424  , 0.0038346566135   , 0.00172684432315  , 0.000617477228615 ,
 0.000175117669522 , 3.93548430943e-05 , 7.00234119563e-06 , 9.92284219364e-07 ,
 1.90847723481e-07 , 7.34480006832e-07 , 5.10094699279e-06 , 6.67116866738e-05 ,
 0.000295283324581 , 0.00104492749709  , 0.00298926390269  , 0.00705953229895  ,
 0.0142919458787   , 0.0262621905747   , 0.0465106207004   , 0.0815775235794   ,
 0.139294474599    , 0.22419599786     , 0.33307246902     , 0.45415714464     ,
 0.571686918872    , 0.675746508213    , 0.773070680104    , 0.886812677306    ,
 1.03691769008     , 1.21604939132     , 1.38779449464     , 1.51101779945     ,
 1.56831923966     , 1.57402298109     , 1.55166876777     , 1.50174210208     ,
 1.40080079996     , 1.23693447531     , 1.03403505189     , 0.834200472185    ,
 0.665203488593    , 0.528631883104    , 0.411152065992    , 0.302840669592    ,
 0.207035400349    , 0.134211970453    , 0.0882979898522   , 0.0618079979161   ,
 0.0437101084122   , 0.0284566215271   , 0.0164785682193   , 0.00912916531021  ,
 0.00568473506875  , 0.00421087503794  , 0.00328371841508  , 0.00244438404264  ,
 0.00170642766347  , 0.00111637081557  , 0.000677811139494 , 0.000388833396387 ,
 0.000229083966534 , 0.000151170321183 , 0.000115656105352 , 0.000146694898462 ,
 0.000439699882364 , 0.00160285137985  , 0.0049071438338   , 0.0118968315172   ,
 0.0227262967701   , 0.0343575915743   , 0.0415296759596   , 0.0409170321047   ,
 0.0340782977313   , 0.0258130207235   , 0.0203856975254   , 0.0192380310351   ,
 0.0206559400183   , 0.0211542730822   , 0.0183325494649   , 0.012809320052    ,
 0.00710704163965  , 0.00312256680159  , 0.00108879268436  , 0.000302663232867 ,
 6.74619026958e-05 , 1.21306207533e-05 , 1.76902013068e-06 , 2.09915688691e-07 ,
 2.0277407585e-08  , 1.59047978894e-09 , 1.00804765929e-10 , 5.13153074683e-12 ,
 2.08524334887e-13 , 6.72681625998e-15 , 1.67713782784e-16 , 3.09048278804e-18 ,
 2.66966762632e-17 , 2.27181849151e-15 , 9.64801172103e-14 , 3.22794307725e-12 ,
 8.5515010506e-11  , 1.79350153204e-09 , 2.97621823166e-08 , 3.9050953277e-07  ,
 4.04866259786e-06 , 3.3150760388e-05  , 0.000214344580653 , 0.00109473842853  ,
 0.00442067612032  , 0.0141368722747   , 0.0358875035722   , 0.0725489440301   ,
 0.117240481898    , 0.152103317223    , 0.159163141762    , 0.135256102309    ,
 0.0953308660181   , 0.0611564458833   , 0.0479440009669   , 0.0592853894211   ,
 0.0894139377572   , 0.1280065563      , 0.164880536451    , 0.192440065163    ,
 0.206005624894    , 0.205114739894    , 0.194049847761    , 0.176983956208    ,
 0.153530884481    , 0.123627426952    , 0.0947998756548   , 0.0787891351986   ,
 0.0804974638363   , 0.0928327984121   , 0.102567455769    , 0.100305765906    ,
 0.0855333467805   , 0.0643375550334   , 0.0438646759685   , 0.0282174212165   ,
 0.0177210863623   , 0.0107997346108   , 0.00608544029403  , 0.00300473035764  ,
 0.00126227504595  , 0.000468497383198 , 0.00022727388447  , 0.000290363633526 ,
 0.000541398064716 , 0.000876262722725 , 0.0011345384523   , 0.00116548657159  ,
 0.000949953401471 , 0.000615949150471 , 0.000320893560897 , 0.000140536018537 ,
 6.4383076248e-05  , 5.80055045862e-05 , 0.000130565131807 , 0.000416130716276 ,
 0.00127340412081  , 0.00325387083488  , 0.00666929128333  , 0.0108529891748   ,
 0.0139866856431   , 0.0142630613995   , 0.0115024342583   , 0.00733688629373  ,
 0.00372884681116  , 0.00161891435597  , 0.000935142491699 , 0.00137134413024  ,
 0.00289981259251  , 0.00576908611016  , 0.0102952723985   , 0.0165803918103   ,
 0.0238958382115   , 0.0299815846209   , 0.0316927577629   , 0.0274963499648   ,
 0.0192549660343   , 0.0107823623424   , 0.00480534933718  , 0.00170053690135  ,
 0.000477321612002 , 0.000106190825318 , 1.87119973569e-05 , 2.62555244768e-06 ,
 4.78390820014e-07 , 1.72692980347e-06 , 1.19778025587e-05 , 0.000126137947743 ,
 0.000558721911309 , 0.00197137866761  , 0.0055805735863   , 0.0128539912377   ,
 0.0247781289115   , 0.0420826010618   , 0.0677349787776   , 0.109562104322    ,
 0.177920811912    , 0.277104502408    , 0.397388289478    , 0.517341963305    ,
 0.617529323934    , 0.694924135753    , 0.766565749233    , 0.860017440547    ,
 0.995355082512    , 1.16833900553     , 1.34764616802     , 1.4928772795      ,
 1.58261735715     , 1.62468582007     , 1.63190613488     , 1.59198193168     ,
 1.47749819267     , 1.28846419499     , 1.06969412261     , 0.878721372965    ,
 0.742531244381    , 0.645277717135    , 0.550806090227    , 0.436930722303    ,
 0.312492341599    , 0.203872020382    , 0.128433850322    , 0.0833604083854   ,
 0.055766258936    , 0.0365590060416   , 0.0235469966183   , 0.0164766914981   ,
 0.0134486567709   , 0.0117424553224   , 0.00981010148174  , 0.00758767709227  ,
 0.00549226126365  , 0.00373668585029  , 0.0023854545438   , 0.00148601460663  ,
 0.000988702330846 , 0.00072634691313  , 0.000547828605226 , 0.000441187069825 ,
 0.000604202779565 , 0.00158639681935  , 0.00445968015415  , 0.010517515222    ,
 0.0200106218891   , 0.0307796391274   , 0.0389037492804   , 0.0415691550255   ,
 0.03912957083     , 0.0344499291996   , 0.0310528732254   , 0.031154305736    ,
 0.0336512848996   , 0.0343614638646   , 0.0299044113489   , 0.0211505730809   ,
 0.0119698289164   , 0.00541080675367  , 0.00196125505464  , 0.000573501153742 ,
 0.000136118096746 , 2.633791887e-05   , 4.16000684309e-06 , 5.35158871994e-07 ,
 5.57856437518e-08 , 4.68071430833e-09 , 3.13950356611e-10 , 1.67296321866e-11 ,
 7.04674666702e-13 , 2.33703638741e-14 , 6.02587298531e-16 , 1.17392160211e-17 ,
 1.78574425421e-17 , 1.57928992374e-15 , 6.74357028389e-14 , 2.26827408985e-12 ,
 6.03996319595e-11 , 1.27277309641e-09 , 2.12105022946e-08 , 2.79315749439e-07 ,
 2.90449174384e-06 , 2.38370538904e-05 , 0.000154373870885 , 0.00078917646636  ,
 0.00318751901355  , 0.0101885007561   , 0.0258331929338   , 0.0521222397781   ,
 0.0840058049604   , 0.10862142473     , 0.11322141371     , 0.0958283818174   ,
 0.0674086260782   , 0.043802526326    , 0.0364841651473   , 0.0489706243939   ,
 0.0774238764251   , 0.112712742296    , 0.14440172292     , 0.166024608375    ,
 0.178231759815    , 0.187325815638    , 0.198555775709    , 0.207915843086    ,
 0.203191106138    , 0.177969966037    , 0.142603531844    , 0.116534795309    ,
 0.110387592831    , 0.117594799364    , 0.122247413456    , 0.113436657757    ,
 0.092589341366    , 0.0691352490919   , 0.051079352479    , 0.0397013427125   ,
 0.0314713973931   , 0.0232147288816   , 0.0148186222788   , 0.00791623388464  ,
 0.00352689800126  , 0.00138974931485  , 0.00072244809781  , 0.000943584193226 ,
 0.00175376434899  , 0.00283781658681  , 0.00368364822012  , 0.0038039069453   ,
 0.0031295605388   , 0.00206466727896  , 0.00111484350051  , 0.000532269758311 ,
 0.000292448010455 , 0.000274173875736 , 0.00043788160762  , 0.00100813695045  ,
 0.00268716144982  , 0.0065988681838   , 0.0134164690836   , 0.0218537546189   ,
 0.0282665044267   , 0.0289570238852   , 0.0234741973158   , 0.0150770408574   ,
 0.00778183121025  , 0.0035935507658   , 0.00248972766756  , 0.0039906700818   ,
 0.00816817500384  , 0.0155575651066   , 0.0266722665148   , 0.0414547121842   ,
 0.0580265719501   , 0.0712084115633   , 0.0740358750218   , 0.0633960690623   ,
 0.043890215418    , 0.0243122916321   , 0.0107182002761   , 0.00375122662971  ,
 0.00104113182447  , 0.000229024821219 , 3.99132666823e-05 , 5.53771754429e-06 ,
 9.58982647035e-07 , 3.25333531821e-06 , 2.25958045173e-05 , 0.000196687168959 ,
 0.000876394757071 , 0.00310834029684  , 0.00882468147385  , 0.0202760333021   ,
 0.0385604936345   , 0.0634046130968   , 0.0966504691286   , 0.146626277313    ,
 0.225403999679    , 0.336380917853    , 0.463115945907    , 0.57507110722     ,
 0.650533356108    , 0.695487657258    , 0.739300962684    , 0.813532944775    ,
 0.933475129889    , 1.09131330659     , 1.26003941771     , 1.40854481987     ,
 1.52132714237     , 1.60038266349     , 1.64049666131     , 1.6124479383      ,
 1.48914532961     , 1.28823679285     , 1.07402201396     , 0.911705252944    ,
 0.820936085415    , 0.767727091061    , 0.696487865942    , 0.576126142185    ,
 0.422165471144    , 0.276574396242    , 0.17009442684     , 0.105469037557    ,
 0.0689203150082   , 0.0478145643113   , 0.036468814525    , 0.032006515614    ,
 0.0306432085817   , 0.0286447126089   , 0.024644260149    , 0.0195402921578   ,
 0.0145622685001   , 0.0102668715946   , 0.00692201591341  , 0.00473717541802  ,
 0.00355881275288  , 0.00287045286736  , 0.00224579690601  , 0.00166673234868  ,
 0.00148120535074  , 0.00227659730239  , 0.00482218703697  , 0.00983009843869  ,
 0.0173335248412   , 0.0261847787355   , 0.0344630221819   , 0.0404515570761   ,
 0.0431468734453   , 0.0427083849694   , 0.0412836322532   , 0.0419246540859   ,
 0.0448047306008   , 0.0457188935936   , 0.0403846415411   , 0.0293715236261   ,
 0.0173008994517   , 0.00824209955683  , 0.00318785865296  , 0.00100522946922  ,
 0.000258909375619 , 5.43841621772e-05 , 9.27261526212e-06 , 1.27488668085e-06 ,
 1.40348540704e-07 , 1.22911173229e-08 , 8.51685582199e-10 , 4.64993510224e-11 ,
 1.99401702992e-12 , 6.7008093717e-14  , 1.75437652731e-15 , 3.49985619653e-17 ,
 9.35376395952e-18 , 8.6599042332e-16  , 3.72075866456e-14 , 1.25903659058e-12 ,
 3.37167669966e-11 , 7.14212260708e-10 , 1.19573291816e-08 , 1.5808589378e-07  ,
 1.64919464331e-06 , 1.35688256246e-05 , 8.80310861649e-05 , 0.000450501035229 ,
 0.00182020377922  , 0.00581571997184  , 0.0147287925174   , 0.029659663511    ,
 0.0476716535053   , 0.0614251013939   , 0.0637672709896   , 0.0537765017939   ,
 0.0379324242917   , 0.0256401549448   , 0.0242393512031   , 0.0367506180169   ,
 0.0609763973528   , 0.089420581128    , 0.112771638509    , 0.127014997233    ,
 0.138050674105    , 0.157559813435    , 0.190858721214    , 0.226745040253    ,
 0.242918472664    , 0.226396185416    , 0.18733763644     , 0.149727482913    ,
 0.129926464936    , 0.125453118837    , 0.122033651439    , 0.109202784721    ,
 0.0891398033246   , 0.0718646888268   , 0.0637441483185   , 0.0616017900435   ,
 0.0572973642855   , 0.0463823394523   , 0.031319724109    , 0.0174854908484   ,
 0.008158308172    , 0.00340750165828  , 0.00188050308146  , 0.00245745267612  ,
 0.0045146957471   , 0.00729672285564  , 0.00951863065802  , 0.00993309446258  ,
 0.00832729071873  , 0.00568495372417  , 0.00328216552755  , 0.00180085882518  ,
 0.00123263640323  , 0.00126249021968  , 0.00164629671046  , 0.00258895732828  ,
 0.00517464499925  , 0.0112976136594   , 0.0221878037663   , 0.0358763370374   ,
 0.0464633200675   , 0.0478196734487   , 0.0390414271553   , 0.0253785991325   ,
 0.0134991760336   , 0.00690207208352  , 0.00580351009296  , 0.00966059204269  ,
 0.0187470757077   , 0.0338759869121   , 0.055551543153    , 0.083179429953    ,
 0.113042202071    , 0.135716245009    , 0.138851951215    , 0.117401641345    ,
 0.0803822266704   , 0.0440523734351   , 0.0192095939199   , 0.0066468633431   ,
 0.00182301882052  , 0.000396167283179 , 6.82039350113e-05 , 9.34577510034e-06 ,
 1.55256907153e-06 , 5.02119860841e-06 , 3.50268074482e-05 , 0.000265749468339 ,
 0.00119526225364  , 0.00428379293636  , 0.0123022674413   , 0.0286093323306   ,
 0.0550009873035   , 0.0908445261058   , 0.136920032865    , 0.200675928354    ,
 0.292887038646    , 0.413063856077    , 0.538064703216    , 0.632267950568    ,
 0.676357394355    , 0.68632153585     , 0.701103480361    , 0.75273053601     ,
 0.84844681883     , 0.973994036625    , 1.10739238003     , 1.23359222638     ,
 1.35132168702     , 1.45998435734     , 1.53494806797     , 1.52921913757     ,
 1.41638537714     , 1.22893662106     , 1.04265532696     , 0.921532099042    ,
 0.875127197009    , 0.857349967782    , 0.803239787566    , 0.679026723788    ,
 0.505683545744    , 0.335171091443    , 0.207108248879    , 0.128869478536    ,
 0.0871568446985   , 0.067249568711    , 0.0604803808405   , 0.0610234596899   ,
 0.0625714338621   , 0.0600253909561   , 0.0524639335246   , 0.0423682067168   ,
 0.0322973376396   , 0.0235077041425   , 0.0168074097746   , 0.0127152627606   ,
 0.010675166496    , 0.00927386368183  , 0.00752937070363  , 0.00565635400408  ,
 0.00471256275856  , 0.00582980249122  , 0.00958907768606  , 0.0155853758883   ,
 0.022508324272    , 0.0291316159317   , 0.0352975422156   , 0.0412235697518   ,
 0.045837505996    , 0.0474147449429   , 0.0466561988225   , 0.0469799029114   ,
 0.0498558115207   , 0.0516282389906   , 0.0472634665058   , 0.0361988847059   ,
 0.022745805198    , 0.0116756195601   , 0.00489342114062  , 0.00167194922828  ,
 0.000463875505154 , 0.000103898612022 , 1.86626973802e-05 , 2.67137643844e-06 ,
 3.0304735473e-07  , 2.71260848318e-08 , 1.9093950765e-09  , 1.05423924719e-10 ,
 4.55732044596e-12 , 1.54033784434e-13 , 4.0594347017e-15  , 8.1788583601e-17  ,
 3.83279327384e-18 , 3.74769574747e-16 , 1.62152961523e-14 , 5.52369997558e-13 ,
 1.4885261587e-11  , 3.17106918696e-10 , 5.33556234454e-09 , 7.08399690125e-08 ,
 7.41579010046e-07 , 6.11772873063e-06 , 3.97662993343e-05 , 0.000203742225999 ,
 0.00082354612287  , 0.00263041868434  , 0.006654260734    , 0.0133736859364   ,
 0.0214351563903   , 0.0275194299565   , 0.0284513114803   , 0.0239294058677   ,
 0.0170597008899   , 0.0124602994032   , 0.014176246353    , 0.0243989589837   ,
 0.0420169159637   , 0.061676898901    , 0.0765921942439   , 0.0853252100221   ,
 0.0962088894478   , 0.122451278127    , 0.168917841679    , 0.22183167719     ,
 0.254887586023    , 0.250293703956    , 0.213898067744    , 0.168498674187    ,
 0.134087970051    , 0.114909606154    , 0.102629314957    , 0.0894189189683   ,
 0.0770499663114   , 0.0733231258912   , 0.0808447440969   , 0.0913104505371   ,
 0.0921356197285   , 0.0780176978838   , 0.0545792635009   , 0.0316738504482   ,
 0.0155278919501   , 0.00694523300799  , 0.00408740563922  , 0.00523937706939  ,
 0.00937760057271  , 0.0150978276836   , 0.0198756652639   , 0.0211661180275   ,
 0.0183928428568   , 0.0133655756413   , 0.00861624376721  , 0.00567735045995  ,
 0.00474884278099  , 0.00521523720429  , 0.00625473728278  , 0.00764633884026  ,
 0.0107062515207   , 0.0182318187652   , 0.0322155781447   , 0.0502000250814   ,
 0.0642908077908   , 0.0661727700912   , 0.0544816324458   , 0.0361955106517   ,
 0.0204093418001   , 0.0121479453989   , 0.0120709970141   , 0.0197050676576   ,
 0.035413867963    , 0.0599308141376   , 0.0933067920442   , 0.134110186083    ,
 0.176732314439    , 0.207591804062    , 0.20911885569     , 0.174714455838    ,
 0.118381040983    , 0.064219866412    , 0.0277087053617   , 0.0094799204197   ,
 0.00256886546464  , 0.000551216121188 , 9.36677739817e-05 , 1.2666652396e-05  ,
 2.06883388889e-06 , 6.67830068128e-06 , 4.69332637951e-05 , 0.00033762784121  ,
 0.00153057132872  , 0.00553956701886  , 0.0161072625318   , 0.0380525567585   ,
 0.0745604627237   , 0.125513941071    , 0.190869644264    , 0.275393893736    ,
 0.384130448832    , 0.508034921064    , 0.617293347921    , 0.67789665259     ,
 0.680717054277    , 0.652810384628    , 0.636995713753    , 0.660659048708    ,
 0.722909404909    , 0.80528987382     , 0.89159091655     , 0.981778079252    ,
 1.08822420772     , 1.21061753441     , 1.31242342204     , 1.33665672327     ,
 1.2580614979      , 1.11467832256     , 0.980211246951    , 0.907708913774    ,
 0.896167299095    , 0.896593906105    , 0.847841486712    , 0.721667112805    ,
 0.542952611016    , 0.365845395574    , 0.231824471891    , 0.150384054231    ,
 0.109757797717    , 0.095201210038    , 0.0964225161227   , 0.104861783506    ,
 0.111191033033    , 0.108463938036    , 0.0961911899831   , 0.0788843405314   ,
 0.0611432372381   , 0.0457500150118   , 0.0347337003253   , 0.0289744773538   ,
 0.0267172630239   , 0.0245736940952   , 0.0206069057323   , 0.0159453144714   ,
 0.0136610419361   , 0.0165696994823   , 0.0253170524652   , 0.0371807650071   ,
 0.0469689017803   , 0.0508807793751   , 0.0499316892787   , 0.0481810577585   ,
 0.047586236259    , 0.0467526276869   , 0.0450933766242   , 0.0451317216939   ,
 0.0486203853219   , 0.052433089546    , 0.0509172103177   , 0.0418187130351   ,
 0.0283214427673   , 0.0156626214355   , 0.00703350645105  , 0.00255090402697  ,
 0.000742888428676 , 0.000172729662124 , 3.18975300403e-05 , 4.65771446973e-06 ,
 5.35876694282e-07 , 4.84421244015e-08 , 3.4333764753e-09  , 1.90483687687e-10 ,
 8.26233669875e-12 , 2.79935263924e-13 , 7.39766536724e-15 , 1.49645961632e-16 ,
 1.22753204744e-18 , 1.28096686137e-16 , 5.58591274741e-15 , 1.9168327904e-13  ,
 5.2006704284e-12  , 1.11468915118e-10 , 1.88550783419e-09 , 2.51456384462e-08 ,
 2.64187675216e-07 , 2.18554603834e-06 , 1.42349586143e-05 , 7.30231793636e-05 ,
 0.000295309703478 , 0.000942955008638 , 0.00238283274968  , 0.00477972301563  ,
 0.00763922247128  , 0.00977162338128  , 0.0100623781577   , 0.00845706385129  ,
 0.00617708497387  , 0.00513045192411  , 0.00725293244619  , 0.013851673199    ,
 0.0244213546996   , 0.0358005794407   , 0.0441131864723   , 0.0496921889072   ,
 0.0603602864943   , 0.0875907830577   , 0.135781149305    , 0.193155596455    ,
 0.235487491079    , 0.242976958475    , 0.215011028724    , 0.168777524972    ,
 0.124883795563    , 0.0940461844472   , 0.0751907789532   , 0.0640358048391   ,
 0.0614821055975   , 0.0720493274559   , 0.0944460471481   , 0.116508507383    ,
 0.122707535546    , 0.10713145006     , 0.0774769821062   , 0.0469321359831   ,
 0.0244416500716   , 0.0119933163747   , 0.00771428837538  , 0.00953612576787  ,
 0.016212930811    , 0.02581836141     , 0.0345073919929   , 0.038096445264    ,
 0.0352122103149   , 0.0282409914044   , 0.0211287902188   , 0.0168146559665   ,
 0.0162708637955   , 0.0185669884416   , 0.021538867728    , 0.0236424165707   ,
 0.0261716646052   , 0.0331548093669   , 0.0475950162512   , 0.0666911177329   ,
 0.081271024972    , 0.0820757606202   , 0.0679112205296   , 0.0468276894581   ,
 0.0291465232884   , 0.0207334624805   , 0.0226209975326   , 0.0343063617123   ,
 0.0557248757806   , 0.0868559267134   , 0.126959263803    , 0.174053240306    ,
 0.221803348048    , 0.254752106978    , 0.25279513778     , 0.208872043216    ,
 0.140180558084    , 0.0753375930397   , 0.0321855782708   , 0.0108934880277   ,
 0.002917353838    , 0.00061809485799  , 0.000103634726651 , 1.38323525706e-05 ,
 2.35287099912e-06 , 8.36313357414e-06 , 5.92421306891e-05 , 0.00043446926488  ,
 0.00196885153847  , 0.00713487987741  , 0.0208226930783   , 0.0495341856729   ,
 0.0980648400739   , 0.166983224437    , 0.255256138268    , 0.363628772658    ,
 0.488225692183    , 0.607979802527    , 0.68678008583     , 0.698378020088    ,
 0.650852991646    , 0.583136920923    , 0.536832959463    , 0.531132538065    ,
 0.55924344197     , 0.602311426268    , 0.64842272999     , 0.704707069098    ,
 0.789829148759    , 0.905867345667    , 1.01714292533     , 1.07002437892     ,
 1.042463783       , 0.967519363231    , 0.902806710827    , 0.882019651907    ,
 0.893923748276    , 0.89446216305     , 0.837301069905    , 0.707240555328    ,
 0.532719570344    , 0.363855409043    , 0.237602971338    , 0.16264570364     ,
 0.129107822209    , 0.123977068534    , 0.136823241022    , 0.156857266216    ,
 0.171384389625    , 0.170827411031    , 0.154390034553    , 0.128549102418    ,
 0.100906086144    , 0.0773064365086   , 0.0621234890959   , 0.0564929784454   ,
 0.0560882309728   , 0.053902372352    , 0.0465466101263   , 0.0372689407622   ,
 0.0332821656111   , 0.0408058808952   , 0.0607129271675   , 0.0858272582247   ,
 0.103129574887    , 0.102876610017    , 0.0871413796559   , 0.0671890453963   ,
 0.0523562646833   , 0.0441272177575   , 0.0403985859226   , 0.0408450935122   ,
 0.0457010931814   , 0.0518029642807   , 0.053206068218    , 0.0463046978304   ,
 0.0331423671446   , 0.0192491514822   , 0.00900240528228  , 0.00337048461523  ,
 0.00100518319655  , 0.000237756986543 , 4.44380516969e-05 , 6.54311847009e-06 ,
 7.57093180871e-07 , 6.87058053021e-08 , 4.88250688018e-09 , 2.71374916698e-10 ,
 1.17858866272e-11 , 3.99668894357e-13 , 1.05726769672e-14 , 2.14161375026e-16 ,
 3.07245028748e-19 , 3.46095233681e-17 , 1.5222039113e-15  , 5.26496184444e-14 ,
 1.43880830163e-12 , 3.10364328109e-11 , 5.27876769702e-10 , 7.07225396542e-09 ,
 7.45783360839e-08 , 6.18723771123e-07 , 4.03813508389e-06 , 2.07414630995e-05 ,
 8.39234394871e-05 , 0.000267911838673 , 0.000676304687716 , 0.00135402838655  ,
 0.00215803562969  , 0.00275046530824  , 0.00282242324212  , 0.00237943418513  ,
 0.00182109301564  , 0.00182099025468  , 0.00317764551298  , 0.00652107731891  ,
 0.0116493416335   , 0.0170765343549   , 0.0211671770266   , 0.0250233614072   ,
 0.0345825227052   , 0.0584475518847   , 0.100717314241    , 0.153545572685    ,
 0.197678496282    , 0.213773052316    , 0.195791905583    , 0.154598661338    ,
 0.10921734408     , 0.0740395175742   , 0.0530040220357   , 0.0442991320113   ,
 0.0479127807773   , 0.065901945618    , 0.0950832371119   , 0.122599697413    ,
 0.132744823735    , 0.119251138304    , 0.0894905200091   , 0.0570969465468   ,
 0.0322793091117   , 0.018183150421    , 0.0133456951278   , 0.0158003260229   ,
 0.0246634797153   , 0.0382786542996   , 0.0522239672156   , 0.0608915329923   ,
 0.0614921125154   , 0.0559200532399   , 0.0489921485918   , 0.0456108252865   ,
 0.0484885766149   , 0.0563523981501   , 0.0642667850474   , 0.0679349078588   ,
 0.0687354172904   , 0.0730265403954   , 0.0850549906534   , 0.100881009773    ,
 0.110197703884    , 0.104795167168    , 0.0856453181594   , 0.0618345656169   ,
 0.0432591949474   , 0.0351280258334   , 0.0381994754404   , 0.0515286004217   ,
 0.0739541340745   , 0.104168511112    , 0.140816726273    , 0.182322538394    ,
 0.223550663175    , 0.250648570893    , 0.245032974688    , 0.20037849092     ,
 0.133334310266    , 0.071063190643    , 0.0300898986068   , 0.0100838222623   ,
 0.00267081641672  , 0.000558988694669 , 9.24939222517e-05 , 1.22064190162e-05 ,
 2.42828091828e-06 , 1.07456149027e-05 , 7.63373001521e-05 , 0.000563818210784 ,
 0.00253226199041  , 0.00909908043688  , 0.0263558650999   , 0.0623130846137   ,
 0.122792398078    , 0.208231097613    , 0.316134610647    , 0.443447226069    ,
 0.577905467118    , 0.686924135273    , 0.72921278179     , 0.688409722988    ,
 0.591313280453    , 0.487765581465    , 0.41599027502     , 0.386938466221    ,
 0.390627123394    , 0.409550407385    , 0.432408597421    , 0.464615182448    ,
 0.523765649373    , 0.616163950973    , 0.71799705674     , 0.790074633644    ,
 0.815597539448    , 0.815685971537    , 0.82354306224     , 0.84994140954     ,
 0.874881327768    , 0.863413618752    , 0.78893461734     , 0.652776858244    ,
 0.48699679016     , 0.334591587242    , 0.224158785578    , 0.161189661065    ,
 0.137471177033    , 0.1430576226      , 0.169067254064    , 0.203551299793    ,
 0.230480860809    , 0.23655366253     , 0.219014861984    , 0.185464945389    ,
 0.147337611698    , 0.115334648889    , 0.0974821328416   , 0.0950878852591   ,
 0.0998157582707   , 0.0992861558077   , 0.0881341751902   , 0.0730970694817   ,
 0.0678359225763   , 0.0835750788327   , 0.12110702182     , 0.166245192963    ,
 0.194375457764    , 0.187328339427    , 0.149118233405    , 0.101881108021    ,
 0.066024694596    , 0.0473982664528   , 0.0414716190616   , 0.0429673850072   ,
 0.0487379077248   , 0.0549748251286   , 0.0562958461208   , 0.0492429069392   ,
 0.0355954210539   , 0.0208975891704   , 0.00986561047285  , 0.00372055489643  ,
 0.00111532252032  , 0.000264719372538 , 4.95857826069e-05 , 7.31071344171e-06 ,
 8.46546296484e-07 , 7.68541041289e-08 , 5.46256285998e-09 , 3.03634456534e-10 ,
 1.31869842013e-11 , 4.47178108825e-13 , 1.18313860364e-14 , 2.3964178033e-16  ,
 6.69049009289e-20 , 7.39775071686e-18 , 3.28355519476e-16 , 1.14519248949e-14 ,
 3.15306359336e-13 , 6.84602347923e-12 , 1.17087642497e-10 , 1.5759052218e-09  ,
 1.66794173095e-08 , 1.38768010956e-07 , 9.07510262435e-07 , 4.66725051595e-06 ,
 1.88946112941e-05 , 6.0305665485e-05  , 0.000152083611859 , 0.000303933204591 ,
 0.000483100055186 , 0.000613628194107 , 0.000628138290428 , 0.000534800120727 ,
 0.000443851586825 , 0.00055964713841  , 0.00116063186222  , 0.00248986152428  ,
 0.00448245310888  , 0.00661107313273  , 0.00847558452677  , 0.0112981744333   ,
 0.0192394465894   , 0.0385260980117   , 0.0730389235232   , 0.118280912583    ,
 0.159674602406    , 0.179667647701    , 0.169611635535    , 0.136158927266    ,
 0.0960554495092   , 0.0640275751437   , 0.0451547946464   , 0.037792288189    ,
 0.0409858114921   , 0.0560675368351   , 0.0808357831173   , 0.105224609519    ,
 0.11617499449     , 0.107547915647    , 0.0843178194851   , 0.0576202096579   ,
 0.0368269495733   , 0.0253416755386   , 0.0219728888168   , 0.0252152616893   ,
 0.0354197509623   , 0.0525302581876   , 0.0730068173881   , 0.0907171301845   ,
 0.101112290921    , 0.104225709245    , 0.10467660546     , 0.109577106886    ,
 0.124088756258    , 0.145826625801    , 0.164639502711    , 0.17190032123     ,
 0.170404001675    , 0.171232868346    , 0.17969868481     , 0.187862996324    ,
 0.182736860387    , 0.159567503269    , 0.125580564032    , 0.0927595275657   ,
 0.069426465337    , 0.0580909563849   , 0.0580113114735   , 0.067371182278    ,
 0.0837287293769   , 0.104547501339    , 0.128355011677    , 0.154770655294    ,
 0.181103806538    , 0.197567908811    , 0.190162524848    , 0.153993986144    ,
 0.101692823596    , 0.0538074989497   , 0.0226065594236   , 0.00750970544255  ,
 0.00196921979948  , 0.000407510768783 , 6.65913856049e-05 , 8.7328988587e-06  ,
 2.44116470208e-06 , 1.41263916675e-05 , 9.99503972836e-05 , 0.000685985792746 ,
 0.00304530936296  , 0.0108080269009   , 0.0309013256703   , 0.0720729300016   ,
 0.140029634914    , 0.234043346833    , 0.350135955516    , 0.483389313519    ,
 0.617246370435    , 0.712313705376    , 0.724341191076    , 0.64447680943     ,
 0.512979067402    , 0.386872323409    , 0.301311679544    , 0.261736445761    ,
 0.256867039792    , 0.269624141993    , 0.285377115584    , 0.302550878175    ,
 0.334555007371    , 0.393493097054    , 0.472149029228    , 0.549388235293    ,
 0.613788967058    , 0.67302093472     , 0.73628399619     , 0.794735988153    ,
 0.823178603739    , 0.796741342964    , 0.706941767976    , 0.569444522585    ,
 0.4184324933      , 0.288693780944    , 0.199015078619    , 0.150107482162    ,
 0.134908941738    , 0.147779754147    , 0.183659744434    , 0.231472453293    ,
 0.272678693354    , 0.289443991551    , 0.275229541351    , 0.237419577954    ,
 0.191292096179    , 0.153211009677    , 0.13551378955     , 0.139740636832    ,
 0.152917501186    , 0.15634856191     , 0.142356396539    , 0.121960020645    ,
 0.116477151822    , 0.142494119732    , 0.199741859004    , 0.265504576073    ,
 0.302889757733    , 0.286085254088    , 0.22264916979     , 0.146883451139    ,
 0.090634615219    , 0.0636012395162   , 0.0577517497465   , 0.0614959100994   ,
 0.0670023151228   , 0.0693719440724   , 0.0649840903532   , 0.0528642649137   ,
 0.0362023670885   , 0.0204330981147   , 0.00937280600648  , 0.00346068193068  ,
 0.00102129352984  , 0.000239595864802 , 4.44919461198e-05 , 6.51726985295e-06 ,
 7.5100471258e-07  , 6.79311377952e-08 , 4.81507893362e-09 , 2.67102443939e-10 ,
 1.15849974306e-11 , 3.92751985398e-13 , 1.04149392334e-14 , 2.12840503712e-16 ,
 2.12540996752e-19 , 1.26047628446e-18 , 5.60900964143e-17 , 1.97295625502e-15 ,
 5.47324567857e-14 , 1.19611113287e-12 , 2.05690775127e-11 , 2.78083306167e-10 ,
 2.95371273514e-09 , 2.46407791476e-08 , 1.614580298e-07   , 8.31380431363e-07 ,
 3.367485714e-06   , 1.07461102266e-05 , 2.70758061626e-05 , 5.40179414349e-05 ,
 8.56449662148e-05 , 0.000108459292399 , 0.000110963255178 , 9.65195856585e-05 ,
 9.09657908535e-05 , 0.000147161854642 , 0.000345366633697 , 0.00076060274435  ,
 0.00138109988082  , 0.00209186622611  , 0.00298690010542  , 0.00517075738908  ,
 0.0116794319635   , 0.0272892539836   , 0.0556507129021   , 0.0942478468065   ,
 0.131760012251    , 0.152870857573    , 0.148762156849    , 0.124173560464    ,
 0.0936196027446   , 0.0698230238467   , 0.0558192978012   , 0.048038815737    ,
 0.0446947419136   , 0.0482766475574   , 0.0599310229162   , 0.0743624487748   ,
 0.0824827488705   , 0.0787576523633   , 0.0652624079581   , 0.0493431311066   ,
 0.0379368038013   , 0.0333553164163   , 0.03397467922     , 0.0387860099223   ,
 0.0499725467806   , 0.0700608899172   , 0.0977449090243   , 0.12787045614     ,
 0.155069605971    , 0.177392972336    , 0.198597577513    , 0.227519727036    ,
 0.270779352213    , 0.322029065844    , 0.36219678205     , 0.37733522139     ,
 0.374781062396    , 0.373716483612    , 0.379355975518    , 0.374818555803    ,
 0.341467282077    , 0.280769335521    , 0.212193532974    , 0.154656427792    ,
 0.115004918262    , 0.0912010849708   , 0.0796804220227   , 0.0776307435759   ,
 0.0817992727515   , 0.0888135935067   , 0.0970980964559   , 0.107093509472    ,
 0.11814444158     , 0.124685506374    , 0.117964720507    , 0.0946103795349   ,
 0.0620530434506   , 0.0326298619549   , 0.013618336819    , 0.0044898059122   ,
 0.00116705704683  , 0.000239081383153 , 3.86281925716e-05 , 5.09508961563e-06 ,
 2.45415112604e-06 , 1.74942796633e-05 , 0.000122918901196 , 0.000729389459307 ,
 0.00320502825801  , 0.0112443093434   , 0.0317326746682   , 0.0729311596574   ,
 0.139396879424    , 0.229029244965    , 0.33728505882     , 0.45985834064     ,
 0.580847878975    , 0.660682976434    , 0.655757130572    , 0.560688366331    ,
 0.420034664147    , 0.291762476242    , 0.208454266748    , 0.17336326625     ,
 0.175081734566    , 0.195370018094    , 0.214185026686    , 0.222228010331    ,
 0.229473382981    , 0.254367906528    , 0.304520318175    , 0.37316285073     ,
 0.452219996955    , 0.538913553943    , 0.626197037165    , 0.694282420262    ,
 0.717749724458    , 0.680766644901    , 0.587328710097    , 0.461225955323    ,
 0.335373366297    , 0.23579195986     , 0.171429871686    , 0.137468040309    ,
 0.127489711987    , 0.141134561223    , 0.179473564449    , 0.234817041419    ,
 0.287678815088    , 0.315782357296    , 0.307914476334    , 0.270295225837    ,
 0.221290797462    , 0.182051687218    , 0.168382871868    , 0.181851101988    ,
 0.20536677255     , 0.214543336676    , 0.199546443878    , 0.175274460633    ,
 0.169811824666    , 0.203768605034    , 0.274761076465    , 0.352618537514    ,
 0.392268013697    , 0.36481727363     , 0.282376982383    , 0.188242260012    ,
 0.121594568733    , 0.0938545234447   , 0.0933441951314   , 0.102344295828    ,
 0.107774330507    , 0.102960571079    , 0.0867717007544   , 0.0630999413389   ,
 0.0388539632261   , 0.0199577999173   , 0.0084532844045   , 0.002924590384    ,
 0.00081972213233  , 0.000184782069558 , 3.32860113617e-05 , 4.765484426e-06   ,
 5.39832850119e-07 , 4.82177203957e-08 , 3.38764222867e-09 , 1.87061791165e-10 ,
 8.14351889396e-12 , 2.8365191371e-13  , 8.29152059936e-15 , 2.25548620243e-16 ,
 4.64066638383e-18 , 3.70203339294e-19 , 7.5946397206e-18  , 2.69170818654e-16 ,
 7.52248246036e-15 , 1.6542959218e-13  , 2.85970140031e-12 , 3.88255478329e-11 ,
 4.13771165336e-10 , 3.46056813389e-09 , 2.27163632386e-08 , 1.17104734159e-07 ,
 4.7456692932e-07  , 1.51419007886e-06 , 3.81200580223e-06 , 7.59340047944e-06 ,
 1.20120071854e-05 , 1.51762857423e-05 , 1.5568829168e-05  , 1.40943871039e-05 ,
 1.58842928014e-05 , 3.23941467914e-05 , 8.24308751738e-05 , 0.000184960122752 ,
 0.000344391295069 , 0.000576944548264 , 0.00110682794566  , 0.00288399077447  ,
 0.00831757314215  , 0.0213542409455   , 0.0454032402902   , 0.0790882329874   ,
 0.113520814179    , 0.135822830365    , 0.138055593203    , 0.123798083476    ,
 0.1051035088      , 0.0916416639667   , 0.0830538407465   , 0.0730412560608   ,
 0.0595181352554   , 0.0476514957732   , 0.0430495106696   , 0.0451002372257   ,
 0.0480986726179   , 0.0471625630337   , 0.0422204453293   , 0.0373354647507   ,
 0.0366815447528   , 0.0407663617791   , 0.0470894625333   , 0.0549208695838   ,
 0.0678453050928   , 0.0904502679374   , 0.123991348915    , 0.166231046838    ,
 0.213985625094    , 0.265850230118    , 0.325588745479    , 0.402535767166    ,
 0.501132376113    , 0.605548544359    , 0.683300570294    , 0.715053276758    ,
 0.71627066325     , 0.716499619999    , 0.718653629401    , 0.692672856468    ,
 0.612787270655    , 0.489885582793    , 0.361244483124    , 0.256882156413    ,
 0.183371294861    , 0.133580263397    , 0.100591168678    , 0.0806977991556   ,
 0.0701745535791   , 0.0646940422229   , 0.0616572402479   , 0.0608901860532   ,
 0.062268146261    , 0.0630017837941   , 0.0584013332017   , 0.0463664434857   ,
 0.0302198251799   , 0.0158064499884   , 0.00656041409272  , 0.00214919382683  ,
 0.000554497389389 , 0.000112602959251 , 1.80167019072e-05 , 2.4578798414e-06  ,
 2.3577268168e-06  , 1.88925195421e-05 , 0.000131877926643 , 0.000650752653879 ,
 0.00283690078853  , 0.00986050563536  , 0.0275242248456   , 0.0624530786486   ,
 0.117651050113    , 0.190465664546    , 0.277171050972    , 0.375549569941    ,
 0.473438142341    , 0.536812086721    , 0.527199448238    , 0.440102794756    ,
 0.315611819896    , 0.205431188118    , 0.138541604597    , 0.118203426777    ,
 0.134065513819    , 0.166788826841    , 0.191957568588    , 0.195055963758    ,
 0.184570960194    , 0.183796273464    , 0.20924327279     , 0.261255738799    ,
 0.332318032964    , 0.414314497099    , 0.49447408616     , 0.551803692344    ,
 0.564801063614    , 0.524340666751    , 0.440466472716    , 0.338496453342    ,
 0.246571568271    , 0.181881985754    , 0.144765563747    , 0.125494712302    ,
 0.118162576305    , 0.127685070678    , 0.162143927692    , 0.218859757579    ,
 0.278815569683    , 0.315853728192    , 0.314177057126    , 0.278952985782    ,
 0.231307216962    , 0.195699864091    , 0.18931545613     , 0.212768353413    ,
 0.245984462511    , 0.260953324751    , 0.246368564102    , 0.219344500761    ,
 0.21191281054     , 0.246577858572    , 0.319011525937    , 0.395524793923    ,
 0.429912322991    , 0.395629166589    , 0.30818469937     , 0.213101198987    ,
 0.150428938044    , 0.131225359938    , 0.141633010459    , 0.159684657343    ,
 0.167268600974    , 0.154868842471    , 0.123445423337    , 0.0831242806472   ,
 0.0466409994541   , 0.0216163705762   , 0.00823340598331  , 0.00256916786308  ,
 0.000654860383313 , 0.000135835893309 , 2.28191570746e-05 , 3.08795666656e-06 ,
 3.34994908582e-07 , 2.90781666652e-08 , 2.03456385861e-09 , 1.18872442905e-10 ,
 6.41419933442e-12 , 3.74210650117e-13 , 2.44686098458e-14 , 1.54983116584e-15 ,
 8.24676117604e-17 , 3.61760157628e-18 , 9.35144603168e-19 , 2.90665618044e-17 ,
 8.17953522554e-16 , 1.80942044701e-14 , 3.14303858805e-13 , 4.28388168922e-12 ,
 4.5793644043e-11  , 3.83878868336e-10 , 2.52405643647e-09 , 1.30252045738e-08 ,
 5.28088347822e-08 , 1.68475751122e-07 , 4.2383269639e-07  , 8.43102033798e-07 ,
 1.3311284927e-06  , 1.67957092512e-06 , 1.73699186385e-06 , 1.68272134945e-06 ,
 2.37000624977e-06 , 5.84098157698e-06 , 1.56791635317e-05 , 3.62901559438e-05 ,
 7.49445067461e-05 , 0.000173691061746 , 0.00055345669795  , 0.00200327654532  ,
 0.00649133344704  , 0.0173424741563   , 0.0377136356474   , 0.0671869509049   ,
 0.0992989237541   , 0.123845047398    , 0.133752602081    , 0.130856281933    ,
 0.124083233242    , 0.11996790532     , 0.115298718725    , 0.101879916055    ,
 0.078159580548    , 0.0523974297423   , 0.0341183881052   , 0.0258822479572   ,
 0.023866625585    , 0.0235387266182   , 0.0236493183775   , 0.0261975482454   ,
 0.0333653582127   , 0.044428913119    , 0.0565404616384   , 0.0689938910628   ,
 0.0850734132595   , 0.109104943692    , 0.143981661655    , 0.192268459489    ,
 0.257206366301    , 0.342543625715    , 0.454644862579    , 0.602193166953    ,
 0.782635650663    , 0.964907362117    , 1.10014018421     , 1.16401197363     ,
 1.18027931317     , 1.1861761348      , 1.17950168274     , 1.11805213478     ,
 0.973070203419    , 0.768361773681    , 0.560431029759    , 0.391123108181    ,
 0.267966051054    , 0.180223666969    , 0.118535703652    , 0.0782846605617   ,
 0.0546227479402   , 0.0412722253283   , 0.0333469479192   , 0.0287551398593   ,
 0.026660016852    , 0.0255133146673   , 0.0230471095089   , 0.0180884363518   ,
 0.0117171471453   , 0.00610041788459  , 0.00252032376277  , 0.000821343719362 ,
 0.000210596857032 , 4.24515388489e-05 , 6.74034634188e-06 , 1.01194598775e-06 ,
 2.01786493575e-06 , 1.70569941578e-05 , 0.000118455044129 , 0.000477647236598 ,
 0.00206987493681  , 0.00714285384462  , 0.0197667932166   , 0.0443995032646   ,
 0.0827229593491   , 0.132597692655    , 0.191962821698    , 0.260606657521    ,
 0.330644581223    , 0.376700886353    , 0.369140253126    , 0.303941527474    ,
 0.211427161777    , 0.131478313938    , 0.0873725815958   , 0.0829004600081   ,
 0.109988692699    , 0.150376451968    , 0.179156046258    , 0.180629461226    ,
 0.162826760109    , 0.150205168522    , 0.161201868764    , 0.196847369681    ,
 0.2484490616      , 0.307046859436    , 0.362180733987    , 0.398291779202    ,
 0.39977248868     , 0.361588139738    , 0.294827392172    , 0.221756808695    ,
 0.163790265836    , 0.130398175549    , 0.116132165105    , 0.108814257528    ,
 0.10355496663     , 0.109207315537    , 0.139407980574    , 0.196199033913    ,
 0.261408467726    , 0.305150217345    , 0.307238379249    , 0.272617038467    ,
 0.226029385879    , 0.194760865048    , 0.19547191432     , 0.226509981654    ,
 0.265967730768    , 0.284786480561    , 0.270988494713    , 0.24146856395     ,
 0.228585789848    , 0.255074347498    , 0.316606827317    , 0.381272819788    ,
 0.407883895843    , 0.374896058254    , 0.297787883362    , 0.217304550211    ,
 0.169051553041    , 0.162895682332    , 0.185281379261    , 0.213008521992    ,
 0.224440515341    , 0.206838091103    , 0.162057058557    , 0.105745973198    ,
 0.0566428785479   , 0.0246870448437   , 0.00871672164479  , 0.00249050600552  ,
 0.000576176067711 , 0.000108087472065 , 1.64756379928e-05 , 2.05187137913e-06 ,
 2.13260633666e-07 , 1.98850762647e-08 , 1.95530601255e-09 , 2.29290253584e-10 ,
 2.86038694752e-11 , 3.17414523135e-12 , 2.86645193969e-13 , 2.04515859363e-14 ,
 1.14248744319e-15 , 4.98725661543e-17 , 1.76663631589e-18 , 2.52613725472e-18 ,
 7.02829070198e-17 , 1.56312117596e-15 , 2.72712169874e-14 , 3.73000232863e-13 ,
 3.99814161779e-12 , 3.35843006262e-11 , 2.21142745289e-10 , 1.14223724139e-09 ,
 4.63292973692e-09 , 1.47789507661e-08 , 3.71558377855e-08 , 7.38245639962e-08 ,
 1.16381778773e-07 , 1.46880538179e-07 , 1.54459862176e-07 , 1.66314084756e-07 ,
 2.99441198609e-07 , 8.51389247522e-07 , 2.413862417e-06   , 6.29059205244e-06 ,
 1.87000850612e-05 , 7.70148609955e-05 , 0.00035695985421  , 0.00146684213474  ,
 0.00493461409018  , 0.0134270828837   , 0.0297530025093   , 0.0544078586534   ,
 0.0834791183468   , 0.109588323739    , 0.126342270801    , 0.13321740768     ,
 0.135525245559    , 0.137174682702    , 0.133873960352    , 0.117527528931    ,
 0.0877438009046   , 0.0546266887013   , 0.0294217235374   , 0.0158762773372   ,
 0.0109056535145   , 0.0102182622842   , 0.0120947986253   , 0.0174885314809   ,
 0.0277094045211   , 0.0421610962607   , 0.0588421318796   , 0.0768769576277   ,
 0.0970505441001   , 0.120479693483    , 0.150123371408    , 0.194205326044    ,
 0.265284695863    , 0.375999301347    , 0.53797031952     , 0.758986520059    ,
 1.02724168264     , 1.29592389299     , 1.50237661622     , 1.6180798163      ,
 1.6686813008      , 1.68894889323     , 1.66800958136     , 1.5587526837      ,
 1.33947944404     , 1.04993102484     , 0.761816339418    , 0.524905781141    ,
 0.34809674062     , 0.219848382624    , 0.130041268415    , 0.0726897713121   ,
 0.0404448426686   , 0.0240180117301   , 0.0157470684019   , 0.0114576240323   ,
 0.00935399503161  , 0.00830292881747  , 0.00724637493118  , 0.00560771735943  ,
 0.00360915212277  , 0.00187128589067  , 0.000770148062021 , 0.000249911960018 ,
 6.37539348425e-05 , 1.27732149391e-05 , 2.01865793061e-06 , 3.77249396589e-07 ,
 1.46236905314e-06 , 1.26299235808e-05 , 8.73747302258e-05 , 0.000285644283697 ,
 0.00123230068986  , 0.00422926232688  , 0.0116275756589   , 0.0259270314708   ,
 0.0479741114569   , 0.0766229397243   , 0.111328625109    , 0.152896969185    ,
 0.196781875122    , 0.226530619143    , 0.222556479341    , 0.181826335437    ,
 0.123845751021    , 0.0749013812716   , 0.0511818125101   , 0.0563759019116   ,
 0.0852528070949   , 0.123326184036    , 0.149809547258    , 0.151592296491    ,
 0.13595772781     , 0.124140906059    , 0.131274786901    , 0.156144962177    ,
 0.189020264863    , 0.222285134201    , 0.250537513595    , 0.265637469949    ,
 0.258175087415    , 0.225546807574    , 0.17701788773     , 0.12944880113     ,
 0.0972672599511   , 0.0844473189775   , 0.0835632283645   , 0.0834088296895   ,
 0.0809492798414   , 0.0868179313441   , 0.117098203238    , 0.176676736885    ,
 0.247845821311    , 0.297219369098    , 0.300582884147    , 0.263234718824    ,
 0.21419859868     , 0.183687734054    , 0.18714395034     , 0.220295196424    ,
 0.260749444529    , 0.280652970934    , 0.267850787224    , 0.236572708791    ,
 0.216181924727    , 0.228608019484    , 0.272052872104    , 0.320870788049    ,
 0.34206998123     , 0.318609337268    , 0.262183803518    , 0.204335361144    ,
 0.173529342601    , 0.178252875053    , 0.207134540429    , 0.238919060166    ,
 0.251800061755    , 0.231707155229    , 0.180555532556    , 0.116486358862    ,
 0.0612489589073   , 0.0259880856485   , 0.00885011828646  , 0.00241392798709  ,
 0.000527836162192 , 9.31095271957e-05 , 1.35767837387e-05 , 1.78648923306e-06 ,
 2.62554919574e-07 , 5.02373751288e-08 , 1.04892089524e-08 , 1.92876504788e-09 ,
 2.86521276182e-10 , 3.35560302257e-11 , 3.07750717802e-12 , 2.20548522074e-13 ,
 1.23389241722e-14 , 5.38610300808e-16 , 1.8340916258e-17  , 6.53940519267e-19 ,
 4.77531395417e-18 , 1.06494274935e-16 , 1.86516247707e-15 , 2.55888312313e-14 ,
 2.74934330319e-13 , 2.31354960305e-12 , 1.52532356347e-11 , 7.88479013822e-11 ,
 3.1992178389e-10  , 1.02046195476e-09 , 2.56418365959e-09 , 5.08982506863e-09 ,
 8.01614388054e-09 , 1.01431678921e-08 , 1.09935202431e-08 , 1.37723993472e-08 ,
 3.16292620958e-08 , 1.01810744108e-07 , 3.36452063638e-07 , 1.33516431598e-06 ,
 7.37419156454e-06 , 4.43652977637e-05 , 0.00023217192165  , 0.000986088151881 ,
 0.00336583448519  , 0.00929562219424  , 0.0210465147769   , 0.039724553478    ,
 0.0636439058196   , 0.0881169494616   , 0.107635876128    , 0.119685647884    ,
 0.12628046561     , 0.129468099116    , 0.125702331348    , 0.108917840385    ,
 0.0798749340899   , 0.048174259135    , 0.0239357456622   , 0.0104620063856   ,
 0.00509905197213  , 0.00413856309163  , 0.00592236484614  , 0.0109784080561   ,
 0.020559329577    , 0.0352462561124   , 0.0547381975437   , 0.0778652855012   ,
 0.101615712874    , 0.122230668431    , 0.141451014742    , 0.172165341488    ,
 0.235420902739    , 0.352421203075    , 0.540093802619    , 0.805660559607    ,
 1.13097584772     , 1.46181377053     , 1.73200118566     , 1.91113549602     ,
 2.016533663       , 2.06663678368     , 2.03765084818     , 1.88508153161     ,
 1.60309892759     , 1.24781451934     , 0.899819799711    , 0.611865283748    ,
 0.394326932839    , 0.23702284242     , 0.129736832612    , 0.0641374051229   ,
 0.0294674140045   , 0.0135491008721   , 0.00681704156224  , 0.00396279463035  ,
 0.00272985567326  , 0.00218345874324  , 0.00181642971172  , 0.00137993711153  ,
 0.000881603281442 , 0.000455290908891 , 0.000186774615245 , 6.03980871058e-05 ,
 1.53446655171e-05 , 3.05920963008e-06 , 4.8385247757e-07  , 1.36570657031e-07 ,
 8.73426802636e-07 , 7.60193422201e-06 , 5.24419709354e-05 , 0.000138440462737 ,
 0.000595258774593 , 0.00203466739542  , 0.00556819375984  , 0.0123611804186   ,
 0.0228239102586   , 0.0366047625698   , 0.0539446457567   , 0.0757449154485   ,
 0.099610997008    , 0.116320048544    , 0.114879106999    , 0.09346608485     ,
 0.0627710236518   , 0.0374807461896   , 0.0271216970413   , 0.0344927945494   ,
 0.0568183732682   , 0.0846845587281   , 0.104093540438    , 0.106447006328    ,
 0.0974872296428   , 0.0924051892644   , 0.101020957678    , 0.120278503398    ,
 0.140841793286    , 0.156627933831    , 0.165888016905    , 0.1663957206      ,
 0.154249827205    , 0.12871303134     , 0.0962023838978   , 0.0675450660174   ,
 0.0510741855054   , 0.0477100040875   , 0.0511655510088   , 0.0536467453299   ,
 0.0543286793544   , 0.0635367893574   , 0.0966061702487   , 0.159067945393    ,
 0.233847685968    , 0.286179584478    , 0.289705931936    , 0.249774434018    ,
 0.197678587163    , 0.164967831643    , 0.165894587218    , 0.194962900102    ,
 0.231398426271    , 0.250389181856    , 0.239854504514    , 0.209565990275    ,
 0.183358602474    , 0.181267154156    , 0.205379162774    , 0.238669073053    ,
 0.257233350277    , 0.247336737269    , 0.215080166774    , 0.181533720595    ,
 0.167081573695    , 0.177966269483    , 0.205026469744    , 0.23117042676     ,
 0.238848598998    , 0.216773039201    , 0.167278067032    , 0.107020616305    ,
 0.0557651796899   , 0.0234006912448   , 0.00785998576716  , 0.00211130108744  ,
 0.000458209167029 , 8.45188913022e-05 , 1.57533143794e-05 , 3.87215624865e-06 ,
 1.19169519747e-06 , 3.48185117679e-07 , 8.39098564764e-08 , 1.60333410269e-08 ,
 2.40500836289e-09 , 2.82356623153e-10 , 2.59122210082e-11 , 1.85731329718e-12 ,
 1.03914890815e-13 , 4.53602109464e-15 , 1.54423389617e-16 , 4.10771012436e-18 ,
 3.38440297142e-19 , 5.71286471271e-18 , 1.00390874394e-16 , 1.38092122276e-15 ,
 1.48671169061e-14 , 1.25294917598e-13 , 8.26953315351e-13 , 4.27761410621e-12 ,
 1.73614803722e-11 , 5.53747740078e-11 , 1.39083142622e-10 , 2.75871658046e-10 ,
 4.34369309068e-10 , 5.53084919946e-10 , 6.30639959013e-10 , 9.65597317154e-10 ,
 2.83129358434e-09 , 1.14696738116e-08 , 6.22205142428e-08 , 4.69252661652e-07 ,
 3.68437966812e-06 , 2.46185416432e-05 , 0.000132352817782 , 0.000568345785697 ,
 0.00196162099146  , 0.00550850494776  , 0.0127935941362   , 0.0250337814259   ,
 0.0419756281208   , 0.0611061735238   , 0.0782475632542   , 0.0901498819894   ,
 0.0966854610224   , 0.0987866917333   , 0.0944963364173   , 0.0804737145906   ,
 0.0580428401466   , 0.0343501291591   , 0.0164867095731   , 0.00655182015321  ,
 0.00250633974096  , 0.00166626775175  , 0.00281189796212  , 0.00637140873783  ,
 0.0138054349815   , 0.0269552552585   , 0.0471077565331   , 0.0728138847951   ,
 0.097810159897    , 0.114222194672    , 0.122211975985    , 0.136672818769    ,
 0.182602187863    , 0.284995525922    , 0.462666145447    , 0.722246624788    ,
 1.04574918561     , 1.38500579094     , 1.68393423971     , 1.91439201785     ,
 2.07903401849     , 2.17227767984     , 2.15559664844     , 1.9887570704      ,
 1.68072078164     , 1.29874823036     , 0.92680968132     , 0.61853239685     ,
 0.386467361462    , 0.222229676049    , 0.114579753368    , 0.0520070133279   ,
 0.0208783632385   , 0.00774648625697  , 0.00291962141444  , 0.00126042405817  ,
 0.000682623219389 , 0.000469203901191 , 0.000363931788345 , 0.000269442281894 ,
 0.000170564456053 , 8.77261257399e-05 , 3.58862850282e-05 , 1.15718680215e-05 ,
 2.93022855237e-06 , 5.81930485119e-07 , 9.32153624978e-08 , 4.90732977411e-08 ,
 4.24348881893e-07 , 3.70189091255e-06 , 2.54844933259e-05 , 5.41941350977e-05 ,
 0.000232463731569 , 0.000792382373325 , 0.0021626124389   , 0.00479498412142  ,
 0.00888443894824  , 0.0144406344835   , 0.0218458742517   , 0.0316927563607   ,
 0.0428394784299   , 0.0508655131763   , 0.0505679653731   , 0.0410699665836   ,
 0.0273420458766   , 0.0162955660871   , 0.0126124517578   , 0.0179415836086   ,
 0.0310783823803   , 0.0470720646812   , 0.0583906641003   , 0.0606419770234   ,
 0.0576243484124   , 0.0583138050552   , 0.0679314717702   , 0.0832714572846   ,
 0.0968762046185   , 0.103853802589    , 0.103737012196    , 0.0974281791243   ,
 0.0849200439115   , 0.0669274988257   , 0.0472061438992   , 0.0313870793041   ,
 0.0233365682333   , 0.0227595089412   , 0.0257515450561   , 0.0282535076974   ,
 0.0310841053628   , 0.0427837046098   , 0.0757653616032   , 0.134729735986    ,
 0.20469382783     , 0.254072184324    , 0.25821836198     , 0.221488083929    ,
 0.172325018199    , 0.139360879391    , 0.135372954921    , 0.156140696704    ,
 0.185222353673    , 0.202481779578    , 0.196297914523    , 0.171216164118    ,
 0.144005189608    , 0.131449095963    , 0.139117463296    , 0.15870284807     ,
 0.175139391049    , 0.177792465662    , 0.167924798061    , 0.157288103147    ,
 0.158147558207    , 0.172908133279    , 0.193034087547    , 0.206147569242    ,
 0.202254189723    , 0.176709528556    , 0.133265752891    , 0.084318859517    ,
 0.0438040965491   , 0.0184342472134   , 0.00625717615831  , 0.00173891490533  ,
 0.000428394022534 , 0.000117811262493 , 4.44492035939e-05 , 1.90836712535e-05 ,
 7.2829348519e-06  , 2.24991508541e-06 , 5.49181439971e-07 , 1.05238776202e-07 ,
 1.57962010467e-08 , 1.85481225981e-09 , 1.70224702803e-10 , 1.22013291961e-11 ,
 6.82653568232e-13 , 2.97987223517e-14 , 1.01446012155e-15 , 2.69269766056e-17 ,
 5.61661609432e-19 , 2.40931149191e-19 , 4.24582696157e-18 , 5.85327375844e-17 ,
 6.31240688475e-16 , 5.32661773017e-15 , 3.51873893919e-14 , 1.82117576573e-13 ,
 7.3934509937e-13  , 2.35803905866e-12 , 5.92057523354e-12 , 1.1737787831e-11  ,
 1.84954190356e-11 , 2.38368999945e-11 , 2.95067695713e-11 , 5.91617423444e-11 ,
 2.53625031671e-10 , 1.87526144004e-09 , 1.93627881271e-08 , 1.98366250459e-07 ,
 1.69469328147e-06 , 1.15606300216e-05 , 6.26503443891e-05 , 0.000271192076911 ,
 0.000947687905405 , 0.00271459823806  , 0.00649444628866  , 0.013221778556    ,
 0.023215594427    , 0.0353817503338   , 0.0470675700844   , 0.0555370421619   ,
 0.0598827637675   , 0.0604810302964   , 0.0567058802352   , 0.0473192553899   ,
 0.033532140136    , 0.0195265547135   , 0.00918879390709  , 0.00350289741379  ,
 0.00118355002665  , 0.000668099780932 , 0.00128294451873  , 0.00345547414737  ,
 0.00868451781937  , 0.0193703525177   , 0.0375432558641   , 0.06169502151     ,
 0.0843763130854   , 0.0962603156478   , 0.0964578265873   , 0.0987208256335   ,
 0.126215352257    , 0.201525196767    , 0.34084831065     , 0.549868473591    ,
 0.816410086819    , 1.10821010695     , 1.38764622657     , 1.63223536504     ,
 1.83185632003     , 1.96207038742     , 1.97509490726     , 1.83299499563     ,
 1.54912150536     , 1.19042537589     , 0.838182801172    , 0.546051208804    ,
 0.329347416084    , 0.181160536967    , 0.0886371890094   , 0.0377188825264   ,
 0.0138308357499   , 0.00443294484905  , 0.00131345001386  , 0.000406022132666 ,
 0.000156219184986 , 8.45288191614e-05 , 5.86589256118e-05 , 4.17796474151e-05 ,
 2.61209266331e-05 , 1.33726029398e-05 , 5.45604554504e-06 , 1.75522607219e-06 ,
 4.43278786498e-07 , 8.77847783712e-08 , 1.46530868244e-08 , 1.66193635293e-08 ,
 1.66624245505e-07 , 1.45411806586e-06 , 9.9954523426e-06  , 1.70930837187e-05 ,
 7.32053907956e-05 , 0.000249141391883 , 0.0006795000142   , 0.00151024473262  ,
 0.00282685475476  , 0.00470658691845  , 0.00740023003272  , 0.0111908980792   ,
 0.0156032414659   , 0.0188516157945   , 0.0188742007074   , 0.0153272851906   ,
 0.0101548657509   , 0.00607666835833  , 0.00499603478233  , 0.00767112340256  ,
 0.0136729838754   , 0.0209105069839   , 0.0261702509199   , 0.0277413959876   ,
 0.0277150068011   , 0.0305134323688   , 0.0385074693502   , 0.0494714121601   ,
 0.0584729654842   , 0.0618136796595   , 0.059064491231    , 0.0519260744096   ,
 0.0421315767157   , 0.031047902916    , 0.0205303979491   , 0.0127887308121   ,
 0.00909605390022  , 0.00894182513379  , 0.0104641432473   , 0.0121546455862   ,
 0.0154127751475   , 0.0262847132656   , 0.0533934800576   , 0.100097763714    ,
 0.155365362093    , 0.195468866617    , 0.201396737056    , 0.175476621999    ,
 0.137990294006    , 0.109999844904    , 0.102059931523    , 0.113212318871    ,
 0.13341537826     , 0.148363842402    , 0.147597446929    , 0.130896495062    ,
 0.107769776624    , 0.0907129488872   , 0.08719569019     , 0.0958907652037   ,
 0.109358546292    , 0.120506511412    , 0.128143147737    , 0.13738733314     ,
 0.153239980954    , 0.17298959493     , 0.186899618591    , 0.186572844716    ,
 0.170205833721    , 0.140711631694    , 0.10330045773     , 0.0654172228649   ,
 0.0347912798655   , 0.0153022001583   , 0.00562216326868  , 0.00187255088089  ,
 0.000705461517031 , 0.000353198295814 , 0.000194354557066 , 9.42741676127e-05 ,
 3.70361584457e-05 , 1.15142464899e-05 , 2.814356322e-06   , 5.39471033556e-07 ,
 8.09791833824e-08 , 9.50882880108e-09 , 8.72672174359e-10 , 6.25512577422e-11 ,
 3.49968772371e-12 , 1.52765952646e-13 , 5.2007251695e-15  , 1.38041783775e-16 ,
 2.82492004732e-18 , 7.97623410712e-21 , 1.40893997243e-19 , 1.94593254479e-18 ,
 2.10152656928e-17 , 1.77519184319e-16 , 1.17354715248e-15 , 6.07668213501e-15 ,
 2.467476354e-14   , 7.86939532279e-14 , 1.97535283699e-13 , 3.91552634505e-13 ,
 6.18371029359e-13 , 8.14724654988e-13 , 1.16650910845e-12 , 3.87195378106e-12 ,
 3.63510104822e-11 , 5.08767880275e-10 , 6.78155461428e-09 , 7.41316878719e-08 ,
 6.43089007752e-07 , 4.41191447797e-06 , 2.40452684136e-05 , 0.000105032735553 ,
 0.000372664973146 , 0.00109348311887  , 0.0027077585603   , 0.00575538654489  ,
 0.010582173441    , 0.0168144098199   , 0.0230756993908   , 0.0276754191935   ,
 0.0298121954635   , 0.0296309342303   , 0.0271425671244   , 0.0221403135194   ,
 0.015389935001    , 0.00881611517546  , 0.0040830915378   , 0.0015217604661   ,
 0.000485598499291 , 0.000254926165633 , 0.00056437882144  , 0.00179332233453  ,
 0.00517495363292  , 0.0128367173055   , 0.0266552536857   , 0.0453726458218   ,
 0.062586880098    , 0.070328814796    , 0.067487878966    , 0.0644329425507   ,
 0.0784415540658   , 0.125741023613    , 0.217503578065    , 0.358462875938    ,
 0.544041366067    , 0.758907849895    , 0.982735102821    , 1.19855842733     ,
 1.38998463658     , 1.52729299221     , 1.56574205716     , 1.47113345795     ,
 1.25146808071     , 0.960716452181    , 0.668828246687    , 0.425641141735    ,
 0.248018765193    , 0.130754446095    , 0.0609659961749   , 0.0245557297141   ,
 0.00841175259315  , 0.00244622778686  , 0.000616822395956 , 0.000144420397413 ,
 3.70841514941e-05 , 1.36404862213e-05 , 7.73842837192e-06 , 5.16062835424e-06 ,
 3.16702752824e-06 , 1.61193342359e-06 , 6.55946945934e-07 , 2.10597253289e-07 ,
 5.30720024132e-08 , 1.04943333529e-08 , 1.9528778913e-09  , 4.93455511379e-09 ,
 5.26883269532e-08 , 4.5971331347e-07  , 3.15676713816e-06 , 4.33497391433e-06 ,
 1.85508321584e-05 , 6.31147373418e-05 , 0.000172404127548 , 0.000385758030455 ,
 0.000735161609089 , 0.00126838064807  , 0.00209586531218  , 0.00332184615763  ,
 0.00478020413481  , 0.00587222678948  , 0.00591984785564  , 0.0048119701943   ,
 0.0031809360943   , 0.00191381413892  , 0.00164507654107  , 0.00264817124167  ,
 0.00479750041524  , 0.00738792619371  , 0.00934022081456  , 0.0101684450783   ,
 0.0108308441737   , 0.0131695118814   , 0.0181525989563   , 0.0246469390208   ,
 0.0299637930695   , 0.0317215316159   , 0.0294207293396   , 0.0243745692494   ,
 0.0183376710601   , 0.0125286546067   , 0.00771876036845  , 0.00447071521722  ,
 0.00296811735524  , 0.0028478001954   , 0.0034155651084   , 0.00433841550653  ,
 0.00678008966002  , 0.014348170629    , 0.0321427052402   , 0.0623077004695   ,
 0.0984690454218   , 0.126488193001    , 0.134548211847    , 0.122713474808    ,
 0.10122441189     , 0.0817941956626   , 0.0722015251825   , 0.0749216105569   ,
 0.0863277122341   , 0.0979522976499   , 0.101306541387    , 0.0930602690053   ,
 0.0768361218361   , 0.0607076342163   , 0.0521159629286   , 0.053842304679    ,
 0.0639311800593   , 0.0790347005365   , 0.0981797896769   , 0.123117083699    ,
 0.153244179594    , 0.180416570933    , 0.192642760727    , 0.184518548087    ,
 0.160995328033    , 0.130281075666    , 0.0972371363317   , 0.0648321841713   ,
 0.03722618631     , 0.0181252803499   , 0.00780224241437  , 0.00348059185293  ,
 0.00194905860795  , 0.00126207040856  , 0.000757051903626 , 0.000375073117944 ,
 0.00014804995083  , 4.60755992193e-05 , 1.12645639135e-05 , 2.15936248338e-06 ,
 3.24142328658e-07 , 3.80619023662e-08 , 3.49313078466e-09 , 2.50380112177e-10 ,
 1.40085466441e-11 , 6.11491406972e-13 , 2.08174576592e-14 , 5.52553469472e-16 ,
 1.13061829425e-17 , 2.06961787073e-22 , 3.66301221309e-21 , 5.06682585183e-20 ,
 5.4783276906e-19  , 4.63161491909e-18 , 3.06372984547e-17 , 1.58701570491e-16 ,
 6.44528398083e-16 , 2.05550923198e-15 , 5.15884727905e-15 , 1.02280306418e-14 ,
 1.62313604875e-14 , 2.24138693996e-14 , 4.76300802513e-14 , 4.54426191234e-13 ,
 8.40249855692e-12 , 1.45179750053e-10 , 2.03166049143e-09 , 2.2455938683e-08  ,
 1.95584172683e-07 , 1.3471905426e-06  , 7.39098182747e-06 , 3.26594238516e-05 ,
 0.000118132932044 , 0.000357016054024 , 0.000920129825961 , 0.00204860150888  ,
 0.00394185288725  , 0.00650342610879  , 0.00915563158806  , 0.011101199851    ,
 0.0118984078931   , 0.0116049535116   , 0.0103617096368   , 0.00824481062671  ,
 0.00561221436603  , 0.00315926325289  , 0.00144052082864  , 0.000527938104812 ,
 0.000164201214585 , 8.95711428819e-05 , 0.000240603203944 , 0.000881934019149 ,
 0.00281380192083  , 0.00744991678835  , 0.0160505043627   , 0.0277895753934   ,
 0.0384625121879   , 0.0428689011037   , 0.0402140926967   , 0.0368925224291   ,
 0.0433719694822   , 0.0691431807952   , 0.120755157915    , 0.202364044888    ,
 0.315247574964    , 0.455599662783    , 0.613525906082    , 0.774891518675    ,
 0.922342821865    , 1.03218001591     , 1.07387234552     , 1.02253180824     ,
 0.879214655214    , 0.678325701354    , 0.470483824215    , 0.295282508914    ,
 0.168073526352    , 0.0858912203587   , 0.0385637921118   , 0.0148453986738   ,
 0.00480935467327  , 0.00129980526742  , 0.000294279271572 , 5.73243951968e-05 ,
 1.04762024949e-05 , 2.30844178959e-06 , 8.81702090277e-07 , 5.12675568104e-07 ,
 3.04446025219e-07 , 1.53663441614e-07 , 6.23473250017e-08 , 1.99811051732e-08 ,
 5.02661722364e-09 , 9.94809381919e-10 , 2.37586001668e-10 , 1.22297218444e-09 ,
 1.33851639369e-08 , 1.16755437688e-07 , 8.01220138452e-07 , 8.82375700397e-07 ,
 3.77580360046e-06 , 1.28592532285e-05 , 3.5270729421e-05  , 7.9848882395e-05  ,
 0.000156306898732 , 0.000282637445511 , 0.000494712775943 , 0.000822739967188 ,
 0.00121935698642  , 0.00152023938471  , 0.00154221795431  , 0.00125558261443  ,
 0.000829365737567 , 0.000500995048198 , 0.000442463648517 , 0.000731416749949 ,
 0.0013376982464   , 0.00207253657361  , 0.00265311378995  , 0.0029909003831   ,
 0.00345158942401  , 0.00469177744105  , 0.00707867154293  , 0.0101724357635   ,
 0.0127735568656   , 0.0136478869768   , 0.0124242078103   , 0.00979932601889  ,
 0.00685303817058  , 0.00431654576831  , 0.00245985940153  , 0.00131570726688  ,
 0.000799757220881 , 0.000729621825872 , 0.000901396586178 , 0.00132460392548  ,
 0.0026700538327   , 0.00672000893171  , 0.0160165957018   , 0.0318350474917   ,
 0.0515343671605   , 0.0687483942812   , 0.077642727103    , 0.076769629754    ,
 0.0686185481502   , 0.0574459803829   , 0.0483289877126   , 0.0456036142581   ,
 0.0499609616961   , 0.057469557218    , 0.0621161930069   , 0.0596661057739   ,
 0.0502627243999   , 0.0383396759773   , 0.0297866083808   , 0.0285974388173   ,
 0.0358787219057   , 0.0516458166676   , 0.0770326960785   , 0.113256347351    ,
 0.156134100213    , 0.192644104127    , 0.208223735454    , 0.199663929095    ,
 0.176713595826    , 0.149547358139    , 0.119967091349    , 0.0868951495537   ,
 0.0542708680297   , 0.0290580551938   , 0.0144234103484   , 0.00799464433696  ,
 0.00542911368442  , 0.00382542007453  , 0.00235011308966  , 0.00117102156838  ,
 0.000462833072805 , 0.000144083500267 , 3.52278248369e-05 , 6.75309982548e-06 ,
 1.01371225056e-06 , 1.19033640663e-07 , 1.09243128405e-08 , 7.8303130769e-10  ,
 4.38099113871e-11 , 1.91236000303e-12 , 6.51038966995e-14 , 1.72803925273e-15 ,
 3.53585911854e-17 , 3.89163608553e-24 , 6.9407865899e-23  , 9.65757083531e-22 ,
 1.04886948686e-20 , 8.8969021421e-20  , 5.89878039545e-19 , 3.06002439573e-18 ,
 1.2435804257e-17  , 3.96558991165e-17 , 9.94501889275e-17 , 1.97070265475e-16 ,
 3.16347083535e-16 , 5.30097881263e-16 , 3.73882300604e-15 , 8.64693233472e-14 ,
 1.92845872112e-12 , 3.45620727913e-11 , 4.87523409834e-10 , 5.40377502625e-09 ,
 4.7199418063e-08  , 3.26683049752e-07 , 1.80793139602e-06 , 8.1114882361e-06  ,
 3.00772249465e-05 , 9.42562674799e-05 , 0.000254320642611 , 0.00059456826103  ,
 0.0011952292103   , 0.00203857699618  , 0.00292939259155  , 0.0035758186764   ,
 0.00380233325263  , 0.00363185230298  , 0.0031547862404   , 0.00244399896565  ,
 0.00162646424932  , 0.000898627634749 , 0.000403146099927 , 0.00014550777583  ,
 4.49506672023e-05 , 2.87894204491e-05 , 9.64418562307e-05 , 0.000389914744558 ,
 0.00131756071688  , 0.00360567338927  , 0.00790278088262  , 0.013784167828    ,
 0.0191020580538   , 0.0212192424119   , 0.019745241407    , 0.0178895103861   ,
 0.0208151779947   , 0.0331485500925   , 0.0584565617347   , 0.100453391787    ,
 0.163165057126    , 0.247974566823    , 0.349330372943    , 0.454203494098    ,
 0.546864579302    , 0.612989767454    , 0.638900043768    , 0.612497436776    ,
 0.532132047322    , 0.414664646613    , 0.289456802788    , 0.181901890858    ,
 0.103090031243    , 0.0521300988473   , 0.0229873229094   , 0.00860917420599  ,
 0.00268106836786  , 0.000685758178772 , 0.000143641858484 , 2.48440047025e-05 ,
 3.66110166405e-06 , 5.16219521762e-07 , 1.03174648043e-07 , 4.24568720842e-08 ,
 2.33201428677e-08 , 1.15947083428e-08 , 4.68634512728e-09 , 1.49924420151e-09 ,
 3.76627894988e-10 , 7.50129485932e-11 , 2.87120540553e-11 , 2.46827052528e-10 ,
 2.72676452837e-09 , 2.37806733152e-08 , 1.63139088796e-07 , 1.4389327735e-07  ,
 6.16172195799e-07 , 2.10366051345e-06 , 5.8107639992e-06  , 1.33870180701e-05 ,
 2.71712033797e-05 , 5.19932894147e-05 , 9.67344714371e-05 , 0.000168334695685 ,
 0.000255962897821 , 0.000323123950947 , 0.000329594135519 , 0.0002688358621   ,
 0.000177573276124 , 0.00010744359787  , 9.60762255379e-05 , 0.000160870002161 ,
 0.00029594071411  , 0.000461414545674 , 0.000600263780631 , 0.000708518574978 ,
 0.000902110254684 , 0.00138187400447  , 0.00227472540432  , 0.00344813005297  ,
 0.00446786492001  , 0.00483068177864  , 0.00434980730415  , 0.00330286861322  ,
 0.00216491469665  , 0.00125660784663  , 0.000657846493782 , 0.000322392885329 ,
 0.000176694724894 , 0.000150363332112 , 0.000196186215546 , 0.000358099001993 ,
 0.000926838036759 , 0.00262387963728  , 0.00651650931899  , 0.0133210509139   ,
 0.0224533234733   , 0.0319687207428   , 0.0396077185481   , 0.0435601540361   ,
 0.0426187918351   , 0.0371127397068   , 0.0299727912852   , 0.0253857993234   ,
 0.0256098751527   , 0.0293578455188   , 0.033006298602    , 0.0331157473201   ,
 0.028630368564    , 0.0215768673105   , 0.0157079062414   , 0.014371075691    ,
 0.0198299092112   , 0.0345573069288   , 0.0623165144353   , 0.105477148044    ,
 0.158289816425    , 0.204240537357    , 0.226487766254    , 0.223256422857    ,
 0.20732499482     , 0.188347198301    , 0.163079609002    , 0.126365106279    ,
 0.0838763804859   , 0.0482263668207   , 0.0266952269989   , 0.0170034247067   ,
 0.0126847716577   , 0.00924804059761  , 0.00573211186425  , 0.00286199339797  ,
 0.00113165717528  , 0.000352323776535 , 8.61430440156e-05 , 1.65134763575e-05 ,
 2.47884901177e-06 , 2.91075096875e-07 , 2.67134164868e-08 , 1.91476034317e-09 ,
 1.07129151263e-10 , 4.6763277314e-12  , 1.59199709822e-13 , 4.22560494136e-15 ,
 8.64629878505e-17 , 0, 0, 0, 0, 4.74629893958e-29 , 2.52988907715e-27 ,
 9.75485559303e-26 , 2.94844964025e-24 , 6.99645225564e-23 , 1.30531784986e-21 ,
 1.91771267945e-20 , 5.06586262114e-19 , 1.60952221621e-17 , 5.46740056486e-16 ,
 1.57940462385e-14 , 3.62715752307e-13 , 6.53812485721e-12 , 9.24090664841e-11 ,
 1.02637150318e-09 , 8.99664640349e-09 , 6.26786839779e-08 , 3.51029402679e-07 ,
 1.60743166113e-06 , 6.1542045912e-06  , 2.01531390284e-05 , 5.7229141657e-05  ,
 0.000140597747223 , 0.000294350169861 , 0.000516516751451 , 0.000754133727158 ,
 0.000923554347926 , 0.000972158904274 , 0.000907974860642 , 0.000766033703121 ,
 0.000576705024427 , 0.00037461569818  , 0.000202904712378 , 8.9492214122e-05  ,
 3.18241947372e-05 , 9.95509163592e-06 , 8.40951353013e-06 , 3.42136818074e-05 ,
 0.000146117029579 , 0.000507783715468 , 0.00141064508505  , 0.00311475817477  ,
 0.0054493567172   , 0.00755656285575  , 0.00839216990282  , 0.00782130657183  ,
 0.00714834214615  , 0.0084517147623   , 0.0136728211369   , 0.0247516417332   ,
 0.044684917404    , 0.0776443255587   , 0.126130959988    , 0.186297766472    ,
 0.246897429893    , 0.295224406857    , 0.324074632078    , 0.33133664911     ,
 0.315223750451    , 0.275047385115    , 0.216859120568    , 0.153668105569    ,
 0.0981072220554   , 0.0564020638604   , 0.0288029773324   , 0.012731491369    ,
 0.00473387433202  , 0.00144708782023  , 0.0003584403562   , 7.14684391687e-05 ,
 1.14765712377e-05 , 1.49847878581e-06 , 1.64598577264e-07 , 1.78679897388e-08 ,
 3.43413837815e-09 , 1.4547158577e-09  , 6.94413294073e-10 , 2.78754938304e-10 ,
 8.8999506297e-11  , 2.23326088892e-11 , 4.54042087657e-12 , 3.49833098027e-12 ,
 4.01111070014e-11 , 4.4465700594e-10  , 3.87779124713e-09 , 2.66009121278e-08 ,
 1.87645009471e-08 , 8.04721227491e-08 , 2.75861205726e-07 , 7.69987102993e-07 ,
 1.81696146334e-06 , 3.85925307011e-06 , 7.86742468785e-06 , 1.55415955235e-05 ,
 2.81466517386e-05 , 4.37143304777e-05 , 5.57448515008e-05 , 5.71246972055e-05 ,
 4.66827914434e-05 , 3.08439285029e-05 , 1.86533206009e-05 , 1.67118989321e-05 ,
 2.81006843509e-05 , 5.19008398383e-05 , 8.1520366871e-05  , 0.000108347177178 ,
 0.000135887032925 , 0.000194484436935 , 0.000336356140577 , 0.000599381734651 ,
 0.000952260993837 , 0.00126850944543  , 0.00138777757157  , 0.00124239238886  ,
 0.000917733270058 , 0.000570577805479 , 0.000307078997318 , 0.000147234187737 ,
 6.55954936034e-05 , 3.1998516975e-05  , 2.51233779222e-05 , 3.64331431515e-05 ,
 8.72409748021e-05 , 0.000275547760457 , 0.000840757503688 , 0.00216546016203  ,
 0.00461951697392  , 0.00832751650062  , 0.013061269524    , 0.0181469332982   ,
 0.0222086229407   , 0.0234338327923   , 0.0210254219575   , 0.0164633868812   ,
 0.0126167083964   , 0.0114521622531   , 0.0127737474505   , 0.0147596019854   ,
 0.0153534354415   , 0.0136021916142   , 0.0102629314346   , 0.0072721290914   ,
 0.0067711958132   , 0.0110756935622   , 0.0238905041614   , 0.0507957367309   ,
 0.095612291217    , 0.152774352524    , 0.20472396586     , 0.233867775692    ,
 0.239426674261    , 0.235443345659    , 0.229439225135    , 0.21222173424     ,
 0.173942749897    , 0.121746218463    , 0.0745048015585   , 0.0447351644842   ,
 0.0308239719348   , 0.023939020791    , 0.0176551704527   , 0.0109677046572   ,
 0.00547765247475  , 0.00216588227411  , 0.000674294663268 , 0.000164862496759 ,
 3.16036879033e-05 , 4.74404147285e-06 , 5.57061528723e-07 , 5.11243097982e-08 ,
 3.66448052714e-09 , 2.05024444734e-10 , 8.94958545025e-12 , 3.04677406835e-13 ,
 8.08698933733e-15 , 1.65473410441e-16 , 0, 0, 0, 0, 9.80289551267e-31 ,
 5.21905130454e-29 , 2.01175647766e-27 , 6.0784031187e-26  , 1.44172599611e-24 ,
 2.68840591196e-23 , 3.94728351255e-22 , 4.6851521636e-20  , 2.13245892472e-18 ,
 7.94112197108e-17 , 2.33837509297e-15 , 5.39202992754e-14 , 9.73322864909e-13 ,
 1.37772728237e-11 , 1.53422306254e-10 , 1.35148829388e-09 , 9.50298842845e-09 ,
 5.41075578483e-08 , 2.54668832125e-07 , 1.01557434161e-06 , 3.50215678687e-06 ,
 1.05029509195e-05 , 2.70713065199e-05 , 5.87527763263e-05 , 0.000105531969046 ,
 0.000155902493231 , 0.000191010410651 , 0.000198713225096 , 0.000181275745067 ,
 0.000148325161527 , 0.000108315289499 , 6.85626392926e-05 , 3.63633170136e-05 ,
 1.57565855262e-05 , 5.52373259064e-06 , 1.79836810428e-06 , 2.17541254568e-06 ,
 1.0162805578e-05  , 4.45915411454e-05 , 0.000156923164523 , 0.000438751484046 ,
 0.000971733122261 , 0.00170221151249  , 0.00236199707274  , 0.00262822402648  ,
 0.00246986907997  , 0.00231524205509  , 0.00285269751763  , 0.00481290271639  ,
 0.00923111078787  , 0.0181174281665   , 0.0344718805646   , 0.0602423126683   ,
 0.0928339241584   , 0.124188116311    , 0.145507237743    , 0.153465797519    ,
 0.150415687375    , 0.139182967558    , 0.120544087585    , 0.0959037284206   ,
 0.0692964821763   , 0.0453639085307   , 0.0267607792206   , 0.01396496475     ,
 0.00626115870952  , 0.00234110659723  , 0.000713352404243 , 0.000174503668571 ,
 3.39911723852e-05 , 5.25630291036e-06 , 6.46291254762e-07 , 6.37173290359e-08 ,
 5.21668402975e-09 , 4.42547543519e-10 , 8.39307542938e-11 , 3.34550418933e-11 ,
 1.31443862625e-11 , 4.1825901143e-12  , 1.04872015476e-12 , 2.25872963045e-13 ,
 3.99606670494e-13 , 5.21955280515e-12 , 5.7939313126e-11  , 5.05327469111e-10 ,
 3.46709960024e-09 , 1.95289599034e-09 , 8.39468354459e-09 , 2.89485937158e-08 ,
 8.19703964047e-08 , 1.99516314693e-07 , 4.47150650624e-07 , 9.73952047928e-07 ,
 2.03320671229e-06 , 3.80744929073e-06 , 6.01391938528e-06 , 7.73064100687e-06 ,
 7.95239706873e-06 , 6.51042373187e-06 , 4.30311791404e-06 , 2.59726049868e-06 ,
 2.31615690453e-06 , 3.89122924315e-06 , 7.21024926431e-06 , 1.14308113226e-05 ,
 1.56401842316e-05 , 2.12363966586e-05 , 3.47206522831e-05 , 6.74283726804e-05 ,
 0.000128651634548 , 0.000212565484762 , 0.000289738360959 , 0.000320312616579 ,
 0.000286020273494 , 0.000207337401748 , 0.000123861917899 , 6.25357394402e-05 ,
 2.75645733767e-05 , 1.11141344743e-05 , 4.77671156051e-06 , 3.46347666493e-06 ,
 6.00835828791e-06 , 1.89278876395e-05 , 6.84716890404e-05 , 0.000220552213953 ,
 0.000595021290058 , 0.0013587843884   , 0.00270179612842  , 0.00476425667898  ,
 0.00739733616935  , 0.00984680806926  , 0.0109301992052   , 0.00998498670323  ,
 0.00765047716213  , 0.00541217519483  , 0.00438681027304  , 0.00464368750464  ,
 0.00542892008239  , 0.00580016735074  , 0.00524341593362  , 0.0039880499324   ,
 0.00285658833899  , 0.0030080590174   , 0.00631377405749  , 0.0164894662408   ,
 0.0393880548809   , 0.0794727936615   , 0.132552407041    , 0.183221607338    ,
 0.216181802633    , 0.232101752396    , 0.244509174402    , 0.257289182945    ,
 0.254738543593    , 0.221120379507    , 0.163102244453    , 0.105077889069    ,
 0.0659836229255   , 0.0464965264649   , 0.0361612190246   , 0.0265738716074   ,
 0.0164705555113   , 0.00821797641092  , 0.00324825507749  , 0.00101114169148  ,
 0.000247210455305 , 4.73889634562e-05 , 7.11354687606e-06 , 8.35295909206e-07 ,
 7.6659235199e-08  , 5.49476841361e-09 , 3.07427418361e-10 , 1.34196092686e-11 ,
 4.56853758804e-13 , 1.21261747451e-14 , 2.48121940932e-16 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 2.175644038e-30   , 4.92896129359e-21 , 2.43722693839e-19 ,
 9.22350340643e-18 , 2.72550702043e-16 , 6.29165491809e-15 , 1.13697111033e-13 ,
 1.6125083515e-12  , 1.80239552836e-11 , 1.59907470669e-10 , 1.1393030752e-09  ,
 6.63780743415e-09 , 3.24033407996e-08 , 1.35886095272e-07 , 4.96559036477e-07 ,
 1.57340881414e-06 , 4.23720546758e-06 , 9.47930724192e-06 , 1.73415959781e-05 ,
 2.58278599165e-05 , 3.15883446277e-05 , 3.24436870694e-05 , 2.88891166895e-05 ,
 2.28977190466e-05 , 1.61893255591e-05 , 9.96808934736e-06 , 5.17048486087e-06 ,
 2.19973173898e-06 , 7.61215063755e-07 , 2.68684081791e-07 , 4.79724228008e-07 ,
 2.44116673417e-06 , 1.08463513699e-05 , 3.8375677979e-05  , 0.000107581393185 ,
 0.000238556844806 , 0.000418136142506 , 0.000580744821378 , 0.000648563862367 ,
 0.000618049816182 , 0.000603116979387 , 0.000794672600583 , 0.00144743453616  ,
 0.00306137115246  , 0.00672197308379  , 0.0140888704975   , 0.0262679376649   ,
 0.0418197087558   , 0.0561501966997   , 0.0642535082589   , 0.0646312863347   ,
 0.0597453691156   , 0.0526606749717   , 0.0445460463705   , 0.0355015007352   ,
 0.0261506288992   , 0.0176093435978   , 0.0106984421918   , 0.00572261345349  ,
 0.00261039780508  , 0.000985697403415 , 0.00030137764679  , 7.35573037358e-05 ,
 1.42129456047e-05 , 2.1649515571e-06  , 2.5962655811e-07  , 2.45470174142e-08 ,
 1.841811913e-09   , 1.13749473549e-10 , 7.75412163785e-12 , 1.42883997412e-12 ,
 4.95639865896e-13 , 1.55797429437e-13 , 3.90449534175e-14 , 9.74580645568e-15 ,
 3.94105349302e-14 , 5.42064873093e-13 , 6.02071873148e-12 , 5.25216203976e-11 ,
 3.6049962526e-10  , 1.61862791155e-10 , 6.98080580978e-10 , 2.4268583313e-09  ,
 7.0025077131e-09  , 1.77086014392e-08 , 4.21466282968e-08 , 9.79981775743e-08 ,
 2.14716753883e-07 , 4.13100076235e-07 , 6.61134809309e-07 , 8.5519731092e-07  ,
 8.82484748802e-07 , 7.23629405019e-07 , 4.78463329176e-07 , 2.87997992378e-07 ,
 2.54744753373e-07 , 4.26475331448e-07 , 7.92853026159e-07 , 1.27249662534e-06 ,
 1.81188503687e-06 , 2.7230252325e-06  , 5.13520823053e-06 , 1.10635547653e-05 ,
 2.23261001726e-05 , 3.80659036324e-05 , 5.28445702616e-05 , 5.89339226827e-05 ,
 5.25911835422e-05 , 3.76609244258e-05 , 2.18715274064e-05 , 1.05081204404e-05 ,
 4.3039768684e-06  , 1.57458436446e-06 , 5.93644197852e-07 , 4.04958285887e-07 ,
 9.01419286405e-07 , 3.55389256194e-06 , 1.40665014452e-05 , 4.78372803056e-05 ,
 0.000138262598003 , 0.000348207589902 , 0.000778868143153 , 0.001536811196    ,
 0.00260030050012  , 0.00365638941317  , 0.00418019902612  , 0.00385475585157  ,
 0.00291026101032  , 0.00194117201828  , 0.00141317062112  , 0.00138977061002  ,
 0.00161676614912  , 0.00175772438566  , 0.00161438168479  , 0.00124475665538  ,
 0.000947366436994 , 0.0012911912477   , 0.00355323262043  , 0.0106143022542   ,
 0.0272091150735   , 0.0572872211293   , 0.0984534780482   , 0.14003988651     ,
 0.172117303457    , 0.197729005428    , 0.228569400408    , 0.263804383759    ,
 0.281237319323    , 0.258518573556    , 0.199664163949    , 0.132911258194    ,
 0.084032169389    , 0.0577955906435   , 0.0436462216841   , 0.0315593419159   ,
 0.0194366171519   , 0.0096767751872   , 0.00382216423633  , 0.00118952839573  ,
 0.000290803633482 , 5.5744381173e-05  , 8.36772360253e-06 , 9.82563551752e-07 ,
 9.01746626958e-08 , 6.46352394409e-09 , 3.61628405137e-10 , 1.57855532099e-11 ,
 5.37399351531e-13 , 1.42640797389e-14 , 2.91867074721e-16 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 4.49845262595e-22 , 2.22435711339e-20 , 8.41929105904e-19 ,
 2.48942212169e-17 , 5.75091097137e-16 , 1.04075501372e-14 , 1.48023202274e-13 ,
 1.6636488889e-12  , 1.49142064438e-11 , 1.08285157756e-10 , 6.51206371271e-10 ,
 3.33230940606e-09 , 1.48264433318e-08 , 5.75890951984e-08 , 1.92200800453e-07 ,
 5.3749289555e-07  , 1.23205070373e-06 , 2.28510365586e-06 , 3.42090726233e-06 ,
 4.16994788051e-06 , 4.22622025459e-06 , 3.67271832207e-06 , 2.81755493604e-06 ,
 1.92525393915e-06 , 1.150792813e-06   , 5.82987753794e-07 , 2.43376074855e-07 ,
 8.3345114701e-08  , 3.373571905e-08   , 8.71389908856e-08 , 4.65650803087e-07 ,
 2.08070556722e-06 , 7.37824830449e-06 , 2.07056095454e-05 , 4.59356823496e-05 ,
 8.05481896995e-05 , 0.00011201943874  , 0.000125770418875 , 0.00012224248222  ,
 0.000126193849041 , 0.00018324442897  , 0.000375549318987 , 0.000907256559825 ,
 0.00224608238017  , 0.00511756182129  , 0.0100171879602   , 0.0163178031229   ,
 0.0219544020585   , 0.0246409365156   , 0.0237383272773   , 0.0206040487214   ,
 0.0170305582237   , 0.0138215070541   , 0.0109105427553   , 0.00815690926953  ,
 0.00564184203204  , 0.0035252661223   , 0.00192937536421  , 0.0008941383993   ,
 0.000340882396128 , 0.00010473351797  , 2.55958467281e-05 , 4.9371643728e-06  ,
 7.4835931202e-07  , 8.89441971396e-08 , 8.28387936807e-09 , 6.05183056359e-10 ,
 3.4860371657e-11  , 1.64872164707e-12 , 9.30068422567e-14 , 1.60864555815e-14 ,
 4.62648280214e-15 , 1.15490924436e-15 , 3.99241249649e-16 , 3.1957950353e-15  ,
 4.48110703635e-14 , 4.97891863361e-13 , 4.34467910933e-12 , 2.98389878085e-11 ,
 1.06606521894e-11 , 4.61806689703e-11 , 1.62261696815e-10 , 4.79499677757e-10 ,
 1.26882087496e-09 , 3.21951689655e-09 , 7.95935277621e-09 , 1.8164721442e-08  ,
 3.5701346404e-08  , 5.7718831879e-08  , 7.50248709617e-08 , 7.76147853708e-08 ,
 6.37320174667e-08 , 4.21532066594e-08 , 2.52971586618e-08 , 2.21645617488e-08 ,
 3.69375472963e-08 , 6.89511162798e-08 , 1.12541249718e-07 , 1.69267729112e-07 ,
 2.88186877005e-07 , 6.26925646779e-07 , 1.47412984395e-06 , 3.10935318169e-06 ,
 5.43274154362e-06 , 7.64996346809e-06 , 8.59193919775e-06 , 7.67054353632e-06 ,
 5.4516244068e-06  , 3.10648682787e-06 , 1.43995391214e-06 , 5.56293369805e-07 ,
 1.86659236118e-07 , 6.20785617107e-08 , 4.14635500803e-08 , 1.22075188705e-07 ,
 5.63869891554e-07 , 2.39756850604e-06 , 8.75279438113e-06 , 2.78715915614e-05 ,
 7.89258271107e-05 , 0.000197653987276 , 0.000425365398599 , 0.000761039637122 ,
 0.0011045681073   , 0.00128296795799  , 0.00118835076739  , 0.000888312997191 ,
 0.000568355338479 , 0.000376562867989 , 0.000338830840723 , 0.000385830766054 ,
 0.000423270165205 , 0.000393665982766 , 0.000310826063335 , 0.000273073254968 ,
 0.000540601731057 , 0.00184633284574  , 0.00596898546372  , 0.0159339149395   ,
 0.0344712677571   , 0.0607109061942   , 0.0893037128729   , 0.116572529654    ,
 0.148007652871    , 0.192914382831    , 0.24626173129     , 0.281536712541    ,
 0.271536498798    , 0.216732547834    , 0.146291167979    , 0.0906638792794   ,
 0.058961000967    , 0.0421666111988   , 0.0296332646003   , 0.0180544963607   ,
 0.00895655115519  , 0.0035337037016   , 0.00109937307049  , 0.00026873510652  ,
 5.15124142245e-05 , 7.73239450487e-06 , 9.07958695709e-07 , 8.33277393556e-08 ,
 5.97274983263e-09 , 3.34169996566e-10 , 1.4586957631e-11  , 4.96594669031e-13 ,
 1.31810094984e-14 , 2.69705635035e-16 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 3.21048509191e-23 , 1.58749514511e-21 , 6.00996073545e-20 , 1.77870053197e-18 ,
 4.11353931459e-17 , 7.46040523982e-16 , 1.06556276629e-14 , 1.20741704944e-13 ,
 1.09906736765e-12 , 8.19684118669e-12 , 5.14389829764e-11 , 2.78958649898e-10 ,
 1.32486091403e-09 , 5.46267110936e-09 , 1.90832329985e-08 , 5.5024147582e-08  ,
 1.28491282732e-07 , 2.40670611071e-07 , 3.61324796297e-07 , 4.3854240254e-07  ,
 4.38603420186e-07 , 3.72156867355e-07 , 2.76251373904e-07 , 1.82137703626e-07 ,
 1.05462974335e-07 , 5.20939087207e-08 , 2.13247684183e-08 , 7.25848276893e-09 ,
 3.60416827909e-09 , 1.27342849341e-08 , 6.99108146519e-08 , 3.13181649159e-07 ,
 1.11154045139e-06 , 3.12052337435e-06 , 6.92436794528e-06 , 1.21471879021e-05 ,
 1.69237213159e-05 , 1.91397507634e-05 , 1.91071823361e-05 , 2.12998436944e-05 ,
 3.54152025999e-05 , 8.51327225027e-05 , 0.000238497093404 , 0.000656021879555 ,
 0.00159014074923  , 0.00321853973839  , 0.00532760650992  , 0.00718530692603  ,
 0.007962085777    , 0.00741983159513  , 0.00608284584649  , 0.00468399593202  ,
 0.00358874590629  , 0.00276686480228  , 0.0020834254202   , 0.00147378251849  ,
 0.000943594207256 , 0.000526554002416 , 0.000247241542633 , 9.50127023782e-05 ,
 2.93212134773e-05 , 7.18046814287e-06 , 1.38547660517e-06 , 2.09756888435e-07 ,
 2.48591397559e-08 , 2.30352472382e-09 , 1.66836579986e-10 , 9.45072464626e-12 ,
 4.20631255377e-13 , 1.54227334309e-14 , 7.34929251158e-16 , 1.14858318902e-16 ,
 2.70228276164e-17 , 1.66438886237e-17 , 2.08303521021e-16 , 2.94161625523e-15 ,
 3.26934270225e-14 , 2.85400145033e-13 , 1.96167672157e-12 , 5.56709968409e-13 ,
 2.42549876443e-12 , 8.63914147751e-12 , 2.6290805152e-11  , 7.32613529893e-11 ,
 1.98421434603e-10 , 5.1839348138e-10  , 1.22326538185e-09 , 2.44449460013e-09 ,
 3.98281255708e-09 , 5.19652715295e-09 , 5.38683828479e-09 , 4.42850717942e-09 ,
 2.92987499667e-09 , 1.75319073738e-09 , 1.52155134008e-09 , 2.52433749238e-09 ,
 4.73883113261e-09 , 7.91912655647e-09 , 1.28309594672e-08 , 2.52549032213e-08 ,
 6.27368405091e-08 , 1.58203902988e-07 , 3.45222817102e-07 , 6.14566468667e-07 ,
 8.74850964149e-07 , 9.88083928143e-07 , 8.82954339748e-07 , 6.24747790715e-07 ,
 3.51665216032e-07 , 1.59066453862e-07 , 5.88639219872e-08 , 1.84172279847e-08 ,
 5.49662672482e-09 , 3.80219673517e-09 , 1.45151064749e-08 , 7.49841764866e-08 ,
 3.44307911202e-07 , 1.38311367974e-06 , 4.94605168597e-06 , 1.56868253478e-05 ,
 4.28938462747e-05 , 9.76975437258e-05 , 0.000180549257198 , 0.000266568885892 ,
 0.000312159351112 , 0.000289691364301 , 0.000215099723809 , 0.000133674007971 ,
 8.18629220242e-05 , 6.68064417421e-05 , 7.33035733927e-05 , 8.05303982517e-05 ,
 7.57490516979e-05 , 6.2714773193e-05  , 7.24386773381e-05 , 0.000212940776944 ,
 0.000831283721209 , 0.0028058039377   , 0.00767437618707  , 0.0169458748501   ,
 0.0306491229065   , 0.0473400560627   , 0.0677968857768   , 0.0985807059874   ,
 0.146573960667    , 0.204840468524    , 0.247297840153    , 0.246681116364    ,
 0.200803221051    , 0.135744154198    , 0.0814763474325   , 0.0492958523767   ,
 0.0327295683294   , 0.0220656631504   , 0.0132282068143   , 0.00652711047493  ,
 0.00257086453678  , 0.000799412440928 , 0.000195381239718 , 3.74498586932e-05 ,
 5.62142295619e-06 , 6.60079977639e-07 , 6.05786419731e-08 , 4.34214277025e-09 ,
 2.42938958011e-10 , 1.06046033164e-11 , 3.61020413395e-13 , 9.5824900967e-15  ,
 1.96073872571e-16 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.79018007679e-24 ,
 8.8519439183e-23  , 3.35203652846e-21 , 9.93489956018e-20 , 2.30139814049e-18 ,
 4.18747647037e-17 , 6.01921803186e-16 , 6.90428447692e-15 , 6.42617648976e-14 ,
 4.97494320184e-13 , 3.29797705712e-12 , 1.9126454884e-11  , 9.70837268454e-11 ,
 4.22502757213e-10 , 1.53241598436e-09 , 4.52363126153e-09 , 1.07079949748e-08 ,
 2.01922052424e-08 , 3.03516639268e-08 , 3.66621762468e-08 , 3.62031420263e-08 ,
 3.00229061831e-08 , 2.15708847856e-08 , 1.37059573591e-08 , 7.6705966707e-09  ,
 3.68705681832e-09 , 1.47866795035e-09 , 5.03828216324e-10 , 3.28409612585e-10 ,
 1.47635451085e-09 , 8.22536290981e-09 , 3.68887411032e-08 , 1.30967818494e-07 ,
 3.6772397273e-07  , 8.16082326396e-07 , 1.43243291224e-06 , 2.00052917073e-06 ,
 2.28457224467e-06 , 2.36511842236e-06 , 2.93197748502e-06 , 5.85090634599e-06 ,
 1.69639909156e-05 , 5.45116504059e-05 , 0.000162352950651 , 0.000410454388743 ,
 0.000849746797439 , 0.00142313991372  , 0.00192562899744  , 0.00211887883705  ,
 0.00193003176313  , 0.0015113084912   , 0.00108687644152  , 0.000777388347013 ,
 0.000576564523662 , 0.000432848705951 , 0.000311274687237 , 0.000203293663296 ,
 0.00011524659061  , 5.46810253962e-05 , 2.11457786598e-05 , 6.5489293274e-06  ,
 1.60677083214e-06 , 3.10270830697e-07 , 4.69733638937e-08 , 5.56283812749e-09 ,
 5.14641043011e-10 , 3.71685381682e-11 , 2.09514616658e-12 , 9.22101253212e-14 ,
 3.17828824577e-15 , 8.88471012171e-17 , 2.93960289632e-18 , 3.13007720536e-19 ,
 6.51604103892e-19 , 1.07984626632e-17 , 1.52976426533e-16 , 1.70068363382e-15 ,
 1.48533975488e-14 , 1.02197713335e-13 , 2.30016884742e-14 , 1.00954680299e-13 ,
 3.65788804125e-13 , 1.15312437474e-12 , 3.40147118803e-12 , 9.81902384427e-12 ,
 2.69169761763e-11 , 6.5245648135e-11  , 1.32065664873e-10 , 2.16453877139e-10 ,
 2.83240253527e-10 , 2.94089245994e-10 , 2.42005619071e-10 , 1.60145659363e-10 ,
 9.55769760037e-11 , 8.2228411035e-11  , 1.35926752706e-10 , 2.57267480376e-10 ,
 4.445371719e-10   , 7.94770434475e-10 , 1.83092000305e-09 , 5.10119997916e-09 ,
 1.35737413925e-08 , 3.03878517956e-08 , 5.48668308939e-08 , 7.87520366391e-08 ,
 8.93350234842e-08 , 7.99197346005e-08 , 5.64078660006e-08 , 3.15093743921e-08 ,
 1.40258204086e-08 , 5.03823330078e-09 , 1.49656698066e-09 , 4.11236905548e-10 ,
 3.12614607428e-10 , 1.48053078514e-09 , 8.41576986766e-09 , 4.25125712397e-08 ,
 1.91433876349e-07 , 7.66884919883e-07 , 2.65983903602e-06 , 7.70857543457e-06 ,
 1.81513842661e-05 , 3.41422620141e-05 , 5.08616023315e-05 , 5.98064598982e-05 ,
 5.55415234847e-05 , 4.10515801105e-05 , 2.49954689963e-05 , 1.43608791859e-05 ,
 1.05986704479e-05 , 1.10429921917e-05 , 1.20652334457e-05 , 1.15099228401e-05 ,
 1.0552213085e-05  , 1.85318714842e-05 , 7.41969362263e-05 , 0.000310838093849 ,
 0.0010747167417   , 0.00299044484741  , 0.0067420546611   , 0.012663394085    ,
 0.0211320442653   , 0.0345689954327   , 0.0587093847952   , 0.0981761686852   ,
 0.146741858676    , 0.183713065609    , 0.187107580525    , 0.153896463921    ,
 0.103603961598    , 0.0601446505079   , 0.0337400827852   , 0.0205070390893   ,
 0.0130792452329   , 0.00766312900808  , 0.0037518559898   , 0.001474151668    ,
 0.000458046818195 , 0.000111924281327 , 2.14517386981e-05 , 3.21995577163e-06 ,
 3.78092121266e-07 , 3.46992299279e-08 , 2.48716257786e-09 , 1.39154465883e-10 ,
 6.07427439409e-12 , 2.06791049829e-13 , 5.48881202712e-15 , 1.12310330521e-16 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7.79371278669e-26 , 3.8537755802e-24  ,
 1.4598119762e-22  , 4.3362744725e-21  , 1.00701938625e-19 , 1.84144359961e-18 ,
 2.67270526752e-17 , 3.12193136464e-16 , 2.99992341145e-15 , 2.44153045794e-14 ,
 1.72959160773e-13 , 1.07743249908e-12 , 5.81990467259e-12 , 2.64991638834e-11 ,
 9.89424190244e-11 , 2.97156622344e-10 , 7.10178330467e-10 , 1.34511872751e-09 ,
 2.02213051057e-09 , 2.43075660624e-09 , 2.37207903638e-09 , 1.92549413996e-09 ,
 1.34042514505e-09 , 8.2026049341e-10  , 4.42749758981e-10 , 2.06621242697e-10 ,
 8.10895888776e-11 , 2.79701762043e-11 , 2.52765278277e-11 , 1.34728080036e-10 ,
 7.56685643823e-10 , 3.39519171992e-09 , 1.20552879708e-08 , 3.38494387596e-08 ,
 7.51327770002e-08 , 1.31977240791e-07 , 1.84913203716e-07 , 2.13951178275e-07 ,
 2.33060780731e-07 , 3.35647066209e-07 , 8.43139660626e-07 , 2.94965849725e-06 ,
 1.05636010575e-05 , 3.32217204935e-05 , 8.63569516618e-05 , 0.00018159047129  ,
 0.000306902378898 , 0.000416880673434 , 0.000457382381884 , 0.000410653550084 ,
 0.000310827149798 , 0.000210591643375 , 0.000139977635039 , 9.84476641095e-05 ,
 7.28091667603e-05 , 5.28513418781e-05 , 3.50471022012e-05 , 2.01172803404e-05 ,
 9.62347806385e-06 , 3.7396876498e-06  , 1.1614039337e-06  , 2.85380325606e-07 ,
 5.51496734598e-08 , 8.35171904161e-09 , 9.88969116572e-10 , 9.14526389972e-11 ,
 6.59900676119e-12 , 3.71400853761e-13 , 1.63010666555e-14 , 5.57992517039e-16 ,
 1.48989698412e-17 , 3.09833889318e-19 , 1.18734423682e-21 , 2.44924239977e-20 ,
 4.43432269886e-19 , 6.28786583958e-18 , 6.99249991942e-17 , 6.11060612081e-16 ,
 4.20972024779e-15 , 7.50434708492e-16 , 3.32449063806e-15 , 1.23034540122e-14 ,
 4.04195046043e-14 , 1.26664539767e-13 , 3.88290189067e-13 , 1.10874601917e-12 ,
 2.74545408135e-12 , 5.61228125454e-12 , 9.24027447384e-12 , 1.21186823021e-11 ,
 1.25990648419e-11 , 1.0376003992e-11  , 6.8675085044e-12  , 4.089299086e-12   ,
 3.49179063243e-12 , 5.75958358312e-12 , 1.10339763875e-11 , 1.9992359186e-11  ,
 4.04912100168e-11 , 1.09243272896e-10 , 3.34047287662e-10 , 9.2527074931e-10  ,
 2.11140557461e-09 , 3.85304296634e-09 , 5.56507433212e-09 , 6.33445004561e-09 ,
 5.67319425469e-09 , 3.99900051911e-09 , 2.22344757101e-09 , 9.79700027289e-10 ,
 3.45070149761e-10 , 9.88757588785e-11 , 2.57378458701e-11 , 2.27020062518e-11 ,
 1.2862637943e-10  , 8.09197473852e-10 , 4.57320527378e-09 , 2.30694669197e-08 ,
 1.01268500245e-07 , 3.7306593872e-07  , 1.11931555894e-06 , 2.68456894799e-06 ,
 5.09708209812e-06 , 7.62828424182e-06 , 8.98843112107e-06 , 8.34899109149e-06 ,
 6.15132393176e-06 , 3.69154589756e-06 , 2.01574618383e-06 , 1.34800213236e-06 ,
 1.31606875348e-06 , 1.42139422455e-06 , 1.39193508054e-06 , 1.57549053734e-06 ,
 4.50863336947e-06 , 2.17129503677e-05 , 9.42312608467e-05 , 0.000330887067588 ,
 0.000935955635135 , 0.00217187012818  , 0.00433643509214  , 0.0081415459912   ,
 0.0156901905072   , 0.0307947624241   , 0.0561524987772   , 0.0876372593754   ,
 0.11215630837     , 0.115613585533    , 0.0955747716114   , 0.0639786064238   ,
 0.0360692270528   , 0.0188611991593   , 0.0104187964861   , 0.00619802268511  ,
 0.00351924776354  , 0.00170414355796  , 0.000667241888871 , 0.000207103165318 ,
 5.05896309765e-05 , 9.69522760953e-06 , 1.4552346596e-06  , 1.70874429605e-07 ,
 1.56818825983e-08 , 1.12404115465e-09 , 6.28890532405e-11 , 2.74518936244e-12 ,
 9.34565272178e-14 , 2.4805972552e-15  , 5.07571941331e-17 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 2.64771581042e-27 , 1.30922254038e-25 , 4.9613827582e-24  ,
 1.47887675535e-22 , 3.44777103105e-21 , 6.35296936379e-20 , 9.35705275525e-19 ,
 1.12255051351e-17 , 1.12747554978e-16 , 9.77544199631e-16 , 7.45806210473e-15 ,
 4.98088555843e-14 , 2.83812669472e-13 , 1.33871405565e-12 , 5.10617066002e-12 ,
 1.55236727121e-11 , 3.73441285929e-11 , 7.09276925548e-11 , 1.06568590648e-10 ,
 1.2751432564e-10  , 1.23114298988e-10 , 9.80059846738e-11 , 6.6219276639e-11  ,
 3.90314668791e-11 , 2.02822732039e-11 , 9.16658055134e-12 , 3.51562122054e-12 ,
 1.24868114394e-12 , 1.61489513131e-12 , 9.63612575896e-12 , 5.4360278772e-11  ,
 2.43958731586e-10 , 8.66233202782e-10 , 2.43230456594e-09 , 5.3999220356e-09  ,
 9.49511607592e-09 , 1.33609782937e-08 , 1.57422947791e-08 , 1.84800897027e-08 ,
 3.28780549333e-08 , 1.0700179859e-07  , 4.39111273378e-07 , 1.69659530955e-06 ,
 5.52804698423e-06 , 1.46381224654e-05 , 3.11297787495e-05 , 5.30037810576e-05 ,
 7.22992668548e-05 , 7.92982110089e-05 , 7.05979956109e-05 , 5.21826223365e-05 ,
 3.3686402672e-05  , 2.08487996008e-05 , 1.37451604153e-05 , 9.88398362259e-06 ,
 7.18432886049e-06 , 4.8150118589e-06  , 2.79044922315e-06 , 1.34338965096e-06 ,
 5.24015016937e-07 , 1.63086364326e-07 , 4.01208319018e-08 , 7.75823713184e-09 ,
 1.17524710468e-09 , 1.39179793317e-10 , 1.28693003656e-11 , 9.28377018654e-13 ,
 5.22244800825e-14 , 2.29024184305e-15 , 7.82863378234e-17 , 2.08545451141e-18 ,
 4.31892945764e-20 , 4.00012728695e-23 , 7.93718057411e-22 , 1.43714155817e-20 ,
 2.03823305613e-19 , 2.2673861851e-18  , 1.98278448606e-17 , 1.36815112156e-16 ,
 1.92341989599e-17 , 8.62208319038e-17 , 3.27525006791e-16 , 1.12847691349e-15 ,
 3.76603698268e-15 , 1.22043072226e-14 , 3.60664882859e-14 , 9.08383685766e-14 ,
 1.87127168661e-13 , 3.09181468008e-13 , 4.062132163e-13   , 4.22749789385e-13 ,
 3.48382629047e-13 , 2.30616920744e-13 , 1.37063167706e-13 , 1.16324510246e-13 ,
 1.91859508338e-13 , 3.74245752504e-13 , 7.24768351153e-13 , 1.70365135416e-12 ,
 5.32063291538e-12 , 1.74783860386e-11 , 4.9862699765e-11  , 1.15413892608e-10 ,
 2.12308865439e-10 , 3.08099856517e-10 , 3.51621594625e-10 , 3.15238649898e-10 ,
 2.22077928072e-10 , 1.23133581978e-10 , 5.39130417523e-11 , 1.87519545262e-11 ,
 5.24749732602e-12 , 1.32949152231e-12 , 1.43469600893e-12 , 9.57266386955e-12 ,
 6.74268573627e-11 , 4.26822780786e-10 , 2.36501736001e-09 , 1.10586128232e-08 ,
 4.22600563547e-08 , 1.29288553068e-07 , 3.13170601028e-07 , 5.97534585279e-07 ,
 8.96408715378e-07 , 1.05733765792e-06 , 9.82089620964e-07 , 7.21972275039e-07 ,
 4.28789407535e-07 , 2.24929169371e-07 , 1.37053569429e-07 , 1.23947640593e-07 ,
 1.31778577004e-07 , 1.37038262374e-07 , 2.24930456988e-07 , 9.79597318524e-07 ,
 5.17030789571e-06 , 2.28664447675e-05 , 8.13866959842e-05 , 0.000235362701685 ,
 0.00057262959994  , 0.00126142496835  , 0.00277329130412  , 0.00630361642063  ,
 0.0138151020626   , 0.0266189319689   , 0.0426165348584   , 0.0552383655761   ,
 0.057333237768    , 0.0475082220666   , 0.0316353777277   , 0.0174211257515   ,
 0.00857710137607  , 0.00430593295415  , 0.00235877551633  , 0.00128485163057  ,
 0.000612725212008 , 0.000238725419635 , 7.39850000392e-05 , 1.80642619895e-05 ,
 3.4614461744e-06  , 5.1953528086e-07  , 6.10033791891e-08 , 5.59852309006e-09 ,
 4.01288792759e-10 , 2.24517238573e-11 , 9.8004706685e-13  , 3.33644726411e-14 ,
 8.85586290422e-16 , 1.81205857462e-17 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 7.01642738178e-29 , 3.46943008195e-27 , 1.31545376634e-25 , 3.94260729368e-24 ,
 9.24705517626e-23 , 1.72399263562e-21 , 2.59563483189e-20 , 3.23504348303e-19 ,
 3.44434097551e-18 , 3.21616758399e-17 , 2.64615101427e-16 , 1.87981239556e-15 ,
 1.11755885975e-14 , 5.41049588339e-14 , 2.0949447932e-13  , 6.42255914384e-13 ,
 1.55179530904e-12 , 2.95216868783e-12 , 4.43171273811e-12 , 5.28053981994e-12 ,
 5.05066782164e-12 , 3.95143792827e-12 , 2.59728099097e-12 , 1.47603667052e-12 ,
 7.37490665873e-13 , 3.21970537256e-13 , 1.2049600113e-13  , 4.51718311479e-14 ,
 8.4071194601e-14  , 5.38860804062e-13 , 3.04735661307e-12 , 1.36769410234e-11 ,
 4.8562559788e-11  , 1.36364255316e-10 , 3.02830789735e-10 , 5.33221447594e-10 ,
 7.54728756476e-10 , 9.13085543012e-10 , 1.20328418727e-09 , 2.8406952863e-09  ,
 1.18605439978e-08 , 5.47060365106e-08 , 2.2200673681e-07  , 7.40017821751e-07 ,
 1.9846422822e-06  , 4.25677175983e-06 , 7.29326381302e-06 , 9.98997384688e-06 ,
 1.09698992559e-05 , 9.72250272973e-06 , 7.07272973384e-06 , 4.39926954584e-06 ,
 2.55245186925e-06 , 1.56597524663e-06 , 1.08038657635e-06 , 7.79443038204e-07 ,
 5.25537474202e-07 , 3.06713105625e-07 , 1.48383049037e-07 , 5.80488078964e-08 ,
 1.80959567191e-08 , 4.45582869254e-09 , 8.62059277365e-10 , 1.30622250129e-10 ,
 1.54709487955e-11 , 1.43056194729e-12 , 1.03193263444e-13 , 5.80412391601e-15 ,
 2.54463636611e-16 , 8.6942297122e-18  , 2.31429630428e-19 , 4.7867130763e-21  ,
 1.08226939593e-24 , 2.01753622984e-23 , 3.65323302076e-22 , 5.1821769184e-21  ,
 5.76691221399e-20 , 5.04720071274e-19 , 3.48955535475e-18 , 3.45599607655e-19 ,
 1.58564883827e-18 , 6.31888769513e-18 , 2.35475813807e-17 , 8.59525462104e-17 ,
 2.98308155141e-16 , 9.15891046749e-16 , 2.34813224453e-15 , 4.87462463364e-15 ,
 8.08150414276e-15 , 1.06349655054e-14 , 1.10776491691e-14 , 9.13370656241e-15 ,
 6.04692447502e-15 , 3.58904021111e-15 , 3.03411234159e-15 , 5.02082108967e-15 ,
 1.00611960326e-14 , 2.13402598488e-14 , 5.91893164162e-14 , 2.09571553129e-13 ,
 7.260302303e-13   , 2.11629985171e-12 , 4.95065951987e-12 , 9.16210264172e-12 ,
 1.33437865186e-11 , 1.52598675016e-11 , 1.36931152059e-11 , 9.64451896679e-12 ,
 5.33890752377e-12 , 2.32856435177e-12 , 8.03565356698e-13 , 2.21543154603e-13 ,
 5.6037075899e-14  , 7.85252438927e-14 , 6.14932291537e-13 , 4.85700349734e-12 ,
 3.38631591204e-11 , 2.00586804876e-10 , 9.75563505734e-10 , 3.80733782668e-09 ,
 1.17730702827e-08 , 2.86686838296e-08 , 5.48420935448e-08 , 8.23753290537e-08 ,
 9.72144550973e-08 , 9.02867711325e-08 , 6.62686411042e-08 , 3.90614552771e-08 ,
 1.98557843053e-08 , 1.11116363814e-08 , 9.224862873e-09   , 9.66294898481e-09 ,
 1.15533239665e-08 , 3.1437662316e-08  , 1.79001186864e-07 , 9.85460456738e-07 ,
 4.41619643224e-06 , 1.5992696309e-05  , 4.79729431351e-05 , 0.000126374373765 ,
 0.000321015279428 , 0.000840339919998 , 0.00218518162852  , 0.00514497678556  ,
 0.0102362031331   , 0.0166265299907   , 0.0217094545758   , 0.0226224726914   ,
 0.0187662577773   , 0.0124430691905   , 0.00673081483958  , 0.00315607842781  ,
 0.00144904045247  , 0.000723949038838 , 0.000373990659379 , 0.000174673319815 ,
 6.75881168184e-05 , 2.09021454105e-05 , 5.1002160686e-06  , 9.77108395881e-07 ,
 1.46647789943e-07 , 1.72189658559e-08 , 1.58024522176e-09 , 1.13268044437e-10 ,
 6.33723492395e-12 , 2.76628572555e-13 , 9.41747264284e-15 , 2.49966026817e-16 ,
 5.11472554572e-18 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.42735229788e-30 ,
 7.05786396744e-29 , 2.67798751488e-27 , 8.09935854195e-26 , 1.91826394795e-24 ,
 3.64365518233e-23 , 5.67310733506e-22 , 7.46461771366e-21 , 8.55981406099e-20 ,
 8.67457006623e-19 , 7.66822371918e-18 , 5.7363199665e-17  , 3.52263873287e-16 ,
 1.7378183825e-15  , 6.80002571028e-15 , 2.09674171477e-14 , 5.08091205069e-14 ,
 9.67519925192e-14 , 1.4509739435e-13  , 1.72252668944e-13 , 1.63428865557e-13 ,
 1.25941412396e-13 , 8.07500789939e-14 , 4.4325648973e-14  , 2.128503623e-14   ,
 8.95526252441e-15 , 3.26582270289e-15 , 1.33613739917e-15 , 3.51201486897e-15 ,
 2.35272733699e-14 , 1.33235478985e-13 , 5.97991270064e-13 , 2.12325680517e-12 ,
 5.96254091968e-12 , 1.32468284271e-11 , 2.33680674084e-11 , 3.33508179109e-11 ,
 4.20548712568e-11 , 6.65636032374e-11 , 2.20026933516e-10 , 1.12314300466e-09 ,
 5.59091219647e-09 , 2.33919211927e-08 , 7.91369501566e-08 , 2.14177993062e-07 ,
 4.62471859863e-07 , 7.96587991296e-07 , 1.0954626487e-06  , 1.20522722597e-06 ,
 1.06601012132e-06 , 7.67462020783e-07 , 4.64397154742e-07 , 2.54962164871e-07 ,
 1.45211086773e-07 , 9.4924560839e-08  , 6.73255402766e-08 , 4.5451540657e-08  ,
 2.66513988301e-08 , 1.29408619052e-08 , 5.07395896638e-09 , 1.58375104576e-09 ,
 3.90245892125e-10 , 7.55290403834e-11 , 1.14468181049e-11 , 1.35591316766e-12 ,
 1.25384015183e-13 , 9.04457744025e-15 , 5.08695163766e-16 , 2.23002735215e-17 ,
 7.6181703997e-19  , 2.02736405006e-20 , 4.19148833312e-22 , 2.16666437335e-26 ,
 3.55840912668e-25 , 6.44515664756e-24 , 9.14824150116e-23 , 1.01911372426e-21 ,
 8.93738788674e-21 , 6.20649737754e-20 , 3.18063156924e-22 , 3.54563238135e-21 ,
 3.10432545171e-20 , 2.13781415263e-19 , 1.15970877862e-18 , 4.96272897381e-18 ,
 1.6773357909e-17  , 4.48177156624e-17 , 9.47186765649e-17 , 1.58344223623e-16 ,
 2.09305510976e-16 , 2.1863213109e-16  , 1.8061142077e-16  , 1.19624430318e-16 ,
 7.05425825209e-17 , 5.83218164602e-17 , 9.60601911911e-17 , 2.01826684084e-16 ,
 4.93914326353e-16 , 1.6653331104e-15  , 6.59336964372e-15 , 2.38049499351e-14 ,
 7.05290778414e-14 , 1.66322582729e-13 , 3.09228317873e-13 , 4.51600342479e-13 ,
 5.1726605841e-13  , 4.64506552898e-13 , 3.27167529834e-13 , 1.80942990818e-13 ,
 7.87313011281e-14 , 2.70349319751e-14 , 7.38371671218e-15 , 1.91064611143e-15 ,
 3.72041507548e-15 , 3.40300629557e-14 , 2.97248100565e-13 , 2.22509710944e-12 ,
 1.3756460911e-11  , 6.84695994971e-11 , 2.70378408005e-10 , 8.40939858412e-10 ,
 2.05359426218e-09 , 3.93385184238e-09 , 5.91269088008e-09 , 6.97962827417e-09 ,
 6.48150735254e-09 , 4.75189462773e-09 , 2.78542792864e-09 , 1.38151138471e-09 ,
 7.1672763976e-10  , 5.43184365846e-10 , 5.68629987417e-10 , 9.04577343692e-10 ,
 4.0724959637e-09  , 2.65466275103e-08 , 1.49277418112e-07 , 6.78708137003e-07 ,
 2.5289044465e-06  , 8.08303893518e-06 , 2.40861596218e-05 , 7.27420862388e-05 ,
 0.000222354039226 , 0.000633594264214 , 0.00155554241959  , 0.0031504833646   ,
 0.0051592757765   , 0.00676571288205  , 0.00706711633717  , 0.0058654879138   ,
 0.00387655029319  , 0.00206943367873  , 0.000934252964345 , 0.00039647529071  ,
 0.000179787227475 , 8.70340882794e-05 , 3.95367425282e-05 , 1.51541573281e-05 ,
 4.67269069547e-06 , 1.13913704734e-06 , 2.18179580022e-07 , 3.27425466916e-08 ,
 3.84444646889e-09 , 3.52815967305e-10 , 2.52889185505e-11 , 1.41488878714e-12 ,
 6.17617392385e-14 , 2.10260091458e-15 , 5.58089008092e-17 , 1.14194402449e-18 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.67972197347e-31 , 5.49603456552e-29 ,
 2.56996474306e-27 , 9.40027820528e-26 , 2.69303260521e-24 , 6.0370948135e-23  ,
 1.0582219175e-21  , 1.4495736519e-20  , 1.5511133518e-19  , 1.29622833225e-18 ,
 8.45900825727e-18 , 4.3111960096e-17  , 1.71650572115e-16 , 5.34203798582e-16 ,
 1.30076637413e-15 , 2.48208012042e-15 , 3.72157428777e-15 , 4.40495585395e-15 ,
 4.14877126084e-15 , 3.15089324051e-15 , 1.96935751988e-15 , 1.03978487986e-15 ,
 4.74962050416e-16 , 1.89403345388e-16 , 6.61037970265e-17 , 3.10388074038e-17 ,
 1.15958180159e-16 , 8.01226245495e-16 , 4.54164067683e-15 , 2.03841909664e-14 ,
 7.23773867689e-14 , 2.03273495364e-13 , 4.51866145376e-13 , 7.99151621086e-13 ,
 1.15488727921e-12 , 1.56214285586e-12 , 3.26995669987e-12 , 1.51233679616e-11 ,
 8.85879269154e-11 , 4.61832926249e-10 , 1.96892139902e-09 , 6.72764317517e-09 ,
 1.83315253216e-08 , 3.97969666805e-08 , 6.88591452302e-08 , 9.50372310971e-08 ,
 1.04789515426e-07 , 9.2631864389e-08  , 6.62497098697e-08 , 3.92962912095e-08 ,
 2.06189085279e-08 , 1.09233572372e-08 , 6.69457655797e-09 , 4.62072270666e-09 ,
 3.10788814462e-09 , 1.82694049945e-09 , 8.89409169544e-10 , 3.49320614744e-10 ,
 1.0914133115e-10  , 2.69076554878e-11 , 5.20931376495e-12 , 7.89627195352e-13 ,
 9.35422032016e-14 , 8.6504272402e-15  , 6.24009875209e-16 , 3.50961625183e-17 ,
 1.53851722975e-18 , 5.25560203858e-20 , 1.39852153359e-21 , 2.89097531778e-23 ,
 1.49224683651e-28 , 3.76930681844e-30 , 4.72532856816e-29 , 1.79381889573e-27 ,
 5.31980492599e-26 , 1.23343016223e-24 , 2.23785420833e-23 , 7.20879975364e-30 ,
 0, 0, 0, 0, 0, 0, 0, 1.4892428436e-30  , 7.21346475129e-29 ,
 2.87026067007e-27 , 8.70688193648e-26 , 2.09985790037e-24 , 4.06489849304e-23 ,
 6.38745497768e-22 , 8.23770443139e-21 , 8.78532183805e-20 , 7.75708409046e-19 ,
 5.63880489877e-18 , 3.34065958518e-17 , 1.59497369027e-16 , 6.07661677301e-16 ,
 1.83359304287e-15 , 4.35963469456e-15 , 8.14156736836e-15 , 1.1920452749e-14  ,
 1.36726494217e-14 , 1.22840559449e-14 , 8.64839312764e-15 , 4.77501211791e-15 ,
 2.06978643703e-15 , 7.05303653909e-16 , 1.900267777e-16   , 5.19163555971e-17 ,
 1.53124212424e-16 , 1.60101581491e-15 , 1.5092827345e-14  , 1.18416096551e-13 ,
 7.51220950894e-13 , 3.78872183995e-12 , 1.50591871183e-11 , 4.69865316027e-11 ,
 1.14918402165e-10 , 2.20299670919e-10 , 3.31231964959e-10 , 3.91053435889e-10 ,
 3.63107116799e-10 , 2.65990657435e-10 , 1.55273053398e-10 , 7.55497688187e-11 ,
 3.66991538087e-11 , 2.53852463692e-11 , 2.78740787209e-11 , 7.08304151856e-11 ,
 4.61652637683e-10 , 3.20636010443e-09 , 1.83474216621e-08 , 8.54403119764e-08 ,
 3.34740261942e-07 , 1.18311441238e-06 , 4.12440650758e-06 , 1.46536505666e-05 ,
 4.99287534961e-05 , 0.000149998686593 , 0.000376605252525 , 0.000770111111019 ,
 0.00126703964312  , 0.00166593399311  , 0.0017427574223   , 0.00144679953442  ,
 0.000953918147656 , 0.000504367626073 , 0.000221259373859 , 8.78924472065e-05 ,
 3.61973560027e-05 , 1.62357732817e-05 , 7.11388550952e-06 , 2.69187269721e-06 ,
 8.26646260879e-07 , 2.01275528278e-07 , 3.85361616984e-08 , 5.78254687587e-09 ,
 6.78932254218e-10 , 6.23069794368e-11 , 4.4659874023e-12  , 2.49867083361e-13 ,
 1.09070232457e-14 , 3.71315920415e-16 , 9.85576160823e-18 , 2.01665467552e-19 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8.72083017592e-31 ,
 4.21706809501e-29 , 1.58405640479e-27 , 4.63534516601e-26 , 1.05676886971e-24 ,
 1.87719425993e-23 , 2.59852409439e-22 , 2.80352949098e-21 , 2.35795927303e-20 ,
 1.54645180877e-19 , 7.91136486886e-19 , 3.15837631858e-18 , 9.84464777708e-18 ,
 2.39738921023e-17 , 4.56474680263e-17 , 6.8020266222e-17  , 7.94102722499e-17 ,
 7.27231957726e-17 , 5.23150855809e-17 , 2.96058397306e-17 , 1.31998955249e-17 ,
 4.64329144987e-18 , 1.29208514095e-18 , 3.11756359729e-19 , 3.75513880055e-19 ,
 2.97051782061e-18 , 2.1268933678e-17  , 1.20674453936e-16 , 5.41621363015e-16 ,
 1.92313735691e-15 , 5.40204843285e-15 , 1.20178758311e-14 , 2.13327331914e-14 ,
 3.14704112425e-14 , 4.82606270217e-14 , 1.47465768119e-13 , 8.9530450599e-13  ,
 5.69898713279e-12 , 3.052266111e-11   , 1.31662680872e-10 , 4.53007728215e-10 ,
 1.24077126714e-09 , 2.70549015265e-09 , 4.69912714158e-09 , 6.50630301967e-09 ,
 7.18965710528e-09 , 6.35697077752e-09 , 4.52776756115e-09 , 2.64761093266e-09 ,
 1.34001871708e-09 , 6.63897649121e-10 , 3.7850924531e-10  , 2.51591515729e-10 ,
 1.67694869559e-10 , 9.86107716356e-11 , 4.80871432254e-11 , 1.89103390089e-11 ,
 5.91311583674e-12 , 1.45903529944e-12 , 2.83319385973e-13 , 4.37528111227e-14 ,
 5.83047311297e-15 , 9.5146580038e-16  , 2.75816747689e-16 , 9.75032088067e-17 ,
 2.97871565955e-17 , 7.25062675911e-18 , 1.38699162558e-18 , 2.07884084946e-19 ,
 2.4380820965e-20  , 2.23537417559e-21 , 1.60102336897e-22 , 8.95205552347e-24 ,
 3.90578145881e-25 , 1.32916248561e-26 , 3.52690081656e-28 , 3.55146547956e-28 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 3.25394719425e-30 , 1.57073710708e-28 ,
 5.89723570933e-27 , 1.72458373721e-25 , 3.92852111571e-24 , 6.97117821036e-23 ,
 9.6370772845e-22  , 1.03796951441e-20 , 8.71108944746e-20 , 5.69732167706e-19 ,
 2.90440961216e-18 , 1.15433856501e-17 , 3.57784964578e-17 , 8.65130851204e-17 ,
 1.63270792582e-16 , 2.40627262294e-16 , 2.77132740188e-16 , 2.49629799927e-16 ,
 1.76034215405e-16 , 9.72939894178e-17 , 4.22013124372e-17 , 1.43871500256e-17 ,
 3.88509473798e-18 , 1.20443065833e-18 , 5.4181980317e-18  , 6.25994746491e-17 ,
 6.21918520752e-16 , 5.02439219832e-15 , 3.23602085853e-14 , 1.64435050996e-13 ,
 6.55974124536e-13 , 2.05031996359e-12 , 5.01885259478e-12 , 9.62507987851e-12 ,
 1.44745379703e-11 , 1.70897957852e-11 , 1.58671117083e-11 , 1.16162241486e-11 ,
 6.76002050339e-12 , 3.24048435188e-12 , 1.49044694186e-12 , 9.87276665842e-13 ,
 1.85924029417e-12 , 1.36240477092e-11 , 1.26696873843e-10 , 9.78096711191e-10 ,
 6.01198891525e-09 , 2.94933249103e-08 , 1.17345370108e-07 , 3.93562552952e-07 ,
 1.19600638193e-06 , 3.57624184973e-06 , 1.07185722652e-05 , 3.01805262171e-05 ,
 7.38740301516e-05 , 0.000149845130574 , 0.000246101651816 , 0.000323643358242 ,
 0.000338739546715 , 0.000281207509567 , 0.00018507595223  , 9.71768541446e-05 ,
 4.17293276642e-05 , 1.5713394685e-05  , 5.9099528281e-06  , 2.43341925903e-06 ,
 1.01857501375e-06 , 3.78846638664e-07 , 1.15694109655e-07 , 2.81218456953e-08 ,
 5.381461785e-09   , 8.07393781388e-10 , 9.47923539284e-11 , 8.69917064566e-12 ,
 6.23529430403e-13 , 3.488573141e-14   , 1.52280746238e-15 , 5.18420692585e-17 ,
 1.37603331233e-18 , 2.81559571273e-20 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.48666659031e-30 ,
 7.84314550051e-29 , 3.01559123869e-27 , 9.08480084774e-26 , 2.14716700151e-24 ,
 3.98683079771e-23 , 5.82427914072e-22 , 6.70430607017e-21 , 6.08930875722e-20 ,
 4.36917755312e-19 , 2.47870790995e-18 , 1.1123768795e-17  , 3.9494383782e-17  ,
 1.10954261414e-16 , 2.47096990142e-16 , 4.41177311891e-16 , 6.76251365175e-16 ,
 1.29921199813e-15 , 6.07312968838e-15 , 4.41823598144e-14 , 2.94633949517e-13 ,
 1.60289756572e-12 , 6.96668398067e-12 , 2.40900938533e-11 , 6.62492970236e-11 ,
 1.44972973364e-10 , 2.52608283971e-10 , 3.50717578853e-10 , 3.88338991686e-10 ,
 3.43577400493e-10 , 2.4409855647e-10  , 1.41294467648e-10 , 6.95284562279e-11 ,
 3.24543653744e-11 , 1.71363876469e-11 , 1.08552916974e-11 , 7.1289775492e-12  ,
 4.18521289635e-12 , 2.04598268183e-12 , 8.14222065524e-13 , 2.73129939747e-13 ,
 9.73675100147e-14 , 5.75275198059e-14 , 4.81898066512e-14 , 3.75584972127e-14 ,
 2.37704764587e-14 , 1.1916007119e-14  , 4.7076841957e-15  , 1.46282089001e-15 ,
 3.5695707431e-16  , 6.83105329641e-17 , 1.02394655169e-17 , 1.2009510262e-18  ,
 1.10113712699e-19 , 7.88678856448e-21 , 4.40995659338e-22 , 1.92409550529e-23 ,
 6.54790530101e-25 , 1.73748869744e-26 , 1.34099840307e-26 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8.36383198027e-31 ,
 4.03716361382e-29 , 1.51570649975e-27 , 5.03549643359e-26 , 1.30175631404e-24 ,
 2.88928703334e-23 , 5.69064025545e-22 , 1.00001706316e-20 , 1.52766357832e-19 ,
 1.95343577214e-18 , 2.0272871706e-17  , 1.67525524793e-16 , 1.09117663414e-15 ,
 5.57516441416e-15 , 2.22996366203e-14 , 6.9788629113e-14  , 1.70935746307e-13 ,
 3.27914280563e-13 , 4.93197138471e-13 , 5.82336068631e-13 , 5.40638986874e-13 ,
 3.95619584487e-13 , 2.29705311171e-13 , 1.09421438104e-13 , 6.33719426591e-14 ,
 3.52929874109e-13 , 5.36005361746e-12 , 6.89307835615e-11 , 7.00911174549e-10 ,
 5.60825284887e-09 , 3.52534311662e-08 , 1.73882992331e-07 , 6.72445636109e-07 ,
 2.03922370747e-06 , 4.86097194098e-06 , 9.18443459175e-06 , 1.40870007079e-05 ,
 1.86065681877e-05 , 2.35526555616e-05 , 3.12759809091e-05 , 4.20819510743e-05 ,
 5.13523391354e-05 , 5.24307715945e-05 , 4.31780169536e-05 , 2.83102907802e-05 ,
 1.47788474777e-05 , 6.24555060187e-06 , 2.25467037668e-06 , 7.81504394793e-07 ,
 2.93604316785e-07 , 1.16169529852e-07 , 4.22360086704e-08 , 1.28012259667e-08 ,
 3.10437240117e-09 , 5.93645607314e-10 , 8.9047656203e-11  , 1.04540325502e-11 ,
 9.59357693096e-13 , 6.87634023524e-14 , 3.84722250878e-15 , 1.67936242782e-16 ,
 5.71717866139e-18 , 1.51749889677e-19 , 3.105058104e-21   , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 9.78333905965e-31 , 4.83765678601e-29 , 1.82850976268e-27 ,
 5.39474718242e-26 , 1.2427633782e-24  , 2.24225215982e-23 , 3.17657856183e-22 ,
 3.57460795421e-21 , 3.30164771959e-20 , 2.72508375618e-19 , 2.32475768841e-18 ,
 2.20946996904e-17 , 2.10873176892e-16 , 1.76580096811e-15 , 1.21174925288e-14 ,
 6.65613265371e-14 , 2.9078174562e-13  , 1.00925255944e-12 , 2.78440666025e-12 ,
 6.11086107566e-12 , 1.06761371403e-11 , 1.48569942586e-11 , 1.64801674974e-11 ,
 1.45919098855e-11 , 1.0351348864e-11  , 5.94858926405e-12 , 2.86433126071e-12 ,
 1.27010633102e-12 , 6.20715708121e-13 , 3.7292103866e-13  , 2.49449841087e-13 ,
 1.85532762092e-13 , 2.20566304657e-13 , 4.24460430271e-13 , 8.27389609077e-13 ,
 1.33578378323e-12 , 1.71840203521e-12 , 1.75041773968e-12 , 1.40971258978e-12 ,
 8.96626891898e-13 , 4.49811545285e-13 , 1.77731469226e-13 , 5.52287284002e-14 ,
 1.34771982209e-14 , 2.57916277509e-15 , 3.8661116519e-16  , 4.53447779648e-17 ,
 4.15764409598e-18 , 2.97789400796e-19 , 1.66512117272e-20 , 7.26507536831e-22 ,
 2.47239264413e-23 , 6.56051999241e-25 , 3.95019541141e-25 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.60195403281e-28 , 7.7590852016e-27  , 2.91588515812e-25 , 8.53763837579e-24 ,
 1.94788393514e-22 , 3.46346411974e-21 , 4.80023238595e-20 , 5.18705824363e-19 ,
 4.37136959245e-18 , 2.8741854201e-17  , 1.47508247184e-16 , 5.91252938382e-16 ,
 1.85222083189e-15 , 4.53883755393e-15 , 8.70898219664e-15 , 1.30999748577e-14 ,
 1.54680484412e-14 , 1.4359506821e-14  , 1.05060257432e-14 , 6.20038737313e-15 ,
 6.6713965197e-15  , 1.01298565553e-13 , 2.07579626095e-12 , 3.39802417781e-11 ,
 4.38933004486e-10 , 4.46658229144e-09 , 3.57524936234e-08 , 2.24778364077e-07 ,
 1.10847249154e-06 , 4.28237336769e-06 , 1.29471692472e-05 , 3.06072413697e-05 ,
 5.65427329877e-05 , 8.16176630346e-05 , 9.2150506955e-05  , 8.17312526126e-05 ,
 5.77472998752e-05 , 3.38592187005e-05 , 1.81528759752e-05 , 1.01917639618e-05 ,
 6.17803416877e-06 , 3.59796894046e-06 , 1.80067117073e-06 , 7.43356137449e-07 ,
 2.58852079436e-07 , 8.3520895642e-08  , 2.85615383045e-08 , 1.05657674656e-08 ,
 3.72915382075e-09 , 1.118801074e-09   , 2.70455600061e-10 , 5.16695292884e-11 ,
 7.7483022116e-12  , 9.09560376966e-13 , 8.34675241318e-14 , 5.98261648209e-15 ,
 3.34718596182e-16 , 1.46108984492e-17 , 4.97409704145e-19 , 1.32026428067e-20 ,
 2.70148288927e-22 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3.02342316737e-31 ,
 1.57780708435e-29 , 2.1639390846e-27  , 9.77250661764e-26 , 3.4617134994e-24  ,
 9.83736873332e-23 , 2.22679072795e-21 , 3.99580494596e-20 , 5.66881527254e-19 ,
 6.35154679262e-18 , 5.62068830715e-17 , 3.93155275484e-16 , 2.17635332221e-15 ,
 9.54747953932e-15 , 3.32382399992e-14 , 9.19399086157e-14 , 2.02259880203e-13 ,
 3.54135914691e-13 , 4.93768582878e-13 , 5.48549754638e-13 , 4.86070601676e-13 ,
 3.44490052262e-13 , 1.96928035392e-13 , 9.33272187033e-14 , 4.06170159834e-14 ,
 2.69004521183e-14 , 7.0926310444e-14  , 3.30680995232e-13 , 1.36338102857e-12 ,
 4.49322993818e-12 , 1.17089055448e-11 , 2.41140097688e-11 , 3.92702479869e-11 ,
 5.058786912e-11   , 5.15432567372e-11 , 4.15140259287e-11 , 2.64056917972e-11 ,
 1.3247510799e-11  , 5.23459998367e-12 , 1.6266625789e-12  , 3.9695678114e-13  ,
 7.5968165862e-14  , 1.13876704051e-14 , 1.33565393665e-15 , 1.22466961914e-16 ,
 8.77172156627e-18 , 4.90483721202e-19 , 2.14003745245e-20 , 7.28283817642e-22 ,
 1.93251568652e-23 , 9.08185211896e-24 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3.28722673208e-30 ,
 1.59217254483e-28 , 5.98342739124e-27 , 1.75193248513e-25 , 3.99707857492e-24 ,
 7.10706525081e-23 , 9.85012796627e-22 , 1.06438987449e-20 , 8.97009694738e-20 ,
 5.89785908362e-19 , 3.02688493455e-18 , 1.21325731675e-17 , 3.80077672285e-17 ,
 9.31374095615e-17 , 1.78709020638e-16 , 2.68810994567e-16 , 3.17393452252e-16 ,
 2.94760324413e-16 , 2.29006551958e-16 , 7.00123336735e-16 , 1.9156024437e-14  ,
 5.00865384416e-13 , 1.03830302475e-11 , 1.70015889543e-10 , 2.19618577502e-09 ,
 2.23484959607e-08 , 1.78887659601e-07 , 1.12467839114e-06 , 5.546204585e-06   ,
 2.14262538555e-05 , 6.4775546163e-05  , 0.000153105856322 , 0.000282719894581 ,
 0.000407600385849 , 0.000458581021146 , 0.000402495061275 , 0.000275580644855 ,
 0.000147287299995 , 6.16189394946e-05 , 2.03711483492e-05 , 5.48382142713e-06 ,
 1.30402223394e-06 , 3.17631798888e-07 , 8.72106537951e-08 , 2.52762687516e-08 ,
 7.30730282976e-09 , 2.24895711648e-09 , 7.67754356384e-10 , 2.60751697846e-10 ,
 7.71615092042e-11 , 1.8571995406e-11  , 3.5434610102e-12  , 5.31166301844e-13 ,
 6.23455626185e-14 , 5.72106445105e-15 , 4.10058798832e-16 , 2.29420949172e-17 ,
 1.00145189501e-18 , 3.40931731572e-20 , 9.04928037371e-22 , 1.85163504366e-23 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3.97711084094e-29 ,
 2.03269130529e-27 , 7.75551881509e-26 , 2.31378552652e-24 , 5.40495513477e-23 ,
 9.89821567115e-22 , 1.42312950974e-20 , 1.60904048479e-19 , 1.43321316715e-18 ,
 1.00766096226e-17 , 5.60322315447e-17 , 2.46903035856e-16 , 8.63726012874e-16 ,
 2.40276352534e-15 , 5.32333130624e-15 , 9.40590527893e-15 , 1.32734422427e-14 ,
 1.4985154157e-14  , 1.35653883982e-14 , 9.89022538624e-15 , 5.98760535685e-15 ,
 5.00643500738e-15 , 2.50863404431e-14 , 2.06891070942e-13 , 1.39935971782e-12 ,
 7.4524924272e-12  , 3.12369485839e-11 , 1.03186044143e-10 , 2.68998426961e-10 ,
 5.54054362182e-10 , 9.02357431398e-10 , 1.16249415558e-09 , 1.18452606977e-09 ,
 9.54101297233e-10 , 6.0690671958e-10  , 3.04495520234e-10 , 1.20323265523e-10 ,
 3.73921391383e-11 , 9.12515308489e-12 , 1.74638615501e-12 , 2.61790041984e-13 ,
 3.0705768202e-14  , 2.81547208278e-15 , 2.01661095803e-16 , 1.12762802158e-17 ,
 4.92000769394e-19 , 1.67435502267e-20 , 4.44295452641e-22 , 1.63056493794e-22 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.79392709305e-30 ,
 6.56081196677e-19 , 5.37324984919e-17 , 2.25205938622e-15 , 7.46617359694e-14 ,
 1.95783798524e-12 , 4.05879590599e-11 , 6.64603871166e-10 , 8.58504252443e-09 ,
 8.73618234417e-08 , 6.992842948e-07   , 4.39644582084e-06 , 2.16804950683e-05 ,
 8.37566644876e-05 , 0.000253211676056 , 0.000598498622388 , 0.00110515752198  ,
 0.0015932811585   , 0.00179244111124  , 0.00157290517556  , 0.00107627668024  ,
 0.000574119600131 , 0.00023871095384  , 7.73651089436e-05 , 1.95542527274e-05 ,
 3.86233322999e-06 , 6.00477426156e-07 , 7.52968729784e-08 , 8.23619651081e-09 ,
 9.69110928432e-10 , 1.68775365945e-10 , 4.57782646085e-11 , 1.44819611552e-11 ,
 4.19695787262e-12 , 1.00394912414e-12 , 1.91199340237e-13 , 2.86454478559e-14 ,
 3.36172111314e-15 , 3.08469819359e-16 , 2.21093509917e-17 , 1.23697388256e-18 ,
 5.39954882493e-20 , 1.83820864464e-21 , 4.87911915209e-23 , 9.98349883208e-25 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7.00168395103e-31 ,
 3.60067403894e-29 , 1.59219459243e-27 , 5.18589455101e-26 , 1.36896686841e-24 ,
 2.96726715579e-23 , 5.31548785837e-22 , 7.87732976932e-21 , 9.61276298775e-20 ,
 9.58036085803e-19 , 7.72787555667e-18 , 5.00605061091e-17 , 2.58939523875e-16 ,
 1.06552911232e-15 , 3.48083922282e-15 , 9.01777337117e-15 , 1.85183089529e-14 ,
 3.01342128777e-14 , 3.88478306917e-14 , 3.9783529074e-14  , 3.4737363525e-14  ,
 5.92456565883e-14 , 4.38697896082e-13 , 3.70555566732e-12 , 2.50934835196e-11 ,
 1.33659170266e-10 , 5.60269907291e-10 , 1.85088649753e-09 , 4.82548530179e-09 ,
 9.93981453462e-09 , 1.61897644966e-08 , 2.08587874073e-08 , 2.12558488583e-08 ,
 1.71222978444e-08 , 1.08923252897e-08 , 5.46521784802e-09 , 2.15973589018e-09 ,
 6.71200611865e-10 , 1.63806032058e-10 , 3.1350516775e-11  , 4.69969410413e-12 ,
 5.51246958896e-13 , 5.05458291422e-14 , 3.62044957107e-15 , 2.02446946222e-16 ,
 8.83313974657e-18 , 3.00607618181e-19 , 7.97676413102e-21 , 2.28773785947e-21 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.00234962489e-18 ,
 1.63990751672e-16 , 6.87325030718e-15 , 2.27866459969e-13 , 5.97529116273e-12 ,
 1.2387382155e-10  , 2.02836070799e-09 , 2.62014166549e-08 , 2.66626930451e-07 ,
 2.13420482367e-06 , 1.34178844537e-05 , 6.61685344699e-05 , 0.000255624038067 ,
 0.000772798082992 , 0.00182660835086  , 0.00337292279637  , 0.00486266608062  ,
 0.00547049180166  , 0.00480045454864  , 0.00328472231259  , 0.001752108833    ,
 0.000728416215287 , 0.00023598503458  , 5.95696237553e-05 , 1.17158771943e-05 ,
 1.79540229296e-06 , 2.1447469288e-07  , 2.00079039712e-08 , 1.46905044724e-09 ,
 8.85729093584e-11 , 5.65104143503e-12 , 7.56459421666e-13 , 1.83056876285e-13 ,
 4.27370156295e-14 , 8.10608981287e-15 , 1.21354357086e-15 , 1.42385382277e-16 ,
 1.30643606619e-17 , 9.3636066757e-19  , 5.23871001703e-20 , 2.28676323543e-21 ,
 7.78499849505e-23 , 2.06635603456e-24 , 4.22811216833e-26 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7.3483539097e-27  , 3.64563507051e-25 ,
 1.37920532838e-23 , 4.07262218611e-22 , 9.39196806097e-21 , 1.69269772762e-19 ,
 2.38620700224e-18 , 2.63376055734e-17 , 2.27869987271e-16 , 1.54742231504e-15 ,
 8.25964154827e-15 , 3.47048894059e-14 , 1.14956553114e-13 , 3.00586725712e-13 ,
 6.21110793261e-13 , 1.01495072358e-12 , 1.31202802355e-12 , 1.34332363772e-12 ,
 1.12228423961e-12 , 1.23571875536e-12 , 6.35010124738e-12 , 5.19961509421e-11 ,
 3.51607146982e-10 , 1.87281085647e-09 , 7.85097419263e-09 , 2.59383675788e-08 ,
 6.76307542677e-08 , 1.39323630918e-07 , 2.26950970344e-07 , 2.92432725412e-07 ,
 2.9802985056e-07  , 2.40096305504e-07 , 1.52750574994e-07 , 7.66486609423e-08 ,
 3.02920227197e-08 , 9.41469327079e-09 , 2.2977660406e-09  , 4.39783521702e-10 ,
 6.59293610018e-11 , 7.73335009506e-12 , 7.09114874602e-13 , 5.07927360042e-14 ,
 2.84024994515e-15 , 1.23926834663e-16 , 4.21749059125e-18 , 1.11913877924e-19 ,
 2.51036793226e-20 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 4.76878206567e-18 , 3.90559243909e-16 , 1.63692855591e-14 , 5.42685190544e-13 ,
 1.42307122498e-11 , 2.95017039632e-10 , 4.83072988218e-09 , 6.24011133188e-08 ,
 6.34996859903e-07 , 5.08280749855e-06 , 3.19559411347e-05 , 0.00015758652563  ,
 0.000608792447088 , 0.00184049058695  , 0.00435023785151  , 0.00803292964734  ,
 0.011580891872    , 0.0130284850831   , 0.0114327282014   , 0.00782286938905  ,
 0.00417280595086  , 0.00173478526082  , 0.000562014271228 , 0.000141865574546 ,
 2.78991553827e-05 , 4.27421275737e-06 , 5.10093100325e-07 , 4.74203921595e-08 ,
 3.43438447052e-09 , 1.93915177166e-10 , 8.5824369771e-12  , 3.1307273084e-13  ,
 1.38234337502e-14 , 1.58540236406e-15 , 2.69688531009e-16 , 4.03319118617e-17 ,
 4.73068106318e-18 , 4.34016954697e-19 , 3.11064185969e-20 , 1.74030959564e-21 ,
 7.59666941811e-23 , 2.58619078141e-24 , 6.86447265351e-26 , 1.40458661867e-27 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.97359993393e-25 ,
 9.79134269075e-24 , 3.70423033296e-22 , 1.09381325072e-20 , 2.52246799383e-19 ,
 4.54619927733e-18 , 6.40880670668e-17 , 7.0736789842e-16  , 6.12006712453e-15 ,
 4.1560227178e-14  , 2.2183509687e-13  , 9.32094021059e-13 , 3.08747031537e-12 ,
 8.07307251835e-12 , 1.66816152034e-11 , 2.72592068483e-11 , 3.52365928749e-11 ,
 3.6044458171e-11  , 2.95270893467e-11 , 2.45287890828e-11 , 7.50822402503e-11 ,
 5.71732007922e-10 , 3.85228786103e-09 , 2.0517124478e-08  , 8.60167536787e-08 ,
 2.84215321671e-07 , 7.41138169806e-07 , 1.52698022867e-06 , 2.48769137559e-06 ,
 3.20587605951e-06 , 3.26765023561e-06 , 2.63277340009e-06 , 1.67517030518e-06 ,
 8.40666719134e-07 , 3.32265601129e-07 , 1.03275127203e-07 , 2.52070904905e-08 ,
 4.82479169591e-09 , 7.23331016148e-10 , 8.48478779826e-11 , 7.78040221441e-12 ,
 5.57309901919e-13 , 3.11644465847e-14 , 1.35979773603e-15 , 4.62772866375e-17 ,
 1.22800883268e-18 , 2.15653977287e-19 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 8.85890786884e-18 , 7.25537110202e-16 , 3.04090207206e-14 ,
 1.00813961272e-12 , 2.64362193519e-11 , 5.48049530855e-10 , 8.97398756669e-09 ,
 1.15921781745e-07 , 1.17962586703e-06 , 9.44226905835e-06 , 5.93641593338e-05 ,
 0.000292746553039 , 0.0011309462512   , 0.00341905675675  , 0.00808138342288  ,
 0.0149226747367   , 0.0215136805781   , 0.0242028566936   , 0.0212384387068   ,
 0.0145324482813   , 0.00775177020264  , 0.00322268906179  , 0.0010440467892   ,
 0.000263541753328 , 5.18277990724e-05 , 7.94009098161e-06 , 9.47568566738e-07 ,
 8.808408608e-08   , 6.37779507387e-09 , 3.59685223401e-10 , 1.58008410887e-11 ,
 5.41088489166e-13 , 1.45622767979e-14 , 3.36032459144e-16 , 7.03377390592e-18 ,
 1.05032318628e-18 , 1.2314169416e-19  , 1.12961783523e-20 , 8.09577116374e-22 ,
 4.52926825752e-23 , 1.97708158259e-24 , 6.73072616639e-26 , 1.78652271284e-27 ,
 3.6555261024e-29  , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 4.18364076735e-24 , 2.0755706232e-22  , 7.85223426805e-21 , 2.31866733927e-19 ,
 5.34713228954e-18 , 9.63704158385e-17 , 1.3585400236e-15  , 1.49947977119e-14 ,
 1.29733295391e-13 , 8.80994459582e-13 , 4.7024644607e-12  , 1.975854619e-11   ,
 6.54482524919e-11 , 1.71133139391e-10 , 3.53617174142e-10 , 5.77840731338e-10 ,
 7.46933061897e-10 , 7.63774205641e-10 , 6.20569242536e-10 , 4.44662643258e-10 ,
 7.61452013323e-10 , 4.94740186462e-09 , 3.30378957017e-08 , 1.75901957449e-07 ,
 7.37527844291e-07 , 2.43724085507e-06 , 6.35640787173e-06 , 1.30982113559e-05 ,
 2.13424221721e-05 , 2.75082600895e-05 , 2.80426841934e-05 , 2.25975636468e-05 ,
 1.4380241361e-05  , 7.21745460911e-06 , 2.85293590328e-06 , 8.86833721767e-07 ,
 2.16472503085e-07 , 4.14368217118e-08 , 6.21251971999e-09 , 7.287695017e-10   ,
 6.68291815293e-11 , 4.78710273193e-12 , 2.67697834907e-13 , 1.16806559207e-14 ,
 3.9752706341e-16  , 1.05488457149e-17 , 1.45198543286e-18 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.28325809273e-17 , 1.05097759456e-15 ,
 4.40490210637e-14 , 1.46034176647e-12 , 3.82942151862e-11 , 7.93877762471e-10 ,
 1.29992797526e-08 , 1.67918626934e-07 , 1.70874837245e-06 , 1.36776094325e-05 ,
 8.59920195704e-05 , 0.000424058347674 , 0.00163823346036  , 0.00495267849892  ,
 0.0117062970192   , 0.0216162572232   , 0.0311636661255   , 0.0350590752026   ,
 0.030764964203    , 0.021050994251    , 0.0112288354149   , 0.00466822984822  ,
 0.00151235514097  , 0.000381753697107 , 7.50752130613e-05 , 1.15016259402e-05 ,
 1.37260079588e-06 , 1.27594070669e-07 , 9.23850111938e-09 , 5.21008180228e-10 ,
 2.28849566146e-11 , 7.82915662872e-13 , 2.08632010679e-14 , 4.33387925134e-16 ,
 1.34181002978e-19 , 1.99827564342e-20 , 2.34094293989e-21 , 2.1469174607e-22  ,
 1.53855172617e-23 , 8.607358563e-25   , 3.75721597643e-26 , 1.27909703414e-27 ,
 3.3950807787e-29  , 6.94690658956e-31 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 6.99015196757e-23 , 3.46792539858e-21 , 1.31197475766e-19 ,
 3.87409865356e-18 , 8.9341483586e-17  , 1.61018569555e-15 , 2.26988925366e-14 ,
 2.50537559408e-13 , 2.16762265325e-12 , 1.47199186009e-11 , 7.8570180927e-11  ,
 3.30131692004e-10 , 1.0935289533e-09  , 2.85934361217e-09 , 5.90834129962e-09 ,
 9.65473259125e-09 , 1.24798933503e-08 , 1.27593538652e-08 , 1.03323899235e-08 ,
 6.91877032393e-09 , 7.09106960459e-09 , 3.40052588873e-08 , 2.22115959474e-07 ,
 1.18150331394e-06 , 4.95429730343e-06 , 1.637454446e-05   , 4.27127424148e-05 ,
 8.80314714507e-05 , 0.00014346735962  , 0.000184950968247 , 0.000188579824761 ,
 0.000151990044423 , 9.67367346776e-05 , 4.85594366122e-05 , 1.91972018738e-05 ,
 5.96810475373e-06 , 1.45692664165e-06 , 2.78904268408e-07 , 4.18180889843e-08 ,
 4.90579095852e-09 , 4.4988658541e-10  , 3.22273109861e-11 , 1.80221931143e-12 ,
 7.86391980906e-14 , 2.67636716462e-15 , 7.10214530434e-17 , 7.67208438517e-18 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.44908692794e-17 ,
 1.18679001711e-15 , 4.97412492262e-14 , 1.64905421295e-12 , 4.32427794194e-11 ,
 8.96466497657e-10 , 1.46791097355e-08 , 1.89617886399e-07 , 1.92956112545e-06 ,
 1.54450964668e-05 , 9.71043254453e-05 , 0.000478857224264 , 0.00184993393439  ,
 0.00559268763761  , 0.0132190415016   , 0.0244096148317   , 0.0351907862222   ,
 0.039589578955    , 0.0347405621033   , 0.0237713058363   , 0.0126798799928   ,
 0.00527148115241  , 0.00170778900785  , 0.000431085761434 , 8.47767961701e-05 ,
 1.29879217935e-05 , 1.5499749125e-06  , 1.44082390224e-07 , 1.04323437101e-08 ,
 5.88335089253e-10 , 2.5842198808e-11  , 8.8407317114e-13  , 2.35556421544e-14 ,
 4.88581437748e-16 , 3.4057573035e-23  , 1.50169190733e-24 , 5.17096039851e-26 ,
 1.39099614845e-27 , 2.90812328796e-29 , 3.97781234108e-32 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9.19212064238e-22 ,
 4.56035702662e-20 , 1.72526009564e-18 , 5.09447897116e-17 , 1.17484955878e-15 ,
 2.11741049962e-14 , 2.98492736085e-13 , 3.2945942838e-12  , 2.85044574542e-11 ,
 1.9356842062e-10  , 1.03320583776e-09 , 4.34126518973e-09 , 1.43800165022e-08 ,
 3.76006581218e-08 , 7.76952861465e-08 , 1.26960695853e-07 , 1.64111399009e-07 ,
 1.67776131663e-07 , 1.35679907312e-07 , 8.82772539936e-08 , 6.34202453699e-08 ,
 1.89432054876e-07 , 1.17324220186e-06 , 6.22541349071e-06 , 2.61056897497e-05 ,
 8.62981685778e-05 , 0.000225153980652 , 0.000464147936573 , 0.000756609234439 ,
 0.00097560937604  , 0.000994977041313 , 0.000802095872736 , 0.000510609004189 ,
 0.000256358491341 , 0.000101362995116 , 3.15163390004e-05 , 7.69459404208e-06 ,
 1.47313853877e-06 , 2.20894912994e-07 , 2.59153699387e-08 , 2.37669254027e-09 ,
 1.70259467498e-10 , 9.52156941605e-12 , 4.15480658953e-13 , 1.41405392789e-14 ,
 3.75246414494e-16 , 3.18585438962e-17 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 1.27535422759e-17 , 1.04450439543e-15 , 4.37777135817e-14 ,
 1.45134720455e-12 , 3.80583528027e-11 , 7.88988097012e-10 , 1.2919214367e-08  ,
 1.66884379662e-07 , 1.69822382032e-06 , 1.35933660671e-05 , 8.54623760565e-05 ,
 0.000421446480264 , 0.00162814322488  , 0.00492217387701  , 0.0116341953949   ,
 0.021483118003    , 0.0309717223414   , 0.0348431387485   , 0.0305754761106   ,
 0.020921336608    , 0.0111596745802   , 0.00463947720718  , 0.00150304021726  ,
 0.000379402393118 , 7.46128084593e-05 , 1.1430784894e-05  , 1.36414663523e-06 ,
 1.26808186465e-07 , 9.18159798787e-09 , 5.17798913604e-10 , 2.27439471754e-11 ,
 7.7808054224e-13  , 2.0731521827e-14  , 4.3000432101e-16  , 2.9197441474e-25  ,
 1.27728056632e-26 , 4.35578224719e-28 , 1.15769846987e-29 , 2.38023360083e-31 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 9.49941226806e-21 , 4.71280928208e-19 , 1.78293535907e-17 , 5.26478686701e-16 ,
 1.21412465589e-14 , 2.18819530979e-13 , 3.08471316838e-12 , 3.40473222398e-11 ,
 2.9457358467e-10  , 2.00039392549e-09 , 1.06774580018e-08 , 4.48639322814e-08 ,
 1.48607389405e-07 , 3.88576441622e-07 , 8.02926312142e-07 , 1.31204972069e-06 ,
 1.69597434336e-06 , 1.73380456178e-06 , 1.40136166445e-06 , 9.01084033882e-07 ,
 5.31908312658e-07 , 8.90432329906e-07 , 4.88758758904e-06 , 2.57703248049e-05 ,
 0.000108053842244 , 0.000357269905418 , 0.000932352396916 , 0.00192251794771  ,
 0.00313475529162  , 0.00404321546667  , 0.00412458344255  , 0.00332585489669  ,
 0.0021177110501   , 0.00106344897966  , 0.000420559827088 , 0.000130783264822 ,
 3.19344493742e-05 , 6.11455486138e-06 , 9.16950530656e-07 , 1.07584368097e-07 ,
 9.86711402442e-09 , 7.06884872836e-10 , 3.95332083031e-11 , 1.7251111215e-12  ,
 5.87140827024e-14 , 1.55811947892e-15 , 1.0412261726e-16  , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8.74685016239e-18 , 7.16359678207e-16 ,
 3.00243722777e-14 , 9.95387497618e-13 , 2.61018234927e-11 , 5.41117166916e-10 ,
 8.86047419919e-09 , 1.14455469059e-07 , 1.16470459557e-06 , 9.32283232528e-06 ,
 5.86132528294e-05 , 0.00028904355626  , 0.00111664073579  , 0.00337580857491  ,
 0.00797916074433  , 0.014733915498    , 0.0212415506791   , 0.0238967109864   ,
 0.0209697903843   , 0.014348625076    , 0.00765371684996  , 0.00318192476138  ,
 0.00103084047428  , 0.000260208168998 , 5.11722187978e-05 , 7.83965431276e-06 ,
 9.35582127675e-07 , 8.69697361227e-08 , 6.29707889085e-09 , 3.55125612413e-10 ,
 1.55986386906e-11 , 5.336363626e-13   , 1.42184430414e-14 , 2.94912835835e-16 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 7.70398134699e-20 , 3.82206748971e-18 , 1.44595269282e-16 ,
 4.26971887047e-15 , 9.84649727577e-14 , 1.77461672096e-12 , 2.50168874025e-11 ,
 2.76122277935e-10 , 2.38897874687e-09 , 1.62231062867e-08 , 8.65937122825e-08 ,
 3.63844507108e-07 , 1.20519935728e-06 , 3.15133776023e-06 , 6.51169688392e-06 ,
 1.06406650118e-05 , 1.37542707394e-05 , 1.40609353986e-05 , 1.13624055669e-05 ,
 7.27146296224e-06 , 3.91353368857e-06 , 3.76225527267e-06 , 1.61774587078e-05 ,
 8.39578624318e-05 , 0.000351842023289 , 0.00116358084611  , 0.00303738851579  ,
 0.00626500098008  , 0.010218579695    , 0.0131841200629   , 0.0134536014081   ,
 0.0108514774275   , 0.00691145100015  , 0.00347155444999  , 0.00137317786625  ,
 0.000427100178757 , 0.000104304524998 , 1.99739246998e-05 , 2.99563836977e-06 ,
 3.51503021484e-07 , 3.22403173718e-08 , 2.30983642747e-09 , 1.29185320926e-10 ,
 5.63745218105e-12 , 1.91875558031e-13 , 5.09198642642e-15 , 2.68231965506e-16 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4.67413009848e-18 ,
 3.82807327333e-16 , 1.60443839263e-14 , 5.31913840512e-13 , 1.39482575496e-11 ,
 2.89161468383e-10 , 4.73484835939e-09 , 6.1162560571e-08  , 6.22393285002e-07 ,
 4.98192267681e-06 , 3.13216717027e-05 , 0.00015445870925  , 0.000596708983858 ,
 0.00180396007405  , 0.00426389325337  , 0.00787349007001  , 0.0113510314598   ,
 0.0127698924759   , 0.0112058085567   , 0.00766759908929  , 0.00408998298009  ,
 0.00170035270093  , 0.000550859154792 , 0.000139049693547 , 2.73453418828e-05 ,
 4.18934399294e-06 , 4.9995512686e-07  , 4.64747713429e-08 , 3.36502460083e-09 ,
 1.8977155009e-10  , 8.33557969387e-12 , 2.85163886172e-13 , 7.59803258766e-15 ,
 1.57595127024e-16 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 4.89677856045e-19 , 2.42936960738e-17 ,
 9.19071558808e-16 , 2.71390426357e-14 , 6.25859728676e-13 , 1.12797587647e-11 ,
 1.59011493362e-10 , 1.75507908152e-09 , 1.51847458894e-08 , 1.03116759336e-07 ,
 5.5040402446e-07  , 2.31265614686e-06 , 7.66044738168e-06 , 2.00304264584e-05 ,
 4.13894274228e-05 , 6.7633834438e-05  , 8.74244147074e-05 , 8.93732798894e-05 ,
 7.22148047556e-05 , 4.61264984449e-05 , 2.38584866524e-05 , 1.51241167996e-05 ,
 4.3198400919e-05  , 0.000215772468486 , 0.000902715604755 , 0.00298584145824  ,
 0.00779643171246  , 0.0160864103846   , 0.0262470131689   , 0.0338761862934   ,
 0.0345806367024   , 0.0279014422778   , 0.0177762036371   , 0.00893124618906  ,
 0.00353360800305  , 0.00109928424045  , 0.000268508492709 , 5.14256934574e-05 ,
 7.71359430775e-06 , 9.05185382216e-07 , 8.30310984289e-08 , 5.94906968673e-09 ,
 3.3273763988e-10  , 1.45207213455e-11 , 4.94240155882e-13 , 1.31164368032e-14 ,
 5.45394028398e-16 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.94596053683e-18 , 1.5937253275e-16  , 6.6796895466e-15  , 2.21449407873e-13 ,
 5.80701824235e-12 , 1.20385353935e-10 , 1.97123910998e-09 , 2.54635465199e-08 ,
 2.59118326936e-07 , 2.07410250086e-06 , 1.30400172432e-05 , 6.43051319576e-05 ,
 0.000248425291999 , 0.000751034960551 , 0.00177516839058  , 0.00327793635191  ,
 0.00472572624375  , 0.00531643456515  , 0.00466526621535  , 0.00319221864296  ,
 0.0017027650724   , 0.000707900547265 , 0.000229336829312 , 5.78899625385e-05 ,
 1.13845689035e-05 , 1.74413161673e-06 , 2.08144173687e-07 , 1.93486422256e-08 ,
 1.40094625967e-09 , 7.90067755296e-11 , 3.47031614313e-12 , 1.18721057679e-13 ,
 3.1632563197e-15  , 6.56109033177e-17 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.43661985985e-18 ,
 1.20884580734e-16 , 4.57326788453e-15 , 1.35042925563e-13 , 3.11425608805e-12 ,
 5.61276845199e-11 , 7.91235621313e-10 , 8.73321203493e-09 , 7.5558763673e-08  ,
 5.13105382611e-07 , 2.73879114684e-06 , 1.15076959819e-05 , 3.81181178506e-05 ,
 9.96707004559e-05 , 0.000205952341094 , 0.000336543590183 , 0.000435020795136 ,
 0.000444717599472 , 0.000359325410849 , 0.000229340789604 , 0.000116694698162 ,
 5.77331315277e-05 , 9.59782420199e-05 , 0.000439083826526 , 0.00182835652498  ,
 0.00604657170841  , 0.0157915292596   , 0.0325924740388   , 0.0531974027074   ,
 0.0686858328357   , 0.0701403870835   , 0.0566132061243   , 0.0360806621812   ,
 0.0181333192416   , 0.00717624578683  , 0.0022329880845   , 0.000545527289852 ,
 0.000104497677668 , 1.56761342633e-05 , 1.83977559022e-06 , 1.68773549701e-07 ,
 1.20932108597e-08 , 6.76421662447e-10 , 2.95203812688e-11 , 1.00481507295e-12 ,
 2.66670675099e-14 , 8.76252265897e-16 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 6.31127077365e-19 , 5.16887772919e-17 , 2.16640207315e-15 ,
 7.18219691151e-14 , 1.88337141588e-12 , 3.90441918779e-11 , 6.3932559511e-10  ,
 8.25850955881e-09 , 8.4039007614e-08  , 6.7268694547e-07  , 4.22922655199e-06 ,
 2.08558751444e-05 , 8.05709702309e-05 , 0.00024358073593  , 0.000575734613821 ,
 0.00106312247881  , 0.0015326794846   , 0.00172426200101  , 0.00151307067944  ,
 0.00103532193193  , 0.000552252280171 , 0.000229591091394 , 7.43800709607e-05 ,
 1.87752640273e-05 , 3.69232035448e-06 , 5.65668557494e-07 , 6.75067256112e-08 ,
 6.27528245704e-09 , 4.54364362318e-10 , 2.56240115812e-11 , 1.12551639332e-12 ,
 3.85044160642e-14 , 1.02592867544e-15 , 2.12793717399e-17 , 9.38380657068e-31 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 9.48248559308e-18 , 4.70441168982e-16 , 1.77975840807e-14 ,
 5.25540572493e-13 , 1.21196124905e-11 , 2.18429624006e-10 , 3.07921662441e-09 ,
 3.39866544909e-08 , 2.94048694163e-07 , 1.99682949257e-06 , 1.06584322078e-05 ,
 4.47839907883e-05 , 0.000148342591025 , 0.000387884050647 , 0.000801495604398 ,
 0.00130971178368  , 0.00169295112191  , 0.00173068676122  , 0.00139835135592  ,
 0.000892234459378 , 0.000450995014547 , 0.000197332005655 , 0.000187259529964 ,
 0.000713458427186 , 0.002932964282    , 0.00968503210214  , 0.0252842079012   ,
 0.052184725905    , 0.0851932436137   , 0.110031164333    , 0.112400891703    ,
 0.090756014032    , 0.0578603654128   , 0.0290884162042   , 0.0115149047342   ,
 0.00358387667479  , 0.000875730701767 , 0.000167777351573 , 2.51724308925e-05 ,
 2.95460387571e-06 , 2.71067571815e-07 , 1.94243172792e-08 , 1.08654128347e-09 ,
 4.74209370831e-11 , 1.61417135663e-12 , 4.28401325287e-14 , 1.11326425634e-15 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.59449110101e-19 ,
 1.30587481302e-17 , 5.4732381968e-16  , 1.81452348851e-14 , 4.75818431857e-13 ,
 9.86419672497e-12 , 1.61520398762e-10 , 2.08644510297e-09 , 2.12317700484e-08 ,
 1.69948871914e-07 , 1.0684796047e-06  , 5.26906680358e-06 , 2.03555986808e-05 ,
 6.15386868591e-05 , 0.00014545465584  , 0.000268589225935 , 0.000387218974844 ,
 0.000435620735516 , 0.000382264970105 , 0.000261565644444 , 0.000139522035712 ,
 5.80043172349e-05 , 1.87915184591e-05 , 4.7434173696e-06  , 9.32834631685e-07 ,
 1.42911548791e-07 , 1.70550238002e-08 , 1.58539894642e-09 , 1.14791451422e-10 ,
 6.47369759758e-12 , 2.84352539754e-13 , 9.72782676932e-15 , 2.59192514866e-16 ,
 5.37605976767e-18 , 4.77196167644e-29 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.88374067442e-17 ,
 1.43066954397e-15 , 5.41246455015e-14 , 1.59823361721e-12 , 3.68572344814e-11 ,
 6.64271392833e-10 , 9.36427705373e-09 , 1.03357602794e-07 , 8.94238299961e-07 ,
 6.07260445701e-06 , 3.2413605253e-05  , 0.000136193632494 , 0.000451128092196 ,
 0.00117960317771  , 0.00243744686161  , 0.00398299486672  , 0.00514847289802  ,
 0.00526323092928  , 0.00425254009335  , 0.00271308794857  , 0.00136788626285  ,
 0.000567394547562 , 0.000343057923807 , 0.000949228876031 , 0.00376591078702  ,
 0.0123435880824   , 0.0321181555141   , 0.0661846994906   , 0.107978632894    ,
 0.13943974518     , 0.142460027029    , 0.115054855492    , 0.0733730594782   ,
 0.0368979437292   , 0.0146103267438   , 0.00454837769123  , 0.00111163701553  ,
 0.000213010115807 , 3.19634285937e-05 , 3.75212504494e-06 , 3.44267268816e-07 ,
 2.4671525455e-08  , 1.38013622956e-09 , 6.02373720957e-11 , 2.05050772569e-12 ,
 5.44220725732e-14 , 1.11881574706e-15 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 3.53338054183e-31 , 1.80696050272e-29 , 6.89192636244e-28 , 2.05590256163e-26 ,
 4.80133055077e-25 , 8.78850106853e-24 , 1.26248102217e-22 , 1.42530445057e-21 ,
 4.40433503356e-20 , 2.65856129576e-18 , 1.08199173441e-16 , 3.57297292453e-15 ,
 9.36444905731e-14 , 1.94121167831e-12 , 3.17859079421e-11 , 4.10595029178e-10 ,
 4.17823495851e-09 , 3.34445174095e-08 , 2.10267854344e-07 , 1.03690830038e-06 ,
 4.00581165882e-06 , 1.21102991462e-05 , 2.86242603577e-05 , 5.28561144347e-05 ,
 7.62014573742e-05 , 8.57265192996e-05 , 7.52265507122e-05 , 5.14739323927e-05 ,
 2.74567703793e-05 , 1.14147647908e-05 , 3.69801376428e-06 , 9.33464891991e-07 ,
 1.83574059066e-07 , 2.81237984448e-08 , 3.35628616024e-09 , 3.11993265227e-10 ,
 2.25899985724e-11 , 1.27396960885e-12 , 5.59582049519e-14 , 1.91435508394e-15 ,
 5.10069234739e-17 , 1.0579637082e-18  , 1.81737327816e-27 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 6.84847741842e-17 , 3.39763840487e-15 , 1.28538400067e-13 , 3.79557944787e-12 ,
 8.75307340534e-11 , 1.57755087823e-09 , 2.22388373931e-08 , 2.45459730494e-07 ,
 2.12368985127e-06 , 1.44215791884e-05 , 7.69777413045e-05 , 0.000323440670286 ,
 0.00107136559803  , 0.002801391192    , 0.0057885925531   , 0.00945905111835  ,
 0.0122268972921   , 0.0124994333064   , 0.0100991913299   , 0.00644310121604  ,
 0.00324616549635  , 0.00132110872901  , 0.00061417780762  , 0.00112178538416  ,
 0.00404319307373  , 0.0128283765822   , 0.0328153629305   , 0.0669994360751   ,
 0.108778120683    , 0.140132567336    , 0.143011359636    , 0.115454762079    ,
 0.0736251613116   , 0.037029299695    , 0.0146650714281   , 0.00456632294207  ,
 0.00111622908674  , 0.000213924692815 , 3.21050597846e-05 , 3.76917646514e-06 ,
 3.45863501526e-07 , 2.47877439996e-08 , 1.38671898808e-09 , 6.05275002998e-11 ,
 2.06045937818e-12 , 5.46877788059e-14 , 8.89290424637e-16 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 1.82841151863e-29 , 9.35044317407e-28 , 3.566351656e-26   ,
 1.06386387777e-24 , 2.48453512998e-23 , 4.54776845996e-22 , 6.53293585464e-21 ,
 7.37549506523e-20 , 6.60188096331e-19 , 4.98431098088e-18 , 4.18875559436e-17 ,
 6.58206212698e-16 , 1.47358637891e-14 , 2.98596495849e-13 , 4.87446732835e-12 ,
 6.29407422762e-11 , 6.40454058986e-10 , 5.12645336169e-09 , 3.2230315948e-08  ,
 1.58939552587e-07 , 6.14019501572e-07 , 1.85629297508e-06 , 4.38758899281e-06 ,
 8.10190072391e-06 , 1.16803265228e-05 , 1.31403497834e-05 , 1.15308924379e-05 ,
 7.89003930502e-06 , 4.20863565955e-06 , 1.74968118894e-06 , 5.66840115032e-07 ,
 1.43083702332e-07 , 2.81386756515e-08 , 4.3108858937e-09  , 5.14460220967e-10 ,
 4.78231721756e-11 , 3.46265963675e-12 , 1.95277962109e-13 , 8.57745931633e-15 ,
 2.93439328555e-16 , 7.81854878693e-18 , 1.62169557292e-19 , 5.41136378374e-26 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 1.26938721444e-16 , 6.29763155653e-15 , 2.38250039594e-13 ,
 7.03522801954e-12 , 1.62241017805e-10 , 2.92404105703e-09 , 4.12203970695e-08 ,
 4.54967468698e-07 , 3.93632712784e-06 , 2.67308587228e-05 , 0.000142680707898 ,
 0.00059950763711  , 0.00198581043501  , 0.00519246825918  , 0.0107293416188   ,
 0.0175326541443   , 0.0226629466298   , 0.0231681120958   , 0.0187192826777   ,
 0.0119431848072   , 0.00601961688089  , 0.0024498958105   , 0.00106351710589  ,
 0.00143839041855  , 0.00424591330293  , 0.0120073560754   , 0.0285968276334   ,
 0.0559568537578   , 0.0886852007381   , 0.112754931419    , 0.114278056117    ,
 0.0919368347678   , 0.058530755019    , 0.0294167410936   , 0.0116473976443   ,
 0.00362662837159  , 0.000886588731509 , 0.00016993222428  , 2.55055747847e-05 ,
 2.99468019387e-06 , 2.74817806274e-07 , 1.96973145359e-08 , 1.10200280747e-09 ,
 4.81023580277e-11 , 1.63754384629e-12 , 4.34641667232e-14 , 5.58711500053e-16 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6.99528314521e-28 , 3.5773673962e-26  ,
 1.36444336381e-24 , 4.07021558175e-23 , 9.50553337768e-22 , 1.73992166053e-20 ,
 2.49942289288e-19 , 2.82177594003e-18 , 2.50745645664e-17 , 1.75670170323e-16 ,
 9.72892574407e-16 , 4.30678294603e-15 , 1.63656009526e-14 , 7.55633536592e-14 ,
 6.6824112365e-13  , 7.66211208389e-12 , 7.66655285834e-11 , 6.12284644821e-10 ,
 3.84833261168e-09 , 1.89768680773e-08 , 7.3311900073e-08  , 2.21636328199e-07 ,
 5.23869653848e-07 , 9.67359289502e-07 , 1.39463434549e-06 , 1.56898197573e-06 ,
 1.37683256984e-06 , 9.42120672352e-07 , 5.02551303439e-07 , 2.08935860867e-07 ,
 6.7691456446e-08  , 1.70878766011e-08 , 3.36072682299e-09 , 5.14916347685e-10 ,
 6.14573839023e-11 , 5.71384095852e-12 , 4.13828017064e-13 , 2.34492502984e-14 ,
 1.29680617676e-15 , 5.77656127857e-16 , 8.63235818155e-16 , 1.09402862889e-15 ,
 1.11369740835e-15 , 9.14130406505e-16 , 6.0727538486e-16  , 3.27142447431e-16 ,
 1.42856632974e-16 , 5.04376483687e-17 , 1.43374185568e-17 , 3.26485548773e-18 ,
 5.92539209613e-19 , 8.53104665045e-20 , 9.70483105849e-21 , 8.69484674109e-22 ,
 6.11936404974e-23 , 3.37638613103e-24 , 1.45824611233e-25 , 4.9241424241e-27  ,
 1.29749723605e-28 , 2.60148464027e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.83552897637e-16 , 9.10635074389e-15 , 3.44508630874e-13 , 1.01729123614e-11 ,
 2.34599880911e-10 , 4.22815199902e-09 , 5.96045338868e-08 , 6.57881190704e-07 ,
 5.69191372138e-06 , 3.86527177765e-05 , 0.000206315748841 , 0.000866885712219 ,
 0.00287147416768  , 0.00750828891356  , 0.0155145862736   , 0.0253521499387   ,
 0.0327705360135   , 0.0335010395718   , 0.0270683819305   , 0.0172725290506   ,
 0.00871979263067  , 0.00360815058485  , 0.00173321945531  , 0.00239399544067  ,
 0.00577869009834  , 0.0131038218117   , 0.025809199557    , 0.0438082363215   ,
 0.0631604243791   , 0.0758138505625   , 0.0743658540697   , 0.0587771059592   ,
 0.0370758822133   , 0.018547286289    , 0.00732712434732  , 0.00227905820259  ,
 0.000556908132379 , 0.000106726128716 , 1.60184420352e-05 , 1.88082786684e-06 ,
 1.72609458491e-07 , 1.23722467583e-08 , 6.92219753214e-10 , 3.02165179309e-11 ,
 1.02868893994e-12 , 2.73044702185e-14 , 2.77176347518e-16 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 2.09468690824e-26 , 1.07121677496e-24 , 4.08572689893e-23 ,
 1.21879659705e-21 , 2.84636317197e-20 , 5.21006948256e-19 , 7.48434095258e-18 ,
 8.44960382139e-17 , 7.50822546361e-16 , 5.25891222555e-15 , 2.90737238661e-14 ,
 1.27012789241e-13 , 4.38902994898e-13 , 1.20223332689e-12 , 2.64562040601e-12 ,
 5.13117047068e-12 , 1.31492213511e-11 , 6.38555545203e-11 , 3.67129992923e-10 ,
 1.78919210098e-09 , 6.90674389506e-09 , 2.08983027207e-08 , 4.94589569795e-08 ,
 9.14748120015e-08 , 1.32141293537e-07 , 1.4903365121e-07  , 1.31197413489e-07 ,
 9.0136575934e-08  , 4.83284025868e-08 , 2.02241771856e-08 , 6.60693350879e-09 ,
 1.6855384646e-09  , 3.35966550263e-10 , 5.23535932468e-11 , 6.38322154259e-12 ,
 6.09909318486e-13 , 4.72692778539e-14 , 7.94182536627e-15 , 1.34536421599e-14 ,
 2.67381430943e-14 , 4.26086962086e-14 , 5.42265843741e-14 , 5.53836867429e-14 ,
 4.56069896001e-14 , 3.03880687007e-14 , 1.64113255248e-14 , 7.1801669326e-15  ,
 2.53829949212e-15 , 7.2205255944e-16  , 1.64467891982e-16 , 2.984849797e-17   ,
 4.29652397779e-18 , 4.88622580464e-19 , 4.37628966748e-20 , 3.07902460152e-21 ,
 1.69837832596e-22 , 7.33339202703e-24 , 2.47578693566e-25 , 6.5227122259e-27  ,
 1.30686225139e-28 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.06985000943e-16 ,
 1.02688546003e-14 , 3.88488115437e-13 , 1.14715719655e-11 , 2.64548569903e-10 ,
 4.76791190316e-09 , 6.72135643815e-08 , 7.41865373039e-07 , 6.41853537672e-06 ,
 4.35870690596e-05 , 0.000232653725537 , 0.000977551116167 , 0.00323804249871  ,
 0.00846678645804  , 0.0174951564409   , 0.0285885700569   , 0.0369539841254   ,
 0.0377778292957   , 0.0305247918954   , 0.0194842647479   , 0.00987283127872  ,
 0.00425328322173  , 0.00261701269989  , 0.00451464677465  , 0.010171065707    ,
 0.0196404039947   , 0.0314049073723   , 0.0423594183703   , 0.0492223487031   ,
 0.04972977081     , 0.0432968127897   , 0.0317944358228   , 0.0192355606636   ,
 0.00940956710355  , 0.00367456157164  , 0.00113634968552  , 0.000276891969153 ,
 5.29922842845e-05 , 7.94866738547e-06 , 9.33056768588e-07 , 8.56210137206e-08 ,
 6.13696375961e-09 , 3.43361711435e-10 , 1.49885671009e-11 , 5.1027624407e-13  ,
 1.35445340779e-14 , 1.08440776533e-16 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 4.91467502591e-25 , 2.51335047283e-23 , 9.58616768642e-22 , 2.85961074833e-20 ,
 6.67830115372e-19 , 1.22241649903e-17 , 1.75601916546e-16 , 1.98249469725e-15 ,
 1.76162296206e-14 , 1.23387523993e-13 , 6.82140152607e-13 , 2.97990472531e-12 ,
 1.02940578849e-11 , 2.81299987278e-11 , 6.0803824483e-11  , 1.03990354551e-10 ,
 1.41579497035e-10 , 1.61610950468e-10 , 2.07993499933e-10 , 5.13428625274e-10 ,
 1.80025179878e-09 , 5.65621931881e-09 , 1.42590971611e-08 , 2.84228427641e-08 ,
 4.47578258911e-08 , 5.57202425531e-08 , 5.48764507055e-08 , 4.27676157562e-08 ,
 2.63713952273e-08 , 1.28581688387e-08 , 4.95248216408e-09 , 1.50490119899e-09 ,
 3.60248560405e-10 , 6.78343831478e-11 , 1.0035185428e-11  , 1.17891335532e-12 ,
 1.67598772913e-13 , 2.06119266742e-13 , 5.03729217533e-13 , 1.00988388664e-12 ,
 1.6106773131e-12  , 2.05165598371e-12 , 2.09749378561e-12 , 1.72900362679e-12 ,
 1.15321183105e-12 , 6.23409347499e-13 , 2.73008265508e-13 , 9.66092468838e-14 ,
 2.75154186558e-14 , 6.27831118702e-15 , 1.14251838097e-15 , 1.65189074537e-16 ,
 1.89240635692e-17 , 1.71548721871e-18 , 1.23104910285e-19 , 7.01100427811e-21 ,
 3.18514081573e-22 , 1.16354590506e-23 , 3.45088023294e-25 , 8.27602984544e-27 ,
 8.78426108977e-29 , 1.80281361595e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.81971053817e-16 , 9.02787295991e-15 , 3.41539683743e-13 , 1.00852430369e-11 ,
 2.32578118375e-10 , 4.19171413181e-09 , 5.90908669014e-08 , 6.52211624549e-07 ,
 5.64286127566e-06 , 3.83196118243e-05 , 0.000204537736636 , 0.000859414962238 ,
 0.00284672803886  , 0.00744358309834  , 0.0153808829136   , 0.0251336685864   ,
 0.0324881435427   , 0.0332125876274   , 0.0268375629347   , 0.0171421696698   ,
 0.00875457244179  , 0.00409100467537  , 0.00359984289164  , 0.00772584211606  ,
 0.0173925806437   , 0.0318808822956   , 0.046576469137    , 0.0546409851776   ,
 0.0523308032628   , 0.0419223354179   , 0.0288630962246   , 0.0173805598601   ,
 0.00912360520107  , 0.00408429658701  , 0.00151676510147  , 0.000456671229833 ,
 0.000109762794193 , 2.08635811728e-05 , 3.1189903033e-06  , 3.65530405948e-07 ,
 3.35166618304e-08 , 2.40147558927e-09 , 1.34340453776e-10 , 5.86389388567e-12 ,
 1.99620792712e-13 , 5.29866277526e-15 , 3.34095156759e-17 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 9.04647190488e-24 , 4.62633934487e-22 , 1.76453165659e-20 ,
 5.26370271835e-19 , 1.22927891348e-17 , 2.25010940829e-16 , 3.23231504851e-15 ,
 3.64918992319e-14 , 3.24262998994e-13 , 2.27120157383e-12 , 1.25561945087e-11 ,
 5.4851273831e-11  , 1.89483020787e-10 , 5.17783644912e-10 , 1.11910203497e-09 ,
 1.91258562622e-09 , 2.58955180883e-09 , 2.83837163971e-09 , 2.94289104334e-09 ,
 4.93272891516e-09 , 1.50258521465e-08 , 4.70326579344e-08 , 1.20922918914e-07 ,
 2.46762114752e-07 , 3.98263112203e-07 , 5.08409180913e-07 , 5.13399412607e-07 ,
 4.09979310725e-07 , 2.58708247055e-07 , 1.28861290357e-07 , 5.0595796671e-08  ,
 1.56367980287e-08 , 3.79819134968e-09 , 7.24088152463e-10 , 1.08280756094e-10 ,
 1.31045911385e-11 , 2.97940381382e-12 , 5.92912972505e-12 , 1.48254216052e-11 ,
 2.97574879009e-11 , 4.75050237132e-11 , 6.05770857905e-11 , 6.2003748635e-11  ,
 5.11723364318e-11 , 3.41702258211e-11 , 1.84912487278e-11 , 8.10538863577e-12 ,
 2.87075429703e-12 , 8.18394471684e-13 , 1.86966207321e-13 , 3.40868932183e-14 ,
 4.94311844558e-15 , 5.69059830146e-16 , 5.19985004538e-17 , 3.77930465378e-18 ,
 2.19540704787e-19 , 1.02725056978e-20 , 3.91130801072e-22 , 1.22412747506e-23 ,
 3.1368741237e-25  , 4.41422344677e-27 , 9.05973459646e-29 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 1.24696049189e-16 , 6.18636902448e-15 , 2.34040790064e-13 ,
 6.91093410428e-12 , 1.59374647126e-10 , 2.87238096721e-09 , 4.04921414215e-08 ,
 4.46929394048e-07 , 3.86678261427e-06 , 2.62585949838e-05 , 0.000140159916281 ,
 0.000588915919087 , 0.00195072640474  , 0.00510073105161  , 0.0105397825914   ,
 0.017222900873    , 0.0222625897827   , 0.0227592467378   , 0.0183928946108   ,
 0.0117648326236   , 0.00610734582339  , 0.00331372006921  , 0.00436275156369  ,
 0.0108337855295   , 0.0246173237853   , 0.0446116011509   , 0.0636724227818   ,
 0.0716141706806   , 0.0637368882093   , 0.045280186951    , 0.0260855323651   ,
 0.0124900798649   , 0.00512355569328  , 0.00184362558697  , 0.000582952349051 ,
 0.000158536986323 , 3.59653506954e-05 , 6.62979652621e-06 , 9.75734705644e-07 ,
 1.13462009708e-07 , 1.0363711608e-08  , 7.41162435426e-10 , 4.14230905527e-11 ,
 1.80728947179e-12 , 6.15009253956e-14 , 1.63235230922e-15 , 8.09358522765e-18 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.30820744702e-22 , 6.69013472549e-21 ,
 2.55168365958e-19 , 7.6118238883e-18  , 1.77765635707e-16 , 3.25387611379e-15 ,
 4.67424059019e-14 , 5.27708203076e-13 , 4.68915699442e-12 , 3.28437742601e-11 ,
 1.81574731619e-10 , 7.93202506272e-10 , 2.74010699872e-09 , 7.48763031289e-09 ,
 1.61828927292e-08 , 2.76521338162e-08 , 3.73847447859e-08 , 4.0506362807e-08  ,
 3.89196210557e-08 , 5.20676338177e-08 , 1.37067920477e-07 , 4.17094459144e-07 ,
 1.06850662768e-06 , 2.17978094839e-06 , 3.51842747047e-06 , 4.49218119044e-06 ,
 4.53696395944e-06 , 3.62355558313e-06 , 2.28687089671e-06 , 1.13921737957e-06 ,
 4.47347620019e-07 , 1.38267075947e-07 , 3.35878543528e-08 , 6.40380811096e-09 ,
 9.58898303485e-10 , 1.22261601845e-10 , 5.21226231317e-11 , 1.35068499482e-10 ,
 3.40677414803e-10 , 6.84483442215e-10 , 1.09397333369e-09 , 1.39692090448e-09 ,
 1.43196764729e-09 , 1.18363255041e-09 , 7.91538767955e-10 , 4.28927599966e-10 ,
 1.88250383057e-10 , 6.6756011964e-11  , 1.90572634917e-11 , 4.36189554934e-12 ,
 7.97517733462e-13 , 1.16184243774e-13 , 1.34752325807e-14 , 1.24606797619e-15 ,
 9.22605084746e-17 , 5.5098459822e-18  , 2.68037738222e-19 , 1.07332344055e-20 ,
 3.56356530758e-22 , 9.73960354187e-24 , 1.67720200129e-25 , 3.44220502882e-27 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 6.65904525225e-17 , 3.30365809895e-15 ,
 1.24982966344e-13 , 3.69059190207e-12 , 8.51095920178e-11 , 1.53391506521e-09 ,
 2.16237004973e-08 , 2.3867019676e-07  , 2.06494757263e-06 , 1.40226713993e-05 ,
 7.48485001039e-05 , 0.000314494146406 , 0.00104173111255  , 0.0027239033757   ,
 0.00562847745896  , 0.00919741211149  , 0.0118887394176   , 0.0121542237767   ,
 0.00982490863432  , 0.00630306771478  , 0.00338331491027  , 0.00234463261126  ,
 0.00446914443156  , 0.0120507816814   , 0.0275660049267   , 0.0498588377981   ,
 0.0708051381028   , 0.078869551489    , 0.0689248310361   , 0.0473314617295   ,
 0.0256411893345   , 0.0110472766154   , 0.00384237984743  , 0.00110543076681  ,
 0.000271552435909 , 5.85489712614e-05 , 1.1145657239e-05  , 1.83584733012e-06 ,
 2.53348769712e-07 , 2.84681334173e-08 , 2.55510485995e-09 , 1.81127267574e-10 ,
 1.00787931784e-11 , 4.38778306157e-13 , 1.49035799699e-14 , 3.95420347329e-16 ,
 1.53948541546e-18 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.48842783299e-21 ,
 7.61177652256e-20 , 2.90320697115e-18 , 8.66043880195e-17 , 2.022548645e-15   ,
 3.70213438541e-14 , 5.3181701483e-13  , 6.00405982205e-12 , 5.33514145609e-11 ,
 3.73683759746e-10 , 2.06588705888e-09 , 9.02475108328e-09 , 3.11758708093e-08 ,
 8.51912056783e-08 , 1.84119892654e-07 , 3.14575928976e-07 , 4.24916662813e-07 ,
 4.57143274686e-07 , 4.17692026079e-07 , 4.5931095692e-07  , 1.00506034037e-06 ,
 2.92679981128e-06 , 7.45244411022e-06 , 1.51916813559e-05 , 2.4518946332e-05  ,
 3.13044421014e-05 , 3.16164997213e-05 , 2.52512935923e-05 , 1.59364151185e-05 ,
 7.9388180706e-06  , 3.1174149328e-06  , 9.63537197081e-07 , 2.34063142086e-07 ,
 4.46296953594e-08 , 6.70494395917e-09 , 9.66397627009e-10 , 8.24301793298e-10 ,
 2.41661238631e-09 , 6.11541536093e-09 , 1.22988361924e-08 , 1.96841363269e-08 ,
 2.51783642786e-08 , 2.58591137668e-08 , 2.1416457233e-08  , 1.4349369109e-08  ,
 7.78981993425e-09 , 3.42471681344e-09 , 1.21660382939e-09 , 3.48051278389e-10 ,
 7.99010287541e-11 , 1.46766547234e-11 , 2.15447684493e-12 , 2.53284018218e-13 ,
 2.41241523055e-14 , 1.96181861985e-15 , 1.68338798815e-16 , 2.22257895985e-17 ,
 4.08774486141e-18 , 7.16886262073e-19 , 1.03126041167e-19 , 1.17613260808e-20 ,
 1.05533666398e-21 , 7.42866220182e-23 , 4.09644427271e-24 , 1.76753578987e-25 ,
 5.962043305e-27   , 1.57098041989e-28 , 3.13002989852e-30 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 2.77088610435e-17 , 1.37468059956e-15 , 5.20064891595e-14 , 1.53568708889e-12 ,
 3.54148345499e-11 , 6.38275274974e-10 , 8.99780808852e-09 , 9.93127252742e-08 ,
 8.59242476731e-07 , 5.83495438977e-06 , 3.11451057941e-05 , 0.00013086372403  ,
 0.000433473291664 , 0.00113343966682  , 0.00234205803516  , 0.00382712376142  ,
 0.00494702733839  , 0.00505772434337  , 0.00409059322866  , 0.00264064818252  ,
 0.00151478991366  , 0.00148059715186  , 0.0037393155417   , 0.0105229484083   ,
 0.0241610403502   , 0.0436968544282   , 0.0619963385634   , 0.0689193817636   ,
 0.0599908259765   , 0.0408793192457   , 0.0218174680522   , 0.00913496821668  ,
 0.00301204787765  , 0.00078813847899  , 0.000166003216083 , 2.88170410258e-05 ,
 4.25684392271e-06 , 5.51182505664e-07 , 6.31336137395e-08 , 6.28111359693e-09 ,
 5.25380122363e-10 , 3.58574714989e-11 , 1.95651405647e-12 , 8.43297072562e-14 ,
 2.83981240614e-15 , 7.52093895645e-17 , 2.29610167169e-19 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 1.33437387454e-20 , 6.82394907259e-19 , 2.60272177718e-17 ,
 7.76407362402e-16 , 1.81321258046e-14 , 3.31895930353e-13 , 4.76773354338e-12 ,
 5.38263286277e-11 , 4.78294830168e-10 , 3.35007069334e-09 , 1.85206541631e-08 ,
 8.09067904763e-08 , 2.79491293268e-07 , 7.63737344371e-07 , 1.6506174092e-06  ,
 2.81995397946e-06 , 3.80700277001e-06 , 4.07788345038e-06 , 3.60693219884e-06 ,
 3.38829239499e-06 , 5.97170598946e-06 , 1.6271071319e-05  , 4.10272672839e-05 ,
 8.35305076821e-05 , 0.000134795617244 , 0.000172096511211 , 0.000173811677063 ,
 0.000138818927804 , 8.76104028447e-05 , 4.36436328714e-05 , 1.71379812052e-05 ,
 5.29704456308e-06 , 1.28676965608e-06 , 2.45406896852e-07 , 3.71887206184e-08 ,
 6.93233653159e-09 , 1.09949628053e-08 , 3.38878911538e-08 , 8.58276798652e-08 ,
 1.72771887447e-07 , 2.76982515237e-07 , 3.55050116073e-07 , 3.65523357354e-07 ,
 3.03481667475e-07 , 2.03840639174e-07 , 1.10923539136e-07 , 4.88823009736e-08 ,
 1.74100875701e-08 , 4.99705166789e-09 , 1.1525687947e-09  , 2.13274260391e-10 ,
 3.16900193008e-11 , 3.80823983643e-12 , 3.81519527433e-13 , 3.62463283543e-14 ,
 4.60819170387e-15 , 9.04676048926e-16 , 1.91898991876e-16 , 3.46997281017e-17 ,
 5.02243542042e-18 , 5.73668381342e-19 , 5.14992879629e-20 , 3.62620152092e-21 ,
 2.00003611984e-22 , 8.63120828981e-24 , 2.91176884855e-25 , 7.6732475997e-27  ,
 1.52943136975e-28 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 8.9830652728e-18  , 4.45664133786e-16 ,
 1.68602269864e-14 , 4.97861580687e-13 , 1.14813008693e-11 , 2.06925446993e-10 ,
 2.91704149241e-09 , 3.21966569524e-08 , 2.78561837729e-07 , 1.89166115723e-06 ,
 1.00970775319e-05 , 4.24253228236e-05 , 0.000140529734103 , 0.000367455109296 ,
 0.000759282796826 , 0.00124073406723  , 0.0016038139027   , 0.00163985631669  ,
 0.00132776595704  , 0.000868325813223 , 0.000564313158312 , 0.00082580800333  ,
 0.0024998369732   , 0.00718596108903  , 0.0165315998185   , 0.0299046231857   ,
 0.0424247986357   , 0.0471464684083   , 0.0410065281557   , 0.0278975372273   ,
 0.0148405266806   , 0.00617359408188  , 0.00200972951911  , 0.000512888625053 ,
 0.000102997741489 , 1.63964722814e-05 , 2.09735689179e-06 , 2.20482026968e-07 ,
 1.96502186029e-08 , 1.53029851878e-09 , 1.05357028895e-10 , 6.31267845541e-12 ,
 3.18917112767e-13 , 1.31769241522e-14 , 4.27085065581e-16 , 1.12168188455e-17 ,
 2.68205161604e-20 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9.43910163913e-20 ,
 4.82712904572e-18 , 1.8411148376e-16  , 5.4921548952e-15  , 1.28263136493e-13 ,
 2.34776735365e-12 , 3.37260211422e-11 , 3.80756995076e-10 , 3.38336473875e-09 ,
 2.36977494629e-08 , 1.31011510501e-07 , 5.72318917429e-07 , 1.97706696766e-06 ,
 5.40252594863e-06 , 1.16760804948e-05 , 1.99468727321e-05 , 2.69197328863e-05 ,
 2.8757803916e-05  , 2.49185100391e-05 , 2.0809141259e-05  , 2.90829644577e-05 ,
 7.19306557248e-05 , 0.000178554865049 , 0.000362807731442 , 0.000585330271652 ,
 0.000747281922172 , 0.00075472691215  , 0.000602780777271 , 0.000380422650967 ,
 0.000189509763286 , 7.44166966486e-05 , 2.30008928886e-05 , 5.58753432311e-06 ,
 1.06629159602e-06 , 1.65290476105e-07 , 4.82525611574e-08 , 1.18974706047e-07 ,
 3.72624177088e-07 , 9.42945923037e-07 , 1.89965559347e-06 , 3.05139264721e-06 ,
 3.92168615932e-06 , 4.04950059992e-06 , 3.37284576006e-06 , 2.27271323078e-06 ,
 1.24068849195e-06 , 5.4856566231e-07  , 1.96124906403e-07 , 5.65749680285e-08 ,
 1.3145693965e-08  , 2.46100065258e-09 , 3.72918797957e-10 , 4.65802357926e-11 ,
 5.1681624644e-12  , 6.55916791827e-13 , 1.28719129306e-13 , 3.17158709613e-14 ,
 7.12234683574e-15 , 1.30273403414e-15 , 1.89001019709e-16 , 2.16001860674e-17 ,
 1.93940892641e-18 , 1.36571764809e-19 , 7.53306666536e-21 , 3.25106639471e-22 ,
 1.0967999893e-23  , 2.89043216483e-25 , 5.76184877031e-27 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 2.26877680101e-18 , 1.12557620041e-16 , 4.25824489581e-15 , 1.25740687625e-13 ,
 2.89973503106e-12 , 5.22614095992e-11 , 7.3673249215e-10  , 8.13163726918e-09 ,
 7.03540067777e-08 , 4.77760855407e-07 , 2.550133453e-06   , 1.07150048766e-05 ,
 3.5492406122e-05  , 9.28050293837e-05 , 0.00019176565776  , 0.000313362193823 ,
 0.000405069158462 , 0.000414254781582 , 0.00033620557659  , 0.00022583914209  ,
 0.000181615597279 , 0.000393222593011 , 0.00131906542652  , 0.00383130769118  ,
 0.00882323271206  , 0.0159639512572   , 0.0226495838823   , 0.0251706911086   ,
 0.0218905271359   , 0.0148881799505   , 0.00791476485065  , 0.00328797213401  ,
 0.00106735737341  , 0.000270856985097 , 5.37807166521e-05 , 8.37170499397e-06 ,
 1.0255121289e-06  , 9.95602833118e-08 , 7.7586420063e-09  , 4.95638603473e-10 ,
 2.67254949778e-11 , 1.25273124708e-12 , 5.17414567568e-14 , 1.8597398924e-15  ,
 5.1791154596e-17  , 1.31018031982e-18 , 2.45105110334e-21 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 1.89369339213e-31 , 9.54289746827e-30 , 3.62555712741e-28 ,
 5.27473680434e-19 , 2.69748498602e-17 , 1.02884749109e-15 , 3.06911315698e-14 ,
 7.16757059561e-13 , 1.31197386098e-11 , 1.88466962424e-10 , 2.12773733292e-09 ,
 1.89068396857e-08 , 1.32427209171e-07 , 7.32115457691e-07 , 3.19821916722e-06 ,
 1.10481988275e-05 , 3.0190256447e-05  , 6.52477720683e-05 , 0.000111463447337 ,
 0.000150397050621 , 0.000160400978319 , 0.00013720625002  , 0.000105461913322 ,
 0.000117433137007 , 0.000254060679691 , 0.000615214781599 , 0.00124602149271  ,
 0.0020094508363   , 0.00256531121821  , 0.00259085403207  , 0.00206924645349  ,
 0.00130592783188  , 0.000650555640374 , 0.000255460308685 , 7.89585657754e-05 ,
 1.91824230943e-05 , 3.66748410119e-06 , 6.03422330551e-07 , 3.28234493957e-07 ,
 1.02905364166e-06 , 3.21950058426e-06 , 8.12387885782e-06 , 1.63719941556e-05 ,
 2.63548578237e-05 , 3.39791079874e-05 , 3.52179532158e-05 , 2.94515007065e-05 ,
 1.99277807528e-05 , 1.09253625785e-05 , 4.85314651902e-06 , 1.7449033994e-06  ,
 5.07217305907e-07 , 1.19214889852e-07 , 2.27296873641e-08 , 3.55693572818e-09 ,
 4.77173350427e-10 , 6.4544442409e-11  , 1.22460808427e-11 , 3.31042088046e-12 ,
 9.04678865228e-13 , 2.07800476418e-13 , 3.81869840306e-14 , 5.54616373057e-15 ,
 6.34058191964e-16 , 5.69382993246e-17 , 4.00995773496e-18 , 2.21198663439e-19 ,
 9.54689909581e-21 , 3.22095517733e-22 , 8.48861051658e-24 , 1.69237710886e-25 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 4.46365591797e-19 , 2.21449058622e-17 , 8.37779195417e-16 ,
 2.47385800222e-14 , 5.70502106075e-13 , 1.02820581617e-11 , 1.44946843034e-10 ,
 1.59984141248e-09 , 1.38416471187e-08 , 9.39960276683e-08 , 5.01720498648e-07 ,
 2.10810049342e-06 , 6.98287680265e-06 , 1.82587254998e-05 , 3.77285306271e-05 ,
 6.16519704087e-05 , 7.96975538946e-05 , 8.15391533069e-05 , 6.65050469373e-05 ,
 4.71510095892e-05 , 5.20031728594e-05 , 0.000154243157483 , 0.000545896402882 ,
 0.00159363396278  , 0.00367215459921  , 0.00664522682011  , 0.0094293025454   ,
 0.0104797256242   , 0.00911444649425  , 0.00619886426191  , 0.00329508652291  ,
 0.00136849974545  , 0.000443993645687 , 0.000112533672892 , 2.22889877125e-05 ,
 3.45207906018e-06 , 4.18574657978e-07 , 3.98193415127e-08 , 2.98329977982e-09 ,
 1.77223330301e-10 , 8.4462018789e-12  , 3.291088613e-13   , 1.07639695805e-14 ,
 3.0352152274e-16  , 5.52909402466e-18 , 1.1973039946e-19  , 1.75091235354e-22 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 1.09227050987e-29 , 5.53506638058e-28 ,
 2.10624316709e-26 , 2.33055538714e-18 , 1.19183905249e-16 , 4.54579192444e-15 ,
 1.35603668497e-13 , 3.16687200566e-12 , 5.79673853266e-11 , 8.32709958886e-10 ,
 9.4010538589e-09  , 8.35367295145e-08 , 5.85107618851e-07 , 3.23473049551e-06 ,
 1.41307999021e-05 , 4.88146291799e-05 , 0.000133390597104 , 0.000288285820925 ,
 0.000492474039915 , 0.000664408976559 , 0.000707883977181 , 0.000600681999162 ,
 0.000436608086407 , 0.000396559480932 , 0.000721347359269 , 0.00168047924628  ,
 0.00338577234881  , 0.00545668788535  , 0.00696559062633  , 0.00703488208797  ,
 0.00561856840713  , 0.00354595080441  , 0.00176643772996  , 0.000693647081909 ,
 0.000214398662256 , 5.20998971567e-05 , 1.00210830342e-05 , 1.92142968863e-06 ,
 2.07199500866e-06 , 7.10574390578e-06 , 2.19376737762e-05 , 5.50215743173e-05 ,
 0.000110811463046 , 0.000178772756155 , 0.00023135812789  , 0.000240903703332 ,
 0.000202488477225 , 0.000137751649818 , 7.59595922979e-05 , 3.39647987271e-05 ,
 1.23136230579e-05 , 3.62125112405e-06 , 8.66213263763e-07 , 1.69942186889e-07 ,
 2.80800413433e-08 , 4.30603055721e-09 , 8.02350090566e-10 , 2.23031044463e-10 ,
 7.16807140736e-11 , 2.04559443932e-11 , 4.74254446105e-12 , 8.73367699851e-13 ,
 1.26920901563e-13 , 1.45137389785e-14 , 1.30353330297e-15 , 9.18140477261e-17 ,
 5.06514929281e-18 , 2.186275361e-19   , 7.37655459263e-21 , 1.94413555706e-22 ,
 3.87672600445e-24 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 6.84066318809e-20 , 3.39376164111e-18 ,
 1.28391735547e-16 , 3.79124862665e-15 , 8.74308599871e-14 , 1.57575086572e-12 ,
 2.22134625007e-11 , 2.4517965678e-10  , 2.12126668546e-09 , 1.44051239277e-08 ,
 7.68899084618e-08 , 3.23071619691e-07 , 1.07014316297e-06 , 2.79819503202e-06 ,
 5.7819941439e-06  , 9.44838278107e-06 , 1.22148516307e-05 , 1.2508233767e-05  ,
 1.03085031764e-05 , 8.10805859633e-06 , 1.32499852548e-05 , 4.85926454014e-05 ,
 0.000176636754062 , 0.000516948096154 , 0.00119161412032  , 0.00215671312549  ,
 0.00306064645817  , 0.00340192334537  , 0.00295894567512  , 0.0020125266871   ,
 0.00106981247211  , 0.000444303021041 , 0.000144136393802 , 3.65242294873e-05 ,
 7.23050985012e-06 , 1.11864524024e-06 , 1.3533677565e-07  , 1.2816046187e-08  ,
 9.51370660587e-10 , 5.54903682552e-11 , 2.55273862167e-12 , 9.32068711466e-14 ,
 2.72920779451e-15 , 6.50721684742e-17 , 6.54311591718e-19 , 8.55277263078e-21 ,
 9.76978516242e-24 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4.30029748064e-28 ,
 2.18225526665e-26 , 8.30739167591e-25 , 8.14508520402e-18 , 4.16536592919e-16 ,
 1.58871068368e-14 , 4.73921668505e-13 , 1.10679088298e-11 , 2.02590344238e-10 ,
 2.91023979153e-09 , 3.28557624101e-08 , 2.91952684924e-07 , 2.04489379232e-06 ,
 1.13050660814e-05 , 4.93857607103e-05 , 0.000170602341791 , 0.000466186990239 ,
 0.00100752936371  , 0.00172112986078  , 0.00232183935768  , 0.00247222159184  ,
 0.00208742378253  , 0.00146284800477  , 0.00112326341262  , 0.00165939372046  ,
 0.00364425316582  , 0.00728056143778  , 0.0117214223716   , 0.0149607762905   ,
 0.0151093778904   , 0.0120674361654   , 0.00761592877146  , 0.00379394556928  ,
 0.00148984132149  , 0.000460540895272 , 0.000112038462152 , 2.2011634939e-05  ,
 6.01859335855e-06 , 1.15366006818e-05 , 3.9448504445e-05  , 0.000118574003179 ,
 0.000293996480529 , 0.000590514806974 , 0.000954497731697 , 0.00124061520884  ,
 0.00129912731465  , 0.00109901789463  , 0.000752936994127 , 0.000418455046059 ,
 0.000188864640744 , 6.93127364298e-05 , 2.07418611874e-05 , 5.09524023803e-06 ,
 1.04567324524e-06 , 1.89878649758e-07 , 3.66742542163e-08 , 1.00032862027e-08 ,
 3.590665121e-09   , 1.24936460609e-09 , 3.63094287677e-10 , 8.45295570551e-11 ,
 1.55838323351e-11 , 2.26565752683e-12 , 2.59147970784e-13 , 2.32792929786e-14 ,
 1.63991149752e-15 , 9.04804415303e-17 , 3.90578942076e-18 , 1.31792558435e-19 ,
 3.47368575129e-21 , 6.92831851424e-23 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8.16575180746e-21 ,
 4.05115914836e-19 , 1.53262194333e-17 , 4.52564242596e-16 , 1.04366885452e-14 ,
 1.88098586011e-13 , 2.65163804213e-12 , 2.92672841505e-11 , 2.53217244335e-10 ,
 1.71955088331e-09 , 9.1784092858e-09  , 3.85653216673e-08 , 1.27743895582e-07 ,
 3.34023100409e-07 , 6.90203261301e-07 , 1.12788094567e-06 , 1.4583579194e-06  ,
 1.49620396967e-06 , 1.25999404783e-06 , 1.19097609122e-06 , 2.91758570051e-06 ,
 1.21155540565e-05 , 4.46194616117e-05 , 0.000130752944099 , 0.000301476649873 ,
 0.000545727799327 , 0.000774549653529 , 0.000861001538325 , 0.000748948874773 ,
 0.000509431971646 , 0.000270816915863 , 0.000112477305537 , 3.64895649139e-05 ,
 9.24638296776e-06 , 1.83033002155e-06 , 2.83119442119e-07 , 3.42374628218e-08 ,
 3.23911325671e-09 , 2.39969754413e-10 , 1.39396385193e-11 , 6.36025959303e-13 ,
 2.28507890157e-14 , 6.48790499879e-16 , 1.46230681175e-17 , 1.02393631604e-19 ,
 4.77221401098e-22 , 4.25552467258e-25 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3.1484520865e-31  ,
 1.56206304453e-29 , 1.38995419784e-26 , 6.93848610963e-25 , 2.61626306443e-23 ,
 2.25166231855e-17 , 1.15147192081e-15 , 4.39179216013e-14 , 1.31009259842e-12 ,
 3.05956910482e-11 , 5.60032311355e-10 , 8.0449425572e-09  , 9.08250489376e-08 ,
 8.07061304506e-07 , 5.6528152101e-06  , 3.12512309101e-05 , 0.000136519838279 ,
 0.000471605649378 , 0.00128870680497  , 0.00278516785633  , 0.00475778442346  ,
 0.00641804286535  , 0.00683110340471  , 0.00575015252169  , 0.00393664627818  ,
 0.00265858024248  , 0.00312243926433  , 0.00628516330321  , 0.0123874403776   ,
 0.0199092907892   , 0.0254062331591   , 0.0256580112124   , 0.0204923891085   ,
 0.0129332256013   , 0.00644308590384  , 0.00253049513235  , 0.000782748115755 ,
 0.000191489753417 , 4.07628561264e-05 , 2.12160935213e-05 , 5.55562606931e-05 ,
 0.000178505501379 , 0.00051288452967  , 0.00124579220006  , 0.00248619212756  ,
 0.00402238298209  , 0.00525307567535  , 0.00553858490408  , 0.00472365166962  ,
 0.00326611172074  , 0.0018346835681   , 0.000839102573451 , 0.000313479155513 ,
 9.62491254328e-05 , 2.46068967468e-05 , 5.42734106854e-06 , 1.15749129592e-06 ,
 3.08945120725e-07 , 1.16255252779e-07 , 4.77612330026e-08 , 1.72081185588e-08 ,
 5.04172650647e-09 , 1.17617176456e-09 , 2.16995401072e-10 , 3.15601479095e-11 ,
 3.61088653981e-12 , 3.24438750006e-13 , 2.2859290463e-14  , 1.26142556757e-15 ,
 5.44588039026e-17 , 1.83777458633e-18 , 4.84423824233e-20 , 9.66467607196e-22 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 7.59224986371e-22 , 3.76663574705e-20 , 1.42498336233e-18 ,
 4.20780217386e-17 , 9.7037208974e-16  , 1.74888772067e-14 , 2.46542620931e-13 ,
 2.7212125933e-12  , 2.35438309275e-11 , 1.59884087073e-10 , 8.53430728468e-10 ,
 3.58604447588e-09 , 1.18792457819e-08 , 3.10653114672e-08 , 6.42039867259e-08 ,
 1.04954956489e-07 , 1.35827832488e-07 , 1.40034079441e-07 , 1.23381913635e-07 ,
 1.55179857264e-07 , 5.3515309215e-07  , 2.37268538027e-06 , 8.79327092762e-06 ,
 2.57863255005e-05 , 5.94687882968e-05 , 0.000107666373942 , 0.000152830355377 ,
 0.000169906971714 , 0.000147808236259 , 0.000100546201018 , 5.34543973033e-05 ,
 2.22022500533e-05 , 7.20314392944e-06 , 1.82533808423e-06 , 3.61338170731e-07 ,
 5.589297627e-08   , 6.75882358829e-09 , 6.39340913888e-10 , 4.73483306938e-11 ,
 2.74818174722e-12 , 1.25175071706e-13 , 4.48132183078e-15 , 1.26341053879e-16 ,
 2.80884063084e-18 , 1.75172282267e-20 , 2.0786528086e-23  , 1.44629514479e-26 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 1.79422745543e-29 , 8.8927898498e-28  , 3.58345525778e-25 ,
 1.75250823047e-23 , 6.52818644859e-22 , 4.92254491826e-17 , 2.5168377039e-15  ,
 9.59858310615e-14 , 2.86318910466e-12 , 6.68651853676e-11 , 1.22390840081e-09 ,
 1.75815384353e-08 , 1.98490006575e-07 , 1.76375834914e-06 , 1.23537021783e-05 ,
 6.82966432404e-05 , 0.000298351305598 , 0.00103064985709  , 0.00281634746317  ,
 0.00608671952428  , 0.0103976479701   , 0.0140255610914   , 0.0149247048015   ,
 0.0125392258688   , 0.00845910055537  , 0.00520990964535  , 0.00485507291685  ,
 0.00864304256884  , 0.0166701184484   , 0.026718257245    , 0.0340838711917   ,
 0.0344207818107   , 0.0274919419651   , 0.0173526714237   , 0.00864751745235  ,
 0.00339989773602  , 0.00105653346401  , 0.000266675985723 , 7.58164168835e-05 ,
 8.49872718784e-05 , 0.000232490381123 , 0.000671541720192 , 0.00179867552373  ,
 0.00421845119812  , 0.00830901860408  , 0.0134262152345   , 0.0176197221263   ,
 0.0187295611412   , 0.0161380173818   , 0.0112942273034   , 0.00643769906964  ,
 0.00299993713598  , 0.00114981606814  , 0.000366454689957 , 9.94732068886e-05 ,
 2.46361074824e-05 , 6.71238793067e-06 , 2.51335533566e-06 , 1.1602447767e-06  ,
 5.08152209023e-07 , 1.85980767694e-07 , 5.47051255624e-08 , 1.27780715723e-08 ,
 2.35890274416e-09 , 3.43226853182e-10 , 3.92827494788e-11 , 3.53053959366e-12 ,
 2.48811489556e-13 , 1.37325256275e-14 , 5.92956202128e-16 , 2.00124183538e-17 ,
 5.27563822699e-19 , 1.05291417113e-20 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5.49808696042e-23 ,
 2.72769598611e-21 , 1.03218902836e-19 , 3.04848528027e-18 , 7.03216969191e-17 ,
 1.26798942515e-15 , 1.78888386767e-14 , 1.97702406361e-13 , 1.71418530204e-12 ,
 1.16825421263e-11 , 6.27314826049e-11 , 2.66216063606e-10 , 8.96470912068e-10 ,
 2.40849690149e-09 , 5.20056203106e-09 , 9.11346896314e-09 , 1.31265847674e-08 ,
 1.58641039994e-08 , 1.74493510259e-08 , 2.61355889055e-08 , 8.61133734209e-08 ,
 3.68024313532e-07 , 1.35389521851e-06 , 3.96635151639e-06 , 9.14745181572e-06 ,
 1.65636234777e-05 , 2.35150952065e-05 , 2.61457486956e-05 , 2.27474569627e-05 ,
 1.54752413472e-05 , 8.22787403297e-06 , 3.41766936361e-06 , 1.10887298732e-06 ,
 2.81014428724e-07 , 5.56319716321e-08 , 8.60583387172e-09 , 1.04071178431e-09 ,
 9.84486913556e-11 , 7.29096316049e-12 , 4.23147755817e-13 , 1.92686344771e-14 ,
 6.8938112144e-16  , 1.94081421763e-17 , 4.30232064306e-19 , 2.6148492126e-21  ,
 7.06449274434e-25 , 3.83377118553e-28 , 0, 0, 0, 0, 1.65147719834e-30 ,
 7.99743329603e-29 , 3.00529607013e-27 , 8.79882822714e-26 , 2.00729916179e-24 ,
 3.56870886881e-23 , 4.94539196902e-22 , 5.34294513503e-21 , 4.50170462549e-20 ,
 2.95901757633e-19 , 1.51806144281e-18 , 6.08199469574e-18 , 1.90421418594e-17 ,
 4.66292908144e-17 , 8.93928772706e-17 , 1.34321533735e-16 , 1.58398193882e-16 ,
 1.46802320517e-16 , 1.07087616709e-16 , 6.15755354752e-17 , 2.79463952896e-17 ,
 1.00224333481e-17 , 2.8423473193e-18  , 6.37636591472e-19 , 1.13133062054e-19 ,
 1.58655590838e-20 , 1.75684122884e-21 , 1.53412859869e-22 , 1.05497977508e-23 ,
 6.05180788891e-25 , 7.59914259918e-24 , 3.58113889451e-22 , 1.30667581076e-20 ,
 8.53150370194e-17 , 4.35230039467e-15 , 1.65826802217e-13 , 4.9442621689e-12  ,
 1.15440523532e-10 , 2.11282020282e-09 , 3.03493240829e-08 , 3.42626062719e-07 ,
 3.04449852263e-06 , 2.13241305134e-05 , 0.00011788874438  , 0.000514991808681 ,
 0.0017790298039   , 0.00486136406851  , 0.0105064261033   , 0.0179475772496   ,
 0.0242093499299   , 0.0257576027535   , 0.0216153903086   , 0.0144485516741   ,
 0.00835600275524  , 0.00629109752681  , 0.00951433718367  , 0.0177359848603   ,
 0.0282990138545   , 0.0360820333757   , 0.0364401466933   , 0.0291127536732   ,
 0.0183900827058   , 0.00918609615097  , 0.00364058133482  , 0.00116906419328  ,
 0.000350615531734 , 0.000199585595356 , 0.000350046995817 , 0.000857914892007 ,
 0.00215201586797  , 0.00520883880267  , 0.0115423463168   , 0.0221893917427   ,
 0.0356580485112   , 0.0469984590924   , 0.050439625717    , 0.0440253006826   ,
 0.0313071898525   , 0.0182055415694   , 0.0087092703697   , 0.00346141795016  ,
 0.00116387836551  , 0.00034571212052  , 0.000102272351179 , 3.7664518388e-05  ,
 1.83677728511e-05 , 9.45523938375e-06 , 4.26631422286e-06 , 1.57326444494e-06 ,
 4.63798985184e-07 , 1.08439213487e-07 , 2.00310098895e-08 , 2.91600998308e-09 ,
 3.33878759887e-10 , 3.00177175017e-11 , 2.11607396842e-12 , 1.16818621738e-13 ,
 5.04505955853e-15 , 1.70297840304e-16 , 4.48990530735e-18 , 8.96498986671e-20 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 3.10651036876e-24 , 1.54345606035e-22 , 6.19484865827e-21 ,
 1.90727711753e-19 , 4.67539398773e-18 , 9.25318814848e-17 , 1.49786687555e-15 ,
 2.00834553921e-14 , 2.24963364143e-13 , 2.10847430297e-12 , 1.64431464514e-11 ,
 1.05647934939e-10 , 5.53293357677e-10 , 2.34037048561e-09 , 7.94008113779e-09 ,
 2.14977372597e-08 , 4.62803802692e-08 , 7.90066468437e-08 , 1.06823612286e-07 ,
 1.15123049442e-07 , 1.04505870502e-07 , 1.0634074658e-07  , 1.94587574575e-07 ,
 4.88792516671e-07 , 1.10149178971e-06 , 1.98840653444e-06 , 2.8221195955e-06  ,
 3.13808727891e-06 , 2.73051826297e-06 , 1.85777527072e-06 , 9.87828163828e-07 ,
 4.10353235465e-07 , 1.33150069062e-07 , 3.37457708419e-08 , 6.68108858376e-09 ,
 1.03359423586e-09 , 1.25004416938e-10 , 1.18262368833e-11 , 8.7592428129e-13  ,
 5.08415545082e-14 , 2.31533929025e-15 , 8.2838787905e-17  , 2.33187928468e-18 ,
 5.16704390795e-20 , 3.131944997e-22   , 1.87260625302e-26 , 7.80712438574e-30 ,
 0, 0, 0, 0, 8.30539972812e-29 , 4.02196775039e-27 , 1.51138539417e-25 ,
 4.42499512792e-24 , 1.00948544305e-22 , 1.79472981513e-21 , 2.48707382434e-20 ,
 2.68700622184e-19 , 2.26394021123e-18 , 1.48811160085e-17 , 7.63444212673e-17 ,
 3.05867965619e-16 , 9.57643254055e-16 , 2.34502117038e-15 , 4.49563323867e-15 ,
 6.75512826264e-15 , 7.96596112692e-15 , 7.38279616656e-15 , 5.38551463862e-15 ,
 3.09667875588e-15 , 1.40544467749e-15 , 5.04035510076e-16 , 1.4294372745e-16  ,
 3.20672109718e-17 , 5.68954451061e-18 , 7.97890580828e-19 , 8.83528315071e-20 ,
 7.71524502985e-21 , 5.30543354628e-22 , 2.97559660013e-23 , 1.37201646922e-22 ,
 6.07564527308e-21 , 2.13693009505e-19 , 1.21705535325e-16 , 6.05132577116e-15 ,
 2.28042063068e-13 , 6.76429244487e-12 , 1.57550093936e-10 , 2.88015953967e-09 ,
 4.13484696118e-08 , 4.66673161812e-07 , 4.14620403863e-06 , 2.90387560079e-05 ,
 0.000160533281861 , 0.000701271432451 , 0.00242251011833  , 0.00661970729506  ,
 0.0143065431927   , 0.0244390603433   , 0.0329652805022   , 0.0350703542918   ,
 0.0294093667959   , 0.0195465686406   , 0.0108454539972   , 0.00681865388971  ,
 0.00843437055231  , 0.0149170255856   , 0.0236300180495   , 0.030110458183    ,
 0.030428744946    , 0.0243588875353   , 0.0154754274677   , 0.00786605340645  ,
 0.00330285419169  , 0.00129858906012  , 0.00069976943303  , 0.000769876675459 ,
 0.00137035640272  , 0.00283314023993  , 0.00602454095997  , 0.0127538035913   ,
 0.0259282414121   , 0.0477977300018   , 0.0758095421684   , 0.100182009156    ,
 0.108710463652    , 0.0964510909738   , 0.0700574992109   , 0.0418683454036   ,
 0.0207709760087   , 0.00868321102716  , 0.00315083167088  , 0.0010687416189   ,
 0.000401357322774 , 0.000196578243532 , 0.000113043994951 , 6.14251507774e-05 ,
 2.81163238824e-05 , 1.0410225194e-05  , 3.07369793726e-06 , 7.19312102107e-07 ,
 1.32966947835e-07 , 1.93682540078e-08 , 2.21876456572e-09 , 1.99565490732e-10 ,
 1.40731739495e-11 , 7.77139075642e-13 , 3.35702483031e-14 , 1.13338893229e-15 ,
 2.98862979274e-17 , 5.97070363395e-19 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.61378065903e-25 ,
 1.81479231348e-23 , 4.56195520879e-21 , 2.20140515565e-19 , 8.10288300023e-18 ,
 2.36146530027e-16 , 5.43309392327e-15 , 9.85339492464e-14 , 1.40800246844e-12 ,
 1.58569034226e-11 , 1.40845951967e-10 , 9.87619723705e-10 , 5.47228852314e-09 ,
 2.39786381511e-08 , 8.31310693814e-08 , 2.28042022283e-07 , 4.94783072391e-07 ,
 8.48432199702e-07 , 1.1484999291e-06  , 1.22572153632e-06 , 1.030344515e-06   ,
 6.8374995245e-07  , 3.67349478436e-07 , 1.87539119458e-07 , 1.48172225578e-07 ,
 1.97336328936e-07 , 2.66392838331e-07 , 2.94175729865e-07 , 2.55756730172e-07 ,
 1.7400850327e-07  , 9.25329959375e-08 , 3.84426174228e-08 , 1.24748288604e-08 ,
 3.16191478744e-09 , 6.26061536898e-10 , 9.68639515329e-11 , 1.17161531495e-11 ,
 1.10856449675e-12 , 8.21191455132e-14 , 4.76727185338e-15 , 2.17144334357e-16 ,
 7.77064588302e-18 , 2.18785374813e-19 , 4.84876523253e-21 , 2.94826510965e-23 ,
 3.81327179676e-28 , 9.20320954756e-22 , 6.55503631703e-23 , 4.95831727311e-24 ,
 2.57434067212e-23 , 3.9424598428e-22  , 4.80519875021e-21 , 4.63262634041e-20 ,
 3.53103494296e-19 , 2.12599662967e-18 , 1.01009857304e-17 , 3.78510267386e-17 ,
 1.12161133426e-16 , 2.67352884559e-16 , 5.52350772143e-16 , 1.2277427322e-15  ,
 3.63579674108e-15 , 1.22549121258e-14 , 3.67982774498e-14 , 8.92746760769e-14 ,
 1.70801315514e-13 , 2.56532997353e-13 , 3.02487036699e-13 , 2.80337167192e-13 ,
 2.04496156015e-13 , 1.1758548121e-13  , 5.33668070599e-14 , 1.91389708976e-14 ,
 5.4277838835e-15  , 1.21763923284e-15 , 2.1604038521e-16  , 3.0297080567e-17  ,
 3.35488714716e-18 , 2.92959217563e-19 , 2.01452157091e-20 , 1.11516168834e-21 ,
 2.18305361301e-21 , 8.81243170293e-20 , 2.92476901444e-18 , 2.03457583765e-16 ,
 8.08871844349e-15 , 2.7271810767e-13  , 7.6501201896e-12  , 1.73392603064e-10 ,
 3.12827097059e-09 , 4.46249420582e-08 , 5.02094322082e-07 , 4.45415631269e-06 ,
 3.11723337594e-05 , 0.000172264704554 , 0.000752380747764 , 0.00259882628703  ,
 0.00710117792949  , 0.0153467411677   , 0.0262156413531   , 0.0353612180424   ,
 0.0376171115492   , 0.0315310648217   , 0.0208830727105   , 0.0112829695363   ,
 0.00616372354566  , 0.00607176704451  , 0.00992615609405  , 0.0155509121126   ,
 0.0198266090991   , 0.0201398276569   , 0.0163578268582   , 0.0108260192239   ,
 0.0061845180627   , 0.00353277403822  , 0.00252573802961  , 0.0024899042091   ,
 0.00318533054475  , 0.00492874114589  , 0.00847023273675  , 0.0150693963798   ,
 0.0271409475806   , 0.0488885425695   , 0.084206618696    , 0.130133125665    ,
 0.171777884328    , 0.188724247084    , 0.170963998256    , 0.127733964574    ,
 0.0792227197394   , 0.0412986124952   , 0.0185006900702   , 0.00746768422012  ,
 0.00303647475988  , 0.00148025618194  , 0.000896234746075 , 0.000564156902397 ,
 0.000314848737747 , 0.000145190031413 , 5.38943621701e-05 , 1.59341193702e-05 ,
 3.73267273235e-06 , 6.90581673102e-07 , 1.00665314443e-07 , 1.15390983902e-08 ,
 1.03842195309e-09 , 7.32603418768e-11 , 4.04696704033e-12 , 1.74867914382e-13 ,
 5.9051997317e-15  , 1.55742655821e-16 , 3.11355064929e-18 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 2.23463452378e-24 , 2.03169619623e-22 , 4.08874182129e-20 , 1.94689684056e-18 ,
 7.0972324418e-17  , 2.05157563873e-15 , 4.68865243952e-14 , 8.45774170628e-13 ,
 1.20345109926e-11 , 1.3508425766e-10  , 1.19679872093e-09 , 8.37569645238e-09 ,
 4.63408729236e-08 , 2.02837570315e-07 , 7.0265727279e-07  , 1.92641022874e-06 ,
 4.17806664329e-06 , 7.16237721258e-06 , 9.69357160727e-06 , 1.03430202912e-05 ,
 8.68748481239e-06 , 5.73561218127e-06 , 2.97290871102e-06 , 1.21025012612e-06 ,
 3.91310244567e-07 , 1.09047821885e-07 , 3.78580247933e-08 , 2.42909824633e-08 ,
 1.9025303704e-08  , 1.27516011271e-08 , 6.76776941745e-09 , 2.81118539967e-09 ,
 9.12307783697e-10 , 2.31260562222e-10 , 4.57954250499e-11 , 7.08699550228e-12 ,
 8.57923175307e-13 , 8.16071057406e-14 , 6.28351659499e-15 , 4.73647739623e-16 ,
 6.17892489236e-17 , 1.41138470664e-17 , 3.20218844798e-18 , 5.94520589583e-19 ,
 8.7463101461e-20  , 1.01280761464e-20 , 4.55215183023e-20 , 3.24251342618e-21 ,
 2.44050236226e-22 , 1.24947129288e-21 , 1.91330756462e-20 , 2.33204955968e-19 ,
 2.24834126908e-18 , 1.71373379259e-17 , 1.03181362945e-16 , 4.90183711027e-16 ,
 1.83585787399e-15 , 5.42611853528e-15 , 1.27840392407e-14 , 2.51875165308e-14 ,
 4.89283234701e-14 , 1.21765685177e-13 , 3.75642450834e-13 , 1.09986213499e-12 ,
 2.65275798227e-12 , 5.06875618584e-12 , 7.61083259694e-12 , 8.97365952692e-12 ,
 8.31644871645e-12 , 6.06654182411e-12 , 3.48826522655e-12 , 1.58316786367e-12 ,
 5.67772452485e-13 , 1.61019428279e-13 , 3.61222143578e-14 , 6.40900596214e-15 ,
 8.98786445845e-16 , 9.95253350738e-17 , 8.69086291487e-18 , 5.97617950893e-19 ,
 3.28079757709e-20 , 3.12441296181e-20 , 1.12337861597e-18 , 3.4497899881e-17  ,
 9.83590459012e-16 , 2.37747678381e-14 , 5.18472328664e-13 , 1.04138587783e-11 ,
 1.89840123211e-10 , 3.02120270636e-09 , 4.03131719723e-08 , 4.38372552564e-07 ,
 3.82294087594e-06 , 2.65276582133e-05 , 0.000145975054368 , 0.000636202523851 ,
 0.00219518077336  , 0.00599499741673  , 0.0129525735023   , 0.0221227895758   ,
 0.0298383018156   , 0.0317396422167   , 0.0265968173087   , 0.0175768554003   ,
 0.00933880412967  , 0.00460618556825  , 0.00358703229307  , 0.0052473320437   ,
 0.00811128150056  , 0.0104658080047   , 0.0110324033851   , 0.00986416840393  ,
 0.00821161385553  , 0.0073085341138   , 0.00746784555883  , 0.00832328549324  ,
 0.00965393767216  , 0.0118904497262   , 0.0160071329886   , 0.0231144654258   ,
 0.0343493068719   , 0.0517539235766   , 0.0798120405904   , 0.124043313343    ,
 0.182913942993    , 0.239354837298    , 0.266408024196    , 0.247771676934    ,
 0.192150570428    , 0.125216417253    , 0.069713708989    , 0.0342450234902   ,
 0.0159267624547   , 0.00802483602799  , 0.00491336399611  , 0.00339699326443  ,
 0.00224159086197  , 0.001268211917    , 0.000587343941191 , 0.000218450422673 ,
 6.46746190387e-05 , 1.51680852711e-05 , 2.80911716415e-06 , 4.09846301264e-07 ,
 4.70157174673e-08 , 4.23371883e-09    , 2.98845054561e-10 , 1.65155789671e-11 ,
 7.13880458156e-13 , 2.4114111177e-14  , 6.36122843864e-16 , 1.27275989628e-17 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 3.09888867312e-23 , 2.82013327042e-21 , 3.32299972128e-19 ,
 1.49421745925e-17 , 5.23801181432e-16 , 1.46957736087e-14 , 3.28410612652e-13 ,
 5.82620021433e-12 , 8.18848892624e-11 , 9.10809751549e-10 , 8.01556924821e-09 ,
 5.58213092517e-08 , 3.07742233772e-07 , 1.34352617257e-06 , 4.6455460409e-06  ,
 1.27196283744e-05 , 2.75617362315e-05 , 4.72191982002e-05 , 6.38798070712e-05 ,
 6.814067209e-05   , 5.72231523386e-05 , 3.77735345844e-05 , 1.95712762813e-05 ,
 7.94868850989e-06 , 2.52787728471e-06 , 6.29374487446e-07 , 1.2327966098e-07  ,
 1.97710896006e-08 , 3.26408988334e-09 , 9.29304718404e-10 , 4.0094386388e-10  ,
 1.61361406826e-10 , 5.21596668025e-11 , 1.32408507409e-11 , 2.65479329371e-12 ,
 4.45297004907e-13 , 8.33863084568e-14 , 2.8472545006e-14  , 1.37804879033e-14 ,
 6.16140774115e-15 , 2.26464539768e-15 , 6.6882756134e-16  , 1.57427511319e-16 ,
 2.93706607635e-17 , 4.32464592783e-18 , 5.00897503423e-19 , 1.8354719673e-18  ,
 1.36211334619e-19 , 1.04769603499e-20 , 4.7074209012e-20  , 7.19431211661e-19 ,
 8.76882982565e-18 , 8.45411881956e-17 , 6.44392638239e-16 , 3.87975516231e-15 ,
 1.84303416299e-14 , 6.90034271194e-14 , 2.03631838579e-13 , 4.76352005202e-13 ,
 9.10374835958e-13 , 1.59832122622e-12 , 3.33966762587e-12 , 9.1609980326e-12  ,
 2.58154266339e-11 , 6.16916280182e-11 , 1.17635666865e-10 , 1.76553438198e-10 ,
 2.08147828332e-10 , 1.92899581119e-10 , 1.40712497717e-10 , 8.09096972571e-11 ,
 3.67212926272e-11 , 1.31693790299e-11 , 3.73481682617e-12 , 8.37850423468e-13 ,
 1.48664426736e-13 , 2.08739453375e-14 , 2.37329808786e-15 , 3.25318067322e-16 ,
 2.00033835128e-16 , 2.21740713399e-16 , 2.07525028203e-16 , 1.66166737612e-16 ,
 4.49084951076e-16 , 8.55374914942e-15 , 1.68841061986e-13 , 2.81209931634e-12 ,
 3.95406027137e-11 , 4.76053282924e-10 , 5.02724497716e-09 , 4.76263494985e-08 ,
 4.05797056374e-07 , 3.03949487708e-06 , 1.93466351603e-05 , 0.000101642316648 ,
 0.000432435447818 , 0.00147373432468  , 0.00399936362039  , 0.0086130331996   ,
 0.0146866862284   , 0.0197920352143   , 0.0210436626234   , 0.0176270869835   ,
 0.0116323939261   , 0.00611635790633  , 0.00281377159962  , 0.00176415471465  ,
 0.00225295099807  , 0.00351647912088  , 0.00496411785925  , 0.0064369797686   ,
 0.00841826999679  , 0.0116668937745   , 0.0164124383013   , 0.0219767820732   ,
 0.0273619046212   , 0.0323679455678   , 0.0381166752614   , 0.0462843117389   ,
 0.0578400397419   , 0.0727978742046   , 0.0917097229535   , 0.118276177061    ,
 0.159300781405    , 0.216757337762    , 0.276622094428    , 0.310965483148    ,
 0.29841772321     , 0.242654925942    , 0.168465919948    , 0.10200027994     ,
 0.0563371280127   , 0.0310756543791   , 0.0193290294946   , 0.0139521698815   ,
 0.0104021323958   , 0.00703449308269  , 0.004009583672    , 0.00186237220691  ,
 0.000693937281965 , 0.000205762172227 , 4.83236070705e-05 , 8.96047253053e-06 ,
 1.30871959945e-06 , 1.50267552265e-07 , 1.35418048216e-08 , 9.56478238252e-10 ,
 5.28867355079e-11 , 2.28696434194e-12 , 7.72769898905e-14 , 2.03908600422e-15 ,
 4.08382685081e-17 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 3.35989464011e-22 , 3.05766644034e-20 ,
 2.3924932504e-18  , 9.98407148722e-17 , 3.30542288327e-15 , 8.8425469665e-14  ,
 1.90185441899e-12 , 3.27420032699e-11 , 4.49646485385e-10 , 4.91408870692e-09 ,
 4.2676002532e-08  , 2.94270201465e-07 , 1.61047947617e-06 , 6.99350217059e-06 ,
 2.40888233503e-05 , 6.57763127816e-05 , 0.000142257853138 , 0.0002434010203   ,
 0.000328992401018 , 0.000350732115448 , 0.000294425450258 , 0.000194305097214 ,
 0.00010065754839  , 4.08762411843e-05 , 1.29969562458e-05 , 3.23236440829e-06 ,
 6.28288940751e-07 , 9.54145767431e-08 , 1.13452781883e-08 , 1.07668057892e-09 ,
 9.26554705041e-11 , 1.17465486161e-11 , 3.2090052177e-12  , 1.71687024175e-12 ,
 1.56928120021e-12 , 1.54088115133e-12 , 1.29929358779e-12 , 8.99709493666e-13 ,
 5.07547146372e-13 , 2.32231457586e-13 , 8.57301404588e-14 , 2.53855318197e-14 ,
 5.99698639436e-15 , 1.12541002856e-15 , 1.67309826021e-16 , 1.96860868343e-17 ,
 5.63185780208e-17 , 4.27673737012e-18 , 3.32863503228e-19 , 1.38448208278e-18 ,
 2.11092648711e-17 , 2.57134695354e-16 , 2.47822223854e-15 , 1.88860273818e-14 ,
 1.13696337814e-13 , 5.40049324929e-13 , 2.02148223135e-12 , 5.95968864311e-12 ,
 1.38799637954e-11 , 2.60165261038e-11 , 4.24991748705e-11 , 7.56186311671e-11 ,
 1.79330280268e-10 , 4.77462620925e-10 , 1.12453501131e-09 , 2.13728920731e-09 ,
 3.20545981714e-09 , 3.77849775618e-09 , 3.50158158853e-09 , 2.55424523284e-09 ,
 1.46868902711e-09 , 6.66572045597e-10 , 2.39053114352e-10 , 6.77951301886e-11 ,
 1.52088973086e-11 , 2.6988780383e-12  , 3.79807422149e-13 , 4.52576540289e-14 ,
 1.00565028765e-14 , 9.87199080916e-15 , 1.14318125038e-14 , 1.07188719116e-14 ,
 8.10043347915e-15 , 8.05333778274e-15 , 7.40720674273e-14 , 1.29657708909e-12 ,
 1.95625330676e-11 , 2.46346455389e-10 , 2.57100400693e-09 , 2.21316874032e-08 ,
 1.57378450451e-07 , 9.34949417043e-07 , 4.74178221719e-06 , 2.10727836946e-05 ,
 8.34075273926e-05 , 0.000292300482395 , 0.000884621626436 , 0.00224436446069  ,
 0.00466055979308  , 0.00779575225841  , 0.0104009343671   , 0.0110012006594   ,
 0.00918949175738  , 0.0060517120544   , 0.00316241944395  , 0.00139897558413  ,
 0.000760630825323 , 0.000915543546709 , 0.00170011401009  , 0.00340533310049  ,
 0.00697655022346  , 0.0138914853658   , 0.0253673053821   , 0.0411778794583   ,
 0.0591089045472   , 0.0760813773281   , 0.0905903189253   , 0.103915204018    ,
 0.118081428843    , 0.132969764835    , 0.146615454032    , 0.158395476304    ,
 0.171952684565    , 0.195115789326    , 0.233476413968    , 0.27970932507     ,
 0.311708815753    , 0.307531551528    , 0.263646577073    , 0.197187583108    ,
 0.131953508788    , 0.0836285328659   , 0.0551283734877   , 0.0407554822261   ,
 0.0326585678208   , 0.0253715337727   , 0.0173818307721   , 0.00995162803101  ,
 0.00463328257048  , 0.00172970610178  , 0.000513786333198 , 0.000120859538801 ,
 2.24431520259e-05 , 3.2820864952e-06  , 3.77257422338e-07 , 3.40284152404e-08 ,
 2.4052708123e-09  , 1.33075905201e-10 , 5.75738117434e-12 , 1.94619488969e-13 ,
 5.13697613415e-15 , 1.03000572648e-16 , 1.8232596494e-24  , 7.81615809867e-26 ,
 2.62266023841e-27 , 6.88147516815e-29 , 1.34952228618e-30 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.8436185009e-21  ,
 2.58783022118e-19 , 1.53949438539e-17 , 5.95703972214e-16 , 1.84562584692e-14 ,
 4.64029510705e-13 , 9.44408747823e-12 , 1.55094892648e-10 , 2.04846147876e-09 ,
 2.16955628506e-08 , 1.83817035157e-07 , 1.24357256834e-06 , 6.70825610241e-06 ,
 2.88194340289e-05 , 9.84922560766e-05 , 0.000267435118944 , 0.000576120463276 ,
 0.00098306001064  , 0.00132631193959  , 0.00141222784579  , 0.00118456017128  ,
 0.000781342591923 , 0.000404632080142 , 0.000164283603381 , 5.22285001666e-05 ,
 1.29881367752e-05 , 2.52426541827e-06 , 3.83145941314e-07 , 4.53941864552e-08 ,
 4.1984106963e-09  , 3.0751486009e-10  , 2.7672498278e-11  , 2.13438589917e-11 ,
 3.29477827763e-11 , 4.26429706687e-11 , 4.47373057184e-11 , 3.81377368416e-11 ,
 2.6470774257e-11  , 1.4949560031e-11  , 6.84727520025e-12 , 2.53075184623e-12 ,
 7.5058977788e-13  , 1.77743078449e-13 , 3.34818817304e-14 , 5.00779104562e-15 ,
 5.94947556995e-16 , 2.38193288712e-15 , 1.44281891633e-15 , 1.51403788208e-15 ,
 1.45533680544e-15 , 1.6268435973e-15  , 6.69065495277e-15 , 5.71643514848e-14 ,
 4.31776033268e-13 , 2.5971321037e-12  , 1.23340859961e-11 , 4.61602923697e-11 ,
 1.36005911666e-10 , 3.15890007478e-10 , 5.84906698244e-10 , 9.0977118447e-10  ,
 1.41497016963e-09 , 2.8455440047e-09  , 6.9906799123e-09  , 1.60987151246e-08 ,
 3.04390740981e-08 , 4.56000574966e-08 , 5.37387751958e-08 , 4.97977864032e-08 ,
 3.63248242995e-08 , 2.0886696092e-08  , 9.47952922689e-09 , 3.39964865683e-09 ,
 9.64136119736e-10 , 2.16293215762e-10 , 3.839241725e-11   , 5.43466348326e-12 ,
 7.24235079398e-13 , 2.96745184891e-13 , 3.71541610673e-13 , 4.36973373259e-13 ,
 4.10191040344e-13 , 3.07008408226e-13 , 2.09576365108e-13 , 6.28161967358e-13 ,
 9.0031500154e-12  , 1.24371916577e-10 , 1.44548835674e-09 , 1.40515463969e-08 ,
 1.13341880456e-07 , 7.51245052421e-07 , 4.05916676238e-06 , 1.78098654552e-05 ,
 6.35563749205e-05 , 0.000186074296911 , 0.000454607414506 , 0.000949648874699 ,
 0.00173731778798  , 0.00281201795194  , 0.00398090268985  , 0.00480044049901  ,
 0.00479466051343  , 0.00388275048606  , 0.00251891311937  , 0.0013186683405   ,
 0.000619231872533 , 0.000434567299805 , 0.000739344125722 , 0.00185476853943  ,
 0.0049115925206   , 0.0122721588566   , 0.0273562181897   , 0.0532424512337   ,
 0.0902155497487   , 0.133920411412    , 0.176809582451    , 0.213188843576    ,
 0.242529723597    , 0.266052478756    , 0.281690443419    , 0.286067256317    ,
 0.280421914073    , 0.271376859704    , 0.266881954454    , 0.272125523244    ,
 0.285357785713    , 0.295623090622    , 0.288209599868    , 0.255942043593    ,
 0.205611675861    , 0.153052450918    , 0.111964430346    , 0.0865637610509   ,
 0.072370084702    , 0.0616757053701   , 0.0489818024884   , 0.0337943474965   ,
 0.0194066395543   , 0.00905544487683  , 0.0033877367547   , 0.00100833180784  ,
 0.000237641965618 , 4.42040433691e-05 , 6.47393822045e-06 , 7.45076539033e-07 ,
 6.72759103348e-08 , 4.75944348218e-09 , 2.63509470929e-10 , 1.14068942909e-11 ,
 3.85767344321e-13 , 1.01860018951e-14 , 2.04509394817e-16 , 8.82897315583e-23 ,
 3.78490252041e-24 , 1.26999834387e-25 , 3.33228907768e-27 , 6.53493366529e-29 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.87973683569e-20 , 1.71065133727e-18 , 8.6552015393e-17  , 3.15641195523e-15 ,
 9.21651530039e-14 , 2.17608987336e-12 , 4.15775516123e-11 , 6.42774188985e-10 ,
 8.03341415622e-09 , 8.10555815438e-08 , 6.59129893558e-07 , 4.31181586745e-06 ,
 2.26469805811e-05 , 9.53123355709e-05 , 0.000320746330823 , 0.000861152857641 ,
 0.00184028668116  , 0.00312265110752  , 0.00419695840786  , 0.00445746876036  ,
 0.0037326260234   , 0.00245939763775  , 0.00127276140456  , 0.000516524247443 ,
 0.000164166568064 , 4.08178061988e-05 , 7.93216580606e-06 , 1.20391106747e-06 ,
 1.42645254519e-07 , 1.32283690966e-08 , 1.05683043772e-09 , 2.94427241453e-10 ,
 4.72897847489e-10 , 7.53274978124e-10 , 9.76221973354e-10 , 1.02508655691e-09 ,
 8.7479952756e-10  , 6.07891637689e-10 , 3.43740164026e-10 , 1.57663886422e-10 ,
 5.83758803716e-11 , 1.73568681592e-11 , 4.12600277235e-12 , 7.82162443941e-13 ,
 1.18491896498e-13 , 1.49043361258e-14 , 7.609587564e-14   , 6.7268907639e-14  ,
 7.3574973134e-14  , 7.00923681132e-14 , 6.47331363841e-14 , 1.45056890886e-13 ,
 1.03622098016e-12 , 7.70297262513e-12 , 4.62588285796e-11 , 2.19620899192e-10 ,
 8.21784052246e-10 , 2.42029927425e-09 , 5.61184832716e-09 , 1.03116707489e-08 ,
 1.55294989378e-08 , 2.17677721098e-08 , 3.69453526851e-08 , 8.15181649175e-08 ,
 1.81463887851e-07 , 3.40340157115e-07 , 5.08944046213e-07 , 5.99548460406e-07 ,
 5.55533817308e-07 , 4.05225043488e-07 , 2.33002640129e-07 , 1.05749296756e-07 ,
 3.7924920618e-08  , 1.07554752915e-08 , 2.41295066589e-09 , 4.28612578896e-10 ,
 6.16230002376e-11 , 1.04899499654e-11 , 7.90633859696e-12 , 1.10541080324e-11 ,
 1.30770518766e-11 , 1.22858283328e-11 , 9.19131370318e-12 , 5.7058291661e-12  ,
 6.23918983459e-12 , 5.57585756662e-11 , 7.0140116939e-10  , 7.50167285569e-09 ,
 6.74223844437e-08 , 5.08856250619e-07 , 3.20164721461e-06 , 1.66133437569e-05 ,
 7.03498690159e-05 , 0.000241127459208 , 0.000665558638924 , 0.00147645024238  ,
 0.00263612060283  , 0.00381020909307  , 0.00451114124637  , 0.00445844096954  ,
 0.0037669089225   , 0.0027771086603   , 0.0018009404782   , 0.00103666642863  ,
 0.0005933929195   , 0.000520808421865 , 0.00086430733174  , 0.00181695850767  ,
 0.00410753604515  , 0.00976047897728  , 0.02297156232     , 0.0501775062573   ,
 0.0981111713816   , 0.169412320071    , 0.257998472906    , 0.349640847927    ,
 0.430192663844    , 0.49301652979     , 0.535800244993    , 0.55418016377     ,
 0.54612491677     , 0.519737400951    , 0.487420215463    , 0.453316264251    ,
 0.413748158434    , 0.368076070775    , 0.321692622539    , 0.278576847715    ,
 0.237354573919    , 0.196681038215    , 0.160167341584    , 0.133112090564    ,
 0.116425353367    , 0.105370855268    , 0.0929632832085   , 0.0746824049736   ,
 0.0517270011193   , 0.0297736001951   , 0.013924320063    , 0.00522150205634  ,
 0.00155773746352  , 0.000367917373506 , 6.85688255875e-05 , 1.00591243909e-05 ,
 1.15933546161e-06 , 1.04804909386e-07 , 7.42164983686e-09 , 4.11229143256e-10 ,
 1.78128183696e-11 , 6.0272078628e-13  , 1.592157297e-14   , 3.20189530068e-16 ,
 7.92916430746e-20 , 5.6251267682e-19  , 3.30959406357e-18 , 1.5503813285e-17  ,
 5.78645978894e-17 , 1.72174335944e-16 , 4.0857327658e-16  , 7.73391768873e-16 ,
 1.16785435348e-15 , 1.40711822528e-15 , 1.35495790464e-15 , 1.05216130946e-15 ,
 6.87251041622e-16 , 4.39852616398e-16 , 3.6165078555e-16  , 3.81354732395e-16 ,
 3.91007322117e-16 , 3.32631852472e-16 , 2.24250592927e-16 , 1.18477845385e-16 ,
 4.89283439404e-17 , 1.59135962901e-17 , 4.82168000935e-18 , 4.52433333357e-18 ,
 1.30162839156e-17 , 3.51209176451e-17 , 7.55852709615e-17 , 1.2864879263e-16  ,
 1.73046706091e-16 , 1.92255336911e-16 , 5.63112791623e-16 , 1.44927274903e-14 ,
 4.03071596733e-13 , 9.05743179804e-12 , 1.63684041049e-10 , 2.38309024884e-09 ,
 2.79993653603e-08 , 2.65859002621e-07 , 2.04207476735e-06 , 1.26922881852e-05 ,
 6.38003118965e-05 , 0.000258994595154 , 0.000847113271707 , 0.00222574425093  ,
 0.0046816766755   , 0.00785512555352  , 0.0104758238374   , 0.0110678696764   ,
 0.00923600563324  , 0.00607182698008  , 0.0031376892514   , 0.0012722010755   ,
 0.000404110253758 , 0.000100440577026 , 1.95144938875e-05 , 2.96165069828e-06 ,
 3.51290141559e-07 , 3.33475664742e-08 , 4.32802867189e-09 , 4.49209671109e-09 ,
 8.43158778623e-09 , 1.34528766471e-08 , 1.7437374612e-08  , 1.83282536469e-08 ,
 1.56622468553e-08 , 1.09002569491e-08 , 6.17421585628e-09 , 2.83766531577e-09 ,
 1.05345625692e-09 , 3.14437399095e-10 , 7.51988330043e-11 , 1.43977827644e-11 ,
 2.2250388876e-12  , 3.04343063564e-13 , 2.27819794939e-12 , 2.48623720378e-12 ,
 2.76640997147e-12 , 2.62680382429e-12 , 2.23665262455e-12 , 2.98188841275e-12 ,
 1.50690376122e-11 , 1.07504112536e-10 , 6.42913431726e-10 , 3.05011833459e-09 ,
 1.14097561917e-08 , 3.35924697415e-08 , 7.78038003272e-08 , 1.42277141376e-07 ,
 2.09849459332e-07 , 2.72773525497e-07 , 3.95060488524e-07 , 7.62768961725e-07 ,
 1.61582248812e-06 , 2.99296350918e-06 , 4.46320131016e-06 , 5.25457617686e-06 ,
 4.86818783426e-06 , 3.55092027157e-06 , 2.04175106269e-06 , 9.26656490006e-07 ,
 3.32327148012e-07 , 9.42480526064e-08 , 2.11460628512e-08 , 3.76343960305e-09 ,
 5.63341213652e-10 , 1.48398760049e-10 , 1.76922066169e-10 , 2.5865739567e-10  ,
 3.06688485295e-10 , 2.8840389046e-10  , 2.16247397595e-10 , 1.32104162943e-10 ,
 8.54431948419e-11 , 3.14628837619e-10 , 3.46130611228e-09 , 3.43173677301e-08 ,
 2.84483274834e-07 , 1.98447939527e-06 , 1.16669786298e-05 , 5.74408162032e-05 ,
 0.000234218261297 , 0.000781771874508 , 0.00211525567076  , 0.00460686702009  ,
 0.00803932365836  , 0.0112124954996   , 0.0124894442154   , 0.0111253013712   ,
 0.00795907056053  , 0.00461999383327  , 0.00224488141275  , 0.0010597125151   ,
 0.000843367303236 , 0.00145884006392  , 0.00301741283246  , 0.00589346023089  ,
 0.0111319947274   , 0.0216120410055   , 0.0435578718127   , 0.0871081815461   ,
 0.164220389135    , 0.282509972224    , 0.436820340877    , 0.606620009481    ,
 0.765776313985    , 0.895362595179    , 0.984323282513    , 1.02469112958     ,
 1.0183351395      , 0.983401837699    , 0.937015873693    , 0.871962275386    ,
 0.766372398089    , 0.618597116008    , 0.459439884184    , 0.326473329599    ,
 0.235930871775    , 0.182002570901    , 0.152504603884    , 0.137909051495    ,
 0.130754671961    , 0.123970032302    , 0.111371957363    , 0.0899537795321   ,
 0.0624315708235   , 0.03600359505     , 0.0168767762725   , 0.00634467972531  ,
 0.0018975944165   , 0.000449243425566 , 8.39019068991e-05 , 1.2330963998e-05  ,
 1.42336587979e-06 , 1.28839067557e-07 , 9.13328278255e-09 , 5.06514204373e-10 ,
 2.19569797891e-11 , 7.43544924413e-13 , 1.96673784101e-14 , 3.97753988088e-16 ,
 3.81308534228e-18 , 2.75177370514e-17 , 1.6198326212e-16  , 7.59149446505e-16 ,
 2.83477672762e-15 , 8.4395458292e-15  , 2.00400015634e-14 , 3.79614822113e-14 ,
 5.73712829119e-14 , 6.91916404456e-14 , 6.66999073104e-14 , 5.18552061103e-14 ,
 3.39007429392e-14 , 2.16851700627e-14 , 1.77923110742e-14 , 1.8751915317e-14  ,
 1.92588723205e-14 , 1.64322892243e-14 , 1.11223159714e-14 , 5.90629770376e-15 ,
 2.45505250884e-15 , 8.05002748467e-16 , 2.45414535009e-16 , 2.27040616679e-16 ,
 6.49127722156e-16 , 1.75064042026e-15 , 3.76751647405e-15 , 6.41243428588e-15 ,
 8.62097663585e-15 , 9.17804242444e-15 , 9.22279351651e-15 , 5.9509111423e-14  ,
 1.49099599758e-12 , 3.24113470918e-11 , 5.63367260675e-10 , 7.83049777697e-09 ,
 8.72247709801e-08 , 7.8080574813e-07  , 5.63477023645e-06 , 3.28878020084e-05 ,
 0.00015566250777  , 0.000598380458414 , 0.00186783551271  , 0.0047249300771   ,
 0.00965149430937  , 0.0158469749486   , 0.0208114321965   , 0.0217561810316   ,
 0.0180270336133   , 0.0117961566758   , 0.00607756108975  , 0.00245950110375  ,
 0.000780314970422 , 0.000193800838058 , 3.76379074087e-05 , 5.71457809297e-06 ,
 6.84659323125e-07 , 7.71917882759e-08 , 3.38710226186e-08 , 6.21227305177e-08 ,
 1.17923839953e-07 , 1.87584255808e-07 , 2.43126451767e-07 , 2.55851194444e-07 ,
 2.19011520147e-07 , 1.52731830364e-07 , 8.67155832743e-08 , 3.99712090088e-08 ,
 1.48986584171e-08 , 4.4737721016e-09  , 1.08011819862e-09 , 2.10116354651e-10 ,
 3.36223499818e-11 , 5.40642153198e-12 , 5.98205496872e-11 , 7.23794740969e-11 ,
 8.1144320252e-11  , 7.69953285656e-11 , 6.35641595661e-11 , 6.08243384824e-11 ,
 1.83281958488e-10 , 1.18036986544e-09 , 6.98168207599e-09 , 3.30629104159e-08 ,
 1.23606546556e-07 , 3.63775226702e-07 , 8.41882443306e-07 , 1.53481504686e-06 ,
 2.23372671269e-06 , 2.75559223754e-06 , 3.48427822225e-06 , 5.77500365929e-06 ,
 1.14127440227e-05 , 2.07452888826e-05 , 3.08033753441e-05 , 3.62311558794e-05 ,
 3.3560139183e-05  , 2.44781214553e-05 , 1.40745805463e-05 , 6.38778311229e-06 ,
 2.29085120103e-06 , 6.4969249409e-07  , 1.45803377351e-07 , 2.60828797974e-08 ,
 4.31282326321e-09 , 2.06097220993e-09 , 3.19709899629e-09 , 4.75479057428e-09 ,
 5.64334790773e-09 , 5.31338312366e-09 , 3.99870556985e-09 , 2.45423073046e-09 ,
 1.35693063786e-09 , 1.83900173313e-09 , 1.46984366456e-08 , 1.36066310895e-07 ,
 1.05234442653e-06 , 6.78882564458e-06 , 3.69030111303e-05 , 0.000169524768528 ,
 0.000654394083366 , 0.00209899248852  , 0.00552541457831  , 0.0118108429045   ,
 0.0203389955953   , 0.0280666432741   , 0.0309330821217   , 0.0271841385927   ,
 0.0190581409837   , 0.010730815271    , 0.00505056644918  , 0.00251421491184  ,
 0.00253325620517  , 0.00482862757238  , 0.00971448078693  , 0.0177550175551   ,
 0.0300996162761   , 0.0502535395389   , 0.0864207624879   , 0.152570913833    ,
 0.266590124977    , 0.443512723341    , 0.683729444655    , 0.964877526941    ,
 1.24920014547     , 1.50045272259     , 1.69144694477     , 1.80424576102     ,
 1.83951707642     , 1.82037107107     , 1.76335682298     , 1.64546371036     ,
 1.4258955668      , 1.10841345236     , 0.762317705177    , 0.472615947565    ,
 0.28156848547     , 0.180276828061    , 0.137498466062    , 0.124368003978    ,
 0.121507118723    , 0.117531012061    , 0.106309534631    , 0.0859568487072   ,
 0.0596763041376   , 0.0344523803065   , 0.0161796961176   , 0.00609637472404  ,
 0.00182761349601  , 0.00043364480086  , 8.11527040514e-05 , 1.19480319495e-05 ,
 1.38125587492e-06 , 1.25190299997e-07 , 8.885234854e-09   , 4.93440029896e-10 ,
 2.14435572033e-11 , 7.30977312558e-13 , 1.97428190698e-14 , 4.43575053043e-16 ,
 1.43947375923e-16 , 1.04451293701e-15 , 6.13451855015e-15 , 2.87058795091e-14 ,
 1.07087275557e-13 , 3.18628775689e-13 , 7.56365591388e-13 , 1.43262137178e-12 ,
 2.16520801001e-12 , 2.61169646316e-12 , 2.51822711305e-12 , 1.95832551746e-12 ,
 1.28055927597e-12 , 8.19020947926e-13 , 6.71644434255e-13 , 7.07813343155e-13 ,
 7.27325330578e-13 , 6.21118330475e-13 , 4.20894472088e-13 , 2.23837337573e-13 ,
 9.3214928071e-14  , 3.06351920675e-14 , 9.35498796657e-15 , 8.61761118984e-15 ,
 2.45927747464e-14 , 6.63149799322e-14 , 1.42713810748e-13 , 2.42903372505e-13 ,
 3.26549444154e-13 , 3.46424584721e-13 , 2.94227960241e-13 , 3.57046625862e-13 ,
 4.59744884037e-12 , 9.62986990392e-11 , 1.63519369621e-09 , 2.20707203489e-08 ,
 2.36995679078e-07 , 2.0288387716e-06  , 1.38895126524e-05 , 7.63572005624e-05 ,
 0.000338722090131 , 0.00121841254374  , 0.00356782451088  , 0.0085207285186   ,
 0.0165818186525   , 0.0262019113791   , 0.0334367772277   , 0.0342453709174   ,
 0.0279782623267   , 0.0181363657771   , 0.00928695525049  , 0.00374354043915  ,
 0.0011847484511   , 0.000293800709624 , 5.70324031259e-05 , 8.7101150167e-06  ,
 1.13676917151e-06 , 2.80260162169e-07 , 3.50218915626e-07 , 6.90463867866e-07 ,
 1.29140342389e-06 , 2.04383828315e-06 , 2.64796599629e-06 , 2.79044731978e-06 ,
 2.39388674619e-06 , 1.67392749717e-06 , 9.5351754624e-07  , 4.41402922356e-07 ,
 1.65531364174e-07 , 5.01700665805e-08 , 1.22933815301e-08 , 2.45270349432e-09 ,
 4.1733550373e-10  , 8.83926976254e-11 , 1.30007738737e-09 , 1.65006375313e-09 ,
 1.85641375225e-09 , 1.76210686475e-09 , 1.43974878618e-09 , 1.17086479408e-09 ,
 2.01175446053e-09 , 1.03401510966e-08 , 5.94186484895e-08 , 2.80102046217e-07 ,
 1.04572462218e-06 , 3.07542800432e-06 , 7.11231306959e-06 , 1.29397878711e-05 ,
 1.86715892784e-05 , 2.2237268239e-05  , 2.52452046656e-05 , 3.56591144879e-05 ,
 6.42619039608e-05 , 0.000113612559302 , 0.000167599098962 , 0.00019684818272  ,
 0.000182278980884 , 0.00013294136137  , 7.6438044449e-05  , 3.4691372808e-05  ,
 1.24413449166e-05 , 3.52850093328e-06 , 7.92365055649e-07 , 1.43684247964e-07 ,
 2.96319462591e-08 , 2.61826822644e-08 , 4.59036784441e-08 , 6.87033433409e-08 ,
 8.15924565812e-08 , 7.69504000525e-08 , 5.82085690647e-08 , 3.61669972764e-08 ,
 1.96694433423e-08 , 1.40621383415e-08 , 5.47010009763e-08 , 4.56355473975e-07 ,
 3.34527911632e-06 , 2.02316478076e-05 , 0.000102047305343 , 0.000434103568958 ,
 0.00156296652215  , 0.00473769390975  , 0.0119557224248   , 0.0248007726317   ,
 0.0418259188691   , 0.0568788253939   , 0.0620327063627   , 0.05410417927     ,
 0.037777027656    , 0.0213952449757   , 0.0105507077588   , 0.00621625662637  ,
 0.00739804244297  , 0.0138979095447   , 0.0266048938627   , 0.0463208985224   ,
 0.0739247808225   , 0.113314838257    , 0.175028943334    , 0.277398122679    ,
 0.444553231184    , 0.700111157258    , 1.05376975642     , 1.48736531195     ,
 1.95646409405     , 2.40748756143     , 2.78988598986     , 3.06029285267     ,
 3.1964101572      , 3.20700620557     , 3.10293627281     , 2.85771715783     ,
 2.43280140093     , 1.85603080672     , 1.24569940052     , 0.73714117761     ,
 0.397470065046    , 0.212744542627    , 0.131203290421    , 0.103354424023    ,
 0.0961947362595   , 0.0919367444072   , 0.082697129832    , 0.0665168790734   ,
 0.0459827507842   , 0.0264744772887   , 0.0124168134383   , 0.00467713453178  ,
 0.00140257643556  , 0.000333005657985 , 6.23679855424e-05 , 9.19043465271e-06 ,
 1.06361061427e-06 , 9.65757151949e-08 , 6.88447789494e-09 , 3.87325790319e-10 ,
 1.75350681376e-11 , 6.78031145467e-13 , 2.61842408719e-14 , 2.06748817805e-15 ,
 4.59694960255e-15 , 3.10393114309e-14 , 1.80968003852e-13 , 8.45634675592e-13 ,
 3.15268624213e-12 , 9.37762037107e-12 , 2.22583674356e-11 , 4.21611503206e-11 ,
 6.37310206132e-11 , 7.68928274499e-11 , 7.41660258001e-11 , 5.76983209169e-11 ,
 3.77405820412e-11 , 2.41337570676e-11 , 1.97770557127e-11 , 2.08388772162e-11 ,
 2.14265372233e-11 , 1.83172661532e-11 , 1.24301059758e-11 , 6.62241624358e-12 ,
 2.76410341863e-12 , 9.10967260054e-13 , 2.78749220845e-13 , 2.55490985203e-13 ,
 7.27497795543e-13 , 1.9613729461e-12  , 4.22094683145e-12 , 7.18417908136e-12 ,
 9.65808502296e-12 , 1.02428877371e-11 , 8.56903579721e-12 , 6.03075396058e-12 ,
 1.38170471423e-11 , 2.32563092851e-10 , 3.88308824975e-09 , 5.15584886129e-08 ,
 5.41872905534e-07 , 4.51107038749e-06 , 2.97994116065e-05 , 0.000156665605884 ,
 0.000658378284709 , 0.00222425559889  , 0.00608019028041  , 0.0135316204525   ,
 0.0246236986076   , 0.036677107242    , 0.0445994100107   , 0.0440246888482   ,
 0.0350228346866   , 0.0222891372457   , 0.0112741688313   , 0.00450842907156  ,
 0.00141960278076  , 0.00035104610172  , 6.83275519738e-05 , 1.10350873045e-05 ,
 2.43060931413e-06 , 1.98531017597e-06 , 3.20591123301e-06 , 6.07277263635e-06 ,
 1.10910661098e-05 , 1.74220626174e-05 , 2.25497370701e-05 , 2.38006965548e-05 ,
 2.04750202786e-05 , 1.43688714095e-05 , 8.22273074129e-06 , 3.83045444909e-06 ,
 1.44978253467e-06 , 4.45724223428e-07 , 1.11736941886e-07 , 2.32004285152e-08 ,
 4.38960644239e-09 , 1.36527772924e-09 , 2.26517978419e-08 , 2.93946527595e-08 ,
 3.31311834277e-08 , 3.14755034143e-08 , 2.56625613395e-08 , 1.95442079921e-08 ,
 2.16303430364e-08 , 7.47175669992e-08 , 3.99134419597e-07 , 1.85959611153e-06 ,
 6.91953208466e-06 , 2.03195540906e-05 , 4.69449417245e-05 , 8.52746670582e-05 ,
 0.000122359476617 , 0.000142365341313 , 0.000149106075129 , 0.000180614494869 ,
 0.000290139467546 , 0.000492977695299 , 0.000720174530416 , 0.00084401489832  ,
 0.000781166873329 , 0.000569660977379 , 0.000327529568175 , 0.000148646803983 ,
 5.33088050961e-05 , 1.5120113055e-05  , 3.40121059313e-06 , 6.38909076155e-07 ,
 1.97690082896e-07 , 2.82579663673e-07 , 5.2083345354e-07  , 7.81258633372e-07 ,
 9.28394786614e-07 , 8.77626152786e-07 , 6.68540127245e-07 , 4.22775394087e-07 ,
 2.36258403715e-07 , 1.3778215786e-07  , 2.06830386075e-07 , 1.28111576758e-06 ,
 8.90654194426e-06 , 5.13839553219e-05 , 0.000244074771243 , 0.00096733834121  ,
 0.00323422722468  , 0.00915331056589  , 0.021813753071    , 0.0432961354239   ,
 0.0706839017248   , 0.0938980594693   , 0.10071752718     , 0.0869050982514   ,
 0.0605564176842   , 0.0350726460315   , 0.0191533558275   , 0.0142563252572   ,
 0.0191697348658   , 0.0344306820397   , 0.0622608422304   , 0.103921791137    ,
 0.159821433549    , 0.234814354904    , 0.344002070403    , 0.513057716107    ,
 0.773959219246    , 1.15814039548     , 1.683092622       , 2.33574032604     ,
 3.06966185641     , 3.81859118338     , 4.50374322337     , 5.03283397273     ,
 5.32174544337     , 5.33272297894     , 5.07180906596     , 4.54703037129     ,
 3.77198800611     , 2.82940952776     , 1.88775730991     , 1.11687146846     ,
 0.594347385385    , 0.296496975597    , 0.152727417398    , 0.0947653842166   ,
 0.0751806090223   , 0.0671389665332   , 0.0584701790448   , 0.0458501040033   ,
 0.0309537032624   , 0.0174526834677   , 0.008045751856    , 0.00298981665038  ,
 0.000887295034092 , 0.000209033013293 , 3.89414648022e-05 , 5.72624901947e-06 ,
 6.65774279278e-07 , 6.18779244946e-08 , 4.76942431993e-09 , 3.34987865728e-10 ,
 2.47956981163e-11 , 2.06031466946e-12 , 1.98695533879e-13 , 4.95701018195e-14 ,
 1.16056938587e-13 , 7.22391438498e-13 , 4.17267087737e-12 , 1.9456791095e-11  ,
 7.24636100689e-11 , 2.15421306975e-10 , 5.11192038527e-10 , 9.6827310959e-10  ,
 1.4638824215e-09  , 1.76673245606e-09 , 1.7047798358e-09  , 1.32688785705e-09 ,
 8.6824481839e-10  , 5.55086726108e-10 , 4.54481787166e-10 , 4.78798107055e-10 ,
 4.92689737178e-10 , 4.2176520338e-10  , 2.86723944775e-10 , 1.53106036489e-10 ,
 6.40864957013e-11 , 2.11947932212e-11 , 6.50183614591e-12 , 5.92178861533e-12 ,
 1.68147482658e-11 , 4.53234795465e-11 , 9.75364753515e-11 , 1.66009896783e-10 ,
 2.23176112198e-10 , 2.36683688476e-10 , 1.97755577097e-10 , 1.30724622503e-10 ,
 8.80954554557e-11 , 4.70970471902e-10 , 7.40986874296e-09 , 9.74579071281e-08 ,
 1.01261995777e-06 , 8.30099960224e-06 , 5.37095035182e-05 , 0.000274665504663 ,
 0.0011130722087   , 0.00358928846395  , 0.0092637872801   , 0.0192761624899   ,
 0.0325907304068   , 0.0450721105576   , 0.0511695545389   , 0.047647480324    ,
 0.0362070270075   , 0.0222794850209   , 0.0110076416834   , 0.004333197271    ,
 0.00135093019443  , 0.000333088502575 , 6.73611473006e-05 , 1.61235185436e-05 ,
 1.14214732164e-05 , 1.5210956342e-05  , 2.3841304722e-05  , 4.23577233263e-05 ,
 7.49178559626e-05 , 0.000116393765444 , 0.000150346543902 , 0.000158954087289 ,
 0.000137222462342 , 9.67670015177e-05 , 5.57380706605e-05 , 2.62061802635e-05 ,
 1.00576325617e-05 , 3.15976924427e-06 , 8.19927562454e-07 , 1.81126564316e-07 ,
 4.06820487771e-08 , 1.93645846728e-08 , 3.11825805444e-07 , 4.08935415614e-07 ,
 4.61422396659e-07 , 4.38909770918e-07 , 3.58353393232e-07 , 2.67098168611e-07 ,
 2.29873849895e-07 , 4.76290663956e-07 , 2.15257281721e-06 , 9.73363201531e-06 ,
 3.59244743014e-05 , 0.000105127253512 , 0.000242418177576 , 0.000439611743384 ,
 0.000628307984705 , 0.000719811594773 , 0.000711555580569 , 0.000752048800818 ,
 0.00105709196711  , 0.00170027162048  , 0.00244852020764  , 0.00286013126631  ,
 0.00264512727399  , 0.00192854317825  , 0.00110873938391  , 0.000503171456522 ,
 0.000180448269742 , 5.11924568188e-05 , 1.1569634846e-05  , 2.373908858e-06   ,
 1.30557329519e-06 , 2.48433168056e-06 , 4.66529580774e-06 , 7.00230101738e-06 ,
 8.32784689342e-06 , 7.89848073112e-06 , 6.07455816275e-06 , 3.93283238451e-06 ,
 2.29850143593e-06 , 1.33893247348e-06 , 1.06356581696e-06 , 3.1751766363e-06  ,
 1.95367723553e-05 , 0.00010850908536  , 0.000493737008298 , 0.00185105770118  ,
 0.00579380022403  , 0.0152906847646   , 0.0341138435426   , 0.0639961109397   ,
 0.09989948202     , 0.128288462474    , 0.134302553647    , 0.114245913044    ,
 0.0799149188133   , 0.0488769944377   , 0.0319239427795   , 0.030618995229    ,
 0.0439869743739   , 0.0744408672283   , 0.126795084985    , 0.203580502794    ,
 0.305656338229    , 0.441723769169    , 0.637498968195    , 0.933399464319    ,
 1.37330518715     , 1.99287211213     , 2.80653541082     , 3.79467021595     ,
 4.90410915835     , 6.05792231316     , 7.14619113604     , 8.00579236918     ,
 8.45134682388     , 8.36725642188     , 7.76345647494     , 6.73655721455     ,
 5.4196114928      , 3.9885300447      , 2.65603233181     , 1.59610244765     ,
 0.871502307561    , 0.440989213489    , 0.218096656206    , 0.118818526956    ,
 0.0805109265873   , 0.0644760954241   , 0.0520366784883   , 0.0379669541328   ,
 0.0237915609461   , 0.0124705523433   , 0.00537686958267  , 0.0018848246838   ,
 0.000532865141154 , 0.000120994048416 , 2.21272211787e-05 , 3.32591223796e-06 ,
 4.37599712975e-07 , 5.71917377844e-08 , 8.23796675618e-09 , 1.23361849619e-09 ,
 1.69205182959e-10 , 2.07093081108e-11 , 3.14526259397e-12 , 1.37229205517e-12 ,
 2.47111704127e-12 , 1.32839336972e-11 , 7.53743696347e-11 , 3.50144702208e-10 ,
 1.30171434449e-09 , 3.86582365317e-09 , 9.16888204559e-09 , 1.73646809859e-08 ,
 2.62559563341e-08 , 3.16981774158e-08 , 3.06015865215e-08 , 2.38322374554e-08 ,
 1.56018177117e-08 , 9.97180166983e-09 , 8.15560178145e-09 , 8.59016061525e-09 ,
 8.84830440198e-09 , 7.58756549544e-09 , 5.169850099e-09   , 2.76850062412e-09 ,
 1.16295138985e-09 , 3.86277668493e-10 , 1.18862355012e-10 , 1.07405081417e-10 ,
 3.03898651155e-10 , 8.18919407002e-10 , 1.76229077354e-09 , 2.99946676773e-09 ,
 4.03234560486e-09 , 4.27639154216e-09 , 3.57266120811e-09 , 2.34889633912e-09 ,
 1.24377206905e-09 , 1.16527699564e-09 , 1.13724758859e-08 , 1.47115094258e-07 ,
 1.51941263328e-06 , 1.23567261336e-05 , 7.90769963827e-05 , 0.000398285494973 ,
 0.0015804658157   , 0.00495187796443  , 0.012295513278    , 0.0243274262064   ,
 0.0386373257592   , 0.0496867370058   , 0.0521790872576   , 0.0450234383763   ,
 0.0319726424655   , 0.0186199066949   , 0.00882633323325  , 0.00337512327113  ,
 0.0010347712963   , 0.000260452312972 , 7.16596731722e-05 , 5.15948972886e-05 ,
 7.01322948909e-05 , 9.7768317454e-05  , 0.000142990000649 , 0.000235730706105 ,
 0.000399721825619 , 0.000611037418629 , 0.000786258346083 , 0.000832587078207 ,
 0.000721905998774 , 0.00051241473733  , 0.000297899126205 , 0.000141980591124 ,
 5.56330732031e-05 , 1.80502752281e-05 , 4.92918434519e-06 , 1.19557189921e-06 ,
 3.43055853547e-07 , 2.38497238215e-07 , 3.37104390353e-06 , 4.44330460176e-06 ,
 5.01750246293e-06 , 4.78042385811e-06 , 3.91594521802e-06 , 2.91012599792e-06 ,
 2.24390945965e-06 , 2.93119446692e-06 , 9.69181953419e-06 , 4.07372744642e-05 ,
 0.000147359532244 , 0.000427643585886 , 0.000981945312279 , 0.00177595985443  ,
 0.00252968189074  , 0.00286768596944  , 0.00272260980556  , 0.00257030081065  ,
 0.00312860829843  , 0.00468003446583  , 0.00660133549024  , 0.00767268844535  ,
 0.00708697573927  , 0.00516496063756  , 0.00296881203153  , 0.00134715275022  ,
 0.00048310293623  , 0.000137152474674 , 3.14075695936e-05 , 7.89141937092e-06 ,
 8.03827404611e-06 , 1.74840921921e-05 , 3.30167808976e-05 , 4.95489883253e-05 ,
 5.89978674618e-05 , 5.62185354887e-05 , 4.3805877004e-05  , 2.92470317857e-05 ,
 1.80871672152e-05 , 1.11645351228e-05 , 7.33663747827e-06 , 8.81596800681e-06 ,
 3.60711618006e-05 , 0.0001878660934   , 0.000827102016413 , 0.00298014175591  ,
 0.00886569424261  , 0.0220343368307   , 0.0461223849889   , 0.0814205609945   ,
 0.120576483986    , 0.148471180723    , 0.150856579053    , 0.126660763106    ,
 0.0906401259852   , 0.0620677548644   , 0.0518185403069   , 0.0609390724928   ,
 0.0892714259047   , 0.142544132078    , 0.229987068356    , 0.357313461733    ,
 0.528884755306    , 0.763763202583    , 1.10932368805     , 1.6330553124      ,
 2.39669352306     , 3.43213793636     , 4.72788881069     , 6.22832091402     ,
 7.85020630607     , 9.49600850433     , 11.0236558072     , 12.1954558553     ,
 12.7125594864     , 12.3711655632     , 11.1975495852     , 9.42200517291     ,
 7.35612340078     , 5.30613828262     , 3.52450022701     , 2.15746952979     ,
 1.22342059538     , 0.6516831483      , 0.340451870865    , 0.192104158779    ,
 0.128297485328    , 0.0970149936264   , 0.0726064422412   , 0.0486717325292   ,
 0.0278054398919   , 0.0132123184213   , 0.00515338763046  , 0.00163946792715  ,
 0.000426711067246 , 9.32861066872e-05 , 1.86192910986e-05 , 3.95703483466e-06 ,
 9.6849726743e-07  , 2.42281117608e-07 , 5.3588148169e-08  , 9.83422250726e-09 ,
 1.50522449616e-09 , 2.22058751112e-10 , 5.67925334489e-11 , 3.4914865799e-11  ,
 4.60813075668e-11 , 1.95227576362e-10 , 1.07021821637e-09 , 4.9383500501e-09  ,
 1.8302456658e-08  , 5.42569242393e-08 , 1.2855973245e-07  , 2.43378078528e-07 ,
 3.68001530265e-07 , 4.44424917901e-07 , 4.29292884822e-07 , 3.34567541863e-07 ,
 2.19151715625e-07 , 1.40022243276e-07 , 1.14365375071e-07 , 1.20429607026e-07 ,
 1.24207412461e-07 , 1.0674051704e-07  , 7.29351815746e-08 , 3.91965857577e-08 ,
 1.65377158718e-08 , 5.52223173911e-09 , 1.70557635096e-09 , 1.52607499319e-09 ,
 4.29891880976e-09 , 1.15803184633e-08 , 2.49199762059e-08 , 4.2414423176e-08  ,
 5.7020001765e-08  , 6.04709604965e-08 , 5.05193070409e-08 , 3.3199399954e-08  ,
 1.71733723884e-08 , 7.74904388125e-09 , 1.56660671523e-08 , 1.76679654461e-07 ,
 1.81429742006e-06 , 1.4695207932e-05  , 9.35200522885e-05 , 0.000467350385191 ,
 0.00183399857171  , 0.00565596392537  , 0.0137321371736   , 0.0263304981556   ,
 0.0400680666998   , 0.0487270037321   , 0.0477752648862   , 0.0381325096013   ,
 0.0249854478709   , 0.0134998078078   , 0.00600930888077  , 0.00219539843375  ,
 0.000669424577231 , 0.000214325466709 , 0.00016294530837  , 0.000248257890226 ,
 0.000373697589251 , 0.00050831495139  , 0.000694690341961 , 0.00105537627384  ,
 0.00169505313847  , 0.00253035875548  , 0.00323358037794  , 0.00342778880409  ,
 0.00298815389658  , 0.00213985384918  , 0.00126054007603  , 0.000612852038995 ,
 0.000247580137144 , 8.41851999614e-05 , 2.47381494433e-05 , 6.85854109565e-06 ,
 2.64397105149e-06 , 2.43411690552e-06 , 2.85582298971e-05 , 3.77275759893e-05 ,
 4.26304673887e-05 , 4.06993488534e-05 , 3.34976410345e-05 , 2.50294497249e-05 ,
 1.86176984931e-05 , 1.81396169311e-05 , 3.92431924977e-05 , 0.000140761166002 ,
 0.000485235233717 , 0.00138026914294  , 0.0031377798122   , 0.00564366865288  ,
 0.00800506521085  , 0.00900316656579  , 0.00831228506234  , 0.00718508232884  ,
 0.00757546998722  , 0.0103430453813   , 0.0141644712619   , 0.0163366905629   ,
 0.0150557650404   , 0.0109625901248   , 0.00629797080882  , 0.0028568571335   ,
 0.00102449872153  , 0.000291605538679 , 6.93890085034e-05 , 2.57960688981e-05 ,
 4.29340873342e-05 , 9.80131146832e-05 , 0.000184927044766 , 0.000277303744548 ,
 0.000330735049313 , 0.000317252832855 , 0.000251669791052 , 0.000174835287687 ,
 0.000115577278624 , 7.66948593916e-05 , 5.03314958274e-05 , 3.68441685441e-05 ,
 6.57333808194e-05 , 0.000273221645091 , 0.00114415701098  , 0.00399174434018  ,
 0.0114476651546   , 0.0271992884326   , 0.0540563820502   , 0.0904129055428   ,
 0.127344570575    , 0.150537302255    , 0.149126882966    , 0.125578484526    ,
 0.0959656628118   , 0.0787489481736   , 0.0833970964921   , 0.110336327326    ,
 0.161060830301    , 0.246211644157    , 0.381720422388    , 0.57958634805     ,
 0.852912945422    , 1.24083383363     , 1.82721590376     , 2.72217545335     ,
 4.01174342111     , 5.71091682827     , 7.74620518638     , 9.97576597077     ,
 12.2401984809     , 14.3976670105     , 16.2805914523     , 17.6063847812     ,
 17.9968109317     , 17.1819924405     , 15.2162934188     , 12.4816940889     ,
 9.49860961723     , 6.72773209329     , 4.45841362883     , 2.78292875798     ,
 1.64749086535     , 0.9378533045      , 0.534766602634    , 0.328775878625    ,
 0.22750514013     , 0.16750066937     , 0.11848850064     , 0.0746559937048   ,
 0.0401528442849   , 0.018008914603    , 0.00665888236366  , 0.00203922869045  ,
 0.000541170879408 , 0.000142374742475 , 4.42892071527e-05 , 1.58367260065e-05 ,
 5.38920889246e-06 , 1.5503176427e-06  , 3.6378769353e-07  , 7.022321918e-08   ,
 1.1965350045e-08  , 2.43367661254e-09 , 1.04157083461e-09 , 7.5165022262e-10  ,
 7.67678945798e-10 , 2.33699691458e-09 , 1.20086415723e-08 , 5.4752457207e-08  ,
 2.01862231276e-07 , 5.9656041479e-07  , 1.41101069191e-06 , 2.66890110988e-06 ,
 4.034699832e-06   , 4.8739219209e-06  , 4.71093539525e-06 , 3.67457404865e-06 ,
 2.40866907498e-06 , 1.53834471215e-06 , 1.25438518858e-06 , 1.3205140548e-06  ,
 1.36413587184e-06 , 1.17548455612e-06 , 8.06047444295e-07 , 4.35094108293e-07 ,
 1.84566885856e-07 , 6.20274375871e-08 , 1.9242020588e-08  , 1.70087835053e-08 ,
 4.76502078377e-08 , 1.28303194854e-07 , 2.7609149031e-07  , 4.69913889271e-07 ,
 6.31730586199e-07 , 6.69964125245e-07 , 5.59708399738e-07 , 3.67805679851e-07 ,
 1.89878630988e-07 , 7.76559190641e-08 , 3.72964013697e-08 , 1.73550007974e-07 ,
 1.7200067456e-06  , 1.38855019621e-05 , 8.81011720054e-05 , 0.000438511899453 ,
 0.00171112552586  , 0.00523413961653  , 0.0125580078598   , 0.0236670108395   ,
 0.0351304440306   , 0.0412516723707   , 0.0385699457718   , 0.0289713422765   ,
 0.0176722071122   , 0.00885280926216  , 0.00368120550859  , 0.00130433142524  ,
 0.000478902883209 , 0.000377534276564 , 0.000629879194428 , 0.00108470389194  ,
 0.00161788060797  , 0.00213718023514  , 0.00275052652232  , 0.00383917344419  ,
 0.00576309206452  , 0.00831276281223  , 0.0104972147501   , 0.0111255504457   ,
 0.00976178923186  , 0.00707468593727  , 0.00424634891395  , 0.00212488406257  ,
 0.000897120738063 , 0.000326019860944 , 0.000106007257716 , 3.50163914122e-05 ,
 1.81433821782e-05 , 2.00281551496e-05 , 0.000189562094535 , 0.000250574083162 ,
 0.000283298763422 , 0.000271158429415 , 0.000224558647672 , 0.000169512603659 ,
 0.000125749756832 , 0.000106910070802 , 0.000156298231973 , 0.000428062883007 ,
 0.00132890687204  , 0.00360903938262  , 0.00801322808309  , 0.014230647008    ,
 0.0200324829972   , 0.0223603548171   , 0.0202449903979   , 0.0163980148026   ,
 0.0151522802975   , 0.0185692244947   , 0.0243944925247   , 0.0277853330842   ,
 0.0254920833503   , 0.018519354604    , 0.0106237746244   , 0.00481498416102  ,
 0.00172773854295  , 0.00049696500745  , 0.000132580477269 , 8.78009417186e-05 ,
 0.00019132815795  , 0.000438335334017 , 0.000821914777101 , 0.00123010586594  ,
 0.00147039817258  , 0.00142374399197  , 0.00115730570443  , 0.00084549811086  ,
 0.000602659071578 , 0.000430569397963 , 0.000294286329712 , 0.000192154869286 ,
 0.000172000709355 , 0.000393968920335 , 0.00139288379238  , 0.00459276531608  ,
 0.0127284168373   , 0.0292631302144   , 0.0560640763799   , 0.0901909873179   ,
 0.122563877374    , 0.141358392235    , 0.139827903376    , 0.123027628703    ,
 0.106457607316    , 0.10651006144     , 0.131496085847    , 0.182602309775    ,
 0.264691025979    , 0.395068243181    , 0.598618549988    , 0.897439492873    ,
 1.32018714389     , 1.93709597322     , 2.88333322434     , 4.32606989275     ,
 6.38025261146     , 9.02596776254     , 12.079550537      , 15.2438468571     ,
 18.220578706      , 20.7972892637     , 22.8046263826     , 23.9786682155     ,
 23.9356187142     , 22.3906156383     , 19.4420400459     , 15.6199291771     ,
 11.6495467364     , 8.14144715843     , 5.40692161172     , 3.46020542638     ,
 2.15399132234     , 1.32020554181     , 0.822059722052    , 0.54301660924     ,
 0.382730908521    , 0.272478384823    , 0.182205447858    , 0.108455185359    ,
 0.0556325891552   , 0.0241726620666   , 0.00890954638866  , 0.00291729858422  ,
 0.000975094534476 , 0.000392376017392 , 0.000180125848598 , 7.79303579863e-05 ,
 2.84345978446e-05 , 8.46844313557e-06 , 2.07123090583e-06 , 4.3498406228e-07  ,
 9.06860484546e-08 , 2.80732007649e-08 , 1.69922530298e-08 , 1.31255273823e-08 ,
 1.13071282945e-08 , 2.34433171799e-08 , 1.07415644788e-07 , 4.79456701664e-07 ,
 1.75219578386e-06 , 5.15115286026e-06 , 1.21455898815e-05 , 2.29348386899e-05 ,
 3.46497502845e-05 , 4.1861714991e-05  , 4.04884493145e-05 , 3.16130071777e-05 ,
 2.07403610585e-05 , 1.32399166124e-05 , 1.0773936648e-05  , 1.13377965644e-05 ,
 1.17359151411e-05 , 1.01470782424e-05 , 6.98849045401e-06 , 3.79270111383e-06 ,
 1.61942264378e-06 , 5.48438740238e-07 , 1.71007057832e-07 , 1.48924281564e-07 ,
 4.14378730142e-07 , 1.11515734342e-06 , 2.39959167332e-06 , 4.08415063195e-06 ,
 5.49054333522e-06 , 5.82284185169e-06 , 4.86458133015e-06 , 3.19670317354e-06 ,
 1.65005951964e-06 , 6.69074667134e-07 , 2.23745510454e-07 , 1.86417600547e-07 ,
 1.32507959962e-06 , 1.047119665e-05   , 6.60352329247e-05 , 0.000327498815103 ,
 0.00127361622244  , 0.00387952541652  , 0.00925405746579  , 0.017296247719    ,
 0.0253714591919   , 0.0293025974416   , 0.0267976901761   , 0.0195888014461   ,
 0.0116147186807   , 0.00570924787125  , 0.00242171461738  , 0.00103382063422  ,
 0.000771938147836 , 0.00124642698368  , 0.00234145193537  , 0.00393121209733  ,
 0.00569674629152  , 0.00730728125683  , 0.00893051611477  , 0.0114734462425   ,
 0.0158955791566   , 0.0218476704661   , 0.0270477959787   , 0.0285870367525   ,
 0.0252733084309   , 0.0186149336137   , 0.0114735355708   , 0.00598374248645  ,
 0.00268924018498  , 0.00107069848561  , 0.000397284562765 , 0.000160718086149 ,
 0.00010677555299  , 0.000131102519918 , 0.000987203638104 , 0.00130389790852  ,
 0.00147482416425  , 0.00141608259021  , 0.00118192955935  , 0.000904767673826 ,
 0.000679848428707 , 0.000552376192329 , 0.000629052259526 , 0.00125307670613  ,
 0.00323917520618  , 0.00799630564431  , 0.0168477089728   , 0.0290609226891   ,
 0.040247642793    , 0.0444534107446   , 0.0396708026058   , 0.0307540607304   ,
 0.0255145202232   , 0.0278289605671   , 0.0345210864509   , 0.0384718408242   ,
 0.034944682961    , 0.0252348487714   , 0.014420138454    , 0.00652555931672  ,
 0.0023539078759   , 0.000708792387562 , 0.000257873148491 , 0.000303935470828 ,
 0.000707014167982 , 0.00157513966929  , 0.00291220059636  , 0.00433917771538  ,
 0.00520059601848  , 0.00510200872771  , 0.00428580522539  , 0.00333169934835  ,
 0.00257603164131  , 0.00197449488098  , 0.00141181139491  , 0.000928237051241 ,
 0.000668546001297 , 0.000833196566562 , 0.0019318460452   , 0.0053653355285   ,
 0.0138639800469   , 0.0307243360813   , 0.0572134461778   , 0.0896458140866   ,
 0.119350663207    , 0.137139800468    , 0.139879743338    , 0.134272789416    ,
 0.134494439999    , 0.15505461734     , 0.204752790859    , 0.28839517991     ,
 0.41694771303     , 0.615868407729    , 0.920394120995    , 1.36700546953     ,
 2.00860706874     , 2.95770149848     , 4.41073580197     , 6.59779016303     ,
 9.65971129992     , 13.5186275864     , 17.8272502419     , 22.0589768945     ,
 25.7159333626     , 28.5009450945     , 30.2824200004     , 30.8919938235     ,
 30.0297003026     , 27.4700922217     , 23.3919107847     , 18.4650027099     ,
 13.5791024854     , 9.44415974871     , 6.35250242165     , 4.21726850172     ,
 2.78924333754     , 1.84684640449     , 1.24186757535     , 0.860869268668    ,
 0.60696961354     , 0.415836004754    , 0.263226770531    , 0.148587554888    ,
 0.0734421417973   , 0.0318147449794   , 0.0125715592863   , 0.00509921314925  ,
 0.00245817241683  , 0.00136142556974  , 0.000726633858393 , 0.00033241918748  ,
 0.000125204387969 , 3.88432362712e-05 , 1.02550333457e-05 , 2.50778854002e-06 ,
 6.95669376569e-07 , 3.12108692672e-07 , 2.28436351285e-07 , 1.82533347468e-07 ,
 1.42664688391e-07 , 2.03811528987e-07 , 7.76528688099e-07 , 3.33975048201e-06 ,
 1.20291647843e-05 , 3.50574145168e-05 , 8.22175657115e-05 , 0.000154781808458 ,
 0.000233515960061 , 0.000282055613998 , 0.000272970699444 , 0.000213379789513 ,
 0.000140143890975 , 8.94132654876e-05 , 7.2574533485e-05  , 7.63342157227e-05 ,
 7.92097413845e-05 , 6.87710806971e-05 , 4.76179790234e-05 , 2.6011952442e-05  ,
 1.1193869577e-05  , 3.82536719119e-06 , 1.19970569334e-06 , 1.02606129416e-06 ,
 2.83118915659e-06 , 7.61410659202e-06 , 1.6383336946e-05  , 2.78846794403e-05 ,
 3.74868673143e-05 , 3.97556535808e-05 , 3.32131419668e-05 , 2.1825831543e-05  ,
 1.12666321029e-05 , 4.5681002387e-06  , 1.48026774832e-06 , 5.32292137336e-07 ,
 1.14397276773e-06 , 7.02883204997e-06 , 4.10475437482e-05 , 0.000197706273088 ,
 0.000759528060521 , 0.00230040451448  , 0.00547162190012  , 0.0102185816636   ,
 0.0150265322916   , 0.0175218344695   , 0.0164280963061   , 0.0126865943675   ,
 0.00835939041969  , 0.00490555001221  , 0.00274992972547  , 0.00187188821348  ,
 0.00229047712353  , 0.00412982175844  , 0.00743197689311  , 0.0118463986368   ,
 0.016495439552    , 0.0204798780528   , 0.0239248157033   , 0.0284763740197   ,
 0.0360923020076   , 0.0464983270481   , 0.055777671893    , 0.0585066372359   ,
 0.0521582836156   , 0.039264104345    , 0.0251264322865   , 0.0138967041566   ,
 0.00681076930203  , 0.00305753879716  , 0.001329107452    , 0.000657999865843 ,
 0.000522966395618 , 0.000679483687049 , 0.00404702212687  , 0.0053313860207   ,
 0.00603035244109  , 0.00581211051001  , 0.0048988776549   , 0.00381759437393  ,
 0.00293181864474  , 0.00237671734263  , 0.00240468853692  , 0.00371962172612  ,
 0.0076728920387   , 0.0162442126997   , 0.0309980057073   , 0.0503286747546   ,
 0.0673102225811   , 0.0729364116379   , 0.0643050212929   , 0.0487494508336   ,
 0.03779133473     , 0.037125402431    , 0.0427574740763   , 0.045814955791    ,
 0.0406747444146   , 0.0289427485786   , 0.0164018614462   , 0.00743494328499  ,
 0.00277196073187  , 0.000998277262533 , 0.000640071494192 , 0.00101928028053  ,
 0.00220688379847  , 0.00461934141426  , 0.00830162934404  , 0.0122463296964   ,
 0.0147120422998   , 0.0146935697      , 0.0128892593448   , 0.0107841520086   ,
 0.00906204808797  , 0.00740551223869  , 0.00552892505094  , 0.00376533855351  ,
 0.00268944018297  , 0.00268520499598  , 0.00421882863562  , 0.00876366365384  ,
 0.0195506431975   , 0.0405427310179   , 0.0727784812598   , 0.11073833315     ,
 0.143771665952    , 0.163459327649    , 0.170709018772    , 0.176277318792    ,
 0.195526585021    , 0.242755348277    , 0.329028166135    , 0.465409981336    ,
 0.671033869971    , 0.979466058434    , 1.43650891371     , 2.09860793657     ,
 3.0548527914      , 4.4711605019      , 6.60589680374     , 9.73986979037     ,
 14.0202514124     , 19.2851904537     , 24.9840140379     , 30.3093267802     ,
 34.5234700014     , 37.2386477233     , 38.392522851      , 37.9757778703     ,
 35.8656738397     , 32.001393507      , 26.7112366951     , 20.7931498962     ,
 15.2149571644     , 10.683042087      , 7.40790809876     , 5.1887804424      ,
 3.68545902636     , 2.63505463303     , 1.8894135666      , 1.35338287977     ,
 0.950185485857    , 0.632069760523    , 0.385501476584    , 0.211564921482    ,
 0.10461352247     , 0.0480891826825   , 0.0223279904913   , 0.0117978990442   ,
 0.00723873269553  , 0.00452999395299  , 0.00253883396361  , 0.00119830604515  ,
 0.000470258620988 , 0.000156707147844 , 4.70188188444e-05 , 1.41584099892e-05 ,
 5.21581670952e-06 , 3.01944955266e-06 , 2.45738716766e-06 , 2.00715225975e-06 ,
 1.49268135749e-06 , 1.57419787316e-06 , 4.63015148708e-06 , 1.87020359141e-05 ,
 6.57942795096e-05 , 0.000189065453953 , 0.000439457878574 , 0.000822933149358 ,
 0.0012381644687   , 0.00149422942274  , 0.00144675295097  , 0.001132413011    ,
 0.000744762100948 , 0.000474864644047 , 0.000384179223042 , 0.000403749983172 ,
 0.000420190682674 , 0.000366658519798 , 0.000255523538571 , 0.000140675164521 ,
 6.10962117493e-05 , 2.1097499599e-05  , 6.65890071741e-06 , 5.57277603347e-06 ,
 1.52205997781e-05 , 4.09003634007e-05 , 8.80011241602e-05 , 0.000149778638964 ,
 0.000201355355823 , 0.000213541919076 , 0.000178400398769 , 0.00011723767127  ,
 6.05293747059e-05 , 2.45765756224e-05 , 8.05293036709e-06 , 2.87757282848e-06 ,
 3.44588118548e-06 , 1.01290143788e-05 , 3.48845994966e-05 , 0.000123552264202 ,
 0.000408052443566 , 0.0011573401149   , 0.00269666706894  , 0.00508675001289  ,
 0.00781396058098  , 0.010004661005    , 0.0110662451308   , 0.0109246527964   ,
 0.00970464000004  , 0.00768085836312  , 0.00564194906     , 0.00488875407304  ,
 0.00670248008809  , 0.0118084286656   , 0.0200223362467   , 0.0300516972332   ,
 0.039799471169    , 0.0475074647843   , 0.0532189816442   , 0.0592498664172   ,
 0.0685843971432   , 0.0815043322993   , 0.0932350172814   , 0.0962747809609   ,
 0.0865565662932   , 0.0671108377115   , 0.045293913303    , 0.0272106944066   ,
 0.0149829913393   , 0.00779566273733  , 0.00401224993482  , 0.00235962058544  ,
 0.00209814477741  , 0.00279170832147  , 0.0131541013229   , 0.0172269887738   ,
 0.0194619580163   , 0.0188375068035   , 0.0160727418948   , 0.0128081492809   ,
 0.0101258542105   , 0.00836243176871  , 0.00810397960988  , 0.010790410956    ,
 0.0184195327309   , 0.0328837142299   , 0.054702804925    , 0.0804454780233   ,
 0.101004163755    , 0.105786122218    , 0.0922258874224   , 0.0701323737692   ,
 0.0537840798029   , 0.0497312719836   , 0.0529028283136   , 0.0532833342641   ,
 0.0453278871388   , 0.0314147972638   , 0.0176922759601   , 0.00828493294497  ,
 0.00355078293699  , 0.00193318444515  , 0.00199792056967  , 0.00321991412653  ,
 0.00603558210737  , 0.0113854187214   , 0.0194009898785   , 0.0280092768368   ,
 0.033645250958    , 0.034390644984    , 0.0318600534599   , 0.0289300375065   ,
 0.0263314452845   , 0.0227707675195   , 0.0177335854699   , 0.0126558696869   ,
 0.00946937286601  , 0.00914810569956  , 0.0121237252063   , 0.0202334446019   ,
 0.038425373652    , 0.0731124587107   , 0.125447238434    , 0.184773617414    ,
 0.232403118728    , 0.256655301674    , 0.26467023175     , 0.27850543683     ,
 0.322036510189    , 0.413533852413    , 0.567908521261    , 0.802762820439    ,
 1.14403191396     , 1.6306848427      , 2.31925877342     , 3.29464547184     ,
 4.69738717264     , 6.75591875799     , 9.7769462126      , 14.05358793       ,
 19.6972682064     , 26.441840558      , 33.5345671164     , 39.8864132563     ,
 44.5015945249     , 46.875924023      , 47.0099808079     , 45.099116187      ,
 41.3114031953     , 35.8946170519     , 29.4123318676     , 22.7516002725     ,
 16.8213740348     , 12.1870834612     , 8.91431967513     , 6.69602152235     ,
 5.13047080326     , 3.93303057298     , 2.96874151455     , 2.17934352799     ,
 1.53030617015     , 1.00615019832     , 0.608828309628    , 0.338097379367    ,
 0.175682102104    , 0.0897552160586   , 0.0488762938237   , 0.0302043086415   ,
 0.020324703106    , 0.0132623578861   , 0.00765613933569  , 0.00375995844111  ,
 0.00157512542738  , 0.0005851394698   , 0.000206852880278 , 7.6581714107e-05  ,
 3.51384651121e-05 , 2.40543358576e-05 , 2.09553474529e-05 , 1.7412508219e-05  ,
 1.26643910103e-05 , 1.08136062778e-05 , 2.33843686442e-05 , 8.54617125368e-05 ,
 0.00028973569761  , 0.000814346760436 , 0.00186572102126  , 0.00346267619186  ,
 0.00518430993674  , 0.00624397446095  , 0.00604617902464  , 0.00473965217524  ,
 0.00312271031226  , 0.00198963041623  , 0.00160259261605  , 0.00168162803097  ,
 0.00175590872518  , 0.00154141184009  , 0.001082470768    , 0.000601407088958 ,
 0.000263972052462 , 9.22293096889e-05 , 2.93082164833e-05 , 2.39038991601e-05 ,
 6.448428057e-05   , 0.000173105811825 , 0.000372428332082 , 0.00063387140604  ,
 0.000852145607999 , 0.000903720840054 , 0.000755007941837 , 0.000496193418862 ,
 0.000256294081417 , 0.000104408725358 , 3.52064288957e-05 , 1.50999489739e-05 ,
 2.09181751942e-05 , 4.95862024009e-05 , 0.000114071250364 , 0.000239585219188 ,
 0.000468052226903 , 0.000878672599991 , 0.00161626686368  , 0.00290106514947  ,
 0.0050111452658   , 0.00816884823549  , 0.0121284362974   , 0.0156586334213   ,
 0.0169369361677   , 0.0152521583903   , 0.0123559231558   , 0.0117692277071   ,
 0.0167560159375   , 0.0286181690601   , 0.0459032072554   , 0.0647949480159   ,
 0.0810050274614   , 0.0921905867496   , 0.0989776540633   , 0.104135872066    ,
 0.110872799788    , 0.120300697768    , 0.128847058083    , 0.129388595247    ,
 0.117209990713    , 0.094641407535    , 0.0689210524077   , 0.0464228996458   ,
 0.0296230711649   , 0.0181397602123   , 0.0109202953316   , 0.00729984902745  ,
 0.00688995464102  , 0.00916599952939  , 0.0344377997694   , 0.0445325511336   ,
 0.0500854378439   , 0.0486716997185   , 0.0421555223835   , 0.0345438419381   ,
 0.0283252552916   , 0.0241337132075   , 0.0232222592539   , 0.0285257223631   ,
 0.04299336574     , 0.0673401492048   , 0.0987894293452   , 0.130335337649    ,
 0.151149080578    , 0.151457321839    , 0.131167311999    , 0.102775108226    ,
 0.0820924156949   , 0.07520839857     , 0.0752371486047   , 0.0710131854954   ,
 0.0577420090755   , 0.0394240509795   , 0.0229668363919   , 0.012139885792    ,
 0.00679948328892  , 0.00531093725338  , 0.00634117297146  , 0.00939133112859  ,
 0.0150545850579   , 0.0246987983619   , 0.038528876423    , 0.0533069318709   ,
 0.0635577089327   , 0.0667292246395   , 0.0658495435847   , 0.0649683919382   ,
 0.0634660676112   , 0.0576514061334   , 0.0469255515259   , 0.0355086257579   ,
 0.0284259032298   , 0.0279539655617   , 0.034381988623    , 0.0500241806954   ,
 0.0829053405412   , 0.144223519611    , 0.236112082075    , 0.339334766795    ,
 0.420185641262    , 0.458715287671    , 0.470529042409    , 0.497985409261    ,
 0.584106243176    , 0.758786749032    , 1.04360663295     , 1.4606152082      ,
 2.03717994101     , 2.81353085953     , 3.86013800277     , 5.30337888182     ,
 7.35121155687     , 10.2957096977     , 14.4581759244     , 20.0754862619     ,
 27.1581842675     , 35.3262892633     , 43.6774181925     , 50.8971618497     ,
 55.7304382401     , 57.5032903095     , 56.2436586815     , 52.4047795899     ,
 46.5905659536     , 39.5098313302     , 32.010176195      , 24.9741090237     ,
 19.084824299      , 14.6355424127     , 11.5064967521     , 9.31113576045     ,
 7.62556276743     , 6.16613594491     , 4.82569502982     , 3.60561550778     ,
 2.54265499442     , 1.67488821998     , 1.02588029683     , 0.589291407241    ,
 0.326213564969    , 0.18253763126     , 0.109606873244    , 0.0727933296756   ,
 0.0509597429392   , 0.0342029654109   , 0.0204686293028   , 0.0106336818345   ,
 0.00486708900139  , 0.0020575384569   , 0.000852596294697 , 0.000371544797717 ,
 0.000200013108472 , 0.000154392837059 , 0.000141319965459 , 0.000119180908176 ,
 8.6086146668e-05  , 6.46758122086e-05 , 0.000102856200836 , 0.000324975389407 ,
 0.00104200521425  , 0.00283260290527  , 0.0063458107462   , 0.0116085608414   ,
 0.0172354038329   , 0.0206788028419   , 0.0200136095344   , 0.0157169671519   ,
 0.0103806419253   , 0.0066086061127   , 0.0052890749945   , 0.00553227098303  ,
 0.00579608442363  , 0.00512333115634  , 0.00363008204622  , 0.00203805520111  ,
 0.000905248274476 , 0.000320381658383 , 0.000102522872714 , 8.11354780003e-05 ,
 0.000215626108777 , 0.000578098372153 , 0.00124360912454  , 0.00211657191352  ,
 0.00284539710991  , 0.00301762067921  , 0.00252112871862  , 0.00165719016436  ,
 0.000856936567914 , 0.000351860486305 , 0.000125880845328 , 7.06922217787e-05 ,
 0.000116607247099 , 0.000264643103193 , 0.000562257095845 , 0.00105100845175  ,
 0.00169761220881  , 0.00238106588679  , 0.00306021063709  , 0.00411621870869  ,
 0.00655665708262  , 0.0115338811661   , 0.0189531464029   , 0.0262793467543   ,
 0.0296983525632   , 0.0277298541263   , 0.0237318078319   , 0.0243765689066   ,
 0.0355765039753   , 0.058837748606    , 0.0896445926884   , 0.119308801556    ,
 0.14037686916     , 0.151263293567    , 0.155218851485    , 0.155767181514    ,
 0.154855389803    , 0.15370586629     , 0.151894061898    , 0.146154316625    ,
 0.133246398255    , 0.113954689205    , 0.0924496507269   , 0.0722878619061   ,
 0.0544714291618   , 0.0389504943777   , 0.0266413017547   , 0.01946039091     ,
 0.0188279619621   , 0.0245303886281   , 0.0751290850815   , 0.0946219879731   ,
 0.105114743785    , 0.102302672852    , 0.0901872276246   , 0.0765122815232   ,
 0.0656402794429   , 0.0582957893968   , 0.0566882206388   , 0.0663115987104   ,
 0.0918339635337   , 0.132025595755    , 0.178493845746    , 0.218328478342    ,
 0.23849153375     , 0.231602742482    , 0.201956268047    , 0.165402715659    ,
 0.138881425332    , 0.12750207331     , 0.122244023433    , 0.110612129812    ,
 0.0886978164542   , 0.0625610377487   , 0.0402132916397   , 0.0252308485137   ,
 0.0172994411618   , 0.0152347360753   , 0.0180117277685   , 0.0246557450764   ,
 0.0349050826219   , 0.0496035045344   , 0.068724128082    , 0.0885564635231   ,
 0.1032138938      , 0.110955825131    , 0.116497462826    , 0.123587679818    ,
 0.127738038707    , 0.121150483672    , 0.103632349472    , 0.0842918815517   ,
 0.073184630122    , 0.0745823795891   , 0.0882397365272   , 0.116373563907    ,
 0.170481499174    , 0.268401504598    , 0.415501739767    , 0.584679778645    ,
 0.725557335521    , 0.807354029878    , 0.853565163375    , 0.930679643281    ,
 1.10933662964     , 1.44109496911     , 1.96033407996     , 2.69234120408     ,
 3.66069254406     , 4.90647629134     , 6.52487657255     , 8.70192009607     ,
 11.7239506206     , 15.9303974581     , 21.5971925911     , 28.8070523343     ,
 37.3797471455     , 46.8040444935     , 56.0999731745     , 63.8265834479     ,
 68.5150033417     , 69.3080429298     , 66.2633855101     , 60.1744439241     ,
 52.2132889187     , 43.6281668724     , 35.5007939107     , 28.5590681163     ,
 23.1052664395     , 19.072811048      , 16.1459177724     , 13.8927498697     ,
 11.9087374302     , 9.94141505475     , 7.93642125821     , 5.98723398529     ,
 4.23892573566     , 2.80901957292     , 1.74877539639     , 1.03761164454     ,
 0.603515418477    , 0.358711431743    , 0.22813278401     , 0.158030970275    ,
 0.113987042329    , 0.0789422970074   , 0.0494032909974   , 0.0274568844022   ,
 0.0138531985      , 0.00662404286702  , 0.00311819235966  , 0.00153271631944  ,
 0.000934583360093 , 0.000792476616346 , 0.000753828943242 , 0.000644397892292 ,
 0.000466476681816 , 0.000327635972712 , 0.000401706385109 , 0.00105178436997  ,
 0.0031149960898   , 0.00807434545273  , 0.0175013082718   , 0.0313125149634   ,
 0.0458682267731   , 0.0546700869263   , 0.0528388934665   , 0.0415926145607   ,
 0.0275718865008   , 0.017535951385    , 0.0138936926263   , 0.0144351201823   ,
 0.0151628611534   , 0.0135052495813   , 0.00966574951629  , 0.00549055202499  ,
 0.00247067768671  , 0.00088650653597  , 0.0002856954551   , 0.000218438339718 ,
 0.000570040107694 , 0.00152549216571  , 0.00328078008025  , 0.00558329951248  ,
 0.00750564973586  , 0.00795999210001  , 0.00665092723635  , 0.00437403627919  ,
 0.00226869722206  , 0.000949838131782 , 0.000383219490948 , 0.000299534301137 ,
 0.000546875270979 , 0.0011792641177   , 0.0023779734616   , 0.00426280624756  ,
 0.00662454598666  , 0.00882428926285  , 0.0102613937315   , 0.011334518722    ,
 0.0139328405521   , 0.0203409158942   , 0.0306890395595   , 0.0412271057974   ,
 0.0464420243209   , 0.044496800057    , 0.0406754450263   , 0.0449485742537   ,
 0.0657133875231   , 0.10376968344     , 0.149703447759    , 0.188165306267    ,
 0.208500212165    , 0.212135014946    , 0.207783325505    , 0.200741128976    ,
 0.190351708286    , 0.176115293555    , 0.160713287029    , 0.14682044079     ,
 0.135059926399    , 0.125346776954    , 0.117197159703    , 0.108330853518    ,
 0.0953295188621   , 0.0772560438382   , 0.0582637449792   , 0.0455513494442   ,
 0.044501800484    , 0.0557456088071   , 0.145638530765    , 0.174679383938    ,
 0.188685804868    , 0.18258316755     , 0.163996824641    , 0.145044531328    ,
 0.131346063211    , 0.122631300125    , 0.121603695289    , 0.136920822399    ,
 0.176156009876    , 0.236787858073    , 0.304046022207    , 0.357285060221    ,
 0.379819252466    , 0.366598184926    , 0.326918214968    , 0.28002516495     ,
 0.243553018723    , 0.221911941304    , 0.205337095291    , 0.181521172389    ,
 0.147896209684    , 0.111711440622    , 0.0807282996706   , 0.0578411820582   ,
 0.0435990662149   , 0.0389862578277   , 0.0441569338385   , 0.0569360938123   ,
 0.0742954788073   , 0.0944872508522   , 0.116331204929    , 0.136893518668    ,
 0.152813620414    , 0.165568036393    , 0.181553184473    , 0.202243915449    ,
 0.217342083836    , 0.214413294406    , 0.194363724331    , 0.172085041814    ,
 0.163124687164    , 0.173701578289    , 0.202276740301    , 0.249387082258    ,
 0.328535425363    , 0.464820359915    , 0.671511762264    , 0.922573468754    ,
 1.16050969574     , 1.34736906996     , 1.50961443483     , 1.73080871972     ,
 2.10984651852     , 2.72977507168     , 3.64824063846     , 4.89798289048     ,
 6.50122879182     , 8.51110253054     , 11.0693175988     , 14.4400030832     ,
 18.9811507592     , 25.0319680885     , 32.731765439      , 41.8865812126     ,
 52.0065296033     , 62.3894041858     , 72.0208407465     , 79.4687554916     ,
 83.2162758771     , 82.3656126901     , 77.1172770251     , 68.6916859498     ,
 58.8545544205     , 49.3129017211     , 41.2120213796     , 34.9474793785     ,
 30.3283470005     , 26.888863357      , 24.1216937869     , 21.5795530171     ,
 18.9257861526     , 15.9961073213     , 12.8446352226     , 9.70820600347     ,
 6.88198199027     , 4.58508322666     , 2.89544051592     , 1.76259685106     ,
 1.06255554841     , 0.657674729441    , 0.434036277825    , 0.309307161365    ,
 0.22861901437     , 0.163292645232    , 0.107033653367    , 0.0637109369497   ,
 0.0352515021509   , 0.0186983137773   , 0.00969883983365  , 0.00523821441803  ,
 0.00354791507356  , 0.00324657613915  , 0.00318466329852  , 0.00275785237344  ,
 0.00201326061811  , 0.0013763259725   , 0.00139750647286  , 0.00296118407776  ,
 0.00788947667548  , 0.0191916569188   , 0.0397563038852   , 0.0688973419227   ,
 0.0989048632079   , 0.116676362569    , 0.112506061519    , 0.0888747248174   ,
 0.05925858929     , 0.0376411801925   , 0.0293250080035   , 0.030045155689    ,
 0.0315637772417   , 0.0283315671401   , 0.020500512859    , 0.0117938509444   ,
 0.00538095094372  , 0.00195862305978  , 0.000636115031328 , 0.000468620834877 ,
 0.00119490519337  , 0.00318665257046  , 0.00684723182491  , 0.011648743309    ,
 0.0156574070244   , 0.0166053045577   , 0.0138783263902   , 0.00914106115965  ,
 0.00478147662771  , 0.00210224657008  , 0.00106316628496  , 0.00115567098557  ,
 0.00216123799261  , 0.00434862335984  , 0.00826359883371  , 0.0141975000159   ,
 0.0214342891857   , 0.0279466963875   , 0.0315625221127   , 0.0322841348761   ,
 0.0333281509415   , 0.0388737262924   , 0.0498565249538   , 0.0619156940554   ,
 0.0686707616092   , 0.068402429533    , 0.0677326268014   , 0.0784651333333   ,
 0.109881804066    , 0.16084973644     , 0.216648002461    , 0.256208877703    ,
 0.267805124257    , 0.258100105425    , 0.242684729356    , 0.22904891419     ,
 0.213183685587    , 0.190875972129    , 0.165757496991    , 0.145868895653    ,
 0.137178476273    , 0.140836007905    , 0.152427411465    , 0.162295659204    ,
 0.159854306975    , 0.141619558477    , 0.115790643117    , 0.0971165715373   ,
 0.096488541351    , 0.115164883201    , 0.273377529237    , 0.305940368964    ,
 0.3149599837      , 0.29917409975     , 0.272836005708    , 0.25221097904     ,
 0.241883495886    , 0.23786780324     , 0.240978745675    , 0.26192521075     ,
 0.312371256874    , 0.391270026426    , 0.47938453998     , 0.548073954495    ,
 0.575943747115    , 0.560069311097    , 0.514606581931    , 0.460336817247    ,
 0.412693627516    , 0.374494429276    , 0.338002042664    , 0.295427477699    ,
 0.247534114288    , 0.200840306769    , 0.159370446568    , 0.123900383792    ,
 0.0975961283376   , 0.0865235997913   , 0.093517248998    , 0.114520346911    ,
 0.141638282951    , 0.16810812849     , 0.190107984431    , 0.206143974008    ,
 0.217883994       , 0.232098766904    , 0.256990380761    , 0.291322972608    ,
 0.320040036011    , 0.327993172576    , 0.317598982411    , 0.307789487598    ,
 0.317527442946    , 0.35397785089     , 0.413330212525    , 0.49182487122     ,
 0.601591486602    , 0.774845578002    , 1.04077319615     , 1.39215098306     ,
 1.7850587767      , 2.18438814555     , 2.61148845366     , 3.15078474685     ,
 3.92315145508     , 5.05234699046     , 6.6338733013      , 8.72013608733     ,
 11.3480531873     , 14.6102672577     , 18.7232592994     , 24.0298777345     ,
 30.9101291718     , 39.6060060309     , 49.9966925354     , 61.4765090644     ,
 73.1073805832     , 83.8910725671     , 92.7910221381     , 98.5810215318     ,
 100.038822432     , 96.5751146223     , 88.7517202559     , 78.2427967618     ,
 67.2581913556     , 57.7102555062     , 50.5552465079     , 45.6888837271     ,
 42.3553788469     , 39.665703905      , 36.9102426857     , 33.6455609237     ,
 29.6782452436     , 25.0486662974     , 20.0315446091     , 15.0825810126     ,
 10.6818602922     , 7.15268492332     , 4.58027010806     , 2.85516444232     ,
 1.77425258996     , 1.13114159838     , 0.762010832091    , 0.548737583635    ,
 0.40962621127     , 0.298873485228    , 0.204027547961    , 0.129443921499    ,
 0.0777845139646   , 0.044950237528    , 0.025181817321    , 0.014731173825    ,
 0.0109228971551   , 0.0106214457316   , 0.0106778238805   , 0.00936764883963  ,
 0.00693238709524  , 0.00473889347082  , 0.00428328273903  , 0.00737080413237  ,
 0.0172232717035   , 0.038702721023    , 0.0757346112929   , 0.1258776         ,
 0.175781921535    , 0.204420911536    , 0.196562260974    , 0.156205726424    ,
 0.105127436133    , 0.0666546120638   , 0.050477220763    , 0.0503040773974   ,
 0.052548934135    , 0.0474862595566   , 0.0347542683496   , 0.0202620375627   ,
 0.00937779698955  , 0.00346517485504  , 0.0011390672954   , 0.000813014462618 ,
 0.00200481868593  , 0.00529527274088  , 0.0113370459491   , 0.0192575907104   ,
 0.0258692662683   , 0.0274344846434   , 0.0229495113696   , 0.0151862602132   ,
 0.00813692754249  , 0.00402977051192  , 0.00289451987964  , 0.00401905312925  ,
 0.00726485570115  , 0.0134368214509   , 0.0238138728916   , 0.0389250935458   ,
 0.056877650596    , 0.0727289364855   , 0.0810286202881   , 0.0807073816488   ,
 0.0771407234172   , 0.0779228985937   , 0.0861236129802   , 0.0979263590847   ,
 0.107034288393    , 0.111665078923    , 0.117762951248    , 0.135874178869    ,
 0.17362656733     , 0.227397995542    , 0.279483915992    , 0.307798910092    ,
 0.303859807364    , 0.280572786005    , 0.258516072622    , 0.245528223798    ,
 0.233488316923    , 0.213139599406    , 0.186541593662    , 0.16532755779     ,
 0.161486804394    , 0.17969910141     , 0.213323211978    , 0.245325526817    ,
 0.257128597785    , 0.242558642019    , 0.214637390659    , 0.196118252839    ,
 0.202307412114    , 0.23253584458     , 0.522173258163    , 0.548117308765    ,
 0.535100344792    , 0.494877666394    , 0.454891501752    , 0.436001762046    ,
 0.438098996966    , 0.448557339553    , 0.461288012557    , 0.485780386954    ,
 0.538709165381    , 0.624860189145    , 0.724160133796    , 0.800643933336    ,
 0.828348533775    , 0.808484421107    , 0.761763162642    , 0.708244910481    ,
 0.655619578283    , 0.601090689388    , 0.53997349458     , 0.473374588796    ,
 0.408141710105    , 0.348677931764    , 0.292312325675    , 0.237074967256    ,
 0.19098906639     , 0.167731415678    , 0.173595803024    , 0.201948428392    ,
 0.238997764336    , 0.271929690391    , 0.293120618221    , 0.30168925836     ,
 0.304354086856    , 0.313707081068    , 0.340588846642    , 0.383210322373    ,
 0.425566468301    , 0.452883158911    , 0.468749375297    , 0.493122241533    ,
 0.546023902277    , 0.635306521755    , 0.75445958704     , 0.892157122154    ,
 1.05437820587     , 1.28007467381     , 1.62484826371     , 2.12261128953     ,
 2.76800608992     , 3.5409086716      , 4.44984622789     , 5.56490115617     ,
 7.02590691582     , 9.01104887989     , 11.6732207761     , 15.1048028871     ,
 19.3863575688     , 24.686150132      , 31.3080289332     , 39.6217533532     ,
 49.9051366911     , 62.1450843884     , 75.8167335358     , 89.7822194519     ,
 102.538540239     , 112.70226845      , 119.262110878     , 121.486291317     ,
 118.92920785      , 111.774162724     , 101.1718428       , 89.1671303563     ,
 78.1106733282     , 69.7662041382     , 64.6378272476     , 61.9915065581     ,
 60.4560828136     , 58.6737055974     , 55.6820307599     , 51.0491320007     ,
 44.8437850264     , 37.5071182489     , 29.7115516449     , 22.2234402586     ,
 15.7188786445     , 10.5940014941     , 6.89611131593     , 4.41161379275     ,
 2.82365438578     , 1.83999096119     , 1.24439842387     , 0.885080028736    ,
 0.652555891355    , 0.478528724262    , 0.337091915754    , 0.226664169779    ,
 0.146755751017    , 0.0912883476844   , 0.0546065275651   , 0.0342581838088   ,
 0.0273525243723   , 0.0278188052295   , 0.0285037168947   , 0.0253503004708   ,
 0.0191188382643   , 0.0133243023495   , 0.011377534394    , 0.0163409311977   ,
 0.0328187634084   , 0.0671311696879   , 0.123036997794    , 0.194790248415    ,
 0.263179980093    , 0.300942763599    , 0.288878037417    , 0.231903596329    ,
 0.158291667396    , 0.100082147692    , 0.072450364876    , 0.0686195083474   ,
 0.070468352149    , 0.063918373913    , 0.047303586785    , 0.0279556674659   ,
 0.0131305279656   , 0.00493813790194  , 0.00167595306217  , 0.00120586388071  ,
 0.00279845306081  , 0.00714173974429  , 0.0150555653984   , 0.025399996025    ,
 0.0340271548634   , 0.0360737653779   , 0.0302660711169   , 0.0203230673522   ,
 0.0116506620537   , 0.00741757031891  , 0.00790407726206  , 0.012381963326    ,
 0.0209934549263   , 0.0354023729869   , 0.0579477958339   , 0.0893156202054   ,
 0.125545800155    , 0.157084188534    , 0.173447600281    , 0.171900632453    ,
 0.161030282744    , 0.153733755023    , 0.156967311108    , 0.168742364174    ,
 0.183157127262    , 0.196828553649    , 0.211709110342    , 0.23354419469     ,
 0.266512997387    , 0.305959644772    , 0.3362704639      , 0.341079615419    ,
 0.319422860188    , 0.28944450493     , 0.272246569291    , 0.2723455261      ,
 0.276076264442    , 0.268134495055    , 0.247517155566    , 0.228794896458    ,
 0.230973572284    , 0.263804929875    , 0.31927910972     , 0.373619785977    ,
 0.402025294329    , 0.398386890846    , 0.382083023154    , 0.382254116434    ,
 0.414051024104    , 0.468892399326    , 0.986219341943    , 0.999455254924    ,
 0.945019944094    , 0.85976920012     , 0.79488037671     , 0.77835525518     ,
 0.801212578786    , 0.835572344878    , 0.862161194641    , 0.885626813586    ,
 0.928666553812    , 1.00594026781     , 1.09899697294     , 1.16394389776     ,
 1.17060580898     , 1.12890689264     , 1.07197918249     , 1.02089553552     ,
 0.971887540435    , 0.910709172552    , 0.831481667426    , 0.742432301291    ,
 0.655954578945    , 0.574616704723    , 0.491108081535    , 0.404238516625    ,
 0.329465097023    , 0.287976205757    , 0.287740110957    , 0.318375002351    ,
 0.360788856211    , 0.397555891859    , 0.417580730982    , 0.418988820495    ,
 0.411354849884    , 0.412378966305    , 0.437090706314    , 0.486079235918    ,
 0.54486504155     , 0.599510171506    , 0.653682583092    , 0.728156705994    ,
 0.846317354392    , 1.02026664457     , 1.24250333877     , 1.49160807102     ,
 1.76190484993     , 2.09676403167     , 2.58636806116     , 3.32539453475     ,
 4.36899700893     , 5.72338571806     , 7.38234412546     , 9.39970818688     ,
 11.9469784573     , 15.2826880334     , 19.6452699672     , 25.1955840389     ,
 32.090450031      , 40.5929683618     , 51.0528014501     , 63.726891515      ,
 78.5769626192     , 95.1257242264     , 112.30605647      , 128.382181209     ,
 141.259231208     , 149.193376554     , 151.361120354     , 147.889933358     ,
 139.599401321     , 127.847184587     , 114.496845861     , 101.776828852     ,
 91.8117849153     , 85.8623905504     , 83.7644916163     , 84.0753124171     ,
 84.7777432458     , 83.9869893581     , 80.4169939605     , 73.6545631167     ,
 64.1790086336     , 53.0691273621     , 41.5933264887     , 30.9076112605     ,
 21.861787429      , 14.8629260356     , 9.85854797955     , 6.48006518188     ,
 4.26335307711     , 2.82031648456     , 1.89115794538     , 1.30414497688     ,
 0.929197821725    , 0.672450713947    , 0.483761758774    , 0.343064320688    ,
 0.238078655505    , 0.158306066147    , 0.100430084338    , 0.0667972030908   ,
 0.0561352389932   , 0.0586388402765   , 0.0609052540915   , 0.0549976422982   ,
 0.0425335168772   , 0.0306790247347   , 0.0258303767626   , 0.0322092853291   ,
 0.0549939449925   , 0.100939080064    , 0.172433761795    , 0.259803621454    ,
 0.339673390661    , 0.382530694854    , 0.367945326541    , 0.299965626797    ,
 0.208603019401    , 0.131359181813    , 0.0892813207638   , 0.0778174754758   ,
 0.0770594580865   , 0.0697550635717   , 0.0521531831715   , 0.0312547922797   ,
 0.0149222965788   , 0.00577764854318  , 0.00218313082814  , 0.0018164857775   ,
 0.00374333653138  , 0.00850741015304  , 0.0168580219569   , 0.0276156201776   ,
 0.0365408595232   , 0.0386558831268   , 0.0327590918195   , 0.0230204733836   ,
 0.0156284036898   , 0.0145812019281   , 0.0206780673778   , 0.0332867423892   ,
 0.0526564607575   , 0.0811406524453   , 0.122056430933    , 0.175995660601    ,
 0.236386514348    , 0.288392946253    , 0.316027306579    , 0.315006127052    ,
 0.297913997857    , 0.283973536693    , 0.284864985363    , 0.300744861257    ,
 0.325172182704    , 0.350583237306    , 0.371793712475    , 0.387858044394    ,
 0.400157570671    , 0.406745467952    , 0.400059831665    , 0.374629534903    ,
 0.338251523482    , 0.311455793047    , 0.311770746256    , 0.337644500727    ,
 0.368509485132    , 0.381998097531    , 0.373563515627    , 0.361432827565    ,
 0.372846805054    , 0.423048553429    , 0.502377096695    , 0.58101021863     ,
 0.630962133206    , 0.650409315855    , 0.66723495621     , 0.715040404049    ,
 0.803494024868    , 0.90856040813     , 1.74090031994     , 1.74690635458     ,
 1.6439540593      , 1.5028084371      , 1.40743704004     , 1.39512708073     ,
 1.44369985769     , 1.5043996933      , 1.54157041891     , 1.55473942716     ,
 1.57401807582     , 1.62503897198     , 1.69015587518     , 1.7154767299      ,
 1.66650551798     , 1.56631698808     , 1.46832165823     , 1.40198228376     ,
 1.35528885159     , 1.29968045284     , 1.21939916493     , 1.11856948278     ,
 1.0074380044      , 0.887693995655    , 0.755996395949    , 0.620990356112    ,
 0.508520764957    , 0.444240678602    , 0.433510407004    , 0.460347059298    ,
 0.501415225828    , 0.537224308477    , 0.555060049111    , 0.551661751011    ,
 0.537694810736    , 0.535297329482    , 0.564821760744    , 0.629862950962    ,
 0.715157334212    , 0.803555198298    , 0.897659420545    , 1.02393346856     ,
 1.21781985849     , 1.50368140216     , 1.87808456708     , 2.31056377474     ,
 2.77960386941     , 3.32625882808     , 4.07403211753     , 5.18826366258     ,
 6.80169381906     , 8.96241423792     , 11.6626291775     , 14.9596704062     ,
 19.0882520991     , 24.4245806175     , 31.3288624746     , 40.0637839106     ,
 50.8814435057     , 64.1090772775     , 80.0175742039     , 98.5226784451     ,
 118.99221977      , 140.252480547     , 160.58103526      , 177.663421959     ,
 188.937913482     , 192.514020568     , 188.060559364     , 176.934389528     ,
 161.565306654     , 144.67962648      , 128.816821445     , 116.142841142     ,
 108.21812546      , 105.514476678     , 107.051104534     , 110.649251503     ,
 113.662438512     , 113.679647949     , 109.082561198     , 99.5160146558     ,
 85.9926157386     , 70.3923261858     , 54.6955117553     , 40.4681168432     ,
 28.6841298889     , 19.6972477796     , 13.3066574234     , 8.95792564738     ,
 6.02430172246     , 4.02292084662     , 2.66375767771     , 1.7713770764      ,
 1.20596926268     , 0.849032929023    , 0.617374157951    , 0.459269382695    ,
 0.340096285292    , 0.240617797003    , 0.160931504131    , 0.111592637417    ,
 0.0957514248401   , 0.100560307394    , 0.105297180204    , 0.0968437147791   ,
 0.0774050975753   , 0.0584622495679   , 0.0497894408903   , 0.055996047063    ,
 0.0813424573674   , 0.132037754655    , 0.209452059927    , 0.301821701806    ,
 0.384734873432    , 0.429804084307    , 0.416731496545    , 0.346365171008    ,
 0.245711466827    , 0.153952762638    , 0.0973844723411   , 0.0758335143396   ,
 0.0706583192355   , 0.0633548959259   , 0.0478537765791   , 0.0291548311865   ,
 0.0142576490349   , 0.00593510469617  , 0.00304926331699  , 0.00356671364623  ,
 0.00637929181821  , 0.0114804475441   , 0.0191544524583   , 0.0283946825646   ,
 0.0358439270879   , 0.0375287400019   , 0.0327610543472   , 0.0258580770772   ,
 0.023473489142    , 0.0306159252187   , 0.0488941898202   , 0.077430576456    ,
 0.115489891676    , 0.164873781834    , 0.229038507664    , 0.308258189905    ,
 0.393958836612    , 0.46750152407     , 0.509135606629    , 0.514128543179    ,
 0.499009819282    , 0.488257863467    , 0.496715571552    , 0.524842066206    ,
 0.563289268413    , 0.59796892369     , 0.615925058347    , 0.611471740642    ,
 0.586996343058    , 0.547813163276    , 0.498023985071    , 0.443350365974    ,
 0.397217697488    , 0.379227470076    , 0.402523542405    , 0.46043143925     ,
 0.526218524712    , 0.570667177696    , 0.586037603521    , 0.594310850159    ,
 0.629891663084    , 0.711805667108    , 0.827950179882    , 0.943124351061    ,
 1.02756205972     , 1.08501687925     , 1.15273462368     , 1.26944483115     ,
 1.43936448278     , 1.62004456666     , 2.79654749622     , 2.80801547553     ,
 2.6732282156      , 2.49496417204     , 2.38724599891     , 2.39162994475     ,
 2.46770466647     , 2.54532573038     , 2.57757277772     , 2.56447805061     ,
 2.54379678314     , 2.54771531354     , 2.55644133802     , 2.50755159676     ,
 2.36492206606     , 2.16600757981     , 1.98686918737     , 1.87209153768     ,
 1.81007656354     , 1.76136858041     , 1.69323179254     , 1.59089279787     ,
 1.45062170832     , 1.27355309335     , 1.0709032809      , 0.871410068881    ,
 0.713758165904    , 0.624524601046    , 0.60254073644     , 0.6243027526      ,
 0.661754004488    , 0.69419668868     , 0.70960801826     , 0.70570529178     ,
 0.69497070355     , 0.703140913265    , 0.754389223206    , 0.852711798016    ,
 0.977467608703    , 1.10372588542     , 1.23317591426     , 1.40457884862     ,
 1.67443026034     , 2.0867943291      , 2.64948525211     , 3.33060095308     ,
 4.09478795538     , 4.97191284134     , 6.10536238187     , 7.72721579017     ,
 10.0619455453     , 13.2302649842     , 17.2645973726     , 22.2715602354     ,
 28.5891639354     , 36.7407645747     , 47.2326761219     , 60.4475144495     ,
 76.716107686      , 96.3362199482     , 119.311756149     , 144.959208717     ,
 171.776937608     , 197.669879416     , 220.166904284     , 236.477144804     ,
 243.869203198     , 240.717792363     , 227.586882552     , 207.346200386     ,
 184.144351214     , 162.014815834     , 143.984867255     , 131.903225631     ,
 126.512382389     , 127.308298398     , 132.41153029      , 138.926518689     ,
 143.672943762     , 143.856329144     , 137.674063317     , 124.932068931     ,
 107.205726683     , 87.1414767238     , 67.3638385788     , 49.7755699543     ,
 35.415599753      , 24.5519825126     , 16.8314190219     , 11.5266060225     ,
 7.86538397757     , 5.28343291781     , 3.46791212004     , 2.24449892764     ,
 1.46911228981     , 1.00332612939     , 0.731429016499    , 0.565841835963    ,
 0.443446809376    , 0.331441875365    , 0.231600510353    , 0.163958011314    ,
 0.138969130378    , 0.14349615763     , 0.150836115128    , 0.142167159717    ,
 0.118592092273    , 0.0943933635744   , 0.0818937410803   , 0.0852140619526   ,
 0.106435312069    , 0.150830046171    , 0.220773770342    , 0.306352756553    ,
 0.38541271797     , 0.431596403236    , 0.423999587133    , 0.359055567232    ,
 0.258833526288    , 0.161421312721    , 0.0961630826859   , 0.0670942724738   ,
 0.0583791293823   , 0.0519106435952   , 0.0398910024855   , 0.0249661831357   ,
 0.0128222543751   , 0.00640804917911  , 0.00551066376156  , 0.00874957805677  ,
 0.0147079120774   , 0.0221665353551   , 0.0302706682941   , 0.0380856746234   ,
 0.0436045862838   , 0.0444037625578   , 0.040693121258    , 0.0374210890333   ,
 0.0425087831398   , 0.0628450269895   , 0.101198773577    , 0.155719316438    ,
 0.222800824921    , 0.301317197356    , 0.393111999174    , 0.498048919076    ,
 0.607642811704    , 0.703151242373    , 0.764524169475    , 0.787752029635    ,
 0.791464573838    , 0.801638302045    , 0.832338445722    , 0.880917643467    ,
 0.932283925387    , 0.964854023586    , 0.96084807396     , 0.916353311396    ,
 0.841599796165    , 0.752990585754    , 0.665086886284    , 0.588680897903    ,
 0.535891307639    , 0.523306889334    , 0.563435822666    , 0.650024220009    ,
 0.754492704454    , 0.843991366307    , 0.909198509045    , 0.973617358643    ,
 1.07291252729     , 1.22451384905     , 1.41221152292     , 1.59516339005     ,
 1.73861907188     , 1.84623858468     , 1.96219451877     , 2.13538403287     ,
 2.37455526583     , 2.62678535723     , 4.12827827516     , 4.14484519757     ,
 4.00757127761     , 3.83838768089     , 3.76235224835     , 3.8091437051      ,
 3.91393816823     , 3.99165453077     , 3.99807067972     , 3.94254956647     ,
 3.86551083294     , 3.79408601044     , 3.70419820873     , 3.53658833993     ,
 3.26551624681     , 2.94231206585     , 2.65702546062     , 2.46556331036     ,
 2.36173867563     , 2.30146785332     , 2.23457648869     , 2.12072559464     ,
 1.93702139376     , 1.68578115934     , 1.39848206153     , 1.12714686435     ,
 0.922270326127    , 0.80938256664     , 0.780023214339    , 0.802168430298    ,
 0.840626268533    , 0.871995942165    , 0.887398258897    , 0.890589104032    ,
 0.898237352928    , 0.936350912462    , 1.02684788534     , 1.17015388004     ,
 1.33979145375     , 1.50469274718     , 1.66814713605     , 1.8832401936      ,
 2.22743667035     , 2.76426101227     , 3.5188690936      , 4.47269511344     ,
 5.58992784713     , 6.88661380633     , 8.50663767256     , 10.7320116486     ,
 13.8900043055     , 18.2244691248     , 23.8851128089     , 31.0982011372     ,
 40.3380142451     , 52.2687408099     , 67.5191723908     , 86.5592148505     ,
 109.730709721     , 137.170665068     , 168.433641514     , 202.040121722     ,
 235.420235842     , 265.371314762     , 288.591298982     , 301.970332659     ,
 303.034524708     , 290.964605185     , 267.629606691     , 237.534890879     ,
 206.40231854      , 179.292895244     , 159.440331578     , 148.158083791     ,
 145.225054595     , 149.082244868     , 156.940337067     , 165.258930899     ,
 170.507822022     , 169.803445956     , 161.46487942      , 145.609016912     ,
 124.27703503      , 100.619008921     , 77.6429053087     , 57.4332413413     ,
 41.0436584096     , 28.6691916463     , 19.8471077484     , 13.7308845617     ,
 9.44906378301     , 6.37925784475     , 4.18562451229     , 2.68552136876     ,
 1.7270000427      , 1.1584162531      , 0.843482593917    , 0.668349084034    ,
 0.544519517687    , 0.423412337555    , 0.304856972479    , 0.216629122565    ,
 0.177754341768    , 0.178204669873    , 0.188384262313    , 0.183854887289    ,
 0.161463096496    , 0.134796590206    , 0.117539401598    , 0.113871876137    ,
 0.123932746031    , 0.151989189033    , 0.202929915267    , 0.271906556004    ,
 0.341219697276    , 0.386200044679    , 0.384746473126    , 0.330026667486    ,
 0.239973659961    , 0.149448506073    , 0.0870474058334   , 0.0585351518989   ,
 0.050541740425    , 0.0461209979699   , 0.0368255316721   , 0.0241364362492   ,
 0.0135146844762   , 0.00888939006282  , 0.0115290280804   , 0.0209714778533   ,
 0.0351354844981   , 0.0504931010972   , 0.0637813676619   , 0.0733755740076   ,
 0.0783174008198   , 0.0775705830176   , 0.072580739571    , 0.0702988634776   ,
 0.0818742136342   , 0.117618333032    , 0.182154170398    , 0.272449471754    ,
 0.380590100487    , 0.499879309379    , 0.62799101176     , 0.763925530519    ,
 0.902043207701    , 1.02842309718     , 1.12668265743     , 1.19309413474     ,
 1.24276970816     , 1.29568051697     , 1.36001844618     , 1.4282940974      ,
 1.47957526933     , 1.48627907238     , 1.4309483058      , 1.32028344406     ,
 1.18103086494     , 1.0439965312      , 0.929282611816    , 0.842012808611    ,
 0.7840662765      , 0.768506433359    , 0.814120523941    , 0.923528608591    ,
 1.073245904       , 1.23240749996     , 1.39249743971     , 1.57431772121     ,
 1.80531403179     , 2.09297611412     , 2.41323198956     , 2.71605606742     ,
 2.95267365176     , 3.11496766653     , 3.24982730571     , 3.42510312859     ,
 3.67093472477     , 3.94091714621     , 5.77582382424     , 5.76134326872     ,
 5.62692858092     , 5.50056895294     , 5.49403343697     , 5.60524227291     ,
 5.73987087767     , 5.80768947734     , 5.78130517775     , 5.6825078382      ,
 5.5408020005      , 5.36137216128     , 5.1161568313      , 4.7706214369      ,
 4.33278450288     , 3.87165360559     , 3.47618094978     , 3.1971539711      ,
 3.02744932787     , 2.92004237678     , 2.81209155647     , 2.6450367739      ,
 2.38648716787     , 2.04692037264     , 1.67667393751     , 1.34268999727     ,
 1.09964847123     , 0.970226781096    , 0.940462869085    , 0.970267438126    ,
 1.01523046122     , 1.04812409485     , 1.06661244855     , 1.0865308731      ,
 1.13044861775     , 1.21810178867     , 1.3596382708      , 1.54858467945     ,
 1.75835503932     , 1.9608062625      , 2.16483679932     , 2.43250046329     ,
 2.85057160497     , 3.49315364499     , 4.40633238815     , 5.60383057253     ,
 7.07378785121     , 8.82904038869     , 10.9999838627     , 13.8953707298     ,
 17.9489644396     , 23.5841441833     , 31.1614294945     , 41.1044570834     ,
 54.040029898      , 70.7266345629     , 91.8348100071     , 117.825996394     ,
 148.939201985     , 185.018746839     , 225.048498619     , 266.669107859     ,
 306.169340785     , 339.143401801     , 361.417606384     , 369.741835713     ,
 362.350767798     , 339.767627039     , 305.486931506     , 265.589644296     ,
 227.019331802     , 195.451823188     , 174.031466056     , 163.395209191     ,
 162.321955065     , 168.220860074     , 177.46940537      , 186.032047337     ,
 190.280392031     , 187.59156785      , 176.741848224     , 158.281527768     ,
 134.522807351     , 108.728130392     , 83.9339459293     , 62.2235098294     ,
 44.6353022586     , 31.3352746993     , 21.8155701609     , 15.176019951      ,
 10.500052029      , 7.13542951531     , 4.72379395251     , 3.06225831004     ,
 1.98464336387     , 1.33333058778     , 0.968944043811    , 0.769830356391    ,
 0.634043667197    , 0.500810710507    , 0.365744173793    , 0.260221680511    ,
 0.209490092374    , 0.207507397122    , 0.223896733308    , 0.228454073554    ,
 0.210610866401    , 0.180374317706    , 0.153374118843    , 0.136916781662    ,
 0.13115366749     , 0.138733647386    , 0.165798964176    , 0.212536055241    ,
 0.266379519617    , 0.304998692025    , 0.306697616816    , 0.264100404646    ,
 0.192263435915    , 0.120651568466    , 0.0731992970465   , 0.0545421493464   ,
 0.0526433407984   , 0.0516664635899   , 0.0433824608061   , 0.0298334639425   ,
 0.0181407007179   , 0.0145661604384   , 0.0226620369692   , 0.0432788905145   ,
 0.073319756775    , 0.105512532055    , 0.132167036811    , 0.149333705139    ,
 0.156186656125    , 0.152707065845    , 0.142049362995    , 0.134840660265    ,
 0.147662527834    , 0.19601602872     , 0.287782179808    , 0.42014393172     ,
 0.581483499772    , 0.758255367566    , 0.941374865779    , 1.1273722097      ,
 1.31495593999     , 1.49951567266     , 1.6720624676      , 1.82632342539     ,
 1.9627357094      , 2.08216787558     , 2.18088449605     , 2.24965784017     ,
 2.26881853452     , 2.21112723196     , 2.06479707141     , 1.8532582508      ,
 1.62644036464     , 1.43315368415     , 1.29579007091     , 1.20514751319     ,
 1.14566117259     , 1.12662781523     , 1.17879017777     , 1.32065667113     ,
 1.53973125151     , 1.81126120229     , 2.12795671159     , 2.50322139936     ,
 2.94896788228     , 3.45662336585     , 3.98881254844     , 4.47705168005     ,
 4.84439836144     , 5.05923130932     , 5.17077382101     , 5.27657515611     ,
 5.44223557846     , 5.64208499337     , 7.90496819691     , 7.78548419636     ,
 7.60309836604     , 7.49013422075     , 7.53510344546     , 7.69744138575     ,
 7.85502114326     , 7.91814022275     , 7.87635966102     , 7.75229514004     ,
 7.54552430119     , 7.22587618262     , 6.76515783536     , 6.17496048493     ,
 5.5217220107      , 4.90140897175     , 4.39092616821     , 4.01692293456     ,
 3.75763760639     , 3.55903527467     , 3.35144593013     , 3.07355804259     ,
 2.70244079438     , 2.266925059       , 1.8304790757      , 1.45943253864     ,
 1.19979173119     , 1.06725500296     , 1.04383174537     , 1.08337227884     ,
 1.13346062026     , 1.16503436446     , 1.18620594553     , 1.22904261371     ,
 1.32239501286     , 1.47431023311     , 1.67572602261     , 1.91076188888     ,
 2.15830508459     , 2.40197520052     , 2.65874993602     , 2.99060456204     ,
 3.47854112469     , 4.1973061788      , 5.21684662673     , 6.60069354133     ,
 8.38821764713     , 10.6113023435     , 13.3866610221     , 17.0294321043     ,
 22.0704768794     , 29.1455075895     , 38.8915904984     , 51.9814478698     ,
 69.1959639954     , 91.3400381401     , 119.042199306     , 152.641979778     ,
 192.141002617     , 236.959769393     , 285.426905019     , 334.301266959     ,
 378.791926901     , 413.356466685     , 433.023227089     , 434.580552168     ,
 417.313794768     , 383.46708924      , 338.323238206     , 289.339021879     ,
 244.224758398     , 208.826807148     , 185.957172493     , 175.532919146     ,
 175.389721554     , 182.011197151     , 191.113530764     , 198.40624503      ,
 200.435139421     , 195.103099556     , 181.840766758     , 161.653407525     ,
 136.907822444     , 110.616463084     , 85.5231084697     , 63.5492185941     ,
 45.7031832052     , 32.1725454721     , 22.4644952947     , 15.6803395038     ,
 10.9039321289     , 7.48004478794     , 5.03442383783     , 3.3408986025      ,
 2.21869873574     , 1.51229904606     , 1.09448600062     , 0.853550659597    ,
 0.689575523234    , 0.538947343158    , 0.394247965854    , 0.285374529471    ,
 0.237568149318    , 0.245188426003    , 0.27585317823     , 0.292685973044    ,
 0.276832706293    , 0.235573123721    , 0.189974143237    , 0.154790643447    ,
 0.132174442593    , 0.121494722394    , 0.126586409427    , 0.150022498939    ,
 0.184144756206    , 0.210939787329    , 0.212019193157    , 0.181559446449    ,
 0.131783459914    , 0.0850250854807   , 0.0585196631721   , 0.0544821232883   ,
 0.0615760110877   , 0.0648091590248   , 0.0564566778471   , 0.0400773472958   ,
 0.0256719377838   , 0.0228494351467   , 0.0382049894251   , 0.0744779290488   ,
 0.12761947042     , 0.185616785308    , 0.234339256546    , 0.265422808541    ,
 0.276995081464    , 0.269939494479    , 0.249673650903    , 0.231425436245    ,
 0.238344990686    , 0.292519617274    , 0.407172796118    , 0.582730348746    ,
 0.807099552183    , 1.06173049169     , 1.3300737486      , 1.60359584529     ,
 1.88364602436     , 2.17649472954     , 2.48282136557     , 2.7892078133      ,
 3.06622329274     , 3.27766637264     , 3.4002004444      , 3.43039654951     ,
 3.36583892379     , 3.19329070999     , 2.91161041858     , 2.5592881224      ,
 2.20836373585     , 1.92892420149     , 1.75031329579     , 1.6511923833      ,
 1.59800408421     , 1.59489040896     , 1.68391236645     , 1.89997566714     ,
 2.24211288391     , 2.690013545       , 3.2331451465      , 3.8738890047      ,
 4.60979734569     , 5.41915467401     , 6.2470231308      , 6.99111489614     ,
 7.52830080464     , 7.79632930722     , 7.85410113694     , 7.8401257327      ,
 7.86001764711     , 7.91000908803     , 10.7283151968     , 10.4190542046     ,
 10.0912024356     , 9.88999437989     , 9.89392789644     , 10.0414175982     ,
 10.1950006572     , 10.2616162932     , 10.2266163946     , 10.0880437079     ,
 9.80172958153     , 9.3042583849      , 8.57764127755     , 7.69027932422     ,
 6.77555136854     , 5.96037914357     , 5.30629770238     , 4.80754755209     ,
 4.42094405087     , 4.0847017892      , 3.72904614163     , 3.30254120175     ,
 2.80383435712     , 2.2833393212      , 1.80952224596     , 1.43445275297     ,
 1.18424952296     , 1.06254395462     , 1.04763776396     , 1.09107034179     ,
 1.13764540138     , 1.16079105134     , 1.18066005426     , 1.24509557482     ,
 1.38934954702     , 1.61140462721     , 1.88364271038     , 2.17865507743     ,
 2.47834061553     , 2.7774428991      , 3.09921430551     , 3.49952978287     ,
 4.04676733409     , 4.81422273515     , 5.89941639963     , 7.42521518403     ,
 9.5008290323      , 12.2022741341     , 15.6475619631     , 20.1484797739     ,
 26.3086492486     , 34.9613054196     , 47.0195739766     , 63.4045058292     ,
 85.0471993035     , 112.799357945     , 147.236281522     , 188.516737178     ,
 236.284626581     , 289.385531316     , 345.377423926     , 400.136623905     ,
 447.945394717     , 482.377983429     , 497.913839432     , 491.57695392      ,
 463.870096818     , 418.876923379     , 363.631746379     , 306.688534583     ,
 256.083473051     , 217.452733762     , 193.120526602     , 182.328752858     ,
 182.098109642     , 188.157237293     , 195.805708792     , 200.790092705     ,
 200.058281175     , 192.129541555     , 177.067754733     , 156.241611543     ,
 131.910975878     , 106.620169136     , 82.614410125      , 61.5330784352     ,
 44.3306738126     , 31.2469333714     , 21.850828223      , 15.2932325641     ,
 10.6983036463     , 7.43090760859     , 5.10971650328     , 3.49037723596     ,
 2.38557449295     , 1.65216145338     , 1.18529652432     , 0.893997158767    ,
 0.692489020672    , 0.524341379578    , 0.38214740652     , 0.290183305212    ,
 0.266789799623    , 0.300806720246    , 0.354018210845    , 0.381933054248    ,
 0.360071905138    , 0.297957469796    , 0.226629544474    , 0.170619534231    ,
 0.133976164468    , 0.110697156204    , 0.099158312235    , 0.101743650082    ,
 0.115315189531    , 0.127941492083    , 0.126429257697    , 0.106773415747    ,
 0.0775287883761   , 0.0534878455276   , 0.0455672843777   , 0.0541000099897   ,
 0.0687947481053   , 0.0756980198052   , 0.067553828284    , 0.049089542567    ,
 0.0327499467683   , 0.0312583013129   , 0.0542771707968   , 0.106731134014    ,
 0.184276642608    , 0.270857446217    , 0.345812096611    , 0.395264500051    ,
 0.415195670239    , 0.407066884256    , 0.378370471157    , 0.348177238076    ,
 0.345582887694    , 0.399866111386    , 0.531533490145    , 0.747452619898    ,
 1.04000908373     , 1.39158074908     , 1.78171512694     , 2.19518486121     ,
 2.63084412266     , 3.10162161984     , 3.61523419665     , 4.14488962296     ,
 4.61742153439     , 4.9430276494      , 5.07103729622     , 5.01226833831     ,
 4.80237576419     , 4.46184318684     , 4.00534074734     , 3.47648798237     ,
 2.95841793903     , 2.54382293932     , 2.28254187436     , 2.15660432093     ,
 2.12212941839     , 2.17540481539     , 2.36168592596     , 2.72476624572     ,
 3.26892149859     , 3.97011218921     , 4.80586984253     , 5.76648215894     ,
 6.84597472722     , 8.02234937855     , 9.22184815692     , 10.2901287528     ,
 11.038893897      , 11.3728846419     , 11.3727610785     , 11.2273316481     ,
 11.0790876712     , 10.9373144517     , 14.3019070794     , 13.7449002012     ,
 13.1796616145     , 12.771006669      , 12.611913659      , 12.6523623732     ,
 12.7577700723     , 12.8197263986     , 12.7864522699     , 12.6052351589     ,
 12.188180414      , 11.4590963806     , 10.4283878451     , 9.22058733306     ,
 8.02085185382     , 6.9740589419      , 6.12494334718     , 5.44258566023     ,
 4.87271029192     , 4.35669429711     , 3.83399158672     , 3.26653301151     ,
 2.66904900403     , 2.10181070397     , 1.62729786382     , 1.27707085047     ,
 1.05446321506     , 0.949697593943    , 0.938763041842    , 0.976236162663    ,
 1.01094646461     , 1.02197589998     , 1.03840672541     , 1.11838517561     ,
 1.30375793592     , 1.5910060464      , 1.94280606076     , 2.31956559645     ,
 2.69658925628     , 3.0692644186      , 3.46123655903     , 3.92244651256     ,
 4.51473608911     , 5.318165022       , 6.46122000638     , 8.1233333691      ,
 10.4849363476     , 13.6827323835     , 17.8596653586     , 23.329053567      ,
 30.7370580375     , 41.0567963601     , 55.4114685186     , 74.9195104837     ,
 100.655426111     , 133.567598807     , 174.250245896     , 222.707652146     ,
 278.160503915     , 338.736385996     , 401.069867474     , 460.098800616     ,
 509.325116231     , 541.791341237     , 551.833655281     , 536.981878274     ,
 499.011106595     , 443.718333302     , 379.638898119     , 316.087137688     ,
 261.067523139     , 219.746908898     , 193.891124746     , 182.162972777     ,
 180.94920838      , 185.452128375     , 190.830207149     , 193.129439125     ,
 189.822729355     , 179.967570975     , 164.071302106     , 143.708078495     ,
 120.953247888     , 97.8331012302     , 76.0244851592     , 56.8066308969     ,
 41.0272042753     , 28.9670959442     , 20.2865553901     , 14.2379928105     ,
 10.0314129383     , 7.07425473021     , 4.98473304611     , 3.5067318804      ,
 2.45835051182     , 1.72084991884     , 1.21861010334     , 0.884968375929    ,
 0.652394455269    , 0.475532533726    , 0.347984413432    , 0.286560119987    ,
 0.299793894987    , 0.367772292206    , 0.443809951156    , 0.476376978258    ,
 0.440161658245    , 0.352405284188    , 0.255979195224    , 0.18349040128     ,
 0.138742168502    , 0.109329869177    , 0.087406640512    , 0.0741041979126   ,
 0.0702364198834   , 0.0702155632941   , 0.066047520015    , 0.0547159002433   ,
 0.0406549625285   , 0.0321028431424   , 0.0353490695962   , 0.0501252205268   ,
 0.0680706185432   , 0.0770026885355   , 0.0701534825793   , 0.0522615393888   ,
 0.0364630883608   , 0.0370713974586   , 0.0656547669618   , 0.12867547851     ,
 0.22236021046     , 0.329576868247    , 0.426633159418    , 0.495709611106    ,
 0.529855596687    , 0.52936150728     , 0.501747187768    , 0.467599989533    ,
 0.460268319645    , 0.515861164675    , 0.662489656862    , 0.91487109862     ,
 1.2749970806      , 1.73554269956     , 2.28083702789     , 2.89077533985     ,
 3.55518067076     , 4.28215112473     , 5.07482012332     , 5.88431052498     ,
 6.58733193298     , 7.0344877313      , 7.14432536701     , 6.94752654794     ,
 6.53503413975     , 5.9805915245      , 5.32101490075     , 4.5935493459      ,
 3.87679079027     , 3.28388413316     , 2.89997860234     , 2.73066709859     ,
 2.73302243537     , 2.8927675565      , 3.24772311771     , 3.84000253723     ,
 4.66980967622     , 5.69883517075     , 6.88389471728     , 8.2044939752      ,
 9.66425251144     , 11.2537580372     , 12.8784722889     , 14.3164980793     ,
 15.3030794349     , 15.7149591056     , 15.6665219247     , 15.3999093046     ,
 15.0877258611     , 14.7446318997     , 18.3473583297     , 17.5325913042     ,
 16.6988044554     , 16.0257396218     , 15.6354647976     , 15.5136874752     ,
 15.5400898681     , 15.5777097291     , 15.5127597738     , 15.2288902083     ,
 14.6049383764     , 13.5778560025     , 12.2074946835     , 10.6717570711     ,
 9.1821400388      , 7.87683250068     , 6.78045102599     , 5.85275429008     ,
 5.04908492815     , 4.33053162187     , 3.65434273089     , 2.99180601148     ,
 2.35635979534     , 1.79691718305     , 1.35785678531     , 1.05048461339     ,
 0.860904868679    , 0.770488522686    , 0.756844245384    , 0.782808793411    ,
 0.805630687964    , 0.809375202161    , 0.825507834039    , 0.91513474667     ,
 1.12616165603     , 1.46209472791     , 1.88625492685     , 2.34951603383     ,
 2.81373186447     , 3.26434818134     , 3.71865667924     , 4.22368291732     ,
 4.8475041271      , 5.69034022501     , 6.91366707034     , 8.74081735414     ,
 11.4071290176     , 15.1082886707     , 20.0305036848     , 26.5056337375     ,
 35.2049717664     , 47.176135691      , 63.6600439801     , 85.8967874998     ,
 115.083791381     , 152.311440457     , 198.279421016     , 252.914273525     ,
 315.031657507     , 381.983785478     , 449.36947343      , 511.09605947      ,
 559.950085802     , 588.753436498     , 592.153886677     , 568.534090341     ,
 520.985001914     , 456.756339874     , 385.476164819     , 316.83598765      ,
 258.538896521     , 215.139592106     , 187.824231155     , 174.777262417     ,
 171.964184839     , 174.339717346     , 177.185391423     , 177.008597647     ,
 171.804266387     , 161.000734976     , 145.31202554      , 126.353546889     ,
 105.993809513     , 85.8039552341     , 66.9356076619     , 50.2808237884     ,
 36.5112153552     , 25.8992684497     , 18.2037546389     , 12.8274924267     ,
 9.11496257462     , 6.54107238725     , 4.73107157643     , 3.42242719083     ,
 2.44786749355     , 1.72220726383     , 1.20342496873     , 0.848774077126    ,
 0.605738327032    , 0.435471970625    , 0.329065198405    , 0.295832848212    ,
 0.337465822301    , 0.428542767035    , 0.516376146544    , 0.545305570214    ,
 0.492463396087    , 0.383722961204    , 0.270807248497    , 0.190171661575    ,
 0.143665280213    , 0.113621496504    , 0.0873140870569   , 0.0644482055945   ,
 0.048694225989    , 0.0397218226778   , 0.0337174639076   , 0.0279341455111   ,
 0.0230827131413   , 0.0224416252579   , 0.0293920806902   , 0.044135829646    ,
 0.060966938247    , 0.0701186858285   , 0.0653217996753   , 0.0502334161425   ,
 0.0369284522407   , 0.0394942201823   , 0.0695119162662   , 0.133337242796    ,
 0.228119504393    , 0.339634843807    , 0.447343565938    , 0.533752069867    ,
 0.588826472993    , 0.608497346487    , 0.596835281335    , 0.573533424172    ,
 0.574682465032    , 0.641527248206    , 0.807297120054    , 1.09351042514     ,
 1.51616369652     , 2.08861822214     , 2.8112442396      , 3.66422929489     ,
 4.62259838014     , 5.67270736285     , 6.79300932517     , 7.90249690969     ,
 8.83283235541     , 9.38560561787     , 9.45327310841     , 9.08628423759     ,
 8.43509085548     , 7.63744301108     , 6.76060642695     , 5.83240480228     ,
 4.91551283319     , 4.13611484536     , 3.61926440688     , 3.4063483361      ,
 3.46428702422     , 3.76827589044     , 4.3436750952      , 5.22606252258     ,
 6.40674428457     , 7.82668181374     , 9.41655578538     , 11.1445926759     ,
 13.0262918788     , 15.0622195978     , 17.1264366862     , 18.9207344161     ,
 20.1113416336     , 20.5682078654     , 20.4535520564     , 20.0586520033     ,
 19.5768141102     , 19.0271952153     , 22.2838771081     , 21.244420311      ,
 20.188276145      , 19.2956141371     , 18.7125921156     , 18.4611570707     ,
 18.4310998921     , 18.4470353094     , 18.3267573134     , 17.8928835876     ,
 17.0004437275     , 15.6139023621     , 13.8581787141     , 11.9700263067     ,
 10.1762165903     , 8.59340610445     , 7.22466053018     , 6.03157621783     ,
 4.98996458502     , 4.08543200846     , 3.29359022398     , 2.59007869597     ,
 1.97399378309     , 1.46724002732     , 1.08808669122     , 0.83070379462     ,
 0.672485950312    , 0.593255463884    , 0.576635668687    , 0.595864809951    ,
 0.615891444666    , 0.621605918808    , 0.640995184045    , 0.733562003687    ,
 0.952021104904    , 1.30928615663     , 1.77434634734     , 2.29423134211     ,
 2.82082409488     , 3.32869609241     , 3.82558930077     , 4.3566373462      ,
 5.00441163167     , 5.89842109978     , 7.23292177531     , 9.2607132467      ,
 12.2477617816     , 16.4286936668     , 22.0329517159     , 29.4283095268     ,
 39.3162250948     , 52.7817413028     , 71.1114347382     , 95.5978171772     ,
 127.52184529      , 168.109814068     , 218.194557558     , 277.684481588     ,
 345.062865893     , 416.959276902     , 487.939373956     , 550.849476419     ,
 597.803988176     , 621.637486618     , 617.688776934     , 585.492960387     ,
 529.461457466     , 457.989858308     , 381.360445462     , 309.285608154     ,
 248.979778115     , 204.315444563     , 175.88688183      , 161.475638484     ,
 156.8381357       , 156.96919287      , 157.483769623     , 155.392868444     ,
 149.120899138     , 138.30802625      , 123.696762318     , 106.810758457     ,
 89.2946185442     , 72.3582792026     , 56.7383284097     , 42.9747079714     ,
 31.5192892661     , 22.5795900726     , 15.9970577293     , 11.3480539395     ,
 8.14410050497     , 5.95157508695     , 4.41676940245     , 3.27759294494     ,
 2.3835665351      , 1.68323709862     , 1.16808798082     , 0.817761872369    ,
 0.589207322862    , 0.441236231288    , 0.355721608673    , 0.334739463731    ,
 0.379813920411    , 0.469166587676    , 0.552122265067    , 0.573116653186    ,
 0.510558830158    , 0.393329175756    , 0.275543969136    , 0.19399998204     ,
 0.149220310246    , 0.121121212555    , 0.0942309842375   , 0.066936808308    ,
 0.0445357724706   , 0.0304681650683   , 0.0239305833402   , 0.0220214056321   ,
 0.022344573656    , 0.0245403677482   , 0.0303400074507   , 0.0411654540955   ,
 0.0542861055106   , 0.0624016478743   , 0.0594922510349   , 0.0475678958288   ,
 0.036880339974    , 0.040291599717    , 0.0678671289114   , 0.12401317355     ,
 0.206149196095    , 0.305384704599    , 0.409602060829    , 0.506488634464    ,
 0.584127741067    , 0.632031969783    , 0.648527404808    , 0.651316936171    ,
 0.677728944077    , 0.770402945428    , 0.962975573747    , 1.28207176579     ,
 1.76152669305     , 2.44309659864     , 3.3510576654      , 4.47014226023     ,
 5.75637711831     , 7.15872722945     , 8.61133523835     , 9.99466504944     ,
 11.1111389619     , 11.7384121457     , 11.7550136066     , 11.2231916135     ,
 10.3381466415     , 9.29749794961     , 8.20874078659     , 7.10081142322     ,
 6.01779277525     , 5.08485624905     , 4.45548798298     , 4.20613721356     ,
 4.31954988932     , 4.76681854758     , 5.56666216719     , 6.75407898169     ,
 8.31629515455     , 10.1758563938     , 12.2362201966     , 14.4467517899     ,
 16.8171854438     , 19.332056515      , 21.810394439      , 23.8741937753     ,
 25.1470697717     , 25.5320650207     , 25.2620590982     , 24.6748070854     ,
 23.9766761853     , 23.1955464306     , 25.5092995091     , 24.3044943043     ,
 23.1226632466     , 22.1285479615     , 21.4763614995     , 21.2073492738     ,
 21.2049376052     , 21.2468924524     , 21.0870202149     , 20.496553391      ,
 19.3102638954     , 17.5188288998     , 15.3172578928     , 13.016217185      ,
 10.8749835184     , 9.00088498886     , 7.38084845074     , 5.97440288191     ,
 4.76331576267     , 3.7400577946      , 2.88836662175     , 2.18681778758     ,
 1.62101754788     , 1.18529766129     , 0.872339976725    , 0.6635857563      ,
 0.534543370729    , 0.468796244769    , 0.45737370415     , 0.481535523922    ,
 0.509315671437    , 0.521973607676    , 0.541899121342    , 0.626716216047    ,
 0.832495655017    , 1.17811916903     , 1.63720502906     , 2.15888527084     ,
 2.695995874       , 3.22143695316     , 3.73710302424     , 4.28593265044     ,
 4.96320399668     , 5.9245760765      , 7.39123477066     , 9.63499619155     ,
 12.9346385943     , 17.5400973765     , 23.7073509219     , 31.8427434724     ,
 42.688981109      , 57.3617288074     , 77.1629437779     , 103.401022644     ,
 137.403361371     , 180.486734299     , 233.572870408     , 296.536238227     ,
 367.560160354     , 442.636506708     , 515.425463113     , 577.866926369     ,
 621.5912291       , 639.684163179     , 628.407615215     , 588.527955575     ,
 525.604904421     , 448.825310322     , 368.764114655     , 294.924156184     ,
 233.946218391     , 189.001169589     , 160.084895805     , 144.630062743     ,
 138.356325932     , 136.521149778     , 135.190683761     , 131.836287916     ,
 125.202197645     , 115.051359799     , 102.070784581     , 87.5990721228     ,
 73.0196564843     , 59.2538571367     , 46.7548743525     , 35.8019413186     ,
 26.6395842975     , 19.3786066168     , 13.9107483413     , 9.96881918977     ,
 7.23120861286     , 5.37082600893     , 4.07524155344     , 3.093458469       ,
 2.28769291744     , 1.62977269194     , 1.13795060929     , 0.812077304378    ,
 0.615443227383    , 0.49832401709     , 0.428147296447    , 0.400033557744    ,
 0.421674412377    , 0.484795211277    , 0.549960489496    , 0.565209843981    ,
 0.505743362928    , 0.394795870495    , 0.282432331417    , 0.204296477826    ,
 0.161446945297    , 0.134129005405    , 0.106316091724    , 0.0760582989841   ,
 0.0499164170061   , 0.0338356658444   , 0.0286797855958   , 0.0306997697913   ,
 0.0345684233182   , 0.0370573723745   , 0.039165267039    , 0.0441910364738   ,
 0.052507316304    , 0.0589407640965   , 0.0573080077209   , 0.0478400817162   ,
 0.0391076479986   , 0.0428269430835   , 0.0671080221465   , 0.113158201622    ,
 0.176954701373    , 0.254058190415    , 0.342124604201    , 0.437357880238    ,
 0.529283422627    , 0.602949568211    , 0.651782435206    , 0.691011977714    ,
 0.75602149764     , 0.885419224623    , 1.10937159174     , 1.46032555856     ,
 1.99308087083     , 2.77876434382     , 3.86385304588     , 5.23610273831     ,
 6.83137112037     , 8.55762241699     , 10.2999605947     , 11.9035482627     ,
 13.1603875954     , 13.8499962446     , 13.847292279      , 13.209058873      ,
 12.144950802      , 10.8965456581     , 9.62187688666     , 8.3712353739      ,
 7.17409331732     , 6.13622745407     , 5.4170491365      , 5.11961794952     ,
 5.24960056792     , 5.78820606385     , 6.76186320137     , 8.2172021028      ,
 10.1486037765     , 12.4708881904     , 15.064318459      , 17.8464784988     ,
 20.7890565283     , 23.8196866373     , 26.6711170817     , 28.8821457923     ,
 30.0632986005     , 30.1939553969     , 29.607964081      , 28.7010090117     ,
 27.6978715483     , 26.6428675326     , 27.7225574566     , 26.4301420895     ,
 25.2333385973     , 24.2702741405     , 23.6891925678     , 23.5317300778     ,
 23.6567254908     , 23.7862045439     , 23.6140704714     , 22.8717081122     ,
 21.3803976664     , 19.1520548094     , 16.4456276073     , 13.6577704371     ,
 11.1138654766     , 8.9468081063      , 7.13962614126     , 5.63239131152     ,
 4.37822156603     , 3.34446753304     , 2.50657100305     , 1.84569367554     ,
 1.34279916641     , 0.975581245725    , 0.720310143602    , 0.55253309094     ,
 0.450463628089    , 0.40265633651     , 0.404740029987    , 0.441194028839    ,
 0.479595251339    , 0.496863547249    , 0.510891158376    , 0.577678176494    ,
 0.753772557539    , 1.05893949806     , 1.4688673232      , 1.93874585221     ,
 2.43206314922     , 2.93202485606     , 3.44496949056     , 4.01487486367     ,
 4.74208376734     , 5.79303515845     , 7.40133344548     , 9.85037008041     ,
 13.4287753898     , 18.3942579351     , 25.0139915478     , 33.716934285      ,
 45.2749163329     , 60.823406636      , 81.6736339267     , 109.152772196     ,
 144.631730744     , 189.48227927      , 244.635526247     , 309.826265069     ,
 382.86000885      , 459.129990926     , 531.618636347     , 591.744588775     ,
 631.059406337     , 643.180670246     , 625.357801803     , 579.40094335      ,
 511.640634927     , 431.655074296     , 350.045033008     , 276.006794501     ,
 215.616165696     , 171.374945439     , 142.709347215     , 126.761477101     ,
 119.324583597     , 116.02717457      , 113.408294076     , 109.332157301     ,
 102.79349187      , 93.6567747512     , 82.5330546625     , 70.5169796257     ,
 58.6872981178     , 47.7205943934     , 37.9048185268     , 29.3739715024     ,
 22.2252353196     , 16.4757068996     , 12.0331869086     , 8.73997798833     ,
 6.40960342937     , 4.82053538211     , 3.7203073023      , 2.88217424265     ,
 2.1755240897      , 1.57924202993     , 1.12587889636     , 0.831704807777    ,
 0.667167534776    , 0.575319914157    , 0.510285006405    , 0.461746471997    ,
 0.445916973634    , 0.471769309662    , 0.515417780899    , 0.530202788526    ,
 0.485062208812    , 0.392106595624    , 0.293536904872    , 0.222845008875    ,
 0.182051445958    , 0.15291003867     , 0.120975544469    , 0.0862143343239   ,
 0.057234680466    , 0.0414409715891   , 0.0396868277023   , 0.0463517822632   ,
 0.0531705134754   , 0.0547047256068   , 0.0519913854539   , 0.0506312843166   ,
 0.0540271072934   , 0.0587916691955   , 0.0583526770893   , 0.0512830166187   ,
 0.0449694993594   , 0.0507134731595   , 0.0751486479841   , 0.115621755376    ,
 0.164191138486    , 0.21733004385     , 0.280387529084    , 0.359791627157    ,
 0.451576952601    , 0.541653137174    , 0.62081943945     , 0.699605460959    ,
 0.806144017219    , 0.970800667531    , 1.22100990288     , 1.5992069908      ,
 2.18161588581     , 3.0607060999      , 4.29298232603     , 5.86245833635     ,
 7.68977394323     , 9.65772791143     , 11.6219908086     , 13.4087493018     ,
 14.8117999437     , 15.6191729033     , 15.693679303      , 15.0583842813     ,
 13.9044054981     , 12.5026928019     , 11.0731033831     , 9.70845262854     ,
 8.4307853802      , 7.3122230859      , 6.49767271361     , 6.10932991727     ,
 6.18554868756     , 6.73473169593     , 7.80389256907     , 9.45785330475     ,
 11.705786809      , 14.4680486413     , 17.6114818652     , 21.0135717847     ,
 24.5795144638     , 28.1445391239     , 31.3294075219     , 33.5854810688     ,
 34.5265889383     , 34.232984512      , 33.1637454323     , 31.7976464493     ,
 30.4010260898     , 29.0459637103     , 29.0146717779     , 27.7366199288     ,
 26.6385803415     , 25.8214702272     , 25.4159407334     , 25.4491499397     ,
 25.7432775917     , 25.9601341349     , 25.7399064937     , 24.7948261484     ,
 22.9589394311     , 20.2738836413     , 17.0473839775     , 13.7504993123     ,
 10.7913428185     , 8.36026419075     , 6.45056600053     , 4.96667918526     ,
 3.80222948686     , 2.87342065448     , 2.13234832825     , 1.55763547298     ,
 1.13035303465     , 0.824079171831    , 0.612489399666    , 0.474684391073    ,
 0.395071743572    , 0.365280030141    , 0.380510540689    , 0.425003758285    ,
 0.467544839146    , 0.485210178699    , 0.492848900078    , 0.540868134215    ,
 0.680274726662    , 0.928347941351    , 1.26344724187     , 1.64929288134     ,
 2.06337362829     , 2.50623763881     , 3.00005231581     , 3.59756951326     ,
 4.39846441983     , 5.56146158866     , 7.31301398903     , 9.94055312118     ,
 13.7516496659     , 19.0278150231     , 26.0516838654     , 35.2536527441     ,
 47.3899816763     , 63.5685451294     , 85.0896583522     , 113.318091517     ,
 149.700617427     , 195.660233544     , 252.057442825     , 318.339378501     ,
 391.803908891     , 467.279834252     , 537.374075284     , 593.485368776     ,
 627.549379799     , 633.922201092     , 610.744375564     , 560.558417337     ,
 490.07546526      , 408.930783234     , 327.550764346     , 254.755168092     ,
 196.068156602     , 153.376883649     , 125.613759683     , 109.716886354     ,
 101.625190418     , 97.3631036631     , 93.9140419353     , 89.4861929809     ,
 83.2953410444     , 75.3020645476     , 66.0320333731     , 56.3093492048     ,
 46.892789852      , 38.2468092195     , 30.5742360793     , 23.9577359785     ,
 18.4204548771     , 13.9176085741     , 10.3565707848     , 7.63960569197     ,
 5.6673208219      , 4.30434935123     , 3.36543320806     , 2.65916193565     ,
 2.05959076782     , 1.53856254085     , 1.12935872803     , 0.85929610475     ,
 0.70912499538     , 0.623027375629    , 0.550178669934    , 0.478111639755    ,
 0.428651898337    , 0.422678555759    , 0.448789509407    , 0.466200636732    ,
 0.439646223164    , 0.371020893961    , 0.293604901974    , 0.236537518149    ,
 0.200888506097    , 0.169681942982    , 0.131842230633    , 0.0916069305698   ,
 0.060518413905    , 0.0464489543739   , 0.0487739500117   , 0.0594942486116   ,
 0.068095993273    , 0.0680416371981   , 0.0609736459332   , 0.0544654824561   ,
 0.0542268414303   , 0.0582727962902   , 0.0597998056393   , 0.0561671218486   ,
 0.0541911069689   , 0.0655987088407   , 0.0962602635871   , 0.139277169466    ,
 0.180489505326    , 0.213603113043    , 0.248902348387    , 0.303832800206    ,
 0.3854221297      , 0.484987853821    , 0.590807623884    , 0.70391809378     ,
 0.840357749975    , 1.02290937569     , 1.28251525178     , 1.67647362392     ,
 2.29784783916     , 3.24586258963     , 4.571258619       , 6.24840521466     ,
 8.19392138713     , 10.2947879623     , 12.4156117574     , 14.3928531945     ,
 16.0278143137     , 17.0971661807     , 17.413838212      , 16.9268695483     ,
 15.783880207      , 14.2823736879     , 12.7155147845     , 11.2331112538     ,
 9.85930247398     , 8.63321293932     , 7.68051106541     , 7.142156992       ,
 7.09782792248     , 7.59282014457     , 8.69486083192     , 10.4794877143     ,
 12.9683164852     , 16.0961779853     , 19.7279939967     , 23.7029663644     ,
 27.8497059701     , 31.8973528474     , 35.3491889488     , 37.5761488348     ,
 38.2038271374     , 37.4120374821     , 35.7837459908     , 33.8956635532     ,
 32.0809450271     , 30.4538064101     , 29.7045610913     , 28.5695218174     ,
 27.6957122571     , 27.1257950877     , 26.952370887      , 27.1724904833     ,
 27.5676654388     , 27.7482328295     , 27.3229995409     , 26.0278223328     ,
 23.7634718119     , 20.6294552648     , 16.960121411      , 13.252948921      ,
 9.96919909668     , 7.3573815295      , 5.43025943072     , 4.05736920541     ,
 3.06848303171     , 2.32420300816     , 1.74566006989     , 1.29893688491     ,
 0.961675088224    , 0.71074813653     , 0.52957813317     , 0.409879219235    ,
 0.344981069557    , 0.327192979969    , 0.347263143599    , 0.388608468845    ,
 0.42653898094     , 0.444762819943    , 0.454986495157    , 0.494444885       ,
 0.601110921079    , 0.789220384986    , 1.04447685644     , 1.34188447437     ,
 1.67098948181     , 2.04828762353     , 2.51603077009     , 3.14205746934     ,
 4.02517279797     , 5.305983709       , 7.18838780612     , 9.95546048993     ,
 13.9441337859     , 19.4881451647     , 26.9110993603     , 36.6373219979     ,
 49.3546423135     , 66.0695705688     , 88.022233181      , 116.613906981     ,
 153.388705472     , 199.807191672     , 256.577505711     , 322.753758475     ,
 395.105826442     , 468.057093566     , 534.180267335     , 585.253484498     ,
 613.850780872     , 615.052439175     , 587.677991203     , 534.7626915       ,
 463.223042632     , 382.613997874     , 303.039672425     , 232.799635703     ,
 176.787831319     , 136.298485405     , 109.871737083     , 94.3665805381     ,
 85.9536472968     , 81.070180946      , 77.1143805538     , 72.6013402209     ,
 66.9324841748     , 60.1258867491     , 52.5962149567     , 44.9053565885     ,
 37.5279596543     , 30.756529667      , 24.7455728329     , 19.5710394585     ,
 15.2382999011     , 11.6879822867     , 8.83732994138     , 6.61736598925     ,
 4.96852988914     , 3.80894619897     , 3.01241228856     , 2.42731611341     ,
 1.93405357061     , 1.49159898657     , 1.12506696865     , 0.866997536182    ,
 0.710094113436    , 0.608991995943    , 0.51877250427     , 0.428777671496    ,
 0.360706998387    , 0.336986632191    , 0.351661140579    , 0.370460009343    ,
 0.359923152679    , 0.316831149087    , 0.265862301947    , 0.228883048486    ,
 0.203524094278    , 0.173654181932    , 0.132400780877    , 0.0889253072781   ,
 0.0574289622182   , 0.0453866985679   , 0.0502570635866   , 0.0624073152296   ,
 0.0707701230893   , 0.0691951434316   , 0.0600430353137   , 0.0515525592512   ,
 0.0502072758564   , 0.054891619847    , 0.0591492374535   , 0.0600220570156   ,
 0.0643269871755   , 0.0845000746559   , 0.125935337484    , 0.177699361819    ,
 0.219053567354    , 0.239637318763    , 0.25290748148     , 0.286478740027    ,
 0.359080424197    , 0.467759931595    , 0.595557720308    , 0.729580460839    ,
 0.873024928998    , 1.04692986871     , 1.29345705923     , 1.68577788403     ,
 2.32460227254     , 3.30206449403     , 4.65372257886     , 6.34436719714     ,
 8.29783068636     , 10.4306568126     , 12.6550246739     , 14.8540129301     ,
 16.845457817      , 18.3645262627     , 19.1206609683     , 18.9435002765     ,
 17.9198252364     , 16.3766967305     , 14.6852702034     , 13.0555552597     ,
 11.5252104307     , 10.1199618018     , 8.96278413609     , 8.22188929786     ,
 8.0211112924      , 8.43770716112     , 9.5448237264      , 11.4113637752     ,
 14.0635064741     , 17.4523101579     , 21.4450008207     , 25.8463797148     ,
 30.4129271952     , 34.7765655127     , 38.346759779      , 40.4529274091     ,
 40.7586320078     , 39.5289336261     , 37.4292992633     , 35.1042061        ,
 32.9524557453     , 31.145681167      , 30.1367876596     , 29.2808023496     ,
 28.7579797524     , 28.5185081936     , 28.5827798799     , 28.8992474389     ,
 29.2140882761     , 29.1144155464     , 28.2254150033     , 26.3720437119     ,
 23.5893489589     , 20.0674711383     , 16.1382778877     , 12.2514455293     ,
 8.84921651179     , 6.20143467427     , 4.33912406329     , 3.1158869609      ,
 2.32231157947     , 1.78117615089     , 1.38574291783     , 1.08217143604     ,
 0.838438874151    , 0.635848403428    , 0.473182813608    , 0.359583091255    ,
 0.299168097555    , 0.284528914566    , 0.300985009551    , 0.331724120015    ,
 0.361766660935    , 0.384731784119    , 0.408394767813    , 0.451776888306    ,
 0.535666944948    , 0.672679850136    , 0.861335727679    , 1.09108398046     ,
 1.35990644093     , 1.69164549211     , 2.14104705595     , 2.78926741039     ,
 3.73791048904     , 5.11256150061     , 7.0907219186      , 9.94254385704     ,
 14.0338667879     , 19.7693732276     , 27.5433175756     , 37.7874987171     ,
 51.0990236833     , 68.3347677873     , 90.6268829954     , 119.375482981     ,
 156.170920879     , 202.417942398     , 258.568377303     , 323.283209133     ,
 393.003272269     , 462.093572533     , 523.419018917     , 569.296525591     ,
 592.879714569     , 589.748117626     , 559.161369324     , 504.550939712     ,
 433.085919028     , 354.273917538     , 277.78800953      , 211.203043341     ,
 158.630875418     , 120.764185606     , 95.8629496521     , 80.85937482       ,
 72.2708364929     , 66.9855433962     , 62.7897423195     , 58.4477841331     ,
 53.4747848581     , 47.8748910861     , 41.9210871508     , 35.9520136469     ,
 30.2360907482     , 24.9499219038     , 20.2138318876     , 16.1019867312     ,
 12.6291919797     , 9.76196108516     , 7.44964580702     , 5.64035250608     ,
 4.28086694916     , 3.31035259971     , 2.64387444478     , 2.16633603854     ,
 1.76847340017     , 1.39991413758     , 1.07601546157     , 0.82901746391     ,
 0.660293608901    , 0.538376832044    , 0.431280729405    , 0.333274568056    ,
 0.261731162266    , 0.232583291001    , 0.239753829077    , 0.256253241877    ,
 0.255916924945    , 0.235221753641    , 0.211013273867    , 0.196325125407    ,
 0.184577166654    , 0.160717308566    , 0.12159837728     , 0.0796748846865   ,
 0.0502236807964   , 0.0398233712771   , 0.0447114472138   , 0.0551910378251   ,
 0.0615067019571   , 0.0590699174465   , 0.0505847438878   , 0.0432609700674   ,
 0.0426920154791   , 0.0482808579006   , 0.0549318189314   , 0.0605461892942   ,
 0.0719952464085   , 0.101398920881    , 0.153132487202    , 0.213661499757    ,
 0.258603486784    , 0.275483747673    , 0.27969696219     , 0.304976083742    ,
 0.377223886154    , 0.495848609959    , 0.63679608083     , 0.773908056579    ,
 0.902127734706    , 1.04738474751     , 1.26567751644     , 1.64035984282     ,
 2.2696307009      , 3.23285946232     , 4.55310612972     , 6.19161699341     ,
 8.08376712897     , 10.1833651408     , 12.4709652095     , 14.9055596685     ,
 17.3363537662     , 19.4412453022     , 20.7913546309     , 21.0674991954     ,
 20.281368191      , 18.7809182712     , 17.0025281791     , 15.2070779406     ,
 13.4561947976     , 11.7924142481     , 10.3661993212     , 9.38700663811     ,
 9.01942811635     , 9.35651367799     , 10.4555112606     , 12.363483951      ,
 15.1054073616     , 18.6436042673     , 22.8398764246     , 27.4623896301     ,
 32.2038570352     , 36.6205644232     , 40.0758636583     , 41.931107643      ,
 41.9435796572     , 40.4514700944     , 38.12747534       , 35.6006908376     ,
 33.2948681235     , 31.4493485008     , 30.5811675336     , 30.1049008171     ,
 30.0081616307     , 30.1183775668     , 30.3505155202     , 30.5924200659     ,
 30.5749303369     , 29.9102481633     , 28.3039524323     , 25.7330139172     ,
 22.4107351322     , 18.6273945921     , 14.6794107833     , 10.9008955182     ,
 7.63875589653     , 5.13124648628     , 3.41549386156     , 2.35173399934     ,
 1.72712922231     , 1.35495904836     , 1.11403535963     , 0.933378584389    ,
 0.769657079206    , 0.60564633674     , 0.452710348267    , 0.335984715198    ,
 0.270902755817    , 0.252503442272    , 0.262750451905    , 0.28439849301     ,
 0.309745235007    , 0.340377213853    , 0.380868387743    , 0.434657780442    ,
 0.507709104468    , 0.61247730579     , 0.761873973178    , 0.961005155055    ,
 1.21323230857     , 1.53871027439     , 1.98889696703     , 2.64850165634     ,
 3.62643358715     , 5.04724427672     , 7.07042852514     , 9.94545169715     ,
 14.0491932424     , 19.8476167936     , 27.8158948357     , 38.4184494046     ,
 52.1907068481     , 69.8625474513     , 92.4531441045     , 121.295223839     ,
 157.879105243     , 203.365420702     , 257.838442171     , 319.676107457     ,
 385.346541371     , 449.582720342     , 505.792753462     , 546.810373709     ,
 566.161113276     , 559.673778421     , 526.871669562     , 471.542140921     ,
 401.160929469     , 325.204907953     , 252.810969197     , 190.66220752      ,
 141.990886928     , 106.926081775     , 83.5805174863     , 69.1041660028     ,
 60.4550998745     , 54.9905116317     , 50.8355711886     , 46.9194491647     ,
 42.7838980687     , 38.3562361564     , 33.7570702572     , 29.1557239684     ,
 24.7023666728     , 20.5247128534     , 16.7298444584     , 13.3863750234     ,
 10.5194590318     , 8.13168359182     , 6.21204868966     , 4.72283380473     ,
 3.60459770599     , 2.79949224167     , 2.24647626521     , 1.85813391799     ,
 1.53855695355     , 1.23633601259     , 0.960441189007    , 0.738144228417    ,
 0.572288227241    , 0.441782759769    , 0.328255362302    , 0.232223525624    ,
 0.166237410974    , 0.137817274535    , 0.139102240805    , 0.150396571925    ,
 0.154567254727    , 0.149820749695    , 0.146452258935    , 0.149815199327    ,
 0.150712428471    , 0.135926346523    , 0.104477390144    , 0.0691296333365   ,
 0.0442131555689   , 0.0354095321145   , 0.0389208408838   , 0.0462672165203   ,
 0.0499401371772   , 0.0472587412982   , 0.0407670596924   , 0.0355175323403   ,
 0.03533781586     , 0.0403866981324   , 0.0482124459288   , 0.0585913685283   ,
 0.0776292694115   , 0.1146609146      , 0.171610269936    , 0.234711822203    ,
 0.281386528919    , 0.301088273159    , 0.309625426488    , 0.339953735627    ,
 0.417275215369    , 0.539658156626    , 0.678886007626    , 0.803332515956    ,
 0.90738679927     , 1.02406799285     , 1.21711217848     , 1.56861748674     ,
 2.16666711139     , 3.0822178107      , 4.33922411855     , 5.90515823433     ,
 7.72455345271     , 9.7793832815      , 12.1149618376     , 14.7713478285     ,
 17.6362222476     , 20.3375315147     , 22.3201028444     , 23.1258139196     ,
 22.6827706984     , 21.3310557985     , 19.5397742205     , 17.6026496194     ,
 15.6107341527     , 13.6475881632     , 11.9168519367     , 10.6804377279     ,
 10.137821085      , 10.3830348389     , 11.4444974767     , 13.3416303241     ,
 16.0933637564     , 19.6610279532     , 23.8876949739     , 28.5053227368     ,
 33.1594233505     , 37.3606624405     , 40.4787088929     , 41.979299037      ,
 41.7663434053     , 40.2397132067     , 38.004127375      , 35.5809894032     ,
 33.3604026655     , 31.6432357074     , 31.1894575135     , 31.1058527903     ,
 31.3872256684     , 31.7403007032     , 31.9684824372     , 31.9077755039     ,
 31.3125706154     , 29.8801733942     , 27.449654426      , 24.1690500689     ,
 20.4129183009     , 16.5420467035     , 12.7927143963     , 9.35679745761     ,
 6.44721370751     , 4.23121623134     , 2.73418943766     , 1.83374055878     ,
 1.33931906946     , 1.07936699179     , 0.936845809955    , 0.836752046252    ,
 0.730122427966    , 0.597892933529    , 0.455408830614    , 0.33627495097     ,
 0.264935873296    , 0.241770393688    , 0.249270559057    , 0.269152328724    ,
 0.295194491361    , 0.332248325556    , 0.384589215224    , 0.449217945501    ,
 0.524675298028    , 0.62340554338     , 0.768095532434    , 0.975773683565    ,
 1.25236203137     , 1.60677753982     , 2.0737027275      , 2.73110266007     ,
 3.69888899148     , 5.11746159006     , 7.14343185329     , 10.0006169847     ,
 14.0465321151     , 19.7684362829     , 27.7003294654     , 38.3575408302     ,
 52.2780692767     , 70.1487817374     , 92.9138374432     , 121.761149337     ,
 157.888133207     , 202.01122339      , 253.797809005     , 311.523260701     ,
 372.012890683     , 430.663862578     , 481.551545289     , 517.985396372     ,
 533.764369837     , 524.885297958     , 491.05839031      , 436.318707096     ,
 368.305515079     , 296.311082883     , 228.811596609     , 171.550780339     ,
 126.939666915     , 94.6861814643     , 72.9101916788     , 59.0745876582     ,
 50.5919315735     , 45.2401512912     , 41.4029950186     , 38.092414063      ,
 34.8205204829     , 31.421308131      , 27.8855022772     , 24.2662745237     ,
 20.6636812907     , 17.2171744253     , 14.0564108341     , 11.2521878889     ,
 8.82612959331     , 6.79311361658     , 5.16354920811     , 3.9107898599      ,
 2.97470818111     , 2.29977299078     , 1.83792315289     , 1.51921718176     ,
 1.26118190076     , 1.01787032164     , 0.795300168399    , 0.6130312392      ,
 0.469579814504    , 0.348696612869    , 0.241955286711    , 0.155210954676    ,
 0.0979525794667   , 0.0719004258252   , 0.0684639010532   , 0.0740610649619   ,
 0.0788151727283   , 0.0823867154401   , 0.0904119477829   , 0.103743858199    ,
 0.113357834037    , 0.108527012014    , 0.0884495068451   , 0.0632098344933   ,
 0.0445738872395   , 0.0377211151658   , 0.0399383963064   , 0.0445074744751   ,
 0.0460034182729   , 0.0432668627166   , 0.0383531409791   , 0.0339656133378   ,
 0.0323111135807   , 0.035026302631    , 0.0434138765815   , 0.0596210520395   ,
 0.0876148587079   , 0.13094769033     , 0.187158654948    , 0.244284081124    ,
 0.286912999378    , 0.310544650773    , 0.329952684202    , 0.370433170485    ,
 0.449015606572    , 0.560803451441    , 0.680619650166    , 0.783042102833    ,
 0.869045650698    , 0.975615952749    , 1.16266212731     , 1.49848182093     ,
 2.05676536167     , 2.90918014728     , 4.09766340472     , 5.60761836568     ,
 7.39023292484     , 9.44085411815     , 11.8479007057     , 14.7085626764     ,
 17.9358572242     , 21.1272838506     , 23.6553050513     , 24.9729024466     ,
 24.9287631615     , 23.8178673077     , 22.1021608349     , 20.0894061834     ,
 17.8986608409     , 15.6597364109     , 13.6340670469     , 12.1355385998     ,
 11.3941486467     , 11.503829752      , 12.469377941      , 14.2854506039     ,
 16.954414752      , 20.4165480842     , 24.4870562353     , 28.8785410107     ,
 33.2256243184     , 37.0347123144     , 39.7199391986     , 40.8762823606     ,
 40.5544530213     , 39.19326798       , 37.2955589174     , 35.2369749486     ,
 33.3338527394     , 31.9134280083     , 31.9590360705     , 32.1659475109     ,
 32.6275810941     , 32.9793260462     , 32.9492430471     , 32.3559934279     ,
 31.0278425605     , 28.8000078175     , 25.6604096609     , 21.881458288      ,
 17.9175165804     , 14.1430038265     , 10.7306629497     , 7.75375379804     ,
 5.30160286969     , 3.45884787735     , 2.22417888466     , 1.48956332135     ,
 1.09488052452     , 0.896895306025    , 0.798442892651    , 0.736381379358    ,
 0.666188051452    , 0.566467436848    , 0.447268271968    , 0.339594954728    ,
 0.270912529747    , 0.248061689572    , 0.258240021881    , 0.283068745531    ,
 0.313760266719    , 0.354699328867    , 0.412912783688    , 0.488372106893    ,
 0.580201104677    , 0.70013840008     , 0.8719460698      , 1.11547618761     ,
 1.43543898262     , 1.82916372907     , 2.31279466443     , 2.95469665756     ,
 3.88767553928     , 5.27854927922     , 7.29442652238     , 10.1333739699     ,
 14.10546808       , 19.6680395227     , 27.3680993069     , 37.767930433      ,
 51.4621828013     , 69.1773114824     , 91.8213964348     , 120.372124834     ,
 155.593321205     , 197.668624307     , 245.919684259     , 298.707782441     ,
 353.3709779       , 406.012410858     , 451.362583921     , 483.241095152     ,
 495.831882966     , 485.416595462     , 451.882512659     , 399.29977841      ,
 335.128943231     , 268.182089876     , 206.162878968     , 153.959176188     ,
 113.359087718     , 83.861461494      , 63.7342253552     , 50.7792216938     ,
 42.7928722986     , 37.8656847505     , 34.5472967721     , 31.8809750259     ,
 29.3452488229     , 26.7168784428     , 23.9113162254     , 20.9144245545     ,
 17.8105733535     , 14.7791940936     , 12.0001267694     , 9.56244946254     ,
 7.47380065034     , 5.72850066251     , 4.3283129502      , 3.25051202553     ,
 2.4441142947      , 1.86281887521     , 1.46780081904     , 1.20051569634     ,
 0.990640891067    , 0.798751062083    , 0.627743723491    , 0.488968036074    ,
 0.37621631074     , 0.275531966374    , 0.183807895968    , 0.109457352625    ,
 0.0604797863454   , 0.0364470251766   , 0.0296648215587   , 0.0308175674189   ,
 0.0342277774904   , 0.0400005112232   , 0.0511218641974   , 0.067228484996    ,
 0.0817192307123   , 0.0864654134364   , 0.0791813799811   , 0.0652662691285   ,
 0.0530224938583   , 0.0476248972799   , 0.0483862771303   , 0.0506631318985   ,
 0.05060415837     , 0.0478542519059   , 0.0437217131945   , 0.0389179048579   ,
 0.0347012057717   , 0.0348183144612   , 0.0447085796465   , 0.0687262856204   ,
 0.107530560387    , 0.156851716609    , 0.208393751817    , 0.25291390981     ,
 0.285325903897    , 0.309944695388    , 0.340011470496    , 0.389033213459    ,
 0.46123980694     , 0.548649722965    , 0.635865468186    , 0.712979449344    ,
 0.791566943045    , 0.908141146745    , 1.11003587967     , 1.44467749367     ,
 1.96955711236     , 2.7618776535      , 3.8915144138      , 5.37164986733     ,
 7.16362509407     , 9.26798929229     , 11.7917839539     , 14.8524468281     ,
 18.3629735923     , 21.9078863902     , 24.8481738984     , 26.6084728217     ,
 26.9730846266     , 26.163713899      , 24.6016784485     , 22.593380659      ,
 20.2805164026     , 17.8294531292     , 15.5443350059     , 13.7783187155     ,
 12.7904525737     , 12.6892538166     , 13.4778873865     , 15.1345478457     ,
 17.6298519949     , 20.8610427608     , 24.6130867924     , 28.6061088976     ,
 32.5096056634     , 35.8712825668     , 38.168669802      , 39.0968474816     ,
 38.7948921664     , 37.7081426744     , 36.2584701348     , 34.7117625344     ,
 33.3018192933     , 32.3164216256     , 32.7369758988     , 33.0556864352     ,
 33.4156108976     , 33.4614589928     , 32.915583058      , 31.6292538024     ,
 29.5460976899     , 26.6633089152     , 23.0919909277     , 19.1415679614     ,
 15.2408294534     , 11.7214992974     , 8.70808233076     , 6.20536786084     ,
 4.21713808242     , 2.75595036552     , 1.78830904104     , 1.21352341955     ,
 0.899526993045    , 0.734159955432    , 0.647150714314    , 0.596679184618    ,
 0.550829023649    , 0.488257137865    , 0.408498901564    , 0.330516678309    ,
 0.277478542254    , 0.261262775925    , 0.276781057551    , 0.308798860424    ,
 0.346599226033    , 0.392898950326    , 0.457687318575    , 0.547531272724    ,
 0.666808095386    , 0.826694522016    , 1.04469606409     , 1.33326457198     ,
 1.6917016015      , 2.11145236389     , 2.60009126664     , 3.22175084095     ,
 4.12078777551     , 5.48907580191     , 7.50862383236     , 10.3559892783     ,
 14.28322053       , 19.6847809745     , 27.077350826      , 37.0413427238     ,
 50.2281663915     , 67.4196242996     , 89.489187195      , 117.181902968     ,
 150.824193794     , 190.14829579      , 234.29238208      , 281.825518397     ,
 330.56044917      , 377.155445991     , 416.912351625     , 444.254650585     ,
 453.964224333     , 442.781424189     , 410.752947433     , 361.727097978     ,
 302.608123907     , 241.446844912     , 185.135174772     , 137.879652786     ,
 101.094140384     , 74.2639704963     , 55.887069969      , 44.0699006741     ,
 36.8831076402     , 32.6102102972     , 29.890364028      , 27.780019437      ,
 25.753454336      , 23.5929923701     , 21.2131165443     , 18.5820932622     ,
 15.7725229277     , 12.9823223814     , 10.4317822319     , 8.23953276509     ,
 6.40937308848     , 4.90606405179     , 3.70272352995     , 2.76798037192     ,
 2.05937478963     , 1.54287564004     , 1.19060772509     , 0.956880022669    ,
 0.783750975809    , 0.63496824668     , 0.506196806706    , 0.400899284581    ,
 0.312027286821    , 0.229403299031    , 0.152338498716    , 0.08873539562     ,
 0.0454452182929   , 0.02222608276     , 0.0131540182486   , 0.0114236617495   ,
 0.0130573117477   , 0.0178771509692   , 0.0276887983881   , 0.0428158615837   ,
 0.0597996872403   , 0.0726905897586   , 0.0770424493179   , 0.0731082479294   ,
 0.0655462103895   , 0.0597373607257   , 0.0576121641611   , 0.0570831400813   ,
 0.0556718831604   , 0.0531346974018   , 0.0497239103879   , 0.0446467658967   ,
 0.0388618668035   , 0.0381878782411   , 0.0514115832132   , 0.0841865950046   ,
 0.133418315708    , 0.187119193252    , 0.231541038157    , 0.260612172525    ,
 0.280182831881    , 0.304187329593    , 0.344703401715    , 0.402538300991    ,
 0.467385064348    , 0.527723077283    , 0.580087436754    , 0.632884627714    ,
 0.708568037403    , 0.841495457067    , 1.06680357137     , 1.41414304398     ,
 1.92509755501     , 2.67596227448     , 3.75703341771     , 5.21085895943     ,
 7.02043507666     , 9.1994197303      , 11.8634146424     , 15.1258493595     ,
 18.883253025      , 22.7168841569     , 26.0089315955     , 28.1897223796     ,
 28.9908560154     , 28.543248285      , 27.1989331694     , 25.2471762666     ,
 22.8519773414     , 20.2152845091     , 17.6732157638     , 15.6056553297     ,
 14.3008886587     , 13.9007029004     , 14.4307214022     , 15.8607019631     ,
 18.1179771512     , 21.0443185589     , 24.3962687072     , 27.9165173232     ,
 31.3348167964     , 34.2705951284     , 36.2725502428     , 37.0916987555     ,
 36.8843318225     , 36.0754457761     , 35.0556543856     , 34.0533106676     ,
 33.2299533544     , 32.7590631983     , 33.2990427616     , 33.56648166       ,
 33.5827621382     , 33.0760672996     , 31.8416774944     , 29.8132896495     ,
 27.0647597811     , 23.7409954251     , 20.0309304233     , 16.2058569452     ,
 12.5925443373     , 9.4435627061      , 6.85081272724     , 4.79292430216     ,
 3.22577947635     , 2.1096229453      , 1.38348679357     , 0.951721320011    ,
 0.707120029425    , 0.566340609899    , 0.484216881875    , 0.439434706168    ,
 0.414051123277    , 0.389308023935    , 0.35482116231     , 0.314797310851    ,
 0.284055690675    , 0.277049080627    , 0.29720366257     , 0.33610972442     ,
 0.384778583373    , 0.444306110468    , 0.523880756141    , 0.633164720007    ,
 0.78210587503     , 0.983675366924    , 1.24850563585     , 1.57725367483     ,
 1.96181000295     , 2.39407857985     , 2.8847080555      , 3.49990548684     ,
 4.38977408178     , 5.75888188993     , 7.79779285083     , 10.6678305663     ,
 14.5758895075     , 19.858467908      , 26.9857949397     , 36.5148756964     ,
 49.0911101507     , 65.483182544      , 86.4910166808     , 112.665638379     ,
 144.037149771     , 180.088540613     , 219.928875769     , 262.336424468     ,
 305.445866653     , 346.291243331     , 380.689125383     , 403.765067546     ,
 411.052063025     , 399.826088244     , 370.21679943      , 325.630665204     ,
 272.15516929      , 216.930707558     , 166.093393067     , 123.382504738     ,
 90.0646432213     , 65.73614929       , 49.1294281497     , 38.5830906294     ,
 32.3428427931     , 28.8026895273     , 26.653017118      , 24.9661140495     ,
 23.2382007325     , 21.3052489907     , 19.1476750486     , 16.7651668389     ,
 14.2086616583     , 11.6373855081     , 9.26442709999     , 7.23755278209     ,
 5.58822787431     , 4.27645539469     , 3.24676478045     , 2.44452834094     ,
 1.82275539553     , 1.35509022071     , 1.02748133427     , 0.812583609575    ,
 0.666712130188    , 0.552877656713    , 0.454540730155    , 0.367027611087    ,
 0.286633553398    , 0.210542368979    , 0.140626490719    , 0.0827737850683   ,
 0.0420343284602   , 0.0185671635164   , 0.00792370339721  , 0.00451851136348  ,
 0.00474167350991  , 0.00789799239897  , 0.0153003696138   , 0.0282688780442   ,
 0.0458517111736   , 0.0637338451722   , 0.075905495513    , 0.0786543812253   ,
 0.0734857715094   , 0.0656493616882   , 0.0594383183735   , 0.0555097449431   ,
 0.0527828474286   , 0.0507364281525   , 0.0484951864531   , 0.0444027951328   ,
 0.0395678278032   , 0.041050966758    , 0.0590559243865   , 0.0989144376365   ,
 0.15398268393     , 0.206875627834    , 0.241206865077    , 0.255087381082    ,
 0.264090495405    , 0.290343475129    , 0.344956605295    , 0.41732248203     ,
 0.483176629999    , 0.526454142458    , 0.553292346673    , 0.587275356906    ,
 0.659061915197    , 0.801969283755    , 1.0470957638      , 1.41786651259     ,
 1.94199741047     , 2.67781690448     , 3.71043997432     , 5.10277464557     ,
 6.87755600349     , 9.08815631236     , 11.8712576986     , 15.3365120959     ,
 19.3659156997     , 23.5404770675     , 27.2602566587     , 29.9557584017     ,
 31.2989219234     , 31.3077703595     , 30.2297724194     , 28.3188030652     ,
 25.7777774409     , 22.8758711899     , 19.9996745125     , 17.5567408282     ,
 15.8628179637     , 15.0989694131     , 15.3209520677     , 16.4892040578     ,
 18.4829547735     , 21.0912840339     , 24.0477932145     , 27.1130635364     ,
 30.070209661      , 32.6174678925     , 34.3815596158     , 35.1458719561     ,
 35.0383177784     , 34.4447920116     , 33.761715432      , 33.2415511375     ,
 32.9972118902     , 33.0447360618     , 33.472276728      , 33.6048013518     ,
 33.1576676297     , 31.9783232414     , 29.9994750818     , 27.2784770606     ,
 24.0089001158     , 20.4397753053     , 16.7943567839     , 13.2741313847     ,
 10.0801851357     , 7.3715503117      , 5.20874889889     , 3.56132200814     ,
 2.3617212112      , 1.53881312553     , 1.01563717306     , 0.704917120484    ,
 0.523383471504    , 0.412854316452    , 0.346623822662    , 0.315891655994    ,
 0.311459939827    , 0.317591126136    , 0.318790093432    , 0.309516179197    ,
 0.298037229372    , 0.299933250787    , 0.325575080021    , 0.374459469881    ,
 0.441681104135    , 0.525955702471    , 0.630046646525    , 0.760021020572    ,
 0.929314827367    , 1.15699588165     , 1.45397427053     , 1.81447967811     ,
 2.22562081837     , 2.6821117051      , 3.20063221224     , 3.84849408088     ,
 4.77050545449     , 6.16477546775     , 8.21685645164     , 11.0807508971     ,
 14.9504834706     , 20.143566336      , 27.0986023475     , 36.3131175936     ,
 48.335167114      , 63.808890983      , 83.4062266845     , 107.562684521     ,
 136.217863989     , 168.817828252     , 204.514586313     , 242.196715901     ,
 280.161505224     , 315.727680901     , 345.23758053      , 364.575288825     ,
 370.04821459      , 359.415181025     , 332.770473591     , 292.93792922      ,
 245.079302951     , 195.410695234     , 149.434346287     , 110.634025683     ,
 80.3058841806     , 58.2079992733     , 43.2515801255     , 33.9227873681     ,
 28.5797667534     , 25.6992111073     , 24.0252289809     , 22.6590679222     ,
 21.1236064217     , 19.3142793534     , 17.3043155023     , 15.1571562631     ,
 12.8977396566     , 10.5965030426     , 8.40655455587     , 6.49476542233     ,
 4.9523069165      , 3.7722032566      , 2.8854861506      , 2.20714306878     ,
 1.67202673644     , 1.25267715411     , 0.946686432322    , 0.746115643141    ,
 0.62226300928     , 0.536603194607    , 0.459125504349    , 0.37685199237     ,
 0.291057298448    , 0.20904263034     , 0.13747350524     , 0.0807335513062   ,
 0.0410989112864   , 0.0177394748597   , 0.00657097118747  , 0.00248775183274  ,
 0.00191218214508  , 0.00375034759285  , 0.00895803586606  , 0.0192631076524   ,
 0.035053362377    , 0.0533104846609   , 0.067936625256    , 0.0735033699135   ,
 0.0694134735866   , 0.0600788591563   , 0.0508608881867   , 0.0444061123027   ,
 0.0408223413073   , 0.0393501355148   , 0.0384659397399   , 0.0365206388266   ,
 0.0350904710232   , 0.041329417687    , 0.0645625430786   , 0.107944565681    ,
 0.161750572263    , 0.206516155101    , 0.227278367026    , 0.227719669869    ,
 0.230742733776    , 0.263302061385    , 0.334942095978    , 0.4263824826      ,
 0.502531295755    , 0.542917591849    , 0.559462212138    , 0.585114176771    ,
 0.65455171297     , 0.801283686048    , 1.06101896843     , 1.46280974891     ,
 2.02275352455     , 2.76301856714     , 3.73442217732     , 5.00805885507     ,
 6.66629789567     , 8.83701646777     , 11.7026791992     , 15.381587412      ,
 19.7500062643     , 24.3883570437     , 28.6974749361     , 32.0831538343     ,
 34.1311245114     , 34.7085988822     , 33.9159268084     , 31.9596854108     ,
 29.1189230197     , 25.7896227433     , 22.4509535346     , 19.5491682889     ,
 17.4201522299     , 16.273569915      , 16.1845595708     , 17.0933821183     ,
 18.8284273934     , 21.1369607821     , 23.7394231472     , 26.4045301156     ,
 28.9488092368     , 31.1433695734     , 32.6997965958     , 33.4295274241     ,
 33.4084037562     , 32.9600116717     , 32.4892867318     , 32.3067948855     ,
 32.5195687701     , 33.004108045      , 33.2229765525     , 33.1832317697     ,
 32.2520585905     , 30.3888414296     , 27.6984726162     , 24.3900164608     ,
 20.756160659      , 17.09662955       , 13.6317403517     , 10.4936344469     ,
 7.77314008657     , 5.53784966462     , 3.80662435315     , 2.53705218826     ,
 1.65141112336     , 1.06706019878     , 0.705421095578    , 0.493012039669    ,
 0.369646915363    , 0.297850674257    , 0.262048017214    , 0.256715794453    ,
 0.273809056267    , 0.299235165444    , 0.31833039846     , 0.324744554763    ,
 0.325947418737    , 0.33864415128     , 0.376834545837    , 0.445082906249    ,
 0.541317220428    , 0.660448118336    , 0.79550031852     , 0.944553111651    ,
 1.12234224975     , 1.35754742962     , 1.67107434134     , 2.06241924289     ,
 2.52116686449     , 3.04470052042     , 3.65042605898     , 4.39754516012     ,
 5.40859240289     , 6.85056037201     , 8.88644930308     , 11.6734630336     ,
 15.4352647264     , 20.5222892358     , 27.369569743      , 36.3963383257     ,
 47.9853954261     , 62.5688026532     , 80.6496599871     , 102.616457414     ,
 128.476494978     , 157.768608333     , 189.683770782     , 223.115219911     ,
 256.442664064     , 287.273422529     , 312.503085896     , 328.751907508     ,
 333.01831756      , 323.429946476     , 299.943264384     , 264.743128367     ,
 222.068726404     , 177.282604354     , 135.395508886     , 99.807199196      ,
 71.9536200034     , 51.750558808      , 38.2120470449     , 29.9035564344     ,
 25.2704974238     , 22.880239156      , 21.5539542546     , 20.4417187497     ,
 19.0890483356     , 17.4221428021     , 15.5801109246     , 13.6867078063     ,
 11.7494044832     , 9.74491567838     , 7.74609514906     , 5.92505886316     ,
 4.43966457685     , 3.3362573509      , 2.55025867121     , 1.9738324086      ,
 1.52215814322     , 1.15987191991     , 0.88712255546     , 0.707421383763    ,
 0.604138520921    , 0.540228965524    , 0.47703889642     , 0.395107671853    ,
 0.299514483763    , 0.207071303151    , 0.130599779268    , 0.0742592623872   ,
 0.0370739848262   , 0.0157666555162   , 0.00560879478427  , 0.00177441005506  ,
 0.000950528373839 , 0.0019321577638   , 0.00529210908925  , 0.0125041874533   ,
 0.0243148737889   , 0.038823294956    , 0.0512368029008   , 0.0565963518268   ,
 0.0534654161312   , 0.044887797032    , 0.0356479962004   , 0.028914456211    ,
 0.025418013373    , 0.0244542892379   , 0.0246409051222   , 0.0251254584508   ,
 0.0281202852045   , 0.040011798335    , 0.0676419061241   , 0.11079535635     ,
 0.157363498263    , 0.188705050359    , 0.194400656038    , 0.184038343695    ,
 0.184520066594    , 0.223422065849    , 0.307839816699    , 0.413741648073    ,
 0.500897480468    , 0.546886902975    , 0.566372034979    , 0.595752513235    ,
 0.669535596284    , 0.821124445156    , 1.09370983628     , 1.52603755409     ,
 2.12380963806     , 2.86660731429     , 3.75949457017     , 4.87813951415     ,
 6.37749010211     , 8.48054564352     , 11.428436076      , 15.3507831076     ,
 20.1187426772     , 25.3138862344     , 30.3357429449     , 34.5526861241     ,
 37.4349316298     , 38.6563524146     , 38.1376899977     , 36.0426056179     ,
 32.7665972462     , 28.8803277876     , 24.9848872527     , 21.5706195643     ,
 18.9850281016     , 17.4555702373     , 17.0678136772     , 17.7342375148     ,
 19.2297414637     , 21.2668349208     , 23.5626313774     , 25.8923951842     ,
 28.0928110017     , 29.9973489359     , 31.4007273663     , 32.1389473427     ,
 32.2187525945     , 31.8720709433     , 31.488399241      , 31.4442793677     ,
 31.8921025624     , 32.6371233217     , 32.6357282518     , 32.3336982473     ,
 30.9095204084     , 28.4054717149     , 25.0935840247     , 21.3360449211     ,
 17.5012259252     , 13.8929286021     , 10.6950808824     , 7.97589067332     ,
 5.74267446588     , 3.984604893       , 2.67107862241     , 1.74042403773     ,
 1.11294123225     , 0.711888289741    , 0.470521548121    , 0.333047045992    ,
 0.259369694561    , 0.227575911994    , 0.22782629135     , 0.251888676785    ,
 0.287523381614    , 0.321023325217    , 0.343123636641    , 0.354132791892    ,
 0.365841812621    , 0.39600219355     , 0.458112139085    , 0.556898481854    ,
 0.690578091082    , 0.851173391416    , 1.02431326823     , 1.20040983098     ,
 1.39297865529     , 1.63867483001     , 1.97241914298     , 2.40858482382     ,
 2.94858021394     , 3.59583658491     , 4.36480979341     , 5.29552904089     ,
 6.46665267336     , 7.98445574132     , 9.96971856317     , 12.5942986976     ,
 16.1520446733     , 21.0683490168     , 27.7952947732     , 36.6738562055     ,
 47.9094169167     , 61.7018188651     , 78.3733343978     , 98.2865759391     ,
 121.563557117     , 147.861446225     , 176.389508239     , 206.020654494     ,
 235.23599802      , 261.962908568     , 283.616565385     , 297.439356703     ,
 300.984117        , 292.64399938      , 272.19398821      , 241.205409464     ,
 203.079849648     , 162.44546829      , 123.945127985     , 90.98615585       ,
 65.170223929      , 46.534030213      , 34.1400301726     , 26.6027324836     ,
 22.4522697741     , 20.3567424598     , 19.2326095238     , 18.3034427319     ,
 17.1469757221     , 15.6875538599     , 14.0662713292     , 12.424170982      ,
 10.7637556475     , 9.01170901215     , 7.18612545295     , 5.45376580026     ,
 4.01427034627     , 2.95608783848     , 2.2285370672      , 1.71894578642     ,
 1.33482251859     , 1.0328901458      , 0.805859459695    , 0.655921453351    ,
 0.571994694018    , 0.522218289661    , 0.467833806643    , 0.387386189031    ,
 0.287583085514    , 0.190563684868    , 0.113570821411    , 0.0610034914539   ,
 0.0291070681445   , 0.0120018823561   , 0.00416380250121  , 0.00123644535463  ,
 0.000520959870127 , 0.000980662600561 , 0.00285732121507  , 0.00707777182852  ,
 0.0142354450583   , 0.0233183708762   , 0.0313740594226   , 0.0350633005637   ,
 0.0330763662971   , 0.0270983383639   , 0.0203526802436   , 0.0153106454288   ,
 0.0127373776503   , 0.0122099685883   , 0.0130053434119   , 0.0153269201483   ,
 0.0218890304646   , 0.0379007526944   , 0.0672994860996   , 0.106673489273    ,
 0.142889767094    , 0.16016286897     , 0.153497781961    , 0.136589352493    ,
 0.136345276675    , 0.177283015542    , 0.263727708164    , 0.371234180351    ,
 0.46101921543     , 0.512451899063    , 0.540927627587    , 0.581345942713    ,
 0.664913737565    , 0.823562392933    , 1.10448428805     , 1.55129570161     ,
 2.16068320891     , 2.88169858304     , 3.68982446456     , 4.67416537586     ,
 6.05865054421     , 8.14824582804     , 11.225871828      , 15.4184548875     ,
 20.5890352943     , 26.3335972031     , 32.0716468912     , 37.1425326302     ,
 40.8860084772     , 42.7617250171     , 42.5089946162     , 40.2648036829     ,
 36.5521118217     , 32.1102828996     , 27.6505007801     , 23.7030020505     ,
 20.6318432286     , 18.6921368621     , 17.9909592582     , 18.4205054719     ,
 19.7029576175     , 21.5142738257     , 23.5696231891     , 25.6520958596     ,
 27.6119510936     , 29.3316677895     , 30.6775583751     , 31.5028291671     ,
 31.7335937749     , 31.4849823847     , 31.0961528891     , 30.9908841343     ,
 31.3971336787     , 32.1276100667     , 31.7833819759     , 31.0203422838     ,
 29.0528056955     , 25.9819004794     , 22.1994317044     , 18.1771593828     ,
 14.323858634      , 10.9145184298     , 8.07297527568     , 5.80402202769     ,
 4.05250118654     , 2.74788248689     , 1.81466665083     , 1.17222231634     ,
 0.746102173424    , 0.477528462761    , 0.319663803331    , 0.234204284451    ,
 0.195855093758    , 0.193417439211    , 0.220532340166    , 0.265305290408    ,
 0.310636866408    , 0.343558258749    , 0.362248203217    , 0.376326219906    ,
 0.403011077249    , 0.459402576447    , 0.55458394306     , 0.689755380414    ,
 0.863558439146    , 1.07088348274     , 1.2979766426      , 1.5310709867      ,
 1.77782815614     , 2.0737929657      , 2.46189841086     , 2.97284953514     ,
 3.62723022176     , 4.44288669077     , 5.43497711615     , 6.61776740907     ,
 8.00721286533     , 9.62465766783     , 11.5347487365     , 13.9322075024     ,
 17.2031858275     , 21.8628072394     , 28.3840506652     , 37.0450669089     ,
 47.9143337966     , 61.0032156925     , 76.4673422662     , 94.6194346905     ,
 115.65197307      , 139.308089263     , 164.827235794     , 191.122313758     ,
 216.837429454     , 240.209197629     , 259.056698822     , 271.071569719     ,
 274.214899341     , 267.077898403     , 249.2762137       , 221.872030721     ,
 187.585519999     , 150.456915352     , 114.836811329     , 84.1300623188     ,
 60.0480456003     , 42.7023641027     , 31.193476388      , 24.194681614      ,
 20.3252431572     , 18.3489468912     , 17.2805046993     , 16.4407512182     ,
 15.4645599497     , 14.2577752028     , 12.895808452      , 11.4738776682     ,
 9.99388132027     , 8.39576347258     , 6.69669581326     , 5.05634640303     ,
 3.67665070512     , 2.65658927381     , 1.95745055869     , 1.47824105045     ,
 1.13462163999     , 0.881632154696    , 0.70100016739     , 0.58420698813     ,
 0.517877935604    , 0.475394129391    , 0.42447549197     , 0.347172184382    ,
 0.251177706204    , 0.159209504584    , 0.0890310030308   , 0.0444034890303   ,
 0.019761281056    , 0.00772017797055  , 0.00257993488217  , 0.000736414136319 ,
 0.00026581531408  , 0.000440350507127 , 0.00130605533841  , 0.00330821233078  ,
 0.00677317349255  , 0.011262239966    , 0.0153435545659   , 0.0172905814516   ,
 0.0163020521516   , 0.0131193740447   , 0.0094147812557   , 0.00659214780765  ,
 0.00515881096553  , 0.00498127576905  , 0.00598257049373  , 0.00908514749924  ,
 0.0170421843328   , 0.0337307667872   , 0.0607054472544   , 0.0928099307038   ,
 0.117942840668    , 0.124436392638    , 0.111642408252    , 0.0940334912801   ,
 0.0947871781963   , 0.133162776272    , 0.211174093164    , 0.307383553373    ,
 0.389387314249    , 0.441275325852    , 0.477796251301    , 0.528900948357    ,
 0.620695940289    , 0.782260600204    , 1.05910389007     , 1.4920403314      ,
 2.0723565748      , 2.74292473613     , 3.48221115673     , 4.40538727566     ,
 5.78231475618     , 7.95363353488     , 11.2024247893     , 15.6375290899     ,
 21.1296784978     , 27.3244920252     , 33.6925620854     , 39.5531187908     ,
 44.1114202846     , 46.6233301743     , 46.6746999081     , 44.3865638102     ,
 40.375314502      , 35.4901280426     , 30.5137315855     , 26.0190893892     ,
 22.4153047099     , 20.0148570722     , 18.9678152414     , 19.159819454      ,
 20.2641410582     , 21.9131203575     , 23.8098471765     , 25.7400476784     ,
 27.564708593      , 29.2086459144     , 30.6010438153     , 31.6065485391     ,
 32.0646123188     , 31.9552466885     , 31.5285886156     , 31.2118528116     ,
 31.3000028739     , 31.6693000164     , 30.6149691441     , 29.1434530871     ,
 26.5737725906     , 23.0573513437     , 19.0286983842     , 14.9819477587     ,
 11.311586699      , 8.24261587469     , 5.83371250111     , 4.03088632219     ,
 2.73198110273     , 1.82712150325     , 1.21219319007     , 0.797766590989    ,
 0.521395153683    , 0.34641463151     , 0.245721142111    , 0.193672729984    ,
 0.173534479934    , 0.181340613118    , 0.214883431191    , 0.261871096131    ,
 0.30374140374     , 0.329943856571    , 0.345596465038    , 0.3676513164      ,
 0.416140521948    , 0.504710351249    , 0.635513166177    , 0.805356488312    ,
 1.01654299528     , 1.27531167311     , 1.57863751395     , 1.91299987916     ,
 2.27440238903     , 2.68433128892     , 3.18139465252     , 3.80628702217     ,
 4.59905475752     , 5.59669159818     , 6.81979167566     , 8.25736786084     ,
 9.86053217612     , 11.5666379567     , 13.3888475763     , 15.5451216183     ,
 18.500906435      , 22.8375335647     , 29.0369846456     , 37.3420694607     ,
 47.7543885738     , 60.1732870833     , 74.6185351394     , 91.3157589678     ,
 110.458594079     , 131.844930402     , 154.786949102     , 178.311466638     ,
 201.250984921     , 222.084550557     , 238.890440114     , 249.636692572     ,
 252.555958648     , 246.393087695     , 230.674577439     , 206.12026188      ,
 174.973584933     , 140.835289947     , 107.781485961     , 79.120803839      ,
 56.569397342      , 40.2792369283     , 29.4186858874     , 22.7554035969     ,
 19.0035170411     , 17.0092344409     , 15.8791333658     , 15.0430843639     ,
 14.2103373498     , 13.2614864543     , 12.1619545741     , 10.9121188642     ,
 9.51072294306     , 7.95954757405     , 6.32367963226     , 4.76086617648     ,
 3.44556083695     , 2.45966572596     , 1.76999365978     , 1.29412437417     ,
 0.96406266532     , 0.7394451124      , 0.594692805995    , 0.509023880423    ,
 0.460670102009    , 0.423416136402    , 0.372122002286    , 0.296261416551    ,
 0.206496947733    , 0.124281694895    , 0.0647497336701   , 0.0295695538564   ,
 0.0119812262819   , 0.0043063651967   , 0.00135093645633  , 0.000366648675785 ,
 0.000116372535726 , 0.000164496548419 , 0.000485685077222 , 0.00124407693853  ,
 0.00257460539314  , 0.00432509163919  , 0.00594813560409  , 0.00674924756766  ,
 0.00636793652146  , 0.00506254010489  , 0.00350694814137  , 0.00230447714981  ,
 0.00170411914127  , 0.00173462209175  , 0.00264355041252  , 0.00550359717238  ,
 0.0125740828263   , 0.0264007243382   , 0.047098087237    , 0.0696179653203   ,
 0.0847350922652   , 0.0851972582741   , 0.0727418557211   , 0.0595645740264   ,
 0.0629437600984   , 0.0964527470463   , 0.160681342877    , 0.23892330425     ,
 0.307195551895    , 0.355358080999    , 0.396607804319    , 0.454195390092    ,
 0.548282738611    , 0.704367692896    , 0.963105577891    , 1.35877255394     ,
 1.88251633532     , 2.49238925696     , 3.19589100361     , 4.13822590269     ,
 5.60173763515     , 7.90752329348     , 11.2978953112     , 15.8656835817     ,
 21.5337801732     , 28.0522311272     , 34.9697072574     , 41.5780118364     ,
 46.9382194579     , 50.1179257609     , 50.5723024082     , 48.3945470866     ,
 44.2399270992     , 39.0099844015     , 33.5416592806     , 28.4774676944     ,
 24.3113861388     , 21.4356179963     , 20.045591954      , 20.0192332776     ,
 20.9828195664     , 22.5212429396     , 24.3138271661     , 26.1423097418     ,
 27.8839809685     , 29.5127501917     , 31.0179540745     , 32.2694167448     ,
 33.0182937263     , 33.1023889104     , 32.6502678668     , 32.0364490495     ,
 31.582296676      , 31.2511480195     , 28.9937966793     , 26.6503464222     ,
 23.4857555953     , 19.7009398921     , 15.6947998167     , 11.8860919097     ,
 8.59223753003     , 5.9728448912      , 4.03231311563     , 2.67410568377     ,
 1.76639886946     , 1.18070636774     , 0.805300851977    , 0.556274762747    ,
 0.387452392595    , 0.280837177405    , 0.222296871914    , 0.191938613115    ,
 0.176372986151    , 0.176728676232    , 0.196592328223    , 0.227804812695    ,
 0.254900971618    , 0.271208512613    , 0.286451468289    , 0.320829666323    ,
 0.393787488924    , 0.513891282431    , 0.676299625487    , 0.874356409413    ,
 1.11634198273     , 1.4249159119      , 1.81517629186     , 2.27917219475     ,
 2.79942908339     , 3.37453689718     , 4.02780527628     , 4.79963317946     ,
 5.73914516682     , 6.89336622623     , 8.28568692413     , 9.88929883947     ,
 11.6152160709     , 13.3513722939     , 15.0831053583     , 17.0393637732     ,
 19.714373686      , 23.6992096076     , 29.465510069      , 37.2569455827     ,
 47.0849839944     , 58.8178106966     , 72.3803251919     , 87.891474954      ,
 105.501205363     , 125.052505451     , 145.962803354     , 167.391345096     ,
 188.32319304      , 207.4022651       , 222.860344695     , 232.804555694     ,
 235.607183747     , 230.122435305     , 215.878354892     , 193.447802517     ,
 164.812294944     , 133.260041507     , 102.56639281      , 75.8125873158     ,
 54.6102289308     , 39.1408020038     , 28.6948633488     , 22.1801856292     ,
 18.4144747674     , 16.316069014      , 15.0718086346     , 14.2082783589     ,
 13.4954973076     , 12.7773418652     , 11.8993823412     , 10.7594027411     ,
 9.35624798599     , 7.77152312192     , 6.13690725187     , 4.6118721946      ,
 3.33481200228     , 2.36296955219     , 1.66621884122     , 1.17834383258     ,
 0.844447320739    , 0.629627054233    , 0.506841292746    , 0.447405557485    ,
 0.418848001605    , 0.38906959611     , 0.336240237179    , 0.258260219976    ,
 0.171532115583    , 0.0972529484694   , 0.0470245023922   , 0.0195697251609   ,
 0.00711556912207  , 0.00228787029874  , 0.000650062955395 , 0.000162346291109 ,
 4.42989340043e-05 , 5.00405086186e-05 , 0.000144378838158 , 0.000372071852143 ,
 0.000775820745749 , 0.00131365357798  , 0.00182059156704  , 0.00207835424322  ,
 0.00196413007096  , 0.00154914803136  , 0.00104532910118  , 0.00065259187857  ,
 0.000468485085668 , 0.000561600403484 , 0.00120908524321  , 0.00323340761571  ,
 0.00812428151822  , 0.01730023287     , 0.0303284280806   , 0.0435128367336   ,
 0.0511283833083   , 0.0495377559253   , 0.0410529781347   , 0.034175036475    ,
 0.0402070887002   , 0.0679578284254   , 0.117539858945    , 0.177397070792    ,
 0.231848549883    , 0.276005233651    , 0.320851207062    , 0.382446004791    ,
 0.474803274198    , 0.620067047415    , 0.854871245381    , 1.20852464657     ,
 1.67567712616     , 2.23666186094     , 2.93363609352     , 3.93388672091     ,
 5.50505338322     , 7.9154795672      , 11.3522601801     , 15.9131400812     ,
 21.6227976722     , 28.3844154885     , 35.8434121714     , 43.2529268596     ,
 49.5117151969     , 53.4835624367     , 54.4672308837     , 52.489497932      ,
 48.2174797747     , 42.6139744765     , 36.6103791785     , 30.9625099776     ,
 26.2683985803     , 22.9841665029     , 21.3159680697     , 21.1112213025     ,
 21.9514562847     , 23.3859056618     , 25.0755437418     , 26.8021801023     ,
 28.4674156453     , 30.0924124809     , 31.7077106236     , 33.1760390983     ,
 34.177867937      , 34.4370958767     , 33.9564621505     , 33.0085394969     ,
 31.8850761792     , 30.6302201833     , 26.83365838       , 23.6349073628     ,
 19.9881502744     , 16.1390203176     , 12.4000777533     , 9.04856346106     ,
 6.27738983661     , 4.16789583586     , 2.68424685826     , 1.71046045264     ,
 1.106991685       , 0.74730187272     , 0.530546818529    , 0.389446056047    ,
 0.294257797033    , 0.238298182406    , 0.212466814486    , 0.197790281218    ,
 0.181509311517    , 0.167838751144    , 0.165861583403    , 0.173884541805    ,
 0.182459583731    , 0.189118209882    , 0.205325905649    , 0.250848749822    ,
 0.342783372156    , 0.48574628963     , 0.670472201878    , 0.887744457964    ,
 1.14930508733     , 1.49108451546     , 1.94780186611     , 2.52415773839     ,
 3.1962034354      , 3.94086431928     , 4.76096036024     , 5.68537604745     ,
 6.75414459514     , 8.00414738054     , 9.45355265979     , 11.0771014829     ,
 12.7881424107     , 14.4743157677     , 16.1180821226     , 17.9355905648     ,
 20.3855305229     , 24.0084346426     , 29.2516403928     , 36.3951530688     ,
 45.5223362225     , 56.5363785065     , 69.3132835853     , 83.873441243      ,
 100.309807864     , 118.505318914     , 137.977280419     , 157.983809437     ,
 177.612319356     , 195.632312512     , 210.374557498     , 219.970428524     ,
 222.793952258     , 217.753179136     , 204.461953732     , 183.531464786     ,
 156.873389313     , 127.561203492     , 99.0269891057     , 74.0046324268     ,
 53.9235165342     , 39.0117406225     , 28.7451980625     , 22.215166178      ,
 18.3514870869     , 16.1344269196     , 14.8072920304     , 13.9524716547     ,
 13.3578200631     , 12.8161938405     , 12.0771988223     , 10.9710452415     ,
 9.51102370708     , 7.8494040901      , 6.17111136486     , 4.63465826772     ,
 3.35008758907     , 2.35907315719     , 1.63664368731     , 1.12650135703     ,
 0.778345094457    , 0.559412381742    , 0.444510269917    , 0.402087580898    ,
 0.390431311989    , 0.368902425882    , 0.315533843091    , 0.235078486419    ,
 0.14979277361     , 0.0810798657495   , 0.0373244762819   , 0.0147221566166   ,
 0.00502860872702  , 0.00149939448168  , 0.000390122863736 , 8.80359323493e-05 ,
 1.9181535984e-05  , 1.30005886438e-05 , 3.4121307685e-05  , 8.8019789128e-05  ,
 0.00018459417442  , 0.00031459596018  , 0.000438845817379 , 0.000503669012008 ,
 0.000476993270364 , 0.000374365489823 , 0.000247944348035 , 0.000149594725405 ,
 0.000111922777052 , 0.000185633506598 , 0.000551507487942 , 0.00168101013547  ,
 0.00436210551563  , 0.00924812738413  , 0.0159086276939   , 0.0222395729001   ,
 0.0253718733478   , 0.0238961608379   , 0.0196420270822   , 0.0176405810417   ,
 0.0245314466933   , 0.0457887216861   , 0.0818220989819   , 0.126034581515    ,
 0.169937298885    , 0.212485647884    , 0.261785564241    , 0.327076226188    ,
 0.416909191632    , 0.551088217563    , 0.764635247353    , 1.08488741195     ,
 1.51002093688     , 2.03729833716     , 2.73365650521     , 3.77641482283     ,
 5.40943864355     , 7.85110033502     , 11.2518784737     , 15.7405448068     ,
 21.4644300864     , 28.4903502706     , 36.5646883517     , 44.903254128      ,
 52.2295319377     , 57.1559652892     , 58.7507330152     , 56.9268221517     ,
 52.392221115      , 46.2615652758     , 39.6470296194     , 33.4491250236     ,
 28.3426887111     , 24.7867779353     , 22.9370053136     , 22.5803664906     ,
 23.2667652096     , 24.5483773426     , 26.1043320536     , 27.7339606836     ,
 29.3510685767     , 30.9772428063     , 32.6268719895     , 34.141331918      ,
 35.1851481577     , 35.4495018646     , 34.8516214757     , 33.5398162085     ,
 31.7261624675     , 29.5081080751     , 24.1745501452     , 20.3180900104     ,
 16.3900236353     , 12.6662236411     , 9.35954017143     , 6.59018688528     ,
 4.41090063922     , 2.81808301532     , 1.74471381027     , 1.07567624725     ,
 0.685485975474    , 0.467016967575    , 0.341643724043    , 0.262566699818    ,
 0.213024791967    , 0.190980708692    , 0.188099598522    , 0.185924679734    ,
 0.17210858652     , 0.151013005504    , 0.133488366774    , 0.122882274373    ,
 0.116247209793    , 0.115094635219    , 0.130675795398    , 0.180158036718    ,
 0.278239661662    , 0.42856652317     , 0.621401765906    , 0.845268109153    ,
 1.1087126864      , 1.45054486813     , 1.9202154349      , 2.54201570565     ,
 3.2999855142      , 4.16045253068     , 5.10633657649     , 6.14529981597     ,
 7.29202232395     , 8.55724658572     , 9.94941113532     , 11.4607865592     ,
 13.040042007      , 14.6075807002     , 16.1549394555     , 17.8647811181     ,
 20.1188336459     , 23.375556692      , 28.0544882009     , 34.4868772076     ,
 42.8511167762     , 53.1222720753     , 65.1742586694     , 78.962604258      ,
 94.5287660658     , 111.777918211     , 130.297972526     , 149.421143997     ,
 168.333248529     , 185.930312295     , 200.593683533     , 210.356167119     ,
 213.454917216     , 208.789943154     , 196.115981877     , 176.221505435     ,
 151.09416643      , 123.665868393     , 97.0004545981     , 73.4200469924     ,
 54.1517288885     , 39.5123399579     , 29.2179004595     , 22.5683537251     ,
 18.6006865888     , 16.3327142675     , 15.0195876744     , 14.2395136894     ,
 13.7519317318     , 13.3012231206     , 12.5928300691     , 11.4457245005     ,
 9.90198481637     , 8.15681838098     , 6.41695018955     , 4.83339459277     ,
 3.50108882755     , 2.45893633427     , 1.68943783137     , 1.14183100907     ,
 0.765836374194    , 0.528285091386    , 0.405268079564    , 0.364188437545    ,
 0.35778826714     , 0.339915409006    , 0.28832925087     , 0.211290034081    ,
 0.132706391427    , 0.07175501957     , 0.0337514164292   , 0.013945488674    ,
 0.005066832523    , 0.00160003425454  , 0.000430128012983 , 9.63399910546e-05 ,
 1.80683112501e-05 , 4.51507571436e-06 , 6.58026917812e-06 , 1.64372858153e-05 ,
 3.45947158581e-05 , 5.92767142925e-05 , 8.31451912559e-05 , 9.58726178261e-05 ,
 9.09995856151e-05 , 7.12157730695e-05 , 4.66003552057e-05 , 2.79066216063e-05 ,
 2.49707142047e-05 , 6.28303925206e-05 , 0.000226877650701 , 0.000727261178262 ,
 0.00189822120939  , 0.00398521290896  , 0.00673711225587  , 0.00921036159139  ,
 0.0102490067269   , 0.00946100308366  , 0.00792800858679  , 0.00823485690407  ,
 0.0139775263204   , 0.0285676387778   , 0.0531136349441   , 0.0852695822      ,
 0.12199143527     , 0.164227557753    , 0.216752532762    , 0.283379192787    ,
 0.369117434484    , 0.492561239442    , 0.687824906002    , 0.980852781535    ,
 1.37136105234     , 1.86595116098     , 2.54488327362     , 3.58810445424     ,
 5.22289357556     , 7.64514026201     , 11.0062834923     , 15.4875459512     ,
 21.3459654309     , 28.7782382684     , 37.6100608146     , 47.0228396819     ,
 55.5641710562     , 61.5542629799     , 63.7619799079     , 61.958410651      ,
 56.9548184775     , 50.1341492757     , 42.87237883       , 36.2157438272     ,
 30.8540977543     , 27.1704990355     , 25.2096927444     , 24.6776970998     ,
 25.119288842      , 26.150681757      , 27.5318418011     , 29.1028116961     ,
 30.747373901      , 32.3940677179     , 33.9560540155     , 35.2426637155     ,
 35.9774265219     , 35.9256331032     , 34.9958451936     , 33.2377097855     ,
 30.7704292853     , 27.7124230049     , 21.1592162402     , 16.9546984915     ,
 12.9895294342     , 9.54426200589     , 6.74403560921     , 4.57713682592     ,
 2.97361488741     , 1.85212030979     , 1.12114492612     , 0.67866569668     ,
 0.427434190664    , 0.289563572977    , 0.21150334263     , 0.164231548229    ,
 0.139034731888    , 0.134969504438    , 0.144591774513    , 0.152627817945    ,
 0.148140923954    , 0.132333870254    , 0.112341466104    , 0.0927184079736   ,
 0.0759465370659   , 0.0676102885369   , 0.0783942657694   , 0.122117037952    ,
 0.211332350284    , 0.350997528048    , 0.534054700704    , 0.747212519347    ,
 0.989942549309    , 1.29249473857     , 1.70953592334     , 2.28647032593     ,
 3.02893325767     , 3.90830939936     , 4.89388208984     , 5.96806831959     ,
 7.1141712549      , 8.31481321481     , 9.57028265931     , 10.8936313195     ,
 12.273686969      , 13.6697613661     , 15.0868878746     , 16.6739568087     ,
 18.7345207427     , 21.6475245789     , 25.8012950072     , 31.5556408662     ,
 39.156493512      , 48.6547932919     , 59.9696722225     , 73.0481162097     ,
 87.8996725597     , 104.430061618     , 122.280259942     , 140.882954722     ,
 159.568970981     , 177.360705409     , 192.610088416     , 203.126418134     ,
 206.900243831     , 202.766332875     , 190.626614337     , 171.506212144     ,
 147.544767108     , 121.585404477     , 96.3496972444     , 73.7775614747     ,
 54.9446494238     , 40.3080740288     , 29.8464879542     , 23.0584330853     ,
 19.0589295316     , 16.859463729      , 15.6675833062     , 14.9993851303     ,
 14.5630855784     , 14.0863984468     , 13.2972201635     , 12.0555124899     ,
 10.4336452337     , 8.63125402111     , 6.84053934056     , 5.19719904872     ,
 3.79268625606     , 2.67361363701     , 1.8328302602      , 1.2259612161      ,
 0.804287961245    , 0.533256658901    , 0.386311239525    , 0.328277232713    ,
 0.310725902998    , 0.288481460308    , 0.241137826755    , 0.176363718648    ,
 0.113332985819    , 0.0651000613752   , 0.0338549215636   , 0.0158424692673   ,
 0.00650192874392  , 0.00226474462896  , 0.000650798218657 , 0.000151249920204 ,
 2.81312134081e-05 , 4.40551352254e-06 , 1.39571860575e-06 , 2.45119419521e-06 ,
 5.09938174317e-06 , 8.77272480585e-06 , 1.2362065313e-05  , 1.43111982205e-05 ,
 1.36133939258e-05 , 1.06385213719e-05 , 6.92489859641e-06 , 4.31925141197e-06 ,
 5.54617571592e-06 , 1.98625648144e-05 , 7.82140815287e-05 , 0.00025451537834  ,
 0.000662414825693 , 0.00137675132024  , 0.00229308121629  , 0.00307661344522  ,
 0.00335454931769  , 0.00306688961202  , 0.00272638543584  , 0.00351649047081  ,
 0.0072975678851   , 0.0163065204438   , 0.0322972158269   , 0.0558473705425   ,
 0.0870886307468   , 0.127137719055    , 0.177616962333    , 0.239216998509    ,
 0.315995269509    , 0.425883295342    , 0.600354524467    , 0.862186893168    ,
 1.21178369049     , 1.6626100562      , 2.30311064091     , 3.31407935137     ,
 4.91800901723     , 7.3186094325      , 10.7066971546     , 15.3362257932     ,
 21.5542401157     , 29.6366585867     , 39.4427961403     , 50.1048997717     ,
 60.000985853      , 67.156763144      , 70.0210529851     , 68.210755427      ,
 62.6680490006     , 55.1018684134     , 47.1940759815     , 40.132440863      ,
 34.5812907655     , 30.8006318179     , 28.6931438697     , 27.8784368866     ,
 27.92217012       , 28.5598674958     , 29.6912779509     , 31.2156800208     ,
 32.9390355266     , 34.6056948588     , 35.9512641567     , 36.7366515053     ,
 36.7883303363     , 36.0234735295     , 34.4324850901     , 32.0510231119     ,
 28.9522635645     , 25.2564605222     , 17.9880369231     , 13.7643172922     ,
 10.0008302216     , 6.94654245987     , 4.65631269396     , 3.02992575883     ,
 1.91538980823     , 1.17753599931     , 0.710294018675    , 0.429016765106    ,
 0.267249285685    , 0.176250250503    , 0.123816336861    , 0.0931490454605   ,
 0.0794791916216   , 0.0821034984452   , 0.0962503766744   , 0.112258052747    ,
 0.121461010714    , 0.120019442306    , 0.107578533825    , 0.0863995794075   ,
 0.0627748042624   , 0.0465562044634   , 0.0485724958596   , 0.0794400910145   ,
 0.149196756196    , 0.263966740438    , 0.420097223792    , 0.603776279669    ,
 0.804847715988    , 1.03914714872     , 1.35595390882     , 1.81407814395     ,
 2.4442370562      , 3.23584381013     , 4.1564027872      , 5.16861780128     ,
 6.22907321697     , 7.29914501607     , 8.37275730245     , 9.47399690549     ,
 10.6168149768     , 11.792551974      , 13.0274108714     , 14.4551013011     ,
 16.3240859475     , 18.9492859601     , 22.6741736852     , 27.8363204878     ,
 34.6915093987     , 43.3501162267     , 53.8180482664     , 66.0976678019     ,
 80.2014203522     , 96.0378986375     , 113.322228159     , 131.649758551     ,
 150.538250294     , 169.093978529     , 185.542892973     , 197.394456275     ,
 202.347528741     , 199.120748466     , 187.703512565     , 169.318612322     ,
 146.254857923     , 121.307514197     , 96.9523167849     , 74.8789812735     ,
 56.1159852777     , 41.2889608907     , 30.6057656003     , 23.7149712544     ,
 19.7684588745     , 17.7292739057     , 16.7097768348     , 16.1300802035     ,
 15.6514195441     , 15.0280609619     , 14.0653389227     , 12.6960384274     ,
 11.0147017809     , 9.19104604405     , 7.37218089788     , 5.66933103291     ,
 4.17747602716     , 2.96087626732     , 2.02957522393     , 1.34984739412     ,
 0.875747568285    , 0.567655666596    , 0.39015743319     , 0.303162370346    ,
 0.261379781604    , 0.226998341544    , 0.183669214096    , 0.135453769369    ,
 0.0923807776695   , 0.059150931397    , 0.0350765634984   , 0.0184966290256   ,
 0.00829624305051  , 0.00306208668441  , 0.000911151275209 , 0.000215983560866 ,
 4.0508463339e-05  , 6.01424717601e-06 , 7.99479650751e-07 , 3.4059196541e-07  ,
 5.93790468418e-07 , 1.01847949641e-06 , 1.4403985034e-06  , 1.67306743167e-06 ,
 1.59466932309e-06 , 1.24590656494e-06 , 8.14732052426e-07 , 5.79355062831e-07 ,
 1.21269780511e-06 , 5.36985889214e-06 , 2.18344957379e-05 , 7.12315088529e-05 ,
 0.000184503797125 , 0.000380140460976 , 0.000625500513276 , 0.000826529954212 ,
 0.000887741848066 , 0.000817183512536 , 0.000821062449058 , 0.00140787371883  ,
 0.00355708423916  , 0.00885357903793  , 0.0193288640037   , 0.0369102258462   ,
 0.062781755823    , 0.0970995149559   , 0.139195891798    , 0.18886737482     ,
 0.251012682645    , 0.34253784908     , 0.489934973801    , 0.711405879229    ,
 1.00971884246     , 1.40739416036     , 2.00029390058     , 2.96915595529     ,
 4.53873244978     , 6.94159392454     , 10.440563719      , 15.3911732981     ,
 22.2334801798     , 31.2933077399     , 42.423808039      , 54.6883845401     ,
 66.3047117676     , 75.0196870424     , 78.9470295831     , 77.4869614595     ,
 71.6326813131     , 63.3755728843     , 54.719137517      , 47.0426713347     ,
 41.0334508773     , 36.8634047388     , 34.3186148698     , 32.948972578      ,
 32.3500949277     , 32.3856786751     , 33.1053820391     , 34.4685691162     ,
 36.1860282402     , 37.785556116      , 38.7871449747     , 38.8674602786     ,
 37.9353142826     , 36.0807718427     , 33.4591312542     , 30.2131499766     ,
 26.4599343982     , 22.3211928373     , 14.8833959606     , 10.9010358627     ,
 7.52549790352     , 4.93206543792     , 3.11404987875     , 1.92428600317     ,
 1.17639630845     , 0.714977775074    , 0.433019850709    , 0.262519295143    ,
 0.161146763537    , 0.101825618353    , 0.0670435691039   , 0.0472843554397   ,
 0.039552658955    , 0.0436210651729   , 0.0581211903212   , 0.0791453200729   ,
 0.10049905118     , 0.113955426885    , 0.111739457463    , 0.0924780626617   ,
 0.0644667781085   , 0.0410947811913   , 0.0338674665852   , 0.0507866018002   ,
 0.0987321313041   , 0.182980829482    , 0.301749135437    , 0.442503232225    ,
 0.59031856069     , 0.748495158873    , 0.953468978199    , 1.26341305937     ,
 1.72517630106     , 2.35030847271     , 3.11751156914     , 3.98317737091     ,
 4.88809652546     , 5.77956998196     , 6.64346763746     , 7.502288784       ,
 8.37981053225     , 9.29356105688     , 10.2989491165     , 11.532388486      ,
 13.2075857273     , 15.5851714765     , 18.9470029093     , 23.5650684006     ,
 29.6591255048     , 37.3795593204     , 46.8360432875     , 58.1255347943     ,
 71.3047514239     , 86.3292694273     , 103.048711205     , 121.274619386     ,
 140.698397414     , 160.427592543     , 178.502264109     , 192.153222581     ,
 198.81713296      , 197.037488941     , 186.755505975     , 169.263468167     ,
 146.943535539     , 122.594616314     , 98.6056306197     , 76.6070942301     ,
 57.6847685948     , 42.6052888798     , 31.7138970245     , 24.7407692849     ,
 20.850903831      , 18.9534699107     , 18.0615419076     , 17.501396812      ,
 16.9003835916     , 16.056416238      , 14.8641178301     , 13.3330207789     ,
 11.5771977202     , 9.72888335892     , 7.88066481053     , 6.11311218095     ,
 4.52562491234     , 3.20658087659     , 2.18932675576     , 1.45159289315     ,
 0.945190720949    , 0.617677815815    , 0.418888853659    , 0.303155037844    ,
 0.232202729076    , 0.179932904711    , 0.135762598815    , 0.0998099926159   ,
 0.0728512528997   , 0.0519960377037   , 0.0341930483705   , 0.0194214764868   ,
 0.00911909676918  , 0.00345506196173  , 0.00104310759918  , 0.0002492343238   ,
 4.69388248278e-05 , 6.95173126995e-06 , 8.1659404023e-07  , 9.85132827619e-08 ,
 5.86396681144e-08 , 9.28662255278e-08 , 1.31383187661e-07 , 1.53013797929e-07 ,
 1.46105934485e-07 , 1.14297933121e-07 , 7.65297328545e-08 , 7.19013175175e-08 ,
 2.41920875737e-07 , 1.18507624808e-06 , 4.86923313698e-06 , 1.58664503102e-05 ,
 4.09118168715e-05 , 8.37040742142e-05 , 0.000136416549106 , 0.000178163997127 ,
 0.000189906592962 , 0.000181824126261 , 0.000230959973195 , 0.000562931307916 ,
 0.00173758131095  , 0.0049212918755   , 0.0119897267752   , 0.0249929582845   ,
 0.0449287991189   , 0.0709258631608   , 0.101222038931    , 0.135908872332    ,
 0.180779039059    , 0.250643719407    , 0.365911940443    , 0.540852298666    ,
 0.783494152109    , 1.12779846092     , 1.67591934912     , 2.60593800008     ,
 4.14721787093     , 6.57525656655     , 10.2552760252     , 15.6877938393     ,
 23.4475786613     , 33.938138074      , 47.0260789786     , 61.7271466663     ,
 76.1065667483     , 87.5845766614     , 93.7958801587     , 93.6922986212     ,
 88.0851714831     , 79.1364332314     , 69.2336913384     , 60.1239445985     ,
 52.7077755464     , 47.2229546371     , 43.4492782939     , 40.9227047182     ,
 39.2554291657     , 38.3702666072     , 38.3887957445     , 39.2928489657     ,
 40.7151104012     , 42.0057575372     , 42.4785100591     , 41.6842022201     ,
 39.5543961011     , 36.3341263746     , 32.3973015208     , 28.0898360403     ,
 23.6483152293     , 19.2044556158     , 12.0337549386     , 8.4366232428      ,
 5.5523233632      , 3.44601394932     , 2.04753492925     , 1.19053135292     ,
 0.692854042216    , 0.40949995105     , 0.245722021697    , 0.14797597215     ,
 0.0887368097982   , 0.0533133568825   , 0.0326007212694   , 0.0212513969968   ,
 0.0173603404181   , 0.0213188907812   , 0.0342690710872   , 0.0562544253135   ,
 0.0832602849818   , 0.105245003063    , 0.110313875731    , 0.0943325240601   ,
 0.0657332653515   , 0.0392728765174   , 0.0266098490791   , 0.0338063391537   ,
 0.0645365784631   , 0.121329462616    , 0.202106493431    , 0.296913646614    ,
 0.392333619756    , 0.485526080445    , 0.598341074572    , 0.776024161325    ,
 1.06675085352     , 1.49814199601     , 2.06648599149     , 2.73541621453     ,
 3.44298320405     , 4.1294857923      , 4.77163808886     , 5.38324710319     ,
 5.98971945834     , 6.62866914618     , 7.38180832585     , 8.39038954547     ,
 9.83982363584     , 11.9401241444     , 14.9074320595     , 18.9406775767     ,
 24.2157010849     , 30.9086536823     , 39.2131225744     , 49.3157291303     ,
 61.3507590252     , 75.3888056228     , 91.4786064902     , 109.657898726     ,
 129.730873163     , 150.73938986      , 170.564702395     , 186.278288031     ,
 195.129533059     , 195.40504654      , 186.8010904       , 170.497903846     ,
 148.90284733      , 124.894348384     , 100.955454922     , 78.8332943735     ,
 59.7269844097     , 44.4678417401     , 33.4239373069     , 26.3449817395     ,
 22.4126213736     , 20.5198136929     , 19.6265052811     , 19.0019996705     ,
 18.2485029894     , 17.1817843063     , 15.7445213717     , 13.9985484973     ,
 12.086873329      , 10.1348328188     , 8.20555040594     , 6.35518021631     ,
 4.68154712629     , 3.2892678777      , 2.22770183083     , 1.4778364705      ,
 0.980879807926    , 0.665671896772    , 0.465437462106    , 0.330491150633    ,
 0.232454175797    , 0.159167808532    , 0.107167547334    , 0.0744140538348   ,
 0.0552641733817   , 0.0417531493013   , 0.0289539450835   , 0.0170306322977   ,
 0.00815801446498  , 0.00312463195496  , 0.000948829122694 , 0.000227410862583 ,
 4.28995725328e-05 , 6.35687568897e-06 , 7.3933451969e-07  , 6.90005252974e-08 ,
 8.57652277891e-09 , 6.85214918651e-09 , 9.38119298743e-09 , 1.09382743092e-08 ,
 1.04617198657e-08 , 8.21838903383e-09 , 5.8725363347e-09  , 8.64797329192e-09 ,
 4.10135725488e-08 , 2.0962423922e-07  , 8.64009793301e-07 , 2.81134848963e-06 ,
 7.22673993662e-06 , 1.47171180932e-05 , 2.38339459012e-05 , 3.09232882285e-05 ,
 3.32174367511e-05 , 3.58717135609e-05 , 6.93291517002e-05 , 0.000244911195782 ,
 0.000901641245154 , 0.00285434229742  , 0.00752720562007  , 0.0164831350403   ,
 0.0302350556167   , 0.0475043263787   , 0.066467601843    , 0.0876358308099   ,
 0.116579953658    , 0.164972200565    , 0.247556885046    , 0.376455469585    ,
 0.56651389748     , 0.862612607275    , 1.37062567246     , 2.264340358       ,
 3.78140916826     , 6.2544163682      , 10.1839421693     , 16.2771739008     ,
 25.3392384938     , 37.9796140488     , 54.2255761007     , 73.1610951646     ,
 92.6847937287     , 109.647863398     , 120.72953644      , 123.863155163     ,
 119.25353914      , 109.147193817     , 96.5737070855     , 84.0723525831     ,
 73.1538955589     , 64.4146612373     , 57.8248354536     , 53.0000329464     ,
 49.5286319856     , 47.2343771625     , 46.1275059076     , 46.1097404754     ,
 46.7474553013     , 47.2862781665     , 46.8883102172     , 44.9774359253     ,
 41.473884275      , 36.7528204762     , 31.4059321597     , 25.9927519721     ,
 20.8791645714     , 16.210809607      , 9.53443282446     , 6.3681721965      ,
 3.99943379932     , 2.3667074895      , 1.33419483627     , 0.73020585765     ,
 0.398169038537    , 0.221875178364    , 0.127379755321    , 0.0741145510638   ,
 0.0427384838894   , 0.0242901928777   , 0.0138083927064   , 0.00836598682621  ,
 0.00693100988095  , 0.0102652247697   , 0.0204646613601   , 0.0392504880858   ,
 0.0642867220105   , 0.0865213430672   , 0.0941367656712   , 0.0821975587314   ,
 0.057733591103    , 0.0340346168352   , 0.0215200623079   , 0.0248166626734   ,
 0.0452090719397   , 0.0821238487143   , 0.132014847011    , 0.187734623064    ,
 0.241011725691    , 0.288753417813    , 0.341390880805    , 0.426790070523    ,
 0.583000903523    , 0.842307807589    , 1.21511731773     , 1.67881141629     ,
 2.18024143835     , 2.6622640658      , 3.09654593683     , 3.48766239188     ,
 3.85769681605     , 4.25266203128     , 4.7642347619      , 5.52677655155     ,
 6.69548511373     , 8.43442586141     , 10.9062008807     , 14.2599386593     ,
 18.6472084847     , 24.2586202816     , 31.3296444649     , 40.1062776382     ,
 50.8198892214     , 63.7054125563     , 79.0285302314     , 97.0107103251     ,
 117.512707822     , 139.526740219     , 160.901447634     , 178.713125309     ,
 190.091519316     , 192.969485045     , 186.598003576     , 171.867111359     ,
 151.147229167     , 127.46520705      , 103.534799752     , 81.3249138809     ,
 62.159810393      , 46.8709978814     , 35.7716954721     , 28.5863644116     ,
 24.5116290532     , 22.4618516642     , 21.4087618454     , 20.6245560338     ,
 19.7018882511     , 18.4347618112     , 16.7491044862     , 14.7173514768     ,
 12.5226101144     , 10.3352602484     , 8.2406848863      , 6.29058161483     ,
 4.56843179555     , 3.16763056152     , 2.12881088876     , 1.42233071987     ,
 0.975269051012    , 0.699864826287    , 0.516026180181    , 0.372474839995    ,
 0.252152185006    , 0.157651897596    , 0.0934509149267   , 0.0570936768554   ,
 0.0392315266802   , 0.0290951973032   , 0.0203167213193   , 0.0120668355869   ,
 0.00581946861194  , 0.00223778920922  , 0.000681016891051 , 0.000163415795224 ,
 3.08468973256e-05 , 4.5723463013e-06  , 5.31454191894e-07 , 4.84669618006e-08 ,
 3.65437517461e-09 , 5.57931433716e-10 , 5.30484864912e-10 , 6.10958928296e-10 ,
 5.85175478931e-10 , 4.65049096671e-10 , 3.90649492979e-10 , 1.03249264123e-09 ,
 6.07078724239e-09 , 3.21902027542e-08 , 1.36059392378e-07 , 4.55897697217e-07 ,
 1.21445404606e-06 , 2.58161265635e-06 , 4.39873569167e-06 , 6.06479051647e-06 ,
 7.11971093107e-06 , 9.58425525198e-06 , 2.69690228182e-05 , 0.000117950054498 ,
 0.000481804311145 , 0.00162890865763  , 0.00447853754643  , 0.0100225023155   ,
 0.0184546257942   , 0.0286416998299   , 0.0391569893614   , 0.0505750881914   ,
 0.0673058120724   , 0.0977103809236   , 0.152117813593    , 0.241580963564    ,
 0.386371284694    , 0.638664583085    , 1.10559231283     , 1.95907300156     ,
 3.45431514511     , 6.00021514081     , 10.2741504042     , 17.2817322713     ,
 28.2395151451     , 44.2569158516     , 65.8855968995     , 92.5495326391     ,
 121.900732391     , 149.586759799     , 170.215870046     , 179.527844705     ,
 176.436699218     , 163.383831253     , 144.792029484     , 124.927627316     ,
 106.639673509     , 91.3034845159     , 79.2839411638     , 70.333947234      ,
 63.9173407436     , 59.5137523697     , 56.7429411592     , 55.2439548221     ,
 54.4754645509     , 53.6345447257     , 51.8196781788     , 48.401828369      ,
 43.3251987905     , 37.0803637257     , 30.4152399353     , 24.0217904038     ,
 18.3380270194     , 13.5140076018     , 7.384464087       , 4.65870818824     ,
 2.78122118111     , 1.57624894748     , 0.854031972662    , 0.446259647728    ,
 0.228131686344    , 0.11681043147     , 0.0612474109958   , 0.032889804942    ,
 0.0177179908995   , 0.00943230841453  , 0.00500875167219  , 0.00288978336137  ,
 0.00263697447256  , 0.00500079963931  , 0.0118440077484   , 0.024948495264    ,
 0.0431126108932   , 0.0599086160051   , 0.0664623890338   , 0.0587293535481   ,
 0.0415774936787   , 0.0247946017318   , 0.0162846483317   , 0.0194981793843   ,
 0.0345015383475   , 0.0587264029187   , 0.0874697969785   , 0.11585331074     ,
 0.140731736817    , 0.161341282727    , 0.181628087445    , 0.215073313262    ,
 0.285894369229    , 0.421312670368    , 0.63695587079     , 0.922555298272    ,
 1.24024938099     , 1.54483019565     , 1.81029921182     , 2.03516226229     ,
 2.234610878       , 2.44959648806     , 2.7619970693      , 3.28461077458     ,
 4.13939782216     , 5.45109858507     , 7.34574143421     , 9.94950637626     ,
 13.4084872624     , 17.9157508293     , 23.713085545      , 31.0830770839     ,
 40.3610475331     , 51.9484089671     , 66.2816788417     , 83.6939457732     ,
 104.093760833     , 126.537270206     , 149.024689177     , 168.774321028     ,
 182.815872709     , 188.648871927     , 184.95750261      , 172.228262907     ,
 152.728579259     , 129.629975651     , 105.907775194     , 83.7786959989     ,
 64.7069894792     , 49.5381237548     , 38.5305962938     , 31.3515428813     ,
 27.1655666823     , 24.8917760726     , 23.5500031169     , 22.4782035683     ,
 21.3013820869     , 19.7881000407     , 17.8105692805     , 15.4165007705     ,
 12.8281601338     , 10.2982996998     , 7.98006901166     , 5.93925253789     ,
 4.22752939733     , 2.89210071106     , 1.9370962158      , 1.3130870195      ,
 0.937802301057    , 0.715158592116    , 0.557006287331    , 0.412056006304    ,
 0.274543395688    , 0.161629698346    , 0.0857193013869   , 0.0444006428087   ,
 0.0257104464611   , 0.0172162183276   , 0.0115934816049   , 0.00682627329773  ,
 0.00328869956256  , 0.00126521747357  , 0.000385241133085 , 9.24744302802e-05 ,
 1.74593609977e-05 , 2.58824022553e-06 , 3.00837007291e-07 , 2.7386664744e-08  ,
 1.95888705163e-09 , 1.24424498439e-10 , 2.743865805e-11   , 2.67805736302e-11 ,
 2.57117611415e-11 , 2.33941653277e-11 , 5.88713648861e-11 , 4.89984797251e-10 ,
 3.9987294741e-09  , 2.61327495571e-08 , 1.35232417904e-07 , 5.53946057602e-07 ,
 1.79683741008e-06 , 4.61752978249e-06 , 9.40551081473e-06 , 1.52004293862e-05 ,
 1.96155384296e-05 , 2.12785071607e-05 , 2.66160017631e-05 , 6.96261280034e-05 ,
 0.000269197087334 , 0.000940906215098 , 0.00267532832415  , 0.00612618415458  ,
 0.0113822030994   , 0.0175004571677   , 0.0232053387755   , 0.0287248164665   ,
 0.0372826040951   , 0.0549293863398   , 0.0891322606554   , 0.149748153519    ,
 0.258859844305    , 0.470689575122    , 0.891586195972    , 1.69657974426     ,
 3.172023413       , 5.82992512013     , 10.5848292074     , 18.8882370564     ,
 32.6892619466     , 54.1544688698     , 85.067053338      , 125.700555487     ,
 173.2288197       , 220.73964954      , 258.529961652     , 277.97757332      ,
 275.722488824     , 255.057001746     , 223.570044116     , 189.12293929      ,
 157.121426475     , 130.185491634     , 109.089449213     , 93.5648110891     ,
 82.6999544376     , 75.2977157118     , 70.2493293054     , 66.6917096614     ,
 63.872492458      , 60.9504786275     , 57.0526494096     , 51.6259646503     ,
 44.7325201356     , 36.9785905423     , 29.1781722386     , 22.0345066304     ,
 15.9702457895     , 11.1099274619     , 5.54044907677     , 3.27444634456     ,
 1.84443510989     , 0.99940264696     , 0.524938089117    , 0.266933207212    ,
 0.130619798278    , 0.0617050630767   , 0.0287233103797   , 0.0135415017388   ,
 0.00656792829272  , 0.00329331940532  , 0.00172715262439  , 0.00103423842422  ,
 0.00107862297719  , 0.00239383202389  , 0.00616798597359  , 0.0135806590938   ,
 0.0240853239248   , 0.0340106496869   , 0.038115907221    , 0.033906109552    ,
 0.0241833893126   , 0.0148447217808   , 0.0109143219604   , 0.0147883157192   ,
 0.0262034121685   , 0.0421472827193   , 0.0579373986904   , 0.0703230234543   ,
 0.0792270018278   , 0.0858715031014   , 0.0915894897683   , 0.101359931477    ,
 0.127886166104    , 0.189185613559    , 0.298643636012    , 0.453289697382    ,
 0.630740224024    , 0.801827764217    , 0.948096005203    , 1.06585739409     ,
 1.163025159       , 1.2681564933      , 1.44143277916     , 1.76523987798     ,
 2.32713672533     , 3.21785563683     , 4.53702047068     , 6.39910222534     ,
 8.94691493389     , 12.3637785491     , 16.8815786092     , 22.8107896574     ,
 30.5795418675     , 40.716042508      , 53.7543166621     , 70.0825904836     ,
 89.6984376028     , 111.876642729     , 134.938432742     , 156.316851849     ,
 172.924007337     , 181.805428127     , 181.081322681     , 170.805235473     ,
 153.048843717     , 131.012420296     , 107.847648855     , 85.9952565595     ,
 67.1103346723     , 52.1511599149     , 41.3915313595     , 34.4228416643     ,
 30.2932782807     , 27.8508972393     , 26.1478109329     , 24.6287209417     ,
 23.0140319703     , 21.0986520587     , 18.7234421252     , 15.9051441982     ,
 12.8897917175     , 10.0081353472     , 7.48663754289     , 5.40369623657     ,
 3.76263337754     , 2.54321215814     , 1.70192412776     , 1.17198797292     ,
 0.87063179303     , 0.701339040983    , 0.572052527423    , 0.432014436826    ,
 0.285059511684    , 0.160781731721    , 0.0781832904408   , 0.0346431536975   ,
 0.0160155436465   , 0.00883226385919  , 0.00541566437346  , 0.003089477665    ,
 0.00147435521814  , 0.000565547614909 , 0.000172023313453 , 4.12745155193e-05 ,
 7.79087938947e-06 , 1.15478720331e-06 , 1.34211145707e-07 , 1.22155223619e-08 ,
 8.70074086808e-10 , 4.89449127459e-11 , 2.87702664016e-12 , 1.01523446706e-12 ,
 1.76896304114e-12 , 1.68499865362e-11 , 2.27911773659e-10 , 2.50550684144e-09 ,
 2.16262235329e-08 , 1.46504365566e-07 , 7.79950734039e-07 , 3.26783517217e-06 ,
 1.07910184474e-05 , 2.81231176073e-05 , 5.79107546141e-05 , 9.43023040525e-05 ,
 0.00012154949357  , 0.000124633838878 , 0.000106440583299 , 0.000104274268903 ,
 0.000227537626656 , 0.000755920746491 , 0.0022426014603   , 0.0053537552405   ,
 0.0102024052042   , 0.0156598061995   , 0.019874975355    , 0.02233313038     ,
 0.0256850625758   , 0.0353373918196   , 0.0575821913136   , 0.100842585149    ,
 0.18570496679     , 0.363678361346    , 0.737775645689    , 1.4893368056      ,
 2.94894042651     , 5.7656869174      , 11.1817301306     , 21.3315580888     ,
 39.4308516682     , 69.6474701675     , 116.195325549     , 181.010310597     ,
 260.222630223     , 341.784371387     , 407.693088567     , 441.448635586     ,
 436.331357255     , 398.334933772     , 341.712057222     , 281.122932075     ,
 226.26045109      , 181.273547817     , 146.869345508     , 122.132214459     ,
 105.244223101     , 93.9076459064     , 85.956497344      , 79.8038391944     ,
 74.3684315417     , 68.7455192976     , 62.1561813795     , 54.2499316589     ,
 45.3133163396     , 36.0830281977     , 27.3635589592     , 19.760827864      ,
 13.5920718141     , 8.90107474403     , 3.96960221802     , 2.18948405523     ,
 1.15582780533     , 0.5943535206      , 0.302031771908    , 0.150906673789    ,
 0.0723544784167   , 0.0325460824525   , 0.0137909530342   , 0.00583601890518  ,
 0.00282832646255  , 0.00177714070535  , 0.0013324699688   , 0.00101460851653  ,
 0.000855457682598 , 0.00124089125634  , 0.0028090026387   , 0.00613730871692  ,
 0.0109801267777   , 0.0156240307124   , 0.0175993835646   , 0.0157135476707   ,
 0.0113030978246   , 0.00727862503565  , 0.00631373750549  , 0.00988692451515  ,
 0.0177938824556   , 0.027656323276    , 0.0358684717986   , 0.0403800160625   ,
 0.0421155862814   , 0.0428883174335   , 0.0433130883862   , 0.0446917563833   ,
 0.0525623978184   , 0.0765504956241   , 0.12498194706     , 0.197754065317    ,
 0.283943906785    , 0.368285771711    , 0.44045256207     , 0.497245333557    ,
 0.541851383629    , 0.590927118961    , 0.681902797142    , 0.866582258068    ,
 1.20041181435     , 1.74404771933     , 2.57326016388     , 3.78777244434     ,
 5.51756444123     , 7.9262473413      , 11.2295307076     , 15.7518435417     ,
 21.9755481806     , 30.4958365014     , 41.8919180093     , 56.6004489272     ,
 74.7737072169     , 96.0239665615     , 119.091928651     , 141.653987223     ,
 160.51366568      , 172.329205862     , 174.750201899     , 167.399190936     ,
 152.01349952      , 131.622659429     , 109.408622443     , 88.0024875348     ,
 69.3244028699     , 54.571719436      , 44.1268736256     , 37.5112451584     ,
 33.5912764057     , 31.0647212698     , 28.9688488948     , 26.8582360277     ,
 24.5986026976     , 22.0867749156     , 19.1983190056     , 15.9438568622     ,
 12.5720594271     , 9.44774485386     , 6.83081661056     , 4.78812597146     ,
 3.26583426887     , 2.17979640336     , 1.44987431995     , 1.00321450454     ,
 0.76392729614     , 0.640060767895    , 0.539742768134    , 0.413604737738    ,
 0.27111605586     , 0.148547285642    , 0.068160935815    , 0.0270662339192   ,
 0.0102592475372   , 0.00439300600375  , 0.00224877536669  , 0.00117863982872  ,
 0.000542188511623 , 0.000204286385472 , 6.15209081702e-05 , 1.46724745141e-05 ,
 2.75917190665e-06 , 4.08009015355e-07 , 4.73491962359e-08 , 4.30555310327e-09 ,
 3.06397148753e-10 , 1.705990311e-11   , 7.67828790003e-13 , 2.44417461118e-13 ,
 4.52459007938e-12 , 8.10732138217e-11 , 1.1415508502e-09  , 1.2584876901e-08  ,
 1.0872853669e-07  , 7.37107513443e-07 , 3.92664299192e-06 , 1.64610974999e-05 ,
 5.43857142156e-05 , 0.000141805979611 , 0.000292135687927 , 0.000475890159744 ,
 0.000613287386238 , 0.000625825801056 , 0.000510623351807 , 0.000366348941928 ,
 0.000393774924813 , 0.000990445883269 , 0.00291728638989  , 0.00713154746393  ,
 0.0138265175972   , 0.0212723031917   , 0.0263457986701   , 0.0274618546725   ,
 0.0272525057872   , 0.0318153146153   , 0.0477281119605   , 0.0826270509474   ,
 0.154713438856    , 0.310456786863    , 0.646898207867    , 1.35149165177     ,
 2.80825480028     , 5.84188489431     , 12.1481007506     , 24.8962545967     ,
 49.36967213       , 93.1466216094     , 164.62014983      , 268.436009399     ,
 398.47816062      , 533.275865309     , 640.414397185     , 690.763405207     ,
 673.721061846     , 601.859796849     , 501.806032209     , 399.511679812     ,
 310.817232613     , 241.084495683     , 189.681378313     , 153.776706914     ,
 129.773118437     , 113.794593646     , 102.396292249     , 93.1698030628     ,
 84.6581249498     , 75.8847580044     , 66.2093960011     , 55.5674347775     ,
 44.5374358601     , 33.9912257981     , 24.6663887581     , 16.9845885597     ,
 11.0710112571     , 6.82004292475     , 2.66828715354     , 1.37535705912     ,
 0.678798293078    , 0.328294931187    , 0.159399609995    , 0.0777341572977   ,
 0.0368453272553   , 0.0163554070398   , 0.00696024212738  , 0.00353461165457  ,
 0.00292520814851  , 0.00318986365717  , 0.00322739711799  , 0.0026861555339   ,
 0.00184223601794  , 0.0012405636942   , 0.00133898501514  , 0.00234249658715  ,
 0.00405840627538  , 0.00576688951769  , 0.00650648741215  , 0.00582192134184  ,
 0.00423760486692  , 0.00293391630717  , 0.00310500315891  , 0.00553154457969  ,
 0.0101226804536   , 0.0154530267479   , 0.0193394948165   , 0.0206344361967   ,
 0.0201518851693   , 0.0193018155279   , 0.0185039418005   , 0.0179408396453   ,
 0.0196118056539   , 0.0276940936139   , 0.046192157901    , 0.0755686429984   ,
 0.111469790488    , 0.147445143998    , 0.178908617194    , 0.204076229955    ,
 0.224229779362    , 0.248142999522    , 0.29598380401     , 0.395477025517    ,
 0.57652319986     , 0.875079133206    , 1.34419020609     , 2.06305443694     ,
 3.13952531689     , 4.71106506362     , 6.96844082063     , 10.2190502412     ,
 14.9381076465     , 21.7249031151     , 31.1836846664     , 43.8341653586     ,
 60.0420377305     , 79.8002866434     , 102.287052599     , 125.451322009     ,
 146.081089428     , 160.597398866     , 166.28853254      , 162.311267879     ,
 149.893115871     , 131.683549102     , 110.760900419     , 89.9257348409     ,
 71.4254465688     , 56.7847081774     , 46.5612978719     , 40.2358139404     ,
 36.4944630292     , 33.8681021846     , 31.349139029      , 28.5762598321     ,
 25.5667380877     , 22.365668017      , 18.9432515843     , 15.3360180308     ,
 11.7760718398     , 8.60459670066     , 6.05547231258     , 4.1528600257      ,
 2.7880383899      , 1.83462994767     , 1.19863795822     , 0.814132932974    ,
 0.616865007949    , 0.523763094834    , 0.449141246012    , 0.346982876676    ,
 0.226698943839    , 0.122531596631    , 0.0550662965595   , 0.0213471746907   ,
 0.00780392914539  , 0.0030488313298   , 0.00132193703885  , 0.000576118795246 ,
 0.000226019454188 , 7.52227305379e-05 , 2.06709256163e-05 , 4.62064313105e-06 ,
 8.3132293061e-07  , 1.19378130826e-07 , 1.35929027376e-08 , 1.22114669069e-09 ,
 8.62389760367e-11 , 4.7760006212e-12  , 2.33597616944e-13 , 7.83061530817e-13 ,
 1.78763893145e-11 , 3.21952256031e-10 , 4.53475456164e-09 , 5.00003920137e-08 ,
 4.320567268e-07   , 2.92963252463e-06 , 1.56099865291e-05 , 6.54565305579e-05 ,
 0.000216324641142 , 0.000564228395188 , 0.00116276896896  , 0.00189481266199  ,
 0.00244254032521  , 0.00249119064395  , 0.00201581791957  , 0.00133661719251  ,
 0.00094712886734  , 0.00148673179519  , 0.00397421671847  , 0.00968004517787  ,
 0.0188681105731   , 0.0291585664619   , 0.0361274088385   , 0.0371528208991   ,
 0.0348864561445   , 0.0361937606023   , 0.0483720100677   , 0.0793345314053   ,
 0.146224216598    , 0.291049597086    , 0.604047924143    , 1.2779829724      ,
 2.75694139349     , 6.08195092621     , 13.557187928      , 29.8368621148     ,
 63.2911826211     , 126.660118518     , 234.575045265     , 395.333465339     ,
 598.440854549     , 807.057597038     , 966.774024787     , 1030.99705813     ,
 986.371375484     , 858.314876752     , 693.202809127     , 533.02643193      ,
 400.852890314     , 301.878291097     , 232.004881114     , 184.711902496     ,
 153.578516959     , 132.762852031     , 117.539955458     , 104.800292215     ,
 92.8204866106     , 80.6355482826     , 67.8066403523     , 54.5791831657     ,
 41.7959432527     , 30.3992744448     , 20.983258603      , 13.7102400897     ,
 8.44711495602     , 4.89449920189     , 1.65187586715     , 0.798379720827    ,
 0.369098302605    , 0.166898752586    , 0.0761147478419   , 0.0355203608696   ,
 0.0165695735144   , 0.00765503584446  , 0.00426255983609  , 0.00423714142359  ,
 0.00596452926964  , 0.00777750565076  , 0.00823556333226  , 0.00690611995079  ,
 0.00457673976335  , 0.00245324802939  , 0.00123973864535  , 0.000956114149818 ,
 0.00125984916769  , 0.0017109021514   , 0.00191907483923  , 0.0017191857409   ,
 0.00127435716017  , 0.000978834163941 , 0.00128058528806  , 0.00252265050341  ,
 0.00467744436633  , 0.00707446221613  , 0.00866830061834  , 0.00891954535133  ,
 0.00826791502816  , 0.00748207415753  , 0.00682795958212  , 0.00628692700422  ,
 0.00644764413956  , 0.0087768753424   , 0.0147961777571   , 0.0248246007698   ,
 0.0374687352309   , 0.0505485816224   , 0.0624632189259   , 0.0725689566691   ,
 0.081650103094    , 0.0941361324476   , 0.119594601926    , 0.170521048447    ,
 0.260325512134    , 0.40786338125     , 0.64734825413     , 1.0365111144      ,
 1.65823251282     , 2.6209785978      , 4.07918460012     , 6.2880850567      ,
 9.65649397384     , 14.7338360856     , 22.1384911838     , 32.504626442      ,
 46.4337727305     , 64.2718556829     , 85.5965019326     , 108.67726544      ,
 130.455202156     , 147.310605833     , 156.258232993     , 155.921701189     ,
 146.861575875     , 131.194847794     , 111.805501841     , 91.6420364343     ,
 73.2967030629     , 58.6416426033     , 48.4261987757     , 42.1264186899     ,
 38.3160859372     , 35.4270022966     , 32.4295741312     , 29.0205546101     ,
 25.3330672658     , 21.5487585912     , 17.7433277179     , 13.9876145975     ,
 10.4789559757     , 7.48949324106     , 5.18130613086     , 3.51753821556     ,
 2.34684121512     , 1.52637115825     , 0.969695631582    , 0.628116865609    ,
 0.452808119523    , 0.374222185936    , 0.319030698817    , 0.246634552749    ,
 0.161491355774    , 0.0882936966389   , 0.0416302292082   , 0.018504019688    ,
 0.0086537998061   , 0.00428051360608  , 0.00200525860488  , 0.000804822508676 ,
 0.000264125481247 , 6.99189028924e-05 , 1.4947033987e-05  , 2.59914891117e-06 ,
 3.70789642596e-07 , 4.36569164668e-08 , 4.24526435585e-09 , 3.39172175296e-10 ,
 2.20583730114e-11 , 1.1577461598e-12  , 1.3058051139e-13  , 2.43032677699e-12 ,
 5.59833264752e-11 , 1.00838876601e-09 , 1.42050705466e-08 , 1.56648967013e-07 ,
 1.353857938e-06   , 9.18203603773e-06 , 4.89371184032e-05 , 0.000205265421164 ,
 0.000678597170138 , 0.00177059234706  , 0.00365027550403  , 0.00595076389882  ,
 0.00767386553846  , 0.00782782919865  , 0.00631980792757  , 0.0040828828101   ,
 0.00235684738783  , 0.00217134190302  , 0.00460096391218  , 0.0108998702701   ,
 0.0213106516829   , 0.0332864591384   , 0.0420546046123   , 0.044597386169    ,
 0.0431028484063   , 0.0437744338305   , 0.0534533139209   , 0.0804919977375   ,
 0.142469483022    , 0.278919650688    , 0.57500700306     , 1.23045168269     ,
 2.75595099478     , 6.44630326282     , 15.3656517599     , 36.0994861697     ,
 81.0962411948     , 169.877189221     , 324.99295083      , 558.608979358     ,
 852.847618397     , 1149.20891612     , 1364.67592077     , 1432.69519006     ,
 1340.84616856     , 1134.88044855     , 887.551292749     , 659.67245083      ,
 480.70083701      , 353.165520762     , 267.044616467     , 210.480552519     ,
 173.493996333     , 148.238946889     , 129.025901818     , 112.413223677     ,
 96.7008585129     , 81.1323852483     , 65.5547026344     , 50.4624202154     ,
 36.7937769529     , 25.3854803826     , 16.5763326259     , 10.2244507495     ,
 5.93337266177     , 3.23019658847     , 0.927749624135    , 0.420860515036    ,
 0.182717189236    , 0.0771404370251   , 0.032590867542    , 0.0142265702619   ,
 0.00657887900509  , 0.00379583382058  , 0.00417308973075  , 0.00720644731786  ,
 0.0118774390189   , 0.0159608140958   , 0.0169969629803   , 0.0142625076253   ,
 0.00941361583643  , 0.00489392518964  , 0.00204344559447  , 0.000780829116207 ,
 0.000433238209385 , 0.00042723182353  , 0.000453097207231 , 0.000403975640465 ,
 0.00030798934582  , 0.000272138720393 , 0.000436829283875 , 0.000925044919731 ,
 0.00173095366435  , 0.00260463991783  , 0.00314975755008  , 0.00316039713215  ,
 0.00280990576255  , 0.00241331061619  , 0.00209916852783  , 0.00184992356017  ,
 0.00180315245832  , 0.00237186304828  , 0.00401575957048  , 0.00686946168228  ,
 0.0105840420807   , 0.0145804937925   , 0.0184361040996   , 0.0220513399857   ,
 0.0259946700243   , 0.0323968964313   , 0.0452716792716   , 0.0693391120692   ,
 0.109647356319    , 0.17546151618     , 0.287945979778    , 0.486965031668    ,
 0.832755502338    , 1.40530686678     , 2.3168621017      , 3.75270793273     ,
 6.02497076713     , 9.59942758387     , 15.0860598607     , 23.2210534746     ,
 34.807561339      , 50.4672350845     , 70.1119944968     , 92.3804644895     ,
 114.54647595      , 133.143982901     , 145.000096931     , 148.179756228     ,
 142.512872781     , 129.523267925     , 111.841601658     , 92.5057337989     ,
 74.397129082      , 59.6841549564     , 49.2807579434     , 42.6920266631     ,
 38.4815096768     , 35.1033327036     , 31.5768045796     , 27.6510810053     ,
 23.5214521422     , 19.4459680831     , 15.5625440768     , 11.9514253815     ,
 8.75588890296     , 6.15722804483     , 4.23083577854     , 2.88285433835     ,
 1.93840019225     , 1.25864043179     , 0.777893212406    , 0.470668958279    ,
 0.306514497984    , 0.232436655386    , 0.190382305509    , 0.146112787285    ,
 0.0976001153502   , 0.0575695920952   , 0.0330357217757   , 0.0205647256661   ,
 0.0134939428158   , 0.00817060684002  , 0.00413741552045  , 0.00167825867274  ,
 0.000536930255321 , 0.000134805776611 , 2.6530672632e-05  , 4.09634139162e-06 ,
 4.97371644856e-07 , 4.76864262268e-08 , 3.63305720729e-09 , 2.21871254912e-10 ,
 1.09782474178e-11 , 4.50321349879e-13 , 2.181225927e-13   , 5.9997203356e-12  ,
 1.38299149414e-10 , 2.49136633768e-09 , 3.51004775561e-08 , 3.87142457131e-07 ,
 3.34661418353e-06 , 2.27027416535e-05 , 0.000121032851148 , 0.000507838323401 ,
 0.00167951935623  , 0.00438400546239  , 0.00904211660975  , 0.0147474228896   ,
 0.0190263104915   , 0.0194150784127   , 0.0156670113265   , 0.0100302805264   ,
 0.0053077117942   , 0.00319151947883  , 0.00446510960115  , 0.00980069501497  ,
 0.019246853778    , 0.0308276684069   , 0.0408710613664   , 0.0469321771187   ,
 0.0500509507977   , 0.0536413250808   , 0.0619095757245   , 0.0825019514125   ,
 0.133482219692    , 0.253162389529    , 0.524151951991    , 1.15594182372     ,
 2.72887033223     , 6.80747380561     , 17.2936452347     , 42.945659228      ,
 100.800799913     , 217.849622103     , 424.849188244     , 736.709479499     ,
 1125.09226016     , 1506.00635584     , 1766.12374186     , 1821.56385044     ,
 1666.78891758     , 1373.37395105     , 1042.33069155     , 751.488981086     ,
 533.35819593      , 384.960316012     , 288.744059241     , 226.983912547     ,
 186.316282689     , 157.44394343      , 134.35873044      , 113.826621848     ,
 94.542740658      , 76.1688557901     , 58.8624286649     , 43.1949118777     ,
 29.919949012      , 19.5348157211     , 12.0268786917     , 6.9742760407      ,
 3.79699198866     , 1.93651086563     , 0.469212283018    , 0.198978584616    ,
 0.0810017187894   , 0.0319362808526   , 0.0124292225125   , 0.0050343185772   ,
 0.00255377729557  , 0.0027061051356   , 0.00549454810442  , 0.0113536910025   ,
 0.0193076552092   , 0.0260775769699   , 0.027794195375    , 0.0233248257622   ,
 0.0153879011728   , 0.00797170887963  , 0.00324644808839  , 0.00105618513643  ,
 0.000306893025493 , 0.000123170081498 , 9.05957092131e-05 , 7.60248111497e-05 ,
 6.01154387489e-05 , 6.32988885771e-05 , 0.000121653120194 , 0.000270642917691 ,
 0.000509458442541 , 0.000764194833572 , 0.000915997679215 , 0.000902132938703 ,
 0.000774919218058 , 0.000633829201286 , 0.00052530491253  , 0.000444690540624 ,
 0.000416392155384 , 0.00053266997895  , 0.000904009206492 , 0.00157221576742  ,
 0.00247177779637  , 0.00348581049731  , 0.00453952368168  , 0.00567611829332  ,
 0.00723118241214  , 0.0101246856757   , 0.0158347833875   , 0.0258804924106   ,
 0.0420351552933   , 0.0690816138619   , 0.120123253185    , 0.221761409202    ,
 0.415560788991    , 0.75637679469     , 1.31824444396     , 2.22290766487     ,
 3.69084612755     , 6.09578048416     , 10.0064185935     , 16.2006421272     ,
 25.595117223      , 38.9822230033     , 56.5349771893     , 77.2871198496     ,
 98.9767187403     , 118.448501495     , 132.451694963     , 138.561632236     ,
 135.936933293     , 125.540227231     , 109.71280279      , 91.4751942775     ,
 73.8615968681     , 59.2229083225     , 48.5890759999     , 41.5301900165     ,
 36.7038733828     , 32.7082377201     , 28.6918488501     , 24.4645919426     ,
 20.2301874447     , 16.2432230856     , 12.6354988767     , 9.45841873777     ,
 6.78832741067     , 4.71731992554     , 3.2470719449      , 2.24871189777     ,
 1.54568236113     , 1.01597326329     , 0.618167862115    , 0.349844927855    ,
 0.198936164435    , 0.128910202108    , 0.096234548132    , 0.0730734393518   ,
 0.0528797701595   , 0.0390075695699   , 0.0320946239438   , 0.0277286243408   ,
 0.0217733298848   , 0.0141629350388   , 0.00734861598241  , 0.00300104034345  ,
 0.000959961549016 , 0.00024004918148  , 4.68821676929e-05 , 7.14775336944e-06 ,
 8.50557104124e-07 , 7.90031669028e-08 , 5.73024268917e-09 , 3.24843570878e-10 ,
 1.44159677068e-11 , 5.12591753872e-13 , 4.09986457808e-13 , 1.16970865016e-11 ,
 2.69667748954e-10 , 4.85849902858e-09 , 6.84613783516e-08 , 7.55243327546e-07 ,
 6.53014649877e-06 , 4.43115064646e-05 , 0.000236310821855 , 0.000991903993338 ,
 0.003281812592    , 0.00857043053294  , 0.0176855389536   , 0.0288595060077   ,
 0.0372522055325   , 0.0380314787377   , 0.0306941815501   , 0.0195931083593   ,
 0.0100307267176   , 0.00472444480719  , 0.00389311502396  , 0.00713332377349  ,
 0.0141017144347   , 0.0238498638088   , 0.0347502136753   , 0.04554826723     ,
 0.0556860037369   , 0.0644437429874   , 0.0718955889693   , 0.0836325886969   ,
 0.116972521136    , 0.208452266731    , 0.438648118699    , 1.02575310953     ,
 2.60903812975     , 6.98787873134     , 18.8162518136     , 48.8273285447     ,
 118.182929394     , 260.306549243     , 512.238768988     , 889.095442326     ,
 1350.50355995     , 1788.88743269     , 2067.21572537     , 2093.19070692     ,
 1874.1871052      , 1506.99826904     , 1114.60724174     , 784.271053894     ,
 546.457434253     , 390.98872825      , 293.316123332     , 231.183916948     ,
 189.214579063     , 157.800907531     , 131.451589091     , 107.663090529     ,
 85.7835407454     , 65.9417723476     , 48.480082302      , 33.7997324901     ,
 22.2114476154     , 13.7209168993     , 7.96114117639     , 4.33292733672     ,
 2.20650600026     , 1.05013663669     , 0.21402774549     , 0.08417079494     ,
 0.0318736691217   , 0.0116962193245   , 0.00420212643198  , 0.00164705108032  ,
 0.00125409802539  , 0.00265741188062  , 0.00679383255339  , 0.0145886341471   ,
 0.0249537555329   , 0.0337339681951   , 0.0359598403089   , 0.0301779392965   ,
 0.0199080325321   , 0.0103092505823   , 0.00418632604635  , 0.00133414313727  ,
 0.000338173201561 , 7.49960328588e-05 , 2.1894128545e-05  , 1.22494591145e-05 ,
 9.60920871589e-06 , 1.23055881778e-05 , 2.73557157703e-05 , 6.28667387517e-05 ,
 0.000118781306205 , 0.000177786116521 , 0.000211737940164 , 0.000205517269872 ,
 0.000171424721712 , 0.00013389318536  , 0.000105580461802 , 8.58726126484e-05 ,
 7.77689682828e-05 , 9.7435398498e-05  , 0.000165960161332 , 0.000293372613913 ,
 0.000471278669719 , 0.00068310869437  , 0.00092489168464  , 0.00123557501508  ,
 0.00176364591979  , 0.00284505105557  , 0.00495302562851  , 0.00853885157926  ,
 0.0143521178431   , 0.0251606301291   , 0.0490853313995   , 0.103091426218    ,
 0.213929732326    , 0.416335276318    , 0.75610989266     , 1.31083337989     ,
 2.23416674421     , 3.81849929233     , 6.56202990111     , 11.2051923412     ,
 18.6663660644     , 29.7991574136     , 44.9686377864     , 63.6026392392     ,
 83.9697936602     , 103.331932836     , 118.483864937     , 126.647187909     ,
 126.444010839     , 118.36721226      , 104.466865663     , 87.6363393863     ,
 70.8918641905     , 56.6220534026     , 45.9179887572     , 38.4496883659     ,
 33.0481338014     , 28.5330407383     , 24.229503905      , 20.0080599383     ,
 16.0327007579     , 12.4840289488     , 9.43196694382     , 6.87658199051     ,
 4.83209228228     , 3.32126361897     , 2.29933559088     , 1.63031342077     ,
 1.15584484017     , 0.777083531425    , 0.47241975363     , 0.25546080053     ,
 0.128108942017    , 0.0677168917149   , 0.0431811389239   , 0.0331107924617   ,
 0.0298019125457   , 0.0316981820676   , 0.0355701241924   , 0.0359551938174   ,
 0.0299527090261   , 0.0198731226392   , 0.0103775606946   , 0.00424639994073  ,
 0.00135895798899  , 0.000339772679018 , 6.63226219842e-05 , 1.01018711565e-05 ,
 1.20016281381e-06 , 1.1118633856e-07  , 8.03061288242e-09 , 4.5215044602e-10  ,
 1.98451751452e-11 , 6.95162892371e-13 , 6.28271550374e-13 , 1.80150819017e-11 ,
 4.15373634456e-10 , 7.48468548432e-09 , 1.05485604211e-07 , 1.16393238738e-06 ,
 1.00664609164e-05 , 6.83290561776e-05 , 0.000364528185607 , 0.00153073423408  ,
 0.00506698449854  , 0.0132392729105   , 0.0273351003508   , 0.0446314261561   ,
 0.0576439942292   , 0.0588822757284   , 0.047542042956    , 0.0303261346451   ,
 0.0153450056292   , 0.00648690821099  , 0.00337144885625  , 0.00441259558892  ,
 0.00876718508513  , 0.0163980397266   , 0.0275755625608   , 0.0421266491555   ,
 0.0580204014836   , 0.070878894508    , 0.0771183374441   , 0.0799750799419   ,
 0.0946069239573   , 0.15384359347     , 0.333585577355    , 0.852088174605    ,
 2.37490683907     , 6.83067842641     , 19.3252215129     , 51.8090127695     ,
 127.9105218       , 284.491186496     , 560.810411531     , 969.059140791     ,
 1458.39955859     , 1906.89149507     , 2168.72828733     , 2156.12639998     ,
 1892.15007393     , 1489.91563913     , 1080.08233008     , 747.81939509      ,
 516.750282554     , 370.21630217      , 279.719418835     , 221.512361863     ,
 180.4011951       , 147.836316898     , 119.584509091     , 94.1649422904     ,
 71.5660377535     , 52.1917088242     , 36.3163087827     , 23.9659454963     ,
 14.9203115441     , 8.72786089271     , 4.7817866177      , 2.44612380162     ,
 1.1649924685      , 0.516230476356    , 0.0886391638042   , 0.0320960849319   ,
 0.0111678938644   , 0.00377559041421  , 0.00126254968205  , 0.000558780012111 ,
 0.000851758798474 , 0.00255228968865  , 0.00689115700889  , 0.0149083278088   ,
 0.0255282436032   , 0.0345163392927   , 0.0367948072738   , 0.0308787617723   ,
 0.0203702437312   , 0.0105481279569   , 0.00428192936749  , 0.00136137966228  ,
 0.000339210987411 , 6.69797331067e-05 , 1.13757033397e-05 , 2.4816763972e-06  ,
 1.34071397366e-06 , 1.99035691081e-06 , 4.92394534073e-06 , 1.15536159482e-05 ,
 2.1878318614e-05  , 3.26923832948e-05 , 3.87435518317e-05 , 3.71630229122e-05 ,
 3.02185420866e-05 , 2.25957533311e-05 , 1.69233945545e-05 , 1.31963475625e-05 ,
 1.15959526682e-05 , 1.43169665208e-05 , 2.45497890593e-05 , 4.41828255989e-05 ,
 7.27256888498e-05 , 0.000108983331478 , 0.000155556198819 , 0.000228575006767 ,
 0.000377532746215 , 0.000702826820549 , 0.00133730007127  , 0.00243226694691  ,
 0.00441712840867  , 0.00899484735659  , 0.0210706785978   , 0.0507818714259   ,
 0.113826738206    , 0.230164982497    , 0.426929466376    , 0.7551028559      ,
 1.32592651089     , 2.36721032544     , 4.29060032468     , 7.73561164472     ,
 13.5272072128     , 22.4897475018     , 35.1209399182     , 51.2186093007     ,
 69.5925014879     , 87.9767434827     , 103.318987881     , 112.628783456     ,
 114.131534217     , 107.954963315     , 95.8964129178     , 80.6686247022     ,
 65.1410280382     , 51.609629863      , 41.1661279662     , 33.5920543648     ,
 27.9248734877     , 23.2222363441     , 18.9812283453     , 15.1119585638     ,
 11.703071512      , 8.82395375598     , 6.46340795425     , 4.57548648654     ,
 3.13409199946     , 2.12084940498     , 1.47235995292     , 1.06819164986     ,
 0.781806553591    , 0.539306810226    , 0.330773665699    , 0.175103519744    ,
 0.0808720130349   , 0.035656094485    , 0.0188907409539   , 0.0157107852331   ,
 0.0198201061605   , 0.0283140195087   , 0.0366087632781   , 0.0389414689442   ,
 0.0329810572829   , 0.021996960661    , 0.0115056089355   , 0.00471045015614  ,
 0.00150770239869  , 0.000376973269518 , 7.3582018475e-05  , 1.12067957858e-05 ,
 1.33127257741e-06 , 1.23308031967e-07 , 8.90321697505e-09 , 5.01014398929e-10 ,
 2.19707866793e-11 , 7.70332979357e-13 , 7.62871652228e-13 , 2.19362709329e-11 ,
 5.05848535586e-10 , 9.11638376823e-09 , 1.28506679386e-07 , 1.41828175701e-06 ,
 1.22697410381e-05 , 8.3312818482e-05  , 0.000444642558345 , 0.00186801075746  ,
 0.00618662421395  , 0.0161738915174   , 0.0334143920032   , 0.0545915287782   ,
 0.070552255639    , 0.072111546448    , 0.058254669301    , 0.0371636505846   ,
 0.0187335677208   , 0.00760012091092  , 0.00299114700053  , 0.00253037956099  ,
 0.00497337924522  , 0.010705241089    , 0.0209736996176   , 0.0361269068946   ,
 0.0533816980214   , 0.0667172424632   , 0.0709840527144   , 0.0678167342949   ,
 0.0692976304143   , 0.10247861063     , 0.234197380943    , 0.668198891435    ,
 2.04540595349     , 6.26063196002     , 18.4006049147     , 50.4409461591     ,
 125.942890351     , 280.952792885     , 551.964019302     , 945.940923065     ,
 1406.77084872     , 1812.73851605     , 2027.91474301     , 1980.88440003     ,
 1707.62870016     , 1322.45605227     , 946.191739369     , 650.915726662     ,
 451.058905925     , 326.601632741     , 249.597660612     , 198.373292658     ,
 160.056729284     , 128.198711548     , 100.180600928     , 75.4928221318     ,
 54.4954231753     , 37.5445953161     , 24.6164880344     , 15.3147775318     ,
 9.01064668703     , 4.99195999834     , 2.58911114489     , 1.24943155389     ,
 0.55835023482     , 0.230759241933    , 0.0334895305615   , 0.0111530733949   ,
 0.00353101161836  , 0.0010840559262   , 0.000344258077813 , 0.000225198938974 ,
 0.00061158743046  , 0.00203677111196  , 0.00556327423788  , 0.0120529157823   ,
 0.0206429768819   , 0.0279119070953   , 0.0297545527984   , 0.0249704905071   ,
 0.0164726386167   , 0.00852982517972  , 0.0034624878051   , 0.00110055518122  ,
 0.000273686601735 , 5.32761281262e-05 , 8.19473082604e-06 , 1.0768217849e-06  ,
 2.20117783651e-07 , 2.68709820722e-07 , 7.04948838814e-07 , 1.67536518685e-06 ,
 3.17658319207e-06 , 4.74043723101e-06 , 5.5957530126e-06  , 5.31519945416e-06 ,
 4.22731588181e-06 , 3.03453498555e-06 , 2.15575082132e-06 , 1.60595491232e-06 ,
 1.369932926e-06   , 1.67510133614e-06 , 2.90349756875e-06 , 5.33566745121e-06 ,
 9.0356517238e-06  , 1.41176376673e-05 , 2.16757086258e-05 , 3.62286837817e-05 ,
 7.04072273024e-05 , 0.000148719112624 , 0.000306553945941 , 0.000614265500537 ,
 0.00135515223483  , 0.00359479287617  , 0.0102457394238   , 0.0270599735743   ,
 0.0623960317311   , 0.126271425554    , 0.233582454589    , 0.418573483738    ,
 0.764304976469    , 1.44682378668     , 2.78831568223     , 5.2969018049      ,
 9.65095510538     , 16.5873902795     , 26.6831834299     , 40.0544643847     ,
 56.0109295894     , 72.7645016861     , 87.4962957137     , 97.1369312738     ,
 99.6466385953     , 94.8860427994     , 84.4576544588     , 70.8967401951     ,
 56.8630503237     , 44.4634013095     , 34.7185527089     , 27.4956957752     ,
 22.0272024127     , 17.5799843919     , 13.7816335233     , 10.5492348949     ,
 7.88395837509     , 5.75037287603     , 4.0739317163      , 2.78564263485     ,
 1.84433567424     , 1.21538034071     , 0.83667660203     , 0.615503389705    ,
 0.462111886144    , 0.326118724975    , 0.202429883992    , 0.106579365918    ,
 0.0472953392674   , 0.0186852361862   , 0.0087377494694   , 0.00852874257249  ,
 0.0140872428951   , 0.0229832818397   , 0.0311153507108   , 0.0335800116804   ,
 0.0285672387559   , 0.0190794323182   , 0.00998389611571  , 0.00408801371894  ,
 0.00130853199905  , 0.000327178447051 , 6.38625678241e-05 , 9.72644853907e-06 ,
 1.15540943711e-06 , 1.07017211237e-07 , 7.72677520527e-09 , 4.34794104754e-10 ,
 1.90656085894e-11 , 6.70274596171e-13 , 7.32991878769e-13 , 2.11343599585e-11 ,
 4.87422534731e-10 , 8.78577300419e-09 , 1.23871799927e-07 , 1.36747282913e-06 ,
 1.1833794866e-05  , 8.03819405773e-05 , 0.000429183510452 , 0.00180394985128  ,
 0.00597775712787  , 0.0156372824611   , 0.0323265631552   , 0.0528493643557   ,
 0.0683462160505   , 0.0699018487159   , 0.056503238411    , 0.0360612960784   ,
 0.018160163368    , 0.00726170125272  , 0.00251657154179  , 0.00145589398491  ,
 0.00273410374409  , 0.00671465970851  , 0.014686118325    , 0.0270241534353   ,
 0.0411188645162   , 0.0515284325315   , 0.0537008476788   , 0.0485657743652   ,
 0.0448233351647   , 0.0627040539545   , 0.15646340796     , 0.500801544122    ,
 1.65893948615     , 5.31912742388     , 16.0458583076     , 44.5738164073     ,
 111.787903733     , 248.834244198     , 485.357205265     , 822.720884562     ,
 1206.88492025     , 1531.24230687     , 1685.0905126      , 1619.33709389     ,
 1375.33339983     , 1053.01460076     , 749.536236317     , 517.684925547     ,
 363.558551312     , 267.858280127     , 207.225061122     , 164.694420093     ,
 130.960204981     , 102.003123792     , 76.6764263505     , 55.1092426964     ,
 37.6842262939     , 24.465455481      , 15.06906164       , 8.8053672878      ,
 4.87965874049     , 2.55669101327     , 1.25714421191     , 0.574466233874    ,
 0.242056235825    , 0.0937620873994   , 0.0115745261868   , 0.00355777110791  ,
 0.00102280833865  , 0.000282274711178 , 8.93499828649e-05 , 0.000104141208596 ,
 0.000378556363615 , 0.00129661651345  , 0.00355052247327  , 0.00769444586598  ,
 0.0131787501396   , 0.0178194336116   , 0.0189958268558   , 0.0159415999672   ,
 0.0105164213956   , 0.00544558690472  , 0.00221050257339  , 0.000702589387825 ,
 0.000174682015411 , 3.39490294683e-05 , 5.15976414335e-06 , 6.1914261146e-07  ,
 6.81019121592e-08 , 3.22310786943e-08 , 8.00045302437e-08 , 1.91265211693e-07 ,
 3.62887771191e-07 , 5.4095179764e-07  , 6.36517458497e-07 , 5.99704724946e-07 ,
 4.67922408878e-07 , 3.23494818225e-07 , 2.17876491058e-07 , 1.54429421731e-07 ,
 1.2769186427e-07  , 1.55244989966e-07 , 2.73278793989e-07 , 5.1475076122e-07  ,
 9.01710905696e-07 , 1.4872182054e-06  , 2.52453733305e-06 , 4.94714498931e-06 ,
 1.1282860853e-05  , 2.67428458462e-05 , 6.26897889649e-05 , 0.000162463056358 ,
 0.000520914741428 , 0.00182951354296  , 0.00587513122074  , 0.0159331056143   ,
 0.0361499222385   , 0.0706083402366   , 0.126275491949    , 0.225349574242    ,
 0.428744646508    , 0.868236645615    , 1.78278269548     , 3.54908472505     ,
 6.68754958635     , 11.8189870911     , 19.5439453511     , 30.2087791088     ,
 43.527563874      , 58.1507155681     , 71.5634304567     , 80.7769792434     ,
 83.6507436719     , 79.8815754777     , 70.9157232796     , 59.1042400005     ,
 46.8494882932     , 35.9907656596     , 27.404077187      , 20.99785035       ,
 16.169768239      , 12.3561930511     , 9.26970012673     , 6.81128009785     ,
 4.90945375136     , 3.46205013843     , 2.36669856403     , 1.55407003084     ,
 0.984379727642    , 0.622074126409    , 0.416762323008    , 0.305575752706    ,
 0.232468828006    , 0.166674438928    , 0.104566934953    , 0.0551420553803   ,
 0.0241121267559   , 0.00909572611369  , 0.00413547921439  , 0.00475554455367  ,
 0.00896625990355  , 0.0152957663844   , 0.0209852972356   , 0.0227377576321   ,
 0.0193667622481   , 0.0129394027893   , 0.00677171431962  , 0.00277285169581  ,
 0.000887572143243 , 0.000221924669957 , 4.33179304617e-05 , 6.59744231722e-06 ,
 7.83712832772e-07 , 7.25895615033e-08 , 5.24104601463e-09 , 2.94918454406e-10 ,
 1.29320617861e-11 , 4.562314335e-13   , 5.57538478689e-13 , 1.61194378693e-11 ,
 3.71815676742e-10 , 6.70312669935e-09 , 9.45285605055e-08 , 1.04381448455e-06 ,
 9.03579892966e-06 , 6.13995837361e-05 , 0.000327976447304 , 0.0013792577108   ,
 0.00457306807485  , 0.0119702285477   , 0.0247622268427   , 0.0405105548198   ,
 0.0524253483602   , 0.0536543390725   , 0.043397036276    , 0.0277112662093   ,
 0.0139552529198   , 0.00555357289305  , 0.00182934958855  , 0.000829901006724 ,
 0.0014387732741   , 0.00382906957293  , 0.0088637093378   , 0.0167576070891   ,
 0.0256773439905   , 0.031967139353    , 0.032701543172    , 0.0285498654372   ,
 0.0251174293564   , 0.0362514773459   , 0.102693640649    , 0.361544395416    ,
 1.26197897967     , 4.1606819236      , 12.7293016863     , 35.5414943265     ,
 89.0014784548     , 196.82437704      , 379.977605618     , 635.753320641     ,
 918.867667729     , 1147.59668916     , 1243.31468628     , 1177.96231768     ,
 989.584908189     , 753.788945408     , 538.526335156     , 377.270447031     ,
 270.760172756     , 203.587011512     , 159.044349603     , 125.76206063      ,
 98.061556944      , 73.9779990716     , 53.3369439583     , 36.4912848667     ,
 23.613824016      , 14.4400601624     , 8.34928025604     , 4.57492809806     ,
 2.38292866786     , 1.17955320081     , 0.550523285508    , 0.23895876664     ,
 0.0952838334235   , 0.034714710525    , 0.00373503449624  , 0.00105517005582  ,
 0.000275022602023 , 6.80949024337e-05 , 2.32732523205e-05 , 4.64142351276e-05 ,
 0.000188953523422 , 0.000652224279406 , 0.00178703567216  , 0.00387296673914  ,
 0.00663351696857  , 0.00896941212372  , 0.00956155125874  , 0.00802420606706  ,
 0.00529344182275  , 0.00274103657277  , 0.00111265612435  , 0.000353647081013 ,
 8.79237333944e-05 , 1.70847037035e-05 , 2.59312698905e-06 , 3.07643497532e-07 ,
 2.92466881875e-08 , 4.4733759119e-09  , 7.23479500891e-09 , 1.71611192165e-08 ,
 3.25634798767e-08 , 4.84981893278e-08 , 5.69175655803e-08 , 5.32652283313e-08 ,
 4.0886535391e-08  , 2.73218765141e-08 , 1.74580233859e-08 , 1.17259970757e-08 ,
 9.37120634346e-09 , 1.13644375385e-08 , 2.04190895682e-08 , 3.9603720746e-08  ,
 7.22977327571e-08 , 1.28174288209e-07 , 2.48655940759e-07 , 5.82577294252e-07 ,
 1.55825102296e-06 , 4.41780570449e-06 , 1.45805926101e-05 , 6.12567492072e-05 ,
 0.000277885950112 , 0.00112268892914  , 0.00373189901909  , 0.0100353354195   ,
 0.022040485031    , 0.0409031659778   , 0.0691498436153   , 0.120337470719    ,
 0.236898296119    , 0.512631089875    , 1.11575736473     , 2.31025165913     ,
 4.47351242418     , 8.0998988669      , 13.7526479607     , 21.889594511      ,
 32.4921251559     , 44.5810626538     , 56.0212350175     , 64.1055758746     ,
 66.8052457329     , 63.7650261865     , 56.2657714138     , 46.4018499358     ,
 36.2383354585     , 27.2804617391     , 20.2120779489     , 14.9541337826     ,
 11.0461718867     , 8.06337694203     , 5.77538444253     , 4.06581004524     ,
 2.82308999433     , 1.92331788175     , 1.26725201337     , 0.797318594631    ,
 0.480861558587    , 0.288108333955    , 0.18371358016     , 0.130558449982    ,
 0.0984124388827   , 0.0707551027774   , 0.0446194605373   , 0.0235910126324   ,
 0.0102783655058   , 0.00383162020586  , 0.00179783829354  , 0.00233913437014  ,
 0.00465867633084  , 0.00805941993363  , 0.0110992715752   , 0.0120393488642   ,
 0.0102578062764   , 0.00685417148951  , 0.00358717652339  , 0.00146887544383  ,
 0.000470179114442 , 0.000117561653154 , 2.2947106774e-05  , 3.49490899272e-06 ,
 4.15161639725e-07 , 3.84533691999e-08 , 2.77637504497e-09 , 1.56229124737e-10 ,
 6.85060619751e-12 , 2.4275063865e-13  , 3.35802096e-13    , 9.73491919507e-12 ,
 2.24580601282e-10 , 4.04947102525e-09 , 5.71186871685e-08 , 6.30890330834e-07 ,
 5.46306774259e-06 , 3.71365559823e-05 , 0.000198460205733 , 0.000835025024905 ,
 0.00277020624809  , 0.00725571843508  , 0.0150195940409   , 0.0245887305031   ,
 0.0318425930835   , 0.0326108223049   , 0.0263930040081   , 0.0168626980191   ,
 0.00849482083185  , 0.00337565528579  , 0.00108964496277  , 0.000430186644947 ,
 0.000675869625284 , 0.00185531498183  , 0.00439218816288  , 0.00836661037784  ,
 0.0127889335873   , 0.0157696389074   , 0.0158817268977   , 0.0136245255884   ,
 0.0122832420449   , 0.0208520866462   , 0.0681996968574   , 0.253531211407    ,
 0.902377332594    , 2.99670022621     , 9.17868163649     , 25.5383962241     ,
 63.4744492483     , 138.87126194      , 264.59023706      , 436.208863449     ,
 620.754308677     , 763.484955079     , 815.719907042     , 764.448286552     ,
 638.561313532     , 487.573602755     , 352.896743906     , 252.999726021     ,
 186.441198292     , 142.904111786     , 112.173296793     , 87.7700868684     ,
 66.83566614       , 48.7163749027     , 33.6476125359     , 21.9094256328     ,
 13.4293568724     , 7.75175451506     , 4.22040332036     , 2.17610852392     ,
 1.06973940167     , 0.503090462786    , 0.224488314993    , 0.0931909129578   ,
 0.0352817199362   , 0.0120659287713   , 0.00120982298587  , 0.000306578248653 ,
 7.0892817138e-05  , 1.55867694073e-05 , 6.11084638805e-06 , 1.76061343773e-05 ,
 7.46922842351e-05 , 0.000258420227649 , 0.000708155669878 , 0.00153477568701  ,
 0.00262872782362  , 0.00355439626395  , 0.00378904911897  , 0.00317983036954  ,
 0.0020976837987   , 0.00108621727853  , 0.000440923064723 , 0.000140143117095 ,
 3.48422867645e-05 , 6.77016714193e-06 , 1.02742536458e-06 , 1.21724629483e-07 ,
 1.12995906348e-08 , 9.77163310414e-10 , 5.45031105647e-10 , 1.20930817711e-09 ,
 2.29195850046e-09 , 3.41090777423e-09 , 3.99457690929e-09 , 3.71753856883e-09 ,
 2.81450405301e-09 , 1.82497322405e-09 , 1.10851691362e-09 , 7.03186476087e-10 ,
 5.41089978706e-10 , 6.56272436654e-10 , 1.21004242868e-09 , 2.42973337681e-09 ,
 4.67145111494e-09 , 9.13412265768e-09 , 2.09960339679e-08 , 6.03237433866e-08 ,
 2.07690905257e-07 , 9.19408198274e-07 , 5.29950533995e-06 , 3.17115083129e-05 ,
 0.000163931533121 , 0.000685673888977 , 0.00228498877234  , 0.00607245116802  ,
 0.0130163532168   , 0.0232335970834   , 0.0374926496259   , 0.0640245338106   ,
 0.13121212898     , 0.303042707784    , 0.693463231458    , 1.47997870815     ,
 2.92303162772     , 5.39088906547     , 9.35333110337     , 15.2585374766     ,
 23.2121873435     , 32.5298754308     , 41.5229563356     , 47.960694611      ,
 50.1332370546     , 47.7260976542     , 41.8037622824     , 34.0877086907     ,
 26.2177678951     , 19.3351491505     , 13.9333759014     , 9.94551244167     ,
 7.0362631128      , 4.89506841365     , 3.33672808909     , 2.24231074688     ,
 1.4951103866      , 0.983008003358    , 0.626440106444    , 0.381948650291    ,
 0.223773810154    , 0.129518038226    , 0.0779787900169   , 0.0512711371689   ,
 0.0362061121997   , 0.0251308373493   , 0.0156349285344   , 0.00823319419295  ,
 0.00358065354974  , 0.00133707363654  , 0.0006605786083   , 0.000938002548936 ,
 0.00191428661795  , 0.00332721788014  , 0.00458728260591  , 0.00497734093896  ,
 0.00424119299248  , 0.00283400319776  , 0.00148320697551  , 0.000607344524513 ,
 0.000194407871732 , 4.86089582261e-05 , 9.48808579758e-06 , 1.44506222909e-06 ,
 1.71659522187e-07 , 1.58995589301e-08 , 1.1479654207e-09  , 6.45970470451e-11 ,
 2.83257479089e-12 , 1.00933600831e-13 , 1.60125133243e-13 , 4.65420212581e-12 ,
 1.07385626655e-10 , 1.93663255631e-09 , 2.73224602788e-08 , 3.01862220966e-07 ,
 2.61473912682e-06 , 1.77810080872e-05 , 9.50646106642e-05 , 0.00040018751473  ,
 0.00132837594008  , 0.00348142075131  , 0.00721136873361  , 0.0118137376802   ,
 0.015309137783    , 0.0156886534602   , 0.0127050674697   , 0.00812183522914  ,
 0.00409325091503  , 0.00162603543398  , 0.000520083582    , 0.000188293791636 ,
 0.000265744648237 , 0.00073091712496  , 0.00174119257813  , 0.00331554976294  ,
 0.00504033461843  , 0.0061573723816   , 0.00614129250936  , 0.00535016610926  ,
 0.0056954089817   , 0.013150176622    , 0.0477698150979   , 0.176993884272    ,
 0.616761256684    , 2.00842646924     , 6.0538901339      , 16.6027304583     ,
 40.6654366938     , 87.5994163447     , 164.213018356     , 266.311525428     ,
 373.018923179     , 452.30150731      , 477.846175572     , 444.975054625     ,
 372.058102307     , 287.192035987     , 212.449094765     , 156.799902624     ,
 118.679836394     , 92.2904920531     , 72.3334202109     , 55.7224495969     ,
 41.3241924941     , 29.0838684459     , 19.2606147128     , 11.9608752197     ,
 6.9685660414      , 3.81773418856     , 1.97297195002     , 0.96804067914     ,
 0.456031639406    , 0.207835845196    , 0.0906468343947   , 0.0366957729985   ,
 0.0133408868302   , 0.00427633717126  , 0.00043401499761  , 9.67188611338e-05 ,
 1.90928795415e-05 , 3.57231026547e-06 , 1.53535138175e-06 , 5.39642809942e-06 ,
 2.32492365867e-05 , 8.04993370081e-05 , 0.000220604091333 , 0.000478113611769 ,
 0.000818902038184 , 0.00110726657604  , 0.0011803657095   , 0.000990581704177 ,
 0.000653471082017 , 0.000338378730015 , 0.000137356483641 , 4.36574235649e-05 ,
 1.08540758613e-05 , 2.10903919027e-06 , 3.20057664448e-07 , 3.79125131572e-08 ,
 3.50621855994e-09 , 2.61554014217e-10 , 4.16749235727e-11 , 6.7183367517e-11  ,
 1.2638256755e-10  , 1.879440909e-10   , 2.19727145274e-10 , 2.03562114871e-10 ,
 1.52353762418e-10 , 9.62393223757e-11 , 5.57455330544e-11 , 3.33233633922e-11 ,
 2.45825630018e-11 , 2.98905247472e-11 , 5.68775705883e-11 , 1.1903393684e-10  ,
 2.44859093639e-10 , 5.47896720414e-10 , 1.58212415623e-09 , 6.43000124177e-09 ,
 3.88947845637e-08 , 3.10238168184e-07 , 2.44804248503e-06 , 1.62479127572e-05 ,
 8.63188002329e-05 , 0.00036294982811  , 0.00120708361909  , 0.00318730717315  ,
 0.00675524290415  , 0.0118737585019   , 0.0190343022745   , 0.0337177864174   ,
 0.074986679557    , 0.186083987855    , 0.443389411069    , 0.963860687389    ,
 1.91943049967     , 3.56317206694     , 6.23832688426     , 10.2967778894     ,
 15.8580219307     , 22.4612380509     , 28.8871310008     , 33.4932308407     ,
 35.012902949      , 33.2180415037     , 28.9042965065     , 23.3380618315     ,
 17.7006962167     , 12.7966596859     , 8.969739557       , 6.17598365891     ,
 4.18441448204     , 2.7729778577      , 1.79557807825     , 1.14754354145     ,
 0.731765799857    , 0.464693440188    , 0.291027500618    , 0.179773297042    ,
 0.110563177504    , 0.067510010656    , 0.0402574302619   , 0.0234702346632   ,
 0.0137633838724   , 0.00817267604282  , 0.00465681374691  , 0.00236019850028  ,
 0.00101224749263  , 0.000378608713514 , 0.000196958003103 , 0.000297997736909 ,
 0.000616086693983 , 0.00107278786553  , 0.00147959069128  , 0.0016055433656   ,
 0.00136811825594  , 0.000914195771185 , 0.000478455588603 , 0.00019591843574  ,
 6.27125021271e-05 , 1.56803816227e-05 , 3.06068706576e-06 , 4.66151276711e-07 ,
 5.53742973849e-08 , 5.12891387295e-09 , 3.70313151069e-10 , 2.08378541499e-11 ,
 9.13742705584e-13 , 3.27907936273e-14 , 6.04162231398e-14 , 1.7604067703e-12  ,
 4.06230163699e-11 , 7.32731395746e-10 , 1.03396473317e-08 , 1.14262225581e-07 ,
 9.90039856348e-07 , 6.73497261152e-06 , 3.60229853902e-05 , 0.000151716252805 ,
 0.000503874078271 , 0.00132132877457  , 0.00273867497487  , 0.00448937644391  ,
 0.00582135919359  , 0.00596932223832  , 0.00483688137529  , 0.0030936341199   ,
 0.00155981656476  , 0.000619657094171 , 0.000197176528667 , 6.69965671623e-05 ,
 8.43536435583e-05 , 0.00022906749403  , 0.000545586515859 , 0.00103607971368  ,
 0.00156751963663  , 0.001908820497    , 0.00193968158777  , 0.00195415776025  ,
 0.00326794818274  , 0.0103258910464   , 0.0374983254095   , 0.129136542756    ,
 0.417930832486    , 1.28343542539     , 3.70988984275     , 9.8708722095      ,
 23.597245091      , 49.7485837821     , 91.4127157597     , 145.54884457      ,
 200.619955258     , 240.209932092     , 251.847100929     , 234.367740157     ,
 197.64074948      , 155.517935438     , 118.355976011     , 90.0736358529     ,
 69.7254679305     , 54.6092278346     , 42.4449370453     , 32.0513640256     ,
 23.1139962639     , 15.7245084928     , 10.0164624539     , 5.96154900939     ,
 3.32391704547     , 1.74447705996     , 0.866571223823    , 0.411515782569    ,
 0.190041455953    , 0.0863291768496   , 0.0379171096039   , 0.0153820696853   ,
 0.00549306768555  , 0.00167604594009  , 0.000170127388202 , 3.43813311916e-05 ,
 5.84648429204e-06 , 8.98420838008e-07 , 3.5062178898e-07  , 1.31190484111e-06 ,
 5.68370652545e-06 , 1.96849126853e-05 , 5.39462009463e-05 , 0.000116917302672 ,
 0.000200253290827 , 0.000270769600063 , 0.000288645172119 , 0.000242235625997 ,
 0.000159799010984 , 8.27467165387e-05 , 3.35889847723e-05 , 1.06759323625e-05 ,
 2.6542422018e-06  , 5.15741696331e-07 , 7.82663361875e-08 , 9.27085481427e-09 ,
 8.56866926517e-10 , 6.21359307291e-11 , 4.65434703865e-12 , 3.02367345998e-12 ,
 5.45668812941e-12 , 8.10443987323e-12 , 9.46176805483e-12 , 8.73347363922e-12 ,
 6.47491374198e-12 , 3.99989233462e-12 , 2.21844139714e-12 , 1.24875063367e-12 ,
 8.79287580495e-13 , 1.07421047681e-12 , 2.12245148067e-12 , 4.67215693096e-12 ,
 1.05579131069e-11 , 2.92125721099e-11 , 1.31455374358e-10 , 1.07348376025e-09 ,
 1.1724748316e-08  , 1.21192934116e-07 , 1.03216587273e-06 , 6.98491843177e-06 ,
 3.72737862851e-05 , 0.000156786209631 , 0.000520863551121 , 0.00137299393572  ,
 0.00290993640773  , 0.00517954883809  , 0.00880859146815  , 0.0178567832422   ,
 0.0455347376773   , 0.121498272502    , 0.297469608726    , 0.650443691668    ,
 1.29029344171     , 2.37712356736     , 4.12915766819     , 6.77121501955     ,
 10.3781527311     , 14.6477756949     , 18.7850293911     , 21.7233721484     ,
 22.6466355138     , 21.4144695418     , 18.54534752       , 14.8594175148     ,
 11.1271973593     , 7.88438348712     , 5.37073573451     , 3.56679428331     ,
 2.319179336       , 1.47040398415     , 0.909037385984    , 0.554408788928    ,
 0.338809353344    , 0.209827804773    , 0.134259238873    , 0.0915228013609   ,
 0.0658700566025   , 0.0463083348581   , 0.029159358475    , 0.0157673535199   ,
 0.00741846720522  , 0.00323187527153  , 0.00139661032941  , 0.000598329176843 ,
 0.000237697753171 , 8.68828252974e-05 , 4.68955908168e-05 , 7.42905581267e-05 ,
 0.000154827587588 , 0.000269842207152 , 0.00037221524556  , 0.000403911748709 ,
 0.000344184433741 , 0.000229989341545 , 0.000120367824439 , 4.92883375424e-05 ,
 1.57769489871e-05 , 3.94480490387e-06 , 7.69994871028e-07 , 1.17272391869e-07 ,
 1.3930834541e-08  , 1.29031073852e-09 , 9.31618364587e-11 , 5.24230034681e-12 ,
 2.29877071258e-13 , 8.32385533468e-15 , 1.80196713549e-14 , 5.26253543102e-13 ,
 1.21452970946e-11 , 2.19102383042e-10 , 3.09235885299e-09 , 3.41811644539e-08 ,
 2.96249450232e-07 , 2.01597072864e-06 , 1.07868774342e-05 , 4.54506412122e-05 ,
 0.000151023451073 , 0.000396247726749 , 0.00082175713995  , 0.0013478535758   ,
 0.0017487736972   , 0.00179422934431  , 0.00145461028277  , 0.000930802942142 ,
 0.000469505842807 , 0.000186544247921 , 5.91482198114e-05 , 1.90741420115e-05 ,
 2.12730406734e-05 , 5.65731945823e-05 , 0.000134558829151 , 0.000255849455143 ,
 0.000392125693708 , 0.000508787979827 , 0.000657464361711 , 0.00117758967566  ,
 0.0032594066533   , 0.0106656934495   , 0.0342467298384   , 0.102965713493    ,
 0.293384194611    , 0.810017582576    , 2.16664395242     , 5.46826703174     ,
 12.5911423567     , 25.7745958411     , 46.2016738807     , 72.0433037168     ,
 97.6835166425     , 115.703758767     , 120.874309942     , 113.090301834     ,
 96.8749336669     , 78.1980069053     , 61.3804881811     , 48.01013341       ,
 37.7128410267     , 29.4857854794     , 22.5657693188     , 16.6315562027     ,
 11.6496612288     , 7.67594000682     , 4.72667092232     , 2.71748752529     ,
 1.46548697647     , 0.746426011067    , 0.361576606216    , 0.168644834359    ,
 0.0774455611651   , 0.0355279678476   , 0.0158914961604   , 0.0065346922392   ,
 0.00233025026948  , 0.000694231921324 , 6.37698246206e-05 , 1.22874868246e-05 ,
 1.91767261541e-06 , 2.53030032235e-07 , 7.19677035894e-08 , 2.51328373259e-07 ,
 1.08950057374e-06 , 3.77369785606e-06 , 1.03418108833e-05 , 2.24137554691e-05 ,
 3.83897701249e-05 , 5.19081742796e-05 , 5.53350298514e-05 , 4.64380384318e-05 ,
 3.06344394343e-05 , 1.58630473403e-05 , 6.43921206555e-06 , 2.04664097212e-06 ,
 5.0883432349e-07  , 9.88708077111e-08 , 1.50041275615e-08 , 1.77727329023e-09 ,
 1.64249563702e-10 , 1.1850752688e-11  , 7.05122243851e-13 , 1.2599519035e-13  ,
 1.84859031925e-13 , 2.73253944994e-13 , 3.18639343746e-13 , 2.93239889967e-13 ,
 2.15731288258e-13 , 1.30792470827e-13 , 6.97783570889e-14 , 3.70138181184e-14 ,
 2.47719822864e-14 , 3.04683175205e-14 , 6.29493911012e-14 , 1.48069235629e-13 ,
 3.94481199655e-13 , 1.80223224545e-12 , 1.903432169e-11   , 2.79777126479e-10 ,
 3.76360661836e-09 , 4.10965684116e-08 , 3.54722289534e-07 , 2.40813444358e-06 ,
 1.28590277317e-05 , 5.40928945701e-05 , 0.000179770000142 , 0.000475249732129 ,
 0.00102177669291  , 0.00192474800912  , 0.00383506911561  , 0.00976118543238  ,
 0.0288049511332   , 0.0810873036349   , 0.201371979067    , 0.44028290362     ,
 0.867150775442    , 1.57758283673     , 2.69405385471     , 4.33222136947     ,
 6.51130419032     , 9.03184187901     , 11.4232152148     , 13.0799523684     ,
 13.5523113229     , 12.7689391687     , 11.0203455798     , 8.77250818795     ,
 6.48409347391     , 4.49492853379     , 2.96917582842     , 1.90161492808     ,
 1.19194578602     , 0.730911822055    , 0.4387501012      , 0.260473783418    ,
 0.155563929814    , 0.0963983233979   , 0.0662616161656   , 0.0529364133322   ,
 0.045159368634    , 0.0355251090456   , 0.0234468222514   , 0.0125019497424   ,
 0.00536074876755  , 0.001891342072    , 0.000583298870836 , 0.000172986506242 ,
 5.26817799985e-05 , 1.68645710828e-05 , 8.92010493536e-06 , 1.44886214338e-05 ,
 3.0349975661e-05  , 5.29233907711e-05 , 7.30058658372e-05 , 7.92235381515e-05 ,
 6.75087272068e-05 , 4.51103987677e-05 , 2.36091007312e-05 , 9.66747879273e-06 ,
 3.09451139959e-06 , 7.73739195198e-07 , 1.51027801732e-07 , 2.30019604348e-08 ,
 2.73241212098e-09 , 2.53083237161e-10 , 1.82728845443e-11 , 1.02823165177e-12 ,
 4.50887656711e-14 , 1.65136893649e-15 , 4.24314017022e-15 , 1.24172055523e-13 ,
 2.86606270853e-12 , 5.17111852969e-11 , 7.29963450077e-10 , 8.07027365723e-09 ,
 6.99628894291e-08 , 4.76237585776e-07 , 2.54909541859e-06 , 1.07449134374e-05 ,
 3.57190591657e-05 , 9.37631161471e-05 , 0.00019454959205  , 0.000319269042908 ,
 0.000414451448979 , 0.000425437574474 , 0.000345070943138 , 0.000220904618217 ,
 0.000111467626458 , 4.42956923083e-05 , 1.40062463222e-05 , 4.31768947234e-06 ,
 4.24167381167e-06 , 1.10325350091e-05 , 2.66848195166e-05 , 5.44025749205e-05 ,
 0.000104840627397 , 0.000233801559948 , 0.000639016694995 , 0.00184980888988  ,
 0.0051571642212   , 0.0137993167741   , 0.0357990147606   , 0.089606415796    ,
 0.216962684546    , 0.518805443376    , 1.239366547       , 2.89147170424     ,
 6.31193983704     , 12.4283156157     , 21.6098729412     , 32.8982256488     ,
 43.8435720216     , 51.4467891041     , 53.7388307843     , 50.7939242172     ,
 44.4097319905     , 36.8616706591     , 29.7731478557     , 23.7601159459     ,
 18.7526269632     , 14.4953311269     , 10.8366836091     , 7.7525273983      ,
 5.26113874893     , 3.36112651407     , 2.01127503759     , 1.12793583938     ,
 0.596500754387    , 0.299478100455    , 0.143319903795    , 0.0660078256903   ,
 0.0299762332534   , 0.0136913893736   , 0.0061411730923   , 0.00253559579647  ,
 0.000903600019089 , 0.000266588764607 , 2.04277705776e-05 , 3.86111808998e-06 ,
 5.81412530505e-07 , 7.09958222777e-08 , 1.35873832143e-08 , 3.78866458358e-08 ,
 1.63549705875e-07 , 5.66476078235e-07 , 1.55242841385e-06 , 3.36457069759e-06 ,
 5.76276012759e-06 , 7.79203303846e-06 , 8.30644473221e-06 , 6.97090072498e-06 ,
 4.59859294823e-06 , 2.38123167858e-06 , 9.66602155724e-07 , 3.07225100742e-07 ,
 7.63820710913e-08 , 1.48416816469e-08 , 2.25229755662e-09 , 2.66789686828e-10 ,
 2.46553766092e-11 , 1.77733382169e-12 , 1.00905251708e-13 , 6.92559011449e-15 ,
 4.99357870377e-15 , 7.20047830306e-15 , 8.38520032682e-15 , 7.69822017525e-15 ,
 5.62775658174e-15 , 3.35872136002e-15 , 1.73129936965e-15 , 8.66564628501e-16 ,
 5.4806422206e-16  , 6.78352027404e-16 , 1.48053763709e-15 , 3.91758643233e-15 ,
 1.69592663079e-14 , 2.15186091492e-13 , 4.17323880946e-12 , 7.2691047112e-11  ,
 1.01721521636e-09 , 1.12098084165e-08 , 9.69669447638e-08 , 6.5864029449e-07  ,
 3.51791625091e-06 , 1.48086652877e-05 , 4.93567235163e-05 , 0.000132028200626 ,
 0.000296874776705 , 0.000643755140225 , 0.00168069529191  , 0.00541704783965  ,
 0.0176471043444   , 0.0510610539082   , 0.127686832799    , 0.279844193134    ,
 0.551270147301    , 0.998602034158    , 1.68570096352     , 2.65886799048     ,
 3.89893898296     , 5.26950833401     , 6.51136866287     , 7.32532015527     ,
 7.50676023118     , 7.03153592215     , 6.0415631552      , 4.77169271944     ,
 3.47343224486     , 2.3488190809      , 1.50081961555     , 0.927059906626    ,
 0.563521829578    , 0.339289968557    , 0.202886983244    , 0.121254429811    ,
 0.0732727597882   , 0.046780099583    , 0.0350094042376   , 0.0317087665941   ,
 0.0298098903032   , 0.0246823333299   , 0.0166364500832   , 0.00888285937391  ,
 0.00373165228219  , 0.00123778385194  , 0.000329580935908 , 7.35714458575e-05 ,
 1.50741188483e-05 , 3.32515400385e-06 , 1.40489864478e-06 , 2.21134584445e-06 ,
 4.63855414524e-06 , 8.0909364668e-06  , 1.11615098569e-05 , 1.21121485564e-05 ,
 1.03211286278e-05 , 6.89674254581e-06 , 3.60949808086e-06 , 1.47802100074e-06 ,
 4.73107100192e-07 , 1.18293798355e-07 , 2.30900185022e-08 , 3.51667498318e-09 ,
 4.17747234084e-10 , 3.86928536537e-11 , 2.79366605011e-12 , 1.57202101849e-13 ,
 6.89350937362e-15 , 2.56140282529e-16 , 7.87657381927e-16 , 2.30915962929e-14 ,
 5.33038617495e-13 , 9.61856265973e-12 , 1.35797509194e-10 , 1.50161400792e-09 ,
 1.30206742139e-08 , 8.86549625823e-08 , 4.74676868891e-07 , 2.0015498622e-06  ,
 6.65629535524e-06 , 1.74802792258e-05 , 3.62861359012e-05 , 5.95752734247e-05 ,
 7.73713899879e-05 , 7.94571178932e-05 , 6.44737910274e-05 , 4.12896492569e-05 ,
 2.08413386613e-05 , 8.28335976655e-06 , 2.61335554757e-06 , 7.75669941381e-07 ,
 6.82692224938e-07 , 1.87248123606e-06 , 5.84719521384e-06 , 2.12177364324e-05 ,
 8.96894435731e-05 , 0.000369026813719 , 0.00130403860325  , 0.00382615678951  ,
 0.0094583585783   , 0.0205812877873   , 0.0418088230046   , 0.0831589707777   ,
 0.165703394377    , 0.336035895535    , 0.702374726367    , 1.48722396035     ,
 3.03906081696     , 5.71102302279     , 9.58621098284     , 14.2089798113     ,
 18.5937951598     , 21.6262714614     , 22.6240802419     , 21.6438883379     ,
 19.325639203      , 16.453058138      , 13.5841714491     , 10.9533641755     ,
 8.59364665467     , 6.50041980332     , 4.70256842962     , 3.238608392       ,
 2.11671293426     , 1.30833317926     , 0.763173343804    , 0.421393997112    ,
 0.221765892478    , 0.111505330715    , 0.0532690318241   , 0.0241746776265   ,
 0.0106547164583   , 0.00469849156885  , 0.00205193126839  , 0.000834529147711 ,
 0.000294863327084 , 8.63367117327e-05 , 5.30936751879e-06 , 9.94418203367e-07 ,
 1.47633438618e-07 , 1.74539910465e-08 , 2.40842717923e-09 , 4.50401577456e-09 ,
 1.9207271485e-08  , 6.65176368768e-08 , 1.82291470627e-07 , 3.95079440572e-07 ,
 6.76683076546e-07 , 9.14967267912e-07 , 9.75371254877e-07 , 8.18547092885e-07 ,
 5.39982570064e-07 , 2.79612398008e-07 , 1.13501743284e-07 , 3.60754259736e-08 ,
 8.96904499245e-09 , 1.74276120758e-09 , 2.64472510554e-10 , 3.13273592474e-11 ,
 2.89511069537e-12 , 2.08667706974e-13 , 1.17462123514e-14 , 5.64430790041e-16 ,
 1.14022992682e-16 , 1.43640634021e-16 , 1.66291731383e-16 , 1.51326325634e-16 ,
 1.08049584849e-16 , 6.06173928314e-17 , 2.67826823729e-17 , 9.49140971878e-18 ,
 3.56125447717e-18 , 5.00641852251e-18 , 1.75663080975e-17 , 9.45059950401e-17 ,
 1.522125533e-15   , 3.87023997177e-14 , 8.70227936647e-13 , 1.56047078727e-11 ,
 2.19755081243e-10 , 2.42533689084e-09 , 2.09892003481e-08 , 1.42632553055e-07 ,
 7.62804460353e-07 , 3.22493349479e-06 , 1.09091937689e-05 , 3.06705020511e-05 ,
 7.99174188368e-05 , 0.000234343327726 , 0.000833527763365 , 0.00307958116596  ,
 0.0102511555572   , 0.0293861096991   , 0.0728643567884   , 0.159708456211    ,
 0.316893131375    , 0.578761134254    , 0.978953989168    , 1.53079375192     ,
 2.20129135183     , 2.89629502168     , 3.4786008769      , 3.81931831263     ,
 3.84746555466     , 3.5651584462      , 3.03617854447     , 2.36880785583     ,
 1.6909444976      , 1.11152638996     , 0.685571701303    , 0.408608925668    ,
 0.24217524808     , 0.145098483368    , 0.0883802208699   , 0.0546666408469   ,
 0.0342768007215   , 0.0227277102294   , 0.01793324203     , 0.0171985512051   ,
 0.0167765208999   , 0.0141398389854   , 0.0096013630357   , 0.00513538865546  ,
 0.00214994881672  , 0.000704107003018 , 0.000180972860242 , 3.68839223106e-05 ,
 6.13554722933e-06 , 9.13244574916e-07 , 2.13772126588e-07 , 2.66315182044e-07 ,
 5.52726548178e-07 , 9.64000663236e-07 , 1.32986377492e-06 , 1.44313266613e-06 ,
 1.22973740543e-06 , 8.21730168802e-07 , 4.30062959701e-07 , 1.76102625528e-07 ,
 5.63695661775e-08 , 1.40944198363e-08 , 2.75111983359e-09 , 4.19003314961e-10 ,
 4.97735721205e-11 , 4.61015988799e-12 , 3.32858550055e-13 , 1.87302500544e-14 ,
 8.21356229749e-16 , 3.10793812574e-17 , 1.15086003113e-16 , 3.37917191595e-15 ,
 7.80103064534e-14 , 1.4078257642e-12  , 1.98786342689e-11 , 2.19847438105e-10 ,
 1.90668504892e-09 , 1.29851314786e-08 , 6.95433212127e-08 , 2.93328342617e-07 ,
 9.75810429516e-07 , 2.56353342924e-06 , 5.32350666563e-06 , 8.74366545067e-06 ,
 1.13599654447e-05 , 1.16705729482e-05 , 9.47315467821e-06 , 6.06863014069e-06 ,
 3.06404536082e-06 , 1.21797432693e-06 , 3.83676397414e-07 , 1.12390123843e-07 ,
 1.1903899522e-07  , 6.2082526842e-07  , 4.30010399132e-06 , 2.83027361723e-05 ,
 0.000156488678241 , 0.000697686983196 , 0.00248523036918  , 0.00709180424215  ,
 0.0164004800813   , 0.0315187506335   , 0.0527264491498   , 0.0822918819961   ,
 0.129180423343    , 0.21531906448     , 0.388954113494    , 0.744462054458    ,
 1.42199178486     , 2.54941557256     , 4.13216217048     , 5.96733782668     ,
 7.67397862035     , 8.8515385282      , 9.26954782582     , 8.95570484207     ,
 8.1280544056      , 7.0436060483      , 5.88505107931     , 4.74250207679     ,
 3.65974681161     , 2.68081802916     , 1.85570252442     , 1.21558735543     ,
 0.756642536845    , 0.449001463464    , 0.254908150024    , 0.13941925664     ,
 0.0739096475715   , 0.0377095964132   , 0.0181262589335   , 0.00808765224153  ,
 0.00340132579066  , 0.00140355685131  , 0.00057706720914  , 0.000225777268742 ,
 7.81455108248e-05 , 2.26243310654e-05 , 1.09956387056e-06 , 2.04504700137e-07 ,
 3.01453538547e-08 , 3.51566680416e-09 , 3.93782791956e-10 , 4.25485945383e-10 ,
 1.76339806258e-09 , 6.10466810615e-09 , 1.67297612933e-08 , 3.62583309277e-08 ,
 6.21024442279e-08 , 8.39709247903e-08 , 8.951448774e-08   , 7.51219839054e-08 ,
 4.9556784564e-08  , 2.56613678621e-08 , 1.04165981485e-08 , 3.31081448206e-09 ,
 8.23132180698e-10 , 1.59941536076e-10 , 2.42719079332e-11 , 2.87506164618e-12 ,
 2.6569800814e-13  , 1.91498161601e-14 , 1.07608438351e-15 , 4.71335890656e-17 ,
 1.60892505501e-18 , 4.27955067946e-20 , 8.82281340811e-22 , 0,
 1.24665327096e-28 , 6.20286511335e-27 , 2.34882328536e-25 , 6.94333962136e-24 ,
 1.60345416876e-22 , 2.89505411702e-21 , 1.5667863902e-19  , 6.19748789908e-18 ,
 2.21273009654e-16 , 6.4450017709e-15  , 1.48171534422e-13 , 2.669016779e-12   ,
 3.76337053414e-11 , 4.15767040087e-10 , 3.60669765922e-09 , 2.46811194823e-08 ,
 1.34772391809e-07 , 6.05462128692e-07 , 2.41095742428e-06 , 9.66223275248e-06 ,
 4.22811664245e-05 , 0.00018861819777  , 0.000763801522632 , 0.00264085378407  ,
 0.00770883740911  , 0.0193097615314   , 0.042843012843    , 0.0873081839342   ,
 0.167656160886    , 0.304690144684    , 0.517678417739    , 0.809212588795    ,
 1.15038383829     , 1.48042318377     , 1.72896249866     , 1.84705205856     ,
 1.81994628213     , 1.65814040771     , 1.38999047013     , 1.06354685542     ,
 0.739728351114    , 0.470492313291    , 0.279423573863    , 0.160627753781    ,
 0.0930445670562   , 0.0558192777903   , 0.0349384143729   , 0.0225358908621   ,
 0.0146961913826   , 0.0100089295335   , 0.00803086452198  , 0.0077952212808   ,
 0.00766410544284  , 0.0064872390137   , 0.00441396523871  , 0.0023624680286   ,
 0.000988587198655 , 0.00032299073751  , 8.24336541699e-05 , 1.64721417584e-05 ,
 2.59400106505e-06 , 3.29770113241e-07 , 4.29054774405e-08 , 2.6395079663e-08  ,
 5.14051917614e-08 , 8.95017241846e-08 , 1.23465816695e-07 , 1.3398182901e-07  ,
 1.14170020357e-07 , 7.62902320723e-08 , 3.99274657298e-08 , 1.63495399826e-08 ,
 5.23340565545e-09 , 1.30853972263e-09 , 2.55416656089e-10 , 3.89006775686e-11 ,
 4.6210271169e-12  , 4.28011752985e-13 , 3.09029133407e-14 , 1.73893473424e-15 ,
 7.62568582732e-17 , 2.95226909644e-18 , 1.32152445883e-17 , 3.88534999353e-16 ,
 8.97022074592e-15 , 1.61896880057e-13 , 2.28624877511e-12 , 2.52880972442e-11 ,
 2.19352883896e-10 , 1.49414720523e-09 , 8.00384731273e-09 , 3.37681564549e-08 ,
 1.1236765687e-07  , 2.95289397744e-07 , 6.13404445507e-07 , 1.00782730767e-06 ,
 1.30982081354e-06 , 1.34605836389e-06 , 1.09293439154e-06 , 7.0033537064e-07  ,
 3.53681020067e-07 , 1.40615060197e-07 , 4.44246734731e-08 , 1.6284782802e-08  ,
 6.59798611937e-08 , 6.82792458569e-07 , 6.04988421455e-06 , 4.29676684407e-05 ,
 0.00024225531818  , 0.00108245749857  , 0.00383527471774  , 0.0107966648143   ,
 0.0242600955541   , 0.0439744517935   , 0.0658255574183   , 0.0854025827819   ,
 0.104732298096    , 0.136511973179    , 0.20628300281     , 0.356355983042    ,
 0.643185113493    , 1.11278012282     , 1.75896074217     , 2.49611776007     ,
 3.17573781459     , 3.64545843301     , 3.81784006229     , 3.70274586777     ,
 3.38020649525     , 2.94223562235     , 2.45404539994     , 1.95307669612     ,
 1.46787600601     , 1.03130371398     , 0.675056016708    , 0.414217741055    ,
 0.241337072434    , 0.135401063858    , 0.0741491787866   , 0.0401651009355   ,
 0.0215893776088   , 0.0112641493021   , 0.00547669830389  , 0.00240698100625  ,
 0.000960957548239 , 0.0003639039802   , 0.000136500089995 , 4.99549968704e-05 ,
 1.66581534066e-05 , 4.73316683357e-06 , 1.80652474741e-07 , 3.33231357101e-08 ,
 4.88423541877e-09 , 5.65612263716e-10 , 5.65830059578e-11 , 3.25037539442e-11 ,
 1.26506811377e-10 , 4.37573163702e-10 , 1.19915065731e-09 , 2.59891310866e-09 ,
 4.45135923373e-09 , 6.01884122397e-09 , 6.41619096489e-09 , 5.38456965534e-09 ,
 3.55211543289e-09 , 1.83934735907e-09 , 7.46637607081e-10 , 2.37311506802e-10 ,
 5.90002064921e-11 , 1.14642385226e-11 , 1.73975409247e-12 , 2.06077753707e-13 ,
 1.9044617271e-14  , 1.37261442844e-15 , 7.71312339853e-17 , 3.37842639712e-18 ,
 1.15324018064e-19 , 3.06748271666e-21 , 6.3239881167e-23  , 0,
 2.5364845445e-30  , 1.26207185808e-28 , 4.77894994771e-27 , 1.41268322313e-25 ,
 3.26229515744e-24 , 5.88988337687e-23 , 1.65165592387e-20 , 7.87471250597e-19 ,
 2.95242490434e-17 , 8.70049234792e-16 , 2.00773048657e-14 , 3.628299331e-13   ,
 5.15123164963e-12 , 5.80121896925e-11 , 5.31028723712e-10 , 4.18767401335e-09 ,
 3.15590749893e-08 , 2.48065799571e-07 , 1.9684398536e-06  , 1.41640700549e-05 ,
 8.54026161766e-05 , 0.000416416847617 , 0.00162219085317  , 0.00504220383867  ,
 0.0125805790421   , 0.025604857765    , 0.0439998838805   , 0.0680326609813   ,
 0.103084609284    , 0.161685102407    , 0.257261627044    , 0.391977876177    ,
 0.547988452615    , 0.691101314282    , 0.787499353824    , 0.820273395823    ,
 0.790157854259    , 0.705279253648    , 0.57810221976     , 0.430071220136    ,
 0.288880617435    , 0.176471850642    , 0.100399253797    , 0.0554782495678   ,
 0.0313288168351   , 0.0187704340408   , 0.0120175430969   , 0.00801780585351  ,
 0.00538091672713  , 0.00371204243862  , 0.0029654964702   , 0.00285365898097  ,
 0.00279482150949  , 0.00236375919142  , 0.00160836306038  , 0.000860913893038 ,
 0.000360228032395 , 0.000117642234752 , 2.99843083325e-05 , 5.9684503563e-06  ,
 9.29384994906e-07 , 1.13830037805e-07 , 1.16320951185e-08 , 2.5404902326e-09  ,
 3.75468470948e-09 , 6.47564512181e-09 , 8.93086622202e-09 , 9.69148524134e-09 ,
 8.25841077974e-09 , 5.51840208675e-09 , 2.88812610181e-09 , 1.18263286517e-09 ,
 3.78554842044e-10 , 9.4652331701e-11  , 1.84753902661e-11 , 2.81385407947e-12 ,
 3.34258856579e-13 , 3.09599393244e-14 , 2.23534123842e-15 , 1.2578466242e-16  ,
 5.51611268533e-18 , 2.19755441435e-19 , 1.19087698128e-18 , 3.50504664475e-17 ,
 8.09268885477e-16 , 1.46069717173e-14 , 2.06293068048e-13 , 2.28205136308e-12 ,
 1.97975097482e-11 , 1.34874347938e-10 , 7.22628147667e-10 , 3.04940302866e-09 ,
 1.01496394224e-08 , 2.66788792177e-08 , 5.54348702931e-08 , 9.11047944824e-08 ,
 1.18436329417e-07 , 1.21744765848e-07 , 9.88749486093e-08 , 6.33715357026e-08 ,
 3.20101736024e-08 , 1.2738085904e-08  , 4.26327304462e-09 , 6.01864695178e-09 ,
 7.2372032603e-08  , 8.23229639069e-07 , 7.42739603268e-06 , 5.29652639408e-05 ,
 0.000298660874096 , 0.00133256104401  , 0.00470724827512  , 0.0131736720135   ,
 0.0292495538161   , 0.0517142001309   , 0.0735029922818   , 0.0859919603069   ,
 0.0876686486691   , 0.0881910704739   , 0.105126694746    , 0.160162841799    ,
 0.276620544335    , 0.471530034245    , 0.741563263369    , 1.05289975864     ,
 1.34480450696     , 1.54996606477     , 1.62497568648     , 1.57021062715     ,
 1.42090064944     , 1.21980465706     , 0.998042500182    , 0.773983293031    ,
 0.561477012029    , 0.375722729993    , 0.230445494641    , 0.130486632689    ,
 0.0696477697621   , 0.0360705334614   , 0.0186917470041   , 0.00993334688648  ,
 0.00540634272293  , 0.00288805909867  , 0.00142334384605  , 0.000619147903172 ,
 0.000236212587483 , 8.19679333865e-05 , 2.74769469716e-05 , 9.12471179254e-06 ,
 2.86526163578e-06 , 7.89493205918e-07 , 2.35755431492e-08 , 4.29804115338e-09 ,
 6.25868609154e-10 , 7.20995834079e-11 , 6.81803205641e-12 , 2.07707049542e-12 ,
 7.0922370463e-12  , 2.44823994733e-11 , 6.70913045404e-11 , 1.45406598231e-10 ,
 2.49049111802e-10 , 3.36748166602e-10 , 3.58979488509e-10 , 3.01261304611e-10 ,
 1.98737317546e-10 , 1.02909651188e-10 , 4.17736298309e-11 , 1.32773422417e-11 ,
 3.30100273891e-12 , 6.4141271722e-13  , 9.7337507201e-14  , 1.15298448914e-14 ,
 1.06552735169e-15 , 7.6796408981e-17  , 4.31541565325e-18 , 1.89019589136e-19 ,
 6.45226385002e-21 , 1.71622600178e-22 , 3.53820831065e-24 , 0, 0, 0, 0, 0, 0,
 0, 1.68082882306e-21 , 8.34027321606e-20 , 3.15541274809e-18 ,
 9.31808750954e-17 , 2.21091215924e-15 , 4.25818210717e-14 , 6.99922997141e-13 ,
 1.08740569669e-11 , 1.72733032807e-10 , 2.72656587455e-09 , 3.88335256212e-08 ,
 4.63470880333e-07 , 4.47420639987e-06 , 3.44496974227e-05 , 0.000210403890026 ,
 0.00101696815422  , 0.00388588798605  , 0.0117366525005   , 0.0280543001935   ,
 0.0532863022712   , 0.0812915396006   , 0.102311533748    , 0.113008229232    ,
 0.122508567267    , 0.145310775137    , 0.18791297159     , 0.242673580267    ,
 0.293014073571    , 0.324144820891    , 0.330199509785    , 0.312417529956    ,
 0.273740678444    , 0.218814565669    , 0.157127861664    , 0.100872310554    ,
 0.0585103258309   , 0.0315539690528   , 0.0166094291523   , 0.0090665260894   ,
 0.00537347155212  , 0.00347668660304  , 0.00236629996801  , 0.00161397967883  ,
 0.00111644230299  , 0.000879753547063 , 0.00083268686197  , 0.000808834142081 ,
 0.000682269097041 , 0.000463908636032 , 0.000248277169379 , 0.000103879734736 ,
 3.39217140578e-05 , 8.64366171427e-06 , 1.71927471101e-06 , 2.67138243824e-07 ,
 3.24756013927e-08 , 3.12836412828e-09 , 3.2677511625e-10  , 2.22256372637e-10 ,
 3.6540113101e-10  , 5.0329014034e-10  , 5.4613595955e-10  , 4.65378762972e-10 ,
 3.10973522824e-10 , 1.62751958751e-10 , 6.66438405169e-11 , 2.13323587262e-11 ,
 5.33385726423e-12 , 1.04112696233e-12 , 1.5856657467e-13  , 1.88361871099e-14 ,
 1.74465746695e-15 , 1.25966163626e-16 , 7.08822934762e-18 , 3.10853528697e-19 ,
 1.28325766662e-20 , 8.41063764376e-20 , 2.47767036407e-18 , 5.72089508977e-17 ,
 1.03266064061e-15 , 1.4585270194e-14  , 1.61359591728e-13 , 1.39999839864e-12 ,
 9.53899868738e-12 , 5.11156708507e-11 , 2.15739177287e-10 , 7.18204824531e-10 ,
 1.88823408742e-09 , 3.92434039687e-09 , 6.4509301185e-09  , 8.38808073856e-09 ,
 8.62423776223e-09 , 7.00556579327e-09 , 4.49086977174e-09 , 2.26911816669e-09 ,
 9.13188875078e-10 , 5.44056029252e-10 , 4.90238948379e-09 , 7.02145061759e-08 ,
 8.03443074033e-07 , 7.25243932123e-06 , 5.16946903278e-05 , 0.000291262001722 ,
 0.00129809592173  , 0.00457794829727  , 0.012776658891    , 0.0282226880336   ,
 0.0493823975207   , 0.068657644817    , 0.0765724608259   , 0.0704542307316   ,
 0.0581411833688   , 0.0529596088013   , 0.0673936257127   , 0.111228585216    ,
 0.190848085116    , 0.305780136113    , 0.443832105994    , 0.578934147019    ,
 0.677295642318    , 0.713351846565    , 0.683932810481    , 0.606502117364    ,
 0.504964661573    , 0.3979737007      , 0.296204197571    , 0.205453907764    ,
 0.130366877941    , 0.0746798601727   , 0.0387069730819   , 0.0185775839862   ,
 0.00862488596714  , 0.00409844479567  , 0.00208964119127  , 0.00113900463232  ,
 0.000619917533028 , 0.000309385955552 , 0.000133850609618 , 4.93939599645e-05 ,
 1.59241098627e-05 , 4.76085713843e-06 , 1.39942622946e-06 , 4.02117220202e-07 ,
 1.05511798126e-07 , 2.45493693644e-09 , 4.39612198403e-10 , 6.34446336092e-11 ,
 7.26915013846e-12 , 6.68628944458e-13 , 1.16889590976e-13 , 3.11036274086e-13 ,
 1.06874975501e-12 , 2.9286204491e-12  , 6.34717771334e-12 , 1.08713014234e-11 ,
 1.46994735137e-11 , 1.5669898181e-11  , 1.31504281449e-11 , 8.67512944444e-12 ,
 4.49213341591e-12 , 1.8234705521e-12  , 5.79572392582e-13 , 1.44092847836e-13 ,
 2.79984575515e-14 , 4.24890244669e-15 , 5.03291974263e-16 , 4.65115853263e-17 ,
 3.35225813152e-18 , 1.88373224822e-19 , 8.25093859342e-21 , 2.81649288618e-22 ,
 7.491538532e-24   , 1.54447164103e-25 , 0, 0, 0, 0, 0, 0, 0,
 1.42407490106e-22 , 7.06625987079e-21 , 2.6734095201e-19  , 7.89470825353e-18 ,
 3.26956720482e-16 , 1.19451657806e-14 , 3.89714141666e-13 , 1.12286307318e-11 ,
 2.68323624293e-10 , 5.1642023713e-09  , 7.91692503761e-08 , 9.63170642865e-07 ,
 9.28764046021e-06 , 7.09415255849e-05 , 0.000428979499703 , 0.00205220247707  ,
 0.00776166936924  , 0.0231968548591   , 0.0547848810284   , 0.102372041751    ,
 0.151939717772    , 0.180931441919    , 0.17723445924     , 0.151257978002    ,
 0.125165182237    , 0.112929744653    , 0.113611947229    , 0.118941343636    ,
 0.122023716351    , 0.11992362079     , 0.11170405299     , 0.0966766570108   ,
 0.0756133360341   , 0.0522954597931   , 0.0318166460531   , 0.0172795754234   ,
 0.00868252872716  , 0.00427853118076  , 0.00222207749889  , 0.00128373649916  ,
 0.000827098454026 , 0.000566359256547 , 0.000388429613789 , 0.000267683081436 ,
 0.000207352073894 , 0.000192612620388 , 0.000185319374396 , 0.000155815124873 ,
 0.000105846998558 , 5.66333129155e-05 , 2.36938381262e-05 , 7.73692542267e-06 ,
 1.97136005167e-06 , 3.92060148931e-07 , 6.08926091195e-08 , 7.39203430056e-09 ,
 7.03559638665e-10 , 5.64083259523e-11 , 1.22050708177e-11 , 1.61521717259e-11 ,
 2.20974564126e-11 , 2.3974413179e-11  , 2.0429220324e-11  , 1.36511297134e-11 ,
 7.14449281063e-12 , 2.92553431069e-12 , 9.36448843545e-13 , 2.34145906265e-13 ,
 4.5703438254e-14  , 6.96076263203e-15 , 8.26871789579e-16 , 7.65870520123e-17 ,
 5.52966832067e-18 , 3.11159410948e-19 , 1.36463704554e-20 , 5.88624698042e-22 ,
 4.65010462711e-21 , 1.37085787737e-19 , 3.16541241654e-18 , 5.71406688147e-17 ,
 8.07102173789e-16 , 8.92978391349e-15 , 7.74840626038e-14 , 5.2799948667e-13  ,
 2.82968561326e-12 , 1.19446667525e-11 , 3.97705068252e-11 , 1.04578428664e-10 ,
 2.17385370387e-10 , 3.57408605018e-10 , 4.64818627007e-10 , 4.77987774293e-10 ,
 3.88337643443e-10 , 2.48984408707e-10 , 1.26083125832e-10 , 5.86065535454e-11 ,
 2.1776823582e-10  , 3.73935473792e-09 , 5.42801169326e-08 , 6.21028330282e-07 ,
 5.60274553765e-06 , 3.99088960307e-05 , 0.000224684431651 , 0.00100048338758  ,
 0.00352451436587  , 0.00982174576883  , 0.0216427518717   , 0.0376990874631   ,
 0.0519327342372   , 0.0567535548289   , 0.0497932261229   , 0.0366789480199   ,
 0.0266234215589   , 0.0268184998666   , 0.0412422557962   , 0.0721022399313   ,
 0.119825203908    , 0.180513855564    , 0.243059724525    , 0.290654148337    ,
 0.309014904349    , 0.294897290942    , 0.256338120251    , 0.205937500004    ,
 0.154581627056    , 0.108826180148    , 0.0713008322103   , 0.0426596506495   ,
 0.0228415493742   , 0.0108609571331   , 0.00466035260655  , 0.00189428975073  ,
 0.000792962777537 , 0.00037323091647  , 0.00019914310893  , 0.000109269970983 ,
 5.50324003604e-05 , 2.37543949609e-05 , 8.57852428748e-06 , 2.62150808009e-06 ,
 7.1043542011e-07  , 1.83260045323e-07 , 4.68261419517e-08 , 1.14089815666e-08 ,
 2.05532528263e-10 , 3.57852136292e-11 , 5.09643590495e-12 , 5.79903430135e-13 ,
 5.25592153798e-14 , 6.0802566476e-15  , 1.07049540974e-14 , 3.63892170755e-14 ,
 9.97012440815e-14 , 2.16081415019e-13 , 3.70099318589e-13 , 5.0042445866e-13  ,
 5.33461304391e-13 , 4.4768922366e-13  , 2.95333499664e-13 , 1.52928839988e-13 ,
 6.20776834668e-14 , 1.97307883538e-14 , 4.90545360743e-15 , 9.53171074488e-16 ,
 1.4464835797e-16  , 1.71339207172e-17 , 1.58342643269e-18 , 1.14123268373e-19 ,
 6.4129214539e-21  , 2.80892473815e-22 , 9.58838373748e-24 , 2.55039686347e-25 ,
 5.25795283861e-27 , 0, 0, 0, 0, 0, 0, 0, 9.52995668815e-24 ,
 4.72876457015e-22 , 1.78905450745e-20 , 5.2831648503e-19  , 2.82675843097e-16 ,
 1.58376846702e-14 , 6.17327446088e-13 , 1.90301878207e-11 , 4.63295223903e-10 ,
 8.90934861839e-09 , 1.35453598573e-07 , 1.62963159601e-06 , 1.55249909048e-05 ,
 0.000117150950206 , 0.000700162208737 , 0.00331300755415  , 0.0124043687137   ,
 0.0367300585531   , 0.0859916836789   , 0.159254924723    , 0.2338017016      ,
 0.273646020007    , 0.258851914093    , 0.204066081816    , 0.14253331269     ,
 0.0968449761399   , 0.0696773168382   , 0.0544828363401   , 0.0457183913588   ,
 0.0403932926356   , 0.0361739523083   , 0.0309198675419   , 0.0238093635443   ,
 0.0159339456069   , 0.00917690680194  , 0.00461915328244  , 0.00211923067366  ,
 0.000951893127996 , 0.000458286263062 , 0.000252838749092 , 0.000159663467207 ,
 0.000108622279198 , 7.42622826865e-05 , 5.07651780188e-05 , 3.86245338916e-05 ,
 3.52188056159e-05 , 3.3563544261e-05  , 2.81270505178e-05 , 1.90883258664e-05 ,
 1.0210366059e-05  , 4.27141133934e-06 , 1.39474305108e-06 , 3.55373900871e-07 ,
 7.06741150375e-08 , 1.09758600529e-08 , 1.33204996662e-09 , 1.26487435862e-10 ,
 9.53858192895e-12 , 8.60393564706e-13 , 5.7255521162e-13  , 7.56338083493e-13 ,
 8.19813818246e-13 , 6.98567639304e-13 , 4.66793698111e-13 , 2.44302432854e-13 ,
 1.00037213062e-13 , 3.20214096075e-14 , 8.00650459886e-15 , 1.56280668922e-15 ,
 2.38019869379e-16 , 2.82744759092e-17 , 2.61885673737e-18 , 1.89084300237e-19 ,
 1.06399436764e-20 , 4.66653269255e-22 , 2.12384775354e-23 , 2.01067576273e-22 ,
 5.93096859812e-21 , 1.36954884523e-19 , 2.47234896286e-18 , 3.4923213017e-17  ,
 3.86413692376e-16 , 3.35316634632e-15 , 2.28514180626e-14 , 1.22478779174e-13 ,
 5.17065692944e-13 , 1.72181848954e-12 , 4.52821945284e-12 , 9.4140801707e-12  ,
 1.54801841697e-11 , 2.01352739319e-11 , 2.07086214748e-11 , 1.68268285709e-11 ,
 1.07940556852e-11 , 5.62715490906e-12 , 7.42597679643e-12 , 1.24428425955e-10 ,
 2.28655680889e-09 , 3.32088258115e-08 , 3.79753891964e-07 , 3.4239749256e-06  ,
 2.43730360444e-05 , 0.000137119047089 , 0.000610090202639 , 0.00214737512327  ,
 0.00597799340005  , 0.0131549662813   , 0.0228653097391   , 0.0313727875807   ,
 0.0339944426677   , 0.0292216582414   , 0.020373070064    , 0.0127636232004   ,
 0.010112662962    , 0.013890677107    , 0.0246899193485   , 0.0428587737608   ,
 0.0673256559799   , 0.0937727469975   , 0.114876734889    , 0.123937769406    ,
 0.118838251134    , 0.102457859097    , 0.0801954040623   , 0.0574448918578   ,
 0.0379467597848   , 0.0231653666733   , 0.01292729539     , 0.0064563411362   ,
 0.0028359404821   , 0.00109784122199  , 0.000388976259446 , 0.00013859022089  ,
 5.7084790544e-05  , 2.86938755768e-05 , 1.56071197753e-05 , 7.88781131371e-06 ,
 3.40091563293e-06 , 1.21224770336e-06 , 3.57683433588e-07 , 9.01070429927e-08 ,
 2.06444343418e-08 , 4.60893037979e-09 , 1.01254638027e-09 , 1.39902439419e-11 ,
 2.33109599945e-12 , 3.25258261055e-13 , 3.66502025734e-14 , 3.28944432809e-15 ,
 2.94528526773e-16 , 2.91484235583e-16 , 9.66187663542e-16 , 2.6463574008e-15  ,
 5.73539849252e-15 , 9.82345922952e-15 , 1.32826487847e-14 , 1.41595380158e-14 ,
 1.18829098371e-14 , 7.83896766536e-15 , 4.05915425485e-15 , 1.6477133613e-15  ,
 5.23709677681e-16 , 1.30204302107e-16 , 2.52997957934e-17 , 3.83936736693e-18 ,
 4.54781630378e-19 , 4.20285156288e-20 , 3.02914708849e-21 , 1.70216666835e-22 ,
 7.45566291051e-24 , 2.54502215856e-25 , 6.76945844927e-27 , 1.39560606347e-28 ,
 0, 0, 0, 0, 0, 0, 0, 5.03110198627e-25 , 2.49643282348e-23 ,
 9.44486516352e-22 , 2.78911454075e-20 , 4.03391925212e-16 , 2.2558417725e-14  ,
 8.80417675483e-13 , 2.69964080397e-11 , 6.51631087028e-10 , 1.2400686445e-08  ,
 1.86333842004e-07 , 2.21371450553e-06 , 2.08159073541e-05 , 0.000155029725487 ,
 0.000914766074739 , 0.00427612636439  , 0.015830282473    , 0.0463905100002   ,
 0.107580170324    , 0.19745796203     , 0.287239211793    , 0.332467995689    ,
 0.309135562884    , 0.235874712206    , 0.154038111994    , 0.0919996485495   ,
 0.0538138004222   , 0.0320143195589   , 0.0199407423149   , 0.0138135047176   ,
 0.0108840540111   , 0.0089181759775   , 0.00675311746848  , 0.00440793929403  ,
 0.00242348097278  , 0.00113274323278  , 0.000468768761316 , 0.000186292975324 ,
 8.00188535999e-05 , 4.08913051328e-05 , 2.48409013839e-05 , 1.65929584335e-05 ,
 1.12245937116e-05 , 7.58572425375e-06 , 5.66961461575e-06 , 5.08029427131e-06 ,
 4.7982814053e-06  , 4.00854595424e-06 , 2.71784812061e-06 , 1.45339278168e-06 ,
 6.07967755831e-07 , 1.98515349515e-07 , 5.05803950543e-08 , 1.00589881957e-08 ,
 1.56216198631e-09 , 1.89577177194e-10 , 1.79937469899e-11 , 1.34057816123e-12 ,
 8.61769035766e-14 , 1.81400777707e-14 , 2.02486487541e-14 , 2.18384823733e-14 ,
 1.86062525623e-14 , 1.24329424795e-14 , 6.5069387321e-15  , 2.66446800684e-15 ,
 8.52882830517e-16 , 2.13251396129e-16 , 4.16249943081e-17 , 6.33960410874e-18 ,
 7.53084119043e-19 , 6.97526428181e-20 , 5.03621655541e-21 , 2.83392436202e-22 ,
 1.24299648898e-23 , 6.03667436276e-25 , 6.7937504214e-24  , 2.00491642588e-22 ,
 4.62976985396e-21 , 8.358058929e-20   , 1.18066539147e-18 , 1.30642911609e-17 ,
 1.13373972644e-16 , 7.72682300485e-16 , 4.14174203594e-15 , 1.74866699436e-14 ,
 5.82361106194e-14 , 1.53172111045e-13 , 3.1847829215e-13  , 5.23755763597e-13 ,
 6.81334622946e-13 , 7.00813256274e-13 , 5.69545507012e-13 , 3.67419562984e-13 ,
 2.69416198527e-13 , 2.62033459049e-12 , 5.99483517601e-11 , 1.10675670873e-09 ,
 1.60678649611e-08 , 1.83646513457e-07 , 1.65484852061e-06 , 1.17722536925e-05 ,
 6.61835107637e-05 , 0.000294260830142 , 0.00103494861104  , 0.00287884225836  ,
 0.00632929900861  , 0.0109881672763   , 0.0150480578593   , 0.0162456545642   ,
 0.0138437560335   , 0.0094129295568   , 0.00543356965361  , 0.00352866587946  ,
 0.00416552479672  , 0.00741894370353  , 0.0134214586909   , 0.0219288998849   ,
 0.0315201917815   , 0.0395839949712   , 0.0435903064052   , 0.042484731872    ,
 0.03691704881     , 0.0286434191731   , 0.0198455759018   , 0.012346712606    ,
 0.00696598209995  , 0.00357556810063  , 0.00164998827079  , 0.000670782741138 ,
 0.000237474120793 , 7.4484666821e-05  , 2.23747252986e-05 , 7.63686851626e-06 ,
 3.41409523873e-06 , 1.792753621e-06   , 9.01812238052e-07 , 3.88169791636e-07 ,
 1.3728712721e-07  , 3.96439183074e-08 , 9.51136958435e-09 , 1.98617724121e-09 ,
 3.88396544714e-10 , 7.50516334712e-11 , 7.85619362846e-13 , 1.22498522536e-13 ,
 1.65533081693e-14 , 1.8380633517e-15  , 1.63484341841e-16 , 1.27579930209e-17 ,
 6.33469618747e-18 , 1.97857233077e-17 , 5.41492595216e-17 , 1.17355474381e-16 ,
 2.01003745727e-16 , 2.71784316781e-16 , 2.89726878122e-16 , 2.43143410913e-16 ,
 1.60397862335e-16 , 8.3056812218e-17  , 3.37148604478e-17 , 1.07159407169e-17 ,
 2.66418903818e-18 , 5.17674435717e-19 , 7.8559619667e-20  , 9.30556221887e-21 ,
 8.59970898176e-22 , 6.19812121229e-23 , 3.48290625241e-24 , 1.52554831731e-25 ,
 5.20752388904e-27 , 1.38513986889e-28 , 2.85563404262e-30 , 0, 0, 0, 0, 0, 0,
 0, 2.09234855547e-26 , 1.03822335608e-24 , 3.92795651848e-23 ,
 1.15994462793e-21 , 4.78175431624e-16 , 2.60646767908e-14 , 1.0109505112e-12  ,
 3.07664851484e-11 , 7.36063336731e-10 , 1.38653056733e-08 , 2.05976409908e-07 ,
 2.41680942972e-06 , 2.24277526008e-05 , 0.00016477931011  , 0.000959158364987 ,
 0.00442464934832  , 0.0161752656837   , 0.0468484811878   , 0.107470606754    ,
 0.195272868761    , 0.281276149491    , 0.32210958681     , 0.29538625244     ,
 0.220502634911    , 0.138522927782    , 0.0773623291468   , 0.0407889129219   ,
 0.0208905454562   , 0.0104277600787   , 0.00536891633193  , 0.00324692205     ,
 0.00233522633639  , 0.00169511836947  , 0.00108180564172  , 0.000575122742785 ,
 0.000253420401375 , 9.52809242701e-05 , 3.29726959034e-05 , 1.20909223233e-05 ,
 5.4639717624e-06  , 3.1099279628e-06  , 2.01353879518e-06 , 1.33822035907e-06 ,
 8.91292177111e-07 , 6.54532881167e-07 , 5.77152657917e-07 , 5.40675103846e-07 ,
 4.50406338741e-07 , 3.05122322338e-07 , 1.63127153396e-07 , 6.8232921674e-08  ,
 2.2279173912e-08  , 5.67655341058e-09 , 1.12890076821e-09 , 1.75317874039e-10 ,
 2.12756112233e-11 , 2.01921118817e-12 , 1.50091540786e-13 , 8.90709735584e-15 ,
 7.01156388944e-16 , 4.31132897337e-16 , 4.52714766382e-16 , 3.85436366845e-16 ,
 2.57548783231e-16 , 1.34791410146e-16 , 5.51945261414e-17 , 1.76674906825e-17 ,
 4.41750838374e-18 , 8.6226287221e-19  , 1.31325068948e-19 , 1.56001577008e-20 ,
 1.44492786462e-21 , 1.04325360864e-22 , 5.8704819079e-24  , 2.57507491459e-25 ,
 1.35222171596e-26 , 1.79251228239e-25 , 5.29189523049e-24 , 1.2220340829e-22  ,
 2.20617690326e-21 , 3.11655844861e-20 , 3.44866332838e-19 , 2.99294115905e-18 ,
 2.03990209805e-17 , 1.09350006088e-16 , 4.61715131297e-16 , 1.53777960347e-15 ,
 4.04500494544e-15 , 8.4112159435e-15  , 1.38340126436e-14 , 1.79978153614e-14 ,
 1.85139891059e-14 , 1.50625692539e-14 , 1.04972712329e-14 , 3.73671460798e-14 ,
 9.76849811103e-13 , 2.29317451937e-11 , 4.23358546678e-10 , 6.14374046186e-09 ,
 7.01853367342e-08 , 6.32098491675e-07 , 4.49392729012e-06 , 2.52486636315e-05 ,
 0.000112184197973 , 0.0003942964189   , 0.00109603203204  , 0.00240797865323  ,
 0.00417713861539  , 0.00571459079036  , 0.00615875615046  , 0.00522810060475  ,
 0.00351419096261  , 0.0019424059596   , 0.0010923886654   , 0.00108671282427  ,
 0.00189892894025  , 0.00355532587469  , 0.00601237280038  , 0.00889465678233  ,
 0.0114660380053   , 0.0129681470394   , 0.0129842256879   , 0.0115291662759   ,
 0.00901039230402  , 0.00614196695388  , 0.00364955306058  , 0.00191128892291  ,
 0.000895279423339 , 0.000376721678146 , 0.000140712616706 , 4.58429175163e-05 ,
 1.29948292832e-05 , 3.35385720432e-06 , 9.20957938287e-07 , 3.40408481598e-07 ,
 1.65380952025e-07 , 8.17548510677e-08 , 3.50518223776e-08 , 1.23342881206e-08 ,
 3.51614862857e-09 , 8.18300382486e-10 , 1.60209048339e-10 , 2.8025628638e-11  ,
 4.71974042289e-12 , 3.69741802998e-14 , 5.25110923132e-15 , 6.75413911477e-16 ,
 7.33113713579e-17 , 6.44470603258e-18 , 4.5001083055e-19  , 2.47391988031e-20 ,
 1.0660506933e-21  , 3.59706815873e-23 , 9.47310592363e-25 , 1.89477282043e-26 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 6.84473496727e-28 , 3.39635750012e-26 , 1.28495901229e-24 , 3.79454634084e-23 ,
 4.52418862205e-16 , 2.41141876684e-14 , 9.30014118237e-13 , 2.81137163412e-11 ,
 6.67253996506e-10 , 1.245283388e-08   , 1.83040856769e-07 , 2.12243686982e-06 ,
 1.94444069894e-05 , 0.000140931797043 , 0.000808967182731 , 0.00368008559112  ,
 0.0132717580878   , 0.0379446138118   , 0.0859934211313   , 0.154477690303    ,
 0.220088466051    , 0.24920499968     , 0.225491130887    , 0.165164555252    ,
 0.100633667782    , 0.0535127168256   , 0.0263461756555   , 0.0124072008531   ,
 0.00551940644723  , 0.00232273597814  , 0.00103342644233  , 0.000573637329874 ,
 0.000372383555019 , 0.00022900586554  , 0.000118710916543 , 5.02767449023e-05 ,
 1.75919349159e-05 , 5.37049605768e-06 , 1.63666619172e-06 , 6.15574712904e-07 ,
 3.14624721856e-07 , 1.94053431648e-07 , 1.25737951231e-07 , 8.2252028029e-08  ,
 5.93427755329e-08 , 5.15590860653e-08 , 4.79472103906e-08 , 3.98415143929e-08 ,
 2.69698958165e-08 , 1.44157883848e-08 , 6.02947849871e-09 , 1.96869037577e-09 ,
 5.01603940162e-10 , 9.97542273852e-11 , 1.54917802706e-11 , 1.8799931375e-12  ,
 1.78421835244e-13 , 1.32555319847e-14 , 7.717817289e-16   , 3.5261219032e-17  ,
 1.26595317412e-18 , 3.57684020848e-20 , 7.96497609075e-22 , 5.08052481203e-24 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.90434164344e-30 , 9.4792368665e-29  ,
 3.58941553523e-27 , 1.06112328585e-25 , 2.45059047975e-24 , 4.42453907757e-23 ,
 6.25104455351e-22 , 6.91812805347e-21 , 6.00494117007e-20 , 4.09360700519e-19 ,
 2.19490629866e-18 , 9.27012512767e-18 , 3.08839404706e-17 , 8.12634571923e-17 ,
 1.6903621867e-16  , 2.78110143604e-16 , 3.61938272536e-16 , 3.72438705044e-16 ,
 3.07694973171e-16 , 4.50485524613e-16 , 9.91702855341e-15 , 2.94596659572e-13 ,
 6.92647516482e-12 , 1.27835449917e-10 , 1.85442150787e-09 , 2.11752865727e-08 ,
 1.90612331741e-07 , 1.35442425734e-06 , 7.60525189441e-06 , 3.37709970219e-05 ,
 0.000118623095348 , 0.000329538860981 , 0.000723564757663 , 0.00125441900302  ,
 0.00171497998947  , 0.00184657675796  , 0.00156468784858  , 0.00104594213937  ,
 0.000564748893735 , 0.000287935854127 , 0.000241289050475 , 0.000404429105434 ,
 0.000777237081002 , 0.00135435566043  , 0.0020594501693   , 0.00273210429885  ,
 0.00319293337955  , 0.00331067813209  , 0.00303044419919  , 0.00241016403941  ,
 0.00163847562798  , 0.000945834137785 , 0.000467013454038 , 0.000200806294401 ,
 7.65273601802e-05 , 2.59574053877e-05 , 7.7466230985e-06  , 2.00797142829e-06 ,
 4.58596285534e-07 , 1.02518746342e-07 , 2.93262931355e-08 , 1.23358456343e-08 ,
 5.86324257113e-09 , 2.49265686542e-09 , 8.73456939363e-10 , 2.47065733918e-10 ,
 5.64558655785e-11 , 1.06051124759e-11 , 1.70867760038e-12 , 2.53604810709e-13 ,
 1.47576680198e-15 , 1.86153279164e-16 , 2.22667788454e-17 , 2.33297850358e-18 ,
 2.01885996819e-19 , 1.39970435945e-20 , 7.66735297092e-22 , 3.29635763751e-23 ,
 1.11118133085e-24 , 2.92391389917e-26 , 5.83300521385e-28 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.75870714889e-29 ,
 8.7267048968e-28  , 3.30161300874e-26 , 9.74982348961e-25 , 3.40910426233e-16 ,
 1.78371099776e-14 , 6.84628542855e-13 , 2.05769981099e-11 , 4.85005684839e-10 ,
 8.97763948793e-09 , 1.30707531956e-07 , 1.49924074557e-06 , 1.35701821121e-05 ,
 9.70763042419e-05 , 0.000549585983028 , 0.00246493748141  , 0.00876445564615  ,
 0.0247141390447   , 0.0552728933905   , 0.0980506029879   , 0.138016808993    ,
 0.154383849797    , 0.137802150126    , 0.0991451826451   , 0.0587875598362   ,
 0.029956832688    , 0.0139092958857   , 0.00613963435497  , 0.00255279832916  ,
 0.00096838938563  , 0.000346796086654 , 0.000139678589074 , 7.24617818042e-05 ,
 4.10142664011e-05 , 2.06402623819e-05 , 8.51817784455e-06 , 2.84862773032e-06 ,
 7.94409839227e-07 , 2.03987879674e-07 , 6.0651535769e-08  , 2.60656055373e-08 ,
 1.48873451065e-08 , 9.31225284099e-09 , 5.95865525665e-09 , 4.22067865371e-09 ,
 3.61672474893e-09 , 3.34133548167e-09 , 2.77033298475e-09 , 1.87409951456e-09 ,
 1.00154720058e-09 , 4.18880436577e-10 , 1.36767004673e-10 , 3.48468115598e-11 ,
 6.92999476568e-12 , 1.07622427207e-12 , 1.30604360786e-13 , 1.23950820289e-14 ,
 9.20870503047e-16 , 5.36161828894e-17 , 2.44962001332e-18 , 8.79465973381e-20 ,
 2.4848543535e-21  , 5.53332113385e-23 , 3.52947391289e-25 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.17383032671e-18 , 6.10548904925e-17 , 2.33899227994e-15 , 7.01537249229e-14 ,
 1.64924693435e-12 , 3.04297595269e-11 , 4.41272287976e-10 , 5.03681462002e-09 ,
 4.53194535588e-08 , 3.21867169093e-07 , 1.80638220047e-06 , 8.01688665171e-06 ,
 2.81446133336e-05 , 7.814503632e-05   , 0.000171494315162 , 0.000297167594641 ,
 0.000406073210717 , 0.000436982964192 , 0.000369918885438 , 0.000246571625945 ,
 0.000131382382048 , 6.27039434121e-05 , 4.47895469937e-05 , 7.04854948492e-05 ,
 0.000137937596134 , 0.000246903863871 , 0.000386008144899 , 0.000528833428086 ,
 0.000642017630619 , 0.00069281526114  , 0.000656239676015 , 0.000533449025707 ,
 0.000364573483961 , 0.00020732339782  , 9.83626866128e-05 , 3.9514366342e-05  ,
 1.37365780847e-05 , 4.20707264642e-06 , 1.13885096937e-06 , 2.69730652584e-07 ,
 5.56624752891e-08 , 1.05339828302e-08 , 2.27671521544e-09 , 7.58743172666e-10 ,
 3.33264544052e-10 , 1.39268969745e-10 , 4.85623214564e-11 , 1.36668436929e-11 ,
 3.08911455121e-12 , 5.65777926877e-13 , 8.62624104232e-14 , 1.15750238468e-14 ,
 5.0056673194e-17  , 5.53163405307e-18 , 5.99432774455e-19 , 5.95270336278e-20 ,
 5.02647594331e-21 , 3.4478809929e-22  , 1.87932795164e-23 , 8.05505346752e-25 ,
 2.71283701402e-26 , 7.13280125823e-28 , 1.4194257176e-29  , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3.17253252186e-31 ,
 1.57421064168e-29 , 5.95578101303e-28 , 1.75877104512e-26 , 2.04362679075e-16 ,
 1.05331514795e-14 , 4.02682011763e-13 , 1.20447499687e-11 , 2.8224008274e-10  ,
 5.18776335741e-09 , 7.49047757323e-08 , 8.50927361592e-07 , 7.61813495177e-06 ,
 5.38388424309e-05 , 0.000300819185385 , 0.00133063392901  , 0.00466451552259  ,
 0.0129674488172   , 0.028600608501    , 0.0500573821955   , 0.0695486118198   ,
 0.0767907220051   , 0.0675874500056   , 0.0477894348646   , 0.0276334453058   ,
 0.0135433029292   , 0.00595063547073  , 0.00246930330847  , 0.000971547623576 ,
 0.000347680313134 , 0.000110892231233 , 3.45246498887e-05 , 1.30614250027e-05 ,
 6.22570590606e-06 , 2.96128172745e-06 , 1.19398574277e-06 , 3.88742547385e-07 ,
 1.02647683076e-07 , 2.32727347503e-08 , 5.44770052815e-09 , 1.81825598302e-09 ,
 9.15129209748e-10 , 5.44272809128e-10 , 3.3884928942e-10  , 2.35299466461e-10 ,
 1.98963348452e-10 , 1.82725036357e-10 , 1.51206704309e-10 , 1.02232592658e-10 ,
 5.46260655819e-11 , 2.28454328192e-11 , 7.45907953582e-12 , 1.90048926659e-12 ,
 3.77950434795e-13 , 5.86954725536e-14 , 7.12294293028e-15 , 6.76006983491e-16 ,
 5.02227323473e-17 , 2.92413665938e-18 , 1.33598165645e-19 , 4.79645986549e-21 ,
 1.35519787452e-22 , 3.01778051059e-24 , 1.92491585601e-26 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 2.20242952977e-19 , 1.14492200574e-17 , 4.38552952018e-16 , 1.31512717889e-14 ,
 3.09108073701e-13 , 5.70181159793e-12 , 8.2659240605e-11  , 9.4317325375e-10  ,
 8.48305203937e-09 , 6.02226258061e-08 , 3.37828060071e-07 , 1.4986066721e-06  ,
 5.25862033225e-06 , 1.45940961306e-05 , 3.20135824835e-05 , 5.54506535878e-05 ,
 7.57425489758e-05 , 8.14751030326e-05 , 6.89312927727e-05 , 4.58726384237e-05 ,
 2.4249805753e-05  , 1.10654343469e-05 , 6.85710032268e-06 , 9.94071869079e-06 ,
 1.96632356842e-05 , 3.6094423165e-05  , 5.81104176613e-05 , 8.25384253816e-05 ,
 0.000104514572623 , 0.000117611065108 , 0.00011527598509  , 9.58038750458e-05 ,
 6.60479032129e-05 , 3.73341699295e-05 , 1.72917483098e-05 , 6.62688785525e-06 ,
 2.14119446707e-06 , 5.966430547e-07   , 1.45795999266e-07 , 3.13198143103e-08 ,
 5.87549699164e-09 , 9.77246948519e-10 , 1.64628154653e-10 , 3.99900180325e-11 ,
 1.51412716271e-11 , 6.11193062744e-12 , 2.11498297699e-12 , 5.92869485474e-13 ,
 1.33123975554e-13 , 2.4015475923e-14  , 3.53626771248e-15 , 4.41552235618e-16 ,
 1.35207229103e-18 , 1.24193440959e-19 , 1.11370424999e-20 , 9.68172872907e-22 ,
 7.60211696415e-23 , 5.02960917881e-24 , 2.69015459626e-25 , 1.13875605922e-26 ,
 3.81548775506e-28 , 9.98699609827e-30 , 1.95932252375e-31 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 9.73246873914e-17 , 4.95636769404e-15 , 1.88871107088e-13 , 5.62714780175e-12 ,
 1.31221786892e-10 , 2.39780097275e-09 , 3.43780933314e-08 , 3.87306854801e-07 ,
 3.43425658324e-06 , 2.40073215021e-05 , 0.000132528761759 , 0.000578632254656 ,
 0.00200076598567  , 0.0054845067162   , 0.0119271071309   , 0.0205868388215   ,
 0.0282153684733   , 0.0307322467961   , 0.0266628827817   , 0.018534403654    ,
 0.0104684839999   , 0.00494946157869  , 0.00206272202016  , 0.000803716589707 ,
 0.000298965543568 , 0.000102307471437 , 3.07237414082e-05 , 8.22568553463e-06 ,
 2.29937958251e-06 , 8.28237784375e-07 , 3.4955872839e-07  , 1.35818820563e-07 ,
 4.33713960938e-08 , 1.11112308115e-08 , 2.33811283665e-09 , 4.53402294942e-10 ,
 1.11626734907e-10 , 4.57370707452e-11 , 2.51756679489e-11 , 1.51327155393e-11 ,
 1.02766340742e-11 , 8.57448246041e-12 , 7.83153470728e-12 , 6.46967730596e-12 ,
 4.37214070488e-12 , 2.33586284895e-12 , 9.76856572683e-13 , 3.18942322799e-13 ,
 8.12626661771e-14 , 1.61606988313e-14 , 2.50974611056e-15 , 3.045682463e-16   ,
 2.89052235389e-17 , 2.14746198368e-18 , 1.25032470461e-19 , 5.71249248778e-21 ,
 2.05090697297e-22 , 5.79465866193e-24 , 1.29036565835e-25 , 8.23070235589e-28 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 3.24737770639e-20 , 1.68733570023e-18 , 6.46241282192e-17 ,
 1.93765080423e-15 , 4.55343830329e-14 , 8.39746066561e-13 , 1.2170714206e-11  ,
 1.38831762192e-10 , 1.24826293465e-09 , 8.85841661268e-09 , 4.96733951851e-08 ,
 2.20262846745e-07 , 7.72591290316e-07 , 2.14330400978e-06 , 4.69978652385e-06 ,
 8.13765970441e-06 , 1.11120390429e-05 , 1.19493648924e-05 , 1.01057622154e-05 ,
 6.71863322394e-06 , 3.53406627905e-06 , 1.56337512119e-06 , 8.56970822887e-07 ,
 1.12623367051e-06 , 2.2362230734e-06  , 4.20785535354e-06 , 6.99431078529e-06 ,
 1.03394166802e-05 , 1.36888730311e-05 , 1.60546982803e-05 , 1.62435709926e-05 ,
 1.37754719033e-05 , 9.58635735149e-06 , 5.41273331983e-06 , 2.47386741021e-06 ,
 9.20407534496e-07 , 2.82504250028e-07 , 7.29770311424e-08 , 1.6217625611e-08  ,
 3.14783716037e-09 , 5.35103887007e-10 , 7.98149488832e-11 , 1.11035822012e-11 ,
 1.90902358591e-12 , 5.61496584132e-13 , 2.11231036315e-13 , 7.20687369951e-14 ,
 2.01128046625e-14 , 4.49340291841e-15 , 8.01621384472e-16 , 1.14908450487e-16 ,
 1.34871109477e-17 , 2.80461121771e-20 , 1.92555396032e-21 , 1.0398113223e-22  ,
 4.40970413906e-24 , 1.46662390994e-25 , 3.82033335296e-27 , 7.2899325932e-29  ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 3.67606096585e-17 , 1.85440132402e-15 ,
 7.0483078321e-14  , 2.09328542811e-12 , 4.86227170131e-11 , 8.84206711133e-10 ,
 1.26033523216e-08 , 1.41002599092e-07 , 1.24004583054e-06 , 8.58679566408e-06 ,
 4.689692709e-05   , 0.000202348429368 , 0.000690813278894 , 0.00186848408814  ,
 0.00400794040448  , 0.00682288713882  , 0.0092230612237   , 0.0099076063117   ,
 0.00847214702536  , 0.0057923536817   , 0.00320054335855  , 0.00146404666175  ,
 0.000580320774359 , 0.000212013385099 , 7.41646802652e-05 , 2.42604408705e-05 ,
 7.00819139699e-06 , 1.73818222786e-06 , 3.95790527984e-07 , 1.02744243423e-07 ,
 3.47156277199e-08 , 1.24752259959e-08 , 3.88649995263e-09 , 9.7749401819e-10  ,
 1.97636265168e-10 , 3.40424661678e-11 , 6.30536474265e-12 , 1.91328740685e-12 ,
 9.27203790573e-13 , 5.3132319328e-13  , 3.51532449683e-13 , 2.8922417212e-13  ,
 2.62776111614e-13 , 2.16751229479e-13 , 1.46418422602e-13 , 7.82169554153e-14 ,
 3.27092903104e-14 , 1.06794470838e-14 , 2.72098808627e-15 , 5.4112227986e-16  ,
 8.40359251403e-17 , 1.01981124127e-17 , 9.67857674129e-19 , 7.19052578543e-20 ,
 4.18656631976e-21 , 1.91276142614e-22 , 6.86722259135e-24 , 1.94027381041e-25 ,
 4.32063877928e-27 , 2.75595460476e-29 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3.75737437384e-21 ,
 1.9515582645e-19  , 7.47360984281e-18 , 2.24056169944e-16 , 5.26447404265e-15 ,
 9.70699426619e-14 , 1.40656655317e-12 , 1.60408111595e-11 , 1.4418605148e-10  ,
 1.02291851529e-09 , 5.73412863465e-09 , 2.5417811256e-08  , 8.9124906678e-08  ,
 2.47166134708e-07 , 5.41809639425e-07 , 9.37868444136e-07 , 1.2803286338e-06  ,
 1.37646793009e-06 , 1.16377705695e-06 , 7.73224244087e-07 , 4.05401745995e-07 ,
 1.75472625833e-07 , 8.67231506605e-08 , 1.02025404398e-07 , 2.02014923806e-07 ,
 3.89916563525e-07 , 6.71315457485e-07 , 1.03623030961e-06 , 1.43542386916e-06 ,
 1.75034573407e-06 , 1.82138106219e-06 , 1.57177157829e-06 , 1.10334141928e-06 ,
 6.23730413859e-07 , 2.83140717226e-07 , 1.03514102431e-07 , 3.07406892406e-08 ,
 7.52467828769e-09 , 1.54854684286e-09 , 2.73515722859e-10 , 4.20464847918e-11 ,
 5.65529874637e-12 , 6.81126846042e-13 , 8.65642174472e-14 , 1.77213367942e-14 ,
 5.78957742429e-15 , 1.91906844461e-15 , 5.31810025582e-16 , 1.18152403555e-16 ,
 2.08506422434e-17 , 2.91368140426e-18 , 3.21809691885e-19 , 5.74238520998e-22 ,
 3.94210342575e-23 , 2.12854113314e-24 , 9.02602161585e-26 , 3.00172999477e-27 ,
 7.81857953621e-29 , 1.49149898587e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.09918573415e-17 ,
 5.50386338982e-16 , 2.08767624023e-14 , 6.18458561072e-13 , 1.43204425297e-11 ,
 2.59408854508e-10 , 3.68005351131e-09 , 4.09355896569e-08 , 3.5755147111e-07  ,
 2.45610141259e-06 , 1.32907733135e-05 , 5.67533631935e-05 , 0.000191551775434 ,
 0.000511776741779 , 0.00108371398265  , 0.00182056342838  , 0.00242814014735  ,
 0.00257301255536  , 0.00216914106554  , 0.00145954084792  , 0.000790195732857 ,
 0.00035078681475  , 0.000132716370198 , 4.54574686519e-05 , 1.4860031128e-05  ,
 4.61672633103e-06 , 1.28828914662e-06 , 3.06686836469e-07 , 6.25964621649e-08 ,
 1.24433083507e-08 , 3.06402238337e-09 , 9.37681204681e-10 , 2.78023053238e-10 ,
 6.86853848561e-11 , 1.35903720748e-11 , 2.1953253584e-12  , 3.30950050845e-13 ,
 7.02008454293e-14 , 2.75391896339e-14 , 1.46987378696e-14 , 9.41865491555e-15 ,
 7.63044184174e-15 , 6.89613867786e-15 , 5.6803157871e-15  , 3.83576854027e-15 ,
 2.04888344919e-15 , 8.5679426233e-16  , 2.79737811252e-16 , 7.12735182516e-17 ,
 1.41741405205e-17 , 2.20123412254e-18 , 2.67128992843e-19 , 2.5352029087e-20  ,
 1.88348373014e-21 , 1.09662766996e-22 , 5.01028037235e-24 , 1.79879780572e-25 ,
 5.08234621235e-27 , 1.13174656159e-28 , 7.21893753954e-31 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 3.40720323633e-22 , 1.76910459819e-20 , 6.7743222315e-19  , 2.03070805499e-17 ,
 4.7707998154e-16  , 8.7954071881e-15  , 1.27425099374e-13 , 1.45289023439e-12 ,
 1.30566041339e-11 , 9.26058930797e-11 , 5.18976876262e-10 , 2.29983797647e-09 ,
 8.06187130461e-09 , 2.23514818526e-08 , 4.89836244702e-08 , 8.47699152193e-08 ,
 1.15698304893e-07 , 1.24361487008e-07 , 1.0512323024e-07  , 6.98145789316e-08 ,
 3.65234379176e-08 , 1.55648412704e-08 , 7.0590248556e-09  , 7.36880094729e-09 ,
 1.44576762105e-08 , 2.86675887214e-08 , 5.13019263927e-08 , 8.28814449162e-08 ,
 1.20007767568e-07 , 1.51594466819e-07 , 1.61581482652e-07 , 1.41471802979e-07 ,
 1.00056348586e-07 , 5.66816485263e-08 , 2.56490614025e-08 , 9.28424259431e-09 ,
 2.70236022312e-09 , 6.38622967123e-10 , 1.24349380739e-10 , 2.03336888347e-11 ,
 2.84681851746e-12 , 3.45976089116e-13 , 3.69777898404e-14 , 3.7480372154e-15  ,
 5.06706450653e-16 , 1.27424610673e-16 , 3.97691675078e-17 , 1.09132377286e-17 ,
 2.42072077101e-18 , 4.27055855081e-19 , 5.96696814279e-20 , 6.58970188077e-21 ,
 7.04229962282e-28 , 1.8290753706e-29  , 3.56180160729e-31 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 2.59677112883e-18 , 1.29277255703e-16 , 4.89580233897e-15 ,
 1.44746676201e-13 , 3.34329642648e-12 , 6.03756061164e-11 , 8.53251622823e-10 ,
 9.447274344e-09   , 8.20564813562e-08 , 5.59929867722e-07 , 3.00654256109e-06 ,
 1.2724770977e-05  , 4.25226293564e-05 , 0.000112376864954 , 0.000235200264429 ,
 0.000390309010419 , 0.000514024814197 , 0.000537661481744 , 0.000447152945549 ,
 0.000296385723346 , 0.000157503525904 , 6.8077524768e-05  , 2.46975857689e-05 ,
 7.94987216634e-06 , 2.41748882723e-06 , 7.07365804374e-07 , 1.90052248724e-07 ,
 4.39985079598e-08 , 8.5186077734e-09  , 1.44408157114e-09 , 2.58767944417e-10 ,
 6.02118804569e-11 , 1.59994862032e-11 , 3.82844895727e-12 , 7.45658153636e-13 ,
 1.16542504276e-13 , 1.55547272249e-14 , 2.36617824476e-15 , 6.71959985977e-16 ,
 3.17693423574e-16 , 1.93096585315e-16 , 1.51604163081e-16 , 1.35169610361e-16 ,
 1.10863858346e-16 , 7.47733692859e-17 , 3.99270046727e-17 , 1.66949655061e-17 ,
 5.45065590008e-18 , 1.38874522319e-18 , 2.76178716329e-19 , 4.28903363865e-20 ,
 5.20492133557e-21 , 4.93975998211e-22 , 3.66990642131e-23 , 2.13674312282e-24 ,
 9.76236732142e-26 , 3.50489865064e-27 , 9.90278525198e-29 , 2.20517113374e-30 ,
 1.40658635234e-32 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 2.41869316111e-23 , 1.25551180068e-21 ,
 4.80732312993e-20 , 1.44094819619e-18 , 3.38491443462e-17 , 6.2396376872e-16  ,
 9.03849156024e-15 , 1.0303902218e-13  , 9.25801476309e-13 , 6.56503169183e-12 ,
 3.67832856859e-11 , 1.62967257081e-10 , 5.71135104201e-10 , 1.58311161372e-09 ,
 3.46867383901e-09 , 6.00162551791e-09 , 8.18987366374e-09 , 8.80170767044e-09 ,
 7.43891469741e-09 , 4.93883102583e-09 , 2.57981613588e-09 , 1.08713252986e-09 ,
 4.59548853653e-10 , 4.23585381294e-10 , 8.18461993102e-10 , 1.67090650416e-09 ,
 3.11849951734e-09 , 5.27883979837e-09 , 7.97034283018e-09 , 1.03856990846e-08 ,
 1.12941258063e-08 , 1.00057029513e-08 , 7.12066938355e-09 , 4.04300570695e-09 ,
 1.82723910008e-09 , 6.57784853868e-10 , 1.89209483376e-10 , 4.37507235272e-11 ,
 8.21220827184e-12 , 1.26938796752e-12 , 1.64535291192e-13 , 1.82080193682e-14 ,
 1.74066191438e-15 , 1.44235594168e-16 , 1.03990699963e-17 , 6.69028843533e-19 ,
 4.10216235912e-20 , 2.5841007798e-21  , 1.66228847946e-22 , 1.00104232326e-23 ,
 5.09258609994e-25 , 2.11862802906e-26 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 4.51728366793e-31 , 2.23079357917e-29 , 8.42880471478e-28 , 2.48495218993e-26 ,
 5.71912538937e-25 , 1.02816906712e-23 , 1.44492111228e-22 , 1.58874523718e-21 ,
 1.36820047038e-20 , 9.23962607273e-20 , 4.89952589105e-19 , 2.0430536651e-18  ,
 6.70933432491e-18 , 1.73771075097e-17 , 3.5540671482e-17  , 5.74580228792e-17 ,
 7.34697976143e-17 , 7.43114945724e-17 , 5.9434821383e-17  , 3.75598184004e-17 ,
 1.87332223823e-17 , 7.36403802665e-18 , 2.27820640058e-18 , 5.53859023393e-19 ,
 1.05662691833e-19 , 1.57979917712e-20 , 1.84904583328e-21 , 1.69253074992e-22 ,
 1.21063546889e-23 , 6.7621446056e-25  , 4.83743535935e-19 , 2.39751059363e-17 ,
 9.06821935494e-16 , 2.67690085297e-14 , 6.1709411925e-13  , 1.11168084742e-11 ,
 1.56633338495e-10 , 1.72783410773e-09 , 1.49399623532e-08 , 1.01395773734e-07 ,
 5.40973800653e-07 , 2.27265911563e-06 , 7.5306741049e-06  , 1.97151777312e-05 ,
 4.08417073602e-05 , 6.70376461514e-05 , 8.72796075882e-05 , 9.02159530317e-05 ,
 7.41147592714e-05 , 4.84973278957e-05 , 2.54145259549e-05 , 1.08133635461e-05 ,
 3.8561852229e-06  , 1.22411597229e-06 , 3.72464642669e-07 , 1.11602540857e-07 ,
 3.12939265095e-08 , 7.62592267085e-09 , 1.54123129643e-09 , 2.56137230586e-10 ,
 3.67111549775e-11 , 5.27913199667e-12 , 9.15409628462e-13 , 1.80447370733e-13 ,
 3.2928736557e-14  , 4.97700613154e-15 , 6.13788602793e-16 , 6.74331581362e-17 ,
 8.68979373438e-18 , 1.61376267454e-18 , 3.36116727369e-19 , 6.11163458595e-20 ,
 8.94461127734e-21 , 1.03313145184e-21 , 9.36615815056e-23 , 6.65050940113e-24 ,
 3.69347317963e-25 , 1.60288284174e-26 , 5.43169269158e-28 , 1.43656867793e-29 ,
 2.90164708252e-31 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.34279481365e-24 ,
 6.96877461249e-23 , 2.66817822526e-21 , 7.99705936994e-20 , 1.87842465433e-18 ,
 3.46228286196e-17 , 5.01474245352e-16 , 5.71605139349e-15 , 5.13507144081e-14 ,
 3.64076848217e-13 , 2.03952613344e-12 , 9.03438502177e-12 , 3.16559944616e-11 ,
 8.77302528242e-11 , 1.92187961558e-10 , 3.32477589947e-10 , 4.53636929336e-10 ,
 4.87463952502e-10 , 4.11936634086e-10 , 2.73431746699e-10 , 1.42674577472e-10 ,
 5.96309859844e-11 , 2.3811644048e-11  , 1.9360362965e-11  , 3.66251987123e-11 ,
 7.71874194914e-11 , 1.50670708427e-10 , 2.67156105945e-10 , 4.19167776811e-10 ,
 5.60946334241e-10 , 6.2013079032e-10  , 5.54603695152e-10 , 3.96682498837e-10 ,
 2.25707518577e-10 , 1.01981668183e-10 , 3.66040189054e-11 , 1.04571460633e-11 ,
 2.38654495966e-12 , 4.37763095879e-13 , 6.51567534774e-14 , 7.97786940093e-15 ,
 8.17320893296e-16 , 7.11982775076e-17 , 5.31949884542e-18 , 3.39773468023e-19 ,
 1.83112618461e-20 , 8.18912995168e-22 , 2.98549354863e-23 , 8.62402787391e-25 ,
 2.07909952063e-26 , 2.59721860685e-28 , 7.10227835898e-31 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 2.74796035561e-29 , 1.35319491608e-27 , 5.10889815523e-26 ,
 1.50469846233e-24 , 3.45875216551e-23 , 6.20833754316e-22 , 8.70781095638e-21 ,
 9.55154408664e-20 , 8.20142659945e-19 , 5.51882298831e-18 , 2.91407888953e-17 ,
 1.2091087212e-16  , 3.94804847888e-16 , 1.01600172562e-15 , 2.06345752069e-15 ,
 3.31116468061e-15 , 4.20141771278e-15 , 4.21694849117e-15 , 3.34764006429e-15 ,
 2.10071430656e-15 , 1.04102441266e-15 , 4.0688527423e-16  , 1.25249850642e-16 ,
 3.03199741819e-17 , 5.76361180402e-18 , 8.59186315633e-19 , 1.00318441322e-19 ,
 9.16469396791e-21 , 6.54501991115e-22 , 3.65120742093e-23 , 7.09262884967e-20 ,
 3.50300650946e-18 , 1.32368059685e-16 , 3.90273001968e-15 , 8.98310139709e-14 ,
 1.61519938083e-12 , 2.27037668605e-11 , 2.49712432765e-10 , 2.15142642841e-09 ,
 1.4538125436e-08  , 7.71635328089e-08 , 3.2220127316e-07  , 1.06019840566e-06 ,
 2.75387511324e-06 , 5.65662265129e-06 , 9.20526644022e-06 , 1.18980735367e-05 ,
 1.2275192077e-05  , 1.02351394177e-05 , 7.12300691284e-06 , 4.44375460987e-06 ,
 2.75566041971e-06 , 1.77831347573e-06 , 1.11200992389e-06 , 6.090001939e-07   ,
 2.74894210111e-07 , 9.96655447006e-08 , 2.87432010581e-08 , 6.56866197788e-09 ,
 1.18725798858e-09 , 1.69523372695e-10 , 1.91192042691e-11 , 1.70892642824e-12 ,
 1.22931081897e-13 , 7.49473399599e-15 , 4.39613295481e-16 , 2.8833786986e-17  ,
 2.06136614647e-18 , 1.36255357342e-19 , 7.40924182183e-21 , 3.25243497244e-22 ,
 1.11260435886e-23 , 2.96593834229e-25 , 6.14359652635e-27 , 1.02282296796e-30 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5.82544362278e-26 ,
 3.02274146892e-24 , 1.15728439564e-22 , 3.46842149844e-21 , 8.14641557051e-20 ,
 1.50141553075e-18 , 2.1744352273e-17  , 2.47826186988e-16 , 2.2261004627e-15  ,
 1.57809524044e-14 , 8.83908249763e-14 , 3.91482015939e-13 , 1.37152577344e-12 ,
 3.80043814209e-12 , 8.32434455052e-12 , 1.4398941327e-11  , 1.96438455818e-11 ,
 2.11064910914e-11 , 1.78345012754e-11 , 1.18360969497e-11 , 6.17120424499e-12 ,
 2.56363081889e-12 , 9.77944473412e-13 , 7.03164494795e-13 , 1.29541658141e-12 ,
 2.82657212611e-12 , 5.78276847393e-12 , 1.07239970674e-11 , 1.74152431691e-11 ,
 2.38371705723e-11 , 2.67088759287e-11 , 2.4069710936e-11  , 1.72876784165e-11 ,
 9.85601625082e-12 , 4.45478026165e-12 , 1.59674692924e-12 , 4.5444521051e-13  ,
 1.02926539598e-13 , 1.86180837985e-14 , 2.70534166652e-15 , 3.18656221054e-16 ,
 3.08234136323e-17 , 2.48790652471e-18 , 1.70099450601e-19 , 9.92966495853e-21 ,
 4.9332256245e-22  , 2.05969390416e-23 , 7.06840319968e-25 , 1.89383010402e-26 ,
 4.39965935709e-28 , 4.43801735304e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.09503222597e-27 , 5.38878093371e-26 , 2.03412815968e-24 , 5.98963490625e-23 ,
 1.37639754473e-21 , 2.4696817e-20     , 3.46239344817e-19 , 3.79573022483e-18 ,
 3.25693788172e-17 , 2.18977865648e-16 , 1.1550911875e-15  , 4.78699775539e-15 ,
 1.56092682982e-14 , 4.01068491365e-14 , 8.13156511577e-14 , 1.3024455243e-13  ,
 1.64945883842e-13 , 1.65235088994e-13 , 1.30923775881e-13 , 8.20094254269e-14 ,
 4.05728071092e-14 , 1.58342229947e-14 , 4.86779569818e-15 , 1.17704929235e-15 ,
 2.23536181073e-16 , 3.32964271403e-17 , 3.88516891508e-18 , 3.54747155409e-19 ,
 2.53237673887e-20 , 1.41223544676e-21 , 8.23160058389e-21 , 4.02451805283e-19 ,
 1.51959984087e-17 , 4.47617425246e-16 , 1.02908248549e-14 , 1.847581005e-13   ,
 2.59219410081e-12 , 2.84451783673e-11 , 2.44381301057e-10 , 1.6457812398e-09  ,
 8.7006920205e-09  , 3.61753206317e-08 , 1.18608790028e-07 , 3.08227797451e-07 ,
 6.42634954581e-07 , 1.10989703185e-06 , 1.71221351935e-06 , 2.65597987338e-06 ,
 4.39501589067e-06 , 7.1525409832e-06  , 1.0195521377e-05  , 1.19172305684e-05 ,
 1.1132271996e-05  , 8.24264422434e-06 , 4.82774696864e-06 , 2.23644163077e-06 ,
 8.19583388085e-07 , 2.37599546024e-07 , 5.44677029561e-08 , 9.86556473141e-09 ,
 1.41025566919e-09 , 1.5888167121e-10  , 1.4086872634e-11  , 9.81523022356e-13 ,
 5.36792273444e-14 , 2.30292887409e-15 , 7.76078446202e-17 , 2.07000353691e-18 ,
 4.30670283643e-20 , 1.95650052824e-22 , 8.58154835761e-24 , 2.93252360773e-25 ,
 7.80677018007e-27 , 1.6143034359e-28  , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 1.97353425012e-27 , 1.0238989508e-25  , 3.91995237894e-24 ,
 1.1747722088e-22  , 2.75908718601e-21 , 5.08478184454e-20 , 7.36352204768e-19 ,
 8.39168188044e-18 , 7.53710319398e-17 , 5.34252471688e-16 , 2.99206382581e-15 ,
 1.32502430382e-14 , 4.64155966765e-14 , 1.28600525453e-13 , 2.8165071996e-13  ,
 4.87132281193e-13 , 6.64512109447e-13 , 7.13932220914e-13 , 6.03209702592e-13 ,
 4.00279246569e-13 , 2.08583665447e-13 , 8.62663472e-14    , 3.18224788373e-14 ,
 2.09877050993e-14 , 4.01048648287e-14 , 9.88508688592e-14 , 2.33364978617e-13 ,
 4.94915218878e-13 , 8.98827315061e-13 , 1.34905538158e-12 , 1.63840711518e-12 ,
 1.59242025663e-12 , 1.23176888057e-12 , 7.56055654314e-13 , 3.67547117015e-13 ,
 1.41302888817e-13 , 4.29009315828e-14 , 1.02732608084e-14 , 1.93830592963e-15 ,
 2.87962949486e-16 , 3.36879827897e-17 , 3.10678690249e-18 , 2.26450279213e-19 ,
 1.31063232674e-20 , 6.0669017013e-22  , 2.26822782209e-23 , 6.92707696198e-25 ,
 1.72632825122e-26 , 2.12435693914e-28 , 4.40371365356e-30 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 3.43430672619e-26 , 1.68886206114e-24 , 6.37377358106e-23 ,
 1.87633571378e-21 , 4.31039996017e-20 , 7.73113220197e-19 , 1.08333844285e-17 ,
 1.18690816401e-16 , 1.01766358253e-15 , 6.83592437536e-15 , 3.60193582154e-14 ,
 1.49079906431e-13 , 4.85383346138e-13 , 1.24502930738e-12 , 2.51950271358e-12 ,
 4.02732630188e-12 , 5.08949647558e-12 , 5.08743060069e-12 , 4.02247441505e-12 ,
 2.5145468861e-12  , 1.24170083669e-12 , 4.83776430582e-13 , 1.48502743682e-13 ,
 3.58625052098e-14 , 6.80336302822e-15 , 1.012470069e-15   , 1.18051930328e-16 ,
 1.0772610711e-17  , 7.6863473476e-19  , 4.28479992464e-20 , 2.60327974109e-21 ,
 3.63564663313e-20 , 1.3695920573e-18  , 4.03136790382e-17 , 9.25967921099e-16 ,
 1.66060004819e-14 , 2.32672788013e-13 , 2.54954926812e-12 , 2.18829420398e-11 ,
 1.47603203415e-10 , 7.89034678202e-10 , 3.42379476038e-09 , 1.28565136938e-08 ,
 4.73556582727e-08 , 1.90176940249e-07 , 7.87435930384e-07 , 2.93158459089e-06 ,
 9.00052578349e-06 , 2.2026660682e-05  , 4.25118802886e-05 , 6.45467885873e-05 ,
 7.71151754387e-05 , 7.25740934264e-05 , 5.38724744286e-05 , 3.15810143152e-05 ,
 1.46344147939e-05 , 5.36368654327e-06 , 1.55503169391e-06 , 3.56488566416e-07 ,
 6.45709367936e-08 , 9.23036534013e-09 , 1.03991273379e-09 , 9.21996769625e-11 ,
 6.42351249325e-12 , 3.51168181039e-13 , 1.50453204916e-14 , 5.04596969936e-16 ,
 1.32353729309e-17 , 2.59222873898e-19 , 4.00427321679e-24 , 1.75652569979e-25 ,
 6.00296095043e-27 , 1.59817013949e-28 , 3.30546222018e-30 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.54995576851e-30 , 7.48841840471e-29 , 2.81217326068e-27 , 8.22649898851e-26 ,
 1.8747167343e-24  , 3.3284185644e-23  , 4.60431828424e-22 , 4.96333093493e-21 ,

 4.16996139842e-20 , 2.73105871557e-19 , 1.3947073408e-18  , 5.55558958892e-18 ,
 1.72683102043e-17 , 4.19046963264e-17 , 7.94401561186e-17 , 1.17736734042e-16 ,
 1.36544326286e-16 , 1.24048044941e-16 , 8.83893105578e-17 , 4.94821213491e-17 ,
 2.19927748598e-17 , 9.54010231592e-18 , 1.61825415197e-17 , 7.95071166817e-17 ,
 3.50162680232e-16 , 1.22624653615e-15 , 3.39713393894e-15 , 7.43947542775e-15 ,
 1.28659839982e-14 , 1.75495992735e-14 , 1.88535447215e-14 , 1.5928667277e-14  ,
 1.05708295957e-14 , 5.53481670017e-15 , 2.60982679405e-15 , 3.82984570016e-15 ,
 2.14087181642e-14 , 1.1520553702e-13  , 4.95043008182e-13 , 1.68400343193e-12 ,
 4.53303390776e-12 , 9.65482928652e-12 , 1.62652416785e-11 , 2.16584451709e-11 ,
 2.2771206163e-11  , 1.88784702004e-11 , 1.23235768478e-11 , 6.32480486123e-12 ,
 2.54841988068e-12 , 8.05063028929e-13 , 1.99163125068e-13 , 3.8544521493e-14  ,
 5.83061295962e-15 , 6.88890846877e-16 , 6.35352305863e-17 , 4.57192174323e-18 ,
 2.56587686446e-19 , 1.12277387513e-20 , 3.82967903336e-22 , 1.01803416535e-23 ,
 2.09429692426e-25 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 8.5054115625e-25  , 4.17932579985e-23 , 1.57693354064e-21 , 4.64094586396e-20 ,
 1.06576369109e-18 , 1.91070884805e-17 , 2.67593469638e-16 , 2.92974827108e-15 ,
 2.50986445017e-14 , 1.68420887849e-13 , 8.86332467916e-13 , 3.66304864416e-12 ,
 1.1906050057e-11  , 3.04803074286e-11 , 6.1548580059e-11  , 9.81538150741e-11 ,
 1.23737456951e-10 , 1.23378837124e-10 , 9.73115652224e-11 , 6.06882869187e-11 ,
 2.990251078e-11   , 1.1627102003e-11  , 3.56285767568e-12 , 8.59104004974e-13 ,
 1.62768491001e-13 , 2.41970909087e-14 , 2.81884261324e-15 , 2.57043624512e-16 ,
 1.83296582086e-17 , 1.02132401864e-18 , 4.44893358815e-20 , 4.07420654066e-21 ,
 9.68029056897e-20 , 2.84659691119e-18 , 6.53369954227e-17 , 1.17443958342e-15 ,
 1.65668505057e-14 , 1.86146291271e-13 , 1.73728393343e-12 , 1.4933681012e-11  ,
 1.36920404759e-10 , 1.37382232118e-09 , 1.31840911166e-08 , 1.07110786525e-07 ,
 6.97880948562e-07 , 3.58168682087e-06 , 1.44064780518e-05 , 4.53744325508e-05 ,
 0.000111961772039 , 0.000216664073112 , 0.000329251301561 , 0.000393474372432 ,
 0.000370338879883 , 0.000274914972288 , 0.000161161843332 , 7.46815190267e-05 ,
 2.73717000808e-05 , 7.93556543719e-06 , 1.81921640369e-06 , 3.29515557708e-07 ,
 4.71039995518e-08 , 5.30683795065e-09 , 4.7050942612e-10  , 3.27801841454e-11 ,
 1.79206385065e-12 , 7.67782012489e-14 , 2.57498429061e-15 , 6.75371888382e-17 ,
 1.32249275101e-18 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7.87730387705e-29 ,
 3.80582133575e-27 , 1.42922422558e-25 , 4.18093430106e-24 , 9.52782892229e-23 ,
 1.6915943664e-21  , 2.34004189078e-20 , 2.52250204885e-19 , 2.11928970867e-18 ,
 1.38799957042e-17 , 7.08828843139e-17 , 2.82350427653e-16 , 8.7762328246e-16  ,
 2.12971256048e-15 , 4.03736843645e-15 , 5.98370643584e-15 , 6.93956013614e-15 ,
 6.30446101041e-15 , 4.4921209318e-15  , 2.51382946796e-15 , 1.10646588949e-15 ,
 3.83659305889e-16 , 1.05201161776e-16 , 2.42541045696e-17 , 1.09149636803e-17 ,
 2.5190712395e-17  , 6.83722033196e-17 , 1.49564193604e-16 , 2.58574519686e-16 ,
 3.52612455226e-16 , 3.78834091008e-16 , 3.22591777292e-16 , 2.61272667188e-16 ,
 8.10398141956e-16 , 7.88143321753e-15 , 6.89672954969e-14 , 4.77591363717e-13 ,
 2.60770091674e-12 , 1.12394975566e-11 , 3.82818695589e-11 , 1.03112507901e-10 ,
 2.1969662481e-10  , 3.70206018308e-10 , 4.93047196868e-10 , 5.18454355565e-10 ,
 4.29876940028e-10 , 2.80645860396e-10 , 1.44047698945e-10 , 5.80445177178e-11 ,
 1.83377325235e-11 , 4.53675663738e-12 , 8.78043461141e-13 , 1.32825373095e-13 ,
 1.56937954904e-14 , 1.44744046034e-15 , 1.04157757613e-16 , 5.84566536526e-18 ,
 2.55796506212e-19 , 8.7250506595e-21  , 2.31937246174e-22 , 4.77150642544e-24 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.66579261675e-23 ,
 8.17818974624e-22 , 3.08503800837e-20 , 9.0765737121e-19  , 2.08357857043e-17 ,
 3.73365276641e-16 , 5.22579727258e-15 , 5.71716939746e-14 , 4.89326329827e-13 ,
 3.27984250485e-12 , 1.72369893375e-11 , 7.11220170225e-11 , 2.30732390177e-10 ,
 5.8941711648e-10  , 1.1873410738e-09  , 1.88854834882e-09 , 2.37422620333e-09 ,
 2.36065395001e-09 , 1.85667275586e-09 , 1.15478270039e-09 , 5.6755018204e-10  ,
 2.20175751825e-10 , 6.73306429236e-11 , 1.62068927834e-11 , 3.06619067161e-12 ,
 4.5535074585e-13  , 5.30351842215e-14 , 4.84651486033e-15 , 3.49075049861e-16 ,
 2.01845573308e-17 , 9.95008348789e-19 , 4.83702280731e-20 , 8.02904914945e-21 ,
 1.57544745278e-19 , 3.61037189034e-18 , 7.98267376211e-17 , 1.64075635271e-15 ,
 3.75855912498e-14 , 8.96317724622e-13 , 1.91055998882e-11 , 3.33008809494e-10 ,
 4.59318136704e-09 , 4.96323788882e-08 , 4.19020384278e-07 , 2.76274189474e-06 ,
 1.42307501777e-05 , 5.73040795826e-05 , 0.000180547213121 , 0.00044555078232  ,
 0.000862242885179 , 0.00131031328488  , 0.00156590605078  , 0.00147383575644  ,
 0.00109407815942  , 0.000641375314644 , 0.000297209835733 , 0.000108931081272 ,
 3.1581148652e-05  , 7.23993070182e-06 , 1.31137219421e-06 , 1.87459662762e-07 ,
 2.11196090135e-08 , 1.87248512521e-09 , 1.30455212681e-10 , 7.13187179978e-12 ,
 3.05554005992e-13 , 1.02476582264e-14 , 2.68777573326e-16 , 5.26312093893e-18 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.99954877451e-27 , 1.44919466125e-25 ,
 5.44225263016e-24 , 1.59203155735e-22 , 3.62804177847e-21 , 6.44131531284e-20 ,
 8.91049767199e-19 , 9.60527618006e-18 , 8.06990938487e-17 , 5.28527587035e-16 ,
 2.69910456796e-15 , 1.07514435455e-14 , 3.34184624901e-14 , 8.10959790376e-14 ,
 1.53736401881e-13 , 2.27849776862e-13 , 2.64247126005e-13 , 2.40063587599e-13 ,
 1.71052633807e-13 , 9.57225091349e-14 , 4.21322453665e-14 , 1.46075924213e-14 ,
 3.99506269454e-15 , 8.62952383756e-16 , 1.47358042488e-16 , 1.99028012853e-17 ,
 2.12634994333e-18 , 1.79656755928e-19 , 1.38111956828e-20 , 6.99820972945e-20 ,
 2.06063692367e-18 , 4.78894597624e-17 , 8.71397246749e-16 , 1.24287329997e-14 ,
 1.39135917446e-13 , 1.22425664546e-12 , 8.47955066871e-12 , 4.62996104643e-11 ,
 1.99556840732e-10 , 6.79693195947e-10 , 1.83075906028e-09 , 3.90070660804e-09 ,
 6.5729969844e-09  , 8.75403959148e-09 , 9.20514405396e-09 , 7.63245504461e-09 ,
 4.98286114904e-09 , 2.55756395701e-09 , 1.03057929411e-09 , 3.25586104974e-10 ,
 8.05500344585e-11 , 1.55896467853e-11 , 2.3583123166e-12  , 2.78643087295e-13 ,
 2.56992826227e-14 , 1.84931937535e-15 , 1.03789699294e-16 , 4.54166310133e-18 ,
 1.54913143637e-19 , 4.11804235028e-21 , 8.47180271128e-23 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 7.31698551658e-30 , 3.65327705311e-28 , 1.38535851987e-26 ,
 2.58712989182e-22 , 1.2679240592e-20  , 4.77988295215e-19 , 1.4055875719e-17  ,
 3.2250025318e-16  , 5.77580357034e-15 , 8.07871853146e-14 , 8.83117413902e-13 ,
 7.55098664206e-12 , 5.05511282944e-11 , 2.65278918475e-10 , 1.09266613026e-09 ,
 3.53756799682e-09 , 9.01573524605e-09 , 1.81139390307e-08 , 2.87289125951e-08 ,
 3.60072358748e-08 , 3.56891648041e-08 , 2.79818960535e-08 , 1.73509229665e-08 ,
 8.50328030816e-09 , 3.29017759776e-09 , 1.00382406629e-09 , 2.41147561066e-10 ,
 4.55506754604e-11 , 6.75832055793e-12 , 7.87683196131e-13 , 7.23947612559e-14 ,
 5.33413340546e-15 , 3.3287576805e-16  , 2.01341598769e-17 , 1.38187350493e-18 ,
 1.04474759817e-19 , 1.41051957366e-20 , 1.56480650036e-19 , 4.99409737311e-17 ,
 2.32709473589e-15 , 8.64595465638e-14 , 2.52444144551e-12 , 5.75885454684e-11 ,
 1.02482475523e-09 , 1.42230846124e-08 , 1.53972261309e-07 , 1.30061913048e-06 ,
 8.57682685987e-06 , 4.41810208579e-05 , 0.000177909900059 , 0.000560541040229 ,
 0.00138329395679  , 0.00267699211831  , 0.00406810995476  , 0.00486164520951  ,
 0.00457579601006  , 0.00339676824978  , 0.00199126843912  , 0.000922742975174 ,
 0.00033819671477  , 9.80495245147e-05 , 2.24777056299e-05 , 4.07139783062e-06 ,
 5.82003238803e-07 , 6.55697373348e-08 , 5.81347683785e-09 , 4.0502236685e-10  ,
 2.21422167582e-11 , 9.48648997344e-13 , 3.18157527343e-14 , 8.34469751485e-16 ,
 1.63403336358e-17 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 4.35980494973e-31 , 2.16786450994e-29 , 8.20646552533e-28 , 2.4251537164e-26  ,
 5.59815866795e-25 , 1.01017167999e-23 , 1.42618196778e-22 , 1.57702711625e-21 ,
 1.36745034669e-20 , 9.31060431302e-20 , 4.98504484945e-19 , 2.10200165047e-18 ,
 6.99027654894e-18 , 1.83571329286e-17 , 3.81058479e-17    , 6.25620881983e-17 ,
 8.12493540342e-17 , 8.34385717411e-17 , 6.77036564563e-17 , 4.33575667942e-17 ,
 2.1884491595e-17  , 8.69787227063e-18 , 2.82163020002e-18 , 2.58229415777e-18 ,
 2.6654055243e-17  , 2.85967088047e-16 , 2.40240451595e-15 , 1.57342025383e-14 ,
 8.03520164986e-14 , 3.20069173773e-13 , 9.94863585776e-13 , 2.41421748595e-12 ,
 4.57671408685e-12 , 6.78306029473e-12 , 7.86660497581e-12 , 7.14666396287e-12 ,
 5.09221621658e-12 , 2.84964751761e-12 , 1.25427184792e-12 , 4.34866259335e-13 ,
 1.18932533143e-13 , 2.56899880751e-14 , 4.3868310993e-15  , 5.92503986668e-16 ,
 6.33011805932e-17 , 5.34778462192e-18 , 3.8208954558e-19  , 9.78198162694e-19 ,
 2.85074554219e-17 , 6.62507140859e-16 , 1.20549884985e-14 , 1.71940218904e-13 ,
 1.92481889374e-12 , 1.69364774044e-11 , 1.17306872569e-10 , 6.4051300793e-10  ,
 2.76068742326e-09 , 9.40293728261e-09 , 2.53268867866e-08 , 5.396272879e-08   ,
 9.09314360828e-08 , 1.21104177207e-07 , 1.27344797231e-07 , 1.05588074921e-07 ,
 6.89333528006e-08 , 3.53815716083e-08 , 1.42571273703e-08 , 4.50418768854e-09 ,
 1.11433647805e-09 , 2.15668586731e-10 , 3.26251063539e-11 , 3.85477372687e-12 ,
 3.5552620528e-13  , 2.55836518677e-14 , 1.43583610792e-15 , 6.28297790168e-17 ,
 2.14308247097e-18 , 5.69693711483e-20 , 1.17199686623e-21 , 0, 0, 0, 0
};
  // type   : prepro
  // tiling : [180, 180]
  // range  : [[-180.0, 178.0], [-180.0, 178.0]]
  ftype32 rama2_prepro_data[] = {
 0, 0, 0, 0, 0, 0, 0, 0, 1.55632350332e-29 , 8.4470519904e-28  ,
 3.27390813122e-26 , 1.00005231632e-24 , 2.64415181401e-23 , 5.78400156988e-22 ,
 1.15864323768e-20 , 2.23865104585e-19 , 5.63042226385e-18 , 1.41872721846e-16 ,
 3.78883854912e-15 , 9.55335551363e-14 , 2.08268761129e-12 , 3.73452598517e-11 ,
 5.40921260416e-10 , 6.32113196114e-09 , 6.00127002303e-08 , 4.67582339092e-07 ,
 3.01686563712e-06 , 1.61888786897e-05 , 7.21037072762e-05 , 0.000264632339021 ,
 0.000792810937054 , 0.00192165234654  , 0.00374302311726  , 0.00583640418263  ,
 0.00729187796099  , 0.00740836097699  , 0.0065707887441   , 0.00656786697455  ,
 0.0105522542379   , 0.0230321361729   , 0.0482641528086   , 0.0848753815616   ,
 0.120517737232    , 0.136395692158    , 0.122641265833    , 0.0884849906084   ,
 0.0544972971846   , 0.0364292111011   , 0.0369887466423   , 0.0479798694221   ,
 0.0569680676432   , 0.0551119093088   , 0.042413395169    , 0.0258526705161   ,
 0.012467413031    , 0.00475279740018  , 0.00143072088635  , 0.00033964118302  ,
 6.34907998444e-05 , 9.33201095297e-06 , 1.07692349968e-06 , 9.7445413187e-08  ,
 6.9056101375e-09  , 3.84072722676e-10 , 3.29905403938e-11 , 1.78970787054e-10 ,
 1.51757216503e-09 , 1.00947122061e-08 , 5.25627932208e-08 , 2.14479718457e-07 ,
 6.86707359397e-07 , 1.72760598636e-06 , 3.42017621043e-06 , 5.33612001373e-06 ,
 6.570111852e-06   , 6.39130171646e-06 , 4.91616886029e-06 , 2.99122855808e-06 ,
 1.43951288841e-06 , 5.47622078737e-07 , 1.64523861898e-07 , 3.89865077566e-08 ,
 7.27639074261e-09 , 1.06803682451e-09 , 1.23109568294e-10 , 1.11286717562e-11 ,
 7.87975251685e-13 , 4.36556152985e-14 , 1.89075679705e-15 , 6.3969631418e-17  ,
 1.68961322554e-18 , 3.39619746684e-20 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7.90248515377e-17 ,
 3.8477682503e-15  , 1.44814224676e-13 , 4.24814456001e-12 , 9.71564491724e-11 ,
 1.73281649543e-09 , 2.41100522528e-08 , 2.61820121222e-07 , 2.22028147229e-06 ,
 1.47132354971e-05 , 7.62535522961e-05 , 0.000309376799431 , 0.000983750385638 ,
 0.00245477384723  , 0.00481372610726  , 0.00742915665931  , 0.00903705529682  ,
 0.0086763205146   , 0.00658200902674  , 0.00394862347469  , 0.0018740586802   ,
 0.000703755058281 , 0.000209128614197 , 4.92268728122e-05 , 9.21788753609e-06 ,
 1.39133848124e-06 , 1.7517127927e-07  , 1.97214686503e-08 , 2.16618125406e-09 ,
 2.3807633096e-10  , 2.44812818492e-11 , 2.17914504722e-12 , 1.65599775362e-13 ,
 1.213154903e-14   , 1.13927207154e-15 , 1.43928026553e-16 , 1.83060763271e-17 ,
 1.96216444528e-18 , 1.68338203068e-19 , 1.14373318891e-20 , 6.12088680565e-22 ,
 2.57615456015e-23 , 8.51351389364e-25 , 2.20617905235e-26 , 4.12137961029e-28 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.63121554484e-31 ,
 1.08181223301e-29 , 4.37478512408e-28 , 1.39682057597e-26 , 3.53119551619e-25 ,
 7.06902493558e-24 , 1.12380866977e-22 , 1.42671147855e-21 , 1.46849090793e-20 ,
 1.26940912436e-19 , 1.01233507581e-18 , 8.98408523691e-18 , 1.09802818813e-16 ,
 1.70021568194e-15 , 2.96883670083e-14 , 5.48281711924e-13 , 9.97422868017e-12 ,
 1.63025761238e-10 , 2.2424601745e-09  , 2.52013024915e-08 , 2.29800445613e-07 ,
 1.70788536646e-06 , 1.04385758469e-05 , 5.29110774004e-05 , 0.00022329767609  ,
 0.000782878526166 , 0.00226394349466  , 0.00535058041884  , 0.0102478934554   ,
 0.0158162850031   , 0.0196638881703   , 0.0199539299548   , 0.0174576032159   ,
 0.0155147676819   , 0.0180658096067   , 0.0280058563668   , 0.0462037198853   ,
 0.0694593504559   , 0.0888404329791   , 0.0935412011938   , 0.0798321084085   ,
 0.055439134458    , 0.0334647243449   , 0.0228468024609   , 0.024310649293    ,
 0.0320770708403   , 0.0379686774084   , 0.0364012127017   , 0.0277125725606   ,
 0.0167007991225   , 0.00796296422397  , 0.00300264167532  , 0.000894727840209 ,
 0.000210454276011 , 3.90229159016e-05 , 5.69558390348e-06 , 6.53381324049e-07 ,
 5.88283551897e-08 , 4.15177104643e-09 , 2.29534135317e-10 , 1.16912127414e-11 ,
 1.96771657105e-11 , 1.64583832663e-10 , 1.0951368411e-09  , 5.70484412076e-09 ,
 2.3290738354e-08  , 7.46184052877e-08 , 1.8786474519e-07  , 3.72242371842e-07 ,
 5.81337371237e-07 , 7.16545319699e-07 , 6.97849285426e-07 , 5.37428108857e-07 ,
 3.27392453322e-07 , 1.57742300416e-07 , 6.00759233072e-08 , 1.80674527527e-08 ,
 4.28533455235e-09 , 8.00458575689e-10 , 1.17574033094e-10 , 1.35603760382e-11 ,
 1.22640709806e-12 , 8.68714633807e-14 , 4.81443335691e-15 , 2.08570913244e-16 ,
 7.05800885106e-18 , 1.8645214444e-19  , 3.75004102902e-21 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 2.52604492519e-17 , 1.22994789069e-15 , 4.62902096228e-14 , 1.35792993548e-12 ,
 3.10563135181e-11 , 5.53899644842e-10 , 7.70685121423e-09 , 8.36916699405e-08 ,
 7.09721136643e-07 , 4.70314645053e-06 , 2.4374805143e-05  , 9.88939535278e-05 ,
 0.000314461893768 , 0.000784686001224 , 0.00153874715148  , 0.00237479921169  ,
 0.00288878630546  , 0.00277347047399  , 0.0021039762044   , 0.00126213978615  ,
 0.000598936930653 , 0.00022481874053  , 6.67251643492e-05 , 1.56520036049e-05 ,
 2.90273326158e-06 , 4.26835381223e-07 , 5.02698010185e-08 , 4.87366668983e-09 ,
 4.12948702548e-10 , 3.33767083435e-11 , 2.70140067779e-12 , 2.08933369116e-13 ,
 1.42907548694e-14 , 8.5518681225e-16  , 5.20920543241e-17 , 4.35179549778e-18 ,
 4.67673739789e-19 , 4.79800031108e-20 , 4.06166046769e-21 , 2.75080665341e-22 ,
 1.46822471713e-23 , 6.16591563505e-25 , 2.03390676623e-26 , 5.26254139383e-28 ,
 9.77017264535e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 8.02997712071e-30 , 5.3254320114e-28  , 2.15357342355e-26 , 6.87612210555e-25 ,
 1.73720300092e-23 , 3.47390058146e-22 , 5.50903708846e-21 , 6.95255422002e-20 ,
 7.04348351188e-19 , 5.84767098073e-18 , 4.19512734478e-17 , 2.93514063322e-16 ,
 2.43284804886e-15 , 2.59564208711e-14 , 3.18088516487e-13 , 4.02852878027e-12 ,
 5.19103037926e-11 , 6.68771764622e-10 , 8.04978639758e-09 , 8.41057376401e-08 ,
 7.30624019384e-07 , 5.19767578645e-06 , 3.02971602808e-05 , 0.000145722621365 ,
 0.000582524880257 , 0.00194129592307  , 0.00537855199424  , 0.0122995480193   ,
 0.0230131120186   , 0.0349878935834   , 0.0431772196764   , 0.0438729844693   ,
 0.0388309861633   , 0.0345424355075   , 0.0369743036902   , 0.0474438952098   ,
 0.0626485646614   , 0.076502644978    , 0.0820487481378   , 0.0748692728422   ,
 0.0569000471029   , 0.0358816366314   , 0.0199208888542   , 0.0127602003042   ,
 0.0132885448028   , 0.0174557712646   , 0.020522958505    , 0.019497277326    ,
 0.0146916533038   , 0.00875840398504  , 0.00413044672999  , 0.0015408492879   ,
 0.000454485926282 , 0.000105902728552 , 1.94718872911e-05 , 2.82110442704e-06 ,
 3.21585033709e-07 , 2.88002814909e-08 , 2.02356396039e-09 , 1.11416805329e-10 ,
 4.95266968925e-12 , 1.81848194438e-12 , 1.41044479685e-11 , 9.38587253615e-11 ,
 4.89133417975e-10 , 1.99793840751e-09 , 6.40474923563e-09 , 1.61362993864e-08 ,
 3.199875894e-08   , 5.00182526459e-08 , 6.17128605772e-08 , 6.01665331108e-08 ,
 4.63865681155e-08 , 2.82892738234e-08 , 1.36449066647e-08 , 5.20195729653e-09 ,
 1.56592646998e-09 , 3.71727416123e-10 , 6.94861554069e-11 , 1.02127939522e-11 ,
 1.17851533473e-12 , 1.06632385948e-13 , 7.55593078867e-15 , 4.18873364697e-16 ,
 1.81506917281e-17 , 6.14331781158e-19 , 1.62312803805e-20 , 3.26631558516e-22 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 6.3090294163e-18  , 3.07191032453e-16 , 1.15614169573e-14 ,
 3.39155918605e-13 , 7.75661247963e-12 , 1.38341816865e-10 , 1.92486205508e-09 ,
 2.09028345612e-08 , 1.77260137543e-07 , 1.17466041851e-06 , 6.08787310628e-06 ,
 2.46998844309e-05 , 7.85405803666e-05 , 0.000195985099297 , 0.000384322354951 ,
 0.000593139232155 , 0.000721516970303 , 0.000692716785699 , 0.000525499935522 ,
 0.00031523526965  , 0.000149586286556 , 5.61425118423e-05 , 1.66571025287e-05 ,
 3.90350300188e-06 , 7.21935535857e-07 , 1.05352787763e-07 , 1.21542547066e-08 ,
 1.11705631897e-09 , 8.35918353908e-11 , 5.35694214084e-12 , 3.19660741223e-13 ,
 1.89889942963e-14 , 1.09749506767e-15 , 5.7150008198e-17  , 2.59397750852e-18 ,
 1.25386528197e-19 , 8.20584267633e-21 , 6.87367474026e-22 , 5.4102535326e-23  ,
 3.59907275696e-24 , 1.89133148661e-25 , 7.8383273812e-27  , 2.55645013648e-28 ,
 6.55187248374e-30 , 1.16919910151e-31 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 3.03138152992e-28 , 2.01039380256e-26 , 8.12992653287e-25 ,
 2.59579857676e-23 , 6.55558884926e-22 , 1.31006554553e-20 , 2.07442236012e-19 ,
 2.60850413637e-18 , 2.61853434269e-17 , 2.1255816771e-16  , 1.44065243203e-15 ,
 8.78170891758e-15 , 5.55246453439e-14 , 4.24275752143e-13 , 3.90592588483e-12 ,
 3.79196370953e-11 , 3.56492199672e-10 , 3.24939820858e-09 , 2.93270289699e-08 ,
 2.54787212941e-07 , 1.99360166658e-06 , 1.33037146405e-05 , 7.37856441472e-05 ,
 0.00033824679898  , 0.00128642316699  , 0.00407943078063  , 0.0108013537895   ,
 0.0237893728258   , 0.0432690146046   , 0.0645407073563   , 0.0788618053278   ,
 0.0802329559649   , 0.0722250683751   , 0.0659544435451   , 0.0701136992125   ,
 0.0838583557879   , 0.0988361429372   , 0.105701653162    , 0.098925078513    ,
 0.0791523961428   , 0.0530966042957   , 0.0295800615084   , 0.0141683293977   ,
 0.00729318461622  , 0.00626910174555  , 0.00775399238361  , 0.00897876781761  ,
 0.00845205974787  , 0.00631089088892  , 0.00372622507537  , 0.00173997690906  ,
 0.000642713242587 , 0.000187770498823 , 4.33627920197e-05 , 7.9078907894e-06  ,
 1.13738231639e-06 , 1.28833991617e-07 , 1.14758465791e-08 , 8.02671836491e-10 ,
 4.40262169835e-11 , 1.90157297399e-12 , 1.75549533032e-13 , 9.5495248556e-13  ,
 6.34752243643e-12 , 3.30914506118e-11 , 1.35227566684e-10 , 4.33728250194e-10 ,
 1.09343361729e-09 , 2.16988007612e-09 , 3.39456823625e-09 , 4.19198122864e-09 ,
 4.09083560045e-09 , 3.15701893238e-09 , 1.92724181836e-09 , 9.304710577e-10   ,
 3.55053358295e-10 , 1.06969568456e-10 , 2.54118975622e-11 , 4.75327974823e-12 ,
 6.99006818942e-13 , 8.07003272798e-14 , 7.30461787942e-15 , 5.17766633499e-16 ,
 2.87104753219e-17 , 1.24434395063e-18 , 4.21232411254e-20 , 1.11308512688e-21 ,
 2.24099930128e-23 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.23038863902e-18 , 5.99085162689e-17 ,
 2.25471248647e-15 , 6.61423472016e-14 , 1.51269865208e-12 , 2.69795037016e-11 ,
 3.75387917738e-10 , 4.0764874672e-09  , 3.45694382956e-08 , 2.2908358248e-07  ,
 1.18726511079e-06 , 4.81701088379e-06 , 1.53171346383e-05 , 3.82214653272e-05 ,
 7.49516033515e-05 , 0.000115675948703 , 0.000140712995018 , 0.000135096653529 ,
 0.000102485506705 , 6.14786540936e-05 , 2.91727699e-05    , 1.09487422663e-05 ,
 3.2481088045e-06  , 7.60967809344e-07 , 1.40628343051e-07 , 2.04775752364e-08 ,
 2.34833100823e-09 , 2.12345764407e-10 , 1.52285912297e-11 , 8.81271648044e-13 ,
 4.29131285736e-14 , 1.89888420359e-15 , 8.26120811146e-17 , 3.51578532825e-18 ,
 1.27259065914e-19 , 4.37772561619e-21 , 1.1785707476e-22  , 2.47906087477e-24 ,
 3.21140090815e-27 , 6.15830829507e-29 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 8.92712096347e-27 , 5.92041595594e-25 ,
 2.39418859697e-23 , 7.64439633589e-22 , 1.93008671718e-20 , 3.85544554366e-19 ,
 6.09897718567e-18 , 7.65128361536e-17 , 7.63670884775e-16 , 6.11389807342e-15 ,
 4.0070788109e-14  , 2.25444517344e-13 , 1.19928495984e-12 , 6.95358298317e-12 ,
 4.80630201342e-11 , 3.72829706746e-10 , 2.86979878463e-09 , 2.04367069089e-08 ,
 1.34857854656e-07 , 8.55654535409e-07 , 5.27967337883e-06 , 3.0409869859e-05  ,
 0.000154506651245 , 0.000667489206922 , 0.00241772127897  , 0.00732985201712  ,
 0.0186205062716   , 0.0395756913699   , 0.0700096332872   , 0.102462502575    ,
 0.123995379695    , 0.126316005855    , 0.11535675016     , 0.107368788104    ,
 0.113495261449    , 0.129871207525    , 0.142937262477    , 0.141260775404    ,
 0.121928255174    , 0.0902398960794   , 0.0561733639909   , 0.0289419964886   ,
 0.0124019226945   , 0.0049474590251   , 0.00282479033494  , 0.00286454471254  ,
 0.00317959033597  , 0.0029580114133   , 0.00219088415797  , 0.0012831878971   ,
 0.000594188707584 , 0.000217622289684 , 6.30484532949e-05 , 1.44440081859e-05 ,
 2.61460098297e-06 , 3.73541116775e-07 , 4.20625819061e-08 , 3.72766896103e-09 ,
 2.59607958337e-10 , 1.41881423785e-11 , 6.08258160616e-13 , 2.63416644321e-14 ,
 5.13213533319e-14 , 3.3826905665e-13  , 1.76402431347e-12 , 7.21150189224e-12 ,
 2.31410499354e-11 , 5.83711199422e-11 , 1.1590909849e-10  , 1.81458220452e-10 ,
 2.24259691242e-10 , 2.19031037985e-10 , 1.69178273571e-10 , 1.03366081659e-10 ,
 4.99468831935e-11 , 1.90740058413e-11 , 5.75072422822e-12 , 1.36703513279e-12 ,
 2.55847029116e-13 , 3.76423979479e-14 , 4.34756986915e-15 , 3.93653341937e-16 ,
 2.79106014204e-17 , 1.54800232817e-18 , 6.7104066397e-20  , 2.27191330125e-21 ,
 6.00409056365e-23 , 1.20931501561e-24 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.87261025813e-19 ,
 9.11787981814e-18 , 3.43159897717e-16 , 1.00666516173e-14 , 2.30227900749e-13 ,
 4.1061954148e-12  , 5.71328783266e-11 , 6.20429047811e-10 , 5.26136682568e-09 ,
 3.48658722464e-08 , 1.80698545532e-07 , 7.33136848216e-07 , 2.33123212617e-06 ,
 5.81722688077e-06 , 1.14074978316e-05 , 1.76057063129e-05 , 2.14163575672e-05 ,
 2.05616080104e-05 , 1.55982537015e-05 , 9.35704305032e-06 , 4.44008952301e-06 ,
 1.66638471229e-06 , 4.94345600801e-07 , 1.15806591175e-07 , 2.13966043164e-08 ,
 3.11374895561e-09 , 3.56469506693e-10 , 3.20821181475e-11 , 2.27157822488e-12 ,
 1.27097266219e-13 , 5.69643361914e-15 , 2.11660302007e-16 , 6.98202359546e-18 ,
 2.19612782444e-19 , 5.46675862185e-21 , 1.87344122627e-22 , 5.01321924839e-24 ,
 1.04429863973e-25 , 6.66425236533e-29 , 1.27796316298e-30 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.05171257183e-25 ,
 1.36068573486e-23 , 5.50256217224e-22 , 1.75691407448e-20 , 4.43521551204e-19 ,
 8.8571433795e-18  , 1.40023884926e-16 , 1.75394952263e-15 , 1.7441509719e-14  ,
 1.38408371577e-13 , 8.88305711317e-13 , 4.7593479055e-12  , 2.27522979129e-11 ,
 1.08406676204e-10 , 5.76587083097e-10 , 3.50816379442e-09 , 2.2513389903e-08  ,
 1.37536948085e-07 , 7.5416382364e-07  , 3.69802456866e-06 , 1.680427121e-05   ,
 7.3405605357e-05  , 0.000306812624348 , 0.00117617498235  , 0.00396259960022  ,
 0.0114497133251   , 0.0280790074426   , 0.0581128994498   , 0.10088508459     ,
 0.146010772953    , 0.176044071462    , 0.179870348262    , 0.165126831099    ,
 0.152686002219    , 0.156066910502    , 0.169087299378    , 0.174707259486    ,
 0.161650134493    , 0.1308964018      , 0.091504064249    , 0.0542629704755   ,
 0.0267726107708   , 0.0108645813707   , 0.00374650161146  , 0.00139866306367  ,
 0.000932945160052 , 0.000917497796917 , 0.000833865025883 , 0.000612531955407 ,
 0.000356388849999 , 0.00016392260027  , 5.96243977846e-05 , 1.71554836396e-05 ,
 3.90404633599e-06 , 7.02267080301e-07 , 9.97556217048e-08 , 1.11755264423e-08 ,
 9.85983075237e-10 , 6.84059527741e-11 , 3.72658122408e-12 , 1.59219408638e-13 ,
 5.5764577568e-15  , 2.26842787225e-15 , 1.41857915313e-14 , 7.39858841267e-14 ,
 3.02564689481e-13 , 9.71297464948e-13 , 2.4511744614e-12  , 4.87002764414e-12 ,
 7.62881835107e-12 , 9.43460031418e-12 , 9.22121164363e-12 , 7.12765650107e-12 ,
 4.35812954064e-12 , 2.107369548e-12   , 8.05315693038e-13 , 2.42948304845e-13 ,
 5.77841990416e-14 , 1.08197492974e-14 , 1.5925429617e-15  , 1.83996268322e-16 ,
 1.66647675846e-17 , 1.18182976431e-18 , 6.55599465154e-20 , 2.84237286793e-21 ,
 9.62445169896e-23 , 2.54374031109e-24 , 5.12526141467e-26 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 2.22325774726e-20 , 1.08252129575e-18 , 4.07417014737e-17 , 1.19516462962e-15 ,
 2.73338447472e-14 , 4.87508824231e-13 , 6.78311367363e-12 , 7.36606029936e-11 ,
 6.24657451026e-10 , 4.13946410637e-09 , 2.14535193174e-08 , 8.70420894158e-08 ,
 2.76777146858e-07 , 6.90655139753e-07 , 1.35436671481e-06 , 2.09025878149e-06 ,
 2.54268773715e-06 , 2.44121135003e-06 , 1.85193269716e-06 , 1.11093513516e-06 ,
 5.27159923439e-07 , 1.97845285376e-07 , 5.86919581429e-08 , 1.37490392498e-08 ,
 2.54013878826e-09 , 3.69590486679e-10 , 4.22910876787e-11 , 3.80107201741e-12 ,
 2.68143785996e-13 , 1.48531945437e-14 , 6.48217205821e-16 , 2.2527441009e-17  ,
 6.41004085465e-19 , 1.54853086738e-20 , 1.83593176265e-22 , 6.26930514055e-24 ,
 1.66803428292e-25 , 3.44231908211e-27 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 3.68206069433e-24 , 2.44193016333e-22 ,
 9.87511357776e-21 , 3.15303601788e-19 , 7.95881084233e-18 , 1.58909616277e-16 ,
 2.51119085426e-15 , 3.1423904017e-14  , 3.11729066643e-13 , 2.45952056991e-12 ,
 1.55716525495e-11 , 8.08506496104e-11 , 3.6098559725e-10  , 1.50839348672e-09 ,
 6.54839655122e-09 , 3.14610350464e-08 , 1.64074277762e-07 , 8.60188969604e-07 ,
 4.17589325363e-06 , 1.78506262304e-05 , 6.66173870015e-05 , 0.000223097960928 ,
 0.000701433056766 , 0.00212906165466  , 0.00615731295754  , 0.0163338797704   ,
 0.0383671204616   , 0.077897364453    , 0.134459145632    , 0.195031390845    ,
 0.236686565417    , 0.243192509641    , 0.22153758942     , 0.196582955936    ,
 0.186199917225    , 0.185693762518    , 0.178144327897    , 0.153942164268    ,
 0.116919717774    , 0.0772459906021   , 0.0437657589792   , 0.0208446104329   ,
 0.00819175897564  , 0.00265177574108  , 0.000771840214356 , 0.000302624233221 ,
 0.000221736900496 , 0.000189437541091 , 0.000137406254121 , 7.94807032522e-05 ,
 3.63675820509e-05 , 1.31583028904e-05 , 3.765811644e-06   , 8.52499815256e-07 ,
 1.52585967811e-07 , 2.15747387564e-08 , 2.40697649015e-09 , 2.11586421341e-10 ,
 1.4633519149e-11  , 7.951301709e-13   , 3.40019330094e-14 , 1.34662668966e-15 ,
 3.99941987801e-16 , 8.07786240338e-16 , 2.73774260848e-15 , 1.01784980361e-14 ,
 3.21350336481e-14 , 8.08965557623e-14 , 1.60724335245e-13 , 2.51882969589e-13 ,
 3.11677491953e-13 , 3.04810612779e-13 , 2.35753226104e-13 , 1.44237973341e-13 ,
 6.97879291666e-14 , 2.66839592316e-14 , 8.05418105896e-15 , 1.91652972624e-15 ,
 3.59001941308e-16 , 5.28589392436e-17 , 6.10885958264e-18 , 5.53417326567e-19 ,
 3.92547327165e-20 , 2.17792702343e-21 , 9.44365384882e-23 , 3.19799878591e-24 ,
 8.45297172443e-26 , 1.70364161089e-27 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.05834902906e-21 ,
 1.00222627947e-19 , 3.77197266708e-18 , 1.10651461424e-16 , 2.5306390551e-15  ,
 4.51348538776e-14 , 6.27998710706e-13 , 6.81969652944e-12 , 5.78324855933e-11 ,
 3.83243013914e-10 , 1.98622712841e-09 , 8.0586067434e-09  , 2.56248444121e-08 ,
 6.3942951693e-08  , 1.25391529835e-07 , 1.93522987029e-07 , 2.3541068753e-07  ,
 2.26016025583e-07 , 1.71458807386e-07 , 1.02854677916e-07 , 4.88065833304e-08 ,
 1.83173294317e-08 , 5.43393958077e-09 , 1.2729357142e-09  , 2.35171354374e-10 ,
 3.42157961099e-11 , 3.91466908678e-12 , 3.51711352288e-13 , 2.47850793687e-14 ,
 1.3689501339e-15  , 5.92759526158e-17 , 2.01731801352e-18 , 5.44147618662e-20 ,
 1.15636363973e-21 , 4.84426914056e-24 , 1.65421188537e-25 , 4.40125671691e-27 ,
 9.08286486496e-29 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 3.01363705579e-31 , 5.1632493884e-23  , 3.42426687693e-21 ,
 1.38477622623e-19 , 4.42149092723e-18 , 1.11598830309e-16 , 2.2279875143e-15  ,
 3.51986645529e-14 , 4.401705515e-13   , 4.35958145934e-12 , 3.42654807963e-11 ,
 2.14986159194e-10 , 1.0931598148e-09  , 4.6628846082e-09  , 1.78203583494e-08 ,
 6.6862454599e-08  , 2.647487475e-07   , 1.12136144266e-06 , 4.90806253019e-06 ,
 2.08606099231e-05 , 8.06045134849e-05 , 0.000271164591676 , 0.000785929387766 ,
 0.00200361960085  , 0.00470147427152  , 0.0106665459641   , 0.0238289669731   ,
 0.051043662887    , 0.0999644673866   , 0.171552669968    , 0.250734927643    ,
 0.307688826894    , 0.31782764385     , 0.28452761003     , 0.236494849657    ,
 0.199568808305    , 0.176083558268    , 0.153030222008    , 0.122077095463    ,
 0.0863819243488   , 0.0535998221004   , 0.0288472033219   , 0.0132185671332   ,
 0.00504605573702  , 0.00158041207008  , 0.000413637337376 , 0.000109102609944 ,
 4.84883143138e-05 , 3.50479347582e-05 , 2.46713877231e-05 , 1.41695917518e-05 ,
 6.45656808326e-06 , 2.32694292037e-06 , 6.63334471447e-07 , 1.49580849842e-07 ,
 2.6672956275e-08  , 3.7582570627e-09  , 4.17962918654e-10 , 3.66386244775e-11 ,
 2.52854211742e-12 , 1.39309467926e-13 , 1.12174791863e-14 , 1.02449051209e-14 ,
 1.46176277452e-14 , 1.65575467553e-14 , 1.46568647697e-14 , 1.02840900923e-14 ,
 6.19330075056e-15 , 4.32776694438e-15 , 4.88537500625e-15 , 6.70562341915e-15 ,
 8.11046147749e-15 , 7.90593575979e-15 , 6.11429457262e-15 , 3.7424049104e-15  ,
 1.81159215051e-15 , 6.92997003646e-16 , 2.09260197121e-16 , 4.98132348443e-17 ,
 9.33401643048e-18 , 1.37471207738e-18 , 1.58911492028e-19 , 1.43989912494e-20 ,
 1.02150394843e-21 , 5.66822275985e-23 , 2.45803591934e-24 , 8.3245737217e-26  ,
 2.20049975391e-27 , 4.43601707949e-29 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.48564550178e-22 ,
 7.23372616052e-21 , 2.72248091637e-19 , 7.98644488107e-18 , 1.82652911028e-16 ,
 3.2576805366e-15  , 4.53268230866e-14 , 4.92222740914e-13 , 4.17415531271e-12 ,
 2.76612080889e-11 , 1.43359340015e-10 , 5.81644031065e-10 , 1.84951912984e-09 ,
 4.61520081494e-09 , 9.05037374329e-09 , 1.39679065943e-08 , 1.69912545646e-08 ,
 1.63131962778e-08 , 1.23754277597e-08 , 7.4237797218e-09  , 3.52273540132e-09 ,
 1.32209993287e-09 , 3.92208703434e-10 , 9.18773854101e-11 , 1.69740242938e-11 ,
 2.46956938091e-12 , 2.82535275036e-13 , 2.53814477181e-14 , 1.78808624856e-15 ,
 9.86786217141e-17 , 4.26305852251e-18 , 1.44184658871e-19 , 3.82502003459e-21 ,
 7.76989911265e-23 , 9.70085139337e-26 , 3.31262842908e-27 , 8.81370050174e-29 ,
 1.81888164601e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.56762463939e-31 , 2.85757646984e-29 , 5.66190709788e-22 , 3.75501869354e-20 ,
 1.51855251732e-18 , 4.84867648155e-17 , 1.22376548396e-15 , 2.4429966755e-14  ,
 3.85890514502e-13 , 4.82363497009e-12 , 4.77245365903e-11 , 3.74150936811e-10 ,
 2.33323756308e-09 , 1.16970160586e-08 , 4.83489617837e-08 , 1.73508559081e-07 ,
 5.85661963281e-07 , 2.00434840642e-06 , 7.13156323734e-06 , 2.59890603852e-05 ,
 9.41368595803e-05 , 0.000323150919665 , 0.000996246871358 , 0.0026599572026   ,
 0.00609729494009  , 0.012235918296    , 0.022527792997    , 0.0404419274757   ,
 0.073271448548    , 0.130623720259    , 0.215471592407    , 0.311389188596    ,
 0.381897941378    , 0.393552636217    , 0.345100963497    , 0.268675030743    ,
 0.199638580749    , 0.150472305225    , 0.11401978363     , 0.0818985894118   ,
 0.0532194549814   , 0.030682267739    , 0.015531442871    , 0.00679139383867  ,
 0.00250711451025  , 0.000764545200571 , 0.000191075599307 , 4.15071433253e-05 ,
 1.09688362532e-05 , 5.49151290632e-06 , 3.55390270231e-06 , 2.01195105148e-06 ,
 9.12940086663e-07 , 3.28063688048e-07 , 9.32581616848e-08 , 2.09713667998e-08 ,
 3.72957756633e-09 , 5.24185035416e-10 , 5.81635488375e-11 , 5.09506274018e-12 ,
 3.77934854518e-13 , 1.03563860555e-13 , 2.03453778036e-13 , 3.7821732693e-13  ,
 5.49805757834e-13 , 6.22606014e-13    , 5.4917052851e-13  , 3.77294022418e-13 ,
 2.01901637078e-13 , 8.41773918748e-14 , 2.73880258087e-14 , 7.02568544842e-15 ,
 1.51002428841e-15 , 3.56154313735e-16 , 1.39430664105e-16 , 7.25707089563e-17 ,
 3.42441180035e-17 , 1.30690573802e-17 , 3.9506023554e-18  , 9.41743667277e-19 ,
 1.76691430592e-19 , 2.60518412631e-20 , 3.01428327902e-21 , 2.7333344587e-22  ,
 1.94031192545e-23 , 1.07720220288e-24 , 4.67319622901e-26 , 1.58317031954e-27 ,
 4.18598689101e-29 , 8.44646105445e-31 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8.35763540596e-24 ,
 4.06939994764e-22 , 1.5315570479e-20  , 4.49284940649e-19 , 1.02753115498e-17 ,
 1.83263906939e-16 , 2.54990375517e-15 , 2.76904655619e-14 , 2.3482118878e-13  ,
 1.55610873305e-12 , 8.06482477021e-12 , 3.27209871941e-11 , 1.0404666578e-10  ,
 2.59633186166e-10 , 5.09139064931e-10 , 7.85781105291e-10 , 9.5586399696e-10  ,
 9.17719914961e-10 , 6.96196411536e-10 , 4.17635222738e-10 , 1.981766769e-10   ,
 7.43767573354e-11 , 2.20643189735e-11 , 5.16870848232e-12 , 9.5489967429e-13  ,
 1.38928737897e-13 , 1.58941448231e-14 , 1.42778465618e-15 , 1.00573654536e-16 ,
 5.54854972312e-18 , 2.3949436438e-19  , 8.08067132744e-21 , 2.12968815869e-22 ,
 4.24656957207e-24 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 7.56031632833e-30 , 1.24010547983e-27 , 4.85991349562e-21 ,
 3.22320865787e-19 , 1.30351678709e-17 , 4.16215203501e-16 , 1.05048128779e-14 ,
 2.09701846584e-13 , 3.312119368e-12   , 4.13910522901e-11 , 4.09245691696e-10 ,
 3.20304355255e-09 , 1.98932333983e-08 , 9.87700803077e-08 , 3.99412892349e-07 ,
 1.36983465087e-06 , 4.27144401795e-06 , 1.3082529986e-05  , 4.0742969876e-05  ,
 0.000127332409914 , 0.000391989331784 , 0.00116627881712  , 0.00323214266207  ,
 0.00798459111236  , 0.0170924362308   , 0.0316167677585   , 0.0517929489543   ,
 0.0790885883445   , 0.119549286268    , 0.183122602729    , 0.273599698792    ,
 0.373867327317    , 0.444698958191    , 0.449357092216    , 0.384924560735    ,
 0.28519320564     , 0.191128844344    , 0.122821837259    , 0.0782437028206   ,
 0.0485095389713   , 0.0280678628525   , 0.014720461761    , 0.00689464873029  ,
 0.00283932970977  , 0.00100434506607  , 0.000297277614553 , 7.22025328216e-05 ,
 1.44875845923e-05 , 2.75207652212e-06 , 8.04268712889e-07 , 4.17664207995e-07 ,
 2.27261415564e-07 , 1.024010785e-07   , 3.6704242854e-08  , 1.04131461174e-08 ,
 2.33718525802e-09 , 4.14883785687e-10 , 5.82160937585e-11 , 6.48893383893e-12 ,
 7.67801844863e-13 , 8.45643373336e-13 , 2.48313604369e-12 , 5.94363290561e-12 ,
 1.10921283533e-11 , 1.61254894331e-11 , 1.82606968022e-11 , 1.61068457623e-11 ,
 1.10656932808e-11 , 5.92121747003e-12 , 2.46773937651e-12 , 8.01008174084e-13 ,
 2.02497144027e-13 , 3.98695372461e-14 , 6.11365236942e-15 , 7.30121496663e-16 ,
 6.79082450194e-17 , 4.91905180693e-18 , 2.77504907524e-19 , 1.21924065528e-20 ,
 4.17192998028e-22 , 1.111764638e-23   , 2.30726935464e-25 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 3.66394378819e-25 , 1.78400398384e-23 ,
 6.71426751621e-22 , 1.96964223157e-20 , 4.50464440234e-19 , 8.03419729829e-18 ,
 1.11786507305e-16 , 1.21393634796e-15 , 1.02944468159e-14 , 6.82190652801e-14 ,
 3.53558167864e-13 , 1.43447332794e-12 , 4.56136071351e-12 , 1.13822116464e-11 ,
 2.23204586362e-11 , 3.44483600406e-11 , 4.19047626939e-11 , 4.02325704482e-11 ,
 3.05210711305e-11 , 1.83090364879e-11 , 8.6880296698e-12  , 3.26066639269e-12 ,
 9.67297372235e-13 , 2.26595794013e-13 , 4.18627585252e-14 , 6.09063316054e-15 ,
 6.96799349704e-16 , 6.25941094902e-17 , 4.40915268825e-18 , 2.43248692493e-19 ,
 1.04994471506e-20 , 3.54257177078e-22 , 9.33656867795e-24 , 1.8617002819e-25  ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 2.83774212502e-28 , 4.22321955999e-26 , 3.26904402815e-20 , 2.168205635e-18   ,
 8.76893972284e-17 , 2.8000298756e-15  , 7.06710577818e-14 , 1.4107969902e-12  ,
 2.22825488005e-11 , 2.7843280051e-10  , 2.75195114282e-09 , 2.1516761865e-08  ,
 1.33283686878e-07 , 6.57489017814e-07 , 2.61884533486e-06 , 8.69322657419e-06 ,
 2.55226567679e-05 , 7.16055886271e-05 , 0.000201242854452 , 0.000560459706842 ,
 0.00150705271232  , 0.00387957647949  , 0.00946470284955  , 0.0212487683052   ,
 0.0424269982521   , 0.0740036598931   , 0.113541673394    , 0.15822555403     ,
 0.2103135955      , 0.277134643997    , 0.360486132433    , 0.443108631367    ,
 0.490034572394    , 0.471976072094    , 0.390816161952    , 0.279367427756    ,
 0.175849414024    , 0.10071006826     , 0.0542894558261   , 0.0279924337599   ,
 0.0136898434894   , 0.00623589487012  , 0.00260630270682  , 0.000983855870013 ,
 0.000327314030401 , 9.3029585026e-05  , 2.19588091001e-05 , 4.24144151322e-06 ,
 6.95006311656e-07 , 1.26069489419e-07 , 4.23053862985e-08 , 2.05399608365e-08 ,
 9.08894901293e-09 , 3.24642794897e-09 , 9.19590456293e-10 , 2.06131095388e-10 ,
 3.65627695689e-11 , 5.26367497584e-12 , 1.49004367728e-12 , 4.72473169079e-12 ,
 1.84527989406e-11 , 5.67284357073e-11 , 1.35897374442e-10 , 2.53618153068e-10 ,
 3.68704525012e-10 , 4.17525409095e-10 , 3.68278244774e-10 , 2.5301379046e-10  ,
 1.35386878907e-10 , 5.64241279487e-11 , 1.83148140086e-11 , 4.63003705846e-12 ,
 9.11605128259e-13 , 1.3978684573e-13  , 1.6694011182e-14  , 1.55270185427e-15 ,
 1.12472658654e-16 , 6.34506729423e-18 , 2.78775754801e-19 , 9.53899399757e-21 ,
 2.54201682643e-22 , 5.27550285568e-24 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 1.25156206929e-26 , 6.09395805256e-25 , 2.29351875281e-23 ,
 6.72807803648e-22 , 1.53873633346e-20 , 2.74439245652e-19 , 3.81850310476e-18 ,
 4.14667236573e-17 , 3.51646969846e-16 , 2.33028855444e-15 , 1.20771622788e-14 ,
 4.90000603155e-14 , 1.55811205624e-13 , 3.8880432427e-13  , 7.62443613893e-13 ,
 1.17672067672e-12 , 1.43142455328e-12 , 1.37430499552e-12 , 1.04257042797e-12 ,
 6.25419500985e-13 , 2.96775143169e-13 , 1.11381455056e-13 , 3.30420363189e-14 ,
 7.74031963135e-15 , 1.42999698225e-15 , 2.08051054069e-16 , 2.38021060185e-17 ,
 2.13816520384e-18 , 1.50613205016e-19 , 8.30918682632e-21 , 3.58653043356e-22 ,
 1.21011546125e-23 , 3.18930092768e-25 , 6.35942948284e-27 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8.29775848938e-27 ,
 1.1391006242e-24  , 1.72570052721e-19 , 1.14463205335e-17 , 4.62955063872e-16 ,
 1.47834677514e-14 , 3.73147879845e-13 , 7.44972197188e-12 , 1.17673938338e-10 ,
 1.47049332049e-09 , 1.4532990735e-08  , 1.13578587175e-07 , 7.02522219489e-07 ,
 3.45168678128e-06 , 1.36115983886e-05 , 4.41647212036e-05 , 0.000123959981686 ,
 0.000324231835549 , 0.000838763486332 , 0.00214380174783  , 0.00522588014291  ,
 0.0119429190295   , 0.0256579452922   , 0.0515435384626   , 0.0946812921454   ,
 0.155529877708    , 0.227290469095    , 0.300365326682    , 0.370243433118    ,
 0.437950424944    , 0.499956867483    , 0.5395944074      , 0.533891333045    ,
 0.47252865787     , 0.369444885461    , 0.254632375886    , 0.155428588963    ,
 0.0846859774623   , 0.0415414716763   , 0.0184875714762   , 0.00751149726562  ,
 0.0028039618208   , 0.000969139279565 , 0.000311330166409 , 9.18506234875e-05 ,
 2.41187881763e-05 , 5.42163633706e-06 , 1.01111920808e-06 , 1.55352866251e-07 ,
 2.15790205232e-08 , 4.16655004015e-09 , 1.5240640705e-09  , 6.39001366218e-10 ,
 2.26384019678e-10 , 6.40133582801e-11 , 1.43631995287e-11 , 2.84345584138e-12 ,
 2.88944880186e-12 , 1.65011250734e-11 , 8.33622958088e-11 , 3.28948443682e-10 ,
 1.01145065515e-09 , 2.42301629307e-09 , 4.52194866984e-09 , 6.57391010044e-09 ,
 7.44437433743e-09 , 6.56630962981e-09 , 4.51117303926e-09 , 2.41391442294e-09 ,
 1.00602818646e-09 , 3.26548584662e-10 , 8.2552410724e-11  , 1.62536930085e-11 ,
 2.49236473852e-12 , 2.97650072847e-13 , 2.76842883949e-14 , 2.00535956736e-15 ,
 1.13130973841e-16 , 4.9705024646e-18  , 1.70077893641e-19 , 4.53235286183e-21 ,
 9.4060905565e-23  , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3.33079510578e-28 ,
 1.62179151826e-26 , 6.10376593035e-25 , 1.79055064486e-23 , 4.09505572347e-22 ,
 7.30368184419e-21 , 1.0162225002e-19  , 1.10355864426e-18 , 9.35842187597e-18 ,
 6.20162495185e-17 , 3.21411023822e-16 , 1.30404496547e-15 , 4.14662483381e-15 ,
 1.03473053953e-14 , 2.02910283819e-14 , 3.13162593209e-14 , 3.80947518337e-14 ,
 3.65746366846e-14 , 2.77461366973e-14 , 1.6644423996e-14  , 7.89814511019e-15 ,
 2.96422182568e-15 , 8.79356207696e-16 , 2.05995210623e-16 , 3.80569103477e-17 ,
 5.53692297949e-18 , 6.33452538189e-19 , 5.69036422562e-20 , 4.00831599005e-21 ,
 2.21135007842e-22 , 9.54494784023e-24 , 3.22051924415e-25 , 8.48779003431e-27 ,
 1.69245617472e-28 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 3.65703620989e-30 , 1.89163335955e-25 , 2.43409108343e-23 ,
 7.16545557732e-19 , 4.75178250892e-17 , 1.92189521948e-15 , 6.13728874951e-14 ,
 1.549241291e-12   , 3.09349628311e-11 , 4.88755968979e-10 , 6.10945052096e-09 ,
 6.03986290589e-08 , 4.72114684721e-07 , 2.91924880106e-06 , 1.43172232876e-05 ,
 5.61421010071e-05 , 0.000179541375803 , 0.000488333787015 , 0.00121029583431  ,
 0.00292571524534  , 0.0069934155272   , 0.01592410627     , 0.0334808831995   ,
 0.064905955823    , 0.117099716222    , 0.19620781894     , 0.301384339769    ,
 0.420705619411    , 0.536212925841    , 0.633081134052    , 0.700907567039    ,
 0.727416974398    , 0.698655713259    , 0.611458155772    , 0.483595691276    ,
 0.346367629065    , 0.226496091728    , 0.135881682735    , 0.0743954260659   ,
 0.0366579859225   , 0.0160008406618   , 0.00610823366295  , 0.00202352334603  ,
 0.000581371560441 , 0.000146342911732 , 3.29620718113e-05 , 6.77732369633e-06 ,
 1.26988662091e-06 , 2.10664349239e-07 , 2.98557422636e-08 , 3.61855802969e-09 ,
 4.53497066665e-10 , 1.00116385582e-10 , 3.59647384156e-11 , 1.24372122867e-11 ,
 3.5321909265e-12  , 1.17953167687e-12 , 4.36769929304e-12 , 3.52608856419e-11 ,
 2.28957662808e-10 , 1.1593795714e-09  , 4.57510748957e-09 , 1.40675500976e-08 ,
 3.37000162451e-08 , 6.28925790148e-08 , 9.14318561792e-08 , 1.0353852629e-07  ,
 9.13261466202e-08 , 6.27427084068e-08 , 3.35734247921e-08 , 1.39921330002e-08 ,
 4.54173281535e-09 , 1.14816296987e-09 , 2.26061095882e-10 , 3.4664534628e-11  ,
 4.13980389698e-12 , 3.85041145417e-13 , 2.78911248783e-14 , 1.57345853102e-15 ,
 6.91311958238e-17 , 2.36549287609e-18 , 6.30372835473e-20 , 1.3082264677e-21  ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6.87992691983e-30 ,
 3.34989404409e-28 , 1.26076445311e-26 , 3.69847547872e-25 , 8.45855179831e-24 ,
 1.50861396682e-22 , 2.09906160747e-21 , 2.27945972816e-20 , 1.9330330819e-19  ,
 1.28098004996e-18 , 6.63892685608e-18 , 2.69358066903e-17 , 8.56510187451e-17 ,
 2.13730005419e-16 , 4.19124266513e-16 , 6.46858406797e-16 , 7.86873952206e-16 ,
 7.55476191922e-16 , 5.73118036281e-16 , 3.43804176172e-16 , 1.63142951159e-16 ,
 6.12286542746e-17 , 1.81639213368e-17 , 4.2550297954e-18  , 7.861033373e-19   ,
 1.14370796829e-19 , 1.3084623116e-20  , 1.17540518076e-21 , 8.27960878143e-23 ,
 4.56778481765e-24 , 1.97161409467e-25 , 6.65233987234e-27 , 1.75324778662e-28 ,
 3.49596136615e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 1.77309953865e-28 , 3.36210309657e-24 , 4.1193930246e-22  ,
 2.35394903707e-18 , 1.55771814692e-16 , 6.29633208908e-15 , 2.00987443735e-13 ,
 5.07306183616e-12 , 1.01314222648e-10 , 1.60133936996e-09 , 2.00291783981e-08 ,
 1.9817894651e-07  , 1.55072396907e-06 , 9.59922842953e-06 , 4.71091428611e-05 ,
 0.000184505825789 , 0.000586261224436 , 0.00156603230237  , 0.00374219592039  ,
 0.00858749796761  , 0.0194611118015   , 0.042204626115    , 0.0840913603564   ,
 0.152038010076    , 0.252042341475    , 0.38792075173     , 0.556096723806    ,
 0.740717773291    , 0.915888998646    , 1.05178853014     , 1.1183328399      ,
 1.0906644527      , 0.963055942877    , 0.762423165852    , 0.541897050406    ,
 0.352149936855    , 0.215905700752    , 0.128002893329    , 0.073009200178    ,
 0.0387573047058   , 0.0183965319081   , 0.0075508315691   , 0.00261315691912  ,
 0.000748408060438 , 0.000175193753421 , 3.33571493591e-05 , 5.19363220237e-06 ,
 6.73944055518e-07 , 7.53395324598e-08 , 7.52503474377e-09 , 6.86898968905e-10 ,
 6.01730830532e-11 , 7.01212306701e-12 , 1.69669410876e-12 , 5.58554507467e-13 ,
 4.64118236513e-13 , 4.3288898875e-12  , 4.59065537567e-11 , 3.82510143865e-10 ,
 2.48507336743e-09 , 1.25838537449e-08 , 4.96580188516e-08 , 1.5268858086e-07  ,
 3.65778520066e-07 , 6.8263333489e-07  , 9.92397415982e-07 , 1.12380269021e-06 ,
 9.91250048996e-07 , 6.81006645786e-07 , 3.64404501906e-07 , 1.51870006951e-07 ,
 4.92957717188e-08 , 1.24621112601e-08 , 2.45365736606e-09 , 3.76247360916e-10 ,
 4.49332526071e-11 , 4.17921995382e-12 , 3.02729064188e-13 , 1.70782509028e-14 ,
 7.50347012149e-16 , 2.56749574758e-17 , 6.84204403314e-19 , 1.42087457071e-20 ,
 1.51835549219e-22 , 1.95626606805e-21 , 1.98953127324e-20 , 1.59532173443e-19 ,
 1.00751129233e-18 , 5.00671706422e-18 , 1.95639307297e-17 , 6.00870013398e-17 ,
 1.45038198084e-16 , 2.75204325602e-16 , 4.10699503563e-16 , 4.82425763936e-16 ,
 4.46484037165e-16 , 3.25938146241e-16 , 1.87891617794e-16 , 8.56170069104e-17 ,
 3.08618370095e-17 , 8.80366939367e-18 , 1.98732305083e-18 , 3.54832349524e-19 ,
 5.00654325336e-20 , 5.57550019695e-21 , 4.89375312389e-22 , 3.38029361471e-23 ,
 1.83470828884e-24 , 7.8138145743e-26  , 2.60785875045e-27 , 6.81276116952e-29 ,
 1.31418970883e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 6.6665962278e-27  , 4.67021126793e-23 , 5.52448500112e-21 , 6.26300800845e-18 ,
 4.09000231796e-16 , 1.64572116343e-14 , 5.23771362085e-13 , 1.31980169386e-11 ,
 2.63395594797e-10 , 4.16364212389e-09 , 5.21218779232e-08 , 5.1652844226e-07  ,
 4.05124083212e-06 , 2.51578952647e-05 , 0.000123958222227 , 0.000487567669813 ,
 0.00155345359325  , 0.0041358366011   , 0.00972195506645  , 0.0215970489032   ,
 0.0470438927847   , 0.0983748754811   , 0.18926710671     , 0.327844173944    ,
 0.513555286487    , 0.739833460862    , 0.995986949966    , 1.26428512927     ,
 1.51380265096     , 1.69528343525     , 1.74906981421     , 1.63481473452     ,
 1.36538789708     , 1.01219852651     , 0.670219265075    , 0.407496719238    ,
 0.239278604309    , 0.142127657673    , 0.0851359625559   , 0.0487311848829   ,
 0.0250277986903   , 0.0110031456915   , 0.00401449108085  , 0.00119094550918  ,
 0.000283392175269 , 5.36186431483e-05 , 8.0284531639e-06  , 9.51196898616e-07 ,
 8.98514900086e-08 , 6.93470571624e-09 , 4.64325775041e-10 , 3.00612350213e-11 ,
 2.12027211554e-12 , 1.93056813527e-13 , 1.7763457295e-13  , 2.66278382983e-12 ,
 3.64029303038e-11 , 3.89001605755e-10 , 3.24171469863e-09 , 2.1060659852e-08  ,
 1.0664645818e-07  , 4.20844992434e-07 , 1.29401506833e-06 , 3.09992347805e-06 ,
 5.78522517216e-06 , 8.41043385708e-06 , 9.52407578071e-06 , 8.40071007708e-06 ,
 5.77143920206e-06 , 3.08827886001e-06 , 1.28707776518e-06 , 4.1777499699e-07  ,
 1.05614707157e-07 , 2.07944142668e-08 , 3.18864548811e-09 , 3.80803237644e-10 ,
 3.54183237781e-11 , 2.56558786829e-12 , 1.44735866196e-13 , 6.35908942721e-15 ,
 2.1759179223e-16  , 5.79855847304e-18 , 1.20802144901e-19 , 7.55164981676e-21 ,
 9.71564614733e-20 , 9.86795917303e-19 , 7.90345863515e-18 , 4.9861778991e-17  ,
 2.47553867103e-16 , 9.66522917629e-16 , 2.96623624721e-15 , 7.15476350733e-15 ,
 1.35663587959e-14 , 2.02313425599e-14 , 2.37471888907e-14 , 2.19609488502e-14 ,
 1.60185225235e-14 , 9.22603667567e-15 , 4.20020114159e-15 , 1.51259485994e-15 ,
 4.31075404816e-16 , 9.72199086136e-17 , 1.73430790255e-17 , 2.44503565762e-18 ,
 2.72088184352e-19 , 2.38662650664e-20 , 1.64760132044e-21 , 8.93835062502e-23 ,
 3.80522682356e-24 , 1.26957751536e-25 , 3.31575044511e-27 , 6.38955433271e-29 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.28545070674e-31 ,
 1.95304849869e-25 , 5.09733613928e-22 , 5.88215296515e-20 , 1.49191146175e-17 ,
 9.13040517563e-16 , 3.58652999373e-14 , 1.12266354342e-12 , 2.79835026456e-11 ,
 5.5480140869e-10  , 8.74063546956e-09 , 1.09334551556e-07 , 1.08513709481e-06 ,
 8.54263313607e-06 , 5.33739533273e-05 , 0.000265319045665 , 0.00105600677471  ,
 0.00341300907053  , 0.009212981343    , 0.0217919731992   , 0.0479534567785   ,
 0.101978286422    , 0.207410842094    , 0.388939015972    , 0.655536571459    ,
 0.990554280651    , 1.36094885595     , 1.73649022315     , 2.096830834       ,
 2.41265218992     , 2.61799218646     , 2.6207952877      , 2.36764051774     ,
 1.90312718979     , 1.35687098685     , 0.868251540121    , 0.515846196014    ,
 0.300981746736    , 0.180776500043    , 0.110655133483    , 0.0648580907607   ,
 0.0340255678665   , 0.0152188933273   , 0.00562541370208  , 0.00168443019816  ,
 0.000403408353191 , 7.67091489962e-05 , 1.15650177787e-05 , 1.39594758121e-06 ,
 1.40039440156e-07 , 1.28449724503e-08 , 1.23851080841e-09 , 1.29966860327e-10 ,
 1.31460574306e-11 , 1.18067872009e-12 , 1.08193070566e-12 , 1.75999959198e-11 ,
 2.41036791062e-10 , 2.57579596989e-09 , 2.14652066352e-08 , 1.39454412692e-07 ,
 7.06165870288e-07 , 2.78665016553e-06 , 8.56839779296e-06 , 2.05263278132e-05 ,
 3.83072128063e-05 , 5.56901883623e-05 , 6.30642346421e-05 , 5.56258017743e-05 ,
 3.82159281847e-05 , 2.04492222818e-05 , 8.52246202731e-06 , 2.76632200805e-06 ,
 6.99334069638e-07 , 1.37691451976e-07 , 2.11138062237e-08 , 2.52151168281e-09 ,
 2.3452490902e-10  , 1.69885292373e-11 , 9.58673558917e-13 , 4.23523553021e-14 ,
 1.61905129611e-15 , 1.46191197723e-16 , 5.34496410415e-17 , 2.07414447161e-17 ,
 9.96008651595e-18 , 3.88495992412e-17 , 2.99174275406e-16 , 1.88513084012e-15 ,
 9.3567189026e-15  , 3.65230172403e-14 , 1.12064788385e-13 , 2.70254345535e-13 ,
 5.12338095403e-13 , 7.63894158458e-13 , 8.96463534952e-13 , 8.28854824959e-13 ,
 6.04436621528e-13 , 3.48047359052e-13 , 1.58410122795e-13 , 5.7032422609e-14  ,
 1.62494278259e-14 , 3.66376751802e-15 , 6.53419287616e-16 , 9.20983138255e-17 ,
 1.02467562782e-17 , 8.98632144785e-19 , 6.2027055522e-20  , 3.364560766e-21   ,
 1.43219813973e-22 , 4.77795333344e-24 , 1.24776230861e-25 , 2.40378384489e-27 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6.23153610051e-30 ,
 4.45926527862e-24 , 4.43091644431e-21 , 4.99818002787e-19 , 4.25018573772e-17 ,
 2.1371603815e-15  , 7.68452869917e-14 , 2.24776734469e-12 , 5.33142610571e-11 ,
 1.02096976613e-09 , 1.57238926631e-08 , 1.94121095571e-07 , 1.91641037121e-06 ,
 1.51079127443e-05 , 9.51230951058e-05 , 0.000479581167585 , 0.00194922557738  ,
 0.00647604311797  , 0.0180387384035   , 0.0438394503231   , 0.0975149348505   ,
 0.205249476411    , 0.408288321832    , 0.748230223777    , 1.2338318061      ,
 1.81673675225     , 2.40869596251     , 2.93362427565     , 3.3619988563      ,
 3.68070315448     , 3.82891366464     , 3.69952167045     , 3.23823134614     ,
 2.5301103422      , 1.76458270905     , 1.11746040008     , 0.666437957282    ,
 0.392948709493    , 0.23616977244     , 0.142127287354    , 0.0811076047941   ,
 0.0414503266227   , 0.0181565692258   , 0.00661243744405  , 0.0019622390292   ,
 0.000469135515653 , 9.03731070809e-05 , 1.43517575548e-05 , 2.01890264294e-06 ,
 2.86751433275e-07 , 4.45582023419e-08 , 6.9596207155e-09  , 9.5765634968e-10  ,
 1.07812735397e-10 , 9.87824303852e-12 , 5.86967084901e-12 , 9.11405522124e-11 ,
 1.24799903893e-09 , 1.33365101658e-08 , 1.1113882852e-07  , 7.22042900515e-07 ,
 3.65626331491e-06 , 1.4428234499e-05  , 4.43639657992e-05 , 0.0001062776644   ,
 0.000198340450556 , 0.000288343010158 , 0.000326523069589 , 0.000288009640436 ,
 0.000197867812856 , 0.000105878440737 , 4.41261275504e-05 , 1.43229828899e-05 ,
 3.62089080775e-06 , 7.12914959149e-07 , 1.09319423469e-07 , 1.30554634271e-08 ,
 1.21429939869e-09 , 8.79761829463e-11 , 4.97814440232e-12 , 2.31554683647e-13 ,
 1.74318324188e-14 , 6.31982596887e-15 , 3.10885695394e-15 , 1.36627731855e-15 ,
 6.88195446036e-16 , 1.38004975722e-15 , 8.96576763546e-15 , 5.56863856165e-14 ,
 2.75997137209e-13 , 1.07691823803e-12 , 3.30344387264e-12 , 7.96455242758e-12 ,
 1.50952035576e-11 , 2.25013249484e-11 , 2.63995189092e-11 , 2.44019179171e-11 ,
 1.77897850193e-11 , 1.02405886123e-11 , 4.65939479504e-12 , 1.67696541693e-12 ,
 4.77633803271e-13 , 1.07657018829e-13 , 1.91942149058e-14 , 2.70460442525e-15 ,
 3.0083211441e-16  , 2.63765997209e-17 , 1.82024895233e-18 , 9.87197414221e-20 ,
 4.2016220182e-21  , 1.40153814762e-22 , 3.65976522259e-24 , 7.04785602096e-26 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.34240473658e-28 ,
 7.93748758237e-23 , 3.16665644513e-20 , 3.43141320327e-18 , 1.80009254964e-16 ,
 7.17316141304e-15 , 2.22999173315e-13 , 5.67956025175e-12 , 1.18959727608e-10 ,
 2.05116174839e-09 , 2.90820639629e-08 , 3.3806043185e-07  , 3.20925221116e-06 ,
 2.47888171742e-05 , 0.00015546191205  , 0.000792191644592 , 0.00329690497021  ,
 0.0113358716484   , 0.032858449922    , 0.0827260168518   , 0.187343665166    ,
 0.392202156293    , 0.763963561777    , 1.36652780328     , 2.20402976079     ,
 3.17196238014     , 4.08312388112     , 4.77409533992     , 5.19472237338     ,
 5.37490348827     , 5.30731445611     , 4.91425207408     , 4.16355687655     ,
 3.17894793921     , 2.19121930226     , 1.39069897648     , 0.840198084358    ,
 0.499321424759    , 0.295022894877    , 0.169688168303    , 0.0912838391512   ,
 0.0440562827261   , 0.0184151837635   , 0.00649065782633  , 0.00189982169941  ,
 0.000464204132117 , 9.92993381808e-05 , 2.07846334864e-05 , 4.73233701422e-06 ,
 1.12345514716e-06 , 2.43370601066e-07 , 4.39177078511e-08 , 6.35307734343e-09 ,
 7.26529549778e-10 , 6.62587048825e-11 , 2.56397056831e-11 , 3.69438919531e-10 ,
 5.05737520269e-09 , 5.40446545906e-08 , 4.50377160728e-07 , 2.92599477414e-06 ,
 1.48165813204e-05 , 5.84687401733e-05 , 0.000179779805322 , 0.000430677859197 ,
 0.000803751579599 , 0.0011684764718   , 0.00132319671667  , 0.00116712552982  ,
 0.00080183627036  , 0.000429060051805 , 0.000178815993562 , 5.80422204074e-05 ,
 1.46732386101e-05 , 2.88900527876e-06 , 4.43004804572e-07 , 5.29063892576e-08 ,
 4.92145004003e-09 , 3.5712045657e-10  , 2.07289978148e-11 , 1.41056985285e-12 ,
 4.19752619543e-13 , 2.4091517645e-13  , 1.2311921121e-13  , 5.56950627145e-14 ,
 2.77535000338e-14 , 3.84503134759e-14 , 2.10383058715e-13 , 1.28468275924e-12 ,
 6.35624569924e-12 , 2.47898903839e-11 , 7.60168983141e-11 , 1.83217625267e-10 ,
 3.47144922e-10    , 5.17302401346e-10 , 6.06724775873e-10 , 5.60622939772e-10 ,
 4.08562973579e-10 , 2.35095693435e-10 , 1.06923259028e-10 , 3.8466629923e-11  ,
 1.09514348451e-11 , 2.4673889713e-12  , 4.39737032833e-13 , 6.19392682909e-14 ,
 6.88717845989e-15 , 6.03681220459e-16 , 4.16493968525e-17 , 2.2583320923e-18  ,
 9.60997334669e-20 , 3.20512806521e-21 , 8.36836566489e-23 , 1.61079742482e-24 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6.86066280713e-27 ,
 1.10189986845e-21 , 1.98148739385e-19 , 1.95468593151e-17 , 8.86429283863e-16 ,
 3.15848022958e-14 , 8.96885512239e-13 , 2.056871553e-11   , 3.82620998771e-10 ,
 5.80580787448e-09 , 7.235792904e-08   , 7.458925111e-07   , 6.39491408246e-06 ,
 4.57352480539e-05 , 0.000273003853283 , 0.00135976730579  , 0.00565841534178  ,
 0.0197784191043   , 0.0587466136951   , 0.151085098215    , 0.344651112537    ,
 0.713451826079    , 1.35648191848     , 2.36151735638     , 3.71769793221     ,
 5.2326845564      , 6.5688377872      , 7.42744914971     , 7.72429744837     ,
 7.56552876881     , 7.06167809447     , 6.22790001143     , 5.0869298035      ,
 3.79410417918     , 2.59053062983     , 1.65062504635     , 1.0073108964      ,
 0.598338593535    , 0.344288733654    , 0.187720092381    , 0.0942713423538   ,
 0.0424258176614   , 0.0167297959495   , 0.00572229283247  , 0.00173534354594  ,
 0.000507803812561 , 0.000161816178444 , 5.64587927319e-05 , 1.89043691578e-05 ,
 5.41233981633e-06 , 1.25634690776e-06 , 2.31863017953e-07 , 3.37742297184e-08 ,
 3.87039454119e-09 , 3.5118564079e-10  , 9.13450515939e-11 , 1.17358643064e-09 ,
 1.60581363257e-08 , 1.71601892116e-07 , 1.43003176119e-06 , 9.29058092841e-06 ,
 4.70454182134e-05 , 0.000185649190888 , 0.000570834522808 , 0.00136748279262  ,
 0.00255206166552  , 0.00371013144663  , 0.00420139717577  , 0.00370584195308  ,
 0.00254598020039  , 0.00136234595186  , 0.000567774241535 , 0.000184294914486 ,
 4.65902858519e-05 , 9.17314488046e-06 , 1.40664001215e-06 , 1.68006757349e-07 ,
 1.56456949783e-08 , 1.1521985322e-09  , 8.26958704898e-11 , 1.89124979582e-11 ,
 1.20461185547e-11 , 7.40256340354e-12 , 3.83654994947e-12 , 1.78619830855e-12 ,
 9.04615893863e-13 , 9.29115833682e-13 , 3.92550720652e-12 , 2.3191015061e-11  ,
 1.14375279769e-10 , 4.45772570901e-10 , 1.36634295034e-09 , 3.29188390961e-09 ,
 6.23476397233e-09 , 9.28717795686e-09 , 1.08881568671e-08 , 1.00564922484e-08 ,
 7.32546561669e-09 , 4.21316796144e-09 , 1.91519601422e-09 , 6.88644199064e-10 ,
 1.95951899978e-10 , 4.41253137118e-11 , 7.86004466423e-12 , 1.10661127077e-12 ,
 1.22994725103e-13 , 1.07768099878e-14 , 7.43276825288e-16 , 4.02912035458e-17 ,
 1.71413429605e-18 , 5.71591593719e-20 , 1.49215423193e-21 , 2.87048498819e-23 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.56590793499e-25 ,
 1.19370830854e-20 , 1.17946273326e-18 , 9.69878348724e-17 , 4.09351615909e-15 ,
 1.37765453051e-13 , 3.73376941149e-12 , 8.15137796803e-11 , 1.43221855376e-09 ,
 2.02782442523e-08 , 2.32342153956e-07 , 2.1704426693e-06  , 1.67047036308e-05 ,
 0.000107235590861 , 0.00058107237496  , 0.00268217110758  , 0.0106028424112   ,
 0.036002788982    , 0.105442362802    , 0.268708745546    , 0.604785496828    ,
 1.22417606164     , 2.26012803126     , 3.81787134966     , 5.8553975966      ,
 8.06436870918     , 9.9182254493      , 10.9463420225     , 11.0146270473     ,
 10.3243334954     , 9.15547949402     , 7.67862020271     , 6.01327748624     ,
 4.35047148453     , 2.91823491241     , 1.84794049802     , 1.1265358401      ,
 0.664439439134    , 0.374165924324    , 0.196755801461    , 0.09447048124     ,
 0.040687187248    , 0.0156858527877   , 0.00565460395031  , 0.00215299878667  ,
 0.000963168154326 , 0.000465343019535 , 0.000205802880469 , 7.5750070756e-05  ,
 2.23889467342e-05 , 5.24937715263e-06 , 9.71764940141e-07 , 1.41682776515e-07 ,
 1.62406053211e-08 , 1.46868359569e-09 , 2.69432775274e-10 , 2.92572341721e-09 ,
 4.00009977461e-08 , 4.27461173657e-07 , 3.56221625914e-06 , 2.31428834921e-05 ,
 0.000117190371726 , 0.000462453061679 , 0.0014219516472   , 0.00340640646596  ,
 0.00635719835442  , 0.00924195596284  , 0.0104657013477   , 0.00923127081347  ,
 0.00634204939691  , 0.00339361058014  , 0.00141432850423  , 0.000459079637401 ,
 0.000116056809598 , 2.28506385506e-05 , 3.50433631347e-06 , 4.18947194968e-07 ,
 3.94208974839e-08 , 3.30162255151e-09 , 6.08921015946e-10 , 3.94243310786e-10 ,
 2.8886875651e-10  , 1.79701895814e-10 , 9.43858422265e-11 , 4.54097830616e-11 ,
 2.38362051818e-11 , 1.98802320369e-11 , 5.9295447464e-11  , 3.28399769374e-10 ,
 1.6095113889e-09  , 6.26656185443e-09 , 1.91970176776e-08 , 4.62278325429e-08 ,
 8.75124060122e-08 , 1.30293122307e-07 , 1.52676309656e-07 , 1.40938691953e-07 ,
 1.02605248059e-07 , 5.89763075429e-08 , 2.6791837733e-08  , 9.62709457652e-09 ,
 2.73752452959e-09 , 6.16040496578e-10 , 1.09665926263e-10 , 1.54307118925e-11 ,
 1.7141363265e-12  , 1.50121799417e-13 , 1.03496655457e-14 , 5.60834728382e-16 ,
 2.3853012742e-17  , 7.95206895148e-19 , 2.07549970698e-20 , 3.98966361701e-22 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.78571694113e-24 ,
 1.01008937197e-19 , 6.9310018151e-18  , 4.46209331309e-16 , 1.73586156727e-14 ,
 5.4726529733e-13  , 1.40805762017e-11 , 2.94446841304e-10 , 4.97987093389e-09 ,
 6.78817856147e-08 , 7.45211172392e-07 , 6.60647493413e-06 , 4.76183007381e-05 ,
 0.000282213157324 , 0.00139644245086  , 0.00587026052831  , 0.0212994076389   ,
 0.0674391589733   , 0.187427553574    , 0.459290911453    , 1.00017209382     ,
 1.95958936102     , 3.49797642049     , 5.72144757772     , 8.5391037638      ,
 11.5175023593     , 13.9391824857     , 15.1531105308     , 14.9542847336     ,
 13.6227823651     , 11.6211183576     , 9.31846371122     , 6.97804486296     ,
 4.85080627516     , 3.14952637996     , 1.94727775646     , 1.16869025442     ,
 0.682838800234    , 0.382899682301    , 0.201822612542    , 0.0980165973107   ,
 0.0434345296175   , 0.0181282348572   , 0.00803115553963  , 0.00429670324106  ,
 0.00257092204127  , 0.00143073662175  , 0.000665421623998 , 0.000248849327376 ,
 7.3907560459e-05  , 1.73537508566e-05 , 3.21391162785e-06 , 4.6864568144e-07  ,
 5.37208387677e-08 , 4.8482099651e-09  , 6.6651511863e-10  , 5.73323840711e-09 ,
 7.8281014618e-08  , 8.36527954102e-07 , 6.97114410183e-06 , 4.52898880954e-05 ,
 0.000229337836106 , 0.000905005956581 , 0.00278271421972  , 0.00666622928398  ,
 0.0124408353078   , 0.0180862143426   , 0.0204810452022   , 0.0180653038535   ,
 0.0124111893253   , 0.00664118832884  , 0.0027677965729   , 0.000898405815612 ,
 0.000227122652591 , 4.47231841066e-05 , 6.86489287508e-06 , 8.27865143331e-07 ,
 8.5330751215e-08  , 1.44669941998e-08 , 8.76489003456e-09 , 7.3519339896e-09  ,
 5.49900773921e-09 , 3.44498442578e-09 , 1.83697717043e-09 , 9.16517359235e-10 ,
 5.03758158868e-10 , 3.72761172743e-10 , 7.45881386155e-10 , 3.66385748191e-09 ,
 1.77341916102e-08 , 6.893235662e-08   , 2.11015780204e-07 , 5.07829667286e-07 ,
 9.60782845132e-07 , 1.42960130319e-06 , 1.67414103707e-06 , 1.54440416282e-06 ,
 1.12354548626e-06 , 6.45310175954e-07 , 2.92917554518e-07 , 1.05166606702e-07 ,
 2.98797003936e-08 , 6.71843985987e-09 , 1.19505185251e-09 , 1.68027413585e-10 ,
 1.86529785303e-11 , 1.6326324968e-12  , 1.12498625554e-13 , 6.09348186268e-15 ,
 2.5906856204e-16  , 8.634164683e-18   , 2.25296880011e-19 , 4.32667722465e-21 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3.8634285635e-23  ,
 6.68656382259e-19 , 3.82298265163e-17 , 1.97066360025e-15 , 6.98855575801e-14 ,
 2.02328200841e-12 , 4.82672041501e-11 , 9.47607526613e-10 , 1.52338532048e-08 ,
 1.99293462649e-07 , 2.11089126864e-06 , 1.80607486027e-05 , 0.00012503003581  ,
 0.000704838884826 , 0.00327430524621  , 0.0127530806962   , 0.0425259347532   ,
 0.123892718445    , 0.320105732368    , 0.739752482637    , 1.53785593768     ,
 2.89723616281     , 4.99047372223     , 7.90265257686     , 11.4818947198     ,
 15.1873017985     , 18.1512732482     , 19.5666037494     , 19.1354579192     ,
 17.1690327776     , 14.2857885208     , 11.0681963815     , 7.95974500439     ,
 5.30089344129     , 3.29955818492     , 1.9659684245      , 1.15085811063     ,
 0.668505545378    , 0.381599896038    , 0.209757951705    , 0.108584008696    ,
 0.0527752835121   , 0.0257080490738   , 0.0144264791682   , 0.00957145976985  ,
 0.00637336270373  , 0.00367928736144  , 0.00172995160638  , 0.000648960013568 ,
 0.000192904927243 , 4.53051828857e-05 , 8.39099707513e-06 , 1.22357230673e-06 ,
 1.40257725384e-07 , 1.26425373754e-08 , 1.39145310567e-09 , 8.84758926265e-09 ,
 1.2052947141e-07  , 1.28799487219e-06 , 1.07334101723e-05 , 6.97324482826e-05 ,
 0.000353109479136 , 0.00139342982985  , 0.00428452097305  , 0.0102639354685   ,
 0.0191550463291   , 0.0278471875166   , 0.0315344878596   , 0.0278149919499   ,
 0.0191094013432   , 0.0102253828335   , 0.00426156103366  , 0.00138328962722  ,
 0.000349743569565 , 6.89334801892e-05 , 1.0668932215e-05  , 1.38820110353e-06 ,
 2.48965531514e-07 , 1.39201808826e-07 , 1.25766924516e-07 , 1.09819387128e-07 ,
 8.27738013623e-08 , 5.22409423036e-08 , 2.83391137693e-08 , 1.47043672677e-08 ,
 8.4965195666e-09  , 5.95285799593e-09 , 8.10537806822e-09 , 3.24622675998e-08 ,
 1.53255231262e-07 , 5.93985316892e-07 , 1.81658459556e-06 , 4.36848042401e-06 ,
 8.25886680203e-06 , 1.22797303405e-05 , 1.43691416367e-05 , 1.32447493834e-05 ,
 9.62702933201e-06 , 5.5241198507e-06  , 2.50501375196e-06 , 8.98455953779e-07 ,
 2.55001907171e-07 , 5.72782437134e-08 , 1.01784072543e-08 , 1.42979345439e-09 ,
 1.5859067434e-10  , 1.3870597255e-11  , 9.55154978869e-13 , 5.17075220188e-14 ,
 2.19737062734e-15 , 7.32055741174e-17 , 1.90960592184e-18 , 3.66287472927e-20 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4.17823894016e-22 ,
 3.4720823058e-18  , 1.82874456461e-16 , 8.12981700022e-15 , 2.66677801841e-13 ,
 7.09154082472e-12 , 1.54843665316e-10 , 2.7940231524e-09  , 4.17191085377e-08 ,
 5.13693921129e-07 , 5.18413134149e-06 , 4.2626339657e-05  , 0.000284635611192 ,
 0.00154515850746  , 0.00686454386744  , 0.0252879812383   , 0.0787874944032   ,
 0.212700113537    , 0.509452007373    , 1.10148817917     , 2.17044084379     ,
 3.91919326987     , 6.51720157645     , 10.0134661728     , 14.1958009259     ,
 18.4527468158     , 21.832518508      , 23.4214548417     , 22.8233209307     ,
 20.331875254      , 16.6746058715     , 12.6279467191     , 8.81686917675     ,
 5.67651475168     , 3.41210205608     , 1.97186263399     , 1.13433337814     ,
 0.661586890223    , 0.388806675839    , 0.225089969586    , 0.125157639637    ,
 0.0672452469843   , 0.0380465075303   , 0.0252925336677   , 0.018674607003    ,
 0.0129486338856   , 0.00756304576951  , 0.00356654387293  , 0.00133878574949  ,
 0.000397994893132 , 9.34708399066e-05 , 1.73113919677e-05 , 2.52430282034e-06 ,
 2.8935697692e-07  , 2.60630270274e-08 , 2.44461814163e-09 , 1.07755809738e-08 ,
 1.46226827894e-07 , 1.56258120588e-06 , 1.30216546044e-05 , 8.45986356212e-05 ,
 0.000428388517763 , 0.00169049367034  , 0.00519793349493  , 0.0124520930807   ,
 0.0232386905214   , 0.03378390018     , 0.0382572924293   , 0.0337448424246   ,
 0.0231833223523   , 0.0124053523524   , 0.00517017624781  , 0.00167843774224  ,
 0.000424803152356 , 8.44443357766e-05 , 1.40410498813e-05 , 2.94917060798e-06 ,
 1.63072740716e-06 , 1.51583584612e-06 , 1.4678500777e-06  , 1.29959764413e-06 ,
 9.86432935267e-07 , 6.27850311192e-07 , 3.4722418677e-07  , 1.87748537048e-07 ,
 1.1404173079e-07  , 7.8626101626e-08  , 7.84443640339e-08 , 2.31714002002e-07 ,
 1.0413272339e-06  , 4.01476721187e-06 , 1.22625090713e-05 , 2.94613325026e-05 ,
 5.56491488671e-05 , 8.26680354294e-05 , 9.66435757654e-05 , 8.89924532055e-05 ,
 6.4615627048e-05  , 3.70349395907e-05 , 1.6773858979e-05  , 6.0086000328e-06  ,
 1.70319742313e-06 , 3.82086932995e-07 , 6.78147102754e-08 , 9.51530740334e-09 ,
 1.05432980901e-09 , 9.2128370307e-11  , 6.33904503952e-12 , 3.42931120863e-13 ,
 1.45649070395e-14 , 4.85001399692e-16 , 1.26465987601e-17 , 2.42214690975e-19 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3.52491056337e-21 ,
 1.42092332441e-17 , 7.21026540136e-16 , 2.95169607538e-14 , 9.20029218956e-13 ,
 2.29551121441e-11 , 4.63970795125e-10 , 7.67996525348e-09 , 1.05047370179e-07 ,
 1.19279868112e-06 , 1.12346930869e-05 , 8.73545559233e-05 , 0.000557499918254 ,
 0.00291013438121  , 0.0124396963216   , 0.0438824356252   , 0.129747730923    ,
 0.329113563469    , 0.736457095398    , 1.49176127963     , 2.78237974284     ,
 4.81494746949     , 7.74892383398     , 11.5991226265     , 16.1081128784     ,
 20.6340418582     , 24.2066069195     , 25.8704123687     , 25.1593156796     ,
 22.329982357      , 18.168015607      , 13.5856839706     , 9.33884546288     ,
 5.92171784088     , 3.52171721583     , 2.03139025613     , 1.17815534692     ,
 0.697295963818    , 0.417274388422    , 0.247687375153    , 0.14366677231     ,
 0.083204370357    , 0.0526086252432   , 0.038681205164    , 0.0299877347036   ,
 0.0210903060903   , 0.0123505124184   , 0.00582392773235  , 0.00218532923323  ,
 0.000649479620489 , 0.000152509818057 , 2.82435663335e-05 , 4.11824510937e-06 ,
 4.72058713227e-07 , 4.2500826937e-08  , 3.57817031218e-09 , 1.03833788451e-08 ,
 1.39979567669e-07 , 1.49579143443e-06 , 1.24650661587e-05 , 8.09826110218e-05 ,
 0.000410077780161 , 0.0016182363975   , 0.00497575668049  , 0.0119198495719   ,
 0.0222453923065   , 0.0323398652239   , 0.036622052051    , 0.0323024913817   ,
 0.0221924625516   , 0.0118753860784   , 0.00495005590488  , 0.00160886770768  ,
 0.000411005597289 , 8.79305344156e-05 , 2.29915859699e-05 , 1.39079204799e-05 ,
 1.33976921234e-05 , 1.37158039304e-05 , 1.36054046262e-05 , 1.2190042013e-05  ,
 9.32381011477e-06 , 5.99233794141e-06 , 3.38581170986e-06 , 1.91012218364e-06 ,
 1.21655680898e-06 , 8.41245111697e-07 , 6.78998273744e-07 , 1.36509665032e-06 ,
 5.58525272942e-06 , 2.13186912631e-05 , 6.49944421325e-05 , 0.000155976851049 ,
 0.000294311832006 , 0.00043673881656  , 0.00051000040248  , 0.000469063584393 ,
 0.000340140343186 , 0.000194685531312 , 8.8048089959e-05  , 3.14918634897e-05 ,
 8.91283553517e-06 , 1.99638443492e-06 , 3.53802085576e-07 , 4.9573951996e-08  ,
 5.48597548317e-09 , 4.78826104986e-10 , 3.29138699253e-11 , 1.77907995873e-12 ,
 7.55072488638e-14 , 2.51286652185e-15 , 6.54924009104e-17 , 1.25201191868e-18 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.32073026227e-20 ,
 4.62145021823e-17 , 2.29949556945e-15 , 9.01139168776e-14 , 2.72644062199e-12 ,
 6.53623668711e-11 , 1.25211540743e-09 , 1.93572883489e-08 , 2.44261251081e-07 ,
 2.54317024044e-06 , 2.20138462188e-05 , 0.000158796505321 , 0.000952231710209 ,
 0.00472559036319  , 0.0193550988867   , 0.0655861253053   , 0.185752577764    ,
 0.448386860466    , 0.948720582272    , 1.81500316871     , 3.21862535319     ,
 5.35663028075     , 8.38087596726     , 12.2878456412     , 16.7981245863     ,
 21.2719843562     , 24.7716330538     , 26.3681416505     , 25.5840860114     ,
 22.650369585      , 18.3606186193     , 13.6739293061     , 9.38677815765     ,
 5.98980759582     , 3.6306949062      , 2.16196230967     , 1.29675972395     ,
 0.782181027566    , 0.467543044674    , 0.275380818214    , 0.161264121829    ,
 0.0974865341712   , 0.0655532090299   , 0.050137661848    , 0.0391981056926   ,
 0.0274756663467   , 0.016023894638    , 0.00753634952207  , 0.00282391188011  ,
 0.000838676034956 , 0.000196869530287 , 3.64526944858e-05 , 5.31482363883e-06 ,
 6.09195573936e-07 , 5.48331992919e-08 , 4.3067694517e-09  , 7.94059014077e-09 ,
 1.05857934218e-07 , 1.13113335368e-06 , 9.4262138252e-06  , 6.12399000531e-05 ,
 0.000310105119501 , 0.00122372734085  , 0.00376271940432  , 0.00901391532168  ,
 0.0168221993102   , 0.0244557478572   , 0.0276939984847   , 0.024427593079    ,
 0.0167826985289   , 0.0089823001513   , 0.00374944283772  , 0.0012318138668   ,
 0.000340940730944 , 0.000115197064014 , 8.28614700755e-05 , 8.71127980881e-05 ,
 9.34793607899e-05 , 9.88547918249e-05 , 0.000100079206167 , 9.07899254706e-05 ,
 7.00392212298e-05 , 4.55208590819e-05 , 2.63361109472e-05 , 1.55075742052e-05 ,
 1.0313449749e-05  , 7.20597770967e-06 , 5.13069786741e-06 , 6.87227582214e-06 ,
 2.38056527663e-05 , 8.91056170447e-05 , 0.000270888960187 , 0.000649201586403 ,
 0.00122345469803  , 0.00181324157036  , 0.00211461580897  , 0.001942138283    ,
 0.0014061973625   , 0.000803547240806 , 0.000362778522539 , 0.000129517778039 ,
 3.65880215288e-05 , 8.18017844856e-06 , 1.44710521058e-06 , 2.02423072819e-07 ,
 2.23660121081e-08 , 1.94945160298e-09 , 1.33841178099e-10 , 7.22700108884e-12 ,
 3.06460509056e-13 , 1.01916181125e-14 , 2.65465245124e-16 , 5.06324514577e-18 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.19304019006e-19 ,
 1.21192140257e-16 , 5.94553293646e-15 , 2.27247134072e-13 , 6.75205781406e-12 ,
 1.58022530188e-10 , 2.92782789259e-09 , 4.32395962651e-08 , 5.13747189487e-07 ,
 4.966888207e-06   , 3.95460225521e-05 , 0.000261933303288 , 0.00145149542893  ,
 0.00673410301749  , 0.0261042543461   , 0.0845047466285   , 0.22967965535     ,
 0.531927505933    , 1.07680219321     , 1.9688014547      , 3.35160465657     ,
 5.4056407105      , 8.279093825       , 11.9666031679     , 16.1898442933     ,
 20.3369268374     , 23.5395478578     , 24.9526442733     , 24.1473122723     ,
 21.3473335556     , 17.3061596468     , 12.9362510316     , 8.98235771219     ,
 5.87457855189     , 3.70930717957     , 2.32326182329     , 1.45391920145     ,
 0.892986115054    , 0.529405276401    , 0.305512176492    , 0.177174230349    ,
 0.108194780899    , 0.0732810414689   , 0.0550689737609   , 0.0418620847759   ,
 0.0287270345305   , 0.0165515507481   , 0.00773639729219  , 0.00289012516946  ,
 0.000857102102346 , 0.000201056992363 , 3.72159658236e-05 , 5.42528056994e-06 ,
 6.21819712783e-07 , 5.59678621526e-08 , 4.21710377601e-09 , 4.8431688912e-09  ,
 6.32996011883e-08 , 6.76307664303e-07 , 5.63594473092e-06 , 3.66154065758e-05 ,
 0.00018541220597  , 0.000731667978592 , 0.00224973425236  , 0.00538943046083  ,
 0.010058014039    , 0.0146221355544   , 0.0165583874776   , 0.0146059469265   ,
 0.010037476325    , 0.00538206979661  , 0.00227654713271  , 0.000820753978927 ,
 0.000369019106991 , 0.000333453761497 , 0.000404458983146 , 0.00047086069493  ,
 0.000521234941659 , 0.000566238570352 , 0.00058537964437  , 0.000538094662744 ,
 0.00041915439034  , 0.000276017882303 , 0.000163893821527 , 0.000100674528368 ,
 6.95482140448e-05 , 4.91542487337e-05 , 3.2713774634e-05  , 3.06505325529e-05 ,
 8.15758005171e-05 , 0.000293865147169 , 0.000889213324939 , 0.00212745740763  ,
 0.00400355469488  , 0.00592494263302  , 0.00689919449032  , 0.00632612400025  ,
 0.00457232108796  , 0.00260779663843  , 0.00117494954829  , 0.000418579963361 ,
 0.000117987267347 , 2.63212500408e-05 , 4.64641420125e-06 , 6.48638660876e-07 ,
 7.15363662031e-08 , 6.22486383422e-09 , 4.26752428802e-10 , 2.3014581417e-11  ,
 9.74907550822e-13 , 3.23931794178e-14 , 8.43152413914e-16 , 1.60366544682e-17 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4.79208126656e-19 ,
 2.62178932564e-16 , 1.2676773745e-14  , 4.75904458123e-13 , 1.39483976971e-11 ,
 3.2118793407e-10  , 5.82616873424e-09 , 8.35880904239e-08 , 9.54305805496e-07 ,
 8.74482610419e-06 , 6.50406766402e-05 , 0.000397704361001 , 0.0020241747981   ,
 0.00865498734118  , 0.0312397692044   , 0.0953826272462   , 0.247286655352    ,
 0.550358612273    , 1.07470236907     , 1.90055439248     , 3.14463739255     ,
 4.96823243608     , 7.51400328468     , 10.7826436439     , 14.5165237656     ,
 18.157082656      , 20.9351465536     , 22.1259522226     , 21.3816559016     ,
 18.9201477021     , 15.4092722627     , 11.6428675215     , 8.2539129273      ,
 5.58751592543     , 3.69816837007     , 2.43335789073     , 1.57978061222     ,
 0.986082640054    , 0.58260123656     , 0.330986750421    , 0.188818078241    ,
 0.113441066705    , 0.0740408056676   , 0.0521400950412   , 0.0371325245202   ,
 0.0243669226339   , 0.0136918617529   , 0.00631823630463  , 0.00234548620753  ,
 0.000693454308899 , 0.000162427875863 , 3.00442041347e-05 , 4.37846647225e-06 ,
 5.01978358403e-07 , 4.53833854244e-08 , 3.49933437396e-09 , 2.49382642255e-09 ,
 3.00192048348e-08 , 3.1989364006e-07  , 2.66547721856e-06 , 1.73168685212e-05 ,
 8.76887076832e-05 , 0.000346034497169 , 0.00106398769026  , 0.00254887424835  ,
 0.00475684009439  , 0.00691546695015  , 0.00783168874445  , 0.00691094648054  ,
 0.0047617063272   , 0.00259874030702  , 0.00123391177339  , 0.000762284676845 ,
 0.000896441102623 , 0.00130111667912  , 0.0017196929025   , 0.00204222682579  ,
 0.00231458374822  , 0.0025846099948   , 0.00273039062184  , 0.00254540278938  ,
 0.00200532983151  , 0.00134135019574  , 0.000819416083786 , 0.000524212739248 ,
 0.000373796307167 , 0.00026664057729  , 0.000171324682371 , 0.000123232111435 ,
 0.000229281736318 , 0.000767277278805 , 0.00230259535305  , 0.00549720598648  ,
 0.010328049254    , 0.0152597520016   , 0.0177384063888   , 0.0162349213429   ,
 0.011710539441    , 0.00666451411929  , 0.00299571004938  , 0.00106460772428  ,
 0.00029932562644  , 6.66051820753e-05 , 1.17283795772e-05 , 1.63341434829e-06 ,
 1.79751527399e-07 , 1.56107206898e-08 , 1.06836613778e-09 , 5.75311349937e-11 ,
 2.43399194754e-12 , 8.0789834435e-14  , 2.10104564686e-15 , 3.98275750771e-17 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.50514100142e-18 ,
 4.82420725833e-16 , 2.29145141281e-14 , 8.45688803982e-13 , 2.44534568056e-11 ,
 5.55401357562e-10 , 9.91917249698e-09 , 1.39579040699e-07 , 1.55290008787e-06 ,
 1.37343178535e-05 , 9.73382591304e-05 , 0.000558881354981 , 0.00263515013456  ,
 0.0103548094505   , 0.0343716996537   , 0.0973997552133   , 0.237662977487    ,
 0.50499958921     , 0.952659441673    , 1.64236379099     , 2.66984143524     ,
 4.17505169387     , 6.28798211875     , 9.01638634412     , 12.1399527205     ,
 15.1798025214     , 17.4912724769     , 18.4870155035     , 17.9023853743     ,
 15.92881596       , 13.1069162592     , 10.0686865342     , 7.31574179456     ,
 5.12002114878     , 3.52195113856     , 2.401783027       , 1.60027672118     ,
 1.01365925391     , 0.601543691669    , 0.339947857934    , 0.191341179594    ,
 0.112150045203    , 0.0694004025008   , 0.0446240636807   , 0.0286848417324   ,
 0.017351997768    , 0.00926006218843  , 0.004151542531    , 0.0015178969259   ,
 0.000445291361753 , 0.000103891589066 , 1.91814177298e-05 , 2.79643765845e-06 ,
 3.24729601285e-07 , 3.33877243166e-08 , 5.80868784482e-09 , 3.567080839e-09   ,
 1.28215255667e-08 , 1.2049878736e-07  , 9.97468069927e-07 , 6.47803902846e-06 ,
 3.28026945228e-05 , 0.000129444889147 , 0.000398018056863 , 0.000953492283045 ,
 0.00177950136703  , 0.00258735103646  , 0.0029321728549   , 0.00259825222505  ,
 0.00183769205031  , 0.00117216156045  , 0.00103635480009  , 0.00162289708632  ,
 0.00286878602202  , 0.00444405803771  , 0.00590554307997  , 0.00708382461221  ,
 0.00822045230629  , 0.00944228825907  , 0.0101981833943   , 0.00965393532085  ,
 0.00771068377431  , 0.00525666398833  , 0.00331148890416  , 0.00219911849111  ,
 0.00160621031551  , 0.00115144267922  , 0.000725458041555 , 0.000440786640036 ,
 0.00054526112061  , 0.00159440613719  , 0.00471122157124  , 0.011215134515    ,
 0.0210322628301   , 0.0310195339799   , 0.0359898094314   , 0.0328720479857   ,
 0.0236584005711   , 0.0134314563174   , 0.00602169020021  , 0.0021340488674   ,
 0.000598288897263 , 0.000132744051966 , 2.33081501422e-05 , 3.23731930429e-06 ,
 3.55358198152e-07 , 3.07912199268e-08 , 2.103057182e-09   , 1.13052556939e-10 ,
 4.77593316428e-12 , 1.58330142453e-13 , 4.11340939249e-15 , 7.76645172862e-17 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3.70020611844e-18 ,
 7.7740296892e-16  , 3.61605209054e-14 , 1.31046302473e-12 , 3.73295712172e-11 ,
 8.36271387819e-10 , 1.47340859731e-08 , 2.04304021387e-07 , 2.23317978634e-06 ,
 1.93004591072e-05 , 0.000132537681368 , 0.000728617554758 , 0.00324155070622  ,
 0.0118417138441   , 0.0361568740405   , 0.0940706754999   , 0.212538471923    ,
 0.424919179552    , 0.768239375613    , 1.29043614255     , 2.06996793878     ,
 3.2224455046      , 4.8579216176      , 6.98982958929     , 9.44624570185     ,
 11.8475281868     , 13.6910311827     , 14.5322199136     , 14.177714953      ,
 12.7657883525     , 10.6796248715     , 8.37233076192     , 6.22250722545     ,
 4.45850160935     , 3.13684126362     , 2.18185934174     , 1.47837005793     ,
 0.950577595617    , 0.571516572717    , 0.32598469593     , 0.184360362721    ,
 0.107788678823    , 0.0648940411208   , 0.0386402012898   , 0.021947049639    ,
 0.0115986598431   , 0.00553909456185  , 0.00230328740396  , 0.000804918846588 ,
 0.000230241879163 , 5.30161715493e-05 , 9.76074871194e-06 , 1.47517983959e-06 ,
 2.3537269493e-07  , 8.48060963571e-08 , 5.87170948487e-08 , 4.1679915179e-08  ,
 2.90499341685e-08 , 4.89806400934e-08 , 3.00881169661e-07 , 1.91803118206e-06 ,
 9.70192225524e-06 , 3.82829861497e-05 , 0.000117716348358 , 0.000282036507869 ,
 0.000526599173088 , 0.000767057960872 , 0.000876859907547 , 0.000813555230254 ,
 0.000725719554274 , 0.000963231113168 , 0.00202047870481  , 0.00436545923348  ,
 0.00804828941478  , 0.0123785491494   , 0.0163582283922   , 0.0197915620737   ,
 0.0235236678064   , 0.0277965271574   , 0.0307080983919   , 0.0295736256809   ,
 0.0240312181892   , 0.0167694770901   , 0.0109124561359   , 0.00748000873295  ,
 0.00554274498547  , 0.00396917121531  , 0.0024665624813   , 0.00135917916999  ,
 0.0011404730521   , 0.00266116266438  , 0.00762994888053  , 0.0180855652688   ,
 0.0338471575486   , 0.0498235733936   , 0.0576895691528   , 0.052576176778    ,
 0.0377486823229   , 0.0213744777021   , 0.00955545044536  , 0.00337610487721  ,
 0.000943506930446 , 0.000208665066225 , 3.6522448566e-05  , 5.0572042301e-06  ,
 5.53545166813e-07 , 4.78397637713e-08 , 3.25999399782e-09 , 1.74897090367e-10 ,
 7.37609292533e-12 , 2.44184416866e-13 , 6.33646594283e-15 , 1.19085730145e-16 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7.12773972804e-18 ,
 1.11039879786e-15 , 5.05808121383e-14 , 1.80056734097e-12 , 5.05155346263e-11 ,
 1.11645981916e-09 , 1.94277926006e-08 , 2.66141333845e-07 , 2.87168519075e-06 ,
 2.44409256297e-05 , 0.000164526515487 , 0.000880005622564 , 0.00376740582178  ,
 0.013054446362    , 0.0372136080837   , 0.0892303329944   , 0.185020550667    ,
 0.342283661062    , 0.583436842489    , 0.944785138415    , 1.4889279044      ,
 2.30594335989     , 3.48197531017     , 5.03225351021     , 6.83310208206     ,
 8.60804360124     , 9.99973420227     , 10.7023689803     , 10.5807813598     ,
 9.70590266509     , 8.2995122615      , 6.64677823422     , 5.02490007379     ,
 3.64119605846     , 2.58092768324     , 1.8096249108      , 1.24206816807     ,
 0.814761705433    , 0.503534659828    , 0.29779425771     , 0.176590442639    ,
 0.108841045495    , 0.0677260619184   , 0.0395731203893   , 0.020547118386    ,
 0.00930230891112  , 0.0036866966498   , 0.00128697277747  , 0.000393031337113 ,
 0.000102909080713 , 2.27517389782e-05 , 4.56396298505e-06 , 1.35412807438e-06 ,
 9.48342887613e-07 , 8.52881355645e-07 , 7.06029831502e-07 , 5.13949757867e-07 ,
 3.24180445981e-07 , 1.80534678292e-07 , 1.45568181474e-07 , 4.77319716504e-07 ,
 2.27959087692e-06 , 8.95722624707e-06 , 2.75522638247e-05 , 6.62052427375e-05 ,
 0.000124799884311 , 0.000187748208513 , 0.000241435474329 , 0.00033358264208  ,
 0.000681427349344 , 0.00182563979158  , 0.00470527483155  , 0.0102938247075   ,
 0.0186322016479   , 0.0281705102022   , 0.0369504043107   , 0.0450864249036   ,
 0.0548812784697   , 0.0666726348815   , 0.0753730232439   , 0.0740439761036   ,
 0.0614978768162   , 0.0441379739019   , 0.02967088177     , 0.0208062553532   ,
 0.0154550189619   , 0.0109689513388   , 0.00672578450012  , 0.0035091468895   ,
 0.00216483016521  , 0.00363036959312  , 0.00980538507203  , 0.023073014206    ,
 0.0430775619147   , 0.0632823958536   , 0.0731183238858   , 0.0664843868491   ,
 0.047614037279    , 0.0268857448779   , 0.0119829240188   , 0.00422005014399  ,
 0.00117535029676  , 0.000259035216676 , 4.51818509611e-05 , 6.23534686599e-06 ,
 6.80359003402e-07 , 5.86309867805e-08 , 3.98514834492e-09 , 2.13325867401e-10 ,
 8.97970957967e-12 , 2.96798510157e-13 , 7.69157237465e-15 , 1.43794741475e-16 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.07721826758e-17 ,
 1.38786609799e-15 , 6.21510152972e-14 , 2.18007510374e-12 , 6.03754877915e-11 ,
 1.31910018803e-09 , 2.2717960353e-08  , 3.08247348642e-07 , 3.29476064382e-06 ,
 2.77569300248e-05 , 0.000184567342669 , 0.000971282897429 , 0.00406407210451  ,
 0.0136250522642   , 0.0370577468916   , 0.0833896891764   , 0.159900218365    ,
 0.272037973844    , 0.430541757158    , 0.662090320156    , 1.01590479907     ,
 1.55946334697     , 2.35459791018     , 3.4112358537      , 4.64210257857     ,
 5.86127047994     , 6.8428610122      , 7.40281560849     , 7.45088583617     ,
 6.99598453811     , 6.1282137942      , 5.00388856624     , 3.82428585883     ,
 2.77841590683     , 1.96840873541     , 1.38689309954     , 0.968798045092    ,
 0.657660043158    , 0.428964154283    , 0.274152190645    , 0.179446236903    ,
 0.121932180749    , 0.0810955864971   , 0.0484341564158   , 0.0244656332346   ,
 0.0101815993701   , 0.00348151224682  , 0.00099098659928  , 0.000240475364095 ,
 5.20006640175e-05 , 1.25192347347e-05 , 6.87224680514e-06 , 7.5342937751e-06  ,
 8.34974098503e-06 , 8.08744686516e-06 , 6.83699789808e-06 , 5.04949016081e-06 ,
 3.21274211246e-06 , 1.72597818757e-06 , 7.87271742801e-07 , 3.93357491654e-07 ,
 5.7246182982e-07  , 1.80363077352e-06 , 5.44042897323e-06 , 1.38933968117e-05 ,
 3.1521841702e-05  , 7.14415075541e-05 , 0.000180161934678 , 0.000504625385402 ,
 0.00145436449751  , 0.00398696138882  , 0.00975522835694  , 0.0204079867854   ,
 0.0358248323836   , 0.0531416012472   , 0.0692696704307   , 0.0853787543412   ,
 0.106398927705    , 0.132659947662    , 0.153449525369    , 0.154211501816    ,
 0.131570331653    , 0.0975115522997   , 0.0675241066551   , 0.0478458683593   ,
 0.0351121354311   , 0.0244550382505   , 0.0147540630243   , 0.00746407269079  ,
 0.00376219461963  , 0.00419488679806  , 0.0100569872313   , 0.023311101528    ,
 0.0433761042804   , 0.0635821720997   , 0.073306204192    , 0.0664998855481   ,
 0.0475027585188   , 0.0267467556738   , 0.0118838840446   , 0.00417112001155  ,
 0.00115760248798  , 0.00025419188286  , 4.41748358119e-05 , 6.0746691825e-06  ,
 6.60596401911e-07 , 5.67518035908e-08 , 3.84673060158e-09 , 2.05416984532e-10 ,
 8.62881911738e-12 , 2.84701540946e-13 , 7.36729881204e-15 , 1.3693009855e-16  ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.27904903226e-17 ,
 1.47650468167e-15 , 6.53675724131e-14 , 2.26986860985e-12 , 6.22941624244e-11 ,
 1.35001463741e-09 , 2.30827838851e-08 , 3.11159201778e-07 , 3.30557185906e-06 ,
 2.76763286708e-05 , 0.000182759776665 , 0.000953406983255 , 0.00394113306061  ,
 0.0129776041544   , 0.0343487395467   , 0.0742130570754   , 0.134366926265    ,
 0.212656386421    , 0.312158867311    , 0.452603234204    , 0.673447730881    ,
 1.02497192447     , 1.54711336747     , 2.23816766033     , 3.03217544088     ,
 3.81268988025     , 4.45810906362     , 4.87628059768     , 5.0063015722      ,
 4.81392878344     , 4.30884793506     , 3.57161419008     , 2.7502910213      ,
 2.00366268565     , 1.42582651419     , 1.01994309301     , 0.737401265072    ,
 0.53101217182     , 0.377235796224    , 0.268242336843    , 0.195531344365    ,
 0.143879464603    , 0.0997903007663   , 0.0604196691798   , 0.0303347514756   ,
 0.0123030802907   , 0.00399012487011  , 0.00103570585843  , 0.000220717191985 ,
 4.88895766005e-05 , 2.9533790053e-05  , 4.06495238616e-05 , 5.45179303947e-05 ,
 6.22986467329e-05 , 6.12089583911e-05 , 5.24697648493e-05 , 3.92401472825e-05 ,
 2.5203275996e-05  , 1.3622893736e-05  , 6.18303903326e-06 , 2.5942839878e-06  ,
 1.49866253759e-06 , 1.68529809603e-06 , 3.12906990625e-06 , 9.6406886254e-06  ,
 3.87542451865e-05 , 0.000149094236199 , 0.0004936077401   , 0.00140447629134  ,
 0.00356080484197  , 0.00832601338064  , 0.0179727773842   , 0.0347547990048   ,
 0.0584197395457   , 0.084968136118    , 0.110640231641    , 0.138414208645    ,
 0.176472786509    , 0.22487801292     , 0.26554713301     , 0.27337404795     ,
 0.240374178853    , 0.184168906483    , 0.130547248103    , 0.0921348640202   ,
 0.0657370846934   , 0.0444061276647   , 0.0262494902916   , 0.0130792854827   ,
 0.00596533482255  , 0.00443693979071  , 0.00840860846767  , 0.0187203595716   ,
 0.0345754367062   , 0.0505357339292   , 0.0581327727825   , 0.0526129481209   ,
 0.0374873900378   , 0.0210480559828   , 0.00932284705027  , 0.00326118824876  ,
 0.000901824660475 , 0.000197290075664 , 3.41573859171e-05 , 4.67983871727e-06 ,
 5.07130978569e-07 , 4.34263386281e-08 , 2.93490789015e-09 , 1.56322391157e-10 ,
 6.55199615965e-12 , 2.15773632669e-13 , 5.57488128078e-15 , 1.02963519257e-16 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.19493360663e-17 ,
 1.30123879961e-15 , 5.72575976957e-14 , 1.97694547972e-12 , 5.39779752976e-11 ,
 1.16454684482e-09 , 1.98352429773e-08 , 2.66519346017e-07 , 2.82366606028e-06 ,
 2.35854929772e-05 , 0.000155386147941 , 0.000808398596339 , 0.00332857330343  ,
 0.0108895191763   , 0.0284980074839   , 0.0603772873515   , 0.105832811029    ,
 0.15960740346     , 0.220855896314    , 0.30423448261     , 0.441597285001    ,
 0.670509063551    , 1.01349621235     , 1.45683381283     , 1.94702548013     ,
 2.41688606186     , 2.81670797838     , 3.11167497332     , 3.25576746394     ,
 3.19362716399     , 2.9032707728      , 2.43398402379     , 1.8960725365      ,
 1.40572586013     , 1.02880904163     , 0.767617909608    , 0.589363208259    ,
 0.459677520206    , 0.358279128849    , 0.278063732896    , 0.215221559806    ,
 0.162277159995    , 0.112634285284    , 0.0676334645487   , 0.0335960400952   ,
 0.0134559216505   , 0.00429187721475  , 0.00109227281169  , 0.000245634426765 ,
 0.000106135643741 , 0.000147836751129 , 0.000236152655109 , 0.000321521046326 ,
 0.000370323196612 , 0.000367670259818 , 0.000318875852709 , 0.000240973656776 ,
 0.000155984291941 , 8.48306074683e-05 , 3.89501939813e-05 , 1.71109906393e-05 ,
 1.07893093641e-05 , 1.13629346881e-05 , 1.50913041804e-05 , 3.23302524115e-05 ,
 0.00011875195209  , 0.000453266382188 , 0.00145316630839  , 0.00382962839606  ,
 0.00853342976479  , 0.0168651453043   , 0.0308908220847   , 0.0530141990773   ,
 0.0835278505836   , 0.118944657087    , 0.156190184877    , 0.199868447487    ,
 0.260032399683    , 0.335693559521    , 0.401837746015    , 0.422471214282    ,
 0.382345964636    , 0.301830529663    , 0.217171149898    , 0.150698036469    ,
 0.103014640847    , 0.0666872121829   , 0.0385195354327   , 0.0192824283534   ,
 0.00879556257279  , 0.00501720397625  , 0.00627971980708  , 0.0122046622448   ,
 0.0219040628591   , 0.0317859148      , 0.0364519471284   , 0.0329114091012   ,
 0.0233917806276   , 0.0130980734125   , 0.00578410670912  , 0.00201667061935  ,
 0.000555713691033 , 0.000121125378595 , 2.08924214191e-05 , 2.85186959356e-06 ,
 3.07949691434e-07 , 2.62832471816e-08 , 1.7710068434e-09  , 9.40799370196e-11 ,
 3.93418199858e-12 , 1.29310721781e-13 , 3.33550951013e-15 , 6.11969246755e-17 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8.79665875439e-18 ,
 9.31909525202e-16 , 4.09514989905e-14 , 1.41095715534e-12 , 3.84611974146e-11 ,
 8.28919981082e-10 , 1.41139047095e-08 , 1.89729978719e-07 , 2.01278570772e-06 ,
 1.68506541897e-05 , 0.000111378526994 , 0.00058190260761  , 0.00240799106643  ,
 0.00791925845957  , 0.0208141959508   , 0.0441419946371   , 0.0768826225197   ,
 0.113767280209    , 0.152287990015    , 0.202404950316    , 0.28843015744     ,
 0.43774605321     , 0.661172108186    , 0.938649057384    , 1.2277277618      ,
 1.49433460388     , 1.73058987832     , 1.93036470971     , 2.05499617137     ,
 2.04644000885     , 1.8809114795      , 1.59921043197     , 1.28191368155     ,
 0.999666140988    , 0.783705829042    , 0.63078028421     , 0.522428295269    ,
 0.438059959924    , 0.362483171677    , 0.29077111264     , 0.224712843479    ,
 0.164943211873    , 0.110710522785    , 0.0646343684808   , 0.0314595648614   ,
 0.0124199783222   , 0.0039274648018   , 0.00102856365648  , 0.00033972019162  ,
 0.000376944337212 , 0.000684644939894 , 0.0011108610267   , 0.00151401385619  ,
 0.00175198723391  , 0.0017531632364   , 0.00153411968023  , 0.00116847126582  ,
 0.000760816314634 , 0.000416001715948 , 0.000193788807856 , 9.06081644933e-05 ,
 6.50013039469e-05 , 7.22124592362e-05 , 8.60434816549e-05 , 0.000126656648406 ,
 0.000338909463361 , 0.00117264945831  , 0.0036061009021   , 0.00905820307699  ,
 0.0186631927672   , 0.0326313444292   , 0.0511383537878   , 0.0759371987796   ,
 0.109466684005    , 0.152096615457    , 0.203434340788    , 0.267806241718    ,
 0.352858056091    , 0.454730583233    , 0.544454053828    , 0.579078428341    ,
 0.535620606501    , 0.432657080242    , 0.313741459386    , 0.212613780275    ,
 0.138077300304    , 0.0849640069139   , 0.048179750099    , 0.0251645985411   ,
 0.0127889739848   , 0.00714765385736  , 0.0055924500724   , 0.00721792391828  ,
 0.0113214103144   , 0.0159001614628   , 0.0180793768897   , 0.0162672062768   ,
 0.0115323468139   , 0.00644070778938  , 0.00283615184233  , 0.000985773924623 ,
 0.000270730979091 , 5.88017615884e-05 , 1.01059094605e-05 , 1.37453567156e-06 ,
 1.47910664111e-07 , 1.25830416094e-08 , 8.45351953652e-10 , 4.47885991181e-11 ,
 1.86864860157e-12 , 6.12995895158e-14 , 1.57858658741e-15 , 2.87674847725e-17 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5.10989469696e-18 ,
 5.36180789266e-16 , 2.36570679482e-14 , 8.16059511962e-13 , 2.22871093346e-11 ,
 4.81725117075e-10 , 8.2361238503e-09  , 1.11339755876e-07 , 1.18996375248e-06 ,
 1.00579193593e-05 , 6.72884923133e-05 , 0.000356845791816 , 0.00150355811961  ,
 0.00505013416524  , 0.0135878536119   , 0.0295129104198   , 0.0524582613472   ,
 0.0783938228313   , 0.104035897735    , 0.134662297803    , 0.186888434924    ,
 0.279773747851    , 0.418063101224    , 0.582460587782    , 0.742201365874    ,
 0.88302684948     , 1.01551297164     , 1.14463969107     , 1.23924746366     ,
 1.25110362899     , 1.16551073317     , 1.01942230852     , 0.867993096835    ,
 0.743505418144    , 0.647933361692    , 0.5717017261      , 0.506353549211    ,
 0.4426890378      , 0.371861513465    , 0.293617849398    , 0.216617522499    ,
 0.149050948677    , 0.093930031936    , 0.0522254542472   , 0.0245939342922   ,
 0.00951818754951  , 0.0030230152635   , 0.000953952591723 , 0.000739743100536 ,
 0.00137698859657  , 0.00260386117899  , 0.00419521062271  , 0.00569866790139  ,
 0.00660463349841  , 0.00663927397211  , 0.00584186225133  , 0.00447107395894  ,
 0.00292213096467  , 0.0016055156448   , 0.000761871868096 , 0.000384798340112 ,
 0.000314449588579 , 0.000367459876586 , 0.000419181684992 , 0.000484817551483 ,
 0.000882178164138 , 0.00255277445805  , 0.00740298284981  , 0.0179045563603   ,
 0.0351862724642   , 0.0571139001519   , 0.0800800362795   , 0.104461852873    ,
 0.136882116079    , 0.185248879957    , 0.25333315402     , 0.341718838617    ,
 0.449561014404    , 0.567627013373    , 0.667698758046    , 0.708124518921    ,
 0.662303790635    , 0.543619569013    , 0.396498140384    , 0.263275168666    ,
 0.163007551507    , 0.0956049350483   , 0.0542705673809   , 0.0313038786009   ,
 0.0191648589876   , 0.0121274199384   , 0.00766572646651  , 0.00549438716744  ,
 0.00547615308711  , 0.00654178274291  , 0.00713882928553  , 0.00635606757344  ,
 0.00448844603453  , 0.00250000019675  , 0.00109794136723  , 0.000380522324322 ,
 0.000104182466583 , 2.25539270133e-05 , 3.86311993475e-06 , 5.23657491204e-07 ,
 5.61642680274e-08 , 4.7631641349e-09  , 3.19085877222e-10 , 1.68627534447e-11 ,
 7.01971689101e-13 , 2.2983699621e-14  , 5.90920182615e-16 , 1.06970757865e-17 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.34496562932e-18 ,
 2.46273048517e-16 , 1.10048045783e-14 , 3.81689038298e-13 , 1.04960310792e-11 ,
 2.28895917264e-10 , 3.95827752502e-09 , 5.42839801481e-08 , 5.90634244246e-07 ,
 5.10287657037e-06 , 3.5053904907e-05  , 0.000191810674895 , 0.000837970296185 ,
 0.00293115684197  , 0.00823885074431  , 0.0187043561211   , 0.0346077604743   ,
 0.0531878252205   , 0.0708741970488   , 0.0891678118394   , 0.118060613367    ,
 0.170264228928    , 0.248436590082    , 0.338291368865    , 0.419575244792    ,
 0.48732334031     , 0.55563912992     , 0.632218250762    , 0.695947295141    ,
 0.714204700133    , 0.681698974154    , 0.629180037405    , 0.591031613211    ,
 0.574110229121    , 0.562118575341    , 0.539780761536    , 0.502138838035    ,
 0.446542622374    , 0.370769527191    , 0.281342059997    , 0.193917311531    ,
 0.122131208303    , 0.0702972378638   , 0.0362601476344   , 0.0162027679754   ,
 0.00611644328133  , 0.00210401398617  , 0.00123030276764  , 0.00205749287894  ,
 0.00430785815048  , 0.00802695273905  , 0.012742948612    , 0.0171832926773   ,
 0.0198714027355   , 0.0199865953151   , 0.0176120436763   , 0.0134979451474   ,
 0.00883435343726  , 0.004876644369    , 0.00237249431398  , 0.00131755187861  ,
 0.00122136750347  , 0.00148593674222  , 0.00166374306603  , 0.00169470110024  ,
 0.00220285529527  , 0.00488821347734  , 0.0128209141897   , 0.0295331974634   ,
 0.0557655790618   , 0.0863042378134   , 0.113121989117    , 0.135431973865    ,
 0.165390140563    , 0.219828041385    , 0.30593070791     , 0.41661567958     ,
 0.537620668637    , 0.652983557048    , 0.740732205736    , 0.770957844616    ,
 0.721536485375    , 0.599740841582    , 0.442295634544    , 0.291930378061    ,
 0.175586612023    , 0.100055825908    , 0.0586413679799   , 0.0387816416848   ,
 0.0282911561942   , 0.0199519828035   , 0.0123035369961   , 0.00662025517636  ,
 0.00362738347309  , 0.0026169689481   , 0.00234275983057  , 0.00198009050407  ,
 0.00138014981435  , 0.000765308004707 , 0.000335163046603 , 0.000115851596406 ,
 3.1629867869e-05  , 6.82706055708e-06 , 1.16576631176e-06 , 1.57533057202e-07 ,
 1.68447498428e-08 , 1.42444665519e-09 , 9.51701211661e-11 , 5.01742266113e-12 ,
 2.08428965437e-13 , 6.81197491234e-15 , 1.74869913206e-16 , 3.14540577815e-18 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8.50859433637e-19 ,
 8.9978577008e-17  , 4.14277071932e-15 , 1.45526030067e-13 , 4.0644537332e-12  ,
 9.03783733451e-11 , 1.60078238614e-09 , 2.25975019263e-08 , 2.54435524534e-07 ,
 2.28711134714e-06 , 1.64303610025e-05 , 9.44365894215e-05 , 0.000434761576726 ,
 0.00160499197884  , 0.00475769697708  , 0.0113501412424   , 0.0219005107034   ,
 0.0346141902639   , 0.0462889819678   , 0.0563706553208   , 0.0701868086404   ,
 0.095820682025    , 0.135471989743    , 0.180497708697    , 0.21858709382     ,
 0.247750333774    , 0.278714910546    , 0.318372207801    , 0.355531999101    ,
 0.37255233533     , 0.370304446935    , 0.371624235308    , 0.396385405826    ,
 0.43968091158     , 0.478585936677    , 0.493811726212    , 0.478023681966    ,
 0.42968795581     , 0.351695835363    , 0.257032455474    , 0.166358391832    ,
 0.0958384585535   , 0.0496088573204   , 0.0230650514841   , 0.00950388819358  ,
 0.00355437345753  , 0.00176492150917  , 0.00244464754602  , 0.00535005730712  ,
 0.011085369211    , 0.0200626616898   , 0.0312219286375   , 0.0416193155095   ,
 0.0478212888432   , 0.0479036063256   , 0.0420788487041   , 0.0321667860507   ,
 0.0210313223683   , 0.011672475582    , 0.00588284031771  , 0.00366741951988  ,
 0.00382096893844  , 0.00477988046488  , 0.00528914571937  , 0.00505350569149  ,
 0.00525049130039  , 0.00869394932183  , 0.0195659073816   , 0.0417735491411   ,
 0.0749143898075   , 0.111019506353    , 0.139437417202    , 0.160064891865    ,
 0.190408497166    , 0.253492974591    , 0.356139338794    , 0.480751462554    ,
 0.59882958157     , 0.689393836199    , 0.741841213082    , 0.746476395542    ,
 0.693420029449    , 0.584545865017    , 0.44108783828     , 0.295925452038    ,
 0.178128281455    , 0.101510582674    , 0.0624383193087   , 0.0461967931807   ,
 0.0373937240425   , 0.0278421093282   , 0.0173201842047   , 0.00875542106713  ,
 0.00370069012621  , 0.00151066291042  , 0.00078084116539  , 0.000519360574439 ,
 0.000339057183636 , 0.000184996870252 , 8.06076687243e-05 , 2.77824868087e-05 ,
 7.56563820535e-06 , 1.62866476104e-06 , 2.77344222823e-07 , 3.73743982393e-08 ,
 3.9854863035e-09  , 3.36147797935e-10 , 2.24044052845e-11 , 1.17859245726e-12 ,
 4.88656434084e-14 , 1.59439561552e-15 , 4.08717023073e-17 , 7.30809070364e-19 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.44207010838e-19 ,
 2.60903990076e-17 , 1.28238477119e-15 , 4.62217764854e-14 , 1.3306810383e-12  ,
 3.06825113522e-11 , 5.6685860458e-10  , 8.39202224402e-09 , 9.95366687772e-08 ,
 9.45437740695e-07 , 7.18694912586e-06 , 4.36924336984e-05 , 0.000212284623725 ,
 0.000823877851386 , 0.00255392247292  , 0.00632898867229  , 0.0125783429503   ,
 0.0202342835572   , 0.0270230068778   , 0.0319072993285   , 0.0374275289982   ,
 0.0482798824662   , 0.0662532742258   , 0.0869591426615   , 0.103562925704    ,
 0.114762730426    , 0.126650935637    , 0.14399433994     , 0.162399533663    ,
 0.174578126381    , 0.184021979267    , 0.206184685637    , 0.252654772628    ,
 0.316979628357    , 0.378536781677    , 0.417115589374    , 0.420848403637    ,
 0.385660899449    , 0.316224840945    , 0.228320968353    , 0.143702698377    ,
 0.0786853613449   , 0.0376196474416   , 0.0157808734008   , 0.0059123115995   ,
 0.00241898118301  , 0.00239799046948  , 0.00519669115796  , 0.0116690598263   ,
 0.0232955835702   , 0.0407413531574   , 0.061896560936    , 0.0812313320325   ,
 0.092327617564    , 0.0916523274516   , 0.0798400387624   , 0.0606102564278   ,
 0.0394946542716   , 0.0220998250191   , 0.0117384311378   , 0.00839924351117  ,
 0.00968530041215  , 0.0122908775147   , 0.0134249508215   , 0.012357508046    ,
 0.0112777260493   , 0.014665432104    , 0.0275854456717   , 0.0530532827645   ,
 0.0884057451602   , 0.124009505491    , 0.150198472216    , 0.170474004523    ,
 0.206031985596    , 0.28017143379     , 0.394086006366    , 0.51947359476     ,
 0.617917817362    , 0.66810442876     , 0.673447110415    , 0.646497577669    ,
 0.592369132416    , 0.508866822849    , 0.398689432947    , 0.278151108683    ,
 0.172336754584    , 0.100207541507    , 0.0635125149252   , 0.0491694593262   ,
 0.0412454140559   , 0.0312584247374   , 0.0195440605385   , 0.00978386451978  ,
 0.00390952869014  , 0.00128368643703  , 0.000391655122209 , 0.000145152047687 ,
 7.12466155431e-05 , 3.58280312966e-05 , 1.53030637534e-05 , 5.24385014029e-06 ,
 1.42382631186e-06 , 3.05764360516e-07 , 5.19431485693e-08 , 6.98279566534e-09 ,
 7.4284128165e-10  , 6.25095697616e-11 , 4.15736974865e-12 , 2.18275033305e-13 ,
 9.03433680424e-15 , 2.94334667349e-16 , 7.53555156383e-18 , 1.34017421698e-19 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 3.58031790322e-30 , 1.78707115043e-28 , 6.7719903532e-27  , 2.00385275988e-25 ,
 4.63318632995e-24 , 8.37738847138e-23 , 1.18568657101e-21 , 1.31507535862e-20 ,
 1.14447102897e-19 , 7.82603714378e-19 , 4.21119221907e-18 , 1.78581712417e-17 ,
 5.97633476649e-17 , 1.58015277362e-16 , 3.30356027677e-16 , 5.46323986747e-16 ,
 7.14599174692e-16 , 7.38884622891e-16 , 6.03360473813e-16 , 3.88614391835e-16 ,
 1.97143204789e-16 , 7.86534870215e-17 , 2.46430235826e-17 , 6.05508197604e-18 ,
 1.16537951309e-18 , 1.75499591946e-19 , 2.06611961299e-20 , 1.9001136544e-21  ,
 1.36420841621e-22 , 7.64260544486e-24 , 3.33954047487e-25 , 1.13782820598e-26 ,
 3.02204044848e-28 , 6.19773772611e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 5.54387897338e-20 , 5.99310107978e-18 , 3.36761702621e-16 , 1.27046084736e-14 ,
 3.84536732261e-13 , 9.37042030852e-12 , 1.83565608971e-10 , 2.88492672117e-09 ,
 3.62878571134e-08 , 3.64456174809e-07 , 2.91655041682e-06 , 1.85651097742e-05 ,
 9.38892346751e-05 , 0.000377013365447 , 0.0012020787439   , 0.00304617590283  ,
 0.00615226595257  , 0.00997822133864  , 0.0132691984969   , 0.0152829712922   ,
 0.0170934283742   , 0.0210480087528   , 0.0282794982225   , 0.0369064749401   ,
 0.043612229601    , 0.0475013563737   , 0.0513229796867   , 0.057688041944    ,
 0.0654467018764   , 0.0725668445905   , 0.0826306671843   , 0.105334586635    ,
 0.148142234642    , 0.207746505812    , 0.270215007098    , 0.318127271567    ,
 0.33728297492     , 0.320546115193    , 0.270672703969    , 0.200817650429    ,
 0.129491965986    , 0.0718919335205   , 0.0340995157459   , 0.0137760293395   ,
 0.00496187433152  , 0.00251015124166  , 0.00398530695992  , 0.00951735277674  ,
 0.0208142377818   , 0.0399115266496   , 0.0673365666076   , 0.0995838806083   ,
 0.128222193977    , 0.14356808511     , 0.140527296565    , 0.120746225553    ,
 0.0906231955025   , 0.0587785856652   , 0.0334135768844   , 0.019230528415    ,
 0.0160839619571   , 0.0200619596299   , 0.0254573317244   , 0.0273077712308   ,
 0.0244135314419   , 0.020613669513    , 0.022695250335    , 0.0364115441747   ,
 0.0627352643014   , 0.0958118833717   , 0.125428639405    , 0.146028854062    ,
 0.166704863145    , 0.209766050269    , 0.292835197608    , 0.408006988462    ,
 0.519732899606    , 0.587687942048    , 0.595541426613    , 0.55891525632     ,
 0.506597737536    , 0.45512090226     , 0.400040379251    , 0.329151871162    ,
 0.242347917064    , 0.15688548893     , 0.0932847573974   , 0.0586717643923   ,
 0.0444054573619   , 0.0367563838377   , 0.0277457129554   , 0.0173294058873   ,
 0.00865713721924  , 0.00342496630595  , 0.00107476861821  , 0.000274052096638 ,
 6.29124696401e-05 , 1.67895302666e-05 , 6.04788473635e-06 , 2.33611484379e-06 ,
 7.81185028382e-07 , 2.10705594677e-07 , 4.5116328503e-08  , 7.64729445674e-09 ,
 1.02586986509e-09 , 1.08908670453e-10 , 9.14641797807e-12 , 6.07179199693e-13 ,
 3.18249577442e-14 , 1.31524829916e-15 , 4.27943552583e-17 , 1.09439724346e-18 ,
 1.9371353748e-20  , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 1.73694790139e-28 , 8.66950664803e-27 , 3.28522737548e-25 ,
 9.72099214617e-24 , 2.24760071875e-22 , 4.06388465642e-21 , 5.75167609508e-20 ,
 6.37918514468e-19 , 5.5514630253e-18  , 3.79603765607e-17 , 2.04257233758e-16 ,
 8.66145840234e-16 , 2.89846954472e-15 , 7.66321878095e-15 , 1.6020343116e-14  ,
 2.64921412525e-14 , 3.46503003133e-14 , 3.58261341877e-14 , 2.92536893623e-14 ,
 1.8841051117e-14  , 9.55768422906e-15 , 3.81307756701e-15 , 1.19464952482e-15 ,
 2.93533248726e-16 , 5.64933163993e-17 , 8.50745478436e-18 , 1.00155325913e-18 ,
 9.21073338142e-20 , 6.61290392133e-21 , 3.70467777519e-22 , 1.61880206649e-23 ,
 5.51546573866e-25 , 1.46488845973e-26 , 3.00422980045e-28 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 9.94942532713e-21 , 1.08870451556e-18 , 7.83820673575e-17 ,
 3.15783571905e-15 , 1.01965050217e-13 , 2.64819634706e-12 , 5.50949455017e-11 ,
 9.14583808056e-10 , 1.20727034519e-08 , 1.26383542798e-07 , 1.04726390561e-06 ,
 6.86118860417e-06 , 3.55228624112e-05 , 0.000145353066326 , 0.00047036022947  ,
 0.00120534729875  , 0.00245278678817  , 0.00398946568998  , 0.00527978887162  ,
 0.00597178437643  , 0.00645754479186  , 0.00770033550481  , 0.0102377629782   ,
 0.0133941597993   , 0.0158285192473   , 0.0170719667081   , 0.0181316660292   ,
 0.0201360044515   , 0.0229745778368   , 0.026490389434    , 0.0332195916277   ,
 0.0487865185006   , 0.0783152877809   , 0.121748465412    , 0.17199518003     ,
 0.217011553855    , 0.244289282744    , 0.245507126181    , 0.219537779572    ,
 0.173070523639    , 0.118579964805    , 0.0694596277575   , 0.0342565502372   ,
 0.0141243225035   , 0.00521634736405  , 0.00315591846986  , 0.00592948751865  ,
 0.014210759036    , 0.0301333174766   , 0.0556573013747   , 0.0906532764174   ,
 0.13035032243     , 0.164298231441    , 0.180645622455    , 0.173601149037    ,
 0.146428923506    , 0.10831379582     , 0.0701391704451   , 0.0412754668238   ,
 0.0267999675669   , 0.0262446454102   , 0.0343087294011   , 0.0428724184986   ,
 0.0448422996232   , 0.0389137691874   , 0.0310536069461   , 0.0305167397197   ,
 0.043494189108    , 0.0686161829548   , 0.0970105433445   , 0.118700798047    ,
 0.132970941138    , 0.153698670383    , 0.201352637553    , 0.284811234297    ,
 0.387832680564    , 0.474033221001    , 0.509524659534    , 0.486123743584    ,
 0.425816133025    , 0.362674716438    , 0.317386296115    , 0.285254002405    ,
 0.247229095503    , 0.192654806719    , 0.130431506027    , 0.0787182862019   ,
 0.0476060692508   , 0.033411321136    , 0.0262378978817   , 0.0193901609891   ,
 0.0120285064386   , 0.00599508823953  , 0.00236645779424  , 0.000736623103033 ,
 0.000181192306145 , 3.59085386745e-05 , 6.24159680521e-06 , 1.20685024439e-06 ,
 3.17732306988e-07 , 9.40066085126e-08 , 2.46132040743e-08 , 5.23029876232e-09 ,
 8.83955375539e-10 , 1.1834548548e-10  , 1.25414365706e-11 , 1.05148211984e-12 ,
 6.9691982667e-14  , 3.64760522552e-15 , 1.5055326372e-16  , 4.89309342641e-18 ,
 1.25013041703e-19 , 2.20373900067e-21 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6.53048301459e-27 , 3.25948758339e-25 ,
 1.23514917379e-23 , 3.6547978086e-22  , 8.4502665543e-21  , 1.5278852526e-19  ,
 2.16242711458e-18 , 2.39833288258e-17 , 2.08712447254e-16 , 1.42714288528e-15 ,
 7.67909112701e-15 , 3.25625370156e-14 , 1.08965811643e-13 , 2.88088973053e-13 ,
 6.02255627933e-13 , 9.95909092056e-13 , 1.3025768514e-12  , 1.34676039399e-12 ,
 1.09967798423e-12 , 7.0824753276e-13  , 3.59276065584e-13 , 1.4333344077e-13  ,
 4.4906505714e-14  , 1.10337577137e-14 , 2.123543078e-15   , 3.19787821621e-16 ,
 3.76473944551e-17 , 3.46221451033e-18 , 2.48571359651e-19 , 1.39254299755e-20 ,
 6.08487093567e-22 , 2.07319129741e-23 , 5.50631943657e-25 , 1.12924655517e-26 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.41028782301e-21 , 1.5613840374e-19  ,
 1.67339842715e-17 , 7.24013272126e-16 , 2.48657160682e-14 , 6.81599531498e-13 ,
 1.48427064989e-11 , 2.55849141504e-10 , 3.48196554484e-09 , 3.73525756309e-08 ,
 3.15572699654e-07 , 2.09927429548e-06 , 1.09993261388e-05 , 4.54268495839e-05 ,
 0.000148046454753 , 0.000381349468912 , 0.000778486493692 , 0.00126682820621  ,
 0.00166958472523  , 0.00186505021335  , 0.00197317736755  , 0.00230988585021  ,
 0.00306753542755  , 0.00404568418507  , 0.00480720652635  , 0.00517336941241  ,
 0.00544620646581  , 0.00601020924263  , 0.00693299245716  , 0.00842538803229  ,
 0.0118959795259   , 0.0202998617962   , 0.0369477770912   , 0.0632607726666   ,
 0.0968290215822   , 0.131264872361    , 0.158336029636    , 0.170833558548    ,
 0.164463503713    , 0.139431653954    , 0.102007419296    , 0.0630540624052   ,
 0.0323721434258   , 0.0137320526273   , 0.00526350473691  , 0.00358706556878  ,
 0.00719902980157  , 0.0170743334279   , 0.0352528521141   , 0.0630227906347   ,
 0.0993692917117   , 0.139026939404    , 0.171456673452    , 0.184844827209    ,
 0.17399487683     , 0.143796292312    , 0.105121921489    , 0.0690710004027   ,
 0.0438552818844   , 0.0335027608572   , 0.0371760659732   , 0.0489466494634   ,
 0.0592742210149   , 0.0599679891514   , 0.0502953691778   , 0.0381305286838   ,
 0.0342565485974   , 0.0446934657553   , 0.0664100852012   , 0.0891751321198   ,
 0.104116332921    , 0.113812300983    , 0.133525240732    , 0.179245514959    ,
 0.251747086534    , 0.330986326862    , 0.386375078646    , 0.395495374088    ,
 0.357986631182    , 0.295375004178    , 0.236971492607    , 0.200836247991    ,
 0.183334588244    , 0.166380537623    , 0.136322411331    , 0.0958742388781   ,
 0.0583161864025   , 0.0334413984431   , 0.0210236124771   , 0.0150756417696   ,
 0.0106899125118   , 0.00653837238564  , 0.00324447981704  , 0.00127869351606  ,
 0.000397343163657 , 9.71172299921e-05 , 1.87045638159e-05 , 2.88300755124e-06 ,
 3.81487209546e-07 , 5.38321868388e-08 , 1.03335732871e-08 , 2.33543220603e-09 ,
 4.78796657746e-10 , 8.02198847596e-11 , 1.0708640521e-11  , 1.13285864373e-12 ,
 9.48401610309e-14 , 6.27770509206e-15 , 3.28171938933e-16 , 1.35305493678e-17 ,
 4.39339366564e-19 , 1.12155472043e-20 , 1.97022926977e-22 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.91322779966e-25 ,
 9.54918159009e-24 , 3.61855348257e-22 , 1.0707236259e-20  , 2.47561153995e-19 ,
 4.47610664582e-18 , 6.33502325323e-17 , 7.02607229275e-16 , 6.11430658983e-15 ,
 4.180818008e-14   , 2.24956105801e-13 , 9.53892852377e-13 , 3.19201069941e-12 ,
 8.43903734359e-12 , 1.76416422775e-11 , 2.91722303611e-11 , 3.81544554322e-11 ,
 3.94479656442e-11 , 3.22101515834e-11 , 2.07446440569e-11 , 1.05230990948e-11 ,
 4.19815182409e-12 , 1.31527287378e-12 , 3.23166779573e-13 , 6.21958789393e-14 ,
 9.36613119721e-15 , 1.10263419388e-15 , 1.01402597082e-16 , 7.28022933829e-18 ,
 4.0785114846e-19  , 1.78214788509e-20 , 6.07199198336e-22 , 1.61269700067e-23 ,
 3.3073380678e-25  , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.57691132184e-22 ,
 1.76481964947e-20 , 3.26174186684e-18 , 1.49454027193e-16 , 5.36486338044e-15 ,
 1.52315042529e-13 , 3.40916393476e-12 , 6.00263937993e-11 , 8.30390841162e-10 ,
 9.02054108548e-09 , 7.69484317831e-08 , 5.15687441393e-07 , 2.71739260927e-06 ,
 1.1271559673e-05  , 3.68537275373e-05 , 9.51471817273e-05 , 0.000194468190159 ,
 0.000316343388699 , 0.000415595817318 , 0.000460550112928 , 0.00048122322464  ,
 0.000559379624933 , 0.000747445249041 , 0.000996975709286 , 0.00119508581374  ,
 0.00129158916994  , 0.00136082244095  , 0.00150672822216  , 0.00177615811512  ,
 0.00232387059803  , 0.00379036282228  , 0.00754374512117  , 0.0154231717892   ,
 0.0288515911327   , 0.0476548743818   , 0.0694810766494   , 0.0903218709899   ,
 0.105297950307    , 0.109286284095    , 0.0989850948003   , 0.076349266274    ,
 0.0490848958543   , 0.0259093665218   , 0.0112170815915   , 0.00444420084056  ,
 0.00333841149207  , 0.0069939630715   , 0.0164287167906   , 0.0332013817909   ,
 0.0577640065285   , 0.0885353833634   , 0.1208396648      , 0.146039012592    ,
 0.154545893281    , 0.142750552746    , 0.11632053908     , 0.0857456794755   ,
 0.0599392116413   , 0.0439219418295   , 0.0396826507413   , 0.0463636471173   ,
 0.0587820262756   , 0.0678287982687   , 0.0658385031271   , 0.0530866421489   ,
 0.0381687289136   , 0.0314991738312   , 0.0380347155268   , 0.0542305534829   ,
 0.0708203232835   , 0.0809647762701   , 0.0882783499555   , 0.105629333715    ,
 0.14321520234     , 0.196834166174    , 0.248046664254    , 0.27581182291     ,
 0.269217744041    , 0.23271483036     , 0.182817303817    , 0.139196570927    ,
 0.113866399391    , 0.104496313593    , 0.098167574128    , 0.0836510283872   ,
 0.0605830312755   , 0.0370098233869   , 0.0201699568133   , 0.0112096026073   ,
 0.0070722816153   , 0.00468016193819  , 0.0027901950037   , 0.00137331217561  ,
 0.00053988825072  , 0.000167605903078 , 4.09134412531e-05 , 7.84047699034e-06 ,
 1.18128412606e-06 , 1.41676226347e-07 , 1.43354528538e-08 , 1.48774116585e-09 ,
 2.08099767103e-10 , 3.5834741122e-11  , 5.75218031711e-12 , 7.60282979921e-13 ,
 8.019336883e-14   , 6.7030422072e-15  , 4.43209356519e-16 , 2.31460138759e-17 ,
 9.53460048006e-19 , 3.09348701791e-20 , 7.89181153695e-22 , 1.38234049412e-23 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 4.36834137442e-24 , 2.18026970693e-22 , 8.26185340153e-21 , 2.44465675571e-19 ,
 5.65223911534e-18 , 1.02196349727e-16 , 1.44636999419e-15 , 1.60412877471e-14 ,
 1.39594513035e-13 , 9.54500025162e-13 , 5.13576337766e-12 , 2.17770165971e-11 ,
 7.28708489184e-11 , 1.92651514977e-10 , 4.02724591483e-10 , 6.65929554517e-10 ,
 8.70950862255e-10 , 9.00457586782e-10 , 7.35228663104e-10 , 4.73508275954e-10 ,
 2.40191793683e-10 , 9.58222943146e-11 , 3.00205856404e-11 , 7.37608221675e-12 ,
 1.41957112269e-12 , 2.13773048316e-13 , 2.51664460474e-14 , 2.31439610477e-15 ,
 1.66162196348e-16 , 9.30867156331e-18 , 4.06751210253e-19 , 1.38584797994e-20 ,
 3.6807525713e-22  , 7.54849621658e-24 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.38892870216e-23 , 1.56945507258e-21 , 5.56976842842e-19 , 2.64601396646e-17 ,
 9.74552206769e-16 , 2.82057532567e-14 , 6.40425693469e-13 , 1.13975506189e-11 ,
 1.58940454329e-10 , 1.7370226002e-09  , 1.48851854926e-08 , 1.00102479133e-07 ,
 5.28875275124e-07 , 2.19810274016e-06 , 7.19746747151e-06 , 1.8600063461e-05  ,
 3.803042573e-05   , 6.18308095083e-05 , 8.10543765325e-05 , 8.94162947918e-05 ,
 9.29668362833e-05 , 0.000108319898307 , 0.000146448929003 , 0.00019791666985  ,
 0.000239808568762 , 0.00026160352984  , 0.000278325546653 , 0.000312594764639 ,
 0.000382699100198 , 0.000556087842244 , 0.00107477212942  , 0.00248217377843  ,
 0.0056229896984   , 0.0113796278981   , 0.020186910446    , 0.0316519155263   ,
 0.0444058595257   , 0.0558139144043   , 0.0619035545358   , 0.05908134791     ,
 0.0473333394159   , 0.0312364830036   , 0.0167813416142   , 0.00736492274297  ,
 0.00301031798968  , 0.00248620824578  , 0.00540987972449  , 0.0126195704913   ,
 0.025082589855    , 0.0426991254423   , 0.063935126647    , 0.0854733798529   ,
 0.101592549895    , 0.106034680252    , 0.0970679743523   , 0.0799835765614   ,
 0.0629443999447   , 0.0510593128798   , 0.0452860716841   , 0.0454138863725   ,
 0.0512260766365   , 0.0598484799668   , 0.0645984266554   , 0.059666348487    ,
 0.0460372258226   , 0.0312881470461   , 0.0236119031536   , 0.0262801339794   ,
 0.0362056203902   , 0.0466997253387   , 0.0534208491986   , 0.0594505307702   ,
 0.0733118155558   , 0.0999355267267   , 0.133624486684    , 0.160876394309    ,
 0.169995051059    , 0.158042018121    , 0.130753552843    , 0.0984893477136   ,
 0.0717278226616   , 0.056591215158    , 0.0516799443162   , 0.0496262271588   ,
 0.0434862716192   , 0.0321737638493   , 0.0197199054422   , 0.0103299940933   ,
 0.00512016447184  , 0.0027663036774   , 0.00164713090623  , 0.00093931440628  ,
 0.000455509165906 , 0.000178257996173 , 5.52622072386e-05 , 1.34819679863e-05 ,
 2.5811551543e-06  , 3.87352501662e-07 , 4.56176901006e-08 , 4.25845016434e-09 ,
 3.30698023231e-10 , 2.54344960358e-11 , 2.59517538821e-12 , 3.39725333448e-13 ,
 4.26858077871e-14 , 4.45166783609e-15 , 3.70815441527e-16 , 2.44968617522e-17 ,
 1.2782742779e-18  , 5.26178732274e-20 , 1.70608839021e-21 , 4.35001257632e-23 ,
 7.60140378472e-25 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 7.77460413099e-23 , 3.88029297722e-21 , 1.47038061197e-19 ,
 4.3507852137e-18  , 1.00592852205e-16 , 1.81877119418e-15 , 2.57405180201e-14 ,
 2.85477099592e-13 , 2.48423919341e-12 , 1.69860647519e-11 , 9.13928719651e-11 ,
 3.87520737593e-10 , 1.29669710116e-09 , 3.42802850925e-09 , 7.16583669395e-09 ,
 1.18487811381e-08 , 1.54962264468e-08 , 1.60207607296e-08 , 1.3080695517e-08  ,
 8.42414203831e-09 , 4.27314115372e-09 , 1.70469968846e-09 , 5.34064776114e-10 ,
 1.31218506776e-10 , 2.52535271184e-11 , 3.80289402295e-12 , 4.47692948388e-13 ,
 4.11712193484e-14 , 2.95587739685e-15 , 1.6559241425e-16  , 7.23569798884e-18 ,
 2.46528006648e-19 , 6.54766699351e-21 , 1.34278925458e-22 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 9.62229413918e-25 , 1.0963896017e-22  , 7.9476993372e-20  ,
 3.84993217875e-18 , 1.43683870987e-16 , 4.1985311955e-15  , 9.59964507168e-14 ,
 1.71719088578e-12 , 2.40372032964e-11 , 2.63438556409e-10 , 2.26228448848e-09 ,
 1.52381167084e-08 , 8.06053018572e-08 , 3.35312944055e-07 , 1.09865912962e-06 ,
 2.84032144981e-06 , 5.80777979338e-06 , 9.43806540051e-06 , 1.23570539042e-05 ,
 1.36091451499e-05 , 1.41682112182e-05 , 1.66806892718e-05 , 2.29213590455e-05 ,
 3.14189724422e-05 , 3.8527659836e-05  , 4.25873787388e-05 , 4.60936846635e-05 ,
 5.31091917183e-05 , 6.90963010055e-05 , 0.000116107216781 , 0.000270189078738 ,
 0.000712566323653 , 0.00175965052784  , 0.003816245894    , 0.00724331581035  ,
 0.0122025913835   , 0.0184267417146   , 0.0247725592096   , 0.0289982147749   ,
 0.0287747572863   , 0.0236678806311   , 0.0158908290417   , 0.00863452719003  ,
 0.00382685071233  , 0.00161628145736  , 0.00147334554966  , 0.00332380789572  ,
 0.00771800391186  , 0.0151479319099   , 0.0253571036673   , 0.0372844058702   ,
 0.0490661443772   , 0.0576869996286   , 0.0599968544861   , 0.0558180070176   ,
 0.0493503184191   , 0.0456666000443   , 0.0459451101678   , 0.0475630740593   ,
 0.0486157323745   , 0.0499839183684   , 0.0519524652663   , 0.0513755063362   ,
 0.044725977589    , 0.0328976985306   , 0.0210953221542   , 0.0144651893491   ,
 0.014644834946    , 0.0194771684608   , 0.0251080230613   , 0.0294216726539   ,
 0.0345109339018   , 0.0448578515555   , 0.0617858744268   , 0.0801558548652   ,
 0.0916620580295   , 0.091269916379    , 0.080039995304    , 0.0628982101969   ,
 0.0453224622186   , 0.0316432307191   , 0.0240599627476   , 0.0216812971749   ,
 0.0210481381283   , 0.0187852275888   , 0.0141064904673   , 0.00867309125326  ,
 0.00442453162765  , 0.00200352223842  , 0.000922266019502 , 0.000474896603453 ,
 0.000251589490438 , 0.000118788407433 , 4.60955220142e-05 , 1.42538472051e-05 ,
 3.47470639935e-06 , 6.65000077044e-07 , 9.97233317098e-08 , 1.17072837053e-08 ,
 1.07696186056e-09 , 7.82665372323e-11 , 4.67839547835e-12 , 2.68586578499e-13 ,
 2.00395239195e-14 , 1.99029539704e-15 , 1.95602653359e-16 , 1.60411845366e-17 ,
 1.05895816698e-18 , 5.5221274353e-20  , 2.2717417214e-21  , 7.36210786518e-23 ,
 1.87627656582e-24 , 3.2723361512e-26  , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.07884049014e-21 , 5.38435931225e-20 ,
 2.04031264526e-18 , 6.03714183995e-17 , 1.39581172003e-15 , 2.52367140749e-14 ,
 3.57162546119e-13 , 3.96106967788e-12 , 3.4468765341e-11  , 2.3567559973e-10  ,
 1.26800821168e-09 , 5.37639297675e-09 , 1.79895172676e-08 , 4.75564263993e-08 ,
 9.94065135209e-08 , 1.64363202793e-07 , 2.14951367154e-07 , 2.2221919494e-07  ,
 1.81432328392e-07 , 1.16841306337e-07 , 5.92661150922e-08 , 2.36427083711e-08 ,
 7.40687386247e-09 , 1.81982315455e-09 , 3.50227678941e-10 , 5.27397469057e-11 ,
 6.20869560429e-12 , 5.70966836055e-13 , 4.09921991349e-14 , 2.29643087619e-15 ,
 1.00344114021e-16 , 3.41882271362e-18 , 9.08021211513e-20 , 1.86214728198e-21 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5.23561227306e-26 , 6.00786110431e-24 ,
 9.16477020208e-21 , 4.48253239927e-19 , 1.68367197766e-17 , 4.94227726492e-16 ,
 1.13373286335e-14 , 2.03288076953e-13 , 2.85062744158e-12 , 3.12825701567e-11 ,
 2.68902127061e-10 , 1.81258009559e-09 , 9.59332761813e-09 , 3.99239275505e-08 ,
 1.30848349453e-07 , 3.38326556926e-07 , 6.91772274002e-07 , 1.12386334986e-06 ,
 1.47086657914e-06 , 1.62129307139e-06 , 1.6997822842e-06  , 2.03690122807e-06 ,
 2.85545524136e-06 , 3.9726809325e-06  , 4.93408200603e-06 , 5.54212869435e-06 ,
 6.13865446162e-06 , 7.3473382271e-06  , 1.04976506616e-05 , 2.13053378734e-05 ,
 5.95217089972e-05 , 0.000175099967103 , 0.00046427772069  , 0.00107160791317  ,
 0.00217133563825  , 0.00392252345151  , 0.00633779083038  , 0.00901835876183  ,
 0.0110082985895   , 0.0112369178404   , 0.0094129479168   , 0.00639378651228  ,
 0.0035006893156   , 0.00156393037621  , 0.000685433586954 , 0.000693389843366 ,
 0.00161891480521  , 0.00374880997893  , 0.0072893228349   , 0.0120508937909   ,
 0.0174874574037   , 0.0227826400612   , 0.026723164708    , 0.0282481568926   ,
 0.0280831724131   , 0.0292206961123   , 0.034146214655    , 0.0413600737829   ,
 0.0462276449904   , 0.0460280037558   , 0.0425403787911   , 0.0386124853457   ,
 0.0342270222429   , 0.0277256007403   , 0.019357404222    , 0.0117162865048   ,
 0.00728020423322  , 0.00660650540469  , 0.00848877062955  , 0.0112411319351   ,
 0.0143172161888   , 0.0191282113981   , 0.0275431187447   , 0.0387864941691   ,
 0.0484289089972   , 0.0515743908179   , 0.0469697238929   , 0.0374316194782   ,
 0.0268980838248   , 0.0179941302748   , 0.0118337218067   , 0.00858723253778  ,
 0.00756686477813  , 0.00736006615938  , 0.00664079352987  , 0.00503652915937  ,
 0.00310557459971  , 0.00155947887244  , 0.000663507974564 , 0.00026555373587  ,
 0.000114968504709 , 5.43740490167e-05 , 2.4494783406e-05  , 9.35798380299e-06 ,
 2.87993573732e-06 , 7.01053343573e-07 , 1.34110731164e-07 , 2.0106523517e-08  ,
 2.35912416786e-09 , 2.16471507761e-10 , 1.55457041928e-11 , 8.79615563158e-13 ,
 4.05666243112e-14 , 1.7496662344e-15  , 9.57823376025e-17 , 7.19678872186e-18 ,
 5.42201994883e-19 , 3.5772958913e-20  , 1.86445991262e-21 , 7.66653978019e-23 ,
 2.48348594317e-24 , 6.32703195894e-26 , 1.10174702379e-27 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.16757889363e-20 ,
 5.82708102154e-19 , 2.20805807836e-17 , 6.5334273625e-16  , 1.51053721679e-14 ,
 2.73105897796e-13 , 3.86506164e-12    , 4.28640869627e-11 , 3.72988585893e-10 ,
 2.55018180509e-09 , 1.37202878564e-08 , 5.81721065741e-08 , 1.94636435159e-07 ,
 5.14509382377e-07 , 1.07541856897e-06 , 1.77805697968e-06 , 2.32519902774e-06 ,
 2.40370626701e-06 , 1.96243805843e-06 , 1.26374959324e-06 , 6.40997703091e-07 ,
 2.55702332649e-07 , 8.01054067851e-08 , 1.96810052845e-08 , 3.78757594202e-09 ,
 5.7035213983e-10  , 6.71429927887e-11 , 6.17458039022e-12 , 4.43297001894e-13 ,
 2.48338805556e-14 , 1.08512869369e-15 , 3.69712775569e-17 , 9.81934953444e-19 ,
 2.01370865253e-20 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.23435573903e-27 ,
 2.57904303535e-25 , 8.38119125742e-22 , 4.11817228499e-20 , 1.55148789748e-18 ,
 4.56398971815e-17 , 1.04855739823e-15 , 1.88223984993e-14 , 2.64153785143e-13 ,
 2.90055187149e-12 , 2.49441124186e-11 , 1.6819683746e-10  , 8.90429711179e-10 ,
 3.7063240987e-09  , 1.21487174733e-08 , 3.14137160637e-08 , 6.42289389746e-08 ,
 1.04340394487e-07 , 1.36612495934e-07 , 1.51078038815e-07 , 1.60394521439e-07 ,
 1.96977091112e-07 , 2.82614880746e-07 , 3.99260543293e-07 , 5.02492222647e-07 ,
 5.74686143501e-07 , 6.54776376947e-07 , 8.27615955164e-07 , 1.35898183548e-06 ,
 3.44142984673e-06 , 1.12805645683e-05 , 3.61394210525e-05 , 0.000101742609094 ,
 0.000248981453904 , 0.000537862694012 , 0.00103819413555  , 0.0017804009019   ,
 0.00265290017022  , 0.00334278973835  , 0.00348276359755  , 0.00295509974119  ,
 0.00202343949736  , 0.00111379504019  , 0.00050124648458  , 0.000229391264357 ,
 0.00025880115464  , 0.000623907338611 , 0.00144265856018  , 0.00278646835796  ,
 0.00456656740941  , 0.00657113741679  , 0.00853156629392  , 0.0101215294612   ,
 0.0112766221245   , 0.0129558463174   , 0.0171149634917   , 0.0246921405532   ,
 0.0332824658845   , 0.0381659218171   , 0.0367397609391   , 0.0309737051395   ,
 0.0245912624173   , 0.0191873862529   , 0.0142142685427   , 0.00935230774002  ,
 0.00535123574518  , 0.00303370167679  , 0.00248861669584  , 0.00325130244526  ,
 0.00497957374504  , 0.0081085066657   , 0.0138253494141   , 0.0226441491522   ,
 0.0324289030838   , 0.0386203122516   , 0.0376974378702   , 0.0303721457417   ,
 0.0206891571704   , 0.012419092197    , 0.00696093676379  , 0.00395059542524  ,
 0.00258752655111  , 0.00217211694608  , 0.00209407722579  , 0.00189881801037  ,
 0.00144915306123  , 0.000895762729011 , 0.000445969267836 , 0.000182556800813 ,
 6.58197779238e-05 , 2.39288743654e-05 , 9.68423675783e-06 , 4.03250873845e-06 ,
 1.49732956163e-06 , 4.56690864181e-07 , 1.10872110334e-07 , 2.11928401924e-08 ,
 3.17653717131e-09 , 3.72648817172e-10 , 3.41788370837e-11 , 2.44954691281e-12 ,
 1.37262238799e-13 , 6.04741504425e-15 , 2.1557462317e-16  , 7.02439062118e-18 ,
 2.81930061792e-19 , 1.43101987106e-20 , 9.43716171058e-22 , 4.91650699049e-23 ,
 2.02087042895e-24 , 6.54419604649e-26 , 1.66674693194e-27 , 2.89873003973e-29 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 9.85897384972e-20 , 4.92018450729e-18 , 1.86438977225e-16 , 5.51648092608e-15 ,
 1.27539889045e-13 , 2.30588525388e-12 , 3.26327162005e-11 , 3.61891565525e-10 ,
 3.14895281864e-09 , 2.15290534683e-08 , 1.15823737469e-07 , 4.91051634299e-07 ,
 1.64290431755e-06 , 4.34265594958e-06 , 9.07637790775e-06 , 1.50055996556e-05 ,
 1.96218985257e-05 , 2.02832172819e-05 , 1.65587642658e-05 , 1.06628155394e-05 ,
 5.40815130665e-06 , 2.1573030374e-06  , 6.75810427901e-07 , 1.66034829754e-07 ,
 3.19524482949e-08 , 4.81147746272e-09 , 5.6640895722e-10  , 5.20873305992e-11 ,
 3.73951825816e-12 , 2.09489593649e-13 , 9.15370158251e-15 , 3.11873232229e-16 ,
 8.28313813072e-18 , 1.69864882676e-19 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 7.46962954731e-29 , 8.66367768282e-27 , 6.02118982415e-23 , 2.96495252017e-21 ,
 1.11859524984e-19 , 3.29382419107e-18 , 7.57279633837e-17 , 1.36007348901e-15 ,
 1.90944855493e-14 , 2.097263466e-13   , 1.80397653093e-12 , 1.21660157163e-11 ,
 6.44140215433e-11 , 2.6813888535e-10  , 8.78958792055e-10 , 2.27281843053e-09 ,
 4.64706137632e-09 , 7.55045116978e-09 , 9.89790910803e-09 , 1.10093115548e-08 ,
 1.19036330991e-08 , 1.50798866276e-08 , 2.22029459646e-08 , 3.18579963053e-08 ,
 4.06373680772e-08 , 4.7386635792e-08  , 5.58489224187e-08 , 7.64435326613e-08 ,
 1.52517361199e-07 , 4.84852754333e-07 , 1.80213551048e-06 , 6.16798317271e-06 ,
 1.83154629705e-05 , 4.74529906689e-05 , 0.000109121809295 , 0.000223856971008 ,
 0.000403799373148 , 0.000623987215283 , 0.000805205104025 , 0.000851474533803 ,
 0.000729103180258 , 0.000502079737308 , 0.000277457567669 , 0.000125804423218 ,
 6.05930182153e-05 , 7.65007998259e-05 , 0.000189884587261 , 0.0004388550174   ,
 0.000843813899595 , 0.00137528547911  , 0.00197179229592  , 0.00257431923476  ,
 0.00316339715402  , 0.00394512684135  , 0.0056765353174   , 0.00949958919829  ,
 0.0156725024905   , 0.0221897745273   , 0.0255782592358   , 0.02396681007     ,
 0.0188749086238   , 0.0133499702185   , 0.00909949614316  , 0.00604403818957  ,
 0.00370221484797  , 0.00200763557442  , 0.00108319296807  , 0.000951448453524 ,
 0.00166808232427  , 0.00366682012923  , 0.00794297443422  , 0.015567271191    ,
 0.0261913124657   , 0.0365829877301   , 0.0416236521452   , 0.038232136504    ,
 0.0283100479491   , 0.0170152749965   , 0.00846686029953  , 0.0036492020569   ,
 0.00150615142381  , 0.000732864089613 , 0.000521852813513 , 0.000481853203228 ,
 0.00043548793561  , 0.000333419971477 , 0.000206480170569 , 0.000102357783761 ,
 4.09815716552e-05 , 1.37980393624e-05 , 4.32919811214e-06 , 1.45907096768e-06 ,
 5.38280169321e-07 , 1.90047008181e-07 , 5.70029415778e-08 , 1.37683051874e-08 ,
 2.62779163776e-09 , 3.93697228696e-10 , 4.61791337289e-11 , 4.23502659086e-12 ,
 3.03411268224e-13 , 1.69738082847e-14 , 7.41848812065e-16 , 2.54451627172e-17 ,
 7.01459338552e-19 , 1.7118454745e-20  , 2.86842038499e-22 , 1.88846467131e-23 ,
 9.82310316664e-25 , 4.03201222038e-26 , 1.30408017697e-27 , 3.31782855038e-29 ,
 5.74337089244e-31 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 6.49831627827e-19 , 3.24288419336e-17 , 1.22880107088e-15 ,
 3.63580416605e-14 , 8.40574619233e-13 , 1.51969999237e-11 , 2.15060687237e-10 ,
 2.38490592854e-09 , 2.07510922796e-08 , 1.418660742e-07   , 7.631794847e-07   ,
 3.23540436291e-06 , 1.0823883776e-05  , 2.86083946333e-05 , 5.97883381662e-05 ,
 9.8837731074e-05  , 0.000129233959333 , 0.000133579671096 , 0.00010904401307  ,
 7.02132665554e-05 , 3.56100646484e-05 , 1.42041426093e-05 , 4.44950642034e-06 ,
 1.09313071062e-06 , 2.10361136641e-07 , 3.1676009852e-08  , 3.72884729769e-09 ,
 3.42902436511e-10 , 2.46178060793e-11 , 1.37908920371e-12 , 6.0259242768e-14  ,
 2.05306488048e-15 , 5.45277571388e-17 , 1.11820066999e-18 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 1.95407878147e-30 , 2.27514405385e-28 , 3.38281991871e-24 ,
 1.66744468397e-22 , 6.29493683524e-21 , 1.8544682176e-19  , 4.26499548427e-18 ,
 7.66175841744e-17 , 1.07584595576e-15 , 1.18182021699e-14 , 1.01664954188e-13 ,
 6.85677743377e-13 , 3.63057196166e-12 , 1.5113681899e-11  , 4.954369323e-11   ,
 1.28112379119e-10 , 2.61959047392e-10 , 4.25804409675e-10 , 5.59363505472e-10 ,
 6.27479839245e-10 , 6.95143116671e-10 , 9.14061206851e-10 , 1.3838848107e-09  ,
 2.01662931613e-09 , 2.6069425616e-09  , 3.1029008948e-09  , 3.81456956724e-09 ,
 5.883337804e-09   , 1.50304374717e-08 , 5.84854967106e-08 , 2.3839268385e-07  ,
 8.60710500938e-07 , 2.68794591953e-06 , 7.3701941549e-06  , 1.79940092179e-05 ,
 3.89687579851e-05 , 7.32829063607e-05 , 0.000116487959102 , 0.000153014708251 ,
 0.000163572150526 , 0.000140992050278 , 9.74895698219e-05 , 5.40391492552e-05 ,
 2.470625634e-05   , 1.26408505412e-05 , 1.7881492781e-05  , 4.55530380572e-05 ,
 0.000105303484004 , 0.00020192665939  , 0.000328288053979 , 0.000471590557042 ,
 0.000628115885874 , 0.000833574130783 , 0.00125830985775  , 0.00233562838669  ,
 0.00463352354327  , 0.00819490287985  , 0.0118444433886   , 0.0136410154841   ,
 0.0125476662952   , 0.00943595501461  , 0.00610441675803  , 0.0036616553643   ,
 0.00214535636911  , 0.00120398815815  , 0.000631379381334 , 0.000411335134679 ,
 0.000690122447068 , 0.00192638868201  , 0.00504943371365  , 0.0112451383536   ,
 0.0210672061084   , 0.0330844138438   , 0.0432360009856   , 0.0465336925769   ,
 0.040815062246    , 0.028935985326    , 0.0165071382535   , 0.00758255715783  ,
 0.00283336384128  , 0.00089421917261  , 0.000274476800198 , 0.000120455468355 ,
 9.13561709275e-05 , 7.98442520844e-05 , 6.10054806221e-05 , 3.78145029378e-05 ,
 1.87076232265e-05 , 7.40032246619e-06 , 2.39193486519e-06 , 6.7508988378e-07  ,
 1.90217417468e-07 , 5.95754749236e-08 , 1.9336651653e-08  , 5.62501041376e-09 ,
 1.34562312472e-09 , 2.56084676863e-10 , 3.83343305768e-11 , 4.49534675738e-12 ,
 4.12227079113e-13 , 2.95307259465e-14 , 1.65149937823e-15 , 7.20662948611e-17 ,
 2.4527677446e-18  , 6.50899799574e-20 , 1.33087282389e-21 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 3.34540945845e-18 , 1.6693829187e-16  , 6.32556923071e-15 , 1.87158846352e-13 ,
 4.32689111728e-12 , 7.82248854314e-11 , 1.10696172814e-09 , 1.22750709156e-08 ,
 1.06799980364e-07 , 7.30099733204e-07 , 3.92734996151e-06 , 1.6648178933e-05  ,
 5.56907365017e-05 , 0.000147181152926 , 0.000307561764152 , 0.00050838804826  ,
 0.000664671116137 , 0.00068695807277  , 0.000560730904087 , 0.00036102594669  ,
 0.000183089175483 , 7.30263735957e-05 , 2.28746940316e-05 , 5.61950283898e-06 ,
 1.08137624893e-06 , 1.6282835442e-07  , 1.91674661434e-08 , 1.76259737031e-09 ,
 1.26539433134e-10 , 7.08865992454e-12 , 3.09736012464e-13 , 1.05528012202e-14 ,
 2.80272445574e-16 , 5.7474372739e-18  , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 3.78877434336e-32 , 4.47861330434e-30 , 1.4830009125e-25  , 7.31350097326e-24 ,
 2.76186653877e-22 , 8.13818179414e-21 , 1.87195572996e-19 , 3.36322075986e-18 ,
 4.72295235508e-17 , 5.1885011065e-16  , 4.46356506962e-15 , 3.0105480787e-14  ,
 1.59408464924e-13 , 6.63611705276e-13 , 2.17539269807e-12 , 5.62538438098e-12 ,
 1.15041670586e-11 , 1.87126906935e-11 , 2.46583618713e-11 , 2.7983502952e-11  ,
 3.19699626849e-11 , 4.38808090012e-11 , 6.83993442003e-11 , 1.01188317376e-10 ,
 1.32525703828e-10 , 1.61242149019e-10 , 2.09888452116e-10 , 3.86581571237e-10 ,
 1.29864917774e-09 , 5.91225496114e-09 , 2.57630138184e-08 , 9.74515188547e-08 ,
 3.19886207493e-07 , 9.2776822698e-07  , 2.39515049888e-06 , 5.43519604944e-06 ,
 1.05700135383e-05 , 1.71702293797e-05 , 2.28555937283e-05 , 2.46283295721e-05 ,
 2.13313138406e-05 , 1.4794105286e-05  , 8.22115424957e-06 , 3.79514602218e-06 ,
 2.08444000413e-06 , 3.29953612823e-06 , 8.59873528622e-06 , 1.98928885928e-05 ,
 3.81054698743e-05 , 6.19939569341e-05 , 8.99466187315e-05 , 0.000125387137539 ,
 0.000191857742841 , 0.000372778103042 , 0.000856748186607 , 0.00187523055271  ,
 0.00342723017698  , 0.00499520748837  , 0.00574128826713  , 0.00521907215569  ,
 0.00381011303953  , 0.00231424217526  , 0.00124654229429  , 0.000641158008766 ,
 0.000327580756729 , 0.00019425846892  , 0.000292439020176 , 0.000960294615311 ,
 0.00303283709028  , 0.00782096017569  , 0.0163664645507   , 0.0280915780262   ,
 0.0399964920346   , 0.0475644993402   , 0.047236790082    , 0.0389143755394   ,
 0.0263281920671   , 0.0144852653601   , 0.00643253268511  , 0.00229722931937  ,
 0.000662349678861 , 0.000159493316559 , 3.87808486909e-05 , 1.62102379904e-05 ,
 1.18738035328e-05 , 8.85714621727e-06 , 5.47939095998e-06 , 2.70767633288e-06 ,
 1.06432190381e-06 , 3.3623046266e-07  , 8.87298811475e-08 , 2.16030329119e-08 ,
 5.61056163831e-09 , 1.60304323322e-09 , 4.41889582361e-10 , 1.03832676292e-10 ,
 1.96528984745e-11 , 2.93719201542e-12 , 3.44273740304e-13 , 3.15658942793e-14 ,
 2.2611975045e-15  , 1.26454986694e-16 , 5.5181022034e-18  , 1.87807949916e-19 ,
 4.98392712591e-21 , 1.01904673691e-22 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.34613635881e-17 ,
 6.71685495221e-16 , 2.54508055173e-14 , 7.53012391833e-13 , 1.74082474066e-11 ,
 3.14708377125e-10 , 4.45324585103e-09 , 4.93792665033e-08 , 4.29599446251e-07 ,
 2.93657856802e-06 , 1.57950408975e-05 , 6.69490755154e-05 , 0.000223930390259 ,
 0.000591740098842 , 0.00123639632805  , 0.0020434625974   , 0.00267131596944  ,
 0.00276056771416  , 0.00225307808161  , 0.00145050234755  , 0.000735539618686 ,
 0.000293353770128 , 9.18841685036e-05 , 2.25715424689e-05 , 4.34332254045e-06 ,
 6.53974187971e-07 , 7.69809848312e-08 , 7.07884547539e-09 , 5.08191845897e-10 ,
 2.84682000334e-11 , 1.2438926012e-12  , 4.23794439406e-14 , 1.12555055723e-15 ,
 2.30806748705e-17 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5.06543810106e-27 ,
 2.49903617025e-25 , 9.43977615215e-24 , 2.78205189183e-22 , 6.40014497213e-21 ,
 1.14998057889e-19 , 1.61502295461e-18 , 1.77430909454e-17 , 1.52646134487e-16 ,
 1.02958419834e-15 , 5.45176118394e-15 , 2.26958480573e-14 , 7.44008175143e-14 ,
 1.92404095024e-13 , 3.93565109961e-13 , 6.40831389379e-13 , 8.48049889895e-13 ,
 9.77122272905e-13 , 1.15915020532e-12 , 1.66870441815e-12 , 2.67896888569e-12 ,
 4.02064130848e-12 , 5.33281085182e-12 , 6.65269300968e-12 , 9.42836289779e-12 ,
 2.22355932597e-11 , 9.66957696283e-11 , 4.91621984015e-10 , 2.25356313355e-09 ,
 8.90672789338e-09 , 3.07447985952e-08 , 9.41835845024e-08 , 2.55752033521e-07 ,
 6.0360061165e-07  , 1.20548910384e-06 , 1.99094955485e-06 , 2.67664101233e-06 ,
 2.90136002561e-06 , 2.52193412635e-06 , 1.75299674185e-06 , 9.76319936576e-07 ,
 4.55977259721e-07 , 2.71895681072e-07 , 4.79808771414e-07 , 1.27509960442e-06 ,
 2.95370580437e-06 , 5.66134283386e-06 , 9.25491370866e-06 , 1.37489256613e-05 ,
 2.09849207906e-05 , 4.00197566807e-05 , 0.000100297366967 , 0.00026531657217  ,
 0.000610626496392 , 0.00113286286336  , 0.00165670598037  , 0.00190080163417  ,
 0.00171532592078  , 0.00122939249332  , 0.00071615103669  , 0.000355559426452 ,
 0.000162809525254 , 8.13059522112e-05 , 9.55150008517e-05 , 0.000346972613257 ,
 0.0013550056865   , 0.00428259629174  , 0.0107240731343   , 0.0213850432585   ,
 0.0342947086692   , 0.0447862033567   , 0.0482665547766   , 0.0433922389415   ,
 0.0326920952418   , 0.0205796529167   , 0.0107302784913   , 0.00458428766292  ,
 0.00158921625318  , 0.000444058723695 , 0.000100086157507 , 1.89193383299e-05 ,
 3.88431902695e-06 , 1.58014566384e-06 , 1.03053412412e-06 , 6.27050089043e-07 ,
 3.09175462809e-07 , 1.21113505264e-07 , 3.77911408443e-08 , 9.58963423405e-09 ,
 2.10845958305e-09 , 4.58475939981e-10 , 1.10713875199e-10 , 2.79363342223e-11 ,
 6.35495091758e-12 , 1.19062911184e-12 , 1.77403525248e-13 , 2.07753151308e-14 ,
 1.90436269531e-15 , 1.36407238018e-16 , 7.6281973088e-18  , 3.32870798363e-19 ,
 1.13292178947e-20 , 3.00647530661e-22 , 6.14723845957e-24 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 4.23736360589e-17 , 2.11415039972e-15 , 8.01053375199e-14 , 2.37000630243e-12 ,
 5.47881661259e-11 , 9.90422735607e-10 , 1.40140970865e-08 , 1.55383220528e-07 ,
 1.35172544461e-06 , 9.23901095755e-06 , 4.96886599648e-05 , 0.000210585066023 ,
 0.000704266344672 , 0.00186076471808  , 0.00388733568069  , 0.00642383218253  ,
 0.00839628647434  , 0.00867557204182  , 0.00707975862566  , 0.00455731385694  ,
 0.00231074057712  , 0.000921505213258 , 0.000288611681828 , 7.08936133556e-05 ,
 1.36409785589e-05 , 2.05383639229e-06 , 2.41754210703e-07 , 2.22300942453e-08 ,
 1.59586905536e-09 , 8.93968469453e-11 , 3.90606319704e-12 , 1.33078244698e-13 ,
 3.53437990667e-15 , 7.24742779974e-17 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.34941723989e-28 , 6.65735603507e-27 , 2.51472753713e-25 , 7.41130127384e-24 ,
 1.70497906249e-22 , 3.06351308463e-21 , 4.30237163457e-20 , 4.72670471162e-19 ,
 4.06644533507e-18 , 2.74277935872e-17 , 1.45233136258e-16 , 6.04610834332e-16 ,
 1.9820409793e-15  , 5.12600429379e-15 , 1.04886986748e-14 , 1.71024713712e-14 ,
 2.2760686347e-14  , 2.67364822958e-14 , 3.31677119457e-14 , 5.02579601919e-14 ,
 8.30563207236e-14 , 1.26339823787e-13 , 1.6966992116e-13  , 2.18526396241e-13 ,
 3.53926447266e-13 , 1.13220653383e-12 , 6.05499885986e-12 , 3.31696158332e-11 ,
 1.58591486429e-10 , 6.54820000222e-10 , 2.37805267287e-09 , 7.67394140015e-09 ,
 2.17863888256e-08 , 5.31054429424e-08 , 1.08296010529e-07 , 1.81131434648e-07 ,
 2.45336844699e-07 , 2.67110422278e-07 , 2.3279675891e-07  , 1.62093329555e-07 ,
 9.04686980946e-08 , 4.28597269676e-08 , 2.80719032472e-08 , 5.48938472775e-08 ,
 1.48332518112e-07 , 3.44239370213e-07 , 6.61522062004e-07 , 1.09372410392e-06 ,
 1.70602965831e-06 , 3.05714075761e-06 , 7.65405690385e-06 , 2.3385313532e-05  ,
 6.69153535432e-05 , 0.000157781053142 , 0.000294722619084 , 0.000431573029397 ,
 0.000494535742275 , 0.000444305516764 , 0.000314890873353 , 0.000178639304287 ,
 8.38751122028e-05 , 3.58182844483e-05 , 2.50588845345e-05 , 8.1834345904e-05  ,
 0.000395177351981 , 0.00157609002313  , 0.00494157777218  , 0.0121695353895   ,
 0.0236303843963   , 0.0363996063991   , 0.0448675657166   , 0.0447712155181   ,
 0.0366615736462   , 0.0249628288893   , 0.014259502359    , 0.00684323066402  ,
 0.00274221718037  , 0.000907781009331 , 0.000245429397293 , 5.370277947e-05   ,
 9.50733398982e-06 , 1.43621418692e-06 , 2.61996765404e-07 , 1.02996519932e-07 ,
 5.7024431547e-08  , 2.77977336735e-08 , 1.08581209129e-08 , 3.36562617232e-09 ,
 8.3567033629e-10  , 1.72437927878e-10 , 3.25659168458e-11 , 6.52371370942e-12 ,
 1.44414430071e-12 , 3.10624964553e-13 , 5.71200244458e-14 , 8.4627209916e-15  ,
 9.89396518852e-16 , 9.06486858314e-17 , 6.49213935111e-18 , 3.63034539087e-19 ,
 1.58416978439e-20 , 5.39170295436e-22 , 1.43081560824e-23 , 2.92554032164e-25 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 1.04451194675e-16 , 5.21085030022e-15 , 1.97434005838e-13 ,
 5.84110025502e-12 , 1.35024557776e-10 , 2.44074748115e-09 , 3.45333089872e-08 ,
 3.82861546354e-07 , 3.33030220141e-06 , 2.27599106295e-05 , 0.000122389570844 ,
 0.000518619837679 , 0.00173414780708  , 0.00458102760498  , 0.00956846863523  ,
 0.0158089351229   , 0.0206592869975   , 0.021342721379    , 0.0174140402024   ,
 0.0112079594426   , 0.00568215494108  , 0.00226574889602  , 0.000709557279941 ,
 0.000174279807553 , 3.35318815277e-05 , 5.04842450048e-06 , 5.94218347873e-07 ,
 5.46385188181e-08 , 3.92232361422e-09 , 2.19714800043e-10 , 9.59995576354e-12 ,
 3.27062995915e-13 , 8.68626681916e-15 , 1.7810990104e-16  , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 2.79714577987e-30 , 1.37997313123e-28 , 5.2126646304e-27  ,
 1.53625501948e-25 , 3.53417366927e-24 , 6.35021689566e-23 , 8.91818952919e-22 ,
 9.79776760823e-21 , 8.4291409297e-20  , 5.68536773816e-19 , 3.01045322097e-18 ,
 1.2532546724e-17  , 4.10841149411e-17 , 1.06256551816e-16 , 2.17481588282e-16 ,
 3.55146549903e-16 , 4.75719975797e-16 , 5.71648688149e-16 , 7.45955411191e-16 ,
 1.19287871745e-15 , 2.02941841937e-15 , 3.1289161354e-15  , 4.25934921895e-15 ,
 5.74962851527e-15 , 1.14487486857e-14 , 5.0439056509e-14  , 3.11798126812e-13 ,
 1.79947103278e-12 , 8.94441821821e-12 , 3.86245193614e-11 , 1.475361512e-10   ,
 4.99583129089e-10 , 1.47355635821e-09 , 3.6869860579e-09  , 7.64188807208e-09 ,
 1.29050879513e-08 , 1.7578067912e-08  , 1.92015611419e-08 , 1.67682270341e-08 ,
 1.16908971875e-08 , 6.53925632306e-09 , 3.15319275592e-09 , 2.29464114608e-09 ,
 4.93337141187e-09 , 1.35207101691e-08 , 3.1458508838e-08  , 6.07870024369e-08 ,
 1.02843719712e-07 , 1.76256388016e-07 , 4.02362177575e-07 , 1.30826729741e-06 ,
 4.52988029843e-06 , 1.34904091613e-05 , 3.21748311543e-05 , 6.02867172061e-05 ,
 8.83240152094e-05 , 0.000101125436659 , 9.06130468147e-05 , 6.37903534148e-05 ,
 3.56101309547e-05 , 1.61991193478e-05 , 7.42942660853e-06 , 1.30249927877e-05 ,
 7.22201941752e-05 , 0.000365994504544 , 0.00146063614492  , 0.0045583181084   ,
 0.0111355593384   , 0.0213422510552   , 0.0322012708754   , 0.0384430949334   ,
 0.0365832706669   , 0.0280350105162   , 0.0175266260167   , 0.00906653158707  ,
 0.00392816580735  , 0.00143393861863  , 0.000439973046628 , 0.000112419087311 ,
 2.36281867259e-05 , 4.04080360944e-06 , 5.62501559027e-07 , 6.8896328442e-08  ,
 1.16347323381e-08 , 4.31834458207e-09 , 1.97485893789e-09 , 7.65146093751e-10 ,
 2.36173158726e-10 , 5.79519697199e-11 , 1.15267405902e-11 , 1.97620341019e-12 ,
 3.33041605531e-13 , 6.23094070514e-14 , 1.22497991164e-14 , 2.17919914744e-15 ,
 3.19520175159e-16 , 3.72404280477e-17 , 3.40889495736e-18 , 2.44076300874e-19 ,
 1.36470982098e-20 , 5.95516908199e-22 , 2.02683468966e-23 , 5.37868412601e-25 ,
 1.09976136669e-26 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.01862473076e-16 , 1.00692345062e-14 ,
 3.81500452406e-13 , 1.12862384196e-11 , 2.60882032545e-10 , 4.71547612139e-09 ,
 6.67122560649e-08 , 7.39547944133e-07 , 6.43216043645e-06 , 4.39524611469e-05 ,
 0.000236312643096 , 0.00100118034629  , 0.00334704596899  , 0.00883983862038  ,
 0.0184597435461   , 0.0304920411572   , 0.0398383899721   , 0.0411475098715   ,
 0.0335666230877   , 0.021600191406    , 0.0109490501942   , 0.00436532889837  ,
 0.00136692139175  , 0.000335708493373 , 6.45861925476e-05 , 9.72322707294e-06 ,
 1.14440231233e-06 , 1.05223824962e-07 , 7.5534381126e-09  , 4.23106357851e-10 ,
 1.84863335247e-11 , 6.29805037356e-13 , 1.67264016704e-14 , 3.42955869708e-16 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4.80111344143e-31 ,
 2.33437775445e-29 , 8.7821461177e-28  , 2.57494668807e-26 , 5.88519059299e-25 ,
 1.04878373141e-23 , 1.45774956933e-22 , 1.58098127316e-21 , 1.33857036182e-20 ,
 8.85357206036e-20 , 4.57888136436e-19 , 1.854248107e-18   , 5.89377143715e-18 ,
 1.47762842554e-17 , 2.95488750953e-17 , 4.84238738537e-17 , 6.96655321984e-17 ,
 1.08612475919e-16 , 3.16111903609e-16 , 1.90451499192e-15 , 1.29837823072e-14 ,
 7.8051155015e-14  , 4.03288234465e-13 , 1.82382396323e-12 , 7.31769470209e-12 ,
 2.58780519205e-11 , 7.88212031295e-11 , 2.0138493427e-10  , 4.22696153986e-10 ,
 7.19076690694e-10 , 9.83628137778e-10 , 1.077154474e-09   , 9.42059610559e-10 ,
 6.57493482834e-10 , 3.68646806483e-10 , 1.81697699009e-10 , 1.4848174799e-10  ,
 3.47796733558e-10 , 9.64775741682e-10 , 2.25296138091e-09 , 4.39901950104e-09 ,
 7.7891060335e-09  , 1.5769229657e-08  , 4.83566225089e-08 , 1.91449030658e-07 ,
 7.09999435242e-07 , 2.15595035821e-06 , 5.16961902599e-06 , 9.70020105671e-06 ,
 1.42139013345e-05 , 1.6265466087e-05  , 1.4551673356e-05  , 1.020376544e-05   ,
 5.64540576052e-06 , 2.57646586044e-06 , 1.85628827176e-06 , 8.30884296153e-06 ,
 5.2669398099e-05  , 0.000268755091996 , 0.00107163149373  , 0.00333692633157  ,
 0.00812172202153  , 0.0154719650067   , 0.0231154552913   , 0.0271631978575   ,
 0.0252133255109   , 0.01860103944     , 0.0110026601235   , 0.00527916800107  ,
 0.00208348146499  , 0.000685799165774 , 0.000190130246987 , 4.44871738051e-05 ,
 8.72876184792e-06 , 1.4192186033e-06  , 1.88969931354e-07 , 2.06731047127e-08 ,
 2.08573716072e-09 , 3.36570291241e-10 , 1.14299876026e-10 , 4.24464354929e-11 ,
 1.30171012657e-11 , 3.1725751927e-12  , 6.18233746081e-13 , 9.9827125722e-14  ,
 1.46963975716e-14 , 2.29021501792e-15 , 3.95371849497e-16 , 6.65123161766e-17 ,
 9.57219246406e-18 , 1.10936874281e-18 , 1.01380714188e-19 , 7.25533109908e-21 ,
 4.05591126249e-22 , 1.76987349093e-23 , 6.02374330322e-25 , 1.59854242921e-26 ,
 3.26848568438e-28 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3.06266422807e-16 , 1.52748017713e-14 ,
 5.78704169049e-13 , 1.71194061671e-11 , 3.95690905932e-10 , 7.15160069187e-09 ,
 1.01167570707e-07 , 1.12137526437e-06 , 9.75169911052e-06 , 6.66245676991e-05 ,
 0.000358141430365 , 0.00151699884492  , 0.00507025766448  , 0.0133875246272   ,
 0.0279488725162   , 0.0461536853523   , 0.0602844295198   , 0.0622495253134   ,
 0.0507688837172   , 0.0326629410157   , 0.0165536233119   , 0.00659878343376  ,
 0.00206600599876  , 0.000507342712369 , 9.75974822519e-05 , 1.46918586842e-05 ,
 1.72909470731e-06 , 1.5897657818e-07  , 1.14116132195e-08 , 6.39202855785e-10 ,
 2.79273364504e-11 , 9.51429612809e-13 , 2.52677529121e-14 , 5.18059124428e-16 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 9.52952892297e-31 , 4.73516634187e-29 , 3.19967020136e-27 ,
 1.25407986645e-25 , 3.99338388207e-24 , 1.05090671562e-22 , 2.26162448041e-21 ,
 3.94568752165e-20 , 5.54725630631e-19 , 6.2765588917e-18  , 5.74265406739e-17 ,
 4.30163452294e-16 , 2.69453578763e-15 , 1.45085883761e-14 , 6.87905014659e-14 ,
 2.89215085049e-13 , 1.06258639812e-12 , 3.32364309041e-12 , 8.63374768361e-12 ,
 1.82993087456e-11 , 3.13050127535e-11 , 4.29603202008e-11 , 4.71334564475e-11 ,
 4.12684448438e-11 , 2.88269879016e-11 , 1.62075007302e-11 , 8.20812458634e-12 ,
 7.60161651617e-12 , 1.92110615834e-11 , 5.3854930878e-11  , 1.26460051315e-10 ,
 2.51857234812e-10 , 4.86930473221e-10 , 1.27293971854e-09 , 5.17329757891e-09 ,
 2.31368776965e-08 , 8.88393133366e-08 , 2.72280715069e-07 , 6.54532585275e-07 ,
 1.22895940027e-06 , 1.80090961753e-06 , 2.06018001201e-06 , 1.84141348021e-06 ,
 1.28836413435e-06 , 7.11511815523e-07 , 3.59335748162e-07 , 6.62662574924e-07 ,
 4.69296414006e-06 , 3.05427557869e-05 , 0.000155983980117 , 0.00062163486026  ,
 0.00193376335574  , 0.00469879727413  , 0.00892689251745  , 0.0132773459073   ,
 0.0154883605448   , 0.0142064992903   , 0.0102831366      , 0.0059042041432   ,
 0.00270870000472  , 0.00100288210199  , 0.000303475345634 , 7.61190532447e-05 ,
 1.60219970783e-05 , 2.84809528359e-06 , 4.26584882012e-07 , 5.33136274365e-08 ,
 5.4973094441e-09  , 4.72078052105e-10 , 4.00129171395e-11 , 6.29052835811e-12 ,
 1.89004847231e-12 , 5.63542041205e-13 , 1.36482912296e-13 , 2.62925380729e-14 ,
 4.0996709873e-15  , 5.50170074182e-16 , 7.25388207658e-17 , 1.06299462602e-17 ,
 1.63807451764e-18 , 2.28267131213e-19 , 2.61891971738e-20 , 2.38616989602e-21 ,
 1.70617053786e-22 , 9.53459304426e-24 , 4.16059977246e-25 , 1.41605516695e-26 ,
 3.7578365354e-28  , 7.68352137282e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3.65317480146e-16 ,
 1.82167538182e-14 , 6.9013086743e-13  , 2.04144506902e-11 , 4.71816141691e-10 ,
 8.52667984107e-09 , 1.20605975866e-07 , 1.33665301833e-06 , 1.16218774948e-05 ,
 7.93863388511e-05 , 0.000426646244836 , 0.00180670638003  , 0.00603683962892  ,
 0.015934847711    , 0.0332563138224   , 0.0549005414647   , 0.0716866632079   ,
 0.0740011991265   , 0.0603364303519   , 0.0388086542732   , 0.0196639530053   ,
 0.00783717313276  , 0.00245333988323  , 0.000602379014415 , 0.000115866964106 ,
 1.74405133161e-05 , 2.05243923277e-06 , 1.88694780825e-07 , 1.3544222518e-08  ,
 7.58630227994e-10 , 3.31442844865e-11 , 1.12913563766e-12 , 2.99866860645e-14 ,
 6.14771891881e-16 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 3.60180297849e-29 , 1.85717033111e-27 ,
 7.10668608842e-26 , 2.1318970695e-24  , 5.01369027726e-23 , 9.27740246751e-22 ,
 1.35683092285e-20 , 1.57967314496e-19 , 1.48138334264e-18 , 1.14003383445e-17 ,
 7.39121257736e-17 , 4.15624188877e-16 , 2.0671295299e-15  , 9.07780767414e-15 ,
 3.44717788834e-14 , 1.10192495662e-13 , 2.90016690556e-13 , 6.19346176517e-13 ,
 1.06407374582e-12 , 1.46381079665e-12 , 1.60827085845e-12 , 1.409333146e-12   ,
 9.85159060775e-13 , 5.55719237305e-13 , 2.91017871848e-13 , 3.07615527241e-13 ,
 8.30611293041e-13 , 2.35098125047e-12 , 5.57070832861e-12 , 1.15310621623e-11 ,
 2.6162999496e-11  , 9.41756794385e-11 , 4.72811569615e-10 , 2.25892490175e-09 ,
 8.8215387019e-09  , 2.7156241398e-08  , 6.53582982989e-08 , 1.22754778281e-07 ,
 1.79885375562e-07 , 2.05743169341e-07 , 1.83799978778e-07 , 1.28496402014e-07 ,
 7.20199937032e-08 , 5.39469077035e-08 , 2.65017313203e-07 , 2.14207206553e-06 ,
 1.4012052836e-05  , 7.15640167152e-05 , 0.000285127493198 , 0.000886576995601 ,
 0.00215270393321  , 0.00408485117777  , 0.00606352511952  , 0.00705012390509  ,
 0.00643186986722  , 0.0046147083548   , 0.00261199011888  , 0.00117133772275  ,
 0.000418656120174 , 0.000120236803736 , 2.80467456127e-05 , 5.38274295746e-06 ,
 8.61226732315e-07 , 1.15996871511e-07 , 1.31840960005e-08 , 1.25720326101e-09 ,
 9.97148656115e-11 , 6.71360765239e-12 , 4.8970504518e-13  , 7.52649313365e-14 ,
 1.93840061803e-14 , 4.60097035038e-15 , 8.76626802701e-16 , 1.32635459041e-16 ,
 1.62728897477e-17 , 1.73151141019e-18 , 1.83551433879e-19 , 2.17252866644e-20 ,
 2.67082289962e-21 , 2.93333723397e-22 , 2.63705005124e-23 , 1.87808761736e-24 ,
 1.04787049861e-25 , 4.57258085146e-27 , 1.55627243549e-28 , 4.12993614489e-30 ,
 8.44434086973e-32 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3.43096611031e-16 , 1.71052815196e-14 ,
 6.47988215925e-13 , 1.91665400848e-11 , 4.42936834353e-10 , 8.00392556241e-09 ,
 1.13197142986e-07 , 1.25434410743e-06 , 1.09041538825e-05 , 7.44670669059e-05 ,
 0.000400104822552 , 0.00169381424998  , 0.00565778805049  , 0.0149290798939   ,
 0.0311458718235   , 0.0513975163599   , 0.0670881500232   , 0.0692302006528   ,
 0.0564283085458   , 0.036284437297    , 0.0183802824781   , 0.00732395597832  ,
 0.00229225892802  , 0.000562741525094 , 0.000108229060257 , 1.62891696968e-05 ,
 1.91678805524e-06 , 1.76211791563e-07 , 1.26475477952e-08 , 7.08376782467e-10 ,
 3.09477132689e-11 , 1.05427719892e-12 , 2.79980875356e-14 , 5.73961025542e-16 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 6.41625174249e-31 , 3.33020565531e-29 , 1.27670716074e-27 ,
 3.84241798235e-26 , 9.07182369536e-25 , 1.68816331881e-23 , 2.49035322019e-22 ,
 2.93932413926e-21 , 2.81767842855e-20 , 2.24387665562e-19 , 1.52749169985e-18 ,
 9.11936269527e-18 , 4.81825407127e-17 , 2.22408074539e-16 , 8.74323314282e-16 ,
 2.85517721832e-15 , 7.60741406001e-15 , 1.63574928975e-14 , 2.82094631929e-14 ,
 3.88883375532e-14 , 4.27766587538e-14 , 3.75112669608e-14 , 2.62390462543e-14 ,
 1.48614375659e-14 , 8.1082738886e-15  , 9.82761818657e-15 , 2.80894880212e-14 ,
 8.02728071192e-14 , 1.9331946371e-13  , 4.31779023472e-13 , 1.26714179963e-12 ,
 6.2406432888e-12  , 3.56764332684e-11 , 1.76184297482e-10 , 6.93612995376e-10 ,
 2.13969040367e-09 , 5.15260741367e-09 , 9.67889375253e-09 , 1.41834158219e-08 ,
 1.62204221932e-08 , 1.44871415359e-08 , 1.01467185741e-08 , 6.14609060038e-09 ,
 1.09430892662e-08 , 9.31979221304e-08 , 7.76485680621e-07 , 5.08434225919e-06 ,
 2.59665463844e-05 , 0.000103444975922 , 0.000321591299012 , 0.000780612711775 ,
 0.00148047662967  , 0.00219571615904  , 0.00254933973737  , 0.00232028562497  ,
 0.00165825278859  , 0.000932568259919 , 0.000413821876856 , 0.000145408428552 ,
 4.06498393147e-05 , 9.09884094345e-06 , 1.64463352126e-06 , 2.42672793562e-07 ,
 2.95954945927e-08 , 3.01765324492e-09 , 2.59000461423e-10 , 1.87014581366e-11 ,
 1.13218751046e-12 , 5.9718374098e-14  , 3.84926994253e-15 , 5.70139195011e-16 ,
 1.22570143176e-16 , 2.3001881336e-17  , 3.42420919506e-18 , 3.99846439353e-19 ,
 3.65311079932e-20 , 2.6090477516e-21  , 1.4555545905e-22  , 6.33924770462e-24 ,
 2.15424436386e-25 , 5.70988694855e-27 , 1.16241161595e-28 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 2.54078779267e-16 , 1.26644124193e-14 , 4.79728487078e-13 ,
 1.41885795864e-11 , 3.27865341174e-10 , 5.92386680741e-09 , 8.37672823832e-08 ,
 9.28065629154e-07 , 8.0660627907e-06  , 5.5071229734e-05  , 0.000295806591971 ,
 0.00125186185988  , 0.00418002206854  , 0.0110253914426   , 0.0229923159485   ,
 0.037926526255    , 0.0494844213984   , 0.0510444204907   , 0.0415903197877   ,
 0.0267345979299   , 0.013538811445    , 0.00539344831491  , 0.00168769336715  ,
 0.000414250621647 , 7.9659200837e-05  , 1.19878280684e-05 , 1.41050612006e-06 ,
 1.29659192323e-07 , 9.30569465405e-09 , 5.211782687e-10   , 2.27684979223e-11 ,
 7.75618059396e-13 , 2.05973563295e-14 , 4.22211255737e-16 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 2.61274222113e-30 , 1.33108010574e-28 , 5.07362485516e-27 , 1.51195163211e-25 ,
 3.52687270446e-24 , 6.44740105073e-23 , 9.24947909674e-22 , 1.04294874041e-20 ,
 9.25903518508e-20 , 6.48358487708e-19 , 3.58767216063e-18 , 1.57155462975e-17 ,
 5.4583574133e-17  , 1.5052006735e-16  , 3.29895006141e-16 , 5.7506543914e-16  ,
 7.97646078831e-16 , 8.80560841669e-16 , 7.73851969696e-16 , 5.42218817747e-16 ,
 3.08884284461e-16 , 1.77319445543e-16 , 2.47374125095e-16 , 7.42609026451e-16 ,
 2.14608139792e-15 , 5.33309340074e-15 , 1.37675683666e-14 , 5.67597388765e-14 ,
 3.55180178653e-13 , 2.17648121365e-12 , 1.09209395603e-11 , 4.3159296979e-11  ,
 1.33272429204e-10 , 3.21020811715e-10 , 6.03059640495e-10 , 8.83715396534e-10 ,
 1.0105788389e-09  , 9.02765771352e-10 , 6.39617558165e-10 , 5.21575349638e-10 ,
 2.60746547057e-09 , 2.65716722482e-08 , 2.22844251207e-07 , 1.45944712632e-06 ,
 7.45346391057e-06 , 2.96915069697e-05 , 9.2297935684e-05  , 0.000224008835728 ,
 0.000424751317855 , 0.000629723124991 , 0.000730694967877 , 0.000664369621481 ,
 0.000474010668558 , 0.000265830413646 , 0.000117416064354 , 4.09439298492e-05 ,
 1.13042710412e-05 , 2.48001523653e-06 , 4.3437633755e-07  , 6.11237455796e-08 ,
 6.96819207405e-09 , 6.50356735643e-10 , 5.02681432684e-11 , 3.2491664828e-12  ,
 1.76485912576e-13 , 8.08872731515e-15 , 3.33420471655e-16 , 1.90944522506e-17 ,
 2.62692350049e-18 , 4.6364598337e-19  , 6.85237166329e-20 , 8.00192652674e-21 ,
 7.31107049978e-22 , 5.22172106113e-23 , 2.91320424558e-24 , 1.26878704394e-25 ,
 4.31174197912e-27 , 1.142853752e-28   , 2.32671075275e-30 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 1.48556827895e-16 , 7.40292349584e-15 , 2.8040444142e-13  ,
 8.29262554121e-12 , 1.9160345923e-10  , 3.46144082909e-09 , 4.89392061145e-08 ,
 5.42097089377e-07 , 4.71041318992e-06 , 3.21516191767e-05 , 0.000172642422477 ,
 0.000730363404007 , 0.00243773909891  , 0.00642710210149  , 0.0133970040202   ,
 0.0220886338765   , 0.0288070162252   , 0.0297023611472   , 0.024191429289    ,
 0.0155448470447   , 0.0078696528357   , 0.00313417221433  , 0.000980504271909 ,
 0.000240622116205 , 4.6263624227e-05  , 6.96126874742e-06 , 8.18988688754e-07 ,
 7.52783807513e-08 , 5.40240502867e-09 , 3.02553362258e-10 , 1.32169786072e-11 ,
 4.50227121031e-13 , 1.19559524569e-14 , 2.45054678292e-16 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 6.1112320827e-34  , 3.03437054436e-32 , 1.14821150318e-30 , 3.3914858848e-29  ,
 7.82395993337e-28 , 1.41072197127e-26 , 1.98979099915e-25 , 2.19768845421e-24 ,
 1.90295407885e-23 , 1.29350732401e-22 , 6.91213286677e-22 , 2.90807293784e-21 ,
 9.64675187169e-21 , 2.52644154234e-20 , 5.22931260953e-20 , 8.56016223719e-20 ,
 1.10856151688e-19 , 1.13705204025e-19 , 9.41755340386e-20 , 7.99960356419e-20 ,
 1.84450712175e-19 , 9.03505916526e-19 , 4.08084927573e-18 , 1.48876681474e-17 ,
 4.42820390872e-17 , 1.17552212432e-16 , 3.9123342146e-16  , 2.30349292899e-15 ,
 1.67366998029e-14 , 1.06165445396e-13 , 5.36769389311e-13 , 2.12518577457e-12 ,
 6.56554069201e-12 , 1.58168335826e-11 , 2.9713921594e-11  , 4.35421983786e-11 ,
 4.97937253044e-11 , 4.45529065443e-11 , 3.32841097891e-11 , 5.73010992295e-11 ,
 5.65858041233e-10 , 6.02434924026e-09 , 5.05948848453e-08 , 3.31367531206e-07 ,
 1.69229082912e-06 , 6.74124636996e-06 , 2.09548813518e-05 , 5.08550358941e-05 ,
 9.64191106695e-05 , 0.000142925912507 , 0.000165800604303 , 0.000150686614298 ,
 0.000107434812592 , 6.0179515098e-05  , 2.652878707e-05   , 9.22058910888e-06 ,
 2.53195600661e-06 , 5.50538334867e-07 , 9.50341540053e-08 , 1.30654460313e-08 ,
 1.43671537795e-09 , 1.27110384647e-10 , 9.12111724978e-12 , 5.36231335186e-13 ,
 2.61058614161e-14 , 1.06117779823e-15 , 3.60994535068e-17 , 9.91981042954e-19 ,
 1.94594368531e-20 , 3.75935156016e-22 , 2.52228061568e-30 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6.86496501883e-17 , 3.42008213805e-15 ,
 1.29535130916e-13 , 3.83050711278e-12 , 8.84951533178e-11 , 1.59850272165e-09 ,
 2.2596437455e-08  , 2.50248095442e-07 , 2.17392916751e-06 , 1.48341390279e-05 ,
 7.96268910517e-05 , 0.000336731694798 , 0.00112343218304  , 0.00296056707921  ,
 0.00616819285302  , 0.0101649745522   , 0.0132503115201   , 0.0136558431915   ,
 0.0111174009493   , 0.00714102282085  , 0.00361394657125  , 0.00143887004211  ,
 0.000450028863025 , 0.00011041716879  , 2.12259382713e-05 , 3.1934169581e-06  ,
 3.75661564974e-07 , 3.45263308979e-08 , 2.47763034796e-09 , 1.38748076535e-10 ,
 6.06091137422e-12 , 2.06453504399e-13 , 5.48230128867e-15 , 1.12356755236e-16 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.77058028502e-31 , 8.5452894857e-30  , 3.20810495695e-28 , 9.38111844975e-27 ,
 2.13678724578e-25 , 3.81488581962e-24 , 5.35411903614e-23 , 6.06997222251e-22 ,
 5.9825730454e-21  , 5.93685889767e-20 , 6.61645528679e-19 , 7.58796805212e-18 ,
 7.6855719471e-17  , 6.32735028295e-16 , 4.11085330137e-15 , 2.08880708907e-14 ,
 8.27974553725e-14 , 2.55871868567e-13 , 6.16463494292e-13 , 1.15812875584e-12 ,
 1.69711016936e-12 , 1.94120272367e-12 , 1.75040406802e-12 , 1.61666746542e-12 ,
 7.90755726501e-12 , 1.0055276932e-10  , 1.0810039497e-09  , 9.08146180256e-09 ,
 5.94787658434e-08 , 3.03756029112e-07 , 1.21000295151e-06 , 3.7611906603e-06  ,
 9.12775617556e-06 , 1.73051946373e-05 , 2.56505475758e-05 , 2.97526579436e-05 ,
 2.70357124924e-05 , 1.92699569143e-05 , 1.07887692567e-05 , 4.75210421486e-06 ,
 1.64943467993e-06 , 4.51902583209e-07 , 9.78886466455e-08 , 1.67919788336e-08 ,
 2.2849439797e-09  , 2.4710528463e-10  , 2.12923100547e-11 , 1.46730172873e-12 ,
 8.13211771915e-14 , 3.65362024542e-15 , 1.34404564005e-16 , 4.09011545179e-18 ,
 9.82630960241e-20 , 1.40742987742e-21 , 2.71900121327e-23 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.50894043348e-17 , 1.24960524329e-15 ,
 4.73251906082e-14 , 1.39933427497e-12 , 3.23247495286e-11 , 5.83804702776e-10 ,
 8.25122689249e-09 , 9.13602391693e-08 , 7.93452896208e-07 , 5.41261533923e-06 ,
 2.90437387118e-05 , 0.000122773301071 , 0.00040942570261  , 0.00107844050194  ,
 0.00224575414035  , 0.00369904687664  , 0.00481938914144  , 0.0049645091329   ,
 0.00403987379686  , 0.00259388250263  , 0.00131225313112  , 0.000522305516053 ,
 0.000163316827618 , 4.00620762607e-05 , 7.69992830887e-06 , 1.15827781592e-06 ,
 1.36239598565e-07 , 1.25203534653e-08 , 8.98401570584e-10 , 5.03078179354e-11 ,
 2.19748709555e-12 , 7.48505221418e-14 , 1.98757282171e-15 , 4.07300439158e-17 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 7.26709588871e-28 , 3.50497821925e-26 , 1.31560590527e-24 , 3.84616423792e-23 ,
 8.75792066496e-22 , 1.55331060275e-20 , 2.14593375116e-19 , 2.30938617581e-18 ,
 1.93609777152e-17 , 1.26457900057e-16 , 6.43581387875e-16 , 2.55253169032e-15 ,
 7.89139317056e-15 , 1.90245431388e-14 , 3.57870191745e-14 , 5.25885368876e-14 ,
 6.05758846559e-14 , 5.72363322325e-14 , 9.70866312289e-14 , 1.05024559686e-12 ,
 1.42260373034e-11 , 1.53241850563e-10 , 1.28744881631e-09 , 8.432109072e-09   ,
 4.30624045191e-08 , 1.71537194166e-07 , 5.33205653803e-07 , 1.29398525959e-06 ,
 2.45321152306e-06 , 3.63616751413e-06 , 4.21749229126e-06 , 3.83208574163e-06 ,
 2.73102880424e-06 , 1.52873044681e-06 , 6.73132279793e-07 , 2.33511290451e-07 ,
 6.39165520494e-08 , 1.38237284497e-08 , 2.36519954669e-09 , 3.20456439081e-10 ,
 3.44099823889e-11 , 2.93072199121e-12 , 1.98220548177e-13 , 1.06679699495e-14 ,
 4.58454405196e-16 , 1.58216734952e-17 , 4.4208874687e-19  , 9.33054302981e-21 ,
 7.93048063985e-23 , 1.53208247447e-24 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 7.25331197657e-18 , 3.61163104796e-16 , 1.36770196118e-14 ,
 4.04371958143e-13 , 9.33996575932e-12 , 1.68661634969e-10 , 2.38337105615e-09 ,
 2.63838578013e-08 , 2.29082301546e-07 , 1.56223564878e-06 , 8.37991601955e-06 ,
 3.54093474198e-05 , 0.000118031212771 , 0.000310749356054 , 0.000646782448209 ,
 0.00106478977704  , 0.00138658641905  , 0.00142764933862  , 0.00116122961467  ,
 0.000745288290152 , 0.000376908601863 , 0.000149971503383 , 4.68814785372e-05 ,
 1.14976471057e-05 , 2.20945005091e-06 , 3.32312574546e-07 , 3.90828492137e-08 ,
 3.59135625062e-09 , 2.5767945912e-10  , 1.44284258965e-11 , 6.30215997605e-13 ,
 2.14655431887e-14 , 5.69977224858e-16 , 1.16789622176e-17 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.77068000909e-29 ,
 8.54013069342e-28 , 3.20556810034e-26 , 9.38051376077e-25 , 2.1383256281e-23  ,
 3.80127921692e-22 , 5.27714181014e-21 , 5.73754767776e-20 , 4.91423383528e-19 ,
 3.35434742311e-18 , 1.86374918197e-17 , 8.71605664316e-17 , 3.56876965339e-16 ,
 1.31115821955e-15 , 4.28385042108e-15 , 1.20261896453e-14 , 2.7983466576e-14  ,
 5.28639445215e-14 , 8.52407587512e-14 , 2.08368029286e-13 , 1.67728862634e-12 ,
 1.72014060428e-11 , 1.44013212862e-10 , 9.42980114302e-10 , 4.81567040064e-09 ,
 1.91829610647e-08 , 5.96281119447e-08 , 1.44705152847e-07 , 2.74338614842e-07 ,
 4.06622412914e-07 , 4.71622187311e-07 , 4.28511687201e-07 , 3.05374623905e-07 ,
 1.70923936645e-07 , 7.52513698665e-08 , 2.60990602891e-08 , 7.14114599211e-09 ,
 1.54350428523e-09 , 2.63812604537e-10 , 3.56810209495e-11 , 3.82022418687e-12 ,
 3.23807125336e-13 , 2.17280976216e-14 , 1.15442945943e-15 , 4.86022177859e-17 ,
 1.62448148577e-18 , 4.32655635846e-20 , 8.37297219653e-22 , 3.48109243785e-24 ,
 6.72509140144e-26 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.65827432241e-18 , 8.25489748676e-17 , 3.12585873724e-15 , 9.24103548228e-14 ,
 2.13420937003e-12 , 3.85343986868e-11 , 5.44440874221e-10 , 6.02570889084e-09 ,
 5.23063096631e-08 , 3.56600546483e-07 , 1.91217378344e-06 , 8.07676445688e-06 ,
 2.69109784717e-05 , 7.08175231224e-05 , 0.00014732496916  , 0.000242418400253 ,
 0.000315525764196 , 0.000324716653793 , 0.000264004003751 , 0.000169372995149 ,
 8.56255867078e-05 , 3.40599997238e-05 , 1.06445090702e-05 , 2.60999854854e-06 ,
 5.01463020395e-07 , 7.54117793194e-08 , 8.86805496062e-09 , 8.14817619772e-10 ,
 5.84587733398e-11 , 3.27313168303e-12 , 1.42959795885e-13 , 4.8691215413e-15  ,
 1.29286701841e-16 , 2.64884350702e-18 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.4624037071e-31  , 1.18763691749e-29 ,
 4.4578369514e-28  , 4.12755901546e-26 , 1.66714694011e-24 , 5.67887222265e-23 ,
 1.58233112054e-21 , 3.52530013548e-20 , 6.20107488284e-19 , 8.55768664725e-18 ,
 9.23835113795e-17 , 7.79247142745e-16 , 5.13438230809e-15 , 2.64326989542e-14 ,
 1.06385064552e-13 , 3.35006545745e-13 , 8.26216995229e-13 , 1.59779364649e-12 ,
 2.42658012458e-12 , 2.90651230341e-12 , 2.86307529892e-12 , 3.52843425176e-12 ,
 1.38646372442e-11 , 8.36120867065e-11 , 4.2440984494e-10  , 1.68987533581e-09 ,
 5.25261938362e-09 , 1.27469771937e-08 , 2.41662354642e-08 , 3.58188455043e-08 ,
 4.15443083676e-08 , 3.77463570268e-08 , 2.68990596152e-08 , 1.50554354366e-08 ,
 6.62799107372e-09 , 2.29855024673e-09 , 6.28829299737e-10 , 1.35882963109e-10 ,
 2.3215196013e-11  , 3.13770692042e-12 , 3.35552311103e-13 , 2.83869832617e-14 ,
 1.89873440705e-15 , 1.00350041951e-16 , 4.18848112281e-18 , 1.3805533719e-19  ,
 3.59626546206e-21 , 6.65785059711e-23 , 1.19028022463e-25 , 2.29949173912e-27 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.99596752459e-19 ,
 1.4910338945e-17  , 5.64568442467e-16 , 1.6689062328e-14  , 3.85392575976e-13 ,
 6.9575931439e-12  , 9.82861521363e-11 , 1.08759163337e-09 , 9.43867067296e-09 ,
 6.43308262414e-08 , 3.44846084787e-07 , 1.45605176889e-06 , 4.84945128893e-06 ,
 1.27559559071e-05 , 2.65245451689e-05 , 4.36246989156e-05 , 5.67543599161e-05 ,
 5.83814397749e-05 , 4.74460374621e-05 , 3.04277472078e-05 , 1.53774542675e-05 ,
 6.11505549046e-06 , 1.91062425602e-06 , 4.68383268898e-07 , 8.99760927979e-08 ,
 1.35290738826e-08 , 1.5907773145e-09  , 1.46151437901e-10 , 1.04848413342e-11 ,
 5.87018059204e-13 , 2.56379215826e-14 , 8.7318141918e-16  , 2.31844035396e-17 ,
 4.74959012234e-19 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 6.94038800302e-25 , 3.36755993967e-23 ,
 1.26617150028e-21 , 3.70969154836e-20 , 8.47067825527e-19 , 1.50771333371e-17 ,
 2.09241189192e-16 , 2.26484726395e-15 , 1.91277436201e-14 , 1.26105141495e-13 ,
 6.49391214146e-13 , 2.6139783152e-12  , 8.23191712747e-12 , 2.03026967683e-11 ,
 3.92626580002e-11 , 5.96157916598e-11 , 7.11755622981e-11 , 6.69248392559e-11 ,
 4.97160100197e-11 , 2.99227347462e-11 , 1.91947933043e-11 , 3.4310188961e-11  ,
 1.18503979063e-10 , 3.6425601737e-10  , 8.83240446033e-10 , 1.67437829983e-09 ,
 2.48172387404e-09 , 2.878406305e-09   , 2.61525276092e-09 , 1.86368500995e-09 ,
 1.04309383206e-09 , 4.59201201035e-10 , 1.59242912603e-10 , 4.35625975147e-11 ,
 9.41247686747e-12 , 1.60783230789e-12 , 2.17251465986e-13 , 2.32227271691e-14 ,
 1.9631025272e-15  , 1.31141488741e-16 , 6.91647469615e-18 , 2.87688794214e-19 ,
 9.42875568866e-21 , 2.43352527733e-22 , 4.41868975416e-24 , 3.17015445643e-27 ,
 6.1243930912e-29  , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 4.27275053955e-20 , 2.125994761e-18   , 8.04943082855e-17 , 2.37929161222e-15 ,
 5.49386514401e-14 , 9.9170527204e-13  , 1.40072543778e-11 , 1.54970785614e-10 ,
 1.34462898575e-09 , 9.16223223013e-09 , 4.90998343289e-08 , 2.07246061616e-07 ,
 6.89986251096e-07 , 1.81420236134e-06 , 3.77082472344e-06 , 6.19915720908e-06 ,
 8.06144991671e-06 , 8.28914866593e-06 , 6.73392752331e-06 , 4.31705127612e-06 ,
 2.18106320993e-06 , 8.67098942974e-07 , 2.70860386498e-07 , 6.63880222146e-08 ,
 1.27511126939e-08 , 1.91705306783e-09 , 2.25388196043e-10 , 2.07056752577e-11 ,
 1.48531964306e-12 , 8.31547651687e-14 , 3.63162354183e-15 , 1.23682593366e-16 ,
 3.28389377189e-18 , 6.72682597996e-20 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.34680714692e-23 ,
 6.53487066204e-22 , 2.45705114044e-20 , 7.19878930112e-19 , 1.64376545064e-17 ,
 2.92577171832e-16 , 4.06040020976e-15 , 4.39501722444e-14 , 3.71180714978e-13 ,
 2.44711543151e-12 , 1.26016690706e-11 , 5.07251853241e-11 , 1.59743299844e-10 ,
 3.93981100448e-10 , 7.619059057e-10   , 1.15686502233e-09 , 1.38117370361e-09 ,
 1.29851272247e-09 , 9.62733058462e-10 , 5.63657111584e-10 , 2.61112792624e-10 ,
 9.70454597725e-11 , 3.40023076575e-11 , 2.61291516702e-11 , 4.9203425839e-11  ,
 9.12758095074e-11 , 1.35063625506e-10 , 1.56632592962e-10 , 1.42311110024e-10 ,
 1.01413574102e-10 , 5.67603228777e-11 , 2.49873977042e-11 , 8.66507503781e-12 ,
 2.37037069487e-12 , 5.12141703959e-13 , 8.74781693049e-14 , 1.18188700159e-14 ,
 1.26313577423e-15 , 1.0674614269e-16  , 7.12749115692e-18 , 3.75601988241e-19 ,
 1.56019871328e-20 , 5.10202389065e-22 , 1.31198437952e-23 , 2.36359293724e-25 ,
 6.56603766824e-29 , 1.26848695496e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 4.80383173017e-21 , 2.38977619212e-19 , 9.04767481567e-18 ,
 2.67417764845e-16 , 6.17424696518e-15 , 1.11440527564e-13 , 1.57382891471e-12 ,
 1.74094879312e-11 , 1.51027603004e-10 , 1.02886298904e-09 , 5.51216974972e-09 ,
 2.32594358474e-08 , 7.74121172241e-08 , 2.03468740223e-07 , 4.2274980847e-07  ,
 6.94722278031e-07 , 9.03077073187e-07 , 9.28242045835e-07 , 7.53824404751e-07 ,
 4.83118063916e-07 , 2.4401372895e-07  , 9.69863839338e-08 , 3.02900091429e-08 ,
 7.42283801981e-09 , 1.42550143794e-09 , 2.14291175675e-10 , 2.51919294836e-11 ,
 2.3141297675e-12  , 1.65994152421e-13 , 9.29265553192e-15 , 4.05823877582e-16 ,
 1.38207884865e-17 , 3.66947127334e-19 , 7.51604431566e-21 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 2.06587761697e-22 , 1.00238872815e-20 , 3.7688892329e-19  , 1.10422770777e-17 ,
 2.52138419358e-16 , 4.48786325428e-15 , 6.22827843504e-14 , 6.74154999175e-13 ,
 5.69356891729e-12 , 3.75364877421e-11 , 1.93297950112e-10 , 7.78077434605e-10 ,
 2.4503144965e-09  , 6.04330574563e-09 , 1.16869320172e-08 , 1.77452395953e-08 ,
 2.1185926785e-08  , 1.99179762832e-08 , 1.47673477689e-08 , 8.6452474199e-09  ,
 4.0004383039e-09  , 1.46412292412e-09 , 4.24110172556e-10 , 9.78731159455e-11 ,
 1.96027754138e-11 , 6.39460387547e-12 , 6.04564987733e-12 , 6.70985604841e-12 ,
 6.07544266187e-12 , 4.32832597388e-12 , 2.42247149755e-12 , 1.06642924655e-12 ,
 3.69810920151e-13 , 1.01162068002e-13 , 2.18565476828e-14 , 3.73314051695e-15 ,
 5.04338959408e-16 , 5.3895140084e-17  , 4.55379282301e-18 , 3.0396731764e-19  ,
 1.6010330107e-20  , 6.64493215397e-22 , 2.16996825937e-23 , 5.56733434777e-25 ,
 9.9804033282e-27  , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 4.25149004531e-22 , 2.11464031805e-20 , 8.00563996023e-19 , 2.36604988866e-17 ,
 5.46242910622e-16 , 9.85837674414e-15 , 1.39210181293e-13 , 1.53971370064e-12 ,
 1.33548380713e-11 , 9.09609097059e-11 , 4.87215089977e-10 , 2.05534266907e-09 ,
 6.83861276671e-09 , 1.7968841181e-08  , 3.73217247389e-08 , 6.13115321719e-08 ,
 7.96727288707e-08 , 8.18664002755e-08 , 6.64635602375e-08 , 4.25841232952e-08 ,
 2.15032134859e-08 , 8.54493328423e-09 , 2.6682091249e-09  , 6.53771136227e-10 ,
 1.25536525408e-10 , 1.88696261172e-11 , 2.21812172962e-12 , 2.0374340509e-13  ,
 1.46139045388e-14 , 8.18079633722e-16 , 3.57255837971e-17 , 1.21664404182e-18 ,
 3.2301712371e-20  , 6.61576966361e-22 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.31433522669e-31 , 1.13350463355e-29 ,
 4.27305060765e-28 , 1.25612547673e-26 , 2.88042883295e-25 , 5.15461701444e-24 ,
 7.20246820481e-23 , 7.86312243208e-22 , 6.71244375832e-21 , 4.48484910432e-20 ,
 2.34787957147e-19 , 9.64298186632e-19 , 3.11141924926e-18 , 7.89874629958e-18 ,
 1.57999266564e-17 , 2.49375732207e-17 , 3.10934824617e-17 , 3.06529556691e-17 ,
 2.39029577381e-17 , 1.47431468888e-17 , 7.1889838019e-18  , 2.76876086245e-18 ,
 8.41224104754e-19 , 2.01340650187e-19 , 3.79051151783e-20 , 5.60497985807e-21 ,
 6.50076290808e-22 , 5.90653053456e-23 , 4.19962557772e-24 , 2.33453413114e-25 ,
 1.01383790592e-26 , 3.43749060699e-28 , 2.50632371826e-21 , 1.21609848256e-19 ,
 4.57241821298e-18 , 1.33964958116e-16 , 3.05894450493e-15 , 5.44467783826e-14 ,
 7.55615036475e-13 , 8.17885166189e-12 , 6.90744052306e-11 , 4.55392848123e-10 ,
 2.34509165169e-09 , 9.43963914365e-09 , 2.97272271457e-08 , 7.33174140982e-08 ,
 1.41785914913e-07 , 2.15285331313e-07 , 2.57027764673e-07 , 2.41644982891e-07 ,
 1.79157530549e-07 , 1.04884158196e-07 , 4.85331748514e-08 , 1.77619204416e-08 ,
 5.1420169066e-09  , 1.17717136933e-09 , 2.13005260156e-10 , 3.0532812993e-11  ,
 3.6143139523e-12  , 5.26579714316e-13 , 2.24160191824e-13 , 1.45857542019e-13 ,
 8.10391906055e-14 , 3.56553487652e-14 , 1.23638518632e-14 , 3.38213041008e-15 ,
 7.30725236695e-16 , 1.24809280379e-16 , 1.68614554703e-17 , 1.80186457469e-18 ,
 1.5224597163e-19  , 1.01624736602e-20 , 5.35269907527e-22 , 2.22158581104e-23 ,
 7.25480800063e-25 , 1.86131486458e-26 , 3.33672668262e-28 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.95747607505e-23 ,
 1.47079928657e-21 , 5.56795513786e-20 , 1.64551515528e-18 , 3.79871454249e-17 ,
 6.85523754972e-16 , 9.67935653061e-15 , 1.07044581069e-13 , 9.28329507243e-13 ,
 6.32187210484e-12 , 3.38553250448e-11 , 1.42788704752e-10 , 4.74974069678e-10 ,
 1.24768518214e-09 , 2.59073690338e-09 , 4.25478450984e-09 , 5.52738735083e-09 ,
 5.67800118943e-09 , 4.60851420783e-09 , 2.95204445612e-09 , 1.49034931985e-09 ,
 5.92127205034e-10 , 1.84867098652e-10 , 4.52907868062e-11 , 8.69577650599e-12 ,
 1.30696570354e-12 , 1.53622950624e-13 , 1.41101005936e-14 , 1.01203040229e-15 ,
 5.66510037617e-17 , 2.47388386508e-18 , 8.42469169023e-20 , 2.23670430507e-21 ,
 4.58075122939e-23 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 1.447503251e-29   , 7.08951591437e-28 , 2.67258371861e-26 ,
 7.8564491879e-25  , 1.80156705558e-23 , 3.22396029755e-22 , 4.5047908451e-21  ,
 4.91799768339e-20 , 4.19830457155e-19 , 2.80505329733e-18 , 1.46848359454e-17 ,
 6.03121252265e-17 , 1.94604023936e-16 , 4.94027866646e-16 , 9.88207971643e-16 ,
 1.55972297758e-15 , 1.94474492844e-15 , 1.91719213673e-15 , 1.49501285014e-15 ,
 9.22111576807e-16 , 4.49635701199e-16 , 1.73172421325e-16 , 5.26144446322e-17 ,
 1.25928708315e-17 , 2.37077916878e-18 , 3.50564018245e-19 , 4.06590857491e-20 ,
 3.69424535059e-21 , 2.62665996119e-22 , 1.46013667571e-23 , 6.34105918572e-25 ,
 2.14998189178e-26 , 2.40524126757e-20 , 1.16705203555e-18 , 4.38800809254e-17 ,
 1.2856201969e-15  , 2.93557426662e-14 , 5.22508862985e-13 , 7.25140339413e-12 ,
 7.84899053594e-11 , 6.62885665793e-10 , 4.37026406985e-09 , 2.25051180055e-08 ,
 9.05892921942e-08 , 2.85282988581e-07 , 7.03604507291e-07 , 1.36067549613e-06 ,
 2.06602662313e-06 , 2.46661582309e-06 , 2.31899203234e-06 , 1.71931931253e-06 ,
 1.00654076948e-06 , 4.65757837821e-07 , 1.70455625491e-07 , 4.93462561072e-08 ,
 1.12966784716e-08 , 2.04348918884e-09 , 2.91769712116e-10 , 3.28412699186e-11 ,
 2.91446723819e-12 , 2.07796551483e-13 , 1.48481132534e-14 , 2.59251844559e-15 ,
 9.48636780548e-16 , 3.23873104562e-16 , 8.84899917011e-17 , 1.91169260212e-17 ,
 3.26520785099e-18 , 4.41122299667e-19 , 4.71396224528e-20 , 3.98299501718e-21 ,
 2.65866357694e-22 , 1.40035059824e-23 , 5.81201927436e-25 , 1.89797232778e-26 ,
 4.86949359095e-28 , 8.72940387732e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 1.61476204104e-24 , 8.02948624022e-23 ,
 3.03959437827e-21 , 8.98263212178e-20 , 2.07355533656e-18 , 3.74173633271e-17 ,
 5.28277682043e-16 , 5.84168147334e-15 , 5.06551967728e-14 , 3.44910656992e-13 ,
 1.84678707781e-12 , 7.78758015235e-12 , 2.58993021593e-11 , 6.80181596771e-11 ,
 1.41201541127e-10 , 2.31839533855e-10 , 3.01109475565e-10 , 3.09242061903e-10 ,
 2.50939620114e-10 , 1.60710803319e-10 , 8.1121119334e-11  , 3.22251351429e-11 ,
 1.0059656706e-11  , 2.46425942265e-12 , 4.73092653276e-13 , 7.11001411784e-14 ,
 8.35673995268e-15 , 7.67521359562e-16 , 5.50475062395e-17 , 3.081334175e-18   ,
 1.34555146367e-19 , 4.58212572013e-21 , 1.21650880862e-22 , 2.49127016705e-24 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 5.78598067251e-28 , 2.83383142868e-26 , 1.06828898179e-24 , 3.14039109234e-23 ,
 7.20124956998e-22 , 1.28868601557e-20 , 1.80066143171e-19 , 1.96582905937e-18 ,
 1.67815230063e-17 , 1.12123991103e-16 , 5.8698436014e-16  , 2.41080488515e-15 ,
 7.77873984401e-15 , 1.97473524576e-14 , 3.95007902082e-14 , 6.23454696667e-14 ,
 7.77356220869e-14 , 7.66342779608e-14 , 5.97588672088e-14 , 3.6858775672e-14  ,
 1.79729024789e-14 , 6.92207276292e-15 , 2.10311209682e-15 , 5.0336403177e-16  ,
 9.47651236007e-17 , 1.40127950154e-17 , 1.62523078372e-18 , 1.47666902877e-19 ,
 1.04993227188e-20 , 5.83647917825e-22 , 2.53465723593e-23 , 8.59393833036e-25 ,
 1.82522975302e-19 , 8.8562337277e-18  , 3.32986225816e-16 , 9.75599425007e-15 ,
 2.22767546238e-13 , 3.96508508125e-12 , 5.50276434583e-11 , 5.95624638769e-10 ,
 5.03034158883e-09 , 3.3163971163e-08  , 1.70781232582e-07 , 6.87441451132e-07 ,
 2.16488446817e-06 , 5.33933858848e-06 , 1.03255552056e-05 , 1.56781481065e-05 ,
 1.87180396241e-05 , 1.759778898e-05   , 1.30471420467e-05 , 7.63818582122e-06 ,
 3.53442704038e-06 , 1.29351118286e-06 , 3.7446657239e-07  , 8.57254135282e-08 ,
 1.55071080609e-08 , 2.21408355552e-09 , 2.49179489626e-10 , 2.20723263426e-11 ,
 1.53666436669e-12 , 8.40210523909e-14 , 3.6357603291e-15  , 1.38593648267e-16 ,
 9.43219140566e-18 , 1.77768261392e-18 , 3.70727789964e-19 , 6.3321021854e-20  ,
 8.55452885458e-21 , 9.1416203799e-22  , 7.72408146853e-23 , 5.15585231141e-24 ,
 2.71565042353e-25 , 1.12710435685e-26 , 3.68067065652e-28 , 9.44323682172e-30 ,
 1.69286244219e-31 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 6.91090919612e-26 , 3.43613857485e-24 , 1.30072836233e-22 , 3.84378926217e-21 ,
 8.87263830103e-20 , 1.60098380584e-18 , 2.26020158257e-17 , 2.49912264652e-16 ,
 2.16686199752e-15 , 1.47524261567e-14 , 7.89795877136e-14 , 3.3299168556e-13  ,
 1.10724564793e-12 , 2.90736378151e-12 , 6.03431500907e-12 , 9.90576445329e-12 ,
 1.2862858927e-11  , 1.32077085269e-11 , 1.07156737282e-11 , 6.86157474931e-12 ,
 3.46297428565e-12 , 1.37548269858e-12 , 4.29335537061e-13 , 1.05162536436e-13 ,
 2.01877831632e-14 , 3.03379787809e-15 , 3.56559384557e-16 , 3.27467696644e-17 ,
 2.34856243296e-18 , 1.31459667943e-19 , 5.74044511257e-21 , 1.95481464432e-22 ,
 5.18977583445e-24 , 1.06276047712e-25 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.82384829516e-26 , 8.93276163977e-25 ,
 3.36744477465e-23 , 9.89909449081e-22 , 2.26996726997e-20 , 4.06217705438e-19 ,
 5.67601841117e-18 , 6.19665737142e-17 , 5.28984693479e-16 , 3.53435591294e-15 ,
 1.85028344394e-14 , 7.59930360751e-14 , 2.45200290254e-13 , 6.2247313208e-13  ,
 1.24513808387e-12 , 1.96524470092e-12 , 2.45037081597e-12 , 2.41565440884e-12 ,
 1.88371019968e-12 , 1.16185689127e-12 , 5.66539181525e-13 , 2.18196556854e-13 ,
 6.6293989376e-14  , 1.58669667798e-14 , 2.98717225183e-15 , 4.41709266039e-16 ,
 5.12303984296e-17 , 4.65599452983e-18 , 3.41958368415e-19 , 9.38861333064e-20 ,
 4.08664497473e-19 , 1.73760530089e-18 , 6.93867585491e-18 , 6.863692832e-17   ,
 2.02921912117e-15 , 5.85504547084e-14 , 1.3357673147e-12  , 2.37743982046e-11 ,
 3.29941284293e-10 , 3.57131637499e-09 , 3.01615143707e-08 , 1.98848442901e-07 ,
 1.02399022142e-06 , 4.12184238931e-06 , 1.29804691791e-05 , 3.20142349412e-05 ,
 6.19111795911e-05 , 9.40048862993e-05 , 0.000112231825766 , 0.000105514895059 ,
 7.82295904019e-05 , 4.57979338364e-05 , 2.1192133778e-05  , 7.75578664301e-06 ,
 2.24527076291e-06 , 5.14002527314e-07 , 9.29793440476e-08 , 1.32754624641e-08 ,
 1.49405913513e-09 , 1.32343173128e-10 , 9.21309542306e-12 , 5.03343128772e-13 ,
 2.1553350662e-14  , 7.22543039374e-16 , 1.8983848658e-17  , 6.2521737431e-19  ,
 1.2776516247e-18  , 5.00357861937e-18 , 1.52930471937e-17 , 3.6463679766e-17  ,
 6.77994837505e-17 , 9.82809362327e-17 , 1.11043252292e-16 , 9.77728928848e-17 ,
 6.70792010615e-17 , 3.58552774026e-17 , 1.49305903388e-17 , 4.84317898431e-18 ,
 1.223745197e-18   , 2.40846692374e-19 , 3.69203433556e-20 , 4.40813951886e-21 ,
 4.09921843928e-22 , 2.96890534785e-23 , 1.67469638188e-24 , 7.3572626613e-26  ,
 2.51729306529e-27 , 6.70789435848e-29 , 1.3918396879e-30  , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 2.31578603736e-27 , 1.15132569591e-25 , 4.35817225995e-24 ,
 1.28784941002e-22 , 2.97264420219e-21 , 5.36361983754e-20 , 7.57172199317e-19 ,
 8.37155791738e-18 , 7.2579718894e-17  , 4.94090244946e-16 , 2.6449022438e-15  ,
 1.11499578383e-14 , 3.70699945368e-14 , 9.73220612469e-14 , 2.01961946015e-13 ,
 3.31480115652e-13 , 4.30363459593e-13 , 4.41831214948e-13 , 3.58413136389e-13 ,
 2.29471945503e-13 , 1.15798537184e-13 , 4.59900480183e-14 , 1.43538116905e-14 ,
 3.515599645e-15   , 6.74839604781e-16 , 1.01409123337e-16 , 1.19180404443e-17 ,
 1.0945295725e-18  , 7.84964528386e-20 , 4.39371256736e-21 , 1.91857031828e-22 ,
 6.53329482515e-24 , 1.73448667628e-25 , 3.55174964584e-27 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4.53955810846e-25 ,
 2.22336422608e-23 , 8.38156949353e-22 , 2.46388445691e-20 , 5.64994816381e-19 ,
 1.01107580242e-17 , 1.41276088974e-16 , 1.54234791843e-15 , 1.31664281558e-14 ,
 8.79701128943e-14 , 4.60535518944e-13 , 1.89146654366e-12 , 6.10303482351e-12 ,
 1.54933552397e-11 , 3.09914848717e-11 , 4.89149373927e-11 , 6.0989725603e-11  ,
 6.01256342863e-11 , 4.68855437901e-11 , 2.8918616124e-11  , 1.41011593019e-11 ,
 5.43091194334e-12 , 1.65005728718e-12 , 3.94928777206e-13 , 7.43507124767e-14 ,
 1.09941431397e-14 , 1.27512779764e-15 , 1.15923995222e-16 , 8.82819819326e-18 ,
 4.51121824047e-18 , 2.19199397034e-17 , 9.32987173495e-17 , 3.1898353033e-16  ,
 1.0854620368e-15  , 1.12017854956e-14 , 2.79730661504e-13 , 6.32458789812e-12 ,
 1.12508349006e-10 , 1.56134428343e-09 , 1.69001111941e-08 , 1.42729693606e-07 ,
 9.40986476907e-07 , 4.8457052839e-06  , 1.95052970498e-05 , 6.14259069779e-05 ,
 0.000151497098474 , 0.000292974799754 , 0.000444847972875 , 0.000531101117712 ,
 0.000499315397563 , 0.000370196444878 , 0.000216724032452 , 0.000100284975847 ,
 3.67017726633e-05 , 1.06250237276e-05 , 2.43235209711e-06 , 4.39994923106e-07 ,
 6.28218680816e-08 , 7.07015564596e-09 , 6.26271618504e-10 , 4.35980190416e-11 ,
 2.38190991524e-12 , 1.01994350429e-13 , 3.41949552768e-15 , 9.20357585769e-17 ,
 1.62827968587e-17 , 7.03518359894e-17 , 2.69344498884e-16 , 8.11425412591e-16 ,
 1.9170512243e-15  , 3.54384311979e-15 , 5.11813536581e-15 , 5.76910286162e-15 ,
 5.07193176215e-15 , 3.47626354469e-15 , 1.85692683928e-15 , 7.72911670678e-16 ,
 2.50643037228e-16 , 6.33181721911e-17 , 1.24599658681e-17 , 1.90984698246e-18 ,
 2.28011666287e-19 , 2.12021632924e-20 , 1.53553181163e-21 , 8.66136166148e-23 ,
 3.80502112843e-24 , 1.3018698859e-25  , 3.46907723016e-27 , 7.19780128703e-29 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 6.06967062356e-29 , 3.0174216908e-27  ,
 1.14217939382e-25 , 3.3750879167e-24  , 7.79023420127e-23 , 1.40556235874e-21 ,
 1.98411905176e-20 , 2.1935931353e-19  , 1.90167810736e-18 , 1.29447796844e-17 ,
 6.92881717154e-17 , 2.92064137202e-16 , 9.70907582947e-16 , 2.54866472815e-15 ,
 5.28827404919e-15 , 8.67847596909e-15 , 1.12658333964e-14 , 1.15645410405e-14 ,
 9.38001684828e-15 , 6.00484384711e-15 , 3.02993280794e-15 , 1.20325367672e-15 ,
 3.75516879845e-16 , 9.1967759954e-17  , 1.76528689124e-17 , 2.65261525387e-18 ,
 3.11736715019e-19 , 2.86285445427e-20 , 2.05311262587e-21 , 1.1491777968e-22  ,
 5.01796527837e-24 , 1.70874688419e-25 , 4.53641679672e-27 , 9.28906069861e-29 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 8.93077784015e-24 , 4.37407595332e-22 , 1.64892558505e-20 , 4.84725697584e-19 ,
 1.11152739218e-17 , 1.9891128509e-16  , 2.7793572295e-15  , 3.03429679335e-14 ,
 2.59026191533e-13 , 1.73065641206e-12 , 9.06022196196e-12 , 3.72112595321e-11 ,
 1.20066418046e-10 , 3.04804367162e-10 , 6.0970266205e-10  , 9.62314896036e-10 ,
 1.19986500201e-09 , 1.18286553334e-09 , 9.22390165519e-10 , 5.68922634931e-10 ,
 2.7741537393e-10  , 1.06843588906e-10 , 3.24619592991e-11 , 7.76952533188e-12 ,
 1.46271879273e-12 , 2.16290333287e-13 , 2.50860002468e-14 , 2.28188554563e-15 ,
 1.84902749952e-16 , 1.6576012516e-16  , 8.4725405049e-16  , 3.60747303172e-15 ,
 1.2151691127e-14  , 3.31849938577e-14 , 1.03026698933e-13 , 1.1451560894e-12  ,
 2.3722777909e-11  , 4.19762261874e-10 , 5.82346966048e-09 , 6.30325237151e-08 ,
 5.32339863916e-07 , 3.50960313287e-06 , 1.80730571525e-05 , 7.27490277717e-05 ,
 0.000229100587454 , 0.000565039670809 , 0.00109270993356  , 0.00165915225232  ,
 0.00198085114329  , 0.00186229974508  , 0.00138072398386  , 0.000808316972315 ,
 0.000374033498401 , 0.000136886829864 , 3.96282171066e-05 , 9.07195875092e-06 ,
 1.6410518024e-06  , 2.34307112268e-07 , 2.63696035039e-08 , 2.33580915226e-09 ,
 1.626078029e-10   , 8.88382435869e-12 , 3.8041034334e-13  , 1.27660216215e-14 ,
 4.33082008104e-16 , 5.92018617254e-16 , 2.78496668506e-15 , 1.0535830491e-14  ,
 3.14930927422e-14 , 7.40315498519e-14 , 1.36417638343e-13 , 1.96624965364e-13 ,
 2.21362492432e-13 , 1.94475210388e-13 , 1.33247671325e-13 , 7.1174843341e-14  ,
 2.963253121e-14   , 9.61484438013e-15 , 2.43136517867e-15 , 4.79234171406e-16 ,
 7.36475650599e-17 , 8.82885876332e-18 , 8.26343174087e-19 , 6.0469342121e-20  ,
 3.46736417835e-21 , 1.56337231884e-22 , 5.57176194663e-24 , 1.58132898384e-25 ,
 3.60840389795e-27 , 2.24739113174e-29 , 4.43583107091e-31 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.18541282158e-30 , 5.89156414322e-29 , 2.22996952931e-27 , 6.58888512538e-26 ,
 1.52065281276e-24 , 2.74328445876e-23 , 3.87182632112e-22 , 4.27972212553e-21 ,
 3.7092796125e-20  , 2.52417909362e-19 , 1.35062962027e-18 , 5.69096326452e-18 ,
 1.89101953107e-17 , 4.96163464392e-17 , 1.02898305769e-16 , 1.68777429882e-16 ,
 2.18983880021e-16 , 2.24679330995e-16 , 1.82153691797e-16 , 1.16561123691e-16 ,
 5.87926725489e-17 , 2.33403323098e-17 , 7.28215456392e-18 , 1.78306074639e-18 ,
 3.42186925683e-19 , 5.14108953999e-20 , 6.0410796658e-21  , 5.54730885491e-22 ,
 3.977966889e-23   , 2.22642521153e-24 , 9.72135516899e-26 , 3.31024230723e-27 ,
 8.78782820816e-29 , 1.79925309986e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.38958734235e-22 , 6.80585799802e-21 ,
 2.56565123718e-19 , 7.5421055806e-18  , 1.72948473525e-16 , 3.09496674263e-15 ,
 4.3245501065e-14  , 4.72122416706e-13 , 4.03032662477e-12 , 2.69282058875e-11 ,
 1.40972824345e-10 , 5.78989827808e-10 , 1.86817741684e-09 , 4.74261366794e-09 ,
 9.48668880745e-09 , 1.49731705661e-08 , 1.86693393247e-08 , 1.84048355277e-08 ,
 1.43519603964e-08 , 8.85217062191e-09 , 4.31645371865e-09 , 1.66243636794e-09 ,
 5.05092933194e-10 , 1.20890187288e-10 , 2.27592216196e-11 , 3.36537686491e-12 ,
 3.90329928115e-13 , 3.55437046098e-14 , 3.2141596287e-15  , 4.89248035449e-15 ,
 2.56793732611e-14 , 1.09356065848e-13 , 3.67809516166e-13 , 9.80163029256e-13 ,
 2.15789873458e-12 , 6.44643978243e-12 , 7.36892054844e-11 , 1.23632793037e-09 ,
 1.7096872212e-08  , 1.85019263246e-07 , 1.56255857965e-06 , 1.03016082488e-05 ,
 5.3049173899e-05  , 0.00021353752068  , 0.000672470449739 , 0.00165853997045  ,
 0.00320739090465  , 0.00487004801556  , 0.0058143188282   , 0.00546633930986  ,
 0.0040527878549   , 0.00237262280268  , 0.00109788664307  , 0.000401798830219 ,
 0.000116319234603 , 2.66285837544e-05 , 4.81691843683e-06 , 6.87752968744e-07 ,
 7.74017182786e-08 , 6.85621389526e-09 , 4.77296647908e-10 , 2.60763642737e-11 ,
 1.11665077385e-12 , 3.78737352304e-14 , 4.13318202411e-15 , 1.83389545995e-14 ,
 8.58787775602e-14 , 3.21627168302e-13 , 9.54940927376e-13 , 2.23498002982e-12 ,
 4.10682718657e-12 , 5.9088538469e-12  , 6.64495715101e-12 , 5.83408754491e-12 ,
 3.99601826695e-12 , 2.13433077939e-12 , 8.88732037154e-13 , 2.88484049138e-13 ,
 7.3004748819e-14  , 1.44071126245e-14 , 2.21834494355e-15 , 2.6674867798e-16  ,
 2.50866562406e-17 , 1.84960383956e-18 , 1.07300443632e-19 , 4.92475735356e-21 ,
 1.80208232814e-22 , 5.30991816256e-24 , 1.27381085719e-25 , 1.18138207219e-27 ,
 2.33120594721e-29 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.71030833219e-21 ,
 8.3766707475e-20  , 3.15781135501e-18 , 9.28284651398e-17 , 2.12865507834e-15 ,
 3.80929449087e-14 , 5.32266943914e-13 , 5.81089708074e-12 , 4.96053828193e-11 ,
 3.31433178015e-10 , 1.73509781459e-09 , 7.12622443064e-09 , 2.29935845316e-08 ,
 5.83722334355e-08 , 1.16762454708e-07 , 1.84290239254e-07 , 2.29782796882e-07 ,
 2.26527276094e-07 , 1.7664436557e-07  , 1.08952785559e-07 , 5.31270438032e-08 ,
 2.0461317437e-08  , 6.2166992016e-09  , 1.48792010621e-09 , 2.80121193022e-10 ,
 4.14211667237e-11 , 4.80427483499e-12 , 4.38386769453e-13 , 4.75344679657e-14 ,
 1.14926361176e-13 , 6.11567683211e-13 , 2.60442428349e-12 , 8.75764625092e-12 ,
 2.32795138198e-11 , 4.91519929513e-11 , 8.83096589101e-11 , 2.66528591482e-10 ,
 2.95205550131e-09 , 3.95181820892e-08 , 4.26821328825e-07 , 3.60424737315e-06 ,
 2.37618498486e-05 , 0.000122363997384 , 0.000492548743344 , 0.00155113009353  ,
 0.00382561235255  , 0.007398214383    , 0.0112333233914   , 0.0134113921442   ,
 0.0126087375399   , 0.00934821925071  , 0.00547272617091  , 0.00253240125546  ,
 0.000926795009767 , 0.000268303633715 , 6.14218775283e-05 , 1.11107739346e-05 ,
 1.58638097349e-06 , 1.78535926212e-07 , 1.58146425835e-08 , 1.10093960682e-09 ,
 6.01486116832e-11 , 2.57752660111e-12 , 9.87023739519e-14 , 8.32961432811e-14 ,
 4.55682614245e-13 , 2.0944679079e-12  , 7.74175030298e-12 , 2.27844021417e-11 ,
 5.30174534163e-11 , 9.70572352232e-11 , 1.3931433614e-10  , 1.56440848774e-10 ,
 1.37234246337e-10 , 9.3958985503e-11  , 5.01816235968e-11 , 2.09010299649e-11 ,
 6.7888013245e-12  , 1.71991976977e-12 , 3.40035781682e-13 , 5.25082424978e-14 ,
 6.34247076725e-15 , 6.00680329172e-16 , 4.47682452797e-17 , 2.63998962385e-18 ,
 1.24126147082e-19 , 4.69927242162e-21 , 1.44842052849e-22 , 3.66999909477e-24 ,
 4.563624666e-26   , 9.00503304024e-28 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.66463378949e-20 , 8.15296803929e-19 , 3.07348060197e-17 , 9.03494397994e-16 ,
 2.0718084002e-14  , 3.70756559168e-13 , 5.18052519063e-12 , 5.65571449648e-11 ,
 4.82806490661e-10 , 3.22582107972e-09 , 1.68876125776e-08 , 6.93591544602e-08 ,
 2.23795306567e-07 , 5.68133770476e-07 , 1.13644261559e-06 , 1.79368686663e-06 ,
 2.23646345359e-06 , 2.20477764699e-06 , 1.71926999428e-06 , 1.06043153089e-06 ,
 5.17082625312e-07 , 1.99148888782e-07 , 6.05067949169e-08 , 1.44818453976e-08 ,
 2.72640432898e-09 , 4.03150069119e-10 , 4.67612796481e-11 , 4.28384863539e-12 ,
 6.11460993601e-13 , 2.13933221581e-12 , 1.14648077015e-11 , 4.88196856857e-11 ,
 1.64132524981e-10 , 4.36119367411e-10 , 9.1684096168e-10  , 1.53593143443e-09 ,
 2.29132638517e-09 , 7.2225282548e-09  , 7.30709497108e-08 , 7.735638265e-07   ,
 6.52437043972e-06 , 4.30103081799e-05 , 0.000221484857168 , 0.000891537224401 ,
 0.00280762100017  , 0.00692454463584  , 0.0133911282682   , 0.0203328623131   ,
 0.0242752728106   , 0.0228224288937   , 0.0169207320286   , 0.00990590084813  ,
 0.00458376958043  , 0.00167754409532  , 0.000485642641305 , 0.000111176589091 ,
 2.01110418328e-05 , 2.87142681195e-06 , 3.23158726821e-07 , 2.86252816007e-08 ,
 1.99276621025e-09 , 1.08893579958e-10 , 4.72259318304e-12 , 4.40890699818e-13 ,
 1.68091697126e-12 , 9.04112020148e-12 , 4.05530992036e-11 , 1.47414919499e-10 ,
 4.28924198302e-10 , 9.90493975044e-10 , 1.80428863183e-09 , 2.58169452769e-09 ,
 2.8934751297e-09  , 2.53545695281e-09 , 1.73508759531e-09 , 9.2669104783e-10  ,
 3.8616931267e-10  , 1.25565876635e-10 , 3.18704589056e-11 , 6.31959253305e-12 ,
 9.80395531028e-13 , 1.19272594877e-13 , 1.14204472773e-14 , 8.65310982198e-16 ,
 5.22751281316e-17 , 2.54256333311e-18 , 1.00651650752e-19 , 3.27450654498e-21 ,
 8.8012779501e-23  , 1.37796956037e-24 , 2.71886970897e-26 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 1.28023968306e-19 , 6.27029998104e-18 , 2.36375823717e-16 ,
 6.94861169492e-15 , 1.59339029785e-13 , 2.85142151266e-12 , 3.98424804906e-11 ,
 4.34970753339e-10 , 3.71317723147e-09 , 2.48092053808e-08 , 1.29879568171e-07 ,
 5.33428688547e-07 , 1.7211691494e-06  , 4.36941387857e-06 , 8.74017422443e-06 ,
 1.37949206616e-05 , 1.72002351574e-05 , 1.69565453605e-05 , 1.32225939812e-05 ,
 8.15558674584e-06 , 3.97678877197e-06 , 1.53161801633e-06 , 4.65346795415e-07 ,
 1.11377248736e-07 , 2.09682817372e-08 , 3.10055572587e-09 , 3.59655185439e-10 ,
 3.31981128016e-11 , 6.89940042142e-12 , 3.15180189346e-11 , 1.69505178066e-10 ,
 7.2164401263e-10  , 2.42555712032e-09 , 6.44309947907e-09 , 1.35359144899e-08 ,
 2.25104002195e-08 , 2.99692090925e-08 , 3.79949852404e-08 , 1.26407390329e-07 ,
 1.11205280669e-06 , 9.26268320477e-06 , 6.10156138346e-05 , 0.000314190070229 ,
 0.0012646975493   , 0.00398277345121  , 0.00982286862989  , 0.0189960929733   ,
 0.0288433457705   , 0.0344358839678   , 0.0323749405158   , 0.0240030408447   ,
 0.0140520955156   , 0.00650234329552  , 0.00237969370183  , 0.000688912284408 ,
 0.000157710446906 , 2.85286806829e-05 , 4.07328587113e-06 , 4.58419689223e-07 ,
 4.06069504408e-08 , 2.827309982e-09   , 1.55249495865e-10 , 8.32214444688e-12 ,
 5.92974031855e-12 , 2.84290938327e-11 , 1.44141732566e-10 , 6.26369753274e-10 ,
 2.22930382857e-09 , 6.39193485016e-09 , 1.46142302122e-08 , 2.64472917157e-08 ,
 3.7684554458e-08  , 4.21281320745e-08 , 3.68638774257e-08 , 2.52134346159e-08 ,
 1.34688116332e-08 , 5.61795133609e-09 , 1.83005926946e-09 , 4.65908571698e-10 ,
 9.28284392393e-11 , 1.45077996607e-11 , 1.78492415233e-12 , 1.73801264858e-13 ,
 1.34940845119e-14 , 8.43413437214e-16 , 4.28914824706e-17 , 1.79165256362e-18 ,
 6.1801336377e-20  , 1.75861361447e-21 , 3.2700784679e-23  , 6.45203436467e-25 ,
 2.20421146107e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7.77160199627e-19 ,
 3.80634005448e-17 , 1.43490226695e-15 , 4.21810425297e-14 , 9.67256005532e-13 ,
 1.73093471583e-11 , 2.41860883562e-10 , 2.6404583608e-09  , 2.25405726493e-08 ,
 1.50602479062e-07 , 7.88424483808e-07 , 3.23814010425e-06 , 1.04482322914e-05 ,
 2.65242095449e-05 , 5.30565927216e-05 , 8.37410637789e-05 , 0.000104412778056 ,
 0.000102933476846 , 8.0266796241e-05  , 4.95078968987e-05 , 2.41408073565e-05 ,
 9.29757590761e-06 , 2.82485391763e-06 , 6.7610749778e-07  , 1.27286432136e-07 ,
 1.88217170457e-08 , 2.18352621733e-09 , 2.04476758074e-10 , 6.76088661934e-11 ,
 3.67683388039e-10 , 1.98064291467e-09 , 8.42936654431e-09 , 2.83211291944e-08 ,
 7.51985043353e-08 , 1.57904904618e-07 , 2.62304674135e-07 , 3.45001551223e-07 ,
 3.65803933853e-07 , 4.05605177774e-07 , 1.40631262179e-06 , 1.03732532761e-05 ,
 6.77916767022e-05 , 0.000348913669477 , 0.00140442777167  , 0.0044228025642   ,
 0.0109081282939   , 0.0210948375311   , 0.0320300439405   , 0.0382404623016   ,
 0.0359518197201   , 0.0266549678064   , 0.0156046125991   , 0.00722074141903  ,
 0.00264260930226  , 0.000765025352574 , 0.000175134765914 , 3.16806180172e-05 ,
 4.52332102224e-06 , 5.09075439636e-07 , 4.51032040885e-08 , 3.15342647703e-09 ,
 1.95132271339e-10 , 5.04610084376e-11 , 1.04361247643e-10 , 4.04348895501e-10 ,
 1.86349626979e-09 , 7.76132972861e-09 , 2.68970028596e-08 , 7.56956710232e-08 ,
 1.70850265367e-07 , 3.06537440507e-07 , 4.34380599672e-07 , 4.83986600591e-07 ,
 4.2276601174e-07  , 2.88999942634e-07 , 1.5446454735e-07  , 6.45359455382e-08 ,
 2.10870462312e-08 , 5.3951077238e-09  , 1.08319771746e-09 , 1.71263072e-10    ,
 2.14362204389e-11 , 2.13966905215e-12 , 1.71917386075e-13 , 1.12351289514e-14 ,
 6.02734060942e-16 , 2.66816446943e-17 , 9.73806696844e-19 , 2.91098393636e-20 ,
 6.11321763123e-22 , 1.20616931219e-23 , 1.08698996298e-28 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 3.71869170808e-18 , 1.82132399543e-16 , 6.86597070279e-15 ,
 2.01835211284e-13 , 4.62829528466e-12 , 8.28247841059e-11 , 1.1572981512e-09  ,
 1.26345258243e-08 , 1.07856064485e-07 , 7.20629016224e-07 , 3.77259102022e-06 ,
 1.54944177031e-05 , 4.99945246874e-05 , 0.000126917665296 , 0.000253874441213 ,
 0.000400698851601 , 0.0004996124765   , 0.000492534057989 , 0.000384074570158 ,
 0.000236894022326 , 0.000115513146693 , 4.44886632762e-05 , 1.35168538547e-05 ,
 3.23515711099e-06 , 6.09062337177e-07 , 9.00616111553e-08 , 1.04505955976e-08 ,
 1.00591985943e-09 , 5.63210481318e-10 , 3.40150453261e-09 , 1.83327899377e-08 ,
 7.7978753607e-08  , 2.61833049457e-07 , 6.94765820105e-07 , 1.45790562571e-06 ,
 2.42001167814e-06 , 3.17729649226e-06 , 3.30321249252e-06 , 2.79776392263e-06 ,
 2.80084978045e-06 , 9.81210438104e-06 , 5.91961315475e-05 , 0.000303121520327 ,
 0.00121972679301  , 0.00384107168695  , 0.00947337194721  , 0.0183202124509   ,
 0.0278171001016   , 0.0332106558912   , 0.0312230407663   , 0.0231490131216   ,
 0.0135521222328   , 0.00627099005042  , 0.00229502425417  , 0.000664400821991 ,
 0.000152099167719 , 2.75137354527e-05 , 3.92851658216e-06 , 4.42309843565e-07 ,
 3.94056918071e-08 , 3.06572444207e-09 , 7.00850591233e-10 , 9.35871303777e-10 ,
 1.7514040035e-09  , 4.99181594869e-09 , 1.97959692157e-08 , 7.76633793645e-08 ,
 2.60228766949e-07 , 7.15478407723e-07 , 1.58858125293e-06 , 2.81862665212e-06 ,
 3.96554587558e-06 , 4.39949535857e-06 , 3.83480604129e-06 , 2.6203905047e-06  ,
 1.40220513095e-06 , 5.87551385858e-07 , 1.92953571005e-07 , 4.97616491784e-08 ,
 1.01119351974e-08 , 1.62739672123e-09 , 2.08920654299e-10 , 2.15896921428e-11 ,
 1.81405265387e-12 , 1.25038572184e-13 , 7.1053544108e-15  , 3.32602343373e-16 ,
 1.27449388323e-17 , 3.9598501907e-19  , 9.03048448067e-21 , 1.78195108639e-22 ,
 4.11178036419e-27 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.40052569517e-17 ,
 6.85943136746e-16 , 2.58584715981e-14 , 7.60147443735e-13 , 1.74309864325e-11 ,
 3.11932925457e-10 , 4.35859147506e-09 , 4.75838801717e-08 , 4.06205196745e-07 ,
 2.7140175447e-06  , 1.4208251385e-05  , 5.83547436261e-05 , 0.000188288306585 ,
 0.000477994588883 , 0.000956136475343 , 0.00150910342063  , 0.0018816297932   ,
 0.00185497120523  , 0.00144649340842  , 0.000892185185933 , 0.000435043135524 ,
 0.000167552249429 , 5.09068850776e-05 , 1.21841793325e-05 , 2.29383759988e-06 ,
 3.39189451663e-07 , 3.93773381744e-08 , 3.99326750549e-09 , 3.90352020069e-09 ,
 2.50087396064e-08 , 1.34754243209e-07 , 5.72686521971e-07 , 1.92112371529e-06 ,
 5.09252116922e-06 , 1.06751087429e-05 , 1.77013025385e-05 , 2.32145283584e-05 ,
 2.40676953708e-05 , 1.97608237704e-05 , 1.34285748892e-05 , 1.2517553126e-05  ,
 4.25144012088e-05 , 0.000206446265476 , 0.000827940578147 , 0.00260675323681  ,
 0.00642904751473  , 0.0124328935891   , 0.0188778940195   , 0.0225381955018   ,
 0.021189313428    , 0.015709927111    , 0.00919705956948  , 0.0042557666261   ,
 0.00155750341406  , 0.000450891709877 , 0.000103222099005 , 1.86738818269e-05 ,
 2.66888430578e-06 , 3.03772028841e-07 , 3.11442872233e-08 , 8.21858919226e-09 ,
 1.03385561514e-08 , 1.65094589304e-08 , 2.65205547694e-08 , 5.54163772858e-08 ,
 1.76293184167e-07 , 6.3282992263e-07  , 2.03020974702e-06 , 5.42351735937e-06 ,
 1.17973896648e-05 , 2.06377006376e-05 , 2.87694497599e-05 , 3.17457991395e-05 ,
 2.76032946581e-05 , 1.88619422448e-05 , 1.01170634155e-05 , 4.26033796189e-06 ,
 1.41066676911e-06 , 3.68409440993e-07 , 7.62577017389e-08 , 1.25974134902e-08 ,
 1.67541637263e-09 , 1.81123618099e-10 , 1.60504727753e-11 , 1.17133326049e-12 ,
 7.03387906159e-14 , 3.45481382935e-15 , 1.37538244046e-16 , 4.39521373849e-18 ,
 1.05813713394e-19 , 2.08876693778e-21 , 1.21284606191e-25 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 4.14541287401e-17 , 2.0303215569e-15  , 7.65384322718e-14 ,
 2.24995871926e-12 , 5.15939377713e-11 , 9.23289568676e-10 , 1.29009851626e-08 ,
 1.40843420538e-07 , 1.2023258537e-06  , 8.03321446288e-06 , 4.20549715094e-05 ,
 0.000172724075196 , 0.000557314137707 , 0.00141481511499  , 0.00283006621575  ,
 0.00446679184084  , 0.00556943181817  , 0.00549052512322  , 0.00428147260568  ,
 0.0026407769372   , 0.00128768320423  , 0.000495937528518 , 0.00015067917541  ,
 3.60639254169e-05 , 6.78952581221e-06 , 1.00397527353e-06 , 1.16665899127e-07 ,
 1.30449164197e-08 , 2.2171415384e-08  , 1.465433267e-07   , 7.88865813867e-07 ,
 3.34816565356e-06 , 1.12156387874e-05 , 2.968516033e-05   , 6.21287778932e-05 ,
 0.000102857588515 , 0.000134684124558 , 0.000139407773919 , 0.000113982975377 ,
 7.38417393921e-05 , 4.05136078224e-05 , 3.60628932307e-05 , 0.000113653814277 ,
 0.000439814884438 , 0.00138165365858  , 0.00340710920127  , 0.0065888242891   ,
 0.0100043532873   , 0.0119441322306   , 0.0112292912256   , 0.00832548670566  ,
 0.0048739881889   , 0.00225534704412  , 0.000825402101507 , 0.000238956499122 ,
 5.47170532321e-05 , 9.92336546452e-06 , 1.45551086853e-06 , 2.13798687047e-07 ,
 8.16108668102e-08 , 9.53774931686e-08 , 1.50516667511e-07 , 2.36505245697e-07 ,
 3.46734816088e-07 , 5.63334763433e-07 , 1.35464584955e-06 , 4.24885646436e-06 ,
 1.28532252148e-05 , 3.31395837427e-05 , 7.02982730378e-05 , 0.000120830022529 ,
 0.000166516455185 , 0.000182541918916 , 0.000158317361677 , 0.00010828450431  ,
 5.83378031301e-05 , 2.47714064027e-05 , 8.31074788138e-06 , 2.21282412474e-06 ,
 4.7064155526e-07  , 8.06228067932e-08 , 1.1224235164e-08  , 1.27986316283e-09 ,
 1.20032793574e-10 , 9.25051282721e-12 , 5.82469695093e-13 , 2.97085924207e-14 ,
 1.21618442151e-15 , 3.96346398781e-17 , 9.88325073444e-19 , 1.95294429109e-20 ,
 2.79424390626e-24 , 1.57141645505e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.01822945743e-30 , 9.62951045726e-17 , 4.71629805233e-15 , 1.7779354104e-13  ,
 5.22650015187e-12 , 1.19849187138e-10 , 2.14473849213e-09 , 2.99681057854e-08 ,
 3.27169628726e-07 , 2.79292068923e-06 , 1.86606075262e-05 , 9.76908212133e-05 ,
 0.00040122620807  , 0.00129460260778  , 0.00328651870368  , 0.00657405017247  ,
 0.0103760518069   , 0.0129374090264   , 0.0127541141732   , 0.00994556790413  ,
 0.00613434413061  , 0.00299119997424  , 0.00115202894513  , 0.000350017416702 ,
 8.37740378853e-05 , 1.57716226712e-05 , 2.33224064331e-06 , 2.71612116543e-07 ,
 3.62939379922e-08 , 1.02506601314e-07 , 6.87019342187e-07 , 3.69113629621e-06 ,
 1.56346519115e-05 , 5.22604274797e-05 , 0.000138005635072 , 0.00028815141487  ,
 0.000475912761143 , 0.000621722756288 , 0.00064211348713  , 0.000523840227993 ,
 0.000337313531115 , 0.000172338750817 , 7.70393523377e-05 , 6.65330235229e-05 ,
 0.000186747766657 , 0.000572412742105 , 0.00140935900428  , 0.0027252138465   ,
 0.00413788889352  , 0.0049401962599   , 0.00464453177837  , 0.00344349362225  ,
 0.00201592566347  , 0.00093283870748  , 0.000341418935202 , 9.8906526669e-05  ,
 2.27984410255e-05 , 4.41648090447e-06 , 1.07567116087e-06 , 7.00800174593e-07 ,
 7.96097253349e-07 , 1.10863354711e-06 , 1.75294764275e-06 , 2.70917619609e-06 ,
 3.77548357509e-06 , 5.17509183908e-06 , 9.28817956797e-06 , 2.39467950777e-05 ,
 6.65908538499e-05 , 0.000164181738813 , 0.000337849756443 , 0.000568424530812 ,
 0.000772530843736 , 0.000840495761167 , 0.000727411232931 , 0.000498949754671 ,
 0.00027093925426  , 0.000116619195434 , 3.99302989244e-05 , 1.09389220334e-05 ,
 2.41574020961e-06 , 4.33582154667e-07 , 6.3685895294e-08  , 7.68262517385e-09 ,
 7.60298414321e-10 , 6.13896790994e-11 , 4.01180845735e-12 , 2.10367826406e-13 ,
 8.78382053585e-15 , 2.90292260079e-16 , 7.41592172355e-18 , 1.4750833529e-19  ,
 1.05354254519e-22 , 3.06334336418e-24 , 1.33191978673e-25 , 4.52033112053e-27 ,
 1.19689581673e-28 , 2.42792991033e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.41580289179e-30 ,
 7.05915994772e-29 , 2.67832296179e-27 , 7.93554723563e-26 , 1.75322365795e-16 ,
 8.58685943115e-15 , 3.23704762517e-13 , 9.51577306478e-12 , 2.18206760408e-10 ,
 3.90487786696e-09 , 5.45622664114e-08 , 5.95670496219e-07 , 5.0850088357e-06  ,
 3.39749547904e-05 , 0.000177863514331 , 0.000730503669872 , 0.00235705429255  ,
 0.00598369180743  , 0.0119692275339   , 0.0188914476957   , 0.0235548540515   ,
 0.0232211331728   , 0.0181076751909   , 0.0111686644868   , 0.00544601154623  ,
 0.00209747360378  , 0.000637269015262 , 0.00015252568903  , 2.87154205627e-05 ,
 4.24719534003e-06 , 4.98127259975e-07 , 9.15855490842e-08 , 3.87622824363e-07 ,
 2.59280875078e-06 , 1.38712047488e-05 , 5.85651353183e-05 , 0.000195132991565 ,
 0.000513560813594 , 0.00106855397987  , 0.00175860466585  , 0.00228949590612  ,
 0.00235696668585  , 0.00191733583842  , 0.00123140779652  , 0.000624289041065 ,
 0.000252161240642 , 9.32926557011e-05 , 7.83119390492e-05 , 0.000188363360556 ,
 0.00045537021239  , 0.000879420559163 , 0.00133516008133  , 0.00159402491057  ,
 0.00149862497782  , 0.00111109908688  , 0.00065049288503  , 0.000301077620093 ,
 0.000110417957131 , 3.25962792952e-05 , 8.89817742682e-06 , 4.27645433466e-06 ,
 4.67225916364e-06 , 5.85927311095e-06 , 7.3470836488e-06  , 1.03357909064e-05 ,
 1.62192323524e-05 , 2.47347134076e-05 , 3.34967520037e-05 , 4.15226325876e-05 ,
 5.81757456929e-05 , 0.000116637722095 , 0.000286232845148 , 0.000664840632885 ,
 0.00131813233702  , 0.0021617072965   , 0.00289037266988  , 0.0031193004522   ,
 0.00269778789932  , 0.00186225703421  , 0.00102499814449  , 0.000450695957441 ,
 0.000159018338067 , 4.53048567244e-05 , 1.0494871781e-05  , 1.98807357023e-06 ,
 3.08795515838e-07 , 3.92703602517e-08 , 4.06776589932e-09 , 3.4065372333e-10  ,
 2.28825248541e-11 , 1.2242324424e-12  , 5.1880884418e-14  , 1.73579331016e-15 ,
 4.53905359432e-17 , 9.33478563202e-19 , 3.37454732387e-21 , 1.48351437087e-22 ,
 6.45012480362e-24 , 2.18904629491e-25 , 5.79606724633e-27 , 1.17574519294e-28 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 7.14400611591e-29 , 3.56232937929e-27 , 1.3515302954e-25  ,
 4.00373653e-24    , 2.49902154648e-16 , 1.22395917748e-14 , 4.614042947e-13   ,
 1.35636509898e-11 , 3.11028887172e-10 , 5.56595867967e-09 , 7.77722966343e-08 ,
 8.49060450456e-07 , 7.24810095328e-06 , 4.84274285724e-05 , 0.000253524182412 ,
 0.00104124978275  , 0.00335971244413  , 0.00852907117679  , 0.0170607706521   ,
 0.0269276071127   , 0.033574761759    , 0.0330990806712   , 0.025810428723    ,
 0.0159196593019   , 0.00776266939003  , 0.00298971016534  , 0.000908355493402 ,
 0.000217410770157 , 4.09370014951e-05 , 6.06759440121e-06 , 7.41398427338e-07 ,
 2.45587087523e-07 , 1.24009291393e-06 , 7.98035378866e-06 , 4.21817318078e-05 ,
 0.000177037694704 , 0.000586988854423 , 0.00153731238315  , 0.0031825281322   ,
 0.00521103961642  , 0.0067504137156   , 0.00691735480514  , 0.00560528232262  ,
 0.00359074397364  , 0.00181941494895  , 0.000731685839812 , 0.000238327050756 ,
 7.60061704446e-05 , 5.9877298776e-05  , 0.000117063489243 , 0.000221757806731 ,
 0.000336057707489 , 0.000401133483188 , 0.000377138133578 , 0.000279687910269 ,
 0.000163965830213 , 7.6541378087e-05  , 2.98974695644e-05 , 1.34810722058e-05 ,
 1.37011604887e-05 , 2.18977640461e-05 , 3.26510450503e-05 , 4.27659159828e-05 ,
 5.44357883183e-05 , 7.68474324422e-05 , 0.000119532649157 , 0.000180058961261 ,
 0.000239628531098 , 0.000281318326352 , 0.000331975262193 , 0.000509880928031 ,
 0.00104662126767  , 0.00223218869074  , 0.0042185077552   , 0.00670660547418  ,
 0.00880001414519  , 0.00942279495659  , 0.00816877321265  , 0.00570747046247  ,
 0.00321047706852  , 0.00145677886879  , 0.000535452751132 , 0.00016021555629  ,
 3.91821638255e-05 , 7.8433907965e-06  , 1.28266666834e-06 , 1.70517197237e-07 ,
 1.83040110884e-08 , 1.57537325581e-09 , 1.0803156246e-10  , 5.87452967116e-12 ,
 2.52751468895e-13 , 8.64242349424e-15 , 2.40081161836e-16 , 5.94031037605e-18 ,
 1.08555832952e-19 , 5.61417644716e-21 , 2.44540271438e-22 , 8.31849274561e-24 ,
 2.20908268991e-25 , 4.49968182046e-27 , 1.60001175323e-30 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.71511765349e-27 ,
 1.35391737605e-25 , 5.13663845448e-24 , 1.52149707579e-22 , 2.78599083548e-16 ,
 1.36449911575e-14 , 5.1438314469e-13  , 1.51210253593e-11 , 3.46740992377e-10 ,
 6.20503696289e-09 , 8.67020354833e-08 , 9.46548717255e-07 , 8.08032054079e-06 ,
 5.39878165337e-05 , 0.000282633570175 , 0.00116080501967  , 0.00374547119942  ,
 0.00950837044134  , 0.0190196710017   , 0.030019407701    , 0.0374297821215   ,
 0.0368994841804   , 0.0287739571192   , 0.0177475403698   , 0.00865397469409  ,
 0.00333299280206  , 0.00101266853859  , 0.000242413298781 , 4.57256679068e-05 ,
 6.94094330842e-06 , 1.15861822864e-06 , 9.84949835929e-07 , 3.79258929328e-06 ,
 2.07872101544e-05 , 0.00010532511654  , 0.000435807838353 , 0.00143311118187  ,
 0.00372648819841  , 0.00765976549839  , 0.0124526144979   , 0.0160197181372   ,
 0.0163137038915   , 0.0131569817406   , 0.00841476730155  , 0.00428429380338  ,
 0.00175357741838  , 0.000590247585218 , 0.000172511299119 , 5.33549220317e-05 ,
 3.34498465186e-05 , 4.60965068173e-05 , 6.66479998715e-05 , 7.9068850807e-05  ,
 7.44852872094e-05 , 5.59289117596e-05 , 3.47048755111e-05 , 2.11896465857e-05 ,
 2.06908812571e-05 , 3.64707782334e-05 , 7.21126690374e-05 , 0.000126886222143 ,
 0.000190190645705 , 0.000250961802052 , 0.000323280406547 , 0.000457500166972 ,
 0.000704309702701 , 0.00104761780644  , 0.00137761242899  , 0.00157365511562  ,
 0.00168126021972  , 0.00206425289926  , 0.00339414163801  , 0.00639078745016  ,
 0.0112964722871   , 0.0172519357075   , 0.0221346828224   , 0.0235361738776   ,
 0.0205516214169   , 0.0146525316267   , 0.00850985662291  , 0.00402751091183  ,
 0.00155597324117  , 0.000491400233797 , 0.000126828251934 , 2.66808223337e-05 ,
 4.5533152882e-06  , 6.26650082855e-07 , 6.91282193981e-08 , 6.07996969006e-09 ,
 4.24720849666e-10 , 2.35503270903e-11 , 1.04613232813e-12 , 3.89192628032e-14 ,
 1.39850355455e-15 , 6.09400685212e-17 , 3.02751251043e-18 , 1.6511920728e-19  ,
 7.20053560707e-21 , 2.45301650822e-22 , 6.52656595411e-24 , 1.33285979235e-25 ,
 7.72099754922e-29 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 3.76652250262e-32 , 3.28251556401e-30 , 1.38818234043e-28 ,
 4.64385318766e-27 , 1.22847965593e-25 , 2.56796359484e-24 , 4.23702043749e-23 ,
 5.51058015697e-22 , 5.64105451055e-21 , 4.53841178356e-20 , 2.86557449934e-19 ,
 1.41814368318e-18 , 5.49454443523e-18 , 1.66501425998e-17 , 3.9429257216e-17  ,
 7.29180731685e-17 , 1.05250434061e-16 , 1.18518889311e-16 , 1.04080194207e-16 ,
 7.12589558661e-17 , 3.80278478758e-17 , 1.58152503437e-17 , 5.12507587257e-18 ,
 1.29397425878e-18 , 2.54515261486e-19 , 3.89973348728e-20 , 4.65441941888e-21 ,
 4.32700401604e-22 , 3.1331846643e-23  , 1.76705656851e-24 , 7.76197049364e-26 ,
 2.65548479405e-27 , 7.07555748706e-29 , 1.46770339051e-30 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.4026110296e-31  , 6.8773445653e-30  ,
 8.08956513576e-26 , 4.02875752035e-24 , 1.52730858609e-22 , 4.52151998998e-21 ,
 2.42816226977e-16 , 1.1889314225e-14  , 4.4815513823e-13  , 1.31736819157e-11 ,
 3.02082234092e-10 , 5.4058265968e-09  , 7.55346397095e-08 , 8.24630703623e-07 ,
 7.03955141171e-06 , 4.70340207385e-05 , 0.000246229491462 , 0.00101128973052  ,
 0.00326304291887  , 0.00828366312286  , 0.016569879686    , 0.0261528187512   ,
 0.0326087185937   , 0.0321467310456   , 0.0250678048022   , 0.0154616355576   ,
 0.00753936939367  , 0.00290379060228  , 0.000882437129029 , 0.000211641461927 ,
 4.07978388279e-05 , 7.89239450461e-06 , 4.21793329345e-06 , 6.29907109205e-06 ,
 1.42205960197e-05 , 5.11992480402e-05 , 0.00022413556096  , 0.00088799762937  ,
 0.00287002996024  , 0.00737959118784  , 0.0150185985667   , 0.0241822476932   ,
 0.0308281754686   , 0.0311557295762   , 0.0250220916921   , 0.016057270182    ,
 0.00833647168452  , 0.00359444200494  , 0.00134805242476  , 0.000466122079183 ,
 0.000154814220034 , 5.14044689108e-05 , 2.12107912764e-05 , 1.5402123871e-05  ,
 1.55841077188e-05 , 1.59436421671e-05 , 1.72272864204e-05 , 2.41156274018e-05 ,
 4.44800070518e-05 , 9.16746552462e-05 , 0.000187953297    , 0.000358813883776 ,
 0.000608355480612 , 0.000898305908257 , 0.0011895016392   , 0.00154881745452  ,
 0.00219318653215  , 0.00333406487329  , 0.00489084688279  , 0.00637072417467  ,
 0.00718915355168  , 0.00732450886476  , 0.00776897776048  , 0.0102739897831   ,
 0.0163959396732   , 0.0263028951732   , 0.0379461031884   , 0.0472472591758   ,
 0.0498737816991   , 0.0440959456977   , 0.0323564018311   , 0.0195802925536   ,
 0.00973305062038  , 0.00396281495402  , 0.00131761572367  , 0.000356412427271 ,
 7.80666280115e-05 , 1.3775244859e-05  , 1.94845871142e-06 , 2.19991606862e-07 ,
 1.97747064985e-08 , 1.41734689809e-09 , 8.22797931288e-11 , 4.12584957056e-12 ,
 2.1353375126e-13  , 1.38673868279e-14 , 1.02460303259e-15 , 6.83815543919e-17 ,
 3.79493538823e-18 , 1.65800521492e-19 , 5.66183840105e-21 , 1.51096855401e-22 ,
 3.09856235387e-24 , 2.89853091832e-27 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 3.9336407399e-31  , 2.18560638239e-29 , 8.51079876083e-28 ,
 2.60331071227e-26 , 6.26437471555e-25 , 1.18760376486e-23 , 1.77630644145e-22 ,
 2.0986526235e-21  , 1.96031343944e-20 , 1.44836620765e-19 , 8.46447973141e-19 ,
 3.91099849468e-18 , 1.42743485222e-17 , 4.11039504644e-17 , 9.32523417976e-17 ,
 1.66432897883e-16 , 2.33338308041e-16 , 2.56647992652e-16 , 2.21412971715e-16 ,
 1.51510423957e-16 , 9.38202405674e-17 , 1.07713025973e-16 , 3.02597402659e-16 ,
 8.89011462661e-16 , 2.10211297549e-15 , 3.89186906079e-15 , 5.62622456612e-15 ,
 6.34737936809e-15 , 5.58695212181e-15 , 3.83612518956e-15 , 2.05458189455e-15 ,
 8.58385431731e-16 , 2.79785476108e-16 , 7.11623743803e-17 , 1.41287342589e-17 ,
 2.19068861322e-18 , 2.65422455246e-19 , 2.5147438129e-20  , 1.86482540411e-21 ,
 1.08350961313e-22 , 4.93866668445e-24 , 1.7683238446e-25  , 4.9810675679e-27  ,
 1.10512345685e-28 , 6.73090674354e-31 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.33494712704e-30 , 6.5390326148e-29  , 2.475973969e-27   , 7.30013726387e-26 ,
 3.55490040288e-24 , 1.23735222078e-22 , 3.97267571979e-21 , 1.09724754143e-19 ,
 1.67600187247e-16 , 8.13191706683e-15 , 3.05510841018e-13 , 8.96948882708e-12 ,
 2.0558101105e-10  , 3.67826344785e-09 , 5.13922034707e-08 , 5.61046708757e-07 ,
 4.78938692855e-06 , 3.19996489041e-05 , 0.000167522235788 , 0.000688030615843 ,
 0.00222001024174  , 0.00563579023173  , 0.0112733274275   , 0.0177931107563   ,
 0.0221854434428   , 0.0218712186395   , 0.0170551774219   , 0.0105197560939   ,
 0.00513006401485  , 0.00197668064474  , 0.000602395327716 , 0.000148119519358 ,
 3.60864010878e-05 , 2.07389055028e-05 , 2.83395455755e-05 , 4.35265818315e-05 ,
 7.06178794212e-05 , 0.000148033455241 , 0.000450138349169 , 0.0015560200557   ,
 0.00480033540849  , 0.0120824575072   , 0.0242323186083   , 0.0385307809296   ,
 0.0485886670969   , 0.048742965917    , 0.0391752800894   , 0.0256166524308   ,
 0.014059004826    , 0.00682012325984  , 0.0030957385897   , 0.00134319702402  ,
 0.000542910851383 , 0.000201025965864 , 7.44508422923e-05 , 3.62548988108e-05 ,
 2.9089725609e-05  , 3.58496081808e-05 , 6.00857979227e-05 , 0.000117546408663 ,
 0.000235788799264 , 0.000459958809674 , 0.000858873585894 , 0.00150734028266  ,
 0.00241738530378  , 0.00348116055716  , 0.0046042446193   , 0.00604273207112  ,
 0.00853273297775  , 0.0127643630005   , 0.0184258413342   , 0.023794636758    ,
 0.0267572364992   , 0.0268558248439   , 0.0265202531496   , 0.0299324817685   ,
 0.0401285780032   , 0.0566289762903   , 0.0752131129593   , 0.0894668240354   ,
 0.0931907679151   , 0.0835085202176   , 0.063302933347    , 0.0400171520201   ,
 0.0208680402329   , 0.00890534626807  , 0.00309069902921  , 0.0008678423691   ,
 0.000196256979375 , 3.56043201282e-05 , 5.16601658175e-06 , 5.98774233102e-07 ,
 5.56732157316e-08 , 4.24993235084e-09 , 2.89884148686e-10 , 2.14988516065e-11 ,
 1.99173082993e-12 , 1.97808323327e-13 , 1.72919753091e-14 , 1.22170852344e-15 ,
 6.82873807427e-17 , 2.99248209518e-18 , 1.0257941871e-19  , 2.7507117315e-21  ,
 5.67792006718e-23 , 8.47543195648e-26 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 1.05558689228e-31 , 9.05049187071e-30 , 4.01191113406e-28 ,
 1.38189151255e-26 , 3.7822266236e-25  , 8.29646495503e-24 , 1.46339902629e-22 ,
 2.08388056239e-21 , 2.40631881129e-20 , 2.26329602783e-19 , 1.74024932533e-18 ,
 1.09579761105e-17 , 5.64585229432e-17 , 2.37174718906e-16 , 8.07822775676e-16 ,
 2.21619839971e-15 , 4.86502950573e-15 , 8.49536862887e-15 , 1.17425723582e-14 ,
 1.2798491035e-14  , 1.09751152531e-14 , 7.45924278816e-15 , 4.4612338013e-15  ,
 4.49772489427e-15 , 1.17778877815e-14 , 3.43157078869e-14 , 8.11078079287e-14 ,
 1.50209491934e-13 , 2.17239547797e-13 , 2.45209681839e-13 , 2.15967986237e-13 ,
 1.48403529396e-13 , 7.95604531959e-14 , 3.32803406304e-14 , 1.08642779521e-14 ,
 2.7686666538e-15  , 5.51042361652e-16 , 8.57020248309e-17 , 1.0423215276e-17  ,
 9.92202418909e-19 , 7.40020142068e-20 , 4.32971567209e-21 , 1.98992728819e-22 ,
 7.19462629682e-24 , 2.04933970263e-25 , 4.6041594168e-27  , 3.30668751989e-29 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6.69820730735e-29 , 3.28188240382e-27 ,
 1.24186231409e-25 , 3.66007389869e-24 , 1.18329554235e-22 , 3.21656125315e-21 ,
 8.58744790063e-20 , 2.14629130289e-18 , 1.3395387817e-16  , 5.10995842403e-15 ,
 1.73362636107e-13 , 4.88685939673e-12 , 1.1025928006e-10  , 1.96088842263e-09 ,
 2.73335343956e-08 , 2.98128027114e-07 , 2.54405866985e-06 , 1.69953170631e-05 ,
 8.89674341197e-05 , 0.000365390250878 , 0.00117896914893  , 0.00299298995995  ,
 0.00598700623788  , 0.00944978309925  , 0.011783077267    , 0.0116171700819   ,
 0.00906065884997  , 0.00559124910236  , 0.002730924545    , 0.00105968842344  ,
 0.00033653533713  , 0.00010923704966  , 7.68805247371e-05 , 0.000113080338004 ,
 0.000177511523054 , 0.000259560164272 , 0.000366512363276 , 0.000548282399849 ,
 0.00103098095736  , 0.00258417743526  , 0.00698236234071  , 0.0166853099424   ,
 0.0326041540537   , 0.0509603790404   , 0.0635178303025   , 0.0635305284484   ,
 0.0518791421198   , 0.0358410576251   , 0.0221934962545   , 0.0130543027473   ,
 0.007379099041    , 0.00384981522131  , 0.00178640874508  , 0.000757032697917 ,
 0.000339414278311 , 0.000204175709224 , 0.000178485000564 , 0.000211555871563 ,
 0.000324874153364 , 0.000584440167122 , 0.0010885731394   , 0.00196278032031  ,
 0.00335436521437  , 0.00539820749493  , 0.00810311692999  , 0.0112643123063   ,
 0.0147851173452   , 0.0194613386146   , 0.0272512764473   , 0.03990315634     ,
 0.0564831752238   , 0.0722887386139   , 0.0814388958405   , 0.0821234113029   ,
 0.0795961373302   , 0.0828172715165   , 0.0970956813494   , 0.119885853885    ,
 0.143320781672    , 0.159171513956    , 0.160916460104    , 0.144685415399    ,
 0.112486708411    , 0.0736994483383   , 0.039932069405    , 0.0176742577249   ,
 0.00634121029852  , 0.00183507908116  , 0.000426916590216 , 7.96829417753e-05 ,
 1.19348254707e-05 , 1.44454919764e-06 , 1.45703398852e-07 , 1.35480264387e-08 ,
 1.41446649663e-09 , 1.80187120573e-10 , 2.34998630236e-11 , 2.64529666273e-12 ,
 2.39919227611e-13 , 1.71729523641e-14 , 9.64917822369e-16 , 4.24871632365e-17 ,
 1.46517811316e-18 , 3.95839209439e-20 , 8.25298257524e-22 , 1.93036797942e-24 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5.14605156749e-30 ,
 4.41217091823e-28 , 1.93453382144e-26 , 6.61847250205e-25 , 1.79777929239e-23 ,
 3.90362821154e-22 , 6.79499172374e-21 , 9.51604789239e-20 , 1.07692156481e-18 ,
 9.89744423053e-18 , 7.4224594934e-17  , 4.55789875914e-16 , 2.29409939966e-15 ,
 9.44489990038e-15 , 3.16533634819e-14 , 8.5786315014e-14  , 1.86683998609e-13 ,
 3.24043432714e-13 , 4.46121959197e-13 , 4.84973501632e-13 , 4.15113037813e-13 ,
 2.81192856541e-13 , 1.64050497014e-13 , 1.47879549249e-13 , 3.59711014371e-13 ,
 1.03814100798e-12 , 2.4525623748e-12  , 4.54368020787e-12 , 6.57445732772e-12 ,
 7.42529304946e-12 , 6.54451512293e-12 , 4.50110882513e-12 , 2.41577681366e-12 ,
 1.01194170607e-12 , 3.30927690754e-13 , 8.45206040583e-14 , 1.68685397174e-14 ,
 2.63255598888e-15 , 3.21539349418e-16 , 3.07675060081e-17 , 2.30924393821e-18 ,
 1.36128167484e-19 , 6.31179917457e-21 , 2.30529435094e-22 , 6.64173515585e-24 ,
 1.5109581183e-25  , 1.24759901703e-27 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 4.66130710183e-31 , 2.5680193828e-27  , 1.25572584694e-25 , 4.74218448641e-24 ,
 1.39556380025e-22 , 3.69408218299e-21 , 8.19204971311e-20 , 1.73185056836e-18 ,
 3.62056236406e-17 , 7.4465387011e-16  , 1.373484822e-14   , 2.32250485759e-13 ,
 3.79710046161e-12 , 6.12447894264e-11 , 9.21289588557e-10 , 1.19373934384e-08 ,
 1.26349096835e-07 , 1.06515129167e-06 , 7.08039338372e-06 , 3.69889667009e-05 ,
 0.000151790357838 , 0.000489643035256 , 0.00124310312677  , 0.00248737223712  ,
 0.00392826270903  , 0.00490302623592  , 0.00484250770178  , 0.00379045367971  ,
 0.00236035172192  , 0.00118670001504  , 0.000514733316128 , 0.000252471548102 ,
 0.000231019750164 , 0.000354983028104 , 0.000590512868232 , 0.00090597992588  ,
 0.00126529776563  , 0.00166280704883  , 0.00214645496816  , 0.00293160731399  ,
 0.00482045312846  , 0.00974195501934  , 0.0203411100653   , 0.0374526588073   ,
 0.0568566068998   , 0.0700187055667   , 0.0706859196536   , 0.0606285434492   ,
 0.0470366924584   , 0.0351455171396   , 0.0254961300631   , 0.017073183392    ,
 0.0100464963272   , 0.00519374597386  , 0.00255238349619  , 0.00141187484589  ,
 0.00101830468059  , 0.000944976526957 , 0.00107082516244  , 0.00148212864192  ,
 0.00240585436269  , 0.00414671747547  , 0.00699879160418  , 0.0111460129905   ,
 0.0166241335656   , 0.0233325249825   , 0.031096745259    , 0.0402247269343   ,
 0.0527275735274   , 0.0726383676188   , 0.10332493898     , 0.142638150508    ,
 0.180624290804    , 0.204590449154    , 0.209876318402    , 0.206056440398    ,
 0.209453148953    , 0.227685700304    , 0.253215005266    , 0.27259556914     ,
 0.277938236983    , 0.266522485913    , 0.235299230341    , 0.184189234033    ,
 0.123122126622    , 0.0684160503553   , 0.0311041558419   , 0.0114711804098   ,
 0.00341696850857  , 0.000820612049412 , 0.000159077609803 , 2.5124029821e-05  ,
 3.35303151176e-06 , 4.21964906893e-07 , 6.02809877059e-08 , 1.02143891414e-08 ,
 1.72117359692e-09 , 2.48029168954e-10 , 2.8779127288e-11  , 2.639004443e-12   ,
 1.90184334008e-13 , 1.07545661134e-14 , 4.77066763196e-16 , 1.66032577518e-17 ,
 4.53625964567e-19 , 9.59806489507e-21 , 3.42477393686e-23 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 1.93743096371e-28 , 1.66113309244e-26 ,
 7.22336448685e-25 , 2.45847753811e-23 , 6.63875389596e-22 , 1.43000414624e-20 ,
 2.46278427727e-19 , 3.40172308314e-18 , 3.78382239616e-17 , 3.40649226012e-16 ,
 2.49576775567e-15 , 1.49530126276e-14 , 7.34724172137e-14 , 2.95995575113e-13 ,
 9.7420650665e-13  , 2.60343207008e-12 , 5.60749925802e-12 , 9.66383077625e-12 ,
 1.32404726508e-11 , 1.43479929341e-11 , 1.22544953199e-11 , 8.27569551452e-12 ,
 4.73193957799e-12 , 3.85213596153e-12 , 8.64379351919e-12 , 2.46645668282e-11 ,
 5.82349697686e-11 , 1.07933046508e-10 , 1.56264297778e-10 , 1.76611888117e-10 ,
 1.55796811997e-10 , 1.07266649445e-10 , 5.76476002989e-11 , 2.41882989458e-11 ,
 7.92668628084e-12 , 2.02981723797e-12 , 4.06429323446e-13 , 6.36842406409e-14 ,
 7.81679644428e-15 , 7.52454853521e-16 , 5.68797756685e-17 , 3.38127755241e-18 ,
 1.58302973224e-19 , 5.84523521955e-21 , 1.70439001128e-22 , 3.92757555364e-24 ,
 3.67143681648e-26 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.65629893632e-29 ,
 7.68115532516e-26 , 3.74928504669e-24 , 1.4134317203e-22  , 4.15413071892e-21 ,
 1.00825816805e-19 , 1.98443183675e-18 , 3.43903643072e-17 , 5.70773763902e-16 ,
 9.37590692255e-15 , 1.44195600107e-13 , 1.92261064595e-12 , 2.12688947986e-11 ,
 1.94300199234e-10 , 1.51149357256e-09 , 1.0638918074e-08  , 7.17331336122e-08 ,
 4.62378207322e-07 , 2.68416055365e-06 , 1.31761238167e-05 , 5.26299919722e-05 ,
 0.000168033033568 , 0.000425958507897 , 0.000856177740718 , 0.00136646494936  ,
 0.00173801388404  , 0.00177493166952  , 0.00148200761832  , 0.00106394709899  ,
 0.000747837220018 , 0.000635344645787 , 0.000720846141594 , 0.00101317791991  ,
 0.0015972825966   , 0.00253832359543  , 0.00374493453855  , 0.00502046476586  ,
 0.00626017764146  , 0.00749414634261  , 0.00884637155117  , 0.0108912146047   ,
 0.0152746876479   , 0.0243613369715   , 0.0388951417626   , 0.0553122589195   ,
 0.0669010413916   , 0.0696581138004   , 0.0660869817729   , 0.0611401843534   ,
 0.055816137715    , 0.047514624759    , 0.0355121089928   , 0.0229167512057   ,
 0.0133219575654   , 0.0077762567221   , 0.00521488472031  , 0.00426231113784  ,
 0.00410632667506  , 0.00450623034202  , 0.00568651021447  , 0.00826401087256  ,
 0.0130687165703   , 0.0207604337553   , 0.0313498128357   , 0.0441648719483   ,
 0.0585863539521   , 0.0749264507056   , 0.0950423048164   , 0.123075660283    ,
 0.165265377223    , 0.226268517616    , 0.302351856779    , 0.377576864325    ,
 0.430925397839    , 0.453453455201    , 0.458830898366    , 0.470353755997    ,
 0.494723072657    , 0.51454564268     , 0.509681772639    , 0.477899762662    ,
 0.428153867053    , 0.362936309814    , 0.280109524444    , 0.188026478013    ,
 0.106088532334    , 0.0493280614072   , 0.0187167066287   , 0.00577208209005  ,
 0.00144775119611  , 0.000298326642668 , 5.24941599593e-05 , 8.79549914752e-06 ,
 1.66093363702e-06 , 3.63082065244e-07 , 7.793340405e-08   , 1.42993273216e-08 ,
 2.11772049334e-09 , 2.48458945469e-10 , 2.29569892952e-11 , 1.66741536e-12    ,
 9.51603974429e-14 , 4.26839946226e-15 , 1.50564218237e-16 , 4.18028354131e-18 ,
 9.02731883886e-20 , 4.73327574281e-22 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 5.68597912313e-27 , 4.87509917064e-25 , 2.10621392203e-23 ,
 7.13901971383e-22 , 1.91869911616e-20 , 4.10610301726e-19 , 7.00958811443e-18 ,
 9.56972440201e-17 , 1.04860547807e-15 , 9.26638585929e-15 , 6.64177451192e-14 ,
 3.88392264673e-13 , 1.86143759438e-12 , 7.32461543182e-12 , 2.36190272678e-11 ,
 6.20883502498e-11 , 1.32087573569e-10 , 2.25642814923e-10 , 3.07306019907e-10 ,
 3.31692067273e-10 , 2.82540072615e-10 , 1.90231564195e-10 , 1.070029893e-10   ,
 7.95211736814e-11 , 1.63705327998e-10 , 4.60928597635e-10 , 1.08752869215e-09 ,
 2.01663829562e-09 , 2.92168679898e-09 , 3.30489011155e-09 , 2.91836124115e-09 ,
 2.01183874654e-09 , 1.08290855483e-09 , 4.55268224067e-10 , 1.49560177886e-10 ,
 3.84151206391e-11 , 7.72082183887e-12 , 1.2153840154e-12  , 1.50017258056e-13 ,
 1.453799294e-14   , 1.1076794913e-15  , 6.64518936706e-17 , 3.14346708415e-18 ,
 1.17403930737e-19 , 3.46560379239e-21 , 8.08917390997e-23 , 8.43043409335e-25 ,
 0, 0, 0, 0, 0, 0, 0, 0, 4.13073645166e-25 , 7.59089500771e-24 ,
 1.09557025424e-22 , 1.24366857416e-21 , 1.11207373624e-20 , 7.84430001379e-20 ,
 4.37080173765e-19 , 1.92784585621e-18 , 6.80090534921e-18 , 2.07417462711e-17 ,
 8.24775534865e-17 , 7.19612705793e-16 , 8.94732848895e-15 , 1.15705973107e-13 ,
 1.49102982375e-12 , 1.7956476089e-11  , 1.86804140265e-10 , 1.59903816133e-09 ,
 1.10568300107e-08 , 6.18233959094e-08 , 2.84157618422e-07 , 1.11001723845e-06 ,
 3.86768147694e-06 , 1.25576527726e-05 , 3.82851017747e-05 , 0.000106129336281 ,
 0.000256496348374 , 0.000525537668985 , 0.000903622156826 , 0.00130943241235  ,
 0.00162880325918  , 0.00180955034217  , 0.00192726305038  , 0.002137858744    ,
 0.00255115930446  , 0.0032063059645   , 0.0042543068039   , 0.00608234756598  ,
 0.00899329580152  , 0.0126916046383   , 0.0163889113334   , 0.0195445543829   ,
 0.0221531843349   , 0.0242969941975   , 0.0261260128437   , 0.0285869103503   ,
 0.0334188401379   , 0.0414714771007   , 0.0510022441912   , 0.0589225581844   ,
 0.0646598347574   , 0.0710650155      , 0.079279840663    , 0.0843953417093   ,
 0.0796892680473   , 0.0646909268333   , 0.0460686019663   , 0.0308755728015   ,
 0.0214983202046   , 0.0167293005116   , 0.014822709246    , 0.0146902134198   ,
 0.0158537242046   , 0.0185890404508   , 0.0241658123325   , 0.0345986866692   ,
 0.0515490077923   , 0.0747059217937   , 0.101516306886    , 0.12976095991     ,
 0.160768283898    , 0.19976285543     , 0.253781098005    , 0.329580325928    ,
 0.43087425419     , 0.552905348562    , 0.677638907566    , 0.779579690794    ,
 0.845604538383    , 0.888841468529    , 0.931093800809    , 0.968272017323    ,
 0.967046235889    , 0.903299591817    , 0.790986242136    , 0.662559948247    ,
 0.533369474454    , 0.40042376369     , 0.267394943716    , 0.152673160209    ,
 0.0727620555967   , 0.0286018105437   , 0.00924242934537  , 0.00247478866828  ,
 0.000569097056587 , 0.000124081182535 , 2.98299009545e-05 , 8.15444509713e-06 ,
 2.19479212199e-06 , 5.09240655611e-07 , 9.59578011888e-08 , 1.43814116317e-08 ,
 1.70232645631e-09 , 1.5877180301e-10  , 1.16601437432e-11 , 6.74347775897e-13 ,
 3.07301256507e-14 , 1.10433976369e-15 , 3.13264257392e-17 , 6.94415400995e-19 ,
 5.09637271129e-21 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.3011296668e-25  , 1.11557499987e-23 , 4.79525242548e-22 , 1.62006082941e-20 ,
 4.33774145755e-19 , 9.23441304859e-18 , 1.56511871316e-16 , 2.11611637238e-15 ,
 2.28925021336e-14 , 1.99013813516e-13 , 1.39813421754e-12 , 7.98837160193e-12 ,
 3.73401094229e-11 , 1.43327606282e-10 , 4.51851031239e-10 , 1.16557059051e-09 ,
 2.44359440123e-09 , 4.13007040833e-09 , 5.58338650137e-09 , 5.99675487405e-09 ,
 5.0913356586e-09  , 3.41729483592e-09 , 1.89651823265e-09 , 1.30103169647e-09 ,
 2.44814932269e-09 , 6.78719681647e-09 , 1.60004353769e-08 , 2.96872017398e-08 ,
 4.30451920412e-08 , 4.87383842114e-08 , 4.30892470151e-08 , 2.97480790513e-08 ,
 1.60415638254e-08 , 6.75932970223e-09 , 2.22674687367e-09 , 5.73936058815e-10 ,
 1.15844096047e-10 , 1.83303833188e-11 , 2.27665736519e-12 , 2.22254940845e-13 ,
 1.70791103245e-14 , 1.03459040792e-15 , 4.94698212567e-17 , 1.86920860398e-18 ,
 5.58528390126e-20 , 1.31997192574e-21 , 1.51123679801e-23 , 0, 0, 0, 0,
 2.99054404487e-31 , 1.54204291917e-29 , 5.89424478881e-28 , 1.76299175257e-26 ,
 2.15017600036e-23 , 3.95129555771e-22 , 5.70278219278e-21 , 6.4736807181e-20  ,
 5.78869108661e-19 , 4.08314823884e-18 , 2.27485593574e-17 , 1.00240943013e-16 ,
 3.50759809848e-16 , 1.00266763785e-15 , 2.83994003874e-15 , 1.44419387376e-14 ,
 1.35815549401e-13 , 1.40819869053e-12 , 1.44467574022e-11 , 1.46640621289e-10 ,
 1.3883991082e-09  , 1.13644156583e-08 , 7.67541419871e-08 , 4.20438648705e-07 ,
 1.8707547114e-06  , 6.86693760015e-06 , 2.14154483488e-05 , 5.91512104256e-05 ,
 0.000150700415521 , 0.000360282398844 , 0.000796831200937 , 0.00158498133277  ,
 0.00277320866663  , 0.00423079177404  , 0.00566210815293  , 0.00682137235756  ,
 0.00778585528212  , 0.00893861963927  , 0.0105657281072   , 0.012642740709    ,
 0.0153712104996   , 0.0197553039793   , 0.0268288966061   , 0.035981361197    ,
 0.0448672198947   , 0.0515203307744   , 0.0557455734427   , 0.0580359327245   ,
 0.0583826869742   , 0.0568980105303   , 0.0546023638915   , 0.0528284730838   ,
 0.0524948257262   , 0.0549258568783   , 0.0630837429413   , 0.0796304974706   ,
 0.101564023658    , 0.118456536514    , 0.119989481124    , 0.105700603649    ,
 0.0846783311354   , 0.0661523322181   , 0.0534157286611   , 0.0459314098623   ,
 0.0429153025267   , 0.0436513111112   , 0.046975067602    , 0.0523777496583   ,
 0.0616571241671   , 0.0791962414186   , 0.109574827169    , 0.153129559547    ,
 0.204220635702    , 0.256728734774    , 0.312195429127    , 0.380496740092    ,
 0.472042193505    , 0.591213315807    , 0.736985073422    , 0.904930927585    ,
 1.08386410438     , 1.25471526686     , 1.40337766062     , 1.53258625191     ,
 1.64352705551     , 1.70384513196     , 1.65902019749     , 1.48985111313     ,
 1.24209859468     , 0.985406066841    , 0.755810823918    , 0.550824326469    ,
 0.365519422052    , 0.211738491142    , 0.104085315209    , 0.0428173330107   ,
 0.0147527040073   , 0.00437465217783  , 0.00121050149708  , 0.000356657572629 ,
 0.000117679466648 , 3.88758215406e-05 , 1.12863186335e-05 , 2.69204675248e-06 ,
 5.1405570793e-07  , 7.78505566376e-08 , 9.31846532784e-09 , 8.80544506638e-10 ,
 6.56776013785e-11 , 3.86819812084e-12 , 1.80019375584e-13 , 6.6268893633e-15  ,
 2.0117521561e-16  , 3.03604239138e-17 , 6.38598726751e-17 , 1.22968616904e-16 ,
 1.85910270273e-16 , 2.20837218278e-16 , 2.06416001123e-16 , 1.52040787652e-16 ,
 8.83735576023e-17 , 4.05821214132e-17 , 1.47352093413e-17 , 4.23214231561e-18 ,
 9.61420967914e-19 , 1.72655728308e-19 , 2.44879456263e-20 , 2.73960009284e-21 ,
 2.41416226664e-22 , 1.90540573155e-23 , 2.00018423449e-22 , 8.52464127504e-21 ,
 2.87261453778e-19 , 7.66852263218e-18 , 1.62568267108e-16 , 2.73934183335e-15 ,
 3.67431632774e-14 , 3.9325026507e-13  , 3.37081953581e-12 , 2.32615439545e-11 ,
 1.3007260974e-10  , 5.93371925139e-10 , 2.2204726367e-09  , 6.83232623217e-09 ,
 1.72545829098e-08 , 3.55627642465e-08 , 5.93453053893e-08 , 7.9508285551e-08  ,
 8.48751000417e-08 , 7.17683986635e-08 , 4.80088798216e-08 , 2.63486797309e-08 ,
 1.68678957056e-08 , 2.89632959325e-08 , 7.88909129461e-08 , 1.85789421263e-07 ,
 3.44935403808e-07 , 5.00601168962e-07 , 5.67442546006e-07 , 5.02352275388e-07 ,
 3.47394047319e-07 , 1.87717828639e-07 , 7.92996174912e-08 , 2.62064108446e-08 ,
 6.78081115918e-09 , 1.37511545513e-09 , 2.18826879862e-10 , 2.73621243011e-11 ,
 2.69222496822e-12 , 2.08745652343e-13 , 1.27721177575e-14 , 6.17381270443e-16 ,
 2.35968543078e-17 , 7.13424242499e-19 , 1.70588337385e-20 , 2.11616571406e-22 ,
 0, 0, 0, 0, 1.55667060353e-29 , 8.02680999058e-28 , 3.06813658488e-26 ,
 9.17691695664e-25 , 8.23887105938e-22 , 1.51402558594e-20 , 2.1851461463e-19  ,
 2.480532929e-18   , 2.21806432109e-17 , 1.56454075806e-16 , 8.7162394326e-16  ,
 3.83952600646e-15 , 1.33979615167e-14 , 3.74388941974e-14 , 9.08686501802e-14 ,
 2.8818343949e-13  , 1.89757484054e-12 , 1.64484369056e-11 , 1.37594802332e-10 ,
 1.11793205762e-09 , 8.95028024849e-09 , 6.67432052048e-08 , 4.31134052646e-07 ,
 2.3097308616e-06  , 1.01192941765e-05 , 3.64674472466e-05 , 0.000110419872021 ,
 0.000290818073424 , 0.000693613429093 , 0.00154060317677  , 0.00319006337852  ,
 0.00604024051717  , 0.010241046385    , 0.0153769704125   , 0.0204982535203   ,
 0.0247530374607   , 0.0282376267284   , 0.0320016580981   , 0.0367826834985   ,
 0.0421201828697   , 0.0477705589225   , 0.0557891665377   , 0.0692134434239   ,
 0.0876062503708   , 0.105635591507    , 0.117713677588    , 0.122634088638    ,
 0.122262886072    , 0.117687697542    , 0.10868202735     , 0.0957533887278   ,
 0.0812636011686   , 0.069327027227    , 0.065481518517    , 0.0752133214751   ,
 0.100014422571    , 0.133072069879    , 0.160547277567    , 0.170896528948    ,
 0.163837055485    , 0.148169711028    , 0.131864076927    , 0.117830345119    ,
 0.107835899859    , 0.10471296138     , 0.109254081027    , 0.11836823438     ,
 0.128408462014    , 0.14052487035     , 0.163199654921    , 0.208110185716    ,
 0.279874225154    , 0.369565111172    , 0.462947338747    , 0.557248221484    ,
 0.665934269303    , 0.804445900097    , 0.974991870732    , 1.16938733442     ,
 1.38348034026     , 1.62078626598     , 1.88168710548     , 2.15709865561     ,
 2.42774807491     , 2.64931393792     , 2.74089172363     , 2.62485953991     ,
 2.3002870783      , 1.8608720742      , 1.42494573636     , 1.0556482715      ,
 0.752431507933    , 0.498485976861    , 0.294359740474    , 0.150193069077    ,
 0.0653503530932   , 0.0245507082282   , 0.00842645031116  , 0.00294195571524  ,
 0.00112492728942  , 0.000441820219433 , 0.000157617837291 , 4.71533559049e-05 ,
 1.1418548271e-05  , 2.20707779715e-06 , 3.38625578404e-07 , 4.11497429958e-08 ,
 3.95778873622e-09 , 3.01286381558e-10 , 1.81590868483e-11 , 8.66933569007e-13 ,
 3.28921580226e-14 , 1.3907823279e-15  , 1.30529782521e-15 , 3.15302802323e-15 ,
 6.07500201764e-15 , 9.18450004113e-15 , 1.09099913489e-14 , 1.01975419003e-14 ,
 7.51125055322e-15 , 4.36590696275e-15 , 2.00487307797e-15 , 7.27961562328e-16 ,
 2.0907995677e-16  , 4.74969505793e-17 , 8.52968768975e-18 , 1.20977467937e-18 ,
 1.35344094376e-19 , 1.19266533283e-20 , 8.58939395493e-22 , 2.81782514462e-21 ,
 1.18349566059e-19 , 3.980013641e-18   , 1.05996829746e-16 , 2.23958600887e-15 ,
 3.75620365778e-14 , 5.00570626512e-13 , 5.31011385211e-12 , 4.49769942428e-11 ,
 3.05582739732e-10 , 1.67574522577e-09 , 7.47051154516e-09 , 2.72590929188e-08 ,
 8.17766292038e-08 , 2.01785792633e-07 , 4.07897799488e-07 , 6.70544565022e-07 ,
 8.88665345358e-07 , 9.41589124582e-07 , 7.92228958326e-07 , 5.27967333337e-07 ,
 2.8707514962e-07  , 1.73291841158e-07 , 2.71606473035e-07 , 7.25166937966e-07 ,
 1.70553789079e-06 , 3.16864229549e-06 , 4.60330717038e-06 , 5.22445466738e-06 ,
 4.63218474195e-06 , 3.20927898106e-06 , 1.73814348898e-06 , 7.36338087113e-07 ,
 2.44184972938e-07 , 6.34494595938e-08 , 1.2933005514e-08  , 2.07060446047e-09 ,
 2.60755801798e-10 , 2.58667554282e-11 , 2.02409140556e-12 , 1.25093308894e-13 ,
 6.11171967794e-15 , 2.36187157409e-16 , 7.2202215735e-18  , 1.74510991034e-19 ,
 2.31646163502e-21 , 0, 0, 0, 0, 5.96472491905e-28 , 3.07564833964e-26 ,
 1.17562384112e-24 , 3.51633705467e-23 , 2.47169136463e-20 , 4.54213200253e-19 ,
 6.55551827285e-18 , 7.44168975837e-17 , 6.65427515691e-16 , 4.69367334939e-15 ,
 2.6148652149e-14  , 1.15171577767e-13 , 4.0147475802e-13  , 1.11230424367e-12 ,
 2.52927210622e-12 , 5.82694028151e-12 , 2.42577012802e-11 , 1.72745102963e-10 ,
 1.25439779404e-09 , 8.36852515531e-09 , 5.38881060299e-08 , 3.40750043599e-07 ,
 2.00475467596e-06 , 1.02513496268e-05 , 4.37980886992e-05 , 0.000154816533372 ,
 0.000457926509762 , 0.00116481727461  , 0.00264374488801  , 0.00553001696079  ,
 0.0107872664025   , 0.0194331651006   , 0.0317943792339   , 0.0467428136473   ,
 0.0617906418868   , 0.0745896941313   , 0.0850168178361   , 0.0953425391824   ,
 0.107157720026    , 0.118780432769    , 0.128240191475    , 0.138936330531    ,
 0.158356237084    , 0.188375430021    , 0.219643214705    , 0.239383957622    ,
 0.242980133067    , 0.234511051885    , 0.218478650459    , 0.19577483629     ,
 0.16708421956     , 0.136658823556    , 0.112381572329    , 0.10333738532     ,
 0.11578111666     , 0.148342150757    , 0.190256143032    , 0.226503033141    ,
 0.247459760605    , 0.253859527543    , 0.251420648341    , 0.243072873551    ,
 0.230272415427    , 0.21937334162     , 0.219823084496    , 0.23477712948     ,
 0.257155380029    , 0.276592523389    , 0.291276346063    , 0.315454263233    ,
 0.373725378688    , 0.481249338333    , 0.627026019692    , 0.782517699371    ,
 0.931528690771    , 1.08766271524     , 1.27737372336     , 1.50992221347     ,
 1.77284391747     , 2.05745468594     , 2.37833944939     , 2.7596119775      ,
 3.20214071896     , 3.65685197619     , 4.0144819035      , 4.13194512959     ,
 3.91197744988     , 3.3848644307      , 2.70250144002     , 2.03752062101     ,
 1.48442376956     , 1.04724241069     , 0.696858656204    , 0.420717060817    ,
 0.223602459329    , 0.103831060976    , 0.0433385185425   , 0.0175269761618   ,
 0.00746848373888  , 0.00333550582126  , 0.00141744798252  , 0.000522777876457 ,
 0.000159105776828 , 3.90655814162e-05 , 7.66316231494e-06 , 1.19585930695e-06 ,
 1.48189926466e-07 , 1.45720105501e-08 , 1.13681387628e-09 , 7.03537375353e-11 ,
 3.45391181969e-12 , 1.38198583438e-13 , 1.95627763652e-14 , 4.85495981563e-14 ,
 1.19137350643e-13 , 2.29561915476e-13 , 3.47063493314e-13 , 4.12266284787e-13 ,
 3.85344275603e-13 , 2.83834813488e-13 , 1.64978704904e-13 , 7.5760057812e-14  ,
 2.75081802699e-14 , 7.90070443175e-15 , 1.79481272971e-15 , 3.22319472287e-16 ,
 4.57149136552e-17 , 5.11437682871e-18 , 4.50683864025e-19 , 3.15870812503e-20 ,
 3.18454865711e-20 , 1.28358675071e-18 , 4.30959035692e-17 , 1.14560654459e-15 ,
 2.41413819043e-14 , 4.03389178815e-13 , 5.34776172124e-12 , 5.63196925398e-11 ,
 4.72314923902e-10 , 3.16657522823e-09 , 1.70683618284e-08 , 7.44973915825e-08 ,
 2.65304298799e-07 , 7.75731191912e-07 , 1.86744363301e-06 , 3.69424457266e-06 ,
 5.96871428238e-06 , 7.80896299487e-06 , 8.19954232836e-06 , 6.85715412165e-06 ,
 4.55042810192e-06 , 2.4550190842e-06  , 1.41128533145e-06 , 2.02335410429e-06 ,
 5.28117447808e-06 , 1.23983459719e-05 , 2.30491060231e-05 , 3.35216205704e-05 ,
 3.80966689276e-05 , 3.38339635225e-05 , 2.3488580618e-05  , 1.2753153416e-05  ,
 5.41921400127e-06 , 1.80383416706e-06 , 4.70828901792e-07 , 9.64881649808e-08 ,
 1.55462441685e-08 , 1.97217167822e-09 , 1.9726584176e-10  , 1.55780006122e-11 ,
 9.72255903746e-13 , 4.79907505817e-14 , 1.87391062216e-15 , 5.78701242909e-17 ,
 1.41231096294e-18 , 1.98402553882e-20 , 0, 0, 0, 0, 1.78943922632e-26 ,
 9.22705717366e-25 , 3.52691439296e-23 , 1.05491393887e-21 , 5.81240458065e-19 ,
 1.0681232066e-17  , 1.54158913164e-16 , 1.74998043208e-15 , 1.56481304408e-14 ,
 1.10375954752e-13 , 6.14906606111e-13 , 2.70823692347e-12 , 9.4370071667e-12  ,
 2.60618763012e-11 , 5.77598840565e-11 , 1.12710962244e-10 , 2.97538672255e-10 ,
 1.57501374503e-09 , 1.02183504867e-08 , 5.99605887481e-08 , 3.18499071106e-07 ,
 1.62820411453e-06 , 8.14121278452e-06 , 3.78576777248e-05 , 0.000153838624177 ,
 0.000527899554939 , 0.00152306897288  , 0.00376019496385  , 0.00819851893693  ,
 0.0163194444263   , 0.0302248807456   , 0.0520248036525   , 0.0822825262532   ,
 0.11853830134     , 0.155517773588    , 0.18790839008     , 0.21444982008     ,
 0.238767915089    , 0.263674367559    , 0.285382026642    , 0.298342669208    ,
 0.307087614356    , 0.32676153573     , 0.365922590138    , 0.4121485558      ,
 0.441749184642    , 0.442337519739    , 0.419349715711    , 0.382834585526    ,
 0.337188462245    , 0.285128049449    , 0.234478768141    , 0.197625186469    ,
 0.186081418646    , 0.204533139183    , 0.246718992509    , 0.297425300564    ,
 0.341796495655    , 0.374106569182    , 0.396606456759    , 0.410500333571    ,
 0.412423335377    , 0.403197749323    , 0.395839591251    , 0.407612725483    ,
 0.443596815452    , 0.491179591002    , 0.531044501145    , 0.556236742137    ,
 0.586589783315    , 0.662969615828    , 0.816271046004    , 1.0354219402      ,
 1.27235614394     , 1.48823375105     , 1.69412796701     , 1.93863556401     ,
 2.25610235185     , 2.63799677679     , 3.06061768848     , 3.52998989        ,
 4.08153876403     , 4.72397595138     , 5.37675089759     , 5.86107095237     ,
 5.9726440687      , 5.604293485       , 4.82676188802     , 3.85192874407     ,
 2.90532918258     , 2.11438771338     , 1.492050782       , 1.00088661428     ,
 0.617470806296    , 0.341697848396    , 0.169757584408    , 0.0787223996445   ,
 0.0365307877079   , 0.0176736032367   , 0.00852724832155  , 0.00375702034627  ,
 0.00141199388536  , 0.000436221329109 , 0.000108828806496 , 2.17416676329e-05 ,
 3.46414499962e-06 , 4.39317731646e-07 , 4.42955803722e-08 , 3.54810484999e-09 ,
 2.25600420437e-10 , 1.13965701562e-11 , 5.67393603512e-13 , 4.69074720218e-13 ,
 1.42891224677e-12 , 3.51280994571e-12 , 6.76879009557e-12 , 1.02334044879e-11 ,
 1.21559533924e-11 , 1.13621395373e-11 , 8.36906361551e-12 , 4.86450995767e-12 ,
 2.23383712361e-12 , 8.11097510542e-13 , 2.32957674163e-13 , 5.29212809671e-14 ,
 9.50381010328e-15 , 1.34793549761e-15 , 1.50800898971e-16 , 1.32887219935e-17 ,
 9.23985510776e-19 , 3.06130845259e-19 , 1.08813417539e-17 , 3.64830809647e-16 ,
 9.6839961545e-15  , 2.03645220017e-13 , 3.39273463627e-12 , 4.47899891322e-11 ,
 4.68940370967e-10 , 3.90066689555e-09 , 2.58606331438e-08 , 1.37333616182e-07 ,
 5.88146969821e-07 , 2.04740526208e-06 , 5.83721944446e-06 , 1.36977425812e-05 ,
 2.6469701128e-05  , 4.19376973815e-05 , 5.40485264208e-05 , 5.61425480683e-05 ,
 4.66095967429e-05 , 3.07822166806e-05 , 1.65038157537e-05 , 9.12452668073e-06 ,
 1.20100121479e-05 , 3.05340176928e-05 , 7.14800791663e-05 , 0.000132942801969 ,
 0.000193560083616 , 0.000220295623398 , 0.000195994752711 , 0.000136361872468 ,
 7.4234921105e-05  , 3.16471234647e-05 , 1.05754568634e-05 , 2.77338274385e-06 ,
 5.71530209866e-07 , 9.26837931596e-08 , 1.18448523735e-08 , 1.19455800533e-09 ,
 9.51786325255e-11 , 5.99638974378e-12 , 2.98841441748e-13 , 1.17806934235e-14 ,
 3.67160623623e-16 , 9.03761458296e-18 , 1.33098643084e-19 , 0, 0, 0, 0,
 4.20802729949e-25 , 2.16982549112e-23 , 8.29385643851e-22 , 2.48072501601e-20 ,
 1.07280272305e-17 , 1.97144826946e-16 , 2.84533027204e-15 , 3.22996091076e-14 ,
 2.88819570706e-13 , 2.03722397379e-12 , 1.13494109847e-11 , 4.99856464487e-11 ,
 1.74154412523e-10 , 4.80383902266e-10 , 1.05423641006e-09 , 1.91274118937e-09 ,
 3.6346951858e-09  , 1.27018611049e-08 , 7.09554250039e-08 , 3.84071367377e-07 ,
 1.8030847028e-06  , 7.64070583598e-06 , 3.10674754836e-05 , 0.000122968324929 ,
 0.000452977658739 , 0.00147076143025  , 0.00409577572646  , 0.00980730708154  ,
 0.0206700467848   , 0.039561217883    , 0.0703409417854   , 0.11676235061     ,
 0.179726105463    , 0.254823690499    , 0.332621007452    , 0.402758585585    ,
 0.460595135696    , 0.509855495208    , 0.554681797132    , 0.589392125137    ,
 0.603967198158    , 0.603262469433    , 0.612118296115    , 0.65086079598     ,
 0.707981992525    , 0.747810594009    , 0.745307682958    , 0.703170016796    ,
 0.636490705686    , 0.555947061976    , 0.470611297317    , 0.395421742893    ,
 0.347732223486    , 0.338455934242    , 0.366556305654    , 0.418866138209    ,
 0.476791951078    , 0.527632486999    , 0.569985883107    , 0.606690115743    ,
 0.634530962208    , 0.646224971104    , 0.64481206329     , 0.650442437537    ,
 0.686078171547    , 0.75705253633     , 0.846408027098    , 0.928199560655    ,
 0.989828819452    , 1.05222162762     , 1.16748064429     , 1.3811226914      ,
 1.68506333231     , 2.01456336382     , 2.30800492469     , 2.57515937134     ,
 2.89613067805     , 3.34550884164     , 3.92604227128     , 4.58733782827     ,
 5.30078923667     , 6.08851750539     , 6.95491358069     , 7.78831202548     ,
 8.34982655114     , 8.38962170792     , 7.8062353973      , 6.71802958128     ,
 5.39366617208     , 4.10486127085     , 3.00979979596     , 2.13524497425     ,
 1.44375756471     , 0.906902942179    , 0.520197281607    , 0.274577372066    ,
 0.138694498577    , 0.070546265975    , 0.036524940308    , 0.0182660769886   ,
 0.00819810953913  , 0.0031256163012   , 0.000980895562435 , 0.000249245965279 ,
 5.08468268584e-05 , 8.29017333903e-06 , 1.07742180439e-06 , 1.11415985013e-07 ,
 9.15337422486e-09 , 5.96579255793e-10 , 3.12902355054e-11 , 3.86136706245e-12 ,
 1.05079061505e-11 , 3.2884919666e-11  , 8.0861181878e-11  , 1.55810629639e-10 ,
 2.35562511778e-10 , 2.79817622529e-10 , 2.61544838939e-10 , 1.92647290433e-10 ,
 1.11976047224e-10 , 5.14206473871e-11 , 1.86706356723e-11 , 5.36244755387e-12 ,
 1.21819379717e-12 , 2.18767994761e-13 , 3.1028097434e-14  , 3.47128256114e-15 ,
 3.05892797925e-16 , 2.12202928458e-17 , 2.85339458433e-18 , 7.2163295995e-17  ,
 2.41596387777e-15 , 6.40550325738e-14 , 1.34480031253e-12 , 2.23519126189e-11 ,
 2.94101851373e-10 , 3.06465960995e-09 , 2.53227935096e-08 , 1.66335272758e-07 ,
 8.72232907722e-07 , 3.67383268589e-06 , 1.25263290181e-05 , 3.48620560102e-05 ,
 7.97358984672e-05 , 0.000150317813684 , 0.00023306928751  , 0.000295247741349 ,
 0.000302822593948 , 0.000249239679026 , 0.000163740869643 , 8.74210140039e-05 ,
 4.7000319457e-05  , 5.70836123003e-05 , 0.000140520406252 , 0.00032731445013  ,
 0.000608676424418 , 0.000887098256464 , 0.00101112712304  , 0.000901269803096 ,
 0.000628486809625 , 0.000343099951503 , 0.0001467615423   , 4.92424518323e-05 ,
 1.29761415385e-05 , 2.6892318977e-06  , 4.38947185957e-07 , 5.65077123393e-08 ,
 5.74460807669e-09 , 4.6163496497e-10  , 2.93417648318e-11 , 1.47533255527e-12 ,
 5.86638714007e-14 , 1.84331348433e-15 , 4.57146782379e-17 , 7.00213733303e-19 ,
 0, 0, 0, 0, 7.76680816654e-24 , 4.00487381496e-22 , 1.5308073673e-20  ,
 4.57870492323e-19 , 1.5563435712e-16  , 2.86003270471e-15 , 4.12779679561e-14 ,
 4.68579113406e-13 , 4.1899841609e-12  , 2.95545810573e-11 , 1.64649312962e-10 ,
 7.25156296028e-10 , 2.5264083161e-09  , 6.96583720149e-09 , 1.52304999025e-08 ,
 2.68327630997e-08 , 4.25892817758e-08 , 9.61291879406e-08 , 4.17632629522e-07 ,
 2.0918240007e-06  , 9.14936659154e-06 , 3.43626624871e-05 , 0.000116564650505 ,
 0.000377805646658 , 0.00118576224967  , 0.00347382307316  , 0.00909470755703  ,
 0.0209038429239   , 0.0426230094243   , 0.0791208302006   , 0.136828430987    ,
 0.222100843678    , 0.336711380697    , 0.473811928907    , 0.618001535246    ,
 0.750605780329    , 0.859374101264    , 0.944923751819    , 1.01290108874     ,
 1.05905999569     , 1.07174134804     , 1.0554932415      , 1.04298970846     ,
 1.068016186       , 1.12544610184     , 1.17141977103     , 1.16582633648     ,
 1.10192932694     , 0.995593310632    , 0.866563210724    , 0.738065180752    ,
 0.638454496295    , 0.589656682234    , 0.59468617382     , 0.637839065508    ,
 0.695620608807    , 0.750186856641    , 0.796996358561    , 0.840900279309    ,
 0.884407868455    , 0.921089972696    , 0.943692427874    , 0.959895424534    ,
 0.99491008873     , 1.07301639489     , 1.19829091336     , 1.35354909725     ,
 1.5124259769      , 1.65721958282     , 1.80048179353     , 1.99114954098     ,
 2.28163135967     , 2.67355265707     , 3.10238360198     , 3.49761322223     ,
 3.87002210605     , 4.32649436762     , 4.97946637226     , 5.84371235123     ,
 6.83830320466     , 7.8855975718      , 8.97199738582     , 10.0775578175     ,
 11.0534985298     , 11.6124200083     , 11.4807960568     , 10.5835938466     ,
 9.09831269804     , 7.3503037941      , 5.64954537468     , 4.17841821433     ,
 2.9799892918      , 2.02616519756     , 1.29019636382     , 0.762043576632    ,
 0.421970491731    , 0.226126334281    , 0.121097787891    , 0.0646041142733   ,
 0.0327474114224   , 0.0148341942338   , 0.00572247008954  , 0.00182418463326  ,
 0.000472395081543 , 9.84382196209e-05 , 1.64156561964e-05 , 2.18309453363e-06 ,
 2.3093456901e-07  , 1.93888573042e-08 , 1.29065401802e-09 , 7.68745120603e-11 ,
 4.96615951852e-11 , 1.88313742428e-10 , 5.91307137137e-10 , 1.45401242024e-09 ,
 2.80172300104e-09 , 4.23578871967e-09 , 5.03156601672e-09 , 4.70299229748e-09 ,
 3.4641047658e-09  , 2.0135074725e-09  , 9.24625045457e-10 , 3.35727732621e-10 ,
 9.64253381707e-11 , 2.19050625055e-11 , 3.9337965852e-12  , 5.57934554662e-13 ,
 6.2419182935e-14  , 5.50043915351e-15 , 3.81321158621e-16 , 2.95766426953e-17 ,
 3.75009676185e-16 , 1.25243245978e-14 , 3.31759633812e-13 , 6.95608557838e-12 ,
 1.15402858169e-10 , 1.51443033409e-09 , 1.57214145273e-08 , 1.29206092619e-07 ,
 8.42271579633e-07 , 4.37024960598e-06 , 1.81461038492e-05 , 6.0738079722e-05  ,
 0.000165293237966 , 0.000368708447006 , 0.000677663383177 , 0.00102658377743  ,
 0.00127561825917  , 0.00128936356713  , 0.00105064766176  , 0.000686520391833 ,
 0.000366259472542 , 0.000194271392494 , 0.000219259557504 , 0.00051693699606  ,
 0.00119250080337  , 0.00221426699483  , 0.0032292227004   , 0.00368600143587  ,
 0.0032918134875   , 0.00230093068848  , 0.00125972671468  , 0.000540720356044 ,
 0.000182178235638 , 4.82412962622e-05 , 1.00543518928e-05 , 1.65166749085e-06 ,
 2.14144049016e-07 , 2.19378308043e-08 , 1.77718119947e-09 , 1.13889145543e-10 ,
 5.77302265522e-12 , 2.31340444453e-13 , 7.32168629506e-15 , 1.82770135058e-16 ,
 2.89271854331e-18 , 0, 0, 0, 0, 1.12675160773e-22 , 5.80997742317e-21 ,
 2.22078313929e-19 , 6.64244954035e-18 , 1.77729293716e-15 , 3.26606289549e-14 ,
 4.71380776398e-13 , 5.35101938592e-12 , 4.78482545495e-11 , 3.37503958833e-10 ,
 1.88024710649e-09 , 8.28111150483e-09 , 2.88509377036e-08 , 7.95380716546e-08 ,
 1.73673982822e-07 , 3.02501768911e-07 , 4.42204213766e-07 , 7.14855009019e-07 ,
 2.15297763879e-06 , 9.54215810911e-06 , 3.96026944264e-05 , 0.000138899018015 ,
 0.000419019962098 , 0.00114332874683  , 0.00296553750532  , 0.00741507928545  ,
 0.0174359741369   , 0.0374815522232   , 0.0732895136619   , 0.132509077168    ,
 0.225778902241    , 0.364383579754    , 0.552682911027    , 0.780739656628    ,
 1.02342497937     , 1.24760852989     , 1.42669563692     , 1.55383116614     ,
 1.63789521592     , 1.6845907625      , 1.68974257001     , 1.6588284072      ,
 1.62524295373     , 1.62988222645     , 1.67592766631     , 1.71819790247     ,
 1.7040472236      , 1.61267936068     , 1.45611536101     , 1.26619014651     ,
 1.0896977216      , 0.976103586276    , 0.950549999746    , 0.996348058992    ,
 1.06774759763     , 1.12358592621     , 1.15241381133     , 1.16900261439     ,
 1.19160187313     , 1.22517177483     , 1.26293295858     , 1.30055023998     ,
 1.34994036737     , 1.43753829569     , 1.58504175571     , 1.79448231025     ,
 2.05170606859     , 2.3344472658      , 2.61911622784     , 2.89915206009     ,
 3.2044490809      , 3.5868563824      , 4.06961437431     , 4.61489872131     ,
 5.16353361201     , 5.72316124016     , 6.40361670033     , 7.33401823124     ,
 8.53843515648     , 9.91659179949     , 11.348998881      , 12.7756826842     ,
 14.1286073342     , 15.2041800657     , 15.6678945209     , 15.2399452076     ,
 13.8953913785     , 11.8924288214     , 9.62469799143     , 7.43830654457     ,
 5.53081875422     , 3.95723850508     , 2.70132825159     , 1.73962102492     ,
 1.05247889638     , 0.603897674908    , 0.335511250807    , 0.183654259765    ,
 0.0983858270881   , 0.0497046546589   , 0.0225089079626   , 0.0087388690752   ,
 0.00282021472316  , 0.000742278832189 , 0.000157547682147 , 2.67824533638e-05 ,
 3.63027281641e-06 , 3.9106596861e-07  , 3.33914237083e-08 , 2.27348790478e-09 ,
 2.48146616637e-10 , 6.63640629403e-10 , 2.64602043497e-09 , 8.31202986048e-09 ,
 2.04391852704e-08 , 3.93840768751e-08 , 5.95428700483e-08 , 7.07291844094e-08 ,
 6.61103935393e-08 , 4.86952380192e-08 , 2.83040589865e-08 , 1.29975389635e-08 ,
 4.71935549151e-09 , 1.35545981163e-09 , 3.07921470234e-10 , 5.52977389503e-11 ,
 7.84293714401e-12 , 8.77432172374e-13 , 7.73201770439e-14 , 5.35923807651e-15 ,
 3.27589276103e-16 , 1.53302711672e-15 , 5.08731297868e-14 , 1.34662397897e-12 ,
 2.82061720685e-11 , 4.67261272711e-10 , 6.11899742282e-09 , 6.33304764316e-08 ,
 5.1823152347e-07  , 3.35741245363e-06 , 1.72686341021e-05 , 7.08400302534e-05 ,
 0.000233319732637 , 0.000622177971324 , 0.00135524497733  , 0.0024285396332   ,
 0.00359042811776  , 0.00436827208574  , 0.00434316409744  , 0.00349950464591  ,
 0.00227583626591  , 0.00122103841112  , 0.000652815077026 , 0.000692091115923 ,
 0.00153207213456  , 0.00346605125167  , 0.00640674634095  , 0.00934151466572  ,
 0.010676029087    , 0.00955246808308  , 0.00669316505712  , 0.00367518991155  ,
 0.00158309278713  , 0.000535603849954 , 0.000142522680002 , 2.98708380574e-05 ,
 4.93787763401e-06 , 6.44621733389e-07 , 6.65221206085e-08 , 5.42979942805e-09 ,
 3.50607715252e-10 , 1.79034563411e-11 , 7.22433592766e-13 , 2.30101472406e-14 ,
 5.77676266965e-16 , 9.39793850258e-18 , 0, 0, 0, 0, 1.2867131049e-21  ,
 6.63480223883e-20 , 2.53606096399e-18 , 7.58545788937e-17 , 1.59999055572e-14 ,
 2.94024116857e-13 , 4.24355947095e-12 , 4.81720352708e-11 , 4.3074942725e-10  ,
 3.03835060609e-09 , 1.69268102587e-08 , 7.45507490812e-08 , 2.59734716726e-07 ,
 7.16049568979e-07 , 1.56288078978e-06 , 2.71067749215e-06 , 3.82919780627e-06 ,
 5.09981475486e-06 , 1.02977166081e-05 , 3.69815936676e-05 , 0.000143713546517 ,
 0.000481231075556 , 0.00135636783148  , 0.0033100508002   , 0.00732554240237  ,
 0.0153566130262   , 0.0310304344297   , 0.0599636452364   , 0.109967187034    ,
 0.192765607434    , 0.326312532975    , 0.531285778422    , 0.818087338439    ,
 1.17261709528     , 1.55280456678     , 1.90024494934     , 2.16452349335     ,
 2.32765068393     , 2.40707538458     , 2.43248760319     , 2.42216301894     ,
 2.38646803116     , 2.34861181999     , 2.34106176231     , 2.36886562704     ,
 2.39074713665     , 2.34988516994     , 2.21578219512     , 1.9978993994      ,
 1.74232436259     , 1.52362365274     , 1.41624188249     , 1.44705737542     ,
 1.56886114309     , 1.68975982877     , 1.74118314344     , 1.7214110926      ,
 1.6752948588      , 1.64402041458     , 1.64161825611     , 1.66620254466     ,
 1.71898601602     , 1.81498889233     , 1.97921389878     , 2.22868176261     ,
 2.5612442722      , 2.96359115324     , 3.41652801274     , 3.8889453812      ,
 4.34933969958     , 4.80024944188     , 5.2908819153      , 5.87802191013     ,
 6.57244863122     , 7.34019845206     , 8.1750769471      , 9.15958157187     ,
 10.4143198035     , 11.9725451557     , 13.7357517586     , 15.5616887145     ,
 17.3410692156     , 18.9356792684     , 20.0660115702     , 20.3444076952     ,
 19.4931175708     , 17.5556656901     , 14.896237229      , 12.0007782519     ,
 9.26285604121     , 6.89061681277     , 4.93802607598     , 3.38777955598     ,
 2.20947351264     , 1.36690825596     , 0.805855498046    , 0.456609598188    ,
 0.250182100933    , 0.131807066357    , 0.0651540863823   , 0.0290557461932   ,
 0.0112224037228   , 0.00363420231697  , 0.00096526586275  , 0.000207390439703 ,
 3.57337873448e-05 , 4.90970095193e-06 , 5.3574861225e-07  , 4.63082402815e-08 ,
 3.3711358544e-09  , 1.57860638128e-09 , 7.25117769577e-09 , 2.91019770614e-08 ,
 9.142392939e-08   , 2.24810484721e-07 , 4.33185243215e-07 , 6.54911697572e-07 ,
 7.77949907216e-07 , 7.27147852041e-07 , 5.3559865302e-07  , 3.11316187883e-07 ,
 1.42959859005e-07 , 5.19081648883e-08 , 1.49086949538e-08 , 3.38682654408e-09 ,
 6.08219524158e-10 , 8.62644221678e-11 , 9.65087159969e-12 , 8.50444198664e-13 ,
 5.8942959424e-14  , 3.32274600069e-15 , 4.98422485155e-15 , 1.62099352908e-13 ,
 4.28832126857e-12 , 8.97501805396e-11 , 1.48507473303e-09 , 1.94153626356e-08 ,
 2.00463219484e-07 , 1.63470040029e-06 , 1.05376320178e-05 , 5.38118303102e-05 ,
 0.000218525725    , 0.000709842729255 , 0.00185900742116  , 0.00396112878463  ,
 0.00692553295     , 0.00998745345183  , 0.0118805859157   , 0.0116000832696   ,
 0.00923463630035  , 0.00599052639878  , 0.00327048082041  , 0.00182057925261  ,
 0.00184480298266  , 0.00371216401093  , 0.00807724638336  , 0.014766946438    ,
 0.0214860489152   , 0.0245731120884   , 0.022026530417    , 0.0154708939624   ,
 0.00852036366551  , 0.00368326607706  , 0.00125139071362  , 0.00033461297079  ,
 7.05180189069e-05 , 1.17286349237e-05 , 1.54127276921e-06 , 1.60158862148e-07 ,
 1.31654344155e-08 , 8.56055291917e-10 , 4.40067303587e-11 , 1.78681659863e-12 ,
 5.72328761149e-14 , 1.44401852606e-15 , 2.4046821621e-17  , 0, 0, 0, 0,
 1.15835086396e-20 , 5.97291569988e-19 , 2.28306403151e-17 , 6.82873413363e-16 ,
 1.13700204917e-13 , 2.08942501276e-12 , 3.01560284969e-11 , 3.42325222177e-10 ,
 3.06103831028e-09 , 2.15914795133e-08 , 1.20287638966e-07 , 5.29787599014e-07 ,
 1.84582332417e-06 , 5.08890373149e-06 , 1.11069723228e-05 , 1.92379248007e-05 ,
 2.68150652897e-05 , 3.25275616629e-05 , 4.76467016913e-05 , 0.000126398444107 ,
 0.000440377011021 , 0.00140505824977  , 0.00378165451437  , 0.00863661104627  ,
 0.0172738313384   , 0.0315784287287   , 0.0549267269957   , 0.0932005643889   ,
 0.156249161652    , 0.261522115113    , 0.438066602685    , 0.721451530054    ,
 1.1329043483      , 1.65351279523     , 2.21498018656     , 2.71903042634     ,
 3.08000098093     , 3.26716272881     , 3.31562885723     , 3.2949653922      ,
 3.26089108321     , 3.23304532973     , 3.21355023941     , 3.2075685601      ,
 3.20961674185     , 3.18461402306     , 3.08512266973     , 2.88631736736     ,
 2.6030595577      , 2.29230767933     , 2.04709690394     , 1.96123396648     ,
 2.06378408471     , 2.27773140097     , 2.46225924939     , 2.51765290086     ,
 2.44995315252     , 2.33330301269     , 2.23200375072     , 2.17201461111     ,
 2.162073587       , 2.21517945418     , 2.35423199647     , 2.60550658253     ,
 2.98055497178     , 3.4672821143      , 4.04562023018     , 4.69644367004     ,
 5.38365241559     , 6.05289287151     , 6.67725003971     , 7.30013824183     ,
 8.01289918055     , 8.88120268016     , 9.90247645332     , 11.0544230433     ,
 12.3791973773     , 13.9744785914     , 15.879938299      , 18.008776554      ,
 20.2047182383     , 22.3057133636     , 24.0946415692     , 25.2152299707     ,
 25.2325793229     , 23.872571924      , 21.2447305687     , 17.8265068876     ,
 14.2194288404     , 10.8903115485     , 8.06615984834     , 5.78448136139     ,
 3.99954461199     , 2.65158729456     , 1.67911606894     , 1.01282591247     ,
 0.580043693539    , 0.314275449809    , 0.160263062992    , 0.0759426096625   ,
 0.032612592008    , 0.0122774405664   , 0.00392374603261  , 0.00103820152999  ,
 0.000223539851355 , 3.8726620881e-05  , 5.35798277581e-06 , 5.88975476451e-07 ,
 5.14567582032e-08 , 5.36104732219e-09 , 1.23284988189e-08 , 6.24172877637e-08 ,
 2.50720128734e-07 , 7.87643419034e-07 , 1.93680702973e-06 , 3.73201554925e-06 ,
 5.64225277062e-06 , 6.70226235945e-06 , 6.26458803231e-06 , 4.61433655125e-06 ,
 2.68207856133e-06 , 1.23164033189e-06 , 4.4720378067e-07  , 1.28442698033e-07 ,
 2.91784854703e-08 , 5.23998625777e-09 , 7.43192825518e-10 , 8.31450365358e-11 ,
 7.32682154551e-12 , 5.07802396695e-13 , 2.79264705349e-14 , 1.33151876319e-14 ,
 4.05697656296e-13 , 1.07272056435e-11 , 2.24366529388e-10 , 3.70913779478e-09 ,
 4.84279301729e-08 , 4.99061126774e-07 , 4.05834994301e-06 , 2.60554027666e-05 ,
 0.000132277853052 , 0.000532680595794 , 0.00171013048817  , 0.00440857763755  ,
 0.00920791183526  , 0.0157272453806   , 0.0221261407664   , 0.0257104534673   ,
 0.0246218912623   , 0.019365867119    , 0.0125960646286   , 0.00714126393558  ,
 0.00432708187059  , 0.00429772182331  , 0.00753905184649  , 0.0152374187762   ,
 0.0271950469779   , 0.0393272317001   , 0.0449582659287   , 0.0403598667682   ,
 0.0284154985701   , 0.0156965737499   , 0.00680995302598  , 0.00232345440412  ,
 0.000624286999761 , 0.000132282019354 , 2.21326946596e-05 , 2.92701680083e-06 ,
 3.06164617535e-07 , 2.53344554781e-08 , 1.65797195587e-09 , 8.57513835678e-11 ,
 3.50134019288e-12 , 1.12713841305e-13 , 2.85634949266e-15 , 4.85293015115e-17 ,
 0, 0, 0, 0, 8.23159422181e-20 , 4.24453590811e-18 , 1.62241487226e-16 ,
 4.85270656636e-15 , 6.38502459246e-13 , 1.17335147577e-11 , 1.69346216412e-10 ,
 1.92238472527e-09 , 1.71897808689e-08 , 1.21250762994e-07 , 6.75498792642e-07 ,
 2.97515615116e-06 , 1.03659847734e-05 , 2.85809678712e-05 , 6.23892236091e-05 ,
 0.000108044568458 , 0.000149904689409 , 0.000174660911741 , 0.000209706537845 ,
 0.000399216280281 , 0.00116682389169  , 0.00347259781088  , 0.00894171489246  ,
 0.0195082262057   , 0.0367538085466   , 0.0619636868066   , 0.0975852964051   ,
 0.149489350396    , 0.22996209827     , 0.363115661601    , 0.590640762171    ,
 0.96596027765     , 1.52531848563     , 2.24659830575     , 3.02928006593     ,
 3.72266267816     , 4.19542550065     , 4.40351107145     , 4.40763148097     ,
 4.32674570708     , 4.26053944861     , 4.23967407442     , 4.24020641115     ,
 4.22969215864     , 4.1843316967      , 4.07820690726     , 3.88778514074     ,
 3.61122260995     , 3.27471427838     , 2.9329895272      , 2.67466321586     ,
 2.59893806913     , 2.74215351262     , 3.01688910817     , 3.25425276434     ,
 3.33259489309     , 3.25751902135     , 3.11305405343     , 2.96832185916     ,
 2.85217588538     , 2.78591758217     , 2.80531683394     , 2.95581282151     ,
 3.27558049924     , 3.77182148281     , 4.41475620924     , 5.16892390415     ,
 6.01574249201     , 6.92418733839     , 7.82536832939     , 8.65943939435     ,
 9.44970041424     , 10.3050321428     , 11.336187934      , 12.5779165019     ,
 14.0121794363     , 15.6594460847     , 17.5947998894     , 19.8473497555     ,
 22.3209145513     , 24.8293745106     , 27.1542156492     , 29.0178847654     ,
 30.026945958      , 29.733884502      , 27.8672695624     , 24.5682506624     ,
 20.3964339995     , 16.0714635944     , 12.1616217519     , 8.93396774357     ,
 6.40298350951     , 4.46838836384     , 3.0177496333      , 1.95660288125     ,
 1.20520751223     , 0.696117994764    , 0.37233077243     , 0.18280323662     ,
 0.08181733775     , 0.0330060440478   , 0.0117662480964   , 0.00361317884738  ,
 0.000932037259208 , 0.000197864710964 , 3.40561130039e-05 , 4.70317519645e-06 ,
 5.17523277014e-07 , 4.65827439483e-08 , 1.5560000741e-08  , 8.21800124356e-08 ,
 4.21668158524e-07 , 1.69396134911e-06 , 5.32162593828e-06 , 1.30858233012e-05 ,
 2.52149518708e-05 , 3.812125919e-05   , 4.52830971867e-05 , 4.23259988177e-05 ,
 3.11762565081e-05 , 1.81211682924e-05 , 8.3214422022e-06  , 3.02148307187e-06 ,
 8.67808937641e-07 , 1.9714122224e-07  , 3.54033898171e-08 , 5.02130044177e-09 ,
 5.61760278563e-10 , 4.95028625144e-11 , 3.4308949252e-12  , 1.87308652778e-13 ,
 3.18654979498e-14 , 7.98748908629e-13 , 2.11076329178e-11 , 4.41256811648e-10 ,
 7.28936889082e-09 , 9.50726359581e-08 , 9.7824886936e-07  , 7.93736587849e-06 ,
 5.07933741316e-05 , 0.000256639581682 , 0.00102635204022  , 0.00326268710681  ,
 0.0082973649931   , 0.0170243303346   , 0.0284538434482   , 0.0390789915382   ,
 0.044342405385    , 0.0416250491647   , 0.0323944120269   , 0.0213399896927   ,
 0.0129671993323   , 0.0089717037256   , 0.00897780718318  , 0.0132806757954   ,
 0.0236754139655   , 0.0402529569386   , 0.0573842746149   , 0.0654139062554   ,
 0.0587729767701   , 0.0414722475847   , 0.0229781721209   , 0.0100053849536   ,
 0.00342817921446  , 0.000925566597507 , 0.000197175499119 , 3.31826207402e-05 ,
 4.41531914691e-06 , 4.64743783806e-07 , 3.86963809312e-08 , 2.5476170456e-09  ,
 1.32502924892e-10 , 5.43781699825e-12 , 1.7584191987e-13  , 4.47356138176e-15 ,
 7.73427339285e-17 , 0, 0, 0, 0, 4.62258897236e-19 , 2.38358990408e-17 ,
 9.11094120412e-16 , 2.72511827664e-14 , 2.83554232631e-12 , 5.21076745489e-11 ,
 7.52054104035e-10 , 8.53717047442e-09 , 7.63385954729e-08 , 5.38466688424e-07 ,
 2.99985694339e-06 , 1.32126669977e-05 , 4.60367963972e-05 , 0.00012694331534  ,
 0.000277164931495 , 0.000480166123882 , 0.00066560952653  , 0.000763597932208 ,
 0.000827539278851 , 0.00119590784919  , 0.00276192473772  , 0.00738322472422  ,
 0.0179844398367   , 0.0376524391103   , 0.0681987053136   , 0.110289343176    ,
 0.166255147919    , 0.243753765605    , 0.358931133662    , 0.541557957186    ,
 0.842122694443    , 1.32803465495     , 2.05066845527     , 2.98905705341     ,
 4.01427739211     , 4.92228358199     , 5.53188922365     , 5.78199034949     ,
 5.75531737127     , 5.61440445263     , 5.49796682471     , 5.44988116        ,
 5.42898310163     , 5.37379220632     , 5.2468292336      , 5.03483775177     ,
 4.74356364105     , 4.39844822815     , 4.03242978703     , 3.68049441567     ,
 3.40392923166     , 3.29480529199     , 3.40683211028     , 3.67365678519     ,
 3.93379025705     , 4.05944231704     , 4.04218772146     , 3.9456934235      ,
 3.81589837089     , 3.6676289003      , 3.53105261008     , 3.47489972706     ,
 3.58557382776     , 3.92838244205     , 4.51075836837     , 5.28040735246     ,
 6.1801597587      , 7.1943147632      , 8.31030069336     , 9.45743554229     ,
 10.5402101913     , 11.5407851802     , 12.5560175139     , 13.719376897      ,
 15.1049275663     , 16.7306179231     , 18.6352006914     , 20.8848415513     ,
 23.4730090063     , 26.2501127677     , 28.9674040988     , 31.3504276795     ,
 33.1039674416     , 33.8690800666     , 33.2446780382     , 30.9647263833     ,
 27.1471149982     , 22.3680340394     , 17.4352605677     , 13.0275228492     ,
 9.47180705447     , 6.76754874861     , 4.75490852845     , 3.26160812504     ,
 2.15781089145     , 1.35431150164     , 0.790242042626    , 0.420026622855    ,
 0.200158030626    , 0.0847191138127   , 0.031683420658    , 0.0104039969477   ,
 0.00296535697945  , 0.000721273659581 , 0.000146883946604 , 2.46057192578e-05 ,
 3.34258174433e-06 , 3.65000038572e-07 , 3.94354944361e-08 , 6.82554626955e-08 ,
 4.35253684362e-07 , 2.23724391139e-06 , 8.98777878738e-06 , 2.82353564656e-05 ,
 6.94304504325e-05 , 0.000133784892685 , 0.000202262871485 , 0.000240261981406 ,
 0.000224572279122 , 0.000165414241225 , 9.61468642785e-05 , 4.41517103703e-05 ,
 1.6031313111e-05  , 4.60440004755e-06 , 1.0459872141e-06  , 1.87842464725e-07 ,
 2.66418966088e-08 , 2.98057434204e-09 , 2.62651112046e-10 , 1.82035360464e-11 ,
 9.91695692798e-13 , 7.93503155184e-14 , 1.23939243803e-12 , 3.27164478292e-11 ,
 6.83663752319e-10 , 1.12872542931e-08 , 1.4709163856e-07  , 1.51164309435e-06 ,
 1.22432514734e-05 , 7.81413573345e-05 , 0.000393286432152 , 0.00156388863812  ,
 0.00493064396418  , 0.0123943497122   , 0.025035192765    , 0.0410225027318   ,
 0.0550647664638   , 0.0610288998838   , 0.0561723511467   , 0.0434256964904   ,
 0.0294827700227   , 0.0200126665459   , 0.0163335380219   , 0.0167803889342   ,
 0.0209218646188   , 0.0311257661085   , 0.0484184676084   , 0.0669872467038   ,
 0.0757702258579   , 0.0680399425739   , 0.0481020538666   , 0.0267304338736   ,
 0.0116818665566   , 0.0040196723746   , 0.00109049547402  , 0.000233544681284 ,
 3.95270629187e-05 , 5.29072998212e-06 , 5.60227124999e-07 , 4.69208924658e-08 ,
 3.1063509103e-09  , 1.6239702908e-10  , 6.69558911855e-12 , 2.17396753554e-13 ,
 5.55015538368e-15 , 9.743728105e-17   , 0, 4.00706005953e-32 ,
 4.96858720048e-30 , 2.18822482484e-28 , 2.05285766545e-18 , 1.05853469271e-16 ,
 4.04610177407e-15 , 1.2102049219e-13  , 9.96154991912e-12 , 1.83050470299e-10 ,
 2.64190169782e-09 , 2.99903449618e-08 , 2.68171023457e-07 , 1.89159033547e-06 ,
 1.05382979886e-05 , 4.64157563825e-05 , 0.000161731544754 , 0.000446006819335 ,
 0.000974055955065 , 0.00168851905079  , 0.00234249712716  , 0.00267590281895  ,
 0.00276961862468  , 0.00333759110449  , 0.00600704866722  , 0.013788764172    ,
 0.0311014389031   , 0.0622409311416   , 0.109357268908    , 0.173546914799    ,
 0.259998938998    , 0.382435575189    , 0.563444578692    , 0.835684575693    ,
 1.24908038544     , 1.8725130324      , 2.76453122142     , 3.90935762465     ,
 5.16586300061     , 6.29510157531     , 7.07318684571     , 7.41137209803     ,
 7.39091580495     , 7.19393744059     , 6.98759681709     , 6.83987072716     ,
 6.71948505403     , 6.56273120533     , 6.33076076388     , 6.01913451249     ,
 5.64994603027     , 5.26116931183     , 4.88036195111     , 4.5145299569      ,
 4.19218528035     , 3.99735498555     , 4.01159712514     , 4.213784371       ,
 4.47497991969     , 4.66841373968     , 4.75700285676     , 4.76233038313     ,
 4.69119215034     , 4.5343513405      , 4.32531175215     , 4.16789449304     ,
 4.19873527515     , 4.52020165383     , 5.14564650105     , 6.00075901762     ,
 7.0031973969      , 8.13875933813     , 9.4221747068      , 10.7976075678     ,
 12.1432995797     , 13.3907677881     , 14.5986989056     , 15.8933037321     ,
 17.3722525158     , 19.1014835516     , 21.1698017207     , 23.6573520684     ,
 26.5141265493     , 29.5057132616     , 32.2936670072     , 34.5499425852     ,
 36.0017354283     , 36.3906386855     , 35.4218396058     , 32.8502761451     ,
 28.730557037      , 23.5882264944     , 18.2632336694     , 13.5169625953     ,
 9.7342518684      , 6.91515862295     , 4.86269990327     , 3.36187456769     ,
 2.25328566095     , 1.43503012477     , 0.846754704016    , 0.450685344354    ,
 0.211413406747    , 0.0860160515315   , 0.0301086135735   , 0.00904749506152  ,
 0.00233367517319  , 0.000515358912552 , 9.66760120301e-05 , 1.52088144792e-05 ,
 1.97673042705e-06 , 2.12194066995e-07 , 5.04962069087e-08 , 2.76962182456e-07 ,
 1.81575401794e-06 , 9.33531048041e-06 , 3.75032273136e-05 , 0.000117817431181 ,
 0.000289711848572 , 0.000558243081087 , 0.0008439805594   , 0.0010025391214   ,
 0.000937070834445 , 0.000690222594078 , 0.00040119120085  , 0.000184231465435 ,
 6.6893723539e-05  , 1.92127408225e-05 , 4.36458193063e-06 , 7.83808651362e-07 ,
 1.11168415223e-07 , 1.24370175347e-08 , 1.09596236697e-09 , 7.59579058666e-11 ,
 4.13555201615e-12 , 2.21851047411e-13 , 1.51986744077e-12 , 4.00008875463e-11 ,
 8.35610992888e-10 , 1.37894419849e-08 , 1.79577445792e-07 , 1.84367159437e-06 ,
 1.49107894418e-05 , 9.49628850705e-05 , 0.000476433943415 , 0.00188564334312  ,
 0.00590430382521  , 0.0146960736242   , 0.0292819146909   , 0.0471332072538   ,
 0.0619265674273   , 0.0670975267547   , 0.0606483121251   , 0.0469358265673   ,
 0.0337306639197   , 0.0266647974095   , 0.0257165238075   , 0.0272525157118   ,
 0.0296470462592   , 0.0357436935964   , 0.0482198530022   , 0.0629804927823   ,
 0.0700168379411   , 0.0626593547783   , 0.044346970409    , 0.024712184603    ,
 0.0108391604854   , 0.003745617987    , 0.00102102195626  , 0.000219811011812 ,
 3.74093521882e-05 , 5.03592663152e-06 , 5.36294757336e-07 , 4.5165231317e-08  ,
 3.00569019135e-09 , 1.57882651411e-10 , 6.53707127509e-12 , 2.13033646812e-13 ,
 5.4559302723e-15  , 9.70900479719e-17 , 1.19690146329e-20 , 1.04001961246e-19 ,
 7.10610510145e-19 , 3.82635573417e-18 , 2.34897114868e-17 , 4.26723402023e-16 ,
 1.43605928203e-14 , 4.25448398443e-13 , 2.7700631403e-11  , 5.0859844242e-10  ,
 7.3399674269e-09  , 8.33214781887e-08 , 7.45053374834e-07 , 5.25536869635e-06 ,
 2.92784661093e-05 , 0.000128958056287 , 0.000449358667722 , 0.0012393225517   ,
 0.00270739493541  , 0.00469678472069  , 0.00652642864954  , 0.00746291958968  ,
 0.00759631797086  , 0.00828071267273  , 0.012085943222    , 0.0230636660643   ,
 0.0468190422434   , 0.0887473057865   , 0.152031181068    , 0.240511484293    ,
 0.366490616512    , 0.55471455872     , 0.837098197706    , 1.24679899288     ,
 1.82300471024     , 2.61857559974     , 3.68224066334     , 5.0017470428      ,
 6.44642014684     , 7.77744705444     , 8.74784970433     , 9.22758921115     ,
 9.25895753138     , 9.00870905292     , 8.6617189682      , 8.32915650344     ,
 8.02711025347     , 7.72278044808     , 7.38608185058     , 7.00731706202     ,
 6.59881544034     , 6.18701470112     , 5.78351817173     , 5.374276376       ,
 4.97079868426     , 4.66079825824     , 4.55786646134     , 4.68673556292     ,
 4.94899290105     , 5.21258896667     , 5.40526167747     , 5.50697338404     ,
 5.49221965094     , 5.33255473063     , 5.0626276754      , 4.81449529958     ,
 4.76799388456     , 5.05838405417     , 5.70538026724     , 6.61602712465     ,
 7.68291696059     , 8.8884738283      , 10.2753319606     , 11.8181279369     ,
 13.3914661774     , 14.8882420612     , 16.3215733408     , 17.7866847315     ,
 19.374686415      , 21.1771021503     , 23.3304340228     , 25.9457136466     ,
 28.9500126453     , 32.0332490078     , 34.7659565854     , 36.7668848717     ,
 37.7963786839     , 37.7192687925     , 36.3786205986     , 33.5794022446     ,
 29.3205349133     , 24.0497733622     , 18.5822515226     , 13.6999524241     ,
 9.811063517       , 6.92531092246     , 4.84528837901     , 3.34637082633     ,
 2.25226666475     , 1.44555761499     , 0.859409788646    , 0.458576582331    ,
 0.213491729644    , 0.0848821583977   , 0.0284378571467   , 0.00798089946624  ,
 0.00187652681808  , 0.000371125741657 , 6.20049817317e-05 , 8.75856136312e-06 ,
 1.04134924227e-06 , 1.12821958446e-07 , 1.1576597315e-07  , 9.06805551992e-07 ,
 5.96725899169e-06 , 3.06803269262e-05 , 0.000123253701021 , 0.000387204928977 ,
 0.000952132928278 , 0.00183465613197  , 0.00277372736183  , 0.00329482730539  ,
 0.00307966692423  , 0.00226840449537  , 0.00131850787169  , 0.000605473492128 ,
 0.000219845053597 , 6.31423370184e-05 , 1.43441222623e-05 , 2.57597345104e-06 ,
 3.653530716e-07   , 4.08740583848e-08 , 3.60187520389e-09 , 2.49643161589e-10 ,
 1.35933452496e-11 , 6.25671377204e-13 , 1.48216246103e-12 , 3.86267407157e-11 ,
 8.06683542672e-10 , 1.33070313162e-08 , 1.73199842534e-07 , 1.7767674392e-06  ,
 1.43527370351e-05 , 9.12489978346e-05 , 0.000456610207414 , 0.00180018503878  ,
 0.00560442397482  , 0.0138333885397   , 0.0272389798696   , 0.0431538529618   ,
 0.0555929934428   , 0.0589761776832   , 0.0525218865233   , 0.041226129704    ,
 0.0324830108434   , 0.0307006311729   , 0.0340789806048   , 0.0370722339381   ,
 0.0368721274782   , 0.0366238483607   , 0.04082318825     , 0.0482573916886   ,
 0.0518172992424   , 0.0459572398042   , 0.0325091817329   , 0.0181579065623   ,
 0.00799241855351  , 0.00277354349709  , 0.000759622625825 , 0.000164373894643 ,
 2.81251877734e-05 , 3.8068886023e-06  , 4.0760661787e-07  , 3.45057222887e-08 ,
 2.30740897927e-09 , 1.21733703889e-10 , 5.05982050778e-12 , 1.65448427816e-13 ,
 4.25667137489e-15 , 8.44823030215e-17 , 7.10383304134e-18 , 9.27961073447e-18 ,
 3.66190365211e-17 , 1.86564747676e-16 , 8.11251040503e-16 , 3.70279526259e-15 ,
 4.66510655183e-14 , 1.19645795156e-12 , 6.17556326653e-11 , 1.11807325407e-09 ,
 1.61187663693e-08 , 1.82961533622e-07 , 1.63601645784e-06 , 1.1539947619e-05  ,
 6.42910829153e-05 , 0.000283175891965 , 0.000986772141257 , 0.00272179112549  ,
 0.00594779109798  , 0.0103269414976   , 0.0143799730574   , 0.0165058998092   ,
 0.0167753515932   , 0.0174631277738   , 0.0220634986888   , 0.0349771381512   ,
 0.0621432647515   , 0.11010466118     , 0.184769401465    , 0.295841666649    ,
 0.466092687326    , 0.733704357324    , 1.14131998256     , 1.72292159869     ,
 2.50311931331     , 3.50583849809     , 4.75059923723     , 6.2187124019      ,
 7.80503754906     , 9.30460412935     , 10.472500243      , 11.1329500274     ,
 11.2598137748     , 10.9722070094     , 10.4581414589     , 9.88308995942     ,
 9.33963832696     , 8.85301226606     , 8.40992932227     , 7.98425323674     ,
 7.55897569148     , 7.13085553206     , 6.68790603793     , 6.20507192298     ,
 5.69896802024     , 5.27679156028     , 5.07990476995     , 5.15807303458     ,
 5.42187825481     , 5.72630764642     , 5.97354895057     , 6.12156282904     ,
 6.13175648649     , 5.96801022311     , 5.66608609697     , 5.3742865864      ,
 5.29714466723     , 5.58701296343     , 6.26396580571     , 7.22049761668     ,
 8.32943279187     , 9.56627674993     , 10.9937711488     , 12.6210277682     ,
 14.3398770322     , 16.0300941706     , 17.6756233285     , 19.3415977035     ,
 21.0938650665     , 23.011838163      , 25.2408531508     , 27.9117609121     ,
 30.9553151867     , 34.0280124046     , 36.6382277042     , 38.3553984817     ,
 38.9548864439     , 38.396567297      , 36.6486423143     , 33.5928373306     ,
 29.2262030543     , 23.9494192596     , 18.523265232      , 13.6797934759     ,
 9.79495735657     , 6.88254873876     , 4.77571032851     , 3.27206555807     ,
 2.1923725756      , 1.40472743557     , 0.833400271716    , 0.442303535777    ,
 0.203705603955    , 0.0795236722153   , 0.0258873301138   , 0.00695730223695  ,
 0.00153688937891  , 0.000279188042096 , 4.18963889917e-05 , 5.23079339708e-06 ,
 5.48893667108e-07 , 7.38130446158e-08 , 2.819747681e-07   , 2.3494091541e-06  ,
 1.54682368279e-05 , 7.95293983838e-05 , 0.000319497671748 , 0.0010037108201   ,
 0.00246811455839  , 0.00475578711172  , 0.00719004319609  , 0.00854083605166  ,
 0.00798309831005  , 0.00588014760656  , 0.00341782998658  , 0.00156950557667  ,
 0.000569881327823 , 0.000163677273167 , 3.71827674821e-05 , 6.67742693706e-06 ,
 9.47067189302e-07 , 1.05954203712e-07 , 9.33729089551e-09 , 6.47456345321e-10 ,
 3.54004097149e-11 , 1.60689025329e-12 , 1.18825209852e-12 , 2.94926943205e-11 ,
 6.15670120257e-10 , 1.01529247362e-08 , 1.32087759669e-07 , 1.3541311181e-06  ,
 1.09281066099e-05 , 6.9376840725e-05  , 0.00034641739376  , 0.00136136327966  ,
 0.00421794519562  , 0.0103375862352   , 0.020148896525    , 0.031476661672    ,
 0.0398349353484   , 0.0414679985848   , 0.0365917789346   , 0.0297155079116   ,
 0.0266526121676   , 0.0301088951679   , 0.0370395975596   , 0.0410516826854   ,
 0.0387773878453   , 0.0333199532862   , 0.030194233831    , 0.0307010259967   ,
 0.0309260039851   , 0.0269012219936   , 0.0189589603773   , 0.0106042865921   ,
 0.00468268780177  , 0.00163163136788  , 0.000448932165347 , 9.76254325306e-05 ,
 1.67903396982e-05 , 2.28447615148e-06 , 2.45844062731e-07 , 2.09121439299e-08 ,
 1.40461640221e-09 , 7.44001492209e-11 , 3.10358749947e-12 , 1.02390713514e-13 ,
 3.44073577924e-15 , 9.07794115864e-16 , 7.30845571927e-16 , 6.54317303977e-16 ,
 1.54768685061e-15 , 7.12786831992e-15 , 2.99425409722e-14 , 1.02943550777e-13 ,
 3.56609651186e-13 , 3.17075683219e-12 , 1.34354160559e-10 , 1.9758472239e-09  ,
 2.79865567741e-08 , 3.17239181984e-07 , 2.83640704176e-06 , 2.00069771815e-05 ,
 0.000111462774164 , 0.000490954184179 , 0.00171087573027  , 0.00471961305769  ,
 0.0103169870081   , 0.0179300316626   , 0.0250302653442   , 0.0288961323609   ,
 0.0295897844408   , 0.0304260199108   , 0.0354379358306   , 0.0482269911426   ,
 0.073994619893    , 0.120890075298    , 0.200047341784    , 0.329996587732    ,
 0.544742742632    , 0.893808717143    , 1.42878654243     , 2.18711175899     ,
 3.18483852233     , 4.41873438815     , 5.87066720114     , 7.50208237894     ,
 9.22747511396     , 10.8835651082     , 12.2438180582     , 13.1002522873     ,
 13.3584809702     , 13.0737327863     , 12.4143014643     , 11.5874240548     ,
 10.767883071      , 10.0547468705     , 9.46537431663     , 8.96533231359     ,
 8.51087583101     , 8.06389432355     , 7.57884559778     , 7.01695313949     ,
 6.40982830695     , 5.89340220069     , 5.62828034217     , 5.66483174281     ,
 5.90319115352     , 6.18843273638     , 6.41982930494     , 6.5591359107      ,
 6.57183307224     , 6.42027760572     , 6.13575671284     , 5.86603639138     ,
 5.81964560942     , 6.15128636276     , 6.87786697089     , 7.88471771346     ,
 9.03483310197     , 10.2948761249     , 11.7310145161     , 13.3731705283     ,
 15.1379889043     , 16.9191816677     , 18.7043618726     , 20.5562079838     ,
 22.5247332228     , 24.6524919487     , 27.0403851141     , 29.7962033404     ,
 32.8578006981     , 35.890803586      , 38.3842394852     , 39.8700345989     ,
 40.1116952804     , 39.1120589363     , 36.923536663      , 33.5168242783     ,
 28.9528526638     , 23.6482232468     , 18.3140334481     , 13.5847260896     ,
 9.75578194465     , 6.83176406084     , 4.69086627418     , 3.17063110996     ,
 2.09753763098     , 1.32760541488     , 0.776395868247    , 0.404750970143    ,
 0.182538882639    , 0.0696064119187   , 0.0220710623389   , 0.00575212532901  ,
 0.0012230169653   , 0.00021133519605  , 2.96640466558e-05 , 3.39177174456e-06 ,
 3.21468223274e-07 , 7.72682980767e-08 , 5.71584002626e-07 , 4.8092328186e-06  ,
 3.16657618652e-05 , 0.000162808499779 , 0.000654059227343 , 0.00205474525026  ,
 0.00505259738602  , 0.00973580316499  , 0.0147190872216   , 0.0174843609922   ,
 0.0163425889275   , 0.012037536234    , 0.00699680604277  , 0.00321301122283  ,
 0.00116663179261  , 0.000335071713312 , 7.61186615013e-05 , 1.36697004784e-05 ,
 1.93880639934e-06 , 2.16923283889e-07 , 1.91302254573e-08 , 1.33516366243e-09 ,
 7.73144501772e-11 , 5.14461994489e-12 , 1.4097515545e-12  , 1.79606981052e-11 ,
 3.71717001702e-10 , 6.12790647407e-09 , 7.96935560867e-08 , 8.16558204058e-07 ,
 6.5845438378e-06  , 4.17523301651e-05 , 0.00020811062845  , 0.000815655163892 ,
 0.00251701121332  , 0.0061319126866   , 0.0118473381755   , 0.0182821595043   ,
 0.0227752802254   , 0.0233365444262   , 0.0205846638929   , 0.0177652326777   ,
 0.0186787929099   , 0.0246162389473   , 0.0324177710105   , 0.0363692432775   ,
 0.0334221168938   , 0.0261790500598   , 0.0197843680014   , 0.0166188928714   ,
 0.0150587087353   , 0.0126134709396   , 0.00880352692916  , 0.00492193492978  ,
 0.00217917010799  , 0.000762200462832 , 0.000210633932052 , 4.6020469269e-05  ,
 7.95341465074e-06 , 1.08738721421e-06 , 1.17569261447e-07 , 1.00449175878e-08 ,
 6.77416835169e-10 , 3.60178729525e-11 , 1.52274369003e-12 , 7.645098277e-14   ,
 3.69193940307e-14 , 3.73696730385e-14 , 3.14562340157e-14 , 2.57849798818e-14 ,
 4.90367773515e-14 , 2.11264163877e-13 , 8.79385167992e-13 , 2.9610065859e-12  ,
 8.07602306806e-12 , 2.14474665186e-11 , 8.08507703328e-10 , 3.55853268736e-09 ,
 3.92053786121e-08 , 4.34532086451e-07 , 3.87818924186e-06 , 2.73513327197e-05 ,
 0.000152378032809 , 0.000671179216948 , 0.00233902360634  , 0.00645326706631  ,
 0.0141122503512   , 0.024553910554    , 0.0343869471039   , 0.0400194478742   ,
 0.0416187269815   , 0.0433126321158   , 0.0489859390546   , 0.0604152580968   ,
 0.0814076565596   , 0.122569908642    , 0.202791901016    , 0.351516279508    ,
 0.612557839516    , 1.04147837697     , 1.6937967017      , 2.61191811367     ,
 3.81487351294     , 5.28998192135     , 6.99335135542     , 8.85942440136     ,
 10.7947272117     , 12.647539538      , 14.2031242874     , 15.2459355221     ,
 15.6462489922     , 15.4056905536     , 14.6532481273     , 13.6070866727     ,
 12.5039398476     , 11.516256395      , 10.7090811633     , 10.0655794473     ,
 9.53705651558     , 9.0563617518      , 8.53387977918     , 7.90315100997     ,
 7.20452292382     , 6.60037725409     , 6.26284202906     , 6.23141255984     ,
 6.39205899974     , 6.59076923796     , 6.74452883537     , 6.83925216258     ,
 6.85700779431     , 6.75856060195     , 6.55604182612     , 6.37365978093     ,
 6.40604111383     , 6.80565293222     , 7.59282320669     , 8.65791660671     ,
 9.86422936781     , 11.1657886774     , 12.6108277023     , 14.2283238114     ,
 15.9597764922     , 17.7363309145     , 19.5821512105     , 21.5902809918     ,
 23.8193678384     , 26.2734235591     , 28.9719801683     , 31.9500525273     ,
 35.127036568      , 38.188639657      , 40.6301454585     , 41.955964502      ,
 41.8993822239     , 40.4700931558     , 37.777728849      , 33.8903471867     ,
 28.9770172859     , 23.5181955        , 18.1938062503     , 13.5298312513     ,
 9.72470049092     , 6.76592551969     , 4.57520847762     , 3.02978261238     ,
 1.96191192288     , 1.2150847995      , 0.69383872662     , 0.352172477999    ,
 0.154389850032    , 0.0572502963259   , 0.017686143511    , 0.00450147386808  ,
 0.000936456290908 , 0.000158382201485 , 2.17089676607e-05 , 2.40885675903e-06 ,
 2.2256933205e-07  , 1.01078726462e-07 , 9.23355395122e-07 , 7.78249628233e-06 ,
 5.12434187678e-05 , 0.000263466416529 , 0.00105843761937  , 0.00332511121345  ,
 0.00817641419206  , 0.0157550568723   , 0.0238193041041   , 0.028294234912    ,
 0.0264465513147   , 0.0194798584935   , 0.0113226485055   , 0.00519948624753  ,
 0.00188791313035  , 0.000542233117739 , 0.00012317996499  , 2.21214643216e-05 ,
 3.13792681112e-06 , 3.51477438717e-07 , 3.1308617083e-08  , 2.38220227225e-09 ,
 2.35519834901e-10 , 5.16680969568e-11 , 1.49191741589e-11 , 1.20150373502e-11 ,
 1.78185655322e-10 , 2.92615804163e-09 , 3.80419295948e-08 , 3.89612702856e-07 ,
 3.13968517782e-06 , 1.98891062077e-05 , 9.89893522149e-05 , 0.000387108425846 ,
 0.00119054465447  , 0.00288570424573  , 0.00553375172788  , 0.00844913323188  ,
 0.0103840051383   , 0.0105163029413   , 0.00939301958295  , 0.00889323278572  ,
 0.0110888676365   , 0.0164498613473   , 0.0226054938674   , 0.0255537751407   ,
 0.0231528384552   , 0.0171903909609   , 0.0113783056546   , 0.00783467666788  ,
 0.00608874427476  , 0.00476796624644  , 0.00325989252342  , 0.00181551677996  ,
 0.000805024074541 , 0.000282507348261 , 7.83870359435e-05 , 1.72013823148e-05 ,
 2.98615963563e-06 , 4.10083566989e-07 , 4.45279769298e-08 , 3.81955951672e-09 ,
 2.58609555649e-10 , 1.40463708113e-11 , 1.12998916639e-12 , 9.43107765454e-13 ,
 1.2244442542e-12  , 1.28194776386e-12 , 1.07316789194e-12 , 8.22621707546e-13 ,
 1.25065656646e-12 , 4.91098326964e-12 , 2.01959703386e-11 , 6.77776649163e-11 ,
 1.81754498161e-10 , 3.94445335098e-10 , 1.20363716303e-08 , 1.91586411585e-08 ,
 5.91148146355e-08 , 4.82842449177e-07 , 4.18588301268e-06 , 2.94498997966e-05 ,
 0.000164031296227 , 0.000722490908831 , 0.00251794707135  , 0.00694808658918  ,
 0.0152024894173   , 0.0264937362656   , 0.0372793124272   , 0.0439377908521   ,
 0.046966764497    , 0.0507685688478   , 0.0584110563675   , 0.0695900875058   ,
 0.0870266877446   , 0.124970215143    , 0.212124380001    , 0.390213417692    ,
 0.711243556481    , 1.23182942701     , 2.00560928364     , 3.07805113357     ,
 4.47953747243     , 6.21015467865     , 8.22608486812     , 10.4386476705     ,
 12.7113089388     , 14.8487699041     , 16.61695663       , 17.8105359419     ,
 18.313086117      , 18.1133156049     , 17.3082767178     , 16.1013362033     ,
 14.7519738373     , 13.4797465298     , 12.3998872773     , 11.5380390412     ,
 10.8675028064     , 10.3061288449     , 9.72024048835     , 9.00797319933     ,
 8.20764925132     , 7.4968207306      , 7.05258955393     , 6.90682297684     ,
 6.94088244829     , 7.00935499995     , 7.05195667144     , 7.08684334731     ,
 7.12318089799     , 7.12218792439     , 7.06271601835     , 7.023144344       ,
 7.16977284381     , 7.65323558635     , 8.50709693349     , 9.63725356231     ,
 10.912360583      , 12.2695654957     , 13.7267967296     , 15.3024324251     ,
 16.9672972447     , 18.7053202972     , 20.5920977528     , 22.7645808413     ,
 25.3084374029     , 28.206852872      , 31.3971382946     , 34.8121096988     ,
 38.306905959      , 41.5501989446     , 44.0292542237     , 45.2217397603     ,
 44.8330842408     , 42.8837331217     , 39.5526810229     , 35.0231999383     ,
 29.587048341      , 23.7980983899     , 18.3173459386     , 13.5815624545     ,
 9.70889618154     , 6.66990827352     , 4.41394721405     , 2.84190972997     ,
 1.78549254931     , 1.07378462291     , 0.596096781735    , 0.294531904909    ,
 0.126046248115    , 0.0458709600043   , 0.014017986928    , 0.00356455729317  ,
 0.000749082394391 , 0.000129425241509 , 1.83135668047e-05 , 2.11677713029e-06 ,
 2.07558302951e-07 , 1.24693796072e-07 , 1.18168211468e-06 , 9.9611725135e-06  ,
 6.55887254469e-05 , 0.000337222340353 , 0.00135474120505  , 0.00425595716708  ,
 0.010465354795    , 0.0201655953467   , 0.0304873826796   , 0.0362150448906   ,
 0.0338501127908   , 0.0249331339855   , 0.0144923595441   , 0.00665505303645  ,
 0.0024164243707   , 0.000694030023504 , 0.000157667236979 , 2.83202855603e-05 ,
 4.02409033314e-06 , 4.57670182842e-07 , 4.6304088613e-08  , 6.98274324962e-09 ,
 2.26162436499e-09 , 8.36052649728e-10 , 2.56832442398e-10 , 6.55388700704e-11 ,
 7.89295506114e-11 , 1.10672203513e-09 , 1.43620971088e-08 , 1.47035652478e-07 ,
 1.18423909697e-06 , 7.49576176697e-06 , 3.72612449139e-05 , 0.000145443727621 ,
 0.000446047733254 , 0.00107653822432  , 0.00205130766799  , 0.00310380573459  ,
 0.00377253270506  , 0.00379801359723  , 0.0034986699197   , 0.00375566101253  ,
 0.00551055943803  , 0.00888721251623  , 0.0125295602215   , 0.0142258162977   ,
 0.0127938824051   , 0.00922261905205  , 0.00560726062301  , 0.00325375845712  ,
 0.00209243914486  , 0.0014691880529   , 0.000965568421383 , 0.000532286189465 ,
 0.000235894030906 , 8.29915688944e-05 , 2.31098850036e-05 , 5.09134296757e-06 ,
 8.87449043419e-07 , 1.22359411025e-07 , 1.33369482623e-08 , 1.14881956479e-09 ,
 8.05859773032e-11 , 1.1230442121e-11  , 1.51318589085e-11 , 2.50615046698e-11 ,
 3.31873859212e-11 , 3.47493916091e-11 , 2.89703037156e-11 , 2.11525414053e-11 ,
 2.59322025765e-11 , 8.99074424557e-11 , 3.62855370228e-10 , 1.21314696649e-09 ,
 3.24629699044e-09 , 6.94798599481e-09 , 1.66013185311e-07 , 2.30203944482e-07 ,
 2.86208778949e-07 , 6.19371834436e-07 , 3.70001132622e-06 , 2.50423191269e-05 ,
 0.000138960546609 , 0.0006117102473   , 0.00213162569992  , 0.00588333712078  ,
 0.0128850217187   , 0.0225234939319   , 0.0319819831347   , 0.0386344290595   ,
 0.0435838846543   , 0.0509832112452   , 0.0627612144727   , 0.0771316621254   ,
 0.0970108907014   , 0.141913062532    , 0.252159937626    , 0.482992181621    ,
 0.89430416389     , 1.54203510508     , 2.47554346959     , 3.74107889313     ,
 5.38185971307     , 7.42244430743     , 9.83846098225     , 12.524657853      ,
 15.27505934       , 17.8006520589     , 19.8090772683     , 21.105239791      ,
 21.6257366081     , 21.403629513      , 20.5451916135     , 19.236803571      ,
 17.7174504038     , 16.2032908835     , 14.836397075      , 13.6937151744     ,
 12.7932186321     , 12.0592111263     , 11.3307714541     , 10.4796806105     ,
 9.53769868552     , 8.68315485423     , 8.09012542962     , 7.79078098798     ,
 7.67426136068     , 7.60397625786     , 7.53163426478     , 7.50139087828     ,
 7.55587467225     , 7.66758388929     , 7.78492404873     , 7.9322226347      ,
 8.23475206396     , 8.83266804337     , 9.77135857649     , 10.9737572082     ,
 12.3138996276     , 13.7132228854     , 15.1664813674     , 16.6936719453     ,
 18.3052739684     , 20.0387451051     , 22.0119009224     , 24.398096851      ,
 27.3209194996     , 30.7749561247     , 34.6440842966     , 38.7470924277     ,
 42.8125625872     , 46.4153696153     , 48.9923696515     , 50.0008617758     ,
 49.1516452424     , 46.5127314439     , 42.362900543      , 37.0160433887     ,
 30.8814054155     , 24.5744236394     , 18.7454624577     , 13.7764485531     ,
 9.73703688761     , 6.57982252342     , 4.25311843973     , 2.65533471033     ,
 1.61035723405     , 0.93542415325     , 0.504445340443    , 0.244479382784    ,
 0.103990677008    , 0.0382348977521   , 0.0120213892894   , 0.00320148921729  ,
 0.000715418312715 , 0.000132928850803 , 2.03860953783e-05 , 2.57873564796e-06 ,
 2.83030146646e-07 , 1.37745277208e-07 , 1.19841575162e-06 , 1.00856216234e-05 ,
 6.64058129668e-05 , 0.00034142307615  , 0.00137161701358  , 0.00430897298636  ,
 0.0105957201479   , 0.0204167951392   , 0.0308671594268   , 0.0366661702679   ,
 0.0342717785818   , 0.0252437224259   , 0.0146728894067   , 0.00673795701757  ,
 0.00244653520056  , 0.000702700794914 , 0.00015968305553  , 2.87566911703e-05 ,
 4.18102724947e-06 , 5.71285811367e-07 , 1.33100316504e-07 , 6.15021447631e-08 ,
 2.94139002515e-08 , 1.1500444106e-08  , 3.55367404379e-09 , 8.64334388295e-10 ,
 1.84637891358e-10 , 3.54317412282e-10 , 4.28754520604e-09 , 4.385295157e-08   ,
 3.53035110661e-07 , 2.23307055534e-06 , 1.10892840494e-05 , 4.32186485103e-05 ,
 0.000132231574893 , 0.000318002144527 , 0.000602730609915 , 0.000905322306527 ,
 0.00109220573164  , 0.00110542837521  , 0.00108751198076  , 0.0013825839157   ,
 0.00235195227517  , 0.00400826336285  , 0.0057215184727   , 0.00649403487847  ,
 0.00580272438326  , 0.00410645844483  , 0.00236724876654  , 0.00120572598119  ,
 0.000633053504302 , 0.000377492569601 , 0.000230521700597 , 0.0001242158562   ,
 5.47975961922e-05 , 1.93006695738e-05 , 5.39023641302e-06 , 1.19170901999e-06 ,
 2.08491957379e-07 , 2.88541962473e-08 , 3.16036685868e-09 , 2.89348241394e-10 ,
 7.49756932338e-11 , 1.51990876049e-10 , 3.1983162789e-10  , 5.35724670871e-10 ,
 7.09580718403e-10 , 7.42848495761e-10 , 6.17640737984e-10 , 4.35983465595e-10 ,
 4.40830101632e-10 , 1.30409284655e-09 , 5.11244354384e-09 , 1.69844935988e-08 ,
 4.53461951604e-08 , 9.69094734137e-08 , 1.80991416362e-06 , 2.48761370386e-06 ,
 2.76761981351e-06 , 2.70894809768e-06 , 4.15971650482e-06 , 1.78681249447e-05 ,
 9.36757414246e-05 , 0.000408819029629 , 0.00142092760401  , 0.00391976616763  ,
 0.00860175611523  , 0.0151550833825   , 0.0220345142458   , 0.0282864782027   ,
 0.0359076133231   , 0.0486546567068   , 0.0673800903197   , 0.0897276191498   ,
 0.12057595236     , 0.186797766163    , 0.342056916804    , 0.656052769705    ,
 1.19740362978     , 2.02396650243     , 3.18595804759     , 4.73523771308     ,
 6.72821703221     , 9.20979510316     , 12.1692887045     , 15.4761469411     ,
 18.8387767597     , 21.8517718478     , 24.1431272554     , 25.5189752517     ,
 25.9843090986     , 25.658464024      , 24.7037891691     , 23.3074178793     ,
 21.6629304275     , 19.9367049639     , 18.2636500272     , 16.7666077855     ,
 15.5247327963     , 14.494293171      , 13.5124939525     , 12.4408401074     ,
 11.3038567675     , 10.2682134666     , 9.49666152618     , 9.02549619844     ,
 8.75796587149     , 8.56151868648     , 8.38287468645     , 8.27577847412     ,
 8.31619843638     , 8.50838196401     , 8.79708593092     , 9.16314948612     ,
 9.67623174031     , 10.4404481215     , 11.4961457871     , 12.7789439484     ,
 14.1697697818     , 15.5822173094     , 17.0063808004     , 18.4850710832     ,
 20.0755596356     , 21.8571307914     , 23.9724396199     , 26.6254148594     ,
 29.9934978763     , 34.1161435672     , 38.8474309082     , 43.870303225      ,
 48.716234317      , 52.7911826518     , 55.4543602519     , 56.1739529564     ,
 54.7205033995     , 51.2465320683     , 46.1387469174     , 39.8334496115     ,
 32.8466157249     , 25.8523960924     , 19.5066008131     , 14.1694557677     ,
 9.88705977519     , 6.58687654398     , 4.18514147279     , 2.55237548037     ,
 1.50032305247     , 0.842080265845    , 0.441883825531    , 0.212161431741    ,
 0.0916974835178   , 0.0351876204217   , 0.0117980388458   , 0.00339142899578  ,
 0.000820336162472 , 0.000164740392032 , 2.74981774308e-05 , 3.98620685149e-06 ,
 5.86879468036e-07 , 1.92304609902e-07 , 9.78871733997e-07 , 8.07826893325e-06 ,
 5.31630189635e-05 , 0.000273332291382 , 0.0010980719321   , 0.00344962347627  ,
 0.00848258856045  , 0.0163450214305   , 0.024711242824    , 0.029353742114    ,
 0.027436870281    , 0.0202093037126   , 0.0117466452469   , 0.00539422120588  ,
 0.00195872208327  , 0.000562832776998 , 0.000128395658821 , 2.39237834186e-05 ,
 4.499424168e-06   , 1.6215039114e-06  , 1.03666654053e-06 , 6.36438145149e-07 ,
 3.16154962276e-07 , 1.24138996739e-07 , 3.83767532898e-08 , 9.32453220632e-09 ,
 1.7826839872e-09  , 3.43377569181e-10 , 1.04005794819e-09 , 1.03268416794e-08 ,
 8.30825797577e-08 , 5.25234530348e-07 , 2.60610461355e-06 , 1.01440151875e-05 ,
 3.09773872772e-05 , 7.42898791016e-05 , 0.000140304140693 , 0.000210291322863 ,
 0.000256764899496 , 0.000281131019977 , 0.000355299255503 , 0.000626203822926 ,
 0.00123641052213  , 0.00214891080607  , 0.00301714448161  , 0.00334833453134  ,
 0.00292295972234  , 0.00201016620698  , 0.00110078339788  , 0.00049803072324  ,
 0.000205988337953 , 9.1916521635e-05  , 4.66884744523e-05 , 2.34519933797e-05 ,
 1.01536512763e-05 , 3.57146980046e-06 , 1.00233061181e-06 , 2.2350178484e-07  ,
 3.95961060318e-08 , 5.59290119148e-09 , 6.92885364333e-10 , 3.3685324784e-10  ,
 9.53493229431e-10 , 2.54226496284e-09 , 5.38379038259e-09 , 9.01914928427e-09 ,
 1.19461627258e-08 , 1.2505105821e-08  , 1.03800414336e-08 , 7.16409888165e-09 ,
 6.17313821974e-09 , 1.51163726284e-08 , 5.67085391335e-08 , 1.86394873669e-07 ,
 4.95616312609e-07 , 1.05752651067e-06 , 1.54475434719e-05 , 2.12208021559e-05 ,
 2.34445348513e-05 , 2.10082571129e-05 , 1.65659026086e-05 , 1.92782138721e-05 ,
 5.86856573449e-05 , 0.000229317319282 , 0.000769509818852 , 0.00209230305695  ,
 0.00459393288661  , 0.00829107171537  , 0.0129877837983   , 0.0196280106249   ,
 0.0314975769682   , 0.0523507386429   , 0.0822710416922   , 0.119032045266    ,
 0.171166530337    , 0.275055771091    , 0.498790145505    , 0.926298490772    ,
 1.63614983904     , 2.69529009504     , 4.1698663092      , 6.13502084544     ,
 8.66789637751     , 11.8193955397     , 15.5578087994     , 19.6897299893     ,
 23.817798152      , 27.4223159299     , 30.0622304618     , 31.5484201709     ,
 31.9504582208     , 31.4745302086     , 30.3511648317     , 28.7862762615     ,
 26.9390537761     , 24.9213850605     , 22.8460446374     , 20.8731049703     ,
 19.1518013042     , 17.6920276562     , 16.3485926221     , 14.978903251      ,
 13.5948268154     , 12.3445613643     , 11.3772837652     , 10.7328215941     ,
 10.3250909114     , 10.0171285032     , 9.73542877333     , 9.52563957859     ,
 9.49355279107     , 9.6994828973      , 10.1235987866     , 10.7235730649     ,
 11.4976750795     , 12.4799095944     , 13.6824783979     , 15.0507011094     ,
 16.4794388775     , 17.884124877      , 19.2631166035     , 20.6926532202     ,
 22.2743470435     , 24.1183872123     , 26.392151631      , 29.3481653063     ,
 33.2405716404     , 38.1623369043     , 43.9176838349     , 50.0045552349     ,
 55.7046012037     , 60.2355336451     , 62.9062860991     , 63.2478918787     ,
 61.1290886669     , 56.7860582608     , 50.6811044029     , 43.343736145      ,
 35.3954946167     , 27.5901147916     , 20.6132740581     , 14.8209787038     ,
 10.241347896      , 6.76817196574     , 4.26931941994     , 2.57540930773     ,
 1.4846102372      , 0.811531382087    , 0.416436667475    , 0.199253640658    ,
 0.0882598565774   , 0.0355832237296   , 0.0126892967079   , 0.00387992938873  ,
 0.000995490545254 , 0.000215154129019 , 4.19626906468e-05 , 8.89642713307e-06 ,
 2.38611758124e-06 , 7.55997128356e-07 , 7.89851758432e-07 , 5.14676657483e-06 ,
 3.36326465599e-05 , 0.000172886577681 , 0.00069454270774  , 0.00218192491328  ,
 0.00536533084493  , 0.0103384063743   , 0.0156301337195   , 0.0185665659283   ,
 0.0173541249535   , 0.012782619815    , 0.00742994772037  , 0.00341217531983  ,
 0.00123980220155  , 0.000358297960267 , 8.59110092781e-05 , 2.27212172512e-05 ,
 1.25392438645e-05 , 1.08192165197e-05 , 8.48040069527e-06 , 5.34247597498e-06 ,
 2.66157348823e-06 , 1.04540312312e-06 , 3.23190518035e-07 , 7.85251643837e-08 ,
 1.49741530401e-08 , 2.25221178066e-09 , 4.49111826834e-10 , 1.93986809088e-09 ,
 1.54154096189e-08 , 9.74010257041e-08 , 4.82986031587e-07 , 1.87849608614e-06 ,
 5.73297543248e-06 , 1.37703951653e-05 , 2.63520670515e-05 , 4.21538869669e-05 ,
 6.60823524177e-05 , 0.000132745387413 , 0.000340811769935 , 0.000858079946224 ,
 0.00181781723695  , 0.00309476962174  , 0.00418147316373  , 0.00446416823595  ,
 0.00375701497638  , 0.00248891999271  , 0.00129783290786  , 0.000534855901567 ,
 0.000177410790661 , 5.04643692542e-05 , 1.44569991744e-05 , 5.00296094531e-06 ,
 1.98629709549e-06 , 7.55319349011e-07 , 2.50059115431e-07 , 7.01685169255e-08 ,
 1.65809890378e-08 , 3.42067546997e-09 , 1.39632146033e-09 , 3.78131113619e-09 ,
 1.25739966551e-08 , 3.36475249162e-08 , 7.12614705075e-08 , 1.19381547274e-07 ,
 1.58127586281e-07 , 1.65523448521e-07 , 1.37268480864e-07 , 9.34016672465e-08 ,
 7.11887850155e-08 , 1.41658272426e-07 , 4.98269622301e-07 , 1.60904590843e-06 ,
 4.24725841284e-06 , 9.03483118086e-06 , 0.00010330557233  , 0.000141839867856 ,
 0.000156651895454 , 0.000139503327494 , 0.000102367519888 , 7.17380483469e-05 ,
 8.14355137557e-05 , 0.000182002488567 , 0.000466677951089 , 0.00108827754913  ,
 0.00224420757563  , 0.00425298940401  , 0.00813230629881  , 0.016819977723    ,
 0.0355751673067   , 0.0691569484899   , 0.11756369322     , 0.179172970748    ,
 0.267173133334    , 0.428557970906    , 0.745530270791    , 1.31506306909     ,
 2.22816378371     , 3.5729267213      , 5.45482488491     , 7.99957653661     ,
 11.3187246687     , 15.450566415      , 20.2897843221     , 25.5187020982     ,
 30.5999344174     , 34.9092934264     , 37.9746315741     , 39.6417595468     ,
 40.0384244283     , 39.417761824      , 38.0418853411     , 36.1400130316     ,
 33.8814690824     , 31.3690830623     , 28.7082548283     , 26.0890718311     ,
 23.7299846177     , 21.7077804909     , 19.9041936252     , 18.1645823901     ,
 16.4747299422     , 14.9632073982     , 13.7731949036     , 12.9484281726     ,
 12.4042546431     , 11.9893771415     , 11.6011410607     , 11.2664381786     ,
 11.1160806916     , 11.2791540673     , 11.7965953563     , 12.6195795102     ,
 13.6691455461     , 14.8888926357     , 16.2462687733     , 17.6930382306     ,
 19.1442375063     , 20.5244061836     , 21.8436239381     , 23.2081540609     ,
 24.7546209847     , 26.6233230591     , 29.0303103747     , 32.3144661554     ,
 36.82245055       , 42.6708786655     , 49.5496448821     , 56.7111944465     ,
 63.1750150395     , 68.0222071239     , 70.5928709689     , 70.535263338      ,
 67.8120936369     , 62.6906786124     , 55.6469467857     , 47.2739151331     ,
 38.3143514108     , 29.637941759      , 21.9836146001     , 15.7025398674     ,
 10.7932439183     , 7.11013136015     , 4.47684683807     , 2.68986563103     ,
 1.53450393905     , 0.824801438068    , 0.416650650625    , 0.198802664102    ,
 0.0895616628798   , 0.0372796663032   , 0.0137969675018   , 0.0043935362694   ,
 0.0012063415589   , 0.000312186300686 , 9.35961460337e-05 , 3.54122337249e-05 ,
 1.3912439887e-05  , 4.77786017069e-06 , 1.62121963365e-06 , 2.84152225437e-06 ,
 1.68360600407e-05 , 8.6304649732e-05  , 0.000346688217462 , 0.00108912825947  ,
 0.00267815499706  , 0.00516051208988  , 0.00780192732473  , 0.00926767614156  ,
 0.00866248545038  , 0.00638064455765  , 0.00370915446132  , 0.00170499706563  ,
 0.000624692494293 , 0.000193942697358 , 7.3724828862e-05  , 6.11488229453e-05 ,
 6.9875824659e-05  , 6.96754488916e-05 , 5.55862074001e-05 , 3.50872298429e-05 ,
 1.74839315391e-05 , 6.86743754214e-06 , 2.1231009892e-06  , 5.15846861547e-07 ,
 9.83625163688e-08 , 1.47026239328e-08 , 1.74738422661e-09 , 4.37279677169e-10 ,
 2.26285372753e-09 , 1.42331418424e-08 , 7.06885586905e-08 , 2.76668542565e-07 ,
 8.6427447734e-07  , 2.25762046078e-06 , 5.66726887735e-06 , 1.71319318315e-05 ,
 6.39030405753e-05 , 0.000238032948439 , 0.000763570402938 , 0.00200098835779  ,
 0.0042112714916   , 0.0070676832737   , 0.00941900053468  , 0.00993613744428  ,
 0.00827505552046  , 0.00542870043771  , 0.00280045269911  , 0.00113523900584  ,
 0.00036313647705  , 9.43634789085e-05 , 2.30147063532e-05 , 7.70968342845e-06 ,
 3.94543079026e-06 , 2.10113876037e-06 , 9.41860468432e-07 , 3.3851191066e-07  ,
 9.68747659303e-08 , 2.35309259396e-08 , 1.29232356697e-08 , 3.91226149169e-08 ,
 1.30650108728e-07 , 3.49652717996e-07 , 7.40532444189e-07 , 1.24061067793e-06 ,
 1.64332427252e-06 , 1.72029282119e-06 , 1.42614960725e-06 , 9.62448989591e-07 ,
 6.72774519985e-07 , 1.0883441709e-06  , 3.50083109145e-06 , 1.09861575539e-05 ,
 2.86331395238e-05 , 6.05560649706e-05 , 0.000542458341211 , 0.000743639032742 ,
 0.000821036740635 , 0.000730533536254 , 0.000531182025818 , 0.00034636433731  ,
 0.000292345058556 , 0.000437897464147 , 0.000788014679875 , 0.00128903071945  ,
 0.00196003680044  , 0.0033600231223   , 0.00764210133398  , 0.0200009266573   ,
 0.0487205178919   , 0.101280632865    , 0.179083546338    , 0.281534818406    ,
 0.425724287753    , 0.667588090825    , 1.10151413252     , 1.83764915859     ,
 2.98581100531     , 4.67116951203     , 7.062432743       , 10.358918345      ,
 14.7139007669     , 20.1312741313     , 26.3810626497     , 32.961309755      ,
 39.1584925559     , 44.2558529361     , 47.8027822859     , 49.729310614      ,
 50.2176106525     , 49.5073357502     , 47.8300303224     , 45.4335507116     ,
 42.5515262972     , 39.3382059878     , 35.9135019004     , 32.4871132205     ,
 29.3402119889     , 26.6283860156     , 24.2696526936     , 22.0855267705     ,
 20.0169006053     , 18.170580676      , 16.6953917733     , 15.6452182268     ,
 14.9339628166     , 14.3944155011     , 13.8973698491     , 13.449613824      ,
 13.195415257      , 13.3153476539     , 13.9005279361     , 14.9007618553     ,
 16.1766869375     , 17.5952396331     , 19.0789708079     , 20.5771136436     ,
 22.0201084323     , 23.3446177475     , 24.574312149      , 25.8378354703     ,
 27.2957714177     , 29.12279834       , 31.6113646491     , 35.2162566159     ,
 40.3738046426     , 47.1804434663     , 55.1544702658     , 63.2709574029     ,
 70.3067749005     , 75.2772289622     , 77.6396265143     , 77.2050229418     ,
 74.0054421867     , 68.2680361382     , 60.4185980798     , 51.0933313371     ,
 41.1723646312     , 31.6646085986     , 23.3722288079     , 16.6350048349     ,
 11.4087938234     , 7.50541069463     , 4.71699769573     , 2.82161111153     ,
 1.59587425877     , 0.847541613884    , 0.423293383579    , 0.201002027219    ,
 0.0910142280885   , 0.0384067942783   , 0.0145680454009   , 0.00493907919494  ,
 0.00164455195949  , 0.000661679785409 , 0.000334468895905 , 0.000170771203329 ,
 7.48252310377e-05 , 2.65921191502e-05 , 7.65528322404e-06 , 2.70007526196e-06 ,
 6.90571137899e-06 , 3.39905966756e-05 , 0.000136385114162 , 0.000428443056378 ,
 0.00105353605804  , 0.00203004887477  , 0.00306913276697  , 0.00364573735833  ,
 0.00340772067684  , 0.00251043850941  , 0.00146129746653  , 0.000679820769219 ,
 0.000275623868634 , 0.000153613750135 , 0.000186980785452 , 0.000279181464648 ,
 0.000353350167184 , 0.000356642781888 , 0.000284911353018 , 0.000179869222303 ,
 8.96301287375e-05 , 3.5205492362e-05  , 1.0883947588e-05  , 2.6444574645e-06  ,
 5.04248805409e-07 , 7.53615498091e-08 , 8.82074109545e-09 , 8.39163503777e-10 ,
 3.19209065115e-10 , 1.69441507188e-09 , 8.98064307231e-09 , 4.22283080285e-08 ,
 2.01545634298e-07 , 1.07655110992e-06 , 6.03709401511e-06 , 3.14403395561e-05 ,
 0.000141454371658 , 0.000533152025326 , 0.00165789678354  , 0.0042082280106   ,
 0.00864294119857  , 0.0142582331084   , 0.0187808043258   , 0.0196566397334   ,
 0.0162840560151   , 0.0106447189855   , 0.00547900864443  , 0.0022218821202   ,
 0.000720068897916 , 0.000203233432737 , 6.86931225506e-05 , 3.77643695257e-05 ,
 2.46176692469e-05 , 1.39892033939e-05 , 6.39127150572e-06 , 2.31584507673e-06 ,
 6.66234855153e-07 , 1.64538014823e-07 , 1.00665053618e-07 , 3.18214813904e-07 ,
 1.06446611871e-06 , 2.84885515806e-06 , 6.03373411163e-06 , 1.01087185771e-05 ,
 1.33911977157e-05 , 1.40208042328e-05 , 1.16256681171e-05 , 7.81673875264e-06 ,
 5.17321707967e-06 , 6.95486376226e-06 , 1.99415500555e-05 , 5.98415751075e-05 ,
 0.000152643223248 , 0.000319444304391 , 0.00224357174144  , 0.0030646667802   ,
 0.0033796935787   , 0.00300494342942  , 0.00217573938986  , 0.00138147484022  ,
 0.0010578767184   , 0.00140806352658  , 0.00233143788373  , 0.00341886357825  ,
 0.00428858060508  , 0.00558219232362  , 0.0106405037172   , 0.027379945435    ,
 0.0683683863682   , 0.146041273616    , 0.265468662066    , 0.427161189684    ,
 0.648463532647    , 0.988486699349    , 1.550338722       , 2.4603645061      ,
 3.85789657516     , 5.92056764368     , 8.89365617839     , 13.0538173116     ,
 18.5862569701     , 25.4385973192     , 33.2269613658     , 41.2366930556     ,
 48.5672464869     , 54.4347555366     , 58.4661833028     , 60.7194322735     ,
 61.4198515734     , 60.7365989407     , 58.8217790899     , 55.9389615638     ,
 52.4151684189     , 48.4783894343     , 44.2591897008     , 39.9708701842     ,
 35.9563992059     , 32.4711597339     , 29.4891824561     , 26.8047882802     ,
 24.2960138907     , 22.0377764777     , 20.1884690663     , 18.8226479922     ,
 17.8669283608     , 17.1568014175     , 16.5537049582     , 16.0461396563     ,
 15.7655601587     , 15.8948464331     , 16.5331609742     , 17.6264471986     ,
 19.0138293399     , 20.5323202892     , 22.0784500125     , 23.5863945959     ,
 24.9834144853     , 26.2132091116     , 27.3146521591     , 28.4324920058     ,
 29.7410822542     , 31.4494136396     , 33.9329704175     , 37.7573358803     ,
 43.4278837009     , 51.0066560766     , 59.8547155847     , 68.7049420704     ,
 76.1204533409     , 81.0666066824     , 83.1370349906     , 82.3277148453     ,
 78.7417105005     , 72.5419017925     , 64.078449265      , 54.0169428644     ,
 43.3570483754     , 33.2184034699     , 24.4464883811     , 17.3687816475     ,
 11.9041123942     , 7.8263835239      , 4.90597163878     , 2.91641222766     ,
 1.63337347888     , 0.857284273849    , 0.423186434285    , 0.199085678066    ,
 0.0898147273391   , 0.0382931479728   , 0.0153250912143   , 0.00624397971052  ,
 0.00314039644929  , 0.00200226433278  , 0.0012955748055   , 0.000722044874499 ,
 0.000327094759997 , 0.000118463972521 , 3.4153953276e-05  , 8.10465850985e-06 ,
 3.45364773284e-06 , 1.07103732974e-05 , 4.22406883422e-05 , 0.000132630971086 ,
 0.000326133385638 , 0.000628423318756 , 0.000950085134113 , 0.00112860500169  ,
 0.00105514043673  , 0.000778782502989 , 0.000461102392247 , 0.000246873405369 ,
 0.000204849394725 , 0.000356836527519 , 0.000689802194469 , 0.00110693836771  ,
 0.00141284298523  , 0.00142734811164  , 0.00114038483657  , 0.000719951972083 ,
 0.000358757704966 , 0.000140915153891 , 4.3564599425e-05  , 1.05848295725e-05 ,
 2.01832988031e-06 , 3.01644730432e-07 , 3.52940198852e-08 , 3.23310470413e-09 ,
 2.64931028869e-10 , 3.58867911073e-10 , 3.65884900176e-09 , 3.7121467538e-08  ,
 3.29680803827e-07 , 2.44450121373e-06 , 1.49306139923e-05 , 7.52139499828e-05 ,
 0.000314113744993 , 0.00109142725928  , 0.00315353130745  , 0.00754011702345  ,
 0.0148016046313   , 0.0236406376462   , 0.0304544575413   , 0.0314058192453   ,
 0.0257680540664   , 0.0167442779025   , 0.00859794547563  , 0.00351082455281  ,
 0.00119902607236  , 0.000431240633081 , 0.000242963370968 , 0.000185787917895 ,
 0.000131753091963 , 7.60087986629e-05 , 3.48188106905e-05 , 1.26276426129e-05 ,
 3.64054800114e-06 , 9.16158846129e-07 , 6.21813060391e-07 , 2.02953715108e-06 ,
 6.79279726348e-06 , 1.81783767338e-05 , 3.8502206084e-05  , 6.45110159112e-05 ,
 8.54730476101e-05 , 8.95234137221e-05 , 7.42908915758e-05 , 4.995841237e-05   ,
 3.21513273036e-05 , 3.74113849824e-05 , 9.38251258736e-05 , 0.000263463520957 ,
 0.000648723701271 , 0.00133281762832  , 0.00734311759007  , 0.00995814726629  ,
 0.0109501314794   , 0.00972276328049  , 0.00701593580207  , 0.00437033211295  ,
 0.0031187300737   , 0.00382955078462  , 0.00616866961483  , 0.0089232450599   ,
 0.0107220683904   , 0.0119355962789   , 0.0172090392282   , 0.0376991841606   ,
 0.0912749641697   , 0.197203223321    , 0.366233215986    , 0.599299286577    ,
 0.908220454164    , 1.34664079296     , 2.0211100596      , 3.07663049401     ,
 4.69060426288     , 7.10033049484     , 10.6239984254     , 15.5975755955     ,
 22.2150893532     , 30.3555833255     , 39.4869991216     , 48.7020831399     ,
 56.9467577037     , 63.4178332493     , 67.8648556464     , 70.4857612708     ,
 71.5239229719     , 71.0480448825     , 69.1228445947     , 66.0275669765     ,
 62.1607090028     , 57.779774925      , 52.9859372772     , 47.9797074375     ,
 43.1748249375     , 38.9519443038     , 35.3667220561     , 32.197259748      ,
 29.2530370168     , 26.562999779      , 24.2845542678     , 22.5184842928     ,
 21.231172287      , 20.2987783783     , 19.599946079      , 19.0998645393     ,
 18.875494449      , 19.052329905      , 19.696740313      , 20.7576718857     ,
 22.1023769699     , 23.5945050141     , 25.1310178633     , 26.6188652555     ,
 27.954267856      , 29.0703014873     , 30.0152184362     , 30.944487223      ,
 32.0418140417     , 33.5476711853     , 35.9004782964     , 39.7301634349     ,
 45.5749417883     , 53.4913051918     , 62.7860425186     , 72.0643220553     ,
 79.7149080095     , 84.5953453944     , 86.350911319      , 85.1338491893     ,
 81.1577172773     , 74.5854155285     , 65.73657368       , 55.2998480625     ,
 44.3237579744     , 33.9391075544     , 24.9726074572     , 17.7419505355     ,
 12.1629028221     , 7.99707071122     , 5.00368715882     , 2.9580970194      ,
 1.64124427596     , 0.850936151293    , 0.414125112934    , 0.192175547924    ,
 0.0864960688315   , 0.0383821597211   , 0.017938909111    , 0.0103660337182   ,
 0.00775380981128  , 0.00613397106852  , 0.00428712629458  , 0.00246280411664  ,
 0.0011365503432   , 0.000418097127853 , 0.000122176432386 , 2.83617413415e-05 ,
 5.67570386998e-06 , 3.3042931388e-06  , 1.03542023745e-05 , 3.22682345468e-05 ,
 7.93291008023e-05 , 0.000152858066442 , 0.000231106445244 , 0.000274610228914 ,
 0.000257415951024 , 0.000194587209066 , 0.000139484339476 , 0.000173912228646 ,
 0.000423436026431 , 0.00105353191788  , 0.00214299458773  , 0.00345909702369  ,
 0.00441791234075  , 0.00446359362281  , 0.00356623265874  , 0.00225144918949  ,
 0.0011219148696   , 0.000440672927715 , 0.000136236161019 , 3.31011088178e-05 ,
 6.3117650123e-06  , 9.43309882459e-07 , 1.10371353897e-07 , 1.01015991025e-08 ,
 7.52767828138e-10 , 5.84105095632e-10 , 7.82901528298e-09 , 8.98194966118e-08 ,
 8.20562196015e-07 , 5.98759964284e-06 , 3.50991582035e-05 , 0.000166529062834 ,
 0.000644993198752 , 0.00205697622417  , 0.00543912743887  , 0.0119650988971   ,
 0.0218659099938   , 0.0329984083308   , 0.0407605550206   , 0.0408118065633   ,
 0.0328291078287   , 0.0210738576797   , 0.0107882112174   , 0.00452298642718  ,
 0.00180788838649  , 0.00102451945422  , 0.000884127999054 , 0.000774841047165 ,
 0.000563929426835 , 0.000326770712868 , 0.000149849008234 , 5.44232117326e-05 ,
 1.57759667734e-05 , 4.09480497565e-06 , 3.0663649905e-06  , 1.0154353627e-05  ,
 3.39253589069e-05 , 9.07579512473e-05 , 0.00019223794878  , 0.00032215662865  ,
 0.000426981634049 , 0.00044752816161  , 0.000372031410604 , 0.0002512307575   ,
 0.000160916687411 , 0.000170682595485 , 0.000372819619011 , 0.00095536025896  ,
 0.00222575067559  , 0.00443231425968  , 0.0191596862184   , 0.0256269483314   ,
 0.0280073807399   , 0.0247994979932   , 0.0178368539006   , 0.0109477161785   ,
 0.00737812036361  , 0.00842967584478  , 0.0133036624616   , 0.0192838270194   ,
 0.0231013337561   , 0.0242565966611   , 0.0286946308873   , 0.0510295217427   ,
 0.114463016055    , 0.24525141609     , 0.460306159718    , 0.760381647732    ,
 1.147983077       , 1.66441884991     , 2.41227503743     , 3.54939031178     ,
 5.28647205975     , 7.91206697695     , 11.7977514041     , 17.3084369111     ,
 24.6231243567     , 33.5583650619     , 43.477915181      , 53.3534626902     ,
 62.0579942714     , 68.8311722156     , 73.558544201      , 76.544343957      ,
 78.0167554128     , 77.9534439176     , 76.3642276319     , 73.5400992032     ,
 69.8856944947     , 65.6012540804     , 60.7041224826     , 55.3688157166     ,
 50.0824655537     , 45.3554328223     , 41.3377944891     , 37.8148419277     ,
 34.5460916018     , 31.5117802023     , 28.8506367574     , 26.6833515406     ,
 25.0381653033     , 23.8702045318     , 23.0986857747     , 22.6515378435     ,
 22.5065725204     , 22.6884676821     , 23.2206021927     , 24.0852229408     ,
 25.2284989022     , 26.5829975859     , 28.0608605082     , 29.52753698       ,
 30.819049256      , 31.8317163226     , 32.607660032      , 33.3089920589     ,
 34.1371570733     , 35.3693221264     , 37.4742302945     , 41.0720703509     ,
 46.6793661086     , 54.3865053263     , 63.5872299895     , 72.9214280377     ,
 80.6725206569     , 85.5155177432     , 87.001225634      , 85.3520999076     ,
 80.9314119273     , 74.0214199354     , 65.0128049244     , 54.624208786      ,
 43.8551842922     , 33.7089302814     , 24.9012619845     , 17.7333392271     ,
 12.1661176845     , 7.99772094199     , 4.99780769577     , 2.94493751464     ,
 1.62407516286     , 0.834300460122    , 0.401254464711    , 0.184935994128    ,
 0.0854459230153   , 0.0426540266788   , 0.0259747775672   , 0.0206512528955   ,
 0.0186798898165   , 0.0158661558378   , 0.0114077395992   , 0.00667145765496  ,
 0.00312686891149  , 0.00116711991885  , 0.000345691347514 , 8.10485827512e-05 ,
 1.50937610045e-05 , 2.67535762488e-06 , 2.21085020307e-06 , 6.1798338733e-06  ,
 1.51422604366e-05 , 2.91758567184e-05 , 4.41285340373e-05 , 5.26288359922e-05 ,
 5.09976811438e-05 , 4.97433808032e-05 , 9.34187231702e-05 , 0.000311524389851 ,
 0.000994082881316 , 0.0025642089473   , 0.00523729971333  , 0.00845760900005  ,
 0.0108024941319   , 0.0109142537425   , 0.00872005737747  , 0.00550518413951  ,
 0.00274327665118  , 0.00107752182199  , 0.000333121068312 , 8.09379583898e-05 ,
 1.54333613637e-05 , 2.30655644509e-06 , 2.69877064251e-07 , 2.46993122554e-08 ,
 1.82806364084e-09 , 1.2399648792e-09  , 1.6560659186e-08  , 1.8941866265e-07  ,
 1.71362119691e-06 , 1.22984715162e-05 , 7.0300491205e-05  , 0.000321634168337 ,
 0.001184902113    , 0.00354062993573  , 0.00865240459781  , 0.0174345351398   ,
 0.0291500442266   , 0.0405351427871   , 0.0467478571352   , 0.0443866052555   ,
 0.0343710795888   , 0.0215482357829   , 0.0110335755701   , 0.00504962381496  ,
 0.00288160871792  , 0.00267416944301  , 0.00284866669214  , 0.00261021600306  ,
 0.00191442127962  , 0.00111109692041  , 0.00051022567843  , 0.000186083481085 ,
 5.48011745038e-05 , 1.51487070045e-05 , 1.23367960644e-05 , 3.99865207276e-05 ,
 0.000132579501471 , 0.000354302592936 , 0.000750518570924 , 0.00125821614006  ,
 0.00166878302195  , 0.00175150611873  , 0.00146096333162  , 0.000996072113297 ,
 0.000649481135564 , 0.000663203642208 , 0.00127907647193  , 0.00292432708667  ,
 0.00628238675039  , 0.0118927484025   , 0.0403412391199   , 0.0526101503376   ,
 0.0567997002153   , 0.0500144322154   , 0.0358372611221   , 0.0217576176525   ,
 0.0140468207877   , 0.0151235471523   , 0.0235246601927   , 0.0344330367261   ,
 0.0418299848496   , 0.0435895058386   , 0.046526596397    , 0.0681173160932   ,
 0.13531859642     , 0.279025388028    , 0.520922547555    , 0.862788184891    ,
 1.30051500133     , 1.86271548703     , 2.63948998098     , 3.78392163784     ,
 5.51733169959     , 8.1538993202      , 12.0866822624     , 17.6738251814     ,
 25.0600593224     , 34.0234386301     , 43.9015559258     , 53.663014105      ,
 62.2254270424     , 68.9298438304     , 73.7661944744     , 77.0687873757     ,
 79.0161044554     , 79.53001819       , 78.6114006139     , 76.5519613401     ,
 73.6953535051     , 70.1177910486     , 65.7250046788     , 60.6567365315     ,
 55.4438953701     , 50.6786110659     , 46.5820722849     , 42.9704925649     ,
 39.5958855198     , 36.410602608      , 33.5272811527     , 31.0740551045     ,
 29.1432860903     , 27.7841071874     , 26.9666967926     , 26.5732704146     ,
 26.4604514774     , 26.5390014449     , 26.8039092568     , 27.3091830817     ,
 28.1187131698     , 29.2521156202     , 30.6330710609     , 32.0723737189     ,
 33.3310020556     , 34.251157187      , 34.8511851516     , 35.2954423365     ,
 35.8203762106     , 36.7554407417     , 38.5723488156     , 41.8072690025     ,
 46.8894441782     , 53.9535355628     , 62.5833116339     , 71.5976475345     ,
 79.2698662345     , 84.0729783923     , 85.3515684264     , 83.296784213      ,
 78.418803236      , 71.2075726564     , 62.2175047921     , 52.2146331286     ,
 42.0820542698     , 32.5919078776     , 24.2673967677     , 17.367121584      ,
 11.9255450432     , 7.8258537687      , 4.87862386926     , 2.86894835253     ,
 1.57935713153     , 0.80956338412     , 0.389461050213    , 0.183186842803    ,
 0.0920565409544   , 0.0553224314561   , 0.0424514998818   , 0.0393772679494   ,
 0.0378961594829   , 0.0329891927587   , 0.0241057890866   , 0.0143088397634   ,
 0.00680383437996  , 0.00257440735173  , 0.000772087042183 , 0.000183009798101 ,
 3.42158804081e-05 , 5.10216945893e-06 , 8.73960300681e-07 , 9.73530382925e-07 ,
 2.26843243281e-06 , 4.36664329242e-06 , 6.63797215162e-06 , 8.28668168566e-06 ,
 1.1200932702e-05  , 3.15583798456e-05 , 0.000141785236229 , 0.000579169235948 ,
 0.00189617709976  , 0.00490527243265  , 0.0100220486676   , 0.0161849805072   ,
 0.0206723733481   , 0.0208862532021   , 0.0166872916387   , 0.0105350928072   ,
 0.00524971979151  , 0.00206201865665  , 0.000637483013118 , 0.000154888352909 ,
 2.95343244262e-05 , 4.41398245934e-06 , 5.16454987944e-07 , 4.72656958089e-08 ,
 3.48492403107e-09 , 2.1255104051e-09  , 2.80529832444e-08 , 3.19820050337e-07 ,
 2.87829045438e-06 , 2.04897525448e-05 , 0.000115670747655 , 0.00051935824967  ,
 0.00186118269669  , 0.00534687978242  , 0.0123840288742   , 0.023290293949    ,
 0.0358620212421   , 0.0455791845034   , 0.0480903110305   , 0.0421728409931   ,
 0.0306434640085   , 0.018458726986    , 0.00964899023203  , 0.00556341822442  ,
 0.00522314743811  , 0.00656474957783  , 0.00753688443307  , 0.00699934177575  ,
 0.00514689307688  , 0.002991744028    , 0.00137903617504  , 0.000509423783548 ,
 0.000157039402593 , 4.98337290605e-05 , 4.26439062848e-05 , 0.00012522749547  ,
 0.000405861807729 , 0.00108126230634  , 0.00229054607378  , 0.00384306237018  ,
 0.00510446581904  , 0.00537235297578  , 0.00451011910245  , 0.00313092284549  ,
 0.00213175077287  , 0.00220405786973  , 0.00385472476324  , 0.00776851776871  ,
 0.0149811732227   , 0.0262513977479   , 0.0699934919784   , 0.0872662008308   ,
 0.0920269466037   , 0.0801438518204   , 0.0571397057063   , 0.0344830834162   ,
 0.0217267413923   , 0.0225185665592   , 0.0348302594868   , 0.0518230904088   ,
 0.0645169893987   , 0.0684949754134   , 0.0704292237421   , 0.0890982628101   ,
 0.152366019057    , 0.291711561103    , 0.530987538764    , 0.875769376749    ,
 1.32336292548     , 1.89526032913     , 2.66228837395     , 3.75129001029     ,
 5.36396936798     , 7.8053903627      , 11.4498247245     , 16.6089229764     ,
 23.3762107957     , 31.5242234104     , 40.4597644894     , 49.2882865611     ,
 57.0983883902     , 63.3715924846     , 68.1371322862     , 71.6658017691     ,
 74.0547238847     , 75.2039626274     , 75.1357540704     , 74.1267120393     ,
 72.4280632447     , 69.994313707      , 66.6526733663     , 62.5143745215     ,
 58.0886710595     , 53.9417567865     , 50.2946429493     , 46.9984517707     ,
 43.8419978348     , 40.7831183514     , 37.9157667327     , 35.3675437557     ,
 33.2818794704     , 31.7921764864     , 30.922674789      , 30.5280907479     ,
 30.367431584      , 30.2546910321     , 30.1655188861     , 30.2315602139     ,
 30.6357806818     , 31.4770062559     , 32.6814804624     , 34.0114152864     ,
 35.1725667356     , 35.9644978093     , 36.3737623014     , 36.5575194984     ,
 36.7940829441     , 37.4738517693     , 39.0542729256     , 41.9413611728     ,
 46.4265702699     , 52.6644842762     , 60.4515918558     , 68.8565931304     ,
 76.2329924472     , 80.9090506669     , 82.0104345959     , 79.6352753959     ,
 74.3916414903     , 66.9743984946     , 58.1218190473     , 48.6582488151     ,
 39.3504660276     , 30.7316746852     , 23.105240707      , 16.6478178351     ,
 11.4484929195     , 7.49002344595     , 4.64816880612     , 2.72523928926     ,
 1.50015266174     , 0.77195274079     , 0.377115938786    , 0.187075463634    ,
 0.106478385444    , 0.0754970841979   , 0.0651917180329   , 0.0633812390306   ,
 0.0619364940532   , 0.0545137156979   , 0.0403413818934   , 0.0242743780818   ,
 0.0116982892083   , 0.00448193759471  , 0.00135928461945  , 0.000325345357219 ,
 6.13113886592e-05 , 9.08681955277e-06 , 1.08882039256e-06 , 2.03786413999e-07 ,
 2.72203996148e-07 , 5.15623560271e-07 , 8.33803604998e-07 , 1.59263083102e-06 ,
 6.66941795357e-06 , 3.98591099596e-05 , 0.000208248919035 , 0.000866378191745 ,
 0.00284228195704  , 0.00735443909828  , 0.0150263612608   , 0.0242666994072   ,
 0.0309948118552   , 0.0313154904745   , 0.0250198405282   , 0.015795633456    ,
 0.00787108866479  , 0.00309165675875  , 0.00095580059848  , 0.000232229529825 ,
 4.42818465463e-05 , 6.61803842852e-06 , 7.74339033368e-07 , 7.08664551008e-08 ,
 5.20883242789e-09 , 2.8849713479e-09  , 3.76520231722e-08 , 4.28586756967e-07 ,
 3.84790346311e-06 , 2.72891287469e-05 , 0.000153154990723 , 0.000681481609809 ,
 0.00240884611555  , 0.00677924464653  , 0.0152351735322   , 0.027452825859    ,
 0.0398927727428   , 0.047103615245    , 0.0455924226256   , 0.0364889516019   ,
 0.0243599192314   , 0.0139360202852   , 0.00793380202941  , 0.0068566583372   ,
 0.00955262855275  , 0.013577671465    , 0.0159562094883   , 0.0148828190519   ,
 0.0109650272777   , 0.00639790470959  , 0.00298314221908  , 0.00114443940739  ,
 0.000397626694538 , 0.000163034667596 , 0.000138276483967 , 0.000320545533344 ,
 0.000977404436892 , 0.00258127197174  , 0.00546704028454  , 0.00918760144838  ,
 0.0122400876512   , 0.0129547406356   , 0.0110102258749   , 0.00789354502769  ,
 0.00578850003832  , 0.00631007900442  , 0.010303246356    , 0.0183649105456   ,
 0.0312039899632   , 0.0491172527107   , 0.103731377095    , 0.119853592049    ,
 0.120925199913    , 0.103069180397    , 0.0729999020226   , 0.0442331781153   ,
 0.0280366756192   , 0.028837553536    , 0.0446139522681   , 0.0675689405229   ,
 0.0865185153342   , 0.0945095700424   , 0.0968006835229   , 0.111527618964    ,
 0.164682660352    , 0.284596569982    , 0.494419835695    , 0.804900528042    ,
 1.22083714621     , 1.76186246327     , 2.47716431443     , 3.4556948308      ,
 4.85964146372     , 6.95507750641     , 10.0583566735     , 14.3988607132     ,
 20.0076102472     , 26.6824331648     , 33.978305639      , 41.2471598343     ,
 47.8372427976     , 53.3820906738     , 57.886541989      , 61.4876443706     ,
 64.1833284283     , 65.8725640289     , 66.6062808366     , 66.6292861708     ,
 66.1062841213     , 64.9348858683     , 62.9522925283     , 60.2721843421     ,
 57.3120773199     , 54.4853656828     , 51.9173413788     , 49.4692826494     ,
 46.979140938      , 44.4168220001     , 41.8531755199     , 39.4106079919     ,
 37.2790808101     , 35.6734754961     , 34.6873275319     , 34.19375393       ,
 33.9142373864     , 33.6024565156     , 33.2045200983     , 32.8843577467     ,
 32.892639751      , 33.374059209      , 34.2572055283     , 35.2927956734     ,
 36.1885068898     , 36.7454138673     , 36.9303727234     , 36.8824488083     ,
 36.9026749071     , 37.4198103093     , 38.858744231      , 41.4886674962     ,
 45.4533185166     , 50.8930240553     , 57.7731143645     , 65.4065403281     ,
 72.2900820871     , 76.7097030162     , 77.6419596621     , 75.0825270254     ,
 69.668061933      , 62.2178403309     , 53.5947340113     , 44.6680804639     ,
 36.1387259613     , 28.3836534732     , 21.5283802254     , 15.6368131199     ,
 10.7931599561     , 7.04835998825     , 4.349389434       , 2.53421523932     ,
 1.38961618739     , 0.716550382802    , 0.356930185573    , 0.188582136636    ,
 0.120105152115    , 0.0941139057675   , 0.0846947592547   , 0.0826372916441   ,
 0.0806887289704   , 0.0714396987846   , 0.0534344692255   , 0.0325500146851   ,
 0.0158771835613   , 0.00615072090401  , 0.00188366198959  , 0.000454636203763 ,
 8.62787350547e-05 , 1.28516951857e-05 , 1.50345245779e-06 , 1.47098436346e-07 ,
 3.44045065311e-08 , 5.2474454135e-08  , 1.4298965209e-07  , 8.78119346057e-07 ,
 6.91431999558e-06 , 4.61964077288e-05 , 0.00024454011541  , 0.00101883432364  ,
 0.00334297039219  , 0.0086501292419   , 0.017673709701    , 0.0285420193697   ,
 0.0364554951179   , 0.0368326711746   , 0.0294278500936   , 0.018578517036    ,
 0.00925782148963  , 0.00363634658415  , 0.00112419408512  , 0.000273143858918 ,
 5.20834471898e-05 , 7.78400829012e-06 , 9.10762948369e-07 , 8.33522819799e-08 ,
 6.11288439106e-09 , 3.09706036208e-09 , 3.99239956576e-08 , 4.54055502458e-07 ,
 4.07206574445e-06 , 2.88292540296e-05 , 0.000161363747394 , 0.000715004721097 ,
 0.00251100156387  , 0.00699666093051  , 0.0154871238775   , 0.0272795235353   ,
 0.038342682245    , 0.0431923602583   , 0.03925207565     , 0.0290553016407   ,
 0.0178535342791   , 0.00984475989377  , 0.00684112527983  , 0.00902844477876  ,
 0.0152985360731   , 0.0226561489138   , 0.0268259177704   , 0.0250885808052   ,
 0.0185630480432   , 0.010955502226    , 0.00528441746991  , 0.00224271965074  ,
 0.000996178288709 , 0.000562036732605 , 0.000451413297648 , 0.000711974199869 ,
 0.00187449950637  , 0.00483283190346  , 0.010222456044    , 0.0172366848366   ,
 0.0231077003064   , 0.0247347515209   , 0.0215199292872   , 0.0163066533281   ,
 0.0133401560963   , 0.0157045299703   , 0.0244865995537   , 0.0392544573566   ,
 0.0587348330841   , 0.0812277551554   , 0.138721520214    , 0.142773614702    ,
 0.133150097174    , 0.109005939654    , 0.076771745938    , 0.0480268475457   ,
 0.0324276664732   , 0.0341225965953   , 0.0519514078404   , 0.078860492094    ,
 0.102965559427    , 0.115224282935    , 0.118645822238    , 0.129176568398    ,
 0.169242239576    , 0.26211806323     , 0.428068637055    , 0.681055003639    ,
 1.03204587781     , 1.49847381674     , 2.10990507382     , 2.9214373925      ,
 4.05454610166     , 5.72123111893     , 8.15572879484     , 11.4895343468     ,
 15.6952026068     , 20.6160571364     , 25.9848309883     , 31.4305401093     ,
 36.5750558895     , 41.1885863839     , 45.2220119394     , 48.6648715102     ,
 51.4265676637     , 53.4185183322     , 54.7148099831     , 55.5164724337     ,
 55.9255910249     , 55.860967647      , 55.2600027199     , 54.276269041      ,
 53.1979927993     , 52.2101300799     , 51.2806439812     , 50.2465617932     ,
 48.959933897      , 47.3492923361     , 45.4132084057     , 43.2557410708     ,
 41.136662545      , 39.3884548069     , 38.2100839498     , 37.5361836811     ,
 37.1025210957     , 36.6395386008     , 36.0538373143     , 35.4794419986     ,
 35.1551043002     , 35.2226371047     , 35.6196925868     , 36.1365038532     ,
 36.5487911584     , 36.7163194632     , 36.6214865589     , 36.3873942516     ,
 36.2990534588     , 36.7634361534     , 38.1409928238     , 40.5863244088     ,
 44.1286544002     , 48.8743377135     , 54.8876623681     , 61.679835041      ,
 67.931355243      , 71.9942090662     , 72.7888842368     , 70.2196649956     ,
 64.8832786193     , 57.6202745572     , 49.3262534206     , 40.8804284105     ,
 32.9713255844     , 25.9326324451     , 19.7972547528     , 14.5139806894     ,
 10.0978552577     , 6.61154457861     , 4.06218897256     , 2.34327092151     ,
 1.26924689301     , 0.64863085511     , 0.325009996831    , 0.178649792411    ,
 0.121528192421    , 0.0996008329409   , 0.0901437198404   , 0.086781883006    ,
 0.0839519565066   , 0.0744077309454   , 0.0560742396113   , 0.0344976106998   ,
 0.0169975664396   , 0.00664624404201  , 0.00205211419686  , 0.000498784352114 ,
 9.52381099475e-05 , 1.42705931308e-05 , 1.68000076258e-06 , 1.5716041412e-07  ,
 1.38355378646e-08 , 8.88309139606e-09 , 7.18668681125e-08 , 7.39742541253e-07 ,
 6.32159109046e-06 , 4.2634087795e-05  , 0.000225915317    , 0.000941343527732 ,
 0.00308874817877  , 0.00799232555112  , 0.0163297055145   , 0.0263715307588   ,
 0.0336832233273   , 0.0340317168966   , 0.0271899982094   , 0.0171657067484   ,
 0.00855380698644  , 0.00335981924598  , 0.00103870432482  , 0.000252372532006 ,
 4.8122742793e-05  , 7.19207410229e-06 , 8.41515932824e-07 , 7.70462888513e-08 ,
 5.70563545517e-09 , 2.73832572107e-09 , 3.35230785884e-08 , 3.79450741371e-07 ,
 3.39990512328e-06 , 2.40508112178e-05 , 0.000134452370785 , 0.000594618406771 ,
 0.00208198337603  , 0.00577431675272  , 0.0126896231887   , 0.0221047583514   ,
 0.0305460469107   , 0.0335427008856   , 0.0293692552754   , 0.0206575548312   ,
 0.0119950160593   , 0.0067198298961   , 0.00624159476964  , 0.0109586287901   ,
 0.0200392685102   , 0.0300885824994   , 0.0357717193216   , 0.0336311746541   ,
 0.0252000772556   , 0.0153825824653   , 0.0081279768384   , 0.0042769457243   ,
 0.00264481166842  , 0.00189586550623  , 0.00144421788762  , 0.00150300753035  ,
 0.00295464829333  , 0.0071487945471   , 0.0150423857988   , 0.0255314169861   ,
 0.0346689775818   , 0.0379495124218   , 0.0344712529081   , 0.028541717174    ,
 0.0268272235064   , 0.0341827002452   , 0.0515713117694   , 0.0761066129306   ,
 0.102257899315    , 0.124341170159    , 0.177699851067    , 0.158700656257    ,
 0.131279293851    , 0.100631316437    , 0.071581573094    , 0.0495450929771   ,
 0.0387713796997   , 0.0417366557634   , 0.0588645596051   , 0.0855181051635   ,
 0.110875114586    , 0.125008248653    , 0.128748524467    , 0.134948960573    ,
 0.161619547539    , 0.226750841056    , 0.346949836348    , 0.535939981628    ,
 0.804532553791    , 1.16331071022     , 1.62624049201     , 2.2273716507      ,
 3.05788021053     , 4.2751427087      , 6.0294748228      , 8.36687910004     ,
 11.2227727299     , 14.4923954867     , 18.0618959876     , 21.7868116509     ,
 25.5060088793     , 29.0932162675     , 32.4565758376     , 35.481721242      ,
 38.02873143       , 40.0318755183     , 41.5783688559     , 42.8247840809     ,
 43.8406865866     , 44.6144430972     , 45.2174222555     , 45.8519727236     ,
 46.6818288951     , 47.679156166      , 48.6679089357     , 49.4456725714     ,
 49.8187696131     , 49.5816970987     , 48.5793080648     , 46.873421068      ,
 44.8315677053     , 42.9620940422     , 41.604736257      , 40.7634911393     ,
 40.1961198343     , 39.6323191081     , 38.9520380465     , 38.2302800968     ,
 37.6334828851     , 37.2577672303     , 37.0543311346     , 36.8879447455     ,
 36.6415083591     , 36.2758211598     , 35.8360874344     , 35.4512972677     ,
 35.3518126101     , 35.8458205574     , 37.1886295666     , 39.4556737562     ,
 42.6214800263     , 46.7593111299     , 51.9642736271     , 57.8871902753     ,
 63.4181840527     , 67.0711101526     , 67.7912626316     , 65.3953557874     ,
 60.3770713839     , 53.5130277947     , 45.6579710314     , 37.6644659369     ,
 30.2332366111     , 23.7349842263     , 18.1943980751     , 13.4752877258     ,
 9.49181959406     , 6.26965241366     , 3.85420980162     , 2.20311985502     ,
 1.17416312436     , 0.589170020151    , 0.290777682422    , 0.158839855575    ,
 0.108565505257    , 0.0893456648793   , 0.0800377961367   , 0.0752414948231   ,
 0.0711782419632   , 0.0623822662477   , 0.0469415166784   , 0.028989655332    ,
 0.0143693986477   , 0.00565513321402  , 0.0017572375301   , 0.000429929687676 ,
 8.28328989755e-05 , 1.26530233403e-05 , 1.57350835741e-06 , 1.72247777775e-07 ,
 1.95502731898e-08 , 6.06567078642e-09 , 4.91164832024e-08 , 5.33708514237e-07 ,
 4.59131486476e-06 , 3.09873795249e-05 , 0.000164213247918 , 0.000684249442614 ,
 0.00224517000758  , 0.0058095158593   , 0.0118698473528   , 0.0191691175754   ,
 0.0244838903846   , 0.02473720576     , 0.0197640507638   , 0.0124775256313   ,
 0.00621764937981  , 0.00244220825706  , 0.00075502046232  , 0.000183446265474 ,
 3.49798051693e-05 , 5.22790261331e-06 , 6.11951388441e-07 , 5.67089730988e-08 ,
 5.63356153829e-09 , 4.34720629437e-09 , 2.54140693087e-08 , 2.52983156052e-07 ,
 2.23717520243e-06 , 1.58008209995e-05 , 8.82727316646e-05 , 0.000390042774009 ,
 0.00136381864114  , 0.00377442519327  , 0.00826696813759  , 0.0143256104412   ,
 0.019635520288    , 0.0212912703977   , 0.0182878025485   , 0.0125195595877   ,
 0.007108793612    , 0.00434714721721  , 0.00544738666326  , 0.0111438636717   ,
 0.0209858076059   , 0.0317279890319   , 0.0379839975808   , 0.0362618626225   ,
 0.0282028660131   , 0.0188448252234   , 0.0121142190231   , 0.008640234989    ,
 0.00696131748759  , 0.00560311432398  , 0.00414151523471  , 0.00320158423225  ,
 0.00410458029251  , 0.00852256642244  , 0.0176087364932   , 0.0302499311938   ,
 0.0421220879843   , 0.048084926659    , 0.0469927099459   , 0.0440657271523   ,
 0.0479244843229   , 0.0649625185573   , 0.0954279890459   , 0.132638005094    ,
 0.16497541891     , 0.181294413066    , 0.223311689786    , 0.176156152461    ,
 0.12772175768     , 0.0910296609923   , 0.068815837648    , 0.0577745181606   ,
 0.0539918280025   , 0.0569821852318   , 0.0691374326843   , 0.0895693263667   ,
 0.11024433184     , 0.122019969354    , 0.124317595143    , 0.126410029697    ,
 0.141248067364    , 0.18193361747     , 0.261920494917    , 0.392734676718    ,
 0.580116887308    , 0.824393030044    , 1.12801907704     , 1.51495714811     ,
 2.05618244816     , 2.86192396054     , 4.01445095545     , 5.50468842591     ,
 7.25829541769     , 9.21694697451     , 11.3668573067     , 13.7011693133     ,
 16.1889302263     , 18.7702614881     , 21.3433371616     , 23.7587541531     ,
 25.8745172012     , 27.65075728       , 29.1756677903     , 30.5725799247     ,
 31.9099438359     , 33.2554712711     , 34.7843493358     , 36.7212138723     ,
 39.1372820057     , 41.8736000028     , 44.6776865738     , 47.3159418665     ,
 49.5051605965     , 50.8431745826     , 50.9711324205     , 49.8902901301     ,
 48.0864218364     , 46.259119784      , 44.8841498196     , 44.0081872616     ,
 43.3893186591     , 42.7665340899     , 42.0235274185     , 41.1887620771     ,
 40.3393332509     , 39.5085796936     , 38.6658910726     , 37.7612936097     ,
 36.786383707      , 35.8136093821     , 34.9851646112     , 34.4610666382     ,
 34.3909264092     , 34.9242607058     , 36.1851330838     , 38.2123731925     ,
 40.9926462843     , 44.5810671602     , 49.0457150954     , 54.1095246339     ,
 58.8731935323     , 62.0835218875     , 62.7779872851     , 60.6901489558     ,
 56.1639678452     , 49.8596912085     , 42.5538360245     , 35.0449566989     ,
 28.0325039876     , 21.9443082209     , 16.8524260929     , 12.591838513      ,
 8.99368884929     , 6.02493463433     , 3.73894278685     , 2.14312207671     ,
 1.13969669814     , 0.569020446855    , 0.276575790616    , 0.144568171893    ,
 0.0931052399969   , 0.0742661374129   , 0.0654727763688   , 0.0593312314866   ,
 0.0530998280184   , 0.0442982691519   , 0.032305351451    , 0.0196401063884   ,
 0.00967974439892  , 0.0038111822319   , 0.00119165750318  , 0.000297038760718 ,
 6.05552446266e-05 , 1.09212069266e-05 , 2.02271555378e-06 , 4.21363917618e-07 ,
 8.90940113077e-08 , 1.84168965146e-08 , 3.02607542793e-08 , 3.05748675223e-07 ,
 2.62931352609e-06 , 1.77464092193e-05 , 9.40451605719e-05 , 0.000391870891829 ,
 0.00128581301431  , 0.00332712050077  , 0.0067978835863   , 0.0109781891772   ,
 0.0140219694194   , 0.0141670436046   , 0.0113189085174   , 0.00714590206389  ,
 0.0035608593282   , 0.00139865719806  , 0.000432401627842 , 0.000105060077284 ,
 2.00333205375e-05 , 2.99537526288e-06 , 3.54944906924e-07 , 4.43266058522e-08 ,
 2.81388017123e-08 , 4.40469971091e-08 , 6.86110546101e-08 , 1.8911604745e-07  ,
 1.20387404538e-06 , 8.18827482287e-06 , 4.55686923369e-05 , 0.000201201801562 ,
 0.000703057847756 , 0.00194383132479  , 0.00425095160996  , 0.00734857409573  ,
 0.0100341369771   , 0.0108155763754   , 0.0092059959319   , 0.00623177178099  ,
 0.00357081046727  , 0.00255529100394  , 0.00414848142797  , 0.00918556036943  ,
 0.0175454873743   , 0.0267762396476   , 0.0326826066255   , 0.03262056353     ,
 0.0279873761221   , 0.0226329689431   , 0.0192201713871   , 0.0176465832376   ,
 0.016225782213    , 0.013624736068    , 0.00996452232058  , 0.00666502551738  ,
 0.0056276501193   , 0.00864079250324  , 0.0168292320803   , 0.0294282121327   ,
 0.042865742931    , 0.0525206834791   , 0.0571305124851   , 0.0618535639437   ,
 0.0760798303592   , 0.106909131991    , 0.153259828047    , 0.204202529243    ,
 0.241846655889    , 0.249522157225    , 0.266106799546    , 0.195260635132    ,
 0.129965246654    , 0.0904734320558   , 0.0776351741766   , 0.0792650448612   ,
 0.0824226722879   , 0.0828979958025   , 0.0851793633518   , 0.093181945399    ,
 0.103260133467    , 0.10862389257     , 0.108061535513    , 0.107042619209    ,
 0.113113047342    , 0.134899849761    , 0.183435811575    , 0.268045518247    ,
 0.389047665877    , 0.537861427576    , 0.709434268707    , 0.922383556229    ,
 1.23205584742     , 1.711374202       , 2.39708484402     , 3.25611589591     ,
 4.22428001248     , 5.27700424608     , 6.44788284935     , 7.78761572174     ,
 9.32081565122     , 11.0243709466     , 12.8152286559     , 14.563644972      ,
 16.1571938149     , 17.5763927288     , 18.8996200151     , 20.2313810978     ,
 21.6607638332     , 23.3196230422     , 25.4336592872     , 28.2181204376     ,
 31.6928912335     , 35.6576120511     , 39.8507915552     , 44.0230435872     ,
 47.801600614      , 50.6115727645     , 51.9255749886     , 51.6857281783     ,
 50.4422734094     , 49.0022003114     , 47.9062607445     , 47.2071457693     ,
 46.6579026327     , 46.0237398668     , 45.2199103642     , 44.2513940822     ,
 43.119250166      , 41.8090757435     , 40.3283794112     , 38.7184629295     ,
 37.0606062047     , 35.5146893555     , 34.3123096572     , 33.6445619332     ,
 33.56925267       , 34.0638804752     , 35.1329594961     , 36.8237073296     ,
 39.1880847464     , 42.2825801732     , 46.1101535435     , 50.3964482542     ,
 54.413445349      , 57.1626241818     , 57.8233970561     , 56.0736360297     ,
 52.1031728726     , 46.4435917494     , 39.7828425577     , 32.840103212      ,
 26.2684882576     , 20.5231580479     , 15.7480979089     , 11.8173539392     ,
 8.5349338885      , 5.81383054539     , 3.68139246556     , 2.15990863086     ,
 1.18187824546     , 0.609976484347    , 0.302923871573    , 0.153954517277    ,
 0.091657686456    , 0.0696867918671   , 0.0607237658463   , 0.0525260491343   ,
 0.0423176260125   , 0.0310525303286   , 0.0202937862703   , 0.0114539077962   ,
 0.00542133216556  , 0.00211782998294  , 0.000691755181039 , 0.000203151695794 ,
 6.20005488024e-05 , 2.13305542979e-05 , 7.4097088007e-06  , 2.24571927253e-06 ,
 5.51672351243e-07 , 1.07884820523e-07 , 2.88070689956e-08 , 1.39944023167e-07 ,
 1.18822836263e-06 , 8.01880752085e-06 , 4.24947530705e-05 , 0.000177068732452 ,
 0.000581000749502 , 0.00150337528422  , 0.00307165615643  , 0.00496054719746  ,
 0.0063358938331   , 0.00640144629637  , 0.00511450285819  , 0.00322890996735  ,
 0.00160899129097  , 0.000631989948121 , 0.000195382865008 , 4.74727232232e-05 ,
 9.05648346049e-06 , 1.3715156975e-06  , 2.20054923544e-07 , 1.76847393152e-07 ,
 3.40284396558e-07 , 5.6381437131e-07  , 7.48444351612e-07 , 8.32462484604e-07 ,
 1.11720743303e-06 , 3.73202441548e-06 , 1.86679232991e-05 , 8.15365337961e-05 ,
 0.000284543126821 , 0.000786283556044 , 0.00171829001051  , 0.00296708791965  ,
 0.00404434627345  , 0.00434760878433  , 0.00368744152475  , 0.00249732535001  ,
 0.0015028603605   , 0.00136830739886  , 0.00274418643605  , 0.0063058068837   ,
 0.0121366119932   , 0.0188941743776   , 0.0242776155431   , 0.0270309433595   ,
 0.0281216283289   , 0.0293634935724   , 0.0312663856098   , 0.0325651469729   ,
 0.0313744742314   , 0.0267528170775   , 0.0196961520599   , 0.0127182670853   ,
 0.00840848953923  , 0.00853709154322  , 0.0140411710523   , 0.0247070518066   ,
 0.0384522708039   , 0.0520383963668   , 0.0643065741116   , 0.079538578779    ,
 0.106386048873    , 0.151242703095    , 0.211262775179    , 0.272380207761    ,
 0.312676762948    , 0.31185448763     , 0.283435448605    , 0.202415043563    ,
 0.132335187258    , 0.0973688198039   , 0.0967718966511   , 0.111418250258    ,
 0.12057199385     , 0.116356907665    , 0.105251277512    , 0.0965925596217   ,
 0.0923278410668   , 0.0889847280413   , 0.085021863604    , 0.0822212582135   ,
 0.0831973446935   , 0.0926457306735   , 0.119277072643    , 0.170608668294    ,
 0.244094442284    , 0.327218572617    , 0.411626132499    , 0.511303224411    ,
 0.666995630128    , 0.923916199476    , 1.2934843474      , 1.73968598788     ,
 2.21614181861     , 2.71770269052     , 3.28913321785     , 3.98949898967     ,
 4.85520659756     , 5.88151402265     , 7.01511617759     , 8.16737009119     ,
 9.26346773014     , 10.2962291294     , 11.3289981974     , 12.4549772351     ,
 13.7853407629     , 15.490508954      , 17.8081132157     , 20.9329673195     ,
 24.8708099049     , 29.4391258986     , 34.4065115637     , 39.5280794418     ,
 44.3934100272     , 48.3640716039     , 50.8526011191     , 51.7534835244     ,
 51.5636681555     , 51.0203372858     , 50.5984028687     , 50.3217846889     ,
 49.9695728631     , 49.3728398211     , 48.4995293447     , 47.3431995484     ,
 45.8504146515     , 43.9963117337     , 41.867502296      , 39.6177669319     ,
 37.4019210405     , 35.4168578989     , 33.9230129323     , 33.1045855605     ,
 32.9342885212     , 33.2627384509     , 34.0261149203     , 35.3105607063     ,
 37.2480958245     , 39.9094341224     , 43.2293339412     , 46.8934467741     ,
 50.2774611264     , 52.5943138341     , 53.1761009511     , 51.6914609409     ,
 48.221380156      , 43.1951269641     , 37.2174069679     , 30.9056141365     ,
 24.8163919868     , 19.3852968215     , 14.8281365206     , 11.1103154328     ,
 8.06864982123     , 5.58281539169     , 3.63159099608     , 2.2166161374      ,
 1.27935870716     , 0.703329983076    , 0.369633700346    , 0.19163727133     ,
 0.110519390551    , 0.0813111739685   , 0.0701971072543   , 0.0585773549502   ,
 0.0427504475762   , 0.0267411966146   , 0.0144935408692   , 0.00692914103267  ,
 0.00299592486042  , 0.00125353980456  , 0.000582441650225 , 0.00032019841651  ,
 0.000181053943993 , 8.96660989788e-05 , 3.60401081735e-05 , 1.145285809e-05   ,
 2.85339483774e-06 , 5.56041710173e-07 , 8.89868234703e-08 , 5.92892605295e-08 ,
 4.24984650637e-07 , 2.86225767626e-06 , 1.51678807323e-05 , 6.3202080662e-05  ,
 0.00020737967485  , 0.00053660770299  , 0.00109638250129  , 0.00177059438529  ,
 0.00226150414462  , 0.00228490213255  , 0.00182554659478  , 0.00115251193809  ,
 0.000574305798964 , 0.000225579679692 , 6.97403714418e-05 , 1.69534573997e-05 ,
 3.27838519678e-06 , 6.79424369569e-07 , 7.03380067976e-07 , 1.69633224875e-06 ,
 3.51421007542e-06 , 5.80474864458e-06 , 7.62623965868e-06 , 7.98009948681e-06 ,
 6.75980931873e-06 , 5.40967508463e-06 , 8.1366085632e-06  , 2.67838713483e-05 ,
 9.05430159746e-05 , 0.000249384055494 , 0.000544652619839 , 0.000939999194544 ,
 0.00128040099665  , 0.00137577255435  , 0.00117110255504  , 0.000822165574654 ,
 0.000613616723806 , 0.00088348547892  , 0.00205334277802  , 0.00456769971547  ,
 0.00855110435671  , 0.0135338911927   , 0.018897872176    , 0.0247254812591   ,
 0.0316532373209   , 0.0395305102754   , 0.0466745732346   , 0.0506435331575   ,
 0.0494913317798   , 0.0428401818717   , 0.0325304607577   , 0.0218967339155   ,
 0.0139449959446   , 0.0104001137212   , 0.0121694555276   , 0.0197069741866   ,
 0.0324931083839   , 0.0489330252208   , 0.0683082337524   , 0.0936494956041   ,
 0.131211323263    , 0.184704113178    , 0.249329692371    , 0.310631746987    ,
 0.347306069868    , 0.339338063218    , 0.258329838386    , 0.183937602162    ,
 0.124260883905    , 0.10249940936     , 0.116427623759    , 0.143205013307    ,
 0.157248499475    , 0.147956550832    , 0.123349836484    , 0.097828730359    ,
 0.0791174674204   , 0.0671704161907   , 0.0600510086226   , 0.056416550691    ,
 0.055271398866    , 0.0582578238682   , 0.0714336971637   , 0.100401046908    ,
 0.142303252729    , 0.185753450201    , 0.222820413883    , 0.262937972588    ,
 0.333237793399    , 0.459597007709    , 0.642048922816    , 0.851484930838    ,
 1.05827023095     , 1.26537031371     , 1.51074839684     , 1.84132370965     ,
 2.28797357055     , 2.85433213385     , 3.51229964337     , 4.20960761924     ,
 4.90168466992     , 5.58783539128     , 6.31630594985     , 7.16766166732     ,
 8.25974120022     , 9.77436046167     , 11.9423181985     , 14.9426696644     ,
 18.7899128343     , 23.3439983842     , 28.4236814795     , 33.8259486521     ,
 39.1935846027     , 43.966633302      , 47.6178611547     , 49.9989841642     ,
 51.4191645509     , 52.3472181562     , 53.0413632425     , 53.4534626569     ,
 53.4262693857     , 52.9068688809     , 51.9412832757     , 50.5253311613     ,
 48.5761249492     , 46.0961301387     , 43.2898967066     , 40.451921452      ,
 37.8094213686     , 35.5452067228     , 33.8627468996     , 32.8822193967     ,
 32.5160626147     , 32.5728468717     , 32.9861777588     , 33.8793684815     ,
 35.4290075339     , 37.7150474289     , 40.635896754      , 43.8473506327     ,
 46.7748859337     , 48.7593054506     , 49.2460350657     , 47.926920415      ,
 44.8364553072     , 40.3439604566     , 34.9847790742     , 29.2721410836     ,
 23.6491082542     , 18.502425209      , 14.0997777136     , 10.5076352932     ,
 7.62731423458     , 5.33144571701     , 3.5531440498      , 2.25752696853     ,
 1.37693134389     , 0.806659985625    , 0.449753503788    , 0.242143018536    ,
 0.139587425671    , 0.100002132645    , 0.084498101981    , 0.0688718548677   ,
 0.047939624655    , 0.0274926334302   , 0.0131053392069   , 0.00553001246776  ,
 0.00251354643603  , 0.00161863032273  , 0.00134135041476  , 0.00105901132513  ,
 0.000691369527882 , 0.000358539454321 , 0.000146097613458 , 4.66123065303e-05 ,
 1.16264159227e-05 , 2.26519691862e-06 , 3.4573674433e-07  , 5.47744440067e-08 ,
 1.23452188056e-07 , 8.07990611182e-07 , 4.28042998346e-06 , 1.78357934521e-05 ,
 5.85230878428e-05 , 0.000151432100328 , 0.000309402015676 , 0.00049966637657  ,
 0.000638202397418 , 0.000644805370967 , 0.000515174034711 , 0.000325241899548 ,
 0.000162070729651 , 6.36605144656e-05 , 1.96920068652e-05 , 4.85719014214e-06 ,
 1.30475163694e-06 , 1.75949281947e-06 , 5.33665469555e-06 , 1.3851152945e-05  ,
 2.86480931491e-05 , 4.71170967312e-05 , 6.16387898489e-05 , 6.41514632635e-05 ,
 5.3143759729e-05  , 3.5233452103e-05  , 1.97736783203e-05 , 1.40506233504e-05 ,
 2.49328536556e-05 , 6.2546162071e-05  , 0.000135301074613 , 0.000233317637061 ,
 0.000318252559341 , 0.000345564945749 , 0.000314269911978 , 0.000309096928862 ,
 0.000527558189724 , 0.00130572034449  , 0.00307425056419  , 0.00612643754556  ,
 0.0103305123351   , 0.015275885732    , 0.0210168300616   , 0.028477816161    ,
 0.0384260959917   , 0.0498456831642   , 0.0598725112066   , 0.0654506718311   ,
 0.0648136355123   , 0.0580803254614   , 0.0472647823961   , 0.0353178567542   ,
 0.0247370594637   , 0.0172745588917   , 0.0145505992634   , 0.0181111103297   ,
 0.0287394556284   , 0.0462201767664   , 0.0705129742406   , 0.103267566477    ,
 0.146753873499    , 0.199935988747    , 0.256105845357    , 0.303813894061    ,
 0.32786940937     , 0.313354372667    , 0.199888041426    , 0.14321551594     ,
 0.103531475543    , 0.0990316066039   , 0.126134363071    , 0.161648060963    ,
 0.178810666178    , 0.165882185453    , 0.131671048146    , 0.0939425225704   ,
 0.064793909558    , 0.0467953856706   , 0.0375607251646   , 0.0336234255959   ,
 0.032020510661    , 0.0324543010007   , 0.0383342622878   , 0.0531830962103   ,
 0.0750304127106   , 0.096214385798    , 0.111309650233    , 0.125993272512    ,
 0.156239526626    , 0.215391511145    , 0.299833399617    , 0.389589108198    ,
 0.467390361307    , 0.537914190873    , 0.62735018356     , 0.766900766911    ,
 0.978429647141    , 1.26833932229     , 1.62378592885     , 2.0158214251      ,
 2.41931675208     , 2.83644041744     , 3.30161135761     , 3.87802442263     ,
 4.67187831917     , 5.85348354409     , 7.63585778406     , 10.1861088196     ,
 13.5344327305     , 17.5875608092     , 22.2284989025     , 27.3413911553     ,
 32.7082774123     , 37.9550366058     , 42.696236258      , 46.7492202634     ,
 50.1590149969     , 53.000511038      , 55.1994794821     , 56.5736724718     ,
 57.023480742      , 56.6339137255     , 55.5585584617     , 53.8317610368     ,
 51.3781556759     , 48.2473455322     , 44.7633284276     , 41.3655274159     ,
 38.3622126769     , 35.9036789567     , 34.0826444737     , 32.9176774371     ,
 32.2915476343     , 32.0471137172     , 32.160314153      , 32.7629024218     ,
 34.0132494996     , 35.977315434      , 38.5576216878     , 41.4315000361     ,
 44.0659250589     , 45.8576730869     , 46.3003892923     , 45.1069127494     ,
 42.3024468835     , 38.2207923227     , 33.3368093937     , 28.0824783436     ,
 22.8206486894     , 17.8977061061     , 13.6057520095     , 10.0797708281     ,
 7.28094493046     , 5.09730357865     , 3.43968575728     , 2.24249695471     ,
 1.42048804392     , 0.869358033821    , 0.504892221388    , 0.279156356827    ,
 0.159916755414    , 0.109836644546    , 0.0891234811364   , 0.0709002343073   ,
 0.0483480476948   , 0.0270072441566   , 0.0126138016703   , 0.00580406643389  ,
 0.00389848752994  , 0.00392609028351  , 0.00396500568138  , 0.00331576453343  ,
 0.00219826050575  , 0.00114477129711  , 0.000467011871061 , 0.000149048380942 ,
 3.71802878572e-05 , 7.2438347133e-06  , 1.10191239739e-06 , 1.33814305526e-07 ,
 3.88084027314e-08 , 1.81171040376e-07 , 9.55521069826e-07 , 3.98129879331e-06 ,
 1.30634941333e-05 , 3.38025968367e-05 , 6.90645614314e-05 , 0.000111535275827 ,
 0.00014245921633  , 0.00014393312892  , 0.000114996891241 , 7.26003956712e-05 ,
 3.61781821494e-05 , 1.42190028918e-05 , 4.46795259804e-06 , 1.55842979828e-06 ,
 2.75520211488e-06 , 1.05414910762e-05 , 3.43508924972e-05 , 8.91082641488e-05 ,
 0.000183685803345 , 0.00030108344029  , 0.000392636593358 , 0.000407512914461 ,
 0.000336691879403 , 0.000221522045918 , 0.00011632031994  , 4.97224859652e-05 ,
 2.05376819025e-05 , 1.63606629987e-05 , 2.72296718923e-05 , 4.5842062793e-05  ,
 6.44137716409e-05 , 8.19791506202e-05 , 0.000133316332389 , 0.000355627737645 ,
 0.00110561727281  , 0.00304885463831  , 0.00696454718299  , 0.0130847613811   ,
 0.0204662627544   , 0.0274514943541   , 0.0333008202088   , 0.0391917496028   ,
 0.0469356864676   , 0.0566262170982   , 0.0660634809418   , 0.072446831732    ,
 0.0741736115575   , 0.0712966653659   , 0.0647830731653   , 0.0554359745058   ,
 0.044000750257    , 0.0325532172001   , 0.0247932778062   , 0.0242310870942   ,
 0.0325118557005   , 0.0498459439979   , 0.0765436721577   , 0.112977834149    ,
 0.156999127512    , 0.202060388673    , 0.239820628974    , 0.263882723326    ,
 0.268494686021    , 0.247073384679    , 0.139112634284    , 0.0998181894823   ,
 0.0783735019045   , 0.0867758041091   , 0.120454266528    , 0.158346841337    ,
 0.17575119812     , 0.161527388013    , 0.124363743238    , 0.0826521679396   ,
 0.0500730001473   , 0.0303293830639   , 0.0207526130891   , 0.0170073545224   ,
 0.0156062162176   , 0.0153825091883   , 0.0177392978431   , 0.0244378225989   ,
 0.0344651912631   , 0.0438427807232   , 0.0498092783891   , 0.0554814685121   ,
 0.0691028248066   , 0.0966756474675   , 0.134411445854    , 0.170107699978    ,
 0.19447882919     , 0.211413013642    , 0.236747791901    , 0.288969748273    ,
 0.38198776914     , 0.521776638686    , 0.703033296993    , 0.910267871028    ,
 1.12995670697     , 1.36446759835     , 1.63533716991     , 1.98609405575     ,
 2.50062425718     , 3.32300728256     , 4.63898981747     , 6.60168438281     ,
 9.2564449339      , 12.5556783299     , 16.4525131934     , 20.9374893097     ,
 25.9601942618     , 31.3630290021     , 36.9367030192     , 42.5037241452     ,
 47.8782428417     , 52.7461119899     , 56.6627958292     , 59.2412297409     ,
 60.3674745097     , 60.225638655      , 59.0887378767     , 57.0797219122     ,
 54.1778414148     , 50.4830233563     , 46.3993675121     , 42.4749927714     ,
 39.1008862774     , 36.4190844709     , 34.4274464664     , 33.0513174224     ,
 32.1632164086     , 31.6657916163     , 31.5816929415     , 32.0205928764     ,
 33.0756211323     , 34.7723610414     , 37.0370495077     , 39.617874088      ,
 42.0502929523     , 43.7613615533     , 44.2460515178     , 43.2163237375     ,
 40.6863734373     , 36.9423838573     , 32.3882577389     , 27.4055838002     ,
 22.3431002355     , 17.5505697541     , 13.3291540301     , 9.83486358802     ,
 7.06060482299     , 4.9181140085      , 3.31853787811     , 2.17928505521     ,
 1.39942895868     , 0.870667962257    , 0.513107591592    , 0.284794962756    ,
 0.158673956273    , 0.101789492076    , 0.0774131964579   , 0.0595144933163   ,
 0.0399962690146   , 0.0224035409157   , 0.0112763388367   , 0.00716032440336  ,
 0.00758212372134  , 0.00931319216931  , 0.00984500491877  , 0.00830919248188  ,
 0.0055195103821   , 0.002875637795    , 0.0011732521234   , 0.000374458116343 ,
 9.34097339829e-05 , 1.81990099258e-05 , 2.76773318154e-06 , 3.28940324966e-07 ,
 3.51052149631e-08 , 3.40264064638e-08 , 1.68823584767e-07 , 7.02952074196e-07 ,
 2.30652001226e-06 , 5.96826236026e-06 , 1.21941939579e-05 , 1.96929186033e-05 ,
 2.51529189706e-05 , 2.54131571787e-05 , 2.030412867e-05   , 1.28188128281e-05 ,
 6.39197214566e-06 , 2.55513508639e-06 , 1.15764288139e-06 , 2.69009076555e-06 ,
 1.30131371064e-05 , 5.33562378033e-05 , 0.000173949136497 , 0.000450194594238 ,
 0.000925722085436 , 0.00151368185784  , 0.00196957115173  , 0.00204045742316  ,
 0.00168380152416  , 0.00110735014159  , 0.000580965931851 , 0.000243821321449 ,
 8.27392630752e-05 , 2.42940575951e-05 , 9.30835373506e-06 , 9.53447534566e-06 ,
 1.92649703957e-05 , 5.84866319624e-05 , 0.000216978803266 , 0.000782182296668 ,
 0.00247245857455  , 0.00659622803364  , 0.0146039425559   , 0.0266738781783   ,
 0.0403404255923   , 0.05127981022     , 0.056555211749    , 0.0572339944436   ,
 0.0573493067551   , 0.060285686393    , 0.0663941450298   , 0.0737267675254   ,
 0.0802967008836   , 0.0851234613693   , 0.0870064518173   , 0.0833886457226   ,
 0.0726460312719   , 0.0578965626735   , 0.0464267248135   , 0.0443172306048   ,
 0.0527588534336   , 0.0701010806965   , 0.095818271092    , 0.130034243021    ,
 0.168658014351    , 0.201814679574    , 0.220082789574    , 0.220999859416    ,
 0.206746625277    , 0.17852404718     , 0.103407011081    , 0.0723090541198   ,
 0.0585942462095   , 0.0696237661759   , 0.10043360735     , 0.133358025577    ,
 0.147860247408    , 0.134698263693    , 0.10147792794     , 0.0643341947057   ,
 0.0355084534571   , 0.0183594105516   , 0.0102913739      , 0.00726418007311  ,
 0.00625119900462  , 0.00600668013657  , 0.00684142548477  , 0.00942355483022  ,
 0.0133433844627   , 0.0169941649587   , 0.0193588044404   , 0.0220246164578   ,
 0.0287226777715   , 0.041728907071    , 0.0582837521676   , 0.0716796236663   ,
 0.0773308947453   , 0.0778026762407   , 0.0816914960661   , 0.0988585899244   ,
 0.13719565357     , 0.200917715713    , 0.288264253552    , 0.391856352589    ,
 0.505155172354    , 0.629249293402    , 0.774812018526    , 0.967941386539    ,
 1.26856148971     , 1.78856418269     , 2.67976165791     , 4.07750911993     ,
 6.04168215427     , 8.56948813756     , 11.6764483022     , 15.4361220755     ,
 19.9247510138     , 25.1620852416     , 31.1156112851     , 37.681915222      ,
 44.5689566411     , 51.1967713178     , 56.8032206086     , 60.7491779214     ,
 62.7972028836     , 63.134725503      , 62.1211146507     , 59.9900933508     ,
 56.8093961974     , 52.7313511068     , 48.1978490682     , 43.8117439903     ,
 40.0322388271     , 37.035764643      , 34.7933017754     , 33.184270295      ,
 32.0769388449     , 31.4101702068     , 31.2254328081     , 31.5933428262     ,
 32.5314616972     , 34.013370215      , 35.9842826205     , 38.2782170897     ,
 40.5248245317     , 42.1945149615     , 42.777055345      , 41.9669672518     ,
 39.7426961852     , 36.309067252      , 31.9783585469     , 27.1055597925     ,
 22.0881805195     , 17.3325904774     , 13.152304791      , 9.68858248292     ,
 6.93212916815     , 4.8082981646      , 3.23426108909     , 2.1191910046      ,
 1.35489462788     , 0.835460757257    , 0.485596721893    , 0.263094140928    ,
 0.138650969586    , 0.0802709699428   , 0.0551612994184   , 0.0401482953842   ,
 0.0265548170368   , 0.0154137590647   , 0.00960401775924  , 0.00970921178594  ,
 0.013741412663    , 0.018127231859    , 0.0194078941415   , 0.0164160710708   ,
 0.0109088510748   , 0.00568387220288  , 0.00231903826729  , 0.000740152551008 ,
 0.000184633485018 , 3.5972125728e-05  , 5.47060544412e-06 , 6.49176416027e-07 ,
 6.07247580144e-08 , 8.7774324111e-09  , 2.37925797077e-08 , 9.81349302927e-08 ,
 3.21967212629e-07 , 8.33109092196e-07 , 1.70218618699e-06 , 2.7489323353e-06  ,
 3.51109331908e-06 , 3.5474235125e-06  , 2.83432893676e-06 , 1.79067147239e-06 ,
 9.09315632796e-07 , 5.34722329367e-07 , 1.63293922744e-06 , 1.00023960683e-05 ,
 5.16997427435e-05 , 0.000212252643927 , 0.000691041699322 , 0.0017856952813   ,
 0.00366602047798  , 0.00598529580825  , 0.00777768257367  , 0.00805020562738  ,
 0.0066415077451   , 0.00437177919345  , 0.00230037588207  , 0.000971518813861 ,
 0.000332278618353 , 9.39861727174e-05 , 2.39233030728e-05 , 1.1643133661e-05  ,
 3.38105950656e-05 , 0.000142083841173 , 0.00053203268563  , 0.00173658917447  ,
 0.00494990295563  , 0.0122139813336   , 0.0256841033991   , 0.0453991857594   ,
 0.0670426880171   , 0.0830088402172   , 0.0875095626948   , 0.0813015976206   ,
 0.0712397419668   , 0.0651685157693   , 0.0669313418597   , 0.07548443364     ,
 0.0877777426546   , 0.101108186619    , 0.111885615811    , 0.114480000891    ,
 0.105665349597    , 0.0907271911639   , 0.0813045884038   , 0.0851751858263   ,
 0.0999596938806   , 0.118238938586    , 0.136978076079    , 0.158734881183    ,
 0.183482379984    , 0.203405001993    , 0.208909267651    , 0.197365972848    ,
 0.172786887122    , 0.139866454511    , 0.0973429335652   , 0.0647376781624   ,
 0.0478467748233   , 0.0520279370035   , 0.0725750276136   , 0.0955113293474   ,
 0.105244283055    , 0.0949007347135   , 0.0701789661512   , 0.0430042447256   ,
 0.0222731131004   , 0.0102137132464   , 0.00468555718281  , 0.00266698129482  ,
 0.00204408693141  , 0.00189574432138  , 0.00214905339765  , 0.00298095891088  ,
 0.00425847228335  , 0.00548243214586  , 0.0064138447109   , 0.00779276445708  ,
 0.0111059891778   , 0.0170572971727   , 0.0240515744142   , 0.0288232254948   ,
 0.0293316053861   , 0.0269937064445   , 0.025950406657    , 0.0308488067281   ,
 0.0455677340482   , 0.072539369858    , 0.11162211953     , 0.160181123114    ,
 0.215653755123    , 0.27788025794     , 0.35047275139     , 0.447364294624    ,
 0.60822754317     , 0.913410286116    , 1.47867186741     , 2.41865102641     ,
 3.80588682925     , 5.67871723613     , 8.09813937123     , 11.1773503028     ,
 15.0505594391     , 19.8464933066     , 25.6842082547     , 32.5903425255     ,
 40.3077133022     , 48.1669112771     , 55.2142653505     , 60.5723196248     ,
 63.7940682776     , 64.9535313624     , 64.4085578933     , 62.4618241391     ,
 59.2637755279     , 55.0246255913     , 50.2110421243     , 45.4463265134     ,
 41.2406534885     , 37.8408316625     , 35.2643953693     , 33.4011508048     ,
 32.1183119345     , 31.3537535873     , 31.130407864      , 31.4702766211     ,
 32.3283460295     , 33.6356963136     , 35.346638174      , 37.3630609165     ,
 39.4062913478     , 41.008670701      , 41.6734717927     , 41.074678912      ,
 39.1339037645     , 35.9575357151     , 31.7672234123     , 26.9090551554     ,
 21.8555577516     , 17.0924047214     , 12.9515415955     , 9.54622072872     ,
 6.84288115708     , 4.76196124026     , 3.21761232722     , 2.11214213017     ,
 1.33950006315     , 0.807741913136    , 0.453312919874    , 0.233863809083    ,
 0.113578628494    , 0.057099802793    , 0.0334422434143   , 0.0220670428856   ,
 0.0142878454702   , 0.00923910230161  , 0.0085223511175   , 0.0128932398625   ,
 0.0207883373926   , 0.0280974143541   , 0.0302025333344   , 0.0255631792441   ,
 0.0169891195276   , 0.00885205243639  , 0.00361167747946  , 0.00115271658135  ,
 0.000287548970732 , 5.60231414737e-05 , 8.51993425359e-06 , 1.01091944735e-06 ,
 9.3620244416e-08  , 7.23935671035e-09 , 2.97609436908e-09 , 1.08358880166e-08 ,
 3.55008680582e-08 , 9.18592312317e-08 , 1.87684293202e-07 , 3.03099300787e-07 ,
 3.87136152507e-07 , 3.91153100498e-07 , 3.12758431204e-07 , 2.01486244732e-07 ,
 1.53565165776e-07 , 6.15162196111e-07 , 4.77507775073e-06 , 3.11561574767e-05 ,
 0.000161347241823 , 0.000662044225611 , 0.00215388424089  , 0.00556143912708  ,
 0.0114088660252   , 0.0186143174318   , 0.0241786337833   , 0.0250271363017   ,
 0.0206665546731   , 0.0136385410694   , 0.00721809926541  , 0.00308633302088  ,
 0.00108287006008  , 0.000321725015402 , 8.77412382341e-05 , 3.90319706398e-05 ,
 9.56280434259e-05 , 0.000375333188461 , 0.00127816188331  , 0.00368558651183  ,
 0.00919469286632  , 0.0201595913198   , 0.0388598025042   , 0.0651000107917   ,
 0.0935466919755   , 0.114530867211    , 0.119854335228    , 0.109200284843    ,
 0.0910660883875   , 0.0770610101228   , 0.074367413225    , 0.0828575979864   ,
 0.0984714458757   , 0.117053254526    , 0.133431042845    , 0.140425455463    ,
 0.135002599916    , 0.125683923417    , 0.127888803011    , 0.148433619394    ,
 0.177047809726    , 0.196441548731    , 0.200020934503    , 0.196474907932    ,
 0.196888079066    , 0.201686058109    , 0.202337749405    , 0.191636582315    ,
 0.168337140092    , 0.135042703002    , 0.105379283348    , 0.0678512164763   ,
 0.0433479711386   , 0.0371987848435   , 0.0454975358271   , 0.0576758504119   ,
 0.0627292000978   , 0.0558809017014   , 0.0405912623037   , 0.0241896668502   ,
 0.0119699792362   , 0.00505119016591  , 0.00196818310392  , 0.000872070186454 ,
 0.000551899989755 , 0.00048022351247  , 0.000543879576854 , 0.000766727673499 ,
 0.0011148469854   , 0.00147316160686  , 0.00182705039893  , 0.0024765425166   ,
 0.00393974005745  , 0.00638913576491  , 0.00908634263844  , 0.0106680619005   ,
 0.0103394997722   , 0.00874708043049  , 0.00760746172664  , 0.0087993395308   ,
 0.0139356973264   , 0.0241996324623   , 0.0399730929564   , 0.0608086879537   ,
 0.0860068554164   , 0.114958016319    , 0.14820935156     , 0.192901380532    ,
 0.273767715881    , 0.444151054779    , 0.785881866333    , 1.39061885884     ,
 2.3370239703      , 3.69466991577     , 5.55356673443     , 8.0360998166      ,
 11.2857607044     , 15.4801844268     , 20.8425410202     , 27.5341640758     ,
 35.4205420265     , 43.9003454884     , 51.9900518777     , 58.6627469106     ,
 63.2441340083     , 65.5961201107     , 65.951772139      , 64.5861681639     ,
 61.6869613115     , 57.5170297929     , 52.5715263226     , 47.4900417256     ,
 42.8373167967     , 38.9632979444     , 35.9851247793     , 33.842817834      ,
 32.4066719983     , 31.5881038967     , 31.3608302713     , 31.6872243776     ,
 32.4762580821     , 33.6408334023     , 35.1435162018     , 36.9203454933     ,
 38.7506660325     , 40.2279227577     , 40.8890802782     , 40.3971658716     ,
 38.6195941416     , 35.5877425033     , 31.4708477583     , 26.6196277517     ,
 21.5564981236     , 16.8137071894     , 12.732514384      , 9.40770339494     ,
 6.78547520634     , 4.77158702921     , 3.26609503698     , 2.16349567432     ,
 1.36708709339     , 0.806779833672    , 0.435579304733    , 0.212623957738    ,
 0.0947059448147   , 0.0407197011258   , 0.019027972261    , 0.0104582484684   ,
 0.00652857262194  , 0.00537064142834  , 0.00787666332543  , 0.0149491646664   ,
 0.0253009566763   , 0.0344739376476   , 0.0371045849962   , 0.0314114765769   ,
 0.0208765499252   , 0.01087762738     , 0.00443812520172  , 0.00141648896292  ,
 0.00035334787471  , 6.88427366026e-05 , 1.04695225269e-05 , 1.24223526373e-06 ,
 1.14960175285e-07 , 8.33645545061e-09 , 6.92305538698e-10 , 9.61593661185e-10 ,
 3.08881452996e-09 , 7.9907100975e-09  , 1.6326368257e-08  , 2.63661726357e-08 ,
 3.36774462966e-08 , 3.40541281774e-08 , 2.78009138157e-08 , 2.74176390319e-08 ,
 1.43708554035e-07 , 1.41391572084e-06 , 1.16555369627e-05 , 7.62293640374e-05 ,
 0.000394794559896 , 0.00161984855198  , 0.00526961675262  , 0.0136057171165   ,
 0.0279117461788   , 0.0455485436783   , 0.0591949938437   , 0.0613434360406   ,
 0.0507787352411   , 0.0336800579897   , 0.0180129332844   , 0.00787145172261  ,
 0.00288579470173  , 0.000930762075895 , 0.000287479278332 , 0.000126208891455 ,
 0.0002382717274   , 0.000862140071526 , 0.0027626297411   , 0.00730636713422  ,
 0.0162440400625   , 0.0312887923297   , 0.0536659894614   , 0.083012498968    ,
 0.115248512621    , 0.141695276949    , 0.152656729826    , 0.144478209599    ,
 0.123957420585    , 0.104516727263    , 0.09652322015     , 0.101588991659    ,
 0.11579612747     , 0.134608496977    , 0.152236738636    , 0.16120424133     ,
 0.160005796353    , 0.160656158027    , 0.180759608205    , 0.223369575349    ,
 0.267799688135    , 0.28582414832     , 0.268015218306    , 0.231401790864    ,
 0.201247435166    , 0.189063823244    , 0.188541562896    , 0.1864376478      ,
 0.172688982573    , 0.144090633393    , 0.108819199545    , 0.0698541199276   ,
 0.0404542244881   , 0.0265441709716   , 0.0254017540586   , 0.0293940025119   ,
 0.0311199210961   , 0.0273032072992   , 0.0194796054449   , 0.0113196511106   ,
 0.00540060554866  , 0.00214900917237  , 0.00074598763735  , 0.000262376312894 ,
 0.000127232363038 , 9.94495462471e-05 , 0.000116395557315 , 0.000178579110226 ,
 0.000285632820548 , 0.000420806893649 , 0.000587006652745 , 0.000863529399059 ,
 0.00139061988131  , 0.00220661637638  , 0.0030603740245   , 0.00349613810639  ,
 0.0032556241109   , 0.00257294629183  , 0.00203637141209  , 0.00227756849473  ,
 0.00385545851075  , 0.00725786205031  , 0.012835199329    , 0.0207543122636   ,
 0.0309435962419   , 0.0429463271808   , 0.0566983258254   , 0.076111169418    ,
 0.115835060938    , 0.208536187224    , 0.407408860575    , 0.780324663803    ,
 1.40242441304     , 2.36007337068     , 3.76049751606     , 5.72726291585     ,
 8.39820335943     , 11.9633582791     , 16.6939628694     , 22.8426216549     ,
 30.4127910852     , 38.967993994      , 47.6462413265     , 55.4069136014     ,
 61.3964268857     , 65.2052259633     , 66.8250999545     , 66.4017782145     ,
 64.1035129411     , 60.2200397626     , 55.2643855472     , 49.8993809279     ,
 44.7721651505     , 40.3746742837     , 36.9565395039     , 34.5243557361     ,
 32.9509389266     , 32.1075872699     , 31.8998289972     , 32.2218857606     ,
 32.9515364962     , 34.0100653132     , 35.3723094896     , 36.9718723445     ,
 38.5971270078     , 39.8848500146     , 40.423074421      , 39.8879365121     ,
 38.1180386136     , 35.1148007396     , 31.0451091318     , 26.2684300268     ,
 21.2988143207     , 16.6455558267     , 12.6370019072     , 9.37419220353     ,
 6.81107948371     , 4.84496106703     , 3.35830840251     , 2.24020934491     ,
 1.40864142915     , 0.815478586646    , 0.426297115604    , 0.199080183035    ,
 0.0831106336474   , 0.0316912349959   , 0.0118106017872   , 0.00491632832756  ,
 0.0028340434024   , 0.00330958092651  , 0.00682084090775  , 0.0142278151088   ,
 0.0244830164445   , 0.033448062511    , 0.0360155194291   , 0.0304915373253   ,
 0.0202653593707   , 0.0105591875264   , 0.00430820138678  , 0.00137502204616  ,
 0.000343003817303 , 6.6827404855e-05  , 1.01630331845e-05 , 1.20586887531e-06 ,
 1.11589084861e-07 , 8.05395786519e-09 , 4.68263088055e-10 , 8.43437099785e-11 ,
 2.12311287523e-10 , 5.47632844556e-10 , 1.11887375342e-09 , 1.80697689365e-09 ,
 2.31001367826e-09 , 2.38796042103e-09 , 3.0431004678e-09  , 2.08182355547e-08 ,
 2.59578401455e-07 , 2.70448795883e-06 , 2.23539178842e-05 , 0.000146277915653 ,
 0.000757935965614 , 0.00311137189024  , 0.0101273539397   , 0.0261647618866   ,
 0.0537187142481   , 0.0877546634962   , 0.114222793497    , 0.118670002314    ,
 0.0986889875811   , 0.0660560873675   , 0.0359894725677   , 0.0163294660325   ,
 0.00643391400206  , 0.00234257847431  , 0.00084709114208  , 0.000378139823713 ,
 0.000510089909618 , 0.00164281802942  , 0.00506969244166  , 0.0127956112619   ,
 0.0264795957596   , 0.0462237654804   , 0.0710770930261   , 0.100881458607    ,
 0.135599609242    , 0.170803562574    , 0.195546100473    , 0.199337164338    ,
 0.18320940546     , 0.160774915762    , 0.146267347138    , 0.144559539135    ,
 0.153461028202    , 0.169119878154    , 0.185233607799    , 0.193629484389    ,
 0.193910174395    , 0.200664528681    , 0.232193635399    , 0.287458808648    ,
 0.337972761191    , 0.348961598257    , 0.310521725724    , 0.246001815362    ,
 0.190341334184    , 0.163186747081    , 0.161024073598    , 0.167184183891    ,
 0.164685764706    , 0.144401462729    , 0.101718994475    , 0.0668975847278   ,
 0.0376912438787   , 0.0204622349759   , 0.0139855430655   , 0.0131119299842   ,
 0.0129241455804   , 0.0110419690137   , 0.00772328216952  , 0.0043819127384   ,
 0.00202473595217  , 0.000769753676209 , 0.000246839518492 , 7.30762012403e-05 ,
 2.74828380145e-05 , 2.36357104946e-05 , 4.73570540762e-05 , 0.0001194617764   ,
 0.000270380861511 , 0.000504105545641 , 0.000767133461372 , 0.000973775263078 ,
 0.00108484814016  , 0.00113526058806  , 0.00115427903769  , 0.00109984456262  ,
 0.000923832990422 , 0.000673670828736 , 0.000487743359624 , 0.000524872855691 ,
 0.000939746091063 , 0.0018996324201   , 0.00358659558996  , 0.0061683644785   ,
 0.00969145278883  , 0.0139771444752   , 0.0191239872715   , 0.0274899183881   ,
 0.047342582216    , 0.0971344508653   , 0.208520640142    , 0.427645479694    ,
 0.818317961223    , 1.46922481878     , 2.4949296165      , 4.02203203374     ,
 6.18707984232     , 9.17853638012     , 13.2721992588     , 18.7549656257     ,
 25.7367426724     , 33.977771977      , 42.8385664669     , 51.3895185218     ,
 58.6732851898     , 63.9975870587     , 67.047404828      , 67.7766763459     ,
 66.2925304162     , 62.8764127424     , 58.0329096089     , 52.4478646435     ,
 46.8739578489     , 41.9692293428     , 38.127001193      , 35.4217121257     ,
 33.7260237956     , 32.8663957451     , 32.6773005474     , 32.9910742842     ,
 33.6712170997     , 34.6637617703     , 35.9526412905     , 37.4371797839     ,
 38.872823365      , 39.9226188883     , 40.2453088783     , 39.5634143725     ,
 37.7139237948     , 34.6945601234     , 30.6935515292     , 26.0733466863     ,
 21.2911901881     , 16.7760588559     , 12.8239133918     , 9.5651347235      ,
 6.99268811545     , 5.01076930374     , 3.4899470175      , 2.3205440756      ,
 1.43891787574     , 0.81350661931     , 0.412357157074    , 0.185697733407    ,
 0.0741309229815   , 0.0263459411427   , 0.00850568424473  , 0.00272923197275  ,
 0.0013524343778   , 0.00207288684482  , 0.00502996486267  , 0.0108491578332   ,
 0.018771451679    , 0.025667208587    , 0.0276411650184   , 0.0234021258446   ,
 0.0155536307577   , 0.00810416391626  , 0.00330653975492  , 0.00105532790085  ,
 0.000263255051353 , 5.12899595178e-05 , 7.80011675695e-06 , 9.25502995971e-07 ,
 8.564419075e-08   , 6.17931945786e-09 , 3.48345765228e-10 , 1.87083226268e-11 ,
 1.19294621004e-11 , 2.95360762186e-11 , 6.03215003881e-11 , 9.75066585921e-11 ,
 1.27597059201e-10 , 2.09952833276e-10 , 1.87112361906e-09 , 2.95577595075e-08 ,
 3.89231240634e-07 , 4.06701825173e-06 , 3.36459667837e-05 , 0.000220360663448 ,
 0.00114285861597  , 0.0046963135168   , 0.0153038119691   , 0.0395904907792   ,
 0.0814097994354   , 0.133253607075    , 0.173927444016    , 0.181506982162    ,
 0.152173001273    , 0.103490034274    , 0.058225512366    , 0.0281250817795   ,
 0.0123633109202   , 0.00526994808367  , 0.00226075674905  , 0.00105925800382  ,
 0.000990907976413 , 0.00258054045927  , 0.00765165721077  , 0.0188712315552   ,
 0.0377519319912   , 0.0625755267985   , 0.0900942790878   , 0.120935697013    ,
 0.160591917859    , 0.210174544777    , 0.256985846399    , 0.281513733508    ,
 0.277032787353    , 0.256630745729    , 0.238361433915    , 0.230604716527    ,
 0.233752879265    , 0.245465061133    , 0.258469028111    , 0.262205810507    ,
 0.255479359199    , 0.253891908784    , 0.276177175482    , 0.320510833183    ,
 0.358329703357    , 0.356443101074    , 0.306423155549    , 0.231394137356    ,
 0.165752266549    , 0.130617139055    , 0.125443570355    , 0.135013264123    ,
 0.140638651859    , 0.129716818752    , 0.094890912097    , 0.066037391822    ,
 0.0386009600573   , 0.0196926298103   , 0.00994237817627  , 0.00615973577596  ,
 0.00479197570845  , 0.00375337578326  , 0.00253304118493  , 0.00139988541911  ,
 0.000627843497889 , 0.000229607160957 , 6.95396633032e-05 , 1.89438802013e-05 ,
 9.84884218762e-06 , 2.73942922731e-05 , 0.0001034042143   , 0.000322005900916 ,
 0.000791555771583 , 0.0015297443948   , 0.00232678789491  , 0.00279478225635  ,
 0.00266912014073  , 0.00205606144473  , 0.0013152306947   , 0.000735375630446 ,
 0.000383529342863 , 0.00019686613268  , 0.000111606225842 , 0.000106694969615 ,
 0.000196761598035 , 0.000423477545925 , 0.000851832405483 , 0.00155556903031  ,
 0.00257060507268  , 0.00387981760644  , 0.00570385283821  , 0.00947366393256  ,
 0.0196016456936   , 0.0457223528391   , 0.105175803008    , 0.22708182835     ,
 0.460688495405    , 0.885788569729    , 1.6133862825      , 2.7715018154      ,
 4.50132766689     , 6.98994385914     , 10.4991753344     , 15.3132688697     ,
 21.6103993532     , 29.3340281104     , 38.0959027674     , 47.1411716166     ,
 55.4773166826     , 62.1726068721     , 66.6141501561     , 68.548723431      ,
 67.9960111754     , 65.2024980834     , 60.6450822505     , 55.0180394945     ,
 49.1585564452     , 43.8644890662     , 39.6583842667     , 36.6873941873     ,
 34.8362253012     , 33.897971637      , 33.654994613      , 33.9067327785     ,
 34.5245020211     , 35.4791330529     , 36.7464633844     , 38.1689950261     ,
 39.448678005      , 40.2666478826     , 40.3654029246     , 39.5370815543     ,
 37.6278266788     , 34.6243978401     , 30.7250243728     , 26.2885500764     ,
 21.7076977573     , 17.3186810309     , 13.3772951733     , 10.0494019099     ,
 7.38324326806     , 5.30621718051     , 3.68825122108     , 2.42642971954     ,
 1.47447379681     , 0.810645838981    , 0.397441946788    , 0.172376654496    ,
 0.0659392543094   , 0.0222312894097   , 0.00661674424154  , 0.00181173557429  ,
 0.000729949461599 , 0.00117825687307  , 0.00301497970203  , 0.00657272514537  ,
 0.011392185105    , 0.0155814597118   , 0.0167804962251   , 0.0142071432983   ,
 0.00944242863953  , 0.00491994468107  , 0.002007362303    , 0.000640677449039 ,
 0.000159819118532 , 3.11375454283e-05 , 4.73536130945e-06 , 5.61862239204e-07 ,
 5.1993591524e-08  , 3.75130495353e-09 , 2.11005447086e-10 , 9.39391594379e-12 ,
 7.98942309979e-13 , 1.2585987677e-12  , 2.5570910297e-12  , 4.2365798398e-12  ,
 9.00293792809e-12 , 1.04428553205e-10 , 2.08930015644e-09 , 3.47683107277e-08 ,
 4.59237687091e-07 , 4.8041048426e-06  , 3.97900534015e-05 , 0.000260928002696 ,
 0.00135511973308  , 0.0055770921497   , 0.0182053763869   , 0.0471900837916   ,
 0.0972662770405   , 0.159692449812    , 0.209357111942    , 0.220094514051    ,
 0.18708762157     , 0.130770226144    , 0.0776510320593   , 0.0413462484185   ,
 0.0210743769584   , 0.0107155281249   , 0.00540708377982  , 0.00273080165429  ,
 0.00191530143636  , 0.00349477140815  , 0.00953116749922  , 0.0230792154268   ,
 0.0456542294597   , 0.0746185426073   , 0.105657579714    , 0.140518115675    ,
 0.188973416219    , 0.256031010127    , 0.327380988503    , 0.376912527666    ,
 0.392449889714    , 0.38579501996     , 0.375077533029    , 0.368717916398    ,
 0.369055509119    , 0.376532659448    , 0.383549962331    , 0.376192991541    ,
 0.350685365532    , 0.322365612045    , 0.311465608026    , 0.32064661864     ,
 0.3298026361      , 0.313943011498    , 0.265419449976    , 0.199209887686    ,
 0.139710126821    , 0.104334016054    , 0.0961478926206   , 0.105498309489    ,
 0.116154880436    , 0.11397226196     , 0.105198628529    , 0.0779781411541   ,
 0.0481032880454   , 0.0248776551762   , 0.0110735911362   , 0.00461763866002  ,
 0.00214003030498  , 0.00120398281144  , 0.000709652664032 , 0.000371314026369 ,
 0.0001608379757   , 5.67627966984e-05 , 1.66109544016e-05 , 5.9484208402e-06  ,
 1.40081623422e-05 , 6.78626371686e-05 , 0.000272349827762 , 0.000857630004704 ,
 0.00211593159574  , 0.00409418911903  , 0.0062214762885   , 0.00743653759929  ,
 0.00700506471842  , 0.00521255982922  , 0.00307489241915  , 0.00144716658631  ,
 0.000550542517504 , 0.000174471488178 , 5.11233305185e-05 , 2.37259983588e-05 ,
 3.53710100538e-05 , 7.90971827875e-05 , 0.00016904679735  , 0.000326985834773 ,
 0.000569996284638 , 0.000925857720087 , 0.00158354590784  , 0.00333165484727  ,
 0.00834835564633  , 0.0212900720577   , 0.0510724749271   , 0.115196906809    ,
 0.248879744543    , 0.516365416979    , 1.01458924874     , 1.86519561091     ,
 3.21256939743     , 5.24529105554     , 8.21322149194     , 12.3933330087     ,
 18.0145321508     , 25.169960881      , 33.6855840718     , 42.9738714174     ,
 52.0573201763     , 59.8561386595     , 65.5345128084     , 68.6510984474     ,
 69.1198075817     , 67.1358064538     , 63.1361766827     , 57.7839457701     ,
 51.9229066249     , 46.4146664056     , 41.886581031      , 38.5866673767     ,
 36.4522850116     , 35.2743658611     , 34.818157368      , 34.893027085      ,
 35.4018671264     , 36.327450752      , 37.6110194638     , 39.0280989499     ,
 40.2293408148     , 40.9083270161     , 40.8789172973     , 39.9972430142     ,
 38.1144286217     , 35.1876473774     , 31.4001237346     , 27.1039845121     ,
 22.6525270735     , 18.3151057201     , 14.3113655175     , 10.8348927271     ,
 7.99184180643     , 5.74771663685     , 3.98270475363     , 2.59826231326     ,
 1.55633960393     , 0.838698705358    , 0.400934133029    , 0.168516846686    ,
 0.0619508429165   , 0.0198512114066   , 0.00552748591356  , 0.00135981007401  ,
 0.000422282337603 , 0.000566607870479 , 0.00144348859516  , 0.00315423615418  ,
 0.00546986420118  , 0.00748195334611  , 0.00805782153228  , 0.00682213888433  ,
 0.00453416852825  , 0.00236251291166  , 0.000963917220502 , 0.000307647516296 ,
 7.67436952224e-05 , 1.49519676893e-05 , 2.27387767155e-06 , 2.69801165419e-07 ,
 2.49668519493e-08 , 1.80133972929e-09 , 1.01307112337e-10 , 4.44505867508e-12 ,
 1.676923082e-13   , 4.55907155025e-14 , 8.73383391495e-14 , 2.39871652222e-13 ,
 3.62240445477e-12 , 9.17769933753e-11 , 1.92962205255e-09 , 3.22122906139e-08 ,
 4.26066654953e-07 , 4.463321189e-06   , 3.7022864538e-05  , 0.000243178604168 ,
 0.00126522130102  , 0.00521763203289  , 0.0170709934375   , 0.0443674068638   ,
 0.091746345956    , 0.151292218468    , 0.199694415575    , 0.212476202896    ,
 0.184872261856    , 0.135310699713    , 0.0875203171048   , 0.0534195373895   ,
 0.0323756844674   , 0.0195457255124   , 0.0113795816482   , 0.00630595372877  ,
 0.00391339256367  , 0.00470909496173  , 0.0105428025889   , 0.0243694734976   ,
 0.0479609117573   , 0.079323458206    , 0.114969233978    , 0.157407071273    ,
 0.216902098396    , 0.29841959254     , 0.387303696143    , 0.457875715291    ,
 0.498860674184    , 0.520022552022    , 0.532697832454    , 0.538687430904    ,
 0.540055308454    , 0.541553597448    , 0.537737038873    , 0.512757844432    ,
 0.460139839066    , 0.394412208311    , 0.338433285879    , 0.303061298677    ,
 0.280855285278    , 0.256210236785    , 0.219253469224    , 0.172104670679    ,
 0.126079908082    , 0.0945549466953   , 0.0854710719614   , 0.0959448697437   ,
 0.112352736666    , 0.118187428031    , 0.13756534969     , 0.104452278529    ,
 0.0655815629081   , 0.034112557546    , 0.0147347109753   , 0.00534482241361  ,
 0.00170849760818  , 0.000548407543619 , 0.00020610197547  , 8.68979123398e-05 ,
 3.45197832333e-05 , 1.16655867047e-05 , 3.71261393049e-06 , 4.96614897654e-06 ,
 2.80692399518e-05 , 0.00014387224818  , 0.000579196901809 , 0.00182468069506  ,
 0.00450240695832  , 0.00871205872327  , 0.013237397404    , 0.0158170668489   ,
 0.0148850367666   , 0.0110490828514   , 0.00647848026167  , 0.00300454160361  ,
 0.00110378924601  , 0.000322015884167 , 7.53325816739e-05 , 1.56469673315e-05 ,
 6.91075368453e-06 , 1.24817883696e-05 , 2.81415590727e-05 , 5.85169804599e-05 ,
 0.000111877774005 , 0.000212784818928 , 0.000468095448043 , 0.00124604927512  ,
 0.00350662525843  , 0.00933412066724  , 0.0231586960585   , 0.0552188558842   ,
 0.129020228499    , 0.291296083073    , 0.618377522098    , 1.21617719145     ,
 2.22343342742     , 3.82715534116     , 6.27318282775     , 9.84736762205     ,
 14.8340723919     , 21.4431152503     , 29.6472447806     , 38.9777559174     ,
 48.5026901198     , 57.0995323975     , 63.8180317313     , 68.0796427459     ,
 69.6901194049     , 68.7697758061     , 65.675393412      , 60.9651250887     ,
 55.3921153513     , 49.8085687816     , 44.939831685      , 41.1843522339     ,
 38.5909832121     , 36.9888574735     , 36.1570045536     , 35.9440515614     ,
 36.2956830717     , 37.1896657815     , 38.5132679611     , 39.9830182717     ,
 41.2185290799     , 41.9166885596     , 41.9205517466     , 41.1157764069     ,
 39.3521698427     , 36.5534358327     , 32.8688514453     , 28.6352190651     ,
 24.1918184224     , 19.7806658245     , 15.6048198317     , 11.8836806972     ,
 8.78134371566     , 6.31124862729     , 4.36823174051     , 2.84767329222     ,
 1.70471285578     , 0.917840472077    , 0.438005889257    , 0.183304293042    ,
 0.0666690156801   , 0.0208892694975   , 0.00559008146623  , 0.00127717574868  ,
 0.000295908985944 , 0.000234024683663 , 0.000549749542739 , 0.001197431678    ,
 0.00207647165467  , 0.00284035591312  , 0.0030589835383   , 0.00258988418764  ,
 0.00172130366323  , 0.000896879367206 , 0.000365931320392 , 0.000116792043457 ,
 2.91341633309e-05 , 5.67620659288e-06 , 8.63230826798e-07 , 1.02424455813e-07 ,
 9.478151131e-09   , 6.83841450759e-10 , 3.84587436806e-11 , 1.68574546097e-12 ,
 5.79860101191e-14 , 2.63303953161e-15 , 3.98317048617e-15 , 7.81612530414e-14 ,
 2.50821562247e-12 , 6.66208616944e-11 , 1.4052401724e-09  , 2.34953409742e-08 ,
 3.11260869948e-07 , 3.26614019576e-06 , 2.71415474601e-05 , 0.000178629478631 ,
 0.000931434084674 , 0.00385066415553  , 0.0126343856194   , 0.0329478219414   ,
 0.0684280128336   , 0.113550564251    , 0.151462128808    , 0.164370191633    ,
 0.148686152574    , 0.117175585254    , 0.0857771009906   , 0.0618785246781   ,
 0.0447020268517   , 0.0314395842627   , 0.0207471596272   , 0.012796296132    ,
 0.00824972054514  , 0.00782229974557  , 0.0128967856709   , 0.0259987680098   ,
 0.049481043346    , 0.0834344832572   , 0.126793080497    , 0.182075429209    ,
 0.255572525065    , 0.347016540727    , 0.44118617402     , 0.519238434945    ,
 0.578317836167    , 0.628309303272    , 0.67016445761     , 0.693861386019    ,
 0.697719325064    , 0.690333265027    , 0.670843859192    , 0.624983982164    ,
 0.545716213235    , 0.446935124559    , 0.353552649105    , 0.28372253669     ,
 0.240475303768    , 0.214245648419    , 0.190869865294    , 0.16093154444     ,
 0.126380951615    , 0.0996108343211   , 0.0938575225614   , 0.110974362942    ,
 0.136769906661    , 0.149834740888    , 0.17523060232     , 0.131955868475    ,
 0.081867728978    , 0.0419542093447   , 0.0177586245915   , 0.00619590174285  ,
 0.00178517194145  , 0.000435164429341 , 9.79558658846e-05 , 2.40310620905e-05 ,
 6.91533971567e-06 , 2.10557119261e-06 , 1.36885435657e-06 , 7.24208821833e-06 ,
 4.70289259947e-05 , 0.000242139928336 , 0.000974975254884 , 0.00307157986517  ,
 0.0075791681568   , 0.014665512323    , 0.022283092934    , 0.0266249000658   ,
 0.0250543655527   , 0.0185946287441   , 0.0108982147373   , 0.0050492040735   ,
 0.00185042019008  , 0.000536561640995 , 0.000123144569941 , 2.25351306264e-05 ,
 3.85044953712e-06 , 2.38704355413e-06 , 6.26309706094e-06 , 1.82848216793e-05 ,
 4.91665182537e-05 , 0.000120164235299 , 0.000277492735696 , 0.000645868132991 ,
 0.00156416002049  , 0.00388354279064  , 0.00978305929146  , 0.0251097921845   ,
 0.064497867304    , 0.158970617694    , 0.363330362903    , 0.761911102084    ,
 1.47709847581     , 2.68477759651     , 4.62815923732     , 7.61629222891     ,
 11.9991432577     , 18.0828275291     , 25.9338050495     , 35.1556904937     ,
 44.8704992903     , 53.9866404948     , 61.5432003866     , 66.9067627055     ,
 69.7958596401     , 70.2054007818     , 68.3192827941     , 64.5061417055     ,
 59.3814776648     , 53.7765258959     , 48.5291527962     , 44.2244368818     ,
 41.0690088976     , 38.9663216089     , 37.722244013      , 37.2172058861     ,
 37.4219903616     , 38.2940718286     , 39.6701580042     , 41.2365293578     ,
 42.6103391243     , 43.4792374704     , 43.6621690576     , 43.0318451973     ,
 41.4378343903     , 38.7851840909     , 35.1794414082     , 30.9206075907     ,
 26.3394414955     , 21.6890992995     , 17.1962900379     , 13.1227353756     ,
 9.68817710961     , 6.94879600111     , 4.80891044305     , 3.14803090107     ,
 1.90237316411     , 1.039826627       , 0.506630373947    , 0.217423723732    ,
 0.0811532822464   , 0.0259667619207   , 0.00701720696678  , 0.00158303345011  ,
 0.000309465664197 , 0.000103056907447 , 0.000168761698725 , 0.000359418218525 ,
 0.000622663748795 , 0.000851695159145 , 0.000917251111446 , 0.000776589479871 ,
 0.000516141363629 , 0.000268933687832 , 0.000109726305644 , 3.50206684828e-05 ,
 8.73602212414e-06 , 1.70203845614e-06 , 2.58844007824e-07 , 3.0712476685e-08  ,
 2.84207021939e-09 , 2.05053219763e-10 , 1.15320348106e-11 , 5.05443316373e-13 ,
 1.72700909739e-14 , 4.91454666635e-16 , 1.04548806814e-15 , 4.26837291024e-14 ,
 1.43258325043e-12 , 3.81758464169e-11 , 8.06634397007e-10 , 1.35101820844e-08 ,
 1.79306432408e-07 , 1.88516778445e-06 , 1.56986483954e-05 , 0.000103557619719 ,
 0.000541371865889 , 0.00224461565763  , 0.00738984111144  , 0.0193524158594   ,
 0.0404256000795   , 0.0677010904398   , 0.091817083348    , 0.102925442837    ,
 0.0991413343411   , 0.0872192718809   , 0.0748059613824   , 0.0644354688876   ,
 0.0546488199663   , 0.0438701128059   , 0.0325151282089   , 0.0227618784412   ,
 0.0169240052992   , 0.0163004230012   , 0.021908324731    , 0.0359260255642   ,
 0.0616956516079   , 0.10235184434     , 0.16038918019     , 0.238259566454    ,
 0.335273101617    , 0.440195602731    , 0.532257423367    , 0.599331555498    ,
 0.65227323927     , 0.708531154276    , 0.764149212713    , 0.797961407805    ,
 0.800714274001    , 0.78076226251     , 0.741918894644    , 0.675460720368    ,
 0.577634633262    , 0.462378258306    , 0.353599006555    , 0.270730438291    ,
 0.220442584272    , 0.195307176467    , 0.178837126604    , 0.156744616067    ,
 0.128122939836    , 0.10662124868     , 0.108610630625    , 0.136798827462    ,
 0.173420080134    , 0.191374670436    , 0.190408819488    , 0.140613623625    ,
 0.0852950480497   , 0.042668941448    , 0.0176262645404   , 0.00599735855425  ,
 0.00167206659268  , 0.000380708171088 , 7.1507016723e-05  , 1.16794814202e-05 ,
 1.9107636626e-06  , 4.6378458362e-07  , 1.19829874391e-06 , 9.50005425177e-06 ,
 6.25495662556e-05 , 0.000322174881806 , 0.00129725167761  , 0.00408688859876  ,
 0.0100844585133   , 0.0195131874884   , 0.0296487360383   , 0.0354256600577   ,
 0.0333358424978   , 0.0247406242646   , 0.0144999469926   , 0.00671745061209  ,
 0.00246139071438  , 0.000713432213988 , 0.000163529293041 , 2.96694936366e-05 ,
 4.59612055494e-06 , 2.65691192527e-06 , 1.08524399617e-05 , 4.28223551196e-05 ,
 0.000134167679532 , 0.000332682482089 , 0.000659103099968 , 0.00107257762631  ,
 0.00154165381059  , 0.00230748342172  , 0.00445605447196  , 0.0112809052342   ,
 0.0313423664856   , 0.0837434769468   , 0.205055821416    , 0.457462513575    ,
 0.940149052297    , 1.8072903492      , 3.29151076768     , 5.72292734474     ,
 9.51627155754     , 15.0670602436     , 22.5212589515     , 31.5394351087     ,
 41.2922533232     , 50.7428232773     , 58.9862238003     , 65.4143873119     ,
 69.6801863822     , 71.5793718768     , 71.0162683725     , 68.1302226714     ,
 63.4432569771     , 57.818742498      , 52.2129615514     , 47.3821113989     ,
 43.7006922117     , 41.1762184533     , 39.6467092168     , 38.9886526332     ,
 39.1533332705     , 40.0638568749     , 41.528966529      , 43.2400642196     ,
 44.8291650195     , 45.9563169003     , 46.376012158      , 45.9246216323     ,
 44.4644274016     , 41.9037944708     , 38.2996775434     , 33.8904147259     ,
 28.9947517238     , 23.9163393828     , 18.9595122545     , 14.4513828653     ,
 10.6494228491     , 7.62341303316     , 5.27382158056     , 3.46513378767     ,
 2.11539153783     , 1.17775603435     , 0.589636225042    , 0.261855825295    ,
 0.101454419537    , 0.0336364916232   , 0.00936205636897  , 0.00215300855774  ,
 0.000407567670099 , 7.51179876459e-05 , 4.61000991039e-05 , 8.56232278342e-05 ,
 0.000147340809703 , 0.000201475803883 , 0.000216980734635 , 0.000183706357997 ,
 0.000122095973257 , 6.36176882569e-05 , 2.5956338768e-05  , 8.28432461772e-06 ,
 2.06655230411e-06 , 4.02626211706e-07 , 6.12309210271e-08 , 7.26519902953e-09 ,
 6.72306763517e-10 , 4.85064251804e-11 , 2.72796377698e-12 , 1.19564721544e-13 ,
 4.08345449739e-15 , 1.13820634978e-16 , 4.49184227272e-16 , 1.92042510792e-14 ,
 6.46627535698e-13 , 1.72630854857e-11 , 3.65435651402e-10 , 6.13245440427e-09 ,
 8.15551861931e-08 , 8.59302036587e-07 , 7.17256742881e-06 , 4.74363688566e-05 ,
 0.000248699623442 , 0.00103456692518  , 0.00341969334641  , 0.00900281094068  ,
 0.0189562916813   , 0.0321888858547   , 0.0448339669946   , 0.0529609612441   ,
 0.0561380874199   , 0.0572110834745   , 0.0585433313696   , 0.0596320560567   ,
 0.0581731391411   , 0.0525782988925   , 0.0439499607273   , 0.035982725972    ,
 0.0324911418564   , 0.0353568363749   , 0.0453616330001   , 0.0645599337844   ,
 0.0976190443876   , 0.151389643247    , 0.233161028715    , 0.346567654235    ,
 0.483126044927    , 0.615490494895    , 0.708918504422    , 0.751735791718    ,
 0.769965345789    , 0.79805429554     , 0.838483455505    , 0.864491685043    ,
 0.856738892809    , 0.818078245475    , 0.755562222871    , 0.669269788199    ,
 0.562596658213    , 0.449868530138    , 0.349151962818    , 0.272593587601    ,
 0.222904408764    , 0.193441070427    , 0.171336813832    , 0.145966399801    ,
 0.118429182036    , 0.102444198393    , 0.112946563574    , 0.150032631774    ,
 0.19260763864     , 0.211093491995    , 0.16815699351     , 0.121507552462    ,
 0.0718913363942   , 0.0350082227526   , 0.0140736955514   , 0.00466691978648  ,
 0.0012703592198   , 0.000281817131706 , 5.06434866054e-05 , 7.38927014439e-06 ,
 9.09009017205e-07 , 2.10218990151e-07 , 1.19221259897e-06 , 9.96712325182e-06 ,
 6.57129700154e-05 , 0.000338480422004 , 0.00136290801701  , 0.00429373387257  ,
 0.0105948523304   , 0.0205007871213   , 0.0311493137606   , 0.0372186142946   ,
 0.0350230168845   , 0.0259927627613   , 0.0152337698906   , 0.00705737960968  ,
 0.00258591816737  , 0.000749506507949 , 0.000171790535628 , 3.12260602143e-05 ,
 5.44203912198e-06 , 7.04776111003e-06 , 3.36952512385e-05 , 0.00013525334343  ,
 0.00042535314357  , 0.00104797431045  , 0.00202678029763  , 0.00308929450872  ,
 0.00375344912355  , 0.0037997544945   , 0.0038543845549   , 0.00600565677474  ,
 0.0152308116305   , 0.0427569508688   , 0.111810761178    , 0.265664789673    ,
 0.579175959237    , 1.17838656648     , 2.27361091922     , 4.19902885984     ,
 7.41677183823     , 12.4068810317     , 19.4105904227     , 28.1692077166     ,
 37.9125651576     , 47.6579553527     , 56.5665522194     , 64.0707655548     ,
 69.7387313629     , 73.1065811668     , 73.7597836584     , 71.6531925232     ,
 67.3146242242     , 61.6949970936     , 55.8350827474     , 50.5975234521     ,
 46.5066672113     , 43.7038064326     , 42.0764058445     , 41.4678145538     ,
 41.7656626964     , 42.8459836934     , 44.5085632202     , 46.463343198      ,
 48.3422613057     , 49.7485713496     , 50.3569382196     , 49.9787892615     ,
 48.5163284115     , 45.8997637595     , 42.1325579115     , 37.3777614187     ,
 31.9531242791     , 26.2601532003     , 20.7312440744     , 15.7659325412     ,
 11.6174748396     , 8.32011411876     , 5.7533905918      , 3.77973785673     ,
 2.31519618321     , 1.30189210798     , 0.663422170382    , 0.301726922066    ,
 0.120028184428    , 0.0408137424362   , 0.011609431289    , 0.00271528254658  ,
 0.000516405639484 , 8.14734391259e-05 , 1.6868230204e-05  , 1.67668082132e-05 ,
 2.75208872301e-05 , 3.75499085013e-05 , 4.04356000721e-05 , 3.42345741529e-05 ,
 2.27531742891e-05 , 1.1855463343e-05  , 4.83708904072e-06 , 1.54382388734e-06 ,
 3.85111998715e-07 , 7.50313383393e-08 , 1.14106777424e-08 , 1.35390491388e-09 ,
 1.25287611126e-10 , 9.03940651036e-12 , 5.0836921983e-13  , 2.2281463091e-14  ,
 7.60971459578e-16 , 2.20632931393e-17 , 1.59090281426e-16 , 6.83481268691e-15 ,
 2.30559335063e-13 , 6.16711049289e-12 , 1.30810702365e-10 , 2.19974431274e-09 ,
 2.93184094463e-08 , 3.09632288458e-07 , 2.59100783221e-06 , 1.71834750857e-05 ,
 9.03729271063e-05 , 0.000377339548931 , 0.0012531859167   , 0.0033217700409   ,
 0.00707459465922  , 0.012274869031    , 0.0178441522092   , 0.0228631281568   ,
 0.0276902087937   , 0.0335393045188   , 0.0408421514209   , 0.0482709572572   ,
 0.0532965991835   , 0.0541540418871   , 0.0521640030971   , 0.0517161589172   ,
 0.0571576258325   , 0.0702848824855   , 0.0912962529355   , 0.12179125963     ,
 0.16758697386     , 0.239826140046    , 0.352144462561    , 0.511142709308    ,
 0.700924545337    , 0.875420659333    , 0.980421269279    , 0.998997908639    ,
 0.970341075844    , 0.949676487804    , 0.953144275541    , 0.953720884165    ,
 0.922498081278    , 0.855054597507    , 0.761755425021    , 0.653919751288    ,
 0.544089455896    , 0.445891623855    , 0.366622437839    , 0.304124599255    ,
 0.252395791172    , 0.207008065173    , 0.165416787287    , 0.12711373501     ,
 0.0966238020051   , 0.0841532481137   , 0.0985525256235   , 0.135888770469    ,
 0.175108456168    , 0.189758684226    , 0.118991184988    , 0.0841635791334   ,
 0.048583089145    , 0.0230214049796   , 0.00899575265602  , 0.00290217920164  ,
 0.000770640149616 , 0.00016730429624  , 2.94485588887e-05 , 4.17261499276e-06 ,
 4.81461457058e-07 , 1.34381730378e-07 , 9.80992217657e-07 , 8.25660246945e-06 ,
 5.44432163683e-05 , 0.000280432078696 , 0.00112917361501  , 0.00355737214232  ,
 0.0087778687845   , 0.0169849671836   , 0.0258073052174   , 0.0308357397104   ,
 0.029016679723    , 0.0215350846686   , 0.012621224084    , 0.00584705841352  ,
 0.00214243881257  , 0.000620967961776 , 0.000142346368124 , 2.60709010159e-05 ,
 6.20528991661e-06 , 1.70280282857e-05 , 8.55026942958e-05 , 0.000343608415973 ,
 0.00108048064082  , 0.00266012007528  , 0.0051338755779   , 0.00777913794435  ,
 0.00927887027602  , 0.00878207461808  , 0.00687602748237  , 0.00559879311817  ,
 0.00839647704013  , 0.0219148390147   , 0.0605016183821   , 0.153068135813    ,
 0.353133779013    , 0.758001659498    , 1.54722047628     , 3.03749774749     ,
 5.70792298327     , 10.1050583997     , 16.5833765591     , 25.0169912245     ,
 34.7485431468     , 44.8660631383     , 54.5580460591     , 63.2181508175     ,
 70.2582873586     , 74.9470306846     , 76.6219580443     , 75.1581805614     ,
 71.1571019446     , 65.6465356703     , 59.6815130249     , 54.1634842192     ,
 49.7509995072     , 46.7495405844     , 45.1274730376     , 44.6985749523     ,
 45.2757971995     , 46.6850166038     , 48.7142161867     , 51.0640455508     ,
 53.3153693212     , 54.9784243416     , 55.6572268709     , 55.1808028558     ,
 53.5303100496     , 50.6692831137     , 46.5366304719     , 41.214731035      ,
 35.0468041583     , 28.5828065302     , 22.4178620756     , 17.0113824896     ,
 12.56248774       , 9.02229402737     , 6.23486655045     , 4.07601879268     ,
 2.48076319559     , 1.38925776549     , 0.708303356549    , 0.323786665019    ,
 0.129821920133    , 0.0445193514319   , 0.0127589497384   , 0.00300136574141  ,
 0.000572368233103 , 8.81036639673e-05 , 1.18130263268e-05 , 3.37127492357e-06 ,
 4.10537200314e-06 , 5.50881149045e-06 , 5.92763808554e-06 , 5.01842684668e-06 ,
 3.33536959472e-06 , 1.73788274646e-06 , 7.09064952959e-07 , 2.26307889457e-07 ,
 5.645325503e-08   , 1.09987829324e-08 , 1.67268198032e-09 , 1.98467821425e-10 ,
 1.83658091323e-11 , 1.32507925682e-12 , 7.45214309401e-14 , 3.26622157325e-15 ,
 1.11550188053e-16 , 3.47191042765e-18 , 4.45860077474e-17 , 1.92296245733e-15 ,
 6.49933767094e-14 , 1.74198775347e-12 , 3.70268805983e-11 , 6.24010745394e-10 ,
 8.33588018842e-09 , 8.82491113152e-08 , 7.40410953376e-07 , 4.92471605953e-06 ,
 2.5987920319e-05  , 0.000108962244849 , 0.000363971435804 , 0.000973762781862 ,
 0.00210974796364  , 0.00378777720053  , 0.0058889900649   , 0.00848642999138  ,
 0.0121257825097   , 0.0175612932538   , 0.0250490793646   , 0.0337577453358   ,
 0.0419719856936   , 0.0487726261324   , 0.0561991365067   , 0.0688996547186   ,
 0.0908960499949   , 0.123227016592    , 0.164720297054    , 0.215189418385    ,
 0.280463073876    , 0.376207630512    , 0.523657344517    , 0.733039822303    ,
 0.980932138755    , 1.20347937043     , 1.32922114495     , 1.3360867434      ,
 1.27199098813     , 1.20701326087     , 1.16873472264     , 1.13235429886     ,
 1.06352235438     , 0.953931276821    , 0.819687463766    , 0.684581192097    ,
 0.569589255905    , 0.485269218607    , 0.425383650208    , 0.371451882981    ,
 0.30848498134     , 0.236342734681    , 0.166058328937    , 0.109055444308    ,
 0.0721754483631   , 0.0591989404648   , 0.0707054339117   , 0.0993531421802   ,
 0.127744213169    , 0.136679571295    , 0.0671885465355   , 0.0465715151566   ,
 0.0262581709714   , 0.0121161851572   , 0.00460111402107  , 0.00144243743726  ,
 0.000372951078826 , 7.91208775885e-05 , 1.3662644622e-05  , 1.90372754111e-06 ,
 2.1659882389e-07  , 7.78070501144e-08 , 6.39040635846e-07 , 5.38655121666e-06 ,
 3.55190773718e-05 , 0.000182955619079 , 0.000736679842381 , 0.00232085156334  ,
 0.00572673582522  , 0.011081097524    , 0.0168368453583   , 0.020117427076    ,
 0.0189306610775   , 0.0140496222054   , 0.00823416445342  , 0.00381465690909  ,
 0.0013977403528   , 0.000405125942418 , 9.29049146866e-05 , 1.74125037745e-05 ,
 7.45597006956e-06 , 3.35578735977e-05 , 0.000171272471611 , 0.000688486502569 ,
 0.00216491900849  , 0.00532964526032  , 0.0102840987831   , 0.0155748485137   ,
 0.0185423704961   , 0.0173996050314   , 0.012998589125    , 0.00827161094291  ,
 0.00663430587904  , 0.0123955334206   , 0.0342716326606   , 0.0909873197661   ,
 0.219429631552    , 0.491955542537    , 1.05506589971     , 2.19078093748     ,
 4.36049254527     , 8.14246233269     , 14.0026630126     , 22.0005300286     ,
 31.675768915      , 42.2361257299     , 52.8518228848     , 62.7601632669     ,
 71.1365835309     , 77.0271826098     , 79.6506524261     , 78.8887239429     ,
 75.3943605096     , 70.1886664249     , 64.2716130163     , 58.5567058515     ,
 53.8412259633     , 50.6154360796     , 48.9575901163     , 48.6854750104     ,
 49.569394758      , 51.4003321179     , 53.9338023405     , 56.8029778958     ,
 59.4729073527     , 61.3342808503     , 61.9482141098     , 61.2149150329     ,
 59.2326594447     , 56.00206361       , 51.3770823835     , 45.344744834      ,
 38.2885987063     , 30.9406518767     , 24.0781458744     , 18.2116175336     ,
 13.4633060658     , 9.6825966367      , 6.67102401589     , 4.32071391475     ,
 2.59235441894     , 1.42817790309     , 0.716898293702    , 0.323498363439    ,
 0.128425585988    , 0.0437105506023   , 0.0124507269568   , 0.00291240862506  ,
 0.000552111943127 , 8.41417376666e-05 , 1.0361465874e-05  , 1.26067840855e-06 ,
 5.39969047225e-07 , 6.3840650197e-07  , 6.82708322724e-07 , 5.77828974427e-07 ,
 3.84034401539e-07 , 2.00099673747e-07 , 8.16416769968e-08 , 2.60570706788e-08 ,
 6.50002286661e-09 , 1.26639890875e-09 , 1.9259245751e-10  , 2.28515676708e-11 ,
 2.11463766369e-12 , 1.52569510205e-13 , 8.58039106703e-15 , 3.76072467429e-16 ,
 1.28438789355e-17 , 4.52289613718e-19 , 9.88853161946e-18 , 4.279237706e-16   ,
 1.44918774618e-14 , 3.89218109856e-13 , 8.29065432264e-12 , 1.40029828511e-10 ,
 1.87490952483e-09 , 1.98976560974e-08 , 1.6738660876e-07  , 1.11669504555e-06 ,
 5.91417002962e-06 , 2.49167109112e-05 , 8.38521798141e-05 , 0.000227360778561 ,
 0.000505911829552 , 0.000958697087304 , 0.00164805588968  , 0.00277048298308  ,
 0.00474407793352  , 0.00812874611058  , 0.0133473377186   , 0.0203718788995   ,
 0.0289643663731   , 0.0400710743445   , 0.057267341641    , 0.0859117114637   ,
 0.13027506094     , 0.191347257002    , 0.2664219265      , 0.351878830112    ,
 0.451600109705    , 0.585049592507    , 0.780762655945    , 1.05064366882     ,
 1.36158112063     , 1.6344794814      , 1.78804342153     , 1.79905074365     ,
 1.71807790333     , 1.61874030739     , 1.53385118623     , 1.44374975529     ,
 1.31641504204     , 1.14624272427     , 0.957473643592    , 0.784635006224    ,
 0.653333232651    , 0.568489761815    , 0.511562410309    , 0.452025754312    ,
 0.369623009789    , 0.268791670951    , 0.171340160081    , 0.0971602146251   ,
 0.0533363142596   , 0.0370512018645   , 0.0417411040064   , 0.0582799474917   ,
 0.0743543943717   , 0.0785012781215   , 0.0302275038591   , 0.020560762806    ,
 0.011340178697    , 0.00510180472175  , 0.00188388486182  , 0.000573619211101 ,
 0.000144194689654 , 2.98308646938e-05 , 5.04432420822e-06 , 6.91232649118e-07 ,
 7.82242142757e-08 , 3.68890393288e-08 , 3.27581898809e-07 , 2.76313709867e-06 ,
 1.82203085162e-05 , 9.38511997732e-05 , 0.000377896494639 , 0.00119053301031  ,
 0.00293765794802  , 0.00568429821236  , 0.00863683852287  , 0.0103196867018   ,
 0.00971090838916  , 0.00720706971355  , 0.00422389985676  , 0.00195681406736  ,
 0.000717002587697 , 0.000207822723134 , 4.77167839136e-05 , 9.57174304194e-06 ,
 9.22318142038e-06 , 5.27775638278e-05 , 0.000270816165999 , 0.00108873604302  ,
 0.00342348698291  , 0.00842797107913  , 0.0162623871784   , 0.0246274235835   ,
 0.0293130147825   , 0.027471587479    , 0.0203531845058   , 0.0122145159535   ,
 0.00719082544303  , 0.00851551683214  , 0.0213728019908   , 0.0575860820474   ,
 0.142173667055    , 0.328160483059    , 0.731507455895    , 1.59044735318     ,
 3.32068072063     , 6.4917517484      , 11.6550976633     , 19.0752881637     ,
 28.5549725247     , 39.4838394744     , 51.0146652803     , 62.1766095914     ,
 71.8853301707     , 79.0231163835     , 82.771674952      , 83.0180904677     ,
 80.3687266291     , 75.7358009509     , 70.0311141241     , 64.1964804867     ,
 59.1819139589     , 55.6642710264     , 53.8470031526     , 53.5953586291     ,
 54.6895225076     , 56.910488534      , 59.9577608268     , 63.3423959228     ,
 66.3728190574     , 68.3253283108     , 68.7585235643     , 67.6824274526     ,
 65.3258785734     , 61.7158185705     , 56.5959699292     , 49.8311709415     ,
 41.8313080555     , 33.5121585553     , 25.8435735912     , 19.4059216138     ,
 14.2715673252     , 10.2090397512     , 6.97583065812     , 4.46030986851     ,
 2.62865135033     , 1.4162218969      , 0.693231014308    , 0.304895524203    ,
 0.118183288107    , 0.0393905590744   , 0.0110191983568   , 0.00253666510975  ,
 0.000473775169258 , 7.11257024511e-05 , 8.54257123524e-06 , 8.39156506066e-07 ,
 1.03732092389e-07 , 6.0964337329e-08  , 6.18157698418e-08 , 5.21917616127e-08 ,
 3.46836832881e-08 , 1.80717126889e-08 , 7.37334832423e-09 , 2.35330610687e-09 ,
 5.87040028227e-10 , 1.14372959356e-10 , 1.73937052242e-11 , 2.06380580588e-12 ,
 1.90980397955e-13 , 1.37790914609e-14 , 7.74925429887e-16 , 3.39644331144e-17 ,
 1.15997608125e-18 , 5.00505264943e-20 , 1.73537755094e-18 , 7.53265441631e-17 ,
 2.55597711439e-15 , 6.87867716261e-14 , 1.46827932863e-12 , 2.48529595245e-11 ,
 3.33516402739e-10 , 3.54798935973e-09 , 2.99261430783e-08 , 2.00265148408e-07 ,
 1.06484597004e-06 , 4.51271853079e-06 , 1.53434498101e-05 , 4.24577038779e-05 ,
 9.85436748132e-05 , 0.000202910453276 , 0.000400855141207 , 0.000806690152999 ,
 0.00165177531493  , 0.00329986752468  , 0.00620599282537  , 0.0109355903259   ,
 0.0186625807601   , 0.0323529688798   , 0.0575968168972   , 0.10173076298     ,
 0.171733053855    , 0.271623303268    , 0.399277663805    , 0.547580336471    ,
 0.716682766944    , 0.92751470271     , 1.21251588459     , 1.57946159773     ,
 1.97985774966     , 2.3194726318      , 2.51262879901     , 2.53666079205     ,
 2.43755872006     , 2.28344668367     , 2.11188678975     , 1.91812952834     ,
 1.68594690212     , 1.42157509263     , 1.15780873734     , 0.932997005563    ,
 0.769053980969    , 0.661915497502    , 0.58498233073     , 0.504320415961    ,
 0.400309043214    , 0.280145033025    , 0.168734591955    , 0.0872643381851   ,
 0.0407983372076   , 0.0220609688269   , 0.0206643126572   , 0.027443777154    ,
 0.0344717003741   , 0.0358908662161   , 0.0108243987417   , 0.00723579223422  ,
 0.00391054170553  , 0.00171810331198  , 0.000617596707371 , 0.000182682179106 ,
 4.46057216928e-05 , 8.98227155072e-06 , 1.48405177941e-06 , 1.99609400194e-07 ,
 2.25204347636e-08 , 1.40476290444e-08 , 1.31877706446e-07 , 1.11286587701e-06 ,
 7.33833279808e-06 , 3.77991048783e-05 , 0.000152199964107 , 0.000479493946116 ,
 0.00118315845897  , 0.00228938345862  , 0.00347853587379  , 0.0041563125562   ,
 0.00391112362574  , 0.0029026883479   , 0.00170119970903  , 0.000788118016351 ,
 0.000288777173223 , 8.37071250788e-05 , 1.92922939483e-05 , 4.65661455481e-06 ,
 1.04799079181e-05 , 6.58233860589e-05 , 0.000338350652153 , 0.00136027949551  ,
 0.00427734606611  , 0.0105300043129   , 0.0203183831594   , 0.0307695400979   ,
 0.0366224181257   , 0.0343136808059   , 0.0253767116263   , 0.0150057609084   ,
 0.00791267716832  , 0.00675476465726  , 0.014537978591    , 0.0386917664552   ,
 0.0964263194308   , 0.226857935402    , 0.520113108679    , 1.16949415279     ,
 2.53053159166     , 5.13168557584     , 9.56751836023     , 16.2790076373     ,
 25.3405494888     , 36.3723307823     , 48.5790096696     , 60.8528860006     ,
 71.9120797807     , 80.5096463308     , 85.7658371334     , 87.4785310293     ,
 86.0896815187     , 82.3362056574     , 77.0480981765     , 71.2256327228     ,
 65.9780696056     , 62.1584355555     , 60.1014107798     , 59.7517843412     ,
 60.9348125954     , 63.4323138897     , 66.8687547276     , 70.6091981353     ,
 73.8140759452     , 75.6941127946     , 75.8550133057     , 74.4232483357     ,
 71.7241814232     , 67.7741213059     , 62.1886000483     , 54.6993298555     ,
 45.7226217475     , 36.3366573064     , 27.7057581543     , 20.5201380407     ,
 14.8643158033     , 10.4694050894     , 7.04465564213     , 4.43364655298     ,
 2.56615905847     , 1.35175153907     , 0.643356112031    , 0.27396021203     ,
 0.10270088833     , 0.0331684491687   , 0.00902143243575  , 0.00202593781516  ,
 0.000370007934858 , 5.43819388377e-05 , 6.38881645304e-06 , 5.9892385771e-07  ,
 4.72926093132e-08 , 6.6592391791e-09  , 4.48279077484e-09 , 3.69672646441e-09 ,
 2.45407668685e-09 , 1.27862246682e-09 , 5.21683231223e-10 , 1.66502410413e-10 ,
 4.15345795532e-11 , 8.0921786432e-12  , 1.23064901646e-12 , 1.46019525595e-13 ,
 1.35123503518e-14 , 9.74905871725e-16 , 5.48279510218e-17 , 2.4030702871e-18  ,
 8.2071266881e-20  , 4.81787518667e-21 , 2.40871277996e-19 , 1.04844134852e-17 ,
 3.56425526052e-16 , 9.61074753737e-15 , 2.05554416599e-13 , 3.48648943141e-12 ,
 4.68878708322e-11 , 4.99952765522e-10 , 4.22797300009e-09 , 2.83850428959e-08 ,
 1.51622899686e-07 , 6.4756299736e-07  , 2.23540514975e-06 , 6.3871016153e-06  ,
 1.58436805732e-05 , 3.68489589835e-05 , 8.68360076461e-05 , 0.000212078980939 ,
 0.000518523151052 , 0.00122018366192  , 0.00273663674424  , 0.00598517815376  ,
 0.0131374235621   , 0.0287976236581   , 0.0608446853728   , 0.120385898168    ,
 0.220895766944    , 0.374713590157    , 0.585422399076    , 0.845124714164    ,
 1.14929425767     , 1.5162421529      , 1.97565201685     , 2.52176967062     ,
 3.08080103442     , 3.53732260973     , 3.79849762405     , 3.83655564642     ,
 3.68362001204     , 3.39853463138     , 3.03374928621     , 2.62180066031     ,
 2.18678010985     , 1.76180046556     , 1.38749370954     , 1.09315233249     ,
 0.882547269642    , 0.735732717739    , 0.6208071701      , 0.508311332377    ,
 0.384812900374    , 0.258444696659    , 0.149562735873    , 0.0734779349823   ,
 0.031148558991    , 0.0132684865245   , 0.00899550263561  , 0.0104588345159   ,
 0.0127297204151   , 0.0130499512057   , 0.00308212549575  , 0.00202771999871  ,
 0.00107573748002  , 0.000462422915337 , 0.000162072406382 , 4.66105699425e-05 ,
 1.10517585374e-05 , 2.1632879556e-06  , 3.48499129344e-07 , 4.59070261453e-08 ,
 5.17334854539e-09 , 4.26284327181e-09 , 4.16343547777e-08 , 3.51438893632e-07 ,
 2.31742257139e-06 , 1.19368393825e-05 , 4.8064273786e-05  , 0.000151422692115 ,
 0.000373637749773 , 0.000722980153128 , 0.00109851077557  , 0.00131255053714  ,
 0.00123512063792  , 0.000916659923601 , 0.000537233560643 , 0.000248885223596 ,
 9.11952279873e-05 , 2.64397461233e-05 , 6.1659327255e-06  , 2.26558077288e-06 ,
 1.00198442832e-05 , 6.49920985648e-05 , 0.000334267480073 , 0.0013438769747   ,
 0.00422576963429  , 0.0104030325993   , 0.0200733783603   , 0.0303984782399   ,
 0.0361804921943   , 0.0338975278268   , 0.0250556714961   , 0.0147447603799   ,
 0.00745999792102  , 0.00533969412563  , 0.0101709175207   , 0.0269118669407   ,
 0.068093945136    , 0.163282090465    , 0.381898464207    , 0.87668353779     ,
 1.94126971843     , 4.04400806001     , 7.77660616048     , 13.6925719555     ,
 22.0929585234     , 32.8497987728     , 45.3284122279     , 58.4421721519     ,
 70.831431402      , 81.1296626845     , 88.2991353721     , 91.9163050667     ,
 92.1668622006     , 89.59121534       , 84.961385059      , 79.3579639953     ,
 74.0481331377     , 70.0497926379     , 67.8237755889     , 67.3930886214     ,
 68.6219641233     , 71.2835834287     , 74.9229927459     , 78.7737559723     ,
 81.8975022879     , 83.5128215779     , 83.3183252667     , 81.5291287458     ,
 78.4874799676     , 74.1427769119     , 67.993497695      , 59.6816466098     ,
 49.6433457805     , 39.0933548235     , 29.3723628094     , 21.3068853352     ,
 15.0483821464     , 10.3264409012     , 6.79024425523     , 4.19280177757     ,
 2.38418766764     , 1.2299849047      , 0.569399482358    , 0.234099683165    ,
 0.0843539736714   , 0.0261841284131   , 0.00686678900738  , 0.00149339251051  ,
 0.000265183046137 , 3.79979546122e-05 , 4.35741673376e-06 , 3.97802188025e-07 ,
 2.89583800986e-08 , 1.8748130479e-09  , 3.16313499262e-10 , 2.07117122371e-10 ,
 1.35947082051e-10 , 7.07967852256e-11 , 2.88847741108e-11 , 9.21897108279e-12 ,
 2.29970297059e-12 , 4.4805093646e-13  , 6.81390597751e-14 , 8.08486664331e-15 ,
 7.48157139859e-16 , 5.39789725421e-17 , 3.03573560133e-18 , 1.3305414277e-19  ,
 4.54415425114e-21 , 4.06856493064e-22 , 2.64206668877e-20 , 1.15291469563e-18 ,
 3.92627933391e-17 , 1.06059398183e-15 , 2.27259434379e-14 , 3.86198139511e-13 ,
 5.20418349785e-12 , 5.56130270626e-11 , 4.71537116251e-10 , 3.17700673418e-09 ,
 1.70690223323e-08 , 7.37217881992e-08 , 2.60734112771e-07 , 7.86093986006e-07 ,
 2.17806744607e-06 , 6.1205202074e-06  , 1.85039894035e-05 , 5.89490471941e-05 ,
 0.000187807662091 , 0.000578698655777 , 0.00170994100842  , 0.00484156623174  ,
 0.0129936067838   , 0.0324088399451   , 0.0741776068148   , 0.15594309764     ,
 0.302748111491    , 0.542076498239    , 0.889674518347    , 1.33975874741     ,
 1.88097892192     , 2.52402112175     , 3.29040750763     , 4.15361072328     ,
 5.00277944405     , 5.68538747454     , 6.0830135048      , 6.14341180212     ,
 5.87005315067     , 5.31269234776     , 4.56146528302     , 3.72722634325     ,
 2.91648240011     , 2.21319695762     , 1.6643901536      , 1.27197087934     ,
 1.00153902563     , 0.805374442738    , 0.643389721075    , 0.492756808904    ,
 0.348920148192    , 0.221000605386    , 0.121821034454    , 0.0572911022361   ,
 0.0228802813329   , 0.0082682930668   , 0.00379050849271  , 0.00331915775096  ,
 0.00375686098469  , 0.0037714370656   , 0.000697177692358 , 0.000451910755793 ,
 0.00023576525446  , 9.93600602476e-05 , 3.40198920528e-05 , 9.52566994579e-06 ,
 2.19416366197e-06 , 4.17159110373e-07 , 6.54122874803e-08 , 8.42051223111e-09 ,
 9.50032534137e-10 , 1.02499621014e-09 , 1.02948653699e-08 , 8.69169780662e-08 ,
 5.73139827512e-07 , 2.95219275377e-06 , 1.18871500443e-05 , 3.74495258014e-05 ,
 9.24072631063e-05 , 0.000178805854792 , 0.000271681258986 , 0.000324617100118 ,
 0.000305467308443 , 0.000226706307899 , 0.000132867418104 , 6.15537540829e-05 ,
 2.25544361162e-05 , 6.54317860984e-06 , 1.58264131071e-06 , 1.18452535318e-06 ,
 7.74656066964e-06 , 5.07805910425e-05 , 0.000261222509698 , 0.00105021290177  ,
 0.00330235438865  , 0.00812976170796  , 0.0156869426542   , 0.0237557935186   ,
 0.0282742440827   , 0.0264895335384   , 0.0195758167959   , 0.0114977971718   ,
 0.00572486434428  , 0.00382672918551  , 0.00706205660416  , 0.0192709394368   ,
 0.0504250894268   , 0.12364686241     , 0.29235793605     , 0.675591716345    ,
 1.51086052054     , 3.19908321343     , 6.29194322023     , 11.3863802194     ,
 18.941726044      , 29.0738300197     , 41.4003126303     , 55.0131687257     ,
 68.5998136854     , 80.6876696144     , 89.9976324406     , 95.7856619091     ,
 97.9301920764     , 96.7759290015     , 93.0570641255     , 87.9470259106     ,
 82.8684921584     , 78.9852249962     , 76.8438009236     , 76.4901966631     ,
 77.7866484006     , 80.4996587328     , 84.1367723525     , 87.8567203046     ,
 90.6774656623     , 91.8688291605     , 91.2270055556     , 88.9983862731     ,
 85.4558407999     , 80.4507859591     , 73.4330910919     , 64.0646189064     ,
 52.8542603502     , 41.1238205353     , 30.3363934301     , 21.4334476479     ,
 14.643887164      , 9.70393443941     , 6.18843600411     , 3.73165017725     ,
 2.08124825225     , 1.05161206811     , 0.47356290553     , 0.187692826955    ,
 0.0647393550969   , 0.0191890483056   , 0.00481577177836  , 0.0010072177131   ,
 0.000172957355456 , 2.40793882838e-05 , 2.69164425629e-06 , 2.39886825008e-07 ,
 1.69700779265e-08 , 9.58536135441e-10 , 5.2359225678e-11  , 1.03098289075e-11 ,
 5.92182838638e-12 , 3.06552586668e-12 , 1.25040871581e-12 , 3.9908389689e-13  ,
 9.95528042066e-14 , 1.93958644757e-14 , 2.94970027146e-15 , 3.49989175242e-16 ,
 3.23872874944e-17 , 2.33671832992e-18 , 1.31415228752e-19 , 5.759836463e-21   ,
 1.96713794883e-22 , 2.97556571012e-23 , 2.28755175037e-21 , 1.00046859976e-19 ,
 3.41251943722e-18 , 9.23308412296e-17 , 1.9817410094e-15  , 3.37353563503e-14 ,
 4.55440759526e-13 , 4.8773181592e-12  , 4.14707682915e-11 , 2.80696986055e-10 ,
 1.52249817857e-09 , 6.73396595768e-09 , 2.54302085666e-08 , 9.13549843641e-08 ,
 3.68198360829e-07 , 1.77870454329e-06 , 9.19547587439e-06 , 4.47888132549e-05 ,
 0.000193436227066 , 0.000728997035295 , 0.00241247830491  , 0.00712593778217  ,
 0.0191154327231   , 0.0471865638114   , 0.108180371102    , 0.231617698258    ,
 0.462314485682    , 0.851656268566    , 1.43224489666     , 2.19725745765     ,
 3.11993772617     , 4.19832493798     , 5.45004071133     , 6.83387119439     ,
 8.19381426877     , 9.30872420366     , 9.98658410693     , 10.1048074634     ,
 9.61324582786     , 8.56087229641     , 7.12065951118     , 5.55087619681     ,
 4.10310792466     , 2.94115686384     , 2.1113456957      , 1.5635786839      ,
 1.20232129966     , 0.938229899792    , 0.716136648978    , 0.516156730414    ,
 0.341090478787    , 0.201638944731    , 0.104454420893    , 0.0466129282864   ,
 0.0177092540727   , 0.00579441162507  , 0.00188646633763  , 0.00098590152458  ,
 0.000905156532864 , 0.000867949703814 , 0.000125588822059 , 8.00137474644e-05 ,
 4.11052098459e-05 , 1.70182115209e-05 , 5.70456218452e-06 , 1.55801453977e-06 ,
 3.48995976821e-07 , 6.44387040768e-08 , 9.82250004613e-09 , 1.23322077286e-09 ,
 1.39689802366e-10 , 1.94425802762e-10 , 1.99165860567e-09 , 1.68173561488e-08 ,
 1.10895538515e-07 , 5.71213151479e-07 , 2.30001798848e-06 , 7.24602471431e-06 ,
 1.78796739857e-05 , 3.45967436212e-05 , 5.25669971754e-05 , 6.28094342934e-05 ,
 5.91041840726e-05 , 4.38648948148e-05 , 2.57082188048e-05 , 1.19099041173e-05 ,
 4.36415243046e-06 , 1.26860854267e-06 , 3.42063179695e-07 , 6.16953157621e-07 ,
 4.77168064077e-06 , 3.13856013673e-05 , 0.000161461327842 , 0.000649136016211 ,
 0.00204118346374  , 0.00502500131105  , 0.00969609059492  , 0.0146834406623   ,
 0.0174762694972   , 0.0163729666811   , 0.0120986684668   , 0.0071027352576   ,
 0.00353586777712  , 0.00243727400239  , 0.00491540420093  , 0.0143706322503   ,
 0.0392777163648   , 0.0982410829522   , 0.232672492328    , 0.535186691715    ,
 1.19591797346     , 2.54962916809     , 5.08717117087     , 9.39829798072     ,
 16.0371183685     , 25.3296478428     , 37.1788643312     , 50.9449008221     ,
 65.4523137419     , 79.1643598495     , 90.5549413264     , 98.5405190149     ,
 102.684293842     , 103.137123663     , 100.597070249     , 96.3278389162     ,
 91.8933303937     , 88.5563545389     , 86.8587374959     , 86.769106307      ,
 88.10431119       , 90.6746796165     , 94.0608555039     , 97.4425693053     ,
 99.8236974916     , 100.490538095     , 99.268255265      , 96.3625730976     ,
 91.9413571701     , 85.8066571733     , 77.4938892621     , 66.8250429715     ,
 54.434062548      , 41.6983274452     , 30.109705493      , 20.6500741062     ,
 13.5851517389     , 8.63893692738     , 5.30585731898     , 3.10519979732     ,
 1.6909261142      , 0.834374797075    , 0.364848596375    , 0.139169077466    ,
 0.0458134232918   , 0.0128996257562   , 0.00307605476143  , 0.000613929667414 ,
 0.000101241234179 , 1.36242607557e-05 , 1.48017549014e-06 , 1.28718559443e-07 ,
 8.90287886643e-09 , 4.87830635484e-10 , 2.14244754283e-11 , 1.01663347518e-12 ,
 2.18075444571e-13 , 1.04035264152e-13 , 4.22891173601e-14 , 1.34968202481e-14 ,
 3.36682665987e-15 , 6.55958555147e-16 , 9.97574060492e-17 , 1.18364610145e-17 ,
 1.09532206396e-18 , 7.90266595954e-20 , 4.4443981182e-21  , 1.9479482386e-22  ,
 6.6527633677e-24  , 1.83625797106e-24 , 1.56124425535e-22 , 6.84169457565e-21 ,
 2.33691397794e-19 , 6.33190102831e-18 , 1.3610723415e-16  , 2.32055396794e-15 ,
 3.13886884879e-14 , 3.37133272492e-13 , 2.88627394434e-12 , 1.99728739836e-11 ,
 1.17448258595e-10 , 6.80617260123e-10 , 4.87578589328e-09 , 4.3173944517e-08  ,
 3.7995455762e-07  , 2.9015377504e-06  , 1.84539678142e-05 , 9.70775920413e-05 ,
 0.00042396711173  , 0.00155234866027  , 0.00484860468451  , 0.0132721670769   ,
 0.0329791793543   , 0.0770049233392   , 0.172479492187    , 0.370340729472    ,
 0.74925197394     , 1.39739954006     , 2.36673888925     , 3.63682581604     ,
 5.1463855949      , 6.8740799628      , 8.85012188518     , 11.0435013346     ,
 13.2514489873     , 15.131027703      , 16.3248400319     , 16.5554455487     ,
 15.685293327      , 13.79500688       , 11.2268113157     , 8.49133649351     ,
 6.06170994159     , 4.20261139824     , 2.93770825053     , 2.13188441321     ,
 1.60589536447     , 1.21938774804     , 0.898487957635    , 0.621686164316    ,
 0.393441054619    , 0.222876135275    , 0.111059733867    , 0.0479983229867   ,
 0.0177728803053   , 0.00559125687517  , 0.00152526658187  , 0.0004338369908   ,
 0.000209442613576 , 0.000163350180518 , 1.88748206802e-05 , 1.13139374865e-05 ,
 5.69603329696e-06 , 2.31951594884e-06 , 7.62845398865e-07 , 2.03662388768e-07 ,
 4.44350657733e-08 , 7.97223079973e-09 , 1.18050378615e-09 , 1.4431075052e-10  ,
 1.6462212544e-11  , 2.89957658701e-11 , 3.01193036168e-10 , 2.54348071665e-09 ,
 1.67720081727e-08 , 8.63911371998e-08 , 3.47858184105e-07 , 1.09589968936e-06 ,
 2.70414881805e-06 , 5.23246360344e-06 , 7.95031181184e-06 , 9.49939342533e-06 ,
 8.93900580237e-06 , 6.63419274942e-06 , 3.88814983188e-06 , 1.8012749569e-06  ,
 6.60112288939e-07 , 1.93135028161e-07 , 6.9335310114e-08  , 2.83732536313e-07 ,
 2.32890285368e-06 , 1.53346586117e-05 , 7.88896650712e-05 , 0.000317166591586 ,
 0.000997318265009 , 0.00245520585141  , 0.00473749093044  , 0.00717429989608  ,
 0.00853886637533  , 0.00799978518408  , 0.00591159892046  , 0.00347426134336  ,
 0.00176289314319  , 0.00141192905405  , 0.0034416581497   , 0.0108669862247   ,
 0.0308473687378   , 0.0784559553242   , 0.186338520427    , 0.427479257726    ,
 0.954065539448    , 2.04172080499     , 4.11559524605     , 7.73222171221     ,
 13.494250929      , 21.8883677889     , 33.0735981086     , 46.683335771      ,
 61.7199080102     , 76.6512346996     , 89.7862942064     , 99.7754845138     ,
 105.910004523     , 108.14821811      , 107.117426766     , 104.119943641     ,
 100.801087027     , 98.4426864792     , 97.4802368853     , 97.7238640563     ,
 98.9420288278     , 101.077758935     , 103.915786789     , 106.749288285     ,
 108.564685776     , 108.574612774     , 106.525554318     , 102.534231624     ,
 96.7128295881     , 88.9474570995     , 79.0158512071     , 67.0004631469     ,
 53.6589361125     , 40.339848772      , 28.4500892318     , 18.9114916665     ,
 11.9581690743     , 7.27260184137     , 4.27840186239     , 2.41412849865     ,
 1.2752578363      , 0.611239243711    , 0.2585661617      , 0.0946993216519   ,
 0.0296887285101   , 0.00791246357191  , 0.0017820550659   , 0.000336663599721 ,
 5.28437704428e-05 , 6.81721502761e-06 , 7.15095350983e-07 , 6.04107651025e-08 ,
 4.07816682547e-09 , 2.18684239579e-10 , 9.2817432878e-12  , 3.17728153725e-13 ,
 1.33523019567e-14 , 2.8954570111e-15  , 1.11680034128e-15 , 3.56376481604e-16 ,
 8.88992975498e-17 , 1.73202426693e-17 , 2.63404214683e-18 , 3.12535564187e-19 ,
 2.89214063907e-20 , 2.08665762615e-21 , 1.1735200848e-22  , 5.14345547213e-24 ,
 1.7566273821e-25  , 9.31376216991e-26 , 8.38686379766e-24 , 3.68158118818e-22 ,
 1.25903614898e-20 , 3.41557382287e-19 , 7.35158875847e-18 , 1.25514575832e-16 ,
 1.71786416775e-15 , 1.92296810754e-14 , 1.93300661129e-13 , 2.19112492169e-12 ,
 3.27579652701e-11 , 5.34851323068e-10 , 7.72797509869e-09 , 9.15514397785e-08 ,
 8.75094667368e-07 , 6.75259631894e-06 , 4.2263048126e-05  , 0.000215830189725 ,
 0.000905807476828 , 0.00315598282433  , 0.00928417869677  , 0.0237406022024   ,
 0.0551753942093   , 0.122691137038    , 0.269568950907    , 0.581262259783    ,
 1.19020321235     , 2.24041642067     , 3.80896606113     , 5.84745146909     ,
 8.23467872146     , 10.9163266448     , 13.9504883159     , 17.3467532034     ,
 20.8540915402     , 23.933057638      , 25.9285111332     , 26.2920808408     ,
 24.771146572      , 21.5542968041     , 17.2913618162     , 12.8772500413     ,
 9.07571654044     , 6.24857781991     , 4.35547897931     , 3.13866418841     ,
 2.31888765386     , 1.70556134927     , 1.21115910971     , 0.811112693005    ,
 0.502257477236    , 0.28199205031     , 0.14086137555     , 0.0615341340437   ,
 0.0231333524869   , 0.00736873460792  , 0.00196441636825  , 0.000443158340069 ,
 9.7423642224e-05  , 3.28981006609e-05 , 3.75866840004e-06 , 1.4017580177e-06  ,
 6.34999957476e-07 , 2.51537330352e-07 , 8.12065076906e-08 , 2.12383397893e-08 ,
 4.52245938713e-09 , 7.89345287701e-10 , 1.13538247253e-10 , 1.34973894481e-11 ,
 1.55543171419e-12 , 3.39140295961e-12 , 3.55785454762e-11 , 3.00469328338e-10 ,
 1.98133059305e-09 , 1.02056594421e-08 , 4.10935921931e-08 , 1.29462111219e-07 ,
 3.19449689087e-07 , 6.18127545392e-07 , 9.39195586974e-07 , 1.12219351834e-06 ,
 1.05599314849e-06 , 7.83718262829e-07 , 4.59319530947e-07 , 2.12791543169e-07 ,
 7.80088091279e-08 , 2.33076127755e-08 , 1.50155953103e-08 , 1.07354388488e-07 ,
 8.98317837272e-07 , 5.91693897515e-06 , 3.0440063829e-05  , 0.000122380697508 ,
 0.000384821441933 , 0.000947356414286 , 0.0018279902691   , 0.00276824812939  ,
 0.00329477624793  , 0.00308680627188  , 0.00228157364067  , 0.00134590026983  ,
 0.000719242310448 , 0.00076517177235  , 0.00231160588009  , 0.00775380207929  ,
 0.0227294344795   , 0.0592401785107   , 0.143577203644    , 0.334666675328    ,
 0.755521824194    , 1.63243193485     , 3.32997247408     , 6.36288462144     ,
 11.3520115683     , 18.8910128622     , 29.3279865889     , 42.5166937267     ,
 57.6373214592     , 73.237883594      , 87.595101195      , 99.235009049      ,
 107.274910171     , 111.495628122     , 112.378114224     , 111.132119544     ,
 109.349866496     , 108.23127004      , 108.059473782     , 108.504943902     ,
 109.353055091     , 110.749928122     , 112.733021992     , 114.731358831     ,
 115.702603965     , 114.736840175     , 111.451833965     , 105.891898072     ,
 98.2250137174     , 88.5720684721     , 77.0515166003     , 64.0067940766     ,
 50.2443238136     , 36.9805982902     , 25.4353446107     , 16.381150316      ,
 9.95802304197     , 5.78817947225     , 3.25201595512     , 1.75985218011     ,
 0.895962053037    , 0.414517381228    , 0.168793647062    , 0.0591701887074   ,
 0.0176330516505   , 0.00443924232942  , 0.000940722476863 , 0.000167132397848 ,
 2.47473759703e-05 , 3.02937716905e-06 , 3.03710762632e-07 , 2.4702681915e-08  ,
 1.616164556e-09   , 8.44434395028e-11 , 3.50362499267e-12 , 1.14989460244e-13 ,
 3.04611972328e-15 , 1.10176576254e-16 , 2.24497108232e-17 , 7.15510338619e-18 ,
 1.78486431559e-18 , 3.4774496458e-19  , 5.28846454719e-20 , 6.27489295465e-21 ,
 5.80665850531e-22 , 4.18946025267e-23 , 2.35611999274e-24 , 1.03267071665e-25 ,
 3.52684623671e-27 , 3.80463298246e-27 , 3.54086183352e-25 , 1.55658464311e-23 ,
 5.32870174155e-22 , 1.44710033127e-20 , 3.11832957924e-19 , 5.33073573304e-18 ,
 1.08835657958e-16 , 2.72560445653e-15 , 8.22700530194e-14 , 2.34026998321e-12 ,
 5.50601708178e-11 , 1.03421048226e-09 , 1.54206758214e-08 , 1.82856361068e-07 ,
 1.73123523086e-06 , 1.31507215496e-05 , 8.05804673238e-05 , 0.000400660997848 ,
 0.00162804381352  , 0.00546049019922  , 0.0153738421897   , 0.0374612527379   ,
 0.0831306145847   , 0.179078617258    , 0.390130464838    , 0.848530887138    ,
 1.76020996039     , 3.34781897641     , 5.73066969492     , 8.834793729       ,
 12.4637188669     , 16.5076576817     , 21.0432883252     , 26.1271783813     ,
 31.4437642696     , 36.1713219734     , 39.2151072226     , 39.6439592982     ,
 37.0921527143     , 31.9772747568     , 25.4242508921     , 18.8358266195     ,
 13.2999037704     , 9.2394057556      , 6.49973838896     , 4.67438097937     ,
 3.38465282614     , 2.4020445692      , 1.63519804402     , 1.05542369297     ,
 0.639842241093    , 0.358804185668    , 0.182081525628    , 0.0816098511889   ,
 0.0315609410783   , 0.0103115254037   , 0.0027949052931   , 0.000620123099052 ,
 0.000112846121058 , 1.82431386701e-05 , 2.56290900676e-06 , 3.2264915104e-07  ,
 6.91418006524e-08 , 2.23380965622e-08 , 6.89536421518e-09 , 1.76395651193e-09 ,
 3.6726182296e-10  , 6.2464628851e-11  , 8.73301809231e-12 , 1.00892025409e-12 ,
 1.17783885144e-13 , 3.10522461653e-13 , 3.28080997326e-12 , 2.77085073838e-11 ,
 1.82713257227e-10 , 9.41139903125e-10 , 3.78954633902e-09 , 1.19386659435e-08 ,
 2.94588361633e-08 , 5.70021468476e-08 , 8.66102233534e-08 , 1.03485826187e-07 ,
 9.73809968082e-08 , 7.22725011138e-08 , 4.23572891406e-08 , 1.9623464034e-08  ,
 7.2022258874e-09  , 2.29976781444e-09 , 3.47114337662e-09 , 3.24727843857e-08 ,
 2.73361413313e-07 , 1.80073031396e-06 , 9.26398628365e-06 , 3.72447687234e-05 ,
 0.000117114756685 , 0.000288314017543 , 0.000556322006572 , 0.000842475789215 ,
 0.00100271918597  , 0.000939461869118 , 0.000694806037079 , 0.000413589850942 ,
 0.000246843546035 , 0.000387884520952 , 0.00139550401465  , 0.00491170057633  ,
 0.0149832880733   , 0.0408756143245   , 0.103990789806    , 0.252823092134    ,
 0.588041114135    , 1.29647679186     , 2.69107286471     , 5.24369633757     ,
 9.57104143863     , 16.3227105514     , 25.9620696818     , 38.4963724004     ,
 53.268353243      , 68.9680550186     , 83.9657787149     , 96.8143367256     ,
 106.58245645      , 112.914049184     , 116.063677721     , 116.973021621     ,
 116.991620838     , 117.127623368     , 117.535732229     , 117.872233985     ,
 118.053518303     , 118.43577971      , 119.231918538     , 119.95343427      ,
 119.560348744     , 117.095998145     , 112.117555286     , 104.668876517     ,
 95.0689781605     , 83.7451960359     , 71.1410246212     , 57.7647623431     ,
 44.3569691598     , 31.9100003275     , 21.3856153911     , 13.3496471683     ,
 7.81446642167     , 4.34861397325     , 2.33327301254     , 1.20766569135     ,
 0.589697499748    , 0.261873270694    , 0.102129836224    , 0.0341380093215   ,
 0.00964842398621  , 0.00229147219067  , 0.00045613861271  , 7.59556292838e-05 ,
 1.054588379e-05   , 1.2143049786e-06  , 1.15121093086e-07 , 8.91259246663e-09 ,
 5.58871814544e-10 , 2.81721437628e-11 , 1.13423757461e-12 , 3.62224875555e-14 ,
 9.03140823677e-16 , 1.58795457424e-17 , 3.7372715768e-21  , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 1.22285271425e-28 , 1.17322272387e-26 , 5.16381040829e-25 ,
 1.76925332453e-23 , 4.80887368579e-22 , 1.03735755352e-20 , 1.77552776829e-19 ,
 6.19653096667e-17 , 3.19976245218e-15 , 1.23222397305e-13 , 3.73084536109e-12 ,
 8.89289461592e-11 , 1.67144011685e-09 , 2.48372987087e-08 , 2.92760282049e-07 ,
 2.74772674294e-06 , 2.06238185282e-05 , 0.00012439898868  , 0.00060640952801  ,
 0.00240602677089  , 0.00785118015634  , 0.0214495726664   , 0.0507087219447   ,
 0.109765586205    , 0.233746649668    , 0.511439318544    , 1.12665543173     ,
 2.36797766805     , 4.55459658735     , 7.87808329408     , 12.2735543163     ,
 17.4864431888     , 23.3335627293     , 29.8681602609     , 37.1515334151     ,
 44.7552557318     , 51.4931454082     , 55.7268706279     , 56.0848299864     ,
 52.1335856886     , 44.6492381603     , 35.3655444336     , 26.2586039953     ,
 18.7254773722     , 13.1994710551     , 9.37986116136     , 6.71778598239     ,
 4.76098232734     , 3.26206940307     , 2.12867449805     , 1.31915295133     ,
 0.776978438242    , 0.431255273564    , 0.220453749906    , 0.1006073514      ,
 0.0397433317162   , 0.0132394149014   , 0.00364342279572  , 0.000815544256663 ,
 0.000146906790055 , 2.125371491e-05   , 2.79171566829e-06 , 2.56784386941e-07 ,
 2.12639359177e-08 , 2.42715967905e-09 , 5.01040399232e-10 , 1.17593750679e-10 ,
 2.37754520146e-11 , 3.94427074982e-12 , 5.36580319701e-13 , 6.02431035989e-14 ,
 7.14052587401e-15 , 2.22277548426e-14 , 2.36053468671e-13 , 1.99368627837e-12 ,
 1.31466118295e-11 , 6.77170402867e-11 , 2.72666009865e-10 , 8.59012693e-10    ,
 2.1196266237e-09  , 4.10142706916e-09 , 6.23179185649e-09 , 7.44602777736e-09 ,
 7.00677217462e-09 , 5.20016198388e-09 , 3.04770110008e-09 , 1.41203955224e-09 ,
 5.20249838971e-10 , 2.01669345616e-10 , 7.51894157807e-10 , 7.76902175127e-09 ,
 6.5521004168e-08  , 4.31623933073e-07 , 2.22052146903e-06 , 8.92734582986e-06 ,
 2.80716989463e-05 , 6.91071265585e-05 , 0.000133347023783 , 0.00020193643061  ,
 0.000240347230541 , 0.000225205365604 , 0.000166790840707 , 0.000101356536209 ,
 7.47879230752e-05 , 0.000181108025531 , 0.000741517246458 , 0.00276041767668  ,
 0.0089685997365   , 0.0263323937348   , 0.0720405539483   , 0.185725376303    ,
 0.449860500465    , 1.01990820498     , 2.16627913563     , 4.31833395086     ,
 8.06808169462     , 14.0750687561     , 22.8582020672     , 34.5321116549     ,
 48.5961091109     , 63.9221361415     , 79.0473681246     , 92.6444107514     ,
 103.826965126     , 112.157362552     , 117.636851396     , 120.81875291      ,
 122.648624274     , 123.844724331     , 124.474963459     , 124.319177659     ,
 123.51457227      , 122.575288683     , 121.764001062     , 120.63280886      ,
 118.255484471     , 113.811554206     , 106.934556782     , 97.7242534553     ,
 86.6474473547     , 74.378248856      , 61.5719438329     , 48.7766802779     ,
 36.5755735137     , 25.6822034922     , 16.7632236099     , 10.1536805625     ,
 5.73973434587     , 3.0694333249      , 1.57723068291     , 0.780986967693    ,
 0.364908403103    , 0.154960858568    , 0.0576479842868   , 0.0183082891143   ,
 0.00489359356897  , 0.00109419118045  , 0.000204312960789 , 3.18418292318e-05 ,
 4.1354513514e-06  , 4.45969961654e-07 , 3.97111960794e-08 , 2.89975191255e-09 ,
 1.72384911334e-10 , 8.28528360936e-12 , 3.19887545988e-13 , 9.8325900517e-15  ,
 2.35820797516e-16 , 3.6926163249e-18  , 3.46395114396e-22 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 3.1614367722e-30  , 3.0468631087e-28  , 1.34237591517e-26 ,
 4.60255592948e-25 , 1.25187581398e-23 , 2.70330207479e-22 , 4.63295485566e-21 ,
 7.69055051563e-17 , 4.09578168535e-15 , 1.58487088902e-13 , 4.80114735016e-12 ,
 1.14327189182e-10 , 2.14468207294e-09 , 3.17751241042e-08 , 3.72906998448e-07 ,
 3.47830519022e-06 , 2.58858865384e-05 , 0.000154394275236 , 0.000742073683032 ,
 0.0028954135315   , 0.00927619231764  , 0.0248956299349   , 0.058083421944    ,
 0.12536426461     , 0.269802242345    , 0.601395476135    , 1.34822090657     ,
 2.87267266294     , 5.59313380015     , 9.80475808154     , 15.513230118      ,
 22.4673476114     , 30.426725879      , 39.3742622879     , 49.290482098      ,
 59.5451452602     , 68.5167810101     , 73.9912816968     , 74.1836441547     ,
 68.6694323411     , 58.6607729976     , 46.5292823194     , 34.7985976125     ,
 25.1299886132     , 17.9444827737     , 12.8129492971     , 9.0908034855      ,
 6.29619371914     , 4.17735371745     , 2.62638009024     , 1.56620368948     ,
 0.891840738046    , 0.484050372385    , 0.245387853432    , 0.112279210094    ,
 0.0447155879209   , 0.0150346828531   , 0.00417136463949  , 0.000939507790031 ,
 0.000169807401859 , 2.44378939703e-05 , 2.78005615556e-06 , 2.49673471179e-07 ,
 1.77611629807e-08 , 1.04776371133e-09 , 6.6205781921e-11  , 7.48124110161e-12 ,
 1.25585678065e-12 , 1.98943513607e-13 , 2.62942431124e-14 , 2.87087068257e-15 ,
 3.45988974508e-16 , 1.24269393822e-15 , 1.32466204314e-14 , 1.11882441278e-13 ,
 7.37766652001e-13 , 3.80017108535e-12 , 1.5301576712e-11  , 4.82064068968e-11 ,
 1.18950027542e-10 , 2.30165472251e-10 , 3.49718108217e-10 , 4.1785906975e-10  ,
 3.93208754081e-10 , 2.91824718908e-10 , 1.71032645776e-10 , 7.92582386178e-11 ,
 2.95803861935e-11 , 1.81644964754e-11 , 1.37183421487e-10 , 1.46364575707e-09 ,
 1.2350667537e-08  , 8.13615987421e-08 , 4.18570871216e-07 , 1.68281504328e-06 ,
 5.29154781161e-06 , 1.30267735599e-05 , 2.51360702079e-05 , 3.80652891676e-05 ,
 4.53064405977e-05 , 4.24618799501e-05 , 3.15607698204e-05 , 2.02156018122e-05 ,
 2.23121909053e-05 , 8.36751576637e-05 , 0.000387445462039 , 0.00156964291619  ,
 0.00555166580283  , 0.0176020247375   , 0.0510823006751   , 0.137128130677    ,
 0.341980013551    , 0.795413343614    , 1.73295307467     , 3.5415849774      ,
 6.76937370417     , 12.0470940432     , 19.9096203783     , 30.5617865571     ,
 43.669519499      , 58.3060423763     , 73.1856777308     , 87.1038483843     ,
 99.23339248       , 109.093991538     , 116.482132292     , 121.577270904     ,
 124.881891297     , 126.781669216     , 127.272483338     , 126.30519676      ,
 124.232674863     , 121.648310924     , 118.800432477     , 115.332588851     ,
 110.598339516     , 104.09574933      , 95.6320830779     , 85.3423190403     ,
 73.7268417129     , 61.5481946335     , 49.5301680567     , 38.1753924377     ,
 27.8793870432     , 19.0697328641     , 12.1155826565     , 7.13101193817     ,
 3.90736032225     , 2.01895303132     , 0.998861717373    , 0.474699039471    ,
 0.212335145654    , 0.0861088397283   , 0.0304941356348   , 0.00918086311798  ,
 0.00231511212743  , 0.000486032566949 , 8.48833515515e-05 , 1.23466179132e-05 ,
 1.49635291707e-06 , 1.5081635321e-07  , 1.25835571813e-08 , 8.63586562633e-10 ,
 4.84045091019e-11 , 2.20098093605e-12 , 8.06794235124e-14 , 2.35363011965e-15 ,
 5.35564454217e-17 , 6.85368253313e-19 , 2.50236516724e-23 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 5.84995671668e-32 , 5.74140040599e-30 , 2.53953418593e-28 ,
 8.73145058433e-27 , 2.38158685796e-25 , 5.16047866104e-24 , 8.8790540292e-23  ,
 7.84223362839e-17 , 4.17924279186e-15 , 1.61573554464e-13 , 4.89188802963e-12 ,
 1.16381348424e-10 , 2.18015122753e-09 , 3.22327610723e-08 , 3.7711755559e-07  ,
 3.50229251543e-06 , 2.59096839836e-05 , 0.000153340185262 , 0.000730019552468 ,
 0.00281823174935  , 0.00893887665505  , 0.023850618861    , 0.0558794089216   ,
 0.123043119334    , 0.273795335579    , 0.631045823263    , 1.44906804739     ,
 3.13904042941     , 6.20152761812     , 11.0492138438     , 17.8177727315     ,
 26.3492870076     , 36.4164346286     , 47.9275027226     , 60.6961241443     ,
 73.7809467789     , 85.0727002792     , 91.8207582677     , 91.9205073431     ,
 85.0242601298     , 72.7589541028     , 58.0312292656     , 43.8039952275     ,
 31.9660262462     , 22.9713497268     , 16.3438033358     , 11.4140570633     ,
 7.7072231012      , 4.96256414384     , 3.02402049154     , 1.74646832465     ,
 0.962767273948    , 0.507251888172    , 0.251369739895    , 0.113404662487    ,
 0.0448448983091   , 0.0150360140716   , 0.00416871390361  , 0.000938955754702 ,
 0.000169734405362 , 2.44193114803e-05 , 2.3665169409e-06  , 2.11741698655e-07 ,
 1.48978594698e-08 , 8.24428892626e-10 , 3.64676223425e-11 , 1.44709037258e-12 ,
 8.10799501249e-14 , 8.54258601509e-15 , 1.02563441961e-15 , 1.09048180939e-16 ,
 1.33708009988e-17 , 5.42236839622e-17 , 5.79600669855e-16 , 4.89545812869e-15 ,
 3.22812598213e-14 , 1.66277928023e-13 , 6.6952629606e-13  , 2.10928962835e-12 ,
 5.20470359726e-12 , 1.00709775873e-11 , 1.53020485449e-11 , 1.82835821766e-11 ,
 1.72049983065e-11 , 1.27689035974e-11 , 7.48368376012e-12 , 3.47047700304e-12 ,
 1.35143375041e-12 , 1.81140383007e-12 , 2.01056360215e-11 , 2.1662139471e-10  ,
 1.82821625587e-09 , 1.20436416233e-08 , 6.19594241751e-08 , 2.49100590448e-07 ,
 7.83287319895e-07 , 1.92830283739e-06 , 3.72079579287e-06 , 5.63467535469e-06 ,
 6.70689935469e-06 , 6.29124665668e-06 , 4.74542813328e-06 , 3.74450567276e-06 ,
 9.49169418512e-06 , 5.36072151941e-05 , 0.000281051699948 , 0.00123151321149  ,
 0.00455370139302  , 0.0145454623111   , 0.0413705792046   , 0.10815424761     ,
 0.266264148124    , 0.623671200736    , 1.38628525905     , 2.89803018225     ,
 5.6473984823      , 10.2078708552     , 17.106069643      , 26.6330700627     ,
 38.6326186621     , 52.3816244903     , 66.7433262123     , 80.5774069576     ,
 93.0608924377     , 103.676198263     , 112.108465089     , 118.298755491     ,
 122.407791226     , 124.529815135     , 124.584704836     , 122.643912599     ,
 119.184044014     , 114.806352922     , 109.767293457     , 103.915413885     ,
 97.0126748309     , 88.949913139      , 79.7052998097     , 69.3678757656     ,
 58.3233303811     , 47.2562073027     , 36.8440601548     , 27.5104096841     ,
 19.4830568585     , 12.9389441779     , 7.9889531249      , 4.57287494617     ,
 2.43743700981     , 1.22415113269     , 0.587087660235    , 0.269259842156    ,
 0.115666451283    , 0.0448542017996   , 0.0151300791311   , 0.00432009608791  ,
 0.00102776562301  , 0.000202363139595 , 3.29587546136e-05 , 4.45268412475e-06 ,
 5.0061902543e-07  , 4.68978906177e-08 , 3.6521247776e-09  , 2.35071973758e-10 ,
 1.24107591635e-11 , 5.33239140845e-13 , 1.84991828471e-14 , 5.06831519122e-16 ,
 1.08727672519e-17 , 1.00715278243e-19 , 1.40870062808e-24 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.9100224883e-28  , 9.27064135508e-27 ,
 6.3259490886e-17  , 3.3712337471e-15  , 1.3024014967e-13  , 3.94157462205e-12 ,
 9.37113319985e-11 , 1.75372975869e-09 , 2.58898943652e-08 , 3.02258419272e-07 ,
 2.79867114517e-06 , 2.06215874548e-05 , 0.000121434149444 , 0.000574882278903 ,
 0.0022082275018   , 0.00699276350758  , 0.0187915949133   , 0.0450792754713   ,
 0.103795167052    , 0.244280139922    , 0.590733774067    , 1.40113865697     ,
 3.10342537853     , 6.24838196576     , 11.3521537324     , 18.7066728604     ,
 28.3257616866     , 40.0977837855     , 53.9134336501     , 69.386658076      ,
 85.1937641477     , 98.7312306684     , 106.801996327     , 107.086695638     ,
 99.3232244606     , 85.4268373768     , 68.641413318      , 52.2249544219     ,
 38.2908742295     , 27.4384632257     , 19.2695417264     , 13.1548938969     ,
 8.62867913109     , 5.38921690034     , 3.19212330964     , 1.79550159523     ,
 0.963032444134    , 0.492246656157    , 0.236452149397    , 0.103734821924    ,
 0.0401203935076   , 0.0132341404404   , 0.00362684301333  , 0.000810228443078 ,
 0.000145604806053 , 2.0857439939e-05  , 1.69713040067e-06 , 1.50954126951e-07 ,
 1.05690740822e-08 , 5.81014397565e-10 , 2.5050282045e-11  , 8.5100265084e-13  ,
 2.37592179116e-14 , 6.92196839613e-16 , 3.1773987229e-17  , 3.29618178907e-18 ,
 4.11107788116e-19 , 1.84561832461e-18 , 1.97684967662e-17 , 1.66972036079e-16 ,
 1.10103446525e-15 , 5.67133162315e-15 , 2.28358971063e-14 , 7.1942687246e-14  ,
 1.77519653097e-13 , 3.43496303726e-13 , 5.21915282705e-13 , 6.23608070028e-13 ,
 5.86820229472e-13 , 4.35516196309e-13 , 2.55260010438e-13 , 1.18660700847e-13 ,
 5.27430291932e-14 , 1.80092641804e-13 , 2.3270352002e-12  , 2.51451355083e-11 ,
 2.12227407079e-10 , 1.3980802023e-09  , 7.19252932147e-09 , 2.89167196956e-08 ,
 9.09275241198e-08 , 2.23846102126e-07 , 4.319272626e-07   , 6.54112866743e-07 ,
 7.78885823161e-07 , 7.35914684048e-07 , 6.2865476484e-07  , 1.29013184192e-06 ,
 8.55926719939e-06 , 5.7877088262e-05  , 0.000318040463315 , 0.00140967822017  ,
 0.00509970493537  , 0.0153995105161   , 0.0403094934821   , 0.0965001666808   ,
 0.222904398776    , 0.508953949503    , 1.1331591864      , 2.39348828478     ,
 4.70776217737     , 8.57513531066     , 14.4974915321     , 22.8399486947     ,
 33.6137456872     , 46.2845534952     , 59.8345672044     , 73.1342930563     ,
 85.3063415974     , 95.7886948211     , 104.246892992     , 110.54989238      ,
 114.677132934     , 116.522817955     , 115.933894342     , 113.029308737     ,
 108.314340622     , 102.36314888      , 95.4932903774     , 87.8292779201     ,
 79.5443611083     , 70.8550756045     , 61.8312983813     , 52.4459944654     ,
 42.8849026508     , 33.65650148       , 25.323716355      , 18.2199846993     ,
 12.4427419327     , 7.98390110898     , 4.77448321039     , 2.65448476672     ,
 1.37838099625     , 0.675659228452    , 0.315932741298    , 0.140641206091    ,
 0.0582886688909   , 0.021693073213    , 0.00699371703776  , 0.00190104604588  ,
 0.000428454081013 , 7.94107772522e-05 , 1.20820108878e-05 , 1.51315059229e-06 ,
 1.56822322235e-07 , 1.35207607199e-08 , 9.7214937671e-10  , 5.8168967867e-11  ,
 2.87787276387e-12 , 1.16674510586e-13 , 3.83074346751e-15 , 9.77017896912e-17 ,
 1.99061848356e-18 , 1.16583971972e-20 , 6.17900588744e-26 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 3.94826286007e-30 , 1.91636115153e-28 ,
 4.02944214028e-17 , 2.14737601702e-15 , 8.29145730653e-14 , 2.50857975093e-12 ,
 5.96139874282e-11 , 1.11484354935e-09 , 1.64412669324e-08 , 1.91669344482e-07 ,
 1.77124148936e-06 , 1.30194238889e-05 , 7.64662918124e-05 , 0.000361298515244 ,
 0.00138901901419  , 0.00443436793837  , 0.0121949698054   , 0.0306721090796   ,
 0.075887794945    , 0.193027450135    , 0.496375377056    , 1.22750375433     ,
 2.80120647657     , 5.78130965986     , 10.7513981187     , 18.1443119784     ,
 28.1764783888     , 40.9303784652     , 56.3605627303     , 73.9218282256     ,
 91.9351510363     , 107.383905036     , 116.753778111     , 117.585338057     ,
 109.63421993      , 94.9096939827     , 76.7723872185     , 58.6442156994     ,
 42.8813142771     , 30.3514884869     , 20.8499256925     , 13.8189200479     ,
 8.76395753696     , 5.29225557732     , 3.04198609665     , 1.66809502477     ,
 0.87336231794     , 0.434154992415    , 0.201688100694    , 0.085335746324    ,
 0.0318883276423   , 0.0102135781498   , 0.00273393754177  , 0.000599790024443 ,
 0.000106321024358 , 1.50741617278e-05 , 1.01508097004e-06 , 8.93680103584e-08 ,
 6.20828102743e-09 , 3.39205354101e-10 , 1.45421802857e-11 , 4.88399478356e-13 ,
 1.28377410354e-14 , 2.59203493251e-16 , 7.6823705711e-19  , 7.736397503e-20   ,
 9.82230683413e-21 , 4.89647290822e-20 , 5.25475979815e-19 , 4.4384190465e-18  ,
 2.92674919699e-17 , 1.50754275241e-16 , 6.07019540823e-16 , 1.912367041e-15   ,
 4.71879417779e-15 , 9.13075442543e-15 , 1.38734543154e-14 , 1.65766329459e-14 ,
 1.55987459537e-14 , 1.15768340773e-14 , 6.78617973163e-15 , 3.18075403812e-15 ,
 2.00781671371e-15 , 1.55668870351e-14 , 2.11400398503e-13 , 2.28628698785e-12 ,
 1.929676441e-11   , 1.27120390564e-10 , 6.53980464639e-10 , 2.62925167794e-09 ,
 8.26758209311e-09 , 2.03532133757e-08 , 3.92735238248e-08 , 5.94914492241e-08 ,
 7.11947626222e-08 , 7.36820708103e-08 , 1.53199742051e-07 , 1.18859918491e-06 ,
 1.01904096438e-05 , 7.0554165468e-05  , 0.000387798794689 , 0.00169994284564  ,
 0.00600241465926  , 0.0173963692831   , 0.0428750688927   , 0.0953255457743   ,
 0.205427067491    , 0.447716728817    , 0.973047492656    , 2.02826377511     ,
 3.95361346878     , 7.16697340342     , 12.1313551008     , 19.2544962203     ,
 28.6711080509     , 40.0014861513     , 52.3372889853     , 64.5632213779     ,
 75.7500694487     , 85.3106037123     , 92.9567786392     , 98.5955121062     ,
 102.139500993     , 103.359465834     , 102.046681932     , 98.3372635524     ,
 92.7340349943     , 85.793824161      , 77.9220211028     , 69.4843708388     ,
 60.9338881285     , 52.6517895665     , 44.7063941764     , 36.945418224      ,
 29.3671175182     , 22.2896203844     , 16.1315426076     , 11.1288490774     ,
 7.28659564342     , 4.49081189388     , 2.58662701915     , 1.39026287422     ,
 0.701196326922    , 0.335276299953    , 0.153102990334    , 0.0663546383656   ,
 0.0266309052648   , 0.00955186397074  , 0.00295799117039  , 0.000770236735152 ,
 0.000165732220083 , 2.91764048871e-05 , 4.18511884862e-06 , 4.89412259745e-07 ,
 4.68625974355e-08 , 3.6996777369e-09  , 2.4256969375e-10  , 1.32690070325e-11 ,
 6.05233411755e-13 , 2.28749486395e-14 , 7.04442868157e-16 , 1.63526174905e-17 ,
 3.21582911238e-19 , 1.05952560135e-21 , 2.11156998119e-27 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.0241115966e-17  , 1.07869242127e-15 ,
 4.16338750307e-14 , 1.25937687853e-12 , 2.9918173538e-11  , 5.59232006227e-10 ,
 8.24173706754e-09 , 9.59942104555e-08 , 8.86141586954e-07 , 6.50694822332e-06 ,
 3.8206733946e-05  , 0.00018090988392  , 0.00070119738581  , 0.00228643352069  ,
 0.00657779028771  , 0.0178799075391   , 0.0489513926891   , 0.137122964776    ,
 0.379091957367    , 0.986089551509    , 2.33667797235     , 4.97365703713     ,
 9.50562093001     , 16.4658413024     , 26.2520978644     , 39.152969197      ,
 55.2325715025     , 73.8645898331     , 93.1396993513     , 109.804287226     ,
 120.194792173     , 121.769634321     , 114.206669763     , 99.4224861239     ,
 80.7172888875     , 61.5739476413     , 44.5787517748     , 30.916413076      ,
 20.6188459878     , 13.1879250781     , 8.04815093445     , 4.6763246286      ,
 2.59416293958     , 1.37996903631     , 0.703556972203    , 0.340191304413    ,
 0.152858129771    , 0.0621860657198   , 0.0222906307463   , 0.00686262283642  ,
 0.00177462757801  , 0.000378424863989 , 6.55869709446e-05 , 9.13780652292e-06 ,
 5.02990626754e-07 , 4.36013034414e-08 , 2.99281113234e-09 , 1.62015515599e-10 ,
 6.89629482812e-12 , 2.30257176496e-13 , 6.00502243177e-15 , 1.17232455908e-16 ,
 1.16221000006e-20 , 1.05324671093e-21 , 1.46148541164e-22 , 1.00251439267e-21 ,
 1.080840282e-20   , 9.12954929489e-20 , 6.02014040449e-19 , 3.10092134128e-18 ,
 1.24860130548e-17 , 3.93361963391e-17 , 9.70626507791e-17 , 1.8781391914e-16  ,
 2.85368295497e-16 , 3.4097099261e-16  , 3.20856503088e-16 , 2.38129972962e-16 ,
 1.39652225654e-16 , 6.73226884544e-17 , 8.45952245518e-17 , 1.09059678345e-15 ,
 1.50358464682e-14 , 1.62653233094e-13 , 1.37283483134e-12 , 9.04376032915e-12 ,
 4.65263091402e-11 , 1.87053563586e-10 , 5.88183134306e-10 , 1.448009396e-09   ,
 2.79462392317e-09 , 4.24949685073e-09 , 5.46049730026e-09 , 1.24102917976e-08 ,
 1.12745413592e-07 , 1.22054570354e-06 , 1.06920499091e-05 , 7.39935162135e-05 ,
 0.000405477288966 , 0.00176962201067  , 0.00621281933376  , 0.0178747834778   ,
 0.0436162660643   , 0.0955208049524   , 0.201079865767    , 0.42425442674     ,
 0.888203781963    , 1.78527960995     , 3.37708356854     , 6.00046568838     ,
 10.0646412858     , 15.9719996305     , 23.910070919      , 33.603879881      ,
 44.2631196704     , 54.8472574045     , 64.4501064095     , 72.5196308525     ,
 78.8539087488     , 83.4253003622     , 86.1100379331     , 86.5922447051     ,
 84.6364815022     , 80.4121408739     , 74.4409263174     , 67.2886845604     ,
 59.429682168      , 51.3530748588     , 43.5971016394     , 36.5371874914     ,
 30.1812354425     , 24.2984204458     , 18.7743473699     , 13.7755472087     ,
 9.57664408704     , 6.31805830413     , 3.95027817053     , 2.32583683338     ,
 1.28108929615     , 0.659814348028    , 0.320235577703    , 0.148179684789    ,
 0.0657435518654   , 0.0276839081502   , 0.0107656649103   , 0.00373129085369  ,
 0.00111488219414  , 0.000279876735233 , 5.79892854876e-05 , 9.80518845929e-06 ,
 1.34435481545e-06 , 1.49095251597e-07 , 1.33903562603e-08 , 9.78263093247e-10 ,
 5.85683936553e-11 , 2.89878772356e-12 , 1.19470101939e-13 , 4.10853312123e-15 ,
 1.15384746921e-16 , 2.288623578e-18   , 4.41090755082e-20 , 7.54289590164e-23 ,
 5.62139534972e-29 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 8.00696021784e-18 , 4.26708058928e-16 , 1.64645347465e-14 , 4.97967260765e-13 ,
 1.18273546117e-11 , 2.2101051607e-10  , 3.25590985745e-09 , 3.79071639029e-08 ,
 3.4984913293e-07  , 2.57024096256e-06 , 1.5130306008e-05  , 7.2188377976e-05  ,
 0.000285112723478 , 0.000968705216481 , 0.00301032370476  , 0.00918505916393  ,
 0.0286187572445   , 0.0894725050017   , 0.267882384356    , 0.737846545931    ,
 1.82660417279     , 4.02932717194     , 7.94303177508     , 14.1586604242     ,
 23.2069935538     , 35.5338630709     , 51.2914418066     , 69.8247348213     ,
 89.1468256266     , 105.987358917     , 116.73333422      , 118.853867783     ,
 111.918812713     , 97.6563042067     , 79.2022390323     , 59.9981018764     ,
 42.7564199442     , 28.8908924629     , 18.6110459477     , 11.4384126394     ,
 6.69201316493     , 3.7237495025      , 1.97861347859     , 1.01070885113     ,
 0.496959505437    , 0.232358087574    , 0.100788360245    , 0.0393964293351   ,
 0.0135119576257   , 0.00397638973294  , 0.000985466448502 , 0.000202425112094 ,
 3.40025204498e-05 , 4.61914627237e-06 , 2.05857252132e-07 , 1.7463894189e-08  ,
 1.17853358539e-09 , 6.29593156709e-11 , 2.65244415056e-12 , 8.78506953876e-14 ,
 2.27268788821e-15 , 4.3484793452e-17  , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 2.77833312549e-24 , 1.34738479042e-22 , 5.0653060735e-21  ,
 1.48378244679e-19 , 3.38725217558e-18 , 6.02721519443e-17 , 8.36137851197e-16 ,
 9.04601697221e-15 , 7.63508252373e-14 , 5.02972803974e-13 , 2.58758163936e-12 ,
 1.04030682014e-11 , 3.2712328238e-11  , 8.05445966019e-11 , 1.55913596191e-10 ,
 2.50828029218e-10 , 6.39144507039e-10 , 6.76786884014e-09 , 9.25634541916e-08 ,
 1.02978853995e-06 , 9.03293311385e-06 , 6.25664828938e-05 , 0.00034383356028  ,
 0.00151057407625  , 0.00537321311076  , 0.0158172889842   , 0.0399568637653   ,
 0.0911720724857   , 0.197724436329    , 0.417200361834    , 0.848230416946    ,
 1.63296394307     , 2.9623719889      , 5.09741789855     , 8.37709983401     ,
 13.1456676809     , 19.5678339539     , 27.4199308586     , 36.0417858092     ,
 44.5470112475     , 52.1569615139     , 58.4299147263     , 63.2644354498     ,
 66.6701137645     , 68.4706496583     , 68.2883063896     , 65.9011107551     ,
 61.540064802      , 55.7656943476     , 49.155836979      , 42.1965435938     ,
 35.3620621882     , 29.1074369527     , 23.6910061884     , 19.0510321397     ,
 14.9449056178     , 11.2283065108     , 7.97142353095     , 5.32898293861     ,
 3.36397995531     , 2.00697795789     , 1.12550595368     , 0.588923797311    ,
 0.287340486659    , 0.132104875228    , 0.0581696901011   , 0.0247316922539   ,
 0.0100318658865   , 0.00376590990803  , 0.00126097789987  , 0.000364369104566 ,
 8.85805185775e-05 , 1.77930656082e-05 , 2.91697842482e-06 , 3.8715684988e-07  ,
 4.14016179487e-08 , 3.55975391958e-09 , 2.46241419209e-10 , 1.37521414982e-11 ,
 6.24150290236e-13 , 2.32249827819e-14 , 7.14442985591e-16 , 1.75951715483e-17 ,
 2.60014205144e-19 , 4.96035169447e-21 , 4.19992731573e-24 , 1.16248316503e-30 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.49055804878e-18 ,
 1.32727172576e-16 , 5.12011059232e-15 , 1.54845325295e-13 , 3.67734689498e-12 ,
 6.87064394411e-11 , 1.01207338909e-09 , 1.17844278454e-08 , 1.08843115728e-07 ,
 8.01637516719e-07 , 4.75076005709e-06 , 2.30399662633e-05 , 9.44051578945e-05 ,
 0.0003453424911   , 0.00121397645847  , 0.00433488379197  , 0.0156901254822   ,
 0.0550614529454   , 0.179025644989    , 0.523661528314    , 1.35799128143     ,
 3.11249882086     , 6.34655125424     , 11.6751019993     , 19.7111183565     ,
 30.9804328636     , 45.6471830752     , 63.0205060731     , 81.1453422759     ,
 96.9349402542     , 107.040898118     , 109.10621622      , 102.684822938     ,
 89.3397020942     , 71.9879919779     , 53.8832314894     , 37.6490246019     ,
 24.7189334452     , 15.3504242101     , 9.05171856655     , 5.06946589462     ,
 2.69354806898     , 1.36083232737     , 0.658663305728    , 0.307213387193    ,
 0.136981015025    , 0.0569251672059   , 0.0213317384312   , 0.00699817022368  ,
 0.00196565738734  , 0.000464993836578 , 9.1430526214e-05  , 1.47739584398e-05 ,
 1.94208942211e-06 , 6.95832013646e-08 , 5.73979177261e-09 , 3.78638550578e-10 ,
 1.98645686824e-11 , 8.25029956607e-13 , 2.70196029091e-14 , 6.90825562516e-16 ,
 1.28651467668e-17 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.20702736165e-25 , 5.85361882553e-24 , 2.2005867366e-22  , 6.44618888777e-21 ,
 1.47156797693e-19 , 2.61848141515e-18 , 3.63254231554e-17 , 3.92997869808e-16 ,
 3.31700811181e-15 , 2.18513010909e-14 , 1.12415671489e-13 , 4.51954010671e-13 ,
 1.42133731927e-12 , 3.50782941109e-12 , 7.10083073821e-12 , 2.05867598892e-11 ,
 2.520632361e-10   , 4.35849619394e-09 , 6.17786851314e-08 , 6.89899370883e-07 ,
 6.07649690274e-06 , 4.24122776506e-05 , 0.00023629120253  , 0.00106260793747  ,
 0.00392480166253  , 0.0122225944996   , 0.0332519098708   , 0.0821001117973   ,
 0.188909363319    , 0.407371530803    , 0.817863806543    , 1.52534915149     ,
 2.6673974291      , 4.43839782081     , 7.09332173102     , 10.8763301027     ,
 15.87286511       , 21.8697923489     , 28.3429652645     , 34.6190563813     ,
 40.1265421594     , 44.5804942451     , 47.9644140142     , 50.2809950421     ,
 51.2933385673     , 50.6041532761     , 48.0485653229     , 43.9282735034     ,
 38.8279072501     , 33.3047897567     , 27.7870929434     , 22.6313795929     ,
 18.1214656788     , 14.3685053756     , 11.2669273022     , 8.61476531794     ,
 6.29397737504     , 4.3276670138      , 2.78809463251     , 1.68849700772     ,
 0.963252266304    , 0.514726949989    , 0.255051428087    , 0.116760482072    ,
 0.0499428094366   , 0.0204276838281   , 0.00812979098977  , 0.00312379037841  ,
 0.00112171358101  , 0.000361516678365 , 0.000100982433514 , 2.38178771234e-05 ,
 4.65607945165e-06 , 7.44544445759e-07 , 9.64933629748e-08 , 1.00705350197e-08 ,
 8.42784829475e-10 , 5.64265078264e-11 , 3.02137859458e-12 , 1.29639431288e-13 ,
 4.47721467479e-15 , 1.25149068186e-16 , 2.66997700097e-18 , 2.35395591189e-20 ,
 4.46792223475e-22 , 1.82700615255e-25 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 6.08263806468e-19 , 3.24156809966e-17 , 1.2502558897e-15  ,
 3.78100184763e-14 , 8.97916233285e-13 , 1.67767884272e-11 , 2.47184097093e-10 ,
 2.88041838583e-09 , 2.6662789305e-08  , 1.97495455725e-07 , 1.18687805774e-06 ,
 5.9463169573e-06  , 2.6124044689e-05  , 0.000108596373478 , 0.000457967261679 ,
 0.00197979883885  , 0.00837734763317  , 0.0329024708408   , 0.115844340566    ,
 0.359163105423    , 0.974602717047    , 2.32159802505     , 4.90606184508     ,
 9.33929535898     , 16.2661620027     , 26.2094002778     , 39.2515458253     ,
 54.6238960498     , 70.4652091085     , 84.0316244467     , 92.4465414256     ,
 93.7353979488     , 87.6055720911     , 75.530859784      , 60.145046159      ,
 44.3137889903     , 30.305031651      , 19.3379773389     , 11.5949478274     ,
 6.57428458616     , 3.53248393219     , 1.79348943621     , 0.85797600537     ,
 0.388460410932    , 0.168260415002    , 0.0699341228273   , 0.0273890612829   ,
 0.0097638328987   , 0.00305883852003  , 0.000820339040117 , 0.000185117754228 ,
 3.47410298468e-05 , 5.37261593818e-06 , 6.79010846893e-07 , 1.94629044947e-08 ,
 1.55114543431e-09 , 9.94059535337e-11 , 5.09289449399e-12 , 2.07521401095e-13 ,
 6.69300633902e-15 , 1.68229820262e-16 , 3.01918385788e-18 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 4.09374583503e-27 , 1.98530940129e-25 ,
 7.46349509036e-24 , 2.18628506276e-22 , 4.99095999638e-21 , 8.88082385536e-20 ,
 1.23201059457e-18 , 1.33288891687e-17 , 1.12499422747e-16 , 7.41107249705e-16 ,
 3.81268232195e-15 , 1.53284423262e-14 , 4.82969394502e-14 , 1.2349201988e-13  ,
 4.12641551434e-13 , 5.78909410095e-12 , 1.26571775404e-10 , 2.29266886229e-09 ,
 3.27315075597e-08 , 3.68666753545e-07 , 3.29358487941e-06 , 2.35256558639e-05 ,
 0.000135904333932 , 0.000645123934466 , 0.00256884579798  , 0.0087897148943   ,
 0.0264612894435   , 0.0713427443952   , 0.173773963923    , 0.38330414795     ,
 0.767938491985    , 1.41098283564     , 2.41728356658     , 3.92792879468     ,
 6.11041501975     , 9.09121369562     , 12.8539146818     , 17.1777203691     ,
 21.6718413471     , 25.8951074557     , 29.5075827478     , 32.3772248456     ,
 34.5325213306     , 35.9373040005     , 36.3159541438     , 35.3078256361     ,
 32.8337905027     , 29.2438780519     , 25.10041368       , 20.8919019219     ,
 16.9401908326     , 13.448360778      , 10.5280189608     , 8.17357711531     ,
 6.26883484649     , 4.67319142014     , 3.31564137559     , 2.20539410593     ,
 1.36935588805     , 0.796601672164    , 0.435369426897    , 0.222161122877    ,
 0.1043994848      , 0.0447383832874   , 0.0176006951657   , 0.00652955820188  ,
 0.00235829575636  , 0.000835596909581 , 0.00028223735215  , 8.68290132326e-05 ,
 2.33664486885e-05 , 5.34315831244e-06 , 1.01765502253e-06 , 1.59171072084e-07 ,
 2.023594659e-08   , 2.075294219e-09   , 1.70722426981e-10 , 1.12198804744e-11 ,
 5.87492218668e-13 , 2.44784290546e-14 , 8.11599247966e-16 , 2.1404048879e-17  ,
 4.10240465567e-19 , 1.68071521039e-21 , 3.18069152295e-23 , 6.20425142928e-27 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.16485105571e-19 ,
 6.20774075804e-18 , 2.39397254386e-16 , 7.23997118436e-15 , 1.71953309694e-13 ,
 3.21356250609e-12 , 4.73804714405e-11 , 5.53141706311e-10 , 5.14448215161e-09 ,
 3.85592501654e-08 , 2.3848338209e-07  , 1.27617872177e-06 , 6.39917845732e-06 ,
 3.27426959198e-05 , 0.000174813275432 , 0.0009233985453   , 0.00451689475179  ,
 0.0196171907706   , 0.0741318177048   , 0.242118555874    , 0.685004546644    ,
 1.69415183735     , 3.7132902996      , 7.32056886609     , 13.1360623449     ,
 21.60152669       , 32.6473750099     , 45.4071432091     , 58.1723005113     ,
 68.6718637861     , 74.670543994      , 74.7481631521     , 68.8907154968     ,
 58.502999244      , 45.8283133353     , 33.1527743399     , 22.1879710419     ,
 13.7929093662     , 8.0208682841      , 4.39886796225     , 2.28262105409     ,
 1.1139937715      , 0.505797993568    , 0.21286991546     , 0.0839700261949   ,
 0.0315818649521   , 0.0113305815933   , 0.00377355628864  , 0.00112051648276  ,
 0.000286607114191 , 6.17488973619e-05 , 1.10597766481e-05 , 1.63327547346e-06 ,
 1.97592458004e-07 , 4.51668441092e-09 , 3.45918021426e-10 , 2.14049747757e-11 ,
 1.06442948121e-12 , 4.23133569e-14    , 1.33727924286e-15 , 3.27991298829e-17 ,
 5.60038226153e-19 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.0833762357e-28  , 5.25395838564e-27 , 1.9751527188e-25  , 5.78582397859e-24 ,
 1.32081659959e-22 , 2.35023714369e-21 , 3.26041492088e-20 , 3.52738112125e-19 ,
 2.97720488875e-18 , 1.96127950974e-17 , 1.00899693246e-16 , 4.05663894739e-16 ,
 1.31584218507e-15 , 5.13162175718e-15 , 8.20421980498e-14 , 2.26644502675e-12 ,
 5.26235563362e-11 , 9.65420839059e-10 , 1.40139406804e-08 , 1.62072687019e-07 ,
 1.5081472949e-06  , 1.14369968261e-05 , 7.17448406622e-05 , 0.000377926151491 ,
 0.00169283402532  , 0.00650368647804  , 0.0215530989009   , 0.0619522055501   ,
 0.155688465913    , 0.346081085894    , 0.691057688166    , 1.26223434929     ,
 2.14745152784     , 3.44944373067     , 5.25935391919     , 7.59695033693     ,
 10.3553601471     , 13.3090064297     , 16.1884799732     , 18.7630534846     ,
 20.8957271947     , 22.5661173017     , 23.805490925      , 24.5316456641     ,
 24.4704500917     , 23.3427491303     , 21.1545955467     , 18.2583768764     ,
 15.1388276054     , 12.178387281      , 9.58444211541     , 7.43400582942     ,
 5.72211864231     , 4.3800341268      , 3.30253676137     , 2.40279381661     ,
 1.6505321506      , 1.05635396045     , 0.628649489597    , 0.34975117599     ,
 0.182658711095    , 0.089011951114    , 0.0398034316934   , 0.0160548139526   ,
 0.00582237773051  , 0.00193860406542  , 0.000617671169949 , 0.000194678540857 ,
 6.01335284711e-05 , 1.73812868548e-05 , 4.47266411644e-06 , 9.88294133485e-07 ,
 1.83174086342e-07 , 2.80310809387e-08 , 3.50144185417e-09 , 3.53930932066e-10 ,
 2.87566461517e-11 , 1.86824272669e-12 , 9.6660297878e-14  , 3.97086937716e-15 ,
 1.29194546309e-16 , 3.31358379754e-18 , 5.99792829752e-20 , 9.41302089094e-23 ,
 1.77704169146e-24 , 1.64261357356e-28 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 1.74707378061e-20 , 9.31053035665e-19 , 3.59017135602e-17 ,
 1.08583353456e-15 , 2.57963843447e-14 , 4.82372900241e-13 , 7.12288159668e-12 ,
 8.34812832222e-11 , 7.84268619666e-10 , 6.03174797961e-09 , 3.97561994722e-08 ,
 2.44721667105e-07 , 1.56124293472e-06 , 1.06702938045e-05 , 7.30059600815e-05 ,
 0.000459547135081 , 0.00253015460192  , 0.0119176954917   , 0.0477148624582   ,
 0.162835444323    , 0.478125553623    , 1.22468120707     , 2.77807602758     ,
 5.65058390345     , 10.3798553687     , 17.2711291477     , 26.0861346027     ,
 35.8991722421     , 45.2332841954     , 52.38282344       , 55.8375263237     ,
 54.7829432087     , 49.4742340797     , 41.1688485203     , 31.6083389598     ,
 22.4090074851     , 14.6807451954     , 8.91399733364     , 5.05351238675     ,
 2.70098247105     , 1.36617493713     , 0.647457385243    , 0.281764762035    ,
 0.110872427823    , 0.0395829205292   , 0.0131333234337   , 0.00415442569244  ,
 0.00124961088267  , 0.000344838686298 , 8.35012178419e-05 , 1.71620920393e-05 ,
 2.93697588966e-06 , 4.14289132093e-07 , 4.78919034617e-08 , 8.71496014014e-10 ,
 6.39134552284e-11 , 3.79917197221e-12 , 1.82285501862e-13 , 7.02621440298e-15 ,
 2.1633339684e-16  , 5.12427793734e-18 , 8.18797721367e-20 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 2.19315949345e-30 , 1.06359806796e-28 ,
 3.99844928615e-27 , 1.1712675955e-25  , 2.67382777012e-24 , 4.75776072403e-23 ,
 6.60030163179e-22 , 7.14074126622e-21 , 6.02697839454e-20 , 3.97036471207e-19 ,
 2.04485834412e-18 , 8.32494643769e-18 , 4.29394138657e-17 , 8.2610620837e-16  ,
 2.79137921806e-14 , 8.03859597594e-13 , 1.86664684879e-11 , 3.49190011257e-10 ,
 5.29602395886e-09 , 6.57815720437e-08 , 6.76822797824e-07 , 5.82266887148e-06 ,
 4.20641871626e-05 , 0.000254854043499 , 0.00128939446728  , 0.00542925697097  ,
 0.0190474413181   , 0.056112114765    , 0.14096611275     , 0.308920822067    ,
 0.606690429128    , 1.09550820895     , 1.85189443464     , 2.95227703791     ,
 4.43272074416     , 6.23827020353     , 8.2059319481      , 10.1208713312     ,
 11.8142801619     , 13.2146434204     , 14.3280673211     , 15.1960387972     ,
 15.8292542999     , 16.1143238164     , 15.8144277923     , 14.7468136197     ,
 12.9764847363     , 10.8110457475     , 8.61994660614     , 6.66866064383     ,
 5.07377250349     , 3.84196937065     , 2.91880806944     , 2.21929091549     ,
 1.65752910967     , 1.1813413821      , 0.783716026563    , 0.478536104895    ,
 0.269613274344    , 0.141612152627    , 0.0699206806984   , 0.0323411265829   ,
 0.0137661727947   , 0.00526687212133  , 0.00178418628773  , 0.000538618828158 ,
 0.000150105578118 , 4.06992435582e-05 , 1.10385246742e-05 , 2.91278032413e-06 ,
 7.06077090028e-07 , 1.49710500621e-07 , 2.6911328096e-08  , 4.02261972874e-09 ,
 4.93466684109e-10 , 4.91917774483e-11 , 3.9539646494e-12  , 2.54665503082e-13 ,
 1.30776099515e-14 , 5.33299089557e-16 , 1.72018460474e-17 , 4.35693315432e-19 ,
 7.69468079951e-21 , 4.1238158844e-24  , 7.76337570885e-26 , 3.34446059201e-30 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.05004303437e-21 ,
 1.09251183985e-19 , 4.21242571134e-18 , 1.27418689033e-16 , 3.02887497579e-15 ,
 5.67041467732e-14 , 8.40103709464e-13 , 9.93378423334e-12 , 9.56080378222e-11 ,
 7.84820294532e-10 , 6.05745688397e-09 , 4.99686645962e-08 , 4.5670107069e-07  ,
 4.20094497882e-06 , 3.50108154033e-05 , 0.000250111845214 , 0.00149887831172  ,
 0.00749402221602  , 0.0313577503318   , 0.110831924727    , 0.335522310142    ,
 0.884310326427    , 2.05954713725     , 4.27911412111     , 7.95760176531     ,
 13.2497536049     , 19.7936992364     , 26.6918993388     , 32.7721407406     ,
 36.910813885      , 38.279275008      , 36.5762288335     , 32.2002589547     ,
 26.1465920867     , 19.6130872471     , 13.5985582862     , 8.71371813798     ,
 5.17255613802     , 2.86760822964     , 1.50201693916     , 0.746434615469    ,
 0.347031268789    , 0.146658289535    , 0.05483857901     , 0.0179749561736   ,
 0.00525200072333  , 0.00142161656786  , 0.000368518408439 , 9.08647549111e-05 ,
 2.03880214877e-05 , 3.9672032602e-06  , 6.48223327253e-07 , 8.74537369224e-08 ,
 9.66523568853e-09 , 1.3991087956e-10  , 9.81454006643e-12 , 5.58627735928e-13 ,
 2.57349638815e-14 , 9.56187045253e-16 , 2.85025073464e-17 , 6.42978600773e-19 ,
 9.41404082598e-21 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 2.62645350051e-31 , 1.53457332081e-29 , 6.05598015967e-28 , 1.87946977161e-26 ,
 4.59979871993e-25 , 2.20960162802e-20 , 1.09171000281e-18 , 4.47111134729e-17 ,
 1.38784026929e-15 , 3.5320874331e-14  , 7.37171781187e-13 , 1.30978937655e-11 ,
 2.05135105561e-10 , 2.90313527761e-09 , 3.71800724879e-08 , 4.21488123361e-07 ,
 4.09901147035e-06 , 3.32810382163e-05 , 0.000221577463406 , 0.00119849137942  ,
 0.00525491458323  , 0.0187521045307   , 0.0550400782166   , 0.135375041682    ,
 0.286941686217    , 0.543123077105    , 0.950475858809    , 1.57146948918     ,
 2.46264326593     , 3.62747132245     , 4.97482490717     , 6.32729026356     ,
 7.49969966953     , 8.39828569346     , 9.04799899522     , 9.53212828899     ,
 9.91603884921     , 10.1893319848     , 10.2309226901     , 9.85765553632     ,
 8.96886196735     , 7.65394795263     , 6.14950293263     , 4.70499822198     ,
 3.48364067783     , 2.54374518524     , 1.86805123035     , 1.39851175629     ,
 1.06147651055     , 0.792049953306    , 0.557120473183    , 0.357725059947    ,
 0.207156209469    , 0.108913149908    , 0.0529335227255   , 0.0242092058626   ,
 0.0104644386964   , 0.00420969353623  , 0.00153245421487  , 0.000491855625066 ,
 0.00013776703927  , 3.42311714316e-05 , 7.9180454525e-06  , 1.81040063143e-06 ,
 4.1680012684e-07  , 9.24531109303e-08 , 1.85445892408e-08 , 3.21144208489e-09 ,
 4.67245713712e-10 , 5.61767204682e-11 , 5.51699247876e-12 , 4.38608074209e-13 ,
 2.80231933088e-14 , 1.43038647915e-15 , 5.80486249146e-17 , 1.86359358902e-18 ,
 4.68903498171e-20 , 8.20513285568e-22 , 1.41035738857e-25 , 2.6446300988e-27  ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.8803682655e-22  ,
 1.0020885215e-20  , 3.86353992751e-19 , 1.16886598214e-17 , 2.78168364626e-16 ,
 5.22006991552e-15 , 7.80122646608e-14 , 9.46321563292e-13 , 9.82034286464e-12 ,
 9.8393497209e-11  , 1.11240000179e-09 , 1.43492749537e-08 , 1.83068632428e-07 ,
 2.0552773587e-06  , 1.93069028774e-05 , 0.000149220038122 , 0.000945568827769 ,
 0.00492726747781  , 0.0212777998088   , 0.0770814750892   , 0.238020892038    ,
 0.637507485354    , 1.50285397828     , 3.14322320205     , 5.83963644701     ,
 9.62487571942     , 14.0966069931     , 18.4802263565     , 21.9366351237     ,
 23.8445364144     , 23.8953321451     , 22.1167359923     , 18.9023949951     ,
 14.9267350843     , 10.9054853999     , 7.3730106541      , 4.60905867896     ,
 2.66962669138     , 1.44613968542     , 0.742957570677    , 0.363820154594    ,
 0.166868529806    , 0.0691698311569   , 0.0250046857634   , 0.00772202435632  ,
 0.00204169134802  , 0.000475923613515 , 0.00010288766601  , 2.14542254627e-05 ,
 4.2661789053e-06  , 7.67920026468e-07 , 1.18856644514e-07 , 1.53262774164e-08 ,
 1.62168859327e-09 , 1.86712713697e-11 , 1.25415527272e-12 , 6.83004526382e-14 ,
 3.01257532523e-15 , 1.07397614863e-16 , 3.08125455329e-18 , 6.50166540827e-20 ,
 8.49580213519e-22 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.45727638774e-29 , 8.37590188244e-28 , 3.29266515331e-26 , 1.01742530129e-24 ,
 2.47770398635e-23 , 1.70003175759e-19 , 8.35193527022e-18 , 3.17214068966e-16 ,
 9.38329454108e-15 , 2.18098930663e-13 , 3.98978596146e-12 , 5.81124340473e-11 ,
 6.89129151527e-10 , 6.94645933194e-09 , 6.35973035792e-08 , 5.60651947514e-07 ,
 4.74923228202e-06 , 3.64735413578e-05 , 0.000239100239725 , 0.00129100318253  ,
 0.00565740074417  , 0.0200799764613   , 0.0581115400742   , 0.139256175742    ,
 0.283722971047    , 0.510624007087    , 0.847463344898    , 1.33785870189     ,
 2.02126025319     , 2.88625827858     , 3.83769725451     , 4.71828431568     ,
 5.38686075186     , 5.79968519125     , 6.02094170721     , 6.15606063332     ,
 6.27272688065     , 6.35257231412     , 6.2873147489      , 5.94459086445     ,
 5.27651166792     , 4.36963614645     , 3.38963076359     , 2.4891883536      ,
 1.75754748231     , 1.21987684666     , 0.857248502332    , 0.626061114309    ,
 0.473607957632    , 0.355101869012    , 0.248729921908    , 0.155871842973    ,
 0.0859025471957   , 0.0418906660373   , 0.0185057410345   , 0.00763591094508  ,
 0.00300415271548  , 0.00112146397233  , 0.000385985228115 , 0.000118192400006 ,
 3.13803486802e-05 , 7.18902623356e-06 , 1.45792157212e-06 , 2.7785627121e-07  ,
 5.31018626498e-08 , 1.02569799619e-08 , 1.89048295986e-09 , 3.11120943503e-10 ,
 4.37757640828e-11 , 5.13976850457e-12 , 4.96155366319e-13 , 3.89600999988e-14 ,
 2.46753732236e-15 , 1.25185478856e-16 , 5.05856394989e-18 , 1.61824121749e-19 ,
 4.05162577661e-21 , 7.06988547797e-23 , 3.76732318808e-27 , 7.03113157625e-29 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.34720153253e-23 ,
 7.17952550394e-22 , 2.76803194806e-20 , 8.37666720292e-19 , 1.99816390124e-17 ,
 3.76921761356e-16 , 5.82222295948e-15 , 7.88162173819e-14 , 1.09468438338e-12 ,
 1.84542541485e-11 , 3.51471251709e-10 , 6.28069037832e-09 , 9.50663319096e-08 ,
 1.17706319182e-06 , 1.18039890691e-05 , 9.573433117e-05   , 0.00062941593729  ,
 0.00337272629455  , 0.014860207981    , 0.0545285617996   , 0.169424014989    ,
 0.453946179769    , 1.06535252366     , 2.20886650424     , 4.04968365674     ,
 6.54884622681     , 9.3433089722      , 11.8413886964     , 13.5072511988     ,
 14.0758266471     , 13.5459485862     , 12.0855094465     , 9.99137832159     ,
 7.64889823088     , 5.42423033036     , 3.56187894422     , 2.16287470235     ,
 1.21682706825     , 0.641040943868    , 0.321591511811    , 0.154683289323    ,
 0.0699488014201   , 0.0285474620797   , 0.0100865758247   , 0.00300023690443  ,
 0.000743997833422 , 0.000155613428053 , 2.85178093404e-05 , 4.86030768695e-06 ,
 8.05034799256e-07 , 1.27605181346e-07 , 1.82498112815e-08 , 2.23061354473e-09 ,
 2.25820317973e-10 , 2.06791328833e-12 , 1.3324649168e-13  , 6.95195229809e-15 ,
 2.93531720628e-16 , 1.00171692846e-17 , 2.75433344499e-19 , 5.31947172018e-21 ,
 6.00889551251e-23 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 5.67815855897e-28 , 3.25062310139e-26 , 1.27664151121e-24 , 3.94053491554e-23 ,
 9.58441642455e-22 , 1.04561355869e-18 , 5.06854871788e-17 , 1.91170577696e-15 ,
 5.63168911836e-14 , 1.29833541285e-12 , 2.34470983021e-11 , 3.32919107259e-10 ,
 3.74261383705e-09 , 3.37838635561e-08 , 2.51843401767e-07 , 1.63005736272e-06 ,
 9.78820580284e-06 , 5.68778763867e-05 , 0.000313185100275 , 0.00153962791538  ,
 0.00642402096919  , 0.0221539609532   , 0.0626748363201   , 0.146380223117    ,
 0.287811826552    , 0.493003376635    , 0.770023084566    , 1.14247658348     ,
 1.63558893137     , 2.23475635894     , 2.86033713839     , 3.39406153154     ,
 3.74316147803     , 3.89279307033     , 3.90526139143     , 3.87120625805     ,
 3.85077999976     , 3.83300286625     , 3.73631883063     , 3.46826177485     ,
 3.00553065461     , 2.41654068728     , 1.81066560969     , 1.27623107519     ,
 0.856965129565    , 0.560008601601    , 0.369954800776    , 0.258551130921    ,
 0.192816845026    , 0.145146771576    , 0.101870958483    , 0.062980193356    ,
 0.0334533144051   , 0.0152752876032   , 0.00612398665734  , 0.00223790450739  ,
 0.000776418504126 , 0.000260687116055 , 8.31864185861e-05 , 2.41904525919e-05 ,
 6.1550391473e-06  , 1.3379155711e-06  , 2.48595250772e-07 , 4.0853940646e-08  ,
 6.37141572875e-09 , 1.00976257357e-09 , 1.62157353852e-10 , 2.46378151617e-11 ,
 3.30886682436e-12 , 3.77024695143e-13 , 3.56460990822e-14 , 2.75816489599e-15 ,
 1.72895268229e-16 , 8.71031637476e-18 , 3.50319893274e-19 , 1.11663638256e-20 ,
 2.78159569947e-22 , 4.85258508432e-24 , 7.82117953676e-29 , 1.45289826726e-30 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.58606753537e-30 ,
 7.72217792555e-29 , 7.56384398959e-25 , 4.0239717401e-23  , 1.56919988715e-21 ,
 4.78924612396e-20 , 1.17803707917e-18 , 2.33679806576e-17 , 4.52109936592e-16 ,
 1.02917503058e-14 , 2.70270374762e-13 , 7.30319373243e-12 , 1.75200291387e-10 ,
 3.48903094943e-09 , 5.63446230403e-08 , 7.3197866333e-07  , 7.63150263708e-06 ,
 6.38819758728e-05 , 0.000430492890619 , 0.00234761238225  , 0.0104473637175   ,
 0.0384138592011   , 0.118648990081    , 0.313801684628    , 0.723280016583    ,
 1.46867998447     , 2.63246035596     , 4.15063372325     , 5.74499479782     ,
 7.01446254551     , 7.65572146323     , 7.60586292313     , 6.9873291291      ,
 5.97890453073     , 4.76241704269     , 3.52133555042     , 2.41337128841     ,
 1.53147420365     , 0.898358366867    , 0.487929906815    , 0.248166796453    ,
 0.120529723844    , 0.0564636052236   , 0.0250209621262   , 0.010034079646    ,
 0.00347802980695  , 0.0010085841124   , 0.000240623966911 , 4.7164123653e-05  ,
 7.72785999623e-06 , 1.10535080265e-06 , 1.47420718021e-07 , 1.92338660063e-08 ,
 2.41005180482e-09 , 2.71961095169e-10 , 2.61142819835e-11 , 1.90178368088e-13 ,
 1.1747087488e-14  , 5.88057863304e-16 , 2.38190124182e-17 , 7.78570207821e-19 ,
 2.04846538574e-20 , 3.53525894025e-22 , 3.3265991512e-24  , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.73715073289e-26 , 9.89815663806e-25 ,
 3.88298862587e-23 , 1.19700251276e-21 , 2.90714232906e-20 , 5.46435146688e-18 ,
 2.4866168648e-16  , 9.18220436831e-15 , 2.68411711161e-13 , 6.15966529299e-12 ,
 1.10734201039e-10 , 1.5612131431e-09  , 1.73193868178e-08 , 1.52131789213e-07 ,
 1.07045923258e-06 , 6.16459485794e-06 , 3.01621448794e-05 , 0.000132341649746 ,
 0.000547638134298 , 0.00215898060175  , 0.00781955432938  , 0.0247912283248   ,
 0.0665897215212   , 0.149749453886    , 0.283884205429    , 0.465160968447    ,
 0.686762378665    , 0.956289856081    , 1.28884072597     , 1.67294713479     ,
 2.05186001869     , 2.34940151076     , 2.51505680734     , 2.5469993227      ,
 2.48447851005     , 2.38593443173     , 2.30002170576     , 2.23207045563     ,
 2.13388024959     , 1.94384727322     , 1.64582491849     , 1.28446585649     ,
 0.928024357051    , 0.626360511694    , 0.398791998513    , 0.243607036191    ,
 0.148719017651    , 0.0969554673177   , 0.0698080545605   , 0.052297384602    ,
 0.0368140723434   , 0.0226406290422   , 0.0117642051209   , 0.00512952005234  ,
 0.0019009819844   , 0.000618388989166 , 0.00018560605395  , 5.39830899498e-05 ,
 1.54158073395e-05 , 4.17442583775e-06 , 1.01546608946e-06 , 2.125738679e-07   ,
 3.7506245088e-08  , 5.61115764281e-09 , 7.42449304239e-10 , 9.41749597321e-11 ,
 1.22978116349e-11 , 1.63115964211e-12 , 2.03216800837e-13 , 2.2191843221e-14  ,
 2.04269016857e-15 , 1.55202462933e-16 , 9.60608613412e-18 , 4.79856458658e-19 ,
 1.91899376575e-20 , 6.0904621643e-22  , 1.50790071625e-23 , 2.63233521665e-25 ,
 5.12926957551e-32 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 8.33009404459e-29 , 4.05574309578e-27 , 1.85520129311e-25 , 6.22989749206e-24 ,
 4.3778964613e-22  , 1.77546732026e-20 , 7.45470109709e-19 , 2.39074022764e-17 ,
 6.70559543143e-16 , 1.68765203214e-14 , 3.73761976257e-13 , 7.64836801606e-12 ,
 1.45928013157e-10 , 2.53356873803e-09 , 3.83919470497e-08 , 4.88908360837e-07 ,
 5.10367787039e-06 , 4.31092128983e-05 , 0.000293295312026 , 0.00160944356897  ,
 0.00716785415828  , 0.0261966570541   , 0.0798293910983   , 0.206853410429    ,
 0.464768056157    , 0.917938509761    , 1.59977733491     , 2.4505730757      ,
 3.28405700529     , 3.85713500846     , 4.01809385867     , 3.78922255781     ,
 3.30390493245     , 2.69554892121     , 2.05765751616     , 1.46144381079     ,
 0.961970599427    , 0.585924253164    , 0.329815615706    , 0.171786247325    ,
 0.0836768462463   , 0.0389285225078   , 0.0175493804413   , 0.00754321665032  ,
 0.00295406944416  , 0.00100300367974  , 0.000284720841492 , 6.61739263403e-05 ,
 1.2486505505e-05  , 1.91954570944e-06 , 2.45338463615e-07 , 2.73041539305e-08 ,
 2.83836989643e-09 , 2.90089448084e-10 , 2.85638698851e-11 , 2.53049204181e-12 ,
 1.46534911933e-14 , 8.59308966405e-16 , 4.11771696396e-17 , 1.60481282684e-18 ,
 5.04035046475e-20 , 1.27097011849e-21 , 1.91375435501e-23 , 1.44004696485e-25 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4.18180731186e-25 ,
 2.3697175848e-23  , 9.2839326525e-22  , 2.85761977123e-20 , 6.92819855129e-19 ,
 3.17075060222e-17 , 1.10207079079e-15 , 3.64462977427e-14 , 1.02444726182e-12 ,
 2.31772333668e-11 , 4.13956952325e-10 , 5.80674799336e-09 , 6.39959965024e-08 ,
 5.5604044708e-07  , 3.83423621114e-06 , 2.122619204e-05   , 9.61909522182e-05 ,
 0.000368091661432 , 0.00124144657095  , 0.00385136706582  , 0.011203325307    ,
 0.0300834448164   , 0.0721060861248   , 0.150059790986    , 0.268486797253    ,
 0.417703617411    , 0.583614267816    , 0.76515075112     , 0.971641315352    ,
 1.19667512159     , 1.40528950537     , 1.55606366809     , 1.62827162999     ,
 1.62315474286     , 1.55379959669     , 1.44617022425     , 1.33627207974     ,
 1.24448237491     , 1.15353426211     , 1.02672088927     , 0.849142689279    ,
 0.643251427076    , 0.447306984632    , 0.288172249433    , 0.173466534964    ,
 0.0987058980142   , 0.0550466420718   , 0.0326065431193   , 0.0220092189598   ,
 0.0161389374535   , 0.0113469023695   , 0.0069699383853   , 0.00358289135687  ,
 0.00152073879393  , 0.000535095179141 , 0.000159295048536 , 4.18235670724e-05 ,
 1.03058652972e-05 , 2.51826264876e-06 , 6.11041465494e-07 , 1.39494413219e-07 ,
 2.81232322677e-08 , 4.79986020357e-09 , 6.82102235684e-10 , 8.1630660603e-11  ,
 8.64778367965e-12 , 8.87813388345e-13 , 9.5090505964e-14  , 1.03712106054e-14 ,
 1.05562803908e-15 , 9.34827521466e-17 , 6.93502476302e-18 , 4.22333796249e-19 ,
 2.08786126456e-20 , 8.29096408584e-22 , 2.61734159361e-23 , 6.43067175728e-25 ,
 1.12386797958e-26 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 3.19917081919e-27 , 1.55760945617e-25 , 5.86323160059e-24 , 1.72022083954e-22 ,
 6.84698780444e-21 , 2.21142145844e-19 , 7.65539219977e-18 , 2.27342347785e-16 ,
 5.80197928928e-15 , 1.24643134528e-13 , 2.2358159076e-12  , 3.37416202219e-11 ,
 4.34391658663e-10 , 4.89103834103e-09 , 4.98063572773e-08 , 4.69410266375e-07 ,
 4.05464172021e-06 , 3.09127457962e-05 , 0.000199952947975 , 0.00106999638798  ,
 0.00469239890029  , 0.0169092380304   , 0.0506540574738   , 0.128410719873    ,
 0.280986714472    , 0.539003935779    , 0.91163450831     , 1.35445935805     ,
 1.75600465242     , 1.98370825439     , 1.97136601244     , 1.76033490187     ,
 1.4494649773      , 1.12004090715     , 0.813358427144    , 0.550408606444    ,
 0.344756904606    , 0.199606509829    , 0.10687716479     , 0.0529926802351   ,
 0.0245348324504   , 0.0108208924453   , 0.00463210277551  , 0.00190639968114  ,
 0.000722351340443 , 0.00023908270132  , 6.63880723803e-05 , 1.50937393686e-05 ,
 2.77525805722e-06 , 4.11233912106e-07 , 4.94059101274e-08 , 4.91783671041e-09 ,
 4.25405575581e-10 , 3.43992589358e-11 , 2.74415568428e-12 , 2.11449255268e-13 ,
 9.7390177221e-16  , 5.25818111136e-17 , 2.37646101335e-18 , 8.92440479351e-20 ,
 2.70609652877e-21 , 6.56712847402e-23 , 8.44467207835e-25 , 4.87033861181e-27 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4.26983993525e-31 ,
 7.93415910011e-24 , 4.46794458027e-22 , 1.74774929571e-20 , 5.37023329705e-19 ,
 1.29937148964e-17 , 3.02540162477e-16 , 6.40092619213e-15 , 1.45029869589e-13 ,
 3.37351703451e-12 , 7.08754903349e-11 , 1.23212249489e-09 , 1.70926914488e-08 ,
 1.87095548863e-07 , 1.61382842722e-06 , 1.10091037058e-05 , 5.98501430836e-05 ,
 0.000262634911358 , 0.000949019437356 , 0.00290549328182  , 0.00780314357322  ,
 0.018968599899    , 0.0423517854755   , 0.0862879338598   , 0.15764360351     ,
 0.254861317218    , 0.36540548487     , 0.475302014267    , 0.582694427972    ,
 0.695132278006    , 0.810500150279    , 0.910099181061    , 0.975927272553    ,
 1.00404498785     , 0.994599234786    , 0.942809429135    , 0.852419141388    ,
 0.747448163276    , 0.654557360507    , 0.576842037964    , 0.496277157869    ,
 0.399791450305    , 0.294176067509    , 0.197012578552    , 0.12106470705     ,
 0.0688539679036   , 0.0365199567378   , 0.0185488130828   , 0.00978399832921  ,
 0.00597995435572  , 0.0041870080545   , 0.00291359140591  , 0.00178785256184  ,
 0.000915130328928 , 0.000383215435037 , 0.000130959967023 , 3.68774125882e-05 ,
 8.78048760154e-06 , 1.86008644544e-06 , 3.77851867772e-07 , 7.79356144371e-08 ,
 1.60456375025e-08 , 3.06449656131e-09 , 5.07170172759e-10 , 6.99670488056e-11 ,
 7.9524252532e-12  , 7.57043764063e-13 , 6.3924907737e-14  , 5.29422818736e-15 ,
 4.63845001205e-16 , 4.14810747952e-17 , 3.44031038002e-18 , 2.46397395621e-19 ,
 1.46751467072e-20 , 7.1630245315e-22  , 2.81952760329e-23 , 8.84062621353e-25 ,
 2.15083460099e-26 , 3.76303633055e-28 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 9.62450171128e-26 , 4.68597692387e-24 , 1.76358338369e-22 ,
 5.17339672712e-21 , 1.43044633279e-19 , 3.39193522334e-18 , 8.29665350184e-17 ,
 2.00888345779e-15 , 4.54897904266e-14 , 8.9649203071e-13  , 1.48499951167e-11 ,
 2.04497493348e-10 , 2.33395670656e-09 , 2.20639290785e-08 , 1.73437154278e-07 ,
 1.15028915746e-06 , 6.63884511069e-06 , 3.47547755429e-05 , 0.000169488456622 ,
 0.00076136745465  , 0.00303762355775  , 0.0104270584495   , 0.0303940179868   ,
 0.0754869973965   , 0.16168124594     , 0.302306854052    , 0.496181161605    ,
 0.71293684327     , 0.890925795205    , 0.965469852329    , 0.913922981127    ,
 0.77131580006     , 0.59732096446     , 0.434214930178    , 0.297388823174    ,
 0.189802716573    , 0.111783110216    , 0.0607140621938   , 0.0305439259164   ,
 0.0142803420108   , 0.00623859177856  , 0.00258645925542  , 0.00103849499731  ,
 0.000403537774514 , 0.000146250620501 , 4.68473001322e-05 , 1.26810550952e-05 ,
 2.81980463144e-06 , 5.07210233324e-07 , 7.32778308809e-08 , 8.49649991792e-09 ,
 7.96473453274e-10 , 6.17170548093e-11 , 4.14897210165e-12 , 2.6072775641e-13  ,
 1.61979266765e-14 , 5.9397365159e-17  , 2.76658381234e-18 , 1.12817628163e-19 ,
 4.06562902994e-21 , 1.19632909293e-22 , 2.80973660491e-24 , 3.03212115893e-26 ,
 1.2858768104e-28  , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 2.08915409897e-29 , 1.18837063167e-22 , 6.64534627405e-21 , 2.59502535482e-19 ,
 7.9579137071e-18  , 1.92108531748e-16 , 3.7834412735e-15  , 6.11473134867e-14 ,
 8.86386833053e-13 , 1.2990396241e-11  , 2.02576277592e-10 , 3.0746417132e-09  ,
 4.04771958549e-08 , 4.34053222127e-07 , 3.7048585085e-06  , 2.50461643892e-05 ,
 0.000134564101522 , 0.0005798389204   , 0.00203452613961  , 0.00594212766252  ,
 0.0148510622656   , 0.0326602381659   , 0.0644280147706   , 0.114584857978    ,
 0.182783487416    , 0.260226696473    , 0.332521686923    , 0.390184013408    ,
 0.436400153883    , 0.480382375656    , 0.523047575697    , 0.555591952111    ,
 0.572871139201    , 0.57814321739     , 0.570301776785    , 0.53768740748     ,
 0.473967286401    , 0.393061648667    , 0.318385905479    , 0.260551363574    ,
 0.212894473031    , 0.165867149053    , 0.118567932486    , 0.0767133519792   ,
 0.0451142105069   , 0.0243227433431   , 0.0120910162977   , 0.0056350348202   ,
 0.00263880109418  , 0.00142034707738  , 0.000920241853453 , 0.000623290673627 ,
 0.000379686928136 , 0.000193486518753 , 8.03734985561e-05 , 2.702468026e-05   ,
 7.37423304286e-06 , 1.65396635979e-06 , 3.14436696609e-07 , 5.38735141013e-08 ,
 9.08066911634e-09 , 1.58789196199e-09 , 2.76263782971e-10 , 4.3726077866e-11  ,
 5.88317919594e-12 , 6.50860766502e-13 , 5.88099900434e-14 , 4.43308981582e-15 ,
 2.97410110785e-16 , 1.98355345334e-17 , 1.41948207905e-18 , 1.03871358564e-19 ,
 6.99523221904e-21 , 4.02133292565e-22 , 1.93232078482e-23 , 7.52178630752e-25 ,
 2.33782819508e-26 , 5.61500372696e-28 , 9.82885902991e-30 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.27093831445e-24 , 1.1056766215e-22  ,
 4.16125335374e-21 , 1.22068667856e-19 , 2.95586613941e-18 , 5.82990122463e-17 ,
 1.0363382789e-15  , 1.81473155562e-14 , 3.25457963752e-13 , 5.59684889831e-12 ,
 8.50448113141e-11 , 1.09195748872e-09 , 1.16493120868e-08 , 1.02585147669e-07 ,
 7.42218414783e-07 , 4.39523771451e-06 , 2.13071451828e-05 , 8.54253596468e-05 ,
 0.000291298099024 , 0.000887979541635 , 0.00255802019216  , 0.00712531970369  ,
 0.0187333433048   , 0.0446683027339   , 0.0940063426347   , 0.172511258302    ,
 0.274663641579    , 0.378096131416    , 0.448736211268    , 0.459354819094    ,
 0.408935013223    , 0.32303287574     , 0.233321557011    , 0.158196120277    ,
 0.101261364265    , 0.0603556958014   , 0.0330276083633   , 0.0165806887779   ,
 0.00771190082068  , 0.00335381336859  , 0.00137008968304  , 0.000530341051488 ,
 0.000197855203267 , 7.16373849527e-05 , 2.45156181834e-05 , 7.53091259114e-06 ,
 1.97679965777e-06 , 4.28892978439e-07 , 7.54797079579e-08 , 1.06709454668e-08 ,
 1.20699664327e-09 , 1.0931097586e-10  , 7.98968053419e-12 , 4.81948000192e-13 ,
 2.51840555853e-14 , 1.22945768833e-15 , 3.59040155234e-18 , 1.32658306371e-19 ,
 4.42318986936e-21 , 1.50472670486e-22 , 4.31543118607e-24 , 9.86201764929e-26 ,
 8.79187317415e-28 , 2.58333487201e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 7.87341726081e-28 , 1.40727309194e-21 , 7.80982952411e-20 ,
 3.04400748364e-18 , 9.31452683728e-17 , 2.24290520507e-15 , 4.28017040244e-14 ,
 6.49179925669e-13 , 7.98242942284e-12 , 8.33381273717e-11 , 8.11626930197e-10 ,
 8.19057047369e-09 , 8.55008725046e-08 , 8.29286043502e-07 , 6.80211401697e-06 ,
 4.51635646212e-05 , 0.000239658703753 , 0.00101858860784  , 0.00350602952359  ,
 0.00995652443386  , 0.0239124185383   , 0.0498646571021   , 0.0920710403312   ,
 0.151508191865    , 0.221293213023    , 0.285669567259    , 0.328182097834    ,
 0.344219390332    , 0.343773482648    , 0.339589315896    , 0.334997327969    ,
 0.326528831145    , 0.314836395208    , 0.305162446849    , 0.296223768896    ,
 0.276813310991    , 0.238605801523    , 0.187944899367    , 0.140059056216    ,
 0.104325198474    , 0.0791730641272   , 0.0589106274854   , 0.0408071999483   ,
 0.0255977426427   , 0.0145025663354   , 0.00748871224395  , 0.00357103547026  ,
 0.00162375908876  , 0.000768364813474 , 0.000424187864771 , 0.000268731457747 ,
 0.000168938366193 , 9.39493243887e-05 , 4.390602764e-05   , 1.69085195537e-05 ,
 5.32402373288e-06 , 1.36725192043e-06 , 2.87178568563e-07 , 4.99664694201e-08 ,
 7.45161842036e-09 , 1.02382987419e-09 , 1.43094867177e-10 , 2.11725761253e-11 ,
 3.08622775906e-12 , 4.00457305485e-13 , 4.3400673964e-14  , 3.82368492799e-15 ,
 2.73204380892e-16 , 1.62319186752e-17 , 8.60877724414e-19 , 4.59080187353e-20 ,
 2.6618786448e-21  , 1.57726794002e-22 , 8.43544998556e-24 , 3.97124867829e-25 ,
 1.52344311834e-26 , 4.68038988391e-28 , 1.10413088138e-29 , 1.94292959255e-31 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4.20835094034e-23 ,
 2.04897095432e-21 , 7.71138047088e-20 , 2.26210395113e-18 , 5.25867206256e-17 ,
 9.66868292184e-16 , 1.4584106641e-14  , 1.92747258497e-13 , 2.47204872266e-12 ,
 3.26808543801e-11 , 4.24651543158e-10 , 4.96569579784e-09 , 4.94169556503e-08 ,
 4.0896759244e-07  , 2.78911579309e-06 , 1.55832446132e-05 , 7.09277338902e-05 ,
 0.000261876264795 , 0.000784889040111 , 0.00193377738567  , 0.00406497031485  ,
 0.0078668114983   , 0.0154009636907   , 0.0314045443527   , 0.062488801677    ,
 0.111936703411    , 0.172421948164    , 0.224637250746    , 0.247247166678    ,
 0.231567287257    , 0.187289585679    , 0.134064319588    , 0.0878730776756   ,
 0.0544147998207   , 0.0320911694448   , 0.0176975423517   , 0.00892401110282  ,
 0.00409250987764  , 0.00173035926319  , 0.000687374300611 , 0.000259073384796 ,
 9.29345435335e-05 , 3.20082980254e-05 , 1.06852853501e-05 , 3.40814566772e-06 ,
 9.93232575875e-07 , 2.51090951588e-07 , 5.29563448501e-08 , 9.10344723606e-09 ,
 1.25979444953e-09 , 1.39483507953e-10 , 1.23281666505e-11 , 8.71210877489e-13 ,
 4.96339579339e-14 , 2.33090989504e-15 , 9.46976566071e-17 , 2.19573991249e-19 ,
 6.21925231062e-21 , 1.44728139295e-22 , 4.44686915837e-24 , 1.24002337211e-25 ,
 2.74728142618e-27 , 1.86255098702e-29 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 2.3136798185e-26  , 1.31937698348e-20 , 7.263551744e-19   ,
 2.82538799786e-17 , 8.62549927884e-16 , 2.07135623325e-14 , 3.92258661253e-13 ,
 5.86886573685e-12 , 6.96930885906e-11 , 6.63265884992e-10 , 5.18469623185e-09 ,
 3.52901598942e-08 , 2.31463049995e-07 , 1.58170574484e-06 , 1.08046762567e-05 ,
 6.63490275145e-05 , 0.000340513058438 , 0.00142044776925  , 0.00480886855002  ,
 0.0133872183296   , 0.0313452688243   , 0.0633857038685   , 0.113082889155    ,
 0.179358040416    , 0.251572936225    , 0.309653912717    , 0.335364408294    ,
 0.326602104225    , 0.297553217408    , 0.263597831737    , 0.230154406408    ,
 0.197196032794    , 0.16809184502     , 0.148149875712    , 0.136376705356    ,
 0.124282634384    , 0.104645169811    , 0.0789087683797   , 0.0544327061246   ,
 0.0365523694069   , 0.0251907089135   , 0.0175788413899   , 0.0117222190993   ,
 0.00715805579048  , 0.00398961315515  , 0.00213353831412  , 0.00125817524472  ,
 0.000958213697104 , 0.000872497527378 , 0.000763898773449 , 0.000566429344583 ,
 0.000340254142556 , 0.000163458436634 , 6.26141992754e-05 , 1.91321063403e-05 ,
 4.67260468541e-06 , 9.15466546515e-07 , 1.44748407339e-07 , 1.86589286999e-08 ,
 1.99931127044e-09 , 1.85943126668e-10 , 1.65488370864e-11 , 1.63556524943e-12 ,
 1.88625170876e-13 , 2.22600931617e-14 , 2.32998052991e-15 , 2.01403927358e-16 ,
 1.40211562062e-17 , 7.83188242143e-19 , 3.56633628714e-20 , 1.37737070296e-21 ,
 4.84161394027e-23 , 1.6273687216e-24  , 4.47748678277e-26 , 1.46925669037e-27 ,
 3.79693171278e-29 , 7.03179331343e-31 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 6.13385371776e-22 , 2.98647239449e-20 ,
 1.12397119332e-18 , 3.29712984071e-17 , 7.57518118687e-16 , 1.36281779094e-14 ,
 1.941258077e-13   , 2.24441044611e-12 , 2.23100233711e-11 , 2.10354328195e-10 ,
 2.04222681806e-09 , 1.99419878442e-08 , 1.78944347586e-07 , 1.3789554935e-06  ,
 8.85185565843e-06 , 4.67744999163e-05 , 0.000202157446936 , 0.000710636860723 ,
 0.00202203684946  , 0.00465016993824  , 0.00871495067305  , 0.0137653984115   ,
 0.0199888321829   , 0.0304703901799   , 0.0511719504959   , 0.0853929088707   ,
 0.126052023266    , 0.155743143789    , 0.15880931893     , 0.134348912535    ,
 0.0959302689563   , 0.0595709737485   , 0.033624066845    , 0.0180942044122   ,
 0.0094919228004   , 0.00475847614949  , 0.00219670388379  , 0.000915640103858 ,
 0.00034786631615  , 0.000123819259596 , 4.22385215351e-05 , 1.38783467457e-05 ,
 4.38780185843e-06 , 1.34083748376e-06 , 3.93966777121e-07 , 1.07626908056e-07 ,
 2.59808062171e-08 , 5.30003157353e-09 , 8.87654077769e-10 , 1.20113476185e-10 ,
 1.30236487218e-11 , 1.12703709427e-12 , 7.77514281798e-14 , 4.28504896139e-15 ,
 1.90237620579e-16 , 6.95483667082e-18 , 1.27374034495e-20 , 2.90340816188e-22 ,
 4.03560816685e-24 , 1.02604764926e-25 , 2.78586842022e-27 , 6.0227068424e-29  ,
 2.80837535471e-31 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 5.30311355174e-25 , 9.80500572686e-20 , 5.35377925016e-18 , 2.07815864201e-16 ,
 6.32898226035e-15 , 1.51555593008e-13 , 2.85865716629e-12 , 4.25449745072e-11 ,
 5.00654057725e-10 , 4.67131450289e-09 , 3.47375319043e-08 , 2.0844148705e-07  ,
 1.04127994182e-06 , 4.63928484609e-06 , 2.03894136103e-05 , 9.28206386732e-05 ,
 0.000410589175119 , 0.00160581595156  , 0.00527255321963  , 0.0143863924712   ,
 0.0330789238859   , 0.0657073707082   , 0.115347572848    , 0.18056282067     ,
 0.250500112562    , 0.304817071749    , 0.325058686696    , 0.30898947894     ,
 0.270332449691    , 0.224093530588    , 0.177029133828    , 0.132119915981    ,
 0.0946713269984   , 0.0696721550738   , 0.0561817156581   , 0.0478587081149   ,
 0.0389042524253   , 0.0282410444484   , 0.0182586303331   , 0.0110895747586   ,
 0.00682666129137  , 0.00437301323345  , 0.00279130186005  , 0.00173187705429  ,
 0.00118956911112  , 0.00121688895922  , 0.00175132067997  , 0.00249899669901  ,
 0.00298478988773  , 0.00285589007069  , 0.00216777807539  , 0.0013027612512   ,
 0.000619586192682 , 0.000233113233737 , 6.93398457851e-05 , 1.62909743099e-05 ,
 3.01980204915e-06 , 4.41152574875e-07 , 5.07430985341e-08 , 4.5939332169e-09  ,
 3.27711591481e-10 , 1.85293472624e-11 , 8.51251569634e-13 , 3.50401409195e-14 ,
 1.68111277152e-15 , 1.13701311697e-16 , 8.47483298058e-18 , 5.80023583845e-19 ,
 3.15140965146e-20 , 1.35005201373e-21 , 4.52965194856e-23 , 1.19001749135e-24 ,
 2.35653221908e-26 , 3.60928399332e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7.04234073881e-21 , 3.42881089228e-19 ,
 1.29044828313e-17 , 3.78548889975e-16 , 8.66843644172e-15 , 1.54976846166e-13 ,
 2.17047090232e-12 , 2.39977032421e-11 , 2.13707574076e-10 , 1.60838615984e-09 ,
 1.12090731518e-08 , 7.97578427642e-08 , 5.81986026356e-07 , 3.99322449298e-06 ,
 2.37950957603e-05 , 0.000118414674083 , 0.000484651824475 , 0.0016201169195   ,
 0.00440157173195  , 0.00968083156921  , 0.017228652024    , 0.0250764736204   ,
 0.0311476188084   , 0.0368064479645   , 0.0478021314194   , 0.0686704868535   ,
 0.0947004760994   , 0.111925455414    , 0.108435635316    , 0.085394072793    ,
 0.055123111728    , 0.0298232767148   , 0.0141001099008   , 0.00620943291997  ,
 0.00270715704819  , 0.00117854048744  , 0.000489269935481 , 0.000184926374791 ,
 6.29857793427e-05 , 1.98270800927e-05 , 5.98847883278e-06 , 1.76897338617e-06 ,
 5.08815383861e-07 , 1.41595270706e-07 , 3.79774411742e-08 , 9.60753251356e-09 ,
 2.19189120462e-09 , 4.29697784443e-10 , 6.98682112938e-11 , 9.22820636012e-12 ,
 9.79240925199e-13 , 8.30196356951e-14 , 5.60872724368e-15 , 3.01807861043e-16 ,
 1.29649189332e-17 , 4.48255038307e-19 , 6.44065047339e-22 , 1.26040125992e-23 ,
 9.2198354143e-26  , 1.50271364972e-27 , 3.85919443262e-29 , 7.93576769546e-31 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9.48466730493e-24 ,
 5.78326897219e-19 , 3.13196696112e-17 , 1.21310877383e-15 , 3.68537119953e-14 ,
 8.79957470387e-13 , 1.65406555296e-11 , 2.45180798403e-10 , 2.87085971195e-09 ,
 2.65998450425e-08 , 1.95396857757e-07 , 1.14118804649e-06 , 5.33107019217e-06 ,
 2.02275233999e-05 , 6.47602747043e-05 , 0.000189083489688 , 0.000554530714582 ,
 0.00167612959889  , 0.00486571163809  , 0.0125916042097   , 0.0282761495223   ,
 0.0555607174563   , 0.0972325512776   , 0.152613600691    , 0.213070443667    ,
 0.261349625422    , 0.280983075233    , 0.268632558365    , 0.234300565117    ,
 0.189886687697    , 0.142249876943    , 0.0965453715421   , 0.0592500938952   ,
 0.0348038970115   , 0.0220783885133   , 0.0160560117712   , 0.0121331928281   ,
 0.00844176366262  , 0.00517525466032  , 0.00287988660313  , 0.00157700932503  ,
 0.000918683157118 , 0.000611138490664 , 0.000616531577424 , 0.00115595487567  ,
 0.00256924441021  , 0.00493243520747  , 0.0075892586866   , 0.00923914822989  ,
 0.00888622741702  , 0.00675552539588  , 0.00406165870032  , 0.00193174745705  ,
 0.000726615504542 , 0.000216012095245 , 5.07014170935e-05 , 9.38350878189e-06 ,
 1.36736883604e-06 , 1.56653526518e-07 , 1.40901264028e-08 , 9.93700117165e-10 ,
 5.48909571831e-11 , 2.37340644037e-12 , 8.03838441629e-14 , 2.1468999351e-15  ,
 4.5608807422e-17  , 2.8584227414e-19  , 1.9256094101e-20  , 1.03971273537e-21 ,
 4.44947942869e-23 , 1.49094269646e-24 , 3.9131539526e-26  , 7.74302617871e-28 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 6.37793858901e-20 , 3.1053345725e-18  , 1.16870770754e-16 , 3.42837122139e-15 ,
 7.84342903039e-14 , 1.39981170922e-12 , 1.951150436e-11   , 2.12939328875e-10 ,
 1.83090416614e-09 , 1.26033551818e-08 , 7.22722566923e-08 , 3.74791318434e-07 ,
 1.95487308274e-06 , 1.06020994444e-05 , 5.53901181529e-05 , 0.000254756088053 ,
 0.00098206494024  , 0.00311148346098  , 0.0080398560916   , 0.0168731703992   ,
 0.0286958640468   , 0.0396399995459   , 0.0452695702593   , 0.0454154154443   ,
 0.0458111554245   , 0.0526035916816   , 0.0645436332978   , 0.0724291530486   ,
 0.0678383853794   , 0.0514195964558   , 0.031408970015    , 0.0156032777887   ,
 0.00645648867419  , 0.00233748766692  , 0.000801825523615 , 0.000280117643773 ,
 9.93098944381e-05 , 3.34969346345e-05 , 1.0246675952e-05  , 2.84895607321e-06 ,
 7.49376215598e-07 , 1.94240100073e-07 , 4.99975123482e-08 , 1.25848828334e-08 ,
 3.06100960662e-09 , 7.09133992606e-10 , 1.51112364666e-10 , 2.823000431e-11   ,
 4.43514779193e-12 , 5.70416271298e-13 , 5.91700170144e-14 , 4.91278976323e-15 ,
 3.25252703434e-16 , 1.71400352605e-17 , 7.18691278994e-19 , 2.40231763729e-20 ,
 2.7053154753e-23  , 4.74566460009e-25 , 1.64870317065e-27 , 9.29052455074e-31 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3.63059853477e-30 ,
 1.77602622521e-28 , 6.69295231049e-27 , 1.96664806403e-25 , 4.50728390646e-24 ,
 8.06039358712e-23 , 1.12529545537e-21 , 1.22718996038e-20 , 1.04752674895e-19 ,
 3.41083697535e-18 , 1.49369333114e-16 , 5.64645489329e-15 , 1.70695827129e-13 ,
 4.06270906274e-12 , 7.61063838544e-11 , 1.1237660291e-09  , 1.31008960715e-08 ,
 1.20779170773e-07 , 8.8183166011e-07  , 5.10595448386e-06 , 2.3483490927e-05  ,
 8.60426778189e-05 , 0.000252984328614 , 0.000608525846297 , 0.00125497596782  ,
 0.00242548281025  , 0.00483725456424  , 0.0100929644767   , 0.0206696948648   ,
 0.0394510608062   , 0.0689733000418   , 0.109414169862    , 0.15495144811     ,
 0.192898812179    , 0.210508406317    , 0.204130425713    , 0.179698324752    ,
 0.145187315058    , 0.106350479665    , 0.0687466920555   , 0.0384947172173   ,
 0.0190376318208   , 0.00916650880213  , 0.00503131477574  , 0.00323003830617  ,
 0.00209189019311  , 0.00121960336868  , 0.000632043676537 , 0.000314442273454 ,
 0.000192742624048 , 0.000272386297095 , 0.000809527107233 , 0.00245570686275  ,
 0.00608994074791  , 0.0119459957767   , 0.0184670823399   , 0.0225112026524   ,
 0.0216635218328   , 0.0164755564202   , 0.00990911133942  , 0.0047143757015   ,
 0.00177383320962  , 0.000527483216162 , 0.000123838931347 , 2.29239159949e-05 ,
 3.34095819695e-06 , 3.82786520052e-07 , 3.44287821899e-08 , 2.42768152286e-09 ,
 1.34046931695e-10 , 5.78999522872e-12 , 1.95474953449e-13 , 5.15493130012e-15 ,
 1.03031366675e-16 , 7.78634589613e-21 , 5.0562509818e-22  , 2.69210678656e-23 ,
 1.15150938831e-24 , 3.85648292172e-26 , 1.01246737757e-27 , 2.00549448411e-29 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 4.56205897528e-19 , 2.22121529511e-17 , 8.35966049409e-16 , 2.45228633749e-14 ,
 5.60891425294e-13 , 1.00053306567e-11 , 1.392778832e-10   , 1.51450682338e-09 ,
 1.28920325381e-08 , 8.63436726258e-08 , 4.60888893874e-07 , 2.02555369649e-06 ,
 7.87508432622e-06 , 3.01848314522e-05 , 0.000121115154719 , 0.000479481870409 ,
 0.00169811328863  , 0.00506592750915  , 0.0124172049803   , 0.0247835321456   ,
 0.0401465922187   , 0.0527735099028   , 0.0566775239672   , 0.0511937294999   ,
 0.0423988905103   , 0.037580432534    , 0.0382582346676   , 0.0394447913839   ,
 0.035637459225    , 0.0263846643389   , 0.0156880569476   , 0.0074800971288   ,
 0.00288608488744  , 0.000923167717738 , 0.000258254861829 , 6.91932487406e-05 ,
 1.92440680859e-05 , 5.48832902565e-06 , 1.48883549652e-06 , 3.67614167025e-07 ,
 8.39857222145e-08 , 1.86960152588e-08 , 4.19995687378e-09 , 9.43382948171e-10 ,
 2.06765554417e-10 , 4.34654655137e-11 , 8.54517301126e-12 , 1.50530004071e-12 ,
 2.27012294871e-13 , 2.83342164749e-14 , 2.86866988208e-15 , 2.33107833864e-16 ,
 1.51226312833e-17 , 7.81100875814e-19 , 3.20673238724e-20 , 1.04553883414e-21 ,
 9.32878614355e-25 , 1.53285331956e-26 , 4.24093237593e-29 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.76878431647e-28 , 8.65567141249e-27 ,
 3.26221223144e-25 , 9.58684980748e-24 , 2.1975242109e-22  , 3.93063576852e-21 ,
 5.48887808878e-20 , 5.98779665102e-19 , 5.10817291437e-18 , 4.42504117293e-17 ,
 7.19719318277e-16 , 2.16028200517e-14 , 6.33032776017e-13 , 1.49732172993e-11 ,
 2.79413350655e-10 , 4.10939473635e-09 , 4.76987985213e-08 , 4.37643408199e-07 ,
 3.17866158194e-06 , 1.82981668776e-05 , 8.35682740259e-05 , 0.000303084617085 ,
 0.000874290936747 , 0.00201380793623  , 0.00374409378671  , 0.00578249660207  ,
 0.00793289335063  , 0.0108450129869   , 0.0163118578405   , 0.0267343545903   ,
 0.0442384454642   , 0.0692559859618   , 0.0982209398625   , 0.123006937538    ,
 0.135256938958    , 0.132194525922    , 0.116994758884    , 0.0943794432228   ,
 0.068314485097    , 0.043076219983    , 0.0230554238973   , 0.0104125824816   ,
 0.00413356086102  , 0.00164805552944  , 0.000785497338502 , 0.00043633355103  ,
 0.000237331571793 , 0.000116599176046 , 6.1701616574e-05  , 9.18565852089e-05 ,
 0.000369086606606 , 0.00146027565722  , 0.00463500240555  , 0.0115794780376   ,
 0.0227491318051   , 0.0351871286523   , 0.0429099144663   , 0.0413101263302   ,
 0.0314298122915   , 0.0189110205824   , 0.0090008345754   , 0.00338800666881  ,
 0.00100786598681  , 0.00023670099118  , 4.38292568335e-05 , 6.38941887751e-06 ,
 7.32225053183e-07 , 6.5870443826e-08  , 4.64543113788e-09 , 2.56532151346e-10 ,
 1.1081495253e-11  , 3.74131729282e-13 , 9.86535201519e-15 , 1.97081935844e-16 ,
 1.67970098305e-22 , 9.925950585e-24   , 5.08378147037e-25 , 2.17391126129e-26 ,
 7.27756804774e-28 , 1.9122989946e-29  , 3.80009133643e-31 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.57967235694e-18 ,
 1.25601866076e-16 , 4.72709767206e-15 , 1.38668478758e-13 , 3.17143259466e-12 ,
 5.6565372572e-11  , 7.87128231813e-10 , 8.55069894001e-09 , 7.25848855404e-08 ,
 4.82389498614e-07 , 2.5204975604e-06  , 1.04626929657e-05 , 3.54304353531e-05 ,
 0.000104078497842 , 0.00029452168849  , 0.000871466930109 , 0.00260056446941  ,
 0.00707103710473  , 0.0163055702071   , 0.0309019537856   , 0.0476130253635   ,
 0.0594867894488   , 0.060413729276    , 0.0505312098738   , 0.0364258421802   ,
 0.0254480821555   , 0.0201239697763   , 0.0179107280773   , 0.0152511656611   ,
 0.0110168024474   , 0.00644329465656  , 0.00301249154948  , 0.00112605301302  ,
 0.000339502004676 , 8.45780782593e-05 , 1.841659804e-05   , 3.86796176502e-06 ,
 8.54145447702e-07 , 1.94792870269e-07 , 4.23627138799e-08 , 8.47398905092e-09 ,
 1.6090081903e-09  , 3.07142360645e-10 , 6.01080647939e-11 , 1.17409046097e-11 ,
 2.22217345716e-12 , 3.98386121404e-13 , 6.53629708595e-14 , 9.37825586137e-15 ,
 1.13035561136e-15 , 1.11441618859e-16 , 8.85484644344e-18 , 5.62787237542e-19 ,
 2.85047291601e-20 , 1.14795150558e-21 , 3.67291435164e-23 , 2.57211967632e-26 ,
 3.92683725197e-28 , 8.7537212703e-31  , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.31751557386e-30 , 6.46351853348e-29 , 9.10001526699e-27 , 3.97755996706e-25 ,
 1.39342878918e-23 , 3.90624412703e-22 , 8.69105748173e-21 , 1.52594697181e-19 ,
 2.10662316061e-18 , 2.28205042773e-17 , 1.93811255825e-16 , 1.32087155442e-15 ,
 8.35791418563e-15 , 8.99253030459e-14 , 1.96509214424e-12 , 4.45763927281e-11 ,
 8.24935020907e-10 , 1.20731460534e-08 , 1.39459243446e-07 , 1.27298938225e-06 ,
 9.19543859447e-06 , 5.26294892061e-05 , 0.000238899226286 , 0.000860685473008 ,
 0.00246278019295  , 0.00560445021868  , 0.0101793899092   , 0.0149056101251   ,
 0.0180717471553   , 0.0193262384887   , 0.0204546823975   , 0.0240541245176   ,
 0.0317792451813   , 0.0436314405537   , 0.0575348427314   , 0.0693036593569   ,
 0.0746697709351   , 0.0721717259563   , 0.0633770035548   , 0.0506909292484   ,
 0.0362640256739   , 0.0224972177986   , 0.0117581980965   , 0.00509186496423  ,
 0.00183873971277  , 0.000588287350347 , 0.000196681727402 , 8.14307983253e-05 ,
 3.86806299993e-05 , 1.92545118772e-05 , 2.26433613868e-05 , 0.000105634057095 ,
 0.000534649654665 , 0.00216783941154  , 0.00690293860343  , 0.0172577842303   ,
 0.0339183929728   , 0.0524835327915   , 0.0640295402388   , 0.0616706662632   ,
 0.04694350551     , 0.028259656118    , 0.0134571417536   , 0.00506787368436  ,
 0.00150828452476  , 0.000354374556672 , 6.56430483919e-05 , 9.57254087059e-06 ,
 1.09731417405e-06 , 9.8736583808e-08  , 6.96461472988e-09 , 3.84663590232e-10 ,
 1.66185336861e-11 , 5.6112912199e-13  , 1.47973912846e-14 , 2.95696660289e-16 ,
 1.43779671831e-24 , 2.78942519635e-26 , 1.09586344554e-28 , 2.26378976946e-30 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 1.15377541294e-17 , 5.61764949754e-16 , 2.11423682046e-14 ,
 6.20208132737e-13 , 1.41842894351e-11 , 2.52980896134e-10 , 3.51998507651e-09 ,
 3.82278186947e-08 , 3.24261316498e-07 , 2.15042936024e-06 , 1.11693875174e-05 ,
 4.56009603708e-05 , 0.000147594948612 , 0.000386975575109 , 0.000865471767851 ,
 0.00181969408411  , 0.00396484662326  , 0.00886990912611  , 0.0184498804772   ,
 0.0328374525957   , 0.0480920083436   , 0.0571805718168   , 0.0550726550789   ,
 0.0432054283445   , 0.0282171797216   , 0.016417971432    , 0.00987862620305  ,
 0.00698479644864  , 0.00532523129198  , 0.00369267467383  , 0.00212299868114  ,
 0.000980590680509 , 0.000361012696223 , 0.000106047090364 , 2.50690802691e-05 ,
 4.8855921195e-06  , 8.32048598293e-07 , 1.37434883454e-07 , 2.40948354431e-08 ,
 4.38761710342e-09 , 7.66211866311e-10 , 1.25177926886e-10 , 2.00264431818e-11 ,
 3.31150106793e-12 , 5.64286111395e-13 , 9.51971566388e-14 , 1.54037278611e-14 ,
 2.32304390357e-15 , 3.13505545007e-16 , 3.62285853153e-17 , 3.46573245147e-18 ,
 2.68881468749e-19 , 1.67351164986e-20 , 8.31136311164e-22 , 3.28333611018e-23 ,
 1.0310919487e-24  , 5.18833945528e-28 , 6.82290781597e-30 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 6.55660874919e-29 , 3.21656631679e-27 ,
 3.16874153115e-25 , 1.31402108902e-23 , 4.42660563723e-22 , 1.20698486788e-20 ,
 2.63589378631e-19 , 4.57258487305e-18 , 6.26482551599e-17 , 6.75471041225e-16 ,
 5.7200799662e-15  , 3.8089694879e-14  , 2.02259813348e-13 , 9.6509596189e-13  ,
 7.19690170759e-12 , 1.142906592e-10   , 2.00244613813e-09 , 2.89673647669e-08 ,
 3.32289261801e-07 , 3.01304811457e-06 , 2.16165172404e-05 , 0.000122852204054 ,
 0.000553650514995 , 0.00198001801216  , 0.00562275851167  , 0.0126900594859   ,
 0.0228132384825   , 0.0328739806769   , 0.038615092038    , 0.0385044685962   ,
 0.0352980146469   , 0.0329530655923   , 0.0329916722193   , 0.0345640584608   ,
 0.0364101118164   , 0.03744169918     , 0.0366082191525   , 0.0334575629721   ,
 0.0284199315157   , 0.022237961558    , 0.015645535866    , 0.00956347907485  ,
 0.0049210918519   , 0.00208661648824  , 0.000723391205642 , 0.000208507798939 ,
 5.4142265781e-05  , 1.53585895065e-05 , 5.69205202384e-06 , 4.32060032932e-06 ,
 1.89096424721e-05 , 0.000120245669631 , 0.000622578767881 , 0.00252951099205  ,
 0.00805846072206  , 0.020154029556    , 0.0396265238684   , 0.0613438878306   ,
 0.0748772139498   , 0.0721587981712   , 0.0549594515058   , 0.0331053135888   ,
 0.015774198841    , 0.00594395607077  , 0.00176999912876  , 0.000416074959139 ,
 7.71068646989e-05 , 1.12486772583e-05 , 1.2898825295e-06  , 1.16096414591e-07 ,
 8.19102528136e-09 , 4.52485120202e-10 , 1.9551599439e-11  , 6.60245813588e-13 ,
 1.74128744743e-14 , 3.48087673843e-16 , 4.42571973054e-26 , 7.99800616115e-28 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 4.08186223986e-17 , 1.9874375849e-15  , 7.47985183589e-14 ,
 2.1942063223e-12  , 5.01817841814e-11 , 8.94999674124e-10 , 1.24527569898e-08 ,
 1.35230082576e-07 , 1.14683408005e-06 , 7.60117624979e-06 , 3.9416674023e-05  ,
 0.000160189361788 , 0.000511828281261 , 0.00129490234649  , 0.00263995604926  ,
 0.00452735891986  , 0.00712553362433  , 0.0114390972667   , 0.0190843298106   ,
 0.0302382140819   , 0.0414626717736   , 0.0469019089447   , 0.0430279751941   ,
 0.031943789729    , 0.0193673803727   , 0.00991579447087  , 0.00472209767945  ,
 0.00248922764708  , 0.00155920579569  , 0.000997587696185 , 0.000557532669399 ,
 0.000254343421249 , 9.27496725545e-05 , 2.69049100957e-05 , 6.21762043033e-06 ,
 1.15430953446e-06 , 1.76390953567e-07 , 2.35657954103e-08 , 3.06985475499e-09 ,
 4.27948276176e-10 , 6.23199538588e-11 , 8.78270083236e-12 , 1.18489636945e-12 ,
 1.61849340704e-13 , 2.32862799187e-14 , 3.43391601027e-15 , 4.95162390519e-16 ,
 6.75584433026e-17 , 8.42632590401e-18 , 9.19941003943e-19 , 8.44556719562e-20 ,
 6.34167217109e-21 , 3.83303390134e-22 , 1.84937710533e-23 , 7.08506923927e-25 ,
 2.15387337966e-26 , 4.29557877711e-30 , 1.15528687634e-32 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 2.4825672389e-27  , 1.2179073764e-25  ,
 9.07010228669e-24 , 3.54260073798e-22 , 1.13608785025e-20 , 2.98320771398e-19 ,
 6.34300546365e-18 , 1.08073690349e-16 , 1.46356930012e-15 , 1.56649436372e-14 ,
 1.32057006419e-13 , 8.75381138281e-13 , 4.56585806626e-12 , 1.89713275063e-11 ,
 6.95920400034e-11 , 3.74785729736e-10 , 4.37506154661e-09 , 5.91042513953e-08 ,
 6.66581051479e-07 , 5.97740542574e-06 , 4.24320951931e-05 , 0.000238598380751 ,
 0.00106380652174  , 0.0037638788208   , 0.0105748394179   , 0.0236119052684   ,
 0.0419767727634   , 0.059721046318    , 0.0689382320877   , 0.0667676708471   ,
 0.0580122063275   , 0.0493746421651   , 0.0429577067705   , 0.0369463607077   ,
 0.0301945410977   , 0.0235946151138   , 0.0182025803309   , 0.0141013342141   ,
 0.0108446564233   , 0.00802502161874  , 0.00547117589584  , 0.00328074512525  ,
 0.00166492344124  , 0.000696718595872 , 0.000237057651062 , 6.55110222352e-05 ,
 1.50922973305e-05 , 3.21720748889e-06 , 9.54682002033e-07 , 2.18756468215e-06 ,
 1.66222510755e-05 , 0.000109782093036 , 0.000569698545781 , 0.00231564001532  ,
 0.00737973055987  , 0.0184640641552   , 0.0363209879266   , 0.0562573492091   ,
 0.0687103565132   , 0.066259844773    , 0.0505021092543   , 0.0304424549299   ,
 0.0145158786067   , 0.00547362883746  , 0.00163101486135  , 0.000383633622311 ,
 7.11327514532e-05 , 1.03819583564e-05 , 1.19096645114e-06 , 1.07228917165e-07 ,
 7.56745989094e-09 , 4.18131717442e-10 , 1.80704718453e-11 , 6.10317399914e-13 ,
 1.60979550258e-14 , 3.21939341694e-16 , 1.15825218707e-27 , 2.09419179588e-29 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 1.14181829943e-16 , 5.5594762105e-15  , 2.09234769759e-13 ,
 6.13788769341e-12 , 1.40374339822e-10 , 2.5035962848e-09  , 3.48341310033e-08 ,
 3.78273124696e-07 , 3.20782077542e-06 , 2.12580779384e-05 , 0.000110187739828 ,
 0.000447245992706 , 0.00142396517012  , 0.00356653429009  , 0.00706948979428  ,
 0.0112498089455   , 0.0148882469573   , 0.0176785483458   , 0.0209637547324   ,
 0.0259614015521   , 0.0311803462287   , 0.0328626032439   , 0.0286955461889   ,
 0.0203149524456   , 0.0116294752166   , 0.00545603441043  , 0.00220264746301  ,
 0.000872346680131 , 0.000406986502446 , 0.000222068798911 , 0.000117158995861 ,
 5.23912891417e-05 , 1.89251699143e-05 , 5.44623001433e-06 , 1.24483391972e-06 ,
 2.26370914761e-07 , 3.30221473301e-08 , 3.96092452694e-09 , 4.15891674498e-10 ,
 4.28346016314e-11 , 4.76041819286e-12 , 5.5633734449e-13  , 6.37298243402e-14 ,
 7.18138781858e-15 , 8.42756887647e-16 , 1.0429257659e-16  , 1.29336494011e-17 ,
 1.52705263842e-18 , 1.66080238265e-19 , 1.60658020033e-20 , 1.32796988281e-21 ,
 9.05832681052e-23 , 4.97824638992e-24 , 2.17376048403e-25 , 7.46143122495e-27 ,
 2.01737762897e-28 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 7.33849721855e-26 , 3.60014823432e-24 , 2.15739677992e-22 , 7.90883629239e-21 ,
 2.39225656939e-19 , 5.97938635268e-18 , 1.22421194514e-16 , 2.03057924543e-15 ,
 2.70066185036e-14 , 2.85702309056e-13 , 2.39089806132e-12 , 1.57752969452e-11 ,
 8.19406328602e-11 , 3.35343121114e-10 , 1.09459308092e-09 , 3.14547428205e-09 ,
 1.29815053406e-08 , 1.15214290422e-07 , 1.20097344954e-06 , 1.05076028634e-05 ,
 7.32307216634e-05 , 0.000404474694883 , 0.0017712223347   , 0.00615495273419  ,
 0.016986485233    , 0.0372649740992   , 0.0650939287444   , 0.0909276860437   ,
 0.102762281471    , 0.0967506420427   , 0.0806822373483   , 0.0650249682804   ,
 0.0531910120655   , 0.0425009311313   , 0.0310950327358   , 0.0203631110896   ,
 0.0122596101423   , 0.0071693767062   , 0.00428429673692  , 0.00264709668242  ,
 0.00162349225576  , 0.000922151995637 , 0.00045558722743  , 0.00018781951534  ,
 6.31468237703e-05 , 1.71426304533e-05 , 3.77129583024e-06 , 7.05163185977e-07 ,
 2.50413288395e-07 , 1.42511576162e-06 , 1.18919315558e-05 , 7.88765207466e-05 ,
 0.000409510590993 , 0.00166510356814  , 0.00530867612312  , 0.0132886640454   ,
 0.0261550191561   , 0.0405373422088   , 0.0495461355224   , 0.0478164602369   ,
 0.0364750493795   , 0.0220057009317   , 0.0105018672382   , 0.00396326926875  ,
 0.00118186788353  , 0.000278183255043 , 5.16123236728e-05 , 7.53697610751e-06 ,
 8.65001153653e-07 , 7.79104938432e-08 , 5.50011706478e-09 , 3.03981626359e-10 ,
 1.3139976058e-11  , 4.43867864932e-13 , 1.17091871108e-14 , 2.34284978138e-16 ,
 2.3122906551e-29  , 4.20299821845e-31 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.52332759388e-16 ,
 1.228604544e-14   , 4.62394378661e-13 , 1.35643254412e-11 , 3.10218395492e-10 ,
 5.5327967564e-09  , 7.69813805892e-08 , 8.35959538762e-07 , 7.08900035345e-06 ,
 4.69766952695e-05 , 0.000243468088455 , 0.000987894461785 , 0.0031422986361   ,
 0.00784877753772  , 0.0154359691976   , 0.0240245917807   , 0.0299393200704   ,
 0.0307449025349   , 0.0277522487755   , 0.0244099796221   , 0.0223574145397   ,
 0.020243698308    , 0.0163519554227   , 0.0110136681092   , 0.00601871293283  ,
 0.00265905040739  , 0.000967520556895 , 0.00031046304984  , 0.000103971740435 ,
 4.29935877042e-05 , 2.00355191851e-05 , 8.59836400741e-06 , 3.06116337928e-06 ,
 8.74210930244e-07 , 1.9841646609e-07  , 3.57208430277e-08 , 5.1099223409e-09  ,
 5.85647836627e-10 , 5.51590914541e-11 , 4.55736773232e-12 , 3.71998669445e-13 ,
 3.3060412777e-14  , 3.11233305887e-15 , 2.90858129937e-16 , 2.71524488433e-17 ,
 2.60377405127e-18 , 2.46232977775e-19 , 2.09547514351e-20 , 1.49925379047e-21 ,
 8.70660333141e-23 , 4.04574274795e-24 , 1.49969111268e-25 , 4.41104478108e-27 ,
 1.01616195756e-28 , 1.1162853724e-30  , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 1.69459921687e-24 , 8.31343028676e-23 , 4.25045690428e-21 ,
 1.46832213963e-19 , 4.17492462767e-18 , 9.8421401292e-17  , 1.91789708414e-15 ,
 3.06283994688e-14 , 3.96520189046e-13 , 4.11939268196e-12 , 3.407178153e-11   ,
 2.23164511082e-10 , 1.15386738169e-09 , 4.70332683733e-09 , 1.51324309981e-08 ,
 3.89821770348e-08 , 8.98145908399e-08 , 3.07026162717e-07 , 2.18431950716e-06 ,
 1.765120138e-05   , 0.000119143568631 , 0.000640445617671 , 0.00272867421503  ,
 0.00921899648084  , 0.0247252257926   , 0.0527042982535   , 0.0894458022618   ,
 0.121311144572    , 0.132755615127    , 0.120182291483    , 0.0952416445961   ,
 0.0724992561784   , 0.0569928325372   , 0.0452363090886   , 0.0336769756422   ,
 0.0224661729587   , 0.0132977491423   , 0.00700904054433  , 0.00331817695678  ,
 0.00144747597057  , 0.000612451048911 , 0.000261805334565 , 0.000110035046278 ,
 4.20870876493e-05 , 1.36978272166e-05 , 3.65513094218e-06 , 7.88301059729e-07 ,
 1.43081990391e-07 , 9.31815047726e-08 , 7.93869955646e-07 , 6.71681405404e-06 ,
 4.45830485642e-05 , 0.000231544138702 , 0.000941843802448 , 0.00300418831896  ,
 0.0075242594754   , 0.0148190173784   , 0.0229848663008   , 0.0281161887904   ,
 0.0271591128248   , 0.0207370901638   , 0.0125230877467   , 0.00598224968266  ,
 0.00225973846284  , 0.000674456549426 , 0.000158877443529 , 2.94979502212e-05 ,
 4.31024559172e-06 , 4.94935055272e-07 , 4.45981754e-08    , 3.14955706619e-09 ,
 1.74121514359e-10 , 7.52840053205e-12 , 2.54357445964e-13 , 6.71093946316e-15 ,
 1.34351888727e-16 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4.40027910178e-16 , 2.14249667225e-14 ,
 8.06345174707e-13 , 2.36541401486e-11 , 5.40974912651e-10 , 9.64839432347e-09 ,
 1.34244606371e-07 , 1.45779711385e-06 , 1.23622258066e-05 , 8.1920221187e-05  ,
 0.000424559887983 , 0.00172254370107  , 0.0054776779025   , 0.0136719088807   ,
 0.0268306596876   , 0.0415029721652   , 0.0508224115184   , 0.0497364213035   ,
 0.0398104252101   , 0.0275049713371   , 0.0180382041943   , 0.0121910517399   ,
 0.00827433327667  , 0.00510407066551  , 0.00264885780384  , 0.00111776355065  ,
 0.000381598873688 , 0.000108051485455 , 2.78445370947e-05 , 8.00736261508e-06 ,
 2.91535435222e-06 , 1.13855219912e-06 , 3.93516447696e-07 , 1.11148242001e-07 ,
 2.50624847969e-08 , 4.48302541266e-09 , 6.35271995335e-10 , 7.14442490909e-11 ,
 6.43023549779e-12 , 4.7552677512e-13  , 3.09382633714e-14 , 2.00379196353e-15 ,
 1.42260176677e-16 , 1.0699882696e-17  , 7.96507543276e-19 , 5.88685839118e-20 ,
 4.44218090837e-21 , 3.22135730487e-22 , 2.06279096494e-23 , 1.09097655055e-24 ,
 4.61122960527e-26 , 1.54970392513e-27 , 4.07279219601e-29 , 8.12680712828e-31 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.18487852916e-30 ,
 1.07229664371e-28 , 3.05960781202e-23 , 1.500914842e-21   , 6.87564922981e-20 ,
 2.26019799819e-18 , 6.06478894606e-17 , 1.34409786679e-15 , 2.47036614427e-14 ,
 3.75461133264e-13 , 4.67945553725e-12 , 4.7316374243e-11  , 3.84300787577e-10 ,
 2.48777325412e-09 , 1.27694675808e-08 , 5.18153374673e-08 , 1.66026515275e-07 ,
 4.20920314656e-07 , 8.61104415434e-07 , 1.64147402975e-06 , 5.06078020782e-06 ,
 3.02635184741e-05 , 0.000190851945431 , 0.00099170890713  , 0.00409310023448  ,
 0.0133713690946   , 0.0346002989041   , 0.0710227223143   , 0.11587381306     ,
 0.150768889234    , 0.157665769165    , 0.135231171138    , 0.100157813633    ,
 0.0710811202586   , 0.0544063684198   , 0.0454993068048   , 0.0379822504243   ,
 0.0291404010796   , 0.0195991216999   , 0.0112054316652   , 0.00532274985144  ,
 0.00207338216589  , 0.0006642485201   , 0.000180524523802 , 4.47573743993e-05 ,
 1.10821805581e-05 , 2.79369537383e-06 , 6.63783200032e-07 , 1.3641568683e-07  ,
 2.54045972863e-08 , 3.55718201581e-08 , 3.5234985797e-07  , 2.9895877091e-06  ,
 1.98504949862e-05 , 0.000103131978801 , 0.00041969144728  , 0.00133939698034  ,
 0.00335675788898  , 0.00661599547689  , 0.0102702871645   , 0.0125748771285   ,
 0.012159182926    , 0.00929399317941  , 0.00561878661231  , 0.00268700485611  ,
 0.00101605432052  , 0.000303555077613 , 7.15701023973e-05 , 1.32985117701e-05 ,
 1.94450608674e-06 , 2.23412291648e-07 , 2.01412383334e-08 , 1.42295721181e-09 ,
 7.8692982548e-11  , 3.40330050275e-12 , 1.15009416051e-13 , 3.03490454775e-15 ,
 6.0795813498e-17  , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6.0466532141e-16  , 2.94412521378e-14 ,
 1.10804518647e-12 , 3.25045459699e-11 , 7.43386439525e-10 , 1.32584657266e-08 ,
 1.84474331189e-07 , 2.00325939062e-06 , 1.69878241397e-05 , 0.000112572588912 ,
 0.000583416719774 , 0.00236702000974  , 0.00752662519424  , 0.0187822599455   ,
 0.0368382782755   , 0.0568876424919   , 0.069324514047    , 0.0669087569544   ,
 0.0515343503892   , 0.0322650505056   , 0.0171612248607   , 0.00843975259595  ,
 0.00420559925684  , 0.00212742492966  , 0.000997875526266 , 0.000398407124914 ,
 0.000129851481896 , 3.431170764e-05   , 7.59559367632e-06 , 1.5918027933e-06  ,
 3.97917294261e-07 , 1.25991993722e-07 , 4.05771659134e-08 , 1.12152152965e-08 ,
 2.50684708827e-09 , 4.4581356286e-10  , 6.27952055126e-11 , 6.99860678108e-12 ,
 6.18297696072e-13 , 4.36727763991e-14 , 2.53466648815e-15 , 1.29727106095e-16 ,
 6.62314229804e-18 , 3.65377915087e-19 , 2.01945831576e-20 , 9.76167639564e-22 ,
 4.07038614569e-23 , 1.34406448956e-24 , 3.51814587835e-26 , 6.45486468729e-28 ,
 2.06694704989e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.78964622891e-30 , 9.0366089926e-29  , 3.54150026024e-27 , 1.07266627274e-25 ,
 4.34707428125e-22 , 2.12489931171e-20 , 9.0392290291e-19  , 2.86047801292e-17 ,
 7.31225261105e-16 , 1.52964980572e-14 , 2.64343959193e-13 , 3.78966885353e-12 ,
 4.49500533104e-11 , 4.37530288349e-10 , 3.45850646369e-09 , 2.19843596519e-08 ,
 1.11530846601e-07 , 4.49306287488e-07 , 1.43324690052e-06 , 3.61703176752e-06 ,
 7.24654951471e-06 , 1.1882205924e-05  , 1.95693811427e-05 , 5.82772597948e-05 ,
 0.000297740532096 , 0.00147139498966  , 0.00589974572021  , 0.0187228056021   ,
 0.0469213595802   , 0.0929475473374   , 0.145796159447    , 0.181609927761    ,
 0.180714982299    , 0.145943869165    , 0.100232560185    , 0.0661704234348   ,
 0.050883002659    , 0.0478615988565   , 0.0468971700491   , 0.0414244094965   ,
 0.0308357740694   , 0.018768040904    , 0.00919110755225  , 0.00358776073479  ,
 0.00111077508708  , 0.00027265024529  , 5.34705685263e-05 , 8.60182516517e-06 ,
 1.21132571173e-06 , 1.66351976906e-07 , 2.39721016615e-08 , 4.23119652708e-09 ,
 1.17967372152e-08 , 1.2359633762e-07  , 1.04967700564e-06 , 6.97207319217e-06 ,
 3.62375223071e-05 , 0.000147539377636 , 0.00047113261408  , 0.00118156436368  ,
 0.00233069740441  , 0.00362139586173  , 0.00443859256256  , 0.004296664154    ,
 0.00328806465151  , 0.00199022533067  , 0.000952893909483 , 0.000360735334426 ,
 0.000107887513384 , 2.5461507879e-05  , 4.73506399987e-06 , 6.92871059738e-07 ,
 7.96566345328e-08 , 7.18501920111e-09 , 5.07832435474e-10 , 2.80942043977e-11 ,
 1.2153567782e-12  , 4.10804517166e-14 , 1.08423927416e-15 , 2.17341189459e-17 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 6.53783826103e-16 , 3.18329213126e-14 , 1.19805843501e-12 ,
 3.51451199612e-11 , 8.03777900695e-10 , 1.43355820515e-08 , 1.99461370136e-07 ,
 2.16601277542e-06 , 1.83680362966e-05 , 0.000121719131175 , 0.000630820745896 ,
 0.00255934261003  , 0.00813806496894  , 0.0203070940794   , 0.0398229440997   ,
 0.0614688784001   , 0.0748080990222   , 0.0719245138444   , 0.0547915552383   ,
 0.0332676217377   , 0.0163329681208   , 0.00671871557171  , 0.0024920608965   ,
 0.000916297699487 , 0.000343624395487 , 0.000121950790848 , 3.73785070225e-05 ,
 9.409874224e-06   , 1.92813636089e-06 , 3.35693143063e-07 , 5.80496655179e-08 ,
 1.2711367105e-08  , 3.44770122574e-09 , 9.04156872252e-10 , 1.98848874874e-10 ,
 3.51086757401e-11 , 4.91927540956e-12 , 5.4515941294e-13  , 4.77447456481e-14 ,
 3.31060917944e-15 , 1.83346221074e-16 , 8.34161241772e-18 , 3.35348449717e-19 ,
 1.35052819666e-20 , 5.79870856427e-22 , 2.3527382603e-23  , 9.61255274099e-25 ,
 3.096095222e-26   , 7.86710296007e-28 , 1.35280348166e-29 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4.88410083868e-32 , 9.34500512141e-29 ,
 4.6832157543e-27  , 1.81208607956e-25 , 5.44098166493e-24 , 4.91052209321e-21 ,
 2.37001340163e-19 , 9.57613851206e-18 , 2.94621167523e-16 , 7.25635278468e-15 ,
 1.44649642964e-13 , 2.36030026803e-12 , 3.18258675855e-11 , 3.56146159332e-10 ,
 3.29949212285e-09 , 2.51072727776e-08 , 1.55326899447e-07 , 7.73791647598e-07 ,
 3.08119759365e-06 , 9.75896963904e-06 , 2.45187611946e-05 , 4.88424822809e-05 ,
 7.76286467108e-05 , 0.000103575543969 , 0.00015593288975  , 0.000461474838839 ,
 0.00198636479488  , 0.00769127300869  , 0.0238833076033   , 0.058537377067    ,
 0.113080545812    , 0.172330122302    , 0.20760112184     , 0.198545602433    ,
 0.152647133509    , 0.0986585961888   , 0.0621927250375   , 0.0503116132716   ,
 0.0542259887224   , 0.0598155951085   , 0.0569020593857   , 0.0441340739986   ,
 0.0274152684217   , 0.0135354364233   , 0.00528805140624  , 0.0016298647329   ,
 0.000395478449054 , 7.54621171965e-05 , 1.13324630624e-05 , 1.34708840803e-06 ,
 1.29198343577e-07 , 1.05464003028e-08 , 1.03806838683e-09 , 3.21480832086e-09 ,
 3.42569585545e-08 , 2.91082574323e-07 , 1.93409065985e-06 , 1.00568510381e-05 ,
 4.09676665153e-05 , 0.000130903942227 , 0.000328544363601 , 0.000648638459713 ,
 0.00100884706456  , 0.00123786967819  , 0.0011997209953   , 0.000919251565218 ,
 0.000557123580451 , 0.000267080441535 , 0.000101230455038 , 3.03097129015e-05 ,
 7.16038542179e-06 , 1.33280905011e-06 , 1.95178104096e-07 , 2.24535919237e-08 ,
 2.02642066026e-09 , 1.43290614194e-10 , 7.93000072152e-12 , 3.43153659382e-13 ,
 1.16017315483e-14 , 3.06262989445e-16 , 6.1434495918e-18  , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 5.55386990013e-16 , 2.70420097699e-14 , 1.01774911686e-12 , 2.98557578031e-11 ,
 6.82809503359e-10 , 1.2178095281e-08  , 1.6944295528e-07  , 1.84003713045e-06 ,
 1.56037632528e-05 , 0.000103401471496 , 0.000535889475307 , 0.00217419711095  ,
 0.00691340142749  , 0.0172510151548   , 0.0338286345658   , 0.0522101547991   ,
 0.0635174265645   , 0.0610048478457   , 0.0463314629964   , 0.027886205273    ,
 0.0133603688443   , 0.00515187052834  , 0.00164473300511  , 0.000462593014374 ,
 0.000125779792432 , 3.48122290056e-05 , 9.2963546207e-06  , 2.18136367086e-06 ,
 4.2404200199e-07  , 6.75223877275e-08 , 9.31524924545e-09 , 1.35053447507e-09 ,
 2.59709384752e-10 , 5.94194935096e-11 , 1.2568481608e-11  , 2.19176100216e-12 ,
 3.05231165739e-13 , 3.36640459566e-14 , 2.93254467039e-15 , 2.01626154032e-16 ,
 1.09596262436e-17 , 4.74969247589e-19 , 1.687031818e-20   , 5.28025053953e-22 ,
 1.60066808146e-23 , 4.33799610477e-25 , 1.76143371616e-26 , 5.64190563284e-28 ,
 1.42813915736e-29 , 2.41320698005e-31 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 3.51893298392e-30 , 3.65039143951e-27 , 1.81868090494e-25 ,
 6.97265839161e-24 , 2.08026847259e-22 , 4.63859512906e-20 , 2.12670305351e-18 ,
 8.17637335323e-17 , 2.45276930841e-15 , 5.87076241187e-14 , 1.12741630503e-12 ,
 1.75354489425e-11 , 2.23361074266e-10 , 2.35209160164e-09 , 2.05670887242e-08 ,
 1.49001230601e-07 , 8.87532154857e-07 , 4.30360181575e-06 , 1.68293355616e-05 ,
 5.26925889182e-05 , 0.000131462801707 , 0.000260691127456 , 0.000411070350019 ,
 0.00052186430507  , 0.000582685297357 , 0.000856222378206 , 0.00246815978808  ,
 0.00869800164402  , 0.0262742140304   , 0.0632815474139   , 0.12020433179     ,
 0.179838993031    , 0.212103545563    , 0.197814775635    , 0.147515823038    ,
 0.0922310775344   , 0.0578595489223   , 0.050600829578    , 0.0601186791105   ,
 0.0699995546345   , 0.0681473314604   , 0.0532596363851   , 0.0330799353669   ,
 0.0162690854836   , 0.00632131197545  , 0.00193671174878  , 0.000467064188436 ,
 8.85232642479e-05 , 1.31686151745e-05 , 1.53633206473e-06 , 1.40637589455e-07 ,
 1.01446672834e-08 , 6.33892652051e-10 , 7.17943302265e-10 , 7.50759908486e-09 ,
 6.38112946483e-08 , 4.24150021587e-07 , 2.20649424285e-06 , 8.99338322998e-06 ,
 2.87557140338e-05 , 7.22283624646e-05 , 0.000142729471497 , 0.000222222157515 ,
 0.000272983731817 , 0.000264899492805 , 0.000203235619154 , 0.000123336189708 ,
 5.92032984518e-05 , 2.24674874267e-05 , 6.7348139198e-06  , 1.59269270256e-06 ,
 2.96730050109e-07 , 4.34878354491e-08 , 5.00625322978e-09 , 4.52062357295e-10 ,
 3.19804944061e-11 , 1.77052550416e-12 , 7.66386350249e-14 , 2.59170809412e-15 ,
 6.84290709325e-17 , 1.37360852287e-18 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3.70163145297e-16 ,
 1.80234208671e-14 , 6.78327169752e-13 , 1.98987986577e-11 , 4.55091445738e-10 ,
 8.11668955378e-09 , 1.12933726139e-07 , 1.22638674122e-06 , 1.03999466096e-05 ,
 6.89175103502e-05 , 0.000357173647746 , 0.00144912078255  , 0.0046078557701   ,
 0.0114980022247   , 0.0225470535377   , 0.034797524139    , 0.0423297607577   ,
 0.0406437388672   , 0.0308418929573   , 0.0185182096168   , 0.00881072402084  ,
 0.00333210358034  , 0.00100997693027  , 0.00025084656891  , 5.37574639721e-05 ,
 1.08458166204e-05 , 2.20829042712e-06 , 4.4114546969e-07  , 7.89702622816e-08 ,
 1.18461823729e-08 , 1.46946977867e-09 , 1.62144163396e-10 , 2.00370838268e-11 ,
 3.37547834765e-12 , 6.42312560081e-13 , 1.08819693288e-13 , 1.50090301226e-14 ,
 1.64664513935e-15 , 1.4279122147e-16  , 9.76357821209e-18 , 5.25447262481e-19 ,
 2.22253722936e-20 , 7.37917562156e-22 , 1.92113927048e-23 , 3.6441484164e-25  ,
 6.9330547079e-29  , 1.34181877806e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 2.43745625509e-31 , 1.33555219936e-29 , 5.18918569378e-28 ,
 1.59661066226e-26 , 4.90216321893e-25 , 1.26631645538e-23 , 3.1608682635e-22  ,
 7.47077113557e-21 , 4.39725354455e-19 , 1.66415785074e-17 , 5.78155151826e-16 ,
 1.65939265244e-14 , 3.85463683464e-13 , 7.1809690742e-12  , 1.07558355632e-10 ,
 1.30632735313e-09 , 1.30035819286e-08 , 1.07083365698e-07 , 7.32755035563e-07 ,
 4.15786624154e-06 , 1.94197434495e-05 , 7.39382448526e-05 , 0.000227393433844 ,
 0.000560923507563 , 0.00110471836044  , 0.00173376184215  , 0.00217582153273  ,
 0.00224523777392  , 0.00222741176622  , 0.00339574021448  , 0.0089442132099   ,
 0.0248874900091   , 0.0580263351616   , 0.108025640735    , 0.158988470837    ,
 0.184598998241    , 0.169367409928    , 0.124147131911    , 0.0767356293994   ,
 0.0493943193648   , 0.0467709118689   , 0.0587586576701   , 0.0696000586616   ,
 0.0678062090173   , 0.0527012251376   , 0.0324717913546   , 0.0158296720009   ,
 0.00609711889052  , 0.0018528932326   , 0.000443602240957 , 8.35387738815e-05 ,
 1.23563910373e-05 , 1.43357639295e-06 , 1.30313713964e-07 , 9.27502382481e-09 ,
 5.25512723599e-10 , 1.42186156825e-10 , 1.30194583789e-09 , 1.10644914962e-08 ,
 7.35727714238e-08 , 3.82914896923e-07 , 1.56159332879e-06 , 4.99647073246e-06 ,
 1.2560138545e-05  , 2.48429302582e-05 , 3.87197631502e-05 , 4.76196789069e-05 ,
 4.62672246134e-05 , 3.55434066264e-05 , 2.15985275158e-05 , 1.03811079991e-05 ,
 3.94448067368e-06 , 1.18374554915e-06 , 2.80228852243e-07 , 5.22560231378e-08 ,
 7.66446172033e-09 , 8.82903268225e-10 , 7.97695080511e-11 , 5.64572033161e-12 ,
 3.12676526922e-13 , 1.35384460343e-14 , 4.57940941037e-16 , 1.20933160902e-17 ,
 2.42921853519e-19 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.93319973543e-16 , 9.4128561085e-15  ,
 3.5426119989e-13  , 1.03922949685e-11 , 2.37675038588e-10 , 4.23900773543e-09 ,
 5.89806294271e-08 , 6.40492113381e-07 , 5.43148011833e-06 , 3.59929620786e-05 ,
 0.000186538529778 , 0.000756824315797 , 0.00240652791463  , 0.00600504062211  ,
 0.0117756336895   , 0.018173616253    , 0.0221069921959   , 0.0212248885687   ,
 0.0161025234462   , 0.00966185553538  , 0.00458808426913  , 0.00172560362237  ,
 0.000515034314889 , 0.000122723994495 , 2.37508225669e-05 , 3.89445898901e-06 ,
 5.85527320394e-07 , 8.75588521952e-08 , 1.3008975591e-08  , 1.76921749598e-09 ,
 2.04585244811e-10 , 1.98271364065e-11 , 1.77014381643e-12 , 1.8942991178e-13  ,
 2.77656321761e-14 , 4.34141933187e-15 , 5.86121466094e-16 , 6.38211979898e-17 ,
 5.50988763724e-18 , 3.75514392713e-19 , 2.01490469687e-20 , 8.4988910604e-22  ,
 2.81382750203e-23 , 7.30281420379e-25 , 1.3725886167e-26  , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0
};
  // type   : pro
  // tiling : [180, 180]
  // range  : [[-180.0, 178.0], [-180.0, 178.0]]
  ftype32 rama2_pro_data[] = {
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4.05357623806e-31 , 1.10267073123e-28 ,
 5.24421684425e-27 , 1.92190243813e-25 , 5.5339214549e-24  , 1.25126710994e-22 ,
 2.22113095325e-21 , 3.09549013256e-20 , 3.38821579155e-19 , 2.91459449292e-18 ,
 1.97214345765e-17 , 1.05081028562e-16 , 4.41424681265e-16 , 1.46372305829e-15 ,
 3.83533010074e-15 , 7.94788905464e-15 , 1.30323253902e-14 , 1.69168630027e-14 ,
 1.75188580875e-14 , 1.66110290441e-14 , 3.93741626974e-14 , 2.91701685761e-13 ,
 2.14976466404e-12 , 1.27050472117e-11 , 5.93694294533e-11 , 2.18948856816e-10 ,
 6.36360665627e-10 , 1.45546457841e-09 , 2.61573732538e-09 , 3.68867551941e-09 ,
 4.07638847009e-09 , 3.52631490725e-09 , 2.38554921481e-09 , 1.26103120808e-09 ,
 5.20526615046e-10 , 1.67688277374e-10 , 4.21418626812e-11 , 8.25890861319e-12 ,
 1.26184901043e-12 , 1.50269609695e-13 , 1.3945611975e-14  , 1.0084317921e-15  ,
 5.68134033867e-17 , 2.49352316813e-18 , 8.52521561848e-20 , 2.27040877023e-21 ,
 4.70123743138e-23 , 0, 0, 0, 0, 0, 0, 1.08012488053e-25 , 5.21524152378e-24 ,
 1.95816755849e-22 , 5.72696712111e-21 , 1.30472667051e-19 , 2.31558515921e-18 ,
 3.20171027409e-17 , 3.44926340667e-16 , 2.89566661516e-15 , 1.8946034617e-14  ,
 9.66326900754e-14 , 3.84306323227e-13 , 1.19211820659e-12 , 2.88552862409e-12 ,
 5.45273389162e-12 , 8.04924453683e-12 , 9.28913295138e-12 , 8.38816312105e-12 ,
 5.93323853796e-12 , 3.2913972739e-12  , 1.43391521977e-12 , 4.91309824897e-13 ,
 1.3259397218e-13  , 2.82259212208e-14 , 4.74537241018e-15 , 6.30670299288e-16 ,
 6.62951995461e-17 , 5.51245506745e-18 , 3.62427060447e-19 , 1.882573317e-20   ,
 7.71677335694e-22 , 2.49271834872e-23 , 6.33608647146e-25 , 1.09084002709e-26 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.11465268463e-29 ,
 1.28557473284e-27 , 5.10859544491e-26 , 1.59965941203e-24 , 3.95270257486e-23 ,
 7.7163336729e-22  , 1.19108769393e-20 , 1.45436614318e-19 , 1.40468016024e-18 ,
 1.07258049198e-17 , 6.46892642323e-17 , 3.07791199493e-16 , 1.15371028505e-15 ,
 3.40191025837e-15 , 7.87988950078e-15 , 1.43193158831e-14 , 2.039065151e-14   ,
 2.2731813326e-14  , 1.98320900415e-14 , 1.36545433481e-14 , 8.87673788226e-15 ,
 1.88534115261e-14 , 1.19583355087e-13 , 7.01780762222e-13 , 3.2783822596e-12  ,
 1.20902176276e-11 , 3.51394169436e-11 , 8.03697941148e-11 , 1.44439289874e-10 ,
 2.03686229277e-10 , 2.25095482692e-10 , 1.9472078336e-10  , 1.31728454227e-10 ,
 6.96333115836e-11 , 2.87431363639e-11 , 9.25963607599e-12 , 2.32704586214e-12 ,
 4.56051486369e-13 , 6.96784700901e-14 , 8.29778873545e-15 , 7.70067495284e-16 ,
 5.56849384378e-17 , 3.13719866312e-18 , 1.37690704714e-19 , 4.70756783555e-21 ,
 1.2537047482e-22  , 2.59599230209e-24 , 0, 0, 0, 0, 0, 0, 3.64282089211e-27 ,
 1.75888835844e-25 , 6.60410089696e-24 , 1.93147254112e-22 , 4.40031116728e-21 ,
 7.8095247573e-20  , 1.07980635269e-18 , 1.16329593242e-17 , 9.76590302886e-17 ,
 6.3897251114e-16  , 3.25902669787e-15 , 1.29610855972e-14 , 4.02052872507e-14 ,
 9.73171171789e-14 , 1.83898485236e-13 , 2.71468204215e-13 , 3.13284585838e-13 ,
 2.82898546406e-13 , 2.00103948105e-13 , 1.1100541215e-13  , 4.83601147819e-14 ,
 1.65698774919e-14 , 4.47185414145e-15 , 9.51945255366e-16 , 1.60042066138e-16 ,
 2.12699381683e-17 , 2.23586681787e-18 , 1.85912637035e-19 , 1.22231872579e-20 ,
 6.34915233759e-22 , 2.60255306689e-23 , 8.40692279438e-25 , 2.13690366629e-26 ,
 3.67895871328e-28 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 8.10733422322e-28 , 4.90614640365e-26 , 1.9475777849e-24  , 6.09151977122e-23 ,
 1.50328066117e-21 , 2.9305943805e-20  , 4.51699615045e-19 , 5.50702500863e-18 ,
 5.31064775194e-17 , 4.04880567214e-16 , 2.43816123912e-15 , 1.15831117618e-14 ,
 4.33513329815e-14 , 1.27628443364e-13 , 2.95136346178e-13 , 5.35341097028e-13 ,
 7.60733987057e-13 , 8.45978371931e-13 , 7.35545301564e-13 , 4.99635119854e-13 ,
 2.65043833682e-13 , 1.10342552057e-13 , 4.05219739687e-14 , 3.92133414547e-14 ,
 1.43357062878e-13 , 5.22507722235e-13 , 1.51788968185e-12 , 3.47160077096e-12 ,
 6.23909947618e-12 , 8.79828892596e-12 , 9.72306815776e-12 , 8.41102373798e-12 ,
 5.69005083255e-12 , 3.00783217168e-12 , 1.24156855827e-12 , 3.99972809765e-13 ,
 1.00517457089e-13 , 1.96992833092e-14 , 3.00978280716e-15 , 3.58425519979e-16 ,
 3.3263300768e-17  , 2.40532793144e-18 , 1.35512254886e-19 , 5.94759206423e-21 ,
 2.03344831146e-22 , 5.41541596924e-24 , 1.12134680745e-25 , 0, 0, 0, 0, 0, 0,
 9.59745214507e-29 , 4.6340040723e-27  , 1.7399302408e-25  , 5.08869797115e-24 ,
 1.15931518738e-22 , 2.05751373328e-21 , 2.84488041077e-20 , 3.06484380446e-19 ,
 2.57294524625e-18 , 1.68345034777e-17 , 8.5862999304e-17  , 3.41475473135e-16 ,
 1.0592569105e-15  , 2.56393713192e-15 , 4.84502797113e-15 , 7.15215811052e-15 ,
 8.25386125044e-15 , 7.45330429757e-15 , 5.27198048671e-15 , 2.92457181537e-15 ,
 1.27410570296e-15 , 4.365534595e-16   , 1.17816404906e-16 , 2.50801488838e-17 ,
 4.21650176183e-18 , 5.60382241523e-19 , 5.89066150186e-20 , 4.89809323585e-21 ,
 3.22034649088e-22 , 1.67276095989e-23 , 6.85674076609e-25 , 2.21490547013e-26 ,
 5.62993111197e-28 , 9.6926616049e-30  , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 2.43391238588e-26 , 1.46705479267e-24 , 5.81877881727e-23 ,
 1.81821011047e-21 , 4.48223692538e-20 , 8.72791772045e-19 , 1.3436353304e-17  ,
 1.63612876379e-16 , 1.57588674973e-15 , 1.20006624937e-14 , 7.2190132604e-14  ,
 3.42628091856e-13 , 1.28124554217e-12 , 3.76929755757e-12 , 8.71099068517e-12 ,
 1.57925486079e-11 , 2.24321572392e-11 , 2.49372397503e-11 , 2.16759527503e-11 ,
 1.47204335791e-11 , 7.80540779324e-12 , 3.22981650954e-12 , 1.04266934213e-12 ,
 2.63413331096e-13 , 5.6265381205e-14  , 2.55046812501e-14 , 5.218207963e-14   ,
 1.17290269326e-13 , 2.10641882696e-13 , 2.97035649009e-13 , 3.28256388466e-13 ,
 2.83960999232e-13 , 1.92099388554e-13 , 1.01546143965e-13 , 4.19160685717e-14 ,
 1.3503312088e-14  , 3.39352716043e-15 , 6.65059133869e-16 , 1.01611998541e-16 ,
 1.21006516904e-17 , 1.12298816415e-18 , 8.12052543055e-20 , 4.57497166008e-21 ,
 2.00794128637e-22 , 6.86503844614e-24 , 1.82827557608e-25 , 3.78573131229e-27 ,
 0, 0, 0, 0, 0, 0, 1.9112622793e-30  , 9.22827960133e-29 , 3.46494359918e-27 ,
 1.01337691879e-25 , 2.30869125886e-24 , 4.09738785682e-23 , 5.66537090891e-22 ,
 6.10341189191e-21 , 5.123831952e-20   , 3.3524680302e-19  , 1.70989872392e-18 ,
 6.8002338667e-18  , 2.10943253118e-17 , 5.10589295229e-17 , 9.64851823527e-17 ,
 1.42429988768e-16 , 1.64369599641e-16 , 1.48427094449e-16 , 1.04987628895e-16 ,
 5.82407050261e-17 , 2.53728816055e-17 , 8.69364230661e-18 , 2.34622738593e-18 ,
 4.9945279014e-19  , 8.39685433819e-20 , 1.11596017779e-20 , 1.17308208038e-21 ,
 9.75419382215e-23 , 6.41308409906e-24 , 3.33118089739e-25 , 1.3654696879e-26  ,
 4.41082196951e-28 , 1.12115953346e-29 , 1.93022254568e-31 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 5.72835384926e-25 , 3.43622654985e-23 ,
 1.36149851581e-21 , 4.24930012376e-20 , 1.04616403967e-18 , 2.03423654976e-17 ,
 3.1269977932e-16  , 3.80195806783e-15 , 3.65651262118e-14 , 2.78052789481e-13 ,
 1.67041179555e-12 , 7.91858191711e-12 , 2.95799116467e-11 , 8.69416480626e-11 ,
 2.00769915361e-10 , 3.63749916887e-10 , 5.16405747607e-10 , 5.73826708195e-10 ,
 4.9860803641e-10  , 3.38517063568e-10 , 1.79456439713e-10 , 7.42441053404e-11 ,
 2.39608161979e-11 , 6.03016564101e-12 , 1.1832209902e-12  , 1.81383649313e-13 ,
 2.29109727809e-14 , 5.09229585814e-15 , 5.69882332943e-15 , 7.84033554056e-15 ,
 8.65576402285e-15 , 7.48744541406e-15 , 5.06524287242e-15 , 2.67755068878e-15 ,
 1.10523544873e-15 , 3.56052933957e-16 , 8.94799212265e-17 , 1.75361610785e-17 ,
 2.67928712377e-18 , 3.19067833807e-19 , 2.96107523871e-20 , 2.14120571751e-21 ,
 1.20632039882e-22 , 5.29450390812e-24 , 1.81016114013e-25 , 4.8207645554e-27  ,
 9.98214906184e-29 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.05834451163e-23 , 6.31214090565e-22 ,
 2.49786815105e-20 , 7.78486564341e-19 , 1.91357229919e-17 , 3.71449829575e-16 ,
 5.69954705598e-15 , 6.91699177729e-14 , 6.64021260237e-13 , 5.04055886451e-12 ,
 3.023174026e-11   , 1.43100570971e-10 , 5.33850542974e-10 , 1.56731590008e-09 ,
 3.61582922169e-09 , 6.54578878652e-09 , 9.28670640146e-09 , 1.03137474532e-08 ,
 8.95788401267e-09 , 6.07959810536e-09 , 3.22205117239e-09 , 1.33272188495e-09 ,
 4.30034615977e-10 , 1.08210555924e-10 , 2.12282988159e-11 , 3.24596405875e-12 ,
 3.86816444375e-13 , 3.59746764482e-14 , 2.70885047317e-15 , 3.02851737182e-16 ,
 1.79317605217e-16 , 1.49780145604e-16 , 1.01183321305e-16 , 5.34837983677e-17 ,
 2.2076913893e-17  , 7.11210446006e-18 , 1.78734813324e-18 , 3.50282212347e-19 ,
 5.35183622587e-20 , 6.37333257914e-21 , 5.91470379917e-22 , 4.27702661068e-23 ,
 2.40960707538e-24 , 1.05756929006e-25 , 3.6157699854e-27  , 9.62940558147e-29 ,
 1.99391944548e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 1.29419374654e-30 , 6.38425696727e-29 ,
 1.5371889028e-22  , 9.10594738948e-21 , 3.59809302952e-19 , 1.11948053133e-17 ,
 2.74654755647e-16 , 5.32043578171e-15 , 8.14593978726e-14 , 9.86387937481e-13 ,
 9.44816945528e-12 , 7.15672287383e-11 , 4.28378953221e-10 , 2.02401632851e-09 ,
 7.53857484502e-09 , 2.2101214027e-08  , 5.0927057173e-08  , 9.21018830023e-08 ,
 1.3055997447e-07  , 1.44901447511e-07 , 1.25784079627e-07 , 8.53308182743e-08 ,
 4.52077307528e-08 , 1.86939144903e-08 , 6.03072748213e-09 , 1.51726537926e-09 ,
 2.97610768723e-10 , 4.55019654815e-11 , 5.42158725787e-12 , 5.03355496714e-13 ,
 3.6410444918e-14  , 2.05182983269e-15 , 9.0072173142e-17  , 3.07999665009e-18 ,
 8.2035471137e-20  , 1.69940160187e-21 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 6.4035365912e-29  , 3.15886421232e-27 , 1.75787010049e-21 ,
 1.03315544151e-19 , 4.07527539568e-18 , 1.26542472462e-16 , 3.09769580529e-15 ,
 5.98607306903e-14 , 9.14142918882e-13 , 1.10398886139e-11 , 1.05465331512e-10 ,
 7.9681498888e-10  , 4.75794735693e-09 , 2.24307691955e-08 , 8.33802298727e-08 ,
 2.44030753517e-07 , 5.61488724982e-07 , 1.01420929721e-06 , 1.43624387933e-06 ,
 1.59268779133e-06 , 1.38163142902e-06 , 9.36782039511e-07 , 4.96088113849e-07 ,
 2.05068214127e-07 , 6.61379635547e-08 , 1.66360608406e-08 , 3.26261002317e-09 ,
 4.98758000407e-10 , 5.94212365589e-11 , 5.51639370618e-12 , 3.99005824522e-13 ,
 2.24839887324e-14 , 9.86974862765e-16 , 3.37483676102e-17 , 8.98864287487e-19 ,
 1.86188521715e-20 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.42078940084e-27 ,
 1.19417526471e-25 , 1.58523704327e-20 , 9.23366724113e-19 , 3.6348601805e-17  ,
 1.12607392147e-15 , 2.74947133826e-14 , 5.29817215343e-13 , 8.06660183604e-12 ,
 9.71151730405e-11 , 9.24851119689e-10 , 6.96617776529e-09 , 4.14767051702e-08 ,
 1.95019598245e-07 , 7.23215392299e-07 , 2.11226948925e-06 , 4.85149296857e-06 ,
 8.75011796998e-06 , 1.23759185897e-05 , 1.37100890242e-05 , 1.18835332386e-05 ,
 8.05203448762e-06 , 4.26184156817e-06 , 1.76098347929e-06 , 5.67759186296e-07 ,
 1.42774508231e-07 , 2.79947348827e-08 , 4.27889132355e-09 , 5.09716135935e-10 ,
 4.73150355321e-11 , 3.42207652157e-12 , 1.92822508939e-13 , 8.46389142485e-15 ,
 2.89401558432e-16 , 7.70778910491e-18 , 1.59641147507e-19 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 3.95770819375e-31 , 2.07179299307e-29 , 7.95005578134e-28 ,
 2.38928152726e-26 , 5.63066902692e-25 , 1.04191585662e-23 , 1.51677106796e-22 ,
 1.74074958817e-21 , 1.28638091736e-19 , 6.62360425824e-18 , 2.56349191704e-16 ,
 7.90383739547e-15 , 1.9235587833e-13  , 3.6945535463e-12  , 5.6056576963e-11  ,
 6.72458123337e-10 , 6.38082292902e-09 , 4.78914126458e-08 , 2.84185015907e-07 ,
 1.33204981595e-06 , 4.92596278375e-06 , 1.43516715398e-05 , 3.28933691418e-05 ,
 5.92202227363e-05 , 8.36349599479e-05 , 9.25381494635e-05 , 8.01301369183e-05 ,
 5.42512292481e-05 , 2.86961989583e-05 , 1.18511972292e-05 , 3.81941522472e-06 ,
 9.60165160794e-07 , 1.88219027028e-07 , 2.87629595059e-08 , 3.42581738928e-09 ,
 3.17967675153e-10 , 2.29949700703e-11 , 1.29559450267e-12 , 5.68665205588e-14 ,
 1.94432157004e-15 , 5.17823750883e-17 , 1.07236770112e-18 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 1.99088916717e-29 , 1.04219665135e-27 , 3.99920336686e-26 ,
 1.20190637538e-24 , 2.83245692225e-23 , 5.24126310103e-22 , 7.62803161038e-21 ,
 8.74707566131e-20 , 1.42739774499e-18 , 4.19529068822e-17 , 1.45349417765e-15 ,
 4.39266012489e-14 , 1.06275485933e-12 , 2.03298995882e-11 , 3.07243015056e-10 ,
 3.67075060152e-09 , 3.46880090658e-08 , 2.59298607045e-07 , 1.53270879153e-06 ,
 7.15835357703e-06 , 2.63855855756e-05 , 7.66525866026e-05 , 0.000175247438275 ,
 0.00031484513094  , 0.000443864487116 , 0.000490404288762 , 0.000424147887295 ,
 0.000286891724136 , 0.000151635935608 , 6.25859372733e-05 , 2.01605721038e-05 ,
 5.06625782943e-06 , 9.92830906362e-07 , 1.51685328916e-07 , 1.80631901932e-08 ,
 1.67629628611e-09 , 1.21213737944e-10 , 6.82888747988e-12 , 2.99714493886e-13 ,
 1.02469815497e-14 , 2.72892568442e-16 , 5.65053403396e-18 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 7.56023931794e-28 , 3.95765682513e-26 , 1.51866487764e-24 ,
 4.56414148284e-23 , 1.07560242645e-21 , 1.9903269366e-20  , 2.89635418268e-19 ,
 3.32000950271e-18 , 3.28682058878e-17 , 3.75057285117e-16 , 7.47604886647e-15 ,
 1.97521653106e-13 , 4.65949548966e-12 , 8.84654804305e-11 , 1.33035057489e-09 ,
 1.58203133923e-08 , 1.48808443993e-07 , 1.1073115288e-06  , 6.51673368461e-06 ,
 3.03115678523e-05 , 0.00011131310312  , 0.000322308395962 , 0.000734768455276 ,
 0.00131684513959  , 0.0018526760369   , 0.00204347606991  , 0.00176495533789  ,
 0.00119247779127  , 0.000629717936502 , 0.000259723413593 , 8.36164294167e-05 ,
 2.10030333048e-05 , 4.11450116227e-06 , 6.28442278901e-07 , 7.48207574857e-08 ,
 6.94232099212e-09 , 5.01935694317e-10 , 2.82749035123e-11 , 1.24086271557e-12 ,
 4.24213502022e-14 , 1.12968880473e-15 , 2.338734771e-17   , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 2.24300397854e-26 , 1.17417447136e-24 , 4.50563959601e-23 ,
 1.35410892091e-21 , 3.19114305829e-20 , 5.90498666728e-19 , 8.59256511753e-18 ,
 9.84766770762e-17 , 9.00461044121e-16 , 6.92712531467e-15 , 5.79745459807e-14 ,
 8.31916478716e-13 , 1.66692129532e-11 , 3.06409184574e-10 , 4.5630617299e-09  ,
 5.3932579437e-08  , 5.04557457547e-07 , 3.73520353027e-06 , 2.18749738752e-05 ,
 0.000101284162079 , 0.000370398451957 , 0.00106851516222  , 0.00242801781827  ,
 0.00433942317519  , 0.00609094095622  , 0.00670525915593  , 0.00578219906282  ,
 0.00390169338979  , 0.00205826656654  , 0.00084822196019  , 0.000272901772964 ,
 6.85129067954e-05 , 1.34162361052e-05 , 2.04851824657e-06 , 2.43830165339e-07 ,
 2.26195808524e-08 , 1.63516309636e-09 , 9.21004743951e-11 , 4.04151000138e-12 ,
 1.38156892349e-13 , 3.67893439406e-15 , 7.61476331642e-17 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 5.20318336745e-25 , 2.72377808435e-23 , 1.04519070095e-21 ,
 3.14117900922e-20 , 7.40261838272e-19 , 1.36980267116e-17 , 1.99319991358e-16 ,
 2.28415129401e-15 , 2.06760512291e-14 , 1.49068246333e-13 , 8.96012099784e-13 ,
 5.6249292145e-12  , 5.81193736654e-11 , 8.76945474829e-10 , 1.25199023635e-08 ,
 1.46036878914e-07 , 1.35559230146e-06 , 9.97138239643e-06 , 5.80640206356e-05 ,
 0.00026745521251  , 0.000973537917315 , 0.00279683847666  , 0.00633245535751  ,
 0.0112826351433   , 0.0157954565556   , 0.017350980037    , 0.0149358751531   ,
 0.0100638640051   , 0.00530284730334  , 0.0021833021885   , 0.0007019239472   ,
 0.000176117384336 , 3.44715038536e-05 , 5.26152682707e-06 , 6.2608842737e-07  ,
 5.80678637644e-08 , 4.19697616053e-09 , 2.36362175781e-10 , 1.03708281849e-11 ,
 3.54491781783e-13 , 9.43903157608e-15 , 1.95326921584e-16 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 9.44620568988e-24 , 4.94492817594e-22 , 1.89750882279e-20 ,
 5.70270561968e-19 , 1.34392065297e-17 , 2.48683101719e-16 , 3.61854419253e-15 ,
 4.14658481627e-14 , 3.74844153752e-13 , 2.679474453e-12   , 1.52620388643e-11 ,
 7.21166566931e-11 , 3.4411473588e-10  , 2.57319279353e-09 , 2.89779465873e-08 ,
 3.19328149186e-07 , 2.90776280854e-06 , 2.11577153911e-05 , 0.00012221559064  ,
 0.000559264579356 , 0.00202444160352  , 0.00578836193027  , 0.0130526381597   ,
 0.0231763076808   , 0.0323530480389   , 0.0354544391612   , 0.0304598306297   ,
 0.0204913852376   , 0.0107834949835   , 0.00443526122811  , 0.00142475835344  ,
 0.000357250428577 , 6.98890664003e-05 , 1.06631723982e-05 , 1.26845008673e-06 ,
 1.17615947092e-07 , 8.49929363519e-09 , 4.78584474448e-10 , 2.09962983347e-11 ,
 7.17621418782e-13 , 1.9106686522e-14  , 3.95284284482e-16 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 1.34359687634e-22 , 7.0335013539e-21  , 2.69895343254e-19 ,
 8.11133878387e-18 , 1.91154803383e-16 , 3.53718571918e-15 , 5.14686738331e-14 ,
 5.89781873076e-13 , 5.3303491327e-12  , 3.80541611208e-11 , 2.15095660519e-10 ,
 9.69910062588e-10 , 3.62341826906e-09 , 1.33749076045e-08 , 7.3401027917e-08  ,
 6.10653888142e-07 , 5.13431825781e-06 , 3.62325998492e-05 , 0.000205759246544 ,
 0.000930858789047 , 0.00334151502867  , 0.0094931785224   , 0.0212987992025   ,
 0.0376645380658   , 0.0524047854313   , 0.0572749299548   , 0.0491000331562   ,
 0.0329737981552   , 0.0173280982587   , 0.00711913219157  , 0.00228488914678  ,
 0.000572523018189 , 0.000111941184794 , 1.70717746252e-05 , 2.03010131092e-06 ,
 1.88189169954e-07 , 1.35962935764e-08 , 7.65465079073e-10 , 3.35779447612e-11 ,
 1.14752859874e-12 , 3.05505973191e-14 , 6.31865561623e-16 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 1.49915287957e-21 , 7.84781059993e-20 , 3.01142692535e-18 ,
 9.05043552062e-17 , 2.13285903668e-15 , 3.94670622556e-14 , 5.74273442132e-13 ,
 6.58056620727e-12 , 5.94707956373e-11 , 4.24457114628e-10 , 2.39583791006e-09 ,
 1.07205723249e-08 , 3.83568180419e-08 , 1.14198819916e-07 , 3.34375226001e-07 ,
 1.38536982415e-06 , 8.44184968983e-06 , 5.3100067955e-05  , 0.000286156894787 ,
 0.00125638882364  , 0.0044257272864   , 0.0124173766947   , 0.0276214098759   ,
 0.0485475232742   , 0.0672437378494   , 0.0732441786509   , 0.0626269820194   ,
 0.0419733628305   , 0.0220228431368   , 0.00903682306865  , 0.00289758239631  ,
 0.000725497841265 , 0.000141767487533 , 2.16104969985e-05 , 2.56889820263e-06 ,
 2.38068099417e-07 , 1.71961555879e-08 , 9.67969078552e-10 , 4.24552994712e-11 ,
 1.45076089558e-12 , 3.86203632188e-14 , 7.98539614238e-16 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 1.31397973914e-20 , 6.878460673e-19   , 2.6394599375e-17  ,
 7.93253914699e-16 , 1.86941145152e-14 , 3.45921492558e-13 , 5.03339385356e-12 ,
 5.76771222299e-11 , 5.21237235412e-10 , 3.71986976164e-09 , 2.09885204883e-08 ,
 9.3745723632e-08  , 3.32445461718e-07 , 9.46926120492e-07 , 2.2748948672e-06  ,
 5.47582693251e-06 , 1.7915051269e-05  , 7.99764337777e-05 , 0.000366427849543 ,
 0.00146961675771  , 0.00489673344797  , 0.0132679510336   , 0.0288725308517   ,
 0.0500427034048   , 0.0686893914808   , 0.0743684984067   , 0.0633257671166   ,
 0.0423182259566   , 0.0221572009912   , 0.00907793220922  , 0.00290741411462  ,
 0.000727327453081 , 0.000142031123788 , 2.16397377235e-05 , 2.5713741474e-06  ,
 2.38226100163e-07 , 1.72035789666e-08 , 9.68213047997e-10 , 4.2460085919e-11  ,
 1.4507675133e-12  , 3.86172123027e-14 , 7.98241223689e-16 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 9.06016878473e-20 , 4.74284441534e-18 , 1.81996356732e-16 ,
 5.46965386317e-15 , 1.28899881592e-13 , 2.38520200539e-12 , 3.47062959357e-11 ,
 3.9769492336e-10  , 3.59400028633e-09 , 2.56480618858e-08 , 1.4469125445e-07  ,
 6.45851053087e-07 , 2.28405262219e-06 , 6.42818541524e-06 , 1.46584909069e-05 ,
 2.89837770217e-05 , 6.00783983509e-05 , 0.000163582733855 , 0.000543643887502 ,
 0.00177661404578  , 0.00512985039581  , 0.0125816525051   , 0.02562512069     ,
 0.0425752558848   , 0.0569158874545   , 0.0606188351948   , 0.0510911682661   ,
 0.0339210307038   , 0.0176860468079   , 0.00722597213788  , 0.00230994065335  ,
 0.000577112885741 , 0.000112594605728 , 1.71435817517e-05 , 2.0361402363e-06  ,
 1.88572752067e-07 , 1.36142729153e-08 , 7.66056588149e-10 , 3.3589677362e-11  ,
 1.14755415465e-12 , 3.05431971188e-14 , 6.31164765469e-16 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 4.92192152469e-19 , 2.57654228865e-17 , 9.88692161147e-16 ,
 2.97138030443e-14 , 7.00246448835e-13 , 1.29575699636e-11 , 1.88541316006e-10 ,
 2.16046826829e-09 , 1.95242420712e-08 , 1.39329577729e-07 , 7.85961239161e-07 ,
 3.50727331759e-06 , 1.23894246365e-05 , 3.47091126478e-05 , 7.77061574334e-05 ,
 0.000143267342466 , 0.000240267509438 , 0.000450540065113 , 0.001061131152    ,
 0.00269806507141  , 0.00631519596159  , 0.012859148235    , 0.0224465661379   ,
 0.0332052853658   , 0.0409584147664   , 0.0413896808188   , 0.0337473965493   ,
 0.0219507486509   , 0.0113009980067   , 0.00458125883738  , 0.00145737119551  ,
 0.00036298779472  , 7.06791776798e-05 , 1.07477406804e-05 , 1.27542068287e-06 ,
 1.18052540026e-07 , 8.51961017039e-09 , 4.79255022149e-10 , 2.10100420166e-11 ,
 7.17683395405e-13 , 1.90991277892e-14 , 3.94568475364e-16 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 2.10956739583e-18 , 1.10432268756e-16 , 4.23759854196e-15 ,
 1.27355281456e-13 , 3.00130156505e-12 , 5.55369828377e-11 , 8.08100159428e-10 ,
 9.25990109052e-09 , 8.36819513188e-08 , 5.97169300416e-07 , 3.36853595927e-06 ,
 1.50297915688e-05 , 5.30650483683e-05 , 0.000148357337784 , 0.000329489452513 ,
 0.000589401554318 , 0.000893670627288 , 0.00132387708065  , 0.00232705341712  ,
 0.00478327130782  , 0.00952887945134  , 0.0164412143079   , 0.0239021677182   ,
 0.0293550089453   , 0.030613351833    , 0.0270337719759   , 0.0199783827781   ,
 0.012155939206    , 0.00599379392793  , 0.00236470959357  , 0.000739708660716 ,
 0.000182342674335 , 3.52795413324e-05 , 5.34369731259e-06 , 6.32583875365e-07 ,
 5.84623585475e-08 , 4.2150343636e-09  , 2.3696257326e-10  , 1.03840371511e-11 ,
 3.54614507502e-13 , 9.43395492221e-15 , 1.94846164397e-16 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 7.14224528189e-18 , 3.73884404949e-16 , 1.43470022587e-14 ,
 4.31179710069e-13 , 1.01613401804e-11 , 1.88028481302e-10 , 2.73593968709e-09 ,
 3.13507242105e-08 , 2.8331699474e-07  , 2.0217928042e-06  , 1.14044314142e-05 ,
 5.08813259563e-05 , 0.000179600254706 , 0.000501634120369 , 0.00110991186791  ,
 0.001957338874    , 0.00282133148142  , 0.00361549450133  , 0.00494597252581  ,
 0.00820187357408  , 0.0144849015258   , 0.0228864316303   , 0.0300492956833   ,
 0.0322967275413   , 0.0285708038794   , 0.0210382997287   , 0.01302232736     ,
 0.00679689845359  , 0.00297401285867  , 0.00107711792105  , 0.00031806857891  ,
 7.55397594953e-05 , 1.42766122056e-05 , 2.13120498263e-06 , 2.50041203508e-07 ,
 2.29817253848e-08 , 1.65136323689e-09 , 9.26447141921e-11 , 4.05463198417e-12 ,
 1.38353641823e-13 , 3.67648349248e-15 , 7.59155337189e-17 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 1.91180018259e-17 , 1.00079491174e-15 , 3.8403331803e-14  ,
 1.15416009379e-12 , 2.71993627291e-11 , 5.03305152229e-10 , 7.32342508185e-09 ,
 8.39180251323e-08 , 7.58368195099e-07 , 5.41181993636e-06 , 3.05265066805e-05 ,
 0.00013619117602  , 0.000480669181018 , 0.00134191663319  , 0.00296378986359  ,
 0.00519089782503  , 0.00729499653098  , 0.00860296459002  , 0.00968789940309  ,
 0.0126482920332   , 0.01932773376     , 0.0286258723236   , 0.0359930802693   ,
 0.0367211756248   , 0.0301187085141   , 0.0199132604668   , 0.0106949876724   ,
 0.00471530220635  , 0.00172539118726  , 0.000528060182664 , 0.000135301434166 ,
 2.88233742872e-05 , 5.04290723976e-06 , 7.14796965341e-07 , 8.1101814737e-08  ,
 7.29852243049e-09 , 5.17608699162e-10 , 2.88054169632e-11 , 1.25445938244e-12 ,
 4.26731145358e-14 , 1.12880850391e-15 , 2.33039835572e-17 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 4.04780480638e-17 , 2.11895703893e-15 , 8.13103756703e-14 ,
 2.44367315032e-12 , 5.75885033321e-11 , 1.06563490935e-09 , 1.55056972241e-08 ,
 1.77677440255e-07 , 1.60567280708e-06 , 1.14582923584e-05 , 6.46326739355e-05 ,
 0.000288348559238 , 0.00101763145329  , 0.00284036026762  , 0.00626788530264  ,
 0.0109415049612   , 0.0151856564344   , 0.0171320362756   , 0.0169564637704   ,
 0.0175611010083   , 0.0220028757428   , 0.0297906669531   , 0.0362185038003   ,
 0.03621486761     , 0.0290045192122   , 0.0184949282035   , 0.00939196042838  ,
 0.00381005855281  , 0.0012417405101   , 0.000327842245453 , 7.08519033276e-05 ,
 1.26647019653e-05 , 1.88518079852e-06 , 2.33699096304e-07 , 2.39554755796e-08 ,
 2.00677071211e-09 , 1.356561515e-10   , 7.3192747061e-12  , 3.12589507411e-13 ,
 1.05025400491e-14 , 2.72653332921e-16 , 5.62787852139e-18 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 6.77897790395e-17 , 3.54867974951e-15 , 1.36172880461e-13 ,
 4.09249138307e-12 , 9.64451623245e-11 , 1.78465016217e-09 , 2.59678475397e-08 ,
 2.97561631649e-07 , 2.68906717038e-06 , 1.9189528969e-05  , 0.000108241997193 ,
 0.00048290141986  , 0.00170419552536  , 0.00475615567486  , 0.0104911682294   ,
 0.0182846456387   , 0.0252231595581   , 0.0278226218133   , 0.0255487460502   ,
 0.0220433102659   , 0.0217992273881   , 0.0255669391181   , 0.0295077565171   ,
 0.029002561849    , 0.0230172427958   , 0.0145275737359   , 0.007262223201    ,
 0.00287253668015  , 0.000899439726494 , 0.000223348243786 , 4.41476381146e-05 ,
 6.98909212369e-06 , 8.94037434753e-07 , 9.34060339792e-08 , 8.05310648656e-09 ,
 5.76626583743e-10 , 3.42754081393e-11 , 1.67898443106e-12 , 6.70056948916e-14 ,
 2.14958077282e-15 , 5.17327118332e-17 , 1.06766460979e-18 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 8.97574013301e-17 , 4.69864745071e-15 , 1.80300394175e-13 ,
 5.41868400687e-12 , 1.27698707147e-10 , 2.3629751138e-09  , 3.43828603362e-08 ,
 3.93987984005e-07 , 3.56047281842e-06 , 2.54079865474e-05 , 0.000143318210488 ,
 0.000639385279023 , 0.00225640943362  , 0.0062969802522   , 0.0138871698341   ,
 0.0241848249683   , 0.0332642110004   , 0.0362865797392   , 0.0320185252166   ,
 0.0245104543031   , 0.019321164668    , 0.0184586569086   , 0.019422449602    ,
 0.0185496613517   , 0.0145947163235   , 0.00917398857123  , 0.00456648928089  ,
 0.00179458162944  , 0.000556009739673 , 0.000135712120932 , 2.60945750155e-05 ,
 3.95624669029e-06 , 4.74075056227e-07 , 4.50954247491e-08 , 3.42858262703e-09 ,
 2.10328713892e-10 , 1.0527315399e-11  , 4.34371725161e-13 , 1.4864407724e-14  ,
 4.19651052764e-16 , 7.69986784827e-18 , 1.58891007523e-19 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 9.38752898481e-17 , 4.91421191783e-15 , 1.88572212565e-13 ,
 5.66728229875e-12 , 1.33557266242e-10 , 2.47138364552e-09 , 3.59602765508e-08 ,
 4.12063354921e-07 , 3.72382001395e-06 , 2.65736503194e-05 , 0.000149893282701 ,
 0.000668717581072 , 0.00235990921923  , 0.006585656289    , 0.0145224209386   ,
 0.0252818034523   , 0.0347237435615   , 0.0376742918486   , 0.0325795936928   ,
 0.0232890747727   , 0.0154217964737   , 0.0115886769044   , 0.0104718367027   ,
 0.00947023915443  , 0.00733790769225  , 0.00459260621803  , 0.00228185623307  ,
 0.000895180913645 , 0.000276631605473 , 6.72352566831e-05 , 1.28380216179e-05 ,
 1.92429448743e-06 , 2.26363516584e-07 , 2.09077229817e-08 , 1.51853896326e-09 ,
 8.6986884787e-11  , 3.94953144466e-12 , 1.43195386573e-13 , 4.18715148555e-15 ,
 9.8957654315e-17  , 8.9788984494e-19  , 1.85265728338e-20 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 7.74609983338e-17 , 4.05495164696e-15 , 1.55599965304e-13 ,
 4.67634609077e-12 , 1.10204497846e-10 , 2.03925702661e-09 , 2.96725466754e-08 ,
 3.40013211008e-07 , 3.07270222101e-06 , 2.19271904272e-05 , 0.000123684096605 ,
 0.000551790352466 , 0.00194726633509  , 0.00543405474553  , 0.011982407808    ,
 0.0208562543966   , 0.0286258977185   , 0.0309772896352   , 0.0265239168938   ,
 0.0182891708676   , 0.0108326687043   , 0.00651099525164  , 0.00474995696217  ,
 0.00388964730692  , 0.00292389781241  , 0.00181547159715  , 0.000900097335392 ,
 0.000352822068567 , 0.000108953011951 , 2.64539246704e-05 , 5.04276544078e-06 ,
 7.53789175561e-07 , 8.82712860332e-08 , 8.09273829899e-09 , 5.8071469343e-10  ,
 3.26232748638e-11 , 1.43616317513e-12 , 4.96416492885e-14 , 1.35188023421e-15 ,
 2.87999939584e-17 , 8.19427777781e-20 , 1.69062357612e-21 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 5.03564512488e-17 , 2.63607466104e-15 , 1.01153641648e-13 ,
 3.04003561802e-12 , 7.16426013418e-11 , 1.32569614713e-09 , 1.92897610622e-08 ,
 2.21038445453e-07 , 1.99752626254e-06 , 1.42545989223e-05 , 8.04055146397e-05 ,
 0.000358712012342 , 0.00126589169132  , 0.00353258610985  , 0.00778938787922  ,
 0.0135568494893   , 0.0186011551147   , 0.0201038617821   , 0.0171311421203   ,
 0.0116008723165   , 0.00645326866164  , 0.00328324795332  , 0.00187725761459  ,
 0.00130754162089  , 0.000926795137649 , 0.00056623266036  , 0.000279593386862 ,
 0.000109480321843 , 3.3795538249e-05  , 8.20325296072e-06 , 1.56311780546e-06 ,
 2.33503481762e-07 , 2.73150377408e-08 , 2.49986285054e-09 , 1.78866055346e-10 ,
 1.00006777575e-11 , 4.36848269008e-13 , 1.49104258437e-14 , 3.9789570716e-16  ,
 8.19989172003e-18 , 5.84711661365e-21 , 1.20628284789e-22 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 2.57526104098e-17 , 1.34810539808e-15 , 5.17306176328e-14 ,
 1.55469360849e-12 , 3.6638483359e-11  , 6.77969466716e-10 , 9.86490686137e-09 ,
 1.13040470993e-07 , 1.0215476701e-06  , 7.28989272161e-06 , 4.11198907691e-05 ,
 0.000183447569199 , 0.000647384493044 , 0.00180658055285  , 0.00398348657217  ,
 0.0069326811051   , 0.00951074707115  , 0.0102729093366   , 0.00873366595311  ,
 0.00586219846602  , 0.00315630244126  , 0.00144701027274  , 0.00066414957009  ,
 0.000370246906819 , 0.000235924730679 , 0.000139525106629 , 6.83197728665e-05 ,
 2.6697142076e-05  , 8.23691435782e-06 , 1.99902813624e-06 , 3.80867955083e-07 ,
 5.68865037759e-08 , 6.6528944064e-09  , 6.0862339544e-10  , 4.35180078978e-11 ,
 2.43046577531e-12 , 1.05973625564e-13 , 3.60622461995e-15 , 9.57617557081e-17 ,
 1.95709487749e-18 , 3.25970221588e-22 , 6.7245348325e-24  , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 1.03452945862e-17 , 5.41558593653e-16 , 2.07811351945e-14 ,
 6.24548856026e-13 , 1.47183488396e-11 , 2.72352734034e-10 , 3.96291350326e-09 ,
 4.54104245561e-08 , 4.10374381306e-07 , 2.92848321013e-06 , 1.65186117049e-05 ,
 7.36942354843e-05 , 0.00026006607699  , 0.000725735198624 , 0.0016002286594   ,
 0.00278491229313  , 0.00382025722149  , 0.00412521807784  , 0.00350323849874  ,
 0.00234142663555  , 0.00124035304905  , 0.00053680715783  , 0.000210082849532 ,
 9.15289209537e-05 , 4.91461619322e-05 , 2.72880504213e-05 , 1.31335015308e-05 ,
 5.1103375456e-06  , 1.57509115027e-06 , 3.82165379898e-07 , 7.28071431542e-08 ,
 1.08739803939e-08 , 1.27164023642e-09 , 1.16321922355e-10 , 8.31600989524e-12 ,
 4.6432814634e-13  , 2.02372189991e-14 , 6.88184280502e-16 , 1.82535685827e-17 ,
 3.72324249292e-19 , 1.41886291457e-23 , 2.92688997755e-25 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 3.26002034698e-18 , 1.70656525987e-16 , 6.54857365374e-15 ,
 1.96808506646e-13 , 4.63806190255e-12 , 8.58240862171e-11 , 1.24879756161e-09 ,
 1.43097817812e-08 , 1.29317615923e-07 , 9.2282677316e-07  , 5.20536260355e-06 ,
 2.32226054609e-05 , 8.19522845675e-05 , 0.000228694268045 , 0.000504264160841 ,
 0.000877573670265 , 0.00120378593745  , 0.00129970331981  , 0.00110315836078  ,
 0.000735802231869 , 0.000386719029031 , 0.000162480863323 , 5.76863071414e-05 ,
 2.02542311193e-05 , 8.63660770685e-06 , 4.28099852103e-06 , 1.99000127562e-06 ,
 7.67488191166e-07 , 2.36048662925e-07 , 5.7243784287e-08  , 1.09043147116e-08 ,
 1.62853806853e-09 , 1.90443166987e-10 , 1.74201896981e-11 , 1.24534844439e-12 ,
 6.95305542928e-14 , 3.03012033038e-15 , 1.03025574168e-16 , 2.73196179498e-18 ,
 5.56998903683e-20 , 4.81950460517e-25 , 9.94154354949e-27 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 8.04845738119e-19 , 4.21323068582e-17 , 1.61673579763e-15 ,
 4.85888034247e-14 , 1.14506167388e-12 , 2.11885640787e-11 , 3.08307706161e-10 ,
 3.53285122581e-09 , 3.19264056426e-08 , 2.27830846198e-07 , 1.28511893639e-06 ,
 5.73328156828e-06 , 2.02326775307e-05 , 5.64608547001e-05 , 0.000124494389474 ,
 0.000216657316713 , 0.000297188303769 , 0.000320847336299 , 0.000272259458372 ,
 0.000181419036239 , 9.49880698107e-05 , 3.93294645953e-05 , 1.32416568728e-05 ,
 3.99168762701e-06 , 1.32763108399e-06 , 5.49736874056e-07 , 2.38932231658e-07 ,
 9.04800329217e-08 , 2.77039211803e-08 , 6.71134265029e-09 , 1.27812214442e-09 ,
 1.90873900038e-10 , 2.23206651328e-11 , 2.04169676194e-12 , 1.4595716066e-13  ,
 8.14900327872e-15 , 3.5512334384e-16  , 1.20739334059e-17 , 3.20149318033e-19 ,
 6.52661885355e-21 , 1.27697063975e-26 , 2.63403085435e-28 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 1.55505907589e-19 , 8.14047003854e-18 , 3.12372863066e-16 ,
 9.38794307701e-15 , 2.21239731304e-13 , 4.09388623374e-12 , 5.95687687617e-11 ,
 6.82589482934e-10 , 6.16856678183e-09 , 4.40196683802e-08 , 2.48300483572e-07 ,
 1.10773916163e-06 , 3.90919723511e-06 , 1.09089163418e-05 , 2.40538007495e-05 ,
 4.18606903385e-05 , 5.74197447205e-05 , 6.19889905439e-05 , 5.25953379972e-05 ,
 3.50304508652e-05 , 1.8308175328e-05  , 7.52691597733e-06 , 2.46663064077e-06 ,
 6.78635331274e-07 , 1.82648677456e-07 , 5.96556660307e-08 , 2.29964647002e-08 ,
 8.3932705753e-09  , 2.54606074865e-09 , 6.15420807049e-10 , 1.17141323599e-10 ,
 1.74917097398e-11 , 2.04541141411e-12 , 1.87094748125e-13 , 1.3375012166e-14  ,
 7.46744394384e-16 , 3.25420232347e-17 , 1.10639589692e-18 , 2.93365137506e-20 ,
 5.98045405669e-22 , 2.59631277746e-28 , 5.35495072171e-30 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 2.34919779066e-20 , 1.22976512763e-18 , 4.71895666957e-17 ,
 1.41821847653e-15 , 3.34222600313e-14 , 6.18455507228e-13 , 8.99893914873e-12 ,
 1.03117478304e-10 , 9.31873501067e-10 , 6.6499665043e-09  , 3.75102756966e-08 ,
 1.67344020356e-07 , 5.9055488277e-07  , 1.64798883272e-06 , 3.63376009634e-06 ,
 6.32380543783e-06 , 8.67424567646e-06 , 9.36437196976e-06 , 7.94486878207e-06 ,
 5.29041278949e-06 , 2.76257821974e-06 , 1.13191347099e-06 , 3.66045806177e-07 ,
 9.5880181256e-08  , 2.22961856343e-08 , 5.6736863971e-09  , 1.81286778503e-09 ,
 6.16301641533e-10 , 1.83389100547e-10 , 4.41215808961e-11 , 8.38908713777e-12 ,
 1.25235447447e-12 , 1.46436894154e-13 , 1.33944711411e-14 , 9.57538547248e-16 ,
 5.34605817882e-17 , 2.329730297e-18   , 7.92082906578e-20 , 2.10023028446e-21 ,
 4.28143856705e-23 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.77263833728e-21 ,
 1.45142905901e-19 , 5.56954387836e-18 , 1.67385093512e-16 , 3.94465888951e-15 ,
 7.29931492385e-14 , 1.06209889086e-12 , 1.21704300389e-11 , 1.09984276536e-10 ,
 7.84861629863e-10 , 4.42714652564e-09 , 1.97507611731e-08 , 6.9700180095e-08  ,
 1.94503708649e-07 , 4.28874101244e-07 , 7.46366031878e-07 , 1.02377448307e-06 ,
 1.10521868571e-06 , 9.37658336066e-07 , 6.24312576417e-07 , 3.25873784504e-07 ,
 1.33305011282e-07 , 4.28340799139e-08 , 1.09446404769e-08 , 2.3351005924e-09  ,
 4.82802092647e-10 , 1.20995644954e-10 , 3.62688109601e-11 , 1.03820143556e-11 ,
 2.47359414336e-12 , 4.69237543871e-13 , 7.00122563901e-14 , 8.18548283163e-15 ,
 7.48699029259e-16 , 5.35222594124e-17 , 2.98821508024e-18 , 1.30221837727e-19 ,
 4.427400539e-21   , 1.17393780578e-22 , 2.39313880681e-24 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 2.55499353638e-22 , 1.3374957038e-20  , 5.13234936504e-19 ,
 1.54245804893e-17 , 3.63501356467e-16 , 6.72633794307e-15 , 9.78726927578e-14 ,
 1.12150833616e-12 , 1.01350800741e-11 , 7.23252060731e-11 , 4.0796271919e-10  ,
 1.82003784604e-09 , 6.42288993621e-09 , 1.7923567668e-08  , 3.95208584304e-08 ,
 6.87778060145e-08 , 9.4340979616e-08  , 1.01845740124e-07 , 8.64039780649e-08 ,
 5.75267321672e-08 , 3.00215293595e-08 , 1.22714750574e-08 , 3.93108470826e-09 ,
 9.92326106991e-10 , 2.02238334252e-10 , 3.63326675883e-11 , 7.09055732013e-12 ,
 1.74979856172e-12 , 4.64956417794e-13 , 1.08575211697e-13 , 2.04972115007e-14 ,
 3.05483652571e-15 , 3.57064102473e-16 , 3.26575498501e-17 , 2.33455071492e-18 ,
 1.30340903552e-19 , 5.68005700248e-21 , 1.93115746739e-22 , 5.12051877825e-24 ,
 1.04384679827e-25 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.83731275888e-23 ,
 9.61802011058e-22 , 3.69070639011e-20 , 1.10919178972e-18 , 2.61396230791e-17 ,
 4.83695412429e-16 , 7.03809010039e-15 , 8.06484065762e-14 , 7.28820314691e-13 ,
 5.20095342746e-12 , 2.93368690891e-11 , 1.30880125783e-10 , 4.6187426436e-10  ,
 1.2888955993e-09  , 2.84197097759e-09 , 4.94585684188e-09 , 6.78411856445e-09 ,
 7.32377913698e-09 , 6.21331667951e-09 , 4.13665474508e-09 , 2.15860156397e-09 ,
 8.82020270742e-10 , 2.82139117741e-10 , 7.08063310546e-11 , 1.41024072594e-11 ,
 2.33492679032e-12 , 3.71664828091e-13 , 7.16064930215e-14 , 1.66906314948e-14 ,
 3.74310865378e-15 , 6.99534089018e-16 , 1.04009463549e-16 , 1.21505066715e-17 ,
 1.11116297075e-18 , 7.94294790018e-20 , 4.43464774423e-21 , 1.93255158487e-22 ,
 6.57046473759e-24 , 1.74217735419e-25 , 3.55152735873e-27 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 1.03060138021e-24 , 5.3950231135e-23  , 2.07022298257e-21 ,
 6.22177462099e-20 , 1.46624636951e-18 , 2.71318618587e-17 , 3.94786643508e-16 ,
 4.52380024727e-15 , 4.0881620106e-14  , 2.91736382647e-13 , 1.64558906077e-12 ,
 7.3414413297e-12  , 2.59078510993e-11 , 7.22978475646e-11 , 1.59414293905e-10 ,
 2.77427265522e-10 , 3.80540553814e-10 , 4.10811350707e-10 , 3.48521396487e-10 ,
 2.32033351518e-10 , 1.21075073465e-10 , 4.94636392283e-11 , 1.58114492311e-11 ,
 3.95706252048e-12 , 7.79345252819e-13 , 1.23598327053e-13 , 1.71782711433e-14 ,
 2.57712510592e-15 , 4.91692019019e-16 , 1.02055667724e-16 , 1.86794190736e-17 ,
 2.76352467151e-18 , 3.22466778516e-19 , 2.94818072776e-20 , 2.10729203444e-21 ,
 1.17652765502e-22 , 5.127127374e-24   , 1.74316742072e-25 , 4.62205783949e-27 ,
 9.4223270846e-29  , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4.50782242456e-26 ,
 2.35976844579e-24 , 9.05509905563e-23 , 2.72138730799e-21 , 6.41332176661e-20 ,
 1.18674026307e-18 , 1.72678604812e-17 , 1.97869793214e-16 , 1.78815095152e-15 ,
 1.27604700808e-14 , 7.19776182328e-14 , 3.21112648261e-13 , 1.13320236453e-12 ,
 3.1622881947e-12  , 6.97273782779e-12 , 1.21345927983e-11 , 1.66447383313e-11 ,
 1.79687682492e-11 , 1.5244203071e-11  , 1.01490031725e-11 , 5.29564279869e-12 ,
 2.16328751788e-12 , 6.91284244381e-13 , 1.72773975188e-13 , 3.38435868714e-14 ,
 5.25187471539e-15 , 6.74602585282e-16 , 8.26067242704e-17 , 1.22062412408e-17 ,
 2.20634831158e-18 , 3.8690136597e-19  , 5.66334010381e-20 , 6.59196524747e-21 ,
 6.02333197829e-22 , 4.30462432538e-23 , 2.40332591806e-24 , 1.04733263604e-25 ,
 3.56081680176e-27 , 9.44160670853e-29 , 1.92472508353e-30 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 1.53707584294e-27 , 8.04633086961e-26 , 3.08760476854e-24 ,
 9.27937770486e-23 , 2.18681239676e-21 , 4.04654313857e-20 , 5.88798952245e-19 ,
 6.74695785573e-18 , 6.09723137301e-17 , 4.35106099096e-16 , 2.45429051535e-15 ,
 1.09492887687e-14 , 3.86398978223e-14 , 1.07827601127e-13 , 2.37756188846e-13 ,
 4.13764943996e-13 , 5.67551691671e-13 , 6.12698226783e-13 , 5.19795507851e-13 ,
 3.46058216523e-13 , 1.80566236008e-13 , 7.37565789207e-14 , 2.35622976755e-14 ,
 5.88207298713e-15 , 1.14668452643e-15 , 1.7446860657e-16  , 2.07088355707e-17 ,
 1.91691557341e-18 , 1.38335879116e-19 , 7.78130851746e-21 , 3.41097501277e-22 ,
 1.1650679601e-23  , 3.10043526116e-25 , 6.40284710519e-27 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4.084927478e-29   , 2.13839012677e-27 ,
 8.20560782225e-26 , 2.46608422996e-24 , 5.81166511061e-23 , 1.0754079139e-21  ,
 1.56479007206e-20 , 1.79306920113e-19 , 1.62039811436e-18 , 1.1563364737e-17  ,
 6.52251403935e-17 , 2.90987922042e-16 , 1.02689259666e-15 , 2.86562262202e-15 ,
 6.31860030421e-15 , 1.09962029325e-14 , 1.50832342538e-14 , 1.62830470195e-14 ,
 1.38140675537e-14 , 9.19683126995e-15 , 4.79872208294e-15 , 1.96015230673e-15 ,
 6.261908133e-16   , 1.56321769567e-16 , 3.04742485682e-17 , 4.63667169256e-18 ,
 5.50357302464e-19 , 5.09438824036e-20 , 3.67640956944e-21 , 2.06795787753e-22 ,
 9.06499547204e-24 , 3.09628060699e-25 , 8.23970609534e-27 , 1.70161844632e-28 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8.39585689373e-31 ,
 4.39508842789e-29 , 1.68651975764e-27 , 5.06860657727e-26 , 1.1944865324e-24  ,
 2.21031364599e-23 , 3.21615342856e-22 , 3.68534141532e-21 , 3.33044607336e-20 ,
 2.37664820404e-19 , 1.34058914771e-18 , 5.98074987728e-18 , 2.11059886208e-17 ,
 5.88978814814e-17 , 1.29867823134e-16 , 2.26007797429e-16 , 3.100096072e-16   ,
 3.34669668692e-16 , 2.83924096392e-16 , 1.89024847159e-16 , 9.86293737114e-17 ,
 4.02875163535e-17 , 1.28702614305e-17 , 3.21292168277e-18 , 6.26345097436e-19 ,
 9.52987102063e-20 , 1.13116357066e-20 , 1.04706276568e-21 , 7.5562194908e-23  ,
 4.2503272079e-24  , 1.86315191972e-25 , 6.36386545885e-27 , 1.69352806373e-28 ,
 3.49738031825e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 2.54680931616e-31 , 1.22933130065e-29 , 4.61538692736e-28 , 1.349697576e-26   ,
 3.07448037401e-25 , 5.45552539826e-24 , 7.54154046994e-23 , 8.12230441674e-22 ,
 6.81618681894e-21 , 4.45766047974e-20 , 2.27223016643e-19 , 9.0297236736e-19  ,
 2.79830968668e-18 , 6.7650333286e-18  , 1.27640570716e-17 , 1.8805705044e-17  ,
 2.16502859315e-17 , 1.94922950312e-17 , 1.37374757461e-17 , 7.58725248114e-18 ,
 3.28814829668e-18 , 1.11974281391e-18 , 3.00074307104e-19 , 6.33760378221e-20 ,
 1.05633684057e-20 , 1.39109790436e-21 , 1.44856855077e-22 , 1.19318267039e-23 ,
 7.7734721501e-25  , 4.00327930125e-26 , 1.6281318705e-27  , 5.22262721633e-29 ,
 1.31944715267e-30 , 2.20985179083e-32 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 1.788839619e-29   , 8.63463362379e-28 , 3.24177665767e-26 ,
 9.48006779422e-25 , 2.15946763896e-23 , 3.83187697364e-22 , 5.29706181586e-21 ,
 5.70498146289e-20 , 4.78758458862e-19 , 3.13099203132e-18 , 1.59597945531e-17 ,
 6.34233876617e-17 , 1.96548960379e-16 , 4.75165516525e-16 , 8.9652770013e-16  ,
 1.32088374392e-15 , 1.52068272215e-15 , 1.36910876663e-15 , 9.64899127849e-16 ,
 5.32916922813e-16 , 2.30954469536e-16 , 7.86490097984e-17 , 2.1076756936e-17  ,
 4.45143523827e-18 , 7.41954719354e-19 , 9.77085732107e-20 , 1.01745222856e-20 ,
 8.38073121516e-22 , 5.45996705408e-23 , 2.81184169327e-24 , 1.14357473739e-25 ,
 3.66829287947e-27 , 9.26759348214e-29 , 1.5521658455e-30  , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7.31124897681e-28 , 3.52910096448e-26 ,
 1.32496150128e-24 , 3.87464226667e-23 , 8.8260598648e-22  , 1.56614412523e-20 ,
 2.16498658516e-19 , 2.33170930699e-18 , 1.95675579595e-17 , 1.27968220529e-16 ,
 6.52300129969e-16 , 2.59220655235e-15 , 8.03324328355e-15 , 1.94207091548e-14 ,
 3.6642397455e-14  , 5.39864491968e-14 , 6.215252546e-14   , 5.595747636e-14   ,
 3.94368376365e-14 , 2.17810935383e-14 , 9.43944672934e-15 , 3.21449998261e-15 ,
 8.61437861428e-16 , 1.81936664335e-16 , 3.03247738093e-17 , 3.99349219642e-18 ,
 4.15847596733e-19 , 3.42532733908e-20 , 2.23156833702e-21 , 1.14924079747e-22 ,
 4.67395709477e-24 , 1.49928491503e-25 , 3.78780090983e-27 , 6.34392867266e-29 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.36131234682e-26 ,
 1.13979290092e-24 , 4.27922501609e-23 , 1.25139229328e-21 , 2.8505504598e-20  ,
 5.05817196425e-19 , 6.9922520358e-18  , 7.53071601481e-17 , 6.31972955009e-16 ,
 4.13298658127e-15 , 2.10673218162e-14 , 8.37204334991e-14 , 2.59449467671e-13 ,
 6.27230182649e-13 , 1.18343864095e-12 , 1.74359906842e-12 , 2.00733863968e-12 ,
 1.80725728593e-12 , 1.27369060917e-12 , 7.03463461063e-13 , 3.04865586986e-13 ,
 1.03818629647e-13 , 2.78218381656e-14 , 5.87600413004e-15 , 9.79398500003e-16 ,
 1.28977722688e-16 , 1.34306199622e-17 , 1.10627715775e-18 , 7.20729096176e-20 ,
 3.71170027604e-21 , 1.5095468136e-22  , 4.84223693172e-24 , 1.22334516087e-25 ,
 2.04889713777e-27 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 6.03085208798e-25 , 2.91106020159e-23 , 1.09292500664e-21 , 3.19608790211e-20 ,
 7.28037873325e-19 , 1.29187004816e-17 , 1.78583904186e-16 , 1.92336411839e-15 ,
 1.61407508007e-14 , 1.0555753366e-13  , 5.38064783909e-13 , 2.13824127017e-12 ,
 6.62640571857e-12 , 1.60196191824e-11 , 3.0225325372e-11  , 4.45319658643e-11 ,
 5.12679419251e-11 , 4.61578130103e-11 , 3.25303837084e-11 , 1.7966636598e-11  ,
 7.78634501404e-12 , 2.6515543368e-12  , 7.10576857899e-13 , 1.50074647364e-13 ,
 2.50140880204e-14 , 3.29412400364e-15 , 3.43021466646e-16 , 2.8254601369e-17  ,
 1.84076053318e-18 , 9.47977737458e-20 , 3.85542114535e-21 , 1.23671968893e-22 ,
 3.12445480907e-24 , 5.23293565885e-26 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 1.2184196405e-23  , 5.88124675014e-22 , 2.2080483392e-20  ,
 6.45709132953e-19 , 1.47086287468e-17 , 2.60997918152e-16 , 3.60795013977e-15 ,
 3.88579355537e-14 , 3.26093352997e-13 , 2.13259039251e-12 , 1.08705816527e-11 ,
 4.31991221424e-11 , 1.33873999157e-10 , 3.2364611767e-10  , 6.10645552844e-10 ,
 8.99684174768e-10 , 1.03577183553e-09 , 9.32531342403e-10 , 6.57214898411e-10 ,
 3.62981923373e-10 , 1.57308379553e-10 , 5.35696421449e-11 , 1.43558619432e-11 ,
 3.03197450746e-12 , 5.05362354916e-13 , 6.65515473723e-14 , 6.93010019112e-15 ,
 5.70830800362e-16 , 3.71890862911e-17 , 1.91520978665e-18 , 7.78914948894e-20 ,
 2.49855830785e-21 , 6.31237020854e-23 , 1.05721571201e-24 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.94683952068e-22 , 9.39729073911e-21 ,
 3.52810774501e-19 , 1.03173981862e-17 , 2.35020339359e-16 , 4.17032888328e-15 ,
 5.7649267028e-14  , 6.20887599914e-13 , 5.21044971652e-12 , 3.40753802676e-11 ,
 1.73694491378e-10 , 6.90252811509e-10 , 2.13909217881e-09 , 5.17134681393e-09 ,
 9.75713831167e-09 , 1.4375512749e-08  , 1.65499756962e-08 , 1.49003579006e-08 ,
 1.05012418979e-08 , 5.79987001379e-09 , 2.51353605989e-09 , 8.55957118299e-10 ,
 2.29383690606e-10 , 4.8446098541e-11  , 8.0748813636e-12  , 1.06338718024e-12 ,
 1.10731906199e-13 , 9.12096230908e-15 , 5.94222060469e-16 , 3.0601986205e-17  ,
 1.2445813867e-18  , 3.99229616525e-20 , 1.00861570042e-21 , 1.68926145115e-23 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.45868195189e-21 ,
 1.186792691e-19   , 4.45568047331e-18 , 1.30299392638e-16 , 2.96809398294e-15 ,
 5.26674759262e-14 , 7.28058018525e-13 , 7.84124792949e-12 , 6.58032598124e-11 ,
 4.30341184149e-10 , 2.19360407757e-09 , 8.71726771452e-09 , 2.70147964308e-08 ,
 6.53094255757e-08 , 1.23223817958e-07 , 1.81549703351e-07 , 2.09011200545e-07 ,
 1.88178022162e-07 , 1.32621172174e-07 , 7.32471042154e-08 , 3.17436834429e-08 ,
 1.0809962999e-08  , 2.89690821538e-09 , 6.11830337616e-10 , 1.01978436648e-10 ,
 1.3429616772e-11  , 1.39844366409e-12 , 1.15189491352e-13 , 7.50448632242e-15 ,
 3.86475363659e-16 , 1.5717935457e-17  , 5.04190839759e-19 , 1.2737902599e-20  ,
 2.13338418388e-22 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 2.45172087154e-20 , 1.18343261457e-18 , 4.44306544203e-17 , 1.29930485818e-15 ,
 2.95969064283e-14 , 5.25183624831e-13 , 7.25996722897e-12 , 7.81904759701e-11 ,
 6.56169560174e-10 , 4.29122791687e-09 , 2.18739349218e-08 , 8.69258717344e-08 ,
 2.69383114799e-07 , 6.51245199363e-07 , 1.22874943678e-06 , 1.81035695401e-06 ,
 2.08419442933e-06 , 1.87645247954e-06 , 1.32245691875e-06 , 7.30397252265e-07 ,
 3.16538099517e-07 , 1.0779357568e-07  , 2.88870641815e-08 , 6.10098108634e-09 ,
 1.01689712809e-09 , 1.33915945133e-10 , 1.39448435627e-11 , 1.14863364054e-12 ,
 7.48323943761e-14 , 3.85381165179e-15 , 1.56734344546e-16 , 5.0276336235e-18  ,
 1.27018387383e-19 , 2.12734409452e-21 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 1.92785446572e-19 , 9.30565088938e-18 , 3.49370258797e-16 ,
 1.02167856963e-14 , 2.32728484272e-13 , 4.12966095858e-12 , 5.70870868939e-11 ,
 6.14832871169e-10 , 5.15963881343e-09 , 3.37430863316e-08 , 1.72000669453e-07 ,
 6.83521651892e-07 , 2.11823232768e-06 , 5.12091723182e-06 , 9.66198932527e-06 ,
 1.42353266183e-05 , 1.63885847882e-05 , 1.47550536212e-05 , 1.03988366136e-05 ,
 5.74331124261e-06 , 2.48902473282e-06 , 8.47610054887e-07 , 2.271468026e-07   ,
 4.79736652287e-08 , 7.99613729413e-09 , 1.0530173147e-09  , 1.09652078457e-10 ,
 9.03201713981e-12 , 5.88427366887e-13 , 3.03035638729e-14 , 1.23244456403e-15 ,
 3.95336436768e-17 , 9.98779951611e-19 , 1.67278822819e-20 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.19366606589e-18 , 5.76176256308e-17 ,
 2.16318933702e-15 , 6.32590820782e-14 , 1.44098062992e-12 , 2.55695449917e-11 ,
 3.5346505474e-10  , 3.80684925941e-09 , 3.19468397296e-08 , 2.08926440396e-07 ,
 1.06497334777e-06 , 4.23214830617e-06 , 1.31154197279e-05 , 3.17070880325e-05 ,
 5.98239597004e-05 , 8.81406072046e-05 , 0.000101472895789 , 9.13585912278e-05 ,
 6.43862833586e-05 , 3.55607534596e-05 , 1.54112481702e-05 , 5.24813142079e-06 ,
 1.40642063527e-06 , 2.97037651223e-07 , 4.95095346454e-08 , 6.51994773312e-09 ,
 6.78930735879e-10 , 5.59233726301e-11 , 3.64335478939e-12 , 1.87630013125e-13 ,
 7.63090409743e-15 , 2.44779726671e-16 , 6.18412726026e-18 , 1.03573717774e-19 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5.810975147e-18   ,
 2.80492677255e-16 , 1.05307839729e-14 , 3.07956273771e-13 , 7.014945693e-12   ,
 1.24477016406e-10 , 1.72072969746e-09 , 1.85324079045e-08 , 1.55522802397e-07 ,
 1.01709044714e-06 , 5.18447649048e-06 , 2.06028380368e-05 , 6.38481567494e-05 ,
 0.00015435564921  , 0.000291233497331 , 0.000429083889158 , 0.000493987801423 ,
 0.000444749598117 , 0.00031344368672  , 0.000173115966406 , 7.50246510817e-05 ,
 2.55488215053e-05 , 6.84670159547e-06 , 1.4460312296e-06  , 2.41021072464e-07 ,
 3.17402457183e-08 , 3.30515354794e-09 , 2.72244757371e-10 , 1.77364882339e-11 ,
 9.13415715046e-13 , 3.71485755744e-14 , 1.19163051445e-15 , 3.0105412931e-17  ,
 5.0421497022e-19  , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 1.80591780647e-30 , 8.97012984661e-29 ,
 3.39465762887e-27 , 1.00281192371e-25 , 2.31379834827e-24 , 4.17279210078e-23 ,
 5.8870744794e-22  , 6.50412297753e-21 , 5.63389376703e-20 , 3.8312194839e-19  ,
 2.04833013427e-18 , 8.6227363045e-18  , 2.8622207027e-17  , 7.50134653902e-17 ,
 1.55382123157e-16 , 2.7675879522e-16  , 1.40192137059e-15 , 4.05872245077e-14 ,
 1.17729801437e-12 , 2.68116477946e-11 , 4.75757461802e-10 , 6.57671487919e-09 ,
 7.08317886086e-08 , 5.94415918231e-07 , 3.88737048676e-06 , 1.98153280813e-05 ,
 7.87450759695e-05 , 0.000244030843943 , 0.000589955000455 , 0.00111310897223  ,
 0.00163998005462  , 0.00188804604888  , 0.00169985517667  , 0.00119799742534  ,
 0.000661657869746 , 0.000286747963482 , 9.76488718094e-05 , 2.61684354511e-05 ,
 5.52680358042e-06 , 9.21194576566e-07 , 1.21312804377e-07 , 1.26324619335e-08 ,
 1.04053305973e-09 , 6.77897438651e-11 , 3.49112048274e-12 , 1.41983711202e-13 ,
 4.55447134127e-15 , 1.15064391814e-16 , 1.92713479881e-18 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 8.77728735574e-29 , 4.35974477906e-27 , 1.64990263544e-25 , 4.87395848615e-24 ,
 1.12457349461e-22 , 2.02809868827e-21 , 2.86128993274e-20 , 3.16119350317e-19 ,
 2.73823672083e-18 , 1.86208443222e-17 , 9.95548198454e-17 , 4.19090138355e-16 ,
 1.39112275725e-15 , 3.64587324472e-15 , 7.55202446092e-15 , 1.24383786672e-14 ,
 1.92450284141e-14 , 1.37045519595e-13 , 3.54052190473e-12 , 8.03550837971e-11 ,
 1.42571772458e-09 , 1.97085995139e-08 , 2.12263306293e-07 , 1.78130032162e-06 ,
 1.16493756064e-05 , 5.93810650072e-05 , 0.000235977242263 , 0.000731293034791 ,
 0.00176793218309  , 0.00333568013454  , 0.0049145672398   , 0.00565795250551  ,
 0.0050939964423   , 0.00359006738123  , 0.00198280587709  , 0.000859304443024 ,
 0.00029262669692  , 7.84195729834e-05 , 1.65623037552e-05 , 2.7605657e-06     ,
 3.63540966538e-07 , 3.78559991639e-08 , 3.11819017118e-09 , 2.03147137952e-10 ,
 1.04619237937e-11 , 4.25485964718e-13 , 1.36484926054e-14 , 3.44816199978e-16 ,
 5.77509069223e-18 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 3.30174091332e-27 , 1.63999959501e-25 ,
 6.20641755664e-24 , 1.83343070488e-22 , 4.23029367354e-21 , 7.62907279197e-20 ,
 1.0763277597e-18  , 1.18914210066e-17 , 1.03003899099e-16 , 7.00457909687e-16 ,
 3.74494087386e-15 , 1.57648599174e-14 , 5.23296861196e-14 , 1.37146345665e-13 ,
 2.84083534359e-13 , 4.65545433356e-13 , 6.10627132183e-13 , 9.01102779025e-13 ,
 8.77825807697e-12 , 1.88879169285e-10 , 3.34605869145e-09 , 4.62526596834e-08 ,
 4.98144482643e-07 , 4.18039702815e-06 , 2.73390256105e-05 , 0.000139356864421 ,
 0.000553796880409 , 0.00171621550218  , 0.00414902436516  , 0.0078282517197   ,
 0.0115336206995   , 0.0132782145304   , 0.011954709325    , 0.00842525362666  ,
 0.00465329494767  , 0.00201663565226  , 0.000686743138129 , 0.000184036877729 ,
 3.88687996523e-05 , 6.47855978893e-06 , 8.53166395366e-07 , 8.88413392781e-08 ,
 7.31784121539e-09 , 4.76750428062e-10 , 2.45522860785e-11 , 9.98540357788e-13 ,
 3.20305998776e-14 , 8.0922267771e-16  , 1.35531171513e-17 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 9.6794518343e-26  , 4.80785667467e-24 , 1.81948618563e-22 , 5.37492331025e-21 ,
 1.24016162785e-19 , 2.23655473185e-18 , 3.15538468384e-17 , 3.48611353516e-16 ,
 3.01968357375e-15 , 2.05347687077e-14 , 1.09787459896e-13 , 4.62165888392e-13 ,
 1.53410788307e-12 , 4.02061058684e-12 , 8.32825154951e-12 , 1.36437337202e-11 ,
 1.76940827146e-11 , 1.86382593397e-11 , 2.98706282927e-11 , 3.55569668962e-10 ,
 6.14770942882e-09 , 8.49204641345e-08 , 9.14581145355e-07 , 7.67510272857e-06 ,
 5.01937555423e-05 , 0.000255855657844 , 0.00101675698385  , 0.0031509280015   ,
 0.00761750318332  , 0.0143724710068   , 0.0211754341891   , 0.0243784640803   ,
 0.0219485421931   , 0.0154685513202   , 0.00854333114418  , 0.00370249175437  ,
 0.00126084293087  , 0.000337887025616 , 7.13621273401e-05 , 1.1894470958e-05  ,
 1.56639179735e-06 , 1.63110438792e-07 , 1.34353703057e-08 , 8.75301657399e-10 ,
 4.50773726303e-11 , 1.83329469405e-12 , 5.88073665173e-14 , 1.48571224966e-15 ,
 2.48831782988e-17 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 2.21190279703e-24 , 1.09866878915e-22 ,
 4.15780423524e-21 , 1.22825218899e-19 , 2.83395900963e-18 , 5.11086965643e-17 ,
 7.21053663716e-16 , 7.96630264933e-15 , 6.90043884432e-14 , 4.69250874103e-13 ,
 2.50881138498e-12 , 1.05611974596e-11 , 3.50567116362e-11 , 9.18771016689e-11 ,
 1.90313286455e-10 , 3.11774042724e-10 , 4.04040398848e-10 , 4.14782650776e-10 ,
 3.57107697682e-10 , 7.11149505439e-10 , 8.92364828732e-09 , 1.21907287777e-07 ,
 1.31250393517e-06 , 1.10143416917e-05 , 7.20317427143e-05 , 0.000367171744229 ,
 0.00145912128063  , 0.00452181413428  , 0.010931679031    , 0.0206255561891   ,
 0.030388310228    , 0.0349848944176   , 0.0314977772479   , 0.0221985122996   ,
 0.0122603104556   , 0.00531334880992  , 0.00180940262145  , 0.00048489280856  ,
 0.000102409917302 , 1.70694433107e-05 , 2.24788778598e-06 , 2.34075512746e-07 ,
 1.92807475507e-08 , 1.25612245164e-09 , 6.4689355199e-11  , 2.63091313286e-12 ,
 8.43929093241e-14 , 2.13210668311e-15 , 3.57091965553e-17 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 3.94087889509e-23 , 1.95746424737e-21 , 7.40783138508e-20 , 2.18833898848e-18 ,
 5.04917723581e-17 , 9.10587860898e-16 , 1.28467904168e-14 , 1.41933153775e-13 ,
 1.22942987572e-12 , 8.36049788779e-12 , 4.46987175573e-11 , 1.88165593132e-10 ,
 6.24594603361e-10 , 1.63694594263e-09 , 3.39075304328e-09 , 5.55477495151e-09 ,
 7.1983313317e-09  , 7.37760257878e-09 , 5.99834424922e-09 , 4.37572710226e-09 ,
 1.18059153204e-08 , 1.37361271394e-07 , 1.47140887045e-06 , 1.23460315394e-05 ,
 8.07403997307e-05 , 0.0004115628548   , 0.00163552922295  , 0.00506850201881  ,
 0.0122533203692   , 0.023119188467    , 0.0340622606689   , 0.0392145724519   ,
 0.0353058623878   , 0.0248823151646   , 0.0137425834963   , 0.00595573333399  ,
 0.00202815962074  , 0.000543516408703 , 0.000114791288889 , 1.91331411046e-05 ,
 2.51965769555e-06 , 2.62375271003e-07 , 2.1611792299e-08  , 1.4079878104e-09  ,
 7.25103061922e-11 , 2.94899085393e-12 , 9.45960224323e-14 , 2.38987864311e-15 ,
 4.00264428071e-17 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 5.47599848638e-22 , 2.7199697177e-20  ,
 1.02934585233e-18 , 3.04077879772e-17 , 7.01602044539e-16 , 1.26529585931e-14 ,
 1.78510953393e-13 , 1.97221420889e-12 , 1.7083387533e-11  , 1.16172242278e-10 ,
 6.21105383349e-10 , 2.61463122976e-09 , 8.67897541045e-09 , 2.27459755622e-08 ,
 4.71157805834e-08 , 7.71856676376e-08 , 1.00023213787e-07 , 1.02503659989e-07 ,
 8.30309292404e-08 , 5.35516710851e-08 , 3.53873757688e-08 , 1.30129127189e-07 ,
 1.29056239652e-06 , 1.08033722607e-05 , 7.06469243495e-05 , 0.000360112061062 ,
 0.00143106637991  , 0.00443487204094  , 0.010721492802    , 0.0202289832688   ,
 0.0298040263027   , 0.0343122307755   , 0.0308921613123   , 0.021771695744    ,
 0.0120245782854   , 0.00521118767376  , 0.00177461276778  , 0.00047556964872  ,
 0.000100440855251 , 1.67412446953e-05 , 2.20466706429e-06 , 2.2957488213e-07  ,
 1.8910031615e-08  , 1.23197065935e-09 , 6.34455561824e-11 , 2.58032788344e-12 ,
 8.277026496e-14   , 2.09111211472e-15 , 3.5022606568e-17  , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 5.93665007335e-21 , 2.94877883262e-19 , 1.11593641688e-17 , 3.29657499312e-16 ,
 7.60622165901e-15 , 1.37173499493e-13 , 1.93527640154e-12 , 2.13812068374e-11 ,
 1.85204751431e-10 , 1.25944876055e-09 , 6.73353969836e-09 , 2.83457906728e-08 ,
 9.40906761301e-08 , 2.46594110327e-07 , 5.10792512e-07    , 8.36786749187e-07 ,
 1.08437340252e-06 , 1.11125723119e-06 , 8.99939220124e-07 , 5.7561561244e-07  ,
 2.95810352969e-07 , 1.96598168235e-07 , 9.146590241e-07   , 7.38363072205e-06 ,
 4.82318816851e-05 , 0.000245846953078 , 0.000976981940456 , 0.00302766512673  ,
 0.00731950990619  , 0.0138102264451   , 0.0203470607863   , 0.0234247895976   ,
 0.021089925155    , 0.0148634285927   , 0.00820911989601  , 0.00355765195246  ,
 0.00121151932599  , 0.000324669038081 , 6.85704732126e-05 , 1.14291646368e-05 ,
 1.50511525909e-06 , 1.56729632241e-07 , 1.29097846994e-08 , 8.41060252669e-10 ,
 4.33139662123e-11 , 1.76157703525e-12 , 5.65068489518e-14 , 1.4275918588e-15  ,
 2.39097596243e-17 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 5.02380289948e-20 , 2.49536076174e-18 ,
 9.4434479673e-17  , 2.78967815252e-15 , 6.43665332342e-14 , 1.16081058505e-12 ,
 1.63769922047e-11 , 1.80935321397e-10 , 1.56726799751e-09 , 1.06579000898e-08 ,
 5.69815903622e-08 , 2.39872088822e-07 , 7.96228522341e-07 , 2.08676642744e-06 ,
 4.32250658387e-06 , 7.0811849167e-06  , 9.17635049021e-06 , 9.40384708591e-06 ,
 7.61548762342e-06 , 4.86842468962e-06 , 2.45644406968e-06 , 1.01663038641e-06 ,
 7.71353683365e-07 , 4.00104169464e-06 , 2.56947082786e-05 , 0.00013090472097  ,
 0.000520200255305 , 0.0016120988678   , 0.00389731789521  , 0.00735333968126  ,
 0.0108339171751   , 0.0124726727368   , 0.0112294598595   , 0.00791412361727  ,
 0.00437099618307  , 0.00189429357859  , 0.000645080887686 , 0.000172872018461 ,
 3.65107685696e-05 , 6.08552873343e-06 , 8.01407841025e-07 , 8.34516529147e-08 ,
 6.87389395696e-09 , 4.47827684419e-10 , 2.30627866794e-11 , 9.37962484994e-13 ,
 3.00874179223e-14 , 7.60130031579e-16 , 1.27308979988e-17 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 3.32039665465e-19 , 1.64926604233e-17 , 6.24148551733e-16 , 1.843790091e-14   ,
 4.25419599254e-13 , 7.67217914476e-12 , 1.08240930661e-10 , 1.19586107954e-09 ,
 1.03585899367e-08 , 7.04415688908e-08 , 3.76610081648e-07 , 1.58539356978e-06 ,
 5.26253631924e-06 , 1.37921260116e-05 , 2.8568868421e-05  , 4.68018813206e-05 ,
 6.06495200095e-05 , 6.21531182698e-05 , 5.033321557e-05   , 3.21759237145e-05 ,
 1.6215979433e-05  , 6.45012871368e-06 , 2.19972712074e-06 , 2.12098367195e-06 ,
 1.07554253861e-05 , 5.43585487579e-05 , 0.00021596350068  , 0.000669265492332 ,
 0.0016179775891   , 0.003052750393    , 0.00449771754624  , 0.00517804946356  ,
 0.00466192770614  , 0.00328556071466  , 0.00181462585594  , 0.000786418922022 ,
 0.000267806332685 , 7.17680870286e-05 , 1.51575022928e-05 , 2.52641670783e-06 ,
 3.32705710225e-07 , 3.46450833535e-08 , 2.85370775514e-09 , 1.85916358907e-10 ,
 9.57455171904e-12 , 3.89396582812e-13 , 1.24908382926e-14 , 3.15569163507e-16 ,
 5.28525208223e-18 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 1.71523180707e-18 , 8.51968565305e-17 ,
 3.22419144341e-15 , 9.52454703024e-14 , 2.1976086109e-12  , 3.96325110139e-11 ,
 5.59144904681e-10 , 6.17751182702e-09 , 5.35098206142e-08 , 3.63883090087e-07 ,
 1.94547115327e-06 , 8.18973683099e-06 , 2.71849137902e-05 , 7.12465879312e-05 ,
 0.000147579451807 , 0.000241766523162 , 0.000313299875342 , 0.000321067078048 ,
 0.000260008475152 , 0.000166212218883 , 8.37612755053e-05 , 3.32323744954e-05 ,
 1.04225971361e-05 , 3.06275555101e-06 , 3.93641237811e-06 , 1.76594711571e-05 ,
 6.98961509754e-05 , 0.000216582241407 , 0.000523594982387 , 0.000987902825244 ,
 0.00145550971621  , 0.0016756724332   , 0.0015086498879   , 0.00106324274341  ,
 0.000587232421158 , 0.000254493611513 , 8.66650062487e-05 , 2.32249239532e-05 ,
 4.90513057608e-06 , 8.1757558746e-07  , 1.07667142022e-07 , 1.12115211586e-08 ,
 9.23490486394e-10 , 6.01645310059e-11 , 3.09842779385e-12 , 1.2601291741e-13  ,
 4.04216945815e-15 , 1.02121571409e-16 , 1.71036435225e-18 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 6.93112341837e-18 , 3.44274123788e-16 , 1.30287164258e-14 , 3.84879820318e-13 ,
 8.88037199678e-12 , 1.60152012157e-10 , 2.259462731e-09   , 2.49628631624e-08 ,
 2.16229182111e-07 , 1.47042434548e-06 , 7.86150339251e-06 , 3.30941138718e-05 ,
 0.000109852202963 , 0.000287902131977 , 0.000596357524548 , 0.000976960433898 ,
 0.00126602135875  , 0.0012974080437   , 0.00105067479328  , 0.000671651052257 ,
 0.0003384714485   , 0.000134267424726 , 4.18787597648e-05 , 1.03776117051e-05 ,
 2.83526305035e-06 , 4.73053340959e-06 , 1.76607149562e-05 , 5.4626265145e-05  ,
 0.000132053865565 , 0.000249154759252 , 0.000367087882284 , 0.000422614179215 ,
 0.000380490137236 , 0.000268155905886 , 0.000148103377933 , 6.41847455444e-05 ,
 2.18574106462e-05 , 5.85745876039e-06 , 1.23710200824e-06 , 2.06197242958e-07 ,
 2.71542695044e-08 , 2.82760981092e-09 , 2.32909586726e-10 , 1.51738391013e-11 ,
 7.81441225e-13    , 3.17811790685e-14 , 1.01945827471e-15 , 2.5755644853e-17  ,
 4.31363679759e-19 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 2.19317482769e-17 , 1.08936646564e-15 ,
 4.12260050462e-14 , 1.21785269524e-12 , 2.80996414986e-11 , 5.06759641209e-10 ,
 7.14948571339e-09 , 7.89885272706e-08 , 6.8420134889e-07  , 4.65277771852e-06 ,
 2.48756951904e-05 , 0.000104717768112 , 0.000347598898132 , 0.000910991870404 ,
 0.00188701922069  , 0.0030913387368   , 0.00400599730769  , 0.00410531235835  ,
 0.00332458877021  , 0.00212526610701  , 0.00107100508371  , 0.000424850186961 ,
 0.000132467456687 , 3.24424085927e-05 , 6.38913945162e-06 , 1.80554720036e-06 ,
 3.57368295933e-06 , 1.07449404596e-05 , 2.59527277143e-05 , 4.89654874667e-05 ,
 7.21424052013e-05 , 8.30547783069e-05 , 7.47762984052e-05 , 5.2699673592e-05  ,
 2.91062009212e-05 , 1.26139871079e-05 , 4.2955548669e-06  , 1.15114438271e-06 ,
 2.431230139e-07   , 4.05231701443e-08 , 5.33652665519e-09 , 5.55699541983e-10 ,
 4.57728467934e-11 , 2.98205763969e-12 , 1.53573710609e-13 , 6.24583582354e-15 ,
 2.00350307932e-16 , 5.06166020256e-18 , 8.4774284749e-20  , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 5.4405401621e-17  , 2.7023573008e-15  , 1.02268060596e-13 , 3.02108906973e-12 ,
 6.97059013188e-11 , 1.25710278347e-09 , 1.77355054741e-08 , 1.95944367743e-07 ,
 1.69727687488e-06 , 1.15420000829e-05 , 6.17083586019e-05 , 0.000259770090331 ,
 0.000862277708877 , 0.00225986902444  , 0.00468106952861  , 0.0076685872644   ,
 0.00993755215798  , 0.0101839198962   , 0.00824720332285  , 0.00527208112109  ,
 0.00265680874655  , 0.0010539118902   , 0.000328600622031 , 8.04180064627e-05 ,
 1.5451316721e-05  , 2.45010504995e-06 , 8.02542538484e-07 , 1.66871419934e-06 ,
 3.97558134024e-06 , 7.49772542418e-06 , 1.10465021345e-05 , 1.27174087466e-05 ,
 1.14498016926e-05 , 8.06941269586e-06 , 4.45676284559e-06 , 1.93146296316e-06 ,
 6.57738513654e-07 , 1.76264072685e-07 , 3.72271743122e-08 , 6.20493755175e-09 ,
 8.17132877828e-10 , 8.50891216867e-11 , 7.0087718929e-12  , 4.56614854269e-13 ,
 2.35153192736e-14 , 9.56366965011e-16 , 3.06777861841e-17 , 7.75045124881e-19 ,
 1.29807006952e-20 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 1.05945948124e-16 , 5.26241508882e-15 ,
 1.99150935751e-13 , 5.88309499285e-12 , 1.35741260703e-10 , 2.44800961515e-09 ,
 3.45371026944e-08 , 3.81570785282e-07 , 3.30517930904e-06 , 2.24762267274e-05 ,
 0.000120167306269 , 0.000505861324325 , 0.00167914998679  , 0.00440073888433  ,
 0.00911564540776  , 0.0149333655169   , 0.0193518171733   , 0.0198315795284   ,
 0.0160601291302   , 0.0102665473703   , 0.0051737164497   , 0.00205232728211  ,
 0.000639897068436 , 0.000156594078563 , 3.00411386032e-05 , 4.52720145254e-06 ,
 5.93213248202e-07 , 2.44732507102e-07 , 4.7752419266e-07  , 8.94592010889e-07 ,
 1.31775276717e-06 , 1.51706862824e-06 , 1.36585465379e-06 , 9.62605739668e-07 ,
 5.31650276983e-07 , 2.30405533101e-07 , 7.84620755203e-08 , 2.10266613486e-08 ,
 4.44085499276e-09 , 7.40191229003e-10 , 9.74763378444e-11 , 1.01503393114e-11 ,
 8.36081175345e-13 , 5.44698971333e-14 , 2.80515846104e-15 , 1.14085666988e-16 ,
 3.65957401977e-18 , 9.2455661114e-20  , 1.54847663183e-21 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.62190023828e-16 , 8.05610071702e-15 , 3.04875227289e-13 , 9.00628418516e-12 ,
 2.07802928735e-10 , 3.74759719312e-09 , 5.28719937678e-08 , 5.84137249726e-07 ,
 5.05981701406e-06 , 3.44082979389e-05 , 0.000183961148228 , 0.000774410552726 ,
 0.00257056906083  , 0.00673698199078  , 0.0139549154269   , 0.0228611188243   ,
 0.0296252168585   , 0.0303596731467   , 0.0245860532887   , 0.0157168026914   ,
 0.00792031417014  , 0.00314185691739  , 0.000979602466578 , 0.000239725303518 ,
 4.598474237e-05   , 6.90768560531e-06 , 8.17152733628e-07 , 9.26996674878e-08 ,
 4.9391050886e-08  , 8.34133992443e-08 , 1.22468494958e-07 , 1.40978699603e-07 ,
 1.26926268393e-07 , 8.9453108191e-08  , 4.94052421115e-08 , 2.14111449566e-08 ,
 7.29133042053e-09 , 1.95396737235e-09 , 4.12680150088e-10 , 6.87845534197e-11 ,
 9.05828940535e-12 , 9.43251593956e-13 , 7.76954225007e-14 , 5.06178322888e-15 ,
 2.6067800381e-16  , 1.06017625552e-17 , 3.40077205448e-19 , 8.59172753156e-21 ,
 1.4389696801e-22  , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 1.95482892871e-16 , 9.70978261334e-15 ,
 3.67457196124e-13 , 1.08550109617e-11 , 2.50458793318e-10 , 4.51686930759e-09 ,
 6.37250679767e-08 , 7.04043545435e-07 , 6.09844948512e-06 , 4.14713153196e-05 ,
 0.000221722992468 , 0.000933374393466 , 0.00309823171904  , 0.008119887387    ,
 0.0168194514868   , 0.0275538380016   , 0.0357064075628   , 0.0365916262496   ,
 0.0296328510701   , 0.0189430026846   , 0.00954612305909  , 0.00378678826609  ,
 0.00118068620091  , 0.00028893384787  , 5.54237364307e-05 , 8.32395526095e-06 ,
 9.78229159907e-07 , 9.10853556145e-08 , 9.62463403346e-09 , 6.37659428141e-09 ,
 8.87994318972e-09 , 1.02055708369e-08 , 9.18786341406e-09 , 6.47526938462e-09 ,
 3.57631215556e-09 , 1.54989500507e-09 , 5.27799733362e-10 , 1.4144242527e-10  ,
 2.98728024404e-11 , 4.97912820575e-12 , 6.55705126104e-13 , 6.82794375059e-14 ,
 5.62416197239e-15 , 3.6640882863e-16  , 1.88697772517e-17 , 7.67432982334e-19 ,
 2.46172711982e-20 , 6.21931971085e-22 , 1.04163132058e-23 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.85768072196e-16 , 9.22724014891e-15 , 3.49195850011e-13 , 1.03155546269e-11 ,
 2.38011861375e-10 , 4.29239659445e-09 , 6.0558153477e-08  , 6.69055027051e-07 ,
 5.79537773152e-06 , 3.94103350182e-05 , 0.00021070413     , 0.000886988928622 ,
 0.00294426036576  , 0.00771635719208  , 0.0159835831781   , 0.026184507974    ,
 0.0339319231498   , 0.0347731495431   , 0.0281602013154   , 0.0180016012586   ,
 0.00907171390597  , 0.00359859804441  , 0.00112201019804  , 0.000274574836505 ,
 5.26693504876e-05 , 7.91018785985e-06 , 9.29234096211e-07 , 8.53796454208e-08 ,
 6.29583608692e-09 , 6.81488255797e-10 , 5.14745075956e-10 , 5.75912541189e-10 ,
 5.18063955903e-10 , 3.65103795144e-10 , 2.01647859433e-10 , 8.73897457837e-11 ,
 2.97596187951e-11 , 7.97513221667e-12 , 1.68435707101e-12 , 2.80744661221e-13 ,
 3.69714749012e-14 , 3.84988832559e-15 , 3.17114438983e-16 , 2.06597055169e-17 ,
 1.06395919184e-18 , 4.32711719264e-20 , 1.38802761791e-21 , 3.50671991782e-23 ,
 5.87316534401e-25 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 1.39373922629e-16 , 6.92280777528e-15 ,
 2.61986867854e-13 , 7.73932406923e-12 , 1.78570226627e-10 , 3.22040350517e-09 ,
 4.54342196563e-08 , 5.01963671543e-07 , 4.34802664426e-06 , 2.9567906469e-05  ,
 0.000158082391474 , 0.000665470254654 , 0.00220895394761  , 0.00578925623524  ,
 0.0119918060131   , 0.0196451281715   , 0.0254576858975   , 0.0260888224586   ,
 0.0211274072717   , 0.0135058395738   , 0.00680612301726  , 0.0026998758155   ,
 0.000841796766688 , 0.000206001879348 , 3.95155838006e-05 , 5.93467491655e-06 ,
 6.97148064947e-07 , 6.40042032184e-08 , 4.59650254348e-09 , 2.71678089013e-10 ,
 3.316069006e-11   , 2.56520563237e-11 , 2.2761670672e-11  , 1.60346818575e-11 ,
 8.85589233344e-12 , 3.83794889707e-12 , 1.30697137413e-12 , 3.50248757683e-13 ,
 7.39729393305e-14 , 1.23296349386e-14 , 1.62369886819e-15 , 1.69077899478e-16 ,
 1.39269087056e-17 , 9.07324918862e-19 , 4.67265463496e-20 , 1.90036651418e-21 ,
 6.09588575582e-23 , 1.54006762695e-24 , 2.5793539336e-26  , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 8.26410638185e-17 , 4.10484392178e-15 , 1.553437907e-13   , 4.58899313624e-12 ,
 1.05882314398e-10 , 1.90952200076e-09 , 2.69399911786e-08 , 2.97636824966e-07 ,
 2.57814044847e-06 , 1.75321408725e-05 , 9.37341559737e-05 , 0.000394587227988 ,
 0.00130978809172  , 0.00343271025865  , 0.00711048083695  , 0.0116484795743   ,
 0.0150950063343   , 0.015469235572    , 0.0125273894838   , 0.00800821939345  ,
 0.00403565628358  , 0.00160087773496  , 0.000499139143145 , 0.000122147774391 ,
 2.34305658981e-05 , 3.51893538343e-06 , 4.13369836796e-07 , 3.79491442292e-08 ,
 2.72106107127e-09 , 1.52765900272e-10 , 7.39807088295e-12 , 1.09073282024e-12 ,
 7.84255961515e-13 , 5.48604519781e-13 , 3.02928139229e-13 , 1.3128239076e-13  ,
 4.47067773053e-14 , 1.19807468787e-14 , 2.53034748176e-15 , 4.217523462e-16   ,
 5.55408826449e-17 , 5.7835451861e-18  , 4.76389321433e-19 , 3.10363133378e-20 ,
 1.59834663807e-21 , 6.50046850524e-23 , 2.08518267774e-24 , 5.26801594864e-26 ,
 8.82303960006e-28 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 3.87531972551e-17 , 1.92490051376e-15 ,
 7.28459713025e-14 , 2.15193449834e-12 , 4.96518077831e-11 , 8.9543961971e-10  ,
 1.26330754222e-08 , 1.39572000351e-07 , 1.20897748328e-06 , 8.22141538528e-06 ,
 4.3955124343e-05  , 0.000185035332001 , 0.000614204052265 , 0.00160971424648  ,
 0.00333434558705  , 0.0054623670825   , 0.00707856035497  , 0.00725404913498  ,
 0.00587451774364  , 0.00375532563929  , 0.00189245608399  , 0.000750705857082 ,
 0.000234063270464 , 5.72792335493e-05 , 1.09873868997e-05 , 1.65014812744e-06 ,
 1.9384311826e-07  , 1.77955912025e-08 , 1.2758783467e-09  , 7.14117116233e-11 ,
 3.13711790593e-12 , 1.29160979926e-13 , 2.35513726503e-14 , 1.46703031983e-14 ,
 8.07060649569e-15 , 3.49762329222e-15 , 1.19107722459e-15 , 3.19190861003e-16 ,
 6.74134759307e-17 , 1.12363190606e-17 , 1.47971928059e-18 , 1.54085115585e-19 ,
 1.26919564548e-20 , 8.26868948735e-22 , 4.25831248045e-23 , 1.73185374845e-24 ,
 5.55534025545e-26 , 1.40350394132e-27 , 2.35063275697e-29 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.43751936329e-17 , 7.14026701521e-16 , 2.70216399426e-14 , 7.98243171924e-13 ,
 1.8417947464e-11  , 3.32156282105e-10 , 4.68613993779e-09 , 5.17731354545e-08 ,
 4.48460685853e-07 , 3.0496693556e-06  , 1.63048075603e-05 , 6.86374006495e-05 ,
 0.000227834160968 , 0.000597110835386 , 0.00123684926272  , 0.00202622209436  ,
 0.00262573627346  , 0.00269083245575  , 0.00217910613953  , 0.00139300850106  ,
 0.000701991695554 , 0.000278468431544 , 8.68239286978e-05 , 2.12472810436e-05 ,
 4.07568472773e-06 , 6.12109465334e-07 , 7.19045793311e-08 , 6.60113350825e-09 ,
 4.73274514706e-10 , 2.64848577623e-11 , 1.1566837493e-12  , 3.98461359997e-14 ,
 1.47497272805e-15 , 3.24381562523e-16 , 1.67342625656e-16 , 7.25226122209e-17 ,
 2.4696779632e-17  , 6.61836713189e-18 , 1.39780672901e-18 , 2.32983126524e-19 ,
 3.06817225917e-20 , 3.19492814204e-21 , 2.63165515379e-22 , 1.71449842126e-23 ,
 8.82953705798e-25 , 3.59096870442e-26 , 1.15189016495e-27 , 2.91014107532e-29 ,
 4.87399624444e-31 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 4.21700328948e-18 , 2.09461731506e-16 ,
 7.92687371279e-15 , 2.34166868827e-13 , 5.4029564418e-12  , 9.74389750862e-11 ,
 1.37469226761e-09 , 1.51877942025e-08 , 1.3155719747e-07  , 8.94629041721e-07 ,
 4.78306093621e-06 , 2.01349736018e-05 , 6.68357888451e-05 , 0.000175164134919 ,
 0.000362833193254 , 0.000594397922928 , 0.000770267085454 , 0.000789363232739 ,
 0.000639246885515 , 0.000408642942922 , 0.000205931228819 , 8.16894938476e-05 ,
 2.54700425102e-05 , 6.2329493669e-06  , 1.19561352303e-06 , 1.79564024995e-07 ,
 2.10934096073e-08 , 1.93646097361e-09 , 1.3883635985e-10  , 7.76932457271e-12 ,
 3.3919474035e-13  , 1.15488955981e-14 , 3.06569906804e-16 , 6.27513431663e-18 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9.77627205905e-19 ,
 4.85594800999e-17 , 1.83768587962e-15 , 5.42868681792e-14 , 1.25256653771e-12 ,
 2.25892621895e-11 , 3.18694691066e-10 , 3.52098392883e-09 , 3.04988842908e-08 ,
 2.07401709304e-07 , 1.10885626066e-06 , 4.66788774683e-06 , 1.54945303614e-05 ,
 4.06082737054e-05 , 8.41155618294e-05 , 0.0001377991765   , 0.000178570896644 ,
 0.00018299795345  , 0.000148196504406 , 9.47356288526e-05 , 4.774100422e-05   ,
 1.89380624439e-05 , 5.90471592842e-06 , 1.44498366632e-06 , 2.77178894022e-07 ,
 4.16282995261e-08 , 4.89008181446e-09 , 4.48929441364e-10 , 3.21864113544e-11 ,
 1.80116128739e-12 , 7.86354630298e-14 , 2.67737864066e-15 , 7.10720530266e-17 ,
 1.45476339655e-18 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.78919236615e-19 , 8.88705332402e-18 , 3.36321813401e-16 , 9.93524418528e-15 ,
 2.29236919128e-13 , 4.13414594257e-12 , 5.83255155896e-11 , 6.44388528546e-10 ,
 5.5817156703e-09  , 3.79573678773e-08 , 2.02935960123e-07 , 8.54287715423e-07 ,
 2.83571235255e-06 , 7.43187309818e-06 , 1.53943057426e-05 , 2.52191462315e-05 ,
 3.26809322779e-05 , 3.34911446159e-05 , 2.7122000367e-05  , 1.73379242028e-05 ,
 8.73726097094e-06 , 3.46592612701e-06 , 1.08064429873e-06 , 2.64451902461e-07 ,
 5.07275532274e-08 , 7.61855186497e-09 , 8.94952288504e-10 , 8.21602676948e-11 ,
 5.8905563533e-12  , 3.29637310228e-13 , 1.43913722237e-14 , 4.89997147811e-16 ,
 1.30071640758e-17 , 2.66241727719e-19 , 1.93865518378e-30 , 9.34475335662e-29 ,
 3.50699671904e-27 , 1.02504623274e-25 , 2.33343739369e-24 , 4.13712483083e-23 ,
 5.71291153683e-22 , 6.14442542759e-21 , 5.14731637665e-20 , 3.35869235844e-19 ,
 1.70713263902e-18 , 6.75919369634e-18 , 2.08488645131e-17 , 5.01034054839e-17 ,
 9.38203747894e-17 , 1.36909307284e-16 , 1.55722701452e-16 , 1.38086709617e-16 ,
 9.54896467552e-17 , 5.15133921804e-17 , 2.16888667453e-17 , 7.13092359936e-18 ,
 1.83206204507e-18 , 3.68107539202e-19 , 5.78990371731e-20 , 7.13709924077e-21 ,
 6.90373178123e-22 , 5.24771665484e-23 , 3.13924638887e-24 , 1.48009704481e-25 ,
 5.50753496459e-27 , 1.61926771722e-28 , 3.7645749546e-30  , 3.78957558539e-32 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 2.58154209376e-20 , 1.2822714136e-18  ,
 4.85263035306e-17 , 1.43350997698e-15 , 3.30755243186e-14 , 5.96496607877e-13 ,
 8.41551621185e-12 , 9.29758109105e-11 , 8.0535968244e-10  , 5.47669131599e-09 ,
 2.92806817928e-08 , 1.23261184167e-07 , 4.09151690025e-07 , 1.07231025581e-06 ,
 2.22117247035e-06 , 3.63875281366e-06 , 4.71537906906e-06 , 4.83228082289e-06 ,
 3.91330674884e-06 , 2.50160809953e-06 , 1.26065857464e-06 , 5.00082291877e-07 ,
 1.55921118283e-07 , 3.8156529778e-08  , 7.31924171193e-09 , 1.09924526311e-09 ,
 1.29128485477e-10 , 1.18545212634e-11 , 8.49920862027e-13 , 4.75618277903e-14 ,
 2.07646387752e-15 , 7.06993998432e-17 , 1.87674553076e-18 , 3.84609890971e-20 ,
 6.46068617107e-22 , 7.05780668349e-21 , 6.02975837062e-20 , 4.03267540632e-19 ,
 2.11374295493e-18 , 8.69523729178e-18 , 2.81250110024e-17 , 7.1773152724e-17  ,
 1.458553044e-16   , 2.435883678e-16   , 3.69395686943e-16 , 6.20813170034e-16 ,
 1.27000996368e-15 , 2.66120692153e-15 , 4.79580659644e-15 , 6.92732483348e-15 ,
 7.85795468492e-15 , 6.96298698475e-15 , 4.81410253943e-15 , 2.59690564373e-15 ,
 1.09336853582e-15 , 3.59479191993e-16 , 9.23565434126e-17 , 1.85567566323e-17 ,
 2.91876187368e-18 , 3.59789966818e-19 , 3.4802562338e-20  , 2.64543860441e-21 ,
 1.58253277124e-22 , 7.46135150888e-24 , 2.77641621286e-25 , 8.16292801037e-27 ,
 1.8977686035e-28  , 1.91037172942e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 2.9322747e-21     , 1.45648294239e-19 , 5.5119167908e-18  , 1.62826902875e-16 ,
 3.75692201119e-15 , 6.77537629985e-14 , 9.55886225334e-13 , 1.05607659354e-11 ,
 9.14777189545e-11 , 6.220763715e-10   , 3.32588039635e-09 , 1.40007653836e-08 ,
 4.6473971973e-08  , 1.2179961122e-07  , 2.52294465967e-07 , 4.13311982821e-07 ,
 5.35601831887e-07 , 5.48880253958e-07 , 4.44497511806e-07 , 2.84148074026e-07 ,
 1.43193374715e-07 , 5.68024304517e-08 , 1.77104820969e-08 , 4.33405394313e-09 ,
 8.31364607494e-10 , 1.24859055443e-10 , 1.46672096469e-11 , 1.3465096256e-12  ,
 9.65392525169e-14 , 5.40236568881e-15 , 2.35857571838e-16 , 8.03047928605e-18 ,
 2.13298180669e-19 , 6.62168525657e-21 , 3.15709977633e-20 , 3.44889021897e-19 ,
 2.94651938255e-18 , 1.9706146412e-17  , 1.03289570874e-16 , 4.24881617761e-16 ,
 1.37405285676e-15 , 3.50392308742e-15 , 7.09920575973e-15 , 1.17192144701e-14 ,
 1.71155137861e-14 , 2.66328708364e-14 , 5.06356989259e-14 , 1.02587113624e-13 ,
 1.8294058535e-13  , 2.63487637962e-13 , 2.98654500506e-13 , 2.64585108638e-13 ,
 1.82919892407e-13 , 9.8672284441e-14  , 4.15435666742e-14 , 1.36587346287e-14 ,
 3.50916867093e-15 , 7.050803429e-16   , 1.10900930239e-16 , 1.36705368473e-17 ,
 1.32235402268e-18 , 1.00515770779e-19 , 6.01297270669e-21 , 2.83500625031e-22 ,
 1.05492380403e-23 , 3.10157642388e-25 , 7.21073902786e-27 , 7.2586257153e-29  ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 2.61810146779e-22 , 1.30043073021e-20 ,
 4.92135250505e-19 , 1.45381110922e-17 , 3.35439344475e-16 , 6.04944094614e-15 ,
 8.53469536668e-14 , 9.42925190345e-13 , 8.16765053646e-12 , 5.55425131658e-11 ,
 2.96953499868e-10 , 1.2500678876e-09  , 4.14946028885e-09 , 1.08749613708e-08 ,
 2.25262834912e-08 , 3.69028423183e-08 , 4.78215749096e-08 , 4.90071478819e-08 ,
 3.96872635462e-08 , 2.5370354615e-08  , 1.27851181378e-08 , 5.07164374947e-09 ,
 1.58129247485e-09 , 3.86968962696e-10 , 7.42289560781e-11 , 1.11481259352e-11 ,
 1.30957181825e-12 , 1.20224030415e-13 , 8.61957301321e-15 , 4.82353905823e-16 ,
 2.10587112161e-17 , 7.17213506505e-19 , 2.37855230733e-20 , 8.54683196166e-20 ,
 1.18940022445e-18 , 1.29932873277e-17 , 1.11006602811e-16 , 7.42404349532e-16 ,
 3.89127756224e-15 , 1.6006283142e-14  , 5.17570904352e-14 , 1.31912218684e-13 ,
 2.66667051244e-13 , 4.36371143441e-13 , 6.18699458536e-13 , 8.99992830591e-13 ,
 1.58879588071e-12 , 3.09861062456e-12 , 5.45726356823e-12 , 7.83281409897e-12 ,
 8.86996847233e-12 , 7.8561538393e-12  , 5.43095557681e-12 , 2.92956091055e-12 ,
 1.23341420735e-12 , 4.05522572477e-13 , 1.04185826933e-13 , 2.09335536936e-14 ,
 3.292604216e-15   , 4.05872762254e-16 , 3.92601610789e-17 , 2.9842729569e-18  ,
 1.78522750171e-19 , 8.41701995411e-21 , 3.13202650173e-22 , 9.20845611757e-24 ,
 2.14083952283e-25 , 2.15505688844e-27 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.83486157463e-23 , 9.11389572437e-22 , 3.44906441473e-20 , 1.01888417003e-18 ,
 2.35088200884e-17 , 4.2396701872e-16  , 5.98142767656e-15 , 6.60836572149e-14 ,
 5.72418919156e-13 , 3.89262312481e-12 , 2.08115908822e-11 , 8.76093444374e-11 ,
 2.90809402658e-10 , 7.62157196362e-10 , 1.57872460276e-09 , 2.58628659727e-09 ,
 3.35151144138e-09 , 3.43460074549e-09 , 2.7814290538e-09  , 1.77804754287e-09 ,
 8.96027991533e-10 , 3.55439403346e-10 , 1.10822778874e-10 , 2.7120204811e-11  ,
 5.20223761027e-12 , 7.81301571358e-13 , 9.1779598235e-14  , 8.42574118952e-15 ,
 6.04091304678e-16 , 3.3805137097e-17  , 1.47607821611e-18 , 5.63357912968e-20 ,
 1.4092261706e-19  , 2.49902751581e-18 , 3.49360092538e-17 , 3.81649142904e-16 ,
 3.26057305072e-15 , 2.1806455491e-14  , 1.14296884546e-13 , 4.7013480586e-13  ,
 1.5200504883e-12  , 3.87248001882e-12 , 7.81474042713e-12 , 1.26998809659e-11 ,
 1.75754095212e-11 , 2.40694812649e-11 , 3.93699456422e-11 , 7.34778751673e-11 ,
 1.27456477835e-10 , 1.82151232666e-10 , 2.06030371669e-10 , 1.82424676709e-10 ,
 1.26099467064e-10 , 6.80188948573e-11 , 2.86373782877e-11 , 9.41539600994e-12 ,
 2.41897841511e-12 , 4.86033554786e-13 , 7.64474152954e-14 , 9.42352049088e-15 ,
 9.11539195956e-16 , 6.92886043964e-17 , 4.14492654913e-18 , 1.95425677898e-19 ,
 7.2719134044e-21  , 2.1380117773e-22  , 4.97058361867e-24 , 5.00359338136e-26 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 1.00805567027e-24 , 5.00708848571e-23 ,
 1.89488350973e-21 , 5.59765368217e-20 , 1.29155243748e-18 , 2.32923487601e-17 ,
 3.28614003859e-16 , 3.63057389662e-15 , 3.14481563734e-14 , 2.13857048807e-13 ,
 1.14336920486e-12 , 4.81317488196e-12 , 1.59767947278e-11 , 4.18721986472e-11 ,
 8.67336429959e-11 , 1.42088150156e-10 , 1.84128882482e-10 , 1.88693730605e-10 ,
 1.52809092953e-10 , 9.76842576236e-11 , 4.92269340682e-11 , 1.95275061037e-11 ,
 6.08849910991e-12 , 1.48995851331e-12 , 2.85806035378e-13 , 4.29239725813e-14 ,
 5.04228469848e-15 , 4.62902286459e-16 , 3.31882099674e-17 , 1.85734783228e-18 ,
 8.58238806194e-20 , 1.42161972892e-19 , 3.19772323335e-18 , 5.72462392816e-17 ,
 8.00302077988e-16 , 8.74268678289e-15 , 7.46920646481e-14 , 4.99534145416e-13 ,
 2.61825915658e-12 , 1.07694279627e-11 , 3.4817223715e-11  , 8.8671040996e-11  ,
 1.78695701909e-10 , 2.88825467764e-10 , 3.91942587963e-10 , 5.09133322385e-10 ,
 7.71576662358e-10 , 1.37008097271e-09 , 2.33339181871e-09 , 3.31703299468e-09 ,
 3.74647240603e-09 , 3.31593869401e-09 , 2.29187364404e-09 , 1.23621671241e-09 ,
 5.20469042938e-10 , 1.71119421492e-10 , 4.39635189332e-11 , 8.83337434241e-12 ,
 1.38938680125e-12 , 1.71266939181e-13 , 1.65666883881e-14 , 1.25927960297e-15 ,
 7.53316003804e-17 , 3.55174667077e-18 , 1.32162745971e-19 , 3.88571056464e-21 ,
 9.03374316483e-23 , 9.09373646562e-25 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 4.4441737571e-18  , 1.4159588519e-17  ,
 3.54165435827e-17 , 6.96438797901e-17 , 1.07827260582e-16 , 1.31635937262e-16 ,
 1.26878422381e-16 , 9.66538231477e-17 , 5.82310768562e-17 , 2.77513897219e-17 ,
 1.04590136575e-17 , 3.11502241854e-18 , 7.32362918502e-19 , 1.35739773568e-19 ,
 1.98046475524e-20 , 2.27122313782e-21 , 2.04439738093e-22 , 1.44249805357e-23 ,
 7.96904254106e-25 , 3.44353300269e-26 , 1.1629037078e-27  , 3.06705411119e-29 ,
 6.13178822897e-31 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 4.33634821019e-26 , 2.15389683662e-24 , 8.15121124583e-23 , 2.40793998207e-21 ,
 5.55586488505e-20 , 1.00196584212e-18 , 1.41359727394e-17 , 1.56176222037e-16 ,
 1.35280382449e-15 , 9.19947834409e-15 , 4.9184257887e-14  , 2.07048111531e-13 ,
 6.8727300749e-13  , 1.80121434774e-12 , 3.7310169335e-12  , 6.11219909566e-12 ,
 7.9206632485e-12  , 8.11702909984e-12 , 6.57338137438e-12 , 4.20207899427e-12 ,
 2.11759264627e-12 , 8.4001378733e-13  , 2.61908672275e-13 , 6.4093473436e-14  ,
 1.2294504426e-14  , 1.84645845628e-15 , 2.16903717447e-16 , 1.9912645309e-17  ,
 1.42770136437e-18 , 8.21392145459e-20 , 8.82184700647e-20 , 2.49153046305e-18 ,
 5.71491454014e-17 , 1.02311805181e-15 , 1.43031843647e-14 , 1.56251319721e-13 ,
 1.33491361421e-12 , 8.92778128886e-12 , 4.67939322458e-11 , 1.92470113213e-10 ,
 6.22211744479e-10 , 1.58421423622e-09 , 3.18920763499e-09 , 5.13270080339e-09 ,
 6.85619361082e-09 , 8.51060708799e-09 , 1.19738115459e-08 , 2.01222794232e-08 ,
 3.35309424894e-08 , 4.73576574327e-08 , 5.33940069078e-08 , 4.72355452935e-08 ,
 3.26435224743e-08 , 1.76070130906e-08 , 7.41279168269e-09 , 2.43716562016e-09 ,
 6.26149254896e-10 , 1.25809074722e-10 , 1.97882996098e-11 , 2.4392641775e-12  ,
 2.3595055499e-13  , 1.79352513849e-14 , 1.07290802319e-15 , 5.05856437427e-17 ,
 1.88232388272e-18 , 5.53421143259e-20 , 1.28662811782e-21 , 1.29517264541e-23 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.12593088976e-30 , 5.48635671809e-29 ,
 2.06527541466e-27 , 6.06014280505e-26 , 1.38644891092e-24 , 2.47385098106e-23 ,
 3.44395873685e-22 , 3.74251746504e-21 , 3.1764819044e-20  , 2.10725482859e-19 ,
 1.09358058625e-18 , 2.45992554684e-16 , 7.82274008415e-16 , 1.95223899654e-15 ,
 3.82876440775e-15 , 5.90990933576e-15 , 7.19017765148e-15 , 6.90437439207e-15 ,
 5.23867552632e-15 , 3.14315093965e-15 , 1.49176204338e-15 , 5.59965432737e-16 ,
 1.66145030448e-16 , 3.89265461512e-17 , 7.19252866615e-18 , 1.04657042363e-18 ,
 1.19745314281e-19 , 1.07577624018e-20 , 7.57835379127e-22 , 4.18115096339e-23 ,
 1.80481426471e-24 , 6.08977745097e-26 , 1.60503084099e-27 , 3.20077546489e-29 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.4591025754e-27  ,
 7.24747245638e-26 , 2.74273484161e-24 , 8.10228159491e-23 , 1.86944783247e-21 ,
 3.3714334501e-20  , 4.75649860901e-19 , 5.2550467985e-18  , 4.55193967054e-17 ,
 3.09545772009e-16 , 1.65496113028e-15 , 6.96679367346e-15 , 2.31254910036e-14 ,
 6.06075980582e-14 , 1.25541957257e-13 , 2.05664421065e-13 , 2.66515961925e-13 ,
 2.73123316905e-13 , 2.2118236884e-13  , 1.41392341791e-13 , 7.12531543609e-14 ,
 2.8264941399e-14  , 8.81275210648e-15 , 2.1566292102e-15  , 4.13687789857e-16 ,
 6.21299803047e-17 , 7.29841694904e-18 , 6.70024422513e-19 , 4.86776191791e-20 ,
 3.40367972431e-20 , 1.18212315986e-18 , 3.47556365136e-17 , 7.97240609592e-16 ,
 1.42726771926e-14 , 1.99531941631e-13 , 2.17973336783e-12 , 1.86222769312e-11 ,
 1.24544025696e-10 , 6.52781391509e-10 , 2.6849527774e-09  , 8.67942175768e-09 ,
 2.20942409614e-08 , 4.44411953714e-08 , 7.12835672941e-08 , 9.40261900248e-08 ,
 1.12314545017e-07 , 1.47265245916e-07 , 2.33194945371e-07 , 3.78790187294e-07 ,
 5.30812910716e-07 , 5.97179804991e-07 , 5.27992862709e-07 , 3.64827506365e-07 ,
 1.9676940849e-07  , 8.28416181466e-08 , 2.72364444095e-08 , 6.99749903483e-09 ,
 1.40597254298e-09 , 2.21143061975e-10 , 2.72598631283e-11 , 2.63685248184e-12 ,
 2.00434417542e-13 , 1.19902247243e-14 , 5.65317085142e-16 , 2.10358072358e-17 ,
 6.18472761075e-19 , 1.43786419113e-20 , 1.44741308103e-22 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 6.28108557693e-29 , 3.05840426759e-27 , 1.15106911304e-25 ,
 3.37671814464e-24 , 7.72278538136e-23 , 1.37741100972e-21 , 1.91654964231e-20 ,
 2.08131945692e-19 , 1.76506654619e-18 , 1.16972250587e-17 , 6.06263598921e-17 ,
 9.570368494e-15   , 3.04206990341e-14 , 7.58766849309e-14 , 1.48715978687e-13 ,
 2.2938284531e-13  , 2.78843157558e-13 , 2.67515511957e-13 , 2.02778884513e-13 ,
 1.21542088502e-13 , 5.76259492902e-14 , 2.16096282138e-14 , 6.40565841155e-15 ,
 1.49949569906e-15 , 2.7684899273e-16  , 4.02563063017e-17 , 4.60331113146e-18 ,
 4.13352081361e-19 , 2.91068931701e-20 , 1.60535711205e-21 , 6.92772461538e-23 ,
 2.33703315455e-24 , 6.15844737776e-26 , 1.22733426421e-27 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3.83708399982e-29 , 1.90590854065e-27 ,
 7.21272387144e-26 , 2.13070250124e-24 , 4.91619197128e-23 , 8.86604791595e-22 ,
 1.2508431563e-20  , 1.38194917401e-19 , 1.19704914325e-18 , 8.1402990373e-18  ,
 4.35214424288e-17 , 1.83209686455e-16 , 6.0814402643e-16  , 1.59383204921e-15 ,
 3.30144736646e-15 , 5.40847280173e-15 , 7.00871995181e-15 , 7.18247727705e-15 ,
 5.81655699075e-15 , 3.71827383165e-15 , 1.87378422288e-15 , 7.43299040288e-16 ,
 2.31753892236e-16 , 5.67140897117e-17 , 1.08789801768e-17 , 1.63386699026e-18 ,
 1.91930570004e-19 , 1.76200085892e-20 , 8.23177221295e-21 , 3.41616416744e-19 ,
 1.2878069247e-17  , 3.78665939124e-16 , 8.68601265888e-15 , 1.55502182523e-13 ,
 2.17391956425e-12 , 2.37484026768e-11 , 2.02891459194e-10 , 1.35691823911e-09 ,
 7.11209682834e-09 , 2.92524831717e-08 , 9.45585172797e-08 , 2.40669258066e-07 ,
 4.83775483054e-07 , 7.73929505653e-07 , 1.01064110971e-06 , 1.16910464536e-06 ,
 1.43613726688e-06 , 2.13615129234e-06 , 3.36945889375e-06 , 4.67786522756e-06 ,
 5.24904140509e-06 , 4.63763430516e-06 , 3.2038566137e-06  , 1.72790749275e-06 ,
 7.27453588453e-07 , 2.39169295121e-07 , 6.14465335358e-08 , 1.23461414717e-08 ,
 1.94190371268e-09 , 2.39374582784e-10 , 2.31547552429e-11 , 1.760056698e-12   ,
 1.05288680366e-13 , 4.9641679995e-15  , 1.84719839305e-16 , 5.43093914864e-18 ,
 1.26261873077e-19 , 1.27100381145e-21 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 2.44819722295e-27 , 1.19188082414e-25 , 4.48558069459e-24 , 1.31578740221e-22 ,
 3.00906327053e-21 , 5.36634121573e-20 , 7.46587718687e-19 , 8.10646374961e-18 ,
 6.873348133e-17   , 4.55390008602e-16 , 2.35955516854e-15 , 2.9242945901e-13  ,
 9.29028751252e-13 , 2.31574182127e-12 , 4.53536433167e-12 , 6.98937304171e-12 ,
 8.48814217928e-12 , 8.13461455144e-12 , 6.15912558076e-12 , 3.68742828652e-12 ,
 1.74636124432e-12 , 6.54238141249e-13 , 1.93787522061e-13 , 4.53471578334e-14 ,
 8.37464070158e-15 , 1.21934367066e-15 , 1.39856134528e-16 , 1.26334774201e-17 ,
 8.99460190264e-19 , 5.05994979511e-20 , 2.26125892907e-21 , 8.10714623097e-23 ,
 2.36929035151e-24 , 5.64864259848e-26 , 5.87775792482e-28 , 1.39185870777e-29 ,
 1.61484887276e-31 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7.58880749493e-31 ,
 3.7694178753e-29  , 1.42649921078e-27 , 4.21400498703e-26 , 9.72301739547e-25 ,
 1.75348600338e-23 , 2.47385981645e-22 , 2.73315524233e-21 , 2.36746850225e-20 ,
 1.60995074249e-19 , 8.60746985234e-19 , 3.62343655175e-18 , 1.20275916451e-17 ,
 3.15220740575e-17 , 6.52945010322e-17 , 1.06966276828e-16 , 1.38615225788e-16 ,
 1.42051717905e-16 , 1.1503717742e-16  , 7.35383023233e-17 , 3.70588388347e-17 ,
 1.47006250793e-17 , 4.58352143049e-18 , 1.12166506934e-18 , 2.15159444795e-19 ,
 3.2313866629e-20  , 3.79591415831e-21 , 3.48480390965e-22 , 5.93621909628e-20 ,
 2.90828866969e-18 , 1.09657692629e-16 , 3.22436867533e-15 , 7.39620447598e-14 ,
 1.32411266662e-12 , 1.85110869076e-11 , 2.02219412641e-10 , 1.72763569844e-09 ,
 1.15542543572e-08 , 6.05599086258e-08 , 2.490848461e-07   , 8.05142066009e-07 ,
 2.04898591342e-06 , 4.11661355001e-06 , 6.57198805826e-06 , 8.51379198426e-06 ,
 9.59117606569e-06 , 1.11065532754e-05 , 1.54924975999e-05 , 2.36409860257e-05 ,
 3.24627520135e-05 , 3.63136634459e-05 , 3.2056804944e-05  , 2.21410159169e-05 ,
 1.19403738092e-05 , 5.02684293118e-06 , 1.65269764033e-06 , 4.2460470919e-07  ,
 8.53136478234e-08 , 1.3418838048e-08  , 1.65411325473e-09 , 1.60002732206e-10 ,
 1.21622481849e-11 , 7.27560119028e-13 , 3.43031240209e-14 , 1.27644099826e-15 ,
 3.75285806573e-17 , 8.72487935884e-19 , 8.78282148782e-21 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 7.49704628982e-26 , 3.64913226339e-24 , 1.37325457115e-22 ,
 4.02797706321e-21 , 9.21070701775e-20 , 1.6424403645e-18  , 2.28469607914e-17 ,
 2.48026812134e-16 , 2.10249301233e-15 , 1.39259135541e-14 , 7.21297142971e-14 ,
 7.02804777225e-12 , 2.2313729211e-11  , 5.55787741746e-11 , 1.08754945553e-10 ,
 1.67430203012e-10 , 2.03100210948e-10 , 1.94396450239e-10 , 1.46990773933e-10 ,
 8.78824449973e-11 , 4.15659622713e-11 , 1.55532751245e-11 , 4.60260746756e-12 ,
 1.07647858199e-12 , 1.98837648852e-13 , 2.8988239614e-14  , 3.33533286697e-15 ,
 3.03159317635e-16 , 2.18291253896e-17 , 1.25243444304e-18 , 5.78482001052e-20 ,
 2.18562526364e-21 , 6.89744763141e-23 , 1.82698089714e-24 , 2.86965474312e-26 ,
 6.78912962693e-28 , 7.82590358367e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 3.95222712264e-19 , 1.93710026882e-17 , 7.30388458632e-16 ,
 2.14763014949e-14 , 4.92633235336e-13 , 8.81941418768e-12 , 1.23295355369e-10 ,
 1.34690707747e-09 , 1.15071276536e-08 , 7.69584939114e-08 , 4.03366013253e-07 ,
 1.65904840106e-06 , 5.36258625191e-06 , 1.36457910577e-05 , 2.74047153247e-05 ,
 4.36789660704e-05 , 5.62265118724e-05 , 6.198016243e-05   , 6.81065986728e-05 ,
 8.9083158855e-05  , 0.000131048735768 , 0.000177675582654 , 0.000198028175011 ,
 0.000174640227316 , 0.000120588021398 , 6.50268254201e-05 , 2.73754441866e-05 ,
 9.00029718983e-06 , 2.3123181153e-06  , 4.6460202872e-07  , 7.30764514624e-08 ,
 9.00798732297e-09 , 8.7134455047e-10  , 6.623329805e-11   , 3.96215448304e-12 ,
 1.86808310499e-13 , 6.95125569879e-15 , 2.04373535885e-16 , 4.7514038994e-18  ,
 4.78295808455e-20 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.80637366298e-24 ,
 8.79035181429e-23 , 3.3078016295e-21  , 9.70151040917e-20 , 2.2181935577e-18  ,
 3.95492062875e-17 , 5.50050712459e-16 , 5.97007374824e-15 , 5.05939404557e-14 ,
 3.34997348858e-13 , 1.73440514786e-12 , 1.33050614646e-10 , 4.22130074108e-10 ,
 1.05054261993e-09 , 2.05361030143e-09 , 3.15790638087e-09 , 3.82567259835e-09 ,
 3.65648374805e-09 , 2.76063127202e-09 , 1.64800549022e-09 , 7.78343678752e-10 ,
 2.90893104571e-10 , 8.60170901103e-11 , 2.01179504435e-11 , 3.72066610451e-12 ,
 5.44240917985e-13 , 6.30450190307e-14 , 5.80208841365e-15 , 4.26887574275e-16 ,
 2.53792616539e-17 , 1.23872726511e-18 , 5.06178449121e-20 , 1.76271279281e-21 ,
 5.21782437487e-23 , 1.08083658407e-24 , 2.55642464232e-26 , 2.94145817039e-28 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.06120014841e-18 ,
 1.01025351977e-16 , 3.80918594153e-15 , 1.1200509094e-13  , 2.56922405084e-12 ,
 4.59957822981e-11 , 6.43020747573e-10 , 7.02450780041e-09 , 6.00129772057e-08 ,
 4.01360567676e-07 , 2.10366710341e-06 , 8.6523667992e-06  , 2.79667684617e-05 ,
 7.1159610088e-05  , 0.000142863861418 , 0.000227409390104 , 0.000291260333824 ,
 0.000315416273512 , 0.000331049563825 , 0.000406567452214 , 0.000574799557979 ,
 0.000768068883384 , 0.000852424928991 , 0.000750875033132 , 0.000518310669323 ,
 0.000279473787845 , 0.000117652033252 , 3.86805182341e-05 , 9.93761651274e-06 ,
 1.99671250211e-06 , 3.14059420887e-07 , 3.87134722237e-08 , 3.7447624522e-09  ,
 2.84649702315e-10 , 1.70280829456e-11 , 8.02842852243e-13 , 2.98742916584e-14 ,
 8.78332618312e-16 , 2.04200265444e-17 , 2.0555636427e-19  , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 3.42959531146e-23 , 1.66850468079e-21 , 6.27810569584e-20 ,
 1.84114368529e-18 , 4.20916308323e-17 , 7.50357074387e-16 , 1.0433960141e-14  ,
 1.13219275303e-13 , 9.59193543789e-13 , 6.34867356833e-12 , 3.28538371958e-11 ,
 1.98694156065e-09 , 6.29900919131e-09 , 1.56613418045e-08 , 3.05807994069e-08 ,
 4.69645654735e-08 , 5.68131441732e-08 , 5.42148871439e-08 , 4.08646764286e-08 ,
 2.4355561947e-08  , 1.14866710404e-08 , 4.28871456461e-09 , 1.26793853721e-09 ,
 2.96907497345e-10 , 5.5106034427e-11  , 8.12076652702e-12 , 9.5374614207e-13  ,
 8.98845394352e-14 , 6.87382031758e-15 , 4.33310478221e-16 , 2.29257799824e-17 ,
 1.03306402269e-18 , 3.9824004774e-20  , 1.29463194923e-21 , 3.17370210873e-23 ,
 7.50407427663e-25 , 8.61424840543e-27 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 8.42691470911e-18 , 4.13027344882e-16 , 1.55732984326e-14 ,
 4.57916398397e-13 , 1.05038959762e-11 , 1.88047014602e-10 , 2.6288960755e-09  ,
 2.87186702511e-08 , 2.45354248386e-07 , 1.64090347072e-06 , 8.60052586109e-06 ,
 3.53737780538e-05 , 0.000114335886934 , 0.000290902544695 , 0.000583884514467 ,
 0.000928467711927 , 0.00118435951306  , 0.00126413109011  , 0.00127509430166  ,
 0.00147389494198  , 0.00199739198499  , 0.0026256102922   , 0.00289978391888  ,
 0.00255089089154  , 0.00176017205521  , 0.000948992169673 , 0.000399492912998 ,
 0.000131340494257 , 3.37433105524e-05 , 6.77986024023e-06 , 1.06639220095e-06 ,
 1.31452012841e-07 , 1.27153811775e-08 , 9.66531122277e-10 , 5.78190385231e-11 ,
 2.7260615281e-12  , 1.01438478238e-13 , 2.98238784162e-15 , 6.93364195338e-17 ,
 6.97968845555e-19 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 2.16965909925e-31 , 1.87800103501e-29 , 7.94406965667e-28 ,
 2.6563942099e-26  , 7.02584595883e-25 , 1.46882857643e-23 , 2.42475950433e-22 ,
 3.15681734325e-21 , 3.23687145157e-20 , 2.61043137256e-19 , 1.65374799645e-18 ,
 8.22107595861e-18 , 3.20415601262e-17 , 9.78481218954e-17 , 2.34056892841e-16 ,
 4.39322398989e-16 , 6.70925904906e-16 , 1.37120748147e-15 , 1.19075627e-14    ,
 1.56665094855e-13 , 1.69441829844e-12 , 1.43475662118e-11 , 9.49211165085e-11 ,
 4.90948449087e-10 , 2.34356271752e-08 , 7.423244407e-08   , 1.84377001821e-07 ,
 3.59586612827e-07 , 5.51470287494e-07 , 6.66079490844e-07 , 6.34557029912e-07 ,
 4.77490874208e-07 , 2.84144725972e-07 , 1.33854455427e-07 , 4.99594488719e-08 ,
 1.47872588217e-08 , 3.47558896889e-09 , 6.50275430112e-10 , 9.72811533801e-11 ,
 1.17254492676e-11 , 1.15209625768e-12 , 9.37240513541e-14 , 6.41688176965e-15 ,
 3.73979439112e-16 , 1.85712233841e-17 , 7.7812473589e-19  , 2.6985603863e-20  ,
 7.26725064985e-22 , 1.71759460893e-23 , 1.96586817477e-25 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.70432237222e-17 , 1.3254662325e-15  ,
 4.99770328931e-14 , 1.46952188736e-12 , 3.37085657853e-11 , 6.03470862315e-10 ,
 8.43651882195e-09 , 9.21624869613e-08 , 7.87378272356e-07 , 5.26590251079e-06 ,
 2.76003452216e-05 , 0.000113519320004 , 0.000366915364813 , 0.000933490239968 ,
 0.00187327530795  , 0.00297634800531  , 0.00378430220994  , 0.00399151926147  ,
 0.00389065444582  , 0.00424615856257  , 0.00550401508491  , 0.00710400194288  ,
 0.00780220707322  , 0.00685284746451  , 0.00472662280598  , 0.00254805282933  ,
 0.00107260832086  , 0.000352636246068 , 9.05972359238e-05 , 1.82031987672e-05 ,
 2.86314834719e-06 , 3.52934496703e-07 , 3.41394285672e-08 , 2.59503193015e-09 ,
 1.55237889286e-10 , 7.31918153351e-12 , 2.72351387401e-13 , 8.00739013055e-15 ,
 1.86160819157e-16 , 1.87397124262e-18 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.06670244729e-29 , 9.18001106654e-28 ,
 3.88004370065e-26 , 1.29638542746e-24 , 3.42609967112e-23 , 7.15736973914e-22 ,
 1.18075678871e-20 , 1.53632718972e-19 , 1.57448014552e-18 , 1.2692180898e-17  ,
 8.03782456143e-17 , 3.99460058685e-16 , 1.55654295397e-15 , 4.75253435339e-15 ,
 1.13660526798e-14 , 2.12996353654e-14 , 3.15678632809e-14 , 4.34396826279e-14 ,
 1.65617993867e-13 , 1.8707769085e-12  , 2.00403803832e-11 , 1.69531534918e-10 ,
 1.12101327733e-09 , 5.79471757664e-09 , 2.18523382825e-07 , 6.91554608851e-07 ,
 1.71583271895e-06 , 3.34215088559e-06 , 5.1182327327e-06  , 6.1721247038e-06  ,
 5.87028825986e-06 , 4.41030880591e-06 , 2.62125539813e-06 , 1.2342825007e-06  ,
 4.61191543243e-07 , 1.3703491697e-07  , 3.2485623695e-08  , 6.17733172035e-09 ,
 9.50349309535e-10 , 1.19766595319e-10 , 1.25556739491e-11 , 1.11118670437e-12 ,
 8.37568901274e-14 , 5.39879371569e-15 , 3.09785419395e-16 , 2.10377599919e-17 ,
 2.85807779493e-18 , 5.60640543298e-19 , 9.90996109726e-20 , 1.40733177042e-20 ,
 1.57989186202e-21 , 1.39672013328e-22 , 9.70705088393e-24 , 5.29586985375e-25 ,
 2.26508818167e-26 , 7.58613499542e-28 , 1.98748097241e-29 , 3.87530350568e-31 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 2.87796230336e-31 , 2.86240182649e-29 , 1.23711383715e-27 , 4.21642388086e-26 ,
 1.13620607176e-24 , 2.41843699817e-23 , 4.06146870013e-22 , 5.3750684262e-21  ,
 5.59947185406e-20 , 4.58724023466e-19 , 7.1173062321e-17  , 3.35858938511e-15 ,
 1.26132721263e-13 , 3.70724094085e-12 , 8.5034600923e-11  , 1.52233293437e-09 ,
 2.12821938275e-08 , 2.32491603676e-07 , 1.98626184303e-06 , 1.32839073153e-05 ,
 6.96253378211e-05 , 0.000286366117742 , 0.000925579442457 , 0.00235472676527  ,
 0.00472456022613  , 0.00750159251024  , 0.00951271504428  , 0.00993580687447  ,
 0.00940347804268  , 0.00972330756329  , 0.012034199425    , 0.0152205450291   ,
 0.0166108076118   , 0.0145637543037   , 0.0100402057999   , 0.00541181079281  ,
 0.00227803070305  , 0.00074892964199  , 0.000192410080431 , 3.86598582537e-05 ,
 6.08073827483e-06 , 7.49560259042e-07 , 7.25051229618e-08 , 5.51131407931e-09 ,
 3.29693357401e-10 , 1.554443717e-11   , 5.78418388848e-13 , 1.70060521097e-14 ,
 3.95367363568e-16 , 3.97993161578e-18 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4.05515947797e-28 , 3.47337563553e-26 ,
 1.46707231895e-24 , 4.89843434023e-23 , 1.29372041493e-21 , 2.70102176033e-20 ,
 4.45340500238e-19 , 5.79160948363e-18 , 5.93287007688e-17 , 4.78083778349e-16 ,
 3.02672364356e-15 , 1.5038275557e-14  , 5.85864712453e-14 , 1.78850816548e-13 ,
 4.27673994186e-13 , 8.01074267263e-13 , 1.17843234703e-12 , 1.4235435478e-12  ,
 2.47548447094e-12 , 1.8180363036e-11  , 1.87768535321e-10 , 1.58410810287e-09 ,
 1.04672746392e-08 , 5.40725600321e-08 , 1.61170032937e-06 , 5.09582899452e-06 ,
 1.26297169868e-05 , 2.45696277936e-05 , 3.75731340484e-05 , 4.5241232454e-05  ,
 4.29652496871e-05 , 3.22413106564e-05 , 1.91543128571e-05 , 9.02937468237e-06 ,
 3.38732729606e-06 , 1.0155685648e-06  , 2.44926617511e-07 , 4.79811294697e-08 ,
 7.7376553774e-09  , 1.0431143171e-09  , 1.19098492698e-10 , 1.1579524681e-11  ,
 9.57152877722e-13 , 6.89566350487e-14 , 5.94528424809e-15 , 1.60342055201e-15 ,
 9.1582930817e-16  , 5.28434176599e-16 , 2.61082509001e-16 , 1.05693533179e-16 ,
 3.45248034963e-17 , 9.06854149298e-18 , 1.92121209728e-18 , 3.30803941796e-19 ,
 4.682765238e-20   , 5.52421458012e-21 , 5.49704763372e-22 , 4.64088694724e-23 ,
 3.31249160385e-24 , 1.97581758935e-25 , 9.69915947821e-27 , 3.8607305035e-28  ,
 1.22059105406e-29 , 3.02961564035e-31 , 5.60637777329e-33 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.42452695068e-29 , 1.40962311452e-27 ,
 6.08847771408e-26 , 2.07388961159e-24 , 5.5854443768e-23  , 1.18827448395e-21 ,
 1.99467289719e-20 , 2.63879403697e-19 , 2.7480670593e-18  , 2.25068499748e-17 ,
 2.80338582391e-16 , 7.37260056913e-15 , 2.5328032502e-13  , 7.37101089574e-12 ,
 1.68893838568e-10 , 3.02328327685e-09 , 4.22649471093e-08 , 4.61711440878e-07 ,
 3.94457112092e-06 , 2.63808679055e-05 , 0.000138270768314 , 0.00056870089647  ,
 0.00183811491213  , 0.00467611812539  , 0.00938097732923  , 0.0148868176847   ,
 0.0188366734849   , 0.0195144741722   , 0.0180043077955   , 0.0176988934868   ,
 0.0208825950806   , 0.0258250747845   , 0.0279811564068   , 0.0244828780496   ,
 0.01686899431     , 0.00909123613741  , 0.00382667657485  , 0.00125805095406  ,
 0.000323209184385 , 6.49405261853e-05 , 1.02143755528e-05 , 1.25910549746e-06 ,
 1.21793568812e-07 , 9.25786714491e-09 , 5.53816792503e-10 , 2.61114556723e-11 ,
 9.71624256421e-13 , 2.85666918283e-14 , 6.64136662813e-16 , 6.6854996184e-18  ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.19923851557e-26 , 1.0230896811e-24  , 4.31881552892e-23 , 1.44119493679e-21 ,
 3.80421987823e-20 , 7.93829404645e-19 , 1.30823144717e-17 , 1.70062140299e-16 ,
 1.74145923747e-15 , 1.40286724799e-14 , 8.87916489851e-14 , 4.41067304667e-13 ,
 1.71802714506e-12 , 5.24403309926e-12 , 1.2538375479e-11  , 2.3481705462e-11  ,
 3.44781413059e-11 , 4.02026595243e-11 , 4.53501195147e-11 , 1.5465837089e-10  ,
 1.40243247595e-09 , 1.17187284562e-08 , 7.73224945136e-08 , 3.99123357858e-07 ,
 9.40341701308e-06 , 2.97036286974e-05 , 7.35409915997e-05 , 0.000142894550948 ,
 0.000218239046704 , 0.000262441981193 , 0.00024898283765  , 0.00018677711216  ,
 0.000111095039328 , 5.25855676436e-05 , 1.99112961184e-05 , 6.07768278256e-06 ,
 1.51219329071e-06 , 3.11183824715e-07 , 5.37982161736e-08 , 7.90548306201e-09 ,
 9.89747454547e-10 , 1.04863607627e-10 , 9.41284510354e-12 , 8.11758273699e-13 ,
 1.38068320605e-13 , 6.93618492963e-14 , 4.5134467314e-14  , 2.71646873534e-14 ,
 1.40180487412e-14 , 6.23307815162e-15 , 2.70493146799e-15 , 1.5475206417e-15  ,
 1.27517470654e-15 , 1.11638320115e-15 , 8.4461295975e-16  , 5.18686299271e-16 ,
 2.54143270858e-16 , 9.87206999395e-17 , 3.02913269205e-17 , 7.32216942419e-18 ,
 1.39130105334e-18 , 2.07431153618e-19 , 2.4229714301e-20  , 2.2146907066e-21  ,
 1.58248193585e-22 , 8.83243668724e-24 , 3.8482517095e-25  , 1.30818588657e-26 ,
 3.46807572044e-28 , 7.06896112496e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 5.38583524513e-28 , 5.32201531272e-26 , 2.29829840763e-24 , 7.82730266816e-23 ,
 2.107743069e-21   , 4.48349055484e-20 , 7.52519404019e-19 , 9.9541767998e-18  ,
 1.03654513688e-16 , 8.48874347674e-16 , 5.67532199679e-15 , 3.80148535773e-14 ,
 5.01659801832e-13 , 1.18685407384e-11 , 2.65240130288e-10 , 4.73509963246e-09 ,
 6.61765350523e-08 , 7.22903961983e-07 , 6.1760137181e-06  , 4.13044973375e-05 ,
 0.000216490314245 , 0.000890412729952 , 0.00287791091005  , 0.00732113654694  ,
 0.0146856304453   , 0.0232941936269   , 0.0294209597022   , 0.0302702454551   ,
 0.0273146411665   , 0.0256090237228   , 0.0287594797453   , 0.0346899842454   ,
 0.037276368132    , 0.0325390638993   , 0.0224052751651   , 0.012072778104    ,
 0.00508142104758  , 0.00167053738934  , 0.000429181040247 , 8.62328604906e-05 ,
 1.35634269002e-05 , 1.67193966696e-06 , 1.6172751543e-07  , 1.22933933877e-08 ,
 7.35408137949e-10 , 3.46732908449e-11 , 1.29022116577e-12 , 3.79339202911e-14 ,
 8.8191610563e-16  , 8.87811294994e-18 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.77546968017e-25 , 2.35427963711e-23 ,
 9.9300258336e-22  , 3.31093799213e-20 , 8.73266402043e-19 , 1.82087930406e-17 ,
 2.99874138394e-16 , 3.89578537121e-15 , 3.98720285641e-14 , 3.21050821601e-13 ,
 2.03125407401e-12 , 1.00869939809e-11 , 3.92806061351e-11 , 1.19874811364e-10 ,
 2.86574633993e-10 , 5.36621935535e-10 , 7.87503074052e-10 , 9.09932994189e-10 ,
 8.80313336855e-10 , 1.36518947101e-09 , 8.53141530377e-09 , 6.88148859377e-08 ,
 4.521497113e-07   , 2.33082386049e-06 , 4.33923262646e-05 , 0.000136924545647 ,
 0.000338657003769 , 0.00065733568949  , 0.00100289547336  , 0.00120505971008  ,
 0.00114309547586  , 0.000858634958448 , 0.000512865261674 , 0.000245066754579 ,
 9.45150461983e-05 , 2.97929341265e-05 , 7.79939588674e-06 , 1.72364113936e-06 ,
 3.25048959463e-07 , 5.2298561538e-08  , 7.10454885606e-09 , 8.07199263909e-10 ,
 8.02253549118e-11 , 1.03311153235e-11 , 3.74620328007e-12 , 2.45862883899e-12 ,
 1.68553285316e-12 , 1.03528954704e-12 , 5.43059422955e-13 , 2.48368159196e-13 ,
 1.14905440966e-13 , 7.20309850575e-14 , 6.22457910431e-14 , 5.49488327416e-14 ,
 4.15116140813e-14 , 2.54320579874e-14 , 1.24373604656e-14 , 4.82453742709e-15 ,
 1.47888067889e-15 , 3.57227542343e-16 , 6.78610438709e-17 , 1.02731487232e-17 ,
 2.25685953374e-18 , 5.68756025437e-18 , 2.26569739783e-17 , 7.20640587449e-17 ,
 1.79953034059e-16 , 3.53183818564e-16 , 5.45616368939e-16 , 6.64446226813e-16 ,
 6.38744829165e-16 , 4.855061334e-16   , 2.93342120023e-16 , 1.4648097215e-16  ,
 7.82563257203e-17 , 8.30877535464e-17 , 1.41325992993e-16 , 2.22224735699e-16 ,
 2.81997661918e-16 , 2.83740206584e-16 , 2.25851060645e-16 , 1.42090453308e-16 ,
 7.05916998076e-17 , 2.77265314873e-17 , 8.94642282612e-18 , 3.78761771061e-18 ,
 6.82909195953e-18 , 3.44975369558e-17 , 3.15895239676e-16 , 3.0828753677e-15  ,
 2.50077321092e-14 , 1.60983010376e-13 , 8.25147979719e-13 , 3.70933943929e-12 ,
 2.43035210422e-11 , 3.51452282631e-10 , 5.89821231408e-09 , 8.18650755613e-08 ,
 8.93612152472e-07 , 7.63380461894e-06 , 5.10535770699e-05 , 0.000267588078543 ,
 0.00110057360983  , 0.00355715526095  , 0.00904886882786  , 0.0181496255983   ,
 0.0287776442284   , 0.0362904872462   , 0.0371187935798   , 0.0328475667796   ,
 0.0294557118779   , 0.0314311479485   , 0.0368701539563   , 0.0392410651882   ,
 0.0341594214128   , 0.0235031100117   , 0.0126617393406   , 0.00532904258038  ,
 0.00175193154553  , 0.000450095314456 , 9.04362315574e-05 , 1.42248161055e-05 ,
 1.75350571166e-06 , 1.69621831499e-07 , 1.28938577237e-08 , 7.713559586e-10   ,
 3.63696192556e-11 , 1.35340218907e-12 , 3.97933768585e-14 , 9.25191197024e-16 ,
 9.31753051976e-18 , 1.91581695095e-31 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 1.82728044685e-30 , 8.94238398481e-29 , 3.37031856728e-27 ,
 9.9047275005e-26  , 2.27044115603e-24 , 4.06117762595e-23 , 5.72175850357e-22 ,
 6.61100376971e-21 , 7.06259938781e-20 , 9.4682989201e-19  , 1.750663283e-17   ,
 3.33833457599e-16 , 5.39232732733e-15 , 6.97366686142e-14 , 7.12662606038e-13 ,
 5.73373684711e-12 , 3.62554024377e-11 , 1.79956594297e-10 , 7.00522705961e-10 ,
 2.13719449376e-09 , 5.10804924018e-09 , 9.56335955767e-09 , 1.40312565261e-08 ,
 1.6174591168e-08  , 1.4981215878e-08  , 1.4495896868e-08  , 4.53629818356e-08 ,
 3.23850225017e-07 , 2.09666240426e-06 , 1.07713605639e-05 , 0.000158361370087 ,
 0.000498895790031 , 0.00123260678064  , 0.00239045932482  , 0.00364502747897  ,
 0.00438008145247  , 0.00416094561326  , 0.00313886711896  , 0.00189275453225  ,
 0.000921355925967 , 0.000367153771736 , 0.000121902989475 , 3.43198400579e-05 ,
 8.27965650386e-06 , 1.70805368057e-06 , 2.9731657767e-07  , 4.3015897529e-08  ,
 5.23131416284e-09 , 6.46089983905e-10 , 1.62982197881e-10 , 9.55822067457e-11 ,
 6.9839878346e-11  , 4.9483700653e-11  , 3.09233019679e-11 , 1.64840294154e-11 ,
 7.76017313065e-12 , 3.81909538877e-12 , 2.59004886006e-12 , 2.32635487118e-12 ,
 2.07131423843e-12 , 1.56604188593e-12 , 9.59001235496e-13 , 4.68759005624e-13 ,
 1.8176491651e-13  , 5.57017102799e-14 , 1.34540902778e-14 , 2.56337483986e-15 ,
 4.14306529293e-16 , 1.61056371218e-16 , 4.01403431339e-16 , 1.29616116046e-15 ,
 3.74111051419e-15 , 8.97887212172e-15 , 1.73495168046e-14 , 2.66403426708e-14 ,
 3.23662595452e-14 , 3.10862094702e-14 , 2.36204501152e-14 , 1.42700748497e-14 ,
 7.12706126797e-15 , 3.81231653357e-15 , 4.05630516392e-15 , 6.90436784208e-15 ,
 1.08576948682e-14 , 1.3778306531e-14  , 1.38634654125e-14 , 1.10350214865e-14 ,
 6.94251736205e-15 , 3.44923569e-15    , 1.35565432899e-15 , 4.41866138157e-16 ,
 2.02489977578e-16 , 3.5825254436e-16  , 1.25350312024e-15 , 8.11453328228e-15 ,
 7.20237566683e-14 , 5.75369234684e-13 , 3.68967184036e-12 , 1.86519887409e-11 ,
 7.44637760419e-11 , 2.44639271075e-10 , 8.84616051167e-10 , 6.80461823356e-09 ,
 8.15493385499e-08 , 8.74784164921e-07 , 7.45858888282e-06 , 4.98711680655e-05 ,
 0.000261384553714 , 0.00107505579415  , 0.00347466850698  , 0.00883889576977  ,
 0.0177271773921   , 0.0280989410152   , 0.0353886372382   , 0.0360145849541   ,
 0.0313277587099   , 0.0269420827358   , 0.0272660987691   , 0.0309946814996   ,
 0.0326174471836   , 0.0282997172804   , 0.0194538889589   , 0.0104781117586   ,
 0.00440998320602  , 0.00144989131122  , 0.000372538471734 , 7.48638894764e-05 ,
 1.17775664236e-05 , 1.45215320945e-06 , 1.40508474833e-07 , 1.06841425007e-08 ,
 6.39394108228e-10 , 3.01598841419e-11 , 1.12282637835e-12 , 3.30297212639e-14 ,
 7.68319780421e-16 , 7.76974841934e-18 , 2.22805351501e-29 , 1.25323372696e-31 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8.98510587874e-29 ,
 4.39715025958e-27 , 1.65725350065e-25 , 4.87035394295e-24 , 1.11642163158e-22 ,
 1.99696281019e-21 , 2.79592658538e-20 , 3.10217411553e-19 , 2.84640270103e-18 ,
 2.56813440452e-17 , 3.10487655885e-16 , 4.94495085474e-15 , 7.63296708355e-14 ,
 9.76941545627e-13 , 9.95424357568e-12 , 7.9979109768e-11  , 5.05263858557e-10 ,
 2.50615515656e-09 , 9.75031700506e-09 , 2.97335961447e-08 , 7.10408971174e-08 ,
 1.32969275595e-07 , 1.95052066897e-07 , 2.2470285223e-07  , 2.05776699188e-07 ,
 1.66463162308e-07 , 2.48442232827e-07 , 1.26522762865e-06 , 7.76892712167e-06 ,
 3.9454063942e-05  , 0.000457964405306 , 0.00143676742639  , 0.00354385108524  ,
 0.00686807036962  , 0.010474201095    , 0.0126060521691   , 0.0120267288677   ,
 0.00915820977428  , 0.00562504428771  , 0.00282938864106  , 0.00118827164977  ,
 0.000424753334949 , 0.000130664408635 , 3.44777475353e-05 , 7.68187981196e-06 ,
 1.41858583391e-06 , 2.16249647331e-07 , 2.96912126596e-08 , 5.89888053479e-09 ,
 2.81822078937e-09 , 2.0347365937e-09  , 1.57225804123e-09 , 1.14309653519e-09 ,
 7.25949859191e-10 , 3.93904429606e-10 , 1.91723046767e-10 , 1.00765183424e-10 ,
 7.34561726296e-11 , 6.80529089245e-11 , 6.09545021962e-11 , 4.60879639405e-11 ,
 2.82020772017e-11 , 1.37760733072e-11 , 5.33917190298e-12 , 1.63563190965e-12 ,
 3.95029423184e-13 , 7.54509036682e-14 , 1.28283361465e-14 , 6.62373800286e-15 ,
 1.68472084542e-14 , 5.14569044441e-14 , 1.44003667284e-13 , 3.40992520593e-13 ,
 6.55366497e-13    , 1.00427956677e-12 , 1.21924729209e-12 , 1.17077176911e-12 ,
 8.8958170082e-13  , 5.37477360353e-13 , 2.68503192091e-13 , 1.43740932752e-13 ,
 1.53093731709e-13 , 2.60607512355e-13 , 4.09746476153e-13 , 5.19856725251e-13 ,
 5.22973542653e-13 , 4.16215213521e-13 , 2.6184676706e-13  , 1.30152501823e-13 ,
 5.1306290394e-14  , 1.69970250643e-14 , 8.16162726957e-15 , 1.38671904922e-14 ,
 3.89428320827e-14 , 1.75871272587e-13 , 1.33486325505e-12 , 1.0357928365e-11  ,
 6.61286946487e-11 , 3.33866296651e-10 , 1.32541690179e-09 , 4.14234091684e-09 ,
 1.03706735033e-08 , 2.39246093007e-08 , 9.13151148165e-08 , 7.09623558252e-07 ,
 5.79369430512e-06 , 3.85493554061e-05 , 0.000201934704348 , 0.000830497067647 ,
 0.0026842465166   , 0.00682831201762  , 0.0136947377376   , 0.0217040371687   ,
 0.0273112304983   , 0.0276876654069   , 0.0237433091959   , 0.0196574800445   ,
 0.0188455736289   , 0.0206675071636   , 0.0214497034337   , 0.0185321787961   ,
 0.0127267315146   , 0.00685540384338  , 0.00288691339945  , 0.000949983352799 ,
 0.000244377845191 , 4.91823490309e-05 , 7.7516059144e-06  , 9.5789960865e-07  ,
 9.29332567621e-08 , 7.0887726397e-09  , 4.25762240677e-10 , 2.01648845106e-11 ,
 7.54461151211e-13 , 2.26787342722e-14 , 8.14196862422e-16 , 1.78706301995e-16 ,
 8.09163119718e-17 , 2.98984777033e-17 , 8.73761703822e-18 , 2.01840863562e-18 ,
 3.68187036088e-19 , 5.29685599833e-20 , 6.00112988966e-21 , 5.34644586189e-22 ,
 3.74010679706e-23 , 2.05165558721e-24 , 8.81462026083e-26 , 2.96297220676e-27 ,
 7.78558854663e-29 , 1.5351282936e-30  , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3.39090312853e-27 ,
 1.65944739807e-25 , 6.25433484698e-24 , 1.83803047456e-22 , 4.21328101682e-21 ,
 7.53636911133e-20 , 1.05325588053e-18 , 1.15479826194e-17 , 1.00711914351e-16 ,
 7.45920753119e-16 , 5.83953403778e-15 , 6.42666265786e-14 , 8.68863519867e-13 ,
 1.07706802179e-11 , 1.08889796958e-10 , 8.72541262368e-10 , 5.50400880833e-09 ,
 2.72707512258e-08 , 1.06007535588e-07 , 3.23051058838e-07 , 7.71440276435e-07 ,
 1.44335065266e-06 , 2.11666174266e-06 , 2.43786156814e-06 , 2.22666042355e-06 ,
 1.71063738653e-06 , 1.62224687438e-06 , 4.5692232829e-06  , 2.37056751589e-05 ,
 0.000115502593866 , 0.00106060608876  , 0.00328016255838  , 0.0080529037871   ,
 0.0155895884228   , 0.0238022706843   , 0.0287629573395   , 0.0276917587149   ,
 0.0214694738521   , 0.0136209130888   , 0.00722106542982  , 0.0032675573662   ,
 0.00127776197641  , 0.000430202438427 , 0.000122539404401 , 2.89071099187e-05 ,
 5.58137326812e-06 , 9.1643038912e-07  , 1.69830782879e-07 , 6.5052568455e-08  ,
 4.40669071906e-08 , 3.4816981488e-08  , 2.79784567363e-08 , 2.07937737393e-08 ,
 1.34159028658e-08 , 7.42649429883e-09 , 3.75455797283e-09 , 2.11222979737e-09 ,
 1.64221415028e-09 , 1.55843108319e-09 , 1.40097378608e-09 , 1.05855003995e-09 ,
 6.47045037329e-10 , 3.15794001956e-10 , 1.22315464655e-10 , 3.74549682473e-11 ,
 9.0452925611e-12  , 1.73430899829e-12 , 3.16777564994e-13 , 2.1607448398e-13  ,
 5.51538476668e-13 , 1.59778506213e-12 , 4.33038871393e-12 , 1.01035958525e-11 ,
 1.93009917865e-11 , 2.95069672308e-11 , 3.57914233317e-11 , 3.4358065171e-11  ,
 2.61042708508e-11 , 1.57725408131e-11 , 7.88084957301e-12 , 4.22213194494e-12 ,
 4.50152189493e-12 , 7.66421818337e-12 , 1.20489242758e-11 , 1.52847857411e-11 ,
 1.53746088081e-11 , 1.22349578556e-11 , 7.6970595133e-12  , 3.82707883929e-12 ,
 1.51176467346e-12 , 5.0697934747e-13  , 2.53889789167e-13 , 4.29080439563e-13 ,
 1.06510397103e-12 , 3.4221844205e-12  , 2.00823580362e-11 , 1.465312328e-10   ,
 9.26529773916e-10 , 4.67073689084e-09 , 1.85325440239e-08 , 5.7785756713e-08  ,
 1.41726187192e-07 , 2.75516861814e-07 , 4.51566081144e-07 , 9.0676522582e-07  ,
 3.98673102091e-06 , 2.38898098703e-05 , 0.000123600428891 , 0.000507647826638 ,
 0.00164071097077  , 0.00417470590864  , 0.00837690897324  , 0.0132884673907   ,
 0.0167460708424   , 0.0169974501567   , 0.014519037936    , 0.0117505665202   ,
 0.0107504018934   , 0.0113090720271   , 0.011498221869    , 0.00986550059243  ,
 0.00677336101933  , 0.00366137775495  , 0.00155149239619  , 0.00051499493009  ,
 0.000133972420363 , 2.73411575299e-05 , 4.38281421061e-06 , 5.52630576141e-07 ,
 5.48904176715e-08 , 4.30079275158e-09 , 2.66158475431e-10 , 1.30370382574e-11 ,
 5.23849682735e-13 , 3.43895278236e-14 , 1.4554285673e-14  , 8.38203769891e-15 ,
 3.91304153453e-15 , 1.44586401932e-15 , 4.22543455189e-16 , 9.76084617789e-17 ,
 1.78052003961e-17 , 2.56151285285e-18 , 2.90209349637e-19 , 2.58549407357e-20 ,
 1.80868266661e-21 , 9.92162550372e-23 , 4.26267263036e-24 , 1.43286723155e-25 ,
 3.76504196743e-27 , 7.42374505943e-29 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9.98197049674e-26 ,
 4.88499799036e-24 , 1.84111971215e-22 , 5.41070189081e-21 , 1.24028452628e-19 ,
 2.21851852651e-18 , 3.09885986426e-17 , 3.38571310999e-16 , 2.90704858159e-15 ,
 2.00431408555e-14 , 1.21589805207e-13 , 8.46609575038e-13 , 8.42120756435e-12 ,
 9.48510313296e-11 , 9.37157694724e-10 , 7.46208763337e-09 , 4.694384828e-08   ,
 2.32189921992e-07 , 9.01385793588e-07 , 2.74406066459e-06 , 6.54743144547e-06 ,
 1.22425499531e-05 , 1.79460191306e-05 , 2.06658253499e-05 , 1.88721308988e-05 ,
 1.4333719273e-05  , 1.14778317242e-05 , 1.84952359413e-05 , 6.56866581099e-05 ,
 0.000279534194837 , 0.00205288162048  , 0.00602782782911  , 0.0145440735113   ,
 0.0280285086161   , 0.0428726707841   , 0.0522195191209   , 0.0511366532129   ,
 0.0409141205318   , 0.0273440625448   , 0.0156257307568   , 0.00774572562388  ,
 0.00331988728873  , 0.00120735789965  , 0.000363893872852 , 8.94236977509e-05 ,
 1.81735323034e-05 , 3.58811182193e-06 , 1.1660821681e-06  , 7.30225993884e-07 ,
 5.69706695429e-07 , 4.74424627265e-07 , 3.93570842037e-07 , 2.98274471202e-07 ,
 1.95572168356e-07 , 1.10747527304e-07 , 5.84209660673e-08 , 3.51919929618e-08 ,
 2.89286904873e-08 , 2.79471349718e-08 , 2.51624776671e-08 , 1.89845149799e-08 ,
 1.15872377526e-08 , 5.64892248857e-09 , 2.18624896807e-09 , 6.69117788269e-10 ,
 1.61596951186e-10 , 3.11894010762e-11 , 6.34427946956e-12 , 5.71021560602e-12 ,
 1.4361830551e-11  , 3.9213548363e-11  , 1.02242363023e-10 , 2.34121045717e-10 ,
 4.43747737118e-10 , 6.76316039566e-10 , 8.19428666594e-10 , 7.86318151129e-10 ,
 5.97379307244e-10 , 3.60970419862e-10 , 1.80412717618e-10 , 9.67585772991e-11 ,
 1.03306652864e-10 , 1.75923543015e-10 , 2.76516233761e-10 , 3.50701656221e-10 ,
 3.52694799699e-10 , 2.80629047777e-10 , 1.76540064142e-10 , 8.78224585835e-11 ,
 3.48047223129e-11 , 1.18861010461e-11 , 6.29165797899e-12 , 1.06689357615e-11 ,
 2.46985243004e-11 , 6.14033338331e-11 , 2.54614812613e-10 , 1.6426708275e-09  ,
 1.01670102707e-08 , 5.10854937777e-08 , 2.02576631702e-07 , 6.31486589035e-07 ,
 1.54728869243e-06 , 2.98275821297e-06 , 4.54097816098e-06 , 5.60628318929e-06 ,
 6.80265852366e-06 , 1.51837099892e-05 , 6.19118724205e-05 , 0.000246606453193 ,
 0.000795011741964 , 0.00202651441513  , 0.00408481884054  , 0.00654084683766  ,
 0.00839994448344  , 0.00884125043987  , 0.008027934764    , 0.00697147619409  ,
 0.00652122227537  , 0.00659611450839  , 0.00641997654959  , 0.00540951714072  ,
 0.00374179204033  , 0.00207858085794  , 0.00091924246977  , 0.00032253713918  ,
 8.96718208637e-05 , 1.97443094166e-05 , 3.44179909328e-06 , 4.74748991332e-07 ,
 5.17762119915e-08 , 4.45990680041e-09 , 3.03388877766e-10 , 1.68370259883e-11 ,
 1.43431464845e-12 , 7.35059254105e-13 , 5.33276207801e-13 , 3.14683106423e-13 ,
 1.46987945979e-13 , 5.43118645542e-14 , 1.58722553373e-14 , 3.66652567759e-15 ,
 6.68827509999e-16 , 9.62196563411e-17 , 1.09013093017e-17 , 9.71204774376e-19 ,
 6.79406407887e-20 , 3.72692018801e-21 , 1.60121349823e-22 , 5.3823658331e-24  ,
 1.41428548295e-25 , 2.78862625104e-27 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.29301711562e-24 ,
 1.12216159302e-22 , 4.2293442673e-21  , 1.24292411893e-19 , 2.84913044142e-18 ,
 5.09628920367e-17 , 7.11742235696e-16 , 7.76820490633e-15 , 6.63893223159e-14 ,
 4.47502794012e-13 , 2.45465908852e-12 , 1.24363167223e-11 , 7.8663447977e-11  ,
 6.95630269612e-10 , 6.41854848408e-09 , 5.02424924196e-08 , 3.14308353766e-07 ,
 1.55005921228e-06 , 6.00507670624e-06 , 1.82518014353e-05 , 4.34948161459e-05 ,
 8.12498618019e-05 , 0.000119024159616 , 0.000137034405547 , 0.000125234065311 ,
 9.52074943783e-05 , 7.33510089402e-05 , 8.95909909924e-05 , 0.000201287717673 ,
 0.000623808829566 , 0.00379340980535  , 0.00946493305888  , 0.0214141614924   ,
 0.0404165460969   , 0.0617512151259   , 0.0761726571636   , 0.0767709463182   ,
 0.0645919825477   , 0.0465107518779   , 0.0291481828785   , 0.0158670602006   ,
 0.00735688274656  , 0.00283224291533  , 0.000887925365754 , 0.000227096843656 ,
 5.19139232901e-05 , 1.57332908129e-05 , 9.15123504631e-06 , 7.13746927228e-06 ,
 5.9309689479e-06  , 5.1400579622e-06  , 4.3816197796e-06  , 3.38059092766e-06 ,
 2.25452155022e-06 , 1.31000718267e-06 , 7.23974773467e-07 , 4.66163251037e-07 ,
 4.01501614836e-07 , 3.92687509038e-07 , 3.53413542298e-07 , 2.66031808381e-07 ,
 1.62056953727e-07 , 7.88927856544e-08 , 3.05029342846e-08 , 9.3300157213e-09  ,
 2.25404346636e-09 , 4.40102589842e-10 , 1.04602229299e-10 , 1.21757471354e-10 ,
 2.97943161994e-10 , 7.62888413477e-10 , 1.89964829093e-09 , 4.24837012232e-09 ,
 7.97095282482e-09 , 1.21001699286e-08 , 1.46392111218e-08 , 1.40412035048e-08 ,
 1.06666935895e-08 , 6.44628121341e-09 , 3.2232573749e-09  , 1.73135595212e-09 ,
 1.85212926758e-09 , 3.15470497078e-09 , 4.9569202228e-09  , 6.28456726166e-09 ,
 6.3183075068e-09  , 5.02607830667e-09 , 3.16170910048e-09 , 1.57413493388e-09 ,
 6.27090585413e-10 , 2.20064475454e-10 , 1.25040668029e-10 , 2.12740515907e-10 ,
 4.71218418159e-10 , 9.98836933456e-10 , 2.8677875975e-09  , 1.48487074293e-08 ,
 8.76941758205e-08 , 4.37394625163e-07 , 1.73230742348e-06 , 5.39850999561e-06 ,
 1.32258717213e-05 , 2.54860024554e-05 , 3.86689476447e-05 , 4.63030948437e-05 ,
 4.42727277071e-05 , 3.6899894305e-05  , 4.21564480654e-05 , 0.000103833076123 ,
 0.000312919848455 , 0.000804601649049 , 0.00167888849005  , 0.00288063303474  ,
 0.00419885153948  , 0.00543839351799  , 0.0065363134047   , 0.00745814830203  ,
 0.00807260294276  , 0.00817957003576  , 0.0075926905092   , 0.00625672584098  ,
 0.00441657552952  , 0.00258941260041  , 0.00123356784747  , 0.000470881742242 ,
 0.000142805482666 , 3.42265305753e-05 , 6.46041680043e-06 , 9.58040823958e-07 ,
 1.11418609999e-07 , 1.0153351606e-08  , 7.3492162256e-10  , 5.85706541962e-11 ,
 2.37627196036e-11 , 2.09100836525e-11 , 1.55898176461e-11 , 9.20832430936e-12 ,
 4.30132667064e-12 , 1.58933488868e-12 , 4.64471793849e-13 , 1.07293999645e-13 ,
 1.95719831061e-14 , 2.81568784212e-15 , 3.19006378022e-16 , 2.84204868258e-17 ,
 1.98815547186e-18 , 1.09061331759e-19 , 4.68565109362e-21 , 1.57504844794e-22 ,
 4.13864130371e-24 , 8.16039188857e-26 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.0440985827e-33  , 1.14094732343e-31 ,
 4.4476861196e-30  , 1.36221285901e-28 , 3.28276638941e-27 , 6.2339472094e-26  ,
 9.34148910164e-25 , 5.21844380584e-23 , 2.1161305243e-21  , 7.66204582273e-20 ,
 2.23369459168e-18 , 5.11204320736e-17 , 9.1410434422e-16  , 1.27648042063e-14 ,
 1.39274510765e-13 , 1.18861556197e-12 , 7.95715959076e-12 , 4.2228049979e-11  ,
 1.8597926791e-10  , 8.06344978331e-10 , 4.69217473048e-09 , 3.60677863607e-08 ,
 2.68836803601e-07 , 1.65934062188e-06 , 8.1389877118e-06  , 3.14263789244e-05 ,
 9.52806061635e-05 , 0.000226619852517 , 0.000422711573894 , 0.000618620118165 ,
 0.000712034792112 , 0.000651696281582 , 0.000498612861815 , 0.00038704267925  ,
 0.000439910391866 , 0.000755795631958 , 0.00158231846006  , 0.00835508578946  ,
 0.0150709071499   , 0.0281974450083   , 0.0490733838157   , 0.0733436965185   ,
 0.0916256333718   , 0.0962792232851   , 0.0868810809093   , 0.0685167135571   ,
 0.0471936389144   , 0.0278295380282   , 0.0136705473322   , 0.00547254524679  ,
 0.00177621474286  , 0.000492875344096 , 0.000153748394126 , 8.44024252491e-05 ,
 6.77011477567e-05 , 5.71818165117e-05 , 4.9438910415e-05  , 4.43211675894e-05 ,
 3.86849133883e-05 , 3.03524609268e-05 , 2.0613713522e-05  , 1.23296131476e-05 ,
 7.16111254639e-06 , 4.91050452738e-06 , 4.39167804566e-06 , 4.32698051681e-06 ,
 3.88515111558e-06 , 2.9151592913e-06  , 1.77136330343e-06 , 8.60798224008e-07 ,
 3.32413028989e-07 , 1.01611166392e-07 , 2.45741083948e-08 , 4.89662580281e-09 ,
 1.43971544784e-09 , 2.08637349837e-09 , 4.93065414114e-09 , 1.18014803139e-08 ,
 2.78531191873e-08 , 6.04775260634e-08 , 1.11991870193e-07 , 1.69126040878e-07 ,
 2.04229310539e-07 , 1.95776569836e-07 , 1.48721513489e-07 , 8.98992784339e-08 ,
 4.49817647207e-08 , 2.42163433591e-08 , 2.59764346168e-08 , 4.42539083434e-08 ,
 6.94964171014e-08 , 8.80593326692e-08 , 8.84873172942e-08 , 7.03624535919e-08 ,
 4.42596740862e-08 , 2.20654554789e-08 , 8.86326155943e-09 , 3.23846789e-09    ,
 2.00775713502e-09 , 3.4065512605e-09  , 7.27625843753e-09 , 1.41062150176e-08 ,
 2.99727815093e-08 , 1.1192912117e-07  , 5.9902073611e-07  , 2.93800720489e-06 ,
 1.16036119362e-05 , 3.61402446755e-05 , 8.85270505134e-05 , 0.00017058587628  ,
 0.000258806419652 , 0.000309529185558 , 0.000292381078146 , 0.000219514750784 ,
 0.000136651661999 , 9.31558867449e-05 , 0.000135178365213 , 0.000332879133471 ,
 0.000822168084907 , 0.00184641731469  , 0.00374555004194  , 0.00674639880187  ,
 0.0105471799778   , 0.014161433305    , 0.016467177076    , 0.0169337461534   ,
 0.0156400131367   , 0.012880253058    , 0.00919082719158  , 0.00549269058303  ,
 0.00267627928654  , 0.00104476795776  , 0.000323417667569 , 7.89141990597e-05 ,
 1.51229495418e-05 , 2.271064332e-06   , 2.66907214723e-07 , 2.46486042268e-08 ,
 2.03153844929e-09 , 5.16059888024e-10 , 5.06154007251e-10 , 4.75514933181e-10 ,
 3.55395434525e-10 , 2.09937042983e-10 , 9.8064591798e-11  , 3.62347453134e-11 ,
 1.05893460619e-11 , 2.44616208679e-12 , 4.46215475189e-13 , 6.4193979815e-14  ,
 7.27292588519e-15 , 6.47949723096e-16 , 4.53273300826e-17 , 2.48645493467e-18 ,
 1.06826682711e-19 , 3.59090332252e-21 , 9.43555788882e-23 , 1.86046203113e-24 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 8.35547023069e-31 , 4.66374345953e-29 , 1.81803897729e-27 , 5.56818985523e-26 ,
 1.34186565526e-24 , 2.5481921845e-23  , 3.81843300634e-22 , 5.09664082497e-21 ,
 7.05130824447e-20 , 1.37614593839e-18 , 3.30701399809e-17 , 7.24497664897e-16 ,
 1.2838338751e-14  , 1.78942918128e-13 , 1.95148290223e-12 , 1.66462086419e-11 ,
 1.11203481421e-10 , 5.84126901018e-10 , 2.45069120655e-09 , 8.78107971918e-09 ,
 3.3496276392e-08  , 1.79360594492e-07 , 1.16965167471e-06 , 6.9655241615e-06  ,
 3.37773513623e-05 , 0.000129685616545 , 0.000391671938615 , 0.000928831708815 ,
 0.00172868469393  , 0.00252613151912  , 0.00290678943501  , 0.0026676048397   ,
 0.00206439434345  , 0.00164798489919  , 0.00189058754313  , 0.00297908956736  ,
 0.00495904144898  , 0.0226582203516   , 0.0303051223718   , 0.0414497127417   ,
 0.0583671543151   , 0.0792018815171   , 0.097457840223    , 0.106552396035    ,
 0.103609660338    , 0.0891125434049   , 0.0662820089526   , 0.0413563286887   ,
 0.0211080678392   , 0.00872629796385  , 0.00301670387518  , 0.00105072008176  ,
 0.000563143676343 , 0.000469823844542 , 0.000422509234645 , 0.000369642923287 ,
 0.000330127472952 , 0.000304852955698 , 0.000271641823844 , 0.000216588377689 ,
 0.000150005933736 , 9.26370103337e-05 , 5.66515119649e-05 , 4.11481371123e-05 ,
 3.78838871321e-05 , 3.74316877689e-05 , 3.34662268851e-05 , 2.50041395882e-05 ,
 1.51453855024e-05 , 7.34360942275e-06 , 2.83178017195e-06 , 8.65169482305e-07 ,
 2.09793003798e-07 , 4.33288782549e-08 , 1.66880738074e-08 , 2.86363000202e-08 ,
 6.51548294261e-08 , 1.45623973746e-07 , 3.23383724385e-07 , 6.76993549592e-07 ,
 1.2326466936e-06  , 1.84892601775e-06 , 2.22727140165e-06 , 2.13365455957e-06 ,
 1.62089648594e-06 , 9.80201179775e-07 , 4.9097000714e-07  , 2.65206361404e-07 ,
 2.85586148016e-07 , 4.8659133572e-07  , 7.63434321197e-07 , 9.66450493716e-07 ,
 9.70359754374e-07 , 7.71126330343e-07 , 4.85021186913e-07 , 2.42337691156e-07 ,
 9.86257715286e-08 , 3.82113185913e-08 , 2.62360316033e-08 , 4.39397635267e-08 ,
 9.03099869965e-08 , 1.66291875439e-07 , 2.90544814897e-07 , 7.4221804951e-07  ,
 3.29196920777e-06 , 1.55440543867e-05 , 6.09959213795e-05 , 0.00018973269865  ,
 0.000464622299874 , 0.000895302397887 , 0.00135855917539  , 0.00162533428718  ,
 0.00153552820578  , 0.00114872925131  , 0.000686515787358 , 0.00034568511124  ,
 0.000209214817418 , 0.000333776531845 , 0.000930608713088 , 0.00252936050667  ,
 0.00593473718789  , 0.0116875637253   , 0.01916383227     , 0.0263384801266   ,
 0.0309796403279   , 0.0320792592404   , 0.0298079274498   , 0.024697592337    ,
 0.0177245416657   , 0.0106454936923   , 0.00520828576156  , 0.00203997919127  ,
 0.000633186180468 , 0.000154831457425 , 2.97234427791e-05 , 4.47034469325e-06 ,
 5.26904092215e-07 , 5.08675812498e-08 , 8.33703550292e-09 , 7.61441713404e-09 ,
 8.92366025687e-09 , 8.44482269814e-09 , 6.31323749969e-09 , 3.72935158776e-09 ,
 1.74203392449e-09 , 6.43679375682e-10 , 1.88110709683e-10 , 4.3453985109e-11  ,
 7.92663769854e-12 , 1.14035135201e-12 , 1.29197331123e-13 , 1.15102747157e-14 ,
 8.05201395701e-16 , 4.41697532172e-17 , 1.89768499182e-18 , 6.37893377318e-20 ,
 1.67614645898e-21 , 3.30495226915e-23 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 2.04124864974e-30 , 1.37976857566e-28 ,
 5.90319777376e-27 , 1.94115641929e-25 , 5.09699607299e-24 , 1.07194477296e-22 ,
 1.81017345628e-21 , 2.458523577e-20   , 2.75024317824e-19 , 2.67107990652e-18 ,
 2.83169877769e-17 , 4.36455653994e-16 , 8.26960501973e-15 , 1.41837246614e-13 ,
 1.96374921951e-12 , 2.13860321163e-11 , 1.82347983281e-10 , 1.21729983893e-09 ,
 6.37383967439e-09 , 2.63296808149e-08 , 8.78579133352e-08 , 2.60878678335e-07 ,
 8.99637162457e-07 , 4.37636011938e-06 , 2.36709404364e-05 , 0.000111695541764 ,
 0.000424361099476 , 0.00127378425945  , 0.00300733045972  , 0.00557868702447  ,
 0.00813534324564  , 0.00936094317114  , 0.00863340917326  , 0.00680899325709  ,
 0.0056844919092   , 0.00677110465702  , 0.0104922493201   , 0.0161352764374   ,
 0.0619318190393   , 0.0729959181336   , 0.0800818003825   , 0.0869027321016   ,
 0.0962831365169   , 0.107155367106    , 0.115571916225    , 0.116460913414    ,
 0.105216810162    , 0.0816224562545   , 0.0525335331222   , 0.0275842444452   ,
 0.0120321463219   , 0.00495231583475  , 0.00272036440588  , 0.00234028279925  ,
 0.00230231112664  , 0.0021481970421   , 0.00192518566966  , 0.00177093097251  ,
 0.00167846232827  , 0.00152282846998  , 0.00123317953526  , 0.000872150129589 ,
 0.000557487092539 , 0.000359086223643 , 0.000274436930977 , 0.000258005002215 ,
 0.000254579626809 , 0.000226182411925 , 0.000168072735109 , 0.000101402798284 ,
 4.90345903242e-05 , 1.88781033487e-05 , 5.7680311251e-06  , 1.40748333894e-06 ,
 3.09510864146e-07 , 1.63017459175e-07 , 3.14084349023e-07 , 6.87939314295e-07 ,
 1.43767181575e-06 , 2.98509639503e-06 , 5.9779938782e-06  , 1.06514771153e-05 ,
 1.58364522587e-05 , 1.90176791296e-05 , 1.82040687973e-05 , 1.38317065196e-05 ,
 8.37017325786e-06 , 4.19946831601e-06 , 2.2798846005e-06  , 2.46874371357e-06 ,
 4.2061820947e-06  , 6.58921277053e-06 , 8.32900729265e-06 , 8.35195107878e-06 ,
 6.63078034928e-06 , 4.17032221387e-06 , 2.0911726796e-06  , 8.68694195851e-07 ,
 3.65406736357e-07 , 2.8063592187e-07  , 4.58277142313e-07 , 8.99705407887e-07 ,
 1.59802591101e-06 , 2.50523656417e-06 , 4.57660837849e-06 , 1.50246748239e-05 ,
 6.52998556941e-05 , 0.000252387543265 , 0.000782711057263 , 0.0019154475373   ,
 0.00369100032679  , 0.00560290187697  , 0.00670803231657  , 0.00634582382856  ,
 0.00475946042126  , 0.00285671443593  , 0.00142907965065  , 0.000746532910385 ,
 0.000807618983364 , 0.00182213465558  , 0.0045051840297   , 0.00992927490312  ,
 0.0187025214358   , 0.0297747729215   , 0.0402375213212   , 0.0470203726481   ,
 0.0487555121623   , 0.0455686883424   , 0.0380082884151   , 0.0274206033538   ,
 0.016525534427    , 0.00810170714285  , 0.00317714600815  , 0.000986906112358 ,
 0.000241459069401 , 4.63784095657e-05 , 6.98423467287e-06 , 8.36645084306e-07 ,
 1.10736078539e-07 , 7.28515449984e-08 , 1.03031831522e-07 , 1.23429751098e-07 ,
 1.16900209543e-07 , 8.73954333288e-08 , 5.16262117096e-08 , 2.41153479427e-08 ,
 8.91059109993e-09 , 2.60405673409e-09 , 6.01542797723e-10 , 1.09730141453e-10 ,
 1.57861377422e-11 , 1.78853679139e-12 , 1.59409546824e-13 , 1.12737762594e-14 ,
 7.91723296607e-16 , 2.26304620067e-16 , 1.74498588618e-16 , 1.17787367272e-16 ,
 6.23847946432e-17 , 2.57945465686e-17 , 8.32088515776e-18 , 2.0933384827e-18  ,
 4.10590910555e-19 , 6.27736442394e-20 , 7.47933632617e-21 , 6.94389517511e-22 ,
 5.02282288402e-23 , 2.83046750022e-24 , 1.2425204236e-25  , 4.24873914373e-27 ,
 1.13164212479e-28 , 2.34420182484e-30 , 0, 0, 0, 0, 0, 0, 0,
 5.4793374617e-31  , 1.29019564859e-28 , 7.39669766753e-27 , 2.96112652078e-25 ,
 9.26343617344e-24 , 2.32568785387e-22 , 4.69827643526e-21 , 7.65579410302e-20 ,
 1.00805851816e-18 , 1.07877689454e-17 , 9.50179799873e-17 , 7.41043719121e-16 ,
 6.51375477993e-15 , 8.32669838207e-14 , 1.26012517052e-12 , 1.69612699652e-11 ,
 1.83633444623e-10 , 1.56378771084e-09 , 1.04345805437e-08 , 5.45780537296e-08 ,
 2.24346654718e-07 , 7.31081543809e-07 , 1.957526751e-06   , 4.93608599871e-06 ,
 1.57094713453e-05 , 6.78590385741e-05 , 0.00029875647297  , 0.00111038123159  ,
 0.00329904260632  , 0.007737411874    , 0.0142864785905   , 0.0207795852646   ,
 0.0239326593038   , 0.0222848920572   , 0.0181410033684   , 0.0161557141019   ,
 0.0201919616481   , 0.0311968715689   , 0.0466976201738   , 0.148930585096    ,
 0.170011508258    , 0.173419808556    , 0.16452127749     , 0.152969759246    ,
 0.145333413003    , 0.141695634606    , 0.136184161562    , 0.120993656009    ,
 0.093670237924    , 0.0609683092269   , 0.0333965710778   , 0.016717533599    ,
 0.00983046316146  , 0.00851714082018  , 0.00904136443296  , 0.00932105197596  ,
 0.00884329506046  , 0.00810524780057  , 0.00766633344792  , 0.00743241690995  ,
 0.00684831158336  , 0.00562828123718  , 0.00406859417314  , 0.00269619436533  ,
 0.00182666650392  , 0.00145804118112  , 0.00138929235834  , 0.00136358329155  ,
 0.00120130720344  , 0.000886614478721 , 0.000532332066267 , 0.000256593248098 ,
 9.86414482828e-05 , 3.01928463751e-05 , 7.47442238058e-06 , 1.82873625105e-06 ,
 1.33321771406e-06 , 2.74883198773e-06 , 5.80614605378e-06 , 1.1385872089e-05  ,
 2.20075198431e-05 , 4.18102296445e-05 , 7.24811965486e-05 , 0.000106537705541 ,
 0.000127429968086 , 0.000121870851273 , 9.26370589618e-05 , 5.61222356306e-05 ,
 2.82309617079e-05 , 1.54441598474e-05 , 1.68578207383e-05 , 2.87115227475e-05 ,
 4.48676696313e-05 , 5.65810747691e-05 , 5.66235823928e-05 , 4.48894236002e-05 ,
 2.82325916302e-05 , 1.4239989776e-05  , 6.10472376606e-06 , 2.86512539387e-06 ,
 2.46528252581e-06 , 3.88012129929e-06 , 7.20809687774e-06 , 1.23865995299e-05 ,
 1.8334272922e-05  , 2.66680857457e-05 , 6.01333059978e-05 , 0.000221587270534 ,
 0.000826738145307 , 0.00254528230661  , 0.00621853047835  , 0.0119821713438   ,
 0.0182019033576   , 0.0218235024968   , 0.020698625871    , 0.0156042586477   ,
 0.00947618923375  , 0.00486807580897  , 0.00258996111864  , 0.00238209568457  ,
 0.0041504766862   , 0.00844903430874  , 0.0160514342927   , 0.0269767013279   ,
 0.0395746514893   , 0.0507291506693   , 0.0575990267037   , 0.0590934485981   ,
 0.0552581314796   , 0.0463084775174   , 0.0335653303167   , 0.0202956606749   ,
 0.00997089971588  , 0.00391563104761  , 0.00121769726432  , 0.00029832270927  ,
 5.74403908333e-05 , 8.73871958926e-06 , 1.19329165391e-06 , 4.76093638595e-07 ,
 7.34891451595e-07 , 1.10890893871e-06 , 1.33165073237e-06 , 1.26129970557e-06 ,
 9.42957302597e-07 , 5.57023368443e-07 , 2.60193631264e-07 , 9.61412222877e-08 ,
 2.80965868303e-08 , 6.4903729876e-09  , 1.18393839906e-09 , 1.70325700176e-10 ,
 1.92988404708e-11 , 1.7230369359e-12  , 1.27189601928e-13 , 1.638687886e-14   ,
 1.11263191213e-14 , 9.40638028113e-15 , 6.36656661991e-15 , 3.36928059363e-15 ,
 1.39206682767e-15 , 4.48788502756e-16 , 1.12851344579e-16 , 2.21266428382e-17 ,
 3.38187196945e-18 , 4.0285049236e-19  , 3.73943990671e-20 , 2.70452344651e-21 ,
 1.52389063954e-22 , 6.68901673384e-24 , 2.28712574597e-25 , 6.0913933407e-27  ,
 1.26160483109e-28 , 0, 0, 0, 0, 0, 0, 0, 3.19776840026e-29 ,
 5.4446236853e-27  , 2.88115427463e-25 , 1.11050442291e-23 , 3.36631412414e-22 ,
 8.19167973569e-21 , 1.60486804587e-19 , 2.53894827674e-18 , 3.2519232899e-17  ,
 3.38114656457e-16 , 2.86282939862e-15 , 2.00775480288e-14 , 1.26587408071e-13 ,
 9.25047448531e-13 , 9.75805907061e-12 , 1.17579582886e-10 , 1.24165583632e-09 ,
 1.05184470597e-08 , 7.01044882437e-08 , 3.66476114435e-07 , 1.5039394724e-06  ,
 4.86303589918e-06 , 1.25561158799e-05 , 2.73323371579e-05 , 6.03010550917e-05 ,
 0.000178587584567 , 0.000666518198702 , 0.00235487386069  , 0.00686808333544  ,
 0.015949986694    , 0.0292697020411   , 0.0424633379814   , 0.0490934981244   ,
 0.0465826947691   , 0.0399669348026   , 0.0388466883441   , 0.0509798172087   ,
 0.0780407175378   , 0.114451204568    , 0.304171618696    , 0.344673318261    ,
 0.347258179535    , 0.318077192448    , 0.275636492241    , 0.237051727461    ,
 0.208184861815    , 0.183412426443    , 0.153420987283    , 0.115322568904    ,
 0.0760663720775   , 0.0457397178432   , 0.0291815559699   , 0.024423788105    ,
 0.0262477760883   , 0.029476846909    , 0.0307549919774   , 0.0295727833563   ,
 0.0277482160347   , 0.026948106332    , 0.0266315989754   , 0.024849759409    ,
 0.0207008848426   , 0.0152983437929   , 0.0105139772765   , 0.00746972740016  ,
 0.00617847969579  , 0.00592626479389  , 0.00576375047391  , 0.00502355794936  ,
 0.00367674610199  , 0.00219472639425  , 0.00105415565253  , 0.000405022126028 ,
 0.000124763462218 , 3.19007322619e-05 , 9.24915106317e-06 , 9.03795418004e-06 ,
 1.91837521524e-05 , 3.91782162725e-05 , 7.2485787293e-05  , 0.000130213533556 ,
 0.000232823552956 , 0.000390071137712 , 0.000564988180252 , 0.000672376344969 ,
 0.00064243724768  , 0.000488718294208 , 0.000296618528739 , 0.000149817490886 ,
 8.29202189976e-05 , 9.15594600286e-05 , 0.000155788485193 , 0.000242506053388 ,
 0.00030470784243  , 0.000304016262388 , 0.000240509155912 , 0.000151306111946 ,
 7.70403901667e-05 , 3.46128479609e-05 , 1.86117855442e-05 , 1.77946491088e-05 ,
 2.67759029011e-05 , 4.66478786502e-05 , 7.72891874201e-05 , 0.000110548849451 ,
 0.000141694356923 , 0.000225070085374 , 0.00062922409389  , 0.00216950623532  ,
 0.0065617686113   , 0.0159636079367   , 0.0307470798352   , 0.0467712684878   ,
 0.0562377191181   , 0.0536091187044   , 0.0408071734236   , 0.0253102743239   ,
 0.0136505880636   , 0.00785319091859  , 0.00701771288588  , 0.0101866232466   ,
 0.0171567583164   , 0.0274349600621   , 0.0392728499509   , 0.0499734008425   ,
 0.0571707040766   , 0.0599814532574   , 0.0588312626671   , 0.0539874898246   ,
 0.0450581065496   , 0.032710835725    , 0.0198386817603   , 0.00977889010901  ,
 0.00385505621017  , 0.00120517750685  , 0.000297872806641 , 5.85221430588e-05 ,
 9.70416294752e-06 , 2.57099512292e-06 , 3.33420772693e-06 , 6.13821539346e-06 ,
 9.32613996219e-06 , 1.12010804389e-05 , 1.06092011666e-05 , 7.93149450944e-06 ,
 4.68528668561e-06 , 2.18856461892e-06 , 8.08671879527e-07 , 2.3632858973e-07  ,
 5.4592421512e-08  , 9.95845589093e-09 , 1.43267656723e-09 , 1.62379012143e-10 ,
 1.46095745434e-11 , 1.27990514409e-12 , 4.34681457834e-13 , 4.22180930809e-13 ,
 3.63758070185e-13 , 2.46318840578e-13 , 1.30328508966e-13 , 5.38370163427e-14 ,
 1.73539302576e-14 , 4.36326719478e-15 , 8.55425476716e-16 , 1.30764895756e-16 ,
 1.57756710054e-17 , 2.51553354033e-18 , 4.52611109485e-18 , 1.43736709238e-17 ,
 3.67719153665e-17 , 7.42282566799e-17 , 1.18332394056e-16 , 1.49119584179e-16 ,
 1.48630395994e-16 , 1.17183492838e-16 , 7.30547342661e-17 , 3.59834926856e-17 ,
 1.39872718594e-17 , 4.28490625803e-18 , 1.03296566161e-18 , 1.95669569119e-19 ,
 2.90834502519e-20 , 3.39641396894e-21 , 6.38490819502e-22 , 9.74397381367e-21 ,
 2.2998684401e-19  , 4.37712824534e-18 , 6.72551631782e-17 , 8.37129801695e-16 ,
 8.4656049137e-15  , 6.96878578103e-14 , 4.68630729207e-13 , 2.62346031571e-12 ,
 1.33992693708e-11 , 8.12853327294e-11 , 7.03275058112e-10 , 6.72969113221e-09 ,
 5.57583470109e-08 , 3.69877942514e-07 , 1.9314383408e-06  , 7.92024865447e-06 ,
 2.55428108666e-05 , 6.51406033038e-05 , 0.000134113181728 , 0.000241884419838 ,
 0.000482140192486 , 0.00131991650241  , 0.0041469081321   , 0.0116520549641   ,
 0.026655348958    , 0.0485640446158   , 0.070415889099    , 0.0823186464526   ,
 0.0810175968133   , 0.0755248369525   , 0.0816444547726   , 0.111423005996    ,
 0.166675868834    , 0.237505784994    , 0.53095584835     , 0.59746169528     ,
 0.60293841751     , 0.552147013373    , 0.473060652264    , 0.396174490869    ,
 0.334755626463    , 0.282742907009    , 0.228703529701    , 0.170597835943    ,
 0.117622320215    , 0.0805154074865   , 0.0631699768687   , 0.0622286133225   ,
 0.0704073534915   , 0.0793759331316   , 0.0830347797604   , 0.0809782599933   ,
 0.0778936666604   , 0.0775355118017   , 0.0778011423599   , 0.0732579324766   ,
 0.0617261934049   , 0.0465913420346   , 0.033169530759    , 0.0246012174486   ,
 0.0209216776979   , 0.0200753758342   , 0.0192744926711   , 0.0165776211923   ,
 0.0120113824093   , 0.00712133867955  , 0.00340913627131  , 0.00131312382188  ,
 0.000411756344289 , 0.000112848016728 , 4.15207691629e-05 , 5.03163307532e-05 ,
 0.000106765562353 , 0.000211386217057 , 0.000371478223319 , 0.000621274725462 ,
 0.0010388904787   , 0.00167012560307  , 0.00237463430724  , 0.00280819399852  ,
 0.00268061645315  , 0.0020419953389   , 0.00124287226742  , 0.000631768916346 ,
 0.000355927981295 , 0.000399518886964 , 0.000678380031473 , 0.00104967271859  ,
 0.00131177469508  , 0.00130308554773  , 0.00102798124675  , 0.000647371467216 ,
 0.000334626168943 , 0.000160686668759 , 0.000100852853106 , 0.000105412140743 ,
 0.000151255380194 , 0.000245636970166 , 0.000389920442166 , 0.000542970381525 ,
 0.000653173921526 , 0.000812425572463 , 0.00159143118582  , 0.00468039366042  ,
 0.013569591691    , 0.0326533965845   , 0.0627906352719   , 0.0957550604274   ,
 0.115793730838    , 0.111489306093    , 0.0864347487027   , 0.0556467529104   ,
 0.0324312371747   , 0.0209824388424   , 0.0194123865082   , 0.0253558783304   ,
 0.0372504650581   , 0.0521533928935   , 0.0648841985038   , 0.0706957572953   ,
 0.0686266853619   , 0.0616361376071   , 0.0534470872336   , 0.0454359145989   ,
 0.0366194651118   , 0.0263429406212   , 0.0160473794117   , 0.00801134031646  ,
 0.00322500198678  , 0.00104297621178  , 0.000274357399452 , 6.21392845278e-05 ,
 1.59409264713e-05 , 1.16079038929e-05 , 2.15274004133e-05 , 4.02800114554e-05 ,
 6.11823142802e-05 , 7.34709321085e-05 , 6.9586585157e-05  , 5.20230393963e-05 ,
 3.07309863156e-05 , 1.43548821248e-05 , 5.30411062901e-06 , 1.55008845414e-06 ,
 3.58073844488e-07 , 6.53180414263e-08 , 9.39751346297e-09 , 1.06660173526e-09 ,
 9.93801636297e-11 , 1.47949217746e-11 , 1.18883304629e-11 , 1.27672373801e-11 ,
 1.10426314666e-11 , 7.47611881385e-12 , 3.95455885996e-12 , 1.63321023479e-12 ,
 5.26358540573e-13 , 1.32322801182e-13 , 2.59393003801e-14 , 3.9654727628e-15  ,
 4.82372473132e-16 , 9.77205377036e-17 , 2.25877200917e-16 , 7.23862179984e-16 ,
 1.85214117128e-15 , 3.73876604569e-15 , 5.96022562588e-15 , 7.51093033086e-15 ,
 7.48629065406e-15 , 5.90235719536e-15 , 3.67965765498e-15 , 1.81243468728e-15 ,
 7.0451798969e-16  , 2.15824802386e-16 , 5.20341963809e-17 , 9.90008122616e-18 ,
 1.75875643377e-18 , 1.68742801639e-18 , 6.14445613439e-18 , 1.95671644678e-17 ,
 5.3091810252e-17  , 1.89170743119e-16 , 1.57461863874e-15 , 1.74641762501e-14 ,
 1.69891689082e-13 , 1.35812480622e-12 , 8.870700283e-12   , 4.74554171446e-11 ,
 2.12322012321e-10 , 8.79356097483e-10 , 4.41983627316e-09 , 3.12096530749e-08 ,
 2.36778196861e-07 , 1.53982916934e-06 , 8.00652039689e-06 , 3.2796522184e-05  ,
 0.000105652225174 , 0.000268279889978 , 0.000541503722053 , 0.000897635341972 ,
 0.00137800880157  , 0.00255557024739  , 0.00635104637275  , 0.0164806046609   ,
 0.036783192995    , 0.0665838430413   , 0.0971789456659   , 0.116758768829    ,
 0.122799234074    , 0.1285533095      , 0.154767976563    , 0.215432188729    ,
 0.31028838389     , 0.424521327216    , 0.810898753015    , 0.899647693966    ,
 0.909014367584    , 0.840532093688    , 0.729200432217    , 0.618374693808    ,
 0.528277330676    , 0.450226364571    , 0.368754523579    , 0.283647250477    ,
 0.209434121503    , 0.160099865918    , 0.139643832363    , 0.143221380106    ,
 0.160449406204    , 0.178059423958    , 0.185810756901    , 0.183803713073    ,
 0.181286861076    , 0.184414360084    , 0.186972077131    , 0.176859300608    ,
 0.150224550674    , 0.11554044121     , 0.08497395413     , 0.0654274791008   ,
 0.0567789247292   , 0.0541896595848   , 0.0511605696254   , 0.0432977874481   ,
 0.0309976860845   , 0.0182421657413   , 0.00872023995877  , 0.00339573633801  ,
 0.00111306963573  , 0.000349080798094 , 0.000168819984992 , 0.000228660777645 ,
 0.000474326023406 , 0.00091234026684  , 0.00153395342751  , 0.00240077720322  ,
 0.00374272909232  , 0.00573547510779  , 0.00797222921171  , 0.0093554119518   ,
 0.00892256741413  , 0.0068114486755   , 0.0041635577614   , 0.00213734981035  ,
 0.00123686510051  , 0.00142032021163  , 0.00240218540874  , 0.00368382881229  ,
 0.00456817717296  , 0.00451117835377  , 0.00354715645157  , 0.00224017390457  ,
 0.00118542938422  , 0.000621687115559 , 0.000457155687836 , 0.00051202844437  ,
 0.000703246985625 , 0.00106389333644  , 0.00160735148924  , 0.00217810292417  ,
 0.0025347353873   , 0.00275711206668  , 0.00387092903805  , 0.00875662153292  ,
 0.0231061117808   , 0.0540892042462   , 0.103442901686    , 0.158427516773    ,
 0.193738364706    , 0.190219418078    , 0.152598610778    , 0.104642917651    ,
 0.0681639497854   , 0.0505351163656   , 0.0491952027175   , 0.0605270070022   ,
 0.0814145459622   , 0.105221906417    , 0.121122193739    , 0.120476627721    ,
 0.103700248788    , 0.0794536902088   , 0.0572211760083   , 0.0411543503549   ,
 0.0299746180269   , 0.0209577526368   , 0.0130861086722   , 0.00695362043858  ,
 0.00308826815101  , 0.00115870191832  , 0.000386720684767 , 0.000129822138791 ,
 5.82405743638e-05 , 5.91580871401e-05 , 0.00011111053135  , 0.000206467668977 ,
 0.000313132522389 , 0.000375927887661 , 0.000356037487561 , 0.000266172236844 ,
 0.000157232725375 , 7.34456224834e-05 , 2.71380586838e-05 , 7.93090278207e-06 ,
 1.83205646602e-06 , 3.3419787914e-07  , 4.80944056104e-08 , 5.49442041159e-09 ,
 5.93710505247e-10 , 2.28986890516e-10 , 2.77108104639e-10 , 3.04443136514e-10 ,
 2.63426031138e-10 , 1.78277503153e-10 , 9.42700743397e-11 , 3.89226523355e-11 ,
 1.25415302575e-11 , 3.15232785632e-12 , 6.17873948355e-13 , 9.44690804391e-14 ,
 1.16331311849e-14 , 3.09105190398e-15 , 8.53553177386e-15 , 2.74949950018e-14 ,
 7.03576193064e-14 , 1.42025397705e-13 , 2.26412518688e-13 , 2.8531950993e-13  ,
 2.84383516626e-13 , 2.24214256855e-13 , 1.39780036906e-13 , 6.88493907088e-14 ,
 2.67626940825e-14 , 8.19859432521e-15 , 1.97669887527e-15 , 3.76612860361e-16 ,
 7.03507377353e-17 , 8.23683715977e-17 , 3.07008970692e-16 , 9.71966532204e-16 ,
 2.49124001581e-15 , 6.36038286148e-15 , 3.17249533594e-14 , 2.96265478942e-13 ,
 2.74226346895e-12 , 2.12113474998e-11 , 1.34530973119e-10 , 6.98515749654e-10 ,
 2.97616617886e-09 , 1.06502244402e-08 , 3.57948726579e-08 , 1.4883302435e-07  ,
 8.54659073545e-07 , 5.13627358751e-06 , 2.62354149439e-05 , 0.000107048082351 ,
 0.00034444720781  , 0.000873137380468 , 0.00174986120304  , 0.00281007496488  ,
 0.00381072199223  , 0.00517596743632  , 0.0091532106877   , 0.0202823987495   ,
 0.0433447394674   , 0.0783403029713   , 0.117114967699    , 0.149005396462    ,
 0.173745485048    , 0.207176281148    , 0.270771256274    , 0.375534099532    ,
 0.515476678461    , 0.670703159929    , 1.12258142705     , 1.2168234895      ,
 1.22417260476     , 1.14434435285     , 1.01476371709     , 0.885994871796    ,
 0.781304667803    , 0.686975184175    , 0.582643962735    , 0.471118526423    ,
 0.374477170348    , 0.311405677631    , 0.286249157865    , 0.292457270233    ,
 0.316559496972    , 0.340829896525    , 0.351936853022    , 0.351853939918    ,
 0.354739585587    , 0.366822995456    , 0.373414987703    , 0.352808389323    ,
 0.30068307514     , 0.234741795998    , 0.177616647555    , 0.141118758757    ,
 0.124102149698    , 0.117163617471    , 0.108304509333    , 0.0898895561481   ,
 0.0634632762074   , 0.0370931698123   , 0.0178167212325   , 0.00716252158041  ,
 0.00258960974342  , 0.00100742608039  , 0.000616944391431 , 0.000846974988175 ,
 0.00168689371115  , 0.0031545472785   , 0.00510963668614  , 0.00754401216865  ,
 0.0109799109331   , 0.0159693982045   , 0.021619735745    , 0.0251411961006   ,
 0.0239589251097   , 0.0183454369772   , 0.0112826778242   , 0.00587968758761  ,
 0.00354055751553  , 0.00418961974818  , 0.00703572825312  , 0.0106521549154   ,
 0.013073012577    , 0.0128175792371   , 0.0100508997728   , 0.00639046204682  ,
 0.0035021906014   , 0.0020425048051   , 0.00173509779729  , 0.00204338310226  ,
 0.00271180689484  , 0.00384685410167  , 0.00550970938433  , 0.00723822320333  ,
 0.0082433687218   , 0.00842515001356  , 0.00944770722376  , 0.0155423633942   ,
 0.0343006561509   , 0.0752356122317   , 0.141526776296    , 0.218046417461    ,
 0.272196562708    , 0.277047318997    , 0.235758627342    , 0.177890950452    ,
 0.132772491889    , 0.111849772803    , 0.113477391898    , 0.134204468792    ,
 0.169836467941    , 0.208782050823    , 0.231730040508    , 0.223417389533    ,
 0.18507295398     , 0.133262413315    , 0.0867236441495   , 0.0548685523177   ,
 0.0364128522779   , 0.0253680798102   , 0.0171347590024   , 0.0103742954095   ,
 0.00544148914042  , 0.00250407221577  , 0.00107284622877  , 0.000471545447736 ,
 0.000253504103998 , 0.000252634676478 , 0.000450695689757 , 0.000826654247532 ,
 0.0012508570054   , 0.00150112940122  , 0.00142161239235  , 0.00106277949013  ,
 0.00062780129421  , 0.000293254523879 , 0.000108357071112 , 3.16665575558e-05 ,
 7.31505559309e-06 , 1.33445155109e-06 , 1.92273716111e-07 , 2.26421261924e-08 ,
 3.9798568149e-09  , 3.80512365753e-09 , 5.18143507306e-09 , 5.7174403941e-09  ,
 4.94515374181e-09 , 3.34511172566e-09 , 1.76815186588e-09 , 7.29817013956e-10 ,
 2.35101699484e-10 , 5.90816651637e-11 , 1.15786489056e-11 , 1.77071528353e-12 ,
 2.2221091116e-13  , 8.03238852917e-14 , 2.52527240605e-13 , 8.16072194449e-13 ,
 2.08840344326e-12 , 4.21574536459e-12 , 6.72069577429e-12 , 8.46937850601e-12 ,
 8.44173467995e-12 , 6.65577730477e-12 , 4.149447559e-12   , 2.04388479293e-12 ,
 7.94510053561e-13 , 2.43402625425e-13 , 5.86896520158e-14 , 1.12004420652e-14 ,
 2.20990149612e-15 , 3.06995573354e-15 , 1.16333175021e-14 , 3.67594927351e-14 ,
 9.22701414052e-14 , 2.01052499539e-13 , 6.12170431722e-13 , 4.19594962116e-12 ,
 3.58564584846e-11 , 2.66684844684e-10 , 1.63666415244e-09 , 8.24803676126e-09 ,
 3.40880308112e-08 , 1.15753025805e-07 , 3.31475050203e-07 , 9.05073457868e-07 ,
 3.11167112177e-06 , 1.44983329815e-05 , 6.89998366861e-05 , 0.000277057608527 ,
 0.000888232023594 , 0.0022484609942   , 0.00449368054951  , 0.00713280750533  ,
 0.00920377034487  , 0.0105400576036   , 0.0135059572951   , 0.0235000864603   ,
 0.0466753196151   , 0.0852137889269   , 0.134442587666    , 0.187687587743    ,
 0.246942553164    , 0.326844363871    , 0.444047996215    , 0.601710777674    ,
 0.784865745231    , 0.968096716589    , 1.47212267407     , 1.54894475483     ,
 1.54070034123     , 1.45090312334     , 1.31680483242     , 1.18908841668     ,
 1.08833978285     , 0.993532451741    , 0.879363002156    , 0.752238179872    ,
 0.641924000363    , 0.570731169131    , 0.541075136855    , 0.542837888953    ,
 0.560488987956    , 0.576655628552    , 0.581143745035    , 0.581149572801    ,
 0.593491446606    , 0.618181687113    , 0.626708040371    , 0.58737380016     ,
 0.49933339444     , 0.393741808579    , 0.305091973509    , 0.24874204236     ,
 0.220362240757    , 0.204700563245    , 0.184338460541    , 0.149434095981    ,
 0.103893108158    , 0.0605574663382   , 0.0297276163191   , 0.0129101963674   ,
 0.00557950699444  , 0.00279797385102  , 0.00197487312722  , 0.00256887577962  ,
 0.00483585820174  , 0.0087787901539   , 0.0137732216353   , 0.0193672092466   ,
 0.0264861595308   , 0.0365514612773   , 0.0480896276802   , 0.0553503034951   ,
 0.0526982349552   , 0.0405000416463   , 0.0251157229477   , 0.0133876961014   ,
 0.00853578247691  , 0.0104763142751   , 0.0173808995253   , 0.0258581373592   ,
 0.0313293748797   , 0.0304921584805   , 0.0239090033918   , 0.0154154978228   ,
 0.00887332656703  , 0.00579944134284  , 0.00553293703267  , 0.00674954950859  ,
 0.00877040582017  , 0.0118286541747   , 0.0160855277632   , 0.0204138302787   ,
 0.0228199146721   , 0.0227258105532   , 0.0227755149719   , 0.028765813727    ,
 0.0493280876028   , 0.094976575331    , 0.170967963736    , 0.264156459726    ,
 0.34037972674     , 0.366570758419    , 0.339682452896    , 0.288349549241    ,
 0.245960756672    , 0.228689881627    , 0.238109276352    , 0.272857291826    ,
 0.328382269758    , 0.387163996169    , 0.418864055235    , 0.399025652009    ,
 0.3293302246      , 0.236931441822    , 0.153871084922    , 0.0974201486484   ,
 0.0660578725145   , 0.0486144761193   , 0.0354808334104   , 0.0234432416371   ,
 0.0135354018592   , 0.00696073307397  , 0.00338869396971  , 0.00167847572004  ,
 0.000946359154933 , 0.000868487103871 , 0.00143783999268  , 0.00258784653054  ,
 0.00390254822724  , 0.00468063111692  , 0.00443222713931  , 0.00331340595411  ,
 0.00195727025249  , 0.00091426403083  , 0.00033781800646  , 9.87245803232e-05 ,
 2.28057739977e-05 , 4.16128781597e-06 , 6.03054479313e-07 , 8.10867411725e-08 ,
 3.63683643258e-08 , 5.4850730243e-08  , 7.6687627905e-08  , 8.46422902257e-08 ,
 7.3162453842e-08  , 4.94630561053e-08 , 2.61335507012e-08 , 1.07830163072e-08 ,
 3.47265038966e-09 , 8.72494169364e-10 , 1.70960851661e-10 , 2.61556563865e-11 ,
 3.37774321175e-12 , 1.69915500888e-12 , 5.84937557036e-12 , 1.8941059336e-11  ,
 4.84740871394e-11 , 9.78531973054e-11 , 1.55998663643e-10 , 1.96591659264e-10 ,
 1.95953565748e-10 , 1.54500311526e-10 , 9.63233061488e-11 , 4.74471180377e-11 ,
 1.84445326735e-11 , 5.65084112267e-12 , 1.36269949954e-12 , 2.60635941914e-13 ,
 5.49129920897e-14 , 8.9706680719e-14  , 3.44377058138e-13 , 1.08750389724e-12 ,
 2.70784064569e-12 , 5.51537122077e-12 , 1.18636686826e-11 , 5.19532070259e-11 ,
 3.84193962771e-10 , 2.71658559976e-09 , 1.60573783636e-08 , 7.82453507298e-08 ,
 3.13796548036e-07 , 1.03327628994e-06 , 2.79771577156e-06 , 6.41691448095e-06 ,
 1.42721699251e-05 , 4.06454704811e-05 , 0.000153537327942 , 0.00057869038593  ,
 0.00182825434861  , 0.00461137603568  , 0.00920011842352  , 0.0145428468187   ,
 0.0184373060755   , 0.0196723687998   , 0.020750450181    , 0.0285335423374   ,
 0.0517561346381   , 0.0967813308202   , 0.164812046771    , 0.254148647987    ,
 0.366679176895    , 0.510708248541    , 0.693330226031    , 0.907634913659    ,
 1.12890947157     , 1.32560815341     , 1.90860173586     , 1.95208677442     ,
 1.91387217809     , 1.80750968329     , 1.67245381735     , 1.55734487466     ,
 1.47690400248     , 1.40070450354     , 1.29666178957     , 1.17259192714     ,
 1.06388163805     , 0.993840779109    , 0.958581415958    , 0.940221248629    ,
 0.922137595486    , 0.895879646996    , 0.865871477429    , 0.850266822968    ,
 0.864661252972    , 0.894673896265    , 0.894229114241    , 0.825052170114    ,
 0.695245089106    , 0.551048191764    , 0.435715088331    , 0.363266460508    ,
 0.322852812571    , 0.293592381014    , 0.256027655776    , 0.20179793127     ,
 0.138294825969    , 0.0814810729199   , 0.0425129087594   , 0.0214815894876   ,
 0.0117742817717   , 0.00725404007396  , 0.005406721351    , 0.00646974063884  ,
 0.0113588067384   , 0.019909631889    , 0.0303186985822   , 0.0409622427449   ,
 0.0531755380494   , 0.0699562609686   , 0.0894555262885   , 0.1018019737      ,
 0.0967493293559   , 0.0746207704472   , 0.0467736577325   , 0.025782937397    ,
 0.0177784291051   , 0.0226977035421   , 0.036926225609    , 0.0536914532401   ,
 0.064101174804    , 0.0620373148468   , 0.0489264286766   , 0.0323497172202   ,
 0.0198416755181   , 0.0144564049097   , 0.0149870686748   , 0.0187425901848   ,
 0.0241730165524   , 0.0315543666541   , 0.0410614901114   , 0.050315138335    ,
 0.0552430051848   , 0.0545288589275   , 0.0525245746947   , 0.0572945125265   ,
 0.0778480125181   , 0.124114890325    , 0.203564637235    , 0.30902865737     ,
 0.410652926209    , 0.471588475996    , 0.478740584275    , 0.453429778557    ,
 0.429425221269    , 0.427509166636    , 0.453215543304    , 0.507069320761    ,
 0.58346372784     , 0.658693805066    , 0.691702340312    , 0.649576888068    ,
 0.535955722328    , 0.390964137875    , 0.262164414666    , 0.175247345551    ,
 0.127052577686    , 0.099138114048    , 0.0757707841894   , 0.0523509595718   ,
 0.0319194580982   , 0.0176460283472   , 0.0093759802257   , 0.00502512576042  ,
 0.00289559815281  , 0.00241501302574  , 0.00362622663521  , 0.00634590005057  ,
 0.00951868028462  , 0.0114053587249   , 0.0107979994477   , 0.00807187999655  ,
 0.00476805697462  , 0.00222718060911  , 0.00082292568015  , 0.00024049075471  ,
 5.55561124631e-05 , 1.01482176469e-05 , 1.5117069282e-06  , 3.21147179525e-07 ,
 3.7030966409e-07  , 6.38350807625e-07 , 8.96747967696e-07 , 9.89080017592e-07 ,
 8.54296887426e-07 , 5.77214077995e-07 , 3.04818934326e-07 , 1.25722890724e-07 ,
 4.04762929415e-08 , 1.0167076255e-08  , 1.99183358695e-09 , 3.04944501297e-10 ,
 4.10902481552e-11 , 2.89880642509e-11 , 1.06135461357e-10 , 3.44119726742e-10 ,
 8.8071099054e-10  , 1.77790887338e-09 , 2.834442222e-09   , 3.57211923317e-09 ,
 3.56065790025e-09 , 2.80753430183e-09 , 1.75044565315e-09 , 8.62287971893e-10 ,
 3.35228218213e-10 , 1.02713172107e-10 , 2.47744315997e-11 , 4.75253010145e-12 ,
 1.08182019572e-12 , 2.05493413521e-12 , 7.96873939406e-12 , 2.51601599944e-11 ,
 6.24481269714e-11 , 1.23764937005e-10 , 2.20731237252e-10 , 6.00880720908e-10 ,
 3.44221317556e-09 , 2.26122504163e-08 , 1.27975523942e-07 , 6.00157333637e-07 ,
 2.32585670155e-06 , 7.43363772385e-06 , 1.95199082731e-05 , 4.2181284873e-05  ,
 7.77053202089e-05 , 0.000141811118777 , 0.000336867598391 , 0.00103291721685  ,
 0.00308374639873  , 0.00767155922294  , 0.0152503903926   , 0.0240731913371   ,
 0.0304208412073   , 0.0319195434684   , 0.0316200407015   , 0.0389340494441   ,
 0.0668377382049   , 0.127770184471    , 0.230049038905    , 0.376084117004    ,
 0.563920907664    , 0.790327489429    , 1.04915969936     , 1.32314357976     ,
 1.57970777634     , 1.7823921133      , 2.51818996988     , 2.53334663965     ,
 2.46530359789     , 2.33781250394     , 2.19623543757     , 2.09151917844     ,
 2.03643483794     , 1.99287036534     , 1.91885403232     , 1.81684584478     ,
 1.72182362196     , 1.65434706401     , 1.60067807772     , 1.53189879542     ,
 1.431716686       , 1.30966379158     , 1.19683090448     , 1.12843066213     ,
 1.1161700904      , 1.12671180192     , 1.09753569295     , 0.98944803245     ,
 0.822334296827    , 0.653621985636    , 0.527568951139    , 0.450027155186    ,
 0.400700967812    , 0.355295957907    , 0.298287461714    , 0.227935252233    ,
 0.15537470265     , 0.095717533701    , 0.0567696870196   , 0.0355359422548   ,
 0.0240284058595   , 0.0166226122504   , 0.0125503701624   , 0.0139296657235   ,
 0.0226449826098   , 0.0378964740387   , 0.0557669121673   , 0.0727019280224   ,
 0.0904688936784   , 0.114288011159    , 0.142257508832    , 0.159800731743    ,
 0.151236683106    , 0.116909593177    , 0.0743013041481   , 0.0430374608634   ,
 0.0328224216353   , 0.0434272005682   , 0.068585012527    , 0.0968542949534   ,
 0.113781119097    , 0.109877225298    , 0.087917714467    , 0.0604525128988   ,
 0.0400261783078   , 0.0321490897865   , 0.0352704098859   , 0.0449055954584   ,
 0.0580208294597   , 0.074412064933    , 0.0936324694629   , 0.111134982175    ,
 0.120045352077    , 0.118589510705    , 0.114217091176    , 0.118619708268    ,
 0.141093788507    , 0.189374340914    , 0.271636171871    , 0.387190451924    ,
 0.513302130412    , 0.612487639633    , 0.66270694568     , 0.676908134346    ,
 0.687777321065    , 0.719364645575    , 0.778331838883    , 0.861836034117    ,
 0.957922258089    , 1.03565344494     , 1.0482686478      , 0.962584538161    ,
 0.790568621026    , 0.586872683624    , 0.411740267814    , 0.29480372159     ,
 0.22807100709     , 0.185055884989    , 0.144787151244    , 0.102708564531    ,
 0.0652184298315   , 0.0382543036738   , 0.0218298746955   , 0.0124559099358   ,
 0.00729731722726  , 0.00552426275592  , 0.00730689014009  , 0.0122354232445   ,
 0.0181838298022   , 0.0217480625911   , 0.0205812990861   , 0.0153830490326   ,
 0.00908600793132  , 0.0042438291203   , 0.00156796714832  , 0.000458199476853 ,
 0.000105866914874 , 1.94423310584e-05 , 3.27861930447e-06 , 1.76292903692e-06 ,
 3.32388490085e-06 , 5.90044443298e-06 , 8.28909746367e-06 , 9.1339223179e-06  ,
 7.88283783741e-06 , 5.32261348734e-06 , 2.80931454424e-06 , 1.15821592821e-06 ,
 3.72760944957e-07 , 9.36075522625e-08 , 1.83352646718e-08 , 2.81021192707e-09 ,
 4.02647814955e-10 , 3.95779655524e-10 , 1.50986361805e-09 , 4.89945514917e-09 ,
 1.25399560996e-08 , 2.53159258962e-08 , 4.03624069658e-08 , 5.08703080094e-08 ,
 5.07109709745e-08 , 3.99884840381e-08 , 2.49346138453e-08 , 1.22845174691e-08 ,
 4.77649104749e-09 , 1.46378798222e-09 , 3.53209374487e-10 , 6.80404682643e-11 ,
 1.69478610429e-11 , 3.69202380904e-11 , 1.44253516367e-10 , 4.55435022216e-10 ,
 1.12891188704e-09 , 2.21260867347e-09 , 3.6192904927e-09  , 6.80547684991e-09 ,
 2.66908770261e-08 , 1.55576699239e-07 , 8.35743725625e-07 , 3.75400566758e-06 ,
 1.3985897164e-05  , 4.31956573204e-05 , 0.000110209025649 , 0.000231140893626 ,
 0.000399817836081 , 0.000596725790614 , 0.000911580346768 , 0.00184049844671  ,
 0.00460319794023  , 0.0108916055005   , 0.021374782557    , 0.0336947731555   ,
 0.042847775272    , 0.0457723523308   , 0.046909563156    , 0.0595322330833   ,
 0.102458227602    , 0.195451930592    , 0.354006996138    , 0.582980933868    ,
 0.873259697435    , 1.20581341107     , 1.55747603207     , 1.8994709162      ,
 2.19447398252     , 2.40649226079     , 3.4210379573      , 3.44552341774     ,
 3.37979631173     , 3.24697057241     , 3.09418848625     , 2.97973606668     ,
 2.9277718844      , 2.90583270703     , 2.8640625459      , 2.7886581981      ,
 2.70052083673     , 2.61078231482     , 2.49691506022     , 2.32345137043     ,
 2.08000850499     , 1.80055748248     , 1.54820864887     , 1.37681564635     ,
 1.29381594356     , 1.24982022518     , 1.17279766712     , 1.02724144673     ,
 0.841217000186    , 0.673245139326    , 0.558725457452    , 0.490243729836    ,
 0.438089375122    , 0.378505054393    , 0.305576034688    , 0.227800095756    ,
 0.158887037543    , 0.108602281667    , 0.0775825525166   , 0.0589342013107   ,
 0.0448858353277   , 0.0326444473508   , 0.0250484691065   , 0.0269248913084   ,
 0.0407869577434   , 0.0641076239663   , 0.0898870490933   , 0.112443241197    ,
 0.134357319886    , 0.163379750034    , 0.197641391744    , 0.218201312705    ,
 0.204737459704    , 0.158324325333    , 0.102657084201    , 0.0639910956765   ,
 0.0549946972194   , 0.0745099355815   , 0.112833398668    , 0.153555851162    ,
 0.177093273483    , 0.171220024713    , 0.140276349954    , 0.101781531106    ,
 0.0737397502445   , 0.0650669502052   , 0.0746351767188   , 0.0962073697287   ,
 0.124574339882    , 0.15778842943     , 0.193213908461    , 0.223004782452    ,
 0.237713786872    , 0.236874168684    , 0.233380809445    , 0.243959530065    ,
 0.277540405248    , 0.336849088589    , 0.426557931417    , 0.548564790774    ,
 0.686617960031    , 0.807325650293    , 0.887777653057    , 0.939180109233    ,
 0.99576936166     , 1.08390364885     , 1.20632080298     , 1.34615965129     ,
 1.47177160926     , 1.5380671151      , 1.49939894927     , 1.33911580006     ,
 1.0918592229      , 0.829247206948    , 0.615678282121    , 0.473743497435    ,
 0.385219800562    , 0.317338403674    , 0.248607071345    , 0.177849281839    ,
 0.115851827782    , 0.0710709803858   , 0.0429545087282   , 0.0258590410708   ,
 0.0154567308843   , 0.0107141258621   , 0.0120418410063   , 0.0187254753147   ,
 0.0273339576687   , 0.0325593388548   , 0.0307773962702   , 0.0229922919479   ,
 0.0135757294898   , 0.00633900989007  , 0.00234146361514  , 0.00068410391081  ,
 0.000158201524224 , 2.98276937385e-05 , 7.83936377478e-06 , 1.11107518302e-05 ,
 2.42100999051e-05 , 4.31893004312e-05 , 6.06120983548e-05 , 6.67207800272e-05 ,
 5.75329315198e-05 , 3.88202983177e-05 , 2.04782600185e-05 , 8.43897075627e-06 ,
 2.71504617656e-06 , 6.81611458958e-07 , 1.33485193145e-07 , 2.04951241684e-08 ,
 3.20044281778e-09 , 4.30109171552e-09 , 1.68597806611e-08 , 5.47410481645e-08 ,
 1.40120780271e-07 , 2.82907471198e-07 , 4.51106210751e-07 , 5.68623846903e-07 ,
 5.66931088044e-07 , 4.471373458e-07   , 2.78867820025e-07 , 1.37422931621e-07 ,
 5.34488638417e-08 , 1.63864239012e-08 , 3.95743232407e-09 , 7.67296736944e-10 ,
 2.12097060655e-10 , 5.2084843137e-10  , 2.04505870701e-09 , 6.45582699479e-09 ,
 1.59930351222e-08 , 3.11995075198e-08 , 4.91480002412e-08 , 7.39113493352e-08 ,
 1.87910084661e-07 , 8.99013563993e-07 , 4.51499551283e-06 , 1.93352591532e-05 ,
 6.89157775143e-05 , 0.000204533730906 , 0.000504860672751 , 0.00103109963287  ,
 0.00173397525515  , 0.0024231122625   , 0.00300551559718  , 0.00404214683546  ,
 0.00721999496663  , 0.0148930663236   , 0.0280623874228   , 0.0439642075748   ,
 0.0568021580618   , 0.063687911837    , 0.0717468437811   , 0.0998515278003   ,
 0.174268864148    , 0.322371135293    , 0.565244153582    , 0.907777974602    ,
 1.33173124198     , 1.80037430039     , 2.27068203599     , 2.7003046399      ,
 3.05004141996     , 3.29242110571     , 4.77967306734     , 4.8846818032      ,
 4.88828818801     , 4.79341629282     , 4.63147021671     , 4.46637859272     ,
 4.3536299169      , 4.29425574797     , 4.24314103907     , 4.15946946426     ,
 4.03042780709     , 3.84886667192     , 3.59126765617     , 3.23145608634     ,
 2.77725369086     , 2.28970021025     , 1.85803381953     , 1.54727094313     ,
 1.35965551322     , 1.23749241208     , 1.1085768041      , 0.942321771296    ,
 0.765830816345    , 0.626050740828    , 0.541744282408    , 0.492158552302    ,
 0.442758940705    , 0.375076996141    , 0.295126088053    , 0.221029260549    ,
 0.166360754576    , 0.132564691365    , 0.111801750504    , 0.0942924617757   ,
 0.074876322465    , 0.05589665794     , 0.045048111753    , 0.0497028149948   ,
 0.0714934389224   , 0.104116840103    , 0.136365098309    , 0.160903211048    ,
 0.182106408703    , 0.210521053946    , 0.244595316768    , 0.262841858312    ,
 0.243037454664    , 0.18811488721     , 0.126346434428    , 0.0877327014074   ,
 0.0855919938737   , 0.116450426477    , 0.166775868947    , 0.216508252381    ,
 0.243802678791    , 0.236099482615    , 0.199467673508    , 0.155009686099    ,
 0.125237820947    , 0.122710137319    , 0.147371871642    , 0.191316987562    ,
 0.246157154676    , 0.306151328581    , 0.364366101011    , 0.409332804448    ,
 0.431698991193    , 0.43689137219     , 0.446819889115    , 0.483210314841    ,
 0.550516191036    , 0.639866105553    , 0.745419429826    , 0.865949120578    ,
 0.990070704569    , 1.09422950001     , 1.16683379765     , 1.2298882119      ,
 1.3270924183      , 1.48999049485     , 1.71448877334     , 1.95729494873     ,
 2.14612888409     , 2.20473576479     , 2.09022830987     , 1.82245706272     ,
 1.47992675632     , 1.15728299156     , 0.912976286015    , 0.747909282644    ,
 0.626506214735    , 0.513332010019    , 0.394888989882    , 0.27941325464     ,
 0.183245058171    , 0.115626019936    , 0.0731545385599   , 0.0463263223196   ,
 0.028542059912    , 0.0185337967542   , 0.0171310764412   , 0.0234093064724   ,
 0.0328456054343   , 0.0387041721062   , 0.036447161261    , 0.027173177808    ,
 0.0160207653055   , 0.00747134713513  , 0.00275668117273  , 0.000804832660621 ,
 0.000187019959448 , 3.98442399452e-05 , 2.64565234509e-05 , 6.24601697655e-05 ,
 0.000140328415721 , 0.000250256852031 , 0.000350772420875 , 0.000385714590982 ,
 0.000332310616456 , 0.000224068384534 , 0.000118132242405 , 4.865953327e-05   ,
 1.56494532609e-05 , 3.92767661964e-06 , 7.69058205391e-07 , 1.18405565405e-07 ,
 2.07748673615e-08 , 3.70842897867e-08 , 1.47992107357e-07 , 4.80731154257e-07 ,
 1.2307489068e-06  , 2.48542196156e-06 , 3.96403665271e-06 , 4.99807465525e-06 ,
 4.98475926285e-06 , 3.93288436331e-06 , 2.45385690575e-06 , 1.2098244503e-06  ,
 4.70828836628e-07 , 1.44471845113e-07 , 3.4958652699e-08  , 6.85553073372e-09 ,
 2.13697400707e-09 , 5.78108847942e-09 , 2.27355265214e-08 , 7.17443645559e-08 ,
 1.77676293924e-07 , 3.45904772198e-07 , 5.36010873084e-07 , 7.18602505151e-07 ,
 1.25081844206e-06 , 4.46168561646e-06 , 2.03783069097e-05 , 8.27877124257e-05 ,
 0.000281289733564 , 0.000798189416655 , 0.00189537629343  , 0.00375608793615  ,
 0.00617532885022  , 0.0084140247183   , 0.00975313879753  , 0.0107373560861   ,
 0.0140029987401   , 0.0232706041103   , 0.0402902666653   , 0.06194477881     ,
 0.0817372272239   , 0.0976376611662   , 0.121223516432    , 0.179723765619    ,
 0.309001777697    , 0.543047503165    , 0.904007367325    , 1.3922916584      ,
 1.98014195727     , 2.61638751655     , 3.24081161703     , 3.79766305417     ,
 4.24632968854     , 4.57109718011     , 6.78827779825     , 7.05306033977     ,
 7.19655778946     , 7.18438588679     , 7.00944934238     , 6.7330927845      ,
 6.45942589062     , 6.25269272255     , 6.09064274525     , 5.90210879847     ,
 5.62800705838     , 5.23991116224     , 4.7264176576      , 4.09117457266     ,
 3.37384682273     , 2.66007399958     , 2.0495678033      , 1.60286319369     ,
 1.31269159841     , 1.11915273228     , 0.956031489709    , 0.795595560078    ,
 0.654838661261    , 0.560464062817    , 0.512695020955    , 0.482820568006    ,
 0.43917040878     , 0.37225499533     , 0.297589530953    , 0.237717912584    ,
 0.202516231485    , 0.184667816491    , 0.169595917404    , 0.147370108119    ,
 0.118226101444    , 0.0914864867507   , 0.0799878823715   , 0.0923638604291   ,
 0.126826018133    , 0.170432215163    , 0.206227932512    , 0.225772231306    ,
 0.236600568902    , 0.253015622468    , 0.2754332685      , 0.28351976844     ,
 0.257018900068    , 0.201064512312    , 0.144637998212    , 0.116490854817    ,
 0.127270355799    , 0.169803551324    , 0.226995704036    , 0.277673772119    ,
 0.302252529515    , 0.291841599101    , 0.255383771017    , 0.216220716173    ,
 0.199479749683    , 0.219973337248    , 0.277640887773    , 0.361486944168    ,
 0.457650895688    , 0.553828765253    , 0.637419300104    , 0.695779441961    ,
 0.726632732221    , 0.750046033968    , 0.802100230833    , 0.906640742165    ,
 1.0527549371      , 1.2064254472      , 1.34184608626     , 1.45167384287     ,
 1.53098941813     , 1.57157467377     , 1.58346752599     , 1.6125255634      ,
 1.7233069652      , 1.9599728808      , 2.31348417237     , 2.70608725245     ,
 3.00506310007     , 3.08107977635     , 2.88644130701     , 2.48945870128     ,
 2.0309877522      , 1.63742339473     , 1.35646920039     , 1.15706662671     ,
 0.980474240077    , 0.791580028064    , 0.593433052725    , 0.410909419966    ,
 0.267796574514    , 0.171768197034    , 0.113012325012    , 0.0753571074041   ,
 0.048505367405    , 0.0307242466234   , 0.0235448830896   , 0.0261534172748   ,
 0.0334587221112   , 0.0381583719441   , 0.0354344376657   , 0.0262037267262   ,
 0.0153559854258   , 0.00712498586436  , 0.00261748381549  , 0.000762554556738 ,
 0.000182033452541 , 6.03782121316e-05 , 0.000104823016879 , 0.000285851436819 ,
 0.000644597833267 , 0.00114777983506  , 0.00160665976244  , 0.00176483163609  ,
 0.00151917168047  , 0.00102362213413  , 0.000539365422691 , 0.000222068597185 ,
 7.13942723445e-05 , 1.79134760962e-05 , 3.50714348355e-06 , 5.42313823536e-07 ,
 1.10791596484e-07 , 2.53329514693e-07 , 1.02297099871e-06 , 3.32457317296e-06 ,
 8.51440797165e-06 , 1.72013365623e-05 , 2.74476607915e-05 , 3.46263770097e-05 ,
 3.45556891851e-05 , 2.72833170693e-05 , 1.70370280948e-05 , 8.40793526634e-06 ,
 3.27610356527e-06 , 1.00711018577e-06 , 2.44802014244e-07 , 4.91062024975e-08 ,
 1.76010327765e-08 , 5.06740575363e-08 , 1.9855066853e-07  , 6.25944262028e-07 ,
 1.54973792488e-06 , 3.01416032214e-06 , 4.63629040207e-06 , 5.88226792619e-06 ,
 7.86844039686e-06 , 1.95644913717e-05 , 7.7614767857e-05  , 0.000297009140374 ,
 0.000960270318311 , 0.00259696950706  , 0.00590357130715  , 0.0112952871687   ,
 0.0181178526524   , 0.0242794633435   , 0.0275389035047   , 0.0283135185171   ,
 0.0313163121097   , 0.0432874883011   , 0.0676719226133   , 0.100842502954    ,
 0.135129967986    , 0.169783508812    , 0.223027274977    , 0.334118791541    ,
 0.551026966372    , 0.911764245834    , 1.43148907541     , 2.09907395916     ,
 2.87896022472     , 3.71595177886     , 4.54339326001     , 5.295332586       ,
 5.92421251521     , 6.4166946275      , 9.6251254699      , 10.0865483418     ,
 10.3805564296     , 10.4343287348     , 10.1966672052     , 9.72482168449     ,
 9.17733464713     , 8.69044019616     , 8.27310437408     , 7.83223732192     ,
 7.27240072364     , 6.55563175827     , 5.69521234899     , 4.73514253978     ,
 3.74972554643     , 2.83924157773     , 2.09488193853     , 1.55671086683     ,
 1.20269832701     , 0.972358134983    , 0.805858966434    , 0.674943093907    ,
 0.582901574877    , 0.536361098727    , 0.521811213599    , 0.510107150879    ,
 0.478473693527    , 0.426239806741    , 0.371749051997    , 0.334460061111    ,
 0.31795434204     , 0.308591415663    , 0.289032586676    , 0.252438256408    ,
 0.206631648247    , 0.168918002379    , 0.156823093622    , 0.178518795739    ,
 0.226406267674    , 0.278733944176    , 0.311821687839    , 0.316547579175    ,
 0.304603041204    , 0.295281110741    , 0.293592113589    , 0.28469180852     ,
 0.253503447286    , 0.206128080279    , 0.167180318628    , 0.159058577397    ,
 0.187116617069    , 0.239976704889    , 0.29771553402     , 0.340254945408    ,
 0.354089703804    , 0.338200907143    , 0.307298153056    , 0.287796940127    ,
 0.306374559446    , 0.377620754299    , 0.498057618054    , 0.649322532626    ,
 0.807093648087    , 0.948480177107    , 1.05520826533     , 1.11969203787     ,
 1.15856536433     , 1.21973974822     , 1.36099992243     , 1.60346132221     ,
 1.90273703682     , 2.17735260528     , 2.36876657571     , 2.46522648712     ,
 2.47635686647     , 2.41523547443     , 2.31835200146     , 2.26294533559     ,
 2.34336815549     , 2.62357815083     , 3.09445629099     , 3.64544300276     ,
 4.07829642305     , 4.19803893153     , 3.93874967412     , 3.41096383416     ,
 2.81981735323     , 2.32906519524     , 1.98117162303     , 1.71654188918     ,
 1.45403802318     , 1.15904931093     , 0.853427210105    , 0.582259972395    ,
 0.378513408782    , 0.247009271299    , 0.168743526898    , 0.118348907234    ,
 0.0803567210131   , 0.0521827977818   , 0.0362608696177   , 0.0321798612887   ,
 0.0346170472164   , 0.0361696175468   , 0.0321073976965   , 0.0230892908919   ,
 0.0132530215508   , 0.00604499708507  , 0.00219075141728  , 0.000638046104414 ,
 0.000174538919676 , 0.000136850158255 , 0.000375251131259 , 0.00104305430116  ,
 0.00234415678097  , 0.00416516572317  , 0.00582231001561  , 0.00638879776132  ,
 0.00549488905332  , 0.00369997032954  , 0.00194852389016  , 0.000801902843938 ,
 0.000257721684956 , 6.46491985208e-05 , 1.2658041986e-05  , 1.9716665155e-06  ,
 4.88148351623e-07 , 1.37148222429e-06 , 5.58032043369e-06 , 1.81470409071e-05 ,
 4.65070240555e-05 , 9.40317524263e-05 , 0.000150183336617 , 0.000189665223336 ,
 0.000189509464535 , 0.000149835726528 , 9.37155290535e-05 , 4.63375253948e-05 ,
 1.80989350854e-05 , 5.58582029602e-06 , 1.37253387707e-06 , 2.89182867124e-07 ,
 1.22058231952e-07 , 3.53331781738e-07 , 1.36534934043e-06 , 4.29451583141e-06 ,
 1.06279775664e-05 , 2.06597616577e-05 , 3.16675141182e-05 , 3.91381544842e-05 ,
 4.47991855995e-05 , 7.78883120054e-05 , 0.000252177770961 , 0.000897634558706 ,
 0.00276013272303  , 0.00710986860365  , 0.0154305078097   , 0.0283852154577   ,
 0.0442611122632   , 0.0583517916588   , 0.0655882146896   , 0.0661221604187   ,
 0.0684514766178   , 0.0848736805394   , 0.122073564244    , 0.176029015003    ,
 0.237894224904    , 0.309359773257    , 0.41782288405     , 0.617728172391    ,
 0.970590250038    , 1.51443510518     , 2.2476941046      , 3.13969424207     ,
 4.15009559827     , 5.23336079045     , 6.32972990936     , 7.36522818556     ,
 8.27372628494     , 9.02462937586     , 13.3992901342     , 14.0059237874     ,
 14.3416195549     , 14.3158357724     , 13.8664919842     , 13.0707787339     ,
 12.1377055968     , 11.2518572537     , 10.4406414839     , 9.60524787442     ,
 8.64617125105     , 7.53909739347     , 6.32507412495     , 5.07761271626     ,
 3.88957088723     , 2.85844214438     , 2.052251586       , 1.4838159668      ,
 1.1165978028      , 0.890130305028    , 0.748503512229    , 0.661151731661    ,
 0.621214956524    , 0.623366990716    , 0.648409294801    , 0.671219715073    ,
 0.677354502157    , 0.668729698498    , 0.656776365632    , 0.650734624926    ,
 0.64796827011     , 0.633808182625    , 0.593406888439    , 0.525682939067    ,
 0.446808779354    , 0.381961648806    , 0.352667567874    , 0.365777509695    ,
 0.407897138742    , 0.45007746602     , 0.464217001086    , 0.441606092443    ,
 0.397275796457    , 0.354241872626    , 0.322463440439    , 0.294636531917    ,
 0.262105632722    , 0.23027952008     , 0.215953870391    , 0.232706491566    ,
 0.280246393997    , 0.343705714088    , 0.400786070002    , 0.432515611263    ,
 0.431922326641    , 0.407781263272    , 0.384037499098    , 0.393868506848    ,
 0.467643525509    , 0.619441688228    , 0.839377860969    , 1.09561932253     ,
 1.34505202955     , 1.54754723834     , 1.67900553809     , 1.74490237884     ,
 1.79461972331     , 1.91911949309     , 2.20822441022     , 2.67790707733     ,
 3.23117067755     , 3.7115835168      , 4.00979936316     , 4.11059297021     ,
 4.04940159729     , 3.86849012583     , 3.63262707248     , 3.45123097663     ,
 3.45007303773     , 3.71449587503     , 4.23974762944     , 4.89420748208     ,
 5.42954106223     , 5.59126787342     , 5.28301575663     , 4.63360049473     ,
 3.89372143041     , 3.26305793649     , 2.7933278703      , 2.41466890531     ,
 2.03284698536     , 1.61130887697     , 1.18384225821     , 0.811652960644    ,
 0.536248174055    , 0.360009100669    , 0.254976959332    , 0.186525377074    ,
 0.133609454427    , 0.0921539616152   , 0.0649531465252   , 0.0517898352536   ,
 0.0470694183705   , 0.0431378431026   , 0.0352318544767   , 0.0239810957245   ,
 0.0132189641296   , 0.00584151404831  , 0.00207816628321  , 0.000632295278276 ,
 0.000258486128663 , 0.000387108995245 , 0.00111302262222  , 0.00302694956688  ,
 0.00674724271392  , 0.011952269225    , 0.0166816575664   , 0.0182855574116   ,
 0.0157144529473   , 0.0105745319905   , 0.00556605768348  , 0.00228976705532  ,
 0.000735693798057 , 0.000184532328969 , 3.61621424437e-05 , 5.71711281246e-06 ,
 1.79454229134e-06 , 5.89905222882e-06 , 2.40901242778e-05 , 7.84115736707e-05 ,
 0.000201212306907 , 0.000407458448466 , 0.000651943563888 , 0.000825027962737 ,
 0.000826282571755 , 0.000655044992982 , 0.000410958417015 , 0.000203935778059 ,
 8.0033904024e-05  , 2.49107468208e-05 , 6.28091065565e-06 , 1.47178335484e-06 ,
 7.4809092561e-07  , 1.98782058435e-06 , 7.42067901478e-06 , 2.32177971293e-05 ,
 5.7406756362e-05  , 0.000111541409686 , 0.000170665407767 , 0.00020825379431  ,
 0.000219073949166 , 0.000284601420889 , 0.000708378483849 , 0.0022939616764   ,
 0.00670057030417  , 0.0164645104329   , 0.0341139313684   , 0.0602098399639   ,
 0.090999885516    , 0.11784173978     , 0.131748145304    , 0.132690972107    ,
 0.134822860775    , 0.158744656387    , 0.216343575914    , 0.304362461436    ,
 0.414747945411    , 0.554764543449    , 0.763590319378    , 1.11179165292     ,
 1.67358547362     , 2.48299048881     , 3.51355057496     , 4.70705476762     ,
 6.01739447921     , 7.41488450969     , 8.85251399905     , 10.2473707992     ,
 11.5058051933     , 12.5636263368     , 18.1104468453     , 18.7072735086     ,
 18.8437227846     , 18.4509338887     , 17.5269909153     , 16.2206002145     ,
 14.7862400202     , 13.4142158338     , 12.1230668196     , 10.823237955      ,
 9.44621197762     , 7.99885366545     , 6.53692264748     , 5.13324481857     ,
 3.86961384306     , 2.82156781634     , 2.02858155574     , 1.48203305273     ,
 1.13965597017     , 0.945356224317    , 0.847495129769    , 0.815766288773    ,
 0.841361523514    , 0.91716543426     , 1.02397268044     , 1.13895214982     ,
 1.24804520943     , 1.34400583063     , 1.41955506253     , 1.4673520333      ,
 1.48016382724     , 1.44831200578     , 1.36449637615     , 1.23533986611     ,
 1.08504153232     , 0.945840300701    , 0.843601579567    , 0.786512808159    ,
 0.761286841891    , 0.740461263501    , 0.699145433478    , 0.630693656638    ,
 0.548512830107    , 0.47210730706     , 0.411414339911    , 0.365034064812    ,
 0.330764008836    , 0.313430695461    , 0.322215870435    , 0.362989570403    ,
 0.431897432965    , 0.512381611709    , 0.579509403367    , 0.612330830914    ,
 0.605888856817    , 0.575838703312    , 0.556443563401    , 0.59257251594     ,
 0.725048553499    , 0.973589095364    , 1.32431715532     , 1.72753782613     ,
 2.11097520635     , 2.40737323274     , 2.58426677318     , 2.6658387418      ,
 2.74406179411     , 2.96415999349     , 3.45901310266     , 4.24482341555     ,
 5.163974822       , 5.96370249625     , 6.46089641542     , 6.62544701696     ,
 6.52081132374     , 6.22624169391     , 5.84013869952     , 5.50438357721     ,
 5.37260199777     , 5.54746271318     , 6.03045498304     , 6.68375940913     ,
 7.23435187202     , 7.38688729835     , 7.00898410239     , 6.22163481571     ,
 5.29706038819     , 4.46688864825     , 3.8071441715      , 3.2576470232      ,
 2.72183285119     , 2.15841516022     , 1.60297026054     , 1.12388816453     ,
 0.767261677443    , 0.533576145221    , 0.38907006623     , 0.293051898576    ,
 0.219820562758    , 0.162184490442    , 0.121083843549    , 0.0956123571433   ,
 0.0801956060691   , 0.0670748432281   , 0.0512094486981   , 0.0333843758371   ,
 0.0179217704047   , 0.00782518559049  , 0.00284360569051  , 0.00102140068643  ,
 0.000658505721451 , 0.00108015366472  , 0.00272691390599  , 0.00701413681974  ,
 0.0153788591702   , 0.0271051399648   , 0.0377551656198   , 0.0413396161978   ,
 0.0354995136205   , 0.0238741862785   , 0.0125608875352   , 0.00516571603601  ,
 0.00165959320003  , 0.000416549664772 , 8.20286472763e-05 , 1.35269799643e-05 ,
 5.68243880848e-06 , 2.03079414265e-05 , 8.26423353869e-05 , 0.000269292713422 ,
 0.000692687244683 , 0.00140680739669  , 0.00225853591672  , 0.00286915982115  ,
 0.00288604375264  , 0.00229922088291  , 0.00145059255948  , 0.000724654200077 ,
 0.000286968124885 , 9.09351370293e-05 , 2.43174777585e-05 , 6.98636465419e-06 ,
 4.27654578323e-06 , 9.26843936569e-06 , 3.20885251031e-05 , 9.92014285197e-05 ,
 0.000244763890609 , 0.00047522525837  , 0.000726273966235 , 0.000880485000717 ,
 0.000886139725153 , 0.000940149165128 , 0.00174865229378  , 0.0049833316209   ,
 0.0137605975358   , 0.0323081392581   , 0.0640288761228   , 0.108453474768    ,
 0.158680935625    , 0.201640539229    , 0.224767844229    , 0.228871972349    ,
 0.235404709402    , 0.275251073562    , 0.367423685922    , 0.511920426874    ,
 0.705550145301    , 0.9655915091      , 1.34469340026     , 1.9277844931      ,
 2.79940122673     , 3.98773291773     , 5.4371043992      , 7.05241217045     ,
 8.76938299346     , 10.5631805764     , 12.3939159745     , 14.1713396914     ,
 15.7791646822     , 17.1161205835     , 23.5747779659     , 23.918094586      ,
 23.530916529      , 22.4183192061     , 20.7166660316     , 18.696260523      ,
 16.6515664017     , 14.7429674276     , 12.9587857384     , 11.2265236701     ,
 9.52385437949     , 7.88536318342     , 6.35566804537     , 4.97279261879     ,
 3.78000134113     , 2.81850112875     , 2.10284861898     , 1.61572968739     ,
 1.32163627391     , 1.17711912536     , 1.14139142678     , 1.19248328989     ,
 1.32843877668     , 1.54607189344     , 1.82571724857     , 2.14017434609     ,
 2.46511824278     , 2.77208178796     , 3.02448637934     , 3.19186007565     ,
 3.25962341226     , 3.2219477072      , 3.07875764732     , 2.84463555783     ,
 2.55158967424     , 2.23945606581     , 1.94363713206     , 1.68537605712     ,
 1.46792949665     , 1.28250053337     , 1.11884118035     , 0.971773266848    ,
 0.841321656628    , 0.72898925892     , 0.635261527631    , 0.561902388654    ,
 0.514619522928    , 0.500431516073    , 0.523372249295    , 0.583866361637    ,
 0.677402424918    , 0.788545690675    , 0.889695662021    , 0.952930506608    ,
 0.96643501327     , 0.944111426474    , 0.926796236175    , 0.974636484726    ,
 1.14917736828     , 1.48913608544     , 1.98666076335     , 2.57463792909     ,
 3.14268009361     , 3.58589142708     , 3.85875091405     , 4.00440823243     ,
 4.15755426047     , 4.51826486189     , 5.2693288824      , 6.44115052434     ,
 7.82762112293     , 9.0771194335      , 9.91085491496     , 10.2540351783     ,
 10.1805723856     , 9.81002407364     , 9.28740693746     , 8.79345782925     ,
 8.50529258294     , 8.53477863743     , 8.88636406729     , 9.4235904546      ,
 9.86679356685     , 9.8974349108      , 9.35149654766     , 8.3345675308      ,
 7.13470425717     , 6.01897135827     , 5.09501686189     , 4.31692955089     ,
 3.58632710063     , 2.85440929087     , 2.15324044091     , 1.55198174616     ,
 1.096432541       , 0.784769553978    , 0.581684040958    , 0.445303147288    ,
 0.346023316964    , 0.269713410149    , 0.21111583705     , 0.167470188275    ,
 0.134855017876    , 0.107007268377    , 0.0787547987307   , 0.0505751810849   ,
 0.0272459543829   , 0.0121938620332   , 0.00480691505331  , 0.00223212956585  ,
 0.00192264825654  , 0.00280687120752  , 0.00567479127184  , 0.0131183600601   ,
 0.0278183177066   , 0.0485658695498   , 0.0674427031303   , 0.0737496579521   ,
 0.0632830708924   , 0.0425378096446   , 0.0223738052578   , 0.00920153870479  ,
 0.00295875100985  , 0.000746002345784 , 0.000150693027786 , 2.89360694667e-05 ,
 1.70957170029e-05 , 5.71699304288e-05 , 0.000226963256148 , 0.000739670393617 ,
 0.00191057952343  , 0.00390096036545  , 0.00630114320389  , 0.00806010172577  ,
 0.00817024873239  , 0.0065652224417   , 0.0041824654225   , 0.00211359567572  ,
 0.000850846566591 , 0.000279607313934 , 8.4315686544e-05  , 3.28433962252e-05 ,
 2.32530323564e-05 , 3.74077579887e-05 , 0.000111828896222 , 0.000336613538145 ,
 0.000826436138691 , 0.00160192221013  , 0.00244495828842  , 0.00295294588308  ,
 0.00290375495977  , 0.00271762595057  , 0.00385118873335  , 0.0093066821984   ,
 0.0240265870912   , 0.0538630936456   , 0.102285068071    , 0.16654971511     ,
 0.236091050274    , 0.294719674418    , 0.32915697822     , 0.343870181899    ,
 0.369101357268    , 0.446560487507    , 0.603577149499    , 0.846318109198    ,
 1.18025949313     , 1.63494768974     , 2.27523928889     , 3.19670575907     ,
 4.49193074497     , 6.18441367142     , 8.18908125787     , 10.363502989      ,
 12.6014029152     , 14.8562523085     , 17.084102073      , 19.1979420398     ,
 21.0765455655     , 22.5836448237     , 29.2988177203     , 29.0918495901     ,
 27.8650007304     , 25.7521472103     , 23.0709824979     , 20.2216411367     ,
 17.5217620257     , 15.0868048889     , 12.8728129402     , 10.8242043859     ,
 8.95379439816     , 7.30211037076     , 5.8786186837      , 4.66696730946     ,
 3.66030035092     , 2.86461839065     , 2.2779029799      , 1.88460994819     ,
 1.66374848052     , 1.59225921529     , 1.6515271563      , 1.83976087457     ,
 2.16778877432     , 2.63430939358     , 3.2122455001      , 3.86214350685     ,
 4.54365603303     , 5.20520120253     , 5.78066117437     , 6.21058588444     ,
 6.45614274577     , 6.49292375239     , 6.31235429913     , 5.93209070464     ,
 5.39275099367     , 4.74754109456     , 4.05800771566     , 3.38601431987     ,
 2.7813902508      , 2.27766806233     , 1.89013317549     , 1.6091331772      ,
 1.4022913089      , 1.23327134383     , 1.082811576       , 0.955764684898    ,
 0.870390619898    , 0.839935832331    , 0.86444110644     , 0.938724273305    ,
 1.05932755017     , 1.21566975223     , 1.37939995779     , 1.51195410629     ,
 1.58507911281     , 1.59895509248     , 1.59256022852     , 1.64157963752     ,
 1.83822939233     , 2.25569069484     , 2.90548303523     , 3.70784193917     ,
 4.51074575694     , 5.16638497345     , 5.61335349011     , 5.90954070464     ,
 6.22201612587     , 6.79393272488     , 7.85626005476     , 9.46880161619     ,
 11.4031215599     , 13.2260423027     , 14.5516795323     , 15.2250068471     ,
 15.3009915277     , 14.9383240339     , 14.344596612      , 13.7469127661     ,
 13.3363114882     , 13.2174077015     , 13.3854958028     , 13.7024114363     ,
 13.8886230718     , 13.6161027285     , 12.7051065194     , 11.2633794985     ,
 9.61482181838     , 8.07759164827     , 6.79283489537     , 5.7181687847      ,
 4.74036328259     , 3.79493852135     , 2.90671648378     , 2.14344600574     ,
 1.54967873487     , 1.12350984655     , 0.83338291858     , 0.640248619996    ,
 0.508846033689    , 0.411543849988    , 0.331009708432    , 0.261433573528    ,
 0.203168380861    , 0.154350845796    , 0.110473196132    , 0.0706323425468   ,
 0.0387552841142   , 0.018206352655    , 0.00816263301009  , 0.0050081717134   ,
 0.00514098849598  , 0.00667183445751  , 0.0104415412165   , 0.0202279634616   ,
 0.0401657651114   , 0.0688045472312   , 0.0950324924576   , 0.103733149965    ,
 0.0889459199767   , 0.0597737595352   , 0.031449643705    , 0.0129540640216   ,
 0.00418873758087  , 0.0010821592406   , 0.000247031114795 , 7.50289593108e-05 ,
 5.84318642438e-05 , 0.000139825583391 , 0.000506895207132 , 0.00164156598737  ,
 0.00426805263711  , 0.00879454891965  , 0.0143551394896   , 0.0185765980773   ,
 0.0190713573716   , 0.0155392620405   , 0.0100531177888   , 0.00517402186829  ,
 0.00214140665996  , 0.000753025534887 , 0.000277826497694 , 0.000150295365997 ,
 0.000116109818282 , 0.000137420419981 , 0.000322100765475 , 0.000915996619442 ,
 0.0022229525593   , 0.00429130668965  , 0.00653306772976  , 0.00786550436133  ,
 0.00763696637718  , 0.0066527562549   , 0.00761188981903  , 0.015252501453    ,
 0.0362249971823   , 0.077173513554    , 0.140403614021    , 0.220196949978    ,
 0.303298527901    , 0.373763886545    , 0.422827291347    , 0.463446931535    ,
 0.53659723313     , 0.69422548871     , 0.971931554237    , 1.38356555119     ,
 1.94327249438     , 2.68892988757     , 3.69150100566     , 5.05189163452     ,
 6.86793434769     , 9.15954918798     , 11.8148584915     , 14.6376262952     ,
 17.455923091      , 20.1730411509     , 22.73263817       , 25.0671480636     ,
 27.0663916332     , 28.5544539609     , 34.4448718643     , 33.385029556      ,
 31.1054057054     , 27.9037343251     , 24.2599608462     , 20.6542622672     ,
 17.3919903229     , 14.5420434325     , 12.0387860292     , 9.83723348205     ,
 7.96085719058     , 6.43378394354     , 5.22277975214     , 4.26019407742     ,
 3.49567138267     , 2.90857225429     , 2.48877525102     , 2.22622977675     ,
 2.11417779675     , 2.15349025464     , 2.35856720017     , 2.75810649296     ,
 3.3760891819      , 4.2041245364      , 5.19726536717     , 6.29877705925     ,
 7.45789349875     , 8.61796216666     , 9.7023785907      , 10.6190431999     ,
 11.267244101      , 11.5520210004     , 11.4200563559     , 10.8799234477     ,
 9.98274105269     , 8.80836915271     , 7.47503047308     , 6.1280695225      ,
 4.90279335865     , 3.89870258235     , 3.16291691996     , 2.67140424292     ,
 2.33884788879     , 2.07195364073     , 1.82381496692     , 1.60482296317     ,
 1.45089386033     , 1.38321465862     , 1.39540405024     , 1.47380243079     ,
 1.61676953291     , 1.8229552478      , 2.06757378205     , 2.30201563988     ,
 2.47644638733     , 2.56713638095     , 2.60106281758     , 2.66601136692     ,
 2.89001501719     , 3.39014271385     , 4.20534472268     , 5.2478353441      ,
 6.32773908172     , 7.26047368208     , 7.97452753049     , 8.53946463796     ,
 9.13911023508     , 10.0395909275     , 11.5082826077     , 13.6388698855     ,
 16.2003488589     , 18.6998503507     , 20.6496418974     , 21.8000576139     ,
 22.1718000006     , 21.9617691327     , 21.4448008562     , 20.885625538      ,
 20.4629320178     , 20.2434086576     , 20.1929024499     , 20.167864143      ,
 19.9003494461     , 19.0741183487     , 17.5194971709     , 15.3739208854     ,
 13.0237065185     , 10.8579603607     , 9.05899550258     , 7.58282559825     ,
 6.28660546941     , 5.07099433873     , 3.9377400157      , 2.9478126826      ,
 2.15015502141     , 1.55322112091     , 1.13709944478     , 0.866746405103    ,
 0.695945289048    , 0.575653188256    , 0.470465222985    , 0.369507195271    ,
 0.278717869308    , 0.203288644542    , 0.141129594556    , 0.0896219072254   ,
 0.0502552720142   , 0.025174204471    , 0.0132245442334   , 0.0103012410092   ,
 0.0116494941849   , 0.0139723225181   , 0.0174662516276   , 0.0266121226434   ,
 0.0468789858577   , 0.0773002564937   , 0.105654098083    , 0.115003757726    ,
 0.0985651067521   , 0.0663018415404   , 0.0349959700306   , 0.0145438756925   ,
 0.004841137003    , 0.0014044870336   , 0.000486443047876 , 0.000287347084054 ,
 0.000241538993025 , 0.00033928420177  , 0.000955302310558 , 0.00299532691804  ,
 0.00784977396048  , 0.0164099951129   , 0.0272292748973   , 0.0358668109642   ,
 0.0375221578076   , 0.031188711124    , 0.0206165993585   , 0.0108868342605   ,
 0.00470098631003  , 0.0018453154901   , 0.000884439639288 , 0.000621458684171 ,
 0.000502408212271 , 0.000470943047576 , 0.00080122812073  , 0.00204101879289  ,
 0.00482457285158  , 0.00922036693509  , 0.0139525471463   , 0.0167185689831   ,
 0.0160998542456   , 0.0134981450603   , 0.013415289887    , 0.0225845689711   ,
 0.0487760304406   , 0.0981319013064   , 0.170831822606    , 0.258763482079    ,
 0.348459469208    , 0.428388368857    , 0.500062840595    , 0.591040535536    ,
 0.756670408493    , 1.05938863159     , 1.54222778277     , 2.22526090543     ,
 3.12568252384     , 4.2791168464      , 5.75196611391     , 7.64244438926     ,
 10.0463161972     , 12.9750799842     , 16.291509339      , 19.7464377774     ,
 23.0910388089     , 26.1616336328     , 28.8870044571     , 31.2309433329     ,
 33.0994357499     , 34.2726811784     , 38.0793751533     , 35.9025073771     ,
 32.5101767041     , 28.3529749304     , 23.9930733002     , 19.901359134      ,
 16.3241059217     , 13.281808463      , 10.6953601222     , 8.52147749444     ,
 6.77438529419     , 5.45261551257     , 4.48959999175     , 3.78488876012     ,
 3.26194746435     , 2.88630451929     , 2.64675683235     , 2.53877194065     ,
 2.56623743798     , 2.75370533247     , 3.15285355181     , 3.82426484051     ,
 4.79813887902     , 6.04819583552     , 7.50539796349     , 9.09940355606     ,
 10.7870695282     , 12.5395961117     , 14.2998137427     , 15.9384332537     ,
 17.2444759727     , 17.9901144825     , 18.0366244726     , 17.3700117041     ,
 16.0530502105     , 14.2060484178     , 12.0352675203     , 9.81038402507     ,
 7.7843272268      , 6.13633605075     , 4.94454132533     , 4.16274702311     ,
 3.64344768584     , 3.23002798683     , 2.84662495498     , 2.51013655315     ,
 2.27234241312     , 2.15654163018     , 2.14396441909     , 2.21084724576     ,
 2.36051679987     , 2.60594578192     , 2.93099257035     , 3.28155013462     ,
 3.58803456115     , 3.7992340063      , 3.92309776598     , 4.05428518274     ,
 4.35441948173     , 4.98172036006     , 5.99846214538     , 7.30887789731     ,
 8.69644316874     , 9.96192673625     , 11.0445148613     , 12.0287344128     ,
 13.0974705428     , 14.5141808809     , 16.5629342949     , 19.3611611746     ,
 22.6744220484     , 25.9596601429     , 28.6455836723     , 30.40871614       ,
 31.2499691489     , 31.4033107275     , 31.1896053799     , 30.8738255497     ,
 30.5782320405     , 30.29344069       , 29.9381368228     , 29.374588279      ,
 28.3797882641     , 26.6870754378     , 24.165266235      , 20.9977120536     ,
 17.6423609524     , 14.5705925649     , 12.0244951304     , 9.97598519086     ,
 8.25219177154     , 6.69512499476     , 5.2524061567      , 3.96291103244     ,
 2.88691636566     , 2.05873071532     , 1.47816615329     , 1.11151508288     ,
 0.894609018661    , 0.751191787948    , 0.62357183283     , 0.492095040481    ,
 0.366146223919    , 0.259026338314    , 0.174116024349    , 0.109015693663    ,
 0.0623265061098   , 0.0335615254178   , 0.0204832961319   , 0.0184973785381   ,
 0.0216453008402   , 0.0246842084219   , 0.0263539394274   , 0.0310778314368   ,
 0.0452890771199   , 0.0693773096926   , 0.0928799940739   , 0.100660030222    ,
 0.086408042433    , 0.0585197531328   , 0.0314135293891   , 0.0136349423685   ,
 0.0051643109855   , 0.00219362495908  , 0.00144145529196  , 0.00123151795529  ,
 0.00102409577801  , 0.0009379672328   , 0.00164924280623  , 0.00462837511459  ,
 0.0121565105928   , 0.0259164984491   , 0.043988992548    , 0.0593263957108   ,
 0.0635742674826   , 0.0541493346685   , 0.0367223467027   , 0.0200088658306   ,
 0.00915606638172  , 0.00418026389492  , 0.00260759136681  , 0.00217148669957  ,
 0.00179937754565  , 0.00147082341509  , 0.00182186558584  , 0.00388325794039  ,
 0.00869078564527  , 0.0162222940868   , 0.0241946258801   , 0.0287046736156   ,
 0.0274235348163   , 0.0225970659141   , 0.0209431281392   , 0.031304009344    ,
 0.0620978366033   , 0.118261737937    , 0.197906825329    , 0.291951143847    ,
 0.388900721274    , 0.484179573733    , 0.593857251722    , 0.767107300501    ,
 1.08108750957     , 1.61286902938     , 2.4122612521      , 3.50013300762     ,
 4.88675491208     , 6.5932155926      , 8.66974259734     , 11.1991539555     ,
 14.2577800874     , 17.8316659554     , 21.7514535223     , 25.7172473046     ,
 29.4038519885     , 32.5782593289     , 35.1570305784     , 37.1421938314     ,
 38.4631162488     , 38.8800133098     , 39.6362035966     , 36.1536907176     ,
 31.7255630018     , 26.8935415177     , 22.1909005617     , 17.9860938255     ,
 14.4237054988     , 11.4689061611     , 9.02861378342     , 7.05444851597     ,
 5.54446425572     , 4.47417438535     , 3.75753444006     , 3.28104602133     ,
 2.96084500239     , 2.76203942098     , 2.67893028545     , 2.71361018813     ,
 2.8789630161      , 3.22013361638     , 3.81970871718     , 4.75895722419     ,
 6.06237526147     , 7.68154762383     , 9.5315328562      , 11.5464122001     ,
 13.7136798803     , 16.0553996593     , 18.5460279016     , 21.0086367267     ,
 23.093933124      , 24.4166457546     , 24.7432983206     , 24.0352531286     ,
 22.3626932844     , 19.8827730875     , 16.8934592176     , 13.7982319741     ,
 10.9736719192     , 8.67445470453     , 7.00032794669     , 5.8821443153      ,
 5.12411850134     , 4.52603263969     , 3.99509229734     , 3.55253145425     ,
 3.25201700592     , 3.10224324698     , 3.06336818131     , 3.10439991609     ,
 3.24162824314     , 3.50824306553     , 3.90055472743     , 4.36433941204     ,
 4.81729948503     , 5.18588632907     , 5.4598651428      , 5.73679594539     ,
 6.20179143828     , 7.03779758993     , 8.31427663555     , 9.92492077118     ,
 11.6479913161     , 13.3096971929     , 14.8943493629     , 16.504949783      ,
 18.2957916272     , 20.4935024605     , 23.3780718549     , 27.0803027627     ,
 31.3534179366     , 35.6025821887     , 39.1910505538     , 41.7552907486     ,
 43.3000690337     , 44.0844511543     , 44.4285659521     , 44.5404674131     ,
 44.4405021464     , 44.0187915987     , 43.1501971797     , 41.7369433971     ,
 39.6518377272     , 36.719933596      , 32.8683677833     , 28.32840018       ,
 23.6255377611     , 19.3170516995     , 15.7245806277     , 12.8633112982     ,
 10.5446491741     , 8.54116216458     , 6.71962980648     , 5.0757091258      ,
 3.67712923413     , 2.58883300884     , 1.82988131706     , 1.36110496898     ,
 1.0957183083      , 0.930762559665    , 0.786603398077    , 0.630986875224    ,
 0.471844578944    , 0.329660615954    , 0.216572620529    , 0.133900024888    ,
 0.0781801182389   , 0.0451187575858   , 0.0302833295468   , 0.0284059795231   ,
 0.0325834380612   , 0.0356717413089   , 0.0345669605118   , 0.0329292085669   ,
 0.0375592348284   , 0.0505515371767   , 0.065067206657    , 0.0702183743371   ,
 0.0610611696482   , 0.0427794206145   , 0.0247702431017   , 0.0127406247537   ,
 0.00695391042313  , 0.00511156295935  , 0.00485659177933  , 0.00461410030505  ,
 0.00380640640259  , 0.00284356099232  , 0.00296389354808  , 0.00635235915385  ,
 0.0162597142776   , 0.0353786839291   , 0.0616414548446   , 0.0853487898062   ,
 0.0938234573632   , 0.0819192597614   , 0.0569918748177   , 0.0321165781983   ,
 0.0157991972598   , 0.00861031653873  , 0.00669549811438  , 0.00617042300968  ,
 0.00519395365802  , 0.00398253820708  , 0.00392503219339  , 0.00674256859989  ,
 0.0137296283986   , 0.0244143489632   , 0.0352778828573   , 0.0409912481302   ,
 0.0387640867675   , 0.0319993009407   , 0.029648787089    , 0.0427016069533   ,
 0.0807225983419   , 0.148532225608    , 0.243427453207    , 0.35588099966     ,
 0.475749441073    , 0.605241396613    , 0.778690317791    , 1.07643985671     ,
 1.60991173619     , 2.47896923053     , 3.73811975298     , 5.39830143694     ,
 7.45207090471     , 9.90054791082     , 12.7713752304     , 16.112855455      ,
 19.9482285252     , 24.2026115333     , 28.6520753408     , 32.9402045075     ,
 36.6702572484     , 39.5492937275     , 41.4933536764     , 42.5597414774     ,
 42.7363772928     , 41.8341067918     , 39.2170955001     , 34.35763692       ,
 29.051280208      , 23.8457350886     , 19.1511946182     , 15.1701929791     ,
 11.9185986922     , 9.29694254868     , 7.19227729574     , 5.54853907408     ,
 4.35047312602     , 3.55689215271     , 3.07119426671     , 2.77968675683     ,
 2.60600984826     , 2.52636722329     , 2.54617711026     , 2.67562142494     ,
 2.93487005046     , 3.38186924139     , 4.11442169253     , 5.21677402189     ,
 6.69932401347     , 8.50017260205     , 10.5424043211     , 12.7919656449     ,
 15.280875082      , 18.0720792994     , 21.1472438369     , 24.2704458017     ,
 26.9779233321     , 28.7777389842     , 29.3869956368     , 28.7584437352     ,
 26.9560392322     , 24.1398998622     , 20.6558616189     , 17.000498168      ,
 13.6437356485     , 10.891542175      , 8.8483261283      , 7.42773904301     ,
 6.4213283679      , 5.63124175077     , 4.97584026539     , 4.47989775852     ,
 4.17829312237     , 4.04241522173     , 4.0016302267      , 4.0226880025      ,
 4.14386008617     , 4.42303201938     , 4.87056462428     , 5.43661326603     ,
 6.03635128636     , 6.58767676461     , 7.07242414267     , 7.58890902688     ,
 8.32795466628     , 9.47102518763     , 11.0758330462     , 13.0309003771     ,
 15.1456440387     , 17.3231741864     , 19.6244437312     , 22.1571218244     ,
 24.9996396129     , 28.2995989496     , 32.3213558826     , 37.2203000866     ,
 42.7497767182     , 48.2684762277     , 53.0766913324     , 56.7714193011     ,
 59.3510719271     , 61.0680137712     , 62.1891644333     , 62.8107697335     ,
 62.8187334936     , 62.0074650345     , 60.247897653      , 57.5391571647     ,
 53.8977990999     , 49.2641011016     , 43.6312701698     , 37.28770874       ,
 30.8400241109     , 24.9409945831     , 19.9942703464     , 16.059889423      ,
 12.9419882886     , 10.3555739366     , 8.08799813945     , 6.07685397739     ,
 4.37530836281     , 3.05890690924     , 2.14981805456     , 1.59376284652     ,
 1.28235447481     , 1.09491408181     , 0.937398404795    , 0.765084807806    ,
 0.579935337028    , 0.406461537182    , 0.26594267156     , 0.165235694724    ,
 0.0996937391349   , 0.0609406171747   , 0.0420034346192   , 0.0372651356122   ,
 0.039803854024    , 0.0415466245265   , 0.03789726861     , 0.0312345633713   ,
 0.0278254875305   , 0.0309153356871   , 0.037329593073    , 0.0407623503627   ,
 0.037822062801    , 0.0303022869962   , 0.0222167181409   , 0.0163422545126   ,
 0.0135784459112   , 0.0134723643212   , 0.0143475243945   , 0.0140581083942   ,
 0.0116320113821   , 0.0081151464503   , 0.00593677950842  , 0.00828056033876  ,
 0.0191903460493   , 0.0421715519352   , 0.0752598631255   , 0.106733282837    ,
 0.119972919007    , 0.106960489584    , 0.0760645472457   , 0.044346792932    ,
 0.023763298407    , 0.0155686142567   , 0.0142960015105   , 0.0139954399392   ,
 0.0119202141614   , 0.00895198449954  , 0.00787149093816  , 0.0113438574645   ,
 0.0205207939814   , 0.0337786810635   , 0.0461868107244   , 0.0518360924865   ,
 0.0487127633542   , 0.0418281515634   , 0.0419067893057   , 0.0621136825353   ,
 0.115116567914    , 0.208968935301    , 0.342075060766    , 0.5026018144      ,
 0.678086547405    , 0.877934802216    , 1.16331910685     , 1.66044524807     ,
 2.52871602267     , 3.89471961741     , 5.80705068596     , 8.24936245219     ,
 11.1899106716     , 14.6188420103     , 18.5444635209     , 22.9533374135     ,
 27.7601992783     , 32.7708060601     , 37.6672008152     , 42.0239243231     ,
 45.3851481333     , 47.4256762678     , 48.0943334112     , 47.5491046637     ,
 45.9109880112     , 43.1425343337     , 37.4126342299     , 31.2646621023     ,
 25.2797726753     , 19.936524881      , 15.4804817174     , 11.9316492936     ,
 9.17006346148     , 7.02493387396     , 5.35761539413     , 4.10405401127     ,
 3.24102855149     , 2.71731880418     , 2.43218288312     , 2.27965213743     ,
 2.19962420256     , 2.18504386522     , 2.25295544156     , 2.4185872101      ,
 2.70304199418     , 3.16445521298     , 3.89820331638     , 4.97907485899     ,
 6.40650392557     , 8.12364626846     , 10.0864207966     , 12.3101984869     ,
 14.8651154328     , 17.8180675228     , 21.1167856733     , 24.4720399692     ,
 27.3819703052     , 29.3571577859     , 30.1450144649     , 29.7137521217     ,
 28.1012796059     , 25.4190632215     , 21.9850500782     , 18.3098345965     ,
 14.8964384704     , 12.0641334116     , 9.90380513815     , 8.32138554706     ,
 7.13545426726     , 6.20053329042     , 5.47906057771     , 5.00492808819     ,
 4.78205518571     , 4.73063781735     , 4.74372569252     , 4.78715548952     ,
 4.92163649274     , 5.22686911498     , 5.72607116019     , 6.37966561566     ,
 7.11544938291     , 7.86402453169     , 8.61461810834     , 9.46195733123     ,
 10.5790742948     , 12.1208405909     , 14.1273181013     , 16.505891156      ,
 19.1436656891     , 22.0617254656     , 25.401413696      , 29.2357987136     ,
 33.5131227896     , 38.2684083597     , 43.7546518345     , 50.1866487617     ,
 57.3593745666     , 64.6039033013     , 71.1338435811     , 76.4470448029     ,
 80.4715423272     , 83.4079849034     , 85.4350108818     , 86.4980086733     ,
 86.3253909324     , 84.6444558011     , 81.4000642167     , 76.7673674162     ,
 70.9458138563     , 63.9978938884     , 55.996131449      , 47.3243402395     ,
 38.7124963741     , 30.9199903233     , 24.4008480954     , 19.2136624598     ,
 15.138326625      , 11.8561639042     , 9.10517958437     , 6.76415135151     ,
 4.83979797713     , 3.37937634776     , 2.38139331528     , 1.76767120213     ,
 1.41488030901     , 1.19926886373     , 1.02581790085     , 0.843360458935    ,
 0.646243982501    , 0.45770834853     , 0.303416649043    , 0.193492498994    ,
 0.122133130085    , 0.0780358104946   , 0.0529600811284   , 0.0421118002117   ,
 0.0399269640811   , 0.0389114237064   , 0.03385452337     , 0.0255839614661   ,
 0.0188527594479   , 0.0169874372476   , 0.019372076146    , 0.0232732094971   ,
 0.0266113563051   , 0.0285740359448   , 0.028901108786    , 0.028224880043    ,
 0.0285313406786   , 0.0312263554141   , 0.0345164790007   , 0.0343710700646   ,
 0.0287090874129   , 0.0197489692281   , 0.0122448980499   , 0.0109496727797   ,
 0.0202639192093   , 0.0436522299424   , 0.0791142253382   , 0.114212411062    ,
 0.130478146806    , 0.118093283641    , 0.0854659648664   , 0.0516106877728   ,
 0.0305284224663   , 0.023869489772    , 0.0247095218501   , 0.0251139128177   ,
 0.0216113701653   , 0.0162816382646   , 0.0139492245691   , 0.0184536747011   ,
 0.0303121956225   , 0.0459407569867   , 0.058935645373    , 0.0641489635096   ,
 0.0621272161997   , 0.0598854788189   , 0.0687336299982   , 0.103705301516    ,
 0.183740626886    , 0.32566956355     , 0.531925648363    , 0.785808627601    ,
 1.07006346131     , 1.40872358236     , 1.908477473       , 2.76000041619     ,
 4.17543471025     , 6.29340690752     , 9.1286348501      , 12.6143900309     ,
 16.6960755214     , 21.375499464      , 26.6513091317     , 32.413432765      ,
 38.3954244783     , 44.2082677249     , 49.391035714      , 53.4401006089     ,
 55.8735218984     , 56.3953893242     , 55.0576275952     , 52.1983873642     ,
 48.169647898      , 43.1764328221     , 34.779855985      , 27.6078541619     ,
 21.2007609718     , 15.9083670759     , 11.814827696      , 8.78021509327     ,
 6.56315289139     , 4.92589713573     , 3.70418502069     , 2.82600061437     ,
 2.26329646189     , 1.96247387473     , 1.82860335444     , 1.77125233757     ,
 1.74899875179     , 1.76800481918     , 1.8495847731      , 2.00605031114     ,
 2.25115962336     , 2.63210191327     , 3.23026833949     , 4.10863019969     ,
 5.26718010192     , 6.67022843262     , 8.31342239086     , 10.2530362528     ,
 12.5732095116     , 15.3116265703     , 18.3651550206     , 21.4265410186     ,
 24.0484301566     , 25.8478507113     , 26.6648666965     , 26.4957745992     ,
 25.3373982997     , 23.2165315486     , 20.3591833021     , 17.2092837646     ,
 14.2340154951     , 11.7268998308     , 9.75575495466     , 8.23032376685     ,
 7.0188582612      , 6.05142086441     , 5.35042089988     , 4.96737452908     ,
 4.8825680312      , 4.97480026627     , 5.10808235965     , 5.24387742569     ,
 5.45070268938     , 5.81450287444     , 6.36657289542     , 7.08781458346     ,
 7.94064633606     , 8.89278577724     , 9.95236000192     , 11.1996619462     ,
 12.7683026956     , 14.7790086601     , 17.274702587      , 20.2222848321     ,
 23.622768421      , 27.6192620819     , 32.3987896407     , 37.9532727905     ,
 44.0747809763     , 50.685663826      , 58.0433099239     , 66.4510972561     ,
 75.7800825106     , 85.3411222703     , 94.2088955363     , 101.681916917     ,
 107.526322368     , 111.849134365     , 114.728447601     , 115.938267179     ,
 115.035629482     , 111.723924831     , 106.12402827      , 98.6857401304     ,
 89.8424477212     , 79.8072163787     , 68.7776818426     , 57.288980378      ,
 46.2212163244     , 36.4138661112     , 28.3008939261     , 21.8634203873     ,
 16.82049539       , 12.8353141331     , 9.63084701078     , 7.03782920254     ,
 4.9943838016      , 3.48585702574     , 2.46502842003     , 1.82623603539     ,
 1.44009214847     , 1.19310278271     , 1.0020660612      , 0.817856942255    ,
 0.628380186425    , 0.450023115349    , 0.305112575151    , 0.202194011684    ,
 0.133979693514    , 0.0885077930437   , 0.0584991087698   , 0.0412517071979   ,
 0.0335156324913   , 0.0295324348649   , 0.0244020361942   , 0.0175630556044   ,
 0.0117995338268   , 0.00972711432225  , 0.0120974382669   , 0.0184785336777   ,
 0.0277504329794   , 0.0374802158725   , 0.0445604837863   , 0.0483555917      ,
 0.0522209627469   , 0.0592829851433   , 0.0668039159507   , 0.0674553888551   ,
 0.0570963359701   , 0.0395226858036   , 0.0230995076225   , 0.0149639036839   ,
 0.0194203445913   , 0.038656706262    , 0.070127921346    , 0.102290602313    ,
 0.118045109779    , 0.107903366299    , 0.0792335180133   , 0.0497595674955   ,
 0.0329299835299   , 0.0302325691604   , 0.0340790820174   , 0.0355090409579   ,
 0.030893921874    , 0.0237212029286   , 0.0209022771399   , 0.027373359555    ,
 0.0427672491203   , 0.0613912893569   , 0.0760783900047   , 0.0843492258265   ,
 0.0911186621086   , 0.104855288207    , 0.13434538839     , 0.194500059409    ,
 0.314069324587    , 0.527249764975    , 0.848501170011    , 1.26070689719     ,
 1.74891394542     , 2.3698149756      , 3.30006411362     , 4.80663866474     ,
 7.13732625296     , 10.3998240069     , 14.5279791112     , 19.3793628036     ,
 24.8835393378     , 31.0775455539     , 37.9570219742     , 45.2813218033     ,
 52.534715557      , 59.0590894095     , 64.1989491987     , 67.3683798088     ,
 68.1183776843     , 66.291018017      , 62.1615780369     , 56.3568179468     ,
 49.5508048391     , 42.2356269134     , 31.4829114538     , 23.7043905105     ,
 17.2242819826     , 12.2030173045     , 8.57319502704     , 6.07342180477     ,
 4.37650661041     , 3.20128407956     , 2.36902357608     , 1.8016403223      ,
 1.46734073426     , 1.31803365099     , 1.27697669949     , 1.276753981       ,
 1.29181837727     , 1.33129117851     , 1.40989415153     , 1.53070911612     ,
 1.69780424626     , 1.94462789691     , 2.33513283496     , 2.92209759954     ,
 3.713735239       , 4.6983003617      , 5.8971734127      , 7.37937709244     ,
 9.21710797364     , 11.4123097994     , 13.834154668      , 16.2096832507     ,
 18.2092506347     , 19.5999229128     , 20.323525048      , 20.3969254314     ,
 19.7763426054     , 18.4077128806     , 16.4066094507     , 14.1024143838     ,
 11.8742621916     , 9.96353490242     , 8.41862011797     , 7.16457607844     ,
 6.1173237618      , 5.2668167833      , 4.68086496446     , 4.42917409708     ,
 4.48961507545     , 4.73315648549     , 5.01937413331     , 5.30370480463     ,
 5.63889950567     , 6.09268987306     , 6.69674071776     , 7.4641813981      ,
 8.41404009996     , 9.56885442117     , 10.9566697426     , 12.6301620197     ,
 14.6778383939     , 17.2085413442     , 20.3129999511     , 24.0569502686     ,
 28.5602122067     , 34.0507228756     , 40.7085077237     , 48.422132393      ,
 56.8521842346     , 65.8444599343     , 75.6683783869     , 86.6973440763     ,
 98.8531844933     , 111.388708475     , 123.171211881     , 133.209691272     ,
 141.033630001     , 146.622580731     , 149.950167248     , 150.625228348     ,
 148.060142883     , 142.008206174     , 132.879491887     , 121.506632102     ,
 108.639375503     , 94.7191970863     , 80.1421044496     , 65.6169291774     ,
 52.1188344128     , 40.4690586723     , 30.9909715346     , 23.5277397649     ,
 17.7066865393     , 13.1677406864     , 9.63153416049     , 6.89497857486     ,
 4.82972720607     , 3.35134716997     , 2.36135960716     , 1.72965377939     ,
 1.32810984385     , 1.06007004545     , 0.860043569159    , 0.686580081308    ,
 0.523623629956    , 0.377852993621    , 0.262650245826    , 0.181406732156    ,
 0.12567115654     , 0.085085948024    , 0.0549518086111   , 0.0349639491757   ,
 0.024066759205    , 0.0184955526295   , 0.014294186001    , 0.0101664746994   ,
 0.0073383862919   , 0.00760674760588  , 0.0122371106644   , 0.0219026716933   ,
 0.035995433249    , 0.0513628033386   , 0.0634822781921   , 0.0711467394469   ,
 0.0788825349638   , 0.0911906639328   , 0.104162309254    , 0.106666455584    ,
 0.0917419373044   , 0.0644464830174   , 0.0372132576103   , 0.0201587649649   ,
 0.0173818143024   , 0.0289729331065   , 0.051388404182    , 0.0751680073997   ,
 0.0872098799453   , 0.0802319316754   , 0.059732835864    , 0.0393039473182   ,
 0.029444712107    , 0.0310808047903   , 0.0372387367189   , 0.0395559922523   ,
 0.0349694684599   , 0.0278498176719   , 0.0261090619195   , 0.0351019314766   ,
 0.0538568246626   , 0.0759744983367   , 0.0960065566734   , 0.117065637341    ,
 0.149907721215    , 0.201972581612    , 0.273099916       , 0.372907858611    ,
 0.543288577495    , 0.850054196108    , 1.34109540727     , 2.02352600116     ,
 2.9119151872      , 4.1224407387      , 5.91589934117     , 8.61912767928     ,
 12.4606583083     , 17.4406369807     , 23.3489940134     , 29.9441479036     ,
 37.1507423496     , 45.0597175314     , 53.6681634689     , 62.5859413962     ,
 71.0019492631     , 77.9209611849     , 82.4318099032     , 83.8628990894     ,
 81.89145381       , 76.6711424751     , 68.8844760203     , 59.5751854568     ,
 49.7901426555     , 40.280459455      , 27.4275156143     , 19.5601340381     ,
 13.4328454948     , 8.95760401636     , 5.91383357028     , 3.9572799731      ,
 2.72492205202     , 1.93154121326     , 1.40469206223     , 1.06631594454     ,
 0.882732317911    , 0.816908783653    , 0.818049022302    , 0.84449869047     ,
 0.881156989185    , 0.930887756236    , 0.995847890191    , 1.07070471081     ,
 1.155079082       , 1.27302928172     , 1.4720129445      , 1.7936139949      ,
 2.2513839513      , 2.84790302378     , 3.6096649362      , 4.59298861211     ,
 5.84558589032     , 7.34944815774     , 8.98594135456     , 10.5553572878     ,
 11.8572025465     , 12.7865918919     , 13.3519954446     , 13.5737932254     ,
 13.385044461      , 12.6886825305     , 11.5154121688     , 10.0749168229     ,
 8.63714791957     , 7.38272910581     , 6.35127022774     , 5.49120876187     ,
 4.74992026334     , 4.13998525782     , 3.73838975699     , 3.6194518771      ,
 3.77663789915     , 4.11229351692     , 4.51545715256     , 4.94294530898     ,
 5.41601819878     , 5.96526159917     , 6.61512265233     , 7.41496174929     ,
 8.44751607957     , 9.79130812228     , 11.4881679437     , 13.5620154965     ,
 16.0780073203     , 19.1796381422     , 23.0527832123     , 27.8782721637     ,
 33.8684221889     , 41.2884490417     , 50.2843821664     , 60.6653433152     ,
 72.0202034203     , 84.1547276686     , 97.314924533      , 111.847519946     ,
 127.616426161     , 143.73105868      , 158.795057278     , 171.48969245      ,
 181.072030427     , 187.358172669     , 190.206778677     , 189.112000543     ,
 183.456552371     , 173.186317393     , 159.130277904     , 142.610007869     ,
 124.790284728     , 106.43389478      , 88.1751843196     , 70.8294317448     ,
 55.3132218891     , 42.2823826006     , 31.8777563968     , 23.7925704825     ,
 17.5548172706     , 12.7574264822     , 9.10286566659     , 6.36461780029     ,
 4.3716216332      , 2.9882429189      , 2.07575071117     , 1.48752953336     ,
 1.10142847562     , 0.837894138389    , 0.647992667281    , 0.49903943523     ,
 0.373717694194    , 0.270296873003    , 0.192647814935    , 0.138703358284    ,
 0.0998957067699   , 0.0687885344652   , 0.0435764541864   , 0.0256452575384   ,
 0.0151952178117   , 0.00996216644421  , 0.00715483943118  , 0.00556599311214  ,
 0.00579500915106  , 0.00916810261694  , 0.0168261026377   , 0.0293160294656   ,
 0.0458834036418   , 0.0634441107944   , 0.0776364474783   , 0.087387865089    ,
 0.0977305874975   , 0.113895287227    , 0.131428311038    , 0.136557212443    ,
 0.11957773109     , 0.0855770056486   , 0.0497791724141   , 0.0248982678035   ,
 0.0150735109252   , 0.0185138044179   , 0.0307431432609   , 0.0446867787513   ,
 0.0519408125921   , 0.0480069394182   , 0.0362926168421   , 0.0252815165085   ,
 0.0216116166387   , 0.0256602975316   , 0.032214325042    , 0.0349948428425   ,
 0.0319923832927   , 0.0273293904043   , 0.0279899113262   , 0.0385897449245   ,
 0.0583481751271   , 0.0831120552441   , 0.113394613421    , 0.161766391051    ,
 0.246137928206    , 0.369529520296    , 0.515059644834    , 0.680793174526    ,
 0.926795066575    , 1.37409591477     , 2.14723605549     , 3.33476157159     ,
 5.03743216522     , 7.46377542302     , 10.9441926398     , 15.7912296203     ,
 22.0906721307     , 29.6020529913     , 37.8833637734     , 46.5804634085     ,
 55.653856241      , 65.2973823042     , 75.5364526742     , 85.8246788381     ,
 95.0040720943     , 101.651943187     , 104.528655373     , 102.906783331     ,
 96.76360721       , 86.8327188614     , 74.4493900123     , 61.1902943507     ,
 48.4377803096     , 37.0682433941     , 22.6661582345     , 15.2523744872     ,
 9.88358182844     , 6.20234397447     , 3.84388961064     , 2.42075235504     ,
 1.58459240468     , 1.08508510009     , 0.776990649052    , 0.591247462586    ,
 0.496233429651    , 0.467476814035    , 0.478834035971    , 0.510248266738    ,
 0.55219522817     , 0.599199684554    , 0.643391561267    , 0.676819662517    ,
 0.70084184128     , 0.734667467938    , 0.811000555504    , 0.957666541905    ,
 1.18565610822     , 1.49998052237     , 1.91966313806     , 2.47985251547     ,
 3.20669041687     , 4.08110369088     , 5.02148582138     , 5.9074330513      ,
 6.63811500001     , 7.18396819964     , 7.57625973354     , 7.8280744248      ,
 7.87375297114     , 7.61791939925     , 7.04902663931     , 6.28109163543     ,
 5.4818730887      , 4.77530401375     , 4.19993740714     , 3.72998041075     ,
 3.32964414878     , 3.00279800971     , 2.8009664614      , 2.78250393579     ,
 2.96006859684     , 3.29022667049     , 3.71675607157     , 4.21221487229     ,
 4.7701001597      , 5.38299682283     , 6.06366537532     , 6.88732761194     ,
 7.9853485552      , 9.47900135173     , 11.4234194216     , 13.8362423565     ,
 16.8029895334     , 20.547483361      , 25.3723984856     , 31.5584785289     ,
 39.374456596      , 49.1063640573     , 60.9014810882     , 74.5658058608     ,
 89.681513619      , 106.005857461     , 123.649657228     , 142.749544573     ,
 162.931822325     , 183.051791001     , 201.424045946     , 216.424033941     ,
 227.043037199     , 232.905129953     , 233.754450554     , 229.084473605     ,
 218.469807744     , 202.277272653     , 181.907687675     , 159.256657856     ,
 135.962615931     , 113.132452119     , 91.5741073929     , 72.0460079825     ,
 55.2139200361     , 41.4416270289     , 30.6622677329     , 22.4488974359     ,
 16.2423618228     , 11.5611826289     , 8.06021436196     , 5.49315016486     ,
 3.67578726389     , 2.45201067481     , 1.66342549428     , 1.15807819493     ,
 0.823337275754    , 0.594511616115    , 0.43520503629     , 0.320188682069    ,
 0.233498845994    , 0.169152582354    , 0.124730292408    , 0.0945261271571   ,
 0.0707705816816   , 0.049199799653    , 0.030538329531    , 0.0170468835324   ,
 0.00918992173872  , 0.00540527318507  , 0.00387783875489  , 0.00403501743381  ,
 0.00667923882965  , 0.0130423931854   , 0.0236319355142   , 0.0377492180321   ,
 0.0537364150408   , 0.0691076605377   , 0.0811386483897   , 0.0897076667979   ,
 0.0996347500731   , 0.116018749093    , 0.134854928592    , 0.142197425949    ,
 0.12689700629     , 0.092643603335    , 0.0546896186909   , 0.0266270421978   ,
 0.0127609793022   , 0.0104634773479   , 0.014993685209    , 0.0213147754184   ,
 0.0247377935363   , 0.0229568389983   , 0.0176840661307   , 0.0132057159129   ,
 0.0129294673423   , 0.0169744554459   , 0.0223280080576   , 0.0254061557325   ,
 0.0253066595282   , 0.024822605183    , 0.0282478687605   , 0.03836647331     ,
 0.0554934842125   , 0.0808720536043   , 0.125172216814    , 0.21398556967     ,
 0.374356429161    , 0.605006251322    , 0.871272334612    , 1.16154268755     ,
 1.56820111222     , 2.30566167193     , 3.64442677759     , 5.84747910751     ,
 9.18811681851     , 13.999399668      , 20.6175478631     , 29.1698560285     ,
 39.3571408773     , 50.4681184104     , 61.7055541934     , 72.6293122003     ,
 83.3681621102     , 94.3599799941     , 105.727315291     , 116.735912729     ,
 125.76946687      , 130.85597583      , 130.405348513     , 123.795048733     ,
 111.621383956     , 95.5484527773     , 77.7941240083     , 60.4811096292     ,
 45.1423408123     , 32.5204254202     , 17.5929607544     , 11.1069364322     ,
 6.76533810536     , 3.99275737925     , 2.32670911009     , 1.38100344531     ,
 0.859160279824    , 0.568551668849    , 0.402661919264    , 0.308736593072    ,
 0.261387260999    , 0.246564484646    , 0.254721379938    , 0.279152983112    ,
 0.313338341919    , 0.347654736857    , 0.37120165107     , 0.378220662695    ,
 0.373268251243    , 0.371684217413    , 0.393522932552    , 0.453165928388    ,
 0.554722926193    , 0.699613805139    , 0.897687250544    , 1.16787190721     ,
 1.52409575528     , 1.95540235212     , 2.41757076324     , 2.84951200644     ,
 3.20804577115     , 3.49270190244     , 3.73077789513     , 3.92792938268     ,
 4.03728949975     , 3.99234120553     , 3.77281502986     , 3.42994956789     ,
 3.05221205461     , 2.71668956223     , 2.46172096721     , 2.28399438797     ,
 2.15809041927     , 2.06798266677     , 2.0250385361      , 2.05852421672     ,
 2.19271591353     , 2.43632918996     , 2.79088132618     , 3.25493966117     ,
 3.81143232868     , 4.42965491883     , 5.10988561632     , 5.934003704       ,
 7.05651466571     , 8.62896958224     , 10.7347408654     , 13.4252651576     ,
 16.8493322956     , 21.3301357643     , 27.273056208      , 35.0251688761     ,
 44.8901259265     , 57.2042659076     , 72.2101453268     , 89.8260692766     ,
 109.684840876     , 131.43409425      , 154.865531673     , 179.653860778     ,
 204.955631699     , 229.233704116     , 250.493355343     , 266.864989365     ,
 277.144610478     , 280.81384692      , 277.590432535     , 267.171743825     ,
 249.61991358      , 225.982619945     , 198.360103489     , 169.230062171     ,
 140.64809917      , 113.954409896     , 89.9581935351     , 69.1698651525     ,
 51.865588373      , 38.0628649172     , 27.4979758047     , 19.6577920195     ,
 13.9145603057     , 9.70356583988     , 6.61647717037     , 4.38922901477     ,
 2.84586463596     , 1.83739500242     , 1.20860284705     , 0.815457598238    ,
 0.558526339977    , 0.385631345091    , 0.269207112931    , 0.190073596582    ,
 0.135821728427    , 0.100587645348    , 0.0795881789937   , 0.0654271344543   ,
 0.0513656530742   , 0.0359184967855   , 0.0220035361858   , 0.0124129444049   ,
 0.00724905001391  , 0.00486483699863  , 0.00396820614962  , 0.00476465333257  ,
 0.00868724332827  , 0.0170756051002   , 0.0295774144      , 0.0437534948831   ,
 0.0566481660007   , 0.0665045344222   , 0.0729439618308   , 0.0773476751769   ,
 0.0839006647358   , 0.0967607101741   , 0.112964124771    , 0.120830280268    ,
 0.109863483482    , 0.0817763394784   , 0.0490706877862   , 0.0238157680211   ,
 0.0101067773947   , 0.00556074647589  , 0.00605406489434  , 0.00813435516803  ,
 0.0093763578542   , 0.00873697440131  , 0.00689433647786  , 0.00560042604557  ,
 0.00630559001387  , 0.00915007396152  , 0.0130243219083   , 0.0167203191089   ,
 0.0201881527174   , 0.0244341062147   , 0.0303172069573   , 0.03827695808     ,
 0.0502474533597   , 0.0745388542304   , 0.133947832736    , 0.269063766362    ,
 0.520088133165    , 0.890941814904    , 1.34593671812     , 1.88841196488     ,
 2.68076990885     , 4.09347288751     , 6.63899690466     , 10.8711956821     ,
 17.3270638881     , 26.4601250726     , 38.4527264344     , 52.9280510528     ,
 68.8087216748     , 84.5967864242     , 99.0362009392     , 111.735132685     ,
 123.255251001     , 134.50245019      , 145.759450024     , 156.008790447     ,
 163.033743719     , 164.277337654     , 157.97992522      , 144.005628172     ,
 123.998449703     , 100.83666824      , 77.6498060106     , 56.892134835      ,
 39.8970986391     , 26.9428922681     , 12.7703871812     , 7.52886326648     ,
 4.29060298923     , 2.37682220407     , 1.30531412004     , 0.734062315264    ,
 0.435963220463    , 0.279123105836    , 0.195431180249    , 0.15059270765     ,
 0.127325776127    , 0.118224683549    , 0.121356135752    , 0.135738688963    ,
 0.157060573881    , 0.176683496319    , 0.186054892783    , 0.182662284223    ,
 0.171964266037    , 0.164647275692    , 0.171236481313    , 0.196679927513    ,
 0.239558961459    , 0.297893754593    , 0.375833112095    , 0.483713756966    ,
 0.630265328411    , 0.812256781953    , 1.01012080234     , 1.19635058867     ,
 1.35344362872     , 1.48560267146     , 1.60894108231     , 1.72598907818     ,
 1.81238285627     , 1.83412869917     , 1.77725091223     , 1.65844832732     ,
 1.51430525054     , 1.38723727947     , 1.31197837378     , 1.29998750539     ,
 1.33441648056     , 1.38489182827     , 1.43016024763     , 1.47252440131     ,
 1.53869990797     , 1.67017133923     , 1.90827593402     , 2.27529156107     ,
 2.75834522187     , 3.32034904211     , 3.95141871898     , 4.72571016996     ,
 5.80380494339     , 7.36678551303     , 9.55105559701     , 12.4800685353     ,
 16.3892516351     , 21.6915326627     , 28.8638240002     , 38.2957960849     ,
 50.3344416977     , 65.4219301767     , 83.99584784       , 106.190099374     ,
 131.724311053     , 160.05326315      , 190.449800038     , 221.860729132     ,
 252.709300624     , 280.87312052      , 303.982503111     , 320.001742128     ,
 327.715634693     , 326.700908189     , 316.930106678     , 298.625284613     ,
 272.628690206     , 240.828281377     , 206.003429552     , 171.059305266     ,
 138.254440041     , 108.935726117     , 83.7142959147     , 62.7313064639     ,
 45.844577955      , 32.7424857547     , 22.9786308009     , 15.9620240682     ,
 11.0147160179     , 7.51471221657     , 5.01052562975     , 3.23156464151     ,
 2.02074562563     , 1.25234532415     , 0.792579042649    , 0.517738427159    ,
 0.345008828591    , 0.23275781833     , 0.159689295568    , 0.111768871202    ,
 0.0812085625918   , 0.0647330141059   , 0.0577717032978   , 0.0526000710045   ,
 0.0434331899547   , 0.0309092228723   , 0.0197134200412   , 0.0129682282948   ,
 0.0100141848877   , 0.00848759362795  , 0.00718694633032  , 0.00709450828962  ,
 0.0104381731318   , 0.0187479544125   , 0.0309887205153   , 0.043424026162    ,
 0.0521581830925   , 0.0559944681582   , 0.0564400081294   , 0.0561386706822   ,
 0.0584629045084   , 0.0661950673625   , 0.0773828330146   , 0.0838548711344   ,
 0.0775645845765   , 0.0587442313656   , 0.0357860045044   , 0.0174663376046   ,
 0.00703787759624  , 0.00289545937886  , 0.00211140792297  , 0.0024945442572   ,
 0.00282161286523  , 0.00263984120973  , 0.00215053743612  , 0.00194097259448  ,
 0.00256927635881  , 0.00431409090895  , 0.00732048832139  , 0.0119752088423   ,
 0.018752582051    , 0.0271098404514   , 0.0349077456874   , 0.0405183211301   ,
 0.0475221674635   , 0.0709854780017   , 0.145259584486    , 0.326896819049    ,
 0.677149831988    , 1.22765682013     , 1.98352449255     , 3.02367336759     ,
 4.66016993572     , 7.52136676408     , 12.4795212777     , 20.4815052587     ,
 32.35273256       , 48.5357552119     , 68.7213863687     , 91.5344104295     ,
 114.642592861     , 135.513279901     , 152.510389202     , 165.604397059     ,
 176.12164441      , 185.593638366     , 194.410600924     , 201.148178504     ,
 203.00441754      , 197.121942327     , 182.082103191     , 158.767903336     ,
 130.176667274     , 100.34477655      , 72.9526614936     , 50.3048118214     ,
 33.1139637976     , 20.9354845141     , 8.64782783254     , 4.75888124378     ,
 2.53264550644     , 1.3166350385      , 0.685270912346    , 0.369632459338    ,
 0.212021274683    , 0.131205741144    , 0.0893045903758   , 0.0675752492294   ,
 0.0559207203098   , 0.0502934729922   , 0.0506231566749   , 0.0572326200271   ,
 0.0676514389965   , 0.0765313929621   , 0.0791122249008   , 0.0748742071883   ,
 0.067918845717    , 0.0643734220343   , 0.0688636787995   , 0.0818132793727   ,
 0.0998616413373   , 0.120063698256    , 0.144128936072    , 0.178248542484    ,
 0.228526280814    , 0.295525570487    , 0.371821252976    , 0.445503283182    ,
 0.50861753952     , 0.563068086694    , 0.61638413824     , 0.670684157472    ,
 0.717699275885    , 0.745644097887    , 0.74831428516     , 0.727038845318    ,
 0.690836742903    , 0.659913872195    , 0.661748837532    , 0.713097920792    ,
 0.803977082295    , 0.901309889008    , 0.970174664121    , 0.998466775712    ,
 1.0096870236      , 1.0549825135      , 1.18976123742     , 1.4476684456      ,
 1.82399169013     , 2.28548294257     , 2.81767218431     , 3.48510895941     ,
 4.45065507377     , 5.92890130394     , 8.12651445483     , 11.2607983862     ,
 15.6612745917     , 21.8169154795     , 30.2614093816     , 41.4391956517     ,
 55.7828177428     , 73.8890999476     , 96.4247384523     , 123.748217023     ,
 155.634158739     , 191.254769688     , 229.215876627     , 267.539033553     ,
 303.681243036     , 334.715694299     , 357.795516193     , 370.830552869     ,
 372.927514114     , 364.231442845     , 345.467822238     , 317.777947576     ,
 282.956949742     , 243.645946798     , 203.028054752     , 164.089782375     ,
 128.96514663      , 98.7536860116     , 73.7314431534     , 53.6643565038     ,
 38.0642366694     , 26.3518243869     , 17.9077087184     , 12.055532424      ,
 8.09088843275     , 5.39024648228     , 3.51048538036     , 2.19835221133     ,
 1.3204592982      , 0.778438977593    , 0.468585348156    , 0.294894410752    ,
 0.193227374444    , 0.131234913453    , 0.092527750604    , 0.0674749180747   ,
 0.052392160764    , 0.0466546638612   , 0.0468655401495   , 0.0460660131791   ,
 0.0396146260299   , 0.0295117740416   , 0.0212935268834   , 0.0178451874671   ,
 0.0173522094795   , 0.0163456403563   , 0.0135389787752   , 0.010820821117    ,
 0.0113710864752   , 0.0169940380716   , 0.0263930001646   , 0.0355341023192   ,
 0.0404647396033   , 0.0403112485044   , 0.0372488153068   , 0.0342192864457   ,
 0.0336777735525   , 0.0371129124868   , 0.0432963454033   , 0.0474306407341   ,
 0.0445203940121   , 0.0342073531329   , 0.0211010881647   , 0.0103773486285   ,
 0.00410653885611  , 0.00143796857891  , 0.000682598934798 , 0.000625617200856 ,
 0.000674421038455 , 0.000632662799229 , 0.000539741639023 , 0.000568709430979 ,
 0.000963851338146 , 0.00210978559559  , 0.00476250208747  , 0.0100928319126   ,
 0.0188118299653   , 0.0294841228032   , 0.0382614975944   , 0.0424511690795   ,
 0.0471319137042   , 0.0727581978211   , 0.163964880271    , 0.395723907764    ,
 0.863901637845    , 1.66314413008     , 2.90577299567     , 4.84784727218     ,
 8.08480383387     , 13.6507583265     , 22.8936252837     , 37.1662040156     ,
 57.4201120673     , 83.7062486699     , 114.659881291     , 147.328450906     ,
 177.790793882     , 202.562386231     , 220.049144727     , 231.053631808     ,
 237.895645228     , 242.648547229     , 245.60757378      , 244.934316722     ,
 237.631440581     , 221.257613042     , 195.464734967     , 162.539360137     ,
 126.688394846     , 92.5204382204     , 63.5261043202     , 41.2684636898     ,
 25.5445544622     , 15.1532095861     , 5.43627921828     , 2.80674034779     ,
 1.40136783694     , 0.688564250321    , 0.344950472482    , 0.18307029496     ,
 0.103793794576    , 0.062015007153    , 0.0395506165526   , 0.0278609855316   ,
 0.0216953466647   , 0.0185221826817   , 0.0180599534536   , 0.0204345012077   ,
 0.0244598281019   , 0.0276637841027   , 0.0280467362064   , 0.0257404106792   ,
 0.0229691313282   , 0.0225997265852   , 0.0263252470878   , 0.0333642789348   ,
 0.0409155110896   , 0.0467359952831   , 0.0516308586093   , 0.0592522998402   ,
 0.073486291886    , 0.0956414929327   , 0.123140963195    , 0.150790745378    ,
 0.174484711214    , 0.194266845832    , 0.213169072088    , 0.233183334219    ,
 0.253596090476    , 0.272818784485    , 0.289098337329    , 0.299195386936    ,
 0.301551682403    , 0.304465677206    , 0.32653502189     , 0.382320490904    ,
 0.466334571354    , 0.551988639164    , 0.607583662351    , 0.619141939446    ,
 0.604535632015    , 0.60779514618     , 0.678233178028    , 0.8479081482      ,
 1.11731823969     , 1.4615645428      , 1.86961443434     , 2.40252927505     ,
 3.22471797572     , 4.57821649928     , 6.73674394934     , 10.0160541568     ,
 14.848088417      , 21.8074556631     , 31.5077680654     , 44.4994514916     ,
 61.3619670762     , 82.8636699534     , 109.832591356     , 142.715553034     ,
 181.189434959     , 224.021199981     , 269.072852237     , 313.38027865      ,
 353.34349291      , 385.123889218     , 405.380961455     , 412.169202665     ,
 405.364417264     , 386.278614078     , 356.947439739     , 319.732124819     ,
 277.306140104     , 232.680854178     , 188.948152564     , 148.737922398     ,
 113.741960381     , 84.625222591      , 61.282183582      , 43.1793302396     ,
 29.605947519      , 19.8048182042     , 13.0170042584     , 8.49539155162     ,
 5.54617105751     , 3.60479412627     , 2.29013257154     , 1.39144987883     ,
 0.801719940589    , 0.446849440207    , 0.252548093035    , 0.151282162066    ,
 0.0976954360088   , 0.068278880361    , 0.0510936715718   , 0.040002717265    ,
 0.0338126077033   , 0.0332342919239   , 0.0360766823387   , 0.037077167638    ,
 0.0331362278341   , 0.0268448912874   , 0.0233650352712   , 0.0245592707503   ,
 0.0272066811388   , 0.0267035353025   , 0.0217622616417   , 0.0153530064507   ,
 0.0117335695878   , 0.0130630408843   , 0.0181399632936   , 0.0234400135157   ,
 0.0256883460908   , 0.0241680609822   , 0.0206432732531   , 0.0174045987664   ,
 0.0159821724456   , 0.0169933566714   , 0.0197078678775   , 0.0217665378388   ,
 0.0206702436515   , 0.016061275964    , 0.010003479558    , 0.00495330450016  ,
 0.00195162259766  , 0.000635258667154 , 0.000216713057432 , 0.000133874625659 ,
 0.000128777696054 , 0.000120602442631 , 0.00011218510178  , 0.00015922739154  ,
 0.000406575170111 , 0.0012424845571   , 0.00354256478531  , 0.0086136627465   ,
 0.0171719589144   , 0.0276291889307   , 0.036013137203    , 0.0399486096061   ,
 0.0460662694823   , 0.0791657642609   , 0.194357400092    , 0.490955392038    ,
 1.11851231462     , 2.27833908305     , 4.27260279161     , 7.66771372885     ,
 13.5197440641     , 23.4392374705     , 39.3078778817     , 62.7095017589     ,
 94.2590376842     , 132.93710816      , 175.641786779     , 217.454434587     ,
 252.986954991     , 278.387351703     , 292.815343604     , 298.34104304      ,
 298.256906295     , 294.877006128     , 288.22027068      , 276.304778668     ,
 256.678533561     , 228.192821598     , 192.100971613     , 151.968968842     ,
 112.487110944     , 77.8563405139     , 50.5588590556     , 31.0138663162     ,
 18.1109908517     , 10.1265305521     , 3.14402491656     , 1.53889438207     ,
 0.731319444476    , 0.347138121649    , 0.172896409564    , 0.0935794743087   ,
 0.0537008422727   , 0.0309663633361   , 0.0178274344406   , 0.0108772984216   ,
 0.0074516939837   , 0.00582371205461  , 0.00541024648885  , 0.00606476292532  ,
 0.00729786476492  , 0.00822440104673  , 0.00819489113156  , 0.00737450858658  ,
 0.0066880610227   , 0.00723767681775  , 0.00954255428867  , 0.0129603786379   ,
 0.0159272950505   , 0.0172426677919   , 0.0172999916743   , 0.0179517525323   ,
 0.0212123750999   , 0.0279612954481   , 0.0373395049512   , 0.0471649431716   ,
 0.0554194354107   , 0.0617017395516   , 0.0671341757442   , 0.0731389339199   ,
 0.0809369468161   , 0.0916743506359   , 0.105180385674    , 0.118387541994    ,
 0.128024408837    , 0.1371017263      , 0.156184945852    , 0.194503072306    ,
 0.249125715286    , 0.30327941983     , 0.336130868423    , 0.338079499372    ,
 0.32091876609     , 0.314613197929    , 0.353578567307    , 0.46154924674     ,
 0.641288856033    , 0.878590863242    , 1.17291689245     , 1.5870823902      ,
 2.28127037288     , 3.5064075574      , 5.58271088252     , 8.9175965519      ,
 14.0605516003     , 21.7068537352     , 32.6016775175     , 47.4643510178     ,
 67.0670878602     , 92.3211948695     , 124.068483028     , 162.596217499     ,
 207.219296861     , 256.122616021     , 306.394663873     , 354.180966032     ,
 394.979130023     , 424.222171747     , 438.314173508     , 435.786844933     ,
 417.717915623     , 387.044856335     , 347.424102091     , 302.421460891     ,
 255.221128792     , 208.648545521     , 165.183592272     , 126.742498187     ,
 94.3813998688     , 68.2573422808     , 47.9080081659     , 32.6008117183     ,
 21.5306505171     , 13.873173679      , 8.80966808791     , 5.58021327293     ,
 3.54932041804     , 2.25164081785     , 1.39571298219     , 0.825243286445    ,
 0.459853001695    , 0.245068806137    , 0.130712094998    , 0.0738528278069   ,
 0.0462003488074   , 0.0327771870193   , 0.0257963525499   , 0.0214982059582   ,
 0.0195037993928   , 0.0205633272591   , 0.0234097007009   , 0.0248560808501   ,
 0.0234410800267   , 0.0217059995575   , 0.0235591024525   , 0.0294659404442   ,
 0.0350694401586   , 0.0350848132212   , 0.0283932968803   , 0.0188737668852   ,
 0.0116118919852   , 0.00904361609084  , 0.0102064328367   , 0.0123534846365   ,
 0.0130969616085   , 0.0118050716829   , 0.00944256324419  , 0.00731976447734  ,
 0.00621607950982  , 0.00632142467781  , 0.00725592092182  , 0.00805532379609  ,
 0.00771591960239  , 0.00604517938483  , 0.00379160802777  , 0.00188739321656  ,
 0.000743905498772 , 0.000235224972695 , 6.6442367273e-05  , 2.62939027875e-05 ,
 2.00061757177e-05 , 1.86101647322e-05 , 2.16920972166e-05 , 5.38934918002e-05 ,
 0.000210995879661 , 0.000795042786798 , 0.00250798521202  , 0.00639537985535  ,
 0.0130417109992   , 0.0212760142512   , 0.0282716613241   , 0.0331815501642   ,
 0.0445510346255   , 0.0915656152664   , 0.241899643862    , 0.627136460349    ,
 1.47008308516     , 3.12057910859     , 6.15206496937     , 11.5774123068     ,
 21.0883981734     , 37.0013206588     , 61.6595186839     , 96.4600225339     ,
 140.928233129     , 192.141096072     , 244.758688197     , 292.04400957      ,
 327.902614915     , 349.084384348     , 356.182642992     , 352.674929782     ,
 342.567250929     , 328.155051988     , 309.282394962     , 284.361415625     ,
 252.202455488     , 213.414304871     , 170.724213893     , 128.234061911     ,
 90.0695555216     , 59.1107635898     , 36.3608104703     , 21.1109096267     ,
 11.6685120688     , 6.17987196859     , 1.65424121424     , 0.780376584359    ,
 0.364258089161    , 0.175652714853    , 0.0918695340047   , 0.052110423143    ,
 0.0300877540366   , 0.0164992481715   , 0.00842668856224  , 0.00423940816449  ,
 0.00235000151925  , 0.00157226851022  , 0.00134789621716  , 0.00147745496498  ,
 0.00177641770318  , 0.00199195765622  , 0.00195909212585  , 0.00175703436021  ,
 0.00168995890152  , 0.00210831070107  , 0.00314708296382  , 0.00450379228872  ,
 0.00552843178768  , 0.00573403092056  , 0.00528691636342  , 0.0049428598808   ,
 0.0055242109774   , 0.00742041299513  , 0.0103593976354   , 0.0135313268349   ,
 0.0161105277811   , 0.0178339410174   , 0.019093334559    , 0.0206384429098   ,
 0.0234496569478   , 0.0285659794932   , 0.0361097402195   , 0.0443536472854   ,
 0.0512013485762   , 0.0576724664396   , 0.0687148647612   , 0.0888022129728   ,
 0.116442429455    , 0.143188511674    , 0.158483607431    , 0.157580655323    ,
 0.147136614322    , 0.143962833723    , 0.168112092687    , 0.234725890657    ,
 0.348189563969    , 0.505695262183    , 0.719709678797    , 1.05539657968     ,
 1.66116154348     , 2.77833766612     , 4.75024612206     , 8.06186182106     ,
 13.3887959698     , 21.5799159972     , 33.5570367684     , 50.244578139      ,
 72.6056714695     , 101.617851307     , 137.956028652     , 181.473551329     ,
 230.831162204     , 283.446163867     , 335.656024904     , 382.967066403     ,
 420.412838816     , 443.251052413     , 448.181935131     , 434.633283706     ,
 405.106661231     , 364.182858462     , 316.930212486     , 267.68711618      ,
 219.607517247     , 174.848715502     , 134.95598895      , 100.97438718      ,
 73.2880505432     , 51.5836174976     , 35.1212430276     , 23.069838924      ,
 14.6394046083     , 9.05141397171     , 5.53412306253     , 3.3963840752      ,
 2.10470353098     , 1.30502622694     , 0.793156888725    , 0.463094090701    ,
 0.25825324687     , 0.139876800918    , 0.075899269438    , 0.042303715109    ,
 0.0248457047737   , 0.0161944976871   , 0.0120823331065   , 0.0100321553458   ,
 0.00941423765768  , 0.0103812315454   , 0.0122271938295   , 0.0134777757567   ,
 0.0138768134253   , 0.0155064713597   , 0.02084336385     , 0.0292943716139   ,
 0.036252269155    , 0.0366232355792   , 0.0295653333963   , 0.0191568384483   ,
 0.0105050764083   , 0.00599439945093  , 0.00490812868372  , 0.00522607885547  ,
 0.00531268071086  , 0.00462712686596  , 0.00351099375473  , 0.00252041179085  ,
 0.00197007210057  , 0.00189938492968  , 0.00214691258951  , 0.0023885428361   ,
 0.00230157164373  , 0.00181368409624  , 0.00114312067814  , 0.00057117879387  ,
 0.000225468111257 , 7.05554908634e-05 , 1.82685540995e-05 , 5.06701732155e-06 ,
 2.64761834684e-06 , 2.51456624329e-06 , 5.12988668859e-06 , 2.32568654101e-05 ,
 0.000113317816192 , 0.000461527252503 , 0.00150954038321  , 0.00394140734282  ,
 0.00824567495446  , 0.0140242404116   , 0.0202576367465   , 0.0282619866936   ,
 0.0488471542702   , 0.116117259492    , 0.312212727238    , 0.805640145664    ,
 1.90267033459     , 4.1258701995      , 8.37358750256     , 16.1966588981     ,
 30.0204948115     , 52.8713668835     , 87.3139517678     , 133.973330331     ,
 190.467952941     , 251.322209777     , 308.965871492     , 355.66789899      ,
 385.873559067     , 397.921035382     , 394.13667149      , 379.136782033     ,
 357.291009686     , 330.87709635      , 299.981120628     , 263.936094613     ,
 223.028946404     , 179.277107948     , 136.026462214     , 96.867800883      ,
 64.5182577516     , 40.1606085238     , 23.4283886666     , 12.8960378798     ,
 6.76086498078     , 3.40409136035     , 0.784590015587    , 0.36682816981     ,
 0.178994771811    , 0.0958393194025   , 0.0560388749104   , 0.0332951803739   ,
 0.018610740559    , 0.00935525367597  , 0.00418299425519  , 0.001722451233    ,
 0.000728931504339 , 0.000378227200361 , 0.000280100041242 , 0.000293324794765 ,
 0.000350177854764 , 0.000390605530668 , 0.000381502482043 , 0.000348395212255 ,
 0.000371712233257 , 0.000543651129176 , 0.00089426878086  , 0.00132170877965  ,
 0.0016181622278   , 0.00163028666205  , 0.00141381458844  , 0.00121125083509  ,
 0.00128511843929  , 0.00176297970228  , 0.00256772126059  , 0.00345013227366  ,
 0.00414265124859  , 0.0045451036896   , 0.00478278713854  , 0.00515461405815  ,
 0.00611001429176  , 0.00813810723955  , 0.0113238654668   , 0.0149636795934   ,
 0.018174704941    , 0.0212960123562   , 0.0262095976408   , 0.0345962421124   ,
 0.0457813424208   , 0.0563584498268   , 0.0621200337974   , 0.0613120673812   ,
 0.0571380447039   , 0.0576060722751   , 0.072994094497    , 0.112575183121    ,
 0.182509825032    , 0.289560274861    , 0.456698363373    , 0.749319977859    ,
 1.30146769199     , 2.33802568549     , 4.21040799515     , 7.46049056172     ,
 12.8742020476     , 21.4515456005     , 34.2953806185     , 52.5238524058     ,
 77.2369596259     , 109.362698656     , 149.225840592     , 196.013564754     ,
 247.517336534     , 300.301828327     , 350.103438214     , 392.216900524     ,
 421.890082749     , 435.016721222     , 429.295791076     , 405.373639017     ,
 367.006260407     , 319.854253875     , 269.642999728     , 220.76721914      ,
 175.866424405     , 136.228238475     , 102.445165336     , 74.7438090833     ,
 52.9245090484     , 36.3240624839     , 24.0512421624     , 15.2780624693     ,
 9.3112468172      , 5.50329343031     , 3.21843370106     , 1.90055559132     ,
 1.14275709358     , 0.694077223753    , 0.419661279186    , 0.251701413568    ,
 0.152437976748    , 0.0952315996018   , 0.0604879634818   , 0.0370823852868   ,
 0.0210906467832   , 0.0113845142995   , 0.00645032554111  , 0.00434690134705  ,
 0.00378288346429  , 0.00419663680549  , 0.00508378506573  , 0.00593217502733  ,
 0.00702194190803  , 0.00980441206071  , 0.0156354458308   , 0.0235674164279   ,
 0.0297735630035   , 0.0302303637118   , 0.0243869820801   , 0.0156381268494   ,
 0.00814046080593  , 0.00381345730276  , 0.00216572346968  , 0.00181839037856  ,
 0.00171346589493  , 0.00144225869866  , 0.00104878823801  , 0.000703916555325 ,
 0.000505963071193 , 0.000458498317724 , 0.000507416562049 , 0.000564070731707 ,
 0.000545573835487 , 0.000431599433242 , 0.000272917830177 , 0.000136718618692 ,
 5.40478498527e-05 , 1.68572201514e-05 , 4.21293169316e-06 , 9.50104604793e-07 ,
 3.26797136997e-07 , 3.79440397328e-07 , 1.67743601455e-06 , 1.02928021264e-05 ,
 5.42763739286e-05 , 0.00023090252088  , 0.000792290771532 , 0.00222028917902  ,
 0.00519190238339  , 0.0104688962721   , 0.0191775072186   , 0.0347971623639   ,
 0.0698558404818   , 0.16237046663     , 0.407224636805    , 1.00579592774     ,
 2.34007054296     , 5.09724930914     , 10.4984428249     , 20.62751476       ,
 38.5902788536     , 67.9450585977     , 111.111872607     , 167.412181101     ,
 232.05731389      , 296.927926926     , 352.86077548      , 392.384153573     ,
 411.745121629     , 411.489878387     , 395.503543837     , 369.002181688     ,
 336.404226806     , 300.133945663     , 260.920968232     , 219.160206371     ,
 176.155752937     , 134.345327885     , 96.5798510505     , 65.1470879389     ,
 41.1248134436     , 24.2836503861     , 13.4448720608     , 7.02227798401     ,
 3.49397064492     , 1.67551198245     , 0.334770524995    , 0.162841349803    ,
 0.0912117372115   , 0.0588084471991   , 0.0390298620648   , 0.0238013537904   ,
 0.0125957818046   , 0.00569062343011  , 0.00220456299874  , 0.000750028102766 ,
 0.000240937415202 , 8.81802828361e-05 , 4.98615098088e-05 , 4.74068172268e-05 ,
 5.56434971395e-05 , 6.17560280568e-05 , 6.03651039762e-05 , 5.75941580628e-05 ,
 7.06421982844e-05 , 0.000119453541288 , 0.000209762883231 , 0.000315643921942 ,
 0.000385425019113 , 0.000381338133556 , 0.000317850051976 , 0.00025578160644  ,
 0.000260621871914 , 0.00036438937718  , 0.000548660599727 , 0.0007518405037   ,
 0.000906128573605 , 0.000984914554433 , 0.00102294379594  , 0.00111201124027  ,
 0.00139955355499  , 0.00204813761139  , 0.00309024488135  , 0.00430974159543  ,
 0.00543644174059  , 0.00657948441362  , 0.00831405375309  , 0.0111302973606   ,
 0.0147740012676   , 0.0181464796196   , 0.0199226172277   , 0.0196321868189   ,
 0.018615636894    , 0.0202584178123   , 0.029556788639    , 0.0525532441326   ,
 0.0966060227883   , 0.174087609873    , 0.313251707182    , 0.577290356691    ,
 1.08833494381     , 2.05756184633     , 3.83663247717     , 6.99712882805     ,
 12.3914479032     , 21.1220654995     , 34.4252628088     , 53.5547928814     ,
 79.6573477166     , 113.478538207     , 154.834479918     , 202.109617865     ,
 252.182545307     , 300.891593975     , 343.722427487     , 376.341089363     ,
 394.970564789     , 396.920760002     , 381.413984092     , 350.316343535     ,
 308.050311842     , 260.380430987     , 212.681902932     , 168.700543249     ,
 130.30718905      , 98.0201792305     , 71.7094877814     , 50.9901241363     ,
 35.2506008501     , 23.6462900499     , 15.2826493396     , 9.42820232534     ,
 5.53403480641     , 3.12191100907     , 1.73300796553     , 0.973147781141    ,
 0.562559522904    , 0.335832199222    , 0.208162504305    , 0.138076402409    ,
 0.101436826799    , 0.0800959584451   , 0.0617814665061   , 0.0425756487237   ,
 0.0249634964935   , 0.012334735171    , 0.00534678350784  , 0.00234705551681  ,
 0.00141380685146  , 0.00138100715361  , 0.00169340052244  , 0.00216638758859  ,
 0.0031190774197   , 0.00539992524023  , 0.00966233860733  , 0.0151383106086   ,
 0.0193293624813   , 0.0196767779281   , 0.0158711862718   , 0.0101357702733   ,
 0.00516338830187  , 0.0021918790375   , 0.00092792212045  , 0.000549483695184 ,
 0.000444407281905 , 0.000356256129711 , 0.000249628562945 , 0.000158171462947 ,
 0.00010478013257  , 8.85296265359e-05 , 9.53043138449e-05 , 0.000105554526655 ,
 0.000102296799039 , 8.1128982257e-05  , 5.14106904141e-05 , 2.57977529573e-05 ,
 1.02098305357e-05 , 3.18179442627e-06 , 7.84559618013e-07 , 1.60868873746e-07 ,
 4.21545577451e-08 , 8.42545556759e-08 , 6.16534760749e-07 , 4.32178157443e-06 ,
 2.51267898964e-05 , 0.000121720559565 , 0.00049985139717  , 0.00176286098989  ,
 0.00535689840129  , 0.0139834821537   , 0.031468319587    , 0.0628708158414   ,
 0.11984735835     , 0.239637372593    , 0.522682815971    , 1.19015648865     ,
 2.67450134739     , 5.78396744357     , 11.9899857801     , 23.7781390521     ,
 44.6983424434     , 78.4894822207     , 127.048409782     , 188.171054644     ,
 254.806737664     , 316.845262572     , 364.626862726     , 392.11695603      ,
 398.115858503     , 385.420961186     , 358.982317983     , 324.048243779     ,
 284.811540501     , 243.862287605     , 202.567451243     , 162.003643828     ,
 123.662520413     , 89.4059632057     , 60.868158786      , 38.8759801033     ,
 23.2530395126     , 13.0265064156     , 6.84855648781     , 3.39540211705     ,
 1.60262474015     , 0.732502785551    , 0.129635155175    , 0.0703094926515   ,
 0.0486795042599   , 0.0376706478576   , 0.0272618678722   , 0.016799519989    ,
 0.0085353360955   , 0.00355702632716  , 0.00122504240537  , 0.000354925048745 ,
 9.01213263534e-05 , 2.27381620903e-05 , 8.25474147703e-06 , 6.30554218131e-06 ,
 7.11103748353e-06 , 7.84992004564e-06 , 7.75137026387e-06 , 7.94400895979e-06 ,
 1.13993270284e-05 , 2.16289772276e-05 , 3.95601697418e-05 , 6.01072729264e-05 ,
 7.32429463259e-05 , 7.16816564056e-05 , 5.83257967503e-05 , 4.50822943139e-05 ,
 4.47208592192e-05 , 6.34813372335e-05 , 9.77895123967e-05 , 0.000135584886875 ,
 0.000163458446955 , 0.000176215327519 , 0.000181830000252 , 0.000202240039978 ,
 0.000274097764906 , 0.00043827389316  , 0.000703913678024 , 0.00102054272451  ,
 0.00132675029089  , 0.00165413984482  , 0.00214292937612  , 0.00290356966503  ,
 0.00385899985099  , 0.00472670366639  , 0.00517921129972  , 0.00514522801081  ,
 0.00515018304296  , 0.00660095012425  , 0.0120913564262   , 0.0259416374942   ,
 0.0554206260217   , 0.114057528175    , 0.229835150946    , 0.460894751748    ,
 0.919021543358    , 1.80333437837     , 3.45669185966     , 6.44843347624     ,
 11.6379985645     , 20.1507336526     , 33.2671986684     , 52.2794565138     ,
 78.2699974283     , 111.686563168     , 151.760688074     , 196.109271872     ,
 240.901425586     , 281.625548115     , 314.024752029     , 334.715914985     ,
 341.460260853     , 333.384155463     , 311.291023464     , 277.870613847     ,
 237.414523321     , 194.824964363     , 154.312768977     , 118.550878976     ,
 88.6353706591     , 64.5738523482     , 45.8423097568     , 31.7261800001     ,
 21.4212832764     , 14.0768753389     , 8.92124629118     , 5.38149513426     ,
 3.06513676262     , 1.65761753955     , 0.869943460544    , 0.45817894057     ,
 0.250887901148    , 0.14777071397     , 0.0984597101229   , 0.0789127865569   ,
 0.074357470744    , 0.0721794287547   , 0.0635993925207   , 0.0474356733177   ,
 0.0290067667034   , 0.0143558247025   , 0.00576491521052  , 0.00195629509047  ,
 0.000684369204129 , 0.000412559745378 , 0.000464878290971 , 0.000678786103892 ,
 0.00122721642554  , 0.00251500192496  , 0.00481723359865  , 0.00770173327992  ,
 0.00988691835385  , 0.0100778045626   , 0.00812887720866  , 0.0051831165517   ,
 0.00261782319631  , 0.00106488994981  , 0.000379486397864 , 0.000155810306182 ,
 9.57898016347e-05 , 6.9994327682e-05  , 4.71164140941e-05 , 2.84083517011e-05 ,
 1.74226713675e-05 , 1.36294434414e-05 , 1.41686095117e-05 , 1.5588569954e-05  ,
 1.51163085776e-05 , 1.20065481162e-05 , 7.61875154471e-06 , 3.8271990936e-06  ,
 1.51583650686e-06 , 4.72380501564e-07 , 1.15912177215e-07 , 2.29246040995e-08 ,
 6.24541433839e-09 , 2.79755320941e-08 , 2.78342394258e-07 , 2.42655658427e-06 ,
 1.80044183059e-05 , 0.000112956658464 , 0.000592018371446 , 0.00255707997542  ,
 0.00900731278414  , 0.0257690071916   , 0.0602402577762   , 0.117921601917    ,
 0.20487698637     , 0.349600086753    , 0.647827553589    , 1.32443212705     ,
 2.82922834707     , 6.02317819266     , 12.4950450678     , 24.8897949837     ,
 46.8213019879     , 81.7653445614     , 130.827744701     , 190.497830864     ,
 252.31144644      , 305.440112383     , 340.936622842     , 354.869208515     ,
 348.546379988     , 326.481873173     , 294.059208027     , 256.098276563     ,
 216.284646284     , 177.09833393      , 140.098230341     , 106.400141358     ,
 77.003019814      , 52.738136086      , 33.9978969395     , 20.5602860913     ,
 11.6516897418     , 6.19307688814     , 3.09323161679     , 1.45642556558     ,
 0.651892531786    , 0.284450473614    , 0.0462841007903   , 0.0297793932784   ,
 0.0253990122765   , 0.0221579963512   , 0.0167621432718   , 0.0103743145331   ,
 0.00516573450492  , 0.002063810298    , 0.000664046547485 , 0.000173690487337 ,
 3.76629740015e-05 , 7.16627301119e-06 , 1.53069212315e-06 , 7.25348873085e-07 ,
 7.32253409754e-07 , 8.00679347363e-07 , 8.07321823464e-07 , 9.12410352703e-07 ,
 1.52860978106e-06 , 3.15376072323e-06 , 5.91256909339e-06 , 9.03053600993e-06 ,
 1.09879484836e-05 , 1.06848808221e-05 , 8.57248709537e-06 , 6.47014381544e-06 ,
 6.32455365537e-06 , 9.08473600001e-06 , 1.41981166663e-05 , 1.98043138759e-05 ,
 2.38321493929e-05 , 2.55230452629e-05 , 2.63499560516e-05 , 3.04137587188e-05 ,
 4.4761090642e-05  , 7.73494734035e-05 , 0.000130211466456 , 0.000194427472015 ,
 0.000259696331621 , 0.000333688288268 , 0.000443540716295 , 0.000608313274584 ,
 0.000809563062967 , 0.000989996692899 , 0.00108990726998  , 0.00112984795587  ,
 0.00135920976858  , 0.00251919840642  , 0.00629918472551  , 0.0160275888851   ,
 0.03774667664     , 0.0827067021274   , 0.17402461027     , 0.36087104749     ,
 0.74156093664     , 1.49769322239     , 2.94878908059     , 5.6287762354      ,
 10.3443729371     , 18.1567523903     , 30.282004764      , 47.928755507      ,
 72.0014275092     , 102.592335375     , 138.420127366     , 176.597095846     ,
 213.033000451     , 243.408268452     , 264.218116013     , 273.365364817     ,
 270.251049969     , 255.637428777     , 231.457117658     , 200.594901091     ,
 166.546140958     , 132.796225551     , 102.073304864     , 75.9319547809     ,
 54.8491101155     , 38.5775193622     , 26.4865302548     , 17.8015130714     ,
 11.7375325659     , 7.57571573372     , 4.73683100091     , 2.82342836865     ,
 1.58299981196     , 0.832445597178    , 0.415577640948    , 0.203232137057    ,
 0.103158552957    , 0.0598535185852   , 0.0452106317151   , 0.0461441920436   ,
 0.0540938632661   , 0.0602591133321   , 0.0576011778943   , 0.0452371871726   ,
 0.0286243409572   , 0.0144479998963   , 0.00579117601712  , 0.00185218595421  ,
 0.000496985283703 , 0.000152990258844 , 0.000114373657953 , 0.000188480650371 ,
 0.000420262155361 , 0.000961990880845 , 0.00191183559069  , 0.00308813335874  ,
 0.00397491430114  , 0.00405430720874  , 0.00327040021098  , 0.00208401243758  ,
 0.00104906577208  , 0.000419486649768 , 0.000137858613902 , 4.33005034941e-05 ,
 1.83133315999e-05 , 1.11228043988e-05 , 7.04805562455e-06 , 4.05860051338e-06 ,
 2.31764246124e-06 , 1.66952766242e-06 , 1.66250975193e-06 , 1.81127553128e-06 ,
 1.75536124321e-06 , 1.39538974188e-06 , 8.861835816e-07   , 4.45465945512e-07 ,
 1.76524076789e-07 , 5.50188334561e-08 , 1.34791073004e-08 , 2.66878785256e-09 ,
 1.55921088092e-09 , 1.81938031061e-08 , 2.39306815643e-07 , 2.59330559976e-06 ,
 2.28167035986e-05 , 0.0001616359408   , 0.000916891039328 , 0.00415165217361  ,
 0.0149906019768   , 0.0432421694424   , 0.100358901579    , 0.190908818768    ,
 0.310945884973    , 0.473511403927    , 0.762001124379    , 1.39276774339     ,
 2.80212765267     , 5.82758923853     , 12.0137236026     , 23.8745781357     ,
 44.6712973799     , 77.211642407      , 121.731070563     , 173.995333507     ,
 225.402210856     , 265.895809566     , 288.211294766     , 290.532385654     ,
 275.923582316     , 249.681771237     , 216.962459379     , 181.809092418     ,
 147.131752988     , 114.903272742     , 86.3461582679     , 62.137317092      ,
 42.5700613202     , 27.6013359691     , 16.8499352263     , 9.65117523305     ,
 5.1818955982      , 2.61263894234     , 1.23999905601     , 0.554977983175    ,
 0.235800896647    , 0.0986976333211   , 0.0153567722434   , 0.0119082024889   ,
 0.0117890826986   , 0.010957846671    , 0.00846073056308  , 0.00524820638639  ,
 0.00259200489026  , 0.00101710741948  , 0.00031734521993  , 7.8985133705e-05  ,
 1.57980981881e-05 , 2.58918808448e-06 , 3.80703611144e-07 , 8.58472676717e-08 ,
 6.18317939004e-08 , 6.54910014706e-08 , 6.81844274783e-08 , 8.67820950459e-08 ,
 1.67014422304e-07 , 3.65173810804e-07 , 6.94945662072e-07 , 1.06449448271e-06 ,
 1.29398638432e-06 , 1.25360836148e-06 , 9.97849138564e-07 , 7.43728071332e-07 ,
 7.23289685303e-07 , 1.0494091295e-06  , 1.65458134842e-06 , 2.31319471787e-06 ,
 2.77510501379e-06 , 2.9572626531e-06  , 3.0754730454e-06  , 3.730694441e-06   ,
 5.97906127735e-06 , 1.10315775467e-05 , 1.92513747319e-05 , 2.9463372391e-05  ,
 4.04332285673e-05 , 5.36574320035e-05 , 7.32943696813e-05 , 0.000101831372721 ,
 0.000135897241895 , 0.000167191108432 , 0.000193777667543 , 0.000259930315768 ,
 0.000573483574616 , 0.00177775227036  , 0.00538966634595  , 0.014212500695    ,
 0.0326233093439   , 0.0678432083435   , 0.135292505342    , 0.27153132142     ,
 0.556149133891    , 1.14415955845     , 2.3150637887      , 4.536945553       ,
 8.51272840461     , 15.1635468282     , 25.5403600329     , 40.6542534948     ,
 61.1477134919     , 86.786751428      , 116.000677004     , 145.831461979     ,
 172.488948542     , 192.360058125     , 202.981377671     , 203.496306047     ,
 194.552874685     , 177.895537273     , 155.861603254     , 130.958035537     ,
 105.591115195     , 81.8118428207     , 61.0375475942     , 43.9472320441     ,
 30.6170427037     , 20.7246478621     , 13.7123318689     , 8.92905422469     ,
 5.75196304962     , 3.66281583123     , 2.2823060681      , 1.3670529149      ,
 0.772258711767    , 0.405308110325    , 0.196507364316    , 0.0894492620251   ,
 0.0410409407169   , 0.0229748283573   , 0.0202280381515   , 0.0259879838614   ,
 0.0356045726196   , 0.04329093096     , 0.0436307755875   , 0.0355023059211   ,
 0.0230329554361   , 0.0118290522955   , 0.00478801629655  , 0.0015250252624   ,
 0.000385372508997 , 8.43266875674e-05 , 3.07073558338e-05 , 4.71069782954e-05 ,
 0.000121322862184 , 0.000295844852614 , 0.000599197996484 , 0.000972803917862 ,
 0.00125379555357  , 0.0012792512058   , 0.00103194241581  , 0.00065744146229  ,
 0.000330526133057 , 0.000131289098879 , 4.17172144395e-05 , 1.13345771446e-05 ,
 3.3593139577e-06  , 1.49067297594e-06 , 8.41281222202e-07 , 4.60036264219e-07 ,
 2.45891596281e-07 , 1.62517965991e-07 , 1.53675783164e-07 , 1.65206686795e-07 ,
 1.59840862116e-07 , 1.27103057226e-07 , 8.07602782077e-08 , 4.06133323522e-08 ,
 1.60988660501e-08 , 5.0185119068e-09  , 1.23028059468e-09 , 2.85142313897e-10 ,
 1.13926675387e-09 , 2.00120359154e-08 , 2.89156285488e-07 , 3.31994194089e-06 ,
 3.02412000444e-05 , 0.000218444292096 , 0.00125132268402  , 0.00568650928282  ,
 0.0205195770951   , 0.0589292874308   , 0.135472178314    , 0.252938611943    ,
 0.397222274526    , 0.566317032148    , 0.830459390762    , 1.39045791501     ,
 2.64362065852     , 5.3350861376      , 10.8170097631     , 21.2201971809     ,
 39.1329324599     , 66.4617319296     , 102.695535732     , 143.591174003     ,
 181.632710575     , 208.736965065     , 219.811343947     , 214.66772039      ,
 197.048148046     , 172.018502261     , 143.924735126     , 115.803983793     ,
 89.6398005762     , 66.6687290153     , 47.5293416706     , 32.3705205135     ,
 20.9743282162     , 12.8702849082     , 7.44304248018     , 4.03966579251     ,
 2.05453990232     , 0.981588538722    , 0.442340120619    , 0.188327193164    ,
 0.0761575632791   , 0.0308333814228   , 0.00466385309427  , 0.00421707892051  ,
 0.00455733795339  , 0.00436849234782  , 0.00340458409679  , 0.00211459400537  ,
 0.00104123615576  , 0.000405744528638 , 0.000125046614684 , 3.04903976687e-05 ,
 5.89313698394e-06 , 9.07849294862e-07 , 1.14106505833e-07 , 1.42128175438e-08 ,
 4.67724216264e-09 , 4.31334239216e-09 , 4.66866313085e-09 , 6.77805266201e-09 ,
 1.4644744674e-08  , 3.33080425652e-08 , 6.39742017292e-08 , 9.81562115488e-08 ,
 1.19246560272e-07 , 1.15282142002e-07 , 9.13880823243e-08 , 6.77772269423e-08 ,
 6.60788656124e-08 , 9.68011634722e-08 , 1.53449226059e-07 , 2.14522658387e-07 ,
 2.56372606259e-07 , 2.72246403059e-07 , 2.87045576897e-07 , 3.69853534304e-07 ,
 6.44458376961e-07 , 1.25547525231e-06 , 2.25502044921e-06 , 3.53140072595e-06 ,
 4.98879376415e-06 , 6.85738814677e-06 , 9.64178381133e-06 , 1.35932482576e-05 ,
 1.83762697505e-05 , 2.43943430976e-05 , 4.16435819854e-05 , 0.000129918304281 ,
 0.000533448168593 , 0.00198958487279  , 0.00613056115486  , 0.01552627471     ,
 0.03303030131     , 0.0617220090138   , 0.1089501007      , 0.197789242563    ,
 0.386691513987    , 0.79802546658     , 1.65855336365     , 3.34777976757     ,
 6.42937214999     , 11.6341693609     , 19.781923787      , 31.6170618833     ,
 47.4990332614     , 66.977890436      , 88.4880480019     , 109.438741434     ,
 126.788718591     , 137.922871632     , 141.415241277     , 137.297057691     ,
 126.816268995     , 111.92639215      , 94.7211764077     , 77.0218012205     ,
 60.2276020122     , 45.3059510004     , 32.7919049194     , 22.8377788162     ,
 15.3261830732     , 9.9639329436      , 6.340324222       , 3.99999511333     ,
 2.52805757055     , 1.60447236239     , 1.01368669403     , 0.625412367485    ,
 0.36671684823     , 0.19811201503     , 0.0960201945864   , 0.0415090307632   ,
 0.0170127674281   , 0.00873170095241  , 0.00866086545739  , 0.0132379068987   ,
 0.0200919923541   , 0.0258646299896   , 0.0270189617694   , 0.0225306075947   ,
 0.0148732946899   , 0.00773354278446  , 0.00315688271291  , 0.00100966856145  ,
 0.000253108389976 , 5.07094804195e-05 , 1.08454096704e-05 , 1.06226990518e-05 ,
 2.86733083665e-05 , 7.21986419386e-05 , 0.000147609734603 , 0.000240242872743 ,
 0.000309834240953 , 0.000316174719061 , 0.000255056524195 , 0.000162480755776 ,
 8.16470967985e-05 , 3.23489532305e-05 , 1.01440412232e-05 , 2.58379754622e-06 ,
 6.04813083385e-07 , 1.81564300556e-07 , 8.19373449025e-08 , 4.14253145588e-08 ,
 2.07591696038e-08 , 1.25643054622e-08 , 1.11786416436e-08 , 1.18095908064e-08 ,
 1.1394890985e-08  , 9.06048939554e-09 , 5.75848902776e-09 , 2.89658922829e-09 ,
 1.1484122617e-09  , 3.58077236291e-10 , 8.92775656922e-11 , 6.5926624305e-11  ,
 1.1590624697e-09  , 2.14752938324e-08 , 3.14475378462e-07 , 3.63497422747e-06 ,
 3.32001371796e-05 , 0.000239860734151 , 0.00137204043182  , 0.00621923460515  ,
 0.0223631268922   , 0.0639223884062   , 0.14597967556     , 0.269798822451    ,
 0.416681465839    , 0.578059539122    , 0.815437114544    , 1.30847797623     ,
 2.39460058413     , 4.67691638889     , 9.21673192603     , 17.6166903839     ,
 31.662470305      , 52.3684516285     , 78.7572199949     , 107.170378224     ,
 131.92890005      , 147.457611609     , 150.779538097     , 142.641762636     ,
 126.505609021     , 106.450688276     , 85.6628463663     , 66.1212742755     ,
 48.9347408106     , 34.6619390023     , 23.4504793747     , 15.1201504542     ,
 9.26850440009     , 5.38510311605     , 2.95259275806     , 1.51954122681     ,
 0.731688415244    , 0.330477749874    , 0.140967207143    , 0.057026749223    ,
 0.0220064503051   , 0.00869027159832  , 0.00125183875913  , 0.00125259009197  ,
 0.00141780464914  , 0.00137906007633  , 0.00107942026799  , 0.000670930810555 ,
 0.000330029100318 , 0.000128271230381 , 3.93477044298e-05 , 9.51865078641e-06 ,
 1.81548019382e-06 , 2.73252020789e-07 , 3.261934326e-08   , 3.22612981574e-09 ,
 4.25102735396e-10 , 2.35318049842e-10 , 2.59206293395e-10 , 4.30512425498e-10 ,
 1.01983802909e-09 , 2.38225741974e-09 , 4.60220811586e-09 , 7.06823208233e-09 ,
 8.5839965629e-09  , 8.28940779886e-09 , 6.56055920359e-09 , 4.86782547005e-09 ,
 4.78809021722e-09 , 7.0874512831e-09  , 1.12741765862e-08 , 1.5737556189e-08  ,
 1.87254703463e-08 , 1.98409464947e-08 , 2.13389255343e-08 , 2.94481734226e-08 ,
 5.55281329462e-08 , 1.13155167395e-07 , 2.08296582059e-07 , 3.33912110788e-07 ,
 4.87124771649e-07 , 6.95669225291e-07 , 1.00900310971e-06 , 1.46109068877e-06 ,
 2.20494993659e-06 , 5.00148551611e-06 , 2.26560515209e-05 , 0.000123156891861 ,
 0.000577474356841 , 0.00218543991776  , 0.00663253971707  , 0.0162577506065   ,
 0.032745329148    , 0.0561217810217   , 0.087667661908    , 0.139583614305    ,
 0.25133607991     , 0.512361189366    , 1.09200840583     , 2.27212829468     ,
 4.4653998156      , 8.19806885031     , 14.0411723161     , 22.4650055478     ,
 33.5906501739     , 46.8987792386     , 61.0779412848     , 74.1793836744     ,
 84.0950837103     , 89.2038294377     , 88.878348716      , 83.5837325814     ,
 74.5888317432     , 63.5069889804     , 51.8479816372     , 40.7311235525     ,
 30.8355647608     , 22.491012664      , 15.7799492995     , 10.6268700295     ,
 6.87038452502     , 4.29390925334     , 2.63608368879     , 1.62359986201     ,
 1.02054553121     , 0.658066865392    , 0.431497183825    , 0.28095863313     ,
 0.174603442943    , 0.0987079164727   , 0.0486831798126   , 0.0205071429313   ,
 0.00765198516279  , 0.00340192666051  , 0.00343239836402  , 0.00582107900923  ,
 0.00942549835249  , 0.0125985778626   , 0.0134829951618   , 0.0114306919489   ,
 0.00763395358485  , 0.00400218387817  , 0.00164325057944  , 0.000527590280818 ,
 0.000132362570602 , 2.60607543582e-05 , 4.46488382782e-06 , 2.21121013183e-06 ,
 5.45164352628e-06 , 1.38825092176e-05 , 2.85032934724e-05 , 4.64434867361e-05 ,
 5.99142818275e-05 , 6.11447821716e-05 , 4.93257459972e-05 , 3.14214232455e-05 ,
 1.57864915017e-05 , 6.24868186433e-06 , 1.94962143602e-06 , 4.83847948168e-07 ,
 1.00598139674e-07 , 2.16184361322e-08 , 6.85557438252e-09 , 2.99264470173e-09 ,
 1.39358376421e-09 , 7.71325109165e-10 , 6.39655852628e-10 , 6.6088899056e-10  ,
 6.35207728856e-10 , 5.0488399495e-10  , 3.20919906472e-10 , 1.61449479896e-10 ,
 6.4017987793e-11  , 1.99967595424e-11 , 6.30253026989e-12 , 4.36391567537e-11 ,
 1.01047378619e-09 , 1.87942872114e-08 , 2.75251440811e-07 , 3.17841185055e-06 ,
 2.89789851404e-05 , 0.000208883284475 , 0.00119163074108  , 0.00538524112359  ,
 0.0193003836523   , 0.0549686420323   , 0.125044508776    , 0.230251301959    ,
 0.354973803232    , 0.494418513477    , 0.70528514564     , 1.13947623918     ,
 2.06048994711     , 3.90808227659     , 7.42250980155     , 13.6635497781     ,
 23.6823011366     , 37.8159686007     , 54.9581919652     , 72.3562377333     ,
 86.2948552807     , 93.5254228698     , 92.7065129518     , 84.8906380583     ,
 72.7074439888     , 58.9513704373     , 45.6238635642     , 33.8022765232     ,
 23.9486162013     , 16.1854144993     , 10.4133245661     , 6.36983663681     ,
 3.70122046421     , 2.03964062924     , 1.06178762074     , 0.51860881657     ,
 0.23624905296     , 0.100504968565    , 0.0403300682065   , 0.0154209730685   ,
 0.00567443484532  , 0.00219062525527  , 0.000285971245346 , 0.000301780183191 ,
 0.000349312772329 , 0.000342089496531 , 0.000268302575015 , 0.000166837674355 ,
 8.20399153942e-05 , 3.18560626771e-05 , 9.75502869433e-06 , 2.35287659464e-06 ,
 4.46534556556e-07 , 6.66395456713e-08 , 7.82415598805e-09 , 7.28506678907e-10 ,
 6.04891222604e-11 , 1.22090006859e-11 , 1.17180791911e-11 , 2.20283477451e-11 ,
 5.60169957362e-11 , 1.3325331682e-10  , 2.58395210003e-10 , 3.97100187992e-10 ,
 4.82173211122e-10 , 4.65407169511e-10 , 3.68365140748e-10 , 2.74617414305e-10 ,
 2.7411325828e-10  , 4.10613544621e-10 , 6.54811718502e-10 , 9.11770168118e-10 ,
 1.07963949154e-09 , 1.14270890983e-09 , 1.2609199919e-09  , 1.87453360965e-09 ,
 3.79995823095e-09 , 8.04027734225e-09 , 1.51365553333e-08 , 2.48860257845e-08 ,
 3.76356271763e-08 , 5.60411378361e-08 , 8.49399430738e-08 , 1.42248983221e-07 ,
 4.20135165791e-07 , 2.65430861317e-06 , 1.8765248251e-05  , 0.000111222789611 ,
 0.000527097467868 , 0.00198651748867  , 0.00596553946956  , 0.0143588343389   ,
 0.0280402116419   , 0.0455817615977   , 0.0653113472815   , 0.0928341042618   ,
 0.153275028324    , 0.307286577036    , 0.670860080893    , 1.43538694203     ,
 2.87680544395     , 5.33793807846     , 9.16826701099     , 14.6077001172     ,
 21.6206868727     , 29.7419607647     , 38.0376921792     , 45.2518684917     ,
 50.1303193872     , 51.82574473       , 50.1840099906     , 45.7391566893     ,
 39.4589508098     , 32.4172189629     , 25.517767333      , 19.3429993627     ,
 14.1570841999     , 10.0024062018     , 6.80220246143     , 4.43481213831     ,
 2.77140087697     , 1.67793565214     , 1.00896739293     , 0.621150037782    ,
 0.398892326246    , 0.267120392156    , 0.183973801296    , 0.126562355826    ,
 0.0827323252252   , 0.0484710875287   , 0.0242652935269   , 0.010103403421    ,
 0.003551861882    , 0.00134581589596  , 0.0012154935685   , 0.00214001847707  ,
 0.00360196292202  , 0.00493357146767  , 0.00536478680102  , 0.00459781369817  ,
 0.00309388178524  , 0.00163062869098  , 0.000672040782005 , 0.000216349505541 ,
 5.43886332773e-05 , 1.07286113357e-05 , 1.78234045187e-06 , 5.46982753818e-07 ,
 9.17237247176e-07 , 2.15762221782e-06 , 4.34157013133e-06 , 7.03560160143e-06 ,
 9.06287516535e-06 , 9.2453500698e-06  , 7.45745890538e-06 , 4.75034580534e-06 ,
 2.38644789359e-06 , 9.44272816142e-07 , 2.94059096911e-07 , 7.22523768716e-08 ,
 1.4283441606e-08  , 2.5085363267e-09  , 5.34877007524e-10 , 1.78465969974e-10 ,
 7.46270511985e-11 , 3.76149203231e-11 , 2.8797527811e-11  , 2.89339620761e-11 ,
 2.76646295538e-11 , 2.19737591761e-11 , 1.39672042877e-11 , 7.02719253246e-12 ,
 2.78706290682e-12 , 8.9447018194e-13  , 1.19740509405e-12 , 2.97172913097e-11 ,
 7.017775861e-10   , 1.30400971679e-08 , 1.90686091753e-07 , 2.19773803233e-06 ,
 1.99936848965e-05 , 0.000143763471184 , 0.000817970695439 , 0.00368636211525  ,
 0.0131750072847   , 0.0374293394355   , 0.0850291859153   , 0.156930490255    ,
 0.244968596658    , 0.352842189293    , 0.53203666379     , 0.90124913768     ,
 1.6473481291      , 3.05559367471     , 5.57768506039     , 9.81916268545     ,
 16.2899314602     , 24.9485303524     , 34.8371648197     , 44.1440345948     ,
 50.7700375099     , 53.1566086032     , 50.9480157061     , 45.0861746276     ,
 37.2597060419     , 29.1012501507     , 21.6739946357     , 15.4424978451     ,
 10.5057180645     , 6.79908248776     , 4.17534080517     , 2.43179273619     ,
 1.34392926101     , 0.704462250057    , 0.348887192646    , 0.161869532208    ,
 0.0697013897547   , 0.0278132779749   , 0.0104095393728   , 0.00372310143473  ,
 0.00129669107265  , 0.000485382163718 , 5.40565853596e-05 , 5.79380288543e-05 ,
 6.76490913451e-05 , 6.64445504379e-05 , 5.21610224988e-05 , 3.24423932618e-05 ,
 1.59515459415e-05 , 6.19188256812e-06 , 1.89488131e-06    , 4.56537983615e-07 ,
 8.64835048802e-08 , 1.28665017912e-08 , 1.50222888331e-09 , 1.37758603736e-10 ,
 1.01377470416e-11 , 8.60662759585e-13 , 4.42925004093e-13 , 9.0089715778e-13  ,
 2.41617894356e-12 , 5.82029450618e-12 , 1.13144513117e-11 , 1.73951788877e-11 ,
 2.11206355805e-11 , 2.03856484243e-11 , 1.61573997571e-11 , 1.21486745718e-11 ,
 1.23761919671e-11 , 1.87997275972e-11 , 3.00430636818e-11 , 4.1698734355e-11  ,
 4.91158275923e-11 , 5.19797196476e-11 , 5.91662143497e-11 , 9.50551702551e-11 ,
 2.05606756251e-10 , 4.49203010355e-10 , 8.64464863698e-10 , 1.46206722283e-09 ,
 2.30307262341e-09 , 3.6236119055e-09  , 6.51864261177e-09 , 2.37327682122e-08 ,
 1.9966917284e-07  , 1.81181644167e-06 , 1.35817361516e-05 , 8.1082053956e-05  ,
 0.000383851212325 , 0.00144132079166  , 0.0043008190852   , 0.0102427477321   ,
 0.0196475045217   , 0.0309715913351   , 0.0421444465761   , 0.0557489876001   ,
 0.0871040592642   , 0.174317019985    , 0.39038322337     , 0.855109312102    ,
 1.7387170527      , 3.24362081501     , 5.55262675173     , 8.74629399484     ,
 12.7159059708     , 17.1140824862     , 21.374961075      , 24.8131856029     ,
 26.799279561      , 26.9725155655     , 25.3776639043     , 22.4251098224     ,
 18.7145249495     , 14.8425354831     , 11.2647430299     , 8.23475642999     ,
 5.82359889522     , 3.98679572188     , 2.63295420797     , 1.66945482044     ,
 1.01848355929     , 0.609858142073    , 0.372255599872    , 0.239042628049    ,
 0.16135274228     , 0.112239222919    , 0.0792896284701   , 0.0556857575511   ,
 0.0370591736478   , 0.0219707173911   , 0.0110312750996   , 0.00455322716375  ,
 0.00154659658864  , 0.000512331749852 , 0.000374560236351 , 0.000643583656834 ,
 0.00110528515301  , 0.00153736426226  , 0.00168897987919  , 0.00145762211538  ,
 0.000985558018767 , 0.000521192129553 , 0.000215350895993 , 6.95677388333e-05 ,
 1.78072924712e-05 , 4.07582566089e-06 , 1.48881810087e-06 , 1.19680157101e-06 ,
 1.09872317022e-06 , 9.53036195469e-07 , 8.99934357693e-07 , 9.99568046306e-07 ,
 1.12809343834e-06 , 1.10744242993e-06 , 8.8401943734e-07  , 5.61554027579e-07 ,
 2.81896360544e-07 , 1.11504557576e-07 , 3.46975711972e-08 , 8.49326265286e-09 ,
 1.64610471124e-09 , 2.62909824671e-10 , 4.13134741983e-11 , 9.34281545948e-12 ,
 3.22961722659e-12 , 1.45957620086e-12 , 1.02075335635e-12 , 9.90642114526e-13 ,
 9.40724624647e-13 , 7.46463489272e-13 , 4.7443401312e-13  , 2.38705060172e-13 ,
 9.49277061971e-14 , 4.36076322978e-14 , 5.4880273195e-13  , 1.63084714498e-11 ,
 3.85184915414e-10 , 7.14739159142e-09 , 1.04343338475e-07 , 1.20030082531e-06 ,
 1.08961764036e-05 , 7.8164958858e-05  , 0.000443635865282 , 0.00199437424882  ,
 0.0071119460212   , 0.0201785978774   , 0.0459150794782   , 0.0855870197261   ,
 0.137761441844    , 0.212365815742    , 0.352357848278    , 0.642426294888    ,
 1.20194122012     , 2.19225064139     , 3.84708556874     , 6.45521457678     ,
 10.2047547584     , 14.9291549212     , 19.9586685533     , 24.2580010039     ,
 26.8107715372     , 27.0305107838     , 24.9838231631     , 21.3250470959     ,
 16.9812618915     , 12.7677448788     , 9.15705540433     , 6.29048683013     ,
 4.12715641033     , 2.57064814744     , 1.51383611145     , 0.842787299617    ,
 0.444539823481    , 0.222317431489    , 0.104961117314    , 0.0462909085324   ,
 0.01882862737     , 0.00702457894591  , 0.00243155523973  , 0.000802173491481 ,
 0.000260494155995 , 9.27740348479e-05 , 8.31879088757e-06 , 8.78726452591e-06 ,
 1.02612528089e-05 , 1.00868619283e-05 , 7.92141271487e-06 , 4.92739232965e-06 ,
 2.42268802282e-06 , 9.40298255138e-07 , 2.87689261219e-07 , 6.92856577668e-08 ,
 1.31161068075e-08 , 1.94911659693e-09 , 2.27122527399e-10 , 2.07389203138e-11 ,
 1.48857645578e-12 , 9.08696255851e-14 , 1.57354840532e-14 , 2.92750705232e-14 ,
 8.15786023091e-14 , 1.98304244944e-13 , 3.86182653904e-13 , 5.93914320047e-13 ,
 7.21133220221e-13 , 6.96247984435e-13 , 5.53239151268e-13 , 4.21121142234e-13 ,
 4.40418258593e-13 , 6.79997519342e-13 , 1.088878118e-12   , 1.50569520146e-12 ,
 1.76338096286e-12 , 1.86760668361e-12 , 2.20344426473e-12 , 3.82798966465e-12 ,
 8.76819090484e-12 , 1.97033968122e-11 , 3.87955771144e-11 , 6.77862432033e-11 ,
 1.12645720643e-10 , 2.11420434122e-10 , 8.82232145436e-10 , 9.50446176055e-09 ,
 1.09825341754e-07 , 1.04099650955e-06 , 7.84380736595e-06 , 4.6824451419e-05  ,
 0.000221387146099 , 0.000829367888119 , 0.00246528232612  , 0.00583400365596  ,
 0.0110737751618   , 0.0171616901526   , 0.0227688198012   , 0.0293291190936   ,
 0.0457325239971   , 0.0941190334615   , 0.217025379026    , 0.484483453535    ,
 0.994534833117    , 1.85579034677     , 3.14580162182     , 4.85919706533     ,
 6.87690959853     , 8.97562556838     , 10.8653552003     , 12.2386703434     ,
 12.8404229443     , 12.5570495991     , 11.4709844723     , 9.82688812532     ,
 7.93486621105     , 6.07650448158     , 4.44664432902     , 3.13492041844     ,
 2.14350980903     , 1.42489668419     , 0.91823621882     , 0.571719092912    ,
 0.347397171839    , 0.213830655087    , 0.139813795931    , 0.0975287556007   ,
 0.0693330443008   , 0.0484433772637   , 0.0333230663117   , 0.0226880697373   ,
 0.0147889192862   , 0.00866679773485  , 0.00431530348206  , 0.00176335140472  ,
 0.000586209335797 , 0.000176228797043 , 9.90983353237e-05 , 0.00015613876574  ,
 0.00026959644142  , 0.000378454451529 , 0.000418473391935 , 0.000362740807435 ,
 0.00024602034122  , 0.000130460385598 , 5.43214031911e-05 , 1.86118512976e-05 ,
 7.2931174956e-06  , 6.36027603946e-06 , 8.25132648777e-06 , 9.38810832485e-06 ,
 8.47115703596e-06 , 6.00757252643e-06 , 3.36682743991e-06 , 1.52278437824e-06 ,
 5.94188267291e-07 , 2.34390472967e-07 , 1.09663119336e-07 , 5.65066859596e-08 ,
 2.6618267508e-08  , 1.03456356639e-08 , 3.20338787028e-09 , 7.82039387673e-10 ,
 1.50385474177e-10 , 2.30998104057e-11 , 3.06581223534e-12 , 4.67763194371e-13 ,
 1.17000981111e-13 , 4.53013207961e-14 , 2.85111110399e-14 , 2.65088861916e-14 ,
 2.49536901688e-14 , 1.97756098669e-14 , 1.25677848673e-14 , 6.3237125669e-15  ,
 2.62460309401e-15 , 6.90944068568e-15 , 2.35505256881e-13 , 7.07866005936e-12 ,
 1.67008231752e-10 , 3.0946755081e-09  , 4.51054278236e-08 , 5.17903711251e-07 ,
 4.69174282811e-06 , 3.35814297268e-05 , 0.000190154706975 , 0.000852974924862 ,
 0.00303701957239  , 0.00862138391226  , 0.0197468136593   , 0.0376676448331   ,
 0.0644170070881   , 0.11128968661     , 0.210384584317    , 0.416879667614    ,
 0.798773759322    , 1.43184299523     , 2.41064894593     , 3.84072615635     ,
 5.76155228833     , 8.02574321659     , 10.2514881872     , 11.9338932677     ,
 12.6583038199     , 12.2718015262     , 10.9232118789     , 8.98080486026     ,
 6.88132762171     , 4.97471358906     , 3.43592503434     , 2.28146861934     ,
 1.45079849224     , 0.874796434144    , 0.496341500909    , 0.264843116857    ,
 0.133506018393    , 0.0637679599624   , 0.0287276416837   , 0.0120487910854   ,
 0.00462870471998  , 0.00161273861682  , 0.000513668501891 , 0.000154238192235 ,
 4.57625275434e-05 , 1.50911541817e-05 , 1.03552058033e-06 , 1.04875230799e-06 ,
 1.2168808614e-06  , 1.19559649967e-06 , 9.38977306311e-07 , 5.84100365306e-07 ,
 2.87188098582e-07 , 1.11459387845e-07 , 3.40987038788e-08 , 8.21094615988e-09 ,
 1.55398312677e-09 , 2.30832903782e-10 , 2.6879002631e-11  , 2.45105992306e-12 ,
 1.74984701968e-13 , 9.90256154549e-15 , 6.88889923443e-16 , 7.47506895046e-16 ,
 2.14565312765e-15 , 5.26358632301e-15 , 1.0268444161e-14  , 1.57961982116e-14 ,
 1.91796361309e-14 , 1.85245437817e-14 , 1.47681440969e-14 , 1.1419927146e-14  ,
 1.23348274452e-14 , 1.94135078794e-14 , 3.11652162262e-14 , 4.29262050533e-14 ,
 4.99683528066e-14 , 5.30010909425e-14 , 6.50754586333e-14 , 1.22063611133e-13 ,
 2.94019091254e-13 , 6.78008364225e-13 , 1.36902809049e-12 , 2.49694076048e-12 ,
 4.85076593923e-12 , 2.14049442767e-11 , 2.84875381862e-10 , 4.17324864076e-09 ,
 5.00345028661e-08 , 4.76454458642e-07 , 3.59421969789e-06 , 2.14754697832e-05 ,
 0.000101641946753 , 0.000381232410552 , 0.00113466803785  , 0.00268835269468  ,
 0.00510723993284  , 0.00792102120528  , 0.0105506681076   , 0.0138567957357   ,
 0.0226190003783   , 0.0487766863289   , 0.115581807697    , 0.261582414248    ,
 0.53952087143     , 1.0020120327      , 1.67211493355     , 2.51494110553     ,
 3.43584816509     , 4.30933968445     , 5.01193971675     , 5.43847761392     ,
 5.51550111758     , 5.22691634848     , 4.63153500953     , 3.8464229319      ,
 3.00576270807     , 2.22285931665     , 1.56846708858     , 1.06668854175     ,
 0.705941643696    , 0.457062635346    , 0.28934737095     , 0.179433377331    ,
 0.111835280653    , 0.074236465292    , 0.0542450330449   , 0.0413190783783   ,
 0.0301565461981   , 0.0203715921452   , 0.0130359558893   , 0.00821051282757  ,
 0.00505680254446  , 0.00286912918933  , 0.00140326177355  , 0.00056633522606  ,
 0.000185327601142 , 5.21744891757e-05 , 2.24597294736e-05 , 3.03374442864e-05 ,
 5.19179421294e-05 , 7.32364739414e-05 , 8.13056315569e-05 , 7.06870652207e-05 ,
 4.81418464829e-05 , 2.61233399045e-05 , 1.31178709015e-05 , 1.13724286678e-05 ,
 2.01367768767e-05 , 3.65988038628e-05 , 5.38036991117e-05 , 6.20649669352e-05 ,
 5.60431384967e-05 , 3.96422641506e-05 , 2.19935530504e-05 , 9.58564044472e-06 ,
 3.289588188e-06   , 8.9311492576e-07  , 1.94421245403e-07 , 3.54249910768e-08 ,
 6.08267300147e-09 , 1.18234328079e-09 , 2.66847080755e-10 , 5.86173412999e-11 ,
 1.09056240915e-11 , 1.63649494104e-12 , 2.01001270331e-13 , 2.33214831672e-14 ,
 3.80591742888e-15 , 1.13730997925e-15 , 6.22589510542e-16 , 5.47133177932e-16 ,
 5.08922794255e-16 , 4.02552759629e-16 , 2.55753371703e-16 , 1.28677561895e-16 ,
 9.12646067435e-17 , 2.1217687572e-15  , 8.08135927983e-14 , 2.4286014042e-12  ,
 5.72336578796e-11 , 1.0591101435e-09  , 1.54123118219e-08 , 1.76645284245e-07 ,
 1.59702772467e-06 , 1.14062177696e-05 , 6.44495235972e-05 , 0.000288599180639 ,
 0.00102729728441  , 0.00292884262731  , 0.00682656757934  , 0.0137083605633   ,
 0.0263266927601   , 0.054069822787    , 0.118687111615    , 0.253367757471    ,
 0.49194998813     , 0.859470318014    , 1.37661772148     , 2.06378638023     ,
 2.91405063125     , 3.843411014       , 4.6773823103      , 5.21187500281     ,
 5.30913764469     , 4.9556132208      , 4.25333010656     , 3.37079086042     ,
 2.48432468877     , 1.72463809905     , 1.14624791153     , 0.737078558513    ,
 0.456614523771    , 0.268217041013    , 0.147262968337    , 0.0753521973576   ,
 0.036202947528    , 0.0164594406285   , 0.00706174409293  , 0.00281574806478  ,
 0.00102240483402  , 0.000333145437975 , 9.76203879131e-05 , 2.64689107177e-05 ,
 7.03077138595e-06 , 2.07928618392e-06 , 1.04454282427e-07 , 9.83884434923e-08 ,
 1.1272200891e-07  , 1.10578040854e-07 , 8.68306503283e-08 , 5.40137263178e-08 ,
 2.65572170954e-08 , 1.03068660739e-08 , 3.15307684428e-09 , 7.59217658717e-10 ,
 1.43674431494e-10 , 2.13385155351e-11 , 2.48409303036e-12 , 2.26417653355e-13 ,
 1.61433792651e-14 , 9.00355453065e-16 , 4.25616081736e-17 , 1.50516388704e-17 ,
 4.35764718295e-17 , 1.08401635836e-16 , 2.12008508276e-16 , 3.26287983337e-16 ,
 3.96272346095e-16 , 3.83107975863e-16 , 3.0697485218e-16  , 2.42314930228e-16 ,
 2.7172439625e-16  , 4.36127098834e-16 , 7.00974275705e-16 , 9.59952998838e-16 ,
 1.10796494027e-15 , 1.17508794953e-15 , 1.50725268198e-15 , 3.05722953893e-15 ,
 7.7233478764e-15  , 1.82863633279e-14 , 3.81384738936e-14 , 7.84250041733e-14 ,
 3.40441268751e-13 , 5.37947871384e-12 , 9.97681538625e-11 , 1.51760812504e-09 ,
 1.83463171957e-08 , 1.75997556233e-07 , 1.34097866128e-06 , 8.12453807838e-06 ,
 3.91995793483e-05 , 0.000150943203266 , 0.000465434871621 , 0.0011553670406   ,
 0.00232917910575  , 0.00387883510106  , 0.00556303216637  , 0.00766136980453  ,
 0.0123418215451   , 0.0256460321101   , 0.0598105612818   , 0.134947434232    ,
 0.277158830697    , 0.508723776887    , 0.830672437143    , 1.20968592747     ,
 1.58533664135     , 1.89602962632     , 2.10033270759     , 2.17803519863     ,
 2.12304613123     , 1.94462017736     , 1.67200197717     , 1.34985513143     ,
 1.02537411396     , 0.736009447571    , 0.50283100875     , 0.330359379228    ,
 0.211291507383    , 0.132938445001    , 0.0827945177671   , 0.0517335178549   ,
 0.0340128187592   , 0.0251527606183   , 0.0206004975522   , 0.0167144796915   ,
 0.0122280737587   , 0.0078619243207   , 0.00459131711534  , 0.00259241724619  ,
 0.00145908677908  , 0.000783982698875 , 0.000372726025933 , 0.000148060071213 ,
 4.77937311912e-05 , 1.28798603599e-05 , 4.37152541093e-06 , 4.71608140273e-06 ,
 7.86087943186e-06 , 1.11057571767e-05 , 1.23689291237e-05 , 1.08588829528e-05 ,
 7.97411975026e-06 , 7.23046220814e-06 , 1.49094049276e-05 , 4.17742359014e-05 ,
 9.99863889113e-05 , 0.000188720596373 , 0.000278552477282 , 0.000321456037112 ,
 0.000290277078901 , 0.000205323079026 , 0.000113900802926 , 4.96217336164e-05 ,
 1.70024448624e-05 , 4.58889361067e-06 , 9.77101260534e-07 , 1.64424987585e-07 ,
 2.19295670759e-08 , 2.33567005558e-09 , 2.03667200172e-10 , 1.56943738311e-11 ,
 1.25555449872e-12 , 1.17606273489e-13 , 1.17207114907e-14 , 1.11454399838e-15 ,
 1.17092053482e-16 , 1.85346165005e-17 , 3.75210250793e-18 , 6.93091276938e-19 ,
 1.0340523869e-19  , 1.21349432903e-20 , 1.11396028865e-21 , 7.99820461738e-23 ,
 1.09692241648e-17 , 5.72431281517e-16 , 2.19496595144e-14 , 6.5905071381e-13  ,
 1.55141851189e-11 , 2.86708511238e-10 , 4.16572836037e-09 , 4.765985054e-08   ,
 4.30041877565e-07 , 3.0651872523e-06  , 1.72884968508e-05 , 7.73653810829e-05 ,
 0.000276243556424 , 0.00079907893912  , 0.00195053729818  , 0.00440144953037  ,
 0.0103869267525   , 0.0265015158223   , 0.0664903980121   , 0.149150060409    ,
 0.288663731988    , 0.485418999304    , 0.729709035068    , 1.01306103176     ,
 1.32530348479     , 1.63507483057     , 1.8825603432      , 2.00312310015     ,
 1.96204054296     , 1.76955942869     , 1.47099522631     , 1.12796774022     ,
 0.801126131447    , 0.533814114349    , 0.340981377968    , 0.21255012312     ,
 0.128889251223    , 0.0742410540315   , 0.0396248772018   , 0.0194305505953   ,
 0.00883978586575  , 0.00379041303823  , 0.00153784049065  , 0.00058140214461  ,
 0.000199740934646 , 6.10814386932e-05 , 1.65416356001e-05 , 4.05070233893e-06 ,
 9.49924989053e-07 , 2.43972850369e-07 , 8.63001957146e-09 , 7.2636409102e-09  ,
 8.15285638044e-09 , 7.97677073887e-09 , 6.26166823365e-09 , 3.8949842433e-09  ,
 1.915059997e-09   , 7.43231684912e-10 , 2.27366958764e-10 , 5.4745758401e-11  ,
 1.03597435726e-11 , 1.53854156842e-12 , 1.79090362818e-13 , 1.63210179878e-14 ,
 1.16336853486e-15 , 6.48096429454e-17 , 2.81996795072e-18 , 9.57929397965e-20 ,
 2.54063729806e-21 , 6.4659135446e-23  , 1.43989648548e-22 , 1.24936436005e-21 ,
 8.5136778626e-21  , 4.56278599847e-20 , 1.9260848357e-19  , 6.41318641596e-19 ,
 1.68644958958e-18 , 3.50612269676e-18 , 5.76993492863e-18 , 7.55490764206e-18 ,
 8.15608796991e-18 , 8.96274932094e-18 , 1.69353433098e-17 , 5.12459703428e-17 ,
 1.51558093798e-16 , 3.80927968336e-16 , 8.7178449872e-16  , 3.60696609573e-15 ,
 6.49929365822e-14 , 1.53890921337e-12 , 3.02114519368e-11 , 4.74994063245e-10 ,
 5.99009904093e-09 , 6.08472543516e-08 , 4.99963926354e-07 , 3.33517294035e-06 ,
 1.81124017919e-05 , 8.02043547946e-05 , 0.000289680468773 , 0.000852709810483 ,
 0.00204329891919  , 0.00398745128472  , 0.00638898919729  , 0.00870422097016  ,
 0.0112415413971   , 0.0168648125856   , 0.0322553711176   , 0.067810603281    ,
 0.135334644121    , 0.242369644198    , 0.383990523966    , 0.538250977474    ,
 0.673110421882    , 0.762630391528    , 0.798017076589    , 0.784255861137    ,
 0.730527941648    , 0.646304314845    , 0.542767597702    , 0.432812764005    ,
 0.328070556859    , 0.236232199078    , 0.161005147833    , 0.103598094917    ,
 0.0633577483962   , 0.0375836590962   , 0.02227959722     , 0.0137843193502   ,
 0.00959059498903  , 0.00789016855813  , 0.00705918975103  , 0.00594226391988  ,
 0.00431544606618  , 0.00265173739479  , 0.00142102798817  , 0.000711611267777 ,
 0.000355780568138 , 0.000176315166714 , 8.0312765588e-05  , 3.12239281405e-05 ,
 9.93936151652e-06 , 2.59976973835e-06 , 7.30317917821e-07 , 5.8989496631e-07  ,
 9.34085265881e-07 , 1.32108906777e-06 , 1.51532975015e-06 , 1.68477770995e-06 ,
 3.52846670089e-06 , 1.40200731505e-05 , 5.4110231623e-05  , 0.000167317364685 ,
 0.000404858263183 , 0.000765027278386 , 0.00112931781543  , 0.00130327503151  ,
 0.00117686798139  , 0.000832439517134 , 0.000461786455175 , 0.000201179804133 ,
 6.89312947646e-05 , 1.86030894161e-05 , 3.96014032279e-06 , 6.65789798039e-07 ,
 8.84882845199e-08 , 9.30310027049e-09 , 7.73967764806e-10 , 5.09867898772e-11 ,
 2.66767863159e-12 , 1.12228075351e-13 , 3.96210169663e-15 , 1.31528869007e-16 ,
 4.58495817693e-18 , 1.70837055759e-19 , 7.45521005011e-21 , 2.53748250757e-22 ,
 6.73403952341e-24 , 1.37705574861e-25 , 5.55100396096e-29 , 2.74054901661e-27 ,
 2.36676649129e-18 , 1.23156119885e-16 , 4.71885048156e-15 , 1.41557323985e-13 ,
 3.32862276261e-12 , 6.14337683583e-11 , 8.91235410003e-10 , 1.01788976243e-08 ,
 9.16754911637e-08 , 6.52313838491e-07 , 3.67643061459e-06 , 1.64956742698e-05 ,
 5.97040200377e-05 , 0.000180727218464 , 0.000498530967132 , 0.00142569585465  ,
 0.00444453340921  , 0.0137221938288   , 0.0374977173808   , 0.0859960605532   ,
 0.163934587573    , 0.263523193141    , 0.368253174194    , 0.465515489739    ,
 0.551594669131    , 0.622850590189    , 0.668034506705    , 0.673554910328    ,
 0.63383481102     , 0.554680438349    , 0.449638406608    , 0.33587397879     ,
 0.230927880249    , 0.147855639171    , 0.0906389717441   , 0.0547475227852   ,
 0.0326103011443   , 0.0185348042503   , 0.00967044086982  , 0.00454928471731  ,
 0.0019470752323   , 0.000777111764013 , 0.000294161539921 , 0.000104648420042 ,
 3.39924037992e-05 , 9.79779226312e-06 , 2.47121358237e-06 , 5.50857926221e-07 ,
 1.13787277639e-07 , 2.47547618987e-08 , 5.97442764167e-10 , 4.23713265437e-10 ,
 4.6042478254e-10  , 4.48681757463e-10 , 3.52031718475e-10 , 2.18962344265e-10 ,
 1.07657084896e-10 , 4.178143422e-11   , 1.27815854253e-11 , 3.0775469392e-12  ,
 5.82368399112e-13 , 8.64866281066e-14 , 1.00669261197e-14 , 9.1737508415e-16  ,
 6.53846336963e-17 , 3.64191423653e-18 , 1.58424175856e-19 , 5.37928300958e-21 ,
 1.42517865961e-22 , 2.89460708682e-24 , 1.32842847179e-28 , 2.73350965709e-30 ,
 0, 0, 0, 7.44315557587e-31 , 3.75969783501e-29 , 1.4292954961e-27  ,
 4.24657385114e-26 , 9.86838528677e-25 , 1.79555105093e-23 , 2.56107137918e-22 ,
 2.86773407951e-21 , 2.52509733105e-20 , 1.75188154025e-19 , 1.15273860437e-18 ,
 1.53388984446e-17 , 5.30621927444e-16 , 1.746498282e-14   , 4.76675521837e-13 ,
 1.0669833334e-11  , 1.96116403542e-10 , 2.95676966074e-09 , 3.64066915719e-08 ,
 3.63846532779e-07 , 2.93260867449e-06 , 1.89590067708e-05 , 9.79106591753e-05 ,
 0.0004028222057   , 0.00131813166077  , 0.00342787084626  , 0.00708520884715  ,
 0.0116643077814   , 0.015435256629    , 0.0170040803931   , 0.017519608648    ,
 0.0214587426808   , 0.0350801999801   , 0.0636809912974   , 0.108730170151    ,
 0.165281332369    , 0.22144416518     , 0.26274006237     , 0.28008924177     ,
 0.2743778862      , 0.253152620735    , 0.224199424185    , 0.192796619162    ,
 0.162559559469    , 0.135785462072    , 0.112316947073    , 0.0897326581566   ,
 0.0663333189666   , 0.0437026796713   , 0.0253337116536   , 0.0132173512173   ,
 0.00663684537989  , 0.00361512386742  , 0.00247200227707  , 0.0021674362111   ,
 0.00204972132779  , 0.00175989726678  , 0.00126769022967  , 0.000753183669402 ,
 0.00037727040648  , 0.000169222193645 , 7.39984732577e-05 , 3.28565771138e-05 ,
 1.40447953672e-05 , 5.29366291545e-06 , 1.65735342559e-06 , 4.24045674061e-07 ,
 1.03863853193e-07 , 6.01973033433e-08 , 8.80285817458e-08 , 1.36177920249e-07 ,
 2.89632241855e-07 , 1.40921030508e-06 , 8.52565504667e-06 , 4.31156664199e-05 ,
 0.000171317364631 , 0.00053137705114  , 0.00128618858709  , 0.00243048603433  ,
 0.00358784689847  , 0.0041405111168   , 0.00373891543972  , 0.00264466449391  ,
 0.0014670978507   , 0.000639149201104 , 0.000218995013354 , 5.91020522202e-05 ,
 1.2581340541e-05  , 2.11518881141e-06 , 2.81113301874e-07 , 2.95502913809e-08 ,
 2.4571249487e-09  , 1.61551887e-10    , 8.39222821594e-12 , 3.44100297096e-13 ,
 1.11268216955e-14 , 2.83876842093e-16 , 4.96645015905e-18 , 5.82627897047e-21 ,
 2.54254753704e-22 , 8.65390761166e-24 , 2.29659734461e-25 , 4.69635285721e-27 ,
 1.1146675514e-30  , 5.50315057117e-29 , 4.04333178258e-19 , 2.0980990582e-17  ,
 8.03322047368e-16 , 2.40768438508e-14 , 5.65540482719e-13 , 1.04244269427e-11 ,
 1.51006518989e-10 , 1.72187677806e-09 , 1.54844721971e-08 , 1.10109694688e-07 ,
 6.22294124363e-07 , 2.83161056057e-06 , 1.07541594342e-05 , 3.72147900857e-05 ,
 0.000134326818026 , 0.000532890116369 , 0.00209268438449  , 0.00720712194374  ,
 0.0205083407192   , 0.0473541908511   , 0.0888408391941   , 0.13724544789     ,
 0.179109275253    , 0.205214568089    , 0.216080648635    , 0.217032861755    ,
 0.211116404809    , 0.19822478468     , 0.178053926186    , 0.151551277161    ,
 0.120692168072    , 0.088572353653    , 0.0593337606004   , 0.0365939733097   ,
 0.0214894546047   , 0.0125400257349   , 0.0073390900737   , 0.00413351063248  ,
 0.00212131744713  , 0.000962353707537 , 0.000387239083093 , 0.000142336935309 ,
 4.94014708345e-05 , 1.63006104673e-05 , 4.97873729302e-06 , 1.35624368832e-06 ,
 3.21356788978e-07 , 6.60536790706e-08 , 1.21463546164e-08 , 2.2199525295e-09  ,
 3.59992251782e-11 , 1.9721783712e-11  , 2.03142460721e-11 , 1.96756720272e-11 ,
 1.54260327203e-11 , 9.59401329587e-12 , 4.71702176304e-12 , 1.83065893884e-12 ,
 5.60025410712e-13 , 1.34842209928e-13 , 2.55161925058e-14 , 3.78932485337e-15 ,
 4.41063500098e-16 , 4.01917455845e-17 , 2.86445458729e-18 , 1.59535304859e-19 ,
 6.93879183478e-21 , 2.35548301683e-22 , 6.23804641085e-24 , 1.26609168768e-25 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.79419290652e-31 ,
 3.44591145068e-20 , 1.99735280705e-18 , 2.09106277065e-16 , 8.93439296103e-15 ,
 3.05593046693e-13 , 8.42442192789e-12 , 1.85613749284e-10 , 3.24794283795e-09 ,
 4.49474107635e-08 , 4.90719728085e-07 , 4.22189675061e-06 , 2.86187506173e-05 ,
 0.000152918744492 , 0.000644612086421 , 0.00214582222391  , 0.00564640225584  ,
 0.0117549831841   , 0.0193821456211   , 0.0253765510278   , 0.0266447839388   ,
 0.0233470655976   , 0.0195870890268   , 0.0206324771709   , 0.0295854596172   ,
 0.0460251184086   , 0.0662761383357   , 0.0844507993515   , 0.0947354516498   ,
 0.094600964128    , 0.08618856257     , 0.0741605013108   , 0.0625389897882   ,
 0.0537375408378   , 0.0491656144352   , 0.0488296562222   , 0.0500001891636   ,
 0.0479615755914   , 0.0398427631367   , 0.0274713473949   , 0.0154939316127   ,
 0.0072106058575   , 0.00289743441359  , 0.00115494258496  , 0.000615652217173 ,
 0.000507871454211 , 0.000486962406298 , 0.000421620639182 , 0.000301766912519 ,
 0.000175318144078 , 8.37810005357e-05 , 3.44423508666e-05 , 1.32243905435e-05 ,
 5.13766217692e-06 , 2.00602963627e-06 , 7.22033986421e-07 , 2.21071678966e-07 ,
 5.5507589305e-08  , 1.23970046883e-08 , 5.24347097373e-09 , 8.94176844769e-09 ,
 4.43834264788e-08 , 3.93061940123e-07 , 3.2259251132e-06  , 2.10566858834e-05 ,
 0.000107371241591 , 0.000427002286862 , 0.0013245575124   , 0.00320609778518  ,
 0.00605850775326  , 0.00894347885945  , 0.0103211132134   , 0.00932004974794  ,
 0.00659239425152  , 0.00365705648427  , 0.00159321665421  , 0.000545892103399 ,
 0.000147324557152 , 3.13616922168e-05 , 5.27256162839e-06 , 7.00734894393e-07 ,
 7.36602951924e-08 , 6.12486417032e-09 , 4.02691177216e-10 , 2.09172101161e-11 ,
 8.57410755167e-13 , 2.76969010962e-14 , 7.04038321302e-16 , 1.21230426015e-17 ,
 1.54861536028e-22 , 6.75804950302e-24 , 2.30019439881e-25 , 6.10431793989e-27 ,
 1.24828285923e-28 , 0, 0, 5.46972670555e-20 , 2.8306414604e-18  ,
 1.08303704324e-16 , 3.24324694751e-15 , 7.61011762834e-14 , 1.40106437865e-12 ,
 2.02685508733e-11 , 2.30829643823e-10 , 2.07510967088e-09 , 1.48041089426e-08 ,
 8.49735119868e-08 , 4.07901542527e-07 , 1.80060621234e-06 , 8.42842394875e-06 ,
 4.36733709096e-05 , 0.000222276157362 , 0.000981646227876 , 0.00354773311052  ,
 0.0102882270668   , 0.0238431658019   , 0.0443027437199   , 0.0666331401135   ,
 0.082609806466    , 0.0870269523634   , 0.0814225660127   , 0.0712220355289   ,
 0.0607542940027   , 0.0515530325415   , 0.0434811004323   , 0.0359009334072   ,
 0.028251059075    , 0.0205380254509   , 0.0134987488647   , 0.00804461167701  ,
 0.00451331983101  , 0.00252705897008  , 0.0014457675777   , 0.00080698203794  ,
 0.000409407198587 , 0.000180636763736 , 6.88881548289e-05 , 2.33150935187e-05 ,
 7.32082224201e-06 , 2.19781013005e-06 , 6.23203918079e-07 , 1.60110198988e-07 ,
 3.58825906797e-08 , 6.89800635572e-09 , 1.15157106791e-09 , 1.79346268811e-10 ,
 1.9801486223e-12  , 7.48910462396e-13 , 7.0138727576e-13  , 6.72631429378e-13 ,
 5.26789050068e-13 , 3.27585704661e-13 , 1.61058997656e-13 , 6.25062832554e-14 ,
 1.91215865798e-14 , 4.60407174085e-15 , 8.71228574789e-16 , 1.29383260029e-16 ,
 1.50597365949e-17 , 1.37231284125e-18 , 9.7804356736e-20  , 5.44719680865e-21 ,
 2.36919124534e-22 , 8.04259571037e-24 , 2.12992770258e-25 , 4.3229620012e-27  ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4.86795832002e-21 ,
 2.82161348632e-19 , 1.86129679001e-16 , 9.06284003937e-15 , 3.38615631937e-13 ,
 9.92657079506e-12 , 2.28051988634e-10 , 4.10440762349e-09 , 5.78813521013e-08 ,
 6.39990631583e-07 , 5.55355880839e-06 , 3.78662631988e-05 , 0.000203144708304 ,
 0.000858708633022 , 0.00286395903933  , 0.00754550794704  , 0.0157186716428   ,
 0.0259085223011   , 0.033815776756    , 0.0350468314248   , 0.0292034442852   ,
 0.0206206813222   , 0.0147248781107   , 0.0142031381169   , 0.0183361715513   ,
 0.0245190125694   , 0.029792533309    , 0.0319672644363   , 0.0305675330968   ,
 0.0268770447233   , 0.0227166196772   , 0.0193429448529   , 0.0176827945384   ,
 0.0188129958957   , 0.0230000965172   , 0.028094684466    , 0.0301011082933   ,
 0.0265020777626   , 0.0186993557583   , 0.0104949751327   , 0.00469383255001  ,
 0.00169701289746  , 0.0005265009126   , 0.000179146505448 , 0.000105543435976 ,
 9.3690065743e-05  , 8.05027096139e-05 , 5.72977586133e-05 , 3.28198076699e-05 ,
 1.52145837563e-05 , 5.88150964764e-06 , 2.02496249449e-06 , 6.82765291728e-07 ,
 2.3666727489e-07  , 7.95823816637e-08 , 2.35923291974e-08 , 5.80959113037e-09 ,
 1.23247512815e-09 , 6.5161101376e-10  , 5.4072154148e-09  , 7.01704251166e-08 ,
 7.51160408841e-07 , 6.30185551802e-06 , 4.12295348461e-05 , 0.00021028634766  ,
 0.00083630407993  , 0.00259421503714  , 0.00627931160249  , 0.011865907299    ,
 0.0175162755768   , 0.0202144452067   , 0.0182538095517   , 0.0129115522354   ,
 0.00716253822556  , 0.00312039894281  , 0.00106915850886  , 0.000288542924233 ,
 6.14235301522e-05 , 1.03265903367e-05 , 1.37242628305e-06 , 1.44267574381e-07 ,
 1.19958688928e-08 , 7.88691691359e-10 , 4.0967414096e-11  , 1.67927727885e-12 ,
 5.42450267295e-14 , 1.37882133128e-15 , 2.37382530355e-17 , 3.18456116749e-24 ,
 1.38972029901e-25 , 4.73010274084e-27 , 1.25528742411e-28 , 2.56695963474e-30 ,
 0, 0, 5.85721586559e-21 , 3.02348117008e-19 , 1.15604947332e-17 ,
 3.4590662373e-16  , 8.10849011867e-15 , 1.49129602936e-13 , 2.15547348875e-12 ,
 2.45494994498e-11 , 2.21579042644e-10 , 1.6089633464e-09  , 9.81454404655e-09 ,
 5.58950970981e-08 , 3.45080193422e-07 , 2.36823334162e-06 , 1.57572629913e-05 ,
 8.99332150634e-05 , 0.000417110491993 , 0.00154359279336  , 0.00453356418833  ,
 0.0105621930038   , 0.0195689338432   , 0.0290098255035   , 0.034819876016    ,
 0.0345551870731   , 0.0293432551114   , 0.0224161467975   , 0.0163713277917   ,
 0.0120852570874   , 0.00928819356286  , 0.0073528845193   , 0.00572624701274  ,
 0.00414981513315  , 0.00269272022949  , 0.00155583113661  , 0.000831354911733 ,
 0.000441884283633 , 0.000244308030567 , 0.000134431297554 , 6.75548259167e-05 ,
 2.92368776673e-05 , 1.07101813654e-05 , 3.37842844378e-06 , 9.5940979625e-07  ,
 2.57871749705e-07 , 6.66048444294e-08 , 1.59865195748e-08 , 3.39526107792e-09 ,
 6.17625330984e-10 , 9.56788081523e-11 , 1.31078912966e-11 , 1.02743005833e-13 ,
 2.43204501329e-14 , 1.90356259924e-14 , 1.79285456664e-14 , 1.40178126495e-14 ,
 8.71537629748e-15 , 4.2848498596e-15  , 1.66292600358e-15 , 5.08713223361e-16 ,
 1.22487334983e-16 , 2.31782810515e-17 , 3.44212953243e-18 , 4.00651246838e-19 ,
 3.65091945217e-20 , 2.60200020256e-21 , 1.44917953384e-22 , 6.30302811959e-24 ,
 2.13966293486e-25 , 5.66648818772e-27 , 1.15008660088e-28 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 5.42652500195e-22 , 3.1453753554e-20  ,
 1.86401716048e-16 , 9.26247415142e-15 , 3.5029241677e-13  , 1.03486943031e-11 ,
 2.38934624389e-10 , 4.31411994659e-09 , 6.0966677e-08     , 6.75040650492e-07 ,
 5.8631412658e-06  , 4.00021847105e-05 , 0.000214695376379 , 0.000907800729675 ,
 0.00302829228904  , 0.00797943802674  , 0.0166230732509   , 0.0273939265863   ,
 0.0357208928186   , 0.0368794445173   , 0.0302563109371   , 0.0200823903082   ,
 0.0116435309975   , 0.00746978341009  , 0.00696939288847  , 0.00828613217356  ,
 0.00985514209118  , 0.0109887826393   , 0.0118522315005   , 0.0128500130304   ,
 0.0137636334936   , 0.0138193641292   , 0.0129571520804   , 0.0125106668187   ,
 0.0138346085148   , 0.0163147945022   , 0.0174937039506   , 0.0155174640844   ,
 0.0109989427105   , 0.00616823910195  , 0.00273351619385  , 0.0009608421038   ,
 0.000272502823406 , 6.84921809493e-05 , 2.28190572884e-05 , 1.49939052145e-05 ,
 1.22025057841e-05 , 8.60111103598e-06 , 4.88095073639e-06 , 2.22053323358e-06 ,
 8.24646604431e-07 , 2.61902872425e-07 , 7.75536145478e-08 , 2.33833039945e-08 ,
 7.14676513264e-09 , 2.01928106913e-09 , 4.85959563159e-10 , 1.16984336515e-10 ,
 4.60488491559e-10 , 7.78280137555e-09 , 1.07398349098e-07 , 1.1568115135e-06  ,
 9.71128367941e-06 , 6.35397585604e-05 , 0.000324079242568 , 0.00128885679794  ,
 0.00399803375132  , 0.00967726250895  , 0.0182869567881   , 0.0269949331742   ,
 0.0311531749497   , 0.0281315720837   , 0.0198984360714   , 0.0110384333651   ,
 0.00480895385377  , 0.0016477168547   , 0.000444683398788 , 9.46619094064e-05 ,
 1.59146626138e-05 , 2.11509322476e-06 , 2.22335707821e-07 , 1.8487245044e-08  ,
 1.21547981708e-09 , 6.31362864619e-11 , 2.58799170703e-12 , 8.35988581762e-14 ,
 2.12494762832e-15 , 3.65837483263e-17 , 0, 0, 0, 0, 0, 0, 0,
 4.96126712791e-22 , 2.55497865848e-20 , 9.7631025419e-19  , 2.91904588636e-17 ,
 6.8363112138e-16  , 1.25667973078e-14 , 1.81756546328e-13 , 2.08028785233e-12 ,
 1.91628140626e-11 , 1.49205195343e-10 , 1.10557762754e-09 , 9.09677319934e-09 ,
 8.32091919281e-08 , 7.26208395267e-07 , 5.37506020179e-06 , 3.21468575603e-05 ,
 0.000152880684868 , 0.000575100428165 , 0.00170835066092  , 0.00400723486505  ,
 0.0074340307822   , 0.010949223713    , 0.0129001419404   , 0.0123247760082   ,
 0.00977581752516  , 0.00669196149917  , 0.00419749687434  , 0.00261759570259  ,
 0.00175873538121  , 0.00130178272145  , 0.000997551125322 , 0.000722629804958 ,
 0.000465100156818 , 0.000261520720779 , 0.000132859102418 , 6.62247191072e-05 ,
 3.47819768966e-05 , 1.86637030946e-05 , 9.27284665579e-06 , 3.95975568639e-06 ,
 1.41187371422e-06 , 4.22822693229e-07 , 1.10172208603e-07 , 2.64294364283e-08 ,
 6.10271654303e-09 , 1.34542269091e-09 , 2.69339723021e-10 , 4.6654610165e-11  ,
 6.8296834403e-12  , 8.53387173168e-13 , 4.98348951473e-15 , 7.29510863166e-16 ,
 4.09171551165e-16 , 3.71081740719e-16 , 2.89292121025e-16 , 1.79812535662e-16 ,
 8.84005086504e-17 , 3.43075837276e-17 , 1.04951818263e-17 , 2.52701656714e-18 ,
 4.78187394198e-19 , 7.1014021505e-20  , 8.26577151849e-21 , 7.53215327857e-22 ,
 5.36814482305e-23 , 2.98977901871e-24 , 1.30036760706e-25 , 4.4143042324e-27  ,
 1.16904407617e-28 , 2.37272519292e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 4.76680687725e-23 , 2.76298310065e-21 , 1.54461488399e-16 ,
 7.69262948008e-15 , 2.91306818254e-13 , 8.61325157697e-12 , 1.98971665466e-10 ,
 3.59379116741e-09 , 5.07983772188e-08 , 5.62536859941e-07 , 4.88645572364e-06 ,
 3.33408037121e-05 , 0.000178951210739 , 0.000756686233757 , 0.00252424687636  ,
 0.00665136057302  , 0.0138562329662   , 0.0228327010913   , 0.0297641700364   ,
 0.0306915816976   , 0.025051677859    , 0.0162771801417   , 0.00866242525379  ,
 0.0042616805964   , 0.00268133143612  , 0.00270617957395  , 0.00362390659451  ,
 0.00559364246317  , 0.00920432144327  , 0.0143220881734   , 0.0191083760783   ,
 0.0208777322275   , 0.0186453274079   , 0.0143621872999   , 0.0109550154288   ,
 0.00950455824389  , 0.00884659272724  , 0.00749655125206  , 0.00524716754241  ,
 0.00293150117285  , 0.0012953435099   , 0.000452308522012 , 0.000125355452886 ,
 2.83103415664e-05 , 6.15462811866e-06 , 2.23635406229e-06 , 1.48981948647e-06 ,
 1.01748276781e-06 , 5.72392486928e-07 , 2.5737812756e-07  , 9.32308138095e-08 ,
 2.80396895202e-08 , 7.48346832484e-09 , 1.95697041051e-09 , 5.29036357154e-10 ,
 1.39345288806e-10 , 3.31692490035e-11 , 2.96417381879e-11 , 5.32652496958e-10 ,
 9.43205138579e-09 , 1.30406945426e-07 , 1.40489156099e-06 , 1.17940990844e-05 ,
 7.71675151008e-05 , 0.000393586556696 , 0.00156528605658  , 0.00485551731438  ,
 0.0117528061545   , 0.022209075975    , 0.0327847070869   , 0.0378347932541   ,
 0.0341651281263   , 0.024166179404    , 0.0134059159264   , 0.00584036057703  ,
 0.00200111310129  , 0.000540057457509 , 0.000114964647334 , 1.93279808775e-05 ,
 2.56873063503e-06 , 2.7002145213e-07  , 2.2452321319e-08  , 1.47617145469e-09 ,
 7.66775248099e-11 , 3.14305464328e-12 , 1.01528833593e-13 , 2.5806985748e-15  ,
 4.44300960212e-17 , 0, 0, 0, 0, 0, 0, 0, 3.32039692369e-23 ,
 1.70631598576e-21 , 6.5165257054e-20  , 1.94701643903e-18 , 4.55603102649e-17 ,
 8.38437607364e-16 , 1.22067441021e-14 , 1.43034923629e-13 , 1.42754179479e-12 ,
 1.38595231852e-11 , 1.53004341637e-10 , 1.86957854353e-09 , 2.14218729122e-08 ,
 2.05955899076e-07 , 1.59234824765e-06 , 9.76458046729e-06 , 4.72661667074e-05 ,
 0.000180243511659 , 0.000540987160646 , 0.00127788230554  , 0.00237777791475  ,
 0.00349373956455  , 0.00407344964787  , 0.0038020256321   , 0.00288485952833  ,
 0.00182734513636  , 0.0010122707996   , 0.000532303369542 , 0.000300591412556 ,
 0.000199778139108 , 0.000148150718483 , 0.000107044683028 , 6.85293064339e-05 ,
 3.76628134833e-05 , 1.8217793253e-05  , 8.43438201485e-06 , 4.12406423595e-06 ,
 2.12334245387e-06 , 1.0369509745e-06  , 4.37965309811e-07 , 1.53471942802e-07 ,
 4.44025559269e-08 , 1.08507749831e-08 , 2.35363934832e-09 , 4.81740924448e-10 ,
 9.56125258192e-11 , 1.78000810528e-11 , 2.93285685094e-12 , 4.10273418532e-13 ,
 4.81409914319e-14 , 2.13393281028e-16 , 1.71162077511e-17 , 1.28268519859e-18 ,
 1.0047358299e-19  , 8.36759517292e-21 , 6.64089744341e-22 , 4.49864463043e-23 ,
 2.45957302006e-24 , 1.06351447022e-25 , 3.61097396191e-27 , 9.57152124047e-29 ,
 1.94894794647e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 3.29473275878e-24 , 1.90972514056e-22 , 1.01246018807e-16 ,
 5.04354746839e-15 , 1.91017183965e-13 , 5.64842172829e-12 , 1.30489494834e-10 ,
 2.35696325839e-09 , 3.33165490325e-08 , 3.6895030738e-07  , 3.20490636054e-06 ,
 2.18675671991e-05 , 0.000117371080902 , 0.000496299313359 , 0.00165561926987  ,
 0.00436253686049  , 0.00908806599204  , 0.0149752054884   , 0.0195193213206   ,
 0.0201190526086   , 0.0163932617366   , 0.0105726141158   , 0.00545068618677  ,
 0.00237103115691  , 0.0011289903131   , 0.00110738175776  , 0.00225669810787  ,
 0.0053792433143   , 0.0114891213746   , 0.0201569467077   , 0.028197342783    ,
 0.0311477432988   , 0.0271867423034   , 0.0190498579967   , 0.0113305783817   ,
 0.00654935067096  , 0.00428765256161  , 0.00306476066272  , 0.00202497233063  ,
 0.00111235363387  , 0.000489027367819 , 0.000170303265281 , 4.69288187612e-05 ,
 1.02992860968e-05 , 1.88880645062e-06 , 3.85818041613e-07 , 1.56795907472e-07 ,
 9.54744790404e-08 , 5.2743066629e-08  , 2.35150318507e-08 , 8.389236354e-09   ,
 2.43728502821e-09 , 6.03754159347e-10 , 1.39151887696e-10 , 3.26994870533e-11 ,
 7.83371636772e-12 , 2.49245787917e-12 , 2.26819896114e-11 , 5.09355687387e-10 ,
 9.03888804747e-09 , 1.24978527112e-07 , 1.34641725933e-06 , 1.13032117031e-05 ,
 7.39556959919e-05 , 0.000377204939895 , 0.00150013668706  , 0.00465342397179  ,
 0.0112636381161   , 0.0212847035326   , 0.0314201622586   , 0.0362600568586   ,
 0.0327431282662   , 0.0231603496116   , 0.0128479431741   , 0.0055972766965   ,
 0.00191782400782  , 0.000517579519589 , 0.000110179659793 , 1.85235235957e-05 ,
 2.46181651516e-06 , 2.58782786034e-07 , 2.15178246692e-08 , 1.41473115819e-09 ,
 7.34861002336e-11 , 3.01223636428e-12 , 9.73030631926e-14 , 2.47328633274e-15 ,
 4.25808540077e-17 , 0, 0, 0, 0, 0, 0, 0, 1.75343297661e-24 ,
 8.99370147754e-23 , 3.4330362267e-21  , 1.02509798905e-19 , 2.39695139044e-18 ,
 4.44010976245e-17 , 6.66452996153e-16 , 8.561687581e-15   , 1.09619605405e-13 ,
 1.63115448407e-12 , 2.66303633823e-11 , 4.00520311706e-10 , 5.00557777433e-09 ,
 5.00965138255e-08 , 3.96799064105e-07 , 2.47692075192e-06 , 1.21608466234e-05 ,
 4.69037160071e-05 , 0.000142018389623 , 0.000337530697909 , 0.000630035025196 ,
 0.000925138629778 , 0.00107212799355  , 0.000986284164342 , 0.000727476987421 ,
 0.000437755132875 , 0.000221836738219 , 0.000100990689765 , 4.71299258832e-05 ,
 2.67546647948e-05 , 1.86131176463e-05 , 1.33006123451e-05 , 8.47446649188e-06 ,
 4.57332840819e-06 , 2.11742070591e-06 , 9.07632837591e-07 , 4.0540950126e-07  ,
 1.96150352432e-07 , 9.32129388307e-08 , 3.89018650824e-08 , 1.34732319136e-08 ,
 3.81456795847e-09 , 8.92761805078e-10 , 1.79136118713e-10 , 3.27451768958e-11 ,
 5.76610447581e-12 , 9.79147505399e-13 , 1.52037839358e-13 , 2.03860210951e-14 ,
 2.28552646884e-15 , 7.88098097436e-18 , 5.6413595437e-19  , 3.25431861496e-20 ,
 1.50979619228e-21 , 5.63170561537e-23 , 1.68664320086e-24 , 3.89825215656e-26 ,
 5.28933890869e-28 , 1.84131862865e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.78919543581e-25 , 1.03707091145e-23 ,
 5.21691382912e-17 , 2.59885913496e-15 , 9.84295371018e-14 , 2.91061085888e-12 ,
 6.72411518944e-11 , 1.21454625136e-09 , 1.71681037922e-08 , 1.90121356636e-07 ,
 1.65150101778e-06 , 1.12684527755e-05 , 6.04818598963e-05 , 0.000255745407471 ,
 0.000853148609735 , 0.00224803548319  , 0.00468311290448  , 0.00771670942975  ,
 0.0100579268233   , 0.0103654245429   , 0.00844068000676  , 0.00542950687554  ,
 0.00276830412966  , 0.00115526384889  , 0.000527320997919 , 0.000724099627942 ,
 0.00214520921927  , 0.00598933979569  , 0.0135463053615   , 0.0242562048859   ,
 0.0341674469909   , 0.0377669350656   , 0.0327464128017   , 0.0223494157727   ,
 0.0121894591863   , 0.0055892965493   , 0.00244971429484  , 0.00120815378987  ,
 0.00066152174158  , 0.000340529105371 , 0.00014687431909  , 5.0865485987e-05  ,
 1.39793066715e-05 , 3.04549057167e-06 , 5.32126005796e-07 , 8.16635321744e-08 ,
 1.70954029696e-08 , 7.37176642501e-09 , 3.82687398401e-09 , 1.68653141844e-09 ,
 5.9579209307e-10  , 1.69447052535e-10 , 3.99489389455e-11 , 8.34018310515e-12 ,
 1.70428601575e-12 , 3.7550846552e-13  , 6.52933603592e-13 , 1.69400197447e-11 ,
 3.85624487022e-10 , 6.84389621791e-09 , 9.46290883062e-08 , 1.019457172e-06   ,
 8.55837246774e-06 , 5.59965087776e-05 , 0.000285605583826 , 0.00113584783501  ,
 0.00352339996037  , 0.00852840883024  , 0.0161159877196   , 0.0237901809781   ,
 0.0274547695789   , 0.0247918817488   , 0.0175361573324   , 0.00972798583255  ,
 0.00423805022069  , 0.00145210517548  , 0.000391892006802 , 8.3423950042e-05  ,
 1.40253247283e-05 , 1.86399611652e-06 , 1.95940723128e-07 , 1.62924983939e-08 ,
 1.07118193763e-09 , 5.5640948304e-11  , 2.28075360227e-12 , 7.36742688986e-14 ,
 1.87268063679e-15 , 3.22406426392e-17 , 0, 0, 0, 0, 0, 0, 0,
 7.29509042814e-26 , 3.73566243521e-24 , 1.42534141009e-22 , 4.25376684034e-21 ,
 9.9400102763e-20  , 1.88824534468e-18 , 3.206284006e-17   , 5.4489612518e-16  ,
 1.09655379334e-14 , 2.38987270319e-13 , 4.71427495611e-12 , 7.65977412794e-11 ,
 9.92912946173e-10 , 1.0166085259e-08  , 8.19106098241e-08 , 5.18387594316e-07 ,
 2.57371470673e-06 , 1.00157496374e-05 , 3.05352423591e-05 , 7.29236821726e-05 ,
 0.000136479741056 , 0.000200401713561 , 0.000231387327464 , 0.000210902112822 ,
 0.000152755336768 , 8.89153746374e-05 , 4.24568224541e-05 , 1.73802894976e-05 ,
 6.80643804441e-06 , 3.16260136619e-06 , 1.96887319612e-06 , 1.36805484486e-06 ,
 8.65678884953e-07 , 4.60633182815e-07 , 2.05755641326e-07 , 8.20416939887e-08 ,
 3.30596630027e-08 , 1.46804697464e-08 , 6.6886587351e-09  , 2.74669636508e-09 ,
 9.42352169069e-10 , 2.63206662408e-10 , 5.99387235793e-11 , 1.13909378519e-11 ,
 1.89761990571e-12 , 2.96145954913e-13 , 4.50043008294e-14 , 6.47554146293e-15 ,
 8.2749076383e-16  , 8.91754973813e-17 , 2.43339839203e-19 , 1.6955624337e-20  ,
 9.49061040019e-22 , 4.25004951117e-23 , 1.52182623864e-24 , 4.34611155109e-26 ,
 9.37795898845e-28 , 9.5902553659e-30  , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7.6231357388e-27  ,
 4.41859629783e-25 , 2.10912718606e-17 , 1.05068612556e-15 , 3.97938878715e-14 ,
 1.17672640467e-12 , 2.71848391937e-11 , 4.91027545338e-10 , 6.94087528725e-09 ,
 7.68639838489e-08 , 6.67683864379e-07 , 4.55571301011e-06 , 2.44521599664e-05 ,
 0.000103395097027 , 0.000344918731304 , 0.000908856214114 , 0.00189333001866  ,
 0.00311976933887  , 0.00406624224973  , 0.00419033728773  , 0.00341149540893  ,
 0.0021925291045   , 0.00111460265744  , 0.000466889759311 , 0.000261204878055 ,
 0.000575959806701 , 0.00197160870039  , 0.0056829093842   , 0.0129741412836   ,
 0.0233039293722   , 0.0328579024723   , 0.0363151321514   , 0.031433062059    ,
 0.0213107758982   , 0.0113534555213   , 0.00481772933197  , 0.00170483526594  ,
 0.000567932923496 , 0.00021130252493  , 8.86612381519e-05 , 3.55900168768e-05 ,
 1.20684831815e-05 , 3.29682852052e-06 , 7.1594891105e-07  , 1.23539253827e-07 ,
 1.73254990699e-08 , 2.33131083323e-09 , 5.30980843132e-10 , 2.22778305144e-10 ,
 9.4926310441e-11  , 3.32288811372e-11 , 9.32670778742e-12 , 2.13119640932e-12 ,
 4.14755582833e-13 , 7.51691363926e-14 , 2.30282147525e-14 , 3.49071141601e-13 ,
 1.0134122299e-11  , 2.30867083371e-10 , 4.09735045853e-09 , 5.6653191885e-08  ,
 6.10335617245e-07 , 5.12378517535e-06 , 3.35243742475e-05 , 0.000170988311386 ,
 0.000680017178579 , 0.00210941327369  , 0.00510584633941  , 0.00964843015173  ,
 0.0142428688492   , 0.0164368099073   , 0.0148425739424   , 0.0104986670439   ,
 0.00582401733333  , 0.00253726499706  , 0.000869356294035 , 0.000234620596668 ,
 4.9944823052e-05  , 8.39677768137e-06 , 1.11594998993e-06 , 1.17307137104e-07 ,
 9.75410477386e-09 , 6.41302555254e-10 , 3.33115048627e-11 , 1.36545722221e-12 ,
 4.4107817021e-14  , 1.12114929814e-15 , 1.93020492423e-17 , 0, 0, 0, 0, 0, 0,
 0, 2.38746699991e-27 , 1.22086304743e-25 , 4.65647304091e-24 ,
 1.38903545214e-22 , 3.2440530271e-21  , 6.71629193258e-20 , 1.69621433511e-18 ,
 4.62895938028e-17 , 1.34469140345e-15 , 3.47491550734e-14 , 7.33786768763e-13 ,
 1.23200863009e-11 , 1.63077289705e-10 , 1.69635132681e-09 , 1.38432828267e-08 ,
 8.85227603996e-08 , 4.4318778244e-07  , 1.73610326575e-06 , 5.31953697162e-06 ,
 1.27488911009e-05 , 2.39071303342e-05 , 3.510896561e-05   , 4.04429287783e-05 ,
 3.66421664926e-05 , 2.62284440917e-05 , 1.49427591289e-05 , 6.86526035316e-06 ,
 2.61575128319e-06 , 8.92400473619e-07 , 3.34438160231e-07 , 1.75665542057e-07 ,
 1.15309773914e-07 , 7.20488235742e-08 , 3.79087031106e-08 , 1.64757772536e-08 ,
 6.17752822907e-09 , 2.24100307777e-09 , 8.93062424436e-10 , 3.82427830512e-10 ,
 1.53314406022e-10 , 5.20817844954e-11 , 1.44145955903e-11 , 3.22754754761e-12 ,
 5.92029470004e-13 , 9.21054803335e-14 , 1.2911425558e-14  , 1.73696068795e-15 ,
 2.26768856454e-16 , 2.7268313824e-17  , 2.83129070468e-18 , 5.85188819751e-21 ,
 3.94645522037e-22 , 2.13435502151e-23 , 9.19253071027e-25 , 3.15261818883e-26 ,
 8.57888128593e-28 , 1.72034251011e-29 , 1.03825960683e-31 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 2.54505799588e-28 , 1.47519134168e-26 , 6.68148890904e-18 , 3.32846198256e-16 ,
 1.26062828181e-14 , 3.72774518337e-13 , 8.61187100151e-12 , 1.55552366045e-10 ,
 2.19879640821e-09 , 2.43497034123e-08 , 2.11515243582e-07 , 1.44320209921e-06 ,
 7.74618784799e-06 , 3.27544824349e-05 , 0.000109266635456 , 0.000287916095051 ,
 0.000599786884728 , 0.000988308755183 , 0.00128813508609  , 0.00132742211872  ,
 0.00108062229742  , 0.000694378856528 , 0.000353533505225 , 0.000155106891733 ,
 0.000130957196938 , 0.000414490587816 , 0.00148715559364  , 0.00431322031386  ,
 0.00986190346138  , 0.0177221324527   , 0.0249910319031   , 0.0276186592384   ,
 0.0238952195984   , 0.016173706703    , 0.00856601205193  , 0.00356022422256  ,
 0.00117528589957  , 0.000321248579525 , 8.15163115733e-05 , 2.29173901455e-05 ,
 7.37467540775e-06 , 2.31113862836e-06 , 6.16961850032e-07 , 1.3309844714e-07  ,
 2.28624207349e-08 , 3.13143454358e-09 , 3.57372625041e-10 , 4.4978452647e-11  ,
 1.12187683052e-11 , 4.23084950829e-12 , 1.45265590558e-12 , 4.03858927058e-13 ,
 9.05132011437e-14 , 1.68132104743e-14 , 2.85343856318e-15 , 4.81367380146e-15 ,
 1.64160626164e-13 , 4.79899790068e-12 , 1.09331258357e-10 , 1.94037449499e-09 ,
 2.68291448097e-08 , 2.89035482608e-07 , 2.42646124377e-06 , 1.58760744351e-05 ,
 8.09746108623e-05 , 0.000322034447669 , 0.000998950849915 , 0.0024179659832   ,
 0.00456918879796  , 0.00674496843249  , 0.00778394894522  , 0.00702896963798  ,
 0.00497183387309  , 0.00275806886096  , 0.00120156778043  , 0.000411699414068 ,
 0.000111108831717 , 2.36522752838e-05 , 3.97644610754e-06 , 5.28478323717e-07 ,
 5.5552918801e-08  , 4.61923292868e-09 , 3.03700436806e-10 , 1.57752662836e-11 ,
 6.46636991275e-13 , 2.08880553899e-14 , 5.30940550259e-16 , 9.14083491188e-18 ,
 0, 0, 0, 0, 0, 0, 0, 6.13514233682e-29 , 3.13345456918e-27 ,
 1.19473735672e-25 , 3.56249863461e-24 , 8.31614770512e-23 , 2.2253292501e-21  ,
 1.22187476641e-19 , 4.72408377865e-18 , 1.59692447302e-16 , 4.379513496e-15   ,
 9.5201377163e-14  , 1.62867156969e-12 , 2.18673987013e-11 , 2.30078557608e-10 ,
 1.89500915881e-09 , 1.22083511312e-08 , 6.1483709623e-08  , 2.41966542763e-07 ,
 7.4399228309e-07  , 1.78741667745e-06 , 3.35641050044e-06 , 4.92971502725e-06 ,
 5.67011627933e-06 , 5.11723597457e-06 , 3.63496326596e-06 , 2.04242053206e-06 ,
 9.15478117059e-07 , 3.33044981605e-07 , 1.03192875911e-07 , 3.1859526301e-08  ,
 1.33711230327e-08 , 7.92622161616e-09 , 4.83442292819e-09 , 2.51734541533e-09 ,
 1.07245357142e-09 , 3.83258052434e-10 , 1.26262760859e-10 , 4.44536147919e-11 ,
 1.7464539005e-11  , 6.75168285266e-12 , 2.26406546363e-12 , 6.22024571563e-13 ,
 1.37797802959e-13 , 2.47160329297e-14 , 3.66842642146e-15 , 4.71827454497e-16 ,
 5.62415578932e-17 , 6.51430447836e-18 , 7.18550602303e-19 , 7.06802754249e-20 ,
 1.06545706633e-22 , 6.95586301583e-24 , 3.64502904736e-25 , 1.51252067585e-26 ,
 4.96711709645e-28 , 1.28066427199e-29 , 2.34352214311e-31 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 6.65069341697e-30 , 3.85493979343e-28 , 1.65668909394e-18 , 8.2529910675e-17  ,
 3.125754232e-15   , 9.24302237007e-14 , 2.13533149263e-12 , 3.85695358636e-11 ,
 5.45196189071e-10 , 6.03756013115e-09 , 5.24456492041e-08 , 3.57844994069e-07 ,
 1.92068355967e-06 , 8.12154276298e-06 , 2.70928917696e-05 , 7.13893988282e-05 ,
 0.000148718399717 , 0.000245053102855 , 0.000319395116528 , 0.000329134494438 ,
 0.000267938409187 , 0.000172217370687 , 8.82845292427e-05 , 4.34885920746e-05 ,
 6.27261986769e-05 , 0.00024476792295  , 0.000893025298942 , 0.00259380001986  ,
 0.00593206661832  , 0.0106608687155   , 0.0150337778721   , 0.016614102948    ,
 0.0143726832884   , 0.00972436746302  , 0.00514281629758  , 0.00212640202594  ,
 0.000689164713935 , 0.000176975668921 , 3.73942599029e-05 , 7.24162153938e-06 ,
 1.54094578912e-06 , 3.80620536563e-07 , 9.32292440064e-08 , 1.96147150161e-08 ,
 3.34451397723e-09 , 4.54752794572e-10 , 4.96026080299e-11 , 4.71635179046e-12 ,
 5.967305706e-13   , 1.55700815836e-13 , 4.99475358144e-14 , 1.37012710553e-14 ,
 3.02759451998e-15 , 5.43441505018e-16 , 1.16326814291e-16 , 1.64836709045e-15 ,
 6.14634701994e-14 , 1.79754896454e-12 , 4.09520385758e-11 , 7.26803052634e-10 ,
 1.00493509884e-08 , 1.08263570585e-07 , 9.08875809176e-07 , 5.94667647618e-06 ,
 3.03305338831e-05 , 0.000120623941536 , 0.000374175464114 , 0.000905693752654 ,
 0.00171147393212  , 0.00252645232133  , 0.0029156216339   , 0.00263283021058  ,
 0.00186229207085  , 0.00103308555791  , 0.000450069372226 , 0.000154209608358 ,
 4.16178620586e-05 , 8.85939591767e-06 , 1.48945122569e-06 , 1.97951302677e-07 ,
 2.08083702787e-08 , 1.73021888423e-09 , 1.1375659964e-10  , 5.90891692387e-12 ,
 2.42209810767e-13 , 7.82400637692e-15 , 1.98873575038e-16 , 3.42386829726e-18 ,
 0, 0, 0, 0, 0, 0, 0, 1.10945100712e-30 , 5.63920834327e-29 ,
 2.14738636619e-27 , 6.39299413793e-26 , 1.4894905505e-24  , 7.70904759564e-23 ,
 1.02673758554e-20 , 4.55187742968e-19 , 1.62115523039e-17 , 4.56057411968e-16 ,
 1.00787108597e-14 , 1.7458888816e-13  , 2.36753946986e-12 , 2.51101090141e-11 ,
 2.08145968166e-10 , 1.34781335397e-09 , 6.81519313627e-09 , 2.69045094884e-08 ,
 8.2918478859e-08  , 1.99532384252e-07 , 3.75022571644e-07 , 5.50863549632e-07 ,
 6.3297980428e-07  , 5.69815927372e-07 , 4.02764448354e-07 , 2.24304101189e-07 ,
 9.89744319116e-08 , 3.49740153243e-08 , 1.01844567958e-08 , 2.70984561918e-09 ,
 8.85720444404e-10 , 4.45630308733e-10 , 2.59784101282e-10 , 1.33607342477e-10 ,
 5.6098320382e-11  , 1.93558513141e-11 , 5.88561995427e-12 , 1.82342551942e-12 ,
 6.40795982796e-13 , 2.34704068966e-13 , 7.72128776977e-14 , 2.10446028445e-14 ,
 4.6247807446e-15  , 8.16670906775e-16 , 1.17166178096e-16 , 1.40698015782e-17 ,
 1.49550059774e-18 , 1.50610272635e-19 , 1.47591036035e-20 , 1.34617681032e-21 ,
 1.35067840274e-25 , 3.49620078824e-27 , 6.5026580969e-29  , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 1.28410326035e-31 , 7.44304457725e-30 , 3.21213503745e-19 , 1.60016275543e-17 ,
 6.0604882192e-16  , 1.79211876848e-14 , 4.14016919407e-13 , 7.47820208894e-12 ,
 1.05707449933e-10 , 1.17061545587e-09 , 1.01686254424e-08 , 6.93821464043e-08 ,
 3.7239908378e-07  , 1.57467640477e-06 , 5.25300901125e-06 , 1.38416066955e-05 ,
 2.88348348362e-05 , 4.75130499772e-05 , 6.19271048776e-05 , 6.38154814257e-05 ,
 5.19524587142e-05 , 3.34239369608e-05 , 1.74429538243e-05 , 1.08922532933e-05 ,
 2.67497253565e-05 , 0.000115671270865 , 0.000424757201033 , 0.00123423399344  ,
 0.00282285364968  , 0.00507317487721  , 0.00715411868533  , 0.00790609808995  ,
 0.00683929713755  , 0.00462692362019  , 0.00244612460684  , 0.00101011614575  ,
 0.000325885576249 , 8.23325945786e-05 , 1.64466182565e-05 , 2.68825719736e-06 ,
 3.98030822634e-07 , 6.42154453786e-08 , 1.21861083974e-08 , 2.33519501819e-09 ,
 3.87526917462e-10 , 5.22497941888e-11 , 5.62726480683e-12 , 4.91558687309e-13 ,
 4.04487661726e-14 , 5.43712371376e-15 , 1.37732836894e-15 , 3.62478642645e-16 ,
 7.85143726566e-17 , 1.3516406927e-17  , 1.18803617067e-17 , 4.84899754302e-16 ,
 1.8199102948e-14  , 5.32260720813e-13 , 1.21260475562e-11 , 2.15209027266e-10 ,
 2.97564937714e-09 , 3.20572370046e-08 , 2.69121432677e-07 , 1.76083253265e-06 ,
 8.98098139488e-06 , 3.57171877979e-05 , 0.0001107947158   , 0.000268179214168 ,
 0.00050677365593  , 0.00074809172105  , 0.000863326169911 , 0.000779590600951 ,
 0.000551431455331 , 0.000305900391027 , 0.000133267178018 , 4.5662025895e-05  ,
 1.23232003197e-05 , 2.62329935283e-06 , 4.4103192506e-07  , 5.86141006713e-08 ,
 6.16143411954e-09 , 5.12324104424e-10 , 3.36837428859e-11 , 1.74965179188e-12 ,
 7.17192058849e-14 , 2.31671674411e-15 , 5.88871888718e-17 , 1.01381985542e-18 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.72554710946e-30 , 2.76852197802e-24 ,
 7.97341444073e-22 , 3.70394594416e-20 , 1.34881281585e-18 , 3.84898277291e-17 ,
 8.59771592898e-16 , 1.50200405617e-14 , 2.05064124162e-13 , 2.18668106281e-12 ,
 1.820397974e-11   , 1.18275999055e-10 , 5.99643505854e-10 , 2.37205005488e-09 ,
 7.32165615145e-09 , 1.76371339988e-08 , 3.316856683e-08   , 4.87234827634e-08 ,
 5.59513143211e-08 , 5.02862338658e-08 , 3.54316120783e-08 , 1.96209255616e-08 ,
 8.5723930157e-09  , 2.97495284299e-09 , 8.33871840353e-10 , 2.00727926581e-10 ,
 5.20324275535e-11 , 2.07671487474e-11 , 1.11558705972e-11 , 5.63027811422e-12 ,
 2.33695722141e-12 , 7.86646576899e-13 , 2.24897405299e-13 , 6.1836413997e-14  ,
 1.90245496818e-14 , 6.44743963266e-15 , 2.05914819032e-15 , 5.54785046274e-16 ,
 1.20731829987e-16 , 2.09281135516e-17 , 2.87652834817e-18 , 3.12868931754e-19 ,
 2.68887161313e-20 , 1.82329133736e-21 , 9.74002013906e-23 , 4.09270389085e-24 ,
 2.77918146943e-27 , 7.19436085682e-29 , 1.33830303844e-30 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 4.86615756196e-20 , 2.42413348274e-18 , 9.18121132808e-17 ,
 2.71493327689e-15 , 6.27206372454e-14 , 1.1328947647e-12  , 1.60139315839e-11 ,
 1.77339968315e-10 , 1.54047488843e-09 , 1.05109048265e-08 , 5.64158292847e-08 ,
 2.38552346351e-07 , 7.95793739146e-07 , 2.09690558122e-06 , 4.36827361929e-06 ,
 7.19789092041e-06 , 9.38151978552e-06 , 9.66765587985e-06 , 7.87149786653e-06 ,
 5.07662298725e-06 , 2.76746549697e-06 , 2.58635736674e-06 , 9.59204998534e-06 ,
 4.34131321617e-05 , 0.000159829339603 , 0.000464491042318 , 0.0010623638618   ,
 0.00190926217729  , 0.0026924144574   , 0.00297541303365  , 0.00257391197076  ,
 0.00174126241919  , 0.000920477891136 , 0.000379990308296 , 0.000122457167361 ,
 3.08139021164e-05 , 6.06690265033e-06 , 9.42744896494e-07 , 1.19285808577e-07 ,
 1.35274588801e-08 , 1.65768104766e-09 , 2.41911683491e-10 , 3.62939988724e-11 ,
 4.75271469964e-12 , 5.06735705812e-13 , 4.32647992847e-14 , 3.05748481032e-15 ,
 2.30243838191e-16 , 3.34608574008e-17 , 7.67729337003e-18 , 1.63227913617e-18 ,
 2.80364040497e-19 , 2.38576558056e-18 , 1.1335361908e-16  , 4.25593593002e-15 ,
 1.24471488826e-13 , 2.83572906435e-12 , 5.03275688721e-11 , 6.95868574241e-10 ,
 7.49672457376e-09 , 6.29352198191e-08 , 4.11778361183e-07 , 2.10024163685e-06 ,
 8.35262001625e-06 , 2.59098271152e-05 , 6.27148779147e-05 , 0.000118511227877 ,
 0.00017494450903  , 0.000201892587069 , 0.000182310659362 , 0.000128954648878 ,
 7.1536139506e-05  , 3.11651103363e-05 , 1.06782637432e-05 , 2.88183409726e-06 ,
 6.13469985573e-07 , 1.03137237621e-07 , 1.37071628727e-08 , 1.44087821939e-09 ,
 1.19809224445e-10 , 7.87709006217e-12 , 4.0916369623e-13  , 1.67718488369e-14 ,
 5.41774306486e-16 , 1.37710257385e-17 , 2.37086191253e-19 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 1.20045877905e-25 , 5.22087212939e-23 , 2.45694318708e-21 ,
 9.04271288683e-20 , 2.60288246724e-18 , 5.85501704785e-17 , 1.02860600772e-15 ,
 1.41060355529e-14 , 1.50950817543e-13 , 1.2601618544e-12  , 8.20550597051e-12 ,
 4.1671577485e-11  , 1.65057979266e-10 , 5.09967661056e-10 , 1.22928249275e-09 ,
 2.31265866104e-09 , 3.3973309667e-09  , 3.89973029849e-09 , 3.50125945722e-09 ,
 2.46203672656e-09 , 1.35853636867e-09 , 5.89870036015e-10 , 2.02441031138e-10 ,
 5.54590735665e-11 , 1.25524952753e-11 , 2.71816262251e-12 , 8.21836327557e-13 ,
 3.84165069373e-13 , 1.87588388616e-13 , 7.69894815571e-14 , 2.5467417174e-14  ,
 6.96082612659e-15 , 1.72901128967e-15 , 4.60556326618e-16 , 1.40610355568e-16 ,
 4.30268882192e-17 , 1.14460615346e-17 , 2.48319873123e-18 , 4.30231701481e-19 ,
 5.9140736248e-20  , 6.4338120268e-21  , 5.53038738878e-22 , 3.75063272518e-23 ,
 2.00381523097e-24 , 8.4206559218e-26  , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 5.75616346925e-21 , 2.86750036764e-19 , 1.08604278791e-17 , 3.21148658894e-16 ,
 7.41920573436e-15 , 1.34009788545e-13 , 1.89428325755e-12 , 2.09774926984e-11 ,
 1.82222321517e-10 , 1.24333184079e-09 , 6.67341185473e-09 , 2.8218286892e-08  ,
 9.41342073366e-08 , 2.48042344191e-07 , 5.16721800041e-07 , 8.5143642517e-07  ,
 1.1097382435e-06  , 1.14360561963e-06 , 9.31447545636e-07 , 6.04478173377e-07 ,
 3.64900120621e-07 , 5.86783219567e-07 , 2.79582695494e-06 , 1.28983159104e-05 ,
 4.75355076121e-05 , 0.000138153938494 , 0.000315980830187 , 0.000567875549751 ,
 0.000800810026725 , 0.000884982475192 , 0.000765562079485 , 0.000517903054734 ,
 0.000273771792555 , 0.000113009717333 , 3.64092409846e-05 , 9.15279366135e-06 ,
 1.795732185e-06   , 2.75479383361e-07 , 3.33014351698e-08 , 3.26400311571e-09 ,
 2.84001915478e-10 , 2.64866907256e-11 , 2.97539319573e-12 , 3.49652315809e-13 ,
 3.61237654117e-14 , 3.04052566905e-15 , 2.03500914005e-16 , 1.07771000269e-17 ,
 4.49435631187e-19 , 1.47372086907e-20 , 3.79416642669e-22 , 6.90146423655e-24 ,
 4.33037369e-19    , 2.09086422216e-17 , 7.85057119671e-16 , 2.29602226482e-14 ,
 5.23083409012e-13 , 9.28350900087e-12 , 1.28361101424e-10 , 1.38285857269e-09 ,
 1.16091377501e-08 , 7.59573372623e-08 , 3.87414146495e-07 , 1.54073850257e-06 ,
 4.77937080264e-06 , 1.15684931074e-05 , 2.18607827748e-05 , 3.22705618537e-05 ,
 3.72414501886e-05 , 3.36293344795e-05 , 2.37871939852e-05 , 1.31956780324e-05 ,
 5.74876928896e-06 , 1.96973070219e-06 , 5.31588021844e-07 , 1.13161717533e-07 ,
 1.9024870369e-08  , 2.52844659015e-09 , 2.65786848413e-10 , 2.21002134307e-11 ,
 1.45302143798e-12 , 7.54750317154e-14 , 3.09376377853e-15 , 9.99366105579e-17 ,
 2.54022684305e-18 , 4.37333223084e-20 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 4.06578356449e-27 , 2.74448084751e-24 , 1.30315689973e-22 , 4.83083330365e-21 ,
 1.39855905217e-19 , 3.16044943583e-18 , 5.57251421662e-17 , 7.66400975015e-16 ,
 8.21995565104e-15 , 6.87434376854e-14 , 4.48241737355e-13 , 2.27883906807e-12 ,
 9.03373106435e-12 , 2.79278782751e-11 , 6.73487013968e-11 , 1.26732994986e-10 ,
 1.86176282567e-10 , 2.1365343466e-10  , 1.91697478177e-10 , 1.34629010553e-10 ,
 7.4121247343e-11  , 3.20587474794e-11 , 1.0927425303e-11  , 2.95305937151e-12 ,
 6.44744182456e-13 , 1.23750431571e-13 , 2.83443784329e-14 , 1.06756946829e-14 ,
 4.89527095882e-15 , 1.96955874209e-15 , 6.33458834159e-16 , 1.59908610278e-16 ,
 3.1571841233e-17  , 4.87240003514e-18 , 5.87843918996e-19 , 5.54695113666e-20 ,
 4.0965096954e-21  , 2.3698613878e-22  , 1.07509314675e-23 , 3.82932656894e-25 ,
 1.07237758271e-26 , 2.36126339717e-28 , 1.31233238148e-30 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 5.31376567702e-22 , 2.64711471692e-20 ,
 1.00257348858e-18 , 2.96466340814e-17 , 6.84899256122e-16 , 1.23710283518e-14 ,
 1.74869553485e-13 , 1.93652388933e-12 , 1.68217376528e-11 , 1.14777387683e-10 ,
 6.16051768709e-10 , 2.60495319752e-09 , 8.68993944656e-09 , 2.28978711576e-08 ,
 4.77008444048e-08 , 7.85998221955e-08 , 1.02445046999e-07 , 1.05576403219e-07 ,
 8.60645073835e-08 , 5.67413296752e-08 , 4.25690999854e-08 , 1.2062057545e-07  ,
 6.5114024961e-07  , 3.02744219287e-06 , 1.11619613132e-05 , 3.24410672171e-05 ,
 7.41981586251e-05 , 0.000133347721419 , 0.000188045058364 , 0.000207810290696 ,
 0.000179768100252 , 0.000121613026933 , 6.42862665838e-05 , 2.65361345546e-05 ,
 8.54881493859e-06 , 2.14856149501e-06 , 4.21181755407e-07 , 6.44125310836e-08 ,
 7.69807174463e-09 , 7.24001585304e-10 , 5.50057237057e-11 , 3.67857633281e-12 ,
 2.61660195167e-13 , 2.26501571941e-14 , 2.08524930446e-15 , 1.69898418178e-16 ,
 1.12485717274e-17 , 5.95707313095e-19 , 2.48426841758e-20 , 8.14603462142e-22 ,
 2.09723643884e-23 , 3.81480426806e-25 , 6.29177370835e-20 , 3.03790053295e-18 ,
 1.14064099283e-16 , 3.33598288594e-15 , 7.60008875836e-14 , 1.34883827665e-12 ,
 1.86500995278e-11 , 2.00921071318e-10 , 1.68673821017e-09 , 1.1036146341e-08  ,
 5.62889560036e-08 , 2.23860079888e-07 , 6.94413963115e-07 , 1.68083278694e-06 ,
 3.17624085478e-06 , 4.68871943069e-06 , 5.41095974462e-06 , 4.88614095813e-06 ,
 3.45613687005e-06 , 1.91725301445e-06 , 8.35261759305e-07 , 2.8619007808e-07  ,
 7.72365569103e-08 , 1.64417200485e-08 , 2.76419976107e-09 , 3.6736815152e-10  ,
 3.86172377856e-11 , 3.21102869559e-12 , 2.11115315574e-13 , 1.09660702327e-14 ,
 4.49505354389e-16 , 1.45201911849e-17 , 3.69079751737e-19 , 6.35418989621e-21 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1.07454076338e-28 , 1.1481719677e-25  ,
 5.48422563167e-24 , 2.04258464034e-22 , 5.93549029564e-21 , 1.34524942247e-19 ,
 2.37745245511e-18 , 3.27572553114e-17 , 3.51836333672e-16 , 2.94568919663e-15 ,
 1.92240680106e-14 , 9.77999442974e-14 , 3.87895672674e-13 , 1.19963923843e-12 ,
 2.89371156369e-12 , 5.44600379961e-12 , 8.00049900894e-12 , 9.17978052775e-12 ,
 8.23305289632e-12 , 5.77749570858e-12 , 3.1763966569e-12  , 1.37052985119e-12 ,
 4.65178469072e-13 , 1.24680459624e-13 , 2.6655756409e-14  , 4.74885309322e-15 ,
 8.5924659519e-16  , 2.40205912757e-16 , 9.82552034336e-17 , 3.86377631729e-17 ,
 1.23547075645e-17 , 3.10387505639e-18 , 6.08776610032e-19 , 9.30907912925e-20 ,
 1.10937178121e-20 , 1.03012303788e-21 , 7.45232267632e-23 , 4.19998404409e-24 ,
 1.84386392064e-25 , 6.30541090877e-27 , 1.67951686876e-28 , 3.4797471363e-30  ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3.8265430317e-23  ,
 1.90623730699e-21 , 7.21972105974e-20 , 2.13491011747e-18 , 4.93208890875e-17 ,
 8.90861118309e-16 , 1.25926868443e-14 , 1.39452743023e-13 , 1.21136510168e-12 ,
 8.2653364813e-12  , 4.43630514779e-11 , 1.87587600049e-10 , 6.25778953312e-10 ,
 1.6489189535e-09  , 3.43502796874e-09 , 5.66012372039e-09 , 7.37731179916e-09 ,
 7.60372426995e-09 , 6.21231456996e-09 , 4.26117961405e-09 , 4.72158717327e-09 ,
 2.10740018989e-08 , 1.20160242367e-07 , 5.60411660137e-07 , 2.06653507537e-06 ,
 6.00621838776e-06 , 1.37372345012e-05 , 2.46883346025e-05 , 3.48151378494e-05 ,
 3.84745220394e-05 , 3.32827171156e-05 , 2.25157337123e-05 , 1.19021031604e-05 ,
 4.91293891727e-06 , 1.58271642912e-06 , 3.97760211789e-07 , 7.79572698558e-08 ,
 1.19134780744e-08 , 1.41992240358e-09 , 1.32188985346e-10 , 9.67346175999e-12 ,
 5.70045457221e-13 , 2.93512099363e-14 , 1.59594090835e-15 , 1.06572099898e-16 ,
 7.68493824467e-18 , 4.8628352652e-19  , 2.57528386738e-20 , 1.07396639887e-21 ,
 3.52158704183e-23 , 9.06649800784e-25 , 1.64916623877e-26 , 7.18976695085e-21 ,
 3.47148480925e-19 , 1.30343894952e-17 , 3.8121109585e-16  , 8.68481123311e-15 ,
 1.54135118538e-13 , 2.13119345086e-12 , 2.29597526112e-11 , 1.92747787832e-10 ,
 1.26112800469e-09 , 6.43227958177e-09 , 2.55810504096e-08 , 7.9352417834e-08  ,
 1.9207296037e-07  , 3.62956975e-07    , 5.35791679219e-07 , 6.18323883655e-07 ,
 5.58351530211e-07 , 3.94941391693e-07 , 2.19089290217e-07 , 9.54474472659e-08 ,
 3.27036549696e-08 , 8.82601425311e-09 , 1.87883641243e-09 , 3.15872010166e-10 ,
 4.19800761603e-11 , 4.41288820664e-12 , 3.6693226845e-13  , 2.4124674362e-14  ,
 1.25312023278e-15 , 5.13660994662e-17 , 1.65925851025e-18 , 4.21756649917e-20 ,
 7.26109148755e-22 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.16846717751e-30 ,
 3.79526404791e-27 , 1.81995341283e-25 , 6.79937502448e-24 , 1.98063407726e-22 ,
 4.49761564588e-21 , 7.9605618118e-20  , 1.09812077066e-18 , 1.18054485057e-17 ,
 9.89099904169e-17 , 6.45863494529e-16 , 3.28716331315e-15 , 1.30418881933e-14 ,
 4.034428683e-14   , 9.73328781868e-14 , 1.83198891548e-13 , 2.69132481937e-13 ,
 3.08772386463e-13 , 2.76857714684e-13 , 1.94187385991e-13 , 1.06668241366e-13 ,
 4.59546991031e-14 , 1.55558784384e-14 , 4.14683534051e-15 , 8.73048421372e-16 ,
 1.45690566702e-16 , 1.93599073271e-17 , 2.06073977124e-18 , 1.77025671967e-19 ,
 1.23841095842e-20 , 7.12563899539e-22 , 3.40322175606e-23 , 1.35707094807e-24 ,
 4.5194761814e-26  , 1.19023341626e-27 , 2.37440124153e-29 , 3.82974407611e-31 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2.14879839145e-24 ,
 1.07044912995e-22 , 4.05424030812e-21 , 1.19886053503e-19 , 2.76961858936e-18 ,
 5.00263794806e-17 , 7.07143367024e-16 , 7.83098027147e-15 , 6.80243070674e-14 ,
 4.64140650939e-13 , 2.49121081001e-12 , 1.05339971327e-11 , 3.51406686737e-11 ,
 9.25951799039e-11 , 1.9289428838e-10  , 3.17845018759e-10 , 4.14280965564e-10 ,
 4.27129782379e-10 , 3.51001137741e-10 , 2.6496951984e-10  , 5.08004395153e-10 ,
 3.00005432473e-09 , 1.74924575164e-08 , 8.16816926058e-08 , 3.01222980995e-07 ,
 8.75483348286e-07 , 2.00237843198e-06 , 3.59864201044e-06 , 5.07475370733e-06 ,
 5.60815594322e-06 , 4.85138356525e-06 , 3.28195717661e-06 , 1.73488383063e-06 ,
 7.16123016242e-07 , 2.30700138256e-07 , 5.7977642046e-08  , 1.13625442839e-08 ,
 1.73613245105e-09 , 2.06790522792e-10 , 1.92049814667e-11 , 1.39261903588e-12 ,
 7.93044280914e-14 , 3.62699731831e-15 , 1.44019244524e-16 , 5.9999202148e-18  ,
 3.0930634464e-19  , 1.64280008781e-20 , 8.70002032298e-22 , 3.62815517728e-23 ,
 1.18968938614e-24 , 3.06291348794e-26 , 5.57133913471e-28 , 6.45232387414e-22 ,
 3.11542007781e-20 , 1.16974726858e-18 , 3.4211087392e-17  , 7.79402381814e-16 ,
 1.38325722097e-14 , 1.91260029391e-13 , 2.06048069333e-12 , 1.72977950692e-11 ,
 1.13177609074e-10 , 5.77253079192e-10 , 2.29572423434e-09 , 7.12133652678e-09 ,
 1.72372339221e-08 , 3.25729049507e-08 , 4.80836370222e-08 , 5.54903376386e-08 ,
 5.01082292816e-08 , 3.54432874936e-08 , 1.9661764665e-08  , 8.56575528705e-09 ,
 2.93492925673e-09 , 7.92074386668e-10 , 1.68612711961e-10 , 2.83473515387e-11 ,
 3.76742458412e-12 , 3.96026521085e-13 , 3.29296603366e-14 , 2.16502444941e-15 ,
 1.12458966339e-16 , 4.60975595138e-18 , 1.48907097716e-19 , 3.78497734341e-21 ,
 6.5163327654e-23  , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9.69969495411e-29 ,
 4.67997053957e-27 , 1.75682765007e-25 , 5.13676089458e-24 , 1.16986892302e-22 ,
 2.07534365817e-21 , 2.86793930926e-20 , 3.08748846157e-19 , 2.58959822339e-18 ,
 1.69237768976e-17 , 8.61904003555e-17 , 3.42130657301e-16 , 1.05874490933e-15 ,
 2.55491561603e-15 , 4.80947843226e-15 , 7.06550673885e-15 , 8.10485375521e-15 ,
 7.26422059546e-15 , 5.09120665798e-15 , 2.79288345975e-15 , 1.20051470079e-15 ,
 4.04868670139e-16 , 1.0727512509e-16  , 2.23647357054e-17 , 3.67411288043e-18 ,
 4.76285495562e-19 , 4.8777237031e-20  , 3.94972404961e-21 , 2.52985784708e-22 ,
 1.28167950964e-23 , 5.13319831901e-25 , 1.62374247225e-26 , 4.05163112912e-28 ,
 6.39578467584e-30 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 9.40697916518e-26 , 4.68619704056e-24 , 1.77485958017e-22 ,
 5.24835467109e-21 , 1.21247970351e-19 , 2.19004775579e-18 , 3.09572221705e-17 ,
 3.42823545241e-16 , 2.97795848068e-15 , 2.03190836817e-14 , 1.09059874016e-13 ,
 4.61155834568e-13 , 1.5383832168e-12  , 4.05361870074e-12 , 8.44449997719e-12 ,
 1.39146093854e-11 , 1.81371876018e-11 , 1.87151866066e-11 , 1.56135114475e-11 ,
 1.45580759276e-11 , 5.02137233713e-11 , 3.40587049833e-10 , 2.00343465427e-09 ,
 9.3595195823e-09  , 3.45165735992e-08 , 1.0032011617e-07  , 2.29449081804e-07 ,
 4.12362166264e-07 , 5.81507253461e-07 , 6.42628892608e-07 , 5.55911651638e-07 ,
 3.76073789738e-07 , 1.9879732153e-07  , 8.20592727364e-08 , 2.64355002077e-08 ,
 6.6435306218e-09  , 1.30199489126e-09 , 1.98929503864e-10 , 2.36909409577e-11 ,
 2.19898218574e-12 , 1.5911445438e-13  , 8.98658215212e-15 , 3.98279333479e-16 ,
 1.41449551819e-17 , 4.3380562079e-19  , 1.38650381501e-20 , 4.33397569004e-22 ,
 2.29520785045e-23 , 9.57166757827e-25 , 3.1385954484e-26  , 8.08046742627e-28 ,
 1.46981051133e-29 , 4.54135633952e-23 , 2.19273443128e-21 , 8.23306343176e-20 ,
 2.40788809799e-18 , 5.48568859333e-17 , 9.73581623022e-16 , 1.34615057135e-14 ,
 1.4502336277e-13  , 1.21747532873e-12 , 7.96580987699e-12 , 4.06289575947e-11 ,
 1.61580571726e-10 , 5.01222930103e-10 , 1.21321283734e-09 , 2.29258746584e-09 ,
 3.38428346247e-09 , 3.90559124949e-09 , 3.52678088002e-09 , 2.49461436673e-09 ,
 1.38385923195e-09 , 6.02885841356e-10 , 2.06569909479e-10 , 5.57487830343e-11 ,
 1.18675135242e-11 , 1.99517921186e-12 , 2.65163650376e-13 , 2.78736403694e-14 ,
 2.31769707543e-15 , 1.52381493867e-16 , 7.91522945346e-18 , 3.24449683893e-19 ,
 1.04805680155e-20 , 2.66399070919e-22 , 4.58640788835e-24 , 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 1.92889210438e-30 , 9.30664135853e-29 ,
 3.49364696416e-27 , 1.02150197285e-25 , 2.32641432483e-24 , 4.12705143312e-23 ,
 5.70321594198e-22 , 6.13981382307e-21 , 5.14970376929e-20 , 3.36548105775e-19 ,
 1.71399186784e-18 , 6.80364822458e-18 , 2.10543187783e-17 , 5.08073355135e-17 ,
 9.56418219136e-17 , 1.40505451218e-16 , 1.61174021343e-16 , 1.44457097026e-16 ,
 1.0124430068e-16  , 5.55395904659e-17 , 2.38735685865e-17 , 8.05126331124e-18 ,
 2.13328504414e-18 , 4.44747616526e-19 , 7.30638165343e-20 , 9.47146622823e-21 ,
 9.69989549441e-22 , 7.85446508349e-23 , 5.0309033939e-24  , 2.54876209837e-25 ,
 1.02079351512e-26 , 3.22899230243e-28 , 8.05711863289e-30 , 1.27187283939e-31 ,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 3.20978204869e-27 , 1.59899058702e-25 , 6.05604872652e-24 , 1.79080598699e-22 ,
 4.13713639457e-21 , 7.47272407951e-20 , 1.05630016029e-18 , 1.16975794467e-17 ,
 1.01611766171e-16 , 6.93313218857e-16 , 3.72126290177e-15 , 1.57352290619e-14 ,
 5.24916102281e-14 , 1.38314676336e-13 , 2.88137282536e-13 , 4.74787512838e-13 ,
 6.18941300044e-13 , 6.40064246478e-13 , 5.55108033788e-13 , 7.64012528537e-13 ,
 4.24076371233e-12 , 3.05265170597e-11 , 1.80178175215e-10 , 8.41897166541e-10 ,
 3.10482617727e-09 , 9.02397441311e-09 , 2.06393570445e-08 , 3.70927175881e-08 ,
 5.23076220184e-08 , 5.78056232354e-08 , 5.00052515847e-08 , 3.38285127477e-08 ,
 1.78821758155e-08 , 7.3813784519e-09  , 2.37792010737e-09 , 5.97596945559e-10 ,
 1.17116373178e-10 , 1.78938379564e-11 , 2.13094171447e-12 , 1.97767183929e-13 ,
 1.43029386748e-14 , 8.06251215802e-16 , 3.54633942957e-17 , 1.22304083909e-18 ,
 3.37144455373e-20 , 7.95824757311e-22 , 8.67381346366e-24 , 4.59352017154e-25 ,
 1.91562816794e-26 , 6.28143612339e-28 , 1.6171864396e-29  , 2.94160907075e-31 ,
 2.50375739641e-24 , 1.20890646764e-22 , 4.53908302307e-21 , 1.32752578401e-19 ,
 3.024390152e-18   , 5.3675862615e-17  , 7.42164718585e-16 , 7.99548174691e-15 ,
 6.71223007262e-14 , 4.39173980346e-13 , 2.2399707374e-12  , 8.90831992316e-12 ,
 2.76336082148e-11 , 6.68872994724e-11 , 1.26395781247e-10 , 1.86583569252e-10 ,
 2.15324503237e-10 , 1.94439789651e-10 , 1.37534003169e-10 , 7.62954397001e-11 ,
 3.32385254897e-11 , 1.13886887544e-11 , 3.0735625533e-12  , 6.54284150854e-13 ,
 1.0999895924e-13  , 1.46191005782e-14 , 1.53673986409e-15 , 1.27780133542e-16 ,
 8.40115295569e-18 , 4.36385361703e-19 , 1.78876801352e-20 , 5.77818557402e-22 ,
 1.46872122412e-23 , 2.52859538317e-25 , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};
 
  /*****/
}


void Prob_phi_2d::init( const int& size )
{
  n = size;
  data_.clear();
  data_.resize( n*n, 0.0 );
}

void Prob_phi_2d::accumulate( const ftype32 table[] )
{ for ( int i = 0; i < data_.size(); i++ ) data_[i] += table[i]; }

/*! linear interpolation onto grid */
void Prob_phi_2d::accumulate( const ftype& phi1, const ftype& phi2, ftype wgt )
{
  int   i1_0, i2_0, i1_1, i2_1;
  ftype w1_0, w2_0, w1_1, w2_1;
  w1_1 = ftype(n) * phi1 / Util::twopi();
  w2_1 = ftype(n) * phi2 / Util::twopi();
  i1_0 = Util::intf( w1_1 );
  i2_0 = Util::intf( w2_1 );
  w1_1 -= ftype( i1_0 );
  w2_1 -= ftype( i2_0 );
  w1_0 = 1.0 - w1_1;
  w2_0 = 1.0 - w2_1;
  i1_0 = Util::mod( i1_0  , n );
  i2_0 = Util::mod( i2_0  , n );
  i1_1 = Util::mod( i1_0+1, n );
  i2_1 = Util::mod( i2_0+1, n );
  data( i1_0, i2_0 ) += wgt * w1_0 * w2_0;
  data( i1_0, i2_1 ) += wgt * w1_0 * w2_1;
  data( i1_1, i2_0 ) += wgt * w1_1 * w2_0;
  data( i1_1, i2_1 ) += wgt * w1_1 * w2_1;
}

/*! normalise mean value to 1/(2pi)^2 */
void Prob_phi_2d::normalise()
{
  ftype s = 0.0;
  for ( int i = 0; i < data_.size(); i++ ) s += data_[i];
  s = ftype( data_.size() ) / ( Util::twopi() * Util::twopi() * s );
  for ( int i = 0; i < data_.size(); i++ ) data_[i] *= s;
}

/*! linear interpolation off of grid */
ftype Prob_phi_2d::probability( const ftype& phi1, const ftype& phi2 ) const
{
  int   i1_0, i2_0, i1_1, i2_1;
  ftype w1_0, w2_0, w1_1, w2_1;
  w1_1 = ftype(n) * phi1 / Util::twopi();
  w2_1 = ftype(n) * phi2 / Util::twopi();
  i1_0 = Util::intf( w1_1 );
  i2_0 = Util::intf( w2_1 );
  w1_1 -= ftype( i1_0 );
  w2_1 -= ftype( i2_0 );
  w1_0 = 1.0 - w1_1;
  w2_0 = 1.0 - w2_1;
  i1_0 = Util::mod( i1_0  , n );
  i2_0 = Util::mod( i2_0  , n );
  i1_1 = Util::mod( i1_0+1, n );
  i2_1 = Util::mod( i2_0+1, n );
  return
    w1_0 * ( w2_0 * data( i1_0, i2_0 ) + w2_1 * data( i1_0, i2_1 ) ) +
    w1_1 * ( w2_0 * data( i1_1, i2_0 ) + w2_1 * data( i1_1, i2_1 ) );
}

String Prob_phi_2d::format() const
{
  String s;
  for ( int i = 0; i < n; i++ ) {
    for ( int j = 0; j < n; j++ ) {
      if ( j % 12 == 0 ) s += "\n ";
      int k = Util::intr( data(i,j) );
      s += String( k, 5 ) + ",";
    }
    s += "//" + String( i, 2 );
  }
  return s;
}


/*! Construct a Ramachandran plot of a given type.
  \param type The residue type of the plot. Options include:
  Ramachandran::Gly, Ramachandran::Pro, Ramachandran::NonGlyPro,
  Ramachandran::NonGly, Ramachandran::All */
Ramachandran::Ramachandran( TYPE type )
{ init( type ); }

/*! Construct a Ramachandran plot of a given type.
  \param type The residue type of the plot. Options include:
  Ramachandran::Gly, Ramachandran::Pro, Ramachandran::NonGlyPro,
  Ramachandran::NonGly, Ramachandran::All */
void Ramachandran::init( TYPE type )
{
  switch (type) {
  case Gly5:
    Prob_phi_2d::init( data::rama5_data_size );
    Prob_phi_2d::accumulate( data::rama5_gly );
    break;
  case Pro5:
    Prob_phi_2d::init( data::rama5_data_size );
    Prob_phi_2d::accumulate( data::rama5_pro );
    break;
  case NonGlyPro5:
    Prob_phi_2d::init( data::rama5_data_size );
    Prob_phi_2d::accumulate( data::rama5_ngp );
    break;
  case NonGly5:
    Prob_phi_2d::init( data::rama5_data_size );
    Prob_phi_2d::accumulate( data::rama5_ngl );
    break;
  case All5:
    Prob_phi_2d::init( data::rama5_data_size );
    Prob_phi_2d::accumulate( data::rama5_all );
    break;
  case Gly:
    Prob_phi_2d::init( data::rama_data_size );
    Prob_phi_2d::accumulate( data::rama_gly );
    break;
  case Pro:
    Prob_phi_2d::init( data::rama_data_size );
    Prob_phi_2d::accumulate( data::rama_pro );
    break;
  case NonGlyPro:
    Prob_phi_2d::init( data::rama_data_size );
    Prob_phi_2d::accumulate( data::rama_ngp );
    break;
  case NonGly:
    Prob_phi_2d::init( data::rama_data_size );
    Prob_phi_2d::accumulate( data::rama_ngp );
    Prob_phi_2d::accumulate( data::rama_pro );
    break;
    
  /***** Rama2 data set *****/
  
  case Gly2:
    Prob_phi_2d::init( data::rama2_data_size );
    Prob_phi_2d::accumulate( data::rama2_gly_data );
    break;
  case Pro2:
    Prob_phi_2d::init( data::rama2_data_size );
    Prob_phi_2d::accumulate( data::rama2_pro_data );
    break;
  case PrePro2:
    Prob_phi_2d::init( data::rama2_data_size );
    Prob_phi_2d::accumulate( data::rama2_prepro_data );
    break;
  case IleVal2:
    Prob_phi_2d::init( data::rama2_data_size );
    Prob_phi_2d::accumulate( data::rama2_ileval_data );
    break;
  case NoGPIVpreP2:
    Prob_phi_2d::init( data::rama2_data_size );
    Prob_phi_2d::accumulate( data::rama2_nogpivprep_data );
    break;
  case All2:
    Prob_phi_2d::init( data::rama2_data_size );
    Prob_phi_2d::accumulate( data::rama2_gly_data );
    Prob_phi_2d::accumulate( data::rama2_pro_data );
    Prob_phi_2d::accumulate( data::rama2_prepro_data );
    Prob_phi_2d::accumulate( data::rama2_ileval_data );
    Prob_phi_2d::accumulate( data::rama2_nogpivprep_data );
    break;
  
  /*****/
    
  default:
    Prob_phi_2d::init( data::rama_data_size );
    Prob_phi_2d::accumulate( data::rama_ngp );
    Prob_phi_2d::accumulate( data::rama_pro );
    Prob_phi_2d::accumulate( data::rama_gly );
    break;
  }
  Prob_phi_2d::normalise();
  set_thresholds();
}

/*! Set thresholds for favorable and allowed regions of the
  Ramachandran plot. The US spelling is used because it is the same
  length as 'allowed'. I should get out more. Sorry.
  \param prob_favored The probability threshold for the favored region.
  \param prob_allowed The probability threshold for the allowed region.
 */
void Ramachandran::set_thresholds( ftype prob_favored, ftype prob_allowed )
{ p_favored = prob_favored; p_allowed = prob_allowed; }


} // namespace clipper
